/************************************************************************
  DISCLAIMER:
  This software was produced by the National Institute of Standards
  and Technology (NIST), an agency of the U.S. government, and by statute
  is not subject to copyright in the United States.  Recipients of this
  software assume all responsibility associated with its operation,
  modification, maintenance, and subsequent redistribution.

  See NIST Administration Manual 4.09.07 b and Appendix I.
************************************************************************/

#include "dmisConformanceTesterStart.cc"

namespace NDTU {

int aclratStms;
int algdefStms;
int assignStms;
int badtstStms;
int boundStms;
int calibMasterStms;
int calibRtabStms;
int calibSensStms;
int callStms;
int caseStms;
int clmpidStms;
int clmpsnStms;
int closeStms;
int cmpntgrpStms;
int cnfrmrulStms;
int constStms;
int crgdefStms;
int crmodeStms;
int crosclStms;
int crslctStms;
int cutcomStms;
int czoneStms;
int czslctStms;
int datdefStms;
int datsetStms;
int dattrgdefStms;
int declStms;
int decplStms;
int deleteStms;
int deviceStms;
int dftcasStms;
int displyStms;
int dmehwStms;
int dmeidStms;
int dmeswStms;
int dmeswiStms;
int dmeswvStms;
int dmisOffStms;
int dmisOnStms;
int dmismdStms;
int dmismnStms;
int doStms;
int elseStms;
int endcasStms;
int enddoStms;
int endfilStms;
int endgoStms;
int endifStms;
int endmacStms;
int endmesStms;
int endselStms;
int endsimreqtStms;
int endxtnStms;
int equateStms;
int errorStms;
int evalStms;
int extensStms;
int extfilStms;
int featArc1Stms;
int featArc2Stms;
int featCircleStms;
int featCompoundStms;
int featConeStms;
int featConradsegStms;
int featCparlnStms;
int featCylndrStms;
int featCylradsegStms;
int featEdgeptStms;
int featEllipsStms;
int featElongcylStms;
int featGcurveStms;
int featGeomStms;
int featGsurfStms;
int featLineStms;
int featObjectStms;
int featParplnStms;
int featPaternStms;
int featPlaneStms;
int featPointStms;
int featRctnglStms;
int featRevsurfStms;
int featSphereStms;
int featSphradsegStms;
int featSymplnStms;
int featTorradsegStms;
int featTorusStms;
int fedratStms;
int fildefStms;
int filnamStms;
int finposStms;
int fixtidStms;
int fixtsnStms;
int flyStms;
int fromStms;
int geoalgStms;
int geomStms;
int gohomeStms;
int gotargStms;
int gotoStms;
int groupStms;
int ifStms;
int includStms;
int iteratStms;
int jumpStms;
int jumptoStms;
int keycharStms;
int litdefStms;
int locateStms;
int lotidStms;
int macroStms;
int matdefStms;
int measStms;
int mfgdevStms;
int modeStms;
int obtainStms;
int openStms;
int operidStms;
int outputStms;
int pameasStms;
int partidStms;
int partrvStms;
int partsnStms;
int pathStms;
int planidStms;
int popStms;
int prcompStms;
int prevopStms;
int procidStms;
int promptStms;
int psthruStms;
int ptbuffStms;
int ptmeasStms;
int pushStms;
int qisdefStms;
int rapidStms;
int readStms;
int recallDMLStms;
int recallDatumStms;
int recallFeatureStms;
int recallRotaryTableStms;
int recallSensorStms;
int refmntStms;
int reportStms;
int resumeStms;
int rmeasStms;
int rotabStms;
int rotateStms;
int rotdefStms;
int rotsetStms;
int saveDMLStms;
int saveDatumStms;
int saveFeatureStms;
int saveRotaryTableStms;
int saveSensorStms;
int scnmodStms;
int scnsetStms;
int selectStms;
int sensorStms;
int simreqtStms;
int snsdefStms;
int snsetStms;
int snsgrpStms;
int snslctStms;
int snsmntStms;
int tecompStms;
int textStms;
int thldefStms;
int tolAnglStms;
int tolAnglbStms;
int tolAnglrStms;
int tolAnglwrtStms;
int tolCirltyStms;
int tolComposStms;
int tolConcenStms;
int tolCortolStms;
int tolCproflStms;
int tolCprofsStms;
int tolCrnoutStms;
int tolCylctyStms;
int tolDiamStms;
int tolDistbStms;
int tolDistwrtStms;
int tolFlatStms;
int tolGtolStms;
int tolParlelStms;
int tolPerpStms;
int tolPosStms;
int tolProflStms;
int tolProfpStms;
int tolProfsStms;
int tolRadStms;
int tolStrghtStms;
int tolSymStms;
int tolTrnoutStms;
int tolUsetolStms;
int tolWidthStms;
int tooldfStms;
int transStms;
int uncertalgStms;
int uncertsetStms;
int unitsStms;
int valueStms;
int vformStms;
int windefStms;
int wkplanStms;
int wristStms;
int writeStms;
int xternStms;
int xtractStms;
void check_aboveBelow(aboveBelow * a_aboveBelow, int log);
void check_aclratAngSpec(aclratAngSpec * a_aclratAngSpec, int log);
void check_aclratAngular(aclratAngular * a_aclratAngular, int log);
void check_aclratDef(aclratDef * a_aclratDef, int log);
void check_aclratDef_PCENT(aclratDef_PCENT * a_aclratDef_PCENT, int log);
void check_aclratHedMeas(aclratHedMeas * a_aclratHedMeas, int log);
void check_aclratHedRot(aclratHedRot * a_aclratHedRot, int log);
void check_aclratHedScan(aclratHedScan * a_aclratHedScan, int log);
void check_aclratLinSpec(aclratLinSpec * a_aclratLinSpec, int log);
void check_aclratLinear(aclratLinear * a_aclratLinear, int log);
void check_aclratLinear_IPMM(aclratLinear_IPMM * a_aclratLinear_IPMM, int log);
void check_aclratLinear_IPSS(aclratLinear_IPSS * a_aclratLinear_IPSS, int log);
void check_aclratLinear_MMPSS(
     aclratLinear_MMPSS * a_aclratLinear_MMPSS, int log);
void check_aclratLinear_MPMM(aclratLinear_MPMM * a_aclratLinear_MPMM, int log);
void check_aclratMeas(aclratMeas * a_aclratMeas, int log);
void check_aclratMinor(aclratMinor * a_aclratMinor, int log);
void check_aclratPos(aclratPos * a_aclratPos, int log);
void check_aclratRot(aclratRot * a_aclratRot, int log);
void check_aclratScan(aclratScan * a_aclratScan, int log);
void check_aclratStm(aclratStm * a_aclratStm, int log);
void check_algdefMinor(algdefMinor * a_algdefMinor, int log);
void check_algdefMinor_CODE(algdefMinor_CODE * a_algdefMinor_CODE, int log);
void check_algdefMinor_stringVal(
     algdefMinor_stringVal * a_algdefMinor_stringVal, int log);
void check_algdefStm(algdefStm * a_algdefStm, int log);
void check_angle(angle * a_angle, int log);
void check_angleDms(angleDms * a_angleDms, int log);
void check_angleUnit(angleUnit * a_angleUnit, int log);
void check_anyVal(anyVal * a_anyVal, int log);
void check_arrayIndex(arrayIndex * a_arrayIndex, int log);
void check_assignBool(assignBool * a_assignBool, int log);
void check_assignInt(assignInt * a_assignInt, int log);
void check_assignReal(assignReal * a_assignReal, int log);
void check_assignStm(assignStm * a_assignStm, int log);
void check_assignStm_assignBool(
     assignStm_assignBool * a_assignStm_assignBool, int log);
void check_assignStm_assignInt(
     assignStm_assignInt * a_assignStm_assignInt, int log);
void check_assignStm_assignReal(
     assignStm_assignReal * a_assignStm_assignReal, int log);
void check_assignStm_assignString(
     assignStm_assignString * a_assignStm_assignString, int log);
void check_assignStm_assignVector(
     assignStm_assignVector * a_assignStm_assignVector, int log);
void check_assignString(assignString * a_assignString, int log);
void check_assignVector(assignVector * a_assignVector, int log);
void check_avgMaxMin(avgMaxMin * a_avgMaxMin, int log);
void check_axial(axial * a_axial, int log);
void check_axis(axis * a_axis, int log);
void check_badtstStm(badtstStm * a_badtstStm, int log);
void check_bfConst(bfConst * a_bfConst, int log);
void check_bfConst_featureList(
     bfConst_featureList * a_bfConst_featureList, int log);
void check_bfConst_indexedFeatureList(
     bfConst_indexedFeatureList * a_bfConst_indexedFeatureList, int log);
void check_boolConst(boolConst * a_boolConst, int log);
void check_boolExpr(boolExpr * a_boolExpr, int log);
void check_boolExpr_PAREN(boolExpr_PAREN * a_boolExpr_PAREN, int log);
void check_boolExpr_boolRel(boolExpr_boolRel * a_boolExpr_boolRel, int log);
void check_boolExpr_intRel(boolExpr_intRel * a_boolExpr_intRel, int log);
void check_boolExpr_realRel(boolExpr_realRel * a_boolExpr_realRel, int log);
void check_boolExpr_stringRel(
     boolExpr_stringRel * a_boolExpr_stringRel, int log);
void check_boolExpr_vectorRel(
     boolExpr_vectorRel * a_boolExpr_vectorRel, int log);
void check_boolFunc(boolFunc * a_boolFunc, int log);
void check_boolFuncEof(boolFuncEof * a_boolFuncEof, int log);
void check_boolFuncEoln(boolFuncEoln * a_boolFuncEoln, int log);
void check_boolFuncExist(boolFuncExist * a_boolFuncExist, int log);
void check_boolFuncExist_dLabel(
     boolFuncExist_dLabel * a_boolFuncExist_dLabel, int log);
void check_boolFuncExist_daLabel(
     boolFuncExist_daLabel * a_boolFuncExist_daLabel, int log);
void check_boolFuncExist_didLabel(
     boolFuncExist_didLabel * a_boolFuncExist_didLabel, int log);
void check_boolFuncExist_fLabel(
     boolFuncExist_fLabel * a_boolFuncExist_fLabel, int log);
void check_boolFuncExist_faLabel(
     boolFuncExist_faLabel * a_boolFuncExist_faLabel, int log);
void check_boolFuncExist_sLabel(
     boolFuncExist_sLabel * a_boolFuncExist_sLabel, int log);
void check_boolFuncExist_saLabel(
     boolFuncExist_saLabel * a_boolFuncExist_saLabel, int log);
void check_boolRel(boolRel * a_boolRel, int log);
void check_boolRel_AND(boolRel_AND * a_boolRel_AND, int log);
void check_boolRel_EQ(boolRel_EQ * a_boolRel_EQ, int log);
void check_boolRel_NE(boolRel_NE * a_boolRel_NE, int log);
void check_boolRel_NOT(boolRel_NOT * a_boolRel_NOT, int log);
void check_boolRel_OR(boolRel_OR * a_boolRel_OR, int log);
void check_boolVal(boolVal * a_boolVal, int log);
void check_boolVar(boolVar * a_boolVar, int log);
void check_boundFeat(boundFeat * a_boundFeat, int log);
void check_boundMinor(boundMinor * a_boundMinor, int log);
void check_boundStm(boundStm * a_boundStm, int log);
void check_boundTol(boundTol * a_boundTol, int log);
void check_cadfileType(cadfileType * a_cadfileType, int log);
void check_cadfileType_VENDOR(
     cadfileType_VENDOR * a_cadfileType_VENDOR, int log);
void check_calibMasterBlock(calibMasterBlock * a_calibMasterBlock, int log);
void check_calibMasterMinor(calibMasterMinor * a_calibMasterMinor, int log);
void check_calibMasterStm(calibMasterStm * a_calibMasterStm, int log);
void check_calibRtabBlock(calibRtabBlock * a_calibRtabBlock, int log);
void check_calibRtabMinor(calibRtabMinor * a_calibRtabMinor, int log);
void check_calibRtabMinorSpec(
     calibRtabMinorSpec * a_calibRtabMinorSpec, int log);
void check_calibRtabSpec(calibRtabSpec * a_calibRtabSpec, int log);
void check_calibRtabSpec_fLabel(
     calibRtabSpec_fLabel * a_calibRtabSpec_fLabel, int log);
void check_calibRtabSpec_faLabel(
     calibRtabSpec_faLabel * a_calibRtabSpec_faLabel, int log);
void check_calibRtabStm(calibRtabStm * a_calibRtabStm, int log);
void check_calibSensBlock(calibSensBlock * a_calibSensBlock, int log);
void check_calibSensBlockItem(
     calibSensBlockItem * a_calibSensBlockItem, int log);
void check_calibSensBlockStatement(
     calibSensBlockStatement * a_calibSensBlockStatement, int log);
void check_calibSensCaseBlock(
     calibSensCaseBlock * a_calibSensCaseBlock, int log);
void check_calibSensDefaultCaseBlock(
     calibSensDefaultCaseBlock * a_calibSensDefaultCaseBlock, int log);
void check_calibSensDoBlock(calibSensDoBlock * a_calibSensDoBlock, int log);
void check_calibSensIfBlock(calibSensIfBlock * a_calibSensIfBlock, int log);
void check_calibSensMinor(calibSensMinor * a_calibSensMinor, int log);
void check_calibSensMinorSpec(
     calibSensMinorSpec * a_calibSensMinorSpec, int log);
void check_calibSensSelectBlock(
     calibSensSelectBlock * a_calibSensSelectBlock, int log);
void check_calibSensSpec(calibSensSpec * a_calibSensSpec, int log);
void check_calibSensSpecInt(calibSensSpecInt * a_calibSensSpecInt, int log);
void check_calibSensSpecString(
     calibSensSpecString * a_calibSensSpecString, int log);
void check_calibSensStm(calibSensStm * a_calibSensStm, int log);
void check_callBlock(callBlock * a_callBlock, int log);
void check_callMacro(callMacro * a_callMacro, int log);
void check_callMinor(callMinor * a_callMinor, int log);
void check_callModule(callModule * a_callModule, int log);
void check_callProgram(callProgram * a_callProgram, int log);
void check_callRoutine(callRoutine * a_callRoutine, int log);
void check_callStm(callStm * a_callStm, int log);
void check_callType(callType * a_callType, int log);
void check_cartPoint(cartPoint * a_cartPoint, int log);
void check_caseBlock(caseBlock * a_caseBlock, int log);
void check_caseStm(caseStm * a_caseStm, int log);
void check_caseStmInt(caseStmInt * a_caseStmInt, int log);
void check_caseStmString(caseStmString * a_caseStmString, int log);
void check_ccLabel(ccLabel * a_ccLabel, int log);
void check_ciLabel(ciLabel * a_ciLabel, int log);
void check_clmpidStm(clmpidStm * a_clmpidStm, int log);
void check_clmpsnStm(clmpsnStm * a_clmpsnStm, int log);
void check_closeDelete(closeDelete * a_closeDelete, int log);
void check_closeEnd(closeEnd * a_closeEnd, int log);
void check_closeKeep(closeKeep * a_closeKeep, int log);
void check_closeMinor(closeMinor * a_closeMinor, int log);
void check_closePlain(closePlain * a_closePlain, int log);
void check_closeStm(closeStm * a_closeStm, int log);
void check_cmpntgrpSpec(cmpntgrpSpec * a_cmpntgrpSpec, int log);
void check_cmpntgrpStm(cmpntgrpStm * a_cmpntgrpStm, int log);
void check_cnfrmrulCode(cnfrmrulCode * a_cnfrmrulCode, int log);
void check_cnfrmrulMinor(cnfrmrulMinor * a_cnfrmrulMinor, int log);
void check_cnfrmrulName(cnfrmrulName * a_cnfrmrulName, int log);
void check_cnfrmrulStm(cnfrmrulStm * a_cnfrmrulStm, int log);
void check_cogConst(cogConst * a_cogConst, int log);
void check_coneConst(coneConst * a_coneConst, int log);
void check_coneConst_DIAM(coneConst_DIAM * a_coneConst_DIAM, int log);
void check_coneConst_DIST(coneConst_DIST * a_coneConst_DIST, int log);
void check_conformItem(conformItem * a_conformItem, int log);
void check_conformType(conformType * a_conformType, int log);
void check_constArc(constArc * a_constArc, int log);
void check_constArc_bfConst(constArc_bfConst * a_constArc_bfConst, int log);
void check_constArc_projctConst(
     constArc_projctConst * a_constArc_projctConst, int log);
void check_constArc_trConst(constArc_trConst * a_constArc_trConst, int log);
void check_constCircle(constCircle * a_constCircle, int log);
void check_constCircle_bfConst(
     constCircle_bfConst * a_constCircle_bfConst, int log);
void check_constCircle_coneConst(
     constCircle_coneConst * a_constCircle_coneConst, int log);
void check_constCircle_intofConst(
     constCircle_intofConst * a_constCircle_intofConst, int log);
void check_constCircle_projctConst(
     constCircle_projctConst * a_constCircle_projctConst, int log);
void check_constCircle_retrieve2(
     constCircle_retrieve2 * a_constCircle_retrieve2, int log);
void check_constCircle_tantoConst(
     constCircle_tantoConst * a_constCircle_tantoConst, int log);
void check_constCircle_trConst(
     constCircle_trConst * a_constCircle_trConst, int log);
void check_constCompound(constCompound * a_constCompound, int log);
void check_constCone(constCone * a_constCone, int log);
void check_constCone_bfConst(constCone_bfConst * a_constCone_bfConst, int log);
void check_constCone_trConst(constCone_trConst * a_constCone_trConst, int log);
void check_constCparln(constCparln * a_constCparln, int log);
void check_constCparln_bfConst(
     constCparln_bfConst * a_constCparln_bfConst, int log);
void check_constCparln_projctConst(
     constCparln_projctConst * a_constCparln_projctConst, int log);
void check_constCparln_retrieve2(
     constCparln_retrieve2 * a_constCparln_retrieve2, int log);
void check_constCparln_trConst(
     constCparln_trConst * a_constCparln_trConst, int log);
void check_constCylndr(constCylndr * a_constCylndr, int log);
void check_constCylndr_bfConst(
     constCylndr_bfConst * a_constCylndr_bfConst, int log);
void check_constCylndr_retrieve1(
     constCylndr_retrieve1 * a_constCylndr_retrieve1, int log);
void check_constCylndr_trConst(
     constCylndr_trConst * a_constCylndr_trConst, int log);
void check_constEdgept(constEdgept * a_constEdgept, int log);
void check_constEllips(constEllips * a_constEllips, int log);
void check_constEllips_bfConst(
     constEllips_bfConst * a_constEllips_bfConst, int log);
void check_constEllips_intofConst(
     constEllips_intofConst * a_constEllips_intofConst, int log);
void check_constEllips_projctConst(
     constEllips_projctConst * a_constEllips_projctConst, int log);
void check_constEllips_trConst(
     constEllips_trConst * a_constEllips_trConst, int log);
void check_constGcurve(constGcurve * a_constGcurve, int log);
void check_constGcurve_bfConst(
     constGcurve_bfConst * a_constGcurve_bfConst, int log);
void check_constGcurve_projctConst(
     constGcurve_projctConst * a_constGcurve_projctConst, int log);
void check_constGcurve_trConst(
     constGcurve_trConst * a_constGcurve_trConst, int log);
void check_constGeom(constGeom * a_constGeom, int log);
void check_constGsurf(constGsurf * a_constGsurf, int log);
void check_constGsurf_bfConst(
     constGsurf_bfConst * a_constGsurf_bfConst, int log);
void check_constGsurf_trConst(
     constGsurf_trConst * a_constGsurf_trConst, int log);
void check_constLine(constLine * a_constLine, int log);
void check_constLine_bfConst(constLine_bfConst * a_constLine_bfConst, int log);
void check_constLine_intofConst(
     constLine_intofConst * a_constLine_intofConst, int log);
void check_constLine_midliConst(
     constLine_midliConst * a_constLine_midliConst, int log);
void check_constLine_offsetConst(
     constLine_offsetConst * a_constLine_offsetConst, int log);
void check_constLine_partoConst(
     constLine_partoConst * a_constLine_partoConst, int log);
void check_constLine_perptoConst(
     constLine_perptoConst * a_constLine_perptoConst, int log);
void check_constLine_projliConst(
     constLine_projliConst * a_constLine_projliConst, int log);
void check_constLine_tantoConst(
     constLine_tantoConst * a_constLine_tantoConst, int log);
void check_constLine_trConst(constLine_trConst * a_constLine_trConst, int log);
void check_constMinor(constMinor * a_constMinor, int log);
void check_constParpln(constParpln * a_constParpln, int log);
void check_constPatern(constPatern * a_constPatern, int log);
void check_constPatern_BUILD(constPatern_BUILD * a_constPatern_BUILD, int log);
void check_constPatern_trConst(
     constPatern_trConst * a_constPatern_trConst, int log);
void check_constPlane(constPlane * a_constPlane, int log);
void check_constPlane_bfConst(
     constPlane_bfConst * a_constPlane_bfConst, int log);
void check_constPlane_midplConst(
     constPlane_midplConst * a_constPlane_midplConst, int log);
void check_constPlane_offsetConst(
     constPlane_offsetConst * a_constPlane_offsetConst, int log);
void check_constPlane_partoConst(
     constPlane_partoConst * a_constPlane_partoConst, int log);
void check_constPlane_perptoConst(
     constPlane_perptoConst * a_constPlane_perptoConst, int log);
void check_constPlane_tantoConstPlane(
     constPlane_tantoConstPlane * a_constPlane_tantoConstPlane, int log);
void check_constPlane_trConst(
     constPlane_trConst * a_constPlane_trConst, int log);
void check_constPoint(constPoint * a_constPoint, int log);
void check_constPoint_cogConst(
     constPoint_cogConst * a_constPoint_cogConst, int log);
void check_constPoint_curveConst(
     constPoint_curveConst * a_constPoint_curveConst, int log);
void check_constPoint_extremConst(
     constPoint_extremConst * a_constPoint_extremConst, int log);
void check_constPoint_intofConst(
     constPoint_intofConst * a_constPoint_intofConst, int log);
void check_constPoint_midptConst(
     constPoint_midptConst * a_constPoint_midptConst, int log);
void check_constPoint_moveptConst(
     constPoint_moveptConst * a_constPoint_moveptConst, int log);
void check_constPoint_pierceConst(
     constPoint_pierceConst * a_constPoint_pierceConst, int log);
void check_constPoint_projptConst(
     constPoint_projptConst * a_constPoint_projptConst, int log);
void check_constPoint_retrieve1(
     constPoint_retrieve1 * a_constPoint_retrieve1, int log);
void check_constPoint_trConst(
     constPoint_trConst * a_constPoint_trConst, int log);
void check_constPoint_vertexConst(
     constPoint_vertexConst * a_constPoint_vertexConst, int log);
void check_constRctngl(constRctngl * a_constRctngl, int log);
void check_constRctngl_bfConst(
     constRctngl_bfConst * a_constRctngl_bfConst, int log);
void check_constRctngl_trConst(
     constRctngl_trConst * a_constRctngl_trConst, int log);
void check_constSgage(constSgage * a_constSgage, int log);
void check_constSpart(constSpart * a_constSpart, int log);
void check_constSphere(constSphere * a_constSphere, int log);
void check_constSphere_bfConst(
     constSphere_bfConst * a_constSphere_bfConst, int log);
void check_constSphere_retrieve2b(
     constSphere_retrieve2b * a_constSphere_retrieve2b, int log);
void check_constSphere_trConst(
     constSphere_trConst * a_constSphere_trConst, int log);
void check_constStm(constStm * a_constStm, int log);
void check_constSympln(constSympln * a_constSympln, int log);
void check_constTorus(constTorus * a_constTorus, int log);
void check_constTorus_bfConst(
     constTorus_bfConst * a_constTorus_bfConst, int log);
void check_constTorus_trConst(
     constTorus_trConst * a_constTorus_trConst, int log);
void check_coordType(coordType * a_coordType, int log);
void check_crLabel(crLabel * a_crLabel, int log);
void check_crLabelConst(crLabelConst * a_crLabelConst, int log);
void check_crgdefData(crgdefData * a_crgdefData, int log);
void check_crgdefMinor(crgdefMinor * a_crgdefMinor, int log);
void check_crgdefStm(crgdefStm * a_crgdefStm, int log);
void check_criticality(criticality * a_criticality, int log);
void check_crmodeMinor(crmodeMinor * a_crmodeMinor, int log);
void check_crmodeStm(crmodeStm * a_crmodeStm, int log);
void check_crosclStm(crosclStm * a_crosclStm, int log);
void check_crslctMinor(crslctMinor * a_crslctMinor, int log);
void check_crslctMinor_crLabelConst(
     crslctMinor_crLabelConst * a_crslctMinor_crLabelConst, int log);
void check_crslctStm(crslctStm * a_crslctStm, int log);
void check_csLabel(csLabel * a_csLabel, int log);
void check_csSpec(csSpec * a_csSpec, int log);
void check_csSpec_HEADCS(csSpec_HEADCS * a_csSpec_HEADCS, int log);
void check_csSpec_PCS(csSpec_PCS * a_csSpec_PCS, int log);
void check_curveConst(curveConst * a_curveConst, int log);
void check_curvePtdataHeadcs(curvePtdataHeadcs * a_curvePtdataHeadcs, int log);
void check_curvePtdataHeadcsListItem(
     curvePtdataHeadcsListItem * a_curvePtdataHeadcsListItem, int log);
void check_curvePtdataPcs(curvePtdataPcs * a_curvePtdataPcs, int log);
void check_curvePtdataPcsListItem(
     curvePtdataPcsListItem * a_curvePtdataPcsListItem, int log);
void check_cutcomAdjust(cutcomAdjust * a_cutcomAdjust, int log);
void check_cutcomMatrix(cutcomMatrix * a_cutcomMatrix, int log);
void check_cutcomMatx(cutcomMatx * a_cutcomMatx, int log);
void check_cutcomMinor(cutcomMinor * a_cutcomMinor, int log);
void check_cutcomParam(cutcomParam * a_cutcomParam, int log);
void check_cutcomStm(cutcomStm * a_cutcomStm, int log);
void check_cutcomUserdf(cutcomUserdf * a_cutcomUserdf, int log);
void check_czLabel(czLabel * a_czLabel, int log);
void check_czoneStm(czoneStm * a_czoneStm, int log);
void check_czslctStm(czslctStm * a_czslctStm, int log);
void check_dLabel(dLabel * a_dLabel, int log);
void check_daLabel(daLabel * a_daLabel, int log);
void check_datLabel(datLabel * a_datLabel, int log);
void check_datdefMinor(datdefMinor * a_datdefMinor, int log);
void check_datdefMinor_dattrgList(
     datdefMinor_dattrgList * a_datdefMinor_dattrgList, int log);
void check_datdefMinor_featureLabel1(
     datdefMinor_featureLabel1 * a_datdefMinor_featureLabel1, int log);
void check_datdefStm(datdefStm * a_datdefStm, int log);
void check_datsetDats(datsetDats * a_datsetDats, int log);
void check_datsetDrf(datsetDrf * a_datsetDrf, int log);
void check_datsetMatrix(datsetMatrix * a_datsetMatrix, int log);
void check_datsetMinor(datsetMinor * a_datsetMinor, int log);
void check_datsetSpec(datsetSpec * a_datsetSpec, int log);
void check_datsetSpecDir(datsetSpecDir * a_datsetSpecDir, int log);
void check_datsetSpecNoDir(datsetSpecNoDir * a_datsetSpecNoDir, int log);
void check_datsetStm(datsetStm * a_datsetStm, int log);
void check_dattrgLabel(dattrgLabel * a_dattrgLabel, int log);
void check_dattrgMinor(dattrgMinor * a_dattrgMinor, int log);
void check_dattrgdefStm(dattrgdefStm * a_dattrgdefStm, int log);
void check_datumLabel(datumLabel * a_datumLabel, int log);
void check_datumLabel1(datumLabel1 * a_datumLabel1, int log);
void check_datumLabel2(datumLabel2 * a_datumLabel2, int log);
void check_declMinor(declMinor * a_declMinor, int log);
void check_declScope(declScope * a_declScope, int log);
void check_declStm(declStm * a_declStm, int log);
void check_declType(declType * a_declType, int log);
void check_declType_CHAR(declType_CHAR * a_declType_CHAR, int log);
void check_declVar(declVar * a_declVar, int log);
void check_decplAll(decplAll * a_decplAll, int log);
void check_decplMinor(decplMinor * a_decplMinor, int log);
void check_decplMinor_decplAll(
     decplMinor_decplAll * a_decplMinor_decplAll, int log);
void check_decplMinor_decplList(
     decplMinor_decplList * a_decplMinor_decplList, int log);
void check_decplNdigits(decplNdigits * a_decplNdigits, int log);
void check_decplNdigits_intVal(
     decplNdigits_intVal * a_decplNdigits_intVal, int log);
void check_decplSelection(decplSelection * a_decplSelection, int log);
void check_decplSelection_ANGLE(
     decplSelection_ANGLE * a_decplSelection_ANGLE, int log);
void check_decplSelection_DEV(
     decplSelection_DEV * a_decplSelection_DEV, int log);
void check_decplSelection_DIST(
     decplSelection_DIST * a_decplSelection_DIST, int log);
void check_decplSelection_HUMID(
     decplSelection_HUMID * a_decplSelection_HUMID, int log);
void check_decplSelection_TEMP(
     decplSelection_TEMP * a_decplSelection_TEMP, int log);
void check_decplSelection_VEC(
     decplSelection_VEC * a_decplSelection_VEC, int log);
void check_decplStm(decplStm * a_decplStm, int log);
void check_defaultCaseBlock(defaultCaseBlock * a_defaultCaseBlock, int log);
void check_deleteAllSensors(deleteAllSensors * a_deleteAllSensors, int log);
void check_deleteDatum(deleteDatum * a_deleteDatum, int log);
void check_deleteFeature(deleteFeature * a_deleteFeature, int log);
void check_deleteMinor(deleteMinor * a_deleteMinor, int log);
void check_deleteRotaryTable(deleteRotaryTable * a_deleteRotaryTable, int log);
void check_deleteSensor(deleteSensor * a_deleteSensor, int log);
void check_deleteStm(deleteStm * a_deleteStm, int log);
void check_device(device * a_device, int log);
void check_deviceMinor(deviceMinor * a_deviceMinor, int log);
void check_deviceMinor_INCR(deviceMinor_INCR * a_deviceMinor_INCR, int log);
void check_deviceMinor_device(
     deviceMinor_device * a_deviceMinor_device, int log);
void check_deviceStm(deviceStm * a_deviceStm, int log);
void check_diLabel(diLabel * a_diLabel, int log);
void check_didLabel(didLabel * a_didLabel, int log);
void check_dir(dir * a_dir, int log);
void check_displyItemDMIS(displyItemDMIS * a_displyItemDMIS, int log);
void check_displyItemNoDMIS(displyItemNoDMIS * a_displyItemNoDMIS, int log);
void check_displySpecItem(displySpecItem * a_displySpecItem, int log);
void check_displyStm(displyStm * a_displyStm, int log);
void check_displyStmOff(displyStmOff * a_displyStmOff, int log);
void check_displyStmSpec(displyStmSpec * a_displyStmSpec, int log);
void check_dmehwMinor(dmehwMinor * a_dmehwMinor, int log);
void check_dmehwMinor_jointConf(
     dmehwMinor_jointConf * a_dmehwMinor_jointConf, int log);
void check_dmehwStm(dmehwStm * a_dmehwStm, int log);
void check_dmeidStm(dmeidStm * a_dmeidStm, int log);
void check_dmeswComand(dmeswComand * a_dmeswComand, int log);
void check_dmeswDelay(dmeswDelay * a_dmeswDelay, int log);
void check_dmeswMinor(dmeswMinor * a_dmeswMinor, int log);
void check_dmeswStm(dmeswStm * a_dmeswStm, int log);
void check_dmeswSwitch(dmeswSwitch * a_dmeswSwitch, int log);
void check_dmeswiStm(dmeswiStm * a_dmeswiStm, int log);
void check_dmeswvStm(dmeswvStm * a_dmeswvStm, int log);
void check_dmisBlock(dmisBlock * a_dmisBlock, int log);
void check_dmisFirstStatement(
     dmisFirstStatement * a_dmisFirstStatement, int log);
void check_dmisFreeStatement(dmisFreeStatement * a_dmisFreeStatement, int log);
void check_dmisItem(dmisItem * a_dmisItem, int log);
void check_dmisOffBlock(dmisOffBlock * a_dmisOffBlock, int log);
void check_dmismdStm(dmismdStm * a_dmismdStm, int log);
void check_dmismnStm(dmismnStm * a_dmismnStm, int log);
void check_doBlock(doBlock * a_doBlock, int log);
void check_doStm(doStm * a_doStm, int log);
void check_drLabel(drLabel * a_drLabel, int log);
void check_dsLabel(dsLabel * a_dsLabel, int log);
void check_dvLabel(dvLabel * a_dvLabel, int log);
void check_equateCad(equateCad * a_equateCad, int log);
void check_equateCadcs(equateCadcs * a_equateCadcs, int log);
void check_equateCadcs_matrix(
     equateCadcs_matrix * a_equateCadcs_matrix, int log);
void check_equateCadcs_stringVal(
     equateCadcs_stringVal * a_equateCadcs_stringVal, int log);
void check_equateDatum(equateDatum * a_equateDatum, int log);
void check_equateMinor(equateMinor * a_equateMinor, int log);
void check_equateStm(equateStm * a_equateStm, int log);
void check_errorCondition(errorCondition * a_errorCondition, int log);
void check_errorCondition_intVal(
     errorCondition_intVal * a_errorCondition_intVal, int log);
void check_errorMinor(errorMinor * a_errorMinor, int log);
void check_errorMinor_AUTO(errorMinor_AUTO * a_errorMinor_AUTO, int log);
void check_errorMinor_jumpLabel(
     errorMinor_jumpLabel * a_errorMinor_jumpLabel, int log);
void check_errorStm(errorStm * a_errorStm, int log);
void check_euler(euler * a_euler, int log);
void check_evalDat(evalDat * a_evalDat, int log);
void check_evalDatDatFa(evalDatDatFa * a_evalDatDatFa, int log);
void check_evalDatFaDat(evalDatFaDat * a_evalDatFaDat, int log);
void check_evalFeat(evalFeat * a_evalFeat, int log);
void check_evalFeatFFaT(evalFeatFFaT * a_evalFeatFFaT, int log);
void check_evalFeatFaFT(evalFeatFaFT * a_evalFeatFaFT, int log);
void check_evalFeatFaFaT(evalFeatFaFaT * a_evalFeatFaFaT, int log);
void check_evalFeatFaT(evalFeatFaT * a_evalFeatFaT, int log);
void check_evalKeychar(evalKeychar * a_evalKeychar, int log);
void check_evalMinor(evalMinor * a_evalMinor, int log);
void check_evalOrOutput(evalOrOutput * a_evalOrOutput, int log);
void check_evalStm(evalStm * a_evalStm, int log);
void check_extensMinor(extensMinor * a_extensMinor, int log);
void check_extensMinor_VEC(extensMinor_VEC * a_extensMinor_VEC, int log);
void check_extensMinor_vector(
     extensMinor_vector * a_extensMinor_vector, int log);
void check_extensStm(extensStm * a_extensStm, int log);
void check_extfilDme(extfilDme * a_extfilDme, int log);
void check_extfilDmis(extfilDmis * a_extfilDmis, int log);
void check_extfilMinor(extfilMinor * a_extfilMinor, int log);
void check_extfilStm(extfilStm * a_extfilStm, int log);
void check_extremConst(extremConst * a_extremConst, int log);
void check_extremConstAxial(extremConstAxial * a_extremConstAxial, int log);
void check_extremConstDir(extremConstDir * a_extremConstDir, int log);
void check_extremConstFeature(
     extremConstFeature * a_extremConstFeature, int log);
void check_extremConstVectorial(
     extremConstVectorial * a_extremConstVectorial, int log);
void check_extremConst_MAX(extremConst_MAX * a_extremConst_MAX, int log);
void check_extremConst_MIN(extremConst_MIN * a_extremConst_MIN, int log);
void check_fLabel(fLabel * a_fLabel, int log);
void check_faLabel(faLabel * a_faLabel, int log);
void check_featArc1Act(featArc1Act * a_featArc1Act, int log);
void check_featArc1Nom(featArc1Nom * a_featArc1Nom, int log);
void check_featArc1Stm(featArc1Stm * a_featArc1Stm, int log);
void check_featArc2Act(featArc2Act * a_featArc2Act, int log);
void check_featArc2Nom(featArc2Nom * a_featArc2Nom, int log);
void check_featArc2Stm(featArc2Stm * a_featArc2Stm, int log);
void check_featCircleAct(featCircleAct * a_featCircleAct, int log);
void check_featCircleNom(featCircleNom * a_featCircleNom, int log);
void check_featCircleStm(featCircleStm * a_featCircleStm, int log);
void check_featCompoundAxial(featCompoundAxial * a_featCompoundAxial, int log);
void check_featCompoundPlane(featCompoundPlane * a_featCompoundPlane, int log);
void check_featCompoundSphere(
     featCompoundSphere * a_featCompoundSphere, int log);
void check_featCompoundStm(featCompoundStm * a_featCompoundStm, int log);
void check_featConeAct(featConeAct * a_featConeAct, int log);
void check_featConeNom(featConeNom * a_featConeNom, int log);
void check_featConeStm(featConeStm * a_featConeStm, int log);
void check_featConradsegAct(featConradsegAct * a_featConradsegAct, int log);
void check_featConradsegCart(featConradsegCart * a_featConradsegCart, int log);
void check_featConradsegNom(featConradsegNom * a_featConradsegNom, int log);
void check_featConradsegPol(featConradsegPol * a_featConradsegPol, int log);
void check_featConradsegStm(featConradsegStm * a_featConradsegStm, int log);
void check_featCparlnAct(featCparlnAct * a_featCparlnAct, int log);
void check_featCparlnNom(featCparlnNom * a_featCparlnNom, int log);
void check_featCparlnStm(featCparlnStm * a_featCparlnStm, int log);
void check_featCylndrAct(featCylndrAct * a_featCylndrAct, int log);
void check_featCylndrNom(featCylndrNom * a_featCylndrNom, int log);
void check_featCylndrStm(featCylndrStm * a_featCylndrStm, int log);
void check_featCylradsegAct(featCylradsegAct * a_featCylradsegAct, int log);
void check_featCylradsegCart(featCylradsegCart * a_featCylradsegCart, int log);
void check_featCylradsegNom(featCylradsegNom * a_featCylradsegNom, int log);
void check_featCylradsegPol(featCylradsegPol * a_featCylradsegPol, int log);
void check_featCylradsegStm(featCylradsegStm * a_featCylradsegStm, int log);
void check_featEdgeptAct(featEdgeptAct * a_featEdgeptAct, int log);
void check_featEdgeptNom(featEdgeptNom * a_featEdgeptNom, int log);
void check_featEdgeptStm(featEdgeptStm * a_featEdgeptStm, int log);
void check_featEllipsAct(featEllipsAct * a_featEllipsAct, int log);
void check_featEllipsCart(featEllipsCart * a_featEllipsCart, int log);
void check_featEllipsNom(featEllipsNom * a_featEllipsNom, int log);
void check_featEllipsPol(featEllipsPol * a_featEllipsPol, int log);
void check_featEllipsStm(featEllipsStm * a_featEllipsStm, int log);
void check_featElongcylAct(featElongcylAct * a_featElongcylAct, int log);
void check_featElongcylNom(featElongcylNom * a_featElongcylNom, int log);
void check_featElongcylStm(featElongcylStm * a_featElongcylStm, int log);
void check_featGcurveCart(featGcurveCart * a_featGcurveCart, int log);
void check_featGcurvePol(featGcurvePol * a_featGcurvePol, int log);
void check_featGcurveStm(featGcurveStm * a_featGcurveStm, int log);
void check_featGeomStm(featGeomStm * a_featGeomStm, int log);
void check_featGsurfCart(featGsurfCart * a_featGsurfCart, int log);
void check_featGsurfPol(featGsurfPol * a_featGsurfPol, int log);
void check_featGsurfStm(featGsurfStm * a_featGsurfStm, int log);
void check_featLineAct(featLineAct * a_featLineAct, int log);
void check_featLineBndCart(featLineBndCart * a_featLineBndCart, int log);
void check_featLineBndPol(featLineBndPol * a_featLineBndPol, int log);
void check_featLineNom(featLineNom * a_featLineNom, int log);
void check_featLineStm(featLineStm * a_featLineStm, int log);
void check_featLineUnbndCart(featLineUnbndCart * a_featLineUnbndCart, int log);
void check_featLineUnbndPol(featLineUnbndPol * a_featLineUnbndPol, int log);
void check_featMinorArc1(featMinorArc1 * a_featMinorArc1, int log);
void check_featMinorArc2(featMinorArc2 * a_featMinorArc2, int log);
void check_featMinorCircle(featMinorCircle * a_featMinorCircle, int log);
void check_featMinorCompound(featMinorCompound * a_featMinorCompound, int log);
void check_featMinorCone(featMinorCone * a_featMinorCone, int log);
void check_featMinorConradseg(
     featMinorConradseg * a_featMinorConradseg, int log);
void check_featMinorCparln(featMinorCparln * a_featMinorCparln, int log);
void check_featMinorCylndr(featMinorCylndr * a_featMinorCylndr, int log);
void check_featMinorCylradseg(
     featMinorCylradseg * a_featMinorCylradseg, int log);
void check_featMinorEdgept(featMinorEdgept * a_featMinorEdgept, int log);
void check_featMinorEllips(featMinorEllips * a_featMinorEllips, int log);
void check_featMinorElongcyl(featMinorElongcyl * a_featMinorElongcyl, int log);
void check_featMinorGcurve(featMinorGcurve * a_featMinorGcurve, int log);
void check_featMinorGeom(featMinorGeom * a_featMinorGeom, int log);
void check_featMinorGsurf(featMinorGsurf * a_featMinorGsurf, int log);
void check_featMinorLine(featMinorLine * a_featMinorLine, int log);
void check_featMinorObject(featMinorObject * a_featMinorObject, int log);
void check_featMinorParpln(featMinorParpln * a_featMinorParpln, int log);
void check_featMinorPatern(featMinorPatern * a_featMinorPatern, int log);
void check_featMinorPlane(featMinorPlane * a_featMinorPlane, int log);
void check_featMinorPoint(featMinorPoint * a_featMinorPoint, int log);
void check_featMinorRctngl(featMinorRctngl * a_featMinorRctngl, int log);
void check_featMinorRevsurf(featMinorRevsurf * a_featMinorRevsurf, int log);
void check_featMinorSphere(featMinorSphere * a_featMinorSphere, int log);
void check_featMinorSphradseg(
     featMinorSphradseg * a_featMinorSphradseg, int log);
void check_featMinorSympln(featMinorSympln * a_featMinorSympln, int log);
void check_featMinorTorradseg(
     featMinorTorradseg * a_featMinorTorradseg, int log);
void check_featMinorTorus(featMinorTorus * a_featMinorTorus, int log);
void check_featObjectAct(featObjectAct * a_featObjectAct, int log);
void check_featObjectNom(featObjectNom * a_featObjectNom, int log);
void check_featObjectStm(featObjectStm * a_featObjectStm, int log);
void check_featParplnAct(featParplnAct * a_featParplnAct, int log);
void check_featParplnMidplCart(
     featParplnMidplCart * a_featParplnMidplCart, int log);
void check_featParplnMidplPol(
     featParplnMidplPol * a_featParplnMidplPol, int log);
void check_featParplnNom(featParplnNom * a_featParplnNom, int log);
void check_featParplnPointsCart(
     featParplnPointsCart * a_featParplnPointsCart, int log);
void check_featParplnPointsPol(
     featParplnPointsPol * a_featParplnPointsPol, int log);
void check_featParplnStm(featParplnStm * a_featParplnStm, int log);
void check_featPaternStm(featPaternStm * a_featPaternStm, int log);
void check_featPlaneAct(featPlaneAct * a_featPlaneAct, int log);
void check_featPlaneNom(featPlaneNom * a_featPlaneNom, int log);
void check_featPlaneStm(featPlaneStm * a_featPlaneStm, int log);
void check_featPointAct(featPointAct * a_featPointAct, int log);
void check_featPointNom(featPointNom * a_featPointNom, int log);
void check_featPointStm(featPointStm * a_featPointStm, int log);
void check_featRctnglAct(featRctnglAct * a_featRctnglAct, int log);
void check_featRctnglNom(featRctnglNom * a_featRctnglNom, int log);
void check_featRctnglStm(featRctnglStm * a_featRctnglStm, int log);
void check_featRevsurfAct(featRevsurfAct * a_featRevsurfAct, int log);
void check_featRevsurfCart(featRevsurfCart * a_featRevsurfCart, int log);
void check_featRevsurfNom(featRevsurfNom * a_featRevsurfNom, int log);
void check_featRevsurfPol(featRevsurfPol * a_featRevsurfPol, int log);
void check_featRevsurfStm(featRevsurfStm * a_featRevsurfStm, int log);
void check_featSphereAct(featSphereAct * a_featSphereAct, int log);
void check_featSphereNom(featSphereNom * a_featSphereNom, int log);
void check_featSphereStm(featSphereStm * a_featSphereStm, int log);
void check_featSphradsegAct(featSphradsegAct * a_featSphradsegAct, int log);
void check_featSphradsegNom(featSphradsegNom * a_featSphradsegNom, int log);
void check_featSphradsegStm(featSphradsegStm * a_featSphradsegStm, int log);
void check_featSymplnAct(featSymplnAct * a_featSymplnAct, int log);
void check_featSymplnCart(featSymplnCart * a_featSymplnCart, int log);
void check_featSymplnNom(featSymplnNom * a_featSymplnNom, int log);
void check_featSymplnPol(featSymplnPol * a_featSymplnPol, int log);
void check_featSymplnStm(featSymplnStm * a_featSymplnStm, int log);
void check_featTorradsegAct(featTorradsegAct * a_featTorradsegAct, int log);
void check_featTorradsegNom(featTorradsegNom * a_featTorradsegNom, int log);
void check_featTorradsegStm(featTorradsegStm * a_featTorradsegStm, int log);
void check_featTorusAct(featTorusAct * a_featTorusAct, int log);
void check_featTorusNom(featTorusNom * a_featTorusNom, int log);
void check_featTorusStm(featTorusStm * a_featTorusStm, int log);
void check_featureLabel(featureLabel * a_featureLabel, int log);
void check_featureLabel1(featureLabel1 * a_featureLabel1, int log);
void check_fedratAngSpec(fedratAngSpec * a_fedratAngSpec, int log);
void check_fedratAngular(fedratAngular * a_fedratAngular, int log);
void check_fedratDef(fedratDef * a_fedratDef, int log);
void check_fedratDef_PCENT(fedratDef_PCENT * a_fedratDef_PCENT, int log);
void check_fedratHedMeas(fedratHedMeas * a_fedratHedMeas, int log);
void check_fedratHedRot(fedratHedRot * a_fedratHedRot, int log);
void check_fedratHedScan(fedratHedScan * a_fedratHedScan, int log);
void check_fedratLinSpec(fedratLinSpec * a_fedratLinSpec, int log);
void check_fedratLinear(fedratLinear * a_fedratLinear, int log);
void check_fedratLinear_IPM(fedratLinear_IPM * a_fedratLinear_IPM, int log);
void check_fedratLinear_IPS(fedratLinear_IPS * a_fedratLinear_IPS, int log);
void check_fedratLinear_MMPS(fedratLinear_MMPS * a_fedratLinear_MMPS, int log);
void check_fedratLinear_MPM(fedratLinear_MPM * a_fedratLinear_MPM, int log);
void check_fedratMeas(fedratMeas * a_fedratMeas, int log);
void check_fedratMinor(fedratMinor * a_fedratMinor, int log);
void check_fedratPos(fedratPos * a_fedratPos, int log);
void check_fedratRot(fedratRot * a_fedratRot, int log);
void check_fedratScan(fedratScan * a_fedratScan, int log);
void check_fedratStm(fedratStm * a_fedratStm, int log);
void check_fiLabel(fiLabel * a_fiLabel, int log);
void check_fildefStm(fildefStm * a_fildefStm, int log);
void check_filnamStm(filnamStm * a_filnamStm, int log);
void check_finposStm(finposStm * a_finposStm, int log);
void check_fixtidStm(fixtidStm * a_fixtidStm, int log);
void check_fixtsnStm(fixtsnStm * a_fixtsnStm, int log);
void check_flatRoundOpen(flatRoundOpen * a_flatRoundOpen, int log);
void check_flipNoFlip(flipNoFlip * a_flipNoFlip, int log);
void check_flyMinor(flyMinor * a_flyMinor, int log);
void check_flyMinor_rentVal(flyMinor_rentVal * a_flyMinor_rentVal, int log);
void check_flyStm(flyStm * a_flyStm, int log);
void check_forceOrDeflection(forceOrDeflection * a_forceOrDeflection, int log);
void check_forceOrDeflection_DEFLECTION(
     forceOrDeflection_DEFLECTION * a_forceOrDeflection_DEFLECTION, int log);
void check_forceOrDeflection_FORCE(
     forceOrDeflection_FORCE * a_forceOrDeflection_FORCE, int log);
void check_fromMinor(fromMinor * a_fromMinor, int log);
void check_fromMinor_cartPoint(
     fromMinor_cartPoint * a_fromMinor_cartPoint, int log);
void check_fromMinor_impCartPoint(
     fromMinor_impCartPoint * a_fromMinor_impCartPoint, int log);
void check_fromMinor_polPoint(
     fromMinor_polPoint * a_fromMinor_polPoint, int log);
void check_fromStm(fromStm * a_fromStm, int log);
void check_fsLabel(fsLabel * a_fsLabel, int log);
void check_gLabel(gLabel * a_gLabel, int log);
void check_geoalgArc(geoalgArc * a_geoalgArc, int log);
void check_geoalgCircle(geoalgCircle * a_geoalgCircle, int log);
void check_geoalgCone(geoalgCone * a_geoalgCone, int log);
void check_geoalgConradsegmnt(
     geoalgConradsegmnt * a_geoalgConradsegmnt, int log);
void check_geoalgCparln(geoalgCparln * a_geoalgCparln, int log);
void check_geoalgCylndr(geoalgCylndr * a_geoalgCylndr, int log);
void check_geoalgCylradsegmnt(
     geoalgCylradsegmnt * a_geoalgCylradsegmnt, int log);
void check_geoalgEliminate(geoalgEliminate * a_geoalgEliminate, int log);
void check_geoalgEliminateStd(
     geoalgEliminateStd * a_geoalgEliminateStd, int log);
void check_geoalgEllips(geoalgEllips * a_geoalgEllips, int log);
void check_geoalgElongcyl(geoalgElongcyl * a_geoalgElongcyl, int log);
void check_geoalgExternFunc(geoalgExternFunc * a_geoalgExternFunc, int log);
void check_geoalgExternFunc_DME(
     geoalgExternFunc_DME * a_geoalgExternFunc_DME, int log);
void check_geoalgExternFunc_DMIS(
     geoalgExternFunc_DMIS * a_geoalgExternFunc_DMIS, int log);
void check_geoalgExternFunc_SYS(
     geoalgExternFunc_SYS * a_geoalgExternFunc_SYS, int log);
void check_geoalgFiltSetElim(geoalgFiltSetElim * a_geoalgFiltSetElim, int log);
void check_geoalgFiltSetFilt(geoalgFiltSetFilt * a_geoalgFiltSetFilt, int log);
void check_geoalgFilter(geoalgFilter * a_geoalgFilter, int log);
void check_geoalgFilterCirc(geoalgFilterCirc * a_geoalgFilterCirc, int log);
void check_geoalgFilterCurve(geoalgFilterCurve * a_geoalgFilterCurve, int log);
void check_geoalgFilterLambda(
     geoalgFilterLambda * a_geoalgFilterLambda, int log);
void check_geoalgFilterSettings(
     geoalgFilterSettings * a_geoalgFilterSettings, int log);
void check_geoalgFilterType(geoalgFilterType * a_geoalgFilterType, int log);
void check_geoalgFilterType_BANDPASS(
     geoalgFilterType_BANDPASS * a_geoalgFilterType_BANDPASS, int log);
void check_geoalgFilterType_HIGHPASS(
     geoalgFilterType_HIGHPASS * a_geoalgFilterType_HIGHPASS, int log);
void check_geoalgFilterType_LOWPASS(
     geoalgFilterType_LOWPASS * a_geoalgFilterType_LOWPASS, int log);
void check_geoalgGcurve(geoalgGcurve * a_geoalgGcurve, int log);
void check_geoalgGsurf(geoalgGsurf * a_geoalgGsurf, int log);
void check_geoalgLine(geoalgLine * a_geoalgLine, int log);
void check_geoalgMinor(geoalgMinor * a_geoalgMinor, int log);
void check_geoalgObject(geoalgObject * a_geoalgObject, int log);
void check_geoalgParpln(geoalgParpln * a_geoalgParpln, int log);
void check_geoalgPlane(geoalgPlane * a_geoalgPlane, int log);
void check_geoalgRctngl(geoalgRctngl * a_geoalgRctngl, int log);
void check_geoalgRevsurf(geoalgRevsurf * a_geoalgRevsurf, int log);
void check_geoalgSpec1(geoalgSpec1 * a_geoalgSpec1, int log);
void check_geoalgSpec1_DEFALT(
     geoalgSpec1_DEFALT * a_geoalgSpec1_DEFALT, int log);
void check_geoalgSpec1_EXTERN(
     geoalgSpec1_EXTERN * a_geoalgSpec1_EXTERN, int log);
void check_geoalgSpec1_LSTSQR(
     geoalgSpec1_LSTSQR * a_geoalgSpec1_LSTSQR, int log);
void check_geoalgSpec1_MINMAX(
     geoalgSpec1_MINMAX * a_geoalgSpec1_MINMAX, int log);
void check_geoalgSpec2(geoalgSpec2 * a_geoalgSpec2, int log);
void check_geoalgSpec2_DEFALT(
     geoalgSpec2_DEFALT * a_geoalgSpec2_DEFALT, int log);
void check_geoalgSpec2_EXTERN(
     geoalgSpec2_EXTERN * a_geoalgSpec2_EXTERN, int log);
void check_geoalgSpec2_LSTSQR(
     geoalgSpec2_LSTSQR * a_geoalgSpec2_LSTSQR, int log);
void check_geoalgSpec2_MAXINS(
     geoalgSpec2_MAXINS * a_geoalgSpec2_MAXINS, int log);
void check_geoalgSpec2_MINCIR(
     geoalgSpec2_MINCIR * a_geoalgSpec2_MINCIR, int log);
void check_geoalgSpec2_MINMAX(
     geoalgSpec2_MINMAX * a_geoalgSpec2_MINMAX, int log);
void check_geoalgSpec3(geoalgSpec3 * a_geoalgSpec3, int log);
void check_geoalgSpec3_DEFALT(
     geoalgSpec3_DEFALT * a_geoalgSpec3_DEFALT, int log);
void check_geoalgSpec3_EXTERN(
     geoalgSpec3_EXTERN * a_geoalgSpec3_EXTERN, int log);
void check_geoalgSpec4(geoalgSpec4 * a_geoalgSpec4, int log);
void check_geoalgSpec4_BSPLIN(
     geoalgSpec4_BSPLIN * a_geoalgSpec4_BSPLIN, int log);
void check_geoalgSpec4_DEFALT(
     geoalgSpec4_DEFALT * a_geoalgSpec4_DEFALT, int log);
void check_geoalgSpec4_EXTERN(
     geoalgSpec4_EXTERN * a_geoalgSpec4_EXTERN, int log);
void check_geoalgSpec4_LSTSQR(
     geoalgSpec4_LSTSQR * a_geoalgSpec4_LSTSQR, int log);
void check_geoalgSpec4_MINMAX(
     geoalgSpec4_MINMAX * a_geoalgSpec4_MINMAX, int log);
void check_geoalgSpec5(geoalgSpec5 * a_geoalgSpec5, int log);
void check_geoalgSpec5_BEZIER(
     geoalgSpec5_BEZIER * a_geoalgSpec5_BEZIER, int log);
void check_geoalgSpec5_DEFALT(
     geoalgSpec5_DEFALT * a_geoalgSpec5_DEFALT, int log);
void check_geoalgSpec5_EXTERN(
     geoalgSpec5_EXTERN * a_geoalgSpec5_EXTERN, int log);
void check_geoalgSpec5_LSTSQR(
     geoalgSpec5_LSTSQR * a_geoalgSpec5_LSTSQR, int log);
void check_geoalgSpec5_MINMAX(
     geoalgSpec5_MINMAX * a_geoalgSpec5_MINMAX, int log);
void check_geoalgSpec5_NURBS(geoalgSpec5_NURBS * a_geoalgSpec5_NURBS, int log);
void check_geoalgSpec6(geoalgSpec6 * a_geoalgSpec6, int log);
void check_geoalgSpec6_BSPLIN(
     geoalgSpec6_BSPLIN * a_geoalgSpec6_BSPLIN, int log);
void check_geoalgSpec6_DEFALT(
     geoalgSpec6_DEFALT * a_geoalgSpec6_DEFALT, int log);
void check_geoalgSpec6_EXTERN(
     geoalgSpec6_EXTERN * a_geoalgSpec6_EXTERN, int log);
void check_geoalgSpec6_LSTSQR(
     geoalgSpec6_LSTSQR * a_geoalgSpec6_LSTSQR, int log);
void check_geoalgSphere(geoalgSphere * a_geoalgSphere, int log);
void check_geoalgSphradsegmnt(
     geoalgSphradsegmnt * a_geoalgSphradsegmnt, int log);
void check_geoalgStm(geoalgStm * a_geoalgStm, int log);
void check_geoalgSympln(geoalgSympln * a_geoalgSympln, int log);
void check_geoalgTorradsegmnt(
     geoalgTorradsegmnt * a_geoalgTorradsegmnt, int log);
void check_geoalgTorus(geoalgTorus * a_geoalgTorus, int log);
void check_geomEntityItem(geomEntityItem * a_geomEntityItem, int log);
void check_geomMinor(geomMinor * a_geomMinor, int log);
void check_geomStm(geomStm * a_geomStm, int log);
void check_geomStmDid(geomStmDid * a_geomStmDid, int log);
void check_geomStmEntity(geomStmEntity * a_geomStmEntity, int log);
void check_geomStmOffset(geomStmOffset * a_geomStmOffset, int log);
void check_gotargBlock(gotargBlock * a_gotargBlock, int log);
void check_gotargCart(gotargCart * a_gotargCart, int log);
void check_gotargPol(gotargPol * a_gotargPol, int log);
void check_gotargStm(gotargStm * a_gotargStm, int log);
void check_gotargXyz(gotargXyz * a_gotargXyz, int log);
void check_gotoAbs(gotoAbs * a_gotoAbs, int log);
void check_gotoAbsCart(gotoAbsCart * a_gotoAbsCart, int log);
void check_gotoAbsCartSens(gotoAbsCartSens * a_gotoAbsCartSens, int log);
void check_gotoAbsPol(gotoAbsPol * a_gotoAbsPol, int log);
void check_gotoAbsPolSens(gotoAbsPolSens * a_gotoAbsPolSens, int log);
void check_gotoAbsXyz(gotoAbsXyz * a_gotoAbsXyz, int log);
void check_gotoAbsXyzSens(gotoAbsXyzSens * a_gotoAbsXyzSens, int log);
void check_gotoArc(gotoArc * a_gotoArc, int log);
void check_gotoAxis(gotoAxis * a_gotoAxis, int log);
void check_gotoAxisSpec(gotoAxisSpec * a_gotoAxisSpec, int log);
void check_gotoMinor(gotoMinor * a_gotoMinor, int log);
void check_gotoRel(gotoRel * a_gotoRel, int log);
void check_gotoStm(gotoStm * a_gotoStm, int log);
void check_gotoWristAngleItem(
     gotoWristAngleItem * a_gotoWristAngleItem, int log);
void check_gotoWristItem(gotoWristItem * a_gotoWristItem, int log);
void check_groupStm(groupStm * a_groupStm, int log);
void check_gsaLabel(gsaLabel * a_gsaLabel, int log);
void check_ifBlock(ifBlock * a_ifBlock, int log);
void check_ifStm(ifStm * a_ifStm, int log);
void check_impCartPoint(impCartPoint * a_impCartPoint, int log);
void check_impPolPoint(impPolPoint * a_impPolPoint, int log);
void check_includDme(includDme * a_includDme, int log);
void check_includDmis(includDmis * a_includDmis, int log);
void check_includMinor(includMinor * a_includMinor, int log);
void check_includStm(includStm * a_includStm, int log);
void check_indexedFeature(indexedFeature * a_indexedFeature, int log);
void check_inputFile(inputFile * a_inputFile, int log);
void check_intConst(intConst * a_intConst, int log);
void check_intExpr(intExpr * a_intExpr, int log);
void check_intExprDivid(intExprDivid * a_intExprDivid, int log);
void check_intExprMinus(intExprMinus * a_intExprMinus, int log);
void check_intExprNegat(intExprNegat * a_intExprNegat, int log);
void check_intExprParen(intExprParen * a_intExprParen, int log);
void check_intExprPlus(intExprPlus * a_intExprPlus, int log);
void check_intExprPosit(intExprPosit * a_intExprPosit, int log);
void check_intExprPower(intExprPower * a_intExprPower, int log);
void check_intExprTimes(intExprTimes * a_intExprTimes, int log);
void check_intFunc(intFunc * a_intFunc, int log);
void check_intFuncAbs(intFuncAbs * a_intFuncAbs, int log);
void check_intFuncIndx(intFuncIndx * a_intFuncIndx, int log);
void check_intFuncInt(intFuncInt * a_intFuncInt, int log);
void check_intFuncLen(intFuncLen * a_intFuncLen, int log);
void check_intFuncMod(intFuncMod * a_intFuncMod, int log);
void check_intFuncNint(intFuncNint * a_intFuncNint, int log);
void check_intFuncOrd(intFuncOrd * a_intFuncOrd, int log);
void check_intFuncOrd_boolVal(
     intFuncOrd_boolVal * a_intFuncOrd_boolVal, int log);
void check_intFuncOrd_stringVal(
     intFuncOrd_stringVal * a_intFuncOrd_stringVal, int log);
void check_intFuncPtdata(intFuncPtdata * a_intFuncPtdata, int log);
void check_intFuncSign(intFuncSign * a_intFuncSign, int log);
void check_intRealExpr(intRealExpr * a_intRealExpr, int log);
void check_intRealExpr_DIVID(intRealExpr_DIVID * a_intRealExpr_DIVID, int log);
void check_intRealExpr_MINUS(intRealExpr_MINUS * a_intRealExpr_MINUS, int log);
void check_intRealExpr_PLUS(intRealExpr_PLUS * a_intRealExpr_PLUS, int log);
void check_intRealExpr_POWER(intRealExpr_POWER * a_intRealExpr_POWER, int log);
void check_intRealExpr_TIMES(intRealExpr_TIMES * a_intRealExpr_TIMES, int log);
void check_intRealRel(intRealRel * a_intRealRel, int log);
void check_intRealRel_EQ(intRealRel_EQ * a_intRealRel_EQ, int log);
void check_intRealRel_GE(intRealRel_GE * a_intRealRel_GE, int log);
void check_intRealRel_GT(intRealRel_GT * a_intRealRel_GT, int log);
void check_intRealRel_LE(intRealRel_LE * a_intRealRel_LE, int log);
void check_intRealRel_LT(intRealRel_LT * a_intRealRel_LT, int log);
void check_intRealRel_NE(intRealRel_NE * a_intRealRel_NE, int log);
void check_intRel(intRel * a_intRel, int log);
void check_intRel_EQ(intRel_EQ * a_intRel_EQ, int log);
void check_intRel_GE(intRel_GE * a_intRel_GE, int log);
void check_intRel_GT(intRel_GT * a_intRel_GT, int log);
void check_intRel_LE(intRel_LE * a_intRel_LE, int log);
void check_intRel_LT(intRel_LT * a_intRel_LT, int log);
void check_intRel_NE(intRel_NE * a_intRel_NE, int log);
void check_intVal(intVal * a_intVal, int log);
void check_intVar(intVar * a_intVar, int log);
void check_intVecExpr_TIMES(intVecExpr_TIMES * a_intVecExpr_TIMES, int log);
void check_intofConst(intofConst * a_intofConst, int log);
void check_iteratConvergence(iteratConvergence * a_iteratConvergence, int log);
void check_iteratConvergence_ABSL(
     iteratConvergence_ABSL * a_iteratConvergence_ABSL, int log);
void check_iteratConvergence_INCR(
     iteratConvergence_INCR * a_iteratConvergence_INCR, int log);
void check_iteratCriterionItem(
     iteratCriterionItem * a_iteratCriterionItem, int log);
void check_iteratCriterionStart(
     iteratCriterionStart * a_iteratCriterionStart, int log);
void check_iteratCriterionStart_axis(
     iteratCriterionStart_axis * a_iteratCriterionStart_axis, int log);
void check_iteratCriterionStart_vector(
     iteratCriterionStart_vector * a_iteratCriterionStart_vector, int log);
void check_iteratMinor(iteratMinor * a_iteratMinor, int log);
void check_iteratStm(iteratStm * a_iteratStm, int log);
void check_jointConf(jointConf * a_jointConf, int log);
void check_jumpLabel(jumpLabel * a_jumpLabel, int log);
void check_jumpStm(jumpStm * a_jumpStm, int log);
void check_jumptoStm(jumptoStm * a_jumptoStm, int log);
void check_kcLabel(kcLabel * a_kcLabel, int log);
void check_kcaLabel(kcaLabel * a_kcaLabel, int log);
void check_keycharMinor(keycharMinor * a_keycharMinor, int log);
void check_keycharOneFeature(keycharOneFeature * a_keycharOneFeature, int log);
void check_keycharStm(keycharStm * a_keycharStm, int log);
void check_keycharTwoFeatures(
     keycharTwoFeatures * a_keycharTwoFeatures, int log);
void check_labelName(labelName * a_labelName, int log);
void check_labelNameAt(labelNameAt * a_labelNameAt, int log);
void check_labelNameCon(labelNameCon * a_labelNameCon, int log);
void check_labelNameConst(labelNameConst * a_labelNameConst, int log);
void check_leftRight(leftRight * a_leftRight, int log);
void check_lengthUnit(lengthUnit * a_lengthUnit, int log);
void check_liLabel(liLabel * a_liLabel, int log);
void check_litdefLight(litdefLight * a_litdefLight, int log);
void check_litdefLightType(litdefLightType * a_litdefLightType, int log);
void check_litdefMinor(litdefMinor * a_litdefMinor, int log);
void check_litdefStm(litdefStm * a_litdefStm, int log);
void check_litdefStrobe(litdefStrobe * a_litdefStrobe, int log);
void check_litdefStrobeType(litdefStrobeType * a_litdefStrobeType, int log);
void check_litdefStrobeType_CYCLE(
     litdefStrobeType_CYCLE * a_litdefStrobeType_CYCLE, int log);
void check_locateLabel(locateLabel * a_locateLabel, int log);
void check_locateRotAllowed(locateRotAllowed * a_locateRotAllowed, int log);
void check_locateStm(locateStm * a_locateStm, int log);
void check_locateTransAllowed(
     locateTransAllowed * a_locateTransAllowed, int log);
void check_longShort(longShort * a_longShort, int log);
void check_lotidStm(lotidStm * a_lotidStm, int log);
void check_mLabel(mLabel * a_mLabel, int log);
void check_mLabelConst(mLabelConst * a_mLabelConst, int log);
void check_maLabel(maLabel * a_maLabel, int log);
void check_macroBlock(macroBlock * a_macroBlock, int log);
void check_macroPar(macroPar * a_macroPar, int log);
void check_macroPar_MACROVARNAME(
     macroPar_MACROVARNAME * a_macroPar_MACROVARNAME, int log);
void check_macroPar_stringConst(
     macroPar_stringConst * a_macroPar_stringConst, int log);
void check_macroStm(macroStm * a_macroStm, int log);
void check_matDir(matDir * a_matDir, int log);
void check_matdefFeat(matdefFeat * a_matdefFeat, int log);
void check_matdefGeom(matdefGeom * a_matdefGeom, int log);
void check_matdefMat(matdefMat * a_matdefMat, int log);
void check_matdefMat_LMC(matdefMat_LMC * a_matdefMat_LMC, int log);
void check_matdefMat_MMC(matdefMat_MMC * a_matdefMat_MMC, int log);
void check_matdefMating(matdefMating * a_matdefMating, int log);
void check_matdefMethod(matdefMethod * a_matdefMethod, int log);
void check_matdefMinor(matdefMinor * a_matdefMinor, int log);
void check_matdefSpec(matdefSpec * a_matdefSpec, int log);
void check_matdefStm(matdefStm * a_matdefStm, int log);
void check_matdefType(matdefType * a_matdefType, int log);
void check_matdefTypeBand(matdefTypeBand * a_matdefTypeBand, int log);
void check_matdefTypeZone(matdefTypeZone * a_matdefTypeZone, int log);
void check_matrix(matrix * a_matrix, int log);
void check_mdLabel(mdLabel * a_mdLabel, int log);
void check_measBlock(measBlock * a_measBlock, int log);
void check_measBlockItem(measBlockItem * a_measBlockItem, int log);
void check_measBlockStatement(
     measBlockStatement * a_measBlockStatement, int log);
void check_measBlock_measStm(measBlock_measStm * a_measBlock_measStm, int log);
void check_measBlock_rmeasStm(
     measBlock_rmeasStm * a_measBlock_rmeasStm, int log);
void check_measCaseBlock(measCaseBlock * a_measCaseBlock, int log);
void check_measDefaultCaseBlock(
     measDefaultCaseBlock * a_measDefaultCaseBlock, int log);
void check_measDoBlock(measDoBlock * a_measDoBlock, int log);
void check_measGeotype(measGeotype * a_measGeotype, int log);
void check_measIfBlock(measIfBlock * a_measIfBlock, int log);
void check_measMinor(measMinor * a_measMinor, int log);
void check_measMinorComp(measMinorComp * a_measMinorComp, int log);
void check_measMinorOther(measMinorOther * a_measMinorOther, int log);
void check_measSelectBlock(measSelectBlock * a_measSelectBlock, int log);
void check_measStm(measStm * a_measStm, int log);
void check_measVar2(measVar2 * a_measVar2, int log);
void check_measVar2Aux(measVar2Aux * a_measVar2Aux, int log);
void check_measVar2_FEAT(measVar2_FEAT * a_measVar2_FEAT, int log);
void check_measVar2_VEC(measVar2_VEC * a_measVar2_VEC, int log);
void check_mfgdevStm(mfgdevStm * a_mfgdevStm, int log);
void check_midliConst(midliConst * a_midliConst, int log);
void check_midplConst(midplConst * a_midplConst, int log);
void check_midptConst(midptConst * a_midptConst, int log);
void check_modeStm(modeStm * a_modeStm, int log);
void check_moveptConst(moveptConst * a_moveptConst, int log);
void check_moveptConstAxis(moveptConstAxis * a_moveptConstAxis, int log);
void check_moveptConstVec(moveptConstVec * a_moveptConstVec, int log);
void check_nearptConst(nearptConst * a_nearptConst, int log);
void check_negDir(negDir * a_negDir, int log);
void check_noParseStm(noParseStm * a_noParseStm, int log);
void check_obtainBool(obtainBool * a_obtainBool, int log);
void check_obtainInt(obtainInt * a_obtainInt, int log);
void check_obtainLabeled(obtainLabeled * a_obtainLabeled, int log);
void check_obtainLabeled_crLabel(
     obtainLabeled_crLabel * a_obtainLabeled_crLabel, int log);
void check_obtainLabeled_datumLabel1(
     obtainLabeled_datumLabel1 * a_obtainLabeled_datumLabel1, int log);
void check_obtainLabeled_didLabel(
     obtainLabeled_didLabel * a_obtainLabeled_didLabel, int log);
void check_obtainLabeled_featureLabel(
     obtainLabeled_featureLabel * a_obtainLabeled_featureLabel, int log);
void check_obtainLabeled_gLabel(
     obtainLabeled_gLabel * a_obtainLabeled_gLabel, int log);
void check_obtainLabeled_gsaLabel(
     obtainLabeled_gsaLabel * a_obtainLabeled_gsaLabel, int log);
void check_obtainLabeled_kcLabel(
     obtainLabeled_kcLabel * a_obtainLabeled_kcLabel, int log);
void check_obtainLabeled_maLabel(
     obtainLabeled_maLabel * a_obtainLabeled_maLabel, int log);
void check_obtainLabeled_pLabel(
     obtainLabeled_pLabel * a_obtainLabeled_pLabel, int log);
void check_obtainLabeled_qisLabel(
     obtainLabeled_qisLabel * a_obtainLabeled_qisLabel, int log);
void check_obtainLabeled_rLabel(
     obtainLabeled_rLabel * a_obtainLabeled_rLabel, int log);
void check_obtainLabeled_rmLabel(
     obtainLabeled_rmLabel * a_obtainLabeled_rmLabel, int log);
void check_obtainLabeled_rtLabel(
     obtainLabeled_rtLabel * a_obtainLabeled_rtLabel, int log);
void check_obtainLabeled_sensorLabel1(
     obtainLabeled_sensorLabel1 * a_obtainLabeled_sensorLabel1, int log);
void check_obtainLabeled_sgLabel(
     obtainLabeled_sgLabel * a_obtainLabeled_sgLabel, int log);
void check_obtainLabeled_sgsLabel(
     obtainLabeled_sgsLabel * a_obtainLabeled_sgsLabel, int log);
void check_obtainLabeled_sraLabel(
     obtainLabeled_sraLabel * a_obtainLabeled_sraLabel, int log);
void check_obtainLabeled_ssLabel(
     obtainLabeled_ssLabel * a_obtainLabeled_ssLabel, int log);
void check_obtainLabeled_swLabel(
     obtainLabeled_swLabel * a_obtainLabeled_swLabel, int log);
void check_obtainLabeled_sxLabel(
     obtainLabeled_sxLabel * a_obtainLabeled_sxLabel, int log);
void check_obtainLabeled_thLabel(
     obtainLabeled_thLabel * a_obtainLabeled_thLabel, int log);
void check_obtainLabeled_toleranceLabel(
     obtainLabeled_toleranceLabel * a_obtainLabeled_toleranceLabel, int log);
void check_obtainLabeled_vLabel(
     obtainLabeled_vLabel * a_obtainLabeled_vLabel, int log);
void check_obtainLabeled_vaLabel(
     obtainLabeled_vaLabel * a_obtainLabeled_vaLabel, int log);
void check_obtainLabeled_vfLabel(
     obtainLabeled_vfLabel * a_obtainLabeled_vfLabel, int log);
void check_obtainLabeled_vlLabel(
     obtainLabeled_vlLabel * a_obtainLabeled_vlLabel, int log);
void check_obtainLabeled_vwLabel(
     obtainLabeled_vwLabel * a_obtainLabeled_vwLabel, int log);
void check_obtainPoint(obtainPoint * a_obtainPoint, int log);
void check_obtainRealLabel(obtainRealLabel * a_obtainRealLabel, int log);
void check_obtainRealPoint(obtainRealPoint * a_obtainRealPoint, int log);
void check_obtainStm(obtainStm * a_obtainStm, int log);
void check_obtainString(obtainString * a_obtainString, int log);
void check_offsetConst(offsetConst * a_offsetConst, int log);
void check_opLabel(opLabel * a_opLabel, int log);
void check_openCadfile(openCadfile * a_openCadfile, int log);
void check_openDMLfile(openDMLfile * a_openDMLfile, int log);
void check_openDevice(openDevice * a_openDevice, int log);
void check_openDevice_inputAccess(
     openDevice_inputAccess * a_openDevice_inputAccess, int log);
void check_openDevice_outputAccess(
     openDevice_outputAccess * a_openDevice_outputAccess, int log);
void check_openDmlInput(openDmlInput * a_openDmlInput, int log);
void check_openDmlOutput(openDmlOutput * a_openDmlOutput, int log);
void check_openFdata(openFdata * a_openFdata, int log);
void check_openFdata_DMIS(openFdata_DMIS * a_openFdata_DMIS, int log);
void check_openFdata_vLabel(openFdata_vLabel * a_openFdata_vLabel, int log);
void check_openMinor(openMinor * a_openMinor, int log);
void check_openMinor_openCadfile(
     openMinor_openCadfile * a_openMinor_openCadfile, int log);
void check_openMinor_openDMLfile(
     openMinor_openDMLfile * a_openMinor_openDMLfile, int log);
void check_openMinor_openDevice(
     openMinor_openDevice * a_openMinor_openDevice, int log);
void check_openMinor_openFdata(
     openMinor_openFdata * a_openMinor_openFdata, int log);
void check_openMinor_storageSpecList(
     openMinor_storageSpecList * a_openMinor_storageSpecList, int log);
void check_openStm(openStm * a_openStm, int log);
void check_operidStm(operidStm * a_operidStm, int log);
void check_orig(orig * a_orig, int log);
void check_outputAccess(outputAccess * a_outputAccess, int log);
void check_outputConstBothData(
     outputConstBothData * a_outputConstBothData, int log);
void check_outputConstData(outputConstData * a_outputConstData, int log);
void check_outputConstGaugeData(
     outputConstGaugeData * a_outputConstGaugeData, int log);
void check_outputConstPartData(
     outputConstPartData * a_outputConstPartData, int log);
void check_outputDat(outputDat * a_outputDat, int log);
void check_outputDat_datLabel(
     outputDat_datLabel * a_outputDat_datLabel, int log);
void check_outputDat_faLabel(outputDat_faLabel * a_outputDat_faLabel, int log);
void check_outputFeat(outputFeat * a_outputFeat, int log);
void check_outputFeat1F(outputFeat1F * a_outputFeat1F, int log);
void check_outputFeat1FT(outputFeat1FT * a_outputFeat1FT, int log);
void check_outputFeat1Fa(outputFeat1Fa * a_outputFeat1Fa, int log);
void check_outputFeat1FaTa(outputFeat1FaTa * a_outputFeat1FaTa, int log);
void check_outputFeat2FFT(outputFeat2FFT * a_outputFeat2FFT, int log);
void check_outputFeat2FFaTa(outputFeat2FFaTa * a_outputFeat2FFaTa, int log);
void check_outputFeat2FaFTa(outputFeat2FaFTa * a_outputFeat2FaFTa, int log);
void check_outputFeat2FaFaTa(outputFeat2FaFaTa * a_outputFeat2FaFaTa, int log);
void check_outputFeatData(outputFeatData * a_outputFeatData, int log);
void check_outputKeycharData(outputKeycharData * a_outputKeycharData, int log);
void check_outputMinor(outputMinor * a_outputMinor, int log);
void check_outputReportData(outputReportData * a_outputReportData, int log);
void check_outputSensorData(outputSensorData * a_outputSensorData, int log);
void check_outputSensorData_sLabel(
     outputSensorData_sLabel * a_outputSensorData_sLabel, int log);
void check_outputSensorData_saLabel(
     outputSensorData_saLabel * a_outputSensorData_saLabel, int log);
void check_outputSensorDesc(outputSensorDesc * a_outputSensorDesc, int log);
void check_outputSensorDesc_intVal(
     outputSensorDesc_intVal * a_outputSensorDesc_intVal, int log);
void check_outputSensorDesc_outputSensorWristList(
     outputSensorDesc_outputSensorWristList * a_outputSensorDesc_outputSensorWristList, int log);
void check_outputSensorDesc_stringVal(
     outputSensorDesc_stringVal * a_outputSensorDesc_stringVal, int log);
void check_outputSensorWristAngle(
     outputSensorWristAngle * a_outputSensorWristAngle, int log);
void check_outputSensorWristItem(
     outputSensorWristItem * a_outputSensorWristItem, int log);
void check_outputStm(outputStm * a_outputStm, int log);
void check_outputToleranceData(
     outputToleranceData * a_outputToleranceData, int log);
void check_pLabel(pLabel * a_pLabel, int log);
void check_pameasDetail(pameasDetail * a_pameasDetail, int log);
void check_pameasDetailDistance(
     pameasDetailDistance * a_pameasDetailDistance, int log);
void check_pameasDetailPitch(pameasDetailPitch * a_pameasDetailPitch, int log);
void check_pameasDetailScnvelData(
     pameasDetailScnvelData * a_pameasDetailScnvelData, int log);
void check_pameasDetailScnvelNoData(
     pameasDetailScnvelNoData * a_pameasDetailScnvelNoData, int log);
void check_pameasFedrat(pameasFedrat * a_pameasFedrat, int log);
void check_pameasFedrat_IPM(pameasFedrat_IPM * a_pameasFedrat_IPM, int log);
void check_pameasFedrat_IPS(pameasFedrat_IPS * a_pameasFedrat_IPS, int log);
void check_pameasFedrat_MMPS(pameasFedrat_MMPS * a_pameasFedrat_MMPS, int log);
void check_pameasFedrat_MPM(pameasFedrat_MPM * a_pameasFedrat_MPM, int log);
void check_pameasMinor(pameasMinor * a_pameasMinor, int log);
void check_pameasMinor_pameasVar2List(
     pameasMinor_pameasVar2List * a_pameasMinor_pameasVar2List, int log);
void check_pameasMinor_pameasVar3List(
     pameasMinor_pameasVar3List * a_pameasMinor_pameasVar3List, int log);
void check_pameasRemove(pameasRemove * a_pameasRemove, int log);
void check_pameasRemoveCount(pameasRemoveCount * a_pameasRemoveCount, int log);
void check_pameasRemoveDist(pameasRemoveDist * a_pameasRemoveDist, int log);
void check_pameasStm(pameasStm * a_pameasStm, int log);
void check_pameasVar2ListItem(
     pameasVar2ListItem * a_pameasVar2ListItem, int log);
void check_pameasVar3ListItem(
     pameasVar3ListItem * a_pameasVar3ListItem, int log);
void check_param(param * a_param, int log);
void check_partidStm(partidStm * a_partidStm, int log);
void check_partoConst(partoConst * a_partoConst, int log);
void check_partoConstAct(partoConstAct * a_partoConstAct, int log);
void check_partoConstNom(partoConstNom * a_partoConstNom, int log);
void check_partrvStm(partrvStm * a_partrvStm, int log);
void check_partsnStm(partsnStm * a_partsnStm, int log);
void check_pathArc(pathArc * a_pathArc, int log);
void check_pathCurve(pathCurve * a_pathCurve, int log);
void check_pathCurvePoints(pathCurvePoints * a_pathCurvePoints, int log);
void check_pathCurvePtdata(pathCurvePtdata * a_pathCurvePtdata, int log);
void check_pathCurve_pathCurvePoints(
     pathCurve_pathCurvePoints * a_pathCurve_pathCurvePoints, int log);
void check_pathCurve_pathCurvePtdata(
     pathCurve_pathCurvePtdata * a_pathCurve_pathCurvePtdata, int log);
void check_pathHelical(pathHelical * a_pathHelical, int log);
void check_pathLine(pathLine * a_pathLine, int log);
void check_pathLineCart(pathLineCart * a_pathLineCart, int log);
void check_pathLinePol(pathLinePol * a_pathLinePol, int log);
void check_pathMinor(pathMinor * a_pathMinor, int log);
void check_pathPoint(pathPoint * a_pathPoint, int log);
void check_pathStm(pathStm * a_pathStm, int log);
void check_pathSurface(pathSurface * a_pathSurface, int log);
void check_pathSurfaceHeadcs(pathSurfaceHeadcs * a_pathSurfaceHeadcs, int log);
void check_pathSurfaceHeadcsData(
     pathSurfaceHeadcsData * a_pathSurfaceHeadcsData, int log);
void check_pathSurfacePcs(pathSurfacePcs * a_pathSurfacePcs, int log);
void check_pathSurfacePcsData(
     pathSurfacePcsData * a_pathSurfacePcsData, int log);
void check_pathSurfacePlain(pathSurfacePlain * a_pathSurfacePlain, int log);
void check_pathUnknown(pathUnknown * a_pathUnknown, int log);
void check_pcLabel(pcLabel * a_pcLabel, int log);
void check_perptoConst(perptoConst * a_perptoConst, int log);
void check_perptoConstAct(perptoConstAct * a_perptoConstAct, int log);
void check_perptoConstNom(perptoConstNom * a_perptoConstNom, int log);
void check_pierceConst(pierceConst * a_pierceConst, int log);
void check_plLabel(plLabel * a_plLabel, int log);
void check_plan(plan * a_plan, int log);
void check_planidStm(planidStm * a_planidStm, int log);
void check_pnLabel(pnLabel * a_pnLabel, int log);
void check_pointRange(pointRange * a_pointRange, int log);
void check_pointVecCart(pointVecCart * a_pointVecCart, int log);
void check_pointVecPol(pointVecPol * a_pointVecPol, int log);
void check_polPoint(polPoint * a_polPoint, int log);
void check_popStm(popStm * a_popStm, int log);
void check_posDir(posDir * a_posDir, int log);
void check_prLabel(prLabel * a_prLabel, int log);
void check_prcompStm(prcompStm * a_prcompStm, int log);
void check_prevopStm(prevopStm * a_prevopStm, int log);
void check_probeLocCart(probeLocCart * a_probeLocCart, int log);
void check_probeLocPol(probeLocPol * a_probeLocPol, int log);
void check_probeLocSnsCart(probeLocSnsCart * a_probeLocSnsCart, int log);
void check_probeLocSnsVec(probeLocSnsVec * a_probeLocSnsVec, int log);
void check_probeLocVec(probeLocVec * a_probeLocVec, int log);
void check_probeLocation(probeLocation * a_probeLocation, int log);
void check_probeOrient(probeOrient * a_probeOrient, int log);
void check_probeOrient_HEADCS(
     probeOrient_HEADCS * a_probeOrient_HEADCS, int log);
void check_probeOrient_PCS(probeOrient_PCS * a_probeOrient_PCS, int log);
void check_probeOrient_VEC(probeOrient_VEC * a_probeOrient_VEC, int log);
void check_probeOrient_featureLabel(
     probeOrient_featureLabel * a_probeOrient_featureLabel, int log);
void check_procidStm(procidStm * a_procidStm, int log);
void check_projctConst(projctConst * a_projctConst, int log);
void check_projliConst(projliConst * a_projliConst, int log);
void check_projptConst(projptConst * a_projptConst, int log);
void check_promptIntEnd(promptIntEnd * a_promptIntEnd, int log);
void check_promptIntEnd_promptItemList(
     promptIntEnd_promptItemList * a_promptIntEnd_promptItemList, int log);
void check_promptIntEnd_stringVal(
     promptIntEnd_stringVal * a_promptIntEnd_stringVal, int log);
void check_promptItem(promptItem * a_promptItem, int log);
void check_promptItem_BUTTON(promptItem_BUTTON * a_promptItem_BUTTON, int log);
void check_promptItem_CHECK(promptItem_CHECK * a_promptItem_CHECK, int log);
void check_promptItem_EDIT(promptItem_EDIT * a_promptItem_EDIT, int log);
void check_promptItem_GROUP(promptItem_GROUP * a_promptItem_GROUP, int log);
void check_promptItem_LIST(promptItem_LIST * a_promptItem_LIST, int log);
void check_promptItem_PICTURE(
     promptItem_PICTURE * a_promptItem_PICTURE, int log);
void check_promptItem_PIXBTN(promptItem_PIXBTN * a_promptItem_PIXBTN, int log);
void check_promptItem_SOUND(promptItem_SOUND * a_promptItem_SOUND, int log);
void check_promptItem_TEXT(promptItem_TEXT * a_promptItem_TEXT, int log);
void check_promptItem_TITLE(promptItem_TITLE * a_promptItem_TITLE, int log);
void check_promptStm(promptStm * a_promptStm, int log);
void check_promptStm_boolVar(promptStm_boolVar * a_promptStm_boolVar, int log);
void check_promptStm_ccLabel(promptStm_ccLabel * a_promptStm_ccLabel, int log);
void check_promptStm_ciLabel(promptStm_ciLabel * a_promptStm_ciLabel, int log);
void check_promptStm_csLabel(promptStm_csLabel * a_promptStm_csLabel, int log);
void check_promptStm_diLabel(promptStm_diLabel * a_promptStm_diLabel, int log);
void check_promptStm_dsLabel(promptStm_dsLabel * a_promptStm_dsLabel, int log);
void check_promptStm_dvLabel(promptStm_dvLabel * a_promptStm_dvLabel, int log);
void check_promptStm_fiLabel(promptStm_fiLabel * a_promptStm_fiLabel, int log);
void check_promptStm_fsLabel(promptStm_fsLabel * a_promptStm_fsLabel, int log);
void check_promptStm_intVar(promptStm_intVar * a_promptStm_intVar, int log);
void check_promptStm_liLabel(promptStm_liLabel * a_promptStm_liLabel, int log);
void check_promptStm_mdLabel(promptStm_mdLabel * a_promptStm_mdLabel, int log);
void check_promptStm_opLabel(promptStm_opLabel * a_promptStm_opLabel, int log);
void check_promptStm_pcLabel(promptStm_pcLabel * a_promptStm_pcLabel, int log);
void check_promptStm_plLabel(promptStm_plLabel * a_promptStm_plLabel, int log);
void check_promptStm_pnLabel(promptStm_pnLabel * a_promptStm_pnLabel, int log);
void check_promptStm_prLabel(promptStm_prLabel * a_promptStm_prLabel, int log);
void check_promptStm_psLabel(promptStm_psLabel * a_promptStm_psLabel, int log);
void check_promptStm_pvLabel(promptStm_pvLabel * a_promptStm_pvLabel, int log);
void check_promptStm_qLabel(promptStm_qLabel * a_promptStm_qLabel, int log);
void check_promptStm_realVar(promptStm_realVar * a_promptStm_realVar, int log);
void check_promptStm_stringVar(
     promptStm_stringVar * a_promptStm_stringVar, int log);
void check_promptStm_tlLabel(promptStm_tlLabel * a_promptStm_tlLabel, int log);
void check_promptVar(promptVar * a_promptVar, int log);
void check_psLabel(psLabel * a_psLabel, int log);
void check_psthruMinor(psthruMinor * a_psthruMinor, int log);
void check_psthruMinor_COMAND(
     psthruMinor_COMAND * a_psthruMinor_COMAND, int log);
void check_psthruMinor_TRMATX(
     psthruMinor_TRMATX * a_psthruMinor_TRMATX, int log);
void check_psthruStm(psthruStm * a_psthruStm, int log);
void check_ptbuffStm(ptbuffStm * a_ptbuffStm, int log);
void check_ptmeasEnd(ptmeasEnd * a_ptmeasEnd, int log);
void check_ptmeasEnd_csSpec(ptmeasEnd_csSpec * a_ptmeasEnd_csSpec, int log);
void check_ptmeasEnd_touchSpec(
     ptmeasEnd_touchSpec * a_ptmeasEnd_touchSpec, int log);
void check_ptmeasStm(ptmeasStm * a_ptmeasStm, int log);
void check_pushStm(pushStm * a_pushStm, int log);
void check_pvLabel(pvLabel * a_pvLabel, int log);
void check_qLabel(qLabel * a_qLabel, int log);
void check_qisLabel(qisLabel * a_qisLabel, int log);
void check_qisdefStm(qisdefStm * a_qisdefStm, int log);
void check_rLabel(rLabel * a_rLabel, int log);
void check_radiusSpec(radiusSpec * a_radiusSpec, int log);
void check_rapidStm(rapidStm * a_rapidStm, int log);
void check_readSpec(readSpec * a_readSpec, int log);
void check_readStm(readStm * a_readStm, int log);
void check_realConst(realConst * a_realConst, int log);
void check_realExpr(realExpr * a_realExpr, int log);
void check_realExprNegat(realExprNegat * a_realExprNegat, int log);
void check_realExprParen(realExprParen * a_realExprParen, int log);
void check_realExprPosit(realExprPosit * a_realExprPosit, int log);
void check_realFunc(realFunc * a_realFunc, int log);
void check_realFuncAbs(realFuncAbs * a_realFuncAbs, int log);
void check_realFuncAcos(realFuncAcos * a_realFuncAcos, int log);
void check_realFuncAsin(realFuncAsin * a_realFuncAsin, int log);
void check_realFuncAtan(realFuncAtan * a_realFuncAtan, int log);
void check_realFuncAtan2(realFuncAtan2 * a_realFuncAtan2, int log);
void check_realFuncCos(realFuncCos * a_realFuncCos, int log);
void check_realFuncDble(realFuncDble * a_realFuncDble, int log);
void check_realFuncDtor(realFuncDtor * a_realFuncDtor, int log);
void check_realFuncExp(realFuncExp * a_realFuncExp, int log);
void check_realFuncLn(realFuncLn * a_realFuncLn, int log);
void check_realFuncLog(realFuncLog * a_realFuncLog, int log);
void check_realFuncMn(realFuncMn * a_realFuncMn, int log);
void check_realFuncMod(realFuncMod * a_realFuncMod, int log);
void check_realFuncMx(realFuncMx * a_realFuncMx, int log);
void check_realFuncQtemp(realFuncQtemp * a_realFuncQtemp, int log);
void check_realFuncRand(realFuncRand * a_realFuncRand, int log);
void check_realFuncRl(realFuncRl * a_realFuncRl, int log);
void check_realFuncRtod(realFuncRtod * a_realFuncRtod, int log);
void check_realFuncSign(realFuncSign * a_realFuncSign, int log);
void check_realFuncSin(realFuncSin * a_realFuncSin, int log);
void check_realFuncSqrt(realFuncSqrt * a_realFuncSqrt, int log);
void check_realFuncTan(realFuncTan * a_realFuncTan, int log);
void check_realFuncVal(realFuncVal * a_realFuncVal, int log);
void check_realFuncVdot(realFuncVdot * a_realFuncVdot, int log);
void check_realFuncVecX(realFuncVecX * a_realFuncVecX, int log);
void check_realFuncVecY(realFuncVecY * a_realFuncVecY, int log);
void check_realFuncVecZ(realFuncVecZ * a_realFuncVecZ, int log);
void check_realFuncVmag(realFuncVmag * a_realFuncVmag, int log);
void check_realIntExpr(realIntExpr * a_realIntExpr, int log);
void check_realIntExpr_DIVID(realIntExpr_DIVID * a_realIntExpr_DIVID, int log);
void check_realIntExpr_MINUS(realIntExpr_MINUS * a_realIntExpr_MINUS, int log);
void check_realIntExpr_PLUS(realIntExpr_PLUS * a_realIntExpr_PLUS, int log);
void check_realIntExpr_POWER(realIntExpr_POWER * a_realIntExpr_POWER, int log);
void check_realIntExpr_TIMES(realIntExpr_TIMES * a_realIntExpr_TIMES, int log);
void check_realIntRel(realIntRel * a_realIntRel, int log);
void check_realIntRel_EQ(realIntRel_EQ * a_realIntRel_EQ, int log);
void check_realIntRel_GE(realIntRel_GE * a_realIntRel_GE, int log);
void check_realIntRel_GT(realIntRel_GT * a_realIntRel_GT, int log);
void check_realIntRel_LE(realIntRel_LE * a_realIntRel_LE, int log);
void check_realIntRel_LT(realIntRel_LT * a_realIntRel_LT, int log);
void check_realIntRel_NE(realIntRel_NE * a_realIntRel_NE, int log);
void check_realRealExpr(realRealExpr * a_realRealExpr, int log);
void check_realRealExpr_DIVID(
     realRealExpr_DIVID * a_realRealExpr_DIVID, int log);
void check_realRealExpr_MINUS(
     realRealExpr_MINUS * a_realRealExpr_MINUS, int log);
void check_realRealExpr_PLUS(realRealExpr_PLUS * a_realRealExpr_PLUS, int log);
void check_realRealExpr_POWER(
     realRealExpr_POWER * a_realRealExpr_POWER, int log);
void check_realRealExpr_TIMES(
     realRealExpr_TIMES * a_realRealExpr_TIMES, int log);
void check_realRealRel(realRealRel * a_realRealRel, int log);
void check_realRealRel_EQ(realRealRel_EQ * a_realRealRel_EQ, int log);
void check_realRealRel_GE(realRealRel_GE * a_realRealRel_GE, int log);
void check_realRealRel_GT(realRealRel_GT * a_realRealRel_GT, int log);
void check_realRealRel_LE(realRealRel_LE * a_realRealRel_LE, int log);
void check_realRealRel_LT(realRealRel_LT * a_realRealRel_LT, int log);
void check_realRealRel_NE(realRealRel_NE * a_realRealRel_NE, int log);
void check_realRel(realRel * a_realRel, int log);
void check_realVal(realVal * a_realVal, int log);
void check_realVar(realVar * a_realVar, int log);
void check_realVecExpr_TIMES(realVecExpr_TIMES * a_realVecExpr_TIMES, int log);
void check_recallDMLStm(recallDMLStm * a_recallDMLStm, int log);
void check_recallDatumStm(recallDatumStm * a_recallDatumStm, int log);
void check_recallFeatureStm(recallFeatureStm * a_recallFeatureStm, int log);
void check_recallRotaryTableStm(
     recallRotaryTableStm * a_recallRotaryTableStm, int log);
void check_recallSensorStm(recallSensorStm * a_recallSensorStm, int log);
void check_refmntStm(refmntStm * a_refmntStm, int log);
void check_rentVal(rentVal * a_rentVal, int log);
void check_reportItem(reportItem * a_reportItem, int log);
void check_reportItem_qisLabel(
     reportItem_qisLabel * a_reportItem_qisLabel, int log);
void check_reportStm(reportStm * a_reportStm, int log);
void check_resumeMinor(resumeMinor * a_resumeMinor, int log);
void check_resumeMinor_jumpLabel(
     resumeMinor_jumpLabel * a_resumeMinor_jumpLabel, int log);
void check_resumeStm(resumeStm * a_resumeStm, int log);
void check_retrieve1(retrieve1 * a_retrieve1, int log);
void check_retrieve2(retrieve2 * a_retrieve2, int log);
void check_retrieve2b(retrieve2b * a_retrieve2b, int log);
void check_retrieve4(retrieve4 * a_retrieve4, int log);
void check_rightyLefty(rightyLefty * a_rightyLefty, int log);
void check_rmLabel(rmLabel * a_rmLabel, int log);
void check_rmeasArc(rmeasArc * a_rmeasArc, int log);
void check_rmeasArc_rmeasSpecFa(
     rmeasArc_rmeasSpecFa * a_rmeasArc_rmeasSpecFa, int log);
void check_rmeasArc_rmeasSpecVecbld(
     rmeasArc_rmeasSpecVecbld * a_rmeasArc_rmeasSpecVecbld, int log);
void check_rmeasCircle(rmeasCircle * a_rmeasCircle, int log);
void check_rmeasCircle_rmeasSpecFa(
     rmeasCircle_rmeasSpecFa * a_rmeasCircle_rmeasSpecFa, int log);
void check_rmeasCircle_rmeasSpecVecbld(
     rmeasCircle_rmeasSpecVecbld * a_rmeasCircle_rmeasSpecVecbld, int log);
void check_rmeasCone(rmeasCone * a_rmeasCone, int log);
void check_rmeasCparln(rmeasCparln * a_rmeasCparln, int log);
void check_rmeasCparln_rmeasSpecFaOrient(
     rmeasCparln_rmeasSpecFaOrient * a_rmeasCparln_rmeasSpecFaOrient, int log);
void check_rmeasCparln_rmeasSpecVecbldOrient(
     rmeasCparln_rmeasSpecVecbldOrient * a_rmeasCparln_rmeasSpecVecbldOrient, int log);
void check_rmeasCylndr(rmeasCylndr * a_rmeasCylndr, int log);
void check_rmeasEdgept(rmeasEdgept * a_rmeasEdgept, int log);
void check_rmeasEdgept_rmeasSpecFaAxis(
     rmeasEdgept_rmeasSpecFaAxis * a_rmeasEdgept_rmeasSpecFaAxis, int log);
void check_rmeasEdgept_rmeasSpecVecbldEdgept(
     rmeasEdgept_rmeasSpecVecbldEdgept * a_rmeasEdgept_rmeasSpecVecbldEdgept, int log);
void check_rmeasEllips(rmeasEllips * a_rmeasEllips, int log);
void check_rmeasEllips_rmeasSpecFa(
     rmeasEllips_rmeasSpecFa * a_rmeasEllips_rmeasSpecFa, int log);
void check_rmeasEllips_rmeasSpecVecbld(
     rmeasEllips_rmeasSpecVecbld * a_rmeasEllips_rmeasSpecVecbld, int log);
void check_rmeasGcurve(rmeasGcurve * a_rmeasGcurve, int log);
void check_rmeasGcurve_rmeasSpecFeatAxis(
     rmeasGcurve_rmeasSpecFeatAxis * a_rmeasGcurve_rmeasSpecFeatAxis, int log);
void check_rmeasGcurve_rmeasSpecVecbld(
     rmeasGcurve_rmeasSpecVecbld * a_rmeasGcurve_rmeasSpecVecbld, int log);
void check_rmeasGsurf(rmeasGsurf * a_rmeasGsurf, int log);
void check_rmeasLine(rmeasLine * a_rmeasLine, int log);
void check_rmeasLine_rmeasSpecFeatAxis(
     rmeasLine_rmeasSpecFeatAxis * a_rmeasLine_rmeasSpecFeatAxis, int log);
void check_rmeasLine_rmeasSpecVecbld(
     rmeasLine_rmeasSpecVecbld * a_rmeasLine_rmeasSpecVecbld, int log);
void check_rmeasMinor(rmeasMinor * a_rmeasMinor, int log);
void check_rmeasObject(rmeasObject * a_rmeasObject, int log);
void check_rmeasObject_rmeasSpecFa(
     rmeasObject_rmeasSpecFa * a_rmeasObject_rmeasSpecFa, int log);
void check_rmeasObject_rmeasSpecVecbld(
     rmeasObject_rmeasSpecVecbld * a_rmeasObject_rmeasSpecVecbld, int log);
void check_rmeasParpln(rmeasParpln * a_rmeasParpln, int log);
void check_rmeasPlane(rmeasPlane * a_rmeasPlane, int log);
void check_rmeasPoint(rmeasPoint * a_rmeasPoint, int log);
void check_rmeasPoint_rmeasSpecFaAxis(
     rmeasPoint_rmeasSpecFaAxis * a_rmeasPoint_rmeasSpecFaAxis, int log);
void check_rmeasPoint_rmeasSpecVecbld(
     rmeasPoint_rmeasSpecVecbld * a_rmeasPoint_rmeasSpecVecbld, int log);
void check_rmeasRctngl(rmeasRctngl * a_rmeasRctngl, int log);
void check_rmeasSpecFa(rmeasSpecFa * a_rmeasSpecFa, int log);
void check_rmeasSpecFaAxis(rmeasSpecFaAxis * a_rmeasSpecFaAxis, int log);
void check_rmeasSpecFaAxis_axis(
     rmeasSpecFaAxis_axis * a_rmeasSpecFaAxis_axis, int log);
void check_rmeasSpecFaAxis_faLabel(
     rmeasSpecFaAxis_faLabel * a_rmeasSpecFaAxis_faLabel, int log);
void check_rmeasSpecFaOrient(rmeasSpecFaOrient * a_rmeasSpecFaOrient, int log);
void check_rmeasSpecFeatAxis(rmeasSpecFeatAxis * a_rmeasSpecFeatAxis, int log);
void check_rmeasSpecFeatAxis_axis(
     rmeasSpecFeatAxis_axis * a_rmeasSpecFeatAxis_axis, int log);
void check_rmeasSpecFeatAxis_featureLabel1(
     rmeasSpecFeatAxis_featureLabel1 * a_rmeasSpecFeatAxis_featureLabel1, int log);
void check_rmeasSpecVecbld(rmeasSpecVecbld * a_rmeasSpecVecbld, int log);
void check_rmeasSpecVecbldEdgept(
     rmeasSpecVecbldEdgept * a_rmeasSpecVecbldEdgept, int log);
void check_rmeasSpecVecbldOrient(
     rmeasSpecVecbldOrient * a_rmeasSpecVecbldOrient, int log);
void check_rmeasSphere(rmeasSphere * a_rmeasSphere, int log);
void check_rmeasStm(rmeasStm * a_rmeasStm, int log);
void check_rmeasSympln(rmeasSympln * a_rmeasSympln, int log);
void check_rmeasTorus(rmeasTorus * a_rmeasTorus, int log);
void check_rotAbs(rotAbs * a_rotAbs, int log);
void check_rotDir(rotDir * a_rotDir, int log);
void check_rotDir_rotOrient(rotDir_rotOrient * a_rotDir_rotOrient, int log);
void check_rotIncr(rotIncr * a_rotIncr, int log);
void check_rotOrient(rotOrient * a_rotOrient, int log);
void check_rotType(rotType * a_rotType, int log);
void check_rotabAbs(rotabAbs * a_rotabAbs, int log);
void check_rotabFeat(rotabFeat * a_rotabFeat, int log);
void check_rotabIncr(rotabIncr * a_rotabIncr, int log);
void check_rotabMinor(rotabMinor * a_rotabMinor, int log);
void check_rotabStm(rotabStm * a_rotabStm, int log);
void check_rotateDatum(rotateDatum * a_rotateDatum, int log);
void check_rotateFeature(rotateFeature * a_rotateFeature, int log);
void check_rotateMinor(rotateMinor * a_rotateMinor, int log);
void check_rotateStm(rotateStm * a_rotateStm, int log);
void check_rotateValue(rotateValue * a_rotateValue, int log);
void check_rotdefStm(rotdefStm * a_rotdefStm, int log);
void check_rotsetStm(rotsetStm * a_rotsetStm, int log);
void check_rtLabel(rtLabel * a_rtLabel, int log);
void check_rwFormat(rwFormat * a_rwFormat, int log);
void check_rwVar(rwVar * a_rwVar, int log);
void check_sLabel(sLabel * a_sLabel, int log);
void check_saLabel(saLabel * a_saLabel, int log);
void check_saveDMLStm(saveDMLStm * a_saveDMLStm, int log);
void check_saveDatumStm(saveDatumStm * a_saveDatumStm, int log);
void check_saveFeatureStm(saveFeatureStm * a_saveFeatureStm, int log);
void check_saveRotaryTableStm(
     saveRotaryTableStm * a_saveRotaryTableStm, int log);
void check_saveSensorStm(saveSensorStm * a_saveSensorStm, int log);
void check_scnmodStm(scnmodStm * a_scnmodStm, int log);
void check_scnsetDrag(scnsetDrag * a_scnsetDrag, int log);
void check_scnsetMinor(scnsetMinor * a_scnsetMinor, int log);
void check_scnsetNoncon(scnsetNoncon * a_scnsetNoncon, int log);
void check_scnsetPeck(scnsetPeck * a_scnsetPeck, int log);
void check_scnsetSample(scnsetSample * a_scnsetSample, int log);
void check_scnsetSampleDrag(scnsetSampleDrag * a_scnsetSampleDrag, int log);
void check_scnsetSampleDrag_ANGLE(
     scnsetSampleDrag_ANGLE * a_scnsetSampleDrag_ANGLE, int log);
void check_scnsetSampleDrag_CHORD(
     scnsetSampleDrag_CHORD * a_scnsetSampleDrag_CHORD, int log);
void check_scnsetSampleDrag_DEFALT(
     scnsetSampleDrag_DEFALT * a_scnsetSampleDrag_DEFALT, int log);
void check_scnsetSampleDrag_DIST(
     scnsetSampleDrag_DIST * a_scnsetSampleDrag_DIST, int log);
void check_scnsetSampleDrag_TIME(
     scnsetSampleDrag_TIME * a_scnsetSampleDrag_TIME, int log);
void check_scnsetSample_ANGLE(
     scnsetSample_ANGLE * a_scnsetSample_ANGLE, int log);
void check_scnsetSample_CHORD(
     scnsetSample_CHORD * a_scnsetSample_CHORD, int log);
void check_scnsetSample_DIST(scnsetSample_DIST * a_scnsetSample_DIST, int log);
void check_scnsetSample_TIME(scnsetSample_TIME * a_scnsetSample_TIME, int log);
void check_scnsetStm(scnsetStm * a_scnsetStm, int log);
void check_scnsetStop(scnsetStop * a_scnsetStop, int log);
void check_scnsetStopPlane(scnsetStopPlane * a_scnsetStopPlane, int log);
void check_scnsetStopSphere(scnsetStopSphere * a_scnsetStopSphere, int log);
void check_scnsetVendor(scnsetVendor * a_scnsetVendor, int log);
void check_seLabel(seLabel * a_seLabel, int log);
void check_secondsString(secondsString * a_secondsString, int log);
void check_secondsString_INTSTRING(
     secondsString_INTSTRING * a_secondsString_INTSTRING, int log);
void check_secondsString_REALSTRING(
     secondsString_REALSTRING * a_secondsString_REALSTRING, int log);
void check_selectBlock(selectBlock * a_selectBlock, int log);
void check_selectStm(selectStm * a_selectStm, int log);
void check_selectStmInt(selectStmInt * a_selectStmInt, int log);
void check_selectStmString(selectStmString * a_selectStmString, int log);
void check_sensorArea(sensorArea * a_sensorArea, int log);
void check_sensorGeometry(sensorGeometry * a_sensorGeometry, int log);
void check_sensorInfred(sensorInfred * a_sensorInfred, int log);
void check_sensorItem(sensorItem * a_sensorItem, int log);
void check_sensorItem_intVal(sensorItem_intVal * a_sensorItem_intVal, int log);
void check_sensorItem_stringVal(
     sensorItem_stringVal * a_sensorItem_stringVal, int log);
void check_sensorLabel1(sensorLabel1 * a_sensorLabel1, int log);
void check_sensorLabel2(sensorLabel2 * a_sensorLabel2, int log);
void check_sensorLaser(sensorLaser * a_sensorLaser, int log);
void check_sensorLine(sensorLine * a_sensorLine, int log);
void check_sensorMinor(sensorMinor * a_sensorMinor, int log);
void check_sensorMltprb(sensorMltprb * a_sensorMltprb, int log);
void check_sensorMltprbItem(sensorMltprbItem * a_sensorMltprbItem, int log);
void check_sensorMltprbItem_intVal(
     sensorMltprbItem_intVal * a_sensorMltprbItem_intVal, int log);
void check_sensorMltprbItem_stringVal(
     sensorMltprbItem_stringVal * a_sensorMltprbItem_stringVal, int log);
void check_sensorMove(sensorMove * a_sensorMove, int log);
void check_sensorMove_gotoWristList(
     sensorMove_gotoWristList * a_sensorMove_gotoWristList, int log);
void check_sensorMove_probeOrient(
     sensorMove_probeOrient * a_sensorMove_probeOrient, int log);
void check_sensorMove_saLabel(
     sensorMove_saLabel * a_sensorMove_saLabel, int log);
void check_sensorNoncon(sensorNoncon * a_sensorNoncon, int log);
void check_sensorPoint(sensorPoint * a_sensorPoint, int log);
void check_sensorProbe(sensorProbe * a_sensorProbe, int log);
void check_sensorProbeForm(sensorProbeForm * a_sensorProbeForm, int log);
void check_sensorProbeForm_CYLNDR(
     sensorProbeForm_CYLNDR * a_sensorProbeForm_CYLNDR, int log);
void check_sensorProbeForm_DISK(
     sensorProbeForm_DISK * a_sensorProbeForm_DISK, int log);
void check_sensorProbeGeometry(
     sensorProbeGeometry * a_sensorProbeGeometry, int log);
void check_sensorStm(sensorStm * a_sensorStm, int log);
void check_sensorVideo(sensorVideo * a_sensorVideo, int log);
void check_sgLabel(sgLabel * a_sgLabel, int log);
void check_sgageConst(sgageConst * a_sgageConst, int log);
void check_sgsLabel(sgsLabel * a_sgsLabel, int log);
void check_sign(sign * a_sign, int log);
void check_simreqtBlock(simreqtBlock * a_simreqtBlock, int log);
void check_simreqtMinor(simreqtMinor * a_simreqtMinor, int log);
void check_simreqtStm(simreqtStm * a_simreqtStm, int log);
void check_snsdefBuild(snsdefBuild * a_snsdefBuild, int log);
void check_snsdefBuildItem(snsdefBuildItem * a_snsdefBuildItem, int log);
void check_snsdefBuildItem_rmLabel(
     snsdefBuildItem_rmLabel * a_snsdefBuildItem_rmLabel, int log);
void check_snsdefBuildItem_sgLabel(
     snsdefBuildItem_sgLabel * a_snsdefBuildItem_sgLabel, int log);
void check_snsdefBuildItem_swLabel(
     snsdefBuildItem_swLabel * a_snsdefBuildItem_swLabel, int log);
void check_snsdefBuildItem_sxLabel(
     snsdefBuildItem_sxLabel * a_snsdefBuildItem_sxLabel, int log);
void check_snsdefBuildSensor(snsdefBuildSensor * a_snsdefBuildSensor, int log);
void check_snsdefInfred(snsdefInfred * a_snsdefInfred, int log);
void check_snsdefLaser(snsdefLaser * a_snsdefLaser, int log);
void check_snsdefLocation(snsdefLocation * a_snsdefLocation, int log);
void check_snsdefLocation_CART(
     snsdefLocation_CART * a_snsdefLocation_CART, int log);
void check_snsdefLocation_POL(
     snsdefLocation_POL * a_snsdefLocation_POL, int log);
void check_snsdefLocation_VEC(
     snsdefLocation_VEC * a_snsdefLocation_VEC, int log);
void check_snsdefMinor(snsdefMinor * a_snsdefMinor, int log);
void check_snsdefNoncon(snsdefNoncon * a_snsdefNoncon, int log);
void check_snsdefProbe(snsdefProbe * a_snsdefProbe, int log);
void check_snsdefProbeForm(snsdefProbeForm * a_snsdefProbeForm, int log);
void check_snsdefProbeForm_CYLNDR(
     snsdefProbeForm_CYLNDR * a_snsdefProbeForm_CYLNDR, int log);
void check_snsdefProbeForm_DISK(
     snsdefProbeForm_DISK * a_snsdefProbeForm_DISK, int log);
void check_snsdefStm(snsdefStm * a_snsdefStm, int log);
void check_snsdefType(snsdefType * a_snsdefType, int log);
void check_snsdefVideo(snsdefVideo * a_snsdefVideo, int log);
void check_snsdefWristAngleItem(
     snsdefWristAngleItem * a_snsdefWristAngleItem, int log);
void check_snsetFeat(snsetFeat * a_snsetFeat, int log);
void check_snsetItem(snsetItem * a_snsetItem, int log);
void check_snsetItem_CLRSRF(snsetItem_CLRSRF * a_snsetItem_CLRSRF, int log);
void check_snsetItem_DEPTH(snsetItem_DEPTH * a_snsetItem_DEPTH, int log);
void check_snsetItem_snsetLabel(
     snsetItem_snsetLabel * a_snsetItem_snsetLabel, int log);
void check_snsetItem_snsetLabelAndValue(
     snsetItem_snsetLabelAndValue * a_snsetItem_snsetLabelAndValue, int log);
void check_snsetItem_snsetToggle(
     snsetItem_snsetToggle * a_snsetItem_snsetToggle, int log);
void check_snsetItem_snsetType(
     snsetItem_snsetType * a_snsetItem_snsetType, int log);
void check_snsetItem_snsetTypeAndValue(
     snsetItem_snsetTypeAndValue * a_snsetItem_snsetTypeAndValue, int log);
void check_snsetLabel(snsetLabel * a_snsetLabel, int log);
void check_snsetLabelAndValue(
     snsetLabelAndValue * a_snsetLabelAndValue, int log);
void check_snsetStm(snsetStm * a_snsetStm, int log);
void check_snsetToggle(snsetToggle * a_snsetToggle, int log);
void check_snsetType(snsetType * a_snsetType, int log);
void check_snsetTypeAndValue(snsetTypeAndValue * a_snsetTypeAndValue, int log);
void check_snsetTypeAndValue_APPRCH(
     snsetTypeAndValue_APPRCH * a_snsetTypeAndValue_APPRCH, int log);
void check_snsetTypeAndValue_CLRSRF(
     snsetTypeAndValue_CLRSRF * a_snsetTypeAndValue_CLRSRF, int log);
void check_snsetTypeAndValue_DEPTH(
     snsetTypeAndValue_DEPTH * a_snsetTypeAndValue_DEPTH, int log);
void check_snsetTypeAndValue_MINCON(
     snsetTypeAndValue_MINCON * a_snsetTypeAndValue_MINCON, int log);
void check_snsetTypeAndValue_RETRCT(
     snsetTypeAndValue_RETRCT * a_snsetTypeAndValue_RETRCT, int log);
void check_snsetTypeAndValue_SCALEX(
     snsetTypeAndValue_SCALEX * a_snsetTypeAndValue_SCALEX, int log);
void check_snsetTypeAndValue_SCALEY(
     snsetTypeAndValue_SCALEY * a_snsetTypeAndValue_SCALEY, int log);
void check_snsetTypeAndValue_SEARCH(
     snsetTypeAndValue_SEARCH * a_snsetTypeAndValue_SEARCH, int log);
void check_snsgrpItem(snsgrpItem * a_snsgrpItem, int log);
void check_snsgrpMinor(snsgrpMinor * a_snsgrpMinor, int log);
void check_snsgrpMinor_sgsLabel(
     snsgrpMinor_sgsLabel * a_snsgrpMinor_sgsLabel, int log);
void check_snsgrpMinor_ssLabel(
     snsgrpMinor_ssLabel * a_snsgrpMinor_ssLabel, int log);
void check_snsgrpStm(snsgrpStm * a_snsgrpStm, int log);
void check_snslctData(snslctData * a_snslctData, int log);
void check_snslctData_probeOrient(
     snslctData_probeOrient * a_snslctData_probeOrient, int log);
void check_snslctData_snslctWristList(
     snslctData_snslctWristList * a_snslctData_snslctWristList, int log);
void check_snslctGroup(snslctGroup * a_snslctGroup, int log);
void check_snslctGroupFeat(snslctGroupFeat * a_snslctGroupFeat, int log);
void check_snslctGroupVec(snslctGroupVec * a_snslctGroupVec, int log);
void check_snslctSensor(snslctSensor * a_snslctSensor, int log);
void check_snslctSensorList(snslctSensorList * a_snslctSensorList, int log);
void check_snslctSensorTip(snslctSensorTip * a_snslctSensorTip, int log);
void check_snslctStm(snslctStm * a_snslctStm, int log);
void check_snslctStmGroup(snslctStmGroup * a_snslctStmGroup, int log);
void check_snslctStmSensor(snslctStmSensor * a_snslctStmSensor, int log);
void check_snslctTipData(snslctTipData * a_snslctTipData, int log);
void check_snslctWristAngleAngle(
     snslctWristAngleAngle * a_snslctWristAngleAngle, int log);
void check_snslctWristAngleFeat(
     snslctWristAngleFeat * a_snslctWristAngleFeat, int log);
void check_snslctWristAngleItem(
     snslctWristAngleItem * a_snslctWristAngleItem, int log);
void check_snslctWristAngleVec(
     snslctWristAngleVec * a_snslctWristAngleVec, int log);
void check_snslctWristItem(snslctWristItem * a_snslctWristItem, int log);
void check_snsmntMinor(snsmntMinor * a_snsmntMinor, int log);
void check_snsmntStm(snsmntStm * a_snsmntStm, int log);
void check_spartConst(spartConst * a_spartConst, int log);
void check_srLabel(srLabel * a_srLabel, int log);
void check_sraLabel(sraLabel * a_sraLabel, int log);
void check_ssLabel(ssLabel * a_ssLabel, int log);
void check_stLabel(stLabel * a_stLabel, int log);
void check_stackElement(stackElement * a_stackElement, int log);
void check_state(state * a_state, int log);
void check_storageSpec(storageSpec * a_storageSpec, int log);
void check_strVar7(strVar7 * a_strVar7, int log);
void check_stringConst(stringConst * a_stringConst, int log);
void check_stringFunc(stringFunc * a_stringFunc, int log);
void check_stringFuncChr(stringFuncChr * a_stringFuncChr, int log);
void check_stringFuncConcat(stringFuncConcat * a_stringFuncConcat, int log);
void check_stringFuncElemnt(stringFuncElemnt * a_stringFuncElemnt, int log);
void check_stringFuncLwc(stringFuncLwc * a_stringFuncLwc, int log);
void check_stringFuncRpt(stringFuncRpt * a_stringFuncRpt, int log);
void check_stringFuncSelapsetime(
     stringFuncSelapsetime * a_stringFuncSelapsetime, int log);
void check_stringFuncStr(stringFuncStr * a_stringFuncStr, int log);
void check_stringFuncSubstr(stringFuncSubstr * a_stringFuncSubstr, int log);
void check_stringFuncTrim(stringFuncTrim * a_stringFuncTrim, int log);
void check_stringFuncUpc(stringFuncUpc * a_stringFuncUpc, int log);
void check_stringRel(stringRel * a_stringRel, int log);
void check_stringRel_EQ(stringRel_EQ * a_stringRel_EQ, int log);
void check_stringRel_GE(stringRel_GE * a_stringRel_GE, int log);
void check_stringRel_GT(stringRel_GT * a_stringRel_GT, int log);
void check_stringRel_LE(stringRel_LE * a_stringRel_LE, int log);
void check_stringRel_LT(stringRel_LT * a_stringRel_LT, int log);
void check_stringRel_NE(stringRel_NE * a_stringRel_NE, int log);
void check_stringVal(stringVal * a_stringVal, int log);
void check_stringVar(stringVar * a_stringVar, int log);
void check_surfPtdataHeadcsListItem(
     surfPtdataHeadcsListItem * a_surfPtdataHeadcsListItem, int log);
void check_surfPtdataListItem(
     surfPtdataListItem * a_surfPtdataListItem, int log);
void check_surfPtdataPcsListItem(
     surfPtdataPcsListItem * a_surfPtdataPcsListItem, int log);
void check_swLabel(swLabel * a_swLabel, int log);
void check_sxLabel(sxLabel * a_sxLabel, int log);
void check_tLabel(tLabel * a_tLabel, int log);
void check_taLabel(taLabel * a_taLabel, int log);
void check_tantoConst(tantoConst * a_tantoConst, int log);
void check_tantoConstF(tantoConstF * a_tantoConstF, int log);
void check_tantoConstFa(tantoConstFa * a_tantoConstFa, int log);
void check_tantoConstPlane(tantoConstPlane * a_tantoConstPlane, int log);
void check_tantoConstPlaneF(tantoConstPlaneF * a_tantoConstPlaneF, int log);
void check_tantoConstPlaneFa(tantoConstPlaneFa * a_tantoConstPlaneFa, int log);
void check_tecompDatum(tecompDatum * a_tecompDatum, int log);
void check_tecompMinor(tecompMinor * a_tecompMinor, int log);
void check_tecompMinorMach(tecompMinorMach * a_tecompMinorMach, int log);
void check_tecompMinorOnAll(tecompMinorOnAll * a_tecompMinorOnAll, int log);
void check_tecompMinorOnList(tecompMinorOnList * a_tecompMinorOnList, int log);
void check_tecompOffset(tecompOffset * a_tecompOffset, int log);
void check_tecompStm(tecompStm * a_tecompStm, int log);
void check_tecompVar2(tecompVar2 * a_tecompVar2, int log);
void check_tempUnit(tempUnit * a_tempUnit, int log);
void check_textMan(textMan * a_textMan, int log);
void check_textMinor(textMinor * a_textMinor, int log);
void check_textOper(textOper * a_textOper, int log);
void check_textOutfil(textOutfil * a_textOutfil, int log);
void check_textQuery(textQuery * a_textQuery, int log);
void check_textQueryFormat(textQueryFormat * a_textQueryFormat, int log);
void check_textStm(textStm * a_textStm, int log);
void check_textType(textType * a_textType, int log);
void check_thLabel(thLabel * a_thLabel, int log);
void check_thldefPocket(thldefPocket * a_thldefPocket, int log);
void check_thldefPocket_rmLabel(
     thldefPocket_rmLabel * a_thldefPocket_rmLabel, int log);
void check_thldefPocket_sLabel(
     thldefPocket_sLabel * a_thldefPocket_sLabel, int log);
void check_thldefPocket_sgLabel(
     thldefPocket_sgLabel * a_thldefPocket_sgLabel, int log);
void check_thldefPocket_sgsLabel(
     thldefPocket_sgsLabel * a_thldefPocket_sgsLabel, int log);
void check_thldefPocket_ssLabel(
     thldefPocket_ssLabel * a_thldefPocket_ssLabel, int log);
void check_thldefPocket_swLabel(
     thldefPocket_swLabel * a_thldefPocket_swLabel, int log);
void check_thldefPocket_sxLabel(
     thldefPocket_sxLabel * a_thldefPocket_sxLabel, int log);
void check_thldefStm(thldefStm * a_thldefStm, int log);
void check_tier(tier * a_tier, int log);
void check_tlLabel(tlLabel * a_tlLabel, int log);
void check_tolAnglStm(tolAnglStm * a_tolAnglStm, int log);
void check_tolAnglbStm(tolAnglbStm * a_tolAnglbStm, int log);
void check_tolAnglrStm(tolAnglrStm * a_tolAnglrStm, int log);
void check_tolAnglwrtStm(tolAnglwrtStm * a_tolAnglwrtStm, int log);
void check_tolAppData(tolAppData * a_tolAppData, int log);
void check_tolCirltyStm(tolCirltyStm * a_tolCirltyStm, int log);
void check_tolCompos1(tolCompos1 * a_tolCompos1, int log);
void check_tolCompos2(tolCompos2 * a_tolCompos2, int log);
void check_tolComposStm(tolComposStm * a_tolComposStm, int log);
void check_tolConcenStm(tolConcenStm * a_tolConcenStm, int log);
void check_tolCortolAngle(tolCortolAngle * a_tolCortolAngle, int log);
void check_tolCortolAxis(tolCortolAxis * a_tolCortolAxis, int log);
void check_tolCortolMinor(tolCortolMinor * a_tolCortolMinor, int log);
void check_tolCortolRadial(tolCortolRadial * a_tolCortolRadial, int log);
void check_tolCortolStm(tolCortolStm * a_tolCortolStm, int log);
void check_tolCprofSpec(tolCprofSpec * a_tolCprofSpec, int log);
void check_tolCprofSpecC(tolCprofSpecC * a_tolCprofSpecC, int log);
void check_tolCproflStm(tolCproflStm * a_tolCproflStm, int log);
void check_tolCprofsStm(tolCprofsStm * a_tolCprofsStm, int log);
void check_tolCrnoutStm(tolCrnoutStm * a_tolCrnoutStm, int log);
void check_tolCylctyStm(tolCylctyStm * a_tolCylctyStm, int log);
void check_tolDiamAvg(tolDiamAvg * a_tolDiamAvg, int log);
void check_tolDiamMinmax(tolDiamMinmax * a_tolDiamMinmax, int log);
void check_tolDiamMinor(tolDiamMinor * a_tolDiamMinor, int log);
void check_tolDiamPlain(tolDiamPlain * a_tolDiamPlain, int log);
void check_tolDiamStm(tolDiamStm * a_tolDiamStm, int log);
void check_tolDistbDir(tolDistbDir * a_tolDistbDir, int log);
void check_tolDistbLimit(tolDistbLimit * a_tolDistbLimit, int log);
void check_tolDistbNominl(tolDistbNominl * a_tolDistbNominl, int log);
void check_tolDistbStm(tolDistbStm * a_tolDistbStm, int log);
void check_tolDistbTol(tolDistbTol * a_tolDistbTol, int log);
void check_tolDistwrtStm(tolDistwrtStm * a_tolDistwrtStm, int log);
void check_tolFeatMaxMat(tolFeatMaxMat * a_tolFeatMaxMat, int log);
void check_tolFeatMaxMat_datLabel(
     tolFeatMaxMat_datLabel * a_tolFeatMaxMat_datLabel, int log);
void check_tolFeatMaxMat_fLabel(
     tolFeatMaxMat_fLabel * a_tolFeatMaxMat_fLabel, int log);
void check_tolFeatMaxMat_faLabel(
     tolFeatMaxMat_faLabel * a_tolFeatMaxMat_faLabel, int log);
void check_tolFeature(tolFeature * a_tolFeature, int log);
void check_tolFeatureMat(tolFeatureMat * a_tolFeatureMat, int log);
void check_tolFeatureMat_datLabel(
     tolFeatureMat_datLabel * a_tolFeatureMat_datLabel, int log);
void check_tolFeatureMat_fLabel(
     tolFeatureMat_fLabel * a_tolFeatureMat_fLabel, int log);
void check_tolFeatureMat_faLabel(
     tolFeatureMat_faLabel * a_tolFeatureMat_faLabel, int log);
void check_tolFlatMinor(tolFlatMinor * a_tolFlatMinor, int log);
void check_tolFlatPer(tolFlatPer * a_tolFlatPer, int log);
void check_tolFlatStm(tolFlatStm * a_tolFlatStm, int log);
void check_tolFlatZon(tolFlatZon * a_tolFlatZon, int log);
void check_tolFlatZonPer(tolFlatZonPer * a_tolFlatZonPer, int log);
void check_tolGtolRot(tolGtolRot * a_tolGtolRot, int log);
void check_tolGtolSpec(tolGtolSpec * a_tolGtolSpec, int log);
void check_tolGtolStm(tolGtolStm * a_tolGtolStm, int log);
void check_tolGtolTrans(tolGtolTrans * a_tolGtolTrans, int log);
void check_tolMatCond(tolMatCond * a_tolMatCond, int log);
void check_tolMaxMatCond(tolMaxMatCond * a_tolMaxMatCond, int log);
void check_tolMaxMatCond_LMC(tolMaxMatCond_LMC * a_tolMaxMatCond_LMC, int log);
void check_tolMaxMatCond_MMC(tolMaxMatCond_MMC * a_tolMaxMatCond_MMC, int log);
void check_tolParlelStm(tolParlelStm * a_tolParlelStm, int log);
void check_tolPerpStm(tolPerpStm * a_tolPerpStm, int log);
void check_tolPosEnd(tolPosEnd * a_tolPosEnd, int log);
void check_tolPosMethod(tolPosMethod * a_tolPosMethod, int log);
void check_tolPosMethod_VEC(tolPosMethod_VEC * a_tolPosMethod_VEC, int log);
void check_tolPosStart(tolPosStart * a_tolPosStart, int log);
void check_tolPosStart_THREED(
     tolPosStart_THREED * a_tolPosStart_THREED, int log);
void check_tolPosStart_TWOD(tolPosStart_TWOD * a_tolPosStart_TWOD, int log);
void check_tolPosStm(tolPosStm * a_tolPosStm, int log);
void check_tolProflStm(tolProflStm * a_tolProflStm, int log);
void check_tolProfpStm(tolProfpStm * a_tolProfpStm, int log);
void check_tolProfsStm(tolProfsStm * a_tolProfsStm, int log);
void check_tolRadSpec(tolRadSpec * a_tolRadSpec, int log);
void check_tolRadStm(tolRadStm * a_tolRadStm, int log);
void check_tolStrghtMat(tolStrghtMat * a_tolStrghtMat, int log);
void check_tolStrghtMinor(tolStrghtMinor * a_tolStrghtMinor, int log);
void check_tolStrghtPer1(tolStrghtPer1 * a_tolStrghtPer1, int log);
void check_tolStrghtPer2(tolStrghtPer2 * a_tolStrghtPer2, int log);
void check_tolStrghtPlain(tolStrghtPlain * a_tolStrghtPlain, int log);
void check_tolStrghtStm(tolStrghtStm * a_tolStrghtStm, int log);
void check_tolSymStm(tolSymStm * a_tolSymStm, int log);
void check_tolTrnoutStm(tolTrnoutStm * a_tolTrnoutStm, int log);
void check_tolUsetolStm(tolUsetolStm * a_tolUsetolStm, int log);
void check_tolWidthDir(tolWidthDir * a_tolWidthDir, int log);
void check_tolWidthDir_vector(
     tolWidthDir_vector * a_tolWidthDir_vector, int log);
void check_tolWidthStm(tolWidthStm * a_tolWidthStm, int log);
void check_tolZoneDir(tolZoneDir * a_tolZoneDir, int log);
void check_tolZoneDir2(tolZoneDir2 * a_tolZoneDir2, int log);
void check_tolZoneDir2_VEC(tolZoneDir2_VEC * a_tolZoneDir2_VEC, int log);
void check_tolZoneDir3(tolZoneDir3 * a_tolZoneDir3, int log);
void check_tolZoneDir3_VEC(tolZoneDir3_VEC * a_tolZoneDir3_VEC, int log);
void check_tolZoneDir_VEC(tolZoneDir_VEC * a_tolZoneDir_VEC, int log);
void check_tolZoneType(tolZoneType * a_tolZoneType, int log);
void check_toleranceLabel(toleranceLabel * a_toleranceLabel, int log);
void check_tooldfStm(tooldfStm * a_tooldfStm, int log);
void check_touchSpec(touchSpec * a_touchSpec, int log);
void check_trConst(trConst * a_trConst, int log);
void check_transDatum(transDatum * a_transDatum, int log);
void check_transFeature(transFeature * a_transFeature, int log);
void check_transMinor(transMinor * a_transMinor, int log);
void check_transProbe(transProbe * a_transProbe, int log);
void check_transProbe_MINUSPRBRAD(
     transProbe_MINUSPRBRAD * a_transProbe_MINUSPRBRAD, int log);
void check_transProbe_PRBRAD(transProbe_PRBRAD * a_transProbe_PRBRAD, int log);
void check_transStm(transStm * a_transStm, int log);
void check_transValue(transValue * a_transValue, int log);
void check_typePoint(typePoint * a_typePoint, int log);
void check_uLabel(uLabel * a_uLabel, int log);
void check_uncertMinor(uncertMinor * a_uncertMinor, int log);
void check_uncertMinor_ALGOR(uncertMinor_ALGOR * a_uncertMinor_ALGOR, int log);
void check_uncertMinor_stringVal(
     uncertMinor_stringVal * a_uncertMinor_stringVal, int log);
void check_uncertVar3(uncertVar3 * a_uncertVar3, int log);
void check_uncertVar3_DME(uncertVar3_DME * a_uncertVar3_DME, int log);
void check_uncertVar3_SENS(uncertVar3_SENS * a_uncertVar3_SENS, int log);
void check_uncertVar3_paramList(
     uncertVar3_paramList * a_uncertVar3_paramList, int log);
void check_uncertalgStm(uncertalgStm * a_uncertalgStm, int log);
void check_uncertsetMinor(uncertsetMinor * a_uncertsetMinor, int log);
void check_uncertsetMinor_ON(uncertsetMinor_ON * a_uncertsetMinor_ON, int log);
void check_uncertsetStm(uncertsetStm * a_uncertsetStm, int log);
void check_uncertsetVar2(uncertsetVar2 * a_uncertsetVar2, int log);
void check_uncertsetVar2_drLabel(
     uncertsetVar2_drLabel * a_uncertsetVar2_drLabel, int log);
void check_unitsStm(unitsStm * a_unitsStm, int log);
void check_vLabel(vLabel * a_vLabel, int log);
void check_vaLabel(vaLabel * a_vaLabel, int log);
void check_valueAclratReal(valueAclratReal * a_valueAclratReal, int log);
void check_valueAclratString(valueAclratString * a_valueAclratString, int log);
void check_valueBoundInt(valueBoundInt * a_valueBoundInt, int log);
void check_valueBoundInt_featureLabel(
     valueBoundInt_featureLabel * a_valueBoundInt_featureLabel, int log);
void check_valueBoundInt_toleranceLabel(
     valueBoundInt_toleranceLabel * a_valueBoundInt_toleranceLabel, int log);
void check_valueBoundString(valueBoundString * a_valueBoundString, int log);
void check_valueBoundString_featureLabel(
     valueBoundString_featureLabel * a_valueBoundString_featureLabel, int log);
void check_valueBoundString_toleranceLabel(
     valueBoundString_toleranceLabel * a_valueBoundString_toleranceLabel, int log);
void check_valueCzslct(valueCzslct * a_valueCzslct, int log);
void check_valueDmismd(valueDmismd * a_valueDmismd, int log);
void check_valueDmismn(valueDmismn * a_valueDmismn, int log);
void check_valueError(valueError * a_valueError, int log);
void check_valueFaInt(valueFaInt * a_valueFaInt, int log);
void check_valueFaReal(valueFaReal * a_valueFaReal, int log);
void check_valueFedratReal(valueFedratReal * a_valueFedratReal, int log);
void check_valueFedratString(valueFedratString * a_valueFedratString, int log);
void check_valueFilnam(valueFilnam * a_valueFilnam, int log);
void check_valueGeoalg(valueGeoalg * a_valueGeoalg, int log);
void check_valueGotoReal(valueGotoReal * a_valueGotoReal, int log);
void check_valueKeychar(valueKeychar * a_valueKeychar, int log);
void check_valueMinorBool(valueMinorBool * a_valueMinorBool, int log);
void check_valueMinorInt(valueMinorInt * a_valueMinorInt, int log);
void check_valueMinorReal(valueMinorReal * a_valueMinorReal, int log);
void check_valueMinorString(valueMinorString * a_valueMinorString, int log);
void check_valueMinorVector(valueMinorVector * a_valueMinorVector, int log);
void check_valuePtmeasReal(valuePtmeasReal * a_valuePtmeasReal, int log);
void check_valueRt(valueRt * a_valueRt, int log);
void check_valueRt_CCW(valueRt_CCW * a_valueRt_CCW, int log);
void check_valueRt_CW(valueRt_CW * a_valueRt_CW, int log);
void check_valueSa(valueSa * a_valueSa, int log);
void check_valueSaDesc(valueSaDesc * a_valueSaDesc, int log);
void check_valueSaPlain(valueSaPlain * a_valueSaPlain, int log);
void check_valueSaTipnum(valueSaTipnum * a_valueSaTipnum, int log);
void check_valueSnsetReal(valueSnsetReal * a_valueSnsetReal, int log);
void check_valueSnsetString(valueSnsetString * a_valueSnsetString, int log);
void check_valueSnsmnt(valueSnsmnt * a_valueSnsmnt, int log);
void check_valueStm(valueStm * a_valueStm, int log);
void check_valueStm_boolVar(valueStm_boolVar * a_valueStm_boolVar, int log);
void check_valueStm_intVar(valueStm_intVar * a_valueStm_intVar, int log);
void check_valueStm_realVar(valueStm_realVar * a_valueStm_realVar, int log);
void check_valueStm_stringVar(
     valueStm_stringVar * a_valueStm_stringVar, int log);
void check_valueStm_vectorVar(
     valueStm_vectorVar * a_valueStm_vectorVar, int log);
void check_valueSw(valueSw * a_valueSw, int log);
void check_valueTaBool(valueTaBool * a_valueTaBool, int log);
void check_valueTaBoolIntol(valueTaBoolIntol * a_valueTaBoolIntol, int log);
void check_valueTaBoolOutol(valueTaBoolOutol * a_valueTaBoolOutol, int log);
void check_valueTaReal(valueTaReal * a_valueTaReal, int log);
void check_valueTaRealAct(valueTaRealAct * a_valueTaRealAct, int log);
void check_valueTaRealAmt(valueTaRealAmt * a_valueTaRealAmt, int log);
void check_valueTaRealDev(valueTaRealDev * a_valueTaRealDev, int log);
void check_valueUnits(valueUnits * a_valueUnits, int log);
void check_vecExpr_MINUS(vecExpr_MINUS * a_vecExpr_MINUS, int log);
void check_vecExpr_PAREN(vecExpr_PAREN * a_vecExpr_PAREN, int log);
void check_vecExpr_PLUS(vecExpr_PLUS * a_vecExpr_PLUS, int log);
void check_vecIntExpr_DIVID(vecIntExpr_DIVID * a_vecIntExpr_DIVID, int log);
void check_vecIntExpr_TIMES(vecIntExpr_TIMES * a_vecIntExpr_TIMES, int log);
void check_vecRealExpr_DIVID(vecRealExpr_DIVID * a_vecRealExpr_DIVID, int log);
void check_vecRealExpr_TIMES(vecRealExpr_TIMES * a_vecRealExpr_TIMES, int log);
void check_vector(vector * a_vector, int log);
void check_vectorExpr(vectorExpr * a_vectorExpr, int log);
void check_vectorFunc(vectorFunc * a_vectorFunc, int log);
void check_vectorFuncVcart(vectorFuncVcart * a_vectorFuncVcart, int log);
void check_vectorFuncVcross(vectorFuncVcross * a_vectorFuncVcross, int log);
void check_vectorFuncVmcs(vectorFuncVmcs * a_vectorFuncVmcs, int log);
void check_vectorFuncVpcs(vectorFuncVpcs * a_vectorFuncVpcs, int log);
void check_vectorFuncVpol(vectorFuncVpol * a_vectorFuncVpol, int log);
void check_vectorFuncVunit(vectorFuncVunit * a_vectorFuncVunit, int log);
void check_vectorRel(vectorRel * a_vectorRel, int log);
void check_vectorRel_EQ(vectorRel_EQ * a_vectorRel_EQ, int log);
void check_vectorRel_NE(vectorRel_NE * a_vectorRel_NE, int log);
void check_vectorVal(vectorVal * a_vectorVal, int log);
void check_vectorVar(vectorVar * a_vectorVar, int log);
void check_versionTag(versionTag * a_versionTag, int log);
void check_vertexConst(vertexConst * a_vertexConst, int log);
void check_vfLabel(vfLabel * a_vfLabel, int log);
void check_vformItem(vformItem * a_vformItem, int log);
void check_vformItem_ACT(vformItem_ACT * a_vformItem_ACT, int log);
void check_vformItem_AMT(vformItem_AMT * a_vformItem_AMT, int log);
void check_vformItem_DEV(vformItem_DEV * a_vformItem_DEV, int log);
void check_vformItem_DME(vformItem_DME * a_vformItem_DME, int log);
void check_vformItem_HIST(vformItem_HIST * a_vformItem_HIST, int log);
void check_vformItem_NOM(vformItem_NOM * a_vformItem_NOM, int log);
void check_vformItem_PLOT(vformItem_PLOT * a_vformItem_PLOT, int log);
void check_vformItem_STAT(vformItem_STAT * a_vformItem_STAT, int log);
void check_vformStm(vformStm * a_vformStm, int log);
void check_vlLabel(vlLabel * a_vlLabel, int log);
void check_vwLabel(vwLabel * a_vwLabel, int log);
void check_windefBox(windefBox * a_windefBox, int log);
void check_windefEdgeln(windefEdgeln * a_windefEdgeln, int log);
void check_windefMinor(windefMinor * a_windefMinor, int log);
void check_windefStm(windefStm * a_windefStm, int log);
void check_wkplanStm(wkplanStm * a_wkplanStm, int log);
void check_wristDataDesc(wristDataDesc * a_wristDataDesc, int log);
void check_wristDataDesc_intVal(
     wristDataDesc_intVal * a_wristDataDesc_intVal, int log);
void check_wristDataDesc_stringVal(
     wristDataDesc_stringVal * a_wristDataDesc_stringVal, int log);
void check_wristDef(wristDef * a_wristDef, int log);
void check_wristMountDef(wristMountDef * a_wristMountDef, int log);
void check_wristMountOffset(wristMountOffset * a_wristMountOffset, int log);
void check_wristRotDef(wristRotDef * a_wristRotDef, int log);
void check_wristRotLimit(wristRotLimit * a_wristRotLimit, int log);
void check_wristRotLimit_angle(
     wristRotLimit_angle * a_wristRotLimit_angle, int log);
void check_wristRotStep(wristRotStep * a_wristRotStep, int log);
void check_wristRotStep_angle(
     wristRotStep_angle * a_wristRotStep_angle, int log);
void check_wristStm(wristStm * a_wristStm, int log);
void check_writeSpec(writeSpec * a_writeSpec, int log);
void check_writeSpec_rwVar(writeSpec_rwVar * a_writeSpec_rwVar, int log);
void check_writeSpec_stringConst(
     writeSpec_stringConst * a_writeSpec_stringConst, int log);
void check_writeSpec_stringFunc(
     writeSpec_stringFunc * a_writeSpec_stringFunc, int log);
void check_writeStm(writeStm * a_writeStm, int log);
void check_xternBlock(xternBlock * a_xternBlock, int log);
void check_xtractStm(xtractStm * a_xtractStm, int log);

/********************************************************************/

const char * aboveBelowSubs[4] = {"aboveBelowSubs", 0};
const char * aclratAngSpecSubs[4] = {"aclratAngSpecSubs", 0};
const char * aclratAngularAtts[3] = {"aclratAngularAtts", 0};
const char * aclratDefSubs[6] = {"aclratDefSubs", 0};
const char * aclratDef_PCENTAtts[3] = {"aclratDef_PCENTAtts", 0};
const char * aclratHedMeasAtts[3] = {"aclratHedMeasAtts", 0};
const char * aclratHedRotAtts[3] = {"aclratHedRotAtts", 0};
const char * aclratHedScanAtts[3] = {"aclratHedScanAtts", 0};
const char * aclratLinSpecSubs[4] = {"aclratLinSpecSubs", 0};
const char * aclratLinearSubs[6] = {"aclratLinearSubs", 0};
const char * aclratLinear_IPMMAtts[3] = {"aclratLinear_IPMMAtts", 0};
const char * aclratLinear_IPSSAtts[3] = {"aclratLinear_IPSSAtts", 0};
const char * aclratLinear_MMPSSAtts[3] = {"aclratLinear_MMPSSAtts", 0};
const char * aclratLinear_MPMMAtts[3] = {"aclratLinear_MPMMAtts", 0};
const char * aclratMeasAtts[3] = {"aclratMeasAtts", 0};
const char * aclratMinorSubs[9] = {"aclratMinorSubs", 0};
const char * aclratPosAtts[3] = {"aclratPosAtts", 0};
const char * aclratRotAtts[3] = {"aclratRotAtts", 0};
const char * aclratScanAtts[3] = {"aclratScanAtts", 0};
const char * aclratStmAtts[3] = {"aclratStmAtts", 0};
const char * algdefMinorSubs[4] = {"algdefMinorSubs", 0};
const char * algdefMinor_CODEAtts[3] = {"algdefMinor_CODEAtts", 0};
const char * algdefMinor_stringValAtts[4] = {"algdefMinor_stringValAtts", 0};
const char * algdefStmAtts[4] = {"algdefStmAtts", 0};
const char * angleSubs[4] = {"angleSubs", 0};
const char * angleDmsAtts[5] = {"angleDmsAtts", 0};
const char * angleUnitSubs[5] = {"angleUnitSubs", 0};
const char * anyValSubs[6] = {"anyValSubs", 0};
const char * arrayIndexAtts[3] = {"arrayIndexAtts", 0};
const char * assignBoolAtts[4] = {"assignBoolAtts", 0};
const char * assignIntAtts[4] = {"assignIntAtts", 0};
const char * assignRealAtts[4] = {"assignRealAtts", 0};
const char * assignStmSubs[7] = {"assignStmSubs", 0};
const char * assignStm_assignBoolAtts[3] = {"assignStm_assignBoolAtts", 0};
const char * assignStm_assignIntAtts[3] = {"assignStm_assignIntAtts", 0};
const char * assignStm_assignRealAtts[3] = {"assignStm_assignRealAtts", 0};
const char * assignStm_assignStringAtts[3] = {"assignStm_assignStringAtts", 0};
const char * assignStm_assignVectorAtts[3] = {"assignStm_assignVectorAtts", 0};
const char * assignStringAtts[4] = {"assignStringAtts", 0};
const char * assignVectorAtts[4] = {"assignVectorAtts", 0};
const char * avgMaxMinSubs[5] = {"avgMaxMinSubs", 0};
const char * axialAtts[4] = {"axialAtts", 0};
const char * axisSubs[5] = {"axisSubs", 0};
const char * badtstStmAtts[3] = {"badtstStmAtts", 0};
const char * bfConstSubs[4] = {"bfConstSubs", 0};
const char * bfConst_featureListAtts[3] = {"bfConst_featureListAtts", 0};
const char * bfConst_indexedFeatureListAtts[3] = {"bfConst_indexedFeatureListAtts", 0};
const char * boolConstSubs[4] = {"boolConstSubs", 0};
const char * boolExprSubs[8] = {"boolExprSubs", 0};
const char * boolExpr_PARENAtts[3] = {"boolExpr_PARENAtts", 0};
const char * boolExpr_boolRelAtts[3] = {"boolExpr_boolRelAtts", 0};
const char * boolExpr_intRelAtts[3] = {"boolExpr_intRelAtts", 0};
const char * boolExpr_realRelAtts[3] = {"boolExpr_realRelAtts", 0};
const char * boolExpr_stringRelAtts[3] = {"boolExpr_stringRelAtts", 0};
const char * boolExpr_vectorRelAtts[3] = {"boolExpr_vectorRelAtts", 0};
const char * boolFuncSubs[7] = {"boolFuncSubs", 0};
const char * boolFuncEofAtts[3] = {"boolFuncEofAtts", 0};
const char * boolFuncEolnAtts[3] = {"boolFuncEolnAtts", 0};
const char * boolFuncExistSubs[9] = {"boolFuncExistSubs", 0};
const char * boolFuncExist_dLabelAtts[3] = {"boolFuncExist_dLabelAtts", 0};
const char * boolFuncExist_daLabelAtts[3] = {"boolFuncExist_daLabelAtts", 0};
const char * boolFuncExist_didLabelAtts[3] = {"boolFuncExist_didLabelAtts", 0};
const char * boolFuncExist_fLabelAtts[3] = {"boolFuncExist_fLabelAtts", 0};
const char * boolFuncExist_faLabelAtts[3] = {"boolFuncExist_faLabelAtts", 0};
const char * boolFuncExist_sLabelAtts[3] = {"boolFuncExist_sLabelAtts", 0};
const char * boolFuncExist_saLabelAtts[3] = {"boolFuncExist_saLabelAtts", 0};
const char * boolRelSubs[7] = {"boolRelSubs", 0};
const char * boolRel_ANDAtts[4] = {"boolRel_ANDAtts", 0};
const char * boolRel_EQAtts[4] = {"boolRel_EQAtts", 0};
const char * boolRel_NEAtts[4] = {"boolRel_NEAtts", 0};
const char * boolRel_NOTAtts[3] = {"boolRel_NOTAtts", 0};
const char * boolRel_ORAtts[4] = {"boolRel_ORAtts", 0};
const char * boolValSubs[6] = {"boolValSubs", 0};
const char * boolVarAtts[4] = {"boolVarAtts", 0};
const char * boundFeatAtts[4] = {"boundFeatAtts", 0};
const char * boundMinorSubs[4] = {"boundMinorSubs", 0};
const char * boundStmAtts[3] = {"boundStmAtts", 0};
const char * boundTolAtts[4] = {"boundTolAtts", 0};
const char * cadfileTypeSubs[5] = {"cadfileTypeSubs", 0};
const char * cadfileType_VENDORAtts[3] = {"cadfileType_VENDORAtts", 0};
const char * calibMasterBlockAtts[5] = {"calibMasterBlockAtts", 0};
const char * calibMasterMinorAtts[3] = {"calibMasterMinorAtts", 0};
const char * calibMasterStmAtts[3] = {"calibMasterStmAtts", 0};
const char * calibRtabBlockAtts[5] = {"calibRtabBlockAtts", 0};
const char * calibRtabMinorSubs[4] = {"calibRtabMinorSubs", 0};
const char * calibRtabMinorSpecAtts[4] = {"calibRtabMinorSpecAtts", 0};
const char * calibRtabSpecSubs[4] = {"calibRtabSpecSubs", 0};
const char * calibRtabSpec_fLabelAtts[4] = {"calibRtabSpec_fLabelAtts", 0};
const char * calibRtabSpec_faLabelAtts[4] = {"calibRtabSpec_faLabelAtts", 0};
const char * calibRtabStmAtts[3] = {"calibRtabStmAtts", 0};
const char * calibSensBlockAtts[5] = {"calibSensBlockAtts", 0};
const char * calibSensBlockItemSubs[7] = {"calibSensBlockItemSubs", 0};
const char * calibSensBlockStatementSubs[27] = {"calibSensBlockStatementSubs", 0};
const char * calibSensCaseBlockAtts[5] = {"calibSensCaseBlockAtts", 0};
const char * calibSensDefaultCaseBlockAtts[5] = {"calibSensDefaultCaseBlockAtts", 0};
const char * calibSensDoBlockAtts[5] = {"calibSensDoBlockAtts", 0};
const char * calibSensIfBlockAtts[7] = {"calibSensIfBlockAtts", 0};
const char * calibSensMinorSubs[4] = {"calibSensMinorSubs", 0};
const char * calibSensMinorSpecAtts[4] = {"calibSensMinorSpecAtts", 0};
const char * calibSensSelectBlockAtts[6] = {"calibSensSelectBlockAtts", 0};
const char * calibSensSpecSubs[4] = {"calibSensSpecSubs", 0};
const char * calibSensSpecIntAtts[4] = {"calibSensSpecIntAtts", 0};
const char * calibSensSpecStringAtts[5] = {"calibSensSpecStringAtts", 0};
const char * calibSensStmAtts[3] = {"calibSensStmAtts", 0};
const char * callBlockAtts[5] = {"callBlockAtts", 0};
const char * callMacroAtts[5] = {"callMacroAtts", 0};
const char * callMinorSubs[6] = {"callMinorSubs", 0};
const char * callModuleAtts[3] = {"callModuleAtts", 0};
const char * callProgramAtts[5] = {"callProgramAtts", 0};
const char * callRoutineAtts[5] = {"callRoutineAtts", 0};
const char * callStmAtts[3] = {"callStmAtts", 0};
const char * callTypeSubs[5] = {"callTypeSubs", 0};
const char * cartPointAtts[5] = {"cartPointAtts", 0};
const char * caseBlockAtts[5] = {"caseBlockAtts", 0};
const char * caseStmSubs[4] = {"caseStmSubs", 0};
const char * caseStmIntAtts[4] = {"caseStmIntAtts", 0};
const char * caseStmStringAtts[3] = {"caseStmStringAtts", 0};
const char * ccLabelAtts[3] = {"ccLabelAtts", 0};
const char * ciLabelAtts[3] = {"ciLabelAtts", 0};
const char * clmpidStmAtts[4] = {"clmpidStmAtts", 0};
const char * clmpsnStmAtts[4] = {"clmpsnStmAtts", 0};
const char * closeDeleteAtts[3] = {"closeDeleteAtts", 0};
const char * closeEndAtts[3] = {"closeEndAtts", 0};
const char * closeKeepAtts[3] = {"closeKeepAtts", 0};
const char * closeMinorSubs[6] = {"closeMinorSubs", 0};
const char * closePlainAtts[3] = {"closePlainAtts", 0};
const char * closeStmAtts[3] = {"closeStmAtts", 0};
const char * cmpntgrpSpecSubs[6] = {"cmpntgrpSpecSubs", 0};
const char * cmpntgrpStmAtts[4] = {"cmpntgrpStmAtts", 0};
const char * cnfrmrulCodeAtts[3] = {"cnfrmrulCodeAtts", 0};
const char * cnfrmrulMinorSubs[4] = {"cnfrmrulMinorSubs", 0};
const char * cnfrmrulNameAtts[4] = {"cnfrmrulNameAtts", 0};
const char * cnfrmrulStmAtts[4] = {"cnfrmrulStmAtts", 0};
const char * cogConstAtts[3] = {"cogConstAtts", 0};
const char * coneConstSubs[4] = {"coneConstSubs", 0};
const char * coneConst_DIAMAtts[4] = {"coneConst_DIAMAtts", 0};
const char * coneConst_DISTAtts[4] = {"coneConst_DISTAtts", 0};
const char * conformItemAtts[4] = {"conformItemAtts", 0};
const char * conformTypeSubs[12] = {"conformTypeSubs", 0};
const char * constArcSubs[5] = {"constArcSubs", 0};
const char * constArc_bfConstAtts[4] = {"constArc_bfConstAtts", 0};
const char * constArc_projctConstAtts[4] = {"constArc_projctConstAtts", 0};
const char * constArc_trConstAtts[4] = {"constArc_trConstAtts", 0};
const char * constCircleSubs[9] = {"constCircleSubs", 0};
const char * constCircle_bfConstAtts[4] = {"constCircle_bfConstAtts", 0};
const char * constCircle_coneConstAtts[4] = {"constCircle_coneConstAtts", 0};
const char * constCircle_intofConstAtts[4] = {"constCircle_intofConstAtts", 0};
const char * constCircle_projctConstAtts[4] = {"constCircle_projctConstAtts", 0};
const char * constCircle_retrieve2Atts[4] = {"constCircle_retrieve2Atts", 0};
const char * constCircle_tantoConstAtts[4] = {"constCircle_tantoConstAtts", 0};
const char * constCircle_trConstAtts[4] = {"constCircle_trConstAtts", 0};
const char * constCompoundAtts[3] = {"constCompoundAtts", 0};
const char * constConeSubs[4] = {"constConeSubs", 0};
const char * constCone_bfConstAtts[4] = {"constCone_bfConstAtts", 0};
const char * constCone_trConstAtts[4] = {"constCone_trConstAtts", 0};
const char * constCparlnSubs[6] = {"constCparlnSubs", 0};
const char * constCparln_bfConstAtts[4] = {"constCparln_bfConstAtts", 0};
const char * constCparln_projctConstAtts[4] = {"constCparln_projctConstAtts", 0};
const char * constCparln_retrieve2Atts[4] = {"constCparln_retrieve2Atts", 0};
const char * constCparln_trConstAtts[4] = {"constCparln_trConstAtts", 0};
const char * constCylndrSubs[5] = {"constCylndrSubs", 0};
const char * constCylndr_bfConstAtts[4] = {"constCylndr_bfConstAtts", 0};
const char * constCylndr_retrieve1Atts[4] = {"constCylndr_retrieve1Atts", 0};
const char * constCylndr_trConstAtts[4] = {"constCylndr_trConstAtts", 0};
const char * constEdgeptAtts[4] = {"constEdgeptAtts", 0};
const char * constEllipsSubs[6] = {"constEllipsSubs", 0};
const char * constEllips_bfConstAtts[4] = {"constEllips_bfConstAtts", 0};
const char * constEllips_intofConstAtts[4] = {"constEllips_intofConstAtts", 0};
const char * constEllips_projctConstAtts[4] = {"constEllips_projctConstAtts", 0};
const char * constEllips_trConstAtts[4] = {"constEllips_trConstAtts", 0};
const char * constGcurveSubs[5] = {"constGcurveSubs", 0};
const char * constGcurve_bfConstAtts[4] = {"constGcurve_bfConstAtts", 0};
const char * constGcurve_projctConstAtts[4] = {"constGcurve_projctConstAtts", 0};
const char * constGcurve_trConstAtts[4] = {"constGcurve_trConstAtts", 0};
const char * constGeomAtts[4] = {"constGeomAtts", 0};
const char * constGsurfSubs[4] = {"constGsurfSubs", 0};
const char * constGsurf_bfConstAtts[4] = {"constGsurf_bfConstAtts", 0};
const char * constGsurf_trConstAtts[4] = {"constGsurf_trConstAtts", 0};
const char * constLineSubs[11] = {"constLineSubs", 0};
const char * constLine_bfConstAtts[4] = {"constLine_bfConstAtts", 0};
const char * constLine_intofConstAtts[4] = {"constLine_intofConstAtts", 0};
const char * constLine_midliConstAtts[4] = {"constLine_midliConstAtts", 0};
const char * constLine_offsetConstAtts[4] = {"constLine_offsetConstAtts", 0};
const char * constLine_partoConstAtts[4] = {"constLine_partoConstAtts", 0};
const char * constLine_perptoConstAtts[4] = {"constLine_perptoConstAtts", 0};
const char * constLine_projliConstAtts[4] = {"constLine_projliConstAtts", 0};
const char * constLine_tantoConstAtts[4] = {"constLine_tantoConstAtts", 0};
const char * constLine_trConstAtts[4] = {"constLine_trConstAtts", 0};
const char * constMinorSubs[24] = {"constMinorSubs", 0};
const char * constParplnAtts[4] = {"constParplnAtts", 0};
const char * constPaternSubs[4] = {"constPaternSubs", 0};
const char * constPatern_BUILDAtts[3] = {"constPatern_BUILDAtts", 0};
const char * constPatern_trConstAtts[4] = {"constPatern_trConstAtts", 0};
const char * constPlaneSubs[9] = {"constPlaneSubs", 0};
const char * constPlane_bfConstAtts[4] = {"constPlane_bfConstAtts", 0};
const char * constPlane_midplConstAtts[4] = {"constPlane_midplConstAtts", 0};
const char * constPlane_offsetConstAtts[4] = {"constPlane_offsetConstAtts", 0};
const char * constPlane_partoConstAtts[4] = {"constPlane_partoConstAtts", 0};
const char * constPlane_perptoConstAtts[4] = {"constPlane_perptoConstAtts", 0};
const char * constPlane_tantoConstPlaneAtts[4] = {"constPlane_tantoConstPlaneAtts", 0};
const char * constPlane_trConstAtts[4] = {"constPlane_trConstAtts", 0};
const char * constPointSubs[13] = {"constPointSubs", 0};
const char * constPoint_cogConstAtts[4] = {"constPoint_cogConstAtts", 0};
const char * constPoint_curveConstAtts[4] = {"constPoint_curveConstAtts", 0};
const char * constPoint_extremConstAtts[4] = {"constPoint_extremConstAtts", 0};
const char * constPoint_intofConstAtts[4] = {"constPoint_intofConstAtts", 0};
const char * constPoint_midptConstAtts[4] = {"constPoint_midptConstAtts", 0};
const char * constPoint_moveptConstAtts[4] = {"constPoint_moveptConstAtts", 0};
const char * constPoint_pierceConstAtts[4] = {"constPoint_pierceConstAtts", 0};
const char * constPoint_projptConstAtts[4] = {"constPoint_projptConstAtts", 0};
const char * constPoint_retrieve1Atts[4] = {"constPoint_retrieve1Atts", 0};
const char * constPoint_trConstAtts[4] = {"constPoint_trConstAtts", 0};
const char * constPoint_vertexConstAtts[4] = {"constPoint_vertexConstAtts", 0};
const char * constRctnglSubs[4] = {"constRctnglSubs", 0};
const char * constRctngl_bfConstAtts[4] = {"constRctngl_bfConstAtts", 0};
const char * constRctngl_trConstAtts[4] = {"constRctngl_trConstAtts", 0};
const char * constSgageAtts[4] = {"constSgageAtts", 0};
const char * constSpartAtts[4] = {"constSpartAtts", 0};
const char * constSphereSubs[5] = {"constSphereSubs", 0};
const char * constSphere_bfConstAtts[4] = {"constSphere_bfConstAtts", 0};
const char * constSphere_retrieve2bAtts[4] = {"constSphere_retrieve2bAtts", 0};
const char * constSphere_trConstAtts[4] = {"constSphere_trConstAtts", 0};
const char * constStmAtts[3] = {"constStmAtts", 0};
const char * constSymplnAtts[4] = {"constSymplnAtts", 0};
const char * constTorusSubs[4] = {"constTorusSubs", 0};
const char * constTorus_bfConstAtts[4] = {"constTorus_bfConstAtts", 0};
const char * constTorus_trConstAtts[4] = {"constTorus_trConstAtts", 0};
const char * coordTypeSubs[4] = {"coordTypeSubs", 0};
const char * crLabelAtts[3] = {"crLabelAtts", 0};
const char * crLabelConstAtts[3] = {"crLabelConstAtts", 0};
const char * crgdefDataAtts[8] = {"crgdefDataAtts", 0};
const char * crgdefMinorSubs[4] = {"crgdefMinorSubs", 0};
const char * crgdefStmAtts[4] = {"crgdefStmAtts", 0};
const char * criticalitySubs[5] = {"criticalitySubs", 0};
const char * crmodeMinorSubs[5] = {"crmodeMinorSubs", 0};
const char * crmodeStmAtts[3] = {"crmodeStmAtts", 0};
const char * crosclStmAtts[3] = {"crosclStmAtts", 0};
const char * crslctMinorSubs[4] = {"crslctMinorSubs", 0};
const char * crslctMinor_crLabelConstAtts[3] = {"crslctMinor_crLabelConstAtts", 0};
const char * crslctStmAtts[3] = {"crslctStmAtts", 0};
const char * csLabelAtts[3] = {"csLabelAtts", 0};
const char * csSpecSubs[4] = {"csSpecSubs", 0};
const char * csSpec_HEADCSAtts[5] = {"csSpec_HEADCSAtts", 0};
const char * csSpec_PCSAtts[3] = {"csSpec_PCSAtts", 0};
const char * curveConstAtts[4] = {"curveConstAtts", 0};
const char * curvePtdataHeadcsAtts[7] = {"curvePtdataHeadcsAtts", 0};
const char * curvePtdataHeadcsListItemAtts[6] = {"curvePtdataHeadcsListItemAtts", 0};
const char * curvePtdataPcsAtts[5] = {"curvePtdataPcsAtts", 0};
const char * curvePtdataPcsListItemAtts[4] = {"curvePtdataPcsListItemAtts", 0};
const char * cutcomAdjustAtts[7] = {"cutcomAdjustAtts", 0};
const char * cutcomMatrixAtts[4] = {"cutcomMatrixAtts", 0};
const char * cutcomMatxAtts[14] = {"cutcomMatxAtts", 0};
const char * cutcomMinorSubs[6] = {"cutcomMinorSubs", 0};
const char * cutcomParamAtts[4] = {"cutcomParamAtts", 0};
const char * cutcomStmAtts[4] = {"cutcomStmAtts", 0};
const char * cutcomUserdfAtts[4] = {"cutcomUserdfAtts", 0};
const char * czLabelAtts[3] = {"czLabelAtts", 0};
const char * czoneStmAtts[3] = {"czoneStmAtts", 0};
const char * czslctStmAtts[4] = {"czslctStmAtts", 0};
const char * dLabelAtts[3] = {"dLabelAtts", 0};
const char * daLabelAtts[3] = {"daLabelAtts", 0};
const char * datLabelAtts[3] = {"datLabelAtts", 0};
const char * datdefMinorSubs[4] = {"datdefMinorSubs", 0};
const char * datdefMinor_dattrgListAtts[5] = {"datdefMinor_dattrgListAtts", 0};
const char * datdefMinor_featureLabel1Atts[4] = {"datdefMinor_featureLabel1Atts", 0};
const char * datdefStmAtts[3] = {"datdefStmAtts", 0};
const char * datsetDatsAtts[5] = {"datsetDatsAtts", 0};
const char * datsetDrfAtts[6] = {"datsetDrfAtts", 0};
const char * datsetMatrixAtts[3] = {"datsetMatrixAtts", 0};
const char * datsetMinorSubs[6] = {"datsetMinorSubs", 0};
const char * datsetSpecSubs[4] = {"datsetSpecSubs", 0};
const char * datsetSpecDirAtts[7] = {"datsetSpecDirAtts", 0};
const char * datsetSpecNoDirAtts[6] = {"datsetSpecNoDirAtts", 0};
const char * datsetStmAtts[4] = {"datsetStmAtts", 0};
const char * dattrgLabelAtts[3] = {"dattrgLabelAtts", 0};
const char * dattrgMinorAtts[4] = {"dattrgMinorAtts", 0};
const char * dattrgdefStmAtts[3] = {"dattrgdefStmAtts", 0};
const char * datumLabelSubs[4] = {"datumLabelSubs", 0};
const char * datumLabel1Subs[4] = {"datumLabel1Subs", 0};
const char * datumLabel2Subs[4] = {"datumLabel2Subs", 0};
const char * declMinorAtts[5] = {"declMinorAtts", 0};
const char * declScopeSubs[5] = {"declScopeSubs", 0};
const char * declStmAtts[3] = {"declStmAtts", 0};
const char * declTypeSubs[9] = {"declTypeSubs", 0};
const char * declType_CHARAtts[3] = {"declType_CHARAtts", 0};
const char * declVarAtts[4] = {"declVarAtts", 0};
const char * decplAllAtts[3] = {"decplAllAtts", 0};
const char * decplMinorSubs[4] = {"decplMinorSubs", 0};
const char * decplMinor_decplAllAtts[3] = {"decplMinor_decplAllAtts", 0};
const char * decplMinor_decplListAtts[3] = {"decplMinor_decplListAtts", 0};
const char * decplNdigitsSubs[4] = {"decplNdigitsSubs", 0};
const char * decplNdigits_intValAtts[3] = {"decplNdigits_intValAtts", 0};
const char * decplSelectionSubs[8] = {"decplSelectionSubs", 0};
const char * decplSelection_ANGLEAtts[3] = {"decplSelection_ANGLEAtts", 0};
const char * decplSelection_DEVAtts[3] = {"decplSelection_DEVAtts", 0};
const char * decplSelection_DISTAtts[3] = {"decplSelection_DISTAtts", 0};
const char * decplSelection_HUMIDAtts[3] = {"decplSelection_HUMIDAtts", 0};
const char * decplSelection_TEMPAtts[3] = {"decplSelection_TEMPAtts", 0};
const char * decplSelection_VECAtts[3] = {"decplSelection_VECAtts", 0};
const char * decplStmAtts[3] = {"decplStmAtts", 0};
const char * defaultCaseBlockAtts[5] = {"defaultCaseBlockAtts", 0};
const char * deleteAllSensorsAtts[4] = {"deleteAllSensorsAtts", 0};
const char * deleteDatumAtts[4] = {"deleteDatumAtts", 0};
const char * deleteFeatureAtts[4] = {"deleteFeatureAtts", 0};
const char * deleteMinorSubs[7] = {"deleteMinorSubs", 0};
const char * deleteRotaryTableAtts[4] = {"deleteRotaryTableAtts", 0};
const char * deleteSensorAtts[4] = {"deleteSensorAtts", 0};
const char * deleteStmAtts[3] = {"deleteStmAtts", 0};
const char * deviceSubs[6] = {"deviceSubs", 0};
const char * deviceMinorSubs[4] = {"deviceMinorSubs", 0};
const char * deviceMinor_INCRAtts[3] = {"deviceMinor_INCRAtts", 0};
const char * deviceMinor_deviceAtts[4] = {"deviceMinor_deviceAtts", 0};
const char * deviceStmAtts[4] = {"deviceStmAtts", 0};
const char * diLabelAtts[3] = {"diLabelAtts", 0};
const char * didLabelAtts[3] = {"didLabelAtts", 0};
const char * dirSubs[4] = {"dirSubs", 0};
const char * displyItemDMISAtts[4] = {"displyItemDMISAtts", 0};
const char * displyItemNoDMISAtts[4] = {"displyItemNoDMISAtts", 0};
const char * displySpecItemSubs[4] = {"displySpecItemSubs", 0};
const char * displyStmSubs[4] = {"displyStmSubs", 0};
const char * displyStmOffAtts[3] = {"displyStmOffAtts", 0};
const char * displyStmSpecAtts[3] = {"displyStmSpecAtts", 0};
const char * dmehwMinorSubs[7] = {"dmehwMinorSubs", 0};
const char * dmehwMinor_jointConfAtts[3] = {"dmehwMinor_jointConfAtts", 0};
const char * dmehwStmAtts[3] = {"dmehwStmAtts", 0};
const char * dmeidStmAtts[4] = {"dmeidStmAtts", 0};
const char * dmeswComandAtts[3] = {"dmeswComandAtts", 0};
const char * dmeswDelayAtts[3] = {"dmeswDelayAtts", 0};
const char * dmeswMinorSubs[5] = {"dmeswMinorSubs", 0};
const char * dmeswStmAtts[3] = {"dmeswStmAtts", 0};
const char * dmeswSwitchSubs[4] = {"dmeswSwitchSubs", 0};
const char * dmeswiStmAtts[4] = {"dmeswiStmAtts", 0};
const char * dmeswvStmAtts[4] = {"dmeswvStmAtts", 0};
const char * dmisBlockSubs[15] = {"dmisBlockSubs", 0};
const char * dmisFirstStatementSubs[4] = {"dmisFirstStatementSubs", 0};
const char * dmisFreeStatementSubs[181] = {"dmisFreeStatementSubs", 0};
const char * dmisItemSubs[4] = {"dmisItemSubs", 0};
const char * dmisOffBlockAtts[5] = {"dmisOffBlockAtts", 0};
const char * dmismdStmAtts[5] = {"dmismdStmAtts", 0};
const char * dmismnStmAtts[5] = {"dmismnStmAtts", 0};
const char * doBlockAtts[5] = {"doBlockAtts", 0};
const char * doStmAtts[6] = {"doStmAtts", 0};
const char * drLabelAtts[3] = {"drLabelAtts", 0};
const char * dsLabelAtts[3] = {"dsLabelAtts", 0};
const char * dvLabelAtts[3] = {"dvLabelAtts", 0};
const char * equateCadAtts[4] = {"equateCadAtts", 0};
const char * equateCadcsSubs[4] = {"equateCadcsSubs", 0};
const char * equateCadcs_matrixAtts[4] = {"equateCadcs_matrixAtts", 0};
const char * equateCadcs_stringValAtts[4] = {"equateCadcs_stringValAtts", 0};
const char * equateDatumAtts[4] = {"equateDatumAtts", 0};
const char * equateMinorSubs[4] = {"equateMinorSubs", 0};
const char * equateStmAtts[3] = {"equateStmAtts", 0};
const char * errorConditionSubs[6] = {"errorConditionSubs", 0};
const char * errorCondition_intValAtts[3] = {"errorCondition_intValAtts", 0};
const char * errorMinorSubs[5] = {"errorMinorSubs", 0};
const char * errorMinor_AUTOAtts[3] = {"errorMinor_AUTOAtts", 0};
const char * errorMinor_jumpLabelAtts[4] = {"errorMinor_jumpLabelAtts", 0};
const char * errorStmAtts[3] = {"errorStmAtts", 0};
const char * eulerAtts[5] = {"eulerAtts", 0};
const char * evalDatSubs[4] = {"evalDatSubs", 0};
const char * evalDatDatFaAtts[5] = {"evalDatDatFaAtts", 0};
const char * evalDatFaDatAtts[5] = {"evalDatFaDatAtts", 0};
const char * evalFeatSubs[6] = {"evalFeatSubs", 0};
const char * evalFeatFFaTAtts[5] = {"evalFeatFFaTAtts", 0};
const char * evalFeatFaFTAtts[5] = {"evalFeatFaFTAtts", 0};
const char * evalFeatFaFaTAtts[5] = {"evalFeatFaFaTAtts", 0};
const char * evalFeatFaTAtts[4] = {"evalFeatFaTAtts", 0};
const char * evalKeycharSubs[3] = {"evalKeycharSubs", 0};
const char * evalMinorSubs[5] = {"evalMinorSubs", 0};
const char * evalOrOutputSubs[4] = {"evalOrOutputSubs", 0};
const char * evalStmAtts[3] = {"evalStmAtts", 0};
const char * extensMinorSubs[4] = {"extensMinorSubs", 0};
const char * extensMinor_VECAtts[4] = {"extensMinor_VECAtts", 0};
const char * extensMinor_vectorAtts[3] = {"extensMinor_vectorAtts", 0};
const char * extensStmAtts[4] = {"extensStmAtts", 0};
const char * extfilDmeAtts[3] = {"extfilDmeAtts", 0};
const char * extfilDmisAtts[3] = {"extfilDmisAtts", 0};
const char * extfilMinorSubs[4] = {"extfilMinorSubs", 0};
const char * extfilStmAtts[3] = {"extfilStmAtts", 0};
const char * extremConstSubs[4] = {"extremConstSubs", 0};
const char * extremConstAxialSubs[3] = {"extremConstAxialSubs", 0};
const char * extremConstDirSubs[6] = {"extremConstDirSubs", 0};
const char * extremConstFeatureSubs[3] = {"extremConstFeatureSubs", 0};
const char * extremConstVectorialAtts[3] = {"extremConstVectorialAtts", 0};
const char * extremConst_MAXAtts[4] = {"extremConst_MAXAtts", 0};
const char * extremConst_MINAtts[4] = {"extremConst_MINAtts", 0};
const char * fLabelAtts[3] = {"fLabelAtts", 0};
const char * faLabelAtts[3] = {"faLabelAtts", 0};
const char * featArc1ActAtts[4] = {"featArc1ActAtts", 0};
const char * featArc1NomAtts[4] = {"featArc1NomAtts", 0};
const char * featArc1StmSubs[4] = {"featArc1StmSubs", 0};
const char * featArc2ActAtts[4] = {"featArc2ActAtts", 0};
const char * featArc2NomAtts[4] = {"featArc2NomAtts", 0};
const char * featArc2StmSubs[4] = {"featArc2StmSubs", 0};
const char * featCircleActAtts[4] = {"featCircleActAtts", 0};
const char * featCircleNomAtts[4] = {"featCircleNomAtts", 0};
const char * featCircleStmSubs[4] = {"featCircleStmSubs", 0};
const char * featCompoundAxialAtts[6] = {"featCompoundAxialAtts", 0};
const char * featCompoundPlaneAtts[6] = {"featCompoundPlaneAtts", 0};
const char * featCompoundSphereAtts[5] = {"featCompoundSphereAtts", 0};
const char * featCompoundStmAtts[4] = {"featCompoundStmAtts", 0};
const char * featConeActAtts[4] = {"featConeActAtts", 0};
const char * featConeNomAtts[4] = {"featConeNomAtts", 0};
const char * featConeStmSubs[4] = {"featConeStmSubs", 0};
const char * featConradsegActAtts[4] = {"featConradsegActAtts", 0};
const char * featConradsegCartAtts[9] = {"featConradsegCartAtts", 0};
const char * featConradsegNomAtts[4] = {"featConradsegNomAtts", 0};
const char * featConradsegPolAtts[9] = {"featConradsegPolAtts", 0};
const char * featConradsegStmSubs[4] = {"featConradsegStmSubs", 0};
const char * featCparlnActAtts[4] = {"featCparlnActAtts", 0};
const char * featCparlnNomAtts[4] = {"featCparlnNomAtts", 0};
const char * featCparlnStmSubs[4] = {"featCparlnStmSubs", 0};
const char * featCylndrActAtts[4] = {"featCylndrActAtts", 0};
const char * featCylndrNomAtts[4] = {"featCylndrNomAtts", 0};
const char * featCylndrStmSubs[4] = {"featCylndrStmSubs", 0};
const char * featCylradsegActAtts[4] = {"featCylradsegActAtts", 0};
const char * featCylradsegCartAtts[8] = {"featCylradsegCartAtts", 0};
const char * featCylradsegNomAtts[4] = {"featCylradsegNomAtts", 0};
const char * featCylradsegPolAtts[8] = {"featCylradsegPolAtts", 0};
const char * featCylradsegStmSubs[4] = {"featCylradsegStmSubs", 0};
const char * featEdgeptActAtts[4] = {"featEdgeptActAtts", 0};
const char * featEdgeptNomAtts[4] = {"featEdgeptNomAtts", 0};
const char * featEdgeptStmSubs[4] = {"featEdgeptStmSubs", 0};
const char * featEllipsActAtts[4] = {"featEllipsActAtts", 0};
const char * featEllipsCartAtts[8] = {"featEllipsCartAtts", 0};
const char * featEllipsNomAtts[4] = {"featEllipsNomAtts", 0};
const char * featEllipsPolAtts[8] = {"featEllipsPolAtts", 0};
const char * featEllipsStmSubs[4] = {"featEllipsStmSubs", 0};
const char * featElongcylActAtts[4] = {"featElongcylActAtts", 0};
const char * featElongcylNomAtts[4] = {"featElongcylNomAtts", 0};
const char * featElongcylStmSubs[4] = {"featElongcylStmSubs", 0};
const char * featGcurveCartAtts[5] = {"featGcurveCartAtts", 0};
const char * featGcurvePolAtts[5] = {"featGcurvePolAtts", 0};
const char * featGcurveStmAtts[4] = {"featGcurveStmAtts", 0};
const char * featGeomStmAtts[4] = {"featGeomStmAtts", 0};
const char * featGsurfCartAtts[5] = {"featGsurfCartAtts", 0};
const char * featGsurfPolAtts[5] = {"featGsurfPolAtts", 0};
const char * featGsurfStmAtts[4] = {"featGsurfStmAtts", 0};
const char * featLineActAtts[4] = {"featLineActAtts", 0};
const char * featLineBndCartAtts[5] = {"featLineBndCartAtts", 0};
const char * featLineBndPolAtts[5] = {"featLineBndPolAtts", 0};
const char * featLineNomAtts[4] = {"featLineNomAtts", 0};
const char * featLineStmSubs[4] = {"featLineStmSubs", 0};
const char * featLineUnbndCartAtts[5] = {"featLineUnbndCartAtts", 0};
const char * featLineUnbndPolAtts[5] = {"featLineUnbndPolAtts", 0};
const char * featMinorArc1Atts[9] = {"featMinorArc1Atts", 0};
const char * featMinorArc2Atts[7] = {"featMinorArc2Atts", 0};
const char * featMinorCircleAtts[6] = {"featMinorCircleAtts", 0};
const char * featMinorCompoundSubs[5] = {"featMinorCompoundSubs", 0};
const char * featMinorConeAtts[6] = {"featMinorConeAtts", 0};
const char * featMinorConradsegSubs[4] = {"featMinorConradsegSubs", 0};
const char * featMinorCparlnAtts[9] = {"featMinorCparlnAtts", 0};
const char * featMinorCylndrAtts[7] = {"featMinorCylndrAtts", 0};
const char * featMinorCylradsegSubs[4] = {"featMinorCylradsegSubs", 0};
const char * featMinorEdgeptAtts[5] = {"featMinorEdgeptAtts", 0};
const char * featMinorEllipsSubs[4] = {"featMinorEllipsSubs", 0};
const char * featMinorElongcylAtts[9] = {"featMinorElongcylAtts", 0};
const char * featMinorGcurveSubs[4] = {"featMinorGcurveSubs", 0};
const char * featMinorGeomAtts[4] = {"featMinorGeomAtts", 0};
const char * featMinorGsurfSubs[5] = {"featMinorGsurfSubs", 0};
const char * featMinorLineSubs[6] = {"featMinorLineSubs", 0};
const char * featMinorObjectAtts[3] = {"featMinorObjectAtts", 0};
const char * featMinorParplnSubs[6] = {"featMinorParplnSubs", 0};
const char * featMinorPaternAtts[4] = {"featMinorPaternAtts", 0};
const char * featMinorPlaneAtts[4] = {"featMinorPlaneAtts", 0};
const char * featMinorPointAtts[4] = {"featMinorPointAtts", 0};
const char * featMinorRctnglAtts[10] = {"featMinorRctnglAtts", 0};
const char * featMinorRevsurfSubs[4] = {"featMinorRevsurfSubs", 0};
const char * featMinorSphereAtts[7] = {"featMinorSphereAtts", 0};
const char * featMinorSphradsegAtts[11] = {"featMinorSphradsegAtts", 0};
const char * featMinorSymplnSubs[4] = {"featMinorSymplnSubs", 0};
const char * featMinorTorradsegAtts[12] = {"featMinorTorradsegAtts", 0};
const char * featMinorTorusAtts[7] = {"featMinorTorusAtts", 0};
const char * featObjectActAtts[4] = {"featObjectActAtts", 0};
const char * featObjectNomAtts[4] = {"featObjectNomAtts", 0};
const char * featObjectStmSubs[4] = {"featObjectStmSubs", 0};
const char * featParplnActAtts[4] = {"featParplnActAtts", 0};
const char * featParplnMidplCartAtts[6] = {"featParplnMidplCartAtts", 0};
const char * featParplnMidplPolAtts[6] = {"featParplnMidplPolAtts", 0};
const char * featParplnNomAtts[4] = {"featParplnNomAtts", 0};
const char * featParplnPointsCartAtts[7] = {"featParplnPointsCartAtts", 0};
const char * featParplnPointsPolAtts[7] = {"featParplnPointsPolAtts", 0};
const char * featParplnStmSubs[4] = {"featParplnStmSubs", 0};
const char * featPaternStmAtts[4] = {"featPaternStmAtts", 0};
const char * featPlaneActAtts[4] = {"featPlaneActAtts", 0};
const char * featPlaneNomAtts[4] = {"featPlaneNomAtts", 0};
const char * featPlaneStmSubs[4] = {"featPlaneStmSubs", 0};
const char * featPointActAtts[4] = {"featPointActAtts", 0};
const char * featPointNomAtts[4] = {"featPointNomAtts", 0};
const char * featPointStmSubs[4] = {"featPointStmSubs", 0};
const char * featRctnglActAtts[4] = {"featRctnglActAtts", 0};
const char * featRctnglNomAtts[4] = {"featRctnglNomAtts", 0};
const char * featRctnglStmSubs[4] = {"featRctnglStmSubs", 0};
const char * featRevsurfActAtts[4] = {"featRevsurfActAtts", 0};
const char * featRevsurfCartAtts[7] = {"featRevsurfCartAtts", 0};
const char * featRevsurfNomAtts[4] = {"featRevsurfNomAtts", 0};
const char * featRevsurfPolAtts[7] = {"featRevsurfPolAtts", 0};
const char * featRevsurfStmSubs[4] = {"featRevsurfStmSubs", 0};
const char * featSphereActAtts[4] = {"featSphereActAtts", 0};
const char * featSphereNomAtts[4] = {"featSphereNomAtts", 0};
const char * featSphereStmSubs[4] = {"featSphereStmSubs", 0};
const char * featSphradsegActAtts[4] = {"featSphradsegActAtts", 0};
const char * featSphradsegNomAtts[4] = {"featSphradsegNomAtts", 0};
const char * featSphradsegStmSubs[4] = {"featSphradsegStmSubs", 0};
const char * featSymplnActAtts[4] = {"featSymplnActAtts", 0};
const char * featSymplnCartAtts[7] = {"featSymplnCartAtts", 0};
const char * featSymplnNomAtts[4] = {"featSymplnNomAtts", 0};
const char * featSymplnPolAtts[7] = {"featSymplnPolAtts", 0};
const char * featSymplnStmSubs[4] = {"featSymplnStmSubs", 0};
const char * featTorradsegActAtts[4] = {"featTorradsegActAtts", 0};
const char * featTorradsegNomAtts[4] = {"featTorradsegNomAtts", 0};
const char * featTorradsegStmSubs[4] = {"featTorradsegStmSubs", 0};
const char * featTorusActAtts[4] = {"featTorusActAtts", 0};
const char * featTorusNomAtts[4] = {"featTorusNomAtts", 0};
const char * featTorusStmSubs[4] = {"featTorusStmSubs", 0};
const char * featureLabelSubs[4] = {"featureLabelSubs", 0};
const char * featureLabel1Subs[4] = {"featureLabel1Subs", 0};
const char * fedratAngSpecSubs[4] = {"fedratAngSpecSubs", 0};
const char * fedratAngularAtts[3] = {"fedratAngularAtts", 0};
const char * fedratDefSubs[6] = {"fedratDefSubs", 0};
const char * fedratDef_PCENTAtts[3] = {"fedratDef_PCENTAtts", 0};
const char * fedratHedMeasAtts[3] = {"fedratHedMeasAtts", 0};
const char * fedratHedRotAtts[3] = {"fedratHedRotAtts", 0};
const char * fedratHedScanAtts[3] = {"fedratHedScanAtts", 0};
const char * fedratLinSpecSubs[4] = {"fedratLinSpecSubs", 0};
const char * fedratLinearSubs[6] = {"fedratLinearSubs", 0};
const char * fedratLinear_IPMAtts[3] = {"fedratLinear_IPMAtts", 0};
const char * fedratLinear_IPSAtts[3] = {"fedratLinear_IPSAtts", 0};
const char * fedratLinear_MMPSAtts[3] = {"fedratLinear_MMPSAtts", 0};
const char * fedratLinear_MPMAtts[3] = {"fedratLinear_MPMAtts", 0};
const char * fedratMeasAtts[3] = {"fedratMeasAtts", 0};
const char * fedratMinorSubs[9] = {"fedratMinorSubs", 0};
const char * fedratPosAtts[3] = {"fedratPosAtts", 0};
const char * fedratRotAtts[3] = {"fedratRotAtts", 0};
const char * fedratScanAtts[3] = {"fedratScanAtts", 0};
const char * fedratStmAtts[3] = {"fedratStmAtts", 0};
const char * fiLabelAtts[3] = {"fiLabelAtts", 0};
const char * fildefStmAtts[4] = {"fildefStmAtts", 0};
const char * filnamStmAtts[4] = {"filnamStmAtts", 0};
const char * finposStmAtts[3] = {"finposStmAtts", 0};
const char * fixtidStmAtts[4] = {"fixtidStmAtts", 0};
const char * fixtsnStmAtts[4] = {"fixtsnStmAtts", 0};
const char * flatRoundOpenSubs[5] = {"flatRoundOpenSubs", 0};
const char * flipNoFlipSubs[4] = {"flipNoFlipSubs", 0};
const char * flyMinorSubs[4] = {"flyMinorSubs", 0};
const char * flyMinor_rentValAtts[3] = {"flyMinor_rentValAtts", 0};
const char * flyStmAtts[3] = {"flyStmAtts", 0};
const char * forceOrDeflectionSubs[4] = {"forceOrDeflectionSubs", 0};
const char * forceOrDeflection_DEFLECTIONAtts[3] = {"forceOrDeflection_DEFLECTIONAtts", 0};
const char * forceOrDeflection_FORCEAtts[3] = {"forceOrDeflection_FORCEAtts", 0};
const char * fromMinorSubs[7] = {"fromMinorSubs", 0};
const char * fromMinor_cartPointAtts[4] = {"fromMinor_cartPointAtts", 0};
const char * fromMinor_impCartPointAtts[4] = {"fromMinor_impCartPointAtts", 0};
const char * fromMinor_polPointAtts[4] = {"fromMinor_polPointAtts", 0};
const char * fromStmAtts[3] = {"fromStmAtts", 0};
const char * fsLabelAtts[3] = {"fsLabelAtts", 0};
const char * gLabelAtts[3] = {"gLabelAtts", 0};
const char * geoalgArcAtts[3] = {"geoalgArcAtts", 0};
const char * geoalgCircleAtts[3] = {"geoalgCircleAtts", 0};
const char * geoalgConeAtts[3] = {"geoalgConeAtts", 0};
const char * geoalgConradsegmntAtts[3] = {"geoalgConradsegmntAtts", 0};
const char * geoalgCparlnAtts[3] = {"geoalgCparlnAtts", 0};
const char * geoalgCylndrAtts[3] = {"geoalgCylndrAtts", 0};
const char * geoalgCylradsegmntAtts[3] = {"geoalgCylradsegmntAtts", 0};
const char * geoalgEliminateSubs[4] = {"geoalgEliminateSubs", 0};
const char * geoalgEliminateStdAtts[3] = {"geoalgEliminateStdAtts", 0};
const char * geoalgEllipsAtts[3] = {"geoalgEllipsAtts", 0};
const char * geoalgElongcylAtts[3] = {"geoalgElongcylAtts", 0};
const char * geoalgExternFuncSubs[5] = {"geoalgExternFuncSubs", 0};
const char * geoalgExternFunc_DMEAtts[3] = {"geoalgExternFunc_DMEAtts", 0};
const char * geoalgExternFunc_DMISAtts[3] = {"geoalgExternFunc_DMISAtts", 0};
const char * geoalgExternFunc_SYSAtts[3] = {"geoalgExternFunc_SYSAtts", 0};
const char * geoalgFiltSetElimAtts[3] = {"geoalgFiltSetElimAtts", 0};
const char * geoalgFiltSetFiltAtts[4] = {"geoalgFiltSetFiltAtts", 0};
const char * geoalgFilterSubs[5] = {"geoalgFilterSubs", 0};
const char * geoalgFilterCircAtts[3] = {"geoalgFilterCircAtts", 0};
const char * geoalgFilterCurveSubs[6] = {"geoalgFilterCurveSubs", 0};
const char * geoalgFilterLambdaAtts[3] = {"geoalgFilterLambdaAtts", 0};
const char * geoalgFilterSettingsSubs[4] = {"geoalgFilterSettingsSubs", 0};
const char * geoalgFilterTypeSubs[5] = {"geoalgFilterTypeSubs", 0};
const char * geoalgFilterType_BANDPASSAtts[5] = {"geoalgFilterType_BANDPASSAtts", 0};
const char * geoalgFilterType_HIGHPASSAtts[4] = {"geoalgFilterType_HIGHPASSAtts", 0};
const char * geoalgFilterType_LOWPASSAtts[4] = {"geoalgFilterType_LOWPASSAtts", 0};
const char * geoalgGcurveAtts[3] = {"geoalgGcurveAtts", 0};
const char * geoalgGsurfAtts[3] = {"geoalgGsurfAtts", 0};
const char * geoalgLineAtts[3] = {"geoalgLineAtts", 0};
const char * geoalgMinorSubs[24] = {"geoalgMinorSubs", 0};
const char * geoalgObjectAtts[3] = {"geoalgObjectAtts", 0};
const char * geoalgParplnAtts[3] = {"geoalgParplnAtts", 0};
const char * geoalgPlaneAtts[3] = {"geoalgPlaneAtts", 0};
const char * geoalgRctnglAtts[3] = {"geoalgRctnglAtts", 0};
const char * geoalgRevsurfAtts[3] = {"geoalgRevsurfAtts", 0};
const char * geoalgSpec1Subs[6] = {"geoalgSpec1Subs", 0};
const char * geoalgSpec1_DEFALTAtts[3] = {"geoalgSpec1_DEFALTAtts", 0};
const char * geoalgSpec1_EXTERNAtts[5] = {"geoalgSpec1_EXTERNAtts", 0};
const char * geoalgSpec1_LSTSQRAtts[3] = {"geoalgSpec1_LSTSQRAtts", 0};
const char * geoalgSpec1_MINMAXAtts[3] = {"geoalgSpec1_MINMAXAtts", 0};
const char * geoalgSpec2Subs[8] = {"geoalgSpec2Subs", 0};
const char * geoalgSpec2_DEFALTAtts[3] = {"geoalgSpec2_DEFALTAtts", 0};
const char * geoalgSpec2_EXTERNAtts[5] = {"geoalgSpec2_EXTERNAtts", 0};
const char * geoalgSpec2_LSTSQRAtts[3] = {"geoalgSpec2_LSTSQRAtts", 0};
const char * geoalgSpec2_MAXINSAtts[3] = {"geoalgSpec2_MAXINSAtts", 0};
const char * geoalgSpec2_MINCIRAtts[3] = {"geoalgSpec2_MINCIRAtts", 0};
const char * geoalgSpec2_MINMAXAtts[3] = {"geoalgSpec2_MINMAXAtts", 0};
const char * geoalgSpec3Subs[4] = {"geoalgSpec3Subs", 0};
const char * geoalgSpec3_DEFALTAtts[3] = {"geoalgSpec3_DEFALTAtts", 0};
const char * geoalgSpec3_EXTERNAtts[5] = {"geoalgSpec3_EXTERNAtts", 0};
const char * geoalgSpec4Subs[7] = {"geoalgSpec4Subs", 0};
const char * geoalgSpec4_BSPLINAtts[3] = {"geoalgSpec4_BSPLINAtts", 0};
const char * geoalgSpec4_DEFALTAtts[3] = {"geoalgSpec4_DEFALTAtts", 0};
const char * geoalgSpec4_EXTERNAtts[5] = {"geoalgSpec4_EXTERNAtts", 0};
const char * geoalgSpec4_LSTSQRAtts[3] = {"geoalgSpec4_LSTSQRAtts", 0};
const char * geoalgSpec4_MINMAXAtts[3] = {"geoalgSpec4_MINMAXAtts", 0};
const char * geoalgSpec5Subs[8] = {"geoalgSpec5Subs", 0};
const char * geoalgSpec5_BEZIERAtts[3] = {"geoalgSpec5_BEZIERAtts", 0};
const char * geoalgSpec5_DEFALTAtts[3] = {"geoalgSpec5_DEFALTAtts", 0};
const char * geoalgSpec5_EXTERNAtts[5] = {"geoalgSpec5_EXTERNAtts", 0};
const char * geoalgSpec5_LSTSQRAtts[3] = {"geoalgSpec5_LSTSQRAtts", 0};
const char * geoalgSpec5_MINMAXAtts[3] = {"geoalgSpec5_MINMAXAtts", 0};
const char * geoalgSpec5_NURBSAtts[3] = {"geoalgSpec5_NURBSAtts", 0};
const char * geoalgSpec6Subs[6] = {"geoalgSpec6Subs", 0};
const char * geoalgSpec6_BSPLINAtts[3] = {"geoalgSpec6_BSPLINAtts", 0};
const char * geoalgSpec6_DEFALTAtts[3] = {"geoalgSpec6_DEFALTAtts", 0};
const char * geoalgSpec6_EXTERNAtts[5] = {"geoalgSpec6_EXTERNAtts", 0};
const char * geoalgSpec6_LSTSQRAtts[3] = {"geoalgSpec6_LSTSQRAtts", 0};
const char * geoalgSphereAtts[3] = {"geoalgSphereAtts", 0};
const char * geoalgSphradsegmntAtts[3] = {"geoalgSphradsegmntAtts", 0};
const char * geoalgStmAtts[3] = {"geoalgStmAtts", 0};
const char * geoalgSymplnAtts[3] = {"geoalgSymplnAtts", 0};
const char * geoalgTorradsegmntAtts[3] = {"geoalgTorradsegmntAtts", 0};
const char * geoalgTorusAtts[3] = {"geoalgTorusAtts", 0};
const char * geomEntityItemAtts[4] = {"geomEntityItemAtts", 0};
const char * geomMinorSubs[6] = {"geomMinorSubs", 0};
const char * geomStmAtts[4] = {"geomStmAtts", 0};
const char * geomStmDidAtts[3] = {"geomStmDidAtts", 0};
const char * geomStmEntityAtts[4] = {"geomStmEntityAtts", 0};
const char * geomStmOffsetAtts[4] = {"geomStmOffsetAtts", 0};
const char * gotargBlockAtts[6] = {"gotargBlockAtts", 0};
const char * gotargCartAtts[3] = {"gotargCartAtts", 0};
const char * gotargPolAtts[3] = {"gotargPolAtts", 0};
const char * gotargStmSubs[5] = {"gotargStmSubs", 0};
const char * gotargXyzAtts[3] = {"gotargXyzAtts", 0};
const char * gotoAbsSubs[8] = {"gotoAbsSubs", 0};
const char * gotoAbsCartAtts[3] = {"gotoAbsCartAtts", 0};
const char * gotoAbsCartSensAtts[4] = {"gotoAbsCartSensAtts", 0};
const char * gotoAbsPolAtts[3] = {"gotoAbsPolAtts", 0};
const char * gotoAbsPolSensAtts[4] = {"gotoAbsPolSensAtts", 0};
const char * gotoAbsXyzAtts[3] = {"gotoAbsXyzAtts", 0};
const char * gotoAbsXyzSensAtts[4] = {"gotoAbsXyzSensAtts", 0};
const char * gotoArcAtts[5] = {"gotoArcAtts", 0};
const char * gotoAxisAtts[5] = {"gotoAxisAtts", 0};
const char * gotoAxisSpecAtts[4] = {"gotoAxisSpecAtts", 0};
const char * gotoMinorSubs[7] = {"gotoMinorSubs", 0};
const char * gotoRelAtts[4] = {"gotoRelAtts", 0};
const char * gotoStmAtts[3] = {"gotoStmAtts", 0};
const char * gotoWristAngleItemAtts[4] = {"gotoWristAngleItemAtts", 0};
const char * gotoWristItemAtts[4] = {"gotoWristItemAtts", 0};
const char * groupStmAtts[5] = {"groupStmAtts", 0};
const char * gsaLabelAtts[3] = {"gsaLabelAtts", 0};
const char * ifBlockAtts[7] = {"ifBlockAtts", 0};
const char * ifStmAtts[3] = {"ifStmAtts", 0};
const char * impCartPointAtts[5] = {"impCartPointAtts", 0};
const char * impPolPointAtts[5] = {"impPolPointAtts", 0};
const char * includDmeAtts[3] = {"includDmeAtts", 0};
const char * includDmisAtts[3] = {"includDmisAtts", 0};
const char * includMinorSubs[4] = {"includMinorSubs", 0};
const char * includStmAtts[3] = {"includStmAtts", 0};
const char * indexedFeatureAtts[4] = {"indexedFeatureAtts", 0};
const char * inputFileAtts[5] = {"inputFileAtts", 0};
const char * intConstAtts[3] = {"intConstAtts", 0};
const char * intExprSubs[10] = {"intExprSubs", 0};
const char * intExprDividAtts[4] = {"intExprDividAtts", 0};
const char * intExprMinusAtts[4] = {"intExprMinusAtts", 0};
const char * intExprNegatAtts[3] = {"intExprNegatAtts", 0};
const char * intExprParenAtts[3] = {"intExprParenAtts", 0};
const char * intExprPlusAtts[4] = {"intExprPlusAtts", 0};
const char * intExprPositAtts[3] = {"intExprPositAtts", 0};
const char * intExprPowerAtts[4] = {"intExprPowerAtts", 0};
const char * intExprTimesAtts[4] = {"intExprTimesAtts", 0};
const char * intFuncSubs[13] = {"intFuncSubs", 0};
const char * intFuncAbsAtts[3] = {"intFuncAbsAtts", 0};
const char * intFuncIndxAtts[4] = {"intFuncIndxAtts", 0};
const char * intFuncIntAtts[3] = {"intFuncIntAtts", 0};
const char * intFuncLenAtts[3] = {"intFuncLenAtts", 0};
const char * intFuncModAtts[4] = {"intFuncModAtts", 0};
const char * intFuncNintAtts[3] = {"intFuncNintAtts", 0};
const char * intFuncOrdSubs[4] = {"intFuncOrdSubs", 0};
const char * intFuncOrd_boolValAtts[3] = {"intFuncOrd_boolValAtts", 0};
const char * intFuncOrd_stringValAtts[3] = {"intFuncOrd_stringValAtts", 0};
const char * intFuncPtdataAtts[3] = {"intFuncPtdataAtts", 0};
const char * intFuncSignAtts[4] = {"intFuncSignAtts", 0};
const char * intRealExprSubs[7] = {"intRealExprSubs", 0};
const char * intRealExpr_DIVIDAtts[4] = {"intRealExpr_DIVIDAtts", 0};
const char * intRealExpr_MINUSAtts[4] = {"intRealExpr_MINUSAtts", 0};
const char * intRealExpr_PLUSAtts[4] = {"intRealExpr_PLUSAtts", 0};
const char * intRealExpr_POWERAtts[4] = {"intRealExpr_POWERAtts", 0};
const char * intRealExpr_TIMESAtts[4] = {"intRealExpr_TIMESAtts", 0};
const char * intRealRelSubs[8] = {"intRealRelSubs", 0};
const char * intRealRel_EQAtts[4] = {"intRealRel_EQAtts", 0};
const char * intRealRel_GEAtts[4] = {"intRealRel_GEAtts", 0};
const char * intRealRel_GTAtts[4] = {"intRealRel_GTAtts", 0};
const char * intRealRel_LEAtts[4] = {"intRealRel_LEAtts", 0};
const char * intRealRel_LTAtts[4] = {"intRealRel_LTAtts", 0};
const char * intRealRel_NEAtts[4] = {"intRealRel_NEAtts", 0};
const char * intRelSubs[8] = {"intRelSubs", 0};
const char * intRel_EQAtts[4] = {"intRel_EQAtts", 0};
const char * intRel_GEAtts[4] = {"intRel_GEAtts", 0};
const char * intRel_GTAtts[4] = {"intRel_GTAtts", 0};
const char * intRel_LEAtts[4] = {"intRel_LEAtts", 0};
const char * intRel_LTAtts[4] = {"intRel_LTAtts", 0};
const char * intRel_NEAtts[4] = {"intRel_NEAtts", 0};
const char * intValSubs[6] = {"intValSubs", 0};
const char * intVarAtts[4] = {"intVarAtts", 0};
const char * intVecExpr_TIMESAtts[4] = {"intVecExpr_TIMESAtts", 0};
const char * intofConstAtts[4] = {"intofConstAtts", 0};
const char * iteratConvergenceSubs[4] = {"iteratConvergenceSubs", 0};
const char * iteratConvergence_ABSLAtts[3] = {"iteratConvergence_ABSLAtts", 0};
const char * iteratConvergence_INCRAtts[3] = {"iteratConvergence_INCRAtts", 0};
const char * iteratCriterionItemAtts[4] = {"iteratCriterionItemAtts", 0};
const char * iteratCriterionStartSubs[5] = {"iteratCriterionStartSubs", 0};
const char * iteratCriterionStart_axisAtts[3] = {"iteratCriterionStart_axisAtts", 0};
const char * iteratCriterionStart_vectorAtts[3] = {"iteratCriterionStart_vectorAtts", 0};
const char * iteratMinorAtts[7] = {"iteratMinorAtts", 0};
const char * iteratStmAtts[4] = {"iteratStmAtts", 0};
const char * jointConfAtts[6] = {"jointConfAtts", 0};
const char * jumpLabelSubs[3] = {"jumpLabelSubs", 0};
const char * jumpStmAtts[3] = {"jumpStmAtts", 0};
const char * jumptoStmAtts[3] = {"jumptoStmAtts", 0};
const char * kcLabelAtts[3] = {"kcLabelAtts", 0};
const char * kcaLabelAtts[3] = {"kcaLabelAtts", 0};
const char * keycharMinorSubs[4] = {"keycharMinorSubs", 0};
const char * keycharOneFeatureAtts[5] = {"keycharOneFeatureAtts", 0};
const char * keycharStmAtts[4] = {"keycharStmAtts", 0};
const char * keycharTwoFeaturesAtts[6] = {"keycharTwoFeaturesAtts", 0};
const char * labelNameSubs[4] = {"labelNameSubs", 0};
const char * labelNameAtAtts[3] = {"labelNameAtAtts", 0};
const char * labelNameConAtts[3] = {"labelNameConAtts", 0};
const char * labelNameConstAtts[3] = {"labelNameConstAtts", 0};
const char * leftRightSubs[4] = {"leftRightSubs", 0};
const char * lengthUnitSubs[7] = {"lengthUnitSubs", 0};
const char * liLabelAtts[3] = {"liLabelAtts", 0};
const char * litdefLightAtts[4] = {"litdefLightAtts", 0};
const char * litdefLightTypeSubs[6] = {"litdefLightTypeSubs", 0};
const char * litdefMinorSubs[4] = {"litdefMinorSubs", 0};
const char * litdefStmAtts[4] = {"litdefStmAtts", 0};
const char * litdefStrobeAtts[5] = {"litdefStrobeAtts", 0};
const char * litdefStrobeTypeSubs[4] = {"litdefStrobeTypeSubs", 0};
const char * litdefStrobeType_CYCLEAtts[3] = {"litdefStrobeType_CYCLEAtts", 0};
const char * locateLabelSubs[5] = {"locateLabelSubs", 0};
const char * locateRotAllowedSubs[10] = {"locateRotAllowedSubs", 0};
const char * locateStmAtts[6] = {"locateStmAtts", 0};
const char * locateTransAllowedSubs[10] = {"locateTransAllowedSubs", 0};
const char * longShortSubs[4] = {"longShortSubs", 0};
const char * lotidStmAtts[4] = {"lotidStmAtts", 0};
const char * mLabelAtts[3] = {"mLabelAtts", 0};
const char * mLabelConstAtts[3] = {"mLabelConstAtts", 0};
const char * maLabelAtts[3] = {"maLabelAtts", 0};
const char * macroBlockAtts[5] = {"macroBlockAtts", 0};
const char * macroParSubs[4] = {"macroParSubs", 0};
const char * macroPar_MACROVARNAMEAtts[3] = {"macroPar_MACROVARNAMEAtts", 0};
const char * macroPar_stringConstAtts[3] = {"macroPar_stringConstAtts", 0};
const char * macroStmAtts[4] = {"macroStmAtts", 0};
const char * matDirSubs[4] = {"matDirSubs", 0};
const char * matdefFeatAtts[4] = {"matdefFeatAtts", 0};
const char * matdefGeomAtts[4] = {"matdefGeomAtts", 0};
const char * matdefMatSubs[4] = {"matdefMatSubs", 0};
const char * matdefMat_LMCAtts[3] = {"matdefMat_LMCAtts", 0};
const char * matdefMat_MMCAtts[3] = {"matdefMat_MMCAtts", 0};
const char * matdefMatingSubs[6] = {"matdefMatingSubs", 0};
const char * matdefMethodSubs[4] = {"matdefMethodSubs", 0};
const char * matdefMinorSubs[4] = {"matdefMinorSubs", 0};
const char * matdefSpecAtts[4] = {"matdefSpecAtts", 0};
const char * matdefStmAtts[4] = {"matdefStmAtts", 0};
const char * matdefTypeSubs[4] = {"matdefTypeSubs", 0};
const char * matdefTypeBandAtts[7] = {"matdefTypeBandAtts", 0};
const char * matdefTypeZoneAtts[6] = {"matdefTypeZoneAtts", 0};
const char * matrixAtts[14] = {"matrixAtts", 0};
const char * mdLabelAtts[3] = {"mdLabelAtts", 0};
const char * measBlockSubs[4] = {"measBlockSubs", 0};
const char * measBlockItemSubs[6] = {"measBlockItemSubs", 0};
const char * measBlockStatementSubs[7] = {"measBlockStatementSubs", 0};
const char * measBlock_measStmAtts[5] = {"measBlock_measStmAtts", 0};
const char * measBlock_rmeasStmAtts[5] = {"measBlock_rmeasStmAtts", 0};
const char * measCaseBlockAtts[5] = {"measCaseBlockAtts", 0};
const char * measDefaultCaseBlockAtts[5] = {"measDefaultCaseBlockAtts", 0};
const char * measDoBlockAtts[5] = {"measDoBlockAtts", 0};
const char * measGeotypeSubs[25] = {"measGeotypeSubs", 0};
const char * measIfBlockAtts[7] = {"measIfBlockAtts", 0};
const char * measMinorSubs[5] = {"measMinorSubs", 0};
const char * measMinorCompAtts[3] = {"measMinorCompAtts", 0};
const char * measMinorOtherAtts[3] = {"measMinorOtherAtts", 0};
const char * measSelectBlockAtts[6] = {"measSelectBlockAtts", 0};
const char * measStmAtts[5] = {"measStmAtts", 0};
const char * measVar2Subs[8] = {"measVar2Subs", 0};
const char * measVar2AuxSubs[5] = {"measVar2AuxSubs", 0};
const char * measVar2_FEATAtts[3] = {"measVar2_FEATAtts", 0};
const char * measVar2_VECAtts[3] = {"measVar2_VECAtts", 0};
const char * mfgdevStmAtts[4] = {"mfgdevStmAtts", 0};
const char * midliConstAtts[4] = {"midliConstAtts", 0};
const char * midplConstAtts[4] = {"midplConstAtts", 0};
const char * midptConstAtts[4] = {"midptConstAtts", 0};
const char * modeStmAtts[4] = {"modeStmAtts", 0};
const char * moveptConstSubs[4] = {"moveptConstSubs", 0};
const char * moveptConstAxisAtts[5] = {"moveptConstAxisAtts", 0};
const char * moveptConstVecAtts[4] = {"moveptConstVecAtts", 0};
const char * nearptConstAtts[3] = {"nearptConstAtts", 0};
const char * negDirSubs[5] = {"negDirSubs", 0};
const char * noParseStmAtts[3] = {"noParseStmAtts", 0};
const char * obtainBoolAtts[4] = {"obtainBoolAtts", 0};
const char * obtainIntAtts[4] = {"obtainIntAtts", 0};
const char * obtainLabeledSubs[29] = {"obtainLabeledSubs", 0};
const char * obtainLabeled_crLabelAtts[4] = {"obtainLabeled_crLabelAtts", 0};
const char * obtainLabeled_datumLabel1Atts[4] = {"obtainLabeled_datumLabel1Atts", 0};
const char * obtainLabeled_didLabelAtts[4] = {"obtainLabeled_didLabelAtts", 0};
const char * obtainLabeled_featureLabelAtts[4] = {"obtainLabeled_featureLabelAtts", 0};
const char * obtainLabeled_gLabelAtts[4] = {"obtainLabeled_gLabelAtts", 0};
const char * obtainLabeled_gsaLabelAtts[4] = {"obtainLabeled_gsaLabelAtts", 0};
const char * obtainLabeled_kcLabelAtts[4] = {"obtainLabeled_kcLabelAtts", 0};
const char * obtainLabeled_maLabelAtts[4] = {"obtainLabeled_maLabelAtts", 0};
const char * obtainLabeled_pLabelAtts[4] = {"obtainLabeled_pLabelAtts", 0};
const char * obtainLabeled_qisLabelAtts[4] = {"obtainLabeled_qisLabelAtts", 0};
const char * obtainLabeled_rLabelAtts[4] = {"obtainLabeled_rLabelAtts", 0};
const char * obtainLabeled_rmLabelAtts[4] = {"obtainLabeled_rmLabelAtts", 0};
const char * obtainLabeled_rtLabelAtts[4] = {"obtainLabeled_rtLabelAtts", 0};
const char * obtainLabeled_sensorLabel1Atts[4] = {"obtainLabeled_sensorLabel1Atts", 0};
const char * obtainLabeled_sgLabelAtts[4] = {"obtainLabeled_sgLabelAtts", 0};
const char * obtainLabeled_sgsLabelAtts[4] = {"obtainLabeled_sgsLabelAtts", 0};
const char * obtainLabeled_sraLabelAtts[4] = {"obtainLabeled_sraLabelAtts", 0};
const char * obtainLabeled_ssLabelAtts[4] = {"obtainLabeled_ssLabelAtts", 0};
const char * obtainLabeled_swLabelAtts[4] = {"obtainLabeled_swLabelAtts", 0};
const char * obtainLabeled_sxLabelAtts[4] = {"obtainLabeled_sxLabelAtts", 0};
const char * obtainLabeled_thLabelAtts[4] = {"obtainLabeled_thLabelAtts", 0};
const char * obtainLabeled_toleranceLabelAtts[4] = {"obtainLabeled_toleranceLabelAtts", 0};
const char * obtainLabeled_vLabelAtts[4] = {"obtainLabeled_vLabelAtts", 0};
const char * obtainLabeled_vaLabelAtts[4] = {"obtainLabeled_vaLabelAtts", 0};
const char * obtainLabeled_vfLabelAtts[4] = {"obtainLabeled_vfLabelAtts", 0};
const char * obtainLabeled_vlLabelAtts[4] = {"obtainLabeled_vlLabelAtts", 0};
const char * obtainLabeled_vwLabelAtts[4] = {"obtainLabeled_vwLabelAtts", 0};
const char * obtainPointAtts[5] = {"obtainPointAtts", 0};
const char * obtainRealLabelAtts[4] = {"obtainRealLabelAtts", 0};
const char * obtainRealPointAtts[4] = {"obtainRealPointAtts", 0};
const char * obtainStmSubs[7] = {"obtainStmSubs", 0};
const char * obtainStringAtts[4] = {"obtainStringAtts", 0};
const char * offsetConstAtts[3] = {"offsetConstAtts", 0};
const char * opLabelAtts[3] = {"opLabelAtts", 0};
const char * openCadfileAtts[3] = {"openCadfileAtts", 0};
const char * openDMLfileSubs[4] = {"openDMLfileSubs", 0};
const char * openDeviceSubs[4] = {"openDeviceSubs", 0};
const char * openDevice_inputAccessAtts[3] = {"openDevice_inputAccessAtts", 0};
const char * openDevice_outputAccessAtts[3] = {"openDevice_outputAccessAtts", 0};
const char * openDmlInputAtts[3] = {"openDmlInputAtts", 0};
const char * openDmlOutputAtts[4] = {"openDmlOutputAtts", 0};
const char * openFdataSubs[4] = {"openFdataSubs", 0};
const char * openFdata_DMISAtts[3] = {"openFdata_DMISAtts", 0};
const char * openFdata_vLabelAtts[4] = {"openFdata_vLabelAtts", 0};
const char * openMinorSubs[7] = {"openMinorSubs", 0};
const char * openMinor_openCadfileAtts[4] = {"openMinor_openCadfileAtts", 0};
const char * openMinor_openDMLfileAtts[4] = {"openMinor_openDMLfileAtts", 0};
const char * openMinor_openDeviceAtts[4] = {"openMinor_openDeviceAtts", 0};
const char * openMinor_openFdataAtts[4] = {"openMinor_openFdataAtts", 0};
const char * openMinor_storageSpecListAtts[4] = {"openMinor_storageSpecListAtts", 0};
const char * openStmAtts[3] = {"openStmAtts", 0};
const char * operidStmAtts[4] = {"operidStmAtts", 0};
const char * origSubs[5] = {"origSubs", 0};
const char * outputAccessSubs[5] = {"outputAccessSubs", 0};
const char * outputConstBothDataAtts[5] = {"outputConstBothDataAtts", 0};
const char * outputConstDataSubs[5] = {"outputConstDataSubs", 0};
const char * outputConstGaugeDataAtts[3] = {"outputConstGaugeDataAtts", 0};
const char * outputConstPartDataAtts[3] = {"outputConstPartDataAtts", 0};
const char * outputDatSubs[4] = {"outputDatSubs", 0};
const char * outputDat_datLabelAtts[6] = {"outputDat_datLabelAtts", 0};
const char * outputDat_faLabelAtts[6] = {"outputDat_faLabelAtts", 0};
const char * outputFeatSubs[10] = {"outputFeatSubs", 0};
const char * outputFeat1FAtts[5] = {"outputFeat1FAtts", 0};
const char * outputFeat1FTAtts[6] = {"outputFeat1FTAtts", 0};
const char * outputFeat1FaAtts[5] = {"outputFeat1FaAtts", 0};
const char * outputFeat1FaTaAtts[6] = {"outputFeat1FaTaAtts", 0};
const char * outputFeat2FFTAtts[6] = {"outputFeat2FFTAtts", 0};
const char * outputFeat2FFaTaAtts[6] = {"outputFeat2FFaTaAtts", 0};
const char * outputFeat2FaFTaAtts[6] = {"outputFeat2FaFTaAtts", 0};
const char * outputFeat2FaFaTaAtts[6] = {"outputFeat2FaFaTaAtts", 0};
const char * outputFeatDataSubs[4] = {"outputFeatDataSubs", 0};
const char * outputKeycharDataSubs[4] = {"outputKeycharDataSubs", 0};
const char * outputMinorSubs[8] = {"outputMinorSubs", 0};
const char * outputReportDataSubs[3] = {"outputReportDataSubs", 0};
const char * outputSensorDataSubs[4] = {"outputSensorDataSubs", 0};
const char * outputSensorData_sLabelAtts[3] = {"outputSensorData_sLabelAtts", 0};
const char * outputSensorData_saLabelAtts[4] = {"outputSensorData_saLabelAtts", 0};
const char * outputSensorDescSubs[6] = {"outputSensorDescSubs", 0};
const char * outputSensorDesc_intValAtts[4] = {"outputSensorDesc_intValAtts", 0};
const char * outputSensorDesc_outputSensorWristListAtts[3] = {"outputSensorDesc_outputSensorWristListAtts", 0};
const char * outputSensorDesc_stringValAtts[4] = {"outputSensorDesc_stringValAtts", 0};
const char * outputSensorWristAngleAtts[4] = {"outputSensorWristAngleAtts", 0};
const char * outputSensorWristItemAtts[4] = {"outputSensorWristItemAtts", 0};
const char * outputStmAtts[3] = {"outputStmAtts", 0};
const char * outputToleranceDataSubs[4] = {"outputToleranceDataSubs", 0};
const char * pLabelAtts[3] = {"pLabelAtts", 0};
const char * pameasDetailSubs[7] = {"pameasDetailSubs", 0};
const char * pameasDetailDistanceAtts[5] = {"pameasDetailDistanceAtts", 0};
const char * pameasDetailPitchAtts[3] = {"pameasDetailPitchAtts", 0};
const char * pameasDetailScnvelDataAtts[4] = {"pameasDetailScnvelDataAtts", 0};
const char * pameasDetailScnvelNoDataAtts[3] = {"pameasDetailScnvelNoDataAtts", 0};
const char * pameasFedratSubs[6] = {"pameasFedratSubs", 0};
const char * pameasFedrat_IPMAtts[3] = {"pameasFedrat_IPMAtts", 0};
const char * pameasFedrat_IPSAtts[3] = {"pameasFedrat_IPSAtts", 0};
const char * pameasFedrat_MMPSAtts[3] = {"pameasFedrat_MMPSAtts", 0};
const char * pameasFedrat_MPMAtts[3] = {"pameasFedrat_MPMAtts", 0};
const char * pameasMinorSubs[4] = {"pameasMinorSubs", 0};
const char * pameasMinor_pameasVar2ListAtts[3] = {"pameasMinor_pameasVar2ListAtts", 0};
const char * pameasMinor_pameasVar3ListAtts[3] = {"pameasMinor_pameasVar3ListAtts", 0};
const char * pameasRemoveSubs[5] = {"pameasRemoveSubs", 0};
const char * pameasRemoveCountAtts[4] = {"pameasRemoveCountAtts", 0};
const char * pameasRemoveDistAtts[4] = {"pameasRemoveDistAtts", 0};
const char * pameasStmAtts[3] = {"pameasStmAtts", 0};
const char * pameasVar2ListItemAtts[9] = {"pameasVar2ListItemAtts", 0};
const char * pameasVar3ListItemAtts[8] = {"pameasVar3ListItemAtts", 0};
const char * paramSubs[3] = {"paramSubs", 0};
const char * partidStmAtts[4] = {"partidStmAtts", 0};
const char * partoConstSubs[4] = {"partoConstSubs", 0};
const char * partoConstActAtts[4] = {"partoConstActAtts", 0};
const char * partoConstNomAtts[4] = {"partoConstNomAtts", 0};
const char * partrvStmAtts[4] = {"partrvStmAtts", 0};
const char * partsnStmAtts[4] = {"partsnStmAtts", 0};
const char * pathArcAtts[8] = {"pathArcAtts", 0};
const char * pathCurveSubs[4] = {"pathCurveSubs", 0};
const char * pathCurvePointsAtts[4] = {"pathCurvePointsAtts", 0};
const char * pathCurvePtdataSubs[4] = {"pathCurvePtdataSubs", 0};
const char * pathCurve_pathCurvePointsAtts[3] = {"pathCurve_pathCurvePointsAtts", 0};
const char * pathCurve_pathCurvePtdataAtts[3] = {"pathCurve_pathCurvePtdataAtts", 0};
const char * pathHelicalAtts[10] = {"pathHelicalAtts", 0};
const char * pathLineSubs[4] = {"pathLineSubs", 0};
const char * pathLineCartAtts[7] = {"pathLineCartAtts", 0};
const char * pathLinePolAtts[5] = {"pathLinePolAtts", 0};
const char * pathMinorSubs[9] = {"pathMinorSubs", 0};
const char * pathPointAtts[4] = {"pathPointAtts", 0};
const char * pathStmAtts[4] = {"pathStmAtts", 0};
const char * pathSurfaceSubs[7] = {"pathSurfaceSubs", 0};
const char * pathSurfaceHeadcsAtts[6] = {"pathSurfaceHeadcsAtts", 0};
const char * pathSurfaceHeadcsDataAtts[7] = {"pathSurfaceHeadcsDataAtts", 0};
const char * pathSurfacePcsAtts[4] = {"pathSurfacePcsAtts", 0};
const char * pathSurfacePcsDataAtts[5] = {"pathSurfacePcsDataAtts", 0};
const char * pathSurfacePlainAtts[3] = {"pathSurfacePlainAtts", 0};
const char * pathUnknownAtts[6] = {"pathUnknownAtts", 0};
const char * pcLabelAtts[3] = {"pcLabelAtts", 0};
const char * perptoConstSubs[4] = {"perptoConstSubs", 0};
const char * perptoConstActAtts[4] = {"perptoConstActAtts", 0};
const char * perptoConstNomAtts[4] = {"perptoConstNomAtts", 0};
const char * pierceConstAtts[4] = {"pierceConstAtts", 0};
const char * plLabelAtts[3] = {"plLabelAtts", 0};
const char * planSubs[5] = {"planSubs", 0};
const char * planidStmAtts[4] = {"planidStmAtts", 0};
const char * pnLabelAtts[3] = {"pnLabelAtts", 0};
const char * pointRangeAtts[4] = {"pointRangeAtts", 0};
const char * pointVecCartAtts[8] = {"pointVecCartAtts", 0};
const char * pointVecPolAtts[8] = {"pointVecPolAtts", 0};
const char * polPointAtts[5] = {"polPointAtts", 0};
const char * popStmAtts[3] = {"popStmAtts", 0};
const char * posDirSubs[5] = {"posDirSubs", 0};
const char * prLabelAtts[3] = {"prLabelAtts", 0};
const char * prcompStmAtts[3] = {"prcompStmAtts", 0};
const char * prevopStmAtts[4] = {"prevopStmAtts", 0};
const char * probeLocCartAtts[4] = {"probeLocCartAtts", 0};
const char * probeLocPolAtts[6] = {"probeLocPolAtts", 0};
const char * probeLocSnsCartAtts[4] = {"probeLocSnsCartAtts", 0};
const char * probeLocSnsVecAtts[5] = {"probeLocSnsVecAtts", 0};
const char * probeLocVecAtts[5] = {"probeLocVecAtts", 0};
const char * probeLocationSubs[7] = {"probeLocationSubs", 0};
const char * probeOrientSubs[6] = {"probeOrientSubs", 0};
const char * probeOrient_HEADCSAtts[5] = {"probeOrient_HEADCSAtts", 0};
const char * probeOrient_PCSAtts[3] = {"probeOrient_PCSAtts", 0};
const char * probeOrient_VECAtts[4] = {"probeOrient_VECAtts", 0};
const char * probeOrient_featureLabelAtts[4] = {"probeOrient_featureLabelAtts", 0};
const char * procidStmAtts[4] = {"procidStmAtts", 0};
const char * projctConstAtts[4] = {"projctConstAtts", 0};
const char * projliConstAtts[4] = {"projliConstAtts", 0};
const char * projptConstAtts[4] = {"projptConstAtts", 0};
const char * promptIntEndSubs[4] = {"promptIntEndSubs", 0};
const char * promptIntEnd_promptItemListAtts[3] = {"promptIntEnd_promptItemListAtts", 0};
const char * promptIntEnd_stringValAtts[5] = {"promptIntEnd_stringValAtts", 0};
const char * promptItemSubs[12] = {"promptItemSubs", 0};
const char * promptItem_BUTTONAtts[4] = {"promptItem_BUTTONAtts", 0};
const char * promptItem_CHECKAtts[4] = {"promptItem_CHECKAtts", 0};
const char * promptItem_EDITAtts[5] = {"promptItem_EDITAtts", 0};
const char * promptItem_GROUPAtts[6] = {"promptItem_GROUPAtts", 0};
const char * promptItem_LISTAtts[5] = {"promptItem_LISTAtts", 0};
const char * promptItem_PICTUREAtts[4] = {"promptItem_PICTUREAtts", 0};
const char * promptItem_PIXBTNAtts[5] = {"promptItem_PIXBTNAtts", 0};
const char * promptItem_SOUNDAtts[3] = {"promptItem_SOUNDAtts", 0};
const char * promptItem_TEXTAtts[3] = {"promptItem_TEXTAtts", 0};
const char * promptItem_TITLEAtts[3] = {"promptItem_TITLEAtts", 0};
const char * promptStmSubs[25] = {"promptStmSubs", 0};
const char * promptStm_boolVarAtts[4] = {"promptStm_boolVarAtts", 0};
const char * promptStm_ccLabelAtts[5] = {"promptStm_ccLabelAtts", 0};
const char * promptStm_ciLabelAtts[5] = {"promptStm_ciLabelAtts", 0};
const char * promptStm_csLabelAtts[5] = {"promptStm_csLabelAtts", 0};
const char * promptStm_diLabelAtts[5] = {"promptStm_diLabelAtts", 0};
const char * promptStm_dsLabelAtts[5] = {"promptStm_dsLabelAtts", 0};
const char * promptStm_dvLabelAtts[5] = {"promptStm_dvLabelAtts", 0};
const char * promptStm_fiLabelAtts[5] = {"promptStm_fiLabelAtts", 0};
const char * promptStm_fsLabelAtts[5] = {"promptStm_fsLabelAtts", 0};
const char * promptStm_intVarAtts[4] = {"promptStm_intVarAtts", 0};
const char * promptStm_liLabelAtts[5] = {"promptStm_liLabelAtts", 0};
const char * promptStm_mdLabelAtts[5] = {"promptStm_mdLabelAtts", 0};
const char * promptStm_opLabelAtts[5] = {"promptStm_opLabelAtts", 0};
const char * promptStm_pcLabelAtts[5] = {"promptStm_pcLabelAtts", 0};
const char * promptStm_plLabelAtts[5] = {"promptStm_plLabelAtts", 0};
const char * promptStm_pnLabelAtts[5] = {"promptStm_pnLabelAtts", 0};
const char * promptStm_prLabelAtts[5] = {"promptStm_prLabelAtts", 0};
const char * promptStm_psLabelAtts[5] = {"promptStm_psLabelAtts", 0};
const char * promptStm_pvLabelAtts[5] = {"promptStm_pvLabelAtts", 0};
const char * promptStm_qLabelAtts[5] = {"promptStm_qLabelAtts", 0};
const char * promptStm_realVarAtts[6] = {"promptStm_realVarAtts", 0};
const char * promptStm_stringVarAtts[5] = {"promptStm_stringVarAtts", 0};
const char * promptStm_tlLabelAtts[5] = {"promptStm_tlLabelAtts", 0};
const char * promptVarSubs[7] = {"promptVarSubs", 0};
const char * psLabelAtts[3] = {"psLabelAtts", 0};
const char * psthruMinorSubs[8] = {"psthruMinorSubs", 0};
const char * psthruMinor_COMANDAtts[3] = {"psthruMinor_COMANDAtts", 0};
const char * psthruMinor_TRMATXAtts[3] = {"psthruMinor_TRMATXAtts", 0};
const char * psthruStmAtts[3] = {"psthruStmAtts", 0};
const char * ptbuffStmAtts[3] = {"ptbuffStmAtts", 0};
const char * ptmeasEndSubs[4] = {"ptmeasEndSubs", 0};
const char * ptmeasEnd_csSpecAtts[4] = {"ptmeasEnd_csSpecAtts", 0};
const char * ptmeasEnd_touchSpecAtts[3] = {"ptmeasEnd_touchSpecAtts", 0};
const char * ptmeasStmAtts[5] = {"ptmeasStmAtts", 0};
const char * pushStmAtts[3] = {"pushStmAtts", 0};
const char * pvLabelAtts[3] = {"pvLabelAtts", 0};
const char * qLabelAtts[3] = {"qLabelAtts", 0};
const char * qisLabelSubs[21] = {"qisLabelSubs", 0};
const char * qisdefStmAtts[5] = {"qisdefStmAtts", 0};
const char * rLabelAtts[3] = {"rLabelAtts", 0};
const char * radiusSpecSubs[4] = {"radiusSpecSubs", 0};
const char * rapidStmAtts[3] = {"rapidStmAtts", 0};
const char * readSpecAtts[4] = {"readSpecAtts", 0};
const char * readStmAtts[4] = {"readStmAtts", 0};
const char * realConstAtts[3] = {"realConstAtts", 0};
const char * realExprSubs[8] = {"realExprSubs", 0};
const char * realExprNegatAtts[3] = {"realExprNegatAtts", 0};
const char * realExprParenAtts[3] = {"realExprParenAtts", 0};
const char * realExprPositAtts[3] = {"realExprPositAtts", 0};
const char * realFuncSubs[30] = {"realFuncSubs", 0};
const char * realFuncAbsAtts[3] = {"realFuncAbsAtts", 0};
const char * realFuncAcosAtts[3] = {"realFuncAcosAtts", 0};
const char * realFuncAsinAtts[3] = {"realFuncAsinAtts", 0};
const char * realFuncAtanAtts[3] = {"realFuncAtanAtts", 0};
const char * realFuncAtan2Atts[4] = {"realFuncAtan2Atts", 0};
const char * realFuncCosAtts[3] = {"realFuncCosAtts", 0};
const char * realFuncDbleAtts[3] = {"realFuncDbleAtts", 0};
const char * realFuncDtorAtts[3] = {"realFuncDtorAtts", 0};
const char * realFuncExpAtts[3] = {"realFuncExpAtts", 0};
const char * realFuncLnAtts[3] = {"realFuncLnAtts", 0};
const char * realFuncLogAtts[3] = {"realFuncLogAtts", 0};
const char * realFuncMnAtts[4] = {"realFuncMnAtts", 0};
const char * realFuncModAtts[4] = {"realFuncModAtts", 0};
const char * realFuncMxAtts[4] = {"realFuncMxAtts", 0};
const char * realFuncQtempAtts[3] = {"realFuncQtempAtts", 0};
const char * realFuncRandAtts[3] = {"realFuncRandAtts", 0};
const char * realFuncRlAtts[3] = {"realFuncRlAtts", 0};
const char * realFuncRtodAtts[3] = {"realFuncRtodAtts", 0};
const char * realFuncSignAtts[4] = {"realFuncSignAtts", 0};
const char * realFuncSinAtts[3] = {"realFuncSinAtts", 0};
const char * realFuncSqrtAtts[3] = {"realFuncSqrtAtts", 0};
const char * realFuncTanAtts[3] = {"realFuncTanAtts", 0};
const char * realFuncValAtts[3] = {"realFuncValAtts", 0};
const char * realFuncVdotAtts[4] = {"realFuncVdotAtts", 0};
const char * realFuncVecXAtts[3] = {"realFuncVecXAtts", 0};
const char * realFuncVecYAtts[3] = {"realFuncVecYAtts", 0};
const char * realFuncVecZAtts[3] = {"realFuncVecZAtts", 0};
const char * realFuncVmagAtts[3] = {"realFuncVmagAtts", 0};
const char * realIntExprSubs[7] = {"realIntExprSubs", 0};
const char * realIntExpr_DIVIDAtts[4] = {"realIntExpr_DIVIDAtts", 0};
const char * realIntExpr_MINUSAtts[4] = {"realIntExpr_MINUSAtts", 0};
const char * realIntExpr_PLUSAtts[4] = {"realIntExpr_PLUSAtts", 0};
const char * realIntExpr_POWERAtts[4] = {"realIntExpr_POWERAtts", 0};
const char * realIntExpr_TIMESAtts[4] = {"realIntExpr_TIMESAtts", 0};
const char * realIntRelSubs[8] = {"realIntRelSubs", 0};
const char * realIntRel_EQAtts[4] = {"realIntRel_EQAtts", 0};
const char * realIntRel_GEAtts[4] = {"realIntRel_GEAtts", 0};
const char * realIntRel_GTAtts[4] = {"realIntRel_GTAtts", 0};
const char * realIntRel_LEAtts[4] = {"realIntRel_LEAtts", 0};
const char * realIntRel_LTAtts[4] = {"realIntRel_LTAtts", 0};
const char * realIntRel_NEAtts[4] = {"realIntRel_NEAtts", 0};
const char * realRealExprSubs[7] = {"realRealExprSubs", 0};
const char * realRealExpr_DIVIDAtts[4] = {"realRealExpr_DIVIDAtts", 0};
const char * realRealExpr_MINUSAtts[4] = {"realRealExpr_MINUSAtts", 0};
const char * realRealExpr_PLUSAtts[4] = {"realRealExpr_PLUSAtts", 0};
const char * realRealExpr_POWERAtts[4] = {"realRealExpr_POWERAtts", 0};
const char * realRealExpr_TIMESAtts[4] = {"realRealExpr_TIMESAtts", 0};
const char * realRealRelSubs[8] = {"realRealRelSubs", 0};
const char * realRealRel_EQAtts[4] = {"realRealRel_EQAtts", 0};
const char * realRealRel_GEAtts[4] = {"realRealRel_GEAtts", 0};
const char * realRealRel_GTAtts[4] = {"realRealRel_GTAtts", 0};
const char * realRealRel_LEAtts[4] = {"realRealRel_LEAtts", 0};
const char * realRealRel_LTAtts[4] = {"realRealRel_LTAtts", 0};
const char * realRealRel_NEAtts[4] = {"realRealRel_NEAtts", 0};
const char * realRelSubs[5] = {"realRelSubs", 0};
const char * realValSubs[6] = {"realValSubs", 0};
const char * realVarAtts[4] = {"realVarAtts", 0};
const char * realVecExpr_TIMESAtts[4] = {"realVecExpr_TIMESAtts", 0};
const char * recallDMLStmAtts[4] = {"recallDMLStmAtts", 0};
const char * recallDatumStmAtts[4] = {"recallDatumStmAtts", 0};
const char * recallFeatureStmAtts[4] = {"recallFeatureStmAtts", 0};
const char * recallRotaryTableStmAtts[4] = {"recallRotaryTableStmAtts", 0};
const char * recallSensorStmAtts[4] = {"recallSensorStmAtts", 0};
const char * refmntStmAtts[6] = {"refmntStmAtts", 0};
const char * rentValSubs[4] = {"rentValSubs", 0};
const char * reportItemSubs[12] = {"reportItemSubs", 0};
const char * reportItem_qisLabelAtts[3] = {"reportItem_qisLabelAtts", 0};
const char * reportStmAtts[5] = {"reportStmAtts", 0};
const char * resumeMinorSubs[8] = {"resumeMinorSubs", 0};
const char * resumeMinor_jumpLabelAtts[3] = {"resumeMinor_jumpLabelAtts", 0};
const char * resumeStmAtts[3] = {"resumeStmAtts", 0};
const char * retrieve1Atts[4] = {"retrieve1Atts", 0};
const char * retrieve2Atts[5] = {"retrieve2Atts", 0};
const char * retrieve2bAtts[5] = {"retrieve2bAtts", 0};
const char * retrieve4Atts[7] = {"retrieve4Atts", 0};
const char * rightyLeftySubs[4] = {"rightyLeftySubs", 0};
const char * rmLabelAtts[3] = {"rmLabelAtts", 0};
const char * rmeasArcSubs[4] = {"rmeasArcSubs", 0};
const char * rmeasArc_rmeasSpecFaAtts[5] = {"rmeasArc_rmeasSpecFaAtts", 0};
const char * rmeasArc_rmeasSpecVecbldAtts[5] = {"rmeasArc_rmeasSpecVecbldAtts", 0};
const char * rmeasCircleSubs[4] = {"rmeasCircleSubs", 0};
const char * rmeasCircle_rmeasSpecFaAtts[5] = {"rmeasCircle_rmeasSpecFaAtts", 0};
const char * rmeasCircle_rmeasSpecVecbldAtts[5] = {"rmeasCircle_rmeasSpecVecbldAtts", 0};
const char * rmeasConeAtts[5] = {"rmeasConeAtts", 0};
const char * rmeasCparlnSubs[4] = {"rmeasCparlnSubs", 0};
const char * rmeasCparln_rmeasSpecFaOrientAtts[5] = {"rmeasCparln_rmeasSpecFaOrientAtts", 0};
const char * rmeasCparln_rmeasSpecVecbldOrientAtts[5] = {"rmeasCparln_rmeasSpecVecbldOrientAtts", 0};
const char * rmeasCylndrAtts[5] = {"rmeasCylndrAtts", 0};
const char * rmeasEdgeptSubs[4] = {"rmeasEdgeptSubs", 0};
const char * rmeasEdgept_rmeasSpecFaAxisAtts[5] = {"rmeasEdgept_rmeasSpecFaAxisAtts", 0};
const char * rmeasEdgept_rmeasSpecVecbldEdgeptAtts[5] = {"rmeasEdgept_rmeasSpecVecbldEdgeptAtts", 0};
const char * rmeasEllipsSubs[4] = {"rmeasEllipsSubs", 0};
const char * rmeasEllips_rmeasSpecFaAtts[5] = {"rmeasEllips_rmeasSpecFaAtts", 0};
const char * rmeasEllips_rmeasSpecVecbldAtts[5] = {"rmeasEllips_rmeasSpecVecbldAtts", 0};
const char * rmeasGcurveSubs[4] = {"rmeasGcurveSubs", 0};
const char * rmeasGcurve_rmeasSpecFeatAxisAtts[5] = {"rmeasGcurve_rmeasSpecFeatAxisAtts", 0};
const char * rmeasGcurve_rmeasSpecVecbldAtts[5] = {"rmeasGcurve_rmeasSpecVecbldAtts", 0};
const char * rmeasGsurfAtts[5] = {"rmeasGsurfAtts", 0};
const char * rmeasLineSubs[4] = {"rmeasLineSubs", 0};
const char * rmeasLine_rmeasSpecFeatAxisAtts[5] = {"rmeasLine_rmeasSpecFeatAxisAtts", 0};
const char * rmeasLine_rmeasSpecVecbldAtts[5] = {"rmeasLine_rmeasSpecVecbldAtts", 0};
const char * rmeasMinorSubs[20] = {"rmeasMinorSubs", 0};
const char * rmeasObjectSubs[4] = {"rmeasObjectSubs", 0};
const char * rmeasObject_rmeasSpecFaAtts[5] = {"rmeasObject_rmeasSpecFaAtts", 0};
const char * rmeasObject_rmeasSpecVecbldAtts[5] = {"rmeasObject_rmeasSpecVecbldAtts", 0};
const char * rmeasParplnAtts[5] = {"rmeasParplnAtts", 0};
const char * rmeasPlaneAtts[5] = {"rmeasPlaneAtts", 0};
const char * rmeasPointSubs[4] = {"rmeasPointSubs", 0};
const char * rmeasPoint_rmeasSpecFaAxisAtts[5] = {"rmeasPoint_rmeasSpecFaAxisAtts", 0};
const char * rmeasPoint_rmeasSpecVecbldAtts[5] = {"rmeasPoint_rmeasSpecVecbldAtts", 0};
const char * rmeasRctnglAtts[5] = {"rmeasRctnglAtts", 0};
const char * rmeasSpecFaSubs[3] = {"rmeasSpecFaSubs", 0};
const char * rmeasSpecFaAxisSubs[4] = {"rmeasSpecFaAxisSubs", 0};
const char * rmeasSpecFaAxis_axisAtts[3] = {"rmeasSpecFaAxis_axisAtts", 0};
const char * rmeasSpecFaAxis_faLabelAtts[4] = {"rmeasSpecFaAxis_faLabelAtts", 0};
const char * rmeasSpecFaOrientAtts[4] = {"rmeasSpecFaOrientAtts", 0};
const char * rmeasSpecFeatAxisSubs[4] = {"rmeasSpecFeatAxisSubs", 0};
const char * rmeasSpecFeatAxis_axisAtts[3] = {"rmeasSpecFeatAxis_axisAtts", 0};
const char * rmeasSpecFeatAxis_featureLabel1Atts[4] = {"rmeasSpecFeatAxis_featureLabel1Atts", 0};
const char * rmeasSpecVecbldAtts[4] = {"rmeasSpecVecbldAtts", 0};
const char * rmeasSpecVecbldEdgeptAtts[6] = {"rmeasSpecVecbldEdgeptAtts", 0};
const char * rmeasSpecVecbldOrientAtts[4] = {"rmeasSpecVecbldOrientAtts", 0};
const char * rmeasSphereAtts[5] = {"rmeasSphereAtts", 0};
const char * rmeasStmAtts[3] = {"rmeasStmAtts", 0};
const char * rmeasSymplnAtts[5] = {"rmeasSymplnAtts", 0};
const char * rmeasTorusAtts[5] = {"rmeasTorusAtts", 0};
const char * rotAbsAtts[3] = {"rotAbsAtts", 0};
const char * rotDirSubs[4] = {"rotDirSubs", 0};
const char * rotDir_rotOrientAtts[3] = {"rotDir_rotOrientAtts", 0};
const char * rotIncrAtts[3] = {"rotIncrAtts", 0};
const char * rotOrientSubs[4] = {"rotOrientSubs", 0};
const char * rotTypeSubs[5] = {"rotTypeSubs", 0};
const char * rotabAbsAtts[7] = {"rotabAbsAtts", 0};
const char * rotabFeatAtts[6] = {"rotabFeatAtts", 0};
const char * rotabIncrAtts[7] = {"rotabIncrAtts", 0};
const char * rotabMinorSubs[5] = {"rotabMinorSubs", 0};
const char * rotabStmAtts[3] = {"rotabStmAtts", 0};
const char * rotateDatumAtts[5] = {"rotateDatumAtts", 0};
const char * rotateFeatureAtts[5] = {"rotateFeatureAtts", 0};
const char * rotateMinorSubs[5] = {"rotateMinorSubs", 0};
const char * rotateStmAtts[4] = {"rotateStmAtts", 0};
const char * rotateValueAtts[4] = {"rotateValueAtts", 0};
const char * rotdefStmAtts[5] = {"rotdefStmAtts", 0};
const char * rotsetStmAtts[4] = {"rotsetStmAtts", 0};
const char * rtLabelAtts[3] = {"rtLabelAtts", 0};
const char * rwFormatAtts[4] = {"rwFormatAtts", 0};
const char * rwVarSubs[7] = {"rwVarSubs", 0};
const char * sLabelAtts[3] = {"sLabelAtts", 0};
const char * saLabelAtts[3] = {"saLabelAtts", 0};
const char * saveDMLStmAtts[4] = {"saveDMLStmAtts", 0};
const char * saveDatumStmAtts[4] = {"saveDatumStmAtts", 0};
const char * saveFeatureStmAtts[4] = {"saveFeatureStmAtts", 0};
const char * saveRotaryTableStmAtts[4] = {"saveRotaryTableStmAtts", 0};
const char * saveSensorStmAtts[4] = {"saveSensorStmAtts", 0};
const char * scnmodStmAtts[3] = {"scnmodStmAtts", 0};
const char * scnsetDragAtts[3] = {"scnsetDragAtts", 0};
const char * scnsetMinorSubs[7] = {"scnsetMinorSubs", 0};
const char * scnsetNonconAtts[3] = {"scnsetNonconAtts", 0};
const char * scnsetPeckAtts[3] = {"scnsetPeckAtts", 0};
const char * scnsetSampleSubs[7] = {"scnsetSampleSubs", 0};
const char * scnsetSampleDragSubs[7] = {"scnsetSampleDragSubs", 0};
const char * scnsetSampleDrag_ANGLEAtts[4] = {"scnsetSampleDrag_ANGLEAtts", 0};
const char * scnsetSampleDrag_CHORDAtts[5] = {"scnsetSampleDrag_CHORDAtts", 0};
const char * scnsetSampleDrag_DEFALTAtts[3] = {"scnsetSampleDrag_DEFALTAtts", 0};
const char * scnsetSampleDrag_DISTAtts[5] = {"scnsetSampleDrag_DISTAtts", 0};
const char * scnsetSampleDrag_TIMEAtts[4] = {"scnsetSampleDrag_TIMEAtts", 0};
const char * scnsetSample_ANGLEAtts[3] = {"scnsetSample_ANGLEAtts", 0};
const char * scnsetSample_CHORDAtts[4] = {"scnsetSample_CHORDAtts", 0};
const char * scnsetSample_DISTAtts[4] = {"scnsetSample_DISTAtts", 0};
const char * scnsetSample_TIMEAtts[3] = {"scnsetSample_TIMEAtts", 0};
const char * scnsetStmAtts[3] = {"scnsetStmAtts", 0};
const char * scnsetStopSubs[4] = {"scnsetStopSubs", 0};
const char * scnsetStopPlaneAtts[5] = {"scnsetStopPlaneAtts", 0};
const char * scnsetStopSphereAtts[3] = {"scnsetStopSphereAtts", 0};
const char * scnsetVendorSubs[5] = {"scnsetVendorSubs", 0};
const char * seLabelAtts[3] = {"seLabelAtts", 0};
const char * secondsStringSubs[4] = {"secondsStringSubs", 0};
const char * secondsString_INTSTRINGAtts[3] = {"secondsString_INTSTRINGAtts", 0};
const char * secondsString_REALSTRINGAtts[3] = {"secondsString_REALSTRINGAtts", 0};
const char * selectBlockAtts[6] = {"selectBlockAtts", 0};
const char * selectStmSubs[4] = {"selectStmSubs", 0};
const char * selectStmIntAtts[3] = {"selectStmIntAtts", 0};
const char * selectStmStringAtts[3] = {"selectStmStringAtts", 0};
const char * sensorAreaAtts[7] = {"sensorAreaAtts", 0};
const char * sensorGeometryAtts[5] = {"sensorGeometryAtts", 0};
const char * sensorInfredAtts[8] = {"sensorInfredAtts", 0};
const char * sensorItemSubs[4] = {"sensorItemSubs", 0};
const char * sensorItem_intValAtts[5] = {"sensorItem_intValAtts", 0};
const char * sensorItem_stringValAtts[5] = {"sensorItem_stringValAtts", 0};
const char * sensorLabel1Subs[4] = {"sensorLabel1Subs", 0};
const char * sensorLabel2Subs[4] = {"sensorLabel2Subs", 0};
const char * sensorLaserAtts[6] = {"sensorLaserAtts", 0};
const char * sensorLineAtts[6] = {"sensorLineAtts", 0};
const char * sensorMinorSubs[11] = {"sensorMinorSubs", 0};
const char * sensorMltprbAtts[5] = {"sensorMltprbAtts", 0};
const char * sensorMltprbItemSubs[4] = {"sensorMltprbItemSubs", 0};
const char * sensorMltprbItem_intValAtts[4] = {"sensorMltprbItem_intValAtts", 0};
const char * sensorMltprbItem_stringValAtts[4] = {"sensorMltprbItem_stringValAtts", 0};
const char * sensorMoveSubs[5] = {"sensorMoveSubs", 0};
const char * sensorMove_gotoWristListAtts[3] = {"sensorMove_gotoWristListAtts", 0};
const char * sensorMove_probeOrientAtts[3] = {"sensorMove_probeOrientAtts", 0};
const char * sensorMove_saLabelAtts[3] = {"sensorMove_saLabelAtts", 0};
const char * sensorNonconAtts[5] = {"sensorNonconAtts", 0};
const char * sensorPointAtts[5] = {"sensorPointAtts", 0};
const char * sensorProbeAtts[5] = {"sensorProbeAtts", 0};
const char * sensorProbeFormSubs[5] = {"sensorProbeFormSubs", 0};
const char * sensorProbeForm_CYLNDRAtts[3] = {"sensorProbeForm_CYLNDRAtts", 0};
const char * sensorProbeForm_DISKAtts[3] = {"sensorProbeForm_DISKAtts", 0};
const char * sensorProbeGeometryAtts[5] = {"sensorProbeGeometryAtts", 0};
const char * sensorStmAtts[4] = {"sensorStmAtts", 0};
const char * sensorVideoAtts[7] = {"sensorVideoAtts", 0};
const char * sgLabelAtts[3] = {"sgLabelAtts", 0};
const char * sgageConstAtts[3] = {"sgageConstAtts", 0};
const char * sgsLabelAtts[3] = {"sgsLabelAtts", 0};
const char * signSubs[4] = {"signSubs", 0};
const char * simreqtBlockAtts[5] = {"simreqtBlockAtts", 0};
const char * simreqtMinorSubs[4] = {"simreqtMinorSubs", 0};
const char * simreqtStmAtts[4] = {"simreqtStmAtts", 0};
const char * snsdefBuildAtts[4] = {"snsdefBuildAtts", 0};
const char * snsdefBuildItemSubs[6] = {"snsdefBuildItemSubs", 0};
const char * snsdefBuildItem_rmLabelAtts[3] = {"snsdefBuildItem_rmLabelAtts", 0};
const char * snsdefBuildItem_sgLabelAtts[3] = {"snsdefBuildItem_sgLabelAtts", 0};
const char * snsdefBuildItem_swLabelAtts[4] = {"snsdefBuildItem_swLabelAtts", 0};
const char * snsdefBuildItem_sxLabelAtts[3] = {"snsdefBuildItem_sxLabelAtts", 0};
const char * snsdefBuildSensorSubs[4] = {"snsdefBuildSensorSubs", 0};
const char * snsdefInfredAtts[8] = {"snsdefInfredAtts", 0};
const char * snsdefLaserAtts[6] = {"snsdefLaserAtts", 0};
const char * snsdefLocationSubs[5] = {"snsdefLocationSubs", 0};
const char * snsdefLocation_CARTAtts[4] = {"snsdefLocation_CARTAtts", 0};
const char * snsdefLocation_POLAtts[5] = {"snsdefLocation_POLAtts", 0};
const char * snsdefLocation_VECAtts[4] = {"snsdefLocation_VECAtts", 0};
const char * snsdefMinorSubs[8] = {"snsdefMinorSubs", 0};
const char * snsdefNonconAtts[5] = {"snsdefNonconAtts", 0};
const char * snsdefProbeAtts[6] = {"snsdefProbeAtts", 0};
const char * snsdefProbeFormSubs[5] = {"snsdefProbeFormSubs", 0};
const char * snsdefProbeForm_CYLNDRAtts[3] = {"snsdefProbeForm_CYLNDRAtts", 0};
const char * snsdefProbeForm_DISKAtts[3] = {"snsdefProbeForm_DISKAtts", 0};
const char * snsdefStmAtts[4] = {"snsdefStmAtts", 0};
const char * snsdefTypeSubs[4] = {"snsdefTypeSubs", 0};
const char * snsdefVideoAtts[7] = {"snsdefVideoAtts", 0};
const char * snsdefWristAngleItemAtts[4] = {"snsdefWristAngleItemAtts", 0};
const char * snsetFeatSubs[5] = {"snsetFeatSubs", 0};
const char * snsetItemSubs[9] = {"snsetItemSubs", 0};
const char * snsetItem_CLRSRFAtts[4] = {"snsetItem_CLRSRFAtts", 0};
const char * snsetItem_DEPTHAtts[4] = {"snsetItem_DEPTHAtts", 0};
const char * snsetItem_snsetLabelAtts[3] = {"snsetItem_snsetLabelAtts", 0};
const char * snsetItem_snsetLabelAndValueAtts[3] = {"snsetItem_snsetLabelAndValueAtts", 0};
const char * snsetItem_snsetToggleAtts[3] = {"snsetItem_snsetToggleAtts", 0};
const char * snsetItem_snsetTypeAtts[3] = {"snsetItem_snsetTypeAtts", 0};
const char * snsetItem_snsetTypeAndValueAtts[3] = {"snsetItem_snsetTypeAndValueAtts", 0};
const char * snsetLabelSubs[5] = {"snsetLabelSubs", 0};
const char * snsetLabelAndValueAtts[4] = {"snsetLabelAndValueAtts", 0};
const char * snsetStmAtts[3] = {"snsetStmAtts", 0};
const char * snsetToggleSubs[4] = {"snsetToggleSubs", 0};
const char * snsetTypeSubs[4] = {"snsetTypeSubs", 0};
const char * snsetTypeAndValueSubs[10] = {"snsetTypeAndValueSubs", 0};
const char * snsetTypeAndValue_APPRCHAtts[3] = {"snsetTypeAndValue_APPRCHAtts", 0};
const char * snsetTypeAndValue_CLRSRFAtts[3] = {"snsetTypeAndValue_CLRSRFAtts", 0};
const char * snsetTypeAndValue_DEPTHAtts[3] = {"snsetTypeAndValue_DEPTHAtts", 0};
const char * snsetTypeAndValue_MINCONAtts[3] = {"snsetTypeAndValue_MINCONAtts", 0};
const char * snsetTypeAndValue_RETRCTAtts[3] = {"snsetTypeAndValue_RETRCTAtts", 0};
const char * snsetTypeAndValue_SCALEXAtts[3] = {"snsetTypeAndValue_SCALEXAtts", 0};
const char * snsetTypeAndValue_SCALEYAtts[3] = {"snsetTypeAndValue_SCALEYAtts", 0};
const char * snsetTypeAndValue_SEARCHAtts[3] = {"snsetTypeAndValue_SEARCHAtts", 0};
const char * snsgrpItemSubs[6] = {"snsgrpItemSubs", 0};
const char * snsgrpMinorSubs[4] = {"snsgrpMinorSubs", 0};
const char * snsgrpMinor_sgsLabelAtts[4] = {"snsgrpMinor_sgsLabelAtts", 0};
const char * snsgrpMinor_ssLabelAtts[4] = {"snsgrpMinor_ssLabelAtts", 0};
const char * snsgrpStmAtts[4] = {"snsgrpStmAtts", 0};
const char * snslctDataSubs[4] = {"snslctDataSubs", 0};
const char * snslctData_probeOrientAtts[3] = {"snslctData_probeOrientAtts", 0};
const char * snslctData_snslctWristListAtts[3] = {"snslctData_snslctWristListAtts", 0};
const char * snslctGroupSubs[4] = {"snslctGroupSubs", 0};
const char * snslctGroupFeatAtts[5] = {"snslctGroupFeatAtts", 0};
const char * snslctGroupVecAtts[5] = {"snslctGroupVecAtts", 0};
const char * snslctSensorSubs[4] = {"snslctSensorSubs", 0};
const char * snslctSensorListAtts[4] = {"snslctSensorListAtts", 0};
const char * snslctSensorTipAtts[5] = {"snslctSensorTipAtts", 0};
const char * snslctStmSubs[4] = {"snslctStmSubs", 0};
const char * snslctStmGroupAtts[3] = {"snslctStmGroupAtts", 0};
const char * snslctStmSensorAtts[3] = {"snslctStmSensorAtts", 0};
const char * snslctTipDataSubs[4] = {"snslctTipDataSubs", 0};
const char * snslctWristAngleAngleAtts[4] = {"snslctWristAngleAngleAtts", 0};
const char * snslctWristAngleFeatAtts[5] = {"snslctWristAngleFeatAtts", 0};
const char * snslctWristAngleItemSubs[5] = {"snslctWristAngleItemSubs", 0};
const char * snslctWristAngleVecAtts[5] = {"snslctWristAngleVecAtts", 0};
const char * snslctWristItemAtts[4] = {"snslctWristItemAtts", 0};
const char * snsmntMinorAtts[5] = {"snsmntMinorAtts", 0};
const char * snsmntStmAtts[3] = {"snsmntStmAtts", 0};
const char * spartConstAtts[3] = {"spartConstAtts", 0};
const char * srLabelAtts[3] = {"srLabelAtts", 0};
const char * sraLabelAtts[3] = {"sraLabelAtts", 0};
const char * ssLabelAtts[3] = {"ssLabelAtts", 0};
const char * stLabelAtts[3] = {"stLabelAtts", 0};
const char * stackElementSubs[6] = {"stackElementSubs", 0};
const char * stateSubs[4] = {"stateSubs", 0};
const char * storageSpecSubs[6] = {"storageSpecSubs", 0};
const char * strVar7Atts[4] = {"strVar7Atts", 0};
const char * stringConstAtts[3] = {"stringConstAtts", 0};
const char * stringFuncSubs[19] = {"stringFuncSubs", 0};
const char * stringFuncChrAtts[3] = {"stringFuncChrAtts", 0};
const char * stringFuncConcatAtts[4] = {"stringFuncConcatAtts", 0};
const char * stringFuncElemntAtts[5] = {"stringFuncElemntAtts", 0};
const char * stringFuncLwcAtts[3] = {"stringFuncLwcAtts", 0};
const char * stringFuncRptAtts[4] = {"stringFuncRptAtts", 0};
const char * stringFuncSelapsetimeAtts[5] = {"stringFuncSelapsetimeAtts", 0};
const char * stringFuncStrAtts[4] = {"stringFuncStrAtts", 0};
const char * stringFuncSubstrAtts[5] = {"stringFuncSubstrAtts", 0};
const char * stringFuncTrimAtts[3] = {"stringFuncTrimAtts", 0};
const char * stringFuncUpcAtts[3] = {"stringFuncUpcAtts", 0};
const char * stringRelSubs[8] = {"stringRelSubs", 0};
const char * stringRel_EQAtts[4] = {"stringRel_EQAtts", 0};
const char * stringRel_GEAtts[4] = {"stringRel_GEAtts", 0};
const char * stringRel_GTAtts[4] = {"stringRel_GTAtts", 0};
const char * stringRel_LEAtts[4] = {"stringRel_LEAtts", 0};
const char * stringRel_LTAtts[4] = {"stringRel_LTAtts", 0};
const char * stringRel_NEAtts[4] = {"stringRel_NEAtts", 0};
const char * stringValSubs[5] = {"stringValSubs", 0};
const char * stringVarAtts[4] = {"stringVarAtts", 0};
const char * surfPtdataHeadcsListItemAtts[8] = {"surfPtdataHeadcsListItemAtts", 0};
const char * surfPtdataListItemAtts[5] = {"surfPtdataListItemAtts", 0};
const char * surfPtdataPcsListItemAtts[6] = {"surfPtdataPcsListItemAtts", 0};
const char * swLabelAtts[3] = {"swLabelAtts", 0};
const char * sxLabelAtts[3] = {"sxLabelAtts", 0};
const char * tLabelAtts[3] = {"tLabelAtts", 0};
const char * taLabelAtts[3] = {"taLabelAtts", 0};
const char * tantoConstSubs[4] = {"tantoConstSubs", 0};
const char * tantoConstFAtts[4] = {"tantoConstFAtts", 0};
const char * tantoConstFaAtts[5] = {"tantoConstFaAtts", 0};
const char * tantoConstPlaneSubs[4] = {"tantoConstPlaneSubs", 0};
const char * tantoConstPlaneFAtts[4] = {"tantoConstPlaneFAtts", 0};
const char * tantoConstPlaneFaAtts[4] = {"tantoConstPlaneFaAtts", 0};
const char * tecompDatumAtts[3] = {"tecompDatumAtts", 0};
const char * tecompMinorSubs[6] = {"tecompMinorSubs", 0};
const char * tecompMinorMachAtts[3] = {"tecompMinorMachAtts", 0};
const char * tecompMinorOnAllAtts[5] = {"tecompMinorOnAllAtts", 0};
const char * tecompMinorOnListAtts[6] = {"tecompMinorOnListAtts", 0};
const char * tecompOffsetAtts[5] = {"tecompOffsetAtts", 0};
const char * tecompStmAtts[3] = {"tecompStmAtts", 0};
const char * tecompVar2Subs[4] = {"tecompVar2Subs", 0};
const char * tempUnitSubs[4] = {"tempUnitSubs", 0};
const char * textManAtts[3] = {"textManAtts", 0};
const char * textMinorSubs[6] = {"textMinorSubs", 0};
const char * textOperAtts[3] = {"textOperAtts", 0};
const char * textOutfilAtts[3] = {"textOutfilAtts", 0};
const char * textQueryAtts[4] = {"textQueryAtts", 0};
const char * textQueryFormatAtts[6] = {"textQueryFormatAtts", 0};
const char * textStmAtts[3] = {"textStmAtts", 0};
const char * textTypeSubs[5] = {"textTypeSubs", 0};
const char * thLabelAtts[3] = {"thLabelAtts", 0};
const char * thldefPocketSubs[9] = {"thldefPocketSubs", 0};
const char * thldefPocket_rmLabelAtts[4] = {"thldefPocket_rmLabelAtts", 0};
const char * thldefPocket_sLabelAtts[4] = {"thldefPocket_sLabelAtts", 0};
const char * thldefPocket_sgLabelAtts[4] = {"thldefPocket_sgLabelAtts", 0};
const char * thldefPocket_sgsLabelAtts[4] = {"thldefPocket_sgsLabelAtts", 0};
const char * thldefPocket_ssLabelAtts[4] = {"thldefPocket_ssLabelAtts", 0};
const char * thldefPocket_swLabelAtts[4] = {"thldefPocket_swLabelAtts", 0};
const char * thldefPocket_sxLabelAtts[4] = {"thldefPocket_sxLabelAtts", 0};
const char * thldefStmAtts[4] = {"thldefStmAtts", 0};
const char * tierSubs[4] = {"tierSubs", 0};
const char * tlLabelAtts[3] = {"tlLabelAtts", 0};
const char * tolAnglStmAtts[5] = {"tolAnglStmAtts", 0};
const char * tolAnglbStmAtts[7] = {"tolAnglbStmAtts", 0};
const char * tolAnglrStmAtts[5] = {"tolAnglrStmAtts", 0};
const char * tolAnglwrtStmAtts[8] = {"tolAnglwrtStmAtts", 0};
const char * tolAppDataAtts[8] = {"tolAppDataAtts", 0};
const char * tolCirltyStmAtts[4] = {"tolCirltyStmAtts", 0};
const char * tolCompos1Atts[7] = {"tolCompos1Atts", 0};
const char * tolCompos2Atts[7] = {"tolCompos2Atts", 0};
const char * tolComposStmAtts[5] = {"tolComposStmAtts", 0};
const char * tolConcenStmAtts[5] = {"tolConcenStmAtts", 0};
const char * tolCortolAngleAtts[4] = {"tolCortolAngleAtts", 0};
const char * tolCortolAxisAtts[6] = {"tolCortolAxisAtts", 0};
const char * tolCortolMinorSubs[5] = {"tolCortolMinorSubs", 0};
const char * tolCortolRadialAtts[4] = {"tolCortolRadialAtts", 0};
const char * tolCortolStmAtts[4] = {"tolCortolStmAtts", 0};
const char * tolCprofSpecAtts[8] = {"tolCprofSpecAtts", 0};
const char * tolCprofSpecCAtts[8] = {"tolCprofSpecCAtts", 0};
const char * tolCproflStmAtts[5] = {"tolCproflStmAtts", 0};
const char * tolCprofsStmAtts[5] = {"tolCprofsStmAtts", 0};
const char * tolCrnoutStmAtts[8] = {"tolCrnoutStmAtts", 0};
const char * tolCylctyStmAtts[4] = {"tolCylctyStmAtts", 0};
const char * tolDiamAvgAtts[5] = {"tolDiamAvgAtts", 0};
const char * tolDiamMinmaxAtts[5] = {"tolDiamMinmaxAtts", 0};
const char * tolDiamMinorSubs[5] = {"tolDiamMinorSubs", 0};
const char * tolDiamPlainAtts[5] = {"tolDiamPlainAtts", 0};
const char * tolDiamStmAtts[4] = {"tolDiamStmAtts", 0};
const char * tolDistbDirSubs[6] = {"tolDistbDirSubs", 0};
const char * tolDistbLimitAtts[4] = {"tolDistbLimitAtts", 0};
const char * tolDistbNominlAtts[5] = {"tolDistbNominlAtts", 0};
const char * tolDistbStmAtts[6] = {"tolDistbStmAtts", 0};
const char * tolDistbTolSubs[4] = {"tolDistbTolSubs", 0};
const char * tolDistwrtStmAtts[7] = {"tolDistwrtStmAtts", 0};
const char * tolFeatMaxMatSubs[5] = {"tolFeatMaxMatSubs", 0};
const char * tolFeatMaxMat_datLabelAtts[4] = {"tolFeatMaxMat_datLabelAtts", 0};
const char * tolFeatMaxMat_fLabelAtts[3] = {"tolFeatMaxMat_fLabelAtts", 0};
const char * tolFeatMaxMat_faLabelAtts[4] = {"tolFeatMaxMat_faLabelAtts", 0};
const char * tolFeatureSubs[5] = {"tolFeatureSubs", 0};
const char * tolFeatureMatSubs[5] = {"tolFeatureMatSubs", 0};
const char * tolFeatureMat_datLabelAtts[4] = {"tolFeatureMat_datLabelAtts", 0};
const char * tolFeatureMat_fLabelAtts[3] = {"tolFeatureMat_fLabelAtts", 0};
const char * tolFeatureMat_faLabelAtts[4] = {"tolFeatureMat_faLabelAtts", 0};
const char * tolFlatMinorSubs[5] = {"tolFlatMinorSubs", 0};
const char * tolFlatPerAtts[5] = {"tolFlatPerAtts", 0};
const char * tolFlatStmAtts[4] = {"tolFlatStmAtts", 0};
const char * tolFlatZonAtts[3] = {"tolFlatZonAtts", 0};
const char * tolFlatZonPerAtts[6] = {"tolFlatZonPerAtts", 0};
const char * tolGtolRotSubs[10] = {"tolGtolRotSubs", 0};
const char * tolGtolSpecSubs[4] = {"tolGtolSpecSubs", 0};
const char * tolGtolStmAtts[9] = {"tolGtolStmAtts", 0};
const char * tolGtolTransSubs[10] = {"tolGtolTransSubs", 0};
const char * tolMatCondSubs[5] = {"tolMatCondSubs", 0};
const char * tolMaxMatCondSubs[5] = {"tolMaxMatCondSubs", 0};
const char * tolMaxMatCond_LMCAtts[3] = {"tolMaxMatCond_LMCAtts", 0};
const char * tolMaxMatCond_MMCAtts[3] = {"tolMaxMatCond_MMCAtts", 0};
const char * tolParlelStmAtts[4] = {"tolParlelStmAtts", 0};
const char * tolPerpStmAtts[4] = {"tolPerpStmAtts", 0};
const char * tolPosEndAtts[7] = {"tolPosEndAtts", 0};
const char * tolPosMethodSubs[8] = {"tolPosMethodSubs", 0};
const char * tolPosMethod_VECAtts[3] = {"tolPosMethod_VECAtts", 0};
const char * tolPosStartSubs[4] = {"tolPosStartSubs", 0};
const char * tolPosStart_THREEDAtts[3] = {"tolPosStart_THREEDAtts", 0};
const char * tolPosStart_TWODAtts[3] = {"tolPosStart_TWODAtts", 0};
const char * tolPosStmAtts[5] = {"tolPosStmAtts", 0};
const char * tolProflStmAtts[9] = {"tolProflStmAtts", 0};
const char * tolProfpStmAtts[8] = {"tolProfpStmAtts", 0};
const char * tolProfsStmAtts[9] = {"tolProfsStmAtts", 0};
const char * tolRadSpecSubs[4] = {"tolRadSpecSubs", 0};
const char * tolRadStmAtts[7] = {"tolRadStmAtts", 0};
const char * tolStrghtMatAtts[6] = {"tolStrghtMatAtts", 0};
const char * tolStrghtMinorSubs[6] = {"tolStrghtMinorSubs", 0};
const char * tolStrghtPer1Atts[6] = {"tolStrghtPer1Atts", 0};
const char * tolStrghtPer2Atts[7] = {"tolStrghtPer2Atts", 0};
const char * tolStrghtPlainAtts[5] = {"tolStrghtPlainAtts", 0};
const char * tolStrghtStmAtts[4] = {"tolStrghtStmAtts", 0};
const char * tolSymStmAtts[6] = {"tolSymStmAtts", 0};
const char * tolTrnoutStmAtts[7] = {"tolTrnoutStmAtts", 0};
const char * tolUsetolStmAtts[4] = {"tolUsetolStmAtts", 0};
const char * tolWidthDirSubs[5] = {"tolWidthDirSubs", 0};
const char * tolWidthDir_vectorAtts[3] = {"tolWidthDir_vectorAtts", 0};
const char * tolWidthStmAtts[7] = {"tolWidthStmAtts", 0};
const char * tolZoneDirSubs[6] = {"tolZoneDirSubs", 0};
const char * tolZoneDir2Subs[6] = {"tolZoneDir2Subs", 0};
const char * tolZoneDir2_VECAtts[3] = {"tolZoneDir2_VECAtts", 0};
const char * tolZoneDir3Subs[6] = {"tolZoneDir3Subs", 0};
const char * tolZoneDir3_VECAtts[3] = {"tolZoneDir3_VECAtts", 0};
const char * tolZoneDir_VECAtts[3] = {"tolZoneDir_VECAtts", 0};
const char * tolZoneTypeSubs[4] = {"tolZoneTypeSubs", 0};
const char * toleranceLabelSubs[4] = {"toleranceLabelSubs", 0};
const char * tooldfStmAtts[5] = {"tooldfStmAtts", 0};
const char * touchSpecSubs[4] = {"touchSpecSubs", 0};
const char * trConstAtts[4] = {"trConstAtts", 0};
const char * transDatumAtts[4] = {"transDatumAtts", 0};
const char * transFeatureAtts[4] = {"transFeatureAtts", 0};
const char * transMinorSubs[6] = {"transMinorSubs", 0};
const char * transProbeSubs[4] = {"transProbeSubs", 0};
const char * transProbe_MINUSPRBRADAtts[3] = {"transProbe_MINUSPRBRADAtts", 0};
const char * transProbe_PRBRADAtts[3] = {"transProbe_PRBRADAtts", 0};
const char * transStmAtts[6] = {"transStmAtts", 0};
const char * transValueAtts[4] = {"transValueAtts", 0};
const char * typePointSubs[4] = {"typePointSubs", 0};
const char * uLabelAtts[3] = {"uLabelAtts", 0};
const char * uncertMinorSubs[4] = {"uncertMinorSubs", 0};
const char * uncertMinor_ALGORAtts[3] = {"uncertMinor_ALGORAtts", 0};
const char * uncertMinor_stringValAtts[4] = {"uncertMinor_stringValAtts", 0};
const char * uncertVar3Subs[5] = {"uncertVar3Subs", 0};
const char * uncertVar3_DMEAtts[3] = {"uncertVar3_DMEAtts", 0};
const char * uncertVar3_SENSAtts[3] = {"uncertVar3_SENSAtts", 0};
const char * uncertVar3_paramListAtts[3] = {"uncertVar3_paramListAtts", 0};
const char * uncertalgStmAtts[4] = {"uncertalgStmAtts", 0};
const char * uncertsetMinorSubs[4] = {"uncertsetMinorSubs", 0};
const char * uncertsetMinor_ONAtts[4] = {"uncertsetMinor_ONAtts", 0};
const char * uncertsetStmAtts[3] = {"uncertsetStmAtts", 0};
const char * uncertsetVar2Subs[4] = {"uncertsetVar2Subs", 0};
const char * uncertsetVar2_drLabelAtts[3] = {"uncertsetVar2_drLabelAtts", 0};
const char * unitsStmAtts[5] = {"unitsStmAtts", 0};
const char * vLabelAtts[3] = {"vLabelAtts", 0};
const char * vaLabelAtts[3] = {"vaLabelAtts", 0};
const char * valueAclratRealSubs[5] = {"valueAclratRealSubs", 0};
const char * valueAclratStringAtts[3] = {"valueAclratStringAtts", 0};
const char * valueBoundIntSubs[4] = {"valueBoundIntSubs", 0};
const char * valueBoundInt_featureLabelAtts[3] = {"valueBoundInt_featureLabelAtts", 0};
const char * valueBoundInt_toleranceLabelAtts[3] = {"valueBoundInt_toleranceLabelAtts", 0};
const char * valueBoundStringSubs[4] = {"valueBoundStringSubs", 0};
const char * valueBoundString_featureLabelAtts[4] = {"valueBoundString_featureLabelAtts", 0};
const char * valueBoundString_toleranceLabelAtts[4] = {"valueBoundString_toleranceLabelAtts", 0};
const char * valueCzslctAtts[3] = {"valueCzslctAtts", 0};
const char * valueDmismdSubs[4] = {"valueDmismdSubs", 0};
const char * valueDmismnSubs[4] = {"valueDmismnSubs", 0};
const char * valueErrorSubs[4] = {"valueErrorSubs", 0};
const char * valueFaIntAtts[3] = {"valueFaIntAtts", 0};
const char * valueFaRealAtts[4] = {"valueFaRealAtts", 0};
const char * valueFedratRealSubs[6] = {"valueFedratRealSubs", 0};
const char * valueFedratStringAtts[3] = {"valueFedratStringAtts", 0};
const char * valueFilnamSubs[4] = {"valueFilnamSubs", 0};
const char * valueGeoalgAtts[3] = {"valueGeoalgAtts", 0};
const char * valueGotoRealAtts[3] = {"valueGotoRealAtts", 0};
const char * valueKeycharSubs[3] = {"valueKeycharSubs", 0};
const char * valueMinorBoolSubs[11] = {"valueMinorBoolSubs", 0};
const char * valueMinorIntSubs[4] = {"valueMinorIntSubs", 0};
const char * valueMinorRealSubs[13] = {"valueMinorRealSubs", 0};
const char * valueMinorStringSubs[19] = {"valueMinorStringSubs", 0};
const char * valueMinorVectorSubs[5] = {"valueMinorVectorSubs", 0};
const char * valuePtmeasRealAtts[3] = {"valuePtmeasRealAtts", 0};
const char * valueRtSubs[4] = {"valueRtSubs", 0};
const char * valueRt_CCWAtts[3] = {"valueRt_CCWAtts", 0};
const char * valueRt_CWAtts[3] = {"valueRt_CWAtts", 0};
const char * valueSaSubs[5] = {"valueSaSubs", 0};
const char * valueSaDescAtts[4] = {"valueSaDescAtts", 0};
const char * valueSaPlainAtts[3] = {"valueSaPlainAtts", 0};
const char * valueSaTipnumAtts[4] = {"valueSaTipnumAtts", 0};
const char * valueSnsetRealSubs[7] = {"valueSnsetRealSubs", 0};
const char * valueSnsetStringSubs[4] = {"valueSnsetStringSubs", 0};
const char * valueSnsmntSubs[5] = {"valueSnsmntSubs", 0};
const char * valueStmSubs[7] = {"valueStmSubs", 0};
const char * valueStm_boolVarAtts[4] = {"valueStm_boolVarAtts", 0};
const char * valueStm_intVarAtts[4] = {"valueStm_intVarAtts", 0};
const char * valueStm_realVarAtts[4] = {"valueStm_realVarAtts", 0};
const char * valueStm_stringVarAtts[4] = {"valueStm_stringVarAtts", 0};
const char * valueStm_vectorVarAtts[4] = {"valueStm_vectorVarAtts", 0};
const char * valueSwAtts[4] = {"valueSwAtts", 0};
const char * valueTaBoolSubs[4] = {"valueTaBoolSubs", 0};
const char * valueTaBoolIntolAtts[4] = {"valueTaBoolIntolAtts", 0};
const char * valueTaBoolOutolAtts[4] = {"valueTaBoolOutolAtts", 0};
const char * valueTaRealSubs[5] = {"valueTaRealSubs", 0};
const char * valueTaRealActAtts[4] = {"valueTaRealActAtts", 0};
const char * valueTaRealAmtAtts[4] = {"valueTaRealAmtAtts", 0};
const char * valueTaRealDevAtts[4] = {"valueTaRealDevAtts", 0};
const char * valueUnitsSubs[5] = {"valueUnitsSubs", 0};
const char * vecExpr_MINUSAtts[4] = {"vecExpr_MINUSAtts", 0};
const char * vecExpr_PARENAtts[3] = {"vecExpr_PARENAtts", 0};
const char * vecExpr_PLUSAtts[4] = {"vecExpr_PLUSAtts", 0};
const char * vecIntExpr_DIVIDAtts[4] = {"vecIntExpr_DIVIDAtts", 0};
const char * vecIntExpr_TIMESAtts[4] = {"vecIntExpr_TIMESAtts", 0};
const char * vecRealExpr_DIVIDAtts[4] = {"vecRealExpr_DIVIDAtts", 0};
const char * vecRealExpr_TIMESAtts[4] = {"vecRealExpr_TIMESAtts", 0};
const char * vectorAtts[5] = {"vectorAtts", 0};
const char * vectorExprSubs[11] = {"vectorExprSubs", 0};
const char * vectorFuncSubs[8] = {"vectorFuncSubs", 0};
const char * vectorFuncVcartAtts[5] = {"vectorFuncVcartAtts", 0};
const char * vectorFuncVcrossAtts[4] = {"vectorFuncVcrossAtts", 0};
const char * vectorFuncVmcsAtts[3] = {"vectorFuncVmcsAtts", 0};
const char * vectorFuncVpcsAtts[3] = {"vectorFuncVpcsAtts", 0};
const char * vectorFuncVpolAtts[5] = {"vectorFuncVpolAtts", 0};
const char * vectorFuncVunitAtts[3] = {"vectorFuncVunitAtts", 0};
const char * vectorRelSubs[4] = {"vectorRelSubs", 0};
const char * vectorRel_EQAtts[4] = {"vectorRel_EQAtts", 0};
const char * vectorRel_NEAtts[4] = {"vectorRel_NEAtts", 0};
const char * vectorValSubs[5] = {"vectorValSubs", 0};
const char * vectorVarAtts[4] = {"vectorVarAtts", 0};
const char * versionTagAtts[3] = {"versionTagAtts", 0};
const char * vertexConstAtts[3] = {"vertexConstAtts", 0};
const char * vfLabelAtts[3] = {"vfLabelAtts", 0};
const char * vformItemSubs[11] = {"vformItemSubs", 0};
const char * vformItem_ACTAtts[3] = {"vformItem_ACTAtts", 0};
const char * vformItem_AMTAtts[3] = {"vformItem_AMTAtts", 0};
const char * vformItem_DEVAtts[3] = {"vformItem_DEVAtts", 0};
const char * vformItem_DMEAtts[3] = {"vformItem_DMEAtts", 0};
const char * vformItem_HISTAtts[3] = {"vformItem_HISTAtts", 0};
const char * vformItem_NOMAtts[3] = {"vformItem_NOMAtts", 0};
const char * vformItem_PLOTAtts[3] = {"vformItem_PLOTAtts", 0};
const char * vformItem_STATAtts[3] = {"vformItem_STATAtts", 0};
const char * vformStmAtts[4] = {"vformStmAtts", 0};
const char * vlLabelAtts[3] = {"vlLabelAtts", 0};
const char * vwLabelAtts[3] = {"vwLabelAtts", 0};
const char * windefBoxAtts[6] = {"windefBoxAtts", 0};
const char * windefEdgelnAtts[5] = {"windefEdgelnAtts", 0};
const char * windefMinorSubs[4] = {"windefMinorSubs", 0};
const char * windefStmAtts[4] = {"windefStmAtts", 0};
const char * wkplanStmAtts[3] = {"wkplanStmAtts", 0};
const char * wristDataDescSubs[4] = {"wristDataDescSubs", 0};
const char * wristDataDesc_intValAtts[5] = {"wristDataDesc_intValAtts", 0};
const char * wristDataDesc_stringValAtts[5] = {"wristDataDesc_stringValAtts", 0};
const char * wristDefAtts[4] = {"wristDefAtts", 0};
const char * wristMountDefAtts[5] = {"wristMountDefAtts", 0};
const char * wristMountOffsetAtts[3] = {"wristMountOffsetAtts", 0};
const char * wristRotDefAtts[5] = {"wristRotDefAtts", 0};
const char * wristRotLimitSubs[4] = {"wristRotLimitSubs", 0};
const char * wristRotLimit_angleAtts[4] = {"wristRotLimit_angleAtts", 0};
const char * wristRotStepSubs[4] = {"wristRotStepSubs", 0};
const char * wristRotStep_angleAtts[3] = {"wristRotStep_angleAtts", 0};
const char * wristStmAtts[6] = {"wristStmAtts", 0};
const char * writeSpecSubs[5] = {"writeSpecSubs", 0};
const char * writeSpec_rwVarAtts[4] = {"writeSpec_rwVarAtts", 0};
const char * writeSpec_stringConstAtts[3] = {"writeSpec_stringConstAtts", 0};
const char * writeSpec_stringFuncAtts[3] = {"writeSpec_stringFuncAtts", 0};
const char * writeStmAtts[4] = {"writeStmAtts", 0};
const char * xternBlockAtts[5] = {"xternBlockAtts", 0};
const char * xtractStmAtts[4] = {"xtractStmAtts", 0};

/********************************************************************/

void check_aboveBelow(
 aboveBelow * a_aboveBelow,
 int log)
{
  if (isA(a_aboveBelow, aboveBelow_ABOVE))
    {
      adjustLevels(&aboveBelowSubs_aboveBelow_ABOVE, "aboveBelow_ABOVE");
      if (log && !findString("aboveBelow_ABOVE", aboveBelowSubs))
	{
	  warnSub("aboveBelow_ABOVE", "aboveBelow", a_aboveBelow);
	}
      return;
    }
  if (isA(a_aboveBelow, aboveBelow_BELOW))
    {
      adjustLevels(&aboveBelowSubs_aboveBelow_BELOW, "aboveBelow_BELOW");
      if (log && !findString("aboveBelow_BELOW", aboveBelowSubs))
	{
	  warnSub("aboveBelow_BELOW", "aboveBelow", a_aboveBelow);
	}
      return;
    }
}

/********************************************************************/

void check_aclratAngSpec(
 aclratAngSpec * a_aclratAngSpec,
 int log)
{
  if (isA(a_aclratAngSpec, aclratAngular))
    {
      adjustLevels(&aclratAngSpecSubs_aclratAngular, "aclratAngular");
      if (log && !findString("aclratAngular", aclratAngSpecSubs))
	{
	  warnSub("aclratAngular", "aclratAngSpec", a_aclratAngSpec);
	  check_aclratAngular(
	    dynamic_cast<aclratAngular *>(a_aclratAngSpec), 0);
	}
      else
	check_aclratAngular(
	  dynamic_cast<aclratAngular *>(a_aclratAngSpec), log);
      return;
    }
  if (isA(a_aclratAngSpec, aclratDef))
    {
      adjustLevels(&aclratAngSpecSubs_aclratDef, "aclratDef");
      if (log && !findString("aclratDef", aclratAngSpecSubs))
	{
	  warnSub("aclratDef", "aclratAngSpec", a_aclratAngSpec);
	  check_aclratDef(dynamic_cast<aclratDef *>(a_aclratAngSpec), 0);
	}
      else
	check_aclratDef(dynamic_cast<aclratDef *>(a_aclratAngSpec), log);
      return;
    }
}

/********************************************************************/

void check_aclratAngular(
 aclratAngular * a_aclratAngular,
 int log)
{
  if (a_aclratAngular->get_accel())
    {
      adjustLevels(&aclratAngularAtts_accel, "aclratAngular accel");
      if (log && !findString("accel", aclratAngularAtts))
	{
	  warnAtt("accel", "aclratAngular", a_aclratAngular);
	  check_rentVal(a_aclratAngular->get_accel(), 0);
	}
      else
	check_rentVal(a_aclratAngular->get_accel(), log);
    }
}

/********************************************************************/

void check_aclratDef(
 aclratDef * a_aclratDef,
 int log)
{
  if (isA(a_aclratDef, aclratDef_PCENT))
    {
      adjustLevels(&aclratDefSubs_aclratDef_PCENT, "aclratDef_PCENT");
      if (log && !findString("aclratDef_PCENT", aclratDefSubs))
	{
	  warnSub("aclratDef_PCENT", "aclratDef", a_aclratDef);
	  check_aclratDef_PCENT(
	    dynamic_cast<aclratDef_PCENT *>(a_aclratDef), 0);
	}
      else
	check_aclratDef_PCENT(
	  dynamic_cast<aclratDef_PCENT *>(a_aclratDef), log);
      return;
    }
  if (isA(a_aclratDef, aclratDef_HIGH))
    {
      adjustLevels(&aclratDefSubs_aclratDef_HIGH, "aclratDef_HIGH");
      if (log && !findString("aclratDef_HIGH", aclratDefSubs))
	{
	  warnSub("aclratDef_HIGH", "aclratDef", a_aclratDef);
	}
      return;
    }
  if (isA(a_aclratDef, aclratDef_LOW))
    {
      adjustLevels(&aclratDefSubs_aclratDef_LOW, "aclratDef_LOW");
      if (log && !findString("aclratDef_LOW", aclratDefSubs))
	{
	  warnSub("aclratDef_LOW", "aclratDef", a_aclratDef);
	}
      return;
    }
  if (isA(a_aclratDef, aclratDef_DEFALT))
    {
      adjustLevels(&aclratDefSubs_aclratDef_DEFALT, "aclratDef_DEFALT");
      if (log && !findString("aclratDef_DEFALT", aclratDefSubs))
	{
	  warnSub("aclratDef_DEFALT", "aclratDef", a_aclratDef);
	}
      return;
    }
}

/********************************************************************/

void check_aclratDef_PCENT(
 aclratDef_PCENT * a_aclratDef_PCENT,
 int log)
{
  if (a_aclratDef_PCENT->get_accel())
    {
      adjustLevels(&aclratDef_PCENTAtts_accel, "aclratDef_PCENT accel");
      if (log && !findString("accel", aclratDef_PCENTAtts))
	{
	  warnAtt("accel", "aclratDef_PCENT", a_aclratDef_PCENT);
	  check_rentVal(a_aclratDef_PCENT->get_accel(), 0);
	}
      else
	check_rentVal(a_aclratDef_PCENT->get_accel(), log);
    }
}

/********************************************************************/

void check_aclratHedMeas(
 aclratHedMeas * a_aclratHedMeas,
 int log)
{
  if (a_aclratHedMeas->get_aclratLinSpec())
    {
      adjustLevels(&aclratHedMeasAtts_a_aclratLinSpec,
		   "aclratHedMeas a_aclratLinSpec");
      if (log && !findString("a_aclratLinSpec", aclratHedMeasAtts))
	{
	  warnAtt("a_aclratLinSpec", "aclratHedMeas", a_aclratHedMeas);
	  check_aclratLinSpec(a_aclratHedMeas->get_aclratLinSpec(), 0);
	}
      else
	check_aclratLinSpec(a_aclratHedMeas->get_aclratLinSpec(), log);
    }
}

/********************************************************************/

void check_aclratHedRot(
 aclratHedRot * a_aclratHedRot,
 int log)
{
  if (a_aclratHedRot->get_aclratLinSpec())
    {
      adjustLevels(&aclratHedRotAtts_a_aclratLinSpec,
		   "aclratHedRot a_aclratLinSpec");
      if (log && !findString("a_aclratLinSpec", aclratHedRotAtts))
	{
	  warnAtt("a_aclratLinSpec", "aclratHedRot", a_aclratHedRot);
	  check_aclratLinSpec(a_aclratHedRot->get_aclratLinSpec(), 0);
	}
      else
	check_aclratLinSpec(a_aclratHedRot->get_aclratLinSpec(), log);
    }
}

/********************************************************************/

void check_aclratHedScan(
 aclratHedScan * a_aclratHedScan,
 int log)
{
  if (a_aclratHedScan->get_aclratLinSpec())
    {
      adjustLevels(&aclratHedScanAtts_a_aclratLinSpec,
		   "aclratHedScan a_aclratLinSpec");
      if (log && !findString("a_aclratLinSpec", aclratHedScanAtts))
	{
	  warnAtt("a_aclratLinSpec", "aclratHedScan", a_aclratHedScan);
	  check_aclratLinSpec(a_aclratHedScan->get_aclratLinSpec(), 0);
	}
      else
	check_aclratLinSpec(a_aclratHedScan->get_aclratLinSpec(), log);
    }
}

/********************************************************************/

void check_aclratLinSpec(
 aclratLinSpec * a_aclratLinSpec,
 int log)
{
  if (isA(a_aclratLinSpec, aclratLinear))
    {
      adjustLevels(&aclratLinSpecSubs_aclratLinear, "aclratLinear");
      if (log && !findString("aclratLinear", aclratLinSpecSubs))
	{
	  warnSub("aclratLinear", "aclratLinSpec", a_aclratLinSpec);
	  check_aclratLinear(
	    dynamic_cast<aclratLinear *>(a_aclratLinSpec), 0);
	}
      else
	check_aclratLinear(
	  dynamic_cast<aclratLinear *>(a_aclratLinSpec), log);
      return;
    }
  if (isA(a_aclratLinSpec, aclratDef))
    {
      adjustLevels(&aclratLinSpecSubs_aclratDef, "aclratDef");
      if (log && !findString("aclratDef", aclratLinSpecSubs))
	{
	  warnSub("aclratDef", "aclratLinSpec", a_aclratLinSpec);
	  check_aclratDef(dynamic_cast<aclratDef *>(a_aclratLinSpec), 0);
	}
      else
	check_aclratDef(dynamic_cast<aclratDef *>(a_aclratLinSpec), log);
      return;
    }
}

/********************************************************************/

void check_aclratLinear(
 aclratLinear * a_aclratLinear,
 int log)
{
  if (isA(a_aclratLinear, aclratLinear_MPMM))
    {
      adjustLevels(&aclratLinearSubs_aclratLinear_MPMM, "aclratLinear_MPMM");
      if (log && !findString("aclratLinear_MPMM", aclratLinearSubs))
	{
	  warnSub("aclratLinear_MPMM", "aclratLinear", a_aclratLinear);
	  check_aclratLinear_MPMM(
	    dynamic_cast<aclratLinear_MPMM *>(a_aclratLinear), 0);
	}
      else
	check_aclratLinear_MPMM(
	  dynamic_cast<aclratLinear_MPMM *>(a_aclratLinear), log);
      return;
    }
  if (isA(a_aclratLinear, aclratLinear_MMPSS))
    {
      adjustLevels(&aclratLinearSubs_aclratLinear_MMPSS, "aclratLinear_MMPSS");
      if (log && !findString("aclratLinear_MMPSS", aclratLinearSubs))
	{
	  warnSub("aclratLinear_MMPSS", "aclratLinear", a_aclratLinear);
	  check_aclratLinear_MMPSS(
	    dynamic_cast<aclratLinear_MMPSS *>(a_aclratLinear), 0);
	}
      else
	check_aclratLinear_MMPSS(
	  dynamic_cast<aclratLinear_MMPSS *>(a_aclratLinear), log);
      return;
    }
  if (isA(a_aclratLinear, aclratLinear_IPMM))
    {
      adjustLevels(&aclratLinearSubs_aclratLinear_IPMM, "aclratLinear_IPMM");
      if (log && !findString("aclratLinear_IPMM", aclratLinearSubs))
	{
	  warnSub("aclratLinear_IPMM", "aclratLinear", a_aclratLinear);
	  check_aclratLinear_IPMM(
	    dynamic_cast<aclratLinear_IPMM *>(a_aclratLinear), 0);
	}
      else
	check_aclratLinear_IPMM(
	  dynamic_cast<aclratLinear_IPMM *>(a_aclratLinear), log);
      return;
    }
  if (isA(a_aclratLinear, aclratLinear_IPSS))
    {
      adjustLevels(&aclratLinearSubs_aclratLinear_IPSS, "aclratLinear_IPSS");
      if (log && !findString("aclratLinear_IPSS", aclratLinearSubs))
	{
	  warnSub("aclratLinear_IPSS", "aclratLinear", a_aclratLinear);
	  check_aclratLinear_IPSS(
	    dynamic_cast<aclratLinear_IPSS *>(a_aclratLinear), 0);
	}
      else
	check_aclratLinear_IPSS(
	  dynamic_cast<aclratLinear_IPSS *>(a_aclratLinear), log);
      return;
    }
}

/********************************************************************/

void check_aclratLinear_IPMM(
 aclratLinear_IPMM * a_aclratLinear_IPMM,
 int log)
{
  if (a_aclratLinear_IPMM->get_accel())
    {
      adjustLevels(&aclratLinear_IPMMAtts_accel, "aclratLinear_IPMM accel");
      if (log && !findString("accel", aclratLinear_IPMMAtts))
	{
	  warnAtt("accel", "aclratLinear_IPMM", a_aclratLinear_IPMM);
	  check_rentVal(a_aclratLinear_IPMM->get_accel(), 0);
	}
      else
	check_rentVal(a_aclratLinear_IPMM->get_accel(), log);
    }
}

/********************************************************************/

void check_aclratLinear_IPSS(
 aclratLinear_IPSS * a_aclratLinear_IPSS,
 int log)
{
  if (a_aclratLinear_IPSS->get_accel())
    {
      adjustLevels(&aclratLinear_IPSSAtts_accel, "aclratLinear_IPSS accel");
      if (log && !findString("accel", aclratLinear_IPSSAtts))
	{
	  warnAtt("accel", "aclratLinear_IPSS", a_aclratLinear_IPSS);
	  check_rentVal(a_aclratLinear_IPSS->get_accel(), 0);
	}
      else
	check_rentVal(a_aclratLinear_IPSS->get_accel(), log);
    }
}

/********************************************************************/

void check_aclratLinear_MMPSS(
 aclratLinear_MMPSS * a_aclratLinear_MMPSS,
 int log)
{
  if (a_aclratLinear_MMPSS->get_accel())
    {
      adjustLevels(&aclratLinear_MMPSSAtts_accel, "aclratLinear_MMPSS accel");
      if (log && !findString("accel", aclratLinear_MMPSSAtts))
	{
	  warnAtt("accel", "aclratLinear_MMPSS", a_aclratLinear_MMPSS);
	  check_rentVal(a_aclratLinear_MMPSS->get_accel(), 0);
	}
      else
	check_rentVal(a_aclratLinear_MMPSS->get_accel(), log);
    }
}

/********************************************************************/

void check_aclratLinear_MPMM(
 aclratLinear_MPMM * a_aclratLinear_MPMM,
 int log)
{
  if (a_aclratLinear_MPMM->get_accel())
    {
      adjustLevels(&aclratLinear_MPMMAtts_accel, "aclratLinear_MPMM accel");
      if (log && !findString("accel", aclratLinear_MPMMAtts))
	{
	  warnAtt("accel", "aclratLinear_MPMM", a_aclratLinear_MPMM);
	  check_rentVal(a_aclratLinear_MPMM->get_accel(), 0);
	}
      else
	check_rentVal(a_aclratLinear_MPMM->get_accel(), log);
    }
}

/********************************************************************/

void check_aclratMeas(
 aclratMeas * a_aclratMeas,
 int log)
{
  if (a_aclratMeas->get_aclratLinSpec())
    {
      adjustLevels(&aclratMeasAtts_a_aclratLinSpec,
		   "aclratMeas a_aclratLinSpec");
      if (log && !findString("a_aclratLinSpec", aclratMeasAtts))
	{
	  warnAtt("a_aclratLinSpec", "aclratMeas", a_aclratMeas);
	  check_aclratLinSpec(a_aclratMeas->get_aclratLinSpec(), 0);
	}
      else
	check_aclratLinSpec(a_aclratMeas->get_aclratLinSpec(), log);
    }
}

/********************************************************************/

void check_aclratMinor(
 aclratMinor * a_aclratMinor,
 int log)
{
  if (isA(a_aclratMinor, aclratMeas))
    {
      adjustLevels(&aclratMinorSubs_aclratMeas, "aclratMeas");
      if (log && !findString("aclratMeas", aclratMinorSubs))
	{
	  warnSub("aclratMeas", "aclratMinor", a_aclratMinor);
	  check_aclratMeas(dynamic_cast<aclratMeas *>(a_aclratMinor), 0);
	}
      else
	check_aclratMeas(dynamic_cast<aclratMeas *>(a_aclratMinor), log);
      return;
    }
  if (isA(a_aclratMinor, aclratPos))
    {
      adjustLevels(&aclratMinorSubs_aclratPos, "aclratPos");
      if (log && !findString("aclratPos", aclratMinorSubs))
	{
	  warnSub("aclratPos", "aclratMinor", a_aclratMinor);
	  check_aclratPos(dynamic_cast<aclratPos *>(a_aclratMinor), 0);
	}
      else
	check_aclratPos(dynamic_cast<aclratPos *>(a_aclratMinor), log);
      return;
    }
  if (isA(a_aclratMinor, aclratRot))
    {
      adjustLevels(&aclratMinorSubs_aclratRot, "aclratRot");
      if (log && !findString("aclratRot", aclratMinorSubs))
	{
	  warnSub("aclratRot", "aclratMinor", a_aclratMinor);
	  check_aclratRot(dynamic_cast<aclratRot *>(a_aclratMinor), 0);
	}
      else
	check_aclratRot(dynamic_cast<aclratRot *>(a_aclratMinor), log);
      return;
    }
  if (isA(a_aclratMinor, aclratScan))
    {
      adjustLevels(&aclratMinorSubs_aclratScan, "aclratScan");
      if (log && !findString("aclratScan", aclratMinorSubs))
	{
	  warnSub("aclratScan", "aclratMinor", a_aclratMinor);
	  check_aclratScan(dynamic_cast<aclratScan *>(a_aclratMinor), 0);
	}
      else
	check_aclratScan(dynamic_cast<aclratScan *>(a_aclratMinor), log);
      return;
    }
  if (isA(a_aclratMinor, aclratHedRot))
    {
      adjustLevels(&aclratMinorSubs_aclratHedRot, "aclratHedRot");
      if (log && !findString("aclratHedRot", aclratMinorSubs))
	{
	  warnSub("aclratHedRot", "aclratMinor", a_aclratMinor);
	  check_aclratHedRot(
	    dynamic_cast<aclratHedRot *>(a_aclratMinor), 0);
	}
      else
	check_aclratHedRot(
	  dynamic_cast<aclratHedRot *>(a_aclratMinor), log);
      return;
    }
  if (isA(a_aclratMinor, aclratHedMeas))
    {
      adjustLevels(&aclratMinorSubs_aclratHedMeas, "aclratHedMeas");
      if (log && !findString("aclratHedMeas", aclratMinorSubs))
	{
	  warnSub("aclratHedMeas", "aclratMinor", a_aclratMinor);
	  check_aclratHedMeas(
	    dynamic_cast<aclratHedMeas *>(a_aclratMinor), 0);
	}
      else
	check_aclratHedMeas(
	  dynamic_cast<aclratHedMeas *>(a_aclratMinor), log);
      return;
    }
  if (isA(a_aclratMinor, aclratHedScan))
    {
      adjustLevels(&aclratMinorSubs_aclratHedScan, "aclratHedScan");
      if (log && !findString("aclratHedScan", aclratMinorSubs))
	{
	  warnSub("aclratHedScan", "aclratMinor", a_aclratMinor);
	  check_aclratHedScan(
	    dynamic_cast<aclratHedScan *>(a_aclratMinor), 0);
	}
      else
	check_aclratHedScan(
	  dynamic_cast<aclratHedScan *>(a_aclratMinor), log);
      return;
    }
}

/********************************************************************/

void check_aclratPos(
 aclratPos * a_aclratPos,
 int log)
{
  if (a_aclratPos->get_aclratLinSpec())
    {
      adjustLevels(&aclratPosAtts_a_aclratLinSpec,
		   "aclratPos a_aclratLinSpec");
      if (log && !findString("a_aclratLinSpec", aclratPosAtts))
	{
	  warnAtt("a_aclratLinSpec", "aclratPos", a_aclratPos);
	  check_aclratLinSpec(a_aclratPos->get_aclratLinSpec(), 0);
	}
      else
	check_aclratLinSpec(a_aclratPos->get_aclratLinSpec(), log);
    }
}

/********************************************************************/

void check_aclratRot(
 aclratRot * a_aclratRot,
 int log)
{
  if (a_aclratRot->get_aclratAngSpec())
    {
      adjustLevels(&aclratRotAtts_a_aclratAngSpec,
		   "aclratRot a_aclratAngSpec");
      if (log && !findString("a_aclratAngSpec", aclratRotAtts))
	{
	  warnAtt("a_aclratAngSpec", "aclratRot", a_aclratRot);
	  check_aclratAngSpec(a_aclratRot->get_aclratAngSpec(), 0);
	}
      else
	check_aclratAngSpec(a_aclratRot->get_aclratAngSpec(), log);
    }
}

/********************************************************************/

void check_aclratScan(
 aclratScan * a_aclratScan,
 int log)
{
  if (a_aclratScan->get_aclratLinSpec())
    {
      adjustLevels(&aclratScanAtts_a_aclratLinSpec,
		   "aclratScan a_aclratLinSpec");
      if (log && !findString("a_aclratLinSpec", aclratScanAtts))
	{
	  warnAtt("a_aclratLinSpec", "aclratScan", a_aclratScan);
	  check_aclratLinSpec(a_aclratScan->get_aclratLinSpec(), 0);
	}
      else
	check_aclratLinSpec(a_aclratScan->get_aclratLinSpec(), log);
    }
}

/********************************************************************/

void check_aclratStm(
 aclratStm * a_aclratStm,
 int log)
{
  if (a_aclratStm->get_aclratMinor())
    {
      adjustLevels(&aclratStmAtts_a_aclratMinor, "aclratStm a_aclratMinor");
      if (log && !findString("a_aclratMinor", aclratStmAtts))
	{
	  warnAtt("a_aclratMinor", "aclratStm", a_aclratStm);
	  check_aclratMinor(a_aclratStm->get_aclratMinor(), 0);
	}
      else
	check_aclratMinor(a_aclratStm->get_aclratMinor(), log);
    }
}

/********************************************************************/

void check_algdefMinor(
 algdefMinor * a_algdefMinor,
 int log)
{
  if (isA(a_algdefMinor, algdefMinor_CODE))
    {
      adjustLevels(&algdefMinorSubs_algdefMinor_CODE, "algdefMinor_CODE");
      if (log && !findString("algdefMinor_CODE", algdefMinorSubs))
	{
	  warnSub("algdefMinor_CODE", "algdefMinor", a_algdefMinor);
	  check_algdefMinor_CODE(
	    dynamic_cast<algdefMinor_CODE *>(a_algdefMinor), 0);
	}
      else
	check_algdefMinor_CODE(
	  dynamic_cast<algdefMinor_CODE *>(a_algdefMinor), log);
      return;
    }
  if (isA(a_algdefMinor, algdefMinor_stringVal))
    {
      adjustLevels(&algdefMinorSubs_algdefMinor_stringVal,
		   "algdefMinor_stringVal");
      if (log && !findString("algdefMinor_stringVal", algdefMinorSubs))
	{
	  warnSub("algdefMinor_stringVal", "algdefMinor", a_algdefMinor);
	  check_algdefMinor_stringVal(
	    dynamic_cast<algdefMinor_stringVal *>(a_algdefMinor), 0);
	}
      else
	check_algdefMinor_stringVal(
	  dynamic_cast<algdefMinor_stringVal *>(a_algdefMinor), log);
      return;
    }
}

/********************************************************************/

void check_algdefMinor_CODE(
 algdefMinor_CODE * a_algdefMinor_CODE,
 int log)
{
  if (a_algdefMinor_CODE->get_code())
    {
      adjustLevels(&algdefMinor_CODEAtts_code, "algdefMinor_CODE code");
      if (log && !findString("code", algdefMinor_CODEAtts))
	{
	  warnAtt("code", "algdefMinor_CODE", a_algdefMinor_CODE);
	  check_intVal(a_algdefMinor_CODE->get_code(), 0);
	}
      else
	check_intVal(a_algdefMinor_CODE->get_code(), log);
    }
}

/********************************************************************/

void check_algdefMinor_stringVal(
 algdefMinor_stringVal * a_algdefMinor_stringVal,
 int log)
{
  if (a_algdefMinor_stringVal->get_name())
    {
      adjustLevels(&algdefMinor_stringValAtts_name,
		   "algdefMinor_stringVal name");
      if (log && !findString("name", algdefMinor_stringValAtts))
	{
	  warnAtt("name", "algdefMinor_stringVal", a_algdefMinor_stringVal);
	  check_stringVal(a_algdefMinor_stringVal->get_name(), 0);
	}
      else
	check_stringVal(a_algdefMinor_stringVal->get_name(), log);
    }
  if (a_algdefMinor_stringVal->get_paramList())
    {
      std::list<param *> * theList;
      std::list<param *>::iterator iter;
      theList = a_algdefMinor_stringVal->get_paramList();
      adjustLevels(&algdefMinor_stringValAtts_a_paramList,
		   "algdefMinor_stringVal a_paramList");
      if (log && !findString("a_paramList", algdefMinor_stringValAtts))
	{
	  warnAtt("a_paramList", "algdefMinor_stringVal",
		  a_algdefMinor_stringVal);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_param(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_param(*iter, log);
	}
    }
}

/********************************************************************/

void check_algdefStm(
 algdefStm * a_algdefStm,
 int log)
{
  if (a_algdefStm->get_vaLabel())
    {
      adjustLevels(&algdefStmAtts_a_vaLabel, "algdefStm a_vaLabel");
      if (log && !findString("a_vaLabel", algdefStmAtts))
	{
	  warnAtt("a_vaLabel", "algdefStm", a_algdefStm);
	  check_vaLabel(a_algdefStm->get_vaLabel(), 0);
	}
      else
	check_vaLabel(a_algdefStm->get_vaLabel(), log);
    }
  if (a_algdefStm->get_algdefMinor())
    {
      adjustLevels(&algdefStmAtts_a_algdefMinor, "algdefStm a_algdefMinor");
      if (log && !findString("a_algdefMinor", algdefStmAtts))
	{
	  warnAtt("a_algdefMinor", "algdefStm", a_algdefStm);
	  check_algdefMinor(a_algdefStm->get_algdefMinor(), 0);
	}
      else
	check_algdefMinor(a_algdefStm->get_algdefMinor(), log);
    }
}

/********************************************************************/

void check_angle(
 angle * a_angle,
 int log)
{
  if (isA(a_angle, rentVal))
    {
      adjustLevels(&angleSubs_rentVal, "rentVal");
      if (log && !findString("rentVal", angleSubs))
	{
	  warnSub("rentVal", "angle", a_angle);
	  check_rentVal(dynamic_cast<rentVal *>(a_angle), 0);
	}
      else
	check_rentVal(dynamic_cast<rentVal *>(a_angle), log);
      return;
    }
  if (isA(a_angle, angleDms))
    {
      adjustLevels(&angleSubs_angleDms, "angleDms");
      if (log && !findString("angleDms", angleSubs))
	{
	  warnSub("angleDms", "angle", a_angle);
	  check_angleDms(dynamic_cast<angleDms *>(a_angle), 0);
	}
      else
	check_angleDms(dynamic_cast<angleDms *>(a_angle), log);
      return;
    }
}

/********************************************************************/

void check_angleDms(
 angleDms * a_angleDms,
 int log)
{
  if (a_angleDms->get_degrees())
    {
      adjustLevels(&angleDmsAtts_degrees, "angleDms degrees");
      if (log && !findString("degrees", angleDmsAtts))
	{
	  warnAtt("degrees", "angleDms", a_angleDms);
	}
    }
  if (a_angleDms->get_minutes())
    {
      adjustLevels(&angleDmsAtts_minutes, "angleDms minutes");
      if (log && !findString("minutes", angleDmsAtts))
	{
	  warnAtt("minutes", "angleDms", a_angleDms);
	}
    }
  if (a_angleDms->get_secondsString())
    {
      adjustLevels(&angleDmsAtts_a_secondsString, "angleDms a_secondsString");
      if (log && !findString("a_secondsString", angleDmsAtts))
	{
	  warnAtt("a_secondsString", "angleDms", a_angleDms);
	  check_secondsString(a_angleDms->get_secondsString(), 0);
	}
      else
	check_secondsString(a_angleDms->get_secondsString(), log);
    }
}

/********************************************************************/

void check_angleUnit(
 angleUnit * a_angleUnit,
 int log)
{
  if (isA(a_angleUnit, angleUnit_ANGDEC))
    {
      adjustLevels(&angleUnitSubs_angleUnit_ANGDEC, "angleUnit_ANGDEC");
      if (log && !findString("angleUnit_ANGDEC", angleUnitSubs))
	{
	  warnSub("angleUnit_ANGDEC", "angleUnit", a_angleUnit);
	}
      return;
    }
  if (isA(a_angleUnit, angleUnit_ANGDMS))
    {
      adjustLevels(&angleUnitSubs_angleUnit_ANGDMS, "angleUnit_ANGDMS");
      if (log && !findString("angleUnit_ANGDMS", angleUnitSubs))
	{
	  warnSub("angleUnit_ANGDMS", "angleUnit", a_angleUnit);
	}
      return;
    }
  if (isA(a_angleUnit, angleUnit_ANGRAD))
    {
      adjustLevels(&angleUnitSubs_angleUnit_ANGRAD, "angleUnit_ANGRAD");
      if (log && !findString("angleUnit_ANGRAD", angleUnitSubs))
	{
	  warnSub("angleUnit_ANGRAD", "angleUnit", a_angleUnit);
	}
      return;
    }
}

/********************************************************************/

void check_anyVal(
 anyVal * a_anyVal,
 int log)
{
  if (isA(a_anyVal, stringVal))
    {
      adjustLevels(&anyValSubs_stringVal, "stringVal");
      if (log && !findString("stringVal", anyValSubs))
	{
	  warnSub("stringVal", "anyVal", a_anyVal);
	  check_stringVal(dynamic_cast<stringVal *>(a_anyVal), 0);
	}
      else
	check_stringVal(dynamic_cast<stringVal *>(a_anyVal), log);
      return;
    }
  if (isA(a_anyVal, boolVal))
    {
      adjustLevels(&anyValSubs_boolVal, "boolVal");
      if (log && !findString("boolVal", anyValSubs))
	{
	  warnSub("boolVal", "anyVal", a_anyVal);
	  check_boolVal(dynamic_cast<boolVal *>(a_anyVal), 0);
	}
      else
	check_boolVal(dynamic_cast<boolVal *>(a_anyVal), log);
      return;
    }
  if (isA(a_anyVal, rentVal))
    {
      adjustLevels(&anyValSubs_rentVal, "rentVal");
      if (log && !findString("rentVal", anyValSubs))
	{
	  warnSub("rentVal", "anyVal", a_anyVal);
	  check_rentVal(dynamic_cast<rentVal *>(a_anyVal), 0);
	}
      else
	check_rentVal(dynamic_cast<rentVal *>(a_anyVal), log);
      return;
    }
  if (isA(a_anyVal, vectorVal))
    {
      adjustLevels(&anyValSubs_vectorVal, "vectorVal");
      if (log && !findString("vectorVal", anyValSubs))
	{
	  warnSub("vectorVal", "anyVal", a_anyVal);
	  check_vectorVal(dynamic_cast<vectorVal *>(a_anyVal), 0);
	}
      else
	check_vectorVal(dynamic_cast<vectorVal *>(a_anyVal), log);
      return;
    }
}

/********************************************************************/

void check_arrayIndex(
 arrayIndex * a_arrayIndex,
 int log)
{
  if (a_arrayIndex->get_indexes())
    {
      std::list<intVal *> * theList;
      std::list<intVal *>::iterator iter;
      theList = a_arrayIndex->get_indexes();
      adjustLevels(&arrayIndexAtts_indexes, "arrayIndex indexes");
      if (log && !findString("indexes", arrayIndexAtts))
	{
	  warnAtt("indexes", "arrayIndex", a_arrayIndex);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_intVal(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_intVal(*iter, log);
	}
    }
}

/********************************************************************/

void check_assignBool(
 assignBool * a_assignBool,
 int log)
{
  if (a_assignBool->get_boolVar())
    {
      adjustLevels(&assignBoolAtts_a_boolVar, "assignBool a_boolVar");
      if (log && !findString("a_boolVar", assignBoolAtts))
	{
	  warnAtt("a_boolVar", "assignBool", a_assignBool);
	  check_boolVar(a_assignBool->get_boolVar(), 0);
	}
      else
	check_boolVar(a_assignBool->get_boolVar(), log);
    }
  if (a_assignBool->get_value())
    {
      adjustLevels(&assignBoolAtts_value, "assignBool value");
      if (log && !findString("value", assignBoolAtts))
	{
	  warnAtt("value", "assignBool", a_assignBool);
	  check_boolVal(a_assignBool->get_value(), 0);
	}
      else
	check_boolVal(a_assignBool->get_value(), log);
    }
}

/********************************************************************/

void check_assignInt(
 assignInt * a_assignInt,
 int log)
{
  if (a_assignInt->get_intVar())
    {
      adjustLevels(&assignIntAtts_a_intVar, "assignInt a_intVar");
      if (log && !findString("a_intVar", assignIntAtts))
	{
	  warnAtt("a_intVar", "assignInt", a_assignInt);
	  check_intVar(a_assignInt->get_intVar(), 0);
	}
      else
	check_intVar(a_assignInt->get_intVar(), log);
    }
  if (a_assignInt->get_value())
    {
      adjustLevels(&assignIntAtts_value, "assignInt value");
      if (log && !findString("value", assignIntAtts))
	{
	  warnAtt("value", "assignInt", a_assignInt);
	  check_rentVal(a_assignInt->get_value(), 0);
	}
      else
	check_rentVal(a_assignInt->get_value(), log);
    }
}

/********************************************************************/

void check_assignReal(
 assignReal * a_assignReal,
 int log)
{
  if (a_assignReal->get_realVar())
    {
      adjustLevels(&assignRealAtts_a_realVar, "assignReal a_realVar");
      if (log && !findString("a_realVar", assignRealAtts))
	{
	  warnAtt("a_realVar", "assignReal", a_assignReal);
	  check_realVar(a_assignReal->get_realVar(), 0);
	}
      else
	check_realVar(a_assignReal->get_realVar(), log);
    }
  if (a_assignReal->get_value())
    {
      adjustLevels(&assignRealAtts_value, "assignReal value");
      if (log && !findString("value", assignRealAtts))
	{
	  warnAtt("value", "assignReal", a_assignReal);
	  check_rentVal(a_assignReal->get_value(), 0);
	}
      else
	check_rentVal(a_assignReal->get_value(), log);
    }
}

/********************************************************************/

void check_assignStm(
 assignStm * a_assignStm,
 int log)
{
  if (isA(a_assignStm, assignStm_assignString))
    {
      adjustLevels(&assignStmSubs_assignStm_assignString,
		   "assignStm_assignString");
      if (log && !findString("assignStm_assignString", assignStmSubs))
	{
	  warnSub("assignStm_assignString", "assignStm", a_assignStm);
	  check_assignStm_assignString(
	    dynamic_cast<assignStm_assignString *>(a_assignStm), 0);
	}
      else
	check_assignStm_assignString(
	  dynamic_cast<assignStm_assignString *>(a_assignStm), log);
      return;
    }
  if (isA(a_assignStm, assignStm_assignBool))
    {
      adjustLevels(&assignStmSubs_assignStm_assignBool,
		   "assignStm_assignBool");
      if (log && !findString("assignStm_assignBool", assignStmSubs))
	{
	  warnSub("assignStm_assignBool", "assignStm", a_assignStm);
	  check_assignStm_assignBool(
	    dynamic_cast<assignStm_assignBool *>(a_assignStm), 0);
	}
      else
	check_assignStm_assignBool(
	  dynamic_cast<assignStm_assignBool *>(a_assignStm), log);
      return;
    }
  if (isA(a_assignStm, assignStm_assignInt))
    {
      adjustLevels(&assignStmSubs_assignStm_assignInt, "assignStm_assignInt");
      if (log && !findString("assignStm_assignInt", assignStmSubs))
	{
	  warnSub("assignStm_assignInt", "assignStm", a_assignStm);
	  check_assignStm_assignInt(
	    dynamic_cast<assignStm_assignInt *>(a_assignStm), 0);
	}
      else
	check_assignStm_assignInt(
	  dynamic_cast<assignStm_assignInt *>(a_assignStm), log);
      return;
    }
  if (isA(a_assignStm, assignStm_assignReal))
    {
      adjustLevels(&assignStmSubs_assignStm_assignReal,
		   "assignStm_assignReal");
      if (log && !findString("assignStm_assignReal", assignStmSubs))
	{
	  warnSub("assignStm_assignReal", "assignStm", a_assignStm);
	  check_assignStm_assignReal(
	    dynamic_cast<assignStm_assignReal *>(a_assignStm), 0);
	}
      else
	check_assignStm_assignReal(
	  dynamic_cast<assignStm_assignReal *>(a_assignStm), log);
      return;
    }
  if (isA(a_assignStm, assignStm_assignVector))
    {
      adjustLevels(&assignStmSubs_assignStm_assignVector,
		   "assignStm_assignVector");
      if (log && !findString("assignStm_assignVector", assignStmSubs))
	{
	  warnSub("assignStm_assignVector", "assignStm", a_assignStm);
	  check_assignStm_assignVector(
	    dynamic_cast<assignStm_assignVector *>(a_assignStm), 0);
	}
      else
	check_assignStm_assignVector(
	  dynamic_cast<assignStm_assignVector *>(a_assignStm), log);
      return;
    }
}

/********************************************************************/

void check_assignStm_assignBool(
 assignStm_assignBool * a_assignStm_assignBool,
 int log)
{
  if (a_assignStm_assignBool->get_assignBool())
    {
      adjustLevels(&assignStm_assignBoolAtts_a_assignBool,
		   "assignStm_assignBool a_assignBool");
      if (log && !findString("a_assignBool", assignStm_assignBoolAtts))
	{
	  warnAtt("a_assignBool", "assignStm_assignBool",
		  a_assignStm_assignBool);
	  check_assignBool(a_assignStm_assignBool->get_assignBool(), 0);
	}
      else
	check_assignBool(a_assignStm_assignBool->get_assignBool(), log);
    }
}

/********************************************************************/

void check_assignStm_assignInt(
 assignStm_assignInt * a_assignStm_assignInt,
 int log)
{
  if (a_assignStm_assignInt->get_assignInt())
    {
      adjustLevels(&assignStm_assignIntAtts_a_assignInt,
		   "assignStm_assignInt a_assignInt");
      if (log && !findString("a_assignInt", assignStm_assignIntAtts))
	{
	  warnAtt("a_assignInt", "assignStm_assignInt",
		  a_assignStm_assignInt);
	  check_assignInt(a_assignStm_assignInt->get_assignInt(), 0);
	}
      else
	check_assignInt(a_assignStm_assignInt->get_assignInt(), log);
    }
}

/********************************************************************/

void check_assignStm_assignReal(
 assignStm_assignReal * a_assignStm_assignReal,
 int log)
{
  if (a_assignStm_assignReal->get_assignReal())
    {
      adjustLevels(&assignStm_assignRealAtts_a_assignReal,
		   "assignStm_assignReal a_assignReal");
      if (log && !findString("a_assignReal", assignStm_assignRealAtts))
	{
	  warnAtt("a_assignReal", "assignStm_assignReal",
		  a_assignStm_assignReal);
	  check_assignReal(a_assignStm_assignReal->get_assignReal(), 0);
	}
      else
	check_assignReal(a_assignStm_assignReal->get_assignReal(), log);
    }
}

/********************************************************************/

void check_assignStm_assignString(
 assignStm_assignString * a_assignStm_assignString,
 int log)
{
  if (a_assignStm_assignString->get_assignString())
    {
      adjustLevels(&assignStm_assignStringAtts_a_assignString,
		   "assignStm_assignString a_assignString");
      if (log && !findString("a_assignString", assignStm_assignStringAtts))
	{
	  warnAtt("a_assignString", "assignStm_assignString",
		  a_assignStm_assignString);
	  check_assignString(a_assignStm_assignString->get_assignString(), 0);
	}
      else
	check_assignString(a_assignStm_assignString->get_assignString(), log);
    }
}

/********************************************************************/

void check_assignStm_assignVector(
 assignStm_assignVector * a_assignStm_assignVector,
 int log)
{
  if (a_assignStm_assignVector->get_assignVector())
    {
      adjustLevels(&assignStm_assignVectorAtts_a_assignVector,
		   "assignStm_assignVector a_assignVector");
      if (log && !findString("a_assignVector", assignStm_assignVectorAtts))
	{
	  warnAtt("a_assignVector", "assignStm_assignVector",
		  a_assignStm_assignVector);
	  check_assignVector(a_assignStm_assignVector->get_assignVector(), 0);
	}
      else
	check_assignVector(a_assignStm_assignVector->get_assignVector(), log);
    }
}

/********************************************************************/

void check_assignString(
 assignString * a_assignString,
 int log)
{
  if (a_assignString->get_stringVar())
    {
      adjustLevels(&assignStringAtts_a_stringVar, "assignString a_stringVar");
      if (log && !findString("a_stringVar", assignStringAtts))
	{
	  warnAtt("a_stringVar", "assignString", a_assignString);
	  check_stringVar(a_assignString->get_stringVar(), 0);
	}
      else
	check_stringVar(a_assignString->get_stringVar(), log);
    }
  if (a_assignString->get_str())
    {
      adjustLevels(&assignStringAtts_str, "assignString str");
      if (log && !findString("str", assignStringAtts))
	{
	  warnAtt("str", "assignString", a_assignString);
	  check_stringVal(a_assignString->get_str(), 0);
	}
      else
	check_stringVal(a_assignString->get_str(), log);
    }
}

/********************************************************************/

void check_assignVector(
 assignVector * a_assignVector,
 int log)
{
  if (a_assignVector->get_vectorVar())
    {
      adjustLevels(&assignVectorAtts_a_vectorVar, "assignVector a_vectorVar");
      if (log && !findString("a_vectorVar", assignVectorAtts))
	{
	  warnAtt("a_vectorVar", "assignVector", a_assignVector);
	  check_vectorVar(a_assignVector->get_vectorVar(), 0);
	}
      else
	check_vectorVar(a_assignVector->get_vectorVar(), log);
    }
  if (a_assignVector->get_value())
    {
      adjustLevels(&assignVectorAtts_value, "assignVector value");
      if (log && !findString("value", assignVectorAtts))
	{
	  warnAtt("value", "assignVector", a_assignVector);
	  check_vectorVal(a_assignVector->get_value(), 0);
	}
      else
	check_vectorVal(a_assignVector->get_value(), log);
    }
}

/********************************************************************/

void check_avgMaxMin(
 avgMaxMin * a_avgMaxMin,
 int log)
{
  if (isA(a_avgMaxMin, avgMaxMin_AVG))
    {
      adjustLevels(&avgMaxMinSubs_avgMaxMin_AVG, "avgMaxMin_AVG");
      if (log && !findString("avgMaxMin_AVG", avgMaxMinSubs))
	{
	  warnSub("avgMaxMin_AVG", "avgMaxMin", a_avgMaxMin);
	}
      return;
    }
  if (isA(a_avgMaxMin, avgMaxMin_MAX))
    {
      adjustLevels(&avgMaxMinSubs_avgMaxMin_MAX, "avgMaxMin_MAX");
      if (log && !findString("avgMaxMin_MAX", avgMaxMinSubs))
	{
	  warnSub("avgMaxMin_MAX", "avgMaxMin", a_avgMaxMin);
	}
      return;
    }
  if (isA(a_avgMaxMin, avgMaxMin_MIN))
    {
      adjustLevels(&avgMaxMinSubs_avgMaxMin_MIN, "avgMaxMin_MIN");
      if (log && !findString("avgMaxMin_MIN", avgMaxMinSubs))
	{
	  warnSub("avgMaxMin_MIN", "avgMaxMin", a_avgMaxMin);
	}
      return;
    }
}

/********************************************************************/

void check_axial(
 axial * a_axial,
 int log)
{
  if (a_axial->get_featureLabel())
    {
      adjustLevels(&axialAtts_a_featureLabel, "axial a_featureLabel");
      if (log && !findString("a_featureLabel", axialAtts))
	{
	  warnAtt("a_featureLabel", "axial", a_axial);
	  check_featureLabel(a_axial->get_featureLabel(), 0);
	}
      else
	check_featureLabel(a_axial->get_featureLabel(), log);
    }
  if (a_axial->get_dist())
    {
      adjustLevels(&axialAtts_dist, "axial dist");
      if (log && !findString("dist", axialAtts))
	{
	  warnAtt("dist", "axial", a_axial);
	  check_rentVal(a_axial->get_dist(), 0);
	}
      else
	check_rentVal(a_axial->get_dist(), log);
    }
}

/********************************************************************/

void check_axis(
 axis * a_axis,
 int log)
{
  if (isA(a_axis, axis_XAXIS))
    {
      adjustLevels(&axisSubs_axis_XAXIS, "axis_XAXIS");
      if (log && !findString("axis_XAXIS", axisSubs))
	{
	  warnSub("axis_XAXIS", "axis", a_axis);
	}
      return;
    }
  if (isA(a_axis, axis_YAXIS))
    {
      adjustLevels(&axisSubs_axis_YAXIS, "axis_YAXIS");
      if (log && !findString("axis_YAXIS", axisSubs))
	{
	  warnSub("axis_YAXIS", "axis", a_axis);
	}
      return;
    }
  if (isA(a_axis, axis_ZAXIS))
    {
      adjustLevels(&axisSubs_axis_ZAXIS, "axis_ZAXIS");
      if (log && !findString("axis_ZAXIS", axisSubs))
	{
	  warnSub("axis_ZAXIS", "axis", a_axis);
	}
      return;
    }
}

/********************************************************************/

void check_badtstStm(
 badtstStm * a_badtstStm,
 int log)
{
  if (a_badtstStm->get_state())
    {
      adjustLevels(&badtstStmAtts_a_state, "badtstStm a_state");
      if (log && !findString("a_state", badtstStmAtts))
	{
	  warnAtt("a_state", "badtstStm", a_badtstStm);
	  check_state(a_badtstStm->get_state(), 0);
	}
      else
	check_state(a_badtstStm->get_state(), log);
    }
}

/********************************************************************/

void check_bfConst(
 bfConst * a_bfConst,
 int log)
{
  if (isA(a_bfConst, bfConst_featureList))
    {
      adjustLevels(&bfConstSubs_bfConst_featureList, "bfConst_featureList");
      if (log && !findString("bfConst_featureList", bfConstSubs))
	{
	  warnSub("bfConst_featureList", "bfConst", a_bfConst);
	  check_bfConst_featureList(
	    dynamic_cast<bfConst_featureList *>(a_bfConst), 0);
	}
      else
	check_bfConst_featureList(
	  dynamic_cast<bfConst_featureList *>(a_bfConst), log);
      return;
    }
  if (isA(a_bfConst, bfConst_indexedFeatureList))
    {
      adjustLevels(&bfConstSubs_bfConst_indexedFeatureList,
		   "bfConst_indexedFeatureList");
      if (log && !findString("bfConst_indexedFeatureList", bfConstSubs))
	{
	  warnSub("bfConst_indexedFeatureList", "bfConst", a_bfConst);
	  check_bfConst_indexedFeatureList(
	    dynamic_cast<bfConst_indexedFeatureList *>(a_bfConst), 0);
	}
      else
	check_bfConst_indexedFeatureList(
	  dynamic_cast<bfConst_indexedFeatureList *>(a_bfConst), log);
      return;
    }
}

/********************************************************************/

void check_bfConst_featureList(
 bfConst_featureList * a_bfConst_featureList,
 int log)
{
  if (a_bfConst_featureList->get_featureList())
    {
      std::list<featureLabel *> * theList;
      std::list<featureLabel *>::iterator iter;
      theList = a_bfConst_featureList->get_featureList();
      adjustLevels(&bfConst_featureListAtts_a_featureList,
		   "bfConst_featureList a_featureList");
      if (log && !findString("a_featureList", bfConst_featureListAtts))
	{
	  warnAtt("a_featureList", "bfConst_featureList",
		  a_bfConst_featureList);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_featureLabel(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_featureLabel(*iter, log);
	}
    }
}

/********************************************************************/

void check_bfConst_indexedFeatureList(
 bfConst_indexedFeatureList * a_bfConst_indexedFeatureList,
 int log)
{
  if (a_bfConst_indexedFeatureList->get_indexedFeatureList())
    {
      std::list<indexedFeature *> * theList;
      std::list<indexedFeature *>::iterator iter;
      theList = a_bfConst_indexedFeatureList->get_indexedFeatureList();
      adjustLevels(&bfConst_indexedFeatureListAtts_a_indexedFeatureList,
		   "bfConst_indexedFeatureList a_indexedFeatureList");
      if (log && !findString("a_indexedFeatureList",
			     bfConst_indexedFeatureListAtts))
	{
	  warnAtt("a_indexedFeatureList", "bfConst_indexedFeatureList",
		  a_bfConst_indexedFeatureList);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_indexedFeature(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_indexedFeature(*iter, log);
	}
    }
}

/********************************************************************/

void check_boolConst(
 boolConst * a_boolConst,
 int log)
{
  if (isA(a_boolConst, boolConst_TRUE))
    {
      adjustLevels(&boolConstSubs_boolConst_TRUE, "boolConst_TRUE");
      if (log && !findString("boolConst_TRUE", boolConstSubs))
	{
	  warnSub("boolConst_TRUE", "boolConst", a_boolConst);
	}
      return;
    }
  if (isA(a_boolConst, boolConst_FALSE))
    {
      adjustLevels(&boolConstSubs_boolConst_FALSE, "boolConst_FALSE");
      if (log && !findString("boolConst_FALSE", boolConstSubs))
	{
	  warnSub("boolConst_FALSE", "boolConst", a_boolConst);
	}
      return;
    }
}

/********************************************************************/

void check_boolExpr(
 boolExpr * a_boolExpr,
 int log)
{
  if (isA(a_boolExpr, boolExpr_PAREN))
    {
      adjustLevels(&boolExprSubs_boolExpr_PAREN, "boolExpr_PAREN");
      if (log && !findString("boolExpr_PAREN", boolExprSubs))
	{
	  warnSub("boolExpr_PAREN", "boolExpr", a_boolExpr);
	  check_boolExpr_PAREN(
	    dynamic_cast<boolExpr_PAREN *>(a_boolExpr), 0);
	}
      else
	check_boolExpr_PAREN(
	  dynamic_cast<boolExpr_PAREN *>(a_boolExpr), log);
      return;
    }
  if (isA(a_boolExpr, boolExpr_stringRel))
    {
      adjustLevels(&boolExprSubs_boolExpr_stringRel, "boolExpr_stringRel");
      if (log && !findString("boolExpr_stringRel", boolExprSubs))
	{
	  warnSub("boolExpr_stringRel", "boolExpr", a_boolExpr);
	  check_boolExpr_stringRel(
	    dynamic_cast<boolExpr_stringRel *>(a_boolExpr), 0);
	}
      else
	check_boolExpr_stringRel(
	  dynamic_cast<boolExpr_stringRel *>(a_boolExpr), log);
      return;
    }
  if (isA(a_boolExpr, boolExpr_boolRel))
    {
      adjustLevels(&boolExprSubs_boolExpr_boolRel, "boolExpr_boolRel");
      if (log && !findString("boolExpr_boolRel", boolExprSubs))
	{
	  warnSub("boolExpr_boolRel", "boolExpr", a_boolExpr);
	  check_boolExpr_boolRel(
	    dynamic_cast<boolExpr_boolRel *>(a_boolExpr), 0);
	}
      else
	check_boolExpr_boolRel(
	  dynamic_cast<boolExpr_boolRel *>(a_boolExpr), log);
      return;
    }
  if (isA(a_boolExpr, boolExpr_intRel))
    {
      adjustLevels(&boolExprSubs_boolExpr_intRel, "boolExpr_intRel");
      if (log && !findString("boolExpr_intRel", boolExprSubs))
	{
	  warnSub("boolExpr_intRel", "boolExpr", a_boolExpr);
	  check_boolExpr_intRel(
	    dynamic_cast<boolExpr_intRel *>(a_boolExpr), 0);
	}
      else
	check_boolExpr_intRel(
	  dynamic_cast<boolExpr_intRel *>(a_boolExpr), log);
      return;
    }
  if (isA(a_boolExpr, boolExpr_realRel))
    {
      adjustLevels(&boolExprSubs_boolExpr_realRel, "boolExpr_realRel");
      if (log && !findString("boolExpr_realRel", boolExprSubs))
	{
	  warnSub("boolExpr_realRel", "boolExpr", a_boolExpr);
	  check_boolExpr_realRel(
	    dynamic_cast<boolExpr_realRel *>(a_boolExpr), 0);
	}
      else
	check_boolExpr_realRel(
	  dynamic_cast<boolExpr_realRel *>(a_boolExpr), log);
      return;
    }
  if (isA(a_boolExpr, boolExpr_vectorRel))
    {
      adjustLevels(&boolExprSubs_boolExpr_vectorRel, "boolExpr_vectorRel");
      if (log && !findString("boolExpr_vectorRel", boolExprSubs))
	{
	  warnSub("boolExpr_vectorRel", "boolExpr", a_boolExpr);
	  check_boolExpr_vectorRel(
	    dynamic_cast<boolExpr_vectorRel *>(a_boolExpr), 0);
	}
      else
	check_boolExpr_vectorRel(
	  dynamic_cast<boolExpr_vectorRel *>(a_boolExpr), log);
      return;
    }
}

/********************************************************************/

void check_boolExpr_PAREN(
 boolExpr_PAREN * a_boolExpr_PAREN,
 int log)
{
  if (a_boolExpr_PAREN->get_boolVal())
    {
      adjustLevels(&boolExpr_PARENAtts_a_boolVal, "boolExpr_PAREN a_boolVal");
      if (log && !findString("a_boolVal", boolExpr_PARENAtts))
	{
	  warnAtt("a_boolVal", "boolExpr_PAREN", a_boolExpr_PAREN);
	  check_boolVal(a_boolExpr_PAREN->get_boolVal(), 0);
	}
      else
	check_boolVal(a_boolExpr_PAREN->get_boolVal(), log);
    }
}

/********************************************************************/

void check_boolExpr_boolRel(
 boolExpr_boolRel * a_boolExpr_boolRel,
 int log)
{
  if (a_boolExpr_boolRel->get_boolRel())
    {
      adjustLevels(&boolExpr_boolRelAtts_a_boolRel,
		   "boolExpr_boolRel a_boolRel");
      if (log && !findString("a_boolRel", boolExpr_boolRelAtts))
	{
	  warnAtt("a_boolRel", "boolExpr_boolRel", a_boolExpr_boolRel);
	  check_boolRel(a_boolExpr_boolRel->get_boolRel(), 0);
	}
      else
	check_boolRel(a_boolExpr_boolRel->get_boolRel(), log);
    }
}

/********************************************************************/

void check_boolExpr_intRel(
 boolExpr_intRel * a_boolExpr_intRel,
 int log)
{
  if (a_boolExpr_intRel->get_intRel())
    {
      adjustLevels(&boolExpr_intRelAtts_a_intRel, "boolExpr_intRel a_intRel");
      if (log && !findString("a_intRel", boolExpr_intRelAtts))
	{
	  warnAtt("a_intRel", "boolExpr_intRel", a_boolExpr_intRel);
	  check_intRel(a_boolExpr_intRel->get_intRel(), 0);
	}
      else
	check_intRel(a_boolExpr_intRel->get_intRel(), log);
    }
}

/********************************************************************/

void check_boolExpr_realRel(
 boolExpr_realRel * a_boolExpr_realRel,
 int log)
{
  if (a_boolExpr_realRel->get_realRel())
    {
      adjustLevels(&boolExpr_realRelAtts_a_realRel,
		   "boolExpr_realRel a_realRel");
      if (log && !findString("a_realRel", boolExpr_realRelAtts))
	{
	  warnAtt("a_realRel", "boolExpr_realRel", a_boolExpr_realRel);
	  check_realRel(a_boolExpr_realRel->get_realRel(), 0);
	}
      else
	check_realRel(a_boolExpr_realRel->get_realRel(), log);
    }
}

/********************************************************************/

void check_boolExpr_stringRel(
 boolExpr_stringRel * a_boolExpr_stringRel,
 int log)
{
  if (a_boolExpr_stringRel->get_stringRel())
    {
      adjustLevels(&boolExpr_stringRelAtts_a_stringRel,
		   "boolExpr_stringRel a_stringRel");
      if (log && !findString("a_stringRel", boolExpr_stringRelAtts))
	{
	  warnAtt("a_stringRel", "boolExpr_stringRel", a_boolExpr_stringRel);
	  check_stringRel(a_boolExpr_stringRel->get_stringRel(), 0);
	}
      else
	check_stringRel(a_boolExpr_stringRel->get_stringRel(), log);
    }
}

/********************************************************************/

void check_boolExpr_vectorRel(
 boolExpr_vectorRel * a_boolExpr_vectorRel,
 int log)
{
  if (a_boolExpr_vectorRel->get_vectorRel())
    {
      adjustLevels(&boolExpr_vectorRelAtts_a_vectorRel,
		   "boolExpr_vectorRel a_vectorRel");
      if (log && !findString("a_vectorRel", boolExpr_vectorRelAtts))
	{
	  warnAtt("a_vectorRel", "boolExpr_vectorRel", a_boolExpr_vectorRel);
	  check_vectorRel(a_boolExpr_vectorRel->get_vectorRel(), 0);
	}
      else
	check_vectorRel(a_boolExpr_vectorRel->get_vectorRel(), log);
    }
}

/********************************************************************/

void check_boolFunc(
 boolFunc * a_boolFunc,
 int log)
{
  if (isA(a_boolFunc, boolFuncBadgt))
    {
      adjustLevels(&boolFuncSubs_boolFuncBadgt, "boolFuncBadgt");
      if (log && !findString("boolFuncBadgt", boolFuncSubs))
	{
	  warnSub("boolFuncBadgt", "boolFunc", a_boolFunc);
	}
      return;
    }
  if (isA(a_boolFunc, boolFuncBadpt))
    {
      adjustLevels(&boolFuncSubs_boolFuncBadpt, "boolFuncBadpt");
      if (log && !findString("boolFuncBadpt", boolFuncSubs))
	{
	  warnSub("boolFuncBadpt", "boolFunc", a_boolFunc);
	}
      return;
    }
  if (isA(a_boolFunc, boolFuncEof))
    {
      adjustLevels(&boolFuncSubs_boolFuncEof, "boolFuncEof");
      if (log && !findString("boolFuncEof", boolFuncSubs))
	{
	  warnSub("boolFuncEof", "boolFunc", a_boolFunc);
	  check_boolFuncEof(dynamic_cast<boolFuncEof *>(a_boolFunc), 0);
	}
      else
	check_boolFuncEof(dynamic_cast<boolFuncEof *>(a_boolFunc), log);
      return;
    }
  if (isA(a_boolFunc, boolFuncEoln))
    {
      adjustLevels(&boolFuncSubs_boolFuncEoln, "boolFuncEoln");
      if (log && !findString("boolFuncEoln", boolFuncSubs))
	{
	  warnSub("boolFuncEoln", "boolFunc", a_boolFunc);
	  check_boolFuncEoln(dynamic_cast<boolFuncEoln *>(a_boolFunc), 0);
	}
      else
	check_boolFuncEoln(dynamic_cast<boolFuncEoln *>(a_boolFunc), log);
      return;
    }
  if (isA(a_boolFunc, boolFuncExist))
    {
      adjustLevels(&boolFuncSubs_boolFuncExist, "boolFuncExist");
      if (log && !findString("boolFuncExist", boolFuncSubs))
	{
	  warnSub("boolFuncExist", "boolFunc", a_boolFunc);
	  check_boolFuncExist(
	    dynamic_cast<boolFuncExist *>(a_boolFunc), 0);
	}
      else
	check_boolFuncExist(
	  dynamic_cast<boolFuncExist *>(a_boolFunc), log);
      return;
    }
}

/********************************************************************/

void check_boolFuncEof(
 boolFuncEof * a_boolFuncEof,
 int log)
{
  if (a_boolFuncEof->get_didLabel())
    {
      adjustLevels(&boolFuncEofAtts_a_didLabel, "boolFuncEof a_didLabel");
      if (log && !findString("a_didLabel", boolFuncEofAtts))
	{
	  warnAtt("a_didLabel", "boolFuncEof", a_boolFuncEof);
	  check_didLabel(a_boolFuncEof->get_didLabel(), 0);
	}
      else
	check_didLabel(a_boolFuncEof->get_didLabel(), log);
    }
}

/********************************************************************/

void check_boolFuncEoln(
 boolFuncEoln * a_boolFuncEoln,
 int log)
{
  if (a_boolFuncEoln->get_didLabel())
    {
      adjustLevels(&boolFuncEolnAtts_a_didLabel, "boolFuncEoln a_didLabel");
      if (log && !findString("a_didLabel", boolFuncEolnAtts))
	{
	  warnAtt("a_didLabel", "boolFuncEoln", a_boolFuncEoln);
	  check_didLabel(a_boolFuncEoln->get_didLabel(), 0);
	}
      else
	check_didLabel(a_boolFuncEoln->get_didLabel(), log);
    }
}

/********************************************************************/

void check_boolFuncExist(
 boolFuncExist * a_boolFuncExist,
 int log)
{
  if (isA(a_boolFuncExist, boolFuncExist_sLabel))
    {
      adjustLevels(&boolFuncExistSubs_boolFuncExist_sLabel,
		   "boolFuncExist_sLabel");
      if (log && !findString("boolFuncExist_sLabel", boolFuncExistSubs))
	{
	  warnSub("boolFuncExist_sLabel", "boolFuncExist", a_boolFuncExist);
	  check_boolFuncExist_sLabel(
	    dynamic_cast<boolFuncExist_sLabel *>(a_boolFuncExist), 0);
	}
      else
	check_boolFuncExist_sLabel(
	  dynamic_cast<boolFuncExist_sLabel *>(a_boolFuncExist), log);
      return;
    }
  if (isA(a_boolFuncExist, boolFuncExist_saLabel))
    {
      adjustLevels(&boolFuncExistSubs_boolFuncExist_saLabel,
		   "boolFuncExist_saLabel");
      if (log && !findString("boolFuncExist_saLabel", boolFuncExistSubs))
	{
	  warnSub("boolFuncExist_saLabel", "boolFuncExist", a_boolFuncExist);
	  check_boolFuncExist_saLabel(
	    dynamic_cast<boolFuncExist_saLabel *>(a_boolFuncExist), 0);
	}
      else
	check_boolFuncExist_saLabel(
	  dynamic_cast<boolFuncExist_saLabel *>(a_boolFuncExist), log);
      return;
    }
  if (isA(a_boolFuncExist, boolFuncExist_dLabel))
    {
      adjustLevels(&boolFuncExistSubs_boolFuncExist_dLabel,
		   "boolFuncExist_dLabel");
      if (log && !findString("boolFuncExist_dLabel", boolFuncExistSubs))
	{
	  warnSub("boolFuncExist_dLabel", "boolFuncExist", a_boolFuncExist);
	  check_boolFuncExist_dLabel(
	    dynamic_cast<boolFuncExist_dLabel *>(a_boolFuncExist), 0);
	}
      else
	check_boolFuncExist_dLabel(
	  dynamic_cast<boolFuncExist_dLabel *>(a_boolFuncExist), log);
      return;
    }
  if (isA(a_boolFuncExist, boolFuncExist_daLabel))
    {
      adjustLevels(&boolFuncExistSubs_boolFuncExist_daLabel,
		   "boolFuncExist_daLabel");
      if (log && !findString("boolFuncExist_daLabel", boolFuncExistSubs))
	{
	  warnSub("boolFuncExist_daLabel", "boolFuncExist", a_boolFuncExist);
	  check_boolFuncExist_daLabel(
	    dynamic_cast<boolFuncExist_daLabel *>(a_boolFuncExist), 0);
	}
      else
	check_boolFuncExist_daLabel(
	  dynamic_cast<boolFuncExist_daLabel *>(a_boolFuncExist), log);
      return;
    }
  if (isA(a_boolFuncExist, boolFuncExist_didLabel))
    {
      adjustLevels(&boolFuncExistSubs_boolFuncExist_didLabel,
		   "boolFuncExist_didLabel");
      if (log && !findString("boolFuncExist_didLabel", boolFuncExistSubs))
	{
	  warnSub("boolFuncExist_didLabel", "boolFuncExist", a_boolFuncExist);
	  check_boolFuncExist_didLabel(
	    dynamic_cast<boolFuncExist_didLabel *>(a_boolFuncExist), 0);
	}
      else
	check_boolFuncExist_didLabel(
	  dynamic_cast<boolFuncExist_didLabel *>(a_boolFuncExist), log);
      return;
    }
  if (isA(a_boolFuncExist, boolFuncExist_fLabel))
    {
      adjustLevels(&boolFuncExistSubs_boolFuncExist_fLabel,
		   "boolFuncExist_fLabel");
      if (log && !findString("boolFuncExist_fLabel", boolFuncExistSubs))
	{
	  warnSub("boolFuncExist_fLabel", "boolFuncExist", a_boolFuncExist);
	  check_boolFuncExist_fLabel(
	    dynamic_cast<boolFuncExist_fLabel *>(a_boolFuncExist), 0);
	}
      else
	check_boolFuncExist_fLabel(
	  dynamic_cast<boolFuncExist_fLabel *>(a_boolFuncExist), log);
      return;
    }
  if (isA(a_boolFuncExist, boolFuncExist_faLabel))
    {
      adjustLevels(&boolFuncExistSubs_boolFuncExist_faLabel,
		   "boolFuncExist_faLabel");
      if (log && !findString("boolFuncExist_faLabel", boolFuncExistSubs))
	{
	  warnSub("boolFuncExist_faLabel", "boolFuncExist", a_boolFuncExist);
	  check_boolFuncExist_faLabel(
	    dynamic_cast<boolFuncExist_faLabel *>(a_boolFuncExist), 0);
	}
      else
	check_boolFuncExist_faLabel(
	  dynamic_cast<boolFuncExist_faLabel *>(a_boolFuncExist), log);
      return;
    }
}

/********************************************************************/

void check_boolFuncExist_dLabel(
 boolFuncExist_dLabel * a_boolFuncExist_dLabel,
 int log)
{
  if (a_boolFuncExist_dLabel->get_dLabel())
    {
      adjustLevels(&boolFuncExist_dLabelAtts_a_dLabel,
		   "boolFuncExist_dLabel a_dLabel");
      if (log && !findString("a_dLabel", boolFuncExist_dLabelAtts))
	{
	  warnAtt("a_dLabel", "boolFuncExist_dLabel", a_boolFuncExist_dLabel);
	  check_dLabel(a_boolFuncExist_dLabel->get_dLabel(), 0);
	}
      else
	check_dLabel(a_boolFuncExist_dLabel->get_dLabel(), log);
    }
}

/********************************************************************/

void check_boolFuncExist_daLabel(
 boolFuncExist_daLabel * a_boolFuncExist_daLabel,
 int log)
{
  if (a_boolFuncExist_daLabel->get_daLabel())
    {
      adjustLevels(&boolFuncExist_daLabelAtts_a_daLabel,
		   "boolFuncExist_daLabel a_daLabel");
      if (log && !findString("a_daLabel", boolFuncExist_daLabelAtts))
	{
	  warnAtt("a_daLabel", "boolFuncExist_daLabel",
		  a_boolFuncExist_daLabel);
	  check_daLabel(a_boolFuncExist_daLabel->get_daLabel(), 0);
	}
      else
	check_daLabel(a_boolFuncExist_daLabel->get_daLabel(), log);
    }
}

/********************************************************************/

void check_boolFuncExist_didLabel(
 boolFuncExist_didLabel * a_boolFuncExist_didLabel,
 int log)
{
  if (a_boolFuncExist_didLabel->get_didLabel())
    {
      adjustLevels(&boolFuncExist_didLabelAtts_a_didLabel,
		   "boolFuncExist_didLabel a_didLabel");
      if (log && !findString("a_didLabel", boolFuncExist_didLabelAtts))
	{
	  warnAtt("a_didLabel", "boolFuncExist_didLabel",
		  a_boolFuncExist_didLabel);
	  check_didLabel(a_boolFuncExist_didLabel->get_didLabel(), 0);
	}
      else
	check_didLabel(a_boolFuncExist_didLabel->get_didLabel(), log);
    }
}

/********************************************************************/

void check_boolFuncExist_fLabel(
 boolFuncExist_fLabel * a_boolFuncExist_fLabel,
 int log)
{
  if (a_boolFuncExist_fLabel->get_fLabel())
    {
      adjustLevels(&boolFuncExist_fLabelAtts_a_fLabel,
		   "boolFuncExist_fLabel a_fLabel");
      if (log && !findString("a_fLabel", boolFuncExist_fLabelAtts))
	{
	  warnAtt("a_fLabel", "boolFuncExist_fLabel", a_boolFuncExist_fLabel);
	  check_fLabel(a_boolFuncExist_fLabel->get_fLabel(), 0);
	}
      else
	check_fLabel(a_boolFuncExist_fLabel->get_fLabel(), log);
    }
}

/********************************************************************/

void check_boolFuncExist_faLabel(
 boolFuncExist_faLabel * a_boolFuncExist_faLabel,
 int log)
{
  if (a_boolFuncExist_faLabel->get_faLabel())
    {
      adjustLevels(&boolFuncExist_faLabelAtts_a_faLabel,
		   "boolFuncExist_faLabel a_faLabel");
      if (log && !findString("a_faLabel", boolFuncExist_faLabelAtts))
	{
	  warnAtt("a_faLabel", "boolFuncExist_faLabel",
		  a_boolFuncExist_faLabel);
	  check_faLabel(a_boolFuncExist_faLabel->get_faLabel(), 0);
	}
      else
	check_faLabel(a_boolFuncExist_faLabel->get_faLabel(), log);
    }
}

/********************************************************************/

void check_boolFuncExist_sLabel(
 boolFuncExist_sLabel * a_boolFuncExist_sLabel,
 int log)
{
  if (a_boolFuncExist_sLabel->get_sLabel())
    {
      adjustLevels(&boolFuncExist_sLabelAtts_a_sLabel,
		   "boolFuncExist_sLabel a_sLabel");
      if (log && !findString("a_sLabel", boolFuncExist_sLabelAtts))
	{
	  warnAtt("a_sLabel", "boolFuncExist_sLabel", a_boolFuncExist_sLabel);
	  check_sLabel(a_boolFuncExist_sLabel->get_sLabel(), 0);
	}
      else
	check_sLabel(a_boolFuncExist_sLabel->get_sLabel(), log);
    }
}

/********************************************************************/

void check_boolFuncExist_saLabel(
 boolFuncExist_saLabel * a_boolFuncExist_saLabel,
 int log)
{
  if (a_boolFuncExist_saLabel->get_saLabel())
    {
      adjustLevels(&boolFuncExist_saLabelAtts_a_saLabel,
		   "boolFuncExist_saLabel a_saLabel");
      if (log && !findString("a_saLabel", boolFuncExist_saLabelAtts))
	{
	  warnAtt("a_saLabel", "boolFuncExist_saLabel",
		  a_boolFuncExist_saLabel);
	  check_saLabel(a_boolFuncExist_saLabel->get_saLabel(), 0);
	}
      else
	check_saLabel(a_boolFuncExist_saLabel->get_saLabel(), log);
    }
}

/********************************************************************/

void check_boolRel(
 boolRel * a_boolRel,
 int log)
{
  if (isA(a_boolRel, boolRel_NOT))
    {
      adjustLevels(&boolRelSubs_boolRel_NOT, "boolRel_NOT");
      if (log && !findString("boolRel_NOT", boolRelSubs))
	{
	  warnSub("boolRel_NOT", "boolRel", a_boolRel);
	  check_boolRel_NOT(dynamic_cast<boolRel_NOT *>(a_boolRel), 0);
	}
      else
	check_boolRel_NOT(dynamic_cast<boolRel_NOT *>(a_boolRel), log);
      return;
    }
  if (isA(a_boolRel, boolRel_AND))
    {
      adjustLevels(&boolRelSubs_boolRel_AND, "boolRel_AND");
      if (log && !findString("boolRel_AND", boolRelSubs))
	{
	  warnSub("boolRel_AND", "boolRel", a_boolRel);
	  check_boolRel_AND(dynamic_cast<boolRel_AND *>(a_boolRel), 0);
	}
      else
	check_boolRel_AND(dynamic_cast<boolRel_AND *>(a_boolRel), log);
      return;
    }
  if (isA(a_boolRel, boolRel_OR))
    {
      adjustLevels(&boolRelSubs_boolRel_OR, "boolRel_OR");
      if (log && !findString("boolRel_OR", boolRelSubs))
	{
	  warnSub("boolRel_OR", "boolRel", a_boolRel);
	  check_boolRel_OR(dynamic_cast<boolRel_OR *>(a_boolRel), 0);
	}
      else
	check_boolRel_OR(dynamic_cast<boolRel_OR *>(a_boolRel), log);
      return;
    }
  if (isA(a_boolRel, boolRel_EQ))
    {
      adjustLevels(&boolRelSubs_boolRel_EQ, "boolRel_EQ");
      if (log && !findString("boolRel_EQ", boolRelSubs))
	{
	  warnSub("boolRel_EQ", "boolRel", a_boolRel);
	  check_boolRel_EQ(dynamic_cast<boolRel_EQ *>(a_boolRel), 0);
	}
      else
	check_boolRel_EQ(dynamic_cast<boolRel_EQ *>(a_boolRel), log);
      return;
    }
  if (isA(a_boolRel, boolRel_NE))
    {
      adjustLevels(&boolRelSubs_boolRel_NE, "boolRel_NE");
      if (log && !findString("boolRel_NE", boolRelSubs))
	{
	  warnSub("boolRel_NE", "boolRel", a_boolRel);
	  check_boolRel_NE(dynamic_cast<boolRel_NE *>(a_boolRel), 0);
	}
      else
	check_boolRel_NE(dynamic_cast<boolRel_NE *>(a_boolRel), log);
      return;
    }
}

/********************************************************************/

void check_boolRel_AND(
 boolRel_AND * a_boolRel_AND,
 int log)
{
  if (a_boolRel_AND->get_left())
    {
      adjustLevels(&boolRel_ANDAtts_left, "boolRel_AND left");
      if (log && !findString("left", boolRel_ANDAtts))
	{
	  warnAtt("left", "boolRel_AND", a_boolRel_AND);
	  check_boolVal(a_boolRel_AND->get_left(), 0);
	}
      else
	check_boolVal(a_boolRel_AND->get_left(), log);
    }
  if (a_boolRel_AND->get_right())
    {
      adjustLevels(&boolRel_ANDAtts_right, "boolRel_AND right");
      if (log && !findString("right", boolRel_ANDAtts))
	{
	  warnAtt("right", "boolRel_AND", a_boolRel_AND);
	  check_boolVal(a_boolRel_AND->get_right(), 0);
	}
      else
	check_boolVal(a_boolRel_AND->get_right(), log);
    }
}

/********************************************************************/

void check_boolRel_EQ(
 boolRel_EQ * a_boolRel_EQ,
 int log)
{
  if (a_boolRel_EQ->get_left())
    {
      adjustLevels(&boolRel_EQAtts_left, "boolRel_EQ left");
      if (log && !findString("left", boolRel_EQAtts))
	{
	  warnAtt("left", "boolRel_EQ", a_boolRel_EQ);
	  check_boolVal(a_boolRel_EQ->get_left(), 0);
	}
      else
	check_boolVal(a_boolRel_EQ->get_left(), log);
    }
  if (a_boolRel_EQ->get_right())
    {
      adjustLevels(&boolRel_EQAtts_right, "boolRel_EQ right");
      if (log && !findString("right", boolRel_EQAtts))
	{
	  warnAtt("right", "boolRel_EQ", a_boolRel_EQ);
	  check_boolVal(a_boolRel_EQ->get_right(), 0);
	}
      else
	check_boolVal(a_boolRel_EQ->get_right(), log);
    }
}

/********************************************************************/

void check_boolRel_NE(
 boolRel_NE * a_boolRel_NE,
 int log)
{
  if (a_boolRel_NE->get_left())
    {
      adjustLevels(&boolRel_NEAtts_left, "boolRel_NE left");
      if (log && !findString("left", boolRel_NEAtts))
	{
	  warnAtt("left", "boolRel_NE", a_boolRel_NE);
	  check_boolVal(a_boolRel_NE->get_left(), 0);
	}
      else
	check_boolVal(a_boolRel_NE->get_left(), log);
    }
  if (a_boolRel_NE->get_right())
    {
      adjustLevels(&boolRel_NEAtts_right, "boolRel_NE right");
      if (log && !findString("right", boolRel_NEAtts))
	{
	  warnAtt("right", "boolRel_NE", a_boolRel_NE);
	  check_boolVal(a_boolRel_NE->get_right(), 0);
	}
      else
	check_boolVal(a_boolRel_NE->get_right(), log);
    }
}

/********************************************************************/

void check_boolRel_NOT(
 boolRel_NOT * a_boolRel_NOT,
 int log)
{
  if (a_boolRel_NOT->get_boolVal())
    {
      adjustLevels(&boolRel_NOTAtts_a_boolVal, "boolRel_NOT a_boolVal");
      if (log && !findString("a_boolVal", boolRel_NOTAtts))
	{
	  warnAtt("a_boolVal", "boolRel_NOT", a_boolRel_NOT);
	  check_boolVal(a_boolRel_NOT->get_boolVal(), 0);
	}
      else
	check_boolVal(a_boolRel_NOT->get_boolVal(), log);
    }
}

/********************************************************************/

void check_boolRel_OR(
 boolRel_OR * a_boolRel_OR,
 int log)
{
  if (a_boolRel_OR->get_left())
    {
      adjustLevels(&boolRel_ORAtts_left, "boolRel_OR left");
      if (log && !findString("left", boolRel_ORAtts))
	{
	  warnAtt("left", "boolRel_OR", a_boolRel_OR);
	  check_boolVal(a_boolRel_OR->get_left(), 0);
	}
      else
	check_boolVal(a_boolRel_OR->get_left(), log);
    }
  if (a_boolRel_OR->get_right())
    {
      adjustLevels(&boolRel_ORAtts_right, "boolRel_OR right");
      if (log && !findString("right", boolRel_ORAtts))
	{
	  warnAtt("right", "boolRel_OR", a_boolRel_OR);
	  check_boolVal(a_boolRel_OR->get_right(), 0);
	}
      else
	check_boolVal(a_boolRel_OR->get_right(), log);
    }
}

/********************************************************************/

void check_boolVal(
 boolVal * a_boolVal,
 int log)
{
  if (isA(a_boolVal, boolConst))
    {
      adjustLevels(&boolValSubs_boolConst, "boolConst");
      if (log && !findString("boolConst", boolValSubs))
	{
	  warnSub("boolConst", "boolVal", a_boolVal);
	  check_boolConst(dynamic_cast<boolConst *>(a_boolVal), 0);
	}
      else
	check_boolConst(dynamic_cast<boolConst *>(a_boolVal), log);
      return;
    }
  if (isA(a_boolVal, boolExpr))
    {
      adjustLevels(&boolValSubs_boolExpr, "boolExpr");
      if (log && !findString("boolExpr", boolValSubs))
	{
	  warnSub("boolExpr", "boolVal", a_boolVal);
	  check_boolExpr(dynamic_cast<boolExpr *>(a_boolVal), 0);
	}
      else
	check_boolExpr(dynamic_cast<boolExpr *>(a_boolVal), log);
      return;
    }
  if (isA(a_boolVal, boolFunc))
    {
      adjustLevels(&boolValSubs_boolFunc, "boolFunc");
      if (log && !findString("boolFunc", boolValSubs))
	{
	  warnSub("boolFunc", "boolVal", a_boolVal);
	  check_boolFunc(dynamic_cast<boolFunc *>(a_boolVal), 0);
	}
      else
	check_boolFunc(dynamic_cast<boolFunc *>(a_boolVal), log);
      return;
    }
  if (isA(a_boolVal, boolVar))
    {
      adjustLevels(&boolValSubs_boolVar, "boolVar");
      if (log && !findString("boolVar", boolValSubs))
	{
	  warnSub("boolVar", "boolVal", a_boolVal);
	  check_boolVar(dynamic_cast<boolVar *>(a_boolVal), 0);
	}
      else
	check_boolVar(dynamic_cast<boolVar *>(a_boolVal), log);
      return;
    }
}

/********************************************************************/

void check_boolVar(
 boolVar * a_boolVar,
 int log)
{
  if (a_boolVar->get_string())
    {
      adjustLevels(&boolVarAtts_a_string, "boolVar a_string");
      if (log && !findString("a_string", boolVarAtts))
	{
	  warnAtt("a_string", "boolVar", a_boolVar);
	}
    }
  if (a_boolVar->get_arrayIndex())
    {
      adjustLevels(&boolVarAtts_a_arrayIndex, "boolVar a_arrayIndex");
      if (log && !findString("a_arrayIndex", boolVarAtts))
	{
	  warnAtt("a_arrayIndex", "boolVar", a_boolVar);
	  check_arrayIndex(a_boolVar->get_arrayIndex(), 0);
	}
      else
	check_arrayIndex(a_boolVar->get_arrayIndex(), log);
    }
}

/********************************************************************/

void check_boundFeat(
 boundFeat * a_boundFeat,
 int log)
{
  if (a_boundFeat->get_fLabel())
    {
      adjustLevels(&boundFeatAtts_a_fLabel, "boundFeat a_fLabel");
      if (log && !findString("a_fLabel", boundFeatAtts))
	{
	  warnAtt("a_fLabel", "boundFeat", a_boundFeat);
	  check_fLabel(a_boundFeat->get_fLabel(), 0);
	}
      else
	check_fLabel(a_boundFeat->get_fLabel(), log);
    }
  if (a_boundFeat->get_featureList())
    {
      std::list<featureLabel *> * theList;
      std::list<featureLabel *>::iterator iter;
      theList = a_boundFeat->get_featureList();
      adjustLevels(&boundFeatAtts_a_featureList, "boundFeat a_featureList");
      if (log && !findString("a_featureList", boundFeatAtts))
	{
	  warnAtt("a_featureList", "boundFeat", a_boundFeat);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_featureLabel(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_featureLabel(*iter, log);
	}
    }
}

/********************************************************************/

void check_boundMinor(
 boundMinor * a_boundMinor,
 int log)
{
  if (isA(a_boundMinor, boundFeat))
    {
      adjustLevels(&boundMinorSubs_boundFeat, "boundFeat");
      if (log && !findString("boundFeat", boundMinorSubs))
	{
	  warnSub("boundFeat", "boundMinor", a_boundMinor);
	  check_boundFeat(dynamic_cast<boundFeat *>(a_boundMinor), 0);
	}
      else
	check_boundFeat(dynamic_cast<boundFeat *>(a_boundMinor), log);
      return;
    }
  if (isA(a_boundMinor, boundTol))
    {
      adjustLevels(&boundMinorSubs_boundTol, "boundTol");
      if (log && !findString("boundTol", boundMinorSubs))
	{
	  warnSub("boundTol", "boundMinor", a_boundMinor);
	  check_boundTol(dynamic_cast<boundTol *>(a_boundMinor), 0);
	}
      else
	check_boundTol(dynamic_cast<boundTol *>(a_boundMinor), log);
      return;
    }
}

/********************************************************************/

void check_boundStm(
 boundStm * a_boundStm,
 int log)
{
  if (a_boundStm->get_boundMinor())
    {
      adjustLevels(&boundStmAtts_a_boundMinor, "boundStm a_boundMinor");
      if (log && !findString("a_boundMinor", boundStmAtts))
	{
	  warnAtt("a_boundMinor", "boundStm", a_boundStm);
	  check_boundMinor(a_boundStm->get_boundMinor(), 0);
	}
      else
	check_boundMinor(a_boundStm->get_boundMinor(), log);
    }
}

/********************************************************************/

void check_boundTol(
 boundTol * a_boundTol,
 int log)
{
  if (a_boundTol->get_tLabel())
    {
      adjustLevels(&boundTolAtts_a_tLabel, "boundTol a_tLabel");
      if (log && !findString("a_tLabel", boundTolAtts))
	{
	  warnAtt("a_tLabel", "boundTol", a_boundTol);
	  check_tLabel(a_boundTol->get_tLabel(), 0);
	}
      else
	check_tLabel(a_boundTol->get_tLabel(), log);
    }
  if (a_boundTol->get_featureList())
    {
      std::list<featureLabel *> * theList;
      std::list<featureLabel *>::iterator iter;
      theList = a_boundTol->get_featureList();
      adjustLevels(&boundTolAtts_a_featureList, "boundTol a_featureList");
      if (log && !findString("a_featureList", boundTolAtts))
	{
	  warnAtt("a_featureList", "boundTol", a_boundTol);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_featureLabel(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_featureLabel(*iter, log);
	}
    }
}

/********************************************************************/

void check_cadfileType(
 cadfileType * a_cadfileType,
 int log)
{
  if (isA(a_cadfileType, cadfileType_STEP))
    {
      adjustLevels(&cadfileTypeSubs_cadfileType_STEP, "cadfileType_STEP");
      if (log && !findString("cadfileType_STEP", cadfileTypeSubs))
	{
	  warnSub("cadfileType_STEP", "cadfileType", a_cadfileType);
	}
      return;
    }
  if (isA(a_cadfileType, cadfileType_IGES))
    {
      adjustLevels(&cadfileTypeSubs_cadfileType_IGES, "cadfileType_IGES");
      if (log && !findString("cadfileType_IGES", cadfileTypeSubs))
	{
	  warnSub("cadfileType_IGES", "cadfileType", a_cadfileType);
	}
      return;
    }
  if (isA(a_cadfileType, cadfileType_VENDOR))
    {
      adjustLevels(&cadfileTypeSubs_cadfileType_VENDOR, "cadfileType_VENDOR");
      if (log && !findString("cadfileType_VENDOR", cadfileTypeSubs))
	{
	  warnSub("cadfileType_VENDOR", "cadfileType", a_cadfileType);
	  check_cadfileType_VENDOR(
	    dynamic_cast<cadfileType_VENDOR *>(a_cadfileType), 0);
	}
      else
	check_cadfileType_VENDOR(
	  dynamic_cast<cadfileType_VENDOR *>(a_cadfileType), log);
      return;
    }
}

/********************************************************************/

void check_cadfileType_VENDOR(
 cadfileType_VENDOR * a_cadfileType_VENDOR,
 int log)
{
  if (a_cadfileType_VENDOR->get_text())
    {
      adjustLevels(&cadfileType_VENDORAtts_text, "cadfileType_VENDOR text");
      if (log && !findString("text", cadfileType_VENDORAtts))
	{
	  warnAtt("text", "cadfileType_VENDOR", a_cadfileType_VENDOR);
	  check_stringVal(a_cadfileType_VENDOR->get_text(), 0);
	}
      else
	check_stringVal(a_cadfileType_VENDOR->get_text(), log);
    }
}

/********************************************************************/

void check_calibMasterBlock(
 calibMasterBlock * a_calibMasterBlock,
 int log)
{
  if (a_calibMasterBlock->get_calibMasterStm())
    {
      adjustLevels(&calibMasterBlockAtts_a_calibMasterStm,
		   "calibMasterBlock a_calibMasterStm");
      if (log && !findString("a_calibMasterStm", calibMasterBlockAtts))
	{
	  warnAttBlock("calibMasterStm",
	    a_calibMasterBlock->get_calibMasterStm());
	  check_calibMasterStm(a_calibMasterBlock->get_calibMasterStm(), 0);
	}
      else
	check_calibMasterStm(a_calibMasterBlock->get_calibMasterStm(), log);
    }
  if (a_calibMasterBlock->get_calibSensBlockItemList())
    {
      std::list<calibSensBlockItem *> * theList;
      std::list<calibSensBlockItem *>::iterator iter;
      theList = a_calibMasterBlock->get_calibSensBlockItemList();
      adjustLevels(&calibMasterBlockAtts_a_calibSensBlockItemList,
		   "calibMasterBlock a_calibSensBlockItemList");
      if (log && !findString("a_calibSensBlockItemList", calibMasterBlockAtts))
	{
	  warnAttBlock("calibSensBlockItemList",
	    a_calibMasterBlock->get_calibSensBlockItemList()->front());
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_calibSensBlockItem(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_calibSensBlockItem(*iter, log);
	}
    }
  if (a_calibMasterBlock->get_endmesStm())
    {
      adjustLevels(&calibMasterBlockAtts_a_endmesStm,
		   "calibMasterBlock a_endmesStm");
      if (log && !findString("a_endmesStm", calibMasterBlockAtts))
	{
	  warnAttBlock("endmesStm", a_calibMasterBlock->get_endmesStm());
	}
    }
}

/********************************************************************/

void check_calibMasterMinor(
 calibMasterMinor * a_calibMasterMinor,
 int log)
{
  if (a_calibMasterMinor->get_artName())
    {
      adjustLevels(&calibMasterMinorAtts_artName, "calibMasterMinor artName");
      if (log && !findString("artName", calibMasterMinorAtts))
	{
	  warnAtt("artName", "calibMasterMinor", a_calibMasterMinor);
	  check_stringVal(a_calibMasterMinor->get_artName(), 0);
	}
      else
	check_stringVal(a_calibMasterMinor->get_artName(), log);
    }
}

/********************************************************************/

void check_calibMasterStm(
 calibMasterStm * a_calibMasterStm,
 int log)
{
  if (a_calibMasterStm->get_calibMasterMinor())
    {
      adjustLevels(&calibMasterStmAtts_a_calibMasterMinor,
		   "calibMasterStm a_calibMasterMinor");
      if (log && !findString("a_calibMasterMinor", calibMasterStmAtts))
	{
	  warnAtt("a_calibMasterMinor", "calibMasterStm", a_calibMasterStm);
	  check_calibMasterMinor(a_calibMasterStm->get_calibMasterMinor(), 0);
	}
      else
	check_calibMasterMinor(a_calibMasterStm->get_calibMasterMinor(), log);
    }
}

/********************************************************************/

void check_calibRtabBlock(
 calibRtabBlock * a_calibRtabBlock,
 int log)
{
  if (a_calibRtabBlock->get_calibRtabStm())
    {
      adjustLevels(&calibRtabBlockAtts_a_calibRtabStm,
		   "calibRtabBlock a_calibRtabStm");
      if (log && !findString("a_calibRtabStm", calibRtabBlockAtts))
	{
	  warnAttBlock("calibRtabStm", a_calibRtabBlock->get_calibRtabStm());
	  check_calibRtabStm(a_calibRtabBlock->get_calibRtabStm(), 0);
	}
      else
	check_calibRtabStm(a_calibRtabBlock->get_calibRtabStm(), log);
    }
  if (a_calibRtabBlock->get_measBlockItemList())
    {
      std::list<measBlockItem *> * theList;
      std::list<measBlockItem *>::iterator iter;
      theList = a_calibRtabBlock->get_measBlockItemList();
      adjustLevels(&calibRtabBlockAtts_a_measBlockItemList,
		   "calibRtabBlock a_measBlockItemList");
      if (log && !findString("a_measBlockItemList", calibRtabBlockAtts))
	{
	  warnAttBlock("measBlockItemList",
	    a_calibRtabBlock->get_measBlockItemList()->front());
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_measBlockItem(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_measBlockItem(*iter, log);
	}
    }
  if (a_calibRtabBlock->get_endmesStm())
    {
      adjustLevels(&calibRtabBlockAtts_a_endmesStm,
		   "calibRtabBlock a_endmesStm");
      if (log && !findString("a_endmesStm", calibRtabBlockAtts))
	{
	  warnAttBlock("endmesStm", a_calibRtabBlock->get_endmesStm());
	}
    }
}

/********************************************************************/

void check_calibRtabMinor(
 calibRtabMinor * a_calibRtabMinor,
 int log)
{
  if (isA(a_calibRtabMinor, calibRtabMinorSpec))
    {
      adjustLevels(&calibRtabMinorSubs_calibRtabMinorSpec,
		   "calibRtabMinorSpec");
      if (log && !findString("calibRtabMinorSpec", calibRtabMinorSubs))
	{
	  warnSub("calibRtabMinorSpec", "calibRtabMinor", a_calibRtabMinor);
	  check_calibRtabMinorSpec(
	    dynamic_cast<calibRtabMinorSpec *>(a_calibRtabMinor), 0);
	}
      else
	check_calibRtabMinorSpec(
	  dynamic_cast<calibRtabMinorSpec *>(a_calibRtabMinor), log);
      return;
    }
  if (isA(a_calibRtabMinor, calibRtabMinorRecalib))
    {
      adjustLevels(&calibRtabMinorSubs_calibRtabMinorRecalib,
		   "calibRtabMinorRecalib");
      if (log && !findString("calibRtabMinorRecalib", calibRtabMinorSubs))
	{
	  warnSub("calibRtabMinorRecalib", "calibRtabMinor", a_calibRtabMinor);
	}
      return;
    }
}

/********************************************************************/

void check_calibRtabMinorSpec(
 calibRtabMinorSpec * a_calibRtabMinorSpec,
 int log)
{
  if (a_calibRtabMinorSpec->get_rtLabel())
    {
      adjustLevels(&calibRtabMinorSpecAtts_a_rtLabel,
		   "calibRtabMinorSpec a_rtLabel");
      if (log && !findString("a_rtLabel", calibRtabMinorSpecAtts))
	{
	  warnAtt("a_rtLabel", "calibRtabMinorSpec", a_calibRtabMinorSpec);
	  check_rtLabel(a_calibRtabMinorSpec->get_rtLabel(), 0);
	}
      else
	check_rtLabel(a_calibRtabMinorSpec->get_rtLabel(), log);
    }
  if (a_calibRtabMinorSpec->get_calibRtabSpec())
    {
      adjustLevels(&calibRtabMinorSpecAtts_a_calibRtabSpec,
		   "calibRtabMinorSpec a_calibRtabSpec");
      if (log && !findString("a_calibRtabSpec", calibRtabMinorSpecAtts))
	{
	  warnAtt("a_calibRtabSpec", "calibRtabMinorSpec",
		  a_calibRtabMinorSpec);
	  check_calibRtabSpec(a_calibRtabMinorSpec->get_calibRtabSpec(), 0);
	}
      else
	check_calibRtabSpec(a_calibRtabMinorSpec->get_calibRtabSpec(), log);
    }
}

/********************************************************************/

void check_calibRtabSpec(
 calibRtabSpec * a_calibRtabSpec,
 int log)
{
  if (isA(a_calibRtabSpec, calibRtabSpec_fLabel))
    {
      adjustLevels(&calibRtabSpecSubs_calibRtabSpec_fLabel,
		   "calibRtabSpec_fLabel");
      if (log && !findString("calibRtabSpec_fLabel", calibRtabSpecSubs))
	{
	  warnSub("calibRtabSpec_fLabel", "calibRtabSpec", a_calibRtabSpec);
	  check_calibRtabSpec_fLabel(
	    dynamic_cast<calibRtabSpec_fLabel *>(a_calibRtabSpec), 0);
	}
      else
	check_calibRtabSpec_fLabel(
	  dynamic_cast<calibRtabSpec_fLabel *>(a_calibRtabSpec), log);
      return;
    }
  if (isA(a_calibRtabSpec, calibRtabSpec_faLabel))
    {
      adjustLevels(&calibRtabSpecSubs_calibRtabSpec_faLabel,
		   "calibRtabSpec_faLabel");
      if (log && !findString("calibRtabSpec_faLabel", calibRtabSpecSubs))
	{
	  warnSub("calibRtabSpec_faLabel", "calibRtabSpec", a_calibRtabSpec);
	  check_calibRtabSpec_faLabel(
	    dynamic_cast<calibRtabSpec_faLabel *>(a_calibRtabSpec), 0);
	}
      else
	check_calibRtabSpec_faLabel(
	  dynamic_cast<calibRtabSpec_faLabel *>(a_calibRtabSpec), log);
      return;
    }
}

/********************************************************************/

void check_calibRtabSpec_fLabel(
 calibRtabSpec_fLabel * a_calibRtabSpec_fLabel,
 int log)
{
  if (a_calibRtabSpec_fLabel->get_fLabel())
    {
      adjustLevels(&calibRtabSpec_fLabelAtts_a_fLabel,
		   "calibRtabSpec_fLabel a_fLabel");
      if (log && !findString("a_fLabel", calibRtabSpec_fLabelAtts))
	{
	  warnAtt("a_fLabel", "calibRtabSpec_fLabel", a_calibRtabSpec_fLabel);
	  check_fLabel(a_calibRtabSpec_fLabel->get_fLabel(), 0);
	}
      else
	check_fLabel(a_calibRtabSpec_fLabel->get_fLabel(), log);
    }
  if (a_calibRtabSpec_fLabel->get_numMeas())
    {
      adjustLevels(&calibRtabSpec_fLabelAtts_numMeas,
		   "calibRtabSpec_fLabel numMeas");
      if (log && !findString("numMeas", calibRtabSpec_fLabelAtts))
	{
	  warnAtt("numMeas", "calibRtabSpec_fLabel", a_calibRtabSpec_fLabel);
	  check_intVal(a_calibRtabSpec_fLabel->get_numMeas(), 0);
	}
      else
	check_intVal(a_calibRtabSpec_fLabel->get_numMeas(), log);
    }
}

/********************************************************************/

void check_calibRtabSpec_faLabel(
 calibRtabSpec_faLabel * a_calibRtabSpec_faLabel,
 int log)
{
  if (a_calibRtabSpec_faLabel->get_feat1())
    {
      adjustLevels(&calibRtabSpec_faLabelAtts_feat1,
		   "calibRtabSpec_faLabel feat1");
      if (log && !findString("feat1", calibRtabSpec_faLabelAtts))
	{
	  warnAtt("feat1", "calibRtabSpec_faLabel", a_calibRtabSpec_faLabel);
	  check_faLabel(a_calibRtabSpec_faLabel->get_feat1(), 0);
	}
      else
	check_faLabel(a_calibRtabSpec_faLabel->get_feat1(), log);
    }
  if (a_calibRtabSpec_faLabel->get_feat2())
    {
      adjustLevels(&calibRtabSpec_faLabelAtts_feat2,
		   "calibRtabSpec_faLabel feat2");
      if (log && !findString("feat2", calibRtabSpec_faLabelAtts))
	{
	  warnAtt("feat2", "calibRtabSpec_faLabel", a_calibRtabSpec_faLabel);
	  check_faLabel(a_calibRtabSpec_faLabel->get_feat2(), 0);
	}
      else
	check_faLabel(a_calibRtabSpec_faLabel->get_feat2(), log);
    }
}

/********************************************************************/

void check_calibRtabStm(
 calibRtabStm * a_calibRtabStm,
 int log)
{
  if (a_calibRtabStm->get_calibRtabMinor())
    {
      adjustLevels(&calibRtabStmAtts_a_calibRtabMinor,
		   "calibRtabStm a_calibRtabMinor");
      if (log && !findString("a_calibRtabMinor", calibRtabStmAtts))
	{
	  warnAtt("a_calibRtabMinor", "calibRtabStm", a_calibRtabStm);
	  check_calibRtabMinor(a_calibRtabStm->get_calibRtabMinor(), 0);
	}
      else
	check_calibRtabMinor(a_calibRtabStm->get_calibRtabMinor(), log);
    }
}

/********************************************************************/

void check_calibSensBlock(
 calibSensBlock * a_calibSensBlock,
 int log)
{
  if (a_calibSensBlock->get_calibSensStm())
    {
      adjustLevels(&calibSensBlockAtts_a_calibSensStm,
		   "calibSensBlock a_calibSensStm");
      if (log && !findString("a_calibSensStm", calibSensBlockAtts))
	{
	  warnAttBlock("calibSensStm", a_calibSensBlock->get_calibSensStm());
	  check_calibSensStm(a_calibSensBlock->get_calibSensStm(), 0);
	}
      else
	check_calibSensStm(a_calibSensBlock->get_calibSensStm(), log);
    }
  if (a_calibSensBlock->get_calibSensBlockItemList())
    {
      std::list<calibSensBlockItem *> * theList;
      std::list<calibSensBlockItem *>::iterator iter;
      theList = a_calibSensBlock->get_calibSensBlockItemList();
      adjustLevels(&calibSensBlockAtts_a_calibSensBlockItemList,
		   "calibSensBlock a_calibSensBlockItemList");
      if (log && !findString("a_calibSensBlockItemList", calibSensBlockAtts))
	{
	  warnAttBlock("calibSensBlockItemList",
	    a_calibSensBlock->get_calibSensBlockItemList()->front());
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_calibSensBlockItem(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_calibSensBlockItem(*iter, log);
	}
    }
  if (a_calibSensBlock->get_endmesStm())
    {
      adjustLevels(&calibSensBlockAtts_a_endmesStm,
		   "calibSensBlock a_endmesStm");
      if (log && !findString("a_endmesStm", calibSensBlockAtts))
	{
	  warnAttBlock("endmesStm", a_calibSensBlock->get_endmesStm());
	}
    }
}

/********************************************************************/

void check_calibSensBlockItem(
 calibSensBlockItem * a_calibSensBlockItem,
 int log)
{
  if (isA(a_calibSensBlockItem, calibSensBlockStatement))
    {
      adjustLevels(&calibSensBlockItemSubs_calibSensBlockStatement,
		   "calibSensBlockStatement");
      if (log && !findString("calibSensBlockStatement",
			     calibSensBlockItemSubs))
	{
	  warnSub("calibSensBlockStatement", "calibSensBlockItem",
		  a_calibSensBlockItem);
	  check_calibSensBlockStatement(
	    dynamic_cast<calibSensBlockStatement *>(a_calibSensBlockItem), 0);
	}
      else
	check_calibSensBlockStatement(
	  dynamic_cast<calibSensBlockStatement *>(a_calibSensBlockItem), log);
      return;
    }
  if (isA(a_calibSensBlockItem, calibSensDoBlock))
    {
      adjustLevels(&calibSensBlockItemSubs_calibSensDoBlock,
		   "calibSensDoBlock");
      if (log && !findString("calibSensDoBlock", calibSensBlockItemSubs))
	{
	  warnSub("calibSensDoBlock", "calibSensBlockItem",
		  a_calibSensBlockItem);
	  check_calibSensDoBlock(
	    dynamic_cast<calibSensDoBlock *>(a_calibSensBlockItem), 0);
	}
      else
	check_calibSensDoBlock(
	  dynamic_cast<calibSensDoBlock *>(a_calibSensBlockItem), log);
      return;
    }
  if (isA(a_calibSensBlockItem, calibSensIfBlock))
    {
      adjustLevels(&calibSensBlockItemSubs_calibSensIfBlock,
		   "calibSensIfBlock");
      if (log && !findString("calibSensIfBlock", calibSensBlockItemSubs))
	{
	  warnSub("calibSensIfBlock", "calibSensBlockItem",
		  a_calibSensBlockItem);
	  check_calibSensIfBlock(
	    dynamic_cast<calibSensIfBlock *>(a_calibSensBlockItem), 0);
	}
      else
	check_calibSensIfBlock(
	  dynamic_cast<calibSensIfBlock *>(a_calibSensBlockItem), log);
      return;
    }
  if (isA(a_calibSensBlockItem, calibSensSelectBlock))
    {
      adjustLevels(&calibSensBlockItemSubs_calibSensSelectBlock,
		   "calibSensSelectBlock");
      if (log && !findString("calibSensSelectBlock", calibSensBlockItemSubs))
	{
	  warnSub("calibSensSelectBlock", "calibSensBlockItem",
		  a_calibSensBlockItem);
	  check_calibSensSelectBlock(
	    dynamic_cast<calibSensSelectBlock *>(a_calibSensBlockItem), 0);
	}
      else
	check_calibSensSelectBlock(
	  dynamic_cast<calibSensSelectBlock *>(a_calibSensBlockItem), log);
      return;
    }
  if (isA(a_calibSensBlockItem, gotargBlock))
    {
      adjustLevels(&calibSensBlockItemSubs_gotargBlock, "gotargBlock");
      if (log && !findString("gotargBlock", calibSensBlockItemSubs))
	{
	  warnSub("gotargBlock", "calibSensBlockItem", a_calibSensBlockItem);
	  check_gotargBlock(
	    dynamic_cast<gotargBlock *>(a_calibSensBlockItem), 0);
	}
      else
	check_gotargBlock(
	  dynamic_cast<gotargBlock *>(a_calibSensBlockItem), log);
      return;
    }
}

/********************************************************************/

void check_calibSensBlockStatement(
 calibSensBlockStatement * a_calibSensBlockStatement,
 int log)
{
  if (isA(a_calibSensBlockStatement, jumpStm))
    {
      adjustLevels(&calibSensBlockStatementSubs_jumpStm, "jumpStm");
      if (log && !findString("jumpStm", calibSensBlockStatementSubs))
	{
	  warnSub("jumpStm", "calibSensBlockStatement",
		  a_calibSensBlockStatement);
	  check_jumpStm(
	    dynamic_cast<jumpStm *>(a_calibSensBlockStatement), 0);
	}
      else
	check_jumpStm(
	  dynamic_cast<jumpStm *>(a_calibSensBlockStatement), log);
      return;
    }
  if (isA(a_calibSensBlockStatement, aclratStm))
    {
      adjustLevels(&calibSensBlockStatementSubs_aclratStm, "aclratStm");
      if (log && !findString("aclratStm", calibSensBlockStatementSubs))
	{
	  warnSub("aclratStm", "calibSensBlockStatement",
		  a_calibSensBlockStatement);
	  check_aclratStm(
	    dynamic_cast<aclratStm *>(a_calibSensBlockStatement), 0);
	}
      else
	check_aclratStm(
	  dynamic_cast<aclratStm *>(a_calibSensBlockStatement), log);
      return;
    }
  if (isA(a_calibSensBlockStatement, assignStm))
    {
      adjustLevels(&calibSensBlockStatementSubs_assignStm, "assignStm");
      if (log && !findString("assignStm", calibSensBlockStatementSubs))
	{
	  warnSub("assignStm", "calibSensBlockStatement",
		  a_calibSensBlockStatement);
	  check_assignStm(
	    dynamic_cast<assignStm *>(a_calibSensBlockStatement), 0);
	}
      else
	check_assignStm(
	  dynamic_cast<assignStm *>(a_calibSensBlockStatement), log);
      return;
    }
  if (isA(a_calibSensBlockStatement, badtstStm))
    {
      adjustLevels(&calibSensBlockStatementSubs_badtstStm, "badtstStm");
      if (log && !findString("badtstStm", calibSensBlockStatementSubs))
	{
	  warnSub("badtstStm", "calibSensBlockStatement",
		  a_calibSensBlockStatement);
	  check_badtstStm(
	    dynamic_cast<badtstStm *>(a_calibSensBlockStatement), 0);
	}
      else
	check_badtstStm(
	  dynamic_cast<badtstStm *>(a_calibSensBlockStatement), log);
      return;
    }
  if (isA(a_calibSensBlockStatement, czslctStm))
    {
      adjustLevels(&calibSensBlockStatementSubs_czslctStm, "czslctStm");
      if (log && !findString("czslctStm", calibSensBlockStatementSubs))
	{
	  warnSub("czslctStm", "calibSensBlockStatement",
		  a_calibSensBlockStatement);
	  check_czslctStm(
	    dynamic_cast<czslctStm *>(a_calibSensBlockStatement), 0);
	}
      else
	check_czslctStm(
	  dynamic_cast<czslctStm *>(a_calibSensBlockStatement), log);
      return;
    }
  if (isA(a_calibSensBlockStatement, dmehwStm))
    {
      adjustLevels(&calibSensBlockStatementSubs_dmehwStm, "dmehwStm");
      if (log && !findString("dmehwStm", calibSensBlockStatementSubs))
	{
	  warnSub("dmehwStm", "calibSensBlockStatement",
		  a_calibSensBlockStatement);
	  check_dmehwStm(
	    dynamic_cast<dmehwStm *>(a_calibSensBlockStatement), 0);
	}
      else
	check_dmehwStm(
	  dynamic_cast<dmehwStm *>(a_calibSensBlockStatement), log);
      return;
    }
  if (isA(a_calibSensBlockStatement, dmeswStm))
    {
      adjustLevels(&calibSensBlockStatementSubs_dmeswStm, "dmeswStm");
      if (log && !findString("dmeswStm", calibSensBlockStatementSubs))
	{
	  warnSub("dmeswStm", "calibSensBlockStatement",
		  a_calibSensBlockStatement);
	  check_dmeswStm(
	    dynamic_cast<dmeswStm *>(a_calibSensBlockStatement), 0);
	}
      else
	check_dmeswStm(
	  dynamic_cast<dmeswStm *>(a_calibSensBlockStatement), log);
      return;
    }
  if (isA(a_calibSensBlockStatement, errorStm))
    {
      adjustLevels(&calibSensBlockStatementSubs_errorStm, "errorStm");
      if (log && !findString("errorStm", calibSensBlockStatementSubs))
	{
	  warnSub("errorStm", "calibSensBlockStatement",
		  a_calibSensBlockStatement);
	  check_errorStm(
	    dynamic_cast<errorStm *>(a_calibSensBlockStatement), 0);
	}
      else
	check_errorStm(
	  dynamic_cast<errorStm *>(a_calibSensBlockStatement), log);
      return;
    }
  if (isA(a_calibSensBlockStatement, fedratStm))
    {
      adjustLevels(&calibSensBlockStatementSubs_fedratStm, "fedratStm");
      if (log && !findString("fedratStm", calibSensBlockStatementSubs))
	{
	  warnSub("fedratStm", "calibSensBlockStatement",
		  a_calibSensBlockStatement);
	  check_fedratStm(
	    dynamic_cast<fedratStm *>(a_calibSensBlockStatement), 0);
	}
      else
	check_fedratStm(
	  dynamic_cast<fedratStm *>(a_calibSensBlockStatement), log);
      return;
    }
  if (isA(a_calibSensBlockStatement, finposStm))
    {
      adjustLevels(&calibSensBlockStatementSubs_finposStm, "finposStm");
      if (log && !findString("finposStm", calibSensBlockStatementSubs))
	{
	  warnSub("finposStm", "calibSensBlockStatement",
		  a_calibSensBlockStatement);
	  check_finposStm(
	    dynamic_cast<finposStm *>(a_calibSensBlockStatement), 0);
	}
      else
	check_finposStm(
	  dynamic_cast<finposStm *>(a_calibSensBlockStatement), log);
      return;
    }
  if (isA(a_calibSensBlockStatement, fromStm))
    {
      adjustLevels(&calibSensBlockStatementSubs_fromStm, "fromStm");
      if (log && !findString("fromStm", calibSensBlockStatementSubs))
	{
	  warnSub("fromStm", "calibSensBlockStatement",
		  a_calibSensBlockStatement);
	  check_fromStm(
	    dynamic_cast<fromStm *>(a_calibSensBlockStatement), 0);
	}
      else
	check_fromStm(
	  dynamic_cast<fromStm *>(a_calibSensBlockStatement), log);
      return;
    }
  if (isA(a_calibSensBlockStatement, gohomeStm))
    {
      adjustLevels(&calibSensBlockStatementSubs_gohomeStm, "gohomeStm");
      if (log && !findString("gohomeStm", calibSensBlockStatementSubs))
	{
	  warnSub("gohomeStm", "calibSensBlockStatement",
		  a_calibSensBlockStatement);
	}
      return;
    }
  if (isA(a_calibSensBlockStatement, gotoStm))
    {
      adjustLevels(&calibSensBlockStatementSubs_gotoStm, "gotoStm");
      if (log && !findString("gotoStm", calibSensBlockStatementSubs))
	{
	  warnSub("gotoStm", "calibSensBlockStatement",
		  a_calibSensBlockStatement);
	  check_gotoStm(
	    dynamic_cast<gotoStm *>(a_calibSensBlockStatement), 0);
	}
      else
	check_gotoStm(
	  dynamic_cast<gotoStm *>(a_calibSensBlockStatement), log);
      return;
    }
  if (isA(a_calibSensBlockStatement, includStm))
    {
      adjustLevels(&calibSensBlockStatementSubs_includStm, "includStm");
      if (log && !findString("includStm", calibSensBlockStatementSubs))
	{
	  warnSub("includStm", "calibSensBlockStatement",
		  a_calibSensBlockStatement);
	  check_includStm(
	    dynamic_cast<includStm *>(a_calibSensBlockStatement), 0);
	}
      else
	check_includStm(
	  dynamic_cast<includStm *>(a_calibSensBlockStatement), log);
      return;
    }
  if (isA(a_calibSensBlockStatement, jumptoStm))
    {
      adjustLevels(&calibSensBlockStatementSubs_jumptoStm, "jumptoStm");
      if (log && !findString("jumptoStm", calibSensBlockStatementSubs))
	{
	  warnSub("jumptoStm", "calibSensBlockStatement",
		  a_calibSensBlockStatement);
	  check_jumptoStm(
	    dynamic_cast<jumptoStm *>(a_calibSensBlockStatement), 0);
	}
      else
	check_jumptoStm(
	  dynamic_cast<jumptoStm *>(a_calibSensBlockStatement), log);
      return;
    }
  if (isA(a_calibSensBlockStatement, obtainStm))
    {
      adjustLevels(&calibSensBlockStatementSubs_obtainStm, "obtainStm");
      if (log && !findString("obtainStm", calibSensBlockStatementSubs))
	{
	  warnSub("obtainStm", "calibSensBlockStatement",
		  a_calibSensBlockStatement);
	  check_obtainStm(
	    dynamic_cast<obtainStm *>(a_calibSensBlockStatement), 0);
	}
      else
	check_obtainStm(
	  dynamic_cast<obtainStm *>(a_calibSensBlockStatement), log);
      return;
    }
  if (isA(a_calibSensBlockStatement, pameasStm))
    {
      adjustLevels(&calibSensBlockStatementSubs_pameasStm, "pameasStm");
      if (log && !findString("pameasStm", calibSensBlockStatementSubs))
	{
	  warnSub("pameasStm", "calibSensBlockStatement",
		  a_calibSensBlockStatement);
	  check_pameasStm(
	    dynamic_cast<pameasStm *>(a_calibSensBlockStatement), 0);
	}
      else
	check_pameasStm(
	  dynamic_cast<pameasStm *>(a_calibSensBlockStatement), log);
      return;
    }
  if (isA(a_calibSensBlockStatement, ptmeasStm))
    {
      adjustLevels(&calibSensBlockStatementSubs_ptmeasStm, "ptmeasStm");
      if (log && !findString("ptmeasStm", calibSensBlockStatementSubs))
	{
	  warnSub("ptmeasStm", "calibSensBlockStatement",
		  a_calibSensBlockStatement);
	  check_ptmeasStm(
	    dynamic_cast<ptmeasStm *>(a_calibSensBlockStatement), 0);
	}
      else
	check_ptmeasStm(
	  dynamic_cast<ptmeasStm *>(a_calibSensBlockStatement), log);
      return;
    }
  if (isA(a_calibSensBlockStatement, rapidStm))
    {
      adjustLevels(&calibSensBlockStatementSubs_rapidStm, "rapidStm");
      if (log && !findString("rapidStm", calibSensBlockStatementSubs))
	{
	  warnSub("rapidStm", "calibSensBlockStatement",
		  a_calibSensBlockStatement);
	  check_rapidStm(
	    dynamic_cast<rapidStm *>(a_calibSensBlockStatement), 0);
	}
      else
	check_rapidStm(
	  dynamic_cast<rapidStm *>(a_calibSensBlockStatement), log);
      return;
    }
  if (isA(a_calibSensBlockStatement, rotabStm))
    {
      adjustLevels(&calibSensBlockStatementSubs_rotabStm, "rotabStm");
      if (log && !findString("rotabStm", calibSensBlockStatementSubs))
	{
	  warnSub("rotabStm", "calibSensBlockStatement",
		  a_calibSensBlockStatement);
	  check_rotabStm(
	    dynamic_cast<rotabStm *>(a_calibSensBlockStatement), 0);
	}
      else
	check_rotabStm(
	  dynamic_cast<rotabStm *>(a_calibSensBlockStatement), log);
      return;
    }
  if (isA(a_calibSensBlockStatement, rotsetStm))
    {
      adjustLevels(&calibSensBlockStatementSubs_rotsetStm, "rotsetStm");
      if (log && !findString("rotsetStm", calibSensBlockStatementSubs))
	{
	  warnSub("rotsetStm", "calibSensBlockStatement",
		  a_calibSensBlockStatement);
	  check_rotsetStm(
	    dynamic_cast<rotsetStm *>(a_calibSensBlockStatement), 0);
	}
      else
	check_rotsetStm(
	  dynamic_cast<rotsetStm *>(a_calibSensBlockStatement), log);
      return;
    }
  if (isA(a_calibSensBlockStatement, snsetStm))
    {
      adjustLevels(&calibSensBlockStatementSubs_snsetStm, "snsetStm");
      if (log && !findString("snsetStm", calibSensBlockStatementSubs))
	{
	  warnSub("snsetStm", "calibSensBlockStatement",
		  a_calibSensBlockStatement);
	  check_snsetStm(
	    dynamic_cast<snsetStm *>(a_calibSensBlockStatement), 0);
	}
      else
	check_snsetStm(
	  dynamic_cast<snsetStm *>(a_calibSensBlockStatement), log);
      return;
    }
  if (isA(a_calibSensBlockStatement, textStm))
    {
      adjustLevels(&calibSensBlockStatementSubs_textStm, "textStm");
      if (log && !findString("textStm", calibSensBlockStatementSubs))
	{
	  warnSub("textStm", "calibSensBlockStatement",
		  a_calibSensBlockStatement);
	  check_textStm(
	    dynamic_cast<textStm *>(a_calibSensBlockStatement), 0);
	}
      else
	check_textStm(
	  dynamic_cast<textStm *>(a_calibSensBlockStatement), log);
      return;
    }
  if (isA(a_calibSensBlockStatement, valueStm))
    {
      adjustLevels(&calibSensBlockStatementSubs_valueStm, "valueStm");
      if (log && !findString("valueStm", calibSensBlockStatementSubs))
	{
	  warnSub("valueStm", "calibSensBlockStatement",
		  a_calibSensBlockStatement);
	  check_valueStm(
	    dynamic_cast<valueStm *>(a_calibSensBlockStatement), 0);
	}
      else
	check_valueStm(
	  dynamic_cast<valueStm *>(a_calibSensBlockStatement), log);
      return;
    }
  if (isA(a_calibSensBlockStatement, wkplanStm))
    {
      adjustLevels(&calibSensBlockStatementSubs_wkplanStm, "wkplanStm");
      if (log && !findString("wkplanStm", calibSensBlockStatementSubs))
	{
	  warnSub("wkplanStm", "calibSensBlockStatement",
		  a_calibSensBlockStatement);
	  check_wkplanStm(
	    dynamic_cast<wkplanStm *>(a_calibSensBlockStatement), 0);
	}
      else
	check_wkplanStm(
	  dynamic_cast<wkplanStm *>(a_calibSensBlockStatement), log);
      return;
    }
}

/********************************************************************/

void check_calibSensCaseBlock(
 calibSensCaseBlock * a_calibSensCaseBlock,
 int log)
{
  if (a_calibSensCaseBlock->get_caseList())
    {
      std::list<caseStm *> * theList;
      std::list<caseStm *>::iterator iter;
      theList = a_calibSensCaseBlock->get_caseList();
      adjustLevels(&calibSensCaseBlockAtts_a_caseList,
		   "calibSensCaseBlock a_caseList");
      if (log && !findString("a_caseList", calibSensCaseBlockAtts))
	{
	  warnAttBlock("caseList",
	    a_calibSensCaseBlock->get_caseList()->front());
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_caseStm(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_caseStm(*iter, log);
	}
    }
  if (a_calibSensCaseBlock->get_calibSensBlockItemList())
    {
      std::list<calibSensBlockItem *> * theList;
      std::list<calibSensBlockItem *>::iterator iter;
      theList = a_calibSensCaseBlock->get_calibSensBlockItemList();
      adjustLevels(&calibSensCaseBlockAtts_a_calibSensBlockItemList,
		   "calibSensCaseBlock a_calibSensBlockItemList");
      if (log && !findString("a_calibSensBlockItemList",
			     calibSensCaseBlockAtts))
	{
	  warnAttBlock("calibSensBlockItemList",
	    a_calibSensCaseBlock->get_calibSensBlockItemList()->front());
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_calibSensBlockItem(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_calibSensBlockItem(*iter, log);
	}
    }
  if (a_calibSensCaseBlock->get_endcasStm())
    {
      adjustLevels(&calibSensCaseBlockAtts_a_endcasStm,
		   "calibSensCaseBlock a_endcasStm");
      if (log && !findString("a_endcasStm", calibSensCaseBlockAtts))
	{
	  warnAttBlock("endcasStm", a_calibSensCaseBlock->get_endcasStm());
	}
    }
}

/********************************************************************/

void check_calibSensDefaultCaseBlock(
 calibSensDefaultCaseBlock * a_calibSensDefaultCaseBlock,
 int log)
{
  if (a_calibSensDefaultCaseBlock->get_dftcasStm())
    {
      adjustLevels(&calibSensDefaultCaseBlockAtts_a_dftcasStm,
		   "calibSensDefaultCaseBlock a_dftcasStm");
      if (log && !findString("a_dftcasStm", calibSensDefaultCaseBlockAtts))
	{
	  warnAttBlock("dftcasStm",
	    a_calibSensDefaultCaseBlock->get_dftcasStm());
	}
    }
  if (a_calibSensDefaultCaseBlock->get_calibSensBlockItemList())
    {
      std::list<calibSensBlockItem *> * theList;
      std::list<calibSensBlockItem *>::iterator iter;
      theList = a_calibSensDefaultCaseBlock->get_calibSensBlockItemList();
      adjustLevels(&calibSensDefaultCaseBlockAtts_a_calibSensBlockItemList,
		   "calibSensDefaultCaseBlock a_calibSensBlockItemList");
      if (log && !findString("a_calibSensBlockItemList",
			     calibSensDefaultCaseBlockAtts))
	{
	  warnAttBlock("calibSensBlockItemList",
	    a_calibSensDefaultCaseBlock->get_calibSensBlockItemList()->front());
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_calibSensBlockItem(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_calibSensBlockItem(*iter, log);
	}
    }
  if (a_calibSensDefaultCaseBlock->get_endcasStm())
    {
      adjustLevels(&calibSensDefaultCaseBlockAtts_a_endcasStm,
		   "calibSensDefaultCaseBlock a_endcasStm");
      if (log && !findString("a_endcasStm", calibSensDefaultCaseBlockAtts))
	{
	  warnAttBlock("endcasStm",
	    a_calibSensDefaultCaseBlock->get_endcasStm());
	}
    }
}

/********************************************************************/

void check_calibSensDoBlock(
 calibSensDoBlock * a_calibSensDoBlock,
 int log)
{
  if (a_calibSensDoBlock->get_doStm())
    {
      adjustLevels(&calibSensDoBlockAtts_a_doStm, "calibSensDoBlock a_doStm");
      if (log && !findString("a_doStm", calibSensDoBlockAtts))
	{
	  warnAttBlock("doStm", a_calibSensDoBlock->get_doStm());
	  check_doStm(a_calibSensDoBlock->get_doStm(), 0);
	}
      else
	check_doStm(a_calibSensDoBlock->get_doStm(), log);
    }
  if (a_calibSensDoBlock->get_calibSensBlockItemList())
    {
      std::list<calibSensBlockItem *> * theList;
      std::list<calibSensBlockItem *>::iterator iter;
      theList = a_calibSensDoBlock->get_calibSensBlockItemList();
      adjustLevels(&calibSensDoBlockAtts_a_calibSensBlockItemList,
		   "calibSensDoBlock a_calibSensBlockItemList");
      if (log && !findString("a_calibSensBlockItemList", calibSensDoBlockAtts))
	{
	  warnAttBlock("calibSensBlockItemList",
	    a_calibSensDoBlock->get_calibSensBlockItemList()->front());
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_calibSensBlockItem(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_calibSensBlockItem(*iter, log);
	}
    }
  if (a_calibSensDoBlock->get_enddoStm())
    {
      adjustLevels(&calibSensDoBlockAtts_a_enddoStm,
		   "calibSensDoBlock a_enddoStm");
      if (log && !findString("a_enddoStm", calibSensDoBlockAtts))
	{
	  warnAttBlock("enddoStm", a_calibSensDoBlock->get_enddoStm());
	}
    }
}

/********************************************************************/

void check_calibSensIfBlock(
 calibSensIfBlock * a_calibSensIfBlock,
 int log)
{
  if (a_calibSensIfBlock->get_ifStm())
    {
      adjustLevels(&calibSensIfBlockAtts_a_ifStm, "calibSensIfBlock a_ifStm");
      if (log && !findString("a_ifStm", calibSensIfBlockAtts))
	{
	  warnAttBlock("ifStm", a_calibSensIfBlock->get_ifStm());
	  check_ifStm(a_calibSensIfBlock->get_ifStm(), 0);
	}
      else
	check_ifStm(a_calibSensIfBlock->get_ifStm(), log);
    }
  if (a_calibSensIfBlock->get_ifList())
    {
      std::list<calibSensBlockItem *> * theList;
      std::list<calibSensBlockItem *>::iterator iter;
      theList = a_calibSensIfBlock->get_ifList();
      adjustLevels(&calibSensIfBlockAtts_ifList, "calibSensIfBlock ifList");
      if (log && !findString("ifList", calibSensIfBlockAtts))
	{
	  warnAttBlock("ifList",
	    a_calibSensIfBlock->get_ifList()->front());
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_calibSensBlockItem(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_calibSensBlockItem(*iter, log);
	}
    }
  if (a_calibSensIfBlock->get_elseStm())
    {
      adjustLevels(&calibSensIfBlockAtts_a_elseStm,
		   "calibSensIfBlock a_elseStm");
      if (log && !findString("a_elseStm", calibSensIfBlockAtts))
	{
	  warnAttBlock("elseStm", a_calibSensIfBlock->get_elseStm());
	}
    }
  if (a_calibSensIfBlock->get_elseList())
    {
      std::list<calibSensBlockItem *> * theList;
      std::list<calibSensBlockItem *>::iterator iter;
      theList = a_calibSensIfBlock->get_elseList();
      adjustLevels(&calibSensIfBlockAtts_elseList,
		   "calibSensIfBlock elseList");
      if (log && !findString("elseList", calibSensIfBlockAtts))
	{
	  warnAttBlock("elseList",
	    a_calibSensIfBlock->get_elseList()->front());
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_calibSensBlockItem(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_calibSensBlockItem(*iter, log);
	}
    }
  if (a_calibSensIfBlock->get_endifStm())
    {
      adjustLevels(&calibSensIfBlockAtts_a_endifStm,
		   "calibSensIfBlock a_endifStm");
      if (log && !findString("a_endifStm", calibSensIfBlockAtts))
	{
	  warnAttBlock("endifStm", a_calibSensIfBlock->get_endifStm());
	}
    }
}

/********************************************************************/

void check_calibSensMinor(
 calibSensMinor * a_calibSensMinor,
 int log)
{
  if (isA(a_calibSensMinor, calibSensMinorSpec))
    {
      adjustLevels(&calibSensMinorSubs_calibSensMinorSpec,
		   "calibSensMinorSpec");
      if (log && !findString("calibSensMinorSpec", calibSensMinorSubs))
	{
	  warnSub("calibSensMinorSpec", "calibSensMinor", a_calibSensMinor);
	  check_calibSensMinorSpec(
	    dynamic_cast<calibSensMinorSpec *>(a_calibSensMinor), 0);
	}
      else
	check_calibSensMinorSpec(
	  dynamic_cast<calibSensMinorSpec *>(a_calibSensMinor), log);
      return;
    }
  if (isA(a_calibSensMinor, calibSensMinorRecalib))
    {
      adjustLevels(&calibSensMinorSubs_calibSensMinorRecalib,
		   "calibSensMinorRecalib");
      if (log && !findString("calibSensMinorRecalib", calibSensMinorSubs))
	{
	  warnSub("calibSensMinorRecalib", "calibSensMinor", a_calibSensMinor);
	}
      return;
    }
}

/********************************************************************/

void check_calibSensMinorSpec(
 calibSensMinorSpec * a_calibSensMinorSpec,
 int log)
{
  if (a_calibSensMinorSpec->get_sLabel())
    {
      adjustLevels(&calibSensMinorSpecAtts_a_sLabel,
		   "calibSensMinorSpec a_sLabel");
      if (log && !findString("a_sLabel", calibSensMinorSpecAtts))
	{
	  warnAtt("a_sLabel", "calibSensMinorSpec", a_calibSensMinorSpec);
	  check_sLabel(a_calibSensMinorSpec->get_sLabel(), 0);
	}
      else
	check_sLabel(a_calibSensMinorSpec->get_sLabel(), log);
    }
  if (a_calibSensMinorSpec->get_calibSensSpec())
    {
      adjustLevels(&calibSensMinorSpecAtts_a_calibSensSpec,
		   "calibSensMinorSpec a_calibSensSpec");
      if (log && !findString("a_calibSensSpec", calibSensMinorSpecAtts))
	{
	  warnAtt("a_calibSensSpec", "calibSensMinorSpec",
		  a_calibSensMinorSpec);
	  check_calibSensSpec(a_calibSensMinorSpec->get_calibSensSpec(), 0);
	}
      else
	check_calibSensSpec(a_calibSensMinorSpec->get_calibSensSpec(), log);
    }
}

/********************************************************************/

void check_calibSensSelectBlock(
 calibSensSelectBlock * a_calibSensSelectBlock,
 int log)
{
  if (a_calibSensSelectBlock->get_selectStm())
    {
      adjustLevels(&calibSensSelectBlockAtts_a_selectStm,
		   "calibSensSelectBlock a_selectStm");
      if (log && !findString("a_selectStm", calibSensSelectBlockAtts))
	{
	  warnAttBlock("selectStm", a_calibSensSelectBlock->get_selectStm());
	  check_selectStm(a_calibSensSelectBlock->get_selectStm(), 0);
	}
      else
	check_selectStm(a_calibSensSelectBlock->get_selectStm(), log);
    }
  if (a_calibSensSelectBlock->get_calibSensCaseBlockList())
    {
      std::list<calibSensCaseBlock *> * theList;
      std::list<calibSensCaseBlock *>::iterator iter;
      theList = a_calibSensSelectBlock->get_calibSensCaseBlockList();
      adjustLevels(&calibSensSelectBlockAtts_a_calibSensCaseBlockList,
		   "calibSensSelectBlock a_calibSensCaseBlockList");
      if (log && !findString("a_calibSensCaseBlockList",
			     calibSensSelectBlockAtts))
	{
	  warnAttBlock("calibSensCaseBlockList",
	    a_calibSensSelectBlock->get_calibSensCaseBlockList()->front());
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_calibSensCaseBlock(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_calibSensCaseBlock(*iter, log);
	}
    }
  if (a_calibSensSelectBlock->get_calibSensDefaultCaseBlock())
    {
      adjustLevels(&calibSensSelectBlockAtts_a_calibSensDefaultCaseBlock,
		   "calibSensSelectBlock a_calibSensDefaultCaseBlock");
      if (log && !findString("a_calibSensDefaultCaseBlock",
			     calibSensSelectBlockAtts))
	{
	  warnAttBlock("calibSensDefaultCaseBlock",
	    a_calibSensSelectBlock->get_calibSensDefaultCaseBlock());
	  check_calibSensDefaultCaseBlock(
	    a_calibSensSelectBlock->get_calibSensDefaultCaseBlock(), 0);
	}
      else
	check_calibSensDefaultCaseBlock(
	  a_calibSensSelectBlock->get_calibSensDefaultCaseBlock(), log);
    }
  if (a_calibSensSelectBlock->get_endselStm())
    {
      adjustLevels(&calibSensSelectBlockAtts_a_endselStm,
		   "calibSensSelectBlock a_endselStm");
      if (log && !findString("a_endselStm", calibSensSelectBlockAtts))
	{
	  warnAttBlock("endselStm", a_calibSensSelectBlock->get_endselStm());
	}
    }
}

/********************************************************************/

void check_calibSensSpec(
 calibSensSpec * a_calibSensSpec,
 int log)
{
  if (isA(a_calibSensSpec, calibSensSpecInt))
    {
      adjustLevels(&calibSensSpecSubs_calibSensSpecInt, "calibSensSpecInt");
      if (log && !findString("calibSensSpecInt", calibSensSpecSubs))
	{
	  warnSub("calibSensSpecInt", "calibSensSpec", a_calibSensSpec);
	  check_calibSensSpecInt(
	    dynamic_cast<calibSensSpecInt *>(a_calibSensSpec), 0);
	}
      else
	check_calibSensSpecInt(
	  dynamic_cast<calibSensSpecInt *>(a_calibSensSpec), log);
      return;
    }
  if (isA(a_calibSensSpec, calibSensSpecString))
    {
      adjustLevels(&calibSensSpecSubs_calibSensSpecString,
		   "calibSensSpecString");
      if (log && !findString("calibSensSpecString", calibSensSpecSubs))
	{
	  warnSub("calibSensSpecString", "calibSensSpec", a_calibSensSpec);
	  check_calibSensSpecString(
	    dynamic_cast<calibSensSpecString *>(a_calibSensSpec), 0);
	}
      else
	check_calibSensSpecString(
	  dynamic_cast<calibSensSpecString *>(a_calibSensSpec), log);
      return;
    }
}

/********************************************************************/

void check_calibSensSpecInt(
 calibSensSpecInt * a_calibSensSpecInt,
 int log)
{
  if (a_calibSensSpecInt->get_featureLabel1())
    {
      adjustLevels(&calibSensSpecIntAtts_a_featureLabel1,
		   "calibSensSpecInt a_featureLabel1");
      if (log && !findString("a_featureLabel1", calibSensSpecIntAtts))
	{
	  warnAtt("a_featureLabel1", "calibSensSpecInt", a_calibSensSpecInt);
	  check_featureLabel1(a_calibSensSpecInt->get_featureLabel1(), 0);
	}
      else
	check_featureLabel1(a_calibSensSpecInt->get_featureLabel1(), log);
    }
  if (a_calibSensSpecInt->get_numMeas())
    {
      adjustLevels(&calibSensSpecIntAtts_numMeas, "calibSensSpecInt numMeas");
      if (log && !findString("numMeas", calibSensSpecIntAtts))
	{
	  warnAtt("numMeas", "calibSensSpecInt", a_calibSensSpecInt);
	  check_intVal(a_calibSensSpecInt->get_numMeas(), 0);
	}
      else
	check_intVal(a_calibSensSpecInt->get_numMeas(), log);
    }
}

/********************************************************************/

void check_calibSensSpecString(
 calibSensSpecString * a_calibSensSpecString,
 int log)
{
  if (a_calibSensSpecString->get_featureLabel1())
    {
      adjustLevels(&calibSensSpecStringAtts_a_featureLabel1,
		   "calibSensSpecString a_featureLabel1");
      if (log && !findString("a_featureLabel1", calibSensSpecStringAtts))
	{
	  warnAtt("a_featureLabel1", "calibSensSpecString",
		  a_calibSensSpecString);
	  check_featureLabel1(a_calibSensSpecString->get_featureLabel1(), 0);
	}
      else
	check_featureLabel1(a_calibSensSpecString->get_featureLabel1(), log);
    }
  if (a_calibSensSpecString->get_text())
    {
      adjustLevels(&calibSensSpecStringAtts_text, "calibSensSpecString text");
      if (log && !findString("text", calibSensSpecStringAtts))
	{
	  warnAtt("text", "calibSensSpecString", a_calibSensSpecString);
	  check_stringVal(a_calibSensSpecString->get_text(), 0);
	}
      else
	check_stringVal(a_calibSensSpecString->get_text(), log);
    }
  if (a_calibSensSpecString->get_numMeas())
    {
      adjustLevels(&calibSensSpecStringAtts_numMeas,
		   "calibSensSpecString numMeas");
      if (log && !findString("numMeas", calibSensSpecStringAtts))
	{
	  warnAtt("numMeas", "calibSensSpecString", a_calibSensSpecString);
	  check_intVal(a_calibSensSpecString->get_numMeas(), 0);
	}
      else
	check_intVal(a_calibSensSpecString->get_numMeas(), log);
    }
}

/********************************************************************/

void check_calibSensStm(
 calibSensStm * a_calibSensStm,
 int log)
{
  if (a_calibSensStm->get_calibSensMinor())
    {
      adjustLevels(&calibSensStmAtts_a_calibSensMinor,
		   "calibSensStm a_calibSensMinor");
      if (log && !findString("a_calibSensMinor", calibSensStmAtts))
	{
	  warnAtt("a_calibSensMinor", "calibSensStm", a_calibSensStm);
	  check_calibSensMinor(a_calibSensStm->get_calibSensMinor(), 0);
	}
      else
	check_calibSensMinor(a_calibSensStm->get_calibSensMinor(), log);
    }
}

/********************************************************************/

void check_callBlock(
 callBlock * a_callBlock,
 int log)
{
  if (a_callBlock->get_callStm())
    {
      adjustLevels(&callBlockAtts_a_callStm, "callBlock a_callStm");
      if (log && !findString("a_callStm", callBlockAtts))
	{
	  warnAttBlock("callStm", a_callBlock->get_callStm());
	  check_callStm(a_callBlock->get_callStm(), 0);
	}
      else
	check_callStm(a_callBlock->get_callStm(), log);
    }
  if (a_callBlock->get_dmisItemList())
    {
      std::list<dmisItem *> * theList;
      std::list<dmisItem *>::iterator iter;
      theList = a_callBlock->get_dmisItemList();
      adjustLevels(&callBlockAtts_a_dmisItemList, "callBlock a_dmisItemList");
      if (log && !findString("a_dmisItemList", callBlockAtts))
	{
	  warnAttBlock("dmisItemList",
	    a_callBlock->get_dmisItemList()->front());
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_dmisItem(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_dmisItem(*iter, log);
	}
    }
  if (a_callBlock->get_endmacStm())
    {
      adjustLevels(&callBlockAtts_a_endmacStm, "callBlock a_endmacStm");
      if (log && !findString("a_endmacStm", callBlockAtts))
	{
	  warnAttBlock("endmacStm", a_callBlock->get_endmacStm());
	}
    }
}

/********************************************************************/

void check_callMacro(
 callMacro * a_callMacro,
 int log)
{
  if (a_callMacro->get_has_EXTERN())
    {
      adjustLevels(&callMacroAtts_has_EXTERN, "callMacro has_EXTERN");
      if (log && !findString("has_EXTERN", callMacroAtts))
	{
	  warnAtt("has_EXTERN", "callMacro", a_callMacro);
	}
    }
  if (a_callMacro->get_mLabel())
    {
      adjustLevels(&callMacroAtts_a_mLabel, "callMacro a_mLabel");
      if (log && !findString("a_mLabel", callMacroAtts))
	{
	  warnAtt("a_mLabel", "callMacro", a_callMacro);
	  check_mLabel(a_callMacro->get_mLabel(), 0);
	}
      else
	check_mLabel(a_callMacro->get_mLabel(), log);
    }
  if (a_callMacro->get_string())
    {
      adjustLevels(&callMacroAtts_a_string, "callMacro a_string");
      if (log && !findString("a_string", callMacroAtts))
	{
	  warnAtt("a_string", "callMacro", a_callMacro);
	}
    }
}

/********************************************************************/

void check_callMinor(
 callMinor * a_callMinor,
 int log)
{
  if (isA(a_callMinor, callMacro))
    {
      adjustLevels(&callMinorSubs_callMacro, "callMacro");
      if (log && !findString("callMacro", callMinorSubs))
	{
	  warnSub("callMacro", "callMinor", a_callMinor);
	  check_callMacro(dynamic_cast<callMacro *>(a_callMinor), 0);
	}
      else
	check_callMacro(dynamic_cast<callMacro *>(a_callMinor), log);
      return;
    }
  if (isA(a_callMinor, callModule))
    {
      adjustLevels(&callMinorSubs_callModule, "callModule");
      if (log && !findString("callModule", callMinorSubs))
	{
	  warnSub("callModule", "callMinor", a_callMinor);
	  check_callModule(dynamic_cast<callModule *>(a_callMinor), 0);
	}
      else
	check_callModule(dynamic_cast<callModule *>(a_callMinor), log);
      return;
    }
  if (isA(a_callMinor, callRoutine))
    {
      adjustLevels(&callMinorSubs_callRoutine, "callRoutine");
      if (log && !findString("callRoutine", callMinorSubs))
	{
	  warnSub("callRoutine", "callMinor", a_callMinor);
	  check_callRoutine(dynamic_cast<callRoutine *>(a_callMinor), 0);
	}
      else
	check_callRoutine(dynamic_cast<callRoutine *>(a_callMinor), log);
      return;
    }
  if (isA(a_callMinor, callProgram))
    {
      adjustLevels(&callMinorSubs_callProgram, "callProgram");
      if (log && !findString("callProgram", callMinorSubs))
	{
	  warnSub("callProgram", "callMinor", a_callMinor);
	  check_callProgram(dynamic_cast<callProgram *>(a_callMinor), 0);
	}
      else
	check_callProgram(dynamic_cast<callProgram *>(a_callMinor), log);
      return;
    }
}

/********************************************************************/

void check_callModule(
 callModule * a_callModule,
 int log)
{
  if (a_callModule->get_modId())
    {
      adjustLevels(&callModuleAtts_modId, "callModule modId");
      if (log && !findString("modId", callModuleAtts))
	{
	  warnAtt("modId", "callModule", a_callModule);
	  check_stringVal(a_callModule->get_modId(), 0);
	}
      else
	check_stringVal(a_callModule->get_modId(), log);
    }
}

/********************************************************************/

void check_callProgram(
 callProgram * a_callProgram,
 int log)
{
  if (a_callProgram->get_pathname())
    {
      adjustLevels(&callProgramAtts_pathname, "callProgram pathname");
      if (log && !findString("pathname", callProgramAtts))
	{
	  warnAtt("pathname", "callProgram", a_callProgram);
	  check_stringVal(a_callProgram->get_pathname(), 0);
	}
      else
	check_stringVal(a_callProgram->get_pathname(), log);
    }
  if (a_callProgram->get_callType())
    {
      adjustLevels(&callProgramAtts_a_callType, "callProgram a_callType");
      if (log && !findString("a_callType", callProgramAtts))
	{
	  warnAtt("a_callType", "callProgram", a_callProgram);
	  check_callType(a_callProgram->get_callType(), 0);
	}
      else
	check_callType(a_callProgram->get_callType(), log);
    }
  if (a_callProgram->get_paramList())
    {
      std::list<param *> * theList;
      std::list<param *>::iterator iter;
      theList = a_callProgram->get_paramList();
      adjustLevels(&callProgramAtts_a_paramList, "callProgram a_paramList");
      if (log && !findString("a_paramList", callProgramAtts))
	{
	  warnAtt("a_paramList", "callProgram", a_callProgram);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_param(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_param(*iter, log);
	}
    }
}

/********************************************************************/

void check_callRoutine(
 callRoutine * a_callRoutine,
 int log)
{
  if (a_callRoutine->get_routine())
    {
      adjustLevels(&callRoutineAtts_routine, "callRoutine routine");
      if (log && !findString("routine", callRoutineAtts))
	{
	  warnAtt("routine", "callRoutine", a_callRoutine);
	  check_stringVal(a_callRoutine->get_routine(), 0);
	}
      else
	check_stringVal(a_callRoutine->get_routine(), log);
    }
  if (a_callRoutine->get_callType())
    {
      adjustLevels(&callRoutineAtts_a_callType, "callRoutine a_callType");
      if (log && !findString("a_callType", callRoutineAtts))
	{
	  warnAtt("a_callType", "callRoutine", a_callRoutine);
	  check_callType(a_callRoutine->get_callType(), 0);
	}
      else
	check_callType(a_callRoutine->get_callType(), log);
    }
  if (a_callRoutine->get_paramList())
    {
      std::list<param *> * theList;
      std::list<param *>::iterator iter;
      theList = a_callRoutine->get_paramList();
      adjustLevels(&callRoutineAtts_a_paramList, "callRoutine a_paramList");
      if (log && !findString("a_paramList", callRoutineAtts))
	{
	  warnAtt("a_paramList", "callRoutine", a_callRoutine);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_param(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_param(*iter, log);
	}
    }
}

/********************************************************************/

void check_callStm(
 callStm * a_callStm,
 int log)
{
  if (a_callStm->get_callMinor())
    {
      adjustLevels(&callStmAtts_a_callMinor, "callStm a_callMinor");
      if (log && !findString("a_callMinor", callStmAtts))
	{
	  warnAtt("a_callMinor", "callStm", a_callStm);
	  check_callMinor(a_callStm->get_callMinor(), 0);
	}
      else
	check_callMinor(a_callStm->get_callMinor(), log);
    }
}

/********************************************************************/

void check_callType(
 callType * a_callType,
 int log)
{
  if (isA(a_callType, callType_WAIT))
    {
      adjustLevels(&callTypeSubs_callType_WAIT, "callType_WAIT");
      if (log && !findString("callType_WAIT", callTypeSubs))
	{
	  warnSub("callType_WAIT", "callType", a_callType);
	}
      return;
    }
  if (isA(a_callType, callType_CONT))
    {
      adjustLevels(&callTypeSubs_callType_CONT, "callType_CONT");
      if (log && !findString("callType_CONT", callTypeSubs))
	{
	  warnSub("callType_CONT", "callType", a_callType);
	}
      return;
    }
  if (isA(a_callType, callType_ATTACH))
    {
      adjustLevels(&callTypeSubs_callType_ATTACH, "callType_ATTACH");
      if (log && !findString("callType_ATTACH", callTypeSubs))
	{
	  warnSub("callType_ATTACH", "callType", a_callType);
	}
      return;
    }
}

/********************************************************************/

void check_cartPoint(
 cartPoint * a_cartPoint,
 int log)
{
  if (a_cartPoint->get_x())
    {
      adjustLevels(&cartPointAtts_x, "cartPoint x");
      if (log && !findString("x", cartPointAtts))
	{
	  warnAtt("x", "cartPoint", a_cartPoint);
	  check_rentVal(a_cartPoint->get_x(), 0);
	}
      else
	check_rentVal(a_cartPoint->get_x(), log);
    }
  if (a_cartPoint->get_y())
    {
      adjustLevels(&cartPointAtts_y, "cartPoint y");
      if (log && !findString("y", cartPointAtts))
	{
	  warnAtt("y", "cartPoint", a_cartPoint);
	  check_rentVal(a_cartPoint->get_y(), 0);
	}
      else
	check_rentVal(a_cartPoint->get_y(), log);
    }
  if (a_cartPoint->get_z())
    {
      adjustLevels(&cartPointAtts_z, "cartPoint z");
      if (log && !findString("z", cartPointAtts))
	{
	  warnAtt("z", "cartPoint", a_cartPoint);
	  check_rentVal(a_cartPoint->get_z(), 0);
	}
      else
	check_rentVal(a_cartPoint->get_z(), log);
    }
}

/********************************************************************/

void check_caseBlock(
 caseBlock * a_caseBlock,
 int log)
{
  if (a_caseBlock->get_caseList())
    {
      std::list<caseStm *> * theList;
      std::list<caseStm *>::iterator iter;
      theList = a_caseBlock->get_caseList();
      adjustLevels(&caseBlockAtts_a_caseList, "caseBlock a_caseList");
      if (log && !findString("a_caseList", caseBlockAtts))
	{
	  warnAttBlock("caseList",
	    a_caseBlock->get_caseList()->front());
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_caseStm(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_caseStm(*iter, log);
	}
    }
  if (a_caseBlock->get_dmisItemList())
    {
      std::list<dmisItem *> * theList;
      std::list<dmisItem *>::iterator iter;
      theList = a_caseBlock->get_dmisItemList();
      adjustLevels(&caseBlockAtts_a_dmisItemList, "caseBlock a_dmisItemList");
      if (log && !findString("a_dmisItemList", caseBlockAtts))
	{
	  warnAttBlock("dmisItemList",
	    a_caseBlock->get_dmisItemList()->front());
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_dmisItem(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_dmisItem(*iter, log);
	}
    }
  if (a_caseBlock->get_endcasStm())
    {
      adjustLevels(&caseBlockAtts_a_endcasStm, "caseBlock a_endcasStm");
      if (log && !findString("a_endcasStm", caseBlockAtts))
	{
	  warnAttBlock("endcasStm", a_caseBlock->get_endcasStm());
	}
    }
}

/********************************************************************/

void check_caseStm(
 caseStm * a_caseStm,
 int log)
{
  if (isA(a_caseStm, caseStmInt))
    {
      adjustLevels(&caseStmSubs_caseStmInt, "caseStmInt");
      if (log && !findString("caseStmInt", caseStmSubs))
	{
	  warnSub("caseStmInt", "caseStm", a_caseStm);
	  check_caseStmInt(dynamic_cast<caseStmInt *>(a_caseStm), 0);
	}
      else
	check_caseStmInt(dynamic_cast<caseStmInt *>(a_caseStm), log);
      return;
    }
  if (isA(a_caseStm, caseStmString))
    {
      adjustLevels(&caseStmSubs_caseStmString, "caseStmString");
      if (log && !findString("caseStmString", caseStmSubs))
	{
	  warnSub("caseStmString", "caseStm", a_caseStm);
	  check_caseStmString(dynamic_cast<caseStmString *>(a_caseStm), 0);
	}
      else
	check_caseStmString(dynamic_cast<caseStmString *>(a_caseStm), log);
      return;
    }
}

/********************************************************************/

void check_caseStmInt(
 caseStmInt * a_caseStmInt,
 int log)
{
  if (a_caseStmInt->get_sign())
    {
      adjustLevels(&caseStmIntAtts_a_sign, "caseStmInt a_sign");
      if (log && !findString("a_sign", caseStmIntAtts))
	{
	  warnAtt("a_sign", "caseStmInt", a_caseStmInt);
	  check_sign(a_caseStmInt->get_sign(), 0);
	}
      else
	check_sign(a_caseStmInt->get_sign(), log);
    }
  if (a_caseStmInt->get_intConst())
    {
      adjustLevels(&caseStmIntAtts_a_intConst, "caseStmInt a_intConst");
      if (log && !findString("a_intConst", caseStmIntAtts))
	{
	  warnAtt("a_intConst", "caseStmInt", a_caseStmInt);
	  check_intConst(a_caseStmInt->get_intConst(), 0);
	}
      else
	check_intConst(a_caseStmInt->get_intConst(), log);
    }
}

/********************************************************************/

void check_caseStmString(
 caseStmString * a_caseStmString,
 int log)
{
  if (a_caseStmString->get_stringConst())
    {
      adjustLevels(&caseStmStringAtts_a_stringConst,
		   "caseStmString a_stringConst");
      if (log && !findString("a_stringConst", caseStmStringAtts))
	{
	  warnAtt("a_stringConst", "caseStmString", a_caseStmString);
	  check_stringConst(a_caseStmString->get_stringConst(), 0);
	}
      else
	check_stringConst(a_caseStmString->get_stringConst(), log);
    }
}

/********************************************************************/

void check_ccLabel(
 ccLabel * a_ccLabel,
 int log)
{
  if (a_ccLabel->get_labelName())
    {
      adjustLevels(&ccLabelAtts_a_labelName, "ccLabel a_labelName");
      if (log && !findString("a_labelName", ccLabelAtts))
	{
	  warnAtt("a_labelName", "ccLabel", a_ccLabel);
	  check_labelName(a_ccLabel->get_labelName(), 0);
	}
      else
	check_labelName(a_ccLabel->get_labelName(), log);
    }
}

/********************************************************************/

void check_ciLabel(
 ciLabel * a_ciLabel,
 int log)
{
  if (a_ciLabel->get_labelName())
    {
      adjustLevels(&ciLabelAtts_a_labelName, "ciLabel a_labelName");
      if (log && !findString("a_labelName", ciLabelAtts))
	{
	  warnAtt("a_labelName", "ciLabel", a_ciLabel);
	  check_labelName(a_ciLabel->get_labelName(), 0);
	}
      else
	check_labelName(a_ciLabel->get_labelName(), log);
    }
}

/********************************************************************/

void check_clmpidStm(
 clmpidStm * a_clmpidStm,
 int log)
{
  if (a_clmpidStm->get_ciLabel())
    {
      adjustLevels(&clmpidStmAtts_a_ciLabel, "clmpidStm a_ciLabel");
      if (log && !findString("a_ciLabel", clmpidStmAtts))
	{
	  warnAtt("a_ciLabel", "clmpidStm", a_clmpidStm);
	  check_ciLabel(a_clmpidStm->get_ciLabel(), 0);
	}
      else
	check_ciLabel(a_clmpidStm->get_ciLabel(), log);
    }
  if (a_clmpidStm->get_text())
    {
      adjustLevels(&clmpidStmAtts_text, "clmpidStm text");
      if (log && !findString("text", clmpidStmAtts))
	{
	  warnAtt("text", "clmpidStm", a_clmpidStm);
	  check_stringVal(a_clmpidStm->get_text(), 0);
	}
      else
	check_stringVal(a_clmpidStm->get_text(), log);
    }
}

/********************************************************************/

void check_clmpsnStm(
 clmpsnStm * a_clmpsnStm,
 int log)
{
  if (a_clmpsnStm->get_csLabel())
    {
      adjustLevels(&clmpsnStmAtts_a_csLabel, "clmpsnStm a_csLabel");
      if (log && !findString("a_csLabel", clmpsnStmAtts))
	{
	  warnAtt("a_csLabel", "clmpsnStm", a_clmpsnStm);
	  check_csLabel(a_clmpsnStm->get_csLabel(), 0);
	}
      else
	check_csLabel(a_clmpsnStm->get_csLabel(), log);
    }
  if (a_clmpsnStm->get_text())
    {
      adjustLevels(&clmpsnStmAtts_text, "clmpsnStm text");
      if (log && !findString("text", clmpsnStmAtts))
	{
	  warnAtt("text", "clmpsnStm", a_clmpsnStm);
	  check_stringVal(a_clmpsnStm->get_text(), 0);
	}
      else
	check_stringVal(a_clmpsnStm->get_text(), log);
    }
}

/********************************************************************/

void check_closeDelete(
 closeDelete * a_closeDelete,
 int log)
{
  if (a_closeDelete->get_didLabel())
    {
      adjustLevels(&closeDeleteAtts_a_didLabel, "closeDelete a_didLabel");
      if (log && !findString("a_didLabel", closeDeleteAtts))
	{
	  warnAtt("a_didLabel", "closeDelete", a_closeDelete);
	  check_didLabel(a_closeDelete->get_didLabel(), 0);
	}
      else
	check_didLabel(a_closeDelete->get_didLabel(), log);
    }
}

/********************************************************************/

void check_closeEnd(
 closeEnd * a_closeEnd,
 int log)
{
  if (a_closeEnd->get_didLabel())
    {
      adjustLevels(&closeEndAtts_a_didLabel, "closeEnd a_didLabel");
      if (log && !findString("a_didLabel", closeEndAtts))
	{
	  warnAtt("a_didLabel", "closeEnd", a_closeEnd);
	  check_didLabel(a_closeEnd->get_didLabel(), 0);
	}
      else
	check_didLabel(a_closeEnd->get_didLabel(), log);
    }
}

/********************************************************************/

void check_closeKeep(
 closeKeep * a_closeKeep,
 int log)
{
  if (a_closeKeep->get_didLabel())
    {
      adjustLevels(&closeKeepAtts_a_didLabel, "closeKeep a_didLabel");
      if (log && !findString("a_didLabel", closeKeepAtts))
	{
	  warnAtt("a_didLabel", "closeKeep", a_closeKeep);
	  check_didLabel(a_closeKeep->get_didLabel(), 0);
	}
      else
	check_didLabel(a_closeKeep->get_didLabel(), log);
    }
}

/********************************************************************/

void check_closeMinor(
 closeMinor * a_closeMinor,
 int log)
{
  if (isA(a_closeMinor, closePlain))
    {
      adjustLevels(&closeMinorSubs_closePlain, "closePlain");
      if (log && !findString("closePlain", closeMinorSubs))
	{
	  warnSub("closePlain", "closeMinor", a_closeMinor);
	  check_closePlain(dynamic_cast<closePlain *>(a_closeMinor), 0);
	}
      else
	check_closePlain(dynamic_cast<closePlain *>(a_closeMinor), log);
      return;
    }
  if (isA(a_closeMinor, closeKeep))
    {
      adjustLevels(&closeMinorSubs_closeKeep, "closeKeep");
      if (log && !findString("closeKeep", closeMinorSubs))
	{
	  warnSub("closeKeep", "closeMinor", a_closeMinor);
	  check_closeKeep(dynamic_cast<closeKeep *>(a_closeMinor), 0);
	}
      else
	check_closeKeep(dynamic_cast<closeKeep *>(a_closeMinor), log);
      return;
    }
  if (isA(a_closeMinor, closeDelete))
    {
      adjustLevels(&closeMinorSubs_closeDelete, "closeDelete");
      if (log && !findString("closeDelete", closeMinorSubs))
	{
	  warnSub("closeDelete", "closeMinor", a_closeMinor);
	  check_closeDelete(dynamic_cast<closeDelete *>(a_closeMinor), 0);
	}
      else
	check_closeDelete(dynamic_cast<closeDelete *>(a_closeMinor), log);
      return;
    }
  if (isA(a_closeMinor, closeEnd))
    {
      adjustLevels(&closeMinorSubs_closeEnd, "closeEnd");
      if (log && !findString("closeEnd", closeMinorSubs))
	{
	  warnSub("closeEnd", "closeMinor", a_closeMinor);
	  check_closeEnd(dynamic_cast<closeEnd *>(a_closeMinor), 0);
	}
      else
	check_closeEnd(dynamic_cast<closeEnd *>(a_closeMinor), log);
      return;
    }
}

/********************************************************************/

void check_closePlain(
 closePlain * a_closePlain,
 int log)
{
  if (a_closePlain->get_didLabel())
    {
      adjustLevels(&closePlainAtts_a_didLabel, "closePlain a_didLabel");
      if (log && !findString("a_didLabel", closePlainAtts))
	{
	  warnAtt("a_didLabel", "closePlain", a_closePlain);
	  check_didLabel(a_closePlain->get_didLabel(), 0);
	}
      else
	check_didLabel(a_closePlain->get_didLabel(), log);
    }
}

/********************************************************************/

void check_closeStm(
 closeStm * a_closeStm,
 int log)
{
  if (a_closeStm->get_closeMinor())
    {
      adjustLevels(&closeStmAtts_a_closeMinor, "closeStm a_closeMinor");
      if (log && !findString("a_closeMinor", closeStmAtts))
	{
	  warnAtt("a_closeMinor", "closeStm", a_closeStm);
	  check_closeMinor(a_closeStm->get_closeMinor(), 0);
	}
      else
	check_closeMinor(a_closeStm->get_closeMinor(), log);
    }
}

/********************************************************************/

void check_cmpntgrpSpec(
 cmpntgrpSpec * a_cmpntgrpSpec,
 int log)
{
  if (isA(a_cmpntgrpSpec, sgLabel))
    {
      adjustLevels(&cmpntgrpSpecSubs_sgLabel, "sgLabel");
      if (log && !findString("sgLabel", cmpntgrpSpecSubs))
	{
	  warnSub("sgLabel", "cmpntgrpSpec", a_cmpntgrpSpec);
	  check_sgLabel(dynamic_cast<sgLabel *>(a_cmpntgrpSpec), 0);
	}
      else
	check_sgLabel(dynamic_cast<sgLabel *>(a_cmpntgrpSpec), log);
      return;
    }
  if (isA(a_cmpntgrpSpec, swLabel))
    {
      adjustLevels(&cmpntgrpSpecSubs_swLabel, "swLabel");
      if (log && !findString("swLabel", cmpntgrpSpecSubs))
	{
	  warnSub("swLabel", "cmpntgrpSpec", a_cmpntgrpSpec);
	  check_swLabel(dynamic_cast<swLabel *>(a_cmpntgrpSpec), 0);
	}
      else
	check_swLabel(dynamic_cast<swLabel *>(a_cmpntgrpSpec), log);
      return;
    }
  if (isA(a_cmpntgrpSpec, sxLabel))
    {
      adjustLevels(&cmpntgrpSpecSubs_sxLabel, "sxLabel");
      if (log && !findString("sxLabel", cmpntgrpSpecSubs))
	{
	  warnSub("sxLabel", "cmpntgrpSpec", a_cmpntgrpSpec);
	  check_sxLabel(dynamic_cast<sxLabel *>(a_cmpntgrpSpec), 0);
	}
      else
	check_sxLabel(dynamic_cast<sxLabel *>(a_cmpntgrpSpec), log);
      return;
    }
  if (isA(a_cmpntgrpSpec, rmLabel))
    {
      adjustLevels(&cmpntgrpSpecSubs_rmLabel, "rmLabel");
      if (log && !findString("rmLabel", cmpntgrpSpecSubs))
	{
	  warnSub("rmLabel", "cmpntgrpSpec", a_cmpntgrpSpec);
	  check_rmLabel(dynamic_cast<rmLabel *>(a_cmpntgrpSpec), 0);
	}
      else
	check_rmLabel(dynamic_cast<rmLabel *>(a_cmpntgrpSpec), log);
      return;
    }
}

/********************************************************************/

void check_cmpntgrpStm(
 cmpntgrpStm * a_cmpntgrpStm,
 int log)
{
  if (a_cmpntgrpStm->get_sgLabel())
    {
      adjustLevels(&cmpntgrpStmAtts_a_sgLabel, "cmpntgrpStm a_sgLabel");
      if (log && !findString("a_sgLabel", cmpntgrpStmAtts))
	{
	  warnAtt("a_sgLabel", "cmpntgrpStm", a_cmpntgrpStm);
	  check_sgLabel(a_cmpntgrpStm->get_sgLabel(), 0);
	}
      else
	check_sgLabel(a_cmpntgrpStm->get_sgLabel(), log);
    }
  if (a_cmpntgrpStm->get_cmpntgrpSpecList())
    {
      std::list<cmpntgrpSpec *> * theList;
      std::list<cmpntgrpSpec *>::iterator iter;
      theList = a_cmpntgrpStm->get_cmpntgrpSpecList();
      adjustLevels(&cmpntgrpStmAtts_a_cmpntgrpSpecList,
		   "cmpntgrpStm a_cmpntgrpSpecList");
      if (log && !findString("a_cmpntgrpSpecList", cmpntgrpStmAtts))
	{
	  warnAtt("a_cmpntgrpSpecList", "cmpntgrpStm", a_cmpntgrpStm);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_cmpntgrpSpec(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_cmpntgrpSpec(*iter, log);
	}
    }
}

/********************************************************************/

void check_cnfrmrulCode(
 cnfrmrulCode * a_cnfrmrulCode,
 int log)
{
  if (a_cnfrmrulCode->get_code())
    {
      adjustLevels(&cnfrmrulCodeAtts_code, "cnfrmrulCode code");
      if (log && !findString("code", cnfrmrulCodeAtts))
	{
	  warnAtt("code", "cnfrmrulCode", a_cnfrmrulCode);
	  check_intVal(a_cnfrmrulCode->get_code(), 0);
	}
      else
	check_intVal(a_cnfrmrulCode->get_code(), log);
    }
}

/********************************************************************/

void check_cnfrmrulMinor(
 cnfrmrulMinor * a_cnfrmrulMinor,
 int log)
{
  if (isA(a_cnfrmrulMinor, cnfrmrulCode))
    {
      adjustLevels(&cnfrmrulMinorSubs_cnfrmrulCode, "cnfrmrulCode");
      if (log && !findString("cnfrmrulCode", cnfrmrulMinorSubs))
	{
	  warnSub("cnfrmrulCode", "cnfrmrulMinor", a_cnfrmrulMinor);
	  check_cnfrmrulCode(
	    dynamic_cast<cnfrmrulCode *>(a_cnfrmrulMinor), 0);
	}
      else
	check_cnfrmrulCode(
	  dynamic_cast<cnfrmrulCode *>(a_cnfrmrulMinor), log);
      return;
    }
  if (isA(a_cnfrmrulMinor, cnfrmrulName))
    {
      adjustLevels(&cnfrmrulMinorSubs_cnfrmrulName, "cnfrmrulName");
      if (log && !findString("cnfrmrulName", cnfrmrulMinorSubs))
	{
	  warnSub("cnfrmrulName", "cnfrmrulMinor", a_cnfrmrulMinor);
	  check_cnfrmrulName(
	    dynamic_cast<cnfrmrulName *>(a_cnfrmrulMinor), 0);
	}
      else
	check_cnfrmrulName(
	  dynamic_cast<cnfrmrulName *>(a_cnfrmrulMinor), log);
      return;
    }
}

/********************************************************************/

void check_cnfrmrulName(
 cnfrmrulName * a_cnfrmrulName,
 int log)
{
  if (a_cnfrmrulName->get_name())
    {
      adjustLevels(&cnfrmrulNameAtts_name, "cnfrmrulName name");
      if (log && !findString("name", cnfrmrulNameAtts))
	{
	  warnAtt("name", "cnfrmrulName", a_cnfrmrulName);
	  check_stringVal(a_cnfrmrulName->get_name(), 0);
	}
      else
	check_stringVal(a_cnfrmrulName->get_name(), log);
    }
  if (a_cnfrmrulName->get_paramList())
    {
      std::list<param *> * theList;
      std::list<param *>::iterator iter;
      theList = a_cnfrmrulName->get_paramList();
      adjustLevels(&cnfrmrulNameAtts_a_paramList, "cnfrmrulName a_paramList");
      if (log && !findString("a_paramList", cnfrmrulNameAtts))
	{
	  warnAtt("a_paramList", "cnfrmrulName", a_cnfrmrulName);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_param(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_param(*iter, log);
	}
    }
}

/********************************************************************/

void check_cnfrmrulStm(
 cnfrmrulStm * a_cnfrmrulStm,
 int log)
{
  if (a_cnfrmrulStm->get_drLabel())
    {
      adjustLevels(&cnfrmrulStmAtts_a_drLabel, "cnfrmrulStm a_drLabel");
      if (log && !findString("a_drLabel", cnfrmrulStmAtts))
	{
	  warnAtt("a_drLabel", "cnfrmrulStm", a_cnfrmrulStm);
	  check_drLabel(a_cnfrmrulStm->get_drLabel(), 0);
	}
      else
	check_drLabel(a_cnfrmrulStm->get_drLabel(), log);
    }
  if (a_cnfrmrulStm->get_cnfrmrulMinor())
    {
      adjustLevels(&cnfrmrulStmAtts_a_cnfrmrulMinor,
		   "cnfrmrulStm a_cnfrmrulMinor");
      if (log && !findString("a_cnfrmrulMinor", cnfrmrulStmAtts))
	{
	  warnAtt("a_cnfrmrulMinor", "cnfrmrulStm", a_cnfrmrulStm);
	  check_cnfrmrulMinor(a_cnfrmrulStm->get_cnfrmrulMinor(), 0);
	}
      else
	check_cnfrmrulMinor(a_cnfrmrulStm->get_cnfrmrulMinor(), log);
    }
}

/********************************************************************/

void check_cogConst(
 cogConst * a_cogConst,
 int log)
{
  if (a_cogConst->get_featureList())
    {
      std::list<featureLabel *> * theList;
      std::list<featureLabel *>::iterator iter;
      theList = a_cogConst->get_featureList();
      adjustLevels(&cogConstAtts_a_featureList, "cogConst a_featureList");
      if (log && !findString("a_featureList", cogConstAtts))
	{
	  warnAtt("a_featureList", "cogConst", a_cogConst);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_featureLabel(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_featureLabel(*iter, log);
	}
    }
}

/********************************************************************/

void check_coneConst(
 coneConst * a_coneConst,
 int log)
{
  if (isA(a_coneConst, coneConst_DIAM))
    {
      adjustLevels(&coneConstSubs_coneConst_DIAM, "coneConst_DIAM");
      if (log && !findString("coneConst_DIAM", coneConstSubs))
	{
	  warnSub("coneConst_DIAM", "coneConst", a_coneConst);
	  check_coneConst_DIAM(
	    dynamic_cast<coneConst_DIAM *>(a_coneConst), 0);
	}
      else
	check_coneConst_DIAM(
	  dynamic_cast<coneConst_DIAM *>(a_coneConst), log);
      return;
    }
  if (isA(a_coneConst, coneConst_DIST))
    {
      adjustLevels(&coneConstSubs_coneConst_DIST, "coneConst_DIST");
      if (log && !findString("coneConst_DIST", coneConstSubs))
	{
	  warnSub("coneConst_DIST", "coneConst", a_coneConst);
	  check_coneConst_DIST(
	    dynamic_cast<coneConst_DIST *>(a_coneConst), 0);
	}
      else
	check_coneConst_DIST(
	  dynamic_cast<coneConst_DIST *>(a_coneConst), log);
      return;
    }
}

/********************************************************************/

void check_coneConst_DIAM(
 coneConst_DIAM * a_coneConst_DIAM,
 int log)
{
  if (a_coneConst_DIAM->get_diam())
    {
      adjustLevels(&coneConst_DIAMAtts_diam, "coneConst_DIAM diam");
      if (log && !findString("diam", coneConst_DIAMAtts))
	{
	  warnAtt("diam", "coneConst_DIAM", a_coneConst_DIAM);
	  check_rentVal(a_coneConst_DIAM->get_diam(), 0);
	}
      else
	check_rentVal(a_coneConst_DIAM->get_diam(), log);
    }
  if (a_coneConst_DIAM->get_faLabel())
    {
      adjustLevels(&coneConst_DIAMAtts_a_faLabel, "coneConst_DIAM a_faLabel");
      if (log && !findString("a_faLabel", coneConst_DIAMAtts))
	{
	  warnAtt("a_faLabel", "coneConst_DIAM", a_coneConst_DIAM);
	  check_faLabel(a_coneConst_DIAM->get_faLabel(), 0);
	}
      else
	check_faLabel(a_coneConst_DIAM->get_faLabel(), log);
    }
}

/********************************************************************/

void check_coneConst_DIST(
 coneConst_DIST * a_coneConst_DIST,
 int log)
{
  if (a_coneConst_DIST->get_dist())
    {
      adjustLevels(&coneConst_DISTAtts_dist, "coneConst_DIST dist");
      if (log && !findString("dist", coneConst_DISTAtts))
	{
	  warnAtt("dist", "coneConst_DIST", a_coneConst_DIST);
	  check_rentVal(a_coneConst_DIST->get_dist(), 0);
	}
      else
	check_rentVal(a_coneConst_DIST->get_dist(), log);
    }
  if (a_coneConst_DIST->get_faLabel())
    {
      adjustLevels(&coneConst_DISTAtts_a_faLabel, "coneConst_DIST a_faLabel");
      if (log && !findString("a_faLabel", coneConst_DISTAtts))
	{
	  warnAtt("a_faLabel", "coneConst_DIST", a_coneConst_DIST);
	  check_faLabel(a_coneConst_DIST->get_faLabel(), 0);
	}
      else
	check_faLabel(a_coneConst_DIST->get_faLabel(), log);
    }
}

/********************************************************************/

void check_conformItem(
 conformItem * a_conformItem,
 int log)
{
  if (a_conformItem->get_conformType())
    {
      adjustLevels(&conformItemAtts_a_conformType,
		   "conformItem a_conformType");
      if (log && !findString("a_conformType", conformItemAtts))
	{
	  warnAtt("a_conformType", "conformItem", a_conformItem);
	  check_conformType(a_conformItem->get_conformType(), 0);
	}
      else
	check_conformType(a_conformItem->get_conformType(), log);
    }
  if (a_conformItem->get_int())
    {
      adjustLevels(&conformItemAtts_a_int, "conformItem a_int");
      if (log && !findString("a_int", conformItemAtts))
	{
	  warnAtt("a_int", "conformItem", a_conformItem);
	}
    }
}

/********************************************************************/

void check_conformType(
 conformType * a_conformType,
 int log)
{
  if (isA(a_conformType, conformType_CT))
    {
      adjustLevels(&conformTypeSubs_conformType_CT, "conformType_CT");
      if (log && !findString("conformType_CT", conformTypeSubs))
	{
	  warnSub("conformType_CT", "conformType", a_conformType);
	}
      return;
    }
  if (isA(a_conformType, conformType_FX))
    {
      adjustLevels(&conformTypeSubs_conformType_FX, "conformType_FX");
      if (log && !findString("conformType_FX", conformTypeSubs))
	{
	  warnSub("conformType_FX", "conformType", a_conformType);
	}
      return;
    }
  if (isA(a_conformType, conformType_IP))
    {
      adjustLevels(&conformTypeSubs_conformType_IP, "conformType_IP");
      if (log && !findString("conformType_IP", conformTypeSubs))
	{
	  warnSub("conformType_IP", "conformType", a_conformType);
	}
      return;
    }
  if (isA(a_conformType, conformType_MC))
    {
      adjustLevels(&conformTypeSubs_conformType_MC, "conformType_MC");
      if (log && !findString("conformType_MC", conformTypeSubs))
	{
	  warnSub("conformType_MC", "conformType", a_conformType);
	}
      return;
    }
  if (isA(a_conformType, conformType_MU))
    {
      adjustLevels(&conformTypeSubs_conformType_MU, "conformType_MU");
      if (log && !findString("conformType_MU", conformTypeSubs))
	{
	  warnSub("conformType_MU", "conformType", a_conformType);
	}
      return;
    }
  if (isA(a_conformType, conformType_PM))
    {
      adjustLevels(&conformTypeSubs_conformType_PM, "conformType_PM");
      if (log && !findString("conformType_PM", conformTypeSubs))
	{
	  warnSub("conformType_PM", "conformType", a_conformType);
	}
      return;
    }
  if (isA(a_conformType, conformType_QI))
    {
      adjustLevels(&conformTypeSubs_conformType_QI, "conformType_QI");
      if (log && !findString("conformType_QI", conformTypeSubs))
	{
	  warnSub("conformType_QI", "conformType", a_conformType);
	}
      return;
    }
  if (isA(a_conformType, conformType_RY))
    {
      adjustLevels(&conformTypeSubs_conformType_RY, "conformType_RY");
      if (log && !findString("conformType_RY", conformTypeSubs))
	{
	  warnSub("conformType_RY", "conformType", a_conformType);
	}
      return;
    }
  if (isA(a_conformType, conformType_SF))
    {
      adjustLevels(&conformTypeSubs_conformType_SF, "conformType_SF");
      if (log && !findString("conformType_SF", conformTypeSubs))
	{
	  warnSub("conformType_SF", "conformType", a_conformType);
	}
      return;
    }
  if (isA(a_conformType, conformType_TW))
    {
      adjustLevels(&conformTypeSubs_conformType_TW, "conformType_TW");
      if (log && !findString("conformType_TW", conformTypeSubs))
	{
	  warnSub("conformType_TW", "conformType", a_conformType);
	}
      return;
    }
}

/********************************************************************/

void check_constArc(
 constArc * a_constArc,
 int log)
{
  if (isA(a_constArc, constArc_bfConst))
    {
      adjustLevels(&constArcSubs_constArc_bfConst, "constArc_bfConst");
      if (log && !findString("constArc_bfConst", constArcSubs))
	{
	  warnSub("constArc_bfConst", "constArc", a_constArc);
	  check_constArc_bfConst(
	    dynamic_cast<constArc_bfConst *>(a_constArc), 0);
	}
      else
	check_constArc_bfConst(
	  dynamic_cast<constArc_bfConst *>(a_constArc), log);
      return;
    }
  if (isA(a_constArc, constArc_projctConst))
    {
      adjustLevels(&constArcSubs_constArc_projctConst, "constArc_projctConst");
      if (log && !findString("constArc_projctConst", constArcSubs))
	{
	  warnSub("constArc_projctConst", "constArc", a_constArc);
	  check_constArc_projctConst(
	    dynamic_cast<constArc_projctConst *>(a_constArc), 0);
	}
      else
	check_constArc_projctConst(
	  dynamic_cast<constArc_projctConst *>(a_constArc), log);
      return;
    }
  if (isA(a_constArc, constArc_trConst))
    {
      adjustLevels(&constArcSubs_constArc_trConst, "constArc_trConst");
      if (log && !findString("constArc_trConst", constArcSubs))
	{
	  warnSub("constArc_trConst", "constArc", a_constArc);
	  check_constArc_trConst(
	    dynamic_cast<constArc_trConst *>(a_constArc), 0);
	}
      else
	check_constArc_trConst(
	  dynamic_cast<constArc_trConst *>(a_constArc), log);
      return;
    }
}

/********************************************************************/

void check_constArc_bfConst(
 constArc_bfConst * a_constArc_bfConst,
 int log)
{
  if (a_constArc_bfConst->get_fLabel())
    {
      adjustLevels(&constArc_bfConstAtts_a_fLabel,
		   "constArc_bfConst a_fLabel");
      if (log && !findString("a_fLabel", constArc_bfConstAtts))
	{
	  warnAtt("a_fLabel", "constArc_bfConst", a_constArc_bfConst);
	  check_fLabel(a_constArc_bfConst->get_fLabel(), 0);
	}
      else
	check_fLabel(a_constArc_bfConst->get_fLabel(), log);
    }
  if (a_constArc_bfConst->get_bfConst())
    {
      adjustLevels(&constArc_bfConstAtts_a_bfConst,
		   "constArc_bfConst a_bfConst");
      if (log && !findString("a_bfConst", constArc_bfConstAtts))
	{
	  warnAtt("a_bfConst", "constArc_bfConst", a_constArc_bfConst);
	  check_bfConst(a_constArc_bfConst->get_bfConst(), 0);
	}
      else
	check_bfConst(a_constArc_bfConst->get_bfConst(), log);
    }
}

/********************************************************************/

void check_constArc_projctConst(
 constArc_projctConst * a_constArc_projctConst,
 int log)
{
  if (a_constArc_projctConst->get_fLabel())
    {
      adjustLevels(&constArc_projctConstAtts_a_fLabel,
		   "constArc_projctConst a_fLabel");
      if (log && !findString("a_fLabel", constArc_projctConstAtts))
	{
	  warnAtt("a_fLabel", "constArc_projctConst", a_constArc_projctConst);
	  check_fLabel(a_constArc_projctConst->get_fLabel(), 0);
	}
      else
	check_fLabel(a_constArc_projctConst->get_fLabel(), log);
    }
  if (a_constArc_projctConst->get_projctConst())
    {
      adjustLevels(&constArc_projctConstAtts_a_projctConst,
		   "constArc_projctConst a_projctConst");
      if (log && !findString("a_projctConst", constArc_projctConstAtts))
	{
	  warnAtt("a_projctConst", "constArc_projctConst",
		  a_constArc_projctConst);
	  check_projctConst(a_constArc_projctConst->get_projctConst(), 0);
	}
      else
	check_projctConst(a_constArc_projctConst->get_projctConst(), log);
    }
}

/********************************************************************/

void check_constArc_trConst(
 constArc_trConst * a_constArc_trConst,
 int log)
{
  if (a_constArc_trConst->get_fLabel())
    {
      adjustLevels(&constArc_trConstAtts_a_fLabel,
		   "constArc_trConst a_fLabel");
      if (log && !findString("a_fLabel", constArc_trConstAtts))
	{
	  warnAtt("a_fLabel", "constArc_trConst", a_constArc_trConst);
	  check_fLabel(a_constArc_trConst->get_fLabel(), 0);
	}
      else
	check_fLabel(a_constArc_trConst->get_fLabel(), log);
    }
  if (a_constArc_trConst->get_trConst())
    {
      adjustLevels(&constArc_trConstAtts_a_trConst,
		   "constArc_trConst a_trConst");
      if (log && !findString("a_trConst", constArc_trConstAtts))
	{
	  warnAtt("a_trConst", "constArc_trConst", a_constArc_trConst);
	  check_trConst(a_constArc_trConst->get_trConst(), 0);
	}
      else
	check_trConst(a_constArc_trConst->get_trConst(), log);
    }
}

/********************************************************************/

void check_constCircle(
 constCircle * a_constCircle,
 int log)
{
  if (isA(a_constCircle, constCircle_bfConst))
    {
      adjustLevels(&constCircleSubs_constCircle_bfConst,
		   "constCircle_bfConst");
      if (log && !findString("constCircle_bfConst", constCircleSubs))
	{
	  warnSub("constCircle_bfConst", "constCircle", a_constCircle);
	  check_constCircle_bfConst(
	    dynamic_cast<constCircle_bfConst *>(a_constCircle), 0);
	}
      else
	check_constCircle_bfConst(
	  dynamic_cast<constCircle_bfConst *>(a_constCircle), log);
      return;
    }
  if (isA(a_constCircle, constCircle_coneConst))
    {
      adjustLevels(&constCircleSubs_constCircle_coneConst,
		   "constCircle_coneConst");
      if (log && !findString("constCircle_coneConst", constCircleSubs))
	{
	  warnSub("constCircle_coneConst", "constCircle", a_constCircle);
	  check_constCircle_coneConst(
	    dynamic_cast<constCircle_coneConst *>(a_constCircle), 0);
	}
      else
	check_constCircle_coneConst(
	  dynamic_cast<constCircle_coneConst *>(a_constCircle), log);
      return;
    }
  if (isA(a_constCircle, constCircle_intofConst))
    {
      adjustLevels(&constCircleSubs_constCircle_intofConst,
		   "constCircle_intofConst");
      if (log && !findString("constCircle_intofConst", constCircleSubs))
	{
	  warnSub("constCircle_intofConst", "constCircle", a_constCircle);
	  check_constCircle_intofConst(
	    dynamic_cast<constCircle_intofConst *>(a_constCircle), 0);
	}
      else
	check_constCircle_intofConst(
	  dynamic_cast<constCircle_intofConst *>(a_constCircle), log);
      return;
    }
  if (isA(a_constCircle, constCircle_projctConst))
    {
      adjustLevels(&constCircleSubs_constCircle_projctConst,
		   "constCircle_projctConst");
      if (log && !findString("constCircle_projctConst", constCircleSubs))
	{
	  warnSub("constCircle_projctConst", "constCircle", a_constCircle);
	  check_constCircle_projctConst(
	    dynamic_cast<constCircle_projctConst *>(a_constCircle), 0);
	}
      else
	check_constCircle_projctConst(
	  dynamic_cast<constCircle_projctConst *>(a_constCircle), log);
      return;
    }
  if (isA(a_constCircle, constCircle_tantoConst))
    {
      adjustLevels(&constCircleSubs_constCircle_tantoConst,
		   "constCircle_tantoConst");
      if (log && !findString("constCircle_tantoConst", constCircleSubs))
	{
	  warnSub("constCircle_tantoConst", "constCircle", a_constCircle);
	  check_constCircle_tantoConst(
	    dynamic_cast<constCircle_tantoConst *>(a_constCircle), 0);
	}
      else
	check_constCircle_tantoConst(
	  dynamic_cast<constCircle_tantoConst *>(a_constCircle), log);
      return;
    }
  if (isA(a_constCircle, constCircle_trConst))
    {
      adjustLevels(&constCircleSubs_constCircle_trConst,
		   "constCircle_trConst");
      if (log && !findString("constCircle_trConst", constCircleSubs))
	{
	  warnSub("constCircle_trConst", "constCircle", a_constCircle);
	  check_constCircle_trConst(
	    dynamic_cast<constCircle_trConst *>(a_constCircle), 0);
	}
      else
	check_constCircle_trConst(
	  dynamic_cast<constCircle_trConst *>(a_constCircle), log);
      return;
    }
  if (isA(a_constCircle, constCircle_retrieve2))
    {
      adjustLevels(&constCircleSubs_constCircle_retrieve2,
		   "constCircle_retrieve2");
      if (log && !findString("constCircle_retrieve2", constCircleSubs))
	{
	  warnSub("constCircle_retrieve2", "constCircle", a_constCircle);
	  check_constCircle_retrieve2(
	    dynamic_cast<constCircle_retrieve2 *>(a_constCircle), 0);
	}
      else
	check_constCircle_retrieve2(
	  dynamic_cast<constCircle_retrieve2 *>(a_constCircle), log);
      return;
    }
}

/********************************************************************/

void check_constCircle_bfConst(
 constCircle_bfConst * a_constCircle_bfConst,
 int log)
{
  if (a_constCircle_bfConst->get_fLabel())
    {
      adjustLevels(&constCircle_bfConstAtts_a_fLabel,
		   "constCircle_bfConst a_fLabel");
      if (log && !findString("a_fLabel", constCircle_bfConstAtts))
	{
	  warnAtt("a_fLabel", "constCircle_bfConst", a_constCircle_bfConst);
	  check_fLabel(a_constCircle_bfConst->get_fLabel(), 0);
	}
      else
	check_fLabel(a_constCircle_bfConst->get_fLabel(), log);
    }
  if (a_constCircle_bfConst->get_bfConst())
    {
      adjustLevels(&constCircle_bfConstAtts_a_bfConst,
		   "constCircle_bfConst a_bfConst");
      if (log && !findString("a_bfConst", constCircle_bfConstAtts))
	{
	  warnAtt("a_bfConst", "constCircle_bfConst", a_constCircle_bfConst);
	  check_bfConst(a_constCircle_bfConst->get_bfConst(), 0);
	}
      else
	check_bfConst(a_constCircle_bfConst->get_bfConst(), log);
    }
}

/********************************************************************/

void check_constCircle_coneConst(
 constCircle_coneConst * a_constCircle_coneConst,
 int log)
{
  if (a_constCircle_coneConst->get_fLabel())
    {
      adjustLevels(&constCircle_coneConstAtts_a_fLabel,
		   "constCircle_coneConst a_fLabel");
      if (log && !findString("a_fLabel", constCircle_coneConstAtts))
	{
	  warnAtt("a_fLabel", "constCircle_coneConst",
		  a_constCircle_coneConst);
	  check_fLabel(a_constCircle_coneConst->get_fLabel(), 0);
	}
      else
	check_fLabel(a_constCircle_coneConst->get_fLabel(), log);
    }
  if (a_constCircle_coneConst->get_coneConst())
    {
      adjustLevels(&constCircle_coneConstAtts_a_coneConst,
		   "constCircle_coneConst a_coneConst");
      if (log && !findString("a_coneConst", constCircle_coneConstAtts))
	{
	  warnAtt("a_coneConst", "constCircle_coneConst",
		  a_constCircle_coneConst);
	  check_coneConst(a_constCircle_coneConst->get_coneConst(), 0);
	}
      else
	check_coneConst(a_constCircle_coneConst->get_coneConst(), log);
    }
}

/********************************************************************/

void check_constCircle_intofConst(
 constCircle_intofConst * a_constCircle_intofConst,
 int log)
{
  if (a_constCircle_intofConst->get_fLabel())
    {
      adjustLevels(&constCircle_intofConstAtts_a_fLabel,
		   "constCircle_intofConst a_fLabel");
      if (log && !findString("a_fLabel", constCircle_intofConstAtts))
	{
	  warnAtt("a_fLabel", "constCircle_intofConst",
		  a_constCircle_intofConst);
	  check_fLabel(a_constCircle_intofConst->get_fLabel(), 0);
	}
      else
	check_fLabel(a_constCircle_intofConst->get_fLabel(), log);
    }
  if (a_constCircle_intofConst->get_intofConst())
    {
      adjustLevels(&constCircle_intofConstAtts_a_intofConst,
		   "constCircle_intofConst a_intofConst");
      if (log && !findString("a_intofConst", constCircle_intofConstAtts))
	{
	  warnAtt("a_intofConst", "constCircle_intofConst",
		  a_constCircle_intofConst);
	  check_intofConst(a_constCircle_intofConst->get_intofConst(), 0);
	}
      else
	check_intofConst(a_constCircle_intofConst->get_intofConst(), log);
    }
}

/********************************************************************/

void check_constCircle_projctConst(
 constCircle_projctConst * a_constCircle_projctConst,
 int log)
{
  if (a_constCircle_projctConst->get_fLabel())
    {
      adjustLevels(&constCircle_projctConstAtts_a_fLabel,
		   "constCircle_projctConst a_fLabel");
      if (log && !findString("a_fLabel", constCircle_projctConstAtts))
	{
	  warnAtt("a_fLabel", "constCircle_projctConst",
		  a_constCircle_projctConst);
	  check_fLabel(a_constCircle_projctConst->get_fLabel(), 0);
	}
      else
	check_fLabel(a_constCircle_projctConst->get_fLabel(), log);
    }
  if (a_constCircle_projctConst->get_projctConst())
    {
      adjustLevels(&constCircle_projctConstAtts_a_projctConst,
		   "constCircle_projctConst a_projctConst");
      if (log && !findString("a_projctConst", constCircle_projctConstAtts))
	{
	  warnAtt("a_projctConst", "constCircle_projctConst",
		  a_constCircle_projctConst);
	  check_projctConst(a_constCircle_projctConst->get_projctConst(), 0);
	}
      else
	check_projctConst(a_constCircle_projctConst->get_projctConst(), log);
    }
}

/********************************************************************/

void check_constCircle_retrieve2(
 constCircle_retrieve2 * a_constCircle_retrieve2,
 int log)
{
  if (a_constCircle_retrieve2->get_fLabel())
    {
      adjustLevels(&constCircle_retrieve2Atts_a_fLabel,
		   "constCircle_retrieve2 a_fLabel");
      if (log && !findString("a_fLabel", constCircle_retrieve2Atts))
	{
	  warnAtt("a_fLabel", "constCircle_retrieve2",
		  a_constCircle_retrieve2);
	  check_fLabel(a_constCircle_retrieve2->get_fLabel(), 0);
	}
      else
	check_fLabel(a_constCircle_retrieve2->get_fLabel(), log);
    }
  if (a_constCircle_retrieve2->get_retrieve2())
    {
      adjustLevels(&constCircle_retrieve2Atts_a_retrieve2,
		   "constCircle_retrieve2 a_retrieve2");
      if (log && !findString("a_retrieve2", constCircle_retrieve2Atts))
	{
	  warnAtt("a_retrieve2", "constCircle_retrieve2",
		  a_constCircle_retrieve2);
	  check_retrieve2(a_constCircle_retrieve2->get_retrieve2(), 0);
	}
      else
	check_retrieve2(a_constCircle_retrieve2->get_retrieve2(), log);
    }
}

/********************************************************************/

void check_constCircle_tantoConst(
 constCircle_tantoConst * a_constCircle_tantoConst,
 int log)
{
  if (a_constCircle_tantoConst->get_fLabel())
    {
      adjustLevels(&constCircle_tantoConstAtts_a_fLabel,
		   "constCircle_tantoConst a_fLabel");
      if (log && !findString("a_fLabel", constCircle_tantoConstAtts))
	{
	  warnAtt("a_fLabel", "constCircle_tantoConst",
		  a_constCircle_tantoConst);
	  check_fLabel(a_constCircle_tantoConst->get_fLabel(), 0);
	}
      else
	check_fLabel(a_constCircle_tantoConst->get_fLabel(), log);
    }
  if (a_constCircle_tantoConst->get_tantoConst())
    {
      adjustLevels(&constCircle_tantoConstAtts_a_tantoConst,
		   "constCircle_tantoConst a_tantoConst");
      if (log && !findString("a_tantoConst", constCircle_tantoConstAtts))
	{
	  warnAtt("a_tantoConst", "constCircle_tantoConst",
		  a_constCircle_tantoConst);
	  check_tantoConst(a_constCircle_tantoConst->get_tantoConst(), 0);
	}
      else
	check_tantoConst(a_constCircle_tantoConst->get_tantoConst(), log);
    }
}

/********************************************************************/

void check_constCircle_trConst(
 constCircle_trConst * a_constCircle_trConst,
 int log)
{
  if (a_constCircle_trConst->get_fLabel())
    {
      adjustLevels(&constCircle_trConstAtts_a_fLabel,
		   "constCircle_trConst a_fLabel");
      if (log && !findString("a_fLabel", constCircle_trConstAtts))
	{
	  warnAtt("a_fLabel", "constCircle_trConst", a_constCircle_trConst);
	  check_fLabel(a_constCircle_trConst->get_fLabel(), 0);
	}
      else
	check_fLabel(a_constCircle_trConst->get_fLabel(), log);
    }
  if (a_constCircle_trConst->get_trConst())
    {
      adjustLevels(&constCircle_trConstAtts_a_trConst,
		   "constCircle_trConst a_trConst");
      if (log && !findString("a_trConst", constCircle_trConstAtts))
	{
	  warnAtt("a_trConst", "constCircle_trConst", a_constCircle_trConst);
	  check_trConst(a_constCircle_trConst->get_trConst(), 0);
	}
      else
	check_trConst(a_constCircle_trConst->get_trConst(), log);
    }
}

/********************************************************************/

void check_constCompound(
 constCompound * a_constCompound,
 int log)
{
  if (a_constCompound->get_fLabel())
    {
      adjustLevels(&constCompoundAtts_a_fLabel, "constCompound a_fLabel");
      if (log && !findString("a_fLabel", constCompoundAtts))
	{
	  warnAtt("a_fLabel", "constCompound", a_constCompound);
	  check_fLabel(a_constCompound->get_fLabel(), 0);
	}
      else
	check_fLabel(a_constCompound->get_fLabel(), log);
    }
}

/********************************************************************/

void check_constCone(
 constCone * a_constCone,
 int log)
{
  if (isA(a_constCone, constCone_bfConst))
    {
      adjustLevels(&constConeSubs_constCone_bfConst, "constCone_bfConst");
      if (log && !findString("constCone_bfConst", constConeSubs))
	{
	  warnSub("constCone_bfConst", "constCone", a_constCone);
	  check_constCone_bfConst(
	    dynamic_cast<constCone_bfConst *>(a_constCone), 0);
	}
      else
	check_constCone_bfConst(
	  dynamic_cast<constCone_bfConst *>(a_constCone), log);
      return;
    }
  if (isA(a_constCone, constCone_trConst))
    {
      adjustLevels(&constConeSubs_constCone_trConst, "constCone_trConst");
      if (log && !findString("constCone_trConst", constConeSubs))
	{
	  warnSub("constCone_trConst", "constCone", a_constCone);
	  check_constCone_trConst(
	    dynamic_cast<constCone_trConst *>(a_constCone), 0);
	}
      else
	check_constCone_trConst(
	  dynamic_cast<constCone_trConst *>(a_constCone), log);
      return;
    }
}

/********************************************************************/

void check_constCone_bfConst(
 constCone_bfConst * a_constCone_bfConst,
 int log)
{
  if (a_constCone_bfConst->get_fLabel())
    {
      adjustLevels(&constCone_bfConstAtts_a_fLabel,
		   "constCone_bfConst a_fLabel");
      if (log && !findString("a_fLabel", constCone_bfConstAtts))
	{
	  warnAtt("a_fLabel", "constCone_bfConst", a_constCone_bfConst);
	  check_fLabel(a_constCone_bfConst->get_fLabel(), 0);
	}
      else
	check_fLabel(a_constCone_bfConst->get_fLabel(), log);
    }
  if (a_constCone_bfConst->get_bfConst())
    {
      adjustLevels(&constCone_bfConstAtts_a_bfConst,
		   "constCone_bfConst a_bfConst");
      if (log && !findString("a_bfConst", constCone_bfConstAtts))
	{
	  warnAtt("a_bfConst", "constCone_bfConst", a_constCone_bfConst);
	  check_bfConst(a_constCone_bfConst->get_bfConst(), 0);
	}
      else
	check_bfConst(a_constCone_bfConst->get_bfConst(), log);
    }
}

/********************************************************************/

void check_constCone_trConst(
 constCone_trConst * a_constCone_trConst,
 int log)
{
  if (a_constCone_trConst->get_fLabel())
    {
      adjustLevels(&constCone_trConstAtts_a_fLabel,
		   "constCone_trConst a_fLabel");
      if (log && !findString("a_fLabel", constCone_trConstAtts))
	{
	  warnAtt("a_fLabel", "constCone_trConst", a_constCone_trConst);
	  check_fLabel(a_constCone_trConst->get_fLabel(), 0);
	}
      else
	check_fLabel(a_constCone_trConst->get_fLabel(), log);
    }
  if (a_constCone_trConst->get_trConst())
    {
      adjustLevels(&constCone_trConstAtts_a_trConst,
		   "constCone_trConst a_trConst");
      if (log && !findString("a_trConst", constCone_trConstAtts))
	{
	  warnAtt("a_trConst", "constCone_trConst", a_constCone_trConst);
	  check_trConst(a_constCone_trConst->get_trConst(), 0);
	}
      else
	check_trConst(a_constCone_trConst->get_trConst(), log);
    }
}

/********************************************************************/

void check_constCparln(
 constCparln * a_constCparln,
 int log)
{
  if (isA(a_constCparln, constCparln_bfConst))
    {
      adjustLevels(&constCparlnSubs_constCparln_bfConst,
		   "constCparln_bfConst");
      if (log && !findString("constCparln_bfConst", constCparlnSubs))
	{
	  warnSub("constCparln_bfConst", "constCparln", a_constCparln);
	  check_constCparln_bfConst(
	    dynamic_cast<constCparln_bfConst *>(a_constCparln), 0);
	}
      else
	check_constCparln_bfConst(
	  dynamic_cast<constCparln_bfConst *>(a_constCparln), log);
      return;
    }
  if (isA(a_constCparln, constCparln_projctConst))
    {
      adjustLevels(&constCparlnSubs_constCparln_projctConst,
		   "constCparln_projctConst");
      if (log && !findString("constCparln_projctConst", constCparlnSubs))
	{
	  warnSub("constCparln_projctConst", "constCparln", a_constCparln);
	  check_constCparln_projctConst(
	    dynamic_cast<constCparln_projctConst *>(a_constCparln), 0);
	}
      else
	check_constCparln_projctConst(
	  dynamic_cast<constCparln_projctConst *>(a_constCparln), log);
      return;
    }
  if (isA(a_constCparln, constCparln_trConst))
    {
      adjustLevels(&constCparlnSubs_constCparln_trConst,
		   "constCparln_trConst");
      if (log && !findString("constCparln_trConst", constCparlnSubs))
	{
	  warnSub("constCparln_trConst", "constCparln", a_constCparln);
	  check_constCparln_trConst(
	    dynamic_cast<constCparln_trConst *>(a_constCparln), 0);
	}
      else
	check_constCparln_trConst(
	  dynamic_cast<constCparln_trConst *>(a_constCparln), log);
      return;
    }
  if (isA(a_constCparln, constCparln_retrieve2))
    {
      adjustLevels(&constCparlnSubs_constCparln_retrieve2,
		   "constCparln_retrieve2");
      if (log && !findString("constCparln_retrieve2", constCparlnSubs))
	{
	  warnSub("constCparln_retrieve2", "constCparln", a_constCparln);
	  check_constCparln_retrieve2(
	    dynamic_cast<constCparln_retrieve2 *>(a_constCparln), 0);
	}
      else
	check_constCparln_retrieve2(
	  dynamic_cast<constCparln_retrieve2 *>(a_constCparln), log);
      return;
    }
}

/********************************************************************/

void check_constCparln_bfConst(
 constCparln_bfConst * a_constCparln_bfConst,
 int log)
{
  if (a_constCparln_bfConst->get_fLabel())
    {
      adjustLevels(&constCparln_bfConstAtts_a_fLabel,
		   "constCparln_bfConst a_fLabel");
      if (log && !findString("a_fLabel", constCparln_bfConstAtts))
	{
	  warnAtt("a_fLabel", "constCparln_bfConst", a_constCparln_bfConst);
	  check_fLabel(a_constCparln_bfConst->get_fLabel(), 0);
	}
      else
	check_fLabel(a_constCparln_bfConst->get_fLabel(), log);
    }
  if (a_constCparln_bfConst->get_bfConst())
    {
      adjustLevels(&constCparln_bfConstAtts_a_bfConst,
		   "constCparln_bfConst a_bfConst");
      if (log && !findString("a_bfConst", constCparln_bfConstAtts))
	{
	  warnAtt("a_bfConst", "constCparln_bfConst", a_constCparln_bfConst);
	  check_bfConst(a_constCparln_bfConst->get_bfConst(), 0);
	}
      else
	check_bfConst(a_constCparln_bfConst->get_bfConst(), log);
    }
}

/********************************************************************/

void check_constCparln_projctConst(
 constCparln_projctConst * a_constCparln_projctConst,
 int log)
{
  if (a_constCparln_projctConst->get_fLabel())
    {
      adjustLevels(&constCparln_projctConstAtts_a_fLabel,
		   "constCparln_projctConst a_fLabel");
      if (log && !findString("a_fLabel", constCparln_projctConstAtts))
	{
	  warnAtt("a_fLabel", "constCparln_projctConst",
		  a_constCparln_projctConst);
	  check_fLabel(a_constCparln_projctConst->get_fLabel(), 0);
	}
      else
	check_fLabel(a_constCparln_projctConst->get_fLabel(), log);
    }
  if (a_constCparln_projctConst->get_projctConst())
    {
      adjustLevels(&constCparln_projctConstAtts_a_projctConst,
		   "constCparln_projctConst a_projctConst");
      if (log && !findString("a_projctConst", constCparln_projctConstAtts))
	{
	  warnAtt("a_projctConst", "constCparln_projctConst",
		  a_constCparln_projctConst);
	  check_projctConst(a_constCparln_projctConst->get_projctConst(), 0);
	}
      else
	check_projctConst(a_constCparln_projctConst->get_projctConst(), log);
    }
}

/********************************************************************/

void check_constCparln_retrieve2(
 constCparln_retrieve2 * a_constCparln_retrieve2,
 int log)
{
  if (a_constCparln_retrieve2->get_fLabel())
    {
      adjustLevels(&constCparln_retrieve2Atts_a_fLabel,
		   "constCparln_retrieve2 a_fLabel");
      if (log && !findString("a_fLabel", constCparln_retrieve2Atts))
	{
	  warnAtt("a_fLabel", "constCparln_retrieve2",
		  a_constCparln_retrieve2);
	  check_fLabel(a_constCparln_retrieve2->get_fLabel(), 0);
	}
      else
	check_fLabel(a_constCparln_retrieve2->get_fLabel(), log);
    }
  if (a_constCparln_retrieve2->get_retrieve2())
    {
      adjustLevels(&constCparln_retrieve2Atts_a_retrieve2,
		   "constCparln_retrieve2 a_retrieve2");
      if (log && !findString("a_retrieve2", constCparln_retrieve2Atts))
	{
	  warnAtt("a_retrieve2", "constCparln_retrieve2",
		  a_constCparln_retrieve2);
	  check_retrieve2(a_constCparln_retrieve2->get_retrieve2(), 0);
	}
      else
	check_retrieve2(a_constCparln_retrieve2->get_retrieve2(), log);
    }
}

/********************************************************************/

void check_constCparln_trConst(
 constCparln_trConst * a_constCparln_trConst,
 int log)
{
  if (a_constCparln_trConst->get_fLabel())
    {
      adjustLevels(&constCparln_trConstAtts_a_fLabel,
		   "constCparln_trConst a_fLabel");
      if (log && !findString("a_fLabel", constCparln_trConstAtts))
	{
	  warnAtt("a_fLabel", "constCparln_trConst", a_constCparln_trConst);
	  check_fLabel(a_constCparln_trConst->get_fLabel(), 0);
	}
      else
	check_fLabel(a_constCparln_trConst->get_fLabel(), log);
    }
  if (a_constCparln_trConst->get_trConst())
    {
      adjustLevels(&constCparln_trConstAtts_a_trConst,
		   "constCparln_trConst a_trConst");
      if (log && !findString("a_trConst", constCparln_trConstAtts))
	{
	  warnAtt("a_trConst", "constCparln_trConst", a_constCparln_trConst);
	  check_trConst(a_constCparln_trConst->get_trConst(), 0);
	}
      else
	check_trConst(a_constCparln_trConst->get_trConst(), log);
    }
}

/********************************************************************/

void check_constCylndr(
 constCylndr * a_constCylndr,
 int log)
{
  if (isA(a_constCylndr, constCylndr_bfConst))
    {
      adjustLevels(&constCylndrSubs_constCylndr_bfConst,
		   "constCylndr_bfConst");
      if (log && !findString("constCylndr_bfConst", constCylndrSubs))
	{
	  warnSub("constCylndr_bfConst", "constCylndr", a_constCylndr);
	  check_constCylndr_bfConst(
	    dynamic_cast<constCylndr_bfConst *>(a_constCylndr), 0);
	}
      else
	check_constCylndr_bfConst(
	  dynamic_cast<constCylndr_bfConst *>(a_constCylndr), log);
      return;
    }
  if (isA(a_constCylndr, constCylndr_trConst))
    {
      adjustLevels(&constCylndrSubs_constCylndr_trConst,
		   "constCylndr_trConst");
      if (log && !findString("constCylndr_trConst", constCylndrSubs))
	{
	  warnSub("constCylndr_trConst", "constCylndr", a_constCylndr);
	  check_constCylndr_trConst(
	    dynamic_cast<constCylndr_trConst *>(a_constCylndr), 0);
	}
      else
	check_constCylndr_trConst(
	  dynamic_cast<constCylndr_trConst *>(a_constCylndr), log);
      return;
    }
  if (isA(a_constCylndr, constCylndr_retrieve1))
    {
      adjustLevels(&constCylndrSubs_constCylndr_retrieve1,
		   "constCylndr_retrieve1");
      if (log && !findString("constCylndr_retrieve1", constCylndrSubs))
	{
	  warnSub("constCylndr_retrieve1", "constCylndr", a_constCylndr);
	  check_constCylndr_retrieve1(
	    dynamic_cast<constCylndr_retrieve1 *>(a_constCylndr), 0);
	}
      else
	check_constCylndr_retrieve1(
	  dynamic_cast<constCylndr_retrieve1 *>(a_constCylndr), log);
      return;
    }
}

/********************************************************************/

void check_constCylndr_bfConst(
 constCylndr_bfConst * a_constCylndr_bfConst,
 int log)
{
  if (a_constCylndr_bfConst->get_fLabel())
    {
      adjustLevels(&constCylndr_bfConstAtts_a_fLabel,
		   "constCylndr_bfConst a_fLabel");
      if (log && !findString("a_fLabel", constCylndr_bfConstAtts))
	{
	  warnAtt("a_fLabel", "constCylndr_bfConst", a_constCylndr_bfConst);
	  check_fLabel(a_constCylndr_bfConst->get_fLabel(), 0);
	}
      else
	check_fLabel(a_constCylndr_bfConst->get_fLabel(), log);
    }
  if (a_constCylndr_bfConst->get_bfConst())
    {
      adjustLevels(&constCylndr_bfConstAtts_a_bfConst,
		   "constCylndr_bfConst a_bfConst");
      if (log && !findString("a_bfConst", constCylndr_bfConstAtts))
	{
	  warnAtt("a_bfConst", "constCylndr_bfConst", a_constCylndr_bfConst);
	  check_bfConst(a_constCylndr_bfConst->get_bfConst(), 0);
	}
      else
	check_bfConst(a_constCylndr_bfConst->get_bfConst(), log);
    }
}

/********************************************************************/

void check_constCylndr_retrieve1(
 constCylndr_retrieve1 * a_constCylndr_retrieve1,
 int log)
{
  if (a_constCylndr_retrieve1->get_fLabel())
    {
      adjustLevels(&constCylndr_retrieve1Atts_a_fLabel,
		   "constCylndr_retrieve1 a_fLabel");
      if (log && !findString("a_fLabel", constCylndr_retrieve1Atts))
	{
	  warnAtt("a_fLabel", "constCylndr_retrieve1",
		  a_constCylndr_retrieve1);
	  check_fLabel(a_constCylndr_retrieve1->get_fLabel(), 0);
	}
      else
	check_fLabel(a_constCylndr_retrieve1->get_fLabel(), log);
    }
  if (a_constCylndr_retrieve1->get_retrieve1())
    {
      adjustLevels(&constCylndr_retrieve1Atts_a_retrieve1,
		   "constCylndr_retrieve1 a_retrieve1");
      if (log && !findString("a_retrieve1", constCylndr_retrieve1Atts))
	{
	  warnAtt("a_retrieve1", "constCylndr_retrieve1",
		  a_constCylndr_retrieve1);
	  check_retrieve1(a_constCylndr_retrieve1->get_retrieve1(), 0);
	}
      else
	check_retrieve1(a_constCylndr_retrieve1->get_retrieve1(), log);
    }
}

/********************************************************************/

void check_constCylndr_trConst(
 constCylndr_trConst * a_constCylndr_trConst,
 int log)
{
  if (a_constCylndr_trConst->get_fLabel())
    {
      adjustLevels(&constCylndr_trConstAtts_a_fLabel,
		   "constCylndr_trConst a_fLabel");
      if (log && !findString("a_fLabel", constCylndr_trConstAtts))
	{
	  warnAtt("a_fLabel", "constCylndr_trConst", a_constCylndr_trConst);
	  check_fLabel(a_constCylndr_trConst->get_fLabel(), 0);
	}
      else
	check_fLabel(a_constCylndr_trConst->get_fLabel(), log);
    }
  if (a_constCylndr_trConst->get_trConst())
    {
      adjustLevels(&constCylndr_trConstAtts_a_trConst,
		   "constCylndr_trConst a_trConst");
      if (log && !findString("a_trConst", constCylndr_trConstAtts))
	{
	  warnAtt("a_trConst", "constCylndr_trConst", a_constCylndr_trConst);
	  check_trConst(a_constCylndr_trConst->get_trConst(), 0);
	}
      else
	check_trConst(a_constCylndr_trConst->get_trConst(), log);
    }
}

/********************************************************************/

void check_constEdgept(
 constEdgept * a_constEdgept,
 int log)
{
  if (a_constEdgept->get_fLabel())
    {
      adjustLevels(&constEdgeptAtts_a_fLabel, "constEdgept a_fLabel");
      if (log && !findString("a_fLabel", constEdgeptAtts))
	{
	  warnAtt("a_fLabel", "constEdgept", a_constEdgept);
	  check_fLabel(a_constEdgept->get_fLabel(), 0);
	}
      else
	check_fLabel(a_constEdgept->get_fLabel(), log);
    }
  if (a_constEdgept->get_retrieve4())
    {
      adjustLevels(&constEdgeptAtts_a_retrieve4, "constEdgept a_retrieve4");
      if (log && !findString("a_retrieve4", constEdgeptAtts))
	{
	  warnAtt("a_retrieve4", "constEdgept", a_constEdgept);
	  check_retrieve4(a_constEdgept->get_retrieve4(), 0);
	}
      else
	check_retrieve4(a_constEdgept->get_retrieve4(), log);
    }
}

/********************************************************************/

void check_constEllips(
 constEllips * a_constEllips,
 int log)
{
  if (isA(a_constEllips, constEllips_bfConst))
    {
      adjustLevels(&constEllipsSubs_constEllips_bfConst,
		   "constEllips_bfConst");
      if (log && !findString("constEllips_bfConst", constEllipsSubs))
	{
	  warnSub("constEllips_bfConst", "constEllips", a_constEllips);
	  check_constEllips_bfConst(
	    dynamic_cast<constEllips_bfConst *>(a_constEllips), 0);
	}
      else
	check_constEllips_bfConst(
	  dynamic_cast<constEllips_bfConst *>(a_constEllips), log);
      return;
    }
  if (isA(a_constEllips, constEllips_intofConst))
    {
      adjustLevels(&constEllipsSubs_constEllips_intofConst,
		   "constEllips_intofConst");
      if (log && !findString("constEllips_intofConst", constEllipsSubs))
	{
	  warnSub("constEllips_intofConst", "constEllips", a_constEllips);
	  check_constEllips_intofConst(
	    dynamic_cast<constEllips_intofConst *>(a_constEllips), 0);
	}
      else
	check_constEllips_intofConst(
	  dynamic_cast<constEllips_intofConst *>(a_constEllips), log);
      return;
    }
  if (isA(a_constEllips, constEllips_projctConst))
    {
      adjustLevels(&constEllipsSubs_constEllips_projctConst,
		   "constEllips_projctConst");
      if (log && !findString("constEllips_projctConst", constEllipsSubs))
	{
	  warnSub("constEllips_projctConst", "constEllips", a_constEllips);
	  check_constEllips_projctConst(
	    dynamic_cast<constEllips_projctConst *>(a_constEllips), 0);
	}
      else
	check_constEllips_projctConst(
	  dynamic_cast<constEllips_projctConst *>(a_constEllips), log);
      return;
    }
  if (isA(a_constEllips, constEllips_trConst))
    {
      adjustLevels(&constEllipsSubs_constEllips_trConst,
		   "constEllips_trConst");
      if (log && !findString("constEllips_trConst", constEllipsSubs))
	{
	  warnSub("constEllips_trConst", "constEllips", a_constEllips);
	  check_constEllips_trConst(
	    dynamic_cast<constEllips_trConst *>(a_constEllips), 0);
	}
      else
	check_constEllips_trConst(
	  dynamic_cast<constEllips_trConst *>(a_constEllips), log);
      return;
    }
}

/********************************************************************/

void check_constEllips_bfConst(
 constEllips_bfConst * a_constEllips_bfConst,
 int log)
{
  if (a_constEllips_bfConst->get_fLabel())
    {
      adjustLevels(&constEllips_bfConstAtts_a_fLabel,
		   "constEllips_bfConst a_fLabel");
      if (log && !findString("a_fLabel", constEllips_bfConstAtts))
	{
	  warnAtt("a_fLabel", "constEllips_bfConst", a_constEllips_bfConst);
	  check_fLabel(a_constEllips_bfConst->get_fLabel(), 0);
	}
      else
	check_fLabel(a_constEllips_bfConst->get_fLabel(), log);
    }
  if (a_constEllips_bfConst->get_bfConst())
    {
      adjustLevels(&constEllips_bfConstAtts_a_bfConst,
		   "constEllips_bfConst a_bfConst");
      if (log && !findString("a_bfConst", constEllips_bfConstAtts))
	{
	  warnAtt("a_bfConst", "constEllips_bfConst", a_constEllips_bfConst);
	  check_bfConst(a_constEllips_bfConst->get_bfConst(), 0);
	}
      else
	check_bfConst(a_constEllips_bfConst->get_bfConst(), log);
    }
}

/********************************************************************/

void check_constEllips_intofConst(
 constEllips_intofConst * a_constEllips_intofConst,
 int log)
{
  if (a_constEllips_intofConst->get_fLabel())
    {
      adjustLevels(&constEllips_intofConstAtts_a_fLabel,
		   "constEllips_intofConst a_fLabel");
      if (log && !findString("a_fLabel", constEllips_intofConstAtts))
	{
	  warnAtt("a_fLabel", "constEllips_intofConst",
		  a_constEllips_intofConst);
	  check_fLabel(a_constEllips_intofConst->get_fLabel(), 0);
	}
      else
	check_fLabel(a_constEllips_intofConst->get_fLabel(), log);
    }
  if (a_constEllips_intofConst->get_intofConst())
    {
      adjustLevels(&constEllips_intofConstAtts_a_intofConst,
		   "constEllips_intofConst a_intofConst");
      if (log && !findString("a_intofConst", constEllips_intofConstAtts))
	{
	  warnAtt("a_intofConst", "constEllips_intofConst",
		  a_constEllips_intofConst);
	  check_intofConst(a_constEllips_intofConst->get_intofConst(), 0);
	}
      else
	check_intofConst(a_constEllips_intofConst->get_intofConst(), log);
    }
}

/********************************************************************/

void check_constEllips_projctConst(
 constEllips_projctConst * a_constEllips_projctConst,
 int log)
{
  if (a_constEllips_projctConst->get_fLabel())
    {
      adjustLevels(&constEllips_projctConstAtts_a_fLabel,
		   "constEllips_projctConst a_fLabel");
      if (log && !findString("a_fLabel", constEllips_projctConstAtts))
	{
	  warnAtt("a_fLabel", "constEllips_projctConst",
		  a_constEllips_projctConst);
	  check_fLabel(a_constEllips_projctConst->get_fLabel(), 0);
	}
      else
	check_fLabel(a_constEllips_projctConst->get_fLabel(), log);
    }
  if (a_constEllips_projctConst->get_projctConst())
    {
      adjustLevels(&constEllips_projctConstAtts_a_projctConst,
		   "constEllips_projctConst a_projctConst");
      if (log && !findString("a_projctConst", constEllips_projctConstAtts))
	{
	  warnAtt("a_projctConst", "constEllips_projctConst",
		  a_constEllips_projctConst);
	  check_projctConst(a_constEllips_projctConst->get_projctConst(), 0);
	}
      else
	check_projctConst(a_constEllips_projctConst->get_projctConst(), log);
    }
}

/********************************************************************/

void check_constEllips_trConst(
 constEllips_trConst * a_constEllips_trConst,
 int log)
{
  if (a_constEllips_trConst->get_fLabel())
    {
      adjustLevels(&constEllips_trConstAtts_a_fLabel,
		   "constEllips_trConst a_fLabel");
      if (log && !findString("a_fLabel", constEllips_trConstAtts))
	{
	  warnAtt("a_fLabel", "constEllips_trConst", a_constEllips_trConst);
	  check_fLabel(a_constEllips_trConst->get_fLabel(), 0);
	}
      else
	check_fLabel(a_constEllips_trConst->get_fLabel(), log);
    }
  if (a_constEllips_trConst->get_trConst())
    {
      adjustLevels(&constEllips_trConstAtts_a_trConst,
		   "constEllips_trConst a_trConst");
      if (log && !findString("a_trConst", constEllips_trConstAtts))
	{
	  warnAtt("a_trConst", "constEllips_trConst", a_constEllips_trConst);
	  check_trConst(a_constEllips_trConst->get_trConst(), 0);
	}
      else
	check_trConst(a_constEllips_trConst->get_trConst(), log);
    }
}

/********************************************************************/

void check_constGcurve(
 constGcurve * a_constGcurve,
 int log)
{
  if (isA(a_constGcurve, constGcurve_bfConst))
    {
      adjustLevels(&constGcurveSubs_constGcurve_bfConst,
		   "constGcurve_bfConst");
      if (log && !findString("constGcurve_bfConst", constGcurveSubs))
	{
	  warnSub("constGcurve_bfConst", "constGcurve", a_constGcurve);
	  check_constGcurve_bfConst(
	    dynamic_cast<constGcurve_bfConst *>(a_constGcurve), 0);
	}
      else
	check_constGcurve_bfConst(
	  dynamic_cast<constGcurve_bfConst *>(a_constGcurve), log);
      return;
    }
  if (isA(a_constGcurve, constGcurve_projctConst))
    {
      adjustLevels(&constGcurveSubs_constGcurve_projctConst,
		   "constGcurve_projctConst");
      if (log && !findString("constGcurve_projctConst", constGcurveSubs))
	{
	  warnSub("constGcurve_projctConst", "constGcurve", a_constGcurve);
	  check_constGcurve_projctConst(
	    dynamic_cast<constGcurve_projctConst *>(a_constGcurve), 0);
	}
      else
	check_constGcurve_projctConst(
	  dynamic_cast<constGcurve_projctConst *>(a_constGcurve), log);
      return;
    }
  if (isA(a_constGcurve, constGcurve_trConst))
    {
      adjustLevels(&constGcurveSubs_constGcurve_trConst,
		   "constGcurve_trConst");
      if (log && !findString("constGcurve_trConst", constGcurveSubs))
	{
	  warnSub("constGcurve_trConst", "constGcurve", a_constGcurve);
	  check_constGcurve_trConst(
	    dynamic_cast<constGcurve_trConst *>(a_constGcurve), 0);
	}
      else
	check_constGcurve_trConst(
	  dynamic_cast<constGcurve_trConst *>(a_constGcurve), log);
      return;
    }
}

/********************************************************************/

void check_constGcurve_bfConst(
 constGcurve_bfConst * a_constGcurve_bfConst,
 int log)
{
  if (a_constGcurve_bfConst->get_fLabel())
    {
      adjustLevels(&constGcurve_bfConstAtts_a_fLabel,
		   "constGcurve_bfConst a_fLabel");
      if (log && !findString("a_fLabel", constGcurve_bfConstAtts))
	{
	  warnAtt("a_fLabel", "constGcurve_bfConst", a_constGcurve_bfConst);
	  check_fLabel(a_constGcurve_bfConst->get_fLabel(), 0);
	}
      else
	check_fLabel(a_constGcurve_bfConst->get_fLabel(), log);
    }
  if (a_constGcurve_bfConst->get_bfConst())
    {
      adjustLevels(&constGcurve_bfConstAtts_a_bfConst,
		   "constGcurve_bfConst a_bfConst");
      if (log && !findString("a_bfConst", constGcurve_bfConstAtts))
	{
	  warnAtt("a_bfConst", "constGcurve_bfConst", a_constGcurve_bfConst);
	  check_bfConst(a_constGcurve_bfConst->get_bfConst(), 0);
	}
      else
	check_bfConst(a_constGcurve_bfConst->get_bfConst(), log);
    }
}

/********************************************************************/

void check_constGcurve_projctConst(
 constGcurve_projctConst * a_constGcurve_projctConst,
 int log)
{
  if (a_constGcurve_projctConst->get_fLabel())
    {
      adjustLevels(&constGcurve_projctConstAtts_a_fLabel,
		   "constGcurve_projctConst a_fLabel");
      if (log && !findString("a_fLabel", constGcurve_projctConstAtts))
	{
	  warnAtt("a_fLabel", "constGcurve_projctConst",
		  a_constGcurve_projctConst);
	  check_fLabel(a_constGcurve_projctConst->get_fLabel(), 0);
	}
      else
	check_fLabel(a_constGcurve_projctConst->get_fLabel(), log);
    }
  if (a_constGcurve_projctConst->get_projctConst())
    {
      adjustLevels(&constGcurve_projctConstAtts_a_projctConst,
		   "constGcurve_projctConst a_projctConst");
      if (log && !findString("a_projctConst", constGcurve_projctConstAtts))
	{
	  warnAtt("a_projctConst", "constGcurve_projctConst",
		  a_constGcurve_projctConst);
	  check_projctConst(a_constGcurve_projctConst->get_projctConst(), 0);
	}
      else
	check_projctConst(a_constGcurve_projctConst->get_projctConst(), log);
    }
}

/********************************************************************/

void check_constGcurve_trConst(
 constGcurve_trConst * a_constGcurve_trConst,
 int log)
{
  if (a_constGcurve_trConst->get_fLabel())
    {
      adjustLevels(&constGcurve_trConstAtts_a_fLabel,
		   "constGcurve_trConst a_fLabel");
      if (log && !findString("a_fLabel", constGcurve_trConstAtts))
	{
	  warnAtt("a_fLabel", "constGcurve_trConst", a_constGcurve_trConst);
	  check_fLabel(a_constGcurve_trConst->get_fLabel(), 0);
	}
      else
	check_fLabel(a_constGcurve_trConst->get_fLabel(), log);
    }
  if (a_constGcurve_trConst->get_trConst())
    {
      adjustLevels(&constGcurve_trConstAtts_a_trConst,
		   "constGcurve_trConst a_trConst");
      if (log && !findString("a_trConst", constGcurve_trConstAtts))
	{
	  warnAtt("a_trConst", "constGcurve_trConst", a_constGcurve_trConst);
	  check_trConst(a_constGcurve_trConst->get_trConst(), 0);
	}
      else
	check_trConst(a_constGcurve_trConst->get_trConst(), log);
    }
}

/********************************************************************/

void check_constGeom(
 constGeom * a_constGeom,
 int log)
{
  if (a_constGeom->get_fLabel())
    {
      adjustLevels(&constGeomAtts_a_fLabel, "constGeom a_fLabel");
      if (log && !findString("a_fLabel", constGeomAtts))
	{
	  warnAtt("a_fLabel", "constGeom", a_constGeom);
	  check_fLabel(a_constGeom->get_fLabel(), 0);
	}
      else
	check_fLabel(a_constGeom->get_fLabel(), log);
    }
  if (a_constGeom->get_nearptConst())
    {
      adjustLevels(&constGeomAtts_a_nearptConst, "constGeom a_nearptConst");
      if (log && !findString("a_nearptConst", constGeomAtts))
	{
	  warnAtt("a_nearptConst", "constGeom", a_constGeom);
	  check_nearptConst(a_constGeom->get_nearptConst(), 0);
	}
      else
	check_nearptConst(a_constGeom->get_nearptConst(), log);
    }
}

/********************************************************************/

void check_constGsurf(
 constGsurf * a_constGsurf,
 int log)
{
  if (isA(a_constGsurf, constGsurf_bfConst))
    {
      adjustLevels(&constGsurfSubs_constGsurf_bfConst, "constGsurf_bfConst");
      if (log && !findString("constGsurf_bfConst", constGsurfSubs))
	{
	  warnSub("constGsurf_bfConst", "constGsurf", a_constGsurf);
	  check_constGsurf_bfConst(
	    dynamic_cast<constGsurf_bfConst *>(a_constGsurf), 0);
	}
      else
	check_constGsurf_bfConst(
	  dynamic_cast<constGsurf_bfConst *>(a_constGsurf), log);
      return;
    }
  if (isA(a_constGsurf, constGsurf_trConst))
    {
      adjustLevels(&constGsurfSubs_constGsurf_trConst, "constGsurf_trConst");
      if (log && !findString("constGsurf_trConst", constGsurfSubs))
	{
	  warnSub("constGsurf_trConst", "constGsurf", a_constGsurf);
	  check_constGsurf_trConst(
	    dynamic_cast<constGsurf_trConst *>(a_constGsurf), 0);
	}
      else
	check_constGsurf_trConst(
	  dynamic_cast<constGsurf_trConst *>(a_constGsurf), log);
      return;
    }
}

/********************************************************************/

void check_constGsurf_bfConst(
 constGsurf_bfConst * a_constGsurf_bfConst,
 int log)
{
  if (a_constGsurf_bfConst->get_fLabel())
    {
      adjustLevels(&constGsurf_bfConstAtts_a_fLabel,
		   "constGsurf_bfConst a_fLabel");
      if (log && !findString("a_fLabel", constGsurf_bfConstAtts))
	{
	  warnAtt("a_fLabel", "constGsurf_bfConst", a_constGsurf_bfConst);
	  check_fLabel(a_constGsurf_bfConst->get_fLabel(), 0);
	}
      else
	check_fLabel(a_constGsurf_bfConst->get_fLabel(), log);
    }
  if (a_constGsurf_bfConst->get_bfConst())
    {
      adjustLevels(&constGsurf_bfConstAtts_a_bfConst,
		   "constGsurf_bfConst a_bfConst");
      if (log && !findString("a_bfConst", constGsurf_bfConstAtts))
	{
	  warnAtt("a_bfConst", "constGsurf_bfConst", a_constGsurf_bfConst);
	  check_bfConst(a_constGsurf_bfConst->get_bfConst(), 0);
	}
      else
	check_bfConst(a_constGsurf_bfConst->get_bfConst(), log);
    }
}

/********************************************************************/

void check_constGsurf_trConst(
 constGsurf_trConst * a_constGsurf_trConst,
 int log)
{
  if (a_constGsurf_trConst->get_fLabel())
    {
      adjustLevels(&constGsurf_trConstAtts_a_fLabel,
		   "constGsurf_trConst a_fLabel");
      if (log && !findString("a_fLabel", constGsurf_trConstAtts))
	{
	  warnAtt("a_fLabel", "constGsurf_trConst", a_constGsurf_trConst);
	  check_fLabel(a_constGsurf_trConst->get_fLabel(), 0);
	}
      else
	check_fLabel(a_constGsurf_trConst->get_fLabel(), log);
    }
  if (a_constGsurf_trConst->get_trConst())
    {
      adjustLevels(&constGsurf_trConstAtts_a_trConst,
		   "constGsurf_trConst a_trConst");
      if (log && !findString("a_trConst", constGsurf_trConstAtts))
	{
	  warnAtt("a_trConst", "constGsurf_trConst", a_constGsurf_trConst);
	  check_trConst(a_constGsurf_trConst->get_trConst(), 0);
	}
      else
	check_trConst(a_constGsurf_trConst->get_trConst(), log);
    }
}

/********************************************************************/

void check_constLine(
 constLine * a_constLine,
 int log)
{
  if (isA(a_constLine, constLine_bfConst))
    {
      adjustLevels(&constLineSubs_constLine_bfConst, "constLine_bfConst");
      if (log && !findString("constLine_bfConst", constLineSubs))
	{
	  warnSub("constLine_bfConst", "constLine", a_constLine);
	  check_constLine_bfConst(
	    dynamic_cast<constLine_bfConst *>(a_constLine), 0);
	}
      else
	check_constLine_bfConst(
	  dynamic_cast<constLine_bfConst *>(a_constLine), log);
      return;
    }
  if (isA(a_constLine, constLine_intofConst))
    {
      adjustLevels(&constLineSubs_constLine_intofConst,
		   "constLine_intofConst");
      if (log && !findString("constLine_intofConst", constLineSubs))
	{
	  warnSub("constLine_intofConst", "constLine", a_constLine);
	  check_constLine_intofConst(
	    dynamic_cast<constLine_intofConst *>(a_constLine), 0);
	}
      else
	check_constLine_intofConst(
	  dynamic_cast<constLine_intofConst *>(a_constLine), log);
      return;
    }
  if (isA(a_constLine, constLine_midliConst))
    {
      adjustLevels(&constLineSubs_constLine_midliConst,
		   "constLine_midliConst");
      if (log && !findString("constLine_midliConst", constLineSubs))
	{
	  warnSub("constLine_midliConst", "constLine", a_constLine);
	  check_constLine_midliConst(
	    dynamic_cast<constLine_midliConst *>(a_constLine), 0);
	}
      else
	check_constLine_midliConst(
	  dynamic_cast<constLine_midliConst *>(a_constLine), log);
      return;
    }
  if (isA(a_constLine, constLine_offsetConst))
    {
      adjustLevels(&constLineSubs_constLine_offsetConst,
		   "constLine_offsetConst");
      if (log && !findString("constLine_offsetConst", constLineSubs))
	{
	  warnSub("constLine_offsetConst", "constLine", a_constLine);
	  check_constLine_offsetConst(
	    dynamic_cast<constLine_offsetConst *>(a_constLine), 0);
	}
      else
	check_constLine_offsetConst(
	  dynamic_cast<constLine_offsetConst *>(a_constLine), log);
      return;
    }
  if (isA(a_constLine, constLine_partoConst))
    {
      adjustLevels(&constLineSubs_constLine_partoConst,
		   "constLine_partoConst");
      if (log && !findString("constLine_partoConst", constLineSubs))
	{
	  warnSub("constLine_partoConst", "constLine", a_constLine);
	  check_constLine_partoConst(
	    dynamic_cast<constLine_partoConst *>(a_constLine), 0);
	}
      else
	check_constLine_partoConst(
	  dynamic_cast<constLine_partoConst *>(a_constLine), log);
      return;
    }
  if (isA(a_constLine, constLine_perptoConst))
    {
      adjustLevels(&constLineSubs_constLine_perptoConst,
		   "constLine_perptoConst");
      if (log && !findString("constLine_perptoConst", constLineSubs))
	{
	  warnSub("constLine_perptoConst", "constLine", a_constLine);
	  check_constLine_perptoConst(
	    dynamic_cast<constLine_perptoConst *>(a_constLine), 0);
	}
      else
	check_constLine_perptoConst(
	  dynamic_cast<constLine_perptoConst *>(a_constLine), log);
      return;
    }
  if (isA(a_constLine, constLine_projliConst))
    {
      adjustLevels(&constLineSubs_constLine_projliConst,
		   "constLine_projliConst");
      if (log && !findString("constLine_projliConst", constLineSubs))
	{
	  warnSub("constLine_projliConst", "constLine", a_constLine);
	  check_constLine_projliConst(
	    dynamic_cast<constLine_projliConst *>(a_constLine), 0);
	}
      else
	check_constLine_projliConst(
	  dynamic_cast<constLine_projliConst *>(a_constLine), log);
      return;
    }
  if (isA(a_constLine, constLine_tantoConst))
    {
      adjustLevels(&constLineSubs_constLine_tantoConst,
		   "constLine_tantoConst");
      if (log && !findString("constLine_tantoConst", constLineSubs))
	{
	  warnSub("constLine_tantoConst", "constLine", a_constLine);
	  check_constLine_tantoConst(
	    dynamic_cast<constLine_tantoConst *>(a_constLine), 0);
	}
      else
	check_constLine_tantoConst(
	  dynamic_cast<constLine_tantoConst *>(a_constLine), log);
      return;
    }
  if (isA(a_constLine, constLine_trConst))
    {
      adjustLevels(&constLineSubs_constLine_trConst, "constLine_trConst");
      if (log && !findString("constLine_trConst", constLineSubs))
	{
	  warnSub("constLine_trConst", "constLine", a_constLine);
	  check_constLine_trConst(
	    dynamic_cast<constLine_trConst *>(a_constLine), 0);
	}
      else
	check_constLine_trConst(
	  dynamic_cast<constLine_trConst *>(a_constLine), log);
      return;
    }
}

/********************************************************************/

void check_constLine_bfConst(
 constLine_bfConst * a_constLine_bfConst,
 int log)
{
  if (a_constLine_bfConst->get_fLabel())
    {
      adjustLevels(&constLine_bfConstAtts_a_fLabel,
		   "constLine_bfConst a_fLabel");
      if (log && !findString("a_fLabel", constLine_bfConstAtts))
	{
	  warnAtt("a_fLabel", "constLine_bfConst", a_constLine_bfConst);
	  check_fLabel(a_constLine_bfConst->get_fLabel(), 0);
	}
      else
	check_fLabel(a_constLine_bfConst->get_fLabel(), log);
    }
  if (a_constLine_bfConst->get_bfConst())
    {
      adjustLevels(&constLine_bfConstAtts_a_bfConst,
		   "constLine_bfConst a_bfConst");
      if (log && !findString("a_bfConst", constLine_bfConstAtts))
	{
	  warnAtt("a_bfConst", "constLine_bfConst", a_constLine_bfConst);
	  check_bfConst(a_constLine_bfConst->get_bfConst(), 0);
	}
      else
	check_bfConst(a_constLine_bfConst->get_bfConst(), log);
    }
}

/********************************************************************/

void check_constLine_intofConst(
 constLine_intofConst * a_constLine_intofConst,
 int log)
{
  if (a_constLine_intofConst->get_fLabel())
    {
      adjustLevels(&constLine_intofConstAtts_a_fLabel,
		   "constLine_intofConst a_fLabel");
      if (log && !findString("a_fLabel", constLine_intofConstAtts))
	{
	  warnAtt("a_fLabel", "constLine_intofConst", a_constLine_intofConst);
	  check_fLabel(a_constLine_intofConst->get_fLabel(), 0);
	}
      else
	check_fLabel(a_constLine_intofConst->get_fLabel(), log);
    }
  if (a_constLine_intofConst->get_intofConst())
    {
      adjustLevels(&constLine_intofConstAtts_a_intofConst,
		   "constLine_intofConst a_intofConst");
      if (log && !findString("a_intofConst", constLine_intofConstAtts))
	{
	  warnAtt("a_intofConst", "constLine_intofConst",
		  a_constLine_intofConst);
	  check_intofConst(a_constLine_intofConst->get_intofConst(), 0);
	}
      else
	check_intofConst(a_constLine_intofConst->get_intofConst(), log);
    }
}

/********************************************************************/

void check_constLine_midliConst(
 constLine_midliConst * a_constLine_midliConst,
 int log)
{
  if (a_constLine_midliConst->get_fLabel())
    {
      adjustLevels(&constLine_midliConstAtts_a_fLabel,
		   "constLine_midliConst a_fLabel");
      if (log && !findString("a_fLabel", constLine_midliConstAtts))
	{
	  warnAtt("a_fLabel", "constLine_midliConst", a_constLine_midliConst);
	  check_fLabel(a_constLine_midliConst->get_fLabel(), 0);
	}
      else
	check_fLabel(a_constLine_midliConst->get_fLabel(), log);
    }
  if (a_constLine_midliConst->get_midliConst())
    {
      adjustLevels(&constLine_midliConstAtts_a_midliConst,
		   "constLine_midliConst a_midliConst");
      if (log && !findString("a_midliConst", constLine_midliConstAtts))
	{
	  warnAtt("a_midliConst", "constLine_midliConst",
		  a_constLine_midliConst);
	  check_midliConst(a_constLine_midliConst->get_midliConst(), 0);
	}
      else
	check_midliConst(a_constLine_midliConst->get_midliConst(), log);
    }
}

/********************************************************************/

void check_constLine_offsetConst(
 constLine_offsetConst * a_constLine_offsetConst,
 int log)
{
  if (a_constLine_offsetConst->get_fLabel())
    {
      adjustLevels(&constLine_offsetConstAtts_a_fLabel,
		   "constLine_offsetConst a_fLabel");
      if (log && !findString("a_fLabel", constLine_offsetConstAtts))
	{
	  warnAtt("a_fLabel", "constLine_offsetConst",
		  a_constLine_offsetConst);
	  check_fLabel(a_constLine_offsetConst->get_fLabel(), 0);
	}
      else
	check_fLabel(a_constLine_offsetConst->get_fLabel(), log);
    }
  if (a_constLine_offsetConst->get_offsetConst())
    {
      adjustLevels(&constLine_offsetConstAtts_a_offsetConst,
		   "constLine_offsetConst a_offsetConst");
      if (log && !findString("a_offsetConst", constLine_offsetConstAtts))
	{
	  warnAtt("a_offsetConst", "constLine_offsetConst",
		  a_constLine_offsetConst);
	  check_offsetConst(a_constLine_offsetConst->get_offsetConst(), 0);
	}
      else
	check_offsetConst(a_constLine_offsetConst->get_offsetConst(), log);
    }
}

/********************************************************************/

void check_constLine_partoConst(
 constLine_partoConst * a_constLine_partoConst,
 int log)
{
  if (a_constLine_partoConst->get_fLabel())
    {
      adjustLevels(&constLine_partoConstAtts_a_fLabel,
		   "constLine_partoConst a_fLabel");
      if (log && !findString("a_fLabel", constLine_partoConstAtts))
	{
	  warnAtt("a_fLabel", "constLine_partoConst", a_constLine_partoConst);
	  check_fLabel(a_constLine_partoConst->get_fLabel(), 0);
	}
      else
	check_fLabel(a_constLine_partoConst->get_fLabel(), log);
    }
  if (a_constLine_partoConst->get_partoConst())
    {
      adjustLevels(&constLine_partoConstAtts_a_partoConst,
		   "constLine_partoConst a_partoConst");
      if (log && !findString("a_partoConst", constLine_partoConstAtts))
	{
	  warnAtt("a_partoConst", "constLine_partoConst",
		  a_constLine_partoConst);
	  check_partoConst(a_constLine_partoConst->get_partoConst(), 0);
	}
      else
	check_partoConst(a_constLine_partoConst->get_partoConst(), log);
    }
}

/********************************************************************/

void check_constLine_perptoConst(
 constLine_perptoConst * a_constLine_perptoConst,
 int log)
{
  if (a_constLine_perptoConst->get_fLabel())
    {
      adjustLevels(&constLine_perptoConstAtts_a_fLabel,
		   "constLine_perptoConst a_fLabel");
      if (log && !findString("a_fLabel", constLine_perptoConstAtts))
	{
	  warnAtt("a_fLabel", "constLine_perptoConst",
		  a_constLine_perptoConst);
	  check_fLabel(a_constLine_perptoConst->get_fLabel(), 0);
	}
      else
	check_fLabel(a_constLine_perptoConst->get_fLabel(), log);
    }
  if (a_constLine_perptoConst->get_perptoConst())
    {
      adjustLevels(&constLine_perptoConstAtts_a_perptoConst,
		   "constLine_perptoConst a_perptoConst");
      if (log && !findString("a_perptoConst", constLine_perptoConstAtts))
	{
	  warnAtt("a_perptoConst", "constLine_perptoConst",
		  a_constLine_perptoConst);
	  check_perptoConst(a_constLine_perptoConst->get_perptoConst(), 0);
	}
      else
	check_perptoConst(a_constLine_perptoConst->get_perptoConst(), log);
    }
}

/********************************************************************/

void check_constLine_projliConst(
 constLine_projliConst * a_constLine_projliConst,
 int log)
{
  if (a_constLine_projliConst->get_fLabel())
    {
      adjustLevels(&constLine_projliConstAtts_a_fLabel,
		   "constLine_projliConst a_fLabel");
      if (log && !findString("a_fLabel", constLine_projliConstAtts))
	{
	  warnAtt("a_fLabel", "constLine_projliConst",
		  a_constLine_projliConst);
	  check_fLabel(a_constLine_projliConst->get_fLabel(), 0);
	}
      else
	check_fLabel(a_constLine_projliConst->get_fLabel(), log);
    }
  if (a_constLine_projliConst->get_projliConst())
    {
      adjustLevels(&constLine_projliConstAtts_a_projliConst,
		   "constLine_projliConst a_projliConst");
      if (log && !findString("a_projliConst", constLine_projliConstAtts))
	{
	  warnAtt("a_projliConst", "constLine_projliConst",
		  a_constLine_projliConst);
	  check_projliConst(a_constLine_projliConst->get_projliConst(), 0);
	}
      else
	check_projliConst(a_constLine_projliConst->get_projliConst(), log);
    }
}

/********************************************************************/

void check_constLine_tantoConst(
 constLine_tantoConst * a_constLine_tantoConst,
 int log)
{
  if (a_constLine_tantoConst->get_fLabel())
    {
      adjustLevels(&constLine_tantoConstAtts_a_fLabel,
		   "constLine_tantoConst a_fLabel");
      if (log && !findString("a_fLabel", constLine_tantoConstAtts))
	{
	  warnAtt("a_fLabel", "constLine_tantoConst", a_constLine_tantoConst);
	  check_fLabel(a_constLine_tantoConst->get_fLabel(), 0);
	}
      else
	check_fLabel(a_constLine_tantoConst->get_fLabel(), log);
    }
  if (a_constLine_tantoConst->get_tantoConst())
    {
      adjustLevels(&constLine_tantoConstAtts_a_tantoConst,
		   "constLine_tantoConst a_tantoConst");
      if (log && !findString("a_tantoConst", constLine_tantoConstAtts))
	{
	  warnAtt("a_tantoConst", "constLine_tantoConst",
		  a_constLine_tantoConst);
	  check_tantoConst(a_constLine_tantoConst->get_tantoConst(), 0);
	}
      else
	check_tantoConst(a_constLine_tantoConst->get_tantoConst(), log);
    }
}

/********************************************************************/

void check_constLine_trConst(
 constLine_trConst * a_constLine_trConst,
 int log)
{
  if (a_constLine_trConst->get_fLabel())
    {
      adjustLevels(&constLine_trConstAtts_a_fLabel,
		   "constLine_trConst a_fLabel");
      if (log && !findString("a_fLabel", constLine_trConstAtts))
	{
	  warnAtt("a_fLabel", "constLine_trConst", a_constLine_trConst);
	  check_fLabel(a_constLine_trConst->get_fLabel(), 0);
	}
      else
	check_fLabel(a_constLine_trConst->get_fLabel(), log);
    }
  if (a_constLine_trConst->get_trConst())
    {
      adjustLevels(&constLine_trConstAtts_a_trConst,
		   "constLine_trConst a_trConst");
      if (log && !findString("a_trConst", constLine_trConstAtts))
	{
	  warnAtt("a_trConst", "constLine_trConst", a_constLine_trConst);
	  check_trConst(a_constLine_trConst->get_trConst(), 0);
	}
      else
	check_trConst(a_constLine_trConst->get_trConst(), log);
    }
}

/********************************************************************/

void check_constMinor(
 constMinor * a_constMinor,
 int log)
{
  if (isA(a_constMinor, constArc))
    {
      adjustLevels(&constMinorSubs_constArc, "constArc");
      if (log && !findString("constArc", constMinorSubs))
	{
	  warnSub("constArc", "constMinor", a_constMinor);
	  check_constArc(dynamic_cast<constArc *>(a_constMinor), 0);
	}
      else
	check_constArc(dynamic_cast<constArc *>(a_constMinor), log);
      return;
    }
  if (isA(a_constMinor, constCircle))
    {
      adjustLevels(&constMinorSubs_constCircle, "constCircle");
      if (log && !findString("constCircle", constMinorSubs))
	{
	  warnSub("constCircle", "constMinor", a_constMinor);
	  check_constCircle(dynamic_cast<constCircle *>(a_constMinor), 0);
	}
      else
	check_constCircle(dynamic_cast<constCircle *>(a_constMinor), log);
      return;
    }
  if (isA(a_constMinor, constCompound))
    {
      adjustLevels(&constMinorSubs_constCompound, "constCompound");
      if (log && !findString("constCompound", constMinorSubs))
	{
	  warnSub("constCompound", "constMinor", a_constMinor);
	  check_constCompound(
	    dynamic_cast<constCompound *>(a_constMinor), 0);
	}
      else
	check_constCompound(
	  dynamic_cast<constCompound *>(a_constMinor), log);
      return;
    }
  if (isA(a_constMinor, constCone))
    {
      adjustLevels(&constMinorSubs_constCone, "constCone");
      if (log && !findString("constCone", constMinorSubs))
	{
	  warnSub("constCone", "constMinor", a_constMinor);
	  check_constCone(dynamic_cast<constCone *>(a_constMinor), 0);
	}
      else
	check_constCone(dynamic_cast<constCone *>(a_constMinor), log);
      return;
    }
  if (isA(a_constMinor, constCylndr))
    {
      adjustLevels(&constMinorSubs_constCylndr, "constCylndr");
      if (log && !findString("constCylndr", constMinorSubs))
	{
	  warnSub("constCylndr", "constMinor", a_constMinor);
	  check_constCylndr(dynamic_cast<constCylndr *>(a_constMinor), 0);
	}
      else
	check_constCylndr(dynamic_cast<constCylndr *>(a_constMinor), log);
      return;
    }
  if (isA(a_constMinor, constCparln))
    {
      adjustLevels(&constMinorSubs_constCparln, "constCparln");
      if (log && !findString("constCparln", constMinorSubs))
	{
	  warnSub("constCparln", "constMinor", a_constMinor);
	  check_constCparln(dynamic_cast<constCparln *>(a_constMinor), 0);
	}
      else
	check_constCparln(dynamic_cast<constCparln *>(a_constMinor), log);
      return;
    }
  if (isA(a_constMinor, constEllips))
    {
      adjustLevels(&constMinorSubs_constEllips, "constEllips");
      if (log && !findString("constEllips", constMinorSubs))
	{
	  warnSub("constEllips", "constMinor", a_constMinor);
	  check_constEllips(dynamic_cast<constEllips *>(a_constMinor), 0);
	}
      else
	check_constEllips(dynamic_cast<constEllips *>(a_constMinor), log);
      return;
    }
  if (isA(a_constMinor, constEdgept))
    {
      adjustLevels(&constMinorSubs_constEdgept, "constEdgept");
      if (log && !findString("constEdgept", constMinorSubs))
	{
	  warnSub("constEdgept", "constMinor", a_constMinor);
	  check_constEdgept(dynamic_cast<constEdgept *>(a_constMinor), 0);
	}
      else
	check_constEdgept(dynamic_cast<constEdgept *>(a_constMinor), log);
      return;
    }
  if (isA(a_constMinor, constGeom))
    {
      adjustLevels(&constMinorSubs_constGeom, "constGeom");
      if (log && !findString("constGeom", constMinorSubs))
	{
	  warnSub("constGeom", "constMinor", a_constMinor);
	  check_constGeom(dynamic_cast<constGeom *>(a_constMinor), 0);
	}
      else
	check_constGeom(dynamic_cast<constGeom *>(a_constMinor), log);
      return;
    }
  if (isA(a_constMinor, constGcurve))
    {
      adjustLevels(&constMinorSubs_constGcurve, "constGcurve");
      if (log && !findString("constGcurve", constMinorSubs))
	{
	  warnSub("constGcurve", "constMinor", a_constMinor);
	  check_constGcurve(dynamic_cast<constGcurve *>(a_constMinor), 0);
	}
      else
	check_constGcurve(dynamic_cast<constGcurve *>(a_constMinor), log);
      return;
    }
  if (isA(a_constMinor, constGsurf))
    {
      adjustLevels(&constMinorSubs_constGsurf, "constGsurf");
      if (log && !findString("constGsurf", constMinorSubs))
	{
	  warnSub("constGsurf", "constMinor", a_constMinor);
	  check_constGsurf(dynamic_cast<constGsurf *>(a_constMinor), 0);
	}
      else
	check_constGsurf(dynamic_cast<constGsurf *>(a_constMinor), log);
      return;
    }
  if (isA(a_constMinor, constLine))
    {
      adjustLevels(&constMinorSubs_constLine, "constLine");
      if (log && !findString("constLine", constMinorSubs))
	{
	  warnSub("constLine", "constMinor", a_constMinor);
	  check_constLine(dynamic_cast<constLine *>(a_constMinor), 0);
	}
      else
	check_constLine(dynamic_cast<constLine *>(a_constMinor), log);
      return;
    }
  if (isA(a_constMinor, constParpln))
    {
      adjustLevels(&constMinorSubs_constParpln, "constParpln");
      if (log && !findString("constParpln", constMinorSubs))
	{
	  warnSub("constParpln", "constMinor", a_constMinor);
	  check_constParpln(dynamic_cast<constParpln *>(a_constMinor), 0);
	}
      else
	check_constParpln(dynamic_cast<constParpln *>(a_constMinor), log);
      return;
    }
  if (isA(a_constMinor, constPatern))
    {
      adjustLevels(&constMinorSubs_constPatern, "constPatern");
      if (log && !findString("constPatern", constMinorSubs))
	{
	  warnSub("constPatern", "constMinor", a_constMinor);
	  check_constPatern(dynamic_cast<constPatern *>(a_constMinor), 0);
	}
      else
	check_constPatern(dynamic_cast<constPatern *>(a_constMinor), log);
      return;
    }
  if (isA(a_constMinor, constPlane))
    {
      adjustLevels(&constMinorSubs_constPlane, "constPlane");
      if (log && !findString("constPlane", constMinorSubs))
	{
	  warnSub("constPlane", "constMinor", a_constMinor);
	  check_constPlane(dynamic_cast<constPlane *>(a_constMinor), 0);
	}
      else
	check_constPlane(dynamic_cast<constPlane *>(a_constMinor), log);
      return;
    }
  if (isA(a_constMinor, constPoint))
    {
      adjustLevels(&constMinorSubs_constPoint, "constPoint");
      if (log && !findString("constPoint", constMinorSubs))
	{
	  warnSub("constPoint", "constMinor", a_constMinor);
	  check_constPoint(dynamic_cast<constPoint *>(a_constMinor), 0);
	}
      else
	check_constPoint(dynamic_cast<constPoint *>(a_constMinor), log);
      return;
    }
  if (isA(a_constMinor, constRctngl))
    {
      adjustLevels(&constMinorSubs_constRctngl, "constRctngl");
      if (log && !findString("constRctngl", constMinorSubs))
	{
	  warnSub("constRctngl", "constMinor", a_constMinor);
	  check_constRctngl(dynamic_cast<constRctngl *>(a_constMinor), 0);
	}
      else
	check_constRctngl(dynamic_cast<constRctngl *>(a_constMinor), log);
      return;
    }
  if (isA(a_constMinor, constSgage))
    {
      adjustLevels(&constMinorSubs_constSgage, "constSgage");
      if (log && !findString("constSgage", constMinorSubs))
	{
	  warnSub("constSgage", "constMinor", a_constMinor);
	  check_constSgage(dynamic_cast<constSgage *>(a_constMinor), 0);
	}
      else
	check_constSgage(dynamic_cast<constSgage *>(a_constMinor), log);
      return;
    }
  if (isA(a_constMinor, constSpart))
    {
      adjustLevels(&constMinorSubs_constSpart, "constSpart");
      if (log && !findString("constSpart", constMinorSubs))
	{
	  warnSub("constSpart", "constMinor", a_constMinor);
	  check_constSpart(dynamic_cast<constSpart *>(a_constMinor), 0);
	}
      else
	check_constSpart(dynamic_cast<constSpart *>(a_constMinor), log);
      return;
    }
  if (isA(a_constMinor, constSphere))
    {
      adjustLevels(&constMinorSubs_constSphere, "constSphere");
      if (log && !findString("constSphere", constMinorSubs))
	{
	  warnSub("constSphere", "constMinor", a_constMinor);
	  check_constSphere(dynamic_cast<constSphere *>(a_constMinor), 0);
	}
      else
	check_constSphere(dynamic_cast<constSphere *>(a_constMinor), log);
      return;
    }
  if (isA(a_constMinor, constSympln))
    {
      adjustLevels(&constMinorSubs_constSympln, "constSympln");
      if (log && !findString("constSympln", constMinorSubs))
	{
	  warnSub("constSympln", "constMinor", a_constMinor);
	  check_constSympln(dynamic_cast<constSympln *>(a_constMinor), 0);
	}
      else
	check_constSympln(dynamic_cast<constSympln *>(a_constMinor), log);
      return;
    }
  if (isA(a_constMinor, constTorus))
    {
      adjustLevels(&constMinorSubs_constTorus, "constTorus");
      if (log && !findString("constTorus", constMinorSubs))
	{
	  warnSub("constTorus", "constMinor", a_constMinor);
	  check_constTorus(dynamic_cast<constTorus *>(a_constMinor), 0);
	}
      else
	check_constTorus(dynamic_cast<constTorus *>(a_constMinor), log);
      return;
    }
}

/********************************************************************/

void check_constParpln(
 constParpln * a_constParpln,
 int log)
{
  if (a_constParpln->get_fLabel())
    {
      adjustLevels(&constParplnAtts_a_fLabel, "constParpln a_fLabel");
      if (log && !findString("a_fLabel", constParplnAtts))
	{
	  warnAtt("a_fLabel", "constParpln", a_constParpln);
	  check_fLabel(a_constParpln->get_fLabel(), 0);
	}
      else
	check_fLabel(a_constParpln->get_fLabel(), log);
    }
  if (a_constParpln->get_bfConst())
    {
      adjustLevels(&constParplnAtts_a_bfConst, "constParpln a_bfConst");
      if (log && !findString("a_bfConst", constParplnAtts))
	{
	  warnAtt("a_bfConst", "constParpln", a_constParpln);
	  check_bfConst(a_constParpln->get_bfConst(), 0);
	}
      else
	check_bfConst(a_constParpln->get_bfConst(), log);
    }
}

/********************************************************************/

void check_constPatern(
 constPatern * a_constPatern,
 int log)
{
  if (isA(a_constPatern, constPatern_trConst))
    {
      adjustLevels(&constPaternSubs_constPatern_trConst,
		   "constPatern_trConst");
      if (log && !findString("constPatern_trConst", constPaternSubs))
	{
	  warnSub("constPatern_trConst", "constPatern", a_constPatern);
	  check_constPatern_trConst(
	    dynamic_cast<constPatern_trConst *>(a_constPatern), 0);
	}
      else
	check_constPatern_trConst(
	  dynamic_cast<constPatern_trConst *>(a_constPatern), log);
      return;
    }
  if (isA(a_constPatern, constPatern_BUILD))
    {
      adjustLevels(&constPaternSubs_constPatern_BUILD, "constPatern_BUILD");
      if (log && !findString("constPatern_BUILD", constPaternSubs))
	{
	  warnSub("constPatern_BUILD", "constPatern", a_constPatern);
	  check_constPatern_BUILD(
	    dynamic_cast<constPatern_BUILD *>(a_constPatern), 0);
	}
      else
	check_constPatern_BUILD(
	  dynamic_cast<constPatern_BUILD *>(a_constPatern), log);
      return;
    }
}

/********************************************************************/

void check_constPatern_BUILD(
 constPatern_BUILD * a_constPatern_BUILD,
 int log)
{
  if (a_constPatern_BUILD->get_fLabel())
    {
      adjustLevels(&constPatern_BUILDAtts_a_fLabel,
		   "constPatern_BUILD a_fLabel");
      if (log && !findString("a_fLabel", constPatern_BUILDAtts))
	{
	  warnAtt("a_fLabel", "constPatern_BUILD", a_constPatern_BUILD);
	  check_fLabel(a_constPatern_BUILD->get_fLabel(), 0);
	}
      else
	check_fLabel(a_constPatern_BUILD->get_fLabel(), log);
    }
}

/********************************************************************/

void check_constPatern_trConst(
 constPatern_trConst * a_constPatern_trConst,
 int log)
{
  if (a_constPatern_trConst->get_fLabel())
    {
      adjustLevels(&constPatern_trConstAtts_a_fLabel,
		   "constPatern_trConst a_fLabel");
      if (log && !findString("a_fLabel", constPatern_trConstAtts))
	{
	  warnAtt("a_fLabel", "constPatern_trConst", a_constPatern_trConst);
	  check_fLabel(a_constPatern_trConst->get_fLabel(), 0);
	}
      else
	check_fLabel(a_constPatern_trConst->get_fLabel(), log);
    }
  if (a_constPatern_trConst->get_trConst())
    {
      adjustLevels(&constPatern_trConstAtts_a_trConst,
		   "constPatern_trConst a_trConst");
      if (log && !findString("a_trConst", constPatern_trConstAtts))
	{
	  warnAtt("a_trConst", "constPatern_trConst", a_constPatern_trConst);
	  check_trConst(a_constPatern_trConst->get_trConst(), 0);
	}
      else
	check_trConst(a_constPatern_trConst->get_trConst(), log);
    }
}

/********************************************************************/

void check_constPlane(
 constPlane * a_constPlane,
 int log)
{
  if (isA(a_constPlane, constPlane_bfConst))
    {
      adjustLevels(&constPlaneSubs_constPlane_bfConst, "constPlane_bfConst");
      if (log && !findString("constPlane_bfConst", constPlaneSubs))
	{
	  warnSub("constPlane_bfConst", "constPlane", a_constPlane);
	  check_constPlane_bfConst(
	    dynamic_cast<constPlane_bfConst *>(a_constPlane), 0);
	}
      else
	check_constPlane_bfConst(
	  dynamic_cast<constPlane_bfConst *>(a_constPlane), log);
      return;
    }
  if (isA(a_constPlane, constPlane_midplConst))
    {
      adjustLevels(&constPlaneSubs_constPlane_midplConst,
		   "constPlane_midplConst");
      if (log && !findString("constPlane_midplConst", constPlaneSubs))
	{
	  warnSub("constPlane_midplConst", "constPlane", a_constPlane);
	  check_constPlane_midplConst(
	    dynamic_cast<constPlane_midplConst *>(a_constPlane), 0);
	}
      else
	check_constPlane_midplConst(
	  dynamic_cast<constPlane_midplConst *>(a_constPlane), log);
      return;
    }
  if (isA(a_constPlane, constPlane_offsetConst))
    {
      adjustLevels(&constPlaneSubs_constPlane_offsetConst,
		   "constPlane_offsetConst");
      if (log && !findString("constPlane_offsetConst", constPlaneSubs))
	{
	  warnSub("constPlane_offsetConst", "constPlane", a_constPlane);
	  check_constPlane_offsetConst(
	    dynamic_cast<constPlane_offsetConst *>(a_constPlane), 0);
	}
      else
	check_constPlane_offsetConst(
	  dynamic_cast<constPlane_offsetConst *>(a_constPlane), log);
      return;
    }
  if (isA(a_constPlane, constPlane_partoConst))
    {
      adjustLevels(&constPlaneSubs_constPlane_partoConst,
		   "constPlane_partoConst");
      if (log && !findString("constPlane_partoConst", constPlaneSubs))
	{
	  warnSub("constPlane_partoConst", "constPlane", a_constPlane);
	  check_constPlane_partoConst(
	    dynamic_cast<constPlane_partoConst *>(a_constPlane), 0);
	}
      else
	check_constPlane_partoConst(
	  dynamic_cast<constPlane_partoConst *>(a_constPlane), log);
      return;
    }
  if (isA(a_constPlane, constPlane_perptoConst))
    {
      adjustLevels(&constPlaneSubs_constPlane_perptoConst,
		   "constPlane_perptoConst");
      if (log && !findString("constPlane_perptoConst", constPlaneSubs))
	{
	  warnSub("constPlane_perptoConst", "constPlane", a_constPlane);
	  check_constPlane_perptoConst(
	    dynamic_cast<constPlane_perptoConst *>(a_constPlane), 0);
	}
      else
	check_constPlane_perptoConst(
	  dynamic_cast<constPlane_perptoConst *>(a_constPlane), log);
      return;
    }
  if (isA(a_constPlane, constPlane_tantoConstPlane))
    {
      adjustLevels(&constPlaneSubs_constPlane_tantoConstPlane,
		   "constPlane_tantoConstPlane");
      if (log && !findString("constPlane_tantoConstPlane", constPlaneSubs))
	{
	  warnSub("constPlane_tantoConstPlane", "constPlane", a_constPlane);
	  check_constPlane_tantoConstPlane(
	    dynamic_cast<constPlane_tantoConstPlane *>(a_constPlane), 0);
	}
      else
	check_constPlane_tantoConstPlane(
	  dynamic_cast<constPlane_tantoConstPlane *>(a_constPlane), log);
      return;
    }
  if (isA(a_constPlane, constPlane_trConst))
    {
      adjustLevels(&constPlaneSubs_constPlane_trConst, "constPlane_trConst");
      if (log && !findString("constPlane_trConst", constPlaneSubs))
	{
	  warnSub("constPlane_trConst", "constPlane", a_constPlane);
	  check_constPlane_trConst(
	    dynamic_cast<constPlane_trConst *>(a_constPlane), 0);
	}
      else
	check_constPlane_trConst(
	  dynamic_cast<constPlane_trConst *>(a_constPlane), log);
      return;
    }
}

/********************************************************************/

void check_constPlane_bfConst(
 constPlane_bfConst * a_constPlane_bfConst,
 int log)
{
  if (a_constPlane_bfConst->get_fLabel())
    {
      adjustLevels(&constPlane_bfConstAtts_a_fLabel,
		   "constPlane_bfConst a_fLabel");
      if (log && !findString("a_fLabel", constPlane_bfConstAtts))
	{
	  warnAtt("a_fLabel", "constPlane_bfConst", a_constPlane_bfConst);
	  check_fLabel(a_constPlane_bfConst->get_fLabel(), 0);
	}
      else
	check_fLabel(a_constPlane_bfConst->get_fLabel(), log);
    }
  if (a_constPlane_bfConst->get_bfConst())
    {
      adjustLevels(&constPlane_bfConstAtts_a_bfConst,
		   "constPlane_bfConst a_bfConst");
      if (log && !findString("a_bfConst", constPlane_bfConstAtts))
	{
	  warnAtt("a_bfConst", "constPlane_bfConst", a_constPlane_bfConst);
	  check_bfConst(a_constPlane_bfConst->get_bfConst(), 0);
	}
      else
	check_bfConst(a_constPlane_bfConst->get_bfConst(), log);
    }
}

/********************************************************************/

void check_constPlane_midplConst(
 constPlane_midplConst * a_constPlane_midplConst,
 int log)
{
  if (a_constPlane_midplConst->get_fLabel())
    {
      adjustLevels(&constPlane_midplConstAtts_a_fLabel,
		   "constPlane_midplConst a_fLabel");
      if (log && !findString("a_fLabel", constPlane_midplConstAtts))
	{
	  warnAtt("a_fLabel", "constPlane_midplConst",
		  a_constPlane_midplConst);
	  check_fLabel(a_constPlane_midplConst->get_fLabel(), 0);
	}
      else
	check_fLabel(a_constPlane_midplConst->get_fLabel(), log);
    }
  if (a_constPlane_midplConst->get_midplConst())
    {
      adjustLevels(&constPlane_midplConstAtts_a_midplConst,
		   "constPlane_midplConst a_midplConst");
      if (log && !findString("a_midplConst", constPlane_midplConstAtts))
	{
	  warnAtt("a_midplConst", "constPlane_midplConst",
		  a_constPlane_midplConst);
	  check_midplConst(a_constPlane_midplConst->get_midplConst(), 0);
	}
      else
	check_midplConst(a_constPlane_midplConst->get_midplConst(), log);
    }
}

/********************************************************************/

void check_constPlane_offsetConst(
 constPlane_offsetConst * a_constPlane_offsetConst,
 int log)
{
  if (a_constPlane_offsetConst->get_fLabel())
    {
      adjustLevels(&constPlane_offsetConstAtts_a_fLabel,
		   "constPlane_offsetConst a_fLabel");
      if (log && !findString("a_fLabel", constPlane_offsetConstAtts))
	{
	  warnAtt("a_fLabel", "constPlane_offsetConst",
		  a_constPlane_offsetConst);
	  check_fLabel(a_constPlane_offsetConst->get_fLabel(), 0);
	}
      else
	check_fLabel(a_constPlane_offsetConst->get_fLabel(), log);
    }
  if (a_constPlane_offsetConst->get_offsetConst())
    {
      adjustLevels(&constPlane_offsetConstAtts_a_offsetConst,
		   "constPlane_offsetConst a_offsetConst");
      if (log && !findString("a_offsetConst", constPlane_offsetConstAtts))
	{
	  warnAtt("a_offsetConst", "constPlane_offsetConst",
		  a_constPlane_offsetConst);
	  check_offsetConst(a_constPlane_offsetConst->get_offsetConst(), 0);
	}
      else
	check_offsetConst(a_constPlane_offsetConst->get_offsetConst(), log);
    }
}

/********************************************************************/

void check_constPlane_partoConst(
 constPlane_partoConst * a_constPlane_partoConst,
 int log)
{
  if (a_constPlane_partoConst->get_fLabel())
    {
      adjustLevels(&constPlane_partoConstAtts_a_fLabel,
		   "constPlane_partoConst a_fLabel");
      if (log && !findString("a_fLabel", constPlane_partoConstAtts))
	{
	  warnAtt("a_fLabel", "constPlane_partoConst",
		  a_constPlane_partoConst);
	  check_fLabel(a_constPlane_partoConst->get_fLabel(), 0);
	}
      else
	check_fLabel(a_constPlane_partoConst->get_fLabel(), log);
    }
  if (a_constPlane_partoConst->get_partoConst())
    {
      adjustLevels(&constPlane_partoConstAtts_a_partoConst,
		   "constPlane_partoConst a_partoConst");
      if (log && !findString("a_partoConst", constPlane_partoConstAtts))
	{
	  warnAtt("a_partoConst", "constPlane_partoConst",
		  a_constPlane_partoConst);
	  check_partoConst(a_constPlane_partoConst->get_partoConst(), 0);
	}
      else
	check_partoConst(a_constPlane_partoConst->get_partoConst(), log);
    }
}

/********************************************************************/

void check_constPlane_perptoConst(
 constPlane_perptoConst * a_constPlane_perptoConst,
 int log)
{
  if (a_constPlane_perptoConst->get_fLabel())
    {
      adjustLevels(&constPlane_perptoConstAtts_a_fLabel,
		   "constPlane_perptoConst a_fLabel");
      if (log && !findString("a_fLabel", constPlane_perptoConstAtts))
	{
	  warnAtt("a_fLabel", "constPlane_perptoConst",
		  a_constPlane_perptoConst);
	  check_fLabel(a_constPlane_perptoConst->get_fLabel(), 0);
	}
      else
	check_fLabel(a_constPlane_perptoConst->get_fLabel(), log);
    }
  if (a_constPlane_perptoConst->get_perptoConst())
    {
      adjustLevels(&constPlane_perptoConstAtts_a_perptoConst,
		   "constPlane_perptoConst a_perptoConst");
      if (log && !findString("a_perptoConst", constPlane_perptoConstAtts))
	{
	  warnAtt("a_perptoConst", "constPlane_perptoConst",
		  a_constPlane_perptoConst);
	  check_perptoConst(a_constPlane_perptoConst->get_perptoConst(), 0);
	}
      else
	check_perptoConst(a_constPlane_perptoConst->get_perptoConst(), log);
    }
}

/********************************************************************/

void check_constPlane_tantoConstPlane(
 constPlane_tantoConstPlane * a_constPlane_tantoConstPlane,
 int log)
{
  if (a_constPlane_tantoConstPlane->get_fLabel())
    {
      adjustLevels(&constPlane_tantoConstPlaneAtts_a_fLabel,
		   "constPlane_tantoConstPlane a_fLabel");
      if (log && !findString("a_fLabel", constPlane_tantoConstPlaneAtts))
	{
	  warnAtt("a_fLabel", "constPlane_tantoConstPlane",
		  a_constPlane_tantoConstPlane);
	  check_fLabel(a_constPlane_tantoConstPlane->get_fLabel(), 0);
	}
      else
	check_fLabel(a_constPlane_tantoConstPlane->get_fLabel(), log);
    }
  if (a_constPlane_tantoConstPlane->get_tantoConstPlane())
    {
      adjustLevels(&constPlane_tantoConstPlaneAtts_a_tantoConstPlane,
		   "constPlane_tantoConstPlane a_tantoConstPlane");
      if (log && !findString("a_tantoConstPlane",
			     constPlane_tantoConstPlaneAtts))
	{
	  warnAtt("a_tantoConstPlane", "constPlane_tantoConstPlane",
		  a_constPlane_tantoConstPlane);
	  check_tantoConstPlane(
	    a_constPlane_tantoConstPlane->get_tantoConstPlane(), 0);
	}
      else
	check_tantoConstPlane(
	  a_constPlane_tantoConstPlane->get_tantoConstPlane(), log);
    }
}

/********************************************************************/

void check_constPlane_trConst(
 constPlane_trConst * a_constPlane_trConst,
 int log)
{
  if (a_constPlane_trConst->get_fLabel())
    {
      adjustLevels(&constPlane_trConstAtts_a_fLabel,
		   "constPlane_trConst a_fLabel");
      if (log && !findString("a_fLabel", constPlane_trConstAtts))
	{
	  warnAtt("a_fLabel", "constPlane_trConst", a_constPlane_trConst);
	  check_fLabel(a_constPlane_trConst->get_fLabel(), 0);
	}
      else
	check_fLabel(a_constPlane_trConst->get_fLabel(), log);
    }
  if (a_constPlane_trConst->get_trConst())
    {
      adjustLevels(&constPlane_trConstAtts_a_trConst,
		   "constPlane_trConst a_trConst");
      if (log && !findString("a_trConst", constPlane_trConstAtts))
	{
	  warnAtt("a_trConst", "constPlane_trConst", a_constPlane_trConst);
	  check_trConst(a_constPlane_trConst->get_trConst(), 0);
	}
      else
	check_trConst(a_constPlane_trConst->get_trConst(), log);
    }
}

/********************************************************************/

void check_constPoint(
 constPoint * a_constPoint,
 int log)
{
  if (isA(a_constPoint, constPoint_cogConst))
    {
      adjustLevels(&constPointSubs_constPoint_cogConst, "constPoint_cogConst");
      if (log && !findString("constPoint_cogConst", constPointSubs))
	{
	  warnSub("constPoint_cogConst", "constPoint", a_constPoint);
	  check_constPoint_cogConst(
	    dynamic_cast<constPoint_cogConst *>(a_constPoint), 0);
	}
      else
	check_constPoint_cogConst(
	  dynamic_cast<constPoint_cogConst *>(a_constPoint), log);
      return;
    }
  if (isA(a_constPoint, constPoint_curveConst))
    {
      adjustLevels(&constPointSubs_constPoint_curveConst,
		   "constPoint_curveConst");
      if (log && !findString("constPoint_curveConst", constPointSubs))
	{
	  warnSub("constPoint_curveConst", "constPoint", a_constPoint);
	  check_constPoint_curveConst(
	    dynamic_cast<constPoint_curveConst *>(a_constPoint), 0);
	}
      else
	check_constPoint_curveConst(
	  dynamic_cast<constPoint_curveConst *>(a_constPoint), log);
      return;
    }
  if (isA(a_constPoint, constPoint_extremConst))
    {
      adjustLevels(&constPointSubs_constPoint_extremConst,
		   "constPoint_extremConst");
      if (log && !findString("constPoint_extremConst", constPointSubs))
	{
	  warnSub("constPoint_extremConst", "constPoint", a_constPoint);
	  check_constPoint_extremConst(
	    dynamic_cast<constPoint_extremConst *>(a_constPoint), 0);
	}
      else
	check_constPoint_extremConst(
	  dynamic_cast<constPoint_extremConst *>(a_constPoint), log);
      return;
    }
  if (isA(a_constPoint, constPoint_intofConst))
    {
      adjustLevels(&constPointSubs_constPoint_intofConst,
		   "constPoint_intofConst");
      if (log && !findString("constPoint_intofConst", constPointSubs))
	{
	  warnSub("constPoint_intofConst", "constPoint", a_constPoint);
	  check_constPoint_intofConst(
	    dynamic_cast<constPoint_intofConst *>(a_constPoint), 0);
	}
      else
	check_constPoint_intofConst(
	  dynamic_cast<constPoint_intofConst *>(a_constPoint), log);
      return;
    }
  if (isA(a_constPoint, constPoint_midptConst))
    {
      adjustLevels(&constPointSubs_constPoint_midptConst,
		   "constPoint_midptConst");
      if (log && !findString("constPoint_midptConst", constPointSubs))
	{
	  warnSub("constPoint_midptConst", "constPoint", a_constPoint);
	  check_constPoint_midptConst(
	    dynamic_cast<constPoint_midptConst *>(a_constPoint), 0);
	}
      else
	check_constPoint_midptConst(
	  dynamic_cast<constPoint_midptConst *>(a_constPoint), log);
      return;
    }
  if (isA(a_constPoint, constPoint_moveptConst))
    {
      adjustLevels(&constPointSubs_constPoint_moveptConst,
		   "constPoint_moveptConst");
      if (log && !findString("constPoint_moveptConst", constPointSubs))
	{
	  warnSub("constPoint_moveptConst", "constPoint", a_constPoint);
	  check_constPoint_moveptConst(
	    dynamic_cast<constPoint_moveptConst *>(a_constPoint), 0);
	}
      else
	check_constPoint_moveptConst(
	  dynamic_cast<constPoint_moveptConst *>(a_constPoint), log);
      return;
    }
  if (isA(a_constPoint, constPoint_pierceConst))
    {
      adjustLevels(&constPointSubs_constPoint_pierceConst,
		   "constPoint_pierceConst");
      if (log && !findString("constPoint_pierceConst", constPointSubs))
	{
	  warnSub("constPoint_pierceConst", "constPoint", a_constPoint);
	  check_constPoint_pierceConst(
	    dynamic_cast<constPoint_pierceConst *>(a_constPoint), 0);
	}
      else
	check_constPoint_pierceConst(
	  dynamic_cast<constPoint_pierceConst *>(a_constPoint), log);
      return;
    }
  if (isA(a_constPoint, constPoint_projptConst))
    {
      adjustLevels(&constPointSubs_constPoint_projptConst,
		   "constPoint_projptConst");
      if (log && !findString("constPoint_projptConst", constPointSubs))
	{
	  warnSub("constPoint_projptConst", "constPoint", a_constPoint);
	  check_constPoint_projptConst(
	    dynamic_cast<constPoint_projptConst *>(a_constPoint), 0);
	}
      else
	check_constPoint_projptConst(
	  dynamic_cast<constPoint_projptConst *>(a_constPoint), log);
      return;
    }
  if (isA(a_constPoint, constPoint_trConst))
    {
      adjustLevels(&constPointSubs_constPoint_trConst, "constPoint_trConst");
      if (log && !findString("constPoint_trConst", constPointSubs))
	{
	  warnSub("constPoint_trConst", "constPoint", a_constPoint);
	  check_constPoint_trConst(
	    dynamic_cast<constPoint_trConst *>(a_constPoint), 0);
	}
      else
	check_constPoint_trConst(
	  dynamic_cast<constPoint_trConst *>(a_constPoint), log);
      return;
    }
  if (isA(a_constPoint, constPoint_vertexConst))
    {
      adjustLevels(&constPointSubs_constPoint_vertexConst,
		   "constPoint_vertexConst");
      if (log && !findString("constPoint_vertexConst", constPointSubs))
	{
	  warnSub("constPoint_vertexConst", "constPoint", a_constPoint);
	  check_constPoint_vertexConst(
	    dynamic_cast<constPoint_vertexConst *>(a_constPoint), 0);
	}
      else
	check_constPoint_vertexConst(
	  dynamic_cast<constPoint_vertexConst *>(a_constPoint), log);
      return;
    }
  if (isA(a_constPoint, constPoint_retrieve1))
    {
      adjustLevels(&constPointSubs_constPoint_retrieve1,
		   "constPoint_retrieve1");
      if (log && !findString("constPoint_retrieve1", constPointSubs))
	{
	  warnSub("constPoint_retrieve1", "constPoint", a_constPoint);
	  check_constPoint_retrieve1(
	    dynamic_cast<constPoint_retrieve1 *>(a_constPoint), 0);
	}
      else
	check_constPoint_retrieve1(
	  dynamic_cast<constPoint_retrieve1 *>(a_constPoint), log);
      return;
    }
}

/********************************************************************/

void check_constPoint_cogConst(
 constPoint_cogConst * a_constPoint_cogConst,
 int log)
{
  if (a_constPoint_cogConst->get_fLabel())
    {
      adjustLevels(&constPoint_cogConstAtts_a_fLabel,
		   "constPoint_cogConst a_fLabel");
      if (log && !findString("a_fLabel", constPoint_cogConstAtts))
	{
	  warnAtt("a_fLabel", "constPoint_cogConst", a_constPoint_cogConst);
	  check_fLabel(a_constPoint_cogConst->get_fLabel(), 0);
	}
      else
	check_fLabel(a_constPoint_cogConst->get_fLabel(), log);
    }
  if (a_constPoint_cogConst->get_cogConst())
    {
      adjustLevels(&constPoint_cogConstAtts_a_cogConst,
		   "constPoint_cogConst a_cogConst");
      if (log && !findString("a_cogConst", constPoint_cogConstAtts))
	{
	  warnAtt("a_cogConst", "constPoint_cogConst", a_constPoint_cogConst);
	  check_cogConst(a_constPoint_cogConst->get_cogConst(), 0);
	}
      else
	check_cogConst(a_constPoint_cogConst->get_cogConst(), log);
    }
}

/********************************************************************/

void check_constPoint_curveConst(
 constPoint_curveConst * a_constPoint_curveConst,
 int log)
{
  if (a_constPoint_curveConst->get_fLabel())
    {
      adjustLevels(&constPoint_curveConstAtts_a_fLabel,
		   "constPoint_curveConst a_fLabel");
      if (log && !findString("a_fLabel", constPoint_curveConstAtts))
	{
	  warnAtt("a_fLabel", "constPoint_curveConst",
		  a_constPoint_curveConst);
	  check_fLabel(a_constPoint_curveConst->get_fLabel(), 0);
	}
      else
	check_fLabel(a_constPoint_curveConst->get_fLabel(), log);
    }
  if (a_constPoint_curveConst->get_curveConst())
    {
      adjustLevels(&constPoint_curveConstAtts_a_curveConst,
		   "constPoint_curveConst a_curveConst");
      if (log && !findString("a_curveConst", constPoint_curveConstAtts))
	{
	  warnAtt("a_curveConst", "constPoint_curveConst",
		  a_constPoint_curveConst);
	  check_curveConst(a_constPoint_curveConst->get_curveConst(), 0);
	}
      else
	check_curveConst(a_constPoint_curveConst->get_curveConst(), log);
    }
}

/********************************************************************/

void check_constPoint_extremConst(
 constPoint_extremConst * a_constPoint_extremConst,
 int log)
{
  if (a_constPoint_extremConst->get_fLabel())
    {
      adjustLevels(&constPoint_extremConstAtts_a_fLabel,
		   "constPoint_extremConst a_fLabel");
      if (log && !findString("a_fLabel", constPoint_extremConstAtts))
	{
	  warnAtt("a_fLabel", "constPoint_extremConst",
		  a_constPoint_extremConst);
	  check_fLabel(a_constPoint_extremConst->get_fLabel(), 0);
	}
      else
	check_fLabel(a_constPoint_extremConst->get_fLabel(), log);
    }
  if (a_constPoint_extremConst->get_extremConst())
    {
      adjustLevels(&constPoint_extremConstAtts_a_extremConst,
		   "constPoint_extremConst a_extremConst");
      if (log && !findString("a_extremConst", constPoint_extremConstAtts))
	{
	  warnAtt("a_extremConst", "constPoint_extremConst",
		  a_constPoint_extremConst);
	  check_extremConst(a_constPoint_extremConst->get_extremConst(), 0);
	}
      else
	check_extremConst(a_constPoint_extremConst->get_extremConst(), log);
    }
}

/********************************************************************/

void check_constPoint_intofConst(
 constPoint_intofConst * a_constPoint_intofConst,
 int log)
{
  if (a_constPoint_intofConst->get_fLabel())
    {
      adjustLevels(&constPoint_intofConstAtts_a_fLabel,
		   "constPoint_intofConst a_fLabel");
      if (log && !findString("a_fLabel", constPoint_intofConstAtts))
	{
	  warnAtt("a_fLabel", "constPoint_intofConst",
		  a_constPoint_intofConst);
	  check_fLabel(a_constPoint_intofConst->get_fLabel(), 0);
	}
      else
	check_fLabel(a_constPoint_intofConst->get_fLabel(), log);
    }
  if (a_constPoint_intofConst->get_intofConst())
    {
      adjustLevels(&constPoint_intofConstAtts_a_intofConst,
		   "constPoint_intofConst a_intofConst");
      if (log && !findString("a_intofConst", constPoint_intofConstAtts))
	{
	  warnAtt("a_intofConst", "constPoint_intofConst",
		  a_constPoint_intofConst);
	  check_intofConst(a_constPoint_intofConst->get_intofConst(), 0);
	}
      else
	check_intofConst(a_constPoint_intofConst->get_intofConst(), log);
    }
}

/********************************************************************/

void check_constPoint_midptConst(
 constPoint_midptConst * a_constPoint_midptConst,
 int log)
{
  if (a_constPoint_midptConst->get_fLabel())
    {
      adjustLevels(&constPoint_midptConstAtts_a_fLabel,
		   "constPoint_midptConst a_fLabel");
      if (log && !findString("a_fLabel", constPoint_midptConstAtts))
	{
	  warnAtt("a_fLabel", "constPoint_midptConst",
		  a_constPoint_midptConst);
	  check_fLabel(a_constPoint_midptConst->get_fLabel(), 0);
	}
      else
	check_fLabel(a_constPoint_midptConst->get_fLabel(), log);
    }
  if (a_constPoint_midptConst->get_midptConst())
    {
      adjustLevels(&constPoint_midptConstAtts_a_midptConst,
		   "constPoint_midptConst a_midptConst");
      if (log && !findString("a_midptConst", constPoint_midptConstAtts))
	{
	  warnAtt("a_midptConst", "constPoint_midptConst",
		  a_constPoint_midptConst);
	  check_midptConst(a_constPoint_midptConst->get_midptConst(), 0);
	}
      else
	check_midptConst(a_constPoint_midptConst->get_midptConst(), log);
    }
}

/********************************************************************/

void check_constPoint_moveptConst(
 constPoint_moveptConst * a_constPoint_moveptConst,
 int log)
{
  if (a_constPoint_moveptConst->get_fLabel())
    {
      adjustLevels(&constPoint_moveptConstAtts_a_fLabel,
		   "constPoint_moveptConst a_fLabel");
      if (log && !findString("a_fLabel", constPoint_moveptConstAtts))
	{
	  warnAtt("a_fLabel", "constPoint_moveptConst",
		  a_constPoint_moveptConst);
	  check_fLabel(a_constPoint_moveptConst->get_fLabel(), 0);
	}
      else
	check_fLabel(a_constPoint_moveptConst->get_fLabel(), log);
    }
  if (a_constPoint_moveptConst->get_moveptConst())
    {
      adjustLevels(&constPoint_moveptConstAtts_a_moveptConst,
		   "constPoint_moveptConst a_moveptConst");
      if (log && !findString("a_moveptConst", constPoint_moveptConstAtts))
	{
	  warnAtt("a_moveptConst", "constPoint_moveptConst",
		  a_constPoint_moveptConst);
	  check_moveptConst(a_constPoint_moveptConst->get_moveptConst(), 0);
	}
      else
	check_moveptConst(a_constPoint_moveptConst->get_moveptConst(), log);
    }
}

/********************************************************************/

void check_constPoint_pierceConst(
 constPoint_pierceConst * a_constPoint_pierceConst,
 int log)
{
  if (a_constPoint_pierceConst->get_fLabel())
    {
      adjustLevels(&constPoint_pierceConstAtts_a_fLabel,
		   "constPoint_pierceConst a_fLabel");
      if (log && !findString("a_fLabel", constPoint_pierceConstAtts))
	{
	  warnAtt("a_fLabel", "constPoint_pierceConst",
		  a_constPoint_pierceConst);
	  check_fLabel(a_constPoint_pierceConst->get_fLabel(), 0);
	}
      else
	check_fLabel(a_constPoint_pierceConst->get_fLabel(), log);
    }
  if (a_constPoint_pierceConst->get_pierceConst())
    {
      adjustLevels(&constPoint_pierceConstAtts_a_pierceConst,
		   "constPoint_pierceConst a_pierceConst");
      if (log && !findString("a_pierceConst", constPoint_pierceConstAtts))
	{
	  warnAtt("a_pierceConst", "constPoint_pierceConst",
		  a_constPoint_pierceConst);
	  check_pierceConst(a_constPoint_pierceConst->get_pierceConst(), 0);
	}
      else
	check_pierceConst(a_constPoint_pierceConst->get_pierceConst(), log);
    }
}

/********************************************************************/

void check_constPoint_projptConst(
 constPoint_projptConst * a_constPoint_projptConst,
 int log)
{
  if (a_constPoint_projptConst->get_fLabel())
    {
      adjustLevels(&constPoint_projptConstAtts_a_fLabel,
		   "constPoint_projptConst a_fLabel");
      if (log && !findString("a_fLabel", constPoint_projptConstAtts))
	{
	  warnAtt("a_fLabel", "constPoint_projptConst",
		  a_constPoint_projptConst);
	  check_fLabel(a_constPoint_projptConst->get_fLabel(), 0);
	}
      else
	check_fLabel(a_constPoint_projptConst->get_fLabel(), log);
    }
  if (a_constPoint_projptConst->get_projptConst())
    {
      adjustLevels(&constPoint_projptConstAtts_a_projptConst,
		   "constPoint_projptConst a_projptConst");
      if (log && !findString("a_projptConst", constPoint_projptConstAtts))
	{
	  warnAtt("a_projptConst", "constPoint_projptConst",
		  a_constPoint_projptConst);
	  check_projptConst(a_constPoint_projptConst->get_projptConst(), 0);
	}
      else
	check_projptConst(a_constPoint_projptConst->get_projptConst(), log);
    }
}

/********************************************************************/

void check_constPoint_retrieve1(
 constPoint_retrieve1 * a_constPoint_retrieve1,
 int log)
{
  if (a_constPoint_retrieve1->get_fLabel())
    {
      adjustLevels(&constPoint_retrieve1Atts_a_fLabel,
		   "constPoint_retrieve1 a_fLabel");
      if (log && !findString("a_fLabel", constPoint_retrieve1Atts))
	{
	  warnAtt("a_fLabel", "constPoint_retrieve1", a_constPoint_retrieve1);
	  check_fLabel(a_constPoint_retrieve1->get_fLabel(), 0);
	}
      else
	check_fLabel(a_constPoint_retrieve1->get_fLabel(), log);
    }
  if (a_constPoint_retrieve1->get_retrieve1())
    {
      adjustLevels(&constPoint_retrieve1Atts_a_retrieve1,
		   "constPoint_retrieve1 a_retrieve1");
      if (log && !findString("a_retrieve1", constPoint_retrieve1Atts))
	{
	  warnAtt("a_retrieve1", "constPoint_retrieve1",
		  a_constPoint_retrieve1);
	  check_retrieve1(a_constPoint_retrieve1->get_retrieve1(), 0);
	}
      else
	check_retrieve1(a_constPoint_retrieve1->get_retrieve1(), log);
    }
}

/********************************************************************/

void check_constPoint_trConst(
 constPoint_trConst * a_constPoint_trConst,
 int log)
{
  if (a_constPoint_trConst->get_fLabel())
    {
      adjustLevels(&constPoint_trConstAtts_a_fLabel,
		   "constPoint_trConst a_fLabel");
      if (log && !findString("a_fLabel", constPoint_trConstAtts))
	{
	  warnAtt("a_fLabel", "constPoint_trConst", a_constPoint_trConst);
	  check_fLabel(a_constPoint_trConst->get_fLabel(), 0);
	}
      else
	check_fLabel(a_constPoint_trConst->get_fLabel(), log);
    }
  if (a_constPoint_trConst->get_trConst())
    {
      adjustLevels(&constPoint_trConstAtts_a_trConst,
		   "constPoint_trConst a_trConst");
      if (log && !findString("a_trConst", constPoint_trConstAtts))
	{
	  warnAtt("a_trConst", "constPoint_trConst", a_constPoint_trConst);
	  check_trConst(a_constPoint_trConst->get_trConst(), 0);
	}
      else
	check_trConst(a_constPoint_trConst->get_trConst(), log);
    }
}

/********************************************************************/

void check_constPoint_vertexConst(
 constPoint_vertexConst * a_constPoint_vertexConst,
 int log)
{
  if (a_constPoint_vertexConst->get_fLabel())
    {
      adjustLevels(&constPoint_vertexConstAtts_a_fLabel,
		   "constPoint_vertexConst a_fLabel");
      if (log && !findString("a_fLabel", constPoint_vertexConstAtts))
	{
	  warnAtt("a_fLabel", "constPoint_vertexConst",
		  a_constPoint_vertexConst);
	  check_fLabel(a_constPoint_vertexConst->get_fLabel(), 0);
	}
      else
	check_fLabel(a_constPoint_vertexConst->get_fLabel(), log);
    }
  if (a_constPoint_vertexConst->get_vertexConst())
    {
      adjustLevels(&constPoint_vertexConstAtts_a_vertexConst,
		   "constPoint_vertexConst a_vertexConst");
      if (log && !findString("a_vertexConst", constPoint_vertexConstAtts))
	{
	  warnAtt("a_vertexConst", "constPoint_vertexConst",
		  a_constPoint_vertexConst);
	  check_vertexConst(a_constPoint_vertexConst->get_vertexConst(), 0);
	}
      else
	check_vertexConst(a_constPoint_vertexConst->get_vertexConst(), log);
    }
}

/********************************************************************/

void check_constRctngl(
 constRctngl * a_constRctngl,
 int log)
{
  if (isA(a_constRctngl, constRctngl_bfConst))
    {
      adjustLevels(&constRctnglSubs_constRctngl_bfConst,
		   "constRctngl_bfConst");
      if (log && !findString("constRctngl_bfConst", constRctnglSubs))
	{
	  warnSub("constRctngl_bfConst", "constRctngl", a_constRctngl);
	  check_constRctngl_bfConst(
	    dynamic_cast<constRctngl_bfConst *>(a_constRctngl), 0);
	}
      else
	check_constRctngl_bfConst(
	  dynamic_cast<constRctngl_bfConst *>(a_constRctngl), log);
      return;
    }
  if (isA(a_constRctngl, constRctngl_trConst))
    {
      adjustLevels(&constRctnglSubs_constRctngl_trConst,
		   "constRctngl_trConst");
      if (log && !findString("constRctngl_trConst", constRctnglSubs))
	{
	  warnSub("constRctngl_trConst", "constRctngl", a_constRctngl);
	  check_constRctngl_trConst(
	    dynamic_cast<constRctngl_trConst *>(a_constRctngl), 0);
	}
      else
	check_constRctngl_trConst(
	  dynamic_cast<constRctngl_trConst *>(a_constRctngl), log);
      return;
    }
}

/********************************************************************/

void check_constRctngl_bfConst(
 constRctngl_bfConst * a_constRctngl_bfConst,
 int log)
{
  if (a_constRctngl_bfConst->get_fLabel())
    {
      adjustLevels(&constRctngl_bfConstAtts_a_fLabel,
		   "constRctngl_bfConst a_fLabel");
      if (log && !findString("a_fLabel", constRctngl_bfConstAtts))
	{
	  warnAtt("a_fLabel", "constRctngl_bfConst", a_constRctngl_bfConst);
	  check_fLabel(a_constRctngl_bfConst->get_fLabel(), 0);
	}
      else
	check_fLabel(a_constRctngl_bfConst->get_fLabel(), log);
    }
  if (a_constRctngl_bfConst->get_bfConst())
    {
      adjustLevels(&constRctngl_bfConstAtts_a_bfConst,
		   "constRctngl_bfConst a_bfConst");
      if (log && !findString("a_bfConst", constRctngl_bfConstAtts))
	{
	  warnAtt("a_bfConst", "constRctngl_bfConst", a_constRctngl_bfConst);
	  check_bfConst(a_constRctngl_bfConst->get_bfConst(), 0);
	}
      else
	check_bfConst(a_constRctngl_bfConst->get_bfConst(), log);
    }
}

/********************************************************************/

void check_constRctngl_trConst(
 constRctngl_trConst * a_constRctngl_trConst,
 int log)
{
  if (a_constRctngl_trConst->get_fLabel())
    {
      adjustLevels(&constRctngl_trConstAtts_a_fLabel,
		   "constRctngl_trConst a_fLabel");
      if (log && !findString("a_fLabel", constRctngl_trConstAtts))
	{
	  warnAtt("a_fLabel", "constRctngl_trConst", a_constRctngl_trConst);
	  check_fLabel(a_constRctngl_trConst->get_fLabel(), 0);
	}
      else
	check_fLabel(a_constRctngl_trConst->get_fLabel(), log);
    }
  if (a_constRctngl_trConst->get_trConst())
    {
      adjustLevels(&constRctngl_trConstAtts_a_trConst,
		   "constRctngl_trConst a_trConst");
      if (log && !findString("a_trConst", constRctngl_trConstAtts))
	{
	  warnAtt("a_trConst", "constRctngl_trConst", a_constRctngl_trConst);
	  check_trConst(a_constRctngl_trConst->get_trConst(), 0);
	}
      else
	check_trConst(a_constRctngl_trConst->get_trConst(), log);
    }
}

/********************************************************************/

void check_constSgage(
 constSgage * a_constSgage,
 int log)
{
  if (a_constSgage->get_seLabel())
    {
      adjustLevels(&constSgageAtts_a_seLabel, "constSgage a_seLabel");
      if (log && !findString("a_seLabel", constSgageAtts))
	{
	  warnAtt("a_seLabel", "constSgage", a_constSgage);
	  check_seLabel(a_constSgage->get_seLabel(), 0);
	}
      else
	check_seLabel(a_constSgage->get_seLabel(), log);
    }
  if (a_constSgage->get_sgageConst())
    {
      adjustLevels(&constSgageAtts_a_sgageConst, "constSgage a_sgageConst");
      if (log && !findString("a_sgageConst", constSgageAtts))
	{
	  warnAtt("a_sgageConst", "constSgage", a_constSgage);
	  check_sgageConst(a_constSgage->get_sgageConst(), 0);
	}
      else
	check_sgageConst(a_constSgage->get_sgageConst(), log);
    }
}

/********************************************************************/

void check_constSpart(
 constSpart * a_constSpart,
 int log)
{
  if (a_constSpart->get_stLabel())
    {
      adjustLevels(&constSpartAtts_a_stLabel, "constSpart a_stLabel");
      if (log && !findString("a_stLabel", constSpartAtts))
	{
	  warnAtt("a_stLabel", "constSpart", a_constSpart);
	  check_stLabel(a_constSpart->get_stLabel(), 0);
	}
      else
	check_stLabel(a_constSpart->get_stLabel(), log);
    }
  if (a_constSpart->get_spartConst())
    {
      adjustLevels(&constSpartAtts_a_spartConst, "constSpart a_spartConst");
      if (log && !findString("a_spartConst", constSpartAtts))
	{
	  warnAtt("a_spartConst", "constSpart", a_constSpart);
	  check_spartConst(a_constSpart->get_spartConst(), 0);
	}
      else
	check_spartConst(a_constSpart->get_spartConst(), log);
    }
}

/********************************************************************/

void check_constSphere(
 constSphere * a_constSphere,
 int log)
{
  if (isA(a_constSphere, constSphere_bfConst))
    {
      adjustLevels(&constSphereSubs_constSphere_bfConst,
		   "constSphere_bfConst");
      if (log && !findString("constSphere_bfConst", constSphereSubs))
	{
	  warnSub("constSphere_bfConst", "constSphere", a_constSphere);
	  check_constSphere_bfConst(
	    dynamic_cast<constSphere_bfConst *>(a_constSphere), 0);
	}
      else
	check_constSphere_bfConst(
	  dynamic_cast<constSphere_bfConst *>(a_constSphere), log);
      return;
    }
  if (isA(a_constSphere, constSphere_trConst))
    {
      adjustLevels(&constSphereSubs_constSphere_trConst,
		   "constSphere_trConst");
      if (log && !findString("constSphere_trConst", constSphereSubs))
	{
	  warnSub("constSphere_trConst", "constSphere", a_constSphere);
	  check_constSphere_trConst(
	    dynamic_cast<constSphere_trConst *>(a_constSphere), 0);
	}
      else
	check_constSphere_trConst(
	  dynamic_cast<constSphere_trConst *>(a_constSphere), log);
      return;
    }
  if (isA(a_constSphere, constSphere_retrieve2b))
    {
      adjustLevels(&constSphereSubs_constSphere_retrieve2b,
		   "constSphere_retrieve2b");
      if (log && !findString("constSphere_retrieve2b", constSphereSubs))
	{
	  warnSub("constSphere_retrieve2b", "constSphere", a_constSphere);
	  check_constSphere_retrieve2b(
	    dynamic_cast<constSphere_retrieve2b *>(a_constSphere), 0);
	}
      else
	check_constSphere_retrieve2b(
	  dynamic_cast<constSphere_retrieve2b *>(a_constSphere), log);
      return;
    }
}

/********************************************************************/

void check_constSphere_bfConst(
 constSphere_bfConst * a_constSphere_bfConst,
 int log)
{
  if (a_constSphere_bfConst->get_fLabel())
    {
      adjustLevels(&constSphere_bfConstAtts_a_fLabel,
		   "constSphere_bfConst a_fLabel");
      if (log && !findString("a_fLabel", constSphere_bfConstAtts))
	{
	  warnAtt("a_fLabel", "constSphere_bfConst", a_constSphere_bfConst);
	  check_fLabel(a_constSphere_bfConst->get_fLabel(), 0);
	}
      else
	check_fLabel(a_constSphere_bfConst->get_fLabel(), log);
    }
  if (a_constSphere_bfConst->get_bfConst())
    {
      adjustLevels(&constSphere_bfConstAtts_a_bfConst,
		   "constSphere_bfConst a_bfConst");
      if (log && !findString("a_bfConst", constSphere_bfConstAtts))
	{
	  warnAtt("a_bfConst", "constSphere_bfConst", a_constSphere_bfConst);
	  check_bfConst(a_constSphere_bfConst->get_bfConst(), 0);
	}
      else
	check_bfConst(a_constSphere_bfConst->get_bfConst(), log);
    }
}

/********************************************************************/

void check_constSphere_retrieve2b(
 constSphere_retrieve2b * a_constSphere_retrieve2b,
 int log)
{
  if (a_constSphere_retrieve2b->get_fLabel())
    {
      adjustLevels(&constSphere_retrieve2bAtts_a_fLabel,
		   "constSphere_retrieve2b a_fLabel");
      if (log && !findString("a_fLabel", constSphere_retrieve2bAtts))
	{
	  warnAtt("a_fLabel", "constSphere_retrieve2b",
		  a_constSphere_retrieve2b);
	  check_fLabel(a_constSphere_retrieve2b->get_fLabel(), 0);
	}
      else
	check_fLabel(a_constSphere_retrieve2b->get_fLabel(), log);
    }
  if (a_constSphere_retrieve2b->get_retrieve2b())
    {
      adjustLevels(&constSphere_retrieve2bAtts_a_retrieve2b,
		   "constSphere_retrieve2b a_retrieve2b");
      if (log && !findString("a_retrieve2b", constSphere_retrieve2bAtts))
	{
	  warnAtt("a_retrieve2b", "constSphere_retrieve2b",
		  a_constSphere_retrieve2b);
	  check_retrieve2b(a_constSphere_retrieve2b->get_retrieve2b(), 0);
	}
      else
	check_retrieve2b(a_constSphere_retrieve2b->get_retrieve2b(), log);
    }
}

/********************************************************************/

void check_constSphere_trConst(
 constSphere_trConst * a_constSphere_trConst,
 int log)
{
  if (a_constSphere_trConst->get_fLabel())
    {
      adjustLevels(&constSphere_trConstAtts_a_fLabel,
		   "constSphere_trConst a_fLabel");
      if (log && !findString("a_fLabel", constSphere_trConstAtts))
	{
	  warnAtt("a_fLabel", "constSphere_trConst", a_constSphere_trConst);
	  check_fLabel(a_constSphere_trConst->get_fLabel(), 0);
	}
      else
	check_fLabel(a_constSphere_trConst->get_fLabel(), log);
    }
  if (a_constSphere_trConst->get_trConst())
    {
      adjustLevels(&constSphere_trConstAtts_a_trConst,
		   "constSphere_trConst a_trConst");
      if (log && !findString("a_trConst", constSphere_trConstAtts))
	{
	  warnAtt("a_trConst", "constSphere_trConst", a_constSphere_trConst);
	  check_trConst(a_constSphere_trConst->get_trConst(), 0);
	}
      else
	check_trConst(a_constSphere_trConst->get_trConst(), log);
    }
}

/********************************************************************/

void check_constStm(
 constStm * a_constStm,
 int log)
{
  if (a_constStm->get_constMinor())
    {
      adjustLevels(&constStmAtts_a_constMinor, "constStm a_constMinor");
      if (log && !findString("a_constMinor", constStmAtts))
	{
	  warnAtt("a_constMinor", "constStm", a_constStm);
	  check_constMinor(a_constStm->get_constMinor(), 0);
	}
      else
	check_constMinor(a_constStm->get_constMinor(), log);
    }
}

/********************************************************************/

void check_constSympln(
 constSympln * a_constSympln,
 int log)
{
  if (a_constSympln->get_fLabel())
    {
      adjustLevels(&constSymplnAtts_a_fLabel, "constSympln a_fLabel");
      if (log && !findString("a_fLabel", constSymplnAtts))
	{
	  warnAtt("a_fLabel", "constSympln", a_constSympln);
	  check_fLabel(a_constSympln->get_fLabel(), 0);
	}
      else
	check_fLabel(a_constSympln->get_fLabel(), log);
    }
  if (a_constSympln->get_bfConst())
    {
      adjustLevels(&constSymplnAtts_a_bfConst, "constSympln a_bfConst");
      if (log && !findString("a_bfConst", constSymplnAtts))
	{
	  warnAtt("a_bfConst", "constSympln", a_constSympln);
	  check_bfConst(a_constSympln->get_bfConst(), 0);
	}
      else
	check_bfConst(a_constSympln->get_bfConst(), log);
    }
}

/********************************************************************/

void check_constTorus(
 constTorus * a_constTorus,
 int log)
{
  if (isA(a_constTorus, constTorus_bfConst))
    {
      adjustLevels(&constTorusSubs_constTorus_bfConst, "constTorus_bfConst");
      if (log && !findString("constTorus_bfConst", constTorusSubs))
	{
	  warnSub("constTorus_bfConst", "constTorus", a_constTorus);
	  check_constTorus_bfConst(
	    dynamic_cast<constTorus_bfConst *>(a_constTorus), 0);
	}
      else
	check_constTorus_bfConst(
	  dynamic_cast<constTorus_bfConst *>(a_constTorus), log);
      return;
    }
  if (isA(a_constTorus, constTorus_trConst))
    {
      adjustLevels(&constTorusSubs_constTorus_trConst, "constTorus_trConst");
      if (log && !findString("constTorus_trConst", constTorusSubs))
	{
	  warnSub("constTorus_trConst", "constTorus", a_constTorus);
	  check_constTorus_trConst(
	    dynamic_cast<constTorus_trConst *>(a_constTorus), 0);
	}
      else
	check_constTorus_trConst(
	  dynamic_cast<constTorus_trConst *>(a_constTorus), log);
      return;
    }
}

/********************************************************************/

void check_constTorus_bfConst(
 constTorus_bfConst * a_constTorus_bfConst,
 int log)
{
  if (a_constTorus_bfConst->get_fLabel())
    {
      adjustLevels(&constTorus_bfConstAtts_a_fLabel,
		   "constTorus_bfConst a_fLabel");
      if (log && !findString("a_fLabel", constTorus_bfConstAtts))
	{
	  warnAtt("a_fLabel", "constTorus_bfConst", a_constTorus_bfConst);
	  check_fLabel(a_constTorus_bfConst->get_fLabel(), 0);
	}
      else
	check_fLabel(a_constTorus_bfConst->get_fLabel(), log);
    }
  if (a_constTorus_bfConst->get_bfConst())
    {
      adjustLevels(&constTorus_bfConstAtts_a_bfConst,
		   "constTorus_bfConst a_bfConst");
      if (log && !findString("a_bfConst", constTorus_bfConstAtts))
	{
	  warnAtt("a_bfConst", "constTorus_bfConst", a_constTorus_bfConst);
	  check_bfConst(a_constTorus_bfConst->get_bfConst(), 0);
	}
      else
	check_bfConst(a_constTorus_bfConst->get_bfConst(), log);
    }
}

/********************************************************************/

void check_constTorus_trConst(
 constTorus_trConst * a_constTorus_trConst,
 int log)
{
  if (a_constTorus_trConst->get_fLabel())
    {
      adjustLevels(&constTorus_trConstAtts_a_fLabel,
		   "constTorus_trConst a_fLabel");
      if (log && !findString("a_fLabel", constTorus_trConstAtts))
	{
	  warnAtt("a_fLabel", "constTorus_trConst", a_constTorus_trConst);
	  check_fLabel(a_constTorus_trConst->get_fLabel(), 0);
	}
      else
	check_fLabel(a_constTorus_trConst->get_fLabel(), log);
    }
  if (a_constTorus_trConst->get_trConst())
    {
      adjustLevels(&constTorus_trConstAtts_a_trConst,
		   "constTorus_trConst a_trConst");
      if (log && !findString("a_trConst", constTorus_trConstAtts))
	{
	  warnAtt("a_trConst", "constTorus_trConst", a_constTorus_trConst);
	  check_trConst(a_constTorus_trConst->get_trConst(), 0);
	}
      else
	check_trConst(a_constTorus_trConst->get_trConst(), log);
    }
}

/********************************************************************/

void check_coordType(
 coordType * a_coordType,
 int log)
{
  if (isA(a_coordType, coordType_CART))
    {
      adjustLevels(&coordTypeSubs_coordType_CART, "coordType_CART");
      if (log && !findString("coordType_CART", coordTypeSubs))
	{
	  warnSub("coordType_CART", "coordType", a_coordType);
	}
      return;
    }
  if (isA(a_coordType, coordType_POL))
    {
      adjustLevels(&coordTypeSubs_coordType_POL, "coordType_POL");
      if (log && !findString("coordType_POL", coordTypeSubs))
	{
	  warnSub("coordType_POL", "coordType", a_coordType);
	}
      return;
    }
}

/********************************************************************/

void check_crLabel(
 crLabel * a_crLabel,
 int log)
{
  if (a_crLabel->get_labelName())
    {
      adjustLevels(&crLabelAtts_a_labelName, "crLabel a_labelName");
      if (log && !findString("a_labelName", crLabelAtts))
	{
	  warnAtt("a_labelName", "crLabel", a_crLabel);
	  check_labelName(a_crLabel->get_labelName(), 0);
	}
      else
	check_labelName(a_crLabel->get_labelName(), log);
    }
}

/********************************************************************/

void check_crLabelConst(
 crLabelConst * a_crLabelConst,
 int log)
{
  if (a_crLabelConst->get_labelNameConst())
    {
      adjustLevels(&crLabelConstAtts_a_labelNameConst,
		   "crLabelConst a_labelNameConst");
      if (log && !findString("a_labelNameConst", crLabelConstAtts))
	{
	  warnAtt("a_labelNameConst", "crLabelConst", a_crLabelConst);
	  check_labelNameConst(a_crLabelConst->get_labelNameConst(), 0);
	}
      else
	check_labelNameConst(a_crLabelConst->get_labelNameConst(), log);
    }
}

/********************************************************************/

void check_crgdefData(
 crgdefData * a_crgdefData,
 int log)
{
  if (a_crgdefData->get_zoneMin())
    {
      adjustLevels(&crgdefDataAtts_zoneMin, "crgdefData zoneMin");
      if (log && !findString("zoneMin", crgdefDataAtts))
	{
	  warnAtt("zoneMin", "crgdefData", a_crgdefData);
	  check_impCartPoint(a_crgdefData->get_zoneMin(), 0);
	}
      else
	check_impCartPoint(a_crgdefData->get_zoneMin(), log);
    }
  if (a_crgdefData->get_zoneMax())
    {
      adjustLevels(&crgdefDataAtts_zoneMax, "crgdefData zoneMax");
      if (log && !findString("zoneMax", crgdefDataAtts))
	{
	  warnAtt("zoneMax", "crgdefData", a_crgdefData);
	  check_impCartPoint(a_crgdefData->get_zoneMax(), 0);
	}
      else
	check_impCartPoint(a_crgdefData->get_zoneMax(), log);
    }
  if (a_crgdefData->get_xVec())
    {
      adjustLevels(&crgdefDataAtts_xVec, "crgdefData xVec");
      if (log && !findString("xVec", crgdefDataAtts))
	{
	  warnAtt("xVec", "crgdefData", a_crgdefData);
	  check_vector(a_crgdefData->get_xVec(), 0);
	}
      else
	check_vector(a_crgdefData->get_xVec(), log);
    }
  if (a_crgdefData->get_yVec())
    {
      adjustLevels(&crgdefDataAtts_yVec, "crgdefData yVec");
      if (log && !findString("yVec", crgdefDataAtts))
	{
	  warnAtt("yVec", "crgdefData", a_crgdefData);
	  check_vector(a_crgdefData->get_yVec(), 0);
	}
      else
	check_vector(a_crgdefData->get_yVec(), log);
    }
  if (a_crgdefData->get_zVec())
    {
      adjustLevels(&crgdefDataAtts_zVec, "crgdefData zVec");
      if (log && !findString("zVec", crgdefDataAtts))
	{
	  warnAtt("zVec", "crgdefData", a_crgdefData);
	  check_vector(a_crgdefData->get_zVec(), 0);
	}
      else
	check_vector(a_crgdefData->get_zVec(), log);
    }
  if (a_crgdefData->get_aVec())
    {
      adjustLevels(&crgdefDataAtts_aVec, "crgdefData aVec");
      if (log && !findString("aVec", crgdefDataAtts))
	{
	  warnAtt("aVec", "crgdefData", a_crgdefData);
	  check_vector(a_crgdefData->get_aVec(), 0);
	}
      else
	check_vector(a_crgdefData->get_aVec(), log);
    }
}

/********************************************************************/

void check_crgdefMinor(
 crgdefMinor * a_crgdefMinor,
 int log)
{
  if (isA(a_crgdefMinor, crgdefNoData))
    {
      adjustLevels(&crgdefMinorSubs_crgdefNoData, "crgdefNoData");
      if (log && !findString("crgdefNoData", crgdefMinorSubs))
	{
	  warnSub("crgdefNoData", "crgdefMinor", a_crgdefMinor);
	}
      return;
    }
  if (isA(a_crgdefMinor, crgdefData))
    {
      adjustLevels(&crgdefMinorSubs_crgdefData, "crgdefData");
      if (log && !findString("crgdefData", crgdefMinorSubs))
	{
	  warnSub("crgdefData", "crgdefMinor", a_crgdefMinor);
	  check_crgdefData(dynamic_cast<crgdefData *>(a_crgdefMinor), 0);
	}
      else
	check_crgdefData(dynamic_cast<crgdefData *>(a_crgdefMinor), log);
      return;
    }
}

/********************************************************************/

void check_crgdefStm(
 crgdefStm * a_crgdefStm,
 int log)
{
  if (a_crgdefStm->get_crLabelConst())
    {
      adjustLevels(&crgdefStmAtts_a_crLabelConst, "crgdefStm a_crLabelConst");
      if (log && !findString("a_crLabelConst", crgdefStmAtts))
	{
	  warnAtt("a_crLabelConst", "crgdefStm", a_crgdefStm);
	  check_crLabelConst(a_crgdefStm->get_crLabelConst(), 0);
	}
      else
	check_crLabelConst(a_crgdefStm->get_crLabelConst(), log);
    }
  if (a_crgdefStm->get_crgdefMinor())
    {
      adjustLevels(&crgdefStmAtts_a_crgdefMinor, "crgdefStm a_crgdefMinor");
      if (log && !findString("a_crgdefMinor", crgdefStmAtts))
	{
	  warnAtt("a_crgdefMinor", "crgdefStm", a_crgdefStm);
	  check_crgdefMinor(a_crgdefStm->get_crgdefMinor(), 0);
	}
      else
	check_crgdefMinor(a_crgdefStm->get_crgdefMinor(), log);
    }
}

/********************************************************************/

void check_criticality(
 criticality * a_criticality,
 int log)
{
  if (isA(a_criticality, criticality_CRITICAL))
    {
      adjustLevels(&criticalitySubs_criticality_CRITICAL,
		   "criticality_CRITICAL");
      if (log && !findString("criticality_CRITICAL", criticalitySubs))
	{
	  warnSub("criticality_CRITICAL", "criticality", a_criticality);
	}
      return;
    }
  if (isA(a_criticality, criticality_MAJOR))
    {
      adjustLevels(&criticalitySubs_criticality_MAJOR, "criticality_MAJOR");
      if (log && !findString("criticality_MAJOR", criticalitySubs))
	{
	  warnSub("criticality_MAJOR", "criticality", a_criticality);
	}
      return;
    }
  if (isA(a_criticality, criticality_MINOR))
    {
      adjustLevels(&criticalitySubs_criticality_MINOR, "criticality_MINOR");
      if (log && !findString("criticality_MINOR", criticalitySubs))
	{
	  warnSub("criticality_MINOR", "criticality", a_criticality);
	}
      return;
    }
}

/********************************************************************/

void check_crmodeMinor(
 crmodeMinor * a_crmodeMinor,
 int log)
{
  if (isA(a_crmodeMinor, crmodeMinor_SEQNTL))
    {
      adjustLevels(&crmodeMinorSubs_crmodeMinor_SEQNTL, "crmodeMinor_SEQNTL");
      if (log && !findString("crmodeMinor_SEQNTL", crmodeMinorSubs))
	{
	  warnSub("crmodeMinor_SEQNTL", "crmodeMinor", a_crmodeMinor);
	}
      return;
    }
  if (isA(a_crmodeMinor, crmodeMinor_SIMUL))
    {
      adjustLevels(&crmodeMinorSubs_crmodeMinor_SIMUL, "crmodeMinor_SIMUL");
      if (log && !findString("crmodeMinor_SIMUL", crmodeMinorSubs))
	{
	  warnSub("crmodeMinor_SIMUL", "crmodeMinor", a_crmodeMinor);
	}
      return;
    }
  if (isA(a_crmodeMinor, crmodeMinor_SYNC))
    {
      adjustLevels(&crmodeMinorSubs_crmodeMinor_SYNC, "crmodeMinor_SYNC");
      if (log && !findString("crmodeMinor_SYNC", crmodeMinorSubs))
	{
	  warnSub("crmodeMinor_SYNC", "crmodeMinor", a_crmodeMinor);
	}
      return;
    }
}

/********************************************************************/

void check_crmodeStm(
 crmodeStm * a_crmodeStm,
 int log)
{
  if (a_crmodeStm->get_crmodeMinor())
    {
      adjustLevels(&crmodeStmAtts_a_crmodeMinor, "crmodeStm a_crmodeMinor");
      if (log && !findString("a_crmodeMinor", crmodeStmAtts))
	{
	  warnAtt("a_crmodeMinor", "crmodeStm", a_crmodeStm);
	  check_crmodeMinor(a_crmodeStm->get_crmodeMinor(), 0);
	}
      else
	check_crmodeMinor(a_crmodeStm->get_crmodeMinor(), log);
    }
}

/********************************************************************/

void check_crosclStm(
 crosclStm * a_crosclStm,
 int log)
{
  if (a_crosclStm->get_state())
    {
      adjustLevels(&crosclStmAtts_a_state, "crosclStm a_state");
      if (log && !findString("a_state", crosclStmAtts))
	{
	  warnAtt("a_state", "crosclStm", a_crosclStm);
	  check_state(a_crosclStm->get_state(), 0);
	}
      else
	check_state(a_crosclStm->get_state(), log);
    }
}

/********************************************************************/

void check_crslctMinor(
 crslctMinor * a_crslctMinor,
 int log)
{
  if (isA(a_crslctMinor, crslctMinor_crLabelConst))
    {
      adjustLevels(&crslctMinorSubs_crslctMinor_crLabelConst,
		   "crslctMinor_crLabelConst");
      if (log && !findString("crslctMinor_crLabelConst", crslctMinorSubs))
	{
	  warnSub("crslctMinor_crLabelConst", "crslctMinor", a_crslctMinor);
	  check_crslctMinor_crLabelConst(
	    dynamic_cast<crslctMinor_crLabelConst *>(a_crslctMinor), 0);
	}
      else
	check_crslctMinor_crLabelConst(
	  dynamic_cast<crslctMinor_crLabelConst *>(a_crslctMinor), log);
      return;
    }
  if (isA(a_crslctMinor, crslctMinor_ALL))
    {
      adjustLevels(&crslctMinorSubs_crslctMinor_ALL, "crslctMinor_ALL");
      if (log && !findString("crslctMinor_ALL", crslctMinorSubs))
	{
	  warnSub("crslctMinor_ALL", "crslctMinor", a_crslctMinor);
	}
      return;
    }
}

/********************************************************************/

void check_crslctMinor_crLabelConst(
 crslctMinor_crLabelConst * a_crslctMinor_crLabelConst,
 int log)
{
  if (a_crslctMinor_crLabelConst->get_crLabelConst())
    {
      adjustLevels(&crslctMinor_crLabelConstAtts_a_crLabelConst,
		   "crslctMinor_crLabelConst a_crLabelConst");
      if (log && !findString("a_crLabelConst", crslctMinor_crLabelConstAtts))
	{
	  warnAtt("a_crLabelConst", "crslctMinor_crLabelConst",
		  a_crslctMinor_crLabelConst);
	  check_crLabelConst(a_crslctMinor_crLabelConst->get_crLabelConst(), 0);
	}
      else
	check_crLabelConst(a_crslctMinor_crLabelConst->get_crLabelConst(), log);
    }
}

/********************************************************************/

void check_crslctStm(
 crslctStm * a_crslctStm,
 int log)
{
  if (a_crslctStm->get_crslctMinor())
    {
      adjustLevels(&crslctStmAtts_a_crslctMinor, "crslctStm a_crslctMinor");
      if (log && !findString("a_crslctMinor", crslctStmAtts))
	{
	  warnAtt("a_crslctMinor", "crslctStm", a_crslctStm);
	  check_crslctMinor(a_crslctStm->get_crslctMinor(), 0);
	}
      else
	check_crslctMinor(a_crslctStm->get_crslctMinor(), log);
    }
}

/********************************************************************/

void check_csLabel(
 csLabel * a_csLabel,
 int log)
{
  if (a_csLabel->get_labelName())
    {
      adjustLevels(&csLabelAtts_a_labelName, "csLabel a_labelName");
      if (log && !findString("a_labelName", csLabelAtts))
	{
	  warnAtt("a_labelName", "csLabel", a_csLabel);
	  check_labelName(a_csLabel->get_labelName(), 0);
	}
      else
	check_labelName(a_csLabel->get_labelName(), log);
    }
}

/********************************************************************/

void check_csSpec(
 csSpec * a_csSpec,
 int log)
{
  if (isA(a_csSpec, csSpec_PCS))
    {
      adjustLevels(&csSpecSubs_csSpec_PCS, "csSpec_PCS");
      if (log && !findString("csSpec_PCS", csSpecSubs))
	{
	  warnSub("csSpec_PCS", "csSpec", a_csSpec);
	  check_csSpec_PCS(dynamic_cast<csSpec_PCS *>(a_csSpec), 0);
	}
      else
	check_csSpec_PCS(dynamic_cast<csSpec_PCS *>(a_csSpec), log);
      return;
    }
  if (isA(a_csSpec, csSpec_HEADCS))
    {
      adjustLevels(&csSpecSubs_csSpec_HEADCS, "csSpec_HEADCS");
      if (log && !findString("csSpec_HEADCS", csSpecSubs))
	{
	  warnSub("csSpec_HEADCS", "csSpec", a_csSpec);
	  check_csSpec_HEADCS(dynamic_cast<csSpec_HEADCS *>(a_csSpec), 0);
	}
      else
	check_csSpec_HEADCS(dynamic_cast<csSpec_HEADCS *>(a_csSpec), log);
      return;
    }
}

/********************************************************************/

void check_csSpec_HEADCS(
 csSpec_HEADCS * a_csSpec_HEADCS,
 int log)
{
  if (a_csSpec_HEADCS->get_rot1())
    {
      adjustLevels(&csSpec_HEADCSAtts_rot1, "csSpec_HEADCS rot1");
      if (log && !findString("rot1", csSpec_HEADCSAtts))
	{
	  warnAtt("rot1", "csSpec_HEADCS", a_csSpec_HEADCS);
	  check_rentVal(a_csSpec_HEADCS->get_rot1(), 0);
	}
      else
	check_rentVal(a_csSpec_HEADCS->get_rot1(), log);
    }
  if (a_csSpec_HEADCS->get_rot2())
    {
      adjustLevels(&csSpec_HEADCSAtts_rot2, "csSpec_HEADCS rot2");
      if (log && !findString("rot2", csSpec_HEADCSAtts))
	{
	  warnAtt("rot2", "csSpec_HEADCS", a_csSpec_HEADCS);
	  check_rentVal(a_csSpec_HEADCS->get_rot2(), 0);
	}
      else
	check_rentVal(a_csSpec_HEADCS->get_rot2(), log);
    }
  if (a_csSpec_HEADCS->get_rot3())
    {
      adjustLevels(&csSpec_HEADCSAtts_rot3, "csSpec_HEADCS rot3");
      if (log && !findString("rot3", csSpec_HEADCSAtts))
	{
	  warnAtt("rot3", "csSpec_HEADCS", a_csSpec_HEADCS);
	  check_rentVal(a_csSpec_HEADCS->get_rot3(), 0);
	}
      else
	check_rentVal(a_csSpec_HEADCS->get_rot3(), log);
    }
}

/********************************************************************/

void check_csSpec_PCS(
 csSpec_PCS * a_csSpec_PCS,
 int log)
{
  if (a_csSpec_PCS->get_euler())
    {
      adjustLevels(&csSpec_PCSAtts_a_euler, "csSpec_PCS a_euler");
      if (log && !findString("a_euler", csSpec_PCSAtts))
	{
	  warnAtt("a_euler", "csSpec_PCS", a_csSpec_PCS);
	  check_euler(a_csSpec_PCS->get_euler(), 0);
	}
      else
	check_euler(a_csSpec_PCS->get_euler(), log);
    }
}

/********************************************************************/

void check_curveConst(
 curveConst * a_curveConst,
 int log)
{
  if (a_curveConst->get_faLabel())
    {
      adjustLevels(&curveConstAtts_a_faLabel, "curveConst a_faLabel");
      if (log && !findString("a_faLabel", curveConstAtts))
	{
	  warnAtt("a_faLabel", "curveConst", a_curveConst);
	  check_faLabel(a_curveConst->get_faLabel(), 0);
	}
      else
	check_faLabel(a_curveConst->get_faLabel(), log);
    }
  if (a_curveConst->get_featureLabel())
    {
      adjustLevels(&curveConstAtts_a_featureLabel,
		   "curveConst a_featureLabel");
      if (log && !findString("a_featureLabel", curveConstAtts))
	{
	  warnAtt("a_featureLabel", "curveConst", a_curveConst);
	  check_featureLabel(a_curveConst->get_featureLabel(), 0);
	}
      else
	check_featureLabel(a_curveConst->get_featureLabel(), log);
    }
}

/********************************************************************/

void check_curvePtdataHeadcs(
 curvePtdataHeadcs * a_curvePtdataHeadcs,
 int log)
{
  if (a_curvePtdataHeadcs->get_pointVecCart())
    {
      adjustLevels(&curvePtdataHeadcsAtts_a_pointVecCart,
		   "curvePtdataHeadcs a_pointVecCart");
      if (log && !findString("a_pointVecCart", curvePtdataHeadcsAtts))
	{
	  warnAtt("a_pointVecCart", "curvePtdataHeadcs", a_curvePtdataHeadcs);
	  check_pointVecCart(a_curvePtdataHeadcs->get_pointVecCart(), 0);
	}
      else
	check_pointVecCart(a_curvePtdataHeadcs->get_pointVecCart(), log);
    }
  if (a_curvePtdataHeadcs->get_rot1())
    {
      adjustLevels(&curvePtdataHeadcsAtts_rot1, "curvePtdataHeadcs rot1");
      if (log && !findString("rot1", curvePtdataHeadcsAtts))
	{
	  warnAtt("rot1", "curvePtdataHeadcs", a_curvePtdataHeadcs);
	  check_rentVal(a_curvePtdataHeadcs->get_rot1(), 0);
	}
      else
	check_rentVal(a_curvePtdataHeadcs->get_rot1(), log);
    }
  if (a_curvePtdataHeadcs->get_rot2())
    {
      adjustLevels(&curvePtdataHeadcsAtts_rot2, "curvePtdataHeadcs rot2");
      if (log && !findString("rot2", curvePtdataHeadcsAtts))
	{
	  warnAtt("rot2", "curvePtdataHeadcs", a_curvePtdataHeadcs);
	  check_rentVal(a_curvePtdataHeadcs->get_rot2(), 0);
	}
      else
	check_rentVal(a_curvePtdataHeadcs->get_rot2(), log);
    }
  if (a_curvePtdataHeadcs->get_rot3())
    {
      adjustLevels(&curvePtdataHeadcsAtts_rot3, "curvePtdataHeadcs rot3");
      if (log && !findString("rot3", curvePtdataHeadcsAtts))
	{
	  warnAtt("rot3", "curvePtdataHeadcs", a_curvePtdataHeadcs);
	  check_rentVal(a_curvePtdataHeadcs->get_rot3(), 0);
	}
      else
	check_rentVal(a_curvePtdataHeadcs->get_rot3(), log);
    }
  if (a_curvePtdataHeadcs->get_curvePtdataHeadcsList())
    {
      std::list<curvePtdataHeadcsListItem *> * theList;
      std::list<curvePtdataHeadcsListItem *>::iterator iter;
      theList = a_curvePtdataHeadcs->get_curvePtdataHeadcsList();
      adjustLevels(&curvePtdataHeadcsAtts_a_curvePtdataHeadcsList,
		   "curvePtdataHeadcs a_curvePtdataHeadcsList");
      if (log && !findString("a_curvePtdataHeadcsList", curvePtdataHeadcsAtts))
	{
	  warnAtt("a_curvePtdataHeadcsList", "curvePtdataHeadcs",
		  a_curvePtdataHeadcs);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_curvePtdataHeadcsListItem(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_curvePtdataHeadcsListItem(*iter, log);
	}
    }
}

/********************************************************************/

void check_curvePtdataHeadcsListItem(
 curvePtdataHeadcsListItem * a_curvePtdataHeadcsListItem,
 int log)
{
  if (a_curvePtdataHeadcsListItem->get_pointVecCart())
    {
      adjustLevels(&curvePtdataHeadcsListItemAtts_a_pointVecCart,
		   "curvePtdataHeadcsListItem a_pointVecCart");
      if (log && !findString("a_pointVecCart", curvePtdataHeadcsListItemAtts))
	{
	  warnAtt("a_pointVecCart", "curvePtdataHeadcsListItem",
		  a_curvePtdataHeadcsListItem);
	  check_pointVecCart(
	    a_curvePtdataHeadcsListItem->get_pointVecCart(), 0);
	}
      else
	check_pointVecCart(
	  a_curvePtdataHeadcsListItem->get_pointVecCart(), log);
    }
  if (a_curvePtdataHeadcsListItem->get_rot1())
    {
      adjustLevels(&curvePtdataHeadcsListItemAtts_rot1,
		   "curvePtdataHeadcsListItem rot1");
      if (log && !findString("rot1", curvePtdataHeadcsListItemAtts))
	{
	  warnAtt("rot1", "curvePtdataHeadcsListItem",
		  a_curvePtdataHeadcsListItem);
	  check_rentVal(a_curvePtdataHeadcsListItem->get_rot1(), 0);
	}
      else
	check_rentVal(a_curvePtdataHeadcsListItem->get_rot1(), log);
    }
  if (a_curvePtdataHeadcsListItem->get_rot2())
    {
      adjustLevels(&curvePtdataHeadcsListItemAtts_rot2,
		   "curvePtdataHeadcsListItem rot2");
      if (log && !findString("rot2", curvePtdataHeadcsListItemAtts))
	{
	  warnAtt("rot2", "curvePtdataHeadcsListItem",
		  a_curvePtdataHeadcsListItem);
	  check_rentVal(a_curvePtdataHeadcsListItem->get_rot2(), 0);
	}
      else
	check_rentVal(a_curvePtdataHeadcsListItem->get_rot2(), log);
    }
  if (a_curvePtdataHeadcsListItem->get_rot3())
    {
      adjustLevels(&curvePtdataHeadcsListItemAtts_rot3,
		   "curvePtdataHeadcsListItem rot3");
      if (log && !findString("rot3", curvePtdataHeadcsListItemAtts))
	{
	  warnAtt("rot3", "curvePtdataHeadcsListItem",
		  a_curvePtdataHeadcsListItem);
	  check_rentVal(a_curvePtdataHeadcsListItem->get_rot3(), 0);
	}
      else
	check_rentVal(a_curvePtdataHeadcsListItem->get_rot3(), log);
    }
}

/********************************************************************/

void check_curvePtdataPcs(
 curvePtdataPcs * a_curvePtdataPcs,
 int log)
{
  if (a_curvePtdataPcs->get_pointVecCart())
    {
      adjustLevels(&curvePtdataPcsAtts_a_pointVecCart,
		   "curvePtdataPcs a_pointVecCart");
      if (log && !findString("a_pointVecCart", curvePtdataPcsAtts))
	{
	  warnAtt("a_pointVecCart", "curvePtdataPcs", a_curvePtdataPcs);
	  check_pointVecCart(a_curvePtdataPcs->get_pointVecCart(), 0);
	}
      else
	check_pointVecCart(a_curvePtdataPcs->get_pointVecCart(), log);
    }
  if (a_curvePtdataPcs->get_euler())
    {
      adjustLevels(&curvePtdataPcsAtts_a_euler, "curvePtdataPcs a_euler");
      if (log && !findString("a_euler", curvePtdataPcsAtts))
	{
	  warnAtt("a_euler", "curvePtdataPcs", a_curvePtdataPcs);
	  check_euler(a_curvePtdataPcs->get_euler(), 0);
	}
      else
	check_euler(a_curvePtdataPcs->get_euler(), log);
    }
  if (a_curvePtdataPcs->get_curvePtdataPcsList())
    {
      std::list<curvePtdataPcsListItem *> * theList;
      std::list<curvePtdataPcsListItem *>::iterator iter;
      theList = a_curvePtdataPcs->get_curvePtdataPcsList();
      adjustLevels(&curvePtdataPcsAtts_a_curvePtdataPcsList,
		   "curvePtdataPcs a_curvePtdataPcsList");
      if (log && !findString("a_curvePtdataPcsList", curvePtdataPcsAtts))
	{
	  warnAtt("a_curvePtdataPcsList", "curvePtdataPcs", a_curvePtdataPcs);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_curvePtdataPcsListItem(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_curvePtdataPcsListItem(*iter, log);
	}
    }
}

/********************************************************************/

void check_curvePtdataPcsListItem(
 curvePtdataPcsListItem * a_curvePtdataPcsListItem,
 int log)
{
  if (a_curvePtdataPcsListItem->get_pointVecCart())
    {
      adjustLevels(&curvePtdataPcsListItemAtts_a_pointVecCart,
		   "curvePtdataPcsListItem a_pointVecCart");
      if (log && !findString("a_pointVecCart", curvePtdataPcsListItemAtts))
	{
	  warnAtt("a_pointVecCart", "curvePtdataPcsListItem",
		  a_curvePtdataPcsListItem);
	  check_pointVecCart(a_curvePtdataPcsListItem->get_pointVecCart(), 0);
	}
      else
	check_pointVecCart(a_curvePtdataPcsListItem->get_pointVecCart(), log);
    }
  if (a_curvePtdataPcsListItem->get_euler())
    {
      adjustLevels(&curvePtdataPcsListItemAtts_a_euler,
		   "curvePtdataPcsListItem a_euler");
      if (log && !findString("a_euler", curvePtdataPcsListItemAtts))
	{
	  warnAtt("a_euler", "curvePtdataPcsListItem",
		  a_curvePtdataPcsListItem);
	  check_euler(a_curvePtdataPcsListItem->get_euler(), 0);
	}
      else
	check_euler(a_curvePtdataPcsListItem->get_euler(), log);
    }
}

/********************************************************************/

void check_cutcomAdjust(
 cutcomAdjust * a_cutcomAdjust,
 int log)
{
  if (a_cutcomAdjust->get_mdLabel())
    {
      adjustLevels(&cutcomAdjustAtts_a_mdLabel, "cutcomAdjust a_mdLabel");
      if (log && !findString("a_mdLabel", cutcomAdjustAtts))
	{
	  warnAtt("a_mdLabel", "cutcomAdjust", a_cutcomAdjust);
	  check_mdLabel(a_cutcomAdjust->get_mdLabel(), 0);
	}
      else
	check_mdLabel(a_cutcomAdjust->get_mdLabel(), log);
    }
  if (a_cutcomAdjust->get_tlLabel())
    {
      adjustLevels(&cutcomAdjustAtts_a_tlLabel, "cutcomAdjust a_tlLabel");
      if (log && !findString("a_tlLabel", cutcomAdjustAtts))
	{
	  warnAtt("a_tlLabel", "cutcomAdjust", a_cutcomAdjust);
	  check_tlLabel(a_cutcomAdjust->get_tlLabel(), 0);
	}
      else
	check_tlLabel(a_cutcomAdjust->get_tlLabel(), log);
    }
  if (a_cutcomAdjust->get_leftRight())
    {
      adjustLevels(&cutcomAdjustAtts_a_leftRight, "cutcomAdjust a_leftRight");
      if (log && !findString("a_leftRight", cutcomAdjustAtts))
	{
	  warnAtt("a_leftRight", "cutcomAdjust", a_cutcomAdjust);
	  check_leftRight(a_cutcomAdjust->get_leftRight(), 0);
	}
      else
	check_leftRight(a_cutcomAdjust->get_leftRight(), log);
    }
  if (a_cutcomAdjust->get_plan())
    {
      adjustLevels(&cutcomAdjustAtts_a_plan, "cutcomAdjust a_plan");
      if (log && !findString("a_plan", cutcomAdjustAtts))
	{
	  warnAtt("a_plan", "cutcomAdjust", a_cutcomAdjust);
	  check_plan(a_cutcomAdjust->get_plan(), 0);
	}
      else
	check_plan(a_cutcomAdjust->get_plan(), log);
    }
  if (a_cutcomAdjust->get_amt())
    {
      adjustLevels(&cutcomAdjustAtts_amt, "cutcomAdjust amt");
      if (log && !findString("amt", cutcomAdjustAtts))
	{
	  warnAtt("amt", "cutcomAdjust", a_cutcomAdjust);
	  check_rentVal(a_cutcomAdjust->get_amt(), 0);
	}
      else
	check_rentVal(a_cutcomAdjust->get_amt(), log);
    }
}

/********************************************************************/

void check_cutcomMatrix(
 cutcomMatrix * a_cutcomMatrix,
 int log)
{
  if (a_cutcomMatrix->get_mdLabel())
    {
      adjustLevels(&cutcomMatrixAtts_a_mdLabel, "cutcomMatrix a_mdLabel");
      if (log && !findString("a_mdLabel", cutcomMatrixAtts))
	{
	  warnAtt("a_mdLabel", "cutcomMatrix", a_cutcomMatrix);
	  check_mdLabel(a_cutcomMatrix->get_mdLabel(), 0);
	}
      else
	check_mdLabel(a_cutcomMatrix->get_mdLabel(), log);
    }
  if (a_cutcomMatrix->get_cutcomMatx())
    {
      adjustLevels(&cutcomMatrixAtts_a_cutcomMatx,
		   "cutcomMatrix a_cutcomMatx");
      if (log && !findString("a_cutcomMatx", cutcomMatrixAtts))
	{
	  warnAtt("a_cutcomMatx", "cutcomMatrix", a_cutcomMatrix);
	  check_cutcomMatx(a_cutcomMatrix->get_cutcomMatx(), 0);
	}
      else
	check_cutcomMatx(a_cutcomMatrix->get_cutcomMatx(), log);
    }
}

/********************************************************************/

void check_cutcomMatx(
 cutcomMatx * a_cutcomMatx,
 int log)
{
  if (a_cutcomMatx->get_dx())
    {
      adjustLevels(&cutcomMatxAtts_dx, "cutcomMatx dx");
      if (log && !findString("dx", cutcomMatxAtts))
	{
	  warnAtt("dx", "cutcomMatx", a_cutcomMatx);
	  check_rentVal(a_cutcomMatx->get_dx(), 0);
	}
      else
	check_rentVal(a_cutcomMatx->get_dx(), log);
    }
  if (a_cutcomMatx->get_dy())
    {
      adjustLevels(&cutcomMatxAtts_dy, "cutcomMatx dy");
      if (log && !findString("dy", cutcomMatxAtts))
	{
	  warnAtt("dy", "cutcomMatx", a_cutcomMatx);
	  check_rentVal(a_cutcomMatx->get_dy(), 0);
	}
      else
	check_rentVal(a_cutcomMatx->get_dy(), log);
    }
  if (a_cutcomMatx->get_dz())
    {
      adjustLevels(&cutcomMatxAtts_dz, "cutcomMatx dz");
      if (log && !findString("dz", cutcomMatxAtts))
	{
	  warnAtt("dz", "cutcomMatx", a_cutcomMatx);
	  check_rentVal(a_cutcomMatx->get_dz(), 0);
	}
      else
	check_rentVal(a_cutcomMatx->get_dz(), log);
    }
  if (a_cutcomMatx->get_ix())
    {
      adjustLevels(&cutcomMatxAtts_ix, "cutcomMatx ix");
      if (log && !findString("ix", cutcomMatxAtts))
	{
	  warnAtt("ix", "cutcomMatx", a_cutcomMatx);
	  check_rentVal(a_cutcomMatx->get_ix(), 0);
	}
      else
	check_rentVal(a_cutcomMatx->get_ix(), log);
    }
  if (a_cutcomMatx->get_iy())
    {
      adjustLevels(&cutcomMatxAtts_iy, "cutcomMatx iy");
      if (log && !findString("iy", cutcomMatxAtts))
	{
	  warnAtt("iy", "cutcomMatx", a_cutcomMatx);
	  check_rentVal(a_cutcomMatx->get_iy(), 0);
	}
      else
	check_rentVal(a_cutcomMatx->get_iy(), log);
    }
  if (a_cutcomMatx->get_iz())
    {
      adjustLevels(&cutcomMatxAtts_iz, "cutcomMatx iz");
      if (log && !findString("iz", cutcomMatxAtts))
	{
	  warnAtt("iz", "cutcomMatx", a_cutcomMatx);
	  check_rentVal(a_cutcomMatx->get_iz(), 0);
	}
      else
	check_rentVal(a_cutcomMatx->get_iz(), log);
    }
  if (a_cutcomMatx->get_jx())
    {
      adjustLevels(&cutcomMatxAtts_jx, "cutcomMatx jx");
      if (log && !findString("jx", cutcomMatxAtts))
	{
	  warnAtt("jx", "cutcomMatx", a_cutcomMatx);
	  check_rentVal(a_cutcomMatx->get_jx(), 0);
	}
      else
	check_rentVal(a_cutcomMatx->get_jx(), log);
    }
  if (a_cutcomMatx->get_jy())
    {
      adjustLevels(&cutcomMatxAtts_jy, "cutcomMatx jy");
      if (log && !findString("jy", cutcomMatxAtts))
	{
	  warnAtt("jy", "cutcomMatx", a_cutcomMatx);
	  check_rentVal(a_cutcomMatx->get_jy(), 0);
	}
      else
	check_rentVal(a_cutcomMatx->get_jy(), log);
    }
  if (a_cutcomMatx->get_jz())
    {
      adjustLevels(&cutcomMatxAtts_jz, "cutcomMatx jz");
      if (log && !findString("jz", cutcomMatxAtts))
	{
	  warnAtt("jz", "cutcomMatx", a_cutcomMatx);
	  check_rentVal(a_cutcomMatx->get_jz(), 0);
	}
      else
	check_rentVal(a_cutcomMatx->get_jz(), log);
    }
  if (a_cutcomMatx->get_kx())
    {
      adjustLevels(&cutcomMatxAtts_kx, "cutcomMatx kx");
      if (log && !findString("kx", cutcomMatxAtts))
	{
	  warnAtt("kx", "cutcomMatx", a_cutcomMatx);
	  check_rentVal(a_cutcomMatx->get_kx(), 0);
	}
      else
	check_rentVal(a_cutcomMatx->get_kx(), log);
    }
  if (a_cutcomMatx->get_ky())
    {
      adjustLevels(&cutcomMatxAtts_ky, "cutcomMatx ky");
      if (log && !findString("ky", cutcomMatxAtts))
	{
	  warnAtt("ky", "cutcomMatx", a_cutcomMatx);
	  check_rentVal(a_cutcomMatx->get_ky(), 0);
	}
      else
	check_rentVal(a_cutcomMatx->get_ky(), log);
    }
  if (a_cutcomMatx->get_kz())
    {
      adjustLevels(&cutcomMatxAtts_kz, "cutcomMatx kz");
      if (log && !findString("kz", cutcomMatxAtts))
	{
	  warnAtt("kz", "cutcomMatx", a_cutcomMatx);
	  check_rentVal(a_cutcomMatx->get_kz(), 0);
	}
      else
	check_rentVal(a_cutcomMatx->get_kz(), log);
    }
}

/********************************************************************/

void check_cutcomMinor(
 cutcomMinor * a_cutcomMinor,
 int log)
{
  if (isA(a_cutcomMinor, cutcomAdjust))
    {
      adjustLevels(&cutcomMinorSubs_cutcomAdjust, "cutcomAdjust");
      if (log && !findString("cutcomAdjust", cutcomMinorSubs))
	{
	  warnSub("cutcomAdjust", "cutcomMinor", a_cutcomMinor);
	  check_cutcomAdjust(
	    dynamic_cast<cutcomAdjust *>(a_cutcomMinor), 0);
	}
      else
	check_cutcomAdjust(
	  dynamic_cast<cutcomAdjust *>(a_cutcomMinor), log);
      return;
    }
  if (isA(a_cutcomMinor, cutcomParam))
    {
      adjustLevels(&cutcomMinorSubs_cutcomParam, "cutcomParam");
      if (log && !findString("cutcomParam", cutcomMinorSubs))
	{
	  warnSub("cutcomParam", "cutcomMinor", a_cutcomMinor);
	  check_cutcomParam(dynamic_cast<cutcomParam *>(a_cutcomMinor), 0);
	}
      else
	check_cutcomParam(dynamic_cast<cutcomParam *>(a_cutcomMinor), log);
      return;
    }
  if (isA(a_cutcomMinor, cutcomMatrix))
    {
      adjustLevels(&cutcomMinorSubs_cutcomMatrix, "cutcomMatrix");
      if (log && !findString("cutcomMatrix", cutcomMinorSubs))
	{
	  warnSub("cutcomMatrix", "cutcomMinor", a_cutcomMinor);
	  check_cutcomMatrix(
	    dynamic_cast<cutcomMatrix *>(a_cutcomMinor), 0);
	}
      else
	check_cutcomMatrix(
	  dynamic_cast<cutcomMatrix *>(a_cutcomMinor), log);
      return;
    }
  if (isA(a_cutcomMinor, cutcomUserdf))
    {
      adjustLevels(&cutcomMinorSubs_cutcomUserdf, "cutcomUserdf");
      if (log && !findString("cutcomUserdf", cutcomMinorSubs))
	{
	  warnSub("cutcomUserdf", "cutcomMinor", a_cutcomMinor);
	  check_cutcomUserdf(
	    dynamic_cast<cutcomUserdf *>(a_cutcomMinor), 0);
	}
      else
	check_cutcomUserdf(
	  dynamic_cast<cutcomUserdf *>(a_cutcomMinor), log);
      return;
    }
}

/********************************************************************/

void check_cutcomParam(
 cutcomParam * a_cutcomParam,
 int log)
{
  if (a_cutcomParam->get_mdLabel())
    {
      adjustLevels(&cutcomParamAtts_a_mdLabel, "cutcomParam a_mdLabel");
      if (log && !findString("a_mdLabel", cutcomParamAtts))
	{
	  warnAtt("a_mdLabel", "cutcomParam", a_cutcomParam);
	  check_mdLabel(a_cutcomParam->get_mdLabel(), 0);
	}
      else
	check_mdLabel(a_cutcomParam->get_mdLabel(), log);
    }
  if (a_cutcomParam->get_pointVecCart())
    {
      adjustLevels(&cutcomParamAtts_a_pointVecCart,
		   "cutcomParam a_pointVecCart");
      if (log && !findString("a_pointVecCart", cutcomParamAtts))
	{
	  warnAtt("a_pointVecCart", "cutcomParam", a_cutcomParam);
	  check_pointVecCart(a_cutcomParam->get_pointVecCart(), 0);
	}
      else
	check_pointVecCart(a_cutcomParam->get_pointVecCart(), log);
    }
}

/********************************************************************/

void check_cutcomStm(
 cutcomStm * a_cutcomStm,
 int log)
{
  if (a_cutcomStm->get_ccLabel())
    {
      adjustLevels(&cutcomStmAtts_a_ccLabel, "cutcomStm a_ccLabel");
      if (log && !findString("a_ccLabel", cutcomStmAtts))
	{
	  warnAtt("a_ccLabel", "cutcomStm", a_cutcomStm);
	  check_ccLabel(a_cutcomStm->get_ccLabel(), 0);
	}
      else
	check_ccLabel(a_cutcomStm->get_ccLabel(), log);
    }
  if (a_cutcomStm->get_cutcomMinor())
    {
      adjustLevels(&cutcomStmAtts_a_cutcomMinor, "cutcomStm a_cutcomMinor");
      if (log && !findString("a_cutcomMinor", cutcomStmAtts))
	{
	  warnAtt("a_cutcomMinor", "cutcomStm", a_cutcomStm);
	  check_cutcomMinor(a_cutcomStm->get_cutcomMinor(), 0);
	}
      else
	check_cutcomMinor(a_cutcomStm->get_cutcomMinor(), log);
    }
}

/********************************************************************/

void check_cutcomUserdf(
 cutcomUserdf * a_cutcomUserdf,
 int log)
{
  if (a_cutcomUserdf->get_mdLabel())
    {
      adjustLevels(&cutcomUserdfAtts_a_mdLabel, "cutcomUserdf a_mdLabel");
      if (log && !findString("a_mdLabel", cutcomUserdfAtts))
	{
	  warnAtt("a_mdLabel", "cutcomUserdf", a_cutcomUserdf);
	  check_mdLabel(a_cutcomUserdf->get_mdLabel(), 0);
	}
      else
	check_mdLabel(a_cutcomUserdf->get_mdLabel(), log);
    }
  if (a_cutcomUserdf->get_text())
    {
      adjustLevels(&cutcomUserdfAtts_text, "cutcomUserdf text");
      if (log && !findString("text", cutcomUserdfAtts))
	{
	  warnAtt("text", "cutcomUserdf", a_cutcomUserdf);
	  check_stringVal(a_cutcomUserdf->get_text(), 0);
	}
      else
	check_stringVal(a_cutcomUserdf->get_text(), log);
    }
}

/********************************************************************/

void check_czLabel(
 czLabel * a_czLabel,
 int log)
{
  if (a_czLabel->get_labelName())
    {
      adjustLevels(&czLabelAtts_a_labelName, "czLabel a_labelName");
      if (log && !findString("a_labelName", czLabelAtts))
	{
	  warnAtt("a_labelName", "czLabel", a_czLabel);
	  check_labelName(a_czLabel->get_labelName(), 0);
	}
      else
	check_labelName(a_czLabel->get_labelName(), log);
    }
}

/********************************************************************/

void check_czoneStm(
 czoneStm * a_czoneStm,
 int log)
{
  if (a_czoneStm->get_czLabel())
    {
      adjustLevels(&czoneStmAtts_a_czLabel, "czoneStm a_czLabel");
      if (log && !findString("a_czLabel", czoneStmAtts))
	{
	  warnAtt("a_czLabel", "czoneStm", a_czoneStm);
	  check_czLabel(a_czoneStm->get_czLabel(), 0);
	}
      else
	check_czLabel(a_czoneStm->get_czLabel(), log);
    }
}

/********************************************************************/

void check_czslctStm(
 czslctStm * a_czslctStm,
 int log)
{
  if (a_czslctStm->get_czLabel())
    {
      adjustLevels(&czslctStmAtts_a_czLabel, "czslctStm a_czLabel");
      if (log && !findString("a_czLabel", czslctStmAtts))
	{
	  warnAtt("a_czLabel", "czslctStm", a_czslctStm);
	  check_czLabel(a_czslctStm->get_czLabel(), 0);
	}
      else
	check_czLabel(a_czslctStm->get_czLabel(), log);
    }
  if (a_czslctStm->get_state())
    {
      adjustLevels(&czslctStmAtts_a_state, "czslctStm a_state");
      if (log && !findString("a_state", czslctStmAtts))
	{
	  warnAtt("a_state", "czslctStm", a_czslctStm);
	  check_state(a_czslctStm->get_state(), 0);
	}
      else
	check_state(a_czslctStm->get_state(), log);
    }
}

/********************************************************************/

void check_dLabel(
 dLabel * a_dLabel,
 int log)
{
  if (a_dLabel->get_labelName())
    {
      adjustLevels(&dLabelAtts_a_labelName, "dLabel a_labelName");
      if (log && !findString("a_labelName", dLabelAtts))
	{
	  warnAtt("a_labelName", "dLabel", a_dLabel);
	  check_labelName(a_dLabel->get_labelName(), 0);
	}
      else
	check_labelName(a_dLabel->get_labelName(), log);
    }
}

/********************************************************************/

void check_daLabel(
 daLabel * a_daLabel,
 int log)
{
  if (a_daLabel->get_labelName())
    {
      adjustLevels(&daLabelAtts_a_labelName, "daLabel a_labelName");
      if (log && !findString("a_labelName", daLabelAtts))
	{
	  warnAtt("a_labelName", "daLabel", a_daLabel);
	  check_labelName(a_daLabel->get_labelName(), 0);
	}
      else
	check_labelName(a_daLabel->get_labelName(), log);
    }
}

/********************************************************************/

void check_datLabel(
 datLabel * a_datLabel,
 int log)
{
  if (a_datLabel->get_labelName())
    {
      adjustLevels(&datLabelAtts_a_labelName, "datLabel a_labelName");
      if (log && !findString("a_labelName", datLabelAtts))
	{
	  warnAtt("a_labelName", "datLabel", a_datLabel);
	  check_labelName(a_datLabel->get_labelName(), 0);
	}
      else
	check_labelName(a_datLabel->get_labelName(), log);
    }
}

/********************************************************************/

void check_datdefMinor(
 datdefMinor * a_datdefMinor,
 int log)
{
  if (isA(a_datdefMinor, datdefMinor_featureLabel1))
    {
      adjustLevels(&datdefMinorSubs_datdefMinor_featureLabel1,
		   "datdefMinor_featureLabel1");
      if (log && !findString("datdefMinor_featureLabel1", datdefMinorSubs))
	{
	  warnSub("datdefMinor_featureLabel1", "datdefMinor", a_datdefMinor);
	  check_datdefMinor_featureLabel1(
	    dynamic_cast<datdefMinor_featureLabel1 *>(a_datdefMinor), 0);
	}
      else
	check_datdefMinor_featureLabel1(
	  dynamic_cast<datdefMinor_featureLabel1 *>(a_datdefMinor), log);
      return;
    }
  if (isA(a_datdefMinor, datdefMinor_dattrgList))
    {
      adjustLevels(&datdefMinorSubs_datdefMinor_dattrgList,
		   "datdefMinor_dattrgList");
      if (log && !findString("datdefMinor_dattrgList", datdefMinorSubs))
	{
	  warnSub("datdefMinor_dattrgList", "datdefMinor", a_datdefMinor);
	  check_datdefMinor_dattrgList(
	    dynamic_cast<datdefMinor_dattrgList *>(a_datdefMinor), 0);
	}
      else
	check_datdefMinor_dattrgList(
	  dynamic_cast<datdefMinor_dattrgList *>(a_datdefMinor), log);
      return;
    }
}

/********************************************************************/

void check_datdefMinor_dattrgList(
 datdefMinor_dattrgList * a_datdefMinor_dattrgList,
 int log)
{
  if (a_datdefMinor_dattrgList->get_dattrgList())
    {
      std::list<dattrgLabel *> * theList;
      std::list<dattrgLabel *>::iterator iter;
      theList = a_datdefMinor_dattrgList->get_dattrgList();
      adjustLevels(&datdefMinor_dattrgListAtts_a_dattrgList,
		   "datdefMinor_dattrgList a_dattrgList");
      if (log && !findString("a_dattrgList", datdefMinor_dattrgListAtts))
	{
	  warnAtt("a_dattrgList", "datdefMinor_dattrgList",
		  a_datdefMinor_dattrgList);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_dattrgLabel(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_dattrgLabel(*iter, log);
	}
    }
  if (a_datdefMinor_dattrgList->get_fLabel())
    {
      adjustLevels(&datdefMinor_dattrgListAtts_a_fLabel,
		   "datdefMinor_dattrgList a_fLabel");
      if (log && !findString("a_fLabel", datdefMinor_dattrgListAtts))
	{
	  warnAtt("a_fLabel", "datdefMinor_dattrgList",
		  a_datdefMinor_dattrgList);
	  check_fLabel(a_datdefMinor_dattrgList->get_fLabel(), 0);
	}
      else
	check_fLabel(a_datdefMinor_dattrgList->get_fLabel(), log);
    }
  if (a_datdefMinor_dattrgList->get_datLabel())
    {
      adjustLevels(&datdefMinor_dattrgListAtts_a_datLabel,
		   "datdefMinor_dattrgList a_datLabel");
      if (log && !findString("a_datLabel", datdefMinor_dattrgListAtts))
	{
	  warnAtt("a_datLabel", "datdefMinor_dattrgList",
		  a_datdefMinor_dattrgList);
	  check_datLabel(a_datdefMinor_dattrgList->get_datLabel(), 0);
	}
      else
	check_datLabel(a_datdefMinor_dattrgList->get_datLabel(), log);
    }
}

/********************************************************************/

void check_datdefMinor_featureLabel1(
 datdefMinor_featureLabel1 * a_datdefMinor_featureLabel1,
 int log)
{
  if (a_datdefMinor_featureLabel1->get_featureLabel1())
    {
      adjustLevels(&datdefMinor_featureLabel1Atts_a_featureLabel1,
		   "datdefMinor_featureLabel1 a_featureLabel1");
      if (log && !findString("a_featureLabel1", datdefMinor_featureLabel1Atts))
	{
	  warnAtt("a_featureLabel1", "datdefMinor_featureLabel1",
		  a_datdefMinor_featureLabel1);
	  check_featureLabel1(
	    a_datdefMinor_featureLabel1->get_featureLabel1(), 0);
	}
      else
	check_featureLabel1(
	  a_datdefMinor_featureLabel1->get_featureLabel1(), log);
    }
  if (a_datdefMinor_featureLabel1->get_datLabel())
    {
      adjustLevels(&datdefMinor_featureLabel1Atts_a_datLabel,
		   "datdefMinor_featureLabel1 a_datLabel");
      if (log && !findString("a_datLabel", datdefMinor_featureLabel1Atts))
	{
	  warnAtt("a_datLabel", "datdefMinor_featureLabel1",
		  a_datdefMinor_featureLabel1);
	  check_datLabel(a_datdefMinor_featureLabel1->get_datLabel(), 0);
	}
      else
	check_datLabel(a_datdefMinor_featureLabel1->get_datLabel(), log);
    }
}

/********************************************************************/

void check_datdefStm(
 datdefStm * a_datdefStm,
 int log)
{
  if (a_datdefStm->get_datdefMinor())
    {
      adjustLevels(&datdefStmAtts_a_datdefMinor, "datdefStm a_datdefMinor");
      if (log && !findString("a_datdefMinor", datdefStmAtts))
	{
	  warnAtt("a_datdefMinor", "datdefStm", a_datdefStm);
	  check_datdefMinor(a_datdefStm->get_datdefMinor(), 0);
	}
      else
	check_datdefMinor(a_datdefStm->get_datdefMinor(), log);
    }
}

/********************************************************************/

void check_datsetDats(
 datsetDats * a_datsetDats,
 int log)
{
  if (a_datsetDats->get_spec1())
    {
      adjustLevels(&datsetDatsAtts_spec1, "datsetDats spec1");
      if (log && !findString("spec1", datsetDatsAtts))
	{
	  warnAtt("spec1", "datsetDats", a_datsetDats);
	  check_datsetSpec(a_datsetDats->get_spec1(), 0);
	}
      else
	check_datsetSpec(a_datsetDats->get_spec1(), log);
    }
  if (a_datsetDats->get_spec2())
    {
      adjustLevels(&datsetDatsAtts_spec2, "datsetDats spec2");
      if (log && !findString("spec2", datsetDatsAtts))
	{
	  warnAtt("spec2", "datsetDats", a_datsetDats);
	  check_datsetSpec(a_datsetDats->get_spec2(), 0);
	}
      else
	check_datsetSpec(a_datsetDats->get_spec2(), log);
    }
  if (a_datsetDats->get_spec3())
    {
      adjustLevels(&datsetDatsAtts_spec3, "datsetDats spec3");
      if (log && !findString("spec3", datsetDatsAtts))
	{
	  warnAtt("spec3", "datsetDats", a_datsetDats);
	  check_datsetSpec(a_datsetDats->get_spec3(), 0);
	}
      else
	check_datsetSpec(a_datsetDats->get_spec3(), log);
    }
}

/********************************************************************/

void check_datsetDrf(
 datsetDrf * a_datsetDrf,
 int log)
{
  if (a_datsetDrf->get_taLabel())
    {
      adjustLevels(&datsetDrfAtts_a_taLabel, "datsetDrf a_taLabel");
      if (log && !findString("a_taLabel", datsetDrfAtts))
	{
	  warnAtt("a_taLabel", "datsetDrf", a_datsetDrf);
	  check_taLabel(a_datsetDrf->get_taLabel(), 0);
	}
      else
	check_taLabel(a_datsetDrf->get_taLabel(), log);
    }
  if (a_datsetDrf->get_tier())
    {
      adjustLevels(&datsetDrfAtts_a_tier, "datsetDrf a_tier");
      if (log && !findString("a_tier", datsetDrfAtts))
	{
	  warnAtt("a_tier", "datsetDrf", a_datsetDrf);
	  check_tier(a_datsetDrf->get_tier(), 0);
	}
      else
	check_tier(a_datsetDrf->get_tier(), log);
    }
  if (a_datsetDrf->get_dir1())
    {
      adjustLevels(&datsetDrfAtts_dir1, "datsetDrf dir1");
      if (log && !findString("dir1", datsetDrfAtts))
	{
	  warnAtt("dir1", "datsetDrf", a_datsetDrf);
	  check_dir(a_datsetDrf->get_dir1(), 0);
	}
      else
	check_dir(a_datsetDrf->get_dir1(), log);
    }
  if (a_datsetDrf->get_dir2())
    {
      adjustLevels(&datsetDrfAtts_dir2, "datsetDrf dir2");
      if (log && !findString("dir2", datsetDrfAtts))
	{
	  warnAtt("dir2", "datsetDrf", a_datsetDrf);
	  check_dir(a_datsetDrf->get_dir2(), 0);
	}
      else
	check_dir(a_datsetDrf->get_dir2(), log);
    }
}

/********************************************************************/

void check_datsetMatrix(
 datsetMatrix * a_datsetMatrix,
 int log)
{
  if (a_datsetMatrix->get_matrix())
    {
      adjustLevels(&datsetMatrixAtts_a_matrix, "datsetMatrix a_matrix");
      if (log && !findString("a_matrix", datsetMatrixAtts))
	{
	  warnAtt("a_matrix", "datsetMatrix", a_datsetMatrix);
	  check_matrix(a_datsetMatrix->get_matrix(), 0);
	}
      else
	check_matrix(a_datsetMatrix->get_matrix(), log);
    }
}

/********************************************************************/

void check_datsetMinor(
 datsetMinor * a_datsetMinor,
 int log)
{
  if (isA(a_datsetMinor, datsetMcs))
    {
      adjustLevels(&datsetMinorSubs_datsetMcs, "datsetMcs");
      if (log && !findString("datsetMcs", datsetMinorSubs))
	{
	  warnSub("datsetMcs", "datsetMinor", a_datsetMinor);
	}
      return;
    }
  if (isA(a_datsetMinor, datsetDats))
    {
      adjustLevels(&datsetMinorSubs_datsetDats, "datsetDats");
      if (log && !findString("datsetDats", datsetMinorSubs))
	{
	  warnSub("datsetDats", "datsetMinor", a_datsetMinor);
	  check_datsetDats(dynamic_cast<datsetDats *>(a_datsetMinor), 0);
	}
      else
	check_datsetDats(dynamic_cast<datsetDats *>(a_datsetMinor), log);
      return;
    }
  if (isA(a_datsetMinor, datsetMatrix))
    {
      adjustLevels(&datsetMinorSubs_datsetMatrix, "datsetMatrix");
      if (log && !findString("datsetMatrix", datsetMinorSubs))
	{
	  warnSub("datsetMatrix", "datsetMinor", a_datsetMinor);
	  check_datsetMatrix(
	    dynamic_cast<datsetMatrix *>(a_datsetMinor), 0);
	}
      else
	check_datsetMatrix(
	  dynamic_cast<datsetMatrix *>(a_datsetMinor), log);
      return;
    }
  if (isA(a_datsetMinor, datsetDrf))
    {
      adjustLevels(&datsetMinorSubs_datsetDrf, "datsetDrf");
      if (log && !findString("datsetDrf", datsetMinorSubs))
	{
	  warnSub("datsetDrf", "datsetMinor", a_datsetMinor);
	  check_datsetDrf(dynamic_cast<datsetDrf *>(a_datsetMinor), 0);
	}
      else
	check_datsetDrf(dynamic_cast<datsetDrf *>(a_datsetMinor), log);
      return;
    }
}

/********************************************************************/

void check_datsetSpec(
 datsetSpec * a_datsetSpec,
 int log)
{
  if (isA(a_datsetSpec, datsetSpecNoDir))
    {
      adjustLevels(&datsetSpecSubs_datsetSpecNoDir, "datsetSpecNoDir");
      if (log && !findString("datsetSpecNoDir", datsetSpecSubs))
	{
	  warnSub("datsetSpecNoDir", "datsetSpec", a_datsetSpec);
	  check_datsetSpecNoDir(
	    dynamic_cast<datsetSpecNoDir *>(a_datsetSpec), 0);
	}
      else
	check_datsetSpecNoDir(
	  dynamic_cast<datsetSpecNoDir *>(a_datsetSpec), log);
      return;
    }
  if (isA(a_datsetSpec, datsetSpecDir))
    {
      adjustLevels(&datsetSpecSubs_datsetSpecDir, "datsetSpecDir");
      if (log && !findString("datsetSpecDir", datsetSpecSubs))
	{
	  warnSub("datsetSpecDir", "datsetSpec", a_datsetSpec);
	  check_datsetSpecDir(
	    dynamic_cast<datsetSpecDir *>(a_datsetSpec), 0);
	}
      else
	check_datsetSpecDir(
	  dynamic_cast<datsetSpecDir *>(a_datsetSpec), log);
      return;
    }
}

/********************************************************************/

void check_datsetSpecDir(
 datsetSpecDir * a_datsetSpecDir,
 int log)
{
  if (a_datsetSpecDir->get_datLabel())
    {
      adjustLevels(&datsetSpecDirAtts_a_datLabel, "datsetSpecDir a_datLabel");
      if (log && !findString("a_datLabel", datsetSpecDirAtts))
	{
	  warnAtt("a_datLabel", "datsetSpecDir", a_datsetSpecDir);
	  check_datLabel(a_datsetSpecDir->get_datLabel(), 0);
	}
      else
	check_datLabel(a_datsetSpecDir->get_datLabel(), log);
    }
  if (a_datsetSpecDir->get_dir())
    {
      adjustLevels(&datsetSpecDirAtts_a_dir, "datsetSpecDir a_dir");
      if (log && !findString("a_dir", datsetSpecDirAtts))
	{
	  warnAtt("a_dir", "datsetSpecDir", a_datsetSpecDir);
	  check_dir(a_datsetSpecDir->get_dir(), 0);
	}
      else
	check_dir(a_datsetSpecDir->get_dir(), log);
    }
  if (a_datsetSpecDir->get_orig1())
    {
      adjustLevels(&datsetSpecDirAtts_orig1, "datsetSpecDir orig1");
      if (log && !findString("orig1", datsetSpecDirAtts))
	{
	  warnAtt("orig1", "datsetSpecDir", a_datsetSpecDir);
	  check_orig(a_datsetSpecDir->get_orig1(), 0);
	}
      else
	check_orig(a_datsetSpecDir->get_orig1(), log);
    }
  if (a_datsetSpecDir->get_orig2())
    {
      adjustLevels(&datsetSpecDirAtts_orig2, "datsetSpecDir orig2");
      if (log && !findString("orig2", datsetSpecDirAtts))
	{
	  warnAtt("orig2", "datsetSpecDir", a_datsetSpecDir);
	  check_orig(a_datsetSpecDir->get_orig2(), 0);
	}
      else
	check_orig(a_datsetSpecDir->get_orig2(), log);
    }
  if (a_datsetSpecDir->get_orig3())
    {
      adjustLevels(&datsetSpecDirAtts_orig3, "datsetSpecDir orig3");
      if (log && !findString("orig3", datsetSpecDirAtts))
	{
	  warnAtt("orig3", "datsetSpecDir", a_datsetSpecDir);
	  check_orig(a_datsetSpecDir->get_orig3(), 0);
	}
      else
	check_orig(a_datsetSpecDir->get_orig3(), log);
    }
}

/********************************************************************/

void check_datsetSpecNoDir(
 datsetSpecNoDir * a_datsetSpecNoDir,
 int log)
{
  if (a_datsetSpecNoDir->get_datLabel())
    {
      adjustLevels(&datsetSpecNoDirAtts_a_datLabel,
		   "datsetSpecNoDir a_datLabel");
      if (log && !findString("a_datLabel", datsetSpecNoDirAtts))
	{
	  warnAtt("a_datLabel", "datsetSpecNoDir", a_datsetSpecNoDir);
	  check_datLabel(a_datsetSpecNoDir->get_datLabel(), 0);
	}
      else
	check_datLabel(a_datsetSpecNoDir->get_datLabel(), log);
    }
  if (a_datsetSpecNoDir->get_orig1())
    {
      adjustLevels(&datsetSpecNoDirAtts_orig1, "datsetSpecNoDir orig1");
      if (log && !findString("orig1", datsetSpecNoDirAtts))
	{
	  warnAtt("orig1", "datsetSpecNoDir", a_datsetSpecNoDir);
	  check_orig(a_datsetSpecNoDir->get_orig1(), 0);
	}
      else
	check_orig(a_datsetSpecNoDir->get_orig1(), log);
    }
  if (a_datsetSpecNoDir->get_orig2())
    {
      adjustLevels(&datsetSpecNoDirAtts_orig2, "datsetSpecNoDir orig2");
      if (log && !findString("orig2", datsetSpecNoDirAtts))
	{
	  warnAtt("orig2", "datsetSpecNoDir", a_datsetSpecNoDir);
	  check_orig(a_datsetSpecNoDir->get_orig2(), 0);
	}
      else
	check_orig(a_datsetSpecNoDir->get_orig2(), log);
    }
  if (a_datsetSpecNoDir->get_orig3())
    {
      adjustLevels(&datsetSpecNoDirAtts_orig3, "datsetSpecNoDir orig3");
      if (log && !findString("orig3", datsetSpecNoDirAtts))
	{
	  warnAtt("orig3", "datsetSpecNoDir", a_datsetSpecNoDir);
	  check_orig(a_datsetSpecNoDir->get_orig3(), 0);
	}
      else
	check_orig(a_datsetSpecNoDir->get_orig3(), log);
    }
}

/********************************************************************/

void check_datsetStm(
 datsetStm * a_datsetStm,
 int log)
{
  if (a_datsetStm->get_dLabel())
    {
      adjustLevels(&datsetStmAtts_a_dLabel, "datsetStm a_dLabel");
      if (log && !findString("a_dLabel", datsetStmAtts))
	{
	  warnAtt("a_dLabel", "datsetStm", a_datsetStm);
	  check_dLabel(a_datsetStm->get_dLabel(), 0);
	}
      else
	check_dLabel(a_datsetStm->get_dLabel(), log);
    }
  if (a_datsetStm->get_datsetMinor())
    {
      adjustLevels(&datsetStmAtts_a_datsetMinor, "datsetStm a_datsetMinor");
      if (log && !findString("a_datsetMinor", datsetStmAtts))
	{
	  warnAtt("a_datsetMinor", "datsetStm", a_datsetStm);
	  check_datsetMinor(a_datsetStm->get_datsetMinor(), 0);
	}
      else
	check_datsetMinor(a_datsetStm->get_datsetMinor(), log);
    }
}

/********************************************************************/

void check_dattrgLabel(
 dattrgLabel * a_dattrgLabel,
 int log)
{
  if (a_dattrgLabel->get_labelName())
    {
      adjustLevels(&dattrgLabelAtts_a_labelName, "dattrgLabel a_labelName");
      if (log && !findString("a_labelName", dattrgLabelAtts))
	{
	  warnAtt("a_labelName", "dattrgLabel", a_dattrgLabel);
	  check_labelName(a_dattrgLabel->get_labelName(), 0);
	}
      else
	check_labelName(a_dattrgLabel->get_labelName(), log);
    }
}

/********************************************************************/

void check_dattrgMinor(
 dattrgMinor * a_dattrgMinor,
 int log)
{
  if (a_dattrgMinor->get_featureList())
    {
      std::list<featureLabel *> * theList;
      std::list<featureLabel *>::iterator iter;
      theList = a_dattrgMinor->get_featureList();
      adjustLevels(&dattrgMinorAtts_a_featureList,
		   "dattrgMinor a_featureList");
      if (log && !findString("a_featureList", dattrgMinorAtts))
	{
	  warnAtt("a_featureList", "dattrgMinor", a_dattrgMinor);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_featureLabel(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_featureLabel(*iter, log);
	}
    }
  if (a_dattrgMinor->get_dattrgLabel())
    {
      adjustLevels(&dattrgMinorAtts_a_dattrgLabel,
		   "dattrgMinor a_dattrgLabel");
      if (log && !findString("a_dattrgLabel", dattrgMinorAtts))
	{
	  warnAtt("a_dattrgLabel", "dattrgMinor", a_dattrgMinor);
	  check_dattrgLabel(a_dattrgMinor->get_dattrgLabel(), 0);
	}
      else
	check_dattrgLabel(a_dattrgMinor->get_dattrgLabel(), log);
    }
}

/********************************************************************/

void check_dattrgdefStm(
 dattrgdefStm * a_dattrgdefStm,
 int log)
{
  if (a_dattrgdefStm->get_dattrgMinor())
    {
      adjustLevels(&dattrgdefStmAtts_a_dattrgMinor,
		   "dattrgdefStm a_dattrgMinor");
      if (log && !findString("a_dattrgMinor", dattrgdefStmAtts))
	{
	  warnAtt("a_dattrgMinor", "dattrgdefStm", a_dattrgdefStm);
	  check_dattrgMinor(a_dattrgdefStm->get_dattrgMinor(), 0);
	}
      else
	check_dattrgMinor(a_dattrgdefStm->get_dattrgMinor(), log);
    }
}

/********************************************************************/

void check_datumLabel(
 datumLabel * a_datumLabel,
 int log)
{
  if (isA(a_datumLabel, dLabel))
    {
      adjustLevels(&datumLabelSubs_dLabel, "dLabel");
      if (log && !findString("dLabel", datumLabelSubs))
	{
	  warnSub("dLabel", "datumLabel", a_datumLabel);
	  check_dLabel(dynamic_cast<dLabel *>(a_datumLabel), 0);
	}
      else
	check_dLabel(dynamic_cast<dLabel *>(a_datumLabel), log);
      return;
    }
  if (isA(a_datumLabel, daLabel))
    {
      adjustLevels(&datumLabelSubs_daLabel, "daLabel");
      if (log && !findString("daLabel", datumLabelSubs))
	{
	  warnSub("daLabel", "datumLabel", a_datumLabel);
	  check_daLabel(dynamic_cast<daLabel *>(a_datumLabel), 0);
	}
      else
	check_daLabel(dynamic_cast<daLabel *>(a_datumLabel), log);
      return;
    }
}

/********************************************************************/

void check_datumLabel1(
 datumLabel1 * a_datumLabel1,
 int log)
{
  if (isA(a_datumLabel1, dLabel))
    {
      adjustLevels(&datumLabel1Subs_dLabel, "dLabel");
      if (log && !findString("dLabel", datumLabel1Subs))
	{
	  warnSub("dLabel", "datumLabel1", a_datumLabel1);
	  check_dLabel(dynamic_cast<dLabel *>(a_datumLabel1), 0);
	}
      else
	check_dLabel(dynamic_cast<dLabel *>(a_datumLabel1), log);
      return;
    }
  if (isA(a_datumLabel1, daLabel))
    {
      adjustLevels(&datumLabel1Subs_daLabel, "daLabel");
      if (log && !findString("daLabel", datumLabel1Subs))
	{
	  warnSub("daLabel", "datumLabel1", a_datumLabel1);
	  check_daLabel(dynamic_cast<daLabel *>(a_datumLabel1), 0);
	}
      else
	check_daLabel(dynamic_cast<daLabel *>(a_datumLabel1), log);
      return;
    }
}

/********************************************************************/

void check_datumLabel2(
 datumLabel2 * a_datumLabel2,
 int log)
{
  if (isA(a_datumLabel2, dLabel))
    {
      adjustLevels(&datumLabel2Subs_dLabel, "dLabel");
      if (log && !findString("dLabel", datumLabel2Subs))
	{
	  warnSub("dLabel", "datumLabel2", a_datumLabel2);
	  check_dLabel(dynamic_cast<dLabel *>(a_datumLabel2), 0);
	}
      else
	check_dLabel(dynamic_cast<dLabel *>(a_datumLabel2), log);
      return;
    }
  if (isA(a_datumLabel2, daLabel))
    {
      adjustLevels(&datumLabel2Subs_daLabel, "daLabel");
      if (log && !findString("daLabel", datumLabel2Subs))
	{
	  warnSub("daLabel", "datumLabel2", a_datumLabel2);
	  check_daLabel(dynamic_cast<daLabel *>(a_datumLabel2), 0);
	}
      else
	check_daLabel(dynamic_cast<daLabel *>(a_datumLabel2), log);
      return;
    }
}

/********************************************************************/

void check_declMinor(
 declMinor * a_declMinor,
 int log)
{
  if (a_declMinor->get_declScope())
    {
      adjustLevels(&declMinorAtts_a_declScope, "declMinor a_declScope");
      if (log && !findString("a_declScope", declMinorAtts))
	{
	  warnAtt("a_declScope", "declMinor", a_declMinor);
	  check_declScope(a_declMinor->get_declScope(), 0);
	}
      else
	check_declScope(a_declMinor->get_declScope(), log);
    }
  if (a_declMinor->get_declType())
    {
      adjustLevels(&declMinorAtts_a_declType, "declMinor a_declType");
      if (log && !findString("a_declType", declMinorAtts))
	{
	  warnAtt("a_declType", "declMinor", a_declMinor);
	  check_declType(a_declMinor->get_declType(), 0);
	}
      else
	check_declType(a_declMinor->get_declType(), log);
    }
  if (a_declMinor->get_declVarList())
    {
      std::list<declVar *> * theList;
      std::list<declVar *>::iterator iter;
      theList = a_declMinor->get_declVarList();
      adjustLevels(&declMinorAtts_a_declVarList, "declMinor a_declVarList");
      if (log && !findString("a_declVarList", declMinorAtts))
	{
	  warnAtt("a_declVarList", "declMinor", a_declMinor);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_declVar(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_declVar(*iter, log);
	}
    }
}

/********************************************************************/

void check_declScope(
 declScope * a_declScope,
 int log)
{
  if (isA(a_declScope, declScope_COMMON))
    {
      adjustLevels(&declScopeSubs_declScope_COMMON, "declScope_COMMON");
      if (log && !findString("declScope_COMMON", declScopeSubs))
	{
	  warnSub("declScope_COMMON", "declScope", a_declScope);
	}
      return;
    }
  if (isA(a_declScope, declScope_GLOBAL))
    {
      adjustLevels(&declScopeSubs_declScope_GLOBAL, "declScope_GLOBAL");
      if (log && !findString("declScope_GLOBAL", declScopeSubs))
	{
	  warnSub("declScope_GLOBAL", "declScope", a_declScope);
	}
      return;
    }
  if (isA(a_declScope, declScope_LOCAL))
    {
      adjustLevels(&declScopeSubs_declScope_LOCAL, "declScope_LOCAL");
      if (log && !findString("declScope_LOCAL", declScopeSubs))
	{
	  warnSub("declScope_LOCAL", "declScope", a_declScope);
	}
      return;
    }
}

/********************************************************************/

void check_declStm(
 declStm * a_declStm,
 int log)
{
  if (a_declStm->get_declMinor())
    {
      adjustLevels(&declStmAtts_a_declMinor, "declStm a_declMinor");
      if (log && !findString("a_declMinor", declStmAtts))
	{
	  warnAtt("a_declMinor", "declStm", a_declStm);
	  check_declMinor(a_declStm->get_declMinor(), 0);
	}
      else
	check_declMinor(a_declStm->get_declMinor(), log);
    }
}

/********************************************************************/

void check_declType(
 declType * a_declType,
 int log)
{
  if (isA(a_declType, declType_BOOL))
    {
      adjustLevels(&declTypeSubs_declType_BOOL, "declType_BOOL");
      if (log && !findString("declType_BOOL", declTypeSubs))
	{
	  warnSub("declType_BOOL", "declType", a_declType);
	}
      return;
    }
  if (isA(a_declType, declType_INTGR))
    {
      adjustLevels(&declTypeSubs_declType_INTGR, "declType_INTGR");
      if (log && !findString("declType_INTGR", declTypeSubs))
	{
	  warnSub("declType_INTGR", "declType", a_declType);
	}
      return;
    }
  if (isA(a_declType, declType_LONG))
    {
      adjustLevels(&declTypeSubs_declType_LONG, "declType_LONG");
      if (log && !findString("declType_LONG", declTypeSubs))
	{
	  warnSub("declType_LONG", "declType", a_declType);
	}
      return;
    }
  if (isA(a_declType, declType_REAL))
    {
      adjustLevels(&declTypeSubs_declType_REAL, "declType_REAL");
      if (log && !findString("declType_REAL", declTypeSubs))
	{
	  warnSub("declType_REAL", "declType", a_declType);
	}
      return;
    }
  if (isA(a_declType, declType_DOUBLE))
    {
      adjustLevels(&declTypeSubs_declType_DOUBLE, "declType_DOUBLE");
      if (log && !findString("declType_DOUBLE", declTypeSubs))
	{
	  warnSub("declType_DOUBLE", "declType", a_declType);
	}
      return;
    }
  if (isA(a_declType, declType_CHAR))
    {
      adjustLevels(&declTypeSubs_declType_CHAR, "declType_CHAR");
      if (log && !findString("declType_CHAR", declTypeSubs))
	{
	  warnSub("declType_CHAR", "declType", a_declType);
	  check_declType_CHAR(
	    dynamic_cast<declType_CHAR *>(a_declType), 0);
	}
      else
	check_declType_CHAR(
	  dynamic_cast<declType_CHAR *>(a_declType), log);
      return;
    }
  if (isA(a_declType, declType_VECTOR))
    {
      adjustLevels(&declTypeSubs_declType_VECTOR, "declType_VECTOR");
      if (log && !findString("declType_VECTOR", declTypeSubs))
	{
	  warnSub("declType_VECTOR", "declType", a_declType);
	}
      return;
    }
}

/********************************************************************/

void check_declType_CHAR(
 declType_CHAR * a_declType_CHAR,
 int log)
{
  if (a_declType_CHAR->get_size())
    {
      adjustLevels(&declType_CHARAtts_size, "declType_CHAR size");
      if (log && !findString("size", declType_CHARAtts))
	{
	  warnAtt("size", "declType_CHAR", a_declType_CHAR);
	  check_intVal(a_declType_CHAR->get_size(), 0);
	}
      else
	check_intVal(a_declType_CHAR->get_size(), log);
    }
}

/********************************************************************/

void check_declVar(
 declVar * a_declVar,
 int log)
{
  if (a_declVar->get_string())
    {
      adjustLevels(&declVarAtts_a_string, "declVar a_string");
      if (log && !findString("a_string", declVarAtts))
	{
	  warnAtt("a_string", "declVar", a_declVar);
	}
    }
  if (a_declVar->get_declIndicesList())
    {
      std::list<intConst *> * theList;
      std::list<intConst *>::iterator iter;
      theList = a_declVar->get_declIndicesList();
      adjustLevels(&declVarAtts_a_declIndicesList,
		   "declVar a_declIndicesList");
      if (log && !findString("a_declIndicesList", declVarAtts))
	{
	  warnAtt("a_declIndicesList", "declVar", a_declVar);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_intConst(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_intConst(*iter, log);
	}
    }
}

/********************************************************************/

void check_decplAll(
 decplAll * a_decplAll,
 int log)
{
  if (a_decplAll->get_decplNdigits())
    {
      adjustLevels(&decplAllAtts_a_decplNdigits, "decplAll a_decplNdigits");
      if (log && !findString("a_decplNdigits", decplAllAtts))
	{
	  warnAtt("a_decplNdigits", "decplAll", a_decplAll);
	  check_decplNdigits(a_decplAll->get_decplNdigits(), 0);
	}
      else
	check_decplNdigits(a_decplAll->get_decplNdigits(), log);
    }
}

/********************************************************************/

void check_decplMinor(
 decplMinor * a_decplMinor,
 int log)
{
  if (isA(a_decplMinor, decplMinor_decplAll))
    {
      adjustLevels(&decplMinorSubs_decplMinor_decplAll, "decplMinor_decplAll");
      if (log && !findString("decplMinor_decplAll", decplMinorSubs))
	{
	  warnSub("decplMinor_decplAll", "decplMinor", a_decplMinor);
	  check_decplMinor_decplAll(
	    dynamic_cast<decplMinor_decplAll *>(a_decplMinor), 0);
	}
      else
	check_decplMinor_decplAll(
	  dynamic_cast<decplMinor_decplAll *>(a_decplMinor), log);
      return;
    }
  if (isA(a_decplMinor, decplMinor_decplList))
    {
      adjustLevels(&decplMinorSubs_decplMinor_decplList,
		   "decplMinor_decplList");
      if (log && !findString("decplMinor_decplList", decplMinorSubs))
	{
	  warnSub("decplMinor_decplList", "decplMinor", a_decplMinor);
	  check_decplMinor_decplList(
	    dynamic_cast<decplMinor_decplList *>(a_decplMinor), 0);
	}
      else
	check_decplMinor_decplList(
	  dynamic_cast<decplMinor_decplList *>(a_decplMinor), log);
      return;
    }
}

/********************************************************************/

void check_decplMinor_decplAll(
 decplMinor_decplAll * a_decplMinor_decplAll,
 int log)
{
  if (a_decplMinor_decplAll->get_decplAll())
    {
      adjustLevels(&decplMinor_decplAllAtts_a_decplAll,
		   "decplMinor_decplAll a_decplAll");
      if (log && !findString("a_decplAll", decplMinor_decplAllAtts))
	{
	  warnAtt("a_decplAll", "decplMinor_decplAll", a_decplMinor_decplAll);
	  check_decplAll(a_decplMinor_decplAll->get_decplAll(), 0);
	}
      else
	check_decplAll(a_decplMinor_decplAll->get_decplAll(), log);
    }
}

/********************************************************************/

void check_decplMinor_decplList(
 decplMinor_decplList * a_decplMinor_decplList,
 int log)
{
  if (a_decplMinor_decplList->get_decplList())
    {
      std::list<decplSelection *> * theList;
      std::list<decplSelection *>::iterator iter;
      theList = a_decplMinor_decplList->get_decplList();
      adjustLevels(&decplMinor_decplListAtts_a_decplList,
		   "decplMinor_decplList a_decplList");
      if (log && !findString("a_decplList", decplMinor_decplListAtts))
	{
	  warnAtt("a_decplList", "decplMinor_decplList",
		  a_decplMinor_decplList);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_decplSelection(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_decplSelection(*iter, log);
	}
    }
}

/********************************************************************/

void check_decplNdigits(
 decplNdigits * a_decplNdigits,
 int log)
{
  if (isA(a_decplNdigits, decplNdigits_DEFALT))
    {
      adjustLevels(&decplNdigitsSubs_decplNdigits_DEFALT,
		   "decplNdigits_DEFALT");
      if (log && !findString("decplNdigits_DEFALT", decplNdigitsSubs))
	{
	  warnSub("decplNdigits_DEFALT", "decplNdigits", a_decplNdigits);
	}
      return;
    }
  if (isA(a_decplNdigits, decplNdigits_intVal))
    {
      adjustLevels(&decplNdigitsSubs_decplNdigits_intVal,
		   "decplNdigits_intVal");
      if (log && !findString("decplNdigits_intVal", decplNdigitsSubs))
	{
	  warnSub("decplNdigits_intVal", "decplNdigits", a_decplNdigits);
	  check_decplNdigits_intVal(
	    dynamic_cast<decplNdigits_intVal *>(a_decplNdigits), 0);
	}
      else
	check_decplNdigits_intVal(
	  dynamic_cast<decplNdigits_intVal *>(a_decplNdigits), log);
      return;
    }
}

/********************************************************************/

void check_decplNdigits_intVal(
 decplNdigits_intVal * a_decplNdigits_intVal,
 int log)
{
  if (a_decplNdigits_intVal->get_decimal())
    {
      adjustLevels(&decplNdigits_intValAtts_decimal,
		   "decplNdigits_intVal decimal");
      if (log && !findString("decimal", decplNdigits_intValAtts))
	{
	  warnAtt("decimal", "decplNdigits_intVal", a_decplNdigits_intVal);
	  check_intVal(a_decplNdigits_intVal->get_decimal(), 0);
	}
      else
	check_intVal(a_decplNdigits_intVal->get_decimal(), log);
    }
}

/********************************************************************/

void check_decplSelection(
 decplSelection * a_decplSelection,
 int log)
{
  if (isA(a_decplSelection, decplSelection_ANGLE))
    {
      adjustLevels(&decplSelectionSubs_decplSelection_ANGLE,
		   "decplSelection_ANGLE");
      if (log && !findString("decplSelection_ANGLE", decplSelectionSubs))
	{
	  warnSub("decplSelection_ANGLE", "decplSelection", a_decplSelection);
	  check_decplSelection_ANGLE(
	    dynamic_cast<decplSelection_ANGLE *>(a_decplSelection), 0);
	}
      else
	check_decplSelection_ANGLE(
	  dynamic_cast<decplSelection_ANGLE *>(a_decplSelection), log);
      return;
    }
  if (isA(a_decplSelection, decplSelection_DIST))
    {
      adjustLevels(&decplSelectionSubs_decplSelection_DIST,
		   "decplSelection_DIST");
      if (log && !findString("decplSelection_DIST", decplSelectionSubs))
	{
	  warnSub("decplSelection_DIST", "decplSelection", a_decplSelection);
	  check_decplSelection_DIST(
	    dynamic_cast<decplSelection_DIST *>(a_decplSelection), 0);
	}
      else
	check_decplSelection_DIST(
	  dynamic_cast<decplSelection_DIST *>(a_decplSelection), log);
      return;
    }
  if (isA(a_decplSelection, decplSelection_HUMID))
    {
      adjustLevels(&decplSelectionSubs_decplSelection_HUMID,
		   "decplSelection_HUMID");
      if (log && !findString("decplSelection_HUMID", decplSelectionSubs))
	{
	  warnSub("decplSelection_HUMID", "decplSelection", a_decplSelection);
	  check_decplSelection_HUMID(
	    dynamic_cast<decplSelection_HUMID *>(a_decplSelection), 0);
	}
      else
	check_decplSelection_HUMID(
	  dynamic_cast<decplSelection_HUMID *>(a_decplSelection), log);
      return;
    }
  if (isA(a_decplSelection, decplSelection_DEV))
    {
      adjustLevels(&decplSelectionSubs_decplSelection_DEV,
		   "decplSelection_DEV");
      if (log && !findString("decplSelection_DEV", decplSelectionSubs))
	{
	  warnSub("decplSelection_DEV", "decplSelection", a_decplSelection);
	  check_decplSelection_DEV(
	    dynamic_cast<decplSelection_DEV *>(a_decplSelection), 0);
	}
      else
	check_decplSelection_DEV(
	  dynamic_cast<decplSelection_DEV *>(a_decplSelection), log);
      return;
    }
  if (isA(a_decplSelection, decplSelection_TEMP))
    {
      adjustLevels(&decplSelectionSubs_decplSelection_TEMP,
		   "decplSelection_TEMP");
      if (log && !findString("decplSelection_TEMP", decplSelectionSubs))
	{
	  warnSub("decplSelection_TEMP", "decplSelection", a_decplSelection);
	  check_decplSelection_TEMP(
	    dynamic_cast<decplSelection_TEMP *>(a_decplSelection), 0);
	}
      else
	check_decplSelection_TEMP(
	  dynamic_cast<decplSelection_TEMP *>(a_decplSelection), log);
      return;
    }
  if (isA(a_decplSelection, decplSelection_VEC))
    {
      adjustLevels(&decplSelectionSubs_decplSelection_VEC,
		   "decplSelection_VEC");
      if (log && !findString("decplSelection_VEC", decplSelectionSubs))
	{
	  warnSub("decplSelection_VEC", "decplSelection", a_decplSelection);
	  check_decplSelection_VEC(
	    dynamic_cast<decplSelection_VEC *>(a_decplSelection), 0);
	}
      else
	check_decplSelection_VEC(
	  dynamic_cast<decplSelection_VEC *>(a_decplSelection), log);
      return;
    }
}

/********************************************************************/

void check_decplSelection_ANGLE(
 decplSelection_ANGLE * a_decplSelection_ANGLE,
 int log)
{
  if (a_decplSelection_ANGLE->get_decplNdigits())
    {
      adjustLevels(&decplSelection_ANGLEAtts_a_decplNdigits,
		   "decplSelection_ANGLE a_decplNdigits");
      if (log && !findString("a_decplNdigits", decplSelection_ANGLEAtts))
	{
	  warnAtt("a_decplNdigits", "decplSelection_ANGLE",
		  a_decplSelection_ANGLE);
	  check_decplNdigits(a_decplSelection_ANGLE->get_decplNdigits(), 0);
	}
      else
	check_decplNdigits(a_decplSelection_ANGLE->get_decplNdigits(), log);
    }
}

/********************************************************************/

void check_decplSelection_DEV(
 decplSelection_DEV * a_decplSelection_DEV,
 int log)
{
  if (a_decplSelection_DEV->get_decplNdigits())
    {
      adjustLevels(&decplSelection_DEVAtts_a_decplNdigits,
		   "decplSelection_DEV a_decplNdigits");
      if (log && !findString("a_decplNdigits", decplSelection_DEVAtts))
	{
	  warnAtt("a_decplNdigits", "decplSelection_DEV",
		  a_decplSelection_DEV);
	  check_decplNdigits(a_decplSelection_DEV->get_decplNdigits(), 0);
	}
      else
	check_decplNdigits(a_decplSelection_DEV->get_decplNdigits(), log);
    }
}

/********************************************************************/

void check_decplSelection_DIST(
 decplSelection_DIST * a_decplSelection_DIST,
 int log)
{
  if (a_decplSelection_DIST->get_decplNdigits())
    {
      adjustLevels(&decplSelection_DISTAtts_a_decplNdigits,
		   "decplSelection_DIST a_decplNdigits");
      if (log && !findString("a_decplNdigits", decplSelection_DISTAtts))
	{
	  warnAtt("a_decplNdigits", "decplSelection_DIST",
		  a_decplSelection_DIST);
	  check_decplNdigits(a_decplSelection_DIST->get_decplNdigits(), 0);
	}
      else
	check_decplNdigits(a_decplSelection_DIST->get_decplNdigits(), log);
    }
}

/********************************************************************/

void check_decplSelection_HUMID(
 decplSelection_HUMID * a_decplSelection_HUMID,
 int log)
{
  if (a_decplSelection_HUMID->get_decplNdigits())
    {
      adjustLevels(&decplSelection_HUMIDAtts_a_decplNdigits,
		   "decplSelection_HUMID a_decplNdigits");
      if (log && !findString("a_decplNdigits", decplSelection_HUMIDAtts))
	{
	  warnAtt("a_decplNdigits", "decplSelection_HUMID",
		  a_decplSelection_HUMID);
	  check_decplNdigits(a_decplSelection_HUMID->get_decplNdigits(), 0);
	}
      else
	check_decplNdigits(a_decplSelection_HUMID->get_decplNdigits(), log);
    }
}

/********************************************************************/

void check_decplSelection_TEMP(
 decplSelection_TEMP * a_decplSelection_TEMP,
 int log)
{
  if (a_decplSelection_TEMP->get_decplNdigits())
    {
      adjustLevels(&decplSelection_TEMPAtts_a_decplNdigits,
		   "decplSelection_TEMP a_decplNdigits");
      if (log && !findString("a_decplNdigits", decplSelection_TEMPAtts))
	{
	  warnAtt("a_decplNdigits", "decplSelection_TEMP",
		  a_decplSelection_TEMP);
	  check_decplNdigits(a_decplSelection_TEMP->get_decplNdigits(), 0);
	}
      else
	check_decplNdigits(a_decplSelection_TEMP->get_decplNdigits(), log);
    }
}

/********************************************************************/

void check_decplSelection_VEC(
 decplSelection_VEC * a_decplSelection_VEC,
 int log)
{
  if (a_decplSelection_VEC->get_decplNdigits())
    {
      adjustLevels(&decplSelection_VECAtts_a_decplNdigits,
		   "decplSelection_VEC a_decplNdigits");
      if (log && !findString("a_decplNdigits", decplSelection_VECAtts))
	{
	  warnAtt("a_decplNdigits", "decplSelection_VEC",
		  a_decplSelection_VEC);
	  check_decplNdigits(a_decplSelection_VEC->get_decplNdigits(), 0);
	}
      else
	check_decplNdigits(a_decplSelection_VEC->get_decplNdigits(), log);
    }
}

/********************************************************************/

void check_decplStm(
 decplStm * a_decplStm,
 int log)
{
  if (a_decplStm->get_decplMinor())
    {
      adjustLevels(&decplStmAtts_a_decplMinor, "decplStm a_decplMinor");
      if (log && !findString("a_decplMinor", decplStmAtts))
	{
	  warnAtt("a_decplMinor", "decplStm", a_decplStm);
	  check_decplMinor(a_decplStm->get_decplMinor(), 0);
	}
      else
	check_decplMinor(a_decplStm->get_decplMinor(), log);
    }
}

/********************************************************************/

void check_defaultCaseBlock(
 defaultCaseBlock * a_defaultCaseBlock,
 int log)
{
  if (a_defaultCaseBlock->get_dftcasStm())
    {
      adjustLevels(&defaultCaseBlockAtts_a_dftcasStm,
		   "defaultCaseBlock a_dftcasStm");
      if (log && !findString("a_dftcasStm", defaultCaseBlockAtts))
	{
	  warnAttBlock("dftcasStm", a_defaultCaseBlock->get_dftcasStm());
	}
    }
  if (a_defaultCaseBlock->get_dmisItemList())
    {
      std::list<dmisItem *> * theList;
      std::list<dmisItem *>::iterator iter;
      theList = a_defaultCaseBlock->get_dmisItemList();
      adjustLevels(&defaultCaseBlockAtts_a_dmisItemList,
		   "defaultCaseBlock a_dmisItemList");
      if (log && !findString("a_dmisItemList", defaultCaseBlockAtts))
	{
	  warnAttBlock("dmisItemList",
	    a_defaultCaseBlock->get_dmisItemList()->front());
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_dmisItem(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_dmisItem(*iter, log);
	}
    }
  if (a_defaultCaseBlock->get_endcasStm())
    {
      adjustLevels(&defaultCaseBlockAtts_a_endcasStm,
		   "defaultCaseBlock a_endcasStm");
      if (log && !findString("a_endcasStm", defaultCaseBlockAtts))
	{
	  warnAttBlock("endcasStm", a_defaultCaseBlock->get_endcasStm());
	}
    }
}

/********************************************************************/

void check_deleteAllSensors(
 deleteAllSensors * a_deleteAllSensors,
 int log)
{
  if (a_deleteAllSensors->get_saLabelList())
    {
      std::list<saLabel *> * theList;
      std::list<saLabel *>::iterator iter;
      theList = a_deleteAllSensors->get_saLabelList();
      adjustLevels(&deleteAllSensorsAtts_a_saLabelList,
		   "deleteAllSensors a_saLabelList");
      if (log && !findString("a_saLabelList", deleteAllSensorsAtts))
	{
	  warnAtt("a_saLabelList", "deleteAllSensors", a_deleteAllSensors);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_saLabel(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_saLabel(*iter, log);
	}
    }
  if (a_deleteAllSensors->get_didLabel())
    {
      adjustLevels(&deleteAllSensorsAtts_a_didLabel,
		   "deleteAllSensors a_didLabel");
      if (log && !findString("a_didLabel", deleteAllSensorsAtts))
	{
	  warnAtt("a_didLabel", "deleteAllSensors", a_deleteAllSensors);
	  check_didLabel(a_deleteAllSensors->get_didLabel(), 0);
	}
      else
	check_didLabel(a_deleteAllSensors->get_didLabel(), log);
    }
}

/********************************************************************/

void check_deleteDatum(
 deleteDatum * a_deleteDatum,
 int log)
{
  if (a_deleteDatum->get_datumLabel1())
    {
      adjustLevels(&deleteDatumAtts_a_datumLabel1,
		   "deleteDatum a_datumLabel1");
      if (log && !findString("a_datumLabel1", deleteDatumAtts))
	{
	  warnAtt("a_datumLabel1", "deleteDatum", a_deleteDatum);
	  check_datumLabel1(a_deleteDatum->get_datumLabel1(), 0);
	}
      else
	check_datumLabel1(a_deleteDatum->get_datumLabel1(), log);
    }
  if (a_deleteDatum->get_didLabel())
    {
      adjustLevels(&deleteDatumAtts_a_didLabel, "deleteDatum a_didLabel");
      if (log && !findString("a_didLabel", deleteDatumAtts))
	{
	  warnAtt("a_didLabel", "deleteDatum", a_deleteDatum);
	  check_didLabel(a_deleteDatum->get_didLabel(), 0);
	}
      else
	check_didLabel(a_deleteDatum->get_didLabel(), log);
    }
}

/********************************************************************/

void check_deleteFeature(
 deleteFeature * a_deleteFeature,
 int log)
{
  if (a_deleteFeature->get_faLabel())
    {
      adjustLevels(&deleteFeatureAtts_a_faLabel, "deleteFeature a_faLabel");
      if (log && !findString("a_faLabel", deleteFeatureAtts))
	{
	  warnAtt("a_faLabel", "deleteFeature", a_deleteFeature);
	  check_faLabel(a_deleteFeature->get_faLabel(), 0);
	}
      else
	check_faLabel(a_deleteFeature->get_faLabel(), log);
    }
  if (a_deleteFeature->get_didLabel())
    {
      adjustLevels(&deleteFeatureAtts_a_didLabel, "deleteFeature a_didLabel");
      if (log && !findString("a_didLabel", deleteFeatureAtts))
	{
	  warnAtt("a_didLabel", "deleteFeature", a_deleteFeature);
	  check_didLabel(a_deleteFeature->get_didLabel(), 0);
	}
      else
	check_didLabel(a_deleteFeature->get_didLabel(), log);
    }
}

/********************************************************************/

void check_deleteMinor(
 deleteMinor * a_deleteMinor,
 int log)
{
  if (isA(a_deleteMinor, deleteDatum))
    {
      adjustLevels(&deleteMinorSubs_deleteDatum, "deleteDatum");
      if (log && !findString("deleteDatum", deleteMinorSubs))
	{
	  warnSub("deleteDatum", "deleteMinor", a_deleteMinor);
	  check_deleteDatum(dynamic_cast<deleteDatum *>(a_deleteMinor), 0);
	}
      else
	check_deleteDatum(dynamic_cast<deleteDatum *>(a_deleteMinor), log);
      return;
    }
  if (isA(a_deleteMinor, deleteSensor))
    {
      adjustLevels(&deleteMinorSubs_deleteSensor, "deleteSensor");
      if (log && !findString("deleteSensor", deleteMinorSubs))
	{
	  warnSub("deleteSensor", "deleteMinor", a_deleteMinor);
	  check_deleteSensor(
	    dynamic_cast<deleteSensor *>(a_deleteMinor), 0);
	}
      else
	check_deleteSensor(
	  dynamic_cast<deleteSensor *>(a_deleteMinor), log);
      return;
    }
  if (isA(a_deleteMinor, deleteFeature))
    {
      adjustLevels(&deleteMinorSubs_deleteFeature, "deleteFeature");
      if (log && !findString("deleteFeature", deleteMinorSubs))
	{
	  warnSub("deleteFeature", "deleteMinor", a_deleteMinor);
	  check_deleteFeature(
	    dynamic_cast<deleteFeature *>(a_deleteMinor), 0);
	}
      else
	check_deleteFeature(
	  dynamic_cast<deleteFeature *>(a_deleteMinor), log);
      return;
    }
  if (isA(a_deleteMinor, deleteRotaryTable))
    {
      adjustLevels(&deleteMinorSubs_deleteRotaryTable, "deleteRotaryTable");
      if (log && !findString("deleteRotaryTable", deleteMinorSubs))
	{
	  warnSub("deleteRotaryTable", "deleteMinor", a_deleteMinor);
	  check_deleteRotaryTable(
	    dynamic_cast<deleteRotaryTable *>(a_deleteMinor), 0);
	}
      else
	check_deleteRotaryTable(
	  dynamic_cast<deleteRotaryTable *>(a_deleteMinor), log);
      return;
    }
  if (isA(a_deleteMinor, deleteAllSensors))
    {
      adjustLevels(&deleteMinorSubs_deleteAllSensors, "deleteAllSensors");
      if (log && !findString("deleteAllSensors", deleteMinorSubs))
	{
	  warnSub("deleteAllSensors", "deleteMinor", a_deleteMinor);
	  check_deleteAllSensors(
	    dynamic_cast<deleteAllSensors *>(a_deleteMinor), 0);
	}
      else
	check_deleteAllSensors(
	  dynamic_cast<deleteAllSensors *>(a_deleteMinor), log);
      return;
    }
}

/********************************************************************/

void check_deleteRotaryTable(
 deleteRotaryTable * a_deleteRotaryTable,
 int log)
{
  if (a_deleteRotaryTable->get_rtLabel())
    {
      adjustLevels(&deleteRotaryTableAtts_a_rtLabel,
		   "deleteRotaryTable a_rtLabel");
      if (log && !findString("a_rtLabel", deleteRotaryTableAtts))
	{
	  warnAtt("a_rtLabel", "deleteRotaryTable", a_deleteRotaryTable);
	  check_rtLabel(a_deleteRotaryTable->get_rtLabel(), 0);
	}
      else
	check_rtLabel(a_deleteRotaryTable->get_rtLabel(), log);
    }
  if (a_deleteRotaryTable->get_didLabel())
    {
      adjustLevels(&deleteRotaryTableAtts_a_didLabel,
		   "deleteRotaryTable a_didLabel");
      if (log && !findString("a_didLabel", deleteRotaryTableAtts))
	{
	  warnAtt("a_didLabel", "deleteRotaryTable", a_deleteRotaryTable);
	  check_didLabel(a_deleteRotaryTable->get_didLabel(), 0);
	}
      else
	check_didLabel(a_deleteRotaryTable->get_didLabel(), log);
    }
}

/********************************************************************/

void check_deleteSensor(
 deleteSensor * a_deleteSensor,
 int log)
{
  if (a_deleteSensor->get_sensorLabel1())
    {
      adjustLevels(&deleteSensorAtts_a_sensorLabel1,
		   "deleteSensor a_sensorLabel1");
      if (log && !findString("a_sensorLabel1", deleteSensorAtts))
	{
	  warnAtt("a_sensorLabel1", "deleteSensor", a_deleteSensor);
	  check_sensorLabel1(a_deleteSensor->get_sensorLabel1(), 0);
	}
      else
	check_sensorLabel1(a_deleteSensor->get_sensorLabel1(), log);
    }
  if (a_deleteSensor->get_didLabel())
    {
      adjustLevels(&deleteSensorAtts_a_didLabel, "deleteSensor a_didLabel");
      if (log && !findString("a_didLabel", deleteSensorAtts))
	{
	  warnAtt("a_didLabel", "deleteSensor", a_deleteSensor);
	  check_didLabel(a_deleteSensor->get_didLabel(), 0);
	}
      else
	check_didLabel(a_deleteSensor->get_didLabel(), log);
    }
}

/********************************************************************/

void check_deleteStm(
 deleteStm * a_deleteStm,
 int log)
{
  if (a_deleteStm->get_deleteMinor())
    {
      adjustLevels(&deleteStmAtts_a_deleteMinor, "deleteStm a_deleteMinor");
      if (log && !findString("a_deleteMinor", deleteStmAtts))
	{
	  warnAtt("a_deleteMinor", "deleteStm", a_deleteStm);
	  check_deleteMinor(a_deleteStm->get_deleteMinor(), 0);
	}
      else
	check_deleteMinor(a_deleteStm->get_deleteMinor(), log);
    }
}

/********************************************************************/

void check_device(
 device * a_device,
 int log)
{
  if (isA(a_device, device_PRINT))
    {
      adjustLevels(&deviceSubs_device_PRINT, "device_PRINT");
      if (log && !findString("device_PRINT", deviceSubs))
	{
	  warnSub("device_PRINT", "device", a_device);
	}
      return;
    }
  if (isA(a_device, device_TERM))
    {
      adjustLevels(&deviceSubs_device_TERM, "device_TERM");
      if (log && !findString("device_TERM", deviceSubs))
	{
	  warnSub("device_TERM", "device", a_device);
	}
      return;
    }
  if (isA(a_device, device_COMM))
    {
      adjustLevels(&deviceSubs_device_COMM, "device_COMM");
      if (log && !findString("device_COMM", deviceSubs))
	{
	  warnSub("device_COMM", "device", a_device);
	}
      return;
    }
  if (isA(a_device, device_STOR))
    {
      adjustLevels(&deviceSubs_device_STOR, "device_STOR");
      if (log && !findString("device_STOR", deviceSubs))
	{
	  warnSub("device_STOR", "device", a_device);
	}
      return;
    }
}

/********************************************************************/

void check_deviceMinor(
 deviceMinor * a_deviceMinor,
 int log)
{
  if (isA(a_deviceMinor, deviceMinor_device))
    {
      adjustLevels(&deviceMinorSubs_deviceMinor_device, "deviceMinor_device");
      if (log && !findString("deviceMinor_device", deviceMinorSubs))
	{
	  warnSub("deviceMinor_device", "deviceMinor", a_deviceMinor);
	  check_deviceMinor_device(
	    dynamic_cast<deviceMinor_device *>(a_deviceMinor), 0);
	}
      else
	check_deviceMinor_device(
	  dynamic_cast<deviceMinor_device *>(a_deviceMinor), log);
      return;
    }
  if (isA(a_deviceMinor, deviceMinor_INCR))
    {
      adjustLevels(&deviceMinorSubs_deviceMinor_INCR, "deviceMinor_INCR");
      if (log && !findString("deviceMinor_INCR", deviceMinorSubs))
	{
	  warnSub("deviceMinor_INCR", "deviceMinor", a_deviceMinor);
	  check_deviceMinor_INCR(
	    dynamic_cast<deviceMinor_INCR *>(a_deviceMinor), 0);
	}
      else
	check_deviceMinor_INCR(
	  dynamic_cast<deviceMinor_INCR *>(a_deviceMinor), log);
      return;
    }
}

/********************************************************************/

void check_deviceMinor_INCR(
 deviceMinor_INCR * a_deviceMinor_INCR,
 int log)
{
  if (a_deviceMinor_INCR->get_mask())
    {
      adjustLevels(&deviceMinor_INCRAtts_mask, "deviceMinor_INCR mask");
      if (log && !findString("mask", deviceMinor_INCRAtts))
	{
	  warnAtt("mask", "deviceMinor_INCR", a_deviceMinor_INCR);
	  check_stringVal(a_deviceMinor_INCR->get_mask(), 0);
	}
      else
	check_stringVal(a_deviceMinor_INCR->get_mask(), log);
    }
}

/********************************************************************/

void check_deviceMinor_device(
 deviceMinor_device * a_deviceMinor_device,
 int log)
{
  if (a_deviceMinor_device->get_device())
    {
      adjustLevels(&deviceMinor_deviceAtts_a_device,
		   "deviceMinor_device a_device");
      if (log && !findString("a_device", deviceMinor_deviceAtts))
	{
	  warnAtt("a_device", "deviceMinor_device", a_deviceMinor_device);
	  check_device(a_deviceMinor_device->get_device(), 0);
	}
      else
	check_device(a_deviceMinor_device->get_device(), log);
    }
  if (a_deviceMinor_device->get_name())
    {
      adjustLevels(&deviceMinor_deviceAtts_name, "deviceMinor_device name");
      if (log && !findString("name", deviceMinor_deviceAtts))
	{
	  warnAtt("name", "deviceMinor_device", a_deviceMinor_device);
	  check_stringVal(a_deviceMinor_device->get_name(), 0);
	}
      else
	check_stringVal(a_deviceMinor_device->get_name(), log);
    }
}

/********************************************************************/

void check_deviceStm(
 deviceStm * a_deviceStm,
 int log)
{
  if (a_deviceStm->get_didLabel())
    {
      adjustLevels(&deviceStmAtts_a_didLabel, "deviceStm a_didLabel");
      if (log && !findString("a_didLabel", deviceStmAtts))
	{
	  warnAtt("a_didLabel", "deviceStm", a_deviceStm);
	  check_didLabel(a_deviceStm->get_didLabel(), 0);
	}
      else
	check_didLabel(a_deviceStm->get_didLabel(), log);
    }
  if (a_deviceStm->get_deviceMinor())
    {
      adjustLevels(&deviceStmAtts_a_deviceMinor, "deviceStm a_deviceMinor");
      if (log && !findString("a_deviceMinor", deviceStmAtts))
	{
	  warnAtt("a_deviceMinor", "deviceStm", a_deviceStm);
	  check_deviceMinor(a_deviceStm->get_deviceMinor(), 0);
	}
      else
	check_deviceMinor(a_deviceStm->get_deviceMinor(), log);
    }
}

/********************************************************************/

void check_diLabel(
 diLabel * a_diLabel,
 int log)
{
  if (a_diLabel->get_labelName())
    {
      adjustLevels(&diLabelAtts_a_labelName, "diLabel a_labelName");
      if (log && !findString("a_labelName", diLabelAtts))
	{
	  warnAtt("a_labelName", "diLabel", a_diLabel);
	  check_labelName(a_diLabel->get_labelName(), 0);
	}
      else
	check_labelName(a_diLabel->get_labelName(), log);
    }
}

/********************************************************************/

void check_didLabel(
 didLabel * a_didLabel,
 int log)
{
  if (a_didLabel->get_labelName())
    {
      adjustLevels(&didLabelAtts_a_labelName, "didLabel a_labelName");
      if (log && !findString("a_labelName", didLabelAtts))
	{
	  warnAtt("a_labelName", "didLabel", a_didLabel);
	  check_labelName(a_didLabel->get_labelName(), 0);
	}
      else
	check_labelName(a_didLabel->get_labelName(), log);
    }
}

/********************************************************************/

void check_dir(
 dir * a_dir,
 int log)
{
  if (isA(a_dir, posDir))
    {
      adjustLevels(&dirSubs_posDir, "posDir");
      if (log && !findString("posDir", dirSubs))
	{
	  warnSub("posDir", "dir", a_dir);
	  check_posDir(dynamic_cast<posDir *>(a_dir), 0);
	}
      else
	check_posDir(dynamic_cast<posDir *>(a_dir), log);
      return;
    }
  if (isA(a_dir, negDir))
    {
      adjustLevels(&dirSubs_negDir, "negDir");
      if (log && !findString("negDir", dirSubs))
	{
	  warnSub("negDir", "dir", a_dir);
	  check_negDir(dynamic_cast<negDir *>(a_dir), 0);
	}
      else
	check_negDir(dynamic_cast<negDir *>(a_dir), log);
      return;
    }
}

/********************************************************************/

void check_displyItemDMIS(
 displyItemDMIS * a_displyItemDMIS,
 int log)
{
  if (a_displyItemDMIS->get_device())
    {
      adjustLevels(&displyItemDMISAtts_a_device, "displyItemDMIS a_device");
      if (log && !findString("a_device", displyItemDMISAtts))
	{
	  warnAtt("a_device", "displyItemDMIS", a_displyItemDMIS);
	  check_device(a_displyItemDMIS->get_device(), 0);
	}
      else
	check_device(a_displyItemDMIS->get_device(), log);
    }
  if (a_displyItemDMIS->get_vLabel())
    {
      adjustLevels(&displyItemDMISAtts_a_vLabel, "displyItemDMIS a_vLabel");
      if (log && !findString("a_vLabel", displyItemDMISAtts))
	{
	  warnAtt("a_vLabel", "displyItemDMIS", a_displyItemDMIS);
	  check_vLabel(a_displyItemDMIS->get_vLabel(), 0);
	}
      else
	check_vLabel(a_displyItemDMIS->get_vLabel(), log);
    }
}

/********************************************************************/

void check_displyItemNoDMIS(
 displyItemNoDMIS * a_displyItemNoDMIS,
 int log)
{
  if (a_displyItemNoDMIS->get_device())
    {
      adjustLevels(&displyItemNoDMISAtts_a_device,
		   "displyItemNoDMIS a_device");
      if (log && !findString("a_device", displyItemNoDMISAtts))
	{
	  warnAtt("a_device", "displyItemNoDMIS", a_displyItemNoDMIS);
	  check_device(a_displyItemNoDMIS->get_device(), 0);
	}
      else
	check_device(a_displyItemNoDMIS->get_device(), log);
    }
  if (a_displyItemNoDMIS->get_vLabel())
    {
      adjustLevels(&displyItemNoDMISAtts_a_vLabel,
		   "displyItemNoDMIS a_vLabel");
      if (log && !findString("a_vLabel", displyItemNoDMISAtts))
	{
	  warnAtt("a_vLabel", "displyItemNoDMIS", a_displyItemNoDMIS);
	  check_vLabel(a_displyItemNoDMIS->get_vLabel(), 0);
	}
      else
	check_vLabel(a_displyItemNoDMIS->get_vLabel(), log);
    }
}

/********************************************************************/

void check_displySpecItem(
 displySpecItem * a_displySpecItem,
 int log)
{
  if (isA(a_displySpecItem, displyItemDMIS))
    {
      adjustLevels(&displySpecItemSubs_displyItemDMIS, "displyItemDMIS");
      if (log && !findString("displyItemDMIS", displySpecItemSubs))
	{
	  warnSub("displyItemDMIS", "displySpecItem", a_displySpecItem);
	  check_displyItemDMIS(
	    dynamic_cast<displyItemDMIS *>(a_displySpecItem), 0);
	}
      else
	check_displyItemDMIS(
	  dynamic_cast<displyItemDMIS *>(a_displySpecItem), log);
      return;
    }
  if (isA(a_displySpecItem, displyItemNoDMIS))
    {
      adjustLevels(&displySpecItemSubs_displyItemNoDMIS, "displyItemNoDMIS");
      if (log && !findString("displyItemNoDMIS", displySpecItemSubs))
	{
	  warnSub("displyItemNoDMIS", "displySpecItem", a_displySpecItem);
	  check_displyItemNoDMIS(
	    dynamic_cast<displyItemNoDMIS *>(a_displySpecItem), 0);
	}
      else
	check_displyItemNoDMIS(
	  dynamic_cast<displyItemNoDMIS *>(a_displySpecItem), log);
      return;
    }
}

/********************************************************************/

void check_displyStm(
 displyStm * a_displyStm,
 int log)
{
  if (isA(a_displyStm, displyStmOff))
    {
      adjustLevels(&displyStmSubs_displyStmOff, "displyStmOff");
      if (log && !findString("displyStmOff", displyStmSubs))
	{
	  warnSub("displyStmOff", "displyStm", a_displyStm);
	  check_displyStmOff(dynamic_cast<displyStmOff *>(a_displyStm), 0);
	}
      else
	check_displyStmOff(dynamic_cast<displyStmOff *>(a_displyStm), log);
      return;
    }
  if (isA(a_displyStm, displyStmSpec))
    {
      adjustLevels(&displyStmSubs_displyStmSpec, "displyStmSpec");
      if (log && !findString("displyStmSpec", displyStmSubs))
	{
	  warnSub("displyStmSpec", "displyStm", a_displyStm);
	  check_displyStmSpec(
	    dynamic_cast<displyStmSpec *>(a_displyStm), 0);
	}
      else
	check_displyStmSpec(
	  dynamic_cast<displyStmSpec *>(a_displyStm), log);
      return;
    }
}

/********************************************************************/

void check_displyStmOff(
 displyStmOff * a_displyStmOff,
 int log)
{
  if (a_displyStmOff->get_displyOff())
    {
      adjustLevels(&displyStmOffAtts_a_displyOff, "displyStmOff a_displyOff");
      if (log && !findString("a_displyOff", displyStmOffAtts))
	{
	  warnAtt("a_displyOff", "displyStmOff", a_displyStmOff);
	}
    }
}

/********************************************************************/

void check_displyStmSpec(
 displyStmSpec * a_displyStmSpec,
 int log)
{
  if (a_displyStmSpec->get_displySpecList())
    {
      std::list<displySpecItem *> * theList;
      std::list<displySpecItem *>::iterator iter;
      theList = a_displyStmSpec->get_displySpecList();
      adjustLevels(&displyStmSpecAtts_a_displySpecList,
		   "displyStmSpec a_displySpecList");
      if (log && !findString("a_displySpecList", displyStmSpecAtts))
	{
	  warnAtt("a_displySpecList", "displyStmSpec", a_displyStmSpec);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_displySpecItem(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_displySpecItem(*iter, log);
	}
    }
}

/********************************************************************/

void check_dmehwMinor(
 dmehwMinor * a_dmehwMinor,
 int log)
{
  if (isA(a_dmehwMinor, dmehwMinor_CONTIN))
    {
      adjustLevels(&dmehwMinorSubs_dmehwMinor_CONTIN, "dmehwMinor_CONTIN");
      if (log && !findString("dmehwMinor_CONTIN", dmehwMinorSubs))
	{
	  warnSub("dmehwMinor_CONTIN", "dmehwMinor", a_dmehwMinor);
	}
      return;
    }
  if (isA(a_dmehwMinor, dmehwMinor_PAUSE))
    {
      adjustLevels(&dmehwMinorSubs_dmehwMinor_PAUSE, "dmehwMinor_PAUSE");
      if (log && !findString("dmehwMinor_PAUSE", dmehwMinorSubs))
	{
	  warnSub("dmehwMinor_PAUSE", "dmehwMinor", a_dmehwMinor);
	}
      return;
    }
  if (isA(a_dmehwMinor, dmehwMinor_SINGLE))
    {
      adjustLevels(&dmehwMinorSubs_dmehwMinor_SINGLE, "dmehwMinor_SINGLE");
      if (log && !findString("dmehwMinor_SINGLE", dmehwMinorSubs))
	{
	  warnSub("dmehwMinor_SINGLE", "dmehwMinor", a_dmehwMinor);
	}
      return;
    }
  if (isA(a_dmehwMinor, dmehwMinor_AUTO))
    {
      adjustLevels(&dmehwMinorSubs_dmehwMinor_AUTO, "dmehwMinor_AUTO");
      if (log && !findString("dmehwMinor_AUTO", dmehwMinorSubs))
	{
	  warnSub("dmehwMinor_AUTO", "dmehwMinor", a_dmehwMinor);
	}
      return;
    }
  if (isA(a_dmehwMinor, dmehwMinor_jointConf))
    {
      adjustLevels(&dmehwMinorSubs_dmehwMinor_jointConf,
		   "dmehwMinor_jointConf");
      if (log && !findString("dmehwMinor_jointConf", dmehwMinorSubs))
	{
	  warnSub("dmehwMinor_jointConf", "dmehwMinor", a_dmehwMinor);
	  check_dmehwMinor_jointConf(
	    dynamic_cast<dmehwMinor_jointConf *>(a_dmehwMinor), 0);
	}
      else
	check_dmehwMinor_jointConf(
	  dynamic_cast<dmehwMinor_jointConf *>(a_dmehwMinor), log);
      return;
    }
}

/********************************************************************/

void check_dmehwMinor_jointConf(
 dmehwMinor_jointConf * a_dmehwMinor_jointConf,
 int log)
{
  if (a_dmehwMinor_jointConf->get_jointConf())
    {
      adjustLevels(&dmehwMinor_jointConfAtts_a_jointConf,
		   "dmehwMinor_jointConf a_jointConf");
      if (log && !findString("a_jointConf", dmehwMinor_jointConfAtts))
	{
	  warnAtt("a_jointConf", "dmehwMinor_jointConf",
		  a_dmehwMinor_jointConf);
	  check_jointConf(a_dmehwMinor_jointConf->get_jointConf(), 0);
	}
      else
	check_jointConf(a_dmehwMinor_jointConf->get_jointConf(), log);
    }
}

/********************************************************************/

void check_dmehwStm(
 dmehwStm * a_dmehwStm,
 int log)
{
  if (a_dmehwStm->get_dmehwMinor())
    {
      adjustLevels(&dmehwStmAtts_a_dmehwMinor, "dmehwStm a_dmehwMinor");
      if (log && !findString("a_dmehwMinor", dmehwStmAtts))
	{
	  warnAtt("a_dmehwMinor", "dmehwStm", a_dmehwStm);
	  check_dmehwMinor(a_dmehwStm->get_dmehwMinor(), 0);
	}
      else
	check_dmehwMinor(a_dmehwStm->get_dmehwMinor(), log);
    }
}

/********************************************************************/

void check_dmeidStm(
 dmeidStm * a_dmeidStm,
 int log)
{
  if (a_dmeidStm->get_diLabel())
    {
      adjustLevels(&dmeidStmAtts_a_diLabel, "dmeidStm a_diLabel");
      if (log && !findString("a_diLabel", dmeidStmAtts))
	{
	  warnAtt("a_diLabel", "dmeidStm", a_dmeidStm);
	  check_diLabel(a_dmeidStm->get_diLabel(), 0);
	}
      else
	check_diLabel(a_dmeidStm->get_diLabel(), log);
    }
  if (a_dmeidStm->get_text())
    {
      adjustLevels(&dmeidStmAtts_text, "dmeidStm text");
      if (log && !findString("text", dmeidStmAtts))
	{
	  warnAtt("text", "dmeidStm", a_dmeidStm);
	  check_stringVal(a_dmeidStm->get_text(), 0);
	}
      else
	check_stringVal(a_dmeidStm->get_text(), log);
    }
}

/********************************************************************/

void check_dmeswComand(
 dmeswComand * a_dmeswComand,
 int log)
{
  if (a_dmeswComand->get_command())
    {
      adjustLevels(&dmeswComandAtts_command, "dmeswComand command");
      if (log && !findString("command", dmeswComandAtts))
	{
	  warnAtt("command", "dmeswComand", a_dmeswComand);
	  check_stringVal(a_dmeswComand->get_command(), 0);
	}
      else
	check_stringVal(a_dmeswComand->get_command(), log);
    }
}

/********************************************************************/

void check_dmeswDelay(
 dmeswDelay * a_dmeswDelay,
 int log)
{
  if (a_dmeswDelay->get_secs())
    {
      adjustLevels(&dmeswDelayAtts_secs, "dmeswDelay secs");
      if (log && !findString("secs", dmeswDelayAtts))
	{
	  warnAtt("secs", "dmeswDelay", a_dmeswDelay);
	  check_intVal(a_dmeswDelay->get_secs(), 0);
	}
      else
	check_intVal(a_dmeswDelay->get_secs(), log);
    }
}

/********************************************************************/

void check_dmeswMinor(
 dmeswMinor * a_dmeswMinor,
 int log)
{
  if (isA(a_dmeswMinor, dmeswComand))
    {
      adjustLevels(&dmeswMinorSubs_dmeswComand, "dmeswComand");
      if (log && !findString("dmeswComand", dmeswMinorSubs))
	{
	  warnSub("dmeswComand", "dmeswMinor", a_dmeswMinor);
	  check_dmeswComand(dynamic_cast<dmeswComand *>(a_dmeswMinor), 0);
	}
      else
	check_dmeswComand(dynamic_cast<dmeswComand *>(a_dmeswMinor), log);
      return;
    }
  if (isA(a_dmeswMinor, dmeswDelay))
    {
      adjustLevels(&dmeswMinorSubs_dmeswDelay, "dmeswDelay");
      if (log && !findString("dmeswDelay", dmeswMinorSubs))
	{
	  warnSub("dmeswDelay", "dmeswMinor", a_dmeswMinor);
	  check_dmeswDelay(dynamic_cast<dmeswDelay *>(a_dmeswMinor), 0);
	}
      else
	check_dmeswDelay(dynamic_cast<dmeswDelay *>(a_dmeswMinor), log);
      return;
    }
  if (isA(a_dmeswMinor, dmeswSwitch))
    {
      adjustLevels(&dmeswMinorSubs_dmeswSwitch, "dmeswSwitch");
      if (log && !findString("dmeswSwitch", dmeswMinorSubs))
	{
	  warnSub("dmeswSwitch", "dmeswMinor", a_dmeswMinor);
	  check_dmeswSwitch(dynamic_cast<dmeswSwitch *>(a_dmeswMinor), 0);
	}
      else
	check_dmeswSwitch(dynamic_cast<dmeswSwitch *>(a_dmeswMinor), log);
      return;
    }
}

/********************************************************************/

void check_dmeswStm(
 dmeswStm * a_dmeswStm,
 int log)
{
  if (a_dmeswStm->get_dmeswMinor())
    {
      adjustLevels(&dmeswStmAtts_a_dmeswMinor, "dmeswStm a_dmeswMinor");
      if (log && !findString("a_dmeswMinor", dmeswStmAtts))
	{
	  warnAtt("a_dmeswMinor", "dmeswStm", a_dmeswStm);
	  check_dmeswMinor(a_dmeswStm->get_dmeswMinor(), 0);
	}
      else
	check_dmeswMinor(a_dmeswStm->get_dmeswMinor(), log);
    }
}

/********************************************************************/

void check_dmeswSwitch(
 dmeswSwitch * a_dmeswSwitch,
 int log)
{
  if (isA(a_dmeswSwitch, dmeswSwitch_CONTIN))
    {
      adjustLevels(&dmeswSwitchSubs_dmeswSwitch_CONTIN, "dmeswSwitch_CONTIN");
      if (log && !findString("dmeswSwitch_CONTIN", dmeswSwitchSubs))
	{
	  warnSub("dmeswSwitch_CONTIN", "dmeswSwitch", a_dmeswSwitch);
	}
      return;
    }
  if (isA(a_dmeswSwitch, dmeswSwitch_PAUSE))
    {
      adjustLevels(&dmeswSwitchSubs_dmeswSwitch_PAUSE, "dmeswSwitch_PAUSE");
      if (log && !findString("dmeswSwitch_PAUSE", dmeswSwitchSubs))
	{
	  warnSub("dmeswSwitch_PAUSE", "dmeswSwitch", a_dmeswSwitch);
	}
      return;
    }
}

/********************************************************************/

void check_dmeswiStm(
 dmeswiStm * a_dmeswiStm,
 int log)
{
  if (a_dmeswiStm->get_dsLabel())
    {
      adjustLevels(&dmeswiStmAtts_a_dsLabel, "dmeswiStm a_dsLabel");
      if (log && !findString("a_dsLabel", dmeswiStmAtts))
	{
	  warnAtt("a_dsLabel", "dmeswiStm", a_dmeswiStm);
	  check_dsLabel(a_dmeswiStm->get_dsLabel(), 0);
	}
      else
	check_dsLabel(a_dmeswiStm->get_dsLabel(), log);
    }
  if (a_dmeswiStm->get_text())
    {
      adjustLevels(&dmeswiStmAtts_text, "dmeswiStm text");
      if (log && !findString("text", dmeswiStmAtts))
	{
	  warnAtt("text", "dmeswiStm", a_dmeswiStm);
	  check_stringVal(a_dmeswiStm->get_text(), 0);
	}
      else
	check_stringVal(a_dmeswiStm->get_text(), log);
    }
}

/********************************************************************/

void check_dmeswvStm(
 dmeswvStm * a_dmeswvStm,
 int log)
{
  if (a_dmeswvStm->get_dvLabel())
    {
      adjustLevels(&dmeswvStmAtts_a_dvLabel, "dmeswvStm a_dvLabel");
      if (log && !findString("a_dvLabel", dmeswvStmAtts))
	{
	  warnAtt("a_dvLabel", "dmeswvStm", a_dmeswvStm);
	  check_dvLabel(a_dmeswvStm->get_dvLabel(), 0);
	}
      else
	check_dvLabel(a_dmeswvStm->get_dvLabel(), log);
    }
  if (a_dmeswvStm->get_text())
    {
      adjustLevels(&dmeswvStmAtts_text, "dmeswvStm text");
      if (log && !findString("text", dmeswvStmAtts))
	{
	  warnAtt("text", "dmeswvStm", a_dmeswvStm);
	  check_stringVal(a_dmeswvStm->get_text(), 0);
	}
      else
	check_stringVal(a_dmeswvStm->get_text(), log);
    }
}

/********************************************************************/

void check_dmisBlock(
 dmisBlock * a_dmisBlock,
 int log)
{
  if (isA(a_dmisBlock, calibMasterBlock))
    {
      if (log && !findString("calibMasterBlock", dmisBlockSubs))
        {warnBlockBug("calibMasterBlock", "dmisBlock");}
      else
	check_calibMasterBlock(
	  dynamic_cast<calibMasterBlock *>(a_dmisBlock), log);
    }
  else if (isA(a_dmisBlock, calibRtabBlock))
    {
      if (log && !findString("calibRtabBlock", dmisBlockSubs))
        {warnBlockBug("calibRtabBlock", "dmisBlock");}
      else
	check_calibRtabBlock(
	  dynamic_cast<calibRtabBlock *>(a_dmisBlock), log);
    }
  else if (isA(a_dmisBlock, calibSensBlock))
    {
      if (log && !findString("calibSensBlock", dmisBlockSubs))
        {warnBlockBug("calibSensBlock", "dmisBlock");}
      else
	check_calibSensBlock(
	  dynamic_cast<calibSensBlock *>(a_dmisBlock), log);
    }
  else if (isA(a_dmisBlock, callBlock))
    {
      if (log && !findString("callBlock", dmisBlockSubs))
        {warnBlockBug("callBlock", "dmisBlock");}
      else
	check_callBlock(dynamic_cast<callBlock *>(a_dmisBlock), log);
    }
  else if (isA(a_dmisBlock, dmisOffBlock))
    {
      if (log && !findString("dmisOffBlock", dmisBlockSubs))
        {warnBlockBug("dmisOffBlock", "dmisBlock");}
      else
	check_dmisOffBlock(dynamic_cast<dmisOffBlock *>(a_dmisBlock), log);
    }
  else if (isA(a_dmisBlock, doBlock))
    {
      if (log && !findString("doBlock", dmisBlockSubs))
        {warnBlockBug("doBlock", "dmisBlock");}
      else
	check_doBlock(dynamic_cast<doBlock *>(a_dmisBlock), log);
    }
  else if (isA(a_dmisBlock, gotargBlock))
    {
      if (log && !findString("gotargBlock", dmisBlockSubs))
        {warnBlockBug("gotargBlock", "dmisBlock");}
      else
	check_gotargBlock(dynamic_cast<gotargBlock *>(a_dmisBlock), log);
    }
  else if (isA(a_dmisBlock, ifBlock))
    {
      if (log && !findString("ifBlock", dmisBlockSubs))
        {warnBlockBug("ifBlock", "dmisBlock");}
      else
	check_ifBlock(dynamic_cast<ifBlock *>(a_dmisBlock), log);
    }
  else if (isA(a_dmisBlock, macroBlock))
    {
      if (log && !findString("macroBlock", dmisBlockSubs))
        {warnBlockBug("macroBlock", "dmisBlock");}
      else
	check_macroBlock(dynamic_cast<macroBlock *>(a_dmisBlock), log);
    }
  else if (isA(a_dmisBlock, measBlock))
    {
      if (log && !findString("measBlock", dmisBlockSubs))
        {warnBlockBug("measBlock", "dmisBlock");}
      else
	check_measBlock(dynamic_cast<measBlock *>(a_dmisBlock), log);
    }
  else if (isA(a_dmisBlock, selectBlock))
    {
      if (log && !findString("selectBlock", dmisBlockSubs))
        {warnBlockBug("selectBlock", "dmisBlock");}
      else
	check_selectBlock(dynamic_cast<selectBlock *>(a_dmisBlock), log);
    }
  else if (isA(a_dmisBlock, simreqtBlock))
    {
      if (log && !findString("simreqtBlock", dmisBlockSubs))
        {warnBlockBug("simreqtBlock", "dmisBlock");}
      else
	check_simreqtBlock(dynamic_cast<simreqtBlock *>(a_dmisBlock), log);
    }
  else if (isA(a_dmisBlock, xternBlock))
    {
      if (log && !findString("xternBlock", dmisBlockSubs))
        {warnBlockBug("xternBlock", "dmisBlock");}
      else
	check_xternBlock(dynamic_cast<xternBlock *>(a_dmisBlock), log);
    }
}

/********************************************************************/

void check_dmisFirstStatement(
 dmisFirstStatement * a_dmisFirstStatement,
 int log)
{
  if (isA(a_dmisFirstStatement, dmismdStm))
    {
      adjustLevels(&dmisFirstStatementSubs_dmismdStm, "dmismdStm");
      if (log && !findString("dmismdStm", dmisFirstStatementSubs))
	{
	  warnSub("dmismdStm", "dmisFirstStatement", a_dmisFirstStatement);
	  check_dmismdStm(
	    dynamic_cast<dmismdStm *>(a_dmisFirstStatement), 0);
	}
      else
	check_dmismdStm(
	  dynamic_cast<dmismdStm *>(a_dmisFirstStatement), log);
      return;
    }
  if (isA(a_dmisFirstStatement, dmismnStm))
    {
      adjustLevels(&dmisFirstStatementSubs_dmismnStm, "dmismnStm");
      if (log && !findString("dmismnStm", dmisFirstStatementSubs))
	{
	  warnSub("dmismnStm", "dmisFirstStatement", a_dmisFirstStatement);
	  check_dmismnStm(
	    dynamic_cast<dmismnStm *>(a_dmisFirstStatement), 0);
	}
      else
	check_dmismnStm(
	  dynamic_cast<dmismnStm *>(a_dmisFirstStatement), log);
      return;
    }
}

/********************************************************************/

void check_dmisFreeStatement(
 dmisFreeStatement * a_dmisFreeStatement,
 int log)
{
  if (isA(a_dmisFreeStatement, jumpStm))
    {
      adjustLevels(&dmisFreeStatementSubs_jumpStm, "jumpStm");
      if (log && !findString("jumpStm", dmisFreeStatementSubs))
	{
	  warnSub("jumpStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_jumpStm(dynamic_cast<jumpStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_jumpStm(dynamic_cast<jumpStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, aclratStm))
    {
      adjustLevels(&dmisFreeStatementSubs_aclratStm, "aclratStm");
      if (log && !findString("aclratStm", dmisFreeStatementSubs))
	{
	  warnSub("aclratStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_aclratStm(
	    dynamic_cast<aclratStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_aclratStm(
	  dynamic_cast<aclratStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, algdefStm))
    {
      adjustLevels(&dmisFreeStatementSubs_algdefStm, "algdefStm");
      if (log && !findString("algdefStm", dmisFreeStatementSubs))
	{
	  warnSub("algdefStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_algdefStm(
	    dynamic_cast<algdefStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_algdefStm(
	  dynamic_cast<algdefStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, assignStm))
    {
      adjustLevels(&dmisFreeStatementSubs_assignStm, "assignStm");
      if (log && !findString("assignStm", dmisFreeStatementSubs))
	{
	  warnSub("assignStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_assignStm(
	    dynamic_cast<assignStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_assignStm(
	  dynamic_cast<assignStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, badtstStm))
    {
      adjustLevels(&dmisFreeStatementSubs_badtstStm, "badtstStm");
      if (log && !findString("badtstStm", dmisFreeStatementSubs))
	{
	  warnSub("badtstStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_badtstStm(
	    dynamic_cast<badtstStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_badtstStm(
	  dynamic_cast<badtstStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, boundStm))
    {
      adjustLevels(&dmisFreeStatementSubs_boundStm, "boundStm");
      if (log && !findString("boundStm", dmisFreeStatementSubs))
	{
	  warnSub("boundStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_boundStm(dynamic_cast<boundStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_boundStm(dynamic_cast<boundStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, clmpidStm))
    {
      adjustLevels(&dmisFreeStatementSubs_clmpidStm, "clmpidStm");
      if (log && !findString("clmpidStm", dmisFreeStatementSubs))
	{
	  warnSub("clmpidStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_clmpidStm(
	    dynamic_cast<clmpidStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_clmpidStm(
	  dynamic_cast<clmpidStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, clmpsnStm))
    {
      adjustLevels(&dmisFreeStatementSubs_clmpsnStm, "clmpsnStm");
      if (log && !findString("clmpsnStm", dmisFreeStatementSubs))
	{
	  warnSub("clmpsnStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_clmpsnStm(
	    dynamic_cast<clmpsnStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_clmpsnStm(
	  dynamic_cast<clmpsnStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, closeStm))
    {
      adjustLevels(&dmisFreeStatementSubs_closeStm, "closeStm");
      if (log && !findString("closeStm", dmisFreeStatementSubs))
	{
	  warnSub("closeStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_closeStm(dynamic_cast<closeStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_closeStm(dynamic_cast<closeStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, cmpntgrpStm))
    {
      adjustLevels(&dmisFreeStatementSubs_cmpntgrpStm, "cmpntgrpStm");
      if (log && !findString("cmpntgrpStm", dmisFreeStatementSubs))
	{
	  warnSub("cmpntgrpStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_cmpntgrpStm(
	    dynamic_cast<cmpntgrpStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_cmpntgrpStm(
	  dynamic_cast<cmpntgrpStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, cnfrmrulStm))
    {
      adjustLevels(&dmisFreeStatementSubs_cnfrmrulStm, "cnfrmrulStm");
      if (log && !findString("cnfrmrulStm", dmisFreeStatementSubs))
	{
	  warnSub("cnfrmrulStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_cnfrmrulStm(
	    dynamic_cast<cnfrmrulStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_cnfrmrulStm(
	  dynamic_cast<cnfrmrulStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, constStm))
    {
      adjustLevels(&dmisFreeStatementSubs_constStm, "constStm");
      if (log && !findString("constStm", dmisFreeStatementSubs))
	{
	  warnSub("constStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_constStm(dynamic_cast<constStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_constStm(dynamic_cast<constStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, crgdefStm))
    {
      adjustLevels(&dmisFreeStatementSubs_crgdefStm, "crgdefStm");
      if (log && !findString("crgdefStm", dmisFreeStatementSubs))
	{
	  warnSub("crgdefStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_crgdefStm(
	    dynamic_cast<crgdefStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_crgdefStm(
	  dynamic_cast<crgdefStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, crmodeStm))
    {
      adjustLevels(&dmisFreeStatementSubs_crmodeStm, "crmodeStm");
      if (log && !findString("crmodeStm", dmisFreeStatementSubs))
	{
	  warnSub("crmodeStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_crmodeStm(
	    dynamic_cast<crmodeStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_crmodeStm(
	  dynamic_cast<crmodeStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, crosclStm))
    {
      adjustLevels(&dmisFreeStatementSubs_crosclStm, "crosclStm");
      if (log && !findString("crosclStm", dmisFreeStatementSubs))
	{
	  warnSub("crosclStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_crosclStm(
	    dynamic_cast<crosclStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_crosclStm(
	  dynamic_cast<crosclStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, crslctStm))
    {
      adjustLevels(&dmisFreeStatementSubs_crslctStm, "crslctStm");
      if (log && !findString("crslctStm", dmisFreeStatementSubs))
	{
	  warnSub("crslctStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_crslctStm(
	    dynamic_cast<crslctStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_crslctStm(
	  dynamic_cast<crslctStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, cutcomStm))
    {
      adjustLevels(&dmisFreeStatementSubs_cutcomStm, "cutcomStm");
      if (log && !findString("cutcomStm", dmisFreeStatementSubs))
	{
	  warnSub("cutcomStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_cutcomStm(
	    dynamic_cast<cutcomStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_cutcomStm(
	  dynamic_cast<cutcomStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, czoneStm))
    {
      adjustLevels(&dmisFreeStatementSubs_czoneStm, "czoneStm");
      if (log && !findString("czoneStm", dmisFreeStatementSubs))
	{
	  warnSub("czoneStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_czoneStm(dynamic_cast<czoneStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_czoneStm(dynamic_cast<czoneStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, czslctStm))
    {
      adjustLevels(&dmisFreeStatementSubs_czslctStm, "czslctStm");
      if (log && !findString("czslctStm", dmisFreeStatementSubs))
	{
	  warnSub("czslctStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_czslctStm(
	    dynamic_cast<czslctStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_czslctStm(
	  dynamic_cast<czslctStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, datdefStm))
    {
      adjustLevels(&dmisFreeStatementSubs_datdefStm, "datdefStm");
      if (log && !findString("datdefStm", dmisFreeStatementSubs))
	{
	  warnSub("datdefStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_datdefStm(
	    dynamic_cast<datdefStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_datdefStm(
	  dynamic_cast<datdefStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, datsetStm))
    {
      adjustLevels(&dmisFreeStatementSubs_datsetStm, "datsetStm");
      if (log && !findString("datsetStm", dmisFreeStatementSubs))
	{
	  warnSub("datsetStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_datsetStm(
	    dynamic_cast<datsetStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_datsetStm(
	  dynamic_cast<datsetStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, dattrgdefStm))
    {
      adjustLevels(&dmisFreeStatementSubs_dattrgdefStm, "dattrgdefStm");
      if (log && !findString("dattrgdefStm", dmisFreeStatementSubs))
	{
	  warnSub("dattrgdefStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_dattrgdefStm(
	    dynamic_cast<dattrgdefStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_dattrgdefStm(
	  dynamic_cast<dattrgdefStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, declStm))
    {
      adjustLevels(&dmisFreeStatementSubs_declStm, "declStm");
      if (log && !findString("declStm", dmisFreeStatementSubs))
	{
	  warnSub("declStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_declStm(dynamic_cast<declStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_declStm(dynamic_cast<declStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, decplStm))
    {
      adjustLevels(&dmisFreeStatementSubs_decplStm, "decplStm");
      if (log && !findString("decplStm", dmisFreeStatementSubs))
	{
	  warnSub("decplStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_decplStm(dynamic_cast<decplStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_decplStm(dynamic_cast<decplStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, deleteStm))
    {
      adjustLevels(&dmisFreeStatementSubs_deleteStm, "deleteStm");
      if (log && !findString("deleteStm", dmisFreeStatementSubs))
	{
	  warnSub("deleteStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_deleteStm(
	    dynamic_cast<deleteStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_deleteStm(
	  dynamic_cast<deleteStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, deviceStm))
    {
      adjustLevels(&dmisFreeStatementSubs_deviceStm, "deviceStm");
      if (log && !findString("deviceStm", dmisFreeStatementSubs))
	{
	  warnSub("deviceStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_deviceStm(
	    dynamic_cast<deviceStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_deviceStm(
	  dynamic_cast<deviceStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, displyStm))
    {
      adjustLevels(&dmisFreeStatementSubs_displyStm, "displyStm");
      if (log && !findString("displyStm", dmisFreeStatementSubs))
	{
	  warnSub("displyStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_displyStm(
	    dynamic_cast<displyStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_displyStm(
	  dynamic_cast<displyStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, dmehwStm))
    {
      adjustLevels(&dmisFreeStatementSubs_dmehwStm, "dmehwStm");
      if (log && !findString("dmehwStm", dmisFreeStatementSubs))
	{
	  warnSub("dmehwStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_dmehwStm(dynamic_cast<dmehwStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_dmehwStm(dynamic_cast<dmehwStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, dmeidStm))
    {
      adjustLevels(&dmisFreeStatementSubs_dmeidStm, "dmeidStm");
      if (log && !findString("dmeidStm", dmisFreeStatementSubs))
	{
	  warnSub("dmeidStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_dmeidStm(dynamic_cast<dmeidStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_dmeidStm(dynamic_cast<dmeidStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, dmeswStm))
    {
      adjustLevels(&dmisFreeStatementSubs_dmeswStm, "dmeswStm");
      if (log && !findString("dmeswStm", dmisFreeStatementSubs))
	{
	  warnSub("dmeswStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_dmeswStm(dynamic_cast<dmeswStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_dmeswStm(dynamic_cast<dmeswStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, dmeswiStm))
    {
      adjustLevels(&dmisFreeStatementSubs_dmeswiStm, "dmeswiStm");
      if (log && !findString("dmeswiStm", dmisFreeStatementSubs))
	{
	  warnSub("dmeswiStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_dmeswiStm(
	    dynamic_cast<dmeswiStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_dmeswiStm(
	  dynamic_cast<dmeswiStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, dmeswvStm))
    {
      adjustLevels(&dmisFreeStatementSubs_dmeswvStm, "dmeswvStm");
      if (log && !findString("dmeswvStm", dmisFreeStatementSubs))
	{
	  warnSub("dmeswvStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_dmeswvStm(
	    dynamic_cast<dmeswvStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_dmeswvStm(
	  dynamic_cast<dmeswvStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, dmisOnStm))
    {
      adjustLevels(&dmisFreeStatementSubs_dmisOnStm, "dmisOnStm");
      if (log && !findString("dmisOnStm", dmisFreeStatementSubs))
	{
	  warnSub("dmisOnStm", "dmisFreeStatement", a_dmisFreeStatement);
	}
      return;
    }
  if (isA(a_dmisFreeStatement, equateStm))
    {
      adjustLevels(&dmisFreeStatementSubs_equateStm, "equateStm");
      if (log && !findString("equateStm", dmisFreeStatementSubs))
	{
	  warnSub("equateStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_equateStm(
	    dynamic_cast<equateStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_equateStm(
	  dynamic_cast<equateStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, errorStm))
    {
      adjustLevels(&dmisFreeStatementSubs_errorStm, "errorStm");
      if (log && !findString("errorStm", dmisFreeStatementSubs))
	{
	  warnSub("errorStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_errorStm(dynamic_cast<errorStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_errorStm(dynamic_cast<errorStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, evalStm))
    {
      adjustLevels(&dmisFreeStatementSubs_evalStm, "evalStm");
      if (log && !findString("evalStm", dmisFreeStatementSubs))
	{
	  warnSub("evalStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_evalStm(dynamic_cast<evalStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_evalStm(dynamic_cast<evalStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, extensStm))
    {
      adjustLevels(&dmisFreeStatementSubs_extensStm, "extensStm");
      if (log && !findString("extensStm", dmisFreeStatementSubs))
	{
	  warnSub("extensStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_extensStm(
	    dynamic_cast<extensStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_extensStm(
	  dynamic_cast<extensStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, featArc1Stm))
    {
      adjustLevels(&dmisFreeStatementSubs_featArc1Stm, "featArc1Stm");
      if (log && !findString("featArc1Stm", dmisFreeStatementSubs))
	{
	  warnSub("featArc1Stm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_featArc1Stm(
	    dynamic_cast<featArc1Stm *>(a_dmisFreeStatement), 0);
	}
      else
	check_featArc1Stm(
	  dynamic_cast<featArc1Stm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, featArc2Stm))
    {
      adjustLevels(&dmisFreeStatementSubs_featArc2Stm, "featArc2Stm");
      if (log && !findString("featArc2Stm", dmisFreeStatementSubs))
	{
	  warnSub("featArc2Stm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_featArc2Stm(
	    dynamic_cast<featArc2Stm *>(a_dmisFreeStatement), 0);
	}
      else
	check_featArc2Stm(
	  dynamic_cast<featArc2Stm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, featCircleStm))
    {
      adjustLevels(&dmisFreeStatementSubs_featCircleStm, "featCircleStm");
      if (log && !findString("featCircleStm", dmisFreeStatementSubs))
	{
	  warnSub("featCircleStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_featCircleStm(
	    dynamic_cast<featCircleStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_featCircleStm(
	  dynamic_cast<featCircleStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, featCompoundStm))
    {
      adjustLevels(&dmisFreeStatementSubs_featCompoundStm, "featCompoundStm");
      if (log && !findString("featCompoundStm", dmisFreeStatementSubs))
	{
	  warnSub("featCompoundStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_featCompoundStm(
	    dynamic_cast<featCompoundStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_featCompoundStm(
	  dynamic_cast<featCompoundStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, featConeStm))
    {
      adjustLevels(&dmisFreeStatementSubs_featConeStm, "featConeStm");
      if (log && !findString("featConeStm", dmisFreeStatementSubs))
	{
	  warnSub("featConeStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_featConeStm(
	    dynamic_cast<featConeStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_featConeStm(
	  dynamic_cast<featConeStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, featConradsegStm))
    {
      adjustLevels(&dmisFreeStatementSubs_featConradsegStm,
		   "featConradsegStm");
      if (log && !findString("featConradsegStm", dmisFreeStatementSubs))
	{
	  warnSub("featConradsegStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_featConradsegStm(
	    dynamic_cast<featConradsegStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_featConradsegStm(
	  dynamic_cast<featConradsegStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, featCparlnStm))
    {
      adjustLevels(&dmisFreeStatementSubs_featCparlnStm, "featCparlnStm");
      if (log && !findString("featCparlnStm", dmisFreeStatementSubs))
	{
	  warnSub("featCparlnStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_featCparlnStm(
	    dynamic_cast<featCparlnStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_featCparlnStm(
	  dynamic_cast<featCparlnStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, featCylndrStm))
    {
      adjustLevels(&dmisFreeStatementSubs_featCylndrStm, "featCylndrStm");
      if (log && !findString("featCylndrStm", dmisFreeStatementSubs))
	{
	  warnSub("featCylndrStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_featCylndrStm(
	    dynamic_cast<featCylndrStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_featCylndrStm(
	  dynamic_cast<featCylndrStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, featCylradsegStm))
    {
      adjustLevels(&dmisFreeStatementSubs_featCylradsegStm,
		   "featCylradsegStm");
      if (log && !findString("featCylradsegStm", dmisFreeStatementSubs))
	{
	  warnSub("featCylradsegStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_featCylradsegStm(
	    dynamic_cast<featCylradsegStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_featCylradsegStm(
	  dynamic_cast<featCylradsegStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, featEdgeptStm))
    {
      adjustLevels(&dmisFreeStatementSubs_featEdgeptStm, "featEdgeptStm");
      if (log && !findString("featEdgeptStm", dmisFreeStatementSubs))
	{
	  warnSub("featEdgeptStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_featEdgeptStm(
	    dynamic_cast<featEdgeptStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_featEdgeptStm(
	  dynamic_cast<featEdgeptStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, featEllipsStm))
    {
      adjustLevels(&dmisFreeStatementSubs_featEllipsStm, "featEllipsStm");
      if (log && !findString("featEllipsStm", dmisFreeStatementSubs))
	{
	  warnSub("featEllipsStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_featEllipsStm(
	    dynamic_cast<featEllipsStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_featEllipsStm(
	  dynamic_cast<featEllipsStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, featElongcylStm))
    {
      adjustLevels(&dmisFreeStatementSubs_featElongcylStm, "featElongcylStm");
      if (log && !findString("featElongcylStm", dmisFreeStatementSubs))
	{
	  warnSub("featElongcylStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_featElongcylStm(
	    dynamic_cast<featElongcylStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_featElongcylStm(
	  dynamic_cast<featElongcylStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, featGcurveStm))
    {
      adjustLevels(&dmisFreeStatementSubs_featGcurveStm, "featGcurveStm");
      if (log && !findString("featGcurveStm", dmisFreeStatementSubs))
	{
	  warnSub("featGcurveStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_featGcurveStm(
	    dynamic_cast<featGcurveStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_featGcurveStm(
	  dynamic_cast<featGcurveStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, featGeomStm))
    {
      adjustLevels(&dmisFreeStatementSubs_featGeomStm, "featGeomStm");
      if (log && !findString("featGeomStm", dmisFreeStatementSubs))
	{
	  warnSub("featGeomStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_featGeomStm(
	    dynamic_cast<featGeomStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_featGeomStm(
	  dynamic_cast<featGeomStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, featGsurfStm))
    {
      adjustLevels(&dmisFreeStatementSubs_featGsurfStm, "featGsurfStm");
      if (log && !findString("featGsurfStm", dmisFreeStatementSubs))
	{
	  warnSub("featGsurfStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_featGsurfStm(
	    dynamic_cast<featGsurfStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_featGsurfStm(
	  dynamic_cast<featGsurfStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, featLineStm))
    {
      adjustLevels(&dmisFreeStatementSubs_featLineStm, "featLineStm");
      if (log && !findString("featLineStm", dmisFreeStatementSubs))
	{
	  warnSub("featLineStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_featLineStm(
	    dynamic_cast<featLineStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_featLineStm(
	  dynamic_cast<featLineStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, featObjectStm))
    {
      adjustLevels(&dmisFreeStatementSubs_featObjectStm, "featObjectStm");
      if (log && !findString("featObjectStm", dmisFreeStatementSubs))
	{
	  warnSub("featObjectStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_featObjectStm(
	    dynamic_cast<featObjectStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_featObjectStm(
	  dynamic_cast<featObjectStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, featParplnStm))
    {
      adjustLevels(&dmisFreeStatementSubs_featParplnStm, "featParplnStm");
      if (log && !findString("featParplnStm", dmisFreeStatementSubs))
	{
	  warnSub("featParplnStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_featParplnStm(
	    dynamic_cast<featParplnStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_featParplnStm(
	  dynamic_cast<featParplnStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, featPaternStm))
    {
      adjustLevels(&dmisFreeStatementSubs_featPaternStm, "featPaternStm");
      if (log && !findString("featPaternStm", dmisFreeStatementSubs))
	{
	  warnSub("featPaternStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_featPaternStm(
	    dynamic_cast<featPaternStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_featPaternStm(
	  dynamic_cast<featPaternStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, featPlaneStm))
    {
      adjustLevels(&dmisFreeStatementSubs_featPlaneStm, "featPlaneStm");
      if (log && !findString("featPlaneStm", dmisFreeStatementSubs))
	{
	  warnSub("featPlaneStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_featPlaneStm(
	    dynamic_cast<featPlaneStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_featPlaneStm(
	  dynamic_cast<featPlaneStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, featPointStm))
    {
      adjustLevels(&dmisFreeStatementSubs_featPointStm, "featPointStm");
      if (log && !findString("featPointStm", dmisFreeStatementSubs))
	{
	  warnSub("featPointStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_featPointStm(
	    dynamic_cast<featPointStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_featPointStm(
	  dynamic_cast<featPointStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, featRctnglStm))
    {
      adjustLevels(&dmisFreeStatementSubs_featRctnglStm, "featRctnglStm");
      if (log && !findString("featRctnglStm", dmisFreeStatementSubs))
	{
	  warnSub("featRctnglStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_featRctnglStm(
	    dynamic_cast<featRctnglStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_featRctnglStm(
	  dynamic_cast<featRctnglStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, featRevsurfStm))
    {
      adjustLevels(&dmisFreeStatementSubs_featRevsurfStm, "featRevsurfStm");
      if (log && !findString("featRevsurfStm", dmisFreeStatementSubs))
	{
	  warnSub("featRevsurfStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_featRevsurfStm(
	    dynamic_cast<featRevsurfStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_featRevsurfStm(
	  dynamic_cast<featRevsurfStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, featSphereStm))
    {
      adjustLevels(&dmisFreeStatementSubs_featSphereStm, "featSphereStm");
      if (log && !findString("featSphereStm", dmisFreeStatementSubs))
	{
	  warnSub("featSphereStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_featSphereStm(
	    dynamic_cast<featSphereStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_featSphereStm(
	  dynamic_cast<featSphereStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, featSphradsegStm))
    {
      adjustLevels(&dmisFreeStatementSubs_featSphradsegStm,
		   "featSphradsegStm");
      if (log && !findString("featSphradsegStm", dmisFreeStatementSubs))
	{
	  warnSub("featSphradsegStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_featSphradsegStm(
	    dynamic_cast<featSphradsegStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_featSphradsegStm(
	  dynamic_cast<featSphradsegStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, featSymplnStm))
    {
      adjustLevels(&dmisFreeStatementSubs_featSymplnStm, "featSymplnStm");
      if (log && !findString("featSymplnStm", dmisFreeStatementSubs))
	{
	  warnSub("featSymplnStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_featSymplnStm(
	    dynamic_cast<featSymplnStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_featSymplnStm(
	  dynamic_cast<featSymplnStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, featTorradsegStm))
    {
      adjustLevels(&dmisFreeStatementSubs_featTorradsegStm,
		   "featTorradsegStm");
      if (log && !findString("featTorradsegStm", dmisFreeStatementSubs))
	{
	  warnSub("featTorradsegStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_featTorradsegStm(
	    dynamic_cast<featTorradsegStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_featTorradsegStm(
	  dynamic_cast<featTorradsegStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, featTorusStm))
    {
      adjustLevels(&dmisFreeStatementSubs_featTorusStm, "featTorusStm");
      if (log && !findString("featTorusStm", dmisFreeStatementSubs))
	{
	  warnSub("featTorusStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_featTorusStm(
	    dynamic_cast<featTorusStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_featTorusStm(
	  dynamic_cast<featTorusStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, fedratStm))
    {
      adjustLevels(&dmisFreeStatementSubs_fedratStm, "fedratStm");
      if (log && !findString("fedratStm", dmisFreeStatementSubs))
	{
	  warnSub("fedratStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_fedratStm(
	    dynamic_cast<fedratStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_fedratStm(
	  dynamic_cast<fedratStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, fildefStm))
    {
      adjustLevels(&dmisFreeStatementSubs_fildefStm, "fildefStm");
      if (log && !findString("fildefStm", dmisFreeStatementSubs))
	{
	  warnSub("fildefStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_fildefStm(
	    dynamic_cast<fildefStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_fildefStm(
	  dynamic_cast<fildefStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, filnamStm))
    {
      adjustLevels(&dmisFreeStatementSubs_filnamStm, "filnamStm");
      if (log && !findString("filnamStm", dmisFreeStatementSubs))
	{
	  warnSub("filnamStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_filnamStm(
	    dynamic_cast<filnamStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_filnamStm(
	  dynamic_cast<filnamStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, finposStm))
    {
      adjustLevels(&dmisFreeStatementSubs_finposStm, "finposStm");
      if (log && !findString("finposStm", dmisFreeStatementSubs))
	{
	  warnSub("finposStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_finposStm(
	    dynamic_cast<finposStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_finposStm(
	  dynamic_cast<finposStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, fixtidStm))
    {
      adjustLevels(&dmisFreeStatementSubs_fixtidStm, "fixtidStm");
      if (log && !findString("fixtidStm", dmisFreeStatementSubs))
	{
	  warnSub("fixtidStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_fixtidStm(
	    dynamic_cast<fixtidStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_fixtidStm(
	  dynamic_cast<fixtidStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, fixtsnStm))
    {
      adjustLevels(&dmisFreeStatementSubs_fixtsnStm, "fixtsnStm");
      if (log && !findString("fixtsnStm", dmisFreeStatementSubs))
	{
	  warnSub("fixtsnStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_fixtsnStm(
	    dynamic_cast<fixtsnStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_fixtsnStm(
	  dynamic_cast<fixtsnStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, flyStm))
    {
      adjustLevels(&dmisFreeStatementSubs_flyStm, "flyStm");
      if (log && !findString("flyStm", dmisFreeStatementSubs))
	{
	  warnSub("flyStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_flyStm(dynamic_cast<flyStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_flyStm(dynamic_cast<flyStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, fromStm))
    {
      adjustLevels(&dmisFreeStatementSubs_fromStm, "fromStm");
      if (log && !findString("fromStm", dmisFreeStatementSubs))
	{
	  warnSub("fromStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_fromStm(dynamic_cast<fromStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_fromStm(dynamic_cast<fromStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, geoalgStm))
    {
      adjustLevels(&dmisFreeStatementSubs_geoalgStm, "geoalgStm");
      if (log && !findString("geoalgStm", dmisFreeStatementSubs))
	{
	  warnSub("geoalgStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_geoalgStm(
	    dynamic_cast<geoalgStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_geoalgStm(
	  dynamic_cast<geoalgStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, geomStm))
    {
      adjustLevels(&dmisFreeStatementSubs_geomStm, "geomStm");
      if (log && !findString("geomStm", dmisFreeStatementSubs))
	{
	  warnSub("geomStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_geomStm(dynamic_cast<geomStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_geomStm(dynamic_cast<geomStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, gohomeStm))
    {
      adjustLevels(&dmisFreeStatementSubs_gohomeStm, "gohomeStm");
      if (log && !findString("gohomeStm", dmisFreeStatementSubs))
	{
	  warnSub("gohomeStm", "dmisFreeStatement", a_dmisFreeStatement);
	}
      return;
    }
  if (isA(a_dmisFreeStatement, gotoStm))
    {
      adjustLevels(&dmisFreeStatementSubs_gotoStm, "gotoStm");
      if (log && !findString("gotoStm", dmisFreeStatementSubs))
	{
	  warnSub("gotoStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_gotoStm(dynamic_cast<gotoStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_gotoStm(dynamic_cast<gotoStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, groupStm))
    {
      adjustLevels(&dmisFreeStatementSubs_groupStm, "groupStm");
      if (log && !findString("groupStm", dmisFreeStatementSubs))
	{
	  warnSub("groupStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_groupStm(dynamic_cast<groupStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_groupStm(dynamic_cast<groupStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, includStm))
    {
      adjustLevels(&dmisFreeStatementSubs_includStm, "includStm");
      if (log && !findString("includStm", dmisFreeStatementSubs))
	{
	  warnSub("includStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_includStm(
	    dynamic_cast<includStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_includStm(
	  dynamic_cast<includStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, iteratStm))
    {
      adjustLevels(&dmisFreeStatementSubs_iteratStm, "iteratStm");
      if (log && !findString("iteratStm", dmisFreeStatementSubs))
	{
	  warnSub("iteratStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_iteratStm(
	    dynamic_cast<iteratStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_iteratStm(
	  dynamic_cast<iteratStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, jumptoStm))
    {
      adjustLevels(&dmisFreeStatementSubs_jumptoStm, "jumptoStm");
      if (log && !findString("jumptoStm", dmisFreeStatementSubs))
	{
	  warnSub("jumptoStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_jumptoStm(
	    dynamic_cast<jumptoStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_jumptoStm(
	  dynamic_cast<jumptoStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, keycharStm))
    {
      adjustLevels(&dmisFreeStatementSubs_keycharStm, "keycharStm");
      if (log && !findString("keycharStm", dmisFreeStatementSubs))
	{
	  warnSub("keycharStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_keycharStm(
	    dynamic_cast<keycharStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_keycharStm(
	  dynamic_cast<keycharStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, litdefStm))
    {
      adjustLevels(&dmisFreeStatementSubs_litdefStm, "litdefStm");
      if (log && !findString("litdefStm", dmisFreeStatementSubs))
	{
	  warnSub("litdefStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_litdefStm(
	    dynamic_cast<litdefStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_litdefStm(
	  dynamic_cast<litdefStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, locateStm))
    {
      adjustLevels(&dmisFreeStatementSubs_locateStm, "locateStm");
      if (log && !findString("locateStm", dmisFreeStatementSubs))
	{
	  warnSub("locateStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_locateStm(
	    dynamic_cast<locateStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_locateStm(
	  dynamic_cast<locateStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, lotidStm))
    {
      adjustLevels(&dmisFreeStatementSubs_lotidStm, "lotidStm");
      if (log && !findString("lotidStm", dmisFreeStatementSubs))
	{
	  warnSub("lotidStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_lotidStm(dynamic_cast<lotidStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_lotidStm(dynamic_cast<lotidStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, matdefStm))
    {
      adjustLevels(&dmisFreeStatementSubs_matdefStm, "matdefStm");
      if (log && !findString("matdefStm", dmisFreeStatementSubs))
	{
	  warnSub("matdefStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_matdefStm(
	    dynamic_cast<matdefStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_matdefStm(
	  dynamic_cast<matdefStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, mfgdevStm))
    {
      adjustLevels(&dmisFreeStatementSubs_mfgdevStm, "mfgdevStm");
      if (log && !findString("mfgdevStm", dmisFreeStatementSubs))
	{
	  warnSub("mfgdevStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_mfgdevStm(
	    dynamic_cast<mfgdevStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_mfgdevStm(
	  dynamic_cast<mfgdevStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, modeStm))
    {
      adjustLevels(&dmisFreeStatementSubs_modeStm, "modeStm");
      if (log && !findString("modeStm", dmisFreeStatementSubs))
	{
	  warnSub("modeStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_modeStm(dynamic_cast<modeStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_modeStm(dynamic_cast<modeStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, obtainStm))
    {
      adjustLevels(&dmisFreeStatementSubs_obtainStm, "obtainStm");
      if (log && !findString("obtainStm", dmisFreeStatementSubs))
	{
	  warnSub("obtainStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_obtainStm(
	    dynamic_cast<obtainStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_obtainStm(
	  dynamic_cast<obtainStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, openStm))
    {
      adjustLevels(&dmisFreeStatementSubs_openStm, "openStm");
      if (log && !findString("openStm", dmisFreeStatementSubs))
	{
	  warnSub("openStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_openStm(dynamic_cast<openStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_openStm(dynamic_cast<openStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, operidStm))
    {
      adjustLevels(&dmisFreeStatementSubs_operidStm, "operidStm");
      if (log && !findString("operidStm", dmisFreeStatementSubs))
	{
	  warnSub("operidStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_operidStm(
	    dynamic_cast<operidStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_operidStm(
	  dynamic_cast<operidStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, outputStm))
    {
      adjustLevels(&dmisFreeStatementSubs_outputStm, "outputStm");
      if (log && !findString("outputStm", dmisFreeStatementSubs))
	{
	  warnSub("outputStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_outputStm(
	    dynamic_cast<outputStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_outputStm(
	  dynamic_cast<outputStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, pameasStm))
    {
      adjustLevels(&dmisFreeStatementSubs_pameasStm, "pameasStm");
      if (log && !findString("pameasStm", dmisFreeStatementSubs))
	{
	  warnSub("pameasStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_pameasStm(
	    dynamic_cast<pameasStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_pameasStm(
	  dynamic_cast<pameasStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, partidStm))
    {
      adjustLevels(&dmisFreeStatementSubs_partidStm, "partidStm");
      if (log && !findString("partidStm", dmisFreeStatementSubs))
	{
	  warnSub("partidStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_partidStm(
	    dynamic_cast<partidStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_partidStm(
	  dynamic_cast<partidStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, partrvStm))
    {
      adjustLevels(&dmisFreeStatementSubs_partrvStm, "partrvStm");
      if (log && !findString("partrvStm", dmisFreeStatementSubs))
	{
	  warnSub("partrvStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_partrvStm(
	    dynamic_cast<partrvStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_partrvStm(
	  dynamic_cast<partrvStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, partsnStm))
    {
      adjustLevels(&dmisFreeStatementSubs_partsnStm, "partsnStm");
      if (log && !findString("partsnStm", dmisFreeStatementSubs))
	{
	  warnSub("partsnStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_partsnStm(
	    dynamic_cast<partsnStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_partsnStm(
	  dynamic_cast<partsnStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, pathStm))
    {
      adjustLevels(&dmisFreeStatementSubs_pathStm, "pathStm");
      if (log && !findString("pathStm", dmisFreeStatementSubs))
	{
	  warnSub("pathStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_pathStm(dynamic_cast<pathStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_pathStm(dynamic_cast<pathStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, planidStm))
    {
      adjustLevels(&dmisFreeStatementSubs_planidStm, "planidStm");
      if (log && !findString("planidStm", dmisFreeStatementSubs))
	{
	  warnSub("planidStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_planidStm(
	    dynamic_cast<planidStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_planidStm(
	  dynamic_cast<planidStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, popStm))
    {
      adjustLevels(&dmisFreeStatementSubs_popStm, "popStm");
      if (log && !findString("popStm", dmisFreeStatementSubs))
	{
	  warnSub("popStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_popStm(dynamic_cast<popStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_popStm(dynamic_cast<popStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, prcompStm))
    {
      adjustLevels(&dmisFreeStatementSubs_prcompStm, "prcompStm");
      if (log && !findString("prcompStm", dmisFreeStatementSubs))
	{
	  warnSub("prcompStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_prcompStm(
	    dynamic_cast<prcompStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_prcompStm(
	  dynamic_cast<prcompStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, prevopStm))
    {
      adjustLevels(&dmisFreeStatementSubs_prevopStm, "prevopStm");
      if (log && !findString("prevopStm", dmisFreeStatementSubs))
	{
	  warnSub("prevopStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_prevopStm(
	    dynamic_cast<prevopStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_prevopStm(
	  dynamic_cast<prevopStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, procidStm))
    {
      adjustLevels(&dmisFreeStatementSubs_procidStm, "procidStm");
      if (log && !findString("procidStm", dmisFreeStatementSubs))
	{
	  warnSub("procidStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_procidStm(
	    dynamic_cast<procidStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_procidStm(
	  dynamic_cast<procidStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, promptStm))
    {
      adjustLevels(&dmisFreeStatementSubs_promptStm, "promptStm");
      if (log && !findString("promptStm", dmisFreeStatementSubs))
	{
	  warnSub("promptStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_promptStm(
	    dynamic_cast<promptStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_promptStm(
	  dynamic_cast<promptStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, psthruStm))
    {
      adjustLevels(&dmisFreeStatementSubs_psthruStm, "psthruStm");
      if (log && !findString("psthruStm", dmisFreeStatementSubs))
	{
	  warnSub("psthruStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_psthruStm(
	    dynamic_cast<psthruStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_psthruStm(
	  dynamic_cast<psthruStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, ptbuffStm))
    {
      adjustLevels(&dmisFreeStatementSubs_ptbuffStm, "ptbuffStm");
      if (log && !findString("ptbuffStm", dmisFreeStatementSubs))
	{
	  warnSub("ptbuffStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_ptbuffStm(
	    dynamic_cast<ptbuffStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_ptbuffStm(
	  dynamic_cast<ptbuffStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, ptmeasStm))
    {
      adjustLevels(&dmisFreeStatementSubs_ptmeasStm, "ptmeasStm");
      if (log && !findString("ptmeasStm", dmisFreeStatementSubs))
	{
	  warnSub("ptmeasStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_ptmeasStm(
	    dynamic_cast<ptmeasStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_ptmeasStm(
	  dynamic_cast<ptmeasStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, pushStm))
    {
      adjustLevels(&dmisFreeStatementSubs_pushStm, "pushStm");
      if (log && !findString("pushStm", dmisFreeStatementSubs))
	{
	  warnSub("pushStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_pushStm(dynamic_cast<pushStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_pushStm(dynamic_cast<pushStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, qisdefStm))
    {
      adjustLevels(&dmisFreeStatementSubs_qisdefStm, "qisdefStm");
      if (log && !findString("qisdefStm", dmisFreeStatementSubs))
	{
	  warnSub("qisdefStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_qisdefStm(
	    dynamic_cast<qisdefStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_qisdefStm(
	  dynamic_cast<qisdefStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, rapidStm))
    {
      adjustLevels(&dmisFreeStatementSubs_rapidStm, "rapidStm");
      if (log && !findString("rapidStm", dmisFreeStatementSubs))
	{
	  warnSub("rapidStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_rapidStm(dynamic_cast<rapidStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_rapidStm(dynamic_cast<rapidStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, readStm))
    {
      adjustLevels(&dmisFreeStatementSubs_readStm, "readStm");
      if (log && !findString("readStm", dmisFreeStatementSubs))
	{
	  warnSub("readStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_readStm(dynamic_cast<readStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_readStm(dynamic_cast<readStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, recallDatumStm))
    {
      adjustLevels(&dmisFreeStatementSubs_recallDatumStm, "recallDatumStm");
      if (log && !findString("recallDatumStm", dmisFreeStatementSubs))
	{
	  warnSub("recallDatumStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_recallDatumStm(
	    dynamic_cast<recallDatumStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_recallDatumStm(
	  dynamic_cast<recallDatumStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, recallDMLStm))
    {
      adjustLevels(&dmisFreeStatementSubs_recallDMLStm, "recallDMLStm");
      if (log && !findString("recallDMLStm", dmisFreeStatementSubs))
	{
	  warnSub("recallDMLStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_recallDMLStm(
	    dynamic_cast<recallDMLStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_recallDMLStm(
	  dynamic_cast<recallDMLStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, recallFeatureStm))
    {
      adjustLevels(&dmisFreeStatementSubs_recallFeatureStm,
		   "recallFeatureStm");
      if (log && !findString("recallFeatureStm", dmisFreeStatementSubs))
	{
	  warnSub("recallFeatureStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_recallFeatureStm(
	    dynamic_cast<recallFeatureStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_recallFeatureStm(
	  dynamic_cast<recallFeatureStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, recallRotaryTableStm))
    {
      adjustLevels(&dmisFreeStatementSubs_recallRotaryTableStm,
		   "recallRotaryTableStm");
      if (log && !findString("recallRotaryTableStm", dmisFreeStatementSubs))
	{
	  warnSub("recallRotaryTableStm", "dmisFreeStatement",
		  a_dmisFreeStatement);
	  check_recallRotaryTableStm(
	    dynamic_cast<recallRotaryTableStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_recallRotaryTableStm(
	  dynamic_cast<recallRotaryTableStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, recallSensorStm))
    {
      adjustLevels(&dmisFreeStatementSubs_recallSensorStm, "recallSensorStm");
      if (log && !findString("recallSensorStm", dmisFreeStatementSubs))
	{
	  warnSub("recallSensorStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_recallSensorStm(
	    dynamic_cast<recallSensorStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_recallSensorStm(
	  dynamic_cast<recallSensorStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, refmntStm))
    {
      adjustLevels(&dmisFreeStatementSubs_refmntStm, "refmntStm");
      if (log && !findString("refmntStm", dmisFreeStatementSubs))
	{
	  warnSub("refmntStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_refmntStm(
	    dynamic_cast<refmntStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_refmntStm(
	  dynamic_cast<refmntStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, reportStm))
    {
      adjustLevels(&dmisFreeStatementSubs_reportStm, "reportStm");
      if (log && !findString("reportStm", dmisFreeStatementSubs))
	{
	  warnSub("reportStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_reportStm(
	    dynamic_cast<reportStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_reportStm(
	  dynamic_cast<reportStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, resumeStm))
    {
      adjustLevels(&dmisFreeStatementSubs_resumeStm, "resumeStm");
      if (log && !findString("resumeStm", dmisFreeStatementSubs))
	{
	  warnSub("resumeStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_resumeStm(
	    dynamic_cast<resumeStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_resumeStm(
	  dynamic_cast<resumeStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, rotabStm))
    {
      adjustLevels(&dmisFreeStatementSubs_rotabStm, "rotabStm");
      if (log && !findString("rotabStm", dmisFreeStatementSubs))
	{
	  warnSub("rotabStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_rotabStm(dynamic_cast<rotabStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_rotabStm(dynamic_cast<rotabStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, rotateStm))
    {
      adjustLevels(&dmisFreeStatementSubs_rotateStm, "rotateStm");
      if (log && !findString("rotateStm", dmisFreeStatementSubs))
	{
	  warnSub("rotateStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_rotateStm(
	    dynamic_cast<rotateStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_rotateStm(
	  dynamic_cast<rotateStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, rotdefStm))
    {
      adjustLevels(&dmisFreeStatementSubs_rotdefStm, "rotdefStm");
      if (log && !findString("rotdefStm", dmisFreeStatementSubs))
	{
	  warnSub("rotdefStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_rotdefStm(
	    dynamic_cast<rotdefStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_rotdefStm(
	  dynamic_cast<rotdefStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, rotsetStm))
    {
      adjustLevels(&dmisFreeStatementSubs_rotsetStm, "rotsetStm");
      if (log && !findString("rotsetStm", dmisFreeStatementSubs))
	{
	  warnSub("rotsetStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_rotsetStm(
	    dynamic_cast<rotsetStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_rotsetStm(
	  dynamic_cast<rotsetStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, saveDatumStm))
    {
      adjustLevels(&dmisFreeStatementSubs_saveDatumStm, "saveDatumStm");
      if (log && !findString("saveDatumStm", dmisFreeStatementSubs))
	{
	  warnSub("saveDatumStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_saveDatumStm(
	    dynamic_cast<saveDatumStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_saveDatumStm(
	  dynamic_cast<saveDatumStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, saveDMLStm))
    {
      adjustLevels(&dmisFreeStatementSubs_saveDMLStm, "saveDMLStm");
      if (log && !findString("saveDMLStm", dmisFreeStatementSubs))
	{
	  warnSub("saveDMLStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_saveDMLStm(
	    dynamic_cast<saveDMLStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_saveDMLStm(
	  dynamic_cast<saveDMLStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, saveFeatureStm))
    {
      adjustLevels(&dmisFreeStatementSubs_saveFeatureStm, "saveFeatureStm");
      if (log && !findString("saveFeatureStm", dmisFreeStatementSubs))
	{
	  warnSub("saveFeatureStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_saveFeatureStm(
	    dynamic_cast<saveFeatureStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_saveFeatureStm(
	  dynamic_cast<saveFeatureStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, saveRotaryTableStm))
    {
      adjustLevels(&dmisFreeStatementSubs_saveRotaryTableStm,
		   "saveRotaryTableStm");
      if (log && !findString("saveRotaryTableStm", dmisFreeStatementSubs))
	{
	  warnSub("saveRotaryTableStm", "dmisFreeStatement",
		  a_dmisFreeStatement);
	  check_saveRotaryTableStm(
	    dynamic_cast<saveRotaryTableStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_saveRotaryTableStm(
	  dynamic_cast<saveRotaryTableStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, saveSensorStm))
    {
      adjustLevels(&dmisFreeStatementSubs_saveSensorStm, "saveSensorStm");
      if (log && !findString("saveSensorStm", dmisFreeStatementSubs))
	{
	  warnSub("saveSensorStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_saveSensorStm(
	    dynamic_cast<saveSensorStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_saveSensorStm(
	  dynamic_cast<saveSensorStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, scnmodStm))
    {
      adjustLevels(&dmisFreeStatementSubs_scnmodStm, "scnmodStm");
      if (log && !findString("scnmodStm", dmisFreeStatementSubs))
	{
	  warnSub("scnmodStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_scnmodStm(
	    dynamic_cast<scnmodStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_scnmodStm(
	  dynamic_cast<scnmodStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, scnsetStm))
    {
      adjustLevels(&dmisFreeStatementSubs_scnsetStm, "scnsetStm");
      if (log && !findString("scnsetStm", dmisFreeStatementSubs))
	{
	  warnSub("scnsetStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_scnsetStm(
	    dynamic_cast<scnsetStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_scnsetStm(
	  dynamic_cast<scnsetStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, sensorStm))
    {
      adjustLevels(&dmisFreeStatementSubs_sensorStm, "sensorStm");
      if (log && !findString("sensorStm", dmisFreeStatementSubs))
	{
	  warnSub("sensorStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_sensorStm(
	    dynamic_cast<sensorStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_sensorStm(
	  dynamic_cast<sensorStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, snsdefStm))
    {
      adjustLevels(&dmisFreeStatementSubs_snsdefStm, "snsdefStm");
      if (log && !findString("snsdefStm", dmisFreeStatementSubs))
	{
	  warnSub("snsdefStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_snsdefStm(
	    dynamic_cast<snsdefStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_snsdefStm(
	  dynamic_cast<snsdefStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, snsetStm))
    {
      adjustLevels(&dmisFreeStatementSubs_snsetStm, "snsetStm");
      if (log && !findString("snsetStm", dmisFreeStatementSubs))
	{
	  warnSub("snsetStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_snsetStm(dynamic_cast<snsetStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_snsetStm(dynamic_cast<snsetStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, snsgrpStm))
    {
      adjustLevels(&dmisFreeStatementSubs_snsgrpStm, "snsgrpStm");
      if (log && !findString("snsgrpStm", dmisFreeStatementSubs))
	{
	  warnSub("snsgrpStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_snsgrpStm(
	    dynamic_cast<snsgrpStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_snsgrpStm(
	  dynamic_cast<snsgrpStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, snslctStm))
    {
      adjustLevels(&dmisFreeStatementSubs_snslctStm, "snslctStm");
      if (log && !findString("snslctStm", dmisFreeStatementSubs))
	{
	  warnSub("snslctStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_snslctStm(
	    dynamic_cast<snslctStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_snslctStm(
	  dynamic_cast<snslctStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, snsmntStm))
    {
      adjustLevels(&dmisFreeStatementSubs_snsmntStm, "snsmntStm");
      if (log && !findString("snsmntStm", dmisFreeStatementSubs))
	{
	  warnSub("snsmntStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_snsmntStm(
	    dynamic_cast<snsmntStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_snsmntStm(
	  dynamic_cast<snsmntStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, tecompStm))
    {
      adjustLevels(&dmisFreeStatementSubs_tecompStm, "tecompStm");
      if (log && !findString("tecompStm", dmisFreeStatementSubs))
	{
	  warnSub("tecompStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_tecompStm(
	    dynamic_cast<tecompStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_tecompStm(
	  dynamic_cast<tecompStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, textStm))
    {
      adjustLevels(&dmisFreeStatementSubs_textStm, "textStm");
      if (log && !findString("textStm", dmisFreeStatementSubs))
	{
	  warnSub("textStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_textStm(dynamic_cast<textStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_textStm(dynamic_cast<textStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, thldefStm))
    {
      adjustLevels(&dmisFreeStatementSubs_thldefStm, "thldefStm");
      if (log && !findString("thldefStm", dmisFreeStatementSubs))
	{
	  warnSub("thldefStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_thldefStm(
	    dynamic_cast<thldefStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_thldefStm(
	  dynamic_cast<thldefStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, tolAnglStm))
    {
      adjustLevels(&dmisFreeStatementSubs_tolAnglStm, "tolAnglStm");
      if (log && !findString("tolAnglStm", dmisFreeStatementSubs))
	{
	  warnSub("tolAnglStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_tolAnglStm(
	    dynamic_cast<tolAnglStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_tolAnglStm(
	  dynamic_cast<tolAnglStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, tolAnglbStm))
    {
      adjustLevels(&dmisFreeStatementSubs_tolAnglbStm, "tolAnglbStm");
      if (log && !findString("tolAnglbStm", dmisFreeStatementSubs))
	{
	  warnSub("tolAnglbStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_tolAnglbStm(
	    dynamic_cast<tolAnglbStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_tolAnglbStm(
	  dynamic_cast<tolAnglbStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, tolAnglrStm))
    {
      adjustLevels(&dmisFreeStatementSubs_tolAnglrStm, "tolAnglrStm");
      if (log && !findString("tolAnglrStm", dmisFreeStatementSubs))
	{
	  warnSub("tolAnglrStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_tolAnglrStm(
	    dynamic_cast<tolAnglrStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_tolAnglrStm(
	  dynamic_cast<tolAnglrStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, tolAnglwrtStm))
    {
      adjustLevels(&dmisFreeStatementSubs_tolAnglwrtStm, "tolAnglwrtStm");
      if (log && !findString("tolAnglwrtStm", dmisFreeStatementSubs))
	{
	  warnSub("tolAnglwrtStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_tolAnglwrtStm(
	    dynamic_cast<tolAnglwrtStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_tolAnglwrtStm(
	  dynamic_cast<tolAnglwrtStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, tolCirltyStm))
    {
      adjustLevels(&dmisFreeStatementSubs_tolCirltyStm, "tolCirltyStm");
      if (log && !findString("tolCirltyStm", dmisFreeStatementSubs))
	{
	  warnSub("tolCirltyStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_tolCirltyStm(
	    dynamic_cast<tolCirltyStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_tolCirltyStm(
	  dynamic_cast<tolCirltyStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, tolComposStm))
    {
      adjustLevels(&dmisFreeStatementSubs_tolComposStm, "tolComposStm");
      if (log && !findString("tolComposStm", dmisFreeStatementSubs))
	{
	  warnSub("tolComposStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_tolComposStm(
	    dynamic_cast<tolComposStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_tolComposStm(
	  dynamic_cast<tolComposStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, tolConcenStm))
    {
      adjustLevels(&dmisFreeStatementSubs_tolConcenStm, "tolConcenStm");
      if (log && !findString("tolConcenStm", dmisFreeStatementSubs))
	{
	  warnSub("tolConcenStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_tolConcenStm(
	    dynamic_cast<tolConcenStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_tolConcenStm(
	  dynamic_cast<tolConcenStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, tolCortolStm))
    {
      adjustLevels(&dmisFreeStatementSubs_tolCortolStm, "tolCortolStm");
      if (log && !findString("tolCortolStm", dmisFreeStatementSubs))
	{
	  warnSub("tolCortolStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_tolCortolStm(
	    dynamic_cast<tolCortolStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_tolCortolStm(
	  dynamic_cast<tolCortolStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, tolCproflStm))
    {
      adjustLevels(&dmisFreeStatementSubs_tolCproflStm, "tolCproflStm");
      if (log && !findString("tolCproflStm", dmisFreeStatementSubs))
	{
	  warnSub("tolCproflStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_tolCproflStm(
	    dynamic_cast<tolCproflStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_tolCproflStm(
	  dynamic_cast<tolCproflStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, tolCprofsStm))
    {
      adjustLevels(&dmisFreeStatementSubs_tolCprofsStm, "tolCprofsStm");
      if (log && !findString("tolCprofsStm", dmisFreeStatementSubs))
	{
	  warnSub("tolCprofsStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_tolCprofsStm(
	    dynamic_cast<tolCprofsStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_tolCprofsStm(
	  dynamic_cast<tolCprofsStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, tolCrnoutStm))
    {
      adjustLevels(&dmisFreeStatementSubs_tolCrnoutStm, "tolCrnoutStm");
      if (log && !findString("tolCrnoutStm", dmisFreeStatementSubs))
	{
	  warnSub("tolCrnoutStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_tolCrnoutStm(
	    dynamic_cast<tolCrnoutStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_tolCrnoutStm(
	  dynamic_cast<tolCrnoutStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, tolCylctyStm))
    {
      adjustLevels(&dmisFreeStatementSubs_tolCylctyStm, "tolCylctyStm");
      if (log && !findString("tolCylctyStm", dmisFreeStatementSubs))
	{
	  warnSub("tolCylctyStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_tolCylctyStm(
	    dynamic_cast<tolCylctyStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_tolCylctyStm(
	  dynamic_cast<tolCylctyStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, tolDiamStm))
    {
      adjustLevels(&dmisFreeStatementSubs_tolDiamStm, "tolDiamStm");
      if (log && !findString("tolDiamStm", dmisFreeStatementSubs))
	{
	  warnSub("tolDiamStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_tolDiamStm(
	    dynamic_cast<tolDiamStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_tolDiamStm(
	  dynamic_cast<tolDiamStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, tolDistbStm))
    {
      adjustLevels(&dmisFreeStatementSubs_tolDistbStm, "tolDistbStm");
      if (log && !findString("tolDistbStm", dmisFreeStatementSubs))
	{
	  warnSub("tolDistbStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_tolDistbStm(
	    dynamic_cast<tolDistbStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_tolDistbStm(
	  dynamic_cast<tolDistbStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, tolDistwrtStm))
    {
      adjustLevels(&dmisFreeStatementSubs_tolDistwrtStm, "tolDistwrtStm");
      if (log && !findString("tolDistwrtStm", dmisFreeStatementSubs))
	{
	  warnSub("tolDistwrtStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_tolDistwrtStm(
	    dynamic_cast<tolDistwrtStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_tolDistwrtStm(
	  dynamic_cast<tolDistwrtStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, tolFlatStm))
    {
      adjustLevels(&dmisFreeStatementSubs_tolFlatStm, "tolFlatStm");
      if (log && !findString("tolFlatStm", dmisFreeStatementSubs))
	{
	  warnSub("tolFlatStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_tolFlatStm(
	    dynamic_cast<tolFlatStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_tolFlatStm(
	  dynamic_cast<tolFlatStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, tolGtolStm))
    {
      adjustLevels(&dmisFreeStatementSubs_tolGtolStm, "tolGtolStm");
      if (log && !findString("tolGtolStm", dmisFreeStatementSubs))
	{
	  warnSub("tolGtolStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_tolGtolStm(
	    dynamic_cast<tolGtolStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_tolGtolStm(
	  dynamic_cast<tolGtolStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, tolParlelStm))
    {
      adjustLevels(&dmisFreeStatementSubs_tolParlelStm, "tolParlelStm");
      if (log && !findString("tolParlelStm", dmisFreeStatementSubs))
	{
	  warnSub("tolParlelStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_tolParlelStm(
	    dynamic_cast<tolParlelStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_tolParlelStm(
	  dynamic_cast<tolParlelStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, tolPerpStm))
    {
      adjustLevels(&dmisFreeStatementSubs_tolPerpStm, "tolPerpStm");
      if (log && !findString("tolPerpStm", dmisFreeStatementSubs))
	{
	  warnSub("tolPerpStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_tolPerpStm(
	    dynamic_cast<tolPerpStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_tolPerpStm(
	  dynamic_cast<tolPerpStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, tolPosStm))
    {
      adjustLevels(&dmisFreeStatementSubs_tolPosStm, "tolPosStm");
      if (log && !findString("tolPosStm", dmisFreeStatementSubs))
	{
	  warnSub("tolPosStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_tolPosStm(
	    dynamic_cast<tolPosStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_tolPosStm(
	  dynamic_cast<tolPosStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, tolProflStm))
    {
      adjustLevels(&dmisFreeStatementSubs_tolProflStm, "tolProflStm");
      if (log && !findString("tolProflStm", dmisFreeStatementSubs))
	{
	  warnSub("tolProflStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_tolProflStm(
	    dynamic_cast<tolProflStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_tolProflStm(
	  dynamic_cast<tolProflStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, tolProfpStm))
    {
      adjustLevels(&dmisFreeStatementSubs_tolProfpStm, "tolProfpStm");
      if (log && !findString("tolProfpStm", dmisFreeStatementSubs))
	{
	  warnSub("tolProfpStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_tolProfpStm(
	    dynamic_cast<tolProfpStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_tolProfpStm(
	  dynamic_cast<tolProfpStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, tolProfsStm))
    {
      adjustLevels(&dmisFreeStatementSubs_tolProfsStm, "tolProfsStm");
      if (log && !findString("tolProfsStm", dmisFreeStatementSubs))
	{
	  warnSub("tolProfsStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_tolProfsStm(
	    dynamic_cast<tolProfsStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_tolProfsStm(
	  dynamic_cast<tolProfsStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, tolRadStm))
    {
      adjustLevels(&dmisFreeStatementSubs_tolRadStm, "tolRadStm");
      if (log && !findString("tolRadStm", dmisFreeStatementSubs))
	{
	  warnSub("tolRadStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_tolRadStm(
	    dynamic_cast<tolRadStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_tolRadStm(
	  dynamic_cast<tolRadStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, tolStrghtStm))
    {
      adjustLevels(&dmisFreeStatementSubs_tolStrghtStm, "tolStrghtStm");
      if (log && !findString("tolStrghtStm", dmisFreeStatementSubs))
	{
	  warnSub("tolStrghtStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_tolStrghtStm(
	    dynamic_cast<tolStrghtStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_tolStrghtStm(
	  dynamic_cast<tolStrghtStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, tolSymStm))
    {
      adjustLevels(&dmisFreeStatementSubs_tolSymStm, "tolSymStm");
      if (log && !findString("tolSymStm", dmisFreeStatementSubs))
	{
	  warnSub("tolSymStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_tolSymStm(
	    dynamic_cast<tolSymStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_tolSymStm(
	  dynamic_cast<tolSymStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, tolTrnoutStm))
    {
      adjustLevels(&dmisFreeStatementSubs_tolTrnoutStm, "tolTrnoutStm");
      if (log && !findString("tolTrnoutStm", dmisFreeStatementSubs))
	{
	  warnSub("tolTrnoutStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_tolTrnoutStm(
	    dynamic_cast<tolTrnoutStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_tolTrnoutStm(
	  dynamic_cast<tolTrnoutStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, tolUsetolStm))
    {
      adjustLevels(&dmisFreeStatementSubs_tolUsetolStm, "tolUsetolStm");
      if (log && !findString("tolUsetolStm", dmisFreeStatementSubs))
	{
	  warnSub("tolUsetolStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_tolUsetolStm(
	    dynamic_cast<tolUsetolStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_tolUsetolStm(
	  dynamic_cast<tolUsetolStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, tolWidthStm))
    {
      adjustLevels(&dmisFreeStatementSubs_tolWidthStm, "tolWidthStm");
      if (log && !findString("tolWidthStm", dmisFreeStatementSubs))
	{
	  warnSub("tolWidthStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_tolWidthStm(
	    dynamic_cast<tolWidthStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_tolWidthStm(
	  dynamic_cast<tolWidthStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, tooldfStm))
    {
      adjustLevels(&dmisFreeStatementSubs_tooldfStm, "tooldfStm");
      if (log && !findString("tooldfStm", dmisFreeStatementSubs))
	{
	  warnSub("tooldfStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_tooldfStm(
	    dynamic_cast<tooldfStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_tooldfStm(
	  dynamic_cast<tooldfStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, transStm))
    {
      adjustLevels(&dmisFreeStatementSubs_transStm, "transStm");
      if (log && !findString("transStm", dmisFreeStatementSubs))
	{
	  warnSub("transStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_transStm(dynamic_cast<transStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_transStm(dynamic_cast<transStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, uncertalgStm))
    {
      adjustLevels(&dmisFreeStatementSubs_uncertalgStm, "uncertalgStm");
      if (log && !findString("uncertalgStm", dmisFreeStatementSubs))
	{
	  warnSub("uncertalgStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_uncertalgStm(
	    dynamic_cast<uncertalgStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_uncertalgStm(
	  dynamic_cast<uncertalgStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, uncertsetStm))
    {
      adjustLevels(&dmisFreeStatementSubs_uncertsetStm, "uncertsetStm");
      if (log && !findString("uncertsetStm", dmisFreeStatementSubs))
	{
	  warnSub("uncertsetStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_uncertsetStm(
	    dynamic_cast<uncertsetStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_uncertsetStm(
	  dynamic_cast<uncertsetStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, unitsStm))
    {
      adjustLevels(&dmisFreeStatementSubs_unitsStm, "unitsStm");
      if (log && !findString("unitsStm", dmisFreeStatementSubs))
	{
	  warnSub("unitsStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_unitsStm(dynamic_cast<unitsStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_unitsStm(dynamic_cast<unitsStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, valueStm))
    {
      adjustLevels(&dmisFreeStatementSubs_valueStm, "valueStm");
      if (log && !findString("valueStm", dmisFreeStatementSubs))
	{
	  warnSub("valueStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_valueStm(dynamic_cast<valueStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_valueStm(dynamic_cast<valueStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, vformStm))
    {
      adjustLevels(&dmisFreeStatementSubs_vformStm, "vformStm");
      if (log && !findString("vformStm", dmisFreeStatementSubs))
	{
	  warnSub("vformStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_vformStm(dynamic_cast<vformStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_vformStm(dynamic_cast<vformStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, windefStm))
    {
      adjustLevels(&dmisFreeStatementSubs_windefStm, "windefStm");
      if (log && !findString("windefStm", dmisFreeStatementSubs))
	{
	  warnSub("windefStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_windefStm(
	    dynamic_cast<windefStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_windefStm(
	  dynamic_cast<windefStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, wkplanStm))
    {
      adjustLevels(&dmisFreeStatementSubs_wkplanStm, "wkplanStm");
      if (log && !findString("wkplanStm", dmisFreeStatementSubs))
	{
	  warnSub("wkplanStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_wkplanStm(
	    dynamic_cast<wkplanStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_wkplanStm(
	  dynamic_cast<wkplanStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, wristStm))
    {
      adjustLevels(&dmisFreeStatementSubs_wristStm, "wristStm");
      if (log && !findString("wristStm", dmisFreeStatementSubs))
	{
	  warnSub("wristStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_wristStm(dynamic_cast<wristStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_wristStm(dynamic_cast<wristStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, writeStm))
    {
      adjustLevels(&dmisFreeStatementSubs_writeStm, "writeStm");
      if (log && !findString("writeStm", dmisFreeStatementSubs))
	{
	  warnSub("writeStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_writeStm(dynamic_cast<writeStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_writeStm(dynamic_cast<writeStm *>(a_dmisFreeStatement), log);
      return;
    }
  if (isA(a_dmisFreeStatement, xtractStm))
    {
      adjustLevels(&dmisFreeStatementSubs_xtractStm, "xtractStm");
      if (log && !findString("xtractStm", dmisFreeStatementSubs))
	{
	  warnSub("xtractStm", "dmisFreeStatement", a_dmisFreeStatement);
	  check_xtractStm(
	    dynamic_cast<xtractStm *>(a_dmisFreeStatement), 0);
	}
      else
	check_xtractStm(
	  dynamic_cast<xtractStm *>(a_dmisFreeStatement), log);
      return;
    }
}

/********************************************************************/

void check_dmisItem(
 dmisItem * a_dmisItem,
 int log)
{
  if (isA(a_dmisItem, dmisFreeStatement))
    {
      adjustLevels(&dmisItemSubs_dmisFreeStatement, "dmisFreeStatement");
      if (log && !findString("dmisFreeStatement", dmisItemSubs))
	{
	  warnSub("dmisFreeStatement", "dmisItem", a_dmisItem);
	  check_dmisFreeStatement(
	    dynamic_cast<dmisFreeStatement *>(a_dmisItem), 0);
	}
      else
	check_dmisFreeStatement(
	  dynamic_cast<dmisFreeStatement *>(a_dmisItem), log);
      return;
    }
  if (isA(a_dmisItem, dmisBlock))
    {
      adjustLevels(&dmisItemSubs_dmisBlock, "dmisBlock");
      if (log && !findString("dmisBlock", dmisItemSubs))
	{
	  warnSub("dmisBlock", "dmisItem", a_dmisItem);
	  check_dmisBlock(dynamic_cast<dmisBlock *>(a_dmisItem), 0);
	}
      else
	check_dmisBlock(dynamic_cast<dmisBlock *>(a_dmisItem), log);
      return;
    }
}

/********************************************************************/

void check_dmisOffBlock(
 dmisOffBlock * a_dmisOffBlock,
 int log)
{
  if (a_dmisOffBlock->get_dmisOffStm())
    {
      adjustLevels(&dmisOffBlockAtts_a_dmisOffStm,
		   "dmisOffBlock a_dmisOffStm");
      if (log && !findString("a_dmisOffStm", dmisOffBlockAtts))
	{
	  warnAttBlock("dmisOffStm", a_dmisOffBlock->get_dmisOffStm());
	}
    }
  if (a_dmisOffBlock->get_noParseStmList())
    {
      std::list<noParseStm *> * theList;
      std::list<noParseStm *>::iterator iter;
      theList = a_dmisOffBlock->get_noParseStmList();
      adjustLevels(&dmisOffBlockAtts_a_noParseStmList,
		   "dmisOffBlock a_noParseStmList");
      if (log && !findString("a_noParseStmList", dmisOffBlockAtts))
	{
	  warnAttBlock("noParseStmList",
	    a_dmisOffBlock->get_noParseStmList()->front());
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_noParseStm(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_noParseStm(*iter, log);
	}
    }
  if (a_dmisOffBlock->get_dmisOnStm())
    {
      adjustLevels(&dmisOffBlockAtts_a_dmisOnStm, "dmisOffBlock a_dmisOnStm");
      if (log && !findString("a_dmisOnStm", dmisOffBlockAtts))
	{
	  warnAttBlock("dmisOnStm", a_dmisOffBlock->get_dmisOnStm());
	}
    }
}

/********************************************************************/

void check_dmismdStm(
 dmismdStm * a_dmismdStm,
 int log)
{
  if (a_dmismdStm->get_stringConst())
    {
      adjustLevels(&dmismdStmAtts_a_stringConst, "dmismdStm a_stringConst");
      if (log && !findString("a_stringConst", dmismdStmAtts))
	{
	  warnAtt("a_stringConst", "dmismdStm", a_dmismdStm);
	  check_stringConst(a_dmismdStm->get_stringConst(), 0);
	}
      else
	check_stringConst(a_dmismdStm->get_stringConst(), log);
    }
  if (a_dmismdStm->get_versionTag())
    {
      adjustLevels(&dmismdStmAtts_a_versionTag, "dmismdStm a_versionTag");
      if (log && !findString("a_versionTag", dmismdStmAtts))
	{
	  warnAtt("a_versionTag", "dmismdStm", a_dmismdStm);
	  check_versionTag(a_dmismdStm->get_versionTag(), 0);
	}
      else
	check_versionTag(a_dmismdStm->get_versionTag(), log);
    }
  if (a_dmismdStm->get_conformItemList())
    {
      std::list<conformItem *> * theList;
      std::list<conformItem *>::iterator iter;
      theList = a_dmismdStm->get_conformItemList();
      adjustLevels(&dmismdStmAtts_a_conformItemList,
		   "dmismdStm a_conformItemList");
      if (log && !findString("a_conformItemList", dmismdStmAtts))
	{
	  warnAtt("a_conformItemList", "dmismdStm", a_dmismdStm);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_conformItem(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_conformItem(*iter, log);
	}
    }
}

/********************************************************************/

void check_dmismnStm(
 dmismnStm * a_dmismnStm,
 int log)
{
  if (a_dmismnStm->get_stringConst())
    {
      adjustLevels(&dmismnStmAtts_a_stringConst, "dmismnStm a_stringConst");
      if (log && !findString("a_stringConst", dmismnStmAtts))
	{
	  warnAtt("a_stringConst", "dmismnStm", a_dmismnStm);
	  check_stringConst(a_dmismnStm->get_stringConst(), 0);
	}
      else
	check_stringConst(a_dmismnStm->get_stringConst(), log);
    }
  if (a_dmismnStm->get_versionTag())
    {
      adjustLevels(&dmismnStmAtts_a_versionTag, "dmismnStm a_versionTag");
      if (log && !findString("a_versionTag", dmismnStmAtts))
	{
	  warnAtt("a_versionTag", "dmismnStm", a_dmismnStm);
	  check_versionTag(a_dmismnStm->get_versionTag(), 0);
	}
      else
	check_versionTag(a_dmismnStm->get_versionTag(), log);
    }
  if (a_dmismnStm->get_conformItemList())
    {
      std::list<conformItem *> * theList;
      std::list<conformItem *>::iterator iter;
      theList = a_dmismnStm->get_conformItemList();
      adjustLevels(&dmismnStmAtts_a_conformItemList,
		   "dmismnStm a_conformItemList");
      if (log && !findString("a_conformItemList", dmismnStmAtts))
	{
	  warnAtt("a_conformItemList", "dmismnStm", a_dmismnStm);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_conformItem(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_conformItem(*iter, log);
	}
    }
}

/********************************************************************/

void check_doBlock(
 doBlock * a_doBlock,
 int log)
{
  if (a_doBlock->get_doStm())
    {
      adjustLevels(&doBlockAtts_a_doStm, "doBlock a_doStm");
      if (log && !findString("a_doStm", doBlockAtts))
	{
	  warnAttBlock("doStm", a_doBlock->get_doStm());
	  check_doStm(a_doBlock->get_doStm(), 0);
	}
      else
	check_doStm(a_doBlock->get_doStm(), log);
    }
  if (a_doBlock->get_dmisItemList())
    {
      std::list<dmisItem *> * theList;
      std::list<dmisItem *>::iterator iter;
      theList = a_doBlock->get_dmisItemList();
      adjustLevels(&doBlockAtts_a_dmisItemList, "doBlock a_dmisItemList");
      if (log && !findString("a_dmisItemList", doBlockAtts))
	{
	  warnAttBlock("dmisItemList",
	    a_doBlock->get_dmisItemList()->front());
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_dmisItem(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_dmisItem(*iter, log);
	}
    }
  if (a_doBlock->get_enddoStm())
    {
      adjustLevels(&doBlockAtts_a_enddoStm, "doBlock a_enddoStm");
      if (log && !findString("a_enddoStm", doBlockAtts))
	{
	  warnAttBlock("enddoStm", a_doBlock->get_enddoStm());
	}
    }
}

/********************************************************************/

void check_doStm(
 doStm * a_doStm,
 int log)
{
  if (a_doStm->get_index())
    {
      adjustLevels(&doStmAtts_index, "doStm index");
      if (log && !findString("index", doStmAtts))
	{
	  warnAtt("index", "doStm", a_doStm);
	  check_intVar(a_doStm->get_index(), 0);
	}
      else
	check_intVar(a_doStm->get_index(), log);
    }
  if (a_doStm->get_init())
    {
      adjustLevels(&doStmAtts_init, "doStm init");
      if (log && !findString("init", doStmAtts))
	{
	  warnAtt("init", "doStm", a_doStm);
	  check_intVal(a_doStm->get_init(), 0);
	}
      else
	check_intVal(a_doStm->get_init(), log);
    }
  if (a_doStm->get_limit())
    {
      adjustLevels(&doStmAtts_limit, "doStm limit");
      if (log && !findString("limit", doStmAtts))
	{
	  warnAtt("limit", "doStm", a_doStm);
	  check_intVal(a_doStm->get_limit(), 0);
	}
      else
	check_intVal(a_doStm->get_limit(), log);
    }
  if (a_doStm->get_incr())
    {
      adjustLevels(&doStmAtts_incr, "doStm incr");
      if (log && !findString("incr", doStmAtts))
	{
	  warnAtt("incr", "doStm", a_doStm);
	  check_intVal(a_doStm->get_incr(), 0);
	}
      else
	check_intVal(a_doStm->get_incr(), log);
    }
}

/********************************************************************/

void check_drLabel(
 drLabel * a_drLabel,
 int log)
{
  if (a_drLabel->get_labelName())
    {
      adjustLevels(&drLabelAtts_a_labelName, "drLabel a_labelName");
      if (log && !findString("a_labelName", drLabelAtts))
	{
	  warnAtt("a_labelName", "drLabel", a_drLabel);
	  check_labelName(a_drLabel->get_labelName(), 0);
	}
      else
	check_labelName(a_drLabel->get_labelName(), log);
    }
}

/********************************************************************/

void check_dsLabel(
 dsLabel * a_dsLabel,
 int log)
{
  if (a_dsLabel->get_labelName())
    {
      adjustLevels(&dsLabelAtts_a_labelName, "dsLabel a_labelName");
      if (log && !findString("a_labelName", dsLabelAtts))
	{
	  warnAtt("a_labelName", "dsLabel", a_dsLabel);
	  check_labelName(a_dsLabel->get_labelName(), 0);
	}
      else
	check_labelName(a_dsLabel->get_labelName(), log);
    }
}

/********************************************************************/

void check_dvLabel(
 dvLabel * a_dvLabel,
 int log)
{
  if (a_dvLabel->get_labelName())
    {
      adjustLevels(&dvLabelAtts_a_labelName, "dvLabel a_labelName");
      if (log && !findString("a_labelName", dvLabelAtts))
	{
	  warnAtt("a_labelName", "dvLabel", a_dvLabel);
	  check_labelName(a_dvLabel->get_labelName(), 0);
	}
      else
	check_labelName(a_dvLabel->get_labelName(), log);
    }
}

/********************************************************************/

void check_equateCad(
 equateCad * a_equateCad,
 int log)
{
  if (a_equateCad->get_equateFrom())
    {
      adjustLevels(&equateCadAtts_equateFrom, "equateCad equateFrom");
      if (log && !findString("equateFrom", equateCadAtts))
	{
	  warnAtt("equateFrom", "equateCad", a_equateCad);
	  check_daLabel(a_equateCad->get_equateFrom(), 0);
	}
      else
	check_daLabel(a_equateCad->get_equateFrom(), log);
    }
  if (a_equateCad->get_equateCadcs())
    {
      adjustLevels(&equateCadAtts_a_equateCadcs, "equateCad a_equateCadcs");
      if (log && !findString("a_equateCadcs", equateCadAtts))
	{
	  warnAtt("a_equateCadcs", "equateCad", a_equateCad);
	  check_equateCadcs(a_equateCad->get_equateCadcs(), 0);
	}
      else
	check_equateCadcs(a_equateCad->get_equateCadcs(), log);
    }
}

/********************************************************************/

void check_equateCadcs(
 equateCadcs * a_equateCadcs,
 int log)
{
  if (isA(a_equateCadcs, equateCadcs_matrix))
    {
      adjustLevels(&equateCadcsSubs_equateCadcs_matrix, "equateCadcs_matrix");
      if (log && !findString("equateCadcs_matrix", equateCadcsSubs))
	{
	  warnSub("equateCadcs_matrix", "equateCadcs", a_equateCadcs);
	  check_equateCadcs_matrix(
	    dynamic_cast<equateCadcs_matrix *>(a_equateCadcs), 0);
	}
      else
	check_equateCadcs_matrix(
	  dynamic_cast<equateCadcs_matrix *>(a_equateCadcs), log);
      return;
    }
  if (isA(a_equateCadcs, equateCadcs_stringVal))
    {
      adjustLevels(&equateCadcsSubs_equateCadcs_stringVal,
		   "equateCadcs_stringVal");
      if (log && !findString("equateCadcs_stringVal", equateCadcsSubs))
	{
	  warnSub("equateCadcs_stringVal", "equateCadcs", a_equateCadcs);
	  check_equateCadcs_stringVal(
	    dynamic_cast<equateCadcs_stringVal *>(a_equateCadcs), 0);
	}
      else
	check_equateCadcs_stringVal(
	  dynamic_cast<equateCadcs_stringVal *>(a_equateCadcs), log);
      return;
    }
}

/********************************************************************/

void check_equateCadcs_matrix(
 equateCadcs_matrix * a_equateCadcs_matrix,
 int log)
{
  if (a_equateCadcs_matrix->get_didLabel())
    {
      adjustLevels(&equateCadcs_matrixAtts_a_didLabel,
		   "equateCadcs_matrix a_didLabel");
      if (log && !findString("a_didLabel", equateCadcs_matrixAtts))
	{
	  warnAtt("a_didLabel", "equateCadcs_matrix", a_equateCadcs_matrix);
	  check_didLabel(a_equateCadcs_matrix->get_didLabel(), 0);
	}
      else
	check_didLabel(a_equateCadcs_matrix->get_didLabel(), log);
    }
  if (a_equateCadcs_matrix->get_matrix())
    {
      adjustLevels(&equateCadcs_matrixAtts_a_matrix,
		   "equateCadcs_matrix a_matrix");
      if (log && !findString("a_matrix", equateCadcs_matrixAtts))
	{
	  warnAtt("a_matrix", "equateCadcs_matrix", a_equateCadcs_matrix);
	  check_matrix(a_equateCadcs_matrix->get_matrix(), 0);
	}
      else
	check_matrix(a_equateCadcs_matrix->get_matrix(), log);
    }
}

/********************************************************************/

void check_equateCadcs_stringVal(
 equateCadcs_stringVal * a_equateCadcs_stringVal,
 int log)
{
  if (a_equateCadcs_stringVal->get_didLabel())
    {
      adjustLevels(&equateCadcs_stringValAtts_a_didLabel,
		   "equateCadcs_stringVal a_didLabel");
      if (log && !findString("a_didLabel", equateCadcs_stringValAtts))
	{
	  warnAtt("a_didLabel", "equateCadcs_stringVal",
		  a_equateCadcs_stringVal);
	  check_didLabel(a_equateCadcs_stringVal->get_didLabel(), 0);
	}
      else
	check_didLabel(a_equateCadcs_stringVal->get_didLabel(), log);
    }
  if (a_equateCadcs_stringVal->get_text())
    {
      adjustLevels(&equateCadcs_stringValAtts_text,
		   "equateCadcs_stringVal text");
      if (log && !findString("text", equateCadcs_stringValAtts))
	{
	  warnAtt("text", "equateCadcs_stringVal", a_equateCadcs_stringVal);
	  check_stringVal(a_equateCadcs_stringVal->get_text(), 0);
	}
      else
	check_stringVal(a_equateCadcs_stringVal->get_text(), log);
    }
}

/********************************************************************/

void check_equateDatum(
 equateDatum * a_equateDatum,
 int log)
{
  if (a_equateDatum->get_equateFrom())
    {
      adjustLevels(&equateDatumAtts_equateFrom, "equateDatum equateFrom");
      if (log && !findString("equateFrom", equateDatumAtts))
	{
	  warnAtt("equateFrom", "equateDatum", a_equateDatum);
	  check_daLabel(a_equateDatum->get_equateFrom(), 0);
	}
      else
	check_daLabel(a_equateDatum->get_equateFrom(), log);
    }
  if (a_equateDatum->get_equateTo())
    {
      adjustLevels(&equateDatumAtts_equateTo, "equateDatum equateTo");
      if (log && !findString("equateTo", equateDatumAtts))
	{
	  warnAtt("equateTo", "equateDatum", a_equateDatum);
	  check_daLabel(a_equateDatum->get_equateTo(), 0);
	}
      else
	check_daLabel(a_equateDatum->get_equateTo(), log);
    }
}

/********************************************************************/

void check_equateMinor(
 equateMinor * a_equateMinor,
 int log)
{
  if (isA(a_equateMinor, equateDatum))
    {
      adjustLevels(&equateMinorSubs_equateDatum, "equateDatum");
      if (log && !findString("equateDatum", equateMinorSubs))
	{
	  warnSub("equateDatum", "equateMinor", a_equateMinor);
	  check_equateDatum(dynamic_cast<equateDatum *>(a_equateMinor), 0);
	}
      else
	check_equateDatum(dynamic_cast<equateDatum *>(a_equateMinor), log);
      return;
    }
  if (isA(a_equateMinor, equateCad))
    {
      adjustLevels(&equateMinorSubs_equateCad, "equateCad");
      if (log && !findString("equateCad", equateMinorSubs))
	{
	  warnSub("equateCad", "equateMinor", a_equateMinor);
	  check_equateCad(dynamic_cast<equateCad *>(a_equateMinor), 0);
	}
      else
	check_equateCad(dynamic_cast<equateCad *>(a_equateMinor), log);
      return;
    }
}

/********************************************************************/

void check_equateStm(
 equateStm * a_equateStm,
 int log)
{
  if (a_equateStm->get_equateMinor())
    {
      adjustLevels(&equateStmAtts_a_equateMinor, "equateStm a_equateMinor");
      if (log && !findString("a_equateMinor", equateStmAtts))
	{
	  warnAtt("a_equateMinor", "equateStm", a_equateStm);
	  check_equateMinor(a_equateStm->get_equateMinor(), 0);
	}
      else
	check_equateMinor(a_equateStm->get_equateMinor(), log);
    }
}

/********************************************************************/

void check_errorCondition(
 errorCondition * a_errorCondition,
 int log)
{
  if (isA(a_errorCondition, errorCondition_ALL))
    {
      adjustLevels(&errorConditionSubs_errorCondition_ALL,
		   "errorCondition_ALL");
      if (log && !findString("errorCondition_ALL", errorConditionSubs))
	{
	  warnSub("errorCondition_ALL", "errorCondition", a_errorCondition);
	}
      return;
    }
  if (isA(a_errorCondition, errorCondition_ILLEGALTOUCH))
    {
      adjustLevels(&errorConditionSubs_errorCondition_ILLEGALTOUCH,
		   "errorCondition_ILLEGALTOUCH");
      if (log && !findString("errorCondition_ILLEGALTOUCH",
			     errorConditionSubs))
	{
	  warnSub("errorCondition_ILLEGALTOUCH", "errorCondition",
		  a_errorCondition);
	}
      return;
    }
  if (isA(a_errorCondition, errorCondition_NOTOUCH))
    {
      adjustLevels(&errorConditionSubs_errorCondition_NOTOUCH,
		   "errorCondition_NOTOUCH");
      if (log && !findString("errorCondition_NOTOUCH", errorConditionSubs))
	{
	  warnSub("errorCondition_NOTOUCH", "errorCondition", a_errorCondition);
	}
      return;
    }
  if (isA(a_errorCondition, errorCondition_intVal))
    {
      adjustLevels(&errorConditionSubs_errorCondition_intVal,
		   "errorCondition_intVal");
      if (log && !findString("errorCondition_intVal", errorConditionSubs))
	{
	  warnSub("errorCondition_intVal", "errorCondition", a_errorCondition);
	  check_errorCondition_intVal(
	    dynamic_cast<errorCondition_intVal *>(a_errorCondition), 0);
	}
      else
	check_errorCondition_intVal(
	  dynamic_cast<errorCondition_intVal *>(a_errorCondition), log);
      return;
    }
}

/********************************************************************/

void check_errorCondition_intVal(
 errorCondition_intVal * a_errorCondition_intVal,
 int log)
{
  if (a_errorCondition_intVal->get_ercode())
    {
      adjustLevels(&errorCondition_intValAtts_ercode,
		   "errorCondition_intVal ercode");
      if (log && !findString("ercode", errorCondition_intValAtts))
	{
	  warnAtt("ercode", "errorCondition_intVal", a_errorCondition_intVal);
	  check_intVal(a_errorCondition_intVal->get_ercode(), 0);
	}
      else
	check_intVal(a_errorCondition_intVal->get_ercode(), log);
    }
}

/********************************************************************/

void check_errorMinor(
 errorMinor * a_errorMinor,
 int log)
{
  if (isA(a_errorMinor, errorMinor_jumpLabel))
    {
      adjustLevels(&errorMinorSubs_errorMinor_jumpLabel,
		   "errorMinor_jumpLabel");
      if (log && !findString("errorMinor_jumpLabel", errorMinorSubs))
	{
	  warnSub("errorMinor_jumpLabel", "errorMinor", a_errorMinor);
	  check_errorMinor_jumpLabel(
	    dynamic_cast<errorMinor_jumpLabel *>(a_errorMinor), 0);
	}
      else
	check_errorMinor_jumpLabel(
	  dynamic_cast<errorMinor_jumpLabel *>(a_errorMinor), log);
      return;
    }
  if (isA(a_errorMinor, errorMinor_AUTO))
    {
      adjustLevels(&errorMinorSubs_errorMinor_AUTO, "errorMinor_AUTO");
      if (log && !findString("errorMinor_AUTO", errorMinorSubs))
	{
	  warnSub("errorMinor_AUTO", "errorMinor", a_errorMinor);
	  check_errorMinor_AUTO(
	    dynamic_cast<errorMinor_AUTO *>(a_errorMinor), 0);
	}
      else
	check_errorMinor_AUTO(
	  dynamic_cast<errorMinor_AUTO *>(a_errorMinor), log);
      return;
    }
  if (isA(a_errorMinor, errorMinor_OFF))
    {
      adjustLevels(&errorMinorSubs_errorMinor_OFF, "errorMinor_OFF");
      if (log && !findString("errorMinor_OFF", errorMinorSubs))
	{
	  warnSub("errorMinor_OFF", "errorMinor", a_errorMinor);
	}
      return;
    }
}

/********************************************************************/

void check_errorMinor_AUTO(
 errorMinor_AUTO * a_errorMinor_AUTO,
 int log)
{
  if (a_errorMinor_AUTO->get_errorCondition())
    {
      adjustLevels(&errorMinor_AUTOAtts_a_errorCondition,
		   "errorMinor_AUTO a_errorCondition");
      if (log && !findString("a_errorCondition", errorMinor_AUTOAtts))
	{
	  warnAtt("a_errorCondition", "errorMinor_AUTO", a_errorMinor_AUTO);
	  check_errorCondition(a_errorMinor_AUTO->get_errorCondition(), 0);
	}
      else
	check_errorCondition(a_errorMinor_AUTO->get_errorCondition(), log);
    }
}

/********************************************************************/

void check_errorMinor_jumpLabel(
 errorMinor_jumpLabel * a_errorMinor_jumpLabel,
 int log)
{
  if (a_errorMinor_jumpLabel->get_jumpLabel())
    {
      adjustLevels(&errorMinor_jumpLabelAtts_a_jumpLabel,
		   "errorMinor_jumpLabel a_jumpLabel");
      if (log && !findString("a_jumpLabel", errorMinor_jumpLabelAtts))
	{
	  warnAtt("a_jumpLabel", "errorMinor_jumpLabel",
		  a_errorMinor_jumpLabel);
	  check_jumpLabel(a_errorMinor_jumpLabel->get_jumpLabel(), 0);
	}
      else
	check_jumpLabel(a_errorMinor_jumpLabel->get_jumpLabel(), log);
    }
  if (a_errorMinor_jumpLabel->get_errorCondition())
    {
      adjustLevels(&errorMinor_jumpLabelAtts_a_errorCondition,
		   "errorMinor_jumpLabel a_errorCondition");
      if (log && !findString("a_errorCondition", errorMinor_jumpLabelAtts))
	{
	  warnAtt("a_errorCondition", "errorMinor_jumpLabel",
		  a_errorMinor_jumpLabel);
	  check_errorCondition(a_errorMinor_jumpLabel->get_errorCondition(), 0);
	}
      else
	check_errorCondition(a_errorMinor_jumpLabel->get_errorCondition(), log);
    }
}

/********************************************************************/

void check_errorStm(
 errorStm * a_errorStm,
 int log)
{
  if (a_errorStm->get_errorMinor())
    {
      adjustLevels(&errorStmAtts_a_errorMinor, "errorStm a_errorMinor");
      if (log && !findString("a_errorMinor", errorStmAtts))
	{
	  warnAtt("a_errorMinor", "errorStm", a_errorStm);
	  check_errorMinor(a_errorStm->get_errorMinor(), 0);
	}
      else
	check_errorMinor(a_errorStm->get_errorMinor(), log);
    }
}

/********************************************************************/

void check_euler(
 euler * a_euler,
 int log)
{
  if (a_euler->get_ang1())
    {
      adjustLevels(&eulerAtts_ang1, "euler ang1");
      if (log && !findString("ang1", eulerAtts))
	{
	  warnAtt("ang1", "euler", a_euler);
	  check_rentVal(a_euler->get_ang1(), 0);
	}
      else
	check_rentVal(a_euler->get_ang1(), log);
    }
  if (a_euler->get_ang2())
    {
      adjustLevels(&eulerAtts_ang2, "euler ang2");
      if (log && !findString("ang2", eulerAtts))
	{
	  warnAtt("ang2", "euler", a_euler);
	  check_rentVal(a_euler->get_ang2(), 0);
	}
      else
	check_rentVal(a_euler->get_ang2(), log);
    }
  if (a_euler->get_ang3())
    {
      adjustLevels(&eulerAtts_ang3, "euler ang3");
      if (log && !findString("ang3", eulerAtts))
	{
	  warnAtt("ang3", "euler", a_euler);
	  check_rentVal(a_euler->get_ang3(), 0);
	}
      else
	check_rentVal(a_euler->get_ang3(), log);
    }
}

/********************************************************************/

void check_evalDat(
 evalDat * a_evalDat,
 int log)
{
  if (isA(a_evalDat, evalDatDatFa))
    {
      adjustLevels(&evalDatSubs_evalDatDatFa, "evalDatDatFa");
      if (log && !findString("evalDatDatFa", evalDatSubs))
	{
	  warnSub("evalDatDatFa", "evalDat", a_evalDat);
	  check_evalDatDatFa(dynamic_cast<evalDatDatFa *>(a_evalDat), 0);
	}
      else
	check_evalDatDatFa(dynamic_cast<evalDatDatFa *>(a_evalDat), log);
      return;
    }
  if (isA(a_evalDat, evalDatFaDat))
    {
      adjustLevels(&evalDatSubs_evalDatFaDat, "evalDatFaDat");
      if (log && !findString("evalDatFaDat", evalDatSubs))
	{
	  warnSub("evalDatFaDat", "evalDat", a_evalDat);
	  check_evalDatFaDat(dynamic_cast<evalDatFaDat *>(a_evalDat), 0);
	}
      else
	check_evalDatFaDat(dynamic_cast<evalDatFaDat *>(a_evalDat), log);
      return;
    }
}

/********************************************************************/

void check_evalDatDatFa(
 evalDatDatFa * a_evalDatDatFa,
 int log)
{
  if (a_evalDatDatFa->get_datLabel())
    {
      adjustLevels(&evalDatDatFaAtts_a_datLabel, "evalDatDatFa a_datLabel");
      if (log && !findString("a_datLabel", evalDatDatFaAtts))
	{
	  warnAtt("a_datLabel", "evalDatDatFa", a_evalDatDatFa);
	  check_datLabel(a_evalDatDatFa->get_datLabel(), 0);
	}
      else
	check_datLabel(a_evalDatDatFa->get_datLabel(), log);
    }
  if (a_evalDatDatFa->get_faLabel())
    {
      adjustLevels(&evalDatDatFaAtts_a_faLabel, "evalDatDatFa a_faLabel");
      if (log && !findString("a_faLabel", evalDatDatFaAtts))
	{
	  warnAtt("a_faLabel", "evalDatDatFa", a_evalDatDatFa);
	  check_faLabel(a_evalDatDatFa->get_faLabel(), 0);
	}
      else
	check_faLabel(a_evalDatDatFa->get_faLabel(), log);
    }
  if (a_evalDatDatFa->get_tLabel())
    {
      adjustLevels(&evalDatDatFaAtts_a_tLabel, "evalDatDatFa a_tLabel");
      if (log && !findString("a_tLabel", evalDatDatFaAtts))
	{
	  warnAtt("a_tLabel", "evalDatDatFa", a_evalDatDatFa);
	  check_tLabel(a_evalDatDatFa->get_tLabel(), 0);
	}
      else
	check_tLabel(a_evalDatDatFa->get_tLabel(), log);
    }
}

/********************************************************************/

void check_evalDatFaDat(
 evalDatFaDat * a_evalDatFaDat,
 int log)
{
  if (a_evalDatFaDat->get_faLabel())
    {
      adjustLevels(&evalDatFaDatAtts_a_faLabel, "evalDatFaDat a_faLabel");
      if (log && !findString("a_faLabel", evalDatFaDatAtts))
	{
	  warnAtt("a_faLabel", "evalDatFaDat", a_evalDatFaDat);
	  check_faLabel(a_evalDatFaDat->get_faLabel(), 0);
	}
      else
	check_faLabel(a_evalDatFaDat->get_faLabel(), log);
    }
  if (a_evalDatFaDat->get_datLabel())
    {
      adjustLevels(&evalDatFaDatAtts_a_datLabel, "evalDatFaDat a_datLabel");
      if (log && !findString("a_datLabel", evalDatFaDatAtts))
	{
	  warnAtt("a_datLabel", "evalDatFaDat", a_evalDatFaDat);
	  check_datLabel(a_evalDatFaDat->get_datLabel(), 0);
	}
      else
	check_datLabel(a_evalDatFaDat->get_datLabel(), log);
    }
  if (a_evalDatFaDat->get_tLabel())
    {
      adjustLevels(&evalDatFaDatAtts_a_tLabel, "evalDatFaDat a_tLabel");
      if (log && !findString("a_tLabel", evalDatFaDatAtts))
	{
	  warnAtt("a_tLabel", "evalDatFaDat", a_evalDatFaDat);
	  check_tLabel(a_evalDatFaDat->get_tLabel(), 0);
	}
      else
	check_tLabel(a_evalDatFaDat->get_tLabel(), log);
    }
}

/********************************************************************/

void check_evalFeat(
 evalFeat * a_evalFeat,
 int log)
{
  if (isA(a_evalFeat, evalFeatFaT))
    {
      adjustLevels(&evalFeatSubs_evalFeatFaT, "evalFeatFaT");
      if (log && !findString("evalFeatFaT", evalFeatSubs))
	{
	  warnSub("evalFeatFaT", "evalFeat", a_evalFeat);
	  check_evalFeatFaT(dynamic_cast<evalFeatFaT *>(a_evalFeat), 0);
	}
      else
	check_evalFeatFaT(dynamic_cast<evalFeatFaT *>(a_evalFeat), log);
      return;
    }
  if (isA(a_evalFeat, evalFeatFaFT))
    {
      adjustLevels(&evalFeatSubs_evalFeatFaFT, "evalFeatFaFT");
      if (log && !findString("evalFeatFaFT", evalFeatSubs))
	{
	  warnSub("evalFeatFaFT", "evalFeat", a_evalFeat);
	  check_evalFeatFaFT(dynamic_cast<evalFeatFaFT *>(a_evalFeat), 0);
	}
      else
	check_evalFeatFaFT(dynamic_cast<evalFeatFaFT *>(a_evalFeat), log);
      return;
    }
  if (isA(a_evalFeat, evalFeatFFaT))
    {
      adjustLevels(&evalFeatSubs_evalFeatFFaT, "evalFeatFFaT");
      if (log && !findString("evalFeatFFaT", evalFeatSubs))
	{
	  warnSub("evalFeatFFaT", "evalFeat", a_evalFeat);
	  check_evalFeatFFaT(dynamic_cast<evalFeatFFaT *>(a_evalFeat), 0);
	}
      else
	check_evalFeatFFaT(dynamic_cast<evalFeatFFaT *>(a_evalFeat), log);
      return;
    }
  if (isA(a_evalFeat, evalFeatFaFaT))
    {
      adjustLevels(&evalFeatSubs_evalFeatFaFaT, "evalFeatFaFaT");
      if (log && !findString("evalFeatFaFaT", evalFeatSubs))
	{
	  warnSub("evalFeatFaFaT", "evalFeat", a_evalFeat);
	  check_evalFeatFaFaT(
	    dynamic_cast<evalFeatFaFaT *>(a_evalFeat), 0);
	}
      else
	check_evalFeatFaFaT(
	  dynamic_cast<evalFeatFaFaT *>(a_evalFeat), log);
      return;
    }
}

/********************************************************************/

void check_evalFeatFFaT(
 evalFeatFFaT * a_evalFeatFFaT,
 int log)
{
  if (a_evalFeatFFaT->get_f())
    {
      adjustLevels(&evalFeatFFaTAtts_f, "evalFeatFFaT f");
      if (log && !findString("f", evalFeatFFaTAtts))
	{
	  warnAtt("f", "evalFeatFFaT", a_evalFeatFFaT);
	  check_fLabel(a_evalFeatFFaT->get_f(), 0);
	}
      else
	check_fLabel(a_evalFeatFFaT->get_f(), log);
    }
  if (a_evalFeatFFaT->get_fa())
    {
      adjustLevels(&evalFeatFFaTAtts_fa, "evalFeatFFaT fa");
      if (log && !findString("fa", evalFeatFFaTAtts))
	{
	  warnAtt("fa", "evalFeatFFaT", a_evalFeatFFaT);
	  check_faLabel(a_evalFeatFFaT->get_fa(), 0);
	}
      else
	check_faLabel(a_evalFeatFFaT->get_fa(), log);
    }
  if (a_evalFeatFFaT->get_t())
    {
      adjustLevels(&evalFeatFFaTAtts_t, "evalFeatFFaT t");
      if (log && !findString("t", evalFeatFFaTAtts))
	{
	  warnAtt("t", "evalFeatFFaT", a_evalFeatFFaT);
	  check_tLabel(a_evalFeatFFaT->get_t(), 0);
	}
      else
	check_tLabel(a_evalFeatFFaT->get_t(), log);
    }
}

/********************************************************************/

void check_evalFeatFaFT(
 evalFeatFaFT * a_evalFeatFaFT,
 int log)
{
  if (a_evalFeatFaFT->get_fa())
    {
      adjustLevels(&evalFeatFaFTAtts_fa, "evalFeatFaFT fa");
      if (log && !findString("fa", evalFeatFaFTAtts))
	{
	  warnAtt("fa", "evalFeatFaFT", a_evalFeatFaFT);
	  check_faLabel(a_evalFeatFaFT->get_fa(), 0);
	}
      else
	check_faLabel(a_evalFeatFaFT->get_fa(), log);
    }
  if (a_evalFeatFaFT->get_f())
    {
      adjustLevels(&evalFeatFaFTAtts_f, "evalFeatFaFT f");
      if (log && !findString("f", evalFeatFaFTAtts))
	{
	  warnAtt("f", "evalFeatFaFT", a_evalFeatFaFT);
	  check_fLabel(a_evalFeatFaFT->get_f(), 0);
	}
      else
	check_fLabel(a_evalFeatFaFT->get_f(), log);
    }
  if (a_evalFeatFaFT->get_t())
    {
      adjustLevels(&evalFeatFaFTAtts_t, "evalFeatFaFT t");
      if (log && !findString("t", evalFeatFaFTAtts))
	{
	  warnAtt("t", "evalFeatFaFT", a_evalFeatFaFT);
	  check_tLabel(a_evalFeatFaFT->get_t(), 0);
	}
      else
	check_tLabel(a_evalFeatFaFT->get_t(), log);
    }
}

/********************************************************************/

void check_evalFeatFaFaT(
 evalFeatFaFaT * a_evalFeatFaFaT,
 int log)
{
  if (a_evalFeatFaFaT->get_fa1())
    {
      adjustLevels(&evalFeatFaFaTAtts_fa1, "evalFeatFaFaT fa1");
      if (log && !findString("fa1", evalFeatFaFaTAtts))
	{
	  warnAtt("fa1", "evalFeatFaFaT", a_evalFeatFaFaT);
	  check_faLabel(a_evalFeatFaFaT->get_fa1(), 0);
	}
      else
	check_faLabel(a_evalFeatFaFaT->get_fa1(), log);
    }
  if (a_evalFeatFaFaT->get_fa2())
    {
      adjustLevels(&evalFeatFaFaTAtts_fa2, "evalFeatFaFaT fa2");
      if (log && !findString("fa2", evalFeatFaFaTAtts))
	{
	  warnAtt("fa2", "evalFeatFaFaT", a_evalFeatFaFaT);
	  check_faLabel(a_evalFeatFaFaT->get_fa2(), 0);
	}
      else
	check_faLabel(a_evalFeatFaFaT->get_fa2(), log);
    }
  if (a_evalFeatFaFaT->get_t())
    {
      adjustLevels(&evalFeatFaFaTAtts_t, "evalFeatFaFaT t");
      if (log && !findString("t", evalFeatFaFaTAtts))
	{
	  warnAtt("t", "evalFeatFaFaT", a_evalFeatFaFaT);
	  check_tLabel(a_evalFeatFaFaT->get_t(), 0);
	}
      else
	check_tLabel(a_evalFeatFaFaT->get_t(), log);
    }
}

/********************************************************************/

void check_evalFeatFaT(
 evalFeatFaT * a_evalFeatFaT,
 int log)
{
  if (a_evalFeatFaT->get_fa())
    {
      adjustLevels(&evalFeatFaTAtts_fa, "evalFeatFaT fa");
      if (log && !findString("fa", evalFeatFaTAtts))
	{
	  warnAtt("fa", "evalFeatFaT", a_evalFeatFaT);
	  check_faLabel(a_evalFeatFaT->get_fa(), 0);
	}
      else
	check_faLabel(a_evalFeatFaT->get_fa(), log);
    }
  if (a_evalFeatFaT->get_tLabelList())
    {
      std::list<tLabel *> * theList;
      std::list<tLabel *>::iterator iter;
      theList = a_evalFeatFaT->get_tLabelList();
      adjustLevels(&evalFeatFaTAtts_a_tLabelList, "evalFeatFaT a_tLabelList");
      if (log && !findString("a_tLabelList", evalFeatFaTAtts))
	{
	  warnAtt("a_tLabelList", "evalFeatFaT", a_evalFeatFaT);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_tLabel(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_tLabel(*iter, log);
	}
    }
}

/********************************************************************/

void check_evalKeychar(
 evalKeychar * a_evalKeychar,
 int log)
{
  if (isA(a_evalKeychar, kcLabel))
    {
      adjustLevels(&evalKeycharSubs_kcLabel, "kcLabel");
      if (log && !findString("kcLabel", evalKeycharSubs))
	{
	  warnSub("kcLabel", "evalKeychar", a_evalKeychar);
	  check_kcLabel(dynamic_cast<kcLabel *>(a_evalKeychar), 0);
	}
      else
	check_kcLabel(dynamic_cast<kcLabel *>(a_evalKeychar), log);
      return;
    }
}

/********************************************************************/

void check_evalMinor(
 evalMinor * a_evalMinor,
 int log)
{
  if (isA(a_evalMinor, evalFeat))
    {
      adjustLevels(&evalMinorSubs_evalFeat, "evalFeat");
      if (log && !findString("evalFeat", evalMinorSubs))
	{
	  warnSub("evalFeat", "evalMinor", a_evalMinor);
	  check_evalFeat(dynamic_cast<evalFeat *>(a_evalMinor), 0);
	}
      else
	check_evalFeat(dynamic_cast<evalFeat *>(a_evalMinor), log);
      return;
    }
  if (isA(a_evalMinor, evalDat))
    {
      adjustLevels(&evalMinorSubs_evalDat, "evalDat");
      if (log && !findString("evalDat", evalMinorSubs))
	{
	  warnSub("evalDat", "evalMinor", a_evalMinor);
	  check_evalDat(dynamic_cast<evalDat *>(a_evalMinor), 0);
	}
      else
	check_evalDat(dynamic_cast<evalDat *>(a_evalMinor), log);
      return;
    }
  if (isA(a_evalMinor, evalKeychar))
    {
      adjustLevels(&evalMinorSubs_evalKeychar, "evalKeychar");
      if (log && !findString("evalKeychar", evalMinorSubs))
	{
	  warnSub("evalKeychar", "evalMinor", a_evalMinor);
	  check_evalKeychar(dynamic_cast<evalKeychar *>(a_evalMinor), 0);
	}
      else
	check_evalKeychar(dynamic_cast<evalKeychar *>(a_evalMinor), log);
      return;
    }
}

/********************************************************************/

void check_evalOrOutput(
 evalOrOutput * a_evalOrOutput,
 int log)
{
  if (isA(a_evalOrOutput, evalStm))
    {
      adjustLevels(&evalOrOutputSubs_evalStm, "evalStm");
      if (log && !findString("evalStm", evalOrOutputSubs))
	{
	  warnSub("evalStm", "evalOrOutput", a_evalOrOutput);
	  check_evalStm(dynamic_cast<evalStm *>(a_evalOrOutput), 0);
	}
      else
	check_evalStm(dynamic_cast<evalStm *>(a_evalOrOutput), log);
      return;
    }
  if (isA(a_evalOrOutput, outputStm))
    {
      adjustLevels(&evalOrOutputSubs_outputStm, "outputStm");
      if (log && !findString("outputStm", evalOrOutputSubs))
	{
	  warnSub("outputStm", "evalOrOutput", a_evalOrOutput);
	  check_outputStm(dynamic_cast<outputStm *>(a_evalOrOutput), 0);
	}
      else
	check_outputStm(dynamic_cast<outputStm *>(a_evalOrOutput), log);
      return;
    }
}

/********************************************************************/

void check_evalStm(
 evalStm * a_evalStm,
 int log)
{
  if (a_evalStm->get_evalMinor())
    {
      adjustLevels(&evalStmAtts_a_evalMinor, "evalStm a_evalMinor");
      if (log && !findString("a_evalMinor", evalStmAtts))
	{
	  warnAtt("a_evalMinor", "evalStm", a_evalStm);
	  check_evalMinor(a_evalStm->get_evalMinor(), 0);
	}
      else
	check_evalMinor(a_evalStm->get_evalMinor(), log);
    }
}

/********************************************************************/

void check_extensMinor(
 extensMinor * a_extensMinor,
 int log)
{
  if (isA(a_extensMinor, extensMinor_vector))
    {
      adjustLevels(&extensMinorSubs_extensMinor_vector, "extensMinor_vector");
      if (log && !findString("extensMinor_vector", extensMinorSubs))
	{
	  warnSub("extensMinor_vector", "extensMinor", a_extensMinor);
	  check_extensMinor_vector(
	    dynamic_cast<extensMinor_vector *>(a_extensMinor), 0);
	}
      else
	check_extensMinor_vector(
	  dynamic_cast<extensMinor_vector *>(a_extensMinor), log);
      return;
    }
  if (isA(a_extensMinor, extensMinor_VEC))
    {
      adjustLevels(&extensMinorSubs_extensMinor_VEC, "extensMinor_VEC");
      if (log && !findString("extensMinor_VEC", extensMinorSubs))
	{
	  warnSub("extensMinor_VEC", "extensMinor", a_extensMinor);
	  check_extensMinor_VEC(
	    dynamic_cast<extensMinor_VEC *>(a_extensMinor), 0);
	}
      else
	check_extensMinor_VEC(
	  dynamic_cast<extensMinor_VEC *>(a_extensMinor), log);
      return;
    }
}

/********************************************************************/

void check_extensMinor_VEC(
 extensMinor_VEC * a_extensMinor_VEC,
 int log)
{
  if (a_extensMinor_VEC->get_perp())
    {
      adjustLevels(&extensMinor_VECAtts_perp, "extensMinor_VEC perp");
      if (log && !findString("perp", extensMinor_VECAtts))
	{
	  warnAtt("perp", "extensMinor_VEC", a_extensMinor_VEC);
	  check_vector(a_extensMinor_VEC->get_perp(), 0);
	}
      else
	check_vector(a_extensMinor_VEC->get_perp(), log);
    }
  if (a_extensMinor_VEC->get_length())
    {
      adjustLevels(&extensMinor_VECAtts_length, "extensMinor_VEC length");
      if (log && !findString("length", extensMinor_VECAtts))
	{
	  warnAtt("length", "extensMinor_VEC", a_extensMinor_VEC);
	  check_rentVal(a_extensMinor_VEC->get_length(), 0);
	}
      else
	check_rentVal(a_extensMinor_VEC->get_length(), log);
    }
}

/********************************************************************/

void check_extensMinor_vector(
 extensMinor_vector * a_extensMinor_vector,
 int log)
{
  if (a_extensMinor_vector->get_offset())
    {
      adjustLevels(&extensMinor_vectorAtts_offset,
		   "extensMinor_vector offset");
      if (log && !findString("offset", extensMinor_vectorAtts))
	{
	  warnAtt("offset", "extensMinor_vector", a_extensMinor_vector);
	  check_vector(a_extensMinor_vector->get_offset(), 0);
	}
      else
	check_vector(a_extensMinor_vector->get_offset(), log);
    }
}

/********************************************************************/

void check_extensStm(
 extensStm * a_extensStm,
 int log)
{
  if (a_extensStm->get_sxLabel())
    {
      adjustLevels(&extensStmAtts_a_sxLabel, "extensStm a_sxLabel");
      if (log && !findString("a_sxLabel", extensStmAtts))
	{
	  warnAtt("a_sxLabel", "extensStm", a_extensStm);
	  check_sxLabel(a_extensStm->get_sxLabel(), 0);
	}
      else
	check_sxLabel(a_extensStm->get_sxLabel(), log);
    }
  if (a_extensStm->get_extensMinor())
    {
      adjustLevels(&extensStmAtts_a_extensMinor, "extensStm a_extensMinor");
      if (log && !findString("a_extensMinor", extensStmAtts))
	{
	  warnAtt("a_extensMinor", "extensStm", a_extensStm);
	  check_extensMinor(a_extensStm->get_extensMinor(), 0);
	}
      else
	check_extensMinor(a_extensStm->get_extensMinor(), log);
    }
}

/********************************************************************/

void check_extfilDme(
 extfilDme * a_extfilDme,
 int log)
{
  if (a_extfilDme->get_filename())
    {
      adjustLevels(&extfilDmeAtts_filename, "extfilDme filename");
      if (log && !findString("filename", extfilDmeAtts))
	{
	  warnAtt("filename", "extfilDme", a_extfilDme);
	  check_stringVal(a_extfilDme->get_filename(), 0);
	}
      else
	check_stringVal(a_extfilDme->get_filename(), log);
    }
}

/********************************************************************/

void check_extfilDmis(
 extfilDmis * a_extfilDmis,
 int log)
{
  if (a_extfilDmis->get_filename())
    {
      adjustLevels(&extfilDmisAtts_filename, "extfilDmis filename");
      if (log && !findString("filename", extfilDmisAtts))
	{
	  warnAtt("filename", "extfilDmis", a_extfilDmis);
	  check_stringVal(a_extfilDmis->get_filename(), 0);
	}
      else
	check_stringVal(a_extfilDmis->get_filename(), log);
    }
}

/********************************************************************/

void check_extfilMinor(
 extfilMinor * a_extfilMinor,
 int log)
{
  if (isA(a_extfilMinor, extfilDmis))
    {
      adjustLevels(&extfilMinorSubs_extfilDmis, "extfilDmis");
      if (log && !findString("extfilDmis", extfilMinorSubs))
	{
	  warnSub("extfilDmis", "extfilMinor", a_extfilMinor);
	  check_extfilDmis(dynamic_cast<extfilDmis *>(a_extfilMinor), 0);
	}
      else
	check_extfilDmis(dynamic_cast<extfilDmis *>(a_extfilMinor), log);
      return;
    }
  if (isA(a_extfilMinor, extfilDme))
    {
      adjustLevels(&extfilMinorSubs_extfilDme, "extfilDme");
      if (log && !findString("extfilDme", extfilMinorSubs))
	{
	  warnSub("extfilDme", "extfilMinor", a_extfilMinor);
	  check_extfilDme(dynamic_cast<extfilDme *>(a_extfilMinor), 0);
	}
      else
	check_extfilDme(dynamic_cast<extfilDme *>(a_extfilMinor), log);
      return;
    }
}

/********************************************************************/

void check_extfilStm(
 extfilStm * a_extfilStm,
 int log)
{
  if (a_extfilStm->get_extfilMinor())
    {
      adjustLevels(&extfilStmAtts_a_extfilMinor, "extfilStm a_extfilMinor");
      if (log && !findString("a_extfilMinor", extfilStmAtts))
	{
	  warnAtt("a_extfilMinor", "extfilStm", a_extfilStm);
	  check_extfilMinor(a_extfilStm->get_extfilMinor(), 0);
	}
      else
	check_extfilMinor(a_extfilStm->get_extfilMinor(), log);
    }
}

/********************************************************************/

void check_extremConst(
 extremConst * a_extremConst,
 int log)
{
  if (isA(a_extremConst, extremConst_MIN))
    {
      adjustLevels(&extremConstSubs_extremConst_MIN, "extremConst_MIN");
      if (log && !findString("extremConst_MIN", extremConstSubs))
	{
	  warnSub("extremConst_MIN", "extremConst", a_extremConst);
	  check_extremConst_MIN(
	    dynamic_cast<extremConst_MIN *>(a_extremConst), 0);
	}
      else
	check_extremConst_MIN(
	  dynamic_cast<extremConst_MIN *>(a_extremConst), log);
      return;
    }
  if (isA(a_extremConst, extremConst_MAX))
    {
      adjustLevels(&extremConstSubs_extremConst_MAX, "extremConst_MAX");
      if (log && !findString("extremConst_MAX", extremConstSubs))
	{
	  warnSub("extremConst_MAX", "extremConst", a_extremConst);
	  check_extremConst_MAX(
	    dynamic_cast<extremConst_MAX *>(a_extremConst), 0);
	}
      else
	check_extremConst_MAX(
	  dynamic_cast<extremConst_MAX *>(a_extremConst), log);
      return;
    }
}

/********************************************************************/

void check_extremConstAxial(
 extremConstAxial * a_extremConstAxial,
 int log)
{
  if (isA(a_extremConstAxial, posDir))
    {
      adjustLevels(&extremConstAxialSubs_posDir, "posDir");
      if (log && !findString("posDir", extremConstAxialSubs))
	{
	  warnSub("posDir", "extremConstAxial", a_extremConstAxial);
	  check_posDir(dynamic_cast<posDir *>(a_extremConstAxial), 0);
	}
      else
	check_posDir(dynamic_cast<posDir *>(a_extremConstAxial), log);
      return;
    }
}

/********************************************************************/

void check_extremConstDir(
 extremConstDir * a_extremConstDir,
 int log)
{
  if (isA(a_extremConstDir, extremConstAxial))
    {
      adjustLevels(&extremConstDirSubs_extremConstAxial, "extremConstAxial");
      if (log && !findString("extremConstAxial", extremConstDirSubs))
	{
	  warnSub("extremConstAxial", "extremConstDir", a_extremConstDir);
	  check_extremConstAxial(
	    dynamic_cast<extremConstAxial *>(a_extremConstDir), 0);
	}
      else
	check_extremConstAxial(
	  dynamic_cast<extremConstAxial *>(a_extremConstDir), log);
      return;
    }
  if (isA(a_extremConstDir, extremConstVectorial))
    {
      adjustLevels(&extremConstDirSubs_extremConstVectorial,
		   "extremConstVectorial");
      if (log && !findString("extremConstVectorial", extremConstDirSubs))
	{
	  warnSub("extremConstVectorial", "extremConstDir", a_extremConstDir);
	  check_extremConstVectorial(
	    dynamic_cast<extremConstVectorial *>(a_extremConstDir), 0);
	}
      else
	check_extremConstVectorial(
	  dynamic_cast<extremConstVectorial *>(a_extremConstDir), log);
      return;
    }
  if (isA(a_extremConstDir, extremConstFeature))
    {
      adjustLevels(&extremConstDirSubs_extremConstFeature,
		   "extremConstFeature");
      if (log && !findString("extremConstFeature", extremConstDirSubs))
	{
	  warnSub("extremConstFeature", "extremConstDir", a_extremConstDir);
	  check_extremConstFeature(
	    dynamic_cast<extremConstFeature *>(a_extremConstDir), 0);
	}
      else
	check_extremConstFeature(
	  dynamic_cast<extremConstFeature *>(a_extremConstDir), log);
      return;
    }
  if (isA(a_extremConstDir, extremConstRadial))
    {
      adjustLevels(&extremConstDirSubs_extremConstRadial, "extremConstRadial");
      if (log && !findString("extremConstRadial", extremConstDirSubs))
	{
	  warnSub("extremConstRadial", "extremConstDir", a_extremConstDir);
	}
      return;
    }
}

/********************************************************************/

void check_extremConstFeature(
 extremConstFeature * a_extremConstFeature,
 int log)
{
  if (isA(a_extremConstFeature, featureLabel))
    {
      adjustLevels(&extremConstFeatureSubs_featureLabel, "featureLabel");
      if (log && !findString("featureLabel", extremConstFeatureSubs))
	{
	  warnSub("featureLabel", "extremConstFeature", a_extremConstFeature);
	  check_featureLabel(
	    dynamic_cast<featureLabel *>(a_extremConstFeature), 0);
	}
      else
	check_featureLabel(
	  dynamic_cast<featureLabel *>(a_extremConstFeature), log);
      return;
    }
}

/********************************************************************/

void check_extremConstVectorial(
 extremConstVectorial * a_extremConstVectorial,
 int log)
{
  if (a_extremConstVectorial->get_dir())
    {
      adjustLevels(&extremConstVectorialAtts_dir, "extremConstVectorial dir");
      if (log && !findString("dir", extremConstVectorialAtts))
	{
	  warnAtt("dir", "extremConstVectorial", a_extremConstVectorial);
	  check_vector(a_extremConstVectorial->get_dir(), 0);
	}
      else
	check_vector(a_extremConstVectorial->get_dir(), log);
    }
}

/********************************************************************/

void check_extremConst_MAX(
 extremConst_MAX * a_extremConst_MAX,
 int log)
{
  if (a_extremConst_MAX->get_faLabel())
    {
      adjustLevels(&extremConst_MAXAtts_a_faLabel,
		   "extremConst_MAX a_faLabel");
      if (log && !findString("a_faLabel", extremConst_MAXAtts))
	{
	  warnAtt("a_faLabel", "extremConst_MAX", a_extremConst_MAX);
	  check_faLabel(a_extremConst_MAX->get_faLabel(), 0);
	}
      else
	check_faLabel(a_extremConst_MAX->get_faLabel(), log);
    }
  if (a_extremConst_MAX->get_extremConstDir())
    {
      adjustLevels(&extremConst_MAXAtts_a_extremConstDir,
		   "extremConst_MAX a_extremConstDir");
      if (log && !findString("a_extremConstDir", extremConst_MAXAtts))
	{
	  warnAtt("a_extremConstDir", "extremConst_MAX", a_extremConst_MAX);
	  check_extremConstDir(a_extremConst_MAX->get_extremConstDir(), 0);
	}
      else
	check_extremConstDir(a_extremConst_MAX->get_extremConstDir(), log);
    }
}

/********************************************************************/

void check_extremConst_MIN(
 extremConst_MIN * a_extremConst_MIN,
 int log)
{
  if (a_extremConst_MIN->get_faLabel())
    {
      adjustLevels(&extremConst_MINAtts_a_faLabel,
		   "extremConst_MIN a_faLabel");
      if (log && !findString("a_faLabel", extremConst_MINAtts))
	{
	  warnAtt("a_faLabel", "extremConst_MIN", a_extremConst_MIN);
	  check_faLabel(a_extremConst_MIN->get_faLabel(), 0);
	}
      else
	check_faLabel(a_extremConst_MIN->get_faLabel(), log);
    }
  if (a_extremConst_MIN->get_extremConstDir())
    {
      adjustLevels(&extremConst_MINAtts_a_extremConstDir,
		   "extremConst_MIN a_extremConstDir");
      if (log && !findString("a_extremConstDir", extremConst_MINAtts))
	{
	  warnAtt("a_extremConstDir", "extremConst_MIN", a_extremConst_MIN);
	  check_extremConstDir(a_extremConst_MIN->get_extremConstDir(), 0);
	}
      else
	check_extremConstDir(a_extremConst_MIN->get_extremConstDir(), log);
    }
}

/********************************************************************/

void check_fLabel(
 fLabel * a_fLabel,
 int log)
{
  if (a_fLabel->get_labelName())
    {
      adjustLevels(&fLabelAtts_a_labelName, "fLabel a_labelName");
      if (log && !findString("a_labelName", fLabelAtts))
	{
	  warnAtt("a_labelName", "fLabel", a_fLabel);
	  check_labelName(a_fLabel->get_labelName(), 0);
	}
      else
	check_labelName(a_fLabel->get_labelName(), log);
    }
}

/********************************************************************/

void check_faLabel(
 faLabel * a_faLabel,
 int log)
{
  if (a_faLabel->get_labelName())
    {
      adjustLevels(&faLabelAtts_a_labelName, "faLabel a_labelName");
      if (log && !findString("a_labelName", faLabelAtts))
	{
	  warnAtt("a_labelName", "faLabel", a_faLabel);
	  check_labelName(a_faLabel->get_labelName(), 0);
	}
      else
	check_labelName(a_faLabel->get_labelName(), log);
    }
}

/********************************************************************/

void check_featArc1Act(
 featArc1Act * a_featArc1Act,
 int log)
{
  if (a_featArc1Act->get_faLabel())
    {
      adjustLevels(&featArc1ActAtts_a_faLabel, "featArc1Act a_faLabel");
      if (log && !findString("a_faLabel", featArc1ActAtts))
	{
	  warnAtt("a_faLabel", "featArc1Act", a_featArc1Act);
	  check_faLabel(a_featArc1Act->get_faLabel(), 0);
	}
      else
	check_faLabel(a_featArc1Act->get_faLabel(), log);
    }
  if (a_featArc1Act->get_featMinorArc1())
    {
      adjustLevels(&featArc1ActAtts_a_featMinorArc1,
		   "featArc1Act a_featMinorArc1");
      if (log && !findString("a_featMinorArc1", featArc1ActAtts))
	{
	  warnAtt("a_featMinorArc1", "featArc1Act", a_featArc1Act);
	  check_featMinorArc1(a_featArc1Act->get_featMinorArc1(), 0);
	}
      else
	check_featMinorArc1(a_featArc1Act->get_featMinorArc1(), log);
    }
}

/********************************************************************/

void check_featArc1Nom(
 featArc1Nom * a_featArc1Nom,
 int log)
{
  if (a_featArc1Nom->get_fLabel())
    {
      adjustLevels(&featArc1NomAtts_a_fLabel, "featArc1Nom a_fLabel");
      if (log && !findString("a_fLabel", featArc1NomAtts))
	{
	  warnAtt("a_fLabel", "featArc1Nom", a_featArc1Nom);
	  check_fLabel(a_featArc1Nom->get_fLabel(), 0);
	}
      else
	check_fLabel(a_featArc1Nom->get_fLabel(), log);
    }
  if (a_featArc1Nom->get_featMinorArc1())
    {
      adjustLevels(&featArc1NomAtts_a_featMinorArc1,
		   "featArc1Nom a_featMinorArc1");
      if (log && !findString("a_featMinorArc1", featArc1NomAtts))
	{
	  warnAtt("a_featMinorArc1", "featArc1Nom", a_featArc1Nom);
	  check_featMinorArc1(a_featArc1Nom->get_featMinorArc1(), 0);
	}
      else
	check_featMinorArc1(a_featArc1Nom->get_featMinorArc1(), log);
    }
}

/********************************************************************/

void check_featArc1Stm(
 featArc1Stm * a_featArc1Stm,
 int log)
{
  if (isA(a_featArc1Stm, featArc1Nom))
    {
      adjustLevels(&featArc1StmSubs_featArc1Nom, "featArc1Nom");
      if (log && !findString("featArc1Nom", featArc1StmSubs))
	{
	  warnSub("featArc1Nom", "featArc1Stm", a_featArc1Stm);
	  check_featArc1Nom(dynamic_cast<featArc1Nom *>(a_featArc1Stm), 0);
	}
      else
	check_featArc1Nom(dynamic_cast<featArc1Nom *>(a_featArc1Stm), log);
      return;
    }
  if (isA(a_featArc1Stm, featArc1Act))
    {
      adjustLevels(&featArc1StmSubs_featArc1Act, "featArc1Act");
      if (log && !findString("featArc1Act", featArc1StmSubs))
	{
	  warnSub("featArc1Act", "featArc1Stm", a_featArc1Stm);
	  check_featArc1Act(dynamic_cast<featArc1Act *>(a_featArc1Stm), 0);
	}
      else
	check_featArc1Act(dynamic_cast<featArc1Act *>(a_featArc1Stm), log);
      return;
    }
}

/********************************************************************/

void check_featArc2Act(
 featArc2Act * a_featArc2Act,
 int log)
{
  if (a_featArc2Act->get_faLabel())
    {
      adjustLevels(&featArc2ActAtts_a_faLabel, "featArc2Act a_faLabel");
      if (log && !findString("a_faLabel", featArc2ActAtts))
	{
	  warnAtt("a_faLabel", "featArc2Act", a_featArc2Act);
	  check_faLabel(a_featArc2Act->get_faLabel(), 0);
	}
      else
	check_faLabel(a_featArc2Act->get_faLabel(), log);
    }
  if (a_featArc2Act->get_featMinorArc2())
    {
      adjustLevels(&featArc2ActAtts_a_featMinorArc2,
		   "featArc2Act a_featMinorArc2");
      if (log && !findString("a_featMinorArc2", featArc2ActAtts))
	{
	  warnAtt("a_featMinorArc2", "featArc2Act", a_featArc2Act);
	  check_featMinorArc2(a_featArc2Act->get_featMinorArc2(), 0);
	}
      else
	check_featMinorArc2(a_featArc2Act->get_featMinorArc2(), log);
    }
}

/********************************************************************/

void check_featArc2Nom(
 featArc2Nom * a_featArc2Nom,
 int log)
{
  if (a_featArc2Nom->get_fLabel())
    {
      adjustLevels(&featArc2NomAtts_a_fLabel, "featArc2Nom a_fLabel");
      if (log && !findString("a_fLabel", featArc2NomAtts))
	{
	  warnAtt("a_fLabel", "featArc2Nom", a_featArc2Nom);
	  check_fLabel(a_featArc2Nom->get_fLabel(), 0);
	}
      else
	check_fLabel(a_featArc2Nom->get_fLabel(), log);
    }
  if (a_featArc2Nom->get_featMinorArc2())
    {
      adjustLevels(&featArc2NomAtts_a_featMinorArc2,
		   "featArc2Nom a_featMinorArc2");
      if (log && !findString("a_featMinorArc2", featArc2NomAtts))
	{
	  warnAtt("a_featMinorArc2", "featArc2Nom", a_featArc2Nom);
	  check_featMinorArc2(a_featArc2Nom->get_featMinorArc2(), 0);
	}
      else
	check_featMinorArc2(a_featArc2Nom->get_featMinorArc2(), log);
    }
}

/********************************************************************/

void check_featArc2Stm(
 featArc2Stm * a_featArc2Stm,
 int log)
{
  if (isA(a_featArc2Stm, featArc2Nom))
    {
      adjustLevels(&featArc2StmSubs_featArc2Nom, "featArc2Nom");
      if (log && !findString("featArc2Nom", featArc2StmSubs))
	{
	  warnSub("featArc2Nom", "featArc2Stm", a_featArc2Stm);
	  check_featArc2Nom(dynamic_cast<featArc2Nom *>(a_featArc2Stm), 0);
	}
      else
	check_featArc2Nom(dynamic_cast<featArc2Nom *>(a_featArc2Stm), log);
      return;
    }
  if (isA(a_featArc2Stm, featArc2Act))
    {
      adjustLevels(&featArc2StmSubs_featArc2Act, "featArc2Act");
      if (log && !findString("featArc2Act", featArc2StmSubs))
	{
	  warnSub("featArc2Act", "featArc2Stm", a_featArc2Stm);
	  check_featArc2Act(dynamic_cast<featArc2Act *>(a_featArc2Stm), 0);
	}
      else
	check_featArc2Act(dynamic_cast<featArc2Act *>(a_featArc2Stm), log);
      return;
    }
}

/********************************************************************/

void check_featCircleAct(
 featCircleAct * a_featCircleAct,
 int log)
{
  if (a_featCircleAct->get_faLabel())
    {
      adjustLevels(&featCircleActAtts_a_faLabel, "featCircleAct a_faLabel");
      if (log && !findString("a_faLabel", featCircleActAtts))
	{
	  warnAtt("a_faLabel", "featCircleAct", a_featCircleAct);
	  check_faLabel(a_featCircleAct->get_faLabel(), 0);
	}
      else
	check_faLabel(a_featCircleAct->get_faLabel(), log);
    }
  if (a_featCircleAct->get_featMinorCircle())
    {
      adjustLevels(&featCircleActAtts_a_featMinorCircle,
		   "featCircleAct a_featMinorCircle");
      if (log && !findString("a_featMinorCircle", featCircleActAtts))
	{
	  warnAtt("a_featMinorCircle", "featCircleAct", a_featCircleAct);
	  check_featMinorCircle(a_featCircleAct->get_featMinorCircle(), 0);
	}
      else
	check_featMinorCircle(a_featCircleAct->get_featMinorCircle(), log);
    }
}

/********************************************************************/

void check_featCircleNom(
 featCircleNom * a_featCircleNom,
 int log)
{
  if (a_featCircleNom->get_fLabel())
    {
      adjustLevels(&featCircleNomAtts_a_fLabel, "featCircleNom a_fLabel");
      if (log && !findString("a_fLabel", featCircleNomAtts))
	{
	  warnAtt("a_fLabel", "featCircleNom", a_featCircleNom);
	  check_fLabel(a_featCircleNom->get_fLabel(), 0);
	}
      else
	check_fLabel(a_featCircleNom->get_fLabel(), log);
    }
  if (a_featCircleNom->get_featMinorCircle())
    {
      adjustLevels(&featCircleNomAtts_a_featMinorCircle,
		   "featCircleNom a_featMinorCircle");
      if (log && !findString("a_featMinorCircle", featCircleNomAtts))
	{
	  warnAtt("a_featMinorCircle", "featCircleNom", a_featCircleNom);
	  check_featMinorCircle(a_featCircleNom->get_featMinorCircle(), 0);
	}
      else
	check_featMinorCircle(a_featCircleNom->get_featMinorCircle(), log);
    }
}

/********************************************************************/

void check_featCircleStm(
 featCircleStm * a_featCircleStm,
 int log)
{
  if (isA(a_featCircleStm, featCircleNom))
    {
      adjustLevels(&featCircleStmSubs_featCircleNom, "featCircleNom");
      if (log && !findString("featCircleNom", featCircleStmSubs))
	{
	  warnSub("featCircleNom", "featCircleStm", a_featCircleStm);
	  check_featCircleNom(
	    dynamic_cast<featCircleNom *>(a_featCircleStm), 0);
	}
      else
	check_featCircleNom(
	  dynamic_cast<featCircleNom *>(a_featCircleStm), log);
      return;
    }
  if (isA(a_featCircleStm, featCircleAct))
    {
      adjustLevels(&featCircleStmSubs_featCircleAct, "featCircleAct");
      if (log && !findString("featCircleAct", featCircleStmSubs))
	{
	  warnSub("featCircleAct", "featCircleStm", a_featCircleStm);
	  check_featCircleAct(
	    dynamic_cast<featCircleAct *>(a_featCircleStm), 0);
	}
      else
	check_featCircleAct(
	  dynamic_cast<featCircleAct *>(a_featCircleStm), log);
      return;
    }
}

/********************************************************************/

void check_featCompoundAxial(
 featCompoundAxial * a_featCompoundAxial,
 int log)
{
  if (a_featCompoundAxial->get_typePoint())
    {
      adjustLevels(&featCompoundAxialAtts_a_typePoint,
		   "featCompoundAxial a_typePoint");
      if (log && !findString("a_typePoint", featCompoundAxialAtts))
	{
	  warnAtt("a_typePoint", "featCompoundAxial", a_featCompoundAxial);
	  check_typePoint(a_featCompoundAxial->get_typePoint(), 0);
	}
      else
	check_typePoint(a_featCompoundAxial->get_typePoint(), log);
    }
  if (a_featCompoundAxial->get_dir())
    {
      adjustLevels(&featCompoundAxialAtts_dir, "featCompoundAxial dir");
      if (log && !findString("dir", featCompoundAxialAtts))
	{
	  warnAtt("dir", "featCompoundAxial", a_featCompoundAxial);
	  check_vector(a_featCompoundAxial->get_dir(), 0);
	}
      else
	check_vector(a_featCompoundAxial->get_dir(), log);
    }
  if (a_featCompoundAxial->get_fLabel())
    {
      adjustLevels(&featCompoundAxialAtts_a_fLabel,
		   "featCompoundAxial a_fLabel");
      if (log && !findString("a_fLabel", featCompoundAxialAtts))
	{
	  warnAtt("a_fLabel", "featCompoundAxial", a_featCompoundAxial);
	  check_fLabel(a_featCompoundAxial->get_fLabel(), 0);
	}
      else
	check_fLabel(a_featCompoundAxial->get_fLabel(), log);
    }
  if (a_featCompoundAxial->get_featureNominalList())
    {
      std::list<fLabel *> * theList;
      std::list<fLabel *>::iterator iter;
      theList = a_featCompoundAxial->get_featureNominalList();
      adjustLevels(&featCompoundAxialAtts_a_featureNominalList,
		   "featCompoundAxial a_featureNominalList");
      if (log && !findString("a_featureNominalList", featCompoundAxialAtts))
	{
	  warnAtt("a_featureNominalList", "featCompoundAxial",
		  a_featCompoundAxial);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_fLabel(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_fLabel(*iter, log);
	}
    }
}

/********************************************************************/

void check_featCompoundPlane(
 featCompoundPlane * a_featCompoundPlane,
 int log)
{
  if (a_featCompoundPlane->get_typePoint())
    {
      adjustLevels(&featCompoundPlaneAtts_a_typePoint,
		   "featCompoundPlane a_typePoint");
      if (log && !findString("a_typePoint", featCompoundPlaneAtts))
	{
	  warnAtt("a_typePoint", "featCompoundPlane", a_featCompoundPlane);
	  check_typePoint(a_featCompoundPlane->get_typePoint(), 0);
	}
      else
	check_typePoint(a_featCompoundPlane->get_typePoint(), log);
    }
  if (a_featCompoundPlane->get_dir())
    {
      adjustLevels(&featCompoundPlaneAtts_dir, "featCompoundPlane dir");
      if (log && !findString("dir", featCompoundPlaneAtts))
	{
	  warnAtt("dir", "featCompoundPlane", a_featCompoundPlane);
	  check_vector(a_featCompoundPlane->get_dir(), 0);
	}
      else
	check_vector(a_featCompoundPlane->get_dir(), log);
    }
  if (a_featCompoundPlane->get_fLabel())
    {
      adjustLevels(&featCompoundPlaneAtts_a_fLabel,
		   "featCompoundPlane a_fLabel");
      if (log && !findString("a_fLabel", featCompoundPlaneAtts))
	{
	  warnAtt("a_fLabel", "featCompoundPlane", a_featCompoundPlane);
	  check_fLabel(a_featCompoundPlane->get_fLabel(), 0);
	}
      else
	check_fLabel(a_featCompoundPlane->get_fLabel(), log);
    }
  if (a_featCompoundPlane->get_featureNominalList())
    {
      std::list<fLabel *> * theList;
      std::list<fLabel *>::iterator iter;
      theList = a_featCompoundPlane->get_featureNominalList();
      adjustLevels(&featCompoundPlaneAtts_a_featureNominalList,
		   "featCompoundPlane a_featureNominalList");
      if (log && !findString("a_featureNominalList", featCompoundPlaneAtts))
	{
	  warnAtt("a_featureNominalList", "featCompoundPlane",
		  a_featCompoundPlane);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_fLabel(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_fLabel(*iter, log);
	}
    }
}

/********************************************************************/

void check_featCompoundSphere(
 featCompoundSphere * a_featCompoundSphere,
 int log)
{
  if (a_featCompoundSphere->get_typePoint())
    {
      adjustLevels(&featCompoundSphereAtts_a_typePoint,
		   "featCompoundSphere a_typePoint");
      if (log && !findString("a_typePoint", featCompoundSphereAtts))
	{
	  warnAtt("a_typePoint", "featCompoundSphere", a_featCompoundSphere);
	  check_typePoint(a_featCompoundSphere->get_typePoint(), 0);
	}
      else
	check_typePoint(a_featCompoundSphere->get_typePoint(), log);
    }
  if (a_featCompoundSphere->get_fLabel())
    {
      adjustLevels(&featCompoundSphereAtts_a_fLabel,
		   "featCompoundSphere a_fLabel");
      if (log && !findString("a_fLabel", featCompoundSphereAtts))
	{
	  warnAtt("a_fLabel", "featCompoundSphere", a_featCompoundSphere);
	  check_fLabel(a_featCompoundSphere->get_fLabel(), 0);
	}
      else
	check_fLabel(a_featCompoundSphere->get_fLabel(), log);
    }
  if (a_featCompoundSphere->get_featureNominalList())
    {
      std::list<fLabel *> * theList;
      std::list<fLabel *>::iterator iter;
      theList = a_featCompoundSphere->get_featureNominalList();
      adjustLevels(&featCompoundSphereAtts_a_featureNominalList,
		   "featCompoundSphere a_featureNominalList");
      if (log && !findString("a_featureNominalList", featCompoundSphereAtts))
	{
	  warnAtt("a_featureNominalList", "featCompoundSphere",
		  a_featCompoundSphere);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_fLabel(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_fLabel(*iter, log);
	}
    }
}

/********************************************************************/

void check_featCompoundStm(
 featCompoundStm * a_featCompoundStm,
 int log)
{
  if (a_featCompoundStm->get_fLabel())
    {
      adjustLevels(&featCompoundStmAtts_a_fLabel, "featCompoundStm a_fLabel");
      if (log && !findString("a_fLabel", featCompoundStmAtts))
	{
	  warnAtt("a_fLabel", "featCompoundStm", a_featCompoundStm);
	  check_fLabel(a_featCompoundStm->get_fLabel(), 0);
	}
      else
	check_fLabel(a_featCompoundStm->get_fLabel(), log);
    }
  if (a_featCompoundStm->get_featMinorCompound())
    {
      adjustLevels(&featCompoundStmAtts_a_featMinorCompound,
		   "featCompoundStm a_featMinorCompound");
      if (log && !findString("a_featMinorCompound", featCompoundStmAtts))
	{
	  warnAtt("a_featMinorCompound", "featCompoundStm",
		  a_featCompoundStm);
	  check_featMinorCompound(
	    a_featCompoundStm->get_featMinorCompound(), 0);
	}
      else
	check_featMinorCompound(
	  a_featCompoundStm->get_featMinorCompound(), log);
    }
}

/********************************************************************/

void check_featConeAct(
 featConeAct * a_featConeAct,
 int log)
{
  if (a_featConeAct->get_faLabel())
    {
      adjustLevels(&featConeActAtts_a_faLabel, "featConeAct a_faLabel");
      if (log && !findString("a_faLabel", featConeActAtts))
	{
	  warnAtt("a_faLabel", "featConeAct", a_featConeAct);
	  check_faLabel(a_featConeAct->get_faLabel(), 0);
	}
      else
	check_faLabel(a_featConeAct->get_faLabel(), log);
    }
  if (a_featConeAct->get_featMinorCone())
    {
      adjustLevels(&featConeActAtts_a_featMinorCone,
		   "featConeAct a_featMinorCone");
      if (log && !findString("a_featMinorCone", featConeActAtts))
	{
	  warnAtt("a_featMinorCone", "featConeAct", a_featConeAct);
	  check_featMinorCone(a_featConeAct->get_featMinorCone(), 0);
	}
      else
	check_featMinorCone(a_featConeAct->get_featMinorCone(), log);
    }
}

/********************************************************************/

void check_featConeNom(
 featConeNom * a_featConeNom,
 int log)
{
  if (a_featConeNom->get_fLabel())
    {
      adjustLevels(&featConeNomAtts_a_fLabel, "featConeNom a_fLabel");
      if (log && !findString("a_fLabel", featConeNomAtts))
	{
	  warnAtt("a_fLabel", "featConeNom", a_featConeNom);
	  check_fLabel(a_featConeNom->get_fLabel(), 0);
	}
      else
	check_fLabel(a_featConeNom->get_fLabel(), log);
    }
  if (a_featConeNom->get_featMinorCone())
    {
      adjustLevels(&featConeNomAtts_a_featMinorCone,
		   "featConeNom a_featMinorCone");
      if (log && !findString("a_featMinorCone", featConeNomAtts))
	{
	  warnAtt("a_featMinorCone", "featConeNom", a_featConeNom);
	  check_featMinorCone(a_featConeNom->get_featMinorCone(), 0);
	}
      else
	check_featMinorCone(a_featConeNom->get_featMinorCone(), log);
    }
}

/********************************************************************/

void check_featConeStm(
 featConeStm * a_featConeStm,
 int log)
{
  if (isA(a_featConeStm, featConeNom))
    {
      adjustLevels(&featConeStmSubs_featConeNom, "featConeNom");
      if (log && !findString("featConeNom", featConeStmSubs))
	{
	  warnSub("featConeNom", "featConeStm", a_featConeStm);
	  check_featConeNom(dynamic_cast<featConeNom *>(a_featConeStm), 0);
	}
      else
	check_featConeNom(dynamic_cast<featConeNom *>(a_featConeStm), log);
      return;
    }
  if (isA(a_featConeStm, featConeAct))
    {
      adjustLevels(&featConeStmSubs_featConeAct, "featConeAct");
      if (log && !findString("featConeAct", featConeStmSubs))
	{
	  warnSub("featConeAct", "featConeStm", a_featConeStm);
	  check_featConeAct(dynamic_cast<featConeAct *>(a_featConeStm), 0);
	}
      else
	check_featConeAct(dynamic_cast<featConeAct *>(a_featConeStm), log);
      return;
    }
}

/********************************************************************/

void check_featConradsegAct(
 featConradsegAct * a_featConradsegAct,
 int log)
{
  if (a_featConradsegAct->get_faLabel())
    {
      adjustLevels(&featConradsegActAtts_a_faLabel,
		   "featConradsegAct a_faLabel");
      if (log && !findString("a_faLabel", featConradsegActAtts))
	{
	  warnAtt("a_faLabel", "featConradsegAct", a_featConradsegAct);
	  check_faLabel(a_featConradsegAct->get_faLabel(), 0);
	}
      else
	check_faLabel(a_featConradsegAct->get_faLabel(), log);
    }
  if (a_featConradsegAct->get_featMinorConradseg())
    {
      adjustLevels(&featConradsegActAtts_a_featMinorConradseg,
		   "featConradsegAct a_featMinorConradseg");
      if (log && !findString("a_featMinorConradseg", featConradsegActAtts))
	{
	  warnAtt("a_featMinorConradseg", "featConradsegAct",
		  a_featConradsegAct);
	  check_featMinorConradseg(
	    a_featConradsegAct->get_featMinorConradseg(), 0);
	}
      else
	check_featMinorConradseg(
	  a_featConradsegAct->get_featMinorConradseg(), log);
    }
}

/********************************************************************/

void check_featConradsegCart(
 featConradsegCart * a_featConradsegCart,
 int log)
{
  if (a_featConradsegCart->get_matDir())
    {
      adjustLevels(&featConradsegCartAtts_a_matDir,
		   "featConradsegCart a_matDir");
      if (log && !findString("a_matDir", featConradsegCartAtts))
	{
	  warnAtt("a_matDir", "featConradsegCart", a_featConradsegCart);
	  check_matDir(a_featConradsegCart->get_matDir(), 0);
	}
      else
	check_matDir(a_featConradsegCart->get_matDir(), log);
    }
  if (a_featConradsegCart->get_axisStart())
    {
      adjustLevels(&featConradsegCartAtts_axisStart,
		   "featConradsegCart axisStart");
      if (log && !findString("axisStart", featConradsegCartAtts))
	{
	  warnAtt("axisStart", "featConradsegCart", a_featConradsegCart);
	  check_cartPoint(a_featConradsegCart->get_axisStart(), 0);
	}
      else
	check_cartPoint(a_featConradsegCart->get_axisStart(), log);
    }
  if (a_featConradsegCart->get_axisEnd())
    {
      adjustLevels(&featConradsegCartAtts_axisEnd,
		   "featConradsegCart axisEnd");
      if (log && !findString("axisEnd", featConradsegCartAtts))
	{
	  warnAtt("axisEnd", "featConradsegCart", a_featConradsegCart);
	  check_impCartPoint(a_featConradsegCart->get_axisEnd(), 0);
	}
      else
	check_impCartPoint(a_featConradsegCart->get_axisEnd(), log);
    }
  if (a_featConradsegCart->get_startRad())
    {
      adjustLevels(&featConradsegCartAtts_startRad,
		   "featConradsegCart startRad");
      if (log && !findString("startRad", featConradsegCartAtts))
	{
	  warnAtt("startRad", "featConradsegCart", a_featConradsegCart);
	  check_rentVal(a_featConradsegCart->get_startRad(), 0);
	}
      else
	check_rentVal(a_featConradsegCart->get_startRad(), log);
    }
  if (a_featConradsegCart->get_endRad())
    {
      adjustLevels(&featConradsegCartAtts_endRad, "featConradsegCart endRad");
      if (log && !findString("endRad", featConradsegCartAtts))
	{
	  warnAtt("endRad", "featConradsegCart", a_featConradsegCart);
	  check_rentVal(a_featConradsegCart->get_endRad(), 0);
	}
      else
	check_rentVal(a_featConradsegCart->get_endRad(), log);
    }
  if (a_featConradsegCart->get_longStart())
    {
      adjustLevels(&featConradsegCartAtts_longStart,
		   "featConradsegCart longStart");
      if (log && !findString("longStart", featConradsegCartAtts))
	{
	  warnAtt("longStart", "featConradsegCart", a_featConradsegCart);
	  check_vector(a_featConradsegCart->get_longStart(), 0);
	}
      else
	check_vector(a_featConradsegCart->get_longStart(), log);
    }
  if (a_featConradsegCart->get_longEnd())
    {
      adjustLevels(&featConradsegCartAtts_longEnd,
		   "featConradsegCart longEnd");
      if (log && !findString("longEnd", featConradsegCartAtts))
	{
	  warnAtt("longEnd", "featConradsegCart", a_featConradsegCart);
	  check_vector(a_featConradsegCart->get_longEnd(), 0);
	}
      else
	check_vector(a_featConradsegCart->get_longEnd(), log);
    }
}

/********************************************************************/

void check_featConradsegNom(
 featConradsegNom * a_featConradsegNom,
 int log)
{
  if (a_featConradsegNom->get_fLabel())
    {
      adjustLevels(&featConradsegNomAtts_a_fLabel,
		   "featConradsegNom a_fLabel");
      if (log && !findString("a_fLabel", featConradsegNomAtts))
	{
	  warnAtt("a_fLabel", "featConradsegNom", a_featConradsegNom);
	  check_fLabel(a_featConradsegNom->get_fLabel(), 0);
	}
      else
	check_fLabel(a_featConradsegNom->get_fLabel(), log);
    }
  if (a_featConradsegNom->get_featMinorConradseg())
    {
      adjustLevels(&featConradsegNomAtts_a_featMinorConradseg,
		   "featConradsegNom a_featMinorConradseg");
      if (log && !findString("a_featMinorConradseg", featConradsegNomAtts))
	{
	  warnAtt("a_featMinorConradseg", "featConradsegNom",
		  a_featConradsegNom);
	  check_featMinorConradseg(
	    a_featConradsegNom->get_featMinorConradseg(), 0);
	}
      else
	check_featMinorConradseg(
	  a_featConradsegNom->get_featMinorConradseg(), log);
    }
}

/********************************************************************/

void check_featConradsegPol(
 featConradsegPol * a_featConradsegPol,
 int log)
{
  if (a_featConradsegPol->get_matDir())
    {
      adjustLevels(&featConradsegPolAtts_a_matDir,
		   "featConradsegPol a_matDir");
      if (log && !findString("a_matDir", featConradsegPolAtts))
	{
	  warnAtt("a_matDir", "featConradsegPol", a_featConradsegPol);
	  check_matDir(a_featConradsegPol->get_matDir(), 0);
	}
      else
	check_matDir(a_featConradsegPol->get_matDir(), log);
    }
  if (a_featConradsegPol->get_axisStart())
    {
      adjustLevels(&featConradsegPolAtts_axisStart,
		   "featConradsegPol axisStart");
      if (log && !findString("axisStart", featConradsegPolAtts))
	{
	  warnAtt("axisStart", "featConradsegPol", a_featConradsegPol);
	  check_polPoint(a_featConradsegPol->get_axisStart(), 0);
	}
      else
	check_polPoint(a_featConradsegPol->get_axisStart(), log);
    }
  if (a_featConradsegPol->get_axisEnd())
    {
      adjustLevels(&featConradsegPolAtts_axisEnd, "featConradsegPol axisEnd");
      if (log && !findString("axisEnd", featConradsegPolAtts))
	{
	  warnAtt("axisEnd", "featConradsegPol", a_featConradsegPol);
	  check_impPolPoint(a_featConradsegPol->get_axisEnd(), 0);
	}
      else
	check_impPolPoint(a_featConradsegPol->get_axisEnd(), log);
    }
  if (a_featConradsegPol->get_startRad())
    {
      adjustLevels(&featConradsegPolAtts_startRad,
		   "featConradsegPol startRad");
      if (log && !findString("startRad", featConradsegPolAtts))
	{
	  warnAtt("startRad", "featConradsegPol", a_featConradsegPol);
	  check_rentVal(a_featConradsegPol->get_startRad(), 0);
	}
      else
	check_rentVal(a_featConradsegPol->get_startRad(), log);
    }
  if (a_featConradsegPol->get_endRad())
    {
      adjustLevels(&featConradsegPolAtts_endRad, "featConradsegPol endRad");
      if (log && !findString("endRad", featConradsegPolAtts))
	{
	  warnAtt("endRad", "featConradsegPol", a_featConradsegPol);
	  check_rentVal(a_featConradsegPol->get_endRad(), 0);
	}
      else
	check_rentVal(a_featConradsegPol->get_endRad(), log);
    }
  if (a_featConradsegPol->get_longStart())
    {
      adjustLevels(&featConradsegPolAtts_longStart,
		   "featConradsegPol longStart");
      if (log && !findString("longStart", featConradsegPolAtts))
	{
	  warnAtt("longStart", "featConradsegPol", a_featConradsegPol);
	  check_vector(a_featConradsegPol->get_longStart(), 0);
	}
      else
	check_vector(a_featConradsegPol->get_longStart(), log);
    }
  if (a_featConradsegPol->get_longEnd())
    {
      adjustLevels(&featConradsegPolAtts_longEnd, "featConradsegPol longEnd");
      if (log && !findString("longEnd", featConradsegPolAtts))
	{
	  warnAtt("longEnd", "featConradsegPol", a_featConradsegPol);
	  check_vector(a_featConradsegPol->get_longEnd(), 0);
	}
      else
	check_vector(a_featConradsegPol->get_longEnd(), log);
    }
}

/********************************************************************/

void check_featConradsegStm(
 featConradsegStm * a_featConradsegStm,
 int log)
{
  if (isA(a_featConradsegStm, featConradsegNom))
    {
      adjustLevels(&featConradsegStmSubs_featConradsegNom, "featConradsegNom");
      if (log && !findString("featConradsegNom", featConradsegStmSubs))
	{
	  warnSub("featConradsegNom", "featConradsegStm", a_featConradsegStm);
	  check_featConradsegNom(
	    dynamic_cast<featConradsegNom *>(a_featConradsegStm), 0);
	}
      else
	check_featConradsegNom(
	  dynamic_cast<featConradsegNom *>(a_featConradsegStm), log);
      return;
    }
  if (isA(a_featConradsegStm, featConradsegAct))
    {
      adjustLevels(&featConradsegStmSubs_featConradsegAct, "featConradsegAct");
      if (log && !findString("featConradsegAct", featConradsegStmSubs))
	{
	  warnSub("featConradsegAct", "featConradsegStm", a_featConradsegStm);
	  check_featConradsegAct(
	    dynamic_cast<featConradsegAct *>(a_featConradsegStm), 0);
	}
      else
	check_featConradsegAct(
	  dynamic_cast<featConradsegAct *>(a_featConradsegStm), log);
      return;
    }
}

/********************************************************************/

void check_featCparlnAct(
 featCparlnAct * a_featCparlnAct,
 int log)
{
  if (a_featCparlnAct->get_faLabel())
    {
      adjustLevels(&featCparlnActAtts_a_faLabel, "featCparlnAct a_faLabel");
      if (log && !findString("a_faLabel", featCparlnActAtts))
	{
	  warnAtt("a_faLabel", "featCparlnAct", a_featCparlnAct);
	  check_faLabel(a_featCparlnAct->get_faLabel(), 0);
	}
      else
	check_faLabel(a_featCparlnAct->get_faLabel(), log);
    }
  if (a_featCparlnAct->get_featMinorCparln())
    {
      adjustLevels(&featCparlnActAtts_a_featMinorCparln,
		   "featCparlnAct a_featMinorCparln");
      if (log && !findString("a_featMinorCparln", featCparlnActAtts))
	{
	  warnAtt("a_featMinorCparln", "featCparlnAct", a_featCparlnAct);
	  check_featMinorCparln(a_featCparlnAct->get_featMinorCparln(), 0);
	}
      else
	check_featMinorCparln(a_featCparlnAct->get_featMinorCparln(), log);
    }
}

/********************************************************************/

void check_featCparlnNom(
 featCparlnNom * a_featCparlnNom,
 int log)
{
  if (a_featCparlnNom->get_fLabel())
    {
      adjustLevels(&featCparlnNomAtts_a_fLabel, "featCparlnNom a_fLabel");
      if (log && !findString("a_fLabel", featCparlnNomAtts))
	{
	  warnAtt("a_fLabel", "featCparlnNom", a_featCparlnNom);
	  check_fLabel(a_featCparlnNom->get_fLabel(), 0);
	}
      else
	check_fLabel(a_featCparlnNom->get_fLabel(), log);
    }
  if (a_featCparlnNom->get_featMinorCparln())
    {
      adjustLevels(&featCparlnNomAtts_a_featMinorCparln,
		   "featCparlnNom a_featMinorCparln");
      if (log && !findString("a_featMinorCparln", featCparlnNomAtts))
	{
	  warnAtt("a_featMinorCparln", "featCparlnNom", a_featCparlnNom);
	  check_featMinorCparln(a_featCparlnNom->get_featMinorCparln(), 0);
	}
      else
	check_featMinorCparln(a_featCparlnNom->get_featMinorCparln(), log);
    }
}

/********************************************************************/

void check_featCparlnStm(
 featCparlnStm * a_featCparlnStm,
 int log)
{
  if (isA(a_featCparlnStm, featCparlnNom))
    {
      adjustLevels(&featCparlnStmSubs_featCparlnNom, "featCparlnNom");
      if (log && !findString("featCparlnNom", featCparlnStmSubs))
	{
	  warnSub("featCparlnNom", "featCparlnStm", a_featCparlnStm);
	  check_featCparlnNom(
	    dynamic_cast<featCparlnNom *>(a_featCparlnStm), 0);
	}
      else
	check_featCparlnNom(
	  dynamic_cast<featCparlnNom *>(a_featCparlnStm), log);
      return;
    }
  if (isA(a_featCparlnStm, featCparlnAct))
    {
      adjustLevels(&featCparlnStmSubs_featCparlnAct, "featCparlnAct");
      if (log && !findString("featCparlnAct", featCparlnStmSubs))
	{
	  warnSub("featCparlnAct", "featCparlnStm", a_featCparlnStm);
	  check_featCparlnAct(
	    dynamic_cast<featCparlnAct *>(a_featCparlnStm), 0);
	}
      else
	check_featCparlnAct(
	  dynamic_cast<featCparlnAct *>(a_featCparlnStm), log);
      return;
    }
}

/********************************************************************/

void check_featCylndrAct(
 featCylndrAct * a_featCylndrAct,
 int log)
{
  if (a_featCylndrAct->get_faLabel())
    {
      adjustLevels(&featCylndrActAtts_a_faLabel, "featCylndrAct a_faLabel");
      if (log && !findString("a_faLabel", featCylndrActAtts))
	{
	  warnAtt("a_faLabel", "featCylndrAct", a_featCylndrAct);
	  check_faLabel(a_featCylndrAct->get_faLabel(), 0);
	}
      else
	check_faLabel(a_featCylndrAct->get_faLabel(), log);
    }
  if (a_featCylndrAct->get_featMinorCylndr())
    {
      adjustLevels(&featCylndrActAtts_a_featMinorCylndr,
		   "featCylndrAct a_featMinorCylndr");
      if (log && !findString("a_featMinorCylndr", featCylndrActAtts))
	{
	  warnAtt("a_featMinorCylndr", "featCylndrAct", a_featCylndrAct);
	  check_featMinorCylndr(a_featCylndrAct->get_featMinorCylndr(), 0);
	}
      else
	check_featMinorCylndr(a_featCylndrAct->get_featMinorCylndr(), log);
    }
}

/********************************************************************/

void check_featCylndrNom(
 featCylndrNom * a_featCylndrNom,
 int log)
{
  if (a_featCylndrNom->get_fLabel())
    {
      adjustLevels(&featCylndrNomAtts_a_fLabel, "featCylndrNom a_fLabel");
      if (log && !findString("a_fLabel", featCylndrNomAtts))
	{
	  warnAtt("a_fLabel", "featCylndrNom", a_featCylndrNom);
	  check_fLabel(a_featCylndrNom->get_fLabel(), 0);
	}
      else
	check_fLabel(a_featCylndrNom->get_fLabel(), log);
    }
  if (a_featCylndrNom->get_featMinorCylndr())
    {
      adjustLevels(&featCylndrNomAtts_a_featMinorCylndr,
		   "featCylndrNom a_featMinorCylndr");
      if (log && !findString("a_featMinorCylndr", featCylndrNomAtts))
	{
	  warnAtt("a_featMinorCylndr", "featCylndrNom", a_featCylndrNom);
	  check_featMinorCylndr(a_featCylndrNom->get_featMinorCylndr(), 0);
	}
      else
	check_featMinorCylndr(a_featCylndrNom->get_featMinorCylndr(), log);
    }
}

/********************************************************************/

void check_featCylndrStm(
 featCylndrStm * a_featCylndrStm,
 int log)
{
  if (isA(a_featCylndrStm, featCylndrNom))
    {
      adjustLevels(&featCylndrStmSubs_featCylndrNom, "featCylndrNom");
      if (log && !findString("featCylndrNom", featCylndrStmSubs))
	{
	  warnSub("featCylndrNom", "featCylndrStm", a_featCylndrStm);
	  check_featCylndrNom(
	    dynamic_cast<featCylndrNom *>(a_featCylndrStm), 0);
	}
      else
	check_featCylndrNom(
	  dynamic_cast<featCylndrNom *>(a_featCylndrStm), log);
      return;
    }
  if (isA(a_featCylndrStm, featCylndrAct))
    {
      adjustLevels(&featCylndrStmSubs_featCylndrAct, "featCylndrAct");
      if (log && !findString("featCylndrAct", featCylndrStmSubs))
	{
	  warnSub("featCylndrAct", "featCylndrStm", a_featCylndrStm);
	  check_featCylndrAct(
	    dynamic_cast<featCylndrAct *>(a_featCylndrStm), 0);
	}
      else
	check_featCylndrAct(
	  dynamic_cast<featCylndrAct *>(a_featCylndrStm), log);
      return;
    }
}

/********************************************************************/

void check_featCylradsegAct(
 featCylradsegAct * a_featCylradsegAct,
 int log)
{
  if (a_featCylradsegAct->get_faLabel())
    {
      adjustLevels(&featCylradsegActAtts_a_faLabel,
		   "featCylradsegAct a_faLabel");
      if (log && !findString("a_faLabel", featCylradsegActAtts))
	{
	  warnAtt("a_faLabel", "featCylradsegAct", a_featCylradsegAct);
	  check_faLabel(a_featCylradsegAct->get_faLabel(), 0);
	}
      else
	check_faLabel(a_featCylradsegAct->get_faLabel(), log);
    }
  if (a_featCylradsegAct->get_featMinorCylradseg())
    {
      adjustLevels(&featCylradsegActAtts_a_featMinorCylradseg,
		   "featCylradsegAct a_featMinorCylradseg");
      if (log && !findString("a_featMinorCylradseg", featCylradsegActAtts))
	{
	  warnAtt("a_featMinorCylradseg", "featCylradsegAct",
		  a_featCylradsegAct);
	  check_featMinorCylradseg(
	    a_featCylradsegAct->get_featMinorCylradseg(), 0);
	}
      else
	check_featMinorCylradseg(
	  a_featCylradsegAct->get_featMinorCylradseg(), log);
    }
}

/********************************************************************/

void check_featCylradsegCart(
 featCylradsegCart * a_featCylradsegCart,
 int log)
{
  if (a_featCylradsegCart->get_matDir())
    {
      adjustLevels(&featCylradsegCartAtts_a_matDir,
		   "featCylradsegCart a_matDir");
      if (log && !findString("a_matDir", featCylradsegCartAtts))
	{
	  warnAtt("a_matDir", "featCylradsegCart", a_featCylradsegCart);
	  check_matDir(a_featCylradsegCart->get_matDir(), 0);
	}
      else
	check_matDir(a_featCylradsegCart->get_matDir(), log);
    }
  if (a_featCylradsegCart->get_axisStart())
    {
      adjustLevels(&featCylradsegCartAtts_axisStart,
		   "featCylradsegCart axisStart");
      if (log && !findString("axisStart", featCylradsegCartAtts))
	{
	  warnAtt("axisStart", "featCylradsegCart", a_featCylradsegCart);
	  check_cartPoint(a_featCylradsegCart->get_axisStart(), 0);
	}
      else
	check_cartPoint(a_featCylradsegCart->get_axisStart(), log);
    }
  if (a_featCylradsegCart->get_axisEnd())
    {
      adjustLevels(&featCylradsegCartAtts_axisEnd,
		   "featCylradsegCart axisEnd");
      if (log && !findString("axisEnd", featCylradsegCartAtts))
	{
	  warnAtt("axisEnd", "featCylradsegCart", a_featCylradsegCart);
	  check_impCartPoint(a_featCylradsegCart->get_axisEnd(), 0);
	}
      else
	check_impCartPoint(a_featCylradsegCart->get_axisEnd(), log);
    }
  if (a_featCylradsegCart->get_rad())
    {
      adjustLevels(&featCylradsegCartAtts_rad, "featCylradsegCart rad");
      if (log && !findString("rad", featCylradsegCartAtts))
	{
	  warnAtt("rad", "featCylradsegCart", a_featCylradsegCart);
	  check_rentVal(a_featCylradsegCart->get_rad(), 0);
	}
      else
	check_rentVal(a_featCylradsegCart->get_rad(), log);
    }
  if (a_featCylradsegCart->get_longStart())
    {
      adjustLevels(&featCylradsegCartAtts_longStart,
		   "featCylradsegCart longStart");
      if (log && !findString("longStart", featCylradsegCartAtts))
	{
	  warnAtt("longStart", "featCylradsegCart", a_featCylradsegCart);
	  check_vector(a_featCylradsegCart->get_longStart(), 0);
	}
      else
	check_vector(a_featCylradsegCart->get_longStart(), log);
    }
  if (a_featCylradsegCart->get_longEnd())
    {
      adjustLevels(&featCylradsegCartAtts_longEnd,
		   "featCylradsegCart longEnd");
      if (log && !findString("longEnd", featCylradsegCartAtts))
	{
	  warnAtt("longEnd", "featCylradsegCart", a_featCylradsegCart);
	  check_vector(a_featCylradsegCart->get_longEnd(), 0);
	}
      else
	check_vector(a_featCylradsegCart->get_longEnd(), log);
    }
}

/********************************************************************/

void check_featCylradsegNom(
 featCylradsegNom * a_featCylradsegNom,
 int log)
{
  if (a_featCylradsegNom->get_fLabel())
    {
      adjustLevels(&featCylradsegNomAtts_a_fLabel,
		   "featCylradsegNom a_fLabel");
      if (log && !findString("a_fLabel", featCylradsegNomAtts))
	{
	  warnAtt("a_fLabel", "featCylradsegNom", a_featCylradsegNom);
	  check_fLabel(a_featCylradsegNom->get_fLabel(), 0);
	}
      else
	check_fLabel(a_featCylradsegNom->get_fLabel(), log);
    }
  if (a_featCylradsegNom->get_featMinorCylradseg())
    {
      adjustLevels(&featCylradsegNomAtts_a_featMinorCylradseg,
		   "featCylradsegNom a_featMinorCylradseg");
      if (log && !findString("a_featMinorCylradseg", featCylradsegNomAtts))
	{
	  warnAtt("a_featMinorCylradseg", "featCylradsegNom",
		  a_featCylradsegNom);
	  check_featMinorCylradseg(
	    a_featCylradsegNom->get_featMinorCylradseg(), 0);
	}
      else
	check_featMinorCylradseg(
	  a_featCylradsegNom->get_featMinorCylradseg(), log);
    }
}

/********************************************************************/

void check_featCylradsegPol(
 featCylradsegPol * a_featCylradsegPol,
 int log)
{
  if (a_featCylradsegPol->get_matDir())
    {
      adjustLevels(&featCylradsegPolAtts_a_matDir,
		   "featCylradsegPol a_matDir");
      if (log && !findString("a_matDir", featCylradsegPolAtts))
	{
	  warnAtt("a_matDir", "featCylradsegPol", a_featCylradsegPol);
	  check_matDir(a_featCylradsegPol->get_matDir(), 0);
	}
      else
	check_matDir(a_featCylradsegPol->get_matDir(), log);
    }
  if (a_featCylradsegPol->get_axisStart())
    {
      adjustLevels(&featCylradsegPolAtts_axisStart,
		   "featCylradsegPol axisStart");
      if (log && !findString("axisStart", featCylradsegPolAtts))
	{
	  warnAtt("axisStart", "featCylradsegPol", a_featCylradsegPol);
	  check_polPoint(a_featCylradsegPol->get_axisStart(), 0);
	}
      else
	check_polPoint(a_featCylradsegPol->get_axisStart(), log);
    }
  if (a_featCylradsegPol->get_axisEnd())
    {
      adjustLevels(&featCylradsegPolAtts_axisEnd, "featCylradsegPol axisEnd");
      if (log && !findString("axisEnd", featCylradsegPolAtts))
	{
	  warnAtt("axisEnd", "featCylradsegPol", a_featCylradsegPol);
	  check_impPolPoint(a_featCylradsegPol->get_axisEnd(), 0);
	}
      else
	check_impPolPoint(a_featCylradsegPol->get_axisEnd(), log);
    }
  if (a_featCylradsegPol->get_rad())
    {
      adjustLevels(&featCylradsegPolAtts_rad, "featCylradsegPol rad");
      if (log && !findString("rad", featCylradsegPolAtts))
	{
	  warnAtt("rad", "featCylradsegPol", a_featCylradsegPol);
	  check_rentVal(a_featCylradsegPol->get_rad(), 0);
	}
      else
	check_rentVal(a_featCylradsegPol->get_rad(), log);
    }
  if (a_featCylradsegPol->get_longStart())
    {
      adjustLevels(&featCylradsegPolAtts_longStart,
		   "featCylradsegPol longStart");
      if (log && !findString("longStart", featCylradsegPolAtts))
	{
	  warnAtt("longStart", "featCylradsegPol", a_featCylradsegPol);
	  check_vector(a_featCylradsegPol->get_longStart(), 0);
	}
      else
	check_vector(a_featCylradsegPol->get_longStart(), log);
    }
  if (a_featCylradsegPol->get_longEnd())
    {
      adjustLevels(&featCylradsegPolAtts_longEnd, "featCylradsegPol longEnd");
      if (log && !findString("longEnd", featCylradsegPolAtts))
	{
	  warnAtt("longEnd", "featCylradsegPol", a_featCylradsegPol);
	  check_vector(a_featCylradsegPol->get_longEnd(), 0);
	}
      else
	check_vector(a_featCylradsegPol->get_longEnd(), log);
    }
}

/********************************************************************/

void check_featCylradsegStm(
 featCylradsegStm * a_featCylradsegStm,
 int log)
{
  if (isA(a_featCylradsegStm, featCylradsegNom))
    {
      adjustLevels(&featCylradsegStmSubs_featCylradsegNom, "featCylradsegNom");
      if (log && !findString("featCylradsegNom", featCylradsegStmSubs))
	{
	  warnSub("featCylradsegNom", "featCylradsegStm", a_featCylradsegStm);
	  check_featCylradsegNom(
	    dynamic_cast<featCylradsegNom *>(a_featCylradsegStm), 0);
	}
      else
	check_featCylradsegNom(
	  dynamic_cast<featCylradsegNom *>(a_featCylradsegStm), log);
      return;
    }
  if (isA(a_featCylradsegStm, featCylradsegAct))
    {
      adjustLevels(&featCylradsegStmSubs_featCylradsegAct, "featCylradsegAct");
      if (log && !findString("featCylradsegAct", featCylradsegStmSubs))
	{
	  warnSub("featCylradsegAct", "featCylradsegStm", a_featCylradsegStm);
	  check_featCylradsegAct(
	    dynamic_cast<featCylradsegAct *>(a_featCylradsegStm), 0);
	}
      else
	check_featCylradsegAct(
	  dynamic_cast<featCylradsegAct *>(a_featCylradsegStm), log);
      return;
    }
}

/********************************************************************/

void check_featEdgeptAct(
 featEdgeptAct * a_featEdgeptAct,
 int log)
{
  if (a_featEdgeptAct->get_faLabel())
    {
      adjustLevels(&featEdgeptActAtts_a_faLabel, "featEdgeptAct a_faLabel");
      if (log && !findString("a_faLabel", featEdgeptActAtts))
	{
	  warnAtt("a_faLabel", "featEdgeptAct", a_featEdgeptAct);
	  check_faLabel(a_featEdgeptAct->get_faLabel(), 0);
	}
      else
	check_faLabel(a_featEdgeptAct->get_faLabel(), log);
    }
  if (a_featEdgeptAct->get_featMinorEdgept())
    {
      adjustLevels(&featEdgeptActAtts_a_featMinorEdgept,
		   "featEdgeptAct a_featMinorEdgept");
      if (log && !findString("a_featMinorEdgept", featEdgeptActAtts))
	{
	  warnAtt("a_featMinorEdgept", "featEdgeptAct", a_featEdgeptAct);
	  check_featMinorEdgept(a_featEdgeptAct->get_featMinorEdgept(), 0);
	}
      else
	check_featMinorEdgept(a_featEdgeptAct->get_featMinorEdgept(), log);
    }
}

/********************************************************************/

void check_featEdgeptNom(
 featEdgeptNom * a_featEdgeptNom,
 int log)
{
  if (a_featEdgeptNom->get_fLabel())
    {
      adjustLevels(&featEdgeptNomAtts_a_fLabel, "featEdgeptNom a_fLabel");
      if (log && !findString("a_fLabel", featEdgeptNomAtts))
	{
	  warnAtt("a_fLabel", "featEdgeptNom", a_featEdgeptNom);
	  check_fLabel(a_featEdgeptNom->get_fLabel(), 0);
	}
      else
	check_fLabel(a_featEdgeptNom->get_fLabel(), log);
    }
  if (a_featEdgeptNom->get_featMinorEdgept())
    {
      adjustLevels(&featEdgeptNomAtts_a_featMinorEdgept,
		   "featEdgeptNom a_featMinorEdgept");
      if (log && !findString("a_featMinorEdgept", featEdgeptNomAtts))
	{
	  warnAtt("a_featMinorEdgept", "featEdgeptNom", a_featEdgeptNom);
	  check_featMinorEdgept(a_featEdgeptNom->get_featMinorEdgept(), 0);
	}
      else
	check_featMinorEdgept(a_featEdgeptNom->get_featMinorEdgept(), log);
    }
}

/********************************************************************/

void check_featEdgeptStm(
 featEdgeptStm * a_featEdgeptStm,
 int log)
{
  if (isA(a_featEdgeptStm, featEdgeptNom))
    {
      adjustLevels(&featEdgeptStmSubs_featEdgeptNom, "featEdgeptNom");
      if (log && !findString("featEdgeptNom", featEdgeptStmSubs))
	{
	  warnSub("featEdgeptNom", "featEdgeptStm", a_featEdgeptStm);
	  check_featEdgeptNom(
	    dynamic_cast<featEdgeptNom *>(a_featEdgeptStm), 0);
	}
      else
	check_featEdgeptNom(
	  dynamic_cast<featEdgeptNom *>(a_featEdgeptStm), log);
      return;
    }
  if (isA(a_featEdgeptStm, featEdgeptAct))
    {
      adjustLevels(&featEdgeptStmSubs_featEdgeptAct, "featEdgeptAct");
      if (log && !findString("featEdgeptAct", featEdgeptStmSubs))
	{
	  warnSub("featEdgeptAct", "featEdgeptStm", a_featEdgeptStm);
	  check_featEdgeptAct(
	    dynamic_cast<featEdgeptAct *>(a_featEdgeptStm), 0);
	}
      else
	check_featEdgeptAct(
	  dynamic_cast<featEdgeptAct *>(a_featEdgeptStm), log);
      return;
    }
}

/********************************************************************/

void check_featEllipsAct(
 featEllipsAct * a_featEllipsAct,
 int log)
{
  if (a_featEllipsAct->get_faLabel())
    {
      adjustLevels(&featEllipsActAtts_a_faLabel, "featEllipsAct a_faLabel");
      if (log && !findString("a_faLabel", featEllipsActAtts))
	{
	  warnAtt("a_faLabel", "featEllipsAct", a_featEllipsAct);
	  check_faLabel(a_featEllipsAct->get_faLabel(), 0);
	}
      else
	check_faLabel(a_featEllipsAct->get_faLabel(), log);
    }
  if (a_featEllipsAct->get_featMinorEllips())
    {
      adjustLevels(&featEllipsActAtts_a_featMinorEllips,
		   "featEllipsAct a_featMinorEllips");
      if (log && !findString("a_featMinorEllips", featEllipsActAtts))
	{
	  warnAtt("a_featMinorEllips", "featEllipsAct", a_featEllipsAct);
	  check_featMinorEllips(a_featEllipsAct->get_featMinorEllips(), 0);
	}
      else
	check_featMinorEllips(a_featEllipsAct->get_featMinorEllips(), log);
    }
}

/********************************************************************/

void check_featEllipsCart(
 featEllipsCart * a_featEllipsCart,
 int log)
{
  if (a_featEllipsCart->get_matDir())
    {
      adjustLevels(&featEllipsCartAtts_a_matDir, "featEllipsCart a_matDir");
      if (log && !findString("a_matDir", featEllipsCartAtts))
	{
	  warnAtt("a_matDir", "featEllipsCart", a_featEllipsCart);
	  check_matDir(a_featEllipsCart->get_matDir(), 0);
	}
      else
	check_matDir(a_featEllipsCart->get_matDir(), log);
    }
  if (a_featEllipsCart->get_focus1())
    {
      adjustLevels(&featEllipsCartAtts_focus1, "featEllipsCart focus1");
      if (log && !findString("focus1", featEllipsCartAtts))
	{
	  warnAtt("focus1", "featEllipsCart", a_featEllipsCart);
	  check_cartPoint(a_featEllipsCart->get_focus1(), 0);
	}
      else
	check_cartPoint(a_featEllipsCart->get_focus1(), log);
    }
  if (a_featEllipsCart->get_focus2())
    {
      adjustLevels(&featEllipsCartAtts_focus2, "featEllipsCart focus2");
      if (log && !findString("focus2", featEllipsCartAtts))
	{
	  warnAtt("focus2", "featEllipsCart", a_featEllipsCart);
	  check_impCartPoint(a_featEllipsCart->get_focus2(), 0);
	}
      else
	check_impCartPoint(a_featEllipsCart->get_focus2(), log);
    }
  if (a_featEllipsCart->get_radiusSpec())
    {
      adjustLevels(&featEllipsCartAtts_a_radiusSpec,
		   "featEllipsCart a_radiusSpec");
      if (log && !findString("a_radiusSpec", featEllipsCartAtts))
	{
	  warnAtt("a_radiusSpec", "featEllipsCart", a_featEllipsCart);
	  check_radiusSpec(a_featEllipsCart->get_radiusSpec(), 0);
	}
      else
	check_radiusSpec(a_featEllipsCart->get_radiusSpec(), log);
    }
  if (a_featEllipsCart->get_planeVec())
    {
      adjustLevels(&featEllipsCartAtts_planeVec, "featEllipsCart planeVec");
      if (log && !findString("planeVec", featEllipsCartAtts))
	{
	  warnAtt("planeVec", "featEllipsCart", a_featEllipsCart);
	  check_vector(a_featEllipsCart->get_planeVec(), 0);
	}
      else
	check_vector(a_featEllipsCart->get_planeVec(), log);
    }
  if (a_featEllipsCart->get_diam())
    {
      adjustLevels(&featEllipsCartAtts_diam, "featEllipsCart diam");
      if (log && !findString("diam", featEllipsCartAtts))
	{
	  warnAtt("diam", "featEllipsCart", a_featEllipsCart);
	  check_rentVal(a_featEllipsCart->get_diam(), 0);
	}
      else
	check_rentVal(a_featEllipsCart->get_diam(), log);
    }
}

/********************************************************************/

void check_featEllipsNom(
 featEllipsNom * a_featEllipsNom,
 int log)
{
  if (a_featEllipsNom->get_fLabel())
    {
      adjustLevels(&featEllipsNomAtts_a_fLabel, "featEllipsNom a_fLabel");
      if (log && !findString("a_fLabel", featEllipsNomAtts))
	{
	  warnAtt("a_fLabel", "featEllipsNom", a_featEllipsNom);
	  check_fLabel(a_featEllipsNom->get_fLabel(), 0);
	}
      else
	check_fLabel(a_featEllipsNom->get_fLabel(), log);
    }
  if (a_featEllipsNom->get_featMinorEllips())
    {
      adjustLevels(&featEllipsNomAtts_a_featMinorEllips,
		   "featEllipsNom a_featMinorEllips");
      if (log && !findString("a_featMinorEllips", featEllipsNomAtts))
	{
	  warnAtt("a_featMinorEllips", "featEllipsNom", a_featEllipsNom);
	  check_featMinorEllips(a_featEllipsNom->get_featMinorEllips(), 0);
	}
      else
	check_featMinorEllips(a_featEllipsNom->get_featMinorEllips(), log);
    }
}

/********************************************************************/

void check_featEllipsPol(
 featEllipsPol * a_featEllipsPol,
 int log)
{
  if (a_featEllipsPol->get_matDir())
    {
      adjustLevels(&featEllipsPolAtts_a_matDir, "featEllipsPol a_matDir");
      if (log && !findString("a_matDir", featEllipsPolAtts))
	{
	  warnAtt("a_matDir", "featEllipsPol", a_featEllipsPol);
	  check_matDir(a_featEllipsPol->get_matDir(), 0);
	}
      else
	check_matDir(a_featEllipsPol->get_matDir(), log);
    }
  if (a_featEllipsPol->get_focus1())
    {
      adjustLevels(&featEllipsPolAtts_focus1, "featEllipsPol focus1");
      if (log && !findString("focus1", featEllipsPolAtts))
	{
	  warnAtt("focus1", "featEllipsPol", a_featEllipsPol);
	  check_polPoint(a_featEllipsPol->get_focus1(), 0);
	}
      else
	check_polPoint(a_featEllipsPol->get_focus1(), log);
    }
  if (a_featEllipsPol->get_focus2())
    {
      adjustLevels(&featEllipsPolAtts_focus2, "featEllipsPol focus2");
      if (log && !findString("focus2", featEllipsPolAtts))
	{
	  warnAtt("focus2", "featEllipsPol", a_featEllipsPol);
	  check_impPolPoint(a_featEllipsPol->get_focus2(), 0);
	}
      else
	check_impPolPoint(a_featEllipsPol->get_focus2(), log);
    }
  if (a_featEllipsPol->get_radiusSpec())
    {
      adjustLevels(&featEllipsPolAtts_a_radiusSpec,
		   "featEllipsPol a_radiusSpec");
      if (log && !findString("a_radiusSpec", featEllipsPolAtts))
	{
	  warnAtt("a_radiusSpec", "featEllipsPol", a_featEllipsPol);
	  check_radiusSpec(a_featEllipsPol->get_radiusSpec(), 0);
	}
      else
	check_radiusSpec(a_featEllipsPol->get_radiusSpec(), log);
    }
  if (a_featEllipsPol->get_planeVec())
    {
      adjustLevels(&featEllipsPolAtts_planeVec, "featEllipsPol planeVec");
      if (log && !findString("planeVec", featEllipsPolAtts))
	{
	  warnAtt("planeVec", "featEllipsPol", a_featEllipsPol);
	  check_vector(a_featEllipsPol->get_planeVec(), 0);
	}
      else
	check_vector(a_featEllipsPol->get_planeVec(), log);
    }
  if (a_featEllipsPol->get_diam())
    {
      adjustLevels(&featEllipsPolAtts_diam, "featEllipsPol diam");
      if (log && !findString("diam", featEllipsPolAtts))
	{
	  warnAtt("diam", "featEllipsPol", a_featEllipsPol);
	  check_rentVal(a_featEllipsPol->get_diam(), 0);
	}
      else
	check_rentVal(a_featEllipsPol->get_diam(), log);
    }
}

/********************************************************************/

void check_featEllipsStm(
 featEllipsStm * a_featEllipsStm,
 int log)
{
  if (isA(a_featEllipsStm, featEllipsNom))
    {
      adjustLevels(&featEllipsStmSubs_featEllipsNom, "featEllipsNom");
      if (log && !findString("featEllipsNom", featEllipsStmSubs))
	{
	  warnSub("featEllipsNom", "featEllipsStm", a_featEllipsStm);
	  check_featEllipsNom(
	    dynamic_cast<featEllipsNom *>(a_featEllipsStm), 0);
	}
      else
	check_featEllipsNom(
	  dynamic_cast<featEllipsNom *>(a_featEllipsStm), log);
      return;
    }
  if (isA(a_featEllipsStm, featEllipsAct))
    {
      adjustLevels(&featEllipsStmSubs_featEllipsAct, "featEllipsAct");
      if (log && !findString("featEllipsAct", featEllipsStmSubs))
	{
	  warnSub("featEllipsAct", "featEllipsStm", a_featEllipsStm);
	  check_featEllipsAct(
	    dynamic_cast<featEllipsAct *>(a_featEllipsStm), 0);
	}
      else
	check_featEllipsAct(
	  dynamic_cast<featEllipsAct *>(a_featEllipsStm), log);
      return;
    }
}

/********************************************************************/

void check_featElongcylAct(
 featElongcylAct * a_featElongcylAct,
 int log)
{
  if (a_featElongcylAct->get_faLabel())
    {
      adjustLevels(&featElongcylActAtts_a_faLabel,
		   "featElongcylAct a_faLabel");
      if (log && !findString("a_faLabel", featElongcylActAtts))
	{
	  warnAtt("a_faLabel", "featElongcylAct", a_featElongcylAct);
	  check_faLabel(a_featElongcylAct->get_faLabel(), 0);
	}
      else
	check_faLabel(a_featElongcylAct->get_faLabel(), log);
    }
  if (a_featElongcylAct->get_featMinorElongcyl())
    {
      adjustLevels(&featElongcylActAtts_a_featMinorElongcyl,
		   "featElongcylAct a_featMinorElongcyl");
      if (log && !findString("a_featMinorElongcyl", featElongcylActAtts))
	{
	  warnAtt("a_featMinorElongcyl", "featElongcylAct",
		  a_featElongcylAct);
	  check_featMinorElongcyl(
	    a_featElongcylAct->get_featMinorElongcyl(), 0);
	}
      else
	check_featMinorElongcyl(
	  a_featElongcylAct->get_featMinorElongcyl(), log);
    }
}

/********************************************************************/

void check_featElongcylNom(
 featElongcylNom * a_featElongcylNom,
 int log)
{
  if (a_featElongcylNom->get_fLabel())
    {
      adjustLevels(&featElongcylNomAtts_a_fLabel, "featElongcylNom a_fLabel");
      if (log && !findString("a_fLabel", featElongcylNomAtts))
	{
	  warnAtt("a_fLabel", "featElongcylNom", a_featElongcylNom);
	  check_fLabel(a_featElongcylNom->get_fLabel(), 0);
	}
      else
	check_fLabel(a_featElongcylNom->get_fLabel(), log);
    }
  if (a_featElongcylNom->get_featMinorElongcyl())
    {
      adjustLevels(&featElongcylNomAtts_a_featMinorElongcyl,
		   "featElongcylNom a_featMinorElongcyl");
      if (log && !findString("a_featMinorElongcyl", featElongcylNomAtts))
	{
	  warnAtt("a_featMinorElongcyl", "featElongcylNom",
		  a_featElongcylNom);
	  check_featMinorElongcyl(
	    a_featElongcylNom->get_featMinorElongcyl(), 0);
	}
      else
	check_featMinorElongcyl(
	  a_featElongcylNom->get_featMinorElongcyl(), log);
    }
}

/********************************************************************/

void check_featElongcylStm(
 featElongcylStm * a_featElongcylStm,
 int log)
{
  if (isA(a_featElongcylStm, featElongcylNom))
    {
      adjustLevels(&featElongcylStmSubs_featElongcylNom, "featElongcylNom");
      if (log && !findString("featElongcylNom", featElongcylStmSubs))
	{
	  warnSub("featElongcylNom", "featElongcylStm", a_featElongcylStm);
	  check_featElongcylNom(
	    dynamic_cast<featElongcylNom *>(a_featElongcylStm), 0);
	}
      else
	check_featElongcylNom(
	  dynamic_cast<featElongcylNom *>(a_featElongcylStm), log);
      return;
    }
  if (isA(a_featElongcylStm, featElongcylAct))
    {
      adjustLevels(&featElongcylStmSubs_featElongcylAct, "featElongcylAct");
      if (log && !findString("featElongcylAct", featElongcylStmSubs))
	{
	  warnSub("featElongcylAct", "featElongcylStm", a_featElongcylStm);
	  check_featElongcylAct(
	    dynamic_cast<featElongcylAct *>(a_featElongcylStm), 0);
	}
      else
	check_featElongcylAct(
	  dynamic_cast<featElongcylAct *>(a_featElongcylStm), log);
      return;
    }
}

/********************************************************************/

void check_featGcurveCart(
 featGcurveCart * a_featGcurveCart,
 int log)
{
  if (a_featGcurveCart->get_planeData())
    {
      adjustLevels(&featGcurveCartAtts_planeData, "featGcurveCart planeData");
      if (log && !findString("planeData", featGcurveCartAtts))
	{
	  warnAtt("planeData", "featGcurveCart", a_featGcurveCart);
	  check_pointVecCart(a_featGcurveCart->get_planeData(), 0);
	}
      else
	check_pointVecCart(a_featGcurveCart->get_planeData(), log);
    }
  if (a_featGcurveCart->get_curveData1())
    {
      adjustLevels(&featGcurveCartAtts_curveData1,
		   "featGcurveCart curveData1");
      if (log && !findString("curveData1", featGcurveCartAtts))
	{
	  warnAtt("curveData1", "featGcurveCart", a_featGcurveCart);
	  check_pointVecCart(a_featGcurveCart->get_curveData1(), 0);
	}
      else
	check_pointVecCart(a_featGcurveCart->get_curveData1(), log);
    }
  if (a_featGcurveCart->get_curveDataRest())
    {
      std::list<pointVecCart *> * theList;
      std::list<pointVecCart *>::iterator iter;
      theList = a_featGcurveCart->get_curveDataRest();
      adjustLevels(&featGcurveCartAtts_curveDataRest,
		   "featGcurveCart curveDataRest");
      if (log && !findString("curveDataRest", featGcurveCartAtts))
	{
	  warnAtt("curveDataRest", "featGcurveCart", a_featGcurveCart);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_pointVecCart(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_pointVecCart(*iter, log);
	}
    }
}

/********************************************************************/

void check_featGcurvePol(
 featGcurvePol * a_featGcurvePol,
 int log)
{
  if (a_featGcurvePol->get_planeData())
    {
      adjustLevels(&featGcurvePolAtts_planeData, "featGcurvePol planeData");
      if (log && !findString("planeData", featGcurvePolAtts))
	{
	  warnAtt("planeData", "featGcurvePol", a_featGcurvePol);
	  check_pointVecPol(a_featGcurvePol->get_planeData(), 0);
	}
      else
	check_pointVecPol(a_featGcurvePol->get_planeData(), log);
    }
  if (a_featGcurvePol->get_curveData1())
    {
      adjustLevels(&featGcurvePolAtts_curveData1, "featGcurvePol curveData1");
      if (log && !findString("curveData1", featGcurvePolAtts))
	{
	  warnAtt("curveData1", "featGcurvePol", a_featGcurvePol);
	  check_pointVecPol(a_featGcurvePol->get_curveData1(), 0);
	}
      else
	check_pointVecPol(a_featGcurvePol->get_curveData1(), log);
    }
  if (a_featGcurvePol->get_curveDataRest())
    {
      std::list<pointVecPol *> * theList;
      std::list<pointVecPol *>::iterator iter;
      theList = a_featGcurvePol->get_curveDataRest();
      adjustLevels(&featGcurvePolAtts_curveDataRest,
		   "featGcurvePol curveDataRest");
      if (log && !findString("curveDataRest", featGcurvePolAtts))
	{
	  warnAtt("curveDataRest", "featGcurvePol", a_featGcurvePol);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_pointVecPol(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_pointVecPol(*iter, log);
	}
    }
}

/********************************************************************/

void check_featGcurveStm(
 featGcurveStm * a_featGcurveStm,
 int log)
{
  if (a_featGcurveStm->get_fLabel())
    {
      adjustLevels(&featGcurveStmAtts_a_fLabel, "featGcurveStm a_fLabel");
      if (log && !findString("a_fLabel", featGcurveStmAtts))
	{
	  warnAtt("a_fLabel", "featGcurveStm", a_featGcurveStm);
	  check_fLabel(a_featGcurveStm->get_fLabel(), 0);
	}
      else
	check_fLabel(a_featGcurveStm->get_fLabel(), log);
    }
  if (a_featGcurveStm->get_featMinorGcurve())
    {
      adjustLevels(&featGcurveStmAtts_a_featMinorGcurve,
		   "featGcurveStm a_featMinorGcurve");
      if (log && !findString("a_featMinorGcurve", featGcurveStmAtts))
	{
	  warnAtt("a_featMinorGcurve", "featGcurveStm", a_featGcurveStm);
	  check_featMinorGcurve(a_featGcurveStm->get_featMinorGcurve(), 0);
	}
      else
	check_featMinorGcurve(a_featGcurveStm->get_featMinorGcurve(), log);
    }
}

/********************************************************************/

void check_featGeomStm(
 featGeomStm * a_featGeomStm,
 int log)
{
  if (a_featGeomStm->get_fLabel())
    {
      adjustLevels(&featGeomStmAtts_a_fLabel, "featGeomStm a_fLabel");
      if (log && !findString("a_fLabel", featGeomStmAtts))
	{
	  warnAtt("a_fLabel", "featGeomStm", a_featGeomStm);
	  check_fLabel(a_featGeomStm->get_fLabel(), 0);
	}
      else
	check_fLabel(a_featGeomStm->get_fLabel(), log);
    }
  if (a_featGeomStm->get_featMinorGeom())
    {
      adjustLevels(&featGeomStmAtts_a_featMinorGeom,
		   "featGeomStm a_featMinorGeom");
      if (log && !findString("a_featMinorGeom", featGeomStmAtts))
	{
	  warnAtt("a_featMinorGeom", "featGeomStm", a_featGeomStm);
	  check_featMinorGeom(a_featGeomStm->get_featMinorGeom(), 0);
	}
      else
	check_featMinorGeom(a_featGeomStm->get_featMinorGeom(), log);
    }
}

/********************************************************************/

void check_featGsurfCart(
 featGsurfCart * a_featGsurfCart,
 int log)
{
  if (a_featGsurfCart->get_pt1())
    {
      adjustLevels(&featGsurfCartAtts_pt1, "featGsurfCart pt1");
      if (log && !findString("pt1", featGsurfCartAtts))
	{
	  warnAtt("pt1", "featGsurfCart", a_featGsurfCart);
	  check_pointVecCart(a_featGsurfCart->get_pt1(), 0);
	}
      else
	check_pointVecCart(a_featGsurfCart->get_pt1(), log);
    }
  if (a_featGsurfCart->get_pt2())
    {
      adjustLevels(&featGsurfCartAtts_pt2, "featGsurfCart pt2");
      if (log && !findString("pt2", featGsurfCartAtts))
	{
	  warnAtt("pt2", "featGsurfCart", a_featGsurfCart);
	  check_pointVecCart(a_featGsurfCart->get_pt2(), 0);
	}
      else
	check_pointVecCart(a_featGsurfCart->get_pt2(), log);
    }
  if (a_featGsurfCart->get_morePts())
    {
      std::list<pointVecCart *> * theList;
      std::list<pointVecCart *>::iterator iter;
      theList = a_featGsurfCart->get_morePts();
      adjustLevels(&featGsurfCartAtts_morePts, "featGsurfCart morePts");
      if (log && !findString("morePts", featGsurfCartAtts))
	{
	  warnAtt("morePts", "featGsurfCart", a_featGsurfCart);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_pointVecCart(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_pointVecCart(*iter, log);
	}
    }
}

/********************************************************************/

void check_featGsurfPol(
 featGsurfPol * a_featGsurfPol,
 int log)
{
  if (a_featGsurfPol->get_pt1())
    {
      adjustLevels(&featGsurfPolAtts_pt1, "featGsurfPol pt1");
      if (log && !findString("pt1", featGsurfPolAtts))
	{
	  warnAtt("pt1", "featGsurfPol", a_featGsurfPol);
	  check_pointVecPol(a_featGsurfPol->get_pt1(), 0);
	}
      else
	check_pointVecPol(a_featGsurfPol->get_pt1(), log);
    }
  if (a_featGsurfPol->get_pt2())
    {
      adjustLevels(&featGsurfPolAtts_pt2, "featGsurfPol pt2");
      if (log && !findString("pt2", featGsurfPolAtts))
	{
	  warnAtt("pt2", "featGsurfPol", a_featGsurfPol);
	  check_pointVecPol(a_featGsurfPol->get_pt2(), 0);
	}
      else
	check_pointVecPol(a_featGsurfPol->get_pt2(), log);
    }
  if (a_featGsurfPol->get_morePts())
    {
      std::list<pointVecPol *> * theList;
      std::list<pointVecPol *>::iterator iter;
      theList = a_featGsurfPol->get_morePts();
      adjustLevels(&featGsurfPolAtts_morePts, "featGsurfPol morePts");
      if (log && !findString("morePts", featGsurfPolAtts))
	{
	  warnAtt("morePts", "featGsurfPol", a_featGsurfPol);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_pointVecPol(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_pointVecPol(*iter, log);
	}
    }
}

/********************************************************************/

void check_featGsurfStm(
 featGsurfStm * a_featGsurfStm,
 int log)
{
  if (a_featGsurfStm->get_fLabel())
    {
      adjustLevels(&featGsurfStmAtts_a_fLabel, "featGsurfStm a_fLabel");
      if (log && !findString("a_fLabel", featGsurfStmAtts))
	{
	  warnAtt("a_fLabel", "featGsurfStm", a_featGsurfStm);
	  check_fLabel(a_featGsurfStm->get_fLabel(), 0);
	}
      else
	check_fLabel(a_featGsurfStm->get_fLabel(), log);
    }
  if (a_featGsurfStm->get_featMinorGsurf())
    {
      adjustLevels(&featGsurfStmAtts_a_featMinorGsurf,
		   "featGsurfStm a_featMinorGsurf");
      if (log && !findString("a_featMinorGsurf", featGsurfStmAtts))
	{
	  warnAtt("a_featMinorGsurf", "featGsurfStm", a_featGsurfStm);
	  check_featMinorGsurf(a_featGsurfStm->get_featMinorGsurf(), 0);
	}
      else
	check_featMinorGsurf(a_featGsurfStm->get_featMinorGsurf(), log);
    }
}

/********************************************************************/

void check_featLineAct(
 featLineAct * a_featLineAct,
 int log)
{
  if (a_featLineAct->get_faLabel())
    {
      adjustLevels(&featLineActAtts_a_faLabel, "featLineAct a_faLabel");
      if (log && !findString("a_faLabel", featLineActAtts))
	{
	  warnAtt("a_faLabel", "featLineAct", a_featLineAct);
	  check_faLabel(a_featLineAct->get_faLabel(), 0);
	}
      else
	check_faLabel(a_featLineAct->get_faLabel(), log);
    }
  if (a_featLineAct->get_featMinorLine())
    {
      adjustLevels(&featLineActAtts_a_featMinorLine,
		   "featLineAct a_featMinorLine");
      if (log && !findString("a_featMinorLine", featLineActAtts))
	{
	  warnAtt("a_featMinorLine", "featLineAct", a_featLineAct);
	  check_featMinorLine(a_featLineAct->get_featMinorLine(), 0);
	}
      else
	check_featMinorLine(a_featLineAct->get_featMinorLine(), log);
    }
}

/********************************************************************/

void check_featLineBndCart(
 featLineBndCart * a_featLineBndCart,
 int log)
{
  if (a_featLineBndCart->get_start())
    {
      adjustLevels(&featLineBndCartAtts_start, "featLineBndCart start");
      if (log && !findString("start", featLineBndCartAtts))
	{
	  warnAtt("start", "featLineBndCart", a_featLineBndCart);
	  check_cartPoint(a_featLineBndCart->get_start(), 0);
	}
      else
	check_cartPoint(a_featLineBndCart->get_start(), log);
    }
  if (a_featLineBndCart->get_end())
    {
      adjustLevels(&featLineBndCartAtts_end, "featLineBndCart end");
      if (log && !findString("end", featLineBndCartAtts))
	{
	  warnAtt("end", "featLineBndCart", a_featLineBndCart);
	  check_impCartPoint(a_featLineBndCart->get_end(), 0);
	}
      else
	check_impCartPoint(a_featLineBndCart->get_end(), log);
    }
  if (a_featLineBndCart->get_planeVec())
    {
      adjustLevels(&featLineBndCartAtts_planeVec, "featLineBndCart planeVec");
      if (log && !findString("planeVec", featLineBndCartAtts))
	{
	  warnAtt("planeVec", "featLineBndCart", a_featLineBndCart);
	  check_vector(a_featLineBndCart->get_planeVec(), 0);
	}
      else
	check_vector(a_featLineBndCart->get_planeVec(), log);
    }
}

/********************************************************************/

void check_featLineBndPol(
 featLineBndPol * a_featLineBndPol,
 int log)
{
  if (a_featLineBndPol->get_start())
    {
      adjustLevels(&featLineBndPolAtts_start, "featLineBndPol start");
      if (log && !findString("start", featLineBndPolAtts))
	{
	  warnAtt("start", "featLineBndPol", a_featLineBndPol);
	  check_polPoint(a_featLineBndPol->get_start(), 0);
	}
      else
	check_polPoint(a_featLineBndPol->get_start(), log);
    }
  if (a_featLineBndPol->get_end())
    {
      adjustLevels(&featLineBndPolAtts_end, "featLineBndPol end");
      if (log && !findString("end", featLineBndPolAtts))
	{
	  warnAtt("end", "featLineBndPol", a_featLineBndPol);
	  check_impPolPoint(a_featLineBndPol->get_end(), 0);
	}
      else
	check_impPolPoint(a_featLineBndPol->get_end(), log);
    }
  if (a_featLineBndPol->get_planeVec())
    {
      adjustLevels(&featLineBndPolAtts_planeVec, "featLineBndPol planeVec");
      if (log && !findString("planeVec", featLineBndPolAtts))
	{
	  warnAtt("planeVec", "featLineBndPol", a_featLineBndPol);
	  check_vector(a_featLineBndPol->get_planeVec(), 0);
	}
      else
	check_vector(a_featLineBndPol->get_planeVec(), log);
    }
}

/********************************************************************/

void check_featLineNom(
 featLineNom * a_featLineNom,
 int log)
{
  if (a_featLineNom->get_fLabel())
    {
      adjustLevels(&featLineNomAtts_a_fLabel, "featLineNom a_fLabel");
      if (log && !findString("a_fLabel", featLineNomAtts))
	{
	  warnAtt("a_fLabel", "featLineNom", a_featLineNom);
	  check_fLabel(a_featLineNom->get_fLabel(), 0);
	}
      else
	check_fLabel(a_featLineNom->get_fLabel(), log);
    }
  if (a_featLineNom->get_featMinorLine())
    {
      adjustLevels(&featLineNomAtts_a_featMinorLine,
		   "featLineNom a_featMinorLine");
      if (log && !findString("a_featMinorLine", featLineNomAtts))
	{
	  warnAtt("a_featMinorLine", "featLineNom", a_featLineNom);
	  check_featMinorLine(a_featLineNom->get_featMinorLine(), 0);
	}
      else
	check_featMinorLine(a_featLineNom->get_featMinorLine(), log);
    }
}

/********************************************************************/

void check_featLineStm(
 featLineStm * a_featLineStm,
 int log)
{
  if (isA(a_featLineStm, featLineNom))
    {
      adjustLevels(&featLineStmSubs_featLineNom, "featLineNom");
      if (log && !findString("featLineNom", featLineStmSubs))
	{
	  warnSub("featLineNom", "featLineStm", a_featLineStm);
	  check_featLineNom(dynamic_cast<featLineNom *>(a_featLineStm), 0);
	}
      else
	check_featLineNom(dynamic_cast<featLineNom *>(a_featLineStm), log);
      return;
    }
  if (isA(a_featLineStm, featLineAct))
    {
      adjustLevels(&featLineStmSubs_featLineAct, "featLineAct");
      if (log && !findString("featLineAct", featLineStmSubs))
	{
	  warnSub("featLineAct", "featLineStm", a_featLineStm);
	  check_featLineAct(dynamic_cast<featLineAct *>(a_featLineStm), 0);
	}
      else
	check_featLineAct(dynamic_cast<featLineAct *>(a_featLineStm), log);
      return;
    }
}

/********************************************************************/

void check_featLineUnbndCart(
 featLineUnbndCart * a_featLineUnbndCart,
 int log)
{
  if (a_featLineUnbndCart->get_cartPoint())
    {
      adjustLevels(&featLineUnbndCartAtts_a_cartPoint,
		   "featLineUnbndCart a_cartPoint");
      if (log && !findString("a_cartPoint", featLineUnbndCartAtts))
	{
	  warnAtt("a_cartPoint", "featLineUnbndCart", a_featLineUnbndCart);
	  check_cartPoint(a_featLineUnbndCart->get_cartPoint(), 0);
	}
      else
	check_cartPoint(a_featLineUnbndCart->get_cartPoint(), log);
    }
  if (a_featLineUnbndCart->get_lineVec())
    {
      adjustLevels(&featLineUnbndCartAtts_lineVec,
		   "featLineUnbndCart lineVec");
      if (log && !findString("lineVec", featLineUnbndCartAtts))
	{
	  warnAtt("lineVec", "featLineUnbndCart", a_featLineUnbndCart);
	  check_vector(a_featLineUnbndCart->get_lineVec(), 0);
	}
      else
	check_vector(a_featLineUnbndCart->get_lineVec(), log);
    }
  if (a_featLineUnbndCart->get_planeVec())
    {
      adjustLevels(&featLineUnbndCartAtts_planeVec,
		   "featLineUnbndCart planeVec");
      if (log && !findString("planeVec", featLineUnbndCartAtts))
	{
	  warnAtt("planeVec", "featLineUnbndCart", a_featLineUnbndCart);
	  check_vector(a_featLineUnbndCart->get_planeVec(), 0);
	}
      else
	check_vector(a_featLineUnbndCart->get_planeVec(), log);
    }
}

/********************************************************************/

void check_featLineUnbndPol(
 featLineUnbndPol * a_featLineUnbndPol,
 int log)
{
  if (a_featLineUnbndPol->get_polPoint())
    {
      adjustLevels(&featLineUnbndPolAtts_a_polPoint,
		   "featLineUnbndPol a_polPoint");
      if (log && !findString("a_polPoint", featLineUnbndPolAtts))
	{
	  warnAtt("a_polPoint", "featLineUnbndPol", a_featLineUnbndPol);
	  check_polPoint(a_featLineUnbndPol->get_polPoint(), 0);
	}
      else
	check_polPoint(a_featLineUnbndPol->get_polPoint(), log);
    }
  if (a_featLineUnbndPol->get_lineVec())
    {
      adjustLevels(&featLineUnbndPolAtts_lineVec, "featLineUnbndPol lineVec");
      if (log && !findString("lineVec", featLineUnbndPolAtts))
	{
	  warnAtt("lineVec", "featLineUnbndPol", a_featLineUnbndPol);
	  check_vector(a_featLineUnbndPol->get_lineVec(), 0);
	}
      else
	check_vector(a_featLineUnbndPol->get_lineVec(), log);
    }
  if (a_featLineUnbndPol->get_planeVec())
    {
      adjustLevels(&featLineUnbndPolAtts_planeVec,
		   "featLineUnbndPol planeVec");
      if (log && !findString("planeVec", featLineUnbndPolAtts))
	{
	  warnAtt("planeVec", "featLineUnbndPol", a_featLineUnbndPol);
	  check_vector(a_featLineUnbndPol->get_planeVec(), 0);
	}
      else
	check_vector(a_featLineUnbndPol->get_planeVec(), log);
    }
}

/********************************************************************/

void check_featMinorArc1(
 featMinorArc1 * a_featMinorArc1,
 int log)
{
  if (a_featMinorArc1->get_matDir())
    {
      adjustLevels(&featMinorArc1Atts_a_matDir, "featMinorArc1 a_matDir");
      if (log && !findString("a_matDir", featMinorArc1Atts))
	{
	  warnAtt("a_matDir", "featMinorArc1", a_featMinorArc1);
	  check_matDir(a_featMinorArc1->get_matDir(), 0);
	}
      else
	check_matDir(a_featMinorArc1->get_matDir(), log);
    }
  if (a_featMinorArc1->get_typePoint())
    {
      adjustLevels(&featMinorArc1Atts_a_typePoint,
		   "featMinorArc1 a_typePoint");
      if (log && !findString("a_typePoint", featMinorArc1Atts))
	{
	  warnAtt("a_typePoint", "featMinorArc1", a_featMinorArc1);
	  check_typePoint(a_featMinorArc1->get_typePoint(), 0);
	}
      else
	check_typePoint(a_featMinorArc1->get_typePoint(), log);
    }
  if (a_featMinorArc1->get_planeVec())
    {
      adjustLevels(&featMinorArc1Atts_planeVec, "featMinorArc1 planeVec");
      if (log && !findString("planeVec", featMinorArc1Atts))
	{
	  warnAtt("planeVec", "featMinorArc1", a_featMinorArc1);
	  check_vector(a_featMinorArc1->get_planeVec(), 0);
	}
      else
	check_vector(a_featMinorArc1->get_planeVec(), log);
    }
  if (a_featMinorArc1->get_radius())
    {
      adjustLevels(&featMinorArc1Atts_radius, "featMinorArc1 radius");
      if (log && !findString("radius", featMinorArc1Atts))
	{
	  warnAtt("radius", "featMinorArc1", a_featMinorArc1);
	  check_rentVal(a_featMinorArc1->get_radius(), 0);
	}
      else
	check_rentVal(a_featMinorArc1->get_radius(), log);
    }
  if (a_featMinorArc1->get_startAngle())
    {
      adjustLevels(&featMinorArc1Atts_startAngle, "featMinorArc1 startAngle");
      if (log && !findString("startAngle", featMinorArc1Atts))
	{
	  warnAtt("startAngle", "featMinorArc1", a_featMinorArc1);
	  check_angle(a_featMinorArc1->get_startAngle(), 0);
	}
      else
	check_angle(a_featMinorArc1->get_startAngle(), log);
    }
  if (a_featMinorArc1->get_includAngle())
    {
      adjustLevels(&featMinorArc1Atts_includAngle,
		   "featMinorArc1 includAngle");
      if (log && !findString("includAngle", featMinorArc1Atts))
	{
	  warnAtt("includAngle", "featMinorArc1", a_featMinorArc1);
	  check_angle(a_featMinorArc1->get_includAngle(), 0);
	}
      else
	check_angle(a_featMinorArc1->get_includAngle(), log);
    }
  if (a_featMinorArc1->get_startVec())
    {
      adjustLevels(&featMinorArc1Atts_startVec, "featMinorArc1 startVec");
      if (log && !findString("startVec", featMinorArc1Atts))
	{
	  warnAtt("startVec", "featMinorArc1", a_featMinorArc1);
	  check_vector(a_featMinorArc1->get_startVec(), 0);
	}
      else
	check_vector(a_featMinorArc1->get_startVec(), log);
    }
}

/********************************************************************/

void check_featMinorArc2(
 featMinorArc2 * a_featMinorArc2,
 int log)
{
  if (a_featMinorArc2->get_matDir())
    {
      adjustLevels(&featMinorArc2Atts_a_matDir, "featMinorArc2 a_matDir");
      if (log && !findString("a_matDir", featMinorArc2Atts))
	{
	  warnAtt("a_matDir", "featMinorArc2", a_featMinorArc2);
	  check_matDir(a_featMinorArc2->get_matDir(), 0);
	}
      else
	check_matDir(a_featMinorArc2->get_matDir(), log);
    }
  if (a_featMinorArc2->get_end1())
    {
      adjustLevels(&featMinorArc2Atts_end1, "featMinorArc2 end1");
      if (log && !findString("end1", featMinorArc2Atts))
	{
	  warnAtt("end1", "featMinorArc2", a_featMinorArc2);
	  check_impCartPoint(a_featMinorArc2->get_end1(), 0);
	}
      else
	check_impCartPoint(a_featMinorArc2->get_end1(), log);
    }
  if (a_featMinorArc2->get_end2())
    {
      adjustLevels(&featMinorArc2Atts_end2, "featMinorArc2 end2");
      if (log && !findString("end2", featMinorArc2Atts))
	{
	  warnAtt("end2", "featMinorArc2", a_featMinorArc2);
	  check_impCartPoint(a_featMinorArc2->get_end2(), 0);
	}
      else
	check_impCartPoint(a_featMinorArc2->get_end2(), log);
    }
  if (a_featMinorArc2->get_midPt())
    {
      adjustLevels(&featMinorArc2Atts_midPt, "featMinorArc2 midPt");
      if (log && !findString("midPt", featMinorArc2Atts))
	{
	  warnAtt("midPt", "featMinorArc2", a_featMinorArc2);
	  check_impCartPoint(a_featMinorArc2->get_midPt(), 0);
	}
      else
	check_impCartPoint(a_featMinorArc2->get_midPt(), log);
    }
  if (a_featMinorArc2->get_center())
    {
      adjustLevels(&featMinorArc2Atts_center, "featMinorArc2 center");
      if (log && !findString("center", featMinorArc2Atts))
	{
	  warnAtt("center", "featMinorArc2", a_featMinorArc2);
	  check_impCartPoint(a_featMinorArc2->get_center(), 0);
	}
      else
	check_impCartPoint(a_featMinorArc2->get_center(), log);
    }
}

/********************************************************************/

void check_featMinorCircle(
 featMinorCircle * a_featMinorCircle,
 int log)
{
  if (a_featMinorCircle->get_matDir())
    {
      adjustLevels(&featMinorCircleAtts_a_matDir, "featMinorCircle a_matDir");
      if (log && !findString("a_matDir", featMinorCircleAtts))
	{
	  warnAtt("a_matDir", "featMinorCircle", a_featMinorCircle);
	  check_matDir(a_featMinorCircle->get_matDir(), 0);
	}
      else
	check_matDir(a_featMinorCircle->get_matDir(), log);
    }
  if (a_featMinorCircle->get_center())
    {
      adjustLevels(&featMinorCircleAtts_center, "featMinorCircle center");
      if (log && !findString("center", featMinorCircleAtts))
	{
	  warnAtt("center", "featMinorCircle", a_featMinorCircle);
	  check_typePoint(a_featMinorCircle->get_center(), 0);
	}
      else
	check_typePoint(a_featMinorCircle->get_center(), log);
    }
  if (a_featMinorCircle->get_planeVec())
    {
      adjustLevels(&featMinorCircleAtts_planeVec, "featMinorCircle planeVec");
      if (log && !findString("planeVec", featMinorCircleAtts))
	{
	  warnAtt("planeVec", "featMinorCircle", a_featMinorCircle);
	  check_vector(a_featMinorCircle->get_planeVec(), 0);
	}
      else
	check_vector(a_featMinorCircle->get_planeVec(), log);
    }
  if (a_featMinorCircle->get_diam())
    {
      adjustLevels(&featMinorCircleAtts_diam, "featMinorCircle diam");
      if (log && !findString("diam", featMinorCircleAtts))
	{
	  warnAtt("diam", "featMinorCircle", a_featMinorCircle);
	  check_rentVal(a_featMinorCircle->get_diam(), 0);
	}
      else
	check_rentVal(a_featMinorCircle->get_diam(), log);
    }
}

/********************************************************************/

void check_featMinorCompound(
 featMinorCompound * a_featMinorCompound,
 int log)
{
  if (isA(a_featMinorCompound, featCompoundAxial))
    {
      adjustLevels(&featMinorCompoundSubs_featCompoundAxial,
		   "featCompoundAxial");
      if (log && !findString("featCompoundAxial", featMinorCompoundSubs))
	{
	  warnSub("featCompoundAxial", "featMinorCompound",
		  a_featMinorCompound);
	  check_featCompoundAxial(
	    dynamic_cast<featCompoundAxial *>(a_featMinorCompound), 0);
	}
      else
	check_featCompoundAxial(
	  dynamic_cast<featCompoundAxial *>(a_featMinorCompound), log);
      return;
    }
  if (isA(a_featMinorCompound, featCompoundPlane))
    {
      adjustLevels(&featMinorCompoundSubs_featCompoundPlane,
		   "featCompoundPlane");
      if (log && !findString("featCompoundPlane", featMinorCompoundSubs))
	{
	  warnSub("featCompoundPlane", "featMinorCompound",
		  a_featMinorCompound);
	  check_featCompoundPlane(
	    dynamic_cast<featCompoundPlane *>(a_featMinorCompound), 0);
	}
      else
	check_featCompoundPlane(
	  dynamic_cast<featCompoundPlane *>(a_featMinorCompound), log);
      return;
    }
  if (isA(a_featMinorCompound, featCompoundSphere))
    {
      adjustLevels(&featMinorCompoundSubs_featCompoundSphere,
		   "featCompoundSphere");
      if (log && !findString("featCompoundSphere", featMinorCompoundSubs))
	{
	  warnSub("featCompoundSphere", "featMinorCompound",
		  a_featMinorCompound);
	  check_featCompoundSphere(
	    dynamic_cast<featCompoundSphere *>(a_featMinorCompound), 0);
	}
      else
	check_featCompoundSphere(
	  dynamic_cast<featCompoundSphere *>(a_featMinorCompound), log);
      return;
    }
}

/********************************************************************/

void check_featMinorCone(
 featMinorCone * a_featMinorCone,
 int log)
{
  if (a_featMinorCone->get_matDir())
    {
      adjustLevels(&featMinorConeAtts_a_matDir, "featMinorCone a_matDir");
      if (log && !findString("a_matDir", featMinorConeAtts))
	{
	  warnAtt("a_matDir", "featMinorCone", a_featMinorCone);
	  check_matDir(a_featMinorCone->get_matDir(), 0);
	}
      else
	check_matDir(a_featMinorCone->get_matDir(), log);
    }
  if (a_featMinorCone->get_vertex())
    {
      adjustLevels(&featMinorConeAtts_vertex, "featMinorCone vertex");
      if (log && !findString("vertex", featMinorConeAtts))
	{
	  warnAtt("vertex", "featMinorCone", a_featMinorCone);
	  check_typePoint(a_featMinorCone->get_vertex(), 0);
	}
      else
	check_typePoint(a_featMinorCone->get_vertex(), log);
    }
  if (a_featMinorCone->get_axis())
    {
      adjustLevels(&featMinorConeAtts_axis, "featMinorCone axis");
      if (log && !findString("axis", featMinorConeAtts))
	{
	  warnAtt("axis", "featMinorCone", a_featMinorCone);
	  check_vector(a_featMinorCone->get_axis(), 0);
	}
      else
	check_vector(a_featMinorCone->get_axis(), log);
    }
  if (a_featMinorCone->get_ang())
    {
      adjustLevels(&featMinorConeAtts_ang, "featMinorCone ang");
      if (log && !findString("ang", featMinorConeAtts))
	{
	  warnAtt("ang", "featMinorCone", a_featMinorCone);
	  check_angle(a_featMinorCone->get_ang(), 0);
	}
      else
	check_angle(a_featMinorCone->get_ang(), log);
    }
}

/********************************************************************/

void check_featMinorConradseg(
 featMinorConradseg * a_featMinorConradseg,
 int log)
{
  if (isA(a_featMinorConradseg, featConradsegCart))
    {
      adjustLevels(&featMinorConradsegSubs_featConradsegCart,
		   "featConradsegCart");
      if (log && !findString("featConradsegCart", featMinorConradsegSubs))
	{
	  warnSub("featConradsegCart", "featMinorConradseg",
		  a_featMinorConradseg);
	  check_featConradsegCart(
	    dynamic_cast<featConradsegCart *>(a_featMinorConradseg), 0);
	}
      else
	check_featConradsegCart(
	  dynamic_cast<featConradsegCart *>(a_featMinorConradseg), log);
      return;
    }
  if (isA(a_featMinorConradseg, featConradsegPol))
    {
      adjustLevels(&featMinorConradsegSubs_featConradsegPol,
		   "featConradsegPol");
      if (log && !findString("featConradsegPol", featMinorConradsegSubs))
	{
	  warnSub("featConradsegPol", "featMinorConradseg",
		  a_featMinorConradseg);
	  check_featConradsegPol(
	    dynamic_cast<featConradsegPol *>(a_featMinorConradseg), 0);
	}
      else
	check_featConradsegPol(
	  dynamic_cast<featConradsegPol *>(a_featMinorConradseg), log);
      return;
    }
}

/********************************************************************/

void check_featMinorCparln(
 featMinorCparln * a_featMinorCparln,
 int log)
{
  if (a_featMinorCparln->get_matDir())
    {
      adjustLevels(&featMinorCparlnAtts_a_matDir, "featMinorCparln a_matDir");
      if (log && !findString("a_matDir", featMinorCparlnAtts))
	{
	  warnAtt("a_matDir", "featMinorCparln", a_featMinorCparln);
	  check_matDir(a_featMinorCparln->get_matDir(), 0);
	}
      else
	check_matDir(a_featMinorCparln->get_matDir(), log);
    }
  if (a_featMinorCparln->get_flatRoundOpen())
    {
      adjustLevels(&featMinorCparlnAtts_a_flatRoundOpen,
		   "featMinorCparln a_flatRoundOpen");
      if (log && !findString("a_flatRoundOpen", featMinorCparlnAtts))
	{
	  warnAtt("a_flatRoundOpen", "featMinorCparln", a_featMinorCparln);
	  check_flatRoundOpen(a_featMinorCparln->get_flatRoundOpen(), 0);
	}
      else
	check_flatRoundOpen(a_featMinorCparln->get_flatRoundOpen(), log);
    }
  if (a_featMinorCparln->get_center())
    {
      adjustLevels(&featMinorCparlnAtts_center, "featMinorCparln center");
      if (log && !findString("center", featMinorCparlnAtts))
	{
	  warnAtt("center", "featMinorCparln", a_featMinorCparln);
	  check_typePoint(a_featMinorCparln->get_center(), 0);
	}
      else
	check_typePoint(a_featMinorCparln->get_center(), log);
    }
  if (a_featMinorCparln->get_surfVec())
    {
      adjustLevels(&featMinorCparlnAtts_surfVec, "featMinorCparln surfVec");
      if (log && !findString("surfVec", featMinorCparlnAtts))
	{
	  warnAtt("surfVec", "featMinorCparln", a_featMinorCparln);
	  check_vector(a_featMinorCparln->get_surfVec(), 0);
	}
      else
	check_vector(a_featMinorCparln->get_surfVec(), log);
    }
  if (a_featMinorCparln->get_lineVec())
    {
      adjustLevels(&featMinorCparlnAtts_lineVec, "featMinorCparln lineVec");
      if (log && !findString("lineVec", featMinorCparlnAtts))
	{
	  warnAtt("lineVec", "featMinorCparln", a_featMinorCparln);
	  check_vector(a_featMinorCparln->get_lineVec(), 0);
	}
      else
	check_vector(a_featMinorCparln->get_lineVec(), log);
    }
  if (a_featMinorCparln->get_len())
    {
      adjustLevels(&featMinorCparlnAtts_len, "featMinorCparln len");
      if (log && !findString("len", featMinorCparlnAtts))
	{
	  warnAtt("len", "featMinorCparln", a_featMinorCparln);
	  check_rentVal(a_featMinorCparln->get_len(), 0);
	}
      else
	check_rentVal(a_featMinorCparln->get_len(), log);
    }
  if (a_featMinorCparln->get_width())
    {
      adjustLevels(&featMinorCparlnAtts_width, "featMinorCparln width");
      if (log && !findString("width", featMinorCparlnAtts))
	{
	  warnAtt("width", "featMinorCparln", a_featMinorCparln);
	  check_rentVal(a_featMinorCparln->get_width(), 0);
	}
      else
	check_rentVal(a_featMinorCparln->get_width(), log);
    }
}

/********************************************************************/

void check_featMinorCylndr(
 featMinorCylndr * a_featMinorCylndr,
 int log)
{
  if (a_featMinorCylndr->get_matDir())
    {
      adjustLevels(&featMinorCylndrAtts_a_matDir, "featMinorCylndr a_matDir");
      if (log && !findString("a_matDir", featMinorCylndrAtts))
	{
	  warnAtt("a_matDir", "featMinorCylndr", a_featMinorCylndr);
	  check_matDir(a_featMinorCylndr->get_matDir(), 0);
	}
      else
	check_matDir(a_featMinorCylndr->get_matDir(), log);
    }
  if (a_featMinorCylndr->get_axisPoint())
    {
      adjustLevels(&featMinorCylndrAtts_axisPoint,
		   "featMinorCylndr axisPoint");
      if (log && !findString("axisPoint", featMinorCylndrAtts))
	{
	  warnAtt("axisPoint", "featMinorCylndr", a_featMinorCylndr);
	  check_typePoint(a_featMinorCylndr->get_axisPoint(), 0);
	}
      else
	check_typePoint(a_featMinorCylndr->get_axisPoint(), log);
    }
  if (a_featMinorCylndr->get_axisVec())
    {
      adjustLevels(&featMinorCylndrAtts_axisVec, "featMinorCylndr axisVec");
      if (log && !findString("axisVec", featMinorCylndrAtts))
	{
	  warnAtt("axisVec", "featMinorCylndr", a_featMinorCylndr);
	  check_vector(a_featMinorCylndr->get_axisVec(), 0);
	}
      else
	check_vector(a_featMinorCylndr->get_axisVec(), log);
    }
  if (a_featMinorCylndr->get_diam())
    {
      adjustLevels(&featMinorCylndrAtts_diam, "featMinorCylndr diam");
      if (log && !findString("diam", featMinorCylndrAtts))
	{
	  warnAtt("diam", "featMinorCylndr", a_featMinorCylndr);
	  check_rentVal(a_featMinorCylndr->get_diam(), 0);
	}
      else
	check_rentVal(a_featMinorCylndr->get_diam(), log);
    }
  if (a_featMinorCylndr->get_len())
    {
      adjustLevels(&featMinorCylndrAtts_len, "featMinorCylndr len");
      if (log && !findString("len", featMinorCylndrAtts))
	{
	  warnAtt("len", "featMinorCylndr", a_featMinorCylndr);
	  check_rentVal(a_featMinorCylndr->get_len(), 0);
	}
      else
	check_rentVal(a_featMinorCylndr->get_len(), log);
    }
}

/********************************************************************/

void check_featMinorCylradseg(
 featMinorCylradseg * a_featMinorCylradseg,
 int log)
{
  if (isA(a_featMinorCylradseg, featCylradsegCart))
    {
      adjustLevels(&featMinorCylradsegSubs_featCylradsegCart,
		   "featCylradsegCart");
      if (log && !findString("featCylradsegCart", featMinorCylradsegSubs))
	{
	  warnSub("featCylradsegCart", "featMinorCylradseg",
		  a_featMinorCylradseg);
	  check_featCylradsegCart(
	    dynamic_cast<featCylradsegCart *>(a_featMinorCylradseg), 0);
	}
      else
	check_featCylradsegCart(
	  dynamic_cast<featCylradsegCart *>(a_featMinorCylradseg), log);
      return;
    }
  if (isA(a_featMinorCylradseg, featCylradsegPol))
    {
      adjustLevels(&featMinorCylradsegSubs_featCylradsegPol,
		   "featCylradsegPol");
      if (log && !findString("featCylradsegPol", featMinorCylradsegSubs))
	{
	  warnSub("featCylradsegPol", "featMinorCylradseg",
		  a_featMinorCylradseg);
	  check_featCylradsegPol(
	    dynamic_cast<featCylradsegPol *>(a_featMinorCylradseg), 0);
	}
      else
	check_featCylradsegPol(
	  dynamic_cast<featCylradsegPol *>(a_featMinorCylradseg), log);
      return;
    }
}

/********************************************************************/

void check_featMinorEdgept(
 featMinorEdgept * a_featMinorEdgept,
 int log)
{
  if (a_featMinorEdgept->get_typePoint())
    {
      adjustLevels(&featMinorEdgeptAtts_a_typePoint,
		   "featMinorEdgept a_typePoint");
      if (log && !findString("a_typePoint", featMinorEdgeptAtts))
	{
	  warnAtt("a_typePoint", "featMinorEdgept", a_featMinorEdgept);
	  check_typePoint(a_featMinorEdgept->get_typePoint(), 0);
	}
      else
	check_typePoint(a_featMinorEdgept->get_typePoint(), log);
    }
  if (a_featMinorEdgept->get_edgeNorm())
    {
      adjustLevels(&featMinorEdgeptAtts_edgeNorm, "featMinorEdgept edgeNorm");
      if (log && !findString("edgeNorm", featMinorEdgeptAtts))
	{
	  warnAtt("edgeNorm", "featMinorEdgept", a_featMinorEdgept);
	  check_vector(a_featMinorEdgept->get_edgeNorm(), 0);
	}
      else
	check_vector(a_featMinorEdgept->get_edgeNorm(), log);
    }
  if (a_featMinorEdgept->get_surfNorm())
    {
      adjustLevels(&featMinorEdgeptAtts_surfNorm, "featMinorEdgept surfNorm");
      if (log && !findString("surfNorm", featMinorEdgeptAtts))
	{
	  warnAtt("surfNorm", "featMinorEdgept", a_featMinorEdgept);
	  check_vector(a_featMinorEdgept->get_surfNorm(), 0);
	}
      else
	check_vector(a_featMinorEdgept->get_surfNorm(), log);
    }
}

/********************************************************************/

void check_featMinorEllips(
 featMinorEllips * a_featMinorEllips,
 int log)
{
  if (isA(a_featMinorEllips, featEllipsCart))
    {
      adjustLevels(&featMinorEllipsSubs_featEllipsCart, "featEllipsCart");
      if (log && !findString("featEllipsCart", featMinorEllipsSubs))
	{
	  warnSub("featEllipsCart", "featMinorEllips", a_featMinorEllips);
	  check_featEllipsCart(
	    dynamic_cast<featEllipsCart *>(a_featMinorEllips), 0);
	}
      else
	check_featEllipsCart(
	  dynamic_cast<featEllipsCart *>(a_featMinorEllips), log);
      return;
    }
  if (isA(a_featMinorEllips, featEllipsPol))
    {
      adjustLevels(&featMinorEllipsSubs_featEllipsPol, "featEllipsPol");
      if (log && !findString("featEllipsPol", featMinorEllipsSubs))
	{
	  warnSub("featEllipsPol", "featMinorEllips", a_featMinorEllips);
	  check_featEllipsPol(
	    dynamic_cast<featEllipsPol *>(a_featMinorEllips), 0);
	}
      else
	check_featEllipsPol(
	  dynamic_cast<featEllipsPol *>(a_featMinorEllips), log);
      return;
    }
}

/********************************************************************/

void check_featMinorElongcyl(
 featMinorElongcyl * a_featMinorElongcyl,
 int log)
{
  if (a_featMinorElongcyl->get_matDir())
    {
      adjustLevels(&featMinorElongcylAtts_a_matDir,
		   "featMinorElongcyl a_matDir");
      if (log && !findString("a_matDir", featMinorElongcylAtts))
	{
	  warnAtt("a_matDir", "featMinorElongcyl", a_featMinorElongcyl);
	  check_matDir(a_featMinorElongcyl->get_matDir(), 0);
	}
      else
	check_matDir(a_featMinorElongcyl->get_matDir(), log);
    }
  if (a_featMinorElongcyl->get_planePt())
    {
      adjustLevels(&featMinorElongcylAtts_planePt,
		   "featMinorElongcyl planePt");
      if (log && !findString("planePt", featMinorElongcylAtts))
	{
	  warnAtt("planePt", "featMinorElongcyl", a_featMinorElongcyl);
	  check_typePoint(a_featMinorElongcyl->get_planePt(), 0);
	}
      else
	check_typePoint(a_featMinorElongcyl->get_planePt(), log);
    }
  if (a_featMinorElongcyl->get_planeVec())
    {
      adjustLevels(&featMinorElongcylAtts_planeVec,
		   "featMinorElongcyl planeVec");
      if (log && !findString("planeVec", featMinorElongcylAtts))
	{
	  warnAtt("planeVec", "featMinorElongcyl", a_featMinorElongcyl);
	  check_vector(a_featMinorElongcyl->get_planeVec(), 0);
	}
      else
	check_vector(a_featMinorElongcyl->get_planeVec(), log);
    }
  if (a_featMinorElongcyl->get_axisVec())
    {
      adjustLevels(&featMinorElongcylAtts_axisVec,
		   "featMinorElongcyl axisVec");
      if (log && !findString("axisVec", featMinorElongcylAtts))
	{
	  warnAtt("axisVec", "featMinorElongcyl", a_featMinorElongcyl);
	  check_vector(a_featMinorElongcyl->get_axisVec(), 0);
	}
      else
	check_vector(a_featMinorElongcyl->get_axisVec(), log);
    }
  if (a_featMinorElongcyl->get_size())
    {
      adjustLevels(&featMinorElongcylAtts_size, "featMinorElongcyl size");
      if (log && !findString("size", featMinorElongcylAtts))
	{
	  warnAtt("size", "featMinorElongcyl", a_featMinorElongcyl);
	  check_rentVal(a_featMinorElongcyl->get_size(), 0);
	}
      else
	check_rentVal(a_featMinorElongcyl->get_size(), log);
    }
  if (a_featMinorElongcyl->get_radius())
    {
      adjustLevels(&featMinorElongcylAtts_radius, "featMinorElongcyl radius");
      if (log && !findString("radius", featMinorElongcylAtts))
	{
	  warnAtt("radius", "featMinorElongcyl", a_featMinorElongcyl);
	  check_rentVal(a_featMinorElongcyl->get_radius(), 0);
	}
      else
	check_rentVal(a_featMinorElongcyl->get_radius(), log);
    }
  if (a_featMinorElongcyl->get_len())
    {
      adjustLevels(&featMinorElongcylAtts_len, "featMinorElongcyl len");
      if (log && !findString("len", featMinorElongcylAtts))
	{
	  warnAtt("len", "featMinorElongcyl", a_featMinorElongcyl);
	  check_rentVal(a_featMinorElongcyl->get_len(), 0);
	}
      else
	check_rentVal(a_featMinorElongcyl->get_len(), log);
    }
}

/********************************************************************/

void check_featMinorGcurve(
 featMinorGcurve * a_featMinorGcurve,
 int log)
{
  if (isA(a_featMinorGcurve, featGcurveCart))
    {
      adjustLevels(&featMinorGcurveSubs_featGcurveCart, "featGcurveCart");
      if (log && !findString("featGcurveCart", featMinorGcurveSubs))
	{
	  warnSub("featGcurveCart", "featMinorGcurve", a_featMinorGcurve);
	  check_featGcurveCart(
	    dynamic_cast<featGcurveCart *>(a_featMinorGcurve), 0);
	}
      else
	check_featGcurveCart(
	  dynamic_cast<featGcurveCart *>(a_featMinorGcurve), log);
      return;
    }
  if (isA(a_featMinorGcurve, featGcurvePol))
    {
      adjustLevels(&featMinorGcurveSubs_featGcurvePol, "featGcurvePol");
      if (log && !findString("featGcurvePol", featMinorGcurveSubs))
	{
	  warnSub("featGcurvePol", "featMinorGcurve", a_featMinorGcurve);
	  check_featGcurvePol(
	    dynamic_cast<featGcurvePol *>(a_featMinorGcurve), 0);
	}
      else
	check_featGcurvePol(
	  dynamic_cast<featGcurvePol *>(a_featMinorGcurve), log);
      return;
    }
}

/********************************************************************/

void check_featMinorGeom(
 featMinorGeom * a_featMinorGeom,
 int log)
{
  if (a_featMinorGeom->get_gLabel())
    {
      adjustLevels(&featMinorGeomAtts_a_gLabel, "featMinorGeom a_gLabel");
      if (log && !findString("a_gLabel", featMinorGeomAtts))
	{
	  warnAtt("a_gLabel", "featMinorGeom", a_featMinorGeom);
	  check_gLabel(a_featMinorGeom->get_gLabel(), 0);
	}
      else
	check_gLabel(a_featMinorGeom->get_gLabel(), log);
    }
  if (a_featMinorGeom->get_coordType())
    {
      adjustLevels(&featMinorGeomAtts_a_coordType,
		   "featMinorGeom a_coordType");
      if (log && !findString("a_coordType", featMinorGeomAtts))
	{
	  warnAtt("a_coordType", "featMinorGeom", a_featMinorGeom);
	  check_coordType(a_featMinorGeom->get_coordType(), 0);
	}
      else
	check_coordType(a_featMinorGeom->get_coordType(), log);
    }
}

/********************************************************************/

void check_featMinorGsurf(
 featMinorGsurf * a_featMinorGsurf,
 int log)
{
  if (isA(a_featMinorGsurf, featGsurfPlain))
    {
      adjustLevels(&featMinorGsurfSubs_featGsurfPlain, "featGsurfPlain");
      if (log && !findString("featGsurfPlain", featMinorGsurfSubs))
	{
	  warnSub("featGsurfPlain", "featMinorGsurf", a_featMinorGsurf);
	}
      return;
    }
  if (isA(a_featMinorGsurf, featGsurfCart))
    {
      adjustLevels(&featMinorGsurfSubs_featGsurfCart, "featGsurfCart");
      if (log && !findString("featGsurfCart", featMinorGsurfSubs))
	{
	  warnSub("featGsurfCart", "featMinorGsurf", a_featMinorGsurf);
	  check_featGsurfCart(
	    dynamic_cast<featGsurfCart *>(a_featMinorGsurf), 0);
	}
      else
	check_featGsurfCart(
	  dynamic_cast<featGsurfCart *>(a_featMinorGsurf), log);
      return;
    }
  if (isA(a_featMinorGsurf, featGsurfPol))
    {
      adjustLevels(&featMinorGsurfSubs_featGsurfPol, "featGsurfPol");
      if (log && !findString("featGsurfPol", featMinorGsurfSubs))
	{
	  warnSub("featGsurfPol", "featMinorGsurf", a_featMinorGsurf);
	  check_featGsurfPol(
	    dynamic_cast<featGsurfPol *>(a_featMinorGsurf), 0);
	}
      else
	check_featGsurfPol(
	  dynamic_cast<featGsurfPol *>(a_featMinorGsurf), log);
      return;
    }
}

/********************************************************************/

void check_featMinorLine(
 featMinorLine * a_featMinorLine,
 int log)
{
  if (isA(a_featMinorLine, featLineBndCart))
    {
      adjustLevels(&featMinorLineSubs_featLineBndCart, "featLineBndCart");
      if (log && !findString("featLineBndCart", featMinorLineSubs))
	{
	  warnSub("featLineBndCart", "featMinorLine", a_featMinorLine);
	  check_featLineBndCart(
	    dynamic_cast<featLineBndCart *>(a_featMinorLine), 0);
	}
      else
	check_featLineBndCart(
	  dynamic_cast<featLineBndCart *>(a_featMinorLine), log);
      return;
    }
  if (isA(a_featMinorLine, featLineBndPol))
    {
      adjustLevels(&featMinorLineSubs_featLineBndPol, "featLineBndPol");
      if (log && !findString("featLineBndPol", featMinorLineSubs))
	{
	  warnSub("featLineBndPol", "featMinorLine", a_featMinorLine);
	  check_featLineBndPol(
	    dynamic_cast<featLineBndPol *>(a_featMinorLine), 0);
	}
      else
	check_featLineBndPol(
	  dynamic_cast<featLineBndPol *>(a_featMinorLine), log);
      return;
    }
  if (isA(a_featMinorLine, featLineUnbndCart))
    {
      adjustLevels(&featMinorLineSubs_featLineUnbndCart, "featLineUnbndCart");
      if (log && !findString("featLineUnbndCart", featMinorLineSubs))
	{
	  warnSub("featLineUnbndCart", "featMinorLine", a_featMinorLine);
	  check_featLineUnbndCart(
	    dynamic_cast<featLineUnbndCart *>(a_featMinorLine), 0);
	}
      else
	check_featLineUnbndCart(
	  dynamic_cast<featLineUnbndCart *>(a_featMinorLine), log);
      return;
    }
  if (isA(a_featMinorLine, featLineUnbndPol))
    {
      adjustLevels(&featMinorLineSubs_featLineUnbndPol, "featLineUnbndPol");
      if (log && !findString("featLineUnbndPol", featMinorLineSubs))
	{
	  warnSub("featLineUnbndPol", "featMinorLine", a_featMinorLine);
	  check_featLineUnbndPol(
	    dynamic_cast<featLineUnbndPol *>(a_featMinorLine), 0);
	}
      else
	check_featLineUnbndPol(
	  dynamic_cast<featLineUnbndPol *>(a_featMinorLine), log);
      return;
    }
}

/********************************************************************/

void check_featMinorObject(
 featMinorObject * a_featMinorObject,
 int log)
{
  if (a_featMinorObject->get_paramList())
    {
      std::list<param *> * theList;
      std::list<param *>::iterator iter;
      theList = a_featMinorObject->get_paramList();
      adjustLevels(&featMinorObjectAtts_a_paramList,
		   "featMinorObject a_paramList");
      if (log && !findString("a_paramList", featMinorObjectAtts))
	{
	  warnAtt("a_paramList", "featMinorObject", a_featMinorObject);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_param(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_param(*iter, log);
	}
    }
}

/********************************************************************/

void check_featMinorParpln(
 featMinorParpln * a_featMinorParpln,
 int log)
{
  if (isA(a_featMinorParpln, featParplnPointsCart))
    {
      adjustLevels(&featMinorParplnSubs_featParplnPointsCart,
		   "featParplnPointsCart");
      if (log && !findString("featParplnPointsCart", featMinorParplnSubs))
	{
	  warnSub("featParplnPointsCart", "featMinorParpln", a_featMinorParpln);
	  check_featParplnPointsCart(
	    dynamic_cast<featParplnPointsCart *>(a_featMinorParpln), 0);
	}
      else
	check_featParplnPointsCart(
	  dynamic_cast<featParplnPointsCart *>(a_featMinorParpln), log);
      return;
    }
  if (isA(a_featMinorParpln, featParplnPointsPol))
    {
      adjustLevels(&featMinorParplnSubs_featParplnPointsPol,
		   "featParplnPointsPol");
      if (log && !findString("featParplnPointsPol", featMinorParplnSubs))
	{
	  warnSub("featParplnPointsPol", "featMinorParpln", a_featMinorParpln);
	  check_featParplnPointsPol(
	    dynamic_cast<featParplnPointsPol *>(a_featMinorParpln), 0);
	}
      else
	check_featParplnPointsPol(
	  dynamic_cast<featParplnPointsPol *>(a_featMinorParpln), log);
      return;
    }
  if (isA(a_featMinorParpln, featParplnMidplCart))
    {
      adjustLevels(&featMinorParplnSubs_featParplnMidplCart,
		   "featParplnMidplCart");
      if (log && !findString("featParplnMidplCart", featMinorParplnSubs))
	{
	  warnSub("featParplnMidplCart", "featMinorParpln", a_featMinorParpln);
	  check_featParplnMidplCart(
	    dynamic_cast<featParplnMidplCart *>(a_featMinorParpln), 0);
	}
      else
	check_featParplnMidplCart(
	  dynamic_cast<featParplnMidplCart *>(a_featMinorParpln), log);
      return;
    }
  if (isA(a_featMinorParpln, featParplnMidplPol))
    {
      adjustLevels(&featMinorParplnSubs_featParplnMidplPol,
		   "featParplnMidplPol");
      if (log && !findString("featParplnMidplPol", featMinorParplnSubs))
	{
	  warnSub("featParplnMidplPol", "featMinorParpln", a_featMinorParpln);
	  check_featParplnMidplPol(
	    dynamic_cast<featParplnMidplPol *>(a_featMinorParpln), 0);
	}
      else
	check_featParplnMidplPol(
	  dynamic_cast<featParplnMidplPol *>(a_featMinorParpln), log);
      return;
    }
}

/********************************************************************/

void check_featMinorPatern(
 featMinorPatern * a_featMinorPatern,
 int log)
{
  if (a_featMinorPatern->get_fLabel())
    {
      adjustLevels(&featMinorPaternAtts_a_fLabel, "featMinorPatern a_fLabel");
      if (log && !findString("a_fLabel", featMinorPaternAtts))
	{
	  warnAtt("a_fLabel", "featMinorPatern", a_featMinorPatern);
	  check_fLabel(a_featMinorPatern->get_fLabel(), 0);
	}
      else
	check_fLabel(a_featMinorPatern->get_fLabel(), log);
    }
  if (a_featMinorPatern->get_featureNominalList())
    {
      std::list<fLabel *> * theList;
      std::list<fLabel *>::iterator iter;
      theList = a_featMinorPatern->get_featureNominalList();
      adjustLevels(&featMinorPaternAtts_a_featureNominalList,
		   "featMinorPatern a_featureNominalList");
      if (log && !findString("a_featureNominalList", featMinorPaternAtts))
	{
	  warnAtt("a_featureNominalList", "featMinorPatern",
		  a_featMinorPatern);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_fLabel(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_fLabel(*iter, log);
	}
    }
}

/********************************************************************/

void check_featMinorPlane(
 featMinorPlane * a_featMinorPlane,
 int log)
{
  if (a_featMinorPlane->get_typePoint())
    {
      adjustLevels(&featMinorPlaneAtts_a_typePoint,
		   "featMinorPlane a_typePoint");
      if (log && !findString("a_typePoint", featMinorPlaneAtts))
	{
	  warnAtt("a_typePoint", "featMinorPlane", a_featMinorPlane);
	  check_typePoint(a_featMinorPlane->get_typePoint(), 0);
	}
      else
	check_typePoint(a_featMinorPlane->get_typePoint(), log);
    }
  if (a_featMinorPlane->get_planeVec())
    {
      adjustLevels(&featMinorPlaneAtts_planeVec, "featMinorPlane planeVec");
      if (log && !findString("planeVec", featMinorPlaneAtts))
	{
	  warnAtt("planeVec", "featMinorPlane", a_featMinorPlane);
	  check_vector(a_featMinorPlane->get_planeVec(), 0);
	}
      else
	check_vector(a_featMinorPlane->get_planeVec(), log);
    }
}

/********************************************************************/

void check_featMinorPoint(
 featMinorPoint * a_featMinorPoint,
 int log)
{
  if (a_featMinorPoint->get_typePoint())
    {
      adjustLevels(&featMinorPointAtts_a_typePoint,
		   "featMinorPoint a_typePoint");
      if (log && !findString("a_typePoint", featMinorPointAtts))
	{
	  warnAtt("a_typePoint", "featMinorPoint", a_featMinorPoint);
	  check_typePoint(a_featMinorPoint->get_typePoint(), 0);
	}
      else
	check_typePoint(a_featMinorPoint->get_typePoint(), log);
    }
  if (a_featMinorPoint->get_surfNorm())
    {
      adjustLevels(&featMinorPointAtts_surfNorm, "featMinorPoint surfNorm");
      if (log && !findString("surfNorm", featMinorPointAtts))
	{
	  warnAtt("surfNorm", "featMinorPoint", a_featMinorPoint);
	  check_vector(a_featMinorPoint->get_surfNorm(), 0);
	}
      else
	check_vector(a_featMinorPoint->get_surfNorm(), log);
    }
}

/********************************************************************/

void check_featMinorRctngl(
 featMinorRctngl * a_featMinorRctngl,
 int log)
{
  if (a_featMinorRctngl->get_matDir())
    {
      adjustLevels(&featMinorRctnglAtts_a_matDir, "featMinorRctngl a_matDir");
      if (log && !findString("a_matDir", featMinorRctnglAtts))
	{
	  warnAtt("a_matDir", "featMinorRctngl", a_featMinorRctngl);
	  check_matDir(a_featMinorRctngl->get_matDir(), 0);
	}
      else
	check_matDir(a_featMinorRctngl->get_matDir(), log);
    }
  if (a_featMinorRctngl->get_center())
    {
      adjustLevels(&featMinorRctnglAtts_center, "featMinorRctngl center");
      if (log && !findString("center", featMinorRctnglAtts))
	{
	  warnAtt("center", "featMinorRctngl", a_featMinorRctngl);
	  check_typePoint(a_featMinorRctngl->get_center(), 0);
	}
      else
	check_typePoint(a_featMinorRctngl->get_center(), log);
    }
  if (a_featMinorRctngl->get_faceVec1())
    {
      adjustLevels(&featMinorRctnglAtts_faceVec1, "featMinorRctngl faceVec1");
      if (log && !findString("faceVec1", featMinorRctnglAtts))
	{
	  warnAtt("faceVec1", "featMinorRctngl", a_featMinorRctngl);
	  check_vector(a_featMinorRctngl->get_faceVec1(), 0);
	}
      else
	check_vector(a_featMinorRctngl->get_faceVec1(), log);
    }
  if (a_featMinorRctngl->get_width1())
    {
      adjustLevels(&featMinorRctnglAtts_width1, "featMinorRctngl width1");
      if (log && !findString("width1", featMinorRctnglAtts))
	{
	  warnAtt("width1", "featMinorRctngl", a_featMinorRctngl);
	  check_rentVal(a_featMinorRctngl->get_width1(), 0);
	}
      else
	check_rentVal(a_featMinorRctngl->get_width1(), log);
    }
  if (a_featMinorRctngl->get_faceVec2())
    {
      adjustLevels(&featMinorRctnglAtts_faceVec2, "featMinorRctngl faceVec2");
      if (log && !findString("faceVec2", featMinorRctnglAtts))
	{
	  warnAtt("faceVec2", "featMinorRctngl", a_featMinorRctngl);
	  check_vector(a_featMinorRctngl->get_faceVec2(), 0);
	}
      else
	check_vector(a_featMinorRctngl->get_faceVec2(), log);
    }
  if (a_featMinorRctngl->get_width2())
    {
      adjustLevels(&featMinorRctnglAtts_width2, "featMinorRctngl width2");
      if (log && !findString("width2", featMinorRctnglAtts))
	{
	  warnAtt("width2", "featMinorRctngl", a_featMinorRctngl);
	  check_rentVal(a_featMinorRctngl->get_width2(), 0);
	}
      else
	check_rentVal(a_featMinorRctngl->get_width2(), log);
    }
  if (a_featMinorRctngl->get_faceVec3())
    {
      adjustLevels(&featMinorRctnglAtts_faceVec3, "featMinorRctngl faceVec3");
      if (log && !findString("faceVec3", featMinorRctnglAtts))
	{
	  warnAtt("faceVec3", "featMinorRctngl", a_featMinorRctngl);
	  check_vector(a_featMinorRctngl->get_faceVec3(), 0);
	}
      else
	check_vector(a_featMinorRctngl->get_faceVec3(), log);
    }
  if (a_featMinorRctngl->get_width3())
    {
      adjustLevels(&featMinorRctnglAtts_width3, "featMinorRctngl width3");
      if (log && !findString("width3", featMinorRctnglAtts))
	{
	  warnAtt("width3", "featMinorRctngl", a_featMinorRctngl);
	  check_rentVal(a_featMinorRctngl->get_width3(), 0);
	}
      else
	check_rentVal(a_featMinorRctngl->get_width3(), log);
    }
}

/********************************************************************/

void check_featMinorRevsurf(
 featMinorRevsurf * a_featMinorRevsurf,
 int log)
{
  if (isA(a_featMinorRevsurf, featRevsurfCart))
    {
      adjustLevels(&featMinorRevsurfSubs_featRevsurfCart, "featRevsurfCart");
      if (log && !findString("featRevsurfCart", featMinorRevsurfSubs))
	{
	  warnSub("featRevsurfCart", "featMinorRevsurf", a_featMinorRevsurf);
	  check_featRevsurfCart(
	    dynamic_cast<featRevsurfCart *>(a_featMinorRevsurf), 0);
	}
      else
	check_featRevsurfCart(
	  dynamic_cast<featRevsurfCart *>(a_featMinorRevsurf), log);
      return;
    }
  if (isA(a_featMinorRevsurf, featRevsurfPol))
    {
      adjustLevels(&featMinorRevsurfSubs_featRevsurfPol, "featRevsurfPol");
      if (log && !findString("featRevsurfPol", featMinorRevsurfSubs))
	{
	  warnSub("featRevsurfPol", "featMinorRevsurf", a_featMinorRevsurf);
	  check_featRevsurfPol(
	    dynamic_cast<featRevsurfPol *>(a_featMinorRevsurf), 0);
	}
      else
	check_featRevsurfPol(
	  dynamic_cast<featRevsurfPol *>(a_featMinorRevsurf), log);
      return;
    }
}

/********************************************************************/

void check_featMinorSphere(
 featMinorSphere * a_featMinorSphere,
 int log)
{
  if (a_featMinorSphere->get_matDir())
    {
      adjustLevels(&featMinorSphereAtts_a_matDir, "featMinorSphere a_matDir");
      if (log && !findString("a_matDir", featMinorSphereAtts))
	{
	  warnAtt("a_matDir", "featMinorSphere", a_featMinorSphere);
	  check_matDir(a_featMinorSphere->get_matDir(), 0);
	}
      else
	check_matDir(a_featMinorSphere->get_matDir(), log);
    }
  if (a_featMinorSphere->get_center())
    {
      adjustLevels(&featMinorSphereAtts_center, "featMinorSphere center");
      if (log && !findString("center", featMinorSphereAtts))
	{
	  warnAtt("center", "featMinorSphere", a_featMinorSphere);
	  check_typePoint(a_featMinorSphere->get_center(), 0);
	}
      else
	check_typePoint(a_featMinorSphere->get_center(), log);
    }
  if (a_featMinorSphere->get_diam())
    {
      adjustLevels(&featMinorSphereAtts_diam, "featMinorSphere diam");
      if (log && !findString("diam", featMinorSphereAtts))
	{
	  warnAtt("diam", "featMinorSphere", a_featMinorSphere);
	  check_rentVal(a_featMinorSphere->get_diam(), 0);
	}
      else
	check_rentVal(a_featMinorSphere->get_diam(), log);
    }
  if (a_featMinorSphere->get_orient())
    {
      adjustLevels(&featMinorSphereAtts_orient, "featMinorSphere orient");
      if (log && !findString("orient", featMinorSphereAtts))
	{
	  warnAtt("orient", "featMinorSphere", a_featMinorSphere);
	  check_vector(a_featMinorSphere->get_orient(), 0);
	}
      else
	check_vector(a_featMinorSphere->get_orient(), log);
    }
  if (a_featMinorSphere->get_lat())
    {
      adjustLevels(&featMinorSphereAtts_lat, "featMinorSphere lat");
      if (log && !findString("lat", featMinorSphereAtts))
	{
	  warnAtt("lat", "featMinorSphere", a_featMinorSphere);
	  check_angle(a_featMinorSphere->get_lat(), 0);
	}
      else
	check_angle(a_featMinorSphere->get_lat(), log);
    }
}

/********************************************************************/

void check_featMinorSphradseg(
 featMinorSphradseg * a_featMinorSphradseg,
 int log)
{
  if (a_featMinorSphradseg->get_matDir())
    {
      adjustLevels(&featMinorSphradsegAtts_a_matDir,
		   "featMinorSphradseg a_matDir");
      if (log && !findString("a_matDir", featMinorSphradsegAtts))
	{
	  warnAtt("a_matDir", "featMinorSphradseg", a_featMinorSphradseg);
	  check_matDir(a_featMinorSphradseg->get_matDir(), 0);
	}
      else
	check_matDir(a_featMinorSphradseg->get_matDir(), log);
    }
  if (a_featMinorSphradseg->get_center())
    {
      adjustLevels(&featMinorSphradsegAtts_center,
		   "featMinorSphradseg center");
      if (log && !findString("center", featMinorSphradsegAtts))
	{
	  warnAtt("center", "featMinorSphradseg", a_featMinorSphradseg);
	  check_typePoint(a_featMinorSphradseg->get_center(), 0);
	}
      else
	check_typePoint(a_featMinorSphradseg->get_center(), log);
    }
  if (a_featMinorSphradseg->get_diam())
    {
      adjustLevels(&featMinorSphradsegAtts_diam, "featMinorSphradseg diam");
      if (log && !findString("diam", featMinorSphradsegAtts))
	{
	  warnAtt("diam", "featMinorSphradseg", a_featMinorSphradseg);
	  check_rentVal(a_featMinorSphradseg->get_diam(), 0);
	}
      else
	check_rentVal(a_featMinorSphradseg->get_diam(), log);
    }
  if (a_featMinorSphradseg->get_north())
    {
      adjustLevels(&featMinorSphradsegAtts_north, "featMinorSphradseg north");
      if (log && !findString("north", featMinorSphradsegAtts))
	{
	  warnAtt("north", "featMinorSphradseg", a_featMinorSphradseg);
	  check_vector(a_featMinorSphradseg->get_north(), 0);
	}
      else
	check_vector(a_featMinorSphradseg->get_north(), log);
    }
  if (a_featMinorSphradseg->get_latStart())
    {
      adjustLevels(&featMinorSphradsegAtts_latStart,
		   "featMinorSphradseg latStart");
      if (log && !findString("latStart", featMinorSphradsegAtts))
	{
	  warnAtt("latStart", "featMinorSphradseg", a_featMinorSphradseg);
	  check_rentVal(a_featMinorSphradseg->get_latStart(), 0);
	}
      else
	check_rentVal(a_featMinorSphradseg->get_latStart(), log);
    }
  if (a_featMinorSphradseg->get_latStop())
    {
      adjustLevels(&featMinorSphradsegAtts_latStop,
		   "featMinorSphradseg latStop");
      if (log && !findString("latStop", featMinorSphradsegAtts))
	{
	  warnAtt("latStop", "featMinorSphradseg", a_featMinorSphradseg);
	  check_rentVal(a_featMinorSphradseg->get_latStop(), 0);
	}
      else
	check_rentVal(a_featMinorSphradseg->get_latStop(), log);
    }
  if (a_featMinorSphradseg->get_prime())
    {
      adjustLevels(&featMinorSphradsegAtts_prime, "featMinorSphradseg prime");
      if (log && !findString("prime", featMinorSphradsegAtts))
	{
	  warnAtt("prime", "featMinorSphradseg", a_featMinorSphradseg);
	  check_vector(a_featMinorSphradseg->get_prime(), 0);
	}
      else
	check_vector(a_featMinorSphradseg->get_prime(), log);
    }
  if (a_featMinorSphradseg->get_longStart())
    {
      adjustLevels(&featMinorSphradsegAtts_longStart,
		   "featMinorSphradseg longStart");
      if (log && !findString("longStart", featMinorSphradsegAtts))
	{
	  warnAtt("longStart", "featMinorSphradseg", a_featMinorSphradseg);
	  check_rentVal(a_featMinorSphradseg->get_longStart(), 0);
	}
      else
	check_rentVal(a_featMinorSphradseg->get_longStart(), log);
    }
  if (a_featMinorSphradseg->get_longStop())
    {
      adjustLevels(&featMinorSphradsegAtts_longStop,
		   "featMinorSphradseg longStop");
      if (log && !findString("longStop", featMinorSphradsegAtts))
	{
	  warnAtt("longStop", "featMinorSphradseg", a_featMinorSphradseg);
	  check_rentVal(a_featMinorSphradseg->get_longStop(), 0);
	}
      else
	check_rentVal(a_featMinorSphradseg->get_longStop(), log);
    }
}

/********************************************************************/

void check_featMinorSympln(
 featMinorSympln * a_featMinorSympln,
 int log)
{
  if (isA(a_featMinorSympln, featSymplnCart))
    {
      adjustLevels(&featMinorSymplnSubs_featSymplnCart, "featSymplnCart");
      if (log && !findString("featSymplnCart", featMinorSymplnSubs))
	{
	  warnSub("featSymplnCart", "featMinorSympln", a_featMinorSympln);
	  check_featSymplnCart(
	    dynamic_cast<featSymplnCart *>(a_featMinorSympln), 0);
	}
      else
	check_featSymplnCart(
	  dynamic_cast<featSymplnCart *>(a_featMinorSympln), log);
      return;
    }
  if (isA(a_featMinorSympln, featSymplnPol))
    {
      adjustLevels(&featMinorSymplnSubs_featSymplnPol, "featSymplnPol");
      if (log && !findString("featSymplnPol", featMinorSymplnSubs))
	{
	  warnSub("featSymplnPol", "featMinorSympln", a_featMinorSympln);
	  check_featSymplnPol(
	    dynamic_cast<featSymplnPol *>(a_featMinorSympln), 0);
	}
      else
	check_featSymplnPol(
	  dynamic_cast<featSymplnPol *>(a_featMinorSympln), log);
      return;
    }
}

/********************************************************************/

void check_featMinorTorradseg(
 featMinorTorradseg * a_featMinorTorradseg,
 int log)
{
  if (a_featMinorTorradseg->get_matDir())
    {
      adjustLevels(&featMinorTorradsegAtts_a_matDir,
		   "featMinorTorradseg a_matDir");
      if (log && !findString("a_matDir", featMinorTorradsegAtts))
	{
	  warnAtt("a_matDir", "featMinorTorradseg", a_featMinorTorradseg);
	  check_matDir(a_featMinorTorradseg->get_matDir(), 0);
	}
      else
	check_matDir(a_featMinorTorradseg->get_matDir(), log);
    }
  if (a_featMinorTorradseg->get_center())
    {
      adjustLevels(&featMinorTorradsegAtts_center,
		   "featMinorTorradseg center");
      if (log && !findString("center", featMinorTorradsegAtts))
	{
	  warnAtt("center", "featMinorTorradseg", a_featMinorTorradseg);
	  check_typePoint(a_featMinorTorradseg->get_center(), 0);
	}
      else
	check_typePoint(a_featMinorTorradseg->get_center(), log);
    }
  if (a_featMinorTorradseg->get_majrad())
    {
      adjustLevels(&featMinorTorradsegAtts_majrad,
		   "featMinorTorradseg majrad");
      if (log && !findString("majrad", featMinorTorradsegAtts))
	{
	  warnAtt("majrad", "featMinorTorradseg", a_featMinorTorradseg);
	  check_rentVal(a_featMinorTorradseg->get_majrad(), 0);
	}
      else
	check_rentVal(a_featMinorTorradseg->get_majrad(), log);
    }
  if (a_featMinorTorradseg->get_minrad())
    {
      adjustLevels(&featMinorTorradsegAtts_minrad,
		   "featMinorTorradseg minrad");
      if (log && !findString("minrad", featMinorTorradsegAtts))
	{
	  warnAtt("minrad", "featMinorTorradseg", a_featMinorTorradseg);
	  check_rentVal(a_featMinorTorradseg->get_minrad(), 0);
	}
      else
	check_rentVal(a_featMinorTorradseg->get_minrad(), log);
    }
  if (a_featMinorTorradseg->get_north())
    {
      adjustLevels(&featMinorTorradsegAtts_north, "featMinorTorradseg north");
      if (log && !findString("north", featMinorTorradsegAtts))
	{
	  warnAtt("north", "featMinorTorradseg", a_featMinorTorradseg);
	  check_vector(a_featMinorTorradseg->get_north(), 0);
	}
      else
	check_vector(a_featMinorTorradseg->get_north(), log);
    }
  if (a_featMinorTorradseg->get_latStart())
    {
      adjustLevels(&featMinorTorradsegAtts_latStart,
		   "featMinorTorradseg latStart");
      if (log && !findString("latStart", featMinorTorradsegAtts))
	{
	  warnAtt("latStart", "featMinorTorradseg", a_featMinorTorradseg);
	  check_rentVal(a_featMinorTorradseg->get_latStart(), 0);
	}
      else
	check_rentVal(a_featMinorTorradseg->get_latStart(), log);
    }
  if (a_featMinorTorradseg->get_latStop())
    {
      adjustLevels(&featMinorTorradsegAtts_latStop,
		   "featMinorTorradseg latStop");
      if (log && !findString("latStop", featMinorTorradsegAtts))
	{
	  warnAtt("latStop", "featMinorTorradseg", a_featMinorTorradseg);
	  check_rentVal(a_featMinorTorradseg->get_latStop(), 0);
	}
      else
	check_rentVal(a_featMinorTorradseg->get_latStop(), log);
    }
  if (a_featMinorTorradseg->get_prime())
    {
      adjustLevels(&featMinorTorradsegAtts_prime, "featMinorTorradseg prime");
      if (log && !findString("prime", featMinorTorradsegAtts))
	{
	  warnAtt("prime", "featMinorTorradseg", a_featMinorTorradseg);
	  check_vector(a_featMinorTorradseg->get_prime(), 0);
	}
      else
	check_vector(a_featMinorTorradseg->get_prime(), log);
    }
  if (a_featMinorTorradseg->get_longStart())
    {
      adjustLevels(&featMinorTorradsegAtts_longStart,
		   "featMinorTorradseg longStart");
      if (log && !findString("longStart", featMinorTorradsegAtts))
	{
	  warnAtt("longStart", "featMinorTorradseg", a_featMinorTorradseg);
	  check_rentVal(a_featMinorTorradseg->get_longStart(), 0);
	}
      else
	check_rentVal(a_featMinorTorradseg->get_longStart(), log);
    }
  if (a_featMinorTorradseg->get_longStop())
    {
      adjustLevels(&featMinorTorradsegAtts_longStop,
		   "featMinorTorradseg longStop");
      if (log && !findString("longStop", featMinorTorradsegAtts))
	{
	  warnAtt("longStop", "featMinorTorradseg", a_featMinorTorradseg);
	  check_rentVal(a_featMinorTorradseg->get_longStop(), 0);
	}
      else
	check_rentVal(a_featMinorTorradseg->get_longStop(), log);
    }
}

/********************************************************************/

void check_featMinorTorus(
 featMinorTorus * a_featMinorTorus,
 int log)
{
  if (a_featMinorTorus->get_matDir())
    {
      adjustLevels(&featMinorTorusAtts_a_matDir, "featMinorTorus a_matDir");
      if (log && !findString("a_matDir", featMinorTorusAtts))
	{
	  warnAtt("a_matDir", "featMinorTorus", a_featMinorTorus);
	  check_matDir(a_featMinorTorus->get_matDir(), 0);
	}
      else
	check_matDir(a_featMinorTorus->get_matDir(), log);
    }
  if (a_featMinorTorus->get_center())
    {
      adjustLevels(&featMinorTorusAtts_center, "featMinorTorus center");
      if (log && !findString("center", featMinorTorusAtts))
	{
	  warnAtt("center", "featMinorTorus", a_featMinorTorus);
	  check_typePoint(a_featMinorTorus->get_center(), 0);
	}
      else
	check_typePoint(a_featMinorTorus->get_center(), log);
    }
  if (a_featMinorTorus->get_axis())
    {
      adjustLevels(&featMinorTorusAtts_axis, "featMinorTorus axis");
      if (log && !findString("axis", featMinorTorusAtts))
	{
	  warnAtt("axis", "featMinorTorus", a_featMinorTorus);
	  check_vector(a_featMinorTorus->get_axis(), 0);
	}
      else
	check_vector(a_featMinorTorus->get_axis(), log);
    }
  if (a_featMinorTorus->get_majorDiam())
    {
      adjustLevels(&featMinorTorusAtts_majorDiam, "featMinorTorus majorDiam");
      if (log && !findString("majorDiam", featMinorTorusAtts))
	{
	  warnAtt("majorDiam", "featMinorTorus", a_featMinorTorus);
	  check_rentVal(a_featMinorTorus->get_majorDiam(), 0);
	}
      else
	check_rentVal(a_featMinorTorus->get_majorDiam(), log);
    }
  if (a_featMinorTorus->get_minorDiam())
    {
      adjustLevels(&featMinorTorusAtts_minorDiam, "featMinorTorus minorDiam");
      if (log && !findString("minorDiam", featMinorTorusAtts))
	{
	  warnAtt("minorDiam", "featMinorTorus", a_featMinorTorus);
	  check_rentVal(a_featMinorTorus->get_minorDiam(), 0);
	}
      else
	check_rentVal(a_featMinorTorus->get_minorDiam(), log);
    }
}

/********************************************************************/

void check_featObjectAct(
 featObjectAct * a_featObjectAct,
 int log)
{
  if (a_featObjectAct->get_faLabel())
    {
      adjustLevels(&featObjectActAtts_a_faLabel, "featObjectAct a_faLabel");
      if (log && !findString("a_faLabel", featObjectActAtts))
	{
	  warnAtt("a_faLabel", "featObjectAct", a_featObjectAct);
	  check_faLabel(a_featObjectAct->get_faLabel(), 0);
	}
      else
	check_faLabel(a_featObjectAct->get_faLabel(), log);
    }
  if (a_featObjectAct->get_featMinorObject())
    {
      adjustLevels(&featObjectActAtts_a_featMinorObject,
		   "featObjectAct a_featMinorObject");
      if (log && !findString("a_featMinorObject", featObjectActAtts))
	{
	  warnAtt("a_featMinorObject", "featObjectAct", a_featObjectAct);
	  check_featMinorObject(a_featObjectAct->get_featMinorObject(), 0);
	}
      else
	check_featMinorObject(a_featObjectAct->get_featMinorObject(), log);
    }
}

/********************************************************************/

void check_featObjectNom(
 featObjectNom * a_featObjectNom,
 int log)
{
  if (a_featObjectNom->get_fLabel())
    {
      adjustLevels(&featObjectNomAtts_a_fLabel, "featObjectNom a_fLabel");
      if (log && !findString("a_fLabel", featObjectNomAtts))
	{
	  warnAtt("a_fLabel", "featObjectNom", a_featObjectNom);
	  check_fLabel(a_featObjectNom->get_fLabel(), 0);
	}
      else
	check_fLabel(a_featObjectNom->get_fLabel(), log);
    }
  if (a_featObjectNom->get_featMinorObject())
    {
      adjustLevels(&featObjectNomAtts_a_featMinorObject,
		   "featObjectNom a_featMinorObject");
      if (log && !findString("a_featMinorObject", featObjectNomAtts))
	{
	  warnAtt("a_featMinorObject", "featObjectNom", a_featObjectNom);
	  check_featMinorObject(a_featObjectNom->get_featMinorObject(), 0);
	}
      else
	check_featMinorObject(a_featObjectNom->get_featMinorObject(), log);
    }
}

/********************************************************************/

void check_featObjectStm(
 featObjectStm * a_featObjectStm,
 int log)
{
  if (isA(a_featObjectStm, featObjectNom))
    {
      adjustLevels(&featObjectStmSubs_featObjectNom, "featObjectNom");
      if (log && !findString("featObjectNom", featObjectStmSubs))
	{
	  warnSub("featObjectNom", "featObjectStm", a_featObjectStm);
	  check_featObjectNom(
	    dynamic_cast<featObjectNom *>(a_featObjectStm), 0);
	}
      else
	check_featObjectNom(
	  dynamic_cast<featObjectNom *>(a_featObjectStm), log);
      return;
    }
  if (isA(a_featObjectStm, featObjectAct))
    {
      adjustLevels(&featObjectStmSubs_featObjectAct, "featObjectAct");
      if (log && !findString("featObjectAct", featObjectStmSubs))
	{
	  warnSub("featObjectAct", "featObjectStm", a_featObjectStm);
	  check_featObjectAct(
	    dynamic_cast<featObjectAct *>(a_featObjectStm), 0);
	}
      else
	check_featObjectAct(
	  dynamic_cast<featObjectAct *>(a_featObjectStm), log);
      return;
    }
}

/********************************************************************/

void check_featParplnAct(
 featParplnAct * a_featParplnAct,
 int log)
{
  if (a_featParplnAct->get_faLabel())
    {
      adjustLevels(&featParplnActAtts_a_faLabel, "featParplnAct a_faLabel");
      if (log && !findString("a_faLabel", featParplnActAtts))
	{
	  warnAtt("a_faLabel", "featParplnAct", a_featParplnAct);
	  check_faLabel(a_featParplnAct->get_faLabel(), 0);
	}
      else
	check_faLabel(a_featParplnAct->get_faLabel(), log);
    }
  if (a_featParplnAct->get_featMinorParpln())
    {
      adjustLevels(&featParplnActAtts_a_featMinorParpln,
		   "featParplnAct a_featMinorParpln");
      if (log && !findString("a_featMinorParpln", featParplnActAtts))
	{
	  warnAtt("a_featMinorParpln", "featParplnAct", a_featParplnAct);
	  check_featMinorParpln(a_featParplnAct->get_featMinorParpln(), 0);
	}
      else
	check_featMinorParpln(a_featParplnAct->get_featMinorParpln(), log);
    }
}

/********************************************************************/

void check_featParplnMidplCart(
 featParplnMidplCart * a_featParplnMidplCart,
 int log)
{
  if (a_featParplnMidplCart->get_matDir())
    {
      adjustLevels(&featParplnMidplCartAtts_a_matDir,
		   "featParplnMidplCart a_matDir");
      if (log && !findString("a_matDir", featParplnMidplCartAtts))
	{
	  warnAtt("a_matDir", "featParplnMidplCart", a_featParplnMidplCart);
	  check_matDir(a_featParplnMidplCart->get_matDir(), 0);
	}
      else
	check_matDir(a_featParplnMidplCart->get_matDir(), log);
    }
  if (a_featParplnMidplCart->get_centerPt())
    {
      adjustLevels(&featParplnMidplCartAtts_centerPt,
		   "featParplnMidplCart centerPt");
      if (log && !findString("centerPt", featParplnMidplCartAtts))
	{
	  warnAtt("centerPt", "featParplnMidplCart", a_featParplnMidplCart);
	  check_cartPoint(a_featParplnMidplCart->get_centerPt(), 0);
	}
      else
	check_cartPoint(a_featParplnMidplCart->get_centerPt(), log);
    }
  if (a_featParplnMidplCart->get_centerVec())
    {
      adjustLevels(&featParplnMidplCartAtts_centerVec,
		   "featParplnMidplCart centerVec");
      if (log && !findString("centerVec", featParplnMidplCartAtts))
	{
	  warnAtt("centerVec", "featParplnMidplCart", a_featParplnMidplCart);
	  check_vector(a_featParplnMidplCart->get_centerVec(), 0);
	}
      else
	check_vector(a_featParplnMidplCart->get_centerVec(), log);
    }
  if (a_featParplnMidplCart->get_width())
    {
      adjustLevels(&featParplnMidplCartAtts_width,
		   "featParplnMidplCart width");
      if (log && !findString("width", featParplnMidplCartAtts))
	{
	  warnAtt("width", "featParplnMidplCart", a_featParplnMidplCart);
	  check_rentVal(a_featParplnMidplCart->get_width(), 0);
	}
      else
	check_rentVal(a_featParplnMidplCart->get_width(), log);
    }
}

/********************************************************************/

void check_featParplnMidplPol(
 featParplnMidplPol * a_featParplnMidplPol,
 int log)
{
  if (a_featParplnMidplPol->get_matDir())
    {
      adjustLevels(&featParplnMidplPolAtts_a_matDir,
		   "featParplnMidplPol a_matDir");
      if (log && !findString("a_matDir", featParplnMidplPolAtts))
	{
	  warnAtt("a_matDir", "featParplnMidplPol", a_featParplnMidplPol);
	  check_matDir(a_featParplnMidplPol->get_matDir(), 0);
	}
      else
	check_matDir(a_featParplnMidplPol->get_matDir(), log);
    }
  if (a_featParplnMidplPol->get_centerPt())
    {
      adjustLevels(&featParplnMidplPolAtts_centerPt,
		   "featParplnMidplPol centerPt");
      if (log && !findString("centerPt", featParplnMidplPolAtts))
	{
	  warnAtt("centerPt", "featParplnMidplPol", a_featParplnMidplPol);
	  check_polPoint(a_featParplnMidplPol->get_centerPt(), 0);
	}
      else
	check_polPoint(a_featParplnMidplPol->get_centerPt(), log);
    }
  if (a_featParplnMidplPol->get_centerVec())
    {
      adjustLevels(&featParplnMidplPolAtts_centerVec,
		   "featParplnMidplPol centerVec");
      if (log && !findString("centerVec", featParplnMidplPolAtts))
	{
	  warnAtt("centerVec", "featParplnMidplPol", a_featParplnMidplPol);
	  check_vector(a_featParplnMidplPol->get_centerVec(), 0);
	}
      else
	check_vector(a_featParplnMidplPol->get_centerVec(), log);
    }
  if (a_featParplnMidplPol->get_width())
    {
      adjustLevels(&featParplnMidplPolAtts_width, "featParplnMidplPol width");
      if (log && !findString("width", featParplnMidplPolAtts))
	{
	  warnAtt("width", "featParplnMidplPol", a_featParplnMidplPol);
	  check_rentVal(a_featParplnMidplPol->get_width(), 0);
	}
      else
	check_rentVal(a_featParplnMidplPol->get_width(), log);
    }
}

/********************************************************************/

void check_featParplnNom(
 featParplnNom * a_featParplnNom,
 int log)
{
  if (a_featParplnNom->get_fLabel())
    {
      adjustLevels(&featParplnNomAtts_a_fLabel, "featParplnNom a_fLabel");
      if (log && !findString("a_fLabel", featParplnNomAtts))
	{
	  warnAtt("a_fLabel", "featParplnNom", a_featParplnNom);
	  check_fLabel(a_featParplnNom->get_fLabel(), 0);
	}
      else
	check_fLabel(a_featParplnNom->get_fLabel(), log);
    }
  if (a_featParplnNom->get_featMinorParpln())
    {
      adjustLevels(&featParplnNomAtts_a_featMinorParpln,
		   "featParplnNom a_featMinorParpln");
      if (log && !findString("a_featMinorParpln", featParplnNomAtts))
	{
	  warnAtt("a_featMinorParpln", "featParplnNom", a_featParplnNom);
	  check_featMinorParpln(a_featParplnNom->get_featMinorParpln(), 0);
	}
      else
	check_featMinorParpln(a_featParplnNom->get_featMinorParpln(), log);
    }
}

/********************************************************************/

void check_featParplnPointsCart(
 featParplnPointsCart * a_featParplnPointsCart,
 int log)
{
  if (a_featParplnPointsCart->get_matDir())
    {
      adjustLevels(&featParplnPointsCartAtts_a_matDir,
		   "featParplnPointsCart a_matDir");
      if (log && !findString("a_matDir", featParplnPointsCartAtts))
	{
	  warnAtt("a_matDir", "featParplnPointsCart", a_featParplnPointsCart);
	  check_matDir(a_featParplnPointsCart->get_matDir(), 0);
	}
      else
	check_matDir(a_featParplnPointsCart->get_matDir(), log);
    }
  if (a_featParplnPointsCart->get_centerPt())
    {
      adjustLevels(&featParplnPointsCartAtts_centerPt,
		   "featParplnPointsCart centerPt");
      if (log && !findString("centerPt", featParplnPointsCartAtts))
	{
	  warnAtt("centerPt", "featParplnPointsCart", a_featParplnPointsCart);
	  check_cartPoint(a_featParplnPointsCart->get_centerPt(), 0);
	}
      else
	check_cartPoint(a_featParplnPointsCart->get_centerPt(), log);
    }
  if (a_featParplnPointsCart->get_plane1data())
    {
      adjustLevels(&featParplnPointsCartAtts_plane1data,
		   "featParplnPointsCart plane1data");
      if (log && !findString("plane1data", featParplnPointsCartAtts))
	{
	  warnAtt("plane1data", "featParplnPointsCart",
		  a_featParplnPointsCart);
	  check_pointVecCart(a_featParplnPointsCart->get_plane1data(), 0);
	}
      else
	check_pointVecCart(a_featParplnPointsCart->get_plane1data(), log);
    }
  if (a_featParplnPointsCart->get_plane2data())
    {
      adjustLevels(&featParplnPointsCartAtts_plane2data,
		   "featParplnPointsCart plane2data");
      if (log && !findString("plane2data", featParplnPointsCartAtts))
	{
	  warnAtt("plane2data", "featParplnPointsCart",
		  a_featParplnPointsCart);
	  check_pointVecCart(a_featParplnPointsCart->get_plane2data(), 0);
	}
      else
	check_pointVecCart(a_featParplnPointsCart->get_plane2data(), log);
    }
  if (a_featParplnPointsCart->get_width())
    {
      adjustLevels(&featParplnPointsCartAtts_width,
		   "featParplnPointsCart width");
      if (log && !findString("width", featParplnPointsCartAtts))
	{
	  warnAtt("width", "featParplnPointsCart", a_featParplnPointsCart);
	  check_rentVal(a_featParplnPointsCart->get_width(), 0);
	}
      else
	check_rentVal(a_featParplnPointsCart->get_width(), log);
    }
}

/********************************************************************/

void check_featParplnPointsPol(
 featParplnPointsPol * a_featParplnPointsPol,
 int log)
{
  if (a_featParplnPointsPol->get_matDir())
    {
      adjustLevels(&featParplnPointsPolAtts_a_matDir,
		   "featParplnPointsPol a_matDir");
      if (log && !findString("a_matDir", featParplnPointsPolAtts))
	{
	  warnAtt("a_matDir", "featParplnPointsPol", a_featParplnPointsPol);
	  check_matDir(a_featParplnPointsPol->get_matDir(), 0);
	}
      else
	check_matDir(a_featParplnPointsPol->get_matDir(), log);
    }
  if (a_featParplnPointsPol->get_centerPt())
    {
      adjustLevels(&featParplnPointsPolAtts_centerPt,
		   "featParplnPointsPol centerPt");
      if (log && !findString("centerPt", featParplnPointsPolAtts))
	{
	  warnAtt("centerPt", "featParplnPointsPol", a_featParplnPointsPol);
	  check_polPoint(a_featParplnPointsPol->get_centerPt(), 0);
	}
      else
	check_polPoint(a_featParplnPointsPol->get_centerPt(), log);
    }
  if (a_featParplnPointsPol->get_plane1data())
    {
      adjustLevels(&featParplnPointsPolAtts_plane1data,
		   "featParplnPointsPol plane1data");
      if (log && !findString("plane1data", featParplnPointsPolAtts))
	{
	  warnAtt("plane1data", "featParplnPointsPol", a_featParplnPointsPol);
	  check_pointVecPol(a_featParplnPointsPol->get_plane1data(), 0);
	}
      else
	check_pointVecPol(a_featParplnPointsPol->get_plane1data(), log);
    }
  if (a_featParplnPointsPol->get_plane2data())
    {
      adjustLevels(&featParplnPointsPolAtts_plane2data,
		   "featParplnPointsPol plane2data");
      if (log && !findString("plane2data", featParplnPointsPolAtts))
	{
	  warnAtt("plane2data", "featParplnPointsPol", a_featParplnPointsPol);
	  check_pointVecPol(a_featParplnPointsPol->get_plane2data(), 0);
	}
      else
	check_pointVecPol(a_featParplnPointsPol->get_plane2data(), log);
    }
  if (a_featParplnPointsPol->get_width())
    {
      adjustLevels(&featParplnPointsPolAtts_width,
		   "featParplnPointsPol width");
      if (log && !findString("width", featParplnPointsPolAtts))
	{
	  warnAtt("width", "featParplnPointsPol", a_featParplnPointsPol);
	  check_rentVal(a_featParplnPointsPol->get_width(), 0);
	}
      else
	check_rentVal(a_featParplnPointsPol->get_width(), log);
    }
}

/********************************************************************/

void check_featParplnStm(
 featParplnStm * a_featParplnStm,
 int log)
{
  if (isA(a_featParplnStm, featParplnNom))
    {
      adjustLevels(&featParplnStmSubs_featParplnNom, "featParplnNom");
      if (log && !findString("featParplnNom", featParplnStmSubs))
	{
	  warnSub("featParplnNom", "featParplnStm", a_featParplnStm);
	  check_featParplnNom(
	    dynamic_cast<featParplnNom *>(a_featParplnStm), 0);
	}
      else
	check_featParplnNom(
	  dynamic_cast<featParplnNom *>(a_featParplnStm), log);
      return;
    }
  if (isA(a_featParplnStm, featParplnAct))
    {
      adjustLevels(&featParplnStmSubs_featParplnAct, "featParplnAct");
      if (log && !findString("featParplnAct", featParplnStmSubs))
	{
	  warnSub("featParplnAct", "featParplnStm", a_featParplnStm);
	  check_featParplnAct(
	    dynamic_cast<featParplnAct *>(a_featParplnStm), 0);
	}
      else
	check_featParplnAct(
	  dynamic_cast<featParplnAct *>(a_featParplnStm), log);
      return;
    }
}

/********************************************************************/

void check_featPaternStm(
 featPaternStm * a_featPaternStm,
 int log)
{
  if (a_featPaternStm->get_fLabel())
    {
      adjustLevels(&featPaternStmAtts_a_fLabel, "featPaternStm a_fLabel");
      if (log && !findString("a_fLabel", featPaternStmAtts))
	{
	  warnAtt("a_fLabel", "featPaternStm", a_featPaternStm);
	  check_fLabel(a_featPaternStm->get_fLabel(), 0);
	}
      else
	check_fLabel(a_featPaternStm->get_fLabel(), log);
    }
  if (a_featPaternStm->get_featMinorPatern())
    {
      adjustLevels(&featPaternStmAtts_a_featMinorPatern,
		   "featPaternStm a_featMinorPatern");
      if (log && !findString("a_featMinorPatern", featPaternStmAtts))
	{
	  warnAtt("a_featMinorPatern", "featPaternStm", a_featPaternStm);
	  check_featMinorPatern(a_featPaternStm->get_featMinorPatern(), 0);
	}
      else
	check_featMinorPatern(a_featPaternStm->get_featMinorPatern(), log);
    }
}

/********************************************************************/

void check_featPlaneAct(
 featPlaneAct * a_featPlaneAct,
 int log)
{
  if (a_featPlaneAct->get_faLabel())
    {
      adjustLevels(&featPlaneActAtts_a_faLabel, "featPlaneAct a_faLabel");
      if (log && !findString("a_faLabel", featPlaneActAtts))
	{
	  warnAtt("a_faLabel", "featPlaneAct", a_featPlaneAct);
	  check_faLabel(a_featPlaneAct->get_faLabel(), 0);
	}
      else
	check_faLabel(a_featPlaneAct->get_faLabel(), log);
    }
  if (a_featPlaneAct->get_featMinorPlane())
    {
      adjustLevels(&featPlaneActAtts_a_featMinorPlane,
		   "featPlaneAct a_featMinorPlane");
      if (log && !findString("a_featMinorPlane", featPlaneActAtts))
	{
	  warnAtt("a_featMinorPlane", "featPlaneAct", a_featPlaneAct);
	  check_featMinorPlane(a_featPlaneAct->get_featMinorPlane(), 0);
	}
      else
	check_featMinorPlane(a_featPlaneAct->get_featMinorPlane(), log);
    }
}

/********************************************************************/

void check_featPlaneNom(
 featPlaneNom * a_featPlaneNom,
 int log)
{
  if (a_featPlaneNom->get_fLabel())
    {
      adjustLevels(&featPlaneNomAtts_a_fLabel, "featPlaneNom a_fLabel");
      if (log && !findString("a_fLabel", featPlaneNomAtts))
	{
	  warnAtt("a_fLabel", "featPlaneNom", a_featPlaneNom);
	  check_fLabel(a_featPlaneNom->get_fLabel(), 0);
	}
      else
	check_fLabel(a_featPlaneNom->get_fLabel(), log);
    }
  if (a_featPlaneNom->get_featMinorPlane())
    {
      adjustLevels(&featPlaneNomAtts_a_featMinorPlane,
		   "featPlaneNom a_featMinorPlane");
      if (log && !findString("a_featMinorPlane", featPlaneNomAtts))
	{
	  warnAtt("a_featMinorPlane", "featPlaneNom", a_featPlaneNom);
	  check_featMinorPlane(a_featPlaneNom->get_featMinorPlane(), 0);
	}
      else
	check_featMinorPlane(a_featPlaneNom->get_featMinorPlane(), log);
    }
}

/********************************************************************/

void check_featPlaneStm(
 featPlaneStm * a_featPlaneStm,
 int log)
{
  if (isA(a_featPlaneStm, featPlaneNom))
    {
      adjustLevels(&featPlaneStmSubs_featPlaneNom, "featPlaneNom");
      if (log && !findString("featPlaneNom", featPlaneStmSubs))
	{
	  warnSub("featPlaneNom", "featPlaneStm", a_featPlaneStm);
	  check_featPlaneNom(
	    dynamic_cast<featPlaneNom *>(a_featPlaneStm), 0);
	}
      else
	check_featPlaneNom(
	  dynamic_cast<featPlaneNom *>(a_featPlaneStm), log);
      return;
    }
  if (isA(a_featPlaneStm, featPlaneAct))
    {
      adjustLevels(&featPlaneStmSubs_featPlaneAct, "featPlaneAct");
      if (log && !findString("featPlaneAct", featPlaneStmSubs))
	{
	  warnSub("featPlaneAct", "featPlaneStm", a_featPlaneStm);
	  check_featPlaneAct(
	    dynamic_cast<featPlaneAct *>(a_featPlaneStm), 0);
	}
      else
	check_featPlaneAct(
	  dynamic_cast<featPlaneAct *>(a_featPlaneStm), log);
      return;
    }
}

/********************************************************************/

void check_featPointAct(
 featPointAct * a_featPointAct,
 int log)
{
  if (a_featPointAct->get_faLabel())
    {
      adjustLevels(&featPointActAtts_a_faLabel, "featPointAct a_faLabel");
      if (log && !findString("a_faLabel", featPointActAtts))
	{
	  warnAtt("a_faLabel", "featPointAct", a_featPointAct);
	  check_faLabel(a_featPointAct->get_faLabel(), 0);
	}
      else
	check_faLabel(a_featPointAct->get_faLabel(), log);
    }
  if (a_featPointAct->get_featMinorPoint())
    {
      adjustLevels(&featPointActAtts_a_featMinorPoint,
		   "featPointAct a_featMinorPoint");
      if (log && !findString("a_featMinorPoint", featPointActAtts))
	{
	  warnAtt("a_featMinorPoint", "featPointAct", a_featPointAct);
	  check_featMinorPoint(a_featPointAct->get_featMinorPoint(), 0);
	}
      else
	check_featMinorPoint(a_featPointAct->get_featMinorPoint(), log);
    }
}

/********************************************************************/

void check_featPointNom(
 featPointNom * a_featPointNom,
 int log)
{
  if (a_featPointNom->get_fLabel())
    {
      adjustLevels(&featPointNomAtts_a_fLabel, "featPointNom a_fLabel");
      if (log && !findString("a_fLabel", featPointNomAtts))
	{
	  warnAtt("a_fLabel", "featPointNom", a_featPointNom);
	  check_fLabel(a_featPointNom->get_fLabel(), 0);
	}
      else
	check_fLabel(a_featPointNom->get_fLabel(), log);
    }
  if (a_featPointNom->get_featMinorPoint())
    {
      adjustLevels(&featPointNomAtts_a_featMinorPoint,
		   "featPointNom a_featMinorPoint");
      if (log && !findString("a_featMinorPoint", featPointNomAtts))
	{
	  warnAtt("a_featMinorPoint", "featPointNom", a_featPointNom);
	  check_featMinorPoint(a_featPointNom->get_featMinorPoint(), 0);
	}
      else
	check_featMinorPoint(a_featPointNom->get_featMinorPoint(), log);
    }
}

/********************************************************************/

void check_featPointStm(
 featPointStm * a_featPointStm,
 int log)
{
  if (isA(a_featPointStm, featPointNom))
    {
      adjustLevels(&featPointStmSubs_featPointNom, "featPointNom");
      if (log && !findString("featPointNom", featPointStmSubs))
	{
	  warnSub("featPointNom", "featPointStm", a_featPointStm);
	  check_featPointNom(
	    dynamic_cast<featPointNom *>(a_featPointStm), 0);
	}
      else
	check_featPointNom(
	  dynamic_cast<featPointNom *>(a_featPointStm), log);
      return;
    }
  if (isA(a_featPointStm, featPointAct))
    {
      adjustLevels(&featPointStmSubs_featPointAct, "featPointAct");
      if (log && !findString("featPointAct", featPointStmSubs))
	{
	  warnSub("featPointAct", "featPointStm", a_featPointStm);
	  check_featPointAct(
	    dynamic_cast<featPointAct *>(a_featPointStm), 0);
	}
      else
	check_featPointAct(
	  dynamic_cast<featPointAct *>(a_featPointStm), log);
      return;
    }
}

/********************************************************************/

void check_featRctnglAct(
 featRctnglAct * a_featRctnglAct,
 int log)
{
  if (a_featRctnglAct->get_faLabel())
    {
      adjustLevels(&featRctnglActAtts_a_faLabel, "featRctnglAct a_faLabel");
      if (log && !findString("a_faLabel", featRctnglActAtts))
	{
	  warnAtt("a_faLabel", "featRctnglAct", a_featRctnglAct);
	  check_faLabel(a_featRctnglAct->get_faLabel(), 0);
	}
      else
	check_faLabel(a_featRctnglAct->get_faLabel(), log);
    }
  if (a_featRctnglAct->get_featMinorRctngl())
    {
      adjustLevels(&featRctnglActAtts_a_featMinorRctngl,
		   "featRctnglAct a_featMinorRctngl");
      if (log && !findString("a_featMinorRctngl", featRctnglActAtts))
	{
	  warnAtt("a_featMinorRctngl", "featRctnglAct", a_featRctnglAct);
	  check_featMinorRctngl(a_featRctnglAct->get_featMinorRctngl(), 0);
	}
      else
	check_featMinorRctngl(a_featRctnglAct->get_featMinorRctngl(), log);
    }
}

/********************************************************************/

void check_featRctnglNom(
 featRctnglNom * a_featRctnglNom,
 int log)
{
  if (a_featRctnglNom->get_fLabel())
    {
      adjustLevels(&featRctnglNomAtts_a_fLabel, "featRctnglNom a_fLabel");
      if (log && !findString("a_fLabel", featRctnglNomAtts))
	{
	  warnAtt("a_fLabel", "featRctnglNom", a_featRctnglNom);
	  check_fLabel(a_featRctnglNom->get_fLabel(), 0);
	}
      else
	check_fLabel(a_featRctnglNom->get_fLabel(), log);
    }
  if (a_featRctnglNom->get_featMinorRctngl())
    {
      adjustLevels(&featRctnglNomAtts_a_featMinorRctngl,
		   "featRctnglNom a_featMinorRctngl");
      if (log && !findString("a_featMinorRctngl", featRctnglNomAtts))
	{
	  warnAtt("a_featMinorRctngl", "featRctnglNom", a_featRctnglNom);
	  check_featMinorRctngl(a_featRctnglNom->get_featMinorRctngl(), 0);
	}
      else
	check_featMinorRctngl(a_featRctnglNom->get_featMinorRctngl(), log);
    }
}

/********************************************************************/

void check_featRctnglStm(
 featRctnglStm * a_featRctnglStm,
 int log)
{
  if (isA(a_featRctnglStm, featRctnglNom))
    {
      adjustLevels(&featRctnglStmSubs_featRctnglNom, "featRctnglNom");
      if (log && !findString("featRctnglNom", featRctnglStmSubs))
	{
	  warnSub("featRctnglNom", "featRctnglStm", a_featRctnglStm);
	  check_featRctnglNom(
	    dynamic_cast<featRctnglNom *>(a_featRctnglStm), 0);
	}
      else
	check_featRctnglNom(
	  dynamic_cast<featRctnglNom *>(a_featRctnglStm), log);
      return;
    }
  if (isA(a_featRctnglStm, featRctnglAct))
    {
      adjustLevels(&featRctnglStmSubs_featRctnglAct, "featRctnglAct");
      if (log && !findString("featRctnglAct", featRctnglStmSubs))
	{
	  warnSub("featRctnglAct", "featRctnglStm", a_featRctnglStm);
	  check_featRctnglAct(
	    dynamic_cast<featRctnglAct *>(a_featRctnglStm), 0);
	}
      else
	check_featRctnglAct(
	  dynamic_cast<featRctnglAct *>(a_featRctnglStm), log);
      return;
    }
}

/********************************************************************/

void check_featRevsurfAct(
 featRevsurfAct * a_featRevsurfAct,
 int log)
{
  if (a_featRevsurfAct->get_faLabel())
    {
      adjustLevels(&featRevsurfActAtts_a_faLabel, "featRevsurfAct a_faLabel");
      if (log && !findString("a_faLabel", featRevsurfActAtts))
	{
	  warnAtt("a_faLabel", "featRevsurfAct", a_featRevsurfAct);
	  check_faLabel(a_featRevsurfAct->get_faLabel(), 0);
	}
      else
	check_faLabel(a_featRevsurfAct->get_faLabel(), log);
    }
  if (a_featRevsurfAct->get_featMinorRevsurf())
    {
      adjustLevels(&featRevsurfActAtts_a_featMinorRevsurf,
		   "featRevsurfAct a_featMinorRevsurf");
      if (log && !findString("a_featMinorRevsurf", featRevsurfActAtts))
	{
	  warnAtt("a_featMinorRevsurf", "featRevsurfAct", a_featRevsurfAct);
	  check_featMinorRevsurf(a_featRevsurfAct->get_featMinorRevsurf(), 0);
	}
      else
	check_featMinorRevsurf(a_featRevsurfAct->get_featMinorRevsurf(), log);
    }
}

/********************************************************************/

void check_featRevsurfCart(
 featRevsurfCart * a_featRevsurfCart,
 int log)
{
  if (a_featRevsurfCart->get_matDir())
    {
      adjustLevels(&featRevsurfCartAtts_a_matDir, "featRevsurfCart a_matDir");
      if (log && !findString("a_matDir", featRevsurfCartAtts))
	{
	  warnAtt("a_matDir", "featRevsurfCart", a_featRevsurfCart);
	  check_matDir(a_featRevsurfCart->get_matDir(), 0);
	}
      else
	check_matDir(a_featRevsurfCart->get_matDir(), log);
    }
  if (a_featRevsurfCart->get_typePoint())
    {
      adjustLevels(&featRevsurfCartAtts_a_typePoint,
		   "featRevsurfCart a_typePoint");
      if (log && !findString("a_typePoint", featRevsurfCartAtts))
	{
	  warnAtt("a_typePoint", "featRevsurfCart", a_featRevsurfCart);
	  check_typePoint(a_featRevsurfCart->get_typePoint(), 0);
	}
      else
	check_typePoint(a_featRevsurfCart->get_typePoint(), log);
    }
  if (a_featRevsurfCart->get_axis())
    {
      adjustLevels(&featRevsurfCartAtts_axis, "featRevsurfCart axis");
      if (log && !findString("axis", featRevsurfCartAtts))
	{
	  warnAtt("axis", "featRevsurfCart", a_featRevsurfCart);
	  check_vector(a_featRevsurfCart->get_axis(), 0);
	}
      else
	check_vector(a_featRevsurfCart->get_axis(), log);
    }
  if (a_featRevsurfCart->get_cartPoint())
    {
      adjustLevels(&featRevsurfCartAtts_a_cartPoint,
		   "featRevsurfCart a_cartPoint");
      if (log && !findString("a_cartPoint", featRevsurfCartAtts))
	{
	  warnAtt("a_cartPoint", "featRevsurfCart", a_featRevsurfCart);
	  check_cartPoint(a_featRevsurfCart->get_cartPoint(), 0);
	}
      else
	check_cartPoint(a_featRevsurfCart->get_cartPoint(), log);
    }
  if (a_featRevsurfCart->get_impCartPointList())
    {
      std::list<impCartPoint *> * theList;
      std::list<impCartPoint *>::iterator iter;
      theList = a_featRevsurfCart->get_impCartPointList();
      adjustLevels(&featRevsurfCartAtts_a_impCartPointList,
		   "featRevsurfCart a_impCartPointList");
      if (log && !findString("a_impCartPointList", featRevsurfCartAtts))
	{
	  warnAtt("a_impCartPointList", "featRevsurfCart", a_featRevsurfCart);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_impCartPoint(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_impCartPoint(*iter, log);
	}
    }
}

/********************************************************************/

void check_featRevsurfNom(
 featRevsurfNom * a_featRevsurfNom,
 int log)
{
  if (a_featRevsurfNom->get_fLabel())
    {
      adjustLevels(&featRevsurfNomAtts_a_fLabel, "featRevsurfNom a_fLabel");
      if (log && !findString("a_fLabel", featRevsurfNomAtts))
	{
	  warnAtt("a_fLabel", "featRevsurfNom", a_featRevsurfNom);
	  check_fLabel(a_featRevsurfNom->get_fLabel(), 0);
	}
      else
	check_fLabel(a_featRevsurfNom->get_fLabel(), log);
    }
  if (a_featRevsurfNom->get_featMinorRevsurf())
    {
      adjustLevels(&featRevsurfNomAtts_a_featMinorRevsurf,
		   "featRevsurfNom a_featMinorRevsurf");
      if (log && !findString("a_featMinorRevsurf", featRevsurfNomAtts))
	{
	  warnAtt("a_featMinorRevsurf", "featRevsurfNom", a_featRevsurfNom);
	  check_featMinorRevsurf(a_featRevsurfNom->get_featMinorRevsurf(), 0);
	}
      else
	check_featMinorRevsurf(a_featRevsurfNom->get_featMinorRevsurf(), log);
    }
}

/********************************************************************/

void check_featRevsurfPol(
 featRevsurfPol * a_featRevsurfPol,
 int log)
{
  if (a_featRevsurfPol->get_matDir())
    {
      adjustLevels(&featRevsurfPolAtts_a_matDir, "featRevsurfPol a_matDir");
      if (log && !findString("a_matDir", featRevsurfPolAtts))
	{
	  warnAtt("a_matDir", "featRevsurfPol", a_featRevsurfPol);
	  check_matDir(a_featRevsurfPol->get_matDir(), 0);
	}
      else
	check_matDir(a_featRevsurfPol->get_matDir(), log);
    }
  if (a_featRevsurfPol->get_typePoint())
    {
      adjustLevels(&featRevsurfPolAtts_a_typePoint,
		   "featRevsurfPol a_typePoint");
      if (log && !findString("a_typePoint", featRevsurfPolAtts))
	{
	  warnAtt("a_typePoint", "featRevsurfPol", a_featRevsurfPol);
	  check_typePoint(a_featRevsurfPol->get_typePoint(), 0);
	}
      else
	check_typePoint(a_featRevsurfPol->get_typePoint(), log);
    }
  if (a_featRevsurfPol->get_axis())
    {
      adjustLevels(&featRevsurfPolAtts_axis, "featRevsurfPol axis");
      if (log && !findString("axis", featRevsurfPolAtts))
	{
	  warnAtt("axis", "featRevsurfPol", a_featRevsurfPol);
	  check_vector(a_featRevsurfPol->get_axis(), 0);
	}
      else
	check_vector(a_featRevsurfPol->get_axis(), log);
    }
  if (a_featRevsurfPol->get_polPoint())
    {
      adjustLevels(&featRevsurfPolAtts_a_polPoint,
		   "featRevsurfPol a_polPoint");
      if (log && !findString("a_polPoint", featRevsurfPolAtts))
	{
	  warnAtt("a_polPoint", "featRevsurfPol", a_featRevsurfPol);
	  check_polPoint(a_featRevsurfPol->get_polPoint(), 0);
	}
      else
	check_polPoint(a_featRevsurfPol->get_polPoint(), log);
    }
  if (a_featRevsurfPol->get_impPolPointList())
    {
      std::list<impPolPoint *> * theList;
      std::list<impPolPoint *>::iterator iter;
      theList = a_featRevsurfPol->get_impPolPointList();
      adjustLevels(&featRevsurfPolAtts_a_impPolPointList,
		   "featRevsurfPol a_impPolPointList");
      if (log && !findString("a_impPolPointList", featRevsurfPolAtts))
	{
	  warnAtt("a_impPolPointList", "featRevsurfPol", a_featRevsurfPol);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_impPolPoint(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_impPolPoint(*iter, log);
	}
    }
}

/********************************************************************/

void check_featRevsurfStm(
 featRevsurfStm * a_featRevsurfStm,
 int log)
{
  if (isA(a_featRevsurfStm, featRevsurfNom))
    {
      adjustLevels(&featRevsurfStmSubs_featRevsurfNom, "featRevsurfNom");
      if (log && !findString("featRevsurfNom", featRevsurfStmSubs))
	{
	  warnSub("featRevsurfNom", "featRevsurfStm", a_featRevsurfStm);
	  check_featRevsurfNom(
	    dynamic_cast<featRevsurfNom *>(a_featRevsurfStm), 0);
	}
      else
	check_featRevsurfNom(
	  dynamic_cast<featRevsurfNom *>(a_featRevsurfStm), log);
      return;
    }
  if (isA(a_featRevsurfStm, featRevsurfAct))
    {
      adjustLevels(&featRevsurfStmSubs_featRevsurfAct, "featRevsurfAct");
      if (log && !findString("featRevsurfAct", featRevsurfStmSubs))
	{
	  warnSub("featRevsurfAct", "featRevsurfStm", a_featRevsurfStm);
	  check_featRevsurfAct(
	    dynamic_cast<featRevsurfAct *>(a_featRevsurfStm), 0);
	}
      else
	check_featRevsurfAct(
	  dynamic_cast<featRevsurfAct *>(a_featRevsurfStm), log);
      return;
    }
}

/********************************************************************/

void check_featSphereAct(
 featSphereAct * a_featSphereAct,
 int log)
{
  if (a_featSphereAct->get_faLabel())
    {
      adjustLevels(&featSphereActAtts_a_faLabel, "featSphereAct a_faLabel");
      if (log && !findString("a_faLabel", featSphereActAtts))
	{
	  warnAtt("a_faLabel", "featSphereAct", a_featSphereAct);
	  check_faLabel(a_featSphereAct->get_faLabel(), 0);
	}
      else
	check_faLabel(a_featSphereAct->get_faLabel(), log);
    }
  if (a_featSphereAct->get_featMinorSphere())
    {
      adjustLevels(&featSphereActAtts_a_featMinorSphere,
		   "featSphereAct a_featMinorSphere");
      if (log && !findString("a_featMinorSphere", featSphereActAtts))
	{
	  warnAtt("a_featMinorSphere", "featSphereAct", a_featSphereAct);
	  check_featMinorSphere(a_featSphereAct->get_featMinorSphere(), 0);
	}
      else
	check_featMinorSphere(a_featSphereAct->get_featMinorSphere(), log);
    }
}

/********************************************************************/

void check_featSphereNom(
 featSphereNom * a_featSphereNom,
 int log)
{
  if (a_featSphereNom->get_fLabel())
    {
      adjustLevels(&featSphereNomAtts_a_fLabel, "featSphereNom a_fLabel");
      if (log && !findString("a_fLabel", featSphereNomAtts))
	{
	  warnAtt("a_fLabel", "featSphereNom", a_featSphereNom);
	  check_fLabel(a_featSphereNom->get_fLabel(), 0);
	}
      else
	check_fLabel(a_featSphereNom->get_fLabel(), log);
    }
  if (a_featSphereNom->get_featMinorSphere())
    {
      adjustLevels(&featSphereNomAtts_a_featMinorSphere,
		   "featSphereNom a_featMinorSphere");
      if (log && !findString("a_featMinorSphere", featSphereNomAtts))
	{
	  warnAtt("a_featMinorSphere", "featSphereNom", a_featSphereNom);
	  check_featMinorSphere(a_featSphereNom->get_featMinorSphere(), 0);
	}
      else
	check_featMinorSphere(a_featSphereNom->get_featMinorSphere(), log);
    }
}

/********************************************************************/

void check_featSphereStm(
 featSphereStm * a_featSphereStm,
 int log)
{
  if (isA(a_featSphereStm, featSphereNom))
    {
      adjustLevels(&featSphereStmSubs_featSphereNom, "featSphereNom");
      if (log && !findString("featSphereNom", featSphereStmSubs))
	{
	  warnSub("featSphereNom", "featSphereStm", a_featSphereStm);
	  check_featSphereNom(
	    dynamic_cast<featSphereNom *>(a_featSphereStm), 0);
	}
      else
	check_featSphereNom(
	  dynamic_cast<featSphereNom *>(a_featSphereStm), log);
      return;
    }
  if (isA(a_featSphereStm, featSphereAct))
    {
      adjustLevels(&featSphereStmSubs_featSphereAct, "featSphereAct");
      if (log && !findString("featSphereAct", featSphereStmSubs))
	{
	  warnSub("featSphereAct", "featSphereStm", a_featSphereStm);
	  check_featSphereAct(
	    dynamic_cast<featSphereAct *>(a_featSphereStm), 0);
	}
      else
	check_featSphereAct(
	  dynamic_cast<featSphereAct *>(a_featSphereStm), log);
      return;
    }
}

/********************************************************************/

void check_featSphradsegAct(
 featSphradsegAct * a_featSphradsegAct,
 int log)
{
  if (a_featSphradsegAct->get_faLabel())
    {
      adjustLevels(&featSphradsegActAtts_a_faLabel,
		   "featSphradsegAct a_faLabel");
      if (log && !findString("a_faLabel", featSphradsegActAtts))
	{
	  warnAtt("a_faLabel", "featSphradsegAct", a_featSphradsegAct);
	  check_faLabel(a_featSphradsegAct->get_faLabel(), 0);
	}
      else
	check_faLabel(a_featSphradsegAct->get_faLabel(), log);
    }
  if (a_featSphradsegAct->get_featMinorSphradseg())
    {
      adjustLevels(&featSphradsegActAtts_a_featMinorSphradseg,
		   "featSphradsegAct a_featMinorSphradseg");
      if (log && !findString("a_featMinorSphradseg", featSphradsegActAtts))
	{
	  warnAtt("a_featMinorSphradseg", "featSphradsegAct",
		  a_featSphradsegAct);
	  check_featMinorSphradseg(
	    a_featSphradsegAct->get_featMinorSphradseg(), 0);
	}
      else
	check_featMinorSphradseg(
	  a_featSphradsegAct->get_featMinorSphradseg(), log);
    }
}

/********************************************************************/

void check_featSphradsegNom(
 featSphradsegNom * a_featSphradsegNom,
 int log)
{
  if (a_featSphradsegNom->get_fLabel())
    {
      adjustLevels(&featSphradsegNomAtts_a_fLabel,
		   "featSphradsegNom a_fLabel");
      if (log && !findString("a_fLabel", featSphradsegNomAtts))
	{
	  warnAtt("a_fLabel", "featSphradsegNom", a_featSphradsegNom);
	  check_fLabel(a_featSphradsegNom->get_fLabel(), 0);
	}
      else
	check_fLabel(a_featSphradsegNom->get_fLabel(), log);
    }
  if (a_featSphradsegNom->get_featMinorSphradseg())
    {
      adjustLevels(&featSphradsegNomAtts_a_featMinorSphradseg,
		   "featSphradsegNom a_featMinorSphradseg");
      if (log && !findString("a_featMinorSphradseg", featSphradsegNomAtts))
	{
	  warnAtt("a_featMinorSphradseg", "featSphradsegNom",
		  a_featSphradsegNom);
	  check_featMinorSphradseg(
	    a_featSphradsegNom->get_featMinorSphradseg(), 0);
	}
      else
	check_featMinorSphradseg(
	  a_featSphradsegNom->get_featMinorSphradseg(), log);
    }
}

/********************************************************************/

void check_featSphradsegStm(
 featSphradsegStm * a_featSphradsegStm,
 int log)
{
  if (isA(a_featSphradsegStm, featSphradsegNom))
    {
      adjustLevels(&featSphradsegStmSubs_featSphradsegNom, "featSphradsegNom");
      if (log && !findString("featSphradsegNom", featSphradsegStmSubs))
	{
	  warnSub("featSphradsegNom", "featSphradsegStm", a_featSphradsegStm);
	  check_featSphradsegNom(
	    dynamic_cast<featSphradsegNom *>(a_featSphradsegStm), 0);
	}
      else
	check_featSphradsegNom(
	  dynamic_cast<featSphradsegNom *>(a_featSphradsegStm), log);
      return;
    }
  if (isA(a_featSphradsegStm, featSphradsegAct))
    {
      adjustLevels(&featSphradsegStmSubs_featSphradsegAct, "featSphradsegAct");
      if (log && !findString("featSphradsegAct", featSphradsegStmSubs))
	{
	  warnSub("featSphradsegAct", "featSphradsegStm", a_featSphradsegStm);
	  check_featSphradsegAct(
	    dynamic_cast<featSphradsegAct *>(a_featSphradsegStm), 0);
	}
      else
	check_featSphradsegAct(
	  dynamic_cast<featSphradsegAct *>(a_featSphradsegStm), log);
      return;
    }
}

/********************************************************************/

void check_featSymplnAct(
 featSymplnAct * a_featSymplnAct,
 int log)
{
  if (a_featSymplnAct->get_faLabel())
    {
      adjustLevels(&featSymplnActAtts_a_faLabel, "featSymplnAct a_faLabel");
      if (log && !findString("a_faLabel", featSymplnActAtts))
	{
	  warnAtt("a_faLabel", "featSymplnAct", a_featSymplnAct);
	  check_faLabel(a_featSymplnAct->get_faLabel(), 0);
	}
      else
	check_faLabel(a_featSymplnAct->get_faLabel(), log);
    }
  if (a_featSymplnAct->get_featMinorSympln())
    {
      adjustLevels(&featSymplnActAtts_a_featMinorSympln,
		   "featSymplnAct a_featMinorSympln");
      if (log && !findString("a_featMinorSympln", featSymplnActAtts))
	{
	  warnAtt("a_featMinorSympln", "featSymplnAct", a_featSymplnAct);
	  check_featMinorSympln(a_featSymplnAct->get_featMinorSympln(), 0);
	}
      else
	check_featMinorSympln(a_featSymplnAct->get_featMinorSympln(), log);
    }
}

/********************************************************************/

void check_featSymplnCart(
 featSymplnCart * a_featSymplnCart,
 int log)
{
  if (a_featSymplnCart->get_matDir())
    {
      adjustLevels(&featSymplnCartAtts_a_matDir, "featSymplnCart a_matDir");
      if (log && !findString("a_matDir", featSymplnCartAtts))
	{
	  warnAtt("a_matDir", "featSymplnCart", a_featSymplnCart);
	  check_matDir(a_featSymplnCart->get_matDir(), 0);
	}
      else
	check_matDir(a_featSymplnCart->get_matDir(), log);
    }
  if (a_featSymplnCart->get_centerPt())
    {
      adjustLevels(&featSymplnCartAtts_centerPt, "featSymplnCart centerPt");
      if (log && !findString("centerPt", featSymplnCartAtts))
	{
	  warnAtt("centerPt", "featSymplnCart", a_featSymplnCart);
	  check_cartPoint(a_featSymplnCart->get_centerPt(), 0);
	}
      else
	check_cartPoint(a_featSymplnCart->get_centerPt(), log);
    }
  if (a_featSymplnCart->get_plane1data())
    {
      adjustLevels(&featSymplnCartAtts_plane1data,
		   "featSymplnCart plane1data");
      if (log && !findString("plane1data", featSymplnCartAtts))
	{
	  warnAtt("plane1data", "featSymplnCart", a_featSymplnCart);
	  check_pointVecCart(a_featSymplnCart->get_plane1data(), 0);
	}
      else
	check_pointVecCart(a_featSymplnCart->get_plane1data(), log);
    }
  if (a_featSymplnCart->get_plane2data())
    {
      adjustLevels(&featSymplnCartAtts_plane2data,
		   "featSymplnCart plane2data");
      if (log && !findString("plane2data", featSymplnCartAtts))
	{
	  warnAtt("plane2data", "featSymplnCart", a_featSymplnCart);
	  check_pointVecCart(a_featSymplnCart->get_plane2data(), 0);
	}
      else
	check_pointVecCart(a_featSymplnCart->get_plane2data(), log);
    }
  if (a_featSymplnCart->get_width())
    {
      adjustLevels(&featSymplnCartAtts_width, "featSymplnCart width");
      if (log && !findString("width", featSymplnCartAtts))
	{
	  warnAtt("width", "featSymplnCart", a_featSymplnCart);
	  check_rentVal(a_featSymplnCart->get_width(), 0);
	}
      else
	check_rentVal(a_featSymplnCart->get_width(), log);
    }
}

/********************************************************************/

void check_featSymplnNom(
 featSymplnNom * a_featSymplnNom,
 int log)
{
  if (a_featSymplnNom->get_fLabel())
    {
      adjustLevels(&featSymplnNomAtts_a_fLabel, "featSymplnNom a_fLabel");
      if (log && !findString("a_fLabel", featSymplnNomAtts))
	{
	  warnAtt("a_fLabel", "featSymplnNom", a_featSymplnNom);
	  check_fLabel(a_featSymplnNom->get_fLabel(), 0);
	}
      else
	check_fLabel(a_featSymplnNom->get_fLabel(), log);
    }
  if (a_featSymplnNom->get_featMinorSympln())
    {
      adjustLevels(&featSymplnNomAtts_a_featMinorSympln,
		   "featSymplnNom a_featMinorSympln");
      if (log && !findString("a_featMinorSympln", featSymplnNomAtts))
	{
	  warnAtt("a_featMinorSympln", "featSymplnNom", a_featSymplnNom);
	  check_featMinorSympln(a_featSymplnNom->get_featMinorSympln(), 0);
	}
      else
	check_featMinorSympln(a_featSymplnNom->get_featMinorSympln(), log);
    }
}

/********************************************************************/

void check_featSymplnPol(
 featSymplnPol * a_featSymplnPol,
 int log)
{
  if (a_featSymplnPol->get_matDir())
    {
      adjustLevels(&featSymplnPolAtts_a_matDir, "featSymplnPol a_matDir");
      if (log && !findString("a_matDir", featSymplnPolAtts))
	{
	  warnAtt("a_matDir", "featSymplnPol", a_featSymplnPol);
	  check_matDir(a_featSymplnPol->get_matDir(), 0);
	}
      else
	check_matDir(a_featSymplnPol->get_matDir(), log);
    }
  if (a_featSymplnPol->get_centerPt())
    {
      adjustLevels(&featSymplnPolAtts_centerPt, "featSymplnPol centerPt");
      if (log && !findString("centerPt", featSymplnPolAtts))
	{
	  warnAtt("centerPt", "featSymplnPol", a_featSymplnPol);
	  check_polPoint(a_featSymplnPol->get_centerPt(), 0);
	}
      else
	check_polPoint(a_featSymplnPol->get_centerPt(), log);
    }
  if (a_featSymplnPol->get_plane1data())
    {
      adjustLevels(&featSymplnPolAtts_plane1data, "featSymplnPol plane1data");
      if (log && !findString("plane1data", featSymplnPolAtts))
	{
	  warnAtt("plane1data", "featSymplnPol", a_featSymplnPol);
	  check_pointVecPol(a_featSymplnPol->get_plane1data(), 0);
	}
      else
	check_pointVecPol(a_featSymplnPol->get_plane1data(), log);
    }
  if (a_featSymplnPol->get_plane2data())
    {
      adjustLevels(&featSymplnPolAtts_plane2data, "featSymplnPol plane2data");
      if (log && !findString("plane2data", featSymplnPolAtts))
	{
	  warnAtt("plane2data", "featSymplnPol", a_featSymplnPol);
	  check_pointVecPol(a_featSymplnPol->get_plane2data(), 0);
	}
      else
	check_pointVecPol(a_featSymplnPol->get_plane2data(), log);
    }
  if (a_featSymplnPol->get_width())
    {
      adjustLevels(&featSymplnPolAtts_width, "featSymplnPol width");
      if (log && !findString("width", featSymplnPolAtts))
	{
	  warnAtt("width", "featSymplnPol", a_featSymplnPol);
	  check_rentVal(a_featSymplnPol->get_width(), 0);
	}
      else
	check_rentVal(a_featSymplnPol->get_width(), log);
    }
}

/********************************************************************/

void check_featSymplnStm(
 featSymplnStm * a_featSymplnStm,
 int log)
{
  if (isA(a_featSymplnStm, featSymplnNom))
    {
      adjustLevels(&featSymplnStmSubs_featSymplnNom, "featSymplnNom");
      if (log && !findString("featSymplnNom", featSymplnStmSubs))
	{
	  warnSub("featSymplnNom", "featSymplnStm", a_featSymplnStm);
	  check_featSymplnNom(
	    dynamic_cast<featSymplnNom *>(a_featSymplnStm), 0);
	}
      else
	check_featSymplnNom(
	  dynamic_cast<featSymplnNom *>(a_featSymplnStm), log);
      return;
    }
  if (isA(a_featSymplnStm, featSymplnAct))
    {
      adjustLevels(&featSymplnStmSubs_featSymplnAct, "featSymplnAct");
      if (log && !findString("featSymplnAct", featSymplnStmSubs))
	{
	  warnSub("featSymplnAct", "featSymplnStm", a_featSymplnStm);
	  check_featSymplnAct(
	    dynamic_cast<featSymplnAct *>(a_featSymplnStm), 0);
	}
      else
	check_featSymplnAct(
	  dynamic_cast<featSymplnAct *>(a_featSymplnStm), log);
      return;
    }
}

/********************************************************************/

void check_featTorradsegAct(
 featTorradsegAct * a_featTorradsegAct,
 int log)
{
  if (a_featTorradsegAct->get_faLabel())
    {
      adjustLevels(&featTorradsegActAtts_a_faLabel,
		   "featTorradsegAct a_faLabel");
      if (log && !findString("a_faLabel", featTorradsegActAtts))
	{
	  warnAtt("a_faLabel", "featTorradsegAct", a_featTorradsegAct);
	  check_faLabel(a_featTorradsegAct->get_faLabel(), 0);
	}
      else
	check_faLabel(a_featTorradsegAct->get_faLabel(), log);
    }
  if (a_featTorradsegAct->get_featMinorTorradseg())
    {
      adjustLevels(&featTorradsegActAtts_a_featMinorTorradseg,
		   "featTorradsegAct a_featMinorTorradseg");
      if (log && !findString("a_featMinorTorradseg", featTorradsegActAtts))
	{
	  warnAtt("a_featMinorTorradseg", "featTorradsegAct",
		  a_featTorradsegAct);
	  check_featMinorTorradseg(
	    a_featTorradsegAct->get_featMinorTorradseg(), 0);
	}
      else
	check_featMinorTorradseg(
	  a_featTorradsegAct->get_featMinorTorradseg(), log);
    }
}

/********************************************************************/

void check_featTorradsegNom(
 featTorradsegNom * a_featTorradsegNom,
 int log)
{
  if (a_featTorradsegNom->get_fLabel())
    {
      adjustLevels(&featTorradsegNomAtts_a_fLabel,
		   "featTorradsegNom a_fLabel");
      if (log && !findString("a_fLabel", featTorradsegNomAtts))
	{
	  warnAtt("a_fLabel", "featTorradsegNom", a_featTorradsegNom);
	  check_fLabel(a_featTorradsegNom->get_fLabel(), 0);
	}
      else
	check_fLabel(a_featTorradsegNom->get_fLabel(), log);
    }
  if (a_featTorradsegNom->get_featMinorTorradseg())
    {
      adjustLevels(&featTorradsegNomAtts_a_featMinorTorradseg,
		   "featTorradsegNom a_featMinorTorradseg");
      if (log && !findString("a_featMinorTorradseg", featTorradsegNomAtts))
	{
	  warnAtt("a_featMinorTorradseg", "featTorradsegNom",
		  a_featTorradsegNom);
	  check_featMinorTorradseg(
	    a_featTorradsegNom->get_featMinorTorradseg(), 0);
	}
      else
	check_featMinorTorradseg(
	  a_featTorradsegNom->get_featMinorTorradseg(), log);
    }
}

/********************************************************************/

void check_featTorradsegStm(
 featTorradsegStm * a_featTorradsegStm,
 int log)
{
  if (isA(a_featTorradsegStm, featTorradsegNom))
    {
      adjustLevels(&featTorradsegStmSubs_featTorradsegNom, "featTorradsegNom");
      if (log && !findString("featTorradsegNom", featTorradsegStmSubs))
	{
	  warnSub("featTorradsegNom", "featTorradsegStm", a_featTorradsegStm);
	  check_featTorradsegNom(
	    dynamic_cast<featTorradsegNom *>(a_featTorradsegStm), 0);
	}
      else
	check_featTorradsegNom(
	  dynamic_cast<featTorradsegNom *>(a_featTorradsegStm), log);
      return;
    }
  if (isA(a_featTorradsegStm, featTorradsegAct))
    {
      adjustLevels(&featTorradsegStmSubs_featTorradsegAct, "featTorradsegAct");
      if (log && !findString("featTorradsegAct", featTorradsegStmSubs))
	{
	  warnSub("featTorradsegAct", "featTorradsegStm", a_featTorradsegStm);
	  check_featTorradsegAct(
	    dynamic_cast<featTorradsegAct *>(a_featTorradsegStm), 0);
	}
      else
	check_featTorradsegAct(
	  dynamic_cast<featTorradsegAct *>(a_featTorradsegStm), log);
      return;
    }
}

/********************************************************************/

void check_featTorusAct(
 featTorusAct * a_featTorusAct,
 int log)
{
  if (a_featTorusAct->get_faLabel())
    {
      adjustLevels(&featTorusActAtts_a_faLabel, "featTorusAct a_faLabel");
      if (log && !findString("a_faLabel", featTorusActAtts))
	{
	  warnAtt("a_faLabel", "featTorusAct", a_featTorusAct);
	  check_faLabel(a_featTorusAct->get_faLabel(), 0);
	}
      else
	check_faLabel(a_featTorusAct->get_faLabel(), log);
    }
  if (a_featTorusAct->get_featMinorTorus())
    {
      adjustLevels(&featTorusActAtts_a_featMinorTorus,
		   "featTorusAct a_featMinorTorus");
      if (log && !findString("a_featMinorTorus", featTorusActAtts))
	{
	  warnAtt("a_featMinorTorus", "featTorusAct", a_featTorusAct);
	  check_featMinorTorus(a_featTorusAct->get_featMinorTorus(), 0);
	}
      else
	check_featMinorTorus(a_featTorusAct->get_featMinorTorus(), log);
    }
}

/********************************************************************/

void check_featTorusNom(
 featTorusNom * a_featTorusNom,
 int log)
{
  if (a_featTorusNom->get_fLabel())
    {
      adjustLevels(&featTorusNomAtts_a_fLabel, "featTorusNom a_fLabel");
      if (log && !findString("a_fLabel", featTorusNomAtts))
	{
	  warnAtt("a_fLabel", "featTorusNom", a_featTorusNom);
	  check_fLabel(a_featTorusNom->get_fLabel(), 0);
	}
      else
	check_fLabel(a_featTorusNom->get_fLabel(), log);
    }
  if (a_featTorusNom->get_featMinorTorus())
    {
      adjustLevels(&featTorusNomAtts_a_featMinorTorus,
		   "featTorusNom a_featMinorTorus");
      if (log && !findString("a_featMinorTorus", featTorusNomAtts))
	{
	  warnAtt("a_featMinorTorus", "featTorusNom", a_featTorusNom);
	  check_featMinorTorus(a_featTorusNom->get_featMinorTorus(), 0);
	}
      else
	check_featMinorTorus(a_featTorusNom->get_featMinorTorus(), log);
    }
}

/********************************************************************/

void check_featTorusStm(
 featTorusStm * a_featTorusStm,
 int log)
{
  if (isA(a_featTorusStm, featTorusNom))
    {
      adjustLevels(&featTorusStmSubs_featTorusNom, "featTorusNom");
      if (log && !findString("featTorusNom", featTorusStmSubs))
	{
	  warnSub("featTorusNom", "featTorusStm", a_featTorusStm);
	  check_featTorusNom(
	    dynamic_cast<featTorusNom *>(a_featTorusStm), 0);
	}
      else
	check_featTorusNom(
	  dynamic_cast<featTorusNom *>(a_featTorusStm), log);
      return;
    }
  if (isA(a_featTorusStm, featTorusAct))
    {
      adjustLevels(&featTorusStmSubs_featTorusAct, "featTorusAct");
      if (log && !findString("featTorusAct", featTorusStmSubs))
	{
	  warnSub("featTorusAct", "featTorusStm", a_featTorusStm);
	  check_featTorusAct(
	    dynamic_cast<featTorusAct *>(a_featTorusStm), 0);
	}
      else
	check_featTorusAct(
	  dynamic_cast<featTorusAct *>(a_featTorusStm), log);
      return;
    }
}

/********************************************************************/

void check_featureLabel(
 featureLabel * a_featureLabel,
 int log)
{
  if (isA(a_featureLabel, fLabel))
    {
      adjustLevels(&featureLabelSubs_fLabel, "fLabel");
      if (log && !findString("fLabel", featureLabelSubs))
	{
	  warnSub("fLabel", "featureLabel", a_featureLabel);
	  check_fLabel(dynamic_cast<fLabel *>(a_featureLabel), 0);
	}
      else
	check_fLabel(dynamic_cast<fLabel *>(a_featureLabel), log);
      return;
    }
  if (isA(a_featureLabel, faLabel))
    {
      adjustLevels(&featureLabelSubs_faLabel, "faLabel");
      if (log && !findString("faLabel", featureLabelSubs))
	{
	  warnSub("faLabel", "featureLabel", a_featureLabel);
	  check_faLabel(dynamic_cast<faLabel *>(a_featureLabel), 0);
	}
      else
	check_faLabel(dynamic_cast<faLabel *>(a_featureLabel), log);
      return;
    }
}

/********************************************************************/

void check_featureLabel1(
 featureLabel1 * a_featureLabel1,
 int log)
{
  if (isA(a_featureLabel1, fLabel))
    {
      adjustLevels(&featureLabel1Subs_fLabel, "fLabel");
      if (log && !findString("fLabel", featureLabel1Subs))
	{
	  warnSub("fLabel", "featureLabel1", a_featureLabel1);
	  check_fLabel(dynamic_cast<fLabel *>(a_featureLabel1), 0);
	}
      else
	check_fLabel(dynamic_cast<fLabel *>(a_featureLabel1), log);
      return;
    }
  if (isA(a_featureLabel1, faLabel))
    {
      adjustLevels(&featureLabel1Subs_faLabel, "faLabel");
      if (log && !findString("faLabel", featureLabel1Subs))
	{
	  warnSub("faLabel", "featureLabel1", a_featureLabel1);
	  check_faLabel(dynamic_cast<faLabel *>(a_featureLabel1), 0);
	}
      else
	check_faLabel(dynamic_cast<faLabel *>(a_featureLabel1), log);
      return;
    }
}

/********************************************************************/

void check_fedratAngSpec(
 fedratAngSpec * a_fedratAngSpec,
 int log)
{
  if (isA(a_fedratAngSpec, fedratAngular))
    {
      adjustLevels(&fedratAngSpecSubs_fedratAngular, "fedratAngular");
      if (log && !findString("fedratAngular", fedratAngSpecSubs))
	{
	  warnSub("fedratAngular", "fedratAngSpec", a_fedratAngSpec);
	  check_fedratAngular(
	    dynamic_cast<fedratAngular *>(a_fedratAngSpec), 0);
	}
      else
	check_fedratAngular(
	  dynamic_cast<fedratAngular *>(a_fedratAngSpec), log);
      return;
    }
  if (isA(a_fedratAngSpec, fedratDef))
    {
      adjustLevels(&fedratAngSpecSubs_fedratDef, "fedratDef");
      if (log && !findString("fedratDef", fedratAngSpecSubs))
	{
	  warnSub("fedratDef", "fedratAngSpec", a_fedratAngSpec);
	  check_fedratDef(dynamic_cast<fedratDef *>(a_fedratAngSpec), 0);
	}
      else
	check_fedratDef(dynamic_cast<fedratDef *>(a_fedratAngSpec), log);
      return;
    }
}

/********************************************************************/

void check_fedratAngular(
 fedratAngular * a_fedratAngular,
 int log)
{
  if (a_fedratAngular->get_rate())
    {
      adjustLevels(&fedratAngularAtts_rate, "fedratAngular rate");
      if (log && !findString("rate", fedratAngularAtts))
	{
	  warnAtt("rate", "fedratAngular", a_fedratAngular);
	  check_rentVal(a_fedratAngular->get_rate(), 0);
	}
      else
	check_rentVal(a_fedratAngular->get_rate(), log);
    }
}

/********************************************************************/

void check_fedratDef(
 fedratDef * a_fedratDef,
 int log)
{
  if (isA(a_fedratDef, fedratDef_PCENT))
    {
      adjustLevels(&fedratDefSubs_fedratDef_PCENT, "fedratDef_PCENT");
      if (log && !findString("fedratDef_PCENT", fedratDefSubs))
	{
	  warnSub("fedratDef_PCENT", "fedratDef", a_fedratDef);
	  check_fedratDef_PCENT(
	    dynamic_cast<fedratDef_PCENT *>(a_fedratDef), 0);
	}
      else
	check_fedratDef_PCENT(
	  dynamic_cast<fedratDef_PCENT *>(a_fedratDef), log);
      return;
    }
  if (isA(a_fedratDef, fedratDef_HIGH))
    {
      adjustLevels(&fedratDefSubs_fedratDef_HIGH, "fedratDef_HIGH");
      if (log && !findString("fedratDef_HIGH", fedratDefSubs))
	{
	  warnSub("fedratDef_HIGH", "fedratDef", a_fedratDef);
	}
      return;
    }
  if (isA(a_fedratDef, fedratDef_LOW))
    {
      adjustLevels(&fedratDefSubs_fedratDef_LOW, "fedratDef_LOW");
      if (log && !findString("fedratDef_LOW", fedratDefSubs))
	{
	  warnSub("fedratDef_LOW", "fedratDef", a_fedratDef);
	}
      return;
    }
  if (isA(a_fedratDef, fedratDef_DEFALT))
    {
      adjustLevels(&fedratDefSubs_fedratDef_DEFALT, "fedratDef_DEFALT");
      if (log && !findString("fedratDef_DEFALT", fedratDefSubs))
	{
	  warnSub("fedratDef_DEFALT", "fedratDef", a_fedratDef);
	}
      return;
    }
}

/********************************************************************/

void check_fedratDef_PCENT(
 fedratDef_PCENT * a_fedratDef_PCENT,
 int log)
{
  if (a_fedratDef_PCENT->get_rate())
    {
      adjustLevels(&fedratDef_PCENTAtts_rate, "fedratDef_PCENT rate");
      if (log && !findString("rate", fedratDef_PCENTAtts))
	{
	  warnAtt("rate", "fedratDef_PCENT", a_fedratDef_PCENT);
	  check_rentVal(a_fedratDef_PCENT->get_rate(), 0);
	}
      else
	check_rentVal(a_fedratDef_PCENT->get_rate(), log);
    }
}

/********************************************************************/

void check_fedratHedMeas(
 fedratHedMeas * a_fedratHedMeas,
 int log)
{
  if (a_fedratHedMeas->get_fedratLinSpec())
    {
      adjustLevels(&fedratHedMeasAtts_a_fedratLinSpec,
		   "fedratHedMeas a_fedratLinSpec");
      if (log && !findString("a_fedratLinSpec", fedratHedMeasAtts))
	{
	  warnAtt("a_fedratLinSpec", "fedratHedMeas", a_fedratHedMeas);
	  check_fedratLinSpec(a_fedratHedMeas->get_fedratLinSpec(), 0);
	}
      else
	check_fedratLinSpec(a_fedratHedMeas->get_fedratLinSpec(), log);
    }
}

/********************************************************************/

void check_fedratHedRot(
 fedratHedRot * a_fedratHedRot,
 int log)
{
  if (a_fedratHedRot->get_fedratLinSpec())
    {
      adjustLevels(&fedratHedRotAtts_a_fedratLinSpec,
		   "fedratHedRot a_fedratLinSpec");
      if (log && !findString("a_fedratLinSpec", fedratHedRotAtts))
	{
	  warnAtt("a_fedratLinSpec", "fedratHedRot", a_fedratHedRot);
	  check_fedratLinSpec(a_fedratHedRot->get_fedratLinSpec(), 0);
	}
      else
	check_fedratLinSpec(a_fedratHedRot->get_fedratLinSpec(), log);
    }
}

/********************************************************************/

void check_fedratHedScan(
 fedratHedScan * a_fedratHedScan,
 int log)
{
  if (a_fedratHedScan->get_fedratLinSpec())
    {
      adjustLevels(&fedratHedScanAtts_a_fedratLinSpec,
		   "fedratHedScan a_fedratLinSpec");
      if (log && !findString("a_fedratLinSpec", fedratHedScanAtts))
	{
	  warnAtt("a_fedratLinSpec", "fedratHedScan", a_fedratHedScan);
	  check_fedratLinSpec(a_fedratHedScan->get_fedratLinSpec(), 0);
	}
      else
	check_fedratLinSpec(a_fedratHedScan->get_fedratLinSpec(), log);
    }
}

/********************************************************************/

void check_fedratLinSpec(
 fedratLinSpec * a_fedratLinSpec,
 int log)
{
  if (isA(a_fedratLinSpec, fedratLinear))
    {
      adjustLevels(&fedratLinSpecSubs_fedratLinear, "fedratLinear");
      if (log && !findString("fedratLinear", fedratLinSpecSubs))
	{
	  warnSub("fedratLinear", "fedratLinSpec", a_fedratLinSpec);
	  check_fedratLinear(
	    dynamic_cast<fedratLinear *>(a_fedratLinSpec), 0);
	}
      else
	check_fedratLinear(
	  dynamic_cast<fedratLinear *>(a_fedratLinSpec), log);
      return;
    }
  if (isA(a_fedratLinSpec, fedratDef))
    {
      adjustLevels(&fedratLinSpecSubs_fedratDef, "fedratDef");
      if (log && !findString("fedratDef", fedratLinSpecSubs))
	{
	  warnSub("fedratDef", "fedratLinSpec", a_fedratLinSpec);
	  check_fedratDef(dynamic_cast<fedratDef *>(a_fedratLinSpec), 0);
	}
      else
	check_fedratDef(dynamic_cast<fedratDef *>(a_fedratLinSpec), log);
      return;
    }
}

/********************************************************************/

void check_fedratLinear(
 fedratLinear * a_fedratLinear,
 int log)
{
  if (isA(a_fedratLinear, fedratLinear_MPM))
    {
      adjustLevels(&fedratLinearSubs_fedratLinear_MPM, "fedratLinear_MPM");
      if (log && !findString("fedratLinear_MPM", fedratLinearSubs))
	{
	  warnSub("fedratLinear_MPM", "fedratLinear", a_fedratLinear);
	  check_fedratLinear_MPM(
	    dynamic_cast<fedratLinear_MPM *>(a_fedratLinear), 0);
	}
      else
	check_fedratLinear_MPM(
	  dynamic_cast<fedratLinear_MPM *>(a_fedratLinear), log);
      return;
    }
  if (isA(a_fedratLinear, fedratLinear_MMPS))
    {
      adjustLevels(&fedratLinearSubs_fedratLinear_MMPS, "fedratLinear_MMPS");
      if (log && !findString("fedratLinear_MMPS", fedratLinearSubs))
	{
	  warnSub("fedratLinear_MMPS", "fedratLinear", a_fedratLinear);
	  check_fedratLinear_MMPS(
	    dynamic_cast<fedratLinear_MMPS *>(a_fedratLinear), 0);
	}
      else
	check_fedratLinear_MMPS(
	  dynamic_cast<fedratLinear_MMPS *>(a_fedratLinear), log);
      return;
    }
  if (isA(a_fedratLinear, fedratLinear_IPM))
    {
      adjustLevels(&fedratLinearSubs_fedratLinear_IPM, "fedratLinear_IPM");
      if (log && !findString("fedratLinear_IPM", fedratLinearSubs))
	{
	  warnSub("fedratLinear_IPM", "fedratLinear", a_fedratLinear);
	  check_fedratLinear_IPM(
	    dynamic_cast<fedratLinear_IPM *>(a_fedratLinear), 0);
	}
      else
	check_fedratLinear_IPM(
	  dynamic_cast<fedratLinear_IPM *>(a_fedratLinear), log);
      return;
    }
  if (isA(a_fedratLinear, fedratLinear_IPS))
    {
      adjustLevels(&fedratLinearSubs_fedratLinear_IPS, "fedratLinear_IPS");
      if (log && !findString("fedratLinear_IPS", fedratLinearSubs))
	{
	  warnSub("fedratLinear_IPS", "fedratLinear", a_fedratLinear);
	  check_fedratLinear_IPS(
	    dynamic_cast<fedratLinear_IPS *>(a_fedratLinear), 0);
	}
      else
	check_fedratLinear_IPS(
	  dynamic_cast<fedratLinear_IPS *>(a_fedratLinear), log);
      return;
    }
}

/********************************************************************/

void check_fedratLinear_IPM(
 fedratLinear_IPM * a_fedratLinear_IPM,
 int log)
{
  if (a_fedratLinear_IPM->get_rate())
    {
      adjustLevels(&fedratLinear_IPMAtts_rate, "fedratLinear_IPM rate");
      if (log && !findString("rate", fedratLinear_IPMAtts))
	{
	  warnAtt("rate", "fedratLinear_IPM", a_fedratLinear_IPM);
	  check_rentVal(a_fedratLinear_IPM->get_rate(), 0);
	}
      else
	check_rentVal(a_fedratLinear_IPM->get_rate(), log);
    }
}

/********************************************************************/

void check_fedratLinear_IPS(
 fedratLinear_IPS * a_fedratLinear_IPS,
 int log)
{
  if (a_fedratLinear_IPS->get_rate())
    {
      adjustLevels(&fedratLinear_IPSAtts_rate, "fedratLinear_IPS rate");
      if (log && !findString("rate", fedratLinear_IPSAtts))
	{
	  warnAtt("rate", "fedratLinear_IPS", a_fedratLinear_IPS);
	  check_rentVal(a_fedratLinear_IPS->get_rate(), 0);
	}
      else
	check_rentVal(a_fedratLinear_IPS->get_rate(), log);
    }
}

/********************************************************************/

void check_fedratLinear_MMPS(
 fedratLinear_MMPS * a_fedratLinear_MMPS,
 int log)
{
  if (a_fedratLinear_MMPS->get_rate())
    {
      adjustLevels(&fedratLinear_MMPSAtts_rate, "fedratLinear_MMPS rate");
      if (log && !findString("rate", fedratLinear_MMPSAtts))
	{
	  warnAtt("rate", "fedratLinear_MMPS", a_fedratLinear_MMPS);
	  check_rentVal(a_fedratLinear_MMPS->get_rate(), 0);
	}
      else
	check_rentVal(a_fedratLinear_MMPS->get_rate(), log);
    }
}

/********************************************************************/

void check_fedratLinear_MPM(
 fedratLinear_MPM * a_fedratLinear_MPM,
 int log)
{
  if (a_fedratLinear_MPM->get_rate())
    {
      adjustLevels(&fedratLinear_MPMAtts_rate, "fedratLinear_MPM rate");
      if (log && !findString("rate", fedratLinear_MPMAtts))
	{
	  warnAtt("rate", "fedratLinear_MPM", a_fedratLinear_MPM);
	  check_rentVal(a_fedratLinear_MPM->get_rate(), 0);
	}
      else
	check_rentVal(a_fedratLinear_MPM->get_rate(), log);
    }
}

/********************************************************************/

void check_fedratMeas(
 fedratMeas * a_fedratMeas,
 int log)
{
  if (a_fedratMeas->get_fedratLinSpec())
    {
      adjustLevels(&fedratMeasAtts_a_fedratLinSpec,
		   "fedratMeas a_fedratLinSpec");
      if (log && !findString("a_fedratLinSpec", fedratMeasAtts))
	{
	  warnAtt("a_fedratLinSpec", "fedratMeas", a_fedratMeas);
	  check_fedratLinSpec(a_fedratMeas->get_fedratLinSpec(), 0);
	}
      else
	check_fedratLinSpec(a_fedratMeas->get_fedratLinSpec(), log);
    }
}

/********************************************************************/

void check_fedratMinor(
 fedratMinor * a_fedratMinor,
 int log)
{
  if (isA(a_fedratMinor, fedratMeas))
    {
      adjustLevels(&fedratMinorSubs_fedratMeas, "fedratMeas");
      if (log && !findString("fedratMeas", fedratMinorSubs))
	{
	  warnSub("fedratMeas", "fedratMinor", a_fedratMinor);
	  check_fedratMeas(dynamic_cast<fedratMeas *>(a_fedratMinor), 0);
	}
      else
	check_fedratMeas(dynamic_cast<fedratMeas *>(a_fedratMinor), log);
      return;
    }
  if (isA(a_fedratMinor, fedratPos))
    {
      adjustLevels(&fedratMinorSubs_fedratPos, "fedratPos");
      if (log && !findString("fedratPos", fedratMinorSubs))
	{
	  warnSub("fedratPos", "fedratMinor", a_fedratMinor);
	  check_fedratPos(dynamic_cast<fedratPos *>(a_fedratMinor), 0);
	}
      else
	check_fedratPos(dynamic_cast<fedratPos *>(a_fedratMinor), log);
      return;
    }
  if (isA(a_fedratMinor, fedratRot))
    {
      adjustLevels(&fedratMinorSubs_fedratRot, "fedratRot");
      if (log && !findString("fedratRot", fedratMinorSubs))
	{
	  warnSub("fedratRot", "fedratMinor", a_fedratMinor);
	  check_fedratRot(dynamic_cast<fedratRot *>(a_fedratMinor), 0);
	}
      else
	check_fedratRot(dynamic_cast<fedratRot *>(a_fedratMinor), log);
      return;
    }
  if (isA(a_fedratMinor, fedratScan))
    {
      adjustLevels(&fedratMinorSubs_fedratScan, "fedratScan");
      if (log && !findString("fedratScan", fedratMinorSubs))
	{
	  warnSub("fedratScan", "fedratMinor", a_fedratMinor);
	  check_fedratScan(dynamic_cast<fedratScan *>(a_fedratMinor), 0);
	}
      else
	check_fedratScan(dynamic_cast<fedratScan *>(a_fedratMinor), log);
      return;
    }
  if (isA(a_fedratMinor, fedratHedRot))
    {
      adjustLevels(&fedratMinorSubs_fedratHedRot, "fedratHedRot");
      if (log && !findString("fedratHedRot", fedratMinorSubs))
	{
	  warnSub("fedratHedRot", "fedratMinor", a_fedratMinor);
	  check_fedratHedRot(
	    dynamic_cast<fedratHedRot *>(a_fedratMinor), 0);
	}
      else
	check_fedratHedRot(
	  dynamic_cast<fedratHedRot *>(a_fedratMinor), log);
      return;
    }
  if (isA(a_fedratMinor, fedratHedMeas))
    {
      adjustLevels(&fedratMinorSubs_fedratHedMeas, "fedratHedMeas");
      if (log && !findString("fedratHedMeas", fedratMinorSubs))
	{
	  warnSub("fedratHedMeas", "fedratMinor", a_fedratMinor);
	  check_fedratHedMeas(
	    dynamic_cast<fedratHedMeas *>(a_fedratMinor), 0);
	}
      else
	check_fedratHedMeas(
	  dynamic_cast<fedratHedMeas *>(a_fedratMinor), log);
      return;
    }
  if (isA(a_fedratMinor, fedratHedScan))
    {
      adjustLevels(&fedratMinorSubs_fedratHedScan, "fedratHedScan");
      if (log && !findString("fedratHedScan", fedratMinorSubs))
	{
	  warnSub("fedratHedScan", "fedratMinor", a_fedratMinor);
	  check_fedratHedScan(
	    dynamic_cast<fedratHedScan *>(a_fedratMinor), 0);
	}
      else
	check_fedratHedScan(
	  dynamic_cast<fedratHedScan *>(a_fedratMinor), log);
      return;
    }
}

/********************************************************************/

void check_fedratPos(
 fedratPos * a_fedratPos,
 int log)
{
  if (a_fedratPos->get_fedratLinSpec())
    {
      adjustLevels(&fedratPosAtts_a_fedratLinSpec,
		   "fedratPos a_fedratLinSpec");
      if (log && !findString("a_fedratLinSpec", fedratPosAtts))
	{
	  warnAtt("a_fedratLinSpec", "fedratPos", a_fedratPos);
	  check_fedratLinSpec(a_fedratPos->get_fedratLinSpec(), 0);
	}
      else
	check_fedratLinSpec(a_fedratPos->get_fedratLinSpec(), log);
    }
}

/********************************************************************/

void check_fedratRot(
 fedratRot * a_fedratRot,
 int log)
{
  if (a_fedratRot->get_fedratAngSpec())
    {
      adjustLevels(&fedratRotAtts_a_fedratAngSpec,
		   "fedratRot a_fedratAngSpec");
      if (log && !findString("a_fedratAngSpec", fedratRotAtts))
	{
	  warnAtt("a_fedratAngSpec", "fedratRot", a_fedratRot);
	  check_fedratAngSpec(a_fedratRot->get_fedratAngSpec(), 0);
	}
      else
	check_fedratAngSpec(a_fedratRot->get_fedratAngSpec(), log);
    }
}

/********************************************************************/

void check_fedratScan(
 fedratScan * a_fedratScan,
 int log)
{
  if (a_fedratScan->get_fedratLinSpec())
    {
      adjustLevels(&fedratScanAtts_a_fedratLinSpec,
		   "fedratScan a_fedratLinSpec");
      if (log && !findString("a_fedratLinSpec", fedratScanAtts))
	{
	  warnAtt("a_fedratLinSpec", "fedratScan", a_fedratScan);
	  check_fedratLinSpec(a_fedratScan->get_fedratLinSpec(), 0);
	}
      else
	check_fedratLinSpec(a_fedratScan->get_fedratLinSpec(), log);
    }
}

/********************************************************************/

void check_fedratStm(
 fedratStm * a_fedratStm,
 int log)
{
  if (a_fedratStm->get_fedratMinor())
    {
      adjustLevels(&fedratStmAtts_a_fedratMinor, "fedratStm a_fedratMinor");
      if (log && !findString("a_fedratMinor", fedratStmAtts))
	{
	  warnAtt("a_fedratMinor", "fedratStm", a_fedratStm);
	  check_fedratMinor(a_fedratStm->get_fedratMinor(), 0);
	}
      else
	check_fedratMinor(a_fedratStm->get_fedratMinor(), log);
    }
}

/********************************************************************/

void check_fiLabel(
 fiLabel * a_fiLabel,
 int log)
{
  if (a_fiLabel->get_labelName())
    {
      adjustLevels(&fiLabelAtts_a_labelName, "fiLabel a_labelName");
      if (log && !findString("a_labelName", fiLabelAtts))
	{
	  warnAtt("a_labelName", "fiLabel", a_fiLabel);
	  check_labelName(a_fiLabel->get_labelName(), 0);
	}
      else
	check_labelName(a_fiLabel->get_labelName(), log);
    }
}

/********************************************************************/

void check_fildefStm(
 fildefStm * a_fildefStm,
 int log)
{
  if (a_fildefStm->get_vfLabel())
    {
      adjustLevels(&fildefStmAtts_a_vfLabel, "fildefStm a_vfLabel");
      if (log && !findString("a_vfLabel", fildefStmAtts))
	{
	  warnAtt("a_vfLabel", "fildefStm", a_fildefStm);
	  check_vfLabel(a_fildefStm->get_vfLabel(), 0);
	}
      else
	check_vfLabel(a_fildefStm->get_vfLabel(), log);
    }
  if (a_fildefStm->get_code())
    {
      adjustLevels(&fildefStmAtts_code, "fildefStm code");
      if (log && !findString("code", fildefStmAtts))
	{
	  warnAtt("code", "fildefStm", a_fildefStm);
	  check_intVal(a_fildefStm->get_code(), 0);
	}
      else
	check_intVal(a_fildefStm->get_code(), log);
    }
}

/********************************************************************/

void check_filnamStm(
 filnamStm * a_filnamStm,
 int log)
{
  if (a_filnamStm->get_stringConst())
    {
      adjustLevels(&filnamStmAtts_a_stringConst, "filnamStm a_stringConst");
      if (log && !findString("a_stringConst", filnamStmAtts))
	{
	  warnAtt("a_stringConst", "filnamStm", a_filnamStm);
	  check_stringConst(a_filnamStm->get_stringConst(), 0);
	}
      else
	check_stringConst(a_filnamStm->get_stringConst(), log);
    }
  if (a_filnamStm->get_versionTag())
    {
      adjustLevels(&filnamStmAtts_a_versionTag, "filnamStm a_versionTag");
      if (log && !findString("a_versionTag", filnamStmAtts))
	{
	  warnAtt("a_versionTag", "filnamStm", a_filnamStm);
	  check_versionTag(a_filnamStm->get_versionTag(), 0);
	}
      else
	check_versionTag(a_filnamStm->get_versionTag(), log);
    }
}

/********************************************************************/

void check_finposStm(
 finposStm * a_finposStm,
 int log)
{
  if (a_finposStm->get_state())
    {
      adjustLevels(&finposStmAtts_a_state, "finposStm a_state");
      if (log && !findString("a_state", finposStmAtts))
	{
	  warnAtt("a_state", "finposStm", a_finposStm);
	  check_state(a_finposStm->get_state(), 0);
	}
      else
	check_state(a_finposStm->get_state(), log);
    }
}

/********************************************************************/

void check_fixtidStm(
 fixtidStm * a_fixtidStm,
 int log)
{
  if (a_fixtidStm->get_fiLabel())
    {
      adjustLevels(&fixtidStmAtts_a_fiLabel, "fixtidStm a_fiLabel");
      if (log && !findString("a_fiLabel", fixtidStmAtts))
	{
	  warnAtt("a_fiLabel", "fixtidStm", a_fixtidStm);
	  check_fiLabel(a_fixtidStm->get_fiLabel(), 0);
	}
      else
	check_fiLabel(a_fixtidStm->get_fiLabel(), log);
    }
  if (a_fixtidStm->get_text())
    {
      adjustLevels(&fixtidStmAtts_text, "fixtidStm text");
      if (log && !findString("text", fixtidStmAtts))
	{
	  warnAtt("text", "fixtidStm", a_fixtidStm);
	  check_stringVal(a_fixtidStm->get_text(), 0);
	}
      else
	check_stringVal(a_fixtidStm->get_text(), log);
    }
}

/********************************************************************/

void check_fixtsnStm(
 fixtsnStm * a_fixtsnStm,
 int log)
{
  if (a_fixtsnStm->get_fsLabel())
    {
      adjustLevels(&fixtsnStmAtts_a_fsLabel, "fixtsnStm a_fsLabel");
      if (log && !findString("a_fsLabel", fixtsnStmAtts))
	{
	  warnAtt("a_fsLabel", "fixtsnStm", a_fixtsnStm);
	  check_fsLabel(a_fixtsnStm->get_fsLabel(), 0);
	}
      else
	check_fsLabel(a_fixtsnStm->get_fsLabel(), log);
    }
  if (a_fixtsnStm->get_text())
    {
      adjustLevels(&fixtsnStmAtts_text, "fixtsnStm text");
      if (log && !findString("text", fixtsnStmAtts))
	{
	  warnAtt("text", "fixtsnStm", a_fixtsnStm);
	  check_stringVal(a_fixtsnStm->get_text(), 0);
	}
      else
	check_stringVal(a_fixtsnStm->get_text(), log);
    }
}

/********************************************************************/

void check_flatRoundOpen(
 flatRoundOpen * a_flatRoundOpen,
 int log)
{
  if (isA(a_flatRoundOpen, flatRoundOpen_FLAT))
    {
      adjustLevels(&flatRoundOpenSubs_flatRoundOpen_FLAT,
		   "flatRoundOpen_FLAT");
      if (log && !findString("flatRoundOpen_FLAT", flatRoundOpenSubs))
	{
	  warnSub("flatRoundOpen_FLAT", "flatRoundOpen", a_flatRoundOpen);
	}
      return;
    }
  if (isA(a_flatRoundOpen, flatRoundOpen_ROUND))
    {
      adjustLevels(&flatRoundOpenSubs_flatRoundOpen_ROUND,
		   "flatRoundOpen_ROUND");
      if (log && !findString("flatRoundOpen_ROUND", flatRoundOpenSubs))
	{
	  warnSub("flatRoundOpen_ROUND", "flatRoundOpen", a_flatRoundOpen);
	}
      return;
    }
  if (isA(a_flatRoundOpen, flatRoundOpen_OPEN))
    {
      adjustLevels(&flatRoundOpenSubs_flatRoundOpen_OPEN,
		   "flatRoundOpen_OPEN");
      if (log && !findString("flatRoundOpen_OPEN", flatRoundOpenSubs))
	{
	  warnSub("flatRoundOpen_OPEN", "flatRoundOpen", a_flatRoundOpen);
	}
      return;
    }
}

/********************************************************************/

void check_flipNoFlip(
 flipNoFlip * a_flipNoFlip,
 int log)
{
  if (isA(a_flipNoFlip, flipNoFlip_FLIP))
    {
      adjustLevels(&flipNoFlipSubs_flipNoFlip_FLIP, "flipNoFlip_FLIP");
      if (log && !findString("flipNoFlip_FLIP", flipNoFlipSubs))
	{
	  warnSub("flipNoFlip_FLIP", "flipNoFlip", a_flipNoFlip);
	}
      return;
    }
  if (isA(a_flipNoFlip, flipNoFlip_NOFLIP))
    {
      adjustLevels(&flipNoFlipSubs_flipNoFlip_NOFLIP, "flipNoFlip_NOFLIP");
      if (log && !findString("flipNoFlip_NOFLIP", flipNoFlipSubs))
	{
	  warnSub("flipNoFlip_NOFLIP", "flipNoFlip", a_flipNoFlip);
	}
      return;
    }
}

/********************************************************************/

void check_flyMinor(
 flyMinor * a_flyMinor,
 int log)
{
  if (isA(a_flyMinor, flyMinor_OFF))
    {
      adjustLevels(&flyMinorSubs_flyMinor_OFF, "flyMinor_OFF");
      if (log && !findString("flyMinor_OFF", flyMinorSubs))
	{
	  warnSub("flyMinor_OFF", "flyMinor", a_flyMinor);
	}
      return;
    }
  if (isA(a_flyMinor, flyMinor_rentVal))
    {
      adjustLevels(&flyMinorSubs_flyMinor_rentVal, "flyMinor_rentVal");
      if (log && !findString("flyMinor_rentVal", flyMinorSubs))
	{
	  warnSub("flyMinor_rentVal", "flyMinor", a_flyMinor);
	  check_flyMinor_rentVal(
	    dynamic_cast<flyMinor_rentVal *>(a_flyMinor), 0);
	}
      else
	check_flyMinor_rentVal(
	  dynamic_cast<flyMinor_rentVal *>(a_flyMinor), log);
      return;
    }
}

/********************************************************************/

void check_flyMinor_rentVal(
 flyMinor_rentVal * a_flyMinor_rentVal,
 int log)
{
  if (a_flyMinor_rentVal->get_radius())
    {
      adjustLevels(&flyMinor_rentValAtts_radius, "flyMinor_rentVal radius");
      if (log && !findString("radius", flyMinor_rentValAtts))
	{
	  warnAtt("radius", "flyMinor_rentVal", a_flyMinor_rentVal);
	  check_rentVal(a_flyMinor_rentVal->get_radius(), 0);
	}
      else
	check_rentVal(a_flyMinor_rentVal->get_radius(), log);
    }
}

/********************************************************************/

void check_flyStm(
 flyStm * a_flyStm,
 int log)
{
  if (a_flyStm->get_flyMinor())
    {
      adjustLevels(&flyStmAtts_a_flyMinor, "flyStm a_flyMinor");
      if (log && !findString("a_flyMinor", flyStmAtts))
	{
	  warnAtt("a_flyMinor", "flyStm", a_flyStm);
	  check_flyMinor(a_flyStm->get_flyMinor(), 0);
	}
      else
	check_flyMinor(a_flyStm->get_flyMinor(), log);
    }
}

/********************************************************************/

void check_forceOrDeflection(
 forceOrDeflection * a_forceOrDeflection,
 int log)
{
  if (isA(a_forceOrDeflection, forceOrDeflection_FORCE))
    {
      adjustLevels(&forceOrDeflectionSubs_forceOrDeflection_FORCE,
		   "forceOrDeflection_FORCE");
      if (log && !findString("forceOrDeflection_FORCE", forceOrDeflectionSubs))
	{
	  warnSub("forceOrDeflection_FORCE", "forceOrDeflection",
		  a_forceOrDeflection);
	  check_forceOrDeflection_FORCE(
	    dynamic_cast<forceOrDeflection_FORCE *>(a_forceOrDeflection), 0);
	}
      else
	check_forceOrDeflection_FORCE(
	  dynamic_cast<forceOrDeflection_FORCE *>(a_forceOrDeflection), log);
      return;
    }
  if (isA(a_forceOrDeflection, forceOrDeflection_DEFLECTION))
    {
      adjustLevels(&forceOrDeflectionSubs_forceOrDeflection_DEFLECTION,
		   "forceOrDeflection_DEFLECTION");
      if (log && !findString("forceOrDeflection_DEFLECTION",
			     forceOrDeflectionSubs))
	{
	  warnSub("forceOrDeflection_DEFLECTION", "forceOrDeflection",
		  a_forceOrDeflection);
	  check_forceOrDeflection_DEFLECTION(
	    dynamic_cast<forceOrDeflection_DEFLECTION *>(a_forceOrDeflection), 0);
	}
      else
	check_forceOrDeflection_DEFLECTION(
	  dynamic_cast<forceOrDeflection_DEFLECTION *>(a_forceOrDeflection), log);
      return;
    }
}

/********************************************************************/

void check_forceOrDeflection_DEFLECTION(
 forceOrDeflection_DEFLECTION * a_forceOrDeflection_DEFLECTION,
 int log)
{
  if (a_forceOrDeflection_DEFLECTION->get_deflval())
    {
      adjustLevels(&forceOrDeflection_DEFLECTIONAtts_deflval,
		   "forceOrDeflection_DEFLECTION deflval");
      if (log && !findString("deflval", forceOrDeflection_DEFLECTIONAtts))
	{
	  warnAtt("deflval", "forceOrDeflection_DEFLECTION",
		  a_forceOrDeflection_DEFLECTION);
	  check_rentVal(a_forceOrDeflection_DEFLECTION->get_deflval(), 0);
	}
      else
	check_rentVal(a_forceOrDeflection_DEFLECTION->get_deflval(), log);
    }
}

/********************************************************************/

void check_forceOrDeflection_FORCE(
 forceOrDeflection_FORCE * a_forceOrDeflection_FORCE,
 int log)
{
  if (a_forceOrDeflection_FORCE->get_force())
    {
      adjustLevels(&forceOrDeflection_FORCEAtts_force,
		   "forceOrDeflection_FORCE force");
      if (log && !findString("force", forceOrDeflection_FORCEAtts))
	{
	  warnAtt("force", "forceOrDeflection_FORCE",
		  a_forceOrDeflection_FORCE);
	  check_rentVal(a_forceOrDeflection_FORCE->get_force(), 0);
	}
      else
	check_rentVal(a_forceOrDeflection_FORCE->get_force(), log);
    }
}

/********************************************************************/

void check_fromMinor(
 fromMinor * a_fromMinor,
 int log)
{
  if (isA(a_fromMinor, fromMinor_cartPoint))
    {
      adjustLevels(&fromMinorSubs_fromMinor_cartPoint, "fromMinor_cartPoint");
      if (log && !findString("fromMinor_cartPoint", fromMinorSubs))
	{
	  warnSub("fromMinor_cartPoint", "fromMinor", a_fromMinor);
	  check_fromMinor_cartPoint(
	    dynamic_cast<fromMinor_cartPoint *>(a_fromMinor), 0);
	}
      else
	check_fromMinor_cartPoint(
	  dynamic_cast<fromMinor_cartPoint *>(a_fromMinor), log);
      return;
    }
  if (isA(a_fromMinor, fromMinor_DME))
    {
      adjustLevels(&fromMinorSubs_fromMinor_DME, "fromMinor_DME");
      if (log && !findString("fromMinor_DME", fromMinorSubs))
	{
	  warnSub("fromMinor_DME", "fromMinor", a_fromMinor);
	}
      return;
    }
  if (isA(a_fromMinor, fromMinor_impCartPoint))
    {
      adjustLevels(&fromMinorSubs_fromMinor_impCartPoint,
		   "fromMinor_impCartPoint");
      if (log && !findString("fromMinor_impCartPoint", fromMinorSubs))
	{
	  warnSub("fromMinor_impCartPoint", "fromMinor", a_fromMinor);
	  check_fromMinor_impCartPoint(
	    dynamic_cast<fromMinor_impCartPoint *>(a_fromMinor), 0);
	}
      else
	check_fromMinor_impCartPoint(
	  dynamic_cast<fromMinor_impCartPoint *>(a_fromMinor), log);
      return;
    }
  if (isA(a_fromMinor, fromMinor_polPoint))
    {
      adjustLevels(&fromMinorSubs_fromMinor_polPoint, "fromMinor_polPoint");
      if (log && !findString("fromMinor_polPoint", fromMinorSubs))
	{
	  warnSub("fromMinor_polPoint", "fromMinor", a_fromMinor);
	  check_fromMinor_polPoint(
	    dynamic_cast<fromMinor_polPoint *>(a_fromMinor), 0);
	}
      else
	check_fromMinor_polPoint(
	  dynamic_cast<fromMinor_polPoint *>(a_fromMinor), log);
      return;
    }
  if (isA(a_fromMinor, fromMinor_SCALE))
    {
      adjustLevels(&fromMinorSubs_fromMinor_SCALE, "fromMinor_SCALE");
      if (log && !findString("fromMinor_SCALE", fromMinorSubs))
	{
	  warnSub("fromMinor_SCALE", "fromMinor", a_fromMinor);
	}
      return;
    }
}

/********************************************************************/

void check_fromMinor_cartPoint(
 fromMinor_cartPoint * a_fromMinor_cartPoint,
 int log)
{
  if (a_fromMinor_cartPoint->get_cartPoint())
    {
      adjustLevels(&fromMinor_cartPointAtts_a_cartPoint,
		   "fromMinor_cartPoint a_cartPoint");
      if (log && !findString("a_cartPoint", fromMinor_cartPointAtts))
	{
	  warnAtt("a_cartPoint", "fromMinor_cartPoint",
		  a_fromMinor_cartPoint);
	  check_cartPoint(a_fromMinor_cartPoint->get_cartPoint(), 0);
	}
      else
	check_cartPoint(a_fromMinor_cartPoint->get_cartPoint(), log);
    }
  if (a_fromMinor_cartPoint->get_has_RAM())
    {
      adjustLevels(&fromMinor_cartPointAtts_has_RAM,
		   "fromMinor_cartPoint has_RAM");
      if (log && !findString("has_RAM", fromMinor_cartPointAtts))
	{
	  warnAtt("has_RAM", "fromMinor_cartPoint", a_fromMinor_cartPoint);
	}
    }
}

/********************************************************************/

void check_fromMinor_impCartPoint(
 fromMinor_impCartPoint * a_fromMinor_impCartPoint,
 int log)
{
  if (a_fromMinor_impCartPoint->get_impCartPoint())
    {
      adjustLevels(&fromMinor_impCartPointAtts_a_impCartPoint,
		   "fromMinor_impCartPoint a_impCartPoint");
      if (log && !findString("a_impCartPoint", fromMinor_impCartPointAtts))
	{
	  warnAtt("a_impCartPoint", "fromMinor_impCartPoint",
		  a_fromMinor_impCartPoint);
	  check_impCartPoint(a_fromMinor_impCartPoint->get_impCartPoint(), 0);
	}
      else
	check_impCartPoint(a_fromMinor_impCartPoint->get_impCartPoint(), log);
    }
  if (a_fromMinor_impCartPoint->get_has_RAM())
    {
      adjustLevels(&fromMinor_impCartPointAtts_has_RAM,
		   "fromMinor_impCartPoint has_RAM");
      if (log && !findString("has_RAM", fromMinor_impCartPointAtts))
	{
	  warnAtt("has_RAM", "fromMinor_impCartPoint",
		  a_fromMinor_impCartPoint);
	}
    }
}

/********************************************************************/

void check_fromMinor_polPoint(
 fromMinor_polPoint * a_fromMinor_polPoint,
 int log)
{
  if (a_fromMinor_polPoint->get_polPoint())
    {
      adjustLevels(&fromMinor_polPointAtts_a_polPoint,
		   "fromMinor_polPoint a_polPoint");
      if (log && !findString("a_polPoint", fromMinor_polPointAtts))
	{
	  warnAtt("a_polPoint", "fromMinor_polPoint", a_fromMinor_polPoint);
	  check_polPoint(a_fromMinor_polPoint->get_polPoint(), 0);
	}
      else
	check_polPoint(a_fromMinor_polPoint->get_polPoint(), log);
    }
  if (a_fromMinor_polPoint->get_has_RAM())
    {
      adjustLevels(&fromMinor_polPointAtts_has_RAM,
		   "fromMinor_polPoint has_RAM");
      if (log && !findString("has_RAM", fromMinor_polPointAtts))
	{
	  warnAtt("has_RAM", "fromMinor_polPoint", a_fromMinor_polPoint);
	}
    }
}

/********************************************************************/

void check_fromStm(
 fromStm * a_fromStm,
 int log)
{
  if (a_fromStm->get_fromMinor())
    {
      adjustLevels(&fromStmAtts_a_fromMinor, "fromStm a_fromMinor");
      if (log && !findString("a_fromMinor", fromStmAtts))
	{
	  warnAtt("a_fromMinor", "fromStm", a_fromStm);
	  check_fromMinor(a_fromStm->get_fromMinor(), 0);
	}
      else
	check_fromMinor(a_fromStm->get_fromMinor(), log);
    }
}

/********************************************************************/

void check_fsLabel(
 fsLabel * a_fsLabel,
 int log)
{
  if (a_fsLabel->get_labelName())
    {
      adjustLevels(&fsLabelAtts_a_labelName, "fsLabel a_labelName");
      if (log && !findString("a_labelName", fsLabelAtts))
	{
	  warnAtt("a_labelName", "fsLabel", a_fsLabel);
	  check_labelName(a_fsLabel->get_labelName(), 0);
	}
      else
	check_labelName(a_fsLabel->get_labelName(), log);
    }
}

/********************************************************************/

void check_gLabel(
 gLabel * a_gLabel,
 int log)
{
  if (a_gLabel->get_labelName())
    {
      adjustLevels(&gLabelAtts_a_labelName, "gLabel a_labelName");
      if (log && !findString("a_labelName", gLabelAtts))
	{
	  warnAtt("a_labelName", "gLabel", a_gLabel);
	  check_labelName(a_gLabel->get_labelName(), 0);
	}
      else
	check_labelName(a_gLabel->get_labelName(), log);
    }
}

/********************************************************************/

void check_geoalgArc(
 geoalgArc * a_geoalgArc,
 int log)
{
  if (a_geoalgArc->get_geoalgSpec1())
    {
      adjustLevels(&geoalgArcAtts_a_geoalgSpec1, "geoalgArc a_geoalgSpec1");
      if (log && !findString("a_geoalgSpec1", geoalgArcAtts))
	{
	  warnAtt("a_geoalgSpec1", "geoalgArc", a_geoalgArc);
	  check_geoalgSpec1(a_geoalgArc->get_geoalgSpec1(), 0);
	}
      else
	check_geoalgSpec1(a_geoalgArc->get_geoalgSpec1(), log);
    }
}

/********************************************************************/

void check_geoalgCircle(
 geoalgCircle * a_geoalgCircle,
 int log)
{
  if (a_geoalgCircle->get_geoalgSpec2())
    {
      adjustLevels(&geoalgCircleAtts_a_geoalgSpec2,
		   "geoalgCircle a_geoalgSpec2");
      if (log && !findString("a_geoalgSpec2", geoalgCircleAtts))
	{
	  warnAtt("a_geoalgSpec2", "geoalgCircle", a_geoalgCircle);
	  check_geoalgSpec2(a_geoalgCircle->get_geoalgSpec2(), 0);
	}
      else
	check_geoalgSpec2(a_geoalgCircle->get_geoalgSpec2(), log);
    }
}

/********************************************************************/

void check_geoalgCone(
 geoalgCone * a_geoalgCone,
 int log)
{
  if (a_geoalgCone->get_geoalgSpec2())
    {
      adjustLevels(&geoalgConeAtts_a_geoalgSpec2, "geoalgCone a_geoalgSpec2");
      if (log && !findString("a_geoalgSpec2", geoalgConeAtts))
	{
	  warnAtt("a_geoalgSpec2", "geoalgCone", a_geoalgCone);
	  check_geoalgSpec2(a_geoalgCone->get_geoalgSpec2(), 0);
	}
      else
	check_geoalgSpec2(a_geoalgCone->get_geoalgSpec2(), log);
    }
}

/********************************************************************/

void check_geoalgConradsegmnt(
 geoalgConradsegmnt * a_geoalgConradsegmnt,
 int log)
{
  if (a_geoalgConradsegmnt->get_geoalgSpec2())
    {
      adjustLevels(&geoalgConradsegmntAtts_a_geoalgSpec2,
		   "geoalgConradsegmnt a_geoalgSpec2");
      if (log && !findString("a_geoalgSpec2", geoalgConradsegmntAtts))
	{
	  warnAtt("a_geoalgSpec2", "geoalgConradsegmnt",
		  a_geoalgConradsegmnt);
	  check_geoalgSpec2(a_geoalgConradsegmnt->get_geoalgSpec2(), 0);
	}
      else
	check_geoalgSpec2(a_geoalgConradsegmnt->get_geoalgSpec2(), log);
    }
}

/********************************************************************/

void check_geoalgCparln(
 geoalgCparln * a_geoalgCparln,
 int log)
{
  if (a_geoalgCparln->get_geoalgSpec3())
    {
      adjustLevels(&geoalgCparlnAtts_a_geoalgSpec3,
		   "geoalgCparln a_geoalgSpec3");
      if (log && !findString("a_geoalgSpec3", geoalgCparlnAtts))
	{
	  warnAtt("a_geoalgSpec3", "geoalgCparln", a_geoalgCparln);
	  check_geoalgSpec3(a_geoalgCparln->get_geoalgSpec3(), 0);
	}
      else
	check_geoalgSpec3(a_geoalgCparln->get_geoalgSpec3(), log);
    }
}

/********************************************************************/

void check_geoalgCylndr(
 geoalgCylndr * a_geoalgCylndr,
 int log)
{
  if (a_geoalgCylndr->get_geoalgSpec2())
    {
      adjustLevels(&geoalgCylndrAtts_a_geoalgSpec2,
		   "geoalgCylndr a_geoalgSpec2");
      if (log && !findString("a_geoalgSpec2", geoalgCylndrAtts))
	{
	  warnAtt("a_geoalgSpec2", "geoalgCylndr", a_geoalgCylndr);
	  check_geoalgSpec2(a_geoalgCylndr->get_geoalgSpec2(), 0);
	}
      else
	check_geoalgSpec2(a_geoalgCylndr->get_geoalgSpec2(), log);
    }
}

/********************************************************************/

void check_geoalgCylradsegmnt(
 geoalgCylradsegmnt * a_geoalgCylradsegmnt,
 int log)
{
  if (a_geoalgCylradsegmnt->get_geoalgSpec2())
    {
      adjustLevels(&geoalgCylradsegmntAtts_a_geoalgSpec2,
		   "geoalgCylradsegmnt a_geoalgSpec2");
      if (log && !findString("a_geoalgSpec2", geoalgCylradsegmntAtts))
	{
	  warnAtt("a_geoalgSpec2", "geoalgCylradsegmnt",
		  a_geoalgCylradsegmnt);
	  check_geoalgSpec2(a_geoalgCylradsegmnt->get_geoalgSpec2(), 0);
	}
      else
	check_geoalgSpec2(a_geoalgCylradsegmnt->get_geoalgSpec2(), log);
    }
}

/********************************************************************/

void check_geoalgEliminate(
 geoalgEliminate * a_geoalgEliminate,
 int log)
{
  if (isA(a_geoalgEliminate, geoalgEliminateStd))
    {
      adjustLevels(&geoalgEliminateSubs_geoalgEliminateStd,
		   "geoalgEliminateStd");
      if (log && !findString("geoalgEliminateStd", geoalgEliminateSubs))
	{
	  warnSub("geoalgEliminateStd", "geoalgEliminate", a_geoalgEliminate);
	  check_geoalgEliminateStd(
	    dynamic_cast<geoalgEliminateStd *>(a_geoalgEliminate), 0);
	}
      else
	check_geoalgEliminateStd(
	  dynamic_cast<geoalgEliminateStd *>(a_geoalgEliminate), log);
      return;
    }
  if (isA(a_geoalgEliminate, geoalgEliminateOff))
    {
      adjustLevels(&geoalgEliminateSubs_geoalgEliminateOff,
		   "geoalgEliminateOff");
      if (log && !findString("geoalgEliminateOff", geoalgEliminateSubs))
	{
	  warnSub("geoalgEliminateOff", "geoalgEliminate", a_geoalgEliminate);
	}
      return;
    }
}

/********************************************************************/

void check_geoalgEliminateStd(
 geoalgEliminateStd * a_geoalgEliminateStd,
 int log)
{
  if (a_geoalgEliminateStd->get_devVal())
    {
      adjustLevels(&geoalgEliminateStdAtts_devVal,
		   "geoalgEliminateStd devVal");
      if (log && !findString("devVal", geoalgEliminateStdAtts))
	{
	  warnAtt("devVal", "geoalgEliminateStd", a_geoalgEliminateStd);
	  check_rentVal(a_geoalgEliminateStd->get_devVal(), 0);
	}
      else
	check_rentVal(a_geoalgEliminateStd->get_devVal(), log);
    }
}

/********************************************************************/

void check_geoalgEllips(
 geoalgEllips * a_geoalgEllips,
 int log)
{
  if (a_geoalgEllips->get_geoalgSpec1())
    {
      adjustLevels(&geoalgEllipsAtts_a_geoalgSpec1,
		   "geoalgEllips a_geoalgSpec1");
      if (log && !findString("a_geoalgSpec1", geoalgEllipsAtts))
	{
	  warnAtt("a_geoalgSpec1", "geoalgEllips", a_geoalgEllips);
	  check_geoalgSpec1(a_geoalgEllips->get_geoalgSpec1(), 0);
	}
      else
	check_geoalgSpec1(a_geoalgEllips->get_geoalgSpec1(), log);
    }
}

/********************************************************************/

void check_geoalgElongcyl(
 geoalgElongcyl * a_geoalgElongcyl,
 int log)
{
  if (a_geoalgElongcyl->get_geoalgSpec2())
    {
      adjustLevels(&geoalgElongcylAtts_a_geoalgSpec2,
		   "geoalgElongcyl a_geoalgSpec2");
      if (log && !findString("a_geoalgSpec2", geoalgElongcylAtts))
	{
	  warnAtt("a_geoalgSpec2", "geoalgElongcyl", a_geoalgElongcyl);
	  check_geoalgSpec2(a_geoalgElongcyl->get_geoalgSpec2(), 0);
	}
      else
	check_geoalgSpec2(a_geoalgElongcyl->get_geoalgSpec2(), log);
    }
}

/********************************************************************/

void check_geoalgExternFunc(
 geoalgExternFunc * a_geoalgExternFunc,
 int log)
{
  if (isA(a_geoalgExternFunc, geoalgExternFunc_DMIS))
    {
      adjustLevels(&geoalgExternFuncSubs_geoalgExternFunc_DMIS,
		   "geoalgExternFunc_DMIS");
      if (log && !findString("geoalgExternFunc_DMIS", geoalgExternFuncSubs))
	{
	  warnSub("geoalgExternFunc_DMIS", "geoalgExternFunc",
		  a_geoalgExternFunc);
	  check_geoalgExternFunc_DMIS(
	    dynamic_cast<geoalgExternFunc_DMIS *>(a_geoalgExternFunc), 0);
	}
      else
	check_geoalgExternFunc_DMIS(
	  dynamic_cast<geoalgExternFunc_DMIS *>(a_geoalgExternFunc), log);
      return;
    }
  if (isA(a_geoalgExternFunc, geoalgExternFunc_DME))
    {
      adjustLevels(&geoalgExternFuncSubs_geoalgExternFunc_DME,
		   "geoalgExternFunc_DME");
      if (log && !findString("geoalgExternFunc_DME", geoalgExternFuncSubs))
	{
	  warnSub("geoalgExternFunc_DME", "geoalgExternFunc",
		  a_geoalgExternFunc);
	  check_geoalgExternFunc_DME(
	    dynamic_cast<geoalgExternFunc_DME *>(a_geoalgExternFunc), 0);
	}
      else
	check_geoalgExternFunc_DME(
	  dynamic_cast<geoalgExternFunc_DME *>(a_geoalgExternFunc), log);
      return;
    }
  if (isA(a_geoalgExternFunc, geoalgExternFunc_SYS))
    {
      adjustLevels(&geoalgExternFuncSubs_geoalgExternFunc_SYS,
		   "geoalgExternFunc_SYS");
      if (log && !findString("geoalgExternFunc_SYS", geoalgExternFuncSubs))
	{
	  warnSub("geoalgExternFunc_SYS", "geoalgExternFunc",
		  a_geoalgExternFunc);
	  check_geoalgExternFunc_SYS(
	    dynamic_cast<geoalgExternFunc_SYS *>(a_geoalgExternFunc), 0);
	}
      else
	check_geoalgExternFunc_SYS(
	  dynamic_cast<geoalgExternFunc_SYS *>(a_geoalgExternFunc), log);
      return;
    }
}

/********************************************************************/

void check_geoalgExternFunc_DME(
 geoalgExternFunc_DME * a_geoalgExternFunc_DME,
 int log)
{
  if (a_geoalgExternFunc_DME->get_routine())
    {
      adjustLevels(&geoalgExternFunc_DMEAtts_routine,
		   "geoalgExternFunc_DME routine");
      if (log && !findString("routine", geoalgExternFunc_DMEAtts))
	{
	  warnAtt("routine", "geoalgExternFunc_DME", a_geoalgExternFunc_DME);
	  check_stringVal(a_geoalgExternFunc_DME->get_routine(), 0);
	}
      else
	check_stringVal(a_geoalgExternFunc_DME->get_routine(), log);
    }
}

/********************************************************************/

void check_geoalgExternFunc_DMIS(
 geoalgExternFunc_DMIS * a_geoalgExternFunc_DMIS,
 int log)
{
  if (a_geoalgExternFunc_DMIS->get_mLabel())
    {
      adjustLevels(&geoalgExternFunc_DMISAtts_a_mLabel,
		   "geoalgExternFunc_DMIS a_mLabel");
      if (log && !findString("a_mLabel", geoalgExternFunc_DMISAtts))
	{
	  warnAtt("a_mLabel", "geoalgExternFunc_DMIS",
		  a_geoalgExternFunc_DMIS);
	  check_mLabel(a_geoalgExternFunc_DMIS->get_mLabel(), 0);
	}
      else
	check_mLabel(a_geoalgExternFunc_DMIS->get_mLabel(), log);
    }
}

/********************************************************************/

void check_geoalgExternFunc_SYS(
 geoalgExternFunc_SYS * a_geoalgExternFunc_SYS,
 int log)
{
  if (a_geoalgExternFunc_SYS->get_pathname())
    {
      adjustLevels(&geoalgExternFunc_SYSAtts_pathname,
		   "geoalgExternFunc_SYS pathname");
      if (log && !findString("pathname", geoalgExternFunc_SYSAtts))
	{
	  warnAtt("pathname", "geoalgExternFunc_SYS", a_geoalgExternFunc_SYS);
	  check_stringVal(a_geoalgExternFunc_SYS->get_pathname(), 0);
	}
      else
	check_stringVal(a_geoalgExternFunc_SYS->get_pathname(), log);
    }
}

/********************************************************************/

void check_geoalgFiltSetElim(
 geoalgFiltSetElim * a_geoalgFiltSetElim,
 int log)
{
  if (a_geoalgFiltSetElim->get_geoalgEliminate())
    {
      adjustLevels(&geoalgFiltSetElimAtts_a_geoalgEliminate,
		   "geoalgFiltSetElim a_geoalgEliminate");
      if (log && !findString("a_geoalgEliminate", geoalgFiltSetElimAtts))
	{
	  warnAtt("a_geoalgEliminate", "geoalgFiltSetElim",
		  a_geoalgFiltSetElim);
	  check_geoalgEliminate(a_geoalgFiltSetElim->get_geoalgEliminate(), 0);
	}
      else
	check_geoalgEliminate(a_geoalgFiltSetElim->get_geoalgEliminate(), log);
    }
}

/********************************************************************/

void check_geoalgFiltSetFilt(
 geoalgFiltSetFilt * a_geoalgFiltSetFilt,
 int log)
{
  if (a_geoalgFiltSetFilt->get_geoalgEliminate())
    {
      adjustLevels(&geoalgFiltSetFiltAtts_a_geoalgEliminate,
		   "geoalgFiltSetFilt a_geoalgEliminate");
      if (log && !findString("a_geoalgEliminate", geoalgFiltSetFiltAtts))
	{
	  warnAtt("a_geoalgEliminate", "geoalgFiltSetFilt",
		  a_geoalgFiltSetFilt);
	  check_geoalgEliminate(a_geoalgFiltSetFilt->get_geoalgEliminate(), 0);
	}
      else
	check_geoalgEliminate(a_geoalgFiltSetFilt->get_geoalgEliminate(), log);
    }
  if (a_geoalgFiltSetFilt->get_geoalgFilter())
    {
      adjustLevels(&geoalgFiltSetFiltAtts_a_geoalgFilter,
		   "geoalgFiltSetFilt a_geoalgFilter");
      if (log && !findString("a_geoalgFilter", geoalgFiltSetFiltAtts))
	{
	  warnAtt("a_geoalgFilter", "geoalgFiltSetFilt", a_geoalgFiltSetFilt);
	  check_geoalgFilter(a_geoalgFiltSetFilt->get_geoalgFilter(), 0);
	}
      else
	check_geoalgFilter(a_geoalgFiltSetFilt->get_geoalgFilter(), log);
    }
}

/********************************************************************/

void check_geoalgFilter(
 geoalgFilter * a_geoalgFilter,
 int log)
{
  if (isA(a_geoalgFilter, geoalgFilterLambda))
    {
      adjustLevels(&geoalgFilterSubs_geoalgFilterLambda, "geoalgFilterLambda");
      if (log && !findString("geoalgFilterLambda", geoalgFilterSubs))
	{
	  warnSub("geoalgFilterLambda", "geoalgFilter", a_geoalgFilter);
	  check_geoalgFilterLambda(
	    dynamic_cast<geoalgFilterLambda *>(a_geoalgFilter), 0);
	}
      else
	check_geoalgFilterLambda(
	  dynamic_cast<geoalgFilterLambda *>(a_geoalgFilter), log);
      return;
    }
  if (isA(a_geoalgFilter, geoalgFilterCirc))
    {
      adjustLevels(&geoalgFilterSubs_geoalgFilterCirc, "geoalgFilterCirc");
      if (log && !findString("geoalgFilterCirc", geoalgFilterSubs))
	{
	  warnSub("geoalgFilterCirc", "geoalgFilter", a_geoalgFilter);
	  check_geoalgFilterCirc(
	    dynamic_cast<geoalgFilterCirc *>(a_geoalgFilter), 0);
	}
      else
	check_geoalgFilterCirc(
	  dynamic_cast<geoalgFilterCirc *>(a_geoalgFilter), log);
      return;
    }
  if (isA(a_geoalgFilter, geoalgFilterOff))
    {
      adjustLevels(&geoalgFilterSubs_geoalgFilterOff, "geoalgFilterOff");
      if (log && !findString("geoalgFilterOff", geoalgFilterSubs))
	{
	  warnSub("geoalgFilterOff", "geoalgFilter", a_geoalgFilter);
	}
      return;
    }
}

/********************************************************************/

void check_geoalgFilterCirc(
 geoalgFilterCirc * a_geoalgFilterCirc,
 int log)
{
  if (a_geoalgFilterCirc->get_geoalgFilterType())
    {
      adjustLevels(&geoalgFilterCircAtts_a_geoalgFilterType,
		   "geoalgFilterCirc a_geoalgFilterType");
      if (log && !findString("a_geoalgFilterType", geoalgFilterCircAtts))
	{
	  warnAtt("a_geoalgFilterType", "geoalgFilterCirc",
		  a_geoalgFilterCirc);
	  check_geoalgFilterType(a_geoalgFilterCirc->get_geoalgFilterType(), 0);
	}
      else
	check_geoalgFilterType(a_geoalgFilterCirc->get_geoalgFilterType(), log);
    }
}

/********************************************************************/

void check_geoalgFilterCurve(
 geoalgFilterCurve * a_geoalgFilterCurve,
 int log)
{
  if (isA(a_geoalgFilterCurve, geoalgFilterCurve_GAUSS))
    {
      adjustLevels(&geoalgFilterCurveSubs_geoalgFilterCurve_GAUSS,
		   "geoalgFilterCurve_GAUSS");
      if (log && !findString("geoalgFilterCurve_GAUSS", geoalgFilterCurveSubs))
	{
	  warnSub("geoalgFilterCurve_GAUSS", "geoalgFilterCurve",
		  a_geoalgFilterCurve);
	}
      return;
    }
  if (isA(a_geoalgFilterCurve, geoalgFilterCurve_TWORC))
    {
      adjustLevels(&geoalgFilterCurveSubs_geoalgFilterCurve_TWORC,
		   "geoalgFilterCurve_TWORC");
      if (log && !findString("geoalgFilterCurve_TWORC", geoalgFilterCurveSubs))
	{
	  warnSub("geoalgFilterCurve_TWORC", "geoalgFilterCurve",
		  a_geoalgFilterCurve);
	}
      return;
    }
  if (isA(a_geoalgFilterCurve, geoalgFilterCurve_SPLINE))
    {
      adjustLevels(&geoalgFilterCurveSubs_geoalgFilterCurve_SPLINE,
		   "geoalgFilterCurve_SPLINE");
      if (log && !findString("geoalgFilterCurve_SPLINE",
			     geoalgFilterCurveSubs))
	{
	  warnSub("geoalgFilterCurve_SPLINE", "geoalgFilterCurve",
		  a_geoalgFilterCurve);
	}
      return;
    }
  if (isA(a_geoalgFilterCurve, geoalgFilterCurve_RECFILT))
    {
      adjustLevels(&geoalgFilterCurveSubs_geoalgFilterCurve_RECFILT,
		   "geoalgFilterCurve_RECFILT");
      if (log && !findString("geoalgFilterCurve_RECFILT",
			     geoalgFilterCurveSubs))
	{
	  warnSub("geoalgFilterCurve_RECFILT", "geoalgFilterCurve",
		  a_geoalgFilterCurve);
	}
      return;
    }
}

/********************************************************************/

void check_geoalgFilterLambda(
 geoalgFilterLambda * a_geoalgFilterLambda,
 int log)
{
  if (a_geoalgFilterLambda->get_geoalgFilterType())
    {
      adjustLevels(&geoalgFilterLambdaAtts_a_geoalgFilterType,
		   "geoalgFilterLambda a_geoalgFilterType");
      if (log && !findString("a_geoalgFilterType", geoalgFilterLambdaAtts))
	{
	  warnAtt("a_geoalgFilterType", "geoalgFilterLambda",
		  a_geoalgFilterLambda);
	  check_geoalgFilterType(
	    a_geoalgFilterLambda->get_geoalgFilterType(), 0);
	}
      else
	check_geoalgFilterType(
	  a_geoalgFilterLambda->get_geoalgFilterType(), log);
    }
}

/********************************************************************/

void check_geoalgFilterSettings(
 geoalgFilterSettings * a_geoalgFilterSettings,
 int log)
{
  if (isA(a_geoalgFilterSettings, geoalgFiltSetFilt))
    {
      adjustLevels(&geoalgFilterSettingsSubs_geoalgFiltSetFilt,
		   "geoalgFiltSetFilt");
      if (log && !findString("geoalgFiltSetFilt", geoalgFilterSettingsSubs))
	{
	  warnSub("geoalgFiltSetFilt", "geoalgFilterSettings",
		  a_geoalgFilterSettings);
	  check_geoalgFiltSetFilt(
	    dynamic_cast<geoalgFiltSetFilt *>(a_geoalgFilterSettings), 0);
	}
      else
	check_geoalgFiltSetFilt(
	  dynamic_cast<geoalgFiltSetFilt *>(a_geoalgFilterSettings), log);
      return;
    }
  if (isA(a_geoalgFilterSettings, geoalgFiltSetElim))
    {
      adjustLevels(&geoalgFilterSettingsSubs_geoalgFiltSetElim,
		   "geoalgFiltSetElim");
      if (log && !findString("geoalgFiltSetElim", geoalgFilterSettingsSubs))
	{
	  warnSub("geoalgFiltSetElim", "geoalgFilterSettings",
		  a_geoalgFilterSettings);
	  check_geoalgFiltSetElim(
	    dynamic_cast<geoalgFiltSetElim *>(a_geoalgFilterSettings), 0);
	}
      else
	check_geoalgFiltSetElim(
	  dynamic_cast<geoalgFiltSetElim *>(a_geoalgFilterSettings), log);
      return;
    }
}

/********************************************************************/

void check_geoalgFilterType(
 geoalgFilterType * a_geoalgFilterType,
 int log)
{
  if (isA(a_geoalgFilterType, geoalgFilterType_LOWPASS))
    {
      adjustLevels(&geoalgFilterTypeSubs_geoalgFilterType_LOWPASS,
		   "geoalgFilterType_LOWPASS");
      if (log && !findString("geoalgFilterType_LOWPASS", geoalgFilterTypeSubs))
	{
	  warnSub("geoalgFilterType_LOWPASS", "geoalgFilterType",
		  a_geoalgFilterType);
	  check_geoalgFilterType_LOWPASS(
	    dynamic_cast<geoalgFilterType_LOWPASS *>(a_geoalgFilterType), 0);
	}
      else
	check_geoalgFilterType_LOWPASS(
	  dynamic_cast<geoalgFilterType_LOWPASS *>(a_geoalgFilterType), log);
      return;
    }
  if (isA(a_geoalgFilterType, geoalgFilterType_HIGHPASS))
    {
      adjustLevels(&geoalgFilterTypeSubs_geoalgFilterType_HIGHPASS,
		   "geoalgFilterType_HIGHPASS");
      if (log && !findString("geoalgFilterType_HIGHPASS",
			     geoalgFilterTypeSubs))
	{
	  warnSub("geoalgFilterType_HIGHPASS", "geoalgFilterType",
		  a_geoalgFilterType);
	  check_geoalgFilterType_HIGHPASS(
	    dynamic_cast<geoalgFilterType_HIGHPASS *>(a_geoalgFilterType), 0);
	}
      else
	check_geoalgFilterType_HIGHPASS(
	  dynamic_cast<geoalgFilterType_HIGHPASS *>(a_geoalgFilterType), log);
      return;
    }
  if (isA(a_geoalgFilterType, geoalgFilterType_BANDPASS))
    {
      adjustLevels(&geoalgFilterTypeSubs_geoalgFilterType_BANDPASS,
		   "geoalgFilterType_BANDPASS");
      if (log && !findString("geoalgFilterType_BANDPASS",
			     geoalgFilterTypeSubs))
	{
	  warnSub("geoalgFilterType_BANDPASS", "geoalgFilterType",
		  a_geoalgFilterType);
	  check_geoalgFilterType_BANDPASS(
	    dynamic_cast<geoalgFilterType_BANDPASS *>(a_geoalgFilterType), 0);
	}
      else
	check_geoalgFilterType_BANDPASS(
	  dynamic_cast<geoalgFilterType_BANDPASS *>(a_geoalgFilterType), log);
      return;
    }
}

/********************************************************************/

void check_geoalgFilterType_BANDPASS(
 geoalgFilterType_BANDPASS * a_geoalgFilterType_BANDPASS,
 int log)
{
  if (a_geoalgFilterType_BANDPASS->get_waveVal1())
    {
      adjustLevels(&geoalgFilterType_BANDPASSAtts_waveVal1,
		   "geoalgFilterType_BANDPASS waveVal1");
      if (log && !findString("waveVal1", geoalgFilterType_BANDPASSAtts))
	{
	  warnAtt("waveVal1", "geoalgFilterType_BANDPASS",
		  a_geoalgFilterType_BANDPASS);
	  check_rentVal(a_geoalgFilterType_BANDPASS->get_waveVal1(), 0);
	}
      else
	check_rentVal(a_geoalgFilterType_BANDPASS->get_waveVal1(), log);
    }
  if (a_geoalgFilterType_BANDPASS->get_waveVal2())
    {
      adjustLevels(&geoalgFilterType_BANDPASSAtts_waveVal2,
		   "geoalgFilterType_BANDPASS waveVal2");
      if (log && !findString("waveVal2", geoalgFilterType_BANDPASSAtts))
	{
	  warnAtt("waveVal2", "geoalgFilterType_BANDPASS",
		  a_geoalgFilterType_BANDPASS);
	  check_rentVal(a_geoalgFilterType_BANDPASS->get_waveVal2(), 0);
	}
      else
	check_rentVal(a_geoalgFilterType_BANDPASS->get_waveVal2(), log);
    }
  if (a_geoalgFilterType_BANDPASS->get_geoalgFilterCurve())
    {
      adjustLevels(&geoalgFilterType_BANDPASSAtts_a_geoalgFilterCurve,
		   "geoalgFilterType_BANDPASS a_geoalgFilterCurve");
      if (log && !findString("a_geoalgFilterCurve",
			     geoalgFilterType_BANDPASSAtts))
	{
	  warnAtt("a_geoalgFilterCurve", "geoalgFilterType_BANDPASS",
		  a_geoalgFilterType_BANDPASS);
	  check_geoalgFilterCurve(
	    a_geoalgFilterType_BANDPASS->get_geoalgFilterCurve(), 0);
	}
      else
	check_geoalgFilterCurve(
	  a_geoalgFilterType_BANDPASS->get_geoalgFilterCurve(), log);
    }
}

/********************************************************************/

void check_geoalgFilterType_HIGHPASS(
 geoalgFilterType_HIGHPASS * a_geoalgFilterType_HIGHPASS,
 int log)
{
  if (a_geoalgFilterType_HIGHPASS->get_waveVal())
    {
      adjustLevels(&geoalgFilterType_HIGHPASSAtts_waveVal,
		   "geoalgFilterType_HIGHPASS waveVal");
      if (log && !findString("waveVal", geoalgFilterType_HIGHPASSAtts))
	{
	  warnAtt("waveVal", "geoalgFilterType_HIGHPASS",
		  a_geoalgFilterType_HIGHPASS);
	  check_rentVal(a_geoalgFilterType_HIGHPASS->get_waveVal(), 0);
	}
      else
	check_rentVal(a_geoalgFilterType_HIGHPASS->get_waveVal(), log);
    }
  if (a_geoalgFilterType_HIGHPASS->get_geoalgFilterCurve())
    {
      adjustLevels(&geoalgFilterType_HIGHPASSAtts_a_geoalgFilterCurve,
		   "geoalgFilterType_HIGHPASS a_geoalgFilterCurve");
      if (log && !findString("a_geoalgFilterCurve",
			     geoalgFilterType_HIGHPASSAtts))
	{
	  warnAtt("a_geoalgFilterCurve", "geoalgFilterType_HIGHPASS",
		  a_geoalgFilterType_HIGHPASS);
	  check_geoalgFilterCurve(
	    a_geoalgFilterType_HIGHPASS->get_geoalgFilterCurve(), 0);
	}
      else
	check_geoalgFilterCurve(
	  a_geoalgFilterType_HIGHPASS->get_geoalgFilterCurve(), log);
    }
}

/********************************************************************/

void check_geoalgFilterType_LOWPASS(
 geoalgFilterType_LOWPASS * a_geoalgFilterType_LOWPASS,
 int log)
{
  if (a_geoalgFilterType_LOWPASS->get_waveVal())
    {
      adjustLevels(&geoalgFilterType_LOWPASSAtts_waveVal,
		   "geoalgFilterType_LOWPASS waveVal");
      if (log && !findString("waveVal", geoalgFilterType_LOWPASSAtts))
	{
	  warnAtt("waveVal", "geoalgFilterType_LOWPASS",
		  a_geoalgFilterType_LOWPASS);
	  check_rentVal(a_geoalgFilterType_LOWPASS->get_waveVal(), 0);
	}
      else
	check_rentVal(a_geoalgFilterType_LOWPASS->get_waveVal(), log);
    }
  if (a_geoalgFilterType_LOWPASS->get_geoalgFilterCurve())
    {
      adjustLevels(&geoalgFilterType_LOWPASSAtts_a_geoalgFilterCurve,
		   "geoalgFilterType_LOWPASS a_geoalgFilterCurve");
      if (log && !findString("a_geoalgFilterCurve",
			     geoalgFilterType_LOWPASSAtts))
	{
	  warnAtt("a_geoalgFilterCurve", "geoalgFilterType_LOWPASS",
		  a_geoalgFilterType_LOWPASS);
	  check_geoalgFilterCurve(
	    a_geoalgFilterType_LOWPASS->get_geoalgFilterCurve(), 0);
	}
      else
	check_geoalgFilterCurve(
	  a_geoalgFilterType_LOWPASS->get_geoalgFilterCurve(), log);
    }
}

/********************************************************************/

void check_geoalgGcurve(
 geoalgGcurve * a_geoalgGcurve,
 int log)
{
  if (a_geoalgGcurve->get_geoalgSpec4())
    {
      adjustLevels(&geoalgGcurveAtts_a_geoalgSpec4,
		   "geoalgGcurve a_geoalgSpec4");
      if (log && !findString("a_geoalgSpec4", geoalgGcurveAtts))
	{
	  warnAtt("a_geoalgSpec4", "geoalgGcurve", a_geoalgGcurve);
	  check_geoalgSpec4(a_geoalgGcurve->get_geoalgSpec4(), 0);
	}
      else
	check_geoalgSpec4(a_geoalgGcurve->get_geoalgSpec4(), log);
    }
}

/********************************************************************/

void check_geoalgGsurf(
 geoalgGsurf * a_geoalgGsurf,
 int log)
{
  if (a_geoalgGsurf->get_geoalgSpec5())
    {
      adjustLevels(&geoalgGsurfAtts_a_geoalgSpec5,
		   "geoalgGsurf a_geoalgSpec5");
      if (log && !findString("a_geoalgSpec5", geoalgGsurfAtts))
	{
	  warnAtt("a_geoalgSpec5", "geoalgGsurf", a_geoalgGsurf);
	  check_geoalgSpec5(a_geoalgGsurf->get_geoalgSpec5(), 0);
	}
      else
	check_geoalgSpec5(a_geoalgGsurf->get_geoalgSpec5(), log);
    }
}

/********************************************************************/

void check_geoalgLine(
 geoalgLine * a_geoalgLine,
 int log)
{
  if (a_geoalgLine->get_geoalgSpec1())
    {
      adjustLevels(&geoalgLineAtts_a_geoalgSpec1, "geoalgLine a_geoalgSpec1");
      if (log && !findString("a_geoalgSpec1", geoalgLineAtts))
	{
	  warnAtt("a_geoalgSpec1", "geoalgLine", a_geoalgLine);
	  check_geoalgSpec1(a_geoalgLine->get_geoalgSpec1(), 0);
	}
      else
	check_geoalgSpec1(a_geoalgLine->get_geoalgSpec1(), log);
    }
}

/********************************************************************/

void check_geoalgMinor(
 geoalgMinor * a_geoalgMinor,
 int log)
{
  if (isA(a_geoalgMinor, geoalgArc))
    {
      adjustLevels(&geoalgMinorSubs_geoalgArc, "geoalgArc");
      if (log && !findString("geoalgArc", geoalgMinorSubs))
	{
	  warnSub("geoalgArc", "geoalgMinor", a_geoalgMinor);
	  check_geoalgArc(dynamic_cast<geoalgArc *>(a_geoalgMinor), 0);
	}
      else
	check_geoalgArc(dynamic_cast<geoalgArc *>(a_geoalgMinor), log);
      return;
    }
  if (isA(a_geoalgMinor, geoalgCircle))
    {
      adjustLevels(&geoalgMinorSubs_geoalgCircle, "geoalgCircle");
      if (log && !findString("geoalgCircle", geoalgMinorSubs))
	{
	  warnSub("geoalgCircle", "geoalgMinor", a_geoalgMinor);
	  check_geoalgCircle(
	    dynamic_cast<geoalgCircle *>(a_geoalgMinor), 0);
	}
      else
	check_geoalgCircle(
	  dynamic_cast<geoalgCircle *>(a_geoalgMinor), log);
      return;
    }
  if (isA(a_geoalgMinor, geoalgCone))
    {
      adjustLevels(&geoalgMinorSubs_geoalgCone, "geoalgCone");
      if (log && !findString("geoalgCone", geoalgMinorSubs))
	{
	  warnSub("geoalgCone", "geoalgMinor", a_geoalgMinor);
	  check_geoalgCone(dynamic_cast<geoalgCone *>(a_geoalgMinor), 0);
	}
      else
	check_geoalgCone(dynamic_cast<geoalgCone *>(a_geoalgMinor), log);
      return;
    }
  if (isA(a_geoalgMinor, geoalgConradsegmnt))
    {
      adjustLevels(&geoalgMinorSubs_geoalgConradsegmnt, "geoalgConradsegmnt");
      if (log && !findString("geoalgConradsegmnt", geoalgMinorSubs))
	{
	  warnSub("geoalgConradsegmnt", "geoalgMinor", a_geoalgMinor);
	  check_geoalgConradsegmnt(
	    dynamic_cast<geoalgConradsegmnt *>(a_geoalgMinor), 0);
	}
      else
	check_geoalgConradsegmnt(
	  dynamic_cast<geoalgConradsegmnt *>(a_geoalgMinor), log);
      return;
    }
  if (isA(a_geoalgMinor, geoalgCparln))
    {
      adjustLevels(&geoalgMinorSubs_geoalgCparln, "geoalgCparln");
      if (log && !findString("geoalgCparln", geoalgMinorSubs))
	{
	  warnSub("geoalgCparln", "geoalgMinor", a_geoalgMinor);
	  check_geoalgCparln(
	    dynamic_cast<geoalgCparln *>(a_geoalgMinor), 0);
	}
      else
	check_geoalgCparln(
	  dynamic_cast<geoalgCparln *>(a_geoalgMinor), log);
      return;
    }
  if (isA(a_geoalgMinor, geoalgCylndr))
    {
      adjustLevels(&geoalgMinorSubs_geoalgCylndr, "geoalgCylndr");
      if (log && !findString("geoalgCylndr", geoalgMinorSubs))
	{
	  warnSub("geoalgCylndr", "geoalgMinor", a_geoalgMinor);
	  check_geoalgCylndr(
	    dynamic_cast<geoalgCylndr *>(a_geoalgMinor), 0);
	}
      else
	check_geoalgCylndr(
	  dynamic_cast<geoalgCylndr *>(a_geoalgMinor), log);
      return;
    }
  if (isA(a_geoalgMinor, geoalgCylradsegmnt))
    {
      adjustLevels(&geoalgMinorSubs_geoalgCylradsegmnt, "geoalgCylradsegmnt");
      if (log && !findString("geoalgCylradsegmnt", geoalgMinorSubs))
	{
	  warnSub("geoalgCylradsegmnt", "geoalgMinor", a_geoalgMinor);
	  check_geoalgCylradsegmnt(
	    dynamic_cast<geoalgCylradsegmnt *>(a_geoalgMinor), 0);
	}
      else
	check_geoalgCylradsegmnt(
	  dynamic_cast<geoalgCylradsegmnt *>(a_geoalgMinor), log);
      return;
    }
  if (isA(a_geoalgMinor, geoalgEllips))
    {
      adjustLevels(&geoalgMinorSubs_geoalgEllips, "geoalgEllips");
      if (log && !findString("geoalgEllips", geoalgMinorSubs))
	{
	  warnSub("geoalgEllips", "geoalgMinor", a_geoalgMinor);
	  check_geoalgEllips(
	    dynamic_cast<geoalgEllips *>(a_geoalgMinor), 0);
	}
      else
	check_geoalgEllips(
	  dynamic_cast<geoalgEllips *>(a_geoalgMinor), log);
      return;
    }
  if (isA(a_geoalgMinor, geoalgElongcyl))
    {
      adjustLevels(&geoalgMinorSubs_geoalgElongcyl, "geoalgElongcyl");
      if (log && !findString("geoalgElongcyl", geoalgMinorSubs))
	{
	  warnSub("geoalgElongcyl", "geoalgMinor", a_geoalgMinor);
	  check_geoalgElongcyl(
	    dynamic_cast<geoalgElongcyl *>(a_geoalgMinor), 0);
	}
      else
	check_geoalgElongcyl(
	  dynamic_cast<geoalgElongcyl *>(a_geoalgMinor), log);
      return;
    }
  if (isA(a_geoalgMinor, geoalgGcurve))
    {
      adjustLevels(&geoalgMinorSubs_geoalgGcurve, "geoalgGcurve");
      if (log && !findString("geoalgGcurve", geoalgMinorSubs))
	{
	  warnSub("geoalgGcurve", "geoalgMinor", a_geoalgMinor);
	  check_geoalgGcurve(
	    dynamic_cast<geoalgGcurve *>(a_geoalgMinor), 0);
	}
      else
	check_geoalgGcurve(
	  dynamic_cast<geoalgGcurve *>(a_geoalgMinor), log);
      return;
    }
  if (isA(a_geoalgMinor, geoalgGsurf))
    {
      adjustLevels(&geoalgMinorSubs_geoalgGsurf, "geoalgGsurf");
      if (log && !findString("geoalgGsurf", geoalgMinorSubs))
	{
	  warnSub("geoalgGsurf", "geoalgMinor", a_geoalgMinor);
	  check_geoalgGsurf(dynamic_cast<geoalgGsurf *>(a_geoalgMinor), 0);
	}
      else
	check_geoalgGsurf(dynamic_cast<geoalgGsurf *>(a_geoalgMinor), log);
      return;
    }
  if (isA(a_geoalgMinor, geoalgLine))
    {
      adjustLevels(&geoalgMinorSubs_geoalgLine, "geoalgLine");
      if (log && !findString("geoalgLine", geoalgMinorSubs))
	{
	  warnSub("geoalgLine", "geoalgMinor", a_geoalgMinor);
	  check_geoalgLine(dynamic_cast<geoalgLine *>(a_geoalgMinor), 0);
	}
      else
	check_geoalgLine(dynamic_cast<geoalgLine *>(a_geoalgMinor), log);
      return;
    }
  if (isA(a_geoalgMinor, geoalgObject))
    {
      adjustLevels(&geoalgMinorSubs_geoalgObject, "geoalgObject");
      if (log && !findString("geoalgObject", geoalgMinorSubs))
	{
	  warnSub("geoalgObject", "geoalgMinor", a_geoalgMinor);
	  check_geoalgObject(
	    dynamic_cast<geoalgObject *>(a_geoalgMinor), 0);
	}
      else
	check_geoalgObject(
	  dynamic_cast<geoalgObject *>(a_geoalgMinor), log);
      return;
    }
  if (isA(a_geoalgMinor, geoalgParpln))
    {
      adjustLevels(&geoalgMinorSubs_geoalgParpln, "geoalgParpln");
      if (log && !findString("geoalgParpln", geoalgMinorSubs))
	{
	  warnSub("geoalgParpln", "geoalgMinor", a_geoalgMinor);
	  check_geoalgParpln(
	    dynamic_cast<geoalgParpln *>(a_geoalgMinor), 0);
	}
      else
	check_geoalgParpln(
	  dynamic_cast<geoalgParpln *>(a_geoalgMinor), log);
      return;
    }
  if (isA(a_geoalgMinor, geoalgPlane))
    {
      adjustLevels(&geoalgMinorSubs_geoalgPlane, "geoalgPlane");
      if (log && !findString("geoalgPlane", geoalgMinorSubs))
	{
	  warnSub("geoalgPlane", "geoalgMinor", a_geoalgMinor);
	  check_geoalgPlane(dynamic_cast<geoalgPlane *>(a_geoalgMinor), 0);
	}
      else
	check_geoalgPlane(dynamic_cast<geoalgPlane *>(a_geoalgMinor), log);
      return;
    }
  if (isA(a_geoalgMinor, geoalgRctngl))
    {
      adjustLevels(&geoalgMinorSubs_geoalgRctngl, "geoalgRctngl");
      if (log && !findString("geoalgRctngl", geoalgMinorSubs))
	{
	  warnSub("geoalgRctngl", "geoalgMinor", a_geoalgMinor);
	  check_geoalgRctngl(
	    dynamic_cast<geoalgRctngl *>(a_geoalgMinor), 0);
	}
      else
	check_geoalgRctngl(
	  dynamic_cast<geoalgRctngl *>(a_geoalgMinor), log);
      return;
    }
  if (isA(a_geoalgMinor, geoalgRevsurf))
    {
      adjustLevels(&geoalgMinorSubs_geoalgRevsurf, "geoalgRevsurf");
      if (log && !findString("geoalgRevsurf", geoalgMinorSubs))
	{
	  warnSub("geoalgRevsurf", "geoalgMinor", a_geoalgMinor);
	  check_geoalgRevsurf(
	    dynamic_cast<geoalgRevsurf *>(a_geoalgMinor), 0);
	}
      else
	check_geoalgRevsurf(
	  dynamic_cast<geoalgRevsurf *>(a_geoalgMinor), log);
      return;
    }
  if (isA(a_geoalgMinor, geoalgSphere))
    {
      adjustLevels(&geoalgMinorSubs_geoalgSphere, "geoalgSphere");
      if (log && !findString("geoalgSphere", geoalgMinorSubs))
	{
	  warnSub("geoalgSphere", "geoalgMinor", a_geoalgMinor);
	  check_geoalgSphere(
	    dynamic_cast<geoalgSphere *>(a_geoalgMinor), 0);
	}
      else
	check_geoalgSphere(
	  dynamic_cast<geoalgSphere *>(a_geoalgMinor), log);
      return;
    }
  if (isA(a_geoalgMinor, geoalgSphradsegmnt))
    {
      adjustLevels(&geoalgMinorSubs_geoalgSphradsegmnt, "geoalgSphradsegmnt");
      if (log && !findString("geoalgSphradsegmnt", geoalgMinorSubs))
	{
	  warnSub("geoalgSphradsegmnt", "geoalgMinor", a_geoalgMinor);
	  check_geoalgSphradsegmnt(
	    dynamic_cast<geoalgSphradsegmnt *>(a_geoalgMinor), 0);
	}
      else
	check_geoalgSphradsegmnt(
	  dynamic_cast<geoalgSphradsegmnt *>(a_geoalgMinor), log);
      return;
    }
  if (isA(a_geoalgMinor, geoalgSympln))
    {
      adjustLevels(&geoalgMinorSubs_geoalgSympln, "geoalgSympln");
      if (log && !findString("geoalgSympln", geoalgMinorSubs))
	{
	  warnSub("geoalgSympln", "geoalgMinor", a_geoalgMinor);
	  check_geoalgSympln(
	    dynamic_cast<geoalgSympln *>(a_geoalgMinor), 0);
	}
      else
	check_geoalgSympln(
	  dynamic_cast<geoalgSympln *>(a_geoalgMinor), log);
      return;
    }
  if (isA(a_geoalgMinor, geoalgTorus))
    {
      adjustLevels(&geoalgMinorSubs_geoalgTorus, "geoalgTorus");
      if (log && !findString("geoalgTorus", geoalgMinorSubs))
	{
	  warnSub("geoalgTorus", "geoalgMinor", a_geoalgMinor);
	  check_geoalgTorus(dynamic_cast<geoalgTorus *>(a_geoalgMinor), 0);
	}
      else
	check_geoalgTorus(dynamic_cast<geoalgTorus *>(a_geoalgMinor), log);
      return;
    }
  if (isA(a_geoalgMinor, geoalgTorradsegmnt))
    {
      adjustLevels(&geoalgMinorSubs_geoalgTorradsegmnt, "geoalgTorradsegmnt");
      if (log && !findString("geoalgTorradsegmnt", geoalgMinorSubs))
	{
	  warnSub("geoalgTorradsegmnt", "geoalgMinor", a_geoalgMinor);
	  check_geoalgTorradsegmnt(
	    dynamic_cast<geoalgTorradsegmnt *>(a_geoalgMinor), 0);
	}
      else
	check_geoalgTorradsegmnt(
	  dynamic_cast<geoalgTorradsegmnt *>(a_geoalgMinor), log);
      return;
    }
}

/********************************************************************/

void check_geoalgObject(
 geoalgObject * a_geoalgObject,
 int log)
{
  if (a_geoalgObject->get_geoalgSpec3())
    {
      adjustLevels(&geoalgObjectAtts_a_geoalgSpec3,
		   "geoalgObject a_geoalgSpec3");
      if (log && !findString("a_geoalgSpec3", geoalgObjectAtts))
	{
	  warnAtt("a_geoalgSpec3", "geoalgObject", a_geoalgObject);
	  check_geoalgSpec3(a_geoalgObject->get_geoalgSpec3(), 0);
	}
      else
	check_geoalgSpec3(a_geoalgObject->get_geoalgSpec3(), log);
    }
}

/********************************************************************/

void check_geoalgParpln(
 geoalgParpln * a_geoalgParpln,
 int log)
{
  if (a_geoalgParpln->get_geoalgSpec2())
    {
      adjustLevels(&geoalgParplnAtts_a_geoalgSpec2,
		   "geoalgParpln a_geoalgSpec2");
      if (log && !findString("a_geoalgSpec2", geoalgParplnAtts))
	{
	  warnAtt("a_geoalgSpec2", "geoalgParpln", a_geoalgParpln);
	  check_geoalgSpec2(a_geoalgParpln->get_geoalgSpec2(), 0);
	}
      else
	check_geoalgSpec2(a_geoalgParpln->get_geoalgSpec2(), log);
    }
}

/********************************************************************/

void check_geoalgPlane(
 geoalgPlane * a_geoalgPlane,
 int log)
{
  if (a_geoalgPlane->get_geoalgSpec1())
    {
      adjustLevels(&geoalgPlaneAtts_a_geoalgSpec1,
		   "geoalgPlane a_geoalgSpec1");
      if (log && !findString("a_geoalgSpec1", geoalgPlaneAtts))
	{
	  warnAtt("a_geoalgSpec1", "geoalgPlane", a_geoalgPlane);
	  check_geoalgSpec1(a_geoalgPlane->get_geoalgSpec1(), 0);
	}
      else
	check_geoalgSpec1(a_geoalgPlane->get_geoalgSpec1(), log);
    }
}

/********************************************************************/

void check_geoalgRctngl(
 geoalgRctngl * a_geoalgRctngl,
 int log)
{
  if (a_geoalgRctngl->get_geoalgSpec1())
    {
      adjustLevels(&geoalgRctnglAtts_a_geoalgSpec1,
		   "geoalgRctngl a_geoalgSpec1");
      if (log && !findString("a_geoalgSpec1", geoalgRctnglAtts))
	{
	  warnAtt("a_geoalgSpec1", "geoalgRctngl", a_geoalgRctngl);
	  check_geoalgSpec1(a_geoalgRctngl->get_geoalgSpec1(), 0);
	}
      else
	check_geoalgSpec1(a_geoalgRctngl->get_geoalgSpec1(), log);
    }
}

/********************************************************************/

void check_geoalgRevsurf(
 geoalgRevsurf * a_geoalgRevsurf,
 int log)
{
  if (a_geoalgRevsurf->get_geoalgSpec6())
    {
      adjustLevels(&geoalgRevsurfAtts_a_geoalgSpec6,
		   "geoalgRevsurf a_geoalgSpec6");
      if (log && !findString("a_geoalgSpec6", geoalgRevsurfAtts))
	{
	  warnAtt("a_geoalgSpec6", "geoalgRevsurf", a_geoalgRevsurf);
	  check_geoalgSpec6(a_geoalgRevsurf->get_geoalgSpec6(), 0);
	}
      else
	check_geoalgSpec6(a_geoalgRevsurf->get_geoalgSpec6(), log);
    }
}

/********************************************************************/

void check_geoalgSpec1(
 geoalgSpec1 * a_geoalgSpec1,
 int log)
{
  if (isA(a_geoalgSpec1, geoalgSpec1_LSTSQR))
    {
      adjustLevels(&geoalgSpec1Subs_geoalgSpec1_LSTSQR, "geoalgSpec1_LSTSQR");
      if (log && !findString("geoalgSpec1_LSTSQR", geoalgSpec1Subs))
	{
	  warnSub("geoalgSpec1_LSTSQR", "geoalgSpec1", a_geoalgSpec1);
	  check_geoalgSpec1_LSTSQR(
	    dynamic_cast<geoalgSpec1_LSTSQR *>(a_geoalgSpec1), 0);
	}
      else
	check_geoalgSpec1_LSTSQR(
	  dynamic_cast<geoalgSpec1_LSTSQR *>(a_geoalgSpec1), log);
      return;
    }
  if (isA(a_geoalgSpec1, geoalgSpec1_MINMAX))
    {
      adjustLevels(&geoalgSpec1Subs_geoalgSpec1_MINMAX, "geoalgSpec1_MINMAX");
      if (log && !findString("geoalgSpec1_MINMAX", geoalgSpec1Subs))
	{
	  warnSub("geoalgSpec1_MINMAX", "geoalgSpec1", a_geoalgSpec1);
	  check_geoalgSpec1_MINMAX(
	    dynamic_cast<geoalgSpec1_MINMAX *>(a_geoalgSpec1), 0);
	}
      else
	check_geoalgSpec1_MINMAX(
	  dynamic_cast<geoalgSpec1_MINMAX *>(a_geoalgSpec1), log);
      return;
    }
  if (isA(a_geoalgSpec1, geoalgSpec1_DEFALT))
    {
      adjustLevels(&geoalgSpec1Subs_geoalgSpec1_DEFALT, "geoalgSpec1_DEFALT");
      if (log && !findString("geoalgSpec1_DEFALT", geoalgSpec1Subs))
	{
	  warnSub("geoalgSpec1_DEFALT", "geoalgSpec1", a_geoalgSpec1);
	  check_geoalgSpec1_DEFALT(
	    dynamic_cast<geoalgSpec1_DEFALT *>(a_geoalgSpec1), 0);
	}
      else
	check_geoalgSpec1_DEFALT(
	  dynamic_cast<geoalgSpec1_DEFALT *>(a_geoalgSpec1), log);
      return;
    }
  if (isA(a_geoalgSpec1, geoalgSpec1_EXTERN))
    {
      adjustLevels(&geoalgSpec1Subs_geoalgSpec1_EXTERN, "geoalgSpec1_EXTERN");
      if (log && !findString("geoalgSpec1_EXTERN", geoalgSpec1Subs))
	{
	  warnSub("geoalgSpec1_EXTERN", "geoalgSpec1", a_geoalgSpec1);
	  check_geoalgSpec1_EXTERN(
	    dynamic_cast<geoalgSpec1_EXTERN *>(a_geoalgSpec1), 0);
	}
      else
	check_geoalgSpec1_EXTERN(
	  dynamic_cast<geoalgSpec1_EXTERN *>(a_geoalgSpec1), log);
      return;
    }
}

/********************************************************************/

void check_geoalgSpec1_DEFALT(
 geoalgSpec1_DEFALT * a_geoalgSpec1_DEFALT,
 int log)
{
  if (a_geoalgSpec1_DEFALT->get_geoalgFilterSettings())
    {
      adjustLevels(&geoalgSpec1_DEFALTAtts_a_geoalgFilterSettings,
		   "geoalgSpec1_DEFALT a_geoalgFilterSettings");
      if (log && !findString("a_geoalgFilterSettings", geoalgSpec1_DEFALTAtts))
	{
	  warnAtt("a_geoalgFilterSettings", "geoalgSpec1_DEFALT",
		  a_geoalgSpec1_DEFALT);
	  check_geoalgFilterSettings(
	    a_geoalgSpec1_DEFALT->get_geoalgFilterSettings(), 0);
	}
      else
	check_geoalgFilterSettings(
	  a_geoalgSpec1_DEFALT->get_geoalgFilterSettings(), log);
    }
}

/********************************************************************/

void check_geoalgSpec1_EXTERN(
 geoalgSpec1_EXTERN * a_geoalgSpec1_EXTERN,
 int log)
{
  if (a_geoalgSpec1_EXTERN->get_geoalgExternFunc())
    {
      adjustLevels(&geoalgSpec1_EXTERNAtts_a_geoalgExternFunc,
		   "geoalgSpec1_EXTERN a_geoalgExternFunc");
      if (log && !findString("a_geoalgExternFunc", geoalgSpec1_EXTERNAtts))
	{
	  warnAtt("a_geoalgExternFunc", "geoalgSpec1_EXTERN",
		  a_geoalgSpec1_EXTERN);
	  check_geoalgExternFunc(
	    a_geoalgSpec1_EXTERN->get_geoalgExternFunc(), 0);
	}
      else
	check_geoalgExternFunc(
	  a_geoalgSpec1_EXTERN->get_geoalgExternFunc(), log);
    }
  if (a_geoalgSpec1_EXTERN->get_paramList())
    {
      std::list<param *> * theList;
      std::list<param *>::iterator iter;
      theList = a_geoalgSpec1_EXTERN->get_paramList();
      adjustLevels(&geoalgSpec1_EXTERNAtts_a_paramList,
		   "geoalgSpec1_EXTERN a_paramList");
      if (log && !findString("a_paramList", geoalgSpec1_EXTERNAtts))
	{
	  warnAtt("a_paramList", "geoalgSpec1_EXTERN", a_geoalgSpec1_EXTERN);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_param(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_param(*iter, log);
	}
    }
  if (a_geoalgSpec1_EXTERN->get_geoalgFilterSettings())
    {
      adjustLevels(&geoalgSpec1_EXTERNAtts_a_geoalgFilterSettings,
		   "geoalgSpec1_EXTERN a_geoalgFilterSettings");
      if (log && !findString("a_geoalgFilterSettings", geoalgSpec1_EXTERNAtts))
	{
	  warnAtt("a_geoalgFilterSettings", "geoalgSpec1_EXTERN",
		  a_geoalgSpec1_EXTERN);
	  check_geoalgFilterSettings(
	    a_geoalgSpec1_EXTERN->get_geoalgFilterSettings(), 0);
	}
      else
	check_geoalgFilterSettings(
	  a_geoalgSpec1_EXTERN->get_geoalgFilterSettings(), log);
    }
}

/********************************************************************/

void check_geoalgSpec1_LSTSQR(
 geoalgSpec1_LSTSQR * a_geoalgSpec1_LSTSQR,
 int log)
{
  if (a_geoalgSpec1_LSTSQR->get_geoalgFilterSettings())
    {
      adjustLevels(&geoalgSpec1_LSTSQRAtts_a_geoalgFilterSettings,
		   "geoalgSpec1_LSTSQR a_geoalgFilterSettings");
      if (log && !findString("a_geoalgFilterSettings", geoalgSpec1_LSTSQRAtts))
	{
	  warnAtt("a_geoalgFilterSettings", "geoalgSpec1_LSTSQR",
		  a_geoalgSpec1_LSTSQR);
	  check_geoalgFilterSettings(
	    a_geoalgSpec1_LSTSQR->get_geoalgFilterSettings(), 0);
	}
      else
	check_geoalgFilterSettings(
	  a_geoalgSpec1_LSTSQR->get_geoalgFilterSettings(), log);
    }
}

/********************************************************************/

void check_geoalgSpec1_MINMAX(
 geoalgSpec1_MINMAX * a_geoalgSpec1_MINMAX,
 int log)
{
  if (a_geoalgSpec1_MINMAX->get_geoalgFilterSettings())
    {
      adjustLevels(&geoalgSpec1_MINMAXAtts_a_geoalgFilterSettings,
		   "geoalgSpec1_MINMAX a_geoalgFilterSettings");
      if (log && !findString("a_geoalgFilterSettings", geoalgSpec1_MINMAXAtts))
	{
	  warnAtt("a_geoalgFilterSettings", "geoalgSpec1_MINMAX",
		  a_geoalgSpec1_MINMAX);
	  check_geoalgFilterSettings(
	    a_geoalgSpec1_MINMAX->get_geoalgFilterSettings(), 0);
	}
      else
	check_geoalgFilterSettings(
	  a_geoalgSpec1_MINMAX->get_geoalgFilterSettings(), log);
    }
}

/********************************************************************/

void check_geoalgSpec2(
 geoalgSpec2 * a_geoalgSpec2,
 int log)
{
  if (isA(a_geoalgSpec2, geoalgSpec2_LSTSQR))
    {
      adjustLevels(&geoalgSpec2Subs_geoalgSpec2_LSTSQR, "geoalgSpec2_LSTSQR");
      if (log && !findString("geoalgSpec2_LSTSQR", geoalgSpec2Subs))
	{
	  warnSub("geoalgSpec2_LSTSQR", "geoalgSpec2", a_geoalgSpec2);
	  check_geoalgSpec2_LSTSQR(
	    dynamic_cast<geoalgSpec2_LSTSQR *>(a_geoalgSpec2), 0);
	}
      else
	check_geoalgSpec2_LSTSQR(
	  dynamic_cast<geoalgSpec2_LSTSQR *>(a_geoalgSpec2), log);
      return;
    }
  if (isA(a_geoalgSpec2, geoalgSpec2_MINMAX))
    {
      adjustLevels(&geoalgSpec2Subs_geoalgSpec2_MINMAX, "geoalgSpec2_MINMAX");
      if (log && !findString("geoalgSpec2_MINMAX", geoalgSpec2Subs))
	{
	  warnSub("geoalgSpec2_MINMAX", "geoalgSpec2", a_geoalgSpec2);
	  check_geoalgSpec2_MINMAX(
	    dynamic_cast<geoalgSpec2_MINMAX *>(a_geoalgSpec2), 0);
	}
      else
	check_geoalgSpec2_MINMAX(
	  dynamic_cast<geoalgSpec2_MINMAX *>(a_geoalgSpec2), log);
      return;
    }
  if (isA(a_geoalgSpec2, geoalgSpec2_MAXINS))
    {
      adjustLevels(&geoalgSpec2Subs_geoalgSpec2_MAXINS, "geoalgSpec2_MAXINS");
      if (log && !findString("geoalgSpec2_MAXINS", geoalgSpec2Subs))
	{
	  warnSub("geoalgSpec2_MAXINS", "geoalgSpec2", a_geoalgSpec2);
	  check_geoalgSpec2_MAXINS(
	    dynamic_cast<geoalgSpec2_MAXINS *>(a_geoalgSpec2), 0);
	}
      else
	check_geoalgSpec2_MAXINS(
	  dynamic_cast<geoalgSpec2_MAXINS *>(a_geoalgSpec2), log);
      return;
    }
  if (isA(a_geoalgSpec2, geoalgSpec2_MINCIR))
    {
      adjustLevels(&geoalgSpec2Subs_geoalgSpec2_MINCIR, "geoalgSpec2_MINCIR");
      if (log && !findString("geoalgSpec2_MINCIR", geoalgSpec2Subs))
	{
	  warnSub("geoalgSpec2_MINCIR", "geoalgSpec2", a_geoalgSpec2);
	  check_geoalgSpec2_MINCIR(
	    dynamic_cast<geoalgSpec2_MINCIR *>(a_geoalgSpec2), 0);
	}
      else
	check_geoalgSpec2_MINCIR(
	  dynamic_cast<geoalgSpec2_MINCIR *>(a_geoalgSpec2), log);
      return;
    }
  if (isA(a_geoalgSpec2, geoalgSpec2_DEFALT))
    {
      adjustLevels(&geoalgSpec2Subs_geoalgSpec2_DEFALT, "geoalgSpec2_DEFALT");
      if (log && !findString("geoalgSpec2_DEFALT", geoalgSpec2Subs))
	{
	  warnSub("geoalgSpec2_DEFALT", "geoalgSpec2", a_geoalgSpec2);
	  check_geoalgSpec2_DEFALT(
	    dynamic_cast<geoalgSpec2_DEFALT *>(a_geoalgSpec2), 0);
	}
      else
	check_geoalgSpec2_DEFALT(
	  dynamic_cast<geoalgSpec2_DEFALT *>(a_geoalgSpec2), log);
      return;
    }
  if (isA(a_geoalgSpec2, geoalgSpec2_EXTERN))
    {
      adjustLevels(&geoalgSpec2Subs_geoalgSpec2_EXTERN, "geoalgSpec2_EXTERN");
      if (log && !findString("geoalgSpec2_EXTERN", geoalgSpec2Subs))
	{
	  warnSub("geoalgSpec2_EXTERN", "geoalgSpec2", a_geoalgSpec2);
	  check_geoalgSpec2_EXTERN(
	    dynamic_cast<geoalgSpec2_EXTERN *>(a_geoalgSpec2), 0);
	}
      else
	check_geoalgSpec2_EXTERN(
	  dynamic_cast<geoalgSpec2_EXTERN *>(a_geoalgSpec2), log);
      return;
    }
}

/********************************************************************/

void check_geoalgSpec2_DEFALT(
 geoalgSpec2_DEFALT * a_geoalgSpec2_DEFALT,
 int log)
{
  if (a_geoalgSpec2_DEFALT->get_geoalgFilterSettings())
    {
      adjustLevels(&geoalgSpec2_DEFALTAtts_a_geoalgFilterSettings,
		   "geoalgSpec2_DEFALT a_geoalgFilterSettings");
      if (log && !findString("a_geoalgFilterSettings", geoalgSpec2_DEFALTAtts))
	{
	  warnAtt("a_geoalgFilterSettings", "geoalgSpec2_DEFALT",
		  a_geoalgSpec2_DEFALT);
	  check_geoalgFilterSettings(
	    a_geoalgSpec2_DEFALT->get_geoalgFilterSettings(), 0);
	}
      else
	check_geoalgFilterSettings(
	  a_geoalgSpec2_DEFALT->get_geoalgFilterSettings(), log);
    }
}

/********************************************************************/

void check_geoalgSpec2_EXTERN(
 geoalgSpec2_EXTERN * a_geoalgSpec2_EXTERN,
 int log)
{
  if (a_geoalgSpec2_EXTERN->get_geoalgExternFunc())
    {
      adjustLevels(&geoalgSpec2_EXTERNAtts_a_geoalgExternFunc,
		   "geoalgSpec2_EXTERN a_geoalgExternFunc");
      if (log && !findString("a_geoalgExternFunc", geoalgSpec2_EXTERNAtts))
	{
	  warnAtt("a_geoalgExternFunc", "geoalgSpec2_EXTERN",
		  a_geoalgSpec2_EXTERN);
	  check_geoalgExternFunc(
	    a_geoalgSpec2_EXTERN->get_geoalgExternFunc(), 0);
	}
      else
	check_geoalgExternFunc(
	  a_geoalgSpec2_EXTERN->get_geoalgExternFunc(), log);
    }
  if (a_geoalgSpec2_EXTERN->get_paramList())
    {
      std::list<param *> * theList;
      std::list<param *>::iterator iter;
      theList = a_geoalgSpec2_EXTERN->get_paramList();
      adjustLevels(&geoalgSpec2_EXTERNAtts_a_paramList,
		   "geoalgSpec2_EXTERN a_paramList");
      if (log && !findString("a_paramList", geoalgSpec2_EXTERNAtts))
	{
	  warnAtt("a_paramList", "geoalgSpec2_EXTERN", a_geoalgSpec2_EXTERN);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_param(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_param(*iter, log);
	}
    }
  if (a_geoalgSpec2_EXTERN->get_geoalgFilterSettings())
    {
      adjustLevels(&geoalgSpec2_EXTERNAtts_a_geoalgFilterSettings,
		   "geoalgSpec2_EXTERN a_geoalgFilterSettings");
      if (log && !findString("a_geoalgFilterSettings", geoalgSpec2_EXTERNAtts))
	{
	  warnAtt("a_geoalgFilterSettings", "geoalgSpec2_EXTERN",
		  a_geoalgSpec2_EXTERN);
	  check_geoalgFilterSettings(
	    a_geoalgSpec2_EXTERN->get_geoalgFilterSettings(), 0);
	}
      else
	check_geoalgFilterSettings(
	  a_geoalgSpec2_EXTERN->get_geoalgFilterSettings(), log);
    }
}

/********************************************************************/

void check_geoalgSpec2_LSTSQR(
 geoalgSpec2_LSTSQR * a_geoalgSpec2_LSTSQR,
 int log)
{
  if (a_geoalgSpec2_LSTSQR->get_geoalgFilterSettings())
    {
      adjustLevels(&geoalgSpec2_LSTSQRAtts_a_geoalgFilterSettings,
		   "geoalgSpec2_LSTSQR a_geoalgFilterSettings");
      if (log && !findString("a_geoalgFilterSettings", geoalgSpec2_LSTSQRAtts))
	{
	  warnAtt("a_geoalgFilterSettings", "geoalgSpec2_LSTSQR",
		  a_geoalgSpec2_LSTSQR);
	  check_geoalgFilterSettings(
	    a_geoalgSpec2_LSTSQR->get_geoalgFilterSettings(), 0);
	}
      else
	check_geoalgFilterSettings(
	  a_geoalgSpec2_LSTSQR->get_geoalgFilterSettings(), log);
    }
}

/********************************************************************/

void check_geoalgSpec2_MAXINS(
 geoalgSpec2_MAXINS * a_geoalgSpec2_MAXINS,
 int log)
{
  if (a_geoalgSpec2_MAXINS->get_geoalgFilterSettings())
    {
      adjustLevels(&geoalgSpec2_MAXINSAtts_a_geoalgFilterSettings,
		   "geoalgSpec2_MAXINS a_geoalgFilterSettings");
      if (log && !findString("a_geoalgFilterSettings", geoalgSpec2_MAXINSAtts))
	{
	  warnAtt("a_geoalgFilterSettings", "geoalgSpec2_MAXINS",
		  a_geoalgSpec2_MAXINS);
	  check_geoalgFilterSettings(
	    a_geoalgSpec2_MAXINS->get_geoalgFilterSettings(), 0);
	}
      else
	check_geoalgFilterSettings(
	  a_geoalgSpec2_MAXINS->get_geoalgFilterSettings(), log);
    }
}

/********************************************************************/

void check_geoalgSpec2_MINCIR(
 geoalgSpec2_MINCIR * a_geoalgSpec2_MINCIR,
 int log)
{
  if (a_geoalgSpec2_MINCIR->get_geoalgFilterSettings())
    {
      adjustLevels(&geoalgSpec2_MINCIRAtts_a_geoalgFilterSettings,
		   "geoalgSpec2_MINCIR a_geoalgFilterSettings");
      if (log && !findString("a_geoalgFilterSettings", geoalgSpec2_MINCIRAtts))
	{
	  warnAtt("a_geoalgFilterSettings", "geoalgSpec2_MINCIR",
		  a_geoalgSpec2_MINCIR);
	  check_geoalgFilterSettings(
	    a_geoalgSpec2_MINCIR->get_geoalgFilterSettings(), 0);
	}
      else
	check_geoalgFilterSettings(
	  a_geoalgSpec2_MINCIR->get_geoalgFilterSettings(), log);
    }
}

/********************************************************************/

void check_geoalgSpec2_MINMAX(
 geoalgSpec2_MINMAX * a_geoalgSpec2_MINMAX,
 int log)
{
  if (a_geoalgSpec2_MINMAX->get_geoalgFilterSettings())
    {
      adjustLevels(&geoalgSpec2_MINMAXAtts_a_geoalgFilterSettings,
		   "geoalgSpec2_MINMAX a_geoalgFilterSettings");
      if (log && !findString("a_geoalgFilterSettings", geoalgSpec2_MINMAXAtts))
	{
	  warnAtt("a_geoalgFilterSettings", "geoalgSpec2_MINMAX",
		  a_geoalgSpec2_MINMAX);
	  check_geoalgFilterSettings(
	    a_geoalgSpec2_MINMAX->get_geoalgFilterSettings(), 0);
	}
      else
	check_geoalgFilterSettings(
	  a_geoalgSpec2_MINMAX->get_geoalgFilterSettings(), log);
    }
}

/********************************************************************/

void check_geoalgSpec3(
 geoalgSpec3 * a_geoalgSpec3,
 int log)
{
  if (isA(a_geoalgSpec3, geoalgSpec3_DEFALT))
    {
      adjustLevels(&geoalgSpec3Subs_geoalgSpec3_DEFALT, "geoalgSpec3_DEFALT");
      if (log && !findString("geoalgSpec3_DEFALT", geoalgSpec3Subs))
	{
	  warnSub("geoalgSpec3_DEFALT", "geoalgSpec3", a_geoalgSpec3);
	  check_geoalgSpec3_DEFALT(
	    dynamic_cast<geoalgSpec3_DEFALT *>(a_geoalgSpec3), 0);
	}
      else
	check_geoalgSpec3_DEFALT(
	  dynamic_cast<geoalgSpec3_DEFALT *>(a_geoalgSpec3), log);
      return;
    }
  if (isA(a_geoalgSpec3, geoalgSpec3_EXTERN))
    {
      adjustLevels(&geoalgSpec3Subs_geoalgSpec3_EXTERN, "geoalgSpec3_EXTERN");
      if (log && !findString("geoalgSpec3_EXTERN", geoalgSpec3Subs))
	{
	  warnSub("geoalgSpec3_EXTERN", "geoalgSpec3", a_geoalgSpec3);
	  check_geoalgSpec3_EXTERN(
	    dynamic_cast<geoalgSpec3_EXTERN *>(a_geoalgSpec3), 0);
	}
      else
	check_geoalgSpec3_EXTERN(
	  dynamic_cast<geoalgSpec3_EXTERN *>(a_geoalgSpec3), log);
      return;
    }
}

/********************************************************************/

void check_geoalgSpec3_DEFALT(
 geoalgSpec3_DEFALT * a_geoalgSpec3_DEFALT,
 int log)
{
  if (a_geoalgSpec3_DEFALT->get_geoalgFilterSettings())
    {
      adjustLevels(&geoalgSpec3_DEFALTAtts_a_geoalgFilterSettings,
		   "geoalgSpec3_DEFALT a_geoalgFilterSettings");
      if (log && !findString("a_geoalgFilterSettings", geoalgSpec3_DEFALTAtts))
	{
	  warnAtt("a_geoalgFilterSettings", "geoalgSpec3_DEFALT",
		  a_geoalgSpec3_DEFALT);
	  check_geoalgFilterSettings(
	    a_geoalgSpec3_DEFALT->get_geoalgFilterSettings(), 0);
	}
      else
	check_geoalgFilterSettings(
	  a_geoalgSpec3_DEFALT->get_geoalgFilterSettings(), log);
    }
}

/********************************************************************/

void check_geoalgSpec3_EXTERN(
 geoalgSpec3_EXTERN * a_geoalgSpec3_EXTERN,
 int log)
{
  if (a_geoalgSpec3_EXTERN->get_geoalgExternFunc())
    {
      adjustLevels(&geoalgSpec3_EXTERNAtts_a_geoalgExternFunc,
		   "geoalgSpec3_EXTERN a_geoalgExternFunc");
      if (log && !findString("a_geoalgExternFunc", geoalgSpec3_EXTERNAtts))
	{
	  warnAtt("a_geoalgExternFunc", "geoalgSpec3_EXTERN",
		  a_geoalgSpec3_EXTERN);
	  check_geoalgExternFunc(
	    a_geoalgSpec3_EXTERN->get_geoalgExternFunc(), 0);
	}
      else
	check_geoalgExternFunc(
	  a_geoalgSpec3_EXTERN->get_geoalgExternFunc(), log);
    }
  if (a_geoalgSpec3_EXTERN->get_paramList())
    {
      std::list<param *> * theList;
      std::list<param *>::iterator iter;
      theList = a_geoalgSpec3_EXTERN->get_paramList();
      adjustLevels(&geoalgSpec3_EXTERNAtts_a_paramList,
		   "geoalgSpec3_EXTERN a_paramList");
      if (log && !findString("a_paramList", geoalgSpec3_EXTERNAtts))
	{
	  warnAtt("a_paramList", "geoalgSpec3_EXTERN", a_geoalgSpec3_EXTERN);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_param(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_param(*iter, log);
	}
    }
  if (a_geoalgSpec3_EXTERN->get_geoalgFilterSettings())
    {
      adjustLevels(&geoalgSpec3_EXTERNAtts_a_geoalgFilterSettings,
		   "geoalgSpec3_EXTERN a_geoalgFilterSettings");
      if (log && !findString("a_geoalgFilterSettings", geoalgSpec3_EXTERNAtts))
	{
	  warnAtt("a_geoalgFilterSettings", "geoalgSpec3_EXTERN",
		  a_geoalgSpec3_EXTERN);
	  check_geoalgFilterSettings(
	    a_geoalgSpec3_EXTERN->get_geoalgFilterSettings(), 0);
	}
      else
	check_geoalgFilterSettings(
	  a_geoalgSpec3_EXTERN->get_geoalgFilterSettings(), log);
    }
}

/********************************************************************/

void check_geoalgSpec4(
 geoalgSpec4 * a_geoalgSpec4,
 int log)
{
  if (isA(a_geoalgSpec4, geoalgSpec4_LSTSQR))
    {
      adjustLevels(&geoalgSpec4Subs_geoalgSpec4_LSTSQR, "geoalgSpec4_LSTSQR");
      if (log && !findString("geoalgSpec4_LSTSQR", geoalgSpec4Subs))
	{
	  warnSub("geoalgSpec4_LSTSQR", "geoalgSpec4", a_geoalgSpec4);
	  check_geoalgSpec4_LSTSQR(
	    dynamic_cast<geoalgSpec4_LSTSQR *>(a_geoalgSpec4), 0);
	}
      else
	check_geoalgSpec4_LSTSQR(
	  dynamic_cast<geoalgSpec4_LSTSQR *>(a_geoalgSpec4), log);
      return;
    }
  if (isA(a_geoalgSpec4, geoalgSpec4_MINMAX))
    {
      adjustLevels(&geoalgSpec4Subs_geoalgSpec4_MINMAX, "geoalgSpec4_MINMAX");
      if (log && !findString("geoalgSpec4_MINMAX", geoalgSpec4Subs))
	{
	  warnSub("geoalgSpec4_MINMAX", "geoalgSpec4", a_geoalgSpec4);
	  check_geoalgSpec4_MINMAX(
	    dynamic_cast<geoalgSpec4_MINMAX *>(a_geoalgSpec4), 0);
	}
      else
	check_geoalgSpec4_MINMAX(
	  dynamic_cast<geoalgSpec4_MINMAX *>(a_geoalgSpec4), log);
      return;
    }
  if (isA(a_geoalgSpec4, geoalgSpec4_BSPLIN))
    {
      adjustLevels(&geoalgSpec4Subs_geoalgSpec4_BSPLIN, "geoalgSpec4_BSPLIN");
      if (log && !findString("geoalgSpec4_BSPLIN", geoalgSpec4Subs))
	{
	  warnSub("geoalgSpec4_BSPLIN", "geoalgSpec4", a_geoalgSpec4);
	  check_geoalgSpec4_BSPLIN(
	    dynamic_cast<geoalgSpec4_BSPLIN *>(a_geoalgSpec4), 0);
	}
      else
	check_geoalgSpec4_BSPLIN(
	  dynamic_cast<geoalgSpec4_BSPLIN *>(a_geoalgSpec4), log);
      return;
    }
  if (isA(a_geoalgSpec4, geoalgSpec4_DEFALT))
    {
      adjustLevels(&geoalgSpec4Subs_geoalgSpec4_DEFALT, "geoalgSpec4_DEFALT");
      if (log && !findString("geoalgSpec4_DEFALT", geoalgSpec4Subs))
	{
	  warnSub("geoalgSpec4_DEFALT", "geoalgSpec4", a_geoalgSpec4);
	  check_geoalgSpec4_DEFALT(
	    dynamic_cast<geoalgSpec4_DEFALT *>(a_geoalgSpec4), 0);
	}
      else
	check_geoalgSpec4_DEFALT(
	  dynamic_cast<geoalgSpec4_DEFALT *>(a_geoalgSpec4), log);
      return;
    }
  if (isA(a_geoalgSpec4, geoalgSpec4_EXTERN))
    {
      adjustLevels(&geoalgSpec4Subs_geoalgSpec4_EXTERN, "geoalgSpec4_EXTERN");
      if (log && !findString("geoalgSpec4_EXTERN", geoalgSpec4Subs))
	{
	  warnSub("geoalgSpec4_EXTERN", "geoalgSpec4", a_geoalgSpec4);
	  check_geoalgSpec4_EXTERN(
	    dynamic_cast<geoalgSpec4_EXTERN *>(a_geoalgSpec4), 0);
	}
      else
	check_geoalgSpec4_EXTERN(
	  dynamic_cast<geoalgSpec4_EXTERN *>(a_geoalgSpec4), log);
      return;
    }
}

/********************************************************************/

void check_geoalgSpec4_BSPLIN(
 geoalgSpec4_BSPLIN * a_geoalgSpec4_BSPLIN,
 int log)
{
  if (a_geoalgSpec4_BSPLIN->get_geoalgFilterSettings())
    {
      adjustLevels(&geoalgSpec4_BSPLINAtts_a_geoalgFilterSettings,
		   "geoalgSpec4_BSPLIN a_geoalgFilterSettings");
      if (log && !findString("a_geoalgFilterSettings", geoalgSpec4_BSPLINAtts))
	{
	  warnAtt("a_geoalgFilterSettings", "geoalgSpec4_BSPLIN",
		  a_geoalgSpec4_BSPLIN);
	  check_geoalgFilterSettings(
	    a_geoalgSpec4_BSPLIN->get_geoalgFilterSettings(), 0);
	}
      else
	check_geoalgFilterSettings(
	  a_geoalgSpec4_BSPLIN->get_geoalgFilterSettings(), log);
    }
}

/********************************************************************/

void check_geoalgSpec4_DEFALT(
 geoalgSpec4_DEFALT * a_geoalgSpec4_DEFALT,
 int log)
{
  if (a_geoalgSpec4_DEFALT->get_geoalgFilterSettings())
    {
      adjustLevels(&geoalgSpec4_DEFALTAtts_a_geoalgFilterSettings,
		   "geoalgSpec4_DEFALT a_geoalgFilterSettings");
      if (log && !findString("a_geoalgFilterSettings", geoalgSpec4_DEFALTAtts))
	{
	  warnAtt("a_geoalgFilterSettings", "geoalgSpec4_DEFALT",
		  a_geoalgSpec4_DEFALT);
	  check_geoalgFilterSettings(
	    a_geoalgSpec4_DEFALT->get_geoalgFilterSettings(), 0);
	}
      else
	check_geoalgFilterSettings(
	  a_geoalgSpec4_DEFALT->get_geoalgFilterSettings(), log);
    }
}

/********************************************************************/

void check_geoalgSpec4_EXTERN(
 geoalgSpec4_EXTERN * a_geoalgSpec4_EXTERN,
 int log)
{
  if (a_geoalgSpec4_EXTERN->get_geoalgExternFunc())
    {
      adjustLevels(&geoalgSpec4_EXTERNAtts_a_geoalgExternFunc,
		   "geoalgSpec4_EXTERN a_geoalgExternFunc");
      if (log && !findString("a_geoalgExternFunc", geoalgSpec4_EXTERNAtts))
	{
	  warnAtt("a_geoalgExternFunc", "geoalgSpec4_EXTERN",
		  a_geoalgSpec4_EXTERN);
	  check_geoalgExternFunc(
	    a_geoalgSpec4_EXTERN->get_geoalgExternFunc(), 0);
	}
      else
	check_geoalgExternFunc(
	  a_geoalgSpec4_EXTERN->get_geoalgExternFunc(), log);
    }
  if (a_geoalgSpec4_EXTERN->get_paramList())
    {
      std::list<param *> * theList;
      std::list<param *>::iterator iter;
      theList = a_geoalgSpec4_EXTERN->get_paramList();
      adjustLevels(&geoalgSpec4_EXTERNAtts_a_paramList,
		   "geoalgSpec4_EXTERN a_paramList");
      if (log && !findString("a_paramList", geoalgSpec4_EXTERNAtts))
	{
	  warnAtt("a_paramList", "geoalgSpec4_EXTERN", a_geoalgSpec4_EXTERN);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_param(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_param(*iter, log);
	}
    }
  if (a_geoalgSpec4_EXTERN->get_geoalgFilterSettings())
    {
      adjustLevels(&geoalgSpec4_EXTERNAtts_a_geoalgFilterSettings,
		   "geoalgSpec4_EXTERN a_geoalgFilterSettings");
      if (log && !findString("a_geoalgFilterSettings", geoalgSpec4_EXTERNAtts))
	{
	  warnAtt("a_geoalgFilterSettings", "geoalgSpec4_EXTERN",
		  a_geoalgSpec4_EXTERN);
	  check_geoalgFilterSettings(
	    a_geoalgSpec4_EXTERN->get_geoalgFilterSettings(), 0);
	}
      else
	check_geoalgFilterSettings(
	  a_geoalgSpec4_EXTERN->get_geoalgFilterSettings(), log);
    }
}

/********************************************************************/

void check_geoalgSpec4_LSTSQR(
 geoalgSpec4_LSTSQR * a_geoalgSpec4_LSTSQR,
 int log)
{
  if (a_geoalgSpec4_LSTSQR->get_geoalgFilterSettings())
    {
      adjustLevels(&geoalgSpec4_LSTSQRAtts_a_geoalgFilterSettings,
		   "geoalgSpec4_LSTSQR a_geoalgFilterSettings");
      if (log && !findString("a_geoalgFilterSettings", geoalgSpec4_LSTSQRAtts))
	{
	  warnAtt("a_geoalgFilterSettings", "geoalgSpec4_LSTSQR",
		  a_geoalgSpec4_LSTSQR);
	  check_geoalgFilterSettings(
	    a_geoalgSpec4_LSTSQR->get_geoalgFilterSettings(), 0);
	}
      else
	check_geoalgFilterSettings(
	  a_geoalgSpec4_LSTSQR->get_geoalgFilterSettings(), log);
    }
}

/********************************************************************/

void check_geoalgSpec4_MINMAX(
 geoalgSpec4_MINMAX * a_geoalgSpec4_MINMAX,
 int log)
{
  if (a_geoalgSpec4_MINMAX->get_geoalgFilterSettings())
    {
      adjustLevels(&geoalgSpec4_MINMAXAtts_a_geoalgFilterSettings,
		   "geoalgSpec4_MINMAX a_geoalgFilterSettings");
      if (log && !findString("a_geoalgFilterSettings", geoalgSpec4_MINMAXAtts))
	{
	  warnAtt("a_geoalgFilterSettings", "geoalgSpec4_MINMAX",
		  a_geoalgSpec4_MINMAX);
	  check_geoalgFilterSettings(
	    a_geoalgSpec4_MINMAX->get_geoalgFilterSettings(), 0);
	}
      else
	check_geoalgFilterSettings(
	  a_geoalgSpec4_MINMAX->get_geoalgFilterSettings(), log);
    }
}

/********************************************************************/

void check_geoalgSpec5(
 geoalgSpec5 * a_geoalgSpec5,
 int log)
{
  if (isA(a_geoalgSpec5, geoalgSpec5_LSTSQR))
    {
      adjustLevels(&geoalgSpec5Subs_geoalgSpec5_LSTSQR, "geoalgSpec5_LSTSQR");
      if (log && !findString("geoalgSpec5_LSTSQR", geoalgSpec5Subs))
	{
	  warnSub("geoalgSpec5_LSTSQR", "geoalgSpec5", a_geoalgSpec5);
	  check_geoalgSpec5_LSTSQR(
	    dynamic_cast<geoalgSpec5_LSTSQR *>(a_geoalgSpec5), 0);
	}
      else
	check_geoalgSpec5_LSTSQR(
	  dynamic_cast<geoalgSpec5_LSTSQR *>(a_geoalgSpec5), log);
      return;
    }
  if (isA(a_geoalgSpec5, geoalgSpec5_MINMAX))
    {
      adjustLevels(&geoalgSpec5Subs_geoalgSpec5_MINMAX, "geoalgSpec5_MINMAX");
      if (log && !findString("geoalgSpec5_MINMAX", geoalgSpec5Subs))
	{
	  warnSub("geoalgSpec5_MINMAX", "geoalgSpec5", a_geoalgSpec5);
	  check_geoalgSpec5_MINMAX(
	    dynamic_cast<geoalgSpec5_MINMAX *>(a_geoalgSpec5), 0);
	}
      else
	check_geoalgSpec5_MINMAX(
	  dynamic_cast<geoalgSpec5_MINMAX *>(a_geoalgSpec5), log);
      return;
    }
  if (isA(a_geoalgSpec5, geoalgSpec5_BEZIER))
    {
      adjustLevels(&geoalgSpec5Subs_geoalgSpec5_BEZIER, "geoalgSpec5_BEZIER");
      if (log && !findString("geoalgSpec5_BEZIER", geoalgSpec5Subs))
	{
	  warnSub("geoalgSpec5_BEZIER", "geoalgSpec5", a_geoalgSpec5);
	  check_geoalgSpec5_BEZIER(
	    dynamic_cast<geoalgSpec5_BEZIER *>(a_geoalgSpec5), 0);
	}
      else
	check_geoalgSpec5_BEZIER(
	  dynamic_cast<geoalgSpec5_BEZIER *>(a_geoalgSpec5), log);
      return;
    }
  if (isA(a_geoalgSpec5, geoalgSpec5_NURBS))
    {
      adjustLevels(&geoalgSpec5Subs_geoalgSpec5_NURBS, "geoalgSpec5_NURBS");
      if (log && !findString("geoalgSpec5_NURBS", geoalgSpec5Subs))
	{
	  warnSub("geoalgSpec5_NURBS", "geoalgSpec5", a_geoalgSpec5);
	  check_geoalgSpec5_NURBS(
	    dynamic_cast<geoalgSpec5_NURBS *>(a_geoalgSpec5), 0);
	}
      else
	check_geoalgSpec5_NURBS(
	  dynamic_cast<geoalgSpec5_NURBS *>(a_geoalgSpec5), log);
      return;
    }
  if (isA(a_geoalgSpec5, geoalgSpec5_DEFALT))
    {
      adjustLevels(&geoalgSpec5Subs_geoalgSpec5_DEFALT, "geoalgSpec5_DEFALT");
      if (log && !findString("geoalgSpec5_DEFALT", geoalgSpec5Subs))
	{
	  warnSub("geoalgSpec5_DEFALT", "geoalgSpec5", a_geoalgSpec5);
	  check_geoalgSpec5_DEFALT(
	    dynamic_cast<geoalgSpec5_DEFALT *>(a_geoalgSpec5), 0);
	}
      else
	check_geoalgSpec5_DEFALT(
	  dynamic_cast<geoalgSpec5_DEFALT *>(a_geoalgSpec5), log);
      return;
    }
  if (isA(a_geoalgSpec5, geoalgSpec5_EXTERN))
    {
      adjustLevels(&geoalgSpec5Subs_geoalgSpec5_EXTERN, "geoalgSpec5_EXTERN");
      if (log && !findString("geoalgSpec5_EXTERN", geoalgSpec5Subs))
	{
	  warnSub("geoalgSpec5_EXTERN", "geoalgSpec5", a_geoalgSpec5);
	  check_geoalgSpec5_EXTERN(
	    dynamic_cast<geoalgSpec5_EXTERN *>(a_geoalgSpec5), 0);
	}
      else
	check_geoalgSpec5_EXTERN(
	  dynamic_cast<geoalgSpec5_EXTERN *>(a_geoalgSpec5), log);
      return;
    }
}

/********************************************************************/

void check_geoalgSpec5_BEZIER(
 geoalgSpec5_BEZIER * a_geoalgSpec5_BEZIER,
 int log)
{
  if (a_geoalgSpec5_BEZIER->get_geoalgFilterSettings())
    {
      adjustLevels(&geoalgSpec5_BEZIERAtts_a_geoalgFilterSettings,
		   "geoalgSpec5_BEZIER a_geoalgFilterSettings");
      if (log && !findString("a_geoalgFilterSettings", geoalgSpec5_BEZIERAtts))
	{
	  warnAtt("a_geoalgFilterSettings", "geoalgSpec5_BEZIER",
		  a_geoalgSpec5_BEZIER);
	  check_geoalgFilterSettings(
	    a_geoalgSpec5_BEZIER->get_geoalgFilterSettings(), 0);
	}
      else
	check_geoalgFilterSettings(
	  a_geoalgSpec5_BEZIER->get_geoalgFilterSettings(), log);
    }
}

/********************************************************************/

void check_geoalgSpec5_DEFALT(
 geoalgSpec5_DEFALT * a_geoalgSpec5_DEFALT,
 int log)
{
  if (a_geoalgSpec5_DEFALT->get_geoalgFilterSettings())
    {
      adjustLevels(&geoalgSpec5_DEFALTAtts_a_geoalgFilterSettings,
		   "geoalgSpec5_DEFALT a_geoalgFilterSettings");
      if (log && !findString("a_geoalgFilterSettings", geoalgSpec5_DEFALTAtts))
	{
	  warnAtt("a_geoalgFilterSettings", "geoalgSpec5_DEFALT",
		  a_geoalgSpec5_DEFALT);
	  check_geoalgFilterSettings(
	    a_geoalgSpec5_DEFALT->get_geoalgFilterSettings(), 0);
	}
      else
	check_geoalgFilterSettings(
	  a_geoalgSpec5_DEFALT->get_geoalgFilterSettings(), log);
    }
}

/********************************************************************/

void check_geoalgSpec5_EXTERN(
 geoalgSpec5_EXTERN * a_geoalgSpec5_EXTERN,
 int log)
{
  if (a_geoalgSpec5_EXTERN->get_geoalgExternFunc())
    {
      adjustLevels(&geoalgSpec5_EXTERNAtts_a_geoalgExternFunc,
		   "geoalgSpec5_EXTERN a_geoalgExternFunc");
      if (log && !findString("a_geoalgExternFunc", geoalgSpec5_EXTERNAtts))
	{
	  warnAtt("a_geoalgExternFunc", "geoalgSpec5_EXTERN",
		  a_geoalgSpec5_EXTERN);
	  check_geoalgExternFunc(
	    a_geoalgSpec5_EXTERN->get_geoalgExternFunc(), 0);
	}
      else
	check_geoalgExternFunc(
	  a_geoalgSpec5_EXTERN->get_geoalgExternFunc(), log);
    }
  if (a_geoalgSpec5_EXTERN->get_paramList())
    {
      std::list<param *> * theList;
      std::list<param *>::iterator iter;
      theList = a_geoalgSpec5_EXTERN->get_paramList();
      adjustLevels(&geoalgSpec5_EXTERNAtts_a_paramList,
		   "geoalgSpec5_EXTERN a_paramList");
      if (log && !findString("a_paramList", geoalgSpec5_EXTERNAtts))
	{
	  warnAtt("a_paramList", "geoalgSpec5_EXTERN", a_geoalgSpec5_EXTERN);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_param(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_param(*iter, log);
	}
    }
  if (a_geoalgSpec5_EXTERN->get_geoalgFilterSettings())
    {
      adjustLevels(&geoalgSpec5_EXTERNAtts_a_geoalgFilterSettings,
		   "geoalgSpec5_EXTERN a_geoalgFilterSettings");
      if (log && !findString("a_geoalgFilterSettings", geoalgSpec5_EXTERNAtts))
	{
	  warnAtt("a_geoalgFilterSettings", "geoalgSpec5_EXTERN",
		  a_geoalgSpec5_EXTERN);
	  check_geoalgFilterSettings(
	    a_geoalgSpec5_EXTERN->get_geoalgFilterSettings(), 0);
	}
      else
	check_geoalgFilterSettings(
	  a_geoalgSpec5_EXTERN->get_geoalgFilterSettings(), log);
    }
}

/********************************************************************/

void check_geoalgSpec5_LSTSQR(
 geoalgSpec5_LSTSQR * a_geoalgSpec5_LSTSQR,
 int log)
{
  if (a_geoalgSpec5_LSTSQR->get_geoalgFilterSettings())
    {
      adjustLevels(&geoalgSpec5_LSTSQRAtts_a_geoalgFilterSettings,
		   "geoalgSpec5_LSTSQR a_geoalgFilterSettings");
      if (log && !findString("a_geoalgFilterSettings", geoalgSpec5_LSTSQRAtts))
	{
	  warnAtt("a_geoalgFilterSettings", "geoalgSpec5_LSTSQR",
		  a_geoalgSpec5_LSTSQR);
	  check_geoalgFilterSettings(
	    a_geoalgSpec5_LSTSQR->get_geoalgFilterSettings(), 0);
	}
      else
	check_geoalgFilterSettings(
	  a_geoalgSpec5_LSTSQR->get_geoalgFilterSettings(), log);
    }
}

/********************************************************************/

void check_geoalgSpec5_MINMAX(
 geoalgSpec5_MINMAX * a_geoalgSpec5_MINMAX,
 int log)
{
  if (a_geoalgSpec5_MINMAX->get_geoalgFilterSettings())
    {
      adjustLevels(&geoalgSpec5_MINMAXAtts_a_geoalgFilterSettings,
		   "geoalgSpec5_MINMAX a_geoalgFilterSettings");
      if (log && !findString("a_geoalgFilterSettings", geoalgSpec5_MINMAXAtts))
	{
	  warnAtt("a_geoalgFilterSettings", "geoalgSpec5_MINMAX",
		  a_geoalgSpec5_MINMAX);
	  check_geoalgFilterSettings(
	    a_geoalgSpec5_MINMAX->get_geoalgFilterSettings(), 0);
	}
      else
	check_geoalgFilterSettings(
	  a_geoalgSpec5_MINMAX->get_geoalgFilterSettings(), log);
    }
}

/********************************************************************/

void check_geoalgSpec5_NURBS(
 geoalgSpec5_NURBS * a_geoalgSpec5_NURBS,
 int log)
{
  if (a_geoalgSpec5_NURBS->get_geoalgFilterSettings())
    {
      adjustLevels(&geoalgSpec5_NURBSAtts_a_geoalgFilterSettings,
		   "geoalgSpec5_NURBS a_geoalgFilterSettings");
      if (log && !findString("a_geoalgFilterSettings", geoalgSpec5_NURBSAtts))
	{
	  warnAtt("a_geoalgFilterSettings", "geoalgSpec5_NURBS",
		  a_geoalgSpec5_NURBS);
	  check_geoalgFilterSettings(
	    a_geoalgSpec5_NURBS->get_geoalgFilterSettings(), 0);
	}
      else
	check_geoalgFilterSettings(
	  a_geoalgSpec5_NURBS->get_geoalgFilterSettings(), log);
    }
}

/********************************************************************/

void check_geoalgSpec6(
 geoalgSpec6 * a_geoalgSpec6,
 int log)
{
  if (isA(a_geoalgSpec6, geoalgSpec6_LSTSQR))
    {
      adjustLevels(&geoalgSpec6Subs_geoalgSpec6_LSTSQR, "geoalgSpec6_LSTSQR");
      if (log && !findString("geoalgSpec6_LSTSQR", geoalgSpec6Subs))
	{
	  warnSub("geoalgSpec6_LSTSQR", "geoalgSpec6", a_geoalgSpec6);
	  check_geoalgSpec6_LSTSQR(
	    dynamic_cast<geoalgSpec6_LSTSQR *>(a_geoalgSpec6), 0);
	}
      else
	check_geoalgSpec6_LSTSQR(
	  dynamic_cast<geoalgSpec6_LSTSQR *>(a_geoalgSpec6), log);
      return;
    }
  if (isA(a_geoalgSpec6, geoalgSpec6_BSPLIN))
    {
      adjustLevels(&geoalgSpec6Subs_geoalgSpec6_BSPLIN, "geoalgSpec6_BSPLIN");
      if (log && !findString("geoalgSpec6_BSPLIN", geoalgSpec6Subs))
	{
	  warnSub("geoalgSpec6_BSPLIN", "geoalgSpec6", a_geoalgSpec6);
	  check_geoalgSpec6_BSPLIN(
	    dynamic_cast<geoalgSpec6_BSPLIN *>(a_geoalgSpec6), 0);
	}
      else
	check_geoalgSpec6_BSPLIN(
	  dynamic_cast<geoalgSpec6_BSPLIN *>(a_geoalgSpec6), log);
      return;
    }
  if (isA(a_geoalgSpec6, geoalgSpec6_DEFALT))
    {
      adjustLevels(&geoalgSpec6Subs_geoalgSpec6_DEFALT, "geoalgSpec6_DEFALT");
      if (log && !findString("geoalgSpec6_DEFALT", geoalgSpec6Subs))
	{
	  warnSub("geoalgSpec6_DEFALT", "geoalgSpec6", a_geoalgSpec6);
	  check_geoalgSpec6_DEFALT(
	    dynamic_cast<geoalgSpec6_DEFALT *>(a_geoalgSpec6), 0);
	}
      else
	check_geoalgSpec6_DEFALT(
	  dynamic_cast<geoalgSpec6_DEFALT *>(a_geoalgSpec6), log);
      return;
    }
  if (isA(a_geoalgSpec6, geoalgSpec6_EXTERN))
    {
      adjustLevels(&geoalgSpec6Subs_geoalgSpec6_EXTERN, "geoalgSpec6_EXTERN");
      if (log && !findString("geoalgSpec6_EXTERN", geoalgSpec6Subs))
	{
	  warnSub("geoalgSpec6_EXTERN", "geoalgSpec6", a_geoalgSpec6);
	  check_geoalgSpec6_EXTERN(
	    dynamic_cast<geoalgSpec6_EXTERN *>(a_geoalgSpec6), 0);
	}
      else
	check_geoalgSpec6_EXTERN(
	  dynamic_cast<geoalgSpec6_EXTERN *>(a_geoalgSpec6), log);
      return;
    }
}

/********************************************************************/

void check_geoalgSpec6_BSPLIN(
 geoalgSpec6_BSPLIN * a_geoalgSpec6_BSPLIN,
 int log)
{
  if (a_geoalgSpec6_BSPLIN->get_geoalgFilterSettings())
    {
      adjustLevels(&geoalgSpec6_BSPLINAtts_a_geoalgFilterSettings,
		   "geoalgSpec6_BSPLIN a_geoalgFilterSettings");
      if (log && !findString("a_geoalgFilterSettings", geoalgSpec6_BSPLINAtts))
	{
	  warnAtt("a_geoalgFilterSettings", "geoalgSpec6_BSPLIN",
		  a_geoalgSpec6_BSPLIN);
	  check_geoalgFilterSettings(
	    a_geoalgSpec6_BSPLIN->get_geoalgFilterSettings(), 0);
	}
      else
	check_geoalgFilterSettings(
	  a_geoalgSpec6_BSPLIN->get_geoalgFilterSettings(), log);
    }
}

/********************************************************************/

void check_geoalgSpec6_DEFALT(
 geoalgSpec6_DEFALT * a_geoalgSpec6_DEFALT,
 int log)
{
  if (a_geoalgSpec6_DEFALT->get_geoalgFilterSettings())
    {
      adjustLevels(&geoalgSpec6_DEFALTAtts_a_geoalgFilterSettings,
		   "geoalgSpec6_DEFALT a_geoalgFilterSettings");
      if (log && !findString("a_geoalgFilterSettings", geoalgSpec6_DEFALTAtts))
	{
	  warnAtt("a_geoalgFilterSettings", "geoalgSpec6_DEFALT",
		  a_geoalgSpec6_DEFALT);
	  check_geoalgFilterSettings(
	    a_geoalgSpec6_DEFALT->get_geoalgFilterSettings(), 0);
	}
      else
	check_geoalgFilterSettings(
	  a_geoalgSpec6_DEFALT->get_geoalgFilterSettings(), log);
    }
}

/********************************************************************/

void check_geoalgSpec6_EXTERN(
 geoalgSpec6_EXTERN * a_geoalgSpec6_EXTERN,
 int log)
{
  if (a_geoalgSpec6_EXTERN->get_geoalgExternFunc())
    {
      adjustLevels(&geoalgSpec6_EXTERNAtts_a_geoalgExternFunc,
		   "geoalgSpec6_EXTERN a_geoalgExternFunc");
      if (log && !findString("a_geoalgExternFunc", geoalgSpec6_EXTERNAtts))
	{
	  warnAtt("a_geoalgExternFunc", "geoalgSpec6_EXTERN",
		  a_geoalgSpec6_EXTERN);
	  check_geoalgExternFunc(
	    a_geoalgSpec6_EXTERN->get_geoalgExternFunc(), 0);
	}
      else
	check_geoalgExternFunc(
	  a_geoalgSpec6_EXTERN->get_geoalgExternFunc(), log);
    }
  if (a_geoalgSpec6_EXTERN->get_paramList())
    {
      std::list<param *> * theList;
      std::list<param *>::iterator iter;
      theList = a_geoalgSpec6_EXTERN->get_paramList();
      adjustLevels(&geoalgSpec6_EXTERNAtts_a_paramList,
		   "geoalgSpec6_EXTERN a_paramList");
      if (log && !findString("a_paramList", geoalgSpec6_EXTERNAtts))
	{
	  warnAtt("a_paramList", "geoalgSpec6_EXTERN", a_geoalgSpec6_EXTERN);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_param(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_param(*iter, log);
	}
    }
  if (a_geoalgSpec6_EXTERN->get_geoalgFilterSettings())
    {
      adjustLevels(&geoalgSpec6_EXTERNAtts_a_geoalgFilterSettings,
		   "geoalgSpec6_EXTERN a_geoalgFilterSettings");
      if (log && !findString("a_geoalgFilterSettings", geoalgSpec6_EXTERNAtts))
	{
	  warnAtt("a_geoalgFilterSettings", "geoalgSpec6_EXTERN",
		  a_geoalgSpec6_EXTERN);
	  check_geoalgFilterSettings(
	    a_geoalgSpec6_EXTERN->get_geoalgFilterSettings(), 0);
	}
      else
	check_geoalgFilterSettings(
	  a_geoalgSpec6_EXTERN->get_geoalgFilterSettings(), log);
    }
}

/********************************************************************/

void check_geoalgSpec6_LSTSQR(
 geoalgSpec6_LSTSQR * a_geoalgSpec6_LSTSQR,
 int log)
{
  if (a_geoalgSpec6_LSTSQR->get_geoalgFilterSettings())
    {
      adjustLevels(&geoalgSpec6_LSTSQRAtts_a_geoalgFilterSettings,
		   "geoalgSpec6_LSTSQR a_geoalgFilterSettings");
      if (log && !findString("a_geoalgFilterSettings", geoalgSpec6_LSTSQRAtts))
	{
	  warnAtt("a_geoalgFilterSettings", "geoalgSpec6_LSTSQR",
		  a_geoalgSpec6_LSTSQR);
	  check_geoalgFilterSettings(
	    a_geoalgSpec6_LSTSQR->get_geoalgFilterSettings(), 0);
	}
      else
	check_geoalgFilterSettings(
	  a_geoalgSpec6_LSTSQR->get_geoalgFilterSettings(), log);
    }
}

/********************************************************************/

void check_geoalgSphere(
 geoalgSphere * a_geoalgSphere,
 int log)
{
  if (a_geoalgSphere->get_geoalgSpec2())
    {
      adjustLevels(&geoalgSphereAtts_a_geoalgSpec2,
		   "geoalgSphere a_geoalgSpec2");
      if (log && !findString("a_geoalgSpec2", geoalgSphereAtts))
	{
	  warnAtt("a_geoalgSpec2", "geoalgSphere", a_geoalgSphere);
	  check_geoalgSpec2(a_geoalgSphere->get_geoalgSpec2(), 0);
	}
      else
	check_geoalgSpec2(a_geoalgSphere->get_geoalgSpec2(), log);
    }
}

/********************************************************************/

void check_geoalgSphradsegmnt(
 geoalgSphradsegmnt * a_geoalgSphradsegmnt,
 int log)
{
  if (a_geoalgSphradsegmnt->get_geoalgSpec2())
    {
      adjustLevels(&geoalgSphradsegmntAtts_a_geoalgSpec2,
		   "geoalgSphradsegmnt a_geoalgSpec2");
      if (log && !findString("a_geoalgSpec2", geoalgSphradsegmntAtts))
	{
	  warnAtt("a_geoalgSpec2", "geoalgSphradsegmnt",
		  a_geoalgSphradsegmnt);
	  check_geoalgSpec2(a_geoalgSphradsegmnt->get_geoalgSpec2(), 0);
	}
      else
	check_geoalgSpec2(a_geoalgSphradsegmnt->get_geoalgSpec2(), log);
    }
}

/********************************************************************/

void check_geoalgStm(
 geoalgStm * a_geoalgStm,
 int log)
{
  if (a_geoalgStm->get_geoalgMinor())
    {
      adjustLevels(&geoalgStmAtts_a_geoalgMinor, "geoalgStm a_geoalgMinor");
      if (log && !findString("a_geoalgMinor", geoalgStmAtts))
	{
	  warnAtt("a_geoalgMinor", "geoalgStm", a_geoalgStm);
	  check_geoalgMinor(a_geoalgStm->get_geoalgMinor(), 0);
	}
      else
	check_geoalgMinor(a_geoalgStm->get_geoalgMinor(), log);
    }
}

/********************************************************************/

void check_geoalgSympln(
 geoalgSympln * a_geoalgSympln,
 int log)
{
  if (a_geoalgSympln->get_geoalgSpec2())
    {
      adjustLevels(&geoalgSymplnAtts_a_geoalgSpec2,
		   "geoalgSympln a_geoalgSpec2");
      if (log && !findString("a_geoalgSpec2", geoalgSymplnAtts))
	{
	  warnAtt("a_geoalgSpec2", "geoalgSympln", a_geoalgSympln);
	  check_geoalgSpec2(a_geoalgSympln->get_geoalgSpec2(), 0);
	}
      else
	check_geoalgSpec2(a_geoalgSympln->get_geoalgSpec2(), log);
    }
}

/********************************************************************/

void check_geoalgTorradsegmnt(
 geoalgTorradsegmnt * a_geoalgTorradsegmnt,
 int log)
{
  if (a_geoalgTorradsegmnt->get_geoalgSpec2())
    {
      adjustLevels(&geoalgTorradsegmntAtts_a_geoalgSpec2,
		   "geoalgTorradsegmnt a_geoalgSpec2");
      if (log && !findString("a_geoalgSpec2", geoalgTorradsegmntAtts))
	{
	  warnAtt("a_geoalgSpec2", "geoalgTorradsegmnt",
		  a_geoalgTorradsegmnt);
	  check_geoalgSpec2(a_geoalgTorradsegmnt->get_geoalgSpec2(), 0);
	}
      else
	check_geoalgSpec2(a_geoalgTorradsegmnt->get_geoalgSpec2(), log);
    }
}

/********************************************************************/

void check_geoalgTorus(
 geoalgTorus * a_geoalgTorus,
 int log)
{
  if (a_geoalgTorus->get_geoalgSpec2())
    {
      adjustLevels(&geoalgTorusAtts_a_geoalgSpec2,
		   "geoalgTorus a_geoalgSpec2");
      if (log && !findString("a_geoalgSpec2", geoalgTorusAtts))
	{
	  warnAtt("a_geoalgSpec2", "geoalgTorus", a_geoalgTorus);
	  check_geoalgSpec2(a_geoalgTorus->get_geoalgSpec2(), 0);
	}
      else
	check_geoalgSpec2(a_geoalgTorus->get_geoalgSpec2(), log);
    }
}

/********************************************************************/

void check_geomEntityItem(
 geomEntityItem * a_geomEntityItem,
 int log)
{
  if (a_geomEntityItem->get_identity())
    {
      adjustLevels(&geomEntityItemAtts_identity, "geomEntityItem identity");
      if (log && !findString("identity", geomEntityItemAtts))
	{
	  warnAtt("identity", "geomEntityItem", a_geomEntityItem);
	  check_stringVal(a_geomEntityItem->get_identity(), 0);
	}
      else
	check_stringVal(a_geomEntityItem->get_identity(), log);
    }
  if (a_geomEntityItem->get_dist())
    {
      adjustLevels(&geomEntityItemAtts_dist, "geomEntityItem dist");
      if (log && !findString("dist", geomEntityItemAtts))
	{
	  warnAtt("dist", "geomEntityItem", a_geomEntityItem);
	  check_rentVal(a_geomEntityItem->get_dist(), 0);
	}
      else
	check_rentVal(a_geomEntityItem->get_dist(), log);
    }
}

/********************************************************************/

void check_geomMinor(
 geomMinor * a_geomMinor,
 int log)
{
  if (isA(a_geomMinor, geomStmNone))
    {
      adjustLevels(&geomMinorSubs_geomStmNone, "geomStmNone");
      if (log && !findString("geomStmNone", geomMinorSubs))
	{
	  warnSub("geomStmNone", "geomMinor", a_geomMinor);
	}
      return;
    }
  if (isA(a_geomMinor, geomStmDid))
    {
      adjustLevels(&geomMinorSubs_geomStmDid, "geomStmDid");
      if (log && !findString("geomStmDid", geomMinorSubs))
	{
	  warnSub("geomStmDid", "geomMinor", a_geomMinor);
	  check_geomStmDid(dynamic_cast<geomStmDid *>(a_geomMinor), 0);
	}
      else
	check_geomStmDid(dynamic_cast<geomStmDid *>(a_geomMinor), log);
      return;
    }
  if (isA(a_geomMinor, geomStmOffset))
    {
      adjustLevels(&geomMinorSubs_geomStmOffset, "geomStmOffset");
      if (log && !findString("geomStmOffset", geomMinorSubs))
	{
	  warnSub("geomStmOffset", "geomMinor", a_geomMinor);
	  check_geomStmOffset(
	    dynamic_cast<geomStmOffset *>(a_geomMinor), 0);
	}
      else
	check_geomStmOffset(
	  dynamic_cast<geomStmOffset *>(a_geomMinor), log);
      return;
    }
  if (isA(a_geomMinor, geomStmEntity))
    {
      adjustLevels(&geomMinorSubs_geomStmEntity, "geomStmEntity");
      if (log && !findString("geomStmEntity", geomMinorSubs))
	{
	  warnSub("geomStmEntity", "geomMinor", a_geomMinor);
	  check_geomStmEntity(
	    dynamic_cast<geomStmEntity *>(a_geomMinor), 0);
	}
      else
	check_geomStmEntity(
	  dynamic_cast<geomStmEntity *>(a_geomMinor), log);
      return;
    }
}

/********************************************************************/

void check_geomStm(
 geomStm * a_geomStm,
 int log)
{
  if (a_geomStm->get_gLabel())
    {
      adjustLevels(&geomStmAtts_a_gLabel, "geomStm a_gLabel");
      if (log && !findString("a_gLabel", geomStmAtts))
	{
	  warnAtt("a_gLabel", "geomStm", a_geomStm);
	  check_gLabel(a_geomStm->get_gLabel(), 0);
	}
      else
	check_gLabel(a_geomStm->get_gLabel(), log);
    }
  if (a_geomStm->get_geomMinor())
    {
      adjustLevels(&geomStmAtts_a_geomMinor, "geomStm a_geomMinor");
      if (log && !findString("a_geomMinor", geomStmAtts))
	{
	  warnAtt("a_geomMinor", "geomStm", a_geomStm);
	  check_geomMinor(a_geomStm->get_geomMinor(), 0);
	}
      else
	check_geomMinor(a_geomStm->get_geomMinor(), log);
    }
}

/********************************************************************/

void check_geomStmDid(
 geomStmDid * a_geomStmDid,
 int log)
{
  if (a_geomStmDid->get_didLabel())
    {
      adjustLevels(&geomStmDidAtts_a_didLabel, "geomStmDid a_didLabel");
      if (log && !findString("a_didLabel", geomStmDidAtts))
	{
	  warnAtt("a_didLabel", "geomStmDid", a_geomStmDid);
	  check_didLabel(a_geomStmDid->get_didLabel(), 0);
	}
      else
	check_didLabel(a_geomStmDid->get_didLabel(), log);
    }
}

/********************************************************************/

void check_geomStmEntity(
 geomStmEntity * a_geomStmEntity,
 int log)
{
  if (a_geomStmEntity->get_gLabel())
    {
      adjustLevels(&geomStmEntityAtts_a_gLabel, "geomStmEntity a_gLabel");
      if (log && !findString("a_gLabel", geomStmEntityAtts))
	{
	  warnAtt("a_gLabel", "geomStmEntity", a_geomStmEntity);
	  check_gLabel(a_geomStmEntity->get_gLabel(), 0);
	}
      else
	check_gLabel(a_geomStmEntity->get_gLabel(), log);
    }
  if (a_geomStmEntity->get_geomEntityList())
    {
      std::list<geomEntityItem *> * theList;
      std::list<geomEntityItem *>::iterator iter;
      theList = a_geomStmEntity->get_geomEntityList();
      adjustLevels(&geomStmEntityAtts_a_geomEntityList,
		   "geomStmEntity a_geomEntityList");
      if (log && !findString("a_geomEntityList", geomStmEntityAtts))
	{
	  warnAtt("a_geomEntityList", "geomStmEntity", a_geomStmEntity);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_geomEntityItem(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_geomEntityItem(*iter, log);
	}
    }
}

/********************************************************************/

void check_geomStmOffset(
 geomStmOffset * a_geomStmOffset,
 int log)
{
  if (a_geomStmOffset->get_gLabel())
    {
      adjustLevels(&geomStmOffsetAtts_a_gLabel, "geomStmOffset a_gLabel");
      if (log && !findString("a_gLabel", geomStmOffsetAtts))
	{
	  warnAtt("a_gLabel", "geomStmOffset", a_geomStmOffset);
	  check_gLabel(a_geomStmOffset->get_gLabel(), 0);
	}
      else
	check_gLabel(a_geomStmOffset->get_gLabel(), log);
    }
  if (a_geomStmOffset->get_dist())
    {
      adjustLevels(&geomStmOffsetAtts_dist, "geomStmOffset dist");
      if (log && !findString("dist", geomStmOffsetAtts))
	{
	  warnAtt("dist", "geomStmOffset", a_geomStmOffset);
	  check_rentVal(a_geomStmOffset->get_dist(), 0);
	}
      else
	check_rentVal(a_geomStmOffset->get_dist(), log);
    }
}

/********************************************************************/

void check_gotargBlock(
 gotargBlock * a_gotargBlock,
 int log)
{
  if (a_gotargBlock->get_gotargStm())
    {
      adjustLevels(&gotargBlockAtts_a_gotargStm, "gotargBlock a_gotargStm");
      if (log && !findString("a_gotargStm", gotargBlockAtts))
	{
	  warnAttBlock("gotargStm", a_gotargBlock->get_gotargStm());
	  check_gotargStm(a_gotargBlock->get_gotargStm(), 0);
	}
      else
	check_gotargStm(a_gotargBlock->get_gotargStm(), log);
    }
  if (a_gotargBlock->get_gotoStm())
    {
      adjustLevels(&gotargBlockAtts_a_gotoStm, "gotargBlock a_gotoStm");
      if (log && !findString("a_gotoStm", gotargBlockAtts))
	{
	  warnAttBlock("gotoStm", a_gotargBlock->get_gotoStm());
	  check_gotoStm(a_gotargBlock->get_gotoStm(), 0);
	}
      else
	check_gotoStm(a_gotargBlock->get_gotoStm(), log);
    }
  if (a_gotargBlock->get_gotoList())
    {
      std::list<gotoStm *> * theList;
      std::list<gotoStm *>::iterator iter;
      theList = a_gotargBlock->get_gotoList();
      adjustLevels(&gotargBlockAtts_a_gotoList, "gotargBlock a_gotoList");
      if (log && !findString("a_gotoList", gotargBlockAtts))
	{
	  warnAttBlock("gotoList",
	    a_gotargBlock->get_gotoList()->front());
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_gotoStm(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_gotoStm(*iter, log);
	}
    }
  if (a_gotargBlock->get_endgoStm())
    {
      adjustLevels(&gotargBlockAtts_a_endgoStm, "gotargBlock a_endgoStm");
      if (log && !findString("a_endgoStm", gotargBlockAtts))
	{
	  warnAttBlock("endgoStm", a_gotargBlock->get_endgoStm());
	}
    }
}

/********************************************************************/

void check_gotargCart(
 gotargCart * a_gotargCart,
 int log)
{
  if (a_gotargCart->get_cartPoint())
    {
      adjustLevels(&gotargCartAtts_a_cartPoint, "gotargCart a_cartPoint");
      if (log && !findString("a_cartPoint", gotargCartAtts))
	{
	  warnAtt("a_cartPoint", "gotargCart", a_gotargCart);
	  check_cartPoint(a_gotargCart->get_cartPoint(), 0);
	}
      else
	check_cartPoint(a_gotargCart->get_cartPoint(), log);
    }
}

/********************************************************************/

void check_gotargPol(
 gotargPol * a_gotargPol,
 int log)
{
  if (a_gotargPol->get_polPoint())
    {
      adjustLevels(&gotargPolAtts_a_polPoint, "gotargPol a_polPoint");
      if (log && !findString("a_polPoint", gotargPolAtts))
	{
	  warnAtt("a_polPoint", "gotargPol", a_gotargPol);
	  check_polPoint(a_gotargPol->get_polPoint(), 0);
	}
      else
	check_polPoint(a_gotargPol->get_polPoint(), log);
    }
}

/********************************************************************/

void check_gotargStm(
 gotargStm * a_gotargStm,
 int log)
{
  if (isA(a_gotargStm, gotargXyz))
    {
      adjustLevels(&gotargStmSubs_gotargXyz, "gotargXyz");
      if (log && !findString("gotargXyz", gotargStmSubs))
	{
	  warnSub("gotargXyz", "gotargStm", a_gotargStm);
	  check_gotargXyz(dynamic_cast<gotargXyz *>(a_gotargStm), 0);
	}
      else
	check_gotargXyz(dynamic_cast<gotargXyz *>(a_gotargStm), log);
      return;
    }
  if (isA(a_gotargStm, gotargCart))
    {
      adjustLevels(&gotargStmSubs_gotargCart, "gotargCart");
      if (log && !findString("gotargCart", gotargStmSubs))
	{
	  warnSub("gotargCart", "gotargStm", a_gotargStm);
	  check_gotargCart(dynamic_cast<gotargCart *>(a_gotargStm), 0);
	}
      else
	check_gotargCart(dynamic_cast<gotargCart *>(a_gotargStm), log);
      return;
    }
  if (isA(a_gotargStm, gotargPol))
    {
      adjustLevels(&gotargStmSubs_gotargPol, "gotargPol");
      if (log && !findString("gotargPol", gotargStmSubs))
	{
	  warnSub("gotargPol", "gotargStm", a_gotargStm);
	  check_gotargPol(dynamic_cast<gotargPol *>(a_gotargStm), 0);
	}
      else
	check_gotargPol(dynamic_cast<gotargPol *>(a_gotargStm), log);
      return;
    }
}

/********************************************************************/

void check_gotargXyz(
 gotargXyz * a_gotargXyz,
 int log)
{
  if (a_gotargXyz->get_impCartPoint())
    {
      adjustLevels(&gotargXyzAtts_a_impCartPoint, "gotargXyz a_impCartPoint");
      if (log && !findString("a_impCartPoint", gotargXyzAtts))
	{
	  warnAtt("a_impCartPoint", "gotargXyz", a_gotargXyz);
	  check_impCartPoint(a_gotargXyz->get_impCartPoint(), 0);
	}
      else
	check_impCartPoint(a_gotargXyz->get_impCartPoint(), log);
    }
}

/********************************************************************/

void check_gotoAbs(
 gotoAbs * a_gotoAbs,
 int log)
{
  if (isA(a_gotoAbs, gotoAbsXyz))
    {
      adjustLevels(&gotoAbsSubs_gotoAbsXyz, "gotoAbsXyz");
      if (log && !findString("gotoAbsXyz", gotoAbsSubs))
	{
	  warnSub("gotoAbsXyz", "gotoAbs", a_gotoAbs);
	  check_gotoAbsXyz(dynamic_cast<gotoAbsXyz *>(a_gotoAbs), 0);
	}
      else
	check_gotoAbsXyz(dynamic_cast<gotoAbsXyz *>(a_gotoAbs), log);
      return;
    }
  if (isA(a_gotoAbs, gotoAbsXyzSens))
    {
      adjustLevels(&gotoAbsSubs_gotoAbsXyzSens, "gotoAbsXyzSens");
      if (log && !findString("gotoAbsXyzSens", gotoAbsSubs))
	{
	  warnSub("gotoAbsXyzSens", "gotoAbs", a_gotoAbs);
	  check_gotoAbsXyzSens(
	    dynamic_cast<gotoAbsXyzSens *>(a_gotoAbs), 0);
	}
      else
	check_gotoAbsXyzSens(
	  dynamic_cast<gotoAbsXyzSens *>(a_gotoAbs), log);
      return;
    }
  if (isA(a_gotoAbs, gotoAbsCart))
    {
      adjustLevels(&gotoAbsSubs_gotoAbsCart, "gotoAbsCart");
      if (log && !findString("gotoAbsCart", gotoAbsSubs))
	{
	  warnSub("gotoAbsCart", "gotoAbs", a_gotoAbs);
	  check_gotoAbsCart(dynamic_cast<gotoAbsCart *>(a_gotoAbs), 0);
	}
      else
	check_gotoAbsCart(dynamic_cast<gotoAbsCart *>(a_gotoAbs), log);
      return;
    }
  if (isA(a_gotoAbs, gotoAbsCartSens))
    {
      adjustLevels(&gotoAbsSubs_gotoAbsCartSens, "gotoAbsCartSens");
      if (log && !findString("gotoAbsCartSens", gotoAbsSubs))
	{
	  warnSub("gotoAbsCartSens", "gotoAbs", a_gotoAbs);
	  check_gotoAbsCartSens(
	    dynamic_cast<gotoAbsCartSens *>(a_gotoAbs), 0);
	}
      else
	check_gotoAbsCartSens(
	  dynamic_cast<gotoAbsCartSens *>(a_gotoAbs), log);
      return;
    }
  if (isA(a_gotoAbs, gotoAbsPol))
    {
      adjustLevels(&gotoAbsSubs_gotoAbsPol, "gotoAbsPol");
      if (log && !findString("gotoAbsPol", gotoAbsSubs))
	{
	  warnSub("gotoAbsPol", "gotoAbs", a_gotoAbs);
	  check_gotoAbsPol(dynamic_cast<gotoAbsPol *>(a_gotoAbs), 0);
	}
      else
	check_gotoAbsPol(dynamic_cast<gotoAbsPol *>(a_gotoAbs), log);
      return;
    }
  if (isA(a_gotoAbs, gotoAbsPolSens))
    {
      adjustLevels(&gotoAbsSubs_gotoAbsPolSens, "gotoAbsPolSens");
      if (log && !findString("gotoAbsPolSens", gotoAbsSubs))
	{
	  warnSub("gotoAbsPolSens", "gotoAbs", a_gotoAbs);
	  check_gotoAbsPolSens(
	    dynamic_cast<gotoAbsPolSens *>(a_gotoAbs), 0);
	}
      else
	check_gotoAbsPolSens(
	  dynamic_cast<gotoAbsPolSens *>(a_gotoAbs), log);
      return;
    }
}

/********************************************************************/

void check_gotoAbsCart(
 gotoAbsCart * a_gotoAbsCart,
 int log)
{
  if (a_gotoAbsCart->get_cartPoint())
    {
      adjustLevels(&gotoAbsCartAtts_a_cartPoint, "gotoAbsCart a_cartPoint");
      if (log && !findString("a_cartPoint", gotoAbsCartAtts))
	{
	  warnAtt("a_cartPoint", "gotoAbsCart", a_gotoAbsCart);
	  check_cartPoint(a_gotoAbsCart->get_cartPoint(), 0);
	}
      else
	check_cartPoint(a_gotoAbsCart->get_cartPoint(), log);
    }
}

/********************************************************************/

void check_gotoAbsCartSens(
 gotoAbsCartSens * a_gotoAbsCartSens,
 int log)
{
  if (a_gotoAbsCartSens->get_cartPoint())
    {
      adjustLevels(&gotoAbsCartSensAtts_a_cartPoint,
		   "gotoAbsCartSens a_cartPoint");
      if (log && !findString("a_cartPoint", gotoAbsCartSensAtts))
	{
	  warnAtt("a_cartPoint", "gotoAbsCartSens", a_gotoAbsCartSens);
	  check_cartPoint(a_gotoAbsCartSens->get_cartPoint(), 0);
	}
      else
	check_cartPoint(a_gotoAbsCartSens->get_cartPoint(), log);
    }
  if (a_gotoAbsCartSens->get_sensorMove())
    {
      adjustLevels(&gotoAbsCartSensAtts_a_sensorMove,
		   "gotoAbsCartSens a_sensorMove");
      if (log && !findString("a_sensorMove", gotoAbsCartSensAtts))
	{
	  warnAtt("a_sensorMove", "gotoAbsCartSens", a_gotoAbsCartSens);
	  check_sensorMove(a_gotoAbsCartSens->get_sensorMove(), 0);
	}
      else
	check_sensorMove(a_gotoAbsCartSens->get_sensorMove(), log);
    }
}

/********************************************************************/

void check_gotoAbsPol(
 gotoAbsPol * a_gotoAbsPol,
 int log)
{
  if (a_gotoAbsPol->get_polPoint())
    {
      adjustLevels(&gotoAbsPolAtts_a_polPoint, "gotoAbsPol a_polPoint");
      if (log && !findString("a_polPoint", gotoAbsPolAtts))
	{
	  warnAtt("a_polPoint", "gotoAbsPol", a_gotoAbsPol);
	  check_polPoint(a_gotoAbsPol->get_polPoint(), 0);
	}
      else
	check_polPoint(a_gotoAbsPol->get_polPoint(), log);
    }
}

/********************************************************************/

void check_gotoAbsPolSens(
 gotoAbsPolSens * a_gotoAbsPolSens,
 int log)
{
  if (a_gotoAbsPolSens->get_polPoint())
    {
      adjustLevels(&gotoAbsPolSensAtts_a_polPoint,
		   "gotoAbsPolSens a_polPoint");
      if (log && !findString("a_polPoint", gotoAbsPolSensAtts))
	{
	  warnAtt("a_polPoint", "gotoAbsPolSens", a_gotoAbsPolSens);
	  check_polPoint(a_gotoAbsPolSens->get_polPoint(), 0);
	}
      else
	check_polPoint(a_gotoAbsPolSens->get_polPoint(), log);
    }
  if (a_gotoAbsPolSens->get_sensorMove())
    {
      adjustLevels(&gotoAbsPolSensAtts_a_sensorMove,
		   "gotoAbsPolSens a_sensorMove");
      if (log && !findString("a_sensorMove", gotoAbsPolSensAtts))
	{
	  warnAtt("a_sensorMove", "gotoAbsPolSens", a_gotoAbsPolSens);
	  check_sensorMove(a_gotoAbsPolSens->get_sensorMove(), 0);
	}
      else
	check_sensorMove(a_gotoAbsPolSens->get_sensorMove(), log);
    }
}

/********************************************************************/

void check_gotoAbsXyz(
 gotoAbsXyz * a_gotoAbsXyz,
 int log)
{
  if (a_gotoAbsXyz->get_impCartPoint())
    {
      adjustLevels(&gotoAbsXyzAtts_a_impCartPoint,
		   "gotoAbsXyz a_impCartPoint");
      if (log && !findString("a_impCartPoint", gotoAbsXyzAtts))
	{
	  warnAtt("a_impCartPoint", "gotoAbsXyz", a_gotoAbsXyz);
	  check_impCartPoint(a_gotoAbsXyz->get_impCartPoint(), 0);
	}
      else
	check_impCartPoint(a_gotoAbsXyz->get_impCartPoint(), log);
    }
}

/********************************************************************/

void check_gotoAbsXyzSens(
 gotoAbsXyzSens * a_gotoAbsXyzSens,
 int log)
{
  if (a_gotoAbsXyzSens->get_impCartPoint())
    {
      adjustLevels(&gotoAbsXyzSensAtts_a_impCartPoint,
		   "gotoAbsXyzSens a_impCartPoint");
      if (log && !findString("a_impCartPoint", gotoAbsXyzSensAtts))
	{
	  warnAtt("a_impCartPoint", "gotoAbsXyzSens", a_gotoAbsXyzSens);
	  check_impCartPoint(a_gotoAbsXyzSens->get_impCartPoint(), 0);
	}
      else
	check_impCartPoint(a_gotoAbsXyzSens->get_impCartPoint(), log);
    }
  if (a_gotoAbsXyzSens->get_sensorMove())
    {
      adjustLevels(&gotoAbsXyzSensAtts_a_sensorMove,
		   "gotoAbsXyzSens a_sensorMove");
      if (log && !findString("a_sensorMove", gotoAbsXyzSensAtts))
	{
	  warnAtt("a_sensorMove", "gotoAbsXyzSens", a_gotoAbsXyzSens);
	  check_sensorMove(a_gotoAbsXyzSens->get_sensorMove(), 0);
	}
      else
	check_sensorMove(a_gotoAbsXyzSens->get_sensorMove(), log);
    }
}

/********************************************************************/

void check_gotoArc(
 gotoArc * a_gotoArc,
 int log)
{
  if (a_gotoArc->get_inter())
    {
      adjustLevels(&gotoArcAtts_inter, "gotoArc inter");
      if (log && !findString("inter", gotoArcAtts))
	{
	  warnAtt("inter", "gotoArc", a_gotoArc);
	  check_impCartPoint(a_gotoArc->get_inter(), 0);
	}
      else
	check_impCartPoint(a_gotoArc->get_inter(), log);
    }
  if (a_gotoArc->get_end())
    {
      adjustLevels(&gotoArcAtts_end, "gotoArc end");
      if (log && !findString("end", gotoArcAtts))
	{
	  warnAtt("end", "gotoArc", a_gotoArc);
	  check_impCartPoint(a_gotoArc->get_end(), 0);
	}
      else
	check_impCartPoint(a_gotoArc->get_end(), log);
    }
  if (a_gotoArc->get_probeOrient())
    {
      adjustLevels(&gotoArcAtts_a_probeOrient, "gotoArc a_probeOrient");
      if (log && !findString("a_probeOrient", gotoArcAtts))
	{
	  warnAtt("a_probeOrient", "gotoArc", a_gotoArc);
	  check_probeOrient(a_gotoArc->get_probeOrient(), 0);
	}
      else
	check_probeOrient(a_gotoArc->get_probeOrient(), log);
    }
}

/********************************************************************/

void check_gotoAxis(
 gotoAxis * a_gotoAxis,
 int log)
{
  if (a_gotoAxis->get_spec1())
    {
      adjustLevels(&gotoAxisAtts_spec1, "gotoAxis spec1");
      if (log && !findString("spec1", gotoAxisAtts))
	{
	  warnAtt("spec1", "gotoAxis", a_gotoAxis);
	  check_gotoAxisSpec(a_gotoAxis->get_spec1(), 0);
	}
      else
	check_gotoAxisSpec(a_gotoAxis->get_spec1(), log);
    }
  if (a_gotoAxis->get_spec2())
    {
      adjustLevels(&gotoAxisAtts_spec2, "gotoAxis spec2");
      if (log && !findString("spec2", gotoAxisAtts))
	{
	  warnAtt("spec2", "gotoAxis", a_gotoAxis);
	  check_gotoAxisSpec(a_gotoAxis->get_spec2(), 0);
	}
      else
	check_gotoAxisSpec(a_gotoAxis->get_spec2(), log);
    }
  if (a_gotoAxis->get_spec3())
    {
      adjustLevels(&gotoAxisAtts_spec3, "gotoAxis spec3");
      if (log && !findString("spec3", gotoAxisAtts))
	{
	  warnAtt("spec3", "gotoAxis", a_gotoAxis);
	  check_gotoAxisSpec(a_gotoAxis->get_spec3(), 0);
	}
      else
	check_gotoAxisSpec(a_gotoAxis->get_spec3(), log);
    }
}

/********************************************************************/

void check_gotoAxisSpec(
 gotoAxisSpec * a_gotoAxisSpec,
 int log)
{
  if (a_gotoAxisSpec->get_axisName())
    {
      adjustLevels(&gotoAxisSpecAtts_axisName, "gotoAxisSpec axisName");
      if (log && !findString("axisName", gotoAxisSpecAtts))
	{
	  warnAtt("axisName", "gotoAxisSpec", a_gotoAxisSpec);
	  check_axis(a_gotoAxisSpec->get_axisName(), 0);
	}
      else
	check_axis(a_gotoAxisSpec->get_axisName(), log);
    }
  if (a_gotoAxisSpec->get_axisCoord())
    {
      adjustLevels(&gotoAxisSpecAtts_axisCoord, "gotoAxisSpec axisCoord");
      if (log && !findString("axisCoord", gotoAxisSpecAtts))
	{
	  warnAtt("axisCoord", "gotoAxisSpec", a_gotoAxisSpec);
	  check_rentVal(a_gotoAxisSpec->get_axisCoord(), 0);
	}
      else
	check_rentVal(a_gotoAxisSpec->get_axisCoord(), log);
    }
}

/********************************************************************/

void check_gotoMinor(
 gotoMinor * a_gotoMinor,
 int log)
{
  if (isA(a_gotoMinor, gotoAbs))
    {
      adjustLevels(&gotoMinorSubs_gotoAbs, "gotoAbs");
      if (log && !findString("gotoAbs", gotoMinorSubs))
	{
	  warnSub("gotoAbs", "gotoMinor", a_gotoMinor);
	  check_gotoAbs(dynamic_cast<gotoAbs *>(a_gotoMinor), 0);
	}
      else
	check_gotoAbs(dynamic_cast<gotoAbs *>(a_gotoMinor), log);
      return;
    }
  if (isA(a_gotoMinor, gotoRel))
    {
      adjustLevels(&gotoMinorSubs_gotoRel, "gotoRel");
      if (log && !findString("gotoRel", gotoMinorSubs))
	{
	  warnSub("gotoRel", "gotoMinor", a_gotoMinor);
	  check_gotoRel(dynamic_cast<gotoRel *>(a_gotoMinor), 0);
	}
      else
	check_gotoRel(dynamic_cast<gotoRel *>(a_gotoMinor), log);
      return;
    }
  if (isA(a_gotoMinor, gotoArc))
    {
      adjustLevels(&gotoMinorSubs_gotoArc, "gotoArc");
      if (log && !findString("gotoArc", gotoMinorSubs))
	{
	  warnSub("gotoArc", "gotoMinor", a_gotoMinor);
	  check_gotoArc(dynamic_cast<gotoArc *>(a_gotoMinor), 0);
	}
      else
	check_gotoArc(dynamic_cast<gotoArc *>(a_gotoMinor), log);
      return;
    }
  if (isA(a_gotoMinor, gotoAxis))
    {
      adjustLevels(&gotoMinorSubs_gotoAxis, "gotoAxis");
      if (log && !findString("gotoAxis", gotoMinorSubs))
	{
	  warnSub("gotoAxis", "gotoMinor", a_gotoMinor);
	  check_gotoAxis(dynamic_cast<gotoAxis *>(a_gotoMinor), 0);
	}
      else
	check_gotoAxis(dynamic_cast<gotoAxis *>(a_gotoMinor), log);
      return;
    }
  if (isA(a_gotoMinor, probeOrient))
    {
      adjustLevels(&gotoMinorSubs_probeOrient, "probeOrient");
      if (log && !findString("probeOrient", gotoMinorSubs))
	{
	  warnSub("probeOrient", "gotoMinor", a_gotoMinor);
	  check_probeOrient(dynamic_cast<probeOrient *>(a_gotoMinor), 0);
	}
      else
	check_probeOrient(dynamic_cast<probeOrient *>(a_gotoMinor), log);
      return;
    }
}

/********************************************************************/

void check_gotoRel(
 gotoRel * a_gotoRel,
 int log)
{
  if (a_gotoRel->get_dist())
    {
      adjustLevels(&gotoRelAtts_dist, "gotoRel dist");
      if (log && !findString("dist", gotoRelAtts))
	{
	  warnAtt("dist", "gotoRel", a_gotoRel);
	  check_rentVal(a_gotoRel->get_dist(), 0);
	}
      else
	check_rentVal(a_gotoRel->get_dist(), log);
    }
  if (a_gotoRel->get_dir())
    {
      adjustLevels(&gotoRelAtts_dir, "gotoRel dir");
      if (log && !findString("dir", gotoRelAtts))
	{
	  warnAtt("dir", "gotoRel", a_gotoRel);
	  check_vector(a_gotoRel->get_dir(), 0);
	}
      else
	check_vector(a_gotoRel->get_dir(), log);
    }
}

/********************************************************************/

void check_gotoStm(
 gotoStm * a_gotoStm,
 int log)
{
  if (a_gotoStm->get_gotoMinor())
    {
      adjustLevels(&gotoStmAtts_a_gotoMinor, "gotoStm a_gotoMinor");
      if (log && !findString("a_gotoMinor", gotoStmAtts))
	{
	  warnAtt("a_gotoMinor", "gotoStm", a_gotoStm);
	  check_gotoMinor(a_gotoStm->get_gotoMinor(), 0);
	}
      else
	check_gotoMinor(a_gotoStm->get_gotoMinor(), log);
    }
}

/********************************************************************/

void check_gotoWristAngleItem(
 gotoWristAngleItem * a_gotoWristAngleItem,
 int log)
{
  if (a_gotoWristAngleItem->get_anglename())
    {
      adjustLevels(&gotoWristAngleItemAtts_anglename,
		   "gotoWristAngleItem anglename");
      if (log && !findString("anglename", gotoWristAngleItemAtts))
	{
	  warnAtt("anglename", "gotoWristAngleItem", a_gotoWristAngleItem);
	  check_stringVal(a_gotoWristAngleItem->get_anglename(), 0);
	}
      else
	check_stringVal(a_gotoWristAngleItem->get_anglename(), log);
    }
  if (a_gotoWristAngleItem->get_angle())
    {
      adjustLevels(&gotoWristAngleItemAtts_a_angle,
		   "gotoWristAngleItem a_angle");
      if (log && !findString("a_angle", gotoWristAngleItemAtts))
	{
	  warnAtt("a_angle", "gotoWristAngleItem", a_gotoWristAngleItem);
	  check_angle(a_gotoWristAngleItem->get_angle(), 0);
	}
      else
	check_angle(a_gotoWristAngleItem->get_angle(), log);
    }
}

/********************************************************************/

void check_gotoWristItem(
 gotoWristItem * a_gotoWristItem,
 int log)
{
  if (a_gotoWristItem->get_swLabel())
    {
      adjustLevels(&gotoWristItemAtts_a_swLabel, "gotoWristItem a_swLabel");
      if (log && !findString("a_swLabel", gotoWristItemAtts))
	{
	  warnAtt("a_swLabel", "gotoWristItem", a_gotoWristItem);
	  check_swLabel(a_gotoWristItem->get_swLabel(), 0);
	}
      else
	check_swLabel(a_gotoWristItem->get_swLabel(), log);
    }
  if (a_gotoWristItem->get_gotoWristAngleList())
    {
      std::list<gotoWristAngleItem *> * theList;
      std::list<gotoWristAngleItem *>::iterator iter;
      theList = a_gotoWristItem->get_gotoWristAngleList();
      adjustLevels(&gotoWristItemAtts_a_gotoWristAngleList,
		   "gotoWristItem a_gotoWristAngleList");
      if (log && !findString("a_gotoWristAngleList", gotoWristItemAtts))
	{
	  warnAtt("a_gotoWristAngleList", "gotoWristItem", a_gotoWristItem);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_gotoWristAngleItem(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_gotoWristAngleItem(*iter, log);
	}
    }
}

/********************************************************************/

void check_groupStm(
 groupStm * a_groupStm,
 int log)
{
  if (a_groupStm->get_gsaLabel())
    {
      adjustLevels(&groupStmAtts_a_gsaLabel, "groupStm a_gsaLabel");
      if (log && !findString("a_gsaLabel", groupStmAtts))
	{
	  warnAtt("a_gsaLabel", "groupStm", a_groupStm);
	  check_gsaLabel(a_groupStm->get_gsaLabel(), 0);
	}
      else
	check_gsaLabel(a_groupStm->get_gsaLabel(), log);
    }
  if (a_groupStm->get_saLabel())
    {
      adjustLevels(&groupStmAtts_a_saLabel, "groupStm a_saLabel");
      if (log && !findString("a_saLabel", groupStmAtts))
	{
	  warnAtt("a_saLabel", "groupStm", a_groupStm);
	  check_saLabel(a_groupStm->get_saLabel(), 0);
	}
      else
	check_saLabel(a_groupStm->get_saLabel(), log);
    }
  if (a_groupStm->get_saLabelList())
    {
      std::list<saLabel *> * theList;
      std::list<saLabel *>::iterator iter;
      theList = a_groupStm->get_saLabelList();
      adjustLevels(&groupStmAtts_a_saLabelList, "groupStm a_saLabelList");
      if (log && !findString("a_saLabelList", groupStmAtts))
	{
	  warnAtt("a_saLabelList", "groupStm", a_groupStm);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_saLabel(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_saLabel(*iter, log);
	}
    }
}

/********************************************************************/

void check_gsaLabel(
 gsaLabel * a_gsaLabel,
 int log)
{
  if (a_gsaLabel->get_labelName())
    {
      adjustLevels(&gsaLabelAtts_a_labelName, "gsaLabel a_labelName");
      if (log && !findString("a_labelName", gsaLabelAtts))
	{
	  warnAtt("a_labelName", "gsaLabel", a_gsaLabel);
	  check_labelName(a_gsaLabel->get_labelName(), 0);
	}
      else
	check_labelName(a_gsaLabel->get_labelName(), log);
    }
}

/********************************************************************/

void check_ifBlock(
 ifBlock * a_ifBlock,
 int log)
{
  if (a_ifBlock->get_ifStm())
    {
      adjustLevels(&ifBlockAtts_a_ifStm, "ifBlock a_ifStm");
      if (log && !findString("a_ifStm", ifBlockAtts))
	{
	  warnAttBlock("ifStm", a_ifBlock->get_ifStm());
	  check_ifStm(a_ifBlock->get_ifStm(), 0);
	}
      else
	check_ifStm(a_ifBlock->get_ifStm(), log);
    }
  if (a_ifBlock->get_ifList())
    {
      std::list<dmisItem *> * theList;
      std::list<dmisItem *>::iterator iter;
      theList = a_ifBlock->get_ifList();
      adjustLevels(&ifBlockAtts_ifList, "ifBlock ifList");
      if (log && !findString("ifList", ifBlockAtts))
	{
	  warnAttBlock("ifList",
	    a_ifBlock->get_ifList()->front());
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_dmisItem(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_dmisItem(*iter, log);
	}
    }
  if (a_ifBlock->get_elseStm())
    {
      adjustLevels(&ifBlockAtts_a_elseStm, "ifBlock a_elseStm");
      if (log && !findString("a_elseStm", ifBlockAtts))
	{
	  warnAttBlock("elseStm", a_ifBlock->get_elseStm());
	}
    }
  if (a_ifBlock->get_elseList())
    {
      std::list<dmisItem *> * theList;
      std::list<dmisItem *>::iterator iter;
      theList = a_ifBlock->get_elseList();
      adjustLevels(&ifBlockAtts_elseList, "ifBlock elseList");
      if (log && !findString("elseList", ifBlockAtts))
	{
	  warnAttBlock("elseList",
	    a_ifBlock->get_elseList()->front());
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_dmisItem(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_dmisItem(*iter, log);
	}
    }
  if (a_ifBlock->get_endifStm())
    {
      adjustLevels(&ifBlockAtts_a_endifStm, "ifBlock a_endifStm");
      if (log && !findString("a_endifStm", ifBlockAtts))
	{
	  warnAttBlock("endifStm", a_ifBlock->get_endifStm());
	}
    }
}

/********************************************************************/

void check_ifStm(
 ifStm * a_ifStm,
 int log)
{
  if (a_ifStm->get_boolVal())
    {
      adjustLevels(&ifStmAtts_a_boolVal, "ifStm a_boolVal");
      if (log && !findString("a_boolVal", ifStmAtts))
	{
	  warnAtt("a_boolVal", "ifStm", a_ifStm);
	  check_boolVal(a_ifStm->get_boolVal(), 0);
	}
      else
	check_boolVal(a_ifStm->get_boolVal(), log);
    }
}

/********************************************************************/

void check_impCartPoint(
 impCartPoint * a_impCartPoint,
 int log)
{
  if (a_impCartPoint->get_x())
    {
      adjustLevels(&impCartPointAtts_x, "impCartPoint x");
      if (log && !findString("x", impCartPointAtts))
	{
	  warnAtt("x", "impCartPoint", a_impCartPoint);
	  check_rentVal(a_impCartPoint->get_x(), 0);
	}
      else
	check_rentVal(a_impCartPoint->get_x(), log);
    }
  if (a_impCartPoint->get_y())
    {
      adjustLevels(&impCartPointAtts_y, "impCartPoint y");
      if (log && !findString("y", impCartPointAtts))
	{
	  warnAtt("y", "impCartPoint", a_impCartPoint);
	  check_rentVal(a_impCartPoint->get_y(), 0);
	}
      else
	check_rentVal(a_impCartPoint->get_y(), log);
    }
  if (a_impCartPoint->get_z())
    {
      adjustLevels(&impCartPointAtts_z, "impCartPoint z");
      if (log && !findString("z", impCartPointAtts))
	{
	  warnAtt("z", "impCartPoint", a_impCartPoint);
	  check_rentVal(a_impCartPoint->get_z(), 0);
	}
      else
	check_rentVal(a_impCartPoint->get_z(), log);
    }
}

/********************************************************************/

void check_impPolPoint(
 impPolPoint * a_impPolPoint,
 int log)
{
  if (a_impPolPoint->get_r())
    {
      adjustLevels(&impPolPointAtts_r, "impPolPoint r");
      if (log && !findString("r", impPolPointAtts))
	{
	  warnAtt("r", "impPolPoint", a_impPolPoint);
	  check_rentVal(a_impPolPoint->get_r(), 0);
	}
      else
	check_rentVal(a_impPolPoint->get_r(), log);
    }
  if (a_impPolPoint->get_a())
    {
      adjustLevels(&impPolPointAtts_a, "impPolPoint a");
      if (log && !findString("a", impPolPointAtts))
	{
	  warnAtt("a", "impPolPoint", a_impPolPoint);
	  check_rentVal(a_impPolPoint->get_a(), 0);
	}
      else
	check_rentVal(a_impPolPoint->get_a(), log);
    }
  if (a_impPolPoint->get_h())
    {
      adjustLevels(&impPolPointAtts_h, "impPolPoint h");
      if (log && !findString("h", impPolPointAtts))
	{
	  warnAtt("h", "impPolPoint", a_impPolPoint);
	  check_rentVal(a_impPolPoint->get_h(), 0);
	}
      else
	check_rentVal(a_impPolPoint->get_h(), log);
    }
}

/********************************************************************/

void check_includDme(
 includDme * a_includDme,
 int log)
{
  if (a_includDme->get_stringConst())
    {
      adjustLevels(&includDmeAtts_a_stringConst, "includDme a_stringConst");
      if (log && !findString("a_stringConst", includDmeAtts))
	{
	  warnAtt("a_stringConst", "includDme", a_includDme);
	  check_stringConst(a_includDme->get_stringConst(), 0);
	}
      else
	check_stringConst(a_includDme->get_stringConst(), log);
    }
}

/********************************************************************/

void check_includDmis(
 includDmis * a_includDmis,
 int log)
{
  if (a_includDmis->get_stringConst())
    {
      adjustLevels(&includDmisAtts_a_stringConst, "includDmis a_stringConst");
      if (log && !findString("a_stringConst", includDmisAtts))
	{
	  warnAtt("a_stringConst", "includDmis", a_includDmis);
	  check_stringConst(a_includDmis->get_stringConst(), 0);
	}
      else
	check_stringConst(a_includDmis->get_stringConst(), log);
    }
}

/********************************************************************/

void check_includMinor(
 includMinor * a_includMinor,
 int log)
{
  if (isA(a_includMinor, includDmis))
    {
      adjustLevels(&includMinorSubs_includDmis, "includDmis");
      if (log && !findString("includDmis", includMinorSubs))
	{
	  warnSub("includDmis", "includMinor", a_includMinor);
	  check_includDmis(dynamic_cast<includDmis *>(a_includMinor), 0);
	}
      else
	check_includDmis(dynamic_cast<includDmis *>(a_includMinor), log);
      return;
    }
  if (isA(a_includMinor, includDme))
    {
      adjustLevels(&includMinorSubs_includDme, "includDme");
      if (log && !findString("includDme", includMinorSubs))
	{
	  warnSub("includDme", "includMinor", a_includMinor);
	  check_includDme(dynamic_cast<includDme *>(a_includMinor), 0);
	}
      else
	check_includDme(dynamic_cast<includDme *>(a_includMinor), log);
      return;
    }
}

/********************************************************************/

void check_includStm(
 includStm * a_includStm,
 int log)
{
  if (a_includStm->get_includMinor())
    {
      adjustLevels(&includStmAtts_a_includMinor, "includStm a_includMinor");
      if (log && !findString("a_includMinor", includStmAtts))
	{
	  warnAtt("a_includMinor", "includStm", a_includStm);
	  check_includMinor(a_includStm->get_includMinor(), 0);
	}
      else
	check_includMinor(a_includStm->get_includMinor(), log);
    }
}

/********************************************************************/

void check_indexedFeature(
 indexedFeature * a_indexedFeature,
 int log)
{
  if (a_indexedFeature->get_featureLabel())
    {
      adjustLevels(&indexedFeatureAtts_a_featureLabel,
		   "indexedFeature a_featureLabel");
      if (log && !findString("a_featureLabel", indexedFeatureAtts))
	{
	  warnAtt("a_featureLabel", "indexedFeature", a_indexedFeature);
	  check_featureLabel(a_indexedFeature->get_featureLabel(), 0);
	}
      else
	check_featureLabel(a_indexedFeature->get_featureLabel(), log);
    }
  if (a_indexedFeature->get_pointRange())
    {
      adjustLevels(&indexedFeatureAtts_a_pointRange,
		   "indexedFeature a_pointRange");
      if (log && !findString("a_pointRange", indexedFeatureAtts))
	{
	  warnAtt("a_pointRange", "indexedFeature", a_indexedFeature);
	  check_pointRange(a_indexedFeature->get_pointRange(), 0);
	}
      else
	check_pointRange(a_indexedFeature->get_pointRange(), log);
    }
}

/********************************************************************/

void check_inputFile(
 inputFile * a_inputFile,
 int log)
{
  if (a_inputFile->get_dmisFirstStatement())
    {
      adjustLevels(&inputFileAtts_a_dmisFirstStatement,
		   "inputFile a_dmisFirstStatement");
      if (log && !findString("a_dmisFirstStatement", inputFileAtts))
	{
	  warnAtt("a_dmisFirstStatement", "inputFile", a_inputFile);
	  check_dmisFirstStatement(a_inputFile->get_dmisFirstStatement(), 0);
	}
      else
	check_dmisFirstStatement(a_inputFile->get_dmisFirstStatement(), log);
    }
  if (a_inputFile->get_dmisItemList())
    {
      std::list<dmisItem *> * theList;
      std::list<dmisItem *>::iterator iter;
      theList = a_inputFile->get_dmisItemList();
      adjustLevels(&inputFileAtts_a_dmisItemList, "inputFile a_dmisItemList");
      if (log && !findString("a_dmisItemList", inputFileAtts))
	{
	  warnAtt("a_dmisItemList", "inputFile", a_inputFile);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_dmisItem(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_dmisItem(*iter, log);
	}
    }
  if (a_inputFile->get_endfilStm())
    {
      adjustLevels(&inputFileAtts_a_endfilStm, "inputFile a_endfilStm");
      if (log && !findString("a_endfilStm", inputFileAtts))
	{
	  warnAtt("a_endfilStm", "inputFile", a_inputFile);
	}
    }
}

/********************************************************************/

void check_intConst(
 intConst * a_intConst,
 int log)
{
  if (a_intConst->get_int())
    {
      adjustLevels(&intConstAtts_a_int, "intConst a_int");
      if (log && !findString("a_int", intConstAtts))
	{
	  warnAtt("a_int", "intConst", a_intConst);
	}
    }
}

/********************************************************************/

void check_intExpr(
 intExpr * a_intExpr,
 int log)
{
  if (isA(a_intExpr, intExprParen))
    {
      adjustLevels(&intExprSubs_intExprParen, "intExprParen");
      if (log && !findString("intExprParen", intExprSubs))
	{
	  warnSub("intExprParen", "intExpr", a_intExpr);
	  check_intExprParen(dynamic_cast<intExprParen *>(a_intExpr), 0);
	}
      else
	check_intExprParen(dynamic_cast<intExprParen *>(a_intExpr), log);
      return;
    }
  if (isA(a_intExpr, intExprPlus))
    {
      adjustLevels(&intExprSubs_intExprPlus, "intExprPlus");
      if (log && !findString("intExprPlus", intExprSubs))
	{
	  warnSub("intExprPlus", "intExpr", a_intExpr);
	  check_intExprPlus(dynamic_cast<intExprPlus *>(a_intExpr), 0);
	}
      else
	check_intExprPlus(dynamic_cast<intExprPlus *>(a_intExpr), log);
      return;
    }
  if (isA(a_intExpr, intExprMinus))
    {
      adjustLevels(&intExprSubs_intExprMinus, "intExprMinus");
      if (log && !findString("intExprMinus", intExprSubs))
	{
	  warnSub("intExprMinus", "intExpr", a_intExpr);
	  check_intExprMinus(dynamic_cast<intExprMinus *>(a_intExpr), 0);
	}
      else
	check_intExprMinus(dynamic_cast<intExprMinus *>(a_intExpr), log);
      return;
    }
  if (isA(a_intExpr, intExprTimes))
    {
      adjustLevels(&intExprSubs_intExprTimes, "intExprTimes");
      if (log && !findString("intExprTimes", intExprSubs))
	{
	  warnSub("intExprTimes", "intExpr", a_intExpr);
	  check_intExprTimes(dynamic_cast<intExprTimes *>(a_intExpr), 0);
	}
      else
	check_intExprTimes(dynamic_cast<intExprTimes *>(a_intExpr), log);
      return;
    }
  if (isA(a_intExpr, intExprDivid))
    {
      adjustLevels(&intExprSubs_intExprDivid, "intExprDivid");
      if (log && !findString("intExprDivid", intExprSubs))
	{
	  warnSub("intExprDivid", "intExpr", a_intExpr);
	  check_intExprDivid(dynamic_cast<intExprDivid *>(a_intExpr), 0);
	}
      else
	check_intExprDivid(dynamic_cast<intExprDivid *>(a_intExpr), log);
      return;
    }
  if (isA(a_intExpr, intExprPower))
    {
      adjustLevels(&intExprSubs_intExprPower, "intExprPower");
      if (log && !findString("intExprPower", intExprSubs))
	{
	  warnSub("intExprPower", "intExpr", a_intExpr);
	  check_intExprPower(dynamic_cast<intExprPower *>(a_intExpr), 0);
	}
      else
	check_intExprPower(dynamic_cast<intExprPower *>(a_intExpr), log);
      return;
    }
  if (isA(a_intExpr, intExprNegat))
    {
      adjustLevels(&intExprSubs_intExprNegat, "intExprNegat");
      if (log && !findString("intExprNegat", intExprSubs))
	{
	  warnSub("intExprNegat", "intExpr", a_intExpr);
	  check_intExprNegat(dynamic_cast<intExprNegat *>(a_intExpr), 0);
	}
      else
	check_intExprNegat(dynamic_cast<intExprNegat *>(a_intExpr), log);
      return;
    }
  if (isA(a_intExpr, intExprPosit))
    {
      adjustLevels(&intExprSubs_intExprPosit, "intExprPosit");
      if (log && !findString("intExprPosit", intExprSubs))
	{
	  warnSub("intExprPosit", "intExpr", a_intExpr);
	  check_intExprPosit(dynamic_cast<intExprPosit *>(a_intExpr), 0);
	}
      else
	check_intExprPosit(dynamic_cast<intExprPosit *>(a_intExpr), log);
      return;
    }
}

/********************************************************************/

void check_intExprDivid(
 intExprDivid * a_intExprDivid,
 int log)
{
  if (a_intExprDivid->get_dvend())
    {
      adjustLevels(&intExprDividAtts_dvend, "intExprDivid dvend");
      if (log && !findString("dvend", intExprDividAtts))
	{
	  warnAtt("dvend", "intExprDivid", a_intExprDivid);
	  check_intVal(a_intExprDivid->get_dvend(), 0);
	}
      else
	check_intVal(a_intExprDivid->get_dvend(), log);
    }
  if (a_intExprDivid->get_dvisr())
    {
      adjustLevels(&intExprDividAtts_dvisr, "intExprDivid dvisr");
      if (log && !findString("dvisr", intExprDividAtts))
	{
	  warnAtt("dvisr", "intExprDivid", a_intExprDivid);
	  check_intVal(a_intExprDivid->get_dvisr(), 0);
	}
      else
	check_intVal(a_intExprDivid->get_dvisr(), log);
    }
}

/********************************************************************/

void check_intExprMinus(
 intExprMinus * a_intExprMinus,
 int log)
{
  if (a_intExprMinus->get_term1())
    {
      adjustLevels(&intExprMinusAtts_term1, "intExprMinus term1");
      if (log && !findString("term1", intExprMinusAtts))
	{
	  warnAtt("term1", "intExprMinus", a_intExprMinus);
	  check_intVal(a_intExprMinus->get_term1(), 0);
	}
      else
	check_intVal(a_intExprMinus->get_term1(), log);
    }
  if (a_intExprMinus->get_term2())
    {
      adjustLevels(&intExprMinusAtts_term2, "intExprMinus term2");
      if (log && !findString("term2", intExprMinusAtts))
	{
	  warnAtt("term2", "intExprMinus", a_intExprMinus);
	  check_intVal(a_intExprMinus->get_term2(), 0);
	}
      else
	check_intVal(a_intExprMinus->get_term2(), log);
    }
}

/********************************************************************/

void check_intExprNegat(
 intExprNegat * a_intExprNegat,
 int log)
{
  if (a_intExprNegat->get_x())
    {
      adjustLevels(&intExprNegatAtts_x, "intExprNegat x");
      if (log && !findString("x", intExprNegatAtts))
	{
	  warnAtt("x", "intExprNegat", a_intExprNegat);
	  check_intVal(a_intExprNegat->get_x(), 0);
	}
      else
	check_intVal(a_intExprNegat->get_x(), log);
    }
}

/********************************************************************/

void check_intExprParen(
 intExprParen * a_intExprParen,
 int log)
{
  if (a_intExprParen->get_x())
    {
      adjustLevels(&intExprParenAtts_x, "intExprParen x");
      if (log && !findString("x", intExprParenAtts))
	{
	  warnAtt("x", "intExprParen", a_intExprParen);
	  check_intVal(a_intExprParen->get_x(), 0);
	}
      else
	check_intVal(a_intExprParen->get_x(), log);
    }
}

/********************************************************************/

void check_intExprPlus(
 intExprPlus * a_intExprPlus,
 int log)
{
  if (a_intExprPlus->get_term1())
    {
      adjustLevels(&intExprPlusAtts_term1, "intExprPlus term1");
      if (log && !findString("term1", intExprPlusAtts))
	{
	  warnAtt("term1", "intExprPlus", a_intExprPlus);
	  check_intVal(a_intExprPlus->get_term1(), 0);
	}
      else
	check_intVal(a_intExprPlus->get_term1(), log);
    }
  if (a_intExprPlus->get_term2())
    {
      adjustLevels(&intExprPlusAtts_term2, "intExprPlus term2");
      if (log && !findString("term2", intExprPlusAtts))
	{
	  warnAtt("term2", "intExprPlus", a_intExprPlus);
	  check_intVal(a_intExprPlus->get_term2(), 0);
	}
      else
	check_intVal(a_intExprPlus->get_term2(), log);
    }
}

/********************************************************************/

void check_intExprPosit(
 intExprPosit * a_intExprPosit,
 int log)
{
  if (a_intExprPosit->get_x())
    {
      adjustLevels(&intExprPositAtts_x, "intExprPosit x");
      if (log && !findString("x", intExprPositAtts))
	{
	  warnAtt("x", "intExprPosit", a_intExprPosit);
	  check_intVal(a_intExprPosit->get_x(), 0);
	}
      else
	check_intVal(a_intExprPosit->get_x(), log);
    }
}

/********************************************************************/

void check_intExprPower(
 intExprPower * a_intExprPower,
 int log)
{
  if (a_intExprPower->get_base())
    {
      adjustLevels(&intExprPowerAtts_base, "intExprPower base");
      if (log && !findString("base", intExprPowerAtts))
	{
	  warnAtt("base", "intExprPower", a_intExprPower);
	  check_intVal(a_intExprPower->get_base(), 0);
	}
      else
	check_intVal(a_intExprPower->get_base(), log);
    }
  if (a_intExprPower->get_expon())
    {
      adjustLevels(&intExprPowerAtts_expon, "intExprPower expon");
      if (log && !findString("expon", intExprPowerAtts))
	{
	  warnAtt("expon", "intExprPower", a_intExprPower);
	  check_intVal(a_intExprPower->get_expon(), 0);
	}
      else
	check_intVal(a_intExprPower->get_expon(), log);
    }
}

/********************************************************************/

void check_intExprTimes(
 intExprTimes * a_intExprTimes,
 int log)
{
  if (a_intExprTimes->get_term1())
    {
      adjustLevels(&intExprTimesAtts_term1, "intExprTimes term1");
      if (log && !findString("term1", intExprTimesAtts))
	{
	  warnAtt("term1", "intExprTimes", a_intExprTimes);
	  check_intVal(a_intExprTimes->get_term1(), 0);
	}
      else
	check_intVal(a_intExprTimes->get_term1(), log);
    }
  if (a_intExprTimes->get_term2())
    {
      adjustLevels(&intExprTimesAtts_term2, "intExprTimes term2");
      if (log && !findString("term2", intExprTimesAtts))
	{
	  warnAtt("term2", "intExprTimes", a_intExprTimes);
	  check_intVal(a_intExprTimes->get_term2(), 0);
	}
      else
	check_intVal(a_intExprTimes->get_term2(), log);
    }
}

/********************************************************************/

void check_intFunc(
 intFunc * a_intFunc,
 int log)
{
  if (isA(a_intFunc, intFuncAbs))
    {
      adjustLevels(&intFuncSubs_intFuncAbs, "intFuncAbs");
      if (log && !findString("intFuncAbs", intFuncSubs))
	{
	  warnSub("intFuncAbs", "intFunc", a_intFunc);
	  check_intFuncAbs(dynamic_cast<intFuncAbs *>(a_intFunc), 0);
	}
      else
	check_intFuncAbs(dynamic_cast<intFuncAbs *>(a_intFunc), log);
      return;
    }
  if (isA(a_intFunc, intFuncIndx))
    {
      adjustLevels(&intFuncSubs_intFuncIndx, "intFuncIndx");
      if (log && !findString("intFuncIndx", intFuncSubs))
	{
	  warnSub("intFuncIndx", "intFunc", a_intFunc);
	  check_intFuncIndx(dynamic_cast<intFuncIndx *>(a_intFunc), 0);
	}
      else
	check_intFuncIndx(dynamic_cast<intFuncIndx *>(a_intFunc), log);
      return;
    }
  if (isA(a_intFunc, intFuncInt))
    {
      adjustLevels(&intFuncSubs_intFuncInt, "intFuncInt");
      if (log && !findString("intFuncInt", intFuncSubs))
	{
	  warnSub("intFuncInt", "intFunc", a_intFunc);
	  check_intFuncInt(dynamic_cast<intFuncInt *>(a_intFunc), 0);
	}
      else
	check_intFuncInt(dynamic_cast<intFuncInt *>(a_intFunc), log);
      return;
    }
  if (isA(a_intFunc, intFuncLen))
    {
      adjustLevels(&intFuncSubs_intFuncLen, "intFuncLen");
      if (log && !findString("intFuncLen", intFuncSubs))
	{
	  warnSub("intFuncLen", "intFunc", a_intFunc);
	  check_intFuncLen(dynamic_cast<intFuncLen *>(a_intFunc), 0);
	}
      else
	check_intFuncLen(dynamic_cast<intFuncLen *>(a_intFunc), log);
      return;
    }
  if (isA(a_intFunc, intFuncMod))
    {
      adjustLevels(&intFuncSubs_intFuncMod, "intFuncMod");
      if (log && !findString("intFuncMod", intFuncSubs))
	{
	  warnSub("intFuncMod", "intFunc", a_intFunc);
	  check_intFuncMod(dynamic_cast<intFuncMod *>(a_intFunc), 0);
	}
      else
	check_intFuncMod(dynamic_cast<intFuncMod *>(a_intFunc), log);
      return;
    }
  if (isA(a_intFunc, intFuncNint))
    {
      adjustLevels(&intFuncSubs_intFuncNint, "intFuncNint");
      if (log && !findString("intFuncNint", intFuncSubs))
	{
	  warnSub("intFuncNint", "intFunc", a_intFunc);
	  check_intFuncNint(dynamic_cast<intFuncNint *>(a_intFunc), 0);
	}
      else
	check_intFuncNint(dynamic_cast<intFuncNint *>(a_intFunc), log);
      return;
    }
  if (isA(a_intFunc, intFuncOrd))
    {
      adjustLevels(&intFuncSubs_intFuncOrd, "intFuncOrd");
      if (log && !findString("intFuncOrd", intFuncSubs))
	{
	  warnSub("intFuncOrd", "intFunc", a_intFunc);
	  check_intFuncOrd(dynamic_cast<intFuncOrd *>(a_intFunc), 0);
	}
      else
	check_intFuncOrd(dynamic_cast<intFuncOrd *>(a_intFunc), log);
      return;
    }
  if (isA(a_intFunc, intFuncPtdata))
    {
      adjustLevels(&intFuncSubs_intFuncPtdata, "intFuncPtdata");
      if (log && !findString("intFuncPtdata", intFuncSubs))
	{
	  warnSub("intFuncPtdata", "intFunc", a_intFunc);
	  check_intFuncPtdata(dynamic_cast<intFuncPtdata *>(a_intFunc), 0);
	}
      else
	check_intFuncPtdata(dynamic_cast<intFuncPtdata *>(a_intFunc), log);
      return;
    }
  if (isA(a_intFunc, intFuncSensnotouch))
    {
      adjustLevels(&intFuncSubs_intFuncSensnotouch, "intFuncSensnotouch");
      if (log && !findString("intFuncSensnotouch", intFuncSubs))
	{
	  warnSub("intFuncSensnotouch", "intFunc", a_intFunc);
	}
      return;
    }
  if (isA(a_intFunc, intFuncSign))
    {
      adjustLevels(&intFuncSubs_intFuncSign, "intFuncSign");
      if (log && !findString("intFuncSign", intFuncSubs))
	{
	  warnSub("intFuncSign", "intFunc", a_intFunc);
	  check_intFuncSign(dynamic_cast<intFuncSign *>(a_intFunc), 0);
	}
      else
	check_intFuncSign(dynamic_cast<intFuncSign *>(a_intFunc), log);
      return;
    }
  if (isA(a_intFunc, intFuncSiltch))
    {
      adjustLevels(&intFuncSubs_intFuncSiltch, "intFuncSiltch");
      if (log && !findString("intFuncSiltch", intFuncSubs))
	{
	  warnSub("intFuncSiltch", "intFunc", a_intFunc);
	}
      return;
    }
}

/********************************************************************/

void check_intFuncAbs(
 intFuncAbs * a_intFuncAbs,
 int log)
{
  if (a_intFuncAbs->get_x())
    {
      adjustLevels(&intFuncAbsAtts_x, "intFuncAbs x");
      if (log && !findString("x", intFuncAbsAtts))
	{
	  warnAtt("x", "intFuncAbs", a_intFuncAbs);
	  check_intVal(a_intFuncAbs->get_x(), 0);
	}
      else
	check_intVal(a_intFuncAbs->get_x(), log);
    }
}

/********************************************************************/

void check_intFuncIndx(
 intFuncIndx * a_intFuncIndx,
 int log)
{
  if (a_intFuncIndx->get_str())
    {
      adjustLevels(&intFuncIndxAtts_str, "intFuncIndx str");
      if (log && !findString("str", intFuncIndxAtts))
	{
	  warnAtt("str", "intFuncIndx", a_intFuncIndx);
	  check_stringVal(a_intFuncIndx->get_str(), 0);
	}
      else
	check_stringVal(a_intFuncIndx->get_str(), log);
    }
  if (a_intFuncIndx->get_sstr())
    {
      adjustLevels(&intFuncIndxAtts_sstr, "intFuncIndx sstr");
      if (log && !findString("sstr", intFuncIndxAtts))
	{
	  warnAtt("sstr", "intFuncIndx", a_intFuncIndx);
	  check_stringVal(a_intFuncIndx->get_sstr(), 0);
	}
      else
	check_stringVal(a_intFuncIndx->get_sstr(), log);
    }
}

/********************************************************************/

void check_intFuncInt(
 intFuncInt * a_intFuncInt,
 int log)
{
  if (a_intFuncInt->get_realVal())
    {
      adjustLevels(&intFuncIntAtts_a_realVal, "intFuncInt a_realVal");
      if (log && !findString("a_realVal", intFuncIntAtts))
	{
	  warnAtt("a_realVal", "intFuncInt", a_intFuncInt);
	  check_realVal(a_intFuncInt->get_realVal(), 0);
	}
      else
	check_realVal(a_intFuncInt->get_realVal(), log);
    }
}

/********************************************************************/

void check_intFuncLen(
 intFuncLen * a_intFuncLen,
 int log)
{
  if (a_intFuncLen->get_str())
    {
      adjustLevels(&intFuncLenAtts_str, "intFuncLen str");
      if (log && !findString("str", intFuncLenAtts))
	{
	  warnAtt("str", "intFuncLen", a_intFuncLen);
	  check_stringVal(a_intFuncLen->get_str(), 0);
	}
      else
	check_stringVal(a_intFuncLen->get_str(), log);
    }
}

/********************************************************************/

void check_intFuncMod(
 intFuncMod * a_intFuncMod,
 int log)
{
  if (a_intFuncMod->get_num())
    {
      adjustLevels(&intFuncModAtts_num, "intFuncMod num");
      if (log && !findString("num", intFuncModAtts))
	{
	  warnAtt("num", "intFuncMod", a_intFuncMod);
	  check_intVal(a_intFuncMod->get_num(), 0);
	}
      else
	check_intVal(a_intFuncMod->get_num(), log);
    }
  if (a_intFuncMod->get_dvisr())
    {
      adjustLevels(&intFuncModAtts_dvisr, "intFuncMod dvisr");
      if (log && !findString("dvisr", intFuncModAtts))
	{
	  warnAtt("dvisr", "intFuncMod", a_intFuncMod);
	  check_intVal(a_intFuncMod->get_dvisr(), 0);
	}
      else
	check_intVal(a_intFuncMod->get_dvisr(), log);
    }
}

/********************************************************************/

void check_intFuncNint(
 intFuncNint * a_intFuncNint,
 int log)
{
  if (a_intFuncNint->get_realVal())
    {
      adjustLevels(&intFuncNintAtts_a_realVal, "intFuncNint a_realVal");
      if (log && !findString("a_realVal", intFuncNintAtts))
	{
	  warnAtt("a_realVal", "intFuncNint", a_intFuncNint);
	  check_realVal(a_intFuncNint->get_realVal(), 0);
	}
      else
	check_realVal(a_intFuncNint->get_realVal(), log);
    }
}

/********************************************************************/

void check_intFuncOrd(
 intFuncOrd * a_intFuncOrd,
 int log)
{
  if (isA(a_intFuncOrd, intFuncOrd_stringVal))
    {
      adjustLevels(&intFuncOrdSubs_intFuncOrd_stringVal,
		   "intFuncOrd_stringVal");
      if (log && !findString("intFuncOrd_stringVal", intFuncOrdSubs))
	{
	  warnSub("intFuncOrd_stringVal", "intFuncOrd", a_intFuncOrd);
	  check_intFuncOrd_stringVal(
	    dynamic_cast<intFuncOrd_stringVal *>(a_intFuncOrd), 0);
	}
      else
	check_intFuncOrd_stringVal(
	  dynamic_cast<intFuncOrd_stringVal *>(a_intFuncOrd), log);
      return;
    }
  if (isA(a_intFuncOrd, intFuncOrd_boolVal))
    {
      adjustLevels(&intFuncOrdSubs_intFuncOrd_boolVal, "intFuncOrd_boolVal");
      if (log && !findString("intFuncOrd_boolVal", intFuncOrdSubs))
	{
	  warnSub("intFuncOrd_boolVal", "intFuncOrd", a_intFuncOrd);
	  check_intFuncOrd_boolVal(
	    dynamic_cast<intFuncOrd_boolVal *>(a_intFuncOrd), 0);
	}
      else
	check_intFuncOrd_boolVal(
	  dynamic_cast<intFuncOrd_boolVal *>(a_intFuncOrd), log);
      return;
    }
}

/********************************************************************/

void check_intFuncOrd_boolVal(
 intFuncOrd_boolVal * a_intFuncOrd_boolVal,
 int log)
{
  if (a_intFuncOrd_boolVal->get_boolVal())
    {
      adjustLevels(&intFuncOrd_boolValAtts_a_boolVal,
		   "intFuncOrd_boolVal a_boolVal");
      if (log && !findString("a_boolVal", intFuncOrd_boolValAtts))
	{
	  warnAtt("a_boolVal", "intFuncOrd_boolVal", a_intFuncOrd_boolVal);
	  check_boolVal(a_intFuncOrd_boolVal->get_boolVal(), 0);
	}
      else
	check_boolVal(a_intFuncOrd_boolVal->get_boolVal(), log);
    }
}

/********************************************************************/

void check_intFuncOrd_stringVal(
 intFuncOrd_stringVal * a_intFuncOrd_stringVal,
 int log)
{
  if (a_intFuncOrd_stringVal->get_str())
    {
      adjustLevels(&intFuncOrd_stringValAtts_str, "intFuncOrd_stringVal str");
      if (log && !findString("str", intFuncOrd_stringValAtts))
	{
	  warnAtt("str", "intFuncOrd_stringVal", a_intFuncOrd_stringVal);
	  check_stringVal(a_intFuncOrd_stringVal->get_str(), 0);
	}
      else
	check_stringVal(a_intFuncOrd_stringVal->get_str(), log);
    }
}

/********************************************************************/

void check_intFuncPtdata(
 intFuncPtdata * a_intFuncPtdata,
 int log)
{
  if (a_intFuncPtdata->get_faLabel())
    {
      funcPtdataFlag = 1;
      //adjustLevels(&intFuncPtdataAtts_a_faLabel, "intFuncPtdata a_faLabel");
      if (log && !findString("a_faLabel", intFuncPtdataAtts))
	{
	  warnAtt("a_faLabel", "intFuncPtdata", a_intFuncPtdata);
	  check_faLabel(a_intFuncPtdata->get_faLabel(), 0);
	}
      else
	check_faLabel(a_intFuncPtdata->get_faLabel(), log);
    }
}

/********************************************************************/

void check_intFuncSign(
 intFuncSign * a_intFuncSign,
 int log)
{
  if (a_intFuncSign->get_x())
    {
      adjustLevels(&intFuncSignAtts_x, "intFuncSign x");
      if (log && !findString("x", intFuncSignAtts))
	{
	  warnAtt("x", "intFuncSign", a_intFuncSign);
	  check_intVal(a_intFuncSign->get_x(), 0);
	}
      else
	check_intVal(a_intFuncSign->get_x(), log);
    }
  if (a_intFuncSign->get_y())
    {
      adjustLevels(&intFuncSignAtts_y, "intFuncSign y");
      if (log && !findString("y", intFuncSignAtts))
	{
	  warnAtt("y", "intFuncSign", a_intFuncSign);
	  check_intVal(a_intFuncSign->get_y(), 0);
	}
      else
	check_intVal(a_intFuncSign->get_y(), log);
    }
}

/********************************************************************/

void check_intRealExpr(
 intRealExpr * a_intRealExpr,
 int log)
{
  if (isA(a_intRealExpr, intRealExpr_PLUS))
    {
      adjustLevels(&intRealExprSubs_intRealExpr_PLUS, "intRealExpr_PLUS");
      if (log && !findString("intRealExpr_PLUS", intRealExprSubs))
	{
	  warnSub("intRealExpr_PLUS", "intRealExpr", a_intRealExpr);
	  check_intRealExpr_PLUS(
	    dynamic_cast<intRealExpr_PLUS *>(a_intRealExpr), 0);
	}
      else
	check_intRealExpr_PLUS(
	  dynamic_cast<intRealExpr_PLUS *>(a_intRealExpr), log);
      return;
    }
  if (isA(a_intRealExpr, intRealExpr_MINUS))
    {
      adjustLevels(&intRealExprSubs_intRealExpr_MINUS, "intRealExpr_MINUS");
      if (log && !findString("intRealExpr_MINUS", intRealExprSubs))
	{
	  warnSub("intRealExpr_MINUS", "intRealExpr", a_intRealExpr);
	  check_intRealExpr_MINUS(
	    dynamic_cast<intRealExpr_MINUS *>(a_intRealExpr), 0);
	}
      else
	check_intRealExpr_MINUS(
	  dynamic_cast<intRealExpr_MINUS *>(a_intRealExpr), log);
      return;
    }
  if (isA(a_intRealExpr, intRealExpr_TIMES))
    {
      adjustLevels(&intRealExprSubs_intRealExpr_TIMES, "intRealExpr_TIMES");
      if (log && !findString("intRealExpr_TIMES", intRealExprSubs))
	{
	  warnSub("intRealExpr_TIMES", "intRealExpr", a_intRealExpr);
	  check_intRealExpr_TIMES(
	    dynamic_cast<intRealExpr_TIMES *>(a_intRealExpr), 0);
	}
      else
	check_intRealExpr_TIMES(
	  dynamic_cast<intRealExpr_TIMES *>(a_intRealExpr), log);
      return;
    }
  if (isA(a_intRealExpr, intRealExpr_DIVID))
    {
      adjustLevels(&intRealExprSubs_intRealExpr_DIVID, "intRealExpr_DIVID");
      if (log && !findString("intRealExpr_DIVID", intRealExprSubs))
	{
	  warnSub("intRealExpr_DIVID", "intRealExpr", a_intRealExpr);
	  check_intRealExpr_DIVID(
	    dynamic_cast<intRealExpr_DIVID *>(a_intRealExpr), 0);
	}
      else
	check_intRealExpr_DIVID(
	  dynamic_cast<intRealExpr_DIVID *>(a_intRealExpr), log);
      return;
    }
  if (isA(a_intRealExpr, intRealExpr_POWER))
    {
      adjustLevels(&intRealExprSubs_intRealExpr_POWER, "intRealExpr_POWER");
      if (log && !findString("intRealExpr_POWER", intRealExprSubs))
	{
	  warnSub("intRealExpr_POWER", "intRealExpr", a_intRealExpr);
	  check_intRealExpr_POWER(
	    dynamic_cast<intRealExpr_POWER *>(a_intRealExpr), 0);
	}
      else
	check_intRealExpr_POWER(
	  dynamic_cast<intRealExpr_POWER *>(a_intRealExpr), log);
      return;
    }
}

/********************************************************************/

void check_intRealExpr_DIVID(
 intRealExpr_DIVID * a_intRealExpr_DIVID,
 int log)
{
  if (a_intRealExpr_DIVID->get_dvend())
    {
      adjustLevels(&intRealExpr_DIVIDAtts_dvend, "intRealExpr_DIVID dvend");
      if (log && !findString("dvend", intRealExpr_DIVIDAtts))
	{
	  warnAtt("dvend", "intRealExpr_DIVID", a_intRealExpr_DIVID);
	  check_intVal(a_intRealExpr_DIVID->get_dvend(), 0);
	}
      else
	check_intVal(a_intRealExpr_DIVID->get_dvend(), log);
    }
  if (a_intRealExpr_DIVID->get_dvisr())
    {
      adjustLevels(&intRealExpr_DIVIDAtts_dvisr, "intRealExpr_DIVID dvisr");
      if (log && !findString("dvisr", intRealExpr_DIVIDAtts))
	{
	  warnAtt("dvisr", "intRealExpr_DIVID", a_intRealExpr_DIVID);
	  check_realVal(a_intRealExpr_DIVID->get_dvisr(), 0);
	}
      else
	check_realVal(a_intRealExpr_DIVID->get_dvisr(), log);
    }
}

/********************************************************************/

void check_intRealExpr_MINUS(
 intRealExpr_MINUS * a_intRealExpr_MINUS,
 int log)
{
  if (a_intRealExpr_MINUS->get_term1())
    {
      adjustLevels(&intRealExpr_MINUSAtts_term1, "intRealExpr_MINUS term1");
      if (log && !findString("term1", intRealExpr_MINUSAtts))
	{
	  warnAtt("term1", "intRealExpr_MINUS", a_intRealExpr_MINUS);
	  check_intVal(a_intRealExpr_MINUS->get_term1(), 0);
	}
      else
	check_intVal(a_intRealExpr_MINUS->get_term1(), log);
    }
  if (a_intRealExpr_MINUS->get_term2())
    {
      adjustLevels(&intRealExpr_MINUSAtts_term2, "intRealExpr_MINUS term2");
      if (log && !findString("term2", intRealExpr_MINUSAtts))
	{
	  warnAtt("term2", "intRealExpr_MINUS", a_intRealExpr_MINUS);
	  check_realVal(a_intRealExpr_MINUS->get_term2(), 0);
	}
      else
	check_realVal(a_intRealExpr_MINUS->get_term2(), log);
    }
}

/********************************************************************/

void check_intRealExpr_PLUS(
 intRealExpr_PLUS * a_intRealExpr_PLUS,
 int log)
{
  if (a_intRealExpr_PLUS->get_term1())
    {
      adjustLevels(&intRealExpr_PLUSAtts_term1, "intRealExpr_PLUS term1");
      if (log && !findString("term1", intRealExpr_PLUSAtts))
	{
	  warnAtt("term1", "intRealExpr_PLUS", a_intRealExpr_PLUS);
	  check_intVal(a_intRealExpr_PLUS->get_term1(), 0);
	}
      else
	check_intVal(a_intRealExpr_PLUS->get_term1(), log);
    }
  if (a_intRealExpr_PLUS->get_term2())
    {
      adjustLevels(&intRealExpr_PLUSAtts_term2, "intRealExpr_PLUS term2");
      if (log && !findString("term2", intRealExpr_PLUSAtts))
	{
	  warnAtt("term2", "intRealExpr_PLUS", a_intRealExpr_PLUS);
	  check_realVal(a_intRealExpr_PLUS->get_term2(), 0);
	}
      else
	check_realVal(a_intRealExpr_PLUS->get_term2(), log);
    }
}

/********************************************************************/

void check_intRealExpr_POWER(
 intRealExpr_POWER * a_intRealExpr_POWER,
 int log)
{
  if (a_intRealExpr_POWER->get_base())
    {
      adjustLevels(&intRealExpr_POWERAtts_base, "intRealExpr_POWER base");
      if (log && !findString("base", intRealExpr_POWERAtts))
	{
	  warnAtt("base", "intRealExpr_POWER", a_intRealExpr_POWER);
	  check_intVal(a_intRealExpr_POWER->get_base(), 0);
	}
      else
	check_intVal(a_intRealExpr_POWER->get_base(), log);
    }
  if (a_intRealExpr_POWER->get_expon())
    {
      adjustLevels(&intRealExpr_POWERAtts_expon, "intRealExpr_POWER expon");
      if (log && !findString("expon", intRealExpr_POWERAtts))
	{
	  warnAtt("expon", "intRealExpr_POWER", a_intRealExpr_POWER);
	  check_realVal(a_intRealExpr_POWER->get_expon(), 0);
	}
      else
	check_realVal(a_intRealExpr_POWER->get_expon(), log);
    }
}

/********************************************************************/

void check_intRealExpr_TIMES(
 intRealExpr_TIMES * a_intRealExpr_TIMES,
 int log)
{
  if (a_intRealExpr_TIMES->get_term1())
    {
      adjustLevels(&intRealExpr_TIMESAtts_term1, "intRealExpr_TIMES term1");
      if (log && !findString("term1", intRealExpr_TIMESAtts))
	{
	  warnAtt("term1", "intRealExpr_TIMES", a_intRealExpr_TIMES);
	  check_intVal(a_intRealExpr_TIMES->get_term1(), 0);
	}
      else
	check_intVal(a_intRealExpr_TIMES->get_term1(), log);
    }
  if (a_intRealExpr_TIMES->get_term2())
    {
      adjustLevels(&intRealExpr_TIMESAtts_term2, "intRealExpr_TIMES term2");
      if (log && !findString("term2", intRealExpr_TIMESAtts))
	{
	  warnAtt("term2", "intRealExpr_TIMES", a_intRealExpr_TIMES);
	  check_realVal(a_intRealExpr_TIMES->get_term2(), 0);
	}
      else
	check_realVal(a_intRealExpr_TIMES->get_term2(), log);
    }
}

/********************************************************************/

void check_intRealRel(
 intRealRel * a_intRealRel,
 int log)
{
  if (isA(a_intRealRel, intRealRel_EQ))
    {
      adjustLevels(&intRealRelSubs_intRealRel_EQ, "intRealRel_EQ");
      if (log && !findString("intRealRel_EQ", intRealRelSubs))
	{
	  warnSub("intRealRel_EQ", "intRealRel", a_intRealRel);
	  check_intRealRel_EQ(
	    dynamic_cast<intRealRel_EQ *>(a_intRealRel), 0);
	}
      else
	check_intRealRel_EQ(
	  dynamic_cast<intRealRel_EQ *>(a_intRealRel), log);
      return;
    }
  if (isA(a_intRealRel, intRealRel_NE))
    {
      adjustLevels(&intRealRelSubs_intRealRel_NE, "intRealRel_NE");
      if (log && !findString("intRealRel_NE", intRealRelSubs))
	{
	  warnSub("intRealRel_NE", "intRealRel", a_intRealRel);
	  check_intRealRel_NE(
	    dynamic_cast<intRealRel_NE *>(a_intRealRel), 0);
	}
      else
	check_intRealRel_NE(
	  dynamic_cast<intRealRel_NE *>(a_intRealRel), log);
      return;
    }
  if (isA(a_intRealRel, intRealRel_LT))
    {
      adjustLevels(&intRealRelSubs_intRealRel_LT, "intRealRel_LT");
      if (log && !findString("intRealRel_LT", intRealRelSubs))
	{
	  warnSub("intRealRel_LT", "intRealRel", a_intRealRel);
	  check_intRealRel_LT(
	    dynamic_cast<intRealRel_LT *>(a_intRealRel), 0);
	}
      else
	check_intRealRel_LT(
	  dynamic_cast<intRealRel_LT *>(a_intRealRel), log);
      return;
    }
  if (isA(a_intRealRel, intRealRel_LE))
    {
      adjustLevels(&intRealRelSubs_intRealRel_LE, "intRealRel_LE");
      if (log && !findString("intRealRel_LE", intRealRelSubs))
	{
	  warnSub("intRealRel_LE", "intRealRel", a_intRealRel);
	  check_intRealRel_LE(
	    dynamic_cast<intRealRel_LE *>(a_intRealRel), 0);
	}
      else
	check_intRealRel_LE(
	  dynamic_cast<intRealRel_LE *>(a_intRealRel), log);
      return;
    }
  if (isA(a_intRealRel, intRealRel_GT))
    {
      adjustLevels(&intRealRelSubs_intRealRel_GT, "intRealRel_GT");
      if (log && !findString("intRealRel_GT", intRealRelSubs))
	{
	  warnSub("intRealRel_GT", "intRealRel", a_intRealRel);
	  check_intRealRel_GT(
	    dynamic_cast<intRealRel_GT *>(a_intRealRel), 0);
	}
      else
	check_intRealRel_GT(
	  dynamic_cast<intRealRel_GT *>(a_intRealRel), log);
      return;
    }
  if (isA(a_intRealRel, intRealRel_GE))
    {
      adjustLevels(&intRealRelSubs_intRealRel_GE, "intRealRel_GE");
      if (log && !findString("intRealRel_GE", intRealRelSubs))
	{
	  warnSub("intRealRel_GE", "intRealRel", a_intRealRel);
	  check_intRealRel_GE(
	    dynamic_cast<intRealRel_GE *>(a_intRealRel), 0);
	}
      else
	check_intRealRel_GE(
	  dynamic_cast<intRealRel_GE *>(a_intRealRel), log);
      return;
    }
}

/********************************************************************/

void check_intRealRel_EQ(
 intRealRel_EQ * a_intRealRel_EQ,
 int log)
{
  if (a_intRealRel_EQ->get_left())
    {
      adjustLevels(&intRealRel_EQAtts_left, "intRealRel_EQ left");
      if (log && !findString("left", intRealRel_EQAtts))
	{
	  warnAtt("left", "intRealRel_EQ", a_intRealRel_EQ);
	  check_intVal(a_intRealRel_EQ->get_left(), 0);
	}
      else
	check_intVal(a_intRealRel_EQ->get_left(), log);
    }
  if (a_intRealRel_EQ->get_right())
    {
      adjustLevels(&intRealRel_EQAtts_right, "intRealRel_EQ right");
      if (log && !findString("right", intRealRel_EQAtts))
	{
	  warnAtt("right", "intRealRel_EQ", a_intRealRel_EQ);
	  check_realVal(a_intRealRel_EQ->get_right(), 0);
	}
      else
	check_realVal(a_intRealRel_EQ->get_right(), log);
    }
}

/********************************************************************/

void check_intRealRel_GE(
 intRealRel_GE * a_intRealRel_GE,
 int log)
{
  if (a_intRealRel_GE->get_left())
    {
      adjustLevels(&intRealRel_GEAtts_left, "intRealRel_GE left");
      if (log && !findString("left", intRealRel_GEAtts))
	{
	  warnAtt("left", "intRealRel_GE", a_intRealRel_GE);
	  check_intVal(a_intRealRel_GE->get_left(), 0);
	}
      else
	check_intVal(a_intRealRel_GE->get_left(), log);
    }
  if (a_intRealRel_GE->get_right())
    {
      adjustLevels(&intRealRel_GEAtts_right, "intRealRel_GE right");
      if (log && !findString("right", intRealRel_GEAtts))
	{
	  warnAtt("right", "intRealRel_GE", a_intRealRel_GE);
	  check_realVal(a_intRealRel_GE->get_right(), 0);
	}
      else
	check_realVal(a_intRealRel_GE->get_right(), log);
    }
}

/********************************************************************/

void check_intRealRel_GT(
 intRealRel_GT * a_intRealRel_GT,
 int log)
{
  if (a_intRealRel_GT->get_left())
    {
      adjustLevels(&intRealRel_GTAtts_left, "intRealRel_GT left");
      if (log && !findString("left", intRealRel_GTAtts))
	{
	  warnAtt("left", "intRealRel_GT", a_intRealRel_GT);
	  check_intVal(a_intRealRel_GT->get_left(), 0);
	}
      else
	check_intVal(a_intRealRel_GT->get_left(), log);
    }
  if (a_intRealRel_GT->get_right())
    {
      adjustLevels(&intRealRel_GTAtts_right, "intRealRel_GT right");
      if (log && !findString("right", intRealRel_GTAtts))
	{
	  warnAtt("right", "intRealRel_GT", a_intRealRel_GT);
	  check_realVal(a_intRealRel_GT->get_right(), 0);
	}
      else
	check_realVal(a_intRealRel_GT->get_right(), log);
    }
}

/********************************************************************/

void check_intRealRel_LE(
 intRealRel_LE * a_intRealRel_LE,
 int log)
{
  if (a_intRealRel_LE->get_left())
    {
      adjustLevels(&intRealRel_LEAtts_left, "intRealRel_LE left");
      if (log && !findString("left", intRealRel_LEAtts))
	{
	  warnAtt("left", "intRealRel_LE", a_intRealRel_LE);
	  check_intVal(a_intRealRel_LE->get_left(), 0);
	}
      else
	check_intVal(a_intRealRel_LE->get_left(), log);
    }
  if (a_intRealRel_LE->get_right())
    {
      adjustLevels(&intRealRel_LEAtts_right, "intRealRel_LE right");
      if (log && !findString("right", intRealRel_LEAtts))
	{
	  warnAtt("right", "intRealRel_LE", a_intRealRel_LE);
	  check_realVal(a_intRealRel_LE->get_right(), 0);
	}
      else
	check_realVal(a_intRealRel_LE->get_right(), log);
    }
}

/********************************************************************/

void check_intRealRel_LT(
 intRealRel_LT * a_intRealRel_LT,
 int log)
{
  if (a_intRealRel_LT->get_left())
    {
      adjustLevels(&intRealRel_LTAtts_left, "intRealRel_LT left");
      if (log && !findString("left", intRealRel_LTAtts))
	{
	  warnAtt("left", "intRealRel_LT", a_intRealRel_LT);
	  check_intVal(a_intRealRel_LT->get_left(), 0);
	}
      else
	check_intVal(a_intRealRel_LT->get_left(), log);
    }
  if (a_intRealRel_LT->get_right())
    {
      adjustLevels(&intRealRel_LTAtts_right, "intRealRel_LT right");
      if (log && !findString("right", intRealRel_LTAtts))
	{
	  warnAtt("right", "intRealRel_LT", a_intRealRel_LT);
	  check_realVal(a_intRealRel_LT->get_right(), 0);
	}
      else
	check_realVal(a_intRealRel_LT->get_right(), log);
    }
}

/********************************************************************/

void check_intRealRel_NE(
 intRealRel_NE * a_intRealRel_NE,
 int log)
{
  if (a_intRealRel_NE->get_left())
    {
      adjustLevels(&intRealRel_NEAtts_left, "intRealRel_NE left");
      if (log && !findString("left", intRealRel_NEAtts))
	{
	  warnAtt("left", "intRealRel_NE", a_intRealRel_NE);
	  check_intVal(a_intRealRel_NE->get_left(), 0);
	}
      else
	check_intVal(a_intRealRel_NE->get_left(), log);
    }
  if (a_intRealRel_NE->get_right())
    {
      adjustLevels(&intRealRel_NEAtts_right, "intRealRel_NE right");
      if (log && !findString("right", intRealRel_NEAtts))
	{
	  warnAtt("right", "intRealRel_NE", a_intRealRel_NE);
	  check_realVal(a_intRealRel_NE->get_right(), 0);
	}
      else
	check_realVal(a_intRealRel_NE->get_right(), log);
    }
}

/********************************************************************/

void check_intRel(
 intRel * a_intRel,
 int log)
{
  if (isA(a_intRel, intRel_EQ))
    {
      adjustLevels(&intRelSubs_intRel_EQ, "intRel_EQ");
      if (log && !findString("intRel_EQ", intRelSubs))
	{
	  warnSub("intRel_EQ", "intRel", a_intRel);
	  check_intRel_EQ(dynamic_cast<intRel_EQ *>(a_intRel), 0);
	}
      else
	check_intRel_EQ(dynamic_cast<intRel_EQ *>(a_intRel), log);
      return;
    }
  if (isA(a_intRel, intRel_NE))
    {
      adjustLevels(&intRelSubs_intRel_NE, "intRel_NE");
      if (log && !findString("intRel_NE", intRelSubs))
	{
	  warnSub("intRel_NE", "intRel", a_intRel);
	  check_intRel_NE(dynamic_cast<intRel_NE *>(a_intRel), 0);
	}
      else
	check_intRel_NE(dynamic_cast<intRel_NE *>(a_intRel), log);
      return;
    }
  if (isA(a_intRel, intRel_LT))
    {
      adjustLevels(&intRelSubs_intRel_LT, "intRel_LT");
      if (log && !findString("intRel_LT", intRelSubs))
	{
	  warnSub("intRel_LT", "intRel", a_intRel);
	  check_intRel_LT(dynamic_cast<intRel_LT *>(a_intRel), 0);
	}
      else
	check_intRel_LT(dynamic_cast<intRel_LT *>(a_intRel), log);
      return;
    }
  if (isA(a_intRel, intRel_LE))
    {
      adjustLevels(&intRelSubs_intRel_LE, "intRel_LE");
      if (log && !findString("intRel_LE", intRelSubs))
	{
	  warnSub("intRel_LE", "intRel", a_intRel);
	  check_intRel_LE(dynamic_cast<intRel_LE *>(a_intRel), 0);
	}
      else
	check_intRel_LE(dynamic_cast<intRel_LE *>(a_intRel), log);
      return;
    }
  if (isA(a_intRel, intRel_GT))
    {
      adjustLevels(&intRelSubs_intRel_GT, "intRel_GT");
      if (log && !findString("intRel_GT", intRelSubs))
	{
	  warnSub("intRel_GT", "intRel", a_intRel);
	  check_intRel_GT(dynamic_cast<intRel_GT *>(a_intRel), 0);
	}
      else
	check_intRel_GT(dynamic_cast<intRel_GT *>(a_intRel), log);
      return;
    }
  if (isA(a_intRel, intRel_GE))
    {
      adjustLevels(&intRelSubs_intRel_GE, "intRel_GE");
      if (log && !findString("intRel_GE", intRelSubs))
	{
	  warnSub("intRel_GE", "intRel", a_intRel);
	  check_intRel_GE(dynamic_cast<intRel_GE *>(a_intRel), 0);
	}
      else
	check_intRel_GE(dynamic_cast<intRel_GE *>(a_intRel), log);
      return;
    }
}

/********************************************************************/

void check_intRel_EQ(
 intRel_EQ * a_intRel_EQ,
 int log)
{
  if (a_intRel_EQ->get_left())
    {
      adjustLevels(&intRel_EQAtts_left, "intRel_EQ left");
      if (log && !findString("left", intRel_EQAtts))
	{
	  warnAtt("left", "intRel_EQ", a_intRel_EQ);
	  check_intVal(a_intRel_EQ->get_left(), 0);
	}
      else
	check_intVal(a_intRel_EQ->get_left(), log);
    }
  if (a_intRel_EQ->get_right())
    {
      adjustLevels(&intRel_EQAtts_right, "intRel_EQ right");
      if (log && !findString("right", intRel_EQAtts))
	{
	  warnAtt("right", "intRel_EQ", a_intRel_EQ);
	  check_intVal(a_intRel_EQ->get_right(), 0);
	}
      else
	check_intVal(a_intRel_EQ->get_right(), log);
    }
}

/********************************************************************/

void check_intRel_GE(
 intRel_GE * a_intRel_GE,
 int log)
{
  if (a_intRel_GE->get_left())
    {
      adjustLevels(&intRel_GEAtts_left, "intRel_GE left");
      if (log && !findString("left", intRel_GEAtts))
	{
	  warnAtt("left", "intRel_GE", a_intRel_GE);
	  check_intVal(a_intRel_GE->get_left(), 0);
	}
      else
	check_intVal(a_intRel_GE->get_left(), log);
    }
  if (a_intRel_GE->get_right())
    {
      adjustLevels(&intRel_GEAtts_right, "intRel_GE right");
      if (log && !findString("right", intRel_GEAtts))
	{
	  warnAtt("right", "intRel_GE", a_intRel_GE);
	  check_intVal(a_intRel_GE->get_right(), 0);
	}
      else
	check_intVal(a_intRel_GE->get_right(), log);
    }
}

/********************************************************************/

void check_intRel_GT(
 intRel_GT * a_intRel_GT,
 int log)
{
  if (a_intRel_GT->get_left())
    {
      adjustLevels(&intRel_GTAtts_left, "intRel_GT left");
      if (log && !findString("left", intRel_GTAtts))
	{
	  warnAtt("left", "intRel_GT", a_intRel_GT);
	  check_intVal(a_intRel_GT->get_left(), 0);
	}
      else
	check_intVal(a_intRel_GT->get_left(), log);
    }
  if (a_intRel_GT->get_right())
    {
      adjustLevels(&intRel_GTAtts_right, "intRel_GT right");
      if (log && !findString("right", intRel_GTAtts))
	{
	  warnAtt("right", "intRel_GT", a_intRel_GT);
	  check_intVal(a_intRel_GT->get_right(), 0);
	}
      else
	check_intVal(a_intRel_GT->get_right(), log);
    }
}

/********************************************************************/

void check_intRel_LE(
 intRel_LE * a_intRel_LE,
 int log)
{
  if (a_intRel_LE->get_left())
    {
      adjustLevels(&intRel_LEAtts_left, "intRel_LE left");
      if (log && !findString("left", intRel_LEAtts))
	{
	  warnAtt("left", "intRel_LE", a_intRel_LE);
	  check_intVal(a_intRel_LE->get_left(), 0);
	}
      else
	check_intVal(a_intRel_LE->get_left(), log);
    }
  if (a_intRel_LE->get_right())
    {
      adjustLevels(&intRel_LEAtts_right, "intRel_LE right");
      if (log && !findString("right", intRel_LEAtts))
	{
	  warnAtt("right", "intRel_LE", a_intRel_LE);
	  check_intVal(a_intRel_LE->get_right(), 0);
	}
      else
	check_intVal(a_intRel_LE->get_right(), log);
    }
}

/********************************************************************/

void check_intRel_LT(
 intRel_LT * a_intRel_LT,
 int log)
{
  if (a_intRel_LT->get_left())
    {
      adjustLevels(&intRel_LTAtts_left, "intRel_LT left");
      if (log && !findString("left", intRel_LTAtts))
	{
	  warnAtt("left", "intRel_LT", a_intRel_LT);
	  check_intVal(a_intRel_LT->get_left(), 0);
	}
      else
	check_intVal(a_intRel_LT->get_left(), log);
    }
  if (a_intRel_LT->get_right())
    {
      adjustLevels(&intRel_LTAtts_right, "intRel_LT right");
      if (log && !findString("right", intRel_LTAtts))
	{
	  warnAtt("right", "intRel_LT", a_intRel_LT);
	  check_intVal(a_intRel_LT->get_right(), 0);
	}
      else
	check_intVal(a_intRel_LT->get_right(), log);
    }
}

/********************************************************************/

void check_intRel_NE(
 intRel_NE * a_intRel_NE,
 int log)
{
  if (a_intRel_NE->get_left())
    {
      adjustLevels(&intRel_NEAtts_left, "intRel_NE left");
      if (log && !findString("left", intRel_NEAtts))
	{
	  warnAtt("left", "intRel_NE", a_intRel_NE);
	  check_intVal(a_intRel_NE->get_left(), 0);
	}
      else
	check_intVal(a_intRel_NE->get_left(), log);
    }
  if (a_intRel_NE->get_right())
    {
      adjustLevels(&intRel_NEAtts_right, "intRel_NE right");
      if (log && !findString("right", intRel_NEAtts))
	{
	  warnAtt("right", "intRel_NE", a_intRel_NE);
	  check_intVal(a_intRel_NE->get_right(), 0);
	}
      else
	check_intVal(a_intRel_NE->get_right(), log);
    }
}

/********************************************************************/

void check_intVal(
 intVal * a_intVal,
 int log)
{
  if (isA(a_intVal, intConst))
    {
      adjustLevels(&intValSubs_intConst, "intConst");
      if (log && !findString("intConst", intValSubs))
	{
	  warnSub("intConst", "intVal", a_intVal);
	  check_intConst(dynamic_cast<intConst *>(a_intVal), 0);
	}
      else
	check_intConst(dynamic_cast<intConst *>(a_intVal), log);
      return;
    }
  if (isA(a_intVal, intExpr))
    {
      adjustLevels(&intValSubs_intExpr, "intExpr");
      if (log && !findString("intExpr", intValSubs))
	{
	  warnSub("intExpr", "intVal", a_intVal);
	  check_intExpr(dynamic_cast<intExpr *>(a_intVal), 0);
	}
      else
	check_intExpr(dynamic_cast<intExpr *>(a_intVal), log);
      return;
    }
  if (isA(a_intVal, intFunc))
    {
      adjustLevels(&intValSubs_intFunc, "intFunc");
      if (log && !findString("intFunc", intValSubs))
	{
	  warnSub("intFunc", "intVal", a_intVal);
	  check_intFunc(dynamic_cast<intFunc *>(a_intVal), 0);
	}
      else
	check_intFunc(dynamic_cast<intFunc *>(a_intVal), log);
      return;
    }
  if (isA(a_intVal, intVar))
    {
      adjustLevels(&intValSubs_intVar, "intVar");
      if (log && !findString("intVar", intValSubs))
	{
	  warnSub("intVar", "intVal", a_intVal);
	  check_intVar(dynamic_cast<intVar *>(a_intVal), 0);
	}
      else
	check_intVar(dynamic_cast<intVar *>(a_intVal), log);
      return;
    }
}

/********************************************************************/

void check_intVar(
 intVar * a_intVar,
 int log)
{
  if (a_intVar->get_string())
    {
      adjustLevels(&intVarAtts_a_string, "intVar a_string");
      if (log && !findString("a_string", intVarAtts))
	{
	  warnAtt("a_string", "intVar", a_intVar);
	}
    }
  if (a_intVar->get_arrayIndex())
    {
      adjustLevels(&intVarAtts_a_arrayIndex, "intVar a_arrayIndex");
      if (log && !findString("a_arrayIndex", intVarAtts))
	{
	  warnAtt("a_arrayIndex", "intVar", a_intVar);
	  check_arrayIndex(a_intVar->get_arrayIndex(), 0);
	}
      else
	check_arrayIndex(a_intVar->get_arrayIndex(), log);
    }
}

/********************************************************************/

void check_intVecExpr_TIMES(
 intVecExpr_TIMES * a_intVecExpr_TIMES,
 int log)
{
  if (a_intVecExpr_TIMES->get_term1())
    {
      adjustLevels(&intVecExpr_TIMESAtts_term1, "intVecExpr_TIMES term1");
      if (log && !findString("term1", intVecExpr_TIMESAtts))
	{
	  warnAtt("term1", "intVecExpr_TIMES", a_intVecExpr_TIMES);
	  check_intVal(a_intVecExpr_TIMES->get_term1(), 0);
	}
      else
	check_intVal(a_intVecExpr_TIMES->get_term1(), log);
    }
  if (a_intVecExpr_TIMES->get_term2())
    {
      adjustLevels(&intVecExpr_TIMESAtts_term2, "intVecExpr_TIMES term2");
      if (log && !findString("term2", intVecExpr_TIMESAtts))
	{
	  warnAtt("term2", "intVecExpr_TIMES", a_intVecExpr_TIMES);
	  check_vectorVal(a_intVecExpr_TIMES->get_term2(), 0);
	}
      else
	check_vectorVal(a_intVecExpr_TIMES->get_term2(), log);
    }
}

/********************************************************************/

void check_intofConst(
 intofConst * a_intofConst,
 int log)
{
  if (a_intofConst->get_faLabel())
    {
      adjustLevels(&intofConstAtts_a_faLabel, "intofConst a_faLabel");
      if (log && !findString("a_faLabel", intofConstAtts))
	{
	  warnAtt("a_faLabel", "intofConst", a_intofConst);
	  check_faLabel(a_intofConst->get_faLabel(), 0);
	}
      else
	check_faLabel(a_intofConst->get_faLabel(), log);
    }
  if (a_intofConst->get_featureLabel())
    {
      adjustLevels(&intofConstAtts_a_featureLabel,
		   "intofConst a_featureLabel");
      if (log && !findString("a_featureLabel", intofConstAtts))
	{
	  warnAtt("a_featureLabel", "intofConst", a_intofConst);
	  check_featureLabel(a_intofConst->get_featureLabel(), 0);
	}
      else
	check_featureLabel(a_intofConst->get_featureLabel(), log);
    }
}

/********************************************************************/

void check_iteratConvergence(
 iteratConvergence * a_iteratConvergence,
 int log)
{
  if (isA(a_iteratConvergence, iteratConvergence_ABSL))
    {
      adjustLevels(&iteratConvergenceSubs_iteratConvergence_ABSL,
		   "iteratConvergence_ABSL");
      if (log && !findString("iteratConvergence_ABSL", iteratConvergenceSubs))
	{
	  warnSub("iteratConvergence_ABSL", "iteratConvergence",
		  a_iteratConvergence);
	  check_iteratConvergence_ABSL(
	    dynamic_cast<iteratConvergence_ABSL *>(a_iteratConvergence), 0);
	}
      else
	check_iteratConvergence_ABSL(
	  dynamic_cast<iteratConvergence_ABSL *>(a_iteratConvergence), log);
      return;
    }
  if (isA(a_iteratConvergence, iteratConvergence_INCR))
    {
      adjustLevels(&iteratConvergenceSubs_iteratConvergence_INCR,
		   "iteratConvergence_INCR");
      if (log && !findString("iteratConvergence_INCR", iteratConvergenceSubs))
	{
	  warnSub("iteratConvergence_INCR", "iteratConvergence",
		  a_iteratConvergence);
	  check_iteratConvergence_INCR(
	    dynamic_cast<iteratConvergence_INCR *>(a_iteratConvergence), 0);
	}
      else
	check_iteratConvergence_INCR(
	  dynamic_cast<iteratConvergence_INCR *>(a_iteratConvergence), log);
      return;
    }
}

/********************************************************************/

void check_iteratConvergence_ABSL(
 iteratConvergence_ABSL * a_iteratConvergence_ABSL,
 int log)
{
  if (a_iteratConvergence_ABSL->get_converg())
    {
      adjustLevels(&iteratConvergence_ABSLAtts_converg,
		   "iteratConvergence_ABSL converg");
      if (log && !findString("converg", iteratConvergence_ABSLAtts))
	{
	  warnAtt("converg", "iteratConvergence_ABSL",
		  a_iteratConvergence_ABSL);
	  check_rentVal(a_iteratConvergence_ABSL->get_converg(), 0);
	}
      else
	check_rentVal(a_iteratConvergence_ABSL->get_converg(), log);
    }
}

/********************************************************************/

void check_iteratConvergence_INCR(
 iteratConvergence_INCR * a_iteratConvergence_INCR,
 int log)
{
  if (a_iteratConvergence_INCR->get_converg())
    {
      adjustLevels(&iteratConvergence_INCRAtts_converg,
		   "iteratConvergence_INCR converg");
      if (log && !findString("converg", iteratConvergence_INCRAtts))
	{
	  warnAtt("converg", "iteratConvergence_INCR",
		  a_iteratConvergence_INCR);
	  check_rentVal(a_iteratConvergence_INCR->get_converg(), 0);
	}
      else
	check_rentVal(a_iteratConvergence_INCR->get_converg(), log);
    }
}

/********************************************************************/

void check_iteratCriterionItem(
 iteratCriterionItem * a_iteratCriterionItem,
 int log)
{
  if (a_iteratCriterionItem->get_iteratCriterionStart())
    {
      adjustLevels(&iteratCriterionItemAtts_a_iteratCriterionStart,
		   "iteratCriterionItem a_iteratCriterionStart");
      if (log && !findString("a_iteratCriterionStart",
			     iteratCriterionItemAtts))
	{
	  warnAtt("a_iteratCriterionStart", "iteratCriterionItem",
		  a_iteratCriterionItem);
	  check_iteratCriterionStart(
	    a_iteratCriterionItem->get_iteratCriterionStart(), 0);
	}
      else
	check_iteratCriterionStart(
	  a_iteratCriterionItem->get_iteratCriterionStart(), log);
    }
  if (a_iteratCriterionItem->get_featureActualList())
    {
      std::list<faLabel *> * theList;
      std::list<faLabel *>::iterator iter;
      theList = a_iteratCriterionItem->get_featureActualList();
      adjustLevels(&iteratCriterionItemAtts_a_featureActualList,
		   "iteratCriterionItem a_featureActualList");
      if (log && !findString("a_featureActualList", iteratCriterionItemAtts))
	{
	  warnAtt("a_featureActualList", "iteratCriterionItem",
		  a_iteratCriterionItem);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_faLabel(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_faLabel(*iter, log);
	}
    }
}

/********************************************************************/

void check_iteratCriterionStart(
 iteratCriterionStart * a_iteratCriterionStart,
 int log)
{
  if (isA(a_iteratCriterionStart, iteratCriterionStart_axis))
    {
      adjustLevels(&iteratCriterionStartSubs_iteratCriterionStart_axis,
		   "iteratCriterionStart_axis");
      if (log && !findString("iteratCriterionStart_axis",
			     iteratCriterionStartSubs))
	{
	  warnSub("iteratCriterionStart_axis", "iteratCriterionStart",
		  a_iteratCriterionStart);
	  check_iteratCriterionStart_axis(
	    dynamic_cast<iteratCriterionStart_axis *>(a_iteratCriterionStart), 0);
	}
      else
	check_iteratCriterionStart_axis(
	  dynamic_cast<iteratCriterionStart_axis *>(a_iteratCriterionStart), log);
      return;
    }
  if (isA(a_iteratCriterionStart, iteratCriterionStart_vector))
    {
      adjustLevels(&iteratCriterionStartSubs_iteratCriterionStart_vector,
		   "iteratCriterionStart_vector");
      if (log && !findString("iteratCriterionStart_vector",
			     iteratCriterionStartSubs))
	{
	  warnSub("iteratCriterionStart_vector", "iteratCriterionStart",
		  a_iteratCriterionStart);
	  check_iteratCriterionStart_vector(
	    dynamic_cast<iteratCriterionStart_vector *>(a_iteratCriterionStart), 0);
	}
      else
	check_iteratCriterionStart_vector(
	  dynamic_cast<iteratCriterionStart_vector *>(a_iteratCriterionStart), log);
      return;
    }
  if (isA(a_iteratCriterionStart, iteratCriterionStart_NOM))
    {
      adjustLevels(&iteratCriterionStartSubs_iteratCriterionStart_NOM,
		   "iteratCriterionStart_NOM");
      if (log && !findString("iteratCriterionStart_NOM",
			     iteratCriterionStartSubs))
	{
	  warnSub("iteratCriterionStart_NOM", "iteratCriterionStart",
		  a_iteratCriterionStart);
	}
      return;
    }
}

/********************************************************************/

void check_iteratCriterionStart_axis(
 iteratCriterionStart_axis * a_iteratCriterionStart_axis,
 int log)
{
  if (a_iteratCriterionStart_axis->get_axis())
    {
      adjustLevels(&iteratCriterionStart_axisAtts_a_axis,
		   "iteratCriterionStart_axis a_axis");
      if (log && !findString("a_axis", iteratCriterionStart_axisAtts))
	{
	  warnAtt("a_axis", "iteratCriterionStart_axis",
		  a_iteratCriterionStart_axis);
	  check_axis(a_iteratCriterionStart_axis->get_axis(), 0);
	}
      else
	check_axis(a_iteratCriterionStart_axis->get_axis(), log);
    }
}

/********************************************************************/

void check_iteratCriterionStart_vector(
 iteratCriterionStart_vector * a_iteratCriterionStart_vector,
 int log)
{
  if (a_iteratCriterionStart_vector->get_dir())
    {
      adjustLevels(&iteratCriterionStart_vectorAtts_dir,
		   "iteratCriterionStart_vector dir");
      if (log && !findString("dir", iteratCriterionStart_vectorAtts))
	{
	  warnAtt("dir", "iteratCriterionStart_vector",
		  a_iteratCriterionStart_vector);
	  check_vector(a_iteratCriterionStart_vector->get_dir(), 0);
	}
      else
	check_vector(a_iteratCriterionStart_vector->get_dir(), log);
    }
}

/********************************************************************/

void check_iteratMinor(
 iteratMinor * a_iteratMinor,
 int log)
{
  if (a_iteratMinor->get_start())
    {
      adjustLevels(&iteratMinorAtts_start, "iteratMinor start");
      if (log && !findString("start", iteratMinorAtts))
	{
	  warnAtt("start", "iteratMinor", a_iteratMinor);
	  check_jumpLabel(a_iteratMinor->get_start(), 0);
	}
      else
	check_jumpLabel(a_iteratMinor->get_start(), log);
    }
  if (a_iteratMinor->get_fail())
    {
      adjustLevels(&iteratMinorAtts_fail, "iteratMinor fail");
      if (log && !findString("fail", iteratMinorAtts))
	{
	  warnAtt("fail", "iteratMinor", a_iteratMinor);
	  check_jumpLabel(a_iteratMinor->get_fail(), 0);
	}
      else
	check_jumpLabel(a_iteratMinor->get_fail(), log);
    }
  if (a_iteratMinor->get_iteratConvergence())
    {
      adjustLevels(&iteratMinorAtts_a_iteratConvergence,
		   "iteratMinor a_iteratConvergence");
      if (log && !findString("a_iteratConvergence", iteratMinorAtts))
	{
	  warnAtt("a_iteratConvergence", "iteratMinor", a_iteratMinor);
	  check_iteratConvergence(a_iteratMinor->get_iteratConvergence(), 0);
	}
      else
	check_iteratConvergence(a_iteratMinor->get_iteratConvergence(), log);
    }
  if (a_iteratMinor->get_limit())
    {
      adjustLevels(&iteratMinorAtts_limit, "iteratMinor limit");
      if (log && !findString("limit", iteratMinorAtts))
	{
	  warnAtt("limit", "iteratMinor", a_iteratMinor);
	  check_intVal(a_iteratMinor->get_limit(), 0);
	}
      else
	check_intVal(a_iteratMinor->get_limit(), log);
    }
  if (a_iteratMinor->get_iteratCriterionList())
    {
      std::list<iteratCriterionItem *> * theList;
      std::list<iteratCriterionItem *>::iterator iter;
      theList = a_iteratMinor->get_iteratCriterionList();
      adjustLevels(&iteratMinorAtts_a_iteratCriterionList,
		   "iteratMinor a_iteratCriterionList");
      if (log && !findString("a_iteratCriterionList", iteratMinorAtts))
	{
	  warnAtt("a_iteratCriterionList", "iteratMinor", a_iteratMinor);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_iteratCriterionItem(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_iteratCriterionItem(*iter, log);
	}
    }
}

/********************************************************************/

void check_iteratStm(
 iteratStm * a_iteratStm,
 int log)
{
  if (a_iteratStm->get_realVar())
    {
      adjustLevels(&iteratStmAtts_a_realVar, "iteratStm a_realVar");
      if (log && !findString("a_realVar", iteratStmAtts))
	{
	  warnAtt("a_realVar", "iteratStm", a_iteratStm);
	  check_realVar(a_iteratStm->get_realVar(), 0);
	}
      else
	check_realVar(a_iteratStm->get_realVar(), log);
    }
  if (a_iteratStm->get_iteratMinor())
    {
      adjustLevels(&iteratStmAtts_a_iteratMinor, "iteratStm a_iteratMinor");
      if (log && !findString("a_iteratMinor", iteratStmAtts))
	{
	  warnAtt("a_iteratMinor", "iteratStm", a_iteratStm);
	  check_iteratMinor(a_iteratStm->get_iteratMinor(), 0);
	}
      else
	check_iteratMinor(a_iteratStm->get_iteratMinor(), log);
    }
}

/********************************************************************/

void check_jointConf(
 jointConf * a_jointConf,
 int log)
{
  if (a_jointConf->get_rightyLefty())
    {
      adjustLevels(&jointConfAtts_a_rightyLefty, "jointConf a_rightyLefty");
      if (log && !findString("a_rightyLefty", jointConfAtts))
	{
	  warnAtt("a_rightyLefty", "jointConf", a_jointConf);
	  check_rightyLefty(a_jointConf->get_rightyLefty(), 0);
	}
      else
	check_rightyLefty(a_jointConf->get_rightyLefty(), log);
    }
  if (a_jointConf->get_aboveBelow())
    {
      adjustLevels(&jointConfAtts_a_aboveBelow, "jointConf a_aboveBelow");
      if (log && !findString("a_aboveBelow", jointConfAtts))
	{
	  warnAtt("a_aboveBelow", "jointConf", a_jointConf);
	  check_aboveBelow(a_jointConf->get_aboveBelow(), 0);
	}
      else
	check_aboveBelow(a_jointConf->get_aboveBelow(), log);
    }
  if (a_jointConf->get_flipNoFlip())
    {
      adjustLevels(&jointConfAtts_a_flipNoFlip, "jointConf a_flipNoFlip");
      if (log && !findString("a_flipNoFlip", jointConfAtts))
	{
	  warnAtt("a_flipNoFlip", "jointConf", a_jointConf);
	  check_flipNoFlip(a_jointConf->get_flipNoFlip(), 0);
	}
      else
	check_flipNoFlip(a_jointConf->get_flipNoFlip(), log);
    }
  if (a_jointConf->get_stringList())
    {
      std::list<stringVal *> * theList;
      std::list<stringVal *>::iterator iter;
      theList = a_jointConf->get_stringList();
      adjustLevels(&jointConfAtts_a_stringList, "jointConf a_stringList");
      if (log && !findString("a_stringList", jointConfAtts))
	{
	  warnAtt("a_stringList", "jointConf", a_jointConf);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_stringVal(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_stringVal(*iter, log);
	}
    }
}

/********************************************************************/

void check_jumpLabel(
 jumpLabel * a_jumpLabel,
 int log)
{
  if (isA(a_jumpLabel, labelName))
    {
      adjustLevels(&jumpLabelSubs_labelName, "labelName");
      if (log && !findString("labelName", jumpLabelSubs))
	{
	  warnSub("labelName", "jumpLabel", a_jumpLabel);
	  check_labelName(dynamic_cast<labelName *>(a_jumpLabel), 0);
	}
      else
	check_labelName(dynamic_cast<labelName *>(a_jumpLabel), log);
      return;
    }
}

/********************************************************************/

void check_jumpStm(
 jumpStm * a_jumpStm,
 int log)
{
  if (a_jumpStm->get_labelNameConst())
    {
      adjustLevels(&jumpStmAtts_a_labelNameConst, "jumpStm a_labelNameConst");
      if (log && !findString("a_labelNameConst", jumpStmAtts))
	{
	  warnAtt("a_labelNameConst", "jumpStm", a_jumpStm);
	  check_labelNameConst(a_jumpStm->get_labelNameConst(), 0);
	}
      else
	check_labelNameConst(a_jumpStm->get_labelNameConst(), log);
    }
}

/********************************************************************/

void check_jumptoStm(
 jumptoStm * a_jumptoStm,
 int log)
{
  if (a_jumptoStm->get_jumpLabel())
    {
      adjustLevels(&jumptoStmAtts_a_jumpLabel, "jumptoStm a_jumpLabel");
      if (log && !findString("a_jumpLabel", jumptoStmAtts))
	{
	  warnAtt("a_jumpLabel", "jumptoStm", a_jumptoStm);
	  check_jumpLabel(a_jumptoStm->get_jumpLabel(), 0);
	}
      else
	check_jumpLabel(a_jumptoStm->get_jumpLabel(), log);
    }
}

/********************************************************************/

void check_kcLabel(
 kcLabel * a_kcLabel,
 int log)
{
  if (a_kcLabel->get_labelName())
    {
      adjustLevels(&kcLabelAtts_a_labelName, "kcLabel a_labelName");
      if (log && !findString("a_labelName", kcLabelAtts))
	{
	  warnAtt("a_labelName", "kcLabel", a_kcLabel);
	  check_labelName(a_kcLabel->get_labelName(), 0);
	}
      else
	check_labelName(a_kcLabel->get_labelName(), log);
    }
}

/********************************************************************/

void check_kcaLabel(
 kcaLabel * a_kcaLabel,
 int log)
{
  if (a_kcaLabel->get_labelName())
    {
      adjustLevels(&kcaLabelAtts_a_labelName, "kcaLabel a_labelName");
      if (log && !findString("a_labelName", kcaLabelAtts))
	{
	  warnAtt("a_labelName", "kcaLabel", a_kcaLabel);
	  check_labelName(a_kcaLabel->get_labelName(), 0);
	}
      else
	check_labelName(a_kcaLabel->get_labelName(), log);
    }
}

/********************************************************************/

void check_keycharMinor(
 keycharMinor * a_keycharMinor,
 int log)
{
  if (isA(a_keycharMinor, keycharOneFeature))
    {
      adjustLevels(&keycharMinorSubs_keycharOneFeature, "keycharOneFeature");
      if (log && !findString("keycharOneFeature", keycharMinorSubs))
	{
	  warnSub("keycharOneFeature", "keycharMinor", a_keycharMinor);
	  check_keycharOneFeature(
	    dynamic_cast<keycharOneFeature *>(a_keycharMinor), 0);
	}
      else
	check_keycharOneFeature(
	  dynamic_cast<keycharOneFeature *>(a_keycharMinor), log);
      return;
    }
  if (isA(a_keycharMinor, keycharTwoFeatures))
    {
      adjustLevels(&keycharMinorSubs_keycharTwoFeatures, "keycharTwoFeatures");
      if (log && !findString("keycharTwoFeatures", keycharMinorSubs))
	{
	  warnSub("keycharTwoFeatures", "keycharMinor", a_keycharMinor);
	  check_keycharTwoFeatures(
	    dynamic_cast<keycharTwoFeatures *>(a_keycharMinor), 0);
	}
      else
	check_keycharTwoFeatures(
	  dynamic_cast<keycharTwoFeatures *>(a_keycharMinor), log);
      return;
    }
}

/********************************************************************/

void check_keycharOneFeature(
 keycharOneFeature * a_keycharOneFeature,
 int log)
{
  if (a_keycharOneFeature->get_fLabel())
    {
      adjustLevels(&keycharOneFeatureAtts_a_fLabel,
		   "keycharOneFeature a_fLabel");
      if (log && !findString("a_fLabel", keycharOneFeatureAtts))
	{
	  warnAtt("a_fLabel", "keycharOneFeature", a_keycharOneFeature);
	  check_fLabel(a_keycharOneFeature->get_fLabel(), 0);
	}
      else
	check_fLabel(a_keycharOneFeature->get_fLabel(), log);
    }
  if (a_keycharOneFeature->get_tLabelList())
    {
      std::list<tLabel *> * theList;
      std::list<tLabel *>::iterator iter;
      theList = a_keycharOneFeature->get_tLabelList();
      adjustLevels(&keycharOneFeatureAtts_a_tLabelList,
		   "keycharOneFeature a_tLabelList");
      if (log && !findString("a_tLabelList", keycharOneFeatureAtts))
	{
	  warnAtt("a_tLabelList", "keycharOneFeature", a_keycharOneFeature);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_tLabel(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_tLabel(*iter, log);
	}
    }
  if (a_keycharOneFeature->get_criticality())
    {
      adjustLevels(&keycharOneFeatureAtts_a_criticality,
		   "keycharOneFeature a_criticality");
      if (log && !findString("a_criticality", keycharOneFeatureAtts))
	{
	  warnAtt("a_criticality", "keycharOneFeature", a_keycharOneFeature);
	  check_criticality(a_keycharOneFeature->get_criticality(), 0);
	}
      else
	check_criticality(a_keycharOneFeature->get_criticality(), log);
    }
}

/********************************************************************/

void check_keycharStm(
 keycharStm * a_keycharStm,
 int log)
{
  if (a_keycharStm->get_kcLabel())
    {
      adjustLevels(&keycharStmAtts_a_kcLabel, "keycharStm a_kcLabel");
      if (log && !findString("a_kcLabel", keycharStmAtts))
	{
	  warnAtt("a_kcLabel", "keycharStm", a_keycharStm);
	  check_kcLabel(a_keycharStm->get_kcLabel(), 0);
	}
      else
	check_kcLabel(a_keycharStm->get_kcLabel(), log);
    }
  if (a_keycharStm->get_keycharMinor())
    {
      adjustLevels(&keycharStmAtts_a_keycharMinor,
		   "keycharStm a_keycharMinor");
      if (log && !findString("a_keycharMinor", keycharStmAtts))
	{
	  warnAtt("a_keycharMinor", "keycharStm", a_keycharStm);
	  check_keycharMinor(a_keycharStm->get_keycharMinor(), 0);
	}
      else
	check_keycharMinor(a_keycharStm->get_keycharMinor(), log);
    }
}

/********************************************************************/

void check_keycharTwoFeatures(
 keycharTwoFeatures * a_keycharTwoFeatures,
 int log)
{
  if (a_keycharTwoFeatures->get_feat1())
    {
      adjustLevels(&keycharTwoFeaturesAtts_feat1, "keycharTwoFeatures feat1");
      if (log && !findString("feat1", keycharTwoFeaturesAtts))
	{
	  warnAtt("feat1", "keycharTwoFeatures", a_keycharTwoFeatures);
	  check_fLabel(a_keycharTwoFeatures->get_feat1(), 0);
	}
      else
	check_fLabel(a_keycharTwoFeatures->get_feat1(), log);
    }
  if (a_keycharTwoFeatures->get_feat2())
    {
      adjustLevels(&keycharTwoFeaturesAtts_feat2, "keycharTwoFeatures feat2");
      if (log && !findString("feat2", keycharTwoFeaturesAtts))
	{
	  warnAtt("feat2", "keycharTwoFeatures", a_keycharTwoFeatures);
	  check_fLabel(a_keycharTwoFeatures->get_feat2(), 0);
	}
      else
	check_fLabel(a_keycharTwoFeatures->get_feat2(), log);
    }
  if (a_keycharTwoFeatures->get_tLabel())
    {
      adjustLevels(&keycharTwoFeaturesAtts_a_tLabel,
		   "keycharTwoFeatures a_tLabel");
      if (log && !findString("a_tLabel", keycharTwoFeaturesAtts))
	{
	  warnAtt("a_tLabel", "keycharTwoFeatures", a_keycharTwoFeatures);
	  check_tLabel(a_keycharTwoFeatures->get_tLabel(), 0);
	}
      else
	check_tLabel(a_keycharTwoFeatures->get_tLabel(), log);
    }
  if (a_keycharTwoFeatures->get_criticality())
    {
      adjustLevels(&keycharTwoFeaturesAtts_a_criticality,
		   "keycharTwoFeatures a_criticality");
      if (log && !findString("a_criticality", keycharTwoFeaturesAtts))
	{
	  warnAtt("a_criticality", "keycharTwoFeatures",
		  a_keycharTwoFeatures);
	  check_criticality(a_keycharTwoFeatures->get_criticality(), 0);
	}
      else
	check_criticality(a_keycharTwoFeatures->get_criticality(), log);
    }
}

/********************************************************************/

void check_labelName(
 labelName * a_labelName,
 int log)
{
  if (isA(a_labelName, labelNameCon))
    {
      adjustLevels(&labelNameSubs_labelNameCon, "labelNameCon");
      if (log && !findString("labelNameCon", labelNameSubs))
	{
	  warnSub("labelNameCon", "labelName", a_labelName);
	  check_labelNameCon(dynamic_cast<labelNameCon *>(a_labelName), 0);
	}
      else
	check_labelNameCon(dynamic_cast<labelNameCon *>(a_labelName), log);
      return;
    }
  if (isA(a_labelName, labelNameAt))
    {
      adjustLevels(&labelNameSubs_labelNameAt, "labelNameAt");
      if (log && !findString("labelNameAt", labelNameSubs))
	{
	  warnSub("labelNameAt", "labelName", a_labelName);
	  check_labelNameAt(dynamic_cast<labelNameAt *>(a_labelName), 0);
	}
      else
	check_labelNameAt(dynamic_cast<labelNameAt *>(a_labelName), log);
      return;
    }
}

/********************************************************************/

void check_labelNameAt(
 labelNameAt * a_labelNameAt,
 int log)
{
  if (a_labelNameAt->get_stringVar())
    {
      adjustLevels(&labelNameAtAtts_a_stringVar, "labelNameAt a_stringVar");
      if (log && !findString("a_stringVar", labelNameAtAtts))
	{
	  warnAtt("a_stringVar", "labelNameAt", a_labelNameAt);
	  check_stringVar(a_labelNameAt->get_stringVar(), 0);
	}
      else
	check_stringVar(a_labelNameAt->get_stringVar(), log);
    }
}

/********************************************************************/

void check_labelNameCon(
 labelNameCon * a_labelNameCon,
 int log)
{
  if (a_labelNameCon->get_labelNameConst())
    {
      adjustLevels(&labelNameConAtts_a_labelNameConst,
		   "labelNameCon a_labelNameConst");
      if (log && !findString("a_labelNameConst", labelNameConAtts))
	{
	  warnAtt("a_labelNameConst", "labelNameCon", a_labelNameCon);
	  check_labelNameConst(a_labelNameCon->get_labelNameConst(), 0);
	}
      else
	check_labelNameConst(a_labelNameCon->get_labelNameConst(), log);
    }
}

/********************************************************************/

void check_labelNameConst(
 labelNameConst * a_labelNameConst,
 int log)
{
  if (a_labelNameConst->get_string())
    {
      adjustLevels(&labelNameConstAtts_a_string, "labelNameConst a_string");
      if (log && !findString("a_string", labelNameConstAtts))
	{
	  warnAtt("a_string", "labelNameConst", a_labelNameConst);
	}
    }
}

/********************************************************************/

void check_leftRight(
 leftRight * a_leftRight,
 int log)
{
  if (isA(a_leftRight, leftRight_LEFT))
    {
      adjustLevels(&leftRightSubs_leftRight_LEFT, "leftRight_LEFT");
      if (log && !findString("leftRight_LEFT", leftRightSubs))
	{
	  warnSub("leftRight_LEFT", "leftRight", a_leftRight);
	}
      return;
    }
  if (isA(a_leftRight, leftRight_RIGHT))
    {
      adjustLevels(&leftRightSubs_leftRight_RIGHT, "leftRight_RIGHT");
      if (log && !findString("leftRight_RIGHT", leftRightSubs))
	{
	  warnSub("leftRight_RIGHT", "leftRight", a_leftRight);
	}
      return;
    }
}

/********************************************************************/

void check_lengthUnit(
 lengthUnit * a_lengthUnit,
 int log)
{
  if (isA(a_lengthUnit, lengthUnit_MM))
    {
      adjustLevels(&lengthUnitSubs_lengthUnit_MM, "lengthUnit_MM");
      if (log && !findString("lengthUnit_MM", lengthUnitSubs))
	{
	  warnSub("lengthUnit_MM", "lengthUnit", a_lengthUnit);
	}
      return;
    }
  if (isA(a_lengthUnit, lengthUnit_CM))
    {
      adjustLevels(&lengthUnitSubs_lengthUnit_CM, "lengthUnit_CM");
      if (log && !findString("lengthUnit_CM", lengthUnitSubs))
	{
	  warnSub("lengthUnit_CM", "lengthUnit", a_lengthUnit);
	}
      return;
    }
  if (isA(a_lengthUnit, lengthUnit_METER))
    {
      adjustLevels(&lengthUnitSubs_lengthUnit_METER, "lengthUnit_METER");
      if (log && !findString("lengthUnit_METER", lengthUnitSubs))
	{
	  warnSub("lengthUnit_METER", "lengthUnit", a_lengthUnit);
	}
      return;
    }
  if (isA(a_lengthUnit, lengthUnit_INCH))
    {
      adjustLevels(&lengthUnitSubs_lengthUnit_INCH, "lengthUnit_INCH");
      if (log && !findString("lengthUnit_INCH", lengthUnitSubs))
	{
	  warnSub("lengthUnit_INCH", "lengthUnit", a_lengthUnit);
	}
      return;
    }
  if (isA(a_lengthUnit, lengthUnit_FEET))
    {
      adjustLevels(&lengthUnitSubs_lengthUnit_FEET, "lengthUnit_FEET");
      if (log && !findString("lengthUnit_FEET", lengthUnitSubs))
	{
	  warnSub("lengthUnit_FEET", "lengthUnit", a_lengthUnit);
	}
      return;
    }
}

/********************************************************************/

void check_liLabel(
 liLabel * a_liLabel,
 int log)
{
  if (a_liLabel->get_labelName())
    {
      adjustLevels(&liLabelAtts_a_labelName, "liLabel a_labelName");
      if (log && !findString("a_labelName", liLabelAtts))
	{
	  warnAtt("a_labelName", "liLabel", a_liLabel);
	  check_labelName(a_liLabel->get_labelName(), 0);
	}
      else
	check_labelName(a_liLabel->get_labelName(), log);
    }
}

/********************************************************************/

void check_litdefLight(
 litdefLight * a_litdefLight,
 int log)
{
  if (a_litdefLight->get_litdefLightType())
    {
      adjustLevels(&litdefLightAtts_a_litdefLightType,
		   "litdefLight a_litdefLightType");
      if (log && !findString("a_litdefLightType", litdefLightAtts))
	{
	  warnAtt("a_litdefLightType", "litdefLight", a_litdefLight);
	  check_litdefLightType(a_litdefLight->get_litdefLightType(), 0);
	}
      else
	check_litdefLightType(a_litdefLight->get_litdefLightType(), log);
    }
  if (a_litdefLight->get_axis())
    {
      adjustLevels(&litdefLightAtts_axis, "litdefLight axis");
      if (log && !findString("axis", litdefLightAtts))
	{
	  warnAtt("axis", "litdefLight", a_litdefLight);
	  check_vector(a_litdefLight->get_axis(), 0);
	}
      else
	check_vector(a_litdefLight->get_axis(), log);
    }
}

/********************************************************************/

void check_litdefLightType(
 litdefLightType * a_litdefLightType,
 int log)
{
  if (isA(a_litdefLightType, litdefLightType_SURF))
    {
      adjustLevels(&litdefLightTypeSubs_litdefLightType_SURF,
		   "litdefLightType_SURF");
      if (log && !findString("litdefLightType_SURF", litdefLightTypeSubs))
	{
	  warnSub("litdefLightType_SURF", "litdefLightType", a_litdefLightType);
	}
      return;
    }
  if (isA(a_litdefLightType, litdefLightType_BACK))
    {
      adjustLevels(&litdefLightTypeSubs_litdefLightType_BACK,
		   "litdefLightType_BACK");
      if (log && !findString("litdefLightType_BACK", litdefLightTypeSubs))
	{
	  warnSub("litdefLightType_BACK", "litdefLightType", a_litdefLightType);
	}
      return;
    }
  if (isA(a_litdefLightType, litdefLightType_GRID))
    {
      adjustLevels(&litdefLightTypeSubs_litdefLightType_GRID,
		   "litdefLightType_GRID");
      if (log && !findString("litdefLightType_GRID", litdefLightTypeSubs))
	{
	  warnSub("litdefLightType_GRID", "litdefLightType", a_litdefLightType);
	}
      return;
    }
  if (isA(a_litdefLightType, litdefLightType_OBLQ))
    {
      adjustLevels(&litdefLightTypeSubs_litdefLightType_OBLQ,
		   "litdefLightType_OBLQ");
      if (log && !findString("litdefLightType_OBLQ", litdefLightTypeSubs))
	{
	  warnSub("litdefLightType_OBLQ", "litdefLightType", a_litdefLightType);
	}
      return;
    }
}

/********************************************************************/

void check_litdefMinor(
 litdefMinor * a_litdefMinor,
 int log)
{
  if (isA(a_litdefMinor, litdefLight))
    {
      adjustLevels(&litdefMinorSubs_litdefLight, "litdefLight");
      if (log && !findString("litdefLight", litdefMinorSubs))
	{
	  warnSub("litdefLight", "litdefMinor", a_litdefMinor);
	  check_litdefLight(dynamic_cast<litdefLight *>(a_litdefMinor), 0);
	}
      else
	check_litdefLight(dynamic_cast<litdefLight *>(a_litdefMinor), log);
      return;
    }
  if (isA(a_litdefMinor, litdefStrobe))
    {
      adjustLevels(&litdefMinorSubs_litdefStrobe, "litdefStrobe");
      if (log && !findString("litdefStrobe", litdefMinorSubs))
	{
	  warnSub("litdefStrobe", "litdefMinor", a_litdefMinor);
	  check_litdefStrobe(
	    dynamic_cast<litdefStrobe *>(a_litdefMinor), 0);
	}
      else
	check_litdefStrobe(
	  dynamic_cast<litdefStrobe *>(a_litdefMinor), log);
      return;
    }
}

/********************************************************************/

void check_litdefStm(
 litdefStm * a_litdefStm,
 int log)
{
  if (a_litdefStm->get_vlLabel())
    {
      adjustLevels(&litdefStmAtts_a_vlLabel, "litdefStm a_vlLabel");
      if (log && !findString("a_vlLabel", litdefStmAtts))
	{
	  warnAtt("a_vlLabel", "litdefStm", a_litdefStm);
	  check_vlLabel(a_litdefStm->get_vlLabel(), 0);
	}
      else
	check_vlLabel(a_litdefStm->get_vlLabel(), log);
    }
  if (a_litdefStm->get_litdefMinor())
    {
      adjustLevels(&litdefStmAtts_a_litdefMinor, "litdefStm a_litdefMinor");
      if (log && !findString("a_litdefMinor", litdefStmAtts))
	{
	  warnAtt("a_litdefMinor", "litdefStm", a_litdefStm);
	  check_litdefMinor(a_litdefStm->get_litdefMinor(), 0);
	}
      else
	check_litdefMinor(a_litdefStm->get_litdefMinor(), log);
    }
}

/********************************************************************/

void check_litdefStrobe(
 litdefStrobe * a_litdefStrobe,
 int log)
{
  if (a_litdefStrobe->get_litdefStrobeType())
    {
      adjustLevels(&litdefStrobeAtts_a_litdefStrobeType,
		   "litdefStrobe a_litdefStrobeType");
      if (log && !findString("a_litdefStrobeType", litdefStrobeAtts))
	{
	  warnAtt("a_litdefStrobeType", "litdefStrobe", a_litdefStrobe);
	  check_litdefStrobeType(a_litdefStrobe->get_litdefStrobeType(), 0);
	}
      else
	check_litdefStrobeType(a_litdefStrobe->get_litdefStrobeType(), log);
    }
  if (a_litdefStrobe->get_timeon())
    {
      adjustLevels(&litdefStrobeAtts_timeon, "litdefStrobe timeon");
      if (log && !findString("timeon", litdefStrobeAtts))
	{
	  warnAtt("timeon", "litdefStrobe", a_litdefStrobe);
	  check_rentVal(a_litdefStrobe->get_timeon(), 0);
	}
      else
	check_rentVal(a_litdefStrobe->get_timeon(), log);
    }
  if (a_litdefStrobe->get_axis())
    {
      adjustLevels(&litdefStrobeAtts_axis, "litdefStrobe axis");
      if (log && !findString("axis", litdefStrobeAtts))
	{
	  warnAtt("axis", "litdefStrobe", a_litdefStrobe);
	  check_vector(a_litdefStrobe->get_axis(), 0);
	}
      else
	check_vector(a_litdefStrobe->get_axis(), log);
    }
}

/********************************************************************/

void check_litdefStrobeType(
 litdefStrobeType * a_litdefStrobeType,
 int log)
{
  if (isA(a_litdefStrobeType, litdefStrobeType_CYCLE))
    {
      adjustLevels(&litdefStrobeTypeSubs_litdefStrobeType_CYCLE,
		   "litdefStrobeType_CYCLE");
      if (log && !findString("litdefStrobeType_CYCLE", litdefStrobeTypeSubs))
	{
	  warnSub("litdefStrobeType_CYCLE", "litdefStrobeType",
		  a_litdefStrobeType);
	  check_litdefStrobeType_CYCLE(
	    dynamic_cast<litdefStrobeType_CYCLE *>(a_litdefStrobeType), 0);
	}
      else
	check_litdefStrobeType_CYCLE(
	  dynamic_cast<litdefStrobeType_CYCLE *>(a_litdefStrobeType), log);
      return;
    }
  if (isA(a_litdefStrobeType, litdefStrobeType_TRIGER))
    {
      adjustLevels(&litdefStrobeTypeSubs_litdefStrobeType_TRIGER,
		   "litdefStrobeType_TRIGER");
      if (log && !findString("litdefStrobeType_TRIGER", litdefStrobeTypeSubs))
	{
	  warnSub("litdefStrobeType_TRIGER", "litdefStrobeType",
		  a_litdefStrobeType);
	}
      return;
    }
}

/********************************************************************/

void check_litdefStrobeType_CYCLE(
 litdefStrobeType_CYCLE * a_litdefStrobeType_CYCLE,
 int log)
{
  if (a_litdefStrobeType_CYCLE->get_value())
    {
      adjustLevels(&litdefStrobeType_CYCLEAtts_value,
		   "litdefStrobeType_CYCLE value");
      if (log && !findString("value", litdefStrobeType_CYCLEAtts))
	{
	  warnAtt("value", "litdefStrobeType_CYCLE",
		  a_litdefStrobeType_CYCLE);
	  check_rentVal(a_litdefStrobeType_CYCLE->get_value(), 0);
	}
      else
	check_rentVal(a_litdefStrobeType_CYCLE->get_value(), log);
    }
}

/********************************************************************/

void check_locateLabel(
 locateLabel * a_locateLabel,
 int log)
{
  if (isA(a_locateLabel, faLabel))
    {
      adjustLevels(&locateLabelSubs_faLabel, "faLabel");
      if (log && !findString("faLabel", locateLabelSubs))
	{
	  warnSub("faLabel", "locateLabel", a_locateLabel);
	  check_faLabel(dynamic_cast<faLabel *>(a_locateLabel), 0);
	}
      else
	check_faLabel(dynamic_cast<faLabel *>(a_locateLabel), log);
      return;
    }
  if (isA(a_locateLabel, maLabel))
    {
      adjustLevels(&locateLabelSubs_maLabel, "maLabel");
      if (log && !findString("maLabel", locateLabelSubs))
	{
	  warnSub("maLabel", "locateLabel", a_locateLabel);
	  check_maLabel(dynamic_cast<maLabel *>(a_locateLabel), 0);
	}
      else
	check_maLabel(dynamic_cast<maLabel *>(a_locateLabel), log);
      return;
    }
  if (isA(a_locateLabel, datLabel))
    {
      adjustLevels(&locateLabelSubs_datLabel, "datLabel");
      if (log && !findString("datLabel", locateLabelSubs))
	{
	  warnSub("datLabel", "locateLabel", a_locateLabel);
	  check_datLabel(dynamic_cast<datLabel *>(a_locateLabel), 0);
	}
      else
	check_datLabel(dynamic_cast<datLabel *>(a_locateLabel), log);
      return;
    }
}

/********************************************************************/

void check_locateRotAllowed(
 locateRotAllowed * a_locateRotAllowed,
 int log)
{
  if (isA(a_locateRotAllowed, locateRotAllowed_XAXIS))
    {
      adjustLevels(&locateRotAllowedSubs_locateRotAllowed_XAXIS,
		   "locateRotAllowed_XAXIS");
      if (log && !findString("locateRotAllowed_XAXIS", locateRotAllowedSubs))
	{
	  warnSub("locateRotAllowed_XAXIS", "locateRotAllowed",
		  a_locateRotAllowed);
	}
      return;
    }
  if (isA(a_locateRotAllowed, locateRotAllowed_YAXIS))
    {
      adjustLevels(&locateRotAllowedSubs_locateRotAllowed_YAXIS,
		   "locateRotAllowed_YAXIS");
      if (log && !findString("locateRotAllowed_YAXIS", locateRotAllowedSubs))
	{
	  warnSub("locateRotAllowed_YAXIS", "locateRotAllowed",
		  a_locateRotAllowed);
	}
      return;
    }
  if (isA(a_locateRotAllowed, locateRotAllowed_ZAXIS))
    {
      adjustLevels(&locateRotAllowedSubs_locateRotAllowed_ZAXIS,
		   "locateRotAllowed_ZAXIS");
      if (log && !findString("locateRotAllowed_ZAXIS", locateRotAllowedSubs))
	{
	  warnSub("locateRotAllowed_ZAXIS", "locateRotAllowed",
		  a_locateRotAllowed);
	}
      return;
    }
  if (isA(a_locateRotAllowed, locateRotAllowed_XYAXIS))
    {
      adjustLevels(&locateRotAllowedSubs_locateRotAllowed_XYAXIS,
		   "locateRotAllowed_XYAXIS");
      if (log && !findString("locateRotAllowed_XYAXIS", locateRotAllowedSubs))
	{
	  warnSub("locateRotAllowed_XYAXIS", "locateRotAllowed",
		  a_locateRotAllowed);
	}
      return;
    }
  if (isA(a_locateRotAllowed, locateRotAllowed_YZAXIS))
    {
      adjustLevels(&locateRotAllowedSubs_locateRotAllowed_YZAXIS,
		   "locateRotAllowed_YZAXIS");
      if (log && !findString("locateRotAllowed_YZAXIS", locateRotAllowedSubs))
	{
	  warnSub("locateRotAllowed_YZAXIS", "locateRotAllowed",
		  a_locateRotAllowed);
	}
      return;
    }
  if (isA(a_locateRotAllowed, locateRotAllowed_ZXAXIS))
    {
      adjustLevels(&locateRotAllowedSubs_locateRotAllowed_ZXAXIS,
		   "locateRotAllowed_ZXAXIS");
      if (log && !findString("locateRotAllowed_ZXAXIS", locateRotAllowedSubs))
	{
	  warnSub("locateRotAllowed_ZXAXIS", "locateRotAllowed",
		  a_locateRotAllowed);
	}
      return;
    }
  if (isA(a_locateRotAllowed, locateRotAllowed_XYZAXI))
    {
      adjustLevels(&locateRotAllowedSubs_locateRotAllowed_XYZAXI,
		   "locateRotAllowed_XYZAXI");
      if (log && !findString("locateRotAllowed_XYZAXI", locateRotAllowedSubs))
	{
	  warnSub("locateRotAllowed_XYZAXI", "locateRotAllowed",
		  a_locateRotAllowed);
	}
      return;
    }
  if (isA(a_locateRotAllowed, locateRotAllowed_NOROT))
    {
      adjustLevels(&locateRotAllowedSubs_locateRotAllowed_NOROT,
		   "locateRotAllowed_NOROT");
      if (log && !findString("locateRotAllowed_NOROT", locateRotAllowedSubs))
	{
	  warnSub("locateRotAllowed_NOROT", "locateRotAllowed",
		  a_locateRotAllowed);
	}
      return;
    }
}

/********************************************************************/

void check_locateStm(
 locateStm * a_locateStm,
 int log)
{
  if (a_locateStm->get_dLabel())
    {
      adjustLevels(&locateStmAtts_a_dLabel, "locateStm a_dLabel");
      if (log && !findString("a_dLabel", locateStmAtts))
	{
	  warnAtt("a_dLabel", "locateStm", a_locateStm);
	  check_dLabel(a_locateStm->get_dLabel(), 0);
	}
      else
	check_dLabel(a_locateStm->get_dLabel(), log);
    }
  if (a_locateStm->get_locateTransAllowed())
    {
      adjustLevels(&locateStmAtts_a_locateTransAllowed,
		   "locateStm a_locateTransAllowed");
      if (log && !findString("a_locateTransAllowed", locateStmAtts))
	{
	  warnAtt("a_locateTransAllowed", "locateStm", a_locateStm);
	  check_locateTransAllowed(a_locateStm->get_locateTransAllowed(), 0);
	}
      else
	check_locateTransAllowed(a_locateStm->get_locateTransAllowed(), log);
    }
  if (a_locateStm->get_locateRotAllowed())
    {
      adjustLevels(&locateStmAtts_a_locateRotAllowed,
		   "locateStm a_locateRotAllowed");
      if (log && !findString("a_locateRotAllowed", locateStmAtts))
	{
	  warnAtt("a_locateRotAllowed", "locateStm", a_locateStm);
	  check_locateRotAllowed(a_locateStm->get_locateRotAllowed(), 0);
	}
      else
	check_locateRotAllowed(a_locateStm->get_locateRotAllowed(), log);
    }
  if (a_locateStm->get_locateLabelList())
    {
      std::list<locateLabel *> * theList;
      std::list<locateLabel *>::iterator iter;
      theList = a_locateStm->get_locateLabelList();
      adjustLevels(&locateStmAtts_a_locateLabelList,
		   "locateStm a_locateLabelList");
      if (log && !findString("a_locateLabelList", locateStmAtts))
	{
	  warnAtt("a_locateLabelList", "locateStm", a_locateStm);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_locateLabel(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_locateLabel(*iter, log);
	}
    }
}

/********************************************************************/

void check_locateTransAllowed(
 locateTransAllowed * a_locateTransAllowed,
 int log)
{
  if (isA(a_locateTransAllowed, locateTransAllowed_XDIR))
    {
      adjustLevels(&locateTransAllowedSubs_locateTransAllowed_XDIR,
		   "locateTransAllowed_XDIR");
      if (log && !findString("locateTransAllowed_XDIR",
			     locateTransAllowedSubs))
	{
	  warnSub("locateTransAllowed_XDIR", "locateTransAllowed",
		  a_locateTransAllowed);
	}
      return;
    }
  if (isA(a_locateTransAllowed, locateTransAllowed_YDIR))
    {
      adjustLevels(&locateTransAllowedSubs_locateTransAllowed_YDIR,
		   "locateTransAllowed_YDIR");
      if (log && !findString("locateTransAllowed_YDIR",
			     locateTransAllowedSubs))
	{
	  warnSub("locateTransAllowed_YDIR", "locateTransAllowed",
		  a_locateTransAllowed);
	}
      return;
    }
  if (isA(a_locateTransAllowed, locateTransAllowed_ZDIR))
    {
      adjustLevels(&locateTransAllowedSubs_locateTransAllowed_ZDIR,
		   "locateTransAllowed_ZDIR");
      if (log && !findString("locateTransAllowed_ZDIR",
			     locateTransAllowedSubs))
	{
	  warnSub("locateTransAllowed_ZDIR", "locateTransAllowed",
		  a_locateTransAllowed);
	}
      return;
    }
  if (isA(a_locateTransAllowed, locateTransAllowed_XYDIR))
    {
      adjustLevels(&locateTransAllowedSubs_locateTransAllowed_XYDIR,
		   "locateTransAllowed_XYDIR");
      if (log && !findString("locateTransAllowed_XYDIR",
			     locateTransAllowedSubs))
	{
	  warnSub("locateTransAllowed_XYDIR", "locateTransAllowed",
		  a_locateTransAllowed);
	}
      return;
    }
  if (isA(a_locateTransAllowed, locateTransAllowed_YZDIR))
    {
      adjustLevels(&locateTransAllowedSubs_locateTransAllowed_YZDIR,
		   "locateTransAllowed_YZDIR");
      if (log && !findString("locateTransAllowed_YZDIR",
			     locateTransAllowedSubs))
	{
	  warnSub("locateTransAllowed_YZDIR", "locateTransAllowed",
		  a_locateTransAllowed);
	}
      return;
    }
  if (isA(a_locateTransAllowed, locateTransAllowed_ZXDIR))
    {
      adjustLevels(&locateTransAllowedSubs_locateTransAllowed_ZXDIR,
		   "locateTransAllowed_ZXDIR");
      if (log && !findString("locateTransAllowed_ZXDIR",
			     locateTransAllowedSubs))
	{
	  warnSub("locateTransAllowed_ZXDIR", "locateTransAllowed",
		  a_locateTransAllowed);
	}
      return;
    }
  if (isA(a_locateTransAllowed, locateTransAllowed_XYZDIR))
    {
      adjustLevels(&locateTransAllowedSubs_locateTransAllowed_XYZDIR,
		   "locateTransAllowed_XYZDIR");
      if (log && !findString("locateTransAllowed_XYZDIR",
			     locateTransAllowedSubs))
	{
	  warnSub("locateTransAllowed_XYZDIR", "locateTransAllowed",
		  a_locateTransAllowed);
	}
      return;
    }
  if (isA(a_locateTransAllowed, locateTransAllowed_NOTRAN))
    {
      adjustLevels(&locateTransAllowedSubs_locateTransAllowed_NOTRAN,
		   "locateTransAllowed_NOTRAN");
      if (log && !findString("locateTransAllowed_NOTRAN",
			     locateTransAllowedSubs))
	{
	  warnSub("locateTransAllowed_NOTRAN", "locateTransAllowed",
		  a_locateTransAllowed);
	}
      return;
    }
}

/********************************************************************/

void check_longShort(
 longShort * a_longShort,
 int log)
{
  if (isA(a_longShort, longShort_LONG))
    {
      adjustLevels(&longShortSubs_longShort_LONG, "longShort_LONG");
      if (log && !findString("longShort_LONG", longShortSubs))
	{
	  warnSub("longShort_LONG", "longShort", a_longShort);
	}
      return;
    }
  if (isA(a_longShort, longShort_SHORT))
    {
      adjustLevels(&longShortSubs_longShort_SHORT, "longShort_SHORT");
      if (log && !findString("longShort_SHORT", longShortSubs))
	{
	  warnSub("longShort_SHORT", "longShort", a_longShort);
	}
      return;
    }
}

/********************************************************************/

void check_lotidStm(
 lotidStm * a_lotidStm,
 int log)
{
  if (a_lotidStm->get_liLabel())
    {
      adjustLevels(&lotidStmAtts_a_liLabel, "lotidStm a_liLabel");
      if (log && !findString("a_liLabel", lotidStmAtts))
	{
	  warnAtt("a_liLabel", "lotidStm", a_lotidStm);
	  check_liLabel(a_lotidStm->get_liLabel(), 0);
	}
      else
	check_liLabel(a_lotidStm->get_liLabel(), log);
    }
  if (a_lotidStm->get_text())
    {
      adjustLevels(&lotidStmAtts_text, "lotidStm text");
      if (log && !findString("text", lotidStmAtts))
	{
	  warnAtt("text", "lotidStm", a_lotidStm);
	  check_stringVal(a_lotidStm->get_text(), 0);
	}
      else
	check_stringVal(a_lotidStm->get_text(), log);
    }
}

/********************************************************************/

void check_mLabel(
 mLabel * a_mLabel,
 int log)
{
  if (a_mLabel->get_labelName())
    {
      adjustLevels(&mLabelAtts_a_labelName, "mLabel a_labelName");
      if (log && !findString("a_labelName", mLabelAtts))
	{
	  warnAtt("a_labelName", "mLabel", a_mLabel);
	  check_labelName(a_mLabel->get_labelName(), 0);
	}
      else
	check_labelName(a_mLabel->get_labelName(), log);
    }
}

/********************************************************************/

void check_mLabelConst(
 mLabelConst * a_mLabelConst,
 int log)
{
  if (a_mLabelConst->get_labelNameConst())
    {
      adjustLevels(&mLabelConstAtts_a_labelNameConst,
		   "mLabelConst a_labelNameConst");
      if (log && !findString("a_labelNameConst", mLabelConstAtts))
	{
	  warnAtt("a_labelNameConst", "mLabelConst", a_mLabelConst);
	  check_labelNameConst(a_mLabelConst->get_labelNameConst(), 0);
	}
      else
	check_labelNameConst(a_mLabelConst->get_labelNameConst(), log);
    }
}

/********************************************************************/

void check_maLabel(
 maLabel * a_maLabel,
 int log)
{
  if (a_maLabel->get_labelName())
    {
      adjustLevels(&maLabelAtts_a_labelName, "maLabel a_labelName");
      if (log && !findString("a_labelName", maLabelAtts))
	{
	  warnAtt("a_labelName", "maLabel", a_maLabel);
	  check_labelName(a_maLabel->get_labelName(), 0);
	}
      else
	check_labelName(a_maLabel->get_labelName(), log);
    }
}

/********************************************************************/

void check_macroBlock(
 macroBlock * a_macroBlock,
 int log)
{
  if (a_macroBlock->get_macroStm())
    {
      adjustLevels(&macroBlockAtts_a_macroStm, "macroBlock a_macroStm");
      if (log && !findString("a_macroStm", macroBlockAtts))
	{
	  warnAttBlock("macroStm", a_macroBlock->get_macroStm());
	  check_macroStm(a_macroBlock->get_macroStm(), 0);
	}
      else
	check_macroStm(a_macroBlock->get_macroStm(), log);
    }
  if (a_macroBlock->get_noParseStmList())
    {
      std::list<noParseStm *> * theList;
      std::list<noParseStm *>::iterator iter;
      theList = a_macroBlock->get_noParseStmList();
      adjustLevels(&macroBlockAtts_a_noParseStmList,
		   "macroBlock a_noParseStmList");
      if (log && !findString("a_noParseStmList", macroBlockAtts))
	{
	  warnAttBlock("noParseStmList",
	    a_macroBlock->get_noParseStmList()->front());
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_noParseStm(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_noParseStm(*iter, log);
	}
    }
  if (a_macroBlock->get_endmacStm())
    {
      adjustLevels(&macroBlockAtts_a_endmacStm, "macroBlock a_endmacStm");
      if (log && !findString("a_endmacStm", macroBlockAtts))
	{
	  warnAttBlock("endmacStm", a_macroBlock->get_endmacStm());
	}
    }
}

/********************************************************************/

void check_macroPar(
 macroPar * a_macroPar,
 int log)
{
  if (isA(a_macroPar, macroPar_MACROVARNAME))
    {
      adjustLevels(&macroParSubs_macroPar_MACROVARNAME,
		   "macroPar_MACROVARNAME");
      if (log && !findString("macroPar_MACROVARNAME", macroParSubs))
	{
	  warnSub("macroPar_MACROVARNAME", "macroPar", a_macroPar);
	  check_macroPar_MACROVARNAME(
	    dynamic_cast<macroPar_MACROVARNAME *>(a_macroPar), 0);
	}
      else
	check_macroPar_MACROVARNAME(
	  dynamic_cast<macroPar_MACROVARNAME *>(a_macroPar), log);
      return;
    }
  if (isA(a_macroPar, macroPar_stringConst))
    {
      adjustLevels(&macroParSubs_macroPar_stringConst, "macroPar_stringConst");
      if (log && !findString("macroPar_stringConst", macroParSubs))
	{
	  warnSub("macroPar_stringConst", "macroPar", a_macroPar);
	  check_macroPar_stringConst(
	    dynamic_cast<macroPar_stringConst *>(a_macroPar), 0);
	}
      else
	check_macroPar_stringConst(
	  dynamic_cast<macroPar_stringConst *>(a_macroPar), log);
      return;
    }
}

/********************************************************************/

void check_macroPar_MACROVARNAME(
 macroPar_MACROVARNAME * a_macroPar_MACROVARNAME,
 int log)
{
  if (a_macroPar_MACROVARNAME->get_string())
    {
      adjustLevels(&macroPar_MACROVARNAMEAtts_a_string,
		   "macroPar_MACROVARNAME a_string");
      if (log && !findString("a_string", macroPar_MACROVARNAMEAtts))
	{
	  warnAtt("a_string", "macroPar_MACROVARNAME",
		  a_macroPar_MACROVARNAME);
	}
    }
}

/********************************************************************/

void check_macroPar_stringConst(
 macroPar_stringConst * a_macroPar_stringConst,
 int log)
{
  if (a_macroPar_stringConst->get_stringConst())
    {
      adjustLevels(&macroPar_stringConstAtts_a_stringConst,
		   "macroPar_stringConst a_stringConst");
      if (log && !findString("a_stringConst", macroPar_stringConstAtts))
	{
	  warnAtt("a_stringConst", "macroPar_stringConst",
		  a_macroPar_stringConst);
	  check_stringConst(a_macroPar_stringConst->get_stringConst(), 0);
	}
      else
	check_stringConst(a_macroPar_stringConst->get_stringConst(), log);
    }
}

/********************************************************************/

void check_macroStm(
 macroStm * a_macroStm,
 int log)
{
  if (a_macroStm->get_mLabelConst())
    {
      adjustLevels(&macroStmAtts_a_mLabelConst, "macroStm a_mLabelConst");
      if (log && !findString("a_mLabelConst", macroStmAtts))
	{
	  warnAtt("a_mLabelConst", "macroStm", a_macroStm);
	  check_mLabelConst(a_macroStm->get_mLabelConst(), 0);
	}
      else
	check_mLabelConst(a_macroStm->get_mLabelConst(), log);
    }
  if (a_macroStm->get_macroParList())
    {
      std::list<macroPar *> * theList;
      std::list<macroPar *>::iterator iter;
      theList = a_macroStm->get_macroParList();
      adjustLevels(&macroStmAtts_a_macroParList, "macroStm a_macroParList");
      if (log && !findString("a_macroParList", macroStmAtts))
	{
	  warnAtt("a_macroParList", "macroStm", a_macroStm);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_macroPar(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_macroPar(*iter, log);
	}
    }
}

/********************************************************************/

void check_matDir(
 matDir * a_matDir,
 int log)
{
  if (isA(a_matDir, matDir_INNER))
    {
      adjustLevels(&matDirSubs_matDir_INNER, "matDir_INNER");
      if (log && !findString("matDir_INNER", matDirSubs))
	{
	  warnSub("matDir_INNER", "matDir", a_matDir);
	}
      return;
    }
  if (isA(a_matDir, matDir_OUTER))
    {
      adjustLevels(&matDirSubs_matDir_OUTER, "matDir_OUTER");
      if (log && !findString("matDir_OUTER", matDirSubs))
	{
	  warnSub("matDir_OUTER", "matDir", a_matDir);
	}
      return;
    }
}

/********************************************************************/

void check_matdefFeat(
 matdefFeat * a_matdefFeat,
 int log)
{
  if (a_matdefFeat->get_fLabel())
    {
      adjustLevels(&matdefFeatAtts_a_fLabel, "matdefFeat a_fLabel");
      if (log && !findString("a_fLabel", matdefFeatAtts))
	{
	  warnAtt("a_fLabel", "matdefFeat", a_matdefFeat);
	  check_fLabel(a_matdefFeat->get_fLabel(), 0);
	}
      else
	check_fLabel(a_matdefFeat->get_fLabel(), log);
    }
  if (a_matdefFeat->get_matdefSpec())
    {
      adjustLevels(&matdefFeatAtts_a_matdefSpec, "matdefFeat a_matdefSpec");
      if (log && !findString("a_matdefSpec", matdefFeatAtts))
	{
	  warnAtt("a_matdefSpec", "matdefFeat", a_matdefFeat);
	  check_matdefSpec(a_matdefFeat->get_matdefSpec(), 0);
	}
      else
	check_matdefSpec(a_matdefFeat->get_matdefSpec(), log);
    }
}

/********************************************************************/

void check_matdefGeom(
 matdefGeom * a_matdefGeom,
 int log)
{
  if (a_matdefGeom->get_gLabel())
    {
      adjustLevels(&matdefGeomAtts_a_gLabel, "matdefGeom a_gLabel");
      if (log && !findString("a_gLabel", matdefGeomAtts))
	{
	  warnAtt("a_gLabel", "matdefGeom", a_matdefGeom);
	  check_gLabel(a_matdefGeom->get_gLabel(), 0);
	}
      else
	check_gLabel(a_matdefGeom->get_gLabel(), log);
    }
  if (a_matdefGeom->get_matdefSpec())
    {
      adjustLevels(&matdefGeomAtts_a_matdefSpec, "matdefGeom a_matdefSpec");
      if (log && !findString("a_matdefSpec", matdefGeomAtts))
	{
	  warnAtt("a_matdefSpec", "matdefGeom", a_matdefGeom);
	  check_matdefSpec(a_matdefGeom->get_matdefSpec(), 0);
	}
      else
	check_matdefSpec(a_matdefGeom->get_matdefSpec(), log);
    }
}

/********************************************************************/

void check_matdefMat(
 matdefMat * a_matdefMat,
 int log)
{
  if (isA(a_matdefMat, matdefMat_MMC))
    {
      adjustLevels(&matdefMatSubs_matdefMat_MMC, "matdefMat_MMC");
      if (log && !findString("matdefMat_MMC", matdefMatSubs))
	{
	  warnSub("matdefMat_MMC", "matdefMat", a_matdefMat);
	  check_matdefMat_MMC(
	    dynamic_cast<matdefMat_MMC *>(a_matdefMat), 0);
	}
      else
	check_matdefMat_MMC(
	  dynamic_cast<matdefMat_MMC *>(a_matdefMat), log);
      return;
    }
  if (isA(a_matdefMat, matdefMat_LMC))
    {
      adjustLevels(&matdefMatSubs_matdefMat_LMC, "matdefMat_LMC");
      if (log && !findString("matdefMat_LMC", matdefMatSubs))
	{
	  warnSub("matdefMat_LMC", "matdefMat", a_matdefMat);
	  check_matdefMat_LMC(
	    dynamic_cast<matdefMat_LMC *>(a_matdefMat), 0);
	}
      else
	check_matdefMat_LMC(
	  dynamic_cast<matdefMat_LMC *>(a_matdefMat), log);
      return;
    }
}

/********************************************************************/

void check_matdefMat_LMC(
 matdefMat_LMC * a_matdefMat_LMC,
 int log)
{
  if (a_matdefMat_LMC->get_tLabel())
    {
      adjustLevels(&matdefMat_LMCAtts_a_tLabel, "matdefMat_LMC a_tLabel");
      if (log && !findString("a_tLabel", matdefMat_LMCAtts))
	{
	  warnAtt("a_tLabel", "matdefMat_LMC", a_matdefMat_LMC);
	  check_tLabel(a_matdefMat_LMC->get_tLabel(), 0);
	}
      else
	check_tLabel(a_matdefMat_LMC->get_tLabel(), log);
    }
}

/********************************************************************/

void check_matdefMat_MMC(
 matdefMat_MMC * a_matdefMat_MMC,
 int log)
{
  if (a_matdefMat_MMC->get_tLabel())
    {
      adjustLevels(&matdefMat_MMCAtts_a_tLabel, "matdefMat_MMC a_tLabel");
      if (log && !findString("a_tLabel", matdefMat_MMCAtts))
	{
	  warnAtt("a_tLabel", "matdefMat_MMC", a_matdefMat_MMC);
	  check_tLabel(a_matdefMat_MMC->get_tLabel(), 0);
	}
      else
	check_tLabel(a_matdefMat_MMC->get_tLabel(), log);
    }
}

/********************************************************************/

void check_matdefMating(
 matdefMating * a_matdefMating,
 int log)
{
  if (isA(a_matdefMating, matdefMating_PT2PT))
    {
      adjustLevels(&matdefMatingSubs_matdefMating_PT2PT, "matdefMating_PT2PT");
      if (log && !findString("matdefMating_PT2PT", matdefMatingSubs))
	{
	  warnSub("matdefMating_PT2PT", "matdefMating", a_matdefMating);
	}
      return;
    }
  if (isA(a_matdefMating, matdefMating_PT2LN))
    {
      adjustLevels(&matdefMatingSubs_matdefMating_PT2LN, "matdefMating_PT2LN");
      if (log && !findString("matdefMating_PT2LN", matdefMatingSubs))
	{
	  warnSub("matdefMating_PT2LN", "matdefMating", a_matdefMating);
	}
      return;
    }
  if (isA(a_matdefMating, matdefMating_PT2PL))
    {
      adjustLevels(&matdefMatingSubs_matdefMating_PT2PL, "matdefMating_PT2PL");
      if (log && !findString("matdefMating_PT2PL", matdefMatingSubs))
	{
	  warnSub("matdefMating_PT2PL", "matdefMating", a_matdefMating);
	}
      return;
    }
  if (isA(a_matdefMating, matdefMating_LN2LN))
    {
      adjustLevels(&matdefMatingSubs_matdefMating_LN2LN, "matdefMating_LN2LN");
      if (log && !findString("matdefMating_LN2LN", matdefMatingSubs))
	{
	  warnSub("matdefMating_LN2LN", "matdefMating", a_matdefMating);
	}
      return;
    }
}

/********************************************************************/

void check_matdefMethod(
 matdefMethod * a_matdefMethod,
 int log)
{
  if (isA(a_matdefMethod, matdefMethod_BF))
    {
      adjustLevels(&matdefMethodSubs_matdefMethod_BF, "matdefMethod_BF");
      if (log && !findString("matdefMethod_BF", matdefMethodSubs))
	{
	  warnSub("matdefMethod_BF", "matdefMethod", a_matdefMethod);
	}
      return;
    }
  if (isA(a_matdefMethod, matdefMethod_FZ))
    {
      adjustLevels(&matdefMethodSubs_matdefMethod_FZ, "matdefMethod_FZ");
      if (log && !findString("matdefMethod_FZ", matdefMethodSubs))
	{
	  warnSub("matdefMethod_FZ", "matdefMethod", a_matdefMethod);
	}
      return;
    }
}

/********************************************************************/

void check_matdefMinor(
 matdefMinor * a_matdefMinor,
 int log)
{
  if (isA(a_matdefMinor, matdefFeat))
    {
      adjustLevels(&matdefMinorSubs_matdefFeat, "matdefFeat");
      if (log && !findString("matdefFeat", matdefMinorSubs))
	{
	  warnSub("matdefFeat", "matdefMinor", a_matdefMinor);
	  check_matdefFeat(dynamic_cast<matdefFeat *>(a_matdefMinor), 0);
	}
      else
	check_matdefFeat(dynamic_cast<matdefFeat *>(a_matdefMinor), log);
      return;
    }
  if (isA(a_matdefMinor, matdefGeom))
    {
      adjustLevels(&matdefMinorSubs_matdefGeom, "matdefGeom");
      if (log && !findString("matdefGeom", matdefMinorSubs))
	{
	  warnSub("matdefGeom", "matdefMinor", a_matdefMinor);
	  check_matdefGeom(dynamic_cast<matdefGeom *>(a_matdefMinor), 0);
	}
      else
	check_matdefGeom(dynamic_cast<matdefGeom *>(a_matdefMinor), log);
      return;
    }
}

/********************************************************************/

void check_matdefSpec(
 matdefSpec * a_matdefSpec,
 int log)
{
  if (a_matdefSpec->get_faLabelList())
    {
      std::list<faLabel *> * theList;
      std::list<faLabel *>::iterator iter;
      theList = a_matdefSpec->get_faLabelList();
      adjustLevels(&matdefSpecAtts_a_faLabelList, "matdefSpec a_faLabelList");
      if (log && !findString("a_faLabelList", matdefSpecAtts))
	{
	  warnAtt("a_faLabelList", "matdefSpec", a_matdefSpec);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_faLabel(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_faLabel(*iter, log);
	}
    }
  if (a_matdefSpec->get_matdefType())
    {
      adjustLevels(&matdefSpecAtts_a_matdefType, "matdefSpec a_matdefType");
      if (log && !findString("a_matdefType", matdefSpecAtts))
	{
	  warnAtt("a_matdefType", "matdefSpec", a_matdefSpec);
	  check_matdefType(a_matdefSpec->get_matdefType(), 0);
	}
      else
	check_matdefType(a_matdefSpec->get_matdefType(), log);
    }
}

/********************************************************************/

void check_matdefStm(
 matdefStm * a_matdefStm,
 int log)
{
  if (a_matdefStm->get_maLabel())
    {
      adjustLevels(&matdefStmAtts_a_maLabel, "matdefStm a_maLabel");
      if (log && !findString("a_maLabel", matdefStmAtts))
	{
	  warnAtt("a_maLabel", "matdefStm", a_matdefStm);
	  check_maLabel(a_matdefStm->get_maLabel(), 0);
	}
      else
	check_maLabel(a_matdefStm->get_maLabel(), log);
    }
  if (a_matdefStm->get_matdefMinor())
    {
      adjustLevels(&matdefStmAtts_a_matdefMinor, "matdefStm a_matdefMinor");
      if (log && !findString("a_matdefMinor", matdefStmAtts))
	{
	  warnAtt("a_matdefMinor", "matdefStm", a_matdefStm);
	  check_matdefMinor(a_matdefStm->get_matdefMinor(), 0);
	}
      else
	check_matdefMinor(a_matdefStm->get_matdefMinor(), log);
    }
}

/********************************************************************/

void check_matdefType(
 matdefType * a_matdefType,
 int log)
{
  if (isA(a_matdefType, matdefTypeZone))
    {
      adjustLevels(&matdefTypeSubs_matdefTypeZone, "matdefTypeZone");
      if (log && !findString("matdefTypeZone", matdefTypeSubs))
	{
	  warnSub("matdefTypeZone", "matdefType", a_matdefType);
	  check_matdefTypeZone(
	    dynamic_cast<matdefTypeZone *>(a_matdefType), 0);
	}
      else
	check_matdefTypeZone(
	  dynamic_cast<matdefTypeZone *>(a_matdefType), log);
      return;
    }
  if (isA(a_matdefType, matdefTypeBand))
    {
      adjustLevels(&matdefTypeSubs_matdefTypeBand, "matdefTypeBand");
      if (log && !findString("matdefTypeBand", matdefTypeSubs))
	{
	  warnSub("matdefTypeBand", "matdefType", a_matdefType);
	  check_matdefTypeBand(
	    dynamic_cast<matdefTypeBand *>(a_matdefType), 0);
	}
      else
	check_matdefTypeBand(
	  dynamic_cast<matdefTypeBand *>(a_matdefType), log);
      return;
    }
}

/********************************************************************/

void check_matdefTypeBand(
 matdefTypeBand * a_matdefTypeBand,
 int log)
{
  if (a_matdefTypeBand->get_matdefMating())
    {
      adjustLevels(&matdefTypeBandAtts_a_matdefMating,
		   "matdefTypeBand a_matdefMating");
      if (log && !findString("a_matdefMating", matdefTypeBandAtts))
	{
	  warnAtt("a_matdefMating", "matdefTypeBand", a_matdefTypeBand);
	  check_matdefMating(a_matdefTypeBand->get_matdefMating(), 0);
	}
      else
	check_matdefMating(a_matdefTypeBand->get_matdefMating(), log);
    }
  if (a_matdefTypeBand->get_matdefMethod())
    {
      adjustLevels(&matdefTypeBandAtts_a_matdefMethod,
		   "matdefTypeBand a_matdefMethod");
      if (log && !findString("a_matdefMethod", matdefTypeBandAtts))
	{
	  warnAtt("a_matdefMethod", "matdefTypeBand", a_matdefTypeBand);
	  check_matdefMethod(a_matdefTypeBand->get_matdefMethod(), 0);
	}
      else
	check_matdefMethod(a_matdefTypeBand->get_matdefMethod(), log);
    }
  if (a_matdefTypeBand->get_loband())
    {
      adjustLevels(&matdefTypeBandAtts_loband, "matdefTypeBand loband");
      if (log && !findString("loband", matdefTypeBandAtts))
	{
	  warnAtt("loband", "matdefTypeBand", a_matdefTypeBand);
	  check_rentVal(a_matdefTypeBand->get_loband(), 0);
	}
      else
	check_rentVal(a_matdefTypeBand->get_loband(), log);
    }
  if (a_matdefTypeBand->get_upband())
    {
      adjustLevels(&matdefTypeBandAtts_upband, "matdefTypeBand upband");
      if (log && !findString("upband", matdefTypeBandAtts))
	{
	  warnAtt("upband", "matdefTypeBand", a_matdefTypeBand);
	  check_rentVal(a_matdefTypeBand->get_upband(), 0);
	}
      else
	check_rentVal(a_matdefTypeBand->get_upband(), log);
    }
  if (a_matdefTypeBand->get_matdefMat())
    {
      adjustLevels(&matdefTypeBandAtts_a_matdefMat,
		   "matdefTypeBand a_matdefMat");
      if (log && !findString("a_matdefMat", matdefTypeBandAtts))
	{
	  warnAtt("a_matdefMat", "matdefTypeBand", a_matdefTypeBand);
	  check_matdefMat(a_matdefTypeBand->get_matdefMat(), 0);
	}
      else
	check_matdefMat(a_matdefTypeBand->get_matdefMat(), log);
    }
}

/********************************************************************/

void check_matdefTypeZone(
 matdefTypeZone * a_matdefTypeZone,
 int log)
{
  if (a_matdefTypeZone->get_matdefMating())
    {
      adjustLevels(&matdefTypeZoneAtts_a_matdefMating,
		   "matdefTypeZone a_matdefMating");
      if (log && !findString("a_matdefMating", matdefTypeZoneAtts))
	{
	  warnAtt("a_matdefMating", "matdefTypeZone", a_matdefTypeZone);
	  check_matdefMating(a_matdefTypeZone->get_matdefMating(), 0);
	}
      else
	check_matdefMating(a_matdefTypeZone->get_matdefMating(), log);
    }
  if (a_matdefTypeZone->get_matdefMethod())
    {
      adjustLevels(&matdefTypeZoneAtts_a_matdefMethod,
		   "matdefTypeZone a_matdefMethod");
      if (log && !findString("a_matdefMethod", matdefTypeZoneAtts))
	{
	  warnAtt("a_matdefMethod", "matdefTypeZone", a_matdefTypeZone);
	  check_matdefMethod(a_matdefTypeZone->get_matdefMethod(), 0);
	}
      else
	check_matdefMethod(a_matdefTypeZone->get_matdefMethod(), log);
    }
  if (a_matdefTypeZone->get_fitzon())
    {
      adjustLevels(&matdefTypeZoneAtts_fitzon, "matdefTypeZone fitzon");
      if (log && !findString("fitzon", matdefTypeZoneAtts))
	{
	  warnAtt("fitzon", "matdefTypeZone", a_matdefTypeZone);
	  check_rentVal(a_matdefTypeZone->get_fitzon(), 0);
	}
      else
	check_rentVal(a_matdefTypeZone->get_fitzon(), log);
    }
  if (a_matdefTypeZone->get_matdefMat())
    {
      adjustLevels(&matdefTypeZoneAtts_a_matdefMat,
		   "matdefTypeZone a_matdefMat");
      if (log && !findString("a_matdefMat", matdefTypeZoneAtts))
	{
	  warnAtt("a_matdefMat", "matdefTypeZone", a_matdefTypeZone);
	  check_matdefMat(a_matdefTypeZone->get_matdefMat(), 0);
	}
      else
	check_matdefMat(a_matdefTypeZone->get_matdefMat(), log);
    }
}

/********************************************************************/

void check_matrix(
 matrix * a_matrix,
 int log)
{
  if (a_matrix->get_a1())
    {
      adjustLevels(&matrixAtts_a1, "matrix a1");
      if (log && !findString("a1", matrixAtts))
	{
	  warnAtt("a1", "matrix", a_matrix);
	  check_rentVal(a_matrix->get_a1(), 0);
	}
      else
	check_rentVal(a_matrix->get_a1(), log);
    }
  if (a_matrix->get_a2())
    {
      adjustLevels(&matrixAtts_a2, "matrix a2");
      if (log && !findString("a2", matrixAtts))
	{
	  warnAtt("a2", "matrix", a_matrix);
	  check_rentVal(a_matrix->get_a2(), 0);
	}
      else
	check_rentVal(a_matrix->get_a2(), log);
    }
  if (a_matrix->get_a3())
    {
      adjustLevels(&matrixAtts_a3, "matrix a3");
      if (log && !findString("a3", matrixAtts))
	{
	  warnAtt("a3", "matrix", a_matrix);
	  check_rentVal(a_matrix->get_a3(), 0);
	}
      else
	check_rentVal(a_matrix->get_a3(), log);
    }
  if (a_matrix->get_b1())
    {
      adjustLevels(&matrixAtts_b1, "matrix b1");
      if (log && !findString("b1", matrixAtts))
	{
	  warnAtt("b1", "matrix", a_matrix);
	  check_rentVal(a_matrix->get_b1(), 0);
	}
      else
	check_rentVal(a_matrix->get_b1(), log);
    }
  if (a_matrix->get_b2())
    {
      adjustLevels(&matrixAtts_b2, "matrix b2");
      if (log && !findString("b2", matrixAtts))
	{
	  warnAtt("b2", "matrix", a_matrix);
	  check_rentVal(a_matrix->get_b2(), 0);
	}
      else
	check_rentVal(a_matrix->get_b2(), log);
    }
  if (a_matrix->get_b3())
    {
      adjustLevels(&matrixAtts_b3, "matrix b3");
      if (log && !findString("b3", matrixAtts))
	{
	  warnAtt("b3", "matrix", a_matrix);
	  check_rentVal(a_matrix->get_b3(), 0);
	}
      else
	check_rentVal(a_matrix->get_b3(), log);
    }
  if (a_matrix->get_c1())
    {
      adjustLevels(&matrixAtts_c1, "matrix c1");
      if (log && !findString("c1", matrixAtts))
	{
	  warnAtt("c1", "matrix", a_matrix);
	  check_rentVal(a_matrix->get_c1(), 0);
	}
      else
	check_rentVal(a_matrix->get_c1(), log);
    }
  if (a_matrix->get_c2())
    {
      adjustLevels(&matrixAtts_c2, "matrix c2");
      if (log && !findString("c2", matrixAtts))
	{
	  warnAtt("c2", "matrix", a_matrix);
	  check_rentVal(a_matrix->get_c2(), 0);
	}
      else
	check_rentVal(a_matrix->get_c2(), log);
    }
  if (a_matrix->get_c3())
    {
      adjustLevels(&matrixAtts_c3, "matrix c3");
      if (log && !findString("c3", matrixAtts))
	{
	  warnAtt("c3", "matrix", a_matrix);
	  check_rentVal(a_matrix->get_c3(), 0);
	}
      else
	check_rentVal(a_matrix->get_c3(), log);
    }
  if (a_matrix->get_d1())
    {
      adjustLevels(&matrixAtts_d1, "matrix d1");
      if (log && !findString("d1", matrixAtts))
	{
	  warnAtt("d1", "matrix", a_matrix);
	  check_rentVal(a_matrix->get_d1(), 0);
	}
      else
	check_rentVal(a_matrix->get_d1(), log);
    }
  if (a_matrix->get_d2())
    {
      adjustLevels(&matrixAtts_d2, "matrix d2");
      if (log && !findString("d2", matrixAtts))
	{
	  warnAtt("d2", "matrix", a_matrix);
	  check_rentVal(a_matrix->get_d2(), 0);
	}
      else
	check_rentVal(a_matrix->get_d2(), log);
    }
  if (a_matrix->get_d3())
    {
      adjustLevels(&matrixAtts_d3, "matrix d3");
      if (log && !findString("d3", matrixAtts))
	{
	  warnAtt("d3", "matrix", a_matrix);
	  check_rentVal(a_matrix->get_d3(), 0);
	}
      else
	check_rentVal(a_matrix->get_d3(), log);
    }
}

/********************************************************************/

void check_mdLabel(
 mdLabel * a_mdLabel,
 int log)
{
  if (a_mdLabel->get_labelName())
    {
      adjustLevels(&mdLabelAtts_a_labelName, "mdLabel a_labelName");
      if (log && !findString("a_labelName", mdLabelAtts))
	{
	  warnAtt("a_labelName", "mdLabel", a_mdLabel);
	  check_labelName(a_mdLabel->get_labelName(), 0);
	}
      else
	check_labelName(a_mdLabel->get_labelName(), log);
    }
}

/********************************************************************/

void check_measBlock(
 measBlock * a_measBlock,
 int log)
{
  if (isA(a_measBlock, measBlock_measStm))
    {
      if (log && !findString("measBlock_measStm", measBlockSubs))
        {warnBlockBug("measBlock_measStm", "measBlock");}
      else
	check_measBlock_measStm(
	  dynamic_cast<measBlock_measStm *>(a_measBlock), log);
    }
  else if (isA(a_measBlock, measBlock_rmeasStm))
    {
      if (log && !findString("measBlock_rmeasStm", measBlockSubs))
        {warnBlockBug("measBlock_rmeasStm", "measBlock");}
      else
	check_measBlock_rmeasStm(
	  dynamic_cast<measBlock_rmeasStm *>(a_measBlock), log);
    }
}

/********************************************************************/

void check_measBlockItem(
 measBlockItem * a_measBlockItem,
 int log)
{
  if (isA(a_measBlockItem, measBlockStatement))
    {
      adjustLevels(&measBlockItemSubs_measBlockStatement,
		   "measBlockStatement");
      if (log && !findString("measBlockStatement", measBlockItemSubs))
	{
	  warnSub("measBlockStatement", "measBlockItem", a_measBlockItem);
	  check_measBlockStatement(
	    dynamic_cast<measBlockStatement *>(a_measBlockItem), 0);
	}
      else
	check_measBlockStatement(
	  dynamic_cast<measBlockStatement *>(a_measBlockItem), log);
      return;
    }
  if (isA(a_measBlockItem, measDoBlock))
    {
      adjustLevels(&measBlockItemSubs_measDoBlock, "measDoBlock");
      if (log && !findString("measDoBlock", measBlockItemSubs))
	{
	  warnSub("measDoBlock", "measBlockItem", a_measBlockItem);
	  check_measDoBlock(
	    dynamic_cast<measDoBlock *>(a_measBlockItem), 0);
	}
      else
	check_measDoBlock(
	  dynamic_cast<measDoBlock *>(a_measBlockItem), log);
      return;
    }
  if (isA(a_measBlockItem, measIfBlock))
    {
      adjustLevels(&measBlockItemSubs_measIfBlock, "measIfBlock");
      if (log && !findString("measIfBlock", measBlockItemSubs))
	{
	  warnSub("measIfBlock", "measBlockItem", a_measBlockItem);
	  check_measIfBlock(
	    dynamic_cast<measIfBlock *>(a_measBlockItem), 0);
	}
      else
	check_measIfBlock(
	  dynamic_cast<measIfBlock *>(a_measBlockItem), log);
      return;
    }
  if (isA(a_measBlockItem, measSelectBlock))
    {
      adjustLevels(&measBlockItemSubs_measSelectBlock, "measSelectBlock");
      if (log && !findString("measSelectBlock", measBlockItemSubs))
	{
	  warnSub("measSelectBlock", "measBlockItem", a_measBlockItem);
	  check_measSelectBlock(
	    dynamic_cast<measSelectBlock *>(a_measBlockItem), 0);
	}
      else
	check_measSelectBlock(
	  dynamic_cast<measSelectBlock *>(a_measBlockItem), log);
      return;
    }
}

/********************************************************************/

void check_measBlockStatement(
 measBlockStatement * a_measBlockStatement,
 int log)
{
  if (isA(a_measBlockStatement, calibSensBlockStatement))
    {
      adjustLevels(&measBlockStatementSubs_calibSensBlockStatement,
		   "calibSensBlockStatement");
      if (log && !findString("calibSensBlockStatement",
			     measBlockStatementSubs))
	{
	  warnSub("calibSensBlockStatement", "measBlockStatement",
		  a_measBlockStatement);
	  check_calibSensBlockStatement(
	    dynamic_cast<calibSensBlockStatement *>(a_measBlockStatement), 0);
	}
      else
	check_calibSensBlockStatement(
	  dynamic_cast<calibSensBlockStatement *>(a_measBlockStatement), log);
      return;
    }
  if (isA(a_measBlockStatement, crslctStm))
    {
      adjustLevels(&measBlockStatementSubs_crslctStm, "crslctStm");
      if (log && !findString("crslctStm", measBlockStatementSubs))
	{
	  warnSub("crslctStm", "measBlockStatement", a_measBlockStatement);
	  check_crslctStm(
	    dynamic_cast<crslctStm *>(a_measBlockStatement), 0);
	}
      else
	check_crslctStm(
	  dynamic_cast<crslctStm *>(a_measBlockStatement), log);
      return;
    }
  if (isA(a_measBlockStatement, recallSensorStm))
    {
      adjustLevels(&measBlockStatementSubs_recallSensorStm, "recallSensorStm");
      if (log && !findString("recallSensorStm", measBlockStatementSubs))
	{
	  warnSub("recallSensorStm", "measBlockStatement",
		  a_measBlockStatement);
	  check_recallSensorStm(
	    dynamic_cast<recallSensorStm *>(a_measBlockStatement), 0);
	}
      else
	check_recallSensorStm(
	  dynamic_cast<recallSensorStm *>(a_measBlockStatement), log);
      return;
    }
  if (isA(a_measBlockStatement, saveSensorStm))
    {
      adjustLevels(&measBlockStatementSubs_saveSensorStm, "saveSensorStm");
      if (log && !findString("saveSensorStm", measBlockStatementSubs))
	{
	  warnSub("saveSensorStm", "measBlockStatement", a_measBlockStatement);
	  check_saveSensorStm(
	    dynamic_cast<saveSensorStm *>(a_measBlockStatement), 0);
	}
      else
	check_saveSensorStm(
	  dynamic_cast<saveSensorStm *>(a_measBlockStatement), log);
      return;
    }
  if (isA(a_measBlockStatement, snslctStm))
    {
      adjustLevels(&measBlockStatementSubs_snslctStm, "snslctStm");
      if (log && !findString("snslctStm", measBlockStatementSubs))
	{
	  warnSub("snslctStm", "measBlockStatement", a_measBlockStatement);
	  check_snslctStm(
	    dynamic_cast<snslctStm *>(a_measBlockStatement), 0);
	}
      else
	check_snslctStm(
	  dynamic_cast<snslctStm *>(a_measBlockStatement), log);
      return;
    }
}

/********************************************************************/

void check_measBlock_measStm(
 measBlock_measStm * a_measBlock_measStm,
 int log)
{
  if (a_measBlock_measStm->get_measStm())
    {
      adjustLevels(&measBlock_measStmAtts_a_measStm,
		   "measBlock_measStm a_measStm");
      if (log && !findString("a_measStm", measBlock_measStmAtts))
	{
	  warnAttBlock("measStm", a_measBlock_measStm->get_measStm());
	  check_measStm(a_measBlock_measStm->get_measStm(), 0);
	}
      else
	check_measStm(a_measBlock_measStm->get_measStm(), log);
    }
  if (a_measBlock_measStm->get_measBlockItemList())
    {
      std::list<measBlockItem *> * theList;
      std::list<measBlockItem *>::iterator iter;
      theList = a_measBlock_measStm->get_measBlockItemList();
      adjustLevels(&measBlock_measStmAtts_a_measBlockItemList,
		   "measBlock_measStm a_measBlockItemList");
      if (log && !findString("a_measBlockItemList", measBlock_measStmAtts))
	{
	  warnAttBlock("measBlockItemList",
	    a_measBlock_measStm->get_measBlockItemList()->front());
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_measBlockItem(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_measBlockItem(*iter, log);
	}
    }
  if (a_measBlock_measStm->get_endmesStm())
    {
      adjustLevels(&measBlock_measStmAtts_a_endmesStm,
		   "measBlock_measStm a_endmesStm");
      if (log && !findString("a_endmesStm", measBlock_measStmAtts))
	{
	  warnAttBlock("endmesStm", a_measBlock_measStm->get_endmesStm());
	}
    }
}

/********************************************************************/

void check_measBlock_rmeasStm(
 measBlock_rmeasStm * a_measBlock_rmeasStm,
 int log)
{
  if (a_measBlock_rmeasStm->get_rmeasStm())
    {
      adjustLevels(&measBlock_rmeasStmAtts_a_rmeasStm,
		   "measBlock_rmeasStm a_rmeasStm");
      if (log && !findString("a_rmeasStm", measBlock_rmeasStmAtts))
	{
	  warnAttBlock("rmeasStm", a_measBlock_rmeasStm->get_rmeasStm());
	  check_rmeasStm(a_measBlock_rmeasStm->get_rmeasStm(), 0);
	}
      else
	check_rmeasStm(a_measBlock_rmeasStm->get_rmeasStm(), log);
    }
  if (a_measBlock_rmeasStm->get_measBlockItemList())
    {
      std::list<measBlockItem *> * theList;
      std::list<measBlockItem *>::iterator iter;
      theList = a_measBlock_rmeasStm->get_measBlockItemList();
      adjustLevels(&measBlock_rmeasStmAtts_a_measBlockItemList,
		   "measBlock_rmeasStm a_measBlockItemList");
      if (log && !findString("a_measBlockItemList", measBlock_rmeasStmAtts))
	{
	  warnAttBlock("measBlockItemList",
	    a_measBlock_rmeasStm->get_measBlockItemList()->front());
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_measBlockItem(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_measBlockItem(*iter, log);
	}
    }
  if (a_measBlock_rmeasStm->get_endmesStm())
    {
      adjustLevels(&measBlock_rmeasStmAtts_a_endmesStm,
		   "measBlock_rmeasStm a_endmesStm");
      if (log && !findString("a_endmesStm", measBlock_rmeasStmAtts))
	{
	  warnAttBlock("endmesStm", a_measBlock_rmeasStm->get_endmesStm());
	}
    }
}

/********************************************************************/

void check_measCaseBlock(
 measCaseBlock * a_measCaseBlock,
 int log)
{
  if (a_measCaseBlock->get_caseStm())
    {
      adjustLevels(&measCaseBlockAtts_a_caseStm, "measCaseBlock a_caseStm");
      if (log && !findString("a_caseStm", measCaseBlockAtts))
	{
	  warnAttBlock("caseStm", a_measCaseBlock->get_caseStm());
	  check_caseStm(a_measCaseBlock->get_caseStm(), 0);
	}
      else
	check_caseStm(a_measCaseBlock->get_caseStm(), log);
    }
  if (a_measCaseBlock->get_measBlockItemList())
    {
      std::list<measBlockItem *> * theList;
      std::list<measBlockItem *>::iterator iter;
      theList = a_measCaseBlock->get_measBlockItemList();
      adjustLevels(&measCaseBlockAtts_a_measBlockItemList,
		   "measCaseBlock a_measBlockItemList");
      if (log && !findString("a_measBlockItemList", measCaseBlockAtts))
	{
	  warnAttBlock("measBlockItemList",
	    a_measCaseBlock->get_measBlockItemList()->front());
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_measBlockItem(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_measBlockItem(*iter, log);
	}
    }
  if (a_measCaseBlock->get_endcasStm())
    {
      adjustLevels(&measCaseBlockAtts_a_endcasStm,
		   "measCaseBlock a_endcasStm");
      if (log && !findString("a_endcasStm", measCaseBlockAtts))
	{
	  warnAttBlock("endcasStm", a_measCaseBlock->get_endcasStm());
	}
    }
}

/********************************************************************/

void check_measDefaultCaseBlock(
 measDefaultCaseBlock * a_measDefaultCaseBlock,
 int log)
{
  if (a_measDefaultCaseBlock->get_dftcasStm())
    {
      adjustLevels(&measDefaultCaseBlockAtts_a_dftcasStm,
		   "measDefaultCaseBlock a_dftcasStm");
      if (log && !findString("a_dftcasStm", measDefaultCaseBlockAtts))
	{
	  warnAttBlock("dftcasStm", a_measDefaultCaseBlock->get_dftcasStm());
	}
    }
  if (a_measDefaultCaseBlock->get_measBlockItemList())
    {
      std::list<measBlockItem *> * theList;
      std::list<measBlockItem *>::iterator iter;
      theList = a_measDefaultCaseBlock->get_measBlockItemList();
      adjustLevels(&measDefaultCaseBlockAtts_a_measBlockItemList,
		   "measDefaultCaseBlock a_measBlockItemList");
      if (log && !findString("a_measBlockItemList", measDefaultCaseBlockAtts))
	{
	  warnAttBlock("measBlockItemList",
	    a_measDefaultCaseBlock->get_measBlockItemList()->front());
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_measBlockItem(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_measBlockItem(*iter, log);
	}
    }
  if (a_measDefaultCaseBlock->get_endcasStm())
    {
      adjustLevels(&measDefaultCaseBlockAtts_a_endcasStm,
		   "measDefaultCaseBlock a_endcasStm");
      if (log && !findString("a_endcasStm", measDefaultCaseBlockAtts))
	{
	  warnAttBlock("endcasStm", a_measDefaultCaseBlock->get_endcasStm());
	}
    }
}

/********************************************************************/

void check_measDoBlock(
 measDoBlock * a_measDoBlock,
 int log)
{
  if (a_measDoBlock->get_doStm())
    {
      adjustLevels(&measDoBlockAtts_a_doStm, "measDoBlock a_doStm");
      if (log && !findString("a_doStm", measDoBlockAtts))
	{
	  warnAttBlock("doStm", a_measDoBlock->get_doStm());
	  check_doStm(a_measDoBlock->get_doStm(), 0);
	}
      else
	check_doStm(a_measDoBlock->get_doStm(), log);
    }
  if (a_measDoBlock->get_measBlockItemList())
    {
      std::list<measBlockItem *> * theList;
      std::list<measBlockItem *>::iterator iter;
      theList = a_measDoBlock->get_measBlockItemList();
      adjustLevels(&measDoBlockAtts_a_measBlockItemList,
		   "measDoBlock a_measBlockItemList");
      if (log && !findString("a_measBlockItemList", measDoBlockAtts))
	{
	  warnAttBlock("measBlockItemList",
	    a_measDoBlock->get_measBlockItemList()->front());
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_measBlockItem(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_measBlockItem(*iter, log);
	}
    }
  if (a_measDoBlock->get_enddoStm())
    {
      adjustLevels(&measDoBlockAtts_a_enddoStm, "measDoBlock a_enddoStm");
      if (log && !findString("a_enddoStm", measDoBlockAtts))
	{
	  warnAttBlock("enddoStm", a_measDoBlock->get_enddoStm());
	}
    }
}

/********************************************************************/

void check_measGeotype(
 measGeotype * a_measGeotype,
 int log)
{
  if (isA(a_measGeotype, measGeotype_ARC))
    {
      adjustLevels(&measGeotypeSubs_measGeotype_ARC, "measGeotype_ARC");
      if (log && !findString("measGeotype_ARC", measGeotypeSubs))
	{
	  warnSub("measGeotype_ARC", "measGeotype", a_measGeotype);
	}
      return;
    }
  if (isA(a_measGeotype, measGeotype_CIRCLE))
    {
      adjustLevels(&measGeotypeSubs_measGeotype_CIRCLE, "measGeotype_CIRCLE");
      if (log && !findString("measGeotype_CIRCLE", measGeotypeSubs))
	{
	  warnSub("measGeotype_CIRCLE", "measGeotype", a_measGeotype);
	}
      return;
    }
  if (isA(a_measGeotype, measGeotype_CONE))
    {
      adjustLevels(&measGeotypeSubs_measGeotype_CONE, "measGeotype_CONE");
      if (log && !findString("measGeotype_CONE", measGeotypeSubs))
	{
	  warnSub("measGeotype_CONE", "measGeotype", a_measGeotype);
	}
      return;
    }
  if (isA(a_measGeotype, measGeotype_CONRADSEGMNT))
    {
      adjustLevels(&measGeotypeSubs_measGeotype_CONRADSEGMNT,
		   "measGeotype_CONRADSEGMNT");
      if (log && !findString("measGeotype_CONRADSEGMNT", measGeotypeSubs))
	{
	  warnSub("measGeotype_CONRADSEGMNT", "measGeotype", a_measGeotype);
	}
      return;
    }
  if (isA(a_measGeotype, measGeotype_CPARLN))
    {
      adjustLevels(&measGeotypeSubs_measGeotype_CPARLN, "measGeotype_CPARLN");
      if (log && !findString("measGeotype_CPARLN", measGeotypeSubs))
	{
	  warnSub("measGeotype_CPARLN", "measGeotype", a_measGeotype);
	}
      return;
    }
  if (isA(a_measGeotype, measGeotype_CYLNDR))
    {
      adjustLevels(&measGeotypeSubs_measGeotype_CYLNDR, "measGeotype_CYLNDR");
      if (log && !findString("measGeotype_CYLNDR", measGeotypeSubs))
	{
	  warnSub("measGeotype_CYLNDR", "measGeotype", a_measGeotype);
	}
      return;
    }
  if (isA(a_measGeotype, measGeotype_CYLRADSEGMNT))
    {
      adjustLevels(&measGeotypeSubs_measGeotype_CYLRADSEGMNT,
		   "measGeotype_CYLRADSEGMNT");
      if (log && !findString("measGeotype_CYLRADSEGMNT", measGeotypeSubs))
	{
	  warnSub("measGeotype_CYLRADSEGMNT", "measGeotype", a_measGeotype);
	}
      return;
    }
  if (isA(a_measGeotype, measGeotype_EDGEPT))
    {
      adjustLevels(&measGeotypeSubs_measGeotype_EDGEPT, "measGeotype_EDGEPT");
      if (log && !findString("measGeotype_EDGEPT", measGeotypeSubs))
	{
	  warnSub("measGeotype_EDGEPT", "measGeotype", a_measGeotype);
	}
      return;
    }
  if (isA(a_measGeotype, measGeotype_ELLIPS))
    {
      adjustLevels(&measGeotypeSubs_measGeotype_ELLIPS, "measGeotype_ELLIPS");
      if (log && !findString("measGeotype_ELLIPS", measGeotypeSubs))
	{
	  warnSub("measGeotype_ELLIPS", "measGeotype", a_measGeotype);
	}
      return;
    }
  if (isA(a_measGeotype, measGeotype_ELONGCYL))
    {
      adjustLevels(&measGeotypeSubs_measGeotype_ELONGCYL,
		   "measGeotype_ELONGCYL");
      if (log && !findString("measGeotype_ELONGCYL", measGeotypeSubs))
	{
	  warnSub("measGeotype_ELONGCYL", "measGeotype", a_measGeotype);
	}
      return;
    }
  if (isA(a_measGeotype, measGeotype_GCURVE))
    {
      adjustLevels(&measGeotypeSubs_measGeotype_GCURVE, "measGeotype_GCURVE");
      if (log && !findString("measGeotype_GCURVE", measGeotypeSubs))
	{
	  warnSub("measGeotype_GCURVE", "measGeotype", a_measGeotype);
	}
      return;
    }
  if (isA(a_measGeotype, measGeotype_GSURF))
    {
      adjustLevels(&measGeotypeSubs_measGeotype_GSURF, "measGeotype_GSURF");
      if (log && !findString("measGeotype_GSURF", measGeotypeSubs))
	{
	  warnSub("measGeotype_GSURF", "measGeotype", a_measGeotype);
	}
      return;
    }
  if (isA(a_measGeotype, measGeotype_LINE))
    {
      adjustLevels(&measGeotypeSubs_measGeotype_LINE, "measGeotype_LINE");
      if (log && !findString("measGeotype_LINE", measGeotypeSubs))
	{
	  warnSub("measGeotype_LINE", "measGeotype", a_measGeotype);
	}
      return;
    }
  if (isA(a_measGeotype, measGeotype_OBJECT))
    {
      adjustLevels(&measGeotypeSubs_measGeotype_OBJECT, "measGeotype_OBJECT");
      if (log && !findString("measGeotype_OBJECT", measGeotypeSubs))
	{
	  warnSub("measGeotype_OBJECT", "measGeotype", a_measGeotype);
	}
      return;
    }
  if (isA(a_measGeotype, measGeotype_PARPLN))
    {
      adjustLevels(&measGeotypeSubs_measGeotype_PARPLN, "measGeotype_PARPLN");
      if (log && !findString("measGeotype_PARPLN", measGeotypeSubs))
	{
	  warnSub("measGeotype_PARPLN", "measGeotype", a_measGeotype);
	}
      return;
    }
  if (isA(a_measGeotype, measGeotype_PLANE))
    {
      adjustLevels(&measGeotypeSubs_measGeotype_PLANE, "measGeotype_PLANE");
      if (log && !findString("measGeotype_PLANE", measGeotypeSubs))
	{
	  warnSub("measGeotype_PLANE", "measGeotype", a_measGeotype);
	}
      return;
    }
  if (isA(a_measGeotype, measGeotype_REVSURF))
    {
      adjustLevels(&measGeotypeSubs_measGeotype_REVSURF,
		   "measGeotype_REVSURF");
      if (log && !findString("measGeotype_REVSURF", measGeotypeSubs))
	{
	  warnSub("measGeotype_REVSURF", "measGeotype", a_measGeotype);
	}
      return;
    }
  if (isA(a_measGeotype, measGeotype_RCTNGL))
    {
      adjustLevels(&measGeotypeSubs_measGeotype_RCTNGL, "measGeotype_RCTNGL");
      if (log && !findString("measGeotype_RCTNGL", measGeotypeSubs))
	{
	  warnSub("measGeotype_RCTNGL", "measGeotype", a_measGeotype);
	}
      return;
    }
  if (isA(a_measGeotype, measGeotype_SPHERE))
    {
      adjustLevels(&measGeotypeSubs_measGeotype_SPHERE, "measGeotype_SPHERE");
      if (log && !findString("measGeotype_SPHERE", measGeotypeSubs))
	{
	  warnSub("measGeotype_SPHERE", "measGeotype", a_measGeotype);
	}
      return;
    }
  if (isA(a_measGeotype, measGeotype_SPHRADSEGMNT))
    {
      adjustLevels(&measGeotypeSubs_measGeotype_SPHRADSEGMNT,
		   "measGeotype_SPHRADSEGMNT");
      if (log && !findString("measGeotype_SPHRADSEGMNT", measGeotypeSubs))
	{
	  warnSub("measGeotype_SPHRADSEGMNT", "measGeotype", a_measGeotype);
	}
      return;
    }
  if (isA(a_measGeotype, measGeotype_SYMPLN))
    {
      adjustLevels(&measGeotypeSubs_measGeotype_SYMPLN, "measGeotype_SYMPLN");
      if (log && !findString("measGeotype_SYMPLN", measGeotypeSubs))
	{
	  warnSub("measGeotype_SYMPLN", "measGeotype", a_measGeotype);
	}
      return;
    }
  if (isA(a_measGeotype, measGeotype_TORUS))
    {
      adjustLevels(&measGeotypeSubs_measGeotype_TORUS, "measGeotype_TORUS");
      if (log && !findString("measGeotype_TORUS", measGeotypeSubs))
	{
	  warnSub("measGeotype_TORUS", "measGeotype", a_measGeotype);
	}
      return;
    }
  if (isA(a_measGeotype, measGeotype_TORRADSEGMNT))
    {
      adjustLevels(&measGeotypeSubs_measGeotype_TORRADSEGMNT,
		   "measGeotype_TORRADSEGMNT");
      if (log && !findString("measGeotype_TORRADSEGMNT", measGeotypeSubs))
	{
	  warnSub("measGeotype_TORRADSEGMNT", "measGeotype", a_measGeotype);
	}
      return;
    }
}

/********************************************************************/

void check_measIfBlock(
 measIfBlock * a_measIfBlock,
 int log)
{
  if (a_measIfBlock->get_ifStm())
    {
      adjustLevels(&measIfBlockAtts_a_ifStm, "measIfBlock a_ifStm");
      if (log && !findString("a_ifStm", measIfBlockAtts))
	{
	  warnAttBlock("ifStm", a_measIfBlock->get_ifStm());
	  check_ifStm(a_measIfBlock->get_ifStm(), 0);
	}
      else
	check_ifStm(a_measIfBlock->get_ifStm(), log);
    }
  if (a_measIfBlock->get_ifList())
    {
      std::list<measBlockItem *> * theList;
      std::list<measBlockItem *>::iterator iter;
      theList = a_measIfBlock->get_ifList();
      adjustLevels(&measIfBlockAtts_ifList, "measIfBlock ifList");
      if (log && !findString("ifList", measIfBlockAtts))
	{
	  warnAttBlock("ifList",
	    a_measIfBlock->get_ifList()->front());
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_measBlockItem(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_measBlockItem(*iter, log);
	}
    }
  if (a_measIfBlock->get_elseStm())
    {
      adjustLevels(&measIfBlockAtts_a_elseStm, "measIfBlock a_elseStm");
      if (log && !findString("a_elseStm", measIfBlockAtts))
	{
	  warnAttBlock("elseStm", a_measIfBlock->get_elseStm());
	}
    }
  if (a_measIfBlock->get_elseList())
    {
      std::list<measBlockItem *> * theList;
      std::list<measBlockItem *>::iterator iter;
      theList = a_measIfBlock->get_elseList();
      adjustLevels(&measIfBlockAtts_elseList, "measIfBlock elseList");
      if (log && !findString("elseList", measIfBlockAtts))
	{
	  warnAttBlock("elseList",
	    a_measIfBlock->get_elseList()->front());
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_measBlockItem(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_measBlockItem(*iter, log);
	}
    }
  if (a_measIfBlock->get_endifStm())
    {
      adjustLevels(&measIfBlockAtts_a_endifStm, "measIfBlock a_endifStm");
      if (log && !findString("a_endifStm", measIfBlockAtts))
	{
	  warnAttBlock("endifStm", a_measIfBlock->get_endifStm());
	}
    }
}

/********************************************************************/

void check_measMinor(
 measMinor * a_measMinor,
 int log)
{
  if (isA(a_measMinor, measMinorOther))
    {
      adjustLevels(&measMinorSubs_measMinorOther, "measMinorOther");
      if (log && !findString("measMinorOther", measMinorSubs))
	{
	  warnSub("measMinorOther", "measMinor", a_measMinor);
	  check_measMinorOther(
	    dynamic_cast<measMinorOther *>(a_measMinor), 0);
	}
      else
	check_measMinorOther(
	  dynamic_cast<measMinorOther *>(a_measMinor), log);
      return;
    }
  if (isA(a_measMinor, measMinorPoint))
    {
      adjustLevels(&measMinorSubs_measMinorPoint, "measMinorPoint");
      if (log && !findString("measMinorPoint", measMinorSubs))
	{
	  warnSub("measMinorPoint", "measMinor", a_measMinor);
	}
      return;
    }
  if (isA(a_measMinor, measMinorComp))
    {
      adjustLevels(&measMinorSubs_measMinorComp, "measMinorComp");
      if (log && !findString("measMinorComp", measMinorSubs))
	{
	  warnSub("measMinorComp", "measMinor", a_measMinor);
	  check_measMinorComp(
	    dynamic_cast<measMinorComp *>(a_measMinor), 0);
	}
      else
	check_measMinorComp(
	  dynamic_cast<measMinorComp *>(a_measMinor), log);
      return;
    }
}

/********************************************************************/

void check_measMinorComp(
 measMinorComp * a_measMinorComp,
 int log)
{
  if (a_measMinorComp->get_measVar2())
    {
      adjustLevels(&measMinorCompAtts_a_measVar2, "measMinorComp a_measVar2");
      if (log && !findString("a_measVar2", measMinorCompAtts))
	{
	  warnAtt("a_measVar2", "measMinorComp", a_measMinorComp);
	  check_measVar2(a_measMinorComp->get_measVar2(), 0);
	}
      else
	check_measVar2(a_measMinorComp->get_measVar2(), log);
    }
}

/********************************************************************/

void check_measMinorOther(
 measMinorOther * a_measMinorOther,
 int log)
{
  if (a_measMinorOther->get_measGeotype())
    {
      adjustLevels(&measMinorOtherAtts_a_measGeotype,
		   "measMinorOther a_measGeotype");
      if (log && !findString("a_measGeotype", measMinorOtherAtts))
	{
	  warnAtt("a_measGeotype", "measMinorOther", a_measMinorOther);
	  check_measGeotype(a_measMinorOther->get_measGeotype(), 0);
	}
      else
	check_measGeotype(a_measMinorOther->get_measGeotype(), log);
    }
}

/********************************************************************/

void check_measSelectBlock(
 measSelectBlock * a_measSelectBlock,
 int log)
{
  if (a_measSelectBlock->get_selectStm())
    {
      adjustLevels(&measSelectBlockAtts_a_selectStm,
		   "measSelectBlock a_selectStm");
      if (log && !findString("a_selectStm", measSelectBlockAtts))
	{
	  warnAttBlock("selectStm", a_measSelectBlock->get_selectStm());
	  check_selectStm(a_measSelectBlock->get_selectStm(), 0);
	}
      else
	check_selectStm(a_measSelectBlock->get_selectStm(), log);
    }
  if (a_measSelectBlock->get_measCaseBlockList())
    {
      std::list<measCaseBlock *> * theList;
      std::list<measCaseBlock *>::iterator iter;
      theList = a_measSelectBlock->get_measCaseBlockList();
      adjustLevels(&measSelectBlockAtts_a_measCaseBlockList,
		   "measSelectBlock a_measCaseBlockList");
      if (log && !findString("a_measCaseBlockList", measSelectBlockAtts))
	{
	  warnAttBlock("measCaseBlockList",
	    a_measSelectBlock->get_measCaseBlockList()->front());
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_measCaseBlock(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_measCaseBlock(*iter, log);
	}
    }
  if (a_measSelectBlock->get_measDefaultCaseBlock())
    {
      adjustLevels(&measSelectBlockAtts_a_measDefaultCaseBlock,
		   "measSelectBlock a_measDefaultCaseBlock");
      if (log && !findString("a_measDefaultCaseBlock", measSelectBlockAtts))
	{
	  warnAttBlock("measDefaultCaseBlock",
	    a_measSelectBlock->get_measDefaultCaseBlock());
	  check_measDefaultCaseBlock(
	    a_measSelectBlock->get_measDefaultCaseBlock(), 0);
	}
      else
	check_measDefaultCaseBlock(
	  a_measSelectBlock->get_measDefaultCaseBlock(), log);
    }
  if (a_measSelectBlock->get_endselStm())
    {
      adjustLevels(&measSelectBlockAtts_a_endselStm,
		   "measSelectBlock a_endselStm");
      if (log && !findString("a_endselStm", measSelectBlockAtts))
	{
	  warnAttBlock("endselStm", a_measSelectBlock->get_endselStm());
	}
    }
}

/********************************************************************/

void check_measStm(
 measStm * a_measStm,
 int log)
{
  if (a_measStm->get_measMinor())
    {
      adjustLevels(&measStmAtts_a_measMinor, "measStm a_measMinor");
      if (log && !findString("a_measMinor", measStmAtts))
	{
	  warnAtt("a_measMinor", "measStm", a_measStm);
	  check_measMinor(a_measStm->get_measMinor(), 0);
	}
      else
	check_measMinor(a_measStm->get_measMinor(), log);
    }
  if (a_measStm->get_fLabel())
    {
      adjustLevels(&measStmAtts_a_fLabel, "measStm a_fLabel");
      if (log && !findString("a_fLabel", measStmAtts))
	{
	  warnAtt("a_fLabel", "measStm", a_measStm);
	  check_fLabel(a_measStm->get_fLabel(), 0);
	}
      else
	check_fLabel(a_measStm->get_fLabel(), log);
    }
  if (a_measStm->get_numMeas())
    {
      adjustLevels(&measStmAtts_numMeas, "measStm numMeas");
      if (log && !findString("numMeas", measStmAtts))
	{
	  warnAtt("numMeas", "measStm", a_measStm);
	  check_intVal(a_measStm->get_numMeas(), 0);
	}
      else
	check_intVal(a_measStm->get_numMeas(), log);
    }
}

/********************************************************************/

void check_measVar2(
 measVar2 * a_measVar2,
 int log)
{
  if (isA(a_measVar2, measVar2_AXDIR))
    {
      adjustLevels(&measVar2Subs_measVar2_AXDIR, "measVar2_AXDIR");
      if (log && !findString("measVar2_AXDIR", measVar2Subs))
	{
	  warnSub("measVar2_AXDIR", "measVar2", a_measVar2);
	}
      return;
    }
  if (isA(a_measVar2, measVar2_DME))
    {
      adjustLevels(&measVar2Subs_measVar2_DME, "measVar2_DME");
      if (log && !findString("measVar2_DME", measVar2Subs))
	{
	  warnSub("measVar2_DME", "measVar2", a_measVar2);
	}
      return;
    }
  if (isA(a_measVar2, measVar2_FEAT))
    {
      adjustLevels(&measVar2Subs_measVar2_FEAT, "measVar2_FEAT");
      if (log && !findString("measVar2_FEAT", measVar2Subs))
	{
	  warnSub("measVar2_FEAT", "measVar2", a_measVar2);
	  check_measVar2_FEAT(
	    dynamic_cast<measVar2_FEAT *>(a_measVar2), 0);
	}
      else
	check_measVar2_FEAT(
	  dynamic_cast<measVar2_FEAT *>(a_measVar2), log);
      return;
    }
  if (isA(a_measVar2, measVar2_POL))
    {
      adjustLevels(&measVar2Subs_measVar2_POL, "measVar2_POL");
      if (log && !findString("measVar2_POL", measVar2Subs))
	{
	  warnSub("measVar2_POL", "measVar2", a_measVar2);
	}
      return;
    }
  if (isA(a_measVar2, measVar2_SPH))
    {
      adjustLevels(&measVar2Subs_measVar2_SPH, "measVar2_SPH");
      if (log && !findString("measVar2_SPH", measVar2Subs))
	{
	  warnSub("measVar2_SPH", "measVar2", a_measVar2);
	}
      return;
    }
  if (isA(a_measVar2, measVar2_VEC))
    {
      adjustLevels(&measVar2Subs_measVar2_VEC, "measVar2_VEC");
      if (log && !findString("measVar2_VEC", measVar2Subs))
	{
	  warnSub("measVar2_VEC", "measVar2", a_measVar2);
	  check_measVar2_VEC(dynamic_cast<measVar2_VEC *>(a_measVar2), 0);
	}
      else
	check_measVar2_VEC(dynamic_cast<measVar2_VEC *>(a_measVar2), log);
      return;
    }
}

/********************************************************************/

void check_measVar2Aux(
 measVar2Aux * a_measVar2Aux,
 int log)
{
  if (isA(a_measVar2Aux, faLabel))
    {
      adjustLevels(&measVar2AuxSubs_faLabel, "faLabel");
      if (log && !findString("faLabel", measVar2AuxSubs))
	{
	  warnSub("faLabel", "measVar2Aux", a_measVar2Aux);
	  check_faLabel(dynamic_cast<faLabel *>(a_measVar2Aux), 0);
	}
      else
	check_faLabel(dynamic_cast<faLabel *>(a_measVar2Aux), log);
      return;
    }
  if (isA(a_measVar2Aux, fLabel))
    {
      adjustLevels(&measVar2AuxSubs_fLabel, "fLabel");
      if (log && !findString("fLabel", measVar2AuxSubs))
	{
	  warnSub("fLabel", "measVar2Aux", a_measVar2Aux);
	  check_fLabel(dynamic_cast<fLabel *>(a_measVar2Aux), 0);
	}
      else
	check_fLabel(dynamic_cast<fLabel *>(a_measVar2Aux), log);
      return;
    }
  if (isA(a_measVar2Aux, gLabel))
    {
      adjustLevels(&measVar2AuxSubs_gLabel, "gLabel");
      if (log && !findString("gLabel", measVar2AuxSubs))
	{
	  warnSub("gLabel", "measVar2Aux", a_measVar2Aux);
	  check_gLabel(dynamic_cast<gLabel *>(a_measVar2Aux), 0);
	}
      else
	check_gLabel(dynamic_cast<gLabel *>(a_measVar2Aux), log);
      return;
    }
}

/********************************************************************/

void check_measVar2_FEAT(
 measVar2_FEAT * a_measVar2_FEAT,
 int log)
{
  if (a_measVar2_FEAT->get_measVar2Aux())
    {
      adjustLevels(&measVar2_FEATAtts_a_measVar2Aux,
		   "measVar2_FEAT a_measVar2Aux");
      if (log && !findString("a_measVar2Aux", measVar2_FEATAtts))
	{
	  warnAtt("a_measVar2Aux", "measVar2_FEAT", a_measVar2_FEAT);
	  check_measVar2Aux(a_measVar2_FEAT->get_measVar2Aux(), 0);
	}
      else
	check_measVar2Aux(a_measVar2_FEAT->get_measVar2Aux(), log);
    }
}

/********************************************************************/

void check_measVar2_VEC(
 measVar2_VEC * a_measVar2_VEC,
 int log)
{
  if (a_measVar2_VEC->get_compDir())
    {
      adjustLevels(&measVar2_VECAtts_compDir, "measVar2_VEC compDir");
      if (log && !findString("compDir", measVar2_VECAtts))
	{
	  warnAtt("compDir", "measVar2_VEC", a_measVar2_VEC);
	  check_vector(a_measVar2_VEC->get_compDir(), 0);
	}
      else
	check_vector(a_measVar2_VEC->get_compDir(), log);
    }
}

/********************************************************************/

void check_mfgdevStm(
 mfgdevStm * a_mfgdevStm,
 int log)
{
  if (a_mfgdevStm->get_mdLabel())
    {
      adjustLevels(&mfgdevStmAtts_a_mdLabel, "mfgdevStm a_mdLabel");
      if (log && !findString("a_mdLabel", mfgdevStmAtts))
	{
	  warnAtt("a_mdLabel", "mfgdevStm", a_mfgdevStm);
	  check_mdLabel(a_mfgdevStm->get_mdLabel(), 0);
	}
      else
	check_mdLabel(a_mfgdevStm->get_mdLabel(), log);
    }
  if (a_mfgdevStm->get_text())
    {
      adjustLevels(&mfgdevStmAtts_text, "mfgdevStm text");
      if (log && !findString("text", mfgdevStmAtts))
	{
	  warnAtt("text", "mfgdevStm", a_mfgdevStm);
	  check_stringVal(a_mfgdevStm->get_text(), 0);
	}
      else
	check_stringVal(a_mfgdevStm->get_text(), log);
    }
}

/********************************************************************/

void check_midliConst(
 midliConst * a_midliConst,
 int log)
{
  if (a_midliConst->get_faLabel())
    {
      adjustLevels(&midliConstAtts_a_faLabel, "midliConst a_faLabel");
      if (log && !findString("a_faLabel", midliConstAtts))
	{
	  warnAtt("a_faLabel", "midliConst", a_midliConst);
	  check_faLabel(a_midliConst->get_faLabel(), 0);
	}
      else
	check_faLabel(a_midliConst->get_faLabel(), log);
    }
  if (a_midliConst->get_featureLabel())
    {
      adjustLevels(&midliConstAtts_a_featureLabel,
		   "midliConst a_featureLabel");
      if (log && !findString("a_featureLabel", midliConstAtts))
	{
	  warnAtt("a_featureLabel", "midliConst", a_midliConst);
	  check_featureLabel(a_midliConst->get_featureLabel(), 0);
	}
      else
	check_featureLabel(a_midliConst->get_featureLabel(), log);
    }
}

/********************************************************************/

void check_midplConst(
 midplConst * a_midplConst,
 int log)
{
  if (a_midplConst->get_faLabel())
    {
      adjustLevels(&midplConstAtts_a_faLabel, "midplConst a_faLabel");
      if (log && !findString("a_faLabel", midplConstAtts))
	{
	  warnAtt("a_faLabel", "midplConst", a_midplConst);
	  check_faLabel(a_midplConst->get_faLabel(), 0);
	}
      else
	check_faLabel(a_midplConst->get_faLabel(), log);
    }
  if (a_midplConst->get_featureLabel())
    {
      adjustLevels(&midplConstAtts_a_featureLabel,
		   "midplConst a_featureLabel");
      if (log && !findString("a_featureLabel", midplConstAtts))
	{
	  warnAtt("a_featureLabel", "midplConst", a_midplConst);
	  check_featureLabel(a_midplConst->get_featureLabel(), 0);
	}
      else
	check_featureLabel(a_midplConst->get_featureLabel(), log);
    }
}

/********************************************************************/

void check_midptConst(
 midptConst * a_midptConst,
 int log)
{
  if (a_midptConst->get_faLabel())
    {
      adjustLevels(&midptConstAtts_a_faLabel, "midptConst a_faLabel");
      if (log && !findString("a_faLabel", midptConstAtts))
	{
	  warnAtt("a_faLabel", "midptConst", a_midptConst);
	  check_faLabel(a_midptConst->get_faLabel(), 0);
	}
      else
	check_faLabel(a_midptConst->get_faLabel(), log);
    }
  if (a_midptConst->get_featureLabel())
    {
      adjustLevels(&midptConstAtts_a_featureLabel,
		   "midptConst a_featureLabel");
      if (log && !findString("a_featureLabel", midptConstAtts))
	{
	  warnAtt("a_featureLabel", "midptConst", a_midptConst);
	  check_featureLabel(a_midptConst->get_featureLabel(), 0);
	}
      else
	check_featureLabel(a_midptConst->get_featureLabel(), log);
    }
}

/********************************************************************/

void check_modeStm(
 modeStm * a_modeStm,
 int log)
{
  if (a_modeStm->get_has_AUTO())
    {
      adjustLevels(&modeStmAtts_has_AUTO, "modeStm has_AUTO");
      if (log && !findString("has_AUTO", modeStmAtts))
	{
	  warnAtt("has_AUTO", "modeStm", a_modeStm);
	}
    }
  if (a_modeStm->get_has_PROG())
    {
      adjustLevels(&modeStmAtts_has_PROG, "modeStm has_PROG");
      if (log && !findString("has_PROG", modeStmAtts))
	{
	  warnAtt("has_PROG", "modeStm", a_modeStm);
	}
    }
}

/********************************************************************/

void check_moveptConst(
 moveptConst * a_moveptConst,
 int log)
{
  if (isA(a_moveptConst, moveptConstVec))
    {
      adjustLevels(&moveptConstSubs_moveptConstVec, "moveptConstVec");
      if (log && !findString("moveptConstVec", moveptConstSubs))
	{
	  warnSub("moveptConstVec", "moveptConst", a_moveptConst);
	  check_moveptConstVec(
	    dynamic_cast<moveptConstVec *>(a_moveptConst), 0);
	}
      else
	check_moveptConstVec(
	  dynamic_cast<moveptConstVec *>(a_moveptConst), log);
      return;
    }
  if (isA(a_moveptConst, moveptConstAxis))
    {
      adjustLevels(&moveptConstSubs_moveptConstAxis, "moveptConstAxis");
      if (log && !findString("moveptConstAxis", moveptConstSubs))
	{
	  warnSub("moveptConstAxis", "moveptConst", a_moveptConst);
	  check_moveptConstAxis(
	    dynamic_cast<moveptConstAxis *>(a_moveptConst), 0);
	}
      else
	check_moveptConstAxis(
	  dynamic_cast<moveptConstAxis *>(a_moveptConst), log);
      return;
    }
}

/********************************************************************/

void check_moveptConstAxis(
 moveptConstAxis * a_moveptConstAxis,
 int log)
{
  if (a_moveptConstAxis->get_faLabel())
    {
      adjustLevels(&moveptConstAxisAtts_a_faLabel,
		   "moveptConstAxis a_faLabel");
      if (log && !findString("a_faLabel", moveptConstAxisAtts))
	{
	  warnAtt("a_faLabel", "moveptConstAxis", a_moveptConstAxis);
	  check_faLabel(a_moveptConstAxis->get_faLabel(), 0);
	}
      else
	check_faLabel(a_moveptConstAxis->get_faLabel(), log);
    }
  if (a_moveptConstAxis->get_featureLabel())
    {
      adjustLevels(&moveptConstAxisAtts_a_featureLabel,
		   "moveptConstAxis a_featureLabel");
      if (log && !findString("a_featureLabel", moveptConstAxisAtts))
	{
	  warnAtt("a_featureLabel", "moveptConstAxis", a_moveptConstAxis);
	  check_featureLabel(a_moveptConstAxis->get_featureLabel(), 0);
	}
      else
	check_featureLabel(a_moveptConstAxis->get_featureLabel(), log);
    }
  if (a_moveptConstAxis->get_dist())
    {
      adjustLevels(&moveptConstAxisAtts_dist, "moveptConstAxis dist");
      if (log && !findString("dist", moveptConstAxisAtts))
	{
	  warnAtt("dist", "moveptConstAxis", a_moveptConstAxis);
	  check_rentVal(a_moveptConstAxis->get_dist(), 0);
	}
      else
	check_rentVal(a_moveptConstAxis->get_dist(), log);
    }
}

/********************************************************************/

void check_moveptConstVec(
 moveptConstVec * a_moveptConstVec,
 int log)
{
  if (a_moveptConstVec->get_faLabel())
    {
      adjustLevels(&moveptConstVecAtts_a_faLabel, "moveptConstVec a_faLabel");
      if (log && !findString("a_faLabel", moveptConstVecAtts))
	{
	  warnAtt("a_faLabel", "moveptConstVec", a_moveptConstVec);
	  check_faLabel(a_moveptConstVec->get_faLabel(), 0);
	}
      else
	check_faLabel(a_moveptConstVec->get_faLabel(), log);
    }
  if (a_moveptConstVec->get_offset())
    {
      adjustLevels(&moveptConstVecAtts_offset, "moveptConstVec offset");
      if (log && !findString("offset", moveptConstVecAtts))
	{
	  warnAtt("offset", "moveptConstVec", a_moveptConstVec);
	  check_vector(a_moveptConstVec->get_offset(), 0);
	}
      else
	check_vector(a_moveptConstVec->get_offset(), log);
    }
}

/********************************************************************/

void check_nearptConst(
 nearptConst * a_nearptConst,
 int log)
{
  if (a_nearptConst->get_faLabel())
    {
      adjustLevels(&nearptConstAtts_a_faLabel, "nearptConst a_faLabel");
      if (log && !findString("a_faLabel", nearptConstAtts))
	{
	  warnAtt("a_faLabel", "nearptConst", a_nearptConst);
	  check_faLabel(a_nearptConst->get_faLabel(), 0);
	}
      else
	check_faLabel(a_nearptConst->get_faLabel(), log);
    }
}

/********************************************************************/

void check_negDir(
 negDir * a_negDir,
 int log)
{
  if (isA(a_negDir, negDir_MINUSXDIR))
    {
      adjustLevels(&negDirSubs_negDir_MINUSXDIR, "negDir_MINUSXDIR");
      if (log && !findString("negDir_MINUSXDIR", negDirSubs))
	{
	  warnSub("negDir_MINUSXDIR", "negDir", a_negDir);
	}
      return;
    }
  if (isA(a_negDir, negDir_MINUSYDIR))
    {
      adjustLevels(&negDirSubs_negDir_MINUSYDIR, "negDir_MINUSYDIR");
      if (log && !findString("negDir_MINUSYDIR", negDirSubs))
	{
	  warnSub("negDir_MINUSYDIR", "negDir", a_negDir);
	}
      return;
    }
  if (isA(a_negDir, negDir_MINUSZDIR))
    {
      adjustLevels(&negDirSubs_negDir_MINUSZDIR, "negDir_MINUSZDIR");
      if (log && !findString("negDir_MINUSZDIR", negDirSubs))
	{
	  warnSub("negDir_MINUSZDIR", "negDir", a_negDir);
	}
      return;
    }
}

/********************************************************************/

void check_noParseStm(
 noParseStm * a_noParseStm,
 int log)
{
  if (a_noParseStm->get_string())
    {
      adjustLevels(&noParseStmAtts_a_string, "noParseStm a_string");
      if (log && !findString("a_string", noParseStmAtts))
	{
	  warnAtt("a_string", "noParseStm", a_noParseStm);
	}
    }
}

/********************************************************************/

void check_obtainBool(
 obtainBool * a_obtainBool,
 int log)
{
  if (a_obtainBool->get_boolVar())
    {
      adjustLevels(&obtainBoolAtts_a_boolVar, "obtainBool a_boolVar");
      if (log && !findString("a_boolVar", obtainBoolAtts))
	{
	  warnAtt("a_boolVar", "obtainBool", a_obtainBool);
	  check_boolVar(a_obtainBool->get_boolVar(), 0);
	}
      else
	check_boolVar(a_obtainBool->get_boolVar(), log);
    }
  if (a_obtainBool->get_obtainLabeled())
    {
      adjustLevels(&obtainBoolAtts_a_obtainLabeled,
		   "obtainBool a_obtainLabeled");
      if (log && !findString("a_obtainLabeled", obtainBoolAtts))
	{
	  warnAtt("a_obtainLabeled", "obtainBool", a_obtainBool);
	  check_obtainLabeled(a_obtainBool->get_obtainLabeled(), 0);
	}
      else
	check_obtainLabeled(a_obtainBool->get_obtainLabeled(), log);
    }
}

/********************************************************************/

void check_obtainInt(
 obtainInt * a_obtainInt,
 int log)
{
  if (a_obtainInt->get_intVar())
    {
      adjustLevels(&obtainIntAtts_a_intVar, "obtainInt a_intVar");
      if (log && !findString("a_intVar", obtainIntAtts))
	{
	  warnAtt("a_intVar", "obtainInt", a_obtainInt);
	  check_intVar(a_obtainInt->get_intVar(), 0);
	}
      else
	check_intVar(a_obtainInt->get_intVar(), log);
    }
  if (a_obtainInt->get_obtainLabeled())
    {
      adjustLevels(&obtainIntAtts_a_obtainLabeled,
		   "obtainInt a_obtainLabeled");
      if (log && !findString("a_obtainLabeled", obtainIntAtts))
	{
	  warnAtt("a_obtainLabeled", "obtainInt", a_obtainInt);
	  check_obtainLabeled(a_obtainInt->get_obtainLabeled(), 0);
	}
      else
	check_obtainLabeled(a_obtainInt->get_obtainLabeled(), log);
    }
}

/********************************************************************/

void check_obtainLabeled(
 obtainLabeled * a_obtainLabeled,
 int log)
{
  if (isA(a_obtainLabeled, obtainLabeled_datumLabel1))
    {
      adjustLevels(&obtainLabeledSubs_obtainLabeled_datumLabel1,
		   "obtainLabeled_datumLabel1");
      if (log && !findString("obtainLabeled_datumLabel1", obtainLabeledSubs))
	{
	  warnSub("obtainLabeled_datumLabel1", "obtainLabeled",
		  a_obtainLabeled);
	  check_obtainLabeled_datumLabel1(
	    dynamic_cast<obtainLabeled_datumLabel1 *>(a_obtainLabeled), 0);
	}
      else
	check_obtainLabeled_datumLabel1(
	  dynamic_cast<obtainLabeled_datumLabel1 *>(a_obtainLabeled), log);
      return;
    }
  if (isA(a_obtainLabeled, obtainLabeled_featureLabel))
    {
      adjustLevels(&obtainLabeledSubs_obtainLabeled_featureLabel,
		   "obtainLabeled_featureLabel");
      if (log && !findString("obtainLabeled_featureLabel", obtainLabeledSubs))
	{
	  warnSub("obtainLabeled_featureLabel", "obtainLabeled",
		  a_obtainLabeled);
	  check_obtainLabeled_featureLabel(
	    dynamic_cast<obtainLabeled_featureLabel *>(a_obtainLabeled), 0);
	}
      else
	check_obtainLabeled_featureLabel(
	  dynamic_cast<obtainLabeled_featureLabel *>(a_obtainLabeled), log);
      return;
    }
  if (isA(a_obtainLabeled, obtainLabeled_sensorLabel1))
    {
      adjustLevels(&obtainLabeledSubs_obtainLabeled_sensorLabel1,
		   "obtainLabeled_sensorLabel1");
      if (log && !findString("obtainLabeled_sensorLabel1", obtainLabeledSubs))
	{
	  warnSub("obtainLabeled_sensorLabel1", "obtainLabeled",
		  a_obtainLabeled);
	  check_obtainLabeled_sensorLabel1(
	    dynamic_cast<obtainLabeled_sensorLabel1 *>(a_obtainLabeled), 0);
	}
      else
	check_obtainLabeled_sensorLabel1(
	  dynamic_cast<obtainLabeled_sensorLabel1 *>(a_obtainLabeled), log);
      return;
    }
  if (isA(a_obtainLabeled, obtainLabeled_toleranceLabel))
    {
      adjustLevels(&obtainLabeledSubs_obtainLabeled_toleranceLabel,
		   "obtainLabeled_toleranceLabel");
      if (log && !findString("obtainLabeled_toleranceLabel",
			     obtainLabeledSubs))
	{
	  warnSub("obtainLabeled_toleranceLabel", "obtainLabeled",
		  a_obtainLabeled);
	  check_obtainLabeled_toleranceLabel(
	    dynamic_cast<obtainLabeled_toleranceLabel *>(a_obtainLabeled), 0);
	}
      else
	check_obtainLabeled_toleranceLabel(
	  dynamic_cast<obtainLabeled_toleranceLabel *>(a_obtainLabeled), log);
      return;
    }
  if (isA(a_obtainLabeled, obtainLabeled_didLabel))
    {
      adjustLevels(&obtainLabeledSubs_obtainLabeled_didLabel,
		   "obtainLabeled_didLabel");
      if (log && !findString("obtainLabeled_didLabel", obtainLabeledSubs))
	{
	  warnSub("obtainLabeled_didLabel", "obtainLabeled", a_obtainLabeled);
	  check_obtainLabeled_didLabel(
	    dynamic_cast<obtainLabeled_didLabel *>(a_obtainLabeled), 0);
	}
      else
	check_obtainLabeled_didLabel(
	  dynamic_cast<obtainLabeled_didLabel *>(a_obtainLabeled), log);
      return;
    }
  if (isA(a_obtainLabeled, obtainLabeled_qisLabel))
    {
      adjustLevels(&obtainLabeledSubs_obtainLabeled_qisLabel,
		   "obtainLabeled_qisLabel");
      if (log && !findString("obtainLabeled_qisLabel", obtainLabeledSubs))
	{
	  warnSub("obtainLabeled_qisLabel", "obtainLabeled", a_obtainLabeled);
	  check_obtainLabeled_qisLabel(
	    dynamic_cast<obtainLabeled_qisLabel *>(a_obtainLabeled), 0);
	}
      else
	check_obtainLabeled_qisLabel(
	  dynamic_cast<obtainLabeled_qisLabel *>(a_obtainLabeled), log);
      return;
    }
  if (isA(a_obtainLabeled, obtainLabeled_crLabel))
    {
      adjustLevels(&obtainLabeledSubs_obtainLabeled_crLabel,
		   "obtainLabeled_crLabel");
      if (log && !findString("obtainLabeled_crLabel", obtainLabeledSubs))
	{
	  warnSub("obtainLabeled_crLabel", "obtainLabeled", a_obtainLabeled);
	  check_obtainLabeled_crLabel(
	    dynamic_cast<obtainLabeled_crLabel *>(a_obtainLabeled), 0);
	}
      else
	check_obtainLabeled_crLabel(
	  dynamic_cast<obtainLabeled_crLabel *>(a_obtainLabeled), log);
      return;
    }
  if (isA(a_obtainLabeled, obtainLabeled_gLabel))
    {
      adjustLevels(&obtainLabeledSubs_obtainLabeled_gLabel,
		   "obtainLabeled_gLabel");
      if (log && !findString("obtainLabeled_gLabel", obtainLabeledSubs))
	{
	  warnSub("obtainLabeled_gLabel", "obtainLabeled", a_obtainLabeled);
	  check_obtainLabeled_gLabel(
	    dynamic_cast<obtainLabeled_gLabel *>(a_obtainLabeled), 0);
	}
      else
	check_obtainLabeled_gLabel(
	  dynamic_cast<obtainLabeled_gLabel *>(a_obtainLabeled), log);
      return;
    }
  if (isA(a_obtainLabeled, obtainLabeled_gsaLabel))
    {
      adjustLevels(&obtainLabeledSubs_obtainLabeled_gsaLabel,
		   "obtainLabeled_gsaLabel");
      if (log && !findString("obtainLabeled_gsaLabel", obtainLabeledSubs))
	{
	  warnSub("obtainLabeled_gsaLabel", "obtainLabeled", a_obtainLabeled);
	  check_obtainLabeled_gsaLabel(
	    dynamic_cast<obtainLabeled_gsaLabel *>(a_obtainLabeled), 0);
	}
      else
	check_obtainLabeled_gsaLabel(
	  dynamic_cast<obtainLabeled_gsaLabel *>(a_obtainLabeled), log);
      return;
    }
  if (isA(a_obtainLabeled, obtainLabeled_kcLabel))
    {
      adjustLevels(&obtainLabeledSubs_obtainLabeled_kcLabel,
		   "obtainLabeled_kcLabel");
      if (log && !findString("obtainLabeled_kcLabel", obtainLabeledSubs))
	{
	  warnSub("obtainLabeled_kcLabel", "obtainLabeled", a_obtainLabeled);
	  check_obtainLabeled_kcLabel(
	    dynamic_cast<obtainLabeled_kcLabel *>(a_obtainLabeled), 0);
	}
      else
	check_obtainLabeled_kcLabel(
	  dynamic_cast<obtainLabeled_kcLabel *>(a_obtainLabeled), log);
      return;
    }
  if (isA(a_obtainLabeled, obtainLabeled_maLabel))
    {
      adjustLevels(&obtainLabeledSubs_obtainLabeled_maLabel,
		   "obtainLabeled_maLabel");
      if (log && !findString("obtainLabeled_maLabel", obtainLabeledSubs))
	{
	  warnSub("obtainLabeled_maLabel", "obtainLabeled", a_obtainLabeled);
	  check_obtainLabeled_maLabel(
	    dynamic_cast<obtainLabeled_maLabel *>(a_obtainLabeled), 0);
	}
      else
	check_obtainLabeled_maLabel(
	  dynamic_cast<obtainLabeled_maLabel *>(a_obtainLabeled), log);
      return;
    }
  if (isA(a_obtainLabeled, obtainLabeled_pLabel))
    {
      adjustLevels(&obtainLabeledSubs_obtainLabeled_pLabel,
		   "obtainLabeled_pLabel");
      if (log && !findString("obtainLabeled_pLabel", obtainLabeledSubs))
	{
	  warnSub("obtainLabeled_pLabel", "obtainLabeled", a_obtainLabeled);
	  check_obtainLabeled_pLabel(
	    dynamic_cast<obtainLabeled_pLabel *>(a_obtainLabeled), 0);
	}
      else
	check_obtainLabeled_pLabel(
	  dynamic_cast<obtainLabeled_pLabel *>(a_obtainLabeled), log);
      return;
    }
  if (isA(a_obtainLabeled, obtainLabeled_rLabel))
    {
      adjustLevels(&obtainLabeledSubs_obtainLabeled_rLabel,
		   "obtainLabeled_rLabel");
      if (log && !findString("obtainLabeled_rLabel", obtainLabeledSubs))
	{
	  warnSub("obtainLabeled_rLabel", "obtainLabeled", a_obtainLabeled);
	  check_obtainLabeled_rLabel(
	    dynamic_cast<obtainLabeled_rLabel *>(a_obtainLabeled), 0);
	}
      else
	check_obtainLabeled_rLabel(
	  dynamic_cast<obtainLabeled_rLabel *>(a_obtainLabeled), log);
      return;
    }
  if (isA(a_obtainLabeled, obtainLabeled_rmLabel))
    {
      adjustLevels(&obtainLabeledSubs_obtainLabeled_rmLabel,
		   "obtainLabeled_rmLabel");
      if (log && !findString("obtainLabeled_rmLabel", obtainLabeledSubs))
	{
	  warnSub("obtainLabeled_rmLabel", "obtainLabeled", a_obtainLabeled);
	  check_obtainLabeled_rmLabel(
	    dynamic_cast<obtainLabeled_rmLabel *>(a_obtainLabeled), 0);
	}
      else
	check_obtainLabeled_rmLabel(
	  dynamic_cast<obtainLabeled_rmLabel *>(a_obtainLabeled), log);
      return;
    }
  if (isA(a_obtainLabeled, obtainLabeled_rtLabel))
    {
      adjustLevels(&obtainLabeledSubs_obtainLabeled_rtLabel,
		   "obtainLabeled_rtLabel");
      if (log && !findString("obtainLabeled_rtLabel", obtainLabeledSubs))
	{
	  warnSub("obtainLabeled_rtLabel", "obtainLabeled", a_obtainLabeled);
	  check_obtainLabeled_rtLabel(
	    dynamic_cast<obtainLabeled_rtLabel *>(a_obtainLabeled), 0);
	}
      else
	check_obtainLabeled_rtLabel(
	  dynamic_cast<obtainLabeled_rtLabel *>(a_obtainLabeled), log);
      return;
    }
  if (isA(a_obtainLabeled, obtainLabeled_sgLabel))
    {
      adjustLevels(&obtainLabeledSubs_obtainLabeled_sgLabel,
		   "obtainLabeled_sgLabel");
      if (log && !findString("obtainLabeled_sgLabel", obtainLabeledSubs))
	{
	  warnSub("obtainLabeled_sgLabel", "obtainLabeled", a_obtainLabeled);
	  check_obtainLabeled_sgLabel(
	    dynamic_cast<obtainLabeled_sgLabel *>(a_obtainLabeled), 0);
	}
      else
	check_obtainLabeled_sgLabel(
	  dynamic_cast<obtainLabeled_sgLabel *>(a_obtainLabeled), log);
      return;
    }
  if (isA(a_obtainLabeled, obtainLabeled_sgsLabel))
    {
      adjustLevels(&obtainLabeledSubs_obtainLabeled_sgsLabel,
		   "obtainLabeled_sgsLabel");
      if (log && !findString("obtainLabeled_sgsLabel", obtainLabeledSubs))
	{
	  warnSub("obtainLabeled_sgsLabel", "obtainLabeled", a_obtainLabeled);
	  check_obtainLabeled_sgsLabel(
	    dynamic_cast<obtainLabeled_sgsLabel *>(a_obtainLabeled), 0);
	}
      else
	check_obtainLabeled_sgsLabel(
	  dynamic_cast<obtainLabeled_sgsLabel *>(a_obtainLabeled), log);
      return;
    }
  if (isA(a_obtainLabeled, obtainLabeled_sraLabel))
    {
      adjustLevels(&obtainLabeledSubs_obtainLabeled_sraLabel,
		   "obtainLabeled_sraLabel");
      if (log && !findString("obtainLabeled_sraLabel", obtainLabeledSubs))
	{
	  warnSub("obtainLabeled_sraLabel", "obtainLabeled", a_obtainLabeled);
	  check_obtainLabeled_sraLabel(
	    dynamic_cast<obtainLabeled_sraLabel *>(a_obtainLabeled), 0);
	}
      else
	check_obtainLabeled_sraLabel(
	  dynamic_cast<obtainLabeled_sraLabel *>(a_obtainLabeled), log);
      return;
    }
  if (isA(a_obtainLabeled, obtainLabeled_ssLabel))
    {
      adjustLevels(&obtainLabeledSubs_obtainLabeled_ssLabel,
		   "obtainLabeled_ssLabel");
      if (log && !findString("obtainLabeled_ssLabel", obtainLabeledSubs))
	{
	  warnSub("obtainLabeled_ssLabel", "obtainLabeled", a_obtainLabeled);
	  check_obtainLabeled_ssLabel(
	    dynamic_cast<obtainLabeled_ssLabel *>(a_obtainLabeled), 0);
	}
      else
	check_obtainLabeled_ssLabel(
	  dynamic_cast<obtainLabeled_ssLabel *>(a_obtainLabeled), log);
      return;
    }
  if (isA(a_obtainLabeled, obtainLabeled_swLabel))
    {
      adjustLevels(&obtainLabeledSubs_obtainLabeled_swLabel,
		   "obtainLabeled_swLabel");
      if (log && !findString("obtainLabeled_swLabel", obtainLabeledSubs))
	{
	  warnSub("obtainLabeled_swLabel", "obtainLabeled", a_obtainLabeled);
	  check_obtainLabeled_swLabel(
	    dynamic_cast<obtainLabeled_swLabel *>(a_obtainLabeled), 0);
	}
      else
	check_obtainLabeled_swLabel(
	  dynamic_cast<obtainLabeled_swLabel *>(a_obtainLabeled), log);
      return;
    }
  if (isA(a_obtainLabeled, obtainLabeled_sxLabel))
    {
      adjustLevels(&obtainLabeledSubs_obtainLabeled_sxLabel,
		   "obtainLabeled_sxLabel");
      if (log && !findString("obtainLabeled_sxLabel", obtainLabeledSubs))
	{
	  warnSub("obtainLabeled_sxLabel", "obtainLabeled", a_obtainLabeled);
	  check_obtainLabeled_sxLabel(
	    dynamic_cast<obtainLabeled_sxLabel *>(a_obtainLabeled), 0);
	}
      else
	check_obtainLabeled_sxLabel(
	  dynamic_cast<obtainLabeled_sxLabel *>(a_obtainLabeled), log);
      return;
    }
  if (isA(a_obtainLabeled, obtainLabeled_thLabel))
    {
      adjustLevels(&obtainLabeledSubs_obtainLabeled_thLabel,
		   "obtainLabeled_thLabel");
      if (log && !findString("obtainLabeled_thLabel", obtainLabeledSubs))
	{
	  warnSub("obtainLabeled_thLabel", "obtainLabeled", a_obtainLabeled);
	  check_obtainLabeled_thLabel(
	    dynamic_cast<obtainLabeled_thLabel *>(a_obtainLabeled), 0);
	}
      else
	check_obtainLabeled_thLabel(
	  dynamic_cast<obtainLabeled_thLabel *>(a_obtainLabeled), log);
      return;
    }
  if (isA(a_obtainLabeled, obtainLabeled_vLabel))
    {
      adjustLevels(&obtainLabeledSubs_obtainLabeled_vLabel,
		   "obtainLabeled_vLabel");
      if (log && !findString("obtainLabeled_vLabel", obtainLabeledSubs))
	{
	  warnSub("obtainLabeled_vLabel", "obtainLabeled", a_obtainLabeled);
	  check_obtainLabeled_vLabel(
	    dynamic_cast<obtainLabeled_vLabel *>(a_obtainLabeled), 0);
	}
      else
	check_obtainLabeled_vLabel(
	  dynamic_cast<obtainLabeled_vLabel *>(a_obtainLabeled), log);
      return;
    }
  if (isA(a_obtainLabeled, obtainLabeled_vaLabel))
    {
      adjustLevels(&obtainLabeledSubs_obtainLabeled_vaLabel,
		   "obtainLabeled_vaLabel");
      if (log && !findString("obtainLabeled_vaLabel", obtainLabeledSubs))
	{
	  warnSub("obtainLabeled_vaLabel", "obtainLabeled", a_obtainLabeled);
	  check_obtainLabeled_vaLabel(
	    dynamic_cast<obtainLabeled_vaLabel *>(a_obtainLabeled), 0);
	}
      else
	check_obtainLabeled_vaLabel(
	  dynamic_cast<obtainLabeled_vaLabel *>(a_obtainLabeled), log);
      return;
    }
  if (isA(a_obtainLabeled, obtainLabeled_vfLabel))
    {
      adjustLevels(&obtainLabeledSubs_obtainLabeled_vfLabel,
		   "obtainLabeled_vfLabel");
      if (log && !findString("obtainLabeled_vfLabel", obtainLabeledSubs))
	{
	  warnSub("obtainLabeled_vfLabel", "obtainLabeled", a_obtainLabeled);
	  check_obtainLabeled_vfLabel(
	    dynamic_cast<obtainLabeled_vfLabel *>(a_obtainLabeled), 0);
	}
      else
	check_obtainLabeled_vfLabel(
	  dynamic_cast<obtainLabeled_vfLabel *>(a_obtainLabeled), log);
      return;
    }
  if (isA(a_obtainLabeled, obtainLabeled_vlLabel))
    {
      adjustLevels(&obtainLabeledSubs_obtainLabeled_vlLabel,
		   "obtainLabeled_vlLabel");
      if (log && !findString("obtainLabeled_vlLabel", obtainLabeledSubs))
	{
	  warnSub("obtainLabeled_vlLabel", "obtainLabeled", a_obtainLabeled);
	  check_obtainLabeled_vlLabel(
	    dynamic_cast<obtainLabeled_vlLabel *>(a_obtainLabeled), 0);
	}
      else
	check_obtainLabeled_vlLabel(
	  dynamic_cast<obtainLabeled_vlLabel *>(a_obtainLabeled), log);
      return;
    }
  if (isA(a_obtainLabeled, obtainLabeled_vwLabel))
    {
      adjustLevels(&obtainLabeledSubs_obtainLabeled_vwLabel,
		   "obtainLabeled_vwLabel");
      if (log && !findString("obtainLabeled_vwLabel", obtainLabeledSubs))
	{
	  warnSub("obtainLabeled_vwLabel", "obtainLabeled", a_obtainLabeled);
	  check_obtainLabeled_vwLabel(
	    dynamic_cast<obtainLabeled_vwLabel *>(a_obtainLabeled), 0);
	}
      else
	check_obtainLabeled_vwLabel(
	  dynamic_cast<obtainLabeled_vwLabel *>(a_obtainLabeled), log);
      return;
    }
}

/********************************************************************/

void check_obtainLabeled_crLabel(
 obtainLabeled_crLabel * a_obtainLabeled_crLabel,
 int log)
{
  if (a_obtainLabeled_crLabel->get_crLabel())
    {
      adjustLevels(&obtainLabeled_crLabelAtts_a_crLabel,
		   "obtainLabeled_crLabel a_crLabel");
      if (log && !findString("a_crLabel", obtainLabeled_crLabelAtts))
	{
	  warnAtt("a_crLabel", "obtainLabeled_crLabel",
		  a_obtainLabeled_crLabel);
	  check_crLabel(a_obtainLabeled_crLabel->get_crLabel(), 0);
	}
      else
	check_crLabel(a_obtainLabeled_crLabel->get_crLabel(), log);
    }
  if (a_obtainLabeled_crLabel->get_index())
    {
      adjustLevels(&obtainLabeled_crLabelAtts_index,
		   "obtainLabeled_crLabel index");
      if (log && !findString("index", obtainLabeled_crLabelAtts))
	{
	  warnAtt("index", "obtainLabeled_crLabel", a_obtainLabeled_crLabel);
	  check_intVal(a_obtainLabeled_crLabel->get_index(), 0);
	}
      else
	check_intVal(a_obtainLabeled_crLabel->get_index(), log);
    }
}

/********************************************************************/

void check_obtainLabeled_datumLabel1(
 obtainLabeled_datumLabel1 * a_obtainLabeled_datumLabel1,
 int log)
{
  if (a_obtainLabeled_datumLabel1->get_datumLabel1())
    {
      adjustLevels(&obtainLabeled_datumLabel1Atts_a_datumLabel1,
		   "obtainLabeled_datumLabel1 a_datumLabel1");
      if (log && !findString("a_datumLabel1", obtainLabeled_datumLabel1Atts))
	{
	  warnAtt("a_datumLabel1", "obtainLabeled_datumLabel1",
		  a_obtainLabeled_datumLabel1);
	  check_datumLabel1(a_obtainLabeled_datumLabel1->get_datumLabel1(), 0);
	}
      else
	check_datumLabel1(a_obtainLabeled_datumLabel1->get_datumLabel1(), log);
    }
  if (a_obtainLabeled_datumLabel1->get_index())
    {
      adjustLevels(&obtainLabeled_datumLabel1Atts_index,
		   "obtainLabeled_datumLabel1 index");
      if (log && !findString("index", obtainLabeled_datumLabel1Atts))
	{
	  warnAtt("index", "obtainLabeled_datumLabel1",
		  a_obtainLabeled_datumLabel1);
	  check_intVal(a_obtainLabeled_datumLabel1->get_index(), 0);
	}
      else
	check_intVal(a_obtainLabeled_datumLabel1->get_index(), log);
    }
}

/********************************************************************/

void check_obtainLabeled_didLabel(
 obtainLabeled_didLabel * a_obtainLabeled_didLabel,
 int log)
{
  if (a_obtainLabeled_didLabel->get_didLabel())
    {
      adjustLevels(&obtainLabeled_didLabelAtts_a_didLabel,
		   "obtainLabeled_didLabel a_didLabel");
      if (log && !findString("a_didLabel", obtainLabeled_didLabelAtts))
	{
	  warnAtt("a_didLabel", "obtainLabeled_didLabel",
		  a_obtainLabeled_didLabel);
	  check_didLabel(a_obtainLabeled_didLabel->get_didLabel(), 0);
	}
      else
	check_didLabel(a_obtainLabeled_didLabel->get_didLabel(), log);
    }
  if (a_obtainLabeled_didLabel->get_index())
    {
      adjustLevels(&obtainLabeled_didLabelAtts_index,
		   "obtainLabeled_didLabel index");
      if (log && !findString("index", obtainLabeled_didLabelAtts))
	{
	  warnAtt("index", "obtainLabeled_didLabel",
		  a_obtainLabeled_didLabel);
	  check_intVal(a_obtainLabeled_didLabel->get_index(), 0);
	}
      else
	check_intVal(a_obtainLabeled_didLabel->get_index(), log);
    }
}

/********************************************************************/

void check_obtainLabeled_featureLabel(
 obtainLabeled_featureLabel * a_obtainLabeled_featureLabel,
 int log)
{
  if (a_obtainLabeled_featureLabel->get_featureLabel())
    {
      adjustLevels(&obtainLabeled_featureLabelAtts_a_featureLabel,
		   "obtainLabeled_featureLabel a_featureLabel");
      if (log && !findString("a_featureLabel", obtainLabeled_featureLabelAtts))
	{
	  warnAtt("a_featureLabel", "obtainLabeled_featureLabel",
		  a_obtainLabeled_featureLabel);
	  check_featureLabel(
	    a_obtainLabeled_featureLabel->get_featureLabel(), 0);
	}
      else
	check_featureLabel(
	  a_obtainLabeled_featureLabel->get_featureLabel(), log);
    }
  if (a_obtainLabeled_featureLabel->get_index())
    {
      adjustLevels(&obtainLabeled_featureLabelAtts_index,
		   "obtainLabeled_featureLabel index");
      if (log && !findString("index", obtainLabeled_featureLabelAtts))
	{
	  warnAtt("index", "obtainLabeled_featureLabel",
		  a_obtainLabeled_featureLabel);
	  check_intVal(a_obtainLabeled_featureLabel->get_index(), 0);
	}
      else
	check_intVal(a_obtainLabeled_featureLabel->get_index(), log);
    }
}

/********************************************************************/

void check_obtainLabeled_gLabel(
 obtainLabeled_gLabel * a_obtainLabeled_gLabel,
 int log)
{
  if (a_obtainLabeled_gLabel->get_gLabel())
    {
      adjustLevels(&obtainLabeled_gLabelAtts_a_gLabel,
		   "obtainLabeled_gLabel a_gLabel");
      if (log && !findString("a_gLabel", obtainLabeled_gLabelAtts))
	{
	  warnAtt("a_gLabel", "obtainLabeled_gLabel", a_obtainLabeled_gLabel);
	  check_gLabel(a_obtainLabeled_gLabel->get_gLabel(), 0);
	}
      else
	check_gLabel(a_obtainLabeled_gLabel->get_gLabel(), log);
    }
  if (a_obtainLabeled_gLabel->get_index())
    {
      adjustLevels(&obtainLabeled_gLabelAtts_index,
		   "obtainLabeled_gLabel index");
      if (log && !findString("index", obtainLabeled_gLabelAtts))
	{
	  warnAtt("index", "obtainLabeled_gLabel", a_obtainLabeled_gLabel);
	  check_intVal(a_obtainLabeled_gLabel->get_index(), 0);
	}
      else
	check_intVal(a_obtainLabeled_gLabel->get_index(), log);
    }
}

/********************************************************************/

void check_obtainLabeled_gsaLabel(
 obtainLabeled_gsaLabel * a_obtainLabeled_gsaLabel,
 int log)
{
  if (a_obtainLabeled_gsaLabel->get_gsaLabel())
    {
      adjustLevels(&obtainLabeled_gsaLabelAtts_a_gsaLabel,
		   "obtainLabeled_gsaLabel a_gsaLabel");
      if (log && !findString("a_gsaLabel", obtainLabeled_gsaLabelAtts))
	{
	  warnAtt("a_gsaLabel", "obtainLabeled_gsaLabel",
		  a_obtainLabeled_gsaLabel);
	  check_gsaLabel(a_obtainLabeled_gsaLabel->get_gsaLabel(), 0);
	}
      else
	check_gsaLabel(a_obtainLabeled_gsaLabel->get_gsaLabel(), log);
    }
  if (a_obtainLabeled_gsaLabel->get_index())
    {
      adjustLevels(&obtainLabeled_gsaLabelAtts_index,
		   "obtainLabeled_gsaLabel index");
      if (log && !findString("index", obtainLabeled_gsaLabelAtts))
	{
	  warnAtt("index", "obtainLabeled_gsaLabel",
		  a_obtainLabeled_gsaLabel);
	  check_intVal(a_obtainLabeled_gsaLabel->get_index(), 0);
	}
      else
	check_intVal(a_obtainLabeled_gsaLabel->get_index(), log);
    }
}

/********************************************************************/

void check_obtainLabeled_kcLabel(
 obtainLabeled_kcLabel * a_obtainLabeled_kcLabel,
 int log)
{
  if (a_obtainLabeled_kcLabel->get_kcLabel())
    {
      adjustLevels(&obtainLabeled_kcLabelAtts_a_kcLabel,
		   "obtainLabeled_kcLabel a_kcLabel");
      if (log && !findString("a_kcLabel", obtainLabeled_kcLabelAtts))
	{
	  warnAtt("a_kcLabel", "obtainLabeled_kcLabel",
		  a_obtainLabeled_kcLabel);
	  check_kcLabel(a_obtainLabeled_kcLabel->get_kcLabel(), 0);
	}
      else
	check_kcLabel(a_obtainLabeled_kcLabel->get_kcLabel(), log);
    }
  if (a_obtainLabeled_kcLabel->get_index())
    {
      adjustLevels(&obtainLabeled_kcLabelAtts_index,
		   "obtainLabeled_kcLabel index");
      if (log && !findString("index", obtainLabeled_kcLabelAtts))
	{
	  warnAtt("index", "obtainLabeled_kcLabel", a_obtainLabeled_kcLabel);
	  check_intVal(a_obtainLabeled_kcLabel->get_index(), 0);
	}
      else
	check_intVal(a_obtainLabeled_kcLabel->get_index(), log);
    }
}

/********************************************************************/

void check_obtainLabeled_maLabel(
 obtainLabeled_maLabel * a_obtainLabeled_maLabel,
 int log)
{
  if (a_obtainLabeled_maLabel->get_maLabel())
    {
      adjustLevels(&obtainLabeled_maLabelAtts_a_maLabel,
		   "obtainLabeled_maLabel a_maLabel");
      if (log && !findString("a_maLabel", obtainLabeled_maLabelAtts))
	{
	  warnAtt("a_maLabel", "obtainLabeled_maLabel",
		  a_obtainLabeled_maLabel);
	  check_maLabel(a_obtainLabeled_maLabel->get_maLabel(), 0);
	}
      else
	check_maLabel(a_obtainLabeled_maLabel->get_maLabel(), log);
    }
  if (a_obtainLabeled_maLabel->get_index())
    {
      adjustLevels(&obtainLabeled_maLabelAtts_index,
		   "obtainLabeled_maLabel index");
      if (log && !findString("index", obtainLabeled_maLabelAtts))
	{
	  warnAtt("index", "obtainLabeled_maLabel", a_obtainLabeled_maLabel);
	  check_intVal(a_obtainLabeled_maLabel->get_index(), 0);
	}
      else
	check_intVal(a_obtainLabeled_maLabel->get_index(), log);
    }
}

/********************************************************************/

void check_obtainLabeled_pLabel(
 obtainLabeled_pLabel * a_obtainLabeled_pLabel,
 int log)
{
  if (a_obtainLabeled_pLabel->get_pLabel())
    {
      adjustLevels(&obtainLabeled_pLabelAtts_a_pLabel,
		   "obtainLabeled_pLabel a_pLabel");
      if (log && !findString("a_pLabel", obtainLabeled_pLabelAtts))
	{
	  warnAtt("a_pLabel", "obtainLabeled_pLabel", a_obtainLabeled_pLabel);
	  check_pLabel(a_obtainLabeled_pLabel->get_pLabel(), 0);
	}
      else
	check_pLabel(a_obtainLabeled_pLabel->get_pLabel(), log);
    }
  if (a_obtainLabeled_pLabel->get_index())
    {
      adjustLevels(&obtainLabeled_pLabelAtts_index,
		   "obtainLabeled_pLabel index");
      if (log && !findString("index", obtainLabeled_pLabelAtts))
	{
	  warnAtt("index", "obtainLabeled_pLabel", a_obtainLabeled_pLabel);
	  check_intVal(a_obtainLabeled_pLabel->get_index(), 0);
	}
      else
	check_intVal(a_obtainLabeled_pLabel->get_index(), log);
    }
}

/********************************************************************/

void check_obtainLabeled_qisLabel(
 obtainLabeled_qisLabel * a_obtainLabeled_qisLabel,
 int log)
{
  if (a_obtainLabeled_qisLabel->get_qisLabel())
    {
      adjustLevels(&obtainLabeled_qisLabelAtts_a_qisLabel,
		   "obtainLabeled_qisLabel a_qisLabel");
      if (log && !findString("a_qisLabel", obtainLabeled_qisLabelAtts))
	{
	  warnAtt("a_qisLabel", "obtainLabeled_qisLabel",
		  a_obtainLabeled_qisLabel);
	  check_qisLabel(a_obtainLabeled_qisLabel->get_qisLabel(), 0);
	}
      else
	check_qisLabel(a_obtainLabeled_qisLabel->get_qisLabel(), log);
    }
  if (a_obtainLabeled_qisLabel->get_index())
    {
      adjustLevels(&obtainLabeled_qisLabelAtts_index,
		   "obtainLabeled_qisLabel index");
      if (log && !findString("index", obtainLabeled_qisLabelAtts))
	{
	  warnAtt("index", "obtainLabeled_qisLabel",
		  a_obtainLabeled_qisLabel);
	  check_intVal(a_obtainLabeled_qisLabel->get_index(), 0);
	}
      else
	check_intVal(a_obtainLabeled_qisLabel->get_index(), log);
    }
}

/********************************************************************/

void check_obtainLabeled_rLabel(
 obtainLabeled_rLabel * a_obtainLabeled_rLabel,
 int log)
{
  if (a_obtainLabeled_rLabel->get_rLabel())
    {
      adjustLevels(&obtainLabeled_rLabelAtts_a_rLabel,
		   "obtainLabeled_rLabel a_rLabel");
      if (log && !findString("a_rLabel", obtainLabeled_rLabelAtts))
	{
	  warnAtt("a_rLabel", "obtainLabeled_rLabel", a_obtainLabeled_rLabel);
	  check_rLabel(a_obtainLabeled_rLabel->get_rLabel(), 0);
	}
      else
	check_rLabel(a_obtainLabeled_rLabel->get_rLabel(), log);
    }
  if (a_obtainLabeled_rLabel->get_index())
    {
      adjustLevels(&obtainLabeled_rLabelAtts_index,
		   "obtainLabeled_rLabel index");
      if (log && !findString("index", obtainLabeled_rLabelAtts))
	{
	  warnAtt("index", "obtainLabeled_rLabel", a_obtainLabeled_rLabel);
	  check_intVal(a_obtainLabeled_rLabel->get_index(), 0);
	}
      else
	check_intVal(a_obtainLabeled_rLabel->get_index(), log);
    }
}

/********************************************************************/

void check_obtainLabeled_rmLabel(
 obtainLabeled_rmLabel * a_obtainLabeled_rmLabel,
 int log)
{
  if (a_obtainLabeled_rmLabel->get_rmLabel())
    {
      adjustLevels(&obtainLabeled_rmLabelAtts_a_rmLabel,
		   "obtainLabeled_rmLabel a_rmLabel");
      if (log && !findString("a_rmLabel", obtainLabeled_rmLabelAtts))
	{
	  warnAtt("a_rmLabel", "obtainLabeled_rmLabel",
		  a_obtainLabeled_rmLabel);
	  check_rmLabel(a_obtainLabeled_rmLabel->get_rmLabel(), 0);
	}
      else
	check_rmLabel(a_obtainLabeled_rmLabel->get_rmLabel(), log);
    }
  if (a_obtainLabeled_rmLabel->get_index())
    {
      adjustLevels(&obtainLabeled_rmLabelAtts_index,
		   "obtainLabeled_rmLabel index");
      if (log && !findString("index", obtainLabeled_rmLabelAtts))
	{
	  warnAtt("index", "obtainLabeled_rmLabel", a_obtainLabeled_rmLabel);
	  check_intVal(a_obtainLabeled_rmLabel->get_index(), 0);
	}
      else
	check_intVal(a_obtainLabeled_rmLabel->get_index(), log);
    }
}

/********************************************************************/

void check_obtainLabeled_rtLabel(
 obtainLabeled_rtLabel * a_obtainLabeled_rtLabel,
 int log)
{
  if (a_obtainLabeled_rtLabel->get_rtLabel())
    {
      adjustLevels(&obtainLabeled_rtLabelAtts_a_rtLabel,
		   "obtainLabeled_rtLabel a_rtLabel");
      if (log && !findString("a_rtLabel", obtainLabeled_rtLabelAtts))
	{
	  warnAtt("a_rtLabel", "obtainLabeled_rtLabel",
		  a_obtainLabeled_rtLabel);
	  check_rtLabel(a_obtainLabeled_rtLabel->get_rtLabel(), 0);
	}
      else
	check_rtLabel(a_obtainLabeled_rtLabel->get_rtLabel(), log);
    }
  if (a_obtainLabeled_rtLabel->get_index())
    {
      adjustLevels(&obtainLabeled_rtLabelAtts_index,
		   "obtainLabeled_rtLabel index");
      if (log && !findString("index", obtainLabeled_rtLabelAtts))
	{
	  warnAtt("index", "obtainLabeled_rtLabel", a_obtainLabeled_rtLabel);
	  check_intVal(a_obtainLabeled_rtLabel->get_index(), 0);
	}
      else
	check_intVal(a_obtainLabeled_rtLabel->get_index(), log);
    }
}

/********************************************************************/

void check_obtainLabeled_sensorLabel1(
 obtainLabeled_sensorLabel1 * a_obtainLabeled_sensorLabel1,
 int log)
{
  if (a_obtainLabeled_sensorLabel1->get_sensorLabel1())
    {
      adjustLevels(&obtainLabeled_sensorLabel1Atts_a_sensorLabel1,
		   "obtainLabeled_sensorLabel1 a_sensorLabel1");
      if (log && !findString("a_sensorLabel1", obtainLabeled_sensorLabel1Atts))
	{
	  warnAtt("a_sensorLabel1", "obtainLabeled_sensorLabel1",
		  a_obtainLabeled_sensorLabel1);
	  check_sensorLabel1(
	    a_obtainLabeled_sensorLabel1->get_sensorLabel1(), 0);
	}
      else
	check_sensorLabel1(
	  a_obtainLabeled_sensorLabel1->get_sensorLabel1(), log);
    }
  if (a_obtainLabeled_sensorLabel1->get_index())
    {
      adjustLevels(&obtainLabeled_sensorLabel1Atts_index,
		   "obtainLabeled_sensorLabel1 index");
      if (log && !findString("index", obtainLabeled_sensorLabel1Atts))
	{
	  warnAtt("index", "obtainLabeled_sensorLabel1",
		  a_obtainLabeled_sensorLabel1);
	  check_intVal(a_obtainLabeled_sensorLabel1->get_index(), 0);
	}
      else
	check_intVal(a_obtainLabeled_sensorLabel1->get_index(), log);
    }
}

/********************************************************************/

void check_obtainLabeled_sgLabel(
 obtainLabeled_sgLabel * a_obtainLabeled_sgLabel,
 int log)
{
  if (a_obtainLabeled_sgLabel->get_sgLabel())
    {
      adjustLevels(&obtainLabeled_sgLabelAtts_a_sgLabel,
		   "obtainLabeled_sgLabel a_sgLabel");
      if (log && !findString("a_sgLabel", obtainLabeled_sgLabelAtts))
	{
	  warnAtt("a_sgLabel", "obtainLabeled_sgLabel",
		  a_obtainLabeled_sgLabel);
	  check_sgLabel(a_obtainLabeled_sgLabel->get_sgLabel(), 0);
	}
      else
	check_sgLabel(a_obtainLabeled_sgLabel->get_sgLabel(), log);
    }
  if (a_obtainLabeled_sgLabel->get_index())
    {
      adjustLevels(&obtainLabeled_sgLabelAtts_index,
		   "obtainLabeled_sgLabel index");
      if (log && !findString("index", obtainLabeled_sgLabelAtts))
	{
	  warnAtt("index", "obtainLabeled_sgLabel", a_obtainLabeled_sgLabel);
	  check_intVal(a_obtainLabeled_sgLabel->get_index(), 0);
	}
      else
	check_intVal(a_obtainLabeled_sgLabel->get_index(), log);
    }
}

/********************************************************************/

void check_obtainLabeled_sgsLabel(
 obtainLabeled_sgsLabel * a_obtainLabeled_sgsLabel,
 int log)
{
  if (a_obtainLabeled_sgsLabel->get_sgsLabel())
    {
      adjustLevels(&obtainLabeled_sgsLabelAtts_a_sgsLabel,
		   "obtainLabeled_sgsLabel a_sgsLabel");
      if (log && !findString("a_sgsLabel", obtainLabeled_sgsLabelAtts))
	{
	  warnAtt("a_sgsLabel", "obtainLabeled_sgsLabel",
		  a_obtainLabeled_sgsLabel);
	  check_sgsLabel(a_obtainLabeled_sgsLabel->get_sgsLabel(), 0);
	}
      else
	check_sgsLabel(a_obtainLabeled_sgsLabel->get_sgsLabel(), log);
    }
  if (a_obtainLabeled_sgsLabel->get_index())
    {
      adjustLevels(&obtainLabeled_sgsLabelAtts_index,
		   "obtainLabeled_sgsLabel index");
      if (log && !findString("index", obtainLabeled_sgsLabelAtts))
	{
	  warnAtt("index", "obtainLabeled_sgsLabel",
		  a_obtainLabeled_sgsLabel);
	  check_intVal(a_obtainLabeled_sgsLabel->get_index(), 0);
	}
      else
	check_intVal(a_obtainLabeled_sgsLabel->get_index(), log);
    }
}

/********************************************************************/

void check_obtainLabeled_sraLabel(
 obtainLabeled_sraLabel * a_obtainLabeled_sraLabel,
 int log)
{
  if (a_obtainLabeled_sraLabel->get_sraLabel())
    {
      adjustLevels(&obtainLabeled_sraLabelAtts_a_sraLabel,
		   "obtainLabeled_sraLabel a_sraLabel");
      if (log && !findString("a_sraLabel", obtainLabeled_sraLabelAtts))
	{
	  warnAtt("a_sraLabel", "obtainLabeled_sraLabel",
		  a_obtainLabeled_sraLabel);
	  check_sraLabel(a_obtainLabeled_sraLabel->get_sraLabel(), 0);
	}
      else
	check_sraLabel(a_obtainLabeled_sraLabel->get_sraLabel(), log);
    }
  if (a_obtainLabeled_sraLabel->get_index())
    {
      adjustLevels(&obtainLabeled_sraLabelAtts_index,
		   "obtainLabeled_sraLabel index");
      if (log && !findString("index", obtainLabeled_sraLabelAtts))
	{
	  warnAtt("index", "obtainLabeled_sraLabel",
		  a_obtainLabeled_sraLabel);
	  check_intVal(a_obtainLabeled_sraLabel->get_index(), 0);
	}
      else
	check_intVal(a_obtainLabeled_sraLabel->get_index(), log);
    }
}

/********************************************************************/

void check_obtainLabeled_ssLabel(
 obtainLabeled_ssLabel * a_obtainLabeled_ssLabel,
 int log)
{
  if (a_obtainLabeled_ssLabel->get_ssLabel())
    {
      adjustLevels(&obtainLabeled_ssLabelAtts_a_ssLabel,
		   "obtainLabeled_ssLabel a_ssLabel");
      if (log && !findString("a_ssLabel", obtainLabeled_ssLabelAtts))
	{
	  warnAtt("a_ssLabel", "obtainLabeled_ssLabel",
		  a_obtainLabeled_ssLabel);
	  check_ssLabel(a_obtainLabeled_ssLabel->get_ssLabel(), 0);
	}
      else
	check_ssLabel(a_obtainLabeled_ssLabel->get_ssLabel(), log);
    }
  if (a_obtainLabeled_ssLabel->get_index())
    {
      adjustLevels(&obtainLabeled_ssLabelAtts_index,
		   "obtainLabeled_ssLabel index");
      if (log && !findString("index", obtainLabeled_ssLabelAtts))
	{
	  warnAtt("index", "obtainLabeled_ssLabel", a_obtainLabeled_ssLabel);
	  check_intVal(a_obtainLabeled_ssLabel->get_index(), 0);
	}
      else
	check_intVal(a_obtainLabeled_ssLabel->get_index(), log);
    }
}

/********************************************************************/

void check_obtainLabeled_swLabel(
 obtainLabeled_swLabel * a_obtainLabeled_swLabel,
 int log)
{
  if (a_obtainLabeled_swLabel->get_swLabel())
    {
      adjustLevels(&obtainLabeled_swLabelAtts_a_swLabel,
		   "obtainLabeled_swLabel a_swLabel");
      if (log && !findString("a_swLabel", obtainLabeled_swLabelAtts))
	{
	  warnAtt("a_swLabel", "obtainLabeled_swLabel",
		  a_obtainLabeled_swLabel);
	  check_swLabel(a_obtainLabeled_swLabel->get_swLabel(), 0);
	}
      else
	check_swLabel(a_obtainLabeled_swLabel->get_swLabel(), log);
    }
  if (a_obtainLabeled_swLabel->get_index())
    {
      adjustLevels(&obtainLabeled_swLabelAtts_index,
		   "obtainLabeled_swLabel index");
      if (log && !findString("index", obtainLabeled_swLabelAtts))
	{
	  warnAtt("index", "obtainLabeled_swLabel", a_obtainLabeled_swLabel);
	  check_intVal(a_obtainLabeled_swLabel->get_index(), 0);
	}
      else
	check_intVal(a_obtainLabeled_swLabel->get_index(), log);
    }
}

/********************************************************************/

void check_obtainLabeled_sxLabel(
 obtainLabeled_sxLabel * a_obtainLabeled_sxLabel,
 int log)
{
  if (a_obtainLabeled_sxLabel->get_sxLabel())
    {
      adjustLevels(&obtainLabeled_sxLabelAtts_a_sxLabel,
		   "obtainLabeled_sxLabel a_sxLabel");
      if (log && !findString("a_sxLabel", obtainLabeled_sxLabelAtts))
	{
	  warnAtt("a_sxLabel", "obtainLabeled_sxLabel",
		  a_obtainLabeled_sxLabel);
	  check_sxLabel(a_obtainLabeled_sxLabel->get_sxLabel(), 0);
	}
      else
	check_sxLabel(a_obtainLabeled_sxLabel->get_sxLabel(), log);
    }
  if (a_obtainLabeled_sxLabel->get_index())
    {
      adjustLevels(&obtainLabeled_sxLabelAtts_index,
		   "obtainLabeled_sxLabel index");
      if (log && !findString("index", obtainLabeled_sxLabelAtts))
	{
	  warnAtt("index", "obtainLabeled_sxLabel", a_obtainLabeled_sxLabel);
	  check_intVal(a_obtainLabeled_sxLabel->get_index(), 0);
	}
      else
	check_intVal(a_obtainLabeled_sxLabel->get_index(), log);
    }
}

/********************************************************************/

void check_obtainLabeled_thLabel(
 obtainLabeled_thLabel * a_obtainLabeled_thLabel,
 int log)
{
  if (a_obtainLabeled_thLabel->get_thLabel())
    {
      adjustLevels(&obtainLabeled_thLabelAtts_a_thLabel,
		   "obtainLabeled_thLabel a_thLabel");
      if (log && !findString("a_thLabel", obtainLabeled_thLabelAtts))
	{
	  warnAtt("a_thLabel", "obtainLabeled_thLabel",
		  a_obtainLabeled_thLabel);
	  check_thLabel(a_obtainLabeled_thLabel->get_thLabel(), 0);
	}
      else
	check_thLabel(a_obtainLabeled_thLabel->get_thLabel(), log);
    }
  if (a_obtainLabeled_thLabel->get_index())
    {
      adjustLevels(&obtainLabeled_thLabelAtts_index,
		   "obtainLabeled_thLabel index");
      if (log && !findString("index", obtainLabeled_thLabelAtts))
	{
	  warnAtt("index", "obtainLabeled_thLabel", a_obtainLabeled_thLabel);
	  check_intVal(a_obtainLabeled_thLabel->get_index(), 0);
	}
      else
	check_intVal(a_obtainLabeled_thLabel->get_index(), log);
    }
}

/********************************************************************/

void check_obtainLabeled_toleranceLabel(
 obtainLabeled_toleranceLabel * a_obtainLabeled_toleranceLabel,
 int log)
{
  if (a_obtainLabeled_toleranceLabel->get_toleranceLabel())
    {
      adjustLevels(&obtainLabeled_toleranceLabelAtts_a_toleranceLabel,
		   "obtainLabeled_toleranceLabel a_toleranceLabel");
      if (log && !findString("a_toleranceLabel",
			     obtainLabeled_toleranceLabelAtts))
	{
	  warnAtt("a_toleranceLabel", "obtainLabeled_toleranceLabel",
		  a_obtainLabeled_toleranceLabel);
	  check_toleranceLabel(
	    a_obtainLabeled_toleranceLabel->get_toleranceLabel(), 0);
	}
      else
	check_toleranceLabel(
	  a_obtainLabeled_toleranceLabel->get_toleranceLabel(), log);
    }
  if (a_obtainLabeled_toleranceLabel->get_index())
    {
      adjustLevels(&obtainLabeled_toleranceLabelAtts_index,
		   "obtainLabeled_toleranceLabel index");
      if (log && !findString("index", obtainLabeled_toleranceLabelAtts))
	{
	  warnAtt("index", "obtainLabeled_toleranceLabel",
		  a_obtainLabeled_toleranceLabel);
	  check_intVal(a_obtainLabeled_toleranceLabel->get_index(), 0);
	}
      else
	check_intVal(a_obtainLabeled_toleranceLabel->get_index(), log);
    }
}

/********************************************************************/

void check_obtainLabeled_vLabel(
 obtainLabeled_vLabel * a_obtainLabeled_vLabel,
 int log)
{
  if (a_obtainLabeled_vLabel->get_vLabel())
    {
      adjustLevels(&obtainLabeled_vLabelAtts_a_vLabel,
		   "obtainLabeled_vLabel a_vLabel");
      if (log && !findString("a_vLabel", obtainLabeled_vLabelAtts))
	{
	  warnAtt("a_vLabel", "obtainLabeled_vLabel", a_obtainLabeled_vLabel);
	  check_vLabel(a_obtainLabeled_vLabel->get_vLabel(), 0);
	}
      else
	check_vLabel(a_obtainLabeled_vLabel->get_vLabel(), log);
    }
  if (a_obtainLabeled_vLabel->get_index())
    {
      adjustLevels(&obtainLabeled_vLabelAtts_index,
		   "obtainLabeled_vLabel index");
      if (log && !findString("index", obtainLabeled_vLabelAtts))
	{
	  warnAtt("index", "obtainLabeled_vLabel", a_obtainLabeled_vLabel);
	  check_intVal(a_obtainLabeled_vLabel->get_index(), 0);
	}
      else
	check_intVal(a_obtainLabeled_vLabel->get_index(), log);
    }
}

/********************************************************************/

void check_obtainLabeled_vaLabel(
 obtainLabeled_vaLabel * a_obtainLabeled_vaLabel,
 int log)
{
  if (a_obtainLabeled_vaLabel->get_vaLabel())
    {
      adjustLevels(&obtainLabeled_vaLabelAtts_a_vaLabel,
		   "obtainLabeled_vaLabel a_vaLabel");
      if (log && !findString("a_vaLabel", obtainLabeled_vaLabelAtts))
	{
	  warnAtt("a_vaLabel", "obtainLabeled_vaLabel",
		  a_obtainLabeled_vaLabel);
	  check_vaLabel(a_obtainLabeled_vaLabel->get_vaLabel(), 0);
	}
      else
	check_vaLabel(a_obtainLabeled_vaLabel->get_vaLabel(), log);
    }
  if (a_obtainLabeled_vaLabel->get_index())
    {
      adjustLevels(&obtainLabeled_vaLabelAtts_index,
		   "obtainLabeled_vaLabel index");
      if (log && !findString("index", obtainLabeled_vaLabelAtts))
	{
	  warnAtt("index", "obtainLabeled_vaLabel", a_obtainLabeled_vaLabel);
	  check_intVal(a_obtainLabeled_vaLabel->get_index(), 0);
	}
      else
	check_intVal(a_obtainLabeled_vaLabel->get_index(), log);
    }
}

/********************************************************************/

void check_obtainLabeled_vfLabel(
 obtainLabeled_vfLabel * a_obtainLabeled_vfLabel,
 int log)
{
  if (a_obtainLabeled_vfLabel->get_vfLabel())
    {
      adjustLevels(&obtainLabeled_vfLabelAtts_a_vfLabel,
		   "obtainLabeled_vfLabel a_vfLabel");
      if (log && !findString("a_vfLabel", obtainLabeled_vfLabelAtts))
	{
	  warnAtt("a_vfLabel", "obtainLabeled_vfLabel",
		  a_obtainLabeled_vfLabel);
	  check_vfLabel(a_obtainLabeled_vfLabel->get_vfLabel(), 0);
	}
      else
	check_vfLabel(a_obtainLabeled_vfLabel->get_vfLabel(), log);
    }
  if (a_obtainLabeled_vfLabel->get_index())
    {
      adjustLevels(&obtainLabeled_vfLabelAtts_index,
		   "obtainLabeled_vfLabel index");
      if (log && !findString("index", obtainLabeled_vfLabelAtts))
	{
	  warnAtt("index", "obtainLabeled_vfLabel", a_obtainLabeled_vfLabel);
	  check_intVal(a_obtainLabeled_vfLabel->get_index(), 0);
	}
      else
	check_intVal(a_obtainLabeled_vfLabel->get_index(), log);
    }
}

/********************************************************************/

void check_obtainLabeled_vlLabel(
 obtainLabeled_vlLabel * a_obtainLabeled_vlLabel,
 int log)
{
  if (a_obtainLabeled_vlLabel->get_vlLabel())
    {
      adjustLevels(&obtainLabeled_vlLabelAtts_a_vlLabel,
		   "obtainLabeled_vlLabel a_vlLabel");
      if (log && !findString("a_vlLabel", obtainLabeled_vlLabelAtts))
	{
	  warnAtt("a_vlLabel", "obtainLabeled_vlLabel",
		  a_obtainLabeled_vlLabel);
	  check_vlLabel(a_obtainLabeled_vlLabel->get_vlLabel(), 0);
	}
      else
	check_vlLabel(a_obtainLabeled_vlLabel->get_vlLabel(), log);
    }
  if (a_obtainLabeled_vlLabel->get_index())
    {
      adjustLevels(&obtainLabeled_vlLabelAtts_index,
		   "obtainLabeled_vlLabel index");
      if (log && !findString("index", obtainLabeled_vlLabelAtts))
	{
	  warnAtt("index", "obtainLabeled_vlLabel", a_obtainLabeled_vlLabel);
	  check_intVal(a_obtainLabeled_vlLabel->get_index(), 0);
	}
      else
	check_intVal(a_obtainLabeled_vlLabel->get_index(), log);
    }
}

/********************************************************************/

void check_obtainLabeled_vwLabel(
 obtainLabeled_vwLabel * a_obtainLabeled_vwLabel,
 int log)
{
  if (a_obtainLabeled_vwLabel->get_vwLabel())
    {
      adjustLevels(&obtainLabeled_vwLabelAtts_a_vwLabel,
		   "obtainLabeled_vwLabel a_vwLabel");
      if (log && !findString("a_vwLabel", obtainLabeled_vwLabelAtts))
	{
	  warnAtt("a_vwLabel", "obtainLabeled_vwLabel",
		  a_obtainLabeled_vwLabel);
	  check_vwLabel(a_obtainLabeled_vwLabel->get_vwLabel(), 0);
	}
      else
	check_vwLabel(a_obtainLabeled_vwLabel->get_vwLabel(), log);
    }
  if (a_obtainLabeled_vwLabel->get_index())
    {
      adjustLevels(&obtainLabeled_vwLabelAtts_index,
		   "obtainLabeled_vwLabel index");
      if (log && !findString("index", obtainLabeled_vwLabelAtts))
	{
	  warnAtt("index", "obtainLabeled_vwLabel", a_obtainLabeled_vwLabel);
	  check_intVal(a_obtainLabeled_vwLabel->get_index(), 0);
	}
      else
	check_intVal(a_obtainLabeled_vwLabel->get_index(), log);
    }
}

/********************************************************************/

void check_obtainPoint(
 obtainPoint * a_obtainPoint,
 int log)
{
  if (a_obtainPoint->get_featureLabel())
    {
      adjustLevels(&obtainPointAtts_a_featureLabel,
		   "obtainPoint a_featureLabel");
      if (log && !findString("a_featureLabel", obtainPointAtts))
	{
	  warnAtt("a_featureLabel", "obtainPoint", a_obtainPoint);
	  check_featureLabel(a_obtainPoint->get_featureLabel(), 0);
	}
      else
	check_featureLabel(a_obtainPoint->get_featureLabel(), log);
    }
  if (a_obtainPoint->get_subscr())
    {
      adjustLevels(&obtainPointAtts_subscr, "obtainPoint subscr");
      if (log && !findString("subscr", obtainPointAtts))
	{
	  warnAtt("subscr", "obtainPoint", a_obtainPoint);
	  check_intVal(a_obtainPoint->get_subscr(), 0);
	}
      else
	check_intVal(a_obtainPoint->get_subscr(), log);
    }
  if (a_obtainPoint->get_index())
    {
      adjustLevels(&obtainPointAtts_index, "obtainPoint index");
      if (log && !findString("index", obtainPointAtts))
	{
	  warnAtt("index", "obtainPoint", a_obtainPoint);
	  check_intVal(a_obtainPoint->get_index(), 0);
	}
      else
	check_intVal(a_obtainPoint->get_index(), log);
    }
}

/********************************************************************/

void check_obtainRealLabel(
 obtainRealLabel * a_obtainRealLabel,
 int log)
{
  if (a_obtainRealLabel->get_realVar())
    {
      adjustLevels(&obtainRealLabelAtts_a_realVar,
		   "obtainRealLabel a_realVar");
      if (log && !findString("a_realVar", obtainRealLabelAtts))
	{
	  warnAtt("a_realVar", "obtainRealLabel", a_obtainRealLabel);
	  check_realVar(a_obtainRealLabel->get_realVar(), 0);
	}
      else
	check_realVar(a_obtainRealLabel->get_realVar(), log);
    }
  if (a_obtainRealLabel->get_obtainLabeled())
    {
      adjustLevels(&obtainRealLabelAtts_a_obtainLabeled,
		   "obtainRealLabel a_obtainLabeled");
      if (log && !findString("a_obtainLabeled", obtainRealLabelAtts))
	{
	  warnAtt("a_obtainLabeled", "obtainRealLabel", a_obtainRealLabel);
	  check_obtainLabeled(a_obtainRealLabel->get_obtainLabeled(), 0);
	}
      else
	check_obtainLabeled(a_obtainRealLabel->get_obtainLabeled(), log);
    }
}

/********************************************************************/

void check_obtainRealPoint(
 obtainRealPoint * a_obtainRealPoint,
 int log)
{
  if (a_obtainRealPoint->get_realVar())
    {
      adjustLevels(&obtainRealPointAtts_a_realVar,
		   "obtainRealPoint a_realVar");
      if (log && !findString("a_realVar", obtainRealPointAtts))
	{
	  warnAtt("a_realVar", "obtainRealPoint", a_obtainRealPoint);
	  check_realVar(a_obtainRealPoint->get_realVar(), 0);
	}
      else
	check_realVar(a_obtainRealPoint->get_realVar(), log);
    }
  if (a_obtainRealPoint->get_obtainPoint())
    {
      adjustLevels(&obtainRealPointAtts_a_obtainPoint,
		   "obtainRealPoint a_obtainPoint");
      if (log && !findString("a_obtainPoint", obtainRealPointAtts))
	{
	  warnAtt("a_obtainPoint", "obtainRealPoint", a_obtainRealPoint);
	  check_obtainPoint(a_obtainRealPoint->get_obtainPoint(), 0);
	}
      else
	check_obtainPoint(a_obtainRealPoint->get_obtainPoint(), log);
    }
}

/********************************************************************/

void check_obtainStm(
 obtainStm * a_obtainStm,
 int log)
{
  if (isA(a_obtainStm, obtainBool))
    {
      adjustLevels(&obtainStmSubs_obtainBool, "obtainBool");
      if (log && !findString("obtainBool", obtainStmSubs))
	{
	  warnSub("obtainBool", "obtainStm", a_obtainStm);
	  check_obtainBool(dynamic_cast<obtainBool *>(a_obtainStm), 0);
	}
      else
	check_obtainBool(dynamic_cast<obtainBool *>(a_obtainStm), log);
      return;
    }
  if (isA(a_obtainStm, obtainString))
    {
      adjustLevels(&obtainStmSubs_obtainString, "obtainString");
      if (log && !findString("obtainString", obtainStmSubs))
	{
	  warnSub("obtainString", "obtainStm", a_obtainStm);
	  check_obtainString(dynamic_cast<obtainString *>(a_obtainStm), 0);
	}
      else
	check_obtainString(dynamic_cast<obtainString *>(a_obtainStm), log);
      return;
    }
  if (isA(a_obtainStm, obtainInt))
    {
      adjustLevels(&obtainStmSubs_obtainInt, "obtainInt");
      if (log && !findString("obtainInt", obtainStmSubs))
	{
	  warnSub("obtainInt", "obtainStm", a_obtainStm);
	  check_obtainInt(dynamic_cast<obtainInt *>(a_obtainStm), 0);
	}
      else
	check_obtainInt(dynamic_cast<obtainInt *>(a_obtainStm), log);
      return;
    }
  if (isA(a_obtainStm, obtainRealLabel))
    {
      adjustLevels(&obtainStmSubs_obtainRealLabel, "obtainRealLabel");
      if (log && !findString("obtainRealLabel", obtainStmSubs))
	{
	  warnSub("obtainRealLabel", "obtainStm", a_obtainStm);
	  check_obtainRealLabel(
	    dynamic_cast<obtainRealLabel *>(a_obtainStm), 0);
	}
      else
	check_obtainRealLabel(
	  dynamic_cast<obtainRealLabel *>(a_obtainStm), log);
      return;
    }
  if (isA(a_obtainStm, obtainRealPoint))
    {
      adjustLevels(&obtainStmSubs_obtainRealPoint, "obtainRealPoint");
      if (log && !findString("obtainRealPoint", obtainStmSubs))
	{
	  warnSub("obtainRealPoint", "obtainStm", a_obtainStm);
	  check_obtainRealPoint(
	    dynamic_cast<obtainRealPoint *>(a_obtainStm), 0);
	}
      else
	check_obtainRealPoint(
	  dynamic_cast<obtainRealPoint *>(a_obtainStm), log);
      return;
    }
}

/********************************************************************/

void check_obtainString(
 obtainString * a_obtainString,
 int log)
{
  if (a_obtainString->get_stringVar())
    {
      adjustLevels(&obtainStringAtts_a_stringVar, "obtainString a_stringVar");
      if (log && !findString("a_stringVar", obtainStringAtts))
	{
	  warnAtt("a_stringVar", "obtainString", a_obtainString);
	  check_stringVar(a_obtainString->get_stringVar(), 0);
	}
      else
	check_stringVar(a_obtainString->get_stringVar(), log);
    }
  if (a_obtainString->get_obtainLabeled())
    {
      adjustLevels(&obtainStringAtts_a_obtainLabeled,
		   "obtainString a_obtainLabeled");
      if (log && !findString("a_obtainLabeled", obtainStringAtts))
	{
	  warnAtt("a_obtainLabeled", "obtainString", a_obtainString);
	  check_obtainLabeled(a_obtainString->get_obtainLabeled(), 0);
	}
      else
	check_obtainLabeled(a_obtainString->get_obtainLabeled(), log);
    }
}

/********************************************************************/

void check_offsetConst(
 offsetConst * a_offsetConst,
 int log)
{
  if (a_offsetConst->get_featureList())
    {
      std::list<featureLabel *> * theList;
      std::list<featureLabel *>::iterator iter;
      theList = a_offsetConst->get_featureList();
      adjustLevels(&offsetConstAtts_a_featureList,
		   "offsetConst a_featureList");
      if (log && !findString("a_featureList", offsetConstAtts))
	{
	  warnAtt("a_featureList", "offsetConst", a_offsetConst);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_featureLabel(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_featureLabel(*iter, log);
	}
    }
}

/********************************************************************/

void check_opLabel(
 opLabel * a_opLabel,
 int log)
{
  if (a_opLabel->get_labelName())
    {
      adjustLevels(&opLabelAtts_a_labelName, "opLabel a_labelName");
      if (log && !findString("a_labelName", opLabelAtts))
	{
	  warnAtt("a_labelName", "opLabel", a_opLabel);
	  check_labelName(a_opLabel->get_labelName(), 0);
	}
      else
	check_labelName(a_opLabel->get_labelName(), log);
    }
}

/********************************************************************/

void check_openCadfile(
 openCadfile * a_openCadfile,
 int log)
{
  if (a_openCadfile->get_cadfileType())
    {
      adjustLevels(&openCadfileAtts_a_cadfileType,
		   "openCadfile a_cadfileType");
      if (log && !findString("a_cadfileType", openCadfileAtts))
	{
	  warnAtt("a_cadfileType", "openCadfile", a_openCadfile);
	  check_cadfileType(a_openCadfile->get_cadfileType(), 0);
	}
      else
	check_cadfileType(a_openCadfile->get_cadfileType(), log);
    }
}

/********************************************************************/

void check_openDMLfile(
 openDMLfile * a_openDMLfile,
 int log)
{
  if (isA(a_openDMLfile, openDmlInput))
    {
      adjustLevels(&openDMLfileSubs_openDmlInput, "openDmlInput");
      if (log && !findString("openDmlInput", openDMLfileSubs))
	{
	  warnSub("openDmlInput", "openDMLfile", a_openDMLfile);
	  check_openDmlInput(
	    dynamic_cast<openDmlInput *>(a_openDMLfile), 0);
	}
      else
	check_openDmlInput(
	  dynamic_cast<openDmlInput *>(a_openDMLfile), log);
      return;
    }
  if (isA(a_openDMLfile, openDmlOutput))
    {
      adjustLevels(&openDMLfileSubs_openDmlOutput, "openDmlOutput");
      if (log && !findString("openDmlOutput", openDMLfileSubs))
	{
	  warnSub("openDmlOutput", "openDMLfile", a_openDMLfile);
	  check_openDmlOutput(
	    dynamic_cast<openDmlOutput *>(a_openDMLfile), 0);
	}
      else
	check_openDmlOutput(
	  dynamic_cast<openDmlOutput *>(a_openDMLfile), log);
      return;
    }
}

/********************************************************************/

void check_openDevice(
 openDevice * a_openDevice,
 int log)
{
  if (isA(a_openDevice, openDevice_inputAccess))
    {
      adjustLevels(&openDeviceSubs_openDevice_inputAccess,
		   "openDevice_inputAccess");
      if (log && !findString("openDevice_inputAccess", openDeviceSubs))
	{
	  warnSub("openDevice_inputAccess", "openDevice", a_openDevice);
	  check_openDevice_inputAccess(
	    dynamic_cast<openDevice_inputAccess *>(a_openDevice), 0);
	}
      else
	check_openDevice_inputAccess(
	  dynamic_cast<openDevice_inputAccess *>(a_openDevice), log);
      return;
    }
  if (isA(a_openDevice, openDevice_outputAccess))
    {
      adjustLevels(&openDeviceSubs_openDevice_outputAccess,
		   "openDevice_outputAccess");
      if (log && !findString("openDevice_outputAccess", openDeviceSubs))
	{
	  warnSub("openDevice_outputAccess", "openDevice", a_openDevice);
	  check_openDevice_outputAccess(
	    dynamic_cast<openDevice_outputAccess *>(a_openDevice), 0);
	}
      else
	check_openDevice_outputAccess(
	  dynamic_cast<openDevice_outputAccess *>(a_openDevice), log);
      return;
    }
}

/********************************************************************/

void check_openDevice_inputAccess(
 openDevice_inputAccess * a_openDevice_inputAccess,
 int log)
{
  if (a_openDevice_inputAccess->get_inputAccess())
    {
      adjustLevels(&openDevice_inputAccessAtts_a_inputAccess,
		   "openDevice_inputAccess a_inputAccess");
      if (log && !findString("a_inputAccess", openDevice_inputAccessAtts))
	{
	  warnAtt("a_inputAccess", "openDevice_inputAccess",
		  a_openDevice_inputAccess);
	}
    }
}

/********************************************************************/

void check_openDevice_outputAccess(
 openDevice_outputAccess * a_openDevice_outputAccess,
 int log)
{
  if (a_openDevice_outputAccess->get_outputAccess())
    {
      adjustLevels(&openDevice_outputAccessAtts_a_outputAccess,
		   "openDevice_outputAccess a_outputAccess");
      if (log && !findString("a_outputAccess", openDevice_outputAccessAtts))
	{
	  warnAtt("a_outputAccess", "openDevice_outputAccess",
		  a_openDevice_outputAccess);
	  check_outputAccess(a_openDevice_outputAccess->get_outputAccess(), 0);
	}
      else
	check_outputAccess(a_openDevice_outputAccess->get_outputAccess(), log);
    }
}

/********************************************************************/

void check_openDmlInput(
 openDmlInput * a_openDmlInput,
 int log)
{
  if (a_openDmlInput->get_version())
    {
      adjustLevels(&openDmlInputAtts_version, "openDmlInput version");
      if (log && !findString("version", openDmlInputAtts))
	{
	  warnAtt("version", "openDmlInput", a_openDmlInput);
	  check_stringVal(a_openDmlInput->get_version(), 0);
	}
      else
	check_stringVal(a_openDmlInput->get_version(), log);
    }
}

/********************************************************************/

void check_openDmlOutput(
 openDmlOutput * a_openDmlOutput,
 int log)
{
  if (a_openDmlOutput->get_version())
    {
      adjustLevels(&openDmlOutputAtts_version, "openDmlOutput version");
      if (log && !findString("version", openDmlOutputAtts))
	{
	  warnAtt("version", "openDmlOutput", a_openDmlOutput);
	  check_stringVal(a_openDmlOutput->get_version(), 0);
	}
      else
	check_stringVal(a_openDmlOutput->get_version(), log);
    }
  if (a_openDmlOutput->get_state())
    {
      adjustLevels(&openDmlOutputAtts_a_state, "openDmlOutput a_state");
      if (log && !findString("a_state", openDmlOutputAtts))
	{
	  warnAtt("a_state", "openDmlOutput", a_openDmlOutput);
	  check_state(a_openDmlOutput->get_state(), 0);
	}
      else
	check_state(a_openDmlOutput->get_state(), log);
    }
}

/********************************************************************/

void check_openFdata(
 openFdata * a_openFdata,
 int log)
{
  if (isA(a_openFdata, openFdata_vLabel))
    {
      adjustLevels(&openFdataSubs_openFdata_vLabel, "openFdata_vLabel");
      if (log && !findString("openFdata_vLabel", openFdataSubs))
	{
	  warnSub("openFdata_vLabel", "openFdata", a_openFdata);
	  check_openFdata_vLabel(
	    dynamic_cast<openFdata_vLabel *>(a_openFdata), 0);
	}
      else
	check_openFdata_vLabel(
	  dynamic_cast<openFdata_vLabel *>(a_openFdata), log);
      return;
    }
  if (isA(a_openFdata, openFdata_DMIS))
    {
      adjustLevels(&openFdataSubs_openFdata_DMIS, "openFdata_DMIS");
      if (log && !findString("openFdata_DMIS", openFdataSubs))
	{
	  warnSub("openFdata_DMIS", "openFdata", a_openFdata);
	  check_openFdata_DMIS(
	    dynamic_cast<openFdata_DMIS *>(a_openFdata), 0);
	}
      else
	check_openFdata_DMIS(
	  dynamic_cast<openFdata_DMIS *>(a_openFdata), log);
      return;
    }
}

/********************************************************************/

void check_openFdata_DMIS(
 openFdata_DMIS * a_openFdata_DMIS,
 int log)
{
  if (a_openFdata_DMIS->get_outputAccess())
    {
      adjustLevels(&openFdata_DMISAtts_a_outputAccess,
		   "openFdata_DMIS a_outputAccess");
      if (log && !findString("a_outputAccess", openFdata_DMISAtts))
	{
	  warnAtt("a_outputAccess", "openFdata_DMIS", a_openFdata_DMIS);
	  check_outputAccess(a_openFdata_DMIS->get_outputAccess(), 0);
	}
      else
	check_outputAccess(a_openFdata_DMIS->get_outputAccess(), log);
    }
}

/********************************************************************/

void check_openFdata_vLabel(
 openFdata_vLabel * a_openFdata_vLabel,
 int log)
{
  if (a_openFdata_vLabel->get_vLabel())
    {
      adjustLevels(&openFdata_vLabelAtts_a_vLabel,
		   "openFdata_vLabel a_vLabel");
      if (log && !findString("a_vLabel", openFdata_vLabelAtts))
	{
	  warnAtt("a_vLabel", "openFdata_vLabel", a_openFdata_vLabel);
	  check_vLabel(a_openFdata_vLabel->get_vLabel(), 0);
	}
      else
	check_vLabel(a_openFdata_vLabel->get_vLabel(), log);
    }
  if (a_openFdata_vLabel->get_outputAccess())
    {
      adjustLevels(&openFdata_vLabelAtts_a_outputAccess,
		   "openFdata_vLabel a_outputAccess");
      if (log && !findString("a_outputAccess", openFdata_vLabelAtts))
	{
	  warnAtt("a_outputAccess", "openFdata_vLabel", a_openFdata_vLabel);
	  check_outputAccess(a_openFdata_vLabel->get_outputAccess(), 0);
	}
      else
	check_outputAccess(a_openFdata_vLabel->get_outputAccess(), log);
    }
}

/********************************************************************/

void check_openMinor(
 openMinor * a_openMinor,
 int log)
{
  if (isA(a_openMinor, openMinor_openDevice))
    {
      adjustLevels(&openMinorSubs_openMinor_openDevice,
		   "openMinor_openDevice");
      if (log && !findString("openMinor_openDevice", openMinorSubs))
	{
	  warnSub("openMinor_openDevice", "openMinor", a_openMinor);
	  check_openMinor_openDevice(
	    dynamic_cast<openMinor_openDevice *>(a_openMinor), 0);
	}
      else
	check_openMinor_openDevice(
	  dynamic_cast<openMinor_openDevice *>(a_openMinor), log);
      return;
    }
  if (isA(a_openMinor, openMinor_openFdata))
    {
      adjustLevels(&openMinorSubs_openMinor_openFdata, "openMinor_openFdata");
      if (log && !findString("openMinor_openFdata", openMinorSubs))
	{
	  warnSub("openMinor_openFdata", "openMinor", a_openMinor);
	  check_openMinor_openFdata(
	    dynamic_cast<openMinor_openFdata *>(a_openMinor), 0);
	}
      else
	check_openMinor_openFdata(
	  dynamic_cast<openMinor_openFdata *>(a_openMinor), log);
      return;
    }
  if (isA(a_openMinor, openMinor_openCadfile))
    {
      adjustLevels(&openMinorSubs_openMinor_openCadfile,
		   "openMinor_openCadfile");
      if (log && !findString("openMinor_openCadfile", openMinorSubs))
	{
	  warnSub("openMinor_openCadfile", "openMinor", a_openMinor);
	  check_openMinor_openCadfile(
	    dynamic_cast<openMinor_openCadfile *>(a_openMinor), 0);
	}
      else
	check_openMinor_openCadfile(
	  dynamic_cast<openMinor_openCadfile *>(a_openMinor), log);
      return;
    }
  if (isA(a_openMinor, openMinor_storageSpecList))
    {
      adjustLevels(&openMinorSubs_openMinor_storageSpecList,
		   "openMinor_storageSpecList");
      if (log && !findString("openMinor_storageSpecList", openMinorSubs))
	{
	  warnSub("openMinor_storageSpecList", "openMinor", a_openMinor);
	  check_openMinor_storageSpecList(
	    dynamic_cast<openMinor_storageSpecList *>(a_openMinor), 0);
	}
      else
	check_openMinor_storageSpecList(
	  dynamic_cast<openMinor_storageSpecList *>(a_openMinor), log);
      return;
    }
  if (isA(a_openMinor, openMinor_openDMLfile))
    {
      adjustLevels(&openMinorSubs_openMinor_openDMLfile,
		   "openMinor_openDMLfile");
      if (log && !findString("openMinor_openDMLfile", openMinorSubs))
	{
	  warnSub("openMinor_openDMLfile", "openMinor", a_openMinor);
	  check_openMinor_openDMLfile(
	    dynamic_cast<openMinor_openDMLfile *>(a_openMinor), 0);
	}
      else
	check_openMinor_openDMLfile(
	  dynamic_cast<openMinor_openDMLfile *>(a_openMinor), log);
      return;
    }
}

/********************************************************************/

void check_openMinor_openCadfile(
 openMinor_openCadfile * a_openMinor_openCadfile,
 int log)
{
  if (a_openMinor_openCadfile->get_didLabel())
    {
      adjustLevels(&openMinor_openCadfileAtts_a_didLabel,
		   "openMinor_openCadfile a_didLabel");
      if (log && !findString("a_didLabel", openMinor_openCadfileAtts))
	{
	  warnAtt("a_didLabel", "openMinor_openCadfile",
		  a_openMinor_openCadfile);
	  check_didLabel(a_openMinor_openCadfile->get_didLabel(), 0);
	}
      else
	check_didLabel(a_openMinor_openCadfile->get_didLabel(), log);
    }
  if (a_openMinor_openCadfile->get_openCadfile())
    {
      adjustLevels(&openMinor_openCadfileAtts_a_openCadfile,
		   "openMinor_openCadfile a_openCadfile");
      if (log && !findString("a_openCadfile", openMinor_openCadfileAtts))
	{
	  warnAtt("a_openCadfile", "openMinor_openCadfile",
		  a_openMinor_openCadfile);
	  check_openCadfile(a_openMinor_openCadfile->get_openCadfile(), 0);
	}
      else
	check_openCadfile(a_openMinor_openCadfile->get_openCadfile(), log);
    }
}

/********************************************************************/

void check_openMinor_openDMLfile(
 openMinor_openDMLfile * a_openMinor_openDMLfile,
 int log)
{
  if (a_openMinor_openDMLfile->get_didLabel())
    {
      adjustLevels(&openMinor_openDMLfileAtts_a_didLabel,
		   "openMinor_openDMLfile a_didLabel");
      if (log && !findString("a_didLabel", openMinor_openDMLfileAtts))
	{
	  warnAtt("a_didLabel", "openMinor_openDMLfile",
		  a_openMinor_openDMLfile);
	  check_didLabel(a_openMinor_openDMLfile->get_didLabel(), 0);
	}
      else
	check_didLabel(a_openMinor_openDMLfile->get_didLabel(), log);
    }
  if (a_openMinor_openDMLfile->get_openDMLfile())
    {
      adjustLevels(&openMinor_openDMLfileAtts_a_openDMLfile,
		   "openMinor_openDMLfile a_openDMLfile");
      if (log && !findString("a_openDMLfile", openMinor_openDMLfileAtts))
	{
	  warnAtt("a_openDMLfile", "openMinor_openDMLfile",
		  a_openMinor_openDMLfile);
	  check_openDMLfile(a_openMinor_openDMLfile->get_openDMLfile(), 0);
	}
      else
	check_openDMLfile(a_openMinor_openDMLfile->get_openDMLfile(), log);
    }
}

/********************************************************************/

void check_openMinor_openDevice(
 openMinor_openDevice * a_openMinor_openDevice,
 int log)
{
  if (a_openMinor_openDevice->get_didLabel())
    {
      adjustLevels(&openMinor_openDeviceAtts_a_didLabel,
		   "openMinor_openDevice a_didLabel");
      if (log && !findString("a_didLabel", openMinor_openDeviceAtts))
	{
	  warnAtt("a_didLabel", "openMinor_openDevice",
		  a_openMinor_openDevice);
	  check_didLabel(a_openMinor_openDevice->get_didLabel(), 0);
	}
      else
	check_didLabel(a_openMinor_openDevice->get_didLabel(), log);
    }
  if (a_openMinor_openDevice->get_openDevice())
    {
      adjustLevels(&openMinor_openDeviceAtts_a_openDevice,
		   "openMinor_openDevice a_openDevice");
      if (log && !findString("a_openDevice", openMinor_openDeviceAtts))
	{
	  warnAtt("a_openDevice", "openMinor_openDevice",
		  a_openMinor_openDevice);
	  check_openDevice(a_openMinor_openDevice->get_openDevice(), 0);
	}
      else
	check_openDevice(a_openMinor_openDevice->get_openDevice(), log);
    }
}

/********************************************************************/

void check_openMinor_openFdata(
 openMinor_openFdata * a_openMinor_openFdata,
 int log)
{
  if (a_openMinor_openFdata->get_didLabel())
    {
      adjustLevels(&openMinor_openFdataAtts_a_didLabel,
		   "openMinor_openFdata a_didLabel");
      if (log && !findString("a_didLabel", openMinor_openFdataAtts))
	{
	  warnAtt("a_didLabel", "openMinor_openFdata", a_openMinor_openFdata);
	  check_didLabel(a_openMinor_openFdata->get_didLabel(), 0);
	}
      else
	check_didLabel(a_openMinor_openFdata->get_didLabel(), log);
    }
  if (a_openMinor_openFdata->get_openFdata())
    {
      adjustLevels(&openMinor_openFdataAtts_a_openFdata,
		   "openMinor_openFdata a_openFdata");
      if (log && !findString("a_openFdata", openMinor_openFdataAtts))
	{
	  warnAtt("a_openFdata", "openMinor_openFdata",
		  a_openMinor_openFdata);
	  check_openFdata(a_openMinor_openFdata->get_openFdata(), 0);
	}
      else
	check_openFdata(a_openMinor_openFdata->get_openFdata(), log);
    }
}

/********************************************************************/

void check_openMinor_storageSpecList(
 openMinor_storageSpecList * a_openMinor_storageSpecList,
 int log)
{
  if (a_openMinor_storageSpecList->get_didLabel())
    {
      adjustLevels(&openMinor_storageSpecListAtts_a_didLabel,
		   "openMinor_storageSpecList a_didLabel");
      if (log && !findString("a_didLabel", openMinor_storageSpecListAtts))
	{
	  warnAtt("a_didLabel", "openMinor_storageSpecList",
		  a_openMinor_storageSpecList);
	  check_didLabel(a_openMinor_storageSpecList->get_didLabel(), 0);
	}
      else
	check_didLabel(a_openMinor_storageSpecList->get_didLabel(), log);
    }
  if (a_openMinor_storageSpecList->get_storageSpecList())
    {
      std::list<storageSpec *> * theList;
      std::list<storageSpec *>::iterator iter;
      theList = a_openMinor_storageSpecList->get_storageSpecList();
      adjustLevels(&openMinor_storageSpecListAtts_a_storageSpecList,
		   "openMinor_storageSpecList a_storageSpecList");
      if (log && !findString("a_storageSpecList",
			     openMinor_storageSpecListAtts))
	{
	  warnAtt("a_storageSpecList", "openMinor_storageSpecList",
		  a_openMinor_storageSpecList);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_storageSpec(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_storageSpec(*iter, log);
	}
    }
}

/********************************************************************/

void check_openStm(
 openStm * a_openStm,
 int log)
{
  if (a_openStm->get_openMinor())
    {
      adjustLevels(&openStmAtts_a_openMinor, "openStm a_openMinor");
      if (log && !findString("a_openMinor", openStmAtts))
	{
	  warnAtt("a_openMinor", "openStm", a_openStm);
	  check_openMinor(a_openStm->get_openMinor(), 0);
	}
      else
	check_openMinor(a_openStm->get_openMinor(), log);
    }
}

/********************************************************************/

void check_operidStm(
 operidStm * a_operidStm,
 int log)
{
  if (a_operidStm->get_opLabel())
    {
      adjustLevels(&operidStmAtts_a_opLabel, "operidStm a_opLabel");
      if (log && !findString("a_opLabel", operidStmAtts))
	{
	  warnAtt("a_opLabel", "operidStm", a_operidStm);
	  check_opLabel(a_operidStm->get_opLabel(), 0);
	}
      else
	check_opLabel(a_operidStm->get_opLabel(), log);
    }
  if (a_operidStm->get_text())
    {
      adjustLevels(&operidStmAtts_text, "operidStm text");
      if (log && !findString("text", operidStmAtts))
	{
	  warnAtt("text", "operidStm", a_operidStm);
	  check_stringVal(a_operidStm->get_text(), 0);
	}
      else
	check_stringVal(a_operidStm->get_text(), log);
    }
}

/********************************************************************/

void check_orig(
 orig * a_orig,
 int log)
{
  if (isA(a_orig, orig_XORIG))
    {
      adjustLevels(&origSubs_orig_XORIG, "orig_XORIG");
      if (log && !findString("orig_XORIG", origSubs))
	{
	  warnSub("orig_XORIG", "orig", a_orig);
	}
      return;
    }
  if (isA(a_orig, orig_YORIG))
    {
      adjustLevels(&origSubs_orig_YORIG, "orig_YORIG");
      if (log && !findString("orig_YORIG", origSubs))
	{
	  warnSub("orig_YORIG", "orig", a_orig);
	}
      return;
    }
  if (isA(a_orig, orig_ZORIG))
    {
      adjustLevels(&origSubs_orig_ZORIG, "orig_ZORIG");
      if (log && !findString("orig_ZORIG", origSubs))
	{
	  warnSub("orig_ZORIG", "orig", a_orig);
	}
      return;
    }
}

/********************************************************************/

void check_outputAccess(
 outputAccess * a_outputAccess,
 int log)
{
  if (isA(a_outputAccess, outputAccessUnspec))
    {
      adjustLevels(&outputAccessSubs_outputAccessUnspec, "outputAccessUnspec");
      if (log && !findString("outputAccessUnspec", outputAccessSubs))
	{
	  warnSub("outputAccessUnspec", "outputAccess", a_outputAccess);
	}
      return;
    }
  if (isA(a_outputAccess, outputAccessAppend))
    {
      adjustLevels(&outputAccessSubs_outputAccessAppend, "outputAccessAppend");
      if (log && !findString("outputAccessAppend", outputAccessSubs))
	{
	  warnSub("outputAccessAppend", "outputAccess", a_outputAccess);
	}
      return;
    }
  if (isA(a_outputAccess, outputAccessOverwr))
    {
      adjustLevels(&outputAccessSubs_outputAccessOverwr, "outputAccessOverwr");
      if (log && !findString("outputAccessOverwr", outputAccessSubs))
	{
	  warnSub("outputAccessOverwr", "outputAccess", a_outputAccess);
	}
      return;
    }
}

/********************************************************************/

void check_outputConstBothData(
 outputConstBothData * a_outputConstBothData,
 int log)
{
  if (a_outputConstBothData->get_stLabel())
    {
      adjustLevels(&outputConstBothDataAtts_a_stLabel,
		   "outputConstBothData a_stLabel");
      if (log && !findString("a_stLabel", outputConstBothDataAtts))
	{
	  warnAtt("a_stLabel", "outputConstBothData", a_outputConstBothData);
	  check_stLabel(a_outputConstBothData->get_stLabel(), 0);
	}
      else
	check_stLabel(a_outputConstBothData->get_stLabel(), log);
    }
  if (a_outputConstBothData->get_seLabel())
    {
      adjustLevels(&outputConstBothDataAtts_a_seLabel,
		   "outputConstBothData a_seLabel");
      if (log && !findString("a_seLabel", outputConstBothDataAtts))
	{
	  warnAtt("a_seLabel", "outputConstBothData", a_outputConstBothData);
	  check_seLabel(a_outputConstBothData->get_seLabel(), 0);
	}
      else
	check_seLabel(a_outputConstBothData->get_seLabel(), log);
    }
  if (a_outputConstBothData->get_toleranceLabel())
    {
      adjustLevels(&outputConstBothDataAtts_a_toleranceLabel,
		   "outputConstBothData a_toleranceLabel");
      if (log && !findString("a_toleranceLabel", outputConstBothDataAtts))
	{
	  warnAtt("a_toleranceLabel", "outputConstBothData",
		  a_outputConstBothData);
	  check_toleranceLabel(a_outputConstBothData->get_toleranceLabel(), 0);
	}
      else
	check_toleranceLabel(a_outputConstBothData->get_toleranceLabel(), log);
    }
}

/********************************************************************/

void check_outputConstData(
 outputConstData * a_outputConstData,
 int log)
{
  if (isA(a_outputConstData, outputConstGaugeData))
    {
      adjustLevels(&outputConstDataSubs_outputConstGaugeData,
		   "outputConstGaugeData");
      if (log && !findString("outputConstGaugeData", outputConstDataSubs))
	{
	  warnSub("outputConstGaugeData", "outputConstData", a_outputConstData);
	  check_outputConstGaugeData(
	    dynamic_cast<outputConstGaugeData *>(a_outputConstData), 0);
	}
      else
	check_outputConstGaugeData(
	  dynamic_cast<outputConstGaugeData *>(a_outputConstData), log);
      return;
    }
  if (isA(a_outputConstData, outputConstPartData))
    {
      adjustLevels(&outputConstDataSubs_outputConstPartData,
		   "outputConstPartData");
      if (log && !findString("outputConstPartData", outputConstDataSubs))
	{
	  warnSub("outputConstPartData", "outputConstData", a_outputConstData);
	  check_outputConstPartData(
	    dynamic_cast<outputConstPartData *>(a_outputConstData), 0);
	}
      else
	check_outputConstPartData(
	  dynamic_cast<outputConstPartData *>(a_outputConstData), log);
      return;
    }
  if (isA(a_outputConstData, outputConstBothData))
    {
      adjustLevels(&outputConstDataSubs_outputConstBothData,
		   "outputConstBothData");
      if (log && !findString("outputConstBothData", outputConstDataSubs))
	{
	  warnSub("outputConstBothData", "outputConstData", a_outputConstData);
	  check_outputConstBothData(
	    dynamic_cast<outputConstBothData *>(a_outputConstData), 0);
	}
      else
	check_outputConstBothData(
	  dynamic_cast<outputConstBothData *>(a_outputConstData), log);
      return;
    }
}

/********************************************************************/

void check_outputConstGaugeData(
 outputConstGaugeData * a_outputConstGaugeData,
 int log)
{
  if (a_outputConstGaugeData->get_seLabel())
    {
      adjustLevels(&outputConstGaugeDataAtts_a_seLabel,
		   "outputConstGaugeData a_seLabel");
      if (log && !findString("a_seLabel", outputConstGaugeDataAtts))
	{
	  warnAtt("a_seLabel", "outputConstGaugeData",
		  a_outputConstGaugeData);
	  check_seLabel(a_outputConstGaugeData->get_seLabel(), 0);
	}
      else
	check_seLabel(a_outputConstGaugeData->get_seLabel(), log);
    }
}

/********************************************************************/

void check_outputConstPartData(
 outputConstPartData * a_outputConstPartData,
 int log)
{
  if (a_outputConstPartData->get_stLabel())
    {
      adjustLevels(&outputConstPartDataAtts_a_stLabel,
		   "outputConstPartData a_stLabel");
      if (log && !findString("a_stLabel", outputConstPartDataAtts))
	{
	  warnAtt("a_stLabel", "outputConstPartData", a_outputConstPartData);
	  check_stLabel(a_outputConstPartData->get_stLabel(), 0);
	}
      else
	check_stLabel(a_outputConstPartData->get_stLabel(), log);
    }
}

/********************************************************************/

void check_outputDat(
 outputDat * a_outputDat,
 int log)
{
  if (isA(a_outputDat, outputDat_datLabel))
    {
      adjustLevels(&outputDatSubs_outputDat_datLabel, "outputDat_datLabel");
      if (log && !findString("outputDat_datLabel", outputDatSubs))
	{
	  warnSub("outputDat_datLabel", "outputDat", a_outputDat);
	  check_outputDat_datLabel(
	    dynamic_cast<outputDat_datLabel *>(a_outputDat), 0);
	}
      else
	check_outputDat_datLabel(
	  dynamic_cast<outputDat_datLabel *>(a_outputDat), log);
      return;
    }
  if (isA(a_outputDat, outputDat_faLabel))
    {
      adjustLevels(&outputDatSubs_outputDat_faLabel, "outputDat_faLabel");
      if (log && !findString("outputDat_faLabel", outputDatSubs))
	{
	  warnSub("outputDat_faLabel", "outputDat", a_outputDat);
	  check_outputDat_faLabel(
	    dynamic_cast<outputDat_faLabel *>(a_outputDat), 0);
	}
      else
	check_outputDat_faLabel(
	  dynamic_cast<outputDat_faLabel *>(a_outputDat), log);
      return;
    }
}

/********************************************************************/

void check_outputDat_datLabel(
 outputDat_datLabel * a_outputDat_datLabel,
 int log)
{
  if (a_outputDat_datLabel->get_datLabel())
    {
      adjustLevels(&outputDat_datLabelAtts_a_datLabel,
		   "outputDat_datLabel a_datLabel");
      if (log && !findString("a_datLabel", outputDat_datLabelAtts))
	{
	  warnAtt("a_datLabel", "outputDat_datLabel", a_outputDat_datLabel);
	  check_datLabel(a_outputDat_datLabel->get_datLabel(), 0);
	}
      else
	check_datLabel(a_outputDat_datLabel->get_datLabel(), log);
    }
  if (a_outputDat_datLabel->get_faLabel())
    {
      adjustLevels(&outputDat_datLabelAtts_a_faLabel,
		   "outputDat_datLabel a_faLabel");
      if (log && !findString("a_faLabel", outputDat_datLabelAtts))
	{
	  warnAtt("a_faLabel", "outputDat_datLabel", a_outputDat_datLabel);
	  check_faLabel(a_outputDat_datLabel->get_faLabel(), 0);
	}
      else
	check_faLabel(a_outputDat_datLabel->get_faLabel(), log);
    }
  if (a_outputDat_datLabel->get_taLabel())
    {
      adjustLevels(&outputDat_datLabelAtts_a_taLabel,
		   "outputDat_datLabel a_taLabel");
      if (log && !findString("a_taLabel", outputDat_datLabelAtts))
	{
	  warnAtt("a_taLabel", "outputDat_datLabel", a_outputDat_datLabel);
	  check_taLabel(a_outputDat_datLabel->get_taLabel(), 0);
	}
      else
	check_taLabel(a_outputDat_datLabel->get_taLabel(), log);
    }
  if (a_outputDat_datLabel->get_rLabel())
    {
      adjustLevels(&outputDat_datLabelAtts_a_rLabel,
		   "outputDat_datLabel a_rLabel");
      if (log && !findString("a_rLabel", outputDat_datLabelAtts))
	{
	  warnAtt("a_rLabel", "outputDat_datLabel", a_outputDat_datLabel);
	  check_rLabel(a_outputDat_datLabel->get_rLabel(), 0);
	}
      else
	check_rLabel(a_outputDat_datLabel->get_rLabel(), log);
    }
}

/********************************************************************/

void check_outputDat_faLabel(
 outputDat_faLabel * a_outputDat_faLabel,
 int log)
{
  if (a_outputDat_faLabel->get_faLabel())
    {
      adjustLevels(&outputDat_faLabelAtts_a_faLabel,
		   "outputDat_faLabel a_faLabel");
      if (log && !findString("a_faLabel", outputDat_faLabelAtts))
	{
	  warnAtt("a_faLabel", "outputDat_faLabel", a_outputDat_faLabel);
	  check_faLabel(a_outputDat_faLabel->get_faLabel(), 0);
	}
      else
	check_faLabel(a_outputDat_faLabel->get_faLabel(), log);
    }
  if (a_outputDat_faLabel->get_datLabel())
    {
      adjustLevels(&outputDat_faLabelAtts_a_datLabel,
		   "outputDat_faLabel a_datLabel");
      if (log && !findString("a_datLabel", outputDat_faLabelAtts))
	{
	  warnAtt("a_datLabel", "outputDat_faLabel", a_outputDat_faLabel);
	  check_datLabel(a_outputDat_faLabel->get_datLabel(), 0);
	}
      else
	check_datLabel(a_outputDat_faLabel->get_datLabel(), log);
    }
  if (a_outputDat_faLabel->get_taLabel())
    {
      adjustLevels(&outputDat_faLabelAtts_a_taLabel,
		   "outputDat_faLabel a_taLabel");
      if (log && !findString("a_taLabel", outputDat_faLabelAtts))
	{
	  warnAtt("a_taLabel", "outputDat_faLabel", a_outputDat_faLabel);
	  check_taLabel(a_outputDat_faLabel->get_taLabel(), 0);
	}
      else
	check_taLabel(a_outputDat_faLabel->get_taLabel(), log);
    }
  if (a_outputDat_faLabel->get_rLabel())
    {
      adjustLevels(&outputDat_faLabelAtts_a_rLabel,
		   "outputDat_faLabel a_rLabel");
      if (log && !findString("a_rLabel", outputDat_faLabelAtts))
	{
	  warnAtt("a_rLabel", "outputDat_faLabel", a_outputDat_faLabel);
	  check_rLabel(a_outputDat_faLabel->get_rLabel(), 0);
	}
      else
	check_rLabel(a_outputDat_faLabel->get_rLabel(), log);
    }
}

/********************************************************************/

void check_outputFeat(
 outputFeat * a_outputFeat,
 int log)
{
  if (isA(a_outputFeat, outputFeat1F))
    {
      adjustLevels(&outputFeatSubs_outputFeat1F, "outputFeat1F");
      if (log && !findString("outputFeat1F", outputFeatSubs))
	{
	  warnSub("outputFeat1F", "outputFeat", a_outputFeat);
	  check_outputFeat1F(
	    dynamic_cast<outputFeat1F *>(a_outputFeat), 0);
	}
      else
	check_outputFeat1F(
	  dynamic_cast<outputFeat1F *>(a_outputFeat), log);
      return;
    }
  if (isA(a_outputFeat, outputFeat1Fa))
    {
      adjustLevels(&outputFeatSubs_outputFeat1Fa, "outputFeat1Fa");
      if (log && !findString("outputFeat1Fa", outputFeatSubs))
	{
	  warnSub("outputFeat1Fa", "outputFeat", a_outputFeat);
	  check_outputFeat1Fa(
	    dynamic_cast<outputFeat1Fa *>(a_outputFeat), 0);
	}
      else
	check_outputFeat1Fa(
	  dynamic_cast<outputFeat1Fa *>(a_outputFeat), log);
      return;
    }
  if (isA(a_outputFeat, outputFeat2FFaTa))
    {
      adjustLevels(&outputFeatSubs_outputFeat2FFaTa, "outputFeat2FFaTa");
      if (log && !findString("outputFeat2FFaTa", outputFeatSubs))
	{
	  warnSub("outputFeat2FFaTa", "outputFeat", a_outputFeat);
	  check_outputFeat2FFaTa(
	    dynamic_cast<outputFeat2FFaTa *>(a_outputFeat), 0);
	}
      else
	check_outputFeat2FFaTa(
	  dynamic_cast<outputFeat2FFaTa *>(a_outputFeat), log);
      return;
    }
  if (isA(a_outputFeat, outputFeat2FaFaTa))
    {
      adjustLevels(&outputFeatSubs_outputFeat2FaFaTa, "outputFeat2FaFaTa");
      if (log && !findString("outputFeat2FaFaTa", outputFeatSubs))
	{
	  warnSub("outputFeat2FaFaTa", "outputFeat", a_outputFeat);
	  check_outputFeat2FaFaTa(
	    dynamic_cast<outputFeat2FaFaTa *>(a_outputFeat), 0);
	}
      else
	check_outputFeat2FaFaTa(
	  dynamic_cast<outputFeat2FaFaTa *>(a_outputFeat), log);
      return;
    }
  if (isA(a_outputFeat, outputFeat2FFT))
    {
      adjustLevels(&outputFeatSubs_outputFeat2FFT, "outputFeat2FFT");
      if (log && !findString("outputFeat2FFT", outputFeatSubs))
	{
	  warnSub("outputFeat2FFT", "outputFeat", a_outputFeat);
	  check_outputFeat2FFT(
	    dynamic_cast<outputFeat2FFT *>(a_outputFeat), 0);
	}
      else
	check_outputFeat2FFT(
	  dynamic_cast<outputFeat2FFT *>(a_outputFeat), log);
      return;
    }
  if (isA(a_outputFeat, outputFeat2FaFTa))
    {
      adjustLevels(&outputFeatSubs_outputFeat2FaFTa, "outputFeat2FaFTa");
      if (log && !findString("outputFeat2FaFTa", outputFeatSubs))
	{
	  warnSub("outputFeat2FaFTa", "outputFeat", a_outputFeat);
	  check_outputFeat2FaFTa(
	    dynamic_cast<outputFeat2FaFTa *>(a_outputFeat), 0);
	}
      else
	check_outputFeat2FaFTa(
	  dynamic_cast<outputFeat2FaFTa *>(a_outputFeat), log);
      return;
    }
  if (isA(a_outputFeat, outputFeat1FT))
    {
      adjustLevels(&outputFeatSubs_outputFeat1FT, "outputFeat1FT");
      if (log && !findString("outputFeat1FT", outputFeatSubs))
	{
	  warnSub("outputFeat1FT", "outputFeat", a_outputFeat);
	  check_outputFeat1FT(
	    dynamic_cast<outputFeat1FT *>(a_outputFeat), 0);
	}
      else
	check_outputFeat1FT(
	  dynamic_cast<outputFeat1FT *>(a_outputFeat), log);
      return;
    }
  if (isA(a_outputFeat, outputFeat1FaTa))
    {
      adjustLevels(&outputFeatSubs_outputFeat1FaTa, "outputFeat1FaTa");
      if (log && !findString("outputFeat1FaTa", outputFeatSubs))
	{
	  warnSub("outputFeat1FaTa", "outputFeat", a_outputFeat);
	  check_outputFeat1FaTa(
	    dynamic_cast<outputFeat1FaTa *>(a_outputFeat), 0);
	}
      else
	check_outputFeat1FaTa(
	  dynamic_cast<outputFeat1FaTa *>(a_outputFeat), log);
      return;
    }
}

/********************************************************************/

void check_outputFeat1F(
 outputFeat1F * a_outputFeat1F,
 int log)
{
  if (a_outputFeat1F->get_f())
    {
      adjustLevels(&outputFeat1FAtts_f, "outputFeat1F f");
      if (log && !findString("f", outputFeat1FAtts))
	{
	  warnAtt("f", "outputFeat1F", a_outputFeat1F);
	  check_fLabel(a_outputFeat1F->get_f(), 0);
	}
      else
	check_fLabel(a_outputFeat1F->get_f(), log);
    }
  if (a_outputFeat1F->get_pointRange())
    {
      adjustLevels(&outputFeat1FAtts_a_pointRange,
		   "outputFeat1F a_pointRange");
      if (log && !findString("a_pointRange", outputFeat1FAtts))
	{
	  warnAtt("a_pointRange", "outputFeat1F", a_outputFeat1F);
	  check_pointRange(a_outputFeat1F->get_pointRange(), 0);
	}
      else
	check_pointRange(a_outputFeat1F->get_pointRange(), log);
    }
  if (a_outputFeat1F->get_rLabel())
    {
      adjustLevels(&outputFeat1FAtts_a_rLabel, "outputFeat1F a_rLabel");
      if (log && !findString("a_rLabel", outputFeat1FAtts))
	{
	  warnAtt("a_rLabel", "outputFeat1F", a_outputFeat1F);
	  check_rLabel(a_outputFeat1F->get_rLabel(), 0);
	}
      else
	check_rLabel(a_outputFeat1F->get_rLabel(), log);
    }
}

/********************************************************************/

void check_outputFeat1FT(
 outputFeat1FT * a_outputFeat1FT,
 int log)
{
  if (a_outputFeat1FT->get_f())
    {
      adjustLevels(&outputFeat1FTAtts_f, "outputFeat1FT f");
      if (log && !findString("f", outputFeat1FTAtts))
	{
	  warnAtt("f", "outputFeat1FT", a_outputFeat1FT);
	  check_fLabel(a_outputFeat1FT->get_f(), 0);
	}
      else
	check_fLabel(a_outputFeat1FT->get_f(), log);
    }
  if (a_outputFeat1FT->get_pointRange())
    {
      adjustLevels(&outputFeat1FTAtts_a_pointRange,
		   "outputFeat1FT a_pointRange");
      if (log && !findString("a_pointRange", outputFeat1FTAtts))
	{
	  warnAtt("a_pointRange", "outputFeat1FT", a_outputFeat1FT);
	  check_pointRange(a_outputFeat1FT->get_pointRange(), 0);
	}
      else
	check_pointRange(a_outputFeat1FT->get_pointRange(), log);
    }
  if (a_outputFeat1FT->get_tLabelList())
    {
      std::list<tLabel *> * theList;
      std::list<tLabel *>::iterator iter;
      theList = a_outputFeat1FT->get_tLabelList();
      adjustLevels(&outputFeat1FTAtts_a_tLabelList,
		   "outputFeat1FT a_tLabelList");
      if (log && !findString("a_tLabelList", outputFeat1FTAtts))
	{
	  warnAtt("a_tLabelList", "outputFeat1FT", a_outputFeat1FT);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_tLabel(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_tLabel(*iter, log);
	}
    }
  if (a_outputFeat1FT->get_rLabel())
    {
      adjustLevels(&outputFeat1FTAtts_a_rLabel, "outputFeat1FT a_rLabel");
      if (log && !findString("a_rLabel", outputFeat1FTAtts))
	{
	  warnAtt("a_rLabel", "outputFeat1FT", a_outputFeat1FT);
	  check_rLabel(a_outputFeat1FT->get_rLabel(), 0);
	}
      else
	check_rLabel(a_outputFeat1FT->get_rLabel(), log);
    }
}

/********************************************************************/

void check_outputFeat1Fa(
 outputFeat1Fa * a_outputFeat1Fa,
 int log)
{
  if (a_outputFeat1Fa->get_fa())
    {
      adjustLevels(&outputFeat1FaAtts_fa, "outputFeat1Fa fa");
      if (log && !findString("fa", outputFeat1FaAtts))
	{
	  warnAtt("fa", "outputFeat1Fa", a_outputFeat1Fa);
	  check_faLabel(a_outputFeat1Fa->get_fa(), 0);
	}
      else
	check_faLabel(a_outputFeat1Fa->get_fa(), log);
    }
  if (a_outputFeat1Fa->get_pointRange())
    {
      adjustLevels(&outputFeat1FaAtts_a_pointRange,
		   "outputFeat1Fa a_pointRange");
      if (log && !findString("a_pointRange", outputFeat1FaAtts))
	{
	  warnAtt("a_pointRange", "outputFeat1Fa", a_outputFeat1Fa);
	  check_pointRange(a_outputFeat1Fa->get_pointRange(), 0);
	}
      else
	check_pointRange(a_outputFeat1Fa->get_pointRange(), log);
    }
  if (a_outputFeat1Fa->get_rLabel())
    {
      adjustLevels(&outputFeat1FaAtts_a_rLabel, "outputFeat1Fa a_rLabel");
      if (log && !findString("a_rLabel", outputFeat1FaAtts))
	{
	  warnAtt("a_rLabel", "outputFeat1Fa", a_outputFeat1Fa);
	  check_rLabel(a_outputFeat1Fa->get_rLabel(), 0);
	}
      else
	check_rLabel(a_outputFeat1Fa->get_rLabel(), log);
    }
}

/********************************************************************/

void check_outputFeat1FaTa(
 outputFeat1FaTa * a_outputFeat1FaTa,
 int log)
{
  if (a_outputFeat1FaTa->get_fa())
    {
      adjustLevels(&outputFeat1FaTaAtts_fa, "outputFeat1FaTa fa");
      if (log && !findString("fa", outputFeat1FaTaAtts))
	{
	  warnAtt("fa", "outputFeat1FaTa", a_outputFeat1FaTa);
	  check_faLabel(a_outputFeat1FaTa->get_fa(), 0);
	}
      else
	check_faLabel(a_outputFeat1FaTa->get_fa(), log);
    }
  if (a_outputFeat1FaTa->get_pointRange())
    {
      adjustLevels(&outputFeat1FaTaAtts_a_pointRange,
		   "outputFeat1FaTa a_pointRange");
      if (log && !findString("a_pointRange", outputFeat1FaTaAtts))
	{
	  warnAtt("a_pointRange", "outputFeat1FaTa", a_outputFeat1FaTa);
	  check_pointRange(a_outputFeat1FaTa->get_pointRange(), 0);
	}
      else
	check_pointRange(a_outputFeat1FaTa->get_pointRange(), log);
    }
  if (a_outputFeat1FaTa->get_taLabelList())
    {
      std::list<taLabel *> * theList;
      std::list<taLabel *>::iterator iter;
      theList = a_outputFeat1FaTa->get_taLabelList();
      adjustLevels(&outputFeat1FaTaAtts_a_taLabelList,
		   "outputFeat1FaTa a_taLabelList");
      if (log && !findString("a_taLabelList", outputFeat1FaTaAtts))
	{
	  warnAtt("a_taLabelList", "outputFeat1FaTa", a_outputFeat1FaTa);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_taLabel(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_taLabel(*iter, log);
	}
    }
  if (a_outputFeat1FaTa->get_rLabel())
    {
      adjustLevels(&outputFeat1FaTaAtts_a_rLabel, "outputFeat1FaTa a_rLabel");
      if (log && !findString("a_rLabel", outputFeat1FaTaAtts))
	{
	  warnAtt("a_rLabel", "outputFeat1FaTa", a_outputFeat1FaTa);
	  check_rLabel(a_outputFeat1FaTa->get_rLabel(), 0);
	}
      else
	check_rLabel(a_outputFeat1FaTa->get_rLabel(), log);
    }
}

/********************************************************************/

void check_outputFeat2FFT(
 outputFeat2FFT * a_outputFeat2FFT,
 int log)
{
  if (a_outputFeat2FFT->get_f1())
    {
      adjustLevels(&outputFeat2FFTAtts_f1, "outputFeat2FFT f1");
      if (log && !findString("f1", outputFeat2FFTAtts))
	{
	  warnAtt("f1", "outputFeat2FFT", a_outputFeat2FFT);
	  check_fLabel(a_outputFeat2FFT->get_f1(), 0);
	}
      else
	check_fLabel(a_outputFeat2FFT->get_f1(), log);
    }
  if (a_outputFeat2FFT->get_f2())
    {
      adjustLevels(&outputFeat2FFTAtts_f2, "outputFeat2FFT f2");
      if (log && !findString("f2", outputFeat2FFTAtts))
	{
	  warnAtt("f2", "outputFeat2FFT", a_outputFeat2FFT);
	  check_fLabel(a_outputFeat2FFT->get_f2(), 0);
	}
      else
	check_fLabel(a_outputFeat2FFT->get_f2(), log);
    }
  if (a_outputFeat2FFT->get_t())
    {
      adjustLevels(&outputFeat2FFTAtts_t, "outputFeat2FFT t");
      if (log && !findString("t", outputFeat2FFTAtts))
	{
	  warnAtt("t", "outputFeat2FFT", a_outputFeat2FFT);
	  check_tLabel(a_outputFeat2FFT->get_t(), 0);
	}
      else
	check_tLabel(a_outputFeat2FFT->get_t(), log);
    }
  if (a_outputFeat2FFT->get_rLabel())
    {
      adjustLevels(&outputFeat2FFTAtts_a_rLabel, "outputFeat2FFT a_rLabel");
      if (log && !findString("a_rLabel", outputFeat2FFTAtts))
	{
	  warnAtt("a_rLabel", "outputFeat2FFT", a_outputFeat2FFT);
	  check_rLabel(a_outputFeat2FFT->get_rLabel(), 0);
	}
      else
	check_rLabel(a_outputFeat2FFT->get_rLabel(), log);
    }
}

/********************************************************************/

void check_outputFeat2FFaTa(
 outputFeat2FFaTa * a_outputFeat2FFaTa,
 int log)
{
  if (a_outputFeat2FFaTa->get_f())
    {
      adjustLevels(&outputFeat2FFaTaAtts_f, "outputFeat2FFaTa f");
      if (log && !findString("f", outputFeat2FFaTaAtts))
	{
	  warnAtt("f", "outputFeat2FFaTa", a_outputFeat2FFaTa);
	  check_fLabel(a_outputFeat2FFaTa->get_f(), 0);
	}
      else
	check_fLabel(a_outputFeat2FFaTa->get_f(), log);
    }
  if (a_outputFeat2FFaTa->get_fa())
    {
      adjustLevels(&outputFeat2FFaTaAtts_fa, "outputFeat2FFaTa fa");
      if (log && !findString("fa", outputFeat2FFaTaAtts))
	{
	  warnAtt("fa", "outputFeat2FFaTa", a_outputFeat2FFaTa);
	  check_faLabel(a_outputFeat2FFaTa->get_fa(), 0);
	}
      else
	check_faLabel(a_outputFeat2FFaTa->get_fa(), log);
    }
  if (a_outputFeat2FFaTa->get_ta())
    {
      adjustLevels(&outputFeat2FFaTaAtts_ta, "outputFeat2FFaTa ta");
      if (log && !findString("ta", outputFeat2FFaTaAtts))
	{
	  warnAtt("ta", "outputFeat2FFaTa", a_outputFeat2FFaTa);
	  check_taLabel(a_outputFeat2FFaTa->get_ta(), 0);
	}
      else
	check_taLabel(a_outputFeat2FFaTa->get_ta(), log);
    }
  if (a_outputFeat2FFaTa->get_rLabel())
    {
      adjustLevels(&outputFeat2FFaTaAtts_a_rLabel,
		   "outputFeat2FFaTa a_rLabel");
      if (log && !findString("a_rLabel", outputFeat2FFaTaAtts))
	{
	  warnAtt("a_rLabel", "outputFeat2FFaTa", a_outputFeat2FFaTa);
	  check_rLabel(a_outputFeat2FFaTa->get_rLabel(), 0);
	}
      else
	check_rLabel(a_outputFeat2FFaTa->get_rLabel(), log);
    }
}

/********************************************************************/

void check_outputFeat2FaFTa(
 outputFeat2FaFTa * a_outputFeat2FaFTa,
 int log)
{
  if (a_outputFeat2FaFTa->get_fa())
    {
      adjustLevels(&outputFeat2FaFTaAtts_fa, "outputFeat2FaFTa fa");
      if (log && !findString("fa", outputFeat2FaFTaAtts))
	{
	  warnAtt("fa", "outputFeat2FaFTa", a_outputFeat2FaFTa);
	  check_faLabel(a_outputFeat2FaFTa->get_fa(), 0);
	}
      else
	check_faLabel(a_outputFeat2FaFTa->get_fa(), log);
    }
  if (a_outputFeat2FaFTa->get_f())
    {
      adjustLevels(&outputFeat2FaFTaAtts_f, "outputFeat2FaFTa f");
      if (log && !findString("f", outputFeat2FaFTaAtts))
	{
	  warnAtt("f", "outputFeat2FaFTa", a_outputFeat2FaFTa);
	  check_fLabel(a_outputFeat2FaFTa->get_f(), 0);
	}
      else
	check_fLabel(a_outputFeat2FaFTa->get_f(), log);
    }
  if (a_outputFeat2FaFTa->get_ta())
    {
      adjustLevels(&outputFeat2FaFTaAtts_ta, "outputFeat2FaFTa ta");
      if (log && !findString("ta", outputFeat2FaFTaAtts))
	{
	  warnAtt("ta", "outputFeat2FaFTa", a_outputFeat2FaFTa);
	  check_taLabel(a_outputFeat2FaFTa->get_ta(), 0);
	}
      else
	check_taLabel(a_outputFeat2FaFTa->get_ta(), log);
    }
  if (a_outputFeat2FaFTa->get_rLabel())
    {
      adjustLevels(&outputFeat2FaFTaAtts_a_rLabel,
		   "outputFeat2FaFTa a_rLabel");
      if (log && !findString("a_rLabel", outputFeat2FaFTaAtts))
	{
	  warnAtt("a_rLabel", "outputFeat2FaFTa", a_outputFeat2FaFTa);
	  check_rLabel(a_outputFeat2FaFTa->get_rLabel(), 0);
	}
      else
	check_rLabel(a_outputFeat2FaFTa->get_rLabel(), log);
    }
}

/********************************************************************/

void check_outputFeat2FaFaTa(
 outputFeat2FaFaTa * a_outputFeat2FaFaTa,
 int log)
{
  if (a_outputFeat2FaFaTa->get_fa1())
    {
      adjustLevels(&outputFeat2FaFaTaAtts_fa1, "outputFeat2FaFaTa fa1");
      if (log && !findString("fa1", outputFeat2FaFaTaAtts))
	{
	  warnAtt("fa1", "outputFeat2FaFaTa", a_outputFeat2FaFaTa);
	  check_faLabel(a_outputFeat2FaFaTa->get_fa1(), 0);
	}
      else
	check_faLabel(a_outputFeat2FaFaTa->get_fa1(), log);
    }
  if (a_outputFeat2FaFaTa->get_fa2())
    {
      adjustLevels(&outputFeat2FaFaTaAtts_fa2, "outputFeat2FaFaTa fa2");
      if (log && !findString("fa2", outputFeat2FaFaTaAtts))
	{
	  warnAtt("fa2", "outputFeat2FaFaTa", a_outputFeat2FaFaTa);
	  check_faLabel(a_outputFeat2FaFaTa->get_fa2(), 0);
	}
      else
	check_faLabel(a_outputFeat2FaFaTa->get_fa2(), log);
    }
  if (a_outputFeat2FaFaTa->get_ta())
    {
      adjustLevels(&outputFeat2FaFaTaAtts_ta, "outputFeat2FaFaTa ta");
      if (log && !findString("ta", outputFeat2FaFaTaAtts))
	{
	  warnAtt("ta", "outputFeat2FaFaTa", a_outputFeat2FaFaTa);
	  check_taLabel(a_outputFeat2FaFaTa->get_ta(), 0);
	}
      else
	check_taLabel(a_outputFeat2FaFaTa->get_ta(), log);
    }
  if (a_outputFeat2FaFaTa->get_rLabel())
    {
      adjustLevels(&outputFeat2FaFaTaAtts_a_rLabel,
		   "outputFeat2FaFaTa a_rLabel");
      if (log && !findString("a_rLabel", outputFeat2FaFaTaAtts))
	{
	  warnAtt("a_rLabel", "outputFeat2FaFaTa", a_outputFeat2FaFaTa);
	  check_rLabel(a_outputFeat2FaFaTa->get_rLabel(), 0);
	}
      else
	check_rLabel(a_outputFeat2FaFaTa->get_rLabel(), log);
    }
}

/********************************************************************/

void check_outputFeatData(
 outputFeatData * a_outputFeatData,
 int log)
{
  if (isA(a_outputFeatData, outputFeat))
    {
      adjustLevels(&outputFeatDataSubs_outputFeat, "outputFeat");
      if (log && !findString("outputFeat", outputFeatDataSubs))
	{
	  warnSub("outputFeat", "outputFeatData", a_outputFeatData);
	  check_outputFeat(
	    dynamic_cast<outputFeat *>(a_outputFeatData), 0);
	}
      else
	check_outputFeat(
	  dynamic_cast<outputFeat *>(a_outputFeatData), log);
      return;
    }
  if (isA(a_outputFeatData, outputDat))
    {
      adjustLevels(&outputFeatDataSubs_outputDat, "outputDat");
      if (log && !findString("outputDat", outputFeatDataSubs))
	{
	  warnSub("outputDat", "outputFeatData", a_outputFeatData);
	  check_outputDat(dynamic_cast<outputDat *>(a_outputFeatData), 0);
	}
      else
	check_outputDat(dynamic_cast<outputDat *>(a_outputFeatData), log);
      return;
    }
}

/********************************************************************/

void check_outputKeycharData(
 outputKeycharData * a_outputKeycharData,
 int log)
{
  if (isA(a_outputKeycharData, kcLabel))
    {
      adjustLevels(&outputKeycharDataSubs_kcLabel, "kcLabel");
      if (log && !findString("kcLabel", outputKeycharDataSubs))
	{
	  warnSub("kcLabel", "outputKeycharData", a_outputKeycharData);
	  check_kcLabel(dynamic_cast<kcLabel *>(a_outputKeycharData), 0);
	}
      else
	check_kcLabel(dynamic_cast<kcLabel *>(a_outputKeycharData), log);
      return;
    }
  if (isA(a_outputKeycharData, kcaLabel))
    {
      adjustLevels(&outputKeycharDataSubs_kcaLabel, "kcaLabel");
      if (log && !findString("kcaLabel", outputKeycharDataSubs))
	{
	  warnSub("kcaLabel", "outputKeycharData", a_outputKeycharData);
	  check_kcaLabel(dynamic_cast<kcaLabel *>(a_outputKeycharData), 0);
	}
      else
	check_kcaLabel(dynamic_cast<kcaLabel *>(a_outputKeycharData), log);
      return;
    }
}

/********************************************************************/

void check_outputMinor(
 outputMinor * a_outputMinor,
 int log)
{
  if (isA(a_outputMinor, outputFeatData))
    {
      adjustLevels(&outputMinorSubs_outputFeatData, "outputFeatData");
      if (log && !findString("outputFeatData", outputMinorSubs))
	{
	  warnSub("outputFeatData", "outputMinor", a_outputMinor);
	  check_outputFeatData(
	    dynamic_cast<outputFeatData *>(a_outputMinor), 0);
	}
      else
	check_outputFeatData(
	  dynamic_cast<outputFeatData *>(a_outputMinor), log);
      return;
    }
  if (isA(a_outputMinor, outputConstData))
    {
      adjustLevels(&outputMinorSubs_outputConstData, "outputConstData");
      if (log && !findString("outputConstData", outputMinorSubs))
	{
	  warnSub("outputConstData", "outputMinor", a_outputMinor);
	  check_outputConstData(
	    dynamic_cast<outputConstData *>(a_outputMinor), 0);
	}
      else
	check_outputConstData(
	  dynamic_cast<outputConstData *>(a_outputMinor), log);
      return;
    }
  if (isA(a_outputMinor, outputKeycharData))
    {
      adjustLevels(&outputMinorSubs_outputKeycharData, "outputKeycharData");
      if (log && !findString("outputKeycharData", outputMinorSubs))
	{
	  warnSub("outputKeycharData", "outputMinor", a_outputMinor);
	  check_outputKeycharData(
	    dynamic_cast<outputKeycharData *>(a_outputMinor), 0);
	}
      else
	check_outputKeycharData(
	  dynamic_cast<outputKeycharData *>(a_outputMinor), log);
      return;
    }
  if (isA(a_outputMinor, outputSensorData))
    {
      adjustLevels(&outputMinorSubs_outputSensorData, "outputSensorData");
      if (log && !findString("outputSensorData", outputMinorSubs))
	{
	  warnSub("outputSensorData", "outputMinor", a_outputMinor);
	  check_outputSensorData(
	    dynamic_cast<outputSensorData *>(a_outputMinor), 0);
	}
      else
	check_outputSensorData(
	  dynamic_cast<outputSensorData *>(a_outputMinor), log);
      return;
    }
  if (isA(a_outputMinor, outputToleranceData))
    {
      adjustLevels(&outputMinorSubs_outputToleranceData,
		   "outputToleranceData");
      if (log && !findString("outputToleranceData", outputMinorSubs))
	{
	  warnSub("outputToleranceData", "outputMinor", a_outputMinor);
	  check_outputToleranceData(
	    dynamic_cast<outputToleranceData *>(a_outputMinor), 0);
	}
      else
	check_outputToleranceData(
	  dynamic_cast<outputToleranceData *>(a_outputMinor), log);
      return;
    }
  if (isA(a_outputMinor, outputReportData))
    {
      adjustLevels(&outputMinorSubs_outputReportData, "outputReportData");
      if (log && !findString("outputReportData", outputMinorSubs))
	{
	  warnSub("outputReportData", "outputMinor", a_outputMinor);
	  check_outputReportData(
	    dynamic_cast<outputReportData *>(a_outputMinor), 0);
	}
      else
	check_outputReportData(
	  dynamic_cast<outputReportData *>(a_outputMinor), log);
      return;
    }
}

/********************************************************************/

void check_outputReportData(
 outputReportData * a_outputReportData,
 int log)
{
  if (isA(a_outputReportData, rLabel))
    {
      adjustLevels(&outputReportDataSubs_rLabel, "rLabel");
      if (log && !findString("rLabel", outputReportDataSubs))
	{
	  warnSub("rLabel", "outputReportData", a_outputReportData);
	  check_rLabel(dynamic_cast<rLabel *>(a_outputReportData), 0);
	}
      else
	check_rLabel(dynamic_cast<rLabel *>(a_outputReportData), log);
      return;
    }
}

/********************************************************************/

void check_outputSensorData(
 outputSensorData * a_outputSensorData,
 int log)
{
  if (isA(a_outputSensorData, outputSensorData_sLabel))
    {
      adjustLevels(&outputSensorDataSubs_outputSensorData_sLabel,
		   "outputSensorData_sLabel");
      if (log && !findString("outputSensorData_sLabel", outputSensorDataSubs))
	{
	  warnSub("outputSensorData_sLabel", "outputSensorData",
		  a_outputSensorData);
	  check_outputSensorData_sLabel(
	    dynamic_cast<outputSensorData_sLabel *>(a_outputSensorData), 0);
	}
      else
	check_outputSensorData_sLabel(
	  dynamic_cast<outputSensorData_sLabel *>(a_outputSensorData), log);
      return;
    }
  if (isA(a_outputSensorData, outputSensorData_saLabel))
    {
      adjustLevels(&outputSensorDataSubs_outputSensorData_saLabel,
		   "outputSensorData_saLabel");
      if (log && !findString("outputSensorData_saLabel", outputSensorDataSubs))
	{
	  warnSub("outputSensorData_saLabel", "outputSensorData",
		  a_outputSensorData);
	  check_outputSensorData_saLabel(
	    dynamic_cast<outputSensorData_saLabel *>(a_outputSensorData), 0);
	}
      else
	check_outputSensorData_saLabel(
	  dynamic_cast<outputSensorData_saLabel *>(a_outputSensorData), log);
      return;
    }
}

/********************************************************************/

void check_outputSensorData_sLabel(
 outputSensorData_sLabel * a_outputSensorData_sLabel,
 int log)
{
  if (a_outputSensorData_sLabel->get_sLabel())
    {
      adjustLevels(&outputSensorData_sLabelAtts_a_sLabel,
		   "outputSensorData_sLabel a_sLabel");
      if (log && !findString("a_sLabel", outputSensorData_sLabelAtts))
	{
	  warnAtt("a_sLabel", "outputSensorData_sLabel",
		  a_outputSensorData_sLabel);
	  check_sLabel(a_outputSensorData_sLabel->get_sLabel(), 0);
	}
      else
	check_sLabel(a_outputSensorData_sLabel->get_sLabel(), log);
    }
}

/********************************************************************/

void check_outputSensorData_saLabel(
 outputSensorData_saLabel * a_outputSensorData_saLabel,
 int log)
{
  if (a_outputSensorData_saLabel->get_saLabel())
    {
      adjustLevels(&outputSensorData_saLabelAtts_a_saLabel,
		   "outputSensorData_saLabel a_saLabel");
      if (log && !findString("a_saLabel", outputSensorData_saLabelAtts))
	{
	  warnAtt("a_saLabel", "outputSensorData_saLabel",
		  a_outputSensorData_saLabel);
	  check_saLabel(a_outputSensorData_saLabel->get_saLabel(), 0);
	}
      else
	check_saLabel(a_outputSensorData_saLabel->get_saLabel(), log);
    }
  if (a_outputSensorData_saLabel->get_outputSensorDesc())
    {
      adjustLevels(&outputSensorData_saLabelAtts_a_outputSensorDesc,
		   "outputSensorData_saLabel a_outputSensorDesc");
      if (log && !findString("a_outputSensorDesc",
			     outputSensorData_saLabelAtts))
	{
	  warnAtt("a_outputSensorDesc", "outputSensorData_saLabel",
		  a_outputSensorData_saLabel);
	  check_outputSensorDesc(
	    a_outputSensorData_saLabel->get_outputSensorDesc(), 0);
	}
      else
	check_outputSensorDesc(
	  a_outputSensorData_saLabel->get_outputSensorDesc(), log);
    }
}

/********************************************************************/

void check_outputSensorDesc(
 outputSensorDesc * a_outputSensorDesc,
 int log)
{
  if (isA(a_outputSensorDesc, outputSensorDesc_stringVal))
    {
      adjustLevels(&outputSensorDescSubs_outputSensorDesc_stringVal,
		   "outputSensorDesc_stringVal");
      if (log && !findString("outputSensorDesc_stringVal",
			     outputSensorDescSubs))
	{
	  warnSub("outputSensorDesc_stringVal", "outputSensorDesc",
		  a_outputSensorDesc);
	  check_outputSensorDesc_stringVal(
	    dynamic_cast<outputSensorDesc_stringVal *>(a_outputSensorDesc), 0);
	}
      else
	check_outputSensorDesc_stringVal(
	  dynamic_cast<outputSensorDesc_stringVal *>(a_outputSensorDesc), log);
      return;
    }
  if (isA(a_outputSensorDesc, outputSensorDesc_intVal))
    {
      adjustLevels(&outputSensorDescSubs_outputSensorDesc_intVal,
		   "outputSensorDesc_intVal");
      if (log && !findString("outputSensorDesc_intVal", outputSensorDescSubs))
	{
	  warnSub("outputSensorDesc_intVal", "outputSensorDesc",
		  a_outputSensorDesc);
	  check_outputSensorDesc_intVal(
	    dynamic_cast<outputSensorDesc_intVal *>(a_outputSensorDesc), 0);
	}
      else
	check_outputSensorDesc_intVal(
	  dynamic_cast<outputSensorDesc_intVal *>(a_outputSensorDesc), log);
      return;
    }
  if (isA(a_outputSensorDesc, outputSensorDesc_outputSensorWristList))
    {
      adjustLevels(&outputSensorDescSubs_outputSensorDesc_outputSensorWristList,
		   "outputSensorDesc_outputSensorWristList");
      if (log && !findString("outputSensorDesc_outputSensorWristList",
			     outputSensorDescSubs))
	{
	  warnSub("outputSensorDesc_outputSensorWristList", "outputSensorDesc",
		  a_outputSensorDesc);
	  check_outputSensorDesc_outputSensorWristList(
	    dynamic_cast<outputSensorDesc_outputSensorWristList *>(a_outputSensorDesc), 0);
	}
      else
	check_outputSensorDesc_outputSensorWristList(
	  dynamic_cast<outputSensorDesc_outputSensorWristList *>(a_outputSensorDesc), log);
      return;
    }
  if (isA(a_outputSensorDesc, outputSensorDesc_CURENT))
    {
      adjustLevels(&outputSensorDescSubs_outputSensorDesc_CURENT,
		   "outputSensorDesc_CURENT");
      if (log && !findString("outputSensorDesc_CURENT", outputSensorDescSubs))
	{
	  warnSub("outputSensorDesc_CURENT", "outputSensorDesc",
		  a_outputSensorDesc);
	}
      return;
    }
}

/********************************************************************/

void check_outputSensorDesc_intVal(
 outputSensorDesc_intVal * a_outputSensorDesc_intVal,
 int log)
{
  if (a_outputSensorDesc_intVal->get_tipnum())
    {
      adjustLevels(&outputSensorDesc_intValAtts_tipnum,
		   "outputSensorDesc_intVal tipnum");
      if (log && !findString("tipnum", outputSensorDesc_intValAtts))
	{
	  warnAtt("tipnum", "outputSensorDesc_intVal",
		  a_outputSensorDesc_intVal);
	  check_intVal(a_outputSensorDesc_intVal->get_tipnum(), 0);
	}
      else
	check_intVal(a_outputSensorDesc_intVal->get_tipnum(), log);
    }
  if (a_outputSensorDesc_intVal->get_outputSensorWristList())
    {
      std::list<outputSensorWristItem *> * theList;
      std::list<outputSensorWristItem *>::iterator iter;
      theList = a_outputSensorDesc_intVal->get_outputSensorWristList();
      adjustLevels(&outputSensorDesc_intValAtts_a_outputSensorWristList,
		   "outputSensorDesc_intVal a_outputSensorWristList");
      if (log && !findString("a_outputSensorWristList",
			     outputSensorDesc_intValAtts))
	{
	  warnAtt("a_outputSensorWristList", "outputSensorDesc_intVal",
		  a_outputSensorDesc_intVal);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_outputSensorWristItem(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_outputSensorWristItem(*iter, log);
	}
    }
}

/********************************************************************/

void check_outputSensorDesc_outputSensorWristList(
 outputSensorDesc_outputSensorWristList * a_outputSensorDesc_outputSensorWristList,
 int log)
{
  if (a_outputSensorDesc_outputSensorWristList->get_outputSensorWristList())
    {
      std::list<outputSensorWristItem *> * theList;
      std::list<outputSensorWristItem *>::iterator iter;
      theList = a_outputSensorDesc_outputSensorWristList->get_outputSensorWristList();
      adjustLevels(&outputSensorDesc_outputSensorWristListAtts_a_outputSensorWristList,
		   "outputSensorDesc_outputSensorWristList a_outputSensorWristList");
      if (log && !findString("a_outputSensorWristList",
			     outputSensorDesc_outputSensorWristListAtts))
	{
	  warnAtt("a_outputSensorWristList", "outputSensorDesc_outputSensorWristList",
		  a_outputSensorDesc_outputSensorWristList);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_outputSensorWristItem(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_outputSensorWristItem(*iter, log);
	}
    }
}

/********************************************************************/

void check_outputSensorDesc_stringVal(
 outputSensorDesc_stringVal * a_outputSensorDesc_stringVal,
 int log)
{
  if (a_outputSensorDesc_stringVal->get_desc())
    {
      adjustLevels(&outputSensorDesc_stringValAtts_desc,
		   "outputSensorDesc_stringVal desc");
      if (log && !findString("desc", outputSensorDesc_stringValAtts))
	{
	  warnAtt("desc", "outputSensorDesc_stringVal",
		  a_outputSensorDesc_stringVal);
	  check_stringVal(a_outputSensorDesc_stringVal->get_desc(), 0);
	}
      else
	check_stringVal(a_outputSensorDesc_stringVal->get_desc(), log);
    }
  if (a_outputSensorDesc_stringVal->get_outputSensorWristList())
    {
      std::list<outputSensorWristItem *> * theList;
      std::list<outputSensorWristItem *>::iterator iter;
      theList = a_outputSensorDesc_stringVal->get_outputSensorWristList();
      adjustLevels(&outputSensorDesc_stringValAtts_a_outputSensorWristList,
		   "outputSensorDesc_stringVal a_outputSensorWristList");
      if (log && !findString("a_outputSensorWristList",
			     outputSensorDesc_stringValAtts))
	{
	  warnAtt("a_outputSensorWristList", "outputSensorDesc_stringVal",
		  a_outputSensorDesc_stringVal);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_outputSensorWristItem(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_outputSensorWristItem(*iter, log);
	}
    }
}

/********************************************************************/

void check_outputSensorWristAngle(
 outputSensorWristAngle * a_outputSensorWristAngle,
 int log)
{
  if (a_outputSensorWristAngle->get_anglename())
    {
      adjustLevels(&outputSensorWristAngleAtts_anglename,
		   "outputSensorWristAngle anglename");
      if (log && !findString("anglename", outputSensorWristAngleAtts))
	{
	  warnAtt("anglename", "outputSensorWristAngle",
		  a_outputSensorWristAngle);
	  check_stringVal(a_outputSensorWristAngle->get_anglename(), 0);
	}
      else
	check_stringVal(a_outputSensorWristAngle->get_anglename(), log);
    }
  if (a_outputSensorWristAngle->get_angle())
    {
      adjustLevels(&outputSensorWristAngleAtts_a_angle,
		   "outputSensorWristAngle a_angle");
      if (log && !findString("a_angle", outputSensorWristAngleAtts))
	{
	  warnAtt("a_angle", "outputSensorWristAngle",
		  a_outputSensorWristAngle);
	  check_angle(a_outputSensorWristAngle->get_angle(), 0);
	}
      else
	check_angle(a_outputSensorWristAngle->get_angle(), log);
    }
}

/********************************************************************/

void check_outputSensorWristItem(
 outputSensorWristItem * a_outputSensorWristItem,
 int log)
{
  if (a_outputSensorWristItem->get_swLabel())
    {
      adjustLevels(&outputSensorWristItemAtts_a_swLabel,
		   "outputSensorWristItem a_swLabel");
      if (log && !findString("a_swLabel", outputSensorWristItemAtts))
	{
	  warnAtt("a_swLabel", "outputSensorWristItem",
		  a_outputSensorWristItem);
	  check_swLabel(a_outputSensorWristItem->get_swLabel(), 0);
	}
      else
	check_swLabel(a_outputSensorWristItem->get_swLabel(), log);
    }
  if (a_outputSensorWristItem->get_outputSensorWristAngleList())
    {
      std::list<outputSensorWristAngle *> * theList;
      std::list<outputSensorWristAngle *>::iterator iter;
      theList = a_outputSensorWristItem->get_outputSensorWristAngleList();
      adjustLevels(&outputSensorWristItemAtts_a_outputSensorWristAngleList,
		   "outputSensorWristItem a_outputSensorWristAngleList");
      if (log && !findString("a_outputSensorWristAngleList",
			     outputSensorWristItemAtts))
	{
	  warnAtt("a_outputSensorWristAngleList", "outputSensorWristItem",
		  a_outputSensorWristItem);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_outputSensorWristAngle(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_outputSensorWristAngle(*iter, log);
	}
    }
}

/********************************************************************/

void check_outputStm(
 outputStm * a_outputStm,
 int log)
{
  if (a_outputStm->get_outputMinor())
    {
      adjustLevels(&outputStmAtts_a_outputMinor, "outputStm a_outputMinor");
      if (log && !findString("a_outputMinor", outputStmAtts))
	{
	  warnAtt("a_outputMinor", "outputStm", a_outputStm);
	  check_outputMinor(a_outputStm->get_outputMinor(), 0);
	}
      else
	check_outputMinor(a_outputStm->get_outputMinor(), log);
    }
}

/********************************************************************/

void check_outputToleranceData(
 outputToleranceData * a_outputToleranceData,
 int log)
{
  if (isA(a_outputToleranceData, tLabel))
    {
      adjustLevels(&outputToleranceDataSubs_tLabel, "tLabel");
      if (log && !findString("tLabel", outputToleranceDataSubs))
	{
	  warnSub("tLabel", "outputToleranceData", a_outputToleranceData);
	  check_tLabel(dynamic_cast<tLabel *>(a_outputToleranceData), 0);
	}
      else
	check_tLabel(dynamic_cast<tLabel *>(a_outputToleranceData), log);
      return;
    }
  if (isA(a_outputToleranceData, taLabel))
    {
      adjustLevels(&outputToleranceDataSubs_taLabel, "taLabel");
      if (log && !findString("taLabel", outputToleranceDataSubs))
	{
	  warnSub("taLabel", "outputToleranceData", a_outputToleranceData);
	  check_taLabel(dynamic_cast<taLabel *>(a_outputToleranceData), 0);
	}
      else
	check_taLabel(dynamic_cast<taLabel *>(a_outputToleranceData), log);
      return;
    }
}

/********************************************************************/

void check_pLabel(
 pLabel * a_pLabel,
 int log)
{
  if (a_pLabel->get_labelName())
    {
      adjustLevels(&pLabelAtts_a_labelName, "pLabel a_labelName");
      if (log && !findString("a_labelName", pLabelAtts))
	{
	  warnAtt("a_labelName", "pLabel", a_pLabel);
	  check_labelName(a_pLabel->get_labelName(), 0);
	}
      else
	check_labelName(a_pLabel->get_labelName(), log);
    }
}

/********************************************************************/

void check_pameasDetail(
 pameasDetail * a_pameasDetail,
 int log)
{
  if (isA(a_pameasDetail, pameasDetailDistance))
    {
      adjustLevels(&pameasDetailSubs_pameasDetailDistance,
		   "pameasDetailDistance");
      if (log && !findString("pameasDetailDistance", pameasDetailSubs))
	{
	  warnSub("pameasDetailDistance", "pameasDetail", a_pameasDetail);
	  check_pameasDetailDistance(
	    dynamic_cast<pameasDetailDistance *>(a_pameasDetail), 0);
	}
      else
	check_pameasDetailDistance(
	  dynamic_cast<pameasDetailDistance *>(a_pameasDetail), log);
      return;
    }
  if (isA(a_pameasDetail, pameasDetailScnvelData))
    {
      adjustLevels(&pameasDetailSubs_pameasDetailScnvelData,
		   "pameasDetailScnvelData");
      if (log && !findString("pameasDetailScnvelData", pameasDetailSubs))
	{
	  warnSub("pameasDetailScnvelData", "pameasDetail", a_pameasDetail);
	  check_pameasDetailScnvelData(
	    dynamic_cast<pameasDetailScnvelData *>(a_pameasDetail), 0);
	}
      else
	check_pameasDetailScnvelData(
	  dynamic_cast<pameasDetailScnvelData *>(a_pameasDetail), log);
      return;
    }
  if (isA(a_pameasDetail, pameasDetailPitch))
    {
      adjustLevels(&pameasDetailSubs_pameasDetailPitch, "pameasDetailPitch");
      if (log && !findString("pameasDetailPitch", pameasDetailSubs))
	{
	  warnSub("pameasDetailPitch", "pameasDetail", a_pameasDetail);
	  check_pameasDetailPitch(
	    dynamic_cast<pameasDetailPitch *>(a_pameasDetail), 0);
	}
      else
	check_pameasDetailPitch(
	  dynamic_cast<pameasDetailPitch *>(a_pameasDetail), log);
      return;
    }
  if (isA(a_pameasDetail, pameasDetailNoData))
    {
      adjustLevels(&pameasDetailSubs_pameasDetailNoData, "pameasDetailNoData");
      if (log && !findString("pameasDetailNoData", pameasDetailSubs))
	{
	  warnSub("pameasDetailNoData", "pameasDetail", a_pameasDetail);
	}
      return;
    }
  if (isA(a_pameasDetail, pameasDetailScnvelNoData))
    {
      adjustLevels(&pameasDetailSubs_pameasDetailScnvelNoData,
		   "pameasDetailScnvelNoData");
      if (log && !findString("pameasDetailScnvelNoData", pameasDetailSubs))
	{
	  warnSub("pameasDetailScnvelNoData", "pameasDetail", a_pameasDetail);
	  check_pameasDetailScnvelNoData(
	    dynamic_cast<pameasDetailScnvelNoData *>(a_pameasDetail), 0);
	}
      else
	check_pameasDetailScnvelNoData(
	  dynamic_cast<pameasDetailScnvelNoData *>(a_pameasDetail), log);
      return;
    }
}

/********************************************************************/

void check_pameasDetailDistance(
 pameasDetailDistance * a_pameasDetailDistance,
 int log)
{
  if (a_pameasDetailDistance->get_dist())
    {
      adjustLevels(&pameasDetailDistanceAtts_dist,
		   "pameasDetailDistance dist");
      if (log && !findString("dist", pameasDetailDistanceAtts))
	{
	  warnAtt("dist", "pameasDetailDistance", a_pameasDetailDistance);
	  check_rentVal(a_pameasDetailDistance->get_dist(), 0);
	}
      else
	check_rentVal(a_pameasDetailDistance->get_dist(), log);
    }
  if (a_pameasDetailDistance->get_feed())
    {
      adjustLevels(&pameasDetailDistanceAtts_feed,
		   "pameasDetailDistance feed");
      if (log && !findString("feed", pameasDetailDistanceAtts))
	{
	  warnAtt("feed", "pameasDetailDistance", a_pameasDetailDistance);
	  check_pameasFedrat(a_pameasDetailDistance->get_feed(), 0);
	}
      else
	check_pameasFedrat(a_pameasDetailDistance->get_feed(), log);
    }
  if (a_pameasDetailDistance->get_pitch())
    {
      adjustLevels(&pameasDetailDistanceAtts_pitch,
		   "pameasDetailDistance pitch");
      if (log && !findString("pitch", pameasDetailDistanceAtts))
	{
	  warnAtt("pitch", "pameasDetailDistance", a_pameasDetailDistance);
	  check_rentVal(a_pameasDetailDistance->get_pitch(), 0);
	}
      else
	check_rentVal(a_pameasDetailDistance->get_pitch(), log);
    }
}

/********************************************************************/

void check_pameasDetailPitch(
 pameasDetailPitch * a_pameasDetailPitch,
 int log)
{
  if (a_pameasDetailPitch->get_pitch())
    {
      adjustLevels(&pameasDetailPitchAtts_pitch, "pameasDetailPitch pitch");
      if (log && !findString("pitch", pameasDetailPitchAtts))
	{
	  warnAtt("pitch", "pameasDetailPitch", a_pameasDetailPitch);
	  check_rentVal(a_pameasDetailPitch->get_pitch(), 0);
	}
      else
	check_rentVal(a_pameasDetailPitch->get_pitch(), log);
    }
}

/********************************************************************/

void check_pameasDetailScnvelData(
 pameasDetailScnvelData * a_pameasDetailScnvelData,
 int log)
{
  if (a_pameasDetailScnvelData->get_feed())
    {
      adjustLevels(&pameasDetailScnvelDataAtts_feed,
		   "pameasDetailScnvelData feed");
      if (log && !findString("feed", pameasDetailScnvelDataAtts))
	{
	  warnAtt("feed", "pameasDetailScnvelData", a_pameasDetailScnvelData);
	  check_pameasFedrat(a_pameasDetailScnvelData->get_feed(), 0);
	}
      else
	check_pameasFedrat(a_pameasDetailScnvelData->get_feed(), log);
    }
  if (a_pameasDetailScnvelData->get_pitch())
    {
      adjustLevels(&pameasDetailScnvelDataAtts_pitch,
		   "pameasDetailScnvelData pitch");
      if (log && !findString("pitch", pameasDetailScnvelDataAtts))
	{
	  warnAtt("pitch", "pameasDetailScnvelData",
		  a_pameasDetailScnvelData);
	  check_rentVal(a_pameasDetailScnvelData->get_pitch(), 0);
	}
      else
	check_rentVal(a_pameasDetailScnvelData->get_pitch(), log);
    }
}

/********************************************************************/

void check_pameasDetailScnvelNoData(
 pameasDetailScnvelNoData * a_pameasDetailScnvelNoData,
 int log)
{
  if (a_pameasDetailScnvelNoData->get_feed())
    {
      adjustLevels(&pameasDetailScnvelNoDataAtts_feed,
		   "pameasDetailScnvelNoData feed");
      if (log && !findString("feed", pameasDetailScnvelNoDataAtts))
	{
	  warnAtt("feed", "pameasDetailScnvelNoData",
		  a_pameasDetailScnvelNoData);
	  check_pameasFedrat(a_pameasDetailScnvelNoData->get_feed(), 0);
	}
      else
	check_pameasFedrat(a_pameasDetailScnvelNoData->get_feed(), log);
    }
}

/********************************************************************/

void check_pameasFedrat(
 pameasFedrat * a_pameasFedrat,
 int log)
{
  if (isA(a_pameasFedrat, pameasFedrat_MPM))
    {
      adjustLevels(&pameasFedratSubs_pameasFedrat_MPM, "pameasFedrat_MPM");
      if (log && !findString("pameasFedrat_MPM", pameasFedratSubs))
	{
	  warnSub("pameasFedrat_MPM", "pameasFedrat", a_pameasFedrat);
	  check_pameasFedrat_MPM(
	    dynamic_cast<pameasFedrat_MPM *>(a_pameasFedrat), 0);
	}
      else
	check_pameasFedrat_MPM(
	  dynamic_cast<pameasFedrat_MPM *>(a_pameasFedrat), log);
      return;
    }
  if (isA(a_pameasFedrat, pameasFedrat_MMPS))
    {
      adjustLevels(&pameasFedratSubs_pameasFedrat_MMPS, "pameasFedrat_MMPS");
      if (log && !findString("pameasFedrat_MMPS", pameasFedratSubs))
	{
	  warnSub("pameasFedrat_MMPS", "pameasFedrat", a_pameasFedrat);
	  check_pameasFedrat_MMPS(
	    dynamic_cast<pameasFedrat_MMPS *>(a_pameasFedrat), 0);
	}
      else
	check_pameasFedrat_MMPS(
	  dynamic_cast<pameasFedrat_MMPS *>(a_pameasFedrat), log);
      return;
    }
  if (isA(a_pameasFedrat, pameasFedrat_IPM))
    {
      adjustLevels(&pameasFedratSubs_pameasFedrat_IPM, "pameasFedrat_IPM");
      if (log && !findString("pameasFedrat_IPM", pameasFedratSubs))
	{
	  warnSub("pameasFedrat_IPM", "pameasFedrat", a_pameasFedrat);
	  check_pameasFedrat_IPM(
	    dynamic_cast<pameasFedrat_IPM *>(a_pameasFedrat), 0);
	}
      else
	check_pameasFedrat_IPM(
	  dynamic_cast<pameasFedrat_IPM *>(a_pameasFedrat), log);
      return;
    }
  if (isA(a_pameasFedrat, pameasFedrat_IPS))
    {
      adjustLevels(&pameasFedratSubs_pameasFedrat_IPS, "pameasFedrat_IPS");
      if (log && !findString("pameasFedrat_IPS", pameasFedratSubs))
	{
	  warnSub("pameasFedrat_IPS", "pameasFedrat", a_pameasFedrat);
	  check_pameasFedrat_IPS(
	    dynamic_cast<pameasFedrat_IPS *>(a_pameasFedrat), 0);
	}
      else
	check_pameasFedrat_IPS(
	  dynamic_cast<pameasFedrat_IPS *>(a_pameasFedrat), log);
      return;
    }
}

/********************************************************************/

void check_pameasFedrat_IPM(
 pameasFedrat_IPM * a_pameasFedrat_IPM,
 int log)
{
  if (a_pameasFedrat_IPM->get_rate())
    {
      adjustLevels(&pameasFedrat_IPMAtts_rate, "pameasFedrat_IPM rate");
      if (log && !findString("rate", pameasFedrat_IPMAtts))
	{
	  warnAtt("rate", "pameasFedrat_IPM", a_pameasFedrat_IPM);
	  check_rentVal(a_pameasFedrat_IPM->get_rate(), 0);
	}
      else
	check_rentVal(a_pameasFedrat_IPM->get_rate(), log);
    }
}

/********************************************************************/

void check_pameasFedrat_IPS(
 pameasFedrat_IPS * a_pameasFedrat_IPS,
 int log)
{
  if (a_pameasFedrat_IPS->get_rate())
    {
      adjustLevels(&pameasFedrat_IPSAtts_rate, "pameasFedrat_IPS rate");
      if (log && !findString("rate", pameasFedrat_IPSAtts))
	{
	  warnAtt("rate", "pameasFedrat_IPS", a_pameasFedrat_IPS);
	  check_rentVal(a_pameasFedrat_IPS->get_rate(), 0);
	}
      else
	check_rentVal(a_pameasFedrat_IPS->get_rate(), log);
    }
}

/********************************************************************/

void check_pameasFedrat_MMPS(
 pameasFedrat_MMPS * a_pameasFedrat_MMPS,
 int log)
{
  if (a_pameasFedrat_MMPS->get_rate())
    {
      adjustLevels(&pameasFedrat_MMPSAtts_rate, "pameasFedrat_MMPS rate");
      if (log && !findString("rate", pameasFedrat_MMPSAtts))
	{
	  warnAtt("rate", "pameasFedrat_MMPS", a_pameasFedrat_MMPS);
	  check_rentVal(a_pameasFedrat_MMPS->get_rate(), 0);
	}
      else
	check_rentVal(a_pameasFedrat_MMPS->get_rate(), log);
    }
}

/********************************************************************/

void check_pameasFedrat_MPM(
 pameasFedrat_MPM * a_pameasFedrat_MPM,
 int log)
{
  if (a_pameasFedrat_MPM->get_rate())
    {
      adjustLevels(&pameasFedrat_MPMAtts_rate, "pameasFedrat_MPM rate");
      if (log && !findString("rate", pameasFedrat_MPMAtts))
	{
	  warnAtt("rate", "pameasFedrat_MPM", a_pameasFedrat_MPM);
	  check_rentVal(a_pameasFedrat_MPM->get_rate(), 0);
	}
      else
	check_rentVal(a_pameasFedrat_MPM->get_rate(), log);
    }
}

/********************************************************************/

void check_pameasMinor(
 pameasMinor * a_pameasMinor,
 int log)
{
  if (isA(a_pameasMinor, pameasMinor_pameasVar2List))
    {
      adjustLevels(&pameasMinorSubs_pameasMinor_pameasVar2List,
		   "pameasMinor_pameasVar2List");
      if (log && !findString("pameasMinor_pameasVar2List", pameasMinorSubs))
	{
	  warnSub("pameasMinor_pameasVar2List", "pameasMinor", a_pameasMinor);
	  check_pameasMinor_pameasVar2List(
	    dynamic_cast<pameasMinor_pameasVar2List *>(a_pameasMinor), 0);
	}
      else
	check_pameasMinor_pameasVar2List(
	  dynamic_cast<pameasMinor_pameasVar2List *>(a_pameasMinor), log);
      return;
    }
  if (isA(a_pameasMinor, pameasMinor_pameasVar3List))
    {
      adjustLevels(&pameasMinorSubs_pameasMinor_pameasVar3List,
		   "pameasMinor_pameasVar3List");
      if (log && !findString("pameasMinor_pameasVar3List", pameasMinorSubs))
	{
	  warnSub("pameasMinor_pameasVar3List", "pameasMinor", a_pameasMinor);
	  check_pameasMinor_pameasVar3List(
	    dynamic_cast<pameasMinor_pameasVar3List *>(a_pameasMinor), 0);
	}
      else
	check_pameasMinor_pameasVar3List(
	  dynamic_cast<pameasMinor_pameasVar3List *>(a_pameasMinor), log);
      return;
    }
}

/********************************************************************/

void check_pameasMinor_pameasVar2List(
 pameasMinor_pameasVar2List * a_pameasMinor_pameasVar2List,
 int log)
{
  if (a_pameasMinor_pameasVar2List->get_pameasVar2List())
    {
      std::list<pameasVar2ListItem *> * theList;
      std::list<pameasVar2ListItem *>::iterator iter;
      theList = a_pameasMinor_pameasVar2List->get_pameasVar2List();
      adjustLevels(&pameasMinor_pameasVar2ListAtts_a_pameasVar2List,
		   "pameasMinor_pameasVar2List a_pameasVar2List");
      if (log && !findString("a_pameasVar2List",
			     pameasMinor_pameasVar2ListAtts))
	{
	  warnAtt("a_pameasVar2List", "pameasMinor_pameasVar2List",
		  a_pameasMinor_pameasVar2List);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_pameasVar2ListItem(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_pameasVar2ListItem(*iter, log);
	}
    }
}

/********************************************************************/

void check_pameasMinor_pameasVar3List(
 pameasMinor_pameasVar3List * a_pameasMinor_pameasVar3List,
 int log)
{
  if (a_pameasMinor_pameasVar3List->get_pameasVar3List())
    {
      std::list<pameasVar3ListItem *> * theList;
      std::list<pameasVar3ListItem *>::iterator iter;
      theList = a_pameasMinor_pameasVar3List->get_pameasVar3List();
      adjustLevels(&pameasMinor_pameasVar3ListAtts_a_pameasVar3List,
		   "pameasMinor_pameasVar3List a_pameasVar3List");
      if (log && !findString("a_pameasVar3List",
			     pameasMinor_pameasVar3ListAtts))
	{
	  warnAtt("a_pameasVar3List", "pameasMinor_pameasVar3List",
		  a_pameasMinor_pameasVar3List);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_pameasVar3ListItem(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_pameasVar3ListItem(*iter, log);
	}
    }
}

/********************************************************************/

void check_pameasRemove(
 pameasRemove * a_pameasRemove,
 int log)
{
  if (isA(a_pameasRemove, pameasRemoveCount))
    {
      adjustLevels(&pameasRemoveSubs_pameasRemoveCount, "pameasRemoveCount");
      if (log && !findString("pameasRemoveCount", pameasRemoveSubs))
	{
	  warnSub("pameasRemoveCount", "pameasRemove", a_pameasRemove);
	  check_pameasRemoveCount(
	    dynamic_cast<pameasRemoveCount *>(a_pameasRemove), 0);
	}
      else
	check_pameasRemoveCount(
	  dynamic_cast<pameasRemoveCount *>(a_pameasRemove), log);
      return;
    }
  if (isA(a_pameasRemove, pameasRemoveDist))
    {
      adjustLevels(&pameasRemoveSubs_pameasRemoveDist, "pameasRemoveDist");
      if (log && !findString("pameasRemoveDist", pameasRemoveSubs))
	{
	  warnSub("pameasRemoveDist", "pameasRemove", a_pameasRemove);
	  check_pameasRemoveDist(
	    dynamic_cast<pameasRemoveDist *>(a_pameasRemove), 0);
	}
      else
	check_pameasRemoveDist(
	  dynamic_cast<pameasRemoveDist *>(a_pameasRemove), log);
      return;
    }
  if (isA(a_pameasRemove, pameasRemoveAll))
    {
      adjustLevels(&pameasRemoveSubs_pameasRemoveAll, "pameasRemoveAll");
      if (log && !findString("pameasRemoveAll", pameasRemoveSubs))
	{
	  warnSub("pameasRemoveAll", "pameasRemove", a_pameasRemove);
	}
      return;
    }
}

/********************************************************************/

void check_pameasRemoveCount(
 pameasRemoveCount * a_pameasRemoveCount,
 int log)
{
  if (a_pameasRemoveCount->get_numPt1())
    {
      adjustLevels(&pameasRemoveCountAtts_numPt1, "pameasRemoveCount numPt1");
      if (log && !findString("numPt1", pameasRemoveCountAtts))
	{
	  warnAtt("numPt1", "pameasRemoveCount", a_pameasRemoveCount);
	  check_intVal(a_pameasRemoveCount->get_numPt1(), 0);
	}
      else
	check_intVal(a_pameasRemoveCount->get_numPt1(), log);
    }
  if (a_pameasRemoveCount->get_numPt2())
    {
      adjustLevels(&pameasRemoveCountAtts_numPt2, "pameasRemoveCount numPt2");
      if (log && !findString("numPt2", pameasRemoveCountAtts))
	{
	  warnAtt("numPt2", "pameasRemoveCount", a_pameasRemoveCount);
	  check_intVal(a_pameasRemoveCount->get_numPt2(), 0);
	}
      else
	check_intVal(a_pameasRemoveCount->get_numPt2(), log);
    }
}

/********************************************************************/

void check_pameasRemoveDist(
 pameasRemoveDist * a_pameasRemoveDist,
 int log)
{
  if (a_pameasRemoveDist->get_dist1())
    {
      adjustLevels(&pameasRemoveDistAtts_dist1, "pameasRemoveDist dist1");
      if (log && !findString("dist1", pameasRemoveDistAtts))
	{
	  warnAtt("dist1", "pameasRemoveDist", a_pameasRemoveDist);
	  check_rentVal(a_pameasRemoveDist->get_dist1(), 0);
	}
      else
	check_rentVal(a_pameasRemoveDist->get_dist1(), log);
    }
  if (a_pameasRemoveDist->get_dist2())
    {
      adjustLevels(&pameasRemoveDistAtts_dist2, "pameasRemoveDist dist2");
      if (log && !findString("dist2", pameasRemoveDistAtts))
	{
	  warnAtt("dist2", "pameasRemoveDist", a_pameasRemoveDist);
	  check_rentVal(a_pameasRemoveDist->get_dist2(), 0);
	}
      else
	check_rentVal(a_pameasRemoveDist->get_dist2(), log);
    }
}

/********************************************************************/

void check_pameasStm(
 pameasStm * a_pameasStm,
 int log)
{
  if (a_pameasStm->get_pameasMinor())
    {
      adjustLevels(&pameasStmAtts_a_pameasMinor, "pameasStm a_pameasMinor");
      if (log && !findString("a_pameasMinor", pameasStmAtts))
	{
	  warnAtt("a_pameasMinor", "pameasStm", a_pameasStm);
	  check_pameasMinor(a_pameasStm->get_pameasMinor(), 0);
	}
      else
	check_pameasMinor(a_pameasStm->get_pameasMinor(), log);
    }
}

/********************************************************************/

void check_pameasVar2ListItem(
 pameasVar2ListItem * a_pameasVar2ListItem,
 int log)
{
  if (a_pameasVar2ListItem->get_pameasDetail())
    {
      adjustLevels(&pameasVar2ListItemAtts_a_pameasDetail,
		   "pameasVar2ListItem a_pameasDetail");
      if (log && !findString("a_pameasDetail", pameasVar2ListItemAtts))
	{
	  warnAtt("a_pameasDetail", "pameasVar2ListItem",
		  a_pameasVar2ListItem);
	  check_pameasDetail(a_pameasVar2ListItem->get_pameasDetail(), 0);
	}
      else
	check_pameasDetail(a_pameasVar2ListItem->get_pameasDetail(), log);
    }
  if (a_pameasVar2ListItem->get_pLabel())
    {
      adjustLevels(&pameasVar2ListItemAtts_a_pLabel,
		   "pameasVar2ListItem a_pLabel");
      if (log && !findString("a_pLabel", pameasVar2ListItemAtts))
	{
	  warnAtt("a_pLabel", "pameasVar2ListItem", a_pameasVar2ListItem);
	  check_pLabel(a_pameasVar2ListItem->get_pLabel(), 0);
	}
      else
	check_pLabel(a_pameasVar2ListItem->get_pLabel(), log);
    }
  if (a_pameasVar2ListItem->get_apprch())
    {
      adjustLevels(&pameasVar2ListItemAtts_apprch,
		   "pameasVar2ListItem apprch");
      if (log && !findString("apprch", pameasVar2ListItemAtts))
	{
	  warnAtt("apprch", "pameasVar2ListItem", a_pameasVar2ListItem);
	  check_vector(a_pameasVar2ListItem->get_apprch(), 0);
	}
      else
	check_vector(a_pameasVar2ListItem->get_apprch(), log);
    }
  if (a_pameasVar2ListItem->get_forceVec())
    {
      adjustLevels(&pameasVar2ListItemAtts_forceVec,
		   "pameasVar2ListItem forceVec");
      if (log && !findString("forceVec", pameasVar2ListItemAtts))
	{
	  warnAtt("forceVec", "pameasVar2ListItem", a_pameasVar2ListItem);
	  check_vector(a_pameasVar2ListItem->get_forceVec(), 0);
	}
      else
	check_vector(a_pameasVar2ListItem->get_forceVec(), log);
    }
  if (a_pameasVar2ListItem->get_forceOrDeflection())
    {
      adjustLevels(&pameasVar2ListItemAtts_a_forceOrDeflection,
		   "pameasVar2ListItem a_forceOrDeflection");
      if (log && !findString("a_forceOrDeflection", pameasVar2ListItemAtts))
	{
	  warnAtt("a_forceOrDeflection", "pameasVar2ListItem",
		  a_pameasVar2ListItem);
	  check_forceOrDeflection(
	    a_pameasVar2ListItem->get_forceOrDeflection(), 0);
	}
      else
	check_forceOrDeflection(
	  a_pameasVar2ListItem->get_forceOrDeflection(), log);
    }
  if (a_pameasVar2ListItem->get_pameasRemove())
    {
      adjustLevels(&pameasVar2ListItemAtts_a_pameasRemove,
		   "pameasVar2ListItem a_pameasRemove");
      if (log && !findString("a_pameasRemove", pameasVar2ListItemAtts))
	{
	  warnAtt("a_pameasRemove", "pameasVar2ListItem",
		  a_pameasVar2ListItem);
	  check_pameasRemove(a_pameasVar2ListItem->get_pameasRemove(), 0);
	}
      else
	check_pameasRemove(a_pameasVar2ListItem->get_pameasRemove(), log);
    }
  if (a_pameasVar2ListItem->get_rtLabel())
    {
      adjustLevels(&pameasVar2ListItemAtts_a_rtLabel,
		   "pameasVar2ListItem a_rtLabel");
      if (log && !findString("a_rtLabel", pameasVar2ListItemAtts))
	{
	  warnAtt("a_rtLabel", "pameasVar2ListItem", a_pameasVar2ListItem);
	  check_rtLabel(a_pameasVar2ListItem->get_rtLabel(), 0);
	}
      else
	check_rtLabel(a_pameasVar2ListItem->get_rtLabel(), log);
    }
}

/********************************************************************/

void check_pameasVar3ListItem(
 pameasVar3ListItem * a_pameasVar3ListItem,
 int log)
{
  if (a_pameasVar3ListItem->get_pLabel())
    {
      adjustLevels(&pameasVar3ListItemAtts_a_pLabel,
		   "pameasVar3ListItem a_pLabel");
      if (log && !findString("a_pLabel", pameasVar3ListItemAtts))
	{
	  warnAtt("a_pLabel", "pameasVar3ListItem", a_pameasVar3ListItem);
	  check_pLabel(a_pameasVar3ListItem->get_pLabel(), 0);
	}
      else
	check_pLabel(a_pameasVar3ListItem->get_pLabel(), log);
    }
  if (a_pameasVar3ListItem->get_apprch())
    {
      adjustLevels(&pameasVar3ListItemAtts_apprch,
		   "pameasVar3ListItem apprch");
      if (log && !findString("apprch", pameasVar3ListItemAtts))
	{
	  warnAtt("apprch", "pameasVar3ListItem", a_pameasVar3ListItem);
	  check_vector(a_pameasVar3ListItem->get_apprch(), 0);
	}
      else
	check_vector(a_pameasVar3ListItem->get_apprch(), log);
    }
  if (a_pameasVar3ListItem->get_forceVec())
    {
      adjustLevels(&pameasVar3ListItemAtts_forceVec,
		   "pameasVar3ListItem forceVec");
      if (log && !findString("forceVec", pameasVar3ListItemAtts))
	{
	  warnAtt("forceVec", "pameasVar3ListItem", a_pameasVar3ListItem);
	  check_vector(a_pameasVar3ListItem->get_forceVec(), 0);
	}
      else
	check_vector(a_pameasVar3ListItem->get_forceVec(), log);
    }
  if (a_pameasVar3ListItem->get_forceOrDeflection())
    {
      adjustLevels(&pameasVar3ListItemAtts_a_forceOrDeflection,
		   "pameasVar3ListItem a_forceOrDeflection");
      if (log && !findString("a_forceOrDeflection", pameasVar3ListItemAtts))
	{
	  warnAtt("a_forceOrDeflection", "pameasVar3ListItem",
		  a_pameasVar3ListItem);
	  check_forceOrDeflection(
	    a_pameasVar3ListItem->get_forceOrDeflection(), 0);
	}
      else
	check_forceOrDeflection(
	  a_pameasVar3ListItem->get_forceOrDeflection(), log);
    }
  if (a_pameasVar3ListItem->get_pameasRemove())
    {
      adjustLevels(&pameasVar3ListItemAtts_a_pameasRemove,
		   "pameasVar3ListItem a_pameasRemove");
      if (log && !findString("a_pameasRemove", pameasVar3ListItemAtts))
	{
	  warnAtt("a_pameasRemove", "pameasVar3ListItem",
		  a_pameasVar3ListItem);
	  check_pameasRemove(a_pameasVar3ListItem->get_pameasRemove(), 0);
	}
      else
	check_pameasRemove(a_pameasVar3ListItem->get_pameasRemove(), log);
    }
  if (a_pameasVar3ListItem->get_rtLabel())
    {
      adjustLevels(&pameasVar3ListItemAtts_a_rtLabel,
		   "pameasVar3ListItem a_rtLabel");
      if (log && !findString("a_rtLabel", pameasVar3ListItemAtts))
	{
	  warnAtt("a_rtLabel", "pameasVar3ListItem", a_pameasVar3ListItem);
	  check_rtLabel(a_pameasVar3ListItem->get_rtLabel(), 0);
	}
      else
	check_rtLabel(a_pameasVar3ListItem->get_rtLabel(), log);
    }
}

/********************************************************************/

void check_param(
 param * a_param,
 int log)
{
  if (isA(a_param, anyVal))
    {
      adjustLevels(&paramSubs_anyVal, "anyVal");
      if (log && !findString("anyVal", paramSubs))
	{
	  warnSub("anyVal", "param", a_param);
	  check_anyVal(dynamic_cast<anyVal *>(a_param), 0);
	}
      else
	check_anyVal(dynamic_cast<anyVal *>(a_param), log);
      return;
    }
}

/********************************************************************/

void check_partidStm(
 partidStm * a_partidStm,
 int log)
{
  if (a_partidStm->get_pnLabel())
    {
      adjustLevels(&partidStmAtts_a_pnLabel, "partidStm a_pnLabel");
      if (log && !findString("a_pnLabel", partidStmAtts))
	{
	  warnAtt("a_pnLabel", "partidStm", a_partidStm);
	  check_pnLabel(a_partidStm->get_pnLabel(), 0);
	}
      else
	check_pnLabel(a_partidStm->get_pnLabel(), log);
    }
  if (a_partidStm->get_text())
    {
      adjustLevels(&partidStmAtts_text, "partidStm text");
      if (log && !findString("text", partidStmAtts))
	{
	  warnAtt("text", "partidStm", a_partidStm);
	  check_stringVal(a_partidStm->get_text(), 0);
	}
      else
	check_stringVal(a_partidStm->get_text(), log);
    }
}

/********************************************************************/

void check_partoConst(
 partoConst * a_partoConst,
 int log)
{
  if (isA(a_partoConst, partoConstAct))
    {
      adjustLevels(&partoConstSubs_partoConstAct, "partoConstAct");
      if (log && !findString("partoConstAct", partoConstSubs))
	{
	  warnSub("partoConstAct", "partoConst", a_partoConst);
	  check_partoConstAct(
	    dynamic_cast<partoConstAct *>(a_partoConst), 0);
	}
      else
	check_partoConstAct(
	  dynamic_cast<partoConstAct *>(a_partoConst), log);
      return;
    }
  if (isA(a_partoConst, partoConstNom))
    {
      adjustLevels(&partoConstSubs_partoConstNom, "partoConstNom");
      if (log && !findString("partoConstNom", partoConstSubs))
	{
	  warnSub("partoConstNom", "partoConst", a_partoConst);
	  check_partoConstNom(
	    dynamic_cast<partoConstNom *>(a_partoConst), 0);
	}
      else
	check_partoConstNom(
	  dynamic_cast<partoConstNom *>(a_partoConst), log);
      return;
    }
}

/********************************************************************/

void check_partoConstAct(
 partoConstAct * a_partoConstAct,
 int log)
{
  if (a_partoConstAct->get_faLabel())
    {
      adjustLevels(&partoConstActAtts_a_faLabel, "partoConstAct a_faLabel");
      if (log && !findString("a_faLabel", partoConstActAtts))
	{
	  warnAtt("a_faLabel", "partoConstAct", a_partoConstAct);
	  check_faLabel(a_partoConstAct->get_faLabel(), 0);
	}
      else
	check_faLabel(a_partoConstAct->get_faLabel(), log);
    }
  if (a_partoConstAct->get_featureLabel())
    {
      adjustLevels(&partoConstActAtts_a_featureLabel,
		   "partoConstAct a_featureLabel");
      if (log && !findString("a_featureLabel", partoConstActAtts))
	{
	  warnAtt("a_featureLabel", "partoConstAct", a_partoConstAct);
	  check_featureLabel(a_partoConstAct->get_featureLabel(), 0);
	}
      else
	check_featureLabel(a_partoConstAct->get_featureLabel(), log);
    }
}

/********************************************************************/

void check_partoConstNom(
 partoConstNom * a_partoConstNom,
 int log)
{
  if (a_partoConstNom->get_fLabel())
    {
      adjustLevels(&partoConstNomAtts_a_fLabel, "partoConstNom a_fLabel");
      if (log && !findString("a_fLabel", partoConstNomAtts))
	{
	  warnAtt("a_fLabel", "partoConstNom", a_partoConstNom);
	  check_fLabel(a_partoConstNom->get_fLabel(), 0);
	}
      else
	check_fLabel(a_partoConstNom->get_fLabel(), log);
    }
  if (a_partoConstNom->get_faLabel())
    {
      adjustLevels(&partoConstNomAtts_a_faLabel, "partoConstNom a_faLabel");
      if (log && !findString("a_faLabel", partoConstNomAtts))
	{
	  warnAtt("a_faLabel", "partoConstNom", a_partoConstNom);
	  check_faLabel(a_partoConstNom->get_faLabel(), 0);
	}
      else
	check_faLabel(a_partoConstNom->get_faLabel(), log);
    }
}

/********************************************************************/

void check_partrvStm(
 partrvStm * a_partrvStm,
 int log)
{
  if (a_partrvStm->get_prLabel())
    {
      adjustLevels(&partrvStmAtts_a_prLabel, "partrvStm a_prLabel");
      if (log && !findString("a_prLabel", partrvStmAtts))
	{
	  warnAtt("a_prLabel", "partrvStm", a_partrvStm);
	  check_prLabel(a_partrvStm->get_prLabel(), 0);
	}
      else
	check_prLabel(a_partrvStm->get_prLabel(), log);
    }
  if (a_partrvStm->get_text())
    {
      adjustLevels(&partrvStmAtts_text, "partrvStm text");
      if (log && !findString("text", partrvStmAtts))
	{
	  warnAtt("text", "partrvStm", a_partrvStm);
	  check_stringVal(a_partrvStm->get_text(), 0);
	}
      else
	check_stringVal(a_partrvStm->get_text(), log);
    }
}

/********************************************************************/

void check_partsnStm(
 partsnStm * a_partsnStm,
 int log)
{
  if (a_partsnStm->get_psLabel())
    {
      adjustLevels(&partsnStmAtts_a_psLabel, "partsnStm a_psLabel");
      if (log && !findString("a_psLabel", partsnStmAtts))
	{
	  warnAtt("a_psLabel", "partsnStm", a_partsnStm);
	  check_psLabel(a_partsnStm->get_psLabel(), 0);
	}
      else
	check_psLabel(a_partsnStm->get_psLabel(), log);
    }
  if (a_partsnStm->get_text())
    {
      adjustLevels(&partsnStmAtts_text, "partsnStm text");
      if (log && !findString("text", partsnStmAtts))
	{
	  warnAtt("text", "partsnStm", a_partsnStm);
	  check_stringVal(a_partsnStm->get_text(), 0);
	}
      else
	check_stringVal(a_partsnStm->get_text(), log);
    }
}

/********************************************************************/

void check_pathArc(
 pathArc * a_pathArc,
 int log)
{
  if (a_pathArc->get_center())
    {
      adjustLevels(&pathArcAtts_center, "pathArc center");
      if (log && !findString("center", pathArcAtts))
	{
	  warnAtt("center", "pathArc", a_pathArc);
	  check_typePoint(a_pathArc->get_center(), 0);
	}
      else
	check_typePoint(a_pathArc->get_center(), log);
    }
  if (a_pathArc->get_planeVec())
    {
      adjustLevels(&pathArcAtts_planeVec, "pathArc planeVec");
      if (log && !findString("planeVec", pathArcAtts))
	{
	  warnAtt("planeVec", "pathArc", a_pathArc);
	  check_vector(a_pathArc->get_planeVec(), 0);
	}
      else
	check_vector(a_pathArc->get_planeVec(), log);
    }
  if (a_pathArc->get_radius())
    {
      adjustLevels(&pathArcAtts_radius, "pathArc radius");
      if (log && !findString("radius", pathArcAtts))
	{
	  warnAtt("radius", "pathArc", a_pathArc);
	  check_rentVal(a_pathArc->get_radius(), 0);
	}
      else
	check_rentVal(a_pathArc->get_radius(), log);
    }
  if (a_pathArc->get_startAngle())
    {
      adjustLevels(&pathArcAtts_startAngle, "pathArc startAngle");
      if (log && !findString("startAngle", pathArcAtts))
	{
	  warnAtt("startAngle", "pathArc", a_pathArc);
	  check_angle(a_pathArc->get_startAngle(), 0);
	}
      else
	check_angle(a_pathArc->get_startAngle(), log);
    }
  if (a_pathArc->get_includAngle())
    {
      adjustLevels(&pathArcAtts_includAngle, "pathArc includAngle");
      if (log && !findString("includAngle", pathArcAtts))
	{
	  warnAtt("includAngle", "pathArc", a_pathArc);
	  check_angle(a_pathArc->get_includAngle(), 0);
	}
      else
	check_angle(a_pathArc->get_includAngle(), log);
    }
  if (a_pathArc->get_startVec())
    {
      adjustLevels(&pathArcAtts_startVec, "pathArc startVec");
      if (log && !findString("startVec", pathArcAtts))
	{
	  warnAtt("startVec", "pathArc", a_pathArc);
	  check_vector(a_pathArc->get_startVec(), 0);
	}
      else
	check_vector(a_pathArc->get_startVec(), log);
    }
}

/********************************************************************/

void check_pathCurve(
 pathCurve * a_pathCurve,
 int log)
{
  if (isA(a_pathCurve, pathCurve_pathCurvePtdata))
    {
      adjustLevels(&pathCurveSubs_pathCurve_pathCurvePtdata,
		   "pathCurve_pathCurvePtdata");
      if (log && !findString("pathCurve_pathCurvePtdata", pathCurveSubs))
	{
	  warnSub("pathCurve_pathCurvePtdata", "pathCurve", a_pathCurve);
	  check_pathCurve_pathCurvePtdata(
	    dynamic_cast<pathCurve_pathCurvePtdata *>(a_pathCurve), 0);
	}
      else
	check_pathCurve_pathCurvePtdata(
	  dynamic_cast<pathCurve_pathCurvePtdata *>(a_pathCurve), log);
      return;
    }
  if (isA(a_pathCurve, pathCurve_pathCurvePoints))
    {
      adjustLevels(&pathCurveSubs_pathCurve_pathCurvePoints,
		   "pathCurve_pathCurvePoints");
      if (log && !findString("pathCurve_pathCurvePoints", pathCurveSubs))
	{
	  warnSub("pathCurve_pathCurvePoints", "pathCurve", a_pathCurve);
	  check_pathCurve_pathCurvePoints(
	    dynamic_cast<pathCurve_pathCurvePoints *>(a_pathCurve), 0);
	}
      else
	check_pathCurve_pathCurvePoints(
	  dynamic_cast<pathCurve_pathCurvePoints *>(a_pathCurve), log);
      return;
    }
}

/********************************************************************/

void check_pathCurvePoints(
 pathCurvePoints * a_pathCurvePoints,
 int log)
{
  if (a_pathCurvePoints->get_pointVecCart())
    {
      adjustLevels(&pathCurvePointsAtts_a_pointVecCart,
		   "pathCurvePoints a_pointVecCart");
      if (log && !findString("a_pointVecCart", pathCurvePointsAtts))
	{
	  warnAtt("a_pointVecCart", "pathCurvePoints", a_pathCurvePoints);
	  check_pointVecCart(a_pathCurvePoints->get_pointVecCart(), 0);
	}
      else
	check_pointVecCart(a_pathCurvePoints->get_pointVecCart(), log);
    }
  if (a_pathCurvePoints->get_pointVecCartList())
    {
      std::list<pointVecCart *> * theList;
      std::list<pointVecCart *>::iterator iter;
      theList = a_pathCurvePoints->get_pointVecCartList();
      adjustLevels(&pathCurvePointsAtts_a_pointVecCartList,
		   "pathCurvePoints a_pointVecCartList");
      if (log && !findString("a_pointVecCartList", pathCurvePointsAtts))
	{
	  warnAtt("a_pointVecCartList", "pathCurvePoints", a_pathCurvePoints);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_pointVecCart(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_pointVecCart(*iter, log);
	}
    }
}

/********************************************************************/

void check_pathCurvePtdata(
 pathCurvePtdata * a_pathCurvePtdata,
 int log)
{
  if (isA(a_pathCurvePtdata, curvePtdataPcs))
    {
      adjustLevels(&pathCurvePtdataSubs_curvePtdataPcs, "curvePtdataPcs");
      if (log && !findString("curvePtdataPcs", pathCurvePtdataSubs))
	{
	  warnSub("curvePtdataPcs", "pathCurvePtdata", a_pathCurvePtdata);
	  check_curvePtdataPcs(
	    dynamic_cast<curvePtdataPcs *>(a_pathCurvePtdata), 0);
	}
      else
	check_curvePtdataPcs(
	  dynamic_cast<curvePtdataPcs *>(a_pathCurvePtdata), log);
      return;
    }
  if (isA(a_pathCurvePtdata, curvePtdataHeadcs))
    {
      adjustLevels(&pathCurvePtdataSubs_curvePtdataHeadcs,
		   "curvePtdataHeadcs");
      if (log && !findString("curvePtdataHeadcs", pathCurvePtdataSubs))
	{
	  warnSub("curvePtdataHeadcs", "pathCurvePtdata", a_pathCurvePtdata);
	  check_curvePtdataHeadcs(
	    dynamic_cast<curvePtdataHeadcs *>(a_pathCurvePtdata), 0);
	}
      else
	check_curvePtdataHeadcs(
	  dynamic_cast<curvePtdataHeadcs *>(a_pathCurvePtdata), log);
      return;
    }
}

/********************************************************************/

void check_pathCurve_pathCurvePoints(
 pathCurve_pathCurvePoints * a_pathCurve_pathCurvePoints,
 int log)
{
  if (a_pathCurve_pathCurvePoints->get_pathCurvePoints())
    {
      adjustLevels(&pathCurve_pathCurvePointsAtts_a_pathCurvePoints,
		   "pathCurve_pathCurvePoints a_pathCurvePoints");
      if (log && !findString("a_pathCurvePoints",
			     pathCurve_pathCurvePointsAtts))
	{
	  warnAtt("a_pathCurvePoints", "pathCurve_pathCurvePoints",
		  a_pathCurve_pathCurvePoints);
	  check_pathCurvePoints(
	    a_pathCurve_pathCurvePoints->get_pathCurvePoints(), 0);
	}
      else
	check_pathCurvePoints(
	  a_pathCurve_pathCurvePoints->get_pathCurvePoints(), log);
    }
}

/********************************************************************/

void check_pathCurve_pathCurvePtdata(
 pathCurve_pathCurvePtdata * a_pathCurve_pathCurvePtdata,
 int log)
{
  if (a_pathCurve_pathCurvePtdata->get_pathCurvePtdata())
    {
      adjustLevels(&pathCurve_pathCurvePtdataAtts_a_pathCurvePtdata,
		   "pathCurve_pathCurvePtdata a_pathCurvePtdata");
      if (log && !findString("a_pathCurvePtdata",
			     pathCurve_pathCurvePtdataAtts))
	{
	  warnAtt("a_pathCurvePtdata", "pathCurve_pathCurvePtdata",
		  a_pathCurve_pathCurvePtdata);
	  check_pathCurvePtdata(
	    a_pathCurve_pathCurvePtdata->get_pathCurvePtdata(), 0);
	}
      else
	check_pathCurvePtdata(
	  a_pathCurve_pathCurvePtdata->get_pathCurvePtdata(), log);
    }
}

/********************************************************************/

void check_pathHelical(
 pathHelical * a_pathHelical,
 int log)
{
  if (a_pathHelical->get_center())
    {
      adjustLevels(&pathHelicalAtts_center, "pathHelical center");
      if (log && !findString("center", pathHelicalAtts))
	{
	  warnAtt("center", "pathHelical", a_pathHelical);
	  check_typePoint(a_pathHelical->get_center(), 0);
	}
      else
	check_typePoint(a_pathHelical->get_center(), log);
    }
  if (a_pathHelical->get_axisVec())
    {
      adjustLevels(&pathHelicalAtts_axisVec, "pathHelical axisVec");
      if (log && !findString("axisVec", pathHelicalAtts))
	{
	  warnAtt("axisVec", "pathHelical", a_pathHelical);
	  check_vector(a_pathHelical->get_axisVec(), 0);
	}
      else
	check_vector(a_pathHelical->get_axisVec(), log);
    }
  if (a_pathHelical->get_radius())
    {
      adjustLevels(&pathHelicalAtts_radius, "pathHelical radius");
      if (log && !findString("radius", pathHelicalAtts))
	{
	  warnAtt("radius", "pathHelical", a_pathHelical);
	  check_rentVal(a_pathHelical->get_radius(), 0);
	}
      else
	check_rentVal(a_pathHelical->get_radius(), log);
    }
  if (a_pathHelical->get_startAngle())
    {
      adjustLevels(&pathHelicalAtts_startAngle, "pathHelical startAngle");
      if (log && !findString("startAngle", pathHelicalAtts))
	{
	  warnAtt("startAngle", "pathHelical", a_pathHelical);
	  check_angle(a_pathHelical->get_startAngle(), 0);
	}
      else
	check_angle(a_pathHelical->get_startAngle(), log);
    }
  if (a_pathHelical->get_includAngle())
    {
      adjustLevels(&pathHelicalAtts_includAngle, "pathHelical includAngle");
      if (log && !findString("includAngle", pathHelicalAtts))
	{
	  warnAtt("includAngle", "pathHelical", a_pathHelical);
	  check_angle(a_pathHelical->get_includAngle(), 0);
	}
      else
	check_angle(a_pathHelical->get_includAngle(), log);
    }
  if (a_pathHelical->get_startVec())
    {
      adjustLevels(&pathHelicalAtts_startVec, "pathHelical startVec");
      if (log && !findString("startVec", pathHelicalAtts))
	{
	  warnAtt("startVec", "pathHelical", a_pathHelical);
	  check_vector(a_pathHelical->get_startVec(), 0);
	}
      else
	check_vector(a_pathHelical->get_startVec(), log);
    }
  if (a_pathHelical->get_pitch())
    {
      adjustLevels(&pathHelicalAtts_pitch, "pathHelical pitch");
      if (log && !findString("pitch", pathHelicalAtts))
	{
	  warnAtt("pitch", "pathHelical", a_pathHelical);
	  check_rentVal(a_pathHelical->get_pitch(), 0);
	}
      else
	check_rentVal(a_pathHelical->get_pitch(), log);
    }
  if (a_pathHelical->get_coneAngle())
    {
      adjustLevels(&pathHelicalAtts_coneAngle, "pathHelical coneAngle");
      if (log && !findString("coneAngle", pathHelicalAtts))
	{
	  warnAtt("coneAngle", "pathHelical", a_pathHelical);
	  check_angle(a_pathHelical->get_coneAngle(), 0);
	}
      else
	check_angle(a_pathHelical->get_coneAngle(), log);
    }
}

/********************************************************************/

void check_pathLine(
 pathLine * a_pathLine,
 int log)
{
  if (isA(a_pathLine, pathLineCart))
    {
      adjustLevels(&pathLineSubs_pathLineCart, "pathLineCart");
      if (log && !findString("pathLineCart", pathLineSubs))
	{
	  warnSub("pathLineCart", "pathLine", a_pathLine);
	  check_pathLineCart(dynamic_cast<pathLineCart *>(a_pathLine), 0);
	}
      else
	check_pathLineCart(dynamic_cast<pathLineCart *>(a_pathLine), log);
      return;
    }
  if (isA(a_pathLine, pathLinePol))
    {
      adjustLevels(&pathLineSubs_pathLinePol, "pathLinePol");
      if (log && !findString("pathLinePol", pathLineSubs))
	{
	  warnSub("pathLinePol", "pathLine", a_pathLine);
	  check_pathLinePol(dynamic_cast<pathLinePol *>(a_pathLine), 0);
	}
      else
	check_pathLinePol(dynamic_cast<pathLinePol *>(a_pathLine), log);
      return;
    }
}

/********************************************************************/

void check_pathLineCart(
 pathLineCart * a_pathLineCart,
 int log)
{
  if (a_pathLineCart->get_start())
    {
      adjustLevels(&pathLineCartAtts_start, "pathLineCart start");
      if (log && !findString("start", pathLineCartAtts))
	{
	  warnAtt("start", "pathLineCart", a_pathLineCart);
	  check_impCartPoint(a_pathLineCart->get_start(), 0);
	}
      else
	check_impCartPoint(a_pathLineCart->get_start(), log);
    }
  if (a_pathLineCart->get_startSpec())
    {
      adjustLevels(&pathLineCartAtts_startSpec, "pathLineCart startSpec");
      if (log && !findString("startSpec", pathLineCartAtts))
	{
	  warnAtt("startSpec", "pathLineCart", a_pathLineCart);
	  check_csSpec(a_pathLineCart->get_startSpec(), 0);
	}
      else
	check_csSpec(a_pathLineCart->get_startSpec(), log);
    }
  if (a_pathLineCart->get_end())
    {
      adjustLevels(&pathLineCartAtts_end, "pathLineCart end");
      if (log && !findString("end", pathLineCartAtts))
	{
	  warnAtt("end", "pathLineCart", a_pathLineCart);
	  check_impCartPoint(a_pathLineCart->get_end(), 0);
	}
      else
	check_impCartPoint(a_pathLineCart->get_end(), log);
    }
  if (a_pathLineCart->get_endSpec())
    {
      adjustLevels(&pathLineCartAtts_endSpec, "pathLineCart endSpec");
      if (log && !findString("endSpec", pathLineCartAtts))
	{
	  warnAtt("endSpec", "pathLineCart", a_pathLineCart);
	  check_csSpec(a_pathLineCart->get_endSpec(), 0);
	}
      else
	check_csSpec(a_pathLineCart->get_endSpec(), log);
    }
  if (a_pathLineCart->get_planeVec())
    {
      adjustLevels(&pathLineCartAtts_planeVec, "pathLineCart planeVec");
      if (log && !findString("planeVec", pathLineCartAtts))
	{
	  warnAtt("planeVec", "pathLineCart", a_pathLineCart);
	  check_vector(a_pathLineCart->get_planeVec(), 0);
	}
      else
	check_vector(a_pathLineCart->get_planeVec(), log);
    }
}

/********************************************************************/

void check_pathLinePol(
 pathLinePol * a_pathLinePol,
 int log)
{
  if (a_pathLinePol->get_start())
    {
      adjustLevels(&pathLinePolAtts_start, "pathLinePol start");
      if (log && !findString("start", pathLinePolAtts))
	{
	  warnAtt("start", "pathLinePol", a_pathLinePol);
	  check_impPolPoint(a_pathLinePol->get_start(), 0);
	}
      else
	check_impPolPoint(a_pathLinePol->get_start(), log);
    }
  if (a_pathLinePol->get_end())
    {
      adjustLevels(&pathLinePolAtts_end, "pathLinePol end");
      if (log && !findString("end", pathLinePolAtts))
	{
	  warnAtt("end", "pathLinePol", a_pathLinePol);
	  check_impPolPoint(a_pathLinePol->get_end(), 0);
	}
      else
	check_impPolPoint(a_pathLinePol->get_end(), log);
    }
  if (a_pathLinePol->get_planeVec())
    {
      adjustLevels(&pathLinePolAtts_planeVec, "pathLinePol planeVec");
      if (log && !findString("planeVec", pathLinePolAtts))
	{
	  warnAtt("planeVec", "pathLinePol", a_pathLinePol);
	  check_vector(a_pathLinePol->get_planeVec(), 0);
	}
      else
	check_vector(a_pathLinePol->get_planeVec(), log);
    }
}

/********************************************************************/

void check_pathMinor(
 pathMinor * a_pathMinor,
 int log)
{
  if (isA(a_pathMinor, pathPoint))
    {
      adjustLevels(&pathMinorSubs_pathPoint, "pathPoint");
      if (log && !findString("pathPoint", pathMinorSubs))
	{
	  warnSub("pathPoint", "pathMinor", a_pathMinor);
	  check_pathPoint(dynamic_cast<pathPoint *>(a_pathMinor), 0);
	}
      else
	check_pathPoint(dynamic_cast<pathPoint *>(a_pathMinor), log);
      return;
    }
  if (isA(a_pathMinor, pathArc))
    {
      adjustLevels(&pathMinorSubs_pathArc, "pathArc");
      if (log && !findString("pathArc", pathMinorSubs))
	{
	  warnSub("pathArc", "pathMinor", a_pathMinor);
	  check_pathArc(dynamic_cast<pathArc *>(a_pathMinor), 0);
	}
      else
	check_pathArc(dynamic_cast<pathArc *>(a_pathMinor), log);
      return;
    }
  if (isA(a_pathMinor, pathCurve))
    {
      adjustLevels(&pathMinorSubs_pathCurve, "pathCurve");
      if (log && !findString("pathCurve", pathMinorSubs))
	{
	  warnSub("pathCurve", "pathMinor", a_pathMinor);
	  check_pathCurve(dynamic_cast<pathCurve *>(a_pathMinor), 0);
	}
      else
	check_pathCurve(dynamic_cast<pathCurve *>(a_pathMinor), log);
      return;
    }
  if (isA(a_pathMinor, pathHelical))
    {
      adjustLevels(&pathMinorSubs_pathHelical, "pathHelical");
      if (log && !findString("pathHelical", pathMinorSubs))
	{
	  warnSub("pathHelical", "pathMinor", a_pathMinor);
	  check_pathHelical(dynamic_cast<pathHelical *>(a_pathMinor), 0);
	}
      else
	check_pathHelical(dynamic_cast<pathHelical *>(a_pathMinor), log);
      return;
    }
  if (isA(a_pathMinor, pathLine))
    {
      adjustLevels(&pathMinorSubs_pathLine, "pathLine");
      if (log && !findString("pathLine", pathMinorSubs))
	{
	  warnSub("pathLine", "pathMinor", a_pathMinor);
	  check_pathLine(dynamic_cast<pathLine *>(a_pathMinor), 0);
	}
      else
	check_pathLine(dynamic_cast<pathLine *>(a_pathMinor), log);
      return;
    }
  if (isA(a_pathMinor, pathSurface))
    {
      adjustLevels(&pathMinorSubs_pathSurface, "pathSurface");
      if (log && !findString("pathSurface", pathMinorSubs))
	{
	  warnSub("pathSurface", "pathMinor", a_pathMinor);
	  check_pathSurface(dynamic_cast<pathSurface *>(a_pathMinor), 0);
	}
      else
	check_pathSurface(dynamic_cast<pathSurface *>(a_pathMinor), log);
      return;
    }
  if (isA(a_pathMinor, pathUnknown))
    {
      adjustLevels(&pathMinorSubs_pathUnknown, "pathUnknown");
      if (log && !findString("pathUnknown", pathMinorSubs))
	{
	  warnSub("pathUnknown", "pathMinor", a_pathMinor);
	  check_pathUnknown(dynamic_cast<pathUnknown *>(a_pathMinor), 0);
	}
      else
	check_pathUnknown(dynamic_cast<pathUnknown *>(a_pathMinor), log);
      return;
    }
}

/********************************************************************/

void check_pathPoint(
 pathPoint * a_pathPoint,
 int log)
{
  if (a_pathPoint->get_typePoint())
    {
      adjustLevels(&pathPointAtts_a_typePoint, "pathPoint a_typePoint");
      if (log && !findString("a_typePoint", pathPointAtts))
	{
	  warnAtt("a_typePoint", "pathPoint", a_pathPoint);
	  check_typePoint(a_pathPoint->get_typePoint(), 0);
	}
      else
	check_typePoint(a_pathPoint->get_typePoint(), log);
    }
  if (a_pathPoint->get_dir())
    {
      adjustLevels(&pathPointAtts_dir, "pathPoint dir");
      if (log && !findString("dir", pathPointAtts))
	{
	  warnAtt("dir", "pathPoint", a_pathPoint);
	  check_vector(a_pathPoint->get_dir(), 0);
	}
      else
	check_vector(a_pathPoint->get_dir(), log);
    }
}

/********************************************************************/

void check_pathStm(
 pathStm * a_pathStm,
 int log)
{
  if (a_pathStm->get_pLabel())
    {
      adjustLevels(&pathStmAtts_a_pLabel, "pathStm a_pLabel");
      if (log && !findString("a_pLabel", pathStmAtts))
	{
	  warnAtt("a_pLabel", "pathStm", a_pathStm);
	  check_pLabel(a_pathStm->get_pLabel(), 0);
	}
      else
	check_pLabel(a_pathStm->get_pLabel(), log);
    }
  if (a_pathStm->get_pathMinor())
    {
      adjustLevels(&pathStmAtts_a_pathMinor, "pathStm a_pathMinor");
      if (log && !findString("a_pathMinor", pathStmAtts))
	{
	  warnAtt("a_pathMinor", "pathStm", a_pathStm);
	  check_pathMinor(a_pathStm->get_pathMinor(), 0);
	}
      else
	check_pathMinor(a_pathStm->get_pathMinor(), log);
    }
}

/********************************************************************/

void check_pathSurface(
 pathSurface * a_pathSurface,
 int log)
{
  if (isA(a_pathSurface, pathSurfacePlain))
    {
      adjustLevels(&pathSurfaceSubs_pathSurfacePlain, "pathSurfacePlain");
      if (log && !findString("pathSurfacePlain", pathSurfaceSubs))
	{
	  warnSub("pathSurfacePlain", "pathSurface", a_pathSurface);
	  check_pathSurfacePlain(
	    dynamic_cast<pathSurfacePlain *>(a_pathSurface), 0);
	}
      else
	check_pathSurfacePlain(
	  dynamic_cast<pathSurfacePlain *>(a_pathSurface), log);
      return;
    }
  if (isA(a_pathSurface, pathSurfacePcs))
    {
      adjustLevels(&pathSurfaceSubs_pathSurfacePcs, "pathSurfacePcs");
      if (log && !findString("pathSurfacePcs", pathSurfaceSubs))
	{
	  warnSub("pathSurfacePcs", "pathSurface", a_pathSurface);
	  check_pathSurfacePcs(
	    dynamic_cast<pathSurfacePcs *>(a_pathSurface), 0);
	}
      else
	check_pathSurfacePcs(
	  dynamic_cast<pathSurfacePcs *>(a_pathSurface), log);
      return;
    }
  if (isA(a_pathSurface, pathSurfacePcsData))
    {
      adjustLevels(&pathSurfaceSubs_pathSurfacePcsData, "pathSurfacePcsData");
      if (log && !findString("pathSurfacePcsData", pathSurfaceSubs))
	{
	  warnSub("pathSurfacePcsData", "pathSurface", a_pathSurface);
	  check_pathSurfacePcsData(
	    dynamic_cast<pathSurfacePcsData *>(a_pathSurface), 0);
	}
      else
	check_pathSurfacePcsData(
	  dynamic_cast<pathSurfacePcsData *>(a_pathSurface), log);
      return;
    }
  if (isA(a_pathSurface, pathSurfaceHeadcs))
    {
      adjustLevels(&pathSurfaceSubs_pathSurfaceHeadcs, "pathSurfaceHeadcs");
      if (log && !findString("pathSurfaceHeadcs", pathSurfaceSubs))
	{
	  warnSub("pathSurfaceHeadcs", "pathSurface", a_pathSurface);
	  check_pathSurfaceHeadcs(
	    dynamic_cast<pathSurfaceHeadcs *>(a_pathSurface), 0);
	}
      else
	check_pathSurfaceHeadcs(
	  dynamic_cast<pathSurfaceHeadcs *>(a_pathSurface), log);
      return;
    }
  if (isA(a_pathSurface, pathSurfaceHeadcsData))
    {
      adjustLevels(&pathSurfaceSubs_pathSurfaceHeadcsData,
		   "pathSurfaceHeadcsData");
      if (log && !findString("pathSurfaceHeadcsData", pathSurfaceSubs))
	{
	  warnSub("pathSurfaceHeadcsData", "pathSurface", a_pathSurface);
	  check_pathSurfaceHeadcsData(
	    dynamic_cast<pathSurfaceHeadcsData *>(a_pathSurface), 0);
	}
      else
	check_pathSurfaceHeadcsData(
	  dynamic_cast<pathSurfaceHeadcsData *>(a_pathSurface), log);
      return;
    }
}

/********************************************************************/

void check_pathSurfaceHeadcs(
 pathSurfaceHeadcs * a_pathSurfaceHeadcs,
 int log)
{
  if (a_pathSurfaceHeadcs->get_surfPtdataList())
    {
      std::list<surfPtdataListItem *> * theList;
      std::list<surfPtdataListItem *>::iterator iter;
      theList = a_pathSurfaceHeadcs->get_surfPtdataList();
      adjustLevels(&pathSurfaceHeadcsAtts_a_surfPtdataList,
		   "pathSurfaceHeadcs a_surfPtdataList");
      if (log && !findString("a_surfPtdataList", pathSurfaceHeadcsAtts))
	{
	  warnAtt("a_surfPtdataList", "pathSurfaceHeadcs",
		  a_pathSurfaceHeadcs);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_surfPtdataListItem(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_surfPtdataListItem(*iter, log);
	}
    }
  if (a_pathSurfaceHeadcs->get_rot1())
    {
      adjustLevels(&pathSurfaceHeadcsAtts_rot1, "pathSurfaceHeadcs rot1");
      if (log && !findString("rot1", pathSurfaceHeadcsAtts))
	{
	  warnAtt("rot1", "pathSurfaceHeadcs", a_pathSurfaceHeadcs);
	  check_rentVal(a_pathSurfaceHeadcs->get_rot1(), 0);
	}
      else
	check_rentVal(a_pathSurfaceHeadcs->get_rot1(), log);
    }
  if (a_pathSurfaceHeadcs->get_rot2())
    {
      adjustLevels(&pathSurfaceHeadcsAtts_rot2, "pathSurfaceHeadcs rot2");
      if (log && !findString("rot2", pathSurfaceHeadcsAtts))
	{
	  warnAtt("rot2", "pathSurfaceHeadcs", a_pathSurfaceHeadcs);
	  check_rentVal(a_pathSurfaceHeadcs->get_rot2(), 0);
	}
      else
	check_rentVal(a_pathSurfaceHeadcs->get_rot2(), log);
    }
  if (a_pathSurfaceHeadcs->get_rot3())
    {
      adjustLevels(&pathSurfaceHeadcsAtts_rot3, "pathSurfaceHeadcs rot3");
      if (log && !findString("rot3", pathSurfaceHeadcsAtts))
	{
	  warnAtt("rot3", "pathSurfaceHeadcs", a_pathSurfaceHeadcs);
	  check_rentVal(a_pathSurfaceHeadcs->get_rot3(), 0);
	}
      else
	check_rentVal(a_pathSurfaceHeadcs->get_rot3(), log);
    }
}

/********************************************************************/

void check_pathSurfaceHeadcsData(
 pathSurfaceHeadcsData * a_pathSurfaceHeadcsData,
 int log)
{
  if (a_pathSurfaceHeadcsData->get_surfPtdataList())
    {
      std::list<surfPtdataListItem *> * theList;
      std::list<surfPtdataListItem *>::iterator iter;
      theList = a_pathSurfaceHeadcsData->get_surfPtdataList();
      adjustLevels(&pathSurfaceHeadcsDataAtts_a_surfPtdataList,
		   "pathSurfaceHeadcsData a_surfPtdataList");
      if (log && !findString("a_surfPtdataList", pathSurfaceHeadcsDataAtts))
	{
	  warnAtt("a_surfPtdataList", "pathSurfaceHeadcsData",
		  a_pathSurfaceHeadcsData);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_surfPtdataListItem(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_surfPtdataListItem(*iter, log);
	}
    }
  if (a_pathSurfaceHeadcsData->get_rot1())
    {
      adjustLevels(&pathSurfaceHeadcsDataAtts_rot1,
		   "pathSurfaceHeadcsData rot1");
      if (log && !findString("rot1", pathSurfaceHeadcsDataAtts))
	{
	  warnAtt("rot1", "pathSurfaceHeadcsData", a_pathSurfaceHeadcsData);
	  check_rentVal(a_pathSurfaceHeadcsData->get_rot1(), 0);
	}
      else
	check_rentVal(a_pathSurfaceHeadcsData->get_rot1(), log);
    }
  if (a_pathSurfaceHeadcsData->get_rot2())
    {
      adjustLevels(&pathSurfaceHeadcsDataAtts_rot2,
		   "pathSurfaceHeadcsData rot2");
      if (log && !findString("rot2", pathSurfaceHeadcsDataAtts))
	{
	  warnAtt("rot2", "pathSurfaceHeadcsData", a_pathSurfaceHeadcsData);
	  check_rentVal(a_pathSurfaceHeadcsData->get_rot2(), 0);
	}
      else
	check_rentVal(a_pathSurfaceHeadcsData->get_rot2(), log);
    }
  if (a_pathSurfaceHeadcsData->get_rot3())
    {
      adjustLevels(&pathSurfaceHeadcsDataAtts_rot3,
		   "pathSurfaceHeadcsData rot3");
      if (log && !findString("rot3", pathSurfaceHeadcsDataAtts))
	{
	  warnAtt("rot3", "pathSurfaceHeadcsData", a_pathSurfaceHeadcsData);
	  check_rentVal(a_pathSurfaceHeadcsData->get_rot3(), 0);
	}
      else
	check_rentVal(a_pathSurfaceHeadcsData->get_rot3(), log);
    }
  if (a_pathSurfaceHeadcsData->get_surfPtdataHeadcsList())
    {
      std::list<surfPtdataHeadcsListItem *> * theList;
      std::list<surfPtdataHeadcsListItem *>::iterator iter;
      theList = a_pathSurfaceHeadcsData->get_surfPtdataHeadcsList();
      adjustLevels(&pathSurfaceHeadcsDataAtts_a_surfPtdataHeadcsList,
		   "pathSurfaceHeadcsData a_surfPtdataHeadcsList");
      if (log && !findString("a_surfPtdataHeadcsList",
			     pathSurfaceHeadcsDataAtts))
	{
	  warnAtt("a_surfPtdataHeadcsList", "pathSurfaceHeadcsData",
		  a_pathSurfaceHeadcsData);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_surfPtdataHeadcsListItem(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_surfPtdataHeadcsListItem(*iter, log);
	}
    }
}

/********************************************************************/

void check_pathSurfacePcs(
 pathSurfacePcs * a_pathSurfacePcs,
 int log)
{
  if (a_pathSurfacePcs->get_surfPtdataList())
    {
      std::list<surfPtdataListItem *> * theList;
      std::list<surfPtdataListItem *>::iterator iter;
      theList = a_pathSurfacePcs->get_surfPtdataList();
      adjustLevels(&pathSurfacePcsAtts_a_surfPtdataList,
		   "pathSurfacePcs a_surfPtdataList");
      if (log && !findString("a_surfPtdataList", pathSurfacePcsAtts))
	{
	  warnAtt("a_surfPtdataList", "pathSurfacePcs", a_pathSurfacePcs);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_surfPtdataListItem(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_surfPtdataListItem(*iter, log);
	}
    }
  if (a_pathSurfacePcs->get_euler())
    {
      adjustLevels(&pathSurfacePcsAtts_a_euler, "pathSurfacePcs a_euler");
      if (log && !findString("a_euler", pathSurfacePcsAtts))
	{
	  warnAtt("a_euler", "pathSurfacePcs", a_pathSurfacePcs);
	  check_euler(a_pathSurfacePcs->get_euler(), 0);
	}
      else
	check_euler(a_pathSurfacePcs->get_euler(), log);
    }
}

/********************************************************************/

void check_pathSurfacePcsData(
 pathSurfacePcsData * a_pathSurfacePcsData,
 int log)
{
  if (a_pathSurfacePcsData->get_surfPtdataList())
    {
      std::list<surfPtdataListItem *> * theList;
      std::list<surfPtdataListItem *>::iterator iter;
      theList = a_pathSurfacePcsData->get_surfPtdataList();
      adjustLevels(&pathSurfacePcsDataAtts_a_surfPtdataList,
		   "pathSurfacePcsData a_surfPtdataList");
      if (log && !findString("a_surfPtdataList", pathSurfacePcsDataAtts))
	{
	  warnAtt("a_surfPtdataList", "pathSurfacePcsData",
		  a_pathSurfacePcsData);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_surfPtdataListItem(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_surfPtdataListItem(*iter, log);
	}
    }
  if (a_pathSurfacePcsData->get_euler())
    {
      adjustLevels(&pathSurfacePcsDataAtts_a_euler,
		   "pathSurfacePcsData a_euler");
      if (log && !findString("a_euler", pathSurfacePcsDataAtts))
	{
	  warnAtt("a_euler", "pathSurfacePcsData", a_pathSurfacePcsData);
	  check_euler(a_pathSurfacePcsData->get_euler(), 0);
	}
      else
	check_euler(a_pathSurfacePcsData->get_euler(), log);
    }
  if (a_pathSurfacePcsData->get_surfPtdataPcsList())
    {
      std::list<surfPtdataPcsListItem *> * theList;
      std::list<surfPtdataPcsListItem *>::iterator iter;
      theList = a_pathSurfacePcsData->get_surfPtdataPcsList();
      adjustLevels(&pathSurfacePcsDataAtts_a_surfPtdataPcsList,
		   "pathSurfacePcsData a_surfPtdataPcsList");
      if (log && !findString("a_surfPtdataPcsList", pathSurfacePcsDataAtts))
	{
	  warnAtt("a_surfPtdataPcsList", "pathSurfacePcsData",
		  a_pathSurfacePcsData);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_surfPtdataPcsListItem(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_surfPtdataPcsListItem(*iter, log);
	}
    }
}

/********************************************************************/

void check_pathSurfacePlain(
 pathSurfacePlain * a_pathSurfacePlain,
 int log)
{
  if (a_pathSurfacePlain->get_surfPtdataList())
    {
      std::list<surfPtdataListItem *> * theList;
      std::list<surfPtdataListItem *>::iterator iter;
      theList = a_pathSurfacePlain->get_surfPtdataList();
      adjustLevels(&pathSurfacePlainAtts_a_surfPtdataList,
		   "pathSurfacePlain a_surfPtdataList");
      if (log && !findString("a_surfPtdataList", pathSurfacePlainAtts))
	{
	  warnAtt("a_surfPtdataList", "pathSurfacePlain", a_pathSurfacePlain);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_surfPtdataListItem(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_surfPtdataListItem(*iter, log);
	}
    }
}

/********************************************************************/

void check_pathUnknown(
 pathUnknown * a_pathUnknown,
 int log)
{
  if (a_pathUnknown->get_start())
    {
      adjustLevels(&pathUnknownAtts_start, "pathUnknown start");
      if (log && !findString("start", pathUnknownAtts))
	{
	  warnAtt("start", "pathUnknown", a_pathUnknown);
	  check_impCartPoint(a_pathUnknown->get_start(), 0);
	}
      else
	check_impCartPoint(a_pathUnknown->get_start(), log);
    }
  if (a_pathUnknown->get_direction())
    {
      adjustLevels(&pathUnknownAtts_direction, "pathUnknown direction");
      if (log && !findString("direction", pathUnknownAtts))
	{
	  warnAtt("direction", "pathUnknown", a_pathUnknown);
	  check_impCartPoint(a_pathUnknown->get_direction(), 0);
	}
      else
	check_impCartPoint(a_pathUnknown->get_direction(), log);
    }
  if (a_pathUnknown->get_end())
    {
      adjustLevels(&pathUnknownAtts_end, "pathUnknown end");
      if (log && !findString("end", pathUnknownAtts))
	{
	  warnAtt("end", "pathUnknown", a_pathUnknown);
	  check_impCartPoint(a_pathUnknown->get_end(), 0);
	}
      else
	check_impCartPoint(a_pathUnknown->get_end(), log);
    }
  if (a_pathUnknown->get_planeVec())
    {
      adjustLevels(&pathUnknownAtts_planeVec, "pathUnknown planeVec");
      if (log && !findString("planeVec", pathUnknownAtts))
	{
	  warnAtt("planeVec", "pathUnknown", a_pathUnknown);
	  check_vector(a_pathUnknown->get_planeVec(), 0);
	}
      else
	check_vector(a_pathUnknown->get_planeVec(), log);
    }
}

/********************************************************************/

void check_pcLabel(
 pcLabel * a_pcLabel,
 int log)
{
  if (a_pcLabel->get_labelName())
    {
      adjustLevels(&pcLabelAtts_a_labelName, "pcLabel a_labelName");
      if (log && !findString("a_labelName", pcLabelAtts))
	{
	  warnAtt("a_labelName", "pcLabel", a_pcLabel);
	  check_labelName(a_pcLabel->get_labelName(), 0);
	}
      else
	check_labelName(a_pcLabel->get_labelName(), log);
    }
}

/********************************************************************/

void check_perptoConst(
 perptoConst * a_perptoConst,
 int log)
{
  if (isA(a_perptoConst, perptoConstAct))
    {
      adjustLevels(&perptoConstSubs_perptoConstAct, "perptoConstAct");
      if (log && !findString("perptoConstAct", perptoConstSubs))
	{
	  warnSub("perptoConstAct", "perptoConst", a_perptoConst);
	  check_perptoConstAct(
	    dynamic_cast<perptoConstAct *>(a_perptoConst), 0);
	}
      else
	check_perptoConstAct(
	  dynamic_cast<perptoConstAct *>(a_perptoConst), log);
      return;
    }
  if (isA(a_perptoConst, perptoConstNom))
    {
      adjustLevels(&perptoConstSubs_perptoConstNom, "perptoConstNom");
      if (log && !findString("perptoConstNom", perptoConstSubs))
	{
	  warnSub("perptoConstNom", "perptoConst", a_perptoConst);
	  check_perptoConstNom(
	    dynamic_cast<perptoConstNom *>(a_perptoConst), 0);
	}
      else
	check_perptoConstNom(
	  dynamic_cast<perptoConstNom *>(a_perptoConst), log);
      return;
    }
}

/********************************************************************/

void check_perptoConstAct(
 perptoConstAct * a_perptoConstAct,
 int log)
{
  if (a_perptoConstAct->get_faLabel())
    {
      adjustLevels(&perptoConstActAtts_a_faLabel, "perptoConstAct a_faLabel");
      if (log && !findString("a_faLabel", perptoConstActAtts))
	{
	  warnAtt("a_faLabel", "perptoConstAct", a_perptoConstAct);
	  check_faLabel(a_perptoConstAct->get_faLabel(), 0);
	}
      else
	check_faLabel(a_perptoConstAct->get_faLabel(), log);
    }
  if (a_perptoConstAct->get_featureLabel())
    {
      adjustLevels(&perptoConstActAtts_a_featureLabel,
		   "perptoConstAct a_featureLabel");
      if (log && !findString("a_featureLabel", perptoConstActAtts))
	{
	  warnAtt("a_featureLabel", "perptoConstAct", a_perptoConstAct);
	  check_featureLabel(a_perptoConstAct->get_featureLabel(), 0);
	}
      else
	check_featureLabel(a_perptoConstAct->get_featureLabel(), log);
    }
}

/********************************************************************/

void check_perptoConstNom(
 perptoConstNom * a_perptoConstNom,
 int log)
{
  if (a_perptoConstNom->get_fLabel())
    {
      adjustLevels(&perptoConstNomAtts_a_fLabel, "perptoConstNom a_fLabel");
      if (log && !findString("a_fLabel", perptoConstNomAtts))
	{
	  warnAtt("a_fLabel", "perptoConstNom", a_perptoConstNom);
	  check_fLabel(a_perptoConstNom->get_fLabel(), 0);
	}
      else
	check_fLabel(a_perptoConstNom->get_fLabel(), log);
    }
  if (a_perptoConstNom->get_faLabel())
    {
      adjustLevels(&perptoConstNomAtts_a_faLabel, "perptoConstNom a_faLabel");
      if (log && !findString("a_faLabel", perptoConstNomAtts))
	{
	  warnAtt("a_faLabel", "perptoConstNom", a_perptoConstNom);
	  check_faLabel(a_perptoConstNom->get_faLabel(), 0);
	}
      else
	check_faLabel(a_perptoConstNom->get_faLabel(), log);
    }
}

/********************************************************************/

void check_pierceConst(
 pierceConst * a_pierceConst,
 int log)
{
  if (a_pierceConst->get_faLabel())
    {
      adjustLevels(&pierceConstAtts_a_faLabel, "pierceConst a_faLabel");
      if (log && !findString("a_faLabel", pierceConstAtts))
	{
	  warnAtt("a_faLabel", "pierceConst", a_pierceConst);
	  check_faLabel(a_pierceConst->get_faLabel(), 0);
	}
      else
	check_faLabel(a_pierceConst->get_faLabel(), log);
    }
  if (a_pierceConst->get_featureLabel())
    {
      adjustLevels(&pierceConstAtts_a_featureLabel,
		   "pierceConst a_featureLabel");
      if (log && !findString("a_featureLabel", pierceConstAtts))
	{
	  warnAtt("a_featureLabel", "pierceConst", a_pierceConst);
	  check_featureLabel(a_pierceConst->get_featureLabel(), 0);
	}
      else
	check_featureLabel(a_pierceConst->get_featureLabel(), log);
    }
}

/********************************************************************/

void check_plLabel(
 plLabel * a_plLabel,
 int log)
{
  if (a_plLabel->get_labelName())
    {
      adjustLevels(&plLabelAtts_a_labelName, "plLabel a_labelName");
      if (log && !findString("a_labelName", plLabelAtts))
	{
	  warnAtt("a_labelName", "plLabel", a_plLabel);
	  check_labelName(a_plLabel->get_labelName(), 0);
	}
      else
	check_labelName(a_plLabel->get_labelName(), log);
    }
}

/********************************************************************/

void check_plan(
 plan * a_plan,
 int log)
{
  if (isA(a_plan, plan_XYPLAN))
    {
      adjustLevels(&planSubs_plan_XYPLAN, "plan_XYPLAN");
      if (log && !findString("plan_XYPLAN", planSubs))
	{
	  warnSub("plan_XYPLAN", "plan", a_plan);
	}
      return;
    }
  if (isA(a_plan, plan_YZPLAN))
    {
      adjustLevels(&planSubs_plan_YZPLAN, "plan_YZPLAN");
      if (log && !findString("plan_YZPLAN", planSubs))
	{
	  warnSub("plan_YZPLAN", "plan", a_plan);
	}
      return;
    }
  if (isA(a_plan, plan_ZXPLAN))
    {
      adjustLevels(&planSubs_plan_ZXPLAN, "plan_ZXPLAN");
      if (log && !findString("plan_ZXPLAN", planSubs))
	{
	  warnSub("plan_ZXPLAN", "plan", a_plan);
	}
      return;
    }
}

/********************************************************************/

void check_planidStm(
 planidStm * a_planidStm,
 int log)
{
  if (a_planidStm->get_plLabel())
    {
      adjustLevels(&planidStmAtts_a_plLabel, "planidStm a_plLabel");
      if (log && !findString("a_plLabel", planidStmAtts))
	{
	  warnAtt("a_plLabel", "planidStm", a_planidStm);
	  check_plLabel(a_planidStm->get_plLabel(), 0);
	}
      else
	check_plLabel(a_planidStm->get_plLabel(), log);
    }
  if (a_planidStm->get_text())
    {
      adjustLevels(&planidStmAtts_text, "planidStm text");
      if (log && !findString("text", planidStmAtts))
	{
	  warnAtt("text", "planidStm", a_planidStm);
	  check_stringVal(a_planidStm->get_text(), 0);
	}
      else
	check_stringVal(a_planidStm->get_text(), log);
    }
}

/********************************************************************/

void check_pnLabel(
 pnLabel * a_pnLabel,
 int log)
{
  if (a_pnLabel->get_labelName())
    {
      adjustLevels(&pnLabelAtts_a_labelName, "pnLabel a_labelName");
      if (log && !findString("a_labelName", pnLabelAtts))
	{
	  warnAtt("a_labelName", "pnLabel", a_pnLabel);
	  check_labelName(a_pnLabel->get_labelName(), 0);
	}
      else
	check_labelName(a_pnLabel->get_labelName(), log);
    }
}

/********************************************************************/

void check_pointRange(
 pointRange * a_pointRange,
 int log)
{
  if (a_pointRange->get_index1())
    {
      adjustLevels(&pointRangeAtts_index1, "pointRange index1");
      if (log && !findString("index1", pointRangeAtts))
	{
	  warnAtt("index1", "pointRange", a_pointRange);
	  check_intVal(a_pointRange->get_index1(), 0);
	}
      else
	check_intVal(a_pointRange->get_index1(), log);
    }
  if (a_pointRange->get_index2())
    {
      adjustLevels(&pointRangeAtts_index2, "pointRange index2");
      if (log && !findString("index2", pointRangeAtts))
	{
	  warnAtt("index2", "pointRange", a_pointRange);
	  check_intVal(a_pointRange->get_index2(), 0);
	}
      else
	check_intVal(a_pointRange->get_index2(), log);
    }
}

/********************************************************************/

void check_pointVecCart(
 pointVecCart * a_pointVecCart,
 int log)
{
  if (a_pointVecCart->get_x())
    {
      adjustLevels(&pointVecCartAtts_x, "pointVecCart x");
      if (log && !findString("x", pointVecCartAtts))
	{
	  warnAtt("x", "pointVecCart", a_pointVecCart);
	  check_rentVal(a_pointVecCart->get_x(), 0);
	}
      else
	check_rentVal(a_pointVecCart->get_x(), log);
    }
  if (a_pointVecCart->get_y())
    {
      adjustLevels(&pointVecCartAtts_y, "pointVecCart y");
      if (log && !findString("y", pointVecCartAtts))
	{
	  warnAtt("y", "pointVecCart", a_pointVecCart);
	  check_rentVal(a_pointVecCart->get_y(), 0);
	}
      else
	check_rentVal(a_pointVecCart->get_y(), log);
    }
  if (a_pointVecCart->get_z())
    {
      adjustLevels(&pointVecCartAtts_z, "pointVecCart z");
      if (log && !findString("z", pointVecCartAtts))
	{
	  warnAtt("z", "pointVecCart", a_pointVecCart);
	  check_rentVal(a_pointVecCart->get_z(), 0);
	}
      else
	check_rentVal(a_pointVecCart->get_z(), log);
    }
  if (a_pointVecCart->get_i())
    {
      adjustLevels(&pointVecCartAtts_i, "pointVecCart i");
      if (log && !findString("i", pointVecCartAtts))
	{
	  warnAtt("i", "pointVecCart", a_pointVecCart);
	  check_rentVal(a_pointVecCart->get_i(), 0);
	}
      else
	check_rentVal(a_pointVecCart->get_i(), log);
    }
  if (a_pointVecCart->get_j())
    {
      adjustLevels(&pointVecCartAtts_j, "pointVecCart j");
      if (log && !findString("j", pointVecCartAtts))
	{
	  warnAtt("j", "pointVecCart", a_pointVecCart);
	  check_rentVal(a_pointVecCart->get_j(), 0);
	}
      else
	check_rentVal(a_pointVecCart->get_j(), log);
    }
  if (a_pointVecCart->get_k())
    {
      adjustLevels(&pointVecCartAtts_k, "pointVecCart k");
      if (log && !findString("k", pointVecCartAtts))
	{
	  warnAtt("k", "pointVecCart", a_pointVecCart);
	  check_rentVal(a_pointVecCart->get_k(), 0);
	}
      else
	check_rentVal(a_pointVecCart->get_k(), log);
    }
}

/********************************************************************/

void check_pointVecPol(
 pointVecPol * a_pointVecPol,
 int log)
{
  if (a_pointVecPol->get_r())
    {
      adjustLevels(&pointVecPolAtts_r, "pointVecPol r");
      if (log && !findString("r", pointVecPolAtts))
	{
	  warnAtt("r", "pointVecPol", a_pointVecPol);
	  check_rentVal(a_pointVecPol->get_r(), 0);
	}
      else
	check_rentVal(a_pointVecPol->get_r(), log);
    }
  if (a_pointVecPol->get_a())
    {
      adjustLevels(&pointVecPolAtts_a, "pointVecPol a");
      if (log && !findString("a", pointVecPolAtts))
	{
	  warnAtt("a", "pointVecPol", a_pointVecPol);
	  check_rentVal(a_pointVecPol->get_a(), 0);
	}
      else
	check_rentVal(a_pointVecPol->get_a(), log);
    }
  if (a_pointVecPol->get_h())
    {
      adjustLevels(&pointVecPolAtts_h, "pointVecPol h");
      if (log && !findString("h", pointVecPolAtts))
	{
	  warnAtt("h", "pointVecPol", a_pointVecPol);
	  check_rentVal(a_pointVecPol->get_h(), 0);
	}
      else
	check_rentVal(a_pointVecPol->get_h(), log);
    }
  if (a_pointVecPol->get_i())
    {
      adjustLevels(&pointVecPolAtts_i, "pointVecPol i");
      if (log && !findString("i", pointVecPolAtts))
	{
	  warnAtt("i", "pointVecPol", a_pointVecPol);
	  check_rentVal(a_pointVecPol->get_i(), 0);
	}
      else
	check_rentVal(a_pointVecPol->get_i(), log);
    }
  if (a_pointVecPol->get_j())
    {
      adjustLevels(&pointVecPolAtts_j, "pointVecPol j");
      if (log && !findString("j", pointVecPolAtts))
	{
	  warnAtt("j", "pointVecPol", a_pointVecPol);
	  check_rentVal(a_pointVecPol->get_j(), 0);
	}
      else
	check_rentVal(a_pointVecPol->get_j(), log);
    }
  if (a_pointVecPol->get_k())
    {
      adjustLevels(&pointVecPolAtts_k, "pointVecPol k");
      if (log && !findString("k", pointVecPolAtts))
	{
	  warnAtt("k", "pointVecPol", a_pointVecPol);
	  check_rentVal(a_pointVecPol->get_k(), 0);
	}
      else
	check_rentVal(a_pointVecPol->get_k(), log);
    }
}

/********************************************************************/

void check_polPoint(
 polPoint * a_polPoint,
 int log)
{
  if (a_polPoint->get_r())
    {
      adjustLevels(&polPointAtts_r, "polPoint r");
      if (log && !findString("r", polPointAtts))
	{
	  warnAtt("r", "polPoint", a_polPoint);
	  check_rentVal(a_polPoint->get_r(), 0);
	}
      else
	check_rentVal(a_polPoint->get_r(), log);
    }
  if (a_polPoint->get_a())
    {
      adjustLevels(&polPointAtts_a, "polPoint a");
      if (log && !findString("a", polPointAtts))
	{
	  warnAtt("a", "polPoint", a_polPoint);
	  check_rentVal(a_polPoint->get_a(), 0);
	}
      else
	check_rentVal(a_polPoint->get_a(), log);
    }
  if (a_polPoint->get_h())
    {
      adjustLevels(&polPointAtts_h, "polPoint h");
      if (log && !findString("h", polPointAtts))
	{
	  warnAtt("h", "polPoint", a_polPoint);
	  check_rentVal(a_polPoint->get_h(), 0);
	}
      else
	check_rentVal(a_polPoint->get_h(), log);
    }
}

/********************************************************************/

void check_popStm(
 popStm * a_popStm,
 int log)
{
  if (a_popStm->get_stackElementList())
    {
      std::list<stackElement *> * theList;
      std::list<stackElement *>::iterator iter;
      theList = a_popStm->get_stackElementList();
      adjustLevels(&popStmAtts_a_stackElementList,
		   "popStm a_stackElementList");
      if (log && !findString("a_stackElementList", popStmAtts))
	{
	  warnAtt("a_stackElementList", "popStm", a_popStm);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_stackElement(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_stackElement(*iter, log);
	}
    }
}

/********************************************************************/

void check_posDir(
 posDir * a_posDir,
 int log)
{
  if (isA(a_posDir, posDir_XDIR))
    {
      adjustLevels(&posDirSubs_posDir_XDIR, "posDir_XDIR");
      if (log && !findString("posDir_XDIR", posDirSubs))
	{
	  warnSub("posDir_XDIR", "posDir", a_posDir);
	}
      return;
    }
  if (isA(a_posDir, posDir_YDIR))
    {
      adjustLevels(&posDirSubs_posDir_YDIR, "posDir_YDIR");
      if (log && !findString("posDir_YDIR", posDirSubs))
	{
	  warnSub("posDir_YDIR", "posDir", a_posDir);
	}
      return;
    }
  if (isA(a_posDir, posDir_ZDIR))
    {
      adjustLevels(&posDirSubs_posDir_ZDIR, "posDir_ZDIR");
      if (log && !findString("posDir_ZDIR", posDirSubs))
	{
	  warnSub("posDir_ZDIR", "posDir", a_posDir);
	}
      return;
    }
}

/********************************************************************/

void check_prLabel(
 prLabel * a_prLabel,
 int log)
{
  if (a_prLabel->get_labelName())
    {
      adjustLevels(&prLabelAtts_a_labelName, "prLabel a_labelName");
      if (log && !findString("a_labelName", prLabelAtts))
	{
	  warnAtt("a_labelName", "prLabel", a_prLabel);
	  check_labelName(a_prLabel->get_labelName(), 0);
	}
      else
	check_labelName(a_prLabel->get_labelName(), log);
    }
}

/********************************************************************/

void check_prcompStm(
 prcompStm * a_prcompStm,
 int log)
{
  if (a_prcompStm->get_state())
    {
      adjustLevels(&prcompStmAtts_a_state, "prcompStm a_state");
      if (log && !findString("a_state", prcompStmAtts))
	{
	  warnAtt("a_state", "prcompStm", a_prcompStm);
	  check_state(a_prcompStm->get_state(), 0);
	}
      else
	check_state(a_prcompStm->get_state(), log);
    }
}

/********************************************************************/

void check_prevopStm(
 prevopStm * a_prevopStm,
 int log)
{
  if (a_prevopStm->get_pvLabel())
    {
      adjustLevels(&prevopStmAtts_a_pvLabel, "prevopStm a_pvLabel");
      if (log && !findString("a_pvLabel", prevopStmAtts))
	{
	  warnAtt("a_pvLabel", "prevopStm", a_prevopStm);
	  check_pvLabel(a_prevopStm->get_pvLabel(), 0);
	}
      else
	check_pvLabel(a_prevopStm->get_pvLabel(), log);
    }
  if (a_prevopStm->get_text())
    {
      adjustLevels(&prevopStmAtts_text, "prevopStm text");
      if (log && !findString("text", prevopStmAtts))
	{
	  warnAtt("text", "prevopStm", a_prevopStm);
	  check_stringVal(a_prevopStm->get_text(), 0);
	}
      else
	check_stringVal(a_prevopStm->get_text(), log);
    }
}

/********************************************************************/

void check_probeLocCart(
 probeLocCart * a_probeLocCart,
 int log)
{
  if (a_probeLocCart->get_distVec())
    {
      adjustLevels(&probeLocCartAtts_distVec, "probeLocCart distVec");
      if (log && !findString("distVec", probeLocCartAtts))
	{
	  warnAtt("distVec", "probeLocCart", a_probeLocCart);
	  check_vector(a_probeLocCart->get_distVec(), 0);
	}
      else
	check_vector(a_probeLocCart->get_distVec(), log);
    }
  if (a_probeLocCart->get_mountAxisVec())
    {
      adjustLevels(&probeLocCartAtts_mountAxisVec,
		   "probeLocCart mountAxisVec");
      if (log && !findString("mountAxisVec", probeLocCartAtts))
	{
	  warnAtt("mountAxisVec", "probeLocCart", a_probeLocCart);
	  check_vector(a_probeLocCart->get_mountAxisVec(), 0);
	}
      else
	check_vector(a_probeLocCart->get_mountAxisVec(), log);
    }
}

/********************************************************************/

void check_probeLocPol(
 probeLocPol * a_probeLocPol,
 int log)
{
  if (a_probeLocPol->get_tilt())
    {
      adjustLevels(&probeLocPolAtts_tilt, "probeLocPol tilt");
      if (log && !findString("tilt", probeLocPolAtts))
	{
	  warnAtt("tilt", "probeLocPol", a_probeLocPol);
	  check_angle(a_probeLocPol->get_tilt(), 0);
	}
      else
	check_angle(a_probeLocPol->get_tilt(), log);
    }
  if (a_probeLocPol->get_rot())
    {
      adjustLevels(&probeLocPolAtts_rot, "probeLocPol rot");
      if (log && !findString("rot", probeLocPolAtts))
	{
	  warnAtt("rot", "probeLocPol", a_probeLocPol);
	  check_angle(a_probeLocPol->get_rot(), 0);
	}
      else
	check_angle(a_probeLocPol->get_rot(), log);
    }
  if (a_probeLocPol->get_mountAxisVec())
    {
      adjustLevels(&probeLocPolAtts_mountAxisVec, "probeLocPol mountAxisVec");
      if (log && !findString("mountAxisVec", probeLocPolAtts))
	{
	  warnAtt("mountAxisVec", "probeLocPol", a_probeLocPol);
	  check_vector(a_probeLocPol->get_mountAxisVec(), 0);
	}
      else
	check_vector(a_probeLocPol->get_mountAxisVec(), log);
    }
  if (a_probeLocPol->get_len1())
    {
      adjustLevels(&probeLocPolAtts_len1, "probeLocPol len1");
      if (log && !findString("len1", probeLocPolAtts))
	{
	  warnAtt("len1", "probeLocPol", a_probeLocPol);
	  check_rentVal(a_probeLocPol->get_len1(), 0);
	}
      else
	check_rentVal(a_probeLocPol->get_len1(), log);
    }
}

/********************************************************************/

void check_probeLocSnsCart(
 probeLocSnsCart * a_probeLocSnsCart,
 int log)
{
  if (a_probeLocSnsCart->get_sensorLabel2())
    {
      adjustLevels(&probeLocSnsCartAtts_a_sensorLabel2,
		   "probeLocSnsCart a_sensorLabel2");
      if (log && !findString("a_sensorLabel2", probeLocSnsCartAtts))
	{
	  warnAtt("a_sensorLabel2", "probeLocSnsCart", a_probeLocSnsCart);
	  check_sensorLabel2(a_probeLocSnsCart->get_sensorLabel2(), 0);
	}
      else
	check_sensorLabel2(a_probeLocSnsCart->get_sensorLabel2(), log);
    }
  if (a_probeLocSnsCart->get_relVec())
    {
      adjustLevels(&probeLocSnsCartAtts_relVec, "probeLocSnsCart relVec");
      if (log && !findString("relVec", probeLocSnsCartAtts))
	{
	  warnAtt("relVec", "probeLocSnsCart", a_probeLocSnsCart);
	  check_vector(a_probeLocSnsCart->get_relVec(), 0);
	}
      else
	check_vector(a_probeLocSnsCart->get_relVec(), log);
    }
}

/********************************************************************/

void check_probeLocSnsVec(
 probeLocSnsVec * a_probeLocSnsVec,
 int log)
{
  if (a_probeLocSnsVec->get_sensorLabel2())
    {
      adjustLevels(&probeLocSnsVecAtts_a_sensorLabel2,
		   "probeLocSnsVec a_sensorLabel2");
      if (log && !findString("a_sensorLabel2", probeLocSnsVecAtts))
	{
	  warnAtt("a_sensorLabel2", "probeLocSnsVec", a_probeLocSnsVec);
	  check_sensorLabel2(a_probeLocSnsVec->get_sensorLabel2(), 0);
	}
      else
	check_sensorLabel2(a_probeLocSnsVec->get_sensorLabel2(), log);
    }
  if (a_probeLocSnsVec->get_relVec())
    {
      adjustLevels(&probeLocSnsVecAtts_relVec, "probeLocSnsVec relVec");
      if (log && !findString("relVec", probeLocSnsVecAtts))
	{
	  warnAtt("relVec", "probeLocSnsVec", a_probeLocSnsVec);
	  check_vector(a_probeLocSnsVec->get_relVec(), 0);
	}
      else
	check_vector(a_probeLocSnsVec->get_relVec(), log);
    }
  if (a_probeLocSnsVec->get_rlen())
    {
      adjustLevels(&probeLocSnsVecAtts_rlen, "probeLocSnsVec rlen");
      if (log && !findString("rlen", probeLocSnsVecAtts))
	{
	  warnAtt("rlen", "probeLocSnsVec", a_probeLocSnsVec);
	  check_rentVal(a_probeLocSnsVec->get_rlen(), 0);
	}
      else
	check_rentVal(a_probeLocSnsVec->get_rlen(), log);
    }
}

/********************************************************************/

void check_probeLocVec(
 probeLocVec * a_probeLocVec,
 int log)
{
  if (a_probeLocVec->get_tipVec())
    {
      adjustLevels(&probeLocVecAtts_tipVec, "probeLocVec tipVec");
      if (log && !findString("tipVec", probeLocVecAtts))
	{
	  warnAtt("tipVec", "probeLocVec", a_probeLocVec);
	  check_vector(a_probeLocVec->get_tipVec(), 0);
	}
      else
	check_vector(a_probeLocVec->get_tipVec(), log);
    }
  if (a_probeLocVec->get_mountAxisVec())
    {
      adjustLevels(&probeLocVecAtts_mountAxisVec, "probeLocVec mountAxisVec");
      if (log && !findString("mountAxisVec", probeLocVecAtts))
	{
	  warnAtt("mountAxisVec", "probeLocVec", a_probeLocVec);
	  check_vector(a_probeLocVec->get_mountAxisVec(), 0);
	}
      else
	check_vector(a_probeLocVec->get_mountAxisVec(), log);
    }
  if (a_probeLocVec->get_len1())
    {
      adjustLevels(&probeLocVecAtts_len1, "probeLocVec len1");
      if (log && !findString("len1", probeLocVecAtts))
	{
	  warnAtt("len1", "probeLocVec", a_probeLocVec);
	  check_rentVal(a_probeLocVec->get_len1(), 0);
	}
      else
	check_rentVal(a_probeLocVec->get_len1(), log);
    }
}

/********************************************************************/

void check_probeLocation(
 probeLocation * a_probeLocation,
 int log)
{
  if (isA(a_probeLocation, probeLocCart))
    {
      adjustLevels(&probeLocationSubs_probeLocCart, "probeLocCart");
      if (log && !findString("probeLocCart", probeLocationSubs))
	{
	  warnSub("probeLocCart", "probeLocation", a_probeLocation);
	  check_probeLocCart(
	    dynamic_cast<probeLocCart *>(a_probeLocation), 0);
	}
      else
	check_probeLocCart(
	  dynamic_cast<probeLocCart *>(a_probeLocation), log);
      return;
    }
  if (isA(a_probeLocation, probeLocPol))
    {
      adjustLevels(&probeLocationSubs_probeLocPol, "probeLocPol");
      if (log && !findString("probeLocPol", probeLocationSubs))
	{
	  warnSub("probeLocPol", "probeLocation", a_probeLocation);
	  check_probeLocPol(
	    dynamic_cast<probeLocPol *>(a_probeLocation), 0);
	}
      else
	check_probeLocPol(
	  dynamic_cast<probeLocPol *>(a_probeLocation), log);
      return;
    }
  if (isA(a_probeLocation, probeLocVec))
    {
      adjustLevels(&probeLocationSubs_probeLocVec, "probeLocVec");
      if (log && !findString("probeLocVec", probeLocationSubs))
	{
	  warnSub("probeLocVec", "probeLocation", a_probeLocation);
	  check_probeLocVec(
	    dynamic_cast<probeLocVec *>(a_probeLocation), 0);
	}
      else
	check_probeLocVec(
	  dynamic_cast<probeLocVec *>(a_probeLocation), log);
      return;
    }
  if (isA(a_probeLocation, probeLocSnsCart))
    {
      adjustLevels(&probeLocationSubs_probeLocSnsCart, "probeLocSnsCart");
      if (log && !findString("probeLocSnsCart", probeLocationSubs))
	{
	  warnSub("probeLocSnsCart", "probeLocation", a_probeLocation);
	  check_probeLocSnsCart(
	    dynamic_cast<probeLocSnsCart *>(a_probeLocation), 0);
	}
      else
	check_probeLocSnsCart(
	  dynamic_cast<probeLocSnsCart *>(a_probeLocation), log);
      return;
    }
  if (isA(a_probeLocation, probeLocSnsVec))
    {
      adjustLevels(&probeLocationSubs_probeLocSnsVec, "probeLocSnsVec");
      if (log && !findString("probeLocSnsVec", probeLocationSubs))
	{
	  warnSub("probeLocSnsVec", "probeLocation", a_probeLocation);
	  check_probeLocSnsVec(
	    dynamic_cast<probeLocSnsVec *>(a_probeLocation), 0);
	}
      else
	check_probeLocSnsVec(
	  dynamic_cast<probeLocSnsVec *>(a_probeLocation), log);
      return;
    }
}

/********************************************************************/

void check_probeOrient(
 probeOrient * a_probeOrient,
 int log)
{
  if (isA(a_probeOrient, probeOrient_featureLabel))
    {
      adjustLevels(&probeOrientSubs_probeOrient_featureLabel,
		   "probeOrient_featureLabel");
      if (log && !findString("probeOrient_featureLabel", probeOrientSubs))
	{
	  warnSub("probeOrient_featureLabel", "probeOrient", a_probeOrient);
	  check_probeOrient_featureLabel(
	    dynamic_cast<probeOrient_featureLabel *>(a_probeOrient), 0);
	}
      else
	check_probeOrient_featureLabel(
	  dynamic_cast<probeOrient_featureLabel *>(a_probeOrient), log);
      return;
    }
  if (isA(a_probeOrient, probeOrient_VEC))
    {
      adjustLevels(&probeOrientSubs_probeOrient_VEC, "probeOrient_VEC");
      if (log && !findString("probeOrient_VEC", probeOrientSubs))
	{
	  warnSub("probeOrient_VEC", "probeOrient", a_probeOrient);
	  check_probeOrient_VEC(
	    dynamic_cast<probeOrient_VEC *>(a_probeOrient), 0);
	}
      else
	check_probeOrient_VEC(
	  dynamic_cast<probeOrient_VEC *>(a_probeOrient), log);
      return;
    }
  if (isA(a_probeOrient, probeOrient_PCS))
    {
      adjustLevels(&probeOrientSubs_probeOrient_PCS, "probeOrient_PCS");
      if (log && !findString("probeOrient_PCS", probeOrientSubs))
	{
	  warnSub("probeOrient_PCS", "probeOrient", a_probeOrient);
	  check_probeOrient_PCS(
	    dynamic_cast<probeOrient_PCS *>(a_probeOrient), 0);
	}
      else
	check_probeOrient_PCS(
	  dynamic_cast<probeOrient_PCS *>(a_probeOrient), log);
      return;
    }
  if (isA(a_probeOrient, probeOrient_HEADCS))
    {
      adjustLevels(&probeOrientSubs_probeOrient_HEADCS, "probeOrient_HEADCS");
      if (log && !findString("probeOrient_HEADCS", probeOrientSubs))
	{
	  warnSub("probeOrient_HEADCS", "probeOrient", a_probeOrient);
	  check_probeOrient_HEADCS(
	    dynamic_cast<probeOrient_HEADCS *>(a_probeOrient), 0);
	}
      else
	check_probeOrient_HEADCS(
	  dynamic_cast<probeOrient_HEADCS *>(a_probeOrient), log);
      return;
    }
}

/********************************************************************/

void check_probeOrient_HEADCS(
 probeOrient_HEADCS * a_probeOrient_HEADCS,
 int log)
{
  if (a_probeOrient_HEADCS->get_rot1())
    {
      adjustLevels(&probeOrient_HEADCSAtts_rot1, "probeOrient_HEADCS rot1");
      if (log && !findString("rot1", probeOrient_HEADCSAtts))
	{
	  warnAtt("rot1", "probeOrient_HEADCS", a_probeOrient_HEADCS);
	  check_rentVal(a_probeOrient_HEADCS->get_rot1(), 0);
	}
      else
	check_rentVal(a_probeOrient_HEADCS->get_rot1(), log);
    }
  if (a_probeOrient_HEADCS->get_rot2())
    {
      adjustLevels(&probeOrient_HEADCSAtts_rot2, "probeOrient_HEADCS rot2");
      if (log && !findString("rot2", probeOrient_HEADCSAtts))
	{
	  warnAtt("rot2", "probeOrient_HEADCS", a_probeOrient_HEADCS);
	  check_rentVal(a_probeOrient_HEADCS->get_rot2(), 0);
	}
      else
	check_rentVal(a_probeOrient_HEADCS->get_rot2(), log);
    }
  if (a_probeOrient_HEADCS->get_rot3())
    {
      adjustLevels(&probeOrient_HEADCSAtts_rot3, "probeOrient_HEADCS rot3");
      if (log && !findString("rot3", probeOrient_HEADCSAtts))
	{
	  warnAtt("rot3", "probeOrient_HEADCS", a_probeOrient_HEADCS);
	  check_rentVal(a_probeOrient_HEADCS->get_rot3(), 0);
	}
      else
	check_rentVal(a_probeOrient_HEADCS->get_rot3(), log);
    }
}

/********************************************************************/

void check_probeOrient_PCS(
 probeOrient_PCS * a_probeOrient_PCS,
 int log)
{
  if (a_probeOrient_PCS->get_euler())
    {
      adjustLevels(&probeOrient_PCSAtts_a_euler, "probeOrient_PCS a_euler");
      if (log && !findString("a_euler", probeOrient_PCSAtts))
	{
	  warnAtt("a_euler", "probeOrient_PCS", a_probeOrient_PCS);
	  check_euler(a_probeOrient_PCS->get_euler(), 0);
	}
      else
	check_euler(a_probeOrient_PCS->get_euler(), log);
    }
}

/********************************************************************/

void check_probeOrient_VEC(
 probeOrient_VEC * a_probeOrient_VEC,
 int log)
{
  if (a_probeOrient_VEC->get_dir())
    {
      adjustLevels(&probeOrient_VECAtts_dir, "probeOrient_VEC dir");
      if (log && !findString("dir", probeOrient_VECAtts))
	{
	  warnAtt("dir", "probeOrient_VEC", a_probeOrient_VEC);
	  check_vector(a_probeOrient_VEC->get_dir(), 0);
	}
      else
	check_vector(a_probeOrient_VEC->get_dir(), log);
    }
  if (a_probeOrient_VEC->get_angle())
    {
      adjustLevels(&probeOrient_VECAtts_a_angle, "probeOrient_VEC a_angle");
      if (log && !findString("a_angle", probeOrient_VECAtts))
	{
	  warnAtt("a_angle", "probeOrient_VEC", a_probeOrient_VEC);
	  check_angle(a_probeOrient_VEC->get_angle(), 0);
	}
      else
	check_angle(a_probeOrient_VEC->get_angle(), log);
    }
}

/********************************************************************/

void check_probeOrient_featureLabel(
 probeOrient_featureLabel * a_probeOrient_featureLabel,
 int log)
{
  if (a_probeOrient_featureLabel->get_featureLabel())
    {
      adjustLevels(&probeOrient_featureLabelAtts_a_featureLabel,
		   "probeOrient_featureLabel a_featureLabel");
      if (log && !findString("a_featureLabel", probeOrient_featureLabelAtts))
	{
	  warnAtt("a_featureLabel", "probeOrient_featureLabel",
		  a_probeOrient_featureLabel);
	  check_featureLabel(a_probeOrient_featureLabel->get_featureLabel(), 0);
	}
      else
	check_featureLabel(a_probeOrient_featureLabel->get_featureLabel(), log);
    }
  if (a_probeOrient_featureLabel->get_angle())
    {
      adjustLevels(&probeOrient_featureLabelAtts_a_angle,
		   "probeOrient_featureLabel a_angle");
      if (log && !findString("a_angle", probeOrient_featureLabelAtts))
	{
	  warnAtt("a_angle", "probeOrient_featureLabel",
		  a_probeOrient_featureLabel);
	  check_angle(a_probeOrient_featureLabel->get_angle(), 0);
	}
      else
	check_angle(a_probeOrient_featureLabel->get_angle(), log);
    }
}

/********************************************************************/

void check_procidStm(
 procidStm * a_procidStm,
 int log)
{
  if (a_procidStm->get_pcLabel())
    {
      adjustLevels(&procidStmAtts_a_pcLabel, "procidStm a_pcLabel");
      if (log && !findString("a_pcLabel", procidStmAtts))
	{
	  warnAtt("a_pcLabel", "procidStm", a_procidStm);
	  check_pcLabel(a_procidStm->get_pcLabel(), 0);
	}
      else
	check_pcLabel(a_procidStm->get_pcLabel(), log);
    }
  if (a_procidStm->get_text())
    {
      adjustLevels(&procidStmAtts_text, "procidStm text");
      if (log && !findString("text", procidStmAtts))
	{
	  warnAtt("text", "procidStm", a_procidStm);
	  check_stringVal(a_procidStm->get_text(), 0);
	}
      else
	check_stringVal(a_procidStm->get_text(), log);
    }
}

/********************************************************************/

void check_projctConst(
 projctConst * a_projctConst,
 int log)
{
  if (a_projctConst->get_faLabel())
    {
      adjustLevels(&projctConstAtts_a_faLabel, "projctConst a_faLabel");
      if (log && !findString("a_faLabel", projctConstAtts))
	{
	  warnAtt("a_faLabel", "projctConst", a_projctConst);
	  check_faLabel(a_projctConst->get_faLabel(), 0);
	}
      else
	check_faLabel(a_projctConst->get_faLabel(), log);
    }
  if (a_projctConst->get_featureLabel())
    {
      adjustLevels(&projctConstAtts_a_featureLabel,
		   "projctConst a_featureLabel");
      if (log && !findString("a_featureLabel", projctConstAtts))
	{
	  warnAtt("a_featureLabel", "projctConst", a_projctConst);
	  check_featureLabel(a_projctConst->get_featureLabel(), 0);
	}
      else
	check_featureLabel(a_projctConst->get_featureLabel(), log);
    }
}

/********************************************************************/

void check_projliConst(
 projliConst * a_projliConst,
 int log)
{
  if (a_projliConst->get_faLabel())
    {
      adjustLevels(&projliConstAtts_a_faLabel, "projliConst a_faLabel");
      if (log && !findString("a_faLabel", projliConstAtts))
	{
	  warnAtt("a_faLabel", "projliConst", a_projliConst);
	  check_faLabel(a_projliConst->get_faLabel(), 0);
	}
      else
	check_faLabel(a_projliConst->get_faLabel(), log);
    }
  if (a_projliConst->get_featureLabel())
    {
      adjustLevels(&projliConstAtts_a_featureLabel,
		   "projliConst a_featureLabel");
      if (log && !findString("a_featureLabel", projliConstAtts))
	{
	  warnAtt("a_featureLabel", "projliConst", a_projliConst);
	  check_featureLabel(a_projliConst->get_featureLabel(), 0);
	}
      else
	check_featureLabel(a_projliConst->get_featureLabel(), log);
    }
}

/********************************************************************/

void check_projptConst(
 projptConst * a_projptConst,
 int log)
{
  if (a_projptConst->get_faLabel())
    {
      adjustLevels(&projptConstAtts_a_faLabel, "projptConst a_faLabel");
      if (log && !findString("a_faLabel", projptConstAtts))
	{
	  warnAtt("a_faLabel", "projptConst", a_projptConst);
	  check_faLabel(a_projptConst->get_faLabel(), 0);
	}
      else
	check_faLabel(a_projptConst->get_faLabel(), log);
    }
  if (a_projptConst->get_featureLabel())
    {
      adjustLevels(&projptConstAtts_a_featureLabel,
		   "projptConst a_featureLabel");
      if (log && !findString("a_featureLabel", projptConstAtts))
	{
	  warnAtt("a_featureLabel", "projptConst", a_projptConst);
	  check_featureLabel(a_projptConst->get_featureLabel(), 0);
	}
      else
	check_featureLabel(a_projptConst->get_featureLabel(), log);
    }
}

/********************************************************************/

void check_promptIntEnd(
 promptIntEnd * a_promptIntEnd,
 int log)
{
  if (isA(a_promptIntEnd, promptIntEnd_stringVal))
    {
      adjustLevels(&promptIntEndSubs_promptIntEnd_stringVal,
		   "promptIntEnd_stringVal");
      if (log && !findString("promptIntEnd_stringVal", promptIntEndSubs))
	{
	  warnSub("promptIntEnd_stringVal", "promptIntEnd", a_promptIntEnd);
	  check_promptIntEnd_stringVal(
	    dynamic_cast<promptIntEnd_stringVal *>(a_promptIntEnd), 0);
	}
      else
	check_promptIntEnd_stringVal(
	  dynamic_cast<promptIntEnd_stringVal *>(a_promptIntEnd), log);
      return;
    }
  if (isA(a_promptIntEnd, promptIntEnd_promptItemList))
    {
      adjustLevels(&promptIntEndSubs_promptIntEnd_promptItemList,
		   "promptIntEnd_promptItemList");
      if (log && !findString("promptIntEnd_promptItemList", promptIntEndSubs))
	{
	  warnSub("promptIntEnd_promptItemList", "promptIntEnd",
		  a_promptIntEnd);
	  check_promptIntEnd_promptItemList(
	    dynamic_cast<promptIntEnd_promptItemList *>(a_promptIntEnd), 0);
	}
      else
	check_promptIntEnd_promptItemList(
	  dynamic_cast<promptIntEnd_promptItemList *>(a_promptIntEnd), log);
      return;
    }
}

/********************************************************************/

void check_promptIntEnd_promptItemList(
 promptIntEnd_promptItemList * a_promptIntEnd_promptItemList,
 int log)
{
  if (a_promptIntEnd_promptItemList->get_promptItemList())
    {
      std::list<promptItem *> * theList;
      std::list<promptItem *>::iterator iter;
      theList = a_promptIntEnd_promptItemList->get_promptItemList();
      adjustLevels(&promptIntEnd_promptItemListAtts_a_promptItemList,
		   "promptIntEnd_promptItemList a_promptItemList");
      if (log && !findString("a_promptItemList",
			     promptIntEnd_promptItemListAtts))
	{
	  warnAtt("a_promptItemList", "promptIntEnd_promptItemList",
		  a_promptIntEnd_promptItemList);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_promptItem(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_promptItem(*iter, log);
	}
    }
}

/********************************************************************/

void check_promptIntEnd_stringVal(
 promptIntEnd_stringVal * a_promptIntEnd_stringVal,
 int log)
{
  if (a_promptIntEnd_stringVal->get_text())
    {
      adjustLevels(&promptIntEnd_stringValAtts_text,
		   "promptIntEnd_stringVal text");
      if (log && !findString("text", promptIntEnd_stringValAtts))
	{
	  warnAtt("text", "promptIntEnd_stringVal", a_promptIntEnd_stringVal);
	  check_stringVal(a_promptIntEnd_stringVal->get_text(), 0);
	}
      else
	check_stringVal(a_promptIntEnd_stringVal->get_text(), log);
    }
  if (a_promptIntEnd_stringVal->get_maxval())
    {
      adjustLevels(&promptIntEnd_stringValAtts_maxval,
		   "promptIntEnd_stringVal maxval");
      if (log && !findString("maxval", promptIntEnd_stringValAtts))
	{
	  warnAtt("maxval", "promptIntEnd_stringVal",
		  a_promptIntEnd_stringVal);
	  check_intVal(a_promptIntEnd_stringVal->get_maxval(), 0);
	}
      else
	check_intVal(a_promptIntEnd_stringVal->get_maxval(), log);
    }
  if (a_promptIntEnd_stringVal->get_minval())
    {
      adjustLevels(&promptIntEnd_stringValAtts_minval,
		   "promptIntEnd_stringVal minval");
      if (log && !findString("minval", promptIntEnd_stringValAtts))
	{
	  warnAtt("minval", "promptIntEnd_stringVal",
		  a_promptIntEnd_stringVal);
	  check_intVal(a_promptIntEnd_stringVal->get_minval(), 0);
	}
      else
	check_intVal(a_promptIntEnd_stringVal->get_minval(), log);
    }
}

/********************************************************************/

void check_promptItem(
 promptItem * a_promptItem,
 int log)
{
  if (isA(a_promptItem, promptItem_BUTTON))
    {
      adjustLevels(&promptItemSubs_promptItem_BUTTON, "promptItem_BUTTON");
      if (log && !findString("promptItem_BUTTON", promptItemSubs))
	{
	  warnSub("promptItem_BUTTON", "promptItem", a_promptItem);
	  check_promptItem_BUTTON(
	    dynamic_cast<promptItem_BUTTON *>(a_promptItem), 0);
	}
      else
	check_promptItem_BUTTON(
	  dynamic_cast<promptItem_BUTTON *>(a_promptItem), log);
      return;
    }
  if (isA(a_promptItem, promptItem_CHECK))
    {
      adjustLevels(&promptItemSubs_promptItem_CHECK, "promptItem_CHECK");
      if (log && !findString("promptItem_CHECK", promptItemSubs))
	{
	  warnSub("promptItem_CHECK", "promptItem", a_promptItem);
	  check_promptItem_CHECK(
	    dynamic_cast<promptItem_CHECK *>(a_promptItem), 0);
	}
      else
	check_promptItem_CHECK(
	  dynamic_cast<promptItem_CHECK *>(a_promptItem), log);
      return;
    }
  if (isA(a_promptItem, promptItem_EDIT))
    {
      adjustLevels(&promptItemSubs_promptItem_EDIT, "promptItem_EDIT");
      if (log && !findString("promptItem_EDIT", promptItemSubs))
	{
	  warnSub("promptItem_EDIT", "promptItem", a_promptItem);
	  check_promptItem_EDIT(
	    dynamic_cast<promptItem_EDIT *>(a_promptItem), 0);
	}
      else
	check_promptItem_EDIT(
	  dynamic_cast<promptItem_EDIT *>(a_promptItem), log);
      return;
    }
  if (isA(a_promptItem, promptItem_GROUP))
    {
      adjustLevels(&promptItemSubs_promptItem_GROUP, "promptItem_GROUP");
      if (log && !findString("promptItem_GROUP", promptItemSubs))
	{
	  warnSub("promptItem_GROUP", "promptItem", a_promptItem);
	  check_promptItem_GROUP(
	    dynamic_cast<promptItem_GROUP *>(a_promptItem), 0);
	}
      else
	check_promptItem_GROUP(
	  dynamic_cast<promptItem_GROUP *>(a_promptItem), log);
      return;
    }
  if (isA(a_promptItem, promptItem_LIST))
    {
      adjustLevels(&promptItemSubs_promptItem_LIST, "promptItem_LIST");
      if (log && !findString("promptItem_LIST", promptItemSubs))
	{
	  warnSub("promptItem_LIST", "promptItem", a_promptItem);
	  check_promptItem_LIST(
	    dynamic_cast<promptItem_LIST *>(a_promptItem), 0);
	}
      else
	check_promptItem_LIST(
	  dynamic_cast<promptItem_LIST *>(a_promptItem), log);
      return;
    }
  if (isA(a_promptItem, promptItem_PICTURE))
    {
      adjustLevels(&promptItemSubs_promptItem_PICTURE, "promptItem_PICTURE");
      if (log && !findString("promptItem_PICTURE", promptItemSubs))
	{
	  warnSub("promptItem_PICTURE", "promptItem", a_promptItem);
	  check_promptItem_PICTURE(
	    dynamic_cast<promptItem_PICTURE *>(a_promptItem), 0);
	}
      else
	check_promptItem_PICTURE(
	  dynamic_cast<promptItem_PICTURE *>(a_promptItem), log);
      return;
    }
  if (isA(a_promptItem, promptItem_PIXBTN))
    {
      adjustLevels(&promptItemSubs_promptItem_PIXBTN, "promptItem_PIXBTN");
      if (log && !findString("promptItem_PIXBTN", promptItemSubs))
	{
	  warnSub("promptItem_PIXBTN", "promptItem", a_promptItem);
	  check_promptItem_PIXBTN(
	    dynamic_cast<promptItem_PIXBTN *>(a_promptItem), 0);
	}
      else
	check_promptItem_PIXBTN(
	  dynamic_cast<promptItem_PIXBTN *>(a_promptItem), log);
      return;
    }
  if (isA(a_promptItem, promptItem_SOUND))
    {
      adjustLevels(&promptItemSubs_promptItem_SOUND, "promptItem_SOUND");
      if (log && !findString("promptItem_SOUND", promptItemSubs))
	{
	  warnSub("promptItem_SOUND", "promptItem", a_promptItem);
	  check_promptItem_SOUND(
	    dynamic_cast<promptItem_SOUND *>(a_promptItem), 0);
	}
      else
	check_promptItem_SOUND(
	  dynamic_cast<promptItem_SOUND *>(a_promptItem), log);
      return;
    }
  if (isA(a_promptItem, promptItem_TEXT))
    {
      adjustLevels(&promptItemSubs_promptItem_TEXT, "promptItem_TEXT");
      if (log && !findString("promptItem_TEXT", promptItemSubs))
	{
	  warnSub("promptItem_TEXT", "promptItem", a_promptItem);
	  check_promptItem_TEXT(
	    dynamic_cast<promptItem_TEXT *>(a_promptItem), 0);
	}
      else
	check_promptItem_TEXT(
	  dynamic_cast<promptItem_TEXT *>(a_promptItem), log);
      return;
    }
  if (isA(a_promptItem, promptItem_TITLE))
    {
      adjustLevels(&promptItemSubs_promptItem_TITLE, "promptItem_TITLE");
      if (log && !findString("promptItem_TITLE", promptItemSubs))
	{
	  warnSub("promptItem_TITLE", "promptItem", a_promptItem);
	  check_promptItem_TITLE(
	    dynamic_cast<promptItem_TITLE *>(a_promptItem), 0);
	}
      else
	check_promptItem_TITLE(
	  dynamic_cast<promptItem_TITLE *>(a_promptItem), log);
      return;
    }
}

/********************************************************************/

void check_promptItem_BUTTON(
 promptItem_BUTTON * a_promptItem_BUTTON,
 int log)
{
  if (a_promptItem_BUTTON->get_text())
    {
      adjustLevels(&promptItem_BUTTONAtts_text, "promptItem_BUTTON text");
      if (log && !findString("text", promptItem_BUTTONAtts))
	{
	  warnAtt("text", "promptItem_BUTTON", a_promptItem_BUTTON);
	  check_stringVal(a_promptItem_BUTTON->get_text(), 0);
	}
      else
	check_stringVal(a_promptItem_BUTTON->get_text(), log);
    }
  if (a_promptItem_BUTTON->get_retVal())
    {
      adjustLevels(&promptItem_BUTTONAtts_retVal, "promptItem_BUTTON retVal");
      if (log && !findString("retVal", promptItem_BUTTONAtts))
	{
	  warnAtt("retVal", "promptItem_BUTTON", a_promptItem_BUTTON);
	  check_intVal(a_promptItem_BUTTON->get_retVal(), 0);
	}
      else
	check_intVal(a_promptItem_BUTTON->get_retVal(), log);
    }
}

/********************************************************************/

void check_promptItem_CHECK(
 promptItem_CHECK * a_promptItem_CHECK,
 int log)
{
  if (a_promptItem_CHECK->get_text())
    {
      adjustLevels(&promptItem_CHECKAtts_text, "promptItem_CHECK text");
      if (log && !findString("text", promptItem_CHECKAtts))
	{
	  warnAtt("text", "promptItem_CHECK", a_promptItem_CHECK);
	  check_stringVal(a_promptItem_CHECK->get_text(), 0);
	}
      else
	check_stringVal(a_promptItem_CHECK->get_text(), log);
    }
  if (a_promptItem_CHECK->get_boolVar())
    {
      adjustLevels(&promptItem_CHECKAtts_a_boolVar,
		   "promptItem_CHECK a_boolVar");
      if (log && !findString("a_boolVar", promptItem_CHECKAtts))
	{
	  warnAtt("a_boolVar", "promptItem_CHECK", a_promptItem_CHECK);
	  check_boolVar(a_promptItem_CHECK->get_boolVar(), 0);
	}
      else
	check_boolVar(a_promptItem_CHECK->get_boolVar(), log);
    }
}

/********************************************************************/

void check_promptItem_EDIT(
 promptItem_EDIT * a_promptItem_EDIT,
 int log)
{
  if (a_promptItem_EDIT->get_promptVar())
    {
      adjustLevels(&promptItem_EDITAtts_a_promptVar,
		   "promptItem_EDIT a_promptVar");
      if (log && !findString("a_promptVar", promptItem_EDITAtts))
	{
	  warnAtt("a_promptVar", "promptItem_EDIT", a_promptItem_EDIT);
	  check_promptVar(a_promptItem_EDIT->get_promptVar(), 0);
	}
      else
	check_promptVar(a_promptItem_EDIT->get_promptVar(), log);
    }
  if (a_promptItem_EDIT->get_maxval())
    {
      adjustLevels(&promptItem_EDITAtts_maxval, "promptItem_EDIT maxval");
      if (log && !findString("maxval", promptItem_EDITAtts))
	{
	  warnAtt("maxval", "promptItem_EDIT", a_promptItem_EDIT);
	  check_rentVal(a_promptItem_EDIT->get_maxval(), 0);
	}
      else
	check_rentVal(a_promptItem_EDIT->get_maxval(), log);
    }
  if (a_promptItem_EDIT->get_minval())
    {
      adjustLevels(&promptItem_EDITAtts_minval, "promptItem_EDIT minval");
      if (log && !findString("minval", promptItem_EDITAtts))
	{
	  warnAtt("minval", "promptItem_EDIT", a_promptItem_EDIT);
	  check_rentVal(a_promptItem_EDIT->get_minval(), 0);
	}
      else
	check_rentVal(a_promptItem_EDIT->get_minval(), log);
    }
}

/********************************************************************/

void check_promptItem_GROUP(
 promptItem_GROUP * a_promptItem_GROUP,
 int log)
{
  if (a_promptItem_GROUP->get_text())
    {
      adjustLevels(&promptItem_GROUPAtts_text, "promptItem_GROUP text");
      if (log && !findString("text", promptItem_GROUPAtts))
	{
	  warnAtt("text", "promptItem_GROUP", a_promptItem_GROUP);
	  check_stringVal(a_promptItem_GROUP->get_text(), 0);
	}
      else
	check_stringVal(a_promptItem_GROUP->get_text(), log);
    }
  if (a_promptItem_GROUP->get_promptVar())
    {
      adjustLevels(&promptItem_GROUPAtts_a_promptVar,
		   "promptItem_GROUP a_promptVar");
      if (log && !findString("a_promptVar", promptItem_GROUPAtts))
	{
	  warnAtt("a_promptVar", "promptItem_GROUP", a_promptItem_GROUP);
	  check_promptVar(a_promptItem_GROUP->get_promptVar(), 0);
	}
      else
	check_promptVar(a_promptItem_GROUP->get_promptVar(), log);
    }
  if (a_promptItem_GROUP->get_item1())
    {
      adjustLevels(&promptItem_GROUPAtts_item1, "promptItem_GROUP item1");
      if (log && !findString("item1", promptItem_GROUPAtts))
	{
	  warnAtt("item1", "promptItem_GROUP", a_promptItem_GROUP);
	  check_stringVal(a_promptItem_GROUP->get_item1(), 0);
	}
      else
	check_stringVal(a_promptItem_GROUP->get_item1(), log);
    }
  if (a_promptItem_GROUP->get_moreItems())
    {
      std::list<stringVal *> * theList;
      std::list<stringVal *>::iterator iter;
      theList = a_promptItem_GROUP->get_moreItems();
      adjustLevels(&promptItem_GROUPAtts_moreItems,
		   "promptItem_GROUP moreItems");
      if (log && !findString("moreItems", promptItem_GROUPAtts))
	{
	  warnAtt("moreItems", "promptItem_GROUP", a_promptItem_GROUP);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_stringVal(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_stringVal(*iter, log);
	}
    }
}

/********************************************************************/

void check_promptItem_LIST(
 promptItem_LIST * a_promptItem_LIST,
 int log)
{
  if (a_promptItem_LIST->get_promptVar())
    {
      adjustLevels(&promptItem_LISTAtts_a_promptVar,
		   "promptItem_LIST a_promptVar");
      if (log && !findString("a_promptVar", promptItem_LISTAtts))
	{
	  warnAtt("a_promptVar", "promptItem_LIST", a_promptItem_LIST);
	  check_promptVar(a_promptItem_LIST->get_promptVar(), 0);
	}
      else
	check_promptVar(a_promptItem_LIST->get_promptVar(), log);
    }
  if (a_promptItem_LIST->get_item1())
    {
      adjustLevels(&promptItem_LISTAtts_item1, "promptItem_LIST item1");
      if (log && !findString("item1", promptItem_LISTAtts))
	{
	  warnAtt("item1", "promptItem_LIST", a_promptItem_LIST);
	  check_stringVal(a_promptItem_LIST->get_item1(), 0);
	}
      else
	check_stringVal(a_promptItem_LIST->get_item1(), log);
    }
  if (a_promptItem_LIST->get_moreItems())
    {
      std::list<stringVal *> * theList;
      std::list<stringVal *>::iterator iter;
      theList = a_promptItem_LIST->get_moreItems();
      adjustLevels(&promptItem_LISTAtts_moreItems,
		   "promptItem_LIST moreItems");
      if (log && !findString("moreItems", promptItem_LISTAtts))
	{
	  warnAtt("moreItems", "promptItem_LIST", a_promptItem_LIST);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_stringVal(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_stringVal(*iter, log);
	}
    }
}

/********************************************************************/

void check_promptItem_PICTURE(
 promptItem_PICTURE * a_promptItem_PICTURE,
 int log)
{
  if (a_promptItem_PICTURE->get_filename())
    {
      adjustLevels(&promptItem_PICTUREAtts_filename,
		   "promptItem_PICTURE filename");
      if (log && !findString("filename", promptItem_PICTUREAtts))
	{
	  warnAtt("filename", "promptItem_PICTURE", a_promptItem_PICTURE);
	  check_stringVal(a_promptItem_PICTURE->get_filename(), 0);
	}
      else
	check_stringVal(a_promptItem_PICTURE->get_filename(), log);
    }
  if (a_promptItem_PICTURE->get_index())
    {
      adjustLevels(&promptItem_PICTUREAtts_index, "promptItem_PICTURE index");
      if (log && !findString("index", promptItem_PICTUREAtts))
	{
	  warnAtt("index", "promptItem_PICTURE", a_promptItem_PICTURE);
	  check_intVal(a_promptItem_PICTURE->get_index(), 0);
	}
      else
	check_intVal(a_promptItem_PICTURE->get_index(), log);
    }
}

/********************************************************************/

void check_promptItem_PIXBTN(
 promptItem_PIXBTN * a_promptItem_PIXBTN,
 int log)
{
  if (a_promptItem_PIXBTN->get_filnam1())
    {
      adjustLevels(&promptItem_PIXBTNAtts_filnam1,
		   "promptItem_PIXBTN filnam1");
      if (log && !findString("filnam1", promptItem_PIXBTNAtts))
	{
	  warnAtt("filnam1", "promptItem_PIXBTN", a_promptItem_PIXBTN);
	  check_stringVal(a_promptItem_PIXBTN->get_filnam1(), 0);
	}
      else
	check_stringVal(a_promptItem_PIXBTN->get_filnam1(), log);
    }
  if (a_promptItem_PIXBTN->get_filnam2())
    {
      adjustLevels(&promptItem_PIXBTNAtts_filnam2,
		   "promptItem_PIXBTN filnam2");
      if (log && !findString("filnam2", promptItem_PIXBTNAtts))
	{
	  warnAtt("filnam2", "promptItem_PIXBTN", a_promptItem_PIXBTN);
	  check_stringVal(a_promptItem_PIXBTN->get_filnam2(), 0);
	}
      else
	check_stringVal(a_promptItem_PIXBTN->get_filnam2(), log);
    }
  if (a_promptItem_PIXBTN->get_retVal())
    {
      adjustLevels(&promptItem_PIXBTNAtts_retVal, "promptItem_PIXBTN retVal");
      if (log && !findString("retVal", promptItem_PIXBTNAtts))
	{
	  warnAtt("retVal", "promptItem_PIXBTN", a_promptItem_PIXBTN);
	  check_intVal(a_promptItem_PIXBTN->get_retVal(), 0);
	}
      else
	check_intVal(a_promptItem_PIXBTN->get_retVal(), log);
    }
}

/********************************************************************/

void check_promptItem_SOUND(
 promptItem_SOUND * a_promptItem_SOUND,
 int log)
{
  if (a_promptItem_SOUND->get_filename())
    {
      adjustLevels(&promptItem_SOUNDAtts_filename,
		   "promptItem_SOUND filename");
      if (log && !findString("filename", promptItem_SOUNDAtts))
	{
	  warnAtt("filename", "promptItem_SOUND", a_promptItem_SOUND);
	  check_stringVal(a_promptItem_SOUND->get_filename(), 0);
	}
      else
	check_stringVal(a_promptItem_SOUND->get_filename(), log);
    }
}

/********************************************************************/

void check_promptItem_TEXT(
 promptItem_TEXT * a_promptItem_TEXT,
 int log)
{
  if (a_promptItem_TEXT->get_text())
    {
      adjustLevels(&promptItem_TEXTAtts_text, "promptItem_TEXT text");
      if (log && !findString("text", promptItem_TEXTAtts))
	{
	  warnAtt("text", "promptItem_TEXT", a_promptItem_TEXT);
	  check_stringVal(a_promptItem_TEXT->get_text(), 0);
	}
      else
	check_stringVal(a_promptItem_TEXT->get_text(), log);
    }
}

/********************************************************************/

void check_promptItem_TITLE(
 promptItem_TITLE * a_promptItem_TITLE,
 int log)
{
  if (a_promptItem_TITLE->get_text())
    {
      adjustLevels(&promptItem_TITLEAtts_text, "promptItem_TITLE text");
      if (log && !findString("text", promptItem_TITLEAtts))
	{
	  warnAtt("text", "promptItem_TITLE", a_promptItem_TITLE);
	  check_stringVal(a_promptItem_TITLE->get_text(), 0);
	}
      else
	check_stringVal(a_promptItem_TITLE->get_text(), log);
    }
}

/********************************************************************/

void check_promptStm(
 promptStm * a_promptStm,
 int log)
{
  if (isA(a_promptStm, promptStm_boolVar))
    {
      adjustLevels(&promptStmSubs_promptStm_boolVar, "promptStm_boolVar");
      if (log && !findString("promptStm_boolVar", promptStmSubs))
	{
	  warnSub("promptStm_boolVar", "promptStm", a_promptStm);
	  check_promptStm_boolVar(
	    dynamic_cast<promptStm_boolVar *>(a_promptStm), 0);
	}
      else
	check_promptStm_boolVar(
	  dynamic_cast<promptStm_boolVar *>(a_promptStm), log);
      return;
    }
  if (isA(a_promptStm, promptStm_stringVar))
    {
      adjustLevels(&promptStmSubs_promptStm_stringVar, "promptStm_stringVar");
      if (log && !findString("promptStm_stringVar", promptStmSubs))
	{
	  warnSub("promptStm_stringVar", "promptStm", a_promptStm);
	  check_promptStm_stringVar(
	    dynamic_cast<promptStm_stringVar *>(a_promptStm), 0);
	}
      else
	check_promptStm_stringVar(
	  dynamic_cast<promptStm_stringVar *>(a_promptStm), log);
      return;
    }
  if (isA(a_promptStm, promptStm_intVar))
    {
      adjustLevels(&promptStmSubs_promptStm_intVar, "promptStm_intVar");
      if (log && !findString("promptStm_intVar", promptStmSubs))
	{
	  warnSub("promptStm_intVar", "promptStm", a_promptStm);
	  check_promptStm_intVar(
	    dynamic_cast<promptStm_intVar *>(a_promptStm), 0);
	}
      else
	check_promptStm_intVar(
	  dynamic_cast<promptStm_intVar *>(a_promptStm), log);
      return;
    }
  if (isA(a_promptStm, promptStm_realVar))
    {
      adjustLevels(&promptStmSubs_promptStm_realVar, "promptStm_realVar");
      if (log && !findString("promptStm_realVar", promptStmSubs))
	{
	  warnSub("promptStm_realVar", "promptStm", a_promptStm);
	  check_promptStm_realVar(
	    dynamic_cast<promptStm_realVar *>(a_promptStm), 0);
	}
      else
	check_promptStm_realVar(
	  dynamic_cast<promptStm_realVar *>(a_promptStm), log);
      return;
    }
  if (isA(a_promptStm, promptStm_ccLabel))
    {
      adjustLevels(&promptStmSubs_promptStm_ccLabel, "promptStm_ccLabel");
      if (log && !findString("promptStm_ccLabel", promptStmSubs))
	{
	  warnSub("promptStm_ccLabel", "promptStm", a_promptStm);
	  check_promptStm_ccLabel(
	    dynamic_cast<promptStm_ccLabel *>(a_promptStm), 0);
	}
      else
	check_promptStm_ccLabel(
	  dynamic_cast<promptStm_ccLabel *>(a_promptStm), log);
      return;
    }
  if (isA(a_promptStm, promptStm_ciLabel))
    {
      adjustLevels(&promptStmSubs_promptStm_ciLabel, "promptStm_ciLabel");
      if (log && !findString("promptStm_ciLabel", promptStmSubs))
	{
	  warnSub("promptStm_ciLabel", "promptStm", a_promptStm);
	  check_promptStm_ciLabel(
	    dynamic_cast<promptStm_ciLabel *>(a_promptStm), 0);
	}
      else
	check_promptStm_ciLabel(
	  dynamic_cast<promptStm_ciLabel *>(a_promptStm), log);
      return;
    }
  if (isA(a_promptStm, promptStm_csLabel))
    {
      adjustLevels(&promptStmSubs_promptStm_csLabel, "promptStm_csLabel");
      if (log && !findString("promptStm_csLabel", promptStmSubs))
	{
	  warnSub("promptStm_csLabel", "promptStm", a_promptStm);
	  check_promptStm_csLabel(
	    dynamic_cast<promptStm_csLabel *>(a_promptStm), 0);
	}
      else
	check_promptStm_csLabel(
	  dynamic_cast<promptStm_csLabel *>(a_promptStm), log);
      return;
    }
  if (isA(a_promptStm, promptStm_diLabel))
    {
      adjustLevels(&promptStmSubs_promptStm_diLabel, "promptStm_diLabel");
      if (log && !findString("promptStm_diLabel", promptStmSubs))
	{
	  warnSub("promptStm_diLabel", "promptStm", a_promptStm);
	  check_promptStm_diLabel(
	    dynamic_cast<promptStm_diLabel *>(a_promptStm), 0);
	}
      else
	check_promptStm_diLabel(
	  dynamic_cast<promptStm_diLabel *>(a_promptStm), log);
      return;
    }
  if (isA(a_promptStm, promptStm_dsLabel))
    {
      adjustLevels(&promptStmSubs_promptStm_dsLabel, "promptStm_dsLabel");
      if (log && !findString("promptStm_dsLabel", promptStmSubs))
	{
	  warnSub("promptStm_dsLabel", "promptStm", a_promptStm);
	  check_promptStm_dsLabel(
	    dynamic_cast<promptStm_dsLabel *>(a_promptStm), 0);
	}
      else
	check_promptStm_dsLabel(
	  dynamic_cast<promptStm_dsLabel *>(a_promptStm), log);
      return;
    }
  if (isA(a_promptStm, promptStm_dvLabel))
    {
      adjustLevels(&promptStmSubs_promptStm_dvLabel, "promptStm_dvLabel");
      if (log && !findString("promptStm_dvLabel", promptStmSubs))
	{
	  warnSub("promptStm_dvLabel", "promptStm", a_promptStm);
	  check_promptStm_dvLabel(
	    dynamic_cast<promptStm_dvLabel *>(a_promptStm), 0);
	}
      else
	check_promptStm_dvLabel(
	  dynamic_cast<promptStm_dvLabel *>(a_promptStm), log);
      return;
    }
  if (isA(a_promptStm, promptStm_fiLabel))
    {
      adjustLevels(&promptStmSubs_promptStm_fiLabel, "promptStm_fiLabel");
      if (log && !findString("promptStm_fiLabel", promptStmSubs))
	{
	  warnSub("promptStm_fiLabel", "promptStm", a_promptStm);
	  check_promptStm_fiLabel(
	    dynamic_cast<promptStm_fiLabel *>(a_promptStm), 0);
	}
      else
	check_promptStm_fiLabel(
	  dynamic_cast<promptStm_fiLabel *>(a_promptStm), log);
      return;
    }
  if (isA(a_promptStm, promptStm_fsLabel))
    {
      adjustLevels(&promptStmSubs_promptStm_fsLabel, "promptStm_fsLabel");
      if (log && !findString("promptStm_fsLabel", promptStmSubs))
	{
	  warnSub("promptStm_fsLabel", "promptStm", a_promptStm);
	  check_promptStm_fsLabel(
	    dynamic_cast<promptStm_fsLabel *>(a_promptStm), 0);
	}
      else
	check_promptStm_fsLabel(
	  dynamic_cast<promptStm_fsLabel *>(a_promptStm), log);
      return;
    }
  if (isA(a_promptStm, promptStm_liLabel))
    {
      adjustLevels(&promptStmSubs_promptStm_liLabel, "promptStm_liLabel");
      if (log && !findString("promptStm_liLabel", promptStmSubs))
	{
	  warnSub("promptStm_liLabel", "promptStm", a_promptStm);
	  check_promptStm_liLabel(
	    dynamic_cast<promptStm_liLabel *>(a_promptStm), 0);
	}
      else
	check_promptStm_liLabel(
	  dynamic_cast<promptStm_liLabel *>(a_promptStm), log);
      return;
    }
  if (isA(a_promptStm, promptStm_mdLabel))
    {
      adjustLevels(&promptStmSubs_promptStm_mdLabel, "promptStm_mdLabel");
      if (log && !findString("promptStm_mdLabel", promptStmSubs))
	{
	  warnSub("promptStm_mdLabel", "promptStm", a_promptStm);
	  check_promptStm_mdLabel(
	    dynamic_cast<promptStm_mdLabel *>(a_promptStm), 0);
	}
      else
	check_promptStm_mdLabel(
	  dynamic_cast<promptStm_mdLabel *>(a_promptStm), log);
      return;
    }
  if (isA(a_promptStm, promptStm_opLabel))
    {
      adjustLevels(&promptStmSubs_promptStm_opLabel, "promptStm_opLabel");
      if (log && !findString("promptStm_opLabel", promptStmSubs))
	{
	  warnSub("promptStm_opLabel", "promptStm", a_promptStm);
	  check_promptStm_opLabel(
	    dynamic_cast<promptStm_opLabel *>(a_promptStm), 0);
	}
      else
	check_promptStm_opLabel(
	  dynamic_cast<promptStm_opLabel *>(a_promptStm), log);
      return;
    }
  if (isA(a_promptStm, promptStm_pcLabel))
    {
      adjustLevels(&promptStmSubs_promptStm_pcLabel, "promptStm_pcLabel");
      if (log && !findString("promptStm_pcLabel", promptStmSubs))
	{
	  warnSub("promptStm_pcLabel", "promptStm", a_promptStm);
	  check_promptStm_pcLabel(
	    dynamic_cast<promptStm_pcLabel *>(a_promptStm), 0);
	}
      else
	check_promptStm_pcLabel(
	  dynamic_cast<promptStm_pcLabel *>(a_promptStm), log);
      return;
    }
  if (isA(a_promptStm, promptStm_plLabel))
    {
      adjustLevels(&promptStmSubs_promptStm_plLabel, "promptStm_plLabel");
      if (log && !findString("promptStm_plLabel", promptStmSubs))
	{
	  warnSub("promptStm_plLabel", "promptStm", a_promptStm);
	  check_promptStm_plLabel(
	    dynamic_cast<promptStm_plLabel *>(a_promptStm), 0);
	}
      else
	check_promptStm_plLabel(
	  dynamic_cast<promptStm_plLabel *>(a_promptStm), log);
      return;
    }
  if (isA(a_promptStm, promptStm_pnLabel))
    {
      adjustLevels(&promptStmSubs_promptStm_pnLabel, "promptStm_pnLabel");
      if (log && !findString("promptStm_pnLabel", promptStmSubs))
	{
	  warnSub("promptStm_pnLabel", "promptStm", a_promptStm);
	  check_promptStm_pnLabel(
	    dynamic_cast<promptStm_pnLabel *>(a_promptStm), 0);
	}
      else
	check_promptStm_pnLabel(
	  dynamic_cast<promptStm_pnLabel *>(a_promptStm), log);
      return;
    }
  if (isA(a_promptStm, promptStm_prLabel))
    {
      adjustLevels(&promptStmSubs_promptStm_prLabel, "promptStm_prLabel");
      if (log && !findString("promptStm_prLabel", promptStmSubs))
	{
	  warnSub("promptStm_prLabel", "promptStm", a_promptStm);
	  check_promptStm_prLabel(
	    dynamic_cast<promptStm_prLabel *>(a_promptStm), 0);
	}
      else
	check_promptStm_prLabel(
	  dynamic_cast<promptStm_prLabel *>(a_promptStm), log);
      return;
    }
  if (isA(a_promptStm, promptStm_psLabel))
    {
      adjustLevels(&promptStmSubs_promptStm_psLabel, "promptStm_psLabel");
      if (log && !findString("promptStm_psLabel", promptStmSubs))
	{
	  warnSub("promptStm_psLabel", "promptStm", a_promptStm);
	  check_promptStm_psLabel(
	    dynamic_cast<promptStm_psLabel *>(a_promptStm), 0);
	}
      else
	check_promptStm_psLabel(
	  dynamic_cast<promptStm_psLabel *>(a_promptStm), log);
      return;
    }
  if (isA(a_promptStm, promptStm_pvLabel))
    {
      adjustLevels(&promptStmSubs_promptStm_pvLabel, "promptStm_pvLabel");
      if (log && !findString("promptStm_pvLabel", promptStmSubs))
	{
	  warnSub("promptStm_pvLabel", "promptStm", a_promptStm);
	  check_promptStm_pvLabel(
	    dynamic_cast<promptStm_pvLabel *>(a_promptStm), 0);
	}
      else
	check_promptStm_pvLabel(
	  dynamic_cast<promptStm_pvLabel *>(a_promptStm), log);
      return;
    }
  if (isA(a_promptStm, promptStm_qLabel))
    {
      adjustLevels(&promptStmSubs_promptStm_qLabel, "promptStm_qLabel");
      if (log && !findString("promptStm_qLabel", promptStmSubs))
	{
	  warnSub("promptStm_qLabel", "promptStm", a_promptStm);
	  check_promptStm_qLabel(
	    dynamic_cast<promptStm_qLabel *>(a_promptStm), 0);
	}
      else
	check_promptStm_qLabel(
	  dynamic_cast<promptStm_qLabel *>(a_promptStm), log);
      return;
    }
  if (isA(a_promptStm, promptStm_tlLabel))
    {
      adjustLevels(&promptStmSubs_promptStm_tlLabel, "promptStm_tlLabel");
      if (log && !findString("promptStm_tlLabel", promptStmSubs))
	{
	  warnSub("promptStm_tlLabel", "promptStm", a_promptStm);
	  check_promptStm_tlLabel(
	    dynamic_cast<promptStm_tlLabel *>(a_promptStm), 0);
	}
      else
	check_promptStm_tlLabel(
	  dynamic_cast<promptStm_tlLabel *>(a_promptStm), log);
      return;
    }
}

/********************************************************************/

void check_promptStm_boolVar(
 promptStm_boolVar * a_promptStm_boolVar,
 int log)
{
  if (a_promptStm_boolVar->get_boolVar())
    {
      adjustLevels(&promptStm_boolVarAtts_a_boolVar,
		   "promptStm_boolVar a_boolVar");
      if (log && !findString("a_boolVar", promptStm_boolVarAtts))
	{
	  warnAtt("a_boolVar", "promptStm_boolVar", a_promptStm_boolVar);
	  check_boolVar(a_promptStm_boolVar->get_boolVar(), 0);
	}
      else
	check_boolVar(a_promptStm_boolVar->get_boolVar(), log);
    }
  if (a_promptStm_boolVar->get_text())
    {
      adjustLevels(&promptStm_boolVarAtts_text, "promptStm_boolVar text");
      if (log && !findString("text", promptStm_boolVarAtts))
	{
	  warnAtt("text", "promptStm_boolVar", a_promptStm_boolVar);
	  check_stringVal(a_promptStm_boolVar->get_text(), 0);
	}
      else
	check_stringVal(a_promptStm_boolVar->get_text(), log);
    }
}

/********************************************************************/

void check_promptStm_ccLabel(
 promptStm_ccLabel * a_promptStm_ccLabel,
 int log)
{
  if (a_promptStm_ccLabel->get_ccLabel())
    {
      adjustLevels(&promptStm_ccLabelAtts_a_ccLabel,
		   "promptStm_ccLabel a_ccLabel");
      if (log && !findString("a_ccLabel", promptStm_ccLabelAtts))
	{
	  warnAtt("a_ccLabel", "promptStm_ccLabel", a_promptStm_ccLabel);
	  check_ccLabel(a_promptStm_ccLabel->get_ccLabel(), 0);
	}
      else
	check_ccLabel(a_promptStm_ccLabel->get_ccLabel(), log);
    }
  if (a_promptStm_ccLabel->get_text())
    {
      adjustLevels(&promptStm_ccLabelAtts_text, "promptStm_ccLabel text");
      if (log && !findString("text", promptStm_ccLabelAtts))
	{
	  warnAtt("text", "promptStm_ccLabel", a_promptStm_ccLabel);
	  check_stringVal(a_promptStm_ccLabel->get_text(), 0);
	}
      else
	check_stringVal(a_promptStm_ccLabel->get_text(), log);
    }
  if (a_promptStm_ccLabel->get_maxSize())
    {
      adjustLevels(&promptStm_ccLabelAtts_maxSize,
		   "promptStm_ccLabel maxSize");
      if (log && !findString("maxSize", promptStm_ccLabelAtts))
	{
	  warnAtt("maxSize", "promptStm_ccLabel", a_promptStm_ccLabel);
	  check_intVal(a_promptStm_ccLabel->get_maxSize(), 0);
	}
      else
	check_intVal(a_promptStm_ccLabel->get_maxSize(), log);
    }
}

/********************************************************************/

void check_promptStm_ciLabel(
 promptStm_ciLabel * a_promptStm_ciLabel,
 int log)
{
  if (a_promptStm_ciLabel->get_ciLabel())
    {
      adjustLevels(&promptStm_ciLabelAtts_a_ciLabel,
		   "promptStm_ciLabel a_ciLabel");
      if (log && !findString("a_ciLabel", promptStm_ciLabelAtts))
	{
	  warnAtt("a_ciLabel", "promptStm_ciLabel", a_promptStm_ciLabel);
	  check_ciLabel(a_promptStm_ciLabel->get_ciLabel(), 0);
	}
      else
	check_ciLabel(a_promptStm_ciLabel->get_ciLabel(), log);
    }
  if (a_promptStm_ciLabel->get_text())
    {
      adjustLevels(&promptStm_ciLabelAtts_text, "promptStm_ciLabel text");
      if (log && !findString("text", promptStm_ciLabelAtts))
	{
	  warnAtt("text", "promptStm_ciLabel", a_promptStm_ciLabel);
	  check_stringVal(a_promptStm_ciLabel->get_text(), 0);
	}
      else
	check_stringVal(a_promptStm_ciLabel->get_text(), log);
    }
  if (a_promptStm_ciLabel->get_maxSize())
    {
      adjustLevels(&promptStm_ciLabelAtts_maxSize,
		   "promptStm_ciLabel maxSize");
      if (log && !findString("maxSize", promptStm_ciLabelAtts))
	{
	  warnAtt("maxSize", "promptStm_ciLabel", a_promptStm_ciLabel);
	  check_intVal(a_promptStm_ciLabel->get_maxSize(), 0);
	}
      else
	check_intVal(a_promptStm_ciLabel->get_maxSize(), log);
    }
}

/********************************************************************/

void check_promptStm_csLabel(
 promptStm_csLabel * a_promptStm_csLabel,
 int log)
{
  if (a_promptStm_csLabel->get_csLabel())
    {
      adjustLevels(&promptStm_csLabelAtts_a_csLabel,
		   "promptStm_csLabel a_csLabel");
      if (log && !findString("a_csLabel", promptStm_csLabelAtts))
	{
	  warnAtt("a_csLabel", "promptStm_csLabel", a_promptStm_csLabel);
	  check_csLabel(a_promptStm_csLabel->get_csLabel(), 0);
	}
      else
	check_csLabel(a_promptStm_csLabel->get_csLabel(), log);
    }
  if (a_promptStm_csLabel->get_text())
    {
      adjustLevels(&promptStm_csLabelAtts_text, "promptStm_csLabel text");
      if (log && !findString("text", promptStm_csLabelAtts))
	{
	  warnAtt("text", "promptStm_csLabel", a_promptStm_csLabel);
	  check_stringVal(a_promptStm_csLabel->get_text(), 0);
	}
      else
	check_stringVal(a_promptStm_csLabel->get_text(), log);
    }
  if (a_promptStm_csLabel->get_maxSize())
    {
      adjustLevels(&promptStm_csLabelAtts_maxSize,
		   "promptStm_csLabel maxSize");
      if (log && !findString("maxSize", promptStm_csLabelAtts))
	{
	  warnAtt("maxSize", "promptStm_csLabel", a_promptStm_csLabel);
	  check_intVal(a_promptStm_csLabel->get_maxSize(), 0);
	}
      else
	check_intVal(a_promptStm_csLabel->get_maxSize(), log);
    }
}

/********************************************************************/

void check_promptStm_diLabel(
 promptStm_diLabel * a_promptStm_diLabel,
 int log)
{
  if (a_promptStm_diLabel->get_diLabel())
    {
      adjustLevels(&promptStm_diLabelAtts_a_diLabel,
		   "promptStm_diLabel a_diLabel");
      if (log && !findString("a_diLabel", promptStm_diLabelAtts))
	{
	  warnAtt("a_diLabel", "promptStm_diLabel", a_promptStm_diLabel);
	  check_diLabel(a_promptStm_diLabel->get_diLabel(), 0);
	}
      else
	check_diLabel(a_promptStm_diLabel->get_diLabel(), log);
    }
  if (a_promptStm_diLabel->get_text())
    {
      adjustLevels(&promptStm_diLabelAtts_text, "promptStm_diLabel text");
      if (log && !findString("text", promptStm_diLabelAtts))
	{
	  warnAtt("text", "promptStm_diLabel", a_promptStm_diLabel);
	  check_stringVal(a_promptStm_diLabel->get_text(), 0);
	}
      else
	check_stringVal(a_promptStm_diLabel->get_text(), log);
    }
  if (a_promptStm_diLabel->get_maxSize())
    {
      adjustLevels(&promptStm_diLabelAtts_maxSize,
		   "promptStm_diLabel maxSize");
      if (log && !findString("maxSize", promptStm_diLabelAtts))
	{
	  warnAtt("maxSize", "promptStm_diLabel", a_promptStm_diLabel);
	  check_intVal(a_promptStm_diLabel->get_maxSize(), 0);
	}
      else
	check_intVal(a_promptStm_diLabel->get_maxSize(), log);
    }
}

/********************************************************************/

void check_promptStm_dsLabel(
 promptStm_dsLabel * a_promptStm_dsLabel,
 int log)
{
  if (a_promptStm_dsLabel->get_dsLabel())
    {
      adjustLevels(&promptStm_dsLabelAtts_a_dsLabel,
		   "promptStm_dsLabel a_dsLabel");
      if (log && !findString("a_dsLabel", promptStm_dsLabelAtts))
	{
	  warnAtt("a_dsLabel", "promptStm_dsLabel", a_promptStm_dsLabel);
	  check_dsLabel(a_promptStm_dsLabel->get_dsLabel(), 0);
	}
      else
	check_dsLabel(a_promptStm_dsLabel->get_dsLabel(), log);
    }
  if (a_promptStm_dsLabel->get_text())
    {
      adjustLevels(&promptStm_dsLabelAtts_text, "promptStm_dsLabel text");
      if (log && !findString("text", promptStm_dsLabelAtts))
	{
	  warnAtt("text", "promptStm_dsLabel", a_promptStm_dsLabel);
	  check_stringVal(a_promptStm_dsLabel->get_text(), 0);
	}
      else
	check_stringVal(a_promptStm_dsLabel->get_text(), log);
    }
  if (a_promptStm_dsLabel->get_maxSize())
    {
      adjustLevels(&promptStm_dsLabelAtts_maxSize,
		   "promptStm_dsLabel maxSize");
      if (log && !findString("maxSize", promptStm_dsLabelAtts))
	{
	  warnAtt("maxSize", "promptStm_dsLabel", a_promptStm_dsLabel);
	  check_intVal(a_promptStm_dsLabel->get_maxSize(), 0);
	}
      else
	check_intVal(a_promptStm_dsLabel->get_maxSize(), log);
    }
}

/********************************************************************/

void check_promptStm_dvLabel(
 promptStm_dvLabel * a_promptStm_dvLabel,
 int log)
{
  if (a_promptStm_dvLabel->get_dvLabel())
    {
      adjustLevels(&promptStm_dvLabelAtts_a_dvLabel,
		   "promptStm_dvLabel a_dvLabel");
      if (log && !findString("a_dvLabel", promptStm_dvLabelAtts))
	{
	  warnAtt("a_dvLabel", "promptStm_dvLabel", a_promptStm_dvLabel);
	  check_dvLabel(a_promptStm_dvLabel->get_dvLabel(), 0);
	}
      else
	check_dvLabel(a_promptStm_dvLabel->get_dvLabel(), log);
    }
  if (a_promptStm_dvLabel->get_text())
    {
      adjustLevels(&promptStm_dvLabelAtts_text, "promptStm_dvLabel text");
      if (log && !findString("text", promptStm_dvLabelAtts))
	{
	  warnAtt("text", "promptStm_dvLabel", a_promptStm_dvLabel);
	  check_stringVal(a_promptStm_dvLabel->get_text(), 0);
	}
      else
	check_stringVal(a_promptStm_dvLabel->get_text(), log);
    }
  if (a_promptStm_dvLabel->get_maxSize())
    {
      adjustLevels(&promptStm_dvLabelAtts_maxSize,
		   "promptStm_dvLabel maxSize");
      if (log && !findString("maxSize", promptStm_dvLabelAtts))
	{
	  warnAtt("maxSize", "promptStm_dvLabel", a_promptStm_dvLabel);
	  check_intVal(a_promptStm_dvLabel->get_maxSize(), 0);
	}
      else
	check_intVal(a_promptStm_dvLabel->get_maxSize(), log);
    }
}

/********************************************************************/

void check_promptStm_fiLabel(
 promptStm_fiLabel * a_promptStm_fiLabel,
 int log)
{
  if (a_promptStm_fiLabel->get_fiLabel())
    {
      adjustLevels(&promptStm_fiLabelAtts_a_fiLabel,
		   "promptStm_fiLabel a_fiLabel");
      if (log && !findString("a_fiLabel", promptStm_fiLabelAtts))
	{
	  warnAtt("a_fiLabel", "promptStm_fiLabel", a_promptStm_fiLabel);
	  check_fiLabel(a_promptStm_fiLabel->get_fiLabel(), 0);
	}
      else
	check_fiLabel(a_promptStm_fiLabel->get_fiLabel(), log);
    }
  if (a_promptStm_fiLabel->get_text())
    {
      adjustLevels(&promptStm_fiLabelAtts_text, "promptStm_fiLabel text");
      if (log && !findString("text", promptStm_fiLabelAtts))
	{
	  warnAtt("text", "promptStm_fiLabel", a_promptStm_fiLabel);
	  check_stringVal(a_promptStm_fiLabel->get_text(), 0);
	}
      else
	check_stringVal(a_promptStm_fiLabel->get_text(), log);
    }
  if (a_promptStm_fiLabel->get_maxSize())
    {
      adjustLevels(&promptStm_fiLabelAtts_maxSize,
		   "promptStm_fiLabel maxSize");
      if (log && !findString("maxSize", promptStm_fiLabelAtts))
	{
	  warnAtt("maxSize", "promptStm_fiLabel", a_promptStm_fiLabel);
	  check_intVal(a_promptStm_fiLabel->get_maxSize(), 0);
	}
      else
	check_intVal(a_promptStm_fiLabel->get_maxSize(), log);
    }
}

/********************************************************************/

void check_promptStm_fsLabel(
 promptStm_fsLabel * a_promptStm_fsLabel,
 int log)
{
  if (a_promptStm_fsLabel->get_fsLabel())
    {
      adjustLevels(&promptStm_fsLabelAtts_a_fsLabel,
		   "promptStm_fsLabel a_fsLabel");
      if (log && !findString("a_fsLabel", promptStm_fsLabelAtts))
	{
	  warnAtt("a_fsLabel", "promptStm_fsLabel", a_promptStm_fsLabel);
	  check_fsLabel(a_promptStm_fsLabel->get_fsLabel(), 0);
	}
      else
	check_fsLabel(a_promptStm_fsLabel->get_fsLabel(), log);
    }
  if (a_promptStm_fsLabel->get_text())
    {
      adjustLevels(&promptStm_fsLabelAtts_text, "promptStm_fsLabel text");
      if (log && !findString("text", promptStm_fsLabelAtts))
	{
	  warnAtt("text", "promptStm_fsLabel", a_promptStm_fsLabel);
	  check_stringVal(a_promptStm_fsLabel->get_text(), 0);
	}
      else
	check_stringVal(a_promptStm_fsLabel->get_text(), log);
    }
  if (a_promptStm_fsLabel->get_maxSize())
    {
      adjustLevels(&promptStm_fsLabelAtts_maxSize,
		   "promptStm_fsLabel maxSize");
      if (log && !findString("maxSize", promptStm_fsLabelAtts))
	{
	  warnAtt("maxSize", "promptStm_fsLabel", a_promptStm_fsLabel);
	  check_intVal(a_promptStm_fsLabel->get_maxSize(), 0);
	}
      else
	check_intVal(a_promptStm_fsLabel->get_maxSize(), log);
    }
}

/********************************************************************/

void check_promptStm_intVar(
 promptStm_intVar * a_promptStm_intVar,
 int log)
{
  if (a_promptStm_intVar->get_intVar())
    {
      adjustLevels(&promptStm_intVarAtts_a_intVar,
		   "promptStm_intVar a_intVar");
      if (log && !findString("a_intVar", promptStm_intVarAtts))
	{
	  warnAtt("a_intVar", "promptStm_intVar", a_promptStm_intVar);
	  check_intVar(a_promptStm_intVar->get_intVar(), 0);
	}
      else
	check_intVar(a_promptStm_intVar->get_intVar(), log);
    }
  if (a_promptStm_intVar->get_promptIntEnd())
    {
      adjustLevels(&promptStm_intVarAtts_a_promptIntEnd,
		   "promptStm_intVar a_promptIntEnd");
      if (log && !findString("a_promptIntEnd", promptStm_intVarAtts))
	{
	  warnAtt("a_promptIntEnd", "promptStm_intVar", a_promptStm_intVar);
	  check_promptIntEnd(a_promptStm_intVar->get_promptIntEnd(), 0);
	}
      else
	check_promptIntEnd(a_promptStm_intVar->get_promptIntEnd(), log);
    }
}

/********************************************************************/

void check_promptStm_liLabel(
 promptStm_liLabel * a_promptStm_liLabel,
 int log)
{
  if (a_promptStm_liLabel->get_liLabel())
    {
      adjustLevels(&promptStm_liLabelAtts_a_liLabel,
		   "promptStm_liLabel a_liLabel");
      if (log && !findString("a_liLabel", promptStm_liLabelAtts))
	{
	  warnAtt("a_liLabel", "promptStm_liLabel", a_promptStm_liLabel);
	  check_liLabel(a_promptStm_liLabel->get_liLabel(), 0);
	}
      else
	check_liLabel(a_promptStm_liLabel->get_liLabel(), log);
    }
  if (a_promptStm_liLabel->get_text())
    {
      adjustLevels(&promptStm_liLabelAtts_text, "promptStm_liLabel text");
      if (log && !findString("text", promptStm_liLabelAtts))
	{
	  warnAtt("text", "promptStm_liLabel", a_promptStm_liLabel);
	  check_stringVal(a_promptStm_liLabel->get_text(), 0);
	}
      else
	check_stringVal(a_promptStm_liLabel->get_text(), log);
    }
  if (a_promptStm_liLabel->get_maxSize())
    {
      adjustLevels(&promptStm_liLabelAtts_maxSize,
		   "promptStm_liLabel maxSize");
      if (log && !findString("maxSize", promptStm_liLabelAtts))
	{
	  warnAtt("maxSize", "promptStm_liLabel", a_promptStm_liLabel);
	  check_intVal(a_promptStm_liLabel->get_maxSize(), 0);
	}
      else
	check_intVal(a_promptStm_liLabel->get_maxSize(), log);
    }
}

/********************************************************************/

void check_promptStm_mdLabel(
 promptStm_mdLabel * a_promptStm_mdLabel,
 int log)
{
  if (a_promptStm_mdLabel->get_mdLabel())
    {
      adjustLevels(&promptStm_mdLabelAtts_a_mdLabel,
		   "promptStm_mdLabel a_mdLabel");
      if (log && !findString("a_mdLabel", promptStm_mdLabelAtts))
	{
	  warnAtt("a_mdLabel", "promptStm_mdLabel", a_promptStm_mdLabel);
	  check_mdLabel(a_promptStm_mdLabel->get_mdLabel(), 0);
	}
      else
	check_mdLabel(a_promptStm_mdLabel->get_mdLabel(), log);
    }
  if (a_promptStm_mdLabel->get_text())
    {
      adjustLevels(&promptStm_mdLabelAtts_text, "promptStm_mdLabel text");
      if (log && !findString("text", promptStm_mdLabelAtts))
	{
	  warnAtt("text", "promptStm_mdLabel", a_promptStm_mdLabel);
	  check_stringVal(a_promptStm_mdLabel->get_text(), 0);
	}
      else
	check_stringVal(a_promptStm_mdLabel->get_text(), log);
    }
  if (a_promptStm_mdLabel->get_maxSize())
    {
      adjustLevels(&promptStm_mdLabelAtts_maxSize,
		   "promptStm_mdLabel maxSize");
      if (log && !findString("maxSize", promptStm_mdLabelAtts))
	{
	  warnAtt("maxSize", "promptStm_mdLabel", a_promptStm_mdLabel);
	  check_intVal(a_promptStm_mdLabel->get_maxSize(), 0);
	}
      else
	check_intVal(a_promptStm_mdLabel->get_maxSize(), log);
    }
}

/********************************************************************/

void check_promptStm_opLabel(
 promptStm_opLabel * a_promptStm_opLabel,
 int log)
{
  if (a_promptStm_opLabel->get_opLabel())
    {
      adjustLevels(&promptStm_opLabelAtts_a_opLabel,
		   "promptStm_opLabel a_opLabel");
      if (log && !findString("a_opLabel", promptStm_opLabelAtts))
	{
	  warnAtt("a_opLabel", "promptStm_opLabel", a_promptStm_opLabel);
	  check_opLabel(a_promptStm_opLabel->get_opLabel(), 0);
	}
      else
	check_opLabel(a_promptStm_opLabel->get_opLabel(), log);
    }
  if (a_promptStm_opLabel->get_text())
    {
      adjustLevels(&promptStm_opLabelAtts_text, "promptStm_opLabel text");
      if (log && !findString("text", promptStm_opLabelAtts))
	{
	  warnAtt("text", "promptStm_opLabel", a_promptStm_opLabel);
	  check_stringVal(a_promptStm_opLabel->get_text(), 0);
	}
      else
	check_stringVal(a_promptStm_opLabel->get_text(), log);
    }
  if (a_promptStm_opLabel->get_maxSize())
    {
      adjustLevels(&promptStm_opLabelAtts_maxSize,
		   "promptStm_opLabel maxSize");
      if (log && !findString("maxSize", promptStm_opLabelAtts))
	{
	  warnAtt("maxSize", "promptStm_opLabel", a_promptStm_opLabel);
	  check_intVal(a_promptStm_opLabel->get_maxSize(), 0);
	}
      else
	check_intVal(a_promptStm_opLabel->get_maxSize(), log);
    }
}

/********************************************************************/

void check_promptStm_pcLabel(
 promptStm_pcLabel * a_promptStm_pcLabel,
 int log)
{
  if (a_promptStm_pcLabel->get_pcLabel())
    {
      adjustLevels(&promptStm_pcLabelAtts_a_pcLabel,
		   "promptStm_pcLabel a_pcLabel");
      if (log && !findString("a_pcLabel", promptStm_pcLabelAtts))
	{
	  warnAtt("a_pcLabel", "promptStm_pcLabel", a_promptStm_pcLabel);
	  check_pcLabel(a_promptStm_pcLabel->get_pcLabel(), 0);
	}
      else
	check_pcLabel(a_promptStm_pcLabel->get_pcLabel(), log);
    }
  if (a_promptStm_pcLabel->get_text())
    {
      adjustLevels(&promptStm_pcLabelAtts_text, "promptStm_pcLabel text");
      if (log && !findString("text", promptStm_pcLabelAtts))
	{
	  warnAtt("text", "promptStm_pcLabel", a_promptStm_pcLabel);
	  check_stringVal(a_promptStm_pcLabel->get_text(), 0);
	}
      else
	check_stringVal(a_promptStm_pcLabel->get_text(), log);
    }
  if (a_promptStm_pcLabel->get_maxSize())
    {
      adjustLevels(&promptStm_pcLabelAtts_maxSize,
		   "promptStm_pcLabel maxSize");
      if (log && !findString("maxSize", promptStm_pcLabelAtts))
	{
	  warnAtt("maxSize", "promptStm_pcLabel", a_promptStm_pcLabel);
	  check_intVal(a_promptStm_pcLabel->get_maxSize(), 0);
	}
      else
	check_intVal(a_promptStm_pcLabel->get_maxSize(), log);
    }
}

/********************************************************************/

void check_promptStm_plLabel(
 promptStm_plLabel * a_promptStm_plLabel,
 int log)
{
  if (a_promptStm_plLabel->get_plLabel())
    {
      adjustLevels(&promptStm_plLabelAtts_a_plLabel,
		   "promptStm_plLabel a_plLabel");
      if (log && !findString("a_plLabel", promptStm_plLabelAtts))
	{
	  warnAtt("a_plLabel", "promptStm_plLabel", a_promptStm_plLabel);
	  check_plLabel(a_promptStm_plLabel->get_plLabel(), 0);
	}
      else
	check_plLabel(a_promptStm_plLabel->get_plLabel(), log);
    }
  if (a_promptStm_plLabel->get_text())
    {
      adjustLevels(&promptStm_plLabelAtts_text, "promptStm_plLabel text");
      if (log && !findString("text", promptStm_plLabelAtts))
	{
	  warnAtt("text", "promptStm_plLabel", a_promptStm_plLabel);
	  check_stringVal(a_promptStm_plLabel->get_text(), 0);
	}
      else
	check_stringVal(a_promptStm_plLabel->get_text(), log);
    }
  if (a_promptStm_plLabel->get_maxSize())
    {
      adjustLevels(&promptStm_plLabelAtts_maxSize,
		   "promptStm_plLabel maxSize");
      if (log && !findString("maxSize", promptStm_plLabelAtts))
	{
	  warnAtt("maxSize", "promptStm_plLabel", a_promptStm_plLabel);
	  check_intVal(a_promptStm_plLabel->get_maxSize(), 0);
	}
      else
	check_intVal(a_promptStm_plLabel->get_maxSize(), log);
    }
}

/********************************************************************/

void check_promptStm_pnLabel(
 promptStm_pnLabel * a_promptStm_pnLabel,
 int log)
{
  if (a_promptStm_pnLabel->get_pnLabel())
    {
      adjustLevels(&promptStm_pnLabelAtts_a_pnLabel,
		   "promptStm_pnLabel a_pnLabel");
      if (log && !findString("a_pnLabel", promptStm_pnLabelAtts))
	{
	  warnAtt("a_pnLabel", "promptStm_pnLabel", a_promptStm_pnLabel);
	  check_pnLabel(a_promptStm_pnLabel->get_pnLabel(), 0);
	}
      else
	check_pnLabel(a_promptStm_pnLabel->get_pnLabel(), log);
    }
  if (a_promptStm_pnLabel->get_text())
    {
      adjustLevels(&promptStm_pnLabelAtts_text, "promptStm_pnLabel text");
      if (log && !findString("text", promptStm_pnLabelAtts))
	{
	  warnAtt("text", "promptStm_pnLabel", a_promptStm_pnLabel);
	  check_stringVal(a_promptStm_pnLabel->get_text(), 0);
	}
      else
	check_stringVal(a_promptStm_pnLabel->get_text(), log);
    }
  if (a_promptStm_pnLabel->get_maxSize())
    {
      adjustLevels(&promptStm_pnLabelAtts_maxSize,
		   "promptStm_pnLabel maxSize");
      if (log && !findString("maxSize", promptStm_pnLabelAtts))
	{
	  warnAtt("maxSize", "promptStm_pnLabel", a_promptStm_pnLabel);
	  check_intVal(a_promptStm_pnLabel->get_maxSize(), 0);
	}
      else
	check_intVal(a_promptStm_pnLabel->get_maxSize(), log);
    }
}

/********************************************************************/

void check_promptStm_prLabel(
 promptStm_prLabel * a_promptStm_prLabel,
 int log)
{
  if (a_promptStm_prLabel->get_prLabel())
    {
      adjustLevels(&promptStm_prLabelAtts_a_prLabel,
		   "promptStm_prLabel a_prLabel");
      if (log && !findString("a_prLabel", promptStm_prLabelAtts))
	{
	  warnAtt("a_prLabel", "promptStm_prLabel", a_promptStm_prLabel);
	  check_prLabel(a_promptStm_prLabel->get_prLabel(), 0);
	}
      else
	check_prLabel(a_promptStm_prLabel->get_prLabel(), log);
    }
  if (a_promptStm_prLabel->get_text())
    {
      adjustLevels(&promptStm_prLabelAtts_text, "promptStm_prLabel text");
      if (log && !findString("text", promptStm_prLabelAtts))
	{
	  warnAtt("text", "promptStm_prLabel", a_promptStm_prLabel);
	  check_stringVal(a_promptStm_prLabel->get_text(), 0);
	}
      else
	check_stringVal(a_promptStm_prLabel->get_text(), log);
    }
  if (a_promptStm_prLabel->get_maxSize())
    {
      adjustLevels(&promptStm_prLabelAtts_maxSize,
		   "promptStm_prLabel maxSize");
      if (log && !findString("maxSize", promptStm_prLabelAtts))
	{
	  warnAtt("maxSize", "promptStm_prLabel", a_promptStm_prLabel);
	  check_intVal(a_promptStm_prLabel->get_maxSize(), 0);
	}
      else
	check_intVal(a_promptStm_prLabel->get_maxSize(), log);
    }
}

/********************************************************************/

void check_promptStm_psLabel(
 promptStm_psLabel * a_promptStm_psLabel,
 int log)
{
  if (a_promptStm_psLabel->get_psLabel())
    {
      adjustLevels(&promptStm_psLabelAtts_a_psLabel,
		   "promptStm_psLabel a_psLabel");
      if (log && !findString("a_psLabel", promptStm_psLabelAtts))
	{
	  warnAtt("a_psLabel", "promptStm_psLabel", a_promptStm_psLabel);
	  check_psLabel(a_promptStm_psLabel->get_psLabel(), 0);
	}
      else
	check_psLabel(a_promptStm_psLabel->get_psLabel(), log);
    }
  if (a_promptStm_psLabel->get_text())
    {
      adjustLevels(&promptStm_psLabelAtts_text, "promptStm_psLabel text");
      if (log && !findString("text", promptStm_psLabelAtts))
	{
	  warnAtt("text", "promptStm_psLabel", a_promptStm_psLabel);
	  check_stringVal(a_promptStm_psLabel->get_text(), 0);
	}
      else
	check_stringVal(a_promptStm_psLabel->get_text(), log);
    }
  if (a_promptStm_psLabel->get_maxSize())
    {
      adjustLevels(&promptStm_psLabelAtts_maxSize,
		   "promptStm_psLabel maxSize");
      if (log && !findString("maxSize", promptStm_psLabelAtts))
	{
	  warnAtt("maxSize", "promptStm_psLabel", a_promptStm_psLabel);
	  check_intVal(a_promptStm_psLabel->get_maxSize(), 0);
	}
      else
	check_intVal(a_promptStm_psLabel->get_maxSize(), log);
    }
}

/********************************************************************/

void check_promptStm_pvLabel(
 promptStm_pvLabel * a_promptStm_pvLabel,
 int log)
{
  if (a_promptStm_pvLabel->get_pvLabel())
    {
      adjustLevels(&promptStm_pvLabelAtts_a_pvLabel,
		   "promptStm_pvLabel a_pvLabel");
      if (log && !findString("a_pvLabel", promptStm_pvLabelAtts))
	{
	  warnAtt("a_pvLabel", "promptStm_pvLabel", a_promptStm_pvLabel);
	  check_pvLabel(a_promptStm_pvLabel->get_pvLabel(), 0);
	}
      else
	check_pvLabel(a_promptStm_pvLabel->get_pvLabel(), log);
    }
  if (a_promptStm_pvLabel->get_text())
    {
      adjustLevels(&promptStm_pvLabelAtts_text, "promptStm_pvLabel text");
      if (log && !findString("text", promptStm_pvLabelAtts))
	{
	  warnAtt("text", "promptStm_pvLabel", a_promptStm_pvLabel);
	  check_stringVal(a_promptStm_pvLabel->get_text(), 0);
	}
      else
	check_stringVal(a_promptStm_pvLabel->get_text(), log);
    }
  if (a_promptStm_pvLabel->get_maxSize())
    {
      adjustLevels(&promptStm_pvLabelAtts_maxSize,
		   "promptStm_pvLabel maxSize");
      if (log && !findString("maxSize", promptStm_pvLabelAtts))
	{
	  warnAtt("maxSize", "promptStm_pvLabel", a_promptStm_pvLabel);
	  check_intVal(a_promptStm_pvLabel->get_maxSize(), 0);
	}
      else
	check_intVal(a_promptStm_pvLabel->get_maxSize(), log);
    }
}

/********************************************************************/

void check_promptStm_qLabel(
 promptStm_qLabel * a_promptStm_qLabel,
 int log)
{
  if (a_promptStm_qLabel->get_qLabel())
    {
      adjustLevels(&promptStm_qLabelAtts_a_qLabel,
		   "promptStm_qLabel a_qLabel");
      if (log && !findString("a_qLabel", promptStm_qLabelAtts))
	{
	  warnAtt("a_qLabel", "promptStm_qLabel", a_promptStm_qLabel);
	  check_qLabel(a_promptStm_qLabel->get_qLabel(), 0);
	}
      else
	check_qLabel(a_promptStm_qLabel->get_qLabel(), log);
    }
  if (a_promptStm_qLabel->get_text())
    {
      adjustLevels(&promptStm_qLabelAtts_text, "promptStm_qLabel text");
      if (log && !findString("text", promptStm_qLabelAtts))
	{
	  warnAtt("text", "promptStm_qLabel", a_promptStm_qLabel);
	  check_stringVal(a_promptStm_qLabel->get_text(), 0);
	}
      else
	check_stringVal(a_promptStm_qLabel->get_text(), log);
    }
  if (a_promptStm_qLabel->get_maxSize())
    {
      adjustLevels(&promptStm_qLabelAtts_maxSize, "promptStm_qLabel maxSize");
      if (log && !findString("maxSize", promptStm_qLabelAtts))
	{
	  warnAtt("maxSize", "promptStm_qLabel", a_promptStm_qLabel);
	  check_intVal(a_promptStm_qLabel->get_maxSize(), 0);
	}
      else
	check_intVal(a_promptStm_qLabel->get_maxSize(), log);
    }
}

/********************************************************************/

void check_promptStm_realVar(
 promptStm_realVar * a_promptStm_realVar,
 int log)
{
  if (a_promptStm_realVar->get_realVar())
    {
      adjustLevels(&promptStm_realVarAtts_a_realVar,
		   "promptStm_realVar a_realVar");
      if (log && !findString("a_realVar", promptStm_realVarAtts))
	{
	  warnAtt("a_realVar", "promptStm_realVar", a_promptStm_realVar);
	  check_realVar(a_promptStm_realVar->get_realVar(), 0);
	}
      else
	check_realVar(a_promptStm_realVar->get_realVar(), log);
    }
  if (a_promptStm_realVar->get_text())
    {
      adjustLevels(&promptStm_realVarAtts_text, "promptStm_realVar text");
      if (log && !findString("text", promptStm_realVarAtts))
	{
	  warnAtt("text", "promptStm_realVar", a_promptStm_realVar);
	  check_stringVal(a_promptStm_realVar->get_text(), 0);
	}
      else
	check_stringVal(a_promptStm_realVar->get_text(), log);
    }
  if (a_promptStm_realVar->get_maxval())
    {
      adjustLevels(&promptStm_realVarAtts_maxval, "promptStm_realVar maxval");
      if (log && !findString("maxval", promptStm_realVarAtts))
	{
	  warnAtt("maxval", "promptStm_realVar", a_promptStm_realVar);
	  check_rentVal(a_promptStm_realVar->get_maxval(), 0);
	}
      else
	check_rentVal(a_promptStm_realVar->get_maxval(), log);
    }
  if (a_promptStm_realVar->get_minval())
    {
      adjustLevels(&promptStm_realVarAtts_minval, "promptStm_realVar minval");
      if (log && !findString("minval", promptStm_realVarAtts))
	{
	  warnAtt("minval", "promptStm_realVar", a_promptStm_realVar);
	  check_rentVal(a_promptStm_realVar->get_minval(), 0);
	}
      else
	check_rentVal(a_promptStm_realVar->get_minval(), log);
    }
}

/********************************************************************/

void check_promptStm_stringVar(
 promptStm_stringVar * a_promptStm_stringVar,
 int log)
{
  if (a_promptStm_stringVar->get_stringVar())
    {
      adjustLevels(&promptStm_stringVarAtts_a_stringVar,
		   "promptStm_stringVar a_stringVar");
      if (log && !findString("a_stringVar", promptStm_stringVarAtts))
	{
	  warnAtt("a_stringVar", "promptStm_stringVar",
		  a_promptStm_stringVar);
	  check_stringVar(a_promptStm_stringVar->get_stringVar(), 0);
	}
      else
	check_stringVar(a_promptStm_stringVar->get_stringVar(), log);
    }
  if (a_promptStm_stringVar->get_text())
    {
      adjustLevels(&promptStm_stringVarAtts_text, "promptStm_stringVar text");
      if (log && !findString("text", promptStm_stringVarAtts))
	{
	  warnAtt("text", "promptStm_stringVar", a_promptStm_stringVar);
	  check_stringVal(a_promptStm_stringVar->get_text(), 0);
	}
      else
	check_stringVal(a_promptStm_stringVar->get_text(), log);
    }
  if (a_promptStm_stringVar->get_maxSize())
    {
      adjustLevels(&promptStm_stringVarAtts_maxSize,
		   "promptStm_stringVar maxSize");
      if (log && !findString("maxSize", promptStm_stringVarAtts))
	{
	  warnAtt("maxSize", "promptStm_stringVar", a_promptStm_stringVar);
	  check_intVal(a_promptStm_stringVar->get_maxSize(), 0);
	}
      else
	check_intVal(a_promptStm_stringVar->get_maxSize(), log);
    }
}

/********************************************************************/

void check_promptStm_tlLabel(
 promptStm_tlLabel * a_promptStm_tlLabel,
 int log)
{
  if (a_promptStm_tlLabel->get_tlLabel())
    {
      adjustLevels(&promptStm_tlLabelAtts_a_tlLabel,
		   "promptStm_tlLabel a_tlLabel");
      if (log && !findString("a_tlLabel", promptStm_tlLabelAtts))
	{
	  warnAtt("a_tlLabel", "promptStm_tlLabel", a_promptStm_tlLabel);
	  check_tlLabel(a_promptStm_tlLabel->get_tlLabel(), 0);
	}
      else
	check_tlLabel(a_promptStm_tlLabel->get_tlLabel(), log);
    }
  if (a_promptStm_tlLabel->get_text())
    {
      adjustLevels(&promptStm_tlLabelAtts_text, "promptStm_tlLabel text");
      if (log && !findString("text", promptStm_tlLabelAtts))
	{
	  warnAtt("text", "promptStm_tlLabel", a_promptStm_tlLabel);
	  check_stringVal(a_promptStm_tlLabel->get_text(), 0);
	}
      else
	check_stringVal(a_promptStm_tlLabel->get_text(), log);
    }
  if (a_promptStm_tlLabel->get_maxSize())
    {
      adjustLevels(&promptStm_tlLabelAtts_maxSize,
		   "promptStm_tlLabel maxSize");
      if (log && !findString("maxSize", promptStm_tlLabelAtts))
	{
	  warnAtt("maxSize", "promptStm_tlLabel", a_promptStm_tlLabel);
	  check_intVal(a_promptStm_tlLabel->get_maxSize(), 0);
	}
      else
	check_intVal(a_promptStm_tlLabel->get_maxSize(), log);
    }
}

/********************************************************************/

void check_promptVar(
 promptVar * a_promptVar,
 int log)
{
  if (isA(a_promptVar, stringVar))
    {
      adjustLevels(&promptVarSubs_stringVar, "stringVar");
      if (log && !findString("stringVar", promptVarSubs))
	{
	  warnSub("stringVar", "promptVar", a_promptVar);
	  check_stringVar(dynamic_cast<stringVar *>(a_promptVar), 0);
	}
      else
	check_stringVar(dynamic_cast<stringVar *>(a_promptVar), log);
      return;
    }
  if (isA(a_promptVar, boolVar))
    {
      adjustLevels(&promptVarSubs_boolVar, "boolVar");
      if (log && !findString("boolVar", promptVarSubs))
	{
	  warnSub("boolVar", "promptVar", a_promptVar);
	  check_boolVar(dynamic_cast<boolVar *>(a_promptVar), 0);
	}
      else
	check_boolVar(dynamic_cast<boolVar *>(a_promptVar), log);
      return;
    }
  if (isA(a_promptVar, intVar))
    {
      adjustLevels(&promptVarSubs_intVar, "intVar");
      if (log && !findString("intVar", promptVarSubs))
	{
	  warnSub("intVar", "promptVar", a_promptVar);
	  check_intVar(dynamic_cast<intVar *>(a_promptVar), 0);
	}
      else
	check_intVar(dynamic_cast<intVar *>(a_promptVar), log);
      return;
    }
  if (isA(a_promptVar, realVar))
    {
      adjustLevels(&promptVarSubs_realVar, "realVar");
      if (log && !findString("realVar", promptVarSubs))
	{
	  warnSub("realVar", "promptVar", a_promptVar);
	  check_realVar(dynamic_cast<realVar *>(a_promptVar), 0);
	}
      else
	check_realVar(dynamic_cast<realVar *>(a_promptVar), log);
      return;
    }
  if (isA(a_promptVar, qisLabel))
    {
      adjustLevels(&promptVarSubs_qisLabel, "qisLabel");
      if (log && !findString("qisLabel", promptVarSubs))
	{
	  warnSub("qisLabel", "promptVar", a_promptVar);
	  check_qisLabel(dynamic_cast<qisLabel *>(a_promptVar), 0);
	}
      else
	check_qisLabel(dynamic_cast<qisLabel *>(a_promptVar), log);
      return;
    }
}

/********************************************************************/

void check_psLabel(
 psLabel * a_psLabel,
 int log)
{
  if (a_psLabel->get_labelName())
    {
      adjustLevels(&psLabelAtts_a_labelName, "psLabel a_labelName");
      if (log && !findString("a_labelName", psLabelAtts))
	{
	  warnAtt("a_labelName", "psLabel", a_psLabel);
	  check_labelName(a_psLabel->get_labelName(), 0);
	}
      else
	check_labelName(a_psLabel->get_labelName(), log);
    }
}

/********************************************************************/

void check_psthruMinor(
 psthruMinor * a_psthruMinor,
 int log)
{
  if (isA(a_psthruMinor, psthruMinor_COMAND))
    {
      adjustLevels(&psthruMinorSubs_psthruMinor_COMAND, "psthruMinor_COMAND");
      if (log && !findString("psthruMinor_COMAND", psthruMinorSubs))
	{
	  warnSub("psthruMinor_COMAND", "psthruMinor", a_psthruMinor);
	  check_psthruMinor_COMAND(
	    dynamic_cast<psthruMinor_COMAND *>(a_psthruMinor), 0);
	}
      else
	check_psthruMinor_COMAND(
	  dynamic_cast<psthruMinor_COMAND *>(a_psthruMinor), log);
      return;
    }
  if (isA(a_psthruMinor, psthruMinor_CONTIN))
    {
      adjustLevels(&psthruMinorSubs_psthruMinor_CONTIN, "psthruMinor_CONTIN");
      if (log && !findString("psthruMinor_CONTIN", psthruMinorSubs))
	{
	  warnSub("psthruMinor_CONTIN", "psthruMinor", a_psthruMinor);
	}
      return;
    }
  if (isA(a_psthruMinor, psthruMinor_PAUSE))
    {
      adjustLevels(&psthruMinorSubs_psthruMinor_PAUSE, "psthruMinor_PAUSE");
      if (log && !findString("psthruMinor_PAUSE", psthruMinorSubs))
	{
	  warnSub("psthruMinor_PAUSE", "psthruMinor", a_psthruMinor);
	}
      return;
    }
  if (isA(a_psthruMinor, psthruMinor_START))
    {
      adjustLevels(&psthruMinorSubs_psthruMinor_START, "psthruMinor_START");
      if (log && !findString("psthruMinor_START", psthruMinorSubs))
	{
	  warnSub("psthruMinor_START", "psthruMinor", a_psthruMinor);
	}
      return;
    }
  if (isA(a_psthruMinor, psthruMinor_STOP))
    {
      adjustLevels(&psthruMinorSubs_psthruMinor_STOP, "psthruMinor_STOP");
      if (log && !findString("psthruMinor_STOP", psthruMinorSubs))
	{
	  warnSub("psthruMinor_STOP", "psthruMinor", a_psthruMinor);
	}
      return;
    }
  if (isA(a_psthruMinor, psthruMinor_TRMATX))
    {
      adjustLevels(&psthruMinorSubs_psthruMinor_TRMATX, "psthruMinor_TRMATX");
      if (log && !findString("psthruMinor_TRMATX", psthruMinorSubs))
	{
	  warnSub("psthruMinor_TRMATX", "psthruMinor", a_psthruMinor);
	  check_psthruMinor_TRMATX(
	    dynamic_cast<psthruMinor_TRMATX *>(a_psthruMinor), 0);
	}
      else
	check_psthruMinor_TRMATX(
	  dynamic_cast<psthruMinor_TRMATX *>(a_psthruMinor), log);
      return;
    }
}

/********************************************************************/

void check_psthruMinor_COMAND(
 psthruMinor_COMAND * a_psthruMinor_COMAND,
 int log)
{
  if (a_psthruMinor_COMAND->get_command())
    {
      adjustLevels(&psthruMinor_COMANDAtts_command,
		   "psthruMinor_COMAND command");
      if (log && !findString("command", psthruMinor_COMANDAtts))
	{
	  warnAtt("command", "psthruMinor_COMAND", a_psthruMinor_COMAND);
	  check_stringVal(a_psthruMinor_COMAND->get_command(), 0);
	}
      else
	check_stringVal(a_psthruMinor_COMAND->get_command(), log);
    }
}

/********************************************************************/

void check_psthruMinor_TRMATX(
 psthruMinor_TRMATX * a_psthruMinor_TRMATX,
 int log)
{
  if (a_psthruMinor_TRMATX->get_matrix())
    {
      adjustLevels(&psthruMinor_TRMATXAtts_a_matrix,
		   "psthruMinor_TRMATX a_matrix");
      if (log && !findString("a_matrix", psthruMinor_TRMATXAtts))
	{
	  warnAtt("a_matrix", "psthruMinor_TRMATX", a_psthruMinor_TRMATX);
	  check_matrix(a_psthruMinor_TRMATX->get_matrix(), 0);
	}
      else
	check_matrix(a_psthruMinor_TRMATX->get_matrix(), log);
    }
}

/********************************************************************/

void check_psthruStm(
 psthruStm * a_psthruStm,
 int log)
{
  if (a_psthruStm->get_psthruMinor())
    {
      adjustLevels(&psthruStmAtts_a_psthruMinor, "psthruStm a_psthruMinor");
      if (log && !findString("a_psthruMinor", psthruStmAtts))
	{
	  warnAtt("a_psthruMinor", "psthruStm", a_psthruStm);
	  check_psthruMinor(a_psthruStm->get_psthruMinor(), 0);
	}
      else
	check_psthruMinor(a_psthruStm->get_psthruMinor(), log);
    }
}

/********************************************************************/

void check_ptbuffStm(
 ptbuffStm * a_ptbuffStm,
 int log)
{
  if (a_ptbuffStm->get_state())
    {
      adjustLevels(&ptbuffStmAtts_a_state, "ptbuffStm a_state");
      if (log && !findString("a_state", ptbuffStmAtts))
	{
	  warnAtt("a_state", "ptbuffStm", a_ptbuffStm);
	  check_state(a_ptbuffStm->get_state(), 0);
	}
      else
	check_state(a_ptbuffStm->get_state(), log);
    }
}

/********************************************************************/

void check_ptmeasEnd(
 ptmeasEnd * a_ptmeasEnd,
 int log)
{
  if (isA(a_ptmeasEnd, ptmeasEnd_csSpec))
    {
      adjustLevels(&ptmeasEndSubs_ptmeasEnd_csSpec, "ptmeasEnd_csSpec");
      if (log && !findString("ptmeasEnd_csSpec", ptmeasEndSubs))
	{
	  warnSub("ptmeasEnd_csSpec", "ptmeasEnd", a_ptmeasEnd);
	  check_ptmeasEnd_csSpec(
	    dynamic_cast<ptmeasEnd_csSpec *>(a_ptmeasEnd), 0);
	}
      else
	check_ptmeasEnd_csSpec(
	  dynamic_cast<ptmeasEnd_csSpec *>(a_ptmeasEnd), log);
      return;
    }
  if (isA(a_ptmeasEnd, ptmeasEnd_touchSpec))
    {
      adjustLevels(&ptmeasEndSubs_ptmeasEnd_touchSpec, "ptmeasEnd_touchSpec");
      if (log && !findString("ptmeasEnd_touchSpec", ptmeasEndSubs))
	{
	  warnSub("ptmeasEnd_touchSpec", "ptmeasEnd", a_ptmeasEnd);
	  check_ptmeasEnd_touchSpec(
	    dynamic_cast<ptmeasEnd_touchSpec *>(a_ptmeasEnd), 0);
	}
      else
	check_ptmeasEnd_touchSpec(
	  dynamic_cast<ptmeasEnd_touchSpec *>(a_ptmeasEnd), log);
      return;
    }
}

/********************************************************************/

void check_ptmeasEnd_csSpec(
 ptmeasEnd_csSpec * a_ptmeasEnd_csSpec,
 int log)
{
  if (a_ptmeasEnd_csSpec->get_csSpec())
    {
      adjustLevels(&ptmeasEnd_csSpecAtts_a_csSpec,
		   "ptmeasEnd_csSpec a_csSpec");
      if (log && !findString("a_csSpec", ptmeasEnd_csSpecAtts))
	{
	  warnAtt("a_csSpec", "ptmeasEnd_csSpec", a_ptmeasEnd_csSpec);
	  check_csSpec(a_ptmeasEnd_csSpec->get_csSpec(), 0);
	}
      else
	check_csSpec(a_ptmeasEnd_csSpec->get_csSpec(), log);
    }
  if (a_ptmeasEnd_csSpec->get_touchSpec())
    {
      adjustLevels(&ptmeasEnd_csSpecAtts_a_touchSpec,
		   "ptmeasEnd_csSpec a_touchSpec");
      if (log && !findString("a_touchSpec", ptmeasEnd_csSpecAtts))
	{
	  warnAtt("a_touchSpec", "ptmeasEnd_csSpec", a_ptmeasEnd_csSpec);
	  check_touchSpec(a_ptmeasEnd_csSpec->get_touchSpec(), 0);
	}
      else
	check_touchSpec(a_ptmeasEnd_csSpec->get_touchSpec(), log);
    }
}

/********************************************************************/

void check_ptmeasEnd_touchSpec(
 ptmeasEnd_touchSpec * a_ptmeasEnd_touchSpec,
 int log)
{
  if (a_ptmeasEnd_touchSpec->get_touchSpec())
    {
      adjustLevels(&ptmeasEnd_touchSpecAtts_a_touchSpec,
		   "ptmeasEnd_touchSpec a_touchSpec");
      if (log && !findString("a_touchSpec", ptmeasEnd_touchSpecAtts))
	{
	  warnAtt("a_touchSpec", "ptmeasEnd_touchSpec",
		  a_ptmeasEnd_touchSpec);
	  check_touchSpec(a_ptmeasEnd_touchSpec->get_touchSpec(), 0);
	}
      else
	check_touchSpec(a_ptmeasEnd_touchSpec->get_touchSpec(), log);
    }
}

/********************************************************************/

void check_ptmeasStm(
 ptmeasStm * a_ptmeasStm,
 int log)
{
  if (a_ptmeasStm->get_typePoint())
    {
      adjustLevels(&ptmeasStmAtts_a_typePoint, "ptmeasStm a_typePoint");
      if (log && !findString("a_typePoint", ptmeasStmAtts))
	{
	  warnAtt("a_typePoint", "ptmeasStm", a_ptmeasStm);
	  check_typePoint(a_ptmeasStm->get_typePoint(), 0);
	}
      else
	check_typePoint(a_ptmeasStm->get_typePoint(), log);
    }
  if (a_ptmeasStm->get_dir())
    {
      adjustLevels(&ptmeasStmAtts_dir, "ptmeasStm dir");
      if (log && !findString("dir", ptmeasStmAtts))
	{
	  warnAtt("dir", "ptmeasStm", a_ptmeasStm);
	  check_vector(a_ptmeasStm->get_dir(), 0);
	}
      else
	check_vector(a_ptmeasStm->get_dir(), log);
    }
  if (a_ptmeasStm->get_ptmeasEnd())
    {
      adjustLevels(&ptmeasStmAtts_a_ptmeasEnd, "ptmeasStm a_ptmeasEnd");
      if (log && !findString("a_ptmeasEnd", ptmeasStmAtts))
	{
	  warnAtt("a_ptmeasEnd", "ptmeasStm", a_ptmeasStm);
	  check_ptmeasEnd(a_ptmeasStm->get_ptmeasEnd(), 0);
	}
      else
	check_ptmeasEnd(a_ptmeasStm->get_ptmeasEnd(), log);
    }
}

/********************************************************************/

void check_pushStm(
 pushStm * a_pushStm,
 int log)
{
  if (a_pushStm->get_stackElementList())
    {
      std::list<stackElement *> * theList;
      std::list<stackElement *>::iterator iter;
      theList = a_pushStm->get_stackElementList();
      adjustLevels(&pushStmAtts_a_stackElementList,
		   "pushStm a_stackElementList");
      if (log && !findString("a_stackElementList", pushStmAtts))
	{
	  warnAtt("a_stackElementList", "pushStm", a_pushStm);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_stackElement(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_stackElement(*iter, log);
	}
    }
}

/********************************************************************/

void check_pvLabel(
 pvLabel * a_pvLabel,
 int log)
{
  if (a_pvLabel->get_labelName())
    {
      adjustLevels(&pvLabelAtts_a_labelName, "pvLabel a_labelName");
      if (log && !findString("a_labelName", pvLabelAtts))
	{
	  warnAtt("a_labelName", "pvLabel", a_pvLabel);
	  check_labelName(a_pvLabel->get_labelName(), 0);
	}
      else
	check_labelName(a_pvLabel->get_labelName(), log);
    }
}

/********************************************************************/

void check_qLabel(
 qLabel * a_qLabel,
 int log)
{
  if (a_qLabel->get_labelName())
    {
      adjustLevels(&qLabelAtts_a_labelName, "qLabel a_labelName");
      if (log && !findString("a_labelName", qLabelAtts))
	{
	  warnAtt("a_labelName", "qLabel", a_qLabel);
	  check_labelName(a_qLabel->get_labelName(), 0);
	}
      else
	check_labelName(a_qLabel->get_labelName(), log);
    }
}

/********************************************************************/

void check_qisLabel(
 qisLabel * a_qisLabel,
 int log)
{
  if (isA(a_qisLabel, ccLabel))
    {
      adjustLevels(&qisLabelSubs_ccLabel, "ccLabel");
      if (log && !findString("ccLabel", qisLabelSubs))
	{
	  warnSub("ccLabel", "qisLabel", a_qisLabel);
	  check_ccLabel(dynamic_cast<ccLabel *>(a_qisLabel), 0);
	}
      else
	check_ccLabel(dynamic_cast<ccLabel *>(a_qisLabel), log);
      return;
    }
  if (isA(a_qisLabel, ciLabel))
    {
      adjustLevels(&qisLabelSubs_ciLabel, "ciLabel");
      if (log && !findString("ciLabel", qisLabelSubs))
	{
	  warnSub("ciLabel", "qisLabel", a_qisLabel);
	  check_ciLabel(dynamic_cast<ciLabel *>(a_qisLabel), 0);
	}
      else
	check_ciLabel(dynamic_cast<ciLabel *>(a_qisLabel), log);
      return;
    }
  if (isA(a_qisLabel, csLabel))
    {
      adjustLevels(&qisLabelSubs_csLabel, "csLabel");
      if (log && !findString("csLabel", qisLabelSubs))
	{
	  warnSub("csLabel", "qisLabel", a_qisLabel);
	  check_csLabel(dynamic_cast<csLabel *>(a_qisLabel), 0);
	}
      else
	check_csLabel(dynamic_cast<csLabel *>(a_qisLabel), log);
      return;
    }
  if (isA(a_qisLabel, diLabel))
    {
      adjustLevels(&qisLabelSubs_diLabel, "diLabel");
      if (log && !findString("diLabel", qisLabelSubs))
	{
	  warnSub("diLabel", "qisLabel", a_qisLabel);
	  check_diLabel(dynamic_cast<diLabel *>(a_qisLabel), 0);
	}
      else
	check_diLabel(dynamic_cast<diLabel *>(a_qisLabel), log);
      return;
    }
  if (isA(a_qisLabel, dsLabel))
    {
      adjustLevels(&qisLabelSubs_dsLabel, "dsLabel");
      if (log && !findString("dsLabel", qisLabelSubs))
	{
	  warnSub("dsLabel", "qisLabel", a_qisLabel);
	  check_dsLabel(dynamic_cast<dsLabel *>(a_qisLabel), 0);
	}
      else
	check_dsLabel(dynamic_cast<dsLabel *>(a_qisLabel), log);
      return;
    }
  if (isA(a_qisLabel, dvLabel))
    {
      adjustLevels(&qisLabelSubs_dvLabel, "dvLabel");
      if (log && !findString("dvLabel", qisLabelSubs))
	{
	  warnSub("dvLabel", "qisLabel", a_qisLabel);
	  check_dvLabel(dynamic_cast<dvLabel *>(a_qisLabel), 0);
	}
      else
	check_dvLabel(dynamic_cast<dvLabel *>(a_qisLabel), log);
      return;
    }
  if (isA(a_qisLabel, fiLabel))
    {
      adjustLevels(&qisLabelSubs_fiLabel, "fiLabel");
      if (log && !findString("fiLabel", qisLabelSubs))
	{
	  warnSub("fiLabel", "qisLabel", a_qisLabel);
	  check_fiLabel(dynamic_cast<fiLabel *>(a_qisLabel), 0);
	}
      else
	check_fiLabel(dynamic_cast<fiLabel *>(a_qisLabel), log);
      return;
    }
  if (isA(a_qisLabel, fsLabel))
    {
      adjustLevels(&qisLabelSubs_fsLabel, "fsLabel");
      if (log && !findString("fsLabel", qisLabelSubs))
	{
	  warnSub("fsLabel", "qisLabel", a_qisLabel);
	  check_fsLabel(dynamic_cast<fsLabel *>(a_qisLabel), 0);
	}
      else
	check_fsLabel(dynamic_cast<fsLabel *>(a_qisLabel), log);
      return;
    }
  if (isA(a_qisLabel, liLabel))
    {
      adjustLevels(&qisLabelSubs_liLabel, "liLabel");
      if (log && !findString("liLabel", qisLabelSubs))
	{
	  warnSub("liLabel", "qisLabel", a_qisLabel);
	  check_liLabel(dynamic_cast<liLabel *>(a_qisLabel), 0);
	}
      else
	check_liLabel(dynamic_cast<liLabel *>(a_qisLabel), log);
      return;
    }
  if (isA(a_qisLabel, mdLabel))
    {
      adjustLevels(&qisLabelSubs_mdLabel, "mdLabel");
      if (log && !findString("mdLabel", qisLabelSubs))
	{
	  warnSub("mdLabel", "qisLabel", a_qisLabel);
	  check_mdLabel(dynamic_cast<mdLabel *>(a_qisLabel), 0);
	}
      else
	check_mdLabel(dynamic_cast<mdLabel *>(a_qisLabel), log);
      return;
    }
  if (isA(a_qisLabel, opLabel))
    {
      adjustLevels(&qisLabelSubs_opLabel, "opLabel");
      if (log && !findString("opLabel", qisLabelSubs))
	{
	  warnSub("opLabel", "qisLabel", a_qisLabel);
	  check_opLabel(dynamic_cast<opLabel *>(a_qisLabel), 0);
	}
      else
	check_opLabel(dynamic_cast<opLabel *>(a_qisLabel), log);
      return;
    }
  if (isA(a_qisLabel, pcLabel))
    {
      adjustLevels(&qisLabelSubs_pcLabel, "pcLabel");
      if (log && !findString("pcLabel", qisLabelSubs))
	{
	  warnSub("pcLabel", "qisLabel", a_qisLabel);
	  check_pcLabel(dynamic_cast<pcLabel *>(a_qisLabel), 0);
	}
      else
	check_pcLabel(dynamic_cast<pcLabel *>(a_qisLabel), log);
      return;
    }
  if (isA(a_qisLabel, plLabel))
    {
      adjustLevels(&qisLabelSubs_plLabel, "plLabel");
      if (log && !findString("plLabel", qisLabelSubs))
	{
	  warnSub("plLabel", "qisLabel", a_qisLabel);
	  check_plLabel(dynamic_cast<plLabel *>(a_qisLabel), 0);
	}
      else
	check_plLabel(dynamic_cast<plLabel *>(a_qisLabel), log);
      return;
    }
  if (isA(a_qisLabel, pnLabel))
    {
      adjustLevels(&qisLabelSubs_pnLabel, "pnLabel");
      if (log && !findString("pnLabel", qisLabelSubs))
	{
	  warnSub("pnLabel", "qisLabel", a_qisLabel);
	  check_pnLabel(dynamic_cast<pnLabel *>(a_qisLabel), 0);
	}
      else
	check_pnLabel(dynamic_cast<pnLabel *>(a_qisLabel), log);
      return;
    }
  if (isA(a_qisLabel, prLabel))
    {
      adjustLevels(&qisLabelSubs_prLabel, "prLabel");
      if (log && !findString("prLabel", qisLabelSubs))
	{
	  warnSub("prLabel", "qisLabel", a_qisLabel);
	  check_prLabel(dynamic_cast<prLabel *>(a_qisLabel), 0);
	}
      else
	check_prLabel(dynamic_cast<prLabel *>(a_qisLabel), log);
      return;
    }
  if (isA(a_qisLabel, psLabel))
    {
      adjustLevels(&qisLabelSubs_psLabel, "psLabel");
      if (log && !findString("psLabel", qisLabelSubs))
	{
	  warnSub("psLabel", "qisLabel", a_qisLabel);
	  check_psLabel(dynamic_cast<psLabel *>(a_qisLabel), 0);
	}
      else
	check_psLabel(dynamic_cast<psLabel *>(a_qisLabel), log);
      return;
    }
  if (isA(a_qisLabel, pvLabel))
    {
      adjustLevels(&qisLabelSubs_pvLabel, "pvLabel");
      if (log && !findString("pvLabel", qisLabelSubs))
	{
	  warnSub("pvLabel", "qisLabel", a_qisLabel);
	  check_pvLabel(dynamic_cast<pvLabel *>(a_qisLabel), 0);
	}
      else
	check_pvLabel(dynamic_cast<pvLabel *>(a_qisLabel), log);
      return;
    }
  if (isA(a_qisLabel, qLabel))
    {
      adjustLevels(&qisLabelSubs_qLabel, "qLabel");
      if (log && !findString("qLabel", qisLabelSubs))
	{
	  warnSub("qLabel", "qisLabel", a_qisLabel);
	  check_qLabel(dynamic_cast<qLabel *>(a_qisLabel), 0);
	}
      else
	check_qLabel(dynamic_cast<qLabel *>(a_qisLabel), log);
      return;
    }
  if (isA(a_qisLabel, tlLabel))
    {
      adjustLevels(&qisLabelSubs_tlLabel, "tlLabel");
      if (log && !findString("tlLabel", qisLabelSubs))
	{
	  warnSub("tlLabel", "qisLabel", a_qisLabel);
	  check_tlLabel(dynamic_cast<tlLabel *>(a_qisLabel), 0);
	}
      else
	check_tlLabel(dynamic_cast<tlLabel *>(a_qisLabel), log);
      return;
    }
}

/********************************************************************/

void check_qisdefStm(
 qisdefStm * a_qisdefStm,
 int log)
{
  if (a_qisdefStm->get_qLabel())
    {
      adjustLevels(&qisdefStmAtts_a_qLabel, "qisdefStm a_qLabel");
      if (log && !findString("a_qLabel", qisdefStmAtts))
	{
	  warnAtt("a_qLabel", "qisdefStm", a_qisdefStm);
	  check_qLabel(a_qisdefStm->get_qLabel(), 0);
	}
      else
	check_qLabel(a_qisdefStm->get_qLabel(), log);
    }
  if (a_qisdefStm->get_typ())
    {
      adjustLevels(&qisdefStmAtts_typ, "qisdefStm typ");
      if (log && !findString("typ", qisdefStmAtts))
	{
	  warnAtt("typ", "qisdefStm", a_qisdefStm);
	  check_stringVal(a_qisdefStm->get_typ(), 0);
	}
      else
	check_stringVal(a_qisdefStm->get_typ(), log);
    }
  if (a_qisdefStm->get_text())
    {
      adjustLevels(&qisdefStmAtts_text, "qisdefStm text");
      if (log && !findString("text", qisdefStmAtts))
	{
	  warnAtt("text", "qisdefStm", a_qisdefStm);
	  check_stringVal(a_qisdefStm->get_text(), 0);
	}
      else
	check_stringVal(a_qisdefStm->get_text(), log);
    }
}

/********************************************************************/

void check_rLabel(
 rLabel * a_rLabel,
 int log)
{
  if (a_rLabel->get_labelName())
    {
      adjustLevels(&rLabelAtts_a_labelName, "rLabel a_labelName");
      if (log && !findString("a_labelName", rLabelAtts))
	{
	  warnAtt("a_labelName", "rLabel", a_rLabel);
	  check_labelName(a_rLabel->get_labelName(), 0);
	}
      else
	check_labelName(a_rLabel->get_labelName(), log);
    }
}

/********************************************************************/

void check_radiusSpec(
 radiusSpec * a_radiusSpec,
 int log)
{
  if (isA(a_radiusSpec, radiusSpec_MAJOR))
    {
      adjustLevels(&radiusSpecSubs_radiusSpec_MAJOR, "radiusSpec_MAJOR");
      if (log && !findString("radiusSpec_MAJOR", radiusSpecSubs))
	{
	  warnSub("radiusSpec_MAJOR", "radiusSpec", a_radiusSpec);
	}
      return;
    }
  if (isA(a_radiusSpec, radiusSpec_MINOR))
    {
      adjustLevels(&radiusSpecSubs_radiusSpec_MINOR, "radiusSpec_MINOR");
      if (log && !findString("radiusSpec_MINOR", radiusSpecSubs))
	{
	  warnSub("radiusSpec_MINOR", "radiusSpec", a_radiusSpec);
	}
      return;
    }
}

/********************************************************************/

void check_rapidStm(
 rapidStm * a_rapidStm,
 int log)
{
  if (a_rapidStm->get_speed())
    {
      adjustLevels(&rapidStmAtts_speed, "rapidStm speed");
      if (log && !findString("speed", rapidStmAtts))
	{
	  warnAtt("speed", "rapidStm", a_rapidStm);
	  check_rentVal(a_rapidStm->get_speed(), 0);
	}
      else
	check_rentVal(a_rapidStm->get_speed(), log);
    }
}

/********************************************************************/

void check_readSpec(
 readSpec * a_readSpec,
 int log)
{
  if (a_readSpec->get_rwVar())
    {
      adjustLevels(&readSpecAtts_a_rwVar, "readSpec a_rwVar");
      if (log && !findString("a_rwVar", readSpecAtts))
	{
	  warnAtt("a_rwVar", "readSpec", a_readSpec);
	  check_rwVar(a_readSpec->get_rwVar(), 0);
	}
      else
	check_rwVar(a_readSpec->get_rwVar(), log);
    }
  if (a_readSpec->get_rwFormat())
    {
      adjustLevels(&readSpecAtts_a_rwFormat, "readSpec a_rwFormat");
      if (log && !findString("a_rwFormat", readSpecAtts))
	{
	  warnAtt("a_rwFormat", "readSpec", a_readSpec);
	  check_rwFormat(a_readSpec->get_rwFormat(), 0);
	}
      else
	check_rwFormat(a_readSpec->get_rwFormat(), log);
    }
}

/********************************************************************/

void check_readStm(
 readStm * a_readStm,
 int log)
{
  if (a_readStm->get_didLabel())
    {
      adjustLevels(&readStmAtts_a_didLabel, "readStm a_didLabel");
      if (log && !findString("a_didLabel", readStmAtts))
	{
	  warnAtt("a_didLabel", "readStm", a_readStm);
	  check_didLabel(a_readStm->get_didLabel(), 0);
	}
      else
	check_didLabel(a_readStm->get_didLabel(), log);
    }
  if (a_readStm->get_readSpecList())
    {
      std::list<readSpec *> * theList;
      std::list<readSpec *>::iterator iter;
      theList = a_readStm->get_readSpecList();
      adjustLevels(&readStmAtts_a_readSpecList, "readStm a_readSpecList");
      if (log && !findString("a_readSpecList", readStmAtts))
	{
	  warnAtt("a_readSpecList", "readStm", a_readStm);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_readSpec(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_readSpec(*iter, log);
	}
    }
}

/********************************************************************/

void check_realConst(
 realConst * a_realConst,
 int log)
{
  if (a_realConst->get_double())
    {
      adjustLevels(&realConstAtts_a_double, "realConst a_double");
      if (log && !findString("a_double", realConstAtts))
	{
	  warnAtt("a_double", "realConst", a_realConst);
	}
    }
}

/********************************************************************/

void check_realExpr(
 realExpr * a_realExpr,
 int log)
{
  if (isA(a_realExpr, realExprParen))
    {
      adjustLevels(&realExprSubs_realExprParen, "realExprParen");
      if (log && !findString("realExprParen", realExprSubs))
	{
	  warnSub("realExprParen", "realExpr", a_realExpr);
	  check_realExprParen(
	    dynamic_cast<realExprParen *>(a_realExpr), 0);
	}
      else
	check_realExprParen(
	  dynamic_cast<realExprParen *>(a_realExpr), log);
      return;
    }
  if (isA(a_realExpr, realRealExpr))
    {
      adjustLevels(&realExprSubs_realRealExpr, "realRealExpr");
      if (log && !findString("realRealExpr", realExprSubs))
	{
	  warnSub("realRealExpr", "realExpr", a_realExpr);
	  check_realRealExpr(dynamic_cast<realRealExpr *>(a_realExpr), 0);
	}
      else
	check_realRealExpr(dynamic_cast<realRealExpr *>(a_realExpr), log);
      return;
    }
  if (isA(a_realExpr, realIntExpr))
    {
      adjustLevels(&realExprSubs_realIntExpr, "realIntExpr");
      if (log && !findString("realIntExpr", realExprSubs))
	{
	  warnSub("realIntExpr", "realExpr", a_realExpr);
	  check_realIntExpr(dynamic_cast<realIntExpr *>(a_realExpr), 0);
	}
      else
	check_realIntExpr(dynamic_cast<realIntExpr *>(a_realExpr), log);
      return;
    }
  if (isA(a_realExpr, intRealExpr))
    {
      adjustLevels(&realExprSubs_intRealExpr, "intRealExpr");
      if (log && !findString("intRealExpr", realExprSubs))
	{
	  warnSub("intRealExpr", "realExpr", a_realExpr);
	  check_intRealExpr(dynamic_cast<intRealExpr *>(a_realExpr), 0);
	}
      else
	check_intRealExpr(dynamic_cast<intRealExpr *>(a_realExpr), log);
      return;
    }
  if (isA(a_realExpr, realExprNegat))
    {
      adjustLevels(&realExprSubs_realExprNegat, "realExprNegat");
      if (log && !findString("realExprNegat", realExprSubs))
	{
	  warnSub("realExprNegat", "realExpr", a_realExpr);
	  check_realExprNegat(
	    dynamic_cast<realExprNegat *>(a_realExpr), 0);
	}
      else
	check_realExprNegat(
	  dynamic_cast<realExprNegat *>(a_realExpr), log);
      return;
    }
  if (isA(a_realExpr, realExprPosit))
    {
      adjustLevels(&realExprSubs_realExprPosit, "realExprPosit");
      if (log && !findString("realExprPosit", realExprSubs))
	{
	  warnSub("realExprPosit", "realExpr", a_realExpr);
	  check_realExprPosit(
	    dynamic_cast<realExprPosit *>(a_realExpr), 0);
	}
      else
	check_realExprPosit(
	  dynamic_cast<realExprPosit *>(a_realExpr), log);
      return;
    }
}

/********************************************************************/

void check_realExprNegat(
 realExprNegat * a_realExprNegat,
 int log)
{
  if (a_realExprNegat->get_x())
    {
      adjustLevels(&realExprNegatAtts_x, "realExprNegat x");
      if (log && !findString("x", realExprNegatAtts))
	{
	  warnAtt("x", "realExprNegat", a_realExprNegat);
	  check_realVal(a_realExprNegat->get_x(), 0);
	}
      else
	check_realVal(a_realExprNegat->get_x(), log);
    }
}

/********************************************************************/

void check_realExprParen(
 realExprParen * a_realExprParen,
 int log)
{
  if (a_realExprParen->get_x())
    {
      adjustLevels(&realExprParenAtts_x, "realExprParen x");
      if (log && !findString("x", realExprParenAtts))
	{
	  warnAtt("x", "realExprParen", a_realExprParen);
	  check_realVal(a_realExprParen->get_x(), 0);
	}
      else
	check_realVal(a_realExprParen->get_x(), log);
    }
}

/********************************************************************/

void check_realExprPosit(
 realExprPosit * a_realExprPosit,
 int log)
{
  if (a_realExprPosit->get_x())
    {
      adjustLevels(&realExprPositAtts_x, "realExprPosit x");
      if (log && !findString("x", realExprPositAtts))
	{
	  warnAtt("x", "realExprPosit", a_realExprPosit);
	  check_realVal(a_realExprPosit->get_x(), 0);
	}
      else
	check_realVal(a_realExprPosit->get_x(), log);
    }
}

/********************************************************************/

void check_realFunc(
 realFunc * a_realFunc,
 int log)
{
  if (isA(a_realFunc, realFuncAbs))
    {
      adjustLevels(&realFuncSubs_realFuncAbs, "realFuncAbs");
      if (log && !findString("realFuncAbs", realFuncSubs))
	{
	  warnSub("realFuncAbs", "realFunc", a_realFunc);
	  check_realFuncAbs(dynamic_cast<realFuncAbs *>(a_realFunc), 0);
	}
      else
	check_realFuncAbs(dynamic_cast<realFuncAbs *>(a_realFunc), log);
      return;
    }
  if (isA(a_realFunc, realFuncAcos))
    {
      adjustLevels(&realFuncSubs_realFuncAcos, "realFuncAcos");
      if (log && !findString("realFuncAcos", realFuncSubs))
	{
	  warnSub("realFuncAcos", "realFunc", a_realFunc);
	  check_realFuncAcos(dynamic_cast<realFuncAcos *>(a_realFunc), 0);
	}
      else
	check_realFuncAcos(dynamic_cast<realFuncAcos *>(a_realFunc), log);
      return;
    }
  if (isA(a_realFunc, realFuncAsin))
    {
      adjustLevels(&realFuncSubs_realFuncAsin, "realFuncAsin");
      if (log && !findString("realFuncAsin", realFuncSubs))
	{
	  warnSub("realFuncAsin", "realFunc", a_realFunc);
	  check_realFuncAsin(dynamic_cast<realFuncAsin *>(a_realFunc), 0);
	}
      else
	check_realFuncAsin(dynamic_cast<realFuncAsin *>(a_realFunc), log);
      return;
    }
  if (isA(a_realFunc, realFuncAtan))
    {
      adjustLevels(&realFuncSubs_realFuncAtan, "realFuncAtan");
      if (log && !findString("realFuncAtan", realFuncSubs))
	{
	  warnSub("realFuncAtan", "realFunc", a_realFunc);
	  check_realFuncAtan(dynamic_cast<realFuncAtan *>(a_realFunc), 0);
	}
      else
	check_realFuncAtan(dynamic_cast<realFuncAtan *>(a_realFunc), log);
      return;
    }
  if (isA(a_realFunc, realFuncAtan2))
    {
      adjustLevels(&realFuncSubs_realFuncAtan2, "realFuncAtan2");
      if (log && !findString("realFuncAtan2", realFuncSubs))
	{
	  warnSub("realFuncAtan2", "realFunc", a_realFunc);
	  check_realFuncAtan2(
	    dynamic_cast<realFuncAtan2 *>(a_realFunc), 0);
	}
      else
	check_realFuncAtan2(
	  dynamic_cast<realFuncAtan2 *>(a_realFunc), log);
      return;
    }
  if (isA(a_realFunc, realFuncCos))
    {
      adjustLevels(&realFuncSubs_realFuncCos, "realFuncCos");
      if (log && !findString("realFuncCos", realFuncSubs))
	{
	  warnSub("realFuncCos", "realFunc", a_realFunc);
	  check_realFuncCos(dynamic_cast<realFuncCos *>(a_realFunc), 0);
	}
      else
	check_realFuncCos(dynamic_cast<realFuncCos *>(a_realFunc), log);
      return;
    }
  if (isA(a_realFunc, realFuncDble))
    {
      adjustLevels(&realFuncSubs_realFuncDble, "realFuncDble");
      if (log && !findString("realFuncDble", realFuncSubs))
	{
	  warnSub("realFuncDble", "realFunc", a_realFunc);
	  check_realFuncDble(dynamic_cast<realFuncDble *>(a_realFunc), 0);
	}
      else
	check_realFuncDble(dynamic_cast<realFuncDble *>(a_realFunc), log);
      return;
    }
  if (isA(a_realFunc, realFuncDtor))
    {
      adjustLevels(&realFuncSubs_realFuncDtor, "realFuncDtor");
      if (log && !findString("realFuncDtor", realFuncSubs))
	{
	  warnSub("realFuncDtor", "realFunc", a_realFunc);
	  check_realFuncDtor(dynamic_cast<realFuncDtor *>(a_realFunc), 0);
	}
      else
	check_realFuncDtor(dynamic_cast<realFuncDtor *>(a_realFunc), log);
      return;
    }
  if (isA(a_realFunc, realFuncExp))
    {
      adjustLevels(&realFuncSubs_realFuncExp, "realFuncExp");
      if (log && !findString("realFuncExp", realFuncSubs))
	{
	  warnSub("realFuncExp", "realFunc", a_realFunc);
	  check_realFuncExp(dynamic_cast<realFuncExp *>(a_realFunc), 0);
	}
      else
	check_realFuncExp(dynamic_cast<realFuncExp *>(a_realFunc), log);
      return;
    }
  if (isA(a_realFunc, realFuncLn))
    {
      adjustLevels(&realFuncSubs_realFuncLn, "realFuncLn");
      if (log && !findString("realFuncLn", realFuncSubs))
	{
	  warnSub("realFuncLn", "realFunc", a_realFunc);
	  check_realFuncLn(dynamic_cast<realFuncLn *>(a_realFunc), 0);
	}
      else
	check_realFuncLn(dynamic_cast<realFuncLn *>(a_realFunc), log);
      return;
    }
  if (isA(a_realFunc, realFuncLog))
    {
      adjustLevels(&realFuncSubs_realFuncLog, "realFuncLog");
      if (log && !findString("realFuncLog", realFuncSubs))
	{
	  warnSub("realFuncLog", "realFunc", a_realFunc);
	  check_realFuncLog(dynamic_cast<realFuncLog *>(a_realFunc), 0);
	}
      else
	check_realFuncLog(dynamic_cast<realFuncLog *>(a_realFunc), log);
      return;
    }
  if (isA(a_realFunc, realFuncMn))
    {
      adjustLevels(&realFuncSubs_realFuncMn, "realFuncMn");
      if (log && !findString("realFuncMn", realFuncSubs))
	{
	  warnSub("realFuncMn", "realFunc", a_realFunc);
	  check_realFuncMn(dynamic_cast<realFuncMn *>(a_realFunc), 0);
	}
      else
	check_realFuncMn(dynamic_cast<realFuncMn *>(a_realFunc), log);
      return;
    }
  if (isA(a_realFunc, realFuncMod))
    {
      adjustLevels(&realFuncSubs_realFuncMod, "realFuncMod");
      if (log && !findString("realFuncMod", realFuncSubs))
	{
	  warnSub("realFuncMod", "realFunc", a_realFunc);
	  check_realFuncMod(dynamic_cast<realFuncMod *>(a_realFunc), 0);
	}
      else
	check_realFuncMod(dynamic_cast<realFuncMod *>(a_realFunc), log);
      return;
    }
  if (isA(a_realFunc, realFuncMx))
    {
      adjustLevels(&realFuncSubs_realFuncMx, "realFuncMx");
      if (log && !findString("realFuncMx", realFuncSubs))
	{
	  warnSub("realFuncMx", "realFunc", a_realFunc);
	  check_realFuncMx(dynamic_cast<realFuncMx *>(a_realFunc), 0);
	}
      else
	check_realFuncMx(dynamic_cast<realFuncMx *>(a_realFunc), log);
      return;
    }
  if (isA(a_realFunc, realFuncQtemp))
    {
      adjustLevels(&realFuncSubs_realFuncQtemp, "realFuncQtemp");
      if (log && !findString("realFuncQtemp", realFuncSubs))
	{
	  warnSub("realFuncQtemp", "realFunc", a_realFunc);
	  check_realFuncQtemp(
	    dynamic_cast<realFuncQtemp *>(a_realFunc), 0);
	}
      else
	check_realFuncQtemp(
	  dynamic_cast<realFuncQtemp *>(a_realFunc), log);
      return;
    }
  if (isA(a_realFunc, realFuncRand))
    {
      adjustLevels(&realFuncSubs_realFuncRand, "realFuncRand");
      if (log && !findString("realFuncRand", realFuncSubs))
	{
	  warnSub("realFuncRand", "realFunc", a_realFunc);
	  check_realFuncRand(dynamic_cast<realFuncRand *>(a_realFunc), 0);
	}
      else
	check_realFuncRand(dynamic_cast<realFuncRand *>(a_realFunc), log);
      return;
    }
  if (isA(a_realFunc, realFuncRl))
    {
      adjustLevels(&realFuncSubs_realFuncRl, "realFuncRl");
      if (log && !findString("realFuncRl", realFuncSubs))
	{
	  warnSub("realFuncRl", "realFunc", a_realFunc);
	  check_realFuncRl(dynamic_cast<realFuncRl *>(a_realFunc), 0);
	}
      else
	check_realFuncRl(dynamic_cast<realFuncRl *>(a_realFunc), log);
      return;
    }
  if (isA(a_realFunc, realFuncRtod))
    {
      adjustLevels(&realFuncSubs_realFuncRtod, "realFuncRtod");
      if (log && !findString("realFuncRtod", realFuncSubs))
	{
	  warnSub("realFuncRtod", "realFunc", a_realFunc);
	  check_realFuncRtod(dynamic_cast<realFuncRtod *>(a_realFunc), 0);
	}
      else
	check_realFuncRtod(dynamic_cast<realFuncRtod *>(a_realFunc), log);
      return;
    }
  if (isA(a_realFunc, realFuncSign))
    {
      adjustLevels(&realFuncSubs_realFuncSign, "realFuncSign");
      if (log && !findString("realFuncSign", realFuncSubs))
	{
	  warnSub("realFuncSign", "realFunc", a_realFunc);
	  check_realFuncSign(dynamic_cast<realFuncSign *>(a_realFunc), 0);
	}
      else
	check_realFuncSign(dynamic_cast<realFuncSign *>(a_realFunc), log);
      return;
    }
  if (isA(a_realFunc, realFuncSin))
    {
      adjustLevels(&realFuncSubs_realFuncSin, "realFuncSin");
      if (log && !findString("realFuncSin", realFuncSubs))
	{
	  warnSub("realFuncSin", "realFunc", a_realFunc);
	  check_realFuncSin(dynamic_cast<realFuncSin *>(a_realFunc), 0);
	}
      else
	check_realFuncSin(dynamic_cast<realFuncSin *>(a_realFunc), log);
      return;
    }
  if (isA(a_realFunc, realFuncSqrt))
    {
      adjustLevels(&realFuncSubs_realFuncSqrt, "realFuncSqrt");
      if (log && !findString("realFuncSqrt", realFuncSubs))
	{
	  warnSub("realFuncSqrt", "realFunc", a_realFunc);
	  check_realFuncSqrt(dynamic_cast<realFuncSqrt *>(a_realFunc), 0);
	}
      else
	check_realFuncSqrt(dynamic_cast<realFuncSqrt *>(a_realFunc), log);
      return;
    }
  if (isA(a_realFunc, realFuncTan))
    {
      adjustLevels(&realFuncSubs_realFuncTan, "realFuncTan");
      if (log && !findString("realFuncTan", realFuncSubs))
	{
	  warnSub("realFuncTan", "realFunc", a_realFunc);
	  check_realFuncTan(dynamic_cast<realFuncTan *>(a_realFunc), 0);
	}
      else
	check_realFuncTan(dynamic_cast<realFuncTan *>(a_realFunc), log);
      return;
    }
  if (isA(a_realFunc, realFuncVal))
    {
      adjustLevels(&realFuncSubs_realFuncVal, "realFuncVal");
      if (log && !findString("realFuncVal", realFuncSubs))
	{
	  warnSub("realFuncVal", "realFunc", a_realFunc);
	  check_realFuncVal(dynamic_cast<realFuncVal *>(a_realFunc), 0);
	}
      else
	check_realFuncVal(dynamic_cast<realFuncVal *>(a_realFunc), log);
      return;
    }
  if (isA(a_realFunc, realFuncVdot))
    {
      adjustLevels(&realFuncSubs_realFuncVdot, "realFuncVdot");
      if (log && !findString("realFuncVdot", realFuncSubs))
	{
	  warnSub("realFuncVdot", "realFunc", a_realFunc);
	  check_realFuncVdot(dynamic_cast<realFuncVdot *>(a_realFunc), 0);
	}
      else
	check_realFuncVdot(dynamic_cast<realFuncVdot *>(a_realFunc), log);
      return;
    }
  if (isA(a_realFunc, realFuncVecX))
    {
      adjustLevels(&realFuncSubs_realFuncVecX, "realFuncVecX");
      if (log && !findString("realFuncVecX", realFuncSubs))
	{
	  warnSub("realFuncVecX", "realFunc", a_realFunc);
	  check_realFuncVecX(dynamic_cast<realFuncVecX *>(a_realFunc), 0);
	}
      else
	check_realFuncVecX(dynamic_cast<realFuncVecX *>(a_realFunc), log);
      return;
    }
  if (isA(a_realFunc, realFuncVecY))
    {
      adjustLevels(&realFuncSubs_realFuncVecY, "realFuncVecY");
      if (log && !findString("realFuncVecY", realFuncSubs))
	{
	  warnSub("realFuncVecY", "realFunc", a_realFunc);
	  check_realFuncVecY(dynamic_cast<realFuncVecY *>(a_realFunc), 0);
	}
      else
	check_realFuncVecY(dynamic_cast<realFuncVecY *>(a_realFunc), log);
      return;
    }
  if (isA(a_realFunc, realFuncVecZ))
    {
      adjustLevels(&realFuncSubs_realFuncVecZ, "realFuncVecZ");
      if (log && !findString("realFuncVecZ", realFuncSubs))
	{
	  warnSub("realFuncVecZ", "realFunc", a_realFunc);
	  check_realFuncVecZ(dynamic_cast<realFuncVecZ *>(a_realFunc), 0);
	}
      else
	check_realFuncVecZ(dynamic_cast<realFuncVecZ *>(a_realFunc), log);
      return;
    }
  if (isA(a_realFunc, realFuncVmag))
    {
      adjustLevels(&realFuncSubs_realFuncVmag, "realFuncVmag");
      if (log && !findString("realFuncVmag", realFuncSubs))
	{
	  warnSub("realFuncVmag", "realFunc", a_realFunc);
	  check_realFuncVmag(dynamic_cast<realFuncVmag *>(a_realFunc), 0);
	}
      else
	check_realFuncVmag(dynamic_cast<realFuncVmag *>(a_realFunc), log);
      return;
    }
}

/********************************************************************/

void check_realFuncAbs(
 realFuncAbs * a_realFuncAbs,
 int log)
{
  if (a_realFuncAbs->get_realVal())
    {
      adjustLevels(&realFuncAbsAtts_a_realVal, "realFuncAbs a_realVal");
      if (log && !findString("a_realVal", realFuncAbsAtts))
	{
	  warnAtt("a_realVal", "realFuncAbs", a_realFuncAbs);
	  check_realVal(a_realFuncAbs->get_realVal(), 0);
	}
      else
	check_realVal(a_realFuncAbs->get_realVal(), log);
    }
}

/********************************************************************/

void check_realFuncAcos(
 realFuncAcos * a_realFuncAcos,
 int log)
{
  if (a_realFuncAcos->get_x())
    {
      adjustLevels(&realFuncAcosAtts_x, "realFuncAcos x");
      if (log && !findString("x", realFuncAcosAtts))
	{
	  warnAtt("x", "realFuncAcos", a_realFuncAcos);
	  check_rentVal(a_realFuncAcos->get_x(), 0);
	}
      else
	check_rentVal(a_realFuncAcos->get_x(), log);
    }
}

/********************************************************************/

void check_realFuncAsin(
 realFuncAsin * a_realFuncAsin,
 int log)
{
  if (a_realFuncAsin->get_x())
    {
      adjustLevels(&realFuncAsinAtts_x, "realFuncAsin x");
      if (log && !findString("x", realFuncAsinAtts))
	{
	  warnAtt("x", "realFuncAsin", a_realFuncAsin);
	  check_rentVal(a_realFuncAsin->get_x(), 0);
	}
      else
	check_rentVal(a_realFuncAsin->get_x(), log);
    }
}

/********************************************************************/

void check_realFuncAtan(
 realFuncAtan * a_realFuncAtan,
 int log)
{
  if (a_realFuncAtan->get_x())
    {
      adjustLevels(&realFuncAtanAtts_x, "realFuncAtan x");
      if (log && !findString("x", realFuncAtanAtts))
	{
	  warnAtt("x", "realFuncAtan", a_realFuncAtan);
	  check_rentVal(a_realFuncAtan->get_x(), 0);
	}
      else
	check_rentVal(a_realFuncAtan->get_x(), log);
    }
}

/********************************************************************/

void check_realFuncAtan2(
 realFuncAtan2 * a_realFuncAtan2,
 int log)
{
  if (a_realFuncAtan2->get_y())
    {
      adjustLevels(&realFuncAtan2Atts_y, "realFuncAtan2 y");
      if (log && !findString("y", realFuncAtan2Atts))
	{
	  warnAtt("y", "realFuncAtan2", a_realFuncAtan2);
	  check_rentVal(a_realFuncAtan2->get_y(), 0);
	}
      else
	check_rentVal(a_realFuncAtan2->get_y(), log);
    }
  if (a_realFuncAtan2->get_x())
    {
      adjustLevels(&realFuncAtan2Atts_x, "realFuncAtan2 x");
      if (log && !findString("x", realFuncAtan2Atts))
	{
	  warnAtt("x", "realFuncAtan2", a_realFuncAtan2);
	  check_rentVal(a_realFuncAtan2->get_x(), 0);
	}
      else
	check_rentVal(a_realFuncAtan2->get_x(), log);
    }
}

/********************************************************************/

void check_realFuncCos(
 realFuncCos * a_realFuncCos,
 int log)
{
  if (a_realFuncCos->get_x())
    {
      adjustLevels(&realFuncCosAtts_x, "realFuncCos x");
      if (log && !findString("x", realFuncCosAtts))
	{
	  warnAtt("x", "realFuncCos", a_realFuncCos);
	  check_rentVal(a_realFuncCos->get_x(), 0);
	}
      else
	check_rentVal(a_realFuncCos->get_x(), log);
    }
}

/********************************************************************/

void check_realFuncDble(
 realFuncDble * a_realFuncDble,
 int log)
{
  if (a_realFuncDble->get_x())
    {
      adjustLevels(&realFuncDbleAtts_x, "realFuncDble x");
      if (log && !findString("x", realFuncDbleAtts))
	{
	  warnAtt("x", "realFuncDble", a_realFuncDble);
	  check_rentVal(a_realFuncDble->get_x(), 0);
	}
      else
	check_rentVal(a_realFuncDble->get_x(), log);
    }
}

/********************************************************************/

void check_realFuncDtor(
 realFuncDtor * a_realFuncDtor,
 int log)
{
  if (a_realFuncDtor->get_x())
    {
      adjustLevels(&realFuncDtorAtts_x, "realFuncDtor x");
      if (log && !findString("x", realFuncDtorAtts))
	{
	  warnAtt("x", "realFuncDtor", a_realFuncDtor);
	  check_rentVal(a_realFuncDtor->get_x(), 0);
	}
      else
	check_rentVal(a_realFuncDtor->get_x(), log);
    }
}

/********************************************************************/

void check_realFuncExp(
 realFuncExp * a_realFuncExp,
 int log)
{
  if (a_realFuncExp->get_x())
    {
      adjustLevels(&realFuncExpAtts_x, "realFuncExp x");
      if (log && !findString("x", realFuncExpAtts))
	{
	  warnAtt("x", "realFuncExp", a_realFuncExp);
	  check_rentVal(a_realFuncExp->get_x(), 0);
	}
      else
	check_rentVal(a_realFuncExp->get_x(), log);
    }
}

/********************************************************************/

void check_realFuncLn(
 realFuncLn * a_realFuncLn,
 int log)
{
  if (a_realFuncLn->get_x())
    {
      adjustLevels(&realFuncLnAtts_x, "realFuncLn x");
      if (log && !findString("x", realFuncLnAtts))
	{
	  warnAtt("x", "realFuncLn", a_realFuncLn);
	  check_rentVal(a_realFuncLn->get_x(), 0);
	}
      else
	check_rentVal(a_realFuncLn->get_x(), log);
    }
}

/********************************************************************/

void check_realFuncLog(
 realFuncLog * a_realFuncLog,
 int log)
{
  if (a_realFuncLog->get_x())
    {
      adjustLevels(&realFuncLogAtts_x, "realFuncLog x");
      if (log && !findString("x", realFuncLogAtts))
	{
	  warnAtt("x", "realFuncLog", a_realFuncLog);
	  check_rentVal(a_realFuncLog->get_x(), 0);
	}
      else
	check_rentVal(a_realFuncLog->get_x(), log);
    }
}

/********************************************************************/

void check_realFuncMn(
 realFuncMn * a_realFuncMn,
 int log)
{
  if (a_realFuncMn->get_arg1())
    {
      adjustLevels(&realFuncMnAtts_arg1, "realFuncMn arg1");
      if (log && !findString("arg1", realFuncMnAtts))
	{
	  warnAtt("arg1", "realFuncMn", a_realFuncMn);
	  check_rentVal(a_realFuncMn->get_arg1(), 0);
	}
      else
	check_rentVal(a_realFuncMn->get_arg1(), log);
    }
  if (a_realFuncMn->get_moreArgs())
    {
      std::list<rentVal *> * theList;
      std::list<rentVal *>::iterator iter;
      theList = a_realFuncMn->get_moreArgs();
      adjustLevels(&realFuncMnAtts_moreArgs, "realFuncMn moreArgs");
      if (log && !findString("moreArgs", realFuncMnAtts))
	{
	  warnAtt("moreArgs", "realFuncMn", a_realFuncMn);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_rentVal(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_rentVal(*iter, log);
	}
    }
}

/********************************************************************/

void check_realFuncMod(
 realFuncMod * a_realFuncMod,
 int log)
{
  if (a_realFuncMod->get_num())
    {
      adjustLevels(&realFuncModAtts_num, "realFuncMod num");
      if (log && !findString("num", realFuncModAtts))
	{
	  warnAtt("num", "realFuncMod", a_realFuncMod);
	  check_realVal(a_realFuncMod->get_num(), 0);
	}
      else
	check_realVal(a_realFuncMod->get_num(), log);
    }
  if (a_realFuncMod->get_dvisr())
    {
      adjustLevels(&realFuncModAtts_dvisr, "realFuncMod dvisr");
      if (log && !findString("dvisr", realFuncModAtts))
	{
	  warnAtt("dvisr", "realFuncMod", a_realFuncMod);
	  check_realVal(a_realFuncMod->get_dvisr(), 0);
	}
      else
	check_realVal(a_realFuncMod->get_dvisr(), log);
    }
}

/********************************************************************/

void check_realFuncMx(
 realFuncMx * a_realFuncMx,
 int log)
{
  if (a_realFuncMx->get_arg1())
    {
      adjustLevels(&realFuncMxAtts_arg1, "realFuncMx arg1");
      if (log && !findString("arg1", realFuncMxAtts))
	{
	  warnAtt("arg1", "realFuncMx", a_realFuncMx);
	  check_rentVal(a_realFuncMx->get_arg1(), 0);
	}
      else
	check_rentVal(a_realFuncMx->get_arg1(), log);
    }
  if (a_realFuncMx->get_moreArgs())
    {
      std::list<rentVal *> * theList;
      std::list<rentVal *>::iterator iter;
      theList = a_realFuncMx->get_moreArgs();
      adjustLevels(&realFuncMxAtts_moreArgs, "realFuncMx moreArgs");
      if (log && !findString("moreArgs", realFuncMxAtts))
	{
	  warnAtt("moreArgs", "realFuncMx", a_realFuncMx);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_rentVal(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_rentVal(*iter, log);
	}
    }
}

/********************************************************************/

void check_realFuncQtemp(
 realFuncQtemp * a_realFuncQtemp,
 int log)
{
  if (a_realFuncQtemp->get_tempsns())
    {
      adjustLevels(&realFuncQtempAtts_tempsns, "realFuncQtemp tempsns");
      if (log && !findString("tempsns", realFuncQtempAtts))
	{
	  warnAtt("tempsns", "realFuncQtemp", a_realFuncQtemp);
	  check_stringVal(a_realFuncQtemp->get_tempsns(), 0);
	}
      else
	check_stringVal(a_realFuncQtemp->get_tempsns(), log);
    }
}

/********************************************************************/

void check_realFuncRand(
 realFuncRand * a_realFuncRand,
 int log)
{
  if (a_realFuncRand->get_seed())
    {
      adjustLevels(&realFuncRandAtts_seed, "realFuncRand seed");
      if (log && !findString("seed", realFuncRandAtts))
	{
	  warnAtt("seed", "realFuncRand", a_realFuncRand);
	  check_rentVal(a_realFuncRand->get_seed(), 0);
	}
      else
	check_rentVal(a_realFuncRand->get_seed(), log);
    }
}

/********************************************************************/

void check_realFuncRl(
 realFuncRl * a_realFuncRl,
 int log)
{
  if (a_realFuncRl->get_x())
    {
      adjustLevels(&realFuncRlAtts_x, "realFuncRl x");
      if (log && !findString("x", realFuncRlAtts))
	{
	  warnAtt("x", "realFuncRl", a_realFuncRl);
	  check_rentVal(a_realFuncRl->get_x(), 0);
	}
      else
	check_rentVal(a_realFuncRl->get_x(), log);
    }
}

/********************************************************************/

void check_realFuncRtod(
 realFuncRtod * a_realFuncRtod,
 int log)
{
  if (a_realFuncRtod->get_x())
    {
      adjustLevels(&realFuncRtodAtts_x, "realFuncRtod x");
      if (log && !findString("x", realFuncRtodAtts))
	{
	  warnAtt("x", "realFuncRtod", a_realFuncRtod);
	  check_rentVal(a_realFuncRtod->get_x(), 0);
	}
      else
	check_rentVal(a_realFuncRtod->get_x(), log);
    }
}

/********************************************************************/

void check_realFuncSign(
 realFuncSign * a_realFuncSign,
 int log)
{
  if (a_realFuncSign->get_x())
    {
      adjustLevels(&realFuncSignAtts_x, "realFuncSign x");
      if (log && !findString("x", realFuncSignAtts))
	{
	  warnAtt("x", "realFuncSign", a_realFuncSign);
	  check_realVal(a_realFuncSign->get_x(), 0);
	}
      else
	check_realVal(a_realFuncSign->get_x(), log);
    }
  if (a_realFuncSign->get_y())
    {
      adjustLevels(&realFuncSignAtts_y, "realFuncSign y");
      if (log && !findString("y", realFuncSignAtts))
	{
	  warnAtt("y", "realFuncSign", a_realFuncSign);
	  check_realVal(a_realFuncSign->get_y(), 0);
	}
      else
	check_realVal(a_realFuncSign->get_y(), log);
    }
}

/********************************************************************/

void check_realFuncSin(
 realFuncSin * a_realFuncSin,
 int log)
{
  if (a_realFuncSin->get_x())
    {
      adjustLevels(&realFuncSinAtts_x, "realFuncSin x");
      if (log && !findString("x", realFuncSinAtts))
	{
	  warnAtt("x", "realFuncSin", a_realFuncSin);
	  check_rentVal(a_realFuncSin->get_x(), 0);
	}
      else
	check_rentVal(a_realFuncSin->get_x(), log);
    }
}

/********************************************************************/

void check_realFuncSqrt(
 realFuncSqrt * a_realFuncSqrt,
 int log)
{
  if (a_realFuncSqrt->get_x())
    {
      adjustLevels(&realFuncSqrtAtts_x, "realFuncSqrt x");
      if (log && !findString("x", realFuncSqrtAtts))
	{
	  warnAtt("x", "realFuncSqrt", a_realFuncSqrt);
	  check_rentVal(a_realFuncSqrt->get_x(), 0);
	}
      else
	check_rentVal(a_realFuncSqrt->get_x(), log);
    }
}

/********************************************************************/

void check_realFuncTan(
 realFuncTan * a_realFuncTan,
 int log)
{
  if (a_realFuncTan->get_x())
    {
      adjustLevels(&realFuncTanAtts_x, "realFuncTan x");
      if (log && !findString("x", realFuncTanAtts))
	{
	  warnAtt("x", "realFuncTan", a_realFuncTan);
	  check_rentVal(a_realFuncTan->get_x(), 0);
	}
      else
	check_rentVal(a_realFuncTan->get_x(), log);
    }
}

/********************************************************************/

void check_realFuncVal(
 realFuncVal * a_realFuncVal,
 int log)
{
  if (a_realFuncVal->get_str())
    {
      adjustLevels(&realFuncValAtts_str, "realFuncVal str");
      if (log && !findString("str", realFuncValAtts))
	{
	  warnAtt("str", "realFuncVal", a_realFuncVal);
	  check_stringVal(a_realFuncVal->get_str(), 0);
	}
      else
	check_stringVal(a_realFuncVal->get_str(), log);
    }
}

/********************************************************************/

void check_realFuncVdot(
 realFuncVdot * a_realFuncVdot,
 int log)
{
  if (a_realFuncVdot->get_v1())
    {
      adjustLevels(&realFuncVdotAtts_v1, "realFuncVdot v1");
      if (log && !findString("v1", realFuncVdotAtts))
	{
	  warnAtt("v1", "realFuncVdot", a_realFuncVdot);
	  check_vectorVal(a_realFuncVdot->get_v1(), 0);
	}
      else
	check_vectorVal(a_realFuncVdot->get_v1(), log);
    }
  if (a_realFuncVdot->get_v2())
    {
      adjustLevels(&realFuncVdotAtts_v2, "realFuncVdot v2");
      if (log && !findString("v2", realFuncVdotAtts))
	{
	  warnAtt("v2", "realFuncVdot", a_realFuncVdot);
	  check_vectorVal(a_realFuncVdot->get_v2(), 0);
	}
      else
	check_vectorVal(a_realFuncVdot->get_v2(), log);
    }
}

/********************************************************************/

void check_realFuncVecX(
 realFuncVecX * a_realFuncVecX,
 int log)
{
  if (a_realFuncVecX->get_vectorVal())
    {
      adjustLevels(&realFuncVecXAtts_a_vectorVal, "realFuncVecX a_vectorVal");
      if (log && !findString("a_vectorVal", realFuncVecXAtts))
	{
	  warnAtt("a_vectorVal", "realFuncVecX", a_realFuncVecX);
	  check_vectorVal(a_realFuncVecX->get_vectorVal(), 0);
	}
      else
	check_vectorVal(a_realFuncVecX->get_vectorVal(), log);
    }
}

/********************************************************************/

void check_realFuncVecY(
 realFuncVecY * a_realFuncVecY,
 int log)
{
  if (a_realFuncVecY->get_vectorVal())
    {
      adjustLevels(&realFuncVecYAtts_a_vectorVal, "realFuncVecY a_vectorVal");
      if (log && !findString("a_vectorVal", realFuncVecYAtts))
	{
	  warnAtt("a_vectorVal", "realFuncVecY", a_realFuncVecY);
	  check_vectorVal(a_realFuncVecY->get_vectorVal(), 0);
	}
      else
	check_vectorVal(a_realFuncVecY->get_vectorVal(), log);
    }
}

/********************************************************************/

void check_realFuncVecZ(
 realFuncVecZ * a_realFuncVecZ,
 int log)
{
  if (a_realFuncVecZ->get_vectorVal())
    {
      adjustLevels(&realFuncVecZAtts_a_vectorVal, "realFuncVecZ a_vectorVal");
      if (log && !findString("a_vectorVal", realFuncVecZAtts))
	{
	  warnAtt("a_vectorVal", "realFuncVecZ", a_realFuncVecZ);
	  check_vectorVal(a_realFuncVecZ->get_vectorVal(), 0);
	}
      else
	check_vectorVal(a_realFuncVecZ->get_vectorVal(), log);
    }
}

/********************************************************************/

void check_realFuncVmag(
 realFuncVmag * a_realFuncVmag,
 int log)
{
  if (a_realFuncVmag->get_vectorVal())
    {
      adjustLevels(&realFuncVmagAtts_a_vectorVal, "realFuncVmag a_vectorVal");
      if (log && !findString("a_vectorVal", realFuncVmagAtts))
	{
	  warnAtt("a_vectorVal", "realFuncVmag", a_realFuncVmag);
	  check_vectorVal(a_realFuncVmag->get_vectorVal(), 0);
	}
      else
	check_vectorVal(a_realFuncVmag->get_vectorVal(), log);
    }
}

/********************************************************************/

void check_realIntExpr(
 realIntExpr * a_realIntExpr,
 int log)
{
  if (isA(a_realIntExpr, realIntExpr_PLUS))
    {
      adjustLevels(&realIntExprSubs_realIntExpr_PLUS, "realIntExpr_PLUS");
      if (log && !findString("realIntExpr_PLUS", realIntExprSubs))
	{
	  warnSub("realIntExpr_PLUS", "realIntExpr", a_realIntExpr);
	  check_realIntExpr_PLUS(
	    dynamic_cast<realIntExpr_PLUS *>(a_realIntExpr), 0);
	}
      else
	check_realIntExpr_PLUS(
	  dynamic_cast<realIntExpr_PLUS *>(a_realIntExpr), log);
      return;
    }
  if (isA(a_realIntExpr, realIntExpr_MINUS))
    {
      adjustLevels(&realIntExprSubs_realIntExpr_MINUS, "realIntExpr_MINUS");
      if (log && !findString("realIntExpr_MINUS", realIntExprSubs))
	{
	  warnSub("realIntExpr_MINUS", "realIntExpr", a_realIntExpr);
	  check_realIntExpr_MINUS(
	    dynamic_cast<realIntExpr_MINUS *>(a_realIntExpr), 0);
	}
      else
	check_realIntExpr_MINUS(
	  dynamic_cast<realIntExpr_MINUS *>(a_realIntExpr), log);
      return;
    }
  if (isA(a_realIntExpr, realIntExpr_TIMES))
    {
      adjustLevels(&realIntExprSubs_realIntExpr_TIMES, "realIntExpr_TIMES");
      if (log && !findString("realIntExpr_TIMES", realIntExprSubs))
	{
	  warnSub("realIntExpr_TIMES", "realIntExpr", a_realIntExpr);
	  check_realIntExpr_TIMES(
	    dynamic_cast<realIntExpr_TIMES *>(a_realIntExpr), 0);
	}
      else
	check_realIntExpr_TIMES(
	  dynamic_cast<realIntExpr_TIMES *>(a_realIntExpr), log);
      return;
    }
  if (isA(a_realIntExpr, realIntExpr_DIVID))
    {
      adjustLevels(&realIntExprSubs_realIntExpr_DIVID, "realIntExpr_DIVID");
      if (log && !findString("realIntExpr_DIVID", realIntExprSubs))
	{
	  warnSub("realIntExpr_DIVID", "realIntExpr", a_realIntExpr);
	  check_realIntExpr_DIVID(
	    dynamic_cast<realIntExpr_DIVID *>(a_realIntExpr), 0);
	}
      else
	check_realIntExpr_DIVID(
	  dynamic_cast<realIntExpr_DIVID *>(a_realIntExpr), log);
      return;
    }
  if (isA(a_realIntExpr, realIntExpr_POWER))
    {
      adjustLevels(&realIntExprSubs_realIntExpr_POWER, "realIntExpr_POWER");
      if (log && !findString("realIntExpr_POWER", realIntExprSubs))
	{
	  warnSub("realIntExpr_POWER", "realIntExpr", a_realIntExpr);
	  check_realIntExpr_POWER(
	    dynamic_cast<realIntExpr_POWER *>(a_realIntExpr), 0);
	}
      else
	check_realIntExpr_POWER(
	  dynamic_cast<realIntExpr_POWER *>(a_realIntExpr), log);
      return;
    }
}

/********************************************************************/

void check_realIntExpr_DIVID(
 realIntExpr_DIVID * a_realIntExpr_DIVID,
 int log)
{
  if (a_realIntExpr_DIVID->get_dvend())
    {
      adjustLevels(&realIntExpr_DIVIDAtts_dvend, "realIntExpr_DIVID dvend");
      if (log && !findString("dvend", realIntExpr_DIVIDAtts))
	{
	  warnAtt("dvend", "realIntExpr_DIVID", a_realIntExpr_DIVID);
	  check_realVal(a_realIntExpr_DIVID->get_dvend(), 0);
	}
      else
	check_realVal(a_realIntExpr_DIVID->get_dvend(), log);
    }
  if (a_realIntExpr_DIVID->get_dvisr())
    {
      adjustLevels(&realIntExpr_DIVIDAtts_dvisr, "realIntExpr_DIVID dvisr");
      if (log && !findString("dvisr", realIntExpr_DIVIDAtts))
	{
	  warnAtt("dvisr", "realIntExpr_DIVID", a_realIntExpr_DIVID);
	  check_intVal(a_realIntExpr_DIVID->get_dvisr(), 0);
	}
      else
	check_intVal(a_realIntExpr_DIVID->get_dvisr(), log);
    }
}

/********************************************************************/

void check_realIntExpr_MINUS(
 realIntExpr_MINUS * a_realIntExpr_MINUS,
 int log)
{
  if (a_realIntExpr_MINUS->get_term1())
    {
      adjustLevels(&realIntExpr_MINUSAtts_term1, "realIntExpr_MINUS term1");
      if (log && !findString("term1", realIntExpr_MINUSAtts))
	{
	  warnAtt("term1", "realIntExpr_MINUS", a_realIntExpr_MINUS);
	  check_realVal(a_realIntExpr_MINUS->get_term1(), 0);
	}
      else
	check_realVal(a_realIntExpr_MINUS->get_term1(), log);
    }
  if (a_realIntExpr_MINUS->get_term2())
    {
      adjustLevels(&realIntExpr_MINUSAtts_term2, "realIntExpr_MINUS term2");
      if (log && !findString("term2", realIntExpr_MINUSAtts))
	{
	  warnAtt("term2", "realIntExpr_MINUS", a_realIntExpr_MINUS);
	  check_intVal(a_realIntExpr_MINUS->get_term2(), 0);
	}
      else
	check_intVal(a_realIntExpr_MINUS->get_term2(), log);
    }
}

/********************************************************************/

void check_realIntExpr_PLUS(
 realIntExpr_PLUS * a_realIntExpr_PLUS,
 int log)
{
  if (a_realIntExpr_PLUS->get_term1())
    {
      adjustLevels(&realIntExpr_PLUSAtts_term1, "realIntExpr_PLUS term1");
      if (log && !findString("term1", realIntExpr_PLUSAtts))
	{
	  warnAtt("term1", "realIntExpr_PLUS", a_realIntExpr_PLUS);
	  check_realVal(a_realIntExpr_PLUS->get_term1(), 0);
	}
      else
	check_realVal(a_realIntExpr_PLUS->get_term1(), log);
    }
  if (a_realIntExpr_PLUS->get_term2())
    {
      adjustLevels(&realIntExpr_PLUSAtts_term2, "realIntExpr_PLUS term2");
      if (log && !findString("term2", realIntExpr_PLUSAtts))
	{
	  warnAtt("term2", "realIntExpr_PLUS", a_realIntExpr_PLUS);
	  check_intVal(a_realIntExpr_PLUS->get_term2(), 0);
	}
      else
	check_intVal(a_realIntExpr_PLUS->get_term2(), log);
    }
}

/********************************************************************/

void check_realIntExpr_POWER(
 realIntExpr_POWER * a_realIntExpr_POWER,
 int log)
{
  if (a_realIntExpr_POWER->get_base())
    {
      adjustLevels(&realIntExpr_POWERAtts_base, "realIntExpr_POWER base");
      if (log && !findString("base", realIntExpr_POWERAtts))
	{
	  warnAtt("base", "realIntExpr_POWER", a_realIntExpr_POWER);
	  check_realVal(a_realIntExpr_POWER->get_base(), 0);
	}
      else
	check_realVal(a_realIntExpr_POWER->get_base(), log);
    }
  if (a_realIntExpr_POWER->get_expon())
    {
      adjustLevels(&realIntExpr_POWERAtts_expon, "realIntExpr_POWER expon");
      if (log && !findString("expon", realIntExpr_POWERAtts))
	{
	  warnAtt("expon", "realIntExpr_POWER", a_realIntExpr_POWER);
	  check_intVal(a_realIntExpr_POWER->get_expon(), 0);
	}
      else
	check_intVal(a_realIntExpr_POWER->get_expon(), log);
    }
}

/********************************************************************/

void check_realIntExpr_TIMES(
 realIntExpr_TIMES * a_realIntExpr_TIMES,
 int log)
{
  if (a_realIntExpr_TIMES->get_term1())
    {
      adjustLevels(&realIntExpr_TIMESAtts_term1, "realIntExpr_TIMES term1");
      if (log && !findString("term1", realIntExpr_TIMESAtts))
	{
	  warnAtt("term1", "realIntExpr_TIMES", a_realIntExpr_TIMES);
	  check_realVal(a_realIntExpr_TIMES->get_term1(), 0);
	}
      else
	check_realVal(a_realIntExpr_TIMES->get_term1(), log);
    }
  if (a_realIntExpr_TIMES->get_term2())
    {
      adjustLevels(&realIntExpr_TIMESAtts_term2, "realIntExpr_TIMES term2");
      if (log && !findString("term2", realIntExpr_TIMESAtts))
	{
	  warnAtt("term2", "realIntExpr_TIMES", a_realIntExpr_TIMES);
	  check_intVal(a_realIntExpr_TIMES->get_term2(), 0);
	}
      else
	check_intVal(a_realIntExpr_TIMES->get_term2(), log);
    }
}

/********************************************************************/

void check_realIntRel(
 realIntRel * a_realIntRel,
 int log)
{
  if (isA(a_realIntRel, realIntRel_EQ))
    {
      adjustLevels(&realIntRelSubs_realIntRel_EQ, "realIntRel_EQ");
      if (log && !findString("realIntRel_EQ", realIntRelSubs))
	{
	  warnSub("realIntRel_EQ", "realIntRel", a_realIntRel);
	  check_realIntRel_EQ(
	    dynamic_cast<realIntRel_EQ *>(a_realIntRel), 0);
	}
      else
	check_realIntRel_EQ(
	  dynamic_cast<realIntRel_EQ *>(a_realIntRel), log);
      return;
    }
  if (isA(a_realIntRel, realIntRel_NE))
    {
      adjustLevels(&realIntRelSubs_realIntRel_NE, "realIntRel_NE");
      if (log && !findString("realIntRel_NE", realIntRelSubs))
	{
	  warnSub("realIntRel_NE", "realIntRel", a_realIntRel);
	  check_realIntRel_NE(
	    dynamic_cast<realIntRel_NE *>(a_realIntRel), 0);
	}
      else
	check_realIntRel_NE(
	  dynamic_cast<realIntRel_NE *>(a_realIntRel), log);
      return;
    }
  if (isA(a_realIntRel, realIntRel_LT))
    {
      adjustLevels(&realIntRelSubs_realIntRel_LT, "realIntRel_LT");
      if (log && !findString("realIntRel_LT", realIntRelSubs))
	{
	  warnSub("realIntRel_LT", "realIntRel", a_realIntRel);
	  check_realIntRel_LT(
	    dynamic_cast<realIntRel_LT *>(a_realIntRel), 0);
	}
      else
	check_realIntRel_LT(
	  dynamic_cast<realIntRel_LT *>(a_realIntRel), log);
      return;
    }
  if (isA(a_realIntRel, realIntRel_LE))
    {
      adjustLevels(&realIntRelSubs_realIntRel_LE, "realIntRel_LE");
      if (log && !findString("realIntRel_LE", realIntRelSubs))
	{
	  warnSub("realIntRel_LE", "realIntRel", a_realIntRel);
	  check_realIntRel_LE(
	    dynamic_cast<realIntRel_LE *>(a_realIntRel), 0);
	}
      else
	check_realIntRel_LE(
	  dynamic_cast<realIntRel_LE *>(a_realIntRel), log);
      return;
    }
  if (isA(a_realIntRel, realIntRel_GT))
    {
      adjustLevels(&realIntRelSubs_realIntRel_GT, "realIntRel_GT");
      if (log && !findString("realIntRel_GT", realIntRelSubs))
	{
	  warnSub("realIntRel_GT", "realIntRel", a_realIntRel);
	  check_realIntRel_GT(
	    dynamic_cast<realIntRel_GT *>(a_realIntRel), 0);
	}
      else
	check_realIntRel_GT(
	  dynamic_cast<realIntRel_GT *>(a_realIntRel), log);
      return;
    }
  if (isA(a_realIntRel, realIntRel_GE))
    {
      adjustLevels(&realIntRelSubs_realIntRel_GE, "realIntRel_GE");
      if (log && !findString("realIntRel_GE", realIntRelSubs))
	{
	  warnSub("realIntRel_GE", "realIntRel", a_realIntRel);
	  check_realIntRel_GE(
	    dynamic_cast<realIntRel_GE *>(a_realIntRel), 0);
	}
      else
	check_realIntRel_GE(
	  dynamic_cast<realIntRel_GE *>(a_realIntRel), log);
      return;
    }
}

/********************************************************************/

void check_realIntRel_EQ(
 realIntRel_EQ * a_realIntRel_EQ,
 int log)
{
  if (a_realIntRel_EQ->get_left())
    {
      adjustLevels(&realIntRel_EQAtts_left, "realIntRel_EQ left");
      if (log && !findString("left", realIntRel_EQAtts))
	{
	  warnAtt("left", "realIntRel_EQ", a_realIntRel_EQ);
	  check_realVal(a_realIntRel_EQ->get_left(), 0);
	}
      else
	check_realVal(a_realIntRel_EQ->get_left(), log);
    }
  if (a_realIntRel_EQ->get_right())
    {
      adjustLevels(&realIntRel_EQAtts_right, "realIntRel_EQ right");
      if (log && !findString("right", realIntRel_EQAtts))
	{
	  warnAtt("right", "realIntRel_EQ", a_realIntRel_EQ);
	  check_intVal(a_realIntRel_EQ->get_right(), 0);
	}
      else
	check_intVal(a_realIntRel_EQ->get_right(), log);
    }
}

/********************************************************************/

void check_realIntRel_GE(
 realIntRel_GE * a_realIntRel_GE,
 int log)
{
  if (a_realIntRel_GE->get_left())
    {
      adjustLevels(&realIntRel_GEAtts_left, "realIntRel_GE left");
      if (log && !findString("left", realIntRel_GEAtts))
	{
	  warnAtt("left", "realIntRel_GE", a_realIntRel_GE);
	  check_realVal(a_realIntRel_GE->get_left(), 0);
	}
      else
	check_realVal(a_realIntRel_GE->get_left(), log);
    }
  if (a_realIntRel_GE->get_right())
    {
      adjustLevels(&realIntRel_GEAtts_right, "realIntRel_GE right");
      if (log && !findString("right", realIntRel_GEAtts))
	{
	  warnAtt("right", "realIntRel_GE", a_realIntRel_GE);
	  check_intVal(a_realIntRel_GE->get_right(), 0);
	}
      else
	check_intVal(a_realIntRel_GE->get_right(), log);
    }
}

/********************************************************************/

void check_realIntRel_GT(
 realIntRel_GT * a_realIntRel_GT,
 int log)
{
  if (a_realIntRel_GT->get_left())
    {
      adjustLevels(&realIntRel_GTAtts_left, "realIntRel_GT left");
      if (log && !findString("left", realIntRel_GTAtts))
	{
	  warnAtt("left", "realIntRel_GT", a_realIntRel_GT);
	  check_realVal(a_realIntRel_GT->get_left(), 0);
	}
      else
	check_realVal(a_realIntRel_GT->get_left(), log);
    }
  if (a_realIntRel_GT->get_right())
    {
      adjustLevels(&realIntRel_GTAtts_right, "realIntRel_GT right");
      if (log && !findString("right", realIntRel_GTAtts))
	{
	  warnAtt("right", "realIntRel_GT", a_realIntRel_GT);
	  check_intVal(a_realIntRel_GT->get_right(), 0);
	}
      else
	check_intVal(a_realIntRel_GT->get_right(), log);
    }
}

/********************************************************************/

void check_realIntRel_LE(
 realIntRel_LE * a_realIntRel_LE,
 int log)
{
  if (a_realIntRel_LE->get_left())
    {
      adjustLevels(&realIntRel_LEAtts_left, "realIntRel_LE left");
      if (log && !findString("left", realIntRel_LEAtts))
	{
	  warnAtt("left", "realIntRel_LE", a_realIntRel_LE);
	  check_realVal(a_realIntRel_LE->get_left(), 0);
	}
      else
	check_realVal(a_realIntRel_LE->get_left(), log);
    }
  if (a_realIntRel_LE->get_right())
    {
      adjustLevels(&realIntRel_LEAtts_right, "realIntRel_LE right");
      if (log && !findString("right", realIntRel_LEAtts))
	{
	  warnAtt("right", "realIntRel_LE", a_realIntRel_LE);
	  check_intVal(a_realIntRel_LE->get_right(), 0);
	}
      else
	check_intVal(a_realIntRel_LE->get_right(), log);
    }
}

/********************************************************************/

void check_realIntRel_LT(
 realIntRel_LT * a_realIntRel_LT,
 int log)
{
  if (a_realIntRel_LT->get_left())
    {
      adjustLevels(&realIntRel_LTAtts_left, "realIntRel_LT left");
      if (log && !findString("left", realIntRel_LTAtts))
	{
	  warnAtt("left", "realIntRel_LT", a_realIntRel_LT);
	  check_realVal(a_realIntRel_LT->get_left(), 0);
	}
      else
	check_realVal(a_realIntRel_LT->get_left(), log);
    }
  if (a_realIntRel_LT->get_right())
    {
      adjustLevels(&realIntRel_LTAtts_right, "realIntRel_LT right");
      if (log && !findString("right", realIntRel_LTAtts))
	{
	  warnAtt("right", "realIntRel_LT", a_realIntRel_LT);
	  check_intVal(a_realIntRel_LT->get_right(), 0);
	}
      else
	check_intVal(a_realIntRel_LT->get_right(), log);
    }
}

/********************************************************************/

void check_realIntRel_NE(
 realIntRel_NE * a_realIntRel_NE,
 int log)
{
  if (a_realIntRel_NE->get_left())
    {
      adjustLevels(&realIntRel_NEAtts_left, "realIntRel_NE left");
      if (log && !findString("left", realIntRel_NEAtts))
	{
	  warnAtt("left", "realIntRel_NE", a_realIntRel_NE);
	  check_realVal(a_realIntRel_NE->get_left(), 0);
	}
      else
	check_realVal(a_realIntRel_NE->get_left(), log);
    }
  if (a_realIntRel_NE->get_right())
    {
      adjustLevels(&realIntRel_NEAtts_right, "realIntRel_NE right");
      if (log && !findString("right", realIntRel_NEAtts))
	{
	  warnAtt("right", "realIntRel_NE", a_realIntRel_NE);
	  check_intVal(a_realIntRel_NE->get_right(), 0);
	}
      else
	check_intVal(a_realIntRel_NE->get_right(), log);
    }
}

/********************************************************************/

void check_realRealExpr(
 realRealExpr * a_realRealExpr,
 int log)
{
  if (isA(a_realRealExpr, realRealExpr_PLUS))
    {
      adjustLevels(&realRealExprSubs_realRealExpr_PLUS, "realRealExpr_PLUS");
      if (log && !findString("realRealExpr_PLUS", realRealExprSubs))
	{
	  warnSub("realRealExpr_PLUS", "realRealExpr", a_realRealExpr);
	  check_realRealExpr_PLUS(
	    dynamic_cast<realRealExpr_PLUS *>(a_realRealExpr), 0);
	}
      else
	check_realRealExpr_PLUS(
	  dynamic_cast<realRealExpr_PLUS *>(a_realRealExpr), log);
      return;
    }
  if (isA(a_realRealExpr, realRealExpr_MINUS))
    {
      adjustLevels(&realRealExprSubs_realRealExpr_MINUS, "realRealExpr_MINUS");
      if (log && !findString("realRealExpr_MINUS", realRealExprSubs))
	{
	  warnSub("realRealExpr_MINUS", "realRealExpr", a_realRealExpr);
	  check_realRealExpr_MINUS(
	    dynamic_cast<realRealExpr_MINUS *>(a_realRealExpr), 0);
	}
      else
	check_realRealExpr_MINUS(
	  dynamic_cast<realRealExpr_MINUS *>(a_realRealExpr), log);
      return;
    }
  if (isA(a_realRealExpr, realRealExpr_TIMES))
    {
      adjustLevels(&realRealExprSubs_realRealExpr_TIMES, "realRealExpr_TIMES");
      if (log && !findString("realRealExpr_TIMES", realRealExprSubs))
	{
	  warnSub("realRealExpr_TIMES", "realRealExpr", a_realRealExpr);
	  check_realRealExpr_TIMES(
	    dynamic_cast<realRealExpr_TIMES *>(a_realRealExpr), 0);
	}
      else
	check_realRealExpr_TIMES(
	  dynamic_cast<realRealExpr_TIMES *>(a_realRealExpr), log);
      return;
    }
  if (isA(a_realRealExpr, realRealExpr_DIVID))
    {
      adjustLevels(&realRealExprSubs_realRealExpr_DIVID, "realRealExpr_DIVID");
      if (log && !findString("realRealExpr_DIVID", realRealExprSubs))
	{
	  warnSub("realRealExpr_DIVID", "realRealExpr", a_realRealExpr);
	  check_realRealExpr_DIVID(
	    dynamic_cast<realRealExpr_DIVID *>(a_realRealExpr), 0);
	}
      else
	check_realRealExpr_DIVID(
	  dynamic_cast<realRealExpr_DIVID *>(a_realRealExpr), log);
      return;
    }
  if (isA(a_realRealExpr, realRealExpr_POWER))
    {
      adjustLevels(&realRealExprSubs_realRealExpr_POWER, "realRealExpr_POWER");
      if (log && !findString("realRealExpr_POWER", realRealExprSubs))
	{
	  warnSub("realRealExpr_POWER", "realRealExpr", a_realRealExpr);
	  check_realRealExpr_POWER(
	    dynamic_cast<realRealExpr_POWER *>(a_realRealExpr), 0);
	}
      else
	check_realRealExpr_POWER(
	  dynamic_cast<realRealExpr_POWER *>(a_realRealExpr), log);
      return;
    }
}

/********************************************************************/

void check_realRealExpr_DIVID(
 realRealExpr_DIVID * a_realRealExpr_DIVID,
 int log)
{
  if (a_realRealExpr_DIVID->get_dvend())
    {
      adjustLevels(&realRealExpr_DIVIDAtts_dvend, "realRealExpr_DIVID dvend");
      if (log && !findString("dvend", realRealExpr_DIVIDAtts))
	{
	  warnAtt("dvend", "realRealExpr_DIVID", a_realRealExpr_DIVID);
	  check_realVal(a_realRealExpr_DIVID->get_dvend(), 0);
	}
      else
	check_realVal(a_realRealExpr_DIVID->get_dvend(), log);
    }
  if (a_realRealExpr_DIVID->get_dvisr())
    {
      adjustLevels(&realRealExpr_DIVIDAtts_dvisr, "realRealExpr_DIVID dvisr");
      if (log && !findString("dvisr", realRealExpr_DIVIDAtts))
	{
	  warnAtt("dvisr", "realRealExpr_DIVID", a_realRealExpr_DIVID);
	  check_realVal(a_realRealExpr_DIVID->get_dvisr(), 0);
	}
      else
	check_realVal(a_realRealExpr_DIVID->get_dvisr(), log);
    }
}

/********************************************************************/

void check_realRealExpr_MINUS(
 realRealExpr_MINUS * a_realRealExpr_MINUS,
 int log)
{
  if (a_realRealExpr_MINUS->get_term1())
    {
      adjustLevels(&realRealExpr_MINUSAtts_term1, "realRealExpr_MINUS term1");
      if (log && !findString("term1", realRealExpr_MINUSAtts))
	{
	  warnAtt("term1", "realRealExpr_MINUS", a_realRealExpr_MINUS);
	  check_realVal(a_realRealExpr_MINUS->get_term1(), 0);
	}
      else
	check_realVal(a_realRealExpr_MINUS->get_term1(), log);
    }
  if (a_realRealExpr_MINUS->get_term2())
    {
      adjustLevels(&realRealExpr_MINUSAtts_term2, "realRealExpr_MINUS term2");
      if (log && !findString("term2", realRealExpr_MINUSAtts))
	{
	  warnAtt("term2", "realRealExpr_MINUS", a_realRealExpr_MINUS);
	  check_realVal(a_realRealExpr_MINUS->get_term2(), 0);
	}
      else
	check_realVal(a_realRealExpr_MINUS->get_term2(), log);
    }
}

/********************************************************************/

void check_realRealExpr_PLUS(
 realRealExpr_PLUS * a_realRealExpr_PLUS,
 int log)
{
  if (a_realRealExpr_PLUS->get_term1())
    {
      adjustLevels(&realRealExpr_PLUSAtts_term1, "realRealExpr_PLUS term1");
      if (log && !findString("term1", realRealExpr_PLUSAtts))
	{
	  warnAtt("term1", "realRealExpr_PLUS", a_realRealExpr_PLUS);
	  check_realVal(a_realRealExpr_PLUS->get_term1(), 0);
	}
      else
	check_realVal(a_realRealExpr_PLUS->get_term1(), log);
    }
  if (a_realRealExpr_PLUS->get_term2())
    {
      adjustLevels(&realRealExpr_PLUSAtts_term2, "realRealExpr_PLUS term2");
      if (log && !findString("term2", realRealExpr_PLUSAtts))
	{
	  warnAtt("term2", "realRealExpr_PLUS", a_realRealExpr_PLUS);
	  check_realVal(a_realRealExpr_PLUS->get_term2(), 0);
	}
      else
	check_realVal(a_realRealExpr_PLUS->get_term2(), log);
    }
}

/********************************************************************/

void check_realRealExpr_POWER(
 realRealExpr_POWER * a_realRealExpr_POWER,
 int log)
{
  if (a_realRealExpr_POWER->get_base())
    {
      adjustLevels(&realRealExpr_POWERAtts_base, "realRealExpr_POWER base");
      if (log && !findString("base", realRealExpr_POWERAtts))
	{
	  warnAtt("base", "realRealExpr_POWER", a_realRealExpr_POWER);
	  check_realVal(a_realRealExpr_POWER->get_base(), 0);
	}
      else
	check_realVal(a_realRealExpr_POWER->get_base(), log);
    }
  if (a_realRealExpr_POWER->get_expon())
    {
      adjustLevels(&realRealExpr_POWERAtts_expon, "realRealExpr_POWER expon");
      if (log && !findString("expon", realRealExpr_POWERAtts))
	{
	  warnAtt("expon", "realRealExpr_POWER", a_realRealExpr_POWER);
	  check_realVal(a_realRealExpr_POWER->get_expon(), 0);
	}
      else
	check_realVal(a_realRealExpr_POWER->get_expon(), log);
    }
}

/********************************************************************/

void check_realRealExpr_TIMES(
 realRealExpr_TIMES * a_realRealExpr_TIMES,
 int log)
{
  if (a_realRealExpr_TIMES->get_term1())
    {
      adjustLevels(&realRealExpr_TIMESAtts_term1, "realRealExpr_TIMES term1");
      if (log && !findString("term1", realRealExpr_TIMESAtts))
	{
	  warnAtt("term1", "realRealExpr_TIMES", a_realRealExpr_TIMES);
	  check_realVal(a_realRealExpr_TIMES->get_term1(), 0);
	}
      else
	check_realVal(a_realRealExpr_TIMES->get_term1(), log);
    }
  if (a_realRealExpr_TIMES->get_term2())
    {
      adjustLevels(&realRealExpr_TIMESAtts_term2, "realRealExpr_TIMES term2");
      if (log && !findString("term2", realRealExpr_TIMESAtts))
	{
	  warnAtt("term2", "realRealExpr_TIMES", a_realRealExpr_TIMES);
	  check_realVal(a_realRealExpr_TIMES->get_term2(), 0);
	}
      else
	check_realVal(a_realRealExpr_TIMES->get_term2(), log);
    }
}

/********************************************************************/

void check_realRealRel(
 realRealRel * a_realRealRel,
 int log)
{
  if (isA(a_realRealRel, realRealRel_EQ))
    {
      adjustLevels(&realRealRelSubs_realRealRel_EQ, "realRealRel_EQ");
      if (log && !findString("realRealRel_EQ", realRealRelSubs))
	{
	  warnSub("realRealRel_EQ", "realRealRel", a_realRealRel);
	  check_realRealRel_EQ(
	    dynamic_cast<realRealRel_EQ *>(a_realRealRel), 0);
	}
      else
	check_realRealRel_EQ(
	  dynamic_cast<realRealRel_EQ *>(a_realRealRel), log);
      return;
    }
  if (isA(a_realRealRel, realRealRel_NE))
    {
      adjustLevels(&realRealRelSubs_realRealRel_NE, "realRealRel_NE");
      if (log && !findString("realRealRel_NE", realRealRelSubs))
	{
	  warnSub("realRealRel_NE", "realRealRel", a_realRealRel);
	  check_realRealRel_NE(
	    dynamic_cast<realRealRel_NE *>(a_realRealRel), 0);
	}
      else
	check_realRealRel_NE(
	  dynamic_cast<realRealRel_NE *>(a_realRealRel), log);
      return;
    }
  if (isA(a_realRealRel, realRealRel_LT))
    {
      adjustLevels(&realRealRelSubs_realRealRel_LT, "realRealRel_LT");
      if (log && !findString("realRealRel_LT", realRealRelSubs))
	{
	  warnSub("realRealRel_LT", "realRealRel", a_realRealRel);
	  check_realRealRel_LT(
	    dynamic_cast<realRealRel_LT *>(a_realRealRel), 0);
	}
      else
	check_realRealRel_LT(
	  dynamic_cast<realRealRel_LT *>(a_realRealRel), log);
      return;
    }
  if (isA(a_realRealRel, realRealRel_LE))
    {
      adjustLevels(&realRealRelSubs_realRealRel_LE, "realRealRel_LE");
      if (log && !findString("realRealRel_LE", realRealRelSubs))
	{
	  warnSub("realRealRel_LE", "realRealRel", a_realRealRel);
	  check_realRealRel_LE(
	    dynamic_cast<realRealRel_LE *>(a_realRealRel), 0);
	}
      else
	check_realRealRel_LE(
	  dynamic_cast<realRealRel_LE *>(a_realRealRel), log);
      return;
    }
  if (isA(a_realRealRel, realRealRel_GT))
    {
      adjustLevels(&realRealRelSubs_realRealRel_GT, "realRealRel_GT");
      if (log && !findString("realRealRel_GT", realRealRelSubs))
	{
	  warnSub("realRealRel_GT", "realRealRel", a_realRealRel);
	  check_realRealRel_GT(
	    dynamic_cast<realRealRel_GT *>(a_realRealRel), 0);
	}
      else
	check_realRealRel_GT(
	  dynamic_cast<realRealRel_GT *>(a_realRealRel), log);
      return;
    }
  if (isA(a_realRealRel, realRealRel_GE))
    {
      adjustLevels(&realRealRelSubs_realRealRel_GE, "realRealRel_GE");
      if (log && !findString("realRealRel_GE", realRealRelSubs))
	{
	  warnSub("realRealRel_GE", "realRealRel", a_realRealRel);
	  check_realRealRel_GE(
	    dynamic_cast<realRealRel_GE *>(a_realRealRel), 0);
	}
      else
	check_realRealRel_GE(
	  dynamic_cast<realRealRel_GE *>(a_realRealRel), log);
      return;
    }
}

/********************************************************************/

void check_realRealRel_EQ(
 realRealRel_EQ * a_realRealRel_EQ,
 int log)
{
  if (a_realRealRel_EQ->get_left())
    {
      adjustLevels(&realRealRel_EQAtts_left, "realRealRel_EQ left");
      if (log && !findString("left", realRealRel_EQAtts))
	{
	  warnAtt("left", "realRealRel_EQ", a_realRealRel_EQ);
	  check_realVal(a_realRealRel_EQ->get_left(), 0);
	}
      else
	check_realVal(a_realRealRel_EQ->get_left(), log);
    }
  if (a_realRealRel_EQ->get_right())
    {
      adjustLevels(&realRealRel_EQAtts_right, "realRealRel_EQ right");
      if (log && !findString("right", realRealRel_EQAtts))
	{
	  warnAtt("right", "realRealRel_EQ", a_realRealRel_EQ);
	  check_realVal(a_realRealRel_EQ->get_right(), 0);
	}
      else
	check_realVal(a_realRealRel_EQ->get_right(), log);
    }
}

/********************************************************************/

void check_realRealRel_GE(
 realRealRel_GE * a_realRealRel_GE,
 int log)
{
  if (a_realRealRel_GE->get_left())
    {
      adjustLevels(&realRealRel_GEAtts_left, "realRealRel_GE left");
      if (log && !findString("left", realRealRel_GEAtts))
	{
	  warnAtt("left", "realRealRel_GE", a_realRealRel_GE);
	  check_realVal(a_realRealRel_GE->get_left(), 0);
	}
      else
	check_realVal(a_realRealRel_GE->get_left(), log);
    }
  if (a_realRealRel_GE->get_right())
    {
      adjustLevels(&realRealRel_GEAtts_right, "realRealRel_GE right");
      if (log && !findString("right", realRealRel_GEAtts))
	{
	  warnAtt("right", "realRealRel_GE", a_realRealRel_GE);
	  check_realVal(a_realRealRel_GE->get_right(), 0);
	}
      else
	check_realVal(a_realRealRel_GE->get_right(), log);
    }
}

/********************************************************************/

void check_realRealRel_GT(
 realRealRel_GT * a_realRealRel_GT,
 int log)
{
  if (a_realRealRel_GT->get_left())
    {
      adjustLevels(&realRealRel_GTAtts_left, "realRealRel_GT left");
      if (log && !findString("left", realRealRel_GTAtts))
	{
	  warnAtt("left", "realRealRel_GT", a_realRealRel_GT);
	  check_realVal(a_realRealRel_GT->get_left(), 0);
	}
      else
	check_realVal(a_realRealRel_GT->get_left(), log);
    }
  if (a_realRealRel_GT->get_right())
    {
      adjustLevels(&realRealRel_GTAtts_right, "realRealRel_GT right");
      if (log && !findString("right", realRealRel_GTAtts))
	{
	  warnAtt("right", "realRealRel_GT", a_realRealRel_GT);
	  check_realVal(a_realRealRel_GT->get_right(), 0);
	}
      else
	check_realVal(a_realRealRel_GT->get_right(), log);
    }
}

/********************************************************************/

void check_realRealRel_LE(
 realRealRel_LE * a_realRealRel_LE,
 int log)
{
  if (a_realRealRel_LE->get_left())
    {
      adjustLevels(&realRealRel_LEAtts_left, "realRealRel_LE left");
      if (log && !findString("left", realRealRel_LEAtts))
	{
	  warnAtt("left", "realRealRel_LE", a_realRealRel_LE);
	  check_realVal(a_realRealRel_LE->get_left(), 0);
	}
      else
	check_realVal(a_realRealRel_LE->get_left(), log);
    }
  if (a_realRealRel_LE->get_right())
    {
      adjustLevels(&realRealRel_LEAtts_right, "realRealRel_LE right");
      if (log && !findString("right", realRealRel_LEAtts))
	{
	  warnAtt("right", "realRealRel_LE", a_realRealRel_LE);
	  check_realVal(a_realRealRel_LE->get_right(), 0);
	}
      else
	check_realVal(a_realRealRel_LE->get_right(), log);
    }
}

/********************************************************************/

void check_realRealRel_LT(
 realRealRel_LT * a_realRealRel_LT,
 int log)
{
  if (a_realRealRel_LT->get_left())
    {
      adjustLevels(&realRealRel_LTAtts_left, "realRealRel_LT left");
      if (log && !findString("left", realRealRel_LTAtts))
	{
	  warnAtt("left", "realRealRel_LT", a_realRealRel_LT);
	  check_realVal(a_realRealRel_LT->get_left(), 0);
	}
      else
	check_realVal(a_realRealRel_LT->get_left(), log);
    }
  if (a_realRealRel_LT->get_right())
    {
      adjustLevels(&realRealRel_LTAtts_right, "realRealRel_LT right");
      if (log && !findString("right", realRealRel_LTAtts))
	{
	  warnAtt("right", "realRealRel_LT", a_realRealRel_LT);
	  check_realVal(a_realRealRel_LT->get_right(), 0);
	}
      else
	check_realVal(a_realRealRel_LT->get_right(), log);
    }
}

/********************************************************************/

void check_realRealRel_NE(
 realRealRel_NE * a_realRealRel_NE,
 int log)
{
  if (a_realRealRel_NE->get_left())
    {
      adjustLevels(&realRealRel_NEAtts_left, "realRealRel_NE left");
      if (log && !findString("left", realRealRel_NEAtts))
	{
	  warnAtt("left", "realRealRel_NE", a_realRealRel_NE);
	  check_realVal(a_realRealRel_NE->get_left(), 0);
	}
      else
	check_realVal(a_realRealRel_NE->get_left(), log);
    }
  if (a_realRealRel_NE->get_right())
    {
      adjustLevels(&realRealRel_NEAtts_right, "realRealRel_NE right");
      if (log && !findString("right", realRealRel_NEAtts))
	{
	  warnAtt("right", "realRealRel_NE", a_realRealRel_NE);
	  check_realVal(a_realRealRel_NE->get_right(), 0);
	}
      else
	check_realVal(a_realRealRel_NE->get_right(), log);
    }
}

/********************************************************************/

void check_realRel(
 realRel * a_realRel,
 int log)
{
  if (isA(a_realRel, realRealRel))
    {
      adjustLevels(&realRelSubs_realRealRel, "realRealRel");
      if (log && !findString("realRealRel", realRelSubs))
	{
	  warnSub("realRealRel", "realRel", a_realRel);
	  check_realRealRel(dynamic_cast<realRealRel *>(a_realRel), 0);
	}
      else
	check_realRealRel(dynamic_cast<realRealRel *>(a_realRel), log);
      return;
    }
  if (isA(a_realRel, realIntRel))
    {
      adjustLevels(&realRelSubs_realIntRel, "realIntRel");
      if (log && !findString("realIntRel", realRelSubs))
	{
	  warnSub("realIntRel", "realRel", a_realRel);
	  check_realIntRel(dynamic_cast<realIntRel *>(a_realRel), 0);
	}
      else
	check_realIntRel(dynamic_cast<realIntRel *>(a_realRel), log);
      return;
    }
  if (isA(a_realRel, intRealRel))
    {
      adjustLevels(&realRelSubs_intRealRel, "intRealRel");
      if (log && !findString("intRealRel", realRelSubs))
	{
	  warnSub("intRealRel", "realRel", a_realRel);
	  check_intRealRel(dynamic_cast<intRealRel *>(a_realRel), 0);
	}
      else
	check_intRealRel(dynamic_cast<intRealRel *>(a_realRel), log);
      return;
    }
}

/********************************************************************/

void check_realVal(
 realVal * a_realVal,
 int log)
{
  if (isA(a_realVal, realConst))
    {
      adjustLevels(&realValSubs_realConst, "realConst");
      if (log && !findString("realConst", realValSubs))
	{
	  warnSub("realConst", "realVal", a_realVal);
	  check_realConst(dynamic_cast<realConst *>(a_realVal), 0);
	}
      else
	check_realConst(dynamic_cast<realConst *>(a_realVal), log);
      return;
    }
  if (isA(a_realVal, realExpr))
    {
      adjustLevels(&realValSubs_realExpr, "realExpr");
      if (log && !findString("realExpr", realValSubs))
	{
	  warnSub("realExpr", "realVal", a_realVal);
	  check_realExpr(dynamic_cast<realExpr *>(a_realVal), 0);
	}
      else
	check_realExpr(dynamic_cast<realExpr *>(a_realVal), log);
      return;
    }
  if (isA(a_realVal, realFunc))
    {
      adjustLevels(&realValSubs_realFunc, "realFunc");
      if (log && !findString("realFunc", realValSubs))
	{
	  warnSub("realFunc", "realVal", a_realVal);
	  check_realFunc(dynamic_cast<realFunc *>(a_realVal), 0);
	}
      else
	check_realFunc(dynamic_cast<realFunc *>(a_realVal), log);
      return;
    }
  if (isA(a_realVal, realVar))
    {
      adjustLevels(&realValSubs_realVar, "realVar");
      if (log && !findString("realVar", realValSubs))
	{
	  warnSub("realVar", "realVal", a_realVal);
	  check_realVar(dynamic_cast<realVar *>(a_realVal), 0);
	}
      else
	check_realVar(dynamic_cast<realVar *>(a_realVal), log);
      return;
    }
}

/********************************************************************/

void check_realVar(
 realVar * a_realVar,
 int log)
{
  if (a_realVar->get_string())
    {
      adjustLevels(&realVarAtts_a_string, "realVar a_string");
      if (log && !findString("a_string", realVarAtts))
	{
	  warnAtt("a_string", "realVar", a_realVar);
	}
    }
  if (a_realVar->get_arrayIndex())
    {
      adjustLevels(&realVarAtts_a_arrayIndex, "realVar a_arrayIndex");
      if (log && !findString("a_arrayIndex", realVarAtts))
	{
	  warnAtt("a_arrayIndex", "realVar", a_realVar);
	  check_arrayIndex(a_realVar->get_arrayIndex(), 0);
	}
      else
	check_arrayIndex(a_realVar->get_arrayIndex(), log);
    }
}

/********************************************************************/

void check_realVecExpr_TIMES(
 realVecExpr_TIMES * a_realVecExpr_TIMES,
 int log)
{
  if (a_realVecExpr_TIMES->get_term1())
    {
      adjustLevels(&realVecExpr_TIMESAtts_term1, "realVecExpr_TIMES term1");
      if (log && !findString("term1", realVecExpr_TIMESAtts))
	{
	  warnAtt("term1", "realVecExpr_TIMES", a_realVecExpr_TIMES);
	  check_realVal(a_realVecExpr_TIMES->get_term1(), 0);
	}
      else
	check_realVal(a_realVecExpr_TIMES->get_term1(), log);
    }
  if (a_realVecExpr_TIMES->get_term2())
    {
      adjustLevels(&realVecExpr_TIMESAtts_term2, "realVecExpr_TIMES term2");
      if (log && !findString("term2", realVecExpr_TIMESAtts))
	{
	  warnAtt("term2", "realVecExpr_TIMES", a_realVecExpr_TIMES);
	  check_vectorVal(a_realVecExpr_TIMES->get_term2(), 0);
	}
      else
	check_vectorVal(a_realVecExpr_TIMES->get_term2(), log);
    }
}

/********************************************************************/

void check_recallDMLStm(
 recallDMLStm * a_recallDMLStm,
 int log)
{
  if (a_recallDMLStm->get_didLabel())
    {
      adjustLevels(&recallDMLStmAtts_a_didLabel, "recallDMLStm a_didLabel");
      if (log && !findString("a_didLabel", recallDMLStmAtts))
	{
	  warnAtt("a_didLabel", "recallDMLStm", a_recallDMLStm);
	  check_didLabel(a_recallDMLStm->get_didLabel(), 0);
	}
      else
	check_didLabel(a_recallDMLStm->get_didLabel(), log);
    }
  if (a_recallDMLStm->get_daLabel())
    {
      adjustLevels(&recallDMLStmAtts_a_daLabel, "recallDMLStm a_daLabel");
      if (log && !findString("a_daLabel", recallDMLStmAtts))
	{
	  warnAtt("a_daLabel", "recallDMLStm", a_recallDMLStm);
	  check_daLabel(a_recallDMLStm->get_daLabel(), 0);
	}
      else
	check_daLabel(a_recallDMLStm->get_daLabel(), log);
    }
}

/********************************************************************/

void check_recallDatumStm(
 recallDatumStm * a_recallDatumStm,
 int log)
{
  if (a_recallDatumStm->get_datumLabel2())
    {
      adjustLevels(&recallDatumStmAtts_a_datumLabel2,
		   "recallDatumStm a_datumLabel2");
      if (log && !findString("a_datumLabel2", recallDatumStmAtts))
	{
	  warnAtt("a_datumLabel2", "recallDatumStm", a_recallDatumStm);
	  check_datumLabel2(a_recallDatumStm->get_datumLabel2(), 0);
	}
      else
	check_datumLabel2(a_recallDatumStm->get_datumLabel2(), log);
    }
  if (a_recallDatumStm->get_didLabel())
    {
      adjustLevels(&recallDatumStmAtts_a_didLabel,
		   "recallDatumStm a_didLabel");
      if (log && !findString("a_didLabel", recallDatumStmAtts))
	{
	  warnAtt("a_didLabel", "recallDatumStm", a_recallDatumStm);
	  check_didLabel(a_recallDatumStm->get_didLabel(), 0);
	}
      else
	check_didLabel(a_recallDatumStm->get_didLabel(), log);
    }
}

/********************************************************************/

void check_recallFeatureStm(
 recallFeatureStm * a_recallFeatureStm,
 int log)
{
  if (a_recallFeatureStm->get_faLabel())
    {
      adjustLevels(&recallFeatureStmAtts_a_faLabel,
		   "recallFeatureStm a_faLabel");
      if (log && !findString("a_faLabel", recallFeatureStmAtts))
	{
	  warnAtt("a_faLabel", "recallFeatureStm", a_recallFeatureStm);
	  check_faLabel(a_recallFeatureStm->get_faLabel(), 0);
	}
      else
	check_faLabel(a_recallFeatureStm->get_faLabel(), log);
    }
  if (a_recallFeatureStm->get_didLabel())
    {
      adjustLevels(&recallFeatureStmAtts_a_didLabel,
		   "recallFeatureStm a_didLabel");
      if (log && !findString("a_didLabel", recallFeatureStmAtts))
	{
	  warnAtt("a_didLabel", "recallFeatureStm", a_recallFeatureStm);
	  check_didLabel(a_recallFeatureStm->get_didLabel(), 0);
	}
      else
	check_didLabel(a_recallFeatureStm->get_didLabel(), log);
    }
}

/********************************************************************/

void check_recallRotaryTableStm(
 recallRotaryTableStm * a_recallRotaryTableStm,
 int log)
{
  if (a_recallRotaryTableStm->get_rtLabel())
    {
      adjustLevels(&recallRotaryTableStmAtts_a_rtLabel,
		   "recallRotaryTableStm a_rtLabel");
      if (log && !findString("a_rtLabel", recallRotaryTableStmAtts))
	{
	  warnAtt("a_rtLabel", "recallRotaryTableStm",
		  a_recallRotaryTableStm);
	  check_rtLabel(a_recallRotaryTableStm->get_rtLabel(), 0);
	}
      else
	check_rtLabel(a_recallRotaryTableStm->get_rtLabel(), log);
    }
  if (a_recallRotaryTableStm->get_didLabel())
    {
      adjustLevels(&recallRotaryTableStmAtts_a_didLabel,
		   "recallRotaryTableStm a_didLabel");
      if (log && !findString("a_didLabel", recallRotaryTableStmAtts))
	{
	  warnAtt("a_didLabel", "recallRotaryTableStm",
		  a_recallRotaryTableStm);
	  check_didLabel(a_recallRotaryTableStm->get_didLabel(), 0);
	}
      else
	check_didLabel(a_recallRotaryTableStm->get_didLabel(), log);
    }
}

/********************************************************************/

void check_recallSensorStm(
 recallSensorStm * a_recallSensorStm,
 int log)
{
  if (a_recallSensorStm->get_sensorLabel1())
    {
      adjustLevels(&recallSensorStmAtts_a_sensorLabel1,
		   "recallSensorStm a_sensorLabel1");
      if (log && !findString("a_sensorLabel1", recallSensorStmAtts))
	{
	  warnAtt("a_sensorLabel1", "recallSensorStm", a_recallSensorStm);
	  check_sensorLabel1(a_recallSensorStm->get_sensorLabel1(), 0);
	}
      else
	check_sensorLabel1(a_recallSensorStm->get_sensorLabel1(), log);
    }
  if (a_recallSensorStm->get_didLabel())
    {
      adjustLevels(&recallSensorStmAtts_a_didLabel,
		   "recallSensorStm a_didLabel");
      if (log && !findString("a_didLabel", recallSensorStmAtts))
	{
	  warnAtt("a_didLabel", "recallSensorStm", a_recallSensorStm);
	  check_didLabel(a_recallSensorStm->get_didLabel(), 0);
	}
      else
	check_didLabel(a_recallSensorStm->get_didLabel(), log);
    }
}

/********************************************************************/

void check_refmntStm(
 refmntStm * a_refmntStm,
 int log)
{
  if (a_refmntStm->get_rmLabel())
    {
      adjustLevels(&refmntStmAtts_a_rmLabel, "refmntStm a_rmLabel");
      if (log && !findString("a_rmLabel", refmntStmAtts))
	{
	  warnAtt("a_rmLabel", "refmntStm", a_refmntStm);
	  check_rmLabel(a_refmntStm->get_rmLabel(), 0);
	}
      else
	check_rmLabel(a_refmntStm->get_rmLabel(), log);
    }
  if (a_refmntStm->get_xVec())
    {
      adjustLevels(&refmntStmAtts_xVec, "refmntStm xVec");
      if (log && !findString("xVec", refmntStmAtts))
	{
	  warnAtt("xVec", "refmntStm", a_refmntStm);
	  check_vector(a_refmntStm->get_xVec(), 0);
	}
      else
	check_vector(a_refmntStm->get_xVec(), log);
    }
  if (a_refmntStm->get_zVec())
    {
      adjustLevels(&refmntStmAtts_zVec, "refmntStm zVec");
      if (log && !findString("zVec", refmntStmAtts))
	{
	  warnAtt("zVec", "refmntStm", a_refmntStm);
	  check_vector(a_refmntStm->get_zVec(), 0);
	}
      else
	check_vector(a_refmntStm->get_zVec(), log);
    }
  if (a_refmntStm->get_offset())
    {
      adjustLevels(&refmntStmAtts_offset, "refmntStm offset");
      if (log && !findString("offset", refmntStmAtts))
	{
	  warnAtt("offset", "refmntStm", a_refmntStm);
	  check_vector(a_refmntStm->get_offset(), 0);
	}
      else
	check_vector(a_refmntStm->get_offset(), log);
    }
}

/********************************************************************/

void check_rentVal(
 rentVal * a_rentVal,
 int log)
{
  if (isA(a_rentVal, realVal))
    {
      adjustLevels(&rentValSubs_realVal, "realVal");
      if (log && !findString("realVal", rentValSubs))
	{
	  warnSub("realVal", "rentVal", a_rentVal);
	  check_realVal(dynamic_cast<realVal *>(a_rentVal), 0);
	}
      else
	check_realVal(dynamic_cast<realVal *>(a_rentVal), log);
      return;
    }
  if (isA(a_rentVal, intVal))
    {
      adjustLevels(&rentValSubs_intVal, "intVal");
      if (log && !findString("intVal", rentValSubs))
	{
	  warnSub("intVal", "rentVal", a_rentVal);
	  check_intVal(dynamic_cast<intVal *>(a_rentVal), 0);
	}
      else
	check_intVal(dynamic_cast<intVal *>(a_rentVal), log);
      return;
    }
}

/********************************************************************/

void check_reportItem(
 reportItem * a_reportItem,
 int log)
{
  if (isA(a_reportItem, reportItem_ALGOR))
    {
      adjustLevels(&reportItemSubs_reportItem_ALGOR, "reportItem_ALGOR");
      if (log && !findString("reportItem_ALGOR", reportItemSubs))
	{
	  warnSub("reportItem_ALGOR", "reportItem", a_reportItem);
	}
      return;
    }
  if (isA(a_reportItem, reportItem_DATE))
    {
      adjustLevels(&reportItemSubs_reportItem_DATE, "reportItem_DATE");
      if (log && !findString("reportItem_DATE", reportItemSubs))
	{
	  warnSub("reportItem_DATE", "reportItem", a_reportItem);
	}
      return;
    }
  if (isA(a_reportItem, reportItem_HUMID))
    {
      adjustLevels(&reportItemSubs_reportItem_HUMID, "reportItem_HUMID");
      if (log && !findString("reportItem_HUMID", reportItemSubs))
	{
	  warnSub("reportItem_HUMID", "reportItem", a_reportItem);
	}
      return;
    }
  if (isA(a_reportItem, reportItem_MODE))
    {
      adjustLevels(&reportItemSubs_reportItem_MODE, "reportItem_MODE");
      if (log && !findString("reportItem_MODE", reportItemSubs))
	{
	  warnSub("reportItem_MODE", "reportItem", a_reportItem);
	}
      return;
    }
  if (isA(a_reportItem, reportItem_TEMPC))
    {
      adjustLevels(&reportItemSubs_reportItem_TEMPC, "reportItem_TEMPC");
      if (log && !findString("reportItem_TEMPC", reportItemSubs))
	{
	  warnSub("reportItem_TEMPC", "reportItem", a_reportItem);
	}
      return;
    }
  if (isA(a_reportItem, reportItem_TEMPF))
    {
      adjustLevels(&reportItemSubs_reportItem_TEMPF, "reportItem_TEMPF");
      if (log && !findString("reportItem_TEMPF", reportItemSubs))
	{
	  warnSub("reportItem_TEMPF", "reportItem", a_reportItem);
	}
      return;
    }
  if (isA(a_reportItem, reportItem_TEMPWC))
    {
      adjustLevels(&reportItemSubs_reportItem_TEMPWC, "reportItem_TEMPWC");
      if (log && !findString("reportItem_TEMPWC", reportItemSubs))
	{
	  warnSub("reportItem_TEMPWC", "reportItem", a_reportItem);
	}
      return;
    }
  if (isA(a_reportItem, reportItem_TEMPWF))
    {
      adjustLevels(&reportItemSubs_reportItem_TEMPWF, "reportItem_TEMPWF");
      if (log && !findString("reportItem_TEMPWF", reportItemSubs))
	{
	  warnSub("reportItem_TEMPWF", "reportItem", a_reportItem);
	}
      return;
    }
  if (isA(a_reportItem, reportItem_TIME))
    {
      adjustLevels(&reportItemSubs_reportItem_TIME, "reportItem_TIME");
      if (log && !findString("reportItem_TIME", reportItemSubs))
	{
	  warnSub("reportItem_TIME", "reportItem", a_reportItem);
	}
      return;
    }
  if (isA(a_reportItem, reportItem_qisLabel))
    {
      adjustLevels(&reportItemSubs_reportItem_qisLabel, "reportItem_qisLabel");
      if (log && !findString("reportItem_qisLabel", reportItemSubs))
	{
	  warnSub("reportItem_qisLabel", "reportItem", a_reportItem);
	  check_reportItem_qisLabel(
	    dynamic_cast<reportItem_qisLabel *>(a_reportItem), 0);
	}
      else
	check_reportItem_qisLabel(
	  dynamic_cast<reportItem_qisLabel *>(a_reportItem), log);
      return;
    }
}

/********************************************************************/

void check_reportItem_qisLabel(
 reportItem_qisLabel * a_reportItem_qisLabel,
 int log)
{
  if (a_reportItem_qisLabel->get_qisLabel())
    {
      adjustLevels(&reportItem_qisLabelAtts_a_qisLabel,
		   "reportItem_qisLabel a_qisLabel");
      if (log && !findString("a_qisLabel", reportItem_qisLabelAtts))
	{
	  warnAtt("a_qisLabel", "reportItem_qisLabel", a_reportItem_qisLabel);
	  check_qisLabel(a_reportItem_qisLabel->get_qisLabel(), 0);
	}
      else
	check_qisLabel(a_reportItem_qisLabel->get_qisLabel(), log);
    }
}

/********************************************************************/

void check_reportStm(
 reportStm * a_reportStm,
 int log)
{
  if (a_reportStm->get_rLabel())
    {
      adjustLevels(&reportStmAtts_a_rLabel, "reportStm a_rLabel");
      if (log && !findString("a_rLabel", reportStmAtts))
	{
	  warnAtt("a_rLabel", "reportStm", a_reportStm);
	  check_rLabel(a_reportStm->get_rLabel(), 0);
	}
      else
	check_rLabel(a_reportStm->get_rLabel(), log);
    }
  if (a_reportStm->get_reportItemList())
    {
      std::list<reportItem *> * theList;
      std::list<reportItem *>::iterator iter;
      theList = a_reportStm->get_reportItemList();
      adjustLevels(&reportStmAtts_a_reportItemList,
		   "reportStm a_reportItemList");
      if (log && !findString("a_reportItemList", reportStmAtts))
	{
	  warnAtt("a_reportItemList", "reportStm", a_reportStm);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_reportItem(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_reportItem(*iter, log);
	}
    }
  if (a_reportStm->get_text())
    {
      adjustLevels(&reportStmAtts_text, "reportStm text");
      if (log && !findString("text", reportStmAtts))
	{
	  warnAtt("text", "reportStm", a_reportStm);
	  check_stringVal(a_reportStm->get_text(), 0);
	}
      else
	check_stringVal(a_reportStm->get_text(), log);
    }
}

/********************************************************************/

void check_resumeMinor(
 resumeMinor * a_resumeMinor,
 int log)
{
  if (isA(a_resumeMinor, resumeMinor_jumpLabel))
    {
      adjustLevels(&resumeMinorSubs_resumeMinor_jumpLabel,
		   "resumeMinor_jumpLabel");
      if (log && !findString("resumeMinor_jumpLabel", resumeMinorSubs))
	{
	  warnSub("resumeMinor_jumpLabel", "resumeMinor", a_resumeMinor);
	  check_resumeMinor_jumpLabel(
	    dynamic_cast<resumeMinor_jumpLabel *>(a_resumeMinor), 0);
	}
      else
	check_resumeMinor_jumpLabel(
	  dynamic_cast<resumeMinor_jumpLabel *>(a_resumeMinor), log);
      return;
    }
  if (isA(a_resumeMinor, resumeMinor_CURENT))
    {
      adjustLevels(&resumeMinorSubs_resumeMinor_CURENT, "resumeMinor_CURENT");
      if (log && !findString("resumeMinor_CURENT", resumeMinorSubs))
	{
	  warnSub("resumeMinor_CURENT", "resumeMinor", a_resumeMinor);
	}
      return;
    }
  if (isA(a_resumeMinor, resumeMinor_END))
    {
      adjustLevels(&resumeMinorSubs_resumeMinor_END, "resumeMinor_END");
      if (log && !findString("resumeMinor_END", resumeMinorSubs))
	{
	  warnSub("resumeMinor_END", "resumeMinor", a_resumeMinor);
	}
      return;
    }
  if (isA(a_resumeMinor, resumeMinor_NEXT))
    {
      adjustLevels(&resumeMinorSubs_resumeMinor_NEXT, "resumeMinor_NEXT");
      if (log && !findString("resumeMinor_NEXT", resumeMinorSubs))
	{
	  warnSub("resumeMinor_NEXT", "resumeMinor", a_resumeMinor);
	}
      return;
    }
  if (isA(a_resumeMinor, resumeMinor_START))
    {
      adjustLevels(&resumeMinorSubs_resumeMinor_START, "resumeMinor_START");
      if (log && !findString("resumeMinor_START", resumeMinorSubs))
	{
	  warnSub("resumeMinor_START", "resumeMinor", a_resumeMinor);
	}
      return;
    }
  if (isA(a_resumeMinor, resumeMinor_STOP))
    {
      adjustLevels(&resumeMinorSubs_resumeMinor_STOP, "resumeMinor_STOP");
      if (log && !findString("resumeMinor_STOP", resumeMinorSubs))
	{
	  warnSub("resumeMinor_STOP", "resumeMinor", a_resumeMinor);
	}
      return;
    }
}

/********************************************************************/

void check_resumeMinor_jumpLabel(
 resumeMinor_jumpLabel * a_resumeMinor_jumpLabel,
 int log)
{
  if (a_resumeMinor_jumpLabel->get_jumpLabel())
    {
      adjustLevels(&resumeMinor_jumpLabelAtts_a_jumpLabel,
		   "resumeMinor_jumpLabel a_jumpLabel");
      if (log && !findString("a_jumpLabel", resumeMinor_jumpLabelAtts))
	{
	  warnAtt("a_jumpLabel", "resumeMinor_jumpLabel",
		  a_resumeMinor_jumpLabel);
	  check_jumpLabel(a_resumeMinor_jumpLabel->get_jumpLabel(), 0);
	}
      else
	check_jumpLabel(a_resumeMinor_jumpLabel->get_jumpLabel(), log);
    }
}

/********************************************************************/

void check_resumeStm(
 resumeStm * a_resumeStm,
 int log)
{
  if (a_resumeStm->get_resumeMinor())
    {
      adjustLevels(&resumeStmAtts_a_resumeMinor, "resumeStm a_resumeMinor");
      if (log && !findString("a_resumeMinor", resumeStmAtts))
	{
	  warnAtt("a_resumeMinor", "resumeStm", a_resumeStm);
	  check_resumeMinor(a_resumeStm->get_resumeMinor(), 0);
	}
      else
	check_resumeMinor(a_resumeStm->get_resumeMinor(), log);
    }
}

/********************************************************************/

void check_retrieve1(
 retrieve1 * a_retrieve1,
 int log)
{
  if (a_retrieve1->get_searchRad())
    {
      adjustLevels(&retrieve1Atts_searchRad, "retrieve1 searchRad");
      if (log && !findString("searchRad", retrieve1Atts))
	{
	  warnAtt("searchRad", "retrieve1", a_retrieve1);
	  check_rentVal(a_retrieve1->get_searchRad(), 0);
	}
      else
	check_rentVal(a_retrieve1->get_searchRad(), log);
    }
  if (a_retrieve1->get_featureActualList())
    {
      std::list<faLabel *> * theList;
      std::list<faLabel *>::iterator iter;
      theList = a_retrieve1->get_featureActualList();
      adjustLevels(&retrieve1Atts_a_featureActualList,
		   "retrieve1 a_featureActualList");
      if (log && !findString("a_featureActualList", retrieve1Atts))
	{
	  warnAtt("a_featureActualList", "retrieve1", a_retrieve1);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_faLabel(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_faLabel(*iter, log);
	}
    }
}

/********************************************************************/

void check_retrieve2(
 retrieve2 * a_retrieve2,
 int log)
{
  if (a_retrieve2->get_searchRad())
    {
      adjustLevels(&retrieve2Atts_searchRad, "retrieve2 searchRad");
      if (log && !findString("searchRad", retrieve2Atts))
	{
	  warnAtt("searchRad", "retrieve2", a_retrieve2);
	  check_rentVal(a_retrieve2->get_searchRad(), 0);
	}
      else
	check_rentVal(a_retrieve2->get_searchRad(), log);
    }
  if (a_retrieve2->get_depth())
    {
      adjustLevels(&retrieve2Atts_depth, "retrieve2 depth");
      if (log && !findString("depth", retrieve2Atts))
	{
	  warnAtt("depth", "retrieve2", a_retrieve2);
	  check_rentVal(a_retrieve2->get_depth(), 0);
	}
      else
	check_rentVal(a_retrieve2->get_depth(), log);
    }
  if (a_retrieve2->get_featureActualList())
    {
      std::list<faLabel *> * theList;
      std::list<faLabel *>::iterator iter;
      theList = a_retrieve2->get_featureActualList();
      adjustLevels(&retrieve2Atts_a_featureActualList,
		   "retrieve2 a_featureActualList");
      if (log && !findString("a_featureActualList", retrieve2Atts))
	{
	  warnAtt("a_featureActualList", "retrieve2", a_retrieve2);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_faLabel(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_faLabel(*iter, log);
	}
    }
}

/********************************************************************/

void check_retrieve2b(
 retrieve2b * a_retrieve2b,
 int log)
{
  if (a_retrieve2b->get_searchRad())
    {
      adjustLevels(&retrieve2bAtts_searchRad, "retrieve2b searchRad");
      if (log && !findString("searchRad", retrieve2bAtts))
	{
	  warnAtt("searchRad", "retrieve2b", a_retrieve2b);
	  check_rentVal(a_retrieve2b->get_searchRad(), 0);
	}
      else
	check_rentVal(a_retrieve2b->get_searchRad(), log);
    }
  if (a_retrieve2b->get_axis())
    {
      adjustLevels(&retrieve2bAtts_axis, "retrieve2b axis");
      if (log && !findString("axis", retrieve2bAtts))
	{
	  warnAtt("axis", "retrieve2b", a_retrieve2b);
	  check_vector(a_retrieve2b->get_axis(), 0);
	}
      else
	check_vector(a_retrieve2b->get_axis(), log);
    }
  if (a_retrieve2b->get_featureActualList())
    {
      std::list<faLabel *> * theList;
      std::list<faLabel *>::iterator iter;
      theList = a_retrieve2b->get_featureActualList();
      adjustLevels(&retrieve2bAtts_a_featureActualList,
		   "retrieve2b a_featureActualList");
      if (log && !findString("a_featureActualList", retrieve2bAtts))
	{
	  warnAtt("a_featureActualList", "retrieve2b", a_retrieve2b);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_faLabel(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_faLabel(*iter, log);
	}
    }
}

/********************************************************************/

void check_retrieve4(
 retrieve4 * a_retrieve4,
 int log)
{
  if (a_retrieve4->get_dist())
    {
      adjustLevels(&retrieve4Atts_dist, "retrieve4 dist");
      if (log && !findString("dist", retrieve4Atts))
	{
	  warnAtt("dist", "retrieve4", a_retrieve4);
	  check_rentVal(a_retrieve4->get_dist(), 0);
	}
      else
	check_rentVal(a_retrieve4->get_dist(), log);
    }
  if (a_retrieve4->get_patchRad())
    {
      adjustLevels(&retrieve4Atts_patchRad, "retrieve4 patchRad");
      if (log && !findString("patchRad", retrieve4Atts))
	{
	  warnAtt("patchRad", "retrieve4", a_retrieve4);
	  check_rentVal(a_retrieve4->get_patchRad(), 0);
	}
      else
	check_rentVal(a_retrieve4->get_patchRad(), log);
    }
  if (a_retrieve4->get_depth())
    {
      adjustLevels(&retrieve4Atts_depth, "retrieve4 depth");
      if (log && !findString("depth", retrieve4Atts))
	{
	  warnAtt("depth", "retrieve4", a_retrieve4);
	  check_rentVal(a_retrieve4->get_depth(), 0);
	}
      else
	check_rentVal(a_retrieve4->get_depth(), log);
    }
  if (a_retrieve4->get_searchRad())
    {
      adjustLevels(&retrieve4Atts_searchRad, "retrieve4 searchRad");
      if (log && !findString("searchRad", retrieve4Atts))
	{
	  warnAtt("searchRad", "retrieve4", a_retrieve4);
	  check_rentVal(a_retrieve4->get_searchRad(), 0);
	}
      else
	check_rentVal(a_retrieve4->get_searchRad(), log);
    }
  if (a_retrieve4->get_featureActualList())
    {
      std::list<faLabel *> * theList;
      std::list<faLabel *>::iterator iter;
      theList = a_retrieve4->get_featureActualList();
      adjustLevels(&retrieve4Atts_a_featureActualList,
		   "retrieve4 a_featureActualList");
      if (log && !findString("a_featureActualList", retrieve4Atts))
	{
	  warnAtt("a_featureActualList", "retrieve4", a_retrieve4);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_faLabel(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_faLabel(*iter, log);
	}
    }
}

/********************************************************************/

void check_rightyLefty(
 rightyLefty * a_rightyLefty,
 int log)
{
  if (isA(a_rightyLefty, rightyLefty_RIGHTY))
    {
      adjustLevels(&rightyLeftySubs_rightyLefty_RIGHTY, "rightyLefty_RIGHTY");
      if (log && !findString("rightyLefty_RIGHTY", rightyLeftySubs))
	{
	  warnSub("rightyLefty_RIGHTY", "rightyLefty", a_rightyLefty);
	}
      return;
    }
  if (isA(a_rightyLefty, rightyLefty_LEFTY))
    {
      adjustLevels(&rightyLeftySubs_rightyLefty_LEFTY, "rightyLefty_LEFTY");
      if (log && !findString("rightyLefty_LEFTY", rightyLeftySubs))
	{
	  warnSub("rightyLefty_LEFTY", "rightyLefty", a_rightyLefty);
	}
      return;
    }
}

/********************************************************************/

void check_rmLabel(
 rmLabel * a_rmLabel,
 int log)
{
  if (a_rmLabel->get_labelName())
    {
      adjustLevels(&rmLabelAtts_a_labelName, "rmLabel a_labelName");
      if (log && !findString("a_labelName", rmLabelAtts))
	{
	  warnAtt("a_labelName", "rmLabel", a_rmLabel);
	  check_labelName(a_rmLabel->get_labelName(), 0);
	}
      else
	check_labelName(a_rmLabel->get_labelName(), log);
    }
}

/********************************************************************/

void check_rmeasArc(
 rmeasArc * a_rmeasArc,
 int log)
{
  if (isA(a_rmeasArc, rmeasArc_rmeasSpecFa))
    {
      adjustLevels(&rmeasArcSubs_rmeasArc_rmeasSpecFa, "rmeasArc_rmeasSpecFa");
      if (log && !findString("rmeasArc_rmeasSpecFa", rmeasArcSubs))
	{
	  warnSub("rmeasArc_rmeasSpecFa", "rmeasArc", a_rmeasArc);
	  check_rmeasArc_rmeasSpecFa(
	    dynamic_cast<rmeasArc_rmeasSpecFa *>(a_rmeasArc), 0);
	}
      else
	check_rmeasArc_rmeasSpecFa(
	  dynamic_cast<rmeasArc_rmeasSpecFa *>(a_rmeasArc), log);
      return;
    }
  if (isA(a_rmeasArc, rmeasArc_rmeasSpecVecbld))
    {
      adjustLevels(&rmeasArcSubs_rmeasArc_rmeasSpecVecbld,
		   "rmeasArc_rmeasSpecVecbld");
      if (log && !findString("rmeasArc_rmeasSpecVecbld", rmeasArcSubs))
	{
	  warnSub("rmeasArc_rmeasSpecVecbld", "rmeasArc", a_rmeasArc);
	  check_rmeasArc_rmeasSpecVecbld(
	    dynamic_cast<rmeasArc_rmeasSpecVecbld *>(a_rmeasArc), 0);
	}
      else
	check_rmeasArc_rmeasSpecVecbld(
	  dynamic_cast<rmeasArc_rmeasSpecVecbld *>(a_rmeasArc), log);
      return;
    }
}

/********************************************************************/

void check_rmeasArc_rmeasSpecFa(
 rmeasArc_rmeasSpecFa * a_rmeasArc_rmeasSpecFa,
 int log)
{
  if (a_rmeasArc_rmeasSpecFa->get_fLabel())
    {
      adjustLevels(&rmeasArc_rmeasSpecFaAtts_a_fLabel,
		   "rmeasArc_rmeasSpecFa a_fLabel");
      if (log && !findString("a_fLabel", rmeasArc_rmeasSpecFaAtts))
	{
	  warnAtt("a_fLabel", "rmeasArc_rmeasSpecFa", a_rmeasArc_rmeasSpecFa);
	  check_fLabel(a_rmeasArc_rmeasSpecFa->get_fLabel(), 0);
	}
      else
	check_fLabel(a_rmeasArc_rmeasSpecFa->get_fLabel(), log);
    }
  if (a_rmeasArc_rmeasSpecFa->get_numMeas())
    {
      adjustLevels(&rmeasArc_rmeasSpecFaAtts_numMeas,
		   "rmeasArc_rmeasSpecFa numMeas");
      if (log && !findString("numMeas", rmeasArc_rmeasSpecFaAtts))
	{
	  warnAtt("numMeas", "rmeasArc_rmeasSpecFa", a_rmeasArc_rmeasSpecFa);
	  check_intVal(a_rmeasArc_rmeasSpecFa->get_numMeas(), 0);
	}
      else
	check_intVal(a_rmeasArc_rmeasSpecFa->get_numMeas(), log);
    }
  if (a_rmeasArc_rmeasSpecFa->get_rmeasSpecFa())
    {
      adjustLevels(&rmeasArc_rmeasSpecFaAtts_a_rmeasSpecFa,
		   "rmeasArc_rmeasSpecFa a_rmeasSpecFa");
      if (log && !findString("a_rmeasSpecFa", rmeasArc_rmeasSpecFaAtts))
	{
	  warnAtt("a_rmeasSpecFa", "rmeasArc_rmeasSpecFa",
		  a_rmeasArc_rmeasSpecFa);
	  check_rmeasSpecFa(a_rmeasArc_rmeasSpecFa->get_rmeasSpecFa(), 0);
	}
      else
	check_rmeasSpecFa(a_rmeasArc_rmeasSpecFa->get_rmeasSpecFa(), log);
    }
}

/********************************************************************/

void check_rmeasArc_rmeasSpecVecbld(
 rmeasArc_rmeasSpecVecbld * a_rmeasArc_rmeasSpecVecbld,
 int log)
{
  if (a_rmeasArc_rmeasSpecVecbld->get_fLabel())
    {
      adjustLevels(&rmeasArc_rmeasSpecVecbldAtts_a_fLabel,
		   "rmeasArc_rmeasSpecVecbld a_fLabel");
      if (log && !findString("a_fLabel", rmeasArc_rmeasSpecVecbldAtts))
	{
	  warnAtt("a_fLabel", "rmeasArc_rmeasSpecVecbld",
		  a_rmeasArc_rmeasSpecVecbld);
	  check_fLabel(a_rmeasArc_rmeasSpecVecbld->get_fLabel(), 0);
	}
      else
	check_fLabel(a_rmeasArc_rmeasSpecVecbld->get_fLabel(), log);
    }
  if (a_rmeasArc_rmeasSpecVecbld->get_numMeas())
    {
      adjustLevels(&rmeasArc_rmeasSpecVecbldAtts_numMeas,
		   "rmeasArc_rmeasSpecVecbld numMeas");
      if (log && !findString("numMeas", rmeasArc_rmeasSpecVecbldAtts))
	{
	  warnAtt("numMeas", "rmeasArc_rmeasSpecVecbld",
		  a_rmeasArc_rmeasSpecVecbld);
	  check_intVal(a_rmeasArc_rmeasSpecVecbld->get_numMeas(), 0);
	}
      else
	check_intVal(a_rmeasArc_rmeasSpecVecbld->get_numMeas(), log);
    }
  if (a_rmeasArc_rmeasSpecVecbld->get_rmeasSpecVecbld())
    {
      adjustLevels(&rmeasArc_rmeasSpecVecbldAtts_a_rmeasSpecVecbld,
		   "rmeasArc_rmeasSpecVecbld a_rmeasSpecVecbld");
      if (log && !findString("a_rmeasSpecVecbld",
			     rmeasArc_rmeasSpecVecbldAtts))
	{
	  warnAtt("a_rmeasSpecVecbld", "rmeasArc_rmeasSpecVecbld",
		  a_rmeasArc_rmeasSpecVecbld);
	  check_rmeasSpecVecbld(
	    a_rmeasArc_rmeasSpecVecbld->get_rmeasSpecVecbld(), 0);
	}
      else
	check_rmeasSpecVecbld(
	  a_rmeasArc_rmeasSpecVecbld->get_rmeasSpecVecbld(), log);
    }
}

/********************************************************************/

void check_rmeasCircle(
 rmeasCircle * a_rmeasCircle,
 int log)
{
  if (isA(a_rmeasCircle, rmeasCircle_rmeasSpecFa))
    {
      adjustLevels(&rmeasCircleSubs_rmeasCircle_rmeasSpecFa,
		   "rmeasCircle_rmeasSpecFa");
      if (log && !findString("rmeasCircle_rmeasSpecFa", rmeasCircleSubs))
	{
	  warnSub("rmeasCircle_rmeasSpecFa", "rmeasCircle", a_rmeasCircle);
	  check_rmeasCircle_rmeasSpecFa(
	    dynamic_cast<rmeasCircle_rmeasSpecFa *>(a_rmeasCircle), 0);
	}
      else
	check_rmeasCircle_rmeasSpecFa(
	  dynamic_cast<rmeasCircle_rmeasSpecFa *>(a_rmeasCircle), log);
      return;
    }
  if (isA(a_rmeasCircle, rmeasCircle_rmeasSpecVecbld))
    {
      adjustLevels(&rmeasCircleSubs_rmeasCircle_rmeasSpecVecbld,
		   "rmeasCircle_rmeasSpecVecbld");
      if (log && !findString("rmeasCircle_rmeasSpecVecbld", rmeasCircleSubs))
	{
	  warnSub("rmeasCircle_rmeasSpecVecbld", "rmeasCircle", a_rmeasCircle);
	  check_rmeasCircle_rmeasSpecVecbld(
	    dynamic_cast<rmeasCircle_rmeasSpecVecbld *>(a_rmeasCircle), 0);
	}
      else
	check_rmeasCircle_rmeasSpecVecbld(
	  dynamic_cast<rmeasCircle_rmeasSpecVecbld *>(a_rmeasCircle), log);
      return;
    }
}

/********************************************************************/

void check_rmeasCircle_rmeasSpecFa(
 rmeasCircle_rmeasSpecFa * a_rmeasCircle_rmeasSpecFa,
 int log)
{
  if (a_rmeasCircle_rmeasSpecFa->get_fLabel())
    {
      adjustLevels(&rmeasCircle_rmeasSpecFaAtts_a_fLabel,
		   "rmeasCircle_rmeasSpecFa a_fLabel");
      if (log && !findString("a_fLabel", rmeasCircle_rmeasSpecFaAtts))
	{
	  warnAtt("a_fLabel", "rmeasCircle_rmeasSpecFa",
		  a_rmeasCircle_rmeasSpecFa);
	  check_fLabel(a_rmeasCircle_rmeasSpecFa->get_fLabel(), 0);
	}
      else
	check_fLabel(a_rmeasCircle_rmeasSpecFa->get_fLabel(), log);
    }
  if (a_rmeasCircle_rmeasSpecFa->get_numMeas())
    {
      adjustLevels(&rmeasCircle_rmeasSpecFaAtts_numMeas,
		   "rmeasCircle_rmeasSpecFa numMeas");
      if (log && !findString("numMeas", rmeasCircle_rmeasSpecFaAtts))
	{
	  warnAtt("numMeas", "rmeasCircle_rmeasSpecFa",
		  a_rmeasCircle_rmeasSpecFa);
	  check_intVal(a_rmeasCircle_rmeasSpecFa->get_numMeas(), 0);
	}
      else
	check_intVal(a_rmeasCircle_rmeasSpecFa->get_numMeas(), log);
    }
  if (a_rmeasCircle_rmeasSpecFa->get_rmeasSpecFa())
    {
      adjustLevels(&rmeasCircle_rmeasSpecFaAtts_a_rmeasSpecFa,
		   "rmeasCircle_rmeasSpecFa a_rmeasSpecFa");
      if (log && !findString("a_rmeasSpecFa", rmeasCircle_rmeasSpecFaAtts))
	{
	  warnAtt("a_rmeasSpecFa", "rmeasCircle_rmeasSpecFa",
		  a_rmeasCircle_rmeasSpecFa);
	  check_rmeasSpecFa(a_rmeasCircle_rmeasSpecFa->get_rmeasSpecFa(), 0);
	}
      else
	check_rmeasSpecFa(a_rmeasCircle_rmeasSpecFa->get_rmeasSpecFa(), log);
    }
}

/********************************************************************/

void check_rmeasCircle_rmeasSpecVecbld(
 rmeasCircle_rmeasSpecVecbld * a_rmeasCircle_rmeasSpecVecbld,
 int log)
{
  if (a_rmeasCircle_rmeasSpecVecbld->get_fLabel())
    {
      adjustLevels(&rmeasCircle_rmeasSpecVecbldAtts_a_fLabel,
		   "rmeasCircle_rmeasSpecVecbld a_fLabel");
      if (log && !findString("a_fLabel", rmeasCircle_rmeasSpecVecbldAtts))
	{
	  warnAtt("a_fLabel", "rmeasCircle_rmeasSpecVecbld",
		  a_rmeasCircle_rmeasSpecVecbld);
	  check_fLabel(a_rmeasCircle_rmeasSpecVecbld->get_fLabel(), 0);
	}
      else
	check_fLabel(a_rmeasCircle_rmeasSpecVecbld->get_fLabel(), log);
    }
  if (a_rmeasCircle_rmeasSpecVecbld->get_numMeas())
    {
      adjustLevels(&rmeasCircle_rmeasSpecVecbldAtts_numMeas,
		   "rmeasCircle_rmeasSpecVecbld numMeas");
      if (log && !findString("numMeas", rmeasCircle_rmeasSpecVecbldAtts))
	{
	  warnAtt("numMeas", "rmeasCircle_rmeasSpecVecbld",
		  a_rmeasCircle_rmeasSpecVecbld);
	  check_intVal(a_rmeasCircle_rmeasSpecVecbld->get_numMeas(), 0);
	}
      else
	check_intVal(a_rmeasCircle_rmeasSpecVecbld->get_numMeas(), log);
    }
  if (a_rmeasCircle_rmeasSpecVecbld->get_rmeasSpecVecbld())
    {
      adjustLevels(&rmeasCircle_rmeasSpecVecbldAtts_a_rmeasSpecVecbld,
		   "rmeasCircle_rmeasSpecVecbld a_rmeasSpecVecbld");
      if (log && !findString("a_rmeasSpecVecbld",
			     rmeasCircle_rmeasSpecVecbldAtts))
	{
	  warnAtt("a_rmeasSpecVecbld", "rmeasCircle_rmeasSpecVecbld",
		  a_rmeasCircle_rmeasSpecVecbld);
	  check_rmeasSpecVecbld(
	    a_rmeasCircle_rmeasSpecVecbld->get_rmeasSpecVecbld(), 0);
	}
      else
	check_rmeasSpecVecbld(
	  a_rmeasCircle_rmeasSpecVecbld->get_rmeasSpecVecbld(), log);
    }
}

/********************************************************************/

void check_rmeasCone(
 rmeasCone * a_rmeasCone,
 int log)
{
  if (a_rmeasCone->get_fLabel())
    {
      adjustLevels(&rmeasConeAtts_a_fLabel, "rmeasCone a_fLabel");
      if (log && !findString("a_fLabel", rmeasConeAtts))
	{
	  warnAtt("a_fLabel", "rmeasCone", a_rmeasCone);
	  check_fLabel(a_rmeasCone->get_fLabel(), 0);
	}
      else
	check_fLabel(a_rmeasCone->get_fLabel(), log);
    }
  if (a_rmeasCone->get_numMeas())
    {
      adjustLevels(&rmeasConeAtts_numMeas, "rmeasCone numMeas");
      if (log && !findString("numMeas", rmeasConeAtts))
	{
	  warnAtt("numMeas", "rmeasCone", a_rmeasCone);
	  check_intVal(a_rmeasCone->get_numMeas(), 0);
	}
      else
	check_intVal(a_rmeasCone->get_numMeas(), log);
    }
  if (a_rmeasCone->get_rmeasSpecFa())
    {
      adjustLevels(&rmeasConeAtts_a_rmeasSpecFa, "rmeasCone a_rmeasSpecFa");
      if (log && !findString("a_rmeasSpecFa", rmeasConeAtts))
	{
	  warnAtt("a_rmeasSpecFa", "rmeasCone", a_rmeasCone);
	  check_rmeasSpecFa(a_rmeasCone->get_rmeasSpecFa(), 0);
	}
      else
	check_rmeasSpecFa(a_rmeasCone->get_rmeasSpecFa(), log);
    }
}

/********************************************************************/

void check_rmeasCparln(
 rmeasCparln * a_rmeasCparln,
 int log)
{
  if (isA(a_rmeasCparln, rmeasCparln_rmeasSpecFaOrient))
    {
      adjustLevels(&rmeasCparlnSubs_rmeasCparln_rmeasSpecFaOrient,
		   "rmeasCparln_rmeasSpecFaOrient");
      if (log && !findString("rmeasCparln_rmeasSpecFaOrient", rmeasCparlnSubs))
	{
	  warnSub("rmeasCparln_rmeasSpecFaOrient", "rmeasCparln",
		  a_rmeasCparln);
	  check_rmeasCparln_rmeasSpecFaOrient(
	    dynamic_cast<rmeasCparln_rmeasSpecFaOrient *>(a_rmeasCparln), 0);
	}
      else
	check_rmeasCparln_rmeasSpecFaOrient(
	  dynamic_cast<rmeasCparln_rmeasSpecFaOrient *>(a_rmeasCparln), log);
      return;
    }
  if (isA(a_rmeasCparln, rmeasCparln_rmeasSpecVecbldOrient))
    {
      adjustLevels(&rmeasCparlnSubs_rmeasCparln_rmeasSpecVecbldOrient,
		   "rmeasCparln_rmeasSpecVecbldOrient");
      if (log && !findString("rmeasCparln_rmeasSpecVecbldOrient",
			     rmeasCparlnSubs))
	{
	  warnSub("rmeasCparln_rmeasSpecVecbldOrient", "rmeasCparln",
		  a_rmeasCparln);
	  check_rmeasCparln_rmeasSpecVecbldOrient(
	    dynamic_cast<rmeasCparln_rmeasSpecVecbldOrient *>(a_rmeasCparln), 0);
	}
      else
	check_rmeasCparln_rmeasSpecVecbldOrient(
	  dynamic_cast<rmeasCparln_rmeasSpecVecbldOrient *>(a_rmeasCparln), log);
      return;
    }
}

/********************************************************************/

void check_rmeasCparln_rmeasSpecFaOrient(
 rmeasCparln_rmeasSpecFaOrient * a_rmeasCparln_rmeasSpecFaOrient,
 int log)
{
  if (a_rmeasCparln_rmeasSpecFaOrient->get_fLabel())
    {
      adjustLevels(&rmeasCparln_rmeasSpecFaOrientAtts_a_fLabel,
		   "rmeasCparln_rmeasSpecFaOrient a_fLabel");
      if (log && !findString("a_fLabel", rmeasCparln_rmeasSpecFaOrientAtts))
	{
	  warnAtt("a_fLabel", "rmeasCparln_rmeasSpecFaOrient",
		  a_rmeasCparln_rmeasSpecFaOrient);
	  check_fLabel(a_rmeasCparln_rmeasSpecFaOrient->get_fLabel(), 0);
	}
      else
	check_fLabel(a_rmeasCparln_rmeasSpecFaOrient->get_fLabel(), log);
    }
  if (a_rmeasCparln_rmeasSpecFaOrient->get_numMeas())
    {
      adjustLevels(&rmeasCparln_rmeasSpecFaOrientAtts_numMeas,
		   "rmeasCparln_rmeasSpecFaOrient numMeas");
      if (log && !findString("numMeas", rmeasCparln_rmeasSpecFaOrientAtts))
	{
	  warnAtt("numMeas", "rmeasCparln_rmeasSpecFaOrient",
		  a_rmeasCparln_rmeasSpecFaOrient);
	  check_intVal(a_rmeasCparln_rmeasSpecFaOrient->get_numMeas(), 0);
	}
      else
	check_intVal(a_rmeasCparln_rmeasSpecFaOrient->get_numMeas(), log);
    }
  if (a_rmeasCparln_rmeasSpecFaOrient->get_rmeasSpecFaOrient())
    {
      adjustLevels(&rmeasCparln_rmeasSpecFaOrientAtts_a_rmeasSpecFaOrient,
		   "rmeasCparln_rmeasSpecFaOrient a_rmeasSpecFaOrient");
      if (log && !findString("a_rmeasSpecFaOrient",
			     rmeasCparln_rmeasSpecFaOrientAtts))
	{
	  warnAtt("a_rmeasSpecFaOrient", "rmeasCparln_rmeasSpecFaOrient",
		  a_rmeasCparln_rmeasSpecFaOrient);
	  check_rmeasSpecFaOrient(
	    a_rmeasCparln_rmeasSpecFaOrient->get_rmeasSpecFaOrient(), 0);
	}
      else
	check_rmeasSpecFaOrient(
	  a_rmeasCparln_rmeasSpecFaOrient->get_rmeasSpecFaOrient(), log);
    }
}

/********************************************************************/

void check_rmeasCparln_rmeasSpecVecbldOrient(
 rmeasCparln_rmeasSpecVecbldOrient * a_rmeasCparln_rmeasSpecVecbldOrient,
 int log)
{
  if (a_rmeasCparln_rmeasSpecVecbldOrient->get_fLabel())
    {
      adjustLevels(&rmeasCparln_rmeasSpecVecbldOrientAtts_a_fLabel,
		   "rmeasCparln_rmeasSpecVecbldOrient a_fLabel");
      if (log && !findString("a_fLabel",
			     rmeasCparln_rmeasSpecVecbldOrientAtts))
	{
	  warnAtt("a_fLabel", "rmeasCparln_rmeasSpecVecbldOrient",
		  a_rmeasCparln_rmeasSpecVecbldOrient);
	  check_fLabel(a_rmeasCparln_rmeasSpecVecbldOrient->get_fLabel(), 0);
	}
      else
	check_fLabel(a_rmeasCparln_rmeasSpecVecbldOrient->get_fLabel(), log);
    }
  if (a_rmeasCparln_rmeasSpecVecbldOrient->get_numMeas())
    {
      adjustLevels(&rmeasCparln_rmeasSpecVecbldOrientAtts_numMeas,
		   "rmeasCparln_rmeasSpecVecbldOrient numMeas");
      if (log && !findString("numMeas", rmeasCparln_rmeasSpecVecbldOrientAtts))
	{
	  warnAtt("numMeas", "rmeasCparln_rmeasSpecVecbldOrient",
		  a_rmeasCparln_rmeasSpecVecbldOrient);
	  check_intVal(a_rmeasCparln_rmeasSpecVecbldOrient->get_numMeas(), 0);
	}
      else
	check_intVal(a_rmeasCparln_rmeasSpecVecbldOrient->get_numMeas(), log);
    }
  if (a_rmeasCparln_rmeasSpecVecbldOrient->get_rmeasSpecVecbldOrient())
    {
      adjustLevels(&rmeasCparln_rmeasSpecVecbldOrientAtts_a_rmeasSpecVecbldOrient,
		   "rmeasCparln_rmeasSpecVecbldOrient a_rmeasSpecVecbldOrient");
      if (log && !findString("a_rmeasSpecVecbldOrient",
			     rmeasCparln_rmeasSpecVecbldOrientAtts))
	{
	  warnAtt("a_rmeasSpecVecbldOrient", "rmeasCparln_rmeasSpecVecbldOrient",
		  a_rmeasCparln_rmeasSpecVecbldOrient);
	  check_rmeasSpecVecbldOrient(
	    a_rmeasCparln_rmeasSpecVecbldOrient->get_rmeasSpecVecbldOrient(), 0);
	}
      else
	check_rmeasSpecVecbldOrient(
	  a_rmeasCparln_rmeasSpecVecbldOrient->get_rmeasSpecVecbldOrient(), log);
    }
}

/********************************************************************/

void check_rmeasCylndr(
 rmeasCylndr * a_rmeasCylndr,
 int log)
{
  if (a_rmeasCylndr->get_fLabel())
    {
      adjustLevels(&rmeasCylndrAtts_a_fLabel, "rmeasCylndr a_fLabel");
      if (log && !findString("a_fLabel", rmeasCylndrAtts))
	{
	  warnAtt("a_fLabel", "rmeasCylndr", a_rmeasCylndr);
	  check_fLabel(a_rmeasCylndr->get_fLabel(), 0);
	}
      else
	check_fLabel(a_rmeasCylndr->get_fLabel(), log);
    }
  if (a_rmeasCylndr->get_numMeas())
    {
      adjustLevels(&rmeasCylndrAtts_numMeas, "rmeasCylndr numMeas");
      if (log && !findString("numMeas", rmeasCylndrAtts))
	{
	  warnAtt("numMeas", "rmeasCylndr", a_rmeasCylndr);
	  check_intVal(a_rmeasCylndr->get_numMeas(), 0);
	}
      else
	check_intVal(a_rmeasCylndr->get_numMeas(), log);
    }
  if (a_rmeasCylndr->get_rmeasSpecFa())
    {
      adjustLevels(&rmeasCylndrAtts_a_rmeasSpecFa,
		   "rmeasCylndr a_rmeasSpecFa");
      if (log && !findString("a_rmeasSpecFa", rmeasCylndrAtts))
	{
	  warnAtt("a_rmeasSpecFa", "rmeasCylndr", a_rmeasCylndr);
	  check_rmeasSpecFa(a_rmeasCylndr->get_rmeasSpecFa(), 0);
	}
      else
	check_rmeasSpecFa(a_rmeasCylndr->get_rmeasSpecFa(), log);
    }
}

/********************************************************************/

void check_rmeasEdgept(
 rmeasEdgept * a_rmeasEdgept,
 int log)
{
  if (isA(a_rmeasEdgept, rmeasEdgept_rmeasSpecFaAxis))
    {
      adjustLevels(&rmeasEdgeptSubs_rmeasEdgept_rmeasSpecFaAxis,
		   "rmeasEdgept_rmeasSpecFaAxis");
      if (log && !findString("rmeasEdgept_rmeasSpecFaAxis", rmeasEdgeptSubs))
	{
	  warnSub("rmeasEdgept_rmeasSpecFaAxis", "rmeasEdgept", a_rmeasEdgept);
	  check_rmeasEdgept_rmeasSpecFaAxis(
	    dynamic_cast<rmeasEdgept_rmeasSpecFaAxis *>(a_rmeasEdgept), 0);
	}
      else
	check_rmeasEdgept_rmeasSpecFaAxis(
	  dynamic_cast<rmeasEdgept_rmeasSpecFaAxis *>(a_rmeasEdgept), log);
      return;
    }
  if (isA(a_rmeasEdgept, rmeasEdgept_rmeasSpecVecbldEdgept))
    {
      adjustLevels(&rmeasEdgeptSubs_rmeasEdgept_rmeasSpecVecbldEdgept,
		   "rmeasEdgept_rmeasSpecVecbldEdgept");
      if (log && !findString("rmeasEdgept_rmeasSpecVecbldEdgept",
			     rmeasEdgeptSubs))
	{
	  warnSub("rmeasEdgept_rmeasSpecVecbldEdgept", "rmeasEdgept",
		  a_rmeasEdgept);
	  check_rmeasEdgept_rmeasSpecVecbldEdgept(
	    dynamic_cast<rmeasEdgept_rmeasSpecVecbldEdgept *>(a_rmeasEdgept), 0);
	}
      else
	check_rmeasEdgept_rmeasSpecVecbldEdgept(
	  dynamic_cast<rmeasEdgept_rmeasSpecVecbldEdgept *>(a_rmeasEdgept), log);
      return;
    }
}

/********************************************************************/

void check_rmeasEdgept_rmeasSpecFaAxis(
 rmeasEdgept_rmeasSpecFaAxis * a_rmeasEdgept_rmeasSpecFaAxis,
 int log)
{
  if (a_rmeasEdgept_rmeasSpecFaAxis->get_fLabel())
    {
      adjustLevels(&rmeasEdgept_rmeasSpecFaAxisAtts_a_fLabel,
		   "rmeasEdgept_rmeasSpecFaAxis a_fLabel");
      if (log && !findString("a_fLabel", rmeasEdgept_rmeasSpecFaAxisAtts))
	{
	  warnAtt("a_fLabel", "rmeasEdgept_rmeasSpecFaAxis",
		  a_rmeasEdgept_rmeasSpecFaAxis);
	  check_fLabel(a_rmeasEdgept_rmeasSpecFaAxis->get_fLabel(), 0);
	}
      else
	check_fLabel(a_rmeasEdgept_rmeasSpecFaAxis->get_fLabel(), log);
    }
  if (a_rmeasEdgept_rmeasSpecFaAxis->get_numMeas())
    {
      adjustLevels(&rmeasEdgept_rmeasSpecFaAxisAtts_numMeas,
		   "rmeasEdgept_rmeasSpecFaAxis numMeas");
      if (log && !findString("numMeas", rmeasEdgept_rmeasSpecFaAxisAtts))
	{
	  warnAtt("numMeas", "rmeasEdgept_rmeasSpecFaAxis",
		  a_rmeasEdgept_rmeasSpecFaAxis);
	  check_intVal(a_rmeasEdgept_rmeasSpecFaAxis->get_numMeas(), 0);
	}
      else
	check_intVal(a_rmeasEdgept_rmeasSpecFaAxis->get_numMeas(), log);
    }
  if (a_rmeasEdgept_rmeasSpecFaAxis->get_rmeasSpecFaAxis())
    {
      adjustLevels(&rmeasEdgept_rmeasSpecFaAxisAtts_a_rmeasSpecFaAxis,
		   "rmeasEdgept_rmeasSpecFaAxis a_rmeasSpecFaAxis");
      if (log && !findString("a_rmeasSpecFaAxis",
			     rmeasEdgept_rmeasSpecFaAxisAtts))
	{
	  warnAtt("a_rmeasSpecFaAxis", "rmeasEdgept_rmeasSpecFaAxis",
		  a_rmeasEdgept_rmeasSpecFaAxis);
	  check_rmeasSpecFaAxis(
	    a_rmeasEdgept_rmeasSpecFaAxis->get_rmeasSpecFaAxis(), 0);
	}
      else
	check_rmeasSpecFaAxis(
	  a_rmeasEdgept_rmeasSpecFaAxis->get_rmeasSpecFaAxis(), log);
    }
}

/********************************************************************/

void check_rmeasEdgept_rmeasSpecVecbldEdgept(
 rmeasEdgept_rmeasSpecVecbldEdgept * a_rmeasEdgept_rmeasSpecVecbldEdgept,
 int log)
{
  if (a_rmeasEdgept_rmeasSpecVecbldEdgept->get_fLabel())
    {
      adjustLevels(&rmeasEdgept_rmeasSpecVecbldEdgeptAtts_a_fLabel,
		   "rmeasEdgept_rmeasSpecVecbldEdgept a_fLabel");
      if (log && !findString("a_fLabel",
			     rmeasEdgept_rmeasSpecVecbldEdgeptAtts))
	{
	  warnAtt("a_fLabel", "rmeasEdgept_rmeasSpecVecbldEdgept",
		  a_rmeasEdgept_rmeasSpecVecbldEdgept);
	  check_fLabel(a_rmeasEdgept_rmeasSpecVecbldEdgept->get_fLabel(), 0);
	}
      else
	check_fLabel(a_rmeasEdgept_rmeasSpecVecbldEdgept->get_fLabel(), log);
    }
  if (a_rmeasEdgept_rmeasSpecVecbldEdgept->get_numMeas())
    {
      adjustLevels(&rmeasEdgept_rmeasSpecVecbldEdgeptAtts_numMeas,
		   "rmeasEdgept_rmeasSpecVecbldEdgept numMeas");
      if (log && !findString("numMeas", rmeasEdgept_rmeasSpecVecbldEdgeptAtts))
	{
	  warnAtt("numMeas", "rmeasEdgept_rmeasSpecVecbldEdgept",
		  a_rmeasEdgept_rmeasSpecVecbldEdgept);
	  check_intVal(a_rmeasEdgept_rmeasSpecVecbldEdgept->get_numMeas(), 0);
	}
      else
	check_intVal(a_rmeasEdgept_rmeasSpecVecbldEdgept->get_numMeas(), log);
    }
  if (a_rmeasEdgept_rmeasSpecVecbldEdgept->get_rmeasSpecVecbldEdgept())
    {
      adjustLevels(&rmeasEdgept_rmeasSpecVecbldEdgeptAtts_a_rmeasSpecVecbldEdgept,
		   "rmeasEdgept_rmeasSpecVecbldEdgept a_rmeasSpecVecbldEdgept");
      if (log && !findString("a_rmeasSpecVecbldEdgept",
			     rmeasEdgept_rmeasSpecVecbldEdgeptAtts))
	{
	  warnAtt("a_rmeasSpecVecbldEdgept", "rmeasEdgept_rmeasSpecVecbldEdgept",
		  a_rmeasEdgept_rmeasSpecVecbldEdgept);
	  check_rmeasSpecVecbldEdgept(
	    a_rmeasEdgept_rmeasSpecVecbldEdgept->get_rmeasSpecVecbldEdgept(), 0);
	}
      else
	check_rmeasSpecVecbldEdgept(
	  a_rmeasEdgept_rmeasSpecVecbldEdgept->get_rmeasSpecVecbldEdgept(), log);
    }
}

/********************************************************************/

void check_rmeasEllips(
 rmeasEllips * a_rmeasEllips,
 int log)
{
  if (isA(a_rmeasEllips, rmeasEllips_rmeasSpecFa))
    {
      adjustLevels(&rmeasEllipsSubs_rmeasEllips_rmeasSpecFa,
		   "rmeasEllips_rmeasSpecFa");
      if (log && !findString("rmeasEllips_rmeasSpecFa", rmeasEllipsSubs))
	{
	  warnSub("rmeasEllips_rmeasSpecFa", "rmeasEllips", a_rmeasEllips);
	  check_rmeasEllips_rmeasSpecFa(
	    dynamic_cast<rmeasEllips_rmeasSpecFa *>(a_rmeasEllips), 0);
	}
      else
	check_rmeasEllips_rmeasSpecFa(
	  dynamic_cast<rmeasEllips_rmeasSpecFa *>(a_rmeasEllips), log);
      return;
    }
  if (isA(a_rmeasEllips, rmeasEllips_rmeasSpecVecbld))
    {
      adjustLevels(&rmeasEllipsSubs_rmeasEllips_rmeasSpecVecbld,
		   "rmeasEllips_rmeasSpecVecbld");
      if (log && !findString("rmeasEllips_rmeasSpecVecbld", rmeasEllipsSubs))
	{
	  warnSub("rmeasEllips_rmeasSpecVecbld", "rmeasEllips", a_rmeasEllips);
	  check_rmeasEllips_rmeasSpecVecbld(
	    dynamic_cast<rmeasEllips_rmeasSpecVecbld *>(a_rmeasEllips), 0);
	}
      else
	check_rmeasEllips_rmeasSpecVecbld(
	  dynamic_cast<rmeasEllips_rmeasSpecVecbld *>(a_rmeasEllips), log);
      return;
    }
}

/********************************************************************/

void check_rmeasEllips_rmeasSpecFa(
 rmeasEllips_rmeasSpecFa * a_rmeasEllips_rmeasSpecFa,
 int log)
{
  if (a_rmeasEllips_rmeasSpecFa->get_fLabel())
    {
      adjustLevels(&rmeasEllips_rmeasSpecFaAtts_a_fLabel,
		   "rmeasEllips_rmeasSpecFa a_fLabel");
      if (log && !findString("a_fLabel", rmeasEllips_rmeasSpecFaAtts))
	{
	  warnAtt("a_fLabel", "rmeasEllips_rmeasSpecFa",
		  a_rmeasEllips_rmeasSpecFa);
	  check_fLabel(a_rmeasEllips_rmeasSpecFa->get_fLabel(), 0);
	}
      else
	check_fLabel(a_rmeasEllips_rmeasSpecFa->get_fLabel(), log);
    }
  if (a_rmeasEllips_rmeasSpecFa->get_numMeas())
    {
      adjustLevels(&rmeasEllips_rmeasSpecFaAtts_numMeas,
		   "rmeasEllips_rmeasSpecFa numMeas");
      if (log && !findString("numMeas", rmeasEllips_rmeasSpecFaAtts))
	{
	  warnAtt("numMeas", "rmeasEllips_rmeasSpecFa",
		  a_rmeasEllips_rmeasSpecFa);
	  check_intVal(a_rmeasEllips_rmeasSpecFa->get_numMeas(), 0);
	}
      else
	check_intVal(a_rmeasEllips_rmeasSpecFa->get_numMeas(), log);
    }
  if (a_rmeasEllips_rmeasSpecFa->get_rmeasSpecFa())
    {
      adjustLevels(&rmeasEllips_rmeasSpecFaAtts_a_rmeasSpecFa,
		   "rmeasEllips_rmeasSpecFa a_rmeasSpecFa");
      if (log && !findString("a_rmeasSpecFa", rmeasEllips_rmeasSpecFaAtts))
	{
	  warnAtt("a_rmeasSpecFa", "rmeasEllips_rmeasSpecFa",
		  a_rmeasEllips_rmeasSpecFa);
	  check_rmeasSpecFa(a_rmeasEllips_rmeasSpecFa->get_rmeasSpecFa(), 0);
	}
      else
	check_rmeasSpecFa(a_rmeasEllips_rmeasSpecFa->get_rmeasSpecFa(), log);
    }
}

/********************************************************************/

void check_rmeasEllips_rmeasSpecVecbld(
 rmeasEllips_rmeasSpecVecbld * a_rmeasEllips_rmeasSpecVecbld,
 int log)
{
  if (a_rmeasEllips_rmeasSpecVecbld->get_fLabel())
    {
      adjustLevels(&rmeasEllips_rmeasSpecVecbldAtts_a_fLabel,
		   "rmeasEllips_rmeasSpecVecbld a_fLabel");
      if (log && !findString("a_fLabel", rmeasEllips_rmeasSpecVecbldAtts))
	{
	  warnAtt("a_fLabel", "rmeasEllips_rmeasSpecVecbld",
		  a_rmeasEllips_rmeasSpecVecbld);
	  check_fLabel(a_rmeasEllips_rmeasSpecVecbld->get_fLabel(), 0);
	}
      else
	check_fLabel(a_rmeasEllips_rmeasSpecVecbld->get_fLabel(), log);
    }
  if (a_rmeasEllips_rmeasSpecVecbld->get_numMeas())
    {
      adjustLevels(&rmeasEllips_rmeasSpecVecbldAtts_numMeas,
		   "rmeasEllips_rmeasSpecVecbld numMeas");
      if (log && !findString("numMeas", rmeasEllips_rmeasSpecVecbldAtts))
	{
	  warnAtt("numMeas", "rmeasEllips_rmeasSpecVecbld",
		  a_rmeasEllips_rmeasSpecVecbld);
	  check_intVal(a_rmeasEllips_rmeasSpecVecbld->get_numMeas(), 0);
	}
      else
	check_intVal(a_rmeasEllips_rmeasSpecVecbld->get_numMeas(), log);
    }
  if (a_rmeasEllips_rmeasSpecVecbld->get_rmeasSpecVecbld())
    {
      adjustLevels(&rmeasEllips_rmeasSpecVecbldAtts_a_rmeasSpecVecbld,
		   "rmeasEllips_rmeasSpecVecbld a_rmeasSpecVecbld");
      if (log && !findString("a_rmeasSpecVecbld",
			     rmeasEllips_rmeasSpecVecbldAtts))
	{
	  warnAtt("a_rmeasSpecVecbld", "rmeasEllips_rmeasSpecVecbld",
		  a_rmeasEllips_rmeasSpecVecbld);
	  check_rmeasSpecVecbld(
	    a_rmeasEllips_rmeasSpecVecbld->get_rmeasSpecVecbld(), 0);
	}
      else
	check_rmeasSpecVecbld(
	  a_rmeasEllips_rmeasSpecVecbld->get_rmeasSpecVecbld(), log);
    }
}

/********************************************************************/

void check_rmeasGcurve(
 rmeasGcurve * a_rmeasGcurve,
 int log)
{
  if (isA(a_rmeasGcurve, rmeasGcurve_rmeasSpecFeatAxis))
    {
      adjustLevels(&rmeasGcurveSubs_rmeasGcurve_rmeasSpecFeatAxis,
		   "rmeasGcurve_rmeasSpecFeatAxis");
      if (log && !findString("rmeasGcurve_rmeasSpecFeatAxis", rmeasGcurveSubs))
	{
	  warnSub("rmeasGcurve_rmeasSpecFeatAxis", "rmeasGcurve",
		  a_rmeasGcurve);
	  check_rmeasGcurve_rmeasSpecFeatAxis(
	    dynamic_cast<rmeasGcurve_rmeasSpecFeatAxis *>(a_rmeasGcurve), 0);
	}
      else
	check_rmeasGcurve_rmeasSpecFeatAxis(
	  dynamic_cast<rmeasGcurve_rmeasSpecFeatAxis *>(a_rmeasGcurve), log);
      return;
    }
  if (isA(a_rmeasGcurve, rmeasGcurve_rmeasSpecVecbld))
    {
      adjustLevels(&rmeasGcurveSubs_rmeasGcurve_rmeasSpecVecbld,
		   "rmeasGcurve_rmeasSpecVecbld");
      if (log && !findString("rmeasGcurve_rmeasSpecVecbld", rmeasGcurveSubs))
	{
	  warnSub("rmeasGcurve_rmeasSpecVecbld", "rmeasGcurve", a_rmeasGcurve);
	  check_rmeasGcurve_rmeasSpecVecbld(
	    dynamic_cast<rmeasGcurve_rmeasSpecVecbld *>(a_rmeasGcurve), 0);
	}
      else
	check_rmeasGcurve_rmeasSpecVecbld(
	  dynamic_cast<rmeasGcurve_rmeasSpecVecbld *>(a_rmeasGcurve), log);
      return;
    }
}

/********************************************************************/

void check_rmeasGcurve_rmeasSpecFeatAxis(
 rmeasGcurve_rmeasSpecFeatAxis * a_rmeasGcurve_rmeasSpecFeatAxis,
 int log)
{
  if (a_rmeasGcurve_rmeasSpecFeatAxis->get_fLabel())
    {
      adjustLevels(&rmeasGcurve_rmeasSpecFeatAxisAtts_a_fLabel,
		   "rmeasGcurve_rmeasSpecFeatAxis a_fLabel");
      if (log && !findString("a_fLabel", rmeasGcurve_rmeasSpecFeatAxisAtts))
	{
	  warnAtt("a_fLabel", "rmeasGcurve_rmeasSpecFeatAxis",
		  a_rmeasGcurve_rmeasSpecFeatAxis);
	  check_fLabel(a_rmeasGcurve_rmeasSpecFeatAxis->get_fLabel(), 0);
	}
      else
	check_fLabel(a_rmeasGcurve_rmeasSpecFeatAxis->get_fLabel(), log);
    }
  if (a_rmeasGcurve_rmeasSpecFeatAxis->get_numMeas())
    {
      adjustLevels(&rmeasGcurve_rmeasSpecFeatAxisAtts_numMeas,
		   "rmeasGcurve_rmeasSpecFeatAxis numMeas");
      if (log && !findString("numMeas", rmeasGcurve_rmeasSpecFeatAxisAtts))
	{
	  warnAtt("numMeas", "rmeasGcurve_rmeasSpecFeatAxis",
		  a_rmeasGcurve_rmeasSpecFeatAxis);
	  check_intVal(a_rmeasGcurve_rmeasSpecFeatAxis->get_numMeas(), 0);
	}
      else
	check_intVal(a_rmeasGcurve_rmeasSpecFeatAxis->get_numMeas(), log);
    }
  if (a_rmeasGcurve_rmeasSpecFeatAxis->get_rmeasSpecFeatAxis())
    {
      adjustLevels(&rmeasGcurve_rmeasSpecFeatAxisAtts_a_rmeasSpecFeatAxis,
		   "rmeasGcurve_rmeasSpecFeatAxis a_rmeasSpecFeatAxis");
      if (log && !findString("a_rmeasSpecFeatAxis",
			     rmeasGcurve_rmeasSpecFeatAxisAtts))
	{
	  warnAtt("a_rmeasSpecFeatAxis", "rmeasGcurve_rmeasSpecFeatAxis",
		  a_rmeasGcurve_rmeasSpecFeatAxis);
	  check_rmeasSpecFeatAxis(
	    a_rmeasGcurve_rmeasSpecFeatAxis->get_rmeasSpecFeatAxis(), 0);
	}
      else
	check_rmeasSpecFeatAxis(
	  a_rmeasGcurve_rmeasSpecFeatAxis->get_rmeasSpecFeatAxis(), log);
    }
}

/********************************************************************/

void check_rmeasGcurve_rmeasSpecVecbld(
 rmeasGcurve_rmeasSpecVecbld * a_rmeasGcurve_rmeasSpecVecbld,
 int log)
{
  if (a_rmeasGcurve_rmeasSpecVecbld->get_fLabel())
    {
      adjustLevels(&rmeasGcurve_rmeasSpecVecbldAtts_a_fLabel,
		   "rmeasGcurve_rmeasSpecVecbld a_fLabel");
      if (log && !findString("a_fLabel", rmeasGcurve_rmeasSpecVecbldAtts))
	{
	  warnAtt("a_fLabel", "rmeasGcurve_rmeasSpecVecbld",
		  a_rmeasGcurve_rmeasSpecVecbld);
	  check_fLabel(a_rmeasGcurve_rmeasSpecVecbld->get_fLabel(), 0);
	}
      else
	check_fLabel(a_rmeasGcurve_rmeasSpecVecbld->get_fLabel(), log);
    }
  if (a_rmeasGcurve_rmeasSpecVecbld->get_numMeas())
    {
      adjustLevels(&rmeasGcurve_rmeasSpecVecbldAtts_numMeas,
		   "rmeasGcurve_rmeasSpecVecbld numMeas");
      if (log && !findString("numMeas", rmeasGcurve_rmeasSpecVecbldAtts))
	{
	  warnAtt("numMeas", "rmeasGcurve_rmeasSpecVecbld",
		  a_rmeasGcurve_rmeasSpecVecbld);
	  check_intVal(a_rmeasGcurve_rmeasSpecVecbld->get_numMeas(), 0);
	}
      else
	check_intVal(a_rmeasGcurve_rmeasSpecVecbld->get_numMeas(), log);
    }
  if (a_rmeasGcurve_rmeasSpecVecbld->get_rmeasSpecVecbld())
    {
      adjustLevels(&rmeasGcurve_rmeasSpecVecbldAtts_a_rmeasSpecVecbld,
		   "rmeasGcurve_rmeasSpecVecbld a_rmeasSpecVecbld");
      if (log && !findString("a_rmeasSpecVecbld",
			     rmeasGcurve_rmeasSpecVecbldAtts))
	{
	  warnAtt("a_rmeasSpecVecbld", "rmeasGcurve_rmeasSpecVecbld",
		  a_rmeasGcurve_rmeasSpecVecbld);
	  check_rmeasSpecVecbld(
	    a_rmeasGcurve_rmeasSpecVecbld->get_rmeasSpecVecbld(), 0);
	}
      else
	check_rmeasSpecVecbld(
	  a_rmeasGcurve_rmeasSpecVecbld->get_rmeasSpecVecbld(), log);
    }
}

/********************************************************************/

void check_rmeasGsurf(
 rmeasGsurf * a_rmeasGsurf,
 int log)
{
  if (a_rmeasGsurf->get_fLabel())
    {
      adjustLevels(&rmeasGsurfAtts_a_fLabel, "rmeasGsurf a_fLabel");
      if (log && !findString("a_fLabel", rmeasGsurfAtts))
	{
	  warnAtt("a_fLabel", "rmeasGsurf", a_rmeasGsurf);
	  check_fLabel(a_rmeasGsurf->get_fLabel(), 0);
	}
      else
	check_fLabel(a_rmeasGsurf->get_fLabel(), log);
    }
  if (a_rmeasGsurf->get_numMeas())
    {
      adjustLevels(&rmeasGsurfAtts_numMeas, "rmeasGsurf numMeas");
      if (log && !findString("numMeas", rmeasGsurfAtts))
	{
	  warnAtt("numMeas", "rmeasGsurf", a_rmeasGsurf);
	  check_intVal(a_rmeasGsurf->get_numMeas(), 0);
	}
      else
	check_intVal(a_rmeasGsurf->get_numMeas(), log);
    }
  if (a_rmeasGsurf->get_rmeasSpecFaAxis())
    {
      adjustLevels(&rmeasGsurfAtts_a_rmeasSpecFaAxis,
		   "rmeasGsurf a_rmeasSpecFaAxis");
      if (log && !findString("a_rmeasSpecFaAxis", rmeasGsurfAtts))
	{
	  warnAtt("a_rmeasSpecFaAxis", "rmeasGsurf", a_rmeasGsurf);
	  check_rmeasSpecFaAxis(a_rmeasGsurf->get_rmeasSpecFaAxis(), 0);
	}
      else
	check_rmeasSpecFaAxis(a_rmeasGsurf->get_rmeasSpecFaAxis(), log);
    }
}

/********************************************************************/

void check_rmeasLine(
 rmeasLine * a_rmeasLine,
 int log)
{
  if (isA(a_rmeasLine, rmeasLine_rmeasSpecFeatAxis))
    {
      adjustLevels(&rmeasLineSubs_rmeasLine_rmeasSpecFeatAxis,
		   "rmeasLine_rmeasSpecFeatAxis");
      if (log && !findString("rmeasLine_rmeasSpecFeatAxis", rmeasLineSubs))
	{
	  warnSub("rmeasLine_rmeasSpecFeatAxis", "rmeasLine", a_rmeasLine);
	  check_rmeasLine_rmeasSpecFeatAxis(
	    dynamic_cast<rmeasLine_rmeasSpecFeatAxis *>(a_rmeasLine), 0);
	}
      else
	check_rmeasLine_rmeasSpecFeatAxis(
	  dynamic_cast<rmeasLine_rmeasSpecFeatAxis *>(a_rmeasLine), log);
      return;
    }
  if (isA(a_rmeasLine, rmeasLine_rmeasSpecVecbld))
    {
      adjustLevels(&rmeasLineSubs_rmeasLine_rmeasSpecVecbld,
		   "rmeasLine_rmeasSpecVecbld");
      if (log && !findString("rmeasLine_rmeasSpecVecbld", rmeasLineSubs))
	{
	  warnSub("rmeasLine_rmeasSpecVecbld", "rmeasLine", a_rmeasLine);
	  check_rmeasLine_rmeasSpecVecbld(
	    dynamic_cast<rmeasLine_rmeasSpecVecbld *>(a_rmeasLine), 0);
	}
      else
	check_rmeasLine_rmeasSpecVecbld(
	  dynamic_cast<rmeasLine_rmeasSpecVecbld *>(a_rmeasLine), log);
      return;
    }
}

/********************************************************************/

void check_rmeasLine_rmeasSpecFeatAxis(
 rmeasLine_rmeasSpecFeatAxis * a_rmeasLine_rmeasSpecFeatAxis,
 int log)
{
  if (a_rmeasLine_rmeasSpecFeatAxis->get_fLabel())
    {
      adjustLevels(&rmeasLine_rmeasSpecFeatAxisAtts_a_fLabel,
		   "rmeasLine_rmeasSpecFeatAxis a_fLabel");
      if (log && !findString("a_fLabel", rmeasLine_rmeasSpecFeatAxisAtts))
	{
	  warnAtt("a_fLabel", "rmeasLine_rmeasSpecFeatAxis",
		  a_rmeasLine_rmeasSpecFeatAxis);
	  check_fLabel(a_rmeasLine_rmeasSpecFeatAxis->get_fLabel(), 0);
	}
      else
	check_fLabel(a_rmeasLine_rmeasSpecFeatAxis->get_fLabel(), log);
    }
  if (a_rmeasLine_rmeasSpecFeatAxis->get_numMeas())
    {
      adjustLevels(&rmeasLine_rmeasSpecFeatAxisAtts_numMeas,
		   "rmeasLine_rmeasSpecFeatAxis numMeas");
      if (log && !findString("numMeas", rmeasLine_rmeasSpecFeatAxisAtts))
	{
	  warnAtt("numMeas", "rmeasLine_rmeasSpecFeatAxis",
		  a_rmeasLine_rmeasSpecFeatAxis);
	  check_intVal(a_rmeasLine_rmeasSpecFeatAxis->get_numMeas(), 0);
	}
      else
	check_intVal(a_rmeasLine_rmeasSpecFeatAxis->get_numMeas(), log);
    }
  if (a_rmeasLine_rmeasSpecFeatAxis->get_rmeasSpecFeatAxis())
    {
      adjustLevels(&rmeasLine_rmeasSpecFeatAxisAtts_a_rmeasSpecFeatAxis,
		   "rmeasLine_rmeasSpecFeatAxis a_rmeasSpecFeatAxis");
      if (log && !findString("a_rmeasSpecFeatAxis",
			     rmeasLine_rmeasSpecFeatAxisAtts))
	{
	  warnAtt("a_rmeasSpecFeatAxis", "rmeasLine_rmeasSpecFeatAxis",
		  a_rmeasLine_rmeasSpecFeatAxis);
	  check_rmeasSpecFeatAxis(
	    a_rmeasLine_rmeasSpecFeatAxis->get_rmeasSpecFeatAxis(), 0);
	}
      else
	check_rmeasSpecFeatAxis(
	  a_rmeasLine_rmeasSpecFeatAxis->get_rmeasSpecFeatAxis(), log);
    }
}

/********************************************************************/

void check_rmeasLine_rmeasSpecVecbld(
 rmeasLine_rmeasSpecVecbld * a_rmeasLine_rmeasSpecVecbld,
 int log)
{
  if (a_rmeasLine_rmeasSpecVecbld->get_fLabel())
    {
      adjustLevels(&rmeasLine_rmeasSpecVecbldAtts_a_fLabel,
		   "rmeasLine_rmeasSpecVecbld a_fLabel");
      if (log && !findString("a_fLabel", rmeasLine_rmeasSpecVecbldAtts))
	{
	  warnAtt("a_fLabel", "rmeasLine_rmeasSpecVecbld",
		  a_rmeasLine_rmeasSpecVecbld);
	  check_fLabel(a_rmeasLine_rmeasSpecVecbld->get_fLabel(), 0);
	}
      else
	check_fLabel(a_rmeasLine_rmeasSpecVecbld->get_fLabel(), log);
    }
  if (a_rmeasLine_rmeasSpecVecbld->get_numMeas())
    {
      adjustLevels(&rmeasLine_rmeasSpecVecbldAtts_numMeas,
		   "rmeasLine_rmeasSpecVecbld numMeas");
      if (log && !findString("numMeas", rmeasLine_rmeasSpecVecbldAtts))
	{
	  warnAtt("numMeas", "rmeasLine_rmeasSpecVecbld",
		  a_rmeasLine_rmeasSpecVecbld);
	  check_intVal(a_rmeasLine_rmeasSpecVecbld->get_numMeas(), 0);
	}
      else
	check_intVal(a_rmeasLine_rmeasSpecVecbld->get_numMeas(), log);
    }
  if (a_rmeasLine_rmeasSpecVecbld->get_rmeasSpecVecbld())
    {
      adjustLevels(&rmeasLine_rmeasSpecVecbldAtts_a_rmeasSpecVecbld,
		   "rmeasLine_rmeasSpecVecbld a_rmeasSpecVecbld");
      if (log && !findString("a_rmeasSpecVecbld",
			     rmeasLine_rmeasSpecVecbldAtts))
	{
	  warnAtt("a_rmeasSpecVecbld", "rmeasLine_rmeasSpecVecbld",
		  a_rmeasLine_rmeasSpecVecbld);
	  check_rmeasSpecVecbld(
	    a_rmeasLine_rmeasSpecVecbld->get_rmeasSpecVecbld(), 0);
	}
      else
	check_rmeasSpecVecbld(
	  a_rmeasLine_rmeasSpecVecbld->get_rmeasSpecVecbld(), log);
    }
}

/********************************************************************/

void check_rmeasMinor(
 rmeasMinor * a_rmeasMinor,
 int log)
{
  if (isA(a_rmeasMinor, rmeasArc))
    {
      adjustLevels(&rmeasMinorSubs_rmeasArc, "rmeasArc");
      if (log && !findString("rmeasArc", rmeasMinorSubs))
	{
	  warnSub("rmeasArc", "rmeasMinor", a_rmeasMinor);
	  check_rmeasArc(dynamic_cast<rmeasArc *>(a_rmeasMinor), 0);
	}
      else
	check_rmeasArc(dynamic_cast<rmeasArc *>(a_rmeasMinor), log);
      return;
    }
  if (isA(a_rmeasMinor, rmeasCircle))
    {
      adjustLevels(&rmeasMinorSubs_rmeasCircle, "rmeasCircle");
      if (log && !findString("rmeasCircle", rmeasMinorSubs))
	{
	  warnSub("rmeasCircle", "rmeasMinor", a_rmeasMinor);
	  check_rmeasCircle(dynamic_cast<rmeasCircle *>(a_rmeasMinor), 0);
	}
      else
	check_rmeasCircle(dynamic_cast<rmeasCircle *>(a_rmeasMinor), log);
      return;
    }
  if (isA(a_rmeasMinor, rmeasCone))
    {
      adjustLevels(&rmeasMinorSubs_rmeasCone, "rmeasCone");
      if (log && !findString("rmeasCone", rmeasMinorSubs))
	{
	  warnSub("rmeasCone", "rmeasMinor", a_rmeasMinor);
	  check_rmeasCone(dynamic_cast<rmeasCone *>(a_rmeasMinor), 0);
	}
      else
	check_rmeasCone(dynamic_cast<rmeasCone *>(a_rmeasMinor), log);
      return;
    }
  if (isA(a_rmeasMinor, rmeasCparln))
    {
      adjustLevels(&rmeasMinorSubs_rmeasCparln, "rmeasCparln");
      if (log && !findString("rmeasCparln", rmeasMinorSubs))
	{
	  warnSub("rmeasCparln", "rmeasMinor", a_rmeasMinor);
	  check_rmeasCparln(dynamic_cast<rmeasCparln *>(a_rmeasMinor), 0);
	}
      else
	check_rmeasCparln(dynamic_cast<rmeasCparln *>(a_rmeasMinor), log);
      return;
    }
  if (isA(a_rmeasMinor, rmeasCylndr))
    {
      adjustLevels(&rmeasMinorSubs_rmeasCylndr, "rmeasCylndr");
      if (log && !findString("rmeasCylndr", rmeasMinorSubs))
	{
	  warnSub("rmeasCylndr", "rmeasMinor", a_rmeasMinor);
	  check_rmeasCylndr(dynamic_cast<rmeasCylndr *>(a_rmeasMinor), 0);
	}
      else
	check_rmeasCylndr(dynamic_cast<rmeasCylndr *>(a_rmeasMinor), log);
      return;
    }
  if (isA(a_rmeasMinor, rmeasEdgept))
    {
      adjustLevels(&rmeasMinorSubs_rmeasEdgept, "rmeasEdgept");
      if (log && !findString("rmeasEdgept", rmeasMinorSubs))
	{
	  warnSub("rmeasEdgept", "rmeasMinor", a_rmeasMinor);
	  check_rmeasEdgept(dynamic_cast<rmeasEdgept *>(a_rmeasMinor), 0);
	}
      else
	check_rmeasEdgept(dynamic_cast<rmeasEdgept *>(a_rmeasMinor), log);
      return;
    }
  if (isA(a_rmeasMinor, rmeasEllips))
    {
      adjustLevels(&rmeasMinorSubs_rmeasEllips, "rmeasEllips");
      if (log && !findString("rmeasEllips", rmeasMinorSubs))
	{
	  warnSub("rmeasEllips", "rmeasMinor", a_rmeasMinor);
	  check_rmeasEllips(dynamic_cast<rmeasEllips *>(a_rmeasMinor), 0);
	}
      else
	check_rmeasEllips(dynamic_cast<rmeasEllips *>(a_rmeasMinor), log);
      return;
    }
  if (isA(a_rmeasMinor, rmeasGcurve))
    {
      adjustLevels(&rmeasMinorSubs_rmeasGcurve, "rmeasGcurve");
      if (log && !findString("rmeasGcurve", rmeasMinorSubs))
	{
	  warnSub("rmeasGcurve", "rmeasMinor", a_rmeasMinor);
	  check_rmeasGcurve(dynamic_cast<rmeasGcurve *>(a_rmeasMinor), 0);
	}
      else
	check_rmeasGcurve(dynamic_cast<rmeasGcurve *>(a_rmeasMinor), log);
      return;
    }
  if (isA(a_rmeasMinor, rmeasGsurf))
    {
      adjustLevels(&rmeasMinorSubs_rmeasGsurf, "rmeasGsurf");
      if (log && !findString("rmeasGsurf", rmeasMinorSubs))
	{
	  warnSub("rmeasGsurf", "rmeasMinor", a_rmeasMinor);
	  check_rmeasGsurf(dynamic_cast<rmeasGsurf *>(a_rmeasMinor), 0);
	}
      else
	check_rmeasGsurf(dynamic_cast<rmeasGsurf *>(a_rmeasMinor), log);
      return;
    }
  if (isA(a_rmeasMinor, rmeasLine))
    {
      adjustLevels(&rmeasMinorSubs_rmeasLine, "rmeasLine");
      if (log && !findString("rmeasLine", rmeasMinorSubs))
	{
	  warnSub("rmeasLine", "rmeasMinor", a_rmeasMinor);
	  check_rmeasLine(dynamic_cast<rmeasLine *>(a_rmeasMinor), 0);
	}
      else
	check_rmeasLine(dynamic_cast<rmeasLine *>(a_rmeasMinor), log);
      return;
    }
  if (isA(a_rmeasMinor, rmeasObject))
    {
      adjustLevels(&rmeasMinorSubs_rmeasObject, "rmeasObject");
      if (log && !findString("rmeasObject", rmeasMinorSubs))
	{
	  warnSub("rmeasObject", "rmeasMinor", a_rmeasMinor);
	  check_rmeasObject(dynamic_cast<rmeasObject *>(a_rmeasMinor), 0);
	}
      else
	check_rmeasObject(dynamic_cast<rmeasObject *>(a_rmeasMinor), log);
      return;
    }
  if (isA(a_rmeasMinor, rmeasParpln))
    {
      adjustLevels(&rmeasMinorSubs_rmeasParpln, "rmeasParpln");
      if (log && !findString("rmeasParpln", rmeasMinorSubs))
	{
	  warnSub("rmeasParpln", "rmeasMinor", a_rmeasMinor);
	  check_rmeasParpln(dynamic_cast<rmeasParpln *>(a_rmeasMinor), 0);
	}
      else
	check_rmeasParpln(dynamic_cast<rmeasParpln *>(a_rmeasMinor), log);
      return;
    }
  if (isA(a_rmeasMinor, rmeasPlane))
    {
      adjustLevels(&rmeasMinorSubs_rmeasPlane, "rmeasPlane");
      if (log && !findString("rmeasPlane", rmeasMinorSubs))
	{
	  warnSub("rmeasPlane", "rmeasMinor", a_rmeasMinor);
	  check_rmeasPlane(dynamic_cast<rmeasPlane *>(a_rmeasMinor), 0);
	}
      else
	check_rmeasPlane(dynamic_cast<rmeasPlane *>(a_rmeasMinor), log);
      return;
    }
  if (isA(a_rmeasMinor, rmeasPoint))
    {
      adjustLevels(&rmeasMinorSubs_rmeasPoint, "rmeasPoint");
      if (log && !findString("rmeasPoint", rmeasMinorSubs))
	{
	  warnSub("rmeasPoint", "rmeasMinor", a_rmeasMinor);
	  check_rmeasPoint(dynamic_cast<rmeasPoint *>(a_rmeasMinor), 0);
	}
      else
	check_rmeasPoint(dynamic_cast<rmeasPoint *>(a_rmeasMinor), log);
      return;
    }
  if (isA(a_rmeasMinor, rmeasRctngl))
    {
      adjustLevels(&rmeasMinorSubs_rmeasRctngl, "rmeasRctngl");
      if (log && !findString("rmeasRctngl", rmeasMinorSubs))
	{
	  warnSub("rmeasRctngl", "rmeasMinor", a_rmeasMinor);
	  check_rmeasRctngl(dynamic_cast<rmeasRctngl *>(a_rmeasMinor), 0);
	}
      else
	check_rmeasRctngl(dynamic_cast<rmeasRctngl *>(a_rmeasMinor), log);
      return;
    }
  if (isA(a_rmeasMinor, rmeasSphere))
    {
      adjustLevels(&rmeasMinorSubs_rmeasSphere, "rmeasSphere");
      if (log && !findString("rmeasSphere", rmeasMinorSubs))
	{
	  warnSub("rmeasSphere", "rmeasMinor", a_rmeasMinor);
	  check_rmeasSphere(dynamic_cast<rmeasSphere *>(a_rmeasMinor), 0);
	}
      else
	check_rmeasSphere(dynamic_cast<rmeasSphere *>(a_rmeasMinor), log);
      return;
    }
  if (isA(a_rmeasMinor, rmeasSympln))
    {
      adjustLevels(&rmeasMinorSubs_rmeasSympln, "rmeasSympln");
      if (log && !findString("rmeasSympln", rmeasMinorSubs))
	{
	  warnSub("rmeasSympln", "rmeasMinor", a_rmeasMinor);
	  check_rmeasSympln(dynamic_cast<rmeasSympln *>(a_rmeasMinor), 0);
	}
      else
	check_rmeasSympln(dynamic_cast<rmeasSympln *>(a_rmeasMinor), log);
      return;
    }
  if (isA(a_rmeasMinor, rmeasTorus))
    {
      adjustLevels(&rmeasMinorSubs_rmeasTorus, "rmeasTorus");
      if (log && !findString("rmeasTorus", rmeasMinorSubs))
	{
	  warnSub("rmeasTorus", "rmeasMinor", a_rmeasMinor);
	  check_rmeasTorus(dynamic_cast<rmeasTorus *>(a_rmeasMinor), 0);
	}
      else
	check_rmeasTorus(dynamic_cast<rmeasTorus *>(a_rmeasMinor), log);
      return;
    }
}

/********************************************************************/

void check_rmeasObject(
 rmeasObject * a_rmeasObject,
 int log)
{
  if (isA(a_rmeasObject, rmeasObject_rmeasSpecFa))
    {
      adjustLevels(&rmeasObjectSubs_rmeasObject_rmeasSpecFa,
		   "rmeasObject_rmeasSpecFa");
      if (log && !findString("rmeasObject_rmeasSpecFa", rmeasObjectSubs))
	{
	  warnSub("rmeasObject_rmeasSpecFa", "rmeasObject", a_rmeasObject);
	  check_rmeasObject_rmeasSpecFa(
	    dynamic_cast<rmeasObject_rmeasSpecFa *>(a_rmeasObject), 0);
	}
      else
	check_rmeasObject_rmeasSpecFa(
	  dynamic_cast<rmeasObject_rmeasSpecFa *>(a_rmeasObject), log);
      return;
    }
  if (isA(a_rmeasObject, rmeasObject_rmeasSpecVecbld))
    {
      adjustLevels(&rmeasObjectSubs_rmeasObject_rmeasSpecVecbld,
		   "rmeasObject_rmeasSpecVecbld");
      if (log && !findString("rmeasObject_rmeasSpecVecbld", rmeasObjectSubs))
	{
	  warnSub("rmeasObject_rmeasSpecVecbld", "rmeasObject", a_rmeasObject);
	  check_rmeasObject_rmeasSpecVecbld(
	    dynamic_cast<rmeasObject_rmeasSpecVecbld *>(a_rmeasObject), 0);
	}
      else
	check_rmeasObject_rmeasSpecVecbld(
	  dynamic_cast<rmeasObject_rmeasSpecVecbld *>(a_rmeasObject), log);
      return;
    }
}

/********************************************************************/

void check_rmeasObject_rmeasSpecFa(
 rmeasObject_rmeasSpecFa * a_rmeasObject_rmeasSpecFa,
 int log)
{
  if (a_rmeasObject_rmeasSpecFa->get_fLabel())
    {
      adjustLevels(&rmeasObject_rmeasSpecFaAtts_a_fLabel,
		   "rmeasObject_rmeasSpecFa a_fLabel");
      if (log && !findString("a_fLabel", rmeasObject_rmeasSpecFaAtts))
	{
	  warnAtt("a_fLabel", "rmeasObject_rmeasSpecFa",
		  a_rmeasObject_rmeasSpecFa);
	  check_fLabel(a_rmeasObject_rmeasSpecFa->get_fLabel(), 0);
	}
      else
	check_fLabel(a_rmeasObject_rmeasSpecFa->get_fLabel(), log);
    }
  if (a_rmeasObject_rmeasSpecFa->get_numMeas())
    {
      adjustLevels(&rmeasObject_rmeasSpecFaAtts_numMeas,
		   "rmeasObject_rmeasSpecFa numMeas");
      if (log && !findString("numMeas", rmeasObject_rmeasSpecFaAtts))
	{
	  warnAtt("numMeas", "rmeasObject_rmeasSpecFa",
		  a_rmeasObject_rmeasSpecFa);
	  check_intVal(a_rmeasObject_rmeasSpecFa->get_numMeas(), 0);
	}
      else
	check_intVal(a_rmeasObject_rmeasSpecFa->get_numMeas(), log);
    }
  if (a_rmeasObject_rmeasSpecFa->get_rmeasSpecFa())
    {
      adjustLevels(&rmeasObject_rmeasSpecFaAtts_a_rmeasSpecFa,
		   "rmeasObject_rmeasSpecFa a_rmeasSpecFa");
      if (log && !findString("a_rmeasSpecFa", rmeasObject_rmeasSpecFaAtts))
	{
	  warnAtt("a_rmeasSpecFa", "rmeasObject_rmeasSpecFa",
		  a_rmeasObject_rmeasSpecFa);
	  check_rmeasSpecFa(a_rmeasObject_rmeasSpecFa->get_rmeasSpecFa(), 0);
	}
      else
	check_rmeasSpecFa(a_rmeasObject_rmeasSpecFa->get_rmeasSpecFa(), log);
    }
}

/********************************************************************/

void check_rmeasObject_rmeasSpecVecbld(
 rmeasObject_rmeasSpecVecbld * a_rmeasObject_rmeasSpecVecbld,
 int log)
{
  if (a_rmeasObject_rmeasSpecVecbld->get_fLabel())
    {
      adjustLevels(&rmeasObject_rmeasSpecVecbldAtts_a_fLabel,
		   "rmeasObject_rmeasSpecVecbld a_fLabel");
      if (log && !findString("a_fLabel", rmeasObject_rmeasSpecVecbldAtts))
	{
	  warnAtt("a_fLabel", "rmeasObject_rmeasSpecVecbld",
		  a_rmeasObject_rmeasSpecVecbld);
	  check_fLabel(a_rmeasObject_rmeasSpecVecbld->get_fLabel(), 0);
	}
      else
	check_fLabel(a_rmeasObject_rmeasSpecVecbld->get_fLabel(), log);
    }
  if (a_rmeasObject_rmeasSpecVecbld->get_numMeas())
    {
      adjustLevels(&rmeasObject_rmeasSpecVecbldAtts_numMeas,
		   "rmeasObject_rmeasSpecVecbld numMeas");
      if (log && !findString("numMeas", rmeasObject_rmeasSpecVecbldAtts))
	{
	  warnAtt("numMeas", "rmeasObject_rmeasSpecVecbld",
		  a_rmeasObject_rmeasSpecVecbld);
	  check_intVal(a_rmeasObject_rmeasSpecVecbld->get_numMeas(), 0);
	}
      else
	check_intVal(a_rmeasObject_rmeasSpecVecbld->get_numMeas(), log);
    }
  if (a_rmeasObject_rmeasSpecVecbld->get_rmeasSpecVecbld())
    {
      adjustLevels(&rmeasObject_rmeasSpecVecbldAtts_a_rmeasSpecVecbld,
		   "rmeasObject_rmeasSpecVecbld a_rmeasSpecVecbld");
      if (log && !findString("a_rmeasSpecVecbld",
			     rmeasObject_rmeasSpecVecbldAtts))
	{
	  warnAtt("a_rmeasSpecVecbld", "rmeasObject_rmeasSpecVecbld",
		  a_rmeasObject_rmeasSpecVecbld);
	  check_rmeasSpecVecbld(
	    a_rmeasObject_rmeasSpecVecbld->get_rmeasSpecVecbld(), 0);
	}
      else
	check_rmeasSpecVecbld(
	  a_rmeasObject_rmeasSpecVecbld->get_rmeasSpecVecbld(), log);
    }
}

/********************************************************************/

void check_rmeasParpln(
 rmeasParpln * a_rmeasParpln,
 int log)
{
  if (a_rmeasParpln->get_fLabel())
    {
      adjustLevels(&rmeasParplnAtts_a_fLabel, "rmeasParpln a_fLabel");
      if (log && !findString("a_fLabel", rmeasParplnAtts))
	{
	  warnAtt("a_fLabel", "rmeasParpln", a_rmeasParpln);
	  check_fLabel(a_rmeasParpln->get_fLabel(), 0);
	}
      else
	check_fLabel(a_rmeasParpln->get_fLabel(), log);
    }
  if (a_rmeasParpln->get_numMeas())
    {
      adjustLevels(&rmeasParplnAtts_numMeas, "rmeasParpln numMeas");
      if (log && !findString("numMeas", rmeasParplnAtts))
	{
	  warnAtt("numMeas", "rmeasParpln", a_rmeasParpln);
	  check_intVal(a_rmeasParpln->get_numMeas(), 0);
	}
      else
	check_intVal(a_rmeasParpln->get_numMeas(), log);
    }
  if (a_rmeasParpln->get_rmeasSpecFa())
    {
      adjustLevels(&rmeasParplnAtts_a_rmeasSpecFa,
		   "rmeasParpln a_rmeasSpecFa");
      if (log && !findString("a_rmeasSpecFa", rmeasParplnAtts))
	{
	  warnAtt("a_rmeasSpecFa", "rmeasParpln", a_rmeasParpln);
	  check_rmeasSpecFa(a_rmeasParpln->get_rmeasSpecFa(), 0);
	}
      else
	check_rmeasSpecFa(a_rmeasParpln->get_rmeasSpecFa(), log);
    }
}

/********************************************************************/

void check_rmeasPlane(
 rmeasPlane * a_rmeasPlane,
 int log)
{
  if (a_rmeasPlane->get_fLabel())
    {
      adjustLevels(&rmeasPlaneAtts_a_fLabel, "rmeasPlane a_fLabel");
      if (log && !findString("a_fLabel", rmeasPlaneAtts))
	{
	  warnAtt("a_fLabel", "rmeasPlane", a_rmeasPlane);
	  check_fLabel(a_rmeasPlane->get_fLabel(), 0);
	}
      else
	check_fLabel(a_rmeasPlane->get_fLabel(), log);
    }
  if (a_rmeasPlane->get_numMeas())
    {
      adjustLevels(&rmeasPlaneAtts_numMeas, "rmeasPlane numMeas");
      if (log && !findString("numMeas", rmeasPlaneAtts))
	{
	  warnAtt("numMeas", "rmeasPlane", a_rmeasPlane);
	  check_intVal(a_rmeasPlane->get_numMeas(), 0);
	}
      else
	check_intVal(a_rmeasPlane->get_numMeas(), log);
    }
  if (a_rmeasPlane->get_rmeasSpecFaAxis())
    {
      adjustLevels(&rmeasPlaneAtts_a_rmeasSpecFaAxis,
		   "rmeasPlane a_rmeasSpecFaAxis");
      if (log && !findString("a_rmeasSpecFaAxis", rmeasPlaneAtts))
	{
	  warnAtt("a_rmeasSpecFaAxis", "rmeasPlane", a_rmeasPlane);
	  check_rmeasSpecFaAxis(a_rmeasPlane->get_rmeasSpecFaAxis(), 0);
	}
      else
	check_rmeasSpecFaAxis(a_rmeasPlane->get_rmeasSpecFaAxis(), log);
    }
}

/********************************************************************/

void check_rmeasPoint(
 rmeasPoint * a_rmeasPoint,
 int log)
{
  if (isA(a_rmeasPoint, rmeasPoint_rmeasSpecFaAxis))
    {
      adjustLevels(&rmeasPointSubs_rmeasPoint_rmeasSpecFaAxis,
		   "rmeasPoint_rmeasSpecFaAxis");
      if (log && !findString("rmeasPoint_rmeasSpecFaAxis", rmeasPointSubs))
	{
	  warnSub("rmeasPoint_rmeasSpecFaAxis", "rmeasPoint", a_rmeasPoint);
	  check_rmeasPoint_rmeasSpecFaAxis(
	    dynamic_cast<rmeasPoint_rmeasSpecFaAxis *>(a_rmeasPoint), 0);
	}
      else
	check_rmeasPoint_rmeasSpecFaAxis(
	  dynamic_cast<rmeasPoint_rmeasSpecFaAxis *>(a_rmeasPoint), log);
      return;
    }
  if (isA(a_rmeasPoint, rmeasPoint_rmeasSpecVecbld))
    {
      adjustLevels(&rmeasPointSubs_rmeasPoint_rmeasSpecVecbld,
		   "rmeasPoint_rmeasSpecVecbld");
      if (log && !findString("rmeasPoint_rmeasSpecVecbld", rmeasPointSubs))
	{
	  warnSub("rmeasPoint_rmeasSpecVecbld", "rmeasPoint", a_rmeasPoint);
	  check_rmeasPoint_rmeasSpecVecbld(
	    dynamic_cast<rmeasPoint_rmeasSpecVecbld *>(a_rmeasPoint), 0);
	}
      else
	check_rmeasPoint_rmeasSpecVecbld(
	  dynamic_cast<rmeasPoint_rmeasSpecVecbld *>(a_rmeasPoint), log);
      return;
    }
}

/********************************************************************/

void check_rmeasPoint_rmeasSpecFaAxis(
 rmeasPoint_rmeasSpecFaAxis * a_rmeasPoint_rmeasSpecFaAxis,
 int log)
{
  if (a_rmeasPoint_rmeasSpecFaAxis->get_fLabel())
    {
      adjustLevels(&rmeasPoint_rmeasSpecFaAxisAtts_a_fLabel,
		   "rmeasPoint_rmeasSpecFaAxis a_fLabel");
      if (log && !findString("a_fLabel", rmeasPoint_rmeasSpecFaAxisAtts))
	{
	  warnAtt("a_fLabel", "rmeasPoint_rmeasSpecFaAxis",
		  a_rmeasPoint_rmeasSpecFaAxis);
	  check_fLabel(a_rmeasPoint_rmeasSpecFaAxis->get_fLabel(), 0);
	}
      else
	check_fLabel(a_rmeasPoint_rmeasSpecFaAxis->get_fLabel(), log);
    }
  if (a_rmeasPoint_rmeasSpecFaAxis->get_numMeas())
    {
      adjustLevels(&rmeasPoint_rmeasSpecFaAxisAtts_numMeas,
		   "rmeasPoint_rmeasSpecFaAxis numMeas");
      if (log && !findString("numMeas", rmeasPoint_rmeasSpecFaAxisAtts))
	{
	  warnAtt("numMeas", "rmeasPoint_rmeasSpecFaAxis",
		  a_rmeasPoint_rmeasSpecFaAxis);
	  check_intVal(a_rmeasPoint_rmeasSpecFaAxis->get_numMeas(), 0);
	}
      else
	check_intVal(a_rmeasPoint_rmeasSpecFaAxis->get_numMeas(), log);
    }
  if (a_rmeasPoint_rmeasSpecFaAxis->get_rmeasSpecFaAxis())
    {
      adjustLevels(&rmeasPoint_rmeasSpecFaAxisAtts_a_rmeasSpecFaAxis,
		   "rmeasPoint_rmeasSpecFaAxis a_rmeasSpecFaAxis");
      if (log && !findString("a_rmeasSpecFaAxis",
			     rmeasPoint_rmeasSpecFaAxisAtts))
	{
	  warnAtt("a_rmeasSpecFaAxis", "rmeasPoint_rmeasSpecFaAxis",
		  a_rmeasPoint_rmeasSpecFaAxis);
	  check_rmeasSpecFaAxis(
	    a_rmeasPoint_rmeasSpecFaAxis->get_rmeasSpecFaAxis(), 0);
	}
      else
	check_rmeasSpecFaAxis(
	  a_rmeasPoint_rmeasSpecFaAxis->get_rmeasSpecFaAxis(), log);
    }
}

/********************************************************************/

void check_rmeasPoint_rmeasSpecVecbld(
 rmeasPoint_rmeasSpecVecbld * a_rmeasPoint_rmeasSpecVecbld,
 int log)
{
  if (a_rmeasPoint_rmeasSpecVecbld->get_fLabel())
    {
      adjustLevels(&rmeasPoint_rmeasSpecVecbldAtts_a_fLabel,
		   "rmeasPoint_rmeasSpecVecbld a_fLabel");
      if (log && !findString("a_fLabel", rmeasPoint_rmeasSpecVecbldAtts))
	{
	  warnAtt("a_fLabel", "rmeasPoint_rmeasSpecVecbld",
		  a_rmeasPoint_rmeasSpecVecbld);
	  check_fLabel(a_rmeasPoint_rmeasSpecVecbld->get_fLabel(), 0);
	}
      else
	check_fLabel(a_rmeasPoint_rmeasSpecVecbld->get_fLabel(), log);
    }
  if (a_rmeasPoint_rmeasSpecVecbld->get_numMeas())
    {
      adjustLevels(&rmeasPoint_rmeasSpecVecbldAtts_numMeas,
		   "rmeasPoint_rmeasSpecVecbld numMeas");
      if (log && !findString("numMeas", rmeasPoint_rmeasSpecVecbldAtts))
	{
	  warnAtt("numMeas", "rmeasPoint_rmeasSpecVecbld",
		  a_rmeasPoint_rmeasSpecVecbld);
	  check_intVal(a_rmeasPoint_rmeasSpecVecbld->get_numMeas(), 0);
	}
      else
	check_intVal(a_rmeasPoint_rmeasSpecVecbld->get_numMeas(), log);
    }
  if (a_rmeasPoint_rmeasSpecVecbld->get_rmeasSpecVecbld())
    {
      adjustLevels(&rmeasPoint_rmeasSpecVecbldAtts_a_rmeasSpecVecbld,
		   "rmeasPoint_rmeasSpecVecbld a_rmeasSpecVecbld");
      if (log && !findString("a_rmeasSpecVecbld",
			     rmeasPoint_rmeasSpecVecbldAtts))
	{
	  warnAtt("a_rmeasSpecVecbld", "rmeasPoint_rmeasSpecVecbld",
		  a_rmeasPoint_rmeasSpecVecbld);
	  check_rmeasSpecVecbld(
	    a_rmeasPoint_rmeasSpecVecbld->get_rmeasSpecVecbld(), 0);
	}
      else
	check_rmeasSpecVecbld(
	  a_rmeasPoint_rmeasSpecVecbld->get_rmeasSpecVecbld(), log);
    }
}

/********************************************************************/

void check_rmeasRctngl(
 rmeasRctngl * a_rmeasRctngl,
 int log)
{
  if (a_rmeasRctngl->get_fLabel())
    {
      adjustLevels(&rmeasRctnglAtts_a_fLabel, "rmeasRctngl a_fLabel");
      if (log && !findString("a_fLabel", rmeasRctnglAtts))
	{
	  warnAtt("a_fLabel", "rmeasRctngl", a_rmeasRctngl);
	  check_fLabel(a_rmeasRctngl->get_fLabel(), 0);
	}
      else
	check_fLabel(a_rmeasRctngl->get_fLabel(), log);
    }
  if (a_rmeasRctngl->get_numMeas())
    {
      adjustLevels(&rmeasRctnglAtts_numMeas, "rmeasRctngl numMeas");
      if (log && !findString("numMeas", rmeasRctnglAtts))
	{
	  warnAtt("numMeas", "rmeasRctngl", a_rmeasRctngl);
	  check_intVal(a_rmeasRctngl->get_numMeas(), 0);
	}
      else
	check_intVal(a_rmeasRctngl->get_numMeas(), log);
    }
  if (a_rmeasRctngl->get_rmeasSpecFa())
    {
      adjustLevels(&rmeasRctnglAtts_a_rmeasSpecFa,
		   "rmeasRctngl a_rmeasSpecFa");
      if (log && !findString("a_rmeasSpecFa", rmeasRctnglAtts))
	{
	  warnAtt("a_rmeasSpecFa", "rmeasRctngl", a_rmeasRctngl);
	  check_rmeasSpecFa(a_rmeasRctngl->get_rmeasSpecFa(), 0);
	}
      else
	check_rmeasSpecFa(a_rmeasRctngl->get_rmeasSpecFa(), log);
    }
}

/********************************************************************/

void check_rmeasSpecFa(
 rmeasSpecFa * a_rmeasSpecFa,
 int log)
{
  if (isA(a_rmeasSpecFa, faLabel))
    {
      adjustLevels(&rmeasSpecFaSubs_faLabel, "faLabel");
      if (log && !findString("faLabel", rmeasSpecFaSubs))
	{
	  warnSub("faLabel", "rmeasSpecFa", a_rmeasSpecFa);
	  check_faLabel(dynamic_cast<faLabel *>(a_rmeasSpecFa), 0);
	}
      else
	check_faLabel(dynamic_cast<faLabel *>(a_rmeasSpecFa), log);
      return;
    }
}

/********************************************************************/

void check_rmeasSpecFaAxis(
 rmeasSpecFaAxis * a_rmeasSpecFaAxis,
 int log)
{
  if (isA(a_rmeasSpecFaAxis, rmeasSpecFaAxis_faLabel))
    {
      adjustLevels(&rmeasSpecFaAxisSubs_rmeasSpecFaAxis_faLabel,
		   "rmeasSpecFaAxis_faLabel");
      if (log && !findString("rmeasSpecFaAxis_faLabel", rmeasSpecFaAxisSubs))
	{
	  warnSub("rmeasSpecFaAxis_faLabel", "rmeasSpecFaAxis",
		  a_rmeasSpecFaAxis);
	  check_rmeasSpecFaAxis_faLabel(
	    dynamic_cast<rmeasSpecFaAxis_faLabel *>(a_rmeasSpecFaAxis), 0);
	}
      else
	check_rmeasSpecFaAxis_faLabel(
	  dynamic_cast<rmeasSpecFaAxis_faLabel *>(a_rmeasSpecFaAxis), log);
      return;
    }
  if (isA(a_rmeasSpecFaAxis, rmeasSpecFaAxis_axis))
    {
      adjustLevels(&rmeasSpecFaAxisSubs_rmeasSpecFaAxis_axis,
		   "rmeasSpecFaAxis_axis");
      if (log && !findString("rmeasSpecFaAxis_axis", rmeasSpecFaAxisSubs))
	{
	  warnSub("rmeasSpecFaAxis_axis", "rmeasSpecFaAxis", a_rmeasSpecFaAxis);
	  check_rmeasSpecFaAxis_axis(
	    dynamic_cast<rmeasSpecFaAxis_axis *>(a_rmeasSpecFaAxis), 0);
	}
      else
	check_rmeasSpecFaAxis_axis(
	  dynamic_cast<rmeasSpecFaAxis_axis *>(a_rmeasSpecFaAxis), log);
      return;
    }
}

/********************************************************************/

void check_rmeasSpecFaAxis_axis(
 rmeasSpecFaAxis_axis * a_rmeasSpecFaAxis_axis,
 int log)
{
  if (a_rmeasSpecFaAxis_axis->get_axis())
    {
      adjustLevels(&rmeasSpecFaAxis_axisAtts_a_axis,
		   "rmeasSpecFaAxis_axis a_axis");
      if (log && !findString("a_axis", rmeasSpecFaAxis_axisAtts))
	{
	  warnAtt("a_axis", "rmeasSpecFaAxis_axis", a_rmeasSpecFaAxis_axis);
	  check_axis(a_rmeasSpecFaAxis_axis->get_axis(), 0);
	}
      else
	check_axis(a_rmeasSpecFaAxis_axis->get_axis(), log);
    }
}

/********************************************************************/

void check_rmeasSpecFaAxis_faLabel(
 rmeasSpecFaAxis_faLabel * a_rmeasSpecFaAxis_faLabel,
 int log)
{
  if (a_rmeasSpecFaAxis_faLabel->get_faLabel())
    {
      adjustLevels(&rmeasSpecFaAxis_faLabelAtts_a_faLabel,
		   "rmeasSpecFaAxis_faLabel a_faLabel");
      if (log && !findString("a_faLabel", rmeasSpecFaAxis_faLabelAtts))
	{
	  warnAtt("a_faLabel", "rmeasSpecFaAxis_faLabel",
		  a_rmeasSpecFaAxis_faLabel);
	  check_faLabel(a_rmeasSpecFaAxis_faLabel->get_faLabel(), 0);
	}
      else
	check_faLabel(a_rmeasSpecFaAxis_faLabel->get_faLabel(), log);
    }
  if (a_rmeasSpecFaAxis_faLabel->get_axis())
    {
      adjustLevels(&rmeasSpecFaAxis_faLabelAtts_a_axis,
		   "rmeasSpecFaAxis_faLabel a_axis");
      if (log && !findString("a_axis", rmeasSpecFaAxis_faLabelAtts))
	{
	  warnAtt("a_axis", "rmeasSpecFaAxis_faLabel",
		  a_rmeasSpecFaAxis_faLabel);
	  check_axis(a_rmeasSpecFaAxis_faLabel->get_axis(), 0);
	}
      else
	check_axis(a_rmeasSpecFaAxis_faLabel->get_axis(), log);
    }
}

/********************************************************************/

void check_rmeasSpecFaOrient(
 rmeasSpecFaOrient * a_rmeasSpecFaOrient,
 int log)
{
  if (a_rmeasSpecFaOrient->get_faLabel())
    {
      adjustLevels(&rmeasSpecFaOrientAtts_a_faLabel,
		   "rmeasSpecFaOrient a_faLabel");
      if (log && !findString("a_faLabel", rmeasSpecFaOrientAtts))
	{
	  warnAtt("a_faLabel", "rmeasSpecFaOrient", a_rmeasSpecFaOrient);
	  check_faLabel(a_rmeasSpecFaOrient->get_faLabel(), 0);
	}
      else
	check_faLabel(a_rmeasSpecFaOrient->get_faLabel(), log);
    }
  if (a_rmeasSpecFaOrient->get_has_ORIENT())
    {
      adjustLevels(&rmeasSpecFaOrientAtts_has_ORIENT,
		   "rmeasSpecFaOrient has_ORIENT");
      if (log && !findString("has_ORIENT", rmeasSpecFaOrientAtts))
	{
	  warnAtt("has_ORIENT", "rmeasSpecFaOrient", a_rmeasSpecFaOrient);
	}
    }
}

/********************************************************************/

void check_rmeasSpecFeatAxis(
 rmeasSpecFeatAxis * a_rmeasSpecFeatAxis,
 int log)
{
  if (isA(a_rmeasSpecFeatAxis, rmeasSpecFeatAxis_featureLabel1))
    {
      adjustLevels(&rmeasSpecFeatAxisSubs_rmeasSpecFeatAxis_featureLabel1,
		   "rmeasSpecFeatAxis_featureLabel1");
      if (log && !findString("rmeasSpecFeatAxis_featureLabel1",
			     rmeasSpecFeatAxisSubs))
	{
	  warnSub("rmeasSpecFeatAxis_featureLabel1", "rmeasSpecFeatAxis",
		  a_rmeasSpecFeatAxis);
	  check_rmeasSpecFeatAxis_featureLabel1(
	    dynamic_cast<rmeasSpecFeatAxis_featureLabel1 *>(a_rmeasSpecFeatAxis), 0);
	}
      else
	check_rmeasSpecFeatAxis_featureLabel1(
	  dynamic_cast<rmeasSpecFeatAxis_featureLabel1 *>(a_rmeasSpecFeatAxis), log);
      return;
    }
  if (isA(a_rmeasSpecFeatAxis, rmeasSpecFeatAxis_axis))
    {
      adjustLevels(&rmeasSpecFeatAxisSubs_rmeasSpecFeatAxis_axis,
		   "rmeasSpecFeatAxis_axis");
      if (log && !findString("rmeasSpecFeatAxis_axis", rmeasSpecFeatAxisSubs))
	{
	  warnSub("rmeasSpecFeatAxis_axis", "rmeasSpecFeatAxis",
		  a_rmeasSpecFeatAxis);
	  check_rmeasSpecFeatAxis_axis(
	    dynamic_cast<rmeasSpecFeatAxis_axis *>(a_rmeasSpecFeatAxis), 0);
	}
      else
	check_rmeasSpecFeatAxis_axis(
	  dynamic_cast<rmeasSpecFeatAxis_axis *>(a_rmeasSpecFeatAxis), log);
      return;
    }
}

/********************************************************************/

void check_rmeasSpecFeatAxis_axis(
 rmeasSpecFeatAxis_axis * a_rmeasSpecFeatAxis_axis,
 int log)
{
  if (a_rmeasSpecFeatAxis_axis->get_axis())
    {
      adjustLevels(&rmeasSpecFeatAxis_axisAtts_a_axis,
		   "rmeasSpecFeatAxis_axis a_axis");
      if (log && !findString("a_axis", rmeasSpecFeatAxis_axisAtts))
	{
	  warnAtt("a_axis", "rmeasSpecFeatAxis_axis",
		  a_rmeasSpecFeatAxis_axis);
	  check_axis(a_rmeasSpecFeatAxis_axis->get_axis(), 0);
	}
      else
	check_axis(a_rmeasSpecFeatAxis_axis->get_axis(), log);
    }
}

/********************************************************************/

void check_rmeasSpecFeatAxis_featureLabel1(
 rmeasSpecFeatAxis_featureLabel1 * a_rmeasSpecFeatAxis_featureLabel1,
 int log)
{
  if (a_rmeasSpecFeatAxis_featureLabel1->get_featureLabel1())
    {
      adjustLevels(&rmeasSpecFeatAxis_featureLabel1Atts_a_featureLabel1,
		   "rmeasSpecFeatAxis_featureLabel1 a_featureLabel1");
      if (log && !findString("a_featureLabel1",
			     rmeasSpecFeatAxis_featureLabel1Atts))
	{
	  warnAtt("a_featureLabel1", "rmeasSpecFeatAxis_featureLabel1",
		  a_rmeasSpecFeatAxis_featureLabel1);
	  check_featureLabel1(
	    a_rmeasSpecFeatAxis_featureLabel1->get_featureLabel1(), 0);
	}
      else
	check_featureLabel1(
	  a_rmeasSpecFeatAxis_featureLabel1->get_featureLabel1(), log);
    }
  if (a_rmeasSpecFeatAxis_featureLabel1->get_axis())
    {
      adjustLevels(&rmeasSpecFeatAxis_featureLabel1Atts_a_axis,
		   "rmeasSpecFeatAxis_featureLabel1 a_axis");
      if (log && !findString("a_axis", rmeasSpecFeatAxis_featureLabel1Atts))
	{
	  warnAtt("a_axis", "rmeasSpecFeatAxis_featureLabel1",
		  a_rmeasSpecFeatAxis_featureLabel1);
	  check_axis(a_rmeasSpecFeatAxis_featureLabel1->get_axis(), 0);
	}
      else
	check_axis(a_rmeasSpecFeatAxis_featureLabel1->get_axis(), log);
    }
}

/********************************************************************/

void check_rmeasSpecVecbld(
 rmeasSpecVecbld * a_rmeasSpecVecbld,
 int log)
{
  if (a_rmeasSpecVecbld->get_r())
    {
      adjustLevels(&rmeasSpecVecbldAtts_r, "rmeasSpecVecbld r");
      if (log && !findString("r", rmeasSpecVecbldAtts))
	{
	  warnAtt("r", "rmeasSpecVecbld", a_rmeasSpecVecbld);
	  check_rentVal(a_rmeasSpecVecbld->get_r(), 0);
	}
      else
	check_rentVal(a_rmeasSpecVecbld->get_r(), log);
    }
  if (a_rmeasSpecVecbld->get_numPts())
    {
      adjustLevels(&rmeasSpecVecbldAtts_numPts, "rmeasSpecVecbld numPts");
      if (log && !findString("numPts", rmeasSpecVecbldAtts))
	{
	  warnAtt("numPts", "rmeasSpecVecbld", a_rmeasSpecVecbld);
	  check_intVal(a_rmeasSpecVecbld->get_numPts(), 0);
	}
      else
	check_intVal(a_rmeasSpecVecbld->get_numPts(), log);
    }
}

/********************************************************************/

void check_rmeasSpecVecbldEdgept(
 rmeasSpecVecbldEdgept * a_rmeasSpecVecbldEdgept,
 int log)
{
  if (a_rmeasSpecVecbldEdgept->get_rmeasSpecVecbld())
    {
      adjustLevels(&rmeasSpecVecbldEdgeptAtts_a_rmeasSpecVecbld,
		   "rmeasSpecVecbldEdgept a_rmeasSpecVecbld");
      if (log && !findString("a_rmeasSpecVecbld", rmeasSpecVecbldEdgeptAtts))
	{
	  warnAtt("a_rmeasSpecVecbld", "rmeasSpecVecbldEdgept",
		  a_rmeasSpecVecbldEdgept);
	  check_rmeasSpecVecbld(
	    a_rmeasSpecVecbldEdgept->get_rmeasSpecVecbld(), 0);
	}
      else
	check_rmeasSpecVecbld(
	  a_rmeasSpecVecbldEdgept->get_rmeasSpecVecbld(), log);
    }
  if (a_rmeasSpecVecbldEdgept->get_offset())
    {
      adjustLevels(&rmeasSpecVecbldEdgeptAtts_offset,
		   "rmeasSpecVecbldEdgept offset");
      if (log && !findString("offset", rmeasSpecVecbldEdgeptAtts))
	{
	  warnAtt("offset", "rmeasSpecVecbldEdgept", a_rmeasSpecVecbldEdgept);
	  check_rentVal(a_rmeasSpecVecbldEdgept->get_offset(), 0);
	}
      else
	check_rentVal(a_rmeasSpecVecbldEdgept->get_offset(), log);
    }
  if (a_rmeasSpecVecbldEdgept->get_posDir())
    {
      adjustLevels(&rmeasSpecVecbldEdgeptAtts_a_posDir,
		   "rmeasSpecVecbldEdgept a_posDir");
      if (log && !findString("a_posDir", rmeasSpecVecbldEdgeptAtts))
	{
	  warnAtt("a_posDir", "rmeasSpecVecbldEdgept",
		  a_rmeasSpecVecbldEdgept);
	  check_posDir(a_rmeasSpecVecbldEdgept->get_posDir(), 0);
	}
      else
	check_posDir(a_rmeasSpecVecbldEdgept->get_posDir(), log);
    }
  if (a_rmeasSpecVecbldEdgept->get_axis())
    {
      adjustLevels(&rmeasSpecVecbldEdgeptAtts_a_axis,
		   "rmeasSpecVecbldEdgept a_axis");
      if (log && !findString("a_axis", rmeasSpecVecbldEdgeptAtts))
	{
	  warnAtt("a_axis", "rmeasSpecVecbldEdgept", a_rmeasSpecVecbldEdgept);
	  check_axis(a_rmeasSpecVecbldEdgept->get_axis(), 0);
	}
      else
	check_axis(a_rmeasSpecVecbldEdgept->get_axis(), log);
    }
}

/********************************************************************/

void check_rmeasSpecVecbldOrient(
 rmeasSpecVecbldOrient * a_rmeasSpecVecbldOrient,
 int log)
{
  if (a_rmeasSpecVecbldOrient->get_rmeasSpecVecbld())
    {
      adjustLevels(&rmeasSpecVecbldOrientAtts_a_rmeasSpecVecbld,
		   "rmeasSpecVecbldOrient a_rmeasSpecVecbld");
      if (log && !findString("a_rmeasSpecVecbld", rmeasSpecVecbldOrientAtts))
	{
	  warnAtt("a_rmeasSpecVecbld", "rmeasSpecVecbldOrient",
		  a_rmeasSpecVecbldOrient);
	  check_rmeasSpecVecbld(
	    a_rmeasSpecVecbldOrient->get_rmeasSpecVecbld(), 0);
	}
      else
	check_rmeasSpecVecbld(
	  a_rmeasSpecVecbldOrient->get_rmeasSpecVecbld(), log);
    }
  if (a_rmeasSpecVecbldOrient->get_has_ORIENT())
    {
      adjustLevels(&rmeasSpecVecbldOrientAtts_has_ORIENT,
		   "rmeasSpecVecbldOrient has_ORIENT");
      if (log && !findString("has_ORIENT", rmeasSpecVecbldOrientAtts))
	{
	  warnAtt("has_ORIENT", "rmeasSpecVecbldOrient",
		  a_rmeasSpecVecbldOrient);
	}
    }
}

/********************************************************************/

void check_rmeasSphere(
 rmeasSphere * a_rmeasSphere,
 int log)
{
  if (a_rmeasSphere->get_fLabel())
    {
      adjustLevels(&rmeasSphereAtts_a_fLabel, "rmeasSphere a_fLabel");
      if (log && !findString("a_fLabel", rmeasSphereAtts))
	{
	  warnAtt("a_fLabel", "rmeasSphere", a_rmeasSphere);
	  check_fLabel(a_rmeasSphere->get_fLabel(), 0);
	}
      else
	check_fLabel(a_rmeasSphere->get_fLabel(), log);
    }
  if (a_rmeasSphere->get_numMeas())
    {
      adjustLevels(&rmeasSphereAtts_numMeas, "rmeasSphere numMeas");
      if (log && !findString("numMeas", rmeasSphereAtts))
	{
	  warnAtt("numMeas", "rmeasSphere", a_rmeasSphere);
	  check_intVal(a_rmeasSphere->get_numMeas(), 0);
	}
      else
	check_intVal(a_rmeasSphere->get_numMeas(), log);
    }
  if (a_rmeasSphere->get_rmeasSpecFaAxis())
    {
      adjustLevels(&rmeasSphereAtts_a_rmeasSpecFaAxis,
		   "rmeasSphere a_rmeasSpecFaAxis");
      if (log && !findString("a_rmeasSpecFaAxis", rmeasSphereAtts))
	{
	  warnAtt("a_rmeasSpecFaAxis", "rmeasSphere", a_rmeasSphere);
	  check_rmeasSpecFaAxis(a_rmeasSphere->get_rmeasSpecFaAxis(), 0);
	}
      else
	check_rmeasSpecFaAxis(a_rmeasSphere->get_rmeasSpecFaAxis(), log);
    }
}

/********************************************************************/

void check_rmeasStm(
 rmeasStm * a_rmeasStm,
 int log)
{
  if (a_rmeasStm->get_rmeasMinor())
    {
      adjustLevels(&rmeasStmAtts_a_rmeasMinor, "rmeasStm a_rmeasMinor");
      if (log && !findString("a_rmeasMinor", rmeasStmAtts))
	{
	  warnAtt("a_rmeasMinor", "rmeasStm", a_rmeasStm);
	  check_rmeasMinor(a_rmeasStm->get_rmeasMinor(), 0);
	}
      else
	check_rmeasMinor(a_rmeasStm->get_rmeasMinor(), log);
    }
}

/********************************************************************/

void check_rmeasSympln(
 rmeasSympln * a_rmeasSympln,
 int log)
{
  if (a_rmeasSympln->get_fLabel())
    {
      adjustLevels(&rmeasSymplnAtts_a_fLabel, "rmeasSympln a_fLabel");
      if (log && !findString("a_fLabel", rmeasSymplnAtts))
	{
	  warnAtt("a_fLabel", "rmeasSympln", a_rmeasSympln);
	  check_fLabel(a_rmeasSympln->get_fLabel(), 0);
	}
      else
	check_fLabel(a_rmeasSympln->get_fLabel(), log);
    }
  if (a_rmeasSympln->get_numMeas())
    {
      adjustLevels(&rmeasSymplnAtts_numMeas, "rmeasSympln numMeas");
      if (log && !findString("numMeas", rmeasSymplnAtts))
	{
	  warnAtt("numMeas", "rmeasSympln", a_rmeasSympln);
	  check_intVal(a_rmeasSympln->get_numMeas(), 0);
	}
      else
	check_intVal(a_rmeasSympln->get_numMeas(), log);
    }
  if (a_rmeasSympln->get_rmeasSpecFa())
    {
      adjustLevels(&rmeasSymplnAtts_a_rmeasSpecFa,
		   "rmeasSympln a_rmeasSpecFa");
      if (log && !findString("a_rmeasSpecFa", rmeasSymplnAtts))
	{
	  warnAtt("a_rmeasSpecFa", "rmeasSympln", a_rmeasSympln);
	  check_rmeasSpecFa(a_rmeasSympln->get_rmeasSpecFa(), 0);
	}
      else
	check_rmeasSpecFa(a_rmeasSympln->get_rmeasSpecFa(), log);
    }
}

/********************************************************************/

void check_rmeasTorus(
 rmeasTorus * a_rmeasTorus,
 int log)
{
  if (a_rmeasTorus->get_fLabel())
    {
      adjustLevels(&rmeasTorusAtts_a_fLabel, "rmeasTorus a_fLabel");
      if (log && !findString("a_fLabel", rmeasTorusAtts))
	{
	  warnAtt("a_fLabel", "rmeasTorus", a_rmeasTorus);
	  check_fLabel(a_rmeasTorus->get_fLabel(), 0);
	}
      else
	check_fLabel(a_rmeasTorus->get_fLabel(), log);
    }
  if (a_rmeasTorus->get_numMeas())
    {
      adjustLevels(&rmeasTorusAtts_numMeas, "rmeasTorus numMeas");
      if (log && !findString("numMeas", rmeasTorusAtts))
	{
	  warnAtt("numMeas", "rmeasTorus", a_rmeasTorus);
	  check_intVal(a_rmeasTorus->get_numMeas(), 0);
	}
      else
	check_intVal(a_rmeasTorus->get_numMeas(), log);
    }
  if (a_rmeasTorus->get_rmeasSpecFaAxis())
    {
      adjustLevels(&rmeasTorusAtts_a_rmeasSpecFaAxis,
		   "rmeasTorus a_rmeasSpecFaAxis");
      if (log && !findString("a_rmeasSpecFaAxis", rmeasTorusAtts))
	{
	  warnAtt("a_rmeasSpecFaAxis", "rmeasTorus", a_rmeasTorus);
	  check_rmeasSpecFaAxis(a_rmeasTorus->get_rmeasSpecFaAxis(), 0);
	}
      else
	check_rmeasSpecFaAxis(a_rmeasTorus->get_rmeasSpecFaAxis(), log);
    }
}

/********************************************************************/

void check_rotAbs(
 rotAbs * a_rotAbs,
 int log)
{
  if (a_rotAbs->get_rotDir())
    {
      adjustLevels(&rotAbsAtts_a_rotDir, "rotAbs a_rotDir");
      if (log && !findString("a_rotDir", rotAbsAtts))
	{
	  warnAtt("a_rotDir", "rotAbs", a_rotAbs);
	  check_rotDir(a_rotAbs->get_rotDir(), 0);
	}
      else
	check_rotDir(a_rotAbs->get_rotDir(), log);
    }
}

/********************************************************************/

void check_rotDir(
 rotDir * a_rotDir,
 int log)
{
  if (isA(a_rotDir, rotDir_rotOrient))
    {
      adjustLevels(&rotDirSubs_rotDir_rotOrient, "rotDir_rotOrient");
      if (log && !findString("rotDir_rotOrient", rotDirSubs))
	{
	  warnSub("rotDir_rotOrient", "rotDir", a_rotDir);
	  check_rotDir_rotOrient(
	    dynamic_cast<rotDir_rotOrient *>(a_rotDir), 0);
	}
      else
	check_rotDir_rotOrient(
	  dynamic_cast<rotDir_rotOrient *>(a_rotDir), log);
      return;
    }
  if (isA(a_rotDir, rotDir_SHORT))
    {
      adjustLevels(&rotDirSubs_rotDir_SHORT, "rotDir_SHORT");
      if (log && !findString("rotDir_SHORT", rotDirSubs))
	{
	  warnSub("rotDir_SHORT", "rotDir", a_rotDir);
	}
      return;
    }
}

/********************************************************************/

void check_rotDir_rotOrient(
 rotDir_rotOrient * a_rotDir_rotOrient,
 int log)
{
  if (a_rotDir_rotOrient->get_rotOrient())
    {
      adjustLevels(&rotDir_rotOrientAtts_a_rotOrient,
		   "rotDir_rotOrient a_rotOrient");
      if (log && !findString("a_rotOrient", rotDir_rotOrientAtts))
	{
	  warnAtt("a_rotOrient", "rotDir_rotOrient", a_rotDir_rotOrient);
	  check_rotOrient(a_rotDir_rotOrient->get_rotOrient(), 0);
	}
      else
	check_rotOrient(a_rotDir_rotOrient->get_rotOrient(), log);
    }
}

/********************************************************************/

void check_rotIncr(
 rotIncr * a_rotIncr,
 int log)
{
  if (a_rotIncr->get_rotOrient())
    {
      adjustLevels(&rotIncrAtts_a_rotOrient, "rotIncr a_rotOrient");
      if (log && !findString("a_rotOrient", rotIncrAtts))
	{
	  warnAtt("a_rotOrient", "rotIncr", a_rotIncr);
	  check_rotOrient(a_rotIncr->get_rotOrient(), 0);
	}
      else
	check_rotOrient(a_rotIncr->get_rotOrient(), log);
    }
}

/********************************************************************/

void check_rotOrient(
 rotOrient * a_rotOrient,
 int log)
{
  if (isA(a_rotOrient, rotOrient_CW))
    {
      adjustLevels(&rotOrientSubs_rotOrient_CW, "rotOrient_CW");
      if (log && !findString("rotOrient_CW", rotOrientSubs))
	{
	  warnSub("rotOrient_CW", "rotOrient", a_rotOrient);
	}
      return;
    }
  if (isA(a_rotOrient, rotOrient_CCW))
    {
      adjustLevels(&rotOrientSubs_rotOrient_CCW, "rotOrient_CCW");
      if (log && !findString("rotOrient_CCW", rotOrientSubs))
	{
	  warnSub("rotOrient_CCW", "rotOrient", a_rotOrient);
	}
      return;
    }
}

/********************************************************************/

void check_rotType(
 rotType * a_rotType,
 int log)
{
  if (isA(a_rotType, rotType_ROTTOT))
    {
      adjustLevels(&rotTypeSubs_rotType_ROTTOT, "rotType_ROTTOT");
      if (log && !findString("rotType_ROTTOT", rotTypeSubs))
	{
	  warnSub("rotType_ROTTOT", "rotType", a_rotType);
	}
      return;
    }
  if (isA(a_rotType, rotType_ROTORG))
    {
      adjustLevels(&rotTypeSubs_rotType_ROTORG, "rotType_ROTORG");
      if (log && !findString("rotType_ROTORG", rotTypeSubs))
	{
	  warnSub("rotType_ROTORG", "rotType", a_rotType);
	}
      return;
    }
  if (isA(a_rotType, rotType_ROTNUL))
    {
      adjustLevels(&rotTypeSubs_rotType_ROTNUL, "rotType_ROTNUL");
      if (log && !findString("rotType_ROTNUL", rotTypeSubs))
	{
	  warnSub("rotType_ROTNUL", "rotType", a_rotType);
	}
      return;
    }
}

/********************************************************************/

void check_rotabAbs(
 rotabAbs * a_rotabAbs,
 int log)
{
  if (a_rotabAbs->get_rtLabel())
    {
      adjustLevels(&rotabAbsAtts_a_rtLabel, "rotabAbs a_rtLabel");
      if (log && !findString("a_rtLabel", rotabAbsAtts))
	{
	  warnAtt("a_rtLabel", "rotabAbs", a_rotabAbs);
	  check_rtLabel(a_rotabAbs->get_rtLabel(), 0);
	}
      else
	check_rtLabel(a_rotabAbs->get_rtLabel(), log);
    }
  if (a_rotabAbs->get_rotAbs())
    {
      adjustLevels(&rotabAbsAtts_a_rotAbs, "rotabAbs a_rotAbs");
      if (log && !findString("a_rotAbs", rotabAbsAtts))
	{
	  warnAtt("a_rotAbs", "rotabAbs", a_rotabAbs);
	  check_rotAbs(a_rotabAbs->get_rotAbs(), 0);
	}
      else
	check_rotAbs(a_rotabAbs->get_rotAbs(), log);
    }
  if (a_rotabAbs->get_rotType())
    {
      adjustLevels(&rotabAbsAtts_a_rotType, "rotabAbs a_rotType");
      if (log && !findString("a_rotType", rotabAbsAtts))
	{
	  warnAtt("a_rotType", "rotabAbs", a_rotabAbs);
	  check_rotType(a_rotabAbs->get_rotType(), 0);
	}
      else
	check_rotType(a_rotabAbs->get_rotType(), log);
    }
  if (a_rotabAbs->get_rotAngle())
    {
      adjustLevels(&rotabAbsAtts_rotAngle, "rotabAbs rotAngle");
      if (log && !findString("rotAngle", rotabAbsAtts))
	{
	  warnAtt("rotAngle", "rotabAbs", a_rotabAbs);
	  check_angle(a_rotabAbs->get_rotAngle(), 0);
	}
      else
	check_angle(a_rotabAbs->get_rotAngle(), log);
    }
  if (a_rotabAbs->get_maxDev())
    {
      adjustLevels(&rotabAbsAtts_maxDev, "rotabAbs maxDev");
      if (log && !findString("maxDev", rotabAbsAtts))
	{
	  warnAtt("maxDev", "rotabAbs", a_rotabAbs);
	  check_angle(a_rotabAbs->get_maxDev(), 0);
	}
      else
	check_angle(a_rotabAbs->get_maxDev(), log);
    }
}

/********************************************************************/

void check_rotabFeat(
 rotabFeat * a_rotabFeat,
 int log)
{
  if (a_rotabFeat->get_rtLabel())
    {
      adjustLevels(&rotabFeatAtts_a_rtLabel, "rotabFeat a_rtLabel");
      if (log && !findString("a_rtLabel", rotabFeatAtts))
	{
	  warnAtt("a_rtLabel", "rotabFeat", a_rotabFeat);
	  check_rtLabel(a_rotabFeat->get_rtLabel(), 0);
	}
      else
	check_rtLabel(a_rotabFeat->get_rtLabel(), log);
    }
  if (a_rotabFeat->get_featureLabel())
    {
      adjustLevels(&rotabFeatAtts_a_featureLabel, "rotabFeat a_featureLabel");
      if (log && !findString("a_featureLabel", rotabFeatAtts))
	{
	  warnAtt("a_featureLabel", "rotabFeat", a_rotabFeat);
	  check_featureLabel(a_rotabFeat->get_featureLabel(), 0);
	}
      else
	check_featureLabel(a_rotabFeat->get_featureLabel(), log);
    }
  if (a_rotabFeat->get_rotType())
    {
      adjustLevels(&rotabFeatAtts_a_rotType, "rotabFeat a_rotType");
      if (log && !findString("a_rotType", rotabFeatAtts))
	{
	  warnAtt("a_rotType", "rotabFeat", a_rotabFeat);
	  check_rotType(a_rotabFeat->get_rotType(), 0);
	}
      else
	check_rotType(a_rotabFeat->get_rotType(), log);
    }
  if (a_rotabFeat->get_rotDir())
    {
      adjustLevels(&rotabFeatAtts_a_rotDir, "rotabFeat a_rotDir");
      if (log && !findString("a_rotDir", rotabFeatAtts))
	{
	  warnAtt("a_rotDir", "rotabFeat", a_rotabFeat);
	  check_rotDir(a_rotabFeat->get_rotDir(), 0);
	}
      else
	check_rotDir(a_rotabFeat->get_rotDir(), log);
    }
}

/********************************************************************/

void check_rotabIncr(
 rotabIncr * a_rotabIncr,
 int log)
{
  if (a_rotabIncr->get_rtLabel())
    {
      adjustLevels(&rotabIncrAtts_a_rtLabel, "rotabIncr a_rtLabel");
      if (log && !findString("a_rtLabel", rotabIncrAtts))
	{
	  warnAtt("a_rtLabel", "rotabIncr", a_rotabIncr);
	  check_rtLabel(a_rotabIncr->get_rtLabel(), 0);
	}
      else
	check_rtLabel(a_rotabIncr->get_rtLabel(), log);
    }
  if (a_rotabIncr->get_rotIncr())
    {
      adjustLevels(&rotabIncrAtts_a_rotIncr, "rotabIncr a_rotIncr");
      if (log && !findString("a_rotIncr", rotabIncrAtts))
	{
	  warnAtt("a_rotIncr", "rotabIncr", a_rotabIncr);
	  check_rotIncr(a_rotabIncr->get_rotIncr(), 0);
	}
      else
	check_rotIncr(a_rotabIncr->get_rotIncr(), log);
    }
  if (a_rotabIncr->get_rotType())
    {
      adjustLevels(&rotabIncrAtts_a_rotType, "rotabIncr a_rotType");
      if (log && !findString("a_rotType", rotabIncrAtts))
	{
	  warnAtt("a_rotType", "rotabIncr", a_rotabIncr);
	  check_rotType(a_rotabIncr->get_rotType(), 0);
	}
      else
	check_rotType(a_rotabIncr->get_rotType(), log);
    }
  if (a_rotabIncr->get_rotAngle())
    {
      adjustLevels(&rotabIncrAtts_rotAngle, "rotabIncr rotAngle");
      if (log && !findString("rotAngle", rotabIncrAtts))
	{
	  warnAtt("rotAngle", "rotabIncr", a_rotabIncr);
	  check_angle(a_rotabIncr->get_rotAngle(), 0);
	}
      else
	check_angle(a_rotabIncr->get_rotAngle(), log);
    }
  if (a_rotabIncr->get_maxDev())
    {
      adjustLevels(&rotabIncrAtts_maxDev, "rotabIncr maxDev");
      if (log && !findString("maxDev", rotabIncrAtts))
	{
	  warnAtt("maxDev", "rotabIncr", a_rotabIncr);
	  check_angle(a_rotabIncr->get_maxDev(), 0);
	}
      else
	check_angle(a_rotabIncr->get_maxDev(), log);
    }
}

/********************************************************************/

void check_rotabMinor(
 rotabMinor * a_rotabMinor,
 int log)
{
  if (isA(a_rotabMinor, rotabAbs))
    {
      adjustLevels(&rotabMinorSubs_rotabAbs, "rotabAbs");
      if (log && !findString("rotabAbs", rotabMinorSubs))
	{
	  warnSub("rotabAbs", "rotabMinor", a_rotabMinor);
	  check_rotabAbs(dynamic_cast<rotabAbs *>(a_rotabMinor), 0);
	}
      else
	check_rotabAbs(dynamic_cast<rotabAbs *>(a_rotabMinor), log);
      return;
    }
  if (isA(a_rotabMinor, rotabIncr))
    {
      adjustLevels(&rotabMinorSubs_rotabIncr, "rotabIncr");
      if (log && !findString("rotabIncr", rotabMinorSubs))
	{
	  warnSub("rotabIncr", "rotabMinor", a_rotabMinor);
	  check_rotabIncr(dynamic_cast<rotabIncr *>(a_rotabMinor), 0);
	}
      else
	check_rotabIncr(dynamic_cast<rotabIncr *>(a_rotabMinor), log);
      return;
    }
  if (isA(a_rotabMinor, rotabFeat))
    {
      adjustLevels(&rotabMinorSubs_rotabFeat, "rotabFeat");
      if (log && !findString("rotabFeat", rotabMinorSubs))
	{
	  warnSub("rotabFeat", "rotabMinor", a_rotabMinor);
	  check_rotabFeat(dynamic_cast<rotabFeat *>(a_rotabMinor), 0);
	}
      else
	check_rotabFeat(dynamic_cast<rotabFeat *>(a_rotabMinor), log);
      return;
    }
}

/********************************************************************/

void check_rotabStm(
 rotabStm * a_rotabStm,
 int log)
{
  if (a_rotabStm->get_rotabMinor())
    {
      adjustLevels(&rotabStmAtts_a_rotabMinor, "rotabStm a_rotabMinor");
      if (log && !findString("a_rotabMinor", rotabStmAtts))
	{
	  warnAtt("a_rotabMinor", "rotabStm", a_rotabStm);
	  check_rotabMinor(a_rotabStm->get_rotabMinor(), 0);
	}
      else
	check_rotabMinor(a_rotabStm->get_rotabMinor(), log);
    }
}

/********************************************************************/

void check_rotateDatum(
 rotateDatum * a_rotateDatum,
 int log)
{
  if (a_rotateDatum->get_axis())
    {
      adjustLevels(&rotateDatumAtts_a_axis, "rotateDatum a_axis");
      if (log && !findString("a_axis", rotateDatumAtts))
	{
	  warnAtt("a_axis", "rotateDatum", a_rotateDatum);
	  check_axis(a_rotateDatum->get_axis(), 0);
	}
      else
	check_axis(a_rotateDatum->get_axis(), log);
    }
  if (a_rotateDatum->get_datLabel())
    {
      adjustLevels(&rotateDatumAtts_a_datLabel, "rotateDatum a_datLabel");
      if (log && !findString("a_datLabel", rotateDatumAtts))
	{
	  warnAtt("a_datLabel", "rotateDatum", a_rotateDatum);
	  check_datLabel(a_rotateDatum->get_datLabel(), 0);
	}
      else
	check_datLabel(a_rotateDatum->get_datLabel(), log);
    }
  if (a_rotateDatum->get_dir())
    {
      adjustLevels(&rotateDatumAtts_a_dir, "rotateDatum a_dir");
      if (log && !findString("a_dir", rotateDatumAtts))
	{
	  warnAtt("a_dir", "rotateDatum", a_rotateDatum);
	  check_dir(a_rotateDatum->get_dir(), 0);
	}
      else
	check_dir(a_rotateDatum->get_dir(), log);
    }
}

/********************************************************************/

void check_rotateFeature(
 rotateFeature * a_rotateFeature,
 int log)
{
  if (a_rotateFeature->get_axis())
    {
      adjustLevels(&rotateFeatureAtts_a_axis, "rotateFeature a_axis");
      if (log && !findString("a_axis", rotateFeatureAtts))
	{
	  warnAtt("a_axis", "rotateFeature", a_rotateFeature);
	  check_axis(a_rotateFeature->get_axis(), 0);
	}
      else
	check_axis(a_rotateFeature->get_axis(), log);
    }
  if (a_rotateFeature->get_featureLabel())
    {
      adjustLevels(&rotateFeatureAtts_a_featureLabel,
		   "rotateFeature a_featureLabel");
      if (log && !findString("a_featureLabel", rotateFeatureAtts))
	{
	  warnAtt("a_featureLabel", "rotateFeature", a_rotateFeature);
	  check_featureLabel(a_rotateFeature->get_featureLabel(), 0);
	}
      else
	check_featureLabel(a_rotateFeature->get_featureLabel(), log);
    }
  if (a_rotateFeature->get_dir())
    {
      adjustLevels(&rotateFeatureAtts_a_dir, "rotateFeature a_dir");
      if (log && !findString("a_dir", rotateFeatureAtts))
	{
	  warnAtt("a_dir", "rotateFeature", a_rotateFeature);
	  check_dir(a_rotateFeature->get_dir(), 0);
	}
      else
	check_dir(a_rotateFeature->get_dir(), log);
    }
}

/********************************************************************/

void check_rotateMinor(
 rotateMinor * a_rotateMinor,
 int log)
{
  if (isA(a_rotateMinor, rotateValue))
    {
      adjustLevels(&rotateMinorSubs_rotateValue, "rotateValue");
      if (log && !findString("rotateValue", rotateMinorSubs))
	{
	  warnSub("rotateValue", "rotateMinor", a_rotateMinor);
	  check_rotateValue(dynamic_cast<rotateValue *>(a_rotateMinor), 0);
	}
      else
	check_rotateValue(dynamic_cast<rotateValue *>(a_rotateMinor), log);
      return;
    }
  if (isA(a_rotateMinor, rotateFeature))
    {
      adjustLevels(&rotateMinorSubs_rotateFeature, "rotateFeature");
      if (log && !findString("rotateFeature", rotateMinorSubs))
	{
	  warnSub("rotateFeature", "rotateMinor", a_rotateMinor);
	  check_rotateFeature(
	    dynamic_cast<rotateFeature *>(a_rotateMinor), 0);
	}
      else
	check_rotateFeature(
	  dynamic_cast<rotateFeature *>(a_rotateMinor), log);
      return;
    }
  if (isA(a_rotateMinor, rotateDatum))
    {
      adjustLevels(&rotateMinorSubs_rotateDatum, "rotateDatum");
      if (log && !findString("rotateDatum", rotateMinorSubs))
	{
	  warnSub("rotateDatum", "rotateMinor", a_rotateMinor);
	  check_rotateDatum(dynamic_cast<rotateDatum *>(a_rotateMinor), 0);
	}
      else
	check_rotateDatum(dynamic_cast<rotateDatum *>(a_rotateMinor), log);
      return;
    }
}

/********************************************************************/

void check_rotateStm(
 rotateStm * a_rotateStm,
 int log)
{
  if (a_rotateStm->get_dLabel())
    {
      adjustLevels(&rotateStmAtts_a_dLabel, "rotateStm a_dLabel");
      if (log && !findString("a_dLabel", rotateStmAtts))
	{
	  warnAtt("a_dLabel", "rotateStm", a_rotateStm);
	  check_dLabel(a_rotateStm->get_dLabel(), 0);
	}
      else
	check_dLabel(a_rotateStm->get_dLabel(), log);
    }
  if (a_rotateStm->get_rotateMinor())
    {
      adjustLevels(&rotateStmAtts_a_rotateMinor, "rotateStm a_rotateMinor");
      if (log && !findString("a_rotateMinor", rotateStmAtts))
	{
	  warnAtt("a_rotateMinor", "rotateStm", a_rotateStm);
	  check_rotateMinor(a_rotateStm->get_rotateMinor(), 0);
	}
      else
	check_rotateMinor(a_rotateStm->get_rotateMinor(), log);
    }
}

/********************************************************************/

void check_rotateValue(
 rotateValue * a_rotateValue,
 int log)
{
  if (a_rotateValue->get_axis())
    {
      adjustLevels(&rotateValueAtts_a_axis, "rotateValue a_axis");
      if (log && !findString("a_axis", rotateValueAtts))
	{
	  warnAtt("a_axis", "rotateValue", a_rotateValue);
	  check_axis(a_rotateValue->get_axis(), 0);
	}
      else
	check_axis(a_rotateValue->get_axis(), log);
    }
  if (a_rotateValue->get_angle())
    {
      adjustLevels(&rotateValueAtts_a_angle, "rotateValue a_angle");
      if (log && !findString("a_angle", rotateValueAtts))
	{
	  warnAtt("a_angle", "rotateValue", a_rotateValue);
	  check_angle(a_rotateValue->get_angle(), 0);
	}
      else
	check_angle(a_rotateValue->get_angle(), log);
    }
}

/********************************************************************/

void check_rotdefStm(
 rotdefStm * a_rotdefStm,
 int log)
{
  if (a_rotdefStm->get_theTable())
    {
      adjustLevels(&rotdefStmAtts_theTable, "rotdefStm theTable");
      if (log && !findString("theTable", rotdefStmAtts))
	{
	  warnAtt("theTable", "rotdefStm", a_rotdefStm);
	  check_rtLabel(a_rotdefStm->get_theTable(), 0);
	}
      else
	check_rtLabel(a_rotdefStm->get_theTable(), log);
    }
  if (a_rotdefStm->get_pointVecCart())
    {
      adjustLevels(&rotdefStmAtts_a_pointVecCart, "rotdefStm a_pointVecCart");
      if (log && !findString("a_pointVecCart", rotdefStmAtts))
	{
	  warnAtt("a_pointVecCart", "rotdefStm", a_rotdefStm);
	  check_pointVecCart(a_rotdefStm->get_pointVecCart(), 0);
	}
      else
	check_pointVecCart(a_rotdefStm->get_pointVecCart(), log);
    }
  if (a_rotdefStm->get_otherTable())
    {
      adjustLevels(&rotdefStmAtts_otherTable, "rotdefStm otherTable");
      if (log && !findString("otherTable", rotdefStmAtts))
	{
	  warnAtt("otherTable", "rotdefStm", a_rotdefStm);
	  check_rtLabel(a_rotdefStm->get_otherTable(), 0);
	}
      else
	check_rtLabel(a_rotdefStm->get_otherTable(), log);
    }
}

/********************************************************************/

void check_rotsetStm(
 rotsetStm * a_rotsetStm,
 int log)
{
  if (a_rotsetStm->get_rtLabel())
    {
      adjustLevels(&rotsetStmAtts_a_rtLabel, "rotsetStm a_rtLabel");
      if (log && !findString("a_rtLabel", rotsetStmAtts))
	{
	  warnAtt("a_rtLabel", "rotsetStm", a_rotsetStm);
	  check_rtLabel(a_rotsetStm->get_rtLabel(), 0);
	}
      else
	check_rtLabel(a_rotsetStm->get_rtLabel(), log);
    }
  if (a_rotsetStm->get_angle())
    {
      adjustLevels(&rotsetStmAtts_a_angle, "rotsetStm a_angle");
      if (log && !findString("a_angle", rotsetStmAtts))
	{
	  warnAtt("a_angle", "rotsetStm", a_rotsetStm);
	  check_angle(a_rotsetStm->get_angle(), 0);
	}
      else
	check_angle(a_rotsetStm->get_angle(), log);
    }
}

/********************************************************************/

void check_rtLabel(
 rtLabel * a_rtLabel,
 int log)
{
  if (a_rtLabel->get_labelName())
    {
      adjustLevels(&rtLabelAtts_a_labelName, "rtLabel a_labelName");
      if (log && !findString("a_labelName", rtLabelAtts))
	{
	  warnAtt("a_labelName", "rtLabel", a_rtLabel);
	  check_labelName(a_rtLabel->get_labelName(), 0);
	}
      else
	check_labelName(a_rtLabel->get_labelName(), log);
    }
}

/********************************************************************/

void check_rwFormat(
 rwFormat * a_rwFormat,
 int log)
{
  if (a_rwFormat->get_width())
    {
      adjustLevels(&rwFormatAtts_width, "rwFormat width");
      if (log && !findString("width", rwFormatAtts))
	{
	  warnAtt("width", "rwFormat", a_rwFormat);
	  check_intVal(a_rwFormat->get_width(), 0);
	}
      else
	check_intVal(a_rwFormat->get_width(), log);
    }
  if (a_rwFormat->get_decimal())
    {
      adjustLevels(&rwFormatAtts_decimal, "rwFormat decimal");
      if (log && !findString("decimal", rwFormatAtts))
	{
	  warnAtt("decimal", "rwFormat", a_rwFormat);
	  check_intVal(a_rwFormat->get_decimal(), 0);
	}
      else
	check_intVal(a_rwFormat->get_decimal(), log);
    }
}

/********************************************************************/

void check_rwVar(
 rwVar * a_rwVar,
 int log)
{
  if (isA(a_rwVar, stringVar))
    {
      adjustLevels(&rwVarSubs_stringVar, "stringVar");
      if (log && !findString("stringVar", rwVarSubs))
	{
	  warnSub("stringVar", "rwVar", a_rwVar);
	  check_stringVar(dynamic_cast<stringVar *>(a_rwVar), 0);
	}
      else
	check_stringVar(dynamic_cast<stringVar *>(a_rwVar), log);
      return;
    }
  if (isA(a_rwVar, boolVar))
    {
      adjustLevels(&rwVarSubs_boolVar, "boolVar");
      if (log && !findString("boolVar", rwVarSubs))
	{
	  warnSub("boolVar", "rwVar", a_rwVar);
	  check_boolVar(dynamic_cast<boolVar *>(a_rwVar), 0);
	}
      else
	check_boolVar(dynamic_cast<boolVar *>(a_rwVar), log);
      return;
    }
  if (isA(a_rwVar, intVar))
    {
      adjustLevels(&rwVarSubs_intVar, "intVar");
      if (log && !findString("intVar", rwVarSubs))
	{
	  warnSub("intVar", "rwVar", a_rwVar);
	  check_intVar(dynamic_cast<intVar *>(a_rwVar), 0);
	}
      else
	check_intVar(dynamic_cast<intVar *>(a_rwVar), log);
      return;
    }
  if (isA(a_rwVar, realVar))
    {
      adjustLevels(&rwVarSubs_realVar, "realVar");
      if (log && !findString("realVar", rwVarSubs))
	{
	  warnSub("realVar", "rwVar", a_rwVar);
	  check_realVar(dynamic_cast<realVar *>(a_rwVar), 0);
	}
      else
	check_realVar(dynamic_cast<realVar *>(a_rwVar), log);
      return;
    }
  if (isA(a_rwVar, vectorVar))
    {
      adjustLevels(&rwVarSubs_vectorVar, "vectorVar");
      if (log && !findString("vectorVar", rwVarSubs))
	{
	  warnSub("vectorVar", "rwVar", a_rwVar);
	  check_vectorVar(dynamic_cast<vectorVar *>(a_rwVar), 0);
	}
      else
	check_vectorVar(dynamic_cast<vectorVar *>(a_rwVar), log);
      return;
    }
}

/********************************************************************/

void check_sLabel(
 sLabel * a_sLabel,
 int log)
{
  if (a_sLabel->get_labelName())
    {
      adjustLevels(&sLabelAtts_a_labelName, "sLabel a_labelName");
      if (log && !findString("a_labelName", sLabelAtts))
	{
	  warnAtt("a_labelName", "sLabel", a_sLabel);
	  check_labelName(a_sLabel->get_labelName(), 0);
	}
      else
	check_labelName(a_sLabel->get_labelName(), log);
    }
}

/********************************************************************/

void check_saLabel(
 saLabel * a_saLabel,
 int log)
{
  if (a_saLabel->get_labelName())
    {
      adjustLevels(&saLabelAtts_a_labelName, "saLabel a_labelName");
      if (log && !findString("a_labelName", saLabelAtts))
	{
	  warnAtt("a_labelName", "saLabel", a_saLabel);
	  check_labelName(a_saLabel->get_labelName(), 0);
	}
      else
	check_labelName(a_saLabel->get_labelName(), log);
    }
}

/********************************************************************/

void check_saveDMLStm(
 saveDMLStm * a_saveDMLStm,
 int log)
{
  if (a_saveDMLStm->get_didLabel())
    {
      adjustLevels(&saveDMLStmAtts_a_didLabel, "saveDMLStm a_didLabel");
      if (log && !findString("a_didLabel", saveDMLStmAtts))
	{
	  warnAtt("a_didLabel", "saveDMLStm", a_saveDMLStm);
	  check_didLabel(a_saveDMLStm->get_didLabel(), 0);
	}
      else
	check_didLabel(a_saveDMLStm->get_didLabel(), log);
    }
  if (a_saveDMLStm->get_daLabel())
    {
      adjustLevels(&saveDMLStmAtts_a_daLabel, "saveDMLStm a_daLabel");
      if (log && !findString("a_daLabel", saveDMLStmAtts))
	{
	  warnAtt("a_daLabel", "saveDMLStm", a_saveDMLStm);
	  check_daLabel(a_saveDMLStm->get_daLabel(), 0);
	}
      else
	check_daLabel(a_saveDMLStm->get_daLabel(), log);
    }
}

/********************************************************************/

void check_saveDatumStm(
 saveDatumStm * a_saveDatumStm,
 int log)
{
  if (a_saveDatumStm->get_datumLabel1())
    {
      adjustLevels(&saveDatumStmAtts_a_datumLabel1,
		   "saveDatumStm a_datumLabel1");
      if (log && !findString("a_datumLabel1", saveDatumStmAtts))
	{
	  warnAtt("a_datumLabel1", "saveDatumStm", a_saveDatumStm);
	  check_datumLabel1(a_saveDatumStm->get_datumLabel1(), 0);
	}
      else
	check_datumLabel1(a_saveDatumStm->get_datumLabel1(), log);
    }
  if (a_saveDatumStm->get_didLabel())
    {
      adjustLevels(&saveDatumStmAtts_a_didLabel, "saveDatumStm a_didLabel");
      if (log && !findString("a_didLabel", saveDatumStmAtts))
	{
	  warnAtt("a_didLabel", "saveDatumStm", a_saveDatumStm);
	  check_didLabel(a_saveDatumStm->get_didLabel(), 0);
	}
      else
	check_didLabel(a_saveDatumStm->get_didLabel(), log);
    }
}

/********************************************************************/

void check_saveFeatureStm(
 saveFeatureStm * a_saveFeatureStm,
 int log)
{
  if (a_saveFeatureStm->get_faLabel())
    {
      adjustLevels(&saveFeatureStmAtts_a_faLabel, "saveFeatureStm a_faLabel");
      if (log && !findString("a_faLabel", saveFeatureStmAtts))
	{
	  warnAtt("a_faLabel", "saveFeatureStm", a_saveFeatureStm);
	  check_faLabel(a_saveFeatureStm->get_faLabel(), 0);
	}
      else
	check_faLabel(a_saveFeatureStm->get_faLabel(), log);
    }
  if (a_saveFeatureStm->get_didLabel())
    {
      adjustLevels(&saveFeatureStmAtts_a_didLabel,
		   "saveFeatureStm a_didLabel");
      if (log && !findString("a_didLabel", saveFeatureStmAtts))
	{
	  warnAtt("a_didLabel", "saveFeatureStm", a_saveFeatureStm);
	  check_didLabel(a_saveFeatureStm->get_didLabel(), 0);
	}
      else
	check_didLabel(a_saveFeatureStm->get_didLabel(), log);
    }
}

/********************************************************************/

void check_saveRotaryTableStm(
 saveRotaryTableStm * a_saveRotaryTableStm,
 int log)
{
  if (a_saveRotaryTableStm->get_rtLabel())
    {
      adjustLevels(&saveRotaryTableStmAtts_a_rtLabel,
		   "saveRotaryTableStm a_rtLabel");
      if (log && !findString("a_rtLabel", saveRotaryTableStmAtts))
	{
	  warnAtt("a_rtLabel", "saveRotaryTableStm", a_saveRotaryTableStm);
	  check_rtLabel(a_saveRotaryTableStm->get_rtLabel(), 0);
	}
      else
	check_rtLabel(a_saveRotaryTableStm->get_rtLabel(), log);
    }
  if (a_saveRotaryTableStm->get_didLabel())
    {
      adjustLevels(&saveRotaryTableStmAtts_a_didLabel,
		   "saveRotaryTableStm a_didLabel");
      if (log && !findString("a_didLabel", saveRotaryTableStmAtts))
	{
	  warnAtt("a_didLabel", "saveRotaryTableStm", a_saveRotaryTableStm);
	  check_didLabel(a_saveRotaryTableStm->get_didLabel(), 0);
	}
      else
	check_didLabel(a_saveRotaryTableStm->get_didLabel(), log);
    }
}

/********************************************************************/

void check_saveSensorStm(
 saveSensorStm * a_saveSensorStm,
 int log)
{
  if (a_saveSensorStm->get_sensorLabel1())
    {
      adjustLevels(&saveSensorStmAtts_a_sensorLabel1,
		   "saveSensorStm a_sensorLabel1");
      if (log && !findString("a_sensorLabel1", saveSensorStmAtts))
	{
	  warnAtt("a_sensorLabel1", "saveSensorStm", a_saveSensorStm);
	  check_sensorLabel1(a_saveSensorStm->get_sensorLabel1(), 0);
	}
      else
	check_sensorLabel1(a_saveSensorStm->get_sensorLabel1(), log);
    }
  if (a_saveSensorStm->get_didLabel())
    {
      adjustLevels(&saveSensorStmAtts_a_didLabel, "saveSensorStm a_didLabel");
      if (log && !findString("a_didLabel", saveSensorStmAtts))
	{
	  warnAtt("a_didLabel", "saveSensorStm", a_saveSensorStm);
	  check_didLabel(a_saveSensorStm->get_didLabel(), 0);
	}
      else
	check_didLabel(a_saveSensorStm->get_didLabel(), log);
    }
}

/********************************************************************/

void check_scnmodStm(
 scnmodStm * a_scnmodStm,
 int log)
{
  if (a_scnmodStm->get_state())
    {
      adjustLevels(&scnmodStmAtts_a_state, "scnmodStm a_state");
      if (log && !findString("a_state", scnmodStmAtts))
	{
	  warnAtt("a_state", "scnmodStm", a_scnmodStm);
	  check_state(a_scnmodStm->get_state(), 0);
	}
      else
	check_state(a_scnmodStm->get_state(), log);
    }
}

/********************************************************************/

void check_scnsetDrag(
 scnsetDrag * a_scnsetDrag,
 int log)
{
  if (a_scnsetDrag->get_scnsetSampleDrag())
    {
      adjustLevels(&scnsetDragAtts_a_scnsetSampleDrag,
		   "scnsetDrag a_scnsetSampleDrag");
      if (log && !findString("a_scnsetSampleDrag", scnsetDragAtts))
	{
	  warnAtt("a_scnsetSampleDrag", "scnsetDrag", a_scnsetDrag);
	  check_scnsetSampleDrag(a_scnsetDrag->get_scnsetSampleDrag(), 0);
	}
      else
	check_scnsetSampleDrag(a_scnsetDrag->get_scnsetSampleDrag(), log);
    }
}

/********************************************************************/

void check_scnsetMinor(
 scnsetMinor * a_scnsetMinor,
 int log)
{
  if (isA(a_scnsetMinor, scnsetPeck))
    {
      adjustLevels(&scnsetMinorSubs_scnsetPeck, "scnsetPeck");
      if (log && !findString("scnsetPeck", scnsetMinorSubs))
	{
	  warnSub("scnsetPeck", "scnsetMinor", a_scnsetMinor);
	  check_scnsetPeck(dynamic_cast<scnsetPeck *>(a_scnsetMinor), 0);
	}
      else
	check_scnsetPeck(dynamic_cast<scnsetPeck *>(a_scnsetMinor), log);
      return;
    }
  if (isA(a_scnsetMinor, scnsetDrag))
    {
      adjustLevels(&scnsetMinorSubs_scnsetDrag, "scnsetDrag");
      if (log && !findString("scnsetDrag", scnsetMinorSubs))
	{
	  warnSub("scnsetDrag", "scnsetMinor", a_scnsetMinor);
	  check_scnsetDrag(dynamic_cast<scnsetDrag *>(a_scnsetMinor), 0);
	}
      else
	check_scnsetDrag(dynamic_cast<scnsetDrag *>(a_scnsetMinor), log);
      return;
    }
  if (isA(a_scnsetMinor, scnsetNoncon))
    {
      adjustLevels(&scnsetMinorSubs_scnsetNoncon, "scnsetNoncon");
      if (log && !findString("scnsetNoncon", scnsetMinorSubs))
	{
	  warnSub("scnsetNoncon", "scnsetMinor", a_scnsetMinor);
	  check_scnsetNoncon(
	    dynamic_cast<scnsetNoncon *>(a_scnsetMinor), 0);
	}
      else
	check_scnsetNoncon(
	  dynamic_cast<scnsetNoncon *>(a_scnsetMinor), log);
      return;
    }
  if (isA(a_scnsetMinor, scnsetStop))
    {
      adjustLevels(&scnsetMinorSubs_scnsetStop, "scnsetStop");
      if (log && !findString("scnsetStop", scnsetMinorSubs))
	{
	  warnSub("scnsetStop", "scnsetMinor", a_scnsetMinor);
	  check_scnsetStop(dynamic_cast<scnsetStop *>(a_scnsetMinor), 0);
	}
      else
	check_scnsetStop(dynamic_cast<scnsetStop *>(a_scnsetMinor), log);
      return;
    }
  if (isA(a_scnsetMinor, scnsetVendor))
    {
      adjustLevels(&scnsetMinorSubs_scnsetVendor, "scnsetVendor");
      if (log && !findString("scnsetVendor", scnsetMinorSubs))
	{
	  warnSub("scnsetVendor", "scnsetMinor", a_scnsetMinor);
	  check_scnsetVendor(
	    dynamic_cast<scnsetVendor *>(a_scnsetMinor), 0);
	}
      else
	check_scnsetVendor(
	  dynamic_cast<scnsetVendor *>(a_scnsetMinor), log);
      return;
    }
}

/********************************************************************/

void check_scnsetNoncon(
 scnsetNoncon * a_scnsetNoncon,
 int log)
{
  if (a_scnsetNoncon->get_scnsetSample())
    {
      adjustLevels(&scnsetNonconAtts_a_scnsetSample,
		   "scnsetNoncon a_scnsetSample");
      if (log && !findString("a_scnsetSample", scnsetNonconAtts))
	{
	  warnAtt("a_scnsetSample", "scnsetNoncon", a_scnsetNoncon);
	  check_scnsetSample(a_scnsetNoncon->get_scnsetSample(), 0);
	}
      else
	check_scnsetSample(a_scnsetNoncon->get_scnsetSample(), log);
    }
}

/********************************************************************/

void check_scnsetPeck(
 scnsetPeck * a_scnsetPeck,
 int log)
{
  if (a_scnsetPeck->get_scnsetSample())
    {
      adjustLevels(&scnsetPeckAtts_a_scnsetSample,
		   "scnsetPeck a_scnsetSample");
      if (log && !findString("a_scnsetSample", scnsetPeckAtts))
	{
	  warnAtt("a_scnsetSample", "scnsetPeck", a_scnsetPeck);
	  check_scnsetSample(a_scnsetPeck->get_scnsetSample(), 0);
	}
      else
	check_scnsetSample(a_scnsetPeck->get_scnsetSample(), log);
    }
}

/********************************************************************/

void check_scnsetSample(
 scnsetSample * a_scnsetSample,
 int log)
{
  if (isA(a_scnsetSample, scnsetSample_DIST))
    {
      adjustLevels(&scnsetSampleSubs_scnsetSample_DIST, "scnsetSample_DIST");
      if (log && !findString("scnsetSample_DIST", scnsetSampleSubs))
	{
	  warnSub("scnsetSample_DIST", "scnsetSample", a_scnsetSample);
	  check_scnsetSample_DIST(
	    dynamic_cast<scnsetSample_DIST *>(a_scnsetSample), 0);
	}
      else
	check_scnsetSample_DIST(
	  dynamic_cast<scnsetSample_DIST *>(a_scnsetSample), log);
      return;
    }
  if (isA(a_scnsetSample, scnsetSample_CHORD))
    {
      adjustLevels(&scnsetSampleSubs_scnsetSample_CHORD, "scnsetSample_CHORD");
      if (log && !findString("scnsetSample_CHORD", scnsetSampleSubs))
	{
	  warnSub("scnsetSample_CHORD", "scnsetSample", a_scnsetSample);
	  check_scnsetSample_CHORD(
	    dynamic_cast<scnsetSample_CHORD *>(a_scnsetSample), 0);
	}
      else
	check_scnsetSample_CHORD(
	  dynamic_cast<scnsetSample_CHORD *>(a_scnsetSample), log);
      return;
    }
  if (isA(a_scnsetSample, scnsetSample_TIME))
    {
      adjustLevels(&scnsetSampleSubs_scnsetSample_TIME, "scnsetSample_TIME");
      if (log && !findString("scnsetSample_TIME", scnsetSampleSubs))
	{
	  warnSub("scnsetSample_TIME", "scnsetSample", a_scnsetSample);
	  check_scnsetSample_TIME(
	    dynamic_cast<scnsetSample_TIME *>(a_scnsetSample), 0);
	}
      else
	check_scnsetSample_TIME(
	  dynamic_cast<scnsetSample_TIME *>(a_scnsetSample), log);
      return;
    }
  if (isA(a_scnsetSample, scnsetSample_ANGLE))
    {
      adjustLevels(&scnsetSampleSubs_scnsetSample_ANGLE, "scnsetSample_ANGLE");
      if (log && !findString("scnsetSample_ANGLE", scnsetSampleSubs))
	{
	  warnSub("scnsetSample_ANGLE", "scnsetSample", a_scnsetSample);
	  check_scnsetSample_ANGLE(
	    dynamic_cast<scnsetSample_ANGLE *>(a_scnsetSample), 0);
	}
      else
	check_scnsetSample_ANGLE(
	  dynamic_cast<scnsetSample_ANGLE *>(a_scnsetSample), log);
      return;
    }
  if (isA(a_scnsetSample, scnsetSample_DEFALT))
    {
      adjustLevels(&scnsetSampleSubs_scnsetSample_DEFALT,
		   "scnsetSample_DEFALT");
      if (log && !findString("scnsetSample_DEFALT", scnsetSampleSubs))
	{
	  warnSub("scnsetSample_DEFALT", "scnsetSample", a_scnsetSample);
	}
      return;
    }
}

/********************************************************************/

void check_scnsetSampleDrag(
 scnsetSampleDrag * a_scnsetSampleDrag,
 int log)
{
  if (isA(a_scnsetSampleDrag, scnsetSampleDrag_DIST))
    {
      adjustLevels(&scnsetSampleDragSubs_scnsetSampleDrag_DIST,
		   "scnsetSampleDrag_DIST");
      if (log && !findString("scnsetSampleDrag_DIST", scnsetSampleDragSubs))
	{
	  warnSub("scnsetSampleDrag_DIST", "scnsetSampleDrag",
		  a_scnsetSampleDrag);
	  check_scnsetSampleDrag_DIST(
	    dynamic_cast<scnsetSampleDrag_DIST *>(a_scnsetSampleDrag), 0);
	}
      else
	check_scnsetSampleDrag_DIST(
	  dynamic_cast<scnsetSampleDrag_DIST *>(a_scnsetSampleDrag), log);
      return;
    }
  if (isA(a_scnsetSampleDrag, scnsetSampleDrag_CHORD))
    {
      adjustLevels(&scnsetSampleDragSubs_scnsetSampleDrag_CHORD,
		   "scnsetSampleDrag_CHORD");
      if (log && !findString("scnsetSampleDrag_CHORD", scnsetSampleDragSubs))
	{
	  warnSub("scnsetSampleDrag_CHORD", "scnsetSampleDrag",
		  a_scnsetSampleDrag);
	  check_scnsetSampleDrag_CHORD(
	    dynamic_cast<scnsetSampleDrag_CHORD *>(a_scnsetSampleDrag), 0);
	}
      else
	check_scnsetSampleDrag_CHORD(
	  dynamic_cast<scnsetSampleDrag_CHORD *>(a_scnsetSampleDrag), log);
      return;
    }
  if (isA(a_scnsetSampleDrag, scnsetSampleDrag_TIME))
    {
      adjustLevels(&scnsetSampleDragSubs_scnsetSampleDrag_TIME,
		   "scnsetSampleDrag_TIME");
      if (log && !findString("scnsetSampleDrag_TIME", scnsetSampleDragSubs))
	{
	  warnSub("scnsetSampleDrag_TIME", "scnsetSampleDrag",
		  a_scnsetSampleDrag);
	  check_scnsetSampleDrag_TIME(
	    dynamic_cast<scnsetSampleDrag_TIME *>(a_scnsetSampleDrag), 0);
	}
      else
	check_scnsetSampleDrag_TIME(
	  dynamic_cast<scnsetSampleDrag_TIME *>(a_scnsetSampleDrag), log);
      return;
    }
  if (isA(a_scnsetSampleDrag, scnsetSampleDrag_ANGLE))
    {
      adjustLevels(&scnsetSampleDragSubs_scnsetSampleDrag_ANGLE,
		   "scnsetSampleDrag_ANGLE");
      if (log && !findString("scnsetSampleDrag_ANGLE", scnsetSampleDragSubs))
	{
	  warnSub("scnsetSampleDrag_ANGLE", "scnsetSampleDrag",
		  a_scnsetSampleDrag);
	  check_scnsetSampleDrag_ANGLE(
	    dynamic_cast<scnsetSampleDrag_ANGLE *>(a_scnsetSampleDrag), 0);
	}
      else
	check_scnsetSampleDrag_ANGLE(
	  dynamic_cast<scnsetSampleDrag_ANGLE *>(a_scnsetSampleDrag), log);
      return;
    }
  if (isA(a_scnsetSampleDrag, scnsetSampleDrag_DEFALT))
    {
      adjustLevels(&scnsetSampleDragSubs_scnsetSampleDrag_DEFALT,
		   "scnsetSampleDrag_DEFALT");
      if (log && !findString("scnsetSampleDrag_DEFALT", scnsetSampleDragSubs))
	{
	  warnSub("scnsetSampleDrag_DEFALT", "scnsetSampleDrag",
		  a_scnsetSampleDrag);
	  check_scnsetSampleDrag_DEFALT(
	    dynamic_cast<scnsetSampleDrag_DEFALT *>(a_scnsetSampleDrag), 0);
	}
      else
	check_scnsetSampleDrag_DEFALT(
	  dynamic_cast<scnsetSampleDrag_DEFALT *>(a_scnsetSampleDrag), log);
      return;
    }
}

/********************************************************************/

void check_scnsetSampleDrag_ANGLE(
 scnsetSampleDrag_ANGLE * a_scnsetSampleDrag_ANGLE,
 int log)
{
  if (a_scnsetSampleDrag_ANGLE->get_angle())
    {
      adjustLevels(&scnsetSampleDrag_ANGLEAtts_a_angle,
		   "scnsetSampleDrag_ANGLE a_angle");
      if (log && !findString("a_angle", scnsetSampleDrag_ANGLEAtts))
	{
	  warnAtt("a_angle", "scnsetSampleDrag_ANGLE",
		  a_scnsetSampleDrag_ANGLE);
	  check_angle(a_scnsetSampleDrag_ANGLE->get_angle(), 0);
	}
      else
	check_angle(a_scnsetSampleDrag_ANGLE->get_angle(), log);
    }
  if (a_scnsetSampleDrag_ANGLE->get_forceOrDeflection())
    {
      adjustLevels(&scnsetSampleDrag_ANGLEAtts_a_forceOrDeflection,
		   "scnsetSampleDrag_ANGLE a_forceOrDeflection");
      if (log && !findString("a_forceOrDeflection",
			     scnsetSampleDrag_ANGLEAtts))
	{
	  warnAtt("a_forceOrDeflection", "scnsetSampleDrag_ANGLE",
		  a_scnsetSampleDrag_ANGLE);
	  check_forceOrDeflection(
	    a_scnsetSampleDrag_ANGLE->get_forceOrDeflection(), 0);
	}
      else
	check_forceOrDeflection(
	  a_scnsetSampleDrag_ANGLE->get_forceOrDeflection(), log);
    }
}

/********************************************************************/

void check_scnsetSampleDrag_CHORD(
 scnsetSampleDrag_CHORD * a_scnsetSampleDrag_CHORD,
 int log)
{
  if (a_scnsetSampleDrag_CHORD->get_chord())
    {
      adjustLevels(&scnsetSampleDrag_CHORDAtts_chord,
		   "scnsetSampleDrag_CHORD chord");
      if (log && !findString("chord", scnsetSampleDrag_CHORDAtts))
	{
	  warnAtt("chord", "scnsetSampleDrag_CHORD",
		  a_scnsetSampleDrag_CHORD);
	  check_rentVal(a_scnsetSampleDrag_CHORD->get_chord(), 0);
	}
      else
	check_rentVal(a_scnsetSampleDrag_CHORD->get_chord(), log);
    }
  if (a_scnsetSampleDrag_CHORD->get_maxdist())
    {
      adjustLevels(&scnsetSampleDrag_CHORDAtts_maxdist,
		   "scnsetSampleDrag_CHORD maxdist");
      if (log && !findString("maxdist", scnsetSampleDrag_CHORDAtts))
	{
	  warnAtt("maxdist", "scnsetSampleDrag_CHORD",
		  a_scnsetSampleDrag_CHORD);
	  check_rentVal(a_scnsetSampleDrag_CHORD->get_maxdist(), 0);
	}
      else
	check_rentVal(a_scnsetSampleDrag_CHORD->get_maxdist(), log);
    }
  if (a_scnsetSampleDrag_CHORD->get_forceOrDeflection())
    {
      adjustLevels(&scnsetSampleDrag_CHORDAtts_a_forceOrDeflection,
		   "scnsetSampleDrag_CHORD a_forceOrDeflection");
      if (log && !findString("a_forceOrDeflection",
			     scnsetSampleDrag_CHORDAtts))
	{
	  warnAtt("a_forceOrDeflection", "scnsetSampleDrag_CHORD",
		  a_scnsetSampleDrag_CHORD);
	  check_forceOrDeflection(
	    a_scnsetSampleDrag_CHORD->get_forceOrDeflection(), 0);
	}
      else
	check_forceOrDeflection(
	  a_scnsetSampleDrag_CHORD->get_forceOrDeflection(), log);
    }
}

/********************************************************************/

void check_scnsetSampleDrag_DEFALT(
 scnsetSampleDrag_DEFALT * a_scnsetSampleDrag_DEFALT,
 int log)
{
  if (a_scnsetSampleDrag_DEFALT->get_forceOrDeflection())
    {
      adjustLevels(&scnsetSampleDrag_DEFALTAtts_a_forceOrDeflection,
		   "scnsetSampleDrag_DEFALT a_forceOrDeflection");
      if (log && !findString("a_forceOrDeflection",
			     scnsetSampleDrag_DEFALTAtts))
	{
	  warnAtt("a_forceOrDeflection", "scnsetSampleDrag_DEFALT",
		  a_scnsetSampleDrag_DEFALT);
	  check_forceOrDeflection(
	    a_scnsetSampleDrag_DEFALT->get_forceOrDeflection(), 0);
	}
      else
	check_forceOrDeflection(
	  a_scnsetSampleDrag_DEFALT->get_forceOrDeflection(), log);
    }
}

/********************************************************************/

void check_scnsetSampleDrag_DIST(
 scnsetSampleDrag_DIST * a_scnsetSampleDrag_DIST,
 int log)
{
  if (a_scnsetSampleDrag_DIST->get_dist())
    {
      adjustLevels(&scnsetSampleDrag_DISTAtts_dist,
		   "scnsetSampleDrag_DIST dist");
      if (log && !findString("dist", scnsetSampleDrag_DISTAtts))
	{
	  warnAtt("dist", "scnsetSampleDrag_DIST", a_scnsetSampleDrag_DIST);
	  check_rentVal(a_scnsetSampleDrag_DIST->get_dist(), 0);
	}
      else
	check_rentVal(a_scnsetSampleDrag_DIST->get_dist(), log);
    }
  if (a_scnsetSampleDrag_DIST->get_axis())
    {
      adjustLevels(&scnsetSampleDrag_DISTAtts_a_axis,
		   "scnsetSampleDrag_DIST a_axis");
      if (log && !findString("a_axis", scnsetSampleDrag_DISTAtts))
	{
	  warnAtt("a_axis", "scnsetSampleDrag_DIST", a_scnsetSampleDrag_DIST);
	  check_axis(a_scnsetSampleDrag_DIST->get_axis(), 0);
	}
      else
	check_axis(a_scnsetSampleDrag_DIST->get_axis(), log);
    }
  if (a_scnsetSampleDrag_DIST->get_forceOrDeflection())
    {
      adjustLevels(&scnsetSampleDrag_DISTAtts_a_forceOrDeflection,
		   "scnsetSampleDrag_DIST a_forceOrDeflection");
      if (log && !findString("a_forceOrDeflection", scnsetSampleDrag_DISTAtts))
	{
	  warnAtt("a_forceOrDeflection", "scnsetSampleDrag_DIST",
		  a_scnsetSampleDrag_DIST);
	  check_forceOrDeflection(
	    a_scnsetSampleDrag_DIST->get_forceOrDeflection(), 0);
	}
      else
	check_forceOrDeflection(
	  a_scnsetSampleDrag_DIST->get_forceOrDeflection(), log);
    }
}

/********************************************************************/

void check_scnsetSampleDrag_TIME(
 scnsetSampleDrag_TIME * a_scnsetSampleDrag_TIME,
 int log)
{
  if (a_scnsetSampleDrag_TIME->get_time())
    {
      adjustLevels(&scnsetSampleDrag_TIMEAtts_time,
		   "scnsetSampleDrag_TIME time");
      if (log && !findString("time", scnsetSampleDrag_TIMEAtts))
	{
	  warnAtt("time", "scnsetSampleDrag_TIME", a_scnsetSampleDrag_TIME);
	  check_rentVal(a_scnsetSampleDrag_TIME->get_time(), 0);
	}
      else
	check_rentVal(a_scnsetSampleDrag_TIME->get_time(), log);
    }
  if (a_scnsetSampleDrag_TIME->get_forceOrDeflection())
    {
      adjustLevels(&scnsetSampleDrag_TIMEAtts_a_forceOrDeflection,
		   "scnsetSampleDrag_TIME a_forceOrDeflection");
      if (log && !findString("a_forceOrDeflection", scnsetSampleDrag_TIMEAtts))
	{
	  warnAtt("a_forceOrDeflection", "scnsetSampleDrag_TIME",
		  a_scnsetSampleDrag_TIME);
	  check_forceOrDeflection(
	    a_scnsetSampleDrag_TIME->get_forceOrDeflection(), 0);
	}
      else
	check_forceOrDeflection(
	  a_scnsetSampleDrag_TIME->get_forceOrDeflection(), log);
    }
}

/********************************************************************/

void check_scnsetSample_ANGLE(
 scnsetSample_ANGLE * a_scnsetSample_ANGLE,
 int log)
{
  if (a_scnsetSample_ANGLE->get_angle())
    {
      adjustLevels(&scnsetSample_ANGLEAtts_a_angle,
		   "scnsetSample_ANGLE a_angle");
      if (log && !findString("a_angle", scnsetSample_ANGLEAtts))
	{
	  warnAtt("a_angle", "scnsetSample_ANGLE", a_scnsetSample_ANGLE);
	  check_angle(a_scnsetSample_ANGLE->get_angle(), 0);
	}
      else
	check_angle(a_scnsetSample_ANGLE->get_angle(), log);
    }
}

/********************************************************************/

void check_scnsetSample_CHORD(
 scnsetSample_CHORD * a_scnsetSample_CHORD,
 int log)
{
  if (a_scnsetSample_CHORD->get_chord())
    {
      adjustLevels(&scnsetSample_CHORDAtts_chord, "scnsetSample_CHORD chord");
      if (log && !findString("chord", scnsetSample_CHORDAtts))
	{
	  warnAtt("chord", "scnsetSample_CHORD", a_scnsetSample_CHORD);
	  check_rentVal(a_scnsetSample_CHORD->get_chord(), 0);
	}
      else
	check_rentVal(a_scnsetSample_CHORD->get_chord(), log);
    }
  if (a_scnsetSample_CHORD->get_maxdist())
    {
      adjustLevels(&scnsetSample_CHORDAtts_maxdist,
		   "scnsetSample_CHORD maxdist");
      if (log && !findString("maxdist", scnsetSample_CHORDAtts))
	{
	  warnAtt("maxdist", "scnsetSample_CHORD", a_scnsetSample_CHORD);
	  check_rentVal(a_scnsetSample_CHORD->get_maxdist(), 0);
	}
      else
	check_rentVal(a_scnsetSample_CHORD->get_maxdist(), log);
    }
}

/********************************************************************/

void check_scnsetSample_DIST(
 scnsetSample_DIST * a_scnsetSample_DIST,
 int log)
{
  if (a_scnsetSample_DIST->get_dist())
    {
      adjustLevels(&scnsetSample_DISTAtts_dist, "scnsetSample_DIST dist");
      if (log && !findString("dist", scnsetSample_DISTAtts))
	{
	  warnAtt("dist", "scnsetSample_DIST", a_scnsetSample_DIST);
	  check_rentVal(a_scnsetSample_DIST->get_dist(), 0);
	}
      else
	check_rentVal(a_scnsetSample_DIST->get_dist(), log);
    }
  if (a_scnsetSample_DIST->get_axis())
    {
      adjustLevels(&scnsetSample_DISTAtts_a_axis, "scnsetSample_DIST a_axis");
      if (log && !findString("a_axis", scnsetSample_DISTAtts))
	{
	  warnAtt("a_axis", "scnsetSample_DIST", a_scnsetSample_DIST);
	  check_axis(a_scnsetSample_DIST->get_axis(), 0);
	}
      else
	check_axis(a_scnsetSample_DIST->get_axis(), log);
    }
}

/********************************************************************/

void check_scnsetSample_TIME(
 scnsetSample_TIME * a_scnsetSample_TIME,
 int log)
{
  if (a_scnsetSample_TIME->get_time())
    {
      adjustLevels(&scnsetSample_TIMEAtts_time, "scnsetSample_TIME time");
      if (log && !findString("time", scnsetSample_TIMEAtts))
	{
	  warnAtt("time", "scnsetSample_TIME", a_scnsetSample_TIME);
	  check_rentVal(a_scnsetSample_TIME->get_time(), 0);
	}
      else
	check_rentVal(a_scnsetSample_TIME->get_time(), log);
    }
}

/********************************************************************/

void check_scnsetStm(
 scnsetStm * a_scnsetStm,
 int log)
{
  if (a_scnsetStm->get_scnsetMinor())
    {
      adjustLevels(&scnsetStmAtts_a_scnsetMinor, "scnsetStm a_scnsetMinor");
      if (log && !findString("a_scnsetMinor", scnsetStmAtts))
	{
	  warnAtt("a_scnsetMinor", "scnsetStm", a_scnsetStm);
	  check_scnsetMinor(a_scnsetStm->get_scnsetMinor(), 0);
	}
      else
	check_scnsetMinor(a_scnsetStm->get_scnsetMinor(), log);
    }
}

/********************************************************************/

void check_scnsetStop(
 scnsetStop * a_scnsetStop,
 int log)
{
  if (isA(a_scnsetStop, scnsetStopPlane))
    {
      adjustLevels(&scnsetStopSubs_scnsetStopPlane, "scnsetStopPlane");
      if (log && !findString("scnsetStopPlane", scnsetStopSubs))
	{
	  warnSub("scnsetStopPlane", "scnsetStop", a_scnsetStop);
	  check_scnsetStopPlane(
	    dynamic_cast<scnsetStopPlane *>(a_scnsetStop), 0);
	}
      else
	check_scnsetStopPlane(
	  dynamic_cast<scnsetStopPlane *>(a_scnsetStop), log);
      return;
    }
  if (isA(a_scnsetStop, scnsetStopSphere))
    {
      adjustLevels(&scnsetStopSubs_scnsetStopSphere, "scnsetStopSphere");
      if (log && !findString("scnsetStopSphere", scnsetStopSubs))
	{
	  warnSub("scnsetStopSphere", "scnsetStop", a_scnsetStop);
	  check_scnsetStopSphere(
	    dynamic_cast<scnsetStopSphere *>(a_scnsetStop), 0);
	}
      else
	check_scnsetStopSphere(
	  dynamic_cast<scnsetStopSphere *>(a_scnsetStop), log);
      return;
    }
}

/********************************************************************/

void check_scnsetStopPlane(
 scnsetStopPlane * a_scnsetStopPlane,
 int log)
{
  if (a_scnsetStopPlane->get_planeVec())
    {
      adjustLevels(&scnsetStopPlaneAtts_planeVec, "scnsetStopPlane planeVec");
      if (log && !findString("planeVec", scnsetStopPlaneAtts))
	{
	  warnAtt("planeVec", "scnsetStopPlane", a_scnsetStopPlane);
	  check_vector(a_scnsetStopPlane->get_planeVec(), 0);
	}
      else
	check_vector(a_scnsetStopPlane->get_planeVec(), log);
    }
  if (a_scnsetStopPlane->get_radius())
    {
      adjustLevels(&scnsetStopPlaneAtts_radius, "scnsetStopPlane radius");
      if (log && !findString("radius", scnsetStopPlaneAtts))
	{
	  warnAtt("radius", "scnsetStopPlane", a_scnsetStopPlane);
	  check_rentVal(a_scnsetStopPlane->get_radius(), 0);
	}
      else
	check_rentVal(a_scnsetStopPlane->get_radius(), log);
    }
  if (a_scnsetStopPlane->get_count())
    {
      adjustLevels(&scnsetStopPlaneAtts_count, "scnsetStopPlane count");
      if (log && !findString("count", scnsetStopPlaneAtts))
	{
	  warnAtt("count", "scnsetStopPlane", a_scnsetStopPlane);
	  check_intVal(a_scnsetStopPlane->get_count(), 0);
	}
      else
	check_intVal(a_scnsetStopPlane->get_count(), log);
    }
}

/********************************************************************/

void check_scnsetStopSphere(
 scnsetStopSphere * a_scnsetStopSphere,
 int log)
{
  if (a_scnsetStopSphere->get_radius())
    {
      adjustLevels(&scnsetStopSphereAtts_radius, "scnsetStopSphere radius");
      if (log && !findString("radius", scnsetStopSphereAtts))
	{
	  warnAtt("radius", "scnsetStopSphere", a_scnsetStopSphere);
	  check_rentVal(a_scnsetStopSphere->get_radius(), 0);
	}
      else
	check_rentVal(a_scnsetStopSphere->get_radius(), log);
    }
}

/********************************************************************/

void check_scnsetVendor(
 scnsetVendor * a_scnsetVendor,
 int log)
{
  if (isA(a_scnsetVendor, scnsetVendor_FORM))
    {
      adjustLevels(&scnsetVendorSubs_scnsetVendor_FORM, "scnsetVendor_FORM");
      if (log && !findString("scnsetVendor_FORM", scnsetVendorSubs))
	{
	  warnSub("scnsetVendor_FORM", "scnsetVendor", a_scnsetVendor);
	}
      return;
    }
  if (isA(a_scnsetVendor, scnsetVendor_POS))
    {
      adjustLevels(&scnsetVendorSubs_scnsetVendor_POS, "scnsetVendor_POS");
      if (log && !findString("scnsetVendor_POS", scnsetVendorSubs))
	{
	  warnSub("scnsetVendor_POS", "scnsetVendor", a_scnsetVendor);
	}
      return;
    }
  if (isA(a_scnsetVendor, scnsetVendor_SIZE))
    {
      adjustLevels(&scnsetVendorSubs_scnsetVendor_SIZE, "scnsetVendor_SIZE");
      if (log && !findString("scnsetVendor_SIZE", scnsetVendorSubs))
	{
	  warnSub("scnsetVendor_SIZE", "scnsetVendor", a_scnsetVendor);
	}
      return;
    }
}

/********************************************************************/

void check_seLabel(
 seLabel * a_seLabel,
 int log)
{
  if (a_seLabel->get_labelName())
    {
      adjustLevels(&seLabelAtts_a_labelName, "seLabel a_labelName");
      if (log && !findString("a_labelName", seLabelAtts))
	{
	  warnAtt("a_labelName", "seLabel", a_seLabel);
	  check_labelName(a_seLabel->get_labelName(), 0);
	}
      else
	check_labelName(a_seLabel->get_labelName(), log);
    }
}

/********************************************************************/

void check_secondsString(
 secondsString * a_secondsString,
 int log)
{
  if (isA(a_secondsString, secondsString_REALSTRING))
    {
      adjustLevels(&secondsStringSubs_secondsString_REALSTRING,
		   "secondsString_REALSTRING");
      if (log && !findString("secondsString_REALSTRING", secondsStringSubs))
	{
	  warnSub("secondsString_REALSTRING", "secondsString", a_secondsString);
	  check_secondsString_REALSTRING(
	    dynamic_cast<secondsString_REALSTRING *>(a_secondsString), 0);
	}
      else
	check_secondsString_REALSTRING(
	  dynamic_cast<secondsString_REALSTRING *>(a_secondsString), log);
      return;
    }
  if (isA(a_secondsString, secondsString_INTSTRING))
    {
      adjustLevels(&secondsStringSubs_secondsString_INTSTRING,
		   "secondsString_INTSTRING");
      if (log && !findString("secondsString_INTSTRING", secondsStringSubs))
	{
	  warnSub("secondsString_INTSTRING", "secondsString", a_secondsString);
	  check_secondsString_INTSTRING(
	    dynamic_cast<secondsString_INTSTRING *>(a_secondsString), 0);
	}
      else
	check_secondsString_INTSTRING(
	  dynamic_cast<secondsString_INTSTRING *>(a_secondsString), log);
      return;
    }
}

/********************************************************************/

void check_secondsString_INTSTRING(
 secondsString_INTSTRING * a_secondsString_INTSTRING,
 int log)
{
  if (a_secondsString_INTSTRING->get_int())
    {
      adjustLevels(&secondsString_INTSTRINGAtts_a_int,
		   "secondsString_INTSTRING a_int");
      if (log && !findString("a_int", secondsString_INTSTRINGAtts))
	{
	  warnAtt("a_int", "secondsString_INTSTRING",
		  a_secondsString_INTSTRING);
	}
    }
}

/********************************************************************/

void check_secondsString_REALSTRING(
 secondsString_REALSTRING * a_secondsString_REALSTRING,
 int log)
{
  if (a_secondsString_REALSTRING->get_double())
    {
      adjustLevels(&secondsString_REALSTRINGAtts_a_double,
		   "secondsString_REALSTRING a_double");
      if (log && !findString("a_double", secondsString_REALSTRINGAtts))
	{
	  warnAtt("a_double", "secondsString_REALSTRING",
		  a_secondsString_REALSTRING);
	}
    }
}

/********************************************************************/

void check_selectBlock(
 selectBlock * a_selectBlock,
 int log)
{
  if (a_selectBlock->get_selectStm())
    {
      adjustLevels(&selectBlockAtts_a_selectStm, "selectBlock a_selectStm");
      if (log && !findString("a_selectStm", selectBlockAtts))
	{
	  warnAttBlock("selectStm", a_selectBlock->get_selectStm());
	  check_selectStm(a_selectBlock->get_selectStm(), 0);
	}
      else
	check_selectStm(a_selectBlock->get_selectStm(), log);
    }
  if (a_selectBlock->get_caseBlockList())
    {
      std::list<caseBlock *> * theList;
      std::list<caseBlock *>::iterator iter;
      theList = a_selectBlock->get_caseBlockList();
      adjustLevels(&selectBlockAtts_a_caseBlockList,
		   "selectBlock a_caseBlockList");
      if (log && !findString("a_caseBlockList", selectBlockAtts))
	{
	  warnAttBlock("caseBlockList",
	    a_selectBlock->get_caseBlockList()->front());
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_caseBlock(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_caseBlock(*iter, log);
	}
    }
  if (a_selectBlock->get_defaultCaseBlock())
    {
      adjustLevels(&selectBlockAtts_a_defaultCaseBlock,
		   "selectBlock a_defaultCaseBlock");
      if (log && !findString("a_defaultCaseBlock", selectBlockAtts))
	{
	  warnAttBlock("defaultCaseBlock",
	    a_selectBlock->get_defaultCaseBlock());
	  check_defaultCaseBlock(a_selectBlock->get_defaultCaseBlock(), 0);
	}
      else
	check_defaultCaseBlock(a_selectBlock->get_defaultCaseBlock(), log);
    }
  if (a_selectBlock->get_endselStm())
    {
      adjustLevels(&selectBlockAtts_a_endselStm, "selectBlock a_endselStm");
      if (log && !findString("a_endselStm", selectBlockAtts))
	{
	  warnAttBlock("endselStm", a_selectBlock->get_endselStm());
	}
    }
}

/********************************************************************/

void check_selectStm(
 selectStm * a_selectStm,
 int log)
{
  if (isA(a_selectStm, selectStmInt))
    {
      adjustLevels(&selectStmSubs_selectStmInt, "selectStmInt");
      if (log && !findString("selectStmInt", selectStmSubs))
	{
	  warnSub("selectStmInt", "selectStm", a_selectStm);
	  check_selectStmInt(dynamic_cast<selectStmInt *>(a_selectStm), 0);
	}
      else
	check_selectStmInt(dynamic_cast<selectStmInt *>(a_selectStm), log);
      return;
    }
  if (isA(a_selectStm, selectStmString))
    {
      adjustLevels(&selectStmSubs_selectStmString, "selectStmString");
      if (log && !findString("selectStmString", selectStmSubs))
	{
	  warnSub("selectStmString", "selectStm", a_selectStm);
	  check_selectStmString(
	    dynamic_cast<selectStmString *>(a_selectStm), 0);
	}
      else
	check_selectStmString(
	  dynamic_cast<selectStmString *>(a_selectStm), log);
      return;
    }
}

/********************************************************************/

void check_selectStmInt(
 selectStmInt * a_selectStmInt,
 int log)
{
  if (a_selectStmInt->get_arg())
    {
      adjustLevels(&selectStmIntAtts_arg, "selectStmInt arg");
      if (log && !findString("arg", selectStmIntAtts))
	{
	  warnAtt("arg", "selectStmInt", a_selectStmInt);
	  check_intVal(a_selectStmInt->get_arg(), 0);
	}
      else
	check_intVal(a_selectStmInt->get_arg(), log);
    }
}

/********************************************************************/

void check_selectStmString(
 selectStmString * a_selectStmString,
 int log)
{
  if (a_selectStmString->get_arg())
    {
      adjustLevels(&selectStmStringAtts_arg, "selectStmString arg");
      if (log && !findString("arg", selectStmStringAtts))
	{
	  warnAtt("arg", "selectStmString", a_selectStmString);
	  check_stringVal(a_selectStmString->get_arg(), 0);
	}
      else
	check_stringVal(a_selectStmString->get_arg(), log);
    }
}

/********************************************************************/

void check_sensorArea(
 sensorArea * a_sensorArea,
 int log)
{
  if (a_sensorArea->get_sensorGeometry())
    {
      adjustLevels(&sensorAreaAtts_a_sensorGeometry,
		   "sensorArea a_sensorGeometry");
      if (log && !findString("a_sensorGeometry", sensorAreaAtts))
	{
	  warnAtt("a_sensorGeometry", "sensorArea", a_sensorArea);
	  check_sensorGeometry(a_sensorArea->get_sensorGeometry(), 0);
	}
      else
	check_sensorGeometry(a_sensorArea->get_sensorGeometry(), log);
    }
  if (a_sensorArea->get_fovc())
    {
      adjustLevels(&sensorAreaAtts_fovc, "sensorArea fovc");
      if (log && !findString("fovc", sensorAreaAtts))
	{
	  warnAtt("fovc", "sensorArea", a_sensorArea);
	  check_rentVal(a_sensorArea->get_fovc(), 0);
	}
      else
	check_rentVal(a_sensorArea->get_fovc(), log);
    }
  if (a_sensorArea->get_fovo())
    {
      adjustLevels(&sensorAreaAtts_fovo, "sensorArea fovo");
      if (log && !findString("fovo", sensorAreaAtts))
	{
	  warnAtt("fovo", "sensorArea", a_sensorArea);
	  check_rentVal(a_sensorArea->get_fovo(), 0);
	}
      else
	check_rentVal(a_sensorArea->get_fovo(), log);
    }
  if (a_sensorArea->get_fovn())
    {
      adjustLevels(&sensorAreaAtts_fovn, "sensorArea fovn");
      if (log && !findString("fovn", sensorAreaAtts))
	{
	  warnAtt("fovn", "sensorArea", a_sensorArea);
	  check_rentVal(a_sensorArea->get_fovn(), 0);
	}
      else
	check_rentVal(a_sensorArea->get_fovn(), log);
    }
  if (a_sensorArea->get_sensorItem())
    {
      adjustLevels(&sensorAreaAtts_a_sensorItem, "sensorArea a_sensorItem");
      if (log && !findString("a_sensorItem", sensorAreaAtts))
	{
	  warnAtt("a_sensorItem", "sensorArea", a_sensorArea);
	  check_sensorItem(a_sensorArea->get_sensorItem(), 0);
	}
      else
	check_sensorItem(a_sensorArea->get_sensorItem(), log);
    }
}

/********************************************************************/

void check_sensorGeometry(
 sensorGeometry * a_sensorGeometry,
 int log)
{
  if (a_sensorGeometry->get_offset())
    {
      adjustLevels(&sensorGeometryAtts_offset, "sensorGeometry offset");
      if (log && !findString("offset", sensorGeometryAtts))
	{
	  warnAtt("offset", "sensorGeometry", a_sensorGeometry);
	  check_vector(a_sensorGeometry->get_offset(), 0);
	}
      else
	check_vector(a_sensorGeometry->get_offset(), log);
    }
  if (a_sensorGeometry->get_normal())
    {
      adjustLevels(&sensorGeometryAtts_normal, "sensorGeometry normal");
      if (log && !findString("normal", sensorGeometryAtts))
	{
	  warnAtt("normal", "sensorGeometry", a_sensorGeometry);
	  check_vector(a_sensorGeometry->get_normal(), 0);
	}
      else
	check_vector(a_sensorGeometry->get_normal(), log);
    }
  if (a_sensorGeometry->get_clock())
    {
      adjustLevels(&sensorGeometryAtts_clock, "sensorGeometry clock");
      if (log && !findString("clock", sensorGeometryAtts))
	{
	  warnAtt("clock", "sensorGeometry", a_sensorGeometry);
	  check_vector(a_sensorGeometry->get_clock(), 0);
	}
      else
	check_vector(a_sensorGeometry->get_clock(), log);
    }
}

/********************************************************************/

void check_sensorInfred(
 sensorInfred * a_sensorInfred,
 int log)
{
  if (a_sensorInfred->get_sensorGeometry())
    {
      adjustLevels(&sensorInfredAtts_a_sensorGeometry,
		   "sensorInfred a_sensorGeometry");
      if (log && !findString("a_sensorGeometry", sensorInfredAtts))
	{
	  warnAtt("a_sensorGeometry", "sensorInfred", a_sensorInfred);
	  check_sensorGeometry(a_sensorInfred->get_sensorGeometry(), 0);
	}
      else
	check_sensorGeometry(a_sensorInfred->get_sensorGeometry(), log);
    }
  if (a_sensorInfred->get_fovx())
    {
      adjustLevels(&sensorInfredAtts_fovx, "sensorInfred fovx");
      if (log && !findString("fovx", sensorInfredAtts))
	{
	  warnAtt("fovx", "sensorInfred", a_sensorInfred);
	  check_rentVal(a_sensorInfred->get_fovx(), 0);
	}
      else
	check_rentVal(a_sensorInfred->get_fovx(), log);
    }
  if (a_sensorInfred->get_fovy())
    {
      adjustLevels(&sensorInfredAtts_fovy, "sensorInfred fovy");
      if (log && !findString("fovy", sensorInfredAtts))
	{
	  warnAtt("fovy", "sensorInfred", a_sensorInfred);
	  check_rentVal(a_sensorInfred->get_fovy(), 0);
	}
      else
	check_rentVal(a_sensorInfred->get_fovy(), log);
    }
  if (a_sensorInfred->get_freq())
    {
      adjustLevels(&sensorInfredAtts_freq, "sensorInfred freq");
      if (log && !findString("freq", sensorInfredAtts))
	{
	  warnAtt("freq", "sensorInfred", a_sensorInfred);
	  check_rentVal(a_sensorInfred->get_freq(), 0);
	}
      else
	check_rentVal(a_sensorInfred->get_freq(), log);
    }
  if (a_sensorInfred->get_dwell())
    {
      adjustLevels(&sensorInfredAtts_dwell, "sensorInfred dwell");
      if (log && !findString("dwell", sensorInfredAtts))
	{
	  warnAtt("dwell", "sensorInfred", a_sensorInfred);
	  check_rentVal(a_sensorInfred->get_dwell(), 0);
	}
      else
	check_rentVal(a_sensorInfred->get_dwell(), log);
    }
  if (a_sensorInfred->get_sensorItem())
    {
      adjustLevels(&sensorInfredAtts_a_sensorItem,
		   "sensorInfred a_sensorItem");
      if (log && !findString("a_sensorItem", sensorInfredAtts))
	{
	  warnAtt("a_sensorItem", "sensorInfred", a_sensorInfred);
	  check_sensorItem(a_sensorInfred->get_sensorItem(), 0);
	}
      else
	check_sensorItem(a_sensorInfred->get_sensorItem(), log);
    }
}

/********************************************************************/

void check_sensorItem(
 sensorItem * a_sensorItem,
 int log)
{
  if (isA(a_sensorItem, sensorItem_stringVal))
    {
      adjustLevels(&sensorItemSubs_sensorItem_stringVal,
		   "sensorItem_stringVal");
      if (log && !findString("sensorItem_stringVal", sensorItemSubs))
	{
	  warnSub("sensorItem_stringVal", "sensorItem", a_sensorItem);
	  check_sensorItem_stringVal(
	    dynamic_cast<sensorItem_stringVal *>(a_sensorItem), 0);
	}
      else
	check_sensorItem_stringVal(
	  dynamic_cast<sensorItem_stringVal *>(a_sensorItem), log);
      return;
    }
  if (isA(a_sensorItem, sensorItem_intVal))
    {
      adjustLevels(&sensorItemSubs_sensorItem_intVal, "sensorItem_intVal");
      if (log && !findString("sensorItem_intVal", sensorItemSubs))
	{
	  warnSub("sensorItem_intVal", "sensorItem", a_sensorItem);
	  check_sensorItem_intVal(
	    dynamic_cast<sensorItem_intVal *>(a_sensorItem), 0);
	}
      else
	check_sensorItem_intVal(
	  dynamic_cast<sensorItem_intVal *>(a_sensorItem), log);
      return;
    }
}

/********************************************************************/

void check_sensorItem_intVal(
 sensorItem_intVal * a_sensorItem_intVal,
 int log)
{
  if (a_sensorItem_intVal->get_dataStor())
    {
      adjustLevels(&sensorItem_intValAtts_dataStor,
		   "sensorItem_intVal dataStor");
      if (log && !findString("dataStor", sensorItem_intValAtts))
	{
	  warnAtt("dataStor", "sensorItem_intVal", a_sensorItem_intVal);
	  check_stringVal(a_sensorItem_intVal->get_dataStor(), 0);
	}
      else
	check_stringVal(a_sensorItem_intVal->get_dataStor(), log);
    }
  if (a_sensorItem_intVal->get_dataList())
    {
      adjustLevels(&sensorItem_intValAtts_dataList,
		   "sensorItem_intVal dataList");
      if (log && !findString("dataList", sensorItem_intValAtts))
	{
	  warnAtt("dataList", "sensorItem_intVal", a_sensorItem_intVal);
	  check_stringVal(a_sensorItem_intVal->get_dataList(), 0);
	}
      else
	check_stringVal(a_sensorItem_intVal->get_dataList(), log);
    }
  if (a_sensorItem_intVal->get_index())
    {
      adjustLevels(&sensorItem_intValAtts_index, "sensorItem_intVal index");
      if (log && !findString("index", sensorItem_intValAtts))
	{
	  warnAtt("index", "sensorItem_intVal", a_sensorItem_intVal);
	  check_intVal(a_sensorItem_intVal->get_index(), 0);
	}
      else
	check_intVal(a_sensorItem_intVal->get_index(), log);
    }
}

/********************************************************************/

void check_sensorItem_stringVal(
 sensorItem_stringVal * a_sensorItem_stringVal,
 int log)
{
  if (a_sensorItem_stringVal->get_dataStor())
    {
      adjustLevels(&sensorItem_stringValAtts_dataStor,
		   "sensorItem_stringVal dataStor");
      if (log && !findString("dataStor", sensorItem_stringValAtts))
	{
	  warnAtt("dataStor", "sensorItem_stringVal", a_sensorItem_stringVal);
	  check_stringVal(a_sensorItem_stringVal->get_dataStor(), 0);
	}
      else
	check_stringVal(a_sensorItem_stringVal->get_dataStor(), log);
    }
  if (a_sensorItem_stringVal->get_dataList())
    {
      adjustLevels(&sensorItem_stringValAtts_dataList,
		   "sensorItem_stringVal dataList");
      if (log && !findString("dataList", sensorItem_stringValAtts))
	{
	  warnAtt("dataList", "sensorItem_stringVal", a_sensorItem_stringVal);
	  check_stringVal(a_sensorItem_stringVal->get_dataList(), 0);
	}
      else
	check_stringVal(a_sensorItem_stringVal->get_dataList(), log);
    }
  if (a_sensorItem_stringVal->get_dataItem())
    {
      adjustLevels(&sensorItem_stringValAtts_dataItem,
		   "sensorItem_stringVal dataItem");
      if (log && !findString("dataItem", sensorItem_stringValAtts))
	{
	  warnAtt("dataItem", "sensorItem_stringVal", a_sensorItem_stringVal);
	  check_stringVal(a_sensorItem_stringVal->get_dataItem(), 0);
	}
      else
	check_stringVal(a_sensorItem_stringVal->get_dataItem(), log);
    }
}

/********************************************************************/

void check_sensorLabel1(
 sensorLabel1 * a_sensorLabel1,
 int log)
{
  if (isA(a_sensorLabel1, sLabel))
    {
      adjustLevels(&sensorLabel1Subs_sLabel, "sLabel");
      if (log && !findString("sLabel", sensorLabel1Subs))
	{
	  warnSub("sLabel", "sensorLabel1", a_sensorLabel1);
	  check_sLabel(dynamic_cast<sLabel *>(a_sensorLabel1), 0);
	}
      else
	check_sLabel(dynamic_cast<sLabel *>(a_sensorLabel1), log);
      return;
    }
  if (isA(a_sensorLabel1, saLabel))
    {
      adjustLevels(&sensorLabel1Subs_saLabel, "saLabel");
      if (log && !findString("saLabel", sensorLabel1Subs))
	{
	  warnSub("saLabel", "sensorLabel1", a_sensorLabel1);
	  check_saLabel(dynamic_cast<saLabel *>(a_sensorLabel1), 0);
	}
      else
	check_saLabel(dynamic_cast<saLabel *>(a_sensorLabel1), log);
      return;
    }
}

/********************************************************************/

void check_sensorLabel2(
 sensorLabel2 * a_sensorLabel2,
 int log)
{
  if (isA(a_sensorLabel2, sLabel))
    {
      adjustLevels(&sensorLabel2Subs_sLabel, "sLabel");
      if (log && !findString("sLabel", sensorLabel2Subs))
	{
	  warnSub("sLabel", "sensorLabel2", a_sensorLabel2);
	  check_sLabel(dynamic_cast<sLabel *>(a_sensorLabel2), 0);
	}
      else
	check_sLabel(dynamic_cast<sLabel *>(a_sensorLabel2), log);
      return;
    }
  if (isA(a_sensorLabel2, saLabel))
    {
      adjustLevels(&sensorLabel2Subs_saLabel, "saLabel");
      if (log && !findString("saLabel", sensorLabel2Subs))
	{
	  warnSub("saLabel", "sensorLabel2", a_sensorLabel2);
	  check_saLabel(dynamic_cast<saLabel *>(a_sensorLabel2), 0);
	}
      else
	check_saLabel(dynamic_cast<saLabel *>(a_sensorLabel2), log);
      return;
    }
}

/********************************************************************/

void check_sensorLaser(
 sensorLaser * a_sensorLaser,
 int log)
{
  if (a_sensorLaser->get_sensorGeometry())
    {
      adjustLevels(&sensorLaserAtts_a_sensorGeometry,
		   "sensorLaser a_sensorGeometry");
      if (log && !findString("a_sensorGeometry", sensorLaserAtts))
	{
	  warnAtt("a_sensorGeometry", "sensorLaser", a_sensorLaser);
	  check_sensorGeometry(a_sensorLaser->get_sensorGeometry(), 0);
	}
      else
	check_sensorGeometry(a_sensorLaser->get_sensorGeometry(), log);
    }
  if (a_sensorLaser->get_power())
    {
      adjustLevels(&sensorLaserAtts_power, "sensorLaser power");
      if (log && !findString("power", sensorLaserAtts))
	{
	  warnAtt("power", "sensorLaser", a_sensorLaser);
	  check_rentVal(a_sensorLaser->get_power(), 0);
	}
      else
	check_rentVal(a_sensorLaser->get_power(), log);
    }
  if (a_sensorLaser->get_shuter())
    {
      adjustLevels(&sensorLaserAtts_shuter, "sensorLaser shuter");
      if (log && !findString("shuter", sensorLaserAtts))
	{
	  warnAtt("shuter", "sensorLaser", a_sensorLaser);
	  check_rentVal(a_sensorLaser->get_shuter(), 0);
	}
      else
	check_rentVal(a_sensorLaser->get_shuter(), log);
    }
  if (a_sensorLaser->get_sensorItem())
    {
      adjustLevels(&sensorLaserAtts_a_sensorItem, "sensorLaser a_sensorItem");
      if (log && !findString("a_sensorItem", sensorLaserAtts))
	{
	  warnAtt("a_sensorItem", "sensorLaser", a_sensorLaser);
	  check_sensorItem(a_sensorLaser->get_sensorItem(), 0);
	}
      else
	check_sensorItem(a_sensorLaser->get_sensorItem(), log);
    }
}

/********************************************************************/

void check_sensorLine(
 sensorLine * a_sensorLine,
 int log)
{
  if (a_sensorLine->get_sensorGeometry())
    {
      adjustLevels(&sensorLineAtts_a_sensorGeometry,
		   "sensorLine a_sensorGeometry");
      if (log && !findString("a_sensorGeometry", sensorLineAtts))
	{
	  warnAtt("a_sensorGeometry", "sensorLine", a_sensorLine);
	  check_sensorGeometry(a_sensorLine->get_sensorGeometry(), 0);
	}
      else
	check_sensorGeometry(a_sensorLine->get_sensorGeometry(), log);
    }
  if (a_sensorLine->get_fovn())
    {
      adjustLevels(&sensorLineAtts_fovn, "sensorLine fovn");
      if (log && !findString("fovn", sensorLineAtts))
	{
	  warnAtt("fovn", "sensorLine", a_sensorLine);
	  check_rentVal(a_sensorLine->get_fovn(), 0);
	}
      else
	check_rentVal(a_sensorLine->get_fovn(), log);
    }
  if (a_sensorLine->get_fovc())
    {
      adjustLevels(&sensorLineAtts_fovc, "sensorLine fovc");
      if (log && !findString("fovc", sensorLineAtts))
	{
	  warnAtt("fovc", "sensorLine", a_sensorLine);
	  check_rentVal(a_sensorLine->get_fovc(), 0);
	}
      else
	check_rentVal(a_sensorLine->get_fovc(), log);
    }
  if (a_sensorLine->get_sensorItem())
    {
      adjustLevels(&sensorLineAtts_a_sensorItem, "sensorLine a_sensorItem");
      if (log && !findString("a_sensorItem", sensorLineAtts))
	{
	  warnAtt("a_sensorItem", "sensorLine", a_sensorLine);
	  check_sensorItem(a_sensorLine->get_sensorItem(), 0);
	}
      else
	check_sensorItem(a_sensorLine->get_sensorItem(), log);
    }
}

/********************************************************************/

void check_sensorMinor(
 sensorMinor * a_sensorMinor,
 int log)
{
  if (isA(a_sensorMinor, sensorProbe))
    {
      adjustLevels(&sensorMinorSubs_sensorProbe, "sensorProbe");
      if (log && !findString("sensorProbe", sensorMinorSubs))
	{
	  warnSub("sensorProbe", "sensorMinor", a_sensorMinor);
	  check_sensorProbe(dynamic_cast<sensorProbe *>(a_sensorMinor), 0);
	}
      else
	check_sensorProbe(dynamic_cast<sensorProbe *>(a_sensorMinor), log);
      return;
    }
  if (isA(a_sensorMinor, sensorMltprb))
    {
      adjustLevels(&sensorMinorSubs_sensorMltprb, "sensorMltprb");
      if (log && !findString("sensorMltprb", sensorMinorSubs))
	{
	  warnSub("sensorMltprb", "sensorMinor", a_sensorMinor);
	  check_sensorMltprb(
	    dynamic_cast<sensorMltprb *>(a_sensorMinor), 0);
	}
      else
	check_sensorMltprb(
	  dynamic_cast<sensorMltprb *>(a_sensorMinor), log);
      return;
    }
  if (isA(a_sensorMinor, sensorVideo))
    {
      adjustLevels(&sensorMinorSubs_sensorVideo, "sensorVideo");
      if (log && !findString("sensorVideo", sensorMinorSubs))
	{
	  warnSub("sensorVideo", "sensorMinor", a_sensorMinor);
	  check_sensorVideo(dynamic_cast<sensorVideo *>(a_sensorMinor), 0);
	}
      else
	check_sensorVideo(dynamic_cast<sensorVideo *>(a_sensorMinor), log);
      return;
    }
  if (isA(a_sensorMinor, sensorLaser))
    {
      adjustLevels(&sensorMinorSubs_sensorLaser, "sensorLaser");
      if (log && !findString("sensorLaser", sensorMinorSubs))
	{
	  warnSub("sensorLaser", "sensorMinor", a_sensorMinor);
	  check_sensorLaser(dynamic_cast<sensorLaser *>(a_sensorMinor), 0);
	}
      else
	check_sensorLaser(dynamic_cast<sensorLaser *>(a_sensorMinor), log);
      return;
    }
  if (isA(a_sensorMinor, sensorInfred))
    {
      adjustLevels(&sensorMinorSubs_sensorInfred, "sensorInfred");
      if (log && !findString("sensorInfred", sensorMinorSubs))
	{
	  warnSub("sensorInfred", "sensorMinor", a_sensorMinor);
	  check_sensorInfred(
	    dynamic_cast<sensorInfred *>(a_sensorMinor), 0);
	}
      else
	check_sensorInfred(
	  dynamic_cast<sensorInfred *>(a_sensorMinor), log);
      return;
    }
  if (isA(a_sensorMinor, sensorNoncon))
    {
      adjustLevels(&sensorMinorSubs_sensorNoncon, "sensorNoncon");
      if (log && !findString("sensorNoncon", sensorMinorSubs))
	{
	  warnSub("sensorNoncon", "sensorMinor", a_sensorMinor);
	  check_sensorNoncon(
	    dynamic_cast<sensorNoncon *>(a_sensorMinor), 0);
	}
      else
	check_sensorNoncon(
	  dynamic_cast<sensorNoncon *>(a_sensorMinor), log);
      return;
    }
  if (isA(a_sensorMinor, sensorPoint))
    {
      adjustLevels(&sensorMinorSubs_sensorPoint, "sensorPoint");
      if (log && !findString("sensorPoint", sensorMinorSubs))
	{
	  warnSub("sensorPoint", "sensorMinor", a_sensorMinor);
	  check_sensorPoint(dynamic_cast<sensorPoint *>(a_sensorMinor), 0);
	}
      else
	check_sensorPoint(dynamic_cast<sensorPoint *>(a_sensorMinor), log);
      return;
    }
  if (isA(a_sensorMinor, sensorLine))
    {
      adjustLevels(&sensorMinorSubs_sensorLine, "sensorLine");
      if (log && !findString("sensorLine", sensorMinorSubs))
	{
	  warnSub("sensorLine", "sensorMinor", a_sensorMinor);
	  check_sensorLine(dynamic_cast<sensorLine *>(a_sensorMinor), 0);
	}
      else
	check_sensorLine(dynamic_cast<sensorLine *>(a_sensorMinor), log);
      return;
    }
  if (isA(a_sensorMinor, sensorArea))
    {
      adjustLevels(&sensorMinorSubs_sensorArea, "sensorArea");
      if (log && !findString("sensorArea", sensorMinorSubs))
	{
	  warnSub("sensorArea", "sensorMinor", a_sensorMinor);
	  check_sensorArea(dynamic_cast<sensorArea *>(a_sensorMinor), 0);
	}
      else
	check_sensorArea(dynamic_cast<sensorArea *>(a_sensorMinor), log);
      return;
    }
}

/********************************************************************/

void check_sensorMltprb(
 sensorMltprb * a_sensorMltprb,
 int log)
{
  if (a_sensorMltprb->get_numStyli())
    {
      adjustLevels(&sensorMltprbAtts_numStyli, "sensorMltprb numStyli");
      if (log && !findString("numStyli", sensorMltprbAtts))
	{
	  warnAtt("numStyli", "sensorMltprb", a_sensorMltprb);
	  check_intVal(a_sensorMltprb->get_numStyli(), 0);
	}
      else
	check_intVal(a_sensorMltprb->get_numStyli(), log);
    }
  if (a_sensorMltprb->get_sensorMltprbItemList())
    {
      std::list<sensorMltprbItem *> * theList;
      std::list<sensorMltprbItem *>::iterator iter;
      theList = a_sensorMltprb->get_sensorMltprbItemList();
      adjustLevels(&sensorMltprbAtts_a_sensorMltprbItemList,
		   "sensorMltprb a_sensorMltprbItemList");
      if (log && !findString("a_sensorMltprbItemList", sensorMltprbAtts))
	{
	  warnAtt("a_sensorMltprbItemList", "sensorMltprb", a_sensorMltprb);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_sensorMltprbItem(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_sensorMltprbItem(*iter, log);
	}
    }
  if (a_sensorMltprb->get_sensorItem())
    {
      adjustLevels(&sensorMltprbAtts_a_sensorItem,
		   "sensorMltprb a_sensorItem");
      if (log && !findString("a_sensorItem", sensorMltprbAtts))
	{
	  warnAtt("a_sensorItem", "sensorMltprb", a_sensorMltprb);
	  check_sensorItem(a_sensorMltprb->get_sensorItem(), 0);
	}
      else
	check_sensorItem(a_sensorMltprb->get_sensorItem(), log);
    }
}

/********************************************************************/

void check_sensorMltprbItem(
 sensorMltprbItem * a_sensorMltprbItem,
 int log)
{
  if (isA(a_sensorMltprbItem, sensorMltprbItem_stringVal))
    {
      adjustLevels(&sensorMltprbItemSubs_sensorMltprbItem_stringVal,
		   "sensorMltprbItem_stringVal");
      if (log && !findString("sensorMltprbItem_stringVal",
			     sensorMltprbItemSubs))
	{
	  warnSub("sensorMltprbItem_stringVal", "sensorMltprbItem",
		  a_sensorMltprbItem);
	  check_sensorMltprbItem_stringVal(
	    dynamic_cast<sensorMltprbItem_stringVal *>(a_sensorMltprbItem), 0);
	}
      else
	check_sensorMltprbItem_stringVal(
	  dynamic_cast<sensorMltprbItem_stringVal *>(a_sensorMltprbItem), log);
      return;
    }
  if (isA(a_sensorMltprbItem, sensorMltprbItem_intVal))
    {
      adjustLevels(&sensorMltprbItemSubs_sensorMltprbItem_intVal,
		   "sensorMltprbItem_intVal");
      if (log && !findString("sensorMltprbItem_intVal", sensorMltprbItemSubs))
	{
	  warnSub("sensorMltprbItem_intVal", "sensorMltprbItem",
		  a_sensorMltprbItem);
	  check_sensorMltprbItem_intVal(
	    dynamic_cast<sensorMltprbItem_intVal *>(a_sensorMltprbItem), 0);
	}
      else
	check_sensorMltprbItem_intVal(
	  dynamic_cast<sensorMltprbItem_intVal *>(a_sensorMltprbItem), log);
      return;
    }
}

/********************************************************************/

void check_sensorMltprbItem_intVal(
 sensorMltprbItem_intVal * a_sensorMltprbItem_intVal,
 int log)
{
  if (a_sensorMltprbItem_intVal->get_tipnum())
    {
      adjustLevels(&sensorMltprbItem_intValAtts_tipnum,
		   "sensorMltprbItem_intVal tipnum");
      if (log && !findString("tipnum", sensorMltprbItem_intValAtts))
	{
	  warnAtt("tipnum", "sensorMltprbItem_intVal",
		  a_sensorMltprbItem_intVal);
	  check_intVal(a_sensorMltprbItem_intVal->get_tipnum(), 0);
	}
      else
	check_intVal(a_sensorMltprbItem_intVal->get_tipnum(), log);
    }
  if (a_sensorMltprbItem_intVal->get_sensorProbeGeometry())
    {
      adjustLevels(&sensorMltprbItem_intValAtts_a_sensorProbeGeometry,
		   "sensorMltprbItem_intVal a_sensorProbeGeometry");
      if (log && !findString("a_sensorProbeGeometry",
			     sensorMltprbItem_intValAtts))
	{
	  warnAtt("a_sensorProbeGeometry", "sensorMltprbItem_intVal",
		  a_sensorMltprbItem_intVal);
	  check_sensorProbeGeometry(
	    a_sensorMltprbItem_intVal->get_sensorProbeGeometry(), 0);
	}
      else
	check_sensorProbeGeometry(
	  a_sensorMltprbItem_intVal->get_sensorProbeGeometry(), log);
    }
}

/********************************************************************/

void check_sensorMltprbItem_stringVal(
 sensorMltprbItem_stringVal * a_sensorMltprbItem_stringVal,
 int log)
{
  if (a_sensorMltprbItem_stringVal->get_desc())
    {
      adjustLevels(&sensorMltprbItem_stringValAtts_desc,
		   "sensorMltprbItem_stringVal desc");
      if (log && !findString("desc", sensorMltprbItem_stringValAtts))
	{
	  warnAtt("desc", "sensorMltprbItem_stringVal",
		  a_sensorMltprbItem_stringVal);
	  check_stringVal(a_sensorMltprbItem_stringVal->get_desc(), 0);
	}
      else
	check_stringVal(a_sensorMltprbItem_stringVal->get_desc(), log);
    }
  if (a_sensorMltprbItem_stringVal->get_sensorProbeGeometry())
    {
      adjustLevels(&sensorMltprbItem_stringValAtts_a_sensorProbeGeometry,
		   "sensorMltprbItem_stringVal a_sensorProbeGeometry");
      if (log && !findString("a_sensorProbeGeometry",
			     sensorMltprbItem_stringValAtts))
	{
	  warnAtt("a_sensorProbeGeometry", "sensorMltprbItem_stringVal",
		  a_sensorMltprbItem_stringVal);
	  check_sensorProbeGeometry(
	    a_sensorMltprbItem_stringVal->get_sensorProbeGeometry(), 0);
	}
      else
	check_sensorProbeGeometry(
	  a_sensorMltprbItem_stringVal->get_sensorProbeGeometry(), log);
    }
}

/********************************************************************/

void check_sensorMove(
 sensorMove * a_sensorMove,
 int log)
{
  if (isA(a_sensorMove, sensorMove_saLabel))
    {
      adjustLevels(&sensorMoveSubs_sensorMove_saLabel, "sensorMove_saLabel");
      if (log && !findString("sensorMove_saLabel", sensorMoveSubs))
	{
	  warnSub("sensorMove_saLabel", "sensorMove", a_sensorMove);
	  check_sensorMove_saLabel(
	    dynamic_cast<sensorMove_saLabel *>(a_sensorMove), 0);
	}
      else
	check_sensorMove_saLabel(
	  dynamic_cast<sensorMove_saLabel *>(a_sensorMove), log);
      return;
    }
  if (isA(a_sensorMove, sensorMove_gotoWristList))
    {
      adjustLevels(&sensorMoveSubs_sensorMove_gotoWristList,
		   "sensorMove_gotoWristList");
      if (log && !findString("sensorMove_gotoWristList", sensorMoveSubs))
	{
	  warnSub("sensorMove_gotoWristList", "sensorMove", a_sensorMove);
	  check_sensorMove_gotoWristList(
	    dynamic_cast<sensorMove_gotoWristList *>(a_sensorMove), 0);
	}
      else
	check_sensorMove_gotoWristList(
	  dynamic_cast<sensorMove_gotoWristList *>(a_sensorMove), log);
      return;
    }
  if (isA(a_sensorMove, sensorMove_probeOrient))
    {
      adjustLevels(&sensorMoveSubs_sensorMove_probeOrient,
		   "sensorMove_probeOrient");
      if (log && !findString("sensorMove_probeOrient", sensorMoveSubs))
	{
	  warnSub("sensorMove_probeOrient", "sensorMove", a_sensorMove);
	  check_sensorMove_probeOrient(
	    dynamic_cast<sensorMove_probeOrient *>(a_sensorMove), 0);
	}
      else
	check_sensorMove_probeOrient(
	  dynamic_cast<sensorMove_probeOrient *>(a_sensorMove), log);
      return;
    }
}

/********************************************************************/

void check_sensorMove_gotoWristList(
 sensorMove_gotoWristList * a_sensorMove_gotoWristList,
 int log)
{
  if (a_sensorMove_gotoWristList->get_gotoWristList())
    {
      std::list<gotoWristItem *> * theList;
      std::list<gotoWristItem *>::iterator iter;
      theList = a_sensorMove_gotoWristList->get_gotoWristList();
      adjustLevels(&sensorMove_gotoWristListAtts_a_gotoWristList,
		   "sensorMove_gotoWristList a_gotoWristList");
      if (log && !findString("a_gotoWristList", sensorMove_gotoWristListAtts))
	{
	  warnAtt("a_gotoWristList", "sensorMove_gotoWristList",
		  a_sensorMove_gotoWristList);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_gotoWristItem(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_gotoWristItem(*iter, log);
	}
    }
}

/********************************************************************/

void check_sensorMove_probeOrient(
 sensorMove_probeOrient * a_sensorMove_probeOrient,
 int log)
{
  if (a_sensorMove_probeOrient->get_probeOrient())
    {
      adjustLevels(&sensorMove_probeOrientAtts_a_probeOrient,
		   "sensorMove_probeOrient a_probeOrient");
      if (log && !findString("a_probeOrient", sensorMove_probeOrientAtts))
	{
	  warnAtt("a_probeOrient", "sensorMove_probeOrient",
		  a_sensorMove_probeOrient);
	  check_probeOrient(a_sensorMove_probeOrient->get_probeOrient(), 0);
	}
      else
	check_probeOrient(a_sensorMove_probeOrient->get_probeOrient(), log);
    }
}

/********************************************************************/

void check_sensorMove_saLabel(
 sensorMove_saLabel * a_sensorMove_saLabel,
 int log)
{
  if (a_sensorMove_saLabel->get_saLabel())
    {
      adjustLevels(&sensorMove_saLabelAtts_a_saLabel,
		   "sensorMove_saLabel a_saLabel");
      if (log && !findString("a_saLabel", sensorMove_saLabelAtts))
	{
	  warnAtt("a_saLabel", "sensorMove_saLabel", a_sensorMove_saLabel);
	  check_saLabel(a_sensorMove_saLabel->get_saLabel(), 0);
	}
      else
	check_saLabel(a_sensorMove_saLabel->get_saLabel(), log);
    }
}

/********************************************************************/

void check_sensorNoncon(
 sensorNoncon * a_sensorNoncon,
 int log)
{
  if (a_sensorNoncon->get_sensorGeometry())
    {
      adjustLevels(&sensorNonconAtts_a_sensorGeometry,
		   "sensorNoncon a_sensorGeometry");
      if (log && !findString("a_sensorGeometry", sensorNonconAtts))
	{
	  warnAtt("a_sensorGeometry", "sensorNoncon", a_sensorNoncon);
	  check_sensorGeometry(a_sensorNoncon->get_sensorGeometry(), 0);
	}
      else
	check_sensorGeometry(a_sensorNoncon->get_sensorGeometry(), log);
    }
  if (a_sensorNoncon->get_numProbes())
    {
      adjustLevels(&sensorNonconAtts_numProbes, "sensorNoncon numProbes");
      if (log && !findString("numProbes", sensorNonconAtts))
	{
	  warnAtt("numProbes", "sensorNoncon", a_sensorNoncon);
	  check_intVal(a_sensorNoncon->get_numProbes(), 0);
	}
      else
	check_intVal(a_sensorNoncon->get_numProbes(), log);
    }
  if (a_sensorNoncon->get_sensorItem())
    {
      adjustLevels(&sensorNonconAtts_a_sensorItem,
		   "sensorNoncon a_sensorItem");
      if (log && !findString("a_sensorItem", sensorNonconAtts))
	{
	  warnAtt("a_sensorItem", "sensorNoncon", a_sensorNoncon);
	  check_sensorItem(a_sensorNoncon->get_sensorItem(), 0);
	}
      else
	check_sensorItem(a_sensorNoncon->get_sensorItem(), log);
    }
}

/********************************************************************/

void check_sensorPoint(
 sensorPoint * a_sensorPoint,
 int log)
{
  if (a_sensorPoint->get_sensorGeometry())
    {
      adjustLevels(&sensorPointAtts_a_sensorGeometry,
		   "sensorPoint a_sensorGeometry");
      if (log && !findString("a_sensorGeometry", sensorPointAtts))
	{
	  warnAtt("a_sensorGeometry", "sensorPoint", a_sensorPoint);
	  check_sensorGeometry(a_sensorPoint->get_sensorGeometry(), 0);
	}
      else
	check_sensorGeometry(a_sensorPoint->get_sensorGeometry(), log);
    }
  if (a_sensorPoint->get_fovn())
    {
      adjustLevels(&sensorPointAtts_fovn, "sensorPoint fovn");
      if (log && !findString("fovn", sensorPointAtts))
	{
	  warnAtt("fovn", "sensorPoint", a_sensorPoint);
	  check_rentVal(a_sensorPoint->get_fovn(), 0);
	}
      else
	check_rentVal(a_sensorPoint->get_fovn(), log);
    }
  if (a_sensorPoint->get_sensorItem())
    {
      adjustLevels(&sensorPointAtts_a_sensorItem, "sensorPoint a_sensorItem");
      if (log && !findString("a_sensorItem", sensorPointAtts))
	{
	  warnAtt("a_sensorItem", "sensorPoint", a_sensorPoint);
	  check_sensorItem(a_sensorPoint->get_sensorItem(), 0);
	}
      else
	check_sensorItem(a_sensorPoint->get_sensorItem(), log);
    }
}

/********************************************************************/

void check_sensorProbe(
 sensorProbe * a_sensorProbe,
 int log)
{
  if (a_sensorProbe->get_sensorProbeGeometry())
    {
      adjustLevels(&sensorProbeAtts_a_sensorProbeGeometry,
		   "sensorProbe a_sensorProbeGeometry");
      if (log && !findString("a_sensorProbeGeometry", sensorProbeAtts))
	{
	  warnAtt("a_sensorProbeGeometry", "sensorProbe", a_sensorProbe);
	  check_sensorProbeGeometry(
	    a_sensorProbe->get_sensorProbeGeometry(), 0);
	}
      else
	check_sensorProbeGeometry(
	  a_sensorProbe->get_sensorProbeGeometry(), log);
    }
  if (a_sensorProbe->get_sensorProbeForm())
    {
      adjustLevels(&sensorProbeAtts_a_sensorProbeForm,
		   "sensorProbe a_sensorProbeForm");
      if (log && !findString("a_sensorProbeForm", sensorProbeAtts))
	{
	  warnAtt("a_sensorProbeForm", "sensorProbe", a_sensorProbe);
	  check_sensorProbeForm(a_sensorProbe->get_sensorProbeForm(), 0);
	}
      else
	check_sensorProbeForm(a_sensorProbe->get_sensorProbeForm(), log);
    }
  if (a_sensorProbe->get_sensorItem())
    {
      adjustLevels(&sensorProbeAtts_a_sensorItem, "sensorProbe a_sensorItem");
      if (log && !findString("a_sensorItem", sensorProbeAtts))
	{
	  warnAtt("a_sensorItem", "sensorProbe", a_sensorProbe);
	  check_sensorItem(a_sensorProbe->get_sensorItem(), 0);
	}
      else
	check_sensorItem(a_sensorProbe->get_sensorItem(), log);
    }
}

/********************************************************************/

void check_sensorProbeForm(
 sensorProbeForm * a_sensorProbeForm,
 int log)
{
  if (isA(a_sensorProbeForm, sensorProbeForm_SPHERE))
    {
      adjustLevels(&sensorProbeFormSubs_sensorProbeForm_SPHERE,
		   "sensorProbeForm_SPHERE");
      if (log && !findString("sensorProbeForm_SPHERE", sensorProbeFormSubs))
	{
	  warnSub("sensorProbeForm_SPHERE", "sensorProbeForm",
		  a_sensorProbeForm);
	}
      return;
    }
  if (isA(a_sensorProbeForm, sensorProbeForm_CYLNDR))
    {
      adjustLevels(&sensorProbeFormSubs_sensorProbeForm_CYLNDR,
		   "sensorProbeForm_CYLNDR");
      if (log && !findString("sensorProbeForm_CYLNDR", sensorProbeFormSubs))
	{
	  warnSub("sensorProbeForm_CYLNDR", "sensorProbeForm",
		  a_sensorProbeForm);
	  check_sensorProbeForm_CYLNDR(
	    dynamic_cast<sensorProbeForm_CYLNDR *>(a_sensorProbeForm), 0);
	}
      else
	check_sensorProbeForm_CYLNDR(
	  dynamic_cast<sensorProbeForm_CYLNDR *>(a_sensorProbeForm), log);
      return;
    }
  if (isA(a_sensorProbeForm, sensorProbeForm_DISK))
    {
      adjustLevels(&sensorProbeFormSubs_sensorProbeForm_DISK,
		   "sensorProbeForm_DISK");
      if (log && !findString("sensorProbeForm_DISK", sensorProbeFormSubs))
	{
	  warnSub("sensorProbeForm_DISK", "sensorProbeForm", a_sensorProbeForm);
	  check_sensorProbeForm_DISK(
	    dynamic_cast<sensorProbeForm_DISK *>(a_sensorProbeForm), 0);
	}
      else
	check_sensorProbeForm_DISK(
	  dynamic_cast<sensorProbeForm_DISK *>(a_sensorProbeForm), log);
      return;
    }
}

/********************************************************************/

void check_sensorProbeForm_CYLNDR(
 sensorProbeForm_CYLNDR * a_sensorProbeForm_CYLNDR,
 int log)
{
  if (a_sensorProbeForm_CYLNDR->get_len1())
    {
      adjustLevels(&sensorProbeForm_CYLNDRAtts_len1,
		   "sensorProbeForm_CYLNDR len1");
      if (log && !findString("len1", sensorProbeForm_CYLNDRAtts))
	{
	  warnAtt("len1", "sensorProbeForm_CYLNDR", a_sensorProbeForm_CYLNDR);
	  check_rentVal(a_sensorProbeForm_CYLNDR->get_len1(), 0);
	}
      else
	check_rentVal(a_sensorProbeForm_CYLNDR->get_len1(), log);
    }
}

/********************************************************************/

void check_sensorProbeForm_DISK(
 sensorProbeForm_DISK * a_sensorProbeForm_DISK,
 int log)
{
  if (a_sensorProbeForm_DISK->get_thkn())
    {
      adjustLevels(&sensorProbeForm_DISKAtts_thkn,
		   "sensorProbeForm_DISK thkn");
      if (log && !findString("thkn", sensorProbeForm_DISKAtts))
	{
	  warnAtt("thkn", "sensorProbeForm_DISK", a_sensorProbeForm_DISK);
	  check_rentVal(a_sensorProbeForm_DISK->get_thkn(), 0);
	}
      else
	check_rentVal(a_sensorProbeForm_DISK->get_thkn(), log);
    }
}

/********************************************************************/

void check_sensorProbeGeometry(
 sensorProbeGeometry * a_sensorProbeGeometry,
 int log)
{
  if (a_sensorProbeGeometry->get_offset())
    {
      adjustLevels(&sensorProbeGeometryAtts_offset,
		   "sensorProbeGeometry offset");
      if (log && !findString("offset", sensorProbeGeometryAtts))
	{
	  warnAtt("offset", "sensorProbeGeometry", a_sensorProbeGeometry);
	  check_vector(a_sensorProbeGeometry->get_offset(), 0);
	}
      else
	check_vector(a_sensorProbeGeometry->get_offset(), log);
    }
  if (a_sensorProbeGeometry->get_normal())
    {
      adjustLevels(&sensorProbeGeometryAtts_normal,
		   "sensorProbeGeometry normal");
      if (log && !findString("normal", sensorProbeGeometryAtts))
	{
	  warnAtt("normal", "sensorProbeGeometry", a_sensorProbeGeometry);
	  check_vector(a_sensorProbeGeometry->get_normal(), 0);
	}
      else
	check_vector(a_sensorProbeGeometry->get_normal(), log);
    }
  if (a_sensorProbeGeometry->get_diam())
    {
      adjustLevels(&sensorProbeGeometryAtts_diam, "sensorProbeGeometry diam");
      if (log && !findString("diam", sensorProbeGeometryAtts))
	{
	  warnAtt("diam", "sensorProbeGeometry", a_sensorProbeGeometry);
	  check_rentVal(a_sensorProbeGeometry->get_diam(), 0);
	}
      else
	check_rentVal(a_sensorProbeGeometry->get_diam(), log);
    }
}

/********************************************************************/

void check_sensorStm(
 sensorStm * a_sensorStm,
 int log)
{
  if (a_sensorStm->get_ssLabel())
    {
      adjustLevels(&sensorStmAtts_a_ssLabel, "sensorStm a_ssLabel");
      if (log && !findString("a_ssLabel", sensorStmAtts))
	{
	  warnAtt("a_ssLabel", "sensorStm", a_sensorStm);
	  check_ssLabel(a_sensorStm->get_ssLabel(), 0);
	}
      else
	check_ssLabel(a_sensorStm->get_ssLabel(), log);
    }
  if (a_sensorStm->get_sensorMinor())
    {
      adjustLevels(&sensorStmAtts_a_sensorMinor, "sensorStm a_sensorMinor");
      if (log && !findString("a_sensorMinor", sensorStmAtts))
	{
	  warnAtt("a_sensorMinor", "sensorStm", a_sensorStm);
	  check_sensorMinor(a_sensorStm->get_sensorMinor(), 0);
	}
      else
	check_sensorMinor(a_sensorStm->get_sensorMinor(), log);
    }
}

/********************************************************************/

void check_sensorVideo(
 sensorVideo * a_sensorVideo,
 int log)
{
  if (a_sensorVideo->get_sensorGeometry())
    {
      adjustLevels(&sensorVideoAtts_a_sensorGeometry,
		   "sensorVideo a_sensorGeometry");
      if (log && !findString("a_sensorGeometry", sensorVideoAtts))
	{
	  warnAtt("a_sensorGeometry", "sensorVideo", a_sensorVideo);
	  check_sensorGeometry(a_sensorVideo->get_sensorGeometry(), 0);
	}
      else
	check_sensorGeometry(a_sensorVideo->get_sensorGeometry(), log);
    }
  if (a_sensorVideo->get_focal())
    {
      adjustLevels(&sensorVideoAtts_focal, "sensorVideo focal");
      if (log && !findString("focal", sensorVideoAtts))
	{
	  warnAtt("focal", "sensorVideo", a_sensorVideo);
	  check_rentVal(a_sensorVideo->get_focal(), 0);
	}
      else
	check_rentVal(a_sensorVideo->get_focal(), log);
    }
  if (a_sensorVideo->get_mag())
    {
      adjustLevels(&sensorVideoAtts_mag, "sensorVideo mag");
      if (log && !findString("mag", sensorVideoAtts))
	{
	  warnAtt("mag", "sensorVideo", a_sensorVideo);
	  check_rentVal(a_sensorVideo->get_mag(), 0);
	}
      else
	check_rentVal(a_sensorVideo->get_mag(), log);
    }
  if (a_sensorVideo->get_apert())
    {
      adjustLevels(&sensorVideoAtts_apert, "sensorVideo apert");
      if (log && !findString("apert", sensorVideoAtts))
	{
	  warnAtt("apert", "sensorVideo", a_sensorVideo);
	  check_rentVal(a_sensorVideo->get_apert(), 0);
	}
      else
	check_rentVal(a_sensorVideo->get_apert(), log);
    }
  if (a_sensorVideo->get_sensorItem())
    {
      adjustLevels(&sensorVideoAtts_a_sensorItem, "sensorVideo a_sensorItem");
      if (log && !findString("a_sensorItem", sensorVideoAtts))
	{
	  warnAtt("a_sensorItem", "sensorVideo", a_sensorVideo);
	  check_sensorItem(a_sensorVideo->get_sensorItem(), 0);
	}
      else
	check_sensorItem(a_sensorVideo->get_sensorItem(), log);
    }
}

/********************************************************************/

void check_sgLabel(
 sgLabel * a_sgLabel,
 int log)
{
  if (a_sgLabel->get_labelName())
    {
      adjustLevels(&sgLabelAtts_a_labelName, "sgLabel a_labelName");
      if (log && !findString("a_labelName", sgLabelAtts))
	{
	  warnAtt("a_labelName", "sgLabel", a_sgLabel);
	  check_labelName(a_sgLabel->get_labelName(), 0);
	}
      else
	check_labelName(a_sgLabel->get_labelName(), log);
    }
}

/********************************************************************/

void check_sgageConst(
 sgageConst * a_sgageConst,
 int log)
{
  if (a_sgageConst->get_featureNominalList())
    {
      std::list<fLabel *> * theList;
      std::list<fLabel *>::iterator iter;
      theList = a_sgageConst->get_featureNominalList();
      adjustLevels(&sgageConstAtts_a_featureNominalList,
		   "sgageConst a_featureNominalList");
      if (log && !findString("a_featureNominalList", sgageConstAtts))
	{
	  warnAtt("a_featureNominalList", "sgageConst", a_sgageConst);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_fLabel(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_fLabel(*iter, log);
	}
    }
}

/********************************************************************/

void check_sgsLabel(
 sgsLabel * a_sgsLabel,
 int log)
{
  if (a_sgsLabel->get_labelName())
    {
      adjustLevels(&sgsLabelAtts_a_labelName, "sgsLabel a_labelName");
      if (log && !findString("a_labelName", sgsLabelAtts))
	{
	  warnAtt("a_labelName", "sgsLabel", a_sgsLabel);
	  check_labelName(a_sgsLabel->get_labelName(), 0);
	}
      else
	check_labelName(a_sgsLabel->get_labelName(), log);
    }
}

/********************************************************************/

void check_sign(
 sign * a_sign,
 int log)
{
  if (isA(a_sign, plusSign))
    {
      adjustLevels(&signSubs_plusSign, "plusSign");
      if (log && !findString("plusSign", signSubs))
	{
	  warnSub("plusSign", "sign", a_sign);
	}
      return;
    }
  if (isA(a_sign, minusSign))
    {
      adjustLevels(&signSubs_minusSign, "minusSign");
      if (log && !findString("minusSign", signSubs))
	{
	  warnSub("minusSign", "sign", a_sign);
	}
      return;
    }
}

/********************************************************************/

void check_simreqtBlock(
 simreqtBlock * a_simreqtBlock,
 int log)
{
  if (a_simreqtBlock->get_simreqtStm())
    {
      adjustLevels(&simreqtBlockAtts_a_simreqtStm,
		   "simreqtBlock a_simreqtStm");
      if (log && !findString("a_simreqtStm", simreqtBlockAtts))
	{
	  warnAttBlock("simreqtStm", a_simreqtBlock->get_simreqtStm());
	  check_simreqtStm(a_simreqtBlock->get_simreqtStm(), 0);
	}
      else
	check_simreqtStm(a_simreqtBlock->get_simreqtStm(), log);
    }
  if (a_simreqtBlock->get_evalOrOutputList())
    {
      std::list<evalOrOutput *> * theList;
      std::list<evalOrOutput *>::iterator iter;
      theList = a_simreqtBlock->get_evalOrOutputList();
      adjustLevels(&simreqtBlockAtts_a_evalOrOutputList,
		   "simreqtBlock a_evalOrOutputList");
      if (log && !findString("a_evalOrOutputList", simreqtBlockAtts))
	{
	  warnAttBlock("evalOrOutputList",
	    a_simreqtBlock->get_evalOrOutputList()->front());
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_evalOrOutput(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_evalOrOutput(*iter, log);
	}
    }
  if (a_simreqtBlock->get_endsimreqtStm())
    {
      adjustLevels(&simreqtBlockAtts_a_endsimreqtStm,
		   "simreqtBlock a_endsimreqtStm");
      if (log && !findString("a_endsimreqtStm", simreqtBlockAtts))
	{
	  warnAttBlock("endsimreqtStm", a_simreqtBlock->get_endsimreqtStm());
	}
    }
}

/********************************************************************/

void check_simreqtMinor(
 simreqtMinor * a_simreqtMinor,
 int log)
{
  if (isA(a_simreqtMinor, simreqtMinor_FIRST))
    {
      adjustLevels(&simreqtMinorSubs_simreqtMinor_FIRST, "simreqtMinor_FIRST");
      if (log && !findString("simreqtMinor_FIRST", simreqtMinorSubs))
	{
	  warnSub("simreqtMinor_FIRST", "simreqtMinor", a_simreqtMinor);
	}
      return;
    }
  if (isA(a_simreqtMinor, simreqtMinor_OPTIMAL))
    {
      adjustLevels(&simreqtMinorSubs_simreqtMinor_OPTIMAL,
		   "simreqtMinor_OPTIMAL");
      if (log && !findString("simreqtMinor_OPTIMAL", simreqtMinorSubs))
	{
	  warnSub("simreqtMinor_OPTIMAL", "simreqtMinor", a_simreqtMinor);
	}
      return;
    }
}

/********************************************************************/

void check_simreqtStm(
 simreqtStm * a_simreqtStm,
 int log)
{
  if (a_simreqtStm->get_srLabel())
    {
      adjustLevels(&simreqtStmAtts_a_srLabel, "simreqtStm a_srLabel");
      if (log && !findString("a_srLabel", simreqtStmAtts))
	{
	  warnAtt("a_srLabel", "simreqtStm", a_simreqtStm);
	  check_srLabel(a_simreqtStm->get_srLabel(), 0);
	}
      else
	check_srLabel(a_simreqtStm->get_srLabel(), log);
    }
  if (a_simreqtStm->get_simreqtMinor())
    {
      adjustLevels(&simreqtStmAtts_a_simreqtMinor,
		   "simreqtStm a_simreqtMinor");
      if (log && !findString("a_simreqtMinor", simreqtStmAtts))
	{
	  warnAtt("a_simreqtMinor", "simreqtStm", a_simreqtStm);
	  check_simreqtMinor(a_simreqtStm->get_simreqtMinor(), 0);
	}
      else
	check_simreqtMinor(a_simreqtStm->get_simreqtMinor(), log);
    }
}

/********************************************************************/

void check_snsdefBuild(
 snsdefBuild * a_snsdefBuild,
 int log)
{
  if (a_snsdefBuild->get_snsdefBuildItemList())
    {
      std::list<snsdefBuildItem *> * theList;
      std::list<snsdefBuildItem *>::iterator iter;
      theList = a_snsdefBuild->get_snsdefBuildItemList();
      adjustLevels(&snsdefBuildAtts_a_snsdefBuildItemList,
		   "snsdefBuild a_snsdefBuildItemList");
      if (log && !findString("a_snsdefBuildItemList", snsdefBuildAtts))
	{
	  warnAtt("a_snsdefBuildItemList", "snsdefBuild", a_snsdefBuild);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_snsdefBuildItem(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_snsdefBuildItem(*iter, log);
	}
    }
  if (a_snsdefBuild->get_snsdefBuildSensor())
    {
      adjustLevels(&snsdefBuildAtts_a_snsdefBuildSensor,
		   "snsdefBuild a_snsdefBuildSensor");
      if (log && !findString("a_snsdefBuildSensor", snsdefBuildAtts))
	{
	  warnAtt("a_snsdefBuildSensor", "snsdefBuild", a_snsdefBuild);
	  check_snsdefBuildSensor(a_snsdefBuild->get_snsdefBuildSensor(), 0);
	}
      else
	check_snsdefBuildSensor(a_snsdefBuild->get_snsdefBuildSensor(), log);
    }
}

/********************************************************************/

void check_snsdefBuildItem(
 snsdefBuildItem * a_snsdefBuildItem,
 int log)
{
  if (isA(a_snsdefBuildItem, snsdefBuildItem_sgLabel))
    {
      adjustLevels(&snsdefBuildItemSubs_snsdefBuildItem_sgLabel,
		   "snsdefBuildItem_sgLabel");
      if (log && !findString("snsdefBuildItem_sgLabel", snsdefBuildItemSubs))
	{
	  warnSub("snsdefBuildItem_sgLabel", "snsdefBuildItem",
		  a_snsdefBuildItem);
	  check_snsdefBuildItem_sgLabel(
	    dynamic_cast<snsdefBuildItem_sgLabel *>(a_snsdefBuildItem), 0);
	}
      else
	check_snsdefBuildItem_sgLabel(
	  dynamic_cast<snsdefBuildItem_sgLabel *>(a_snsdefBuildItem), log);
      return;
    }
  if (isA(a_snsdefBuildItem, snsdefBuildItem_swLabel))
    {
      adjustLevels(&snsdefBuildItemSubs_snsdefBuildItem_swLabel,
		   "snsdefBuildItem_swLabel");
      if (log && !findString("snsdefBuildItem_swLabel", snsdefBuildItemSubs))
	{
	  warnSub("snsdefBuildItem_swLabel", "snsdefBuildItem",
		  a_snsdefBuildItem);
	  check_snsdefBuildItem_swLabel(
	    dynamic_cast<snsdefBuildItem_swLabel *>(a_snsdefBuildItem), 0);
	}
      else
	check_snsdefBuildItem_swLabel(
	  dynamic_cast<snsdefBuildItem_swLabel *>(a_snsdefBuildItem), log);
      return;
    }
  if (isA(a_snsdefBuildItem, snsdefBuildItem_sxLabel))
    {
      adjustLevels(&snsdefBuildItemSubs_snsdefBuildItem_sxLabel,
		   "snsdefBuildItem_sxLabel");
      if (log && !findString("snsdefBuildItem_sxLabel", snsdefBuildItemSubs))
	{
	  warnSub("snsdefBuildItem_sxLabel", "snsdefBuildItem",
		  a_snsdefBuildItem);
	  check_snsdefBuildItem_sxLabel(
	    dynamic_cast<snsdefBuildItem_sxLabel *>(a_snsdefBuildItem), 0);
	}
      else
	check_snsdefBuildItem_sxLabel(
	  dynamic_cast<snsdefBuildItem_sxLabel *>(a_snsdefBuildItem), log);
      return;
    }
  if (isA(a_snsdefBuildItem, snsdefBuildItem_rmLabel))
    {
      adjustLevels(&snsdefBuildItemSubs_snsdefBuildItem_rmLabel,
		   "snsdefBuildItem_rmLabel");
      if (log && !findString("snsdefBuildItem_rmLabel", snsdefBuildItemSubs))
	{
	  warnSub("snsdefBuildItem_rmLabel", "snsdefBuildItem",
		  a_snsdefBuildItem);
	  check_snsdefBuildItem_rmLabel(
	    dynamic_cast<snsdefBuildItem_rmLabel *>(a_snsdefBuildItem), 0);
	}
      else
	check_snsdefBuildItem_rmLabel(
	  dynamic_cast<snsdefBuildItem_rmLabel *>(a_snsdefBuildItem), log);
      return;
    }
}

/********************************************************************/

void check_snsdefBuildItem_rmLabel(
 snsdefBuildItem_rmLabel * a_snsdefBuildItem_rmLabel,
 int log)
{
  if (a_snsdefBuildItem_rmLabel->get_rmLabel())
    {
      adjustLevels(&snsdefBuildItem_rmLabelAtts_a_rmLabel,
		   "snsdefBuildItem_rmLabel a_rmLabel");
      if (log && !findString("a_rmLabel", snsdefBuildItem_rmLabelAtts))
	{
	  warnAtt("a_rmLabel", "snsdefBuildItem_rmLabel",
		  a_snsdefBuildItem_rmLabel);
	  check_rmLabel(a_snsdefBuildItem_rmLabel->get_rmLabel(), 0);
	}
      else
	check_rmLabel(a_snsdefBuildItem_rmLabel->get_rmLabel(), log);
    }
}

/********************************************************************/

void check_snsdefBuildItem_sgLabel(
 snsdefBuildItem_sgLabel * a_snsdefBuildItem_sgLabel,
 int log)
{
  if (a_snsdefBuildItem_sgLabel->get_sgLabel())
    {
      adjustLevels(&snsdefBuildItem_sgLabelAtts_a_sgLabel,
		   "snsdefBuildItem_sgLabel a_sgLabel");
      if (log && !findString("a_sgLabel", snsdefBuildItem_sgLabelAtts))
	{
	  warnAtt("a_sgLabel", "snsdefBuildItem_sgLabel",
		  a_snsdefBuildItem_sgLabel);
	  check_sgLabel(a_snsdefBuildItem_sgLabel->get_sgLabel(), 0);
	}
      else
	check_sgLabel(a_snsdefBuildItem_sgLabel->get_sgLabel(), log);
    }
}

/********************************************************************/

void check_snsdefBuildItem_swLabel(
 snsdefBuildItem_swLabel * a_snsdefBuildItem_swLabel,
 int log)
{
  if (a_snsdefBuildItem_swLabel->get_swLabel())
    {
      adjustLevels(&snsdefBuildItem_swLabelAtts_a_swLabel,
		   "snsdefBuildItem_swLabel a_swLabel");
      if (log && !findString("a_swLabel", snsdefBuildItem_swLabelAtts))
	{
	  warnAtt("a_swLabel", "snsdefBuildItem_swLabel",
		  a_snsdefBuildItem_swLabel);
	  check_swLabel(a_snsdefBuildItem_swLabel->get_swLabel(), 0);
	}
      else
	check_swLabel(a_snsdefBuildItem_swLabel->get_swLabel(), log);
    }
  if (a_snsdefBuildItem_swLabel->get_snsdefWristAngleList())
    {
      std::list<snsdefWristAngleItem *> * theList;
      std::list<snsdefWristAngleItem *>::iterator iter;
      theList = a_snsdefBuildItem_swLabel->get_snsdefWristAngleList();
      adjustLevels(&snsdefBuildItem_swLabelAtts_a_snsdefWristAngleList,
		   "snsdefBuildItem_swLabel a_snsdefWristAngleList");
      if (log && !findString("a_snsdefWristAngleList",
			     snsdefBuildItem_swLabelAtts))
	{
	  warnAtt("a_snsdefWristAngleList", "snsdefBuildItem_swLabel",
		  a_snsdefBuildItem_swLabel);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_snsdefWristAngleItem(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_snsdefWristAngleItem(*iter, log);
	}
    }
}

/********************************************************************/

void check_snsdefBuildItem_sxLabel(
 snsdefBuildItem_sxLabel * a_snsdefBuildItem_sxLabel,
 int log)
{
  if (a_snsdefBuildItem_sxLabel->get_sxLabel())
    {
      adjustLevels(&snsdefBuildItem_sxLabelAtts_a_sxLabel,
		   "snsdefBuildItem_sxLabel a_sxLabel");
      if (log && !findString("a_sxLabel", snsdefBuildItem_sxLabelAtts))
	{
	  warnAtt("a_sxLabel", "snsdefBuildItem_sxLabel",
		  a_snsdefBuildItem_sxLabel);
	  check_sxLabel(a_snsdefBuildItem_sxLabel->get_sxLabel(), 0);
	}
      else
	check_sxLabel(a_snsdefBuildItem_sxLabel->get_sxLabel(), log);
    }
}

/********************************************************************/

void check_snsdefBuildSensor(
 snsdefBuildSensor * a_snsdefBuildSensor,
 int log)
{
  if (isA(a_snsdefBuildSensor, ssLabel))
    {
      adjustLevels(&snsdefBuildSensorSubs_ssLabel, "ssLabel");
      if (log && !findString("ssLabel", snsdefBuildSensorSubs))
	{
	  warnSub("ssLabel", "snsdefBuildSensor", a_snsdefBuildSensor);
	  check_ssLabel(dynamic_cast<ssLabel *>(a_snsdefBuildSensor), 0);
	}
      else
	check_ssLabel(dynamic_cast<ssLabel *>(a_snsdefBuildSensor), log);
      return;
    }
  if (isA(a_snsdefBuildSensor, sgsLabel))
    {
      adjustLevels(&snsdefBuildSensorSubs_sgsLabel, "sgsLabel");
      if (log && !findString("sgsLabel", snsdefBuildSensorSubs))
	{
	  warnSub("sgsLabel", "snsdefBuildSensor", a_snsdefBuildSensor);
	  check_sgsLabel(dynamic_cast<sgsLabel *>(a_snsdefBuildSensor), 0);
	}
      else
	check_sgsLabel(dynamic_cast<sgsLabel *>(a_snsdefBuildSensor), log);
      return;
    }
}

/********************************************************************/

void check_snsdefInfred(
 snsdefInfred * a_snsdefInfred,
 int log)
{
  if (a_snsdefInfred->get_snsdefType())
    {
      adjustLevels(&snsdefInfredAtts_a_snsdefType,
		   "snsdefInfred a_snsdefType");
      if (log && !findString("a_snsdefType", snsdefInfredAtts))
	{
	  warnAtt("a_snsdefType", "snsdefInfred", a_snsdefInfred);
	  check_snsdefType(a_snsdefInfred->get_snsdefType(), 0);
	}
      else
	check_snsdefType(a_snsdefInfred->get_snsdefType(), log);
    }
  if (a_snsdefInfred->get_snsdefLocation())
    {
      adjustLevels(&snsdefInfredAtts_a_snsdefLocation,
		   "snsdefInfred a_snsdefLocation");
      if (log && !findString("a_snsdefLocation", snsdefInfredAtts))
	{
	  warnAtt("a_snsdefLocation", "snsdefInfred", a_snsdefInfred);
	  check_snsdefLocation(a_snsdefInfred->get_snsdefLocation(), 0);
	}
      else
	check_snsdefLocation(a_snsdefInfred->get_snsdefLocation(), log);
    }
  if (a_snsdefInfred->get_fovx())
    {
      adjustLevels(&snsdefInfredAtts_fovx, "snsdefInfred fovx");
      if (log && !findString("fovx", snsdefInfredAtts))
	{
	  warnAtt("fovx", "snsdefInfred", a_snsdefInfred);
	  check_rentVal(a_snsdefInfred->get_fovx(), 0);
	}
      else
	check_rentVal(a_snsdefInfred->get_fovx(), log);
    }
  if (a_snsdefInfred->get_fovy())
    {
      adjustLevels(&snsdefInfredAtts_fovy, "snsdefInfred fovy");
      if (log && !findString("fovy", snsdefInfredAtts))
	{
	  warnAtt("fovy", "snsdefInfred", a_snsdefInfred);
	  check_rentVal(a_snsdefInfred->get_fovy(), 0);
	}
      else
	check_rentVal(a_snsdefInfred->get_fovy(), log);
    }
  if (a_snsdefInfred->get_freq())
    {
      adjustLevels(&snsdefInfredAtts_freq, "snsdefInfred freq");
      if (log && !findString("freq", snsdefInfredAtts))
	{
	  warnAtt("freq", "snsdefInfred", a_snsdefInfred);
	  check_rentVal(a_snsdefInfred->get_freq(), 0);
	}
      else
	check_rentVal(a_snsdefInfred->get_freq(), log);
    }
  if (a_snsdefInfred->get_dwell())
    {
      adjustLevels(&snsdefInfredAtts_dwell, "snsdefInfred dwell");
      if (log && !findString("dwell", snsdefInfredAtts))
	{
	  warnAtt("dwell", "snsdefInfred", a_snsdefInfred);
	  check_rentVal(a_snsdefInfred->get_dwell(), 0);
	}
      else
	check_rentVal(a_snsdefInfred->get_dwell(), log);
    }
}

/********************************************************************/

void check_snsdefLaser(
 snsdefLaser * a_snsdefLaser,
 int log)
{
  if (a_snsdefLaser->get_snsdefType())
    {
      adjustLevels(&snsdefLaserAtts_a_snsdefType, "snsdefLaser a_snsdefType");
      if (log && !findString("a_snsdefType", snsdefLaserAtts))
	{
	  warnAtt("a_snsdefType", "snsdefLaser", a_snsdefLaser);
	  check_snsdefType(a_snsdefLaser->get_snsdefType(), 0);
	}
      else
	check_snsdefType(a_snsdefLaser->get_snsdefType(), log);
    }
  if (a_snsdefLaser->get_snsdefLocation())
    {
      adjustLevels(&snsdefLaserAtts_a_snsdefLocation,
		   "snsdefLaser a_snsdefLocation");
      if (log && !findString("a_snsdefLocation", snsdefLaserAtts))
	{
	  warnAtt("a_snsdefLocation", "snsdefLaser", a_snsdefLaser);
	  check_snsdefLocation(a_snsdefLaser->get_snsdefLocation(), 0);
	}
      else
	check_snsdefLocation(a_snsdefLaser->get_snsdefLocation(), log);
    }
  if (a_snsdefLaser->get_power())
    {
      adjustLevels(&snsdefLaserAtts_power, "snsdefLaser power");
      if (log && !findString("power", snsdefLaserAtts))
	{
	  warnAtt("power", "snsdefLaser", a_snsdefLaser);
	  check_rentVal(a_snsdefLaser->get_power(), 0);
	}
      else
	check_rentVal(a_snsdefLaser->get_power(), log);
    }
  if (a_snsdefLaser->get_shuter())
    {
      adjustLevels(&snsdefLaserAtts_shuter, "snsdefLaser shuter");
      if (log && !findString("shuter", snsdefLaserAtts))
	{
	  warnAtt("shuter", "snsdefLaser", a_snsdefLaser);
	  check_rentVal(a_snsdefLaser->get_shuter(), 0);
	}
      else
	check_rentVal(a_snsdefLaser->get_shuter(), log);
    }
}

/********************************************************************/

void check_snsdefLocation(
 snsdefLocation * a_snsdefLocation,
 int log)
{
  if (isA(a_snsdefLocation, snsdefLocation_CART))
    {
      adjustLevels(&snsdefLocationSubs_snsdefLocation_CART,
		   "snsdefLocation_CART");
      if (log && !findString("snsdefLocation_CART", snsdefLocationSubs))
	{
	  warnSub("snsdefLocation_CART", "snsdefLocation", a_snsdefLocation);
	  check_snsdefLocation_CART(
	    dynamic_cast<snsdefLocation_CART *>(a_snsdefLocation), 0);
	}
      else
	check_snsdefLocation_CART(
	  dynamic_cast<snsdefLocation_CART *>(a_snsdefLocation), log);
      return;
    }
  if (isA(a_snsdefLocation, snsdefLocation_POL))
    {
      adjustLevels(&snsdefLocationSubs_snsdefLocation_POL,
		   "snsdefLocation_POL");
      if (log && !findString("snsdefLocation_POL", snsdefLocationSubs))
	{
	  warnSub("snsdefLocation_POL", "snsdefLocation", a_snsdefLocation);
	  check_snsdefLocation_POL(
	    dynamic_cast<snsdefLocation_POL *>(a_snsdefLocation), 0);
	}
      else
	check_snsdefLocation_POL(
	  dynamic_cast<snsdefLocation_POL *>(a_snsdefLocation), log);
      return;
    }
  if (isA(a_snsdefLocation, snsdefLocation_VEC))
    {
      adjustLevels(&snsdefLocationSubs_snsdefLocation_VEC,
		   "snsdefLocation_VEC");
      if (log && !findString("snsdefLocation_VEC", snsdefLocationSubs))
	{
	  warnSub("snsdefLocation_VEC", "snsdefLocation", a_snsdefLocation);
	  check_snsdefLocation_VEC(
	    dynamic_cast<snsdefLocation_VEC *>(a_snsdefLocation), 0);
	}
      else
	check_snsdefLocation_VEC(
	  dynamic_cast<snsdefLocation_VEC *>(a_snsdefLocation), log);
      return;
    }
}

/********************************************************************/

void check_snsdefLocation_CART(
 snsdefLocation_CART * a_snsdefLocation_CART,
 int log)
{
  if (a_snsdefLocation_CART->get_distVec())
    {
      adjustLevels(&snsdefLocation_CARTAtts_distVec,
		   "snsdefLocation_CART distVec");
      if (log && !findString("distVec", snsdefLocation_CARTAtts))
	{
	  warnAtt("distVec", "snsdefLocation_CART", a_snsdefLocation_CART);
	  check_vector(a_snsdefLocation_CART->get_distVec(), 0);
	}
      else
	check_vector(a_snsdefLocation_CART->get_distVec(), log);
    }
  if (a_snsdefLocation_CART->get_sockAxis())
    {
      adjustLevels(&snsdefLocation_CARTAtts_sockAxis,
		   "snsdefLocation_CART sockAxis");
      if (log && !findString("sockAxis", snsdefLocation_CARTAtts))
	{
	  warnAtt("sockAxis", "snsdefLocation_CART", a_snsdefLocation_CART);
	  check_vector(a_snsdefLocation_CART->get_sockAxis(), 0);
	}
      else
	check_vector(a_snsdefLocation_CART->get_sockAxis(), log);
    }
}

/********************************************************************/

void check_snsdefLocation_POL(
 snsdefLocation_POL * a_snsdefLocation_POL,
 int log)
{
  if (a_snsdefLocation_POL->get_tilt())
    {
      adjustLevels(&snsdefLocation_POLAtts_tilt, "snsdefLocation_POL tilt");
      if (log && !findString("tilt", snsdefLocation_POLAtts))
	{
	  warnAtt("tilt", "snsdefLocation_POL", a_snsdefLocation_POL);
	  check_angle(a_snsdefLocation_POL->get_tilt(), 0);
	}
      else
	check_angle(a_snsdefLocation_POL->get_tilt(), log);
    }
  if (a_snsdefLocation_POL->get_rot())
    {
      adjustLevels(&snsdefLocation_POLAtts_rot, "snsdefLocation_POL rot");
      if (log && !findString("rot", snsdefLocation_POLAtts))
	{
	  warnAtt("rot", "snsdefLocation_POL", a_snsdefLocation_POL);
	  check_angle(a_snsdefLocation_POL->get_rot(), 0);
	}
      else
	check_angle(a_snsdefLocation_POL->get_rot(), log);
    }
  if (a_snsdefLocation_POL->get_sockAxis())
    {
      adjustLevels(&snsdefLocation_POLAtts_sockAxis,
		   "snsdefLocation_POL sockAxis");
      if (log && !findString("sockAxis", snsdefLocation_POLAtts))
	{
	  warnAtt("sockAxis", "snsdefLocation_POL", a_snsdefLocation_POL);
	  check_vector(a_snsdefLocation_POL->get_sockAxis(), 0);
	}
      else
	check_vector(a_snsdefLocation_POL->get_sockAxis(), log);
    }
}

/********************************************************************/

void check_snsdefLocation_VEC(
 snsdefLocation_VEC * a_snsdefLocation_VEC,
 int log)
{
  if (a_snsdefLocation_VEC->get_beamAxis())
    {
      adjustLevels(&snsdefLocation_VECAtts_beamAxis,
		   "snsdefLocation_VEC beamAxis");
      if (log && !findString("beamAxis", snsdefLocation_VECAtts))
	{
	  warnAtt("beamAxis", "snsdefLocation_VEC", a_snsdefLocation_VEC);
	  check_vector(a_snsdefLocation_VEC->get_beamAxis(), 0);
	}
      else
	check_vector(a_snsdefLocation_VEC->get_beamAxis(), log);
    }
  if (a_snsdefLocation_VEC->get_sockAxis())
    {
      adjustLevels(&snsdefLocation_VECAtts_sockAxis,
		   "snsdefLocation_VEC sockAxis");
      if (log && !findString("sockAxis", snsdefLocation_VECAtts))
	{
	  warnAtt("sockAxis", "snsdefLocation_VEC", a_snsdefLocation_VEC);
	  check_vector(a_snsdefLocation_VEC->get_sockAxis(), 0);
	}
      else
	check_vector(a_snsdefLocation_VEC->get_sockAxis(), log);
    }
}

/********************************************************************/

void check_snsdefMinor(
 snsdefMinor * a_snsdefMinor,
 int log)
{
  if (isA(a_snsdefMinor, snsdefProbe))
    {
      adjustLevels(&snsdefMinorSubs_snsdefProbe, "snsdefProbe");
      if (log && !findString("snsdefProbe", snsdefMinorSubs))
	{
	  warnSub("snsdefProbe", "snsdefMinor", a_snsdefMinor);
	  check_snsdefProbe(dynamic_cast<snsdefProbe *>(a_snsdefMinor), 0);
	}
      else
	check_snsdefProbe(dynamic_cast<snsdefProbe *>(a_snsdefMinor), log);
      return;
    }
  if (isA(a_snsdefMinor, snsdefVideo))
    {
      adjustLevels(&snsdefMinorSubs_snsdefVideo, "snsdefVideo");
      if (log && !findString("snsdefVideo", snsdefMinorSubs))
	{
	  warnSub("snsdefVideo", "snsdefMinor", a_snsdefMinor);
	  check_snsdefVideo(dynamic_cast<snsdefVideo *>(a_snsdefMinor), 0);
	}
      else
	check_snsdefVideo(dynamic_cast<snsdefVideo *>(a_snsdefMinor), log);
      return;
    }
  if (isA(a_snsdefMinor, snsdefLaser))
    {
      adjustLevels(&snsdefMinorSubs_snsdefLaser, "snsdefLaser");
      if (log && !findString("snsdefLaser", snsdefMinorSubs))
	{
	  warnSub("snsdefLaser", "snsdefMinor", a_snsdefMinor);
	  check_snsdefLaser(dynamic_cast<snsdefLaser *>(a_snsdefMinor), 0);
	}
      else
	check_snsdefLaser(dynamic_cast<snsdefLaser *>(a_snsdefMinor), log);
      return;
    }
  if (isA(a_snsdefMinor, snsdefInfred))
    {
      adjustLevels(&snsdefMinorSubs_snsdefInfred, "snsdefInfred");
      if (log && !findString("snsdefInfred", snsdefMinorSubs))
	{
	  warnSub("snsdefInfred", "snsdefMinor", a_snsdefMinor);
	  check_snsdefInfred(
	    dynamic_cast<snsdefInfred *>(a_snsdefMinor), 0);
	}
      else
	check_snsdefInfred(
	  dynamic_cast<snsdefInfred *>(a_snsdefMinor), log);
      return;
    }
  if (isA(a_snsdefMinor, snsdefNoncon))
    {
      adjustLevels(&snsdefMinorSubs_snsdefNoncon, "snsdefNoncon");
      if (log && !findString("snsdefNoncon", snsdefMinorSubs))
	{
	  warnSub("snsdefNoncon", "snsdefMinor", a_snsdefMinor);
	  check_snsdefNoncon(
	    dynamic_cast<snsdefNoncon *>(a_snsdefMinor), 0);
	}
      else
	check_snsdefNoncon(
	  dynamic_cast<snsdefNoncon *>(a_snsdefMinor), log);
      return;
    }
  if (isA(a_snsdefMinor, snsdefBuild))
    {
      adjustLevels(&snsdefMinorSubs_snsdefBuild, "snsdefBuild");
      if (log && !findString("snsdefBuild", snsdefMinorSubs))
	{
	  warnSub("snsdefBuild", "snsdefMinor", a_snsdefMinor);
	  check_snsdefBuild(dynamic_cast<snsdefBuild *>(a_snsdefMinor), 0);
	}
      else
	check_snsdefBuild(dynamic_cast<snsdefBuild *>(a_snsdefMinor), log);
      return;
    }
}

/********************************************************************/

void check_snsdefNoncon(
 snsdefNoncon * a_snsdefNoncon,
 int log)
{
  if (a_snsdefNoncon->get_snsdefType())
    {
      adjustLevels(&snsdefNonconAtts_a_snsdefType,
		   "snsdefNoncon a_snsdefType");
      if (log && !findString("a_snsdefType", snsdefNonconAtts))
	{
	  warnAtt("a_snsdefType", "snsdefNoncon", a_snsdefNoncon);
	  check_snsdefType(a_snsdefNoncon->get_snsdefType(), 0);
	}
      else
	check_snsdefType(a_snsdefNoncon->get_snsdefType(), log);
    }
  if (a_snsdefNoncon->get_snsdefLocation())
    {
      adjustLevels(&snsdefNonconAtts_a_snsdefLocation,
		   "snsdefNoncon a_snsdefLocation");
      if (log && !findString("a_snsdefLocation", snsdefNonconAtts))
	{
	  warnAtt("a_snsdefLocation", "snsdefNoncon", a_snsdefNoncon);
	  check_snsdefLocation(a_snsdefNoncon->get_snsdefLocation(), 0);
	}
      else
	check_snsdefLocation(a_snsdefNoncon->get_snsdefLocation(), log);
    }
  if (a_snsdefNoncon->get_numProbes())
    {
      adjustLevels(&snsdefNonconAtts_numProbes, "snsdefNoncon numProbes");
      if (log && !findString("numProbes", snsdefNonconAtts))
	{
	  warnAtt("numProbes", "snsdefNoncon", a_snsdefNoncon);
	  check_intVal(a_snsdefNoncon->get_numProbes(), 0);
	}
      else
	check_intVal(a_snsdefNoncon->get_numProbes(), log);
    }
}

/********************************************************************/

void check_snsdefProbe(
 snsdefProbe * a_snsdefProbe,
 int log)
{
  if (a_snsdefProbe->get_snsdefType())
    {
      adjustLevels(&snsdefProbeAtts_a_snsdefType, "snsdefProbe a_snsdefType");
      if (log && !findString("a_snsdefType", snsdefProbeAtts))
	{
	  warnAtt("a_snsdefType", "snsdefProbe", a_snsdefProbe);
	  check_snsdefType(a_snsdefProbe->get_snsdefType(), 0);
	}
      else
	check_snsdefType(a_snsdefProbe->get_snsdefType(), log);
    }
  if (a_snsdefProbe->get_probeLocation())
    {
      adjustLevels(&snsdefProbeAtts_a_probeLocation,
		   "snsdefProbe a_probeLocation");
      if (log && !findString("a_probeLocation", snsdefProbeAtts))
	{
	  warnAtt("a_probeLocation", "snsdefProbe", a_snsdefProbe);
	  check_probeLocation(a_snsdefProbe->get_probeLocation(), 0);
	}
      else
	check_probeLocation(a_snsdefProbe->get_probeLocation(), log);
    }
  if (a_snsdefProbe->get_diam())
    {
      adjustLevels(&snsdefProbeAtts_diam, "snsdefProbe diam");
      if (log && !findString("diam", snsdefProbeAtts))
	{
	  warnAtt("diam", "snsdefProbe", a_snsdefProbe);
	  check_rentVal(a_snsdefProbe->get_diam(), 0);
	}
      else
	check_rentVal(a_snsdefProbe->get_diam(), log);
    }
  if (a_snsdefProbe->get_snsdefProbeForm())
    {
      adjustLevels(&snsdefProbeAtts_a_snsdefProbeForm,
		   "snsdefProbe a_snsdefProbeForm");
      if (log && !findString("a_snsdefProbeForm", snsdefProbeAtts))
	{
	  warnAtt("a_snsdefProbeForm", "snsdefProbe", a_snsdefProbe);
	  check_snsdefProbeForm(a_snsdefProbe->get_snsdefProbeForm(), 0);
	}
      else
	check_snsdefProbeForm(a_snsdefProbe->get_snsdefProbeForm(), log);
    }
}

/********************************************************************/

void check_snsdefProbeForm(
 snsdefProbeForm * a_snsdefProbeForm,
 int log)
{
  if (isA(a_snsdefProbeForm, snsdefProbeForm_SPHERE))
    {
      adjustLevels(&snsdefProbeFormSubs_snsdefProbeForm_SPHERE,
		   "snsdefProbeForm_SPHERE");
      if (log && !findString("snsdefProbeForm_SPHERE", snsdefProbeFormSubs))
	{
	  warnSub("snsdefProbeForm_SPHERE", "snsdefProbeForm",
		  a_snsdefProbeForm);
	}
      return;
    }
  if (isA(a_snsdefProbeForm, snsdefProbeForm_CYLNDR))
    {
      adjustLevels(&snsdefProbeFormSubs_snsdefProbeForm_CYLNDR,
		   "snsdefProbeForm_CYLNDR");
      if (log && !findString("snsdefProbeForm_CYLNDR", snsdefProbeFormSubs))
	{
	  warnSub("snsdefProbeForm_CYLNDR", "snsdefProbeForm",
		  a_snsdefProbeForm);
	  check_snsdefProbeForm_CYLNDR(
	    dynamic_cast<snsdefProbeForm_CYLNDR *>(a_snsdefProbeForm), 0);
	}
      else
	check_snsdefProbeForm_CYLNDR(
	  dynamic_cast<snsdefProbeForm_CYLNDR *>(a_snsdefProbeForm), log);
      return;
    }
  if (isA(a_snsdefProbeForm, snsdefProbeForm_DISK))
    {
      adjustLevels(&snsdefProbeFormSubs_snsdefProbeForm_DISK,
		   "snsdefProbeForm_DISK");
      if (log && !findString("snsdefProbeForm_DISK", snsdefProbeFormSubs))
	{
	  warnSub("snsdefProbeForm_DISK", "snsdefProbeForm", a_snsdefProbeForm);
	  check_snsdefProbeForm_DISK(
	    dynamic_cast<snsdefProbeForm_DISK *>(a_snsdefProbeForm), 0);
	}
      else
	check_snsdefProbeForm_DISK(
	  dynamic_cast<snsdefProbeForm_DISK *>(a_snsdefProbeForm), log);
      return;
    }
}

/********************************************************************/

void check_snsdefProbeForm_CYLNDR(
 snsdefProbeForm_CYLNDR * a_snsdefProbeForm_CYLNDR,
 int log)
{
  if (a_snsdefProbeForm_CYLNDR->get_len2())
    {
      adjustLevels(&snsdefProbeForm_CYLNDRAtts_len2,
		   "snsdefProbeForm_CYLNDR len2");
      if (log && !findString("len2", snsdefProbeForm_CYLNDRAtts))
	{
	  warnAtt("len2", "snsdefProbeForm_CYLNDR", a_snsdefProbeForm_CYLNDR);
	  check_rentVal(a_snsdefProbeForm_CYLNDR->get_len2(), 0);
	}
      else
	check_rentVal(a_snsdefProbeForm_CYLNDR->get_len2(), log);
    }
}

/********************************************************************/

void check_snsdefProbeForm_DISK(
 snsdefProbeForm_DISK * a_snsdefProbeForm_DISK,
 int log)
{
  if (a_snsdefProbeForm_DISK->get_thkn())
    {
      adjustLevels(&snsdefProbeForm_DISKAtts_thkn,
		   "snsdefProbeForm_DISK thkn");
      if (log && !findString("thkn", snsdefProbeForm_DISKAtts))
	{
	  warnAtt("thkn", "snsdefProbeForm_DISK", a_snsdefProbeForm_DISK);
	  check_rentVal(a_snsdefProbeForm_DISK->get_thkn(), 0);
	}
      else
	check_rentVal(a_snsdefProbeForm_DISK->get_thkn(), log);
    }
}

/********************************************************************/

void check_snsdefStm(
 snsdefStm * a_snsdefStm,
 int log)
{
  if (a_snsdefStm->get_sLabel())
    {
      adjustLevels(&snsdefStmAtts_a_sLabel, "snsdefStm a_sLabel");
      if (log && !findString("a_sLabel", snsdefStmAtts))
	{
	  warnAtt("a_sLabel", "snsdefStm", a_snsdefStm);
	  check_sLabel(a_snsdefStm->get_sLabel(), 0);
	}
      else
	check_sLabel(a_snsdefStm->get_sLabel(), log);
    }
  if (a_snsdefStm->get_snsdefMinor())
    {
      adjustLevels(&snsdefStmAtts_a_snsdefMinor, "snsdefStm a_snsdefMinor");
      if (log && !findString("a_snsdefMinor", snsdefStmAtts))
	{
	  warnAtt("a_snsdefMinor", "snsdefStm", a_snsdefStm);
	  check_snsdefMinor(a_snsdefStm->get_snsdefMinor(), 0);
	}
      else
	check_snsdefMinor(a_snsdefStm->get_snsdefMinor(), log);
    }
}

/********************************************************************/

void check_snsdefType(
 snsdefType * a_snsdefType,
 int log)
{
  if (isA(a_snsdefType, snsdefType_FIXED))
    {
      adjustLevels(&snsdefTypeSubs_snsdefType_FIXED, "snsdefType_FIXED");
      if (log && !findString("snsdefType_FIXED", snsdefTypeSubs))
	{
	  warnSub("snsdefType_FIXED", "snsdefType", a_snsdefType);
	}
      return;
    }
  if (isA(a_snsdefType, snsdefType_INDEX))
    {
      adjustLevels(&snsdefTypeSubs_snsdefType_INDEX, "snsdefType_INDEX");
      if (log && !findString("snsdefType_INDEX", snsdefTypeSubs))
	{
	  warnSub("snsdefType_INDEX", "snsdefType", a_snsdefType);
	}
      return;
    }
}

/********************************************************************/

void check_snsdefVideo(
 snsdefVideo * a_snsdefVideo,
 int log)
{
  if (a_snsdefVideo->get_snsdefType())
    {
      adjustLevels(&snsdefVideoAtts_a_snsdefType, "snsdefVideo a_snsdefType");
      if (log && !findString("a_snsdefType", snsdefVideoAtts))
	{
	  warnAtt("a_snsdefType", "snsdefVideo", a_snsdefVideo);
	  check_snsdefType(a_snsdefVideo->get_snsdefType(), 0);
	}
      else
	check_snsdefType(a_snsdefVideo->get_snsdefType(), log);
    }
  if (a_snsdefVideo->get_snsdefLocation())
    {
      adjustLevels(&snsdefVideoAtts_a_snsdefLocation,
		   "snsdefVideo a_snsdefLocation");
      if (log && !findString("a_snsdefLocation", snsdefVideoAtts))
	{
	  warnAtt("a_snsdefLocation", "snsdefVideo", a_snsdefVideo);
	  check_snsdefLocation(a_snsdefVideo->get_snsdefLocation(), 0);
	}
      else
	check_snsdefLocation(a_snsdefVideo->get_snsdefLocation(), log);
    }
  if (a_snsdefVideo->get_focal())
    {
      adjustLevels(&snsdefVideoAtts_focal, "snsdefVideo focal");
      if (log && !findString("focal", snsdefVideoAtts))
	{
	  warnAtt("focal", "snsdefVideo", a_snsdefVideo);
	  check_rentVal(a_snsdefVideo->get_focal(), 0);
	}
      else
	check_rentVal(a_snsdefVideo->get_focal(), log);
    }
  if (a_snsdefVideo->get_mag())
    {
      adjustLevels(&snsdefVideoAtts_mag, "snsdefVideo mag");
      if (log && !findString("mag", snsdefVideoAtts))
	{
	  warnAtt("mag", "snsdefVideo", a_snsdefVideo);
	  check_rentVal(a_snsdefVideo->get_mag(), 0);
	}
      else
	check_rentVal(a_snsdefVideo->get_mag(), log);
    }
  if (a_snsdefVideo->get_apert())
    {
      adjustLevels(&snsdefVideoAtts_apert, "snsdefVideo apert");
      if (log && !findString("apert", snsdefVideoAtts))
	{
	  warnAtt("apert", "snsdefVideo", a_snsdefVideo);
	  check_rentVal(a_snsdefVideo->get_apert(), 0);
	}
      else
	check_rentVal(a_snsdefVideo->get_apert(), log);
    }
}

/********************************************************************/

void check_snsdefWristAngleItem(
 snsdefWristAngleItem * a_snsdefWristAngleItem,
 int log)
{
  if (a_snsdefWristAngleItem->get_anglename())
    {
      adjustLevels(&snsdefWristAngleItemAtts_anglename,
		   "snsdefWristAngleItem anglename");
      if (log && !findString("anglename", snsdefWristAngleItemAtts))
	{
	  warnAtt("anglename", "snsdefWristAngleItem",
		  a_snsdefWristAngleItem);
	  check_stringVal(a_snsdefWristAngleItem->get_anglename(), 0);
	}
      else
	check_stringVal(a_snsdefWristAngleItem->get_anglename(), log);
    }
  if (a_snsdefWristAngleItem->get_angle())
    {
      adjustLevels(&snsdefWristAngleItemAtts_a_angle,
		   "snsdefWristAngleItem a_angle");
      if (log && !findString("a_angle", snsdefWristAngleItemAtts))
	{
	  warnAtt("a_angle", "snsdefWristAngleItem", a_snsdefWristAngleItem);
	  check_angle(a_snsdefWristAngleItem->get_angle(), 0);
	}
      else
	check_angle(a_snsdefWristAngleItem->get_angle(), log);
    }
}

/********************************************************************/

void check_snsetFeat(
 snsetFeat * a_snsetFeat,
 int log)
{
  if (isA(a_snsetFeat, fLabel))
    {
      adjustLevels(&snsetFeatSubs_fLabel, "fLabel");
      if (log && !findString("fLabel", snsetFeatSubs))
	{
	  warnSub("fLabel", "snsetFeat", a_snsetFeat);
	  check_fLabel(dynamic_cast<fLabel *>(a_snsetFeat), 0);
	}
      else
	check_fLabel(dynamic_cast<fLabel *>(a_snsetFeat), log);
      return;
    }
  if (isA(a_snsetFeat, faLabel))
    {
      adjustLevels(&snsetFeatSubs_faLabel, "faLabel");
      if (log && !findString("faLabel", snsetFeatSubs))
	{
	  warnSub("faLabel", "snsetFeat", a_snsetFeat);
	  check_faLabel(dynamic_cast<faLabel *>(a_snsetFeat), 0);
	}
      else
	check_faLabel(dynamic_cast<faLabel *>(a_snsetFeat), log);
      return;
    }
  if (isA(a_snsetFeat, datLabel))
    {
      adjustLevels(&snsetFeatSubs_datLabel, "datLabel");
      if (log && !findString("datLabel", snsetFeatSubs))
	{
	  warnSub("datLabel", "snsetFeat", a_snsetFeat);
	  check_datLabel(dynamic_cast<datLabel *>(a_snsetFeat), 0);
	}
      else
	check_datLabel(dynamic_cast<datLabel *>(a_snsetFeat), log);
      return;
    }
}

/********************************************************************/

void check_snsetItem(
 snsetItem * a_snsetItem,
 int log)
{
  if (isA(a_snsetItem, snsetItem_snsetTypeAndValue))
    {
      adjustLevels(&snsetItemSubs_snsetItem_snsetTypeAndValue,
		   "snsetItem_snsetTypeAndValue");
      if (log && !findString("snsetItem_snsetTypeAndValue", snsetItemSubs))
	{
	  warnSub("snsetItem_snsetTypeAndValue", "snsetItem", a_snsetItem);
	  check_snsetItem_snsetTypeAndValue(
	    dynamic_cast<snsetItem_snsetTypeAndValue *>(a_snsetItem), 0);
	}
      else
	check_snsetItem_snsetTypeAndValue(
	  dynamic_cast<snsetItem_snsetTypeAndValue *>(a_snsetItem), log);
      return;
    }
  if (isA(a_snsetItem, snsetItem_snsetType))
    {
      adjustLevels(&snsetItemSubs_snsetItem_snsetType, "snsetItem_snsetType");
      if (log && !findString("snsetItem_snsetType", snsetItemSubs))
	{
	  warnSub("snsetItem_snsetType", "snsetItem", a_snsetItem);
	  check_snsetItem_snsetType(
	    dynamic_cast<snsetItem_snsetType *>(a_snsetItem), 0);
	}
      else
	check_snsetItem_snsetType(
	  dynamic_cast<snsetItem_snsetType *>(a_snsetItem), log);
      return;
    }
  if (isA(a_snsetItem, snsetItem_snsetLabelAndValue))
    {
      adjustLevels(&snsetItemSubs_snsetItem_snsetLabelAndValue,
		   "snsetItem_snsetLabelAndValue");
      if (log && !findString("snsetItem_snsetLabelAndValue", snsetItemSubs))
	{
	  warnSub("snsetItem_snsetLabelAndValue", "snsetItem", a_snsetItem);
	  check_snsetItem_snsetLabelAndValue(
	    dynamic_cast<snsetItem_snsetLabelAndValue *>(a_snsetItem), 0);
	}
      else
	check_snsetItem_snsetLabelAndValue(
	  dynamic_cast<snsetItem_snsetLabelAndValue *>(a_snsetItem), log);
      return;
    }
  if (isA(a_snsetItem, snsetItem_snsetLabel))
    {
      adjustLevels(&snsetItemSubs_snsetItem_snsetLabel,
		   "snsetItem_snsetLabel");
      if (log && !findString("snsetItem_snsetLabel", snsetItemSubs))
	{
	  warnSub("snsetItem_snsetLabel", "snsetItem", a_snsetItem);
	  check_snsetItem_snsetLabel(
	    dynamic_cast<snsetItem_snsetLabel *>(a_snsetItem), 0);
	}
      else
	check_snsetItem_snsetLabel(
	  dynamic_cast<snsetItem_snsetLabel *>(a_snsetItem), log);
      return;
    }
  if (isA(a_snsetItem, snsetItem_snsetToggle))
    {
      adjustLevels(&snsetItemSubs_snsetItem_snsetToggle,
		   "snsetItem_snsetToggle");
      if (log && !findString("snsetItem_snsetToggle", snsetItemSubs))
	{
	  warnSub("snsetItem_snsetToggle", "snsetItem", a_snsetItem);
	  check_snsetItem_snsetToggle(
	    dynamic_cast<snsetItem_snsetToggle *>(a_snsetItem), 0);
	}
      else
	check_snsetItem_snsetToggle(
	  dynamic_cast<snsetItem_snsetToggle *>(a_snsetItem), log);
      return;
    }
  if (isA(a_snsetItem, snsetItem_CLRSRF))
    {
      adjustLevels(&snsetItemSubs_snsetItem_CLRSRF, "snsetItem_CLRSRF");
      if (log && !findString("snsetItem_CLRSRF", snsetItemSubs))
	{
	  warnSub("snsetItem_CLRSRF", "snsetItem", a_snsetItem);
	  check_snsetItem_CLRSRF(
	    dynamic_cast<snsetItem_CLRSRF *>(a_snsetItem), 0);
	}
      else
	check_snsetItem_CLRSRF(
	  dynamic_cast<snsetItem_CLRSRF *>(a_snsetItem), log);
      return;
    }
  if (isA(a_snsetItem, snsetItem_DEPTH))
    {
      adjustLevels(&snsetItemSubs_snsetItem_DEPTH, "snsetItem_DEPTH");
      if (log && !findString("snsetItem_DEPTH", snsetItemSubs))
	{
	  warnSub("snsetItem_DEPTH", "snsetItem", a_snsetItem);
	  check_snsetItem_DEPTH(
	    dynamic_cast<snsetItem_DEPTH *>(a_snsetItem), 0);
	}
      else
	check_snsetItem_DEPTH(
	  dynamic_cast<snsetItem_DEPTH *>(a_snsetItem), log);
      return;
    }
}

/********************************************************************/

void check_snsetItem_CLRSRF(
 snsetItem_CLRSRF * a_snsetItem_CLRSRF,
 int log)
{
  if (a_snsetItem_CLRSRF->get_snsetFeat())
    {
      adjustLevels(&snsetItem_CLRSRFAtts_a_snsetFeat,
		   "snsetItem_CLRSRF a_snsetFeat");
      if (log && !findString("a_snsetFeat", snsetItem_CLRSRFAtts))
	{
	  warnAtt("a_snsetFeat", "snsetItem_CLRSRF", a_snsetItem_CLRSRF);
	  check_snsetFeat(a_snsetItem_CLRSRF->get_snsetFeat(), 0);
	}
      else
	check_snsetFeat(a_snsetItem_CLRSRF->get_snsetFeat(), log);
    }
  if (a_snsetItem_CLRSRF->get_dist())
    {
      adjustLevels(&snsetItem_CLRSRFAtts_dist, "snsetItem_CLRSRF dist");
      if (log && !findString("dist", snsetItem_CLRSRFAtts))
	{
	  warnAtt("dist", "snsetItem_CLRSRF", a_snsetItem_CLRSRF);
	  check_rentVal(a_snsetItem_CLRSRF->get_dist(), 0);
	}
      else
	check_rentVal(a_snsetItem_CLRSRF->get_dist(), log);
    }
}

/********************************************************************/

void check_snsetItem_DEPTH(
 snsetItem_DEPTH * a_snsetItem_DEPTH,
 int log)
{
  if (a_snsetItem_DEPTH->get_snsetFeat())
    {
      adjustLevels(&snsetItem_DEPTHAtts_a_snsetFeat,
		   "snsetItem_DEPTH a_snsetFeat");
      if (log && !findString("a_snsetFeat", snsetItem_DEPTHAtts))
	{
	  warnAtt("a_snsetFeat", "snsetItem_DEPTH", a_snsetItem_DEPTH);
	  check_snsetFeat(a_snsetItem_DEPTH->get_snsetFeat(), 0);
	}
      else
	check_snsetFeat(a_snsetItem_DEPTH->get_snsetFeat(), log);
    }
  if (a_snsetItem_DEPTH->get_dist())
    {
      adjustLevels(&snsetItem_DEPTHAtts_dist, "snsetItem_DEPTH dist");
      if (log && !findString("dist", snsetItem_DEPTHAtts))
	{
	  warnAtt("dist", "snsetItem_DEPTH", a_snsetItem_DEPTH);
	  check_rentVal(a_snsetItem_DEPTH->get_dist(), 0);
	}
      else
	check_rentVal(a_snsetItem_DEPTH->get_dist(), log);
    }
}

/********************************************************************/

void check_snsetItem_snsetLabel(
 snsetItem_snsetLabel * a_snsetItem_snsetLabel,
 int log)
{
  if (a_snsetItem_snsetLabel->get_snsetLabel())
    {
      adjustLevels(&snsetItem_snsetLabelAtts_a_snsetLabel,
		   "snsetItem_snsetLabel a_snsetLabel");
      if (log && !findString("a_snsetLabel", snsetItem_snsetLabelAtts))
	{
	  warnAtt("a_snsetLabel", "snsetItem_snsetLabel",
		  a_snsetItem_snsetLabel);
	  check_snsetLabel(a_snsetItem_snsetLabel->get_snsetLabel(), 0);
	}
      else
	check_snsetLabel(a_snsetItem_snsetLabel->get_snsetLabel(), log);
    }
}

/********************************************************************/

void check_snsetItem_snsetLabelAndValue(
 snsetItem_snsetLabelAndValue * a_snsetItem_snsetLabelAndValue,
 int log)
{
  if (a_snsetItem_snsetLabelAndValue->get_snsetLabelAndValue())
    {
      adjustLevels(&snsetItem_snsetLabelAndValueAtts_a_snsetLabelAndValue,
		   "snsetItem_snsetLabelAndValue a_snsetLabelAndValue");
      if (log && !findString("a_snsetLabelAndValue",
			     snsetItem_snsetLabelAndValueAtts))
	{
	  warnAtt("a_snsetLabelAndValue", "snsetItem_snsetLabelAndValue",
		  a_snsetItem_snsetLabelAndValue);
	  check_snsetLabelAndValue(
	    a_snsetItem_snsetLabelAndValue->get_snsetLabelAndValue(), 0);
	}
      else
	check_snsetLabelAndValue(
	  a_snsetItem_snsetLabelAndValue->get_snsetLabelAndValue(), log);
    }
}

/********************************************************************/

void check_snsetItem_snsetToggle(
 snsetItem_snsetToggle * a_snsetItem_snsetToggle,
 int log)
{
  if (a_snsetItem_snsetToggle->get_snsetToggle())
    {
      adjustLevels(&snsetItem_snsetToggleAtts_a_snsetToggle,
		   "snsetItem_snsetToggle a_snsetToggle");
      if (log && !findString("a_snsetToggle", snsetItem_snsetToggleAtts))
	{
	  warnAtt("a_snsetToggle", "snsetItem_snsetToggle",
		  a_snsetItem_snsetToggle);
	  check_snsetToggle(a_snsetItem_snsetToggle->get_snsetToggle(), 0);
	}
      else
	check_snsetToggle(a_snsetItem_snsetToggle->get_snsetToggle(), log);
    }
}

/********************************************************************/

void check_snsetItem_snsetType(
 snsetItem_snsetType * a_snsetItem_snsetType,
 int log)
{
  if (a_snsetItem_snsetType->get_snsetType())
    {
      adjustLevels(&snsetItem_snsetTypeAtts_a_snsetType,
		   "snsetItem_snsetType a_snsetType");
      if (log && !findString("a_snsetType", snsetItem_snsetTypeAtts))
	{
	  warnAtt("a_snsetType", "snsetItem_snsetType",
		  a_snsetItem_snsetType);
	  check_snsetType(a_snsetItem_snsetType->get_snsetType(), 0);
	}
      else
	check_snsetType(a_snsetItem_snsetType->get_snsetType(), log);
    }
}

/********************************************************************/

void check_snsetItem_snsetTypeAndValue(
 snsetItem_snsetTypeAndValue * a_snsetItem_snsetTypeAndValue,
 int log)
{
  if (a_snsetItem_snsetTypeAndValue->get_snsetTypeAndValue())
    {
      adjustLevels(&snsetItem_snsetTypeAndValueAtts_a_snsetTypeAndValue,
		   "snsetItem_snsetTypeAndValue a_snsetTypeAndValue");
      if (log && !findString("a_snsetTypeAndValue",
			     snsetItem_snsetTypeAndValueAtts))
	{
	  warnAtt("a_snsetTypeAndValue", "snsetItem_snsetTypeAndValue",
		  a_snsetItem_snsetTypeAndValue);
	  check_snsetTypeAndValue(
	    a_snsetItem_snsetTypeAndValue->get_snsetTypeAndValue(), 0);
	}
      else
	check_snsetTypeAndValue(
	  a_snsetItem_snsetTypeAndValue->get_snsetTypeAndValue(), log);
    }
}

/********************************************************************/

void check_snsetLabel(
 snsetLabel * a_snsetLabel,
 int log)
{
  if (isA(a_snsetLabel, vaLabel))
    {
      adjustLevels(&snsetLabelSubs_vaLabel, "vaLabel");
      if (log && !findString("vaLabel", snsetLabelSubs))
	{
	  warnSub("vaLabel", "snsetLabel", a_snsetLabel);
	  check_vaLabel(dynamic_cast<vaLabel *>(a_snsetLabel), 0);
	}
      else
	check_vaLabel(dynamic_cast<vaLabel *>(a_snsetLabel), log);
      return;
    }
  if (isA(a_snsetLabel, vfLabel))
    {
      adjustLevels(&snsetLabelSubs_vfLabel, "vfLabel");
      if (log && !findString("vfLabel", snsetLabelSubs))
	{
	  warnSub("vfLabel", "snsetLabel", a_snsetLabel);
	  check_vfLabel(dynamic_cast<vfLabel *>(a_snsetLabel), 0);
	}
      else
	check_vfLabel(dynamic_cast<vfLabel *>(a_snsetLabel), log);
      return;
    }
  if (isA(a_snsetLabel, vwLabel))
    {
      adjustLevels(&snsetLabelSubs_vwLabel, "vwLabel");
      if (log && !findString("vwLabel", snsetLabelSubs))
	{
	  warnSub("vwLabel", "snsetLabel", a_snsetLabel);
	  check_vwLabel(dynamic_cast<vwLabel *>(a_snsetLabel), 0);
	}
      else
	check_vwLabel(dynamic_cast<vwLabel *>(a_snsetLabel), log);
      return;
    }
}

/********************************************************************/

void check_snsetLabelAndValue(
 snsetLabelAndValue * a_snsetLabelAndValue,
 int log)
{
  if (a_snsetLabelAndValue->get_vlLabel())
    {
      adjustLevels(&snsetLabelAndValueAtts_a_vlLabel,
		   "snsetLabelAndValue a_vlLabel");
      if (log && !findString("a_vlLabel", snsetLabelAndValueAtts))
	{
	  warnAtt("a_vlLabel", "snsetLabelAndValue", a_snsetLabelAndValue);
	  check_vlLabel(a_snsetLabelAndValue->get_vlLabel(), 0);
	}
      else
	check_vlLabel(a_snsetLabelAndValue->get_vlLabel(), log);
    }
  if (a_snsetLabelAndValue->get_intnsty())
    {
      adjustLevels(&snsetLabelAndValueAtts_intnsty,
		   "snsetLabelAndValue intnsty");
      if (log && !findString("intnsty", snsetLabelAndValueAtts))
	{
	  warnAtt("intnsty", "snsetLabelAndValue", a_snsetLabelAndValue);
	  check_rentVal(a_snsetLabelAndValue->get_intnsty(), 0);
	}
      else
	check_rentVal(a_snsetLabelAndValue->get_intnsty(), log);
    }
}

/********************************************************************/

void check_snsetStm(
 snsetStm * a_snsetStm,
 int log)
{
  if (a_snsetStm->get_snsetItemList())
    {
      std::list<snsetItem *> * theList;
      std::list<snsetItem *>::iterator iter;
      theList = a_snsetStm->get_snsetItemList();
      adjustLevels(&snsetStmAtts_a_snsetItemList, "snsetStm a_snsetItemList");
      if (log && !findString("a_snsetItemList", snsetStmAtts))
	{
	  warnAtt("a_snsetItemList", "snsetStm", a_snsetStm);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_snsetItem(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_snsetItem(*iter, log);
	}
    }
}

/********************************************************************/

void check_snsetToggle(
 snsetToggle * a_snsetToggle,
 int log)
{
  if (isA(a_snsetToggle, snsetToggle_CLRSRF))
    {
      adjustLevels(&snsetToggleSubs_snsetToggle_CLRSRF, "snsetToggle_CLRSRF");
      if (log && !findString("snsetToggle_CLRSRF", snsetToggleSubs))
	{
	  warnSub("snsetToggle_CLRSRF", "snsetToggle", a_snsetToggle);
	}
      return;
    }
  if (isA(a_snsetToggle, snsetToggle_DEPTH))
    {
      adjustLevels(&snsetToggleSubs_snsetToggle_DEPTH, "snsetToggle_DEPTH");
      if (log && !findString("snsetToggle_DEPTH", snsetToggleSubs))
	{
	  warnSub("snsetToggle_DEPTH", "snsetToggle", a_snsetToggle);
	}
      return;
    }
}

/********************************************************************/

void check_snsetType(
 snsetType * a_snsetType,
 int log)
{
  if (isA(a_snsetType, snsetType_FOCUSY))
    {
      adjustLevels(&snsetTypeSubs_snsetType_FOCUSY, "snsetType_FOCUSY");
      if (log && !findString("snsetType_FOCUSY", snsetTypeSubs))
	{
	  warnSub("snsetType_FOCUSY", "snsetType", a_snsetType);
	}
      return;
    }
  if (isA(a_snsetType, snsetType_FOCUSN))
    {
      adjustLevels(&snsetTypeSubs_snsetType_FOCUSN, "snsetType_FOCUSN");
      if (log && !findString("snsetType_FOCUSN", snsetTypeSubs))
	{
	  warnSub("snsetType_FOCUSN", "snsetType", a_snsetType);
	}
      return;
    }
}

/********************************************************************/

void check_snsetTypeAndValue(
 snsetTypeAndValue * a_snsetTypeAndValue,
 int log)
{
  if (isA(a_snsetTypeAndValue, snsetTypeAndValue_APPRCH))
    {
      adjustLevels(&snsetTypeAndValueSubs_snsetTypeAndValue_APPRCH,
		   "snsetTypeAndValue_APPRCH");
      if (log && !findString("snsetTypeAndValue_APPRCH",
			     snsetTypeAndValueSubs))
	{
	  warnSub("snsetTypeAndValue_APPRCH", "snsetTypeAndValue",
		  a_snsetTypeAndValue);
	  check_snsetTypeAndValue_APPRCH(
	    dynamic_cast<snsetTypeAndValue_APPRCH *>(a_snsetTypeAndValue), 0);
	}
      else
	check_snsetTypeAndValue_APPRCH(
	  dynamic_cast<snsetTypeAndValue_APPRCH *>(a_snsetTypeAndValue), log);
      return;
    }
  if (isA(a_snsetTypeAndValue, snsetTypeAndValue_CLRSRF))
    {
      adjustLevels(&snsetTypeAndValueSubs_snsetTypeAndValue_CLRSRF,
		   "snsetTypeAndValue_CLRSRF");
      if (log && !findString("snsetTypeAndValue_CLRSRF",
			     snsetTypeAndValueSubs))
	{
	  warnSub("snsetTypeAndValue_CLRSRF", "snsetTypeAndValue",
		  a_snsetTypeAndValue);
	  check_snsetTypeAndValue_CLRSRF(
	    dynamic_cast<snsetTypeAndValue_CLRSRF *>(a_snsetTypeAndValue), 0);
	}
      else
	check_snsetTypeAndValue_CLRSRF(
	  dynamic_cast<snsetTypeAndValue_CLRSRF *>(a_snsetTypeAndValue), log);
      return;
    }
  if (isA(a_snsetTypeAndValue, snsetTypeAndValue_DEPTH))
    {
      adjustLevels(&snsetTypeAndValueSubs_snsetTypeAndValue_DEPTH,
		   "snsetTypeAndValue_DEPTH");
      if (log && !findString("snsetTypeAndValue_DEPTH", snsetTypeAndValueSubs))
	{
	  warnSub("snsetTypeAndValue_DEPTH", "snsetTypeAndValue",
		  a_snsetTypeAndValue);
	  check_snsetTypeAndValue_DEPTH(
	    dynamic_cast<snsetTypeAndValue_DEPTH *>(a_snsetTypeAndValue), 0);
	}
      else
	check_snsetTypeAndValue_DEPTH(
	  dynamic_cast<snsetTypeAndValue_DEPTH *>(a_snsetTypeAndValue), log);
      return;
    }
  if (isA(a_snsetTypeAndValue, snsetTypeAndValue_MINCON))
    {
      adjustLevels(&snsetTypeAndValueSubs_snsetTypeAndValue_MINCON,
		   "snsetTypeAndValue_MINCON");
      if (log && !findString("snsetTypeAndValue_MINCON",
			     snsetTypeAndValueSubs))
	{
	  warnSub("snsetTypeAndValue_MINCON", "snsetTypeAndValue",
		  a_snsetTypeAndValue);
	  check_snsetTypeAndValue_MINCON(
	    dynamic_cast<snsetTypeAndValue_MINCON *>(a_snsetTypeAndValue), 0);
	}
      else
	check_snsetTypeAndValue_MINCON(
	  dynamic_cast<snsetTypeAndValue_MINCON *>(a_snsetTypeAndValue), log);
      return;
    }
  if (isA(a_snsetTypeAndValue, snsetTypeAndValue_RETRCT))
    {
      adjustLevels(&snsetTypeAndValueSubs_snsetTypeAndValue_RETRCT,
		   "snsetTypeAndValue_RETRCT");
      if (log && !findString("snsetTypeAndValue_RETRCT",
			     snsetTypeAndValueSubs))
	{
	  warnSub("snsetTypeAndValue_RETRCT", "snsetTypeAndValue",
		  a_snsetTypeAndValue);
	  check_snsetTypeAndValue_RETRCT(
	    dynamic_cast<snsetTypeAndValue_RETRCT *>(a_snsetTypeAndValue), 0);
	}
      else
	check_snsetTypeAndValue_RETRCT(
	  dynamic_cast<snsetTypeAndValue_RETRCT *>(a_snsetTypeAndValue), log);
      return;
    }
  if (isA(a_snsetTypeAndValue, snsetTypeAndValue_SEARCH))
    {
      adjustLevels(&snsetTypeAndValueSubs_snsetTypeAndValue_SEARCH,
		   "snsetTypeAndValue_SEARCH");
      if (log && !findString("snsetTypeAndValue_SEARCH",
			     snsetTypeAndValueSubs))
	{
	  warnSub("snsetTypeAndValue_SEARCH", "snsetTypeAndValue",
		  a_snsetTypeAndValue);
	  check_snsetTypeAndValue_SEARCH(
	    dynamic_cast<snsetTypeAndValue_SEARCH *>(a_snsetTypeAndValue), 0);
	}
      else
	check_snsetTypeAndValue_SEARCH(
	  dynamic_cast<snsetTypeAndValue_SEARCH *>(a_snsetTypeAndValue), log);
      return;
    }
  if (isA(a_snsetTypeAndValue, snsetTypeAndValue_SCALEX))
    {
      adjustLevels(&snsetTypeAndValueSubs_snsetTypeAndValue_SCALEX,
		   "snsetTypeAndValue_SCALEX");
      if (log && !findString("snsetTypeAndValue_SCALEX",
			     snsetTypeAndValueSubs))
	{
	  warnSub("snsetTypeAndValue_SCALEX", "snsetTypeAndValue",
		  a_snsetTypeAndValue);
	  check_snsetTypeAndValue_SCALEX(
	    dynamic_cast<snsetTypeAndValue_SCALEX *>(a_snsetTypeAndValue), 0);
	}
      else
	check_snsetTypeAndValue_SCALEX(
	  dynamic_cast<snsetTypeAndValue_SCALEX *>(a_snsetTypeAndValue), log);
      return;
    }
  if (isA(a_snsetTypeAndValue, snsetTypeAndValue_SCALEY))
    {
      adjustLevels(&snsetTypeAndValueSubs_snsetTypeAndValue_SCALEY,
		   "snsetTypeAndValue_SCALEY");
      if (log && !findString("snsetTypeAndValue_SCALEY",
			     snsetTypeAndValueSubs))
	{
	  warnSub("snsetTypeAndValue_SCALEY", "snsetTypeAndValue",
		  a_snsetTypeAndValue);
	  check_snsetTypeAndValue_SCALEY(
	    dynamic_cast<snsetTypeAndValue_SCALEY *>(a_snsetTypeAndValue), 0);
	}
      else
	check_snsetTypeAndValue_SCALEY(
	  dynamic_cast<snsetTypeAndValue_SCALEY *>(a_snsetTypeAndValue), log);
      return;
    }
}

/********************************************************************/

void check_snsetTypeAndValue_APPRCH(
 snsetTypeAndValue_APPRCH * a_snsetTypeAndValue_APPRCH,
 int log)
{
  if (a_snsetTypeAndValue_APPRCH->get_dist())
    {
      adjustLevels(&snsetTypeAndValue_APPRCHAtts_dist,
		   "snsetTypeAndValue_APPRCH dist");
      if (log && !findString("dist", snsetTypeAndValue_APPRCHAtts))
	{
	  warnAtt("dist", "snsetTypeAndValue_APPRCH",
		  a_snsetTypeAndValue_APPRCH);
	  check_rentVal(a_snsetTypeAndValue_APPRCH->get_dist(), 0);
	}
      else
	check_rentVal(a_snsetTypeAndValue_APPRCH->get_dist(), log);
    }
}

/********************************************************************/

void check_snsetTypeAndValue_CLRSRF(
 snsetTypeAndValue_CLRSRF * a_snsetTypeAndValue_CLRSRF,
 int log)
{
  if (a_snsetTypeAndValue_CLRSRF->get_dist())
    {
      adjustLevels(&snsetTypeAndValue_CLRSRFAtts_dist,
		   "snsetTypeAndValue_CLRSRF dist");
      if (log && !findString("dist", snsetTypeAndValue_CLRSRFAtts))
	{
	  warnAtt("dist", "snsetTypeAndValue_CLRSRF",
		  a_snsetTypeAndValue_CLRSRF);
	  check_rentVal(a_snsetTypeAndValue_CLRSRF->get_dist(), 0);
	}
      else
	check_rentVal(a_snsetTypeAndValue_CLRSRF->get_dist(), log);
    }
}

/********************************************************************/

void check_snsetTypeAndValue_DEPTH(
 snsetTypeAndValue_DEPTH * a_snsetTypeAndValue_DEPTH,
 int log)
{
  if (a_snsetTypeAndValue_DEPTH->get_dist())
    {
      adjustLevels(&snsetTypeAndValue_DEPTHAtts_dist,
		   "snsetTypeAndValue_DEPTH dist");
      if (log && !findString("dist", snsetTypeAndValue_DEPTHAtts))
	{
	  warnAtt("dist", "snsetTypeAndValue_DEPTH",
		  a_snsetTypeAndValue_DEPTH);
	  check_rentVal(a_snsetTypeAndValue_DEPTH->get_dist(), 0);
	}
      else
	check_rentVal(a_snsetTypeAndValue_DEPTH->get_dist(), log);
    }
}

/********************************************************************/

void check_snsetTypeAndValue_MINCON(
 snsetTypeAndValue_MINCON * a_snsetTypeAndValue_MINCON,
 int log)
{
  if (a_snsetTypeAndValue_MINCON->get_level())
    {
      adjustLevels(&snsetTypeAndValue_MINCONAtts_level,
		   "snsetTypeAndValue_MINCON level");
      if (log && !findString("level", snsetTypeAndValue_MINCONAtts))
	{
	  warnAtt("level", "snsetTypeAndValue_MINCON",
		  a_snsetTypeAndValue_MINCON);
	  check_rentVal(a_snsetTypeAndValue_MINCON->get_level(), 0);
	}
      else
	check_rentVal(a_snsetTypeAndValue_MINCON->get_level(), log);
    }
}

/********************************************************************/

void check_snsetTypeAndValue_RETRCT(
 snsetTypeAndValue_RETRCT * a_snsetTypeAndValue_RETRCT,
 int log)
{
  if (a_snsetTypeAndValue_RETRCT->get_dist())
    {
      adjustLevels(&snsetTypeAndValue_RETRCTAtts_dist,
		   "snsetTypeAndValue_RETRCT dist");
      if (log && !findString("dist", snsetTypeAndValue_RETRCTAtts))
	{
	  warnAtt("dist", "snsetTypeAndValue_RETRCT",
		  a_snsetTypeAndValue_RETRCT);
	  check_rentVal(a_snsetTypeAndValue_RETRCT->get_dist(), 0);
	}
      else
	check_rentVal(a_snsetTypeAndValue_RETRCT->get_dist(), log);
    }
}

/********************************************************************/

void check_snsetTypeAndValue_SCALEX(
 snsetTypeAndValue_SCALEX * a_snsetTypeAndValue_SCALEX,
 int log)
{
  if (a_snsetTypeAndValue_SCALEX->get_scale())
    {
      adjustLevels(&snsetTypeAndValue_SCALEXAtts_scale,
		   "snsetTypeAndValue_SCALEX scale");
      if (log && !findString("scale", snsetTypeAndValue_SCALEXAtts))
	{
	  warnAtt("scale", "snsetTypeAndValue_SCALEX",
		  a_snsetTypeAndValue_SCALEX);
	  check_rentVal(a_snsetTypeAndValue_SCALEX->get_scale(), 0);
	}
      else
	check_rentVal(a_snsetTypeAndValue_SCALEX->get_scale(), log);
    }
}

/********************************************************************/

void check_snsetTypeAndValue_SCALEY(
 snsetTypeAndValue_SCALEY * a_snsetTypeAndValue_SCALEY,
 int log)
{
  if (a_snsetTypeAndValue_SCALEY->get_scale())
    {
      adjustLevels(&snsetTypeAndValue_SCALEYAtts_scale,
		   "snsetTypeAndValue_SCALEY scale");
      if (log && !findString("scale", snsetTypeAndValue_SCALEYAtts))
	{
	  warnAtt("scale", "snsetTypeAndValue_SCALEY",
		  a_snsetTypeAndValue_SCALEY);
	  check_rentVal(a_snsetTypeAndValue_SCALEY->get_scale(), 0);
	}
      else
	check_rentVal(a_snsetTypeAndValue_SCALEY->get_scale(), log);
    }
}

/********************************************************************/

void check_snsetTypeAndValue_SEARCH(
 snsetTypeAndValue_SEARCH * a_snsetTypeAndValue_SEARCH,
 int log)
{
  if (a_snsetTypeAndValue_SEARCH->get_dist())
    {
      adjustLevels(&snsetTypeAndValue_SEARCHAtts_dist,
		   "snsetTypeAndValue_SEARCH dist");
      if (log && !findString("dist", snsetTypeAndValue_SEARCHAtts))
	{
	  warnAtt("dist", "snsetTypeAndValue_SEARCH",
		  a_snsetTypeAndValue_SEARCH);
	  check_rentVal(a_snsetTypeAndValue_SEARCH->get_dist(), 0);
	}
      else
	check_rentVal(a_snsetTypeAndValue_SEARCH->get_dist(), log);
    }
}

/********************************************************************/

void check_snsgrpItem(
 snsgrpItem * a_snsgrpItem,
 int log)
{
  if (isA(a_snsgrpItem, sgLabel))
    {
      adjustLevels(&snsgrpItemSubs_sgLabel, "sgLabel");
      if (log && !findString("sgLabel", snsgrpItemSubs))
	{
	  warnSub("sgLabel", "snsgrpItem", a_snsgrpItem);
	  check_sgLabel(dynamic_cast<sgLabel *>(a_snsgrpItem), 0);
	}
      else
	check_sgLabel(dynamic_cast<sgLabel *>(a_snsgrpItem), log);
      return;
    }
  if (isA(a_snsgrpItem, swLabel))
    {
      adjustLevels(&snsgrpItemSubs_swLabel, "swLabel");
      if (log && !findString("swLabel", snsgrpItemSubs))
	{
	  warnSub("swLabel", "snsgrpItem", a_snsgrpItem);
	  check_swLabel(dynamic_cast<swLabel *>(a_snsgrpItem), 0);
	}
      else
	check_swLabel(dynamic_cast<swLabel *>(a_snsgrpItem), log);
      return;
    }
  if (isA(a_snsgrpItem, sxLabel))
    {
      adjustLevels(&snsgrpItemSubs_sxLabel, "sxLabel");
      if (log && !findString("sxLabel", snsgrpItemSubs))
	{
	  warnSub("sxLabel", "snsgrpItem", a_snsgrpItem);
	  check_sxLabel(dynamic_cast<sxLabel *>(a_snsgrpItem), 0);
	}
      else
	check_sxLabel(dynamic_cast<sxLabel *>(a_snsgrpItem), log);
      return;
    }
  if (isA(a_snsgrpItem, rmLabel))
    {
      adjustLevels(&snsgrpItemSubs_rmLabel, "rmLabel");
      if (log && !findString("rmLabel", snsgrpItemSubs))
	{
	  warnSub("rmLabel", "snsgrpItem", a_snsgrpItem);
	  check_rmLabel(dynamic_cast<rmLabel *>(a_snsgrpItem), 0);
	}
      else
	check_rmLabel(dynamic_cast<rmLabel *>(a_snsgrpItem), log);
      return;
    }
}

/********************************************************************/

void check_snsgrpMinor(
 snsgrpMinor * a_snsgrpMinor,
 int log)
{
  if (isA(a_snsgrpMinor, snsgrpMinor_ssLabel))
    {
      adjustLevels(&snsgrpMinorSubs_snsgrpMinor_ssLabel,
		   "snsgrpMinor_ssLabel");
      if (log && !findString("snsgrpMinor_ssLabel", snsgrpMinorSubs))
	{
	  warnSub("snsgrpMinor_ssLabel", "snsgrpMinor", a_snsgrpMinor);
	  check_snsgrpMinor_ssLabel(
	    dynamic_cast<snsgrpMinor_ssLabel *>(a_snsgrpMinor), 0);
	}
      else
	check_snsgrpMinor_ssLabel(
	  dynamic_cast<snsgrpMinor_ssLabel *>(a_snsgrpMinor), log);
      return;
    }
  if (isA(a_snsgrpMinor, snsgrpMinor_sgsLabel))
    {
      adjustLevels(&snsgrpMinorSubs_snsgrpMinor_sgsLabel,
		   "snsgrpMinor_sgsLabel");
      if (log && !findString("snsgrpMinor_sgsLabel", snsgrpMinorSubs))
	{
	  warnSub("snsgrpMinor_sgsLabel", "snsgrpMinor", a_snsgrpMinor);
	  check_snsgrpMinor_sgsLabel(
	    dynamic_cast<snsgrpMinor_sgsLabel *>(a_snsgrpMinor), 0);
	}
      else
	check_snsgrpMinor_sgsLabel(
	  dynamic_cast<snsgrpMinor_sgsLabel *>(a_snsgrpMinor), log);
      return;
    }
}

/********************************************************************/

void check_snsgrpMinor_sgsLabel(
 snsgrpMinor_sgsLabel * a_snsgrpMinor_sgsLabel,
 int log)
{
  if (a_snsgrpMinor_sgsLabel->get_snsgrpItemList())
    {
      std::list<snsgrpItem *> * theList;
      std::list<snsgrpItem *>::iterator iter;
      theList = a_snsgrpMinor_sgsLabel->get_snsgrpItemList();
      adjustLevels(&snsgrpMinor_sgsLabelAtts_a_snsgrpItemList,
		   "snsgrpMinor_sgsLabel a_snsgrpItemList");
      if (log && !findString("a_snsgrpItemList", snsgrpMinor_sgsLabelAtts))
	{
	  warnAtt("a_snsgrpItemList", "snsgrpMinor_sgsLabel",
		  a_snsgrpMinor_sgsLabel);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_snsgrpItem(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_snsgrpItem(*iter, log);
	}
    }
  if (a_snsgrpMinor_sgsLabel->get_sgsLabel())
    {
      adjustLevels(&snsgrpMinor_sgsLabelAtts_a_sgsLabel,
		   "snsgrpMinor_sgsLabel a_sgsLabel");
      if (log && !findString("a_sgsLabel", snsgrpMinor_sgsLabelAtts))
	{
	  warnAtt("a_sgsLabel", "snsgrpMinor_sgsLabel",
		  a_snsgrpMinor_sgsLabel);
	  check_sgsLabel(a_snsgrpMinor_sgsLabel->get_sgsLabel(), 0);
	}
      else
	check_sgsLabel(a_snsgrpMinor_sgsLabel->get_sgsLabel(), log);
    }
}

/********************************************************************/

void check_snsgrpMinor_ssLabel(
 snsgrpMinor_ssLabel * a_snsgrpMinor_ssLabel,
 int log)
{
  if (a_snsgrpMinor_ssLabel->get_snsgrpItemList())
    {
      std::list<snsgrpItem *> * theList;
      std::list<snsgrpItem *>::iterator iter;
      theList = a_snsgrpMinor_ssLabel->get_snsgrpItemList();
      adjustLevels(&snsgrpMinor_ssLabelAtts_a_snsgrpItemList,
		   "snsgrpMinor_ssLabel a_snsgrpItemList");
      if (log && !findString("a_snsgrpItemList", snsgrpMinor_ssLabelAtts))
	{
	  warnAtt("a_snsgrpItemList", "snsgrpMinor_ssLabel",
		  a_snsgrpMinor_ssLabel);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_snsgrpItem(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_snsgrpItem(*iter, log);
	}
    }
  if (a_snsgrpMinor_ssLabel->get_ssLabel())
    {
      adjustLevels(&snsgrpMinor_ssLabelAtts_a_ssLabel,
		   "snsgrpMinor_ssLabel a_ssLabel");
      if (log && !findString("a_ssLabel", snsgrpMinor_ssLabelAtts))
	{
	  warnAtt("a_ssLabel", "snsgrpMinor_ssLabel", a_snsgrpMinor_ssLabel);
	  check_ssLabel(a_snsgrpMinor_ssLabel->get_ssLabel(), 0);
	}
      else
	check_ssLabel(a_snsgrpMinor_ssLabel->get_ssLabel(), log);
    }
}

/********************************************************************/

void check_snsgrpStm(
 snsgrpStm * a_snsgrpStm,
 int log)
{
  if (a_snsgrpStm->get_sgsLabel())
    {
      adjustLevels(&snsgrpStmAtts_a_sgsLabel, "snsgrpStm a_sgsLabel");
      if (log && !findString("a_sgsLabel", snsgrpStmAtts))
	{
	  warnAtt("a_sgsLabel", "snsgrpStm", a_snsgrpStm);
	  check_sgsLabel(a_snsgrpStm->get_sgsLabel(), 0);
	}
      else
	check_sgsLabel(a_snsgrpStm->get_sgsLabel(), log);
    }
  if (a_snsgrpStm->get_snsgrpMinor())
    {
      adjustLevels(&snsgrpStmAtts_a_snsgrpMinor, "snsgrpStm a_snsgrpMinor");
      if (log && !findString("a_snsgrpMinor", snsgrpStmAtts))
	{
	  warnAtt("a_snsgrpMinor", "snsgrpStm", a_snsgrpStm);
	  check_snsgrpMinor(a_snsgrpStm->get_snsgrpMinor(), 0);
	}
      else
	check_snsgrpMinor(a_snsgrpStm->get_snsgrpMinor(), log);
    }
}

/********************************************************************/

void check_snslctData(
 snslctData * a_snslctData,
 int log)
{
  if (isA(a_snslctData, snslctData_snslctWristList))
    {
      adjustLevels(&snslctDataSubs_snslctData_snslctWristList,
		   "snslctData_snslctWristList");
      if (log && !findString("snslctData_snslctWristList", snslctDataSubs))
	{
	  warnSub("snslctData_snslctWristList", "snslctData", a_snslctData);
	  check_snslctData_snslctWristList(
	    dynamic_cast<snslctData_snslctWristList *>(a_snslctData), 0);
	}
      else
	check_snslctData_snslctWristList(
	  dynamic_cast<snslctData_snslctWristList *>(a_snslctData), log);
      return;
    }
  if (isA(a_snslctData, snslctData_probeOrient))
    {
      adjustLevels(&snslctDataSubs_snslctData_probeOrient,
		   "snslctData_probeOrient");
      if (log && !findString("snslctData_probeOrient", snslctDataSubs))
	{
	  warnSub("snslctData_probeOrient", "snslctData", a_snslctData);
	  check_snslctData_probeOrient(
	    dynamic_cast<snslctData_probeOrient *>(a_snslctData), 0);
	}
      else
	check_snslctData_probeOrient(
	  dynamic_cast<snslctData_probeOrient *>(a_snslctData), log);
      return;
    }
}

/********************************************************************/

void check_snslctData_probeOrient(
 snslctData_probeOrient * a_snslctData_probeOrient,
 int log)
{
  if (a_snslctData_probeOrient->get_probeOrient())
    {
      adjustLevels(&snslctData_probeOrientAtts_a_probeOrient,
		   "snslctData_probeOrient a_probeOrient");
      if (log && !findString("a_probeOrient", snslctData_probeOrientAtts))
	{
	  warnAtt("a_probeOrient", "snslctData_probeOrient",
		  a_snslctData_probeOrient);
	  check_probeOrient(a_snslctData_probeOrient->get_probeOrient(), 0);
	}
      else
	check_probeOrient(a_snslctData_probeOrient->get_probeOrient(), log);
    }
}

/********************************************************************/

void check_snslctData_snslctWristList(
 snslctData_snslctWristList * a_snslctData_snslctWristList,
 int log)
{
  if (a_snslctData_snslctWristList->get_snslctWristList())
    {
      std::list<snslctWristItem *> * theList;
      std::list<snslctWristItem *>::iterator iter;
      theList = a_snslctData_snslctWristList->get_snslctWristList();
      adjustLevels(&snslctData_snslctWristListAtts_a_snslctWristList,
		   "snslctData_snslctWristList a_snslctWristList");
      if (log && !findString("a_snslctWristList",
			     snslctData_snslctWristListAtts))
	{
	  warnAtt("a_snslctWristList", "snslctData_snslctWristList",
		  a_snslctData_snslctWristList);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_snslctWristItem(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_snslctWristItem(*iter, log);
	}
    }
}

/********************************************************************/

void check_snslctGroup(
 snslctGroup * a_snslctGroup,
 int log)
{
  if (isA(a_snslctGroup, snslctGroupFeat))
    {
      adjustLevels(&snslctGroupSubs_snslctGroupFeat, "snslctGroupFeat");
      if (log && !findString("snslctGroupFeat", snslctGroupSubs))
	{
	  warnSub("snslctGroupFeat", "snslctGroup", a_snslctGroup);
	  check_snslctGroupFeat(
	    dynamic_cast<snslctGroupFeat *>(a_snslctGroup), 0);
	}
      else
	check_snslctGroupFeat(
	  dynamic_cast<snslctGroupFeat *>(a_snslctGroup), log);
      return;
    }
  if (isA(a_snslctGroup, snslctGroupVec))
    {
      adjustLevels(&snslctGroupSubs_snslctGroupVec, "snslctGroupVec");
      if (log && !findString("snslctGroupVec", snslctGroupSubs))
	{
	  warnSub("snslctGroupVec", "snslctGroup", a_snslctGroup);
	  check_snslctGroupVec(
	    dynamic_cast<snslctGroupVec *>(a_snslctGroup), 0);
	}
      else
	check_snslctGroupVec(
	  dynamic_cast<snslctGroupVec *>(a_snslctGroup), log);
      return;
    }
}

/********************************************************************/

void check_snslctGroupFeat(
 snslctGroupFeat * a_snslctGroupFeat,
 int log)
{
  if (a_snslctGroupFeat->get_gsaLabel())
    {
      adjustLevels(&snslctGroupFeatAtts_a_gsaLabel,
		   "snslctGroupFeat a_gsaLabel");
      if (log && !findString("a_gsaLabel", snslctGroupFeatAtts))
	{
	  warnAtt("a_gsaLabel", "snslctGroupFeat", a_snslctGroupFeat);
	  check_gsaLabel(a_snslctGroupFeat->get_gsaLabel(), 0);
	}
      else
	check_gsaLabel(a_snslctGroupFeat->get_gsaLabel(), log);
    }
  if (a_snslctGroupFeat->get_featureLabel())
    {
      adjustLevels(&snslctGroupFeatAtts_a_featureLabel,
		   "snslctGroupFeat a_featureLabel");
      if (log && !findString("a_featureLabel", snslctGroupFeatAtts))
	{
	  warnAtt("a_featureLabel", "snslctGroupFeat", a_snslctGroupFeat);
	  check_featureLabel(a_snslctGroupFeat->get_featureLabel(), 0);
	}
      else
	check_featureLabel(a_snslctGroupFeat->get_featureLabel(), log);
    }
  if (a_snslctGroupFeat->get_angle())
    {
      adjustLevels(&snslctGroupFeatAtts_a_angle, "snslctGroupFeat a_angle");
      if (log && !findString("a_angle", snslctGroupFeatAtts))
	{
	  warnAtt("a_angle", "snslctGroupFeat", a_snslctGroupFeat);
	  check_angle(a_snslctGroupFeat->get_angle(), 0);
	}
      else
	check_angle(a_snslctGroupFeat->get_angle(), log);
    }
}

/********************************************************************/

void check_snslctGroupVec(
 snslctGroupVec * a_snslctGroupVec,
 int log)
{
  if (a_snslctGroupVec->get_gsaLabel())
    {
      adjustLevels(&snslctGroupVecAtts_a_gsaLabel,
		   "snslctGroupVec a_gsaLabel");
      if (log && !findString("a_gsaLabel", snslctGroupVecAtts))
	{
	  warnAtt("a_gsaLabel", "snslctGroupVec", a_snslctGroupVec);
	  check_gsaLabel(a_snslctGroupVec->get_gsaLabel(), 0);
	}
      else
	check_gsaLabel(a_snslctGroupVec->get_gsaLabel(), log);
    }
  if (a_snslctGroupVec->get_dir())
    {
      adjustLevels(&snslctGroupVecAtts_dir, "snslctGroupVec dir");
      if (log && !findString("dir", snslctGroupVecAtts))
	{
	  warnAtt("dir", "snslctGroupVec", a_snslctGroupVec);
	  check_vector(a_snslctGroupVec->get_dir(), 0);
	}
      else
	check_vector(a_snslctGroupVec->get_dir(), log);
    }
  if (a_snslctGroupVec->get_angle())
    {
      adjustLevels(&snslctGroupVecAtts_a_angle, "snslctGroupVec a_angle");
      if (log && !findString("a_angle", snslctGroupVecAtts))
	{
	  warnAtt("a_angle", "snslctGroupVec", a_snslctGroupVec);
	  check_angle(a_snslctGroupVec->get_angle(), 0);
	}
      else
	check_angle(a_snslctGroupVec->get_angle(), log);
    }
}

/********************************************************************/

void check_snslctSensor(
 snslctSensor * a_snslctSensor,
 int log)
{
  if (isA(a_snslctSensor, snslctSensorTip))
    {
      adjustLevels(&snslctSensorSubs_snslctSensorTip, "snslctSensorTip");
      if (log && !findString("snslctSensorTip", snslctSensorSubs))
	{
	  warnSub("snslctSensorTip", "snslctSensor", a_snslctSensor);
	  check_snslctSensorTip(
	    dynamic_cast<snslctSensorTip *>(a_snslctSensor), 0);
	}
      else
	check_snslctSensorTip(
	  dynamic_cast<snslctSensorTip *>(a_snslctSensor), log);
      return;
    }
  if (isA(a_snslctSensor, snslctSensorList))
    {
      adjustLevels(&snslctSensorSubs_snslctSensorList, "snslctSensorList");
      if (log && !findString("snslctSensorList", snslctSensorSubs))
	{
	  warnSub("snslctSensorList", "snslctSensor", a_snslctSensor);
	  check_snslctSensorList(
	    dynamic_cast<snslctSensorList *>(a_snslctSensor), 0);
	}
      else
	check_snslctSensorList(
	  dynamic_cast<snslctSensorList *>(a_snslctSensor), log);
      return;
    }
}

/********************************************************************/

void check_snslctSensorList(
 snslctSensorList * a_snslctSensorList,
 int log)
{
  if (a_snslctSensorList->get_sensorLabel2())
    {
      adjustLevels(&snslctSensorListAtts_a_sensorLabel2,
		   "snslctSensorList a_sensorLabel2");
      if (log && !findString("a_sensorLabel2", snslctSensorListAtts))
	{
	  warnAtt("a_sensorLabel2", "snslctSensorList", a_snslctSensorList);
	  check_sensorLabel2(a_snslctSensorList->get_sensorLabel2(), 0);
	}
      else
	check_sensorLabel2(a_snslctSensorList->get_sensorLabel2(), log);
    }
  if (a_snslctSensorList->get_sensorList())
    {
      std::list<sensorLabel2 *> * theList;
      std::list<sensorLabel2 *>::iterator iter;
      theList = a_snslctSensorList->get_sensorList();
      adjustLevels(&snslctSensorListAtts_a_sensorList,
		   "snslctSensorList a_sensorList");
      if (log && !findString("a_sensorList", snslctSensorListAtts))
	{
	  warnAtt("a_sensorList", "snslctSensorList", a_snslctSensorList);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_sensorLabel2(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_sensorLabel2(*iter, log);
	}
    }
}

/********************************************************************/

void check_snslctSensorTip(
 snslctSensorTip * a_snslctSensorTip,
 int log)
{
  if (a_snslctSensorTip->get_sensorLabel2())
    {
      adjustLevels(&snslctSensorTipAtts_a_sensorLabel2,
		   "snslctSensorTip a_sensorLabel2");
      if (log && !findString("a_sensorLabel2", snslctSensorTipAtts))
	{
	  warnAtt("a_sensorLabel2", "snslctSensorTip", a_snslctSensorTip);
	  check_sensorLabel2(a_snslctSensorTip->get_sensorLabel2(), 0);
	}
      else
	check_sensorLabel2(a_snslctSensorTip->get_sensorLabel2(), log);
    }
  if (a_snslctSensorTip->get_snslctTipData())
    {
      adjustLevels(&snslctSensorTipAtts_a_snslctTipData,
		   "snslctSensorTip a_snslctTipData");
      if (log && !findString("a_snslctTipData", snslctSensorTipAtts))
	{
	  warnAtt("a_snslctTipData", "snslctSensorTip", a_snslctSensorTip);
	  check_snslctTipData(a_snslctSensorTip->get_snslctTipData(), 0);
	}
      else
	check_snslctTipData(a_snslctSensorTip->get_snslctTipData(), log);
    }
  if (a_snslctSensorTip->get_snslctData())
    {
      adjustLevels(&snslctSensorTipAtts_a_snslctData,
		   "snslctSensorTip a_snslctData");
      if (log && !findString("a_snslctData", snslctSensorTipAtts))
	{
	  warnAtt("a_snslctData", "snslctSensorTip", a_snslctSensorTip);
	  check_snslctData(a_snslctSensorTip->get_snslctData(), 0);
	}
      else
	check_snslctData(a_snslctSensorTip->get_snslctData(), log);
    }
}

/********************************************************************/

void check_snslctStm(
 snslctStm * a_snslctStm,
 int log)
{
  if (isA(a_snslctStm, snslctStmSensor))
    {
      adjustLevels(&snslctStmSubs_snslctStmSensor, "snslctStmSensor");
      if (log && !findString("snslctStmSensor", snslctStmSubs))
	{
	  warnSub("snslctStmSensor", "snslctStm", a_snslctStm);
	  check_snslctStmSensor(
	    dynamic_cast<snslctStmSensor *>(a_snslctStm), 0);
	}
      else
	check_snslctStmSensor(
	  dynamic_cast<snslctStmSensor *>(a_snslctStm), log);
      return;
    }
  if (isA(a_snslctStm, snslctStmGroup))
    {
      adjustLevels(&snslctStmSubs_snslctStmGroup, "snslctStmGroup");
      if (log && !findString("snslctStmGroup", snslctStmSubs))
	{
	  warnSub("snslctStmGroup", "snslctStm", a_snslctStm);
	  check_snslctStmGroup(
	    dynamic_cast<snslctStmGroup *>(a_snslctStm), 0);
	}
      else
	check_snslctStmGroup(
	  dynamic_cast<snslctStmGroup *>(a_snslctStm), log);
      return;
    }
}

/********************************************************************/

void check_snslctStmGroup(
 snslctStmGroup * a_snslctStmGroup,
 int log)
{
  if (a_snslctStmGroup->get_snslctGroup())
    {
      adjustLevels(&snslctStmGroupAtts_a_snslctGroup,
		   "snslctStmGroup a_snslctGroup");
      if (log && !findString("a_snslctGroup", snslctStmGroupAtts))
	{
	  warnAtt("a_snslctGroup", "snslctStmGroup", a_snslctStmGroup);
	  check_snslctGroup(a_snslctStmGroup->get_snslctGroup(), 0);
	}
      else
	check_snslctGroup(a_snslctStmGroup->get_snslctGroup(), log);
    }
}

/********************************************************************/

void check_snslctStmSensor(
 snslctStmSensor * a_snslctStmSensor,
 int log)
{
  if (a_snslctStmSensor->get_snslctSensor())
    {
      adjustLevels(&snslctStmSensorAtts_a_snslctSensor,
		   "snslctStmSensor a_snslctSensor");
      if (log && !findString("a_snslctSensor", snslctStmSensorAtts))
	{
	  warnAtt("a_snslctSensor", "snslctStmSensor", a_snslctStmSensor);
	  check_snslctSensor(a_snslctStmSensor->get_snslctSensor(), 0);
	}
      else
	check_snslctSensor(a_snslctStmSensor->get_snslctSensor(), log);
    }
}

/********************************************************************/

void check_snslctTipData(
 snslctTipData * a_snslctTipData,
 int log)
{
  if (isA(a_snslctTipData, stringVal))
    {
      adjustLevels(&snslctTipDataSubs_stringVal, "stringVal");
      if (log && !findString("stringVal", snslctTipDataSubs))
	{
	  warnSub("stringVal", "snslctTipData", a_snslctTipData);
	  check_stringVal(dynamic_cast<stringVal *>(a_snslctTipData), 0);
	}
      else
	check_stringVal(dynamic_cast<stringVal *>(a_snslctTipData), log);
      return;
    }
  if (isA(a_snslctTipData, intVal))
    {
      adjustLevels(&snslctTipDataSubs_intVal, "intVal");
      if (log && !findString("intVal", snslctTipDataSubs))
	{
	  warnSub("intVal", "snslctTipData", a_snslctTipData);
	  check_intVal(dynamic_cast<intVal *>(a_snslctTipData), 0);
	}
      else
	check_intVal(dynamic_cast<intVal *>(a_snslctTipData), log);
      return;
    }
}

/********************************************************************/

void check_snslctWristAngleAngle(
 snslctWristAngleAngle * a_snslctWristAngleAngle,
 int log)
{
  if (a_snslctWristAngleAngle->get_anglename())
    {
      adjustLevels(&snslctWristAngleAngleAtts_anglename,
		   "snslctWristAngleAngle anglename");
      if (log && !findString("anglename", snslctWristAngleAngleAtts))
	{
	  warnAtt("anglename", "snslctWristAngleAngle",
		  a_snslctWristAngleAngle);
	  check_stringVal(a_snslctWristAngleAngle->get_anglename(), 0);
	}
      else
	check_stringVal(a_snslctWristAngleAngle->get_anglename(), log);
    }
  if (a_snslctWristAngleAngle->get_angle())
    {
      adjustLevels(&snslctWristAngleAngleAtts_a_angle,
		   "snslctWristAngleAngle a_angle");
      if (log && !findString("a_angle", snslctWristAngleAngleAtts))
	{
	  warnAtt("a_angle", "snslctWristAngleAngle",
		  a_snslctWristAngleAngle);
	  check_angle(a_snslctWristAngleAngle->get_angle(), 0);
	}
      else
	check_angle(a_snslctWristAngleAngle->get_angle(), log);
    }
}

/********************************************************************/

void check_snslctWristAngleFeat(
 snslctWristAngleFeat * a_snslctWristAngleFeat,
 int log)
{
  if (a_snslctWristAngleFeat->get_anglename())
    {
      adjustLevels(&snslctWristAngleFeatAtts_anglename,
		   "snslctWristAngleFeat anglename");
      if (log && !findString("anglename", snslctWristAngleFeatAtts))
	{
	  warnAtt("anglename", "snslctWristAngleFeat",
		  a_snslctWristAngleFeat);
	  check_stringVal(a_snslctWristAngleFeat->get_anglename(), 0);
	}
      else
	check_stringVal(a_snslctWristAngleFeat->get_anglename(), log);
    }
  if (a_snslctWristAngleFeat->get_featureLabel())
    {
      adjustLevels(&snslctWristAngleFeatAtts_a_featureLabel,
		   "snslctWristAngleFeat a_featureLabel");
      if (log && !findString("a_featureLabel", snslctWristAngleFeatAtts))
	{
	  warnAtt("a_featureLabel", "snslctWristAngleFeat",
		  a_snslctWristAngleFeat);
	  check_featureLabel(a_snslctWristAngleFeat->get_featureLabel(), 0);
	}
      else
	check_featureLabel(a_snslctWristAngleFeat->get_featureLabel(), log);
    }
  if (a_snslctWristAngleFeat->get_angle())
    {
      adjustLevels(&snslctWristAngleFeatAtts_a_angle,
		   "snslctWristAngleFeat a_angle");
      if (log && !findString("a_angle", snslctWristAngleFeatAtts))
	{
	  warnAtt("a_angle", "snslctWristAngleFeat", a_snslctWristAngleFeat);
	  check_angle(a_snslctWristAngleFeat->get_angle(), 0);
	}
      else
	check_angle(a_snslctWristAngleFeat->get_angle(), log);
    }
}

/********************************************************************/

void check_snslctWristAngleItem(
 snslctWristAngleItem * a_snslctWristAngleItem,
 int log)
{
  if (isA(a_snslctWristAngleItem, snslctWristAngleAngle))
    {
      adjustLevels(&snslctWristAngleItemSubs_snslctWristAngleAngle,
		   "snslctWristAngleAngle");
      if (log && !findString("snslctWristAngleAngle",
			     snslctWristAngleItemSubs))
	{
	  warnSub("snslctWristAngleAngle", "snslctWristAngleItem",
		  a_snslctWristAngleItem);
	  check_snslctWristAngleAngle(
	    dynamic_cast<snslctWristAngleAngle *>(a_snslctWristAngleItem), 0);
	}
      else
	check_snslctWristAngleAngle(
	  dynamic_cast<snslctWristAngleAngle *>(a_snslctWristAngleItem), log);
      return;
    }
  if (isA(a_snslctWristAngleItem, snslctWristAngleFeat))
    {
      adjustLevels(&snslctWristAngleItemSubs_snslctWristAngleFeat,
		   "snslctWristAngleFeat");
      if (log && !findString("snslctWristAngleFeat", snslctWristAngleItemSubs))
	{
	  warnSub("snslctWristAngleFeat", "snslctWristAngleItem",
		  a_snslctWristAngleItem);
	  check_snslctWristAngleFeat(
	    dynamic_cast<snslctWristAngleFeat *>(a_snslctWristAngleItem), 0);
	}
      else
	check_snslctWristAngleFeat(
	  dynamic_cast<snslctWristAngleFeat *>(a_snslctWristAngleItem), log);
      return;
    }
  if (isA(a_snslctWristAngleItem, snslctWristAngleVec))
    {
      adjustLevels(&snslctWristAngleItemSubs_snslctWristAngleVec,
		   "snslctWristAngleVec");
      if (log && !findString("snslctWristAngleVec", snslctWristAngleItemSubs))
	{
	  warnSub("snslctWristAngleVec", "snslctWristAngleItem",
		  a_snslctWristAngleItem);
	  check_snslctWristAngleVec(
	    dynamic_cast<snslctWristAngleVec *>(a_snslctWristAngleItem), 0);
	}
      else
	check_snslctWristAngleVec(
	  dynamic_cast<snslctWristAngleVec *>(a_snslctWristAngleItem), log);
      return;
    }
}

/********************************************************************/

void check_snslctWristAngleVec(
 snslctWristAngleVec * a_snslctWristAngleVec,
 int log)
{
  if (a_snslctWristAngleVec->get_anglename())
    {
      adjustLevels(&snslctWristAngleVecAtts_anglename,
		   "snslctWristAngleVec anglename");
      if (log && !findString("anglename", snslctWristAngleVecAtts))
	{
	  warnAtt("anglename", "snslctWristAngleVec", a_snslctWristAngleVec);
	  check_stringVal(a_snslctWristAngleVec->get_anglename(), 0);
	}
      else
	check_stringVal(a_snslctWristAngleVec->get_anglename(), log);
    }
  if (a_snslctWristAngleVec->get_dir())
    {
      adjustLevels(&snslctWristAngleVecAtts_dir, "snslctWristAngleVec dir");
      if (log && !findString("dir", snslctWristAngleVecAtts))
	{
	  warnAtt("dir", "snslctWristAngleVec", a_snslctWristAngleVec);
	  check_vector(a_snslctWristAngleVec->get_dir(), 0);
	}
      else
	check_vector(a_snslctWristAngleVec->get_dir(), log);
    }
  if (a_snslctWristAngleVec->get_angle())
    {
      adjustLevels(&snslctWristAngleVecAtts_a_angle,
		   "snslctWristAngleVec a_angle");
      if (log && !findString("a_angle", snslctWristAngleVecAtts))
	{
	  warnAtt("a_angle", "snslctWristAngleVec", a_snslctWristAngleVec);
	  check_angle(a_snslctWristAngleVec->get_angle(), 0);
	}
      else
	check_angle(a_snslctWristAngleVec->get_angle(), log);
    }
}

/********************************************************************/

void check_snslctWristItem(
 snslctWristItem * a_snslctWristItem,
 int log)
{
  if (a_snslctWristItem->get_swLabel())
    {
      adjustLevels(&snslctWristItemAtts_a_swLabel,
		   "snslctWristItem a_swLabel");
      if (log && !findString("a_swLabel", snslctWristItemAtts))
	{
	  warnAtt("a_swLabel", "snslctWristItem", a_snslctWristItem);
	  check_swLabel(a_snslctWristItem->get_swLabel(), 0);
	}
      else
	check_swLabel(a_snslctWristItem->get_swLabel(), log);
    }
  if (a_snslctWristItem->get_snslctWristAngleList())
    {
      std::list<snslctWristAngleItem *> * theList;
      std::list<snslctWristAngleItem *>::iterator iter;
      theList = a_snslctWristItem->get_snslctWristAngleList();
      adjustLevels(&snslctWristItemAtts_a_snslctWristAngleList,
		   "snslctWristItem a_snslctWristAngleList");
      if (log && !findString("a_snslctWristAngleList", snslctWristItemAtts))
	{
	  warnAtt("a_snslctWristAngleList", "snslctWristItem",
		  a_snslctWristItem);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_snslctWristAngleItem(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_snslctWristAngleItem(*iter, log);
	}
    }
}

/********************************************************************/

void check_snsmntMinor(
 snsmntMinor * a_snsmntMinor,
 int log)
{
  if (a_snsmntMinor->get_xVec())
    {
      adjustLevels(&snsmntMinorAtts_xVec, "snsmntMinor xVec");
      if (log && !findString("xVec", snsmntMinorAtts))
	{
	  warnAtt("xVec", "snsmntMinor", a_snsmntMinor);
	  check_vector(a_snsmntMinor->get_xVec(), 0);
	}
      else
	check_vector(a_snsmntMinor->get_xVec(), log);
    }
  if (a_snsmntMinor->get_zVec())
    {
      adjustLevels(&snsmntMinorAtts_zVec, "snsmntMinor zVec");
      if (log && !findString("zVec", snsmntMinorAtts))
	{
	  warnAtt("zVec", "snsmntMinor", a_snsmntMinor);
	  check_vector(a_snsmntMinor->get_zVec(), 0);
	}
      else
	check_vector(a_snsmntMinor->get_zVec(), log);
    }
  if (a_snsmntMinor->get_distVec())
    {
      adjustLevels(&snsmntMinorAtts_distVec, "snsmntMinor distVec");
      if (log && !findString("distVec", snsmntMinorAtts))
	{
	  warnAtt("distVec", "snsmntMinor", a_snsmntMinor);
	  check_vector(a_snsmntMinor->get_distVec(), 0);
	}
      else
	check_vector(a_snsmntMinor->get_distVec(), log);
    }
}

/********************************************************************/

void check_snsmntStm(
 snsmntStm * a_snsmntStm,
 int log)
{
  if (a_snsmntStm->get_snsmntMinor())
    {
      adjustLevels(&snsmntStmAtts_a_snsmntMinor, "snsmntStm a_snsmntMinor");
      if (log && !findString("a_snsmntMinor", snsmntStmAtts))
	{
	  warnAtt("a_snsmntMinor", "snsmntStm", a_snsmntStm);
	  check_snsmntMinor(a_snsmntStm->get_snsmntMinor(), 0);
	}
      else
	check_snsmntMinor(a_snsmntStm->get_snsmntMinor(), log);
    }
}

/********************************************************************/

void check_spartConst(
 spartConst * a_spartConst,
 int log)
{
  if (a_spartConst->get_featureActualList())
    {
      std::list<faLabel *> * theList;
      std::list<faLabel *>::iterator iter;
      theList = a_spartConst->get_featureActualList();
      adjustLevels(&spartConstAtts_a_featureActualList,
		   "spartConst a_featureActualList");
      if (log && !findString("a_featureActualList", spartConstAtts))
	{
	  warnAtt("a_featureActualList", "spartConst", a_spartConst);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_faLabel(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_faLabel(*iter, log);
	}
    }
}

/********************************************************************/

void check_srLabel(
 srLabel * a_srLabel,
 int log)
{
  if (a_srLabel->get_labelName())
    {
      adjustLevels(&srLabelAtts_a_labelName, "srLabel a_labelName");
      if (log && !findString("a_labelName", srLabelAtts))
	{
	  warnAtt("a_labelName", "srLabel", a_srLabel);
	  check_labelName(a_srLabel->get_labelName(), 0);
	}
      else
	check_labelName(a_srLabel->get_labelName(), log);
    }
}

/********************************************************************/

void check_sraLabel(
 sraLabel * a_sraLabel,
 int log)
{
  if (a_sraLabel->get_labelName())
    {
      adjustLevels(&sraLabelAtts_a_labelName, "sraLabel a_labelName");
      if (log && !findString("a_labelName", sraLabelAtts))
	{
	  warnAtt("a_labelName", "sraLabel", a_sraLabel);
	  check_labelName(a_sraLabel->get_labelName(), 0);
	}
      else
	check_labelName(a_sraLabel->get_labelName(), log);
    }
}

/********************************************************************/

void check_ssLabel(
 ssLabel * a_ssLabel,
 int log)
{
  if (a_ssLabel->get_labelName())
    {
      adjustLevels(&ssLabelAtts_a_labelName, "ssLabel a_labelName");
      if (log && !findString("a_labelName", ssLabelAtts))
	{
	  warnAtt("a_labelName", "ssLabel", a_ssLabel);
	  check_labelName(a_ssLabel->get_labelName(), 0);
	}
      else
	check_labelName(a_ssLabel->get_labelName(), log);
    }
}

/********************************************************************/

void check_stLabel(
 stLabel * a_stLabel,
 int log)
{
  if (a_stLabel->get_labelName())
    {
      adjustLevels(&stLabelAtts_a_labelName, "stLabel a_labelName");
      if (log && !findString("a_labelName", stLabelAtts))
	{
	  warnAtt("a_labelName", "stLabel", a_stLabel);
	  check_labelName(a_stLabel->get_labelName(), 0);
	}
      else
	check_labelName(a_stLabel->get_labelName(), log);
    }
}

/********************************************************************/

void check_stackElement(
 stackElement * a_stackElement,
 int log)
{
  if (isA(a_stackElement, stackElement_ALGOR))
    {
      adjustLevels(&stackElementSubs_stackElement_ALGOR, "stackElement_ALGOR");
      if (log && !findString("stackElement_ALGOR", stackElementSubs))
	{
	  warnSub("stackElement_ALGOR", "stackElement", a_stackElement);
	}
      return;
    }
  if (isA(a_stackElement, stackElement_DME))
    {
      adjustLevels(&stackElementSubs_stackElement_DME, "stackElement_DME");
      if (log && !findString("stackElement_DME", stackElementSubs))
	{
	  warnSub("stackElement_DME", "stackElement", a_stackElement);
	}
      return;
    }
  if (isA(a_stackElement, stackElement_DATSET))
    {
      adjustLevels(&stackElementSubs_stackElement_DATSET,
		   "stackElement_DATSET");
      if (log && !findString("stackElement_DATSET", stackElementSubs))
	{
	  warnSub("stackElement_DATSET", "stackElement", a_stackElement);
	}
      return;
    }
  if (isA(a_stackElement, stackElement_REPORT))
    {
      adjustLevels(&stackElementSubs_stackElement_REPORT,
		   "stackElement_REPORT");
      if (log && !findString("stackElement_REPORT", stackElementSubs))
	{
	  warnSub("stackElement_REPORT", "stackElement", a_stackElement);
	}
      return;
    }
}

/********************************************************************/

void check_state(
 state * a_state,
 int log)
{
  if (isA(a_state, state_ON))
    {
      adjustLevels(&stateSubs_state_ON, "state_ON");
      if (log && !findString("state_ON", stateSubs))
	{
	  warnSub("state_ON", "state", a_state);
	}
      return;
    }
  if (isA(a_state, state_OFF))
    {
      adjustLevels(&stateSubs_state_OFF, "state_OFF");
      if (log && !findString("state_OFF", stateSubs))
	{
	  warnSub("state_OFF", "state", a_state);
	}
      return;
    }
}

/********************************************************************/

void check_storageSpec(
 storageSpec * a_storageSpec,
 int log)
{
  if (isA(a_storageSpec, storageSpec_SNS))
    {
      adjustLevels(&storageSpecSubs_storageSpec_SNS, "storageSpec_SNS");
      if (log && !findString("storageSpec_SNS", storageSpecSubs))
	{
	  warnSub("storageSpec_SNS", "storageSpec", a_storageSpec);
	}
      return;
    }
  if (isA(a_storageSpec, storageSpec_PCS))
    {
      adjustLevels(&storageSpecSubs_storageSpec_PCS, "storageSpec_PCS");
      if (log && !findString("storageSpec_PCS", storageSpecSubs))
	{
	  warnSub("storageSpec_PCS", "storageSpec", a_storageSpec);
	}
      return;
    }
  if (isA(a_storageSpec, storageSpec_FEATUR))
    {
      adjustLevels(&storageSpecSubs_storageSpec_FEATUR, "storageSpec_FEATUR");
      if (log && !findString("storageSpec_FEATUR", storageSpecSubs))
	{
	  warnSub("storageSpec_FEATUR", "storageSpec", a_storageSpec);
	}
      return;
    }
  if (isA(a_storageSpec, storageSpec_RTAB))
    {
      adjustLevels(&storageSpecSubs_storageSpec_RTAB, "storageSpec_RTAB");
      if (log && !findString("storageSpec_RTAB", storageSpecSubs))
	{
	  warnSub("storageSpec_RTAB", "storageSpec", a_storageSpec);
	}
      return;
    }
}

/********************************************************************/

void check_strVar7(
 strVar7 * a_strVar7,
 int log)
{
  if (a_strVar7->get_width())
    {
      adjustLevels(&strVar7Atts_width, "strVar7 width");
      if (log && !findString("width", strVar7Atts))
	{
	  warnAtt("width", "strVar7", a_strVar7);
	  check_intVal(a_strVar7->get_width(), 0);
	}
      else
	check_intVal(a_strVar7->get_width(), log);
    }
  if (a_strVar7->get_decimal())
    {
      adjustLevels(&strVar7Atts_decimal, "strVar7 decimal");
      if (log && !findString("decimal", strVar7Atts))
	{
	  warnAtt("decimal", "strVar7", a_strVar7);
	  check_intVal(a_strVar7->get_decimal(), 0);
	}
      else
	check_intVal(a_strVar7->get_decimal(), log);
    }
}

/********************************************************************/

void check_stringConst(
 stringConst * a_stringConst,
 int log)
{
  if (a_stringConst->get_string())
    {
      adjustLevels(&stringConstAtts_a_string, "stringConst a_string");
      if (log && !findString("a_string", stringConstAtts))
	{
	  warnAtt("a_string", "stringConst", a_stringConst);
	}
    }
}

/********************************************************************/

void check_stringFunc(
 stringFunc * a_stringFunc,
 int log)
{
  if (isA(a_stringFunc, stringFuncChr))
    {
      adjustLevels(&stringFuncSubs_stringFuncChr, "stringFuncChr");
      if (log && !findString("stringFuncChr", stringFuncSubs))
	{
	  warnSub("stringFuncChr", "stringFunc", a_stringFunc);
	  check_stringFuncChr(
	    dynamic_cast<stringFuncChr *>(a_stringFunc), 0);
	}
      else
	check_stringFuncChr(
	  dynamic_cast<stringFuncChr *>(a_stringFunc), log);
      return;
    }
  if (isA(a_stringFunc, stringFuncConcat))
    {
      adjustLevels(&stringFuncSubs_stringFuncConcat, "stringFuncConcat");
      if (log && !findString("stringFuncConcat", stringFuncSubs))
	{
	  warnSub("stringFuncConcat", "stringFunc", a_stringFunc);
	  check_stringFuncConcat(
	    dynamic_cast<stringFuncConcat *>(a_stringFunc), 0);
	}
      else
	check_stringFuncConcat(
	  dynamic_cast<stringFuncConcat *>(a_stringFunc), log);
      return;
    }
  if (isA(a_stringFunc, stringFuncElemnt))
    {
      adjustLevels(&stringFuncSubs_stringFuncElemnt, "stringFuncElemnt");
      if (log && !findString("stringFuncElemnt", stringFuncSubs))
	{
	  warnSub("stringFuncElemnt", "stringFunc", a_stringFunc);
	  check_stringFuncElemnt(
	    dynamic_cast<stringFuncElemnt *>(a_stringFunc), 0);
	}
      else
	check_stringFuncElemnt(
	  dynamic_cast<stringFuncElemnt *>(a_stringFunc), log);
      return;
    }
  if (isA(a_stringFunc, stringFuncLwc))
    {
      adjustLevels(&stringFuncSubs_stringFuncLwc, "stringFuncLwc");
      if (log && !findString("stringFuncLwc", stringFuncSubs))
	{
	  warnSub("stringFuncLwc", "stringFunc", a_stringFunc);
	  check_stringFuncLwc(
	    dynamic_cast<stringFuncLwc *>(a_stringFunc), 0);
	}
      else
	check_stringFuncLwc(
	  dynamic_cast<stringFuncLwc *>(a_stringFunc), log);
      return;
    }
  if (isA(a_stringFunc, stringFuncRpt))
    {
      adjustLevels(&stringFuncSubs_stringFuncRpt, "stringFuncRpt");
      if (log && !findString("stringFuncRpt", stringFuncSubs))
	{
	  warnSub("stringFuncRpt", "stringFunc", a_stringFunc);
	  check_stringFuncRpt(
	    dynamic_cast<stringFuncRpt *>(a_stringFunc), 0);
	}
      else
	check_stringFuncRpt(
	  dynamic_cast<stringFuncRpt *>(a_stringFunc), log);
      return;
    }
  if (isA(a_stringFunc, stringFuncScfeat))
    {
      adjustLevels(&stringFuncSubs_stringFuncScfeat, "stringFuncScfeat");
      if (log && !findString("stringFuncScfeat", stringFuncSubs))
	{
	  warnSub("stringFuncScfeat", "stringFunc", a_stringFunc);
	}
      return;
    }
  if (isA(a_stringFunc, stringFuncScsns))
    {
      adjustLevels(&stringFuncSubs_stringFuncScsns, "stringFuncScsns");
      if (log && !findString("stringFuncScsns", stringFuncSubs))
	{
	  warnSub("stringFuncScsns", "stringFunc", a_stringFunc);
	}
      return;
    }
  if (isA(a_stringFunc, stringFuncSdate))
    {
      adjustLevels(&stringFuncSubs_stringFuncSdate, "stringFuncSdate");
      if (log && !findString("stringFuncSdate", stringFuncSubs))
	{
	  warnSub("stringFuncSdate", "stringFunc", a_stringFunc);
	}
      return;
    }
  if (isA(a_stringFunc, stringFuncSdatetime))
    {
      adjustLevels(&stringFuncSubs_stringFuncSdatetime, "stringFuncSdatetime");
      if (log && !findString("stringFuncSdatetime", stringFuncSubs))
	{
	  warnSub("stringFuncSdatetime", "stringFunc", a_stringFunc);
	}
      return;
    }
  if (isA(a_stringFunc, stringFuncSelapsetime))
    {
      adjustLevels(&stringFuncSubs_stringFuncSelapsetime,
		   "stringFuncSelapsetime");
      if (log && !findString("stringFuncSelapsetime", stringFuncSubs))
	{
	  warnSub("stringFuncSelapsetime", "stringFunc", a_stringFunc);
	  check_stringFuncSelapsetime(
	    dynamic_cast<stringFuncSelapsetime *>(a_stringFunc), 0);
	}
      else
	check_stringFuncSelapsetime(
	  dynamic_cast<stringFuncSelapsetime *>(a_stringFunc), log);
      return;
    }
  if (isA(a_stringFunc, stringFuncSerror))
    {
      adjustLevels(&stringFuncSubs_stringFuncSerror, "stringFuncSerror");
      if (log && !findString("stringFuncSerror", stringFuncSubs))
	{
	  warnSub("stringFuncSerror", "stringFunc", a_stringFunc);
	}
      return;
    }
  if (isA(a_stringFunc, stringFuncSmode))
    {
      adjustLevels(&stringFuncSubs_stringFuncSmode, "stringFuncSmode");
      if (log && !findString("stringFuncSmode", stringFuncSubs))
	{
	  warnSub("stringFuncSmode", "stringFunc", a_stringFunc);
	}
      return;
    }
  if (isA(a_stringFunc, stringFuncStime))
    {
      adjustLevels(&stringFuncSubs_stringFuncStime, "stringFuncStime");
      if (log && !findString("stringFuncStime", stringFuncSubs))
	{
	  warnSub("stringFuncStime", "stringFunc", a_stringFunc);
	}
      return;
    }
  if (isA(a_stringFunc, stringFuncStr))
    {
      adjustLevels(&stringFuncSubs_stringFuncStr, "stringFuncStr");
      if (log && !findString("stringFuncStr", stringFuncSubs))
	{
	  warnSub("stringFuncStr", "stringFunc", a_stringFunc);
	  check_stringFuncStr(
	    dynamic_cast<stringFuncStr *>(a_stringFunc), 0);
	}
      else
	check_stringFuncStr(
	  dynamic_cast<stringFuncStr *>(a_stringFunc), log);
      return;
    }
  if (isA(a_stringFunc, stringFuncSubstr))
    {
      adjustLevels(&stringFuncSubs_stringFuncSubstr, "stringFuncSubstr");
      if (log && !findString("stringFuncSubstr", stringFuncSubs))
	{
	  warnSub("stringFuncSubstr", "stringFunc", a_stringFunc);
	  check_stringFuncSubstr(
	    dynamic_cast<stringFuncSubstr *>(a_stringFunc), 0);
	}
      else
	check_stringFuncSubstr(
	  dynamic_cast<stringFuncSubstr *>(a_stringFunc), log);
      return;
    }
  if (isA(a_stringFunc, stringFuncTrim))
    {
      adjustLevels(&stringFuncSubs_stringFuncTrim, "stringFuncTrim");
      if (log && !findString("stringFuncTrim", stringFuncSubs))
	{
	  warnSub("stringFuncTrim", "stringFunc", a_stringFunc);
	  check_stringFuncTrim(
	    dynamic_cast<stringFuncTrim *>(a_stringFunc), 0);
	}
      else
	check_stringFuncTrim(
	  dynamic_cast<stringFuncTrim *>(a_stringFunc), log);
      return;
    }
  if (isA(a_stringFunc, stringFuncUpc))
    {
      adjustLevels(&stringFuncSubs_stringFuncUpc, "stringFuncUpc");
      if (log && !findString("stringFuncUpc", stringFuncSubs))
	{
	  warnSub("stringFuncUpc", "stringFunc", a_stringFunc);
	  check_stringFuncUpc(
	    dynamic_cast<stringFuncUpc *>(a_stringFunc), 0);
	}
      else
	check_stringFuncUpc(
	  dynamic_cast<stringFuncUpc *>(a_stringFunc), log);
      return;
    }
}

/********************************************************************/

void check_stringFuncChr(
 stringFuncChr * a_stringFuncChr,
 int log)
{
  if (a_stringFuncChr->get_index())
    {
      adjustLevels(&stringFuncChrAtts_index, "stringFuncChr index");
      if (log && !findString("index", stringFuncChrAtts))
	{
	  warnAtt("index", "stringFuncChr", a_stringFuncChr);
	  check_intVal(a_stringFuncChr->get_index(), 0);
	}
      else
	check_intVal(a_stringFuncChr->get_index(), log);
    }
}

/********************************************************************/

void check_stringFuncConcat(
 stringFuncConcat * a_stringFuncConcat,
 int log)
{
  if (a_stringFuncConcat->get_str1())
    {
      adjustLevels(&stringFuncConcatAtts_str1, "stringFuncConcat str1");
      if (log && !findString("str1", stringFuncConcatAtts))
	{
	  warnAtt("str1", "stringFuncConcat", a_stringFuncConcat);
	  check_stringVal(a_stringFuncConcat->get_str1(), 0);
	}
      else
	check_stringVal(a_stringFuncConcat->get_str1(), log);
    }
  if (a_stringFuncConcat->get_moreStrs())
    {
      std::list<stringVal *> * theList;
      std::list<stringVal *>::iterator iter;
      theList = a_stringFuncConcat->get_moreStrs();
      adjustLevels(&stringFuncConcatAtts_moreStrs,
		   "stringFuncConcat moreStrs");
      if (log && !findString("moreStrs", stringFuncConcatAtts))
	{
	  warnAtt("moreStrs", "stringFuncConcat", a_stringFuncConcat);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_stringVal(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_stringVal(*iter, log);
	}
    }
}

/********************************************************************/

void check_stringFuncElemnt(
 stringFuncElemnt * a_stringFuncElemnt,
 int log)
{
  if (a_stringFuncElemnt->get_index())
    {
      adjustLevels(&stringFuncElemntAtts_index, "stringFuncElemnt index");
      if (log && !findString("index", stringFuncElemntAtts))
	{
	  warnAtt("index", "stringFuncElemnt", a_stringFuncElemnt);
	  check_intVal(a_stringFuncElemnt->get_index(), 0);
	}
      else
	check_intVal(a_stringFuncElemnt->get_index(), log);
    }
  if (a_stringFuncElemnt->get_delim())
    {
      adjustLevels(&stringFuncElemntAtts_delim, "stringFuncElemnt delim");
      if (log && !findString("delim", stringFuncElemntAtts))
	{
	  warnAtt("delim", "stringFuncElemnt", a_stringFuncElemnt);
	  check_stringVal(a_stringFuncElemnt->get_delim(), 0);
	}
      else
	check_stringVal(a_stringFuncElemnt->get_delim(), log);
    }
  if (a_stringFuncElemnt->get_strings())
    {
      adjustLevels(&stringFuncElemntAtts_strings, "stringFuncElemnt strings");
      if (log && !findString("strings", stringFuncElemntAtts))
	{
	  warnAtt("strings", "stringFuncElemnt", a_stringFuncElemnt);
	  check_stringVal(a_stringFuncElemnt->get_strings(), 0);
	}
      else
	check_stringVal(a_stringFuncElemnt->get_strings(), log);
    }
}

/********************************************************************/

void check_stringFuncLwc(
 stringFuncLwc * a_stringFuncLwc,
 int log)
{
  if (a_stringFuncLwc->get_str())
    {
      adjustLevels(&stringFuncLwcAtts_str, "stringFuncLwc str");
      if (log && !findString("str", stringFuncLwcAtts))
	{
	  warnAtt("str", "stringFuncLwc", a_stringFuncLwc);
	  check_stringVal(a_stringFuncLwc->get_str(), 0);
	}
      else
	check_stringVal(a_stringFuncLwc->get_str(), log);
    }
}

/********************************************************************/

void check_stringFuncRpt(
 stringFuncRpt * a_stringFuncRpt,
 int log)
{
  if (a_stringFuncRpt->get_str())
    {
      adjustLevels(&stringFuncRptAtts_str, "stringFuncRpt str");
      if (log && !findString("str", stringFuncRptAtts))
	{
	  warnAtt("str", "stringFuncRpt", a_stringFuncRpt);
	  check_stringVal(a_stringFuncRpt->get_str(), 0);
	}
      else
	check_stringVal(a_stringFuncRpt->get_str(), log);
    }
  if (a_stringFuncRpt->get_reps())
    {
      adjustLevels(&stringFuncRptAtts_reps, "stringFuncRpt reps");
      if (log && !findString("reps", stringFuncRptAtts))
	{
	  warnAtt("reps", "stringFuncRpt", a_stringFuncRpt);
	  check_intVal(a_stringFuncRpt->get_reps(), 0);
	}
      else
	check_intVal(a_stringFuncRpt->get_reps(), log);
    }
}

/********************************************************************/

void check_stringFuncSelapsetime(
 stringFuncSelapsetime * a_stringFuncSelapsetime,
 int log)
{
  if (a_stringFuncSelapsetime->get_start())
    {
      adjustLevels(&stringFuncSelapsetimeAtts_start,
		   "stringFuncSelapsetime start");
      if (log && !findString("start", stringFuncSelapsetimeAtts))
	{
	  warnAtt("start", "stringFuncSelapsetime", a_stringFuncSelapsetime);
	  check_stringVal(a_stringFuncSelapsetime->get_start(), 0);
	}
      else
	check_stringVal(a_stringFuncSelapsetime->get_start(), log);
    }
  if (a_stringFuncSelapsetime->get_stop())
    {
      adjustLevels(&stringFuncSelapsetimeAtts_stop,
		   "stringFuncSelapsetime stop");
      if (log && !findString("stop", stringFuncSelapsetimeAtts))
	{
	  warnAtt("stop", "stringFuncSelapsetime", a_stringFuncSelapsetime);
	  check_stringVal(a_stringFuncSelapsetime->get_stop(), 0);
	}
      else
	check_stringVal(a_stringFuncSelapsetime->get_stop(), log);
    }
  if (a_stringFuncSelapsetime->get_longShort())
    {
      adjustLevels(&stringFuncSelapsetimeAtts_a_longShort,
		   "stringFuncSelapsetime a_longShort");
      if (log && !findString("a_longShort", stringFuncSelapsetimeAtts))
	{
	  warnAtt("a_longShort", "stringFuncSelapsetime",
		  a_stringFuncSelapsetime);
	  check_longShort(a_stringFuncSelapsetime->get_longShort(), 0);
	}
      else
	check_longShort(a_stringFuncSelapsetime->get_longShort(), log);
    }
}

/********************************************************************/

void check_stringFuncStr(
 stringFuncStr * a_stringFuncStr,
 int log)
{
  if (a_stringFuncStr->get_x())
    {
      adjustLevels(&stringFuncStrAtts_x, "stringFuncStr x");
      if (log && !findString("x", stringFuncStrAtts))
	{
	  warnAtt("x", "stringFuncStr", a_stringFuncStr);
	  check_rentVal(a_stringFuncStr->get_x(), 0);
	}
      else
	check_rentVal(a_stringFuncStr->get_x(), log);
    }
  if (a_stringFuncStr->get_strVar7())
    {
      adjustLevels(&stringFuncStrAtts_a_strVar7, "stringFuncStr a_strVar7");
      if (log && !findString("a_strVar7", stringFuncStrAtts))
	{
	  warnAtt("a_strVar7", "stringFuncStr", a_stringFuncStr);
	  check_strVar7(a_stringFuncStr->get_strVar7(), 0);
	}
      else
	check_strVar7(a_stringFuncStr->get_strVar7(), log);
    }
}

/********************************************************************/

void check_stringFuncSubstr(
 stringFuncSubstr * a_stringFuncSubstr,
 int log)
{
  if (a_stringFuncSubstr->get_str())
    {
      adjustLevels(&stringFuncSubstrAtts_str, "stringFuncSubstr str");
      if (log && !findString("str", stringFuncSubstrAtts))
	{
	  warnAtt("str", "stringFuncSubstr", a_stringFuncSubstr);
	  check_stringVal(a_stringFuncSubstr->get_str(), 0);
	}
      else
	check_stringVal(a_stringFuncSubstr->get_str(), log);
    }
  if (a_stringFuncSubstr->get_startIndex())
    {
      adjustLevels(&stringFuncSubstrAtts_startIndex,
		   "stringFuncSubstr startIndex");
      if (log && !findString("startIndex", stringFuncSubstrAtts))
	{
	  warnAtt("startIndex", "stringFuncSubstr", a_stringFuncSubstr);
	  check_intVal(a_stringFuncSubstr->get_startIndex(), 0);
	}
      else
	check_intVal(a_stringFuncSubstr->get_startIndex(), log);
    }
  if (a_stringFuncSubstr->get_endIndex())
    {
      adjustLevels(&stringFuncSubstrAtts_endIndex,
		   "stringFuncSubstr endIndex");
      if (log && !findString("endIndex", stringFuncSubstrAtts))
	{
	  warnAtt("endIndex", "stringFuncSubstr", a_stringFuncSubstr);
	  check_intVal(a_stringFuncSubstr->get_endIndex(), 0);
	}
      else
	check_intVal(a_stringFuncSubstr->get_endIndex(), log);
    }
}

/********************************************************************/

void check_stringFuncTrim(
 stringFuncTrim * a_stringFuncTrim,
 int log)
{
  if (a_stringFuncTrim->get_str())
    {
      adjustLevels(&stringFuncTrimAtts_str, "stringFuncTrim str");
      if (log && !findString("str", stringFuncTrimAtts))
	{
	  warnAtt("str", "stringFuncTrim", a_stringFuncTrim);
	  check_stringVal(a_stringFuncTrim->get_str(), 0);
	}
      else
	check_stringVal(a_stringFuncTrim->get_str(), log);
    }
}

/********************************************************************/

void check_stringFuncUpc(
 stringFuncUpc * a_stringFuncUpc,
 int log)
{
  if (a_stringFuncUpc->get_str())
    {
      adjustLevels(&stringFuncUpcAtts_str, "stringFuncUpc str");
      if (log && !findString("str", stringFuncUpcAtts))
	{
	  warnAtt("str", "stringFuncUpc", a_stringFuncUpc);
	  check_stringVal(a_stringFuncUpc->get_str(), 0);
	}
      else
	check_stringVal(a_stringFuncUpc->get_str(), log);
    }
}

/********************************************************************/

void check_stringRel(
 stringRel * a_stringRel,
 int log)
{
  if (isA(a_stringRel, stringRel_EQ))
    {
      adjustLevels(&stringRelSubs_stringRel_EQ, "stringRel_EQ");
      if (log && !findString("stringRel_EQ", stringRelSubs))
	{
	  warnSub("stringRel_EQ", "stringRel", a_stringRel);
	  check_stringRel_EQ(dynamic_cast<stringRel_EQ *>(a_stringRel), 0);
	}
      else
	check_stringRel_EQ(dynamic_cast<stringRel_EQ *>(a_stringRel), log);
      return;
    }
  if (isA(a_stringRel, stringRel_NE))
    {
      adjustLevels(&stringRelSubs_stringRel_NE, "stringRel_NE");
      if (log && !findString("stringRel_NE", stringRelSubs))
	{
	  warnSub("stringRel_NE", "stringRel", a_stringRel);
	  check_stringRel_NE(dynamic_cast<stringRel_NE *>(a_stringRel), 0);
	}
      else
	check_stringRel_NE(dynamic_cast<stringRel_NE *>(a_stringRel), log);
      return;
    }
  if (isA(a_stringRel, stringRel_LT))
    {
      adjustLevels(&stringRelSubs_stringRel_LT, "stringRel_LT");
      if (log && !findString("stringRel_LT", stringRelSubs))
	{
	  warnSub("stringRel_LT", "stringRel", a_stringRel);
	  check_stringRel_LT(dynamic_cast<stringRel_LT *>(a_stringRel), 0);
	}
      else
	check_stringRel_LT(dynamic_cast<stringRel_LT *>(a_stringRel), log);
      return;
    }
  if (isA(a_stringRel, stringRel_LE))
    {
      adjustLevels(&stringRelSubs_stringRel_LE, "stringRel_LE");
      if (log && !findString("stringRel_LE", stringRelSubs))
	{
	  warnSub("stringRel_LE", "stringRel", a_stringRel);
	  check_stringRel_LE(dynamic_cast<stringRel_LE *>(a_stringRel), 0);
	}
      else
	check_stringRel_LE(dynamic_cast<stringRel_LE *>(a_stringRel), log);
      return;
    }
  if (isA(a_stringRel, stringRel_GT))
    {
      adjustLevels(&stringRelSubs_stringRel_GT, "stringRel_GT");
      if (log && !findString("stringRel_GT", stringRelSubs))
	{
	  warnSub("stringRel_GT", "stringRel", a_stringRel);
	  check_stringRel_GT(dynamic_cast<stringRel_GT *>(a_stringRel), 0);
	}
      else
	check_stringRel_GT(dynamic_cast<stringRel_GT *>(a_stringRel), log);
      return;
    }
  if (isA(a_stringRel, stringRel_GE))
    {
      adjustLevels(&stringRelSubs_stringRel_GE, "stringRel_GE");
      if (log && !findString("stringRel_GE", stringRelSubs))
	{
	  warnSub("stringRel_GE", "stringRel", a_stringRel);
	  check_stringRel_GE(dynamic_cast<stringRel_GE *>(a_stringRel), 0);
	}
      else
	check_stringRel_GE(dynamic_cast<stringRel_GE *>(a_stringRel), log);
      return;
    }
}

/********************************************************************/

void check_stringRel_EQ(
 stringRel_EQ * a_stringRel_EQ,
 int log)
{
  if (a_stringRel_EQ->get_left())
    {
      adjustLevels(&stringRel_EQAtts_left, "stringRel_EQ left");
      if (log && !findString("left", stringRel_EQAtts))
	{
	  warnAtt("left", "stringRel_EQ", a_stringRel_EQ);
	  check_stringVal(a_stringRel_EQ->get_left(), 0);
	}
      else
	check_stringVal(a_stringRel_EQ->get_left(), log);
    }
  if (a_stringRel_EQ->get_right())
    {
      adjustLevels(&stringRel_EQAtts_right, "stringRel_EQ right");
      if (log && !findString("right", stringRel_EQAtts))
	{
	  warnAtt("right", "stringRel_EQ", a_stringRel_EQ);
	  check_stringVal(a_stringRel_EQ->get_right(), 0);
	}
      else
	check_stringVal(a_stringRel_EQ->get_right(), log);
    }
}

/********************************************************************/

void check_stringRel_GE(
 stringRel_GE * a_stringRel_GE,
 int log)
{
  if (a_stringRel_GE->get_left())
    {
      adjustLevels(&stringRel_GEAtts_left, "stringRel_GE left");
      if (log && !findString("left", stringRel_GEAtts))
	{
	  warnAtt("left", "stringRel_GE", a_stringRel_GE);
	  check_stringVal(a_stringRel_GE->get_left(), 0);
	}
      else
	check_stringVal(a_stringRel_GE->get_left(), log);
    }
  if (a_stringRel_GE->get_right())
    {
      adjustLevels(&stringRel_GEAtts_right, "stringRel_GE right");
      if (log && !findString("right", stringRel_GEAtts))
	{
	  warnAtt("right", "stringRel_GE", a_stringRel_GE);
	  check_stringVal(a_stringRel_GE->get_right(), 0);
	}
      else
	check_stringVal(a_stringRel_GE->get_right(), log);
    }
}

/********************************************************************/

void check_stringRel_GT(
 stringRel_GT * a_stringRel_GT,
 int log)
{
  if (a_stringRel_GT->get_left())
    {
      adjustLevels(&stringRel_GTAtts_left, "stringRel_GT left");
      if (log && !findString("left", stringRel_GTAtts))
	{
	  warnAtt("left", "stringRel_GT", a_stringRel_GT);
	  check_stringVal(a_stringRel_GT->get_left(), 0);
	}
      else
	check_stringVal(a_stringRel_GT->get_left(), log);
    }
  if (a_stringRel_GT->get_right())
    {
      adjustLevels(&stringRel_GTAtts_right, "stringRel_GT right");
      if (log && !findString("right", stringRel_GTAtts))
	{
	  warnAtt("right", "stringRel_GT", a_stringRel_GT);
	  check_stringVal(a_stringRel_GT->get_right(), 0);
	}
      else
	check_stringVal(a_stringRel_GT->get_right(), log);
    }
}

/********************************************************************/

void check_stringRel_LE(
 stringRel_LE * a_stringRel_LE,
 int log)
{
  if (a_stringRel_LE->get_left())
    {
      adjustLevels(&stringRel_LEAtts_left, "stringRel_LE left");
      if (log && !findString("left", stringRel_LEAtts))
	{
	  warnAtt("left", "stringRel_LE", a_stringRel_LE);
	  check_stringVal(a_stringRel_LE->get_left(), 0);
	}
      else
	check_stringVal(a_stringRel_LE->get_left(), log);
    }
  if (a_stringRel_LE->get_right())
    {
      adjustLevels(&stringRel_LEAtts_right, "stringRel_LE right");
      if (log && !findString("right", stringRel_LEAtts))
	{
	  warnAtt("right", "stringRel_LE", a_stringRel_LE);
	  check_stringVal(a_stringRel_LE->get_right(), 0);
	}
      else
	check_stringVal(a_stringRel_LE->get_right(), log);
    }
}

/********************************************************************/

void check_stringRel_LT(
 stringRel_LT * a_stringRel_LT,
 int log)
{
  if (a_stringRel_LT->get_left())
    {
      adjustLevels(&stringRel_LTAtts_left, "stringRel_LT left");
      if (log && !findString("left", stringRel_LTAtts))
	{
	  warnAtt("left", "stringRel_LT", a_stringRel_LT);
	  check_stringVal(a_stringRel_LT->get_left(), 0);
	}
      else
	check_stringVal(a_stringRel_LT->get_left(), log);
    }
  if (a_stringRel_LT->get_right())
    {
      adjustLevels(&stringRel_LTAtts_right, "stringRel_LT right");
      if (log && !findString("right", stringRel_LTAtts))
	{
	  warnAtt("right", "stringRel_LT", a_stringRel_LT);
	  check_stringVal(a_stringRel_LT->get_right(), 0);
	}
      else
	check_stringVal(a_stringRel_LT->get_right(), log);
    }
}

/********************************************************************/

void check_stringRel_NE(
 stringRel_NE * a_stringRel_NE,
 int log)
{
  if (a_stringRel_NE->get_left())
    {
      adjustLevels(&stringRel_NEAtts_left, "stringRel_NE left");
      if (log && !findString("left", stringRel_NEAtts))
	{
	  warnAtt("left", "stringRel_NE", a_stringRel_NE);
	  check_stringVal(a_stringRel_NE->get_left(), 0);
	}
      else
	check_stringVal(a_stringRel_NE->get_left(), log);
    }
  if (a_stringRel_NE->get_right())
    {
      adjustLevels(&stringRel_NEAtts_right, "stringRel_NE right");
      if (log && !findString("right", stringRel_NEAtts))
	{
	  warnAtt("right", "stringRel_NE", a_stringRel_NE);
	  check_stringVal(a_stringRel_NE->get_right(), 0);
	}
      else
	check_stringVal(a_stringRel_NE->get_right(), log);
    }
}

/********************************************************************/

void check_stringVal(
 stringVal * a_stringVal,
 int log)
{
  if (isA(a_stringVal, stringConst))
    {
      adjustLevels(&stringValSubs_stringConst, "stringConst");
      if (log && !findString("stringConst", stringValSubs))
	{
	  warnSub("stringConst", "stringVal", a_stringVal);
	  check_stringConst(dynamic_cast<stringConst *>(a_stringVal), 0);
	}
      else
	check_stringConst(dynamic_cast<stringConst *>(a_stringVal), log);
      return;
    }
  if (isA(a_stringVal, stringFunc))
    {
      adjustLevels(&stringValSubs_stringFunc, "stringFunc");
      if (log && !findString("stringFunc", stringValSubs))
	{
	  warnSub("stringFunc", "stringVal", a_stringVal);
	  check_stringFunc(dynamic_cast<stringFunc *>(a_stringVal), 0);
	}
      else
	check_stringFunc(dynamic_cast<stringFunc *>(a_stringVal), log);
      return;
    }
  if (isA(a_stringVal, stringVar))
    {
      adjustLevels(&stringValSubs_stringVar, "stringVar");
      if (log && !findString("stringVar", stringValSubs))
	{
	  warnSub("stringVar", "stringVal", a_stringVal);
	  check_stringVar(dynamic_cast<stringVar *>(a_stringVal), 0);
	}
      else
	check_stringVar(dynamic_cast<stringVar *>(a_stringVal), log);
      return;
    }
}

/********************************************************************/

void check_stringVar(
 stringVar * a_stringVar,
 int log)
{
  if (a_stringVar->get_string())
    {
      adjustLevels(&stringVarAtts_a_string, "stringVar a_string");
      if (log && !findString("a_string", stringVarAtts))
	{
	  warnAtt("a_string", "stringVar", a_stringVar);
	}
    }
  if (a_stringVar->get_arrayIndex())
    {
      adjustLevels(&stringVarAtts_a_arrayIndex, "stringVar a_arrayIndex");
      if (log && !findString("a_arrayIndex", stringVarAtts))
	{
	  warnAtt("a_arrayIndex", "stringVar", a_stringVar);
	  check_arrayIndex(a_stringVar->get_arrayIndex(), 0);
	}
      else
	check_arrayIndex(a_stringVar->get_arrayIndex(), log);
    }
}

/********************************************************************/

void check_surfPtdataHeadcsListItem(
 surfPtdataHeadcsListItem * a_surfPtdataHeadcsListItem,
 int log)
{
  if (a_surfPtdataHeadcsListItem->get_pointVecCart())
    {
      adjustLevels(&surfPtdataHeadcsListItemAtts_a_pointVecCart,
		   "surfPtdataHeadcsListItem a_pointVecCart");
      if (log && !findString("a_pointVecCart", surfPtdataHeadcsListItemAtts))
	{
	  warnAtt("a_pointVecCart", "surfPtdataHeadcsListItem",
		  a_surfPtdataHeadcsListItem);
	  check_pointVecCart(a_surfPtdataHeadcsListItem->get_pointVecCart(), 0);
	}
      else
	check_pointVecCart(a_surfPtdataHeadcsListItem->get_pointVecCart(), log);
    }
  if (a_surfPtdataHeadcsListItem->get_width())
    {
      adjustLevels(&surfPtdataHeadcsListItemAtts_width,
		   "surfPtdataHeadcsListItem width");
      if (log && !findString("width", surfPtdataHeadcsListItemAtts))
	{
	  warnAtt("width", "surfPtdataHeadcsListItem",
		  a_surfPtdataHeadcsListItem);
	  check_rentVal(a_surfPtdataHeadcsListItem->get_width(), 0);
	}
      else
	check_rentVal(a_surfPtdataHeadcsListItem->get_width(), log);
    }
  if (a_surfPtdataHeadcsListItem->get_height())
    {
      adjustLevels(&surfPtdataHeadcsListItemAtts_height,
		   "surfPtdataHeadcsListItem height");
      if (log && !findString("height", surfPtdataHeadcsListItemAtts))
	{
	  warnAtt("height", "surfPtdataHeadcsListItem",
		  a_surfPtdataHeadcsListItem);
	  check_rentVal(a_surfPtdataHeadcsListItem->get_height(), 0);
	}
      else
	check_rentVal(a_surfPtdataHeadcsListItem->get_height(), log);
    }
  if (a_surfPtdataHeadcsListItem->get_rot1())
    {
      adjustLevels(&surfPtdataHeadcsListItemAtts_rot1,
		   "surfPtdataHeadcsListItem rot1");
      if (log && !findString("rot1", surfPtdataHeadcsListItemAtts))
	{
	  warnAtt("rot1", "surfPtdataHeadcsListItem",
		  a_surfPtdataHeadcsListItem);
	  check_rentVal(a_surfPtdataHeadcsListItem->get_rot1(), 0);
	}
      else
	check_rentVal(a_surfPtdataHeadcsListItem->get_rot1(), log);
    }
  if (a_surfPtdataHeadcsListItem->get_rot2())
    {
      adjustLevels(&surfPtdataHeadcsListItemAtts_rot2,
		   "surfPtdataHeadcsListItem rot2");
      if (log && !findString("rot2", surfPtdataHeadcsListItemAtts))
	{
	  warnAtt("rot2", "surfPtdataHeadcsListItem",
		  a_surfPtdataHeadcsListItem);
	  check_rentVal(a_surfPtdataHeadcsListItem->get_rot2(), 0);
	}
      else
	check_rentVal(a_surfPtdataHeadcsListItem->get_rot2(), log);
    }
  if (a_surfPtdataHeadcsListItem->get_rot3())
    {
      adjustLevels(&surfPtdataHeadcsListItemAtts_rot3,
		   "surfPtdataHeadcsListItem rot3");
      if (log && !findString("rot3", surfPtdataHeadcsListItemAtts))
	{
	  warnAtt("rot3", "surfPtdataHeadcsListItem",
		  a_surfPtdataHeadcsListItem);
	  check_rentVal(a_surfPtdataHeadcsListItem->get_rot3(), 0);
	}
      else
	check_rentVal(a_surfPtdataHeadcsListItem->get_rot3(), log);
    }
}

/********************************************************************/

void check_surfPtdataListItem(
 surfPtdataListItem * a_surfPtdataListItem,
 int log)
{
  if (a_surfPtdataListItem->get_pointVecCart())
    {
      adjustLevels(&surfPtdataListItemAtts_a_pointVecCart,
		   "surfPtdataListItem a_pointVecCart");
      if (log && !findString("a_pointVecCart", surfPtdataListItemAtts))
	{
	  warnAtt("a_pointVecCart", "surfPtdataListItem",
		  a_surfPtdataListItem);
	  check_pointVecCart(a_surfPtdataListItem->get_pointVecCart(), 0);
	}
      else
	check_pointVecCart(a_surfPtdataListItem->get_pointVecCart(), log);
    }
  if (a_surfPtdataListItem->get_width())
    {
      adjustLevels(&surfPtdataListItemAtts_width, "surfPtdataListItem width");
      if (log && !findString("width", surfPtdataListItemAtts))
	{
	  warnAtt("width", "surfPtdataListItem", a_surfPtdataListItem);
	  check_rentVal(a_surfPtdataListItem->get_width(), 0);
	}
      else
	check_rentVal(a_surfPtdataListItem->get_width(), log);
    }
  if (a_surfPtdataListItem->get_height())
    {
      adjustLevels(&surfPtdataListItemAtts_height,
		   "surfPtdataListItem height");
      if (log && !findString("height", surfPtdataListItemAtts))
	{
	  warnAtt("height", "surfPtdataListItem", a_surfPtdataListItem);
	  check_rentVal(a_surfPtdataListItem->get_height(), 0);
	}
      else
	check_rentVal(a_surfPtdataListItem->get_height(), log);
    }
}

/********************************************************************/

void check_surfPtdataPcsListItem(
 surfPtdataPcsListItem * a_surfPtdataPcsListItem,
 int log)
{
  if (a_surfPtdataPcsListItem->get_pointVecCart())
    {
      adjustLevels(&surfPtdataPcsListItemAtts_a_pointVecCart,
		   "surfPtdataPcsListItem a_pointVecCart");
      if (log && !findString("a_pointVecCart", surfPtdataPcsListItemAtts))
	{
	  warnAtt("a_pointVecCart", "surfPtdataPcsListItem",
		  a_surfPtdataPcsListItem);
	  check_pointVecCart(a_surfPtdataPcsListItem->get_pointVecCart(), 0);
	}
      else
	check_pointVecCart(a_surfPtdataPcsListItem->get_pointVecCart(), log);
    }
  if (a_surfPtdataPcsListItem->get_width())
    {
      adjustLevels(&surfPtdataPcsListItemAtts_width,
		   "surfPtdataPcsListItem width");
      if (log && !findString("width", surfPtdataPcsListItemAtts))
	{
	  warnAtt("width", "surfPtdataPcsListItem", a_surfPtdataPcsListItem);
	  check_rentVal(a_surfPtdataPcsListItem->get_width(), 0);
	}
      else
	check_rentVal(a_surfPtdataPcsListItem->get_width(), log);
    }
  if (a_surfPtdataPcsListItem->get_height())
    {
      adjustLevels(&surfPtdataPcsListItemAtts_height,
		   "surfPtdataPcsListItem height");
      if (log && !findString("height", surfPtdataPcsListItemAtts))
	{
	  warnAtt("height", "surfPtdataPcsListItem", a_surfPtdataPcsListItem);
	  check_rentVal(a_surfPtdataPcsListItem->get_height(), 0);
	}
      else
	check_rentVal(a_surfPtdataPcsListItem->get_height(), log);
    }
  if (a_surfPtdataPcsListItem->get_euler())
    {
      adjustLevels(&surfPtdataPcsListItemAtts_a_euler,
		   "surfPtdataPcsListItem a_euler");
      if (log && !findString("a_euler", surfPtdataPcsListItemAtts))
	{
	  warnAtt("a_euler", "surfPtdataPcsListItem",
		  a_surfPtdataPcsListItem);
	  check_euler(a_surfPtdataPcsListItem->get_euler(), 0);
	}
      else
	check_euler(a_surfPtdataPcsListItem->get_euler(), log);
    }
}

/********************************************************************/

void check_swLabel(
 swLabel * a_swLabel,
 int log)
{
  if (a_swLabel->get_labelName())
    {
      adjustLevels(&swLabelAtts_a_labelName, "swLabel a_labelName");
      if (log && !findString("a_labelName", swLabelAtts))
	{
	  warnAtt("a_labelName", "swLabel", a_swLabel);
	  check_labelName(a_swLabel->get_labelName(), 0);
	}
      else
	check_labelName(a_swLabel->get_labelName(), log);
    }
}

/********************************************************************/

void check_sxLabel(
 sxLabel * a_sxLabel,
 int log)
{
  if (a_sxLabel->get_labelName())
    {
      adjustLevels(&sxLabelAtts_a_labelName, "sxLabel a_labelName");
      if (log && !findString("a_labelName", sxLabelAtts))
	{
	  warnAtt("a_labelName", "sxLabel", a_sxLabel);
	  check_labelName(a_sxLabel->get_labelName(), 0);
	}
      else
	check_labelName(a_sxLabel->get_labelName(), log);
    }
}

/********************************************************************/

void check_tLabel(
 tLabel * a_tLabel,
 int log)
{
  if (a_tLabel->get_labelName())
    {
      adjustLevels(&tLabelAtts_a_labelName, "tLabel a_labelName");
      if (log && !findString("a_labelName", tLabelAtts))
	{
	  warnAtt("a_labelName", "tLabel", a_tLabel);
	  check_labelName(a_tLabel->get_labelName(), 0);
	}
      else
	check_labelName(a_tLabel->get_labelName(), log);
    }
}

/********************************************************************/

void check_taLabel(
 taLabel * a_taLabel,
 int log)
{
  if (a_taLabel->get_labelName())
    {
      adjustLevels(&taLabelAtts_a_labelName, "taLabel a_labelName");
      if (log && !findString("a_labelName", taLabelAtts))
	{
	  warnAtt("a_labelName", "taLabel", a_taLabel);
	  check_labelName(a_taLabel->get_labelName(), 0);
	}
      else
	check_labelName(a_taLabel->get_labelName(), log);
    }
}

/********************************************************************/

void check_tantoConst(
 tantoConst * a_tantoConst,
 int log)
{
  if (isA(a_tantoConst, tantoConstFa))
    {
      adjustLevels(&tantoConstSubs_tantoConstFa, "tantoConstFa");
      if (log && !findString("tantoConstFa", tantoConstSubs))
	{
	  warnSub("tantoConstFa", "tantoConst", a_tantoConst);
	  check_tantoConstFa(
	    dynamic_cast<tantoConstFa *>(a_tantoConst), 0);
	}
      else
	check_tantoConstFa(
	  dynamic_cast<tantoConstFa *>(a_tantoConst), log);
      return;
    }
  if (isA(a_tantoConst, tantoConstF))
    {
      adjustLevels(&tantoConstSubs_tantoConstF, "tantoConstF");
      if (log && !findString("tantoConstF", tantoConstSubs))
	{
	  warnSub("tantoConstF", "tantoConst", a_tantoConst);
	  check_tantoConstF(dynamic_cast<tantoConstF *>(a_tantoConst), 0);
	}
      else
	check_tantoConstF(dynamic_cast<tantoConstF *>(a_tantoConst), log);
      return;
    }
}

/********************************************************************/

void check_tantoConstF(
 tantoConstF * a_tantoConstF,
 int log)
{
  if (a_tantoConstF->get_fLabel())
    {
      adjustLevels(&tantoConstFAtts_a_fLabel, "tantoConstF a_fLabel");
      if (log && !findString("a_fLabel", tantoConstFAtts))
	{
	  warnAtt("a_fLabel", "tantoConstF", a_tantoConstF);
	  check_fLabel(a_tantoConstF->get_fLabel(), 0);
	}
      else
	check_fLabel(a_tantoConstF->get_fLabel(), log);
    }
  if (a_tantoConstF->get_faLabel())
    {
      adjustLevels(&tantoConstFAtts_a_faLabel, "tantoConstF a_faLabel");
      if (log && !findString("a_faLabel", tantoConstFAtts))
	{
	  warnAtt("a_faLabel", "tantoConstF", a_tantoConstF);
	  check_faLabel(a_tantoConstF->get_faLabel(), 0);
	}
      else
	check_faLabel(a_tantoConstF->get_faLabel(), log);
    }
}

/********************************************************************/

void check_tantoConstFa(
 tantoConstFa * a_tantoConstFa,
 int log)
{
  if (a_tantoConstFa->get_faLabel())
    {
      adjustLevels(&tantoConstFaAtts_a_faLabel, "tantoConstFa a_faLabel");
      if (log && !findString("a_faLabel", tantoConstFaAtts))
	{
	  warnAtt("a_faLabel", "tantoConstFa", a_tantoConstFa);
	  check_faLabel(a_tantoConstFa->get_faLabel(), 0);
	}
      else
	check_faLabel(a_tantoConstFa->get_faLabel(), log);
    }
  if (a_tantoConstFa->get_has_THRU())
    {
      adjustLevels(&tantoConstFaAtts_has_THRU, "tantoConstFa has_THRU");
      if (log && !findString("has_THRU", tantoConstFaAtts))
	{
	  warnAtt("has_THRU", "tantoConstFa", a_tantoConstFa);
	}
    }
  if (a_tantoConstFa->get_featureLabel())
    {
      adjustLevels(&tantoConstFaAtts_a_featureLabel,
		   "tantoConstFa a_featureLabel");
      if (log && !findString("a_featureLabel", tantoConstFaAtts))
	{
	  warnAtt("a_featureLabel", "tantoConstFa", a_tantoConstFa);
	  check_featureLabel(a_tantoConstFa->get_featureLabel(), 0);
	}
      else
	check_featureLabel(a_tantoConstFa->get_featureLabel(), log);
    }
}

/********************************************************************/

void check_tantoConstPlane(
 tantoConstPlane * a_tantoConstPlane,
 int log)
{
  if (isA(a_tantoConstPlane, tantoConstPlaneFa))
    {
      adjustLevels(&tantoConstPlaneSubs_tantoConstPlaneFa,
		   "tantoConstPlaneFa");
      if (log && !findString("tantoConstPlaneFa", tantoConstPlaneSubs))
	{
	  warnSub("tantoConstPlaneFa", "tantoConstPlane", a_tantoConstPlane);
	  check_tantoConstPlaneFa(
	    dynamic_cast<tantoConstPlaneFa *>(a_tantoConstPlane), 0);
	}
      else
	check_tantoConstPlaneFa(
	  dynamic_cast<tantoConstPlaneFa *>(a_tantoConstPlane), log);
      return;
    }
  if (isA(a_tantoConstPlane, tantoConstPlaneF))
    {
      adjustLevels(&tantoConstPlaneSubs_tantoConstPlaneF, "tantoConstPlaneF");
      if (log && !findString("tantoConstPlaneF", tantoConstPlaneSubs))
	{
	  warnSub("tantoConstPlaneF", "tantoConstPlane", a_tantoConstPlane);
	  check_tantoConstPlaneF(
	    dynamic_cast<tantoConstPlaneF *>(a_tantoConstPlane), 0);
	}
      else
	check_tantoConstPlaneF(
	  dynamic_cast<tantoConstPlaneF *>(a_tantoConstPlane), log);
      return;
    }
}

/********************************************************************/

void check_tantoConstPlaneF(
 tantoConstPlaneF * a_tantoConstPlaneF,
 int log)
{
  if (a_tantoConstPlaneF->get_fLabel())
    {
      adjustLevels(&tantoConstPlaneFAtts_a_fLabel,
		   "tantoConstPlaneF a_fLabel");
      if (log && !findString("a_fLabel", tantoConstPlaneFAtts))
	{
	  warnAtt("a_fLabel", "tantoConstPlaneF", a_tantoConstPlaneF);
	  check_fLabel(a_tantoConstPlaneF->get_fLabel(), 0);
	}
      else
	check_fLabel(a_tantoConstPlaneF->get_fLabel(), log);
    }
  if (a_tantoConstPlaneF->get_faLabel())
    {
      adjustLevels(&tantoConstPlaneFAtts_a_faLabel,
		   "tantoConstPlaneF a_faLabel");
      if (log && !findString("a_faLabel", tantoConstPlaneFAtts))
	{
	  warnAtt("a_faLabel", "tantoConstPlaneF", a_tantoConstPlaneF);
	  check_faLabel(a_tantoConstPlaneF->get_faLabel(), 0);
	}
      else
	check_faLabel(a_tantoConstPlaneF->get_faLabel(), log);
    }
}

/********************************************************************/

void check_tantoConstPlaneFa(
 tantoConstPlaneFa * a_tantoConstPlaneFa,
 int log)
{
  if (a_tantoConstPlaneFa->get_faLabel())
    {
      adjustLevels(&tantoConstPlaneFaAtts_a_faLabel,
		   "tantoConstPlaneFa a_faLabel");
      if (log && !findString("a_faLabel", tantoConstPlaneFaAtts))
	{
	  warnAtt("a_faLabel", "tantoConstPlaneFa", a_tantoConstPlaneFa);
	  check_faLabel(a_tantoConstPlaneFa->get_faLabel(), 0);
	}
      else
	check_faLabel(a_tantoConstPlaneFa->get_faLabel(), log);
    }
  if (a_tantoConstPlaneFa->get_featureLabel())
    {
      adjustLevels(&tantoConstPlaneFaAtts_a_featureLabel,
		   "tantoConstPlaneFa a_featureLabel");
      if (log && !findString("a_featureLabel", tantoConstPlaneFaAtts))
	{
	  warnAtt("a_featureLabel", "tantoConstPlaneFa", a_tantoConstPlaneFa);
	  check_featureLabel(a_tantoConstPlaneFa->get_featureLabel(), 0);
	}
      else
	check_featureLabel(a_tantoConstPlaneFa->get_featureLabel(), log);
    }
}

/********************************************************************/

void check_tecompDatum(
 tecompDatum * a_tecompDatum,
 int log)
{
  if (a_tecompDatum->get_daLabel())
    {
      adjustLevels(&tecompDatumAtts_a_daLabel, "tecompDatum a_daLabel");
      if (log && !findString("a_daLabel", tecompDatumAtts))
	{
	  warnAtt("a_daLabel", "tecompDatum", a_tecompDatum);
	  check_daLabel(a_tecompDatum->get_daLabel(), 0);
	}
      else
	check_daLabel(a_tecompDatum->get_daLabel(), log);
    }
}

/********************************************************************/

void check_tecompMinor(
 tecompMinor * a_tecompMinor,
 int log)
{
  if (isA(a_tecompMinor, tecompMinorMach))
    {
      adjustLevels(&tecompMinorSubs_tecompMinorMach, "tecompMinorMach");
      if (log && !findString("tecompMinorMach", tecompMinorSubs))
	{
	  warnSub("tecompMinorMach", "tecompMinor", a_tecompMinor);
	  check_tecompMinorMach(
	    dynamic_cast<tecompMinorMach *>(a_tecompMinor), 0);
	}
      else
	check_tecompMinorMach(
	  dynamic_cast<tecompMinorMach *>(a_tecompMinor), log);
      return;
    }
  if (isA(a_tecompMinor, tecompMinorOnList))
    {
      adjustLevels(&tecompMinorSubs_tecompMinorOnList, "tecompMinorOnList");
      if (log && !findString("tecompMinorOnList", tecompMinorSubs))
	{
	  warnSub("tecompMinorOnList", "tecompMinor", a_tecompMinor);
	  check_tecompMinorOnList(
	    dynamic_cast<tecompMinorOnList *>(a_tecompMinor), 0);
	}
      else
	check_tecompMinorOnList(
	  dynamic_cast<tecompMinorOnList *>(a_tecompMinor), log);
      return;
    }
  if (isA(a_tecompMinor, tecompMinorOnAll))
    {
      adjustLevels(&tecompMinorSubs_tecompMinorOnAll, "tecompMinorOnAll");
      if (log && !findString("tecompMinorOnAll", tecompMinorSubs))
	{
	  warnSub("tecompMinorOnAll", "tecompMinor", a_tecompMinor);
	  check_tecompMinorOnAll(
	    dynamic_cast<tecompMinorOnAll *>(a_tecompMinor), 0);
	}
      else
	check_tecompMinorOnAll(
	  dynamic_cast<tecompMinorOnAll *>(a_tecompMinor), log);
      return;
    }
  if (isA(a_tecompMinor, tecompMinorOff))
    {
      adjustLevels(&tecompMinorSubs_tecompMinorOff, "tecompMinorOff");
      if (log && !findString("tecompMinorOff", tecompMinorSubs))
	{
	  warnSub("tecompMinorOff", "tecompMinor", a_tecompMinor);
	}
      return;
    }
}

/********************************************************************/

void check_tecompMinorMach(
 tecompMinorMach * a_tecompMinorMach,
 int log)
{
  if (a_tecompMinorMach->get_state())
    {
      adjustLevels(&tecompMinorMachAtts_a_state, "tecompMinorMach a_state");
      if (log && !findString("a_state", tecompMinorMachAtts))
	{
	  warnAtt("a_state", "tecompMinorMach", a_tecompMinorMach);
	  check_state(a_tecompMinorMach->get_state(), 0);
	}
      else
	check_state(a_tecompMinorMach->get_state(), log);
    }
}

/********************************************************************/

void check_tecompMinorOnAll(
 tecompMinorOnAll * a_tecompMinorOnAll,
 int log)
{
  if (a_tecompMinorOnAll->get_tecompVar2())
    {
      adjustLevels(&tecompMinorOnAllAtts_a_tecompVar2,
		   "tecompMinorOnAll a_tecompVar2");
      if (log && !findString("a_tecompVar2", tecompMinorOnAllAtts))
	{
	  warnAtt("a_tecompVar2", "tecompMinorOnAll", a_tecompMinorOnAll);
	  check_tecompVar2(a_tecompMinorOnAll->get_tecompVar2(), 0);
	}
      else
	check_tecompVar2(a_tecompMinorOnAll->get_tecompVar2(), log);
    }
  if (a_tecompMinorOnAll->get_tmpexp())
    {
      adjustLevels(&tecompMinorOnAllAtts_tmpexp, "tecompMinorOnAll tmpexp");
      if (log && !findString("tmpexp", tecompMinorOnAllAtts))
	{
	  warnAtt("tmpexp", "tecompMinorOnAll", a_tecompMinorOnAll);
	  check_rentVal(a_tecompMinorOnAll->get_tmpexp(), 0);
	}
      else
	check_rentVal(a_tecompMinorOnAll->get_tmpexp(), log);
    }
  if (a_tecompMinorOnAll->get_tmpexpunc())
    {
      adjustLevels(&tecompMinorOnAllAtts_tmpexpunc,
		   "tecompMinorOnAll tmpexpunc");
      if (log && !findString("tmpexpunc", tecompMinorOnAllAtts))
	{
	  warnAtt("tmpexpunc", "tecompMinorOnAll", a_tecompMinorOnAll);
	  check_rentVal(a_tecompMinorOnAll->get_tmpexpunc(), 0);
	}
      else
	check_rentVal(a_tecompMinorOnAll->get_tmpexpunc(), log);
    }
}

/********************************************************************/

void check_tecompMinorOnList(
 tecompMinorOnList * a_tecompMinorOnList,
 int log)
{
  if (a_tecompMinorOnList->get_tecompVar2())
    {
      adjustLevels(&tecompMinorOnListAtts_a_tecompVar2,
		   "tecompMinorOnList a_tecompVar2");
      if (log && !findString("a_tecompVar2", tecompMinorOnListAtts))
	{
	  warnAtt("a_tecompVar2", "tecompMinorOnList", a_tecompMinorOnList);
	  check_tecompVar2(a_tecompMinorOnList->get_tecompVar2(), 0);
	}
      else
	check_tecompVar2(a_tecompMinorOnList->get_tecompVar2(), log);
    }
  if (a_tecompMinorOnList->get_tmpexp())
    {
      adjustLevels(&tecompMinorOnListAtts_tmpexp, "tecompMinorOnList tmpexp");
      if (log && !findString("tmpexp", tecompMinorOnListAtts))
	{
	  warnAtt("tmpexp", "tecompMinorOnList", a_tecompMinorOnList);
	  check_rentVal(a_tecompMinorOnList->get_tmpexp(), 0);
	}
      else
	check_rentVal(a_tecompMinorOnList->get_tmpexp(), log);
    }
  if (a_tecompMinorOnList->get_tmpexpunc())
    {
      adjustLevels(&tecompMinorOnListAtts_tmpexpunc,
		   "tecompMinorOnList tmpexpunc");
      if (log && !findString("tmpexpunc", tecompMinorOnListAtts))
	{
	  warnAtt("tmpexpunc", "tecompMinorOnList", a_tecompMinorOnList);
	  check_rentVal(a_tecompMinorOnList->get_tmpexpunc(), 0);
	}
      else
	check_rentVal(a_tecompMinorOnList->get_tmpexpunc(), log);
    }
  if (a_tecompMinorOnList->get_stringList())
    {
      std::list<stringVal *> * theList;
      std::list<stringVal *>::iterator iter;
      theList = a_tecompMinorOnList->get_stringList();
      adjustLevels(&tecompMinorOnListAtts_a_stringList,
		   "tecompMinorOnList a_stringList");
      if (log && !findString("a_stringList", tecompMinorOnListAtts))
	{
	  warnAtt("a_stringList", "tecompMinorOnList", a_tecompMinorOnList);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_stringVal(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_stringVal(*iter, log);
	}
    }
}

/********************************************************************/

void check_tecompOffset(
 tecompOffset * a_tecompOffset,
 int log)
{
  if (a_tecompOffset->get_xoff())
    {
      adjustLevels(&tecompOffsetAtts_xoff, "tecompOffset xoff");
      if (log && !findString("xoff", tecompOffsetAtts))
	{
	  warnAtt("xoff", "tecompOffset", a_tecompOffset);
	  check_rentVal(a_tecompOffset->get_xoff(), 0);
	}
      else
	check_rentVal(a_tecompOffset->get_xoff(), log);
    }
  if (a_tecompOffset->get_yoff())
    {
      adjustLevels(&tecompOffsetAtts_yoff, "tecompOffset yoff");
      if (log && !findString("yoff", tecompOffsetAtts))
	{
	  warnAtt("yoff", "tecompOffset", a_tecompOffset);
	  check_rentVal(a_tecompOffset->get_yoff(), 0);
	}
      else
	check_rentVal(a_tecompOffset->get_yoff(), log);
    }
  if (a_tecompOffset->get_zoff())
    {
      adjustLevels(&tecompOffsetAtts_zoff, "tecompOffset zoff");
      if (log && !findString("zoff", tecompOffsetAtts))
	{
	  warnAtt("zoff", "tecompOffset", a_tecompOffset);
	  check_rentVal(a_tecompOffset->get_zoff(), 0);
	}
      else
	check_rentVal(a_tecompOffset->get_zoff(), log);
    }
}

/********************************************************************/

void check_tecompStm(
 tecompStm * a_tecompStm,
 int log)
{
  if (a_tecompStm->get_tecompMinor())
    {
      adjustLevels(&tecompStmAtts_a_tecompMinor, "tecompStm a_tecompMinor");
      if (log && !findString("a_tecompMinor", tecompStmAtts))
	{
	  warnAtt("a_tecompMinor", "tecompStm", a_tecompStm);
	  check_tecompMinor(a_tecompStm->get_tecompMinor(), 0);
	}
      else
	check_tecompMinor(a_tecompStm->get_tecompMinor(), log);
    }
}

/********************************************************************/

void check_tecompVar2(
 tecompVar2 * a_tecompVar2,
 int log)
{
  if (isA(a_tecompVar2, tecompDatum))
    {
      adjustLevels(&tecompVar2Subs_tecompDatum, "tecompDatum");
      if (log && !findString("tecompDatum", tecompVar2Subs))
	{
	  warnSub("tecompDatum", "tecompVar2", a_tecompVar2);
	  check_tecompDatum(dynamic_cast<tecompDatum *>(a_tecompVar2), 0);
	}
      else
	check_tecompDatum(dynamic_cast<tecompDatum *>(a_tecompVar2), log);
      return;
    }
  if (isA(a_tecompVar2, tecompOffset))
    {
      adjustLevels(&tecompVar2Subs_tecompOffset, "tecompOffset");
      if (log && !findString("tecompOffset", tecompVar2Subs))
	{
	  warnSub("tecompOffset", "tecompVar2", a_tecompVar2);
	  check_tecompOffset(
	    dynamic_cast<tecompOffset *>(a_tecompVar2), 0);
	}
      else
	check_tecompOffset(
	  dynamic_cast<tecompOffset *>(a_tecompVar2), log);
      return;
    }
}

/********************************************************************/

void check_tempUnit(
 tempUnit * a_tempUnit,
 int log)
{
  if (isA(a_tempUnit, tempUnit_TEMPF))
    {
      adjustLevels(&tempUnitSubs_tempUnit_TEMPF, "tempUnit_TEMPF");
      if (log && !findString("tempUnit_TEMPF", tempUnitSubs))
	{
	  warnSub("tempUnit_TEMPF", "tempUnit", a_tempUnit);
	}
      return;
    }
  if (isA(a_tempUnit, tempUnit_TEMPC))
    {
      adjustLevels(&tempUnitSubs_tempUnit_TEMPC, "tempUnit_TEMPC");
      if (log && !findString("tempUnit_TEMPC", tempUnitSubs))
	{
	  warnSub("tempUnit_TEMPC", "tempUnit", a_tempUnit);
	}
      return;
    }
}

/********************************************************************/

void check_textMan(
 textMan * a_textMan,
 int log)
{
  if (a_textMan->get_text())
    {
      adjustLevels(&textManAtts_text, "textMan text");
      if (log && !findString("text", textManAtts))
	{
	  warnAtt("text", "textMan", a_textMan);
	  check_stringVal(a_textMan->get_text(), 0);
	}
      else
	check_stringVal(a_textMan->get_text(), log);
    }
}

/********************************************************************/

void check_textMinor(
 textMinor * a_textMinor,
 int log)
{
  if (isA(a_textMinor, textMan))
    {
      adjustLevels(&textMinorSubs_textMan, "textMan");
      if (log && !findString("textMan", textMinorSubs))
	{
	  warnSub("textMan", "textMinor", a_textMinor);
	  check_textMan(dynamic_cast<textMan *>(a_textMinor), 0);
	}
      else
	check_textMan(dynamic_cast<textMan *>(a_textMinor), log);
      return;
    }
  if (isA(a_textMinor, textOper))
    {
      adjustLevels(&textMinorSubs_textOper, "textOper");
      if (log && !findString("textOper", textMinorSubs))
	{
	  warnSub("textOper", "textMinor", a_textMinor);
	  check_textOper(dynamic_cast<textOper *>(a_textMinor), 0);
	}
      else
	check_textOper(dynamic_cast<textOper *>(a_textMinor), log);
      return;
    }
  if (isA(a_textMinor, textOutfil))
    {
      adjustLevels(&textMinorSubs_textOutfil, "textOutfil");
      if (log && !findString("textOutfil", textMinorSubs))
	{
	  warnSub("textOutfil", "textMinor", a_textMinor);
	  check_textOutfil(dynamic_cast<textOutfil *>(a_textMinor), 0);
	}
      else
	check_textOutfil(dynamic_cast<textOutfil *>(a_textMinor), log);
      return;
    }
  if (isA(a_textMinor, textQuery))
    {
      adjustLevels(&textMinorSubs_textQuery, "textQuery");
      if (log && !findString("textQuery", textMinorSubs))
	{
	  warnSub("textQuery", "textMinor", a_textMinor);
	  check_textQuery(dynamic_cast<textQuery *>(a_textMinor), 0);
	}
      else
	check_textQuery(dynamic_cast<textQuery *>(a_textMinor), log);
      return;
    }
}

/********************************************************************/

void check_textOper(
 textOper * a_textOper,
 int log)
{
  if (a_textOper->get_text())
    {
      adjustLevels(&textOperAtts_text, "textOper text");
      if (log && !findString("text", textOperAtts))
	{
	  warnAtt("text", "textOper", a_textOper);
	  check_stringVal(a_textOper->get_text(), 0);
	}
      else
	check_stringVal(a_textOper->get_text(), log);
    }
}

/********************************************************************/

void check_textOutfil(
 textOutfil * a_textOutfil,
 int log)
{
  if (a_textOutfil->get_text())
    {
      adjustLevels(&textOutfilAtts_text, "textOutfil text");
      if (log && !findString("text", textOutfilAtts))
	{
	  warnAtt("text", "textOutfil", a_textOutfil);
	  check_stringVal(a_textOutfil->get_text(), 0);
	}
      else
	check_stringVal(a_textOutfil->get_text(), log);
    }
}

/********************************************************************/

void check_textQuery(
 textQuery * a_textQuery,
 int log)
{
  if (a_textQuery->get_textQueryFormat())
    {
      adjustLevels(&textQueryAtts_a_textQueryFormat,
		   "textQuery a_textQueryFormat");
      if (log && !findString("a_textQueryFormat", textQueryAtts))
	{
	  warnAtt("a_textQueryFormat", "textQuery", a_textQuery);
	  check_textQueryFormat(a_textQuery->get_textQueryFormat(), 0);
	}
      else
	check_textQueryFormat(a_textQuery->get_textQueryFormat(), log);
    }
  if (a_textQuery->get_text())
    {
      adjustLevels(&textQueryAtts_text, "textQuery text");
      if (log && !findString("text", textQueryAtts))
	{
	  warnAtt("text", "textQuery", a_textQuery);
	  check_stringVal(a_textQuery->get_text(), 0);
	}
      else
	check_stringVal(a_textQuery->get_text(), log);
    }
}

/********************************************************************/

void check_textQueryFormat(
 textQueryFormat * a_textQueryFormat,
 int log)
{
  if (a_textQueryFormat->get_labelName())
    {
      adjustLevels(&textQueryFormatAtts_a_labelName,
		   "textQueryFormat a_labelName");
      if (log && !findString("a_labelName", textQueryFormatAtts))
	{
	  warnAtt("a_labelName", "textQueryFormat", a_textQueryFormat);
	  check_labelName(a_textQueryFormat->get_labelName(), 0);
	}
      else
	check_labelName(a_textQueryFormat->get_labelName(), log);
    }
  if (a_textQueryFormat->get_length())
    {
      adjustLevels(&textQueryFormatAtts_length, "textQueryFormat length");
      if (log && !findString("length", textQueryFormatAtts))
	{
	  warnAtt("length", "textQueryFormat", a_textQueryFormat);
	  check_intVal(a_textQueryFormat->get_length(), 0);
	}
      else
	check_intVal(a_textQueryFormat->get_length(), log);
    }
  if (a_textQueryFormat->get_textType())
    {
      adjustLevels(&textQueryFormatAtts_a_textType,
		   "textQueryFormat a_textType");
      if (log && !findString("a_textType", textQueryFormatAtts))
	{
	  warnAtt("a_textType", "textQueryFormat", a_textQueryFormat);
	  check_textType(a_textQueryFormat->get_textType(), 0);
	}
      else
	check_textType(a_textQueryFormat->get_textType(), log);
    }
  if (a_textQueryFormat->get_leftRight())
    {
      adjustLevels(&textQueryFormatAtts_a_leftRight,
		   "textQueryFormat a_leftRight");
      if (log && !findString("a_leftRight", textQueryFormatAtts))
	{
	  warnAtt("a_leftRight", "textQueryFormat", a_textQueryFormat);
	  check_leftRight(a_textQueryFormat->get_leftRight(), 0);
	}
      else
	check_leftRight(a_textQueryFormat->get_leftRight(), log);
    }
}

/********************************************************************/

void check_textStm(
 textStm * a_textStm,
 int log)
{
  if (a_textStm->get_textMinor())
    {
      adjustLevels(&textStmAtts_a_textMinor, "textStm a_textMinor");
      if (log && !findString("a_textMinor", textStmAtts))
	{
	  warnAtt("a_textMinor", "textStm", a_textStm);
	  check_textMinor(a_textStm->get_textMinor(), 0);
	}
      else
	check_textMinor(a_textStm->get_textMinor(), log);
    }
}

/********************************************************************/

void check_textType(
 textType * a_textType,
 int log)
{
  if (isA(a_textType, textType_ALPHA))
    {
      adjustLevels(&textTypeSubs_textType_ALPHA, "textType_ALPHA");
      if (log && !findString("textType_ALPHA", textTypeSubs))
	{
	  warnSub("textType_ALPHA", "textType", a_textType);
	}
      return;
    }
  if (isA(a_textType, textType_NUMERIC))
    {
      adjustLevels(&textTypeSubs_textType_NUMERIC, "textType_NUMERIC");
      if (log && !findString("textType_NUMERIC", textTypeSubs))
	{
	  warnSub("textType_NUMERIC", "textType", a_textType);
	}
      return;
    }
  if (isA(a_textType, textType_PRNTCHAR))
    {
      adjustLevels(&textTypeSubs_textType_PRNTCHAR, "textType_PRNTCHAR");
      if (log && !findString("textType_PRNTCHAR", textTypeSubs))
	{
	  warnSub("textType_PRNTCHAR", "textType", a_textType);
	}
      return;
    }
}

/********************************************************************/

void check_thLabel(
 thLabel * a_thLabel,
 int log)
{
  if (a_thLabel->get_labelName())
    {
      adjustLevels(&thLabelAtts_a_labelName, "thLabel a_labelName");
      if (log && !findString("a_labelName", thLabelAtts))
	{
	  warnAtt("a_labelName", "thLabel", a_thLabel);
	  check_labelName(a_thLabel->get_labelName(), 0);
	}
      else
	check_labelName(a_thLabel->get_labelName(), log);
    }
}

/********************************************************************/

void check_thldefPocket(
 thldefPocket * a_thldefPocket,
 int log)
{
  if (isA(a_thldefPocket, thldefPocket_sLabel))
    {
      adjustLevels(&thldefPocketSubs_thldefPocket_sLabel,
		   "thldefPocket_sLabel");
      if (log && !findString("thldefPocket_sLabel", thldefPocketSubs))
	{
	  warnSub("thldefPocket_sLabel", "thldefPocket", a_thldefPocket);
	  check_thldefPocket_sLabel(
	    dynamic_cast<thldefPocket_sLabel *>(a_thldefPocket), 0);
	}
      else
	check_thldefPocket_sLabel(
	  dynamic_cast<thldefPocket_sLabel *>(a_thldefPocket), log);
      return;
    }
  if (isA(a_thldefPocket, thldefPocket_ssLabel))
    {
      adjustLevels(&thldefPocketSubs_thldefPocket_ssLabel,
		   "thldefPocket_ssLabel");
      if (log && !findString("thldefPocket_ssLabel", thldefPocketSubs))
	{
	  warnSub("thldefPocket_ssLabel", "thldefPocket", a_thldefPocket);
	  check_thldefPocket_ssLabel(
	    dynamic_cast<thldefPocket_ssLabel *>(a_thldefPocket), 0);
	}
      else
	check_thldefPocket_ssLabel(
	  dynamic_cast<thldefPocket_ssLabel *>(a_thldefPocket), log);
      return;
    }
  if (isA(a_thldefPocket, thldefPocket_sgsLabel))
    {
      adjustLevels(&thldefPocketSubs_thldefPocket_sgsLabel,
		   "thldefPocket_sgsLabel");
      if (log && !findString("thldefPocket_sgsLabel", thldefPocketSubs))
	{
	  warnSub("thldefPocket_sgsLabel", "thldefPocket", a_thldefPocket);
	  check_thldefPocket_sgsLabel(
	    dynamic_cast<thldefPocket_sgsLabel *>(a_thldefPocket), 0);
	}
      else
	check_thldefPocket_sgsLabel(
	  dynamic_cast<thldefPocket_sgsLabel *>(a_thldefPocket), log);
      return;
    }
  if (isA(a_thldefPocket, thldefPocket_sgLabel))
    {
      adjustLevels(&thldefPocketSubs_thldefPocket_sgLabel,
		   "thldefPocket_sgLabel");
      if (log && !findString("thldefPocket_sgLabel", thldefPocketSubs))
	{
	  warnSub("thldefPocket_sgLabel", "thldefPocket", a_thldefPocket);
	  check_thldefPocket_sgLabel(
	    dynamic_cast<thldefPocket_sgLabel *>(a_thldefPocket), 0);
	}
      else
	check_thldefPocket_sgLabel(
	  dynamic_cast<thldefPocket_sgLabel *>(a_thldefPocket), log);
      return;
    }
  if (isA(a_thldefPocket, thldefPocket_swLabel))
    {
      adjustLevels(&thldefPocketSubs_thldefPocket_swLabel,
		   "thldefPocket_swLabel");
      if (log && !findString("thldefPocket_swLabel", thldefPocketSubs))
	{
	  warnSub("thldefPocket_swLabel", "thldefPocket", a_thldefPocket);
	  check_thldefPocket_swLabel(
	    dynamic_cast<thldefPocket_swLabel *>(a_thldefPocket), 0);
	}
      else
	check_thldefPocket_swLabel(
	  dynamic_cast<thldefPocket_swLabel *>(a_thldefPocket), log);
      return;
    }
  if (isA(a_thldefPocket, thldefPocket_sxLabel))
    {
      adjustLevels(&thldefPocketSubs_thldefPocket_sxLabel,
		   "thldefPocket_sxLabel");
      if (log && !findString("thldefPocket_sxLabel", thldefPocketSubs))
	{
	  warnSub("thldefPocket_sxLabel", "thldefPocket", a_thldefPocket);
	  check_thldefPocket_sxLabel(
	    dynamic_cast<thldefPocket_sxLabel *>(a_thldefPocket), 0);
	}
      else
	check_thldefPocket_sxLabel(
	  dynamic_cast<thldefPocket_sxLabel *>(a_thldefPocket), log);
      return;
    }
  if (isA(a_thldefPocket, thldefPocket_rmLabel))
    {
      adjustLevels(&thldefPocketSubs_thldefPocket_rmLabel,
		   "thldefPocket_rmLabel");
      if (log && !findString("thldefPocket_rmLabel", thldefPocketSubs))
	{
	  warnSub("thldefPocket_rmLabel", "thldefPocket", a_thldefPocket);
	  check_thldefPocket_rmLabel(
	    dynamic_cast<thldefPocket_rmLabel *>(a_thldefPocket), 0);
	}
      else
	check_thldefPocket_rmLabel(
	  dynamic_cast<thldefPocket_rmLabel *>(a_thldefPocket), log);
      return;
    }
}

/********************************************************************/

void check_thldefPocket_rmLabel(
 thldefPocket_rmLabel * a_thldefPocket_rmLabel,
 int log)
{
  if (a_thldefPocket_rmLabel->get_rmLabel())
    {
      adjustLevels(&thldefPocket_rmLabelAtts_a_rmLabel,
		   "thldefPocket_rmLabel a_rmLabel");
      if (log && !findString("a_rmLabel", thldefPocket_rmLabelAtts))
	{
	  warnAtt("a_rmLabel", "thldefPocket_rmLabel",
		  a_thldefPocket_rmLabel);
	  check_rmLabel(a_thldefPocket_rmLabel->get_rmLabel(), 0);
	}
      else
	check_rmLabel(a_thldefPocket_rmLabel->get_rmLabel(), log);
    }
  if (a_thldefPocket_rmLabel->get_pocket())
    {
      adjustLevels(&thldefPocket_rmLabelAtts_pocket,
		   "thldefPocket_rmLabel pocket");
      if (log && !findString("pocket", thldefPocket_rmLabelAtts))
	{
	  warnAtt("pocket", "thldefPocket_rmLabel", a_thldefPocket_rmLabel);
	  check_intVal(a_thldefPocket_rmLabel->get_pocket(), 0);
	}
      else
	check_intVal(a_thldefPocket_rmLabel->get_pocket(), log);
    }
}

/********************************************************************/

void check_thldefPocket_sLabel(
 thldefPocket_sLabel * a_thldefPocket_sLabel,
 int log)
{
  if (a_thldefPocket_sLabel->get_sLabel())
    {
      adjustLevels(&thldefPocket_sLabelAtts_a_sLabel,
		   "thldefPocket_sLabel a_sLabel");
      if (log && !findString("a_sLabel", thldefPocket_sLabelAtts))
	{
	  warnAtt("a_sLabel", "thldefPocket_sLabel", a_thldefPocket_sLabel);
	  check_sLabel(a_thldefPocket_sLabel->get_sLabel(), 0);
	}
      else
	check_sLabel(a_thldefPocket_sLabel->get_sLabel(), log);
    }
  if (a_thldefPocket_sLabel->get_pocket())
    {
      adjustLevels(&thldefPocket_sLabelAtts_pocket,
		   "thldefPocket_sLabel pocket");
      if (log && !findString("pocket", thldefPocket_sLabelAtts))
	{
	  warnAtt("pocket", "thldefPocket_sLabel", a_thldefPocket_sLabel);
	  check_intVal(a_thldefPocket_sLabel->get_pocket(), 0);
	}
      else
	check_intVal(a_thldefPocket_sLabel->get_pocket(), log);
    }
}

/********************************************************************/

void check_thldefPocket_sgLabel(
 thldefPocket_sgLabel * a_thldefPocket_sgLabel,
 int log)
{
  if (a_thldefPocket_sgLabel->get_sgLabel())
    {
      adjustLevels(&thldefPocket_sgLabelAtts_a_sgLabel,
		   "thldefPocket_sgLabel a_sgLabel");
      if (log && !findString("a_sgLabel", thldefPocket_sgLabelAtts))
	{
	  warnAtt("a_sgLabel", "thldefPocket_sgLabel",
		  a_thldefPocket_sgLabel);
	  check_sgLabel(a_thldefPocket_sgLabel->get_sgLabel(), 0);
	}
      else
	check_sgLabel(a_thldefPocket_sgLabel->get_sgLabel(), log);
    }
  if (a_thldefPocket_sgLabel->get_pocket())
    {
      adjustLevels(&thldefPocket_sgLabelAtts_pocket,
		   "thldefPocket_sgLabel pocket");
      if (log && !findString("pocket", thldefPocket_sgLabelAtts))
	{
	  warnAtt("pocket", "thldefPocket_sgLabel", a_thldefPocket_sgLabel);
	  check_intVal(a_thldefPocket_sgLabel->get_pocket(), 0);
	}
      else
	check_intVal(a_thldefPocket_sgLabel->get_pocket(), log);
    }
}

/********************************************************************/

void check_thldefPocket_sgsLabel(
 thldefPocket_sgsLabel * a_thldefPocket_sgsLabel,
 int log)
{
  if (a_thldefPocket_sgsLabel->get_sgsLabel())
    {
      adjustLevels(&thldefPocket_sgsLabelAtts_a_sgsLabel,
		   "thldefPocket_sgsLabel a_sgsLabel");
      if (log && !findString("a_sgsLabel", thldefPocket_sgsLabelAtts))
	{
	  warnAtt("a_sgsLabel", "thldefPocket_sgsLabel",
		  a_thldefPocket_sgsLabel);
	  check_sgsLabel(a_thldefPocket_sgsLabel->get_sgsLabel(), 0);
	}
      else
	check_sgsLabel(a_thldefPocket_sgsLabel->get_sgsLabel(), log);
    }
  if (a_thldefPocket_sgsLabel->get_pocket())
    {
      adjustLevels(&thldefPocket_sgsLabelAtts_pocket,
		   "thldefPocket_sgsLabel pocket");
      if (log && !findString("pocket", thldefPocket_sgsLabelAtts))
	{
	  warnAtt("pocket", "thldefPocket_sgsLabel", a_thldefPocket_sgsLabel);
	  check_intVal(a_thldefPocket_sgsLabel->get_pocket(), 0);
	}
      else
	check_intVal(a_thldefPocket_sgsLabel->get_pocket(), log);
    }
}

/********************************************************************/

void check_thldefPocket_ssLabel(
 thldefPocket_ssLabel * a_thldefPocket_ssLabel,
 int log)
{
  if (a_thldefPocket_ssLabel->get_ssLabel())
    {
      adjustLevels(&thldefPocket_ssLabelAtts_a_ssLabel,
		   "thldefPocket_ssLabel a_ssLabel");
      if (log && !findString("a_ssLabel", thldefPocket_ssLabelAtts))
	{
	  warnAtt("a_ssLabel", "thldefPocket_ssLabel",
		  a_thldefPocket_ssLabel);
	  check_ssLabel(a_thldefPocket_ssLabel->get_ssLabel(), 0);
	}
      else
	check_ssLabel(a_thldefPocket_ssLabel->get_ssLabel(), log);
    }
  if (a_thldefPocket_ssLabel->get_pocket())
    {
      adjustLevels(&thldefPocket_ssLabelAtts_pocket,
		   "thldefPocket_ssLabel pocket");
      if (log && !findString("pocket", thldefPocket_ssLabelAtts))
	{
	  warnAtt("pocket", "thldefPocket_ssLabel", a_thldefPocket_ssLabel);
	  check_intVal(a_thldefPocket_ssLabel->get_pocket(), 0);
	}
      else
	check_intVal(a_thldefPocket_ssLabel->get_pocket(), log);
    }
}

/********************************************************************/

void check_thldefPocket_swLabel(
 thldefPocket_swLabel * a_thldefPocket_swLabel,
 int log)
{
  if (a_thldefPocket_swLabel->get_swLabel())
    {
      adjustLevels(&thldefPocket_swLabelAtts_a_swLabel,
		   "thldefPocket_swLabel a_swLabel");
      if (log && !findString("a_swLabel", thldefPocket_swLabelAtts))
	{
	  warnAtt("a_swLabel", "thldefPocket_swLabel",
		  a_thldefPocket_swLabel);
	  check_swLabel(a_thldefPocket_swLabel->get_swLabel(), 0);
	}
      else
	check_swLabel(a_thldefPocket_swLabel->get_swLabel(), log);
    }
  if (a_thldefPocket_swLabel->get_pocket())
    {
      adjustLevels(&thldefPocket_swLabelAtts_pocket,
		   "thldefPocket_swLabel pocket");
      if (log && !findString("pocket", thldefPocket_swLabelAtts))
	{
	  warnAtt("pocket", "thldefPocket_swLabel", a_thldefPocket_swLabel);
	  check_intVal(a_thldefPocket_swLabel->get_pocket(), 0);
	}
      else
	check_intVal(a_thldefPocket_swLabel->get_pocket(), log);
    }
}

/********************************************************************/

void check_thldefPocket_sxLabel(
 thldefPocket_sxLabel * a_thldefPocket_sxLabel,
 int log)
{
  if (a_thldefPocket_sxLabel->get_sxLabel())
    {
      adjustLevels(&thldefPocket_sxLabelAtts_a_sxLabel,
		   "thldefPocket_sxLabel a_sxLabel");
      if (log && !findString("a_sxLabel", thldefPocket_sxLabelAtts))
	{
	  warnAtt("a_sxLabel", "thldefPocket_sxLabel",
		  a_thldefPocket_sxLabel);
	  check_sxLabel(a_thldefPocket_sxLabel->get_sxLabel(), 0);
	}
      else
	check_sxLabel(a_thldefPocket_sxLabel->get_sxLabel(), log);
    }
  if (a_thldefPocket_sxLabel->get_pocket())
    {
      adjustLevels(&thldefPocket_sxLabelAtts_pocket,
		   "thldefPocket_sxLabel pocket");
      if (log && !findString("pocket", thldefPocket_sxLabelAtts))
	{
	  warnAtt("pocket", "thldefPocket_sxLabel", a_thldefPocket_sxLabel);
	  check_intVal(a_thldefPocket_sxLabel->get_pocket(), 0);
	}
      else
	check_intVal(a_thldefPocket_sxLabel->get_pocket(), log);
    }
}

/********************************************************************/

void check_thldefStm(
 thldefStm * a_thldefStm,
 int log)
{
  if (a_thldefStm->get_thLabel())
    {
      adjustLevels(&thldefStmAtts_a_thLabel, "thldefStm a_thLabel");
      if (log && !findString("a_thLabel", thldefStmAtts))
	{
	  warnAtt("a_thLabel", "thldefStm", a_thldefStm);
	  check_thLabel(a_thldefStm->get_thLabel(), 0);
	}
      else
	check_thLabel(a_thldefStm->get_thLabel(), log);
    }
  if (a_thldefStm->get_thldefPocketList())
    {
      std::list<thldefPocket *> * theList;
      std::list<thldefPocket *>::iterator iter;
      theList = a_thldefStm->get_thldefPocketList();
      adjustLevels(&thldefStmAtts_a_thldefPocketList,
		   "thldefStm a_thldefPocketList");
      if (log && !findString("a_thldefPocketList", thldefStmAtts))
	{
	  warnAtt("a_thldefPocketList", "thldefStm", a_thldefStm);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_thldefPocket(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_thldefPocket(*iter, log);
	}
    }
}

/********************************************************************/

void check_tier(
 tier * a_tier,
 int log)
{
  if (isA(a_tier, tier_UPTIER))
    {
      adjustLevels(&tierSubs_tier_UPTIER, "tier_UPTIER");
      if (log && !findString("tier_UPTIER", tierSubs))
	{
	  warnSub("tier_UPTIER", "tier", a_tier);
	}
      return;
    }
  if (isA(a_tier, tier_LOTIER))
    {
      adjustLevels(&tierSubs_tier_LOTIER, "tier_LOTIER");
      if (log && !findString("tier_LOTIER", tierSubs))
	{
	  warnSub("tier_LOTIER", "tier", a_tier);
	}
      return;
    }
}

/********************************************************************/

void check_tlLabel(
 tlLabel * a_tlLabel,
 int log)
{
  if (a_tlLabel->get_labelName())
    {
      adjustLevels(&tlLabelAtts_a_labelName, "tlLabel a_labelName");
      if (log && !findString("a_labelName", tlLabelAtts))
	{
	  warnAtt("a_labelName", "tlLabel", a_tlLabel);
	  check_labelName(a_tlLabel->get_labelName(), 0);
	}
      else
	check_labelName(a_tlLabel->get_labelName(), log);
    }
}

/********************************************************************/

void check_tolAnglStm(
 tolAnglStm * a_tolAnglStm,
 int log)
{
  if (a_tolAnglStm->get_tLabel())
    {
      adjustLevels(&tolAnglStmAtts_a_tLabel, "tolAnglStm a_tLabel");
      if (log && !findString("a_tLabel", tolAnglStmAtts))
	{
	  warnAtt("a_tLabel", "tolAnglStm", a_tolAnglStm);
	  check_tLabel(a_tolAnglStm->get_tLabel(), 0);
	}
      else
	check_tLabel(a_tolAnglStm->get_tLabel(), log);
    }
  if (a_tolAnglStm->get_lotol())
    {
      adjustLevels(&tolAnglStmAtts_lotol, "tolAnglStm lotol");
      if (log && !findString("lotol", tolAnglStmAtts))
	{
	  warnAtt("lotol", "tolAnglStm", a_tolAnglStm);
	  check_angle(a_tolAnglStm->get_lotol(), 0);
	}
      else
	check_angle(a_tolAnglStm->get_lotol(), log);
    }
  if (a_tolAnglStm->get_uptol())
    {
      adjustLevels(&tolAnglStmAtts_uptol, "tolAnglStm uptol");
      if (log && !findString("uptol", tolAnglStmAtts))
	{
	  warnAtt("uptol", "tolAnglStm", a_tolAnglStm);
	  check_angle(a_tolAnglStm->get_uptol(), 0);
	}
      else
	check_angle(a_tolAnglStm->get_uptol(), log);
    }
}

/********************************************************************/

void check_tolAnglbStm(
 tolAnglbStm * a_tolAnglbStm,
 int log)
{
  if (a_tolAnglbStm->get_tLabel())
    {
      adjustLevels(&tolAnglbStmAtts_a_tLabel, "tolAnglbStm a_tLabel");
      if (log && !findString("a_tLabel", tolAnglbStmAtts))
	{
	  warnAtt("a_tLabel", "tolAnglbStm", a_tolAnglbStm);
	  check_tLabel(a_tolAnglbStm->get_tLabel(), 0);
	}
      else
	check_tLabel(a_tolAnglbStm->get_tLabel(), log);
    }
  if (a_tolAnglbStm->get_ang())
    {
      adjustLevels(&tolAnglbStmAtts_ang, "tolAnglbStm ang");
      if (log && !findString("ang", tolAnglbStmAtts))
	{
	  warnAtt("ang", "tolAnglbStm", a_tolAnglbStm);
	  check_angle(a_tolAnglbStm->get_ang(), 0);
	}
      else
	check_angle(a_tolAnglbStm->get_ang(), log);
    }
  if (a_tolAnglbStm->get_lotol())
    {
      adjustLevels(&tolAnglbStmAtts_lotol, "tolAnglbStm lotol");
      if (log && !findString("lotol", tolAnglbStmAtts))
	{
	  warnAtt("lotol", "tolAnglbStm", a_tolAnglbStm);
	  check_angle(a_tolAnglbStm->get_lotol(), 0);
	}
      else
	check_angle(a_tolAnglbStm->get_lotol(), log);
    }
  if (a_tolAnglbStm->get_uptol())
    {
      adjustLevels(&tolAnglbStmAtts_uptol, "tolAnglbStm uptol");
      if (log && !findString("uptol", tolAnglbStmAtts))
	{
	  warnAtt("uptol", "tolAnglbStm", a_tolAnglbStm);
	  check_angle(a_tolAnglbStm->get_uptol(), 0);
	}
      else
	check_angle(a_tolAnglbStm->get_uptol(), log);
    }
  if (a_tolAnglbStm->get_tolZoneDir2())
    {
      adjustLevels(&tolAnglbStmAtts_a_tolZoneDir2,
		   "tolAnglbStm a_tolZoneDir2");
      if (log && !findString("a_tolZoneDir2", tolAnglbStmAtts))
	{
	  warnAtt("a_tolZoneDir2", "tolAnglbStm", a_tolAnglbStm);
	  check_tolZoneDir2(a_tolAnglbStm->get_tolZoneDir2(), 0);
	}
      else
	check_tolZoneDir2(a_tolAnglbStm->get_tolZoneDir2(), log);
    }
}

/********************************************************************/

void check_tolAnglrStm(
 tolAnglrStm * a_tolAnglrStm,
 int log)
{
  if (a_tolAnglrStm->get_tLabel())
    {
      adjustLevels(&tolAnglrStmAtts_a_tLabel, "tolAnglrStm a_tLabel");
      if (log && !findString("a_tLabel", tolAnglrStmAtts))
	{
	  warnAtt("a_tLabel", "tolAnglrStm", a_tolAnglrStm);
	  check_tLabel(a_tolAnglrStm->get_tLabel(), 0);
	}
      else
	check_tLabel(a_tolAnglrStm->get_tLabel(), log);
    }
  if (a_tolAnglrStm->get_angle())
    {
      adjustLevels(&tolAnglrStmAtts_a_angle, "tolAnglrStm a_angle");
      if (log && !findString("a_angle", tolAnglrStmAtts))
	{
	  warnAtt("a_angle", "tolAnglrStm", a_tolAnglrStm);
	  check_angle(a_tolAnglrStm->get_angle(), 0);
	}
      else
	check_angle(a_tolAnglrStm->get_angle(), log);
    }
  if (a_tolAnglrStm->get_tolAppData())
    {
      adjustLevels(&tolAnglrStmAtts_a_tolAppData, "tolAnglrStm a_tolAppData");
      if (log && !findString("a_tolAppData", tolAnglrStmAtts))
	{
	  warnAtt("a_tolAppData", "tolAnglrStm", a_tolAnglrStm);
	  check_tolAppData(a_tolAnglrStm->get_tolAppData(), 0);
	}
      else
	check_tolAppData(a_tolAnglrStm->get_tolAppData(), log);
    }
}

/********************************************************************/

void check_tolAnglwrtStm(
 tolAnglwrtStm * a_tolAnglwrtStm,
 int log)
{
  if (a_tolAnglwrtStm->get_tLabel())
    {
      adjustLevels(&tolAnglwrtStmAtts_a_tLabel, "tolAnglwrtStm a_tLabel");
      if (log && !findString("a_tLabel", tolAnglwrtStmAtts))
	{
	  warnAtt("a_tLabel", "tolAnglwrtStm", a_tolAnglwrtStm);
	  check_tLabel(a_tolAnglwrtStm->get_tLabel(), 0);
	}
      else
	check_tLabel(a_tolAnglwrtStm->get_tLabel(), log);
    }
  if (a_tolAnglwrtStm->get_ang())
    {
      adjustLevels(&tolAnglwrtStmAtts_ang, "tolAnglwrtStm ang");
      if (log && !findString("ang", tolAnglwrtStmAtts))
	{
	  warnAtt("ang", "tolAnglwrtStm", a_tolAnglwrtStm);
	  check_angle(a_tolAnglwrtStm->get_ang(), 0);
	}
      else
	check_angle(a_tolAnglwrtStm->get_ang(), log);
    }
  if (a_tolAnglwrtStm->get_lotol())
    {
      adjustLevels(&tolAnglwrtStmAtts_lotol, "tolAnglwrtStm lotol");
      if (log && !findString("lotol", tolAnglwrtStmAtts))
	{
	  warnAtt("lotol", "tolAnglwrtStm", a_tolAnglwrtStm);
	  check_angle(a_tolAnglwrtStm->get_lotol(), 0);
	}
      else
	check_angle(a_tolAnglwrtStm->get_lotol(), log);
    }
  if (a_tolAnglwrtStm->get_uptol())
    {
      adjustLevels(&tolAnglwrtStmAtts_uptol, "tolAnglwrtStm uptol");
      if (log && !findString("uptol", tolAnglwrtStmAtts))
	{
	  warnAtt("uptol", "tolAnglwrtStm", a_tolAnglwrtStm);
	  check_angle(a_tolAnglwrtStm->get_uptol(), 0);
	}
      else
	check_angle(a_tolAnglwrtStm->get_uptol(), log);
    }
  if (a_tolAnglwrtStm->get_tolFeature())
    {
      adjustLevels(&tolAnglwrtStmAtts_a_tolFeature,
		   "tolAnglwrtStm a_tolFeature");
      if (log && !findString("a_tolFeature", tolAnglwrtStmAtts))
	{
	  warnAtt("a_tolFeature", "tolAnglwrtStm", a_tolAnglwrtStm);
	  check_tolFeature(a_tolAnglwrtStm->get_tolFeature(), 0);
	}
      else
	check_tolFeature(a_tolAnglwrtStm->get_tolFeature(), log);
    }
  if (a_tolAnglwrtStm->get_tolZoneDir2())
    {
      adjustLevels(&tolAnglwrtStmAtts_a_tolZoneDir2,
		   "tolAnglwrtStm a_tolZoneDir2");
      if (log && !findString("a_tolZoneDir2", tolAnglwrtStmAtts))
	{
	  warnAtt("a_tolZoneDir2", "tolAnglwrtStm", a_tolAnglwrtStm);
	  check_tolZoneDir2(a_tolAnglwrtStm->get_tolZoneDir2(), 0);
	}
      else
	check_tolZoneDir2(a_tolAnglwrtStm->get_tolZoneDir2(), log);
    }
}

/********************************************************************/

void check_tolAppData(
 tolAppData * a_tolAppData,
 int log)
{
  if (a_tolAppData->get_tolzon())
    {
      adjustLevels(&tolAppDataAtts_tolzon, "tolAppData tolzon");
      if (log && !findString("tolzon", tolAppDataAtts))
	{
	  warnAtt("tolzon", "tolAppData", a_tolAppData);
	  check_rentVal(a_tolAppData->get_tolzon(), 0);
	}
      else
	check_rentVal(a_tolAppData->get_tolzon(), log);
    }
  if (a_tolAppData->get_tolMaxMatCond())
    {
      adjustLevels(&tolAppDataAtts_a_tolMaxMatCond,
		   "tolAppData a_tolMaxMatCond");
      if (log && !findString("a_tolMaxMatCond", tolAppDataAtts))
	{
	  warnAtt("a_tolMaxMatCond", "tolAppData", a_tolAppData);
	  check_tolMaxMatCond(a_tolAppData->get_tolMaxMatCond(), 0);
	}
      else
	check_tolMaxMatCond(a_tolAppData->get_tolMaxMatCond(), log);
    }
  if (a_tolAppData->get_ref1())
    {
      adjustLevels(&tolAppDataAtts_ref1, "tolAppData ref1");
      if (log && !findString("ref1", tolAppDataAtts))
	{
	  warnAtt("ref1", "tolAppData", a_tolAppData);
	  check_tolFeatMaxMat(a_tolAppData->get_ref1(), 0);
	}
      else
	check_tolFeatMaxMat(a_tolAppData->get_ref1(), log);
    }
  if (a_tolAppData->get_ref2())
    {
      adjustLevels(&tolAppDataAtts_ref2, "tolAppData ref2");
      if (log && !findString("ref2", tolAppDataAtts))
	{
	  warnAtt("ref2", "tolAppData", a_tolAppData);
	  check_tolFeatMaxMat(a_tolAppData->get_ref2(), 0);
	}
      else
	check_tolFeatMaxMat(a_tolAppData->get_ref2(), log);
    }
  if (a_tolAppData->get_tolZoneType())
    {
      adjustLevels(&tolAppDataAtts_a_tolZoneType, "tolAppData a_tolZoneType");
      if (log && !findString("a_tolZoneType", tolAppDataAtts))
	{
	  warnAtt("a_tolZoneType", "tolAppData", a_tolAppData);
	  check_tolZoneType(a_tolAppData->get_tolZoneType(), 0);
	}
      else
	check_tolZoneType(a_tolAppData->get_tolZoneType(), log);
    }
  if (a_tolAppData->get_tolZoneDir())
    {
      adjustLevels(&tolAppDataAtts_a_tolZoneDir, "tolAppData a_tolZoneDir");
      if (log && !findString("a_tolZoneDir", tolAppDataAtts))
	{
	  warnAtt("a_tolZoneDir", "tolAppData", a_tolAppData);
	  check_tolZoneDir(a_tolAppData->get_tolZoneDir(), 0);
	}
      else
	check_tolZoneDir(a_tolAppData->get_tolZoneDir(), log);
    }
}

/********************************************************************/

void check_tolCirltyStm(
 tolCirltyStm * a_tolCirltyStm,
 int log)
{
  if (a_tolCirltyStm->get_tLabel())
    {
      adjustLevels(&tolCirltyStmAtts_a_tLabel, "tolCirltyStm a_tLabel");
      if (log && !findString("a_tLabel", tolCirltyStmAtts))
	{
	  warnAtt("a_tLabel", "tolCirltyStm", a_tolCirltyStm);
	  check_tLabel(a_tolCirltyStm->get_tLabel(), 0);
	}
      else
	check_tLabel(a_tolCirltyStm->get_tLabel(), log);
    }
  if (a_tolCirltyStm->get_tolzon())
    {
      adjustLevels(&tolCirltyStmAtts_tolzon, "tolCirltyStm tolzon");
      if (log && !findString("tolzon", tolCirltyStmAtts))
	{
	  warnAtt("tolzon", "tolCirltyStm", a_tolCirltyStm);
	  check_rentVal(a_tolCirltyStm->get_tolzon(), 0);
	}
      else
	check_rentVal(a_tolCirltyStm->get_tolzon(), log);
    }
}

/********************************************************************/

void check_tolCompos1(
 tolCompos1 * a_tolCompos1,
 int log)
{
  if (a_tolCompos1->get_tolzon1())
    {
      adjustLevels(&tolCompos1Atts_tolzon1, "tolCompos1 tolzon1");
      if (log && !findString("tolzon1", tolCompos1Atts))
	{
	  warnAtt("tolzon1", "tolCompos1", a_tolCompos1);
	  check_rentVal(a_tolCompos1->get_tolzon1(), 0);
	}
      else
	check_rentVal(a_tolCompos1->get_tolzon1(), log);
    }
  if (a_tolCompos1->get_tolMatCond())
    {
      adjustLevels(&tolCompos1Atts_a_tolMatCond, "tolCompos1 a_tolMatCond");
      if (log && !findString("a_tolMatCond", tolCompos1Atts))
	{
	  warnAtt("a_tolMatCond", "tolCompos1", a_tolCompos1);
	  check_tolMatCond(a_tolCompos1->get_tolMatCond(), 0);
	}
      else
	check_tolMatCond(a_tolCompos1->get_tolMatCond(), log);
    }
  if (a_tolCompos1->get_tfm1())
    {
      adjustLevels(&tolCompos1Atts_tfm1, "tolCompos1 tfm1");
      if (log && !findString("tfm1", tolCompos1Atts))
	{
	  warnAtt("tfm1", "tolCompos1", a_tolCompos1);
	  check_tolFeatureMat(a_tolCompos1->get_tfm1(), 0);
	}
      else
	check_tolFeatureMat(a_tolCompos1->get_tfm1(), log);
    }
  if (a_tolCompos1->get_tfm2())
    {
      adjustLevels(&tolCompos1Atts_tfm2, "tolCompos1 tfm2");
      if (log && !findString("tfm2", tolCompos1Atts))
	{
	  warnAtt("tfm2", "tolCompos1", a_tolCompos1);
	  check_tolFeatureMat(a_tolCompos1->get_tfm2(), 0);
	}
      else
	check_tolFeatureMat(a_tolCompos1->get_tfm2(), log);
    }
  if (a_tolCompos1->get_tfm3())
    {
      adjustLevels(&tolCompos1Atts_tfm3, "tolCompos1 tfm3");
      if (log && !findString("tfm3", tolCompos1Atts))
	{
	  warnAtt("tfm3", "tolCompos1", a_tolCompos1);
	  check_tolFeatureMat(a_tolCompos1->get_tfm3(), 0);
	}
      else
	check_tolFeatureMat(a_tolCompos1->get_tfm3(), log);
    }
}

/********************************************************************/

void check_tolCompos2(
 tolCompos2 * a_tolCompos2,
 int log)
{
  if (a_tolCompos2->get_tolzon2())
    {
      adjustLevels(&tolCompos2Atts_tolzon2, "tolCompos2 tolzon2");
      if (log && !findString("tolzon2", tolCompos2Atts))
	{
	  warnAtt("tolzon2", "tolCompos2", a_tolCompos2);
	  check_rentVal(a_tolCompos2->get_tolzon2(), 0);
	}
      else
	check_rentVal(a_tolCompos2->get_tolzon2(), log);
    }
  if (a_tolCompos2->get_tolMatCond())
    {
      adjustLevels(&tolCompos2Atts_a_tolMatCond, "tolCompos2 a_tolMatCond");
      if (log && !findString("a_tolMatCond", tolCompos2Atts))
	{
	  warnAtt("a_tolMatCond", "tolCompos2", a_tolCompos2);
	  check_tolMatCond(a_tolCompos2->get_tolMatCond(), 0);
	}
      else
	check_tolMatCond(a_tolCompos2->get_tolMatCond(), log);
    }
  if (a_tolCompos2->get_tfm1())
    {
      adjustLevels(&tolCompos2Atts_tfm1, "tolCompos2 tfm1");
      if (log && !findString("tfm1", tolCompos2Atts))
	{
	  warnAtt("tfm1", "tolCompos2", a_tolCompos2);
	  check_tolFeatureMat(a_tolCompos2->get_tfm1(), 0);
	}
      else
	check_tolFeatureMat(a_tolCompos2->get_tfm1(), log);
    }
  if (a_tolCompos2->get_tfm2())
    {
      adjustLevels(&tolCompos2Atts_tfm2, "tolCompos2 tfm2");
      if (log && !findString("tfm2", tolCompos2Atts))
	{
	  warnAtt("tfm2", "tolCompos2", a_tolCompos2);
	  check_tolFeatureMat(a_tolCompos2->get_tfm2(), 0);
	}
      else
	check_tolFeatureMat(a_tolCompos2->get_tfm2(), log);
    }
  if (a_tolCompos2->get_tfm3())
    {
      adjustLevels(&tolCompos2Atts_tfm3, "tolCompos2 tfm3");
      if (log && !findString("tfm3", tolCompos2Atts))
	{
	  warnAtt("tfm3", "tolCompos2", a_tolCompos2);
	  check_tolFeatureMat(a_tolCompos2->get_tfm3(), 0);
	}
      else
	check_tolFeatureMat(a_tolCompos2->get_tfm3(), log);
    }
}

/********************************************************************/

void check_tolComposStm(
 tolComposStm * a_tolComposStm,
 int log)
{
  if (a_tolComposStm->get_tLabel())
    {
      adjustLevels(&tolComposStmAtts_a_tLabel, "tolComposStm a_tLabel");
      if (log && !findString("a_tLabel", tolComposStmAtts))
	{
	  warnAtt("a_tLabel", "tolComposStm", a_tolComposStm);
	  check_tLabel(a_tolComposStm->get_tLabel(), 0);
	}
      else
	check_tLabel(a_tolComposStm->get_tLabel(), log);
    }
  if (a_tolComposStm->get_tolCompos1())
    {
      adjustLevels(&tolComposStmAtts_a_tolCompos1,
		   "tolComposStm a_tolCompos1");
      if (log && !findString("a_tolCompos1", tolComposStmAtts))
	{
	  warnAtt("a_tolCompos1", "tolComposStm", a_tolComposStm);
	  check_tolCompos1(a_tolComposStm->get_tolCompos1(), 0);
	}
      else
	check_tolCompos1(a_tolComposStm->get_tolCompos1(), log);
    }
  if (a_tolComposStm->get_tolCompos2())
    {
      adjustLevels(&tolComposStmAtts_a_tolCompos2,
		   "tolComposStm a_tolCompos2");
      if (log && !findString("a_tolCompos2", tolComposStmAtts))
	{
	  warnAtt("a_tolCompos2", "tolComposStm", a_tolComposStm);
	  check_tolCompos2(a_tolComposStm->get_tolCompos2(), 0);
	}
      else
	check_tolCompos2(a_tolComposStm->get_tolCompos2(), log);
    }
}

/********************************************************************/

void check_tolConcenStm(
 tolConcenStm * a_tolConcenStm,
 int log)
{
  if (a_tolConcenStm->get_tLabel())
    {
      adjustLevels(&tolConcenStmAtts_a_tLabel, "tolConcenStm a_tLabel");
      if (log && !findString("a_tLabel", tolConcenStmAtts))
	{
	  warnAtt("a_tLabel", "tolConcenStm", a_tolConcenStm);
	  check_tLabel(a_tolConcenStm->get_tLabel(), 0);
	}
      else
	check_tLabel(a_tolConcenStm->get_tLabel(), log);
    }
  if (a_tolConcenStm->get_tolzon())
    {
      adjustLevels(&tolConcenStmAtts_tolzon, "tolConcenStm tolzon");
      if (log && !findString("tolzon", tolConcenStmAtts))
	{
	  warnAtt("tolzon", "tolConcenStm", a_tolConcenStm);
	  check_rentVal(a_tolConcenStm->get_tolzon(), 0);
	}
      else
	check_rentVal(a_tolConcenStm->get_tolzon(), log);
    }
  if (a_tolConcenStm->get_tolFeature())
    {
      adjustLevels(&tolConcenStmAtts_a_tolFeature,
		   "tolConcenStm a_tolFeature");
      if (log && !findString("a_tolFeature", tolConcenStmAtts))
	{
	  warnAtt("a_tolFeature", "tolConcenStm", a_tolConcenStm);
	  check_tolFeature(a_tolConcenStm->get_tolFeature(), 0);
	}
      else
	check_tolFeature(a_tolConcenStm->get_tolFeature(), log);
    }
}

/********************************************************************/

void check_tolCortolAngle(
 tolCortolAngle * a_tolCortolAngle,
 int log)
{
  if (a_tolCortolAngle->get_lotol())
    {
      adjustLevels(&tolCortolAngleAtts_lotol, "tolCortolAngle lotol");
      if (log && !findString("lotol", tolCortolAngleAtts))
	{
	  warnAtt("lotol", "tolCortolAngle", a_tolCortolAngle);
	  check_rentVal(a_tolCortolAngle->get_lotol(), 0);
	}
      else
	check_rentVal(a_tolCortolAngle->get_lotol(), log);
    }
  if (a_tolCortolAngle->get_uptol())
    {
      adjustLevels(&tolCortolAngleAtts_uptol, "tolCortolAngle uptol");
      if (log && !findString("uptol", tolCortolAngleAtts))
	{
	  warnAtt("uptol", "tolCortolAngle", a_tolCortolAngle);
	  check_rentVal(a_tolCortolAngle->get_uptol(), 0);
	}
      else
	check_rentVal(a_tolCortolAngle->get_uptol(), log);
    }
}

/********************************************************************/

void check_tolCortolAxis(
 tolCortolAxis * a_tolCortolAxis,
 int log)
{
  if (a_tolCortolAxis->get_axis())
    {
      adjustLevels(&tolCortolAxisAtts_a_axis, "tolCortolAxis a_axis");
      if (log && !findString("a_axis", tolCortolAxisAtts))
	{
	  warnAtt("a_axis", "tolCortolAxis", a_tolCortolAxis);
	  check_axis(a_tolCortolAxis->get_axis(), 0);
	}
      else
	check_axis(a_tolCortolAxis->get_axis(), log);
    }
  if (a_tolCortolAxis->get_lotol())
    {
      adjustLevels(&tolCortolAxisAtts_lotol, "tolCortolAxis lotol");
      if (log && !findString("lotol", tolCortolAxisAtts))
	{
	  warnAtt("lotol", "tolCortolAxis", a_tolCortolAxis);
	  check_rentVal(a_tolCortolAxis->get_lotol(), 0);
	}
      else
	check_rentVal(a_tolCortolAxis->get_lotol(), log);
    }
  if (a_tolCortolAxis->get_uptol())
    {
      adjustLevels(&tolCortolAxisAtts_uptol, "tolCortolAxis uptol");
      if (log && !findString("uptol", tolCortolAxisAtts))
	{
	  warnAtt("uptol", "tolCortolAxis", a_tolCortolAxis);
	  check_rentVal(a_tolCortolAxis->get_uptol(), 0);
	}
      else
	check_rentVal(a_tolCortolAxis->get_uptol(), log);
    }
  if (a_tolCortolAxis->get_axial())
    {
      adjustLevels(&tolCortolAxisAtts_a_axial, "tolCortolAxis a_axial");
      if (log && !findString("a_axial", tolCortolAxisAtts))
	{
	  warnAtt("a_axial", "tolCortolAxis", a_tolCortolAxis);
	  check_axial(a_tolCortolAxis->get_axial(), 0);
	}
      else
	check_axial(a_tolCortolAxis->get_axial(), log);
    }
}

/********************************************************************/

void check_tolCortolMinor(
 tolCortolMinor * a_tolCortolMinor,
 int log)
{
  if (isA(a_tolCortolMinor, tolCortolAxis))
    {
      adjustLevels(&tolCortolMinorSubs_tolCortolAxis, "tolCortolAxis");
      if (log && !findString("tolCortolAxis", tolCortolMinorSubs))
	{
	  warnSub("tolCortolAxis", "tolCortolMinor", a_tolCortolMinor);
	  check_tolCortolAxis(
	    dynamic_cast<tolCortolAxis *>(a_tolCortolMinor), 0);
	}
      else
	check_tolCortolAxis(
	  dynamic_cast<tolCortolAxis *>(a_tolCortolMinor), log);
      return;
    }
  if (isA(a_tolCortolMinor, tolCortolRadial))
    {
      adjustLevels(&tolCortolMinorSubs_tolCortolRadial, "tolCortolRadial");
      if (log && !findString("tolCortolRadial", tolCortolMinorSubs))
	{
	  warnSub("tolCortolRadial", "tolCortolMinor", a_tolCortolMinor);
	  check_tolCortolRadial(
	    dynamic_cast<tolCortolRadial *>(a_tolCortolMinor), 0);
	}
      else
	check_tolCortolRadial(
	  dynamic_cast<tolCortolRadial *>(a_tolCortolMinor), log);
      return;
    }
  if (isA(a_tolCortolMinor, tolCortolAngle))
    {
      adjustLevels(&tolCortolMinorSubs_tolCortolAngle, "tolCortolAngle");
      if (log && !findString("tolCortolAngle", tolCortolMinorSubs))
	{
	  warnSub("tolCortolAngle", "tolCortolMinor", a_tolCortolMinor);
	  check_tolCortolAngle(
	    dynamic_cast<tolCortolAngle *>(a_tolCortolMinor), 0);
	}
      else
	check_tolCortolAngle(
	  dynamic_cast<tolCortolAngle *>(a_tolCortolMinor), log);
      return;
    }
}

/********************************************************************/

void check_tolCortolRadial(
 tolCortolRadial * a_tolCortolRadial,
 int log)
{
  if (a_tolCortolRadial->get_lotol())
    {
      adjustLevels(&tolCortolRadialAtts_lotol, "tolCortolRadial lotol");
      if (log && !findString("lotol", tolCortolRadialAtts))
	{
	  warnAtt("lotol", "tolCortolRadial", a_tolCortolRadial);
	  check_rentVal(a_tolCortolRadial->get_lotol(), 0);
	}
      else
	check_rentVal(a_tolCortolRadial->get_lotol(), log);
    }
  if (a_tolCortolRadial->get_uptol())
    {
      adjustLevels(&tolCortolRadialAtts_uptol, "tolCortolRadial uptol");
      if (log && !findString("uptol", tolCortolRadialAtts))
	{
	  warnAtt("uptol", "tolCortolRadial", a_tolCortolRadial);
	  check_rentVal(a_tolCortolRadial->get_uptol(), 0);
	}
      else
	check_rentVal(a_tolCortolRadial->get_uptol(), log);
    }
}

/********************************************************************/

void check_tolCortolStm(
 tolCortolStm * a_tolCortolStm,
 int log)
{
  if (a_tolCortolStm->get_tLabel())
    {
      adjustLevels(&tolCortolStmAtts_a_tLabel, "tolCortolStm a_tLabel");
      if (log && !findString("a_tLabel", tolCortolStmAtts))
	{
	  warnAtt("a_tLabel", "tolCortolStm", a_tolCortolStm);
	  check_tLabel(a_tolCortolStm->get_tLabel(), 0);
	}
      else
	check_tLabel(a_tolCortolStm->get_tLabel(), log);
    }
  if (a_tolCortolStm->get_tolCortolMinor())
    {
      adjustLevels(&tolCortolStmAtts_a_tolCortolMinor,
		   "tolCortolStm a_tolCortolMinor");
      if (log && !findString("a_tolCortolMinor", tolCortolStmAtts))
	{
	  warnAtt("a_tolCortolMinor", "tolCortolStm", a_tolCortolStm);
	  check_tolCortolMinor(a_tolCortolStm->get_tolCortolMinor(), 0);
	}
      else
	check_tolCortolMinor(a_tolCortolStm->get_tolCortolMinor(), log);
    }
}

/********************************************************************/

void check_tolCprofSpec(
 tolCprofSpec * a_tolCprofSpec,
 int log)
{
  if (a_tolCprofSpec->get_lotol())
    {
      adjustLevels(&tolCprofSpecAtts_lotol, "tolCprofSpec lotol");
      if (log && !findString("lotol", tolCprofSpecAtts))
	{
	  warnAtt("lotol", "tolCprofSpec", a_tolCprofSpec);
	  check_rentVal(a_tolCprofSpec->get_lotol(), 0);
	}
      else
	check_rentVal(a_tolCprofSpec->get_lotol(), log);
    }
  if (a_tolCprofSpec->get_uptol())
    {
      adjustLevels(&tolCprofSpecAtts_uptol, "tolCprofSpec uptol");
      if (log && !findString("uptol", tolCprofSpecAtts))
	{
	  warnAtt("uptol", "tolCprofSpec", a_tolCprofSpec);
	  check_rentVal(a_tolCprofSpec->get_uptol(), 0);
	}
      else
	check_rentVal(a_tolCprofSpec->get_uptol(), log);
    }
  if (a_tolCprofSpec->get_tfm1())
    {
      adjustLevels(&tolCprofSpecAtts_tfm1, "tolCprofSpec tfm1");
      if (log && !findString("tfm1", tolCprofSpecAtts))
	{
	  warnAtt("tfm1", "tolCprofSpec", a_tolCprofSpec);
	  check_tolFeatureMat(a_tolCprofSpec->get_tfm1(), 0);
	}
      else
	check_tolFeatureMat(a_tolCprofSpec->get_tfm1(), log);
    }
  if (a_tolCprofSpec->get_tfm2())
    {
      adjustLevels(&tolCprofSpecAtts_tfm2, "tolCprofSpec tfm2");
      if (log && !findString("tfm2", tolCprofSpecAtts))
	{
	  warnAtt("tfm2", "tolCprofSpec", a_tolCprofSpec);
	  check_tolFeatureMat(a_tolCprofSpec->get_tfm2(), 0);
	}
      else
	check_tolFeatureMat(a_tolCprofSpec->get_tfm2(), log);
    }
  if (a_tolCprofSpec->get_tfm3())
    {
      adjustLevels(&tolCprofSpecAtts_tfm3, "tolCprofSpec tfm3");
      if (log && !findString("tfm3", tolCprofSpecAtts))
	{
	  warnAtt("tfm3", "tolCprofSpec", a_tolCprofSpec);
	  check_tolFeatureMat(a_tolCprofSpec->get_tfm3(), 0);
	}
      else
	check_tolFeatureMat(a_tolCprofSpec->get_tfm3(), log);
    }
  if (a_tolCprofSpec->get_has_AVGDEV())
    {
      adjustLevels(&tolCprofSpecAtts_has_AVGDEV, "tolCprofSpec has_AVGDEV");
      if (log && !findString("has_AVGDEV", tolCprofSpecAtts))
	{
	  warnAtt("has_AVGDEV", "tolCprofSpec", a_tolCprofSpec);
	}
    }
}

/********************************************************************/

void check_tolCprofSpecC(
 tolCprofSpecC * a_tolCprofSpecC,
 int log)
{
  if (a_tolCprofSpecC->get_lotol())
    {
      adjustLevels(&tolCprofSpecCAtts_lotol, "tolCprofSpecC lotol");
      if (log && !findString("lotol", tolCprofSpecCAtts))
	{
	  warnAtt("lotol", "tolCprofSpecC", a_tolCprofSpecC);
	  check_rentVal(a_tolCprofSpecC->get_lotol(), 0);
	}
      else
	check_rentVal(a_tolCprofSpecC->get_lotol(), log);
    }
  if (a_tolCprofSpecC->get_uptol())
    {
      adjustLevels(&tolCprofSpecCAtts_uptol, "tolCprofSpecC uptol");
      if (log && !findString("uptol", tolCprofSpecCAtts))
	{
	  warnAtt("uptol", "tolCprofSpecC", a_tolCprofSpecC);
	  check_rentVal(a_tolCprofSpecC->get_uptol(), 0);
	}
      else
	check_rentVal(a_tolCprofSpecC->get_uptol(), log);
    }
  if (a_tolCprofSpecC->get_tfm1())
    {
      adjustLevels(&tolCprofSpecCAtts_tfm1, "tolCprofSpecC tfm1");
      if (log && !findString("tfm1", tolCprofSpecCAtts))
	{
	  warnAtt("tfm1", "tolCprofSpecC", a_tolCprofSpecC);
	  check_tolFeatureMat(a_tolCprofSpecC->get_tfm1(), 0);
	}
      else
	check_tolFeatureMat(a_tolCprofSpecC->get_tfm1(), log);
    }
  if (a_tolCprofSpecC->get_tfm2())
    {
      adjustLevels(&tolCprofSpecCAtts_tfm2, "tolCprofSpecC tfm2");
      if (log && !findString("tfm2", tolCprofSpecCAtts))
	{
	  warnAtt("tfm2", "tolCprofSpecC", a_tolCprofSpecC);
	  check_tolFeatureMat(a_tolCprofSpecC->get_tfm2(), 0);
	}
      else
	check_tolFeatureMat(a_tolCprofSpecC->get_tfm2(), log);
    }
  if (a_tolCprofSpecC->get_tfm3())
    {
      adjustLevels(&tolCprofSpecCAtts_tfm3, "tolCprofSpecC tfm3");
      if (log && !findString("tfm3", tolCprofSpecCAtts))
	{
	  warnAtt("tfm3", "tolCprofSpecC", a_tolCprofSpecC);
	  check_tolFeatureMat(a_tolCprofSpecC->get_tfm3(), 0);
	}
      else
	check_tolFeatureMat(a_tolCprofSpecC->get_tfm3(), log);
    }
  if (a_tolCprofSpecC->get_has_AVGDEV())
    {
      adjustLevels(&tolCprofSpecCAtts_has_AVGDEV, "tolCprofSpecC has_AVGDEV");
      if (log && !findString("has_AVGDEV", tolCprofSpecCAtts))
	{
	  warnAtt("has_AVGDEV", "tolCprofSpecC", a_tolCprofSpecC);
	}
    }
}

/********************************************************************/

void check_tolCproflStm(
 tolCproflStm * a_tolCproflStm,
 int log)
{
  if (a_tolCproflStm->get_tLabel())
    {
      adjustLevels(&tolCproflStmAtts_a_tLabel, "tolCproflStm a_tLabel");
      if (log && !findString("a_tLabel", tolCproflStmAtts))
	{
	  warnAtt("a_tLabel", "tolCproflStm", a_tolCproflStm);
	  check_tLabel(a_tolCproflStm->get_tLabel(), 0);
	}
      else
	check_tLabel(a_tolCproflStm->get_tLabel(), log);
    }
  if (a_tolCproflStm->get_upper())
    {
      adjustLevels(&tolCproflStmAtts_upper, "tolCproflStm upper");
      if (log && !findString("upper", tolCproflStmAtts))
	{
	  warnAtt("upper", "tolCproflStm", a_tolCproflStm);
	  check_tolCprofSpecC(a_tolCproflStm->get_upper(), 0);
	}
      else
	check_tolCprofSpecC(a_tolCproflStm->get_upper(), log);
    }
  if (a_tolCproflStm->get_lower())
    {
      adjustLevels(&tolCproflStmAtts_lower, "tolCproflStm lower");
      if (log && !findString("lower", tolCproflStmAtts))
	{
	  warnAtt("lower", "tolCproflStm", a_tolCproflStm);
	  check_tolCprofSpec(a_tolCproflStm->get_lower(), 0);
	}
      else
	check_tolCprofSpec(a_tolCproflStm->get_lower(), log);
    }
}

/********************************************************************/

void check_tolCprofsStm(
 tolCprofsStm * a_tolCprofsStm,
 int log)
{
  if (a_tolCprofsStm->get_tLabel())
    {
      adjustLevels(&tolCprofsStmAtts_a_tLabel, "tolCprofsStm a_tLabel");
      if (log && !findString("a_tLabel", tolCprofsStmAtts))
	{
	  warnAtt("a_tLabel", "tolCprofsStm", a_tolCprofsStm);
	  check_tLabel(a_tolCprofsStm->get_tLabel(), 0);
	}
      else
	check_tLabel(a_tolCprofsStm->get_tLabel(), log);
    }
  if (a_tolCprofsStm->get_upper())
    {
      adjustLevels(&tolCprofsStmAtts_upper, "tolCprofsStm upper");
      if (log && !findString("upper", tolCprofsStmAtts))
	{
	  warnAtt("upper", "tolCprofsStm", a_tolCprofsStm);
	  check_tolCprofSpecC(a_tolCprofsStm->get_upper(), 0);
	}
      else
	check_tolCprofSpecC(a_tolCprofsStm->get_upper(), log);
    }
  if (a_tolCprofsStm->get_lower())
    {
      adjustLevels(&tolCprofsStmAtts_lower, "tolCprofsStm lower");
      if (log && !findString("lower", tolCprofsStmAtts))
	{
	  warnAtt("lower", "tolCprofsStm", a_tolCprofsStm);
	  check_tolCprofSpec(a_tolCprofsStm->get_lower(), 0);
	}
      else
	check_tolCprofSpec(a_tolCprofsStm->get_lower(), log);
    }
}

/********************************************************************/

void check_tolCrnoutStm(
 tolCrnoutStm * a_tolCrnoutStm,
 int log)
{
  if (a_tolCrnoutStm->get_tLabel())
    {
      adjustLevels(&tolCrnoutStmAtts_a_tLabel, "tolCrnoutStm a_tLabel");
      if (log && !findString("a_tLabel", tolCrnoutStmAtts))
	{
	  warnAtt("a_tLabel", "tolCrnoutStm", a_tolCrnoutStm);
	  check_tLabel(a_tolCrnoutStm->get_tLabel(), 0);
	}
      else
	check_tLabel(a_tolCrnoutStm->get_tLabel(), log);
    }
  if (a_tolCrnoutStm->get_tolzon())
    {
      adjustLevels(&tolCrnoutStmAtts_tolzon, "tolCrnoutStm tolzon");
      if (log && !findString("tolzon", tolCrnoutStmAtts))
	{
	  warnAtt("tolzon", "tolCrnoutStm", a_tolCrnoutStm);
	  check_rentVal(a_tolCrnoutStm->get_tolzon(), 0);
	}
      else
	check_rentVal(a_tolCrnoutStm->get_tolzon(), log);
    }
  if (a_tolCrnoutStm->get_datLabel())
    {
      adjustLevels(&tolCrnoutStmAtts_a_datLabel, "tolCrnoutStm a_datLabel");
      if (log && !findString("a_datLabel", tolCrnoutStmAtts))
	{
	  warnAtt("a_datLabel", "tolCrnoutStm", a_tolCrnoutStm);
	  check_datLabel(a_tolCrnoutStm->get_datLabel(), 0);
	}
      else
	check_datLabel(a_tolCrnoutStm->get_datLabel(), log);
    }
  if (a_tolCrnoutStm->get_tolFeat1())
    {
      adjustLevels(&tolCrnoutStmAtts_tolFeat1, "tolCrnoutStm tolFeat1");
      if (log && !findString("tolFeat1", tolCrnoutStmAtts))
	{
	  warnAtt("tolFeat1", "tolCrnoutStm", a_tolCrnoutStm);
	  check_tolFeature(a_tolCrnoutStm->get_tolFeat1(), 0);
	}
      else
	check_tolFeature(a_tolCrnoutStm->get_tolFeat1(), log);
    }
  if (a_tolCrnoutStm->get_tolFeat2())
    {
      adjustLevels(&tolCrnoutStmAtts_tolFeat2, "tolCrnoutStm tolFeat2");
      if (log && !findString("tolFeat2", tolCrnoutStmAtts))
	{
	  warnAtt("tolFeat2", "tolCrnoutStm", a_tolCrnoutStm);
	  check_tolFeature(a_tolCrnoutStm->get_tolFeat2(), 0);
	}
      else
	check_tolFeature(a_tolCrnoutStm->get_tolFeat2(), log);
    }
  if (a_tolCrnoutStm->get_dir())
    {
      adjustLevels(&tolCrnoutStmAtts_dir, "tolCrnoutStm dir");
      if (log && !findString("dir", tolCrnoutStmAtts))
	{
	  warnAtt("dir", "tolCrnoutStm", a_tolCrnoutStm);
	  check_vector(a_tolCrnoutStm->get_dir(), 0);
	}
      else
	check_vector(a_tolCrnoutStm->get_dir(), log);
    }
}

/********************************************************************/

void check_tolCylctyStm(
 tolCylctyStm * a_tolCylctyStm,
 int log)
{
  if (a_tolCylctyStm->get_tLabel())
    {
      adjustLevels(&tolCylctyStmAtts_a_tLabel, "tolCylctyStm a_tLabel");
      if (log && !findString("a_tLabel", tolCylctyStmAtts))
	{
	  warnAtt("a_tLabel", "tolCylctyStm", a_tolCylctyStm);
	  check_tLabel(a_tolCylctyStm->get_tLabel(), 0);
	}
      else
	check_tLabel(a_tolCylctyStm->get_tLabel(), log);
    }
  if (a_tolCylctyStm->get_tolzon())
    {
      adjustLevels(&tolCylctyStmAtts_tolzon, "tolCylctyStm tolzon");
      if (log && !findString("tolzon", tolCylctyStmAtts))
	{
	  warnAtt("tolzon", "tolCylctyStm", a_tolCylctyStm);
	  check_rentVal(a_tolCylctyStm->get_tolzon(), 0);
	}
      else
	check_rentVal(a_tolCylctyStm->get_tolzon(), log);
    }
}

/********************************************************************/

void check_tolDiamAvg(
 tolDiamAvg * a_tolDiamAvg,
 int log)
{
  if (a_tolDiamAvg->get_lotol())
    {
      adjustLevels(&tolDiamAvgAtts_lotol, "tolDiamAvg lotol");
      if (log && !findString("lotol", tolDiamAvgAtts))
	{
	  warnAtt("lotol", "tolDiamAvg", a_tolDiamAvg);
	  check_rentVal(a_tolDiamAvg->get_lotol(), 0);
	}
      else
	check_rentVal(a_tolDiamAvg->get_lotol(), log);
    }
  if (a_tolDiamAvg->get_uptol())
    {
      adjustLevels(&tolDiamAvgAtts_uptol, "tolDiamAvg uptol");
      if (log && !findString("uptol", tolDiamAvgAtts))
	{
	  warnAtt("uptol", "tolDiamAvg", a_tolDiamAvg);
	  check_rentVal(a_tolDiamAvg->get_uptol(), 0);
	}
      else
	check_rentVal(a_tolDiamAvg->get_uptol(), log);
    }
  if (a_tolDiamAvg->get_radiusSpec())
    {
      adjustLevels(&tolDiamAvgAtts_a_radiusSpec, "tolDiamAvg a_radiusSpec");
      if (log && !findString("a_radiusSpec", tolDiamAvgAtts))
	{
	  warnAtt("a_radiusSpec", "tolDiamAvg", a_tolDiamAvg);
	  check_radiusSpec(a_tolDiamAvg->get_radiusSpec(), 0);
	}
      else
	check_radiusSpec(a_tolDiamAvg->get_radiusSpec(), log);
    }
}

/********************************************************************/

void check_tolDiamMinmax(
 tolDiamMinmax * a_tolDiamMinmax,
 int log)
{
  if (a_tolDiamMinmax->get_lotol())
    {
      adjustLevels(&tolDiamMinmaxAtts_lotol, "tolDiamMinmax lotol");
      if (log && !findString("lotol", tolDiamMinmaxAtts))
	{
	  warnAtt("lotol", "tolDiamMinmax", a_tolDiamMinmax);
	  check_rentVal(a_tolDiamMinmax->get_lotol(), 0);
	}
      else
	check_rentVal(a_tolDiamMinmax->get_lotol(), log);
    }
  if (a_tolDiamMinmax->get_uptol())
    {
      adjustLevels(&tolDiamMinmaxAtts_uptol, "tolDiamMinmax uptol");
      if (log && !findString("uptol", tolDiamMinmaxAtts))
	{
	  warnAtt("uptol", "tolDiamMinmax", a_tolDiamMinmax);
	  check_rentVal(a_tolDiamMinmax->get_uptol(), 0);
	}
      else
	check_rentVal(a_tolDiamMinmax->get_uptol(), log);
    }
  if (a_tolDiamMinmax->get_radiusSpec())
    {
      adjustLevels(&tolDiamMinmaxAtts_a_radiusSpec,
		   "tolDiamMinmax a_radiusSpec");
      if (log && !findString("a_radiusSpec", tolDiamMinmaxAtts))
	{
	  warnAtt("a_radiusSpec", "tolDiamMinmax", a_tolDiamMinmax);
	  check_radiusSpec(a_tolDiamMinmax->get_radiusSpec(), 0);
	}
      else
	check_radiusSpec(a_tolDiamMinmax->get_radiusSpec(), log);
    }
}

/********************************************************************/

void check_tolDiamMinor(
 tolDiamMinor * a_tolDiamMinor,
 int log)
{
  if (isA(a_tolDiamMinor, tolDiamPlain))
    {
      adjustLevels(&tolDiamMinorSubs_tolDiamPlain, "tolDiamPlain");
      if (log && !findString("tolDiamPlain", tolDiamMinorSubs))
	{
	  warnSub("tolDiamPlain", "tolDiamMinor", a_tolDiamMinor);
	  check_tolDiamPlain(
	    dynamic_cast<tolDiamPlain *>(a_tolDiamMinor), 0);
	}
      else
	check_tolDiamPlain(
	  dynamic_cast<tolDiamPlain *>(a_tolDiamMinor), log);
      return;
    }
  if (isA(a_tolDiamMinor, tolDiamAvg))
    {
      adjustLevels(&tolDiamMinorSubs_tolDiamAvg, "tolDiamAvg");
      if (log && !findString("tolDiamAvg", tolDiamMinorSubs))
	{
	  warnSub("tolDiamAvg", "tolDiamMinor", a_tolDiamMinor);
	  check_tolDiamAvg(dynamic_cast<tolDiamAvg *>(a_tolDiamMinor), 0);
	}
      else
	check_tolDiamAvg(dynamic_cast<tolDiamAvg *>(a_tolDiamMinor), log);
      return;
    }
  if (isA(a_tolDiamMinor, tolDiamMinmax))
    {
      adjustLevels(&tolDiamMinorSubs_tolDiamMinmax, "tolDiamMinmax");
      if (log && !findString("tolDiamMinmax", tolDiamMinorSubs))
	{
	  warnSub("tolDiamMinmax", "tolDiamMinor", a_tolDiamMinor);
	  check_tolDiamMinmax(
	    dynamic_cast<tolDiamMinmax *>(a_tolDiamMinor), 0);
	}
      else
	check_tolDiamMinmax(
	  dynamic_cast<tolDiamMinmax *>(a_tolDiamMinor), log);
      return;
    }
}

/********************************************************************/

void check_tolDiamPlain(
 tolDiamPlain * a_tolDiamPlain,
 int log)
{
  if (a_tolDiamPlain->get_lotol())
    {
      adjustLevels(&tolDiamPlainAtts_lotol, "tolDiamPlain lotol");
      if (log && !findString("lotol", tolDiamPlainAtts))
	{
	  warnAtt("lotol", "tolDiamPlain", a_tolDiamPlain);
	  check_rentVal(a_tolDiamPlain->get_lotol(), 0);
	}
      else
	check_rentVal(a_tolDiamPlain->get_lotol(), log);
    }
  if (a_tolDiamPlain->get_uptol())
    {
      adjustLevels(&tolDiamPlainAtts_uptol, "tolDiamPlain uptol");
      if (log && !findString("uptol", tolDiamPlainAtts))
	{
	  warnAtt("uptol", "tolDiamPlain", a_tolDiamPlain);
	  check_rentVal(a_tolDiamPlain->get_uptol(), 0);
	}
      else
	check_rentVal(a_tolDiamPlain->get_uptol(), log);
    }
  if (a_tolDiamPlain->get_radiusSpec())
    {
      adjustLevels(&tolDiamPlainAtts_a_radiusSpec,
		   "tolDiamPlain a_radiusSpec");
      if (log && !findString("a_radiusSpec", tolDiamPlainAtts))
	{
	  warnAtt("a_radiusSpec", "tolDiamPlain", a_tolDiamPlain);
	  check_radiusSpec(a_tolDiamPlain->get_radiusSpec(), 0);
	}
      else
	check_radiusSpec(a_tolDiamPlain->get_radiusSpec(), log);
    }
}

/********************************************************************/

void check_tolDiamStm(
 tolDiamStm * a_tolDiamStm,
 int log)
{
  if (a_tolDiamStm->get_tLabel())
    {
      adjustLevels(&tolDiamStmAtts_a_tLabel, "tolDiamStm a_tLabel");
      if (log && !findString("a_tLabel", tolDiamStmAtts))
	{
	  warnAtt("a_tLabel", "tolDiamStm", a_tolDiamStm);
	  check_tLabel(a_tolDiamStm->get_tLabel(), 0);
	}
      else
	check_tLabel(a_tolDiamStm->get_tLabel(), log);
    }
  if (a_tolDiamStm->get_tolDiamMinor())
    {
      adjustLevels(&tolDiamStmAtts_a_tolDiamMinor,
		   "tolDiamStm a_tolDiamMinor");
      if (log && !findString("a_tolDiamMinor", tolDiamStmAtts))
	{
	  warnAtt("a_tolDiamMinor", "tolDiamStm", a_tolDiamStm);
	  check_tolDiamMinor(a_tolDiamStm->get_tolDiamMinor(), 0);
	}
      else
	check_tolDiamMinor(a_tolDiamStm->get_tolDiamMinor(), log);
    }
}

/********************************************************************/

void check_tolDistbDir(
 tolDistbDir * a_tolDistbDir,
 int log)
{
  if (isA(a_tolDistbDir, tolDistbDir_XAXIS))
    {
      adjustLevels(&tolDistbDirSubs_tolDistbDir_XAXIS, "tolDistbDir_XAXIS");
      if (log && !findString("tolDistbDir_XAXIS", tolDistbDirSubs))
	{
	  warnSub("tolDistbDir_XAXIS", "tolDistbDir", a_tolDistbDir);
	}
      return;
    }
  if (isA(a_tolDistbDir, tolDistbDir_YAXIS))
    {
      adjustLevels(&tolDistbDirSubs_tolDistbDir_YAXIS, "tolDistbDir_YAXIS");
      if (log && !findString("tolDistbDir_YAXIS", tolDistbDirSubs))
	{
	  warnSub("tolDistbDir_YAXIS", "tolDistbDir", a_tolDistbDir);
	}
      return;
    }
  if (isA(a_tolDistbDir, tolDistbDir_ZAXIS))
    {
      adjustLevels(&tolDistbDirSubs_tolDistbDir_ZAXIS, "tolDistbDir_ZAXIS");
      if (log && !findString("tolDistbDir_ZAXIS", tolDistbDirSubs))
	{
	  warnSub("tolDistbDir_ZAXIS", "tolDistbDir", a_tolDistbDir);
	}
      return;
    }
  if (isA(a_tolDistbDir, tolDistbDir_PT2PT))
    {
      adjustLevels(&tolDistbDirSubs_tolDistbDir_PT2PT, "tolDistbDir_PT2PT");
      if (log && !findString("tolDistbDir_PT2PT", tolDistbDirSubs))
	{
	  warnSub("tolDistbDir_PT2PT", "tolDistbDir", a_tolDistbDir);
	}
      return;
    }
}

/********************************************************************/

void check_tolDistbLimit(
 tolDistbLimit * a_tolDistbLimit,
 int log)
{
  if (a_tolDistbLimit->get_lolimt())
    {
      adjustLevels(&tolDistbLimitAtts_lolimt, "tolDistbLimit lolimt");
      if (log && !findString("lolimt", tolDistbLimitAtts))
	{
	  warnAtt("lolimt", "tolDistbLimit", a_tolDistbLimit);
	  check_rentVal(a_tolDistbLimit->get_lolimt(), 0);
	}
      else
	check_rentVal(a_tolDistbLimit->get_lolimt(), log);
    }
  if (a_tolDistbLimit->get_uplimt())
    {
      adjustLevels(&tolDistbLimitAtts_uplimt, "tolDistbLimit uplimt");
      if (log && !findString("uplimt", tolDistbLimitAtts))
	{
	  warnAtt("uplimt", "tolDistbLimit", a_tolDistbLimit);
	  check_rentVal(a_tolDistbLimit->get_uplimt(), 0);
	}
      else
	check_rentVal(a_tolDistbLimit->get_uplimt(), log);
    }
}

/********************************************************************/

void check_tolDistbNominl(
 tolDistbNominl * a_tolDistbNominl,
 int log)
{
  if (a_tolDistbNominl->get_dist())
    {
      adjustLevels(&tolDistbNominlAtts_dist, "tolDistbNominl dist");
      if (log && !findString("dist", tolDistbNominlAtts))
	{
	  warnAtt("dist", "tolDistbNominl", a_tolDistbNominl);
	  check_rentVal(a_tolDistbNominl->get_dist(), 0);
	}
      else
	check_rentVal(a_tolDistbNominl->get_dist(), log);
    }
  if (a_tolDistbNominl->get_lotol())
    {
      adjustLevels(&tolDistbNominlAtts_lotol, "tolDistbNominl lotol");
      if (log && !findString("lotol", tolDistbNominlAtts))
	{
	  warnAtt("lotol", "tolDistbNominl", a_tolDistbNominl);
	  check_rentVal(a_tolDistbNominl->get_lotol(), 0);
	}
      else
	check_rentVal(a_tolDistbNominl->get_lotol(), log);
    }
  if (a_tolDistbNominl->get_uptol())
    {
      adjustLevels(&tolDistbNominlAtts_uptol, "tolDistbNominl uptol");
      if (log && !findString("uptol", tolDistbNominlAtts))
	{
	  warnAtt("uptol", "tolDistbNominl", a_tolDistbNominl);
	  check_rentVal(a_tolDistbNominl->get_uptol(), 0);
	}
      else
	check_rentVal(a_tolDistbNominl->get_uptol(), log);
    }
}

/********************************************************************/

void check_tolDistbStm(
 tolDistbStm * a_tolDistbStm,
 int log)
{
  if (a_tolDistbStm->get_tLabel())
    {
      adjustLevels(&tolDistbStmAtts_a_tLabel, "tolDistbStm a_tLabel");
      if (log && !findString("a_tLabel", tolDistbStmAtts))
	{
	  warnAtt("a_tLabel", "tolDistbStm", a_tolDistbStm);
	  check_tLabel(a_tolDistbStm->get_tLabel(), 0);
	}
      else
	check_tLabel(a_tolDistbStm->get_tLabel(), log);
    }
  if (a_tolDistbStm->get_tolDistbTol())
    {
      adjustLevels(&tolDistbStmAtts_a_tolDistbTol,
		   "tolDistbStm a_tolDistbTol");
      if (log && !findString("a_tolDistbTol", tolDistbStmAtts))
	{
	  warnAtt("a_tolDistbTol", "tolDistbStm", a_tolDistbStm);
	  check_tolDistbTol(a_tolDistbStm->get_tolDistbTol(), 0);
	}
      else
	check_tolDistbTol(a_tolDistbStm->get_tolDistbTol(), log);
    }
  if (a_tolDistbStm->get_tolDistbDir())
    {
      adjustLevels(&tolDistbStmAtts_a_tolDistbDir,
		   "tolDistbStm a_tolDistbDir");
      if (log && !findString("a_tolDistbDir", tolDistbStmAtts))
	{
	  warnAtt("a_tolDistbDir", "tolDistbStm", a_tolDistbStm);
	  check_tolDistbDir(a_tolDistbStm->get_tolDistbDir(), 0);
	}
      else
	check_tolDistbDir(a_tolDistbStm->get_tolDistbDir(), log);
    }
  if (a_tolDistbStm->get_avgMaxMin())
    {
      adjustLevels(&tolDistbStmAtts_a_avgMaxMin, "tolDistbStm a_avgMaxMin");
      if (log && !findString("a_avgMaxMin", tolDistbStmAtts))
	{
	  warnAtt("a_avgMaxMin", "tolDistbStm", a_tolDistbStm);
	  check_avgMaxMin(a_tolDistbStm->get_avgMaxMin(), 0);
	}
      else
	check_avgMaxMin(a_tolDistbStm->get_avgMaxMin(), log);
    }
}

/********************************************************************/

void check_tolDistbTol(
 tolDistbTol * a_tolDistbTol,
 int log)
{
  if (isA(a_tolDistbTol, tolDistbLimit))
    {
      adjustLevels(&tolDistbTolSubs_tolDistbLimit, "tolDistbLimit");
      if (log && !findString("tolDistbLimit", tolDistbTolSubs))
	{
	  warnSub("tolDistbLimit", "tolDistbTol", a_tolDistbTol);
	  check_tolDistbLimit(
	    dynamic_cast<tolDistbLimit *>(a_tolDistbTol), 0);
	}
      else
	check_tolDistbLimit(
	  dynamic_cast<tolDistbLimit *>(a_tolDistbTol), log);
      return;
    }
  if (isA(a_tolDistbTol, tolDistbNominl))
    {
      adjustLevels(&tolDistbTolSubs_tolDistbNominl, "tolDistbNominl");
      if (log && !findString("tolDistbNominl", tolDistbTolSubs))
	{
	  warnSub("tolDistbNominl", "tolDistbTol", a_tolDistbTol);
	  check_tolDistbNominl(
	    dynamic_cast<tolDistbNominl *>(a_tolDistbTol), 0);
	}
      else
	check_tolDistbNominl(
	  dynamic_cast<tolDistbNominl *>(a_tolDistbTol), log);
      return;
    }
}

/********************************************************************/

void check_tolDistwrtStm(
 tolDistwrtStm * a_tolDistwrtStm,
 int log)
{
  if (a_tolDistwrtStm->get_tLabel())
    {
      adjustLevels(&tolDistwrtStmAtts_a_tLabel, "tolDistwrtStm a_tLabel");
      if (log && !findString("a_tLabel", tolDistwrtStmAtts))
	{
	  warnAtt("a_tLabel", "tolDistwrtStm", a_tolDistwrtStm);
	  check_tLabel(a_tolDistwrtStm->get_tLabel(), 0);
	}
      else
	check_tLabel(a_tolDistwrtStm->get_tLabel(), log);
    }
  if (a_tolDistwrtStm->get_tolDistbTol())
    {
      adjustLevels(&tolDistwrtStmAtts_a_tolDistbTol,
		   "tolDistwrtStm a_tolDistbTol");
      if (log && !findString("a_tolDistbTol", tolDistwrtStmAtts))
	{
	  warnAtt("a_tolDistbTol", "tolDistwrtStm", a_tolDistwrtStm);
	  check_tolDistbTol(a_tolDistwrtStm->get_tolDistbTol(), 0);
	}
      else
	check_tolDistbTol(a_tolDistwrtStm->get_tolDistbTol(), log);
    }
  if (a_tolDistwrtStm->get_tolFeature())
    {
      adjustLevels(&tolDistwrtStmAtts_a_tolFeature,
		   "tolDistwrtStm a_tolFeature");
      if (log && !findString("a_tolFeature", tolDistwrtStmAtts))
	{
	  warnAtt("a_tolFeature", "tolDistwrtStm", a_tolDistwrtStm);
	  check_tolFeature(a_tolDistwrtStm->get_tolFeature(), 0);
	}
      else
	check_tolFeature(a_tolDistwrtStm->get_tolFeature(), log);
    }
  if (a_tolDistwrtStm->get_tolDistbDir())
    {
      adjustLevels(&tolDistwrtStmAtts_a_tolDistbDir,
		   "tolDistwrtStm a_tolDistbDir");
      if (log && !findString("a_tolDistbDir", tolDistwrtStmAtts))
	{
	  warnAtt("a_tolDistbDir", "tolDistwrtStm", a_tolDistwrtStm);
	  check_tolDistbDir(a_tolDistwrtStm->get_tolDistbDir(), 0);
	}
      else
	check_tolDistbDir(a_tolDistwrtStm->get_tolDistbDir(), log);
    }
  if (a_tolDistwrtStm->get_avgMaxMin())
    {
      adjustLevels(&tolDistwrtStmAtts_a_avgMaxMin,
		   "tolDistwrtStm a_avgMaxMin");
      if (log && !findString("a_avgMaxMin", tolDistwrtStmAtts))
	{
	  warnAtt("a_avgMaxMin", "tolDistwrtStm", a_tolDistwrtStm);
	  check_avgMaxMin(a_tolDistwrtStm->get_avgMaxMin(), 0);
	}
      else
	check_avgMaxMin(a_tolDistwrtStm->get_avgMaxMin(), log);
    }
}

/********************************************************************/

void check_tolFeatMaxMat(
 tolFeatMaxMat * a_tolFeatMaxMat,
 int log)
{
  if (isA(a_tolFeatMaxMat, tolFeatMaxMat_datLabel))
    {
      adjustLevels(&tolFeatMaxMatSubs_tolFeatMaxMat_datLabel,
		   "tolFeatMaxMat_datLabel");
      if (log && !findString("tolFeatMaxMat_datLabel", tolFeatMaxMatSubs))
	{
	  warnSub("tolFeatMaxMat_datLabel", "tolFeatMaxMat", a_tolFeatMaxMat);
	  check_tolFeatMaxMat_datLabel(
	    dynamic_cast<tolFeatMaxMat_datLabel *>(a_tolFeatMaxMat), 0);
	}
      else
	check_tolFeatMaxMat_datLabel(
	  dynamic_cast<tolFeatMaxMat_datLabel *>(a_tolFeatMaxMat), log);
      return;
    }
  if (isA(a_tolFeatMaxMat, tolFeatMaxMat_faLabel))
    {
      adjustLevels(&tolFeatMaxMatSubs_tolFeatMaxMat_faLabel,
		   "tolFeatMaxMat_faLabel");
      if (log && !findString("tolFeatMaxMat_faLabel", tolFeatMaxMatSubs))
	{
	  warnSub("tolFeatMaxMat_faLabel", "tolFeatMaxMat", a_tolFeatMaxMat);
	  check_tolFeatMaxMat_faLabel(
	    dynamic_cast<tolFeatMaxMat_faLabel *>(a_tolFeatMaxMat), 0);
	}
      else
	check_tolFeatMaxMat_faLabel(
	  dynamic_cast<tolFeatMaxMat_faLabel *>(a_tolFeatMaxMat), log);
      return;
    }
  if (isA(a_tolFeatMaxMat, tolFeatMaxMat_fLabel))
    {
      adjustLevels(&tolFeatMaxMatSubs_tolFeatMaxMat_fLabel,
		   "tolFeatMaxMat_fLabel");
      if (log && !findString("tolFeatMaxMat_fLabel", tolFeatMaxMatSubs))
	{
	  warnSub("tolFeatMaxMat_fLabel", "tolFeatMaxMat", a_tolFeatMaxMat);
	  check_tolFeatMaxMat_fLabel(
	    dynamic_cast<tolFeatMaxMat_fLabel *>(a_tolFeatMaxMat), 0);
	}
      else
	check_tolFeatMaxMat_fLabel(
	  dynamic_cast<tolFeatMaxMat_fLabel *>(a_tolFeatMaxMat), log);
      return;
    }
}

/********************************************************************/

void check_tolFeatMaxMat_datLabel(
 tolFeatMaxMat_datLabel * a_tolFeatMaxMat_datLabel,
 int log)
{
  if (a_tolFeatMaxMat_datLabel->get_datLabel())
    {
      adjustLevels(&tolFeatMaxMat_datLabelAtts_a_datLabel,
		   "tolFeatMaxMat_datLabel a_datLabel");
      if (log && !findString("a_datLabel", tolFeatMaxMat_datLabelAtts))
	{
	  warnAtt("a_datLabel", "tolFeatMaxMat_datLabel",
		  a_tolFeatMaxMat_datLabel);
	  check_datLabel(a_tolFeatMaxMat_datLabel->get_datLabel(), 0);
	}
      else
	check_datLabel(a_tolFeatMaxMat_datLabel->get_datLabel(), log);
    }
  if (a_tolFeatMaxMat_datLabel->get_tolMaxMatCond())
    {
      adjustLevels(&tolFeatMaxMat_datLabelAtts_a_tolMaxMatCond,
		   "tolFeatMaxMat_datLabel a_tolMaxMatCond");
      if (log && !findString("a_tolMaxMatCond", tolFeatMaxMat_datLabelAtts))
	{
	  warnAtt("a_tolMaxMatCond", "tolFeatMaxMat_datLabel",
		  a_tolFeatMaxMat_datLabel);
	  check_tolMaxMatCond(a_tolFeatMaxMat_datLabel->get_tolMaxMatCond(), 0);
	}
      else
	check_tolMaxMatCond(a_tolFeatMaxMat_datLabel->get_tolMaxMatCond(), log);
    }
}

/********************************************************************/

void check_tolFeatMaxMat_fLabel(
 tolFeatMaxMat_fLabel * a_tolFeatMaxMat_fLabel,
 int log)
{
  if (a_tolFeatMaxMat_fLabel->get_fLabel())
    {
      adjustLevels(&tolFeatMaxMat_fLabelAtts_a_fLabel,
		   "tolFeatMaxMat_fLabel a_fLabel");
      if (log && !findString("a_fLabel", tolFeatMaxMat_fLabelAtts))
	{
	  warnAtt("a_fLabel", "tolFeatMaxMat_fLabel", a_tolFeatMaxMat_fLabel);
	  check_fLabel(a_tolFeatMaxMat_fLabel->get_fLabel(), 0);
	}
      else
	check_fLabel(a_tolFeatMaxMat_fLabel->get_fLabel(), log);
    }
}

/********************************************************************/

void check_tolFeatMaxMat_faLabel(
 tolFeatMaxMat_faLabel * a_tolFeatMaxMat_faLabel,
 int log)
{
  if (a_tolFeatMaxMat_faLabel->get_faLabel())
    {
      adjustLevels(&tolFeatMaxMat_faLabelAtts_a_faLabel,
		   "tolFeatMaxMat_faLabel a_faLabel");
      if (log && !findString("a_faLabel", tolFeatMaxMat_faLabelAtts))
	{
	  warnAtt("a_faLabel", "tolFeatMaxMat_faLabel",
		  a_tolFeatMaxMat_faLabel);
	  check_faLabel(a_tolFeatMaxMat_faLabel->get_faLabel(), 0);
	}
      else
	check_faLabel(a_tolFeatMaxMat_faLabel->get_faLabel(), log);
    }
  if (a_tolFeatMaxMat_faLabel->get_tolMaxMatCond())
    {
      adjustLevels(&tolFeatMaxMat_faLabelAtts_a_tolMaxMatCond,
		   "tolFeatMaxMat_faLabel a_tolMaxMatCond");
      if (log && !findString("a_tolMaxMatCond", tolFeatMaxMat_faLabelAtts))
	{
	  warnAtt("a_tolMaxMatCond", "tolFeatMaxMat_faLabel",
		  a_tolFeatMaxMat_faLabel);
	  check_tolMaxMatCond(a_tolFeatMaxMat_faLabel->get_tolMaxMatCond(), 0);
	}
      else
	check_tolMaxMatCond(a_tolFeatMaxMat_faLabel->get_tolMaxMatCond(), log);
    }
}

/********************************************************************/

void check_tolFeature(
 tolFeature * a_tolFeature,
 int log)
{
  if (isA(a_tolFeature, fLabel))
    {
      adjustLevels(&tolFeatureSubs_fLabel, "fLabel");
      if (log && !findString("fLabel", tolFeatureSubs))
	{
	  warnSub("fLabel", "tolFeature", a_tolFeature);
	  check_fLabel(dynamic_cast<fLabel *>(a_tolFeature), 0);
	}
      else
	check_fLabel(dynamic_cast<fLabel *>(a_tolFeature), log);
      return;
    }
  if (isA(a_tolFeature, faLabel))
    {
      adjustLevels(&tolFeatureSubs_faLabel, "faLabel");
      if (log && !findString("faLabel", tolFeatureSubs))
	{
	  warnSub("faLabel", "tolFeature", a_tolFeature);
	  check_faLabel(dynamic_cast<faLabel *>(a_tolFeature), 0);
	}
      else
	check_faLabel(dynamic_cast<faLabel *>(a_tolFeature), log);
      return;
    }
  if (isA(a_tolFeature, datLabel))
    {
      adjustLevels(&tolFeatureSubs_datLabel, "datLabel");
      if (log && !findString("datLabel", tolFeatureSubs))
	{
	  warnSub("datLabel", "tolFeature", a_tolFeature);
	  check_datLabel(dynamic_cast<datLabel *>(a_tolFeature), 0);
	}
      else
	check_datLabel(dynamic_cast<datLabel *>(a_tolFeature), log);
      return;
    }
}

/********************************************************************/

void check_tolFeatureMat(
 tolFeatureMat * a_tolFeatureMat,
 int log)
{
  if (isA(a_tolFeatureMat, tolFeatureMat_datLabel))
    {
      adjustLevels(&tolFeatureMatSubs_tolFeatureMat_datLabel,
		   "tolFeatureMat_datLabel");
      if (log && !findString("tolFeatureMat_datLabel", tolFeatureMatSubs))
	{
	  warnSub("tolFeatureMat_datLabel", "tolFeatureMat", a_tolFeatureMat);
	  check_tolFeatureMat_datLabel(
	    dynamic_cast<tolFeatureMat_datLabel *>(a_tolFeatureMat), 0);
	}
      else
	check_tolFeatureMat_datLabel(
	  dynamic_cast<tolFeatureMat_datLabel *>(a_tolFeatureMat), log);
      return;
    }
  if (isA(a_tolFeatureMat, tolFeatureMat_faLabel))
    {
      adjustLevels(&tolFeatureMatSubs_tolFeatureMat_faLabel,
		   "tolFeatureMat_faLabel");
      if (log && !findString("tolFeatureMat_faLabel", tolFeatureMatSubs))
	{
	  warnSub("tolFeatureMat_faLabel", "tolFeatureMat", a_tolFeatureMat);
	  check_tolFeatureMat_faLabel(
	    dynamic_cast<tolFeatureMat_faLabel *>(a_tolFeatureMat), 0);
	}
      else
	check_tolFeatureMat_faLabel(
	  dynamic_cast<tolFeatureMat_faLabel *>(a_tolFeatureMat), log);
      return;
    }
  if (isA(a_tolFeatureMat, tolFeatureMat_fLabel))
    {
      adjustLevels(&tolFeatureMatSubs_tolFeatureMat_fLabel,
		   "tolFeatureMat_fLabel");
      if (log && !findString("tolFeatureMat_fLabel", tolFeatureMatSubs))
	{
	  warnSub("tolFeatureMat_fLabel", "tolFeatureMat", a_tolFeatureMat);
	  check_tolFeatureMat_fLabel(
	    dynamic_cast<tolFeatureMat_fLabel *>(a_tolFeatureMat), 0);
	}
      else
	check_tolFeatureMat_fLabel(
	  dynamic_cast<tolFeatureMat_fLabel *>(a_tolFeatureMat), log);
      return;
    }
}

/********************************************************************/

void check_tolFeatureMat_datLabel(
 tolFeatureMat_datLabel * a_tolFeatureMat_datLabel,
 int log)
{
  if (a_tolFeatureMat_datLabel->get_datLabel())
    {
      adjustLevels(&tolFeatureMat_datLabelAtts_a_datLabel,
		   "tolFeatureMat_datLabel a_datLabel");
      if (log && !findString("a_datLabel", tolFeatureMat_datLabelAtts))
	{
	  warnAtt("a_datLabel", "tolFeatureMat_datLabel",
		  a_tolFeatureMat_datLabel);
	  check_datLabel(a_tolFeatureMat_datLabel->get_datLabel(), 0);
	}
      else
	check_datLabel(a_tolFeatureMat_datLabel->get_datLabel(), log);
    }
  if (a_tolFeatureMat_datLabel->get_tolMatCond())
    {
      adjustLevels(&tolFeatureMat_datLabelAtts_a_tolMatCond,
		   "tolFeatureMat_datLabel a_tolMatCond");
      if (log && !findString("a_tolMatCond", tolFeatureMat_datLabelAtts))
	{
	  warnAtt("a_tolMatCond", "tolFeatureMat_datLabel",
		  a_tolFeatureMat_datLabel);
	  check_tolMatCond(a_tolFeatureMat_datLabel->get_tolMatCond(), 0);
	}
      else
	check_tolMatCond(a_tolFeatureMat_datLabel->get_tolMatCond(), log);
    }
}

/********************************************************************/

void check_tolFeatureMat_fLabel(
 tolFeatureMat_fLabel * a_tolFeatureMat_fLabel,
 int log)
{
  if (a_tolFeatureMat_fLabel->get_fLabel())
    {
      adjustLevels(&tolFeatureMat_fLabelAtts_a_fLabel,
		   "tolFeatureMat_fLabel a_fLabel");
      if (log && !findString("a_fLabel", tolFeatureMat_fLabelAtts))
	{
	  warnAtt("a_fLabel", "tolFeatureMat_fLabel", a_tolFeatureMat_fLabel);
	  check_fLabel(a_tolFeatureMat_fLabel->get_fLabel(), 0);
	}
      else
	check_fLabel(a_tolFeatureMat_fLabel->get_fLabel(), log);
    }
}

/********************************************************************/

void check_tolFeatureMat_faLabel(
 tolFeatureMat_faLabel * a_tolFeatureMat_faLabel,
 int log)
{
  if (a_tolFeatureMat_faLabel->get_faLabel())
    {
      adjustLevels(&tolFeatureMat_faLabelAtts_a_faLabel,
		   "tolFeatureMat_faLabel a_faLabel");
      if (log && !findString("a_faLabel", tolFeatureMat_faLabelAtts))
	{
	  warnAtt("a_faLabel", "tolFeatureMat_faLabel",
		  a_tolFeatureMat_faLabel);
	  check_faLabel(a_tolFeatureMat_faLabel->get_faLabel(), 0);
	}
      else
	check_faLabel(a_tolFeatureMat_faLabel->get_faLabel(), log);
    }
  if (a_tolFeatureMat_faLabel->get_tolMatCond())
    {
      adjustLevels(&tolFeatureMat_faLabelAtts_a_tolMatCond,
		   "tolFeatureMat_faLabel a_tolMatCond");
      if (log && !findString("a_tolMatCond", tolFeatureMat_faLabelAtts))
	{
	  warnAtt("a_tolMatCond", "tolFeatureMat_faLabel",
		  a_tolFeatureMat_faLabel);
	  check_tolMatCond(a_tolFeatureMat_faLabel->get_tolMatCond(), 0);
	}
      else
	check_tolMatCond(a_tolFeatureMat_faLabel->get_tolMatCond(), log);
    }
}

/********************************************************************/

void check_tolFlatMinor(
 tolFlatMinor * a_tolFlatMinor,
 int log)
{
  if (isA(a_tolFlatMinor, tolFlatZon))
    {
      adjustLevels(&tolFlatMinorSubs_tolFlatZon, "tolFlatZon");
      if (log && !findString("tolFlatZon", tolFlatMinorSubs))
	{
	  warnSub("tolFlatZon", "tolFlatMinor", a_tolFlatMinor);
	  check_tolFlatZon(dynamic_cast<tolFlatZon *>(a_tolFlatMinor), 0);
	}
      else
	check_tolFlatZon(dynamic_cast<tolFlatZon *>(a_tolFlatMinor), log);
      return;
    }
  if (isA(a_tolFlatMinor, tolFlatPer))
    {
      adjustLevels(&tolFlatMinorSubs_tolFlatPer, "tolFlatPer");
      if (log && !findString("tolFlatPer", tolFlatMinorSubs))
	{
	  warnSub("tolFlatPer", "tolFlatMinor", a_tolFlatMinor);
	  check_tolFlatPer(dynamic_cast<tolFlatPer *>(a_tolFlatMinor), 0);
	}
      else
	check_tolFlatPer(dynamic_cast<tolFlatPer *>(a_tolFlatMinor), log);
      return;
    }
  if (isA(a_tolFlatMinor, tolFlatZonPer))
    {
      adjustLevels(&tolFlatMinorSubs_tolFlatZonPer, "tolFlatZonPer");
      if (log && !findString("tolFlatZonPer", tolFlatMinorSubs))
	{
	  warnSub("tolFlatZonPer", "tolFlatMinor", a_tolFlatMinor);
	  check_tolFlatZonPer(
	    dynamic_cast<tolFlatZonPer *>(a_tolFlatMinor), 0);
	}
      else
	check_tolFlatZonPer(
	  dynamic_cast<tolFlatZonPer *>(a_tolFlatMinor), log);
      return;
    }
}

/********************************************************************/

void check_tolFlatPer(
 tolFlatPer * a_tolFlatPer,
 int log)
{
  if (a_tolFlatPer->get_tolzon1())
    {
      adjustLevels(&tolFlatPerAtts_tolzon1, "tolFlatPer tolzon1");
      if (log && !findString("tolzon1", tolFlatPerAtts))
	{
	  warnAtt("tolzon1", "tolFlatPer", a_tolFlatPer);
	  check_rentVal(a_tolFlatPer->get_tolzon1(), 0);
	}
      else
	check_rentVal(a_tolFlatPer->get_tolzon1(), log);
    }
  if (a_tolFlatPer->get_unit1())
    {
      adjustLevels(&tolFlatPerAtts_unit1, "tolFlatPer unit1");
      if (log && !findString("unit1", tolFlatPerAtts))
	{
	  warnAtt("unit1", "tolFlatPer", a_tolFlatPer);
	  check_rentVal(a_tolFlatPer->get_unit1(), 0);
	}
      else
	check_rentVal(a_tolFlatPer->get_unit1(), log);
    }
  if (a_tolFlatPer->get_unit2())
    {
      adjustLevels(&tolFlatPerAtts_unit2, "tolFlatPer unit2");
      if (log && !findString("unit2", tolFlatPerAtts))
	{
	  warnAtt("unit2", "tolFlatPer", a_tolFlatPer);
	  check_rentVal(a_tolFlatPer->get_unit2(), 0);
	}
      else
	check_rentVal(a_tolFlatPer->get_unit2(), log);
    }
}

/********************************************************************/

void check_tolFlatStm(
 tolFlatStm * a_tolFlatStm,
 int log)
{
  if (a_tolFlatStm->get_tLabel())
    {
      adjustLevels(&tolFlatStmAtts_a_tLabel, "tolFlatStm a_tLabel");
      if (log && !findString("a_tLabel", tolFlatStmAtts))
	{
	  warnAtt("a_tLabel", "tolFlatStm", a_tolFlatStm);
	  check_tLabel(a_tolFlatStm->get_tLabel(), 0);
	}
      else
	check_tLabel(a_tolFlatStm->get_tLabel(), log);
    }
  if (a_tolFlatStm->get_tolFlatMinor())
    {
      adjustLevels(&tolFlatStmAtts_a_tolFlatMinor,
		   "tolFlatStm a_tolFlatMinor");
      if (log && !findString("a_tolFlatMinor", tolFlatStmAtts))
	{
	  warnAtt("a_tolFlatMinor", "tolFlatStm", a_tolFlatStm);
	  check_tolFlatMinor(a_tolFlatStm->get_tolFlatMinor(), 0);
	}
      else
	check_tolFlatMinor(a_tolFlatStm->get_tolFlatMinor(), log);
    }
}

/********************************************************************/

void check_tolFlatZon(
 tolFlatZon * a_tolFlatZon,
 int log)
{
  if (a_tolFlatZon->get_tolzon())
    {
      adjustLevels(&tolFlatZonAtts_tolzon, "tolFlatZon tolzon");
      if (log && !findString("tolzon", tolFlatZonAtts))
	{
	  warnAtt("tolzon", "tolFlatZon", a_tolFlatZon);
	  check_rentVal(a_tolFlatZon->get_tolzon(), 0);
	}
      else
	check_rentVal(a_tolFlatZon->get_tolzon(), log);
    }
}

/********************************************************************/

void check_tolFlatZonPer(
 tolFlatZonPer * a_tolFlatZonPer,
 int log)
{
  if (a_tolFlatZonPer->get_tolzon())
    {
      adjustLevels(&tolFlatZonPerAtts_tolzon, "tolFlatZonPer tolzon");
      if (log && !findString("tolzon", tolFlatZonPerAtts))
	{
	  warnAtt("tolzon", "tolFlatZonPer", a_tolFlatZonPer);
	  check_rentVal(a_tolFlatZonPer->get_tolzon(), 0);
	}
      else
	check_rentVal(a_tolFlatZonPer->get_tolzon(), log);
    }
  if (a_tolFlatZonPer->get_tolzon1())
    {
      adjustLevels(&tolFlatZonPerAtts_tolzon1, "tolFlatZonPer tolzon1");
      if (log && !findString("tolzon1", tolFlatZonPerAtts))
	{
	  warnAtt("tolzon1", "tolFlatZonPer", a_tolFlatZonPer);
	  check_rentVal(a_tolFlatZonPer->get_tolzon1(), 0);
	}
      else
	check_rentVal(a_tolFlatZonPer->get_tolzon1(), log);
    }
  if (a_tolFlatZonPer->get_unit1())
    {
      adjustLevels(&tolFlatZonPerAtts_unit1, "tolFlatZonPer unit1");
      if (log && !findString("unit1", tolFlatZonPerAtts))
	{
	  warnAtt("unit1", "tolFlatZonPer", a_tolFlatZonPer);
	  check_rentVal(a_tolFlatZonPer->get_unit1(), 0);
	}
      else
	check_rentVal(a_tolFlatZonPer->get_unit1(), log);
    }
  if (a_tolFlatZonPer->get_unit2())
    {
      adjustLevels(&tolFlatZonPerAtts_unit2, "tolFlatZonPer unit2");
      if (log && !findString("unit2", tolFlatZonPerAtts))
	{
	  warnAtt("unit2", "tolFlatZonPer", a_tolFlatZonPer);
	  check_rentVal(a_tolFlatZonPer->get_unit2(), 0);
	}
      else
	check_rentVal(a_tolFlatZonPer->get_unit2(), log);
    }
}

/********************************************************************/

void check_tolGtolRot(
 tolGtolRot * a_tolGtolRot,
 int log)
{
  if (isA(a_tolGtolRot, tolGtolRot_XAXIS))
    {
      adjustLevels(&tolGtolRotSubs_tolGtolRot_XAXIS, "tolGtolRot_XAXIS");
      if (log && !findString("tolGtolRot_XAXIS", tolGtolRotSubs))
	{
	  warnSub("tolGtolRot_XAXIS", "tolGtolRot", a_tolGtolRot);
	}
      return;
    }
  if (isA(a_tolGtolRot, tolGtolRot_YAXIS))
    {
      adjustLevels(&tolGtolRotSubs_tolGtolRot_YAXIS, "tolGtolRot_YAXIS");
      if (log && !findString("tolGtolRot_YAXIS", tolGtolRotSubs))
	{
	  warnSub("tolGtolRot_YAXIS", "tolGtolRot", a_tolGtolRot);
	}
      return;
    }
  if (isA(a_tolGtolRot, tolGtolRot_ZAXIS))
    {
      adjustLevels(&tolGtolRotSubs_tolGtolRot_ZAXIS, "tolGtolRot_ZAXIS");
      if (log && !findString("tolGtolRot_ZAXIS", tolGtolRotSubs))
	{
	  warnSub("tolGtolRot_ZAXIS", "tolGtolRot", a_tolGtolRot);
	}
      return;
    }
  if (isA(a_tolGtolRot, tolGtolRot_XYAXIS))
    {
      adjustLevels(&tolGtolRotSubs_tolGtolRot_XYAXIS, "tolGtolRot_XYAXIS");
      if (log && !findString("tolGtolRot_XYAXIS", tolGtolRotSubs))
	{
	  warnSub("tolGtolRot_XYAXIS", "tolGtolRot", a_tolGtolRot);
	}
      return;
    }
  if (isA(a_tolGtolRot, tolGtolRot_YZAXIS))
    {
      adjustLevels(&tolGtolRotSubs_tolGtolRot_YZAXIS, "tolGtolRot_YZAXIS");
      if (log && !findString("tolGtolRot_YZAXIS", tolGtolRotSubs))
	{
	  warnSub("tolGtolRot_YZAXIS", "tolGtolRot", a_tolGtolRot);
	}
      return;
    }
  if (isA(a_tolGtolRot, tolGtolRot_ZXAXIS))
    {
      adjustLevels(&tolGtolRotSubs_tolGtolRot_ZXAXIS, "tolGtolRot_ZXAXIS");
      if (log && !findString("tolGtolRot_ZXAXIS", tolGtolRotSubs))
	{
	  warnSub("tolGtolRot_ZXAXIS", "tolGtolRot", a_tolGtolRot);
	}
      return;
    }
  if (isA(a_tolGtolRot, tolGtolRot_XYZAXI))
    {
      adjustLevels(&tolGtolRotSubs_tolGtolRot_XYZAXI, "tolGtolRot_XYZAXI");
      if (log && !findString("tolGtolRot_XYZAXI", tolGtolRotSubs))
	{
	  warnSub("tolGtolRot_XYZAXI", "tolGtolRot", a_tolGtolRot);
	}
      return;
    }
  if (isA(a_tolGtolRot, tolGtolRot_NOROT))
    {
      adjustLevels(&tolGtolRotSubs_tolGtolRot_NOROT, "tolGtolRot_NOROT");
      if (log && !findString("tolGtolRot_NOROT", tolGtolRotSubs))
	{
	  warnSub("tolGtolRot_NOROT", "tolGtolRot", a_tolGtolRot);
	}
      return;
    }
}

/********************************************************************/

void check_tolGtolSpec(
 tolGtolSpec * a_tolGtolSpec,
 int log)
{
  if (isA(a_tolGtolSpec, tolGtolSpec_PERCNT))
    {
      adjustLevels(&tolGtolSpecSubs_tolGtolSpec_PERCNT, "tolGtolSpec_PERCNT");
      if (log && !findString("tolGtolSpec_PERCNT", tolGtolSpecSubs))
	{
	  warnSub("tolGtolSpec_PERCNT", "tolGtolSpec", a_tolGtolSpec);
	}
      return;
    }
  if (isA(a_tolGtolSpec, tolGtolSpec_INTFPT))
    {
      adjustLevels(&tolGtolSpecSubs_tolGtolSpec_INTFPT, "tolGtolSpec_INTFPT");
      if (log && !findString("tolGtolSpec_INTFPT", tolGtolSpecSubs))
	{
	  warnSub("tolGtolSpec_INTFPT", "tolGtolSpec", a_tolGtolSpec);
	}
      return;
    }
}

/********************************************************************/

void check_tolGtolStm(
 tolGtolStm * a_tolGtolStm,
 int log)
{
  if (a_tolGtolStm->get_tLabel())
    {
      adjustLevels(&tolGtolStmAtts_a_tLabel, "tolGtolStm a_tLabel");
      if (log && !findString("a_tLabel", tolGtolStmAtts))
	{
	  warnAtt("a_tLabel", "tolGtolStm", a_tolGtolStm);
	  check_tLabel(a_tolGtolStm->get_tLabel(), 0);
	}
      else
	check_tLabel(a_tolGtolStm->get_tLabel(), log);
    }
  if (a_tolGtolStm->get_tolGtolTrans())
    {
      adjustLevels(&tolGtolStmAtts_a_tolGtolTrans,
		   "tolGtolStm a_tolGtolTrans");
      if (log && !findString("a_tolGtolTrans", tolGtolStmAtts))
	{
	  warnAtt("a_tolGtolTrans", "tolGtolStm", a_tolGtolStm);
	  check_tolGtolTrans(a_tolGtolStm->get_tolGtolTrans(), 0);
	}
      else
	check_tolGtolTrans(a_tolGtolStm->get_tolGtolTrans(), log);
    }
  if (a_tolGtolStm->get_tolGtolRot())
    {
      adjustLevels(&tolGtolStmAtts_a_tolGtolRot, "tolGtolStm a_tolGtolRot");
      if (log && !findString("a_tolGtolRot", tolGtolStmAtts))
	{
	  warnAtt("a_tolGtolRot", "tolGtolStm", a_tolGtolStm);
	  check_tolGtolRot(a_tolGtolStm->get_tolGtolRot(), 0);
	}
      else
	check_tolGtolRot(a_tolGtolStm->get_tolGtolRot(), log);
    }
  if (a_tolGtolStm->get_maxitr())
    {
      adjustLevels(&tolGtolStmAtts_maxitr, "tolGtolStm maxitr");
      if (log && !findString("maxitr", tolGtolStmAtts))
	{
	  warnAtt("maxitr", "tolGtolStm", a_tolGtolStm);
	  check_intVal(a_tolGtolStm->get_maxitr(), 0);
	}
      else
	check_intVal(a_tolGtolStm->get_maxitr(), log);
    }
  if (a_tolGtolStm->get_minshf())
    {
      adjustLevels(&tolGtolStmAtts_minshf, "tolGtolStm minshf");
      if (log && !findString("minshf", tolGtolStmAtts))
	{
	  warnAtt("minshf", "tolGtolStm", a_tolGtolStm);
	  check_rentVal(a_tolGtolStm->get_minshf(), 0);
	}
      else
	check_rentVal(a_tolGtolStm->get_minshf(), log);
    }
  if (a_tolGtolStm->get_maxrot())
    {
      adjustLevels(&tolGtolStmAtts_maxrot, "tolGtolStm maxrot");
      if (log && !findString("maxrot", tolGtolStmAtts))
	{
	  warnAtt("maxrot", "tolGtolStm", a_tolGtolStm);
	  check_angle(a_tolGtolStm->get_maxrot(), 0);
	}
      else
	check_angle(a_tolGtolStm->get_maxrot(), log);
    }
  if (a_tolGtolStm->get_tolGtolSpec())
    {
      adjustLevels(&tolGtolStmAtts_a_tolGtolSpec, "tolGtolStm a_tolGtolSpec");
      if (log && !findString("a_tolGtolSpec", tolGtolStmAtts))
	{
	  warnAtt("a_tolGtolSpec", "tolGtolStm", a_tolGtolStm);
	  check_tolGtolSpec(a_tolGtolStm->get_tolGtolSpec(), 0);
	}
      else
	check_tolGtolSpec(a_tolGtolStm->get_tolGtolSpec(), log);
    }
}

/********************************************************************/

void check_tolGtolTrans(
 tolGtolTrans * a_tolGtolTrans,
 int log)
{
  if (isA(a_tolGtolTrans, tolGtolTrans_XDIR))
    {
      adjustLevels(&tolGtolTransSubs_tolGtolTrans_XDIR, "tolGtolTrans_XDIR");
      if (log && !findString("tolGtolTrans_XDIR", tolGtolTransSubs))
	{
	  warnSub("tolGtolTrans_XDIR", "tolGtolTrans", a_tolGtolTrans);
	}
      return;
    }
  if (isA(a_tolGtolTrans, tolGtolTrans_YDIR))
    {
      adjustLevels(&tolGtolTransSubs_tolGtolTrans_YDIR, "tolGtolTrans_YDIR");
      if (log && !findString("tolGtolTrans_YDIR", tolGtolTransSubs))
	{
	  warnSub("tolGtolTrans_YDIR", "tolGtolTrans", a_tolGtolTrans);
	}
      return;
    }
  if (isA(a_tolGtolTrans, tolGtolTrans_ZDIR))
    {
      adjustLevels(&tolGtolTransSubs_tolGtolTrans_ZDIR, "tolGtolTrans_ZDIR");
      if (log && !findString("tolGtolTrans_ZDIR", tolGtolTransSubs))
	{
	  warnSub("tolGtolTrans_ZDIR", "tolGtolTrans", a_tolGtolTrans);
	}
      return;
    }
  if (isA(a_tolGtolTrans, tolGtolTrans_XYDIR))
    {
      adjustLevels(&tolGtolTransSubs_tolGtolTrans_XYDIR, "tolGtolTrans_XYDIR");
      if (log && !findString("tolGtolTrans_XYDIR", tolGtolTransSubs))
	{
	  warnSub("tolGtolTrans_XYDIR", "tolGtolTrans", a_tolGtolTrans);
	}
      return;
    }
  if (isA(a_tolGtolTrans, tolGtolTrans_YZDIR))
    {
      adjustLevels(&tolGtolTransSubs_tolGtolTrans_YZDIR, "tolGtolTrans_YZDIR");
      if (log && !findString("tolGtolTrans_YZDIR", tolGtolTransSubs))
	{
	  warnSub("tolGtolTrans_YZDIR", "tolGtolTrans", a_tolGtolTrans);
	}
      return;
    }
  if (isA(a_tolGtolTrans, tolGtolTrans_ZXDIR))
    {
      adjustLevels(&tolGtolTransSubs_tolGtolTrans_ZXDIR, "tolGtolTrans_ZXDIR");
      if (log && !findString("tolGtolTrans_ZXDIR", tolGtolTransSubs))
	{
	  warnSub("tolGtolTrans_ZXDIR", "tolGtolTrans", a_tolGtolTrans);
	}
      return;
    }
  if (isA(a_tolGtolTrans, tolGtolTrans_XYZDIR))
    {
      adjustLevels(&tolGtolTransSubs_tolGtolTrans_XYZDIR,
		   "tolGtolTrans_XYZDIR");
      if (log && !findString("tolGtolTrans_XYZDIR", tolGtolTransSubs))
	{
	  warnSub("tolGtolTrans_XYZDIR", "tolGtolTrans", a_tolGtolTrans);
	}
      return;
    }
  if (isA(a_tolGtolTrans, tolGtolTrans_NOTRAN))
    {
      adjustLevels(&tolGtolTransSubs_tolGtolTrans_NOTRAN,
		   "tolGtolTrans_NOTRAN");
      if (log && !findString("tolGtolTrans_NOTRAN", tolGtolTransSubs))
	{
	  warnSub("tolGtolTrans_NOTRAN", "tolGtolTrans", a_tolGtolTrans);
	}
      return;
    }
}

/********************************************************************/

void check_tolMatCond(
 tolMatCond * a_tolMatCond,
 int log)
{
  if (isA(a_tolMatCond, tolMatCond_MMC))
    {
      adjustLevels(&tolMatCondSubs_tolMatCond_MMC, "tolMatCond_MMC");
      if (log && !findString("tolMatCond_MMC", tolMatCondSubs))
	{
	  warnSub("tolMatCond_MMC", "tolMatCond", a_tolMatCond);
	}
      return;
    }
  if (isA(a_tolMatCond, tolMatCond_LMC))
    {
      adjustLevels(&tolMatCondSubs_tolMatCond_LMC, "tolMatCond_LMC");
      if (log && !findString("tolMatCond_LMC", tolMatCondSubs))
	{
	  warnSub("tolMatCond_LMC", "tolMatCond", a_tolMatCond);
	}
      return;
    }
  if (isA(a_tolMatCond, tolMatCond_RFS))
    {
      adjustLevels(&tolMatCondSubs_tolMatCond_RFS, "tolMatCond_RFS");
      if (log && !findString("tolMatCond_RFS", tolMatCondSubs))
	{
	  warnSub("tolMatCond_RFS", "tolMatCond", a_tolMatCond);
	}
      return;
    }
}

/********************************************************************/

void check_tolMaxMatCond(
 tolMaxMatCond * a_tolMaxMatCond,
 int log)
{
  if (isA(a_tolMaxMatCond, tolMaxMatCond_LMC))
    {
      adjustLevels(&tolMaxMatCondSubs_tolMaxMatCond_LMC, "tolMaxMatCond_LMC");
      if (log && !findString("tolMaxMatCond_LMC", tolMaxMatCondSubs))
	{
	  warnSub("tolMaxMatCond_LMC", "tolMaxMatCond", a_tolMaxMatCond);
	  check_tolMaxMatCond_LMC(
	    dynamic_cast<tolMaxMatCond_LMC *>(a_tolMaxMatCond), 0);
	}
      else
	check_tolMaxMatCond_LMC(
	  dynamic_cast<tolMaxMatCond_LMC *>(a_tolMaxMatCond), log);
      return;
    }
  if (isA(a_tolMaxMatCond, tolMaxMatCond_RFS))
    {
      adjustLevels(&tolMaxMatCondSubs_tolMaxMatCond_RFS, "tolMaxMatCond_RFS");
      if (log && !findString("tolMaxMatCond_RFS", tolMaxMatCondSubs))
	{
	  warnSub("tolMaxMatCond_RFS", "tolMaxMatCond", a_tolMaxMatCond);
	}
      return;
    }
  if (isA(a_tolMaxMatCond, tolMaxMatCond_MMC))
    {
      adjustLevels(&tolMaxMatCondSubs_tolMaxMatCond_MMC, "tolMaxMatCond_MMC");
      if (log && !findString("tolMaxMatCond_MMC", tolMaxMatCondSubs))
	{
	  warnSub("tolMaxMatCond_MMC", "tolMaxMatCond", a_tolMaxMatCond);
	  check_tolMaxMatCond_MMC(
	    dynamic_cast<tolMaxMatCond_MMC *>(a_tolMaxMatCond), 0);
	}
      else
	check_tolMaxMatCond_MMC(
	  dynamic_cast<tolMaxMatCond_MMC *>(a_tolMaxMatCond), log);
      return;
    }
}

/********************************************************************/

void check_tolMaxMatCond_LMC(
 tolMaxMatCond_LMC * a_tolMaxMatCond_LMC,
 int log)
{
  if (a_tolMaxMatCond_LMC->get_lim())
    {
      adjustLevels(&tolMaxMatCond_LMCAtts_lim, "tolMaxMatCond_LMC lim");
      if (log && !findString("lim", tolMaxMatCond_LMCAtts))
	{
	  warnAtt("lim", "tolMaxMatCond_LMC", a_tolMaxMatCond_LMC);
	  check_rentVal(a_tolMaxMatCond_LMC->get_lim(), 0);
	}
      else
	check_rentVal(a_tolMaxMatCond_LMC->get_lim(), log);
    }
}

/********************************************************************/

void check_tolMaxMatCond_MMC(
 tolMaxMatCond_MMC * a_tolMaxMatCond_MMC,
 int log)
{
  if (a_tolMaxMatCond_MMC->get_lim())
    {
      adjustLevels(&tolMaxMatCond_MMCAtts_lim, "tolMaxMatCond_MMC lim");
      if (log && !findString("lim", tolMaxMatCond_MMCAtts))
	{
	  warnAtt("lim", "tolMaxMatCond_MMC", a_tolMaxMatCond_MMC);
	  check_rentVal(a_tolMaxMatCond_MMC->get_lim(), 0);
	}
      else
	check_rentVal(a_tolMaxMatCond_MMC->get_lim(), log);
    }
}

/********************************************************************/

void check_tolParlelStm(
 tolParlelStm * a_tolParlelStm,
 int log)
{
  if (a_tolParlelStm->get_tLabel())
    {
      adjustLevels(&tolParlelStmAtts_a_tLabel, "tolParlelStm a_tLabel");
      if (log && !findString("a_tLabel", tolParlelStmAtts))
	{
	  warnAtt("a_tLabel", "tolParlelStm", a_tolParlelStm);
	  check_tLabel(a_tolParlelStm->get_tLabel(), 0);
	}
      else
	check_tLabel(a_tolParlelStm->get_tLabel(), log);
    }
  if (a_tolParlelStm->get_tolAppData())
    {
      adjustLevels(&tolParlelStmAtts_a_tolAppData,
		   "tolParlelStm a_tolAppData");
      if (log && !findString("a_tolAppData", tolParlelStmAtts))
	{
	  warnAtt("a_tolAppData", "tolParlelStm", a_tolParlelStm);
	  check_tolAppData(a_tolParlelStm->get_tolAppData(), 0);
	}
      else
	check_tolAppData(a_tolParlelStm->get_tolAppData(), log);
    }
}

/********************************************************************/

void check_tolPerpStm(
 tolPerpStm * a_tolPerpStm,
 int log)
{
  if (a_tolPerpStm->get_tLabel())
    {
      adjustLevels(&tolPerpStmAtts_a_tLabel, "tolPerpStm a_tLabel");
      if (log && !findString("a_tLabel", tolPerpStmAtts))
	{
	  warnAtt("a_tLabel", "tolPerpStm", a_tolPerpStm);
	  check_tLabel(a_tolPerpStm->get_tLabel(), 0);
	}
      else
	check_tLabel(a_tolPerpStm->get_tLabel(), log);
    }
  if (a_tolPerpStm->get_tolAppData())
    {
      adjustLevels(&tolPerpStmAtts_a_tolAppData, "tolPerpStm a_tolAppData");
      if (log && !findString("a_tolAppData", tolPerpStmAtts))
	{
	  warnAtt("a_tolAppData", "tolPerpStm", a_tolPerpStm);
	  check_tolAppData(a_tolPerpStm->get_tolAppData(), 0);
	}
      else
	check_tolAppData(a_tolPerpStm->get_tolAppData(), log);
    }
}

/********************************************************************/

void check_tolPosEnd(
 tolPosEnd * a_tolPosEnd,
 int log)
{
  if (a_tolPosEnd->get_tolMatCond())
    {
      adjustLevels(&tolPosEndAtts_a_tolMatCond, "tolPosEnd a_tolMatCond");
      if (log && !findString("a_tolMatCond", tolPosEndAtts))
	{
	  warnAtt("a_tolMatCond", "tolPosEnd", a_tolPosEnd);
	  check_tolMatCond(a_tolPosEnd->get_tolMatCond(), 0);
	}
      else
	check_tolMatCond(a_tolPosEnd->get_tolMatCond(), log);
    }
  if (a_tolPosEnd->get_tfm1())
    {
      adjustLevels(&tolPosEndAtts_tfm1, "tolPosEnd tfm1");
      if (log && !findString("tfm1", tolPosEndAtts))
	{
	  warnAtt("tfm1", "tolPosEnd", a_tolPosEnd);
	  check_tolFeatureMat(a_tolPosEnd->get_tfm1(), 0);
	}
      else
	check_tolFeatureMat(a_tolPosEnd->get_tfm1(), log);
    }
  if (a_tolPosEnd->get_tfm2())
    {
      adjustLevels(&tolPosEndAtts_tfm2, "tolPosEnd tfm2");
      if (log && !findString("tfm2", tolPosEndAtts))
	{
	  warnAtt("tfm2", "tolPosEnd", a_tolPosEnd);
	  check_tolFeatureMat(a_tolPosEnd->get_tfm2(), 0);
	}
      else
	check_tolFeatureMat(a_tolPosEnd->get_tfm2(), log);
    }
  if (a_tolPosEnd->get_tfm3())
    {
      adjustLevels(&tolPosEndAtts_tfm3, "tolPosEnd tfm3");
      if (log && !findString("tfm3", tolPosEndAtts))
	{
	  warnAtt("tfm3", "tolPosEnd", a_tolPosEnd);
	  check_tolFeatureMat(a_tolPosEnd->get_tfm3(), 0);
	}
      else
	check_tolFeatureMat(a_tolPosEnd->get_tfm3(), log);
    }
  if (a_tolPosEnd->get_tolPosMethod())
    {
      adjustLevels(&tolPosEndAtts_a_tolPosMethod, "tolPosEnd a_tolPosMethod");
      if (log && !findString("a_tolPosMethod", tolPosEndAtts))
	{
	  warnAtt("a_tolPosMethod", "tolPosEnd", a_tolPosEnd);
	  check_tolPosMethod(a_tolPosEnd->get_tolPosMethod(), 0);
	}
      else
	check_tolPosMethod(a_tolPosEnd->get_tolPosMethod(), log);
    }
}

/********************************************************************/

void check_tolPosMethod(
 tolPosMethod * a_tolPosMethod,
 int log)
{
  if (isA(a_tolPosMethod, tolPosMethod_XAXIS))
    {
      adjustLevels(&tolPosMethodSubs_tolPosMethod_XAXIS, "tolPosMethod_XAXIS");
      if (log && !findString("tolPosMethod_XAXIS", tolPosMethodSubs))
	{
	  warnSub("tolPosMethod_XAXIS", "tolPosMethod", a_tolPosMethod);
	}
      return;
    }
  if (isA(a_tolPosMethod, tolPosMethod_YAXIS))
    {
      adjustLevels(&tolPosMethodSubs_tolPosMethod_YAXIS, "tolPosMethod_YAXIS");
      if (log && !findString("tolPosMethod_YAXIS", tolPosMethodSubs))
	{
	  warnSub("tolPosMethod_YAXIS", "tolPosMethod", a_tolPosMethod);
	}
      return;
    }
  if (isA(a_tolPosMethod, tolPosMethod_ZAXIS))
    {
      adjustLevels(&tolPosMethodSubs_tolPosMethod_ZAXIS, "tolPosMethod_ZAXIS");
      if (log && !findString("tolPosMethod_ZAXIS", tolPosMethodSubs))
	{
	  warnSub("tolPosMethod_ZAXIS", "tolPosMethod", a_tolPosMethod);
	}
      return;
    }
  if (isA(a_tolPosMethod, tolPosMethod_RADIAL))
    {
      adjustLevels(&tolPosMethodSubs_tolPosMethod_RADIAL,
		   "tolPosMethod_RADIAL");
      if (log && !findString("tolPosMethod_RADIAL", tolPosMethodSubs))
	{
	  warnSub("tolPosMethod_RADIAL", "tolPosMethod", a_tolPosMethod);
	}
      return;
    }
  if (isA(a_tolPosMethod, tolPosMethod_ANGLE))
    {
      adjustLevels(&tolPosMethodSubs_tolPosMethod_ANGLE, "tolPosMethod_ANGLE");
      if (log && !findString("tolPosMethod_ANGLE", tolPosMethodSubs))
	{
	  warnSub("tolPosMethod_ANGLE", "tolPosMethod", a_tolPosMethod);
	}
      return;
    }
  if (isA(a_tolPosMethod, tolPosMethod_VEC))
    {
      adjustLevels(&tolPosMethodSubs_tolPosMethod_VEC, "tolPosMethod_VEC");
      if (log && !findString("tolPosMethod_VEC", tolPosMethodSubs))
	{
	  warnSub("tolPosMethod_VEC", "tolPosMethod", a_tolPosMethod);
	  check_tolPosMethod_VEC(
	    dynamic_cast<tolPosMethod_VEC *>(a_tolPosMethod), 0);
	}
      else
	check_tolPosMethod_VEC(
	  dynamic_cast<tolPosMethod_VEC *>(a_tolPosMethod), log);
      return;
    }
}

/********************************************************************/

void check_tolPosMethod_VEC(
 tolPosMethod_VEC * a_tolPosMethod_VEC,
 int log)
{
  if (a_tolPosMethod_VEC->get_dir())
    {
      adjustLevels(&tolPosMethod_VECAtts_dir, "tolPosMethod_VEC dir");
      if (log && !findString("dir", tolPosMethod_VECAtts))
	{
	  warnAtt("dir", "tolPosMethod_VEC", a_tolPosMethod_VEC);
	  check_vector(a_tolPosMethod_VEC->get_dir(), 0);
	}
      else
	check_vector(a_tolPosMethod_VEC->get_dir(), log);
    }
}

/********************************************************************/

void check_tolPosStart(
 tolPosStart * a_tolPosStart,
 int log)
{
  if (isA(a_tolPosStart, tolPosStart_TWOD))
    {
      adjustLevels(&tolPosStartSubs_tolPosStart_TWOD, "tolPosStart_TWOD");
      if (log && !findString("tolPosStart_TWOD", tolPosStartSubs))
	{
	  warnSub("tolPosStart_TWOD", "tolPosStart", a_tolPosStart);
	  check_tolPosStart_TWOD(
	    dynamic_cast<tolPosStart_TWOD *>(a_tolPosStart), 0);
	}
      else
	check_tolPosStart_TWOD(
	  dynamic_cast<tolPosStart_TWOD *>(a_tolPosStart), log);
      return;
    }
  if (isA(a_tolPosStart, tolPosStart_THREED))
    {
      adjustLevels(&tolPosStartSubs_tolPosStart_THREED, "tolPosStart_THREED");
      if (log && !findString("tolPosStart_THREED", tolPosStartSubs))
	{
	  warnSub("tolPosStart_THREED", "tolPosStart", a_tolPosStart);
	  check_tolPosStart_THREED(
	    dynamic_cast<tolPosStart_THREED *>(a_tolPosStart), 0);
	}
      else
	check_tolPosStart_THREED(
	  dynamic_cast<tolPosStart_THREED *>(a_tolPosStart), log);
      return;
    }
}

/********************************************************************/

void check_tolPosStart_THREED(
 tolPosStart_THREED * a_tolPosStart_THREED,
 int log)
{
  if (a_tolPosStart_THREED->get_tolzon())
    {
      adjustLevels(&tolPosStart_THREEDAtts_tolzon,
		   "tolPosStart_THREED tolzon");
      if (log && !findString("tolzon", tolPosStart_THREEDAtts))
	{
	  warnAtt("tolzon", "tolPosStart_THREED", a_tolPosStart_THREED);
	  check_rentVal(a_tolPosStart_THREED->get_tolzon(), 0);
	}
      else
	check_rentVal(a_tolPosStart_THREED->get_tolzon(), log);
    }
}

/********************************************************************/

void check_tolPosStart_TWOD(
 tolPosStart_TWOD * a_tolPosStart_TWOD,
 int log)
{
  if (a_tolPosStart_TWOD->get_tolzon())
    {
      adjustLevels(&tolPosStart_TWODAtts_tolzon, "tolPosStart_TWOD tolzon");
      if (log && !findString("tolzon", tolPosStart_TWODAtts))
	{
	  warnAtt("tolzon", "tolPosStart_TWOD", a_tolPosStart_TWOD);
	  check_rentVal(a_tolPosStart_TWOD->get_tolzon(), 0);
	}
      else
	check_rentVal(a_tolPosStart_TWOD->get_tolzon(), log);
    }
}

/********************************************************************/

void check_tolPosStm(
 tolPosStm * a_tolPosStm,
 int log)
{
  if (a_tolPosStm->get_tLabel())
    {
      adjustLevels(&tolPosStmAtts_a_tLabel, "tolPosStm a_tLabel");
      if (log && !findString("a_tLabel", tolPosStmAtts))
	{
	  warnAtt("a_tLabel", "tolPosStm", a_tolPosStm);
	  check_tLabel(a_tolPosStm->get_tLabel(), 0);
	}
      else
	check_tLabel(a_tolPosStm->get_tLabel(), log);
    }
  if (a_tolPosStm->get_tolPosStart())
    {
      adjustLevels(&tolPosStmAtts_a_tolPosStart, "tolPosStm a_tolPosStart");
      if (log && !findString("a_tolPosStart", tolPosStmAtts))
	{
	  warnAtt("a_tolPosStart", "tolPosStm", a_tolPosStm);
	  check_tolPosStart(a_tolPosStm->get_tolPosStart(), 0);
	}
      else
	check_tolPosStart(a_tolPosStm->get_tolPosStart(), log);
    }
  if (a_tolPosStm->get_tolPosEnd())
    {
      adjustLevels(&tolPosStmAtts_a_tolPosEnd, "tolPosStm a_tolPosEnd");
      if (log && !findString("a_tolPosEnd", tolPosStmAtts))
	{
	  warnAtt("a_tolPosEnd", "tolPosStm", a_tolPosStm);
	  check_tolPosEnd(a_tolPosStm->get_tolPosEnd(), 0);
	}
      else
	check_tolPosEnd(a_tolPosStm->get_tolPosEnd(), log);
    }
}

/********************************************************************/

void check_tolProflStm(
 tolProflStm * a_tolProflStm,
 int log)
{
  if (a_tolProflStm->get_tLabel())
    {
      adjustLevels(&tolProflStmAtts_a_tLabel, "tolProflStm a_tLabel");
      if (log && !findString("a_tLabel", tolProflStmAtts))
	{
	  warnAtt("a_tLabel", "tolProflStm", a_tolProflStm);
	  check_tLabel(a_tolProflStm->get_tLabel(), 0);
	}
      else
	check_tLabel(a_tolProflStm->get_tLabel(), log);
    }
  if (a_tolProflStm->get_lotol())
    {
      adjustLevels(&tolProflStmAtts_lotol, "tolProflStm lotol");
      if (log && !findString("lotol", tolProflStmAtts))
	{
	  warnAtt("lotol", "tolProflStm", a_tolProflStm);
	  check_rentVal(a_tolProflStm->get_lotol(), 0);
	}
      else
	check_rentVal(a_tolProflStm->get_lotol(), log);
    }
  if (a_tolProflStm->get_uptol())
    {
      adjustLevels(&tolProflStmAtts_uptol, "tolProflStm uptol");
      if (log && !findString("uptol", tolProflStmAtts))
	{
	  warnAtt("uptol", "tolProflStm", a_tolProflStm);
	  check_rentVal(a_tolProflStm->get_uptol(), 0);
	}
      else
	check_rentVal(a_tolProflStm->get_uptol(), log);
    }
  if (a_tolProflStm->get_tfm1())
    {
      adjustLevels(&tolProflStmAtts_tfm1, "tolProflStm tfm1");
      if (log && !findString("tfm1", tolProflStmAtts))
	{
	  warnAtt("tfm1", "tolProflStm", a_tolProflStm);
	  check_tolFeatureMat(a_tolProflStm->get_tfm1(), 0);
	}
      else
	check_tolFeatureMat(a_tolProflStm->get_tfm1(), log);
    }
  if (a_tolProflStm->get_tfm2())
    {
      adjustLevels(&tolProflStmAtts_tfm2, "tolProflStm tfm2");
      if (log && !findString("tfm2", tolProflStmAtts))
	{
	  warnAtt("tfm2", "tolProflStm", a_tolProflStm);
	  check_tolFeatureMat(a_tolProflStm->get_tfm2(), 0);
	}
      else
	check_tolFeatureMat(a_tolProflStm->get_tfm2(), log);
    }
  if (a_tolProflStm->get_tfm3())
    {
      adjustLevels(&tolProflStmAtts_tfm3, "tolProflStm tfm3");
      if (log && !findString("tfm3", tolProflStmAtts))
	{
	  warnAtt("tfm3", "tolProflStm", a_tolProflStm);
	  check_tolFeatureMat(a_tolProflStm->get_tfm3(), 0);
	}
      else
	check_tolFeatureMat(a_tolProflStm->get_tfm3(), log);
    }
  if (a_tolProflStm->get_tolZoneDir2())
    {
      adjustLevels(&tolProflStmAtts_a_tolZoneDir2,
		   "tolProflStm a_tolZoneDir2");
      if (log && !findString("a_tolZoneDir2", tolProflStmAtts))
	{
	  warnAtt("a_tolZoneDir2", "tolProflStm", a_tolProflStm);
	  check_tolZoneDir2(a_tolProflStm->get_tolZoneDir2(), 0);
	}
      else
	check_tolZoneDir2(a_tolProflStm->get_tolZoneDir2(), log);
    }
}

/********************************************************************/

void check_tolProfpStm(
 tolProfpStm * a_tolProfpStm,
 int log)
{
  if (a_tolProfpStm->get_tLabel())
    {
      adjustLevels(&tolProfpStmAtts_a_tLabel, "tolProfpStm a_tLabel");
      if (log && !findString("a_tLabel", tolProfpStmAtts))
	{
	  warnAtt("a_tLabel", "tolProfpStm", a_tolProfpStm);
	  check_tLabel(a_tolProfpStm->get_tLabel(), 0);
	}
      else
	check_tLabel(a_tolProfpStm->get_tLabel(), log);
    }
  if (a_tolProfpStm->get_lotol())
    {
      adjustLevels(&tolProfpStmAtts_lotol, "tolProfpStm lotol");
      if (log && !findString("lotol", tolProfpStmAtts))
	{
	  warnAtt("lotol", "tolProfpStm", a_tolProfpStm);
	  check_rentVal(a_tolProfpStm->get_lotol(), 0);
	}
      else
	check_rentVal(a_tolProfpStm->get_lotol(), log);
    }
  if (a_tolProfpStm->get_uptol())
    {
      adjustLevels(&tolProfpStmAtts_uptol, "tolProfpStm uptol");
      if (log && !findString("uptol", tolProfpStmAtts))
	{
	  warnAtt("uptol", "tolProfpStm", a_tolProfpStm);
	  check_rentVal(a_tolProfpStm->get_uptol(), 0);
	}
      else
	check_rentVal(a_tolProfpStm->get_uptol(), log);
    }
  if (a_tolProfpStm->get_tfm1())
    {
      adjustLevels(&tolProfpStmAtts_tfm1, "tolProfpStm tfm1");
      if (log && !findString("tfm1", tolProfpStmAtts))
	{
	  warnAtt("tfm1", "tolProfpStm", a_tolProfpStm);
	  check_tolFeatureMat(a_tolProfpStm->get_tfm1(), 0);
	}
      else
	check_tolFeatureMat(a_tolProfpStm->get_tfm1(), log);
    }
  if (a_tolProfpStm->get_tfm2())
    {
      adjustLevels(&tolProfpStmAtts_tfm2, "tolProfpStm tfm2");
      if (log && !findString("tfm2", tolProfpStmAtts))
	{
	  warnAtt("tfm2", "tolProfpStm", a_tolProfpStm);
	  check_tolFeatureMat(a_tolProfpStm->get_tfm2(), 0);
	}
      else
	check_tolFeatureMat(a_tolProfpStm->get_tfm2(), log);
    }
  if (a_tolProfpStm->get_tfm3())
    {
      adjustLevels(&tolProfpStmAtts_tfm3, "tolProfpStm tfm3");
      if (log && !findString("tfm3", tolProfpStmAtts))
	{
	  warnAtt("tfm3", "tolProfpStm", a_tolProfpStm);
	  check_tolFeatureMat(a_tolProfpStm->get_tfm3(), 0);
	}
      else
	check_tolFeatureMat(a_tolProfpStm->get_tfm3(), log);
    }
}

/********************************************************************/

void check_tolProfsStm(
 tolProfsStm * a_tolProfsStm,
 int log)
{
  if (a_tolProfsStm->get_tLabel())
    {
      adjustLevels(&tolProfsStmAtts_a_tLabel, "tolProfsStm a_tLabel");
      if (log && !findString("a_tLabel", tolProfsStmAtts))
	{
	  warnAtt("a_tLabel", "tolProfsStm", a_tolProfsStm);
	  check_tLabel(a_tolProfsStm->get_tLabel(), 0);
	}
      else
	check_tLabel(a_tolProfsStm->get_tLabel(), log);
    }
  if (a_tolProfsStm->get_lotol())
    {
      adjustLevels(&tolProfsStmAtts_lotol, "tolProfsStm lotol");
      if (log && !findString("lotol", tolProfsStmAtts))
	{
	  warnAtt("lotol", "tolProfsStm", a_tolProfsStm);
	  check_rentVal(a_tolProfsStm->get_lotol(), 0);
	}
      else
	check_rentVal(a_tolProfsStm->get_lotol(), log);
    }
  if (a_tolProfsStm->get_uptol())
    {
      adjustLevels(&tolProfsStmAtts_uptol, "tolProfsStm uptol");
      if (log && !findString("uptol", tolProfsStmAtts))
	{
	  warnAtt("uptol", "tolProfsStm", a_tolProfsStm);
	  check_rentVal(a_tolProfsStm->get_uptol(), 0);
	}
      else
	check_rentVal(a_tolProfsStm->get_uptol(), log);
    }
  if (a_tolProfsStm->get_tfm1())
    {
      adjustLevels(&tolProfsStmAtts_tfm1, "tolProfsStm tfm1");
      if (log && !findString("tfm1", tolProfsStmAtts))
	{
	  warnAtt("tfm1", "tolProfsStm", a_tolProfsStm);
	  check_tolFeatureMat(a_tolProfsStm->get_tfm1(), 0);
	}
      else
	check_tolFeatureMat(a_tolProfsStm->get_tfm1(), log);
    }
  if (a_tolProfsStm->get_tfm2())
    {
      adjustLevels(&tolProfsStmAtts_tfm2, "tolProfsStm tfm2");
      if (log && !findString("tfm2", tolProfsStmAtts))
	{
	  warnAtt("tfm2", "tolProfsStm", a_tolProfsStm);
	  check_tolFeatureMat(a_tolProfsStm->get_tfm2(), 0);
	}
      else
	check_tolFeatureMat(a_tolProfsStm->get_tfm2(), log);
    }
  if (a_tolProfsStm->get_tfm3())
    {
      adjustLevels(&tolProfsStmAtts_tfm3, "tolProfsStm tfm3");
      if (log && !findString("tfm3", tolProfsStmAtts))
	{
	  warnAtt("tfm3", "tolProfsStm", a_tolProfsStm);
	  check_tolFeatureMat(a_tolProfsStm->get_tfm3(), 0);
	}
      else
	check_tolFeatureMat(a_tolProfsStm->get_tfm3(), log);
    }
  if (a_tolProfsStm->get_has_AVGDEV())
    {
      adjustLevels(&tolProfsStmAtts_has_AVGDEV, "tolProfsStm has_AVGDEV");
      if (log && !findString("has_AVGDEV", tolProfsStmAtts))
	{
	  warnAtt("has_AVGDEV", "tolProfsStm", a_tolProfsStm);
	}
    }
}

/********************************************************************/

void check_tolRadSpec(
 tolRadSpec * a_tolRadSpec,
 int log)
{
  if (isA(a_tolRadSpec, tolRadSpec_AVG))
    {
      adjustLevels(&tolRadSpecSubs_tolRadSpec_AVG, "tolRadSpec_AVG");
      if (log && !findString("tolRadSpec_AVG", tolRadSpecSubs))
	{
	  warnSub("tolRadSpec_AVG", "tolRadSpec", a_tolRadSpec);
	}
      return;
    }
  if (isA(a_tolRadSpec, tolRadSpec_CRAD))
    {
      adjustLevels(&tolRadSpecSubs_tolRadSpec_CRAD, "tolRadSpec_CRAD");
      if (log && !findString("tolRadSpec_CRAD", tolRadSpecSubs))
	{
	  warnSub("tolRadSpec_CRAD", "tolRadSpec", a_tolRadSpec);
	}
      return;
    }
}

/********************************************************************/

void check_tolRadStm(
 tolRadStm * a_tolRadStm,
 int log)
{
  if (a_tolRadStm->get_tLabel())
    {
      adjustLevels(&tolRadStmAtts_a_tLabel, "tolRadStm a_tLabel");
      if (log && !findString("a_tLabel", tolRadStmAtts))
	{
	  warnAtt("a_tLabel", "tolRadStm", a_tolRadStm);
	  check_tLabel(a_tolRadStm->get_tLabel(), 0);
	}
      else
	check_tLabel(a_tolRadStm->get_tLabel(), log);
    }
  if (a_tolRadStm->get_lotol())
    {
      adjustLevels(&tolRadStmAtts_lotol, "tolRadStm lotol");
      if (log && !findString("lotol", tolRadStmAtts))
	{
	  warnAtt("lotol", "tolRadStm", a_tolRadStm);
	  check_rentVal(a_tolRadStm->get_lotol(), 0);
	}
      else
	check_rentVal(a_tolRadStm->get_lotol(), log);
    }
  if (a_tolRadStm->get_uptol())
    {
      adjustLevels(&tolRadStmAtts_uptol, "tolRadStm uptol");
      if (log && !findString("uptol", tolRadStmAtts))
	{
	  warnAtt("uptol", "tolRadStm", a_tolRadStm);
	  check_rentVal(a_tolRadStm->get_uptol(), 0);
	}
      else
	check_rentVal(a_tolRadStm->get_uptol(), log);
    }
  if (a_tolRadStm->get_tolRadSpec())
    {
      adjustLevels(&tolRadStmAtts_a_tolRadSpec, "tolRadStm a_tolRadSpec");
      if (log && !findString("a_tolRadSpec", tolRadStmAtts))
	{
	  warnAtt("a_tolRadSpec", "tolRadStm", a_tolRadStm);
	  check_tolRadSpec(a_tolRadStm->get_tolRadSpec(), 0);
	}
      else
	check_tolRadSpec(a_tolRadStm->get_tolRadSpec(), log);
    }
  if (a_tolRadStm->get_has_MINMAX())
    {
      adjustLevels(&tolRadStmAtts_has_MINMAX, "tolRadStm has_MINMAX");
      if (log && !findString("has_MINMAX", tolRadStmAtts))
	{
	  warnAtt("has_MINMAX", "tolRadStm", a_tolRadStm);
	}
    }
}

/********************************************************************/

void check_tolStrghtMat(
 tolStrghtMat * a_tolStrghtMat,
 int log)
{
  if (a_tolStrghtMat->get_tolzon())
    {
      adjustLevels(&tolStrghtMatAtts_tolzon, "tolStrghtMat tolzon");
      if (log && !findString("tolzon", tolStrghtMatAtts))
	{
	  warnAtt("tolzon", "tolStrghtMat", a_tolStrghtMat);
	  check_rentVal(a_tolStrghtMat->get_tolzon(), 0);
	}
      else
	check_rentVal(a_tolStrghtMat->get_tolzon(), log);
    }
  if (a_tolStrghtMat->get_tolMatCond())
    {
      adjustLevels(&tolStrghtMatAtts_a_tolMatCond,
		   "tolStrghtMat a_tolMatCond");
      if (log && !findString("a_tolMatCond", tolStrghtMatAtts))
	{
	  warnAtt("a_tolMatCond", "tolStrghtMat", a_tolStrghtMat);
	  check_tolMatCond(a_tolStrghtMat->get_tolMatCond(), 0);
	}
      else
	check_tolMatCond(a_tolStrghtMat->get_tolMatCond(), log);
    }
  if (a_tolStrghtMat->get_axis())
    {
      adjustLevels(&tolStrghtMatAtts_a_axis, "tolStrghtMat a_axis");
      if (log && !findString("a_axis", tolStrghtMatAtts))
	{
	  warnAtt("a_axis", "tolStrghtMat", a_tolStrghtMat);
	  check_axis(a_tolStrghtMat->get_axis(), 0);
	}
      else
	check_axis(a_tolStrghtMat->get_axis(), log);
    }
  if (a_tolStrghtMat->get_tolZoneDir3())
    {
      adjustLevels(&tolStrghtMatAtts_a_tolZoneDir3,
		   "tolStrghtMat a_tolZoneDir3");
      if (log && !findString("a_tolZoneDir3", tolStrghtMatAtts))
	{
	  warnAtt("a_tolZoneDir3", "tolStrghtMat", a_tolStrghtMat);
	  check_tolZoneDir3(a_tolStrghtMat->get_tolZoneDir3(), 0);
	}
      else
	check_tolZoneDir3(a_tolStrghtMat->get_tolZoneDir3(), log);
    }
}

/********************************************************************/

void check_tolStrghtMinor(
 tolStrghtMinor * a_tolStrghtMinor,
 int log)
{
  if (isA(a_tolStrghtMinor, tolStrghtPlain))
    {
      adjustLevels(&tolStrghtMinorSubs_tolStrghtPlain, "tolStrghtPlain");
      if (log && !findString("tolStrghtPlain", tolStrghtMinorSubs))
	{
	  warnSub("tolStrghtPlain", "tolStrghtMinor", a_tolStrghtMinor);
	  check_tolStrghtPlain(
	    dynamic_cast<tolStrghtPlain *>(a_tolStrghtMinor), 0);
	}
      else
	check_tolStrghtPlain(
	  dynamic_cast<tolStrghtPlain *>(a_tolStrghtMinor), log);
      return;
    }
  if (isA(a_tolStrghtMinor, tolStrghtMat))
    {
      adjustLevels(&tolStrghtMinorSubs_tolStrghtMat, "tolStrghtMat");
      if (log && !findString("tolStrghtMat", tolStrghtMinorSubs))
	{
	  warnSub("tolStrghtMat", "tolStrghtMinor", a_tolStrghtMinor);
	  check_tolStrghtMat(
	    dynamic_cast<tolStrghtMat *>(a_tolStrghtMinor), 0);
	}
      else
	check_tolStrghtMat(
	  dynamic_cast<tolStrghtMat *>(a_tolStrghtMinor), log);
      return;
    }
  if (isA(a_tolStrghtMinor, tolStrghtPer1))
    {
      adjustLevels(&tolStrghtMinorSubs_tolStrghtPer1, "tolStrghtPer1");
      if (log && !findString("tolStrghtPer1", tolStrghtMinorSubs))
	{
	  warnSub("tolStrghtPer1", "tolStrghtMinor", a_tolStrghtMinor);
	  check_tolStrghtPer1(
	    dynamic_cast<tolStrghtPer1 *>(a_tolStrghtMinor), 0);
	}
      else
	check_tolStrghtPer1(
	  dynamic_cast<tolStrghtPer1 *>(a_tolStrghtMinor), log);
      return;
    }
  if (isA(a_tolStrghtMinor, tolStrghtPer2))
    {
      adjustLevels(&tolStrghtMinorSubs_tolStrghtPer2, "tolStrghtPer2");
      if (log && !findString("tolStrghtPer2", tolStrghtMinorSubs))
	{
	  warnSub("tolStrghtPer2", "tolStrghtMinor", a_tolStrghtMinor);
	  check_tolStrghtPer2(
	    dynamic_cast<tolStrghtPer2 *>(a_tolStrghtMinor), 0);
	}
      else
	check_tolStrghtPer2(
	  dynamic_cast<tolStrghtPer2 *>(a_tolStrghtMinor), log);
      return;
    }
}

/********************************************************************/

void check_tolStrghtPer1(
 tolStrghtPer1 * a_tolStrghtPer1,
 int log)
{
  if (a_tolStrghtPer1->get_tolzon())
    {
      adjustLevels(&tolStrghtPer1Atts_tolzon, "tolStrghtPer1 tolzon");
      if (log && !findString("tolzon", tolStrghtPer1Atts))
	{
	  warnAtt("tolzon", "tolStrghtPer1", a_tolStrghtPer1);
	  check_rentVal(a_tolStrghtPer1->get_tolzon(), 0);
	}
      else
	check_rentVal(a_tolStrghtPer1->get_tolzon(), log);
    }
  if (a_tolStrghtPer1->get_unit())
    {
      adjustLevels(&tolStrghtPer1Atts_unit, "tolStrghtPer1 unit");
      if (log && !findString("unit", tolStrghtPer1Atts))
	{
	  warnAtt("unit", "tolStrghtPer1", a_tolStrghtPer1);
	  check_rentVal(a_tolStrghtPer1->get_unit(), 0);
	}
      else
	check_rentVal(a_tolStrghtPer1->get_unit(), log);
    }
  if (a_tolStrghtPer1->get_axis())
    {
      adjustLevels(&tolStrghtPer1Atts_a_axis, "tolStrghtPer1 a_axis");
      if (log && !findString("a_axis", tolStrghtPer1Atts))
	{
	  warnAtt("a_axis", "tolStrghtPer1", a_tolStrghtPer1);
	  check_axis(a_tolStrghtPer1->get_axis(), 0);
	}
      else
	check_axis(a_tolStrghtPer1->get_axis(), log);
    }
  if (a_tolStrghtPer1->get_tolZoneDir3())
    {
      adjustLevels(&tolStrghtPer1Atts_a_tolZoneDir3,
		   "tolStrghtPer1 a_tolZoneDir3");
      if (log && !findString("a_tolZoneDir3", tolStrghtPer1Atts))
	{
	  warnAtt("a_tolZoneDir3", "tolStrghtPer1", a_tolStrghtPer1);
	  check_tolZoneDir3(a_tolStrghtPer1->get_tolZoneDir3(), 0);
	}
      else
	check_tolZoneDir3(a_tolStrghtPer1->get_tolZoneDir3(), log);
    }
}

/********************************************************************/

void check_tolStrghtPer2(
 tolStrghtPer2 * a_tolStrghtPer2,
 int log)
{
  if (a_tolStrghtPer2->get_tolzon())
    {
      adjustLevels(&tolStrghtPer2Atts_tolzon, "tolStrghtPer2 tolzon");
      if (log && !findString("tolzon", tolStrghtPer2Atts))
	{
	  warnAtt("tolzon", "tolStrghtPer2", a_tolStrghtPer2);
	  check_rentVal(a_tolStrghtPer2->get_tolzon(), 0);
	}
      else
	check_rentVal(a_tolStrghtPer2->get_tolzon(), log);
    }
  if (a_tolStrghtPer2->get_tolzon1())
    {
      adjustLevels(&tolStrghtPer2Atts_tolzon1, "tolStrghtPer2 tolzon1");
      if (log && !findString("tolzon1", tolStrghtPer2Atts))
	{
	  warnAtt("tolzon1", "tolStrghtPer2", a_tolStrghtPer2);
	  check_rentVal(a_tolStrghtPer2->get_tolzon1(), 0);
	}
      else
	check_rentVal(a_tolStrghtPer2->get_tolzon1(), log);
    }
  if (a_tolStrghtPer2->get_unit())
    {
      adjustLevels(&tolStrghtPer2Atts_unit, "tolStrghtPer2 unit");
      if (log && !findString("unit", tolStrghtPer2Atts))
	{
	  warnAtt("unit", "tolStrghtPer2", a_tolStrghtPer2);
	  check_rentVal(a_tolStrghtPer2->get_unit(), 0);
	}
      else
	check_rentVal(a_tolStrghtPer2->get_unit(), log);
    }
  if (a_tolStrghtPer2->get_axis())
    {
      adjustLevels(&tolStrghtPer2Atts_a_axis, "tolStrghtPer2 a_axis");
      if (log && !findString("a_axis", tolStrghtPer2Atts))
	{
	  warnAtt("a_axis", "tolStrghtPer2", a_tolStrghtPer2);
	  check_axis(a_tolStrghtPer2->get_axis(), 0);
	}
      else
	check_axis(a_tolStrghtPer2->get_axis(), log);
    }
  if (a_tolStrghtPer2->get_tolZoneDir3())
    {
      adjustLevels(&tolStrghtPer2Atts_a_tolZoneDir3,
		   "tolStrghtPer2 a_tolZoneDir3");
      if (log && !findString("a_tolZoneDir3", tolStrghtPer2Atts))
	{
	  warnAtt("a_tolZoneDir3", "tolStrghtPer2", a_tolStrghtPer2);
	  check_tolZoneDir3(a_tolStrghtPer2->get_tolZoneDir3(), 0);
	}
      else
	check_tolZoneDir3(a_tolStrghtPer2->get_tolZoneDir3(), log);
    }
}

/********************************************************************/

void check_tolStrghtPlain(
 tolStrghtPlain * a_tolStrghtPlain,
 int log)
{
  if (a_tolStrghtPlain->get_tolzon())
    {
      adjustLevels(&tolStrghtPlainAtts_tolzon, "tolStrghtPlain tolzon");
      if (log && !findString("tolzon", tolStrghtPlainAtts))
	{
	  warnAtt("tolzon", "tolStrghtPlain", a_tolStrghtPlain);
	  check_rentVal(a_tolStrghtPlain->get_tolzon(), 0);
	}
      else
	check_rentVal(a_tolStrghtPlain->get_tolzon(), log);
    }
  if (a_tolStrghtPlain->get_axis())
    {
      adjustLevels(&tolStrghtPlainAtts_a_axis, "tolStrghtPlain a_axis");
      if (log && !findString("a_axis", tolStrghtPlainAtts))
	{
	  warnAtt("a_axis", "tolStrghtPlain", a_tolStrghtPlain);
	  check_axis(a_tolStrghtPlain->get_axis(), 0);
	}
      else
	check_axis(a_tolStrghtPlain->get_axis(), log);
    }
  if (a_tolStrghtPlain->get_tolZoneDir3())
    {
      adjustLevels(&tolStrghtPlainAtts_a_tolZoneDir3,
		   "tolStrghtPlain a_tolZoneDir3");
      if (log && !findString("a_tolZoneDir3", tolStrghtPlainAtts))
	{
	  warnAtt("a_tolZoneDir3", "tolStrghtPlain", a_tolStrghtPlain);
	  check_tolZoneDir3(a_tolStrghtPlain->get_tolZoneDir3(), 0);
	}
      else
	check_tolZoneDir3(a_tolStrghtPlain->get_tolZoneDir3(), log);
    }
}

/********************************************************************/

void check_tolStrghtStm(
 tolStrghtStm * a_tolStrghtStm,
 int log)
{
  if (a_tolStrghtStm->get_tLabel())
    {
      adjustLevels(&tolStrghtStmAtts_a_tLabel, "tolStrghtStm a_tLabel");
      if (log && !findString("a_tLabel", tolStrghtStmAtts))
	{
	  warnAtt("a_tLabel", "tolStrghtStm", a_tolStrghtStm);
	  check_tLabel(a_tolStrghtStm->get_tLabel(), 0);
	}
      else
	check_tLabel(a_tolStrghtStm->get_tLabel(), log);
    }
  if (a_tolStrghtStm->get_tolStrghtMinor())
    {
      adjustLevels(&tolStrghtStmAtts_a_tolStrghtMinor,
		   "tolStrghtStm a_tolStrghtMinor");
      if (log && !findString("a_tolStrghtMinor", tolStrghtStmAtts))
	{
	  warnAtt("a_tolStrghtMinor", "tolStrghtStm", a_tolStrghtStm);
	  check_tolStrghtMinor(a_tolStrghtStm->get_tolStrghtMinor(), 0);
	}
      else
	check_tolStrghtMinor(a_tolStrghtStm->get_tolStrghtMinor(), log);
    }
}

/********************************************************************/

void check_tolSymStm(
 tolSymStm * a_tolSymStm,
 int log)
{
  if (a_tolSymStm->get_tLabel())
    {
      adjustLevels(&tolSymStmAtts_a_tLabel, "tolSymStm a_tLabel");
      if (log && !findString("a_tLabel", tolSymStmAtts))
	{
	  warnAtt("a_tLabel", "tolSymStm", a_tolSymStm);
	  check_tLabel(a_tolSymStm->get_tLabel(), 0);
	}
      else
	check_tLabel(a_tolSymStm->get_tLabel(), log);
    }
  if (a_tolSymStm->get_tolzon())
    {
      adjustLevels(&tolSymStmAtts_tolzon, "tolSymStm tolzon");
      if (log && !findString("tolzon", tolSymStmAtts))
	{
	  warnAtt("tolzon", "tolSymStm", a_tolSymStm);
	  check_rentVal(a_tolSymStm->get_tolzon(), 0);
	}
      else
	check_rentVal(a_tolSymStm->get_tolzon(), log);
    }
  if (a_tolSymStm->get_tolFeatureMat())
    {
      adjustLevels(&tolSymStmAtts_a_tolFeatureMat,
		   "tolSymStm a_tolFeatureMat");
      if (log && !findString("a_tolFeatureMat", tolSymStmAtts))
	{
	  warnAtt("a_tolFeatureMat", "tolSymStm", a_tolSymStm);
	  check_tolFeatureMat(a_tolSymStm->get_tolFeatureMat(), 0);
	}
      else
	check_tolFeatureMat(a_tolSymStm->get_tolFeatureMat(), log);
    }
  if (a_tolSymStm->get_tolZoneDir3())
    {
      adjustLevels(&tolSymStmAtts_a_tolZoneDir3, "tolSymStm a_tolZoneDir3");
      if (log && !findString("a_tolZoneDir3", tolSymStmAtts))
	{
	  warnAtt("a_tolZoneDir3", "tolSymStm", a_tolSymStm);
	  check_tolZoneDir3(a_tolSymStm->get_tolZoneDir3(), 0);
	}
      else
	check_tolZoneDir3(a_tolSymStm->get_tolZoneDir3(), log);
    }
}

/********************************************************************/

void check_tolTrnoutStm(
 tolTrnoutStm * a_tolTrnoutStm,
 int log)
{
  if (a_tolTrnoutStm->get_tLabel())
    {
      adjustLevels(&tolTrnoutStmAtts_a_tLabel, "tolTrnoutStm a_tLabel");
      if (log && !findString("a_tLabel", tolTrnoutStmAtts))
	{
	  warnAtt("a_tLabel", "tolTrnoutStm", a_tolTrnoutStm);
	  check_tLabel(a_tolTrnoutStm->get_tLabel(), 0);
	}
      else
	check_tLabel(a_tolTrnoutStm->get_tLabel(), log);
    }
  if (a_tolTrnoutStm->get_tolzon())
    {
      adjustLevels(&tolTrnoutStmAtts_tolzon, "tolTrnoutStm tolzon");
      if (log && !findString("tolzon", tolTrnoutStmAtts))
	{
	  warnAtt("tolzon", "tolTrnoutStm", a_tolTrnoutStm);
	  check_rentVal(a_tolTrnoutStm->get_tolzon(), 0);
	}
      else
	check_rentVal(a_tolTrnoutStm->get_tolzon(), log);
    }
  if (a_tolTrnoutStm->get_datLabel())
    {
      adjustLevels(&tolTrnoutStmAtts_a_datLabel, "tolTrnoutStm a_datLabel");
      if (log && !findString("a_datLabel", tolTrnoutStmAtts))
	{
	  warnAtt("a_datLabel", "tolTrnoutStm", a_tolTrnoutStm);
	  check_datLabel(a_tolTrnoutStm->get_datLabel(), 0);
	}
      else
	check_datLabel(a_tolTrnoutStm->get_datLabel(), log);
    }
  if (a_tolTrnoutStm->get_tolFeat1())
    {
      adjustLevels(&tolTrnoutStmAtts_tolFeat1, "tolTrnoutStm tolFeat1");
      if (log && !findString("tolFeat1", tolTrnoutStmAtts))
	{
	  warnAtt("tolFeat1", "tolTrnoutStm", a_tolTrnoutStm);
	  check_tolFeature(a_tolTrnoutStm->get_tolFeat1(), 0);
	}
      else
	check_tolFeature(a_tolTrnoutStm->get_tolFeat1(), log);
    }
  if (a_tolTrnoutStm->get_tolFeat2())
    {
      adjustLevels(&tolTrnoutStmAtts_tolFeat2, "tolTrnoutStm tolFeat2");
      if (log && !findString("tolFeat2", tolTrnoutStmAtts))
	{
	  warnAtt("tolFeat2", "tolTrnoutStm", a_tolTrnoutStm);
	  check_tolFeature(a_tolTrnoutStm->get_tolFeat2(), 0);
	}
      else
	check_tolFeature(a_tolTrnoutStm->get_tolFeat2(), log);
    }
}

/********************************************************************/

void check_tolUsetolStm(
 tolUsetolStm * a_tolUsetolStm,
 int log)
{
  if (a_tolUsetolStm->get_tLabel())
    {
      adjustLevels(&tolUsetolStmAtts_a_tLabel, "tolUsetolStm a_tLabel");
      if (log && !findString("a_tLabel", tolUsetolStmAtts))
	{
	  warnAtt("a_tLabel", "tolUsetolStm", a_tolUsetolStm);
	  check_tLabel(a_tolUsetolStm->get_tLabel(), 0);
	}
      else
	check_tLabel(a_tolUsetolStm->get_tLabel(), log);
    }
  if (a_tolUsetolStm->get_text())
    {
      adjustLevels(&tolUsetolStmAtts_text, "tolUsetolStm text");
      if (log && !findString("text", tolUsetolStmAtts))
	{
	  warnAtt("text", "tolUsetolStm", a_tolUsetolStm);
	  check_stringVal(a_tolUsetolStm->get_text(), 0);
	}
      else
	check_stringVal(a_tolUsetolStm->get_text(), log);
    }
}

/********************************************************************/

void check_tolWidthDir(
 tolWidthDir * a_tolWidthDir,
 int log)
{
  if (isA(a_tolWidthDir, tolWidthDir_vector))
    {
      adjustLevels(&tolWidthDirSubs_tolWidthDir_vector, "tolWidthDir_vector");
      if (log && !findString("tolWidthDir_vector", tolWidthDirSubs))
	{
	  warnSub("tolWidthDir_vector", "tolWidthDir", a_tolWidthDir);
	  check_tolWidthDir_vector(
	    dynamic_cast<tolWidthDir_vector *>(a_tolWidthDir), 0);
	}
      else
	check_tolWidthDir_vector(
	  dynamic_cast<tolWidthDir_vector *>(a_tolWidthDir), log);
      return;
    }
  if (isA(a_tolWidthDir, tolWidthDir_SHORT))
    {
      adjustLevels(&tolWidthDirSubs_tolWidthDir_SHORT, "tolWidthDir_SHORT");
      if (log && !findString("tolWidthDir_SHORT", tolWidthDirSubs))
	{
	  warnSub("tolWidthDir_SHORT", "tolWidthDir", a_tolWidthDir);
	}
      return;
    }
  if (isA(a_tolWidthDir, tolWidthDir_LONG))
    {
      adjustLevels(&tolWidthDirSubs_tolWidthDir_LONG, "tolWidthDir_LONG");
      if (log && !findString("tolWidthDir_LONG", tolWidthDirSubs))
	{
	  warnSub("tolWidthDir_LONG", "tolWidthDir", a_tolWidthDir);
	}
      return;
    }
}

/********************************************************************/

void check_tolWidthDir_vector(
 tolWidthDir_vector * a_tolWidthDir_vector,
 int log)
{
  if (a_tolWidthDir_vector->get_dir())
    {
      adjustLevels(&tolWidthDir_vectorAtts_dir, "tolWidthDir_vector dir");
      if (log && !findString("dir", tolWidthDir_vectorAtts))
	{
	  warnAtt("dir", "tolWidthDir_vector", a_tolWidthDir_vector);
	  check_vector(a_tolWidthDir_vector->get_dir(), 0);
	}
      else
	check_vector(a_tolWidthDir_vector->get_dir(), log);
    }
}

/********************************************************************/

void check_tolWidthStm(
 tolWidthStm * a_tolWidthStm,
 int log)
{
  if (a_tolWidthStm->get_tLabel())
    {
      adjustLevels(&tolWidthStmAtts_a_tLabel, "tolWidthStm a_tLabel");
      if (log && !findString("a_tLabel", tolWidthStmAtts))
	{
	  warnAtt("a_tLabel", "tolWidthStm", a_tolWidthStm);
	  check_tLabel(a_tolWidthStm->get_tLabel(), 0);
	}
      else
	check_tLabel(a_tolWidthStm->get_tLabel(), log);
    }
  if (a_tolWidthStm->get_lotol())
    {
      adjustLevels(&tolWidthStmAtts_lotol, "tolWidthStm lotol");
      if (log && !findString("lotol", tolWidthStmAtts))
	{
	  warnAtt("lotol", "tolWidthStm", a_tolWidthStm);
	  check_rentVal(a_tolWidthStm->get_lotol(), 0);
	}
      else
	check_rentVal(a_tolWidthStm->get_lotol(), log);
    }
  if (a_tolWidthStm->get_uptol())
    {
      adjustLevels(&tolWidthStmAtts_uptol, "tolWidthStm uptol");
      if (log && !findString("uptol", tolWidthStmAtts))
	{
	  warnAtt("uptol", "tolWidthStm", a_tolWidthStm);
	  check_rentVal(a_tolWidthStm->get_uptol(), 0);
	}
      else
	check_rentVal(a_tolWidthStm->get_uptol(), log);
    }
  if (a_tolWidthStm->get_tolWidthDir())
    {
      adjustLevels(&tolWidthStmAtts_a_tolWidthDir,
		   "tolWidthStm a_tolWidthDir");
      if (log && !findString("a_tolWidthDir", tolWidthStmAtts))
	{
	  warnAtt("a_tolWidthDir", "tolWidthStm", a_tolWidthStm);
	  check_tolWidthDir(a_tolWidthStm->get_tolWidthDir(), 0);
	}
      else
	check_tolWidthDir(a_tolWidthStm->get_tolWidthDir(), log);
    }
  if (a_tolWidthStm->get_has_MINMAX())
    {
      adjustLevels(&tolWidthStmAtts_has_MINMAX, "tolWidthStm has_MINMAX");
      if (log && !findString("has_MINMAX", tolWidthStmAtts))
	{
	  warnAtt("has_MINMAX", "tolWidthStm", a_tolWidthStm);
	}
    }
}

/********************************************************************/

void check_tolZoneDir(
 tolZoneDir * a_tolZoneDir,
 int log)
{
  if (isA(a_tolZoneDir, tolZoneDir_XAXIS))
    {
      adjustLevels(&tolZoneDirSubs_tolZoneDir_XAXIS, "tolZoneDir_XAXIS");
      if (log && !findString("tolZoneDir_XAXIS", tolZoneDirSubs))
	{
	  warnSub("tolZoneDir_XAXIS", "tolZoneDir", a_tolZoneDir);
	}
      return;
    }
  if (isA(a_tolZoneDir, tolZoneDir_YAXIS))
    {
      adjustLevels(&tolZoneDirSubs_tolZoneDir_YAXIS, "tolZoneDir_YAXIS");
      if (log && !findString("tolZoneDir_YAXIS", tolZoneDirSubs))
	{
	  warnSub("tolZoneDir_YAXIS", "tolZoneDir", a_tolZoneDir);
	}
      return;
    }
  if (isA(a_tolZoneDir, tolZoneDir_ZAXIS))
    {
      adjustLevels(&tolZoneDirSubs_tolZoneDir_ZAXIS, "tolZoneDir_ZAXIS");
      if (log && !findString("tolZoneDir_ZAXIS", tolZoneDirSubs))
	{
	  warnSub("tolZoneDir_ZAXIS", "tolZoneDir", a_tolZoneDir);
	}
      return;
    }
  if (isA(a_tolZoneDir, tolZoneDir_VEC))
    {
      adjustLevels(&tolZoneDirSubs_tolZoneDir_VEC, "tolZoneDir_VEC");
      if (log && !findString("tolZoneDir_VEC", tolZoneDirSubs))
	{
	  warnSub("tolZoneDir_VEC", "tolZoneDir", a_tolZoneDir);
	  check_tolZoneDir_VEC(
	    dynamic_cast<tolZoneDir_VEC *>(a_tolZoneDir), 0);
	}
      else
	check_tolZoneDir_VEC(
	  dynamic_cast<tolZoneDir_VEC *>(a_tolZoneDir), log);
      return;
    }
}

/********************************************************************/

void check_tolZoneDir2(
 tolZoneDir2 * a_tolZoneDir2,
 int log)
{
  if (isA(a_tolZoneDir2, tolZoneDir2_XYPLAN))
    {
      adjustLevels(&tolZoneDir2Subs_tolZoneDir2_XYPLAN, "tolZoneDir2_XYPLAN");
      if (log && !findString("tolZoneDir2_XYPLAN", tolZoneDir2Subs))
	{
	  warnSub("tolZoneDir2_XYPLAN", "tolZoneDir2", a_tolZoneDir2);
	}
      return;
    }
  if (isA(a_tolZoneDir2, tolZoneDir2_YZPLAN))
    {
      adjustLevels(&tolZoneDir2Subs_tolZoneDir2_YZPLAN, "tolZoneDir2_YZPLAN");
      if (log && !findString("tolZoneDir2_YZPLAN", tolZoneDir2Subs))
	{
	  warnSub("tolZoneDir2_YZPLAN", "tolZoneDir2", a_tolZoneDir2);
	}
      return;
    }
  if (isA(a_tolZoneDir2, tolZoneDir2_ZXPLAN))
    {
      adjustLevels(&tolZoneDir2Subs_tolZoneDir2_ZXPLAN, "tolZoneDir2_ZXPLAN");
      if (log && !findString("tolZoneDir2_ZXPLAN", tolZoneDir2Subs))
	{
	  warnSub("tolZoneDir2_ZXPLAN", "tolZoneDir2", a_tolZoneDir2);
	}
      return;
    }
  if (isA(a_tolZoneDir2, tolZoneDir2_VEC))
    {
      adjustLevels(&tolZoneDir2Subs_tolZoneDir2_VEC, "tolZoneDir2_VEC");
      if (log && !findString("tolZoneDir2_VEC", tolZoneDir2Subs))
	{
	  warnSub("tolZoneDir2_VEC", "tolZoneDir2", a_tolZoneDir2);
	  check_tolZoneDir2_VEC(
	    dynamic_cast<tolZoneDir2_VEC *>(a_tolZoneDir2), 0);
	}
      else
	check_tolZoneDir2_VEC(
	  dynamic_cast<tolZoneDir2_VEC *>(a_tolZoneDir2), log);
      return;
    }
}

/********************************************************************/

void check_tolZoneDir2_VEC(
 tolZoneDir2_VEC * a_tolZoneDir2_VEC,
 int log)
{
  if (a_tolZoneDir2_VEC->get_planeVec())
    {
      adjustLevels(&tolZoneDir2_VECAtts_planeVec, "tolZoneDir2_VEC planeVec");
      if (log && !findString("planeVec", tolZoneDir2_VECAtts))
	{
	  warnAtt("planeVec", "tolZoneDir2_VEC", a_tolZoneDir2_VEC);
	  check_vector(a_tolZoneDir2_VEC->get_planeVec(), 0);
	}
      else
	check_vector(a_tolZoneDir2_VEC->get_planeVec(), log);
    }
}

/********************************************************************/

void check_tolZoneDir3(
 tolZoneDir3 * a_tolZoneDir3,
 int log)
{
  if (isA(a_tolZoneDir3, tolZoneDir3_XDIR))
    {
      adjustLevels(&tolZoneDir3Subs_tolZoneDir3_XDIR, "tolZoneDir3_XDIR");
      if (log && !findString("tolZoneDir3_XDIR", tolZoneDir3Subs))
	{
	  warnSub("tolZoneDir3_XDIR", "tolZoneDir3", a_tolZoneDir3);
	}
      return;
    }
  if (isA(a_tolZoneDir3, tolZoneDir3_YDIR))
    {
      adjustLevels(&tolZoneDir3Subs_tolZoneDir3_YDIR, "tolZoneDir3_YDIR");
      if (log && !findString("tolZoneDir3_YDIR", tolZoneDir3Subs))
	{
	  warnSub("tolZoneDir3_YDIR", "tolZoneDir3", a_tolZoneDir3);
	}
      return;
    }
  if (isA(a_tolZoneDir3, tolZoneDir3_ZDIR))
    {
      adjustLevels(&tolZoneDir3Subs_tolZoneDir3_ZDIR, "tolZoneDir3_ZDIR");
      if (log && !findString("tolZoneDir3_ZDIR", tolZoneDir3Subs))
	{
	  warnSub("tolZoneDir3_ZDIR", "tolZoneDir3", a_tolZoneDir3);
	}
      return;
    }
  if (isA(a_tolZoneDir3, tolZoneDir3_VEC))
    {
      adjustLevels(&tolZoneDir3Subs_tolZoneDir3_VEC, "tolZoneDir3_VEC");
      if (log && !findString("tolZoneDir3_VEC", tolZoneDir3Subs))
	{
	  warnSub("tolZoneDir3_VEC", "tolZoneDir3", a_tolZoneDir3);
	  check_tolZoneDir3_VEC(
	    dynamic_cast<tolZoneDir3_VEC *>(a_tolZoneDir3), 0);
	}
      else
	check_tolZoneDir3_VEC(
	  dynamic_cast<tolZoneDir3_VEC *>(a_tolZoneDir3), log);
      return;
    }
}

/********************************************************************/

void check_tolZoneDir3_VEC(
 tolZoneDir3_VEC * a_tolZoneDir3_VEC,
 int log)
{
  if (a_tolZoneDir3_VEC->get_dir())
    {
      adjustLevels(&tolZoneDir3_VECAtts_dir, "tolZoneDir3_VEC dir");
      if (log && !findString("dir", tolZoneDir3_VECAtts))
	{
	  warnAtt("dir", "tolZoneDir3_VEC", a_tolZoneDir3_VEC);
	  check_vector(a_tolZoneDir3_VEC->get_dir(), 0);
	}
      else
	check_vector(a_tolZoneDir3_VEC->get_dir(), log);
    }
}

/********************************************************************/

void check_tolZoneDir_VEC(
 tolZoneDir_VEC * a_tolZoneDir_VEC,
 int log)
{
  if (a_tolZoneDir_VEC->get_dir())
    {
      adjustLevels(&tolZoneDir_VECAtts_dir, "tolZoneDir_VEC dir");
      if (log && !findString("dir", tolZoneDir_VECAtts))
	{
	  warnAtt("dir", "tolZoneDir_VEC", a_tolZoneDir_VEC);
	  check_vector(a_tolZoneDir_VEC->get_dir(), 0);
	}
      else
	check_vector(a_tolZoneDir_VEC->get_dir(), log);
    }
}

/********************************************************************/

void check_tolZoneType(
 tolZoneType * a_tolZoneType,
 int log)
{
  if (isA(a_tolZoneType, tolZoneType_TANGPL))
    {
      adjustLevels(&tolZoneTypeSubs_tolZoneType_TANGPL, "tolZoneType_TANGPL");
      if (log && !findString("tolZoneType_TANGPL", tolZoneTypeSubs))
	{
	  warnSub("tolZoneType_TANGPL", "tolZoneType", a_tolZoneType);
	}
      return;
    }
  if (isA(a_tolZoneType, tolZoneType_PARPLN))
    {
      adjustLevels(&tolZoneTypeSubs_tolZoneType_PARPLN, "tolZoneType_PARPLN");
      if (log && !findString("tolZoneType_PARPLN", tolZoneTypeSubs))
	{
	  warnSub("tolZoneType_PARPLN", "tolZoneType", a_tolZoneType);
	}
      return;
    }
}

/********************************************************************/

void check_toleranceLabel(
 toleranceLabel * a_toleranceLabel,
 int log)
{
  if (isA(a_toleranceLabel, tLabel))
    {
      adjustLevels(&toleranceLabelSubs_tLabel, "tLabel");
      if (log && !findString("tLabel", toleranceLabelSubs))
	{
	  warnSub("tLabel", "toleranceLabel", a_toleranceLabel);
	  check_tLabel(dynamic_cast<tLabel *>(a_toleranceLabel), 0);
	}
      else
	check_tLabel(dynamic_cast<tLabel *>(a_toleranceLabel), log);
      return;
    }
  if (isA(a_toleranceLabel, taLabel))
    {
      adjustLevels(&toleranceLabelSubs_taLabel, "taLabel");
      if (log && !findString("taLabel", toleranceLabelSubs))
	{
	  warnSub("taLabel", "toleranceLabel", a_toleranceLabel);
	  check_taLabel(dynamic_cast<taLabel *>(a_toleranceLabel), 0);
	}
      else
	check_taLabel(dynamic_cast<taLabel *>(a_toleranceLabel), log);
      return;
    }
}

/********************************************************************/

void check_tooldfStm(
 tooldfStm * a_tooldfStm,
 int log)
{
  if (a_tooldfStm->get_tlLabel())
    {
      adjustLevels(&tooldfStmAtts_a_tlLabel, "tooldfStm a_tlLabel");
      if (log && !findString("a_tlLabel", tooldfStmAtts))
	{
	  warnAtt("a_tlLabel", "tooldfStm", a_tooldfStm);
	  check_tlLabel(a_tooldfStm->get_tlLabel(), 0);
	}
      else
	check_tlLabel(a_tooldfStm->get_tlLabel(), log);
    }
  if (a_tooldfStm->get_mdLabel())
    {
      adjustLevels(&tooldfStmAtts_a_mdLabel, "tooldfStm a_mdLabel");
      if (log && !findString("a_mdLabel", tooldfStmAtts))
	{
	  warnAtt("a_mdLabel", "tooldfStm", a_tooldfStm);
	  check_mdLabel(a_tooldfStm->get_mdLabel(), 0);
	}
      else
	check_mdLabel(a_tooldfStm->get_mdLabel(), log);
    }
  if (a_tooldfStm->get_text())
    {
      adjustLevels(&tooldfStmAtts_text, "tooldfStm text");
      if (log && !findString("text", tooldfStmAtts))
	{
	  warnAtt("text", "tooldfStm", a_tooldfStm);
	  check_stringVal(a_tooldfStm->get_text(), 0);
	}
      else
	check_stringVal(a_tooldfStm->get_text(), log);
    }
}

/********************************************************************/

void check_touchSpec(
 touchSpec * a_touchSpec,
 int log)
{
  if (isA(a_touchSpec, touchSpec_HEADTOUCH))
    {
      adjustLevels(&touchSpecSubs_touchSpec_HEADTOUCH, "touchSpec_HEADTOUCH");
      if (log && !findString("touchSpec_HEADTOUCH", touchSpecSubs))
	{
	  warnSub("touchSpec_HEADTOUCH", "touchSpec", a_touchSpec);
	}
      return;
    }
  if (isA(a_touchSpec, touchSpec_ALLAXESTOUCH))
    {
      adjustLevels(&touchSpecSubs_touchSpec_ALLAXESTOUCH,
		   "touchSpec_ALLAXESTOUCH");
      if (log && !findString("touchSpec_ALLAXESTOUCH", touchSpecSubs))
	{
	  warnSub("touchSpec_ALLAXESTOUCH", "touchSpec", a_touchSpec);
	}
      return;
    }
}

/********************************************************************/

void check_trConst(
 trConst * a_trConst,
 int log)
{
  if (a_trConst->get_faLabel())
    {
      adjustLevels(&trConstAtts_a_faLabel, "trConst a_faLabel");
      if (log && !findString("a_faLabel", trConstAtts))
	{
	  warnAtt("a_faLabel", "trConst", a_trConst);
	  check_faLabel(a_trConst->get_faLabel(), 0);
	}
      else
	check_faLabel(a_trConst->get_faLabel(), log);
    }
  if (a_trConst->get_datumLabel())
    {
      adjustLevels(&trConstAtts_a_datumLabel, "trConst a_datumLabel");
      if (log && !findString("a_datumLabel", trConstAtts))
	{
	  warnAtt("a_datumLabel", "trConst", a_trConst);
	  check_datumLabel(a_trConst->get_datumLabel(), 0);
	}
      else
	check_datumLabel(a_trConst->get_datumLabel(), log);
    }
}

/********************************************************************/

void check_transDatum(
 transDatum * a_transDatum,
 int log)
{
  if (a_transDatum->get_orig())
    {
      adjustLevels(&transDatumAtts_a_orig, "transDatum a_orig");
      if (log && !findString("a_orig", transDatumAtts))
	{
	  warnAtt("a_orig", "transDatum", a_transDatum);
	  check_orig(a_transDatum->get_orig(), 0);
	}
      else
	check_orig(a_transDatum->get_orig(), log);
    }
  if (a_transDatum->get_datLabel())
    {
      adjustLevels(&transDatumAtts_a_datLabel, "transDatum a_datLabel");
      if (log && !findString("a_datLabel", transDatumAtts))
	{
	  warnAtt("a_datLabel", "transDatum", a_transDatum);
	  check_datLabel(a_transDatum->get_datLabel(), 0);
	}
      else
	check_datLabel(a_transDatum->get_datLabel(), log);
    }
}

/********************************************************************/

void check_transFeature(
 transFeature * a_transFeature,
 int log)
{
  if (a_transFeature->get_orig())
    {
      adjustLevels(&transFeatureAtts_a_orig, "transFeature a_orig");
      if (log && !findString("a_orig", transFeatureAtts))
	{
	  warnAtt("a_orig", "transFeature", a_transFeature);
	  check_orig(a_transFeature->get_orig(), 0);
	}
      else
	check_orig(a_transFeature->get_orig(), log);
    }
  if (a_transFeature->get_featureLabel())
    {
      adjustLevels(&transFeatureAtts_a_featureLabel,
		   "transFeature a_featureLabel");
      if (log && !findString("a_featureLabel", transFeatureAtts))
	{
	  warnAtt("a_featureLabel", "transFeature", a_transFeature);
	  check_featureLabel(a_transFeature->get_featureLabel(), 0);
	}
      else
	check_featureLabel(a_transFeature->get_featureLabel(), log);
    }
}

/********************************************************************/

void check_transMinor(
 transMinor * a_transMinor,
 int log)
{
  if (isA(a_transMinor, transValue))
    {
      adjustLevels(&transMinorSubs_transValue, "transValue");
      if (log && !findString("transValue", transMinorSubs))
	{
	  warnSub("transValue", "transMinor", a_transMinor);
	  check_transValue(dynamic_cast<transValue *>(a_transMinor), 0);
	}
      else
	check_transValue(dynamic_cast<transValue *>(a_transMinor), log);
      return;
    }
  if (isA(a_transMinor, transFeature))
    {
      adjustLevels(&transMinorSubs_transFeature, "transFeature");
      if (log && !findString("transFeature", transMinorSubs))
	{
	  warnSub("transFeature", "transMinor", a_transMinor);
	  check_transFeature(
	    dynamic_cast<transFeature *>(a_transMinor), 0);
	}
      else
	check_transFeature(
	  dynamic_cast<transFeature *>(a_transMinor), log);
      return;
    }
  if (isA(a_transMinor, transDatum))
    {
      adjustLevels(&transMinorSubs_transDatum, "transDatum");
      if (log && !findString("transDatum", transMinorSubs))
	{
	  warnSub("transDatum", "transMinor", a_transMinor);
	  check_transDatum(dynamic_cast<transDatum *>(a_transMinor), 0);
	}
      else
	check_transDatum(dynamic_cast<transDatum *>(a_transMinor), log);
      return;
    }
  if (isA(a_transMinor, transProbe))
    {
      adjustLevels(&transMinorSubs_transProbe, "transProbe");
      if (log && !findString("transProbe", transMinorSubs))
	{
	  warnSub("transProbe", "transMinor", a_transMinor);
	  check_transProbe(dynamic_cast<transProbe *>(a_transMinor), 0);
	}
      else
	check_transProbe(dynamic_cast<transProbe *>(a_transMinor), log);
      return;
    }
}

/********************************************************************/

void check_transProbe(
 transProbe * a_transProbe,
 int log)
{
  if (isA(a_transProbe, transProbe_MINUSPRBRAD))
    {
      adjustLevels(&transProbeSubs_transProbe_MINUSPRBRAD,
		   "transProbe_MINUSPRBRAD");
      if (log && !findString("transProbe_MINUSPRBRAD", transProbeSubs))
	{
	  warnSub("transProbe_MINUSPRBRAD", "transProbe", a_transProbe);
	  check_transProbe_MINUSPRBRAD(
	    dynamic_cast<transProbe_MINUSPRBRAD *>(a_transProbe), 0);
	}
      else
	check_transProbe_MINUSPRBRAD(
	  dynamic_cast<transProbe_MINUSPRBRAD *>(a_transProbe), log);
      return;
    }
  if (isA(a_transProbe, transProbe_PRBRAD))
    {
      adjustLevels(&transProbeSubs_transProbe_PRBRAD, "transProbe_PRBRAD");
      if (log && !findString("transProbe_PRBRAD", transProbeSubs))
	{
	  warnSub("transProbe_PRBRAD", "transProbe", a_transProbe);
	  check_transProbe_PRBRAD(
	    dynamic_cast<transProbe_PRBRAD *>(a_transProbe), 0);
	}
      else
	check_transProbe_PRBRAD(
	  dynamic_cast<transProbe_PRBRAD *>(a_transProbe), log);
      return;
    }
}

/********************************************************************/

void check_transProbe_MINUSPRBRAD(
 transProbe_MINUSPRBRAD * a_transProbe_MINUSPRBRAD,
 int log)
{
  if (a_transProbe_MINUSPRBRAD->get_orig())
    {
      adjustLevels(&transProbe_MINUSPRBRADAtts_a_orig,
		   "transProbe_MINUSPRBRAD a_orig");
      if (log && !findString("a_orig", transProbe_MINUSPRBRADAtts))
	{
	  warnAtt("a_orig", "transProbe_MINUSPRBRAD",
		  a_transProbe_MINUSPRBRAD);
	  check_orig(a_transProbe_MINUSPRBRAD->get_orig(), 0);
	}
      else
	check_orig(a_transProbe_MINUSPRBRAD->get_orig(), log);
    }
}

/********************************************************************/

void check_transProbe_PRBRAD(
 transProbe_PRBRAD * a_transProbe_PRBRAD,
 int log)
{
  if (a_transProbe_PRBRAD->get_orig())
    {
      adjustLevels(&transProbe_PRBRADAtts_a_orig, "transProbe_PRBRAD a_orig");
      if (log && !findString("a_orig", transProbe_PRBRADAtts))
	{
	  warnAtt("a_orig", "transProbe_PRBRAD", a_transProbe_PRBRAD);
	  check_orig(a_transProbe_PRBRAD->get_orig(), 0);
	}
      else
	check_orig(a_transProbe_PRBRAD->get_orig(), log);
    }
}

/********************************************************************/

void check_transStm(
 transStm * a_transStm,
 int log)
{
  if (a_transStm->get_dLabel())
    {
      adjustLevels(&transStmAtts_a_dLabel, "transStm a_dLabel");
      if (log && !findString("a_dLabel", transStmAtts))
	{
	  warnAtt("a_dLabel", "transStm", a_transStm);
	  check_dLabel(a_transStm->get_dLabel(), 0);
	}
      else
	check_dLabel(a_transStm->get_dLabel(), log);
    }
  if (a_transStm->get_tMinor1())
    {
      adjustLevels(&transStmAtts_tMinor1, "transStm tMinor1");
      if (log && !findString("tMinor1", transStmAtts))
	{
	  warnAtt("tMinor1", "transStm", a_transStm);
	  check_transMinor(a_transStm->get_tMinor1(), 0);
	}
      else
	check_transMinor(a_transStm->get_tMinor1(), log);
    }
  if (a_transStm->get_tMinor2())
    {
      adjustLevels(&transStmAtts_tMinor2, "transStm tMinor2");
      if (log && !findString("tMinor2", transStmAtts))
	{
	  warnAtt("tMinor2", "transStm", a_transStm);
	  check_transMinor(a_transStm->get_tMinor2(), 0);
	}
      else
	check_transMinor(a_transStm->get_tMinor2(), log);
    }
  if (a_transStm->get_tMinor3())
    {
      adjustLevels(&transStmAtts_tMinor3, "transStm tMinor3");
      if (log && !findString("tMinor3", transStmAtts))
	{
	  warnAtt("tMinor3", "transStm", a_transStm);
	  check_transMinor(a_transStm->get_tMinor3(), 0);
	}
      else
	check_transMinor(a_transStm->get_tMinor3(), log);
    }
}

/********************************************************************/

void check_transValue(
 transValue * a_transValue,
 int log)
{
  if (a_transValue->get_orig())
    {
      adjustLevels(&transValueAtts_a_orig, "transValue a_orig");
      if (log && !findString("a_orig", transValueAtts))
	{
	  warnAtt("a_orig", "transValue", a_transValue);
	  check_orig(a_transValue->get_orig(), 0);
	}
      else
	check_orig(a_transValue->get_orig(), log);
    }
  if (a_transValue->get_value())
    {
      adjustLevels(&transValueAtts_value, "transValue value");
      if (log && !findString("value", transValueAtts))
	{
	  warnAtt("value", "transValue", a_transValue);
	  check_rentVal(a_transValue->get_value(), 0);
	}
      else
	check_rentVal(a_transValue->get_value(), log);
    }
}

/********************************************************************/

void check_typePoint(
 typePoint * a_typePoint,
 int log)
{
  if (isA(a_typePoint, cartPoint))
    {
      adjustLevels(&typePointSubs_cartPoint, "cartPoint");
      if (log && !findString("cartPoint", typePointSubs))
	{
	  warnSub("cartPoint", "typePoint", a_typePoint);
	  check_cartPoint(dynamic_cast<cartPoint *>(a_typePoint), 0);
	}
      else
	check_cartPoint(dynamic_cast<cartPoint *>(a_typePoint), log);
      return;
    }
  if (isA(a_typePoint, polPoint))
    {
      adjustLevels(&typePointSubs_polPoint, "polPoint");
      if (log && !findString("polPoint", typePointSubs))
	{
	  warnSub("polPoint", "typePoint", a_typePoint);
	  check_polPoint(dynamic_cast<polPoint *>(a_typePoint), 0);
	}
      else
	check_polPoint(dynamic_cast<polPoint *>(a_typePoint), log);
      return;
    }
}

/********************************************************************/

void check_uLabel(
 uLabel * a_uLabel,
 int log)
{
  if (a_uLabel->get_labelName())
    {
      adjustLevels(&uLabelAtts_a_labelName, "uLabel a_labelName");
      if (log && !findString("a_labelName", uLabelAtts))
	{
	  warnAtt("a_labelName", "uLabel", a_uLabel);
	  check_labelName(a_uLabel->get_labelName(), 0);
	}
      else
	check_labelName(a_uLabel->get_labelName(), log);
    }
}

/********************************************************************/

void check_uncertMinor(
 uncertMinor * a_uncertMinor,
 int log)
{
  if (isA(a_uncertMinor, uncertMinor_ALGOR))
    {
      adjustLevels(&uncertMinorSubs_uncertMinor_ALGOR, "uncertMinor_ALGOR");
      if (log && !findString("uncertMinor_ALGOR", uncertMinorSubs))
	{
	  warnSub("uncertMinor_ALGOR", "uncertMinor", a_uncertMinor);
	  check_uncertMinor_ALGOR(
	    dynamic_cast<uncertMinor_ALGOR *>(a_uncertMinor), 0);
	}
      else
	check_uncertMinor_ALGOR(
	  dynamic_cast<uncertMinor_ALGOR *>(a_uncertMinor), log);
      return;
    }
  if (isA(a_uncertMinor, uncertMinor_stringVal))
    {
      adjustLevels(&uncertMinorSubs_uncertMinor_stringVal,
		   "uncertMinor_stringVal");
      if (log && !findString("uncertMinor_stringVal", uncertMinorSubs))
	{
	  warnSub("uncertMinor_stringVal", "uncertMinor", a_uncertMinor);
	  check_uncertMinor_stringVal(
	    dynamic_cast<uncertMinor_stringVal *>(a_uncertMinor), 0);
	}
      else
	check_uncertMinor_stringVal(
	  dynamic_cast<uncertMinor_stringVal *>(a_uncertMinor), log);
      return;
    }
}

/********************************************************************/

void check_uncertMinor_ALGOR(
 uncertMinor_ALGOR * a_uncertMinor_ALGOR,
 int log)
{
  if (a_uncertMinor_ALGOR->get_code())
    {
      adjustLevels(&uncertMinor_ALGORAtts_code, "uncertMinor_ALGOR code");
      if (log && !findString("code", uncertMinor_ALGORAtts))
	{
	  warnAtt("code", "uncertMinor_ALGOR", a_uncertMinor_ALGOR);
	  check_intVal(a_uncertMinor_ALGOR->get_code(), 0);
	}
      else
	check_intVal(a_uncertMinor_ALGOR->get_code(), log);
    }
}

/********************************************************************/

void check_uncertMinor_stringVal(
 uncertMinor_stringVal * a_uncertMinor_stringVal,
 int log)
{
  if (a_uncertMinor_stringVal->get_name())
    {
      adjustLevels(&uncertMinor_stringValAtts_name,
		   "uncertMinor_stringVal name");
      if (log && !findString("name", uncertMinor_stringValAtts))
	{
	  warnAtt("name", "uncertMinor_stringVal", a_uncertMinor_stringVal);
	  check_stringVal(a_uncertMinor_stringVal->get_name(), 0);
	}
      else
	check_stringVal(a_uncertMinor_stringVal->get_name(), log);
    }
  if (a_uncertMinor_stringVal->get_uncertVar3())
    {
      adjustLevels(&uncertMinor_stringValAtts_a_uncertVar3,
		   "uncertMinor_stringVal a_uncertVar3");
      if (log && !findString("a_uncertVar3", uncertMinor_stringValAtts))
	{
	  warnAtt("a_uncertVar3", "uncertMinor_stringVal",
		  a_uncertMinor_stringVal);
	  check_uncertVar3(a_uncertMinor_stringVal->get_uncertVar3(), 0);
	}
      else
	check_uncertVar3(a_uncertMinor_stringVal->get_uncertVar3(), log);
    }
}

/********************************************************************/

void check_uncertVar3(
 uncertVar3 * a_uncertVar3,
 int log)
{
  if (isA(a_uncertVar3, uncertVar3_DME))
    {
      adjustLevels(&uncertVar3Subs_uncertVar3_DME, "uncertVar3_DME");
      if (log && !findString("uncertVar3_DME", uncertVar3Subs))
	{
	  warnSub("uncertVar3_DME", "uncertVar3", a_uncertVar3);
	  check_uncertVar3_DME(
	    dynamic_cast<uncertVar3_DME *>(a_uncertVar3), 0);
	}
      else
	check_uncertVar3_DME(
	  dynamic_cast<uncertVar3_DME *>(a_uncertVar3), log);
      return;
    }
  if (isA(a_uncertVar3, uncertVar3_SENS))
    {
      adjustLevels(&uncertVar3Subs_uncertVar3_SENS, "uncertVar3_SENS");
      if (log && !findString("uncertVar3_SENS", uncertVar3Subs))
	{
	  warnSub("uncertVar3_SENS", "uncertVar3", a_uncertVar3);
	  check_uncertVar3_SENS(
	    dynamic_cast<uncertVar3_SENS *>(a_uncertVar3), 0);
	}
      else
	check_uncertVar3_SENS(
	  dynamic_cast<uncertVar3_SENS *>(a_uncertVar3), log);
      return;
    }
  if (isA(a_uncertVar3, uncertVar3_paramList))
    {
      adjustLevels(&uncertVar3Subs_uncertVar3_paramList,
		   "uncertVar3_paramList");
      if (log && !findString("uncertVar3_paramList", uncertVar3Subs))
	{
	  warnSub("uncertVar3_paramList", "uncertVar3", a_uncertVar3);
	  check_uncertVar3_paramList(
	    dynamic_cast<uncertVar3_paramList *>(a_uncertVar3), 0);
	}
      else
	check_uncertVar3_paramList(
	  dynamic_cast<uncertVar3_paramList *>(a_uncertVar3), log);
      return;
    }
}

/********************************************************************/

void check_uncertVar3_DME(
 uncertVar3_DME * a_uncertVar3_DME,
 int log)
{
  if (a_uncertVar3_DME->get_paramList())
    {
      std::list<param *> * theList;
      std::list<param *>::iterator iter;
      theList = a_uncertVar3_DME->get_paramList();
      adjustLevels(&uncertVar3_DMEAtts_a_paramList,
		   "uncertVar3_DME a_paramList");
      if (log && !findString("a_paramList", uncertVar3_DMEAtts))
	{
	  warnAtt("a_paramList", "uncertVar3_DME", a_uncertVar3_DME);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_param(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_param(*iter, log);
	}
    }
}

/********************************************************************/

void check_uncertVar3_SENS(
 uncertVar3_SENS * a_uncertVar3_SENS,
 int log)
{
  if (a_uncertVar3_SENS->get_paramList())
    {
      std::list<param *> * theList;
      std::list<param *>::iterator iter;
      theList = a_uncertVar3_SENS->get_paramList();
      adjustLevels(&uncertVar3_SENSAtts_a_paramList,
		   "uncertVar3_SENS a_paramList");
      if (log && !findString("a_paramList", uncertVar3_SENSAtts))
	{
	  warnAtt("a_paramList", "uncertVar3_SENS", a_uncertVar3_SENS);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_param(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_param(*iter, log);
	}
    }
}

/********************************************************************/

void check_uncertVar3_paramList(
 uncertVar3_paramList * a_uncertVar3_paramList,
 int log)
{
  if (a_uncertVar3_paramList->get_paramList())
    {
      std::list<param *> * theList;
      std::list<param *>::iterator iter;
      theList = a_uncertVar3_paramList->get_paramList();
      adjustLevels(&uncertVar3_paramListAtts_a_paramList,
		   "uncertVar3_paramList a_paramList");
      if (log && !findString("a_paramList", uncertVar3_paramListAtts))
	{
	  warnAtt("a_paramList", "uncertVar3_paramList",
		  a_uncertVar3_paramList);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_param(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_param(*iter, log);
	}
    }
}

/********************************************************************/

void check_uncertalgStm(
 uncertalgStm * a_uncertalgStm,
 int log)
{
  if (a_uncertalgStm->get_uLabel())
    {
      adjustLevels(&uncertalgStmAtts_a_uLabel, "uncertalgStm a_uLabel");
      if (log && !findString("a_uLabel", uncertalgStmAtts))
	{
	  warnAtt("a_uLabel", "uncertalgStm", a_uncertalgStm);
	  check_uLabel(a_uncertalgStm->get_uLabel(), 0);
	}
      else
	check_uLabel(a_uncertalgStm->get_uLabel(), log);
    }
  if (a_uncertalgStm->get_uncertMinor())
    {
      adjustLevels(&uncertalgStmAtts_a_uncertMinor,
		   "uncertalgStm a_uncertMinor");
      if (log && !findString("a_uncertMinor", uncertalgStmAtts))
	{
	  warnAtt("a_uncertMinor", "uncertalgStm", a_uncertalgStm);
	  check_uncertMinor(a_uncertalgStm->get_uncertMinor(), 0);
	}
      else
	check_uncertMinor(a_uncertalgStm->get_uncertMinor(), log);
    }
}

/********************************************************************/

void check_uncertsetMinor(
 uncertsetMinor * a_uncertsetMinor,
 int log)
{
  if (isA(a_uncertsetMinor, uncertsetMinor_ON))
    {
      adjustLevels(&uncertsetMinorSubs_uncertsetMinor_ON, "uncertsetMinor_ON");
      if (log && !findString("uncertsetMinor_ON", uncertsetMinorSubs))
	{
	  warnSub("uncertsetMinor_ON", "uncertsetMinor", a_uncertsetMinor);
	  check_uncertsetMinor_ON(
	    dynamic_cast<uncertsetMinor_ON *>(a_uncertsetMinor), 0);
	}
      else
	check_uncertsetMinor_ON(
	  dynamic_cast<uncertsetMinor_ON *>(a_uncertsetMinor), log);
      return;
    }
  if (isA(a_uncertsetMinor, uncertsetMinor_OFF))
    {
      adjustLevels(&uncertsetMinorSubs_uncertsetMinor_OFF,
		   "uncertsetMinor_OFF");
      if (log && !findString("uncertsetMinor_OFF", uncertsetMinorSubs))
	{
	  warnSub("uncertsetMinor_OFF", "uncertsetMinor", a_uncertsetMinor);
	}
      return;
    }
}

/********************************************************************/

void check_uncertsetMinor_ON(
 uncertsetMinor_ON * a_uncertsetMinor_ON,
 int log)
{
  if (a_uncertsetMinor_ON->get_uLabel())
    {
      adjustLevels(&uncertsetMinor_ONAtts_a_uLabel,
		   "uncertsetMinor_ON a_uLabel");
      if (log && !findString("a_uLabel", uncertsetMinor_ONAtts))
	{
	  warnAtt("a_uLabel", "uncertsetMinor_ON", a_uncertsetMinor_ON);
	  check_uLabel(a_uncertsetMinor_ON->get_uLabel(), 0);
	}
      else
	check_uLabel(a_uncertsetMinor_ON->get_uLabel(), log);
    }
  if (a_uncertsetMinor_ON->get_uncertsetVar2())
    {
      adjustLevels(&uncertsetMinor_ONAtts_a_uncertsetVar2,
		   "uncertsetMinor_ON a_uncertsetVar2");
      if (log && !findString("a_uncertsetVar2", uncertsetMinor_ONAtts))
	{
	  warnAtt("a_uncertsetVar2", "uncertsetMinor_ON",
		  a_uncertsetMinor_ON);
	  check_uncertsetVar2(a_uncertsetMinor_ON->get_uncertsetVar2(), 0);
	}
      else
	check_uncertsetVar2(a_uncertsetMinor_ON->get_uncertsetVar2(), log);
    }
}

/********************************************************************/

void check_uncertsetStm(
 uncertsetStm * a_uncertsetStm,
 int log)
{
  if (a_uncertsetStm->get_uncertsetMinor())
    {
      adjustLevels(&uncertsetStmAtts_a_uncertsetMinor,
		   "uncertsetStm a_uncertsetMinor");
      if (log && !findString("a_uncertsetMinor", uncertsetStmAtts))
	{
	  warnAtt("a_uncertsetMinor", "uncertsetStm", a_uncertsetStm);
	  check_uncertsetMinor(a_uncertsetStm->get_uncertsetMinor(), 0);
	}
      else
	check_uncertsetMinor(a_uncertsetStm->get_uncertsetMinor(), log);
    }
}

/********************************************************************/

void check_uncertsetVar2(
 uncertsetVar2 * a_uncertsetVar2,
 int log)
{
  if (isA(a_uncertsetVar2, uncertsetVar2_drLabel))
    {
      adjustLevels(&uncertsetVar2Subs_uncertsetVar2_drLabel,
		   "uncertsetVar2_drLabel");
      if (log && !findString("uncertsetVar2_drLabel", uncertsetVar2Subs))
	{
	  warnSub("uncertsetVar2_drLabel", "uncertsetVar2", a_uncertsetVar2);
	  check_uncertsetVar2_drLabel(
	    dynamic_cast<uncertsetVar2_drLabel *>(a_uncertsetVar2), 0);
	}
      else
	check_uncertsetVar2_drLabel(
	  dynamic_cast<uncertsetVar2_drLabel *>(a_uncertsetVar2), log);
      return;
    }
  if (isA(a_uncertsetVar2, uncertsetVar2_NONE))
    {
      adjustLevels(&uncertsetVar2Subs_uncertsetVar2_NONE,
		   "uncertsetVar2_NONE");
      if (log && !findString("uncertsetVar2_NONE", uncertsetVar2Subs))
	{
	  warnSub("uncertsetVar2_NONE", "uncertsetVar2", a_uncertsetVar2);
	}
      return;
    }
}

/********************************************************************/

void check_uncertsetVar2_drLabel(
 uncertsetVar2_drLabel * a_uncertsetVar2_drLabel,
 int log)
{
  if (a_uncertsetVar2_drLabel->get_drLabel())
    {
      adjustLevels(&uncertsetVar2_drLabelAtts_a_drLabel,
		   "uncertsetVar2_drLabel a_drLabel");
      if (log && !findString("a_drLabel", uncertsetVar2_drLabelAtts))
	{
	  warnAtt("a_drLabel", "uncertsetVar2_drLabel",
		  a_uncertsetVar2_drLabel);
	  check_drLabel(a_uncertsetVar2_drLabel->get_drLabel(), 0);
	}
      else
	check_drLabel(a_uncertsetVar2_drLabel->get_drLabel(), log);
    }
}

/********************************************************************/

void check_unitsStm(
 unitsStm * a_unitsStm,
 int log)
{
  if (a_unitsStm->get_lengthUnit())
    {
      adjustLevels(&unitsStmAtts_a_lengthUnit, "unitsStm a_lengthUnit");
      if (log && !findString("a_lengthUnit", unitsStmAtts))
	{
	  warnAtt("a_lengthUnit", "unitsStm", a_unitsStm);
	  check_lengthUnit(a_unitsStm->get_lengthUnit(), 0);
	}
      else
	check_lengthUnit(a_unitsStm->get_lengthUnit(), log);
    }
  if (a_unitsStm->get_angleUnit())
    {
      adjustLevels(&unitsStmAtts_a_angleUnit, "unitsStm a_angleUnit");
      if (log && !findString("a_angleUnit", unitsStmAtts))
	{
	  warnAtt("a_angleUnit", "unitsStm", a_unitsStm);
	  check_angleUnit(a_unitsStm->get_angleUnit(), 0);
	}
      else
	check_angleUnit(a_unitsStm->get_angleUnit(), log);
    }
  if (a_unitsStm->get_tempUnit())
    {
      adjustLevels(&unitsStmAtts_a_tempUnit, "unitsStm a_tempUnit");
      if (log && !findString("a_tempUnit", unitsStmAtts))
	{
	  warnAtt("a_tempUnit", "unitsStm", a_unitsStm);
	  check_tempUnit(a_unitsStm->get_tempUnit(), 0);
	}
      else
	check_tempUnit(a_unitsStm->get_tempUnit(), log);
    }
}

/********************************************************************/

void check_vLabel(
 vLabel * a_vLabel,
 int log)
{
  if (a_vLabel->get_labelName())
    {
      adjustLevels(&vLabelAtts_a_labelName, "vLabel a_labelName");
      if (log && !findString("a_labelName", vLabelAtts))
	{
	  warnAtt("a_labelName", "vLabel", a_vLabel);
	  check_labelName(a_vLabel->get_labelName(), 0);
	}
      else
	check_labelName(a_vLabel->get_labelName(), log);
    }
}

/********************************************************************/

void check_vaLabel(
 vaLabel * a_vaLabel,
 int log)
{
  if (a_vaLabel->get_labelName())
    {
      adjustLevels(&vaLabelAtts_a_labelName, "vaLabel a_labelName");
      if (log && !findString("a_labelName", vaLabelAtts))
	{
	  warnAtt("a_labelName", "vaLabel", a_vaLabel);
	  check_labelName(a_vaLabel->get_labelName(), 0);
	}
      else
	check_labelName(a_vaLabel->get_labelName(), log);
    }
}

/********************************************************************/

void check_valueAclratReal(
 valueAclratReal * a_valueAclratReal,
 int log)
{
  if (isA(a_valueAclratReal, valueAclratReal_MESACL))
    {
      adjustLevels(&valueAclratRealSubs_valueAclratReal_MESACL,
		   "valueAclratReal_MESACL");
      if (log && !findString("valueAclratReal_MESACL", valueAclratRealSubs))
	{
	  warnSub("valueAclratReal_MESACL", "valueAclratReal",
		  a_valueAclratReal);
	}
      return;
    }
  if (isA(a_valueAclratReal, valueAclratReal_POSACL))
    {
      adjustLevels(&valueAclratRealSubs_valueAclratReal_POSACL,
		   "valueAclratReal_POSACL");
      if (log && !findString("valueAclratReal_POSACL", valueAclratRealSubs))
	{
	  warnSub("valueAclratReal_POSACL", "valueAclratReal",
		  a_valueAclratReal);
	}
      return;
    }
  if (isA(a_valueAclratReal, valueAclratReal_ROTACL))
    {
      adjustLevels(&valueAclratRealSubs_valueAclratReal_ROTACL,
		   "valueAclratReal_ROTACL");
      if (log && !findString("valueAclratReal_ROTACL", valueAclratRealSubs))
	{
	  warnSub("valueAclratReal_ROTACL", "valueAclratReal",
		  a_valueAclratReal);
	}
      return;
    }
}

/********************************************************************/

void check_valueAclratString(
 valueAclratString * a_valueAclratString,
 int log)
{
  if (a_valueAclratString->get_valueAclratReal())
    {
      adjustLevels(&valueAclratStringAtts_a_valueAclratReal,
		   "valueAclratString a_valueAclratReal");
      if (log && !findString("a_valueAclratReal", valueAclratStringAtts))
	{
	  warnAtt("a_valueAclratReal", "valueAclratString",
		  a_valueAclratString);
	  check_valueAclratReal(a_valueAclratString->get_valueAclratReal(), 0);
	}
      else
	check_valueAclratReal(a_valueAclratString->get_valueAclratReal(), log);
    }
}

/********************************************************************/

void check_valueBoundInt(
 valueBoundInt * a_valueBoundInt,
 int log)
{
  if (isA(a_valueBoundInt, valueBoundInt_featureLabel))
    {
      adjustLevels(&valueBoundIntSubs_valueBoundInt_featureLabel,
		   "valueBoundInt_featureLabel");
      if (log && !findString("valueBoundInt_featureLabel", valueBoundIntSubs))
	{
	  warnSub("valueBoundInt_featureLabel", "valueBoundInt",
		  a_valueBoundInt);
	  check_valueBoundInt_featureLabel(
	    dynamic_cast<valueBoundInt_featureLabel *>(a_valueBoundInt), 0);
	}
      else
	check_valueBoundInt_featureLabel(
	  dynamic_cast<valueBoundInt_featureLabel *>(a_valueBoundInt), log);
      return;
    }
  if (isA(a_valueBoundInt, valueBoundInt_toleranceLabel))
    {
      adjustLevels(&valueBoundIntSubs_valueBoundInt_toleranceLabel,
		   "valueBoundInt_toleranceLabel");
      if (log && !findString("valueBoundInt_toleranceLabel",
			     valueBoundIntSubs))
	{
	  warnSub("valueBoundInt_toleranceLabel", "valueBoundInt",
		  a_valueBoundInt);
	  check_valueBoundInt_toleranceLabel(
	    dynamic_cast<valueBoundInt_toleranceLabel *>(a_valueBoundInt), 0);
	}
      else
	check_valueBoundInt_toleranceLabel(
	  dynamic_cast<valueBoundInt_toleranceLabel *>(a_valueBoundInt), log);
      return;
    }
}

/********************************************************************/

void check_valueBoundInt_featureLabel(
 valueBoundInt_featureLabel * a_valueBoundInt_featureLabel,
 int log)
{
  if (a_valueBoundInt_featureLabel->get_featureLabel())
    {
      adjustLevels(&valueBoundInt_featureLabelAtts_a_featureLabel,
		   "valueBoundInt_featureLabel a_featureLabel");
      if (log && !findString("a_featureLabel", valueBoundInt_featureLabelAtts))
	{
	  warnAtt("a_featureLabel", "valueBoundInt_featureLabel",
		  a_valueBoundInt_featureLabel);
	  check_featureLabel(
	    a_valueBoundInt_featureLabel->get_featureLabel(), 0);
	}
      else
	check_featureLabel(
	  a_valueBoundInt_featureLabel->get_featureLabel(), log);
    }
}

/********************************************************************/

void check_valueBoundInt_toleranceLabel(
 valueBoundInt_toleranceLabel * a_valueBoundInt_toleranceLabel,
 int log)
{
  if (a_valueBoundInt_toleranceLabel->get_toleranceLabel())
    {
      adjustLevels(&valueBoundInt_toleranceLabelAtts_a_toleranceLabel,
		   "valueBoundInt_toleranceLabel a_toleranceLabel");
      if (log && !findString("a_toleranceLabel",
			     valueBoundInt_toleranceLabelAtts))
	{
	  warnAtt("a_toleranceLabel", "valueBoundInt_toleranceLabel",
		  a_valueBoundInt_toleranceLabel);
	  check_toleranceLabel(
	    a_valueBoundInt_toleranceLabel->get_toleranceLabel(), 0);
	}
      else
	check_toleranceLabel(
	  a_valueBoundInt_toleranceLabel->get_toleranceLabel(), log);
    }
}

/********************************************************************/

void check_valueBoundString(
 valueBoundString * a_valueBoundString,
 int log)
{
  if (isA(a_valueBoundString, valueBoundString_featureLabel))
    {
      adjustLevels(&valueBoundStringSubs_valueBoundString_featureLabel,
		   "valueBoundString_featureLabel");
      if (log && !findString("valueBoundString_featureLabel",
			     valueBoundStringSubs))
	{
	  warnSub("valueBoundString_featureLabel", "valueBoundString",
		  a_valueBoundString);
	  check_valueBoundString_featureLabel(
	    dynamic_cast<valueBoundString_featureLabel *>(a_valueBoundString), 0);
	}
      else
	check_valueBoundString_featureLabel(
	  dynamic_cast<valueBoundString_featureLabel *>(a_valueBoundString), log);
      return;
    }
  if (isA(a_valueBoundString, valueBoundString_toleranceLabel))
    {
      adjustLevels(&valueBoundStringSubs_valueBoundString_toleranceLabel,
		   "valueBoundString_toleranceLabel");
      if (log && !findString("valueBoundString_toleranceLabel",
			     valueBoundStringSubs))
	{
	  warnSub("valueBoundString_toleranceLabel", "valueBoundString",
		  a_valueBoundString);
	  check_valueBoundString_toleranceLabel(
	    dynamic_cast<valueBoundString_toleranceLabel *>(a_valueBoundString), 0);
	}
      else
	check_valueBoundString_toleranceLabel(
	  dynamic_cast<valueBoundString_toleranceLabel *>(a_valueBoundString), log);
      return;
    }
}

/********************************************************************/

void check_valueBoundString_featureLabel(
 valueBoundString_featureLabel * a_valueBoundString_featureLabel,
 int log)
{
  if (a_valueBoundString_featureLabel->get_featureLabel())
    {
      adjustLevels(&valueBoundString_featureLabelAtts_a_featureLabel,
		   "valueBoundString_featureLabel a_featureLabel");
      if (log && !findString("a_featureLabel",
			     valueBoundString_featureLabelAtts))
	{
	  warnAtt("a_featureLabel", "valueBoundString_featureLabel",
		  a_valueBoundString_featureLabel);
	  check_featureLabel(
	    a_valueBoundString_featureLabel->get_featureLabel(), 0);
	}
      else
	check_featureLabel(
	  a_valueBoundString_featureLabel->get_featureLabel(), log);
    }
  if (a_valueBoundString_featureLabel->get_bndnum())
    {
      adjustLevels(&valueBoundString_featureLabelAtts_bndnum,
		   "valueBoundString_featureLabel bndnum");
      if (log && !findString("bndnum", valueBoundString_featureLabelAtts))
	{
	  warnAtt("bndnum", "valueBoundString_featureLabel",
		  a_valueBoundString_featureLabel);
	  check_intVal(a_valueBoundString_featureLabel->get_bndnum(), 0);
	}
      else
	check_intVal(a_valueBoundString_featureLabel->get_bndnum(), log);
    }
}

/********************************************************************/

void check_valueBoundString_toleranceLabel(
 valueBoundString_toleranceLabel * a_valueBoundString_toleranceLabel,
 int log)
{
  if (a_valueBoundString_toleranceLabel->get_toleranceLabel())
    {
      adjustLevels(&valueBoundString_toleranceLabelAtts_a_toleranceLabel,
		   "valueBoundString_toleranceLabel a_toleranceLabel");
      if (log && !findString("a_toleranceLabel",
			     valueBoundString_toleranceLabelAtts))
	{
	  warnAtt("a_toleranceLabel", "valueBoundString_toleranceLabel",
		  a_valueBoundString_toleranceLabel);
	  check_toleranceLabel(
	    a_valueBoundString_toleranceLabel->get_toleranceLabel(), 0);
	}
      else
	check_toleranceLabel(
	  a_valueBoundString_toleranceLabel->get_toleranceLabel(), log);
    }
  if (a_valueBoundString_toleranceLabel->get_bndnum())
    {
      adjustLevels(&valueBoundString_toleranceLabelAtts_bndnum,
		   "valueBoundString_toleranceLabel bndnum");
      if (log && !findString("bndnum", valueBoundString_toleranceLabelAtts))
	{
	  warnAtt("bndnum", "valueBoundString_toleranceLabel",
		  a_valueBoundString_toleranceLabel);
	  check_intVal(a_valueBoundString_toleranceLabel->get_bndnum(), 0);
	}
      else
	check_intVal(a_valueBoundString_toleranceLabel->get_bndnum(), log);
    }
}

/********************************************************************/

void check_valueCzslct(
 valueCzslct * a_valueCzslct,
 int log)
{
  if (a_valueCzslct->get_czLabel())
    {
      adjustLevels(&valueCzslctAtts_a_czLabel, "valueCzslct a_czLabel");
      if (log && !findString("a_czLabel", valueCzslctAtts))
	{
	  warnAtt("a_czLabel", "valueCzslct", a_valueCzslct);
	  check_czLabel(a_valueCzslct->get_czLabel(), 0);
	}
      else
	check_czLabel(a_valueCzslct->get_czLabel(), log);
    }
}

/********************************************************************/

void check_valueDmismd(
 valueDmismd * a_valueDmismd,
 int log)
{
  if (isA(a_valueDmismd, valueDmismd_NAME))
    {
      adjustLevels(&valueDmismdSubs_valueDmismd_NAME, "valueDmismd_NAME");
      if (log && !findString("valueDmismd_NAME", valueDmismdSubs))
	{
	  warnSub("valueDmismd_NAME", "valueDmismd", a_valueDmismd);
	}
      return;
    }
  if (isA(a_valueDmismd, valueDmismd_VERSION))
    {
      adjustLevels(&valueDmismdSubs_valueDmismd_VERSION,
		   "valueDmismd_VERSION");
      if (log && !findString("valueDmismd_VERSION", valueDmismdSubs))
	{
	  warnSub("valueDmismd_VERSION", "valueDmismd", a_valueDmismd);
	}
      return;
    }
}

/********************************************************************/

void check_valueDmismn(
 valueDmismn * a_valueDmismn,
 int log)
{
  if (isA(a_valueDmismn, valueDmismn_NAME))
    {
      adjustLevels(&valueDmismnSubs_valueDmismn_NAME, "valueDmismn_NAME");
      if (log && !findString("valueDmismn_NAME", valueDmismnSubs))
	{
	  warnSub("valueDmismn_NAME", "valueDmismn", a_valueDmismn);
	}
      return;
    }
  if (isA(a_valueDmismn, valueDmismn_VERSION))
    {
      adjustLevels(&valueDmismnSubs_valueDmismn_VERSION,
		   "valueDmismn_VERSION");
      if (log && !findString("valueDmismn_VERSION", valueDmismnSubs))
	{
	  warnSub("valueDmismn_VERSION", "valueDmismn", a_valueDmismn);
	}
      return;
    }
}

/********************************************************************/

void check_valueError(
 valueError * a_valueError,
 int log)
{
  if (isA(a_valueError, valueError_ERR))
    {
      adjustLevels(&valueErrorSubs_valueError_ERR, "valueError_ERR");
      if (log && !findString("valueError_ERR", valueErrorSubs))
	{
	  warnSub("valueError_ERR", "valueError", a_valueError);
	}
      return;
    }
  if (isA(a_valueError, valueError_ERRMODE))
    {
      adjustLevels(&valueErrorSubs_valueError_ERRMODE, "valueError_ERRMODE");
      if (log && !findString("valueError_ERRMODE", valueErrorSubs))
	{
	  warnSub("valueError_ERRMODE", "valueError", a_valueError);
	}
      return;
    }
}

/********************************************************************/

void check_valueFaInt(
 valueFaInt * a_valueFaInt,
 int log)
{
  if (a_valueFaInt->get_faLabel())
    {
      adjustLevels(&valueFaIntAtts_a_faLabel, "valueFaInt a_faLabel");
      if (log && !findString("a_faLabel", valueFaIntAtts))
	{
	  warnAtt("a_faLabel", "valueFaInt", a_valueFaInt);
	  check_faLabel(a_valueFaInt->get_faLabel(), 0);
	}
      else
	check_faLabel(a_valueFaInt->get_faLabel(), log);
    }
}

/********************************************************************/

void check_valueFaReal(
 valueFaReal * a_valueFaReal,
 int log)
{
  if (a_valueFaReal->get_faLabel())
    {
      adjustLevels(&valueFaRealAtts_a_faLabel, "valueFaReal a_faLabel");
      if (log && !findString("a_faLabel", valueFaRealAtts))
	{
	  warnAtt("a_faLabel", "valueFaReal", a_valueFaReal);
	  check_faLabel(a_valueFaReal->get_faLabel(), 0);
	}
      else
	check_faLabel(a_valueFaReal->get_faLabel(), log);
    }
  if (a_valueFaReal->get_sizenum())
    {
      adjustLevels(&valueFaRealAtts_sizenum, "valueFaReal sizenum");
      if (log && !findString("sizenum", valueFaRealAtts))
	{
	  warnAtt("sizenum", "valueFaReal", a_valueFaReal);
	  check_intVal(a_valueFaReal->get_sizenum(), 0);
	}
      else
	check_intVal(a_valueFaReal->get_sizenum(), log);
    }
}

/********************************************************************/

void check_valueFedratReal(
 valueFedratReal * a_valueFedratReal,
 int log)
{
  if (isA(a_valueFedratReal, valueFedratReal_MESVEL))
    {
      adjustLevels(&valueFedratRealSubs_valueFedratReal_MESVEL,
		   "valueFedratReal_MESVEL");
      if (log && !findString("valueFedratReal_MESVEL", valueFedratRealSubs))
	{
	  warnSub("valueFedratReal_MESVEL", "valueFedratReal",
		  a_valueFedratReal);
	}
      return;
    }
  if (isA(a_valueFedratReal, valueFedratReal_POSVEL))
    {
      adjustLevels(&valueFedratRealSubs_valueFedratReal_POSVEL,
		   "valueFedratReal_POSVEL");
      if (log && !findString("valueFedratReal_POSVEL", valueFedratRealSubs))
	{
	  warnSub("valueFedratReal_POSVEL", "valueFedratReal",
		  a_valueFedratReal);
	}
      return;
    }
  if (isA(a_valueFedratReal, valueFedratReal_ROTVEL))
    {
      adjustLevels(&valueFedratRealSubs_valueFedratReal_ROTVEL,
		   "valueFedratReal_ROTVEL");
      if (log && !findString("valueFedratReal_ROTVEL", valueFedratRealSubs))
	{
	  warnSub("valueFedratReal_ROTVEL", "valueFedratReal",
		  a_valueFedratReal);
	}
      return;
    }
  if (isA(a_valueFedratReal, valueFedratReal_SCNVEL))
    {
      adjustLevels(&valueFedratRealSubs_valueFedratReal_SCNVEL,
		   "valueFedratReal_SCNVEL");
      if (log && !findString("valueFedratReal_SCNVEL", valueFedratRealSubs))
	{
	  warnSub("valueFedratReal_SCNVEL", "valueFedratReal",
		  a_valueFedratReal);
	}
      return;
    }
}

/********************************************************************/

void check_valueFedratString(
 valueFedratString * a_valueFedratString,
 int log)
{
  if (a_valueFedratString->get_valueFedratReal())
    {
      adjustLevels(&valueFedratStringAtts_a_valueFedratReal,
		   "valueFedratString a_valueFedratReal");
      if (log && !findString("a_valueFedratReal", valueFedratStringAtts))
	{
	  warnAtt("a_valueFedratReal", "valueFedratString",
		  a_valueFedratString);
	  check_valueFedratReal(a_valueFedratString->get_valueFedratReal(), 0);
	}
      else
	check_valueFedratReal(a_valueFedratString->get_valueFedratReal(), log);
    }
}

/********************************************************************/

void check_valueFilnam(
 valueFilnam * a_valueFilnam,
 int log)
{
  if (isA(a_valueFilnam, valueFilnam_NAME))
    {
      adjustLevels(&valueFilnamSubs_valueFilnam_NAME, "valueFilnam_NAME");
      if (log && !findString("valueFilnam_NAME", valueFilnamSubs))
	{
	  warnSub("valueFilnam_NAME", "valueFilnam", a_valueFilnam);
	}
      return;
    }
  if (isA(a_valueFilnam, valueFilnam_VERSION))
    {
      adjustLevels(&valueFilnamSubs_valueFilnam_VERSION,
		   "valueFilnam_VERSION");
      if (log && !findString("valueFilnam_VERSION", valueFilnamSubs))
	{
	  warnSub("valueFilnam_VERSION", "valueFilnam", a_valueFilnam);
	}
      return;
    }
}

/********************************************************************/

void check_valueGeoalg(
 valueGeoalg * a_valueGeoalg,
 int log)
{
  if (a_valueGeoalg->get_measGeotype())
    {
      adjustLevels(&valueGeoalgAtts_a_measGeotype,
		   "valueGeoalg a_measGeotype");
      if (log && !findString("a_measGeotype", valueGeoalgAtts))
	{
	  warnAtt("a_measGeotype", "valueGeoalg", a_valueGeoalg);
	  check_measGeotype(a_valueGeoalg->get_measGeotype(), 0);
	}
      else
	check_measGeotype(a_valueGeoalg->get_measGeotype(), log);
    }
}

/********************************************************************/

void check_valueGotoReal(
 valueGotoReal * a_valueGotoReal,
 int log)
{
  if (a_valueGotoReal->get_axis())
    {
      adjustLevels(&valueGotoRealAtts_a_axis, "valueGotoReal a_axis");
      if (log && !findString("a_axis", valueGotoRealAtts))
	{
	  warnAtt("a_axis", "valueGotoReal", a_valueGotoReal);
	  check_axis(a_valueGotoReal->get_axis(), 0);
	}
      else
	check_axis(a_valueGotoReal->get_axis(), log);
    }
}

/********************************************************************/

void check_valueKeychar(
 valueKeychar * a_valueKeychar,
 int log)
{
  if (isA(a_valueKeychar, kcLabel))
    {
      adjustLevels(&valueKeycharSubs_kcLabel, "kcLabel");
      if (log && !findString("kcLabel", valueKeycharSubs))
	{
	  warnSub("kcLabel", "valueKeychar", a_valueKeychar);
	  check_kcLabel(dynamic_cast<kcLabel *>(a_valueKeychar), 0);
	}
      else
	check_kcLabel(dynamic_cast<kcLabel *>(a_valueKeychar), log);
      return;
    }
}

/********************************************************************/

void check_valueMinorBool(
 valueMinorBool * a_valueMinorBool,
 int log)
{
  if (isA(a_valueMinorBool, valueBadtst))
    {
      adjustLevels(&valueMinorBoolSubs_valueBadtst, "valueBadtst");
      if (log && !findString("valueBadtst", valueMinorBoolSubs))
	{
	  warnSub("valueBadtst", "valueMinorBool", a_valueMinorBool);
	}
      return;
    }
  if (isA(a_valueMinorBool, valueCroscl))
    {
      adjustLevels(&valueMinorBoolSubs_valueCroscl, "valueCroscl");
      if (log && !findString("valueCroscl", valueMinorBoolSubs))
	{
	  warnSub("valueCroscl", "valueMinorBool", a_valueMinorBool);
	}
      return;
    }
  if (isA(a_valueMinorBool, valueCzslct))
    {
      adjustLevels(&valueMinorBoolSubs_valueCzslct, "valueCzslct");
      if (log && !findString("valueCzslct", valueMinorBoolSubs))
	{
	  warnSub("valueCzslct", "valueMinorBool", a_valueMinorBool);
	  check_valueCzslct(
	    dynamic_cast<valueCzslct *>(a_valueMinorBool), 0);
	}
      else
	check_valueCzslct(
	  dynamic_cast<valueCzslct *>(a_valueMinorBool), log);
      return;
    }
  if (isA(a_valueMinorBool, valueFinpos))
    {
      adjustLevels(&valueMinorBoolSubs_valueFinpos, "valueFinpos");
      if (log && !findString("valueFinpos", valueMinorBoolSubs))
	{
	  warnSub("valueFinpos", "valueMinorBool", a_valueMinorBool);
	}
      return;
    }
  if (isA(a_valueMinorBool, valuePrcomp))
    {
      adjustLevels(&valueMinorBoolSubs_valuePrcomp, "valuePrcomp");
      if (log && !findString("valuePrcomp", valueMinorBoolSubs))
	{
	  warnSub("valuePrcomp", "valueMinorBool", a_valueMinorBool);
	}
      return;
    }
  if (isA(a_valueMinorBool, valuePtbuff))
    {
      adjustLevels(&valueMinorBoolSubs_valuePtbuff, "valuePtbuff");
      if (log && !findString("valuePtbuff", valueMinorBoolSubs))
	{
	  warnSub("valuePtbuff", "valueMinorBool", a_valueMinorBool);
	}
      return;
    }
  if (isA(a_valueMinorBool, valueScnmod))
    {
      adjustLevels(&valueMinorBoolSubs_valueScnmod, "valueScnmod");
      if (log && !findString("valueScnmod", valueMinorBoolSubs))
	{
	  warnSub("valueScnmod", "valueMinorBool", a_valueMinorBool);
	}
      return;
    }
  if (isA(a_valueMinorBool, valueTaBool))
    {
      adjustLevels(&valueMinorBoolSubs_valueTaBool, "valueTaBool");
      if (log && !findString("valueTaBool", valueMinorBoolSubs))
	{
	  warnSub("valueTaBool", "valueMinorBool", a_valueMinorBool);
	  check_valueTaBool(
	    dynamic_cast<valueTaBool *>(a_valueMinorBool), 0);
	}
      else
	check_valueTaBool(
	  dynamic_cast<valueTaBool *>(a_valueMinorBool), log);
      return;
    }
  if (isA(a_valueMinorBool, valueTecomp))
    {
      adjustLevels(&valueMinorBoolSubs_valueTecomp, "valueTecomp");
      if (log && !findString("valueTecomp", valueMinorBoolSubs))
	{
	  warnSub("valueTecomp", "valueMinorBool", a_valueMinorBool);
	}
      return;
    }
}

/********************************************************************/

void check_valueMinorInt(
 valueMinorInt * a_valueMinorInt,
 int log)
{
  if (isA(a_valueMinorInt, valueBoundInt))
    {
      adjustLevels(&valueMinorIntSubs_valueBoundInt, "valueBoundInt");
      if (log && !findString("valueBoundInt", valueMinorIntSubs))
	{
	  warnSub("valueBoundInt", "valueMinorInt", a_valueMinorInt);
	  check_valueBoundInt(
	    dynamic_cast<valueBoundInt *>(a_valueMinorInt), 0);
	}
      else
	check_valueBoundInt(
	  dynamic_cast<valueBoundInt *>(a_valueMinorInt), log);
      return;
    }
  if (isA(a_valueMinorInt, valueFaInt))
    {
      adjustLevels(&valueMinorIntSubs_valueFaInt, "valueFaInt");
      if (log && !findString("valueFaInt", valueMinorIntSubs))
	{
	  warnSub("valueFaInt", "valueMinorInt", a_valueMinorInt);
	  check_valueFaInt(dynamic_cast<valueFaInt *>(a_valueMinorInt), 0);
	}
      else
	check_valueFaInt(dynamic_cast<valueFaInt *>(a_valueMinorInt), log);
      return;
    }
}

/********************************************************************/

void check_valueMinorReal(
 valueMinorReal * a_valueMinorReal,
 int log)
{
  if (isA(a_valueMinorReal, valueAclratReal))
    {
      adjustLevels(&valueMinorRealSubs_valueAclratReal, "valueAclratReal");
      if (log && !findString("valueAclratReal", valueMinorRealSubs))
	{
	  warnSub("valueAclratReal", "valueMinorReal", a_valueMinorReal);
	  check_valueAclratReal(
	    dynamic_cast<valueAclratReal *>(a_valueMinorReal), 0);
	}
      else
	check_valueAclratReal(
	  dynamic_cast<valueAclratReal *>(a_valueMinorReal), log);
      return;
    }
  if (isA(a_valueMinorReal, valueDeflection))
    {
      adjustLevels(&valueMinorRealSubs_valueDeflection, "valueDeflection");
      if (log && !findString("valueDeflection", valueMinorRealSubs))
	{
	  warnSub("valueDeflection", "valueMinorReal", a_valueMinorReal);
	}
      return;
    }
  if (isA(a_valueMinorReal, valueFedratReal))
    {
      adjustLevels(&valueMinorRealSubs_valueFedratReal, "valueFedratReal");
      if (log && !findString("valueFedratReal", valueMinorRealSubs))
	{
	  warnSub("valueFedratReal", "valueMinorReal", a_valueMinorReal);
	  check_valueFedratReal(
	    dynamic_cast<valueFedratReal *>(a_valueMinorReal), 0);
	}
      else
	check_valueFedratReal(
	  dynamic_cast<valueFedratReal *>(a_valueMinorReal), log);
      return;
    }
  if (isA(a_valueMinorReal, valueGotoReal))
    {
      adjustLevels(&valueMinorRealSubs_valueGotoReal, "valueGotoReal");
      if (log && !findString("valueGotoReal", valueMinorRealSubs))
	{
	  warnSub("valueGotoReal", "valueMinorReal", a_valueMinorReal);
	  check_valueGotoReal(
	    dynamic_cast<valueGotoReal *>(a_valueMinorReal), 0);
	}
      else
	check_valueGotoReal(
	  dynamic_cast<valueGotoReal *>(a_valueMinorReal), log);
      return;
    }
  if (isA(a_valueMinorReal, valuePtmeasReal))
    {
      adjustLevels(&valueMinorRealSubs_valuePtmeasReal, "valuePtmeasReal");
      if (log && !findString("valuePtmeasReal", valueMinorRealSubs))
	{
	  warnSub("valuePtmeasReal", "valueMinorReal", a_valueMinorReal);
	  check_valuePtmeasReal(
	    dynamic_cast<valuePtmeasReal *>(a_valueMinorReal), 0);
	}
      else
	check_valuePtmeasReal(
	  dynamic_cast<valuePtmeasReal *>(a_valueMinorReal), log);
      return;
    }
  if (isA(a_valueMinorReal, valueSnsetReal))
    {
      adjustLevels(&valueMinorRealSubs_valueSnsetReal, "valueSnsetReal");
      if (log && !findString("valueSnsetReal", valueMinorRealSubs))
	{
	  warnSub("valueSnsetReal", "valueMinorReal", a_valueMinorReal);
	  check_valueSnsetReal(
	    dynamic_cast<valueSnsetReal *>(a_valueMinorReal), 0);
	}
      else
	check_valueSnsetReal(
	  dynamic_cast<valueSnsetReal *>(a_valueMinorReal), log);
      return;
    }
  if (isA(a_valueMinorReal, valueFaReal))
    {
      adjustLevels(&valueMinorRealSubs_valueFaReal, "valueFaReal");
      if (log && !findString("valueFaReal", valueMinorRealSubs))
	{
	  warnSub("valueFaReal", "valueMinorReal", a_valueMinorReal);
	  check_valueFaReal(
	    dynamic_cast<valueFaReal *>(a_valueMinorReal), 0);
	}
      else
	check_valueFaReal(
	  dynamic_cast<valueFaReal *>(a_valueMinorReal), log);
      return;
    }
  if (isA(a_valueMinorReal, valueRt))
    {
      adjustLevels(&valueMinorRealSubs_valueRt, "valueRt");
      if (log && !findString("valueRt", valueMinorRealSubs))
	{
	  warnSub("valueRt", "valueMinorReal", a_valueMinorReal);
	  check_valueRt(dynamic_cast<valueRt *>(a_valueMinorReal), 0);
	}
      else
	check_valueRt(dynamic_cast<valueRt *>(a_valueMinorReal), log);
      return;
    }
  if (isA(a_valueMinorReal, valueSa))
    {
      adjustLevels(&valueMinorRealSubs_valueSa, "valueSa");
      if (log && !findString("valueSa", valueMinorRealSubs))
	{
	  warnSub("valueSa", "valueMinorReal", a_valueMinorReal);
	  check_valueSa(dynamic_cast<valueSa *>(a_valueMinorReal), 0);
	}
      else
	check_valueSa(dynamic_cast<valueSa *>(a_valueMinorReal), log);
      return;
    }
  if (isA(a_valueMinorReal, valueSw))
    {
      adjustLevels(&valueMinorRealSubs_valueSw, "valueSw");
      if (log && !findString("valueSw", valueMinorRealSubs))
	{
	  warnSub("valueSw", "valueMinorReal", a_valueMinorReal);
	  check_valueSw(dynamic_cast<valueSw *>(a_valueMinorReal), 0);
	}
      else
	check_valueSw(dynamic_cast<valueSw *>(a_valueMinorReal), log);
      return;
    }
  if (isA(a_valueMinorReal, valueTaReal))
    {
      adjustLevels(&valueMinorRealSubs_valueTaReal, "valueTaReal");
      if (log && !findString("valueTaReal", valueMinorRealSubs))
	{
	  warnSub("valueTaReal", "valueMinorReal", a_valueMinorReal);
	  check_valueTaReal(
	    dynamic_cast<valueTaReal *>(a_valueMinorReal), 0);
	}
      else
	check_valueTaReal(
	  dynamic_cast<valueTaReal *>(a_valueMinorReal), log);
      return;
    }
}

/********************************************************************/

void check_valueMinorString(
 valueMinorString * a_valueMinorString,
 int log)
{
  if (isA(a_valueMinorString, valueAclratString))
    {
      adjustLevels(&valueMinorStringSubs_valueAclratString,
		   "valueAclratString");
      if (log && !findString("valueAclratString", valueMinorStringSubs))
	{
	  warnSub("valueAclratString", "valueMinorString", a_valueMinorString);
	  check_valueAclratString(
	    dynamic_cast<valueAclratString *>(a_valueMinorString), 0);
	}
      else
	check_valueAclratString(
	  dynamic_cast<valueAclratString *>(a_valueMinorString), log);
      return;
    }
  if (isA(a_valueMinorString, valueBoundString))
    {
      adjustLevels(&valueMinorStringSubs_valueBoundString, "valueBoundString");
      if (log && !findString("valueBoundString", valueMinorStringSubs))
	{
	  warnSub("valueBoundString", "valueMinorString", a_valueMinorString);
	  check_valueBoundString(
	    dynamic_cast<valueBoundString *>(a_valueMinorString), 0);
	}
      else
	check_valueBoundString(
	  dynamic_cast<valueBoundString *>(a_valueMinorString), log);
      return;
    }
  if (isA(a_valueMinorString, valueCrmode))
    {
      adjustLevels(&valueMinorStringSubs_valueCrmode, "valueCrmode");
      if (log && !findString("valueCrmode", valueMinorStringSubs))
	{
	  warnSub("valueCrmode", "valueMinorString", a_valueMinorString);
	}
      return;
    }
  if (isA(a_valueMinorString, valueCrslct))
    {
      adjustLevels(&valueMinorStringSubs_valueCrslct, "valueCrslct");
      if (log && !findString("valueCrslct", valueMinorStringSubs))
	{
	  warnSub("valueCrslct", "valueMinorString", a_valueMinorString);
	}
      return;
    }
  if (isA(a_valueMinorString, valueDatset))
    {
      adjustLevels(&valueMinorStringSubs_valueDatset, "valueDatset");
      if (log && !findString("valueDatset", valueMinorStringSubs))
	{
	  warnSub("valueDatset", "valueMinorString", a_valueMinorString);
	}
      return;
    }
  if (isA(a_valueMinorString, valueDmismd))
    {
      adjustLevels(&valueMinorStringSubs_valueDmismd, "valueDmismd");
      if (log && !findString("valueDmismd", valueMinorStringSubs))
	{
	  warnSub("valueDmismd", "valueMinorString", a_valueMinorString);
	  check_valueDmismd(
	    dynamic_cast<valueDmismd *>(a_valueMinorString), 0);
	}
      else
	check_valueDmismd(
	  dynamic_cast<valueDmismd *>(a_valueMinorString), log);
      return;
    }
  if (isA(a_valueMinorString, valueDmismn))
    {
      adjustLevels(&valueMinorStringSubs_valueDmismn, "valueDmismn");
      if (log && !findString("valueDmismn", valueMinorStringSubs))
	{
	  warnSub("valueDmismn", "valueMinorString", a_valueMinorString);
	  check_valueDmismn(
	    dynamic_cast<valueDmismn *>(a_valueMinorString), 0);
	}
      else
	check_valueDmismn(
	  dynamic_cast<valueDmismn *>(a_valueMinorString), log);
      return;
    }
  if (isA(a_valueMinorString, valueError))
    {
      adjustLevels(&valueMinorStringSubs_valueError, "valueError");
      if (log && !findString("valueError", valueMinorStringSubs))
	{
	  warnSub("valueError", "valueMinorString", a_valueMinorString);
	  check_valueError(
	    dynamic_cast<valueError *>(a_valueMinorString), 0);
	}
      else
	check_valueError(
	  dynamic_cast<valueError *>(a_valueMinorString), log);
      return;
    }
  if (isA(a_valueMinorString, valueFedratString))
    {
      adjustLevels(&valueMinorStringSubs_valueFedratString,
		   "valueFedratString");
      if (log && !findString("valueFedratString", valueMinorStringSubs))
	{
	  warnSub("valueFedratString", "valueMinorString", a_valueMinorString);
	  check_valueFedratString(
	    dynamic_cast<valueFedratString *>(a_valueMinorString), 0);
	}
      else
	check_valueFedratString(
	  dynamic_cast<valueFedratString *>(a_valueMinorString), log);
      return;
    }
  if (isA(a_valueMinorString, valueFilnam))
    {
      adjustLevels(&valueMinorStringSubs_valueFilnam, "valueFilnam");
      if (log && !findString("valueFilnam", valueMinorStringSubs))
	{
	  warnSub("valueFilnam", "valueMinorString", a_valueMinorString);
	  check_valueFilnam(
	    dynamic_cast<valueFilnam *>(a_valueMinorString), 0);
	}
      else
	check_valueFilnam(
	  dynamic_cast<valueFilnam *>(a_valueMinorString), log);
      return;
    }
  if (isA(a_valueMinorString, valueGeoalg))
    {
      adjustLevels(&valueMinorStringSubs_valueGeoalg, "valueGeoalg");
      if (log && !findString("valueGeoalg", valueMinorStringSubs))
	{
	  warnSub("valueGeoalg", "valueMinorString", a_valueMinorString);
	  check_valueGeoalg(
	    dynamic_cast<valueGeoalg *>(a_valueMinorString), 0);
	}
      else
	check_valueGeoalg(
	  dynamic_cast<valueGeoalg *>(a_valueMinorString), log);
      return;
    }
  if (isA(a_valueMinorString, valueKeychar))
    {
      adjustLevels(&valueMinorStringSubs_valueKeychar, "valueKeychar");
      if (log && !findString("valueKeychar", valueMinorStringSubs))
	{
	  warnSub("valueKeychar", "valueMinorString", a_valueMinorString);
	  check_valueKeychar(
	    dynamic_cast<valueKeychar *>(a_valueMinorString), 0);
	}
      else
	check_valueKeychar(
	  dynamic_cast<valueKeychar *>(a_valueMinorString), log);
      return;
    }
  if (isA(a_valueMinorString, valueMode))
    {
      adjustLevels(&valueMinorStringSubs_valueMode, "valueMode");
      if (log && !findString("valueMode", valueMinorStringSubs))
	{
	  warnSub("valueMode", "valueMinorString", a_valueMinorString);
	}
      return;
    }
  if (isA(a_valueMinorString, valueSnsetString))
    {
      adjustLevels(&valueMinorStringSubs_valueSnsetString, "valueSnsetString");
      if (log && !findString("valueSnsetString", valueMinorStringSubs))
	{
	  warnSub("valueSnsetString", "valueMinorString", a_valueMinorString);
	  check_valueSnsetString(
	    dynamic_cast<valueSnsetString *>(a_valueMinorString), 0);
	}
      else
	check_valueSnsetString(
	  dynamic_cast<valueSnsetString *>(a_valueMinorString), log);
      return;
    }
  if (isA(a_valueMinorString, valueSnslct))
    {
      adjustLevels(&valueMinorStringSubs_valueSnslct, "valueSnslct");
      if (log && !findString("valueSnslct", valueMinorStringSubs))
	{
	  warnSub("valueSnslct", "valueMinorString", a_valueMinorString);
	}
      return;
    }
  if (isA(a_valueMinorString, valueUnits))
    {
      adjustLevels(&valueMinorStringSubs_valueUnits, "valueUnits");
      if (log && !findString("valueUnits", valueMinorStringSubs))
	{
	  warnSub("valueUnits", "valueMinorString", a_valueMinorString);
	  check_valueUnits(
	    dynamic_cast<valueUnits *>(a_valueMinorString), 0);
	}
      else
	check_valueUnits(
	  dynamic_cast<valueUnits *>(a_valueMinorString), log);
      return;
    }
  if (isA(a_valueMinorString, valueWkplan))
    {
      adjustLevels(&valueMinorStringSubs_valueWkplan, "valueWkplan");
      if (log && !findString("valueWkplan", valueMinorStringSubs))
	{
	  warnSub("valueWkplan", "valueMinorString", a_valueMinorString);
	}
      return;
    }
}

/********************************************************************/

void check_valueMinorVector(
 valueMinorVector * a_valueMinorVector,
 int log)
{
  if (isA(a_valueMinorVector, valueGotoVector))
    {
      adjustLevels(&valueMinorVectorSubs_valueGotoVector, "valueGotoVector");
      if (log && !findString("valueGotoVector", valueMinorVectorSubs))
	{
	  warnSub("valueGotoVector", "valueMinorVector", a_valueMinorVector);
	}
      return;
    }
  if (isA(a_valueMinorVector, valuePtmeasVector))
    {
      adjustLevels(&valueMinorVectorSubs_valuePtmeasVector,
		   "valuePtmeasVector");
      if (log && !findString("valuePtmeasVector", valueMinorVectorSubs))
	{
	  warnSub("valuePtmeasVector", "valueMinorVector", a_valueMinorVector);
	}
      return;
    }
  if (isA(a_valueMinorVector, valueSnsmnt))
    {
      adjustLevels(&valueMinorVectorSubs_valueSnsmnt, "valueSnsmnt");
      if (log && !findString("valueSnsmnt", valueMinorVectorSubs))
	{
	  warnSub("valueSnsmnt", "valueMinorVector", a_valueMinorVector);
	  check_valueSnsmnt(
	    dynamic_cast<valueSnsmnt *>(a_valueMinorVector), 0);
	}
      else
	check_valueSnsmnt(
	  dynamic_cast<valueSnsmnt *>(a_valueMinorVector), log);
      return;
    }
}

/********************************************************************/

void check_valuePtmeasReal(
 valuePtmeasReal * a_valuePtmeasReal,
 int log)
{
  if (a_valuePtmeasReal->get_axis())
    {
      adjustLevels(&valuePtmeasRealAtts_a_axis, "valuePtmeasReal a_axis");
      if (log && !findString("a_axis", valuePtmeasRealAtts))
	{
	  warnAtt("a_axis", "valuePtmeasReal", a_valuePtmeasReal);
	  check_axis(a_valuePtmeasReal->get_axis(), 0);
	}
      else
	check_axis(a_valuePtmeasReal->get_axis(), log);
    }
}

/********************************************************************/

void check_valueRt(
 valueRt * a_valueRt,
 int log)
{
  if (isA(a_valueRt, valueRt_CW))
    {
      adjustLevels(&valueRtSubs_valueRt_CW, "valueRt_CW");
      if (log && !findString("valueRt_CW", valueRtSubs))
	{
	  warnSub("valueRt_CW", "valueRt", a_valueRt);
	  check_valueRt_CW(dynamic_cast<valueRt_CW *>(a_valueRt), 0);
	}
      else
	check_valueRt_CW(dynamic_cast<valueRt_CW *>(a_valueRt), log);
      return;
    }
  if (isA(a_valueRt, valueRt_CCW))
    {
      adjustLevels(&valueRtSubs_valueRt_CCW, "valueRt_CCW");
      if (log && !findString("valueRt_CCW", valueRtSubs))
	{
	  warnSub("valueRt_CCW", "valueRt", a_valueRt);
	  check_valueRt_CCW(dynamic_cast<valueRt_CCW *>(a_valueRt), 0);
	}
      else
	check_valueRt_CCW(dynamic_cast<valueRt_CCW *>(a_valueRt), log);
      return;
    }
}

/********************************************************************/

void check_valueRt_CCW(
 valueRt_CCW * a_valueRt_CCW,
 int log)
{
  if (a_valueRt_CCW->get_rtLabel())
    {
      adjustLevels(&valueRt_CCWAtts_a_rtLabel, "valueRt_CCW a_rtLabel");
      if (log && !findString("a_rtLabel", valueRt_CCWAtts))
	{
	  warnAtt("a_rtLabel", "valueRt_CCW", a_valueRt_CCW);
	  check_rtLabel(a_valueRt_CCW->get_rtLabel(), 0);
	}
      else
	check_rtLabel(a_valueRt_CCW->get_rtLabel(), log);
    }
}

/********************************************************************/

void check_valueRt_CW(
 valueRt_CW * a_valueRt_CW,
 int log)
{
  if (a_valueRt_CW->get_rtLabel())
    {
      adjustLevels(&valueRt_CWAtts_a_rtLabel, "valueRt_CW a_rtLabel");
      if (log && !findString("a_rtLabel", valueRt_CWAtts))
	{
	  warnAtt("a_rtLabel", "valueRt_CW", a_valueRt_CW);
	  check_rtLabel(a_valueRt_CW->get_rtLabel(), 0);
	}
      else
	check_rtLabel(a_valueRt_CW->get_rtLabel(), log);
    }
}

/********************************************************************/

void check_valueSa(
 valueSa * a_valueSa,
 int log)
{
  if (isA(a_valueSa, valueSaPlain))
    {
      adjustLevels(&valueSaSubs_valueSaPlain, "valueSaPlain");
      if (log && !findString("valueSaPlain", valueSaSubs))
	{
	  warnSub("valueSaPlain", "valueSa", a_valueSa);
	  check_valueSaPlain(dynamic_cast<valueSaPlain *>(a_valueSa), 0);
	}
      else
	check_valueSaPlain(dynamic_cast<valueSaPlain *>(a_valueSa), log);
      return;
    }
  if (isA(a_valueSa, valueSaDesc))
    {
      adjustLevels(&valueSaSubs_valueSaDesc, "valueSaDesc");
      if (log && !findString("valueSaDesc", valueSaSubs))
	{
	  warnSub("valueSaDesc", "valueSa", a_valueSa);
	  check_valueSaDesc(dynamic_cast<valueSaDesc *>(a_valueSa), 0);
	}
      else
	check_valueSaDesc(dynamic_cast<valueSaDesc *>(a_valueSa), log);
      return;
    }
  if (isA(a_valueSa, valueSaTipnum))
    {
      adjustLevels(&valueSaSubs_valueSaTipnum, "valueSaTipnum");
      if (log && !findString("valueSaTipnum", valueSaSubs))
	{
	  warnSub("valueSaTipnum", "valueSa", a_valueSa);
	  check_valueSaTipnum(dynamic_cast<valueSaTipnum *>(a_valueSa), 0);
	}
      else
	check_valueSaTipnum(dynamic_cast<valueSaTipnum *>(a_valueSa), log);
      return;
    }
}

/********************************************************************/

void check_valueSaDesc(
 valueSaDesc * a_valueSaDesc,
 int log)
{
  if (a_valueSaDesc->get_saLabel())
    {
      adjustLevels(&valueSaDescAtts_a_saLabel, "valueSaDesc a_saLabel");
      if (log && !findString("a_saLabel", valueSaDescAtts))
	{
	  warnAtt("a_saLabel", "valueSaDesc", a_valueSaDesc);
	  check_saLabel(a_valueSaDesc->get_saLabel(), 0);
	}
      else
	check_saLabel(a_valueSaDesc->get_saLabel(), log);
    }
  if (a_valueSaDesc->get_desc())
    {
      adjustLevels(&valueSaDescAtts_desc, "valueSaDesc desc");
      if (log && !findString("desc", valueSaDescAtts))
	{
	  warnAtt("desc", "valueSaDesc", a_valueSaDesc);
	  check_stringVal(a_valueSaDesc->get_desc(), 0);
	}
      else
	check_stringVal(a_valueSaDesc->get_desc(), log);
    }
}

/********************************************************************/

void check_valueSaPlain(
 valueSaPlain * a_valueSaPlain,
 int log)
{
  if (a_valueSaPlain->get_saLabel())
    {
      adjustLevels(&valueSaPlainAtts_a_saLabel, "valueSaPlain a_saLabel");
      if (log && !findString("a_saLabel", valueSaPlainAtts))
	{
	  warnAtt("a_saLabel", "valueSaPlain", a_valueSaPlain);
	  check_saLabel(a_valueSaPlain->get_saLabel(), 0);
	}
      else
	check_saLabel(a_valueSaPlain->get_saLabel(), log);
    }
}

/********************************************************************/

void check_valueSaTipnum(
 valueSaTipnum * a_valueSaTipnum,
 int log)
{
  if (a_valueSaTipnum->get_saLabel())
    {
      adjustLevels(&valueSaTipnumAtts_a_saLabel, "valueSaTipnum a_saLabel");
      if (log && !findString("a_saLabel", valueSaTipnumAtts))
	{
	  warnAtt("a_saLabel", "valueSaTipnum", a_valueSaTipnum);
	  check_saLabel(a_valueSaTipnum->get_saLabel(), 0);
	}
      else
	check_saLabel(a_valueSaTipnum->get_saLabel(), log);
    }
  if (a_valueSaTipnum->get_tipnum())
    {
      adjustLevels(&valueSaTipnumAtts_tipnum, "valueSaTipnum tipnum");
      if (log && !findString("tipnum", valueSaTipnumAtts))
	{
	  warnAtt("tipnum", "valueSaTipnum", a_valueSaTipnum);
	  check_intVal(a_valueSaTipnum->get_tipnum(), 0);
	}
      else
	check_intVal(a_valueSaTipnum->get_tipnum(), log);
    }
}

/********************************************************************/

void check_valueSnsetReal(
 valueSnsetReal * a_valueSnsetReal,
 int log)
{
  if (isA(a_valueSnsetReal, valueSnsetRealApprch))
    {
      adjustLevels(&valueSnsetRealSubs_valueSnsetRealApprch,
		   "valueSnsetRealApprch");
      if (log && !findString("valueSnsetRealApprch", valueSnsetRealSubs))
	{
	  warnSub("valueSnsetRealApprch", "valueSnsetReal", a_valueSnsetReal);
	}
      return;
    }
  if (isA(a_valueSnsetReal, valueSnsetRealRetrct))
    {
      adjustLevels(&valueSnsetRealSubs_valueSnsetRealRetrct,
		   "valueSnsetRealRetrct");
      if (log && !findString("valueSnsetRealRetrct", valueSnsetRealSubs))
	{
	  warnSub("valueSnsetRealRetrct", "valueSnsetReal", a_valueSnsetReal);
	}
      return;
    }
  if (isA(a_valueSnsetReal, valueSnsetRealSearch))
    {
      adjustLevels(&valueSnsetRealSubs_valueSnsetRealSearch,
		   "valueSnsetRealSearch");
      if (log && !findString("valueSnsetRealSearch", valueSnsetRealSubs))
	{
	  warnSub("valueSnsetRealSearch", "valueSnsetReal", a_valueSnsetReal);
	}
      return;
    }
  if (isA(a_valueSnsetReal, valueSnsetRealClrsrf))
    {
      adjustLevels(&valueSnsetRealSubs_valueSnsetRealClrsrf,
		   "valueSnsetRealClrsrf");
      if (log && !findString("valueSnsetRealClrsrf", valueSnsetRealSubs))
	{
	  warnSub("valueSnsetRealClrsrf", "valueSnsetReal", a_valueSnsetReal);
	}
      return;
    }
  if (isA(a_valueSnsetReal, valueSnsetRealDepth))
    {
      adjustLevels(&valueSnsetRealSubs_valueSnsetRealDepth,
		   "valueSnsetRealDepth");
      if (log && !findString("valueSnsetRealDepth", valueSnsetRealSubs))
	{
	  warnSub("valueSnsetRealDepth", "valueSnsetReal", a_valueSnsetReal);
	}
      return;
    }
}

/********************************************************************/

void check_valueSnsetString(
 valueSnsetString * a_valueSnsetString,
 int log)
{
  if (isA(a_valueSnsetString, valueSnsetString_CLRSRF))
    {
      adjustLevels(&valueSnsetStringSubs_valueSnsetString_CLRSRF,
		   "valueSnsetString_CLRSRF");
      if (log && !findString("valueSnsetString_CLRSRF", valueSnsetStringSubs))
	{
	  warnSub("valueSnsetString_CLRSRF", "valueSnsetString",
		  a_valueSnsetString);
	}
      return;
    }
  if (isA(a_valueSnsetString, valueSnsetString_DEPTH))
    {
      adjustLevels(&valueSnsetStringSubs_valueSnsetString_DEPTH,
		   "valueSnsetString_DEPTH");
      if (log && !findString("valueSnsetString_DEPTH", valueSnsetStringSubs))
	{
	  warnSub("valueSnsetString_DEPTH", "valueSnsetString",
		  a_valueSnsetString);
	}
      return;
    }
}

/********************************************************************/

void check_valueSnsmnt(
 valueSnsmnt * a_valueSnsmnt,
 int log)
{
  if (isA(a_valueSnsmnt, valueSnsmnt_XVEC))
    {
      adjustLevels(&valueSnsmntSubs_valueSnsmnt_XVEC, "valueSnsmnt_XVEC");
      if (log && !findString("valueSnsmnt_XVEC", valueSnsmntSubs))
	{
	  warnSub("valueSnsmnt_XVEC", "valueSnsmnt", a_valueSnsmnt);
	}
      return;
    }
  if (isA(a_valueSnsmnt, valueSnsmnt_ZVEC))
    {
      adjustLevels(&valueSnsmntSubs_valueSnsmnt_ZVEC, "valueSnsmnt_ZVEC");
      if (log && !findString("valueSnsmnt_ZVEC", valueSnsmntSubs))
	{
	  warnSub("valueSnsmnt_ZVEC", "valueSnsmnt", a_valueSnsmnt);
	}
      return;
    }
  if (isA(a_valueSnsmnt, valueSnsmnt_MNTLEN))
    {
      adjustLevels(&valueSnsmntSubs_valueSnsmnt_MNTLEN, "valueSnsmnt_MNTLEN");
      if (log && !findString("valueSnsmnt_MNTLEN", valueSnsmntSubs))
	{
	  warnSub("valueSnsmnt_MNTLEN", "valueSnsmnt", a_valueSnsmnt);
	}
      return;
    }
}

/********************************************************************/

void check_valueStm(
 valueStm * a_valueStm,
 int log)
{
  if (isA(a_valueStm, valueStm_boolVar))
    {
      adjustLevels(&valueStmSubs_valueStm_boolVar, "valueStm_boolVar");
      if (log && !findString("valueStm_boolVar", valueStmSubs))
	{
	  warnSub("valueStm_boolVar", "valueStm", a_valueStm);
	  check_valueStm_boolVar(
	    dynamic_cast<valueStm_boolVar *>(a_valueStm), 0);
	}
      else
	check_valueStm_boolVar(
	  dynamic_cast<valueStm_boolVar *>(a_valueStm), log);
      return;
    }
  if (isA(a_valueStm, valueStm_stringVar))
    {
      adjustLevels(&valueStmSubs_valueStm_stringVar, "valueStm_stringVar");
      if (log && !findString("valueStm_stringVar", valueStmSubs))
	{
	  warnSub("valueStm_stringVar", "valueStm", a_valueStm);
	  check_valueStm_stringVar(
	    dynamic_cast<valueStm_stringVar *>(a_valueStm), 0);
	}
      else
	check_valueStm_stringVar(
	  dynamic_cast<valueStm_stringVar *>(a_valueStm), log);
      return;
    }
  if (isA(a_valueStm, valueStm_intVar))
    {
      adjustLevels(&valueStmSubs_valueStm_intVar, "valueStm_intVar");
      if (log && !findString("valueStm_intVar", valueStmSubs))
	{
	  warnSub("valueStm_intVar", "valueStm", a_valueStm);
	  check_valueStm_intVar(
	    dynamic_cast<valueStm_intVar *>(a_valueStm), 0);
	}
      else
	check_valueStm_intVar(
	  dynamic_cast<valueStm_intVar *>(a_valueStm), log);
      return;
    }
  if (isA(a_valueStm, valueStm_realVar))
    {
      adjustLevels(&valueStmSubs_valueStm_realVar, "valueStm_realVar");
      if (log && !findString("valueStm_realVar", valueStmSubs))
	{
	  warnSub("valueStm_realVar", "valueStm", a_valueStm);
	  check_valueStm_realVar(
	    dynamic_cast<valueStm_realVar *>(a_valueStm), 0);
	}
      else
	check_valueStm_realVar(
	  dynamic_cast<valueStm_realVar *>(a_valueStm), log);
      return;
    }
  if (isA(a_valueStm, valueStm_vectorVar))
    {
      adjustLevels(&valueStmSubs_valueStm_vectorVar, "valueStm_vectorVar");
      if (log && !findString("valueStm_vectorVar", valueStmSubs))
	{
	  warnSub("valueStm_vectorVar", "valueStm", a_valueStm);
	  check_valueStm_vectorVar(
	    dynamic_cast<valueStm_vectorVar *>(a_valueStm), 0);
	}
      else
	check_valueStm_vectorVar(
	  dynamic_cast<valueStm_vectorVar *>(a_valueStm), log);
      return;
    }
}

/********************************************************************/

void check_valueStm_boolVar(
 valueStm_boolVar * a_valueStm_boolVar,
 int log)
{
  if (a_valueStm_boolVar->get_boolVar())
    {
      adjustLevels(&valueStm_boolVarAtts_a_boolVar,
		   "valueStm_boolVar a_boolVar");
      if (log && !findString("a_boolVar", valueStm_boolVarAtts))
	{
	  warnAtt("a_boolVar", "valueStm_boolVar", a_valueStm_boolVar);
	  check_boolVar(a_valueStm_boolVar->get_boolVar(), 0);
	}
      else
	check_boolVar(a_valueStm_boolVar->get_boolVar(), log);
    }
  if (a_valueStm_boolVar->get_valueMinorBool())
    {
      adjustLevels(&valueStm_boolVarAtts_a_valueMinorBool,
		   "valueStm_boolVar a_valueMinorBool");
      if (log && !findString("a_valueMinorBool", valueStm_boolVarAtts))
	{
	  warnAtt("a_valueMinorBool", "valueStm_boolVar", a_valueStm_boolVar);
	  check_valueMinorBool(a_valueStm_boolVar->get_valueMinorBool(), 0);
	}
      else
	check_valueMinorBool(a_valueStm_boolVar->get_valueMinorBool(), log);
    }
}

/********************************************************************/

void check_valueStm_intVar(
 valueStm_intVar * a_valueStm_intVar,
 int log)
{
  if (a_valueStm_intVar->get_intVar())
    {
      adjustLevels(&valueStm_intVarAtts_a_intVar, "valueStm_intVar a_intVar");
      if (log && !findString("a_intVar", valueStm_intVarAtts))
	{
	  warnAtt("a_intVar", "valueStm_intVar", a_valueStm_intVar);
	  check_intVar(a_valueStm_intVar->get_intVar(), 0);
	}
      else
	check_intVar(a_valueStm_intVar->get_intVar(), log);
    }
  if (a_valueStm_intVar->get_valueMinorInt())
    {
      adjustLevels(&valueStm_intVarAtts_a_valueMinorInt,
		   "valueStm_intVar a_valueMinorInt");
      if (log && !findString("a_valueMinorInt", valueStm_intVarAtts))
	{
	  warnAtt("a_valueMinorInt", "valueStm_intVar", a_valueStm_intVar);
	  check_valueMinorInt(a_valueStm_intVar->get_valueMinorInt(), 0);
	}
      else
	check_valueMinorInt(a_valueStm_intVar->get_valueMinorInt(), log);
    }
}

/********************************************************************/

void check_valueStm_realVar(
 valueStm_realVar * a_valueStm_realVar,
 int log)
{
  if (a_valueStm_realVar->get_realVar())
    {
      adjustLevels(&valueStm_realVarAtts_a_realVar,
		   "valueStm_realVar a_realVar");
      if (log && !findString("a_realVar", valueStm_realVarAtts))
	{
	  warnAtt("a_realVar", "valueStm_realVar", a_valueStm_realVar);
	  check_realVar(a_valueStm_realVar->get_realVar(), 0);
	}
      else
	check_realVar(a_valueStm_realVar->get_realVar(), log);
    }
  if (a_valueStm_realVar->get_valueMinorReal())
    {
      adjustLevels(&valueStm_realVarAtts_a_valueMinorReal,
		   "valueStm_realVar a_valueMinorReal");
      if (log && !findString("a_valueMinorReal", valueStm_realVarAtts))
	{
	  warnAtt("a_valueMinorReal", "valueStm_realVar", a_valueStm_realVar);
	  check_valueMinorReal(a_valueStm_realVar->get_valueMinorReal(), 0);
	}
      else
	check_valueMinorReal(a_valueStm_realVar->get_valueMinorReal(), log);
    }
}

/********************************************************************/

void check_valueStm_stringVar(
 valueStm_stringVar * a_valueStm_stringVar,
 int log)
{
  if (a_valueStm_stringVar->get_stringVar())
    {
      adjustLevels(&valueStm_stringVarAtts_a_stringVar,
		   "valueStm_stringVar a_stringVar");
      if (log && !findString("a_stringVar", valueStm_stringVarAtts))
	{
	  warnAtt("a_stringVar", "valueStm_stringVar", a_valueStm_stringVar);
	  check_stringVar(a_valueStm_stringVar->get_stringVar(), 0);
	}
      else
	check_stringVar(a_valueStm_stringVar->get_stringVar(), log);
    }
  if (a_valueStm_stringVar->get_valueMinorString())
    {
      adjustLevels(&valueStm_stringVarAtts_a_valueMinorString,
		   "valueStm_stringVar a_valueMinorString");
      if (log && !findString("a_valueMinorString", valueStm_stringVarAtts))
	{
	  warnAtt("a_valueMinorString", "valueStm_stringVar",
		  a_valueStm_stringVar);
	  check_valueMinorString(
	    a_valueStm_stringVar->get_valueMinorString(), 0);
	}
      else
	check_valueMinorString(
	  a_valueStm_stringVar->get_valueMinorString(), log);
    }
}

/********************************************************************/

void check_valueStm_vectorVar(
 valueStm_vectorVar * a_valueStm_vectorVar,
 int log)
{
  if (a_valueStm_vectorVar->get_vectorVar())
    {
      adjustLevels(&valueStm_vectorVarAtts_a_vectorVar,
		   "valueStm_vectorVar a_vectorVar");
      if (log && !findString("a_vectorVar", valueStm_vectorVarAtts))
	{
	  warnAtt("a_vectorVar", "valueStm_vectorVar", a_valueStm_vectorVar);
	  check_vectorVar(a_valueStm_vectorVar->get_vectorVar(), 0);
	}
      else
	check_vectorVar(a_valueStm_vectorVar->get_vectorVar(), log);
    }
  if (a_valueStm_vectorVar->get_valueMinorVector())
    {
      adjustLevels(&valueStm_vectorVarAtts_a_valueMinorVector,
		   "valueStm_vectorVar a_valueMinorVector");
      if (log && !findString("a_valueMinorVector", valueStm_vectorVarAtts))
	{
	  warnAtt("a_valueMinorVector", "valueStm_vectorVar",
		  a_valueStm_vectorVar);
	  check_valueMinorVector(
	    a_valueStm_vectorVar->get_valueMinorVector(), 0);
	}
      else
	check_valueMinorVector(
	  a_valueStm_vectorVar->get_valueMinorVector(), log);
    }
}

/********************************************************************/

void check_valueSw(
 valueSw * a_valueSw,
 int log)
{
  if (a_valueSw->get_swLabel())
    {
      adjustLevels(&valueSwAtts_a_swLabel, "valueSw a_swLabel");
      if (log && !findString("a_swLabel", valueSwAtts))
	{
	  warnAtt("a_swLabel", "valueSw", a_valueSw);
	  check_swLabel(a_valueSw->get_swLabel(), 0);
	}
      else
	check_swLabel(a_valueSw->get_swLabel(), log);
    }
  if (a_valueSw->get_anglename())
    {
      adjustLevels(&valueSwAtts_anglename, "valueSw anglename");
      if (log && !findString("anglename", valueSwAtts))
	{
	  warnAtt("anglename", "valueSw", a_valueSw);
	  check_stringVal(a_valueSw->get_anglename(), 0);
	}
      else
	check_stringVal(a_valueSw->get_anglename(), log);
    }
}

/********************************************************************/

void check_valueTaBool(
 valueTaBool * a_valueTaBool,
 int log)
{
  if (isA(a_valueTaBool, valueTaBoolIntol))
    {
      adjustLevels(&valueTaBoolSubs_valueTaBoolIntol, "valueTaBoolIntol");
      if (log && !findString("valueTaBoolIntol", valueTaBoolSubs))
	{
	  warnSub("valueTaBoolIntol", "valueTaBool", a_valueTaBool);
	  check_valueTaBoolIntol(
	    dynamic_cast<valueTaBoolIntol *>(a_valueTaBool), 0);
	}
      else
	check_valueTaBoolIntol(
	  dynamic_cast<valueTaBoolIntol *>(a_valueTaBool), log);
      return;
    }
  if (isA(a_valueTaBool, valueTaBoolOutol))
    {
      adjustLevels(&valueTaBoolSubs_valueTaBoolOutol, "valueTaBoolOutol");
      if (log && !findString("valueTaBoolOutol", valueTaBoolSubs))
	{
	  warnSub("valueTaBoolOutol", "valueTaBool", a_valueTaBool);
	  check_valueTaBoolOutol(
	    dynamic_cast<valueTaBoolOutol *>(a_valueTaBool), 0);
	}
      else
	check_valueTaBoolOutol(
	  dynamic_cast<valueTaBoolOutol *>(a_valueTaBool), log);
      return;
    }
}

/********************************************************************/

void check_valueTaBoolIntol(
 valueTaBoolIntol * a_valueTaBoolIntol,
 int log)
{
  if (a_valueTaBoolIntol->get_taLabel())
    {
      adjustLevels(&valueTaBoolIntolAtts_a_taLabel,
		   "valueTaBoolIntol a_taLabel");
      if (log && !findString("a_taLabel", valueTaBoolIntolAtts))
	{
	  warnAtt("a_taLabel", "valueTaBoolIntol", a_valueTaBoolIntol);
	  check_taLabel(a_valueTaBoolIntol->get_taLabel(), 0);
	}
      else
	check_taLabel(a_valueTaBoolIntol->get_taLabel(), log);
    }
  if (a_valueTaBoolIntol->get_tolnum())
    {
      adjustLevels(&valueTaBoolIntolAtts_tolnum, "valueTaBoolIntol tolnum");
      if (log && !findString("tolnum", valueTaBoolIntolAtts))
	{
	  warnAtt("tolnum", "valueTaBoolIntol", a_valueTaBoolIntol);
	  check_intVal(a_valueTaBoolIntol->get_tolnum(), 0);
	}
      else
	check_intVal(a_valueTaBoolIntol->get_tolnum(), log);
    }
}

/********************************************************************/

void check_valueTaBoolOutol(
 valueTaBoolOutol * a_valueTaBoolOutol,
 int log)
{
  if (a_valueTaBoolOutol->get_taLabel())
    {
      adjustLevels(&valueTaBoolOutolAtts_a_taLabel,
		   "valueTaBoolOutol a_taLabel");
      if (log && !findString("a_taLabel", valueTaBoolOutolAtts))
	{
	  warnAtt("a_taLabel", "valueTaBoolOutol", a_valueTaBoolOutol);
	  check_taLabel(a_valueTaBoolOutol->get_taLabel(), 0);
	}
      else
	check_taLabel(a_valueTaBoolOutol->get_taLabel(), log);
    }
  if (a_valueTaBoolOutol->get_tolnum())
    {
      adjustLevels(&valueTaBoolOutolAtts_tolnum, "valueTaBoolOutol tolnum");
      if (log && !findString("tolnum", valueTaBoolOutolAtts))
	{
	  warnAtt("tolnum", "valueTaBoolOutol", a_valueTaBoolOutol);
	  check_intVal(a_valueTaBoolOutol->get_tolnum(), 0);
	}
      else
	check_intVal(a_valueTaBoolOutol->get_tolnum(), log);
    }
}

/********************************************************************/

void check_valueTaReal(
 valueTaReal * a_valueTaReal,
 int log)
{
  if (isA(a_valueTaReal, valueTaRealAct))
    {
      adjustLevels(&valueTaRealSubs_valueTaRealAct, "valueTaRealAct");
      if (log && !findString("valueTaRealAct", valueTaRealSubs))
	{
	  warnSub("valueTaRealAct", "valueTaReal", a_valueTaReal);
	  check_valueTaRealAct(
	    dynamic_cast<valueTaRealAct *>(a_valueTaReal), 0);
	}
      else
	check_valueTaRealAct(
	  dynamic_cast<valueTaRealAct *>(a_valueTaReal), log);
      return;
    }
  if (isA(a_valueTaReal, valueTaRealDev))
    {
      adjustLevels(&valueTaRealSubs_valueTaRealDev, "valueTaRealDev");
      if (log && !findString("valueTaRealDev", valueTaRealSubs))
	{
	  warnSub("valueTaRealDev", "valueTaReal", a_valueTaReal);
	  check_valueTaRealDev(
	    dynamic_cast<valueTaRealDev *>(a_valueTaReal), 0);
	}
      else
	check_valueTaRealDev(
	  dynamic_cast<valueTaRealDev *>(a_valueTaReal), log);
      return;
    }
  if (isA(a_valueTaReal, valueTaRealAmt))
    {
      adjustLevels(&valueTaRealSubs_valueTaRealAmt, "valueTaRealAmt");
      if (log && !findString("valueTaRealAmt", valueTaRealSubs))
	{
	  warnSub("valueTaRealAmt", "valueTaReal", a_valueTaReal);
	  check_valueTaRealAmt(
	    dynamic_cast<valueTaRealAmt *>(a_valueTaReal), 0);
	}
      else
	check_valueTaRealAmt(
	  dynamic_cast<valueTaRealAmt *>(a_valueTaReal), log);
      return;
    }
}

/********************************************************************/

void check_valueTaRealAct(
 valueTaRealAct * a_valueTaRealAct,
 int log)
{
  if (a_valueTaRealAct->get_taLabel())
    {
      adjustLevels(&valueTaRealActAtts_a_taLabel, "valueTaRealAct a_taLabel");
      if (log && !findString("a_taLabel", valueTaRealActAtts))
	{
	  warnAtt("a_taLabel", "valueTaRealAct", a_valueTaRealAct);
	  check_taLabel(a_valueTaRealAct->get_taLabel(), 0);
	}
      else
	check_taLabel(a_valueTaRealAct->get_taLabel(), log);
    }
  if (a_valueTaRealAct->get_tolnum())
    {
      adjustLevels(&valueTaRealActAtts_tolnum, "valueTaRealAct tolnum");
      if (log && !findString("tolnum", valueTaRealActAtts))
	{
	  warnAtt("tolnum", "valueTaRealAct", a_valueTaRealAct);
	  check_intVal(a_valueTaRealAct->get_tolnum(), 0);
	}
      else
	check_intVal(a_valueTaRealAct->get_tolnum(), log);
    }
}

/********************************************************************/

void check_valueTaRealAmt(
 valueTaRealAmt * a_valueTaRealAmt,
 int log)
{
  if (a_valueTaRealAmt->get_taLabel())
    {
      adjustLevels(&valueTaRealAmtAtts_a_taLabel, "valueTaRealAmt a_taLabel");
      if (log && !findString("a_taLabel", valueTaRealAmtAtts))
	{
	  warnAtt("a_taLabel", "valueTaRealAmt", a_valueTaRealAmt);
	  check_taLabel(a_valueTaRealAmt->get_taLabel(), 0);
	}
      else
	check_taLabel(a_valueTaRealAmt->get_taLabel(), log);
    }
  if (a_valueTaRealAmt->get_tolnum())
    {
      adjustLevels(&valueTaRealAmtAtts_tolnum, "valueTaRealAmt tolnum");
      if (log && !findString("tolnum", valueTaRealAmtAtts))
	{
	  warnAtt("tolnum", "valueTaRealAmt", a_valueTaRealAmt);
	  check_intVal(a_valueTaRealAmt->get_tolnum(), 0);
	}
      else
	check_intVal(a_valueTaRealAmt->get_tolnum(), log);
    }
}

/********************************************************************/

void check_valueTaRealDev(
 valueTaRealDev * a_valueTaRealDev,
 int log)
{
  if (a_valueTaRealDev->get_taLabel())
    {
      adjustLevels(&valueTaRealDevAtts_a_taLabel, "valueTaRealDev a_taLabel");
      if (log && !findString("a_taLabel", valueTaRealDevAtts))
	{
	  warnAtt("a_taLabel", "valueTaRealDev", a_valueTaRealDev);
	  check_taLabel(a_valueTaRealDev->get_taLabel(), 0);
	}
      else
	check_taLabel(a_valueTaRealDev->get_taLabel(), log);
    }
  if (a_valueTaRealDev->get_tolnum())
    {
      adjustLevels(&valueTaRealDevAtts_tolnum, "valueTaRealDev tolnum");
      if (log && !findString("tolnum", valueTaRealDevAtts))
	{
	  warnAtt("tolnum", "valueTaRealDev", a_valueTaRealDev);
	  check_intVal(a_valueTaRealDev->get_tolnum(), 0);
	}
      else
	check_intVal(a_valueTaRealDev->get_tolnum(), log);
    }
}

/********************************************************************/

void check_valueUnits(
 valueUnits * a_valueUnits,
 int log)
{
  if (isA(a_valueUnits, valueUnits_DIST))
    {
      adjustLevels(&valueUnitsSubs_valueUnits_DIST, "valueUnits_DIST");
      if (log && !findString("valueUnits_DIST", valueUnitsSubs))
	{
	  warnSub("valueUnits_DIST", "valueUnits", a_valueUnits);
	}
      return;
    }
  if (isA(a_valueUnits, valueUnits_ANGL))
    {
      adjustLevels(&valueUnitsSubs_valueUnits_ANGL, "valueUnits_ANGL");
      if (log && !findString("valueUnits_ANGL", valueUnitsSubs))
	{
	  warnSub("valueUnits_ANGL", "valueUnits", a_valueUnits);
	}
      return;
    }
  if (isA(a_valueUnits, valueUnits_TEMP))
    {
      adjustLevels(&valueUnitsSubs_valueUnits_TEMP, "valueUnits_TEMP");
      if (log && !findString("valueUnits_TEMP", valueUnitsSubs))
	{
	  warnSub("valueUnits_TEMP", "valueUnits", a_valueUnits);
	}
      return;
    }
}

/********************************************************************/

void check_vecExpr_MINUS(
 vecExpr_MINUS * a_vecExpr_MINUS,
 int log)
{
  if (a_vecExpr_MINUS->get_term1())
    {
      adjustLevels(&vecExpr_MINUSAtts_term1, "vecExpr_MINUS term1");
      if (log && !findString("term1", vecExpr_MINUSAtts))
	{
	  warnAtt("term1", "vecExpr_MINUS", a_vecExpr_MINUS);
	  check_vectorVal(a_vecExpr_MINUS->get_term1(), 0);
	}
      else
	check_vectorVal(a_vecExpr_MINUS->get_term1(), log);
    }
  if (a_vecExpr_MINUS->get_term2())
    {
      adjustLevels(&vecExpr_MINUSAtts_term2, "vecExpr_MINUS term2");
      if (log && !findString("term2", vecExpr_MINUSAtts))
	{
	  warnAtt("term2", "vecExpr_MINUS", a_vecExpr_MINUS);
	  check_vectorVal(a_vecExpr_MINUS->get_term2(), 0);
	}
      else
	check_vectorVal(a_vecExpr_MINUS->get_term2(), log);
    }
}

/********************************************************************/

void check_vecExpr_PAREN(
 vecExpr_PAREN * a_vecExpr_PAREN,
 int log)
{
  if (a_vecExpr_PAREN->get_vectorVal())
    {
      adjustLevels(&vecExpr_PARENAtts_a_vectorVal,
		   "vecExpr_PAREN a_vectorVal");
      if (log && !findString("a_vectorVal", vecExpr_PARENAtts))
	{
	  warnAtt("a_vectorVal", "vecExpr_PAREN", a_vecExpr_PAREN);
	  check_vectorVal(a_vecExpr_PAREN->get_vectorVal(), 0);
	}
      else
	check_vectorVal(a_vecExpr_PAREN->get_vectorVal(), log);
    }
}

/********************************************************************/

void check_vecExpr_PLUS(
 vecExpr_PLUS * a_vecExpr_PLUS,
 int log)
{
  if (a_vecExpr_PLUS->get_term1())
    {
      adjustLevels(&vecExpr_PLUSAtts_term1, "vecExpr_PLUS term1");
      if (log && !findString("term1", vecExpr_PLUSAtts))
	{
	  warnAtt("term1", "vecExpr_PLUS", a_vecExpr_PLUS);
	  check_vectorVal(a_vecExpr_PLUS->get_term1(), 0);
	}
      else
	check_vectorVal(a_vecExpr_PLUS->get_term1(), log);
    }
  if (a_vecExpr_PLUS->get_term2())
    {
      adjustLevels(&vecExpr_PLUSAtts_term2, "vecExpr_PLUS term2");
      if (log && !findString("term2", vecExpr_PLUSAtts))
	{
	  warnAtt("term2", "vecExpr_PLUS", a_vecExpr_PLUS);
	  check_vectorVal(a_vecExpr_PLUS->get_term2(), 0);
	}
      else
	check_vectorVal(a_vecExpr_PLUS->get_term2(), log);
    }
}

/********************************************************************/

void check_vecIntExpr_DIVID(
 vecIntExpr_DIVID * a_vecIntExpr_DIVID,
 int log)
{
  if (a_vecIntExpr_DIVID->get_dvend())
    {
      adjustLevels(&vecIntExpr_DIVIDAtts_dvend, "vecIntExpr_DIVID dvend");
      if (log && !findString("dvend", vecIntExpr_DIVIDAtts))
	{
	  warnAtt("dvend", "vecIntExpr_DIVID", a_vecIntExpr_DIVID);
	  check_vectorVal(a_vecIntExpr_DIVID->get_dvend(), 0);
	}
      else
	check_vectorVal(a_vecIntExpr_DIVID->get_dvend(), log);
    }
  if (a_vecIntExpr_DIVID->get_dvisr())
    {
      adjustLevels(&vecIntExpr_DIVIDAtts_dvisr, "vecIntExpr_DIVID dvisr");
      if (log && !findString("dvisr", vecIntExpr_DIVIDAtts))
	{
	  warnAtt("dvisr", "vecIntExpr_DIVID", a_vecIntExpr_DIVID);
	  check_intVal(a_vecIntExpr_DIVID->get_dvisr(), 0);
	}
      else
	check_intVal(a_vecIntExpr_DIVID->get_dvisr(), log);
    }
}

/********************************************************************/

void check_vecIntExpr_TIMES(
 vecIntExpr_TIMES * a_vecIntExpr_TIMES,
 int log)
{
  if (a_vecIntExpr_TIMES->get_term1())
    {
      adjustLevels(&vecIntExpr_TIMESAtts_term1, "vecIntExpr_TIMES term1");
      if (log && !findString("term1", vecIntExpr_TIMESAtts))
	{
	  warnAtt("term1", "vecIntExpr_TIMES", a_vecIntExpr_TIMES);
	  check_vectorVal(a_vecIntExpr_TIMES->get_term1(), 0);
	}
      else
	check_vectorVal(a_vecIntExpr_TIMES->get_term1(), log);
    }
  if (a_vecIntExpr_TIMES->get_term2())
    {
      adjustLevels(&vecIntExpr_TIMESAtts_term2, "vecIntExpr_TIMES term2");
      if (log && !findString("term2", vecIntExpr_TIMESAtts))
	{
	  warnAtt("term2", "vecIntExpr_TIMES", a_vecIntExpr_TIMES);
	  check_intVal(a_vecIntExpr_TIMES->get_term2(), 0);
	}
      else
	check_intVal(a_vecIntExpr_TIMES->get_term2(), log);
    }
}

/********************************************************************/

void check_vecRealExpr_DIVID(
 vecRealExpr_DIVID * a_vecRealExpr_DIVID,
 int log)
{
  if (a_vecRealExpr_DIVID->get_dvend())
    {
      adjustLevels(&vecRealExpr_DIVIDAtts_dvend, "vecRealExpr_DIVID dvend");
      if (log && !findString("dvend", vecRealExpr_DIVIDAtts))
	{
	  warnAtt("dvend", "vecRealExpr_DIVID", a_vecRealExpr_DIVID);
	  check_vectorVal(a_vecRealExpr_DIVID->get_dvend(), 0);
	}
      else
	check_vectorVal(a_vecRealExpr_DIVID->get_dvend(), log);
    }
  if (a_vecRealExpr_DIVID->get_dvisr())
    {
      adjustLevels(&vecRealExpr_DIVIDAtts_dvisr, "vecRealExpr_DIVID dvisr");
      if (log && !findString("dvisr", vecRealExpr_DIVIDAtts))
	{
	  warnAtt("dvisr", "vecRealExpr_DIVID", a_vecRealExpr_DIVID);
	  check_realVal(a_vecRealExpr_DIVID->get_dvisr(), 0);
	}
      else
	check_realVal(a_vecRealExpr_DIVID->get_dvisr(), log);
    }
}

/********************************************************************/

void check_vecRealExpr_TIMES(
 vecRealExpr_TIMES * a_vecRealExpr_TIMES,
 int log)
{
  if (a_vecRealExpr_TIMES->get_term1())
    {
      adjustLevels(&vecRealExpr_TIMESAtts_term1, "vecRealExpr_TIMES term1");
      if (log && !findString("term1", vecRealExpr_TIMESAtts))
	{
	  warnAtt("term1", "vecRealExpr_TIMES", a_vecRealExpr_TIMES);
	  check_vectorVal(a_vecRealExpr_TIMES->get_term1(), 0);
	}
      else
	check_vectorVal(a_vecRealExpr_TIMES->get_term1(), log);
    }
  if (a_vecRealExpr_TIMES->get_term2())
    {
      adjustLevels(&vecRealExpr_TIMESAtts_term2, "vecRealExpr_TIMES term2");
      if (log && !findString("term2", vecRealExpr_TIMESAtts))
	{
	  warnAtt("term2", "vecRealExpr_TIMES", a_vecRealExpr_TIMES);
	  check_realVal(a_vecRealExpr_TIMES->get_term2(), 0);
	}
      else
	check_realVal(a_vecRealExpr_TIMES->get_term2(), log);
    }
}

/********************************************************************/

void check_vector(
 vector * a_vector,
 int log)
{
  if (a_vector->get_i())
    {
      adjustLevels(&vectorAtts_i, "vector i");
      if (log && !findString("i", vectorAtts))
	{
	  warnAtt("i", "vector", a_vector);
	  check_rentVal(a_vector->get_i(), 0);
	}
      else
	check_rentVal(a_vector->get_i(), log);
    }
  if (a_vector->get_j())
    {
      adjustLevels(&vectorAtts_j, "vector j");
      if (log && !findString("j", vectorAtts))
	{
	  warnAtt("j", "vector", a_vector);
	  check_rentVal(a_vector->get_j(), 0);
	}
      else
	check_rentVal(a_vector->get_j(), log);
    }
  if (a_vector->get_k())
    {
      adjustLevels(&vectorAtts_k, "vector k");
      if (log && !findString("k", vectorAtts))
	{
	  warnAtt("k", "vector", a_vector);
	  check_rentVal(a_vector->get_k(), 0);
	}
      else
	check_rentVal(a_vector->get_k(), log);
    }
}

/********************************************************************/

void check_vectorExpr(
 vectorExpr * a_vectorExpr,
 int log)
{
  if (isA(a_vectorExpr, vecExpr_PAREN))
    {
      adjustLevels(&vectorExprSubs_vecExpr_PAREN, "vecExpr_PAREN");
      if (log && !findString("vecExpr_PAREN", vectorExprSubs))
	{
	  warnSub("vecExpr_PAREN", "vectorExpr", a_vectorExpr);
	  check_vecExpr_PAREN(
	    dynamic_cast<vecExpr_PAREN *>(a_vectorExpr), 0);
	}
      else
	check_vecExpr_PAREN(
	  dynamic_cast<vecExpr_PAREN *>(a_vectorExpr), log);
      return;
    }
  if (isA(a_vectorExpr, vecExpr_PLUS))
    {
      adjustLevels(&vectorExprSubs_vecExpr_PLUS, "vecExpr_PLUS");
      if (log && !findString("vecExpr_PLUS", vectorExprSubs))
	{
	  warnSub("vecExpr_PLUS", "vectorExpr", a_vectorExpr);
	  check_vecExpr_PLUS(
	    dynamic_cast<vecExpr_PLUS *>(a_vectorExpr), 0);
	}
      else
	check_vecExpr_PLUS(
	  dynamic_cast<vecExpr_PLUS *>(a_vectorExpr), log);
      return;
    }
  if (isA(a_vectorExpr, vecExpr_MINUS))
    {
      adjustLevels(&vectorExprSubs_vecExpr_MINUS, "vecExpr_MINUS");
      if (log && !findString("vecExpr_MINUS", vectorExprSubs))
	{
	  warnSub("vecExpr_MINUS", "vectorExpr", a_vectorExpr);
	  check_vecExpr_MINUS(
	    dynamic_cast<vecExpr_MINUS *>(a_vectorExpr), 0);
	}
      else
	check_vecExpr_MINUS(
	  dynamic_cast<vecExpr_MINUS *>(a_vectorExpr), log);
      return;
    }
  if (isA(a_vectorExpr, vecRealExpr_DIVID))
    {
      adjustLevels(&vectorExprSubs_vecRealExpr_DIVID, "vecRealExpr_DIVID");
      if (log && !findString("vecRealExpr_DIVID", vectorExprSubs))
	{
	  warnSub("vecRealExpr_DIVID", "vectorExpr", a_vectorExpr);
	  check_vecRealExpr_DIVID(
	    dynamic_cast<vecRealExpr_DIVID *>(a_vectorExpr), 0);
	}
      else
	check_vecRealExpr_DIVID(
	  dynamic_cast<vecRealExpr_DIVID *>(a_vectorExpr), log);
      return;
    }
  if (isA(a_vectorExpr, vecIntExpr_DIVID))
    {
      adjustLevels(&vectorExprSubs_vecIntExpr_DIVID, "vecIntExpr_DIVID");
      if (log && !findString("vecIntExpr_DIVID", vectorExprSubs))
	{
	  warnSub("vecIntExpr_DIVID", "vectorExpr", a_vectorExpr);
	  check_vecIntExpr_DIVID(
	    dynamic_cast<vecIntExpr_DIVID *>(a_vectorExpr), 0);
	}
      else
	check_vecIntExpr_DIVID(
	  dynamic_cast<vecIntExpr_DIVID *>(a_vectorExpr), log);
      return;
    }
  if (isA(a_vectorExpr, vecRealExpr_TIMES))
    {
      adjustLevels(&vectorExprSubs_vecRealExpr_TIMES, "vecRealExpr_TIMES");
      if (log && !findString("vecRealExpr_TIMES", vectorExprSubs))
	{
	  warnSub("vecRealExpr_TIMES", "vectorExpr", a_vectorExpr);
	  check_vecRealExpr_TIMES(
	    dynamic_cast<vecRealExpr_TIMES *>(a_vectorExpr), 0);
	}
      else
	check_vecRealExpr_TIMES(
	  dynamic_cast<vecRealExpr_TIMES *>(a_vectorExpr), log);
      return;
    }
  if (isA(a_vectorExpr, realVecExpr_TIMES))
    {
      adjustLevels(&vectorExprSubs_realVecExpr_TIMES, "realVecExpr_TIMES");
      if (log && !findString("realVecExpr_TIMES", vectorExprSubs))
	{
	  warnSub("realVecExpr_TIMES", "vectorExpr", a_vectorExpr);
	  check_realVecExpr_TIMES(
	    dynamic_cast<realVecExpr_TIMES *>(a_vectorExpr), 0);
	}
      else
	check_realVecExpr_TIMES(
	  dynamic_cast<realVecExpr_TIMES *>(a_vectorExpr), log);
      return;
    }
  if (isA(a_vectorExpr, vecIntExpr_TIMES))
    {
      adjustLevels(&vectorExprSubs_vecIntExpr_TIMES, "vecIntExpr_TIMES");
      if (log && !findString("vecIntExpr_TIMES", vectorExprSubs))
	{
	  warnSub("vecIntExpr_TIMES", "vectorExpr", a_vectorExpr);
	  check_vecIntExpr_TIMES(
	    dynamic_cast<vecIntExpr_TIMES *>(a_vectorExpr), 0);
	}
      else
	check_vecIntExpr_TIMES(
	  dynamic_cast<vecIntExpr_TIMES *>(a_vectorExpr), log);
      return;
    }
  if (isA(a_vectorExpr, intVecExpr_TIMES))
    {
      adjustLevels(&vectorExprSubs_intVecExpr_TIMES, "intVecExpr_TIMES");
      if (log && !findString("intVecExpr_TIMES", vectorExprSubs))
	{
	  warnSub("intVecExpr_TIMES", "vectorExpr", a_vectorExpr);
	  check_intVecExpr_TIMES(
	    dynamic_cast<intVecExpr_TIMES *>(a_vectorExpr), 0);
	}
      else
	check_intVecExpr_TIMES(
	  dynamic_cast<intVecExpr_TIMES *>(a_vectorExpr), log);
      return;
    }
}

/********************************************************************/

void check_vectorFunc(
 vectorFunc * a_vectorFunc,
 int log)
{
  if (isA(a_vectorFunc, vectorFuncVcart))
    {
      adjustLevels(&vectorFuncSubs_vectorFuncVcart, "vectorFuncVcart");
      if (log && !findString("vectorFuncVcart", vectorFuncSubs))
	{
	  warnSub("vectorFuncVcart", "vectorFunc", a_vectorFunc);
	  check_vectorFuncVcart(
	    dynamic_cast<vectorFuncVcart *>(a_vectorFunc), 0);
	}
      else
	check_vectorFuncVcart(
	  dynamic_cast<vectorFuncVcart *>(a_vectorFunc), log);
      return;
    }
  if (isA(a_vectorFunc, vectorFuncVcross))
    {
      adjustLevels(&vectorFuncSubs_vectorFuncVcross, "vectorFuncVcross");
      if (log && !findString("vectorFuncVcross", vectorFuncSubs))
	{
	  warnSub("vectorFuncVcross", "vectorFunc", a_vectorFunc);
	  check_vectorFuncVcross(
	    dynamic_cast<vectorFuncVcross *>(a_vectorFunc), 0);
	}
      else
	check_vectorFuncVcross(
	  dynamic_cast<vectorFuncVcross *>(a_vectorFunc), log);
      return;
    }
  if (isA(a_vectorFunc, vectorFuncVmcs))
    {
      adjustLevels(&vectorFuncSubs_vectorFuncVmcs, "vectorFuncVmcs");
      if (log && !findString("vectorFuncVmcs", vectorFuncSubs))
	{
	  warnSub("vectorFuncVmcs", "vectorFunc", a_vectorFunc);
	  check_vectorFuncVmcs(
	    dynamic_cast<vectorFuncVmcs *>(a_vectorFunc), 0);
	}
      else
	check_vectorFuncVmcs(
	  dynamic_cast<vectorFuncVmcs *>(a_vectorFunc), log);
      return;
    }
  if (isA(a_vectorFunc, vectorFuncVpcs))
    {
      adjustLevels(&vectorFuncSubs_vectorFuncVpcs, "vectorFuncVpcs");
      if (log && !findString("vectorFuncVpcs", vectorFuncSubs))
	{
	  warnSub("vectorFuncVpcs", "vectorFunc", a_vectorFunc);
	  check_vectorFuncVpcs(
	    dynamic_cast<vectorFuncVpcs *>(a_vectorFunc), 0);
	}
      else
	check_vectorFuncVpcs(
	  dynamic_cast<vectorFuncVpcs *>(a_vectorFunc), log);
      return;
    }
  if (isA(a_vectorFunc, vectorFuncVpol))
    {
      adjustLevels(&vectorFuncSubs_vectorFuncVpol, "vectorFuncVpol");
      if (log && !findString("vectorFuncVpol", vectorFuncSubs))
	{
	  warnSub("vectorFuncVpol", "vectorFunc", a_vectorFunc);
	  check_vectorFuncVpol(
	    dynamic_cast<vectorFuncVpol *>(a_vectorFunc), 0);
	}
      else
	check_vectorFuncVpol(
	  dynamic_cast<vectorFuncVpol *>(a_vectorFunc), log);
      return;
    }
  if (isA(a_vectorFunc, vectorFuncVunit))
    {
      adjustLevels(&vectorFuncSubs_vectorFuncVunit, "vectorFuncVunit");
      if (log && !findString("vectorFuncVunit", vectorFuncSubs))
	{
	  warnSub("vectorFuncVunit", "vectorFunc", a_vectorFunc);
	  check_vectorFuncVunit(
	    dynamic_cast<vectorFuncVunit *>(a_vectorFunc), 0);
	}
      else
	check_vectorFuncVunit(
	  dynamic_cast<vectorFuncVunit *>(a_vectorFunc), log);
      return;
    }
}

/********************************************************************/

void check_vectorFuncVcart(
 vectorFuncVcart * a_vectorFuncVcart,
 int log)
{
  if (a_vectorFuncVcart->get_x())
    {
      adjustLevels(&vectorFuncVcartAtts_x, "vectorFuncVcart x");
      if (log && !findString("x", vectorFuncVcartAtts))
	{
	  warnAtt("x", "vectorFuncVcart", a_vectorFuncVcart);
	  check_rentVal(a_vectorFuncVcart->get_x(), 0);
	}
      else
	check_rentVal(a_vectorFuncVcart->get_x(), log);
    }
  if (a_vectorFuncVcart->get_y())
    {
      adjustLevels(&vectorFuncVcartAtts_y, "vectorFuncVcart y");
      if (log && !findString("y", vectorFuncVcartAtts))
	{
	  warnAtt("y", "vectorFuncVcart", a_vectorFuncVcart);
	  check_rentVal(a_vectorFuncVcart->get_y(), 0);
	}
      else
	check_rentVal(a_vectorFuncVcart->get_y(), log);
    }
  if (a_vectorFuncVcart->get_z())
    {
      adjustLevels(&vectorFuncVcartAtts_z, "vectorFuncVcart z");
      if (log && !findString("z", vectorFuncVcartAtts))
	{
	  warnAtt("z", "vectorFuncVcart", a_vectorFuncVcart);
	  check_rentVal(a_vectorFuncVcart->get_z(), 0);
	}
      else
	check_rentVal(a_vectorFuncVcart->get_z(), log);
    }
}

/********************************************************************/

void check_vectorFuncVcross(
 vectorFuncVcross * a_vectorFuncVcross,
 int log)
{
  if (a_vectorFuncVcross->get_v1())
    {
      adjustLevels(&vectorFuncVcrossAtts_v1, "vectorFuncVcross v1");
      if (log && !findString("v1", vectorFuncVcrossAtts))
	{
	  warnAtt("v1", "vectorFuncVcross", a_vectorFuncVcross);
	  check_vectorVal(a_vectorFuncVcross->get_v1(), 0);
	}
      else
	check_vectorVal(a_vectorFuncVcross->get_v1(), log);
    }
  if (a_vectorFuncVcross->get_v2())
    {
      adjustLevels(&vectorFuncVcrossAtts_v2, "vectorFuncVcross v2");
      if (log && !findString("v2", vectorFuncVcrossAtts))
	{
	  warnAtt("v2", "vectorFuncVcross", a_vectorFuncVcross);
	  check_vectorVal(a_vectorFuncVcross->get_v2(), 0);
	}
      else
	check_vectorVal(a_vectorFuncVcross->get_v2(), log);
    }
}

/********************************************************************/

void check_vectorFuncVmcs(
 vectorFuncVmcs * a_vectorFuncVmcs,
 int log)
{
  if (a_vectorFuncVmcs->get_vectorVal())
    {
      adjustLevels(&vectorFuncVmcsAtts_a_vectorVal,
		   "vectorFuncVmcs a_vectorVal");
      if (log && !findString("a_vectorVal", vectorFuncVmcsAtts))
	{
	  warnAtt("a_vectorVal", "vectorFuncVmcs", a_vectorFuncVmcs);
	  check_vectorVal(a_vectorFuncVmcs->get_vectorVal(), 0);
	}
      else
	check_vectorVal(a_vectorFuncVmcs->get_vectorVal(), log);
    }
}

/********************************************************************/

void check_vectorFuncVpcs(
 vectorFuncVpcs * a_vectorFuncVpcs,
 int log)
{
  if (a_vectorFuncVpcs->get_vectorVal())
    {
      adjustLevels(&vectorFuncVpcsAtts_a_vectorVal,
		   "vectorFuncVpcs a_vectorVal");
      if (log && !findString("a_vectorVal", vectorFuncVpcsAtts))
	{
	  warnAtt("a_vectorVal", "vectorFuncVpcs", a_vectorFuncVpcs);
	  check_vectorVal(a_vectorFuncVpcs->get_vectorVal(), 0);
	}
      else
	check_vectorVal(a_vectorFuncVpcs->get_vectorVal(), log);
    }
}

/********************************************************************/

void check_vectorFuncVpol(
 vectorFuncVpol * a_vectorFuncVpol,
 int log)
{
  if (a_vectorFuncVpol->get_r())
    {
      adjustLevels(&vectorFuncVpolAtts_r, "vectorFuncVpol r");
      if (log && !findString("r", vectorFuncVpolAtts))
	{
	  warnAtt("r", "vectorFuncVpol", a_vectorFuncVpol);
	  check_rentVal(a_vectorFuncVpol->get_r(), 0);
	}
      else
	check_rentVal(a_vectorFuncVpol->get_r(), log);
    }
  if (a_vectorFuncVpol->get_a())
    {
      adjustLevels(&vectorFuncVpolAtts_a, "vectorFuncVpol a");
      if (log && !findString("a", vectorFuncVpolAtts))
	{
	  warnAtt("a", "vectorFuncVpol", a_vectorFuncVpol);
	  check_angle(a_vectorFuncVpol->get_a(), 0);
	}
      else
	check_angle(a_vectorFuncVpol->get_a(), log);
    }
  if (a_vectorFuncVpol->get_h())
    {
      adjustLevels(&vectorFuncVpolAtts_h, "vectorFuncVpol h");
      if (log && !findString("h", vectorFuncVpolAtts))
	{
	  warnAtt("h", "vectorFuncVpol", a_vectorFuncVpol);
	  check_rentVal(a_vectorFuncVpol->get_h(), 0);
	}
      else
	check_rentVal(a_vectorFuncVpol->get_h(), log);
    }
}

/********************************************************************/

void check_vectorFuncVunit(
 vectorFuncVunit * a_vectorFuncVunit,
 int log)
{
  if (a_vectorFuncVunit->get_vectorVal())
    {
      adjustLevels(&vectorFuncVunitAtts_a_vectorVal,
		   "vectorFuncVunit a_vectorVal");
      if (log && !findString("a_vectorVal", vectorFuncVunitAtts))
	{
	  warnAtt("a_vectorVal", "vectorFuncVunit", a_vectorFuncVunit);
	  check_vectorVal(a_vectorFuncVunit->get_vectorVal(), 0);
	}
      else
	check_vectorVal(a_vectorFuncVunit->get_vectorVal(), log);
    }
}

/********************************************************************/

void check_vectorRel(
 vectorRel * a_vectorRel,
 int log)
{
  if (isA(a_vectorRel, vectorRel_EQ))
    {
      adjustLevels(&vectorRelSubs_vectorRel_EQ, "vectorRel_EQ");
      if (log && !findString("vectorRel_EQ", vectorRelSubs))
	{
	  warnSub("vectorRel_EQ", "vectorRel", a_vectorRel);
	  check_vectorRel_EQ(dynamic_cast<vectorRel_EQ *>(a_vectorRel), 0);
	}
      else
	check_vectorRel_EQ(dynamic_cast<vectorRel_EQ *>(a_vectorRel), log);
      return;
    }
  if (isA(a_vectorRel, vectorRel_NE))
    {
      adjustLevels(&vectorRelSubs_vectorRel_NE, "vectorRel_NE");
      if (log && !findString("vectorRel_NE", vectorRelSubs))
	{
	  warnSub("vectorRel_NE", "vectorRel", a_vectorRel);
	  check_vectorRel_NE(dynamic_cast<vectorRel_NE *>(a_vectorRel), 0);
	}
      else
	check_vectorRel_NE(dynamic_cast<vectorRel_NE *>(a_vectorRel), log);
      return;
    }
}

/********************************************************************/

void check_vectorRel_EQ(
 vectorRel_EQ * a_vectorRel_EQ,
 int log)
{
  if (a_vectorRel_EQ->get_left())
    {
      adjustLevels(&vectorRel_EQAtts_left, "vectorRel_EQ left");
      if (log && !findString("left", vectorRel_EQAtts))
	{
	  warnAtt("left", "vectorRel_EQ", a_vectorRel_EQ);
	  check_vectorVal(a_vectorRel_EQ->get_left(), 0);
	}
      else
	check_vectorVal(a_vectorRel_EQ->get_left(), log);
    }
  if (a_vectorRel_EQ->get_right())
    {
      adjustLevels(&vectorRel_EQAtts_right, "vectorRel_EQ right");
      if (log && !findString("right", vectorRel_EQAtts))
	{
	  warnAtt("right", "vectorRel_EQ", a_vectorRel_EQ);
	  check_vectorVal(a_vectorRel_EQ->get_right(), 0);
	}
      else
	check_vectorVal(a_vectorRel_EQ->get_right(), log);
    }
}

/********************************************************************/

void check_vectorRel_NE(
 vectorRel_NE * a_vectorRel_NE,
 int log)
{
  if (a_vectorRel_NE->get_left())
    {
      adjustLevels(&vectorRel_NEAtts_left, "vectorRel_NE left");
      if (log && !findString("left", vectorRel_NEAtts))
	{
	  warnAtt("left", "vectorRel_NE", a_vectorRel_NE);
	  check_vectorVal(a_vectorRel_NE->get_left(), 0);
	}
      else
	check_vectorVal(a_vectorRel_NE->get_left(), log);
    }
  if (a_vectorRel_NE->get_right())
    {
      adjustLevels(&vectorRel_NEAtts_right, "vectorRel_NE right");
      if (log && !findString("right", vectorRel_NEAtts))
	{
	  warnAtt("right", "vectorRel_NE", a_vectorRel_NE);
	  check_vectorVal(a_vectorRel_NE->get_right(), 0);
	}
      else
	check_vectorVal(a_vectorRel_NE->get_right(), log);
    }
}

/********************************************************************/

void check_vectorVal(
 vectorVal * a_vectorVal,
 int log)
{
  if (isA(a_vectorVal, vectorFunc))
    {
      adjustLevels(&vectorValSubs_vectorFunc, "vectorFunc");
      if (log && !findString("vectorFunc", vectorValSubs))
	{
	  warnSub("vectorFunc", "vectorVal", a_vectorVal);
	  check_vectorFunc(dynamic_cast<vectorFunc *>(a_vectorVal), 0);
	}
      else
	check_vectorFunc(dynamic_cast<vectorFunc *>(a_vectorVal), log);
      return;
    }
  if (isA(a_vectorVal, vectorExpr))
    {
      adjustLevels(&vectorValSubs_vectorExpr, "vectorExpr");
      if (log && !findString("vectorExpr", vectorValSubs))
	{
	  warnSub("vectorExpr", "vectorVal", a_vectorVal);
	  check_vectorExpr(dynamic_cast<vectorExpr *>(a_vectorVal), 0);
	}
      else
	check_vectorExpr(dynamic_cast<vectorExpr *>(a_vectorVal), log);
      return;
    }
  if (isA(a_vectorVal, vectorVar))
    {
      adjustLevels(&vectorValSubs_vectorVar, "vectorVar");
      if (log && !findString("vectorVar", vectorValSubs))
	{
	  warnSub("vectorVar", "vectorVal", a_vectorVal);
	  check_vectorVar(dynamic_cast<vectorVar *>(a_vectorVal), 0);
	}
      else
	check_vectorVar(dynamic_cast<vectorVar *>(a_vectorVal), log);
      return;
    }
}

/********************************************************************/

void check_vectorVar(
 vectorVar * a_vectorVar,
 int log)
{
  if (a_vectorVar->get_string())
    {
      adjustLevels(&vectorVarAtts_a_string, "vectorVar a_string");
      if (log && !findString("a_string", vectorVarAtts))
	{
	  warnAtt("a_string", "vectorVar", a_vectorVar);
	}
    }
  if (a_vectorVar->get_arrayIndex())
    {
      adjustLevels(&vectorVarAtts_a_arrayIndex, "vectorVar a_arrayIndex");
      if (log && !findString("a_arrayIndex", vectorVarAtts))
	{
	  warnAtt("a_arrayIndex", "vectorVar", a_vectorVar);
	  check_arrayIndex(a_vectorVar->get_arrayIndex(), 0);
	}
      else
	check_arrayIndex(a_vectorVar->get_arrayIndex(), log);
    }
}

/********************************************************************/

void check_versionTag(
 versionTag * a_versionTag,
 int log)
{
  if (a_versionTag->get_double())
    {
      adjustLevels(&versionTagAtts_a_double, "versionTag a_double");
      if (log && !findString("a_double", versionTagAtts))
	{
	  warnAtt("a_double", "versionTag", a_versionTag);
	}
    }
}

/********************************************************************/

void check_vertexConst(
 vertexConst * a_vertexConst,
 int log)
{
  if (a_vertexConst->get_faLabel())
    {
      adjustLevels(&vertexConstAtts_a_faLabel, "vertexConst a_faLabel");
      if (log && !findString("a_faLabel", vertexConstAtts))
	{
	  warnAtt("a_faLabel", "vertexConst", a_vertexConst);
	  check_faLabel(a_vertexConst->get_faLabel(), 0);
	}
      else
	check_faLabel(a_vertexConst->get_faLabel(), log);
    }
}

/********************************************************************/

void check_vfLabel(
 vfLabel * a_vfLabel,
 int log)
{
  if (a_vfLabel->get_labelName())
    {
      adjustLevels(&vfLabelAtts_a_labelName, "vfLabel a_labelName");
      if (log && !findString("a_labelName", vfLabelAtts))
	{
	  warnAtt("a_labelName", "vfLabel", a_vfLabel);
	  check_labelName(a_vfLabel->get_labelName(), 0);
	}
      else
	check_labelName(a_vfLabel->get_labelName(), log);
    }
}

/********************************************************************/

void check_vformItem(
 vformItem * a_vformItem,
 int log)
{
  if (isA(a_vformItem, vformItem_NOM))
    {
      adjustLevels(&vformItemSubs_vformItem_NOM, "vformItem_NOM");
      if (log && !findString("vformItem_NOM", vformItemSubs))
	{
	  warnSub("vformItem_NOM", "vformItem", a_vformItem);
	  check_vformItem_NOM(
	    dynamic_cast<vformItem_NOM *>(a_vformItem), 0);
	}
      else
	check_vformItem_NOM(
	  dynamic_cast<vformItem_NOM *>(a_vformItem), log);
      return;
    }
  if (isA(a_vformItem, vformItem_ACT))
    {
      adjustLevels(&vformItemSubs_vformItem_ACT, "vformItem_ACT");
      if (log && !findString("vformItem_ACT", vformItemSubs))
	{
	  warnSub("vformItem_ACT", "vformItem", a_vformItem);
	  check_vformItem_ACT(
	    dynamic_cast<vformItem_ACT *>(a_vformItem), 0);
	}
      else
	check_vformItem_ACT(
	  dynamic_cast<vformItem_ACT *>(a_vformItem), log);
      return;
    }
  if (isA(a_vformItem, vformItem_DEV))
    {
      adjustLevels(&vformItemSubs_vformItem_DEV, "vformItem_DEV");
      if (log && !findString("vformItem_DEV", vformItemSubs))
	{
	  warnSub("vformItem_DEV", "vformItem", a_vformItem);
	  check_vformItem_DEV(
	    dynamic_cast<vformItem_DEV *>(a_vformItem), 0);
	}
      else
	check_vformItem_DEV(
	  dynamic_cast<vformItem_DEV *>(a_vformItem), log);
      return;
    }
  if (isA(a_vformItem, vformItem_AMT))
    {
      adjustLevels(&vformItemSubs_vformItem_AMT, "vformItem_AMT");
      if (log && !findString("vformItem_AMT", vformItemSubs))
	{
	  warnSub("vformItem_AMT", "vformItem", a_vformItem);
	  check_vformItem_AMT(
	    dynamic_cast<vformItem_AMT *>(a_vformItem), 0);
	}
      else
	check_vformItem_AMT(
	  dynamic_cast<vformItem_AMT *>(a_vformItem), log);
      return;
    }
  if (isA(a_vformItem, vformItem_HIST))
    {
      adjustLevels(&vformItemSubs_vformItem_HIST, "vformItem_HIST");
      if (log && !findString("vformItem_HIST", vformItemSubs))
	{
	  warnSub("vformItem_HIST", "vformItem", a_vformItem);
	  check_vformItem_HIST(
	    dynamic_cast<vformItem_HIST *>(a_vformItem), 0);
	}
      else
	check_vformItem_HIST(
	  dynamic_cast<vformItem_HIST *>(a_vformItem), log);
      return;
    }
  if (isA(a_vformItem, vformItem_PLOT))
    {
      adjustLevels(&vformItemSubs_vformItem_PLOT, "vformItem_PLOT");
      if (log && !findString("vformItem_PLOT", vformItemSubs))
	{
	  warnSub("vformItem_PLOT", "vformItem", a_vformItem);
	  check_vformItem_PLOT(
	    dynamic_cast<vformItem_PLOT *>(a_vformItem), 0);
	}
      else
	check_vformItem_PLOT(
	  dynamic_cast<vformItem_PLOT *>(a_vformItem), log);
      return;
    }
  if (isA(a_vformItem, vformItem_STAT))
    {
      adjustLevels(&vformItemSubs_vformItem_STAT, "vformItem_STAT");
      if (log && !findString("vformItem_STAT", vformItemSubs))
	{
	  warnSub("vformItem_STAT", "vformItem", a_vformItem);
	  check_vformItem_STAT(
	    dynamic_cast<vformItem_STAT *>(a_vformItem), 0);
	}
      else
	check_vformItem_STAT(
	  dynamic_cast<vformItem_STAT *>(a_vformItem), log);
      return;
    }
  if (isA(a_vformItem, vformItem_ALL))
    {
      adjustLevels(&vformItemSubs_vformItem_ALL, "vformItem_ALL");
      if (log && !findString("vformItem_ALL", vformItemSubs))
	{
	  warnSub("vformItem_ALL", "vformItem", a_vformItem);
	}
      return;
    }
  if (isA(a_vformItem, vformItem_DME))
    {
      adjustLevels(&vformItemSubs_vformItem_DME, "vformItem_DME");
      if (log && !findString("vformItem_DME", vformItemSubs))
	{
	  warnSub("vformItem_DME", "vformItem", a_vformItem);
	  check_vformItem_DME(
	    dynamic_cast<vformItem_DME *>(a_vformItem), 0);
	}
      else
	check_vformItem_DME(
	  dynamic_cast<vformItem_DME *>(a_vformItem), log);
      return;
    }
}

/********************************************************************/

void check_vformItem_ACT(
 vformItem_ACT * a_vformItem_ACT,
 int log)
{
  if (a_vformItem_ACT->get_text())
    {
      adjustLevels(&vformItem_ACTAtts_text, "vformItem_ACT text");
      if (log && !findString("text", vformItem_ACTAtts))
	{
	  warnAtt("text", "vformItem_ACT", a_vformItem_ACT);
	  check_stringVal(a_vformItem_ACT->get_text(), 0);
	}
      else
	check_stringVal(a_vformItem_ACT->get_text(), log);
    }
}

/********************************************************************/

void check_vformItem_AMT(
 vformItem_AMT * a_vformItem_AMT,
 int log)
{
  if (a_vformItem_AMT->get_text())
    {
      adjustLevels(&vformItem_AMTAtts_text, "vformItem_AMT text");
      if (log && !findString("text", vformItem_AMTAtts))
	{
	  warnAtt("text", "vformItem_AMT", a_vformItem_AMT);
	  check_stringVal(a_vformItem_AMT->get_text(), 0);
	}
      else
	check_stringVal(a_vformItem_AMT->get_text(), log);
    }
}

/********************************************************************/

void check_vformItem_DEV(
 vformItem_DEV * a_vformItem_DEV,
 int log)
{
  if (a_vformItem_DEV->get_text())
    {
      adjustLevels(&vformItem_DEVAtts_text, "vformItem_DEV text");
      if (log && !findString("text", vformItem_DEVAtts))
	{
	  warnAtt("text", "vformItem_DEV", a_vformItem_DEV);
	  check_stringVal(a_vformItem_DEV->get_text(), 0);
	}
      else
	check_stringVal(a_vformItem_DEV->get_text(), log);
    }
}

/********************************************************************/

void check_vformItem_DME(
 vformItem_DME * a_vformItem_DME,
 int log)
{
  if (a_vformItem_DME->get_text())
    {
      adjustLevels(&vformItem_DMEAtts_text, "vformItem_DME text");
      if (log && !findString("text", vformItem_DMEAtts))
	{
	  warnAtt("text", "vformItem_DME", a_vformItem_DME);
	  check_stringVal(a_vformItem_DME->get_text(), 0);
	}
      else
	check_stringVal(a_vformItem_DME->get_text(), log);
    }
}

/********************************************************************/

void check_vformItem_HIST(
 vformItem_HIST * a_vformItem_HIST,
 int log)
{
  if (a_vformItem_HIST->get_text())
    {
      adjustLevels(&vformItem_HISTAtts_text, "vformItem_HIST text");
      if (log && !findString("text", vformItem_HISTAtts))
	{
	  warnAtt("text", "vformItem_HIST", a_vformItem_HIST);
	  check_stringVal(a_vformItem_HIST->get_text(), 0);
	}
      else
	check_stringVal(a_vformItem_HIST->get_text(), log);
    }
}

/********************************************************************/

void check_vformItem_NOM(
 vformItem_NOM * a_vformItem_NOM,
 int log)
{
  if (a_vformItem_NOM->get_text())
    {
      adjustLevels(&vformItem_NOMAtts_text, "vformItem_NOM text");
      if (log && !findString("text", vformItem_NOMAtts))
	{
	  warnAtt("text", "vformItem_NOM", a_vformItem_NOM);
	  check_stringVal(a_vformItem_NOM->get_text(), 0);
	}
      else
	check_stringVal(a_vformItem_NOM->get_text(), log);
    }
}

/********************************************************************/

void check_vformItem_PLOT(
 vformItem_PLOT * a_vformItem_PLOT,
 int log)
{
  if (a_vformItem_PLOT->get_text())
    {
      adjustLevels(&vformItem_PLOTAtts_text, "vformItem_PLOT text");
      if (log && !findString("text", vformItem_PLOTAtts))
	{
	  warnAtt("text", "vformItem_PLOT", a_vformItem_PLOT);
	  check_stringVal(a_vformItem_PLOT->get_text(), 0);
	}
      else
	check_stringVal(a_vformItem_PLOT->get_text(), log);
    }
}

/********************************************************************/

void check_vformItem_STAT(
 vformItem_STAT * a_vformItem_STAT,
 int log)
{
  if (a_vformItem_STAT->get_text())
    {
      adjustLevels(&vformItem_STATAtts_text, "vformItem_STAT text");
      if (log && !findString("text", vformItem_STATAtts))
	{
	  warnAtt("text", "vformItem_STAT", a_vformItem_STAT);
	  check_stringVal(a_vformItem_STAT->get_text(), 0);
	}
      else
	check_stringVal(a_vformItem_STAT->get_text(), log);
    }
}

/********************************************************************/

void check_vformStm(
 vformStm * a_vformStm,
 int log)
{
  if (a_vformStm->get_vLabel())
    {
      adjustLevels(&vformStmAtts_a_vLabel, "vformStm a_vLabel");
      if (log && !findString("a_vLabel", vformStmAtts))
	{
	  warnAtt("a_vLabel", "vformStm", a_vformStm);
	  check_vLabel(a_vformStm->get_vLabel(), 0);
	}
      else
	check_vLabel(a_vformStm->get_vLabel(), log);
    }
  if (a_vformStm->get_vformItemList())
    {
      std::list<vformItem *> * theList;
      std::list<vformItem *>::iterator iter;
      theList = a_vformStm->get_vformItemList();
      adjustLevels(&vformStmAtts_a_vformItemList, "vformStm a_vformItemList");
      if (log && !findString("a_vformItemList", vformStmAtts))
	{
	  warnAtt("a_vformItemList", "vformStm", a_vformStm);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_vformItem(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_vformItem(*iter, log);
	}
    }
}

/********************************************************************/

void check_vlLabel(
 vlLabel * a_vlLabel,
 int log)
{
  if (a_vlLabel->get_labelName())
    {
      adjustLevels(&vlLabelAtts_a_labelName, "vlLabel a_labelName");
      if (log && !findString("a_labelName", vlLabelAtts))
	{
	  warnAtt("a_labelName", "vlLabel", a_vlLabel);
	  check_labelName(a_vlLabel->get_labelName(), 0);
	}
      else
	check_labelName(a_vlLabel->get_labelName(), log);
    }
}

/********************************************************************/

void check_vwLabel(
 vwLabel * a_vwLabel,
 int log)
{
  if (a_vwLabel->get_labelName())
    {
      adjustLevels(&vwLabelAtts_a_labelName, "vwLabel a_labelName");
      if (log && !findString("a_labelName", vwLabelAtts))
	{
	  warnAtt("a_labelName", "vwLabel", a_vwLabel);
	  check_labelName(a_vwLabel->get_labelName(), 0);
	}
      else
	check_labelName(a_vwLabel->get_labelName(), log);
    }
}

/********************************************************************/

void check_windefBox(
 windefBox * a_windefBox,
 int log)
{
  if (a_windefBox->get_impCartPoint())
    {
      adjustLevels(&windefBoxAtts_a_impCartPoint, "windefBox a_impCartPoint");
      if (log && !findString("a_impCartPoint", windefBoxAtts))
	{
	  warnAtt("a_impCartPoint", "windefBox", a_windefBox);
	  check_impCartPoint(a_windefBox->get_impCartPoint(), 0);
	}
      else
	check_impCartPoint(a_windefBox->get_impCartPoint(), log);
    }
  if (a_windefBox->get_dx())
    {
      adjustLevels(&windefBoxAtts_dx, "windefBox dx");
      if (log && !findString("dx", windefBoxAtts))
	{
	  warnAtt("dx", "windefBox", a_windefBox);
	  check_rentVal(a_windefBox->get_dx(), 0);
	}
      else
	check_rentVal(a_windefBox->get_dx(), log);
    }
  if (a_windefBox->get_dy())
    {
      adjustLevels(&windefBoxAtts_dy, "windefBox dy");
      if (log && !findString("dy", windefBoxAtts))
	{
	  warnAtt("dy", "windefBox", a_windefBox);
	  check_rentVal(a_windefBox->get_dy(), 0);
	}
      else
	check_rentVal(a_windefBox->get_dy(), log);
    }
  if (a_windefBox->get_angle())
    {
      adjustLevels(&windefBoxAtts_a_angle, "windefBox a_angle");
      if (log && !findString("a_angle", windefBoxAtts))
	{
	  warnAtt("a_angle", "windefBox", a_windefBox);
	  check_angle(a_windefBox->get_angle(), 0);
	}
      else
	check_angle(a_windefBox->get_angle(), log);
    }
}

/********************************************************************/

void check_windefEdgeln(
 windefEdgeln * a_windefEdgeln,
 int log)
{
  if (a_windefEdgeln->get_impCartPoint())
    {
      adjustLevels(&windefEdgelnAtts_a_impCartPoint,
		   "windefEdgeln a_impCartPoint");
      if (log && !findString("a_impCartPoint", windefEdgelnAtts))
	{
	  warnAtt("a_impCartPoint", "windefEdgeln", a_windefEdgeln);
	  check_impCartPoint(a_windefEdgeln->get_impCartPoint(), 0);
	}
      else
	check_impCartPoint(a_windefEdgeln->get_impCartPoint(), log);
    }
  if (a_windefEdgeln->get_angle())
    {
      adjustLevels(&windefEdgelnAtts_a_angle, "windefEdgeln a_angle");
      if (log && !findString("a_angle", windefEdgelnAtts))
	{
	  warnAtt("a_angle", "windefEdgeln", a_windefEdgeln);
	  check_angle(a_windefEdgeln->get_angle(), 0);
	}
      else
	check_angle(a_windefEdgeln->get_angle(), log);
    }
  if (a_windefEdgeln->get_len())
    {
      adjustLevels(&windefEdgelnAtts_len, "windefEdgeln len");
      if (log && !findString("len", windefEdgelnAtts))
	{
	  warnAtt("len", "windefEdgeln", a_windefEdgeln);
	  check_rentVal(a_windefEdgeln->get_len(), 0);
	}
      else
	check_rentVal(a_windefEdgeln->get_len(), log);
    }
}

/********************************************************************/

void check_windefMinor(
 windefMinor * a_windefMinor,
 int log)
{
  if (isA(a_windefMinor, windefEdgeln))
    {
      adjustLevels(&windefMinorSubs_windefEdgeln, "windefEdgeln");
      if (log && !findString("windefEdgeln", windefMinorSubs))
	{
	  warnSub("windefEdgeln", "windefMinor", a_windefMinor);
	  check_windefEdgeln(
	    dynamic_cast<windefEdgeln *>(a_windefMinor), 0);
	}
      else
	check_windefEdgeln(
	  dynamic_cast<windefEdgeln *>(a_windefMinor), log);
      return;
    }
  if (isA(a_windefMinor, windefBox))
    {
      adjustLevels(&windefMinorSubs_windefBox, "windefBox");
      if (log && !findString("windefBox", windefMinorSubs))
	{
	  warnSub("windefBox", "windefMinor", a_windefMinor);
	  check_windefBox(dynamic_cast<windefBox *>(a_windefMinor), 0);
	}
      else
	check_windefBox(dynamic_cast<windefBox *>(a_windefMinor), log);
      return;
    }
}

/********************************************************************/

void check_windefStm(
 windefStm * a_windefStm,
 int log)
{
  if (a_windefStm->get_vwLabel())
    {
      adjustLevels(&windefStmAtts_a_vwLabel, "windefStm a_vwLabel");
      if (log && !findString("a_vwLabel", windefStmAtts))
	{
	  warnAtt("a_vwLabel", "windefStm", a_windefStm);
	  check_vwLabel(a_windefStm->get_vwLabel(), 0);
	}
      else
	check_vwLabel(a_windefStm->get_vwLabel(), log);
    }
  if (a_windefStm->get_windefMinor())
    {
      adjustLevels(&windefStmAtts_a_windefMinor, "windefStm a_windefMinor");
      if (log && !findString("a_windefMinor", windefStmAtts))
	{
	  warnAtt("a_windefMinor", "windefStm", a_windefStm);
	  check_windefMinor(a_windefStm->get_windefMinor(), 0);
	}
      else
	check_windefMinor(a_windefStm->get_windefMinor(), log);
    }
}

/********************************************************************/

void check_wkplanStm(
 wkplanStm * a_wkplanStm,
 int log)
{
  if (a_wkplanStm->get_plan())
    {
      adjustLevels(&wkplanStmAtts_a_plan, "wkplanStm a_plan");
      if (log && !findString("a_plan", wkplanStmAtts))
	{
	  warnAtt("a_plan", "wkplanStm", a_wkplanStm);
	  check_plan(a_wkplanStm->get_plan(), 0);
	}
      else
	check_plan(a_wkplanStm->get_plan(), log);
    }
}

/********************************************************************/

void check_wristDataDesc(
 wristDataDesc * a_wristDataDesc,
 int log)
{
  if (isA(a_wristDataDesc, wristDataDesc_stringVal))
    {
      adjustLevels(&wristDataDescSubs_wristDataDesc_stringVal,
		   "wristDataDesc_stringVal");
      if (log && !findString("wristDataDesc_stringVal", wristDataDescSubs))
	{
	  warnSub("wristDataDesc_stringVal", "wristDataDesc", a_wristDataDesc);
	  check_wristDataDesc_stringVal(
	    dynamic_cast<wristDataDesc_stringVal *>(a_wristDataDesc), 0);
	}
      else
	check_wristDataDesc_stringVal(
	  dynamic_cast<wristDataDesc_stringVal *>(a_wristDataDesc), log);
      return;
    }
  if (isA(a_wristDataDesc, wristDataDesc_intVal))
    {
      adjustLevels(&wristDataDescSubs_wristDataDesc_intVal,
		   "wristDataDesc_intVal");
      if (log && !findString("wristDataDesc_intVal", wristDataDescSubs))
	{
	  warnSub("wristDataDesc_intVal", "wristDataDesc", a_wristDataDesc);
	  check_wristDataDesc_intVal(
	    dynamic_cast<wristDataDesc_intVal *>(a_wristDataDesc), 0);
	}
      else
	check_wristDataDesc_intVal(
	  dynamic_cast<wristDataDesc_intVal *>(a_wristDataDesc), log);
      return;
    }
}

/********************************************************************/

void check_wristDataDesc_intVal(
 wristDataDesc_intVal * a_wristDataDesc_intVal,
 int log)
{
  if (a_wristDataDesc_intVal->get_dataStor())
    {
      adjustLevels(&wristDataDesc_intValAtts_dataStor,
		   "wristDataDesc_intVal dataStor");
      if (log && !findString("dataStor", wristDataDesc_intValAtts))
	{
	  warnAtt("dataStor", "wristDataDesc_intVal", a_wristDataDesc_intVal);
	  check_stringVal(a_wristDataDesc_intVal->get_dataStor(), 0);
	}
      else
	check_stringVal(a_wristDataDesc_intVal->get_dataStor(), log);
    }
  if (a_wristDataDesc_intVal->get_dataList())
    {
      adjustLevels(&wristDataDesc_intValAtts_dataList,
		   "wristDataDesc_intVal dataList");
      if (log && !findString("dataList", wristDataDesc_intValAtts))
	{
	  warnAtt("dataList", "wristDataDesc_intVal", a_wristDataDesc_intVal);
	  check_stringVal(a_wristDataDesc_intVal->get_dataList(), 0);
	}
      else
	check_stringVal(a_wristDataDesc_intVal->get_dataList(), log);
    }
  if (a_wristDataDesc_intVal->get_index())
    {
      adjustLevels(&wristDataDesc_intValAtts_index,
		   "wristDataDesc_intVal index");
      if (log && !findString("index", wristDataDesc_intValAtts))
	{
	  warnAtt("index", "wristDataDesc_intVal", a_wristDataDesc_intVal);
	  check_intVal(a_wristDataDesc_intVal->get_index(), 0);
	}
      else
	check_intVal(a_wristDataDesc_intVal->get_index(), log);
    }
}

/********************************************************************/

void check_wristDataDesc_stringVal(
 wristDataDesc_stringVal * a_wristDataDesc_stringVal,
 int log)
{
  if (a_wristDataDesc_stringVal->get_dataStor())
    {
      adjustLevels(&wristDataDesc_stringValAtts_dataStor,
		   "wristDataDesc_stringVal dataStor");
      if (log && !findString("dataStor", wristDataDesc_stringValAtts))
	{
	  warnAtt("dataStor", "wristDataDesc_stringVal",
		  a_wristDataDesc_stringVal);
	  check_stringVal(a_wristDataDesc_stringVal->get_dataStor(), 0);
	}
      else
	check_stringVal(a_wristDataDesc_stringVal->get_dataStor(), log);
    }
  if (a_wristDataDesc_stringVal->get_dataList())
    {
      adjustLevels(&wristDataDesc_stringValAtts_dataList,
		   "wristDataDesc_stringVal dataList");
      if (log && !findString("dataList", wristDataDesc_stringValAtts))
	{
	  warnAtt("dataList", "wristDataDesc_stringVal",
		  a_wristDataDesc_stringVal);
	  check_stringVal(a_wristDataDesc_stringVal->get_dataList(), 0);
	}
      else
	check_stringVal(a_wristDataDesc_stringVal->get_dataList(), log);
    }
  if (a_wristDataDesc_stringVal->get_dataItem())
    {
      adjustLevels(&wristDataDesc_stringValAtts_dataItem,
		   "wristDataDesc_stringVal dataItem");
      if (log && !findString("dataItem", wristDataDesc_stringValAtts))
	{
	  warnAtt("dataItem", "wristDataDesc_stringVal",
		  a_wristDataDesc_stringVal);
	  check_stringVal(a_wristDataDesc_stringVal->get_dataItem(), 0);
	}
      else
	check_stringVal(a_wristDataDesc_stringVal->get_dataItem(), log);
    }
}

/********************************************************************/

void check_wristDef(
 wristDef * a_wristDef,
 int log)
{
  if (a_wristDef->get_wristMountDef())
    {
      adjustLevels(&wristDefAtts_a_wristMountDef, "wristDef a_wristMountDef");
      if (log && !findString("a_wristMountDef", wristDefAtts))
	{
	  warnAtt("a_wristMountDef", "wristDef", a_wristDef);
	  check_wristMountDef(a_wristDef->get_wristMountDef(), 0);
	}
      else
	check_wristMountDef(a_wristDef->get_wristMountDef(), log);
    }
  if (a_wristDef->get_wristRotDef())
    {
      adjustLevels(&wristDefAtts_a_wristRotDef, "wristDef a_wristRotDef");
      if (log && !findString("a_wristRotDef", wristDefAtts))
	{
	  warnAtt("a_wristRotDef", "wristDef", a_wristDef);
	  check_wristRotDef(a_wristDef->get_wristRotDef(), 0);
	}
      else
	check_wristRotDef(a_wristDef->get_wristRotDef(), log);
    }
}

/********************************************************************/

void check_wristMountDef(
 wristMountDef * a_wristMountDef,
 int log)
{
  if (a_wristMountDef->get_offset())
    {
      adjustLevels(&wristMountDefAtts_offset, "wristMountDef offset");
      if (log && !findString("offset", wristMountDefAtts))
	{
	  warnAtt("offset", "wristMountDef", a_wristMountDef);
	  check_vector(a_wristMountDef->get_offset(), 0);
	}
      else
	check_vector(a_wristMountDef->get_offset(), log);
    }
  if (a_wristMountDef->get_axisVec())
    {
      adjustLevels(&wristMountDefAtts_axisVec, "wristMountDef axisVec");
      if (log && !findString("axisVec", wristMountDefAtts))
	{
	  warnAtt("axisVec", "wristMountDef", a_wristMountDef);
	  check_vector(a_wristMountDef->get_axisVec(), 0);
	}
      else
	check_vector(a_wristMountDef->get_axisVec(), log);
    }
  if (a_wristMountDef->get_zeroVec())
    {
      adjustLevels(&wristMountDefAtts_zeroVec, "wristMountDef zeroVec");
      if (log && !findString("zeroVec", wristMountDefAtts))
	{
	  warnAtt("zeroVec", "wristMountDef", a_wristMountDef);
	  check_vector(a_wristMountDef->get_zeroVec(), 0);
	}
      else
	check_vector(a_wristMountDef->get_zeroVec(), log);
    }
}

/********************************************************************/

void check_wristMountOffset(
 wristMountOffset * a_wristMountOffset,
 int log)
{
  if (a_wristMountOffset->get_offset())
    {
      adjustLevels(&wristMountOffsetAtts_offset, "wristMountOffset offset");
      if (log && !findString("offset", wristMountOffsetAtts))
	{
	  warnAtt("offset", "wristMountOffset", a_wristMountOffset);
	  check_vector(a_wristMountOffset->get_offset(), 0);
	}
      else
	check_vector(a_wristMountOffset->get_offset(), log);
    }
}

/********************************************************************/

void check_wristRotDef(
 wristRotDef * a_wristRotDef,
 int log)
{
  if (a_wristRotDef->get_anglename())
    {
      adjustLevels(&wristRotDefAtts_anglename, "wristRotDef anglename");
      if (log && !findString("anglename", wristRotDefAtts))
	{
	  warnAtt("anglename", "wristRotDef", a_wristRotDef);
	  check_stringVal(a_wristRotDef->get_anglename(), 0);
	}
      else
	check_stringVal(a_wristRotDef->get_anglename(), log);
    }
  if (a_wristRotDef->get_wristRotLimit())
    {
      adjustLevels(&wristRotDefAtts_a_wristRotLimit,
		   "wristRotDef a_wristRotLimit");
      if (log && !findString("a_wristRotLimit", wristRotDefAtts))
	{
	  warnAtt("a_wristRotLimit", "wristRotDef", a_wristRotDef);
	  check_wristRotLimit(a_wristRotDef->get_wristRotLimit(), 0);
	}
      else
	check_wristRotLimit(a_wristRotDef->get_wristRotLimit(), log);
    }
  if (a_wristRotDef->get_wristRotStep())
    {
      adjustLevels(&wristRotDefAtts_a_wristRotStep,
		   "wristRotDef a_wristRotStep");
      if (log && !findString("a_wristRotStep", wristRotDefAtts))
	{
	  warnAtt("a_wristRotStep", "wristRotDef", a_wristRotDef);
	  check_wristRotStep(a_wristRotDef->get_wristRotStep(), 0);
	}
      else
	check_wristRotStep(a_wristRotDef->get_wristRotStep(), log);
    }
}

/********************************************************************/

void check_wristRotLimit(
 wristRotLimit * a_wristRotLimit,
 int log)
{
  if (isA(a_wristRotLimit, wristRotLimit_angle))
    {
      adjustLevels(&wristRotLimitSubs_wristRotLimit_angle,
		   "wristRotLimit_angle");
      if (log && !findString("wristRotLimit_angle", wristRotLimitSubs))
	{
	  warnSub("wristRotLimit_angle", "wristRotLimit", a_wristRotLimit);
	  check_wristRotLimit_angle(
	    dynamic_cast<wristRotLimit_angle *>(a_wristRotLimit), 0);
	}
      else
	check_wristRotLimit_angle(
	  dynamic_cast<wristRotLimit_angle *>(a_wristRotLimit), log);
      return;
    }
  if (isA(a_wristRotLimit, wristRotLimit_THRU))
    {
      adjustLevels(&wristRotLimitSubs_wristRotLimit_THRU,
		   "wristRotLimit_THRU");
      if (log && !findString("wristRotLimit_THRU", wristRotLimitSubs))
	{
	  warnSub("wristRotLimit_THRU", "wristRotLimit", a_wristRotLimit);
	}
      return;
    }
}

/********************************************************************/

void check_wristRotLimit_angle(
 wristRotLimit_angle * a_wristRotLimit_angle,
 int log)
{
  if (a_wristRotLimit_angle->get_begin())
    {
      adjustLevels(&wristRotLimit_angleAtts_begin,
		   "wristRotLimit_angle begin");
      if (log && !findString("begin", wristRotLimit_angleAtts))
	{
	  warnAtt("begin", "wristRotLimit_angle", a_wristRotLimit_angle);
	  check_angle(a_wristRotLimit_angle->get_begin(), 0);
	}
      else
	check_angle(a_wristRotLimit_angle->get_begin(), log);
    }
  if (a_wristRotLimit_angle->get_end())
    {
      adjustLevels(&wristRotLimit_angleAtts_end, "wristRotLimit_angle end");
      if (log && !findString("end", wristRotLimit_angleAtts))
	{
	  warnAtt("end", "wristRotLimit_angle", a_wristRotLimit_angle);
	  check_angle(a_wristRotLimit_angle->get_end(), 0);
	}
      else
	check_angle(a_wristRotLimit_angle->get_end(), log);
    }
}

/********************************************************************/

void check_wristRotStep(
 wristRotStep * a_wristRotStep,
 int log)
{
  if (isA(a_wristRotStep, wristRotStep_angle))
    {
      adjustLevels(&wristRotStepSubs_wristRotStep_angle, "wristRotStep_angle");
      if (log && !findString("wristRotStep_angle", wristRotStepSubs))
	{
	  warnSub("wristRotStep_angle", "wristRotStep", a_wristRotStep);
	  check_wristRotStep_angle(
	    dynamic_cast<wristRotStep_angle *>(a_wristRotStep), 0);
	}
      else
	check_wristRotStep_angle(
	  dynamic_cast<wristRotStep_angle *>(a_wristRotStep), log);
      return;
    }
  if (isA(a_wristRotStep, wristRotStep_CONTIN))
    {
      adjustLevels(&wristRotStepSubs_wristRotStep_CONTIN,
		   "wristRotStep_CONTIN");
      if (log && !findString("wristRotStep_CONTIN", wristRotStepSubs))
	{
	  warnSub("wristRotStep_CONTIN", "wristRotStep", a_wristRotStep);
	}
      return;
    }
}

/********************************************************************/

void check_wristRotStep_angle(
 wristRotStep_angle * a_wristRotStep_angle,
 int log)
{
  if (a_wristRotStep_angle->get_angle())
    {
      adjustLevels(&wristRotStep_angleAtts_a_angle,
		   "wristRotStep_angle a_angle");
      if (log && !findString("a_angle", wristRotStep_angleAtts))
	{
	  warnAtt("a_angle", "wristRotStep_angle", a_wristRotStep_angle);
	  check_angle(a_wristRotStep_angle->get_angle(), 0);
	}
      else
	check_angle(a_wristRotStep_angle->get_angle(), log);
    }
}

/********************************************************************/

void check_wristStm(
 wristStm * a_wristStm,
 int log)
{
  if (a_wristStm->get_swLabel())
    {
      adjustLevels(&wristStmAtts_a_swLabel, "wristStm a_swLabel");
      if (log && !findString("a_swLabel", wristStmAtts))
	{
	  warnAtt("a_swLabel", "wristStm", a_wristStm);
	  check_swLabel(a_wristStm->get_swLabel(), 0);
	}
      else
	check_swLabel(a_wristStm->get_swLabel(), log);
    }
  if (a_wristStm->get_wristList())
    {
      std::list<wristDef *> * theList;
      std::list<wristDef *>::iterator iter;
      theList = a_wristStm->get_wristList();
      adjustLevels(&wristStmAtts_a_wristList, "wristStm a_wristList");
      if (log && !findString("a_wristList", wristStmAtts))
	{
	  warnAtt("a_wristList", "wristStm", a_wristStm);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_wristDef(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_wristDef(*iter, log);
	}
    }
  if (a_wristStm->get_wristMountOffset())
    {
      adjustLevels(&wristStmAtts_a_wristMountOffset,
		   "wristStm a_wristMountOffset");
      if (log && !findString("a_wristMountOffset", wristStmAtts))
	{
	  warnAtt("a_wristMountOffset", "wristStm", a_wristStm);
	  check_wristMountOffset(a_wristStm->get_wristMountOffset(), 0);
	}
      else
	check_wristMountOffset(a_wristStm->get_wristMountOffset(), log);
    }
  if (a_wristStm->get_wristDataDesc())
    {
      adjustLevels(&wristStmAtts_a_wristDataDesc, "wristStm a_wristDataDesc");
      if (log && !findString("a_wristDataDesc", wristStmAtts))
	{
	  warnAtt("a_wristDataDesc", "wristStm", a_wristStm);
	  check_wristDataDesc(a_wristStm->get_wristDataDesc(), 0);
	}
      else
	check_wristDataDesc(a_wristStm->get_wristDataDesc(), log);
    }
}

/********************************************************************/

void check_writeSpec(
 writeSpec * a_writeSpec,
 int log)
{
  if (isA(a_writeSpec, writeSpec_stringConst))
    {
      adjustLevels(&writeSpecSubs_writeSpec_stringConst,
		   "writeSpec_stringConst");
      if (log && !findString("writeSpec_stringConst", writeSpecSubs))
	{
	  warnSub("writeSpec_stringConst", "writeSpec", a_writeSpec);
	  check_writeSpec_stringConst(
	    dynamic_cast<writeSpec_stringConst *>(a_writeSpec), 0);
	}
      else
	check_writeSpec_stringConst(
	  dynamic_cast<writeSpec_stringConst *>(a_writeSpec), log);
      return;
    }
  if (isA(a_writeSpec, writeSpec_stringFunc))
    {
      adjustLevels(&writeSpecSubs_writeSpec_stringFunc,
		   "writeSpec_stringFunc");
      if (log && !findString("writeSpec_stringFunc", writeSpecSubs))
	{
	  warnSub("writeSpec_stringFunc", "writeSpec", a_writeSpec);
	  check_writeSpec_stringFunc(
	    dynamic_cast<writeSpec_stringFunc *>(a_writeSpec), 0);
	}
      else
	check_writeSpec_stringFunc(
	  dynamic_cast<writeSpec_stringFunc *>(a_writeSpec), log);
      return;
    }
  if (isA(a_writeSpec, writeSpec_rwVar))
    {
      adjustLevels(&writeSpecSubs_writeSpec_rwVar, "writeSpec_rwVar");
      if (log && !findString("writeSpec_rwVar", writeSpecSubs))
	{
	  warnSub("writeSpec_rwVar", "writeSpec", a_writeSpec);
	  check_writeSpec_rwVar(
	    dynamic_cast<writeSpec_rwVar *>(a_writeSpec), 0);
	}
      else
	check_writeSpec_rwVar(
	  dynamic_cast<writeSpec_rwVar *>(a_writeSpec), log);
      return;
    }
}

/********************************************************************/

void check_writeSpec_rwVar(
 writeSpec_rwVar * a_writeSpec_rwVar,
 int log)
{
  if (a_writeSpec_rwVar->get_rwVar())
    {
      adjustLevels(&writeSpec_rwVarAtts_a_rwVar, "writeSpec_rwVar a_rwVar");
      if (log && !findString("a_rwVar", writeSpec_rwVarAtts))
	{
	  warnAtt("a_rwVar", "writeSpec_rwVar", a_writeSpec_rwVar);
	  check_rwVar(a_writeSpec_rwVar->get_rwVar(), 0);
	}
      else
	check_rwVar(a_writeSpec_rwVar->get_rwVar(), log);
    }
  if (a_writeSpec_rwVar->get_rwFormat())
    {
      adjustLevels(&writeSpec_rwVarAtts_a_rwFormat,
		   "writeSpec_rwVar a_rwFormat");
      if (log && !findString("a_rwFormat", writeSpec_rwVarAtts))
	{
	  warnAtt("a_rwFormat", "writeSpec_rwVar", a_writeSpec_rwVar);
	  check_rwFormat(a_writeSpec_rwVar->get_rwFormat(), 0);
	}
      else
	check_rwFormat(a_writeSpec_rwVar->get_rwFormat(), log);
    }
}

/********************************************************************/

void check_writeSpec_stringConst(
 writeSpec_stringConst * a_writeSpec_stringConst,
 int log)
{
  if (a_writeSpec_stringConst->get_stringConst())
    {
      adjustLevels(&writeSpec_stringConstAtts_a_stringConst,
		   "writeSpec_stringConst a_stringConst");
      if (log && !findString("a_stringConst", writeSpec_stringConstAtts))
	{
	  warnAtt("a_stringConst", "writeSpec_stringConst",
		  a_writeSpec_stringConst);
	  check_stringConst(a_writeSpec_stringConst->get_stringConst(), 0);
	}
      else
	check_stringConst(a_writeSpec_stringConst->get_stringConst(), log);
    }
}

/********************************************************************/

void check_writeSpec_stringFunc(
 writeSpec_stringFunc * a_writeSpec_stringFunc,
 int log)
{
  if (a_writeSpec_stringFunc->get_stringFunc())
    {
      adjustLevels(&writeSpec_stringFuncAtts_a_stringFunc,
		   "writeSpec_stringFunc a_stringFunc");
      if (log && !findString("a_stringFunc", writeSpec_stringFuncAtts))
	{
	  warnAtt("a_stringFunc", "writeSpec_stringFunc",
		  a_writeSpec_stringFunc);
	  check_stringFunc(a_writeSpec_stringFunc->get_stringFunc(), 0);
	}
      else
	check_stringFunc(a_writeSpec_stringFunc->get_stringFunc(), log);
    }
}

/********************************************************************/

void check_writeStm(
 writeStm * a_writeStm,
 int log)
{
  if (a_writeStm->get_didLabel())
    {
      adjustLevels(&writeStmAtts_a_didLabel, "writeStm a_didLabel");
      if (log && !findString("a_didLabel", writeStmAtts))
	{
	  warnAtt("a_didLabel", "writeStm", a_writeStm);
	  check_didLabel(a_writeStm->get_didLabel(), 0);
	}
      else
	check_didLabel(a_writeStm->get_didLabel(), log);
    }
  if (a_writeStm->get_writeSpecList())
    {
      std::list<writeSpec *> * theList;
      std::list<writeSpec *>::iterator iter;
      theList = a_writeStm->get_writeSpecList();
      adjustLevels(&writeStmAtts_a_writeSpecList, "writeStm a_writeSpecList");
      if (log && !findString("a_writeSpecList", writeStmAtts))
	{
	  warnAtt("a_writeSpecList", "writeStm", a_writeStm);
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_writeSpec(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_writeSpec(*iter, log);
	}
    }
}

/********************************************************************/

void check_xternBlock(
 xternBlock * a_xternBlock,
 int log)
{
  if (a_xternBlock->get_xternStm())
    {
      adjustLevels(&xternBlockAtts_a_xternStm, "xternBlock a_xternStm");
      if (log && !findString("a_xternStm", xternBlockAtts))
	{
	  warnAttBlock("xternStm", a_xternBlock->get_xternStm());
	}
    }
  if (a_xternBlock->get_extfilList())
    {
      std::list<extfilStm *> * theList;
      std::list<extfilStm *>::iterator iter;
      theList = a_xternBlock->get_extfilList();
      adjustLevels(&xternBlockAtts_a_extfilList, "xternBlock a_extfilList");
      if (log && !findString("a_extfilList", xternBlockAtts))
	{
	  warnAttBlock("extfilList",
	    a_xternBlock->get_extfilList()->front());
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_extfilStm(*iter, 0);
	}
      else
	{
	  for (iter = theList->begin(); iter != theList->end(); iter++)
	    check_extfilStm(*iter, log);
	}
    }
  if (a_xternBlock->get_endxtnStm())
    {
      adjustLevels(&xternBlockAtts_a_endxtnStm, "xternBlock a_endxtnStm");
      if (log && !findString("a_endxtnStm", xternBlockAtts))
	{
	  warnAttBlock("endxtnStm", a_xternBlock->get_endxtnStm());
	}
    }
}

/********************************************************************/

void check_xtractStm(
 xtractStm * a_xtractStm,
 int log)
{
  if (a_xtractStm->get_fLabel())
    {
      adjustLevels(&xtractStmAtts_a_fLabel, "xtractStm a_fLabel");
      if (log && !findString("a_fLabel", xtractStmAtts))
	{
	  warnAtt("a_fLabel", "xtractStm", a_xtractStm);
	  check_fLabel(a_xtractStm->get_fLabel(), 0);
	}
      else
	check_fLabel(a_xtractStm->get_fLabel(), log);
    }
  if (a_xtractStm->get_faLabel())
    {
      adjustLevels(&xtractStmAtts_a_faLabel, "xtractStm a_faLabel");
      if (log && !findString("a_faLabel", xtractStmAtts))
	{
	  warnAtt("a_faLabel", "xtractStm", a_xtractStm);
	  check_faLabel(a_xtractStm->get_faLabel(), 0);
	}
      else
	check_faLabel(a_xtractStm->get_faLabel(), log);
    }
}

/********************************************************************/

} // namespace NDTU

/********************************************************************/

#include "assignModuleSubAtts.cc"

/********************************************************************/

#include "assignMasterSubAtts.cc"

/********************************************************************/

