/************************************************************************
  DISCLAIMER:
  This software was produced by the National Institute of Standards
  and Technology (NIST), an agency of the U.S. government, and by statute
  is not subject to copyright in the United States.  Recipients of this
  software assume all responsibility associated with its operation,
  modification, maintenance, and subsequent redistribution.

  See NIST Administration Manual 4.09.07 b and Appendix I.
************************************************************************/

#include "dmisConformanceCheckerStart.cc"

namespace NDTU {

int aclratStms;
int algdefStms;
int assignStms;
int badtstStms;
int boundStms;
int calibMasterStms;
int calibRtabStms;
int calibSensStms;
int callStms;
int caseStms;
int clmpidStms;
int clmpsnStms;
int closeStms;
int cmpntgrpStms;
int cnfrmrulStms;
int constStms;
int crgdefStms;
int crmodeStms;
int crosclStms;
int crslctStms;
int cutcomStms;
int czoneStms;
int czslctStms;
int datdefStms;
int datsetStms;
int dattrgdefStms;
int declStms;
int decplStms;
int deleteStms;
int deviceStms;
int dftcasStms;
int displyStms;
int dmehwStms;
int dmeidStms;
int dmeswStms;
int dmeswiStms;
int dmeswvStms;
int dmisOffStms;
int dmisOnStms;
int dmismdStms;
int dmismnStms;
int doStms;
int elseStms;
int endcasStms;
int enddoStms;
int endfilStms;
int endgoStms;
int endifStms;
int endmacStms;
int endmesStms;
int endselStms;
int endsimreqtStms;
int endxtnStms;
int equateStms;
int errorStms;
int evalStms;
int extensStms;
int extfilStms;
int featArc1Stms;
int featArc2Stms;
int featCircleStms;
int featCompoundStms;
int featConeStms;
int featConradsegStms;
int featCparlnStms;
int featCylndrStms;
int featCylradsegStms;
int featEdgeptStms;
int featEllipsStms;
int featElongcylStms;
int featGcurveStms;
int featGeomStms;
int featGsurfStms;
int featLineStms;
int featObjectStms;
int featParplnStms;
int featPaternStms;
int featPlaneStms;
int featPointStms;
int featRctnglStms;
int featRevsurfStms;
int featSphereStms;
int featSphradsegStms;
int featSymplnStms;
int featTorradsegStms;
int featTorusStms;
int fedratStms;
int fildefStms;
int filnamStms;
int finposStms;
int fixtidStms;
int fixtsnStms;
int flyStms;
int fromStms;
int geoalgStms;
int geomStms;
int gohomeStms;
int gotargStms;
int gotoStms;
int groupStms;
int ifStms;
int includStms;
int iteratStms;
int jumpStms;
int jumptoStms;
int keycharStms;
int litdefStms;
int locateStms;
int lotidStms;
int macroStms;
int matdefStms;
int measStms;
int mfgdevStms;
int modeStms;
int obtainStms;
int openStms;
int operidStms;
int outputStms;
int pameasStms;
int partidStms;
int partrvStms;
int partsnStms;
int pathStms;
int planidStms;
int popStms;
int prcompStms;
int prevopStms;
int procidStms;
int promptStms;
int psthruStms;
int ptbuffStms;
int ptmeasStms;
int pushStms;
int qisdefStms;
int rapidStms;
int readStms;
int recallDMLStms;
int recallDatumStms;
int recallFeatureStms;
int recallRotaryTableStms;
int recallSensorStms;
int refmntStms;
int reportStms;
int resumeStms;
int rmeasStms;
int rotabStms;
int rotateStms;
int rotdefStms;
int rotsetStms;
int saveDMLStms;
int saveDatumStms;
int saveFeatureStms;
int saveRotaryTableStms;
int saveSensorStms;
int scnmodStms;
int scnsetStms;
int selectStms;
int sensorStms;
int simreqtStms;
int snsdefStms;
int snsetStms;
int snsgrpStms;
int snslctStms;
int snsmntStms;
int tecompStms;
int textStms;
int thldefStms;
int tolAnglStms;
int tolAnglbStms;
int tolAnglrStms;
int tolAnglwrtStms;
int tolCirltyStms;
int tolComposStms;
int tolConcenStms;
int tolCortolStms;
int tolCproflStms;
int tolCprofsStms;
int tolCrnoutStms;
int tolCylctyStms;
int tolDiamStms;
int tolDistbStms;
int tolDistwrtStms;
int tolFlatStms;
int tolGtolStms;
int tolParlelStms;
int tolPerpStms;
int tolPosStms;
int tolProflStms;
int tolProfpStms;
int tolProfsStms;
int tolRadStms;
int tolStrghtStms;
int tolSymStms;
int tolTrnoutStms;
int tolUsetolStms;
int tolWidthStms;
int tooldfStms;
int transStms;
int uncertalgStms;
int uncertsetStms;
int unitsStms;
int valueStms;
int vformStms;
int windefStms;
int wkplanStms;
int wristStms;
int writeStms;
int xternStms;
int xtractStms;
void check_aboveBelow(aboveBelow * a_aboveBelow);
void check_aclratAngSpec(aclratAngSpec * a_aclratAngSpec);
void check_aclratAngular(aclratAngular * a_aclratAngular);
void check_aclratDef(aclratDef * a_aclratDef);
void check_aclratDef_PCENT(aclratDef_PCENT * a_aclratDef_PCENT);
void check_aclratHedMeas(aclratHedMeas * a_aclratHedMeas);
void check_aclratHedRot(aclratHedRot * a_aclratHedRot);
void check_aclratHedScan(aclratHedScan * a_aclratHedScan);
void check_aclratLinSpec(aclratLinSpec * a_aclratLinSpec);
void check_aclratLinear(aclratLinear * a_aclratLinear);
void check_aclratLinear_IPMM(aclratLinear_IPMM * a_aclratLinear_IPMM);
void check_aclratLinear_IPSS(aclratLinear_IPSS * a_aclratLinear_IPSS);
void check_aclratLinear_MMPSS(aclratLinear_MMPSS * a_aclratLinear_MMPSS);
void check_aclratLinear_MPMM(aclratLinear_MPMM * a_aclratLinear_MPMM);
void check_aclratMeas(aclratMeas * a_aclratMeas);
void check_aclratMinor(aclratMinor * a_aclratMinor);
void check_aclratPos(aclratPos * a_aclratPos);
void check_aclratRot(aclratRot * a_aclratRot);
void check_aclratScan(aclratScan * a_aclratScan);
void check_aclratStm(aclratStm * a_aclratStm);
void check_algdefMinor(algdefMinor * a_algdefMinor);
void check_algdefMinor_CODE(algdefMinor_CODE * a_algdefMinor_CODE);
void check_algdefMinor_stringVal(algdefMinor_stringVal * a_algdefMinor_stringVal);
void check_algdefStm(algdefStm * a_algdefStm);
void check_angle(angle * a_angle);
void check_angleDms(angleDms * a_angleDms);
void check_angleUnit(angleUnit * a_angleUnit);
void check_anyVal(anyVal * a_anyVal);
void check_arrayIndex(arrayIndex * a_arrayIndex);
void check_assignBool(assignBool * a_assignBool);
void check_assignInt(assignInt * a_assignInt);
void check_assignReal(assignReal * a_assignReal);
void check_assignStm(assignStm * a_assignStm);
void check_assignStm_assignBool(assignStm_assignBool * a_assignStm_assignBool);
void check_assignStm_assignInt(assignStm_assignInt * a_assignStm_assignInt);
void check_assignStm_assignReal(assignStm_assignReal * a_assignStm_assignReal);
void check_assignStm_assignString(assignStm_assignString * a_assignStm_assignString);
void check_assignStm_assignVector(assignStm_assignVector * a_assignStm_assignVector);
void check_assignString(assignString * a_assignString);
void check_assignVector(assignVector * a_assignVector);
void check_avgMaxMin(avgMaxMin * a_avgMaxMin);
void check_axial(axial * a_axial);
void check_axis(axis * a_axis);
void check_badtstStm(badtstStm * a_badtstStm);
void check_bfConst(bfConst * a_bfConst);
void check_bfConst_featureList(bfConst_featureList * a_bfConst_featureList);
void check_bfConst_indexedFeatureList(bfConst_indexedFeatureList * a_bfConst_indexedFeatureList);
void check_boolConst(boolConst * a_boolConst);
void check_boolExpr(boolExpr * a_boolExpr);
void check_boolExpr_PAREN(boolExpr_PAREN * a_boolExpr_PAREN);
void check_boolExpr_boolRel(boolExpr_boolRel * a_boolExpr_boolRel);
void check_boolExpr_intRel(boolExpr_intRel * a_boolExpr_intRel);
void check_boolExpr_realRel(boolExpr_realRel * a_boolExpr_realRel);
void check_boolExpr_stringRel(boolExpr_stringRel * a_boolExpr_stringRel);
void check_boolExpr_vectorRel(boolExpr_vectorRel * a_boolExpr_vectorRel);
void check_boolFunc(boolFunc * a_boolFunc);
void check_boolFuncEof(boolFuncEof * a_boolFuncEof);
void check_boolFuncEoln(boolFuncEoln * a_boolFuncEoln);
void check_boolFuncExist(boolFuncExist * a_boolFuncExist);
void check_boolFuncExist_dLabel(boolFuncExist_dLabel * a_boolFuncExist_dLabel);
void check_boolFuncExist_daLabel(boolFuncExist_daLabel * a_boolFuncExist_daLabel);
void check_boolFuncExist_didLabel(boolFuncExist_didLabel * a_boolFuncExist_didLabel);
void check_boolFuncExist_fLabel(boolFuncExist_fLabel * a_boolFuncExist_fLabel);
void check_boolFuncExist_faLabel(boolFuncExist_faLabel * a_boolFuncExist_faLabel);
void check_boolFuncExist_sLabel(boolFuncExist_sLabel * a_boolFuncExist_sLabel);
void check_boolFuncExist_saLabel(boolFuncExist_saLabel * a_boolFuncExist_saLabel);
void check_boolRel(boolRel * a_boolRel);
void check_boolRel_AND(boolRel_AND * a_boolRel_AND);
void check_boolRel_EQ(boolRel_EQ * a_boolRel_EQ);
void check_boolRel_NE(boolRel_NE * a_boolRel_NE);
void check_boolRel_NOT(boolRel_NOT * a_boolRel_NOT);
void check_boolRel_OR(boolRel_OR * a_boolRel_OR);
void check_boolVal(boolVal * a_boolVal);
void check_boolVar(boolVar * a_boolVar);
void check_boundFeat(boundFeat * a_boundFeat);
void check_boundMinor(boundMinor * a_boundMinor);
void check_boundStm(boundStm * a_boundStm);
void check_boundTol(boundTol * a_boundTol);
void check_cadfileType(cadfileType * a_cadfileType);
void check_cadfileType_VENDOR(cadfileType_VENDOR * a_cadfileType_VENDOR);
void check_calibMasterBlock(calibMasterBlock * a_calibMasterBlock);
void check_calibMasterMinor(calibMasterMinor * a_calibMasterMinor);
void check_calibMasterStm(calibMasterStm * a_calibMasterStm);
void check_calibRtabBlock(calibRtabBlock * a_calibRtabBlock);
void check_calibRtabMinor(calibRtabMinor * a_calibRtabMinor);
void check_calibRtabMinorSpec(calibRtabMinorSpec * a_calibRtabMinorSpec);
void check_calibRtabSpec(calibRtabSpec * a_calibRtabSpec);
void check_calibRtabSpec_fLabel(calibRtabSpec_fLabel * a_calibRtabSpec_fLabel);
void check_calibRtabSpec_faLabel(calibRtabSpec_faLabel * a_calibRtabSpec_faLabel);
void check_calibRtabStm(calibRtabStm * a_calibRtabStm);
void check_calibSensBlock(calibSensBlock * a_calibSensBlock);
void check_calibSensBlockItem(calibSensBlockItem * a_calibSensBlockItem);
void check_calibSensBlockStatement(calibSensBlockStatement * a_calibSensBlockStatement);
void check_calibSensCaseBlock(calibSensCaseBlock * a_calibSensCaseBlock);
void check_calibSensDefaultCaseBlock(calibSensDefaultCaseBlock * a_calibSensDefaultCaseBlock);
void check_calibSensDoBlock(calibSensDoBlock * a_calibSensDoBlock);
void check_calibSensIfBlock(calibSensIfBlock * a_calibSensIfBlock);
void check_calibSensMinor(calibSensMinor * a_calibSensMinor);
void check_calibSensMinorSpec(calibSensMinorSpec * a_calibSensMinorSpec);
void check_calibSensSelectBlock(calibSensSelectBlock * a_calibSensSelectBlock);
void check_calibSensSpec(calibSensSpec * a_calibSensSpec);
void check_calibSensSpecInt(calibSensSpecInt * a_calibSensSpecInt);
void check_calibSensSpecString(calibSensSpecString * a_calibSensSpecString);
void check_calibSensStm(calibSensStm * a_calibSensStm);
void check_callBlock(callBlock * a_callBlock);
void check_callMacro(callMacro * a_callMacro);
void check_callMinor(callMinor * a_callMinor);
void check_callModule(callModule * a_callModule);
void check_callProgram(callProgram * a_callProgram);
void check_callRoutine(callRoutine * a_callRoutine);
void check_callStm(callStm * a_callStm);
void check_callType(callType * a_callType);
void check_cartPoint(cartPoint * a_cartPoint);
void check_caseBlock(caseBlock * a_caseBlock);
void check_caseStm(caseStm * a_caseStm);
void check_caseStmInt(caseStmInt * a_caseStmInt);
void check_caseStmString(caseStmString * a_caseStmString);
void check_ccLabel(ccLabel * a_ccLabel);
void check_ciLabel(ciLabel * a_ciLabel);
void check_clmpidStm(clmpidStm * a_clmpidStm);
void check_clmpsnStm(clmpsnStm * a_clmpsnStm);
void check_closeDelete(closeDelete * a_closeDelete);
void check_closeEnd(closeEnd * a_closeEnd);
void check_closeKeep(closeKeep * a_closeKeep);
void check_closeMinor(closeMinor * a_closeMinor);
void check_closePlain(closePlain * a_closePlain);
void check_closeStm(closeStm * a_closeStm);
void check_cmpntgrpSpec(cmpntgrpSpec * a_cmpntgrpSpec);
void check_cmpntgrpStm(cmpntgrpStm * a_cmpntgrpStm);
void check_cnfrmrulCode(cnfrmrulCode * a_cnfrmrulCode);
void check_cnfrmrulMinor(cnfrmrulMinor * a_cnfrmrulMinor);
void check_cnfrmrulName(cnfrmrulName * a_cnfrmrulName);
void check_cnfrmrulStm(cnfrmrulStm * a_cnfrmrulStm);
void check_cogConst(cogConst * a_cogConst);
void check_coneConst(coneConst * a_coneConst);
void check_coneConst_DIAM(coneConst_DIAM * a_coneConst_DIAM);
void check_coneConst_DIST(coneConst_DIST * a_coneConst_DIST);
void check_conformItem(conformItem * a_conformItem);
void check_conformType(conformType * a_conformType);
void check_constArc(constArc * a_constArc);
void check_constArc_bfConst(constArc_bfConst * a_constArc_bfConst);
void check_constArc_projctConst(constArc_projctConst * a_constArc_projctConst);
void check_constArc_trConst(constArc_trConst * a_constArc_trConst);
void check_constCircle(constCircle * a_constCircle);
void check_constCircle_bfConst(constCircle_bfConst * a_constCircle_bfConst);
void check_constCircle_coneConst(constCircle_coneConst * a_constCircle_coneConst);
void check_constCircle_intofConst(constCircle_intofConst * a_constCircle_intofConst);
void check_constCircle_projctConst(constCircle_projctConst * a_constCircle_projctConst);
void check_constCircle_retrieve2(constCircle_retrieve2 * a_constCircle_retrieve2);
void check_constCircle_tantoConst(constCircle_tantoConst * a_constCircle_tantoConst);
void check_constCircle_trConst(constCircle_trConst * a_constCircle_trConst);
void check_constCompound(constCompound * a_constCompound);
void check_constCone(constCone * a_constCone);
void check_constCone_bfConst(constCone_bfConst * a_constCone_bfConst);
void check_constCone_trConst(constCone_trConst * a_constCone_trConst);
void check_constCparln(constCparln * a_constCparln);
void check_constCparln_bfConst(constCparln_bfConst * a_constCparln_bfConst);
void check_constCparln_projctConst(constCparln_projctConst * a_constCparln_projctConst);
void check_constCparln_retrieve2(constCparln_retrieve2 * a_constCparln_retrieve2);
void check_constCparln_trConst(constCparln_trConst * a_constCparln_trConst);
void check_constCylndr(constCylndr * a_constCylndr);
void check_constCylndr_bfConst(constCylndr_bfConst * a_constCylndr_bfConst);
void check_constCylndr_retrieve1(constCylndr_retrieve1 * a_constCylndr_retrieve1);
void check_constCylndr_trConst(constCylndr_trConst * a_constCylndr_trConst);
void check_constEdgept(constEdgept * a_constEdgept);
void check_constEllips(constEllips * a_constEllips);
void check_constEllips_bfConst(constEllips_bfConst * a_constEllips_bfConst);
void check_constEllips_intofConst(constEllips_intofConst * a_constEllips_intofConst);
void check_constEllips_projctConst(constEllips_projctConst * a_constEllips_projctConst);
void check_constEllips_trConst(constEllips_trConst * a_constEllips_trConst);
void check_constGcurve(constGcurve * a_constGcurve);
void check_constGcurve_bfConst(constGcurve_bfConst * a_constGcurve_bfConst);
void check_constGcurve_projctConst(constGcurve_projctConst * a_constGcurve_projctConst);
void check_constGcurve_trConst(constGcurve_trConst * a_constGcurve_trConst);
void check_constGeom(constGeom * a_constGeom);
void check_constGsurf(constGsurf * a_constGsurf);
void check_constGsurf_bfConst(constGsurf_bfConst * a_constGsurf_bfConst);
void check_constGsurf_trConst(constGsurf_trConst * a_constGsurf_trConst);
void check_constLine(constLine * a_constLine);
void check_constLine_bfConst(constLine_bfConst * a_constLine_bfConst);
void check_constLine_intofConst(constLine_intofConst * a_constLine_intofConst);
void check_constLine_midliConst(constLine_midliConst * a_constLine_midliConst);
void check_constLine_offsetConst(constLine_offsetConst * a_constLine_offsetConst);
void check_constLine_partoConst(constLine_partoConst * a_constLine_partoConst);
void check_constLine_perptoConst(constLine_perptoConst * a_constLine_perptoConst);
void check_constLine_projliConst(constLine_projliConst * a_constLine_projliConst);
void check_constLine_tantoConst(constLine_tantoConst * a_constLine_tantoConst);
void check_constLine_trConst(constLine_trConst * a_constLine_trConst);
void check_constMinor(constMinor * a_constMinor);
void check_constParpln(constParpln * a_constParpln);
void check_constPatern(constPatern * a_constPatern);
void check_constPatern_BUILD(constPatern_BUILD * a_constPatern_BUILD);
void check_constPatern_trConst(constPatern_trConst * a_constPatern_trConst);
void check_constPlane(constPlane * a_constPlane);
void check_constPlane_bfConst(constPlane_bfConst * a_constPlane_bfConst);
void check_constPlane_midplConst(constPlane_midplConst * a_constPlane_midplConst);
void check_constPlane_offsetConst(constPlane_offsetConst * a_constPlane_offsetConst);
void check_constPlane_partoConst(constPlane_partoConst * a_constPlane_partoConst);
void check_constPlane_perptoConst(constPlane_perptoConst * a_constPlane_perptoConst);
void check_constPlane_tantoConstPlane(constPlane_tantoConstPlane * a_constPlane_tantoConstPlane);
void check_constPlane_trConst(constPlane_trConst * a_constPlane_trConst);
void check_constPoint(constPoint * a_constPoint);
void check_constPoint_cogConst(constPoint_cogConst * a_constPoint_cogConst);
void check_constPoint_curveConst(constPoint_curveConst * a_constPoint_curveConst);
void check_constPoint_extremConst(constPoint_extremConst * a_constPoint_extremConst);
void check_constPoint_intofConst(constPoint_intofConst * a_constPoint_intofConst);
void check_constPoint_midptConst(constPoint_midptConst * a_constPoint_midptConst);
void check_constPoint_moveptConst(constPoint_moveptConst * a_constPoint_moveptConst);
void check_constPoint_pierceConst(constPoint_pierceConst * a_constPoint_pierceConst);
void check_constPoint_projptConst(constPoint_projptConst * a_constPoint_projptConst);
void check_constPoint_retrieve1(constPoint_retrieve1 * a_constPoint_retrieve1);
void check_constPoint_trConst(constPoint_trConst * a_constPoint_trConst);
void check_constPoint_vertexConst(constPoint_vertexConst * a_constPoint_vertexConst);
void check_constRctngl(constRctngl * a_constRctngl);
void check_constRctngl_bfConst(constRctngl_bfConst * a_constRctngl_bfConst);
void check_constRctngl_trConst(constRctngl_trConst * a_constRctngl_trConst);
void check_constSgage(constSgage * a_constSgage);
void check_constSpart(constSpart * a_constSpart);
void check_constSphere(constSphere * a_constSphere);
void check_constSphere_bfConst(constSphere_bfConst * a_constSphere_bfConst);
void check_constSphere_retrieve2b(constSphere_retrieve2b * a_constSphere_retrieve2b);
void check_constSphere_trConst(constSphere_trConst * a_constSphere_trConst);
void check_constStm(constStm * a_constStm);
void check_constSympln(constSympln * a_constSympln);
void check_constTorus(constTorus * a_constTorus);
void check_constTorus_bfConst(constTorus_bfConst * a_constTorus_bfConst);
void check_constTorus_trConst(constTorus_trConst * a_constTorus_trConst);
void check_coordType(coordType * a_coordType);
void check_crLabel(crLabel * a_crLabel);
void check_crLabelConst(crLabelConst * a_crLabelConst);
void check_crgdefData(crgdefData * a_crgdefData);
void check_crgdefMinor(crgdefMinor * a_crgdefMinor);
void check_crgdefStm(crgdefStm * a_crgdefStm);
void check_criticality(criticality * a_criticality);
void check_crmodeMinor(crmodeMinor * a_crmodeMinor);
void check_crmodeStm(crmodeStm * a_crmodeStm);
void check_crosclStm(crosclStm * a_crosclStm);
void check_crslctMinor(crslctMinor * a_crslctMinor);
void check_crslctMinor_crLabelConst(crslctMinor_crLabelConst * a_crslctMinor_crLabelConst);
void check_crslctStm(crslctStm * a_crslctStm);
void check_csLabel(csLabel * a_csLabel);
void check_csSpec(csSpec * a_csSpec);
void check_csSpec_HEADCS(csSpec_HEADCS * a_csSpec_HEADCS);
void check_csSpec_PCS(csSpec_PCS * a_csSpec_PCS);
void check_curveConst(curveConst * a_curveConst);
void check_curvePtdataHeadcs(curvePtdataHeadcs * a_curvePtdataHeadcs);
void check_curvePtdataHeadcsListItem(curvePtdataHeadcsListItem * a_curvePtdataHeadcsListItem);
void check_curvePtdataPcs(curvePtdataPcs * a_curvePtdataPcs);
void check_curvePtdataPcsListItem(curvePtdataPcsListItem * a_curvePtdataPcsListItem);
void check_cutcomAdjust(cutcomAdjust * a_cutcomAdjust);
void check_cutcomMatrix(cutcomMatrix * a_cutcomMatrix);
void check_cutcomMatx(cutcomMatx * a_cutcomMatx);
void check_cutcomMinor(cutcomMinor * a_cutcomMinor);
void check_cutcomParam(cutcomParam * a_cutcomParam);
void check_cutcomStm(cutcomStm * a_cutcomStm);
void check_cutcomUserdf(cutcomUserdf * a_cutcomUserdf);
void check_czLabel(czLabel * a_czLabel);
void check_czoneStm(czoneStm * a_czoneStm);
void check_czslctStm(czslctStm * a_czslctStm);
void check_dLabel(dLabel * a_dLabel);
void check_daLabel(daLabel * a_daLabel);
void check_datLabel(datLabel * a_datLabel);
void check_datdefMinor(datdefMinor * a_datdefMinor);
void check_datdefMinor_dattrgList(datdefMinor_dattrgList * a_datdefMinor_dattrgList);
void check_datdefMinor_featureLabel1(datdefMinor_featureLabel1 * a_datdefMinor_featureLabel1);
void check_datdefStm(datdefStm * a_datdefStm);
void check_datsetDats(datsetDats * a_datsetDats);
void check_datsetDrf(datsetDrf * a_datsetDrf);
void check_datsetMatrix(datsetMatrix * a_datsetMatrix);
void check_datsetMinor(datsetMinor * a_datsetMinor);
void check_datsetSpec(datsetSpec * a_datsetSpec);
void check_datsetSpecDir(datsetSpecDir * a_datsetSpecDir);
void check_datsetSpecNoDir(datsetSpecNoDir * a_datsetSpecNoDir);
void check_datsetStm(datsetStm * a_datsetStm);
void check_dattrgLabel(dattrgLabel * a_dattrgLabel);
void check_dattrgMinor(dattrgMinor * a_dattrgMinor);
void check_dattrgdefStm(dattrgdefStm * a_dattrgdefStm);
void check_datumLabel(datumLabel * a_datumLabel);
void check_datumLabel1(datumLabel1 * a_datumLabel1);
void check_datumLabel2(datumLabel2 * a_datumLabel2);
void check_declMinor(declMinor * a_declMinor);
void check_declScope(declScope * a_declScope);
void check_declStm(declStm * a_declStm);
void check_declType(declType * a_declType);
void check_declType_CHAR(declType_CHAR * a_declType_CHAR);
void check_declVar(declVar * a_declVar);
void check_decplAll(decplAll * a_decplAll);
void check_decplMinor(decplMinor * a_decplMinor);
void check_decplMinor_decplAll(decplMinor_decplAll * a_decplMinor_decplAll);
void check_decplMinor_decplList(decplMinor_decplList * a_decplMinor_decplList);
void check_decplNdigits(decplNdigits * a_decplNdigits);
void check_decplNdigits_intVal(decplNdigits_intVal * a_decplNdigits_intVal);
void check_decplSelection(decplSelection * a_decplSelection);
void check_decplSelection_ANGLE(decplSelection_ANGLE * a_decplSelection_ANGLE);
void check_decplSelection_DEV(decplSelection_DEV * a_decplSelection_DEV);
void check_decplSelection_DIST(decplSelection_DIST * a_decplSelection_DIST);
void check_decplSelection_HUMID(decplSelection_HUMID * a_decplSelection_HUMID);
void check_decplSelection_TEMP(decplSelection_TEMP * a_decplSelection_TEMP);
void check_decplSelection_VEC(decplSelection_VEC * a_decplSelection_VEC);
void check_decplStm(decplStm * a_decplStm);
void check_defaultCaseBlock(defaultCaseBlock * a_defaultCaseBlock);
void check_deleteAllSensors(deleteAllSensors * a_deleteAllSensors);
void check_deleteDatum(deleteDatum * a_deleteDatum);
void check_deleteFeature(deleteFeature * a_deleteFeature);
void check_deleteMinor(deleteMinor * a_deleteMinor);
void check_deleteRotaryTable(deleteRotaryTable * a_deleteRotaryTable);
void check_deleteSensor(deleteSensor * a_deleteSensor);
void check_deleteStm(deleteStm * a_deleteStm);
void check_device(device * a_device);
void check_deviceMinor(deviceMinor * a_deviceMinor);
void check_deviceMinor_INCR(deviceMinor_INCR * a_deviceMinor_INCR);
void check_deviceMinor_device(deviceMinor_device * a_deviceMinor_device);
void check_deviceStm(deviceStm * a_deviceStm);
void check_diLabel(diLabel * a_diLabel);
void check_didLabel(didLabel * a_didLabel);
void check_dir(dir * a_dir);
void check_displyItemDMIS(displyItemDMIS * a_displyItemDMIS);
void check_displyItemNoDMIS(displyItemNoDMIS * a_displyItemNoDMIS);
void check_displySpecItem(displySpecItem * a_displySpecItem);
void check_displyStm(displyStm * a_displyStm);
void check_displyStmOff(displyStmOff * a_displyStmOff);
void check_displyStmSpec(displyStmSpec * a_displyStmSpec);
void check_dmehwMinor(dmehwMinor * a_dmehwMinor);
void check_dmehwMinor_jointConf(dmehwMinor_jointConf * a_dmehwMinor_jointConf);
void check_dmehwStm(dmehwStm * a_dmehwStm);
void check_dmeidStm(dmeidStm * a_dmeidStm);
void check_dmeswComand(dmeswComand * a_dmeswComand);
void check_dmeswDelay(dmeswDelay * a_dmeswDelay);
void check_dmeswMinor(dmeswMinor * a_dmeswMinor);
void check_dmeswStm(dmeswStm * a_dmeswStm);
void check_dmeswSwitch(dmeswSwitch * a_dmeswSwitch);
void check_dmeswiStm(dmeswiStm * a_dmeswiStm);
void check_dmeswvStm(dmeswvStm * a_dmeswvStm);
void check_dmisBlock(dmisBlock * a_dmisBlock);
void check_dmisFirstStatement(dmisFirstStatement * a_dmisFirstStatement);
void check_dmisFreeStatement(dmisFreeStatement * a_dmisFreeStatement);
void check_dmisItem(dmisItem * a_dmisItem);
void check_dmisOffBlock(dmisOffBlock * a_dmisOffBlock);
void check_dmismdStm(dmismdStm * a_dmismdStm);
void check_dmismnStm(dmismnStm * a_dmismnStm);
void check_doBlock(doBlock * a_doBlock);
void check_doStm(doStm * a_doStm);
void check_drLabel(drLabel * a_drLabel);
void check_dsLabel(dsLabel * a_dsLabel);
void check_dvLabel(dvLabel * a_dvLabel);
void check_equateCad(equateCad * a_equateCad);
void check_equateCadcs(equateCadcs * a_equateCadcs);
void check_equateCadcs_matrix(equateCadcs_matrix * a_equateCadcs_matrix);
void check_equateCadcs_stringVal(equateCadcs_stringVal * a_equateCadcs_stringVal);
void check_equateDatum(equateDatum * a_equateDatum);
void check_equateMinor(equateMinor * a_equateMinor);
void check_equateStm(equateStm * a_equateStm);
void check_errorCondition(errorCondition * a_errorCondition);
void check_errorCondition_intVal(errorCondition_intVal * a_errorCondition_intVal);
void check_errorMinor(errorMinor * a_errorMinor);
void check_errorMinor_AUTO(errorMinor_AUTO * a_errorMinor_AUTO);
void check_errorMinor_jumpLabel(errorMinor_jumpLabel * a_errorMinor_jumpLabel);
void check_errorStm(errorStm * a_errorStm);
void check_euler(euler * a_euler);
void check_evalDat(evalDat * a_evalDat);
void check_evalDatDatFa(evalDatDatFa * a_evalDatDatFa);
void check_evalDatFaDat(evalDatFaDat * a_evalDatFaDat);
void check_evalFeat(evalFeat * a_evalFeat);
void check_evalFeatFFaT(evalFeatFFaT * a_evalFeatFFaT);
void check_evalFeatFaFT(evalFeatFaFT * a_evalFeatFaFT);
void check_evalFeatFaFaT(evalFeatFaFaT * a_evalFeatFaFaT);
void check_evalFeatFaT(evalFeatFaT * a_evalFeatFaT);
void check_evalKeychar(evalKeychar * a_evalKeychar);
void check_evalMinor(evalMinor * a_evalMinor);
void check_evalOrOutput(evalOrOutput * a_evalOrOutput);
void check_evalStm(evalStm * a_evalStm);
void check_extensMinor(extensMinor * a_extensMinor);
void check_extensMinor_VEC(extensMinor_VEC * a_extensMinor_VEC);
void check_extensMinor_vector(extensMinor_vector * a_extensMinor_vector);
void check_extensStm(extensStm * a_extensStm);
void check_extfilDme(extfilDme * a_extfilDme);
void check_extfilDmis(extfilDmis * a_extfilDmis);
void check_extfilMinor(extfilMinor * a_extfilMinor);
void check_extfilStm(extfilStm * a_extfilStm);
void check_extremConst(extremConst * a_extremConst);
void check_extremConstAxial(extremConstAxial * a_extremConstAxial);
void check_extremConstDir(extremConstDir * a_extremConstDir);
void check_extremConstFeature(extremConstFeature * a_extremConstFeature);
void check_extremConstVectorial(extremConstVectorial * a_extremConstVectorial);
void check_extremConst_MAX(extremConst_MAX * a_extremConst_MAX);
void check_extremConst_MIN(extremConst_MIN * a_extremConst_MIN);
void check_fLabel(fLabel * a_fLabel);
void check_faLabel(faLabel * a_faLabel);
void check_featArc1Act(featArc1Act * a_featArc1Act);
void check_featArc1Nom(featArc1Nom * a_featArc1Nom);
void check_featArc1Stm(featArc1Stm * a_featArc1Stm);
void check_featArc2Act(featArc2Act * a_featArc2Act);
void check_featArc2Nom(featArc2Nom * a_featArc2Nom);
void check_featArc2Stm(featArc2Stm * a_featArc2Stm);
void check_featCircleAct(featCircleAct * a_featCircleAct);
void check_featCircleNom(featCircleNom * a_featCircleNom);
void check_featCircleStm(featCircleStm * a_featCircleStm);
void check_featCompoundAxial(featCompoundAxial * a_featCompoundAxial);
void check_featCompoundPlane(featCompoundPlane * a_featCompoundPlane);
void check_featCompoundSphere(featCompoundSphere * a_featCompoundSphere);
void check_featCompoundStm(featCompoundStm * a_featCompoundStm);
void check_featConeAct(featConeAct * a_featConeAct);
void check_featConeNom(featConeNom * a_featConeNom);
void check_featConeStm(featConeStm * a_featConeStm);
void check_featConradsegAct(featConradsegAct * a_featConradsegAct);
void check_featConradsegCart(featConradsegCart * a_featConradsegCart);
void check_featConradsegNom(featConradsegNom * a_featConradsegNom);
void check_featConradsegPol(featConradsegPol * a_featConradsegPol);
void check_featConradsegStm(featConradsegStm * a_featConradsegStm);
void check_featCparlnAct(featCparlnAct * a_featCparlnAct);
void check_featCparlnNom(featCparlnNom * a_featCparlnNom);
void check_featCparlnStm(featCparlnStm * a_featCparlnStm);
void check_featCylndrAct(featCylndrAct * a_featCylndrAct);
void check_featCylndrNom(featCylndrNom * a_featCylndrNom);
void check_featCylndrStm(featCylndrStm * a_featCylndrStm);
void check_featCylradsegAct(featCylradsegAct * a_featCylradsegAct);
void check_featCylradsegCart(featCylradsegCart * a_featCylradsegCart);
void check_featCylradsegNom(featCylradsegNom * a_featCylradsegNom);
void check_featCylradsegPol(featCylradsegPol * a_featCylradsegPol);
void check_featCylradsegStm(featCylradsegStm * a_featCylradsegStm);
void check_featEdgeptAct(featEdgeptAct * a_featEdgeptAct);
void check_featEdgeptNom(featEdgeptNom * a_featEdgeptNom);
void check_featEdgeptStm(featEdgeptStm * a_featEdgeptStm);
void check_featEllipsAct(featEllipsAct * a_featEllipsAct);
void check_featEllipsCart(featEllipsCart * a_featEllipsCart);
void check_featEllipsNom(featEllipsNom * a_featEllipsNom);
void check_featEllipsPol(featEllipsPol * a_featEllipsPol);
void check_featEllipsStm(featEllipsStm * a_featEllipsStm);
void check_featElongcylAct(featElongcylAct * a_featElongcylAct);
void check_featElongcylNom(featElongcylNom * a_featElongcylNom);
void check_featElongcylStm(featElongcylStm * a_featElongcylStm);
void check_featGcurveCart(featGcurveCart * a_featGcurveCart);
void check_featGcurvePol(featGcurvePol * a_featGcurvePol);
void check_featGcurveStm(featGcurveStm * a_featGcurveStm);
void check_featGeomStm(featGeomStm * a_featGeomStm);
void check_featGsurfCart(featGsurfCart * a_featGsurfCart);
void check_featGsurfPol(featGsurfPol * a_featGsurfPol);
void check_featGsurfStm(featGsurfStm * a_featGsurfStm);
void check_featLineAct(featLineAct * a_featLineAct);
void check_featLineBndCart(featLineBndCart * a_featLineBndCart);
void check_featLineBndPol(featLineBndPol * a_featLineBndPol);
void check_featLineNom(featLineNom * a_featLineNom);
void check_featLineStm(featLineStm * a_featLineStm);
void check_featLineUnbndCart(featLineUnbndCart * a_featLineUnbndCart);
void check_featLineUnbndPol(featLineUnbndPol * a_featLineUnbndPol);
void check_featMinorArc1(featMinorArc1 * a_featMinorArc1);
void check_featMinorArc2(featMinorArc2 * a_featMinorArc2);
void check_featMinorCircle(featMinorCircle * a_featMinorCircle);
void check_featMinorCompound(featMinorCompound * a_featMinorCompound);
void check_featMinorCone(featMinorCone * a_featMinorCone);
void check_featMinorConradseg(featMinorConradseg * a_featMinorConradseg);
void check_featMinorCparln(featMinorCparln * a_featMinorCparln);
void check_featMinorCylndr(featMinorCylndr * a_featMinorCylndr);
void check_featMinorCylradseg(featMinorCylradseg * a_featMinorCylradseg);
void check_featMinorEdgept(featMinorEdgept * a_featMinorEdgept);
void check_featMinorEllips(featMinorEllips * a_featMinorEllips);
void check_featMinorElongcyl(featMinorElongcyl * a_featMinorElongcyl);
void check_featMinorGcurve(featMinorGcurve * a_featMinorGcurve);
void check_featMinorGeom(featMinorGeom * a_featMinorGeom);
void check_featMinorGsurf(featMinorGsurf * a_featMinorGsurf);
void check_featMinorLine(featMinorLine * a_featMinorLine);
void check_featMinorObject(featMinorObject * a_featMinorObject);
void check_featMinorParpln(featMinorParpln * a_featMinorParpln);
void check_featMinorPatern(featMinorPatern * a_featMinorPatern);
void check_featMinorPlane(featMinorPlane * a_featMinorPlane);
void check_featMinorPoint(featMinorPoint * a_featMinorPoint);
void check_featMinorRctngl(featMinorRctngl * a_featMinorRctngl);
void check_featMinorRevsurf(featMinorRevsurf * a_featMinorRevsurf);
void check_featMinorSphere(featMinorSphere * a_featMinorSphere);
void check_featMinorSphradseg(featMinorSphradseg * a_featMinorSphradseg);
void check_featMinorSympln(featMinorSympln * a_featMinorSympln);
void check_featMinorTorradseg(featMinorTorradseg * a_featMinorTorradseg);
void check_featMinorTorus(featMinorTorus * a_featMinorTorus);
void check_featObjectAct(featObjectAct * a_featObjectAct);
void check_featObjectNom(featObjectNom * a_featObjectNom);
void check_featObjectStm(featObjectStm * a_featObjectStm);
void check_featParplnAct(featParplnAct * a_featParplnAct);
void check_featParplnMidplCart(featParplnMidplCart * a_featParplnMidplCart);
void check_featParplnMidplPol(featParplnMidplPol * a_featParplnMidplPol);
void check_featParplnNom(featParplnNom * a_featParplnNom);
void check_featParplnPointsCart(featParplnPointsCart * a_featParplnPointsCart);
void check_featParplnPointsPol(featParplnPointsPol * a_featParplnPointsPol);
void check_featParplnStm(featParplnStm * a_featParplnStm);
void check_featPaternStm(featPaternStm * a_featPaternStm);
void check_featPlaneAct(featPlaneAct * a_featPlaneAct);
void check_featPlaneNom(featPlaneNom * a_featPlaneNom);
void check_featPlaneStm(featPlaneStm * a_featPlaneStm);
void check_featPointAct(featPointAct * a_featPointAct);
void check_featPointNom(featPointNom * a_featPointNom);
void check_featPointStm(featPointStm * a_featPointStm);
void check_featRctnglAct(featRctnglAct * a_featRctnglAct);
void check_featRctnglNom(featRctnglNom * a_featRctnglNom);
void check_featRctnglStm(featRctnglStm * a_featRctnglStm);
void check_featRevsurfAct(featRevsurfAct * a_featRevsurfAct);
void check_featRevsurfCart(featRevsurfCart * a_featRevsurfCart);
void check_featRevsurfNom(featRevsurfNom * a_featRevsurfNom);
void check_featRevsurfPol(featRevsurfPol * a_featRevsurfPol);
void check_featRevsurfStm(featRevsurfStm * a_featRevsurfStm);
void check_featSphereAct(featSphereAct * a_featSphereAct);
void check_featSphereNom(featSphereNom * a_featSphereNom);
void check_featSphereStm(featSphereStm * a_featSphereStm);
void check_featSphradsegAct(featSphradsegAct * a_featSphradsegAct);
void check_featSphradsegNom(featSphradsegNom * a_featSphradsegNom);
void check_featSphradsegStm(featSphradsegStm * a_featSphradsegStm);
void check_featSymplnAct(featSymplnAct * a_featSymplnAct);
void check_featSymplnCart(featSymplnCart * a_featSymplnCart);
void check_featSymplnNom(featSymplnNom * a_featSymplnNom);
void check_featSymplnPol(featSymplnPol * a_featSymplnPol);
void check_featSymplnStm(featSymplnStm * a_featSymplnStm);
void check_featTorradsegAct(featTorradsegAct * a_featTorradsegAct);
void check_featTorradsegNom(featTorradsegNom * a_featTorradsegNom);
void check_featTorradsegStm(featTorradsegStm * a_featTorradsegStm);
void check_featTorusAct(featTorusAct * a_featTorusAct);
void check_featTorusNom(featTorusNom * a_featTorusNom);
void check_featTorusStm(featTorusStm * a_featTorusStm);
void check_featureLabel(featureLabel * a_featureLabel);
void check_featureLabel1(featureLabel1 * a_featureLabel1);
void check_fedratAngSpec(fedratAngSpec * a_fedratAngSpec);
void check_fedratAngular(fedratAngular * a_fedratAngular);
void check_fedratDef(fedratDef * a_fedratDef);
void check_fedratDef_PCENT(fedratDef_PCENT * a_fedratDef_PCENT);
void check_fedratHedMeas(fedratHedMeas * a_fedratHedMeas);
void check_fedratHedRot(fedratHedRot * a_fedratHedRot);
void check_fedratHedScan(fedratHedScan * a_fedratHedScan);
void check_fedratLinSpec(fedratLinSpec * a_fedratLinSpec);
void check_fedratLinear(fedratLinear * a_fedratLinear);
void check_fedratLinear_IPM(fedratLinear_IPM * a_fedratLinear_IPM);
void check_fedratLinear_IPS(fedratLinear_IPS * a_fedratLinear_IPS);
void check_fedratLinear_MMPS(fedratLinear_MMPS * a_fedratLinear_MMPS);
void check_fedratLinear_MPM(fedratLinear_MPM * a_fedratLinear_MPM);
void check_fedratMeas(fedratMeas * a_fedratMeas);
void check_fedratMinor(fedratMinor * a_fedratMinor);
void check_fedratPos(fedratPos * a_fedratPos);
void check_fedratRot(fedratRot * a_fedratRot);
void check_fedratScan(fedratScan * a_fedratScan);
void check_fedratStm(fedratStm * a_fedratStm);
void check_fiLabel(fiLabel * a_fiLabel);
void check_fildefStm(fildefStm * a_fildefStm);
void check_filnamStm(filnamStm * a_filnamStm);
void check_finposStm(finposStm * a_finposStm);
void check_fixtidStm(fixtidStm * a_fixtidStm);
void check_fixtsnStm(fixtsnStm * a_fixtsnStm);
void check_flatRoundOpen(flatRoundOpen * a_flatRoundOpen);
void check_flipNoFlip(flipNoFlip * a_flipNoFlip);
void check_flyMinor(flyMinor * a_flyMinor);
void check_flyMinor_rentVal(flyMinor_rentVal * a_flyMinor_rentVal);
void check_flyStm(flyStm * a_flyStm);
void check_forceOrDeflection(forceOrDeflection * a_forceOrDeflection);
void check_forceOrDeflection_DEFLECTION(forceOrDeflection_DEFLECTION * a_forceOrDeflection_DEFLECTION);
void check_forceOrDeflection_FORCE(forceOrDeflection_FORCE * a_forceOrDeflection_FORCE);
void check_fromMinor(fromMinor * a_fromMinor);
void check_fromMinor_cartPoint(fromMinor_cartPoint * a_fromMinor_cartPoint);
void check_fromMinor_impCartPoint(fromMinor_impCartPoint * a_fromMinor_impCartPoint);
void check_fromMinor_polPoint(fromMinor_polPoint * a_fromMinor_polPoint);
void check_fromStm(fromStm * a_fromStm);
void check_fsLabel(fsLabel * a_fsLabel);
void check_gLabel(gLabel * a_gLabel);
void check_geoalgArc(geoalgArc * a_geoalgArc);
void check_geoalgCircle(geoalgCircle * a_geoalgCircle);
void check_geoalgCone(geoalgCone * a_geoalgCone);
void check_geoalgConradsegmnt(geoalgConradsegmnt * a_geoalgConradsegmnt);
void check_geoalgCparln(geoalgCparln * a_geoalgCparln);
void check_geoalgCylndr(geoalgCylndr * a_geoalgCylndr);
void check_geoalgCylradsegmnt(geoalgCylradsegmnt * a_geoalgCylradsegmnt);
void check_geoalgEliminate(geoalgEliminate * a_geoalgEliminate);
void check_geoalgEliminateStd(geoalgEliminateStd * a_geoalgEliminateStd);
void check_geoalgEllips(geoalgEllips * a_geoalgEllips);
void check_geoalgElongcyl(geoalgElongcyl * a_geoalgElongcyl);
void check_geoalgExternFunc(geoalgExternFunc * a_geoalgExternFunc);
void check_geoalgExternFunc_DME(geoalgExternFunc_DME * a_geoalgExternFunc_DME);
void check_geoalgExternFunc_DMIS(geoalgExternFunc_DMIS * a_geoalgExternFunc_DMIS);
void check_geoalgExternFunc_SYS(geoalgExternFunc_SYS * a_geoalgExternFunc_SYS);
void check_geoalgFiltSetElim(geoalgFiltSetElim * a_geoalgFiltSetElim);
void check_geoalgFiltSetFilt(geoalgFiltSetFilt * a_geoalgFiltSetFilt);
void check_geoalgFilter(geoalgFilter * a_geoalgFilter);
void check_geoalgFilterCirc(geoalgFilterCirc * a_geoalgFilterCirc);
void check_geoalgFilterCurve(geoalgFilterCurve * a_geoalgFilterCurve);
void check_geoalgFilterLambda(geoalgFilterLambda * a_geoalgFilterLambda);
void check_geoalgFilterSettings(geoalgFilterSettings * a_geoalgFilterSettings);
void check_geoalgFilterType(geoalgFilterType * a_geoalgFilterType);
void check_geoalgFilterType_BANDPASS(geoalgFilterType_BANDPASS * a_geoalgFilterType_BANDPASS);
void check_geoalgFilterType_HIGHPASS(geoalgFilterType_HIGHPASS * a_geoalgFilterType_HIGHPASS);
void check_geoalgFilterType_LOWPASS(geoalgFilterType_LOWPASS * a_geoalgFilterType_LOWPASS);
void check_geoalgGcurve(geoalgGcurve * a_geoalgGcurve);
void check_geoalgGsurf(geoalgGsurf * a_geoalgGsurf);
void check_geoalgLine(geoalgLine * a_geoalgLine);
void check_geoalgMinor(geoalgMinor * a_geoalgMinor);
void check_geoalgObject(geoalgObject * a_geoalgObject);
void check_geoalgParpln(geoalgParpln * a_geoalgParpln);
void check_geoalgPlane(geoalgPlane * a_geoalgPlane);
void check_geoalgRctngl(geoalgRctngl * a_geoalgRctngl);
void check_geoalgRevsurf(geoalgRevsurf * a_geoalgRevsurf);
void check_geoalgSpec1(geoalgSpec1 * a_geoalgSpec1);
void check_geoalgSpec1_DEFALT(geoalgSpec1_DEFALT * a_geoalgSpec1_DEFALT);
void check_geoalgSpec1_EXTERN(geoalgSpec1_EXTERN * a_geoalgSpec1_EXTERN);
void check_geoalgSpec1_LSTSQR(geoalgSpec1_LSTSQR * a_geoalgSpec1_LSTSQR);
void check_geoalgSpec1_MINMAX(geoalgSpec1_MINMAX * a_geoalgSpec1_MINMAX);
void check_geoalgSpec2(geoalgSpec2 * a_geoalgSpec2);
void check_geoalgSpec2_DEFALT(geoalgSpec2_DEFALT * a_geoalgSpec2_DEFALT);
void check_geoalgSpec2_EXTERN(geoalgSpec2_EXTERN * a_geoalgSpec2_EXTERN);
void check_geoalgSpec2_LSTSQR(geoalgSpec2_LSTSQR * a_geoalgSpec2_LSTSQR);
void check_geoalgSpec2_MAXINS(geoalgSpec2_MAXINS * a_geoalgSpec2_MAXINS);
void check_geoalgSpec2_MINCIR(geoalgSpec2_MINCIR * a_geoalgSpec2_MINCIR);
void check_geoalgSpec2_MINMAX(geoalgSpec2_MINMAX * a_geoalgSpec2_MINMAX);
void check_geoalgSpec3(geoalgSpec3 * a_geoalgSpec3);
void check_geoalgSpec3_DEFALT(geoalgSpec3_DEFALT * a_geoalgSpec3_DEFALT);
void check_geoalgSpec3_EXTERN(geoalgSpec3_EXTERN * a_geoalgSpec3_EXTERN);
void check_geoalgSpec4(geoalgSpec4 * a_geoalgSpec4);
void check_geoalgSpec4_BSPLIN(geoalgSpec4_BSPLIN * a_geoalgSpec4_BSPLIN);
void check_geoalgSpec4_DEFALT(geoalgSpec4_DEFALT * a_geoalgSpec4_DEFALT);
void check_geoalgSpec4_EXTERN(geoalgSpec4_EXTERN * a_geoalgSpec4_EXTERN);
void check_geoalgSpec4_LSTSQR(geoalgSpec4_LSTSQR * a_geoalgSpec4_LSTSQR);
void check_geoalgSpec4_MINMAX(geoalgSpec4_MINMAX * a_geoalgSpec4_MINMAX);
void check_geoalgSpec5(geoalgSpec5 * a_geoalgSpec5);
void check_geoalgSpec5_BEZIER(geoalgSpec5_BEZIER * a_geoalgSpec5_BEZIER);
void check_geoalgSpec5_DEFALT(geoalgSpec5_DEFALT * a_geoalgSpec5_DEFALT);
void check_geoalgSpec5_EXTERN(geoalgSpec5_EXTERN * a_geoalgSpec5_EXTERN);
void check_geoalgSpec5_LSTSQR(geoalgSpec5_LSTSQR * a_geoalgSpec5_LSTSQR);
void check_geoalgSpec5_MINMAX(geoalgSpec5_MINMAX * a_geoalgSpec5_MINMAX);
void check_geoalgSpec5_NURBS(geoalgSpec5_NURBS * a_geoalgSpec5_NURBS);
void check_geoalgSpec6(geoalgSpec6 * a_geoalgSpec6);
void check_geoalgSpec6_BSPLIN(geoalgSpec6_BSPLIN * a_geoalgSpec6_BSPLIN);
void check_geoalgSpec6_DEFALT(geoalgSpec6_DEFALT * a_geoalgSpec6_DEFALT);
void check_geoalgSpec6_EXTERN(geoalgSpec6_EXTERN * a_geoalgSpec6_EXTERN);
void check_geoalgSpec6_LSTSQR(geoalgSpec6_LSTSQR * a_geoalgSpec6_LSTSQR);
void check_geoalgSphere(geoalgSphere * a_geoalgSphere);
void check_geoalgSphradsegmnt(geoalgSphradsegmnt * a_geoalgSphradsegmnt);
void check_geoalgStm(geoalgStm * a_geoalgStm);
void check_geoalgSympln(geoalgSympln * a_geoalgSympln);
void check_geoalgTorradsegmnt(geoalgTorradsegmnt * a_geoalgTorradsegmnt);
void check_geoalgTorus(geoalgTorus * a_geoalgTorus);
void check_geomEntityItem(geomEntityItem * a_geomEntityItem);
void check_geomMinor(geomMinor * a_geomMinor);
void check_geomStm(geomStm * a_geomStm);
void check_geomStmDid(geomStmDid * a_geomStmDid);
void check_geomStmEntity(geomStmEntity * a_geomStmEntity);
void check_geomStmOffset(geomStmOffset * a_geomStmOffset);
void check_gotargBlock(gotargBlock * a_gotargBlock);
void check_gotargCart(gotargCart * a_gotargCart);
void check_gotargPol(gotargPol * a_gotargPol);
void check_gotargStm(gotargStm * a_gotargStm);
void check_gotargXyz(gotargXyz * a_gotargXyz);
void check_gotoAbs(gotoAbs * a_gotoAbs);
void check_gotoAbsCart(gotoAbsCart * a_gotoAbsCart);
void check_gotoAbsCartSens(gotoAbsCartSens * a_gotoAbsCartSens);
void check_gotoAbsPol(gotoAbsPol * a_gotoAbsPol);
void check_gotoAbsPolSens(gotoAbsPolSens * a_gotoAbsPolSens);
void check_gotoAbsXyz(gotoAbsXyz * a_gotoAbsXyz);
void check_gotoAbsXyzSens(gotoAbsXyzSens * a_gotoAbsXyzSens);
void check_gotoArc(gotoArc * a_gotoArc);
void check_gotoAxis(gotoAxis * a_gotoAxis);
void check_gotoAxisSpec(gotoAxisSpec * a_gotoAxisSpec);
void check_gotoMinor(gotoMinor * a_gotoMinor);
void check_gotoRel(gotoRel * a_gotoRel);
void check_gotoStm(gotoStm * a_gotoStm);
void check_gotoWristAngleItem(gotoWristAngleItem * a_gotoWristAngleItem);
void check_gotoWristItem(gotoWristItem * a_gotoWristItem);
void check_groupStm(groupStm * a_groupStm);
void check_gsaLabel(gsaLabel * a_gsaLabel);
void check_ifBlock(ifBlock * a_ifBlock);
void check_ifStm(ifStm * a_ifStm);
void check_impCartPoint(impCartPoint * a_impCartPoint);
void check_impPolPoint(impPolPoint * a_impPolPoint);
void check_includDme(includDme * a_includDme);
void check_includDmis(includDmis * a_includDmis);
void check_includMinor(includMinor * a_includMinor);
void check_includStm(includStm * a_includStm);
void check_indexedFeature(indexedFeature * a_indexedFeature);
void check_inputFile(inputFile * a_inputFile);
void check_intConst(intConst * a_intConst);
void check_intExpr(intExpr * a_intExpr);
void check_intExprDivid(intExprDivid * a_intExprDivid);
void check_intExprMinus(intExprMinus * a_intExprMinus);
void check_intExprNegat(intExprNegat * a_intExprNegat);
void check_intExprParen(intExprParen * a_intExprParen);
void check_intExprPlus(intExprPlus * a_intExprPlus);
void check_intExprPosit(intExprPosit * a_intExprPosit);
void check_intExprPower(intExprPower * a_intExprPower);
void check_intExprTimes(intExprTimes * a_intExprTimes);
void check_intFunc(intFunc * a_intFunc);
void check_intFuncAbs(intFuncAbs * a_intFuncAbs);
void check_intFuncIndx(intFuncIndx * a_intFuncIndx);
void check_intFuncInt(intFuncInt * a_intFuncInt);
void check_intFuncLen(intFuncLen * a_intFuncLen);
void check_intFuncMod(intFuncMod * a_intFuncMod);
void check_intFuncNint(intFuncNint * a_intFuncNint);
void check_intFuncOrd(intFuncOrd * a_intFuncOrd);
void check_intFuncOrd_boolVal(intFuncOrd_boolVal * a_intFuncOrd_boolVal);
void check_intFuncOrd_stringVal(intFuncOrd_stringVal * a_intFuncOrd_stringVal);
void check_intFuncPtdata(intFuncPtdata * a_intFuncPtdata);
void check_intFuncSign(intFuncSign * a_intFuncSign);
void check_intRealExpr(intRealExpr * a_intRealExpr);
void check_intRealExpr_DIVID(intRealExpr_DIVID * a_intRealExpr_DIVID);
void check_intRealExpr_MINUS(intRealExpr_MINUS * a_intRealExpr_MINUS);
void check_intRealExpr_PLUS(intRealExpr_PLUS * a_intRealExpr_PLUS);
void check_intRealExpr_POWER(intRealExpr_POWER * a_intRealExpr_POWER);
void check_intRealExpr_TIMES(intRealExpr_TIMES * a_intRealExpr_TIMES);
void check_intRealRel(intRealRel * a_intRealRel);
void check_intRealRel_EQ(intRealRel_EQ * a_intRealRel_EQ);
void check_intRealRel_GE(intRealRel_GE * a_intRealRel_GE);
void check_intRealRel_GT(intRealRel_GT * a_intRealRel_GT);
void check_intRealRel_LE(intRealRel_LE * a_intRealRel_LE);
void check_intRealRel_LT(intRealRel_LT * a_intRealRel_LT);
void check_intRealRel_NE(intRealRel_NE * a_intRealRel_NE);
void check_intRel(intRel * a_intRel);
void check_intRel_EQ(intRel_EQ * a_intRel_EQ);
void check_intRel_GE(intRel_GE * a_intRel_GE);
void check_intRel_GT(intRel_GT * a_intRel_GT);
void check_intRel_LE(intRel_LE * a_intRel_LE);
void check_intRel_LT(intRel_LT * a_intRel_LT);
void check_intRel_NE(intRel_NE * a_intRel_NE);
void check_intVal(intVal * a_intVal);
void check_intVar(intVar * a_intVar);
void check_intVecExpr_TIMES(intVecExpr_TIMES * a_intVecExpr_TIMES);
void check_intofConst(intofConst * a_intofConst);
void check_iteratConvergence(iteratConvergence * a_iteratConvergence);
void check_iteratConvergence_ABSL(iteratConvergence_ABSL * a_iteratConvergence_ABSL);
void check_iteratConvergence_INCR(iteratConvergence_INCR * a_iteratConvergence_INCR);
void check_iteratCriterionItem(iteratCriterionItem * a_iteratCriterionItem);
void check_iteratCriterionStart(iteratCriterionStart * a_iteratCriterionStart);
void check_iteratCriterionStart_axis(iteratCriterionStart_axis * a_iteratCriterionStart_axis);
void check_iteratCriterionStart_vector(iteratCriterionStart_vector * a_iteratCriterionStart_vector);
void check_iteratMinor(iteratMinor * a_iteratMinor);
void check_iteratStm(iteratStm * a_iteratStm);
void check_jointConf(jointConf * a_jointConf);
void check_jumpLabel(jumpLabel * a_jumpLabel);
void check_jumpStm(jumpStm * a_jumpStm);
void check_jumptoStm(jumptoStm * a_jumptoStm);
void check_kcLabel(kcLabel * a_kcLabel);
void check_kcaLabel(kcaLabel * a_kcaLabel);
void check_keycharMinor(keycharMinor * a_keycharMinor);
void check_keycharOneFeature(keycharOneFeature * a_keycharOneFeature);
void check_keycharStm(keycharStm * a_keycharStm);
void check_keycharTwoFeatures(keycharTwoFeatures * a_keycharTwoFeatures);
void check_labelName(labelName * a_labelName);
void check_labelNameAt(labelNameAt * a_labelNameAt);
void check_labelNameCon(labelNameCon * a_labelNameCon);
void check_labelNameConst(labelNameConst * a_labelNameConst);
void check_leftRight(leftRight * a_leftRight);
void check_lengthUnit(lengthUnit * a_lengthUnit);
void check_liLabel(liLabel * a_liLabel);
void check_litdefLight(litdefLight * a_litdefLight);
void check_litdefLightType(litdefLightType * a_litdefLightType);
void check_litdefMinor(litdefMinor * a_litdefMinor);
void check_litdefStm(litdefStm * a_litdefStm);
void check_litdefStrobe(litdefStrobe * a_litdefStrobe);
void check_litdefStrobeType(litdefStrobeType * a_litdefStrobeType);
void check_litdefStrobeType_CYCLE(litdefStrobeType_CYCLE * a_litdefStrobeType_CYCLE);
void check_locateLabel(locateLabel * a_locateLabel);
void check_locateRotAllowed(locateRotAllowed * a_locateRotAllowed);
void check_locateStm(locateStm * a_locateStm);
void check_locateTransAllowed(locateTransAllowed * a_locateTransAllowed);
void check_longShort(longShort * a_longShort);
void check_lotidStm(lotidStm * a_lotidStm);
void check_mLabel(mLabel * a_mLabel);
void check_mLabelConst(mLabelConst * a_mLabelConst);
void check_maLabel(maLabel * a_maLabel);
void check_macroBlock(macroBlock * a_macroBlock);
void check_macroPar(macroPar * a_macroPar);
void check_macroPar_MACROVARNAME(macroPar_MACROVARNAME * a_macroPar_MACROVARNAME);
void check_macroPar_stringConst(macroPar_stringConst * a_macroPar_stringConst);
void check_macroStm(macroStm * a_macroStm);
void check_matDir(matDir * a_matDir);
void check_matdefFeat(matdefFeat * a_matdefFeat);
void check_matdefGeom(matdefGeom * a_matdefGeom);
void check_matdefMat(matdefMat * a_matdefMat);
void check_matdefMat_LMC(matdefMat_LMC * a_matdefMat_LMC);
void check_matdefMat_MMC(matdefMat_MMC * a_matdefMat_MMC);
void check_matdefMating(matdefMating * a_matdefMating);
void check_matdefMethod(matdefMethod * a_matdefMethod);
void check_matdefMinor(matdefMinor * a_matdefMinor);
void check_matdefSpec(matdefSpec * a_matdefSpec);
void check_matdefStm(matdefStm * a_matdefStm);
void check_matdefType(matdefType * a_matdefType);
void check_matdefTypeBand(matdefTypeBand * a_matdefTypeBand);
void check_matdefTypeZone(matdefTypeZone * a_matdefTypeZone);
void check_matrix(matrix * a_matrix);
void check_mdLabel(mdLabel * a_mdLabel);
void check_measBlock(measBlock * a_measBlock);
void check_measBlockItem(measBlockItem * a_measBlockItem);
void check_measBlockStatement(measBlockStatement * a_measBlockStatement);
void check_measBlock_measStm(measBlock_measStm * a_measBlock_measStm);
void check_measBlock_rmeasStm(measBlock_rmeasStm * a_measBlock_rmeasStm);
void check_measCaseBlock(measCaseBlock * a_measCaseBlock);
void check_measDefaultCaseBlock(measDefaultCaseBlock * a_measDefaultCaseBlock);
void check_measDoBlock(measDoBlock * a_measDoBlock);
void check_measGeotype(measGeotype * a_measGeotype);
void check_measIfBlock(measIfBlock * a_measIfBlock);
void check_measMinor(measMinor * a_measMinor);
void check_measMinorComp(measMinorComp * a_measMinorComp);
void check_measMinorOther(measMinorOther * a_measMinorOther);
void check_measSelectBlock(measSelectBlock * a_measSelectBlock);
void check_measStm(measStm * a_measStm);
void check_measVar2(measVar2 * a_measVar2);
void check_measVar2Aux(measVar2Aux * a_measVar2Aux);
void check_measVar2_FEAT(measVar2_FEAT * a_measVar2_FEAT);
void check_measVar2_VEC(measVar2_VEC * a_measVar2_VEC);
void check_mfgdevStm(mfgdevStm * a_mfgdevStm);
void check_midliConst(midliConst * a_midliConst);
void check_midplConst(midplConst * a_midplConst);
void check_midptConst(midptConst * a_midptConst);
void check_modeStm(modeStm * a_modeStm);
void check_moveptConst(moveptConst * a_moveptConst);
void check_moveptConstAxis(moveptConstAxis * a_moveptConstAxis);
void check_moveptConstVec(moveptConstVec * a_moveptConstVec);
void check_nearptConst(nearptConst * a_nearptConst);
void check_negDir(negDir * a_negDir);
void check_noParseStm(noParseStm * a_noParseStm);
void check_obtainBool(obtainBool * a_obtainBool);
void check_obtainInt(obtainInt * a_obtainInt);
void check_obtainLabeled(obtainLabeled * a_obtainLabeled);
void check_obtainLabeled_crLabel(obtainLabeled_crLabel * a_obtainLabeled_crLabel);
void check_obtainLabeled_datumLabel1(obtainLabeled_datumLabel1 * a_obtainLabeled_datumLabel1);
void check_obtainLabeled_didLabel(obtainLabeled_didLabel * a_obtainLabeled_didLabel);
void check_obtainLabeled_featureLabel(obtainLabeled_featureLabel * a_obtainLabeled_featureLabel);
void check_obtainLabeled_gLabel(obtainLabeled_gLabel * a_obtainLabeled_gLabel);
void check_obtainLabeled_gsaLabel(obtainLabeled_gsaLabel * a_obtainLabeled_gsaLabel);
void check_obtainLabeled_kcLabel(obtainLabeled_kcLabel * a_obtainLabeled_kcLabel);
void check_obtainLabeled_maLabel(obtainLabeled_maLabel * a_obtainLabeled_maLabel);
void check_obtainLabeled_pLabel(obtainLabeled_pLabel * a_obtainLabeled_pLabel);
void check_obtainLabeled_qisLabel(obtainLabeled_qisLabel * a_obtainLabeled_qisLabel);
void check_obtainLabeled_rLabel(obtainLabeled_rLabel * a_obtainLabeled_rLabel);
void check_obtainLabeled_rmLabel(obtainLabeled_rmLabel * a_obtainLabeled_rmLabel);
void check_obtainLabeled_rtLabel(obtainLabeled_rtLabel * a_obtainLabeled_rtLabel);
void check_obtainLabeled_sensorLabel1(obtainLabeled_sensorLabel1 * a_obtainLabeled_sensorLabel1);
void check_obtainLabeled_sgLabel(obtainLabeled_sgLabel * a_obtainLabeled_sgLabel);
void check_obtainLabeled_sgsLabel(obtainLabeled_sgsLabel * a_obtainLabeled_sgsLabel);
void check_obtainLabeled_sraLabel(obtainLabeled_sraLabel * a_obtainLabeled_sraLabel);
void check_obtainLabeled_ssLabel(obtainLabeled_ssLabel * a_obtainLabeled_ssLabel);
void check_obtainLabeled_swLabel(obtainLabeled_swLabel * a_obtainLabeled_swLabel);
void check_obtainLabeled_sxLabel(obtainLabeled_sxLabel * a_obtainLabeled_sxLabel);
void check_obtainLabeled_thLabel(obtainLabeled_thLabel * a_obtainLabeled_thLabel);
void check_obtainLabeled_toleranceLabel(obtainLabeled_toleranceLabel * a_obtainLabeled_toleranceLabel);
void check_obtainLabeled_vLabel(obtainLabeled_vLabel * a_obtainLabeled_vLabel);
void check_obtainLabeled_vaLabel(obtainLabeled_vaLabel * a_obtainLabeled_vaLabel);
void check_obtainLabeled_vfLabel(obtainLabeled_vfLabel * a_obtainLabeled_vfLabel);
void check_obtainLabeled_vlLabel(obtainLabeled_vlLabel * a_obtainLabeled_vlLabel);
void check_obtainLabeled_vwLabel(obtainLabeled_vwLabel * a_obtainLabeled_vwLabel);
void check_obtainPoint(obtainPoint * a_obtainPoint);
void check_obtainRealLabel(obtainRealLabel * a_obtainRealLabel);
void check_obtainRealPoint(obtainRealPoint * a_obtainRealPoint);
void check_obtainStm(obtainStm * a_obtainStm);
void check_obtainString(obtainString * a_obtainString);
void check_offsetConst(offsetConst * a_offsetConst);
void check_opLabel(opLabel * a_opLabel);
void check_openCadfile(openCadfile * a_openCadfile);
void check_openDMLfile(openDMLfile * a_openDMLfile);
void check_openDevice(openDevice * a_openDevice);
void check_openDevice_inputAccess(openDevice_inputAccess * a_openDevice_inputAccess);
void check_openDevice_outputAccess(openDevice_outputAccess * a_openDevice_outputAccess);
void check_openDmlInput(openDmlInput * a_openDmlInput);
void check_openDmlOutput(openDmlOutput * a_openDmlOutput);
void check_openFdata(openFdata * a_openFdata);
void check_openFdata_DMIS(openFdata_DMIS * a_openFdata_DMIS);
void check_openFdata_vLabel(openFdata_vLabel * a_openFdata_vLabel);
void check_openMinor(openMinor * a_openMinor);
void check_openMinor_openCadfile(openMinor_openCadfile * a_openMinor_openCadfile);
void check_openMinor_openDMLfile(openMinor_openDMLfile * a_openMinor_openDMLfile);
void check_openMinor_openDevice(openMinor_openDevice * a_openMinor_openDevice);
void check_openMinor_openFdata(openMinor_openFdata * a_openMinor_openFdata);
void check_openMinor_storageSpecList(openMinor_storageSpecList * a_openMinor_storageSpecList);
void check_openStm(openStm * a_openStm);
void check_operidStm(operidStm * a_operidStm);
void check_orig(orig * a_orig);
void check_outputAccess(outputAccess * a_outputAccess);
void check_outputConstBothData(outputConstBothData * a_outputConstBothData);
void check_outputConstData(outputConstData * a_outputConstData);
void check_outputConstGaugeData(outputConstGaugeData * a_outputConstGaugeData);
void check_outputConstPartData(outputConstPartData * a_outputConstPartData);
void check_outputDat(outputDat * a_outputDat);
void check_outputDat_datLabel(outputDat_datLabel * a_outputDat_datLabel);
void check_outputDat_faLabel(outputDat_faLabel * a_outputDat_faLabel);
void check_outputFeat(outputFeat * a_outputFeat);
void check_outputFeat1F(outputFeat1F * a_outputFeat1F);
void check_outputFeat1FT(outputFeat1FT * a_outputFeat1FT);
void check_outputFeat1Fa(outputFeat1Fa * a_outputFeat1Fa);
void check_outputFeat1FaTa(outputFeat1FaTa * a_outputFeat1FaTa);
void check_outputFeat2FFT(outputFeat2FFT * a_outputFeat2FFT);
void check_outputFeat2FFaTa(outputFeat2FFaTa * a_outputFeat2FFaTa);
void check_outputFeat2FaFTa(outputFeat2FaFTa * a_outputFeat2FaFTa);
void check_outputFeat2FaFaTa(outputFeat2FaFaTa * a_outputFeat2FaFaTa);
void check_outputFeatData(outputFeatData * a_outputFeatData);
void check_outputKeycharData(outputKeycharData * a_outputKeycharData);
void check_outputMinor(outputMinor * a_outputMinor);
void check_outputReportData(outputReportData * a_outputReportData);
void check_outputSensorData(outputSensorData * a_outputSensorData);
void check_outputSensorData_sLabel(outputSensorData_sLabel * a_outputSensorData_sLabel);
void check_outputSensorData_saLabel(outputSensorData_saLabel * a_outputSensorData_saLabel);
void check_outputSensorDesc(outputSensorDesc * a_outputSensorDesc);
void check_outputSensorDesc_intVal(outputSensorDesc_intVal * a_outputSensorDesc_intVal);
void check_outputSensorDesc_outputSensorWristList(outputSensorDesc_outputSensorWristList * a_outputSensorDesc_outputSensorWristList);
void check_outputSensorDesc_stringVal(outputSensorDesc_stringVal * a_outputSensorDesc_stringVal);
void check_outputSensorWristAngle(outputSensorWristAngle * a_outputSensorWristAngle);
void check_outputSensorWristItem(outputSensorWristItem * a_outputSensorWristItem);
void check_outputStm(outputStm * a_outputStm);
void check_outputToleranceData(outputToleranceData * a_outputToleranceData);
void check_pLabel(pLabel * a_pLabel);
void check_pameasDetail(pameasDetail * a_pameasDetail);
void check_pameasDetailDistance(pameasDetailDistance * a_pameasDetailDistance);
void check_pameasDetailPitch(pameasDetailPitch * a_pameasDetailPitch);
void check_pameasDetailScnvelData(pameasDetailScnvelData * a_pameasDetailScnvelData);
void check_pameasDetailScnvelNoData(pameasDetailScnvelNoData * a_pameasDetailScnvelNoData);
void check_pameasFedrat(pameasFedrat * a_pameasFedrat);
void check_pameasFedrat_IPM(pameasFedrat_IPM * a_pameasFedrat_IPM);
void check_pameasFedrat_IPS(pameasFedrat_IPS * a_pameasFedrat_IPS);
void check_pameasFedrat_MMPS(pameasFedrat_MMPS * a_pameasFedrat_MMPS);
void check_pameasFedrat_MPM(pameasFedrat_MPM * a_pameasFedrat_MPM);
void check_pameasMinor(pameasMinor * a_pameasMinor);
void check_pameasMinor_pameasVar2List(pameasMinor_pameasVar2List * a_pameasMinor_pameasVar2List);
void check_pameasMinor_pameasVar3List(pameasMinor_pameasVar3List * a_pameasMinor_pameasVar3List);
void check_pameasRemove(pameasRemove * a_pameasRemove);
void check_pameasRemoveCount(pameasRemoveCount * a_pameasRemoveCount);
void check_pameasRemoveDist(pameasRemoveDist * a_pameasRemoveDist);
void check_pameasStm(pameasStm * a_pameasStm);
void check_pameasVar2ListItem(pameasVar2ListItem * a_pameasVar2ListItem);
void check_pameasVar3ListItem(pameasVar3ListItem * a_pameasVar3ListItem);
void check_param(param * a_param);
void check_partidStm(partidStm * a_partidStm);
void check_partoConst(partoConst * a_partoConst);
void check_partoConstAct(partoConstAct * a_partoConstAct);
void check_partoConstNom(partoConstNom * a_partoConstNom);
void check_partrvStm(partrvStm * a_partrvStm);
void check_partsnStm(partsnStm * a_partsnStm);
void check_pathArc(pathArc * a_pathArc);
void check_pathCurve(pathCurve * a_pathCurve);
void check_pathCurvePoints(pathCurvePoints * a_pathCurvePoints);
void check_pathCurvePtdata(pathCurvePtdata * a_pathCurvePtdata);
void check_pathCurve_pathCurvePoints(pathCurve_pathCurvePoints * a_pathCurve_pathCurvePoints);
void check_pathCurve_pathCurvePtdata(pathCurve_pathCurvePtdata * a_pathCurve_pathCurvePtdata);
void check_pathHelical(pathHelical * a_pathHelical);
void check_pathLine(pathLine * a_pathLine);
void check_pathLineCart(pathLineCart * a_pathLineCart);
void check_pathLinePol(pathLinePol * a_pathLinePol);
void check_pathMinor(pathMinor * a_pathMinor);
void check_pathPoint(pathPoint * a_pathPoint);
void check_pathStm(pathStm * a_pathStm);
void check_pathSurface(pathSurface * a_pathSurface);
void check_pathSurfaceHeadcs(pathSurfaceHeadcs * a_pathSurfaceHeadcs);
void check_pathSurfaceHeadcsData(pathSurfaceHeadcsData * a_pathSurfaceHeadcsData);
void check_pathSurfacePcs(pathSurfacePcs * a_pathSurfacePcs);
void check_pathSurfacePcsData(pathSurfacePcsData * a_pathSurfacePcsData);
void check_pathSurfacePlain(pathSurfacePlain * a_pathSurfacePlain);
void check_pathUnknown(pathUnknown * a_pathUnknown);
void check_pcLabel(pcLabel * a_pcLabel);
void check_perptoConst(perptoConst * a_perptoConst);
void check_perptoConstAct(perptoConstAct * a_perptoConstAct);
void check_perptoConstNom(perptoConstNom * a_perptoConstNom);
void check_pierceConst(pierceConst * a_pierceConst);
void check_plLabel(plLabel * a_plLabel);
void check_plan(plan * a_plan);
void check_planidStm(planidStm * a_planidStm);
void check_pnLabel(pnLabel * a_pnLabel);
void check_pointRange(pointRange * a_pointRange);
void check_pointVecCart(pointVecCart * a_pointVecCart);
void check_pointVecPol(pointVecPol * a_pointVecPol);
void check_polPoint(polPoint * a_polPoint);
void check_popStm(popStm * a_popStm);
void check_posDir(posDir * a_posDir);
void check_prLabel(prLabel * a_prLabel);
void check_prcompStm(prcompStm * a_prcompStm);
void check_prevopStm(prevopStm * a_prevopStm);
void check_probeLocCart(probeLocCart * a_probeLocCart);
void check_probeLocPol(probeLocPol * a_probeLocPol);
void check_probeLocSnsCart(probeLocSnsCart * a_probeLocSnsCart);
void check_probeLocSnsVec(probeLocSnsVec * a_probeLocSnsVec);
void check_probeLocVec(probeLocVec * a_probeLocVec);
void check_probeLocation(probeLocation * a_probeLocation);
void check_probeOrient(probeOrient * a_probeOrient);
void check_probeOrient_HEADCS(probeOrient_HEADCS * a_probeOrient_HEADCS);
void check_probeOrient_PCS(probeOrient_PCS * a_probeOrient_PCS);
void check_probeOrient_VEC(probeOrient_VEC * a_probeOrient_VEC);
void check_probeOrient_featureLabel(probeOrient_featureLabel * a_probeOrient_featureLabel);
void check_procidStm(procidStm * a_procidStm);
void check_projctConst(projctConst * a_projctConst);
void check_projliConst(projliConst * a_projliConst);
void check_projptConst(projptConst * a_projptConst);
void check_promptIntEnd(promptIntEnd * a_promptIntEnd);
void check_promptIntEnd_promptItemList(promptIntEnd_promptItemList * a_promptIntEnd_promptItemList);
void check_promptIntEnd_stringVal(promptIntEnd_stringVal * a_promptIntEnd_stringVal);
void check_promptItem(promptItem * a_promptItem);
void check_promptItem_BUTTON(promptItem_BUTTON * a_promptItem_BUTTON);
void check_promptItem_CHECK(promptItem_CHECK * a_promptItem_CHECK);
void check_promptItem_EDIT(promptItem_EDIT * a_promptItem_EDIT);
void check_promptItem_GROUP(promptItem_GROUP * a_promptItem_GROUP);
void check_promptItem_LIST(promptItem_LIST * a_promptItem_LIST);
void check_promptItem_PICTURE(promptItem_PICTURE * a_promptItem_PICTURE);
void check_promptItem_PIXBTN(promptItem_PIXBTN * a_promptItem_PIXBTN);
void check_promptItem_SOUND(promptItem_SOUND * a_promptItem_SOUND);
void check_promptItem_TEXT(promptItem_TEXT * a_promptItem_TEXT);
void check_promptItem_TITLE(promptItem_TITLE * a_promptItem_TITLE);
void check_promptStm(promptStm * a_promptStm);
void check_promptStm_boolVar(promptStm_boolVar * a_promptStm_boolVar);
void check_promptStm_ccLabel(promptStm_ccLabel * a_promptStm_ccLabel);
void check_promptStm_ciLabel(promptStm_ciLabel * a_promptStm_ciLabel);
void check_promptStm_csLabel(promptStm_csLabel * a_promptStm_csLabel);
void check_promptStm_diLabel(promptStm_diLabel * a_promptStm_diLabel);
void check_promptStm_dsLabel(promptStm_dsLabel * a_promptStm_dsLabel);
void check_promptStm_dvLabel(promptStm_dvLabel * a_promptStm_dvLabel);
void check_promptStm_fiLabel(promptStm_fiLabel * a_promptStm_fiLabel);
void check_promptStm_fsLabel(promptStm_fsLabel * a_promptStm_fsLabel);
void check_promptStm_intVar(promptStm_intVar * a_promptStm_intVar);
void check_promptStm_liLabel(promptStm_liLabel * a_promptStm_liLabel);
void check_promptStm_mdLabel(promptStm_mdLabel * a_promptStm_mdLabel);
void check_promptStm_opLabel(promptStm_opLabel * a_promptStm_opLabel);
void check_promptStm_pcLabel(promptStm_pcLabel * a_promptStm_pcLabel);
void check_promptStm_plLabel(promptStm_plLabel * a_promptStm_plLabel);
void check_promptStm_pnLabel(promptStm_pnLabel * a_promptStm_pnLabel);
void check_promptStm_prLabel(promptStm_prLabel * a_promptStm_prLabel);
void check_promptStm_psLabel(promptStm_psLabel * a_promptStm_psLabel);
void check_promptStm_pvLabel(promptStm_pvLabel * a_promptStm_pvLabel);
void check_promptStm_qLabel(promptStm_qLabel * a_promptStm_qLabel);
void check_promptStm_realVar(promptStm_realVar * a_promptStm_realVar);
void check_promptStm_stringVar(promptStm_stringVar * a_promptStm_stringVar);
void check_promptStm_tlLabel(promptStm_tlLabel * a_promptStm_tlLabel);
void check_promptVar(promptVar * a_promptVar);
void check_psLabel(psLabel * a_psLabel);
void check_psthruMinor(psthruMinor * a_psthruMinor);
void check_psthruMinor_COMAND(psthruMinor_COMAND * a_psthruMinor_COMAND);
void check_psthruMinor_TRMATX(psthruMinor_TRMATX * a_psthruMinor_TRMATX);
void check_psthruStm(psthruStm * a_psthruStm);
void check_ptbuffStm(ptbuffStm * a_ptbuffStm);
void check_ptmeasEnd(ptmeasEnd * a_ptmeasEnd);
void check_ptmeasEnd_csSpec(ptmeasEnd_csSpec * a_ptmeasEnd_csSpec);
void check_ptmeasEnd_touchSpec(ptmeasEnd_touchSpec * a_ptmeasEnd_touchSpec);
void check_ptmeasStm(ptmeasStm * a_ptmeasStm);
void check_pushStm(pushStm * a_pushStm);
void check_pvLabel(pvLabel * a_pvLabel);
void check_qLabel(qLabel * a_qLabel);
void check_qisLabel(qisLabel * a_qisLabel);
void check_qisdefStm(qisdefStm * a_qisdefStm);
void check_rLabel(rLabel * a_rLabel);
void check_radiusSpec(radiusSpec * a_radiusSpec);
void check_rapidStm(rapidStm * a_rapidStm);
void check_readSpec(readSpec * a_readSpec);
void check_readStm(readStm * a_readStm);
void check_realConst(realConst * a_realConst);
void check_realExpr(realExpr * a_realExpr);
void check_realExprNegat(realExprNegat * a_realExprNegat);
void check_realExprParen(realExprParen * a_realExprParen);
void check_realExprPosit(realExprPosit * a_realExprPosit);
void check_realFunc(realFunc * a_realFunc);
void check_realFuncAbs(realFuncAbs * a_realFuncAbs);
void check_realFuncAcos(realFuncAcos * a_realFuncAcos);
void check_realFuncAsin(realFuncAsin * a_realFuncAsin);
void check_realFuncAtan(realFuncAtan * a_realFuncAtan);
void check_realFuncAtan2(realFuncAtan2 * a_realFuncAtan2);
void check_realFuncCos(realFuncCos * a_realFuncCos);
void check_realFuncDble(realFuncDble * a_realFuncDble);
void check_realFuncDtor(realFuncDtor * a_realFuncDtor);
void check_realFuncExp(realFuncExp * a_realFuncExp);
void check_realFuncLn(realFuncLn * a_realFuncLn);
void check_realFuncLog(realFuncLog * a_realFuncLog);
void check_realFuncMn(realFuncMn * a_realFuncMn);
void check_realFuncMod(realFuncMod * a_realFuncMod);
void check_realFuncMx(realFuncMx * a_realFuncMx);
void check_realFuncQtemp(realFuncQtemp * a_realFuncQtemp);
void check_realFuncRand(realFuncRand * a_realFuncRand);
void check_realFuncRl(realFuncRl * a_realFuncRl);
void check_realFuncRtod(realFuncRtod * a_realFuncRtod);
void check_realFuncSign(realFuncSign * a_realFuncSign);
void check_realFuncSin(realFuncSin * a_realFuncSin);
void check_realFuncSqrt(realFuncSqrt * a_realFuncSqrt);
void check_realFuncTan(realFuncTan * a_realFuncTan);
void check_realFuncVal(realFuncVal * a_realFuncVal);
void check_realFuncVdot(realFuncVdot * a_realFuncVdot);
void check_realFuncVecX(realFuncVecX * a_realFuncVecX);
void check_realFuncVecY(realFuncVecY * a_realFuncVecY);
void check_realFuncVecZ(realFuncVecZ * a_realFuncVecZ);
void check_realFuncVmag(realFuncVmag * a_realFuncVmag);
void check_realIntExpr(realIntExpr * a_realIntExpr);
void check_realIntExpr_DIVID(realIntExpr_DIVID * a_realIntExpr_DIVID);
void check_realIntExpr_MINUS(realIntExpr_MINUS * a_realIntExpr_MINUS);
void check_realIntExpr_PLUS(realIntExpr_PLUS * a_realIntExpr_PLUS);
void check_realIntExpr_POWER(realIntExpr_POWER * a_realIntExpr_POWER);
void check_realIntExpr_TIMES(realIntExpr_TIMES * a_realIntExpr_TIMES);
void check_realIntRel(realIntRel * a_realIntRel);
void check_realIntRel_EQ(realIntRel_EQ * a_realIntRel_EQ);
void check_realIntRel_GE(realIntRel_GE * a_realIntRel_GE);
void check_realIntRel_GT(realIntRel_GT * a_realIntRel_GT);
void check_realIntRel_LE(realIntRel_LE * a_realIntRel_LE);
void check_realIntRel_LT(realIntRel_LT * a_realIntRel_LT);
void check_realIntRel_NE(realIntRel_NE * a_realIntRel_NE);
void check_realRealExpr(realRealExpr * a_realRealExpr);
void check_realRealExpr_DIVID(realRealExpr_DIVID * a_realRealExpr_DIVID);
void check_realRealExpr_MINUS(realRealExpr_MINUS * a_realRealExpr_MINUS);
void check_realRealExpr_PLUS(realRealExpr_PLUS * a_realRealExpr_PLUS);
void check_realRealExpr_POWER(realRealExpr_POWER * a_realRealExpr_POWER);
void check_realRealExpr_TIMES(realRealExpr_TIMES * a_realRealExpr_TIMES);
void check_realRealRel(realRealRel * a_realRealRel);
void check_realRealRel_EQ(realRealRel_EQ * a_realRealRel_EQ);
void check_realRealRel_GE(realRealRel_GE * a_realRealRel_GE);
void check_realRealRel_GT(realRealRel_GT * a_realRealRel_GT);
void check_realRealRel_LE(realRealRel_LE * a_realRealRel_LE);
void check_realRealRel_LT(realRealRel_LT * a_realRealRel_LT);
void check_realRealRel_NE(realRealRel_NE * a_realRealRel_NE);
void check_realRel(realRel * a_realRel);
void check_realVal(realVal * a_realVal);
void check_realVar(realVar * a_realVar);
void check_realVecExpr_TIMES(realVecExpr_TIMES * a_realVecExpr_TIMES);
void check_recallDMLStm(recallDMLStm * a_recallDMLStm);
void check_recallDatumStm(recallDatumStm * a_recallDatumStm);
void check_recallFeatureStm(recallFeatureStm * a_recallFeatureStm);
void check_recallRotaryTableStm(recallRotaryTableStm * a_recallRotaryTableStm);
void check_recallSensorStm(recallSensorStm * a_recallSensorStm);
void check_refmntStm(refmntStm * a_refmntStm);
void check_rentVal(rentVal * a_rentVal);
void check_reportItem(reportItem * a_reportItem);
void check_reportItem_qisLabel(reportItem_qisLabel * a_reportItem_qisLabel);
void check_reportStm(reportStm * a_reportStm);
void check_resumeMinor(resumeMinor * a_resumeMinor);
void check_resumeMinor_jumpLabel(resumeMinor_jumpLabel * a_resumeMinor_jumpLabel);
void check_resumeStm(resumeStm * a_resumeStm);
void check_retrieve1(retrieve1 * a_retrieve1);
void check_retrieve2(retrieve2 * a_retrieve2);
void check_retrieve2b(retrieve2b * a_retrieve2b);
void check_retrieve4(retrieve4 * a_retrieve4);
void check_rightyLefty(rightyLefty * a_rightyLefty);
void check_rmLabel(rmLabel * a_rmLabel);
void check_rmeasArc(rmeasArc * a_rmeasArc);
void check_rmeasArc_rmeasSpecFa(rmeasArc_rmeasSpecFa * a_rmeasArc_rmeasSpecFa);
void check_rmeasArc_rmeasSpecVecbld(rmeasArc_rmeasSpecVecbld * a_rmeasArc_rmeasSpecVecbld);
void check_rmeasCircle(rmeasCircle * a_rmeasCircle);
void check_rmeasCircle_rmeasSpecFa(rmeasCircle_rmeasSpecFa * a_rmeasCircle_rmeasSpecFa);
void check_rmeasCircle_rmeasSpecVecbld(rmeasCircle_rmeasSpecVecbld * a_rmeasCircle_rmeasSpecVecbld);
void check_rmeasCone(rmeasCone * a_rmeasCone);
void check_rmeasCparln(rmeasCparln * a_rmeasCparln);
void check_rmeasCparln_rmeasSpecFaOrient(rmeasCparln_rmeasSpecFaOrient * a_rmeasCparln_rmeasSpecFaOrient);
void check_rmeasCparln_rmeasSpecVecbldOrient(rmeasCparln_rmeasSpecVecbldOrient * a_rmeasCparln_rmeasSpecVecbldOrient);
void check_rmeasCylndr(rmeasCylndr * a_rmeasCylndr);
void check_rmeasEdgept(rmeasEdgept * a_rmeasEdgept);
void check_rmeasEdgept_rmeasSpecFaAxis(rmeasEdgept_rmeasSpecFaAxis * a_rmeasEdgept_rmeasSpecFaAxis);
void check_rmeasEdgept_rmeasSpecVecbldEdgept(rmeasEdgept_rmeasSpecVecbldEdgept * a_rmeasEdgept_rmeasSpecVecbldEdgept);
void check_rmeasEllips(rmeasEllips * a_rmeasEllips);
void check_rmeasEllips_rmeasSpecFa(rmeasEllips_rmeasSpecFa * a_rmeasEllips_rmeasSpecFa);
void check_rmeasEllips_rmeasSpecVecbld(rmeasEllips_rmeasSpecVecbld * a_rmeasEllips_rmeasSpecVecbld);
void check_rmeasGcurve(rmeasGcurve * a_rmeasGcurve);
void check_rmeasGcurve_rmeasSpecFeatAxis(rmeasGcurve_rmeasSpecFeatAxis * a_rmeasGcurve_rmeasSpecFeatAxis);
void check_rmeasGcurve_rmeasSpecVecbld(rmeasGcurve_rmeasSpecVecbld * a_rmeasGcurve_rmeasSpecVecbld);
void check_rmeasGsurf(rmeasGsurf * a_rmeasGsurf);
void check_rmeasLine(rmeasLine * a_rmeasLine);
void check_rmeasLine_rmeasSpecFeatAxis(rmeasLine_rmeasSpecFeatAxis * a_rmeasLine_rmeasSpecFeatAxis);
void check_rmeasLine_rmeasSpecVecbld(rmeasLine_rmeasSpecVecbld * a_rmeasLine_rmeasSpecVecbld);
void check_rmeasMinor(rmeasMinor * a_rmeasMinor);
void check_rmeasObject(rmeasObject * a_rmeasObject);
void check_rmeasObject_rmeasSpecFa(rmeasObject_rmeasSpecFa * a_rmeasObject_rmeasSpecFa);
void check_rmeasObject_rmeasSpecVecbld(rmeasObject_rmeasSpecVecbld * a_rmeasObject_rmeasSpecVecbld);
void check_rmeasParpln(rmeasParpln * a_rmeasParpln);
void check_rmeasPlane(rmeasPlane * a_rmeasPlane);
void check_rmeasPoint(rmeasPoint * a_rmeasPoint);
void check_rmeasPoint_rmeasSpecFaAxis(rmeasPoint_rmeasSpecFaAxis * a_rmeasPoint_rmeasSpecFaAxis);
void check_rmeasPoint_rmeasSpecVecbld(rmeasPoint_rmeasSpecVecbld * a_rmeasPoint_rmeasSpecVecbld);
void check_rmeasRctngl(rmeasRctngl * a_rmeasRctngl);
void check_rmeasSpecFa(rmeasSpecFa * a_rmeasSpecFa);
void check_rmeasSpecFaAxis(rmeasSpecFaAxis * a_rmeasSpecFaAxis);
void check_rmeasSpecFaAxis_axis(rmeasSpecFaAxis_axis * a_rmeasSpecFaAxis_axis);
void check_rmeasSpecFaAxis_faLabel(rmeasSpecFaAxis_faLabel * a_rmeasSpecFaAxis_faLabel);
void check_rmeasSpecFaOrient(rmeasSpecFaOrient * a_rmeasSpecFaOrient);
void check_rmeasSpecFeatAxis(rmeasSpecFeatAxis * a_rmeasSpecFeatAxis);
void check_rmeasSpecFeatAxis_axis(rmeasSpecFeatAxis_axis * a_rmeasSpecFeatAxis_axis);
void check_rmeasSpecFeatAxis_featureLabel1(rmeasSpecFeatAxis_featureLabel1 * a_rmeasSpecFeatAxis_featureLabel1);
void check_rmeasSpecVecbld(rmeasSpecVecbld * a_rmeasSpecVecbld);
void check_rmeasSpecVecbldEdgept(rmeasSpecVecbldEdgept * a_rmeasSpecVecbldEdgept);
void check_rmeasSpecVecbldOrient(rmeasSpecVecbldOrient * a_rmeasSpecVecbldOrient);
void check_rmeasSphere(rmeasSphere * a_rmeasSphere);
void check_rmeasStm(rmeasStm * a_rmeasStm);
void check_rmeasSympln(rmeasSympln * a_rmeasSympln);
void check_rmeasTorus(rmeasTorus * a_rmeasTorus);
void check_rotAbs(rotAbs * a_rotAbs);
void check_rotDir(rotDir * a_rotDir);
void check_rotDir_rotOrient(rotDir_rotOrient * a_rotDir_rotOrient);
void check_rotIncr(rotIncr * a_rotIncr);
void check_rotOrient(rotOrient * a_rotOrient);
void check_rotType(rotType * a_rotType);
void check_rotabAbs(rotabAbs * a_rotabAbs);
void check_rotabFeat(rotabFeat * a_rotabFeat);
void check_rotabIncr(rotabIncr * a_rotabIncr);
void check_rotabMinor(rotabMinor * a_rotabMinor);
void check_rotabStm(rotabStm * a_rotabStm);
void check_rotateDatum(rotateDatum * a_rotateDatum);
void check_rotateFeature(rotateFeature * a_rotateFeature);
void check_rotateMinor(rotateMinor * a_rotateMinor);
void check_rotateStm(rotateStm * a_rotateStm);
void check_rotateValue(rotateValue * a_rotateValue);
void check_rotdefStm(rotdefStm * a_rotdefStm);
void check_rotsetStm(rotsetStm * a_rotsetStm);
void check_rtLabel(rtLabel * a_rtLabel);
void check_rwFormat(rwFormat * a_rwFormat);
void check_rwVar(rwVar * a_rwVar);
void check_sLabel(sLabel * a_sLabel);
void check_saLabel(saLabel * a_saLabel);
void check_saveDMLStm(saveDMLStm * a_saveDMLStm);
void check_saveDatumStm(saveDatumStm * a_saveDatumStm);
void check_saveFeatureStm(saveFeatureStm * a_saveFeatureStm);
void check_saveRotaryTableStm(saveRotaryTableStm * a_saveRotaryTableStm);
void check_saveSensorStm(saveSensorStm * a_saveSensorStm);
void check_scnmodStm(scnmodStm * a_scnmodStm);
void check_scnsetDrag(scnsetDrag * a_scnsetDrag);
void check_scnsetMinor(scnsetMinor * a_scnsetMinor);
void check_scnsetNoncon(scnsetNoncon * a_scnsetNoncon);
void check_scnsetPeck(scnsetPeck * a_scnsetPeck);
void check_scnsetSample(scnsetSample * a_scnsetSample);
void check_scnsetSampleDrag(scnsetSampleDrag * a_scnsetSampleDrag);
void check_scnsetSampleDrag_ANGLE(scnsetSampleDrag_ANGLE * a_scnsetSampleDrag_ANGLE);
void check_scnsetSampleDrag_CHORD(scnsetSampleDrag_CHORD * a_scnsetSampleDrag_CHORD);
void check_scnsetSampleDrag_DEFALT(scnsetSampleDrag_DEFALT * a_scnsetSampleDrag_DEFALT);
void check_scnsetSampleDrag_DIST(scnsetSampleDrag_DIST * a_scnsetSampleDrag_DIST);
void check_scnsetSampleDrag_TIME(scnsetSampleDrag_TIME * a_scnsetSampleDrag_TIME);
void check_scnsetSample_ANGLE(scnsetSample_ANGLE * a_scnsetSample_ANGLE);
void check_scnsetSample_CHORD(scnsetSample_CHORD * a_scnsetSample_CHORD);
void check_scnsetSample_DIST(scnsetSample_DIST * a_scnsetSample_DIST);
void check_scnsetSample_TIME(scnsetSample_TIME * a_scnsetSample_TIME);
void check_scnsetStm(scnsetStm * a_scnsetStm);
void check_scnsetStop(scnsetStop * a_scnsetStop);
void check_scnsetStopPlane(scnsetStopPlane * a_scnsetStopPlane);
void check_scnsetStopSphere(scnsetStopSphere * a_scnsetStopSphere);
void check_scnsetVendor(scnsetVendor * a_scnsetVendor);
void check_seLabel(seLabel * a_seLabel);
void check_secondsString(secondsString * a_secondsString);
void check_secondsString_INTSTRING(secondsString_INTSTRING * a_secondsString_INTSTRING);
void check_secondsString_REALSTRING(secondsString_REALSTRING * a_secondsString_REALSTRING);
void check_selectBlock(selectBlock * a_selectBlock);
void check_selectStm(selectStm * a_selectStm);
void check_selectStmInt(selectStmInt * a_selectStmInt);
void check_selectStmString(selectStmString * a_selectStmString);
void check_sensorArea(sensorArea * a_sensorArea);
void check_sensorGeometry(sensorGeometry * a_sensorGeometry);
void check_sensorInfred(sensorInfred * a_sensorInfred);
void check_sensorItem(sensorItem * a_sensorItem);
void check_sensorItem_intVal(sensorItem_intVal * a_sensorItem_intVal);
void check_sensorItem_stringVal(sensorItem_stringVal * a_sensorItem_stringVal);
void check_sensorLabel1(sensorLabel1 * a_sensorLabel1);
void check_sensorLabel2(sensorLabel2 * a_sensorLabel2);
void check_sensorLaser(sensorLaser * a_sensorLaser);
void check_sensorLine(sensorLine * a_sensorLine);
void check_sensorMinor(sensorMinor * a_sensorMinor);
void check_sensorMltprb(sensorMltprb * a_sensorMltprb);
void check_sensorMltprbItem(sensorMltprbItem * a_sensorMltprbItem);
void check_sensorMltprbItem_intVal(sensorMltprbItem_intVal * a_sensorMltprbItem_intVal);
void check_sensorMltprbItem_stringVal(sensorMltprbItem_stringVal * a_sensorMltprbItem_stringVal);
void check_sensorMove(sensorMove * a_sensorMove);
void check_sensorMove_gotoWristList(sensorMove_gotoWristList * a_sensorMove_gotoWristList);
void check_sensorMove_probeOrient(sensorMove_probeOrient * a_sensorMove_probeOrient);
void check_sensorMove_saLabel(sensorMove_saLabel * a_sensorMove_saLabel);
void check_sensorNoncon(sensorNoncon * a_sensorNoncon);
void check_sensorPoint(sensorPoint * a_sensorPoint);
void check_sensorProbe(sensorProbe * a_sensorProbe);
void check_sensorProbeForm(sensorProbeForm * a_sensorProbeForm);
void check_sensorProbeForm_CYLNDR(sensorProbeForm_CYLNDR * a_sensorProbeForm_CYLNDR);
void check_sensorProbeForm_DISK(sensorProbeForm_DISK * a_sensorProbeForm_DISK);
void check_sensorProbeGeometry(sensorProbeGeometry * a_sensorProbeGeometry);
void check_sensorStm(sensorStm * a_sensorStm);
void check_sensorVideo(sensorVideo * a_sensorVideo);
void check_sgLabel(sgLabel * a_sgLabel);
void check_sgageConst(sgageConst * a_sgageConst);
void check_sgsLabel(sgsLabel * a_sgsLabel);
void check_sign(sign * a_sign);
void check_simreqtBlock(simreqtBlock * a_simreqtBlock);
void check_simreqtMinor(simreqtMinor * a_simreqtMinor);
void check_simreqtStm(simreqtStm * a_simreqtStm);
void check_snsdefBuild(snsdefBuild * a_snsdefBuild);
void check_snsdefBuildItem(snsdefBuildItem * a_snsdefBuildItem);
void check_snsdefBuildItem_rmLabel(snsdefBuildItem_rmLabel * a_snsdefBuildItem_rmLabel);
void check_snsdefBuildItem_sgLabel(snsdefBuildItem_sgLabel * a_snsdefBuildItem_sgLabel);
void check_snsdefBuildItem_swLabel(snsdefBuildItem_swLabel * a_snsdefBuildItem_swLabel);
void check_snsdefBuildItem_sxLabel(snsdefBuildItem_sxLabel * a_snsdefBuildItem_sxLabel);
void check_snsdefBuildSensor(snsdefBuildSensor * a_snsdefBuildSensor);
void check_snsdefInfred(snsdefInfred * a_snsdefInfred);
void check_snsdefLaser(snsdefLaser * a_snsdefLaser);
void check_snsdefLocation(snsdefLocation * a_snsdefLocation);
void check_snsdefLocation_CART(snsdefLocation_CART * a_snsdefLocation_CART);
void check_snsdefLocation_POL(snsdefLocation_POL * a_snsdefLocation_POL);
void check_snsdefLocation_VEC(snsdefLocation_VEC * a_snsdefLocation_VEC);
void check_snsdefMinor(snsdefMinor * a_snsdefMinor);
void check_snsdefNoncon(snsdefNoncon * a_snsdefNoncon);
void check_snsdefProbe(snsdefProbe * a_snsdefProbe);
void check_snsdefProbeForm(snsdefProbeForm * a_snsdefProbeForm);
void check_snsdefProbeForm_CYLNDR(snsdefProbeForm_CYLNDR * a_snsdefProbeForm_CYLNDR);
void check_snsdefProbeForm_DISK(snsdefProbeForm_DISK * a_snsdefProbeForm_DISK);
void check_snsdefStm(snsdefStm * a_snsdefStm);
void check_snsdefType(snsdefType * a_snsdefType);
void check_snsdefVideo(snsdefVideo * a_snsdefVideo);
void check_snsdefWristAngleItem(snsdefWristAngleItem * a_snsdefWristAngleItem);
void check_snsetFeat(snsetFeat * a_snsetFeat);
void check_snsetItem(snsetItem * a_snsetItem);
void check_snsetItem_CLRSRF(snsetItem_CLRSRF * a_snsetItem_CLRSRF);
void check_snsetItem_DEPTH(snsetItem_DEPTH * a_snsetItem_DEPTH);
void check_snsetItem_snsetLabel(snsetItem_snsetLabel * a_snsetItem_snsetLabel);
void check_snsetItem_snsetLabelAndValue(snsetItem_snsetLabelAndValue * a_snsetItem_snsetLabelAndValue);
void check_snsetItem_snsetToggle(snsetItem_snsetToggle * a_snsetItem_snsetToggle);
void check_snsetItem_snsetType(snsetItem_snsetType * a_snsetItem_snsetType);
void check_snsetItem_snsetTypeAndValue(snsetItem_snsetTypeAndValue * a_snsetItem_snsetTypeAndValue);
void check_snsetLabel(snsetLabel * a_snsetLabel);
void check_snsetLabelAndValue(snsetLabelAndValue * a_snsetLabelAndValue);
void check_snsetStm(snsetStm * a_snsetStm);
void check_snsetToggle(snsetToggle * a_snsetToggle);
void check_snsetType(snsetType * a_snsetType);
void check_snsetTypeAndValue(snsetTypeAndValue * a_snsetTypeAndValue);
void check_snsetTypeAndValue_APPRCH(snsetTypeAndValue_APPRCH * a_snsetTypeAndValue_APPRCH);
void check_snsetTypeAndValue_CLRSRF(snsetTypeAndValue_CLRSRF * a_snsetTypeAndValue_CLRSRF);
void check_snsetTypeAndValue_DEPTH(snsetTypeAndValue_DEPTH * a_snsetTypeAndValue_DEPTH);
void check_snsetTypeAndValue_MINCON(snsetTypeAndValue_MINCON * a_snsetTypeAndValue_MINCON);
void check_snsetTypeAndValue_RETRCT(snsetTypeAndValue_RETRCT * a_snsetTypeAndValue_RETRCT);
void check_snsetTypeAndValue_SCALEX(snsetTypeAndValue_SCALEX * a_snsetTypeAndValue_SCALEX);
void check_snsetTypeAndValue_SCALEY(snsetTypeAndValue_SCALEY * a_snsetTypeAndValue_SCALEY);
void check_snsetTypeAndValue_SEARCH(snsetTypeAndValue_SEARCH * a_snsetTypeAndValue_SEARCH);
void check_snsgrpItem(snsgrpItem * a_snsgrpItem);
void check_snsgrpMinor(snsgrpMinor * a_snsgrpMinor);
void check_snsgrpMinor_sgsLabel(snsgrpMinor_sgsLabel * a_snsgrpMinor_sgsLabel);
void check_snsgrpMinor_ssLabel(snsgrpMinor_ssLabel * a_snsgrpMinor_ssLabel);
void check_snsgrpStm(snsgrpStm * a_snsgrpStm);
void check_snslctData(snslctData * a_snslctData);
void check_snslctData_probeOrient(snslctData_probeOrient * a_snslctData_probeOrient);
void check_snslctData_snslctWristList(snslctData_snslctWristList * a_snslctData_snslctWristList);
void check_snslctGroup(snslctGroup * a_snslctGroup);
void check_snslctGroupFeat(snslctGroupFeat * a_snslctGroupFeat);
void check_snslctGroupVec(snslctGroupVec * a_snslctGroupVec);
void check_snslctSensor(snslctSensor * a_snslctSensor);
void check_snslctSensorList(snslctSensorList * a_snslctSensorList);
void check_snslctSensorTip(snslctSensorTip * a_snslctSensorTip);
void check_snslctStm(snslctStm * a_snslctStm);
void check_snslctStmGroup(snslctStmGroup * a_snslctStmGroup);
void check_snslctStmSensor(snslctStmSensor * a_snslctStmSensor);
void check_snslctTipData(snslctTipData * a_snslctTipData);
void check_snslctWristAngleAngle(snslctWristAngleAngle * a_snslctWristAngleAngle);
void check_snslctWristAngleFeat(snslctWristAngleFeat * a_snslctWristAngleFeat);
void check_snslctWristAngleItem(snslctWristAngleItem * a_snslctWristAngleItem);
void check_snslctWristAngleVec(snslctWristAngleVec * a_snslctWristAngleVec);
void check_snslctWristItem(snslctWristItem * a_snslctWristItem);
void check_snsmntMinor(snsmntMinor * a_snsmntMinor);
void check_snsmntStm(snsmntStm * a_snsmntStm);
void check_spartConst(spartConst * a_spartConst);
void check_srLabel(srLabel * a_srLabel);
void check_sraLabel(sraLabel * a_sraLabel);
void check_ssLabel(ssLabel * a_ssLabel);
void check_stLabel(stLabel * a_stLabel);
void check_stackElement(stackElement * a_stackElement);
void check_state(state * a_state);
void check_storageSpec(storageSpec * a_storageSpec);
void check_strVar7(strVar7 * a_strVar7);
void check_stringConst(stringConst * a_stringConst);
void check_stringFunc(stringFunc * a_stringFunc);
void check_stringFuncChr(stringFuncChr * a_stringFuncChr);
void check_stringFuncConcat(stringFuncConcat * a_stringFuncConcat);
void check_stringFuncElemnt(stringFuncElemnt * a_stringFuncElemnt);
void check_stringFuncLwc(stringFuncLwc * a_stringFuncLwc);
void check_stringFuncRpt(stringFuncRpt * a_stringFuncRpt);
void check_stringFuncSelapsetime(stringFuncSelapsetime * a_stringFuncSelapsetime);
void check_stringFuncStr(stringFuncStr * a_stringFuncStr);
void check_stringFuncSubstr(stringFuncSubstr * a_stringFuncSubstr);
void check_stringFuncTrim(stringFuncTrim * a_stringFuncTrim);
void check_stringFuncUpc(stringFuncUpc * a_stringFuncUpc);
void check_stringRel(stringRel * a_stringRel);
void check_stringRel_EQ(stringRel_EQ * a_stringRel_EQ);
void check_stringRel_GE(stringRel_GE * a_stringRel_GE);
void check_stringRel_GT(stringRel_GT * a_stringRel_GT);
void check_stringRel_LE(stringRel_LE * a_stringRel_LE);
void check_stringRel_LT(stringRel_LT * a_stringRel_LT);
void check_stringRel_NE(stringRel_NE * a_stringRel_NE);
void check_stringVal(stringVal * a_stringVal);
void check_stringVar(stringVar * a_stringVar);
void check_surfPtdataHeadcsListItem(surfPtdataHeadcsListItem * a_surfPtdataHeadcsListItem);
void check_surfPtdataListItem(surfPtdataListItem * a_surfPtdataListItem);
void check_surfPtdataPcsListItem(surfPtdataPcsListItem * a_surfPtdataPcsListItem);
void check_swLabel(swLabel * a_swLabel);
void check_sxLabel(sxLabel * a_sxLabel);
void check_tLabel(tLabel * a_tLabel);
void check_taLabel(taLabel * a_taLabel);
void check_tantoConst(tantoConst * a_tantoConst);
void check_tantoConstF(tantoConstF * a_tantoConstF);
void check_tantoConstFa(tantoConstFa * a_tantoConstFa);
void check_tantoConstPlane(tantoConstPlane * a_tantoConstPlane);
void check_tantoConstPlaneF(tantoConstPlaneF * a_tantoConstPlaneF);
void check_tantoConstPlaneFa(tantoConstPlaneFa * a_tantoConstPlaneFa);
void check_tecompDatum(tecompDatum * a_tecompDatum);
void check_tecompMinor(tecompMinor * a_tecompMinor);
void check_tecompMinorMach(tecompMinorMach * a_tecompMinorMach);
void check_tecompMinorOnAll(tecompMinorOnAll * a_tecompMinorOnAll);
void check_tecompMinorOnList(tecompMinorOnList * a_tecompMinorOnList);
void check_tecompOffset(tecompOffset * a_tecompOffset);
void check_tecompStm(tecompStm * a_tecompStm);
void check_tecompVar2(tecompVar2 * a_tecompVar2);
void check_tempUnit(tempUnit * a_tempUnit);
void check_textMan(textMan * a_textMan);
void check_textMinor(textMinor * a_textMinor);
void check_textOper(textOper * a_textOper);
void check_textOutfil(textOutfil * a_textOutfil);
void check_textQuery(textQuery * a_textQuery);
void check_textQueryFormat(textQueryFormat * a_textQueryFormat);
void check_textStm(textStm * a_textStm);
void check_textType(textType * a_textType);
void check_thLabel(thLabel * a_thLabel);
void check_thldefPocket(thldefPocket * a_thldefPocket);
void check_thldefPocket_rmLabel(thldefPocket_rmLabel * a_thldefPocket_rmLabel);
void check_thldefPocket_sLabel(thldefPocket_sLabel * a_thldefPocket_sLabel);
void check_thldefPocket_sgLabel(thldefPocket_sgLabel * a_thldefPocket_sgLabel);
void check_thldefPocket_sgsLabel(thldefPocket_sgsLabel * a_thldefPocket_sgsLabel);
void check_thldefPocket_ssLabel(thldefPocket_ssLabel * a_thldefPocket_ssLabel);
void check_thldefPocket_swLabel(thldefPocket_swLabel * a_thldefPocket_swLabel);
void check_thldefPocket_sxLabel(thldefPocket_sxLabel * a_thldefPocket_sxLabel);
void check_thldefStm(thldefStm * a_thldefStm);
void check_tier(tier * a_tier);
void check_tlLabel(tlLabel * a_tlLabel);
void check_tolAnglStm(tolAnglStm * a_tolAnglStm);
void check_tolAnglbStm(tolAnglbStm * a_tolAnglbStm);
void check_tolAnglrStm(tolAnglrStm * a_tolAnglrStm);
void check_tolAnglwrtStm(tolAnglwrtStm * a_tolAnglwrtStm);
void check_tolAppData(tolAppData * a_tolAppData);
void check_tolCirltyStm(tolCirltyStm * a_tolCirltyStm);
void check_tolCompos1(tolCompos1 * a_tolCompos1);
void check_tolCompos2(tolCompos2 * a_tolCompos2);
void check_tolComposStm(tolComposStm * a_tolComposStm);
void check_tolConcenStm(tolConcenStm * a_tolConcenStm);
void check_tolCortolAngle(tolCortolAngle * a_tolCortolAngle);
void check_tolCortolAxis(tolCortolAxis * a_tolCortolAxis);
void check_tolCortolMinor(tolCortolMinor * a_tolCortolMinor);
void check_tolCortolRadial(tolCortolRadial * a_tolCortolRadial);
void check_tolCortolStm(tolCortolStm * a_tolCortolStm);
void check_tolCprofSpec(tolCprofSpec * a_tolCprofSpec);
void check_tolCprofSpecC(tolCprofSpecC * a_tolCprofSpecC);
void check_tolCproflStm(tolCproflStm * a_tolCproflStm);
void check_tolCprofsStm(tolCprofsStm * a_tolCprofsStm);
void check_tolCrnoutStm(tolCrnoutStm * a_tolCrnoutStm);
void check_tolCylctyStm(tolCylctyStm * a_tolCylctyStm);
void check_tolDiamAvg(tolDiamAvg * a_tolDiamAvg);
void check_tolDiamMinmax(tolDiamMinmax * a_tolDiamMinmax);
void check_tolDiamMinor(tolDiamMinor * a_tolDiamMinor);
void check_tolDiamPlain(tolDiamPlain * a_tolDiamPlain);
void check_tolDiamStm(tolDiamStm * a_tolDiamStm);
void check_tolDistbDir(tolDistbDir * a_tolDistbDir);
void check_tolDistbLimit(tolDistbLimit * a_tolDistbLimit);
void check_tolDistbNominl(tolDistbNominl * a_tolDistbNominl);
void check_tolDistbStm(tolDistbStm * a_tolDistbStm);
void check_tolDistbTol(tolDistbTol * a_tolDistbTol);
void check_tolDistwrtStm(tolDistwrtStm * a_tolDistwrtStm);
void check_tolFeatMaxMat(tolFeatMaxMat * a_tolFeatMaxMat);
void check_tolFeatMaxMat_datLabel(tolFeatMaxMat_datLabel * a_tolFeatMaxMat_datLabel);
void check_tolFeatMaxMat_fLabel(tolFeatMaxMat_fLabel * a_tolFeatMaxMat_fLabel);
void check_tolFeatMaxMat_faLabel(tolFeatMaxMat_faLabel * a_tolFeatMaxMat_faLabel);
void check_tolFeature(tolFeature * a_tolFeature);
void check_tolFeatureMat(tolFeatureMat * a_tolFeatureMat);
void check_tolFeatureMat_datLabel(tolFeatureMat_datLabel * a_tolFeatureMat_datLabel);
void check_tolFeatureMat_fLabel(tolFeatureMat_fLabel * a_tolFeatureMat_fLabel);
void check_tolFeatureMat_faLabel(tolFeatureMat_faLabel * a_tolFeatureMat_faLabel);
void check_tolFlatMinor(tolFlatMinor * a_tolFlatMinor);
void check_tolFlatPer(tolFlatPer * a_tolFlatPer);
void check_tolFlatStm(tolFlatStm * a_tolFlatStm);
void check_tolFlatZon(tolFlatZon * a_tolFlatZon);
void check_tolFlatZonPer(tolFlatZonPer * a_tolFlatZonPer);
void check_tolGtolRot(tolGtolRot * a_tolGtolRot);
void check_tolGtolSpec(tolGtolSpec * a_tolGtolSpec);
void check_tolGtolStm(tolGtolStm * a_tolGtolStm);
void check_tolGtolTrans(tolGtolTrans * a_tolGtolTrans);
void check_tolMatCond(tolMatCond * a_tolMatCond);
void check_tolMaxMatCond(tolMaxMatCond * a_tolMaxMatCond);
void check_tolMaxMatCond_LMC(tolMaxMatCond_LMC * a_tolMaxMatCond_LMC);
void check_tolMaxMatCond_MMC(tolMaxMatCond_MMC * a_tolMaxMatCond_MMC);
void check_tolParlelStm(tolParlelStm * a_tolParlelStm);
void check_tolPerpStm(tolPerpStm * a_tolPerpStm);
void check_tolPosEnd(tolPosEnd * a_tolPosEnd);
void check_tolPosMethod(tolPosMethod * a_tolPosMethod);
void check_tolPosMethod_VEC(tolPosMethod_VEC * a_tolPosMethod_VEC);
void check_tolPosStart(tolPosStart * a_tolPosStart);
void check_tolPosStart_THREED(tolPosStart_THREED * a_tolPosStart_THREED);
void check_tolPosStart_TWOD(tolPosStart_TWOD * a_tolPosStart_TWOD);
void check_tolPosStm(tolPosStm * a_tolPosStm);
void check_tolProflStm(tolProflStm * a_tolProflStm);
void check_tolProfpStm(tolProfpStm * a_tolProfpStm);
void check_tolProfsStm(tolProfsStm * a_tolProfsStm);
void check_tolRadSpec(tolRadSpec * a_tolRadSpec);
void check_tolRadStm(tolRadStm * a_tolRadStm);
void check_tolStrghtMat(tolStrghtMat * a_tolStrghtMat);
void check_tolStrghtMinor(tolStrghtMinor * a_tolStrghtMinor);
void check_tolStrghtPer1(tolStrghtPer1 * a_tolStrghtPer1);
void check_tolStrghtPer2(tolStrghtPer2 * a_tolStrghtPer2);
void check_tolStrghtPlain(tolStrghtPlain * a_tolStrghtPlain);
void check_tolStrghtStm(tolStrghtStm * a_tolStrghtStm);
void check_tolSymStm(tolSymStm * a_tolSymStm);
void check_tolTrnoutStm(tolTrnoutStm * a_tolTrnoutStm);
void check_tolUsetolStm(tolUsetolStm * a_tolUsetolStm);
void check_tolWidthDir(tolWidthDir * a_tolWidthDir);
void check_tolWidthDir_vector(tolWidthDir_vector * a_tolWidthDir_vector);
void check_tolWidthStm(tolWidthStm * a_tolWidthStm);
void check_tolZoneDir(tolZoneDir * a_tolZoneDir);
void check_tolZoneDir2(tolZoneDir2 * a_tolZoneDir2);
void check_tolZoneDir2_VEC(tolZoneDir2_VEC * a_tolZoneDir2_VEC);
void check_tolZoneDir3(tolZoneDir3 * a_tolZoneDir3);
void check_tolZoneDir3_VEC(tolZoneDir3_VEC * a_tolZoneDir3_VEC);
void check_tolZoneDir_VEC(tolZoneDir_VEC * a_tolZoneDir_VEC);
void check_tolZoneType(tolZoneType * a_tolZoneType);
void check_toleranceLabel(toleranceLabel * a_toleranceLabel);
void check_tooldfStm(tooldfStm * a_tooldfStm);
void check_touchSpec(touchSpec * a_touchSpec);
void check_trConst(trConst * a_trConst);
void check_transDatum(transDatum * a_transDatum);
void check_transFeature(transFeature * a_transFeature);
void check_transMinor(transMinor * a_transMinor);
void check_transProbe(transProbe * a_transProbe);
void check_transProbe_MINUSPRBRAD(transProbe_MINUSPRBRAD * a_transProbe_MINUSPRBRAD);
void check_transProbe_PRBRAD(transProbe_PRBRAD * a_transProbe_PRBRAD);
void check_transStm(transStm * a_transStm);
void check_transValue(transValue * a_transValue);
void check_typePoint(typePoint * a_typePoint);
void check_uLabel(uLabel * a_uLabel);
void check_uncertMinor(uncertMinor * a_uncertMinor);
void check_uncertMinor_ALGOR(uncertMinor_ALGOR * a_uncertMinor_ALGOR);
void check_uncertMinor_stringVal(uncertMinor_stringVal * a_uncertMinor_stringVal);
void check_uncertVar3(uncertVar3 * a_uncertVar3);
void check_uncertVar3_DME(uncertVar3_DME * a_uncertVar3_DME);
void check_uncertVar3_SENS(uncertVar3_SENS * a_uncertVar3_SENS);
void check_uncertVar3_paramList(uncertVar3_paramList * a_uncertVar3_paramList);
void check_uncertalgStm(uncertalgStm * a_uncertalgStm);
void check_uncertsetMinor(uncertsetMinor * a_uncertsetMinor);
void check_uncertsetMinor_ON(uncertsetMinor_ON * a_uncertsetMinor_ON);
void check_uncertsetStm(uncertsetStm * a_uncertsetStm);
void check_uncertsetVar2(uncertsetVar2 * a_uncertsetVar2);
void check_uncertsetVar2_drLabel(uncertsetVar2_drLabel * a_uncertsetVar2_drLabel);
void check_unitsStm(unitsStm * a_unitsStm);
void check_vLabel(vLabel * a_vLabel);
void check_vaLabel(vaLabel * a_vaLabel);
void check_valueAclratReal(valueAclratReal * a_valueAclratReal);
void check_valueAclratString(valueAclratString * a_valueAclratString);
void check_valueBoundInt(valueBoundInt * a_valueBoundInt);
void check_valueBoundInt_featureLabel(valueBoundInt_featureLabel * a_valueBoundInt_featureLabel);
void check_valueBoundInt_toleranceLabel(valueBoundInt_toleranceLabel * a_valueBoundInt_toleranceLabel);
void check_valueBoundString(valueBoundString * a_valueBoundString);
void check_valueBoundString_featureLabel(valueBoundString_featureLabel * a_valueBoundString_featureLabel);
void check_valueBoundString_toleranceLabel(valueBoundString_toleranceLabel * a_valueBoundString_toleranceLabel);
void check_valueCzslct(valueCzslct * a_valueCzslct);
void check_valueDmismd(valueDmismd * a_valueDmismd);
void check_valueDmismn(valueDmismn * a_valueDmismn);
void check_valueError(valueError * a_valueError);
void check_valueFaInt(valueFaInt * a_valueFaInt);
void check_valueFaReal(valueFaReal * a_valueFaReal);
void check_valueFedratReal(valueFedratReal * a_valueFedratReal);
void check_valueFedratString(valueFedratString * a_valueFedratString);
void check_valueFilnam(valueFilnam * a_valueFilnam);
void check_valueGeoalg(valueGeoalg * a_valueGeoalg);
void check_valueGotoReal(valueGotoReal * a_valueGotoReal);
void check_valueKeychar(valueKeychar * a_valueKeychar);
void check_valueMinorBool(valueMinorBool * a_valueMinorBool);
void check_valueMinorInt(valueMinorInt * a_valueMinorInt);
void check_valueMinorReal(valueMinorReal * a_valueMinorReal);
void check_valueMinorString(valueMinorString * a_valueMinorString);
void check_valueMinorVector(valueMinorVector * a_valueMinorVector);
void check_valuePtmeasReal(valuePtmeasReal * a_valuePtmeasReal);
void check_valueRt(valueRt * a_valueRt);
void check_valueRt_CCW(valueRt_CCW * a_valueRt_CCW);
void check_valueRt_CW(valueRt_CW * a_valueRt_CW);
void check_valueSa(valueSa * a_valueSa);
void check_valueSaDesc(valueSaDesc * a_valueSaDesc);
void check_valueSaPlain(valueSaPlain * a_valueSaPlain);
void check_valueSaTipnum(valueSaTipnum * a_valueSaTipnum);
void check_valueSnsetReal(valueSnsetReal * a_valueSnsetReal);
void check_valueSnsetString(valueSnsetString * a_valueSnsetString);
void check_valueSnsmnt(valueSnsmnt * a_valueSnsmnt);
void check_valueStm(valueStm * a_valueStm);
void check_valueStm_boolVar(valueStm_boolVar * a_valueStm_boolVar);
void check_valueStm_intVar(valueStm_intVar * a_valueStm_intVar);
void check_valueStm_realVar(valueStm_realVar * a_valueStm_realVar);
void check_valueStm_stringVar(valueStm_stringVar * a_valueStm_stringVar);
void check_valueStm_vectorVar(valueStm_vectorVar * a_valueStm_vectorVar);
void check_valueSw(valueSw * a_valueSw);
void check_valueTaBool(valueTaBool * a_valueTaBool);
void check_valueTaBoolIntol(valueTaBoolIntol * a_valueTaBoolIntol);
void check_valueTaBoolOutol(valueTaBoolOutol * a_valueTaBoolOutol);
void check_valueTaReal(valueTaReal * a_valueTaReal);
void check_valueTaRealAct(valueTaRealAct * a_valueTaRealAct);
void check_valueTaRealAmt(valueTaRealAmt * a_valueTaRealAmt);
void check_valueTaRealDev(valueTaRealDev * a_valueTaRealDev);
void check_valueUnits(valueUnits * a_valueUnits);
void check_vecExpr_MINUS(vecExpr_MINUS * a_vecExpr_MINUS);
void check_vecExpr_PAREN(vecExpr_PAREN * a_vecExpr_PAREN);
void check_vecExpr_PLUS(vecExpr_PLUS * a_vecExpr_PLUS);
void check_vecIntExpr_DIVID(vecIntExpr_DIVID * a_vecIntExpr_DIVID);
void check_vecIntExpr_TIMES(vecIntExpr_TIMES * a_vecIntExpr_TIMES);
void check_vecRealExpr_DIVID(vecRealExpr_DIVID * a_vecRealExpr_DIVID);
void check_vecRealExpr_TIMES(vecRealExpr_TIMES * a_vecRealExpr_TIMES);
void check_vector(vector * a_vector);
void check_vectorExpr(vectorExpr * a_vectorExpr);
void check_vectorFunc(vectorFunc * a_vectorFunc);
void check_vectorFuncVcart(vectorFuncVcart * a_vectorFuncVcart);
void check_vectorFuncVcross(vectorFuncVcross * a_vectorFuncVcross);
void check_vectorFuncVmcs(vectorFuncVmcs * a_vectorFuncVmcs);
void check_vectorFuncVpcs(vectorFuncVpcs * a_vectorFuncVpcs);
void check_vectorFuncVpol(vectorFuncVpol * a_vectorFuncVpol);
void check_vectorFuncVunit(vectorFuncVunit * a_vectorFuncVunit);
void check_vectorRel(vectorRel * a_vectorRel);
void check_vectorRel_EQ(vectorRel_EQ * a_vectorRel_EQ);
void check_vectorRel_NE(vectorRel_NE * a_vectorRel_NE);
void check_vectorVal(vectorVal * a_vectorVal);
void check_vectorVar(vectorVar * a_vectorVar);
void check_versionTag(versionTag * a_versionTag);
void check_vertexConst(vertexConst * a_vertexConst);
void check_vfLabel(vfLabel * a_vfLabel);
void check_vformItem(vformItem * a_vformItem);
void check_vformItem_ACT(vformItem_ACT * a_vformItem_ACT);
void check_vformItem_AMT(vformItem_AMT * a_vformItem_AMT);
void check_vformItem_DEV(vformItem_DEV * a_vformItem_DEV);
void check_vformItem_DME(vformItem_DME * a_vformItem_DME);
void check_vformItem_HIST(vformItem_HIST * a_vformItem_HIST);
void check_vformItem_NOM(vformItem_NOM * a_vformItem_NOM);
void check_vformItem_PLOT(vformItem_PLOT * a_vformItem_PLOT);
void check_vformItem_STAT(vformItem_STAT * a_vformItem_STAT);
void check_vformStm(vformStm * a_vformStm);
void check_vlLabel(vlLabel * a_vlLabel);
void check_vwLabel(vwLabel * a_vwLabel);
void check_windefBox(windefBox * a_windefBox);
void check_windefEdgeln(windefEdgeln * a_windefEdgeln);
void check_windefMinor(windefMinor * a_windefMinor);
void check_windefStm(windefStm * a_windefStm);
void check_wkplanStm(wkplanStm * a_wkplanStm);
void check_wristDataDesc(wristDataDesc * a_wristDataDesc);
void check_wristDataDesc_intVal(wristDataDesc_intVal * a_wristDataDesc_intVal);
void check_wristDataDesc_stringVal(wristDataDesc_stringVal * a_wristDataDesc_stringVal);
void check_wristDef(wristDef * a_wristDef);
void check_wristMountDef(wristMountDef * a_wristMountDef);
void check_wristMountOffset(wristMountOffset * a_wristMountOffset);
void check_wristRotDef(wristRotDef * a_wristRotDef);
void check_wristRotLimit(wristRotLimit * a_wristRotLimit);
void check_wristRotLimit_angle(wristRotLimit_angle * a_wristRotLimit_angle);
void check_wristRotStep(wristRotStep * a_wristRotStep);
void check_wristRotStep_angle(wristRotStep_angle * a_wristRotStep_angle);
void check_wristStm(wristStm * a_wristStm);
void check_writeSpec(writeSpec * a_writeSpec);
void check_writeSpec_rwVar(writeSpec_rwVar * a_writeSpec_rwVar);
void check_writeSpec_stringConst(writeSpec_stringConst * a_writeSpec_stringConst);
void check_writeSpec_stringFunc(writeSpec_stringFunc * a_writeSpec_stringFunc);
void check_writeStm(writeStm * a_writeStm);
void check_xternBlock(xternBlock * a_xternBlock);
void check_xtractStm(xtractStm * a_xtractStm);

/********************************************************************/

const char * aboveBelowSubs[4] = {"aboveBelowSubs", 0};
const char * aclratAngSpecSubs[4] = {"aclratAngSpecSubs", 0};
const char * aclratAngularAtts[3] = {"aclratAngularAtts", 0};
const char * aclratDefSubs[6] = {"aclratDefSubs", 0};
const char * aclratDef_PCENTAtts[3] = {"aclratDef_PCENTAtts", 0};
const char * aclratHedMeasAtts[3] = {"aclratHedMeasAtts", 0};
const char * aclratHedRotAtts[3] = {"aclratHedRotAtts", 0};
const char * aclratHedScanAtts[3] = {"aclratHedScanAtts", 0};
const char * aclratLinSpecSubs[4] = {"aclratLinSpecSubs", 0};
const char * aclratLinearSubs[6] = {"aclratLinearSubs", 0};
const char * aclratLinear_IPMMAtts[3] = {"aclratLinear_IPMMAtts", 0};
const char * aclratLinear_IPSSAtts[3] = {"aclratLinear_IPSSAtts", 0};
const char * aclratLinear_MMPSSAtts[3] = {"aclratLinear_MMPSSAtts", 0};
const char * aclratLinear_MPMMAtts[3] = {"aclratLinear_MPMMAtts", 0};
const char * aclratMeasAtts[3] = {"aclratMeasAtts", 0};
const char * aclratMinorSubs[9] = {"aclratMinorSubs", 0};
const char * aclratPosAtts[3] = {"aclratPosAtts", 0};
const char * aclratRotAtts[3] = {"aclratRotAtts", 0};
const char * aclratScanAtts[3] = {"aclratScanAtts", 0};
const char * aclratStmAtts[3] = {"aclratStmAtts", 0};
const char * algdefMinorSubs[4] = {"algdefMinorSubs", 0};
const char * algdefMinor_CODEAtts[3] = {"algdefMinor_CODEAtts", 0};
const char * algdefMinor_stringValAtts[4] = {"algdefMinor_stringValAtts", 0};
const char * algdefStmAtts[4] = {"algdefStmAtts", 0};
const char * angleSubs[4] = {"angleSubs", 0};
const char * angleDmsAtts[5] = {"angleDmsAtts", 0};
const char * angleUnitSubs[5] = {"angleUnitSubs", 0};
const char * anyValSubs[6] = {"anyValSubs", 0};
const char * arrayIndexAtts[3] = {"arrayIndexAtts", 0};
const char * assignBoolAtts[4] = {"assignBoolAtts", 0};
const char * assignIntAtts[4] = {"assignIntAtts", 0};
const char * assignRealAtts[4] = {"assignRealAtts", 0};
const char * assignStmSubs[7] = {"assignStmSubs", 0};
const char * assignStm_assignBoolAtts[3] = {"assignStm_assignBoolAtts", 0};
const char * assignStm_assignIntAtts[3] = {"assignStm_assignIntAtts", 0};
const char * assignStm_assignRealAtts[3] = {"assignStm_assignRealAtts", 0};
const char * assignStm_assignStringAtts[3] = {"assignStm_assignStringAtts", 0};
const char * assignStm_assignVectorAtts[3] = {"assignStm_assignVectorAtts", 0};
const char * assignStringAtts[4] = {"assignStringAtts", 0};
const char * assignVectorAtts[4] = {"assignVectorAtts", 0};
const char * avgMaxMinSubs[5] = {"avgMaxMinSubs", 0};
const char * axialAtts[4] = {"axialAtts", 0};
const char * axisSubs[5] = {"axisSubs", 0};
const char * badtstStmAtts[3] = {"badtstStmAtts", 0};
const char * bfConstSubs[4] = {"bfConstSubs", 0};
const char * bfConst_featureListAtts[3] = {"bfConst_featureListAtts", 0};
const char * bfConst_indexedFeatureListAtts[3] = {"bfConst_indexedFeatureListAtts", 0};
const char * boolConstSubs[4] = {"boolConstSubs", 0};
const char * boolExprSubs[8] = {"boolExprSubs", 0};
const char * boolExpr_PARENAtts[3] = {"boolExpr_PARENAtts", 0};
const char * boolExpr_boolRelAtts[3] = {"boolExpr_boolRelAtts", 0};
const char * boolExpr_intRelAtts[3] = {"boolExpr_intRelAtts", 0};
const char * boolExpr_realRelAtts[3] = {"boolExpr_realRelAtts", 0};
const char * boolExpr_stringRelAtts[3] = {"boolExpr_stringRelAtts", 0};
const char * boolExpr_vectorRelAtts[3] = {"boolExpr_vectorRelAtts", 0};
const char * boolFuncSubs[7] = {"boolFuncSubs", 0};
const char * boolFuncEofAtts[3] = {"boolFuncEofAtts", 0};
const char * boolFuncEolnAtts[3] = {"boolFuncEolnAtts", 0};
const char * boolFuncExistSubs[9] = {"boolFuncExistSubs", 0};
const char * boolFuncExist_dLabelAtts[3] = {"boolFuncExist_dLabelAtts", 0};
const char * boolFuncExist_daLabelAtts[3] = {"boolFuncExist_daLabelAtts", 0};
const char * boolFuncExist_didLabelAtts[3] = {"boolFuncExist_didLabelAtts", 0};
const char * boolFuncExist_fLabelAtts[3] = {"boolFuncExist_fLabelAtts", 0};
const char * boolFuncExist_faLabelAtts[3] = {"boolFuncExist_faLabelAtts", 0};
const char * boolFuncExist_sLabelAtts[3] = {"boolFuncExist_sLabelAtts", 0};
const char * boolFuncExist_saLabelAtts[3] = {"boolFuncExist_saLabelAtts", 0};
const char * boolRelSubs[7] = {"boolRelSubs", 0};
const char * boolRel_ANDAtts[4] = {"boolRel_ANDAtts", 0};
const char * boolRel_EQAtts[4] = {"boolRel_EQAtts", 0};
const char * boolRel_NEAtts[4] = {"boolRel_NEAtts", 0};
const char * boolRel_NOTAtts[3] = {"boolRel_NOTAtts", 0};
const char * boolRel_ORAtts[4] = {"boolRel_ORAtts", 0};
const char * boolValSubs[6] = {"boolValSubs", 0};
const char * boolVarAtts[4] = {"boolVarAtts", 0};
const char * boundFeatAtts[4] = {"boundFeatAtts", 0};
const char * boundMinorSubs[4] = {"boundMinorSubs", 0};
const char * boundStmAtts[3] = {"boundStmAtts", 0};
const char * boundTolAtts[4] = {"boundTolAtts", 0};
const char * cadfileTypeSubs[5] = {"cadfileTypeSubs", 0};
const char * cadfileType_VENDORAtts[3] = {"cadfileType_VENDORAtts", 0};
const char * calibMasterBlockAtts[5] = {"calibMasterBlockAtts", 0};
const char * calibMasterMinorAtts[3] = {"calibMasterMinorAtts", 0};
const char * calibMasterStmAtts[3] = {"calibMasterStmAtts", 0};
const char * calibRtabBlockAtts[5] = {"calibRtabBlockAtts", 0};
const char * calibRtabMinorSubs[4] = {"calibRtabMinorSubs", 0};
const char * calibRtabMinorSpecAtts[4] = {"calibRtabMinorSpecAtts", 0};
const char * calibRtabSpecSubs[4] = {"calibRtabSpecSubs", 0};
const char * calibRtabSpec_fLabelAtts[4] = {"calibRtabSpec_fLabelAtts", 0};
const char * calibRtabSpec_faLabelAtts[4] = {"calibRtabSpec_faLabelAtts", 0};
const char * calibRtabStmAtts[3] = {"calibRtabStmAtts", 0};
const char * calibSensBlockAtts[5] = {"calibSensBlockAtts", 0};
const char * calibSensBlockItemSubs[7] = {"calibSensBlockItemSubs", 0};
const char * calibSensBlockStatementSubs[27] = {"calibSensBlockStatementSubs", 0};
const char * calibSensCaseBlockAtts[5] = {"calibSensCaseBlockAtts", 0};
const char * calibSensDefaultCaseBlockAtts[5] = {"calibSensDefaultCaseBlockAtts", 0};
const char * calibSensDoBlockAtts[5] = {"calibSensDoBlockAtts", 0};
const char * calibSensIfBlockAtts[7] = {"calibSensIfBlockAtts", 0};
const char * calibSensMinorSubs[4] = {"calibSensMinorSubs", 0};
const char * calibSensMinorSpecAtts[4] = {"calibSensMinorSpecAtts", 0};
const char * calibSensSelectBlockAtts[6] = {"calibSensSelectBlockAtts", 0};
const char * calibSensSpecSubs[4] = {"calibSensSpecSubs", 0};
const char * calibSensSpecIntAtts[4] = {"calibSensSpecIntAtts", 0};
const char * calibSensSpecStringAtts[5] = {"calibSensSpecStringAtts", 0};
const char * calibSensStmAtts[3] = {"calibSensStmAtts", 0};
const char * callBlockAtts[5] = {"callBlockAtts", 0};
const char * callMacroAtts[5] = {"callMacroAtts", 0};
const char * callMinorSubs[6] = {"callMinorSubs", 0};
const char * callModuleAtts[3] = {"callModuleAtts", 0};
const char * callProgramAtts[5] = {"callProgramAtts", 0};
const char * callRoutineAtts[5] = {"callRoutineAtts", 0};
const char * callStmAtts[3] = {"callStmAtts", 0};
const char * callTypeSubs[5] = {"callTypeSubs", 0};
const char * cartPointAtts[5] = {"cartPointAtts", 0};
const char * caseBlockAtts[5] = {"caseBlockAtts", 0};
const char * caseStmSubs[4] = {"caseStmSubs", 0};
const char * caseStmIntAtts[4] = {"caseStmIntAtts", 0};
const char * caseStmStringAtts[3] = {"caseStmStringAtts", 0};
const char * ccLabelAtts[3] = {"ccLabelAtts", 0};
const char * ciLabelAtts[3] = {"ciLabelAtts", 0};
const char * clmpidStmAtts[4] = {"clmpidStmAtts", 0};
const char * clmpsnStmAtts[4] = {"clmpsnStmAtts", 0};
const char * closeDeleteAtts[3] = {"closeDeleteAtts", 0};
const char * closeEndAtts[3] = {"closeEndAtts", 0};
const char * closeKeepAtts[3] = {"closeKeepAtts", 0};
const char * closeMinorSubs[6] = {"closeMinorSubs", 0};
const char * closePlainAtts[3] = {"closePlainAtts", 0};
const char * closeStmAtts[3] = {"closeStmAtts", 0};
const char * cmpntgrpSpecSubs[6] = {"cmpntgrpSpecSubs", 0};
const char * cmpntgrpStmAtts[4] = {"cmpntgrpStmAtts", 0};
const char * cnfrmrulCodeAtts[3] = {"cnfrmrulCodeAtts", 0};
const char * cnfrmrulMinorSubs[4] = {"cnfrmrulMinorSubs", 0};
const char * cnfrmrulNameAtts[4] = {"cnfrmrulNameAtts", 0};
const char * cnfrmrulStmAtts[4] = {"cnfrmrulStmAtts", 0};
const char * cogConstAtts[3] = {"cogConstAtts", 0};
const char * coneConstSubs[4] = {"coneConstSubs", 0};
const char * coneConst_DIAMAtts[4] = {"coneConst_DIAMAtts", 0};
const char * coneConst_DISTAtts[4] = {"coneConst_DISTAtts", 0};
const char * conformItemAtts[4] = {"conformItemAtts", 0};
const char * conformTypeSubs[12] = {"conformTypeSubs", 0};
const char * constArcSubs[5] = {"constArcSubs", 0};
const char * constArc_bfConstAtts[4] = {"constArc_bfConstAtts", 0};
const char * constArc_projctConstAtts[4] = {"constArc_projctConstAtts", 0};
const char * constArc_trConstAtts[4] = {"constArc_trConstAtts", 0};
const char * constCircleSubs[9] = {"constCircleSubs", 0};
const char * constCircle_bfConstAtts[4] = {"constCircle_bfConstAtts", 0};
const char * constCircle_coneConstAtts[4] = {"constCircle_coneConstAtts", 0};
const char * constCircle_intofConstAtts[4] = {"constCircle_intofConstAtts", 0};
const char * constCircle_projctConstAtts[4] = {"constCircle_projctConstAtts", 0};
const char * constCircle_retrieve2Atts[4] = {"constCircle_retrieve2Atts", 0};
const char * constCircle_tantoConstAtts[4] = {"constCircle_tantoConstAtts", 0};
const char * constCircle_trConstAtts[4] = {"constCircle_trConstAtts", 0};
const char * constCompoundAtts[3] = {"constCompoundAtts", 0};
const char * constConeSubs[4] = {"constConeSubs", 0};
const char * constCone_bfConstAtts[4] = {"constCone_bfConstAtts", 0};
const char * constCone_trConstAtts[4] = {"constCone_trConstAtts", 0};
const char * constCparlnSubs[6] = {"constCparlnSubs", 0};
const char * constCparln_bfConstAtts[4] = {"constCparln_bfConstAtts", 0};
const char * constCparln_projctConstAtts[4] = {"constCparln_projctConstAtts", 0};
const char * constCparln_retrieve2Atts[4] = {"constCparln_retrieve2Atts", 0};
const char * constCparln_trConstAtts[4] = {"constCparln_trConstAtts", 0};
const char * constCylndrSubs[5] = {"constCylndrSubs", 0};
const char * constCylndr_bfConstAtts[4] = {"constCylndr_bfConstAtts", 0};
const char * constCylndr_retrieve1Atts[4] = {"constCylndr_retrieve1Atts", 0};
const char * constCylndr_trConstAtts[4] = {"constCylndr_trConstAtts", 0};
const char * constEdgeptAtts[4] = {"constEdgeptAtts", 0};
const char * constEllipsSubs[6] = {"constEllipsSubs", 0};
const char * constEllips_bfConstAtts[4] = {"constEllips_bfConstAtts", 0};
const char * constEllips_intofConstAtts[4] = {"constEllips_intofConstAtts", 0};
const char * constEllips_projctConstAtts[4] = {"constEllips_projctConstAtts", 0};
const char * constEllips_trConstAtts[4] = {"constEllips_trConstAtts", 0};
const char * constGcurveSubs[5] = {"constGcurveSubs", 0};
const char * constGcurve_bfConstAtts[4] = {"constGcurve_bfConstAtts", 0};
const char * constGcurve_projctConstAtts[4] = {"constGcurve_projctConstAtts", 0};
const char * constGcurve_trConstAtts[4] = {"constGcurve_trConstAtts", 0};
const char * constGeomAtts[4] = {"constGeomAtts", 0};
const char * constGsurfSubs[4] = {"constGsurfSubs", 0};
const char * constGsurf_bfConstAtts[4] = {"constGsurf_bfConstAtts", 0};
const char * constGsurf_trConstAtts[4] = {"constGsurf_trConstAtts", 0};
const char * constLineSubs[11] = {"constLineSubs", 0};
const char * constLine_bfConstAtts[4] = {"constLine_bfConstAtts", 0};
const char * constLine_intofConstAtts[4] = {"constLine_intofConstAtts", 0};
const char * constLine_midliConstAtts[4] = {"constLine_midliConstAtts", 0};
const char * constLine_offsetConstAtts[4] = {"constLine_offsetConstAtts", 0};
const char * constLine_partoConstAtts[4] = {"constLine_partoConstAtts", 0};
const char * constLine_perptoConstAtts[4] = {"constLine_perptoConstAtts", 0};
const char * constLine_projliConstAtts[4] = {"constLine_projliConstAtts", 0};
const char * constLine_tantoConstAtts[4] = {"constLine_tantoConstAtts", 0};
const char * constLine_trConstAtts[4] = {"constLine_trConstAtts", 0};
const char * constMinorSubs[24] = {"constMinorSubs", 0};
const char * constParplnAtts[4] = {"constParplnAtts", 0};
const char * constPaternSubs[4] = {"constPaternSubs", 0};
const char * constPatern_BUILDAtts[3] = {"constPatern_BUILDAtts", 0};
const char * constPatern_trConstAtts[4] = {"constPatern_trConstAtts", 0};
const char * constPlaneSubs[9] = {"constPlaneSubs", 0};
const char * constPlane_bfConstAtts[4] = {"constPlane_bfConstAtts", 0};
const char * constPlane_midplConstAtts[4] = {"constPlane_midplConstAtts", 0};
const char * constPlane_offsetConstAtts[4] = {"constPlane_offsetConstAtts", 0};
const char * constPlane_partoConstAtts[4] = {"constPlane_partoConstAtts", 0};
const char * constPlane_perptoConstAtts[4] = {"constPlane_perptoConstAtts", 0};
const char * constPlane_tantoConstPlaneAtts[4] = {"constPlane_tantoConstPlaneAtts", 0};
const char * constPlane_trConstAtts[4] = {"constPlane_trConstAtts", 0};
const char * constPointSubs[13] = {"constPointSubs", 0};
const char * constPoint_cogConstAtts[4] = {"constPoint_cogConstAtts", 0};
const char * constPoint_curveConstAtts[4] = {"constPoint_curveConstAtts", 0};
const char * constPoint_extremConstAtts[4] = {"constPoint_extremConstAtts", 0};
const char * constPoint_intofConstAtts[4] = {"constPoint_intofConstAtts", 0};
const char * constPoint_midptConstAtts[4] = {"constPoint_midptConstAtts", 0};
const char * constPoint_moveptConstAtts[4] = {"constPoint_moveptConstAtts", 0};
const char * constPoint_pierceConstAtts[4] = {"constPoint_pierceConstAtts", 0};
const char * constPoint_projptConstAtts[4] = {"constPoint_projptConstAtts", 0};
const char * constPoint_retrieve1Atts[4] = {"constPoint_retrieve1Atts", 0};
const char * constPoint_trConstAtts[4] = {"constPoint_trConstAtts", 0};
const char * constPoint_vertexConstAtts[4] = {"constPoint_vertexConstAtts", 0};
const char * constRctnglSubs[4] = {"constRctnglSubs", 0};
const char * constRctngl_bfConstAtts[4] = {"constRctngl_bfConstAtts", 0};
const char * constRctngl_trConstAtts[4] = {"constRctngl_trConstAtts", 0};
const char * constSgageAtts[4] = {"constSgageAtts", 0};
const char * constSpartAtts[4] = {"constSpartAtts", 0};
const char * constSphereSubs[5] = {"constSphereSubs", 0};
const char * constSphere_bfConstAtts[4] = {"constSphere_bfConstAtts", 0};
const char * constSphere_retrieve2bAtts[4] = {"constSphere_retrieve2bAtts", 0};
const char * constSphere_trConstAtts[4] = {"constSphere_trConstAtts", 0};
const char * constStmAtts[3] = {"constStmAtts", 0};
const char * constSymplnAtts[4] = {"constSymplnAtts", 0};
const char * constTorusSubs[4] = {"constTorusSubs", 0};
const char * constTorus_bfConstAtts[4] = {"constTorus_bfConstAtts", 0};
const char * constTorus_trConstAtts[4] = {"constTorus_trConstAtts", 0};
const char * coordTypeSubs[4] = {"coordTypeSubs", 0};
const char * crLabelAtts[3] = {"crLabelAtts", 0};
const char * crLabelConstAtts[3] = {"crLabelConstAtts", 0};
const char * crgdefDataAtts[8] = {"crgdefDataAtts", 0};
const char * crgdefMinorSubs[4] = {"crgdefMinorSubs", 0};
const char * crgdefStmAtts[4] = {"crgdefStmAtts", 0};
const char * criticalitySubs[5] = {"criticalitySubs", 0};
const char * crmodeMinorSubs[5] = {"crmodeMinorSubs", 0};
const char * crmodeStmAtts[3] = {"crmodeStmAtts", 0};
const char * crosclStmAtts[3] = {"crosclStmAtts", 0};
const char * crslctMinorSubs[4] = {"crslctMinorSubs", 0};
const char * crslctMinor_crLabelConstAtts[3] = {"crslctMinor_crLabelConstAtts", 0};
const char * crslctStmAtts[3] = {"crslctStmAtts", 0};
const char * csLabelAtts[3] = {"csLabelAtts", 0};
const char * csSpecSubs[4] = {"csSpecSubs", 0};
const char * csSpec_HEADCSAtts[5] = {"csSpec_HEADCSAtts", 0};
const char * csSpec_PCSAtts[3] = {"csSpec_PCSAtts", 0};
const char * curveConstAtts[4] = {"curveConstAtts", 0};
const char * curvePtdataHeadcsAtts[7] = {"curvePtdataHeadcsAtts", 0};
const char * curvePtdataHeadcsListItemAtts[6] = {"curvePtdataHeadcsListItemAtts", 0};
const char * curvePtdataPcsAtts[5] = {"curvePtdataPcsAtts", 0};
const char * curvePtdataPcsListItemAtts[4] = {"curvePtdataPcsListItemAtts", 0};
const char * cutcomAdjustAtts[7] = {"cutcomAdjustAtts", 0};
const char * cutcomMatrixAtts[4] = {"cutcomMatrixAtts", 0};
const char * cutcomMatxAtts[14] = {"cutcomMatxAtts", 0};
const char * cutcomMinorSubs[6] = {"cutcomMinorSubs", 0};
const char * cutcomParamAtts[4] = {"cutcomParamAtts", 0};
const char * cutcomStmAtts[4] = {"cutcomStmAtts", 0};
const char * cutcomUserdfAtts[4] = {"cutcomUserdfAtts", 0};
const char * czLabelAtts[3] = {"czLabelAtts", 0};
const char * czoneStmAtts[3] = {"czoneStmAtts", 0};
const char * czslctStmAtts[4] = {"czslctStmAtts", 0};
const char * dLabelAtts[3] = {"dLabelAtts", 0};
const char * daLabelAtts[3] = {"daLabelAtts", 0};
const char * datLabelAtts[3] = {"datLabelAtts", 0};
const char * datdefMinorSubs[4] = {"datdefMinorSubs", 0};
const char * datdefMinor_dattrgListAtts[5] = {"datdefMinor_dattrgListAtts", 0};
const char * datdefMinor_featureLabel1Atts[4] = {"datdefMinor_featureLabel1Atts", 0};
const char * datdefStmAtts[3] = {"datdefStmAtts", 0};
const char * datsetDatsAtts[5] = {"datsetDatsAtts", 0};
const char * datsetDrfAtts[6] = {"datsetDrfAtts", 0};
const char * datsetMatrixAtts[3] = {"datsetMatrixAtts", 0};
const char * datsetMinorSubs[6] = {"datsetMinorSubs", 0};
const char * datsetSpecSubs[4] = {"datsetSpecSubs", 0};
const char * datsetSpecDirAtts[7] = {"datsetSpecDirAtts", 0};
const char * datsetSpecNoDirAtts[6] = {"datsetSpecNoDirAtts", 0};
const char * datsetStmAtts[4] = {"datsetStmAtts", 0};
const char * dattrgLabelAtts[3] = {"dattrgLabelAtts", 0};
const char * dattrgMinorAtts[4] = {"dattrgMinorAtts", 0};
const char * dattrgdefStmAtts[3] = {"dattrgdefStmAtts", 0};
const char * datumLabelSubs[4] = {"datumLabelSubs", 0};
const char * datumLabel1Subs[4] = {"datumLabel1Subs", 0};
const char * datumLabel2Subs[4] = {"datumLabel2Subs", 0};
const char * declMinorAtts[5] = {"declMinorAtts", 0};
const char * declScopeSubs[5] = {"declScopeSubs", 0};
const char * declStmAtts[3] = {"declStmAtts", 0};
const char * declTypeSubs[9] = {"declTypeSubs", 0};
const char * declType_CHARAtts[3] = {"declType_CHARAtts", 0};
const char * declVarAtts[4] = {"declVarAtts", 0};
const char * decplAllAtts[3] = {"decplAllAtts", 0};
const char * decplMinorSubs[4] = {"decplMinorSubs", 0};
const char * decplMinor_decplAllAtts[3] = {"decplMinor_decplAllAtts", 0};
const char * decplMinor_decplListAtts[3] = {"decplMinor_decplListAtts", 0};
const char * decplNdigitsSubs[4] = {"decplNdigitsSubs", 0};
const char * decplNdigits_intValAtts[3] = {"decplNdigits_intValAtts", 0};
const char * decplSelectionSubs[8] = {"decplSelectionSubs", 0};
const char * decplSelection_ANGLEAtts[3] = {"decplSelection_ANGLEAtts", 0};
const char * decplSelection_DEVAtts[3] = {"decplSelection_DEVAtts", 0};
const char * decplSelection_DISTAtts[3] = {"decplSelection_DISTAtts", 0};
const char * decplSelection_HUMIDAtts[3] = {"decplSelection_HUMIDAtts", 0};
const char * decplSelection_TEMPAtts[3] = {"decplSelection_TEMPAtts", 0};
const char * decplSelection_VECAtts[3] = {"decplSelection_VECAtts", 0};
const char * decplStmAtts[3] = {"decplStmAtts", 0};
const char * defaultCaseBlockAtts[5] = {"defaultCaseBlockAtts", 0};
const char * deleteAllSensorsAtts[4] = {"deleteAllSensorsAtts", 0};
const char * deleteDatumAtts[4] = {"deleteDatumAtts", 0};
const char * deleteFeatureAtts[4] = {"deleteFeatureAtts", 0};
const char * deleteMinorSubs[7] = {"deleteMinorSubs", 0};
const char * deleteRotaryTableAtts[4] = {"deleteRotaryTableAtts", 0};
const char * deleteSensorAtts[4] = {"deleteSensorAtts", 0};
const char * deleteStmAtts[3] = {"deleteStmAtts", 0};
const char * deviceSubs[6] = {"deviceSubs", 0};
const char * deviceMinorSubs[4] = {"deviceMinorSubs", 0};
const char * deviceMinor_INCRAtts[3] = {"deviceMinor_INCRAtts", 0};
const char * deviceMinor_deviceAtts[4] = {"deviceMinor_deviceAtts", 0};
const char * deviceStmAtts[4] = {"deviceStmAtts", 0};
const char * diLabelAtts[3] = {"diLabelAtts", 0};
const char * didLabelAtts[3] = {"didLabelAtts", 0};
const char * dirSubs[4] = {"dirSubs", 0};
const char * displyItemDMISAtts[4] = {"displyItemDMISAtts", 0};
const char * displyItemNoDMISAtts[4] = {"displyItemNoDMISAtts", 0};
const char * displySpecItemSubs[4] = {"displySpecItemSubs", 0};
const char * displyStmSubs[4] = {"displyStmSubs", 0};
const char * displyStmOffAtts[3] = {"displyStmOffAtts", 0};
const char * displyStmSpecAtts[3] = {"displyStmSpecAtts", 0};
const char * dmehwMinorSubs[7] = {"dmehwMinorSubs", 0};
const char * dmehwMinor_jointConfAtts[3] = {"dmehwMinor_jointConfAtts", 0};
const char * dmehwStmAtts[3] = {"dmehwStmAtts", 0};
const char * dmeidStmAtts[4] = {"dmeidStmAtts", 0};
const char * dmeswComandAtts[3] = {"dmeswComandAtts", 0};
const char * dmeswDelayAtts[3] = {"dmeswDelayAtts", 0};
const char * dmeswMinorSubs[5] = {"dmeswMinorSubs", 0};
const char * dmeswStmAtts[3] = {"dmeswStmAtts", 0};
const char * dmeswSwitchSubs[4] = {"dmeswSwitchSubs", 0};
const char * dmeswiStmAtts[4] = {"dmeswiStmAtts", 0};
const char * dmeswvStmAtts[4] = {"dmeswvStmAtts", 0};
const char * dmisBlockSubs[15] = {"dmisBlockSubs", 0};
const char * dmisFirstStatementSubs[4] = {"dmisFirstStatementSubs", 0};
const char * dmisFreeStatementSubs[181] = {"dmisFreeStatementSubs", 0};
const char * dmisItemSubs[4] = {"dmisItemSubs", 0};
const char * dmisOffBlockAtts[5] = {"dmisOffBlockAtts", 0};
const char * dmismdStmAtts[5] = {"dmismdStmAtts", 0};
const char * dmismnStmAtts[5] = {"dmismnStmAtts", 0};
const char * doBlockAtts[5] = {"doBlockAtts", 0};
const char * doStmAtts[6] = {"doStmAtts", 0};
const char * drLabelAtts[3] = {"drLabelAtts", 0};
const char * dsLabelAtts[3] = {"dsLabelAtts", 0};
const char * dvLabelAtts[3] = {"dvLabelAtts", 0};
const char * equateCadAtts[4] = {"equateCadAtts", 0};
const char * equateCadcsSubs[4] = {"equateCadcsSubs", 0};
const char * equateCadcs_matrixAtts[4] = {"equateCadcs_matrixAtts", 0};
const char * equateCadcs_stringValAtts[4] = {"equateCadcs_stringValAtts", 0};
const char * equateDatumAtts[4] = {"equateDatumAtts", 0};
const char * equateMinorSubs[4] = {"equateMinorSubs", 0};
const char * equateStmAtts[3] = {"equateStmAtts", 0};
const char * errorConditionSubs[6] = {"errorConditionSubs", 0};
const char * errorCondition_intValAtts[3] = {"errorCondition_intValAtts", 0};
const char * errorMinorSubs[5] = {"errorMinorSubs", 0};
const char * errorMinor_AUTOAtts[3] = {"errorMinor_AUTOAtts", 0};
const char * errorMinor_jumpLabelAtts[4] = {"errorMinor_jumpLabelAtts", 0};
const char * errorStmAtts[3] = {"errorStmAtts", 0};
const char * eulerAtts[5] = {"eulerAtts", 0};
const char * evalDatSubs[4] = {"evalDatSubs", 0};
const char * evalDatDatFaAtts[5] = {"evalDatDatFaAtts", 0};
const char * evalDatFaDatAtts[5] = {"evalDatFaDatAtts", 0};
const char * evalFeatSubs[6] = {"evalFeatSubs", 0};
const char * evalFeatFFaTAtts[5] = {"evalFeatFFaTAtts", 0};
const char * evalFeatFaFTAtts[5] = {"evalFeatFaFTAtts", 0};
const char * evalFeatFaFaTAtts[5] = {"evalFeatFaFaTAtts", 0};
const char * evalFeatFaTAtts[4] = {"evalFeatFaTAtts", 0};
const char * evalKeycharSubs[3] = {"evalKeycharSubs", 0};
const char * evalMinorSubs[5] = {"evalMinorSubs", 0};
const char * evalOrOutputSubs[4] = {"evalOrOutputSubs", 0};
const char * evalStmAtts[3] = {"evalStmAtts", 0};
const char * extensMinorSubs[4] = {"extensMinorSubs", 0};
const char * extensMinor_VECAtts[4] = {"extensMinor_VECAtts", 0};
const char * extensMinor_vectorAtts[3] = {"extensMinor_vectorAtts", 0};
const char * extensStmAtts[4] = {"extensStmAtts", 0};
const char * extfilDmeAtts[3] = {"extfilDmeAtts", 0};
const char * extfilDmisAtts[3] = {"extfilDmisAtts", 0};
const char * extfilMinorSubs[4] = {"extfilMinorSubs", 0};
const char * extfilStmAtts[3] = {"extfilStmAtts", 0};
const char * extremConstSubs[4] = {"extremConstSubs", 0};
const char * extremConstAxialSubs[3] = {"extremConstAxialSubs", 0};
const char * extremConstDirSubs[6] = {"extremConstDirSubs", 0};
const char * extremConstFeatureSubs[3] = {"extremConstFeatureSubs", 0};
const char * extremConstVectorialAtts[3] = {"extremConstVectorialAtts", 0};
const char * extremConst_MAXAtts[4] = {"extremConst_MAXAtts", 0};
const char * extremConst_MINAtts[4] = {"extremConst_MINAtts", 0};
const char * fLabelAtts[3] = {"fLabelAtts", 0};
const char * faLabelAtts[3] = {"faLabelAtts", 0};
const char * featArc1ActAtts[4] = {"featArc1ActAtts", 0};
const char * featArc1NomAtts[4] = {"featArc1NomAtts", 0};
const char * featArc1StmSubs[4] = {"featArc1StmSubs", 0};
const char * featArc2ActAtts[4] = {"featArc2ActAtts", 0};
const char * featArc2NomAtts[4] = {"featArc2NomAtts", 0};
const char * featArc2StmSubs[4] = {"featArc2StmSubs", 0};
const char * featCircleActAtts[4] = {"featCircleActAtts", 0};
const char * featCircleNomAtts[4] = {"featCircleNomAtts", 0};
const char * featCircleStmSubs[4] = {"featCircleStmSubs", 0};
const char * featCompoundAxialAtts[6] = {"featCompoundAxialAtts", 0};
const char * featCompoundPlaneAtts[6] = {"featCompoundPlaneAtts", 0};
const char * featCompoundSphereAtts[5] = {"featCompoundSphereAtts", 0};
const char * featCompoundStmAtts[4] = {"featCompoundStmAtts", 0};
const char * featConeActAtts[4] = {"featConeActAtts", 0};
const char * featConeNomAtts[4] = {"featConeNomAtts", 0};
const char * featConeStmSubs[4] = {"featConeStmSubs", 0};
const char * featConradsegActAtts[4] = {"featConradsegActAtts", 0};
const char * featConradsegCartAtts[9] = {"featConradsegCartAtts", 0};
const char * featConradsegNomAtts[4] = {"featConradsegNomAtts", 0};
const char * featConradsegPolAtts[9] = {"featConradsegPolAtts", 0};
const char * featConradsegStmSubs[4] = {"featConradsegStmSubs", 0};
const char * featCparlnActAtts[4] = {"featCparlnActAtts", 0};
const char * featCparlnNomAtts[4] = {"featCparlnNomAtts", 0};
const char * featCparlnStmSubs[4] = {"featCparlnStmSubs", 0};
const char * featCylndrActAtts[4] = {"featCylndrActAtts", 0};
const char * featCylndrNomAtts[4] = {"featCylndrNomAtts", 0};
const char * featCylndrStmSubs[4] = {"featCylndrStmSubs", 0};
const char * featCylradsegActAtts[4] = {"featCylradsegActAtts", 0};
const char * featCylradsegCartAtts[8] = {"featCylradsegCartAtts", 0};
const char * featCylradsegNomAtts[4] = {"featCylradsegNomAtts", 0};
const char * featCylradsegPolAtts[8] = {"featCylradsegPolAtts", 0};
const char * featCylradsegStmSubs[4] = {"featCylradsegStmSubs", 0};
const char * featEdgeptActAtts[4] = {"featEdgeptActAtts", 0};
const char * featEdgeptNomAtts[4] = {"featEdgeptNomAtts", 0};
const char * featEdgeptStmSubs[4] = {"featEdgeptStmSubs", 0};
const char * featEllipsActAtts[4] = {"featEllipsActAtts", 0};
const char * featEllipsCartAtts[8] = {"featEllipsCartAtts", 0};
const char * featEllipsNomAtts[4] = {"featEllipsNomAtts", 0};
const char * featEllipsPolAtts[8] = {"featEllipsPolAtts", 0};
const char * featEllipsStmSubs[4] = {"featEllipsStmSubs", 0};
const char * featElongcylActAtts[4] = {"featElongcylActAtts", 0};
const char * featElongcylNomAtts[4] = {"featElongcylNomAtts", 0};
const char * featElongcylStmSubs[4] = {"featElongcylStmSubs", 0};
const char * featGcurveCartAtts[5] = {"featGcurveCartAtts", 0};
const char * featGcurvePolAtts[5] = {"featGcurvePolAtts", 0};
const char * featGcurveStmAtts[4] = {"featGcurveStmAtts", 0};
const char * featGeomStmAtts[4] = {"featGeomStmAtts", 0};
const char * featGsurfCartAtts[5] = {"featGsurfCartAtts", 0};
const char * featGsurfPolAtts[5] = {"featGsurfPolAtts", 0};
const char * featGsurfStmAtts[4] = {"featGsurfStmAtts", 0};
const char * featLineActAtts[4] = {"featLineActAtts", 0};
const char * featLineBndCartAtts[5] = {"featLineBndCartAtts", 0};
const char * featLineBndPolAtts[5] = {"featLineBndPolAtts", 0};
const char * featLineNomAtts[4] = {"featLineNomAtts", 0};
const char * featLineStmSubs[4] = {"featLineStmSubs", 0};
const char * featLineUnbndCartAtts[5] = {"featLineUnbndCartAtts", 0};
const char * featLineUnbndPolAtts[5] = {"featLineUnbndPolAtts", 0};
const char * featMinorArc1Atts[9] = {"featMinorArc1Atts", 0};
const char * featMinorArc2Atts[7] = {"featMinorArc2Atts", 0};
const char * featMinorCircleAtts[6] = {"featMinorCircleAtts", 0};
const char * featMinorCompoundSubs[5] = {"featMinorCompoundSubs", 0};
const char * featMinorConeAtts[6] = {"featMinorConeAtts", 0};
const char * featMinorConradsegSubs[4] = {"featMinorConradsegSubs", 0};
const char * featMinorCparlnAtts[9] = {"featMinorCparlnAtts", 0};
const char * featMinorCylndrAtts[7] = {"featMinorCylndrAtts", 0};
const char * featMinorCylradsegSubs[4] = {"featMinorCylradsegSubs", 0};
const char * featMinorEdgeptAtts[5] = {"featMinorEdgeptAtts", 0};
const char * featMinorEllipsSubs[4] = {"featMinorEllipsSubs", 0};
const char * featMinorElongcylAtts[9] = {"featMinorElongcylAtts", 0};
const char * featMinorGcurveSubs[4] = {"featMinorGcurveSubs", 0};
const char * featMinorGeomAtts[4] = {"featMinorGeomAtts", 0};
const char * featMinorGsurfSubs[5] = {"featMinorGsurfSubs", 0};
const char * featMinorLineSubs[6] = {"featMinorLineSubs", 0};
const char * featMinorObjectAtts[3] = {"featMinorObjectAtts", 0};
const char * featMinorParplnSubs[6] = {"featMinorParplnSubs", 0};
const char * featMinorPaternAtts[4] = {"featMinorPaternAtts", 0};
const char * featMinorPlaneAtts[4] = {"featMinorPlaneAtts", 0};
const char * featMinorPointAtts[4] = {"featMinorPointAtts", 0};
const char * featMinorRctnglAtts[10] = {"featMinorRctnglAtts", 0};
const char * featMinorRevsurfSubs[4] = {"featMinorRevsurfSubs", 0};
const char * featMinorSphereAtts[7] = {"featMinorSphereAtts", 0};
const char * featMinorSphradsegAtts[11] = {"featMinorSphradsegAtts", 0};
const char * featMinorSymplnSubs[4] = {"featMinorSymplnSubs", 0};
const char * featMinorTorradsegAtts[12] = {"featMinorTorradsegAtts", 0};
const char * featMinorTorusAtts[7] = {"featMinorTorusAtts", 0};
const char * featObjectActAtts[4] = {"featObjectActAtts", 0};
const char * featObjectNomAtts[4] = {"featObjectNomAtts", 0};
const char * featObjectStmSubs[4] = {"featObjectStmSubs", 0};
const char * featParplnActAtts[4] = {"featParplnActAtts", 0};
const char * featParplnMidplCartAtts[6] = {"featParplnMidplCartAtts", 0};
const char * featParplnMidplPolAtts[6] = {"featParplnMidplPolAtts", 0};
const char * featParplnNomAtts[4] = {"featParplnNomAtts", 0};
const char * featParplnPointsCartAtts[7] = {"featParplnPointsCartAtts", 0};
const char * featParplnPointsPolAtts[7] = {"featParplnPointsPolAtts", 0};
const char * featParplnStmSubs[4] = {"featParplnStmSubs", 0};
const char * featPaternStmAtts[4] = {"featPaternStmAtts", 0};
const char * featPlaneActAtts[4] = {"featPlaneActAtts", 0};
const char * featPlaneNomAtts[4] = {"featPlaneNomAtts", 0};
const char * featPlaneStmSubs[4] = {"featPlaneStmSubs", 0};
const char * featPointActAtts[4] = {"featPointActAtts", 0};
const char * featPointNomAtts[4] = {"featPointNomAtts", 0};
const char * featPointStmSubs[4] = {"featPointStmSubs", 0};
const char * featRctnglActAtts[4] = {"featRctnglActAtts", 0};
const char * featRctnglNomAtts[4] = {"featRctnglNomAtts", 0};
const char * featRctnglStmSubs[4] = {"featRctnglStmSubs", 0};
const char * featRevsurfActAtts[4] = {"featRevsurfActAtts", 0};
const char * featRevsurfCartAtts[7] = {"featRevsurfCartAtts", 0};
const char * featRevsurfNomAtts[4] = {"featRevsurfNomAtts", 0};
const char * featRevsurfPolAtts[7] = {"featRevsurfPolAtts", 0};
const char * featRevsurfStmSubs[4] = {"featRevsurfStmSubs", 0};
const char * featSphereActAtts[4] = {"featSphereActAtts", 0};
const char * featSphereNomAtts[4] = {"featSphereNomAtts", 0};
const char * featSphereStmSubs[4] = {"featSphereStmSubs", 0};
const char * featSphradsegActAtts[4] = {"featSphradsegActAtts", 0};
const char * featSphradsegNomAtts[4] = {"featSphradsegNomAtts", 0};
const char * featSphradsegStmSubs[4] = {"featSphradsegStmSubs", 0};
const char * featSymplnActAtts[4] = {"featSymplnActAtts", 0};
const char * featSymplnCartAtts[7] = {"featSymplnCartAtts", 0};
const char * featSymplnNomAtts[4] = {"featSymplnNomAtts", 0};
const char * featSymplnPolAtts[7] = {"featSymplnPolAtts", 0};
const char * featSymplnStmSubs[4] = {"featSymplnStmSubs", 0};
const char * featTorradsegActAtts[4] = {"featTorradsegActAtts", 0};
const char * featTorradsegNomAtts[4] = {"featTorradsegNomAtts", 0};
const char * featTorradsegStmSubs[4] = {"featTorradsegStmSubs", 0};
const char * featTorusActAtts[4] = {"featTorusActAtts", 0};
const char * featTorusNomAtts[4] = {"featTorusNomAtts", 0};
const char * featTorusStmSubs[4] = {"featTorusStmSubs", 0};
const char * featureLabelSubs[4] = {"featureLabelSubs", 0};
const char * featureLabel1Subs[4] = {"featureLabel1Subs", 0};
const char * fedratAngSpecSubs[4] = {"fedratAngSpecSubs", 0};
const char * fedratAngularAtts[3] = {"fedratAngularAtts", 0};
const char * fedratDefSubs[6] = {"fedratDefSubs", 0};
const char * fedratDef_PCENTAtts[3] = {"fedratDef_PCENTAtts", 0};
const char * fedratHedMeasAtts[3] = {"fedratHedMeasAtts", 0};
const char * fedratHedRotAtts[3] = {"fedratHedRotAtts", 0};
const char * fedratHedScanAtts[3] = {"fedratHedScanAtts", 0};
const char * fedratLinSpecSubs[4] = {"fedratLinSpecSubs", 0};
const char * fedratLinearSubs[6] = {"fedratLinearSubs", 0};
const char * fedratLinear_IPMAtts[3] = {"fedratLinear_IPMAtts", 0};
const char * fedratLinear_IPSAtts[3] = {"fedratLinear_IPSAtts", 0};
const char * fedratLinear_MMPSAtts[3] = {"fedratLinear_MMPSAtts", 0};
const char * fedratLinear_MPMAtts[3] = {"fedratLinear_MPMAtts", 0};
const char * fedratMeasAtts[3] = {"fedratMeasAtts", 0};
const char * fedratMinorSubs[9] = {"fedratMinorSubs", 0};
const char * fedratPosAtts[3] = {"fedratPosAtts", 0};
const char * fedratRotAtts[3] = {"fedratRotAtts", 0};
const char * fedratScanAtts[3] = {"fedratScanAtts", 0};
const char * fedratStmAtts[3] = {"fedratStmAtts", 0};
const char * fiLabelAtts[3] = {"fiLabelAtts", 0};
const char * fildefStmAtts[4] = {"fildefStmAtts", 0};
const char * filnamStmAtts[4] = {"filnamStmAtts", 0};
const char * finposStmAtts[3] = {"finposStmAtts", 0};
const char * fixtidStmAtts[4] = {"fixtidStmAtts", 0};
const char * fixtsnStmAtts[4] = {"fixtsnStmAtts", 0};
const char * flatRoundOpenSubs[5] = {"flatRoundOpenSubs", 0};
const char * flipNoFlipSubs[4] = {"flipNoFlipSubs", 0};
const char * flyMinorSubs[4] = {"flyMinorSubs", 0};
const char * flyMinor_rentValAtts[3] = {"flyMinor_rentValAtts", 0};
const char * flyStmAtts[3] = {"flyStmAtts", 0};
const char * forceOrDeflectionSubs[4] = {"forceOrDeflectionSubs", 0};
const char * forceOrDeflection_DEFLECTIONAtts[3] = {"forceOrDeflection_DEFLECTIONAtts", 0};
const char * forceOrDeflection_FORCEAtts[3] = {"forceOrDeflection_FORCEAtts", 0};
const char * fromMinorSubs[7] = {"fromMinorSubs", 0};
const char * fromMinor_cartPointAtts[4] = {"fromMinor_cartPointAtts", 0};
const char * fromMinor_impCartPointAtts[4] = {"fromMinor_impCartPointAtts", 0};
const char * fromMinor_polPointAtts[4] = {"fromMinor_polPointAtts", 0};
const char * fromStmAtts[3] = {"fromStmAtts", 0};
const char * fsLabelAtts[3] = {"fsLabelAtts", 0};
const char * gLabelAtts[3] = {"gLabelAtts", 0};
const char * geoalgArcAtts[3] = {"geoalgArcAtts", 0};
const char * geoalgCircleAtts[3] = {"geoalgCircleAtts", 0};
const char * geoalgConeAtts[3] = {"geoalgConeAtts", 0};
const char * geoalgConradsegmntAtts[3] = {"geoalgConradsegmntAtts", 0};
const char * geoalgCparlnAtts[3] = {"geoalgCparlnAtts", 0};
const char * geoalgCylndrAtts[3] = {"geoalgCylndrAtts", 0};
const char * geoalgCylradsegmntAtts[3] = {"geoalgCylradsegmntAtts", 0};
const char * geoalgEliminateSubs[4] = {"geoalgEliminateSubs", 0};
const char * geoalgEliminateStdAtts[3] = {"geoalgEliminateStdAtts", 0};
const char * geoalgEllipsAtts[3] = {"geoalgEllipsAtts", 0};
const char * geoalgElongcylAtts[3] = {"geoalgElongcylAtts", 0};
const char * geoalgExternFuncSubs[5] = {"geoalgExternFuncSubs", 0};
const char * geoalgExternFunc_DMEAtts[3] = {"geoalgExternFunc_DMEAtts", 0};
const char * geoalgExternFunc_DMISAtts[3] = {"geoalgExternFunc_DMISAtts", 0};
const char * geoalgExternFunc_SYSAtts[3] = {"geoalgExternFunc_SYSAtts", 0};
const char * geoalgFiltSetElimAtts[3] = {"geoalgFiltSetElimAtts", 0};
const char * geoalgFiltSetFiltAtts[4] = {"geoalgFiltSetFiltAtts", 0};
const char * geoalgFilterSubs[5] = {"geoalgFilterSubs", 0};
const char * geoalgFilterCircAtts[3] = {"geoalgFilterCircAtts", 0};
const char * geoalgFilterCurveSubs[6] = {"geoalgFilterCurveSubs", 0};
const char * geoalgFilterLambdaAtts[3] = {"geoalgFilterLambdaAtts", 0};
const char * geoalgFilterSettingsSubs[4] = {"geoalgFilterSettingsSubs", 0};
const char * geoalgFilterTypeSubs[5] = {"geoalgFilterTypeSubs", 0};
const char * geoalgFilterType_BANDPASSAtts[5] = {"geoalgFilterType_BANDPASSAtts", 0};
const char * geoalgFilterType_HIGHPASSAtts[4] = {"geoalgFilterType_HIGHPASSAtts", 0};
const char * geoalgFilterType_LOWPASSAtts[4] = {"geoalgFilterType_LOWPASSAtts", 0};
const char * geoalgGcurveAtts[3] = {"geoalgGcurveAtts", 0};
const char * geoalgGsurfAtts[3] = {"geoalgGsurfAtts", 0};
const char * geoalgLineAtts[3] = {"geoalgLineAtts", 0};
const char * geoalgMinorSubs[24] = {"geoalgMinorSubs", 0};
const char * geoalgObjectAtts[3] = {"geoalgObjectAtts", 0};
const char * geoalgParplnAtts[3] = {"geoalgParplnAtts", 0};
const char * geoalgPlaneAtts[3] = {"geoalgPlaneAtts", 0};
const char * geoalgRctnglAtts[3] = {"geoalgRctnglAtts", 0};
const char * geoalgRevsurfAtts[3] = {"geoalgRevsurfAtts", 0};
const char * geoalgSpec1Subs[6] = {"geoalgSpec1Subs", 0};
const char * geoalgSpec1_DEFALTAtts[3] = {"geoalgSpec1_DEFALTAtts", 0};
const char * geoalgSpec1_EXTERNAtts[5] = {"geoalgSpec1_EXTERNAtts", 0};
const char * geoalgSpec1_LSTSQRAtts[3] = {"geoalgSpec1_LSTSQRAtts", 0};
const char * geoalgSpec1_MINMAXAtts[3] = {"geoalgSpec1_MINMAXAtts", 0};
const char * geoalgSpec2Subs[8] = {"geoalgSpec2Subs", 0};
const char * geoalgSpec2_DEFALTAtts[3] = {"geoalgSpec2_DEFALTAtts", 0};
const char * geoalgSpec2_EXTERNAtts[5] = {"geoalgSpec2_EXTERNAtts", 0};
const char * geoalgSpec2_LSTSQRAtts[3] = {"geoalgSpec2_LSTSQRAtts", 0};
const char * geoalgSpec2_MAXINSAtts[3] = {"geoalgSpec2_MAXINSAtts", 0};
const char * geoalgSpec2_MINCIRAtts[3] = {"geoalgSpec2_MINCIRAtts", 0};
const char * geoalgSpec2_MINMAXAtts[3] = {"geoalgSpec2_MINMAXAtts", 0};
const char * geoalgSpec3Subs[4] = {"geoalgSpec3Subs", 0};
const char * geoalgSpec3_DEFALTAtts[3] = {"geoalgSpec3_DEFALTAtts", 0};
const char * geoalgSpec3_EXTERNAtts[5] = {"geoalgSpec3_EXTERNAtts", 0};
const char * geoalgSpec4Subs[7] = {"geoalgSpec4Subs", 0};
const char * geoalgSpec4_BSPLINAtts[3] = {"geoalgSpec4_BSPLINAtts", 0};
const char * geoalgSpec4_DEFALTAtts[3] = {"geoalgSpec4_DEFALTAtts", 0};
const char * geoalgSpec4_EXTERNAtts[5] = {"geoalgSpec4_EXTERNAtts", 0};
const char * geoalgSpec4_LSTSQRAtts[3] = {"geoalgSpec4_LSTSQRAtts", 0};
const char * geoalgSpec4_MINMAXAtts[3] = {"geoalgSpec4_MINMAXAtts", 0};
const char * geoalgSpec5Subs[8] = {"geoalgSpec5Subs", 0};
const char * geoalgSpec5_BEZIERAtts[3] = {"geoalgSpec5_BEZIERAtts", 0};
const char * geoalgSpec5_DEFALTAtts[3] = {"geoalgSpec5_DEFALTAtts", 0};
const char * geoalgSpec5_EXTERNAtts[5] = {"geoalgSpec5_EXTERNAtts", 0};
const char * geoalgSpec5_LSTSQRAtts[3] = {"geoalgSpec5_LSTSQRAtts", 0};
const char * geoalgSpec5_MINMAXAtts[3] = {"geoalgSpec5_MINMAXAtts", 0};
const char * geoalgSpec5_NURBSAtts[3] = {"geoalgSpec5_NURBSAtts", 0};
const char * geoalgSpec6Subs[6] = {"geoalgSpec6Subs", 0};
const char * geoalgSpec6_BSPLINAtts[3] = {"geoalgSpec6_BSPLINAtts", 0};
const char * geoalgSpec6_DEFALTAtts[3] = {"geoalgSpec6_DEFALTAtts", 0};
const char * geoalgSpec6_EXTERNAtts[5] = {"geoalgSpec6_EXTERNAtts", 0};
const char * geoalgSpec6_LSTSQRAtts[3] = {"geoalgSpec6_LSTSQRAtts", 0};
const char * geoalgSphereAtts[3] = {"geoalgSphereAtts", 0};
const char * geoalgSphradsegmntAtts[3] = {"geoalgSphradsegmntAtts", 0};
const char * geoalgStmAtts[3] = {"geoalgStmAtts", 0};
const char * geoalgSymplnAtts[3] = {"geoalgSymplnAtts", 0};
const char * geoalgTorradsegmntAtts[3] = {"geoalgTorradsegmntAtts", 0};
const char * geoalgTorusAtts[3] = {"geoalgTorusAtts", 0};
const char * geomEntityItemAtts[4] = {"geomEntityItemAtts", 0};
const char * geomMinorSubs[6] = {"geomMinorSubs", 0};
const char * geomStmAtts[4] = {"geomStmAtts", 0};
const char * geomStmDidAtts[3] = {"geomStmDidAtts", 0};
const char * geomStmEntityAtts[4] = {"geomStmEntityAtts", 0};
const char * geomStmOffsetAtts[4] = {"geomStmOffsetAtts", 0};
const char * gotargBlockAtts[6] = {"gotargBlockAtts", 0};
const char * gotargCartAtts[3] = {"gotargCartAtts", 0};
const char * gotargPolAtts[3] = {"gotargPolAtts", 0};
const char * gotargStmSubs[5] = {"gotargStmSubs", 0};
const char * gotargXyzAtts[3] = {"gotargXyzAtts", 0};
const char * gotoAbsSubs[8] = {"gotoAbsSubs", 0};
const char * gotoAbsCartAtts[3] = {"gotoAbsCartAtts", 0};
const char * gotoAbsCartSensAtts[4] = {"gotoAbsCartSensAtts", 0};
const char * gotoAbsPolAtts[3] = {"gotoAbsPolAtts", 0};
const char * gotoAbsPolSensAtts[4] = {"gotoAbsPolSensAtts", 0};
const char * gotoAbsXyzAtts[3] = {"gotoAbsXyzAtts", 0};
const char * gotoAbsXyzSensAtts[4] = {"gotoAbsXyzSensAtts", 0};
const char * gotoArcAtts[5] = {"gotoArcAtts", 0};
const char * gotoAxisAtts[5] = {"gotoAxisAtts", 0};
const char * gotoAxisSpecAtts[4] = {"gotoAxisSpecAtts", 0};
const char * gotoMinorSubs[7] = {"gotoMinorSubs", 0};
const char * gotoRelAtts[4] = {"gotoRelAtts", 0};
const char * gotoStmAtts[3] = {"gotoStmAtts", 0};
const char * gotoWristAngleItemAtts[4] = {"gotoWristAngleItemAtts", 0};
const char * gotoWristItemAtts[4] = {"gotoWristItemAtts", 0};
const char * groupStmAtts[5] = {"groupStmAtts", 0};
const char * gsaLabelAtts[3] = {"gsaLabelAtts", 0};
const char * ifBlockAtts[7] = {"ifBlockAtts", 0};
const char * ifStmAtts[3] = {"ifStmAtts", 0};
const char * impCartPointAtts[5] = {"impCartPointAtts", 0};
const char * impPolPointAtts[5] = {"impPolPointAtts", 0};
const char * includDmeAtts[3] = {"includDmeAtts", 0};
const char * includDmisAtts[3] = {"includDmisAtts", 0};
const char * includMinorSubs[4] = {"includMinorSubs", 0};
const char * includStmAtts[3] = {"includStmAtts", 0};
const char * indexedFeatureAtts[4] = {"indexedFeatureAtts", 0};
const char * inputFileAtts[5] = {"inputFileAtts", 0};
const char * intConstAtts[3] = {"intConstAtts", 0};
const char * intExprSubs[10] = {"intExprSubs", 0};
const char * intExprDividAtts[4] = {"intExprDividAtts", 0};
const char * intExprMinusAtts[4] = {"intExprMinusAtts", 0};
const char * intExprNegatAtts[3] = {"intExprNegatAtts", 0};
const char * intExprParenAtts[3] = {"intExprParenAtts", 0};
const char * intExprPlusAtts[4] = {"intExprPlusAtts", 0};
const char * intExprPositAtts[3] = {"intExprPositAtts", 0};
const char * intExprPowerAtts[4] = {"intExprPowerAtts", 0};
const char * intExprTimesAtts[4] = {"intExprTimesAtts", 0};
const char * intFuncSubs[13] = {"intFuncSubs", 0};
const char * intFuncAbsAtts[3] = {"intFuncAbsAtts", 0};
const char * intFuncIndxAtts[4] = {"intFuncIndxAtts", 0};
const char * intFuncIntAtts[3] = {"intFuncIntAtts", 0};
const char * intFuncLenAtts[3] = {"intFuncLenAtts", 0};
const char * intFuncModAtts[4] = {"intFuncModAtts", 0};
const char * intFuncNintAtts[3] = {"intFuncNintAtts", 0};
const char * intFuncOrdSubs[4] = {"intFuncOrdSubs", 0};
const char * intFuncOrd_boolValAtts[3] = {"intFuncOrd_boolValAtts", 0};
const char * intFuncOrd_stringValAtts[3] = {"intFuncOrd_stringValAtts", 0};
const char * intFuncPtdataAtts[3] = {"intFuncPtdataAtts", 0};
const char * intFuncSignAtts[4] = {"intFuncSignAtts", 0};
const char * intRealExprSubs[7] = {"intRealExprSubs", 0};
const char * intRealExpr_DIVIDAtts[4] = {"intRealExpr_DIVIDAtts", 0};
const char * intRealExpr_MINUSAtts[4] = {"intRealExpr_MINUSAtts", 0};
const char * intRealExpr_PLUSAtts[4] = {"intRealExpr_PLUSAtts", 0};
const char * intRealExpr_POWERAtts[4] = {"intRealExpr_POWERAtts", 0};
const char * intRealExpr_TIMESAtts[4] = {"intRealExpr_TIMESAtts", 0};
const char * intRealRelSubs[8] = {"intRealRelSubs", 0};
const char * intRealRel_EQAtts[4] = {"intRealRel_EQAtts", 0};
const char * intRealRel_GEAtts[4] = {"intRealRel_GEAtts", 0};
const char * intRealRel_GTAtts[4] = {"intRealRel_GTAtts", 0};
const char * intRealRel_LEAtts[4] = {"intRealRel_LEAtts", 0};
const char * intRealRel_LTAtts[4] = {"intRealRel_LTAtts", 0};
const char * intRealRel_NEAtts[4] = {"intRealRel_NEAtts", 0};
const char * intRelSubs[8] = {"intRelSubs", 0};
const char * intRel_EQAtts[4] = {"intRel_EQAtts", 0};
const char * intRel_GEAtts[4] = {"intRel_GEAtts", 0};
const char * intRel_GTAtts[4] = {"intRel_GTAtts", 0};
const char * intRel_LEAtts[4] = {"intRel_LEAtts", 0};
const char * intRel_LTAtts[4] = {"intRel_LTAtts", 0};
const char * intRel_NEAtts[4] = {"intRel_NEAtts", 0};
const char * intValSubs[6] = {"intValSubs", 0};
const char * intVarAtts[4] = {"intVarAtts", 0};
const char * intVecExpr_TIMESAtts[4] = {"intVecExpr_TIMESAtts", 0};
const char * intofConstAtts[4] = {"intofConstAtts", 0};
const char * iteratConvergenceSubs[4] = {"iteratConvergenceSubs", 0};
const char * iteratConvergence_ABSLAtts[3] = {"iteratConvergence_ABSLAtts", 0};
const char * iteratConvergence_INCRAtts[3] = {"iteratConvergence_INCRAtts", 0};
const char * iteratCriterionItemAtts[4] = {"iteratCriterionItemAtts", 0};
const char * iteratCriterionStartSubs[5] = {"iteratCriterionStartSubs", 0};
const char * iteratCriterionStart_axisAtts[3] = {"iteratCriterionStart_axisAtts", 0};
const char * iteratCriterionStart_vectorAtts[3] = {"iteratCriterionStart_vectorAtts", 0};
const char * iteratMinorAtts[7] = {"iteratMinorAtts", 0};
const char * iteratStmAtts[4] = {"iteratStmAtts", 0};
const char * jointConfAtts[6] = {"jointConfAtts", 0};
const char * jumpLabelSubs[3] = {"jumpLabelSubs", 0};
const char * jumpStmAtts[3] = {"jumpStmAtts", 0};
const char * jumptoStmAtts[3] = {"jumptoStmAtts", 0};
const char * kcLabelAtts[3] = {"kcLabelAtts", 0};
const char * kcaLabelAtts[3] = {"kcaLabelAtts", 0};
const char * keycharMinorSubs[4] = {"keycharMinorSubs", 0};
const char * keycharOneFeatureAtts[5] = {"keycharOneFeatureAtts", 0};
const char * keycharStmAtts[4] = {"keycharStmAtts", 0};
const char * keycharTwoFeaturesAtts[6] = {"keycharTwoFeaturesAtts", 0};
const char * labelNameSubs[4] = {"labelNameSubs", 0};
const char * labelNameAtAtts[3] = {"labelNameAtAtts", 0};
const char * labelNameConAtts[3] = {"labelNameConAtts", 0};
const char * labelNameConstAtts[3] = {"labelNameConstAtts", 0};
const char * leftRightSubs[4] = {"leftRightSubs", 0};
const char * lengthUnitSubs[7] = {"lengthUnitSubs", 0};
const char * liLabelAtts[3] = {"liLabelAtts", 0};
const char * litdefLightAtts[4] = {"litdefLightAtts", 0};
const char * litdefLightTypeSubs[6] = {"litdefLightTypeSubs", 0};
const char * litdefMinorSubs[4] = {"litdefMinorSubs", 0};
const char * litdefStmAtts[4] = {"litdefStmAtts", 0};
const char * litdefStrobeAtts[5] = {"litdefStrobeAtts", 0};
const char * litdefStrobeTypeSubs[4] = {"litdefStrobeTypeSubs", 0};
const char * litdefStrobeType_CYCLEAtts[3] = {"litdefStrobeType_CYCLEAtts", 0};
const char * locateLabelSubs[5] = {"locateLabelSubs", 0};
const char * locateRotAllowedSubs[10] = {"locateRotAllowedSubs", 0};
const char * locateStmAtts[6] = {"locateStmAtts", 0};
const char * locateTransAllowedSubs[10] = {"locateTransAllowedSubs", 0};
const char * longShortSubs[4] = {"longShortSubs", 0};
const char * lotidStmAtts[4] = {"lotidStmAtts", 0};
const char * mLabelAtts[3] = {"mLabelAtts", 0};
const char * mLabelConstAtts[3] = {"mLabelConstAtts", 0};
const char * maLabelAtts[3] = {"maLabelAtts", 0};
const char * macroBlockAtts[5] = {"macroBlockAtts", 0};
const char * macroParSubs[4] = {"macroParSubs", 0};
const char * macroPar_MACROVARNAMEAtts[3] = {"macroPar_MACROVARNAMEAtts", 0};
const char * macroPar_stringConstAtts[3] = {"macroPar_stringConstAtts", 0};
const char * macroStmAtts[4] = {"macroStmAtts", 0};
const char * matDirSubs[4] = {"matDirSubs", 0};
const char * matdefFeatAtts[4] = {"matdefFeatAtts", 0};
const char * matdefGeomAtts[4] = {"matdefGeomAtts", 0};
const char * matdefMatSubs[4] = {"matdefMatSubs", 0};
const char * matdefMat_LMCAtts[3] = {"matdefMat_LMCAtts", 0};
const char * matdefMat_MMCAtts[3] = {"matdefMat_MMCAtts", 0};
const char * matdefMatingSubs[6] = {"matdefMatingSubs", 0};
const char * matdefMethodSubs[4] = {"matdefMethodSubs", 0};
const char * matdefMinorSubs[4] = {"matdefMinorSubs", 0};
const char * matdefSpecAtts[4] = {"matdefSpecAtts", 0};
const char * matdefStmAtts[4] = {"matdefStmAtts", 0};
const char * matdefTypeSubs[4] = {"matdefTypeSubs", 0};
const char * matdefTypeBandAtts[7] = {"matdefTypeBandAtts", 0};
const char * matdefTypeZoneAtts[6] = {"matdefTypeZoneAtts", 0};
const char * matrixAtts[14] = {"matrixAtts", 0};
const char * mdLabelAtts[3] = {"mdLabelAtts", 0};
const char * measBlockSubs[4] = {"measBlockSubs", 0};
const char * measBlockItemSubs[6] = {"measBlockItemSubs", 0};
const char * measBlockStatementSubs[7] = {"measBlockStatementSubs", 0};
const char * measBlock_measStmAtts[5] = {"measBlock_measStmAtts", 0};
const char * measBlock_rmeasStmAtts[5] = {"measBlock_rmeasStmAtts", 0};
const char * measCaseBlockAtts[5] = {"measCaseBlockAtts", 0};
const char * measDefaultCaseBlockAtts[5] = {"measDefaultCaseBlockAtts", 0};
const char * measDoBlockAtts[5] = {"measDoBlockAtts", 0};
const char * measGeotypeSubs[25] = {"measGeotypeSubs", 0};
const char * measIfBlockAtts[7] = {"measIfBlockAtts", 0};
const char * measMinorSubs[5] = {"measMinorSubs", 0};
const char * measMinorCompAtts[3] = {"measMinorCompAtts", 0};
const char * measMinorOtherAtts[3] = {"measMinorOtherAtts", 0};
const char * measSelectBlockAtts[6] = {"measSelectBlockAtts", 0};
const char * measStmAtts[5] = {"measStmAtts", 0};
const char * measVar2Subs[8] = {"measVar2Subs", 0};
const char * measVar2AuxSubs[5] = {"measVar2AuxSubs", 0};
const char * measVar2_FEATAtts[3] = {"measVar2_FEATAtts", 0};
const char * measVar2_VECAtts[3] = {"measVar2_VECAtts", 0};
const char * mfgdevStmAtts[4] = {"mfgdevStmAtts", 0};
const char * midliConstAtts[4] = {"midliConstAtts", 0};
const char * midplConstAtts[4] = {"midplConstAtts", 0};
const char * midptConstAtts[4] = {"midptConstAtts", 0};
const char * modeStmAtts[4] = {"modeStmAtts", 0};
const char * moveptConstSubs[4] = {"moveptConstSubs", 0};
const char * moveptConstAxisAtts[5] = {"moveptConstAxisAtts", 0};
const char * moveptConstVecAtts[4] = {"moveptConstVecAtts", 0};
const char * nearptConstAtts[3] = {"nearptConstAtts", 0};
const char * negDirSubs[5] = {"negDirSubs", 0};
const char * noParseStmAtts[3] = {"noParseStmAtts", 0};
const char * obtainBoolAtts[4] = {"obtainBoolAtts", 0};
const char * obtainIntAtts[4] = {"obtainIntAtts", 0};
const char * obtainLabeledSubs[29] = {"obtainLabeledSubs", 0};
const char * obtainLabeled_crLabelAtts[4] = {"obtainLabeled_crLabelAtts", 0};
const char * obtainLabeled_datumLabel1Atts[4] = {"obtainLabeled_datumLabel1Atts", 0};
const char * obtainLabeled_didLabelAtts[4] = {"obtainLabeled_didLabelAtts", 0};
const char * obtainLabeled_featureLabelAtts[4] = {"obtainLabeled_featureLabelAtts", 0};
const char * obtainLabeled_gLabelAtts[4] = {"obtainLabeled_gLabelAtts", 0};
const char * obtainLabeled_gsaLabelAtts[4] = {"obtainLabeled_gsaLabelAtts", 0};
const char * obtainLabeled_kcLabelAtts[4] = {"obtainLabeled_kcLabelAtts", 0};
const char * obtainLabeled_maLabelAtts[4] = {"obtainLabeled_maLabelAtts", 0};
const char * obtainLabeled_pLabelAtts[4] = {"obtainLabeled_pLabelAtts", 0};
const char * obtainLabeled_qisLabelAtts[4] = {"obtainLabeled_qisLabelAtts", 0};
const char * obtainLabeled_rLabelAtts[4] = {"obtainLabeled_rLabelAtts", 0};
const char * obtainLabeled_rmLabelAtts[4] = {"obtainLabeled_rmLabelAtts", 0};
const char * obtainLabeled_rtLabelAtts[4] = {"obtainLabeled_rtLabelAtts", 0};
const char * obtainLabeled_sensorLabel1Atts[4] = {"obtainLabeled_sensorLabel1Atts", 0};
const char * obtainLabeled_sgLabelAtts[4] = {"obtainLabeled_sgLabelAtts", 0};
const char * obtainLabeled_sgsLabelAtts[4] = {"obtainLabeled_sgsLabelAtts", 0};
const char * obtainLabeled_sraLabelAtts[4] = {"obtainLabeled_sraLabelAtts", 0};
const char * obtainLabeled_ssLabelAtts[4] = {"obtainLabeled_ssLabelAtts", 0};
const char * obtainLabeled_swLabelAtts[4] = {"obtainLabeled_swLabelAtts", 0};
const char * obtainLabeled_sxLabelAtts[4] = {"obtainLabeled_sxLabelAtts", 0};
const char * obtainLabeled_thLabelAtts[4] = {"obtainLabeled_thLabelAtts", 0};
const char * obtainLabeled_toleranceLabelAtts[4] = {"obtainLabeled_toleranceLabelAtts", 0};
const char * obtainLabeled_vLabelAtts[4] = {"obtainLabeled_vLabelAtts", 0};
const char * obtainLabeled_vaLabelAtts[4] = {"obtainLabeled_vaLabelAtts", 0};
const char * obtainLabeled_vfLabelAtts[4] = {"obtainLabeled_vfLabelAtts", 0};
const char * obtainLabeled_vlLabelAtts[4] = {"obtainLabeled_vlLabelAtts", 0};
const char * obtainLabeled_vwLabelAtts[4] = {"obtainLabeled_vwLabelAtts", 0};
const char * obtainPointAtts[5] = {"obtainPointAtts", 0};
const char * obtainRealLabelAtts[4] = {"obtainRealLabelAtts", 0};
const char * obtainRealPointAtts[4] = {"obtainRealPointAtts", 0};
const char * obtainStmSubs[7] = {"obtainStmSubs", 0};
const char * obtainStringAtts[4] = {"obtainStringAtts", 0};
const char * offsetConstAtts[3] = {"offsetConstAtts", 0};
const char * opLabelAtts[3] = {"opLabelAtts", 0};
const char * openCadfileAtts[3] = {"openCadfileAtts", 0};
const char * openDMLfileSubs[4] = {"openDMLfileSubs", 0};
const char * openDeviceSubs[4] = {"openDeviceSubs", 0};
const char * openDevice_inputAccessAtts[3] = {"openDevice_inputAccessAtts", 0};
const char * openDevice_outputAccessAtts[3] = {"openDevice_outputAccessAtts", 0};
const char * openDmlInputAtts[3] = {"openDmlInputAtts", 0};
const char * openDmlOutputAtts[4] = {"openDmlOutputAtts", 0};
const char * openFdataSubs[4] = {"openFdataSubs", 0};
const char * openFdata_DMISAtts[3] = {"openFdata_DMISAtts", 0};
const char * openFdata_vLabelAtts[4] = {"openFdata_vLabelAtts", 0};
const char * openMinorSubs[7] = {"openMinorSubs", 0};
const char * openMinor_openCadfileAtts[4] = {"openMinor_openCadfileAtts", 0};
const char * openMinor_openDMLfileAtts[4] = {"openMinor_openDMLfileAtts", 0};
const char * openMinor_openDeviceAtts[4] = {"openMinor_openDeviceAtts", 0};
const char * openMinor_openFdataAtts[4] = {"openMinor_openFdataAtts", 0};
const char * openMinor_storageSpecListAtts[4] = {"openMinor_storageSpecListAtts", 0};
const char * openStmAtts[3] = {"openStmAtts", 0};
const char * operidStmAtts[4] = {"operidStmAtts", 0};
const char * origSubs[5] = {"origSubs", 0};
const char * outputAccessSubs[5] = {"outputAccessSubs", 0};
const char * outputConstBothDataAtts[5] = {"outputConstBothDataAtts", 0};
const char * outputConstDataSubs[5] = {"outputConstDataSubs", 0};
const char * outputConstGaugeDataAtts[3] = {"outputConstGaugeDataAtts", 0};
const char * outputConstPartDataAtts[3] = {"outputConstPartDataAtts", 0};
const char * outputDatSubs[4] = {"outputDatSubs", 0};
const char * outputDat_datLabelAtts[6] = {"outputDat_datLabelAtts", 0};
const char * outputDat_faLabelAtts[6] = {"outputDat_faLabelAtts", 0};
const char * outputFeatSubs[10] = {"outputFeatSubs", 0};
const char * outputFeat1FAtts[5] = {"outputFeat1FAtts", 0};
const char * outputFeat1FTAtts[6] = {"outputFeat1FTAtts", 0};
const char * outputFeat1FaAtts[5] = {"outputFeat1FaAtts", 0};
const char * outputFeat1FaTaAtts[6] = {"outputFeat1FaTaAtts", 0};
const char * outputFeat2FFTAtts[6] = {"outputFeat2FFTAtts", 0};
const char * outputFeat2FFaTaAtts[6] = {"outputFeat2FFaTaAtts", 0};
const char * outputFeat2FaFTaAtts[6] = {"outputFeat2FaFTaAtts", 0};
const char * outputFeat2FaFaTaAtts[6] = {"outputFeat2FaFaTaAtts", 0};
const char * outputFeatDataSubs[4] = {"outputFeatDataSubs", 0};
const char * outputKeycharDataSubs[4] = {"outputKeycharDataSubs", 0};
const char * outputMinorSubs[8] = {"outputMinorSubs", 0};
const char * outputReportDataSubs[3] = {"outputReportDataSubs", 0};
const char * outputSensorDataSubs[4] = {"outputSensorDataSubs", 0};
const char * outputSensorData_sLabelAtts[3] = {"outputSensorData_sLabelAtts", 0};
const char * outputSensorData_saLabelAtts[4] = {"outputSensorData_saLabelAtts", 0};
const char * outputSensorDescSubs[6] = {"outputSensorDescSubs", 0};
const char * outputSensorDesc_intValAtts[4] = {"outputSensorDesc_intValAtts", 0};
const char * outputSensorDesc_outputSensorWristListAtts[3] = {"outputSensorDesc_outputSensorWristListAtts", 0};
const char * outputSensorDesc_stringValAtts[4] = {"outputSensorDesc_stringValAtts", 0};
const char * outputSensorWristAngleAtts[4] = {"outputSensorWristAngleAtts", 0};
const char * outputSensorWristItemAtts[4] = {"outputSensorWristItemAtts", 0};
const char * outputStmAtts[3] = {"outputStmAtts", 0};
const char * outputToleranceDataSubs[4] = {"outputToleranceDataSubs", 0};
const char * pLabelAtts[3] = {"pLabelAtts", 0};
const char * pameasDetailSubs[7] = {"pameasDetailSubs", 0};
const char * pameasDetailDistanceAtts[5] = {"pameasDetailDistanceAtts", 0};
const char * pameasDetailPitchAtts[3] = {"pameasDetailPitchAtts", 0};
const char * pameasDetailScnvelDataAtts[4] = {"pameasDetailScnvelDataAtts", 0};
const char * pameasDetailScnvelNoDataAtts[3] = {"pameasDetailScnvelNoDataAtts", 0};
const char * pameasFedratSubs[6] = {"pameasFedratSubs", 0};
const char * pameasFedrat_IPMAtts[3] = {"pameasFedrat_IPMAtts", 0};
const char * pameasFedrat_IPSAtts[3] = {"pameasFedrat_IPSAtts", 0};
const char * pameasFedrat_MMPSAtts[3] = {"pameasFedrat_MMPSAtts", 0};
const char * pameasFedrat_MPMAtts[3] = {"pameasFedrat_MPMAtts", 0};
const char * pameasMinorSubs[4] = {"pameasMinorSubs", 0};
const char * pameasMinor_pameasVar2ListAtts[3] = {"pameasMinor_pameasVar2ListAtts", 0};
const char * pameasMinor_pameasVar3ListAtts[3] = {"pameasMinor_pameasVar3ListAtts", 0};
const char * pameasRemoveSubs[5] = {"pameasRemoveSubs", 0};
const char * pameasRemoveCountAtts[4] = {"pameasRemoveCountAtts", 0};
const char * pameasRemoveDistAtts[4] = {"pameasRemoveDistAtts", 0};
const char * pameasStmAtts[3] = {"pameasStmAtts", 0};
const char * pameasVar2ListItemAtts[9] = {"pameasVar2ListItemAtts", 0};
const char * pameasVar3ListItemAtts[8] = {"pameasVar3ListItemAtts", 0};
const char * paramSubs[3] = {"paramSubs", 0};
const char * partidStmAtts[4] = {"partidStmAtts", 0};
const char * partoConstSubs[4] = {"partoConstSubs", 0};
const char * partoConstActAtts[4] = {"partoConstActAtts", 0};
const char * partoConstNomAtts[4] = {"partoConstNomAtts", 0};
const char * partrvStmAtts[4] = {"partrvStmAtts", 0};
const char * partsnStmAtts[4] = {"partsnStmAtts", 0};
const char * pathArcAtts[8] = {"pathArcAtts", 0};
const char * pathCurveSubs[4] = {"pathCurveSubs", 0};
const char * pathCurvePointsAtts[4] = {"pathCurvePointsAtts", 0};
const char * pathCurvePtdataSubs[4] = {"pathCurvePtdataSubs", 0};
const char * pathCurve_pathCurvePointsAtts[3] = {"pathCurve_pathCurvePointsAtts", 0};
const char * pathCurve_pathCurvePtdataAtts[3] = {"pathCurve_pathCurvePtdataAtts", 0};
const char * pathHelicalAtts[10] = {"pathHelicalAtts", 0};
const char * pathLineSubs[4] = {"pathLineSubs", 0};
const char * pathLineCartAtts[7] = {"pathLineCartAtts", 0};
const char * pathLinePolAtts[5] = {"pathLinePolAtts", 0};
const char * pathMinorSubs[9] = {"pathMinorSubs", 0};
const char * pathPointAtts[4] = {"pathPointAtts", 0};
const char * pathStmAtts[4] = {"pathStmAtts", 0};
const char * pathSurfaceSubs[7] = {"pathSurfaceSubs", 0};
const char * pathSurfaceHeadcsAtts[6] = {"pathSurfaceHeadcsAtts", 0};
const char * pathSurfaceHeadcsDataAtts[7] = {"pathSurfaceHeadcsDataAtts", 0};
const char * pathSurfacePcsAtts[4] = {"pathSurfacePcsAtts", 0};
const char * pathSurfacePcsDataAtts[5] = {"pathSurfacePcsDataAtts", 0};
const char * pathSurfacePlainAtts[3] = {"pathSurfacePlainAtts", 0};
const char * pathUnknownAtts[6] = {"pathUnknownAtts", 0};
const char * pcLabelAtts[3] = {"pcLabelAtts", 0};
const char * perptoConstSubs[4] = {"perptoConstSubs", 0};
const char * perptoConstActAtts[4] = {"perptoConstActAtts", 0};
const char * perptoConstNomAtts[4] = {"perptoConstNomAtts", 0};
const char * pierceConstAtts[4] = {"pierceConstAtts", 0};
const char * plLabelAtts[3] = {"plLabelAtts", 0};
const char * planSubs[5] = {"planSubs", 0};
const char * planidStmAtts[4] = {"planidStmAtts", 0};
const char * pnLabelAtts[3] = {"pnLabelAtts", 0};
const char * pointRangeAtts[4] = {"pointRangeAtts", 0};
const char * pointVecCartAtts[8] = {"pointVecCartAtts", 0};
const char * pointVecPolAtts[8] = {"pointVecPolAtts", 0};
const char * polPointAtts[5] = {"polPointAtts", 0};
const char * popStmAtts[3] = {"popStmAtts", 0};
const char * posDirSubs[5] = {"posDirSubs", 0};
const char * prLabelAtts[3] = {"prLabelAtts", 0};
const char * prcompStmAtts[3] = {"prcompStmAtts", 0};
const char * prevopStmAtts[4] = {"prevopStmAtts", 0};
const char * probeLocCartAtts[4] = {"probeLocCartAtts", 0};
const char * probeLocPolAtts[6] = {"probeLocPolAtts", 0};
const char * probeLocSnsCartAtts[4] = {"probeLocSnsCartAtts", 0};
const char * probeLocSnsVecAtts[5] = {"probeLocSnsVecAtts", 0};
const char * probeLocVecAtts[5] = {"probeLocVecAtts", 0};
const char * probeLocationSubs[7] = {"probeLocationSubs", 0};
const char * probeOrientSubs[6] = {"probeOrientSubs", 0};
const char * probeOrient_HEADCSAtts[5] = {"probeOrient_HEADCSAtts", 0};
const char * probeOrient_PCSAtts[3] = {"probeOrient_PCSAtts", 0};
const char * probeOrient_VECAtts[4] = {"probeOrient_VECAtts", 0};
const char * probeOrient_featureLabelAtts[4] = {"probeOrient_featureLabelAtts", 0};
const char * procidStmAtts[4] = {"procidStmAtts", 0};
const char * projctConstAtts[4] = {"projctConstAtts", 0};
const char * projliConstAtts[4] = {"projliConstAtts", 0};
const char * projptConstAtts[4] = {"projptConstAtts", 0};
const char * promptIntEndSubs[4] = {"promptIntEndSubs", 0};
const char * promptIntEnd_promptItemListAtts[3] = {"promptIntEnd_promptItemListAtts", 0};
const char * promptIntEnd_stringValAtts[5] = {"promptIntEnd_stringValAtts", 0};
const char * promptItemSubs[12] = {"promptItemSubs", 0};
const char * promptItem_BUTTONAtts[4] = {"promptItem_BUTTONAtts", 0};
const char * promptItem_CHECKAtts[4] = {"promptItem_CHECKAtts", 0};
const char * promptItem_EDITAtts[5] = {"promptItem_EDITAtts", 0};
const char * promptItem_GROUPAtts[6] = {"promptItem_GROUPAtts", 0};
const char * promptItem_LISTAtts[5] = {"promptItem_LISTAtts", 0};
const char * promptItem_PICTUREAtts[4] = {"promptItem_PICTUREAtts", 0};
const char * promptItem_PIXBTNAtts[5] = {"promptItem_PIXBTNAtts", 0};
const char * promptItem_SOUNDAtts[3] = {"promptItem_SOUNDAtts", 0};
const char * promptItem_TEXTAtts[3] = {"promptItem_TEXTAtts", 0};
const char * promptItem_TITLEAtts[3] = {"promptItem_TITLEAtts", 0};
const char * promptStmSubs[25] = {"promptStmSubs", 0};
const char * promptStm_boolVarAtts[4] = {"promptStm_boolVarAtts", 0};
const char * promptStm_ccLabelAtts[5] = {"promptStm_ccLabelAtts", 0};
const char * promptStm_ciLabelAtts[5] = {"promptStm_ciLabelAtts", 0};
const char * promptStm_csLabelAtts[5] = {"promptStm_csLabelAtts", 0};
const char * promptStm_diLabelAtts[5] = {"promptStm_diLabelAtts", 0};
const char * promptStm_dsLabelAtts[5] = {"promptStm_dsLabelAtts", 0};
const char * promptStm_dvLabelAtts[5] = {"promptStm_dvLabelAtts", 0};
const char * promptStm_fiLabelAtts[5] = {"promptStm_fiLabelAtts", 0};
const char * promptStm_fsLabelAtts[5] = {"promptStm_fsLabelAtts", 0};
const char * promptStm_intVarAtts[4] = {"promptStm_intVarAtts", 0};
const char * promptStm_liLabelAtts[5] = {"promptStm_liLabelAtts", 0};
const char * promptStm_mdLabelAtts[5] = {"promptStm_mdLabelAtts", 0};
const char * promptStm_opLabelAtts[5] = {"promptStm_opLabelAtts", 0};
const char * promptStm_pcLabelAtts[5] = {"promptStm_pcLabelAtts", 0};
const char * promptStm_plLabelAtts[5] = {"promptStm_plLabelAtts", 0};
const char * promptStm_pnLabelAtts[5] = {"promptStm_pnLabelAtts", 0};
const char * promptStm_prLabelAtts[5] = {"promptStm_prLabelAtts", 0};
const char * promptStm_psLabelAtts[5] = {"promptStm_psLabelAtts", 0};
const char * promptStm_pvLabelAtts[5] = {"promptStm_pvLabelAtts", 0};
const char * promptStm_qLabelAtts[5] = {"promptStm_qLabelAtts", 0};
const char * promptStm_realVarAtts[6] = {"promptStm_realVarAtts", 0};
const char * promptStm_stringVarAtts[5] = {"promptStm_stringVarAtts", 0};
const char * promptStm_tlLabelAtts[5] = {"promptStm_tlLabelAtts", 0};
const char * promptVarSubs[7] = {"promptVarSubs", 0};
const char * psLabelAtts[3] = {"psLabelAtts", 0};
const char * psthruMinorSubs[8] = {"psthruMinorSubs", 0};
const char * psthruMinor_COMANDAtts[3] = {"psthruMinor_COMANDAtts", 0};
const char * psthruMinor_TRMATXAtts[3] = {"psthruMinor_TRMATXAtts", 0};
const char * psthruStmAtts[3] = {"psthruStmAtts", 0};
const char * ptbuffStmAtts[3] = {"ptbuffStmAtts", 0};
const char * ptmeasEndSubs[4] = {"ptmeasEndSubs", 0};
const char * ptmeasEnd_csSpecAtts[4] = {"ptmeasEnd_csSpecAtts", 0};
const char * ptmeasEnd_touchSpecAtts[3] = {"ptmeasEnd_touchSpecAtts", 0};
const char * ptmeasStmAtts[5] = {"ptmeasStmAtts", 0};
const char * pushStmAtts[3] = {"pushStmAtts", 0};
const char * pvLabelAtts[3] = {"pvLabelAtts", 0};
const char * qLabelAtts[3] = {"qLabelAtts", 0};
const char * qisLabelSubs[21] = {"qisLabelSubs", 0};
const char * qisdefStmAtts[5] = {"qisdefStmAtts", 0};
const char * rLabelAtts[3] = {"rLabelAtts", 0};
const char * radiusSpecSubs[4] = {"radiusSpecSubs", 0};
const char * rapidStmAtts[3] = {"rapidStmAtts", 0};
const char * readSpecAtts[4] = {"readSpecAtts", 0};
const char * readStmAtts[4] = {"readStmAtts", 0};
const char * realConstAtts[3] = {"realConstAtts", 0};
const char * realExprSubs[8] = {"realExprSubs", 0};
const char * realExprNegatAtts[3] = {"realExprNegatAtts", 0};
const char * realExprParenAtts[3] = {"realExprParenAtts", 0};
const char * realExprPositAtts[3] = {"realExprPositAtts", 0};
const char * realFuncSubs[30] = {"realFuncSubs", 0};
const char * realFuncAbsAtts[3] = {"realFuncAbsAtts", 0};
const char * realFuncAcosAtts[3] = {"realFuncAcosAtts", 0};
const char * realFuncAsinAtts[3] = {"realFuncAsinAtts", 0};
const char * realFuncAtanAtts[3] = {"realFuncAtanAtts", 0};
const char * realFuncAtan2Atts[4] = {"realFuncAtan2Atts", 0};
const char * realFuncCosAtts[3] = {"realFuncCosAtts", 0};
const char * realFuncDbleAtts[3] = {"realFuncDbleAtts", 0};
const char * realFuncDtorAtts[3] = {"realFuncDtorAtts", 0};
const char * realFuncExpAtts[3] = {"realFuncExpAtts", 0};
const char * realFuncLnAtts[3] = {"realFuncLnAtts", 0};
const char * realFuncLogAtts[3] = {"realFuncLogAtts", 0};
const char * realFuncMnAtts[4] = {"realFuncMnAtts", 0};
const char * realFuncModAtts[4] = {"realFuncModAtts", 0};
const char * realFuncMxAtts[4] = {"realFuncMxAtts", 0};
const char * realFuncQtempAtts[3] = {"realFuncQtempAtts", 0};
const char * realFuncRandAtts[3] = {"realFuncRandAtts", 0};
const char * realFuncRlAtts[3] = {"realFuncRlAtts", 0};
const char * realFuncRtodAtts[3] = {"realFuncRtodAtts", 0};
const char * realFuncSignAtts[4] = {"realFuncSignAtts", 0};
const char * realFuncSinAtts[3] = {"realFuncSinAtts", 0};
const char * realFuncSqrtAtts[3] = {"realFuncSqrtAtts", 0};
const char * realFuncTanAtts[3] = {"realFuncTanAtts", 0};
const char * realFuncValAtts[3] = {"realFuncValAtts", 0};
const char * realFuncVdotAtts[4] = {"realFuncVdotAtts", 0};
const char * realFuncVecXAtts[3] = {"realFuncVecXAtts", 0};
const char * realFuncVecYAtts[3] = {"realFuncVecYAtts", 0};
const char * realFuncVecZAtts[3] = {"realFuncVecZAtts", 0};
const char * realFuncVmagAtts[3] = {"realFuncVmagAtts", 0};
const char * realIntExprSubs[7] = {"realIntExprSubs", 0};
const char * realIntExpr_DIVIDAtts[4] = {"realIntExpr_DIVIDAtts", 0};
const char * realIntExpr_MINUSAtts[4] = {"realIntExpr_MINUSAtts", 0};
const char * realIntExpr_PLUSAtts[4] = {"realIntExpr_PLUSAtts", 0};
const char * realIntExpr_POWERAtts[4] = {"realIntExpr_POWERAtts", 0};
const char * realIntExpr_TIMESAtts[4] = {"realIntExpr_TIMESAtts", 0};
const char * realIntRelSubs[8] = {"realIntRelSubs", 0};
const char * realIntRel_EQAtts[4] = {"realIntRel_EQAtts", 0};
const char * realIntRel_GEAtts[4] = {"realIntRel_GEAtts", 0};
const char * realIntRel_GTAtts[4] = {"realIntRel_GTAtts", 0};
const char * realIntRel_LEAtts[4] = {"realIntRel_LEAtts", 0};
const char * realIntRel_LTAtts[4] = {"realIntRel_LTAtts", 0};
const char * realIntRel_NEAtts[4] = {"realIntRel_NEAtts", 0};
const char * realRealExprSubs[7] = {"realRealExprSubs", 0};
const char * realRealExpr_DIVIDAtts[4] = {"realRealExpr_DIVIDAtts", 0};
const char * realRealExpr_MINUSAtts[4] = {"realRealExpr_MINUSAtts", 0};
const char * realRealExpr_PLUSAtts[4] = {"realRealExpr_PLUSAtts", 0};
const char * realRealExpr_POWERAtts[4] = {"realRealExpr_POWERAtts", 0};
const char * realRealExpr_TIMESAtts[4] = {"realRealExpr_TIMESAtts", 0};
const char * realRealRelSubs[8] = {"realRealRelSubs", 0};
const char * realRealRel_EQAtts[4] = {"realRealRel_EQAtts", 0};
const char * realRealRel_GEAtts[4] = {"realRealRel_GEAtts", 0};
const char * realRealRel_GTAtts[4] = {"realRealRel_GTAtts", 0};
const char * realRealRel_LEAtts[4] = {"realRealRel_LEAtts", 0};
const char * realRealRel_LTAtts[4] = {"realRealRel_LTAtts", 0};
const char * realRealRel_NEAtts[4] = {"realRealRel_NEAtts", 0};
const char * realRelSubs[5] = {"realRelSubs", 0};
const char * realValSubs[6] = {"realValSubs", 0};
const char * realVarAtts[4] = {"realVarAtts", 0};
const char * realVecExpr_TIMESAtts[4] = {"realVecExpr_TIMESAtts", 0};
const char * recallDMLStmAtts[4] = {"recallDMLStmAtts", 0};
const char * recallDatumStmAtts[4] = {"recallDatumStmAtts", 0};
const char * recallFeatureStmAtts[4] = {"recallFeatureStmAtts", 0};
const char * recallRotaryTableStmAtts[4] = {"recallRotaryTableStmAtts", 0};
const char * recallSensorStmAtts[4] = {"recallSensorStmAtts", 0};
const char * refmntStmAtts[6] = {"refmntStmAtts", 0};
const char * rentValSubs[4] = {"rentValSubs", 0};
const char * reportItemSubs[12] = {"reportItemSubs", 0};
const char * reportItem_qisLabelAtts[3] = {"reportItem_qisLabelAtts", 0};
const char * reportStmAtts[5] = {"reportStmAtts", 0};
const char * resumeMinorSubs[8] = {"resumeMinorSubs", 0};
const char * resumeMinor_jumpLabelAtts[3] = {"resumeMinor_jumpLabelAtts", 0};
const char * resumeStmAtts[3] = {"resumeStmAtts", 0};
const char * retrieve1Atts[4] = {"retrieve1Atts", 0};
const char * retrieve2Atts[5] = {"retrieve2Atts", 0};
const char * retrieve2bAtts[5] = {"retrieve2bAtts", 0};
const char * retrieve4Atts[7] = {"retrieve4Atts", 0};
const char * rightyLeftySubs[4] = {"rightyLeftySubs", 0};
const char * rmLabelAtts[3] = {"rmLabelAtts", 0};
const char * rmeasArcSubs[4] = {"rmeasArcSubs", 0};
const char * rmeasArc_rmeasSpecFaAtts[5] = {"rmeasArc_rmeasSpecFaAtts", 0};
const char * rmeasArc_rmeasSpecVecbldAtts[5] = {"rmeasArc_rmeasSpecVecbldAtts", 0};
const char * rmeasCircleSubs[4] = {"rmeasCircleSubs", 0};
const char * rmeasCircle_rmeasSpecFaAtts[5] = {"rmeasCircle_rmeasSpecFaAtts", 0};
const char * rmeasCircle_rmeasSpecVecbldAtts[5] = {"rmeasCircle_rmeasSpecVecbldAtts", 0};
const char * rmeasConeAtts[5] = {"rmeasConeAtts", 0};
const char * rmeasCparlnSubs[4] = {"rmeasCparlnSubs", 0};
const char * rmeasCparln_rmeasSpecFaOrientAtts[5] = {"rmeasCparln_rmeasSpecFaOrientAtts", 0};
const char * rmeasCparln_rmeasSpecVecbldOrientAtts[5] = {"rmeasCparln_rmeasSpecVecbldOrientAtts", 0};
const char * rmeasCylndrAtts[5] = {"rmeasCylndrAtts", 0};
const char * rmeasEdgeptSubs[4] = {"rmeasEdgeptSubs", 0};
const char * rmeasEdgept_rmeasSpecFaAxisAtts[5] = {"rmeasEdgept_rmeasSpecFaAxisAtts", 0};
const char * rmeasEdgept_rmeasSpecVecbldEdgeptAtts[5] = {"rmeasEdgept_rmeasSpecVecbldEdgeptAtts", 0};
const char * rmeasEllipsSubs[4] = {"rmeasEllipsSubs", 0};
const char * rmeasEllips_rmeasSpecFaAtts[5] = {"rmeasEllips_rmeasSpecFaAtts", 0};
const char * rmeasEllips_rmeasSpecVecbldAtts[5] = {"rmeasEllips_rmeasSpecVecbldAtts", 0};
const char * rmeasGcurveSubs[4] = {"rmeasGcurveSubs", 0};
const char * rmeasGcurve_rmeasSpecFeatAxisAtts[5] = {"rmeasGcurve_rmeasSpecFeatAxisAtts", 0};
const char * rmeasGcurve_rmeasSpecVecbldAtts[5] = {"rmeasGcurve_rmeasSpecVecbldAtts", 0};
const char * rmeasGsurfAtts[5] = {"rmeasGsurfAtts", 0};
const char * rmeasLineSubs[4] = {"rmeasLineSubs", 0};
const char * rmeasLine_rmeasSpecFeatAxisAtts[5] = {"rmeasLine_rmeasSpecFeatAxisAtts", 0};
const char * rmeasLine_rmeasSpecVecbldAtts[5] = {"rmeasLine_rmeasSpecVecbldAtts", 0};
const char * rmeasMinorSubs[20] = {"rmeasMinorSubs", 0};
const char * rmeasObjectSubs[4] = {"rmeasObjectSubs", 0};
const char * rmeasObject_rmeasSpecFaAtts[5] = {"rmeasObject_rmeasSpecFaAtts", 0};
const char * rmeasObject_rmeasSpecVecbldAtts[5] = {"rmeasObject_rmeasSpecVecbldAtts", 0};
const char * rmeasParplnAtts[5] = {"rmeasParplnAtts", 0};
const char * rmeasPlaneAtts[5] = {"rmeasPlaneAtts", 0};
const char * rmeasPointSubs[4] = {"rmeasPointSubs", 0};
const char * rmeasPoint_rmeasSpecFaAxisAtts[5] = {"rmeasPoint_rmeasSpecFaAxisAtts", 0};
const char * rmeasPoint_rmeasSpecVecbldAtts[5] = {"rmeasPoint_rmeasSpecVecbldAtts", 0};
const char * rmeasRctnglAtts[5] = {"rmeasRctnglAtts", 0};
const char * rmeasSpecFaSubs[3] = {"rmeasSpecFaSubs", 0};
const char * rmeasSpecFaAxisSubs[4] = {"rmeasSpecFaAxisSubs", 0};
const char * rmeasSpecFaAxis_axisAtts[3] = {"rmeasSpecFaAxis_axisAtts", 0};
const char * rmeasSpecFaAxis_faLabelAtts[4] = {"rmeasSpecFaAxis_faLabelAtts", 0};
const char * rmeasSpecFaOrientAtts[4] = {"rmeasSpecFaOrientAtts", 0};
const char * rmeasSpecFeatAxisSubs[4] = {"rmeasSpecFeatAxisSubs", 0};
const char * rmeasSpecFeatAxis_axisAtts[3] = {"rmeasSpecFeatAxis_axisAtts", 0};
const char * rmeasSpecFeatAxis_featureLabel1Atts[4] = {"rmeasSpecFeatAxis_featureLabel1Atts", 0};
const char * rmeasSpecVecbldAtts[4] = {"rmeasSpecVecbldAtts", 0};
const char * rmeasSpecVecbldEdgeptAtts[6] = {"rmeasSpecVecbldEdgeptAtts", 0};
const char * rmeasSpecVecbldOrientAtts[4] = {"rmeasSpecVecbldOrientAtts", 0};
const char * rmeasSphereAtts[5] = {"rmeasSphereAtts", 0};
const char * rmeasStmAtts[3] = {"rmeasStmAtts", 0};
const char * rmeasSymplnAtts[5] = {"rmeasSymplnAtts", 0};
const char * rmeasTorusAtts[5] = {"rmeasTorusAtts", 0};
const char * rotAbsAtts[3] = {"rotAbsAtts", 0};
const char * rotDirSubs[4] = {"rotDirSubs", 0};
const char * rotDir_rotOrientAtts[3] = {"rotDir_rotOrientAtts", 0};
const char * rotIncrAtts[3] = {"rotIncrAtts", 0};
const char * rotOrientSubs[4] = {"rotOrientSubs", 0};
const char * rotTypeSubs[5] = {"rotTypeSubs", 0};
const char * rotabAbsAtts[7] = {"rotabAbsAtts", 0};
const char * rotabFeatAtts[6] = {"rotabFeatAtts", 0};
const char * rotabIncrAtts[7] = {"rotabIncrAtts", 0};
const char * rotabMinorSubs[5] = {"rotabMinorSubs", 0};
const char * rotabStmAtts[3] = {"rotabStmAtts", 0};
const char * rotateDatumAtts[5] = {"rotateDatumAtts", 0};
const char * rotateFeatureAtts[5] = {"rotateFeatureAtts", 0};
const char * rotateMinorSubs[5] = {"rotateMinorSubs", 0};
const char * rotateStmAtts[4] = {"rotateStmAtts", 0};
const char * rotateValueAtts[4] = {"rotateValueAtts", 0};
const char * rotdefStmAtts[5] = {"rotdefStmAtts", 0};
const char * rotsetStmAtts[4] = {"rotsetStmAtts", 0};
const char * rtLabelAtts[3] = {"rtLabelAtts", 0};
const char * rwFormatAtts[4] = {"rwFormatAtts", 0};
const char * rwVarSubs[7] = {"rwVarSubs", 0};
const char * sLabelAtts[3] = {"sLabelAtts", 0};
const char * saLabelAtts[3] = {"saLabelAtts", 0};
const char * saveDMLStmAtts[4] = {"saveDMLStmAtts", 0};
const char * saveDatumStmAtts[4] = {"saveDatumStmAtts", 0};
const char * saveFeatureStmAtts[4] = {"saveFeatureStmAtts", 0};
const char * saveRotaryTableStmAtts[4] = {"saveRotaryTableStmAtts", 0};
const char * saveSensorStmAtts[4] = {"saveSensorStmAtts", 0};
const char * scnmodStmAtts[3] = {"scnmodStmAtts", 0};
const char * scnsetDragAtts[3] = {"scnsetDragAtts", 0};
const char * scnsetMinorSubs[7] = {"scnsetMinorSubs", 0};
const char * scnsetNonconAtts[3] = {"scnsetNonconAtts", 0};
const char * scnsetPeckAtts[3] = {"scnsetPeckAtts", 0};
const char * scnsetSampleSubs[7] = {"scnsetSampleSubs", 0};
const char * scnsetSampleDragSubs[7] = {"scnsetSampleDragSubs", 0};
const char * scnsetSampleDrag_ANGLEAtts[4] = {"scnsetSampleDrag_ANGLEAtts", 0};
const char * scnsetSampleDrag_CHORDAtts[5] = {"scnsetSampleDrag_CHORDAtts", 0};
const char * scnsetSampleDrag_DEFALTAtts[3] = {"scnsetSampleDrag_DEFALTAtts", 0};
const char * scnsetSampleDrag_DISTAtts[5] = {"scnsetSampleDrag_DISTAtts", 0};
const char * scnsetSampleDrag_TIMEAtts[4] = {"scnsetSampleDrag_TIMEAtts", 0};
const char * scnsetSample_ANGLEAtts[3] = {"scnsetSample_ANGLEAtts", 0};
const char * scnsetSample_CHORDAtts[4] = {"scnsetSample_CHORDAtts", 0};
const char * scnsetSample_DISTAtts[4] = {"scnsetSample_DISTAtts", 0};
const char * scnsetSample_TIMEAtts[3] = {"scnsetSample_TIMEAtts", 0};
const char * scnsetStmAtts[3] = {"scnsetStmAtts", 0};
const char * scnsetStopSubs[4] = {"scnsetStopSubs", 0};
const char * scnsetStopPlaneAtts[5] = {"scnsetStopPlaneAtts", 0};
const char * scnsetStopSphereAtts[3] = {"scnsetStopSphereAtts", 0};
const char * scnsetVendorSubs[5] = {"scnsetVendorSubs", 0};
const char * seLabelAtts[3] = {"seLabelAtts", 0};
const char * secondsStringSubs[4] = {"secondsStringSubs", 0};
const char * secondsString_INTSTRINGAtts[3] = {"secondsString_INTSTRINGAtts", 0};
const char * secondsString_REALSTRINGAtts[3] = {"secondsString_REALSTRINGAtts", 0};
const char * selectBlockAtts[6] = {"selectBlockAtts", 0};
const char * selectStmSubs[4] = {"selectStmSubs", 0};
const char * selectStmIntAtts[3] = {"selectStmIntAtts", 0};
const char * selectStmStringAtts[3] = {"selectStmStringAtts", 0};
const char * sensorAreaAtts[7] = {"sensorAreaAtts", 0};
const char * sensorGeometryAtts[5] = {"sensorGeometryAtts", 0};
const char * sensorInfredAtts[8] = {"sensorInfredAtts", 0};
const char * sensorItemSubs[4] = {"sensorItemSubs", 0};
const char * sensorItem_intValAtts[5] = {"sensorItem_intValAtts", 0};
const char * sensorItem_stringValAtts[5] = {"sensorItem_stringValAtts", 0};
const char * sensorLabel1Subs[4] = {"sensorLabel1Subs", 0};
const char * sensorLabel2Subs[4] = {"sensorLabel2Subs", 0};
const char * sensorLaserAtts[6] = {"sensorLaserAtts", 0};
const char * sensorLineAtts[6] = {"sensorLineAtts", 0};
const char * sensorMinorSubs[11] = {"sensorMinorSubs", 0};
const char * sensorMltprbAtts[5] = {"sensorMltprbAtts", 0};
const char * sensorMltprbItemSubs[4] = {"sensorMltprbItemSubs", 0};
const char * sensorMltprbItem_intValAtts[4] = {"sensorMltprbItem_intValAtts", 0};
const char * sensorMltprbItem_stringValAtts[4] = {"sensorMltprbItem_stringValAtts", 0};
const char * sensorMoveSubs[5] = {"sensorMoveSubs", 0};
const char * sensorMove_gotoWristListAtts[3] = {"sensorMove_gotoWristListAtts", 0};
const char * sensorMove_probeOrientAtts[3] = {"sensorMove_probeOrientAtts", 0};
const char * sensorMove_saLabelAtts[3] = {"sensorMove_saLabelAtts", 0};
const char * sensorNonconAtts[5] = {"sensorNonconAtts", 0};
const char * sensorPointAtts[5] = {"sensorPointAtts", 0};
const char * sensorProbeAtts[5] = {"sensorProbeAtts", 0};
const char * sensorProbeFormSubs[5] = {"sensorProbeFormSubs", 0};
const char * sensorProbeForm_CYLNDRAtts[3] = {"sensorProbeForm_CYLNDRAtts", 0};
const char * sensorProbeForm_DISKAtts[3] = {"sensorProbeForm_DISKAtts", 0};
const char * sensorProbeGeometryAtts[5] = {"sensorProbeGeometryAtts", 0};
const char * sensorStmAtts[4] = {"sensorStmAtts", 0};
const char * sensorVideoAtts[7] = {"sensorVideoAtts", 0};
const char * sgLabelAtts[3] = {"sgLabelAtts", 0};
const char * sgageConstAtts[3] = {"sgageConstAtts", 0};
const char * sgsLabelAtts[3] = {"sgsLabelAtts", 0};
const char * signSubs[4] = {"signSubs", 0};
const char * simreqtBlockAtts[5] = {"simreqtBlockAtts", 0};
const char * simreqtMinorSubs[4] = {"simreqtMinorSubs", 0};
const char * simreqtStmAtts[4] = {"simreqtStmAtts", 0};
const char * snsdefBuildAtts[4] = {"snsdefBuildAtts", 0};
const char * snsdefBuildItemSubs[6] = {"snsdefBuildItemSubs", 0};
const char * snsdefBuildItem_rmLabelAtts[3] = {"snsdefBuildItem_rmLabelAtts", 0};
const char * snsdefBuildItem_sgLabelAtts[3] = {"snsdefBuildItem_sgLabelAtts", 0};
const char * snsdefBuildItem_swLabelAtts[4] = {"snsdefBuildItem_swLabelAtts", 0};
const char * snsdefBuildItem_sxLabelAtts[3] = {"snsdefBuildItem_sxLabelAtts", 0};
const char * snsdefBuildSensorSubs[4] = {"snsdefBuildSensorSubs", 0};
const char * snsdefInfredAtts[8] = {"snsdefInfredAtts", 0};
const char * snsdefLaserAtts[6] = {"snsdefLaserAtts", 0};
const char * snsdefLocationSubs[5] = {"snsdefLocationSubs", 0};
const char * snsdefLocation_CARTAtts[4] = {"snsdefLocation_CARTAtts", 0};
const char * snsdefLocation_POLAtts[5] = {"snsdefLocation_POLAtts", 0};
const char * snsdefLocation_VECAtts[4] = {"snsdefLocation_VECAtts", 0};
const char * snsdefMinorSubs[8] = {"snsdefMinorSubs", 0};
const char * snsdefNonconAtts[5] = {"snsdefNonconAtts", 0};
const char * snsdefProbeAtts[6] = {"snsdefProbeAtts", 0};
const char * snsdefProbeFormSubs[5] = {"snsdefProbeFormSubs", 0};
const char * snsdefProbeForm_CYLNDRAtts[3] = {"snsdefProbeForm_CYLNDRAtts", 0};
const char * snsdefProbeForm_DISKAtts[3] = {"snsdefProbeForm_DISKAtts", 0};
const char * snsdefStmAtts[4] = {"snsdefStmAtts", 0};
const char * snsdefTypeSubs[4] = {"snsdefTypeSubs", 0};
const char * snsdefVideoAtts[7] = {"snsdefVideoAtts", 0};
const char * snsdefWristAngleItemAtts[4] = {"snsdefWristAngleItemAtts", 0};
const char * snsetFeatSubs[5] = {"snsetFeatSubs", 0};
const char * snsetItemSubs[9] = {"snsetItemSubs", 0};
const char * snsetItem_CLRSRFAtts[4] = {"snsetItem_CLRSRFAtts", 0};
const char * snsetItem_DEPTHAtts[4] = {"snsetItem_DEPTHAtts", 0};
const char * snsetItem_snsetLabelAtts[3] = {"snsetItem_snsetLabelAtts", 0};
const char * snsetItem_snsetLabelAndValueAtts[3] = {"snsetItem_snsetLabelAndValueAtts", 0};
const char * snsetItem_snsetToggleAtts[3] = {"snsetItem_snsetToggleAtts", 0};
const char * snsetItem_snsetTypeAtts[3] = {"snsetItem_snsetTypeAtts", 0};
const char * snsetItem_snsetTypeAndValueAtts[3] = {"snsetItem_snsetTypeAndValueAtts", 0};
const char * snsetLabelSubs[5] = {"snsetLabelSubs", 0};
const char * snsetLabelAndValueAtts[4] = {"snsetLabelAndValueAtts", 0};
const char * snsetStmAtts[3] = {"snsetStmAtts", 0};
const char * snsetToggleSubs[4] = {"snsetToggleSubs", 0};
const char * snsetTypeSubs[4] = {"snsetTypeSubs", 0};
const char * snsetTypeAndValueSubs[10] = {"snsetTypeAndValueSubs", 0};
const char * snsetTypeAndValue_APPRCHAtts[3] = {"snsetTypeAndValue_APPRCHAtts", 0};
const char * snsetTypeAndValue_CLRSRFAtts[3] = {"snsetTypeAndValue_CLRSRFAtts", 0};
const char * snsetTypeAndValue_DEPTHAtts[3] = {"snsetTypeAndValue_DEPTHAtts", 0};
const char * snsetTypeAndValue_MINCONAtts[3] = {"snsetTypeAndValue_MINCONAtts", 0};
const char * snsetTypeAndValue_RETRCTAtts[3] = {"snsetTypeAndValue_RETRCTAtts", 0};
const char * snsetTypeAndValue_SCALEXAtts[3] = {"snsetTypeAndValue_SCALEXAtts", 0};
const char * snsetTypeAndValue_SCALEYAtts[3] = {"snsetTypeAndValue_SCALEYAtts", 0};
const char * snsetTypeAndValue_SEARCHAtts[3] = {"snsetTypeAndValue_SEARCHAtts", 0};
const char * snsgrpItemSubs[6] = {"snsgrpItemSubs", 0};
const char * snsgrpMinorSubs[4] = {"snsgrpMinorSubs", 0};
const char * snsgrpMinor_sgsLabelAtts[4] = {"snsgrpMinor_sgsLabelAtts", 0};
const char * snsgrpMinor_ssLabelAtts[4] = {"snsgrpMinor_ssLabelAtts", 0};
const char * snsgrpStmAtts[4] = {"snsgrpStmAtts", 0};
const char * snslctDataSubs[4] = {"snslctDataSubs", 0};
const char * snslctData_probeOrientAtts[3] = {"snslctData_probeOrientAtts", 0};
const char * snslctData_snslctWristListAtts[3] = {"snslctData_snslctWristListAtts", 0};
const char * snslctGroupSubs[4] = {"snslctGroupSubs", 0};
const char * snslctGroupFeatAtts[5] = {"snslctGroupFeatAtts", 0};
const char * snslctGroupVecAtts[5] = {"snslctGroupVecAtts", 0};
const char * snslctSensorSubs[4] = {"snslctSensorSubs", 0};
const char * snslctSensorListAtts[4] = {"snslctSensorListAtts", 0};
const char * snslctSensorTipAtts[5] = {"snslctSensorTipAtts", 0};
const char * snslctStmSubs[4] = {"snslctStmSubs", 0};
const char * snslctStmGroupAtts[3] = {"snslctStmGroupAtts", 0};
const char * snslctStmSensorAtts[3] = {"snslctStmSensorAtts", 0};
const char * snslctTipDataSubs[4] = {"snslctTipDataSubs", 0};
const char * snslctWristAngleAngleAtts[4] = {"snslctWristAngleAngleAtts", 0};
const char * snslctWristAngleFeatAtts[5] = {"snslctWristAngleFeatAtts", 0};
const char * snslctWristAngleItemSubs[5] = {"snslctWristAngleItemSubs", 0};
const char * snslctWristAngleVecAtts[5] = {"snslctWristAngleVecAtts", 0};
const char * snslctWristItemAtts[4] = {"snslctWristItemAtts", 0};
const char * snsmntMinorAtts[5] = {"snsmntMinorAtts", 0};
const char * snsmntStmAtts[3] = {"snsmntStmAtts", 0};
const char * spartConstAtts[3] = {"spartConstAtts", 0};
const char * srLabelAtts[3] = {"srLabelAtts", 0};
const char * sraLabelAtts[3] = {"sraLabelAtts", 0};
const char * ssLabelAtts[3] = {"ssLabelAtts", 0};
const char * stLabelAtts[3] = {"stLabelAtts", 0};
const char * stackElementSubs[6] = {"stackElementSubs", 0};
const char * stateSubs[4] = {"stateSubs", 0};
const char * storageSpecSubs[6] = {"storageSpecSubs", 0};
const char * strVar7Atts[4] = {"strVar7Atts", 0};
const char * stringConstAtts[3] = {"stringConstAtts", 0};
const char * stringFuncSubs[19] = {"stringFuncSubs", 0};
const char * stringFuncChrAtts[3] = {"stringFuncChrAtts", 0};
const char * stringFuncConcatAtts[4] = {"stringFuncConcatAtts", 0};
const char * stringFuncElemntAtts[5] = {"stringFuncElemntAtts", 0};
const char * stringFuncLwcAtts[3] = {"stringFuncLwcAtts", 0};
const char * stringFuncRptAtts[4] = {"stringFuncRptAtts", 0};
const char * stringFuncSelapsetimeAtts[5] = {"stringFuncSelapsetimeAtts", 0};
const char * stringFuncStrAtts[4] = {"stringFuncStrAtts", 0};
const char * stringFuncSubstrAtts[5] = {"stringFuncSubstrAtts", 0};
const char * stringFuncTrimAtts[3] = {"stringFuncTrimAtts", 0};
const char * stringFuncUpcAtts[3] = {"stringFuncUpcAtts", 0};
const char * stringRelSubs[8] = {"stringRelSubs", 0};
const char * stringRel_EQAtts[4] = {"stringRel_EQAtts", 0};
const char * stringRel_GEAtts[4] = {"stringRel_GEAtts", 0};
const char * stringRel_GTAtts[4] = {"stringRel_GTAtts", 0};
const char * stringRel_LEAtts[4] = {"stringRel_LEAtts", 0};
const char * stringRel_LTAtts[4] = {"stringRel_LTAtts", 0};
const char * stringRel_NEAtts[4] = {"stringRel_NEAtts", 0};
const char * stringValSubs[5] = {"stringValSubs", 0};
const char * stringVarAtts[4] = {"stringVarAtts", 0};
const char * surfPtdataHeadcsListItemAtts[8] = {"surfPtdataHeadcsListItemAtts", 0};
const char * surfPtdataListItemAtts[5] = {"surfPtdataListItemAtts", 0};
const char * surfPtdataPcsListItemAtts[6] = {"surfPtdataPcsListItemAtts", 0};
const char * swLabelAtts[3] = {"swLabelAtts", 0};
const char * sxLabelAtts[3] = {"sxLabelAtts", 0};
const char * tLabelAtts[3] = {"tLabelAtts", 0};
const char * taLabelAtts[3] = {"taLabelAtts", 0};
const char * tantoConstSubs[4] = {"tantoConstSubs", 0};
const char * tantoConstFAtts[4] = {"tantoConstFAtts", 0};
const char * tantoConstFaAtts[5] = {"tantoConstFaAtts", 0};
const char * tantoConstPlaneSubs[4] = {"tantoConstPlaneSubs", 0};
const char * tantoConstPlaneFAtts[4] = {"tantoConstPlaneFAtts", 0};
const char * tantoConstPlaneFaAtts[4] = {"tantoConstPlaneFaAtts", 0};
const char * tecompDatumAtts[3] = {"tecompDatumAtts", 0};
const char * tecompMinorSubs[6] = {"tecompMinorSubs", 0};
const char * tecompMinorMachAtts[3] = {"tecompMinorMachAtts", 0};
const char * tecompMinorOnAllAtts[5] = {"tecompMinorOnAllAtts", 0};
const char * tecompMinorOnListAtts[6] = {"tecompMinorOnListAtts", 0};
const char * tecompOffsetAtts[5] = {"tecompOffsetAtts", 0};
const char * tecompStmAtts[3] = {"tecompStmAtts", 0};
const char * tecompVar2Subs[4] = {"tecompVar2Subs", 0};
const char * tempUnitSubs[4] = {"tempUnitSubs", 0};
const char * textManAtts[3] = {"textManAtts", 0};
const char * textMinorSubs[6] = {"textMinorSubs", 0};
const char * textOperAtts[3] = {"textOperAtts", 0};
const char * textOutfilAtts[3] = {"textOutfilAtts", 0};
const char * textQueryAtts[4] = {"textQueryAtts", 0};
const char * textQueryFormatAtts[6] = {"textQueryFormatAtts", 0};
const char * textStmAtts[3] = {"textStmAtts", 0};
const char * textTypeSubs[5] = {"textTypeSubs", 0};
const char * thLabelAtts[3] = {"thLabelAtts", 0};
const char * thldefPocketSubs[9] = {"thldefPocketSubs", 0};
const char * thldefPocket_rmLabelAtts[4] = {"thldefPocket_rmLabelAtts", 0};
const char * thldefPocket_sLabelAtts[4] = {"thldefPocket_sLabelAtts", 0};
const char * thldefPocket_sgLabelAtts[4] = {"thldefPocket_sgLabelAtts", 0};
const char * thldefPocket_sgsLabelAtts[4] = {"thldefPocket_sgsLabelAtts", 0};
const char * thldefPocket_ssLabelAtts[4] = {"thldefPocket_ssLabelAtts", 0};
const char * thldefPocket_swLabelAtts[4] = {"thldefPocket_swLabelAtts", 0};
const char * thldefPocket_sxLabelAtts[4] = {"thldefPocket_sxLabelAtts", 0};
const char * thldefStmAtts[4] = {"thldefStmAtts", 0};
const char * tierSubs[4] = {"tierSubs", 0};
const char * tlLabelAtts[3] = {"tlLabelAtts", 0};
const char * tolAnglStmAtts[5] = {"tolAnglStmAtts", 0};
const char * tolAnglbStmAtts[7] = {"tolAnglbStmAtts", 0};
const char * tolAnglrStmAtts[5] = {"tolAnglrStmAtts", 0};
const char * tolAnglwrtStmAtts[8] = {"tolAnglwrtStmAtts", 0};
const char * tolAppDataAtts[8] = {"tolAppDataAtts", 0};
const char * tolCirltyStmAtts[4] = {"tolCirltyStmAtts", 0};
const char * tolCompos1Atts[7] = {"tolCompos1Atts", 0};
const char * tolCompos2Atts[7] = {"tolCompos2Atts", 0};
const char * tolComposStmAtts[5] = {"tolComposStmAtts", 0};
const char * tolConcenStmAtts[5] = {"tolConcenStmAtts", 0};
const char * tolCortolAngleAtts[4] = {"tolCortolAngleAtts", 0};
const char * tolCortolAxisAtts[6] = {"tolCortolAxisAtts", 0};
const char * tolCortolMinorSubs[5] = {"tolCortolMinorSubs", 0};
const char * tolCortolRadialAtts[4] = {"tolCortolRadialAtts", 0};
const char * tolCortolStmAtts[4] = {"tolCortolStmAtts", 0};
const char * tolCprofSpecAtts[8] = {"tolCprofSpecAtts", 0};
const char * tolCprofSpecCAtts[8] = {"tolCprofSpecCAtts", 0};
const char * tolCproflStmAtts[5] = {"tolCproflStmAtts", 0};
const char * tolCprofsStmAtts[5] = {"tolCprofsStmAtts", 0};
const char * tolCrnoutStmAtts[8] = {"tolCrnoutStmAtts", 0};
const char * tolCylctyStmAtts[4] = {"tolCylctyStmAtts", 0};
const char * tolDiamAvgAtts[5] = {"tolDiamAvgAtts", 0};
const char * tolDiamMinmaxAtts[5] = {"tolDiamMinmaxAtts", 0};
const char * tolDiamMinorSubs[5] = {"tolDiamMinorSubs", 0};
const char * tolDiamPlainAtts[5] = {"tolDiamPlainAtts", 0};
const char * tolDiamStmAtts[4] = {"tolDiamStmAtts", 0};
const char * tolDistbDirSubs[6] = {"tolDistbDirSubs", 0};
const char * tolDistbLimitAtts[4] = {"tolDistbLimitAtts", 0};
const char * tolDistbNominlAtts[5] = {"tolDistbNominlAtts", 0};
const char * tolDistbStmAtts[6] = {"tolDistbStmAtts", 0};
const char * tolDistbTolSubs[4] = {"tolDistbTolSubs", 0};
const char * tolDistwrtStmAtts[7] = {"tolDistwrtStmAtts", 0};
const char * tolFeatMaxMatSubs[5] = {"tolFeatMaxMatSubs", 0};
const char * tolFeatMaxMat_datLabelAtts[4] = {"tolFeatMaxMat_datLabelAtts", 0};
const char * tolFeatMaxMat_fLabelAtts[3] = {"tolFeatMaxMat_fLabelAtts", 0};
const char * tolFeatMaxMat_faLabelAtts[4] = {"tolFeatMaxMat_faLabelAtts", 0};
const char * tolFeatureSubs[5] = {"tolFeatureSubs", 0};
const char * tolFeatureMatSubs[5] = {"tolFeatureMatSubs", 0};
const char * tolFeatureMat_datLabelAtts[4] = {"tolFeatureMat_datLabelAtts", 0};
const char * tolFeatureMat_fLabelAtts[3] = {"tolFeatureMat_fLabelAtts", 0};
const char * tolFeatureMat_faLabelAtts[4] = {"tolFeatureMat_faLabelAtts", 0};
const char * tolFlatMinorSubs[5] = {"tolFlatMinorSubs", 0};
const char * tolFlatPerAtts[5] = {"tolFlatPerAtts", 0};
const char * tolFlatStmAtts[4] = {"tolFlatStmAtts", 0};
const char * tolFlatZonAtts[3] = {"tolFlatZonAtts", 0};
const char * tolFlatZonPerAtts[6] = {"tolFlatZonPerAtts", 0};
const char * tolGtolRotSubs[10] = {"tolGtolRotSubs", 0};
const char * tolGtolSpecSubs[4] = {"tolGtolSpecSubs", 0};
const char * tolGtolStmAtts[9] = {"tolGtolStmAtts", 0};
const char * tolGtolTransSubs[10] = {"tolGtolTransSubs", 0};
const char * tolMatCondSubs[5] = {"tolMatCondSubs", 0};
const char * tolMaxMatCondSubs[5] = {"tolMaxMatCondSubs", 0};
const char * tolMaxMatCond_LMCAtts[3] = {"tolMaxMatCond_LMCAtts", 0};
const char * tolMaxMatCond_MMCAtts[3] = {"tolMaxMatCond_MMCAtts", 0};
const char * tolParlelStmAtts[4] = {"tolParlelStmAtts", 0};
const char * tolPerpStmAtts[4] = {"tolPerpStmAtts", 0};
const char * tolPosEndAtts[7] = {"tolPosEndAtts", 0};
const char * tolPosMethodSubs[8] = {"tolPosMethodSubs", 0};
const char * tolPosMethod_VECAtts[3] = {"tolPosMethod_VECAtts", 0};
const char * tolPosStartSubs[4] = {"tolPosStartSubs", 0};
const char * tolPosStart_THREEDAtts[3] = {"tolPosStart_THREEDAtts", 0};
const char * tolPosStart_TWODAtts[3] = {"tolPosStart_TWODAtts", 0};
const char * tolPosStmAtts[5] = {"tolPosStmAtts", 0};
const char * tolProflStmAtts[9] = {"tolProflStmAtts", 0};
const char * tolProfpStmAtts[8] = {"tolProfpStmAtts", 0};
const char * tolProfsStmAtts[9] = {"tolProfsStmAtts", 0};
const char * tolRadSpecSubs[4] = {"tolRadSpecSubs", 0};
const char * tolRadStmAtts[7] = {"tolRadStmAtts", 0};
const char * tolStrghtMatAtts[6] = {"tolStrghtMatAtts", 0};
const char * tolStrghtMinorSubs[6] = {"tolStrghtMinorSubs", 0};
const char * tolStrghtPer1Atts[6] = {"tolStrghtPer1Atts", 0};
const char * tolStrghtPer2Atts[7] = {"tolStrghtPer2Atts", 0};
const char * tolStrghtPlainAtts[5] = {"tolStrghtPlainAtts", 0};
const char * tolStrghtStmAtts[4] = {"tolStrghtStmAtts", 0};
const char * tolSymStmAtts[6] = {"tolSymStmAtts", 0};
const char * tolTrnoutStmAtts[7] = {"tolTrnoutStmAtts", 0};
const char * tolUsetolStmAtts[4] = {"tolUsetolStmAtts", 0};
const char * tolWidthDirSubs[5] = {"tolWidthDirSubs", 0};
const char * tolWidthDir_vectorAtts[3] = {"tolWidthDir_vectorAtts", 0};
const char * tolWidthStmAtts[7] = {"tolWidthStmAtts", 0};
const char * tolZoneDirSubs[6] = {"tolZoneDirSubs", 0};
const char * tolZoneDir2Subs[6] = {"tolZoneDir2Subs", 0};
const char * tolZoneDir2_VECAtts[3] = {"tolZoneDir2_VECAtts", 0};
const char * tolZoneDir3Subs[6] = {"tolZoneDir3Subs", 0};
const char * tolZoneDir3_VECAtts[3] = {"tolZoneDir3_VECAtts", 0};
const char * tolZoneDir_VECAtts[3] = {"tolZoneDir_VECAtts", 0};
const char * tolZoneTypeSubs[4] = {"tolZoneTypeSubs", 0};
const char * toleranceLabelSubs[4] = {"toleranceLabelSubs", 0};
const char * tooldfStmAtts[5] = {"tooldfStmAtts", 0};
const char * touchSpecSubs[4] = {"touchSpecSubs", 0};
const char * trConstAtts[4] = {"trConstAtts", 0};
const char * transDatumAtts[4] = {"transDatumAtts", 0};
const char * transFeatureAtts[4] = {"transFeatureAtts", 0};
const char * transMinorSubs[6] = {"transMinorSubs", 0};
const char * transProbeSubs[4] = {"transProbeSubs", 0};
const char * transProbe_MINUSPRBRADAtts[3] = {"transProbe_MINUSPRBRADAtts", 0};
const char * transProbe_PRBRADAtts[3] = {"transProbe_PRBRADAtts", 0};
const char * transStmAtts[6] = {"transStmAtts", 0};
const char * transValueAtts[4] = {"transValueAtts", 0};
const char * typePointSubs[4] = {"typePointSubs", 0};
const char * uLabelAtts[3] = {"uLabelAtts", 0};
const char * uncertMinorSubs[4] = {"uncertMinorSubs", 0};
const char * uncertMinor_ALGORAtts[3] = {"uncertMinor_ALGORAtts", 0};
const char * uncertMinor_stringValAtts[4] = {"uncertMinor_stringValAtts", 0};
const char * uncertVar3Subs[5] = {"uncertVar3Subs", 0};
const char * uncertVar3_DMEAtts[3] = {"uncertVar3_DMEAtts", 0};
const char * uncertVar3_SENSAtts[3] = {"uncertVar3_SENSAtts", 0};
const char * uncertVar3_paramListAtts[3] = {"uncertVar3_paramListAtts", 0};
const char * uncertalgStmAtts[4] = {"uncertalgStmAtts", 0};
const char * uncertsetMinorSubs[4] = {"uncertsetMinorSubs", 0};
const char * uncertsetMinor_ONAtts[4] = {"uncertsetMinor_ONAtts", 0};
const char * uncertsetStmAtts[3] = {"uncertsetStmAtts", 0};
const char * uncertsetVar2Subs[4] = {"uncertsetVar2Subs", 0};
const char * uncertsetVar2_drLabelAtts[3] = {"uncertsetVar2_drLabelAtts", 0};
const char * unitsStmAtts[5] = {"unitsStmAtts", 0};
const char * vLabelAtts[3] = {"vLabelAtts", 0};
const char * vaLabelAtts[3] = {"vaLabelAtts", 0};
const char * valueAclratRealSubs[5] = {"valueAclratRealSubs", 0};
const char * valueAclratStringAtts[3] = {"valueAclratStringAtts", 0};
const char * valueBoundIntSubs[4] = {"valueBoundIntSubs", 0};
const char * valueBoundInt_featureLabelAtts[3] = {"valueBoundInt_featureLabelAtts", 0};
const char * valueBoundInt_toleranceLabelAtts[3] = {"valueBoundInt_toleranceLabelAtts", 0};
const char * valueBoundStringSubs[4] = {"valueBoundStringSubs", 0};
const char * valueBoundString_featureLabelAtts[4] = {"valueBoundString_featureLabelAtts", 0};
const char * valueBoundString_toleranceLabelAtts[4] = {"valueBoundString_toleranceLabelAtts", 0};
const char * valueCzslctAtts[3] = {"valueCzslctAtts", 0};
const char * valueDmismdSubs[4] = {"valueDmismdSubs", 0};
const char * valueDmismnSubs[4] = {"valueDmismnSubs", 0};
const char * valueErrorSubs[4] = {"valueErrorSubs", 0};
const char * valueFaIntAtts[3] = {"valueFaIntAtts", 0};
const char * valueFaRealAtts[4] = {"valueFaRealAtts", 0};
const char * valueFedratRealSubs[6] = {"valueFedratRealSubs", 0};
const char * valueFedratStringAtts[3] = {"valueFedratStringAtts", 0};
const char * valueFilnamSubs[4] = {"valueFilnamSubs", 0};
const char * valueGeoalgAtts[3] = {"valueGeoalgAtts", 0};
const char * valueGotoRealAtts[3] = {"valueGotoRealAtts", 0};
const char * valueKeycharSubs[3] = {"valueKeycharSubs", 0};
const char * valueMinorBoolSubs[11] = {"valueMinorBoolSubs", 0};
const char * valueMinorIntSubs[4] = {"valueMinorIntSubs", 0};
const char * valueMinorRealSubs[13] = {"valueMinorRealSubs", 0};
const char * valueMinorStringSubs[19] = {"valueMinorStringSubs", 0};
const char * valueMinorVectorSubs[5] = {"valueMinorVectorSubs", 0};
const char * valuePtmeasRealAtts[3] = {"valuePtmeasRealAtts", 0};
const char * valueRtSubs[4] = {"valueRtSubs", 0};
const char * valueRt_CCWAtts[3] = {"valueRt_CCWAtts", 0};
const char * valueRt_CWAtts[3] = {"valueRt_CWAtts", 0};
const char * valueSaSubs[5] = {"valueSaSubs", 0};
const char * valueSaDescAtts[4] = {"valueSaDescAtts", 0};
const char * valueSaPlainAtts[3] = {"valueSaPlainAtts", 0};
const char * valueSaTipnumAtts[4] = {"valueSaTipnumAtts", 0};
const char * valueSnsetRealSubs[7] = {"valueSnsetRealSubs", 0};
const char * valueSnsetStringSubs[4] = {"valueSnsetStringSubs", 0};
const char * valueSnsmntSubs[5] = {"valueSnsmntSubs", 0};
const char * valueStmSubs[7] = {"valueStmSubs", 0};
const char * valueStm_boolVarAtts[4] = {"valueStm_boolVarAtts", 0};
const char * valueStm_intVarAtts[4] = {"valueStm_intVarAtts", 0};
const char * valueStm_realVarAtts[4] = {"valueStm_realVarAtts", 0};
const char * valueStm_stringVarAtts[4] = {"valueStm_stringVarAtts", 0};
const char * valueStm_vectorVarAtts[4] = {"valueStm_vectorVarAtts", 0};
const char * valueSwAtts[4] = {"valueSwAtts", 0};
const char * valueTaBoolSubs[4] = {"valueTaBoolSubs", 0};
const char * valueTaBoolIntolAtts[4] = {"valueTaBoolIntolAtts", 0};
const char * valueTaBoolOutolAtts[4] = {"valueTaBoolOutolAtts", 0};
const char * valueTaRealSubs[5] = {"valueTaRealSubs", 0};
const char * valueTaRealActAtts[4] = {"valueTaRealActAtts", 0};
const char * valueTaRealAmtAtts[4] = {"valueTaRealAmtAtts", 0};
const char * valueTaRealDevAtts[4] = {"valueTaRealDevAtts", 0};
const char * valueUnitsSubs[5] = {"valueUnitsSubs", 0};
const char * vecExpr_MINUSAtts[4] = {"vecExpr_MINUSAtts", 0};
const char * vecExpr_PARENAtts[3] = {"vecExpr_PARENAtts", 0};
const char * vecExpr_PLUSAtts[4] = {"vecExpr_PLUSAtts", 0};
const char * vecIntExpr_DIVIDAtts[4] = {"vecIntExpr_DIVIDAtts", 0};
const char * vecIntExpr_TIMESAtts[4] = {"vecIntExpr_TIMESAtts", 0};
const char * vecRealExpr_DIVIDAtts[4] = {"vecRealExpr_DIVIDAtts", 0};
const char * vecRealExpr_TIMESAtts[4] = {"vecRealExpr_TIMESAtts", 0};
const char * vectorAtts[5] = {"vectorAtts", 0};
const char * vectorExprSubs[11] = {"vectorExprSubs", 0};
const char * vectorFuncSubs[8] = {"vectorFuncSubs", 0};
const char * vectorFuncVcartAtts[5] = {"vectorFuncVcartAtts", 0};
const char * vectorFuncVcrossAtts[4] = {"vectorFuncVcrossAtts", 0};
const char * vectorFuncVmcsAtts[3] = {"vectorFuncVmcsAtts", 0};
const char * vectorFuncVpcsAtts[3] = {"vectorFuncVpcsAtts", 0};
const char * vectorFuncVpolAtts[5] = {"vectorFuncVpolAtts", 0};
const char * vectorFuncVunitAtts[3] = {"vectorFuncVunitAtts", 0};
const char * vectorRelSubs[4] = {"vectorRelSubs", 0};
const char * vectorRel_EQAtts[4] = {"vectorRel_EQAtts", 0};
const char * vectorRel_NEAtts[4] = {"vectorRel_NEAtts", 0};
const char * vectorValSubs[5] = {"vectorValSubs", 0};
const char * vectorVarAtts[4] = {"vectorVarAtts", 0};
const char * versionTagAtts[3] = {"versionTagAtts", 0};
const char * vertexConstAtts[3] = {"vertexConstAtts", 0};
const char * vfLabelAtts[3] = {"vfLabelAtts", 0};
const char * vformItemSubs[11] = {"vformItemSubs", 0};
const char * vformItem_ACTAtts[3] = {"vformItem_ACTAtts", 0};
const char * vformItem_AMTAtts[3] = {"vformItem_AMTAtts", 0};
const char * vformItem_DEVAtts[3] = {"vformItem_DEVAtts", 0};
const char * vformItem_DMEAtts[3] = {"vformItem_DMEAtts", 0};
const char * vformItem_HISTAtts[3] = {"vformItem_HISTAtts", 0};
const char * vformItem_NOMAtts[3] = {"vformItem_NOMAtts", 0};
const char * vformItem_PLOTAtts[3] = {"vformItem_PLOTAtts", 0};
const char * vformItem_STATAtts[3] = {"vformItem_STATAtts", 0};
const char * vformStmAtts[4] = {"vformStmAtts", 0};
const char * vlLabelAtts[3] = {"vlLabelAtts", 0};
const char * vwLabelAtts[3] = {"vwLabelAtts", 0};
const char * windefBoxAtts[6] = {"windefBoxAtts", 0};
const char * windefEdgelnAtts[5] = {"windefEdgelnAtts", 0};
const char * windefMinorSubs[4] = {"windefMinorSubs", 0};
const char * windefStmAtts[4] = {"windefStmAtts", 0};
const char * wkplanStmAtts[3] = {"wkplanStmAtts", 0};
const char * wristDataDescSubs[4] = {"wristDataDescSubs", 0};
const char * wristDataDesc_intValAtts[5] = {"wristDataDesc_intValAtts", 0};
const char * wristDataDesc_stringValAtts[5] = {"wristDataDesc_stringValAtts", 0};
const char * wristDefAtts[4] = {"wristDefAtts", 0};
const char * wristMountDefAtts[5] = {"wristMountDefAtts", 0};
const char * wristMountOffsetAtts[3] = {"wristMountOffsetAtts", 0};
const char * wristRotDefAtts[5] = {"wristRotDefAtts", 0};
const char * wristRotLimitSubs[4] = {"wristRotLimitSubs", 0};
const char * wristRotLimit_angleAtts[4] = {"wristRotLimit_angleAtts", 0};
const char * wristRotStepSubs[4] = {"wristRotStepSubs", 0};
const char * wristRotStep_angleAtts[3] = {"wristRotStep_angleAtts", 0};
const char * wristStmAtts[6] = {"wristStmAtts", 0};
const char * writeSpecSubs[5] = {"writeSpecSubs", 0};
const char * writeSpec_rwVarAtts[4] = {"writeSpec_rwVarAtts", 0};
const char * writeSpec_stringConstAtts[3] = {"writeSpec_stringConstAtts", 0};
const char * writeSpec_stringFuncAtts[3] = {"writeSpec_stringFuncAtts", 0};
const char * writeStmAtts[4] = {"writeStmAtts", 0};
const char * xternBlockAtts[5] = {"xternBlockAtts", 0};
const char * xtractStmAtts[4] = {"xtractStmAtts", 0};

/********************************************************************/

/* analyzeItems

This is not written using "else if"s because some compilers fail when
there are a lot of them.

*/

void analyzeItems(                   /* ARGUMENTS                         */
 std::list<dmisStatement *> * items) /* list of dmisStatements to examine */
{
  std::list<dmisStatement *>::iterator iter;

  for (iter = items->begin(); iter != items->end(); iter++)
    {
      if (isA((*iter), aclratStm))
	{ aclratStms++; continue; }
      if (isA((*iter), algdefStm))
	{ algdefStms++; continue; }
      if (isA((*iter), assignStm))
	{ assignStms++; continue; }
      if (isA((*iter), badtstStm))
	{ badtstStms++; continue; }
      if (isA((*iter), boundStm))
	{ boundStms++; continue; }
      if (isA((*iter), calibMasterStm))
	{ calibMasterStms++; continue; }
      if (isA((*iter), calibRtabStm))
	{ calibRtabStms++; continue; }
      if (isA((*iter), calibSensStm))
	{ calibSensStms++; continue; }
      if (isA((*iter), callStm))
	{ callStms++; continue; }
      if (isA((*iter), caseStm))
	{ caseStms++; continue; }
      if (isA((*iter), clmpidStm))
	{ clmpidStms++; continue; }
      if (isA((*iter), clmpsnStm))
	{ clmpsnStms++; continue; }
      if (isA((*iter), closeStm))
	{ closeStms++; continue; }
      if (isA((*iter), cmpntgrpStm))
	{ cmpntgrpStms++; continue; }
      if (isA((*iter), cnfrmrulStm))
	{ cnfrmrulStms++; continue; }
      if (isA((*iter), constStm))
	{ constStms++; continue; }
      if (isA((*iter), crgdefStm))
	{ crgdefStms++; continue; }
      if (isA((*iter), crmodeStm))
	{ crmodeStms++; continue; }
      if (isA((*iter), crosclStm))
	{ crosclStms++; continue; }
      if (isA((*iter), crslctStm))
	{ crslctStms++; continue; }
      if (isA((*iter), cutcomStm))
	{ cutcomStms++; continue; }
      if (isA((*iter), czoneStm))
	{ czoneStms++; continue; }
      if (isA((*iter), czslctStm))
	{ czslctStms++; continue; }
      if (isA((*iter), datdefStm))
	{ datdefStms++; continue; }
      if (isA((*iter), datsetStm))
	{ datsetStms++; continue; }
      if (isA((*iter), dattrgdefStm))
	{ dattrgdefStms++; continue; }
      if (isA((*iter), declStm))
	{ declStms++; continue; }
      if (isA((*iter), decplStm))
	{ decplStms++; continue; }
      if (isA((*iter), deleteStm))
	{ deleteStms++; continue; }
      if (isA((*iter), deviceStm))
	{ deviceStms++; continue; }
      if (isA((*iter), dftcasStm))
	{ dftcasStms++; continue; }
      if (isA((*iter), displyStm))
	{ displyStms++; continue; }
      if (isA((*iter), dmehwStm))
	{ dmehwStms++; continue; }
      if (isA((*iter), dmeidStm))
	{ dmeidStms++; continue; }
      if (isA((*iter), dmeswStm))
	{ dmeswStms++; continue; }
      if (isA((*iter), dmeswiStm))
	{ dmeswiStms++; continue; }
      if (isA((*iter), dmeswvStm))
	{ dmeswvStms++; continue; }
      if (isA((*iter), dmisOffStm))
	{ dmisOffStms++; continue; }
      if (isA((*iter), dmisOnStm))
	{ dmisOnStms++; continue; }
      if (isA((*iter), dmismdStm))
	{ dmismdStms++; continue; }
      if (isA((*iter), dmismnStm))
	{ dmismnStms++; continue; }
      if (isA((*iter), doStm))
	{ doStms++; continue; }
      if (isA((*iter), elseStm))
	{ elseStms++; continue; }
      if (isA((*iter), endcasStm))
	{ endcasStms++; continue; }
      if (isA((*iter), enddoStm))
	{ enddoStms++; continue; }
      if (isA((*iter), endfilStm))
	{ endfilStms++; continue; }
      if (isA((*iter), endgoStm))
	{ endgoStms++; continue; }
      if (isA((*iter), endifStm))
	{ endifStms++; continue; }
      if (isA((*iter), endmacStm))
	{ endmacStms++; continue; }
      if (isA((*iter), endmesStm))
	{ endmesStms++; continue; }
      if (isA((*iter), endselStm))
	{ endselStms++; continue; }
      if (isA((*iter), endsimreqtStm))
	{ endsimreqtStms++; continue; }
      if (isA((*iter), endxtnStm))
	{ endxtnStms++; continue; }
      if (isA((*iter), equateStm))
	{ equateStms++; continue; }
      if (isA((*iter), errorStm))
	{ errorStms++; continue; }
      if (isA((*iter), evalStm))
	{ evalStms++; continue; }
      if (isA((*iter), extensStm))
	{ extensStms++; continue; }
      if (isA((*iter), extfilStm))
	{ extfilStms++; continue; }
      if (isA((*iter), featArc1Stm))
	{ featArc1Stms++; continue; }
      if (isA((*iter), featArc2Stm))
	{ featArc2Stms++; continue; }
      if (isA((*iter), featCircleStm))
	{ featCircleStms++; continue; }
      if (isA((*iter), featCompoundStm))
	{ featCompoundStms++; continue; }
      if (isA((*iter), featConeStm))
	{ featConeStms++; continue; }
      if (isA((*iter), featConradsegStm))
	{ featConradsegStms++; continue; }
      if (isA((*iter), featCparlnStm))
	{ featCparlnStms++; continue; }
      if (isA((*iter), featCylndrStm))
	{ featCylndrStms++; continue; }
      if (isA((*iter), featCylradsegStm))
	{ featCylradsegStms++; continue; }
      if (isA((*iter), featEdgeptStm))
	{ featEdgeptStms++; continue; }
      if (isA((*iter), featEllipsStm))
	{ featEllipsStms++; continue; }
      if (isA((*iter), featElongcylStm))
	{ featElongcylStms++; continue; }
      if (isA((*iter), featGcurveStm))
	{ featGcurveStms++; continue; }
      if (isA((*iter), featGeomStm))
	{ featGeomStms++; continue; }
      if (isA((*iter), featGsurfStm))
	{ featGsurfStms++; continue; }
      if (isA((*iter), featLineStm))
	{ featLineStms++; continue; }
      if (isA((*iter), featObjectStm))
	{ featObjectStms++; continue; }
      if (isA((*iter), featParplnStm))
	{ featParplnStms++; continue; }
      if (isA((*iter), featPaternStm))
	{ featPaternStms++; continue; }
      if (isA((*iter), featPlaneStm))
	{ featPlaneStms++; continue; }
      if (isA((*iter), featPointStm))
	{ featPointStms++; continue; }
      if (isA((*iter), featRctnglStm))
	{ featRctnglStms++; continue; }
      if (isA((*iter), featRevsurfStm))
	{ featRevsurfStms++; continue; }
      if (isA((*iter), featSphereStm))
	{ featSphereStms++; continue; }
      if (isA((*iter), featSphradsegStm))
	{ featSphradsegStms++; continue; }
      if (isA((*iter), featSymplnStm))
	{ featSymplnStms++; continue; }
      if (isA((*iter), featTorradsegStm))
	{ featTorradsegStms++; continue; }
      if (isA((*iter), featTorusStm))
	{ featTorusStms++; continue; }
      if (isA((*iter), fedratStm))
	{ fedratStms++; continue; }
      if (isA((*iter), fildefStm))
	{ fildefStms++; continue; }
      if (isA((*iter), filnamStm))
	{ filnamStms++; continue; }
      if (isA((*iter), finposStm))
	{ finposStms++; continue; }
      if (isA((*iter), fixtidStm))
	{ fixtidStms++; continue; }
      if (isA((*iter), fixtsnStm))
	{ fixtsnStms++; continue; }
      if (isA((*iter), flyStm))
	{ flyStms++; continue; }
      if (isA((*iter), fromStm))
	{ fromStms++; continue; }
      if (isA((*iter), geoalgStm))
	{ geoalgStms++; continue; }
      if (isA((*iter), geomStm))
	{ geomStms++; continue; }
      if (isA((*iter), gohomeStm))
	{ gohomeStms++; continue; }
      if (isA((*iter), gotargStm))
	{ gotargStms++; continue; }
      if (isA((*iter), gotoStm))
	{ gotoStms++; continue; }
      if (isA((*iter), groupStm))
	{ groupStms++; continue; }
      if (isA((*iter), ifStm))
	{ ifStms++; continue; }
      if (isA((*iter), includStm))
	{ includStms++; continue; }
      if (isA((*iter), iteratStm))
	{ iteratStms++; continue; }
      if (isA((*iter), jumpStm))
	{ jumpStms++; continue; }
      if (isA((*iter), jumptoStm))
	{ jumptoStms++; continue; }
      if (isA((*iter), keycharStm))
	{ keycharStms++; continue; }
      if (isA((*iter), litdefStm))
	{ litdefStms++; continue; }
      if (isA((*iter), locateStm))
	{ locateStms++; continue; }
      if (isA((*iter), lotidStm))
	{ lotidStms++; continue; }
      if (isA((*iter), macroStm))
	{ macroStms++; continue; }
      if (isA((*iter), matdefStm))
	{ matdefStms++; continue; }
      if (isA((*iter), measStm))
	{ measStms++; continue; }
      if (isA((*iter), mfgdevStm))
	{ mfgdevStms++; continue; }
      if (isA((*iter), modeStm))
	{ modeStms++; continue; }
      if (isA((*iter), obtainStm))
	{ obtainStms++; continue; }
      if (isA((*iter), openStm))
	{ openStms++; continue; }
      if (isA((*iter), operidStm))
	{ operidStms++; continue; }
      if (isA((*iter), outputStm))
	{ outputStms++; continue; }
      if (isA((*iter), pameasStm))
	{ pameasStms++; continue; }
      if (isA((*iter), partidStm))
	{ partidStms++; continue; }
      if (isA((*iter), partrvStm))
	{ partrvStms++; continue; }
      if (isA((*iter), partsnStm))
	{ partsnStms++; continue; }
      if (isA((*iter), pathStm))
	{ pathStms++; continue; }
      if (isA((*iter), planidStm))
	{ planidStms++; continue; }
      if (isA((*iter), popStm))
	{ popStms++; continue; }
      if (isA((*iter), prcompStm))
	{ prcompStms++; continue; }
      if (isA((*iter), prevopStm))
	{ prevopStms++; continue; }
      if (isA((*iter), procidStm))
	{ procidStms++; continue; }
      if (isA((*iter), promptStm))
	{ promptStms++; continue; }
      if (isA((*iter), psthruStm))
	{ psthruStms++; continue; }
      if (isA((*iter), ptbuffStm))
	{ ptbuffStms++; continue; }
      if (isA((*iter), ptmeasStm))
	{ ptmeasStms++; continue; }
      if (isA((*iter), pushStm))
	{ pushStms++; continue; }
      if (isA((*iter), qisdefStm))
	{ qisdefStms++; continue; }
      if (isA((*iter), rapidStm))
	{ rapidStms++; continue; }
      if (isA((*iter), readStm))
	{ readStms++; continue; }
      if (isA((*iter), recallDMLStm))
	{ recallDMLStms++; continue; }
      if (isA((*iter), recallDatumStm))
	{ recallDatumStms++; continue; }
      if (isA((*iter), recallFeatureStm))
	{ recallFeatureStms++; continue; }
      if (isA((*iter), recallRotaryTableStm))
	{ recallRotaryTableStms++; continue; }
      if (isA((*iter), recallSensorStm))
	{ recallSensorStms++; continue; }
      if (isA((*iter), refmntStm))
	{ refmntStms++; continue; }
      if (isA((*iter), reportStm))
	{ reportStms++; continue; }
      if (isA((*iter), resumeStm))
	{ resumeStms++; continue; }
      if (isA((*iter), rmeasStm))
	{ rmeasStms++; continue; }
      if (isA((*iter), rotabStm))
	{ rotabStms++; continue; }
      if (isA((*iter), rotateStm))
	{ rotateStms++; continue; }
      if (isA((*iter), rotdefStm))
	{ rotdefStms++; continue; }
      if (isA((*iter), rotsetStm))
	{ rotsetStms++; continue; }
      if (isA((*iter), saveDMLStm))
	{ saveDMLStms++; continue; }
      if (isA((*iter), saveDatumStm))
	{ saveDatumStms++; continue; }
      if (isA((*iter), saveFeatureStm))
	{ saveFeatureStms++; continue; }
      if (isA((*iter), saveRotaryTableStm))
	{ saveRotaryTableStms++; continue; }
      if (isA((*iter), saveSensorStm))
	{ saveSensorStms++; continue; }
      if (isA((*iter), scnmodStm))
	{ scnmodStms++; continue; }
      if (isA((*iter), scnsetStm))
	{ scnsetStms++; continue; }
      if (isA((*iter), selectStm))
	{ selectStms++; continue; }
      if (isA((*iter), sensorStm))
	{ sensorStms++; continue; }
      if (isA((*iter), simreqtStm))
	{ simreqtStms++; continue; }
      if (isA((*iter), snsdefStm))
	{ snsdefStms++; continue; }
      if (isA((*iter), snsetStm))
	{ snsetStms++; continue; }
      if (isA((*iter), snsgrpStm))
	{ snsgrpStms++; continue; }
      if (isA((*iter), snslctStm))
	{ snslctStms++; continue; }
      if (isA((*iter), snsmntStm))
	{ snsmntStms++; continue; }
      if (isA((*iter), tecompStm))
	{ tecompStms++; continue; }
      if (isA((*iter), textStm))
	{ textStms++; continue; }
      if (isA((*iter), thldefStm))
	{ thldefStms++; continue; }
      if (isA((*iter), tolAnglStm))
	{ tolAnglStms++; continue; }
      if (isA((*iter), tolAnglbStm))
	{ tolAnglbStms++; continue; }
      if (isA((*iter), tolAnglrStm))
	{ tolAnglrStms++; continue; }
      if (isA((*iter), tolAnglwrtStm))
	{ tolAnglwrtStms++; continue; }
      if (isA((*iter), tolCirltyStm))
	{ tolCirltyStms++; continue; }
      if (isA((*iter), tolComposStm))
	{ tolComposStms++; continue; }
      if (isA((*iter), tolConcenStm))
	{ tolConcenStms++; continue; }
      if (isA((*iter), tolCortolStm))
	{ tolCortolStms++; continue; }
      if (isA((*iter), tolCproflStm))
	{ tolCproflStms++; continue; }
      if (isA((*iter), tolCprofsStm))
	{ tolCprofsStms++; continue; }
      if (isA((*iter), tolCrnoutStm))
	{ tolCrnoutStms++; continue; }
      if (isA((*iter), tolCylctyStm))
	{ tolCylctyStms++; continue; }
      if (isA((*iter), tolDiamStm))
	{ tolDiamStms++; continue; }
      if (isA((*iter), tolDistbStm))
	{ tolDistbStms++; continue; }
      if (isA((*iter), tolDistwrtStm))
	{ tolDistwrtStms++; continue; }
      if (isA((*iter), tolFlatStm))
	{ tolFlatStms++; continue; }
      if (isA((*iter), tolGtolStm))
	{ tolGtolStms++; continue; }
      if (isA((*iter), tolParlelStm))
	{ tolParlelStms++; continue; }
      if (isA((*iter), tolPerpStm))
	{ tolPerpStms++; continue; }
      if (isA((*iter), tolPosStm))
	{ tolPosStms++; continue; }
      if (isA((*iter), tolProflStm))
	{ tolProflStms++; continue; }
      if (isA((*iter), tolProfpStm))
	{ tolProfpStms++; continue; }
      if (isA((*iter), tolProfsStm))
	{ tolProfsStms++; continue; }
      if (isA((*iter), tolRadStm))
	{ tolRadStms++; continue; }
      if (isA((*iter), tolStrghtStm))
	{ tolStrghtStms++; continue; }
      if (isA((*iter), tolSymStm))
	{ tolSymStms++; continue; }
      if (isA((*iter), tolTrnoutStm))
	{ tolTrnoutStms++; continue; }
      if (isA((*iter), tolUsetolStm))
	{ tolUsetolStms++; continue; }
      if (isA((*iter), tolWidthStm))
	{ tolWidthStms++; continue; }
      if (isA((*iter), tooldfStm))
	{ tooldfStms++; continue; }
      if (isA((*iter), transStm))
	{ transStms++; continue; }
      if (isA((*iter), uncertalgStm))
	{ uncertalgStms++; continue; }
      if (isA((*iter), uncertsetStm))
	{ uncertsetStms++; continue; }
      if (isA((*iter), unitsStm))
	{ unitsStms++; continue; }
      if (isA((*iter), valueStm))
	{ valueStms++; continue; }
      if (isA((*iter), vformStm))
	{ vformStms++; continue; }
      if (isA((*iter), windefStm))
	{ windefStms++; continue; }
      if (isA((*iter), wkplanStm))
	{ wkplanStms++; continue; }
      if (isA((*iter), wristStm))
	{ wristStms++; continue; }
      if (isA((*iter), writeStm))
	{ writeStms++; continue; }
      if (isA((*iter), xternStm))
	{ xternStms++; continue; }
      if (isA((*iter), xtractStm))
	{ xtractStms++; continue; }
    }
}

/********************************************************************/

void check_aboveBelow(
 aboveBelow * a_aboveBelow)
{
  if (isA(a_aboveBelow, aboveBelow_ABOVE))
    {
      if (!findString("aboveBelow_ABOVE", aboveBelowSubs))
        {warnSub("aboveBelow_ABOVE", "aboveBelow", a_aboveBelow);}
      return;
    }
  if (isA(a_aboveBelow, aboveBelow_BELOW))
    {
      if (!findString("aboveBelow_BELOW", aboveBelowSubs))
        {warnSub("aboveBelow_BELOW", "aboveBelow", a_aboveBelow);}
      return;
    }
}

/********************************************************************/

void check_aclratAngSpec(
 aclratAngSpec * a_aclratAngSpec)
{
  if (isA(a_aclratAngSpec, aclratAngular))
    {
      if (!findString("aclratAngular", aclratAngSpecSubs))
        {warnSub("aclratAngular", "aclratAngSpec", a_aclratAngSpec);}
      else
        check_aclratAngular(dynamic_cast<aclratAngular *>(a_aclratAngSpec));
      return;
    }
  if (isA(a_aclratAngSpec, aclratDef))
    {
      if (!findString("aclratDef", aclratAngSpecSubs))
        {warnSub("aclratDef", "aclratAngSpec", a_aclratAngSpec);}
      else
        check_aclratDef(dynamic_cast<aclratDef *>(a_aclratAngSpec));
      return;
    }
}

/********************************************************************/

void check_aclratAngular(
 aclratAngular * a_aclratAngular)
{
  if (a_aclratAngular->get_accel())
    {
      if (!findString("accel", aclratAngularAtts))
	{warnAtt("accel", "aclratAngular", a_aclratAngular);}
      else
        check_rentVal(a_aclratAngular->get_accel());
    }
}

/********************************************************************/

void check_aclratDef(
 aclratDef * a_aclratDef)
{
  if (isA(a_aclratDef, aclratDef_PCENT))
    {
      if (!findString("aclratDef_PCENT", aclratDefSubs))
        {warnSub("aclratDef_PCENT", "aclratDef", a_aclratDef);}
      else
        check_aclratDef_PCENT(dynamic_cast<aclratDef_PCENT *>(a_aclratDef));
      return;
    }
  if (isA(a_aclratDef, aclratDef_HIGH))
    {
      if (!findString("aclratDef_HIGH", aclratDefSubs))
        {warnSub("aclratDef_HIGH", "aclratDef", a_aclratDef);}
      return;
    }
  if (isA(a_aclratDef, aclratDef_LOW))
    {
      if (!findString("aclratDef_LOW", aclratDefSubs))
        {warnSub("aclratDef_LOW", "aclratDef", a_aclratDef);}
      return;
    }
  if (isA(a_aclratDef, aclratDef_DEFALT))
    {
      if (!findString("aclratDef_DEFALT", aclratDefSubs))
        {warnSub("aclratDef_DEFALT", "aclratDef", a_aclratDef);}
      return;
    }
}

/********************************************************************/

void check_aclratDef_PCENT(
 aclratDef_PCENT * a_aclratDef_PCENT)
{
  if (a_aclratDef_PCENT->get_accel())
    {
      if (!findString("accel", aclratDef_PCENTAtts))
	{warnAtt("accel", "aclratDef_PCENT", a_aclratDef_PCENT);}
      else
        check_rentVal(a_aclratDef_PCENT->get_accel());
    }
}

/********************************************************************/

void check_aclratHedMeas(
 aclratHedMeas * a_aclratHedMeas)
{
  if (a_aclratHedMeas->get_aclratLinSpec())
    {
      if (!findString("a_aclratLinSpec", aclratHedMeasAtts))
	{warnAtt("a_aclratLinSpec", "aclratHedMeas", a_aclratHedMeas);}
      else
        check_aclratLinSpec(a_aclratHedMeas->get_aclratLinSpec());
    }
}

/********************************************************************/

void check_aclratHedRot(
 aclratHedRot * a_aclratHedRot)
{
  if (a_aclratHedRot->get_aclratLinSpec())
    {
      if (!findString("a_aclratLinSpec", aclratHedRotAtts))
	{warnAtt("a_aclratLinSpec", "aclratHedRot", a_aclratHedRot);}
      else
        check_aclratLinSpec(a_aclratHedRot->get_aclratLinSpec());
    }
}

/********************************************************************/

void check_aclratHedScan(
 aclratHedScan * a_aclratHedScan)
{
  if (a_aclratHedScan->get_aclratLinSpec())
    {
      if (!findString("a_aclratLinSpec", aclratHedScanAtts))
	{warnAtt("a_aclratLinSpec", "aclratHedScan", a_aclratHedScan);}
      else
        check_aclratLinSpec(a_aclratHedScan->get_aclratLinSpec());
    }
}

/********************************************************************/

void check_aclratLinSpec(
 aclratLinSpec * a_aclratLinSpec)
{
  if (isA(a_aclratLinSpec, aclratLinear))
    {
      if (!findString("aclratLinear", aclratLinSpecSubs))
        {warnSub("aclratLinear", "aclratLinSpec", a_aclratLinSpec);}
      else
        check_aclratLinear(dynamic_cast<aclratLinear *>(a_aclratLinSpec));
      return;
    }
  if (isA(a_aclratLinSpec, aclratDef))
    {
      if (!findString("aclratDef", aclratLinSpecSubs))
        {warnSub("aclratDef", "aclratLinSpec", a_aclratLinSpec);}
      else
        check_aclratDef(dynamic_cast<aclratDef *>(a_aclratLinSpec));
      return;
    }
}

/********************************************************************/

void check_aclratLinear(
 aclratLinear * a_aclratLinear)
{
  if (isA(a_aclratLinear, aclratLinear_MPMM))
    {
      if (!findString("aclratLinear_MPMM", aclratLinearSubs))
        {warnSub("aclratLinear_MPMM", "aclratLinear", a_aclratLinear);}
      else
        check_aclratLinear_MPMM(dynamic_cast<aclratLinear_MPMM *>(a_aclratLinear));
      return;
    }
  if (isA(a_aclratLinear, aclratLinear_MMPSS))
    {
      if (!findString("aclratLinear_MMPSS", aclratLinearSubs))
        {warnSub("aclratLinear_MMPSS", "aclratLinear", a_aclratLinear);}
      else
        check_aclratLinear_MMPSS(dynamic_cast<aclratLinear_MMPSS *>(a_aclratLinear));
      return;
    }
  if (isA(a_aclratLinear, aclratLinear_IPMM))
    {
      if (!findString("aclratLinear_IPMM", aclratLinearSubs))
        {warnSub("aclratLinear_IPMM", "aclratLinear", a_aclratLinear);}
      else
        check_aclratLinear_IPMM(dynamic_cast<aclratLinear_IPMM *>(a_aclratLinear));
      return;
    }
  if (isA(a_aclratLinear, aclratLinear_IPSS))
    {
      if (!findString("aclratLinear_IPSS", aclratLinearSubs))
        {warnSub("aclratLinear_IPSS", "aclratLinear", a_aclratLinear);}
      else
        check_aclratLinear_IPSS(dynamic_cast<aclratLinear_IPSS *>(a_aclratLinear));
      return;
    }
}

/********************************************************************/

void check_aclratLinear_IPMM(
 aclratLinear_IPMM * a_aclratLinear_IPMM)
{
  if (a_aclratLinear_IPMM->get_accel())
    {
      if (!findString("accel", aclratLinear_IPMMAtts))
	{warnAtt("accel", "aclratLinear_IPMM", a_aclratLinear_IPMM);}
      else
        check_rentVal(a_aclratLinear_IPMM->get_accel());
    }
}

/********************************************************************/

void check_aclratLinear_IPSS(
 aclratLinear_IPSS * a_aclratLinear_IPSS)
{
  if (a_aclratLinear_IPSS->get_accel())
    {
      if (!findString("accel", aclratLinear_IPSSAtts))
	{warnAtt("accel", "aclratLinear_IPSS", a_aclratLinear_IPSS);}
      else
        check_rentVal(a_aclratLinear_IPSS->get_accel());
    }
}

/********************************************************************/

void check_aclratLinear_MMPSS(
 aclratLinear_MMPSS * a_aclratLinear_MMPSS)
{
  if (a_aclratLinear_MMPSS->get_accel())
    {
      if (!findString("accel", aclratLinear_MMPSSAtts))
	{warnAtt("accel", "aclratLinear_MMPSS", a_aclratLinear_MMPSS);}
      else
        check_rentVal(a_aclratLinear_MMPSS->get_accel());
    }
}

/********************************************************************/

void check_aclratLinear_MPMM(
 aclratLinear_MPMM * a_aclratLinear_MPMM)
{
  if (a_aclratLinear_MPMM->get_accel())
    {
      if (!findString("accel", aclratLinear_MPMMAtts))
	{warnAtt("accel", "aclratLinear_MPMM", a_aclratLinear_MPMM);}
      else
        check_rentVal(a_aclratLinear_MPMM->get_accel());
    }
}

/********************************************************************/

void check_aclratMeas(
 aclratMeas * a_aclratMeas)
{
  if (a_aclratMeas->get_aclratLinSpec())
    {
      if (!findString("a_aclratLinSpec", aclratMeasAtts))
	{warnAtt("a_aclratLinSpec", "aclratMeas", a_aclratMeas);}
      else
        check_aclratLinSpec(a_aclratMeas->get_aclratLinSpec());
    }
}

/********************************************************************/

void check_aclratMinor(
 aclratMinor * a_aclratMinor)
{
  if (isA(a_aclratMinor, aclratMeas))
    {
      if (!findString("aclratMeas", aclratMinorSubs))
        {warnSub("aclratMeas", "aclratMinor", a_aclratMinor);}
      else
        check_aclratMeas(dynamic_cast<aclratMeas *>(a_aclratMinor));
      return;
    }
  if (isA(a_aclratMinor, aclratPos))
    {
      if (!findString("aclratPos", aclratMinorSubs))
        {warnSub("aclratPos", "aclratMinor", a_aclratMinor);}
      else
        check_aclratPos(dynamic_cast<aclratPos *>(a_aclratMinor));
      return;
    }
  if (isA(a_aclratMinor, aclratRot))
    {
      if (!findString("aclratRot", aclratMinorSubs))
        {warnSub("aclratRot", "aclratMinor", a_aclratMinor);}
      else
        check_aclratRot(dynamic_cast<aclratRot *>(a_aclratMinor));
      return;
    }
  if (isA(a_aclratMinor, aclratScan))
    {
      if (!findString("aclratScan", aclratMinorSubs))
        {warnSub("aclratScan", "aclratMinor", a_aclratMinor);}
      else
        check_aclratScan(dynamic_cast<aclratScan *>(a_aclratMinor));
      return;
    }
  if (isA(a_aclratMinor, aclratHedRot))
    {
      if (!findString("aclratHedRot", aclratMinorSubs))
        {warnSub("aclratHedRot", "aclratMinor", a_aclratMinor);}
      else
        check_aclratHedRot(dynamic_cast<aclratHedRot *>(a_aclratMinor));
      return;
    }
  if (isA(a_aclratMinor, aclratHedMeas))
    {
      if (!findString("aclratHedMeas", aclratMinorSubs))
        {warnSub("aclratHedMeas", "aclratMinor", a_aclratMinor);}
      else
        check_aclratHedMeas(dynamic_cast<aclratHedMeas *>(a_aclratMinor));
      return;
    }
  if (isA(a_aclratMinor, aclratHedScan))
    {
      if (!findString("aclratHedScan", aclratMinorSubs))
        {warnSub("aclratHedScan", "aclratMinor", a_aclratMinor);}
      else
        check_aclratHedScan(dynamic_cast<aclratHedScan *>(a_aclratMinor));
      return;
    }
}

/********************************************************************/

void check_aclratPos(
 aclratPos * a_aclratPos)
{
  if (a_aclratPos->get_aclratLinSpec())
    {
      if (!findString("a_aclratLinSpec", aclratPosAtts))
	{warnAtt("a_aclratLinSpec", "aclratPos", a_aclratPos);}
      else
        check_aclratLinSpec(a_aclratPos->get_aclratLinSpec());
    }
}

/********************************************************************/

void check_aclratRot(
 aclratRot * a_aclratRot)
{
  if (a_aclratRot->get_aclratAngSpec())
    {
      if (!findString("a_aclratAngSpec", aclratRotAtts))
	{warnAtt("a_aclratAngSpec", "aclratRot", a_aclratRot);}
      else
        check_aclratAngSpec(a_aclratRot->get_aclratAngSpec());
    }
}

/********************************************************************/

void check_aclratScan(
 aclratScan * a_aclratScan)
{
  if (a_aclratScan->get_aclratLinSpec())
    {
      if (!findString("a_aclratLinSpec", aclratScanAtts))
	{warnAtt("a_aclratLinSpec", "aclratScan", a_aclratScan);}
      else
        check_aclratLinSpec(a_aclratScan->get_aclratLinSpec());
    }
}

/********************************************************************/

void check_aclratStm(
 aclratStm * a_aclratStm)
{
  if (a_aclratStm->get_aclratMinor())
    {
      if (!findString("a_aclratMinor", aclratStmAtts))
	{warnAtt("a_aclratMinor", "aclratStm", a_aclratStm);}
      else
        check_aclratMinor(a_aclratStm->get_aclratMinor());
    }
}

/********************************************************************/

void check_algdefMinor(
 algdefMinor * a_algdefMinor)
{
  if (isA(a_algdefMinor, algdefMinor_CODE))
    {
      if (!findString("algdefMinor_CODE", algdefMinorSubs))
        {warnSub("algdefMinor_CODE", "algdefMinor", a_algdefMinor);}
      else
        check_algdefMinor_CODE(dynamic_cast<algdefMinor_CODE *>(a_algdefMinor));
      return;
    }
  if (isA(a_algdefMinor, algdefMinor_stringVal))
    {
      if (!findString("algdefMinor_stringVal", algdefMinorSubs))
        {warnSub("algdefMinor_stringVal", "algdefMinor", a_algdefMinor);}
      else
        check_algdefMinor_stringVal(dynamic_cast<algdefMinor_stringVal *>(a_algdefMinor));
      return;
    }
}

/********************************************************************/

void check_algdefMinor_CODE(
 algdefMinor_CODE * a_algdefMinor_CODE)
{
  if (a_algdefMinor_CODE->get_code())
    {
      if (!findString("code", algdefMinor_CODEAtts))
	{warnAtt("code", "algdefMinor_CODE", a_algdefMinor_CODE);}
      else
        check_intVal(a_algdefMinor_CODE->get_code());
    }
}

/********************************************************************/

void check_algdefMinor_stringVal(
 algdefMinor_stringVal * a_algdefMinor_stringVal)
{
  if (a_algdefMinor_stringVal->get_name())
    {
      if (!findString("name", algdefMinor_stringValAtts))
	{warnAtt("name", "algdefMinor_stringVal", a_algdefMinor_stringVal);}
      else
        check_stringVal(a_algdefMinor_stringVal->get_name());
    }
  if (a_algdefMinor_stringVal->get_paramList())
    {
      if (!findString("a_paramList", algdefMinor_stringValAtts))
	{warnAtt("a_paramList", "algdefMinor_stringVal", a_algdefMinor_stringVal);}
      else
        {
          std::list<param *> * theList;
          std::list<param *>::iterator iter;
          theList = a_algdefMinor_stringVal->get_paramList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_param(*iter);
        }
    }
}

/********************************************************************/

void check_algdefStm(
 algdefStm * a_algdefStm)
{
  if (a_algdefStm->get_vaLabel())
    {
      if (!findString("a_vaLabel", algdefStmAtts))
	{warnAtt("a_vaLabel", "algdefStm", a_algdefStm);}
      else
        check_vaLabel(a_algdefStm->get_vaLabel());
    }
  if (a_algdefStm->get_algdefMinor())
    {
      if (!findString("a_algdefMinor", algdefStmAtts))
	{warnAtt("a_algdefMinor", "algdefStm", a_algdefStm);}
      else
        check_algdefMinor(a_algdefStm->get_algdefMinor());
    }
}

/********************************************************************/

void check_angle(
 angle * a_angle)
{
  if (isA(a_angle, rentVal))
    {
      if (!findString("rentVal", angleSubs))
        {warnSub("rentVal", "angle", a_angle);}
      else
        check_rentVal(dynamic_cast<rentVal *>(a_angle));
      return;
    }
  if (isA(a_angle, angleDms))
    {
      if (!findString("angleDms", angleSubs))
        {warnSub("angleDms", "angle", a_angle);}
      else
        check_angleDms(dynamic_cast<angleDms *>(a_angle));
      return;
    }
}

/********************************************************************/

void check_angleDms(
 angleDms * a_angleDms)
{
  if (a_angleDms->get_degrees())
    {
      if (!findString("degrees", angleDmsAtts))
	{warnAtt("degrees", "angleDms", a_angleDms);}
    }
  if (a_angleDms->get_minutes())
    {
      if (!findString("minutes", angleDmsAtts))
	{warnAtt("minutes", "angleDms", a_angleDms);}
    }
  if (a_angleDms->get_secondsString())
    {
      if (!findString("a_secondsString", angleDmsAtts))
	{warnAtt("a_secondsString", "angleDms", a_angleDms);}
      else
        check_secondsString(a_angleDms->get_secondsString());
    }
}

/********************************************************************/

void check_angleUnit(
 angleUnit * a_angleUnit)
{
  if (isA(a_angleUnit, angleUnit_ANGDEC))
    {
      if (!findString("angleUnit_ANGDEC", angleUnitSubs))
        {warnSub("angleUnit_ANGDEC", "angleUnit", a_angleUnit);}
      return;
    }
  if (isA(a_angleUnit, angleUnit_ANGDMS))
    {
      if (!findString("angleUnit_ANGDMS", angleUnitSubs))
        {warnSub("angleUnit_ANGDMS", "angleUnit", a_angleUnit);}
      return;
    }
  if (isA(a_angleUnit, angleUnit_ANGRAD))
    {
      if (!findString("angleUnit_ANGRAD", angleUnitSubs))
        {warnSub("angleUnit_ANGRAD", "angleUnit", a_angleUnit);}
      return;
    }
}

/********************************************************************/

void check_anyVal(
 anyVal * a_anyVal)
{
  if (isA(a_anyVal, stringVal))
    {
      if (!findString("stringVal", anyValSubs))
        {warnSub("stringVal", "anyVal", a_anyVal);}
      else
        check_stringVal(dynamic_cast<stringVal *>(a_anyVal));
      return;
    }
  if (isA(a_anyVal, boolVal))
    {
      if (!findString("boolVal", anyValSubs))
        {warnSub("boolVal", "anyVal", a_anyVal);}
      else
        check_boolVal(dynamic_cast<boolVal *>(a_anyVal));
      return;
    }
  if (isA(a_anyVal, rentVal))
    {
      if (!findString("rentVal", anyValSubs))
        {warnSub("rentVal", "anyVal", a_anyVal);}
      else
        check_rentVal(dynamic_cast<rentVal *>(a_anyVal));
      return;
    }
  if (isA(a_anyVal, vectorVal))
    {
      if (!findString("vectorVal", anyValSubs))
        {warnSub("vectorVal", "anyVal", a_anyVal);}
      else
        check_vectorVal(dynamic_cast<vectorVal *>(a_anyVal));
      return;
    }
}

/********************************************************************/

void check_arrayIndex(
 arrayIndex * a_arrayIndex)
{
  if (a_arrayIndex->get_indexes())
    {
      if (!findString("indexes", arrayIndexAtts))
	{warnAtt("indexes", "arrayIndex", a_arrayIndex);}
      else
        {
          std::list<intVal *> * theList;
          std::list<intVal *>::iterator iter;
          theList = a_arrayIndex->get_indexes();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_intVal(*iter);
        }
    }
}

/********************************************************************/

void check_assignBool(
 assignBool * a_assignBool)
{
  if (a_assignBool->get_boolVar())
    {
      if (!findString("a_boolVar", assignBoolAtts))
	{warnAtt("a_boolVar", "assignBool", a_assignBool);}
      else
        check_boolVar(a_assignBool->get_boolVar());
    }
  if (a_assignBool->get_value())
    {
      if (!findString("value", assignBoolAtts))
	{warnAtt("value", "assignBool", a_assignBool);}
      else
        check_boolVal(a_assignBool->get_value());
    }
}

/********************************************************************/

void check_assignInt(
 assignInt * a_assignInt)
{
  if (a_assignInt->get_intVar())
    {
      if (!findString("a_intVar", assignIntAtts))
	{warnAtt("a_intVar", "assignInt", a_assignInt);}
      else
        check_intVar(a_assignInt->get_intVar());
    }
  if (a_assignInt->get_value())
    {
      if (!findString("value", assignIntAtts))
	{warnAtt("value", "assignInt", a_assignInt);}
      else
        check_rentVal(a_assignInt->get_value());
    }
}

/********************************************************************/

void check_assignReal(
 assignReal * a_assignReal)
{
  if (a_assignReal->get_realVar())
    {
      if (!findString("a_realVar", assignRealAtts))
	{warnAtt("a_realVar", "assignReal", a_assignReal);}
      else
        check_realVar(a_assignReal->get_realVar());
    }
  if (a_assignReal->get_value())
    {
      if (!findString("value", assignRealAtts))
	{warnAtt("value", "assignReal", a_assignReal);}
      else
        check_rentVal(a_assignReal->get_value());
    }
}

/********************************************************************/

void check_assignStm(
 assignStm * a_assignStm)
{
  if (isA(a_assignStm, assignStm_assignString))
    {
      if (!findString("assignStm_assignString", assignStmSubs))
        {warnSub("assignStm_assignString", "assignStm", a_assignStm);}
      else
        check_assignStm_assignString(dynamic_cast<assignStm_assignString *>(a_assignStm));
      return;
    }
  if (isA(a_assignStm, assignStm_assignBool))
    {
      if (!findString("assignStm_assignBool", assignStmSubs))
        {warnSub("assignStm_assignBool", "assignStm", a_assignStm);}
      else
        check_assignStm_assignBool(dynamic_cast<assignStm_assignBool *>(a_assignStm));
      return;
    }
  if (isA(a_assignStm, assignStm_assignInt))
    {
      if (!findString("assignStm_assignInt", assignStmSubs))
        {warnSub("assignStm_assignInt", "assignStm", a_assignStm);}
      else
        check_assignStm_assignInt(dynamic_cast<assignStm_assignInt *>(a_assignStm));
      return;
    }
  if (isA(a_assignStm, assignStm_assignReal))
    {
      if (!findString("assignStm_assignReal", assignStmSubs))
        {warnSub("assignStm_assignReal", "assignStm", a_assignStm);}
      else
        check_assignStm_assignReal(dynamic_cast<assignStm_assignReal *>(a_assignStm));
      return;
    }
  if (isA(a_assignStm, assignStm_assignVector))
    {
      if (!findString("assignStm_assignVector", assignStmSubs))
        {warnSub("assignStm_assignVector", "assignStm", a_assignStm);}
      else
        check_assignStm_assignVector(dynamic_cast<assignStm_assignVector *>(a_assignStm));
      return;
    }
}

/********************************************************************/

void check_assignStm_assignBool(
 assignStm_assignBool * a_assignStm_assignBool)
{
  if (a_assignStm_assignBool->get_assignBool())
    {
      if (!findString("a_assignBool", assignStm_assignBoolAtts))
	{warnAtt("a_assignBool", "assignStm_assignBool", a_assignStm_assignBool);}
      else
        check_assignBool(a_assignStm_assignBool->get_assignBool());
    }
}

/********************************************************************/

void check_assignStm_assignInt(
 assignStm_assignInt * a_assignStm_assignInt)
{
  if (a_assignStm_assignInt->get_assignInt())
    {
      if (!findString("a_assignInt", assignStm_assignIntAtts))
	{warnAtt("a_assignInt", "assignStm_assignInt", a_assignStm_assignInt);}
      else
        check_assignInt(a_assignStm_assignInt->get_assignInt());
    }
}

/********************************************************************/

void check_assignStm_assignReal(
 assignStm_assignReal * a_assignStm_assignReal)
{
  if (a_assignStm_assignReal->get_assignReal())
    {
      if (!findString("a_assignReal", assignStm_assignRealAtts))
	{warnAtt("a_assignReal", "assignStm_assignReal", a_assignStm_assignReal);}
      else
        check_assignReal(a_assignStm_assignReal->get_assignReal());
    }
}

/********************************************************************/

void check_assignStm_assignString(
 assignStm_assignString * a_assignStm_assignString)
{
  if (a_assignStm_assignString->get_assignString())
    {
      if (!findString("a_assignString", assignStm_assignStringAtts))
	{warnAtt("a_assignString", "assignStm_assignString", a_assignStm_assignString);}
      else
        check_assignString(a_assignStm_assignString->get_assignString());
    }
}

/********************************************************************/

void check_assignStm_assignVector(
 assignStm_assignVector * a_assignStm_assignVector)
{
  if (a_assignStm_assignVector->get_assignVector())
    {
      if (!findString("a_assignVector", assignStm_assignVectorAtts))
	{warnAtt("a_assignVector", "assignStm_assignVector", a_assignStm_assignVector);}
      else
        check_assignVector(a_assignStm_assignVector->get_assignVector());
    }
}

/********************************************************************/

void check_assignString(
 assignString * a_assignString)
{
  if (a_assignString->get_stringVar())
    {
      if (!findString("a_stringVar", assignStringAtts))
	{warnAtt("a_stringVar", "assignString", a_assignString);}
      else
        check_stringVar(a_assignString->get_stringVar());
    }
  if (a_assignString->get_str())
    {
      if (!findString("str", assignStringAtts))
	{warnAtt("str", "assignString", a_assignString);}
      else
        check_stringVal(a_assignString->get_str());
    }
}

/********************************************************************/

void check_assignVector(
 assignVector * a_assignVector)
{
  if (a_assignVector->get_vectorVar())
    {
      if (!findString("a_vectorVar", assignVectorAtts))
	{warnAtt("a_vectorVar", "assignVector", a_assignVector);}
      else
        check_vectorVar(a_assignVector->get_vectorVar());
    }
  if (a_assignVector->get_value())
    {
      if (!findString("value", assignVectorAtts))
	{warnAtt("value", "assignVector", a_assignVector);}
      else
        check_vectorVal(a_assignVector->get_value());
    }
}

/********************************************************************/

void check_avgMaxMin(
 avgMaxMin * a_avgMaxMin)
{
  if (isA(a_avgMaxMin, avgMaxMin_AVG))
    {
      if (!findString("avgMaxMin_AVG", avgMaxMinSubs))
        {warnSub("avgMaxMin_AVG", "avgMaxMin", a_avgMaxMin);}
      return;
    }
  if (isA(a_avgMaxMin, avgMaxMin_MAX))
    {
      if (!findString("avgMaxMin_MAX", avgMaxMinSubs))
        {warnSub("avgMaxMin_MAX", "avgMaxMin", a_avgMaxMin);}
      return;
    }
  if (isA(a_avgMaxMin, avgMaxMin_MIN))
    {
      if (!findString("avgMaxMin_MIN", avgMaxMinSubs))
        {warnSub("avgMaxMin_MIN", "avgMaxMin", a_avgMaxMin);}
      return;
    }
}

/********************************************************************/

void check_axial(
 axial * a_axial)
{
  if (a_axial->get_featureLabel())
    {
      if (!findString("a_featureLabel", axialAtts))
	{warnAtt("a_featureLabel", "axial", a_axial);}
      else
        check_featureLabel(a_axial->get_featureLabel());
    }
  if (a_axial->get_dist())
    {
      if (!findString("dist", axialAtts))
	{warnAtt("dist", "axial", a_axial);}
      else
        check_rentVal(a_axial->get_dist());
    }
}

/********************************************************************/

void check_axis(
 axis * a_axis)
{
  if (isA(a_axis, axis_XAXIS))
    {
      if (!findString("axis_XAXIS", axisSubs))
        {warnSub("axis_XAXIS", "axis", a_axis);}
      return;
    }
  if (isA(a_axis, axis_YAXIS))
    {
      if (!findString("axis_YAXIS", axisSubs))
        {warnSub("axis_YAXIS", "axis", a_axis);}
      return;
    }
  if (isA(a_axis, axis_ZAXIS))
    {
      if (!findString("axis_ZAXIS", axisSubs))
        {warnSub("axis_ZAXIS", "axis", a_axis);}
      return;
    }
}

/********************************************************************/

void check_badtstStm(
 badtstStm * a_badtstStm)
{
  if (a_badtstStm->get_state())
    {
      if (!findString("a_state", badtstStmAtts))
	{warnAtt("a_state", "badtstStm", a_badtstStm);}
      else
        check_state(a_badtstStm->get_state());
    }
}

/********************************************************************/

void check_bfConst(
 bfConst * a_bfConst)
{
  if (isA(a_bfConst, bfConst_featureList))
    {
      if (!findString("bfConst_featureList", bfConstSubs))
        {warnSub("bfConst_featureList", "bfConst", a_bfConst);}
      else
        check_bfConst_featureList(dynamic_cast<bfConst_featureList *>(a_bfConst));
      return;
    }
  if (isA(a_bfConst, bfConst_indexedFeatureList))
    {
      if (!findString("bfConst_indexedFeatureList", bfConstSubs))
        {warnSub("bfConst_indexedFeatureList", "bfConst", a_bfConst);}
      else
        check_bfConst_indexedFeatureList(dynamic_cast<bfConst_indexedFeatureList *>(a_bfConst));
      return;
    }
}

/********************************************************************/

void check_bfConst_featureList(
 bfConst_featureList * a_bfConst_featureList)
{
  if (a_bfConst_featureList->get_featureList())
    {
      if (!findString("a_featureList", bfConst_featureListAtts))
	{warnAtt("a_featureList", "bfConst_featureList", a_bfConst_featureList);}
      else
        {
          std::list<featureLabel *> * theList;
          std::list<featureLabel *>::iterator iter;
          theList = a_bfConst_featureList->get_featureList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_featureLabel(*iter);
        }
    }
}

/********************************************************************/

void check_bfConst_indexedFeatureList(
 bfConst_indexedFeatureList * a_bfConst_indexedFeatureList)
{
  if (a_bfConst_indexedFeatureList->get_indexedFeatureList())
    {
      if (!findString("a_indexedFeatureList", bfConst_indexedFeatureListAtts))
	{warnAtt("a_indexedFeatureList", "bfConst_indexedFeatureList", a_bfConst_indexedFeatureList);}
      else
        {
          std::list<indexedFeature *> * theList;
          std::list<indexedFeature *>::iterator iter;
          theList = a_bfConst_indexedFeatureList->get_indexedFeatureList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_indexedFeature(*iter);
        }
    }
}

/********************************************************************/

void check_boolConst(
 boolConst * a_boolConst)
{
  if (isA(a_boolConst, boolConst_TRUE))
    {
      if (!findString("boolConst_TRUE", boolConstSubs))
        {warnSub("boolConst_TRUE", "boolConst", a_boolConst);}
      return;
    }
  if (isA(a_boolConst, boolConst_FALSE))
    {
      if (!findString("boolConst_FALSE", boolConstSubs))
        {warnSub("boolConst_FALSE", "boolConst", a_boolConst);}
      return;
    }
}

/********************************************************************/

void check_boolExpr(
 boolExpr * a_boolExpr)
{
  if (isA(a_boolExpr, boolExpr_PAREN))
    {
      if (!findString("boolExpr_PAREN", boolExprSubs))
        {warnSub("boolExpr_PAREN", "boolExpr", a_boolExpr);}
      else
        check_boolExpr_PAREN(dynamic_cast<boolExpr_PAREN *>(a_boolExpr));
      return;
    }
  if (isA(a_boolExpr, boolExpr_stringRel))
    {
      if (!findString("boolExpr_stringRel", boolExprSubs))
        {warnSub("boolExpr_stringRel", "boolExpr", a_boolExpr);}
      else
        check_boolExpr_stringRel(dynamic_cast<boolExpr_stringRel *>(a_boolExpr));
      return;
    }
  if (isA(a_boolExpr, boolExpr_boolRel))
    {
      if (!findString("boolExpr_boolRel", boolExprSubs))
        {warnSub("boolExpr_boolRel", "boolExpr", a_boolExpr);}
      else
        check_boolExpr_boolRel(dynamic_cast<boolExpr_boolRel *>(a_boolExpr));
      return;
    }
  if (isA(a_boolExpr, boolExpr_intRel))
    {
      if (!findString("boolExpr_intRel", boolExprSubs))
        {warnSub("boolExpr_intRel", "boolExpr", a_boolExpr);}
      else
        check_boolExpr_intRel(dynamic_cast<boolExpr_intRel *>(a_boolExpr));
      return;
    }
  if (isA(a_boolExpr, boolExpr_realRel))
    {
      if (!findString("boolExpr_realRel", boolExprSubs))
        {warnSub("boolExpr_realRel", "boolExpr", a_boolExpr);}
      else
        check_boolExpr_realRel(dynamic_cast<boolExpr_realRel *>(a_boolExpr));
      return;
    }
  if (isA(a_boolExpr, boolExpr_vectorRel))
    {
      if (!findString("boolExpr_vectorRel", boolExprSubs))
        {warnSub("boolExpr_vectorRel", "boolExpr", a_boolExpr);}
      else
        check_boolExpr_vectorRel(dynamic_cast<boolExpr_vectorRel *>(a_boolExpr));
      return;
    }
}

/********************************************************************/

void check_boolExpr_PAREN(
 boolExpr_PAREN * a_boolExpr_PAREN)
{
  if (a_boolExpr_PAREN->get_boolVal())
    {
      if (!findString("a_boolVal", boolExpr_PARENAtts))
	{warnAtt("a_boolVal", "boolExpr_PAREN", a_boolExpr_PAREN);}
      else
        check_boolVal(a_boolExpr_PAREN->get_boolVal());
    }
}

/********************************************************************/

void check_boolExpr_boolRel(
 boolExpr_boolRel * a_boolExpr_boolRel)
{
  if (a_boolExpr_boolRel->get_boolRel())
    {
      if (!findString("a_boolRel", boolExpr_boolRelAtts))
	{warnAtt("a_boolRel", "boolExpr_boolRel", a_boolExpr_boolRel);}
      else
        check_boolRel(a_boolExpr_boolRel->get_boolRel());
    }
}

/********************************************************************/

void check_boolExpr_intRel(
 boolExpr_intRel * a_boolExpr_intRel)
{
  if (a_boolExpr_intRel->get_intRel())
    {
      if (!findString("a_intRel", boolExpr_intRelAtts))
	{warnAtt("a_intRel", "boolExpr_intRel", a_boolExpr_intRel);}
      else
        check_intRel(a_boolExpr_intRel->get_intRel());
    }
}

/********************************************************************/

void check_boolExpr_realRel(
 boolExpr_realRel * a_boolExpr_realRel)
{
  if (a_boolExpr_realRel->get_realRel())
    {
      if (!findString("a_realRel", boolExpr_realRelAtts))
	{warnAtt("a_realRel", "boolExpr_realRel", a_boolExpr_realRel);}
      else
        check_realRel(a_boolExpr_realRel->get_realRel());
    }
}

/********************************************************************/

void check_boolExpr_stringRel(
 boolExpr_stringRel * a_boolExpr_stringRel)
{
  if (a_boolExpr_stringRel->get_stringRel())
    {
      if (!findString("a_stringRel", boolExpr_stringRelAtts))
	{warnAtt("a_stringRel", "boolExpr_stringRel", a_boolExpr_stringRel);}
      else
        check_stringRel(a_boolExpr_stringRel->get_stringRel());
    }
}

/********************************************************************/

void check_boolExpr_vectorRel(
 boolExpr_vectorRel * a_boolExpr_vectorRel)
{
  if (a_boolExpr_vectorRel->get_vectorRel())
    {
      if (!findString("a_vectorRel", boolExpr_vectorRelAtts))
	{warnAtt("a_vectorRel", "boolExpr_vectorRel", a_boolExpr_vectorRel);}
      else
        check_vectorRel(a_boolExpr_vectorRel->get_vectorRel());
    }
}

/********************************************************************/

void check_boolFunc(
 boolFunc * a_boolFunc)
{
  if (isA(a_boolFunc, boolFuncBadgt))
    {
      if (!findString("boolFuncBadgt", boolFuncSubs))
        {warnSub("boolFuncBadgt", "boolFunc", a_boolFunc);}
      return;
    }
  if (isA(a_boolFunc, boolFuncBadpt))
    {
      if (!findString("boolFuncBadpt", boolFuncSubs))
        {warnSub("boolFuncBadpt", "boolFunc", a_boolFunc);}
      return;
    }
  if (isA(a_boolFunc, boolFuncEof))
    {
      if (!findString("boolFuncEof", boolFuncSubs))
        {warnSub("boolFuncEof", "boolFunc", a_boolFunc);}
      else
        check_boolFuncEof(dynamic_cast<boolFuncEof *>(a_boolFunc));
      return;
    }
  if (isA(a_boolFunc, boolFuncEoln))
    {
      if (!findString("boolFuncEoln", boolFuncSubs))
        {warnSub("boolFuncEoln", "boolFunc", a_boolFunc);}
      else
        check_boolFuncEoln(dynamic_cast<boolFuncEoln *>(a_boolFunc));
      return;
    }
  if (isA(a_boolFunc, boolFuncExist))
    {
      if (!findString("boolFuncExist", boolFuncSubs))
        {warnSub("boolFuncExist", "boolFunc", a_boolFunc);}
      else
        check_boolFuncExist(dynamic_cast<boolFuncExist *>(a_boolFunc));
      return;
    }
}

/********************************************************************/

void check_boolFuncEof(
 boolFuncEof * a_boolFuncEof)
{
  if (a_boolFuncEof->get_didLabel())
    {
      if (!findString("a_didLabel", boolFuncEofAtts))
	{warnAtt("a_didLabel", "boolFuncEof", a_boolFuncEof);}
      else
        check_didLabel(a_boolFuncEof->get_didLabel());
    }
}

/********************************************************************/

void check_boolFuncEoln(
 boolFuncEoln * a_boolFuncEoln)
{
  if (a_boolFuncEoln->get_didLabel())
    {
      if (!findString("a_didLabel", boolFuncEolnAtts))
	{warnAtt("a_didLabel", "boolFuncEoln", a_boolFuncEoln);}
      else
        check_didLabel(a_boolFuncEoln->get_didLabel());
    }
}

/********************************************************************/

void check_boolFuncExist(
 boolFuncExist * a_boolFuncExist)
{
  if (isA(a_boolFuncExist, boolFuncExist_sLabel))
    {
      if (!findString("boolFuncExist_sLabel", boolFuncExistSubs))
        {warnSub("boolFuncExist_sLabel", "boolFuncExist", a_boolFuncExist);}
      else
        check_boolFuncExist_sLabel(dynamic_cast<boolFuncExist_sLabel *>(a_boolFuncExist));
      return;
    }
  if (isA(a_boolFuncExist, boolFuncExist_saLabel))
    {
      if (!findString("boolFuncExist_saLabel", boolFuncExistSubs))
        {warnSub("boolFuncExist_saLabel", "boolFuncExist", a_boolFuncExist);}
      else
        check_boolFuncExist_saLabel(dynamic_cast<boolFuncExist_saLabel *>(a_boolFuncExist));
      return;
    }
  if (isA(a_boolFuncExist, boolFuncExist_dLabel))
    {
      if (!findString("boolFuncExist_dLabel", boolFuncExistSubs))
        {warnSub("boolFuncExist_dLabel", "boolFuncExist", a_boolFuncExist);}
      else
        check_boolFuncExist_dLabel(dynamic_cast<boolFuncExist_dLabel *>(a_boolFuncExist));
      return;
    }
  if (isA(a_boolFuncExist, boolFuncExist_daLabel))
    {
      if (!findString("boolFuncExist_daLabel", boolFuncExistSubs))
        {warnSub("boolFuncExist_daLabel", "boolFuncExist", a_boolFuncExist);}
      else
        check_boolFuncExist_daLabel(dynamic_cast<boolFuncExist_daLabel *>(a_boolFuncExist));
      return;
    }
  if (isA(a_boolFuncExist, boolFuncExist_didLabel))
    {
      if (!findString("boolFuncExist_didLabel", boolFuncExistSubs))
        {warnSub("boolFuncExist_didLabel", "boolFuncExist", a_boolFuncExist);}
      else
        check_boolFuncExist_didLabel(dynamic_cast<boolFuncExist_didLabel *>(a_boolFuncExist));
      return;
    }
  if (isA(a_boolFuncExist, boolFuncExist_fLabel))
    {
      if (!findString("boolFuncExist_fLabel", boolFuncExistSubs))
        {warnSub("boolFuncExist_fLabel", "boolFuncExist", a_boolFuncExist);}
      else
        check_boolFuncExist_fLabel(dynamic_cast<boolFuncExist_fLabel *>(a_boolFuncExist));
      return;
    }
  if (isA(a_boolFuncExist, boolFuncExist_faLabel))
    {
      if (!findString("boolFuncExist_faLabel", boolFuncExistSubs))
        {warnSub("boolFuncExist_faLabel", "boolFuncExist", a_boolFuncExist);}
      else
        check_boolFuncExist_faLabel(dynamic_cast<boolFuncExist_faLabel *>(a_boolFuncExist));
      return;
    }
}

/********************************************************************/

void check_boolFuncExist_dLabel(
 boolFuncExist_dLabel * a_boolFuncExist_dLabel)
{
  if (a_boolFuncExist_dLabel->get_dLabel())
    {
      if (!findString("a_dLabel", boolFuncExist_dLabelAtts))
	{warnAtt("a_dLabel", "boolFuncExist_dLabel", a_boolFuncExist_dLabel);}
      else
        check_dLabel(a_boolFuncExist_dLabel->get_dLabel());
    }
}

/********************************************************************/

void check_boolFuncExist_daLabel(
 boolFuncExist_daLabel * a_boolFuncExist_daLabel)
{
  if (a_boolFuncExist_daLabel->get_daLabel())
    {
      if (!findString("a_daLabel", boolFuncExist_daLabelAtts))
	{warnAtt("a_daLabel", "boolFuncExist_daLabel", a_boolFuncExist_daLabel);}
      else
        check_daLabel(a_boolFuncExist_daLabel->get_daLabel());
    }
}

/********************************************************************/

void check_boolFuncExist_didLabel(
 boolFuncExist_didLabel * a_boolFuncExist_didLabel)
{
  if (a_boolFuncExist_didLabel->get_didLabel())
    {
      if (!findString("a_didLabel", boolFuncExist_didLabelAtts))
	{warnAtt("a_didLabel", "boolFuncExist_didLabel", a_boolFuncExist_didLabel);}
      else
        check_didLabel(a_boolFuncExist_didLabel->get_didLabel());
    }
}

/********************************************************************/

void check_boolFuncExist_fLabel(
 boolFuncExist_fLabel * a_boolFuncExist_fLabel)
{
  if (a_boolFuncExist_fLabel->get_fLabel())
    {
      if (!findString("a_fLabel", boolFuncExist_fLabelAtts))
	{warnAtt("a_fLabel", "boolFuncExist_fLabel", a_boolFuncExist_fLabel);}
      else
        check_fLabel(a_boolFuncExist_fLabel->get_fLabel());
    }
}

/********************************************************************/

void check_boolFuncExist_faLabel(
 boolFuncExist_faLabel * a_boolFuncExist_faLabel)
{
  if (a_boolFuncExist_faLabel->get_faLabel())
    {
      if (!findString("a_faLabel", boolFuncExist_faLabelAtts))
	{warnAtt("a_faLabel", "boolFuncExist_faLabel", a_boolFuncExist_faLabel);}
      else
        check_faLabel(a_boolFuncExist_faLabel->get_faLabel());
    }
}

/********************************************************************/

void check_boolFuncExist_sLabel(
 boolFuncExist_sLabel * a_boolFuncExist_sLabel)
{
  if (a_boolFuncExist_sLabel->get_sLabel())
    {
      if (!findString("a_sLabel", boolFuncExist_sLabelAtts))
	{warnAtt("a_sLabel", "boolFuncExist_sLabel", a_boolFuncExist_sLabel);}
      else
        check_sLabel(a_boolFuncExist_sLabel->get_sLabel());
    }
}

/********************************************************************/

void check_boolFuncExist_saLabel(
 boolFuncExist_saLabel * a_boolFuncExist_saLabel)
{
  if (a_boolFuncExist_saLabel->get_saLabel())
    {
      if (!findString("a_saLabel", boolFuncExist_saLabelAtts))
	{warnAtt("a_saLabel", "boolFuncExist_saLabel", a_boolFuncExist_saLabel);}
      else
        check_saLabel(a_boolFuncExist_saLabel->get_saLabel());
    }
}

/********************************************************************/

void check_boolRel(
 boolRel * a_boolRel)
{
  if (isA(a_boolRel, boolRel_NOT))
    {
      if (!findString("boolRel_NOT", boolRelSubs))
        {warnSub("boolRel_NOT", "boolRel", a_boolRel);}
      else
        check_boolRel_NOT(dynamic_cast<boolRel_NOT *>(a_boolRel));
      return;
    }
  if (isA(a_boolRel, boolRel_AND))
    {
      if (!findString("boolRel_AND", boolRelSubs))
        {warnSub("boolRel_AND", "boolRel", a_boolRel);}
      else
        check_boolRel_AND(dynamic_cast<boolRel_AND *>(a_boolRel));
      return;
    }
  if (isA(a_boolRel, boolRel_OR))
    {
      if (!findString("boolRel_OR", boolRelSubs))
        {warnSub("boolRel_OR", "boolRel", a_boolRel);}
      else
        check_boolRel_OR(dynamic_cast<boolRel_OR *>(a_boolRel));
      return;
    }
  if (isA(a_boolRel, boolRel_EQ))
    {
      if (!findString("boolRel_EQ", boolRelSubs))
        {warnSub("boolRel_EQ", "boolRel", a_boolRel);}
      else
        check_boolRel_EQ(dynamic_cast<boolRel_EQ *>(a_boolRel));
      return;
    }
  if (isA(a_boolRel, boolRel_NE))
    {
      if (!findString("boolRel_NE", boolRelSubs))
        {warnSub("boolRel_NE", "boolRel", a_boolRel);}
      else
        check_boolRel_NE(dynamic_cast<boolRel_NE *>(a_boolRel));
      return;
    }
}

/********************************************************************/

void check_boolRel_AND(
 boolRel_AND * a_boolRel_AND)
{
  if (a_boolRel_AND->get_left())
    {
      if (!findString("left", boolRel_ANDAtts))
	{warnAtt("left", "boolRel_AND", a_boolRel_AND);}
      else
        check_boolVal(a_boolRel_AND->get_left());
    }
  if (a_boolRel_AND->get_right())
    {
      if (!findString("right", boolRel_ANDAtts))
	{warnAtt("right", "boolRel_AND", a_boolRel_AND);}
      else
        check_boolVal(a_boolRel_AND->get_right());
    }
}

/********************************************************************/

void check_boolRel_EQ(
 boolRel_EQ * a_boolRel_EQ)
{
  if (a_boolRel_EQ->get_left())
    {
      if (!findString("left", boolRel_EQAtts))
	{warnAtt("left", "boolRel_EQ", a_boolRel_EQ);}
      else
        check_boolVal(a_boolRel_EQ->get_left());
    }
  if (a_boolRel_EQ->get_right())
    {
      if (!findString("right", boolRel_EQAtts))
	{warnAtt("right", "boolRel_EQ", a_boolRel_EQ);}
      else
        check_boolVal(a_boolRel_EQ->get_right());
    }
}

/********************************************************************/

void check_boolRel_NE(
 boolRel_NE * a_boolRel_NE)
{
  if (a_boolRel_NE->get_left())
    {
      if (!findString("left", boolRel_NEAtts))
	{warnAtt("left", "boolRel_NE", a_boolRel_NE);}
      else
        check_boolVal(a_boolRel_NE->get_left());
    }
  if (a_boolRel_NE->get_right())
    {
      if (!findString("right", boolRel_NEAtts))
	{warnAtt("right", "boolRel_NE", a_boolRel_NE);}
      else
        check_boolVal(a_boolRel_NE->get_right());
    }
}

/********************************************************************/

void check_boolRel_NOT(
 boolRel_NOT * a_boolRel_NOT)
{
  if (a_boolRel_NOT->get_boolVal())
    {
      if (!findString("a_boolVal", boolRel_NOTAtts))
	{warnAtt("a_boolVal", "boolRel_NOT", a_boolRel_NOT);}
      else
        check_boolVal(a_boolRel_NOT->get_boolVal());
    }
}

/********************************************************************/

void check_boolRel_OR(
 boolRel_OR * a_boolRel_OR)
{
  if (a_boolRel_OR->get_left())
    {
      if (!findString("left", boolRel_ORAtts))
	{warnAtt("left", "boolRel_OR", a_boolRel_OR);}
      else
        check_boolVal(a_boolRel_OR->get_left());
    }
  if (a_boolRel_OR->get_right())
    {
      if (!findString("right", boolRel_ORAtts))
	{warnAtt("right", "boolRel_OR", a_boolRel_OR);}
      else
        check_boolVal(a_boolRel_OR->get_right());
    }
}

/********************************************************************/

void check_boolVal(
 boolVal * a_boolVal)
{
  if (isA(a_boolVal, boolConst))
    {
      if (!findString("boolConst", boolValSubs))
        {warnSub("boolConst", "boolVal", a_boolVal);}
      else
        check_boolConst(dynamic_cast<boolConst *>(a_boolVal));
      return;
    }
  if (isA(a_boolVal, boolExpr))
    {
      if (!findString("boolExpr", boolValSubs))
        {warnSub("boolExpr", "boolVal", a_boolVal);}
      else
        check_boolExpr(dynamic_cast<boolExpr *>(a_boolVal));
      return;
    }
  if (isA(a_boolVal, boolFunc))
    {
      if (!findString("boolFunc", boolValSubs))
        {warnSub("boolFunc", "boolVal", a_boolVal);}
      else
        check_boolFunc(dynamic_cast<boolFunc *>(a_boolVal));
      return;
    }
  if (isA(a_boolVal, boolVar))
    {
      if (!findString("boolVar", boolValSubs))
        {warnSub("boolVar", "boolVal", a_boolVal);}
      else
        check_boolVar(dynamic_cast<boolVar *>(a_boolVal));
      return;
    }
}

/********************************************************************/

void check_boolVar(
 boolVar * a_boolVar)
{
  if (a_boolVar->get_string())
    {
      if (!findString("a_string", boolVarAtts))
	{warnAtt("a_string", "boolVar", a_boolVar);}
    }
  if (a_boolVar->get_arrayIndex())
    {
      if (!findString("a_arrayIndex", boolVarAtts))
	{warnAtt("a_arrayIndex", "boolVar", a_boolVar);}
      else
        check_arrayIndex(a_boolVar->get_arrayIndex());
    }
}

/********************************************************************/

void check_boundFeat(
 boundFeat * a_boundFeat)
{
  if (a_boundFeat->get_fLabel())
    {
      if (!findString("a_fLabel", boundFeatAtts))
	{warnAtt("a_fLabel", "boundFeat", a_boundFeat);}
      else
        check_fLabel(a_boundFeat->get_fLabel());
    }
  if (a_boundFeat->get_featureList())
    {
      if (!findString("a_featureList", boundFeatAtts))
	{warnAtt("a_featureList", "boundFeat", a_boundFeat);}
      else
        {
          std::list<featureLabel *> * theList;
          std::list<featureLabel *>::iterator iter;
          theList = a_boundFeat->get_featureList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_featureLabel(*iter);
        }
    }
}

/********************************************************************/

void check_boundMinor(
 boundMinor * a_boundMinor)
{
  if (isA(a_boundMinor, boundFeat))
    {
      if (!findString("boundFeat", boundMinorSubs))
        {warnSub("boundFeat", "boundMinor", a_boundMinor);}
      else
        check_boundFeat(dynamic_cast<boundFeat *>(a_boundMinor));
      return;
    }
  if (isA(a_boundMinor, boundTol))
    {
      if (!findString("boundTol", boundMinorSubs))
        {warnSub("boundTol", "boundMinor", a_boundMinor);}
      else
        check_boundTol(dynamic_cast<boundTol *>(a_boundMinor));
      return;
    }
}

/********************************************************************/

void check_boundStm(
 boundStm * a_boundStm)
{
  if (a_boundStm->get_boundMinor())
    {
      if (!findString("a_boundMinor", boundStmAtts))
	{warnAtt("a_boundMinor", "boundStm", a_boundStm);}
      else
        check_boundMinor(a_boundStm->get_boundMinor());
    }
}

/********************************************************************/

void check_boundTol(
 boundTol * a_boundTol)
{
  if (a_boundTol->get_tLabel())
    {
      if (!findString("a_tLabel", boundTolAtts))
	{warnAtt("a_tLabel", "boundTol", a_boundTol);}
      else
        check_tLabel(a_boundTol->get_tLabel());
    }
  if (a_boundTol->get_featureList())
    {
      if (!findString("a_featureList", boundTolAtts))
	{warnAtt("a_featureList", "boundTol", a_boundTol);}
      else
        {
          std::list<featureLabel *> * theList;
          std::list<featureLabel *>::iterator iter;
          theList = a_boundTol->get_featureList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_featureLabel(*iter);
        }
    }
}

/********************************************************************/

void check_cadfileType(
 cadfileType * a_cadfileType)
{
  if (isA(a_cadfileType, cadfileType_STEP))
    {
      if (!findString("cadfileType_STEP", cadfileTypeSubs))
        {warnSub("cadfileType_STEP", "cadfileType", a_cadfileType);}
      return;
    }
  if (isA(a_cadfileType, cadfileType_IGES))
    {
      if (!findString("cadfileType_IGES", cadfileTypeSubs))
        {warnSub("cadfileType_IGES", "cadfileType", a_cadfileType);}
      return;
    }
  if (isA(a_cadfileType, cadfileType_VENDOR))
    {
      if (!findString("cadfileType_VENDOR", cadfileTypeSubs))
        {warnSub("cadfileType_VENDOR", "cadfileType", a_cadfileType);}
      else
        check_cadfileType_VENDOR(dynamic_cast<cadfileType_VENDOR *>(a_cadfileType));
      return;
    }
}

/********************************************************************/

void check_cadfileType_VENDOR(
 cadfileType_VENDOR * a_cadfileType_VENDOR)
{
  if (a_cadfileType_VENDOR->get_text())
    {
      if (!findString("text", cadfileType_VENDORAtts))
	{warnAtt("text", "cadfileType_VENDOR", a_cadfileType_VENDOR);}
      else
        check_stringVal(a_cadfileType_VENDOR->get_text());
    }
}

/********************************************************************/

void check_calibMasterBlock(
 calibMasterBlock * a_calibMasterBlock)
{
  if (a_calibMasterBlock->get_calibMasterStm())
    {
      if (!findString("a_calibMasterStm", calibMasterBlockAtts))
	{warnAttBlock("calibMasterStm", a_calibMasterBlock->get_calibMasterStm());}
      else
        check_calibMasterStm(a_calibMasterBlock->get_calibMasterStm());
    }
  if (a_calibMasterBlock->get_calibSensBlockItemList())
    {
      if (!findString("a_calibSensBlockItemList", calibMasterBlockAtts))
	{warnAttBlock("calibSensBlockItemList", a_calibMasterBlock->get_calibSensBlockItemList()->front());}
      else
        {
          std::list<calibSensBlockItem *> * theList;
          std::list<calibSensBlockItem *>::iterator iter;
          theList = a_calibMasterBlock->get_calibSensBlockItemList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_calibSensBlockItem(*iter);
        }
    }
  if (a_calibMasterBlock->get_endmesStm())
    {
      if (!findString("a_endmesStm", calibMasterBlockAtts))
	{warnAttBlock("endmesStm", a_calibMasterBlock->get_endmesStm());}
    }
}

/********************************************************************/

void check_calibMasterMinor(
 calibMasterMinor * a_calibMasterMinor)
{
  if (a_calibMasterMinor->get_artName())
    {
      if (!findString("artName", calibMasterMinorAtts))
	{warnAtt("artName", "calibMasterMinor", a_calibMasterMinor);}
      else
        check_stringVal(a_calibMasterMinor->get_artName());
    }
}

/********************************************************************/

void check_calibMasterStm(
 calibMasterStm * a_calibMasterStm)
{
  if (a_calibMasterStm->get_calibMasterMinor())
    {
      if (!findString("a_calibMasterMinor", calibMasterStmAtts))
	{warnAtt("a_calibMasterMinor", "calibMasterStm", a_calibMasterStm);}
      else
        check_calibMasterMinor(a_calibMasterStm->get_calibMasterMinor());
    }
}

/********************************************************************/

void check_calibRtabBlock(
 calibRtabBlock * a_calibRtabBlock)
{
  if (a_calibRtabBlock->get_calibRtabStm())
    {
      if (!findString("a_calibRtabStm", calibRtabBlockAtts))
	{warnAttBlock("calibRtabStm", a_calibRtabBlock->get_calibRtabStm());}
      else
        check_calibRtabStm(a_calibRtabBlock->get_calibRtabStm());
    }
  if (a_calibRtabBlock->get_measBlockItemList())
    {
      if (!findString("a_measBlockItemList", calibRtabBlockAtts))
	{warnAttBlock("measBlockItemList", a_calibRtabBlock->get_measBlockItemList()->front());}
      else
        {
          std::list<measBlockItem *> * theList;
          std::list<measBlockItem *>::iterator iter;
          theList = a_calibRtabBlock->get_measBlockItemList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_measBlockItem(*iter);
        }
    }
  if (a_calibRtabBlock->get_endmesStm())
    {
      if (!findString("a_endmesStm", calibRtabBlockAtts))
	{warnAttBlock("endmesStm", a_calibRtabBlock->get_endmesStm());}
    }
}

/********************************************************************/

void check_calibRtabMinor(
 calibRtabMinor * a_calibRtabMinor)
{
  if (isA(a_calibRtabMinor, calibRtabMinorSpec))
    {
      if (!findString("calibRtabMinorSpec", calibRtabMinorSubs))
        {warnSub("calibRtabMinorSpec", "calibRtabMinor", a_calibRtabMinor);}
      else
        check_calibRtabMinorSpec(dynamic_cast<calibRtabMinorSpec *>(a_calibRtabMinor));
      return;
    }
  if (isA(a_calibRtabMinor, calibRtabMinorRecalib))
    {
      if (!findString("calibRtabMinorRecalib", calibRtabMinorSubs))
        {warnSub("calibRtabMinorRecalib", "calibRtabMinor", a_calibRtabMinor);}
      return;
    }
}

/********************************************************************/

void check_calibRtabMinorSpec(
 calibRtabMinorSpec * a_calibRtabMinorSpec)
{
  if (a_calibRtabMinorSpec->get_rtLabel())
    {
      if (!findString("a_rtLabel", calibRtabMinorSpecAtts))
	{warnAtt("a_rtLabel", "calibRtabMinorSpec", a_calibRtabMinorSpec);}
      else
        check_rtLabel(a_calibRtabMinorSpec->get_rtLabel());
    }
  if (a_calibRtabMinorSpec->get_calibRtabSpec())
    {
      if (!findString("a_calibRtabSpec", calibRtabMinorSpecAtts))
	{warnAtt("a_calibRtabSpec", "calibRtabMinorSpec", a_calibRtabMinorSpec);}
      else
        check_calibRtabSpec(a_calibRtabMinorSpec->get_calibRtabSpec());
    }
}

/********************************************************************/

void check_calibRtabSpec(
 calibRtabSpec * a_calibRtabSpec)
{
  if (isA(a_calibRtabSpec, calibRtabSpec_fLabel))
    {
      if (!findString("calibRtabSpec_fLabel", calibRtabSpecSubs))
        {warnSub("calibRtabSpec_fLabel", "calibRtabSpec", a_calibRtabSpec);}
      else
        check_calibRtabSpec_fLabel(dynamic_cast<calibRtabSpec_fLabel *>(a_calibRtabSpec));
      return;
    }
  if (isA(a_calibRtabSpec, calibRtabSpec_faLabel))
    {
      if (!findString("calibRtabSpec_faLabel", calibRtabSpecSubs))
        {warnSub("calibRtabSpec_faLabel", "calibRtabSpec", a_calibRtabSpec);}
      else
        check_calibRtabSpec_faLabel(dynamic_cast<calibRtabSpec_faLabel *>(a_calibRtabSpec));
      return;
    }
}

/********************************************************************/

void check_calibRtabSpec_fLabel(
 calibRtabSpec_fLabel * a_calibRtabSpec_fLabel)
{
  if (a_calibRtabSpec_fLabel->get_fLabel())
    {
      if (!findString("a_fLabel", calibRtabSpec_fLabelAtts))
	{warnAtt("a_fLabel", "calibRtabSpec_fLabel", a_calibRtabSpec_fLabel);}
      else
        check_fLabel(a_calibRtabSpec_fLabel->get_fLabel());
    }
  if (a_calibRtabSpec_fLabel->get_numMeas())
    {
      if (!findString("numMeas", calibRtabSpec_fLabelAtts))
	{warnAtt("numMeas", "calibRtabSpec_fLabel", a_calibRtabSpec_fLabel);}
      else
        check_intVal(a_calibRtabSpec_fLabel->get_numMeas());
    }
}

/********************************************************************/

void check_calibRtabSpec_faLabel(
 calibRtabSpec_faLabel * a_calibRtabSpec_faLabel)
{
  if (a_calibRtabSpec_faLabel->get_feat1())
    {
      if (!findString("feat1", calibRtabSpec_faLabelAtts))
	{warnAtt("feat1", "calibRtabSpec_faLabel", a_calibRtabSpec_faLabel);}
      else
        check_faLabel(a_calibRtabSpec_faLabel->get_feat1());
    }
  if (a_calibRtabSpec_faLabel->get_feat2())
    {
      if (!findString("feat2", calibRtabSpec_faLabelAtts))
	{warnAtt("feat2", "calibRtabSpec_faLabel", a_calibRtabSpec_faLabel);}
      else
        check_faLabel(a_calibRtabSpec_faLabel->get_feat2());
    }
}

/********************************************************************/

void check_calibRtabStm(
 calibRtabStm * a_calibRtabStm)
{
  if (a_calibRtabStm->get_calibRtabMinor())
    {
      if (!findString("a_calibRtabMinor", calibRtabStmAtts))
	{warnAtt("a_calibRtabMinor", "calibRtabStm", a_calibRtabStm);}
      else
        check_calibRtabMinor(a_calibRtabStm->get_calibRtabMinor());
    }
}

/********************************************************************/

void check_calibSensBlock(
 calibSensBlock * a_calibSensBlock)
{
  if (a_calibSensBlock->get_calibSensStm())
    {
      if (!findString("a_calibSensStm", calibSensBlockAtts))
	{warnAttBlock("calibSensStm", a_calibSensBlock->get_calibSensStm());}
      else
        check_calibSensStm(a_calibSensBlock->get_calibSensStm());
    }
  if (a_calibSensBlock->get_calibSensBlockItemList())
    {
      if (!findString("a_calibSensBlockItemList", calibSensBlockAtts))
	{warnAttBlock("calibSensBlockItemList", a_calibSensBlock->get_calibSensBlockItemList()->front());}
      else
        {
          std::list<calibSensBlockItem *> * theList;
          std::list<calibSensBlockItem *>::iterator iter;
          theList = a_calibSensBlock->get_calibSensBlockItemList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_calibSensBlockItem(*iter);
        }
    }
  if (a_calibSensBlock->get_endmesStm())
    {
      if (!findString("a_endmesStm", calibSensBlockAtts))
	{warnAttBlock("endmesStm", a_calibSensBlock->get_endmesStm());}
    }
}

/********************************************************************/

void check_calibSensBlockItem(
 calibSensBlockItem * a_calibSensBlockItem)
{
  if (isA(a_calibSensBlockItem, calibSensBlockStatement))
    {
      if (!findString("calibSensBlockStatement", calibSensBlockItemSubs))
        {warnSub("calibSensBlockStatement", "calibSensBlockItem", a_calibSensBlockItem);}
      else
        check_calibSensBlockStatement(dynamic_cast<calibSensBlockStatement *>(a_calibSensBlockItem));
      return;
    }
  if (isA(a_calibSensBlockItem, calibSensDoBlock))
    {
      if (!findString("calibSensDoBlock", calibSensBlockItemSubs))
        {warnSub("calibSensDoBlock", "calibSensBlockItem", a_calibSensBlockItem);}
      else
        check_calibSensDoBlock(dynamic_cast<calibSensDoBlock *>(a_calibSensBlockItem));
      return;
    }
  if (isA(a_calibSensBlockItem, calibSensIfBlock))
    {
      if (!findString("calibSensIfBlock", calibSensBlockItemSubs))
        {warnSub("calibSensIfBlock", "calibSensBlockItem", a_calibSensBlockItem);}
      else
        check_calibSensIfBlock(dynamic_cast<calibSensIfBlock *>(a_calibSensBlockItem));
      return;
    }
  if (isA(a_calibSensBlockItem, calibSensSelectBlock))
    {
      if (!findString("calibSensSelectBlock", calibSensBlockItemSubs))
        {warnSub("calibSensSelectBlock", "calibSensBlockItem", a_calibSensBlockItem);}
      else
        check_calibSensSelectBlock(dynamic_cast<calibSensSelectBlock *>(a_calibSensBlockItem));
      return;
    }
  if (isA(a_calibSensBlockItem, gotargBlock))
    {
      if (!findString("gotargBlock", calibSensBlockItemSubs))
        {warnSub("gotargBlock", "calibSensBlockItem", a_calibSensBlockItem);}
      else
        check_gotargBlock(dynamic_cast<gotargBlock *>(a_calibSensBlockItem));
      return;
    }
}

/********************************************************************/

void check_calibSensBlockStatement(
 calibSensBlockStatement * a_calibSensBlockStatement)
{
  if (isA(a_calibSensBlockStatement, jumpStm))
    {
      if (!findString("jumpStm", calibSensBlockStatementSubs))
        {warnSub("jumpStm", "calibSensBlockStatement", a_calibSensBlockStatement);}
      else
        check_jumpStm(dynamic_cast<jumpStm *>(a_calibSensBlockStatement));
      return;
    }
  if (isA(a_calibSensBlockStatement, aclratStm))
    {
      if (!findString("aclratStm", calibSensBlockStatementSubs))
        {warnSub("aclratStm", "calibSensBlockStatement", a_calibSensBlockStatement);}
      else
        check_aclratStm(dynamic_cast<aclratStm *>(a_calibSensBlockStatement));
      return;
    }
  if (isA(a_calibSensBlockStatement, assignStm))
    {
      if (!findString("assignStm", calibSensBlockStatementSubs))
        {warnSub("assignStm", "calibSensBlockStatement", a_calibSensBlockStatement);}
      else
        check_assignStm(dynamic_cast<assignStm *>(a_calibSensBlockStatement));
      return;
    }
  if (isA(a_calibSensBlockStatement, badtstStm))
    {
      if (!findString("badtstStm", calibSensBlockStatementSubs))
        {warnSub("badtstStm", "calibSensBlockStatement", a_calibSensBlockStatement);}
      else
        check_badtstStm(dynamic_cast<badtstStm *>(a_calibSensBlockStatement));
      return;
    }
  if (isA(a_calibSensBlockStatement, czslctStm))
    {
      if (!findString("czslctStm", calibSensBlockStatementSubs))
        {warnSub("czslctStm", "calibSensBlockStatement", a_calibSensBlockStatement);}
      else
        check_czslctStm(dynamic_cast<czslctStm *>(a_calibSensBlockStatement));
      return;
    }
  if (isA(a_calibSensBlockStatement, dmehwStm))
    {
      if (!findString("dmehwStm", calibSensBlockStatementSubs))
        {warnSub("dmehwStm", "calibSensBlockStatement", a_calibSensBlockStatement);}
      else
        check_dmehwStm(dynamic_cast<dmehwStm *>(a_calibSensBlockStatement));
      return;
    }
  if (isA(a_calibSensBlockStatement, dmeswStm))
    {
      if (!findString("dmeswStm", calibSensBlockStatementSubs))
        {warnSub("dmeswStm", "calibSensBlockStatement", a_calibSensBlockStatement);}
      else
        check_dmeswStm(dynamic_cast<dmeswStm *>(a_calibSensBlockStatement));
      return;
    }
  if (isA(a_calibSensBlockStatement, errorStm))
    {
      if (!findString("errorStm", calibSensBlockStatementSubs))
        {warnSub("errorStm", "calibSensBlockStatement", a_calibSensBlockStatement);}
      else
        check_errorStm(dynamic_cast<errorStm *>(a_calibSensBlockStatement));
      return;
    }
  if (isA(a_calibSensBlockStatement, fedratStm))
    {
      if (!findString("fedratStm", calibSensBlockStatementSubs))
        {warnSub("fedratStm", "calibSensBlockStatement", a_calibSensBlockStatement);}
      else
        check_fedratStm(dynamic_cast<fedratStm *>(a_calibSensBlockStatement));
      return;
    }
  if (isA(a_calibSensBlockStatement, finposStm))
    {
      if (!findString("finposStm", calibSensBlockStatementSubs))
        {warnSub("finposStm", "calibSensBlockStatement", a_calibSensBlockStatement);}
      else
        check_finposStm(dynamic_cast<finposStm *>(a_calibSensBlockStatement));
      return;
    }
  if (isA(a_calibSensBlockStatement, fromStm))
    {
      if (!findString("fromStm", calibSensBlockStatementSubs))
        {warnSub("fromStm", "calibSensBlockStatement", a_calibSensBlockStatement);}
      else
        check_fromStm(dynamic_cast<fromStm *>(a_calibSensBlockStatement));
      return;
    }
  if (isA(a_calibSensBlockStatement, gohomeStm))
    {
      if (!findString("gohomeStm", calibSensBlockStatementSubs))
        {warnSub("gohomeStm", "calibSensBlockStatement", a_calibSensBlockStatement);}
      return;
    }
  if (isA(a_calibSensBlockStatement, gotoStm))
    {
      if (!findString("gotoStm", calibSensBlockStatementSubs))
        {warnSub("gotoStm", "calibSensBlockStatement", a_calibSensBlockStatement);}
      else
        check_gotoStm(dynamic_cast<gotoStm *>(a_calibSensBlockStatement));
      return;
    }
  if (isA(a_calibSensBlockStatement, includStm))
    {
      if (!findString("includStm", calibSensBlockStatementSubs))
        {warnSub("includStm", "calibSensBlockStatement", a_calibSensBlockStatement);}
      else
        check_includStm(dynamic_cast<includStm *>(a_calibSensBlockStatement));
      return;
    }
  if (isA(a_calibSensBlockStatement, jumptoStm))
    {
      if (!findString("jumptoStm", calibSensBlockStatementSubs))
        {warnSub("jumptoStm", "calibSensBlockStatement", a_calibSensBlockStatement);}
      else
        check_jumptoStm(dynamic_cast<jumptoStm *>(a_calibSensBlockStatement));
      return;
    }
  if (isA(a_calibSensBlockStatement, obtainStm))
    {
      if (!findString("obtainStm", calibSensBlockStatementSubs))
        {warnSub("obtainStm", "calibSensBlockStatement", a_calibSensBlockStatement);}
      else
        check_obtainStm(dynamic_cast<obtainStm *>(a_calibSensBlockStatement));
      return;
    }
  if (isA(a_calibSensBlockStatement, pameasStm))
    {
      if (!findString("pameasStm", calibSensBlockStatementSubs))
        {warnSub("pameasStm", "calibSensBlockStatement", a_calibSensBlockStatement);}
      else
        check_pameasStm(dynamic_cast<pameasStm *>(a_calibSensBlockStatement));
      return;
    }
  if (isA(a_calibSensBlockStatement, ptmeasStm))
    {
      if (!findString("ptmeasStm", calibSensBlockStatementSubs))
        {warnSub("ptmeasStm", "calibSensBlockStatement", a_calibSensBlockStatement);}
      else
        check_ptmeasStm(dynamic_cast<ptmeasStm *>(a_calibSensBlockStatement));
      return;
    }
  if (isA(a_calibSensBlockStatement, rapidStm))
    {
      if (!findString("rapidStm", calibSensBlockStatementSubs))
        {warnSub("rapidStm", "calibSensBlockStatement", a_calibSensBlockStatement);}
      else
        check_rapidStm(dynamic_cast<rapidStm *>(a_calibSensBlockStatement));
      return;
    }
  if (isA(a_calibSensBlockStatement, rotabStm))
    {
      if (!findString("rotabStm", calibSensBlockStatementSubs))
        {warnSub("rotabStm", "calibSensBlockStatement", a_calibSensBlockStatement);}
      else
        check_rotabStm(dynamic_cast<rotabStm *>(a_calibSensBlockStatement));
      return;
    }
  if (isA(a_calibSensBlockStatement, rotsetStm))
    {
      if (!findString("rotsetStm", calibSensBlockStatementSubs))
        {warnSub("rotsetStm", "calibSensBlockStatement", a_calibSensBlockStatement);}
      else
        check_rotsetStm(dynamic_cast<rotsetStm *>(a_calibSensBlockStatement));
      return;
    }
  if (isA(a_calibSensBlockStatement, snsetStm))
    {
      if (!findString("snsetStm", calibSensBlockStatementSubs))
        {warnSub("snsetStm", "calibSensBlockStatement", a_calibSensBlockStatement);}
      else
        check_snsetStm(dynamic_cast<snsetStm *>(a_calibSensBlockStatement));
      return;
    }
  if (isA(a_calibSensBlockStatement, textStm))
    {
      if (!findString("textStm", calibSensBlockStatementSubs))
        {warnSub("textStm", "calibSensBlockStatement", a_calibSensBlockStatement);}
      else
        check_textStm(dynamic_cast<textStm *>(a_calibSensBlockStatement));
      return;
    }
  if (isA(a_calibSensBlockStatement, valueStm))
    {
      if (!findString("valueStm", calibSensBlockStatementSubs))
        {warnSub("valueStm", "calibSensBlockStatement", a_calibSensBlockStatement);}
      else
        check_valueStm(dynamic_cast<valueStm *>(a_calibSensBlockStatement));
      return;
    }
  if (isA(a_calibSensBlockStatement, wkplanStm))
    {
      if (!findString("wkplanStm", calibSensBlockStatementSubs))
        {warnSub("wkplanStm", "calibSensBlockStatement", a_calibSensBlockStatement);}
      else
        check_wkplanStm(dynamic_cast<wkplanStm *>(a_calibSensBlockStatement));
      return;
    }
}

/********************************************************************/

void check_calibSensCaseBlock(
 calibSensCaseBlock * a_calibSensCaseBlock)
{
  if (a_calibSensCaseBlock->get_caseList())
    {
      if (!findString("a_caseList", calibSensCaseBlockAtts))
	{warnAttBlock("caseList", a_calibSensCaseBlock->get_caseList()->front());}
      else
        {
          std::list<caseStm *> * theList;
          std::list<caseStm *>::iterator iter;
          theList = a_calibSensCaseBlock->get_caseList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_caseStm(*iter);
        }
    }
  if (a_calibSensCaseBlock->get_calibSensBlockItemList())
    {
      if (!findString("a_calibSensBlockItemList", calibSensCaseBlockAtts))
	{warnAttBlock("calibSensBlockItemList", a_calibSensCaseBlock->get_calibSensBlockItemList()->front());}
      else
        {
          std::list<calibSensBlockItem *> * theList;
          std::list<calibSensBlockItem *>::iterator iter;
          theList = a_calibSensCaseBlock->get_calibSensBlockItemList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_calibSensBlockItem(*iter);
        }
    }
  if (a_calibSensCaseBlock->get_endcasStm())
    {
      if (!findString("a_endcasStm", calibSensCaseBlockAtts))
	{warnAttBlock("endcasStm", a_calibSensCaseBlock->get_endcasStm());}
    }
}

/********************************************************************/

void check_calibSensDefaultCaseBlock(
 calibSensDefaultCaseBlock * a_calibSensDefaultCaseBlock)
{
  if (a_calibSensDefaultCaseBlock->get_dftcasStm())
    {
      if (!findString("a_dftcasStm", calibSensDefaultCaseBlockAtts))
	{warnAttBlock("dftcasStm", a_calibSensDefaultCaseBlock->get_dftcasStm());}
    }
  if (a_calibSensDefaultCaseBlock->get_calibSensBlockItemList())
    {
      if (!findString("a_calibSensBlockItemList", calibSensDefaultCaseBlockAtts))
	{warnAttBlock("calibSensBlockItemList", a_calibSensDefaultCaseBlock->get_calibSensBlockItemList()->front());}
      else
        {
          std::list<calibSensBlockItem *> * theList;
          std::list<calibSensBlockItem *>::iterator iter;
          theList = a_calibSensDefaultCaseBlock->get_calibSensBlockItemList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_calibSensBlockItem(*iter);
        }
    }
  if (a_calibSensDefaultCaseBlock->get_endcasStm())
    {
      if (!findString("a_endcasStm", calibSensDefaultCaseBlockAtts))
	{warnAttBlock("endcasStm", a_calibSensDefaultCaseBlock->get_endcasStm());}
    }
}

/********************************************************************/

void check_calibSensDoBlock(
 calibSensDoBlock * a_calibSensDoBlock)
{
  if (a_calibSensDoBlock->get_doStm())
    {
      if (!findString("a_doStm", calibSensDoBlockAtts))
	{warnAttBlock("doStm", a_calibSensDoBlock->get_doStm());}
      else
        check_doStm(a_calibSensDoBlock->get_doStm());
    }
  if (a_calibSensDoBlock->get_calibSensBlockItemList())
    {
      if (!findString("a_calibSensBlockItemList", calibSensDoBlockAtts))
	{warnAttBlock("calibSensBlockItemList", a_calibSensDoBlock->get_calibSensBlockItemList()->front());}
      else
        {
          std::list<calibSensBlockItem *> * theList;
          std::list<calibSensBlockItem *>::iterator iter;
          theList = a_calibSensDoBlock->get_calibSensBlockItemList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_calibSensBlockItem(*iter);
        }
    }
  if (a_calibSensDoBlock->get_enddoStm())
    {
      if (!findString("a_enddoStm", calibSensDoBlockAtts))
	{warnAttBlock("enddoStm", a_calibSensDoBlock->get_enddoStm());}
    }
}

/********************************************************************/

void check_calibSensIfBlock(
 calibSensIfBlock * a_calibSensIfBlock)
{
  if (a_calibSensIfBlock->get_ifStm())
    {
      if (!findString("a_ifStm", calibSensIfBlockAtts))
	{warnAttBlock("ifStm", a_calibSensIfBlock->get_ifStm());}
      else
        check_ifStm(a_calibSensIfBlock->get_ifStm());
    }
  if (a_calibSensIfBlock->get_ifList())
    {
      if (!findString("ifList", calibSensIfBlockAtts))
	{warnAttBlock("ifList", a_calibSensIfBlock->get_ifList()->front());}
      else
        {
          std::list<calibSensBlockItem *> * theList;
          std::list<calibSensBlockItem *>::iterator iter;
          theList = a_calibSensIfBlock->get_ifList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_calibSensBlockItem(*iter);
        }
    }
  if (a_calibSensIfBlock->get_elseStm())
    {
      if (!findString("a_elseStm", calibSensIfBlockAtts))
	{warnAttBlock("elseStm", a_calibSensIfBlock->get_elseStm());}
    }
  if (a_calibSensIfBlock->get_elseList())
    {
      if (!findString("elseList", calibSensIfBlockAtts))
	{warnAttBlock("elseList", a_calibSensIfBlock->get_elseList()->front());}
      else
        {
          std::list<calibSensBlockItem *> * theList;
          std::list<calibSensBlockItem *>::iterator iter;
          theList = a_calibSensIfBlock->get_elseList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_calibSensBlockItem(*iter);
        }
    }
  if (a_calibSensIfBlock->get_endifStm())
    {
      if (!findString("a_endifStm", calibSensIfBlockAtts))
	{warnAttBlock("endifStm", a_calibSensIfBlock->get_endifStm());}
    }
}

/********************************************************************/

void check_calibSensMinor(
 calibSensMinor * a_calibSensMinor)
{
  if (isA(a_calibSensMinor, calibSensMinorSpec))
    {
      if (!findString("calibSensMinorSpec", calibSensMinorSubs))
        {warnSub("calibSensMinorSpec", "calibSensMinor", a_calibSensMinor);}
      else
        check_calibSensMinorSpec(dynamic_cast<calibSensMinorSpec *>(a_calibSensMinor));
      return;
    }
  if (isA(a_calibSensMinor, calibSensMinorRecalib))
    {
      if (!findString("calibSensMinorRecalib", calibSensMinorSubs))
        {warnSub("calibSensMinorRecalib", "calibSensMinor", a_calibSensMinor);}
      return;
    }
}

/********************************************************************/

void check_calibSensMinorSpec(
 calibSensMinorSpec * a_calibSensMinorSpec)
{
  if (a_calibSensMinorSpec->get_sLabel())
    {
      if (!findString("a_sLabel", calibSensMinorSpecAtts))
	{warnAtt("a_sLabel", "calibSensMinorSpec", a_calibSensMinorSpec);}
      else
        check_sLabel(a_calibSensMinorSpec->get_sLabel());
    }
  if (a_calibSensMinorSpec->get_calibSensSpec())
    {
      if (!findString("a_calibSensSpec", calibSensMinorSpecAtts))
	{warnAtt("a_calibSensSpec", "calibSensMinorSpec", a_calibSensMinorSpec);}
      else
        check_calibSensSpec(a_calibSensMinorSpec->get_calibSensSpec());
    }
}

/********************************************************************/

void check_calibSensSelectBlock(
 calibSensSelectBlock * a_calibSensSelectBlock)
{
  if (a_calibSensSelectBlock->get_selectStm())
    {
      if (!findString("a_selectStm", calibSensSelectBlockAtts))
	{warnAttBlock("selectStm", a_calibSensSelectBlock->get_selectStm());}
      else
        check_selectStm(a_calibSensSelectBlock->get_selectStm());
    }
  if (a_calibSensSelectBlock->get_calibSensCaseBlockList())
    {
      if (!findString("a_calibSensCaseBlockList", calibSensSelectBlockAtts))
	{warnAttBlock("calibSensCaseBlockList", a_calibSensSelectBlock->get_calibSensCaseBlockList()->front());}
      else
        {
          std::list<calibSensCaseBlock *> * theList;
          std::list<calibSensCaseBlock *>::iterator iter;
          theList = a_calibSensSelectBlock->get_calibSensCaseBlockList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_calibSensCaseBlock(*iter);
        }
    }
  if (a_calibSensSelectBlock->get_calibSensDefaultCaseBlock())
    {
      if (!findString("a_calibSensDefaultCaseBlock", calibSensSelectBlockAtts))
	{warnAttBlock("calibSensDefaultCaseBlock", a_calibSensSelectBlock->get_calibSensDefaultCaseBlock());}
      else
        check_calibSensDefaultCaseBlock(a_calibSensSelectBlock->get_calibSensDefaultCaseBlock());
    }
  if (a_calibSensSelectBlock->get_endselStm())
    {
      if (!findString("a_endselStm", calibSensSelectBlockAtts))
	{warnAttBlock("endselStm", a_calibSensSelectBlock->get_endselStm());}
    }
}

/********************************************************************/

void check_calibSensSpec(
 calibSensSpec * a_calibSensSpec)
{
  if (isA(a_calibSensSpec, calibSensSpecInt))
    {
      if (!findString("calibSensSpecInt", calibSensSpecSubs))
        {warnSub("calibSensSpecInt", "calibSensSpec", a_calibSensSpec);}
      else
        check_calibSensSpecInt(dynamic_cast<calibSensSpecInt *>(a_calibSensSpec));
      return;
    }
  if (isA(a_calibSensSpec, calibSensSpecString))
    {
      if (!findString("calibSensSpecString", calibSensSpecSubs))
        {warnSub("calibSensSpecString", "calibSensSpec", a_calibSensSpec);}
      else
        check_calibSensSpecString(dynamic_cast<calibSensSpecString *>(a_calibSensSpec));
      return;
    }
}

/********************************************************************/

void check_calibSensSpecInt(
 calibSensSpecInt * a_calibSensSpecInt)
{
  if (a_calibSensSpecInt->get_featureLabel1())
    {
      if (!findString("a_featureLabel1", calibSensSpecIntAtts))
	{warnAtt("a_featureLabel1", "calibSensSpecInt", a_calibSensSpecInt);}
      else
        check_featureLabel1(a_calibSensSpecInt->get_featureLabel1());
    }
  if (a_calibSensSpecInt->get_numMeas())
    {
      if (!findString("numMeas", calibSensSpecIntAtts))
	{warnAtt("numMeas", "calibSensSpecInt", a_calibSensSpecInt);}
      else
        check_intVal(a_calibSensSpecInt->get_numMeas());
    }
}

/********************************************************************/

void check_calibSensSpecString(
 calibSensSpecString * a_calibSensSpecString)
{
  if (a_calibSensSpecString->get_featureLabel1())
    {
      if (!findString("a_featureLabel1", calibSensSpecStringAtts))
	{warnAtt("a_featureLabel1", "calibSensSpecString", a_calibSensSpecString);}
      else
        check_featureLabel1(a_calibSensSpecString->get_featureLabel1());
    }
  if (a_calibSensSpecString->get_text())
    {
      if (!findString("text", calibSensSpecStringAtts))
	{warnAtt("text", "calibSensSpecString", a_calibSensSpecString);}
      else
        check_stringVal(a_calibSensSpecString->get_text());
    }
  if (a_calibSensSpecString->get_numMeas())
    {
      if (!findString("numMeas", calibSensSpecStringAtts))
	{warnAtt("numMeas", "calibSensSpecString", a_calibSensSpecString);}
      else
        check_intVal(a_calibSensSpecString->get_numMeas());
    }
}

/********************************************************************/

void check_calibSensStm(
 calibSensStm * a_calibSensStm)
{
  if (a_calibSensStm->get_calibSensMinor())
    {
      if (!findString("a_calibSensMinor", calibSensStmAtts))
	{warnAtt("a_calibSensMinor", "calibSensStm", a_calibSensStm);}
      else
        check_calibSensMinor(a_calibSensStm->get_calibSensMinor());
    }
}

/********************************************************************/

void check_callBlock(
 callBlock * a_callBlock)
{
  if (a_callBlock->get_callStm())
    {
      if (!findString("a_callStm", callBlockAtts))
	{warnAttBlock("callStm", a_callBlock->get_callStm());}
      else
        check_callStm(a_callBlock->get_callStm());
    }
  if (a_callBlock->get_dmisItemList())
    {
      if (!findString("a_dmisItemList", callBlockAtts))
	{warnAttBlock("dmisItemList", a_callBlock->get_dmisItemList()->front());}
      else
        {
          std::list<dmisItem *> * theList;
          std::list<dmisItem *>::iterator iter;
          theList = a_callBlock->get_dmisItemList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_dmisItem(*iter);
        }
    }
  if (a_callBlock->get_endmacStm())
    {
      if (!findString("a_endmacStm", callBlockAtts))
	{warnAttBlock("endmacStm", a_callBlock->get_endmacStm());}
    }
}

/********************************************************************/

void check_callMacro(
 callMacro * a_callMacro)
{
  if (a_callMacro->get_has_EXTERN())
    {
      if (!findString("has_EXTERN", callMacroAtts))
	{warnAtt("has_EXTERN", "callMacro", a_callMacro);}
    }
  if (a_callMacro->get_mLabel())
    {
      if (!findString("a_mLabel", callMacroAtts))
	{warnAtt("a_mLabel", "callMacro", a_callMacro);}
      else
        check_mLabel(a_callMacro->get_mLabel());
    }
  if (a_callMacro->get_string())
    {
      if (!findString("a_string", callMacroAtts))
	{warnAtt("a_string", "callMacro", a_callMacro);}
    }
}

/********************************************************************/

void check_callMinor(
 callMinor * a_callMinor)
{
  if (isA(a_callMinor, callMacro))
    {
      if (!findString("callMacro", callMinorSubs))
        {warnSub("callMacro", "callMinor", a_callMinor);}
      else
        check_callMacro(dynamic_cast<callMacro *>(a_callMinor));
      return;
    }
  if (isA(a_callMinor, callModule))
    {
      if (!findString("callModule", callMinorSubs))
        {warnSub("callModule", "callMinor", a_callMinor);}
      else
        check_callModule(dynamic_cast<callModule *>(a_callMinor));
      return;
    }
  if (isA(a_callMinor, callRoutine))
    {
      if (!findString("callRoutine", callMinorSubs))
        {warnSub("callRoutine", "callMinor", a_callMinor);}
      else
        check_callRoutine(dynamic_cast<callRoutine *>(a_callMinor));
      return;
    }
  if (isA(a_callMinor, callProgram))
    {
      if (!findString("callProgram", callMinorSubs))
        {warnSub("callProgram", "callMinor", a_callMinor);}
      else
        check_callProgram(dynamic_cast<callProgram *>(a_callMinor));
      return;
    }
}

/********************************************************************/

void check_callModule(
 callModule * a_callModule)
{
  if (a_callModule->get_modId())
    {
      if (!findString("modId", callModuleAtts))
	{warnAtt("modId", "callModule", a_callModule);}
      else
        check_stringVal(a_callModule->get_modId());
    }
}

/********************************************************************/

void check_callProgram(
 callProgram * a_callProgram)
{
  if (a_callProgram->get_pathname())
    {
      if (!findString("pathname", callProgramAtts))
	{warnAtt("pathname", "callProgram", a_callProgram);}
      else
        check_stringVal(a_callProgram->get_pathname());
    }
  if (a_callProgram->get_callType())
    {
      if (!findString("a_callType", callProgramAtts))
	{warnAtt("a_callType", "callProgram", a_callProgram);}
      else
        check_callType(a_callProgram->get_callType());
    }
  if (a_callProgram->get_paramList())
    {
      if (!findString("a_paramList", callProgramAtts))
	{warnAtt("a_paramList", "callProgram", a_callProgram);}
      else
        {
          std::list<param *> * theList;
          std::list<param *>::iterator iter;
          theList = a_callProgram->get_paramList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_param(*iter);
        }
    }
}

/********************************************************************/

void check_callRoutine(
 callRoutine * a_callRoutine)
{
  if (a_callRoutine->get_routine())
    {
      if (!findString("routine", callRoutineAtts))
	{warnAtt("routine", "callRoutine", a_callRoutine);}
      else
        check_stringVal(a_callRoutine->get_routine());
    }
  if (a_callRoutine->get_callType())
    {
      if (!findString("a_callType", callRoutineAtts))
	{warnAtt("a_callType", "callRoutine", a_callRoutine);}
      else
        check_callType(a_callRoutine->get_callType());
    }
  if (a_callRoutine->get_paramList())
    {
      if (!findString("a_paramList", callRoutineAtts))
	{warnAtt("a_paramList", "callRoutine", a_callRoutine);}
      else
        {
          std::list<param *> * theList;
          std::list<param *>::iterator iter;
          theList = a_callRoutine->get_paramList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_param(*iter);
        }
    }
}

/********************************************************************/

void check_callStm(
 callStm * a_callStm)
{
  if (a_callStm->get_callMinor())
    {
      if (!findString("a_callMinor", callStmAtts))
	{warnAtt("a_callMinor", "callStm", a_callStm);}
      else
        check_callMinor(a_callStm->get_callMinor());
    }
}

/********************************************************************/

void check_callType(
 callType * a_callType)
{
  if (isA(a_callType, callType_WAIT))
    {
      if (!findString("callType_WAIT", callTypeSubs))
        {warnSub("callType_WAIT", "callType", a_callType);}
      return;
    }
  if (isA(a_callType, callType_CONT))
    {
      if (!findString("callType_CONT", callTypeSubs))
        {warnSub("callType_CONT", "callType", a_callType);}
      return;
    }
  if (isA(a_callType, callType_ATTACH))
    {
      if (!findString("callType_ATTACH", callTypeSubs))
        {warnSub("callType_ATTACH", "callType", a_callType);}
      return;
    }
}

/********************************************************************/

void check_cartPoint(
 cartPoint * a_cartPoint)
{
  if (a_cartPoint->get_x())
    {
      if (!findString("x", cartPointAtts))
	{warnAtt("x", "cartPoint", a_cartPoint);}
      else
        check_rentVal(a_cartPoint->get_x());
    }
  if (a_cartPoint->get_y())
    {
      if (!findString("y", cartPointAtts))
	{warnAtt("y", "cartPoint", a_cartPoint);}
      else
        check_rentVal(a_cartPoint->get_y());
    }
  if (a_cartPoint->get_z())
    {
      if (!findString("z", cartPointAtts))
	{warnAtt("z", "cartPoint", a_cartPoint);}
      else
        check_rentVal(a_cartPoint->get_z());
    }
}

/********************************************************************/

void check_caseBlock(
 caseBlock * a_caseBlock)
{
  if (a_caseBlock->get_caseList())
    {
      if (!findString("a_caseList", caseBlockAtts))
	{warnAttBlock("caseList", a_caseBlock->get_caseList()->front());}
      else
        {
          std::list<caseStm *> * theList;
          std::list<caseStm *>::iterator iter;
          theList = a_caseBlock->get_caseList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_caseStm(*iter);
        }
    }
  if (a_caseBlock->get_dmisItemList())
    {
      if (!findString("a_dmisItemList", caseBlockAtts))
	{warnAttBlock("dmisItemList", a_caseBlock->get_dmisItemList()->front());}
      else
        {
          std::list<dmisItem *> * theList;
          std::list<dmisItem *>::iterator iter;
          theList = a_caseBlock->get_dmisItemList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_dmisItem(*iter);
        }
    }
  if (a_caseBlock->get_endcasStm())
    {
      if (!findString("a_endcasStm", caseBlockAtts))
	{warnAttBlock("endcasStm", a_caseBlock->get_endcasStm());}
    }
}

/********************************************************************/

void check_caseStm(
 caseStm * a_caseStm)
{
  if (isA(a_caseStm, caseStmInt))
    {
      if (!findString("caseStmInt", caseStmSubs))
        {warnSub("caseStmInt", "caseStm", a_caseStm);}
      else
        check_caseStmInt(dynamic_cast<caseStmInt *>(a_caseStm));
      return;
    }
  if (isA(a_caseStm, caseStmString))
    {
      if (!findString("caseStmString", caseStmSubs))
        {warnSub("caseStmString", "caseStm", a_caseStm);}
      else
        check_caseStmString(dynamic_cast<caseStmString *>(a_caseStm));
      return;
    }
}

/********************************************************************/

void check_caseStmInt(
 caseStmInt * a_caseStmInt)
{
  if (a_caseStmInt->get_sign())
    {
      if (!findString("a_sign", caseStmIntAtts))
	{warnAtt("a_sign", "caseStmInt", a_caseStmInt);}
      else
        check_sign(a_caseStmInt->get_sign());
    }
  if (a_caseStmInt->get_intConst())
    {
      if (!findString("a_intConst", caseStmIntAtts))
	{warnAtt("a_intConst", "caseStmInt", a_caseStmInt);}
      else
        check_intConst(a_caseStmInt->get_intConst());
    }
}

/********************************************************************/

void check_caseStmString(
 caseStmString * a_caseStmString)
{
  if (a_caseStmString->get_stringConst())
    {
      if (!findString("a_stringConst", caseStmStringAtts))
	{warnAtt("a_stringConst", "caseStmString", a_caseStmString);}
      else
        check_stringConst(a_caseStmString->get_stringConst());
    }
}

/********************************************************************/

void check_ccLabel(
 ccLabel * a_ccLabel)
{
  if (a_ccLabel->get_labelName())
    {
      if (!findString("a_labelName", ccLabelAtts))
	{warnAtt("a_labelName", "ccLabel", a_ccLabel);}
      else
        check_labelName(a_ccLabel->get_labelName());
    }
}

/********************************************************************/

void check_ciLabel(
 ciLabel * a_ciLabel)
{
  if (a_ciLabel->get_labelName())
    {
      if (!findString("a_labelName", ciLabelAtts))
	{warnAtt("a_labelName", "ciLabel", a_ciLabel);}
      else
        check_labelName(a_ciLabel->get_labelName());
    }
}

/********************************************************************/

void check_clmpidStm(
 clmpidStm * a_clmpidStm)
{
  if (a_clmpidStm->get_ciLabel())
    {
      if (!findString("a_ciLabel", clmpidStmAtts))
	{warnAtt("a_ciLabel", "clmpidStm", a_clmpidStm);}
      else
        check_ciLabel(a_clmpidStm->get_ciLabel());
    }
  if (a_clmpidStm->get_text())
    {
      if (!findString("text", clmpidStmAtts))
	{warnAtt("text", "clmpidStm", a_clmpidStm);}
      else
        check_stringVal(a_clmpidStm->get_text());
    }
}

/********************************************************************/

void check_clmpsnStm(
 clmpsnStm * a_clmpsnStm)
{
  if (a_clmpsnStm->get_csLabel())
    {
      if (!findString("a_csLabel", clmpsnStmAtts))
	{warnAtt("a_csLabel", "clmpsnStm", a_clmpsnStm);}
      else
        check_csLabel(a_clmpsnStm->get_csLabel());
    }
  if (a_clmpsnStm->get_text())
    {
      if (!findString("text", clmpsnStmAtts))
	{warnAtt("text", "clmpsnStm", a_clmpsnStm);}
      else
        check_stringVal(a_clmpsnStm->get_text());
    }
}

/********************************************************************/

void check_closeDelete(
 closeDelete * a_closeDelete)
{
  if (a_closeDelete->get_didLabel())
    {
      if (!findString("a_didLabel", closeDeleteAtts))
	{warnAtt("a_didLabel", "closeDelete", a_closeDelete);}
      else
        check_didLabel(a_closeDelete->get_didLabel());
    }
}

/********************************************************************/

void check_closeEnd(
 closeEnd * a_closeEnd)
{
  if (a_closeEnd->get_didLabel())
    {
      if (!findString("a_didLabel", closeEndAtts))
	{warnAtt("a_didLabel", "closeEnd", a_closeEnd);}
      else
        check_didLabel(a_closeEnd->get_didLabel());
    }
}

/********************************************************************/

void check_closeKeep(
 closeKeep * a_closeKeep)
{
  if (a_closeKeep->get_didLabel())
    {
      if (!findString("a_didLabel", closeKeepAtts))
	{warnAtt("a_didLabel", "closeKeep", a_closeKeep);}
      else
        check_didLabel(a_closeKeep->get_didLabel());
    }
}

/********************************************************************/

void check_closeMinor(
 closeMinor * a_closeMinor)
{
  if (isA(a_closeMinor, closePlain))
    {
      if (!findString("closePlain", closeMinorSubs))
        {warnSub("closePlain", "closeMinor", a_closeMinor);}
      else
        check_closePlain(dynamic_cast<closePlain *>(a_closeMinor));
      return;
    }
  if (isA(a_closeMinor, closeKeep))
    {
      if (!findString("closeKeep", closeMinorSubs))
        {warnSub("closeKeep", "closeMinor", a_closeMinor);}
      else
        check_closeKeep(dynamic_cast<closeKeep *>(a_closeMinor));
      return;
    }
  if (isA(a_closeMinor, closeDelete))
    {
      if (!findString("closeDelete", closeMinorSubs))
        {warnSub("closeDelete", "closeMinor", a_closeMinor);}
      else
        check_closeDelete(dynamic_cast<closeDelete *>(a_closeMinor));
      return;
    }
  if (isA(a_closeMinor, closeEnd))
    {
      if (!findString("closeEnd", closeMinorSubs))
        {warnSub("closeEnd", "closeMinor", a_closeMinor);}
      else
        check_closeEnd(dynamic_cast<closeEnd *>(a_closeMinor));
      return;
    }
}

/********************************************************************/

void check_closePlain(
 closePlain * a_closePlain)
{
  if (a_closePlain->get_didLabel())
    {
      if (!findString("a_didLabel", closePlainAtts))
	{warnAtt("a_didLabel", "closePlain", a_closePlain);}
      else
        check_didLabel(a_closePlain->get_didLabel());
    }
}

/********************************************************************/

void check_closeStm(
 closeStm * a_closeStm)
{
  if (a_closeStm->get_closeMinor())
    {
      if (!findString("a_closeMinor", closeStmAtts))
	{warnAtt("a_closeMinor", "closeStm", a_closeStm);}
      else
        check_closeMinor(a_closeStm->get_closeMinor());
    }
}

/********************************************************************/

void check_cmpntgrpSpec(
 cmpntgrpSpec * a_cmpntgrpSpec)
{
  if (isA(a_cmpntgrpSpec, sgLabel))
    {
      if (!findString("sgLabel", cmpntgrpSpecSubs))
        {warnSub("sgLabel", "cmpntgrpSpec", a_cmpntgrpSpec);}
      else
        check_sgLabel(dynamic_cast<sgLabel *>(a_cmpntgrpSpec));
      return;
    }
  if (isA(a_cmpntgrpSpec, swLabel))
    {
      if (!findString("swLabel", cmpntgrpSpecSubs))
        {warnSub("swLabel", "cmpntgrpSpec", a_cmpntgrpSpec);}
      else
        check_swLabel(dynamic_cast<swLabel *>(a_cmpntgrpSpec));
      return;
    }
  if (isA(a_cmpntgrpSpec, sxLabel))
    {
      if (!findString("sxLabel", cmpntgrpSpecSubs))
        {warnSub("sxLabel", "cmpntgrpSpec", a_cmpntgrpSpec);}
      else
        check_sxLabel(dynamic_cast<sxLabel *>(a_cmpntgrpSpec));
      return;
    }
  if (isA(a_cmpntgrpSpec, rmLabel))
    {
      if (!findString("rmLabel", cmpntgrpSpecSubs))
        {warnSub("rmLabel", "cmpntgrpSpec", a_cmpntgrpSpec);}
      else
        check_rmLabel(dynamic_cast<rmLabel *>(a_cmpntgrpSpec));
      return;
    }
}

/********************************************************************/

void check_cmpntgrpStm(
 cmpntgrpStm * a_cmpntgrpStm)
{
  if (a_cmpntgrpStm->get_sgLabel())
    {
      if (!findString("a_sgLabel", cmpntgrpStmAtts))
	{warnAtt("a_sgLabel", "cmpntgrpStm", a_cmpntgrpStm);}
      else
        check_sgLabel(a_cmpntgrpStm->get_sgLabel());
    }
  if (a_cmpntgrpStm->get_cmpntgrpSpecList())
    {
      if (!findString("a_cmpntgrpSpecList", cmpntgrpStmAtts))
	{warnAtt("a_cmpntgrpSpecList", "cmpntgrpStm", a_cmpntgrpStm);}
      else
        {
          std::list<cmpntgrpSpec *> * theList;
          std::list<cmpntgrpSpec *>::iterator iter;
          theList = a_cmpntgrpStm->get_cmpntgrpSpecList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_cmpntgrpSpec(*iter);
        }
    }
}

/********************************************************************/

void check_cnfrmrulCode(
 cnfrmrulCode * a_cnfrmrulCode)
{
  if (a_cnfrmrulCode->get_code())
    {
      if (!findString("code", cnfrmrulCodeAtts))
	{warnAtt("code", "cnfrmrulCode", a_cnfrmrulCode);}
      else
        check_intVal(a_cnfrmrulCode->get_code());
    }
}

/********************************************************************/

void check_cnfrmrulMinor(
 cnfrmrulMinor * a_cnfrmrulMinor)
{
  if (isA(a_cnfrmrulMinor, cnfrmrulCode))
    {
      if (!findString("cnfrmrulCode", cnfrmrulMinorSubs))
        {warnSub("cnfrmrulCode", "cnfrmrulMinor", a_cnfrmrulMinor);}
      else
        check_cnfrmrulCode(dynamic_cast<cnfrmrulCode *>(a_cnfrmrulMinor));
      return;
    }
  if (isA(a_cnfrmrulMinor, cnfrmrulName))
    {
      if (!findString("cnfrmrulName", cnfrmrulMinorSubs))
        {warnSub("cnfrmrulName", "cnfrmrulMinor", a_cnfrmrulMinor);}
      else
        check_cnfrmrulName(dynamic_cast<cnfrmrulName *>(a_cnfrmrulMinor));
      return;
    }
}

/********************************************************************/

void check_cnfrmrulName(
 cnfrmrulName * a_cnfrmrulName)
{
  if (a_cnfrmrulName->get_name())
    {
      if (!findString("name", cnfrmrulNameAtts))
	{warnAtt("name", "cnfrmrulName", a_cnfrmrulName);}
      else
        check_stringVal(a_cnfrmrulName->get_name());
    }
  if (a_cnfrmrulName->get_paramList())
    {
      if (!findString("a_paramList", cnfrmrulNameAtts))
	{warnAtt("a_paramList", "cnfrmrulName", a_cnfrmrulName);}
      else
        {
          std::list<param *> * theList;
          std::list<param *>::iterator iter;
          theList = a_cnfrmrulName->get_paramList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_param(*iter);
        }
    }
}

/********************************************************************/

void check_cnfrmrulStm(
 cnfrmrulStm * a_cnfrmrulStm)
{
  if (a_cnfrmrulStm->get_drLabel())
    {
      if (!findString("a_drLabel", cnfrmrulStmAtts))
	{warnAtt("a_drLabel", "cnfrmrulStm", a_cnfrmrulStm);}
      else
        check_drLabel(a_cnfrmrulStm->get_drLabel());
    }
  if (a_cnfrmrulStm->get_cnfrmrulMinor())
    {
      if (!findString("a_cnfrmrulMinor", cnfrmrulStmAtts))
	{warnAtt("a_cnfrmrulMinor", "cnfrmrulStm", a_cnfrmrulStm);}
      else
        check_cnfrmrulMinor(a_cnfrmrulStm->get_cnfrmrulMinor());
    }
}

/********************************************************************/

void check_cogConst(
 cogConst * a_cogConst)
{
  if (a_cogConst->get_featureList())
    {
      if (!findString("a_featureList", cogConstAtts))
	{warnAtt("a_featureList", "cogConst", a_cogConst);}
      else
        {
          std::list<featureLabel *> * theList;
          std::list<featureLabel *>::iterator iter;
          theList = a_cogConst->get_featureList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_featureLabel(*iter);
        }
    }
}

/********************************************************************/

void check_coneConst(
 coneConst * a_coneConst)
{
  if (isA(a_coneConst, coneConst_DIAM))
    {
      if (!findString("coneConst_DIAM", coneConstSubs))
        {warnSub("coneConst_DIAM", "coneConst", a_coneConst);}
      else
        check_coneConst_DIAM(dynamic_cast<coneConst_DIAM *>(a_coneConst));
      return;
    }
  if (isA(a_coneConst, coneConst_DIST))
    {
      if (!findString("coneConst_DIST", coneConstSubs))
        {warnSub("coneConst_DIST", "coneConst", a_coneConst);}
      else
        check_coneConst_DIST(dynamic_cast<coneConst_DIST *>(a_coneConst));
      return;
    }
}

/********************************************************************/

void check_coneConst_DIAM(
 coneConst_DIAM * a_coneConst_DIAM)
{
  if (a_coneConst_DIAM->get_diam())
    {
      if (!findString("diam", coneConst_DIAMAtts))
	{warnAtt("diam", "coneConst_DIAM", a_coneConst_DIAM);}
      else
        check_rentVal(a_coneConst_DIAM->get_diam());
    }
  if (a_coneConst_DIAM->get_faLabel())
    {
      if (!findString("a_faLabel", coneConst_DIAMAtts))
	{warnAtt("a_faLabel", "coneConst_DIAM", a_coneConst_DIAM);}
      else
        check_faLabel(a_coneConst_DIAM->get_faLabel());
    }
}

/********************************************************************/

void check_coneConst_DIST(
 coneConst_DIST * a_coneConst_DIST)
{
  if (a_coneConst_DIST->get_dist())
    {
      if (!findString("dist", coneConst_DISTAtts))
	{warnAtt("dist", "coneConst_DIST", a_coneConst_DIST);}
      else
        check_rentVal(a_coneConst_DIST->get_dist());
    }
  if (a_coneConst_DIST->get_faLabel())
    {
      if (!findString("a_faLabel", coneConst_DISTAtts))
	{warnAtt("a_faLabel", "coneConst_DIST", a_coneConst_DIST);}
      else
        check_faLabel(a_coneConst_DIST->get_faLabel());
    }
}

/********************************************************************/

void check_conformItem(
 conformItem * a_conformItem)
{
  if (a_conformItem->get_conformType())
    {
      if (!findString("a_conformType", conformItemAtts))
	{warnAtt("a_conformType", "conformItem", a_conformItem);}
      else
        check_conformType(a_conformItem->get_conformType());
    }
  if (a_conformItem->get_int())
    {
      if (!findString("a_int", conformItemAtts))
	{warnAtt("a_int", "conformItem", a_conformItem);}
    }
}

/********************************************************************/

void check_conformType(
 conformType * a_conformType)
{
  if (isA(a_conformType, conformType_CT))
    {
      if (!findString("conformType_CT", conformTypeSubs))
        {warnSub("conformType_CT", "conformType", a_conformType);}
      return;
    }
  if (isA(a_conformType, conformType_FX))
    {
      if (!findString("conformType_FX", conformTypeSubs))
        {warnSub("conformType_FX", "conformType", a_conformType);}
      return;
    }
  if (isA(a_conformType, conformType_IP))
    {
      if (!findString("conformType_IP", conformTypeSubs))
        {warnSub("conformType_IP", "conformType", a_conformType);}
      return;
    }
  if (isA(a_conformType, conformType_MC))
    {
      if (!findString("conformType_MC", conformTypeSubs))
        {warnSub("conformType_MC", "conformType", a_conformType);}
      return;
    }
  if (isA(a_conformType, conformType_MU))
    {
      if (!findString("conformType_MU", conformTypeSubs))
        {warnSub("conformType_MU", "conformType", a_conformType);}
      return;
    }
  if (isA(a_conformType, conformType_PM))
    {
      if (!findString("conformType_PM", conformTypeSubs))
        {warnSub("conformType_PM", "conformType", a_conformType);}
      return;
    }
  if (isA(a_conformType, conformType_QI))
    {
      if (!findString("conformType_QI", conformTypeSubs))
        {warnSub("conformType_QI", "conformType", a_conformType);}
      return;
    }
  if (isA(a_conformType, conformType_RY))
    {
      if (!findString("conformType_RY", conformTypeSubs))
        {warnSub("conformType_RY", "conformType", a_conformType);}
      return;
    }
  if (isA(a_conformType, conformType_SF))
    {
      if (!findString("conformType_SF", conformTypeSubs))
        {warnSub("conformType_SF", "conformType", a_conformType);}
      return;
    }
  if (isA(a_conformType, conformType_TW))
    {
      if (!findString("conformType_TW", conformTypeSubs))
        {warnSub("conformType_TW", "conformType", a_conformType);}
      return;
    }
}

/********************************************************************/

void check_constArc(
 constArc * a_constArc)
{
  if (isA(a_constArc, constArc_bfConst))
    {
      if (!findString("constArc_bfConst", constArcSubs))
        {warnSub("constArc_bfConst", "constArc", a_constArc);}
      else
        check_constArc_bfConst(dynamic_cast<constArc_bfConst *>(a_constArc));
      return;
    }
  if (isA(a_constArc, constArc_projctConst))
    {
      if (!findString("constArc_projctConst", constArcSubs))
        {warnSub("constArc_projctConst", "constArc", a_constArc);}
      else
        check_constArc_projctConst(dynamic_cast<constArc_projctConst *>(a_constArc));
      return;
    }
  if (isA(a_constArc, constArc_trConst))
    {
      if (!findString("constArc_trConst", constArcSubs))
        {warnSub("constArc_trConst", "constArc", a_constArc);}
      else
        check_constArc_trConst(dynamic_cast<constArc_trConst *>(a_constArc));
      return;
    }
}

/********************************************************************/

void check_constArc_bfConst(
 constArc_bfConst * a_constArc_bfConst)
{
  if (a_constArc_bfConst->get_fLabel())
    {
      if (!findString("a_fLabel", constArc_bfConstAtts))
	{warnAtt("a_fLabel", "constArc_bfConst", a_constArc_bfConst);}
      else
        check_fLabel(a_constArc_bfConst->get_fLabel());
    }
  if (a_constArc_bfConst->get_bfConst())
    {
      if (!findString("a_bfConst", constArc_bfConstAtts))
	{warnAtt("a_bfConst", "constArc_bfConst", a_constArc_bfConst);}
      else
        check_bfConst(a_constArc_bfConst->get_bfConst());
    }
}

/********************************************************************/

void check_constArc_projctConst(
 constArc_projctConst * a_constArc_projctConst)
{
  if (a_constArc_projctConst->get_fLabel())
    {
      if (!findString("a_fLabel", constArc_projctConstAtts))
	{warnAtt("a_fLabel", "constArc_projctConst", a_constArc_projctConst);}
      else
        check_fLabel(a_constArc_projctConst->get_fLabel());
    }
  if (a_constArc_projctConst->get_projctConst())
    {
      if (!findString("a_projctConst", constArc_projctConstAtts))
	{warnAtt("a_projctConst", "constArc_projctConst", a_constArc_projctConst);}
      else
        check_projctConst(a_constArc_projctConst->get_projctConst());
    }
}

/********************************************************************/

void check_constArc_trConst(
 constArc_trConst * a_constArc_trConst)
{
  if (a_constArc_trConst->get_fLabel())
    {
      if (!findString("a_fLabel", constArc_trConstAtts))
	{warnAtt("a_fLabel", "constArc_trConst", a_constArc_trConst);}
      else
        check_fLabel(a_constArc_trConst->get_fLabel());
    }
  if (a_constArc_trConst->get_trConst())
    {
      if (!findString("a_trConst", constArc_trConstAtts))
	{warnAtt("a_trConst", "constArc_trConst", a_constArc_trConst);}
      else
        check_trConst(a_constArc_trConst->get_trConst());
    }
}

/********************************************************************/

void check_constCircle(
 constCircle * a_constCircle)
{
  if (isA(a_constCircle, constCircle_bfConst))
    {
      if (!findString("constCircle_bfConst", constCircleSubs))
        {warnSub("constCircle_bfConst", "constCircle", a_constCircle);}
      else
        check_constCircle_bfConst(dynamic_cast<constCircle_bfConst *>(a_constCircle));
      return;
    }
  if (isA(a_constCircle, constCircle_coneConst))
    {
      if (!findString("constCircle_coneConst", constCircleSubs))
        {warnSub("constCircle_coneConst", "constCircle", a_constCircle);}
      else
        check_constCircle_coneConst(dynamic_cast<constCircle_coneConst *>(a_constCircle));
      return;
    }
  if (isA(a_constCircle, constCircle_intofConst))
    {
      if (!findString("constCircle_intofConst", constCircleSubs))
        {warnSub("constCircle_intofConst", "constCircle", a_constCircle);}
      else
        check_constCircle_intofConst(dynamic_cast<constCircle_intofConst *>(a_constCircle));
      return;
    }
  if (isA(a_constCircle, constCircle_projctConst))
    {
      if (!findString("constCircle_projctConst", constCircleSubs))
        {warnSub("constCircle_projctConst", "constCircle", a_constCircle);}
      else
        check_constCircle_projctConst(dynamic_cast<constCircle_projctConst *>(a_constCircle));
      return;
    }
  if (isA(a_constCircle, constCircle_tantoConst))
    {
      if (!findString("constCircle_tantoConst", constCircleSubs))
        {warnSub("constCircle_tantoConst", "constCircle", a_constCircle);}
      else
        check_constCircle_tantoConst(dynamic_cast<constCircle_tantoConst *>(a_constCircle));
      return;
    }
  if (isA(a_constCircle, constCircle_trConst))
    {
      if (!findString("constCircle_trConst", constCircleSubs))
        {warnSub("constCircle_trConst", "constCircle", a_constCircle);}
      else
        check_constCircle_trConst(dynamic_cast<constCircle_trConst *>(a_constCircle));
      return;
    }
  if (isA(a_constCircle, constCircle_retrieve2))
    {
      if (!findString("constCircle_retrieve2", constCircleSubs))
        {warnSub("constCircle_retrieve2", "constCircle", a_constCircle);}
      else
        check_constCircle_retrieve2(dynamic_cast<constCircle_retrieve2 *>(a_constCircle));
      return;
    }
}

/********************************************************************/

void check_constCircle_bfConst(
 constCircle_bfConst * a_constCircle_bfConst)
{
  if (a_constCircle_bfConst->get_fLabel())
    {
      if (!findString("a_fLabel", constCircle_bfConstAtts))
	{warnAtt("a_fLabel", "constCircle_bfConst", a_constCircle_bfConst);}
      else
        check_fLabel(a_constCircle_bfConst->get_fLabel());
    }
  if (a_constCircle_bfConst->get_bfConst())
    {
      if (!findString("a_bfConst", constCircle_bfConstAtts))
	{warnAtt("a_bfConst", "constCircle_bfConst", a_constCircle_bfConst);}
      else
        check_bfConst(a_constCircle_bfConst->get_bfConst());
    }
}

/********************************************************************/

void check_constCircle_coneConst(
 constCircle_coneConst * a_constCircle_coneConst)
{
  if (a_constCircle_coneConst->get_fLabel())
    {
      if (!findString("a_fLabel", constCircle_coneConstAtts))
	{warnAtt("a_fLabel", "constCircle_coneConst", a_constCircle_coneConst);}
      else
        check_fLabel(a_constCircle_coneConst->get_fLabel());
    }
  if (a_constCircle_coneConst->get_coneConst())
    {
      if (!findString("a_coneConst", constCircle_coneConstAtts))
	{warnAtt("a_coneConst", "constCircle_coneConst", a_constCircle_coneConst);}
      else
        check_coneConst(a_constCircle_coneConst->get_coneConst());
    }
}

/********************************************************************/

void check_constCircle_intofConst(
 constCircle_intofConst * a_constCircle_intofConst)
{
  if (a_constCircle_intofConst->get_fLabel())
    {
      if (!findString("a_fLabel", constCircle_intofConstAtts))
	{warnAtt("a_fLabel", "constCircle_intofConst", a_constCircle_intofConst);}
      else
        check_fLabel(a_constCircle_intofConst->get_fLabel());
    }
  if (a_constCircle_intofConst->get_intofConst())
    {
      if (!findString("a_intofConst", constCircle_intofConstAtts))
	{warnAtt("a_intofConst", "constCircle_intofConst", a_constCircle_intofConst);}
      else
        check_intofConst(a_constCircle_intofConst->get_intofConst());
    }
}

/********************************************************************/

void check_constCircle_projctConst(
 constCircle_projctConst * a_constCircle_projctConst)
{
  if (a_constCircle_projctConst->get_fLabel())
    {
      if (!findString("a_fLabel", constCircle_projctConstAtts))
	{warnAtt("a_fLabel", "constCircle_projctConst", a_constCircle_projctConst);}
      else
        check_fLabel(a_constCircle_projctConst->get_fLabel());
    }
  if (a_constCircle_projctConst->get_projctConst())
    {
      if (!findString("a_projctConst", constCircle_projctConstAtts))
	{warnAtt("a_projctConst", "constCircle_projctConst", a_constCircle_projctConst);}
      else
        check_projctConst(a_constCircle_projctConst->get_projctConst());
    }
}

/********************************************************************/

void check_constCircle_retrieve2(
 constCircle_retrieve2 * a_constCircle_retrieve2)
{
  if (a_constCircle_retrieve2->get_fLabel())
    {
      if (!findString("a_fLabel", constCircle_retrieve2Atts))
	{warnAtt("a_fLabel", "constCircle_retrieve2", a_constCircle_retrieve2);}
      else
        check_fLabel(a_constCircle_retrieve2->get_fLabel());
    }
  if (a_constCircle_retrieve2->get_retrieve2())
    {
      if (!findString("a_retrieve2", constCircle_retrieve2Atts))
	{warnAtt("a_retrieve2", "constCircle_retrieve2", a_constCircle_retrieve2);}
      else
        check_retrieve2(a_constCircle_retrieve2->get_retrieve2());
    }
}

/********************************************************************/

void check_constCircle_tantoConst(
 constCircle_tantoConst * a_constCircle_tantoConst)
{
  if (a_constCircle_tantoConst->get_fLabel())
    {
      if (!findString("a_fLabel", constCircle_tantoConstAtts))
	{warnAtt("a_fLabel", "constCircle_tantoConst", a_constCircle_tantoConst);}
      else
        check_fLabel(a_constCircle_tantoConst->get_fLabel());
    }
  if (a_constCircle_tantoConst->get_tantoConst())
    {
      if (!findString("a_tantoConst", constCircle_tantoConstAtts))
	{warnAtt("a_tantoConst", "constCircle_tantoConst", a_constCircle_tantoConst);}
      else
        check_tantoConst(a_constCircle_tantoConst->get_tantoConst());
    }
}

/********************************************************************/

void check_constCircle_trConst(
 constCircle_trConst * a_constCircle_trConst)
{
  if (a_constCircle_trConst->get_fLabel())
    {
      if (!findString("a_fLabel", constCircle_trConstAtts))
	{warnAtt("a_fLabel", "constCircle_trConst", a_constCircle_trConst);}
      else
        check_fLabel(a_constCircle_trConst->get_fLabel());
    }
  if (a_constCircle_trConst->get_trConst())
    {
      if (!findString("a_trConst", constCircle_trConstAtts))
	{warnAtt("a_trConst", "constCircle_trConst", a_constCircle_trConst);}
      else
        check_trConst(a_constCircle_trConst->get_trConst());
    }
}

/********************************************************************/

void check_constCompound(
 constCompound * a_constCompound)
{
  if (a_constCompound->get_fLabel())
    {
      if (!findString("a_fLabel", constCompoundAtts))
	{warnAtt("a_fLabel", "constCompound", a_constCompound);}
      else
        check_fLabel(a_constCompound->get_fLabel());
    }
}

/********************************************************************/

void check_constCone(
 constCone * a_constCone)
{
  if (isA(a_constCone, constCone_bfConst))
    {
      if (!findString("constCone_bfConst", constConeSubs))
        {warnSub("constCone_bfConst", "constCone", a_constCone);}
      else
        check_constCone_bfConst(dynamic_cast<constCone_bfConst *>(a_constCone));
      return;
    }
  if (isA(a_constCone, constCone_trConst))
    {
      if (!findString("constCone_trConst", constConeSubs))
        {warnSub("constCone_trConst", "constCone", a_constCone);}
      else
        check_constCone_trConst(dynamic_cast<constCone_trConst *>(a_constCone));
      return;
    }
}

/********************************************************************/

void check_constCone_bfConst(
 constCone_bfConst * a_constCone_bfConst)
{
  if (a_constCone_bfConst->get_fLabel())
    {
      if (!findString("a_fLabel", constCone_bfConstAtts))
	{warnAtt("a_fLabel", "constCone_bfConst", a_constCone_bfConst);}
      else
        check_fLabel(a_constCone_bfConst->get_fLabel());
    }
  if (a_constCone_bfConst->get_bfConst())
    {
      if (!findString("a_bfConst", constCone_bfConstAtts))
	{warnAtt("a_bfConst", "constCone_bfConst", a_constCone_bfConst);}
      else
        check_bfConst(a_constCone_bfConst->get_bfConst());
    }
}

/********************************************************************/

void check_constCone_trConst(
 constCone_trConst * a_constCone_trConst)
{
  if (a_constCone_trConst->get_fLabel())
    {
      if (!findString("a_fLabel", constCone_trConstAtts))
	{warnAtt("a_fLabel", "constCone_trConst", a_constCone_trConst);}
      else
        check_fLabel(a_constCone_trConst->get_fLabel());
    }
  if (a_constCone_trConst->get_trConst())
    {
      if (!findString("a_trConst", constCone_trConstAtts))
	{warnAtt("a_trConst", "constCone_trConst", a_constCone_trConst);}
      else
        check_trConst(a_constCone_trConst->get_trConst());
    }
}

/********************************************************************/

void check_constCparln(
 constCparln * a_constCparln)
{
  if (isA(a_constCparln, constCparln_bfConst))
    {
      if (!findString("constCparln_bfConst", constCparlnSubs))
        {warnSub("constCparln_bfConst", "constCparln", a_constCparln);}
      else
        check_constCparln_bfConst(dynamic_cast<constCparln_bfConst *>(a_constCparln));
      return;
    }
  if (isA(a_constCparln, constCparln_projctConst))
    {
      if (!findString("constCparln_projctConst", constCparlnSubs))
        {warnSub("constCparln_projctConst", "constCparln", a_constCparln);}
      else
        check_constCparln_projctConst(dynamic_cast<constCparln_projctConst *>(a_constCparln));
      return;
    }
  if (isA(a_constCparln, constCparln_trConst))
    {
      if (!findString("constCparln_trConst", constCparlnSubs))
        {warnSub("constCparln_trConst", "constCparln", a_constCparln);}
      else
        check_constCparln_trConst(dynamic_cast<constCparln_trConst *>(a_constCparln));
      return;
    }
  if (isA(a_constCparln, constCparln_retrieve2))
    {
      if (!findString("constCparln_retrieve2", constCparlnSubs))
        {warnSub("constCparln_retrieve2", "constCparln", a_constCparln);}
      else
        check_constCparln_retrieve2(dynamic_cast<constCparln_retrieve2 *>(a_constCparln));
      return;
    }
}

/********************************************************************/

void check_constCparln_bfConst(
 constCparln_bfConst * a_constCparln_bfConst)
{
  if (a_constCparln_bfConst->get_fLabel())
    {
      if (!findString("a_fLabel", constCparln_bfConstAtts))
	{warnAtt("a_fLabel", "constCparln_bfConst", a_constCparln_bfConst);}
      else
        check_fLabel(a_constCparln_bfConst->get_fLabel());
    }
  if (a_constCparln_bfConst->get_bfConst())
    {
      if (!findString("a_bfConst", constCparln_bfConstAtts))
	{warnAtt("a_bfConst", "constCparln_bfConst", a_constCparln_bfConst);}
      else
        check_bfConst(a_constCparln_bfConst->get_bfConst());
    }
}

/********************************************************************/

void check_constCparln_projctConst(
 constCparln_projctConst * a_constCparln_projctConst)
{
  if (a_constCparln_projctConst->get_fLabel())
    {
      if (!findString("a_fLabel", constCparln_projctConstAtts))
	{warnAtt("a_fLabel", "constCparln_projctConst", a_constCparln_projctConst);}
      else
        check_fLabel(a_constCparln_projctConst->get_fLabel());
    }
  if (a_constCparln_projctConst->get_projctConst())
    {
      if (!findString("a_projctConst", constCparln_projctConstAtts))
	{warnAtt("a_projctConst", "constCparln_projctConst", a_constCparln_projctConst);}
      else
        check_projctConst(a_constCparln_projctConst->get_projctConst());
    }
}

/********************************************************************/

void check_constCparln_retrieve2(
 constCparln_retrieve2 * a_constCparln_retrieve2)
{
  if (a_constCparln_retrieve2->get_fLabel())
    {
      if (!findString("a_fLabel", constCparln_retrieve2Atts))
	{warnAtt("a_fLabel", "constCparln_retrieve2", a_constCparln_retrieve2);}
      else
        check_fLabel(a_constCparln_retrieve2->get_fLabel());
    }
  if (a_constCparln_retrieve2->get_retrieve2())
    {
      if (!findString("a_retrieve2", constCparln_retrieve2Atts))
	{warnAtt("a_retrieve2", "constCparln_retrieve2", a_constCparln_retrieve2);}
      else
        check_retrieve2(a_constCparln_retrieve2->get_retrieve2());
    }
}

/********************************************************************/

void check_constCparln_trConst(
 constCparln_trConst * a_constCparln_trConst)
{
  if (a_constCparln_trConst->get_fLabel())
    {
      if (!findString("a_fLabel", constCparln_trConstAtts))
	{warnAtt("a_fLabel", "constCparln_trConst", a_constCparln_trConst);}
      else
        check_fLabel(a_constCparln_trConst->get_fLabel());
    }
  if (a_constCparln_trConst->get_trConst())
    {
      if (!findString("a_trConst", constCparln_trConstAtts))
	{warnAtt("a_trConst", "constCparln_trConst", a_constCparln_trConst);}
      else
        check_trConst(a_constCparln_trConst->get_trConst());
    }
}

/********************************************************************/

void check_constCylndr(
 constCylndr * a_constCylndr)
{
  if (isA(a_constCylndr, constCylndr_bfConst))
    {
      if (!findString("constCylndr_bfConst", constCylndrSubs))
        {warnSub("constCylndr_bfConst", "constCylndr", a_constCylndr);}
      else
        check_constCylndr_bfConst(dynamic_cast<constCylndr_bfConst *>(a_constCylndr));
      return;
    }
  if (isA(a_constCylndr, constCylndr_trConst))
    {
      if (!findString("constCylndr_trConst", constCylndrSubs))
        {warnSub("constCylndr_trConst", "constCylndr", a_constCylndr);}
      else
        check_constCylndr_trConst(dynamic_cast<constCylndr_trConst *>(a_constCylndr));
      return;
    }
  if (isA(a_constCylndr, constCylndr_retrieve1))
    {
      if (!findString("constCylndr_retrieve1", constCylndrSubs))
        {warnSub("constCylndr_retrieve1", "constCylndr", a_constCylndr);}
      else
        check_constCylndr_retrieve1(dynamic_cast<constCylndr_retrieve1 *>(a_constCylndr));
      return;
    }
}

/********************************************************************/

void check_constCylndr_bfConst(
 constCylndr_bfConst * a_constCylndr_bfConst)
{
  if (a_constCylndr_bfConst->get_fLabel())
    {
      if (!findString("a_fLabel", constCylndr_bfConstAtts))
	{warnAtt("a_fLabel", "constCylndr_bfConst", a_constCylndr_bfConst);}
      else
        check_fLabel(a_constCylndr_bfConst->get_fLabel());
    }
  if (a_constCylndr_bfConst->get_bfConst())
    {
      if (!findString("a_bfConst", constCylndr_bfConstAtts))
	{warnAtt("a_bfConst", "constCylndr_bfConst", a_constCylndr_bfConst);}
      else
        check_bfConst(a_constCylndr_bfConst->get_bfConst());
    }
}

/********************************************************************/

void check_constCylndr_retrieve1(
 constCylndr_retrieve1 * a_constCylndr_retrieve1)
{
  if (a_constCylndr_retrieve1->get_fLabel())
    {
      if (!findString("a_fLabel", constCylndr_retrieve1Atts))
	{warnAtt("a_fLabel", "constCylndr_retrieve1", a_constCylndr_retrieve1);}
      else
        check_fLabel(a_constCylndr_retrieve1->get_fLabel());
    }
  if (a_constCylndr_retrieve1->get_retrieve1())
    {
      if (!findString("a_retrieve1", constCylndr_retrieve1Atts))
	{warnAtt("a_retrieve1", "constCylndr_retrieve1", a_constCylndr_retrieve1);}
      else
        check_retrieve1(a_constCylndr_retrieve1->get_retrieve1());
    }
}

/********************************************************************/

void check_constCylndr_trConst(
 constCylndr_trConst * a_constCylndr_trConst)
{
  if (a_constCylndr_trConst->get_fLabel())
    {
      if (!findString("a_fLabel", constCylndr_trConstAtts))
	{warnAtt("a_fLabel", "constCylndr_trConst", a_constCylndr_trConst);}
      else
        check_fLabel(a_constCylndr_trConst->get_fLabel());
    }
  if (a_constCylndr_trConst->get_trConst())
    {
      if (!findString("a_trConst", constCylndr_trConstAtts))
	{warnAtt("a_trConst", "constCylndr_trConst", a_constCylndr_trConst);}
      else
        check_trConst(a_constCylndr_trConst->get_trConst());
    }
}

/********************************************************************/

void check_constEdgept(
 constEdgept * a_constEdgept)
{
  if (a_constEdgept->get_fLabel())
    {
      if (!findString("a_fLabel", constEdgeptAtts))
	{warnAtt("a_fLabel", "constEdgept", a_constEdgept);}
      else
        check_fLabel(a_constEdgept->get_fLabel());
    }
  if (a_constEdgept->get_retrieve4())
    {
      if (!findString("a_retrieve4", constEdgeptAtts))
	{warnAtt("a_retrieve4", "constEdgept", a_constEdgept);}
      else
        check_retrieve4(a_constEdgept->get_retrieve4());
    }
}

/********************************************************************/

void check_constEllips(
 constEllips * a_constEllips)
{
  if (isA(a_constEllips, constEllips_bfConst))
    {
      if (!findString("constEllips_bfConst", constEllipsSubs))
        {warnSub("constEllips_bfConst", "constEllips", a_constEllips);}
      else
        check_constEllips_bfConst(dynamic_cast<constEllips_bfConst *>(a_constEllips));
      return;
    }
  if (isA(a_constEllips, constEllips_intofConst))
    {
      if (!findString("constEllips_intofConst", constEllipsSubs))
        {warnSub("constEllips_intofConst", "constEllips", a_constEllips);}
      else
        check_constEllips_intofConst(dynamic_cast<constEllips_intofConst *>(a_constEllips));
      return;
    }
  if (isA(a_constEllips, constEllips_projctConst))
    {
      if (!findString("constEllips_projctConst", constEllipsSubs))
        {warnSub("constEllips_projctConst", "constEllips", a_constEllips);}
      else
        check_constEllips_projctConst(dynamic_cast<constEllips_projctConst *>(a_constEllips));
      return;
    }
  if (isA(a_constEllips, constEllips_trConst))
    {
      if (!findString("constEllips_trConst", constEllipsSubs))
        {warnSub("constEllips_trConst", "constEllips", a_constEllips);}
      else
        check_constEllips_trConst(dynamic_cast<constEllips_trConst *>(a_constEllips));
      return;
    }
}

/********************************************************************/

void check_constEllips_bfConst(
 constEllips_bfConst * a_constEllips_bfConst)
{
  if (a_constEllips_bfConst->get_fLabel())
    {
      if (!findString("a_fLabel", constEllips_bfConstAtts))
	{warnAtt("a_fLabel", "constEllips_bfConst", a_constEllips_bfConst);}
      else
        check_fLabel(a_constEllips_bfConst->get_fLabel());
    }
  if (a_constEllips_bfConst->get_bfConst())
    {
      if (!findString("a_bfConst", constEllips_bfConstAtts))
	{warnAtt("a_bfConst", "constEllips_bfConst", a_constEllips_bfConst);}
      else
        check_bfConst(a_constEllips_bfConst->get_bfConst());
    }
}

/********************************************************************/

void check_constEllips_intofConst(
 constEllips_intofConst * a_constEllips_intofConst)
{
  if (a_constEllips_intofConst->get_fLabel())
    {
      if (!findString("a_fLabel", constEllips_intofConstAtts))
	{warnAtt("a_fLabel", "constEllips_intofConst", a_constEllips_intofConst);}
      else
        check_fLabel(a_constEllips_intofConst->get_fLabel());
    }
  if (a_constEllips_intofConst->get_intofConst())
    {
      if (!findString("a_intofConst", constEllips_intofConstAtts))
	{warnAtt("a_intofConst", "constEllips_intofConst", a_constEllips_intofConst);}
      else
        check_intofConst(a_constEllips_intofConst->get_intofConst());
    }
}

/********************************************************************/

void check_constEllips_projctConst(
 constEllips_projctConst * a_constEllips_projctConst)
{
  if (a_constEllips_projctConst->get_fLabel())
    {
      if (!findString("a_fLabel", constEllips_projctConstAtts))
	{warnAtt("a_fLabel", "constEllips_projctConst", a_constEllips_projctConst);}
      else
        check_fLabel(a_constEllips_projctConst->get_fLabel());
    }
  if (a_constEllips_projctConst->get_projctConst())
    {
      if (!findString("a_projctConst", constEllips_projctConstAtts))
	{warnAtt("a_projctConst", "constEllips_projctConst", a_constEllips_projctConst);}
      else
        check_projctConst(a_constEllips_projctConst->get_projctConst());
    }
}

/********************************************************************/

void check_constEllips_trConst(
 constEllips_trConst * a_constEllips_trConst)
{
  if (a_constEllips_trConst->get_fLabel())
    {
      if (!findString("a_fLabel", constEllips_trConstAtts))
	{warnAtt("a_fLabel", "constEllips_trConst", a_constEllips_trConst);}
      else
        check_fLabel(a_constEllips_trConst->get_fLabel());
    }
  if (a_constEllips_trConst->get_trConst())
    {
      if (!findString("a_trConst", constEllips_trConstAtts))
	{warnAtt("a_trConst", "constEllips_trConst", a_constEllips_trConst);}
      else
        check_trConst(a_constEllips_trConst->get_trConst());
    }
}

/********************************************************************/

void check_constGcurve(
 constGcurve * a_constGcurve)
{
  if (isA(a_constGcurve, constGcurve_bfConst))
    {
      if (!findString("constGcurve_bfConst", constGcurveSubs))
        {warnSub("constGcurve_bfConst", "constGcurve", a_constGcurve);}
      else
        check_constGcurve_bfConst(dynamic_cast<constGcurve_bfConst *>(a_constGcurve));
      return;
    }
  if (isA(a_constGcurve, constGcurve_projctConst))
    {
      if (!findString("constGcurve_projctConst", constGcurveSubs))
        {warnSub("constGcurve_projctConst", "constGcurve", a_constGcurve);}
      else
        check_constGcurve_projctConst(dynamic_cast<constGcurve_projctConst *>(a_constGcurve));
      return;
    }
  if (isA(a_constGcurve, constGcurve_trConst))
    {
      if (!findString("constGcurve_trConst", constGcurveSubs))
        {warnSub("constGcurve_trConst", "constGcurve", a_constGcurve);}
      else
        check_constGcurve_trConst(dynamic_cast<constGcurve_trConst *>(a_constGcurve));
      return;
    }
}

/********************************************************************/

void check_constGcurve_bfConst(
 constGcurve_bfConst * a_constGcurve_bfConst)
{
  if (a_constGcurve_bfConst->get_fLabel())
    {
      if (!findString("a_fLabel", constGcurve_bfConstAtts))
	{warnAtt("a_fLabel", "constGcurve_bfConst", a_constGcurve_bfConst);}
      else
        check_fLabel(a_constGcurve_bfConst->get_fLabel());
    }
  if (a_constGcurve_bfConst->get_bfConst())
    {
      if (!findString("a_bfConst", constGcurve_bfConstAtts))
	{warnAtt("a_bfConst", "constGcurve_bfConst", a_constGcurve_bfConst);}
      else
        check_bfConst(a_constGcurve_bfConst->get_bfConst());
    }
}

/********************************************************************/

void check_constGcurve_projctConst(
 constGcurve_projctConst * a_constGcurve_projctConst)
{
  if (a_constGcurve_projctConst->get_fLabel())
    {
      if (!findString("a_fLabel", constGcurve_projctConstAtts))
	{warnAtt("a_fLabel", "constGcurve_projctConst", a_constGcurve_projctConst);}
      else
        check_fLabel(a_constGcurve_projctConst->get_fLabel());
    }
  if (a_constGcurve_projctConst->get_projctConst())
    {
      if (!findString("a_projctConst", constGcurve_projctConstAtts))
	{warnAtt("a_projctConst", "constGcurve_projctConst", a_constGcurve_projctConst);}
      else
        check_projctConst(a_constGcurve_projctConst->get_projctConst());
    }
}

/********************************************************************/

void check_constGcurve_trConst(
 constGcurve_trConst * a_constGcurve_trConst)
{
  if (a_constGcurve_trConst->get_fLabel())
    {
      if (!findString("a_fLabel", constGcurve_trConstAtts))
	{warnAtt("a_fLabel", "constGcurve_trConst", a_constGcurve_trConst);}
      else
        check_fLabel(a_constGcurve_trConst->get_fLabel());
    }
  if (a_constGcurve_trConst->get_trConst())
    {
      if (!findString("a_trConst", constGcurve_trConstAtts))
	{warnAtt("a_trConst", "constGcurve_trConst", a_constGcurve_trConst);}
      else
        check_trConst(a_constGcurve_trConst->get_trConst());
    }
}

/********************************************************************/

void check_constGeom(
 constGeom * a_constGeom)
{
  if (a_constGeom->get_fLabel())
    {
      if (!findString("a_fLabel", constGeomAtts))
	{warnAtt("a_fLabel", "constGeom", a_constGeom);}
      else
        check_fLabel(a_constGeom->get_fLabel());
    }
  if (a_constGeom->get_nearptConst())
    {
      if (!findString("a_nearptConst", constGeomAtts))
	{warnAtt("a_nearptConst", "constGeom", a_constGeom);}
      else
        check_nearptConst(a_constGeom->get_nearptConst());
    }
}

/********************************************************************/

void check_constGsurf(
 constGsurf * a_constGsurf)
{
  if (isA(a_constGsurf, constGsurf_bfConst))
    {
      if (!findString("constGsurf_bfConst", constGsurfSubs))
        {warnSub("constGsurf_bfConst", "constGsurf", a_constGsurf);}
      else
        check_constGsurf_bfConst(dynamic_cast<constGsurf_bfConst *>(a_constGsurf));
      return;
    }
  if (isA(a_constGsurf, constGsurf_trConst))
    {
      if (!findString("constGsurf_trConst", constGsurfSubs))
        {warnSub("constGsurf_trConst", "constGsurf", a_constGsurf);}
      else
        check_constGsurf_trConst(dynamic_cast<constGsurf_trConst *>(a_constGsurf));
      return;
    }
}

/********************************************************************/

void check_constGsurf_bfConst(
 constGsurf_bfConst * a_constGsurf_bfConst)
{
  if (a_constGsurf_bfConst->get_fLabel())
    {
      if (!findString("a_fLabel", constGsurf_bfConstAtts))
	{warnAtt("a_fLabel", "constGsurf_bfConst", a_constGsurf_bfConst);}
      else
        check_fLabel(a_constGsurf_bfConst->get_fLabel());
    }
  if (a_constGsurf_bfConst->get_bfConst())
    {
      if (!findString("a_bfConst", constGsurf_bfConstAtts))
	{warnAtt("a_bfConst", "constGsurf_bfConst", a_constGsurf_bfConst);}
      else
        check_bfConst(a_constGsurf_bfConst->get_bfConst());
    }
}

/********************************************************************/

void check_constGsurf_trConst(
 constGsurf_trConst * a_constGsurf_trConst)
{
  if (a_constGsurf_trConst->get_fLabel())
    {
      if (!findString("a_fLabel", constGsurf_trConstAtts))
	{warnAtt("a_fLabel", "constGsurf_trConst", a_constGsurf_trConst);}
      else
        check_fLabel(a_constGsurf_trConst->get_fLabel());
    }
  if (a_constGsurf_trConst->get_trConst())
    {
      if (!findString("a_trConst", constGsurf_trConstAtts))
	{warnAtt("a_trConst", "constGsurf_trConst", a_constGsurf_trConst);}
      else
        check_trConst(a_constGsurf_trConst->get_trConst());
    }
}

/********************************************************************/

void check_constLine(
 constLine * a_constLine)
{
  if (isA(a_constLine, constLine_bfConst))
    {
      if (!findString("constLine_bfConst", constLineSubs))
        {warnSub("constLine_bfConst", "constLine", a_constLine);}
      else
        check_constLine_bfConst(dynamic_cast<constLine_bfConst *>(a_constLine));
      return;
    }
  if (isA(a_constLine, constLine_intofConst))
    {
      if (!findString("constLine_intofConst", constLineSubs))
        {warnSub("constLine_intofConst", "constLine", a_constLine);}
      else
        check_constLine_intofConst(dynamic_cast<constLine_intofConst *>(a_constLine));
      return;
    }
  if (isA(a_constLine, constLine_midliConst))
    {
      if (!findString("constLine_midliConst", constLineSubs))
        {warnSub("constLine_midliConst", "constLine", a_constLine);}
      else
        check_constLine_midliConst(dynamic_cast<constLine_midliConst *>(a_constLine));
      return;
    }
  if (isA(a_constLine, constLine_offsetConst))
    {
      if (!findString("constLine_offsetConst", constLineSubs))
        {warnSub("constLine_offsetConst", "constLine", a_constLine);}
      else
        check_constLine_offsetConst(dynamic_cast<constLine_offsetConst *>(a_constLine));
      return;
    }
  if (isA(a_constLine, constLine_partoConst))
    {
      if (!findString("constLine_partoConst", constLineSubs))
        {warnSub("constLine_partoConst", "constLine", a_constLine);}
      else
        check_constLine_partoConst(dynamic_cast<constLine_partoConst *>(a_constLine));
      return;
    }
  if (isA(a_constLine, constLine_perptoConst))
    {
      if (!findString("constLine_perptoConst", constLineSubs))
        {warnSub("constLine_perptoConst", "constLine", a_constLine);}
      else
        check_constLine_perptoConst(dynamic_cast<constLine_perptoConst *>(a_constLine));
      return;
    }
  if (isA(a_constLine, constLine_projliConst))
    {
      if (!findString("constLine_projliConst", constLineSubs))
        {warnSub("constLine_projliConst", "constLine", a_constLine);}
      else
        check_constLine_projliConst(dynamic_cast<constLine_projliConst *>(a_constLine));
      return;
    }
  if (isA(a_constLine, constLine_tantoConst))
    {
      if (!findString("constLine_tantoConst", constLineSubs))
        {warnSub("constLine_tantoConst", "constLine", a_constLine);}
      else
        check_constLine_tantoConst(dynamic_cast<constLine_tantoConst *>(a_constLine));
      return;
    }
  if (isA(a_constLine, constLine_trConst))
    {
      if (!findString("constLine_trConst", constLineSubs))
        {warnSub("constLine_trConst", "constLine", a_constLine);}
      else
        check_constLine_trConst(dynamic_cast<constLine_trConst *>(a_constLine));
      return;
    }
}

/********************************************************************/

void check_constLine_bfConst(
 constLine_bfConst * a_constLine_bfConst)
{
  if (a_constLine_bfConst->get_fLabel())
    {
      if (!findString("a_fLabel", constLine_bfConstAtts))
	{warnAtt("a_fLabel", "constLine_bfConst", a_constLine_bfConst);}
      else
        check_fLabel(a_constLine_bfConst->get_fLabel());
    }
  if (a_constLine_bfConst->get_bfConst())
    {
      if (!findString("a_bfConst", constLine_bfConstAtts))
	{warnAtt("a_bfConst", "constLine_bfConst", a_constLine_bfConst);}
      else
        check_bfConst(a_constLine_bfConst->get_bfConst());
    }
}

/********************************************************************/

void check_constLine_intofConst(
 constLine_intofConst * a_constLine_intofConst)
{
  if (a_constLine_intofConst->get_fLabel())
    {
      if (!findString("a_fLabel", constLine_intofConstAtts))
	{warnAtt("a_fLabel", "constLine_intofConst", a_constLine_intofConst);}
      else
        check_fLabel(a_constLine_intofConst->get_fLabel());
    }
  if (a_constLine_intofConst->get_intofConst())
    {
      if (!findString("a_intofConst", constLine_intofConstAtts))
	{warnAtt("a_intofConst", "constLine_intofConst", a_constLine_intofConst);}
      else
        check_intofConst(a_constLine_intofConst->get_intofConst());
    }
}

/********************************************************************/

void check_constLine_midliConst(
 constLine_midliConst * a_constLine_midliConst)
{
  if (a_constLine_midliConst->get_fLabel())
    {
      if (!findString("a_fLabel", constLine_midliConstAtts))
	{warnAtt("a_fLabel", "constLine_midliConst", a_constLine_midliConst);}
      else
        check_fLabel(a_constLine_midliConst->get_fLabel());
    }
  if (a_constLine_midliConst->get_midliConst())
    {
      if (!findString("a_midliConst", constLine_midliConstAtts))
	{warnAtt("a_midliConst", "constLine_midliConst", a_constLine_midliConst);}
      else
        check_midliConst(a_constLine_midliConst->get_midliConst());
    }
}

/********************************************************************/

void check_constLine_offsetConst(
 constLine_offsetConst * a_constLine_offsetConst)
{
  if (a_constLine_offsetConst->get_fLabel())
    {
      if (!findString("a_fLabel", constLine_offsetConstAtts))
	{warnAtt("a_fLabel", "constLine_offsetConst", a_constLine_offsetConst);}
      else
        check_fLabel(a_constLine_offsetConst->get_fLabel());
    }
  if (a_constLine_offsetConst->get_offsetConst())
    {
      if (!findString("a_offsetConst", constLine_offsetConstAtts))
	{warnAtt("a_offsetConst", "constLine_offsetConst", a_constLine_offsetConst);}
      else
        check_offsetConst(a_constLine_offsetConst->get_offsetConst());
    }
}

/********************************************************************/

void check_constLine_partoConst(
 constLine_partoConst * a_constLine_partoConst)
{
  if (a_constLine_partoConst->get_fLabel())
    {
      if (!findString("a_fLabel", constLine_partoConstAtts))
	{warnAtt("a_fLabel", "constLine_partoConst", a_constLine_partoConst);}
      else
        check_fLabel(a_constLine_partoConst->get_fLabel());
    }
  if (a_constLine_partoConst->get_partoConst())
    {
      if (!findString("a_partoConst", constLine_partoConstAtts))
	{warnAtt("a_partoConst", "constLine_partoConst", a_constLine_partoConst);}
      else
        check_partoConst(a_constLine_partoConst->get_partoConst());
    }
}

/********************************************************************/

void check_constLine_perptoConst(
 constLine_perptoConst * a_constLine_perptoConst)
{
  if (a_constLine_perptoConst->get_fLabel())
    {
      if (!findString("a_fLabel", constLine_perptoConstAtts))
	{warnAtt("a_fLabel", "constLine_perptoConst", a_constLine_perptoConst);}
      else
        check_fLabel(a_constLine_perptoConst->get_fLabel());
    }
  if (a_constLine_perptoConst->get_perptoConst())
    {
      if (!findString("a_perptoConst", constLine_perptoConstAtts))
	{warnAtt("a_perptoConst", "constLine_perptoConst", a_constLine_perptoConst);}
      else
        check_perptoConst(a_constLine_perptoConst->get_perptoConst());
    }
}

/********************************************************************/

void check_constLine_projliConst(
 constLine_projliConst * a_constLine_projliConst)
{
  if (a_constLine_projliConst->get_fLabel())
    {
      if (!findString("a_fLabel", constLine_projliConstAtts))
	{warnAtt("a_fLabel", "constLine_projliConst", a_constLine_projliConst);}
      else
        check_fLabel(a_constLine_projliConst->get_fLabel());
    }
  if (a_constLine_projliConst->get_projliConst())
    {
      if (!findString("a_projliConst", constLine_projliConstAtts))
	{warnAtt("a_projliConst", "constLine_projliConst", a_constLine_projliConst);}
      else
        check_projliConst(a_constLine_projliConst->get_projliConst());
    }
}

/********************************************************************/

void check_constLine_tantoConst(
 constLine_tantoConst * a_constLine_tantoConst)
{
  if (a_constLine_tantoConst->get_fLabel())
    {
      if (!findString("a_fLabel", constLine_tantoConstAtts))
	{warnAtt("a_fLabel", "constLine_tantoConst", a_constLine_tantoConst);}
      else
        check_fLabel(a_constLine_tantoConst->get_fLabel());
    }
  if (a_constLine_tantoConst->get_tantoConst())
    {
      if (!findString("a_tantoConst", constLine_tantoConstAtts))
	{warnAtt("a_tantoConst", "constLine_tantoConst", a_constLine_tantoConst);}
      else
        check_tantoConst(a_constLine_tantoConst->get_tantoConst());
    }
}

/********************************************************************/

void check_constLine_trConst(
 constLine_trConst * a_constLine_trConst)
{
  if (a_constLine_trConst->get_fLabel())
    {
      if (!findString("a_fLabel", constLine_trConstAtts))
	{warnAtt("a_fLabel", "constLine_trConst", a_constLine_trConst);}
      else
        check_fLabel(a_constLine_trConst->get_fLabel());
    }
  if (a_constLine_trConst->get_trConst())
    {
      if (!findString("a_trConst", constLine_trConstAtts))
	{warnAtt("a_trConst", "constLine_trConst", a_constLine_trConst);}
      else
        check_trConst(a_constLine_trConst->get_trConst());
    }
}

/********************************************************************/

void check_constMinor(
 constMinor * a_constMinor)
{
  if (isA(a_constMinor, constArc))
    {
      if (!findString("constArc", constMinorSubs))
        {warnSub("constArc", "constMinor", a_constMinor);}
      else
        check_constArc(dynamic_cast<constArc *>(a_constMinor));
      return;
    }
  if (isA(a_constMinor, constCircle))
    {
      if (!findString("constCircle", constMinorSubs))
        {warnSub("constCircle", "constMinor", a_constMinor);}
      else
        check_constCircle(dynamic_cast<constCircle *>(a_constMinor));
      return;
    }
  if (isA(a_constMinor, constCompound))
    {
      if (!findString("constCompound", constMinorSubs))
        {warnSub("constCompound", "constMinor", a_constMinor);}
      else
        check_constCompound(dynamic_cast<constCompound *>(a_constMinor));
      return;
    }
  if (isA(a_constMinor, constCone))
    {
      if (!findString("constCone", constMinorSubs))
        {warnSub("constCone", "constMinor", a_constMinor);}
      else
        check_constCone(dynamic_cast<constCone *>(a_constMinor));
      return;
    }
  if (isA(a_constMinor, constCylndr))
    {
      if (!findString("constCylndr", constMinorSubs))
        {warnSub("constCylndr", "constMinor", a_constMinor);}
      else
        check_constCylndr(dynamic_cast<constCylndr *>(a_constMinor));
      return;
    }
  if (isA(a_constMinor, constCparln))
    {
      if (!findString("constCparln", constMinorSubs))
        {warnSub("constCparln", "constMinor", a_constMinor);}
      else
        check_constCparln(dynamic_cast<constCparln *>(a_constMinor));
      return;
    }
  if (isA(a_constMinor, constEllips))
    {
      if (!findString("constEllips", constMinorSubs))
        {warnSub("constEllips", "constMinor", a_constMinor);}
      else
        check_constEllips(dynamic_cast<constEllips *>(a_constMinor));
      return;
    }
  if (isA(a_constMinor, constEdgept))
    {
      if (!findString("constEdgept", constMinorSubs))
        {warnSub("constEdgept", "constMinor", a_constMinor);}
      else
        check_constEdgept(dynamic_cast<constEdgept *>(a_constMinor));
      return;
    }
  if (isA(a_constMinor, constGeom))
    {
      if (!findString("constGeom", constMinorSubs))
        {warnSub("constGeom", "constMinor", a_constMinor);}
      else
        check_constGeom(dynamic_cast<constGeom *>(a_constMinor));
      return;
    }
  if (isA(a_constMinor, constGcurve))
    {
      if (!findString("constGcurve", constMinorSubs))
        {warnSub("constGcurve", "constMinor", a_constMinor);}
      else
        check_constGcurve(dynamic_cast<constGcurve *>(a_constMinor));
      return;
    }
  if (isA(a_constMinor, constGsurf))
    {
      if (!findString("constGsurf", constMinorSubs))
        {warnSub("constGsurf", "constMinor", a_constMinor);}
      else
        check_constGsurf(dynamic_cast<constGsurf *>(a_constMinor));
      return;
    }
  if (isA(a_constMinor, constLine))
    {
      if (!findString("constLine", constMinorSubs))
        {warnSub("constLine", "constMinor", a_constMinor);}
      else
        check_constLine(dynamic_cast<constLine *>(a_constMinor));
      return;
    }
  if (isA(a_constMinor, constParpln))
    {
      if (!findString("constParpln", constMinorSubs))
        {warnSub("constParpln", "constMinor", a_constMinor);}
      else
        check_constParpln(dynamic_cast<constParpln *>(a_constMinor));
      return;
    }
  if (isA(a_constMinor, constPatern))
    {
      if (!findString("constPatern", constMinorSubs))
        {warnSub("constPatern", "constMinor", a_constMinor);}
      else
        check_constPatern(dynamic_cast<constPatern *>(a_constMinor));
      return;
    }
  if (isA(a_constMinor, constPlane))
    {
      if (!findString("constPlane", constMinorSubs))
        {warnSub("constPlane", "constMinor", a_constMinor);}
      else
        check_constPlane(dynamic_cast<constPlane *>(a_constMinor));
      return;
    }
  if (isA(a_constMinor, constPoint))
    {
      if (!findString("constPoint", constMinorSubs))
        {warnSub("constPoint", "constMinor", a_constMinor);}
      else
        check_constPoint(dynamic_cast<constPoint *>(a_constMinor));
      return;
    }
  if (isA(a_constMinor, constRctngl))
    {
      if (!findString("constRctngl", constMinorSubs))
        {warnSub("constRctngl", "constMinor", a_constMinor);}
      else
        check_constRctngl(dynamic_cast<constRctngl *>(a_constMinor));
      return;
    }
  if (isA(a_constMinor, constSgage))
    {
      if (!findString("constSgage", constMinorSubs))
        {warnSub("constSgage", "constMinor", a_constMinor);}
      else
        check_constSgage(dynamic_cast<constSgage *>(a_constMinor));
      return;
    }
  if (isA(a_constMinor, constSpart))
    {
      if (!findString("constSpart", constMinorSubs))
        {warnSub("constSpart", "constMinor", a_constMinor);}
      else
        check_constSpart(dynamic_cast<constSpart *>(a_constMinor));
      return;
    }
  if (isA(a_constMinor, constSphere))
    {
      if (!findString("constSphere", constMinorSubs))
        {warnSub("constSphere", "constMinor", a_constMinor);}
      else
        check_constSphere(dynamic_cast<constSphere *>(a_constMinor));
      return;
    }
  if (isA(a_constMinor, constSympln))
    {
      if (!findString("constSympln", constMinorSubs))
        {warnSub("constSympln", "constMinor", a_constMinor);}
      else
        check_constSympln(dynamic_cast<constSympln *>(a_constMinor));
      return;
    }
  if (isA(a_constMinor, constTorus))
    {
      if (!findString("constTorus", constMinorSubs))
        {warnSub("constTorus", "constMinor", a_constMinor);}
      else
        check_constTorus(dynamic_cast<constTorus *>(a_constMinor));
      return;
    }
}

/********************************************************************/

void check_constParpln(
 constParpln * a_constParpln)
{
  if (a_constParpln->get_fLabel())
    {
      if (!findString("a_fLabel", constParplnAtts))
	{warnAtt("a_fLabel", "constParpln", a_constParpln);}
      else
        check_fLabel(a_constParpln->get_fLabel());
    }
  if (a_constParpln->get_bfConst())
    {
      if (!findString("a_bfConst", constParplnAtts))
	{warnAtt("a_bfConst", "constParpln", a_constParpln);}
      else
        check_bfConst(a_constParpln->get_bfConst());
    }
}

/********************************************************************/

void check_constPatern(
 constPatern * a_constPatern)
{
  if (isA(a_constPatern, constPatern_trConst))
    {
      if (!findString("constPatern_trConst", constPaternSubs))
        {warnSub("constPatern_trConst", "constPatern", a_constPatern);}
      else
        check_constPatern_trConst(dynamic_cast<constPatern_trConst *>(a_constPatern));
      return;
    }
  if (isA(a_constPatern, constPatern_BUILD))
    {
      if (!findString("constPatern_BUILD", constPaternSubs))
        {warnSub("constPatern_BUILD", "constPatern", a_constPatern);}
      else
        check_constPatern_BUILD(dynamic_cast<constPatern_BUILD *>(a_constPatern));
      return;
    }
}

/********************************************************************/

void check_constPatern_BUILD(
 constPatern_BUILD * a_constPatern_BUILD)
{
  if (a_constPatern_BUILD->get_fLabel())
    {
      if (!findString("a_fLabel", constPatern_BUILDAtts))
	{warnAtt("a_fLabel", "constPatern_BUILD", a_constPatern_BUILD);}
      else
        check_fLabel(a_constPatern_BUILD->get_fLabel());
    }
}

/********************************************************************/

void check_constPatern_trConst(
 constPatern_trConst * a_constPatern_trConst)
{
  if (a_constPatern_trConst->get_fLabel())
    {
      if (!findString("a_fLabel", constPatern_trConstAtts))
	{warnAtt("a_fLabel", "constPatern_trConst", a_constPatern_trConst);}
      else
        check_fLabel(a_constPatern_trConst->get_fLabel());
    }
  if (a_constPatern_trConst->get_trConst())
    {
      if (!findString("a_trConst", constPatern_trConstAtts))
	{warnAtt("a_trConst", "constPatern_trConst", a_constPatern_trConst);}
      else
        check_trConst(a_constPatern_trConst->get_trConst());
    }
}

/********************************************************************/

void check_constPlane(
 constPlane * a_constPlane)
{
  if (isA(a_constPlane, constPlane_bfConst))
    {
      if (!findString("constPlane_bfConst", constPlaneSubs))
        {warnSub("constPlane_bfConst", "constPlane", a_constPlane);}
      else
        check_constPlane_bfConst(dynamic_cast<constPlane_bfConst *>(a_constPlane));
      return;
    }
  if (isA(a_constPlane, constPlane_midplConst))
    {
      if (!findString("constPlane_midplConst", constPlaneSubs))
        {warnSub("constPlane_midplConst", "constPlane", a_constPlane);}
      else
        check_constPlane_midplConst(dynamic_cast<constPlane_midplConst *>(a_constPlane));
      return;
    }
  if (isA(a_constPlane, constPlane_offsetConst))
    {
      if (!findString("constPlane_offsetConst", constPlaneSubs))
        {warnSub("constPlane_offsetConst", "constPlane", a_constPlane);}
      else
        check_constPlane_offsetConst(dynamic_cast<constPlane_offsetConst *>(a_constPlane));
      return;
    }
  if (isA(a_constPlane, constPlane_partoConst))
    {
      if (!findString("constPlane_partoConst", constPlaneSubs))
        {warnSub("constPlane_partoConst", "constPlane", a_constPlane);}
      else
        check_constPlane_partoConst(dynamic_cast<constPlane_partoConst *>(a_constPlane));
      return;
    }
  if (isA(a_constPlane, constPlane_perptoConst))
    {
      if (!findString("constPlane_perptoConst", constPlaneSubs))
        {warnSub("constPlane_perptoConst", "constPlane", a_constPlane);}
      else
        check_constPlane_perptoConst(dynamic_cast<constPlane_perptoConst *>(a_constPlane));
      return;
    }
  if (isA(a_constPlane, constPlane_tantoConstPlane))
    {
      if (!findString("constPlane_tantoConstPlane", constPlaneSubs))
        {warnSub("constPlane_tantoConstPlane", "constPlane", a_constPlane);}
      else
        check_constPlane_tantoConstPlane(dynamic_cast<constPlane_tantoConstPlane *>(a_constPlane));
      return;
    }
  if (isA(a_constPlane, constPlane_trConst))
    {
      if (!findString("constPlane_trConst", constPlaneSubs))
        {warnSub("constPlane_trConst", "constPlane", a_constPlane);}
      else
        check_constPlane_trConst(dynamic_cast<constPlane_trConst *>(a_constPlane));
      return;
    }
}

/********************************************************************/

void check_constPlane_bfConst(
 constPlane_bfConst * a_constPlane_bfConst)
{
  if (a_constPlane_bfConst->get_fLabel())
    {
      if (!findString("a_fLabel", constPlane_bfConstAtts))
	{warnAtt("a_fLabel", "constPlane_bfConst", a_constPlane_bfConst);}
      else
        check_fLabel(a_constPlane_bfConst->get_fLabel());
    }
  if (a_constPlane_bfConst->get_bfConst())
    {
      if (!findString("a_bfConst", constPlane_bfConstAtts))
	{warnAtt("a_bfConst", "constPlane_bfConst", a_constPlane_bfConst);}
      else
        check_bfConst(a_constPlane_bfConst->get_bfConst());
    }
}

/********************************************************************/

void check_constPlane_midplConst(
 constPlane_midplConst * a_constPlane_midplConst)
{
  if (a_constPlane_midplConst->get_fLabel())
    {
      if (!findString("a_fLabel", constPlane_midplConstAtts))
	{warnAtt("a_fLabel", "constPlane_midplConst", a_constPlane_midplConst);}
      else
        check_fLabel(a_constPlane_midplConst->get_fLabel());
    }
  if (a_constPlane_midplConst->get_midplConst())
    {
      if (!findString("a_midplConst", constPlane_midplConstAtts))
	{warnAtt("a_midplConst", "constPlane_midplConst", a_constPlane_midplConst);}
      else
        check_midplConst(a_constPlane_midplConst->get_midplConst());
    }
}

/********************************************************************/

void check_constPlane_offsetConst(
 constPlane_offsetConst * a_constPlane_offsetConst)
{
  if (a_constPlane_offsetConst->get_fLabel())
    {
      if (!findString("a_fLabel", constPlane_offsetConstAtts))
	{warnAtt("a_fLabel", "constPlane_offsetConst", a_constPlane_offsetConst);}
      else
        check_fLabel(a_constPlane_offsetConst->get_fLabel());
    }
  if (a_constPlane_offsetConst->get_offsetConst())
    {
      if (!findString("a_offsetConst", constPlane_offsetConstAtts))
	{warnAtt("a_offsetConst", "constPlane_offsetConst", a_constPlane_offsetConst);}
      else
        check_offsetConst(a_constPlane_offsetConst->get_offsetConst());
    }
}

/********************************************************************/

void check_constPlane_partoConst(
 constPlane_partoConst * a_constPlane_partoConst)
{
  if (a_constPlane_partoConst->get_fLabel())
    {
      if (!findString("a_fLabel", constPlane_partoConstAtts))
	{warnAtt("a_fLabel", "constPlane_partoConst", a_constPlane_partoConst);}
      else
        check_fLabel(a_constPlane_partoConst->get_fLabel());
    }
  if (a_constPlane_partoConst->get_partoConst())
    {
      if (!findString("a_partoConst", constPlane_partoConstAtts))
	{warnAtt("a_partoConst", "constPlane_partoConst", a_constPlane_partoConst);}
      else
        check_partoConst(a_constPlane_partoConst->get_partoConst());
    }
}

/********************************************************************/

void check_constPlane_perptoConst(
 constPlane_perptoConst * a_constPlane_perptoConst)
{
  if (a_constPlane_perptoConst->get_fLabel())
    {
      if (!findString("a_fLabel", constPlane_perptoConstAtts))
	{warnAtt("a_fLabel", "constPlane_perptoConst", a_constPlane_perptoConst);}
      else
        check_fLabel(a_constPlane_perptoConst->get_fLabel());
    }
  if (a_constPlane_perptoConst->get_perptoConst())
    {
      if (!findString("a_perptoConst", constPlane_perptoConstAtts))
	{warnAtt("a_perptoConst", "constPlane_perptoConst", a_constPlane_perptoConst);}
      else
        check_perptoConst(a_constPlane_perptoConst->get_perptoConst());
    }
}

/********************************************************************/

void check_constPlane_tantoConstPlane(
 constPlane_tantoConstPlane * a_constPlane_tantoConstPlane)
{
  if (a_constPlane_tantoConstPlane->get_fLabel())
    {
      if (!findString("a_fLabel", constPlane_tantoConstPlaneAtts))
	{warnAtt("a_fLabel", "constPlane_tantoConstPlane", a_constPlane_tantoConstPlane);}
      else
        check_fLabel(a_constPlane_tantoConstPlane->get_fLabel());
    }
  if (a_constPlane_tantoConstPlane->get_tantoConstPlane())
    {
      if (!findString("a_tantoConstPlane", constPlane_tantoConstPlaneAtts))
	{warnAtt("a_tantoConstPlane", "constPlane_tantoConstPlane", a_constPlane_tantoConstPlane);}
      else
        check_tantoConstPlane(a_constPlane_tantoConstPlane->get_tantoConstPlane());
    }
}

/********************************************************************/

void check_constPlane_trConst(
 constPlane_trConst * a_constPlane_trConst)
{
  if (a_constPlane_trConst->get_fLabel())
    {
      if (!findString("a_fLabel", constPlane_trConstAtts))
	{warnAtt("a_fLabel", "constPlane_trConst", a_constPlane_trConst);}
      else
        check_fLabel(a_constPlane_trConst->get_fLabel());
    }
  if (a_constPlane_trConst->get_trConst())
    {
      if (!findString("a_trConst", constPlane_trConstAtts))
	{warnAtt("a_trConst", "constPlane_trConst", a_constPlane_trConst);}
      else
        check_trConst(a_constPlane_trConst->get_trConst());
    }
}

/********************************************************************/

void check_constPoint(
 constPoint * a_constPoint)
{
  if (isA(a_constPoint, constPoint_cogConst))
    {
      if (!findString("constPoint_cogConst", constPointSubs))
        {warnSub("constPoint_cogConst", "constPoint", a_constPoint);}
      else
        check_constPoint_cogConst(dynamic_cast<constPoint_cogConst *>(a_constPoint));
      return;
    }
  if (isA(a_constPoint, constPoint_curveConst))
    {
      if (!findString("constPoint_curveConst", constPointSubs))
        {warnSub("constPoint_curveConst", "constPoint", a_constPoint);}
      else
        check_constPoint_curveConst(dynamic_cast<constPoint_curveConst *>(a_constPoint));
      return;
    }
  if (isA(a_constPoint, constPoint_extremConst))
    {
      if (!findString("constPoint_extremConst", constPointSubs))
        {warnSub("constPoint_extremConst", "constPoint", a_constPoint);}
      else
        check_constPoint_extremConst(dynamic_cast<constPoint_extremConst *>(a_constPoint));
      return;
    }
  if (isA(a_constPoint, constPoint_intofConst))
    {
      if (!findString("constPoint_intofConst", constPointSubs))
        {warnSub("constPoint_intofConst", "constPoint", a_constPoint);}
      else
        check_constPoint_intofConst(dynamic_cast<constPoint_intofConst *>(a_constPoint));
      return;
    }
  if (isA(a_constPoint, constPoint_midptConst))
    {
      if (!findString("constPoint_midptConst", constPointSubs))
        {warnSub("constPoint_midptConst", "constPoint", a_constPoint);}
      else
        check_constPoint_midptConst(dynamic_cast<constPoint_midptConst *>(a_constPoint));
      return;
    }
  if (isA(a_constPoint, constPoint_moveptConst))
    {
      if (!findString("constPoint_moveptConst", constPointSubs))
        {warnSub("constPoint_moveptConst", "constPoint", a_constPoint);}
      else
        check_constPoint_moveptConst(dynamic_cast<constPoint_moveptConst *>(a_constPoint));
      return;
    }
  if (isA(a_constPoint, constPoint_pierceConst))
    {
      if (!findString("constPoint_pierceConst", constPointSubs))
        {warnSub("constPoint_pierceConst", "constPoint", a_constPoint);}
      else
        check_constPoint_pierceConst(dynamic_cast<constPoint_pierceConst *>(a_constPoint));
      return;
    }
  if (isA(a_constPoint, constPoint_projptConst))
    {
      if (!findString("constPoint_projptConst", constPointSubs))
        {warnSub("constPoint_projptConst", "constPoint", a_constPoint);}
      else
        check_constPoint_projptConst(dynamic_cast<constPoint_projptConst *>(a_constPoint));
      return;
    }
  if (isA(a_constPoint, constPoint_trConst))
    {
      if (!findString("constPoint_trConst", constPointSubs))
        {warnSub("constPoint_trConst", "constPoint", a_constPoint);}
      else
        check_constPoint_trConst(dynamic_cast<constPoint_trConst *>(a_constPoint));
      return;
    }
  if (isA(a_constPoint, constPoint_vertexConst))
    {
      if (!findString("constPoint_vertexConst", constPointSubs))
        {warnSub("constPoint_vertexConst", "constPoint", a_constPoint);}
      else
        check_constPoint_vertexConst(dynamic_cast<constPoint_vertexConst *>(a_constPoint));
      return;
    }
  if (isA(a_constPoint, constPoint_retrieve1))
    {
      if (!findString("constPoint_retrieve1", constPointSubs))
        {warnSub("constPoint_retrieve1", "constPoint", a_constPoint);}
      else
        check_constPoint_retrieve1(dynamic_cast<constPoint_retrieve1 *>(a_constPoint));
      return;
    }
}

/********************************************************************/

void check_constPoint_cogConst(
 constPoint_cogConst * a_constPoint_cogConst)
{
  if (a_constPoint_cogConst->get_fLabel())
    {
      if (!findString("a_fLabel", constPoint_cogConstAtts))
	{warnAtt("a_fLabel", "constPoint_cogConst", a_constPoint_cogConst);}
      else
        check_fLabel(a_constPoint_cogConst->get_fLabel());
    }
  if (a_constPoint_cogConst->get_cogConst())
    {
      if (!findString("a_cogConst", constPoint_cogConstAtts))
	{warnAtt("a_cogConst", "constPoint_cogConst", a_constPoint_cogConst);}
      else
        check_cogConst(a_constPoint_cogConst->get_cogConst());
    }
}

/********************************************************************/

void check_constPoint_curveConst(
 constPoint_curveConst * a_constPoint_curveConst)
{
  if (a_constPoint_curveConst->get_fLabel())
    {
      if (!findString("a_fLabel", constPoint_curveConstAtts))
	{warnAtt("a_fLabel", "constPoint_curveConst", a_constPoint_curveConst);}
      else
        check_fLabel(a_constPoint_curveConst->get_fLabel());
    }
  if (a_constPoint_curveConst->get_curveConst())
    {
      if (!findString("a_curveConst", constPoint_curveConstAtts))
	{warnAtt("a_curveConst", "constPoint_curveConst", a_constPoint_curveConst);}
      else
        check_curveConst(a_constPoint_curveConst->get_curveConst());
    }
}

/********************************************************************/

void check_constPoint_extremConst(
 constPoint_extremConst * a_constPoint_extremConst)
{
  if (a_constPoint_extremConst->get_fLabel())
    {
      if (!findString("a_fLabel", constPoint_extremConstAtts))
	{warnAtt("a_fLabel", "constPoint_extremConst", a_constPoint_extremConst);}
      else
        check_fLabel(a_constPoint_extremConst->get_fLabel());
    }
  if (a_constPoint_extremConst->get_extremConst())
    {
      if (!findString("a_extremConst", constPoint_extremConstAtts))
	{warnAtt("a_extremConst", "constPoint_extremConst", a_constPoint_extremConst);}
      else
        check_extremConst(a_constPoint_extremConst->get_extremConst());
    }
}

/********************************************************************/

void check_constPoint_intofConst(
 constPoint_intofConst * a_constPoint_intofConst)
{
  if (a_constPoint_intofConst->get_fLabel())
    {
      if (!findString("a_fLabel", constPoint_intofConstAtts))
	{warnAtt("a_fLabel", "constPoint_intofConst", a_constPoint_intofConst);}
      else
        check_fLabel(a_constPoint_intofConst->get_fLabel());
    }
  if (a_constPoint_intofConst->get_intofConst())
    {
      if (!findString("a_intofConst", constPoint_intofConstAtts))
	{warnAtt("a_intofConst", "constPoint_intofConst", a_constPoint_intofConst);}
      else
        check_intofConst(a_constPoint_intofConst->get_intofConst());
    }
}

/********************************************************************/

void check_constPoint_midptConst(
 constPoint_midptConst * a_constPoint_midptConst)
{
  if (a_constPoint_midptConst->get_fLabel())
    {
      if (!findString("a_fLabel", constPoint_midptConstAtts))
	{warnAtt("a_fLabel", "constPoint_midptConst", a_constPoint_midptConst);}
      else
        check_fLabel(a_constPoint_midptConst->get_fLabel());
    }
  if (a_constPoint_midptConst->get_midptConst())
    {
      if (!findString("a_midptConst", constPoint_midptConstAtts))
	{warnAtt("a_midptConst", "constPoint_midptConst", a_constPoint_midptConst);}
      else
        check_midptConst(a_constPoint_midptConst->get_midptConst());
    }
}

/********************************************************************/

void check_constPoint_moveptConst(
 constPoint_moveptConst * a_constPoint_moveptConst)
{
  if (a_constPoint_moveptConst->get_fLabel())
    {
      if (!findString("a_fLabel", constPoint_moveptConstAtts))
	{warnAtt("a_fLabel", "constPoint_moveptConst", a_constPoint_moveptConst);}
      else
        check_fLabel(a_constPoint_moveptConst->get_fLabel());
    }
  if (a_constPoint_moveptConst->get_moveptConst())
    {
      if (!findString("a_moveptConst", constPoint_moveptConstAtts))
	{warnAtt("a_moveptConst", "constPoint_moveptConst", a_constPoint_moveptConst);}
      else
        check_moveptConst(a_constPoint_moveptConst->get_moveptConst());
    }
}

/********************************************************************/

void check_constPoint_pierceConst(
 constPoint_pierceConst * a_constPoint_pierceConst)
{
  if (a_constPoint_pierceConst->get_fLabel())
    {
      if (!findString("a_fLabel", constPoint_pierceConstAtts))
	{warnAtt("a_fLabel", "constPoint_pierceConst", a_constPoint_pierceConst);}
      else
        check_fLabel(a_constPoint_pierceConst->get_fLabel());
    }
  if (a_constPoint_pierceConst->get_pierceConst())
    {
      if (!findString("a_pierceConst", constPoint_pierceConstAtts))
	{warnAtt("a_pierceConst", "constPoint_pierceConst", a_constPoint_pierceConst);}
      else
        check_pierceConst(a_constPoint_pierceConst->get_pierceConst());
    }
}

/********************************************************************/

void check_constPoint_projptConst(
 constPoint_projptConst * a_constPoint_projptConst)
{
  if (a_constPoint_projptConst->get_fLabel())
    {
      if (!findString("a_fLabel", constPoint_projptConstAtts))
	{warnAtt("a_fLabel", "constPoint_projptConst", a_constPoint_projptConst);}
      else
        check_fLabel(a_constPoint_projptConst->get_fLabel());
    }
  if (a_constPoint_projptConst->get_projptConst())
    {
      if (!findString("a_projptConst", constPoint_projptConstAtts))
	{warnAtt("a_projptConst", "constPoint_projptConst", a_constPoint_projptConst);}
      else
        check_projptConst(a_constPoint_projptConst->get_projptConst());
    }
}

/********************************************************************/

void check_constPoint_retrieve1(
 constPoint_retrieve1 * a_constPoint_retrieve1)
{
  if (a_constPoint_retrieve1->get_fLabel())
    {
      if (!findString("a_fLabel", constPoint_retrieve1Atts))
	{warnAtt("a_fLabel", "constPoint_retrieve1", a_constPoint_retrieve1);}
      else
        check_fLabel(a_constPoint_retrieve1->get_fLabel());
    }
  if (a_constPoint_retrieve1->get_retrieve1())
    {
      if (!findString("a_retrieve1", constPoint_retrieve1Atts))
	{warnAtt("a_retrieve1", "constPoint_retrieve1", a_constPoint_retrieve1);}
      else
        check_retrieve1(a_constPoint_retrieve1->get_retrieve1());
    }
}

/********************************************************************/

void check_constPoint_trConst(
 constPoint_trConst * a_constPoint_trConst)
{
  if (a_constPoint_trConst->get_fLabel())
    {
      if (!findString("a_fLabel", constPoint_trConstAtts))
	{warnAtt("a_fLabel", "constPoint_trConst", a_constPoint_trConst);}
      else
        check_fLabel(a_constPoint_trConst->get_fLabel());
    }
  if (a_constPoint_trConst->get_trConst())
    {
      if (!findString("a_trConst", constPoint_trConstAtts))
	{warnAtt("a_trConst", "constPoint_trConst", a_constPoint_trConst);}
      else
        check_trConst(a_constPoint_trConst->get_trConst());
    }
}

/********************************************************************/

void check_constPoint_vertexConst(
 constPoint_vertexConst * a_constPoint_vertexConst)
{
  if (a_constPoint_vertexConst->get_fLabel())
    {
      if (!findString("a_fLabel", constPoint_vertexConstAtts))
	{warnAtt("a_fLabel", "constPoint_vertexConst", a_constPoint_vertexConst);}
      else
        check_fLabel(a_constPoint_vertexConst->get_fLabel());
    }
  if (a_constPoint_vertexConst->get_vertexConst())
    {
      if (!findString("a_vertexConst", constPoint_vertexConstAtts))
	{warnAtt("a_vertexConst", "constPoint_vertexConst", a_constPoint_vertexConst);}
      else
        check_vertexConst(a_constPoint_vertexConst->get_vertexConst());
    }
}

/********************************************************************/

void check_constRctngl(
 constRctngl * a_constRctngl)
{
  if (isA(a_constRctngl, constRctngl_bfConst))
    {
      if (!findString("constRctngl_bfConst", constRctnglSubs))
        {warnSub("constRctngl_bfConst", "constRctngl", a_constRctngl);}
      else
        check_constRctngl_bfConst(dynamic_cast<constRctngl_bfConst *>(a_constRctngl));
      return;
    }
  if (isA(a_constRctngl, constRctngl_trConst))
    {
      if (!findString("constRctngl_trConst", constRctnglSubs))
        {warnSub("constRctngl_trConst", "constRctngl", a_constRctngl);}
      else
        check_constRctngl_trConst(dynamic_cast<constRctngl_trConst *>(a_constRctngl));
      return;
    }
}

/********************************************************************/

void check_constRctngl_bfConst(
 constRctngl_bfConst * a_constRctngl_bfConst)
{
  if (a_constRctngl_bfConst->get_fLabel())
    {
      if (!findString("a_fLabel", constRctngl_bfConstAtts))
	{warnAtt("a_fLabel", "constRctngl_bfConst", a_constRctngl_bfConst);}
      else
        check_fLabel(a_constRctngl_bfConst->get_fLabel());
    }
  if (a_constRctngl_bfConst->get_bfConst())
    {
      if (!findString("a_bfConst", constRctngl_bfConstAtts))
	{warnAtt("a_bfConst", "constRctngl_bfConst", a_constRctngl_bfConst);}
      else
        check_bfConst(a_constRctngl_bfConst->get_bfConst());
    }
}

/********************************************************************/

void check_constRctngl_trConst(
 constRctngl_trConst * a_constRctngl_trConst)
{
  if (a_constRctngl_trConst->get_fLabel())
    {
      if (!findString("a_fLabel", constRctngl_trConstAtts))
	{warnAtt("a_fLabel", "constRctngl_trConst", a_constRctngl_trConst);}
      else
        check_fLabel(a_constRctngl_trConst->get_fLabel());
    }
  if (a_constRctngl_trConst->get_trConst())
    {
      if (!findString("a_trConst", constRctngl_trConstAtts))
	{warnAtt("a_trConst", "constRctngl_trConst", a_constRctngl_trConst);}
      else
        check_trConst(a_constRctngl_trConst->get_trConst());
    }
}

/********************************************************************/

void check_constSgage(
 constSgage * a_constSgage)
{
  if (a_constSgage->get_seLabel())
    {
      if (!findString("a_seLabel", constSgageAtts))
	{warnAtt("a_seLabel", "constSgage", a_constSgage);}
      else
        check_seLabel(a_constSgage->get_seLabel());
    }
  if (a_constSgage->get_sgageConst())
    {
      if (!findString("a_sgageConst", constSgageAtts))
	{warnAtt("a_sgageConst", "constSgage", a_constSgage);}
      else
        check_sgageConst(a_constSgage->get_sgageConst());
    }
}

/********************************************************************/

void check_constSpart(
 constSpart * a_constSpart)
{
  if (a_constSpart->get_stLabel())
    {
      if (!findString("a_stLabel", constSpartAtts))
	{warnAtt("a_stLabel", "constSpart", a_constSpart);}
      else
        check_stLabel(a_constSpart->get_stLabel());
    }
  if (a_constSpart->get_spartConst())
    {
      if (!findString("a_spartConst", constSpartAtts))
	{warnAtt("a_spartConst", "constSpart", a_constSpart);}
      else
        check_spartConst(a_constSpart->get_spartConst());
    }
}

/********************************************************************/

void check_constSphere(
 constSphere * a_constSphere)
{
  if (isA(a_constSphere, constSphere_bfConst))
    {
      if (!findString("constSphere_bfConst", constSphereSubs))
        {warnSub("constSphere_bfConst", "constSphere", a_constSphere);}
      else
        check_constSphere_bfConst(dynamic_cast<constSphere_bfConst *>(a_constSphere));
      return;
    }
  if (isA(a_constSphere, constSphere_trConst))
    {
      if (!findString("constSphere_trConst", constSphereSubs))
        {warnSub("constSphere_trConst", "constSphere", a_constSphere);}
      else
        check_constSphere_trConst(dynamic_cast<constSphere_trConst *>(a_constSphere));
      return;
    }
  if (isA(a_constSphere, constSphere_retrieve2b))
    {
      if (!findString("constSphere_retrieve2b", constSphereSubs))
        {warnSub("constSphere_retrieve2b", "constSphere", a_constSphere);}
      else
        check_constSphere_retrieve2b(dynamic_cast<constSphere_retrieve2b *>(a_constSphere));
      return;
    }
}

/********************************************************************/

void check_constSphere_bfConst(
 constSphere_bfConst * a_constSphere_bfConst)
{
  if (a_constSphere_bfConst->get_fLabel())
    {
      if (!findString("a_fLabel", constSphere_bfConstAtts))
	{warnAtt("a_fLabel", "constSphere_bfConst", a_constSphere_bfConst);}
      else
        check_fLabel(a_constSphere_bfConst->get_fLabel());
    }
  if (a_constSphere_bfConst->get_bfConst())
    {
      if (!findString("a_bfConst", constSphere_bfConstAtts))
	{warnAtt("a_bfConst", "constSphere_bfConst", a_constSphere_bfConst);}
      else
        check_bfConst(a_constSphere_bfConst->get_bfConst());
    }
}

/********************************************************************/

void check_constSphere_retrieve2b(
 constSphere_retrieve2b * a_constSphere_retrieve2b)
{
  if (a_constSphere_retrieve2b->get_fLabel())
    {
      if (!findString("a_fLabel", constSphere_retrieve2bAtts))
	{warnAtt("a_fLabel", "constSphere_retrieve2b", a_constSphere_retrieve2b);}
      else
        check_fLabel(a_constSphere_retrieve2b->get_fLabel());
    }
  if (a_constSphere_retrieve2b->get_retrieve2b())
    {
      if (!findString("a_retrieve2b", constSphere_retrieve2bAtts))
	{warnAtt("a_retrieve2b", "constSphere_retrieve2b", a_constSphere_retrieve2b);}
      else
        check_retrieve2b(a_constSphere_retrieve2b->get_retrieve2b());
    }
}

/********************************************************************/

void check_constSphere_trConst(
 constSphere_trConst * a_constSphere_trConst)
{
  if (a_constSphere_trConst->get_fLabel())
    {
      if (!findString("a_fLabel", constSphere_trConstAtts))
	{warnAtt("a_fLabel", "constSphere_trConst", a_constSphere_trConst);}
      else
        check_fLabel(a_constSphere_trConst->get_fLabel());
    }
  if (a_constSphere_trConst->get_trConst())
    {
      if (!findString("a_trConst", constSphere_trConstAtts))
	{warnAtt("a_trConst", "constSphere_trConst", a_constSphere_trConst);}
      else
        check_trConst(a_constSphere_trConst->get_trConst());
    }
}

/********************************************************************/

void check_constStm(
 constStm * a_constStm)
{
  if (a_constStm->get_constMinor())
    {
      if (!findString("a_constMinor", constStmAtts))
	{warnAtt("a_constMinor", "constStm", a_constStm);}
      else
        check_constMinor(a_constStm->get_constMinor());
    }
}

/********************************************************************/

void check_constSympln(
 constSympln * a_constSympln)
{
  if (a_constSympln->get_fLabel())
    {
      if (!findString("a_fLabel", constSymplnAtts))
	{warnAtt("a_fLabel", "constSympln", a_constSympln);}
      else
        check_fLabel(a_constSympln->get_fLabel());
    }
  if (a_constSympln->get_bfConst())
    {
      if (!findString("a_bfConst", constSymplnAtts))
	{warnAtt("a_bfConst", "constSympln", a_constSympln);}
      else
        check_bfConst(a_constSympln->get_bfConst());
    }
}

/********************************************************************/

void check_constTorus(
 constTorus * a_constTorus)
{
  if (isA(a_constTorus, constTorus_bfConst))
    {
      if (!findString("constTorus_bfConst", constTorusSubs))
        {warnSub("constTorus_bfConst", "constTorus", a_constTorus);}
      else
        check_constTorus_bfConst(dynamic_cast<constTorus_bfConst *>(a_constTorus));
      return;
    }
  if (isA(a_constTorus, constTorus_trConst))
    {
      if (!findString("constTorus_trConst", constTorusSubs))
        {warnSub("constTorus_trConst", "constTorus", a_constTorus);}
      else
        check_constTorus_trConst(dynamic_cast<constTorus_trConst *>(a_constTorus));
      return;
    }
}

/********************************************************************/

void check_constTorus_bfConst(
 constTorus_bfConst * a_constTorus_bfConst)
{
  if (a_constTorus_bfConst->get_fLabel())
    {
      if (!findString("a_fLabel", constTorus_bfConstAtts))
	{warnAtt("a_fLabel", "constTorus_bfConst", a_constTorus_bfConst);}
      else
        check_fLabel(a_constTorus_bfConst->get_fLabel());
    }
  if (a_constTorus_bfConst->get_bfConst())
    {
      if (!findString("a_bfConst", constTorus_bfConstAtts))
	{warnAtt("a_bfConst", "constTorus_bfConst", a_constTorus_bfConst);}
      else
        check_bfConst(a_constTorus_bfConst->get_bfConst());
    }
}

/********************************************************************/

void check_constTorus_trConst(
 constTorus_trConst * a_constTorus_trConst)
{
  if (a_constTorus_trConst->get_fLabel())
    {
      if (!findString("a_fLabel", constTorus_trConstAtts))
	{warnAtt("a_fLabel", "constTorus_trConst", a_constTorus_trConst);}
      else
        check_fLabel(a_constTorus_trConst->get_fLabel());
    }
  if (a_constTorus_trConst->get_trConst())
    {
      if (!findString("a_trConst", constTorus_trConstAtts))
	{warnAtt("a_trConst", "constTorus_trConst", a_constTorus_trConst);}
      else
        check_trConst(a_constTorus_trConst->get_trConst());
    }
}

/********************************************************************/

void check_coordType(
 coordType * a_coordType)
{
  if (isA(a_coordType, coordType_CART))
    {
      if (!findString("coordType_CART", coordTypeSubs))
        {warnSub("coordType_CART", "coordType", a_coordType);}
      return;
    }
  if (isA(a_coordType, coordType_POL))
    {
      if (!findString("coordType_POL", coordTypeSubs))
        {warnSub("coordType_POL", "coordType", a_coordType);}
      return;
    }
}

/********************************************************************/

void check_crLabel(
 crLabel * a_crLabel)
{
  if (a_crLabel->get_labelName())
    {
      if (!findString("a_labelName", crLabelAtts))
	{warnAtt("a_labelName", "crLabel", a_crLabel);}
      else
        check_labelName(a_crLabel->get_labelName());
    }
}

/********************************************************************/

void check_crLabelConst(
 crLabelConst * a_crLabelConst)
{
  if (a_crLabelConst->get_labelNameConst())
    {
      if (!findString("a_labelNameConst", crLabelConstAtts))
	{warnAtt("a_labelNameConst", "crLabelConst", a_crLabelConst);}
      else
        check_labelNameConst(a_crLabelConst->get_labelNameConst());
    }
}

/********************************************************************/

void check_crgdefData(
 crgdefData * a_crgdefData)
{
  if (a_crgdefData->get_zoneMin())
    {
      if (!findString("zoneMin", crgdefDataAtts))
	{warnAtt("zoneMin", "crgdefData", a_crgdefData);}
      else
        check_impCartPoint(a_crgdefData->get_zoneMin());
    }
  if (a_crgdefData->get_zoneMax())
    {
      if (!findString("zoneMax", crgdefDataAtts))
	{warnAtt("zoneMax", "crgdefData", a_crgdefData);}
      else
        check_impCartPoint(a_crgdefData->get_zoneMax());
    }
  if (a_crgdefData->get_xVec())
    {
      if (!findString("xVec", crgdefDataAtts))
	{warnAtt("xVec", "crgdefData", a_crgdefData);}
      else
        check_vector(a_crgdefData->get_xVec());
    }
  if (a_crgdefData->get_yVec())
    {
      if (!findString("yVec", crgdefDataAtts))
	{warnAtt("yVec", "crgdefData", a_crgdefData);}
      else
        check_vector(a_crgdefData->get_yVec());
    }
  if (a_crgdefData->get_zVec())
    {
      if (!findString("zVec", crgdefDataAtts))
	{warnAtt("zVec", "crgdefData", a_crgdefData);}
      else
        check_vector(a_crgdefData->get_zVec());
    }
  if (a_crgdefData->get_aVec())
    {
      if (!findString("aVec", crgdefDataAtts))
	{warnAtt("aVec", "crgdefData", a_crgdefData);}
      else
        check_vector(a_crgdefData->get_aVec());
    }
}

/********************************************************************/

void check_crgdefMinor(
 crgdefMinor * a_crgdefMinor)
{
  if (isA(a_crgdefMinor, crgdefNoData))
    {
      if (!findString("crgdefNoData", crgdefMinorSubs))
        {warnSub("crgdefNoData", "crgdefMinor", a_crgdefMinor);}
      return;
    }
  if (isA(a_crgdefMinor, crgdefData))
    {
      if (!findString("crgdefData", crgdefMinorSubs))
        {warnSub("crgdefData", "crgdefMinor", a_crgdefMinor);}
      else
        check_crgdefData(dynamic_cast<crgdefData *>(a_crgdefMinor));
      return;
    }
}

/********************************************************************/

void check_crgdefStm(
 crgdefStm * a_crgdefStm)
{
  if (a_crgdefStm->get_crLabelConst())
    {
      if (!findString("a_crLabelConst", crgdefStmAtts))
	{warnAtt("a_crLabelConst", "crgdefStm", a_crgdefStm);}
      else
        check_crLabelConst(a_crgdefStm->get_crLabelConst());
    }
  if (a_crgdefStm->get_crgdefMinor())
    {
      if (!findString("a_crgdefMinor", crgdefStmAtts))
	{warnAtt("a_crgdefMinor", "crgdefStm", a_crgdefStm);}
      else
        check_crgdefMinor(a_crgdefStm->get_crgdefMinor());
    }
}

/********************************************************************/

void check_criticality(
 criticality * a_criticality)
{
  if (isA(a_criticality, criticality_CRITICAL))
    {
      if (!findString("criticality_CRITICAL", criticalitySubs))
        {warnSub("criticality_CRITICAL", "criticality", a_criticality);}
      return;
    }
  if (isA(a_criticality, criticality_MAJOR))
    {
      if (!findString("criticality_MAJOR", criticalitySubs))
        {warnSub("criticality_MAJOR", "criticality", a_criticality);}
      return;
    }
  if (isA(a_criticality, criticality_MINOR))
    {
      if (!findString("criticality_MINOR", criticalitySubs))
        {warnSub("criticality_MINOR", "criticality", a_criticality);}
      return;
    }
}

/********************************************************************/

void check_crmodeMinor(
 crmodeMinor * a_crmodeMinor)
{
  if (isA(a_crmodeMinor, crmodeMinor_SEQNTL))
    {
      if (!findString("crmodeMinor_SEQNTL", crmodeMinorSubs))
        {warnSub("crmodeMinor_SEQNTL", "crmodeMinor", a_crmodeMinor);}
      return;
    }
  if (isA(a_crmodeMinor, crmodeMinor_SIMUL))
    {
      if (!findString("crmodeMinor_SIMUL", crmodeMinorSubs))
        {warnSub("crmodeMinor_SIMUL", "crmodeMinor", a_crmodeMinor);}
      return;
    }
  if (isA(a_crmodeMinor, crmodeMinor_SYNC))
    {
      if (!findString("crmodeMinor_SYNC", crmodeMinorSubs))
        {warnSub("crmodeMinor_SYNC", "crmodeMinor", a_crmodeMinor);}
      return;
    }
}

/********************************************************************/

void check_crmodeStm(
 crmodeStm * a_crmodeStm)
{
  if (a_crmodeStm->get_crmodeMinor())
    {
      if (!findString("a_crmodeMinor", crmodeStmAtts))
	{warnAtt("a_crmodeMinor", "crmodeStm", a_crmodeStm);}
      else
        check_crmodeMinor(a_crmodeStm->get_crmodeMinor());
    }
}

/********************************************************************/

void check_crosclStm(
 crosclStm * a_crosclStm)
{
  if (a_crosclStm->get_state())
    {
      if (!findString("a_state", crosclStmAtts))
	{warnAtt("a_state", "crosclStm", a_crosclStm);}
      else
        check_state(a_crosclStm->get_state());
    }
}

/********************************************************************/

void check_crslctMinor(
 crslctMinor * a_crslctMinor)
{
  if (isA(a_crslctMinor, crslctMinor_crLabelConst))
    {
      if (!findString("crslctMinor_crLabelConst", crslctMinorSubs))
        {warnSub("crslctMinor_crLabelConst", "crslctMinor", a_crslctMinor);}
      else
        check_crslctMinor_crLabelConst(dynamic_cast<crslctMinor_crLabelConst *>(a_crslctMinor));
      return;
    }
  if (isA(a_crslctMinor, crslctMinor_ALL))
    {
      if (!findString("crslctMinor_ALL", crslctMinorSubs))
        {warnSub("crslctMinor_ALL", "crslctMinor", a_crslctMinor);}
      return;
    }
}

/********************************************************************/

void check_crslctMinor_crLabelConst(
 crslctMinor_crLabelConst * a_crslctMinor_crLabelConst)
{
  if (a_crslctMinor_crLabelConst->get_crLabelConst())
    {
      if (!findString("a_crLabelConst", crslctMinor_crLabelConstAtts))
	{warnAtt("a_crLabelConst", "crslctMinor_crLabelConst", a_crslctMinor_crLabelConst);}
      else
        check_crLabelConst(a_crslctMinor_crLabelConst->get_crLabelConst());
    }
}

/********************************************************************/

void check_crslctStm(
 crslctStm * a_crslctStm)
{
  if (a_crslctStm->get_crslctMinor())
    {
      if (!findString("a_crslctMinor", crslctStmAtts))
	{warnAtt("a_crslctMinor", "crslctStm", a_crslctStm);}
      else
        check_crslctMinor(a_crslctStm->get_crslctMinor());
    }
}

/********************************************************************/

void check_csLabel(
 csLabel * a_csLabel)
{
  if (a_csLabel->get_labelName())
    {
      if (!findString("a_labelName", csLabelAtts))
	{warnAtt("a_labelName", "csLabel", a_csLabel);}
      else
        check_labelName(a_csLabel->get_labelName());
    }
}

/********************************************************************/

void check_csSpec(
 csSpec * a_csSpec)
{
  if (isA(a_csSpec, csSpec_PCS))
    {
      if (!findString("csSpec_PCS", csSpecSubs))
        {warnSub("csSpec_PCS", "csSpec", a_csSpec);}
      else
        check_csSpec_PCS(dynamic_cast<csSpec_PCS *>(a_csSpec));
      return;
    }
  if (isA(a_csSpec, csSpec_HEADCS))
    {
      if (!findString("csSpec_HEADCS", csSpecSubs))
        {warnSub("csSpec_HEADCS", "csSpec", a_csSpec);}
      else
        check_csSpec_HEADCS(dynamic_cast<csSpec_HEADCS *>(a_csSpec));
      return;
    }
}

/********************************************************************/

void check_csSpec_HEADCS(
 csSpec_HEADCS * a_csSpec_HEADCS)
{
  if (a_csSpec_HEADCS->get_rot1())
    {
      if (!findString("rot1", csSpec_HEADCSAtts))
	{warnAtt("rot1", "csSpec_HEADCS", a_csSpec_HEADCS);}
      else
        check_rentVal(a_csSpec_HEADCS->get_rot1());
    }
  if (a_csSpec_HEADCS->get_rot2())
    {
      if (!findString("rot2", csSpec_HEADCSAtts))
	{warnAtt("rot2", "csSpec_HEADCS", a_csSpec_HEADCS);}
      else
        check_rentVal(a_csSpec_HEADCS->get_rot2());
    }
  if (a_csSpec_HEADCS->get_rot3())
    {
      if (!findString("rot3", csSpec_HEADCSAtts))
	{warnAtt("rot3", "csSpec_HEADCS", a_csSpec_HEADCS);}
      else
        check_rentVal(a_csSpec_HEADCS->get_rot3());
    }
}

/********************************************************************/

void check_csSpec_PCS(
 csSpec_PCS * a_csSpec_PCS)
{
  if (a_csSpec_PCS->get_euler())
    {
      if (!findString("a_euler", csSpec_PCSAtts))
	{warnAtt("a_euler", "csSpec_PCS", a_csSpec_PCS);}
      else
        check_euler(a_csSpec_PCS->get_euler());
    }
}

/********************************************************************/

void check_curveConst(
 curveConst * a_curveConst)
{
  if (a_curveConst->get_faLabel())
    {
      if (!findString("a_faLabel", curveConstAtts))
	{warnAtt("a_faLabel", "curveConst", a_curveConst);}
      else
        check_faLabel(a_curveConst->get_faLabel());
    }
  if (a_curveConst->get_featureLabel())
    {
      if (!findString("a_featureLabel", curveConstAtts))
	{warnAtt("a_featureLabel", "curveConst", a_curveConst);}
      else
        check_featureLabel(a_curveConst->get_featureLabel());
    }
}

/********************************************************************/

void check_curvePtdataHeadcs(
 curvePtdataHeadcs * a_curvePtdataHeadcs)
{
  if (a_curvePtdataHeadcs->get_pointVecCart())
    {
      if (!findString("a_pointVecCart", curvePtdataHeadcsAtts))
	{warnAtt("a_pointVecCart", "curvePtdataHeadcs", a_curvePtdataHeadcs);}
      else
        check_pointVecCart(a_curvePtdataHeadcs->get_pointVecCart());
    }
  if (a_curvePtdataHeadcs->get_rot1())
    {
      if (!findString("rot1", curvePtdataHeadcsAtts))
	{warnAtt("rot1", "curvePtdataHeadcs", a_curvePtdataHeadcs);}
      else
        check_rentVal(a_curvePtdataHeadcs->get_rot1());
    }
  if (a_curvePtdataHeadcs->get_rot2())
    {
      if (!findString("rot2", curvePtdataHeadcsAtts))
	{warnAtt("rot2", "curvePtdataHeadcs", a_curvePtdataHeadcs);}
      else
        check_rentVal(a_curvePtdataHeadcs->get_rot2());
    }
  if (a_curvePtdataHeadcs->get_rot3())
    {
      if (!findString("rot3", curvePtdataHeadcsAtts))
	{warnAtt("rot3", "curvePtdataHeadcs", a_curvePtdataHeadcs);}
      else
        check_rentVal(a_curvePtdataHeadcs->get_rot3());
    }
  if (a_curvePtdataHeadcs->get_curvePtdataHeadcsList())
    {
      if (!findString("a_curvePtdataHeadcsList", curvePtdataHeadcsAtts))
	{warnAtt("a_curvePtdataHeadcsList", "curvePtdataHeadcs", a_curvePtdataHeadcs);}
      else
        {
          std::list<curvePtdataHeadcsListItem *> * theList;
          std::list<curvePtdataHeadcsListItem *>::iterator iter;
          theList = a_curvePtdataHeadcs->get_curvePtdataHeadcsList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_curvePtdataHeadcsListItem(*iter);
        }
    }
}

/********************************************************************/

void check_curvePtdataHeadcsListItem(
 curvePtdataHeadcsListItem * a_curvePtdataHeadcsListItem)
{
  if (a_curvePtdataHeadcsListItem->get_pointVecCart())
    {
      if (!findString("a_pointVecCart", curvePtdataHeadcsListItemAtts))
	{warnAtt("a_pointVecCart", "curvePtdataHeadcsListItem", a_curvePtdataHeadcsListItem);}
      else
        check_pointVecCart(a_curvePtdataHeadcsListItem->get_pointVecCart());
    }
  if (a_curvePtdataHeadcsListItem->get_rot1())
    {
      if (!findString("rot1", curvePtdataHeadcsListItemAtts))
	{warnAtt("rot1", "curvePtdataHeadcsListItem", a_curvePtdataHeadcsListItem);}
      else
        check_rentVal(a_curvePtdataHeadcsListItem->get_rot1());
    }
  if (a_curvePtdataHeadcsListItem->get_rot2())
    {
      if (!findString("rot2", curvePtdataHeadcsListItemAtts))
	{warnAtt("rot2", "curvePtdataHeadcsListItem", a_curvePtdataHeadcsListItem);}
      else
        check_rentVal(a_curvePtdataHeadcsListItem->get_rot2());
    }
  if (a_curvePtdataHeadcsListItem->get_rot3())
    {
      if (!findString("rot3", curvePtdataHeadcsListItemAtts))
	{warnAtt("rot3", "curvePtdataHeadcsListItem", a_curvePtdataHeadcsListItem);}
      else
        check_rentVal(a_curvePtdataHeadcsListItem->get_rot3());
    }
}

/********************************************************************/

void check_curvePtdataPcs(
 curvePtdataPcs * a_curvePtdataPcs)
{
  if (a_curvePtdataPcs->get_pointVecCart())
    {
      if (!findString("a_pointVecCart", curvePtdataPcsAtts))
	{warnAtt("a_pointVecCart", "curvePtdataPcs", a_curvePtdataPcs);}
      else
        check_pointVecCart(a_curvePtdataPcs->get_pointVecCart());
    }
  if (a_curvePtdataPcs->get_euler())
    {
      if (!findString("a_euler", curvePtdataPcsAtts))
	{warnAtt("a_euler", "curvePtdataPcs", a_curvePtdataPcs);}
      else
        check_euler(a_curvePtdataPcs->get_euler());
    }
  if (a_curvePtdataPcs->get_curvePtdataPcsList())
    {
      if (!findString("a_curvePtdataPcsList", curvePtdataPcsAtts))
	{warnAtt("a_curvePtdataPcsList", "curvePtdataPcs", a_curvePtdataPcs);}
      else
        {
          std::list<curvePtdataPcsListItem *> * theList;
          std::list<curvePtdataPcsListItem *>::iterator iter;
          theList = a_curvePtdataPcs->get_curvePtdataPcsList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_curvePtdataPcsListItem(*iter);
        }
    }
}

/********************************************************************/

void check_curvePtdataPcsListItem(
 curvePtdataPcsListItem * a_curvePtdataPcsListItem)
{
  if (a_curvePtdataPcsListItem->get_pointVecCart())
    {
      if (!findString("a_pointVecCart", curvePtdataPcsListItemAtts))
	{warnAtt("a_pointVecCart", "curvePtdataPcsListItem", a_curvePtdataPcsListItem);}
      else
        check_pointVecCart(a_curvePtdataPcsListItem->get_pointVecCart());
    }
  if (a_curvePtdataPcsListItem->get_euler())
    {
      if (!findString("a_euler", curvePtdataPcsListItemAtts))
	{warnAtt("a_euler", "curvePtdataPcsListItem", a_curvePtdataPcsListItem);}
      else
        check_euler(a_curvePtdataPcsListItem->get_euler());
    }
}

/********************************************************************/

void check_cutcomAdjust(
 cutcomAdjust * a_cutcomAdjust)
{
  if (a_cutcomAdjust->get_mdLabel())
    {
      if (!findString("a_mdLabel", cutcomAdjustAtts))
	{warnAtt("a_mdLabel", "cutcomAdjust", a_cutcomAdjust);}
      else
        check_mdLabel(a_cutcomAdjust->get_mdLabel());
    }
  if (a_cutcomAdjust->get_tlLabel())
    {
      if (!findString("a_tlLabel", cutcomAdjustAtts))
	{warnAtt("a_tlLabel", "cutcomAdjust", a_cutcomAdjust);}
      else
        check_tlLabel(a_cutcomAdjust->get_tlLabel());
    }
  if (a_cutcomAdjust->get_leftRight())
    {
      if (!findString("a_leftRight", cutcomAdjustAtts))
	{warnAtt("a_leftRight", "cutcomAdjust", a_cutcomAdjust);}
      else
        check_leftRight(a_cutcomAdjust->get_leftRight());
    }
  if (a_cutcomAdjust->get_plan())
    {
      if (!findString("a_plan", cutcomAdjustAtts))
	{warnAtt("a_plan", "cutcomAdjust", a_cutcomAdjust);}
      else
        check_plan(a_cutcomAdjust->get_plan());
    }
  if (a_cutcomAdjust->get_amt())
    {
      if (!findString("amt", cutcomAdjustAtts))
	{warnAtt("amt", "cutcomAdjust", a_cutcomAdjust);}
      else
        check_rentVal(a_cutcomAdjust->get_amt());
    }
}

/********************************************************************/

void check_cutcomMatrix(
 cutcomMatrix * a_cutcomMatrix)
{
  if (a_cutcomMatrix->get_mdLabel())
    {
      if (!findString("a_mdLabel", cutcomMatrixAtts))
	{warnAtt("a_mdLabel", "cutcomMatrix", a_cutcomMatrix);}
      else
        check_mdLabel(a_cutcomMatrix->get_mdLabel());
    }
  if (a_cutcomMatrix->get_cutcomMatx())
    {
      if (!findString("a_cutcomMatx", cutcomMatrixAtts))
	{warnAtt("a_cutcomMatx", "cutcomMatrix", a_cutcomMatrix);}
      else
        check_cutcomMatx(a_cutcomMatrix->get_cutcomMatx());
    }
}

/********************************************************************/

void check_cutcomMatx(
 cutcomMatx * a_cutcomMatx)
{
  if (a_cutcomMatx->get_dx())
    {
      if (!findString("dx", cutcomMatxAtts))
	{warnAtt("dx", "cutcomMatx", a_cutcomMatx);}
      else
        check_rentVal(a_cutcomMatx->get_dx());
    }
  if (a_cutcomMatx->get_dy())
    {
      if (!findString("dy", cutcomMatxAtts))
	{warnAtt("dy", "cutcomMatx", a_cutcomMatx);}
      else
        check_rentVal(a_cutcomMatx->get_dy());
    }
  if (a_cutcomMatx->get_dz())
    {
      if (!findString("dz", cutcomMatxAtts))
	{warnAtt("dz", "cutcomMatx", a_cutcomMatx);}
      else
        check_rentVal(a_cutcomMatx->get_dz());
    }
  if (a_cutcomMatx->get_ix())
    {
      if (!findString("ix", cutcomMatxAtts))
	{warnAtt("ix", "cutcomMatx", a_cutcomMatx);}
      else
        check_rentVal(a_cutcomMatx->get_ix());
    }
  if (a_cutcomMatx->get_iy())
    {
      if (!findString("iy", cutcomMatxAtts))
	{warnAtt("iy", "cutcomMatx", a_cutcomMatx);}
      else
        check_rentVal(a_cutcomMatx->get_iy());
    }
  if (a_cutcomMatx->get_iz())
    {
      if (!findString("iz", cutcomMatxAtts))
	{warnAtt("iz", "cutcomMatx", a_cutcomMatx);}
      else
        check_rentVal(a_cutcomMatx->get_iz());
    }
  if (a_cutcomMatx->get_jx())
    {
      if (!findString("jx", cutcomMatxAtts))
	{warnAtt("jx", "cutcomMatx", a_cutcomMatx);}
      else
        check_rentVal(a_cutcomMatx->get_jx());
    }
  if (a_cutcomMatx->get_jy())
    {
      if (!findString("jy", cutcomMatxAtts))
	{warnAtt("jy", "cutcomMatx", a_cutcomMatx);}
      else
        check_rentVal(a_cutcomMatx->get_jy());
    }
  if (a_cutcomMatx->get_jz())
    {
      if (!findString("jz", cutcomMatxAtts))
	{warnAtt("jz", "cutcomMatx", a_cutcomMatx);}
      else
        check_rentVal(a_cutcomMatx->get_jz());
    }
  if (a_cutcomMatx->get_kx())
    {
      if (!findString("kx", cutcomMatxAtts))
	{warnAtt("kx", "cutcomMatx", a_cutcomMatx);}
      else
        check_rentVal(a_cutcomMatx->get_kx());
    }
  if (a_cutcomMatx->get_ky())
    {
      if (!findString("ky", cutcomMatxAtts))
	{warnAtt("ky", "cutcomMatx", a_cutcomMatx);}
      else
        check_rentVal(a_cutcomMatx->get_ky());
    }
  if (a_cutcomMatx->get_kz())
    {
      if (!findString("kz", cutcomMatxAtts))
	{warnAtt("kz", "cutcomMatx", a_cutcomMatx);}
      else
        check_rentVal(a_cutcomMatx->get_kz());
    }
}

/********************************************************************/

void check_cutcomMinor(
 cutcomMinor * a_cutcomMinor)
{
  if (isA(a_cutcomMinor, cutcomAdjust))
    {
      if (!findString("cutcomAdjust", cutcomMinorSubs))
        {warnSub("cutcomAdjust", "cutcomMinor", a_cutcomMinor);}
      else
        check_cutcomAdjust(dynamic_cast<cutcomAdjust *>(a_cutcomMinor));
      return;
    }
  if (isA(a_cutcomMinor, cutcomParam))
    {
      if (!findString("cutcomParam", cutcomMinorSubs))
        {warnSub("cutcomParam", "cutcomMinor", a_cutcomMinor);}
      else
        check_cutcomParam(dynamic_cast<cutcomParam *>(a_cutcomMinor));
      return;
    }
  if (isA(a_cutcomMinor, cutcomMatrix))
    {
      if (!findString("cutcomMatrix", cutcomMinorSubs))
        {warnSub("cutcomMatrix", "cutcomMinor", a_cutcomMinor);}
      else
        check_cutcomMatrix(dynamic_cast<cutcomMatrix *>(a_cutcomMinor));
      return;
    }
  if (isA(a_cutcomMinor, cutcomUserdf))
    {
      if (!findString("cutcomUserdf", cutcomMinorSubs))
        {warnSub("cutcomUserdf", "cutcomMinor", a_cutcomMinor);}
      else
        check_cutcomUserdf(dynamic_cast<cutcomUserdf *>(a_cutcomMinor));
      return;
    }
}

/********************************************************************/

void check_cutcomParam(
 cutcomParam * a_cutcomParam)
{
  if (a_cutcomParam->get_mdLabel())
    {
      if (!findString("a_mdLabel", cutcomParamAtts))
	{warnAtt("a_mdLabel", "cutcomParam", a_cutcomParam);}
      else
        check_mdLabel(a_cutcomParam->get_mdLabel());
    }
  if (a_cutcomParam->get_pointVecCart())
    {
      if (!findString("a_pointVecCart", cutcomParamAtts))
	{warnAtt("a_pointVecCart", "cutcomParam", a_cutcomParam);}
      else
        check_pointVecCart(a_cutcomParam->get_pointVecCart());
    }
}

/********************************************************************/

void check_cutcomStm(
 cutcomStm * a_cutcomStm)
{
  if (a_cutcomStm->get_ccLabel())
    {
      if (!findString("a_ccLabel", cutcomStmAtts))
	{warnAtt("a_ccLabel", "cutcomStm", a_cutcomStm);}
      else
        check_ccLabel(a_cutcomStm->get_ccLabel());
    }
  if (a_cutcomStm->get_cutcomMinor())
    {
      if (!findString("a_cutcomMinor", cutcomStmAtts))
	{warnAtt("a_cutcomMinor", "cutcomStm", a_cutcomStm);}
      else
        check_cutcomMinor(a_cutcomStm->get_cutcomMinor());
    }
}

/********************************************************************/

void check_cutcomUserdf(
 cutcomUserdf * a_cutcomUserdf)
{
  if (a_cutcomUserdf->get_mdLabel())
    {
      if (!findString("a_mdLabel", cutcomUserdfAtts))
	{warnAtt("a_mdLabel", "cutcomUserdf", a_cutcomUserdf);}
      else
        check_mdLabel(a_cutcomUserdf->get_mdLabel());
    }
  if (a_cutcomUserdf->get_text())
    {
      if (!findString("text", cutcomUserdfAtts))
	{warnAtt("text", "cutcomUserdf", a_cutcomUserdf);}
      else
        check_stringVal(a_cutcomUserdf->get_text());
    }
}

/********************************************************************/

void check_czLabel(
 czLabel * a_czLabel)
{
  if (a_czLabel->get_labelName())
    {
      if (!findString("a_labelName", czLabelAtts))
	{warnAtt("a_labelName", "czLabel", a_czLabel);}
      else
        check_labelName(a_czLabel->get_labelName());
    }
}

/********************************************************************/

void check_czoneStm(
 czoneStm * a_czoneStm)
{
  if (a_czoneStm->get_czLabel())
    {
      if (!findString("a_czLabel", czoneStmAtts))
	{warnAtt("a_czLabel", "czoneStm", a_czoneStm);}
      else
        check_czLabel(a_czoneStm->get_czLabel());
    }
}

/********************************************************************/

void check_czslctStm(
 czslctStm * a_czslctStm)
{
  if (a_czslctStm->get_czLabel())
    {
      if (!findString("a_czLabel", czslctStmAtts))
	{warnAtt("a_czLabel", "czslctStm", a_czslctStm);}
      else
        check_czLabel(a_czslctStm->get_czLabel());
    }
  if (a_czslctStm->get_state())
    {
      if (!findString("a_state", czslctStmAtts))
	{warnAtt("a_state", "czslctStm", a_czslctStm);}
      else
        check_state(a_czslctStm->get_state());
    }
}

/********************************************************************/

void check_dLabel(
 dLabel * a_dLabel)
{
  if (a_dLabel->get_labelName())
    {
      if (!findString("a_labelName", dLabelAtts))
	{warnAtt("a_labelName", "dLabel", a_dLabel);}
      else
        check_labelName(a_dLabel->get_labelName());
    }
}

/********************************************************************/

void check_daLabel(
 daLabel * a_daLabel)
{
  if (a_daLabel->get_labelName())
    {
      if (!findString("a_labelName", daLabelAtts))
	{warnAtt("a_labelName", "daLabel", a_daLabel);}
      else
        check_labelName(a_daLabel->get_labelName());
    }
}

/********************************************************************/

void check_datLabel(
 datLabel * a_datLabel)
{
  if (a_datLabel->get_labelName())
    {
      if (!findString("a_labelName", datLabelAtts))
	{warnAtt("a_labelName", "datLabel", a_datLabel);}
      else
        check_labelName(a_datLabel->get_labelName());
    }
}

/********************************************************************/

void check_datdefMinor(
 datdefMinor * a_datdefMinor)
{
  if (isA(a_datdefMinor, datdefMinor_featureLabel1))
    {
      if (!findString("datdefMinor_featureLabel1", datdefMinorSubs))
        {warnSub("datdefMinor_featureLabel1", "datdefMinor", a_datdefMinor);}
      else
        check_datdefMinor_featureLabel1(dynamic_cast<datdefMinor_featureLabel1 *>(a_datdefMinor));
      return;
    }
  if (isA(a_datdefMinor, datdefMinor_dattrgList))
    {
      if (!findString("datdefMinor_dattrgList", datdefMinorSubs))
        {warnSub("datdefMinor_dattrgList", "datdefMinor", a_datdefMinor);}
      else
        check_datdefMinor_dattrgList(dynamic_cast<datdefMinor_dattrgList *>(a_datdefMinor));
      return;
    }
}

/********************************************************************/

void check_datdefMinor_dattrgList(
 datdefMinor_dattrgList * a_datdefMinor_dattrgList)
{
  if (a_datdefMinor_dattrgList->get_dattrgList())
    {
      if (!findString("a_dattrgList", datdefMinor_dattrgListAtts))
	{warnAtt("a_dattrgList", "datdefMinor_dattrgList", a_datdefMinor_dattrgList);}
      else
        {
          std::list<dattrgLabel *> * theList;
          std::list<dattrgLabel *>::iterator iter;
          theList = a_datdefMinor_dattrgList->get_dattrgList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_dattrgLabel(*iter);
        }
    }
  if (a_datdefMinor_dattrgList->get_fLabel())
    {
      if (!findString("a_fLabel", datdefMinor_dattrgListAtts))
	{warnAtt("a_fLabel", "datdefMinor_dattrgList", a_datdefMinor_dattrgList);}
      else
        check_fLabel(a_datdefMinor_dattrgList->get_fLabel());
    }
  if (a_datdefMinor_dattrgList->get_datLabel())
    {
      if (!findString("a_datLabel", datdefMinor_dattrgListAtts))
	{warnAtt("a_datLabel", "datdefMinor_dattrgList", a_datdefMinor_dattrgList);}
      else
        check_datLabel(a_datdefMinor_dattrgList->get_datLabel());
    }
}

/********************************************************************/

void check_datdefMinor_featureLabel1(
 datdefMinor_featureLabel1 * a_datdefMinor_featureLabel1)
{
  if (a_datdefMinor_featureLabel1->get_featureLabel1())
    {
      if (!findString("a_featureLabel1", datdefMinor_featureLabel1Atts))
	{warnAtt("a_featureLabel1", "datdefMinor_featureLabel1", a_datdefMinor_featureLabel1);}
      else
        check_featureLabel1(a_datdefMinor_featureLabel1->get_featureLabel1());
    }
  if (a_datdefMinor_featureLabel1->get_datLabel())
    {
      if (!findString("a_datLabel", datdefMinor_featureLabel1Atts))
	{warnAtt("a_datLabel", "datdefMinor_featureLabel1", a_datdefMinor_featureLabel1);}
      else
        check_datLabel(a_datdefMinor_featureLabel1->get_datLabel());
    }
}

/********************************************************************/

void check_datdefStm(
 datdefStm * a_datdefStm)
{
  if (a_datdefStm->get_datdefMinor())
    {
      if (!findString("a_datdefMinor", datdefStmAtts))
	{warnAtt("a_datdefMinor", "datdefStm", a_datdefStm);}
      else
        check_datdefMinor(a_datdefStm->get_datdefMinor());
    }
}

/********************************************************************/

void check_datsetDats(
 datsetDats * a_datsetDats)
{
  if (a_datsetDats->get_spec1())
    {
      if (!findString("spec1", datsetDatsAtts))
	{warnAtt("spec1", "datsetDats", a_datsetDats);}
      else
        check_datsetSpec(a_datsetDats->get_spec1());
    }
  if (a_datsetDats->get_spec2())
    {
      if (!findString("spec2", datsetDatsAtts))
	{warnAtt("spec2", "datsetDats", a_datsetDats);}
      else
        check_datsetSpec(a_datsetDats->get_spec2());
    }
  if (a_datsetDats->get_spec3())
    {
      if (!findString("spec3", datsetDatsAtts))
	{warnAtt("spec3", "datsetDats", a_datsetDats);}
      else
        check_datsetSpec(a_datsetDats->get_spec3());
    }
}

/********************************************************************/

void check_datsetDrf(
 datsetDrf * a_datsetDrf)
{
  if (a_datsetDrf->get_taLabel())
    {
      if (!findString("a_taLabel", datsetDrfAtts))
	{warnAtt("a_taLabel", "datsetDrf", a_datsetDrf);}
      else
        check_taLabel(a_datsetDrf->get_taLabel());
    }
  if (a_datsetDrf->get_tier())
    {
      if (!findString("a_tier", datsetDrfAtts))
	{warnAtt("a_tier", "datsetDrf", a_datsetDrf);}
      else
        check_tier(a_datsetDrf->get_tier());
    }
  if (a_datsetDrf->get_dir1())
    {
      if (!findString("dir1", datsetDrfAtts))
	{warnAtt("dir1", "datsetDrf", a_datsetDrf);}
      else
        check_dir(a_datsetDrf->get_dir1());
    }
  if (a_datsetDrf->get_dir2())
    {
      if (!findString("dir2", datsetDrfAtts))
	{warnAtt("dir2", "datsetDrf", a_datsetDrf);}
      else
        check_dir(a_datsetDrf->get_dir2());
    }
}

/********************************************************************/

void check_datsetMatrix(
 datsetMatrix * a_datsetMatrix)
{
  if (a_datsetMatrix->get_matrix())
    {
      if (!findString("a_matrix", datsetMatrixAtts))
	{warnAtt("a_matrix", "datsetMatrix", a_datsetMatrix);}
      else
        check_matrix(a_datsetMatrix->get_matrix());
    }
}

/********************************************************************/

void check_datsetMinor(
 datsetMinor * a_datsetMinor)
{
  if (isA(a_datsetMinor, datsetMcs))
    {
      if (!findString("datsetMcs", datsetMinorSubs))
        {warnSub("datsetMcs", "datsetMinor", a_datsetMinor);}
      return;
    }
  if (isA(a_datsetMinor, datsetDats))
    {
      if (!findString("datsetDats", datsetMinorSubs))
        {warnSub("datsetDats", "datsetMinor", a_datsetMinor);}
      else
        check_datsetDats(dynamic_cast<datsetDats *>(a_datsetMinor));
      return;
    }
  if (isA(a_datsetMinor, datsetMatrix))
    {
      if (!findString("datsetMatrix", datsetMinorSubs))
        {warnSub("datsetMatrix", "datsetMinor", a_datsetMinor);}
      else
        check_datsetMatrix(dynamic_cast<datsetMatrix *>(a_datsetMinor));
      return;
    }
  if (isA(a_datsetMinor, datsetDrf))
    {
      if (!findString("datsetDrf", datsetMinorSubs))
        {warnSub("datsetDrf", "datsetMinor", a_datsetMinor);}
      else
        check_datsetDrf(dynamic_cast<datsetDrf *>(a_datsetMinor));
      return;
    }
}

/********************************************************************/

void check_datsetSpec(
 datsetSpec * a_datsetSpec)
{
  if (isA(a_datsetSpec, datsetSpecNoDir))
    {
      if (!findString("datsetSpecNoDir", datsetSpecSubs))
        {warnSub("datsetSpecNoDir", "datsetSpec", a_datsetSpec);}
      else
        check_datsetSpecNoDir(dynamic_cast<datsetSpecNoDir *>(a_datsetSpec));
      return;
    }
  if (isA(a_datsetSpec, datsetSpecDir))
    {
      if (!findString("datsetSpecDir", datsetSpecSubs))
        {warnSub("datsetSpecDir", "datsetSpec", a_datsetSpec);}
      else
        check_datsetSpecDir(dynamic_cast<datsetSpecDir *>(a_datsetSpec));
      return;
    }
}

/********************************************************************/

void check_datsetSpecDir(
 datsetSpecDir * a_datsetSpecDir)
{
  if (a_datsetSpecDir->get_datLabel())
    {
      if (!findString("a_datLabel", datsetSpecDirAtts))
	{warnAtt("a_datLabel", "datsetSpecDir", a_datsetSpecDir);}
      else
        check_datLabel(a_datsetSpecDir->get_datLabel());
    }
  if (a_datsetSpecDir->get_dir())
    {
      if (!findString("a_dir", datsetSpecDirAtts))
	{warnAtt("a_dir", "datsetSpecDir", a_datsetSpecDir);}
      else
        check_dir(a_datsetSpecDir->get_dir());
    }
  if (a_datsetSpecDir->get_orig1())
    {
      if (!findString("orig1", datsetSpecDirAtts))
	{warnAtt("orig1", "datsetSpecDir", a_datsetSpecDir);}
      else
        check_orig(a_datsetSpecDir->get_orig1());
    }
  if (a_datsetSpecDir->get_orig2())
    {
      if (!findString("orig2", datsetSpecDirAtts))
	{warnAtt("orig2", "datsetSpecDir", a_datsetSpecDir);}
      else
        check_orig(a_datsetSpecDir->get_orig2());
    }
  if (a_datsetSpecDir->get_orig3())
    {
      if (!findString("orig3", datsetSpecDirAtts))
	{warnAtt("orig3", "datsetSpecDir", a_datsetSpecDir);}
      else
        check_orig(a_datsetSpecDir->get_orig3());
    }
}

/********************************************************************/

void check_datsetSpecNoDir(
 datsetSpecNoDir * a_datsetSpecNoDir)
{
  if (a_datsetSpecNoDir->get_datLabel())
    {
      if (!findString("a_datLabel", datsetSpecNoDirAtts))
	{warnAtt("a_datLabel", "datsetSpecNoDir", a_datsetSpecNoDir);}
      else
        check_datLabel(a_datsetSpecNoDir->get_datLabel());
    }
  if (a_datsetSpecNoDir->get_orig1())
    {
      if (!findString("orig1", datsetSpecNoDirAtts))
	{warnAtt("orig1", "datsetSpecNoDir", a_datsetSpecNoDir);}
      else
        check_orig(a_datsetSpecNoDir->get_orig1());
    }
  if (a_datsetSpecNoDir->get_orig2())
    {
      if (!findString("orig2", datsetSpecNoDirAtts))
	{warnAtt("orig2", "datsetSpecNoDir", a_datsetSpecNoDir);}
      else
        check_orig(a_datsetSpecNoDir->get_orig2());
    }
  if (a_datsetSpecNoDir->get_orig3())
    {
      if (!findString("orig3", datsetSpecNoDirAtts))
	{warnAtt("orig3", "datsetSpecNoDir", a_datsetSpecNoDir);}
      else
        check_orig(a_datsetSpecNoDir->get_orig3());
    }
}

/********************************************************************/

void check_datsetStm(
 datsetStm * a_datsetStm)
{
  if (a_datsetStm->get_dLabel())
    {
      if (!findString("a_dLabel", datsetStmAtts))
	{warnAtt("a_dLabel", "datsetStm", a_datsetStm);}
      else
        check_dLabel(a_datsetStm->get_dLabel());
    }
  if (a_datsetStm->get_datsetMinor())
    {
      if (!findString("a_datsetMinor", datsetStmAtts))
	{warnAtt("a_datsetMinor", "datsetStm", a_datsetStm);}
      else
        check_datsetMinor(a_datsetStm->get_datsetMinor());
    }
}

/********************************************************************/

void check_dattrgLabel(
 dattrgLabel * a_dattrgLabel)
{
  if (a_dattrgLabel->get_labelName())
    {
      if (!findString("a_labelName", dattrgLabelAtts))
	{warnAtt("a_labelName", "dattrgLabel", a_dattrgLabel);}
      else
        check_labelName(a_dattrgLabel->get_labelName());
    }
}

/********************************************************************/

void check_dattrgMinor(
 dattrgMinor * a_dattrgMinor)
{
  if (a_dattrgMinor->get_featureList())
    {
      if (!findString("a_featureList", dattrgMinorAtts))
	{warnAtt("a_featureList", "dattrgMinor", a_dattrgMinor);}
      else
        {
          std::list<featureLabel *> * theList;
          std::list<featureLabel *>::iterator iter;
          theList = a_dattrgMinor->get_featureList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_featureLabel(*iter);
        }
    }
  if (a_dattrgMinor->get_dattrgLabel())
    {
      if (!findString("a_dattrgLabel", dattrgMinorAtts))
	{warnAtt("a_dattrgLabel", "dattrgMinor", a_dattrgMinor);}
      else
        check_dattrgLabel(a_dattrgMinor->get_dattrgLabel());
    }
}

/********************************************************************/

void check_dattrgdefStm(
 dattrgdefStm * a_dattrgdefStm)
{
  if (a_dattrgdefStm->get_dattrgMinor())
    {
      if (!findString("a_dattrgMinor", dattrgdefStmAtts))
	{warnAtt("a_dattrgMinor", "dattrgdefStm", a_dattrgdefStm);}
      else
        check_dattrgMinor(a_dattrgdefStm->get_dattrgMinor());
    }
}

/********************************************************************/

void check_datumLabel(
 datumLabel * a_datumLabel)
{
  if (isA(a_datumLabel, dLabel))
    {
      if (!findString("dLabel", datumLabelSubs))
        {warnSub("dLabel", "datumLabel", a_datumLabel);}
      else
        check_dLabel(dynamic_cast<dLabel *>(a_datumLabel));
      return;
    }
  if (isA(a_datumLabel, daLabel))
    {
      if (!findString("daLabel", datumLabelSubs))
        {warnSub("daLabel", "datumLabel", a_datumLabel);}
      else
        check_daLabel(dynamic_cast<daLabel *>(a_datumLabel));
      return;
    }
}

/********************************************************************/

void check_datumLabel1(
 datumLabel1 * a_datumLabel1)
{
  if (isA(a_datumLabel1, dLabel))
    {
      if (!findString("dLabel", datumLabel1Subs))
        {warnSub("dLabel", "datumLabel1", a_datumLabel1);}
      else
        check_dLabel(dynamic_cast<dLabel *>(a_datumLabel1));
      return;
    }
  if (isA(a_datumLabel1, daLabel))
    {
      if (!findString("daLabel", datumLabel1Subs))
        {warnSub("daLabel", "datumLabel1", a_datumLabel1);}
      else
        check_daLabel(dynamic_cast<daLabel *>(a_datumLabel1));
      return;
    }
}

/********************************************************************/

void check_datumLabel2(
 datumLabel2 * a_datumLabel2)
{
  if (isA(a_datumLabel2, dLabel))
    {
      if (!findString("dLabel", datumLabel2Subs))
        {warnSub("dLabel", "datumLabel2", a_datumLabel2);}
      else
        check_dLabel(dynamic_cast<dLabel *>(a_datumLabel2));
      return;
    }
  if (isA(a_datumLabel2, daLabel))
    {
      if (!findString("daLabel", datumLabel2Subs))
        {warnSub("daLabel", "datumLabel2", a_datumLabel2);}
      else
        check_daLabel(dynamic_cast<daLabel *>(a_datumLabel2));
      return;
    }
}

/********************************************************************/

void check_declMinor(
 declMinor * a_declMinor)
{
  if (a_declMinor->get_declScope())
    {
      if (!findString("a_declScope", declMinorAtts))
	{warnAtt("a_declScope", "declMinor", a_declMinor);}
      else
        check_declScope(a_declMinor->get_declScope());
    }
  if (a_declMinor->get_declType())
    {
      if (!findString("a_declType", declMinorAtts))
	{warnAtt("a_declType", "declMinor", a_declMinor);}
      else
        check_declType(a_declMinor->get_declType());
    }
  if (a_declMinor->get_declVarList())
    {
      if (!findString("a_declVarList", declMinorAtts))
	{warnAtt("a_declVarList", "declMinor", a_declMinor);}
      else
        {
          std::list<declVar *> * theList;
          std::list<declVar *>::iterator iter;
          theList = a_declMinor->get_declVarList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_declVar(*iter);
        }
    }
}

/********************************************************************/

void check_declScope(
 declScope * a_declScope)
{
  if (isA(a_declScope, declScope_COMMON))
    {
      if (!findString("declScope_COMMON", declScopeSubs))
        {warnSub("declScope_COMMON", "declScope", a_declScope);}
      return;
    }
  if (isA(a_declScope, declScope_GLOBAL))
    {
      if (!findString("declScope_GLOBAL", declScopeSubs))
        {warnSub("declScope_GLOBAL", "declScope", a_declScope);}
      return;
    }
  if (isA(a_declScope, declScope_LOCAL))
    {
      if (!findString("declScope_LOCAL", declScopeSubs))
        {warnSub("declScope_LOCAL", "declScope", a_declScope);}
      return;
    }
}

/********************************************************************/

void check_declStm(
 declStm * a_declStm)
{
  if (a_declStm->get_declMinor())
    {
      if (!findString("a_declMinor", declStmAtts))
	{warnAtt("a_declMinor", "declStm", a_declStm);}
      else
        check_declMinor(a_declStm->get_declMinor());
    }
}

/********************************************************************/

void check_declType(
 declType * a_declType)
{
  if (isA(a_declType, declType_BOOL))
    {
      if (!findString("declType_BOOL", declTypeSubs))
        {warnSub("declType_BOOL", "declType", a_declType);}
      return;
    }
  if (isA(a_declType, declType_INTGR))
    {
      if (!findString("declType_INTGR", declTypeSubs))
        {warnSub("declType_INTGR", "declType", a_declType);}
      return;
    }
  if (isA(a_declType, declType_LONG))
    {
      if (!findString("declType_LONG", declTypeSubs))
        {warnSub("declType_LONG", "declType", a_declType);}
      return;
    }
  if (isA(a_declType, declType_REAL))
    {
      if (!findString("declType_REAL", declTypeSubs))
        {warnSub("declType_REAL", "declType", a_declType);}
      return;
    }
  if (isA(a_declType, declType_DOUBLE))
    {
      if (!findString("declType_DOUBLE", declTypeSubs))
        {warnSub("declType_DOUBLE", "declType", a_declType);}
      return;
    }
  if (isA(a_declType, declType_CHAR))
    {
      if (!findString("declType_CHAR", declTypeSubs))
        {warnSub("declType_CHAR", "declType", a_declType);}
      else
        check_declType_CHAR(dynamic_cast<declType_CHAR *>(a_declType));
      return;
    }
  if (isA(a_declType, declType_VECTOR))
    {
      if (!findString("declType_VECTOR", declTypeSubs))
        {warnSub("declType_VECTOR", "declType", a_declType);}
      return;
    }
}

/********************************************************************/

void check_declType_CHAR(
 declType_CHAR * a_declType_CHAR)
{
  if (a_declType_CHAR->get_size())
    {
      if (!findString("size", declType_CHARAtts))
	{warnAtt("size", "declType_CHAR", a_declType_CHAR);}
      else
        check_intVal(a_declType_CHAR->get_size());
    }
}

/********************************************************************/

void check_declVar(
 declVar * a_declVar)
{
  if (a_declVar->get_string())
    {
      if (!findString("a_string", declVarAtts))
	{warnAtt("a_string", "declVar", a_declVar);}
    }
  if (a_declVar->get_declIndicesList())
    {
      if (!findString("a_declIndicesList", declVarAtts))
	{warnAtt("a_declIndicesList", "declVar", a_declVar);}
      else
        {
          std::list<intConst *> * theList;
          std::list<intConst *>::iterator iter;
          theList = a_declVar->get_declIndicesList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_intConst(*iter);
        }
    }
}

/********************************************************************/

void check_decplAll(
 decplAll * a_decplAll)
{
  if (a_decplAll->get_decplNdigits())
    {
      if (!findString("a_decplNdigits", decplAllAtts))
	{warnAtt("a_decplNdigits", "decplAll", a_decplAll);}
      else
        check_decplNdigits(a_decplAll->get_decplNdigits());
    }
}

/********************************************************************/

void check_decplMinor(
 decplMinor * a_decplMinor)
{
  if (isA(a_decplMinor, decplMinor_decplAll))
    {
      if (!findString("decplMinor_decplAll", decplMinorSubs))
        {warnSub("decplMinor_decplAll", "decplMinor", a_decplMinor);}
      else
        check_decplMinor_decplAll(dynamic_cast<decplMinor_decplAll *>(a_decplMinor));
      return;
    }
  if (isA(a_decplMinor, decplMinor_decplList))
    {
      if (!findString("decplMinor_decplList", decplMinorSubs))
        {warnSub("decplMinor_decplList", "decplMinor", a_decplMinor);}
      else
        check_decplMinor_decplList(dynamic_cast<decplMinor_decplList *>(a_decplMinor));
      return;
    }
}

/********************************************************************/

void check_decplMinor_decplAll(
 decplMinor_decplAll * a_decplMinor_decplAll)
{
  if (a_decplMinor_decplAll->get_decplAll())
    {
      if (!findString("a_decplAll", decplMinor_decplAllAtts))
	{warnAtt("a_decplAll", "decplMinor_decplAll", a_decplMinor_decplAll);}
      else
        check_decplAll(a_decplMinor_decplAll->get_decplAll());
    }
}

/********************************************************************/

void check_decplMinor_decplList(
 decplMinor_decplList * a_decplMinor_decplList)
{
  if (a_decplMinor_decplList->get_decplList())
    {
      if (!findString("a_decplList", decplMinor_decplListAtts))
	{warnAtt("a_decplList", "decplMinor_decplList", a_decplMinor_decplList);}
      else
        {
          std::list<decplSelection *> * theList;
          std::list<decplSelection *>::iterator iter;
          theList = a_decplMinor_decplList->get_decplList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_decplSelection(*iter);
        }
    }
}

/********************************************************************/

void check_decplNdigits(
 decplNdigits * a_decplNdigits)
{
  if (isA(a_decplNdigits, decplNdigits_DEFALT))
    {
      if (!findString("decplNdigits_DEFALT", decplNdigitsSubs))
        {warnSub("decplNdigits_DEFALT", "decplNdigits", a_decplNdigits);}
      return;
    }
  if (isA(a_decplNdigits, decplNdigits_intVal))
    {
      if (!findString("decplNdigits_intVal", decplNdigitsSubs))
        {warnSub("decplNdigits_intVal", "decplNdigits", a_decplNdigits);}
      else
        check_decplNdigits_intVal(dynamic_cast<decplNdigits_intVal *>(a_decplNdigits));
      return;
    }
}

/********************************************************************/

void check_decplNdigits_intVal(
 decplNdigits_intVal * a_decplNdigits_intVal)
{
  if (a_decplNdigits_intVal->get_decimal())
    {
      if (!findString("decimal", decplNdigits_intValAtts))
	{warnAtt("decimal", "decplNdigits_intVal", a_decplNdigits_intVal);}
      else
        check_intVal(a_decplNdigits_intVal->get_decimal());
    }
}

/********************************************************************/

void check_decplSelection(
 decplSelection * a_decplSelection)
{
  if (isA(a_decplSelection, decplSelection_ANGLE))
    {
      if (!findString("decplSelection_ANGLE", decplSelectionSubs))
        {warnSub("decplSelection_ANGLE", "decplSelection", a_decplSelection);}
      else
        check_decplSelection_ANGLE(dynamic_cast<decplSelection_ANGLE *>(a_decplSelection));
      return;
    }
  if (isA(a_decplSelection, decplSelection_DIST))
    {
      if (!findString("decplSelection_DIST", decplSelectionSubs))
        {warnSub("decplSelection_DIST", "decplSelection", a_decplSelection);}
      else
        check_decplSelection_DIST(dynamic_cast<decplSelection_DIST *>(a_decplSelection));
      return;
    }
  if (isA(a_decplSelection, decplSelection_HUMID))
    {
      if (!findString("decplSelection_HUMID", decplSelectionSubs))
        {warnSub("decplSelection_HUMID", "decplSelection", a_decplSelection);}
      else
        check_decplSelection_HUMID(dynamic_cast<decplSelection_HUMID *>(a_decplSelection));
      return;
    }
  if (isA(a_decplSelection, decplSelection_DEV))
    {
      if (!findString("decplSelection_DEV", decplSelectionSubs))
        {warnSub("decplSelection_DEV", "decplSelection", a_decplSelection);}
      else
        check_decplSelection_DEV(dynamic_cast<decplSelection_DEV *>(a_decplSelection));
      return;
    }
  if (isA(a_decplSelection, decplSelection_TEMP))
    {
      if (!findString("decplSelection_TEMP", decplSelectionSubs))
        {warnSub("decplSelection_TEMP", "decplSelection", a_decplSelection);}
      else
        check_decplSelection_TEMP(dynamic_cast<decplSelection_TEMP *>(a_decplSelection));
      return;
    }
  if (isA(a_decplSelection, decplSelection_VEC))
    {
      if (!findString("decplSelection_VEC", decplSelectionSubs))
        {warnSub("decplSelection_VEC", "decplSelection", a_decplSelection);}
      else
        check_decplSelection_VEC(dynamic_cast<decplSelection_VEC *>(a_decplSelection));
      return;
    }
}

/********************************************************************/

void check_decplSelection_ANGLE(
 decplSelection_ANGLE * a_decplSelection_ANGLE)
{
  if (a_decplSelection_ANGLE->get_decplNdigits())
    {
      if (!findString("a_decplNdigits", decplSelection_ANGLEAtts))
	{warnAtt("a_decplNdigits", "decplSelection_ANGLE", a_decplSelection_ANGLE);}
      else
        check_decplNdigits(a_decplSelection_ANGLE->get_decplNdigits());
    }
}

/********************************************************************/

void check_decplSelection_DEV(
 decplSelection_DEV * a_decplSelection_DEV)
{
  if (a_decplSelection_DEV->get_decplNdigits())
    {
      if (!findString("a_decplNdigits", decplSelection_DEVAtts))
	{warnAtt("a_decplNdigits", "decplSelection_DEV", a_decplSelection_DEV);}
      else
        check_decplNdigits(a_decplSelection_DEV->get_decplNdigits());
    }
}

/********************************************************************/

void check_decplSelection_DIST(
 decplSelection_DIST * a_decplSelection_DIST)
{
  if (a_decplSelection_DIST->get_decplNdigits())
    {
      if (!findString("a_decplNdigits", decplSelection_DISTAtts))
	{warnAtt("a_decplNdigits", "decplSelection_DIST", a_decplSelection_DIST);}
      else
        check_decplNdigits(a_decplSelection_DIST->get_decplNdigits());
    }
}

/********************************************************************/

void check_decplSelection_HUMID(
 decplSelection_HUMID * a_decplSelection_HUMID)
{
  if (a_decplSelection_HUMID->get_decplNdigits())
    {
      if (!findString("a_decplNdigits", decplSelection_HUMIDAtts))
	{warnAtt("a_decplNdigits", "decplSelection_HUMID", a_decplSelection_HUMID);}
      else
        check_decplNdigits(a_decplSelection_HUMID->get_decplNdigits());
    }
}

/********************************************************************/

void check_decplSelection_TEMP(
 decplSelection_TEMP * a_decplSelection_TEMP)
{
  if (a_decplSelection_TEMP->get_decplNdigits())
    {
      if (!findString("a_decplNdigits", decplSelection_TEMPAtts))
	{warnAtt("a_decplNdigits", "decplSelection_TEMP", a_decplSelection_TEMP);}
      else
        check_decplNdigits(a_decplSelection_TEMP->get_decplNdigits());
    }
}

/********************************************************************/

void check_decplSelection_VEC(
 decplSelection_VEC * a_decplSelection_VEC)
{
  if (a_decplSelection_VEC->get_decplNdigits())
    {
      if (!findString("a_decplNdigits", decplSelection_VECAtts))
	{warnAtt("a_decplNdigits", "decplSelection_VEC", a_decplSelection_VEC);}
      else
        check_decplNdigits(a_decplSelection_VEC->get_decplNdigits());
    }
}

/********************************************************************/

void check_decplStm(
 decplStm * a_decplStm)
{
  if (a_decplStm->get_decplMinor())
    {
      if (!findString("a_decplMinor", decplStmAtts))
	{warnAtt("a_decplMinor", "decplStm", a_decplStm);}
      else
        check_decplMinor(a_decplStm->get_decplMinor());
    }
}

/********************************************************************/

void check_defaultCaseBlock(
 defaultCaseBlock * a_defaultCaseBlock)
{
  if (a_defaultCaseBlock->get_dftcasStm())
    {
      if (!findString("a_dftcasStm", defaultCaseBlockAtts))
	{warnAttBlock("dftcasStm", a_defaultCaseBlock->get_dftcasStm());}
    }
  if (a_defaultCaseBlock->get_dmisItemList())
    {
      if (!findString("a_dmisItemList", defaultCaseBlockAtts))
	{warnAttBlock("dmisItemList", a_defaultCaseBlock->get_dmisItemList()->front());}
      else
        {
          std::list<dmisItem *> * theList;
          std::list<dmisItem *>::iterator iter;
          theList = a_defaultCaseBlock->get_dmisItemList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_dmisItem(*iter);
        }
    }
  if (a_defaultCaseBlock->get_endcasStm())
    {
      if (!findString("a_endcasStm", defaultCaseBlockAtts))
	{warnAttBlock("endcasStm", a_defaultCaseBlock->get_endcasStm());}
    }
}

/********************************************************************/

void check_deleteAllSensors(
 deleteAllSensors * a_deleteAllSensors)
{
  if (a_deleteAllSensors->get_saLabelList())
    {
      if (!findString("a_saLabelList", deleteAllSensorsAtts))
	{warnAtt("a_saLabelList", "deleteAllSensors", a_deleteAllSensors);}
      else
        {
          std::list<saLabel *> * theList;
          std::list<saLabel *>::iterator iter;
          theList = a_deleteAllSensors->get_saLabelList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_saLabel(*iter);
        }
    }
  if (a_deleteAllSensors->get_didLabel())
    {
      if (!findString("a_didLabel", deleteAllSensorsAtts))
	{warnAtt("a_didLabel", "deleteAllSensors", a_deleteAllSensors);}
      else
        check_didLabel(a_deleteAllSensors->get_didLabel());
    }
}

/********************************************************************/

void check_deleteDatum(
 deleteDatum * a_deleteDatum)
{
  if (a_deleteDatum->get_datumLabel1())
    {
      if (!findString("a_datumLabel1", deleteDatumAtts))
	{warnAtt("a_datumLabel1", "deleteDatum", a_deleteDatum);}
      else
        check_datumLabel1(a_deleteDatum->get_datumLabel1());
    }
  if (a_deleteDatum->get_didLabel())
    {
      if (!findString("a_didLabel", deleteDatumAtts))
	{warnAtt("a_didLabel", "deleteDatum", a_deleteDatum);}
      else
        check_didLabel(a_deleteDatum->get_didLabel());
    }
}

/********************************************************************/

void check_deleteFeature(
 deleteFeature * a_deleteFeature)
{
  if (a_deleteFeature->get_faLabel())
    {
      if (!findString("a_faLabel", deleteFeatureAtts))
	{warnAtt("a_faLabel", "deleteFeature", a_deleteFeature);}
      else
        check_faLabel(a_deleteFeature->get_faLabel());
    }
  if (a_deleteFeature->get_didLabel())
    {
      if (!findString("a_didLabel", deleteFeatureAtts))
	{warnAtt("a_didLabel", "deleteFeature", a_deleteFeature);}
      else
        check_didLabel(a_deleteFeature->get_didLabel());
    }
}

/********************************************************************/

void check_deleteMinor(
 deleteMinor * a_deleteMinor)
{
  if (isA(a_deleteMinor, deleteDatum))
    {
      if (!findString("deleteDatum", deleteMinorSubs))
        {warnSub("deleteDatum", "deleteMinor", a_deleteMinor);}
      else
        check_deleteDatum(dynamic_cast<deleteDatum *>(a_deleteMinor));
      return;
    }
  if (isA(a_deleteMinor, deleteSensor))
    {
      if (!findString("deleteSensor", deleteMinorSubs))
        {warnSub("deleteSensor", "deleteMinor", a_deleteMinor);}
      else
        check_deleteSensor(dynamic_cast<deleteSensor *>(a_deleteMinor));
      return;
    }
  if (isA(a_deleteMinor, deleteFeature))
    {
      if (!findString("deleteFeature", deleteMinorSubs))
        {warnSub("deleteFeature", "deleteMinor", a_deleteMinor);}
      else
        check_deleteFeature(dynamic_cast<deleteFeature *>(a_deleteMinor));
      return;
    }
  if (isA(a_deleteMinor, deleteRotaryTable))
    {
      if (!findString("deleteRotaryTable", deleteMinorSubs))
        {warnSub("deleteRotaryTable", "deleteMinor", a_deleteMinor);}
      else
        check_deleteRotaryTable(dynamic_cast<deleteRotaryTable *>(a_deleteMinor));
      return;
    }
  if (isA(a_deleteMinor, deleteAllSensors))
    {
      if (!findString("deleteAllSensors", deleteMinorSubs))
        {warnSub("deleteAllSensors", "deleteMinor", a_deleteMinor);}
      else
        check_deleteAllSensors(dynamic_cast<deleteAllSensors *>(a_deleteMinor));
      return;
    }
}

/********************************************************************/

void check_deleteRotaryTable(
 deleteRotaryTable * a_deleteRotaryTable)
{
  if (a_deleteRotaryTable->get_rtLabel())
    {
      if (!findString("a_rtLabel", deleteRotaryTableAtts))
	{warnAtt("a_rtLabel", "deleteRotaryTable", a_deleteRotaryTable);}
      else
        check_rtLabel(a_deleteRotaryTable->get_rtLabel());
    }
  if (a_deleteRotaryTable->get_didLabel())
    {
      if (!findString("a_didLabel", deleteRotaryTableAtts))
	{warnAtt("a_didLabel", "deleteRotaryTable", a_deleteRotaryTable);}
      else
        check_didLabel(a_deleteRotaryTable->get_didLabel());
    }
}

/********************************************************************/

void check_deleteSensor(
 deleteSensor * a_deleteSensor)
{
  if (a_deleteSensor->get_sensorLabel1())
    {
      if (!findString("a_sensorLabel1", deleteSensorAtts))
	{warnAtt("a_sensorLabel1", "deleteSensor", a_deleteSensor);}
      else
        check_sensorLabel1(a_deleteSensor->get_sensorLabel1());
    }
  if (a_deleteSensor->get_didLabel())
    {
      if (!findString("a_didLabel", deleteSensorAtts))
	{warnAtt("a_didLabel", "deleteSensor", a_deleteSensor);}
      else
        check_didLabel(a_deleteSensor->get_didLabel());
    }
}

/********************************************************************/

void check_deleteStm(
 deleteStm * a_deleteStm)
{
  if (a_deleteStm->get_deleteMinor())
    {
      if (!findString("a_deleteMinor", deleteStmAtts))
	{warnAtt("a_deleteMinor", "deleteStm", a_deleteStm);}
      else
        check_deleteMinor(a_deleteStm->get_deleteMinor());
    }
}

/********************************************************************/

void check_device(
 device * a_device)
{
  if (isA(a_device, device_PRINT))
    {
      if (!findString("device_PRINT", deviceSubs))
        {warnSub("device_PRINT", "device", a_device);}
      return;
    }
  if (isA(a_device, device_TERM))
    {
      if (!findString("device_TERM", deviceSubs))
        {warnSub("device_TERM", "device", a_device);}
      return;
    }
  if (isA(a_device, device_COMM))
    {
      if (!findString("device_COMM", deviceSubs))
        {warnSub("device_COMM", "device", a_device);}
      return;
    }
  if (isA(a_device, device_STOR))
    {
      if (!findString("device_STOR", deviceSubs))
        {warnSub("device_STOR", "device", a_device);}
      return;
    }
}

/********************************************************************/

void check_deviceMinor(
 deviceMinor * a_deviceMinor)
{
  if (isA(a_deviceMinor, deviceMinor_device))
    {
      if (!findString("deviceMinor_device", deviceMinorSubs))
        {warnSub("deviceMinor_device", "deviceMinor", a_deviceMinor);}
      else
        check_deviceMinor_device(dynamic_cast<deviceMinor_device *>(a_deviceMinor));
      return;
    }
  if (isA(a_deviceMinor, deviceMinor_INCR))
    {
      if (!findString("deviceMinor_INCR", deviceMinorSubs))
        {warnSub("deviceMinor_INCR", "deviceMinor", a_deviceMinor);}
      else
        check_deviceMinor_INCR(dynamic_cast<deviceMinor_INCR *>(a_deviceMinor));
      return;
    }
}

/********************************************************************/

void check_deviceMinor_INCR(
 deviceMinor_INCR * a_deviceMinor_INCR)
{
  if (a_deviceMinor_INCR->get_mask())
    {
      if (!findString("mask", deviceMinor_INCRAtts))
	{warnAtt("mask", "deviceMinor_INCR", a_deviceMinor_INCR);}
      else
        check_stringVal(a_deviceMinor_INCR->get_mask());
    }
}

/********************************************************************/

void check_deviceMinor_device(
 deviceMinor_device * a_deviceMinor_device)
{
  if (a_deviceMinor_device->get_device())
    {
      if (!findString("a_device", deviceMinor_deviceAtts))
	{warnAtt("a_device", "deviceMinor_device", a_deviceMinor_device);}
      else
        check_device(a_deviceMinor_device->get_device());
    }
  if (a_deviceMinor_device->get_name())
    {
      if (!findString("name", deviceMinor_deviceAtts))
	{warnAtt("name", "deviceMinor_device", a_deviceMinor_device);}
      else
        check_stringVal(a_deviceMinor_device->get_name());
    }
}

/********************************************************************/

void check_deviceStm(
 deviceStm * a_deviceStm)
{
  if (a_deviceStm->get_didLabel())
    {
      if (!findString("a_didLabel", deviceStmAtts))
	{warnAtt("a_didLabel", "deviceStm", a_deviceStm);}
      else
        check_didLabel(a_deviceStm->get_didLabel());
    }
  if (a_deviceStm->get_deviceMinor())
    {
      if (!findString("a_deviceMinor", deviceStmAtts))
	{warnAtt("a_deviceMinor", "deviceStm", a_deviceStm);}
      else
        check_deviceMinor(a_deviceStm->get_deviceMinor());
    }
}

/********************************************************************/

void check_diLabel(
 diLabel * a_diLabel)
{
  if (a_diLabel->get_labelName())
    {
      if (!findString("a_labelName", diLabelAtts))
	{warnAtt("a_labelName", "diLabel", a_diLabel);}
      else
        check_labelName(a_diLabel->get_labelName());
    }
}

/********************************************************************/

void check_didLabel(
 didLabel * a_didLabel)
{
  if (a_didLabel->get_labelName())
    {
      if (!findString("a_labelName", didLabelAtts))
	{warnAtt("a_labelName", "didLabel", a_didLabel);}
      else
        check_labelName(a_didLabel->get_labelName());
    }
}

/********************************************************************/

void check_dir(
 dir * a_dir)
{
  if (isA(a_dir, posDir))
    {
      if (!findString("posDir", dirSubs))
        {warnSub("posDir", "dir", a_dir);}
      else
        check_posDir(dynamic_cast<posDir *>(a_dir));
      return;
    }
  if (isA(a_dir, negDir))
    {
      if (!findString("negDir", dirSubs))
        {warnSub("negDir", "dir", a_dir);}
      else
        check_negDir(dynamic_cast<negDir *>(a_dir));
      return;
    }
}

/********************************************************************/

void check_displyItemDMIS(
 displyItemDMIS * a_displyItemDMIS)
{
  if (a_displyItemDMIS->get_device())
    {
      if (!findString("a_device", displyItemDMISAtts))
	{warnAtt("a_device", "displyItemDMIS", a_displyItemDMIS);}
      else
        check_device(a_displyItemDMIS->get_device());
    }
  if (a_displyItemDMIS->get_vLabel())
    {
      if (!findString("a_vLabel", displyItemDMISAtts))
	{warnAtt("a_vLabel", "displyItemDMIS", a_displyItemDMIS);}
      else
        check_vLabel(a_displyItemDMIS->get_vLabel());
    }
}

/********************************************************************/

void check_displyItemNoDMIS(
 displyItemNoDMIS * a_displyItemNoDMIS)
{
  if (a_displyItemNoDMIS->get_device())
    {
      if (!findString("a_device", displyItemNoDMISAtts))
	{warnAtt("a_device", "displyItemNoDMIS", a_displyItemNoDMIS);}
      else
        check_device(a_displyItemNoDMIS->get_device());
    }
  if (a_displyItemNoDMIS->get_vLabel())
    {
      if (!findString("a_vLabel", displyItemNoDMISAtts))
	{warnAtt("a_vLabel", "displyItemNoDMIS", a_displyItemNoDMIS);}
      else
        check_vLabel(a_displyItemNoDMIS->get_vLabel());
    }
}

/********************************************************************/

void check_displySpecItem(
 displySpecItem * a_displySpecItem)
{
  if (isA(a_displySpecItem, displyItemDMIS))
    {
      if (!findString("displyItemDMIS", displySpecItemSubs))
        {warnSub("displyItemDMIS", "displySpecItem", a_displySpecItem);}
      else
        check_displyItemDMIS(dynamic_cast<displyItemDMIS *>(a_displySpecItem));
      return;
    }
  if (isA(a_displySpecItem, displyItemNoDMIS))
    {
      if (!findString("displyItemNoDMIS", displySpecItemSubs))
        {warnSub("displyItemNoDMIS", "displySpecItem", a_displySpecItem);}
      else
        check_displyItemNoDMIS(dynamic_cast<displyItemNoDMIS *>(a_displySpecItem));
      return;
    }
}

/********************************************************************/

void check_displyStm(
 displyStm * a_displyStm)
{
  if (isA(a_displyStm, displyStmOff))
    {
      if (!findString("displyStmOff", displyStmSubs))
        {warnSub("displyStmOff", "displyStm", a_displyStm);}
      else
        check_displyStmOff(dynamic_cast<displyStmOff *>(a_displyStm));
      return;
    }
  if (isA(a_displyStm, displyStmSpec))
    {
      if (!findString("displyStmSpec", displyStmSubs))
        {warnSub("displyStmSpec", "displyStm", a_displyStm);}
      else
        check_displyStmSpec(dynamic_cast<displyStmSpec *>(a_displyStm));
      return;
    }
}

/********************************************************************/

void check_displyStmOff(
 displyStmOff * a_displyStmOff)
{
  if (a_displyStmOff->get_displyOff())
    {
      if (!findString("a_displyOff", displyStmOffAtts))
	{warnAtt("a_displyOff", "displyStmOff", a_displyStmOff);}
    }
}

/********************************************************************/

void check_displyStmSpec(
 displyStmSpec * a_displyStmSpec)
{
  if (a_displyStmSpec->get_displySpecList())
    {
      if (!findString("a_displySpecList", displyStmSpecAtts))
	{warnAtt("a_displySpecList", "displyStmSpec", a_displyStmSpec);}
      else
        {
          std::list<displySpecItem *> * theList;
          std::list<displySpecItem *>::iterator iter;
          theList = a_displyStmSpec->get_displySpecList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_displySpecItem(*iter);
        }
    }
}

/********************************************************************/

void check_dmehwMinor(
 dmehwMinor * a_dmehwMinor)
{
  if (isA(a_dmehwMinor, dmehwMinor_CONTIN))
    {
      if (!findString("dmehwMinor_CONTIN", dmehwMinorSubs))
        {warnSub("dmehwMinor_CONTIN", "dmehwMinor", a_dmehwMinor);}
      return;
    }
  if (isA(a_dmehwMinor, dmehwMinor_PAUSE))
    {
      if (!findString("dmehwMinor_PAUSE", dmehwMinorSubs))
        {warnSub("dmehwMinor_PAUSE", "dmehwMinor", a_dmehwMinor);}
      return;
    }
  if (isA(a_dmehwMinor, dmehwMinor_SINGLE))
    {
      if (!findString("dmehwMinor_SINGLE", dmehwMinorSubs))
        {warnSub("dmehwMinor_SINGLE", "dmehwMinor", a_dmehwMinor);}
      return;
    }
  if (isA(a_dmehwMinor, dmehwMinor_AUTO))
    {
      if (!findString("dmehwMinor_AUTO", dmehwMinorSubs))
        {warnSub("dmehwMinor_AUTO", "dmehwMinor", a_dmehwMinor);}
      return;
    }
  if (isA(a_dmehwMinor, dmehwMinor_jointConf))
    {
      if (!findString("dmehwMinor_jointConf", dmehwMinorSubs))
        {warnSub("dmehwMinor_jointConf", "dmehwMinor", a_dmehwMinor);}
      else
        check_dmehwMinor_jointConf(dynamic_cast<dmehwMinor_jointConf *>(a_dmehwMinor));
      return;
    }
}

/********************************************************************/

void check_dmehwMinor_jointConf(
 dmehwMinor_jointConf * a_dmehwMinor_jointConf)
{
  if (a_dmehwMinor_jointConf->get_jointConf())
    {
      if (!findString("a_jointConf", dmehwMinor_jointConfAtts))
	{warnAtt("a_jointConf", "dmehwMinor_jointConf", a_dmehwMinor_jointConf);}
      else
        check_jointConf(a_dmehwMinor_jointConf->get_jointConf());
    }
}

/********************************************************************/

void check_dmehwStm(
 dmehwStm * a_dmehwStm)
{
  if (a_dmehwStm->get_dmehwMinor())
    {
      if (!findString("a_dmehwMinor", dmehwStmAtts))
	{warnAtt("a_dmehwMinor", "dmehwStm", a_dmehwStm);}
      else
        check_dmehwMinor(a_dmehwStm->get_dmehwMinor());
    }
}

/********************************************************************/

void check_dmeidStm(
 dmeidStm * a_dmeidStm)
{
  if (a_dmeidStm->get_diLabel())
    {
      if (!findString("a_diLabel", dmeidStmAtts))
	{warnAtt("a_diLabel", "dmeidStm", a_dmeidStm);}
      else
        check_diLabel(a_dmeidStm->get_diLabel());
    }
  if (a_dmeidStm->get_text())
    {
      if (!findString("text", dmeidStmAtts))
	{warnAtt("text", "dmeidStm", a_dmeidStm);}
      else
        check_stringVal(a_dmeidStm->get_text());
    }
}

/********************************************************************/

void check_dmeswComand(
 dmeswComand * a_dmeswComand)
{
  if (a_dmeswComand->get_command())
    {
      if (!findString("command", dmeswComandAtts))
	{warnAtt("command", "dmeswComand", a_dmeswComand);}
      else
        check_stringVal(a_dmeswComand->get_command());
    }
}

/********************************************************************/

void check_dmeswDelay(
 dmeswDelay * a_dmeswDelay)
{
  if (a_dmeswDelay->get_secs())
    {
      if (!findString("secs", dmeswDelayAtts))
	{warnAtt("secs", "dmeswDelay", a_dmeswDelay);}
      else
        check_intVal(a_dmeswDelay->get_secs());
    }
}

/********************************************************************/

void check_dmeswMinor(
 dmeswMinor * a_dmeswMinor)
{
  if (isA(a_dmeswMinor, dmeswComand))
    {
      if (!findString("dmeswComand", dmeswMinorSubs))
        {warnSub("dmeswComand", "dmeswMinor", a_dmeswMinor);}
      else
        check_dmeswComand(dynamic_cast<dmeswComand *>(a_dmeswMinor));
      return;
    }
  if (isA(a_dmeswMinor, dmeswDelay))
    {
      if (!findString("dmeswDelay", dmeswMinorSubs))
        {warnSub("dmeswDelay", "dmeswMinor", a_dmeswMinor);}
      else
        check_dmeswDelay(dynamic_cast<dmeswDelay *>(a_dmeswMinor));
      return;
    }
  if (isA(a_dmeswMinor, dmeswSwitch))
    {
      if (!findString("dmeswSwitch", dmeswMinorSubs))
        {warnSub("dmeswSwitch", "dmeswMinor", a_dmeswMinor);}
      else
        check_dmeswSwitch(dynamic_cast<dmeswSwitch *>(a_dmeswMinor));
      return;
    }
}

/********************************************************************/

void check_dmeswStm(
 dmeswStm * a_dmeswStm)
{
  if (a_dmeswStm->get_dmeswMinor())
    {
      if (!findString("a_dmeswMinor", dmeswStmAtts))
	{warnAtt("a_dmeswMinor", "dmeswStm", a_dmeswStm);}
      else
        check_dmeswMinor(a_dmeswStm->get_dmeswMinor());
    }
}

/********************************************************************/

void check_dmeswSwitch(
 dmeswSwitch * a_dmeswSwitch)
{
  if (isA(a_dmeswSwitch, dmeswSwitch_CONTIN))
    {
      if (!findString("dmeswSwitch_CONTIN", dmeswSwitchSubs))
        {warnSub("dmeswSwitch_CONTIN", "dmeswSwitch", a_dmeswSwitch);}
      return;
    }
  if (isA(a_dmeswSwitch, dmeswSwitch_PAUSE))
    {
      if (!findString("dmeswSwitch_PAUSE", dmeswSwitchSubs))
        {warnSub("dmeswSwitch_PAUSE", "dmeswSwitch", a_dmeswSwitch);}
      return;
    }
}

/********************************************************************/

void check_dmeswiStm(
 dmeswiStm * a_dmeswiStm)
{
  if (a_dmeswiStm->get_dsLabel())
    {
      if (!findString("a_dsLabel", dmeswiStmAtts))
	{warnAtt("a_dsLabel", "dmeswiStm", a_dmeswiStm);}
      else
        check_dsLabel(a_dmeswiStm->get_dsLabel());
    }
  if (a_dmeswiStm->get_text())
    {
      if (!findString("text", dmeswiStmAtts))
	{warnAtt("text", "dmeswiStm", a_dmeswiStm);}
      else
        check_stringVal(a_dmeswiStm->get_text());
    }
}

/********************************************************************/

void check_dmeswvStm(
 dmeswvStm * a_dmeswvStm)
{
  if (a_dmeswvStm->get_dvLabel())
    {
      if (!findString("a_dvLabel", dmeswvStmAtts))
	{warnAtt("a_dvLabel", "dmeswvStm", a_dmeswvStm);}
      else
        check_dvLabel(a_dmeswvStm->get_dvLabel());
    }
  if (a_dmeswvStm->get_text())
    {
      if (!findString("text", dmeswvStmAtts))
	{warnAtt("text", "dmeswvStm", a_dmeswvStm);}
      else
        check_stringVal(a_dmeswvStm->get_text());
    }
}

/********************************************************************/

void check_dmisBlock(
 dmisBlock * a_dmisBlock)
{
  if (isA(a_dmisBlock, calibMasterBlock))
    {
      if (!findString("calibMasterBlock", dmisBlockSubs))
        {warnBlockBug("calibMasterBlock", "dmisBlock");}
      else
        check_calibMasterBlock(dynamic_cast<calibMasterBlock *>(a_dmisBlock));
    }
  else if (isA(a_dmisBlock, calibRtabBlock))
    {
      if (!findString("calibRtabBlock", dmisBlockSubs))
        {warnBlockBug("calibRtabBlock", "dmisBlock");}
      else
        check_calibRtabBlock(dynamic_cast<calibRtabBlock *>(a_dmisBlock));
    }
  else if (isA(a_dmisBlock, calibSensBlock))
    {
      if (!findString("calibSensBlock", dmisBlockSubs))
        {warnBlockBug("calibSensBlock", "dmisBlock");}
      else
        check_calibSensBlock(dynamic_cast<calibSensBlock *>(a_dmisBlock));
    }
  else if (isA(a_dmisBlock, callBlock))
    {
      if (!findString("callBlock", dmisBlockSubs))
        {warnBlockBug("callBlock", "dmisBlock");}
      else
        check_callBlock(dynamic_cast<callBlock *>(a_dmisBlock));
    }
  else if (isA(a_dmisBlock, dmisOffBlock))
    {
      if (!findString("dmisOffBlock", dmisBlockSubs))
        {warnBlockBug("dmisOffBlock", "dmisBlock");}
      else
        check_dmisOffBlock(dynamic_cast<dmisOffBlock *>(a_dmisBlock));
    }
  else if (isA(a_dmisBlock, doBlock))
    {
      if (!findString("doBlock", dmisBlockSubs))
        {warnBlockBug("doBlock", "dmisBlock");}
      else
        check_doBlock(dynamic_cast<doBlock *>(a_dmisBlock));
    }
  else if (isA(a_dmisBlock, gotargBlock))
    {
      if (!findString("gotargBlock", dmisBlockSubs))
        {warnBlockBug("gotargBlock", "dmisBlock");}
      else
        check_gotargBlock(dynamic_cast<gotargBlock *>(a_dmisBlock));
    }
  else if (isA(a_dmisBlock, ifBlock))
    {
      if (!findString("ifBlock", dmisBlockSubs))
        {warnBlockBug("ifBlock", "dmisBlock");}
      else
        check_ifBlock(dynamic_cast<ifBlock *>(a_dmisBlock));
    }
  else if (isA(a_dmisBlock, macroBlock))
    {
      if (!findString("macroBlock", dmisBlockSubs))
        {warnBlockBug("macroBlock", "dmisBlock");}
      else
        check_macroBlock(dynamic_cast<macroBlock *>(a_dmisBlock));
    }
  else if (isA(a_dmisBlock, measBlock))
    {
      if (!findString("measBlock", dmisBlockSubs))
        {warnBlockBug("measBlock", "dmisBlock");}
      else
        check_measBlock(dynamic_cast<measBlock *>(a_dmisBlock));
    }
  else if (isA(a_dmisBlock, selectBlock))
    {
      if (!findString("selectBlock", dmisBlockSubs))
        {warnBlockBug("selectBlock", "dmisBlock");}
      else
        check_selectBlock(dynamic_cast<selectBlock *>(a_dmisBlock));
    }
  else if (isA(a_dmisBlock, simreqtBlock))
    {
      if (!findString("simreqtBlock", dmisBlockSubs))
        {warnBlockBug("simreqtBlock", "dmisBlock");}
      else
        check_simreqtBlock(dynamic_cast<simreqtBlock *>(a_dmisBlock));
    }
  else if (isA(a_dmisBlock, xternBlock))
    {
      if (!findString("xternBlock", dmisBlockSubs))
        {warnBlockBug("xternBlock", "dmisBlock");}
      else
        check_xternBlock(dynamic_cast<xternBlock *>(a_dmisBlock));
    }
}

/********************************************************************/

void check_dmisFirstStatement(
 dmisFirstStatement * a_dmisFirstStatement)
{
  if (isA(a_dmisFirstStatement, dmismdStm))
    {
      if (!findString("dmismdStm", dmisFirstStatementSubs))
        {warnSub("dmismdStm", "dmisFirstStatement", a_dmisFirstStatement);}
      else
        check_dmismdStm(dynamic_cast<dmismdStm *>(a_dmisFirstStatement));
      return;
    }
  if (isA(a_dmisFirstStatement, dmismnStm))
    {
      if (!findString("dmismnStm", dmisFirstStatementSubs))
        {warnSub("dmismnStm", "dmisFirstStatement", a_dmisFirstStatement);}
      else
        check_dmismnStm(dynamic_cast<dmismnStm *>(a_dmisFirstStatement));
      return;
    }
}

/********************************************************************/

void check_dmisFreeStatement(
 dmisFreeStatement * a_dmisFreeStatement)
{
  if (isA(a_dmisFreeStatement, jumpStm))
    {
      if (!findString("jumpStm", dmisFreeStatementSubs))
        {warnSub("jumpStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_jumpStm(dynamic_cast<jumpStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, aclratStm))
    {
      if (!findString("aclratStm", dmisFreeStatementSubs))
        {warnSub("aclratStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_aclratStm(dynamic_cast<aclratStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, algdefStm))
    {
      if (!findString("algdefStm", dmisFreeStatementSubs))
        {warnSub("algdefStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_algdefStm(dynamic_cast<algdefStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, assignStm))
    {
      if (!findString("assignStm", dmisFreeStatementSubs))
        {warnSub("assignStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_assignStm(dynamic_cast<assignStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, badtstStm))
    {
      if (!findString("badtstStm", dmisFreeStatementSubs))
        {warnSub("badtstStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_badtstStm(dynamic_cast<badtstStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, boundStm))
    {
      if (!findString("boundStm", dmisFreeStatementSubs))
        {warnSub("boundStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_boundStm(dynamic_cast<boundStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, clmpidStm))
    {
      if (!findString("clmpidStm", dmisFreeStatementSubs))
        {warnSub("clmpidStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_clmpidStm(dynamic_cast<clmpidStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, clmpsnStm))
    {
      if (!findString("clmpsnStm", dmisFreeStatementSubs))
        {warnSub("clmpsnStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_clmpsnStm(dynamic_cast<clmpsnStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, closeStm))
    {
      if (!findString("closeStm", dmisFreeStatementSubs))
        {warnSub("closeStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_closeStm(dynamic_cast<closeStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, cmpntgrpStm))
    {
      if (!findString("cmpntgrpStm", dmisFreeStatementSubs))
        {warnSub("cmpntgrpStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_cmpntgrpStm(dynamic_cast<cmpntgrpStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, cnfrmrulStm))
    {
      if (!findString("cnfrmrulStm", dmisFreeStatementSubs))
        {warnSub("cnfrmrulStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_cnfrmrulStm(dynamic_cast<cnfrmrulStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, constStm))
    {
      if (!findString("constStm", dmisFreeStatementSubs))
        {warnSub("constStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_constStm(dynamic_cast<constStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, crgdefStm))
    {
      if (!findString("crgdefStm", dmisFreeStatementSubs))
        {warnSub("crgdefStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_crgdefStm(dynamic_cast<crgdefStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, crmodeStm))
    {
      if (!findString("crmodeStm", dmisFreeStatementSubs))
        {warnSub("crmodeStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_crmodeStm(dynamic_cast<crmodeStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, crosclStm))
    {
      if (!findString("crosclStm", dmisFreeStatementSubs))
        {warnSub("crosclStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_crosclStm(dynamic_cast<crosclStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, crslctStm))
    {
      if (!findString("crslctStm", dmisFreeStatementSubs))
        {warnSub("crslctStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_crslctStm(dynamic_cast<crslctStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, cutcomStm))
    {
      if (!findString("cutcomStm", dmisFreeStatementSubs))
        {warnSub("cutcomStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_cutcomStm(dynamic_cast<cutcomStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, czoneStm))
    {
      if (!findString("czoneStm", dmisFreeStatementSubs))
        {warnSub("czoneStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_czoneStm(dynamic_cast<czoneStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, czslctStm))
    {
      if (!findString("czslctStm", dmisFreeStatementSubs))
        {warnSub("czslctStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_czslctStm(dynamic_cast<czslctStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, datdefStm))
    {
      if (!findString("datdefStm", dmisFreeStatementSubs))
        {warnSub("datdefStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_datdefStm(dynamic_cast<datdefStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, datsetStm))
    {
      if (!findString("datsetStm", dmisFreeStatementSubs))
        {warnSub("datsetStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_datsetStm(dynamic_cast<datsetStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, dattrgdefStm))
    {
      if (!findString("dattrgdefStm", dmisFreeStatementSubs))
        {warnSub("dattrgdefStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_dattrgdefStm(dynamic_cast<dattrgdefStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, declStm))
    {
      if (!findString("declStm", dmisFreeStatementSubs))
        {warnSub("declStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_declStm(dynamic_cast<declStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, decplStm))
    {
      if (!findString("decplStm", dmisFreeStatementSubs))
        {warnSub("decplStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_decplStm(dynamic_cast<decplStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, deleteStm))
    {
      if (!findString("deleteStm", dmisFreeStatementSubs))
        {warnSub("deleteStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_deleteStm(dynamic_cast<deleteStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, deviceStm))
    {
      if (!findString("deviceStm", dmisFreeStatementSubs))
        {warnSub("deviceStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_deviceStm(dynamic_cast<deviceStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, displyStm))
    {
      if (!findString("displyStm", dmisFreeStatementSubs))
        {warnSub("displyStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_displyStm(dynamic_cast<displyStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, dmehwStm))
    {
      if (!findString("dmehwStm", dmisFreeStatementSubs))
        {warnSub("dmehwStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_dmehwStm(dynamic_cast<dmehwStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, dmeidStm))
    {
      if (!findString("dmeidStm", dmisFreeStatementSubs))
        {warnSub("dmeidStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_dmeidStm(dynamic_cast<dmeidStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, dmeswStm))
    {
      if (!findString("dmeswStm", dmisFreeStatementSubs))
        {warnSub("dmeswStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_dmeswStm(dynamic_cast<dmeswStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, dmeswiStm))
    {
      if (!findString("dmeswiStm", dmisFreeStatementSubs))
        {warnSub("dmeswiStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_dmeswiStm(dynamic_cast<dmeswiStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, dmeswvStm))
    {
      if (!findString("dmeswvStm", dmisFreeStatementSubs))
        {warnSub("dmeswvStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_dmeswvStm(dynamic_cast<dmeswvStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, dmisOnStm))
    {
      if (!findString("dmisOnStm", dmisFreeStatementSubs))
        {warnSub("dmisOnStm", "dmisFreeStatement", a_dmisFreeStatement);}
      return;
    }
  if (isA(a_dmisFreeStatement, equateStm))
    {
      if (!findString("equateStm", dmisFreeStatementSubs))
        {warnSub("equateStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_equateStm(dynamic_cast<equateStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, errorStm))
    {
      if (!findString("errorStm", dmisFreeStatementSubs))
        {warnSub("errorStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_errorStm(dynamic_cast<errorStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, evalStm))
    {
      if (!findString("evalStm", dmisFreeStatementSubs))
        {warnSub("evalStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_evalStm(dynamic_cast<evalStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, extensStm))
    {
      if (!findString("extensStm", dmisFreeStatementSubs))
        {warnSub("extensStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_extensStm(dynamic_cast<extensStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, featArc1Stm))
    {
      if (!findString("featArc1Stm", dmisFreeStatementSubs))
        {warnSub("featArc1Stm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_featArc1Stm(dynamic_cast<featArc1Stm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, featArc2Stm))
    {
      if (!findString("featArc2Stm", dmisFreeStatementSubs))
        {warnSub("featArc2Stm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_featArc2Stm(dynamic_cast<featArc2Stm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, featCircleStm))
    {
      if (!findString("featCircleStm", dmisFreeStatementSubs))
        {warnSub("featCircleStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_featCircleStm(dynamic_cast<featCircleStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, featCompoundStm))
    {
      if (!findString("featCompoundStm", dmisFreeStatementSubs))
        {warnSub("featCompoundStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_featCompoundStm(dynamic_cast<featCompoundStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, featConeStm))
    {
      if (!findString("featConeStm", dmisFreeStatementSubs))
        {warnSub("featConeStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_featConeStm(dynamic_cast<featConeStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, featConradsegStm))
    {
      if (!findString("featConradsegStm", dmisFreeStatementSubs))
        {warnSub("featConradsegStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_featConradsegStm(dynamic_cast<featConradsegStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, featCparlnStm))
    {
      if (!findString("featCparlnStm", dmisFreeStatementSubs))
        {warnSub("featCparlnStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_featCparlnStm(dynamic_cast<featCparlnStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, featCylndrStm))
    {
      if (!findString("featCylndrStm", dmisFreeStatementSubs))
        {warnSub("featCylndrStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_featCylndrStm(dynamic_cast<featCylndrStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, featCylradsegStm))
    {
      if (!findString("featCylradsegStm", dmisFreeStatementSubs))
        {warnSub("featCylradsegStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_featCylradsegStm(dynamic_cast<featCylradsegStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, featEdgeptStm))
    {
      if (!findString("featEdgeptStm", dmisFreeStatementSubs))
        {warnSub("featEdgeptStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_featEdgeptStm(dynamic_cast<featEdgeptStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, featEllipsStm))
    {
      if (!findString("featEllipsStm", dmisFreeStatementSubs))
        {warnSub("featEllipsStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_featEllipsStm(dynamic_cast<featEllipsStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, featElongcylStm))
    {
      if (!findString("featElongcylStm", dmisFreeStatementSubs))
        {warnSub("featElongcylStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_featElongcylStm(dynamic_cast<featElongcylStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, featGcurveStm))
    {
      if (!findString("featGcurveStm", dmisFreeStatementSubs))
        {warnSub("featGcurveStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_featGcurveStm(dynamic_cast<featGcurveStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, featGeomStm))
    {
      if (!findString("featGeomStm", dmisFreeStatementSubs))
        {warnSub("featGeomStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_featGeomStm(dynamic_cast<featGeomStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, featGsurfStm))
    {
      if (!findString("featGsurfStm", dmisFreeStatementSubs))
        {warnSub("featGsurfStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_featGsurfStm(dynamic_cast<featGsurfStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, featLineStm))
    {
      if (!findString("featLineStm", dmisFreeStatementSubs))
        {warnSub("featLineStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_featLineStm(dynamic_cast<featLineStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, featObjectStm))
    {
      if (!findString("featObjectStm", dmisFreeStatementSubs))
        {warnSub("featObjectStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_featObjectStm(dynamic_cast<featObjectStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, featParplnStm))
    {
      if (!findString("featParplnStm", dmisFreeStatementSubs))
        {warnSub("featParplnStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_featParplnStm(dynamic_cast<featParplnStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, featPaternStm))
    {
      if (!findString("featPaternStm", dmisFreeStatementSubs))
        {warnSub("featPaternStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_featPaternStm(dynamic_cast<featPaternStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, featPlaneStm))
    {
      if (!findString("featPlaneStm", dmisFreeStatementSubs))
        {warnSub("featPlaneStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_featPlaneStm(dynamic_cast<featPlaneStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, featPointStm))
    {
      if (!findString("featPointStm", dmisFreeStatementSubs))
        {warnSub("featPointStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_featPointStm(dynamic_cast<featPointStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, featRctnglStm))
    {
      if (!findString("featRctnglStm", dmisFreeStatementSubs))
        {warnSub("featRctnglStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_featRctnglStm(dynamic_cast<featRctnglStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, featRevsurfStm))
    {
      if (!findString("featRevsurfStm", dmisFreeStatementSubs))
        {warnSub("featRevsurfStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_featRevsurfStm(dynamic_cast<featRevsurfStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, featSphereStm))
    {
      if (!findString("featSphereStm", dmisFreeStatementSubs))
        {warnSub("featSphereStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_featSphereStm(dynamic_cast<featSphereStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, featSphradsegStm))
    {
      if (!findString("featSphradsegStm", dmisFreeStatementSubs))
        {warnSub("featSphradsegStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_featSphradsegStm(dynamic_cast<featSphradsegStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, featSymplnStm))
    {
      if (!findString("featSymplnStm", dmisFreeStatementSubs))
        {warnSub("featSymplnStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_featSymplnStm(dynamic_cast<featSymplnStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, featTorradsegStm))
    {
      if (!findString("featTorradsegStm", dmisFreeStatementSubs))
        {warnSub("featTorradsegStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_featTorradsegStm(dynamic_cast<featTorradsegStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, featTorusStm))
    {
      if (!findString("featTorusStm", dmisFreeStatementSubs))
        {warnSub("featTorusStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_featTorusStm(dynamic_cast<featTorusStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, fedratStm))
    {
      if (!findString("fedratStm", dmisFreeStatementSubs))
        {warnSub("fedratStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_fedratStm(dynamic_cast<fedratStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, fildefStm))
    {
      if (!findString("fildefStm", dmisFreeStatementSubs))
        {warnSub("fildefStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_fildefStm(dynamic_cast<fildefStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, filnamStm))
    {
      if (!findString("filnamStm", dmisFreeStatementSubs))
        {warnSub("filnamStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_filnamStm(dynamic_cast<filnamStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, finposStm))
    {
      if (!findString("finposStm", dmisFreeStatementSubs))
        {warnSub("finposStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_finposStm(dynamic_cast<finposStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, fixtidStm))
    {
      if (!findString("fixtidStm", dmisFreeStatementSubs))
        {warnSub("fixtidStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_fixtidStm(dynamic_cast<fixtidStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, fixtsnStm))
    {
      if (!findString("fixtsnStm", dmisFreeStatementSubs))
        {warnSub("fixtsnStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_fixtsnStm(dynamic_cast<fixtsnStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, flyStm))
    {
      if (!findString("flyStm", dmisFreeStatementSubs))
        {warnSub("flyStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_flyStm(dynamic_cast<flyStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, fromStm))
    {
      if (!findString("fromStm", dmisFreeStatementSubs))
        {warnSub("fromStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_fromStm(dynamic_cast<fromStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, geoalgStm))
    {
      if (!findString("geoalgStm", dmisFreeStatementSubs))
        {warnSub("geoalgStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_geoalgStm(dynamic_cast<geoalgStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, geomStm))
    {
      if (!findString("geomStm", dmisFreeStatementSubs))
        {warnSub("geomStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_geomStm(dynamic_cast<geomStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, gohomeStm))
    {
      if (!findString("gohomeStm", dmisFreeStatementSubs))
        {warnSub("gohomeStm", "dmisFreeStatement", a_dmisFreeStatement);}
      return;
    }
  if (isA(a_dmisFreeStatement, gotoStm))
    {
      if (!findString("gotoStm", dmisFreeStatementSubs))
        {warnSub("gotoStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_gotoStm(dynamic_cast<gotoStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, groupStm))
    {
      if (!findString("groupStm", dmisFreeStatementSubs))
        {warnSub("groupStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_groupStm(dynamic_cast<groupStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, includStm))
    {
      if (!findString("includStm", dmisFreeStatementSubs))
        {warnSub("includStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_includStm(dynamic_cast<includStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, iteratStm))
    {
      if (!findString("iteratStm", dmisFreeStatementSubs))
        {warnSub("iteratStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_iteratStm(dynamic_cast<iteratStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, jumptoStm))
    {
      if (!findString("jumptoStm", dmisFreeStatementSubs))
        {warnSub("jumptoStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_jumptoStm(dynamic_cast<jumptoStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, keycharStm))
    {
      if (!findString("keycharStm", dmisFreeStatementSubs))
        {warnSub("keycharStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_keycharStm(dynamic_cast<keycharStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, litdefStm))
    {
      if (!findString("litdefStm", dmisFreeStatementSubs))
        {warnSub("litdefStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_litdefStm(dynamic_cast<litdefStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, locateStm))
    {
      if (!findString("locateStm", dmisFreeStatementSubs))
        {warnSub("locateStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_locateStm(dynamic_cast<locateStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, lotidStm))
    {
      if (!findString("lotidStm", dmisFreeStatementSubs))
        {warnSub("lotidStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_lotidStm(dynamic_cast<lotidStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, matdefStm))
    {
      if (!findString("matdefStm", dmisFreeStatementSubs))
        {warnSub("matdefStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_matdefStm(dynamic_cast<matdefStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, mfgdevStm))
    {
      if (!findString("mfgdevStm", dmisFreeStatementSubs))
        {warnSub("mfgdevStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_mfgdevStm(dynamic_cast<mfgdevStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, modeStm))
    {
      if (!findString("modeStm", dmisFreeStatementSubs))
        {warnSub("modeStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_modeStm(dynamic_cast<modeStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, obtainStm))
    {
      if (!findString("obtainStm", dmisFreeStatementSubs))
        {warnSub("obtainStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_obtainStm(dynamic_cast<obtainStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, openStm))
    {
      if (!findString("openStm", dmisFreeStatementSubs))
        {warnSub("openStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_openStm(dynamic_cast<openStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, operidStm))
    {
      if (!findString("operidStm", dmisFreeStatementSubs))
        {warnSub("operidStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_operidStm(dynamic_cast<operidStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, outputStm))
    {
      if (!findString("outputStm", dmisFreeStatementSubs))
        {warnSub("outputStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_outputStm(dynamic_cast<outputStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, pameasStm))
    {
      if (!findString("pameasStm", dmisFreeStatementSubs))
        {warnSub("pameasStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_pameasStm(dynamic_cast<pameasStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, partidStm))
    {
      if (!findString("partidStm", dmisFreeStatementSubs))
        {warnSub("partidStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_partidStm(dynamic_cast<partidStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, partrvStm))
    {
      if (!findString("partrvStm", dmisFreeStatementSubs))
        {warnSub("partrvStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_partrvStm(dynamic_cast<partrvStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, partsnStm))
    {
      if (!findString("partsnStm", dmisFreeStatementSubs))
        {warnSub("partsnStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_partsnStm(dynamic_cast<partsnStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, pathStm))
    {
      if (!findString("pathStm", dmisFreeStatementSubs))
        {warnSub("pathStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_pathStm(dynamic_cast<pathStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, planidStm))
    {
      if (!findString("planidStm", dmisFreeStatementSubs))
        {warnSub("planidStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_planidStm(dynamic_cast<planidStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, popStm))
    {
      if (!findString("popStm", dmisFreeStatementSubs))
        {warnSub("popStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_popStm(dynamic_cast<popStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, prcompStm))
    {
      if (!findString("prcompStm", dmisFreeStatementSubs))
        {warnSub("prcompStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_prcompStm(dynamic_cast<prcompStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, prevopStm))
    {
      if (!findString("prevopStm", dmisFreeStatementSubs))
        {warnSub("prevopStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_prevopStm(dynamic_cast<prevopStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, procidStm))
    {
      if (!findString("procidStm", dmisFreeStatementSubs))
        {warnSub("procidStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_procidStm(dynamic_cast<procidStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, promptStm))
    {
      if (!findString("promptStm", dmisFreeStatementSubs))
        {warnSub("promptStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_promptStm(dynamic_cast<promptStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, psthruStm))
    {
      if (!findString("psthruStm", dmisFreeStatementSubs))
        {warnSub("psthruStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_psthruStm(dynamic_cast<psthruStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, ptbuffStm))
    {
      if (!findString("ptbuffStm", dmisFreeStatementSubs))
        {warnSub("ptbuffStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_ptbuffStm(dynamic_cast<ptbuffStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, ptmeasStm))
    {
      if (!findString("ptmeasStm", dmisFreeStatementSubs))
        {warnSub("ptmeasStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_ptmeasStm(dynamic_cast<ptmeasStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, pushStm))
    {
      if (!findString("pushStm", dmisFreeStatementSubs))
        {warnSub("pushStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_pushStm(dynamic_cast<pushStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, qisdefStm))
    {
      if (!findString("qisdefStm", dmisFreeStatementSubs))
        {warnSub("qisdefStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_qisdefStm(dynamic_cast<qisdefStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, rapidStm))
    {
      if (!findString("rapidStm", dmisFreeStatementSubs))
        {warnSub("rapidStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_rapidStm(dynamic_cast<rapidStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, readStm))
    {
      if (!findString("readStm", dmisFreeStatementSubs))
        {warnSub("readStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_readStm(dynamic_cast<readStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, recallDatumStm))
    {
      if (!findString("recallDatumStm", dmisFreeStatementSubs))
        {warnSub("recallDatumStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_recallDatumStm(dynamic_cast<recallDatumStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, recallDMLStm))
    {
      if (!findString("recallDMLStm", dmisFreeStatementSubs))
        {warnSub("recallDMLStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_recallDMLStm(dynamic_cast<recallDMLStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, recallFeatureStm))
    {
      if (!findString("recallFeatureStm", dmisFreeStatementSubs))
        {warnSub("recallFeatureStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_recallFeatureStm(dynamic_cast<recallFeatureStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, recallRotaryTableStm))
    {
      if (!findString("recallRotaryTableStm", dmisFreeStatementSubs))
        {warnSub("recallRotaryTableStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_recallRotaryTableStm(dynamic_cast<recallRotaryTableStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, recallSensorStm))
    {
      if (!findString("recallSensorStm", dmisFreeStatementSubs))
        {warnSub("recallSensorStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_recallSensorStm(dynamic_cast<recallSensorStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, refmntStm))
    {
      if (!findString("refmntStm", dmisFreeStatementSubs))
        {warnSub("refmntStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_refmntStm(dynamic_cast<refmntStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, reportStm))
    {
      if (!findString("reportStm", dmisFreeStatementSubs))
        {warnSub("reportStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_reportStm(dynamic_cast<reportStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, resumeStm))
    {
      if (!findString("resumeStm", dmisFreeStatementSubs))
        {warnSub("resumeStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_resumeStm(dynamic_cast<resumeStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, rotabStm))
    {
      if (!findString("rotabStm", dmisFreeStatementSubs))
        {warnSub("rotabStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_rotabStm(dynamic_cast<rotabStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, rotateStm))
    {
      if (!findString("rotateStm", dmisFreeStatementSubs))
        {warnSub("rotateStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_rotateStm(dynamic_cast<rotateStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, rotdefStm))
    {
      if (!findString("rotdefStm", dmisFreeStatementSubs))
        {warnSub("rotdefStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_rotdefStm(dynamic_cast<rotdefStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, rotsetStm))
    {
      if (!findString("rotsetStm", dmisFreeStatementSubs))
        {warnSub("rotsetStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_rotsetStm(dynamic_cast<rotsetStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, saveDatumStm))
    {
      if (!findString("saveDatumStm", dmisFreeStatementSubs))
        {warnSub("saveDatumStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_saveDatumStm(dynamic_cast<saveDatumStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, saveDMLStm))
    {
      if (!findString("saveDMLStm", dmisFreeStatementSubs))
        {warnSub("saveDMLStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_saveDMLStm(dynamic_cast<saveDMLStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, saveFeatureStm))
    {
      if (!findString("saveFeatureStm", dmisFreeStatementSubs))
        {warnSub("saveFeatureStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_saveFeatureStm(dynamic_cast<saveFeatureStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, saveRotaryTableStm))
    {
      if (!findString("saveRotaryTableStm", dmisFreeStatementSubs))
        {warnSub("saveRotaryTableStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_saveRotaryTableStm(dynamic_cast<saveRotaryTableStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, saveSensorStm))
    {
      if (!findString("saveSensorStm", dmisFreeStatementSubs))
        {warnSub("saveSensorStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_saveSensorStm(dynamic_cast<saveSensorStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, scnmodStm))
    {
      if (!findString("scnmodStm", dmisFreeStatementSubs))
        {warnSub("scnmodStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_scnmodStm(dynamic_cast<scnmodStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, scnsetStm))
    {
      if (!findString("scnsetStm", dmisFreeStatementSubs))
        {warnSub("scnsetStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_scnsetStm(dynamic_cast<scnsetStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, sensorStm))
    {
      if (!findString("sensorStm", dmisFreeStatementSubs))
        {warnSub("sensorStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_sensorStm(dynamic_cast<sensorStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, snsdefStm))
    {
      if (!findString("snsdefStm", dmisFreeStatementSubs))
        {warnSub("snsdefStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_snsdefStm(dynamic_cast<snsdefStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, snsetStm))
    {
      if (!findString("snsetStm", dmisFreeStatementSubs))
        {warnSub("snsetStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_snsetStm(dynamic_cast<snsetStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, snsgrpStm))
    {
      if (!findString("snsgrpStm", dmisFreeStatementSubs))
        {warnSub("snsgrpStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_snsgrpStm(dynamic_cast<snsgrpStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, snslctStm))
    {
      if (!findString("snslctStm", dmisFreeStatementSubs))
        {warnSub("snslctStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_snslctStm(dynamic_cast<snslctStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, snsmntStm))
    {
      if (!findString("snsmntStm", dmisFreeStatementSubs))
        {warnSub("snsmntStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_snsmntStm(dynamic_cast<snsmntStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, tecompStm))
    {
      if (!findString("tecompStm", dmisFreeStatementSubs))
        {warnSub("tecompStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_tecompStm(dynamic_cast<tecompStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, textStm))
    {
      if (!findString("textStm", dmisFreeStatementSubs))
        {warnSub("textStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_textStm(dynamic_cast<textStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, thldefStm))
    {
      if (!findString("thldefStm", dmisFreeStatementSubs))
        {warnSub("thldefStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_thldefStm(dynamic_cast<thldefStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, tolAnglStm))
    {
      if (!findString("tolAnglStm", dmisFreeStatementSubs))
        {warnSub("tolAnglStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_tolAnglStm(dynamic_cast<tolAnglStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, tolAnglbStm))
    {
      if (!findString("tolAnglbStm", dmisFreeStatementSubs))
        {warnSub("tolAnglbStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_tolAnglbStm(dynamic_cast<tolAnglbStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, tolAnglrStm))
    {
      if (!findString("tolAnglrStm", dmisFreeStatementSubs))
        {warnSub("tolAnglrStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_tolAnglrStm(dynamic_cast<tolAnglrStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, tolAnglwrtStm))
    {
      if (!findString("tolAnglwrtStm", dmisFreeStatementSubs))
        {warnSub("tolAnglwrtStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_tolAnglwrtStm(dynamic_cast<tolAnglwrtStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, tolCirltyStm))
    {
      if (!findString("tolCirltyStm", dmisFreeStatementSubs))
        {warnSub("tolCirltyStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_tolCirltyStm(dynamic_cast<tolCirltyStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, tolComposStm))
    {
      if (!findString("tolComposStm", dmisFreeStatementSubs))
        {warnSub("tolComposStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_tolComposStm(dynamic_cast<tolComposStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, tolConcenStm))
    {
      if (!findString("tolConcenStm", dmisFreeStatementSubs))
        {warnSub("tolConcenStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_tolConcenStm(dynamic_cast<tolConcenStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, tolCortolStm))
    {
      if (!findString("tolCortolStm", dmisFreeStatementSubs))
        {warnSub("tolCortolStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_tolCortolStm(dynamic_cast<tolCortolStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, tolCproflStm))
    {
      if (!findString("tolCproflStm", dmisFreeStatementSubs))
        {warnSub("tolCproflStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_tolCproflStm(dynamic_cast<tolCproflStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, tolCprofsStm))
    {
      if (!findString("tolCprofsStm", dmisFreeStatementSubs))
        {warnSub("tolCprofsStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_tolCprofsStm(dynamic_cast<tolCprofsStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, tolCrnoutStm))
    {
      if (!findString("tolCrnoutStm", dmisFreeStatementSubs))
        {warnSub("tolCrnoutStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_tolCrnoutStm(dynamic_cast<tolCrnoutStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, tolCylctyStm))
    {
      if (!findString("tolCylctyStm", dmisFreeStatementSubs))
        {warnSub("tolCylctyStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_tolCylctyStm(dynamic_cast<tolCylctyStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, tolDiamStm))
    {
      if (!findString("tolDiamStm", dmisFreeStatementSubs))
        {warnSub("tolDiamStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_tolDiamStm(dynamic_cast<tolDiamStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, tolDistbStm))
    {
      if (!findString("tolDistbStm", dmisFreeStatementSubs))
        {warnSub("tolDistbStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_tolDistbStm(dynamic_cast<tolDistbStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, tolDistwrtStm))
    {
      if (!findString("tolDistwrtStm", dmisFreeStatementSubs))
        {warnSub("tolDistwrtStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_tolDistwrtStm(dynamic_cast<tolDistwrtStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, tolFlatStm))
    {
      if (!findString("tolFlatStm", dmisFreeStatementSubs))
        {warnSub("tolFlatStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_tolFlatStm(dynamic_cast<tolFlatStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, tolGtolStm))
    {
      if (!findString("tolGtolStm", dmisFreeStatementSubs))
        {warnSub("tolGtolStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_tolGtolStm(dynamic_cast<tolGtolStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, tolParlelStm))
    {
      if (!findString("tolParlelStm", dmisFreeStatementSubs))
        {warnSub("tolParlelStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_tolParlelStm(dynamic_cast<tolParlelStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, tolPerpStm))
    {
      if (!findString("tolPerpStm", dmisFreeStatementSubs))
        {warnSub("tolPerpStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_tolPerpStm(dynamic_cast<tolPerpStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, tolPosStm))
    {
      if (!findString("tolPosStm", dmisFreeStatementSubs))
        {warnSub("tolPosStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_tolPosStm(dynamic_cast<tolPosStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, tolProflStm))
    {
      if (!findString("tolProflStm", dmisFreeStatementSubs))
        {warnSub("tolProflStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_tolProflStm(dynamic_cast<tolProflStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, tolProfpStm))
    {
      if (!findString("tolProfpStm", dmisFreeStatementSubs))
        {warnSub("tolProfpStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_tolProfpStm(dynamic_cast<tolProfpStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, tolProfsStm))
    {
      if (!findString("tolProfsStm", dmisFreeStatementSubs))
        {warnSub("tolProfsStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_tolProfsStm(dynamic_cast<tolProfsStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, tolRadStm))
    {
      if (!findString("tolRadStm", dmisFreeStatementSubs))
        {warnSub("tolRadStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_tolRadStm(dynamic_cast<tolRadStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, tolStrghtStm))
    {
      if (!findString("tolStrghtStm", dmisFreeStatementSubs))
        {warnSub("tolStrghtStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_tolStrghtStm(dynamic_cast<tolStrghtStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, tolSymStm))
    {
      if (!findString("tolSymStm", dmisFreeStatementSubs))
        {warnSub("tolSymStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_tolSymStm(dynamic_cast<tolSymStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, tolTrnoutStm))
    {
      if (!findString("tolTrnoutStm", dmisFreeStatementSubs))
        {warnSub("tolTrnoutStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_tolTrnoutStm(dynamic_cast<tolTrnoutStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, tolUsetolStm))
    {
      if (!findString("tolUsetolStm", dmisFreeStatementSubs))
        {warnSub("tolUsetolStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_tolUsetolStm(dynamic_cast<tolUsetolStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, tolWidthStm))
    {
      if (!findString("tolWidthStm", dmisFreeStatementSubs))
        {warnSub("tolWidthStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_tolWidthStm(dynamic_cast<tolWidthStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, tooldfStm))
    {
      if (!findString("tooldfStm", dmisFreeStatementSubs))
        {warnSub("tooldfStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_tooldfStm(dynamic_cast<tooldfStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, transStm))
    {
      if (!findString("transStm", dmisFreeStatementSubs))
        {warnSub("transStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_transStm(dynamic_cast<transStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, uncertalgStm))
    {
      if (!findString("uncertalgStm", dmisFreeStatementSubs))
        {warnSub("uncertalgStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_uncertalgStm(dynamic_cast<uncertalgStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, uncertsetStm))
    {
      if (!findString("uncertsetStm", dmisFreeStatementSubs))
        {warnSub("uncertsetStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_uncertsetStm(dynamic_cast<uncertsetStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, unitsStm))
    {
      if (!findString("unitsStm", dmisFreeStatementSubs))
        {warnSub("unitsStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_unitsStm(dynamic_cast<unitsStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, valueStm))
    {
      if (!findString("valueStm", dmisFreeStatementSubs))
        {warnSub("valueStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_valueStm(dynamic_cast<valueStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, vformStm))
    {
      if (!findString("vformStm", dmisFreeStatementSubs))
        {warnSub("vformStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_vformStm(dynamic_cast<vformStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, windefStm))
    {
      if (!findString("windefStm", dmisFreeStatementSubs))
        {warnSub("windefStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_windefStm(dynamic_cast<windefStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, wkplanStm))
    {
      if (!findString("wkplanStm", dmisFreeStatementSubs))
        {warnSub("wkplanStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_wkplanStm(dynamic_cast<wkplanStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, wristStm))
    {
      if (!findString("wristStm", dmisFreeStatementSubs))
        {warnSub("wristStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_wristStm(dynamic_cast<wristStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, writeStm))
    {
      if (!findString("writeStm", dmisFreeStatementSubs))
        {warnSub("writeStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_writeStm(dynamic_cast<writeStm *>(a_dmisFreeStatement));
      return;
    }
  if (isA(a_dmisFreeStatement, xtractStm))
    {
      if (!findString("xtractStm", dmisFreeStatementSubs))
        {warnSub("xtractStm", "dmisFreeStatement", a_dmisFreeStatement);}
      else
        check_xtractStm(dynamic_cast<xtractStm *>(a_dmisFreeStatement));
      return;
    }
}

/********************************************************************/

void check_dmisItem(
 dmisItem * a_dmisItem)
{
  if (isA(a_dmisItem, dmisFreeStatement))
    {
      if (!findString("dmisFreeStatement", dmisItemSubs))
        {warnSub("dmisFreeStatement", "dmisItem", a_dmisItem);}
      else
        check_dmisFreeStatement(dynamic_cast<dmisFreeStatement *>(a_dmisItem));
      return;
    }
  if (isA(a_dmisItem, dmisBlock))
    {
      if (!findString("dmisBlock", dmisItemSubs))
        {warnSub("dmisBlock", "dmisItem", a_dmisItem);}
      else
        check_dmisBlock(dynamic_cast<dmisBlock *>(a_dmisItem));
      return;
    }
}

/********************************************************************/

void check_dmisOffBlock(
 dmisOffBlock * a_dmisOffBlock)
{
  if (a_dmisOffBlock->get_dmisOffStm())
    {
      if (!findString("a_dmisOffStm", dmisOffBlockAtts))
	{warnAttBlock("dmisOffStm", a_dmisOffBlock->get_dmisOffStm());}
    }
  if (a_dmisOffBlock->get_noParseStmList())
    {
      if (!findString("a_noParseStmList", dmisOffBlockAtts))
	{warnAttBlock("noParseStmList", a_dmisOffBlock->get_noParseStmList()->front());}
      else
        {
          std::list<noParseStm *> * theList;
          std::list<noParseStm *>::iterator iter;
          theList = a_dmisOffBlock->get_noParseStmList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_noParseStm(*iter);
        }
    }
  if (a_dmisOffBlock->get_dmisOnStm())
    {
      if (!findString("a_dmisOnStm", dmisOffBlockAtts))
	{warnAttBlock("dmisOnStm", a_dmisOffBlock->get_dmisOnStm());}
    }
}

/********************************************************************/

void check_dmismdStm(
 dmismdStm * a_dmismdStm)
{
  if (a_dmismdStm->get_stringConst())
    {
      if (!findString("a_stringConst", dmismdStmAtts))
	{warnAtt("a_stringConst", "dmismdStm", a_dmismdStm);}
      else
        check_stringConst(a_dmismdStm->get_stringConst());
    }
  if (a_dmismdStm->get_versionTag())
    {
      if (!findString("a_versionTag", dmismdStmAtts))
	{warnAtt("a_versionTag", "dmismdStm", a_dmismdStm);}
      else
        check_versionTag(a_dmismdStm->get_versionTag());
    }
  if (a_dmismdStm->get_conformItemList())
    {
      if (!findString("a_conformItemList", dmismdStmAtts))
	{warnAtt("a_conformItemList", "dmismdStm", a_dmismdStm);}
      else
        {
          std::list<conformItem *> * theList;
          std::list<conformItem *>::iterator iter;
          theList = a_dmismdStm->get_conformItemList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_conformItem(*iter);
        }
    }
}

/********************************************************************/

void check_dmismnStm(
 dmismnStm * a_dmismnStm)
{
  if (a_dmismnStm->get_stringConst())
    {
      if (!findString("a_stringConst", dmismnStmAtts))
	{warnAtt("a_stringConst", "dmismnStm", a_dmismnStm);}
      else
        check_stringConst(a_dmismnStm->get_stringConst());
    }
  if (a_dmismnStm->get_versionTag())
    {
      if (!findString("a_versionTag", dmismnStmAtts))
	{warnAtt("a_versionTag", "dmismnStm", a_dmismnStm);}
      else
        check_versionTag(a_dmismnStm->get_versionTag());
    }
  if (a_dmismnStm->get_conformItemList())
    {
      if (!findString("a_conformItemList", dmismnStmAtts))
	{warnAtt("a_conformItemList", "dmismnStm", a_dmismnStm);}
      else
        {
          std::list<conformItem *> * theList;
          std::list<conformItem *>::iterator iter;
          theList = a_dmismnStm->get_conformItemList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_conformItem(*iter);
        }
    }
}

/********************************************************************/

void check_doBlock(
 doBlock * a_doBlock)
{
  if (a_doBlock->get_doStm())
    {
      if (!findString("a_doStm", doBlockAtts))
	{warnAttBlock("doStm", a_doBlock->get_doStm());}
      else
        check_doStm(a_doBlock->get_doStm());
    }
  if (a_doBlock->get_dmisItemList())
    {
      if (!findString("a_dmisItemList", doBlockAtts))
	{warnAttBlock("dmisItemList", a_doBlock->get_dmisItemList()->front());}
      else
        {
          std::list<dmisItem *> * theList;
          std::list<dmisItem *>::iterator iter;
          theList = a_doBlock->get_dmisItemList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_dmisItem(*iter);
        }
    }
  if (a_doBlock->get_enddoStm())
    {
      if (!findString("a_enddoStm", doBlockAtts))
	{warnAttBlock("enddoStm", a_doBlock->get_enddoStm());}
    }
}

/********************************************************************/

void check_doStm(
 doStm * a_doStm)
{
  if (a_doStm->get_index())
    {
      if (!findString("index", doStmAtts))
	{warnAtt("index", "doStm", a_doStm);}
      else
        check_intVar(a_doStm->get_index());
    }
  if (a_doStm->get_init())
    {
      if (!findString("init", doStmAtts))
	{warnAtt("init", "doStm", a_doStm);}
      else
        check_intVal(a_doStm->get_init());
    }
  if (a_doStm->get_limit())
    {
      if (!findString("limit", doStmAtts))
	{warnAtt("limit", "doStm", a_doStm);}
      else
        check_intVal(a_doStm->get_limit());
    }
  if (a_doStm->get_incr())
    {
      if (!findString("incr", doStmAtts))
	{warnAtt("incr", "doStm", a_doStm);}
      else
        check_intVal(a_doStm->get_incr());
    }
}

/********************************************************************/

void check_drLabel(
 drLabel * a_drLabel)
{
  if (a_drLabel->get_labelName())
    {
      if (!findString("a_labelName", drLabelAtts))
	{warnAtt("a_labelName", "drLabel", a_drLabel);}
      else
        check_labelName(a_drLabel->get_labelName());
    }
}

/********************************************************************/

void check_dsLabel(
 dsLabel * a_dsLabel)
{
  if (a_dsLabel->get_labelName())
    {
      if (!findString("a_labelName", dsLabelAtts))
	{warnAtt("a_labelName", "dsLabel", a_dsLabel);}
      else
        check_labelName(a_dsLabel->get_labelName());
    }
}

/********************************************************************/

void check_dvLabel(
 dvLabel * a_dvLabel)
{
  if (a_dvLabel->get_labelName())
    {
      if (!findString("a_labelName", dvLabelAtts))
	{warnAtt("a_labelName", "dvLabel", a_dvLabel);}
      else
        check_labelName(a_dvLabel->get_labelName());
    }
}

/********************************************************************/

void check_equateCad(
 equateCad * a_equateCad)
{
  if (a_equateCad->get_equateFrom())
    {
      if (!findString("equateFrom", equateCadAtts))
	{warnAtt("equateFrom", "equateCad", a_equateCad);}
      else
        check_daLabel(a_equateCad->get_equateFrom());
    }
  if (a_equateCad->get_equateCadcs())
    {
      if (!findString("a_equateCadcs", equateCadAtts))
	{warnAtt("a_equateCadcs", "equateCad", a_equateCad);}
      else
        check_equateCadcs(a_equateCad->get_equateCadcs());
    }
}

/********************************************************************/

void check_equateCadcs(
 equateCadcs * a_equateCadcs)
{
  if (isA(a_equateCadcs, equateCadcs_matrix))
    {
      if (!findString("equateCadcs_matrix", equateCadcsSubs))
        {warnSub("equateCadcs_matrix", "equateCadcs", a_equateCadcs);}
      else
        check_equateCadcs_matrix(dynamic_cast<equateCadcs_matrix *>(a_equateCadcs));
      return;
    }
  if (isA(a_equateCadcs, equateCadcs_stringVal))
    {
      if (!findString("equateCadcs_stringVal", equateCadcsSubs))
        {warnSub("equateCadcs_stringVal", "equateCadcs", a_equateCadcs);}
      else
        check_equateCadcs_stringVal(dynamic_cast<equateCadcs_stringVal *>(a_equateCadcs));
      return;
    }
}

/********************************************************************/

void check_equateCadcs_matrix(
 equateCadcs_matrix * a_equateCadcs_matrix)
{
  if (a_equateCadcs_matrix->get_didLabel())
    {
      if (!findString("a_didLabel", equateCadcs_matrixAtts))
	{warnAtt("a_didLabel", "equateCadcs_matrix", a_equateCadcs_matrix);}
      else
        check_didLabel(a_equateCadcs_matrix->get_didLabel());
    }
  if (a_equateCadcs_matrix->get_matrix())
    {
      if (!findString("a_matrix", equateCadcs_matrixAtts))
	{warnAtt("a_matrix", "equateCadcs_matrix", a_equateCadcs_matrix);}
      else
        check_matrix(a_equateCadcs_matrix->get_matrix());
    }
}

/********************************************************************/

void check_equateCadcs_stringVal(
 equateCadcs_stringVal * a_equateCadcs_stringVal)
{
  if (a_equateCadcs_stringVal->get_didLabel())
    {
      if (!findString("a_didLabel", equateCadcs_stringValAtts))
	{warnAtt("a_didLabel", "equateCadcs_stringVal", a_equateCadcs_stringVal);}
      else
        check_didLabel(a_equateCadcs_stringVal->get_didLabel());
    }
  if (a_equateCadcs_stringVal->get_text())
    {
      if (!findString("text", equateCadcs_stringValAtts))
	{warnAtt("text", "equateCadcs_stringVal", a_equateCadcs_stringVal);}
      else
        check_stringVal(a_equateCadcs_stringVal->get_text());
    }
}

/********************************************************************/

void check_equateDatum(
 equateDatum * a_equateDatum)
{
  if (a_equateDatum->get_equateFrom())
    {
      if (!findString("equateFrom", equateDatumAtts))
	{warnAtt("equateFrom", "equateDatum", a_equateDatum);}
      else
        check_daLabel(a_equateDatum->get_equateFrom());
    }
  if (a_equateDatum->get_equateTo())
    {
      if (!findString("equateTo", equateDatumAtts))
	{warnAtt("equateTo", "equateDatum", a_equateDatum);}
      else
        check_daLabel(a_equateDatum->get_equateTo());
    }
}

/********************************************************************/

void check_equateMinor(
 equateMinor * a_equateMinor)
{
  if (isA(a_equateMinor, equateDatum))
    {
      if (!findString("equateDatum", equateMinorSubs))
        {warnSub("equateDatum", "equateMinor", a_equateMinor);}
      else
        check_equateDatum(dynamic_cast<equateDatum *>(a_equateMinor));
      return;
    }
  if (isA(a_equateMinor, equateCad))
    {
      if (!findString("equateCad", equateMinorSubs))
        {warnSub("equateCad", "equateMinor", a_equateMinor);}
      else
        check_equateCad(dynamic_cast<equateCad *>(a_equateMinor));
      return;
    }
}

/********************************************************************/

void check_equateStm(
 equateStm * a_equateStm)
{
  if (a_equateStm->get_equateMinor())
    {
      if (!findString("a_equateMinor", equateStmAtts))
	{warnAtt("a_equateMinor", "equateStm", a_equateStm);}
      else
        check_equateMinor(a_equateStm->get_equateMinor());
    }
}

/********************************************************************/

void check_errorCondition(
 errorCondition * a_errorCondition)
{
  if (isA(a_errorCondition, errorCondition_ALL))
    {
      if (!findString("errorCondition_ALL", errorConditionSubs))
        {warnSub("errorCondition_ALL", "errorCondition", a_errorCondition);}
      return;
    }
  if (isA(a_errorCondition, errorCondition_ILLEGALTOUCH))
    {
      if (!findString("errorCondition_ILLEGALTOUCH", errorConditionSubs))
        {warnSub("errorCondition_ILLEGALTOUCH", "errorCondition", a_errorCondition);}
      return;
    }
  if (isA(a_errorCondition, errorCondition_NOTOUCH))
    {
      if (!findString("errorCondition_NOTOUCH", errorConditionSubs))
        {warnSub("errorCondition_NOTOUCH", "errorCondition", a_errorCondition);}
      return;
    }
  if (isA(a_errorCondition, errorCondition_intVal))
    {
      if (!findString("errorCondition_intVal", errorConditionSubs))
        {warnSub("errorCondition_intVal", "errorCondition", a_errorCondition);}
      else
        check_errorCondition_intVal(dynamic_cast<errorCondition_intVal *>(a_errorCondition));
      return;
    }
}

/********************************************************************/

void check_errorCondition_intVal(
 errorCondition_intVal * a_errorCondition_intVal)
{
  if (a_errorCondition_intVal->get_ercode())
    {
      if (!findString("ercode", errorCondition_intValAtts))
	{warnAtt("ercode", "errorCondition_intVal", a_errorCondition_intVal);}
      else
        check_intVal(a_errorCondition_intVal->get_ercode());
    }
}

/********************************************************************/

void check_errorMinor(
 errorMinor * a_errorMinor)
{
  if (isA(a_errorMinor, errorMinor_jumpLabel))
    {
      if (!findString("errorMinor_jumpLabel", errorMinorSubs))
        {warnSub("errorMinor_jumpLabel", "errorMinor", a_errorMinor);}
      else
        check_errorMinor_jumpLabel(dynamic_cast<errorMinor_jumpLabel *>(a_errorMinor));
      return;
    }
  if (isA(a_errorMinor, errorMinor_AUTO))
    {
      if (!findString("errorMinor_AUTO", errorMinorSubs))
        {warnSub("errorMinor_AUTO", "errorMinor", a_errorMinor);}
      else
        check_errorMinor_AUTO(dynamic_cast<errorMinor_AUTO *>(a_errorMinor));
      return;
    }
  if (isA(a_errorMinor, errorMinor_OFF))
    {
      if (!findString("errorMinor_OFF", errorMinorSubs))
        {warnSub("errorMinor_OFF", "errorMinor", a_errorMinor);}
      return;
    }
}

/********************************************************************/

void check_errorMinor_AUTO(
 errorMinor_AUTO * a_errorMinor_AUTO)
{
  if (a_errorMinor_AUTO->get_errorCondition())
    {
      if (!findString("a_errorCondition", errorMinor_AUTOAtts))
	{warnAtt("a_errorCondition", "errorMinor_AUTO", a_errorMinor_AUTO);}
      else
        check_errorCondition(a_errorMinor_AUTO->get_errorCondition());
    }
}

/********************************************************************/

void check_errorMinor_jumpLabel(
 errorMinor_jumpLabel * a_errorMinor_jumpLabel)
{
  if (a_errorMinor_jumpLabel->get_jumpLabel())
    {
      if (!findString("a_jumpLabel", errorMinor_jumpLabelAtts))
	{warnAtt("a_jumpLabel", "errorMinor_jumpLabel", a_errorMinor_jumpLabel);}
      else
        check_jumpLabel(a_errorMinor_jumpLabel->get_jumpLabel());
    }
  if (a_errorMinor_jumpLabel->get_errorCondition())
    {
      if (!findString("a_errorCondition", errorMinor_jumpLabelAtts))
	{warnAtt("a_errorCondition", "errorMinor_jumpLabel", a_errorMinor_jumpLabel);}
      else
        check_errorCondition(a_errorMinor_jumpLabel->get_errorCondition());
    }
}

/********************************************************************/

void check_errorStm(
 errorStm * a_errorStm)
{
  if (a_errorStm->get_errorMinor())
    {
      if (!findString("a_errorMinor", errorStmAtts))
	{warnAtt("a_errorMinor", "errorStm", a_errorStm);}
      else
        check_errorMinor(a_errorStm->get_errorMinor());
    }
}

/********************************************************************/

void check_euler(
 euler * a_euler)
{
  if (a_euler->get_ang1())
    {
      if (!findString("ang1", eulerAtts))
	{warnAtt("ang1", "euler", a_euler);}
      else
        check_rentVal(a_euler->get_ang1());
    }
  if (a_euler->get_ang2())
    {
      if (!findString("ang2", eulerAtts))
	{warnAtt("ang2", "euler", a_euler);}
      else
        check_rentVal(a_euler->get_ang2());
    }
  if (a_euler->get_ang3())
    {
      if (!findString("ang3", eulerAtts))
	{warnAtt("ang3", "euler", a_euler);}
      else
        check_rentVal(a_euler->get_ang3());
    }
}

/********************************************************************/

void check_evalDat(
 evalDat * a_evalDat)
{
  if (isA(a_evalDat, evalDatDatFa))
    {
      if (!findString("evalDatDatFa", evalDatSubs))
        {warnSub("evalDatDatFa", "evalDat", a_evalDat);}
      else
        check_evalDatDatFa(dynamic_cast<evalDatDatFa *>(a_evalDat));
      return;
    }
  if (isA(a_evalDat, evalDatFaDat))
    {
      if (!findString("evalDatFaDat", evalDatSubs))
        {warnSub("evalDatFaDat", "evalDat", a_evalDat);}
      else
        check_evalDatFaDat(dynamic_cast<evalDatFaDat *>(a_evalDat));
      return;
    }
}

/********************************************************************/

void check_evalDatDatFa(
 evalDatDatFa * a_evalDatDatFa)
{
  if (a_evalDatDatFa->get_datLabel())
    {
      if (!findString("a_datLabel", evalDatDatFaAtts))
	{warnAtt("a_datLabel", "evalDatDatFa", a_evalDatDatFa);}
      else
        check_datLabel(a_evalDatDatFa->get_datLabel());
    }
  if (a_evalDatDatFa->get_faLabel())
    {
      if (!findString("a_faLabel", evalDatDatFaAtts))
	{warnAtt("a_faLabel", "evalDatDatFa", a_evalDatDatFa);}
      else
        check_faLabel(a_evalDatDatFa->get_faLabel());
    }
  if (a_evalDatDatFa->get_tLabel())
    {
      if (!findString("a_tLabel", evalDatDatFaAtts))
	{warnAtt("a_tLabel", "evalDatDatFa", a_evalDatDatFa);}
      else
        check_tLabel(a_evalDatDatFa->get_tLabel());
    }
}

/********************************************************************/

void check_evalDatFaDat(
 evalDatFaDat * a_evalDatFaDat)
{
  if (a_evalDatFaDat->get_faLabel())
    {
      if (!findString("a_faLabel", evalDatFaDatAtts))
	{warnAtt("a_faLabel", "evalDatFaDat", a_evalDatFaDat);}
      else
        check_faLabel(a_evalDatFaDat->get_faLabel());
    }
  if (a_evalDatFaDat->get_datLabel())
    {
      if (!findString("a_datLabel", evalDatFaDatAtts))
	{warnAtt("a_datLabel", "evalDatFaDat", a_evalDatFaDat);}
      else
        check_datLabel(a_evalDatFaDat->get_datLabel());
    }
  if (a_evalDatFaDat->get_tLabel())
    {
      if (!findString("a_tLabel", evalDatFaDatAtts))
	{warnAtt("a_tLabel", "evalDatFaDat", a_evalDatFaDat);}
      else
        check_tLabel(a_evalDatFaDat->get_tLabel());
    }
}

/********************************************************************/

void check_evalFeat(
 evalFeat * a_evalFeat)
{
  if (isA(a_evalFeat, evalFeatFaT))
    {
      if (!findString("evalFeatFaT", evalFeatSubs))
        {warnSub("evalFeatFaT", "evalFeat", a_evalFeat);}
      else
        check_evalFeatFaT(dynamic_cast<evalFeatFaT *>(a_evalFeat));
      return;
    }
  if (isA(a_evalFeat, evalFeatFaFT))
    {
      if (!findString("evalFeatFaFT", evalFeatSubs))
        {warnSub("evalFeatFaFT", "evalFeat", a_evalFeat);}
      else
        check_evalFeatFaFT(dynamic_cast<evalFeatFaFT *>(a_evalFeat));
      return;
    }
  if (isA(a_evalFeat, evalFeatFFaT))
    {
      if (!findString("evalFeatFFaT", evalFeatSubs))
        {warnSub("evalFeatFFaT", "evalFeat", a_evalFeat);}
      else
        check_evalFeatFFaT(dynamic_cast<evalFeatFFaT *>(a_evalFeat));
      return;
    }
  if (isA(a_evalFeat, evalFeatFaFaT))
    {
      if (!findString("evalFeatFaFaT", evalFeatSubs))
        {warnSub("evalFeatFaFaT", "evalFeat", a_evalFeat);}
      else
        check_evalFeatFaFaT(dynamic_cast<evalFeatFaFaT *>(a_evalFeat));
      return;
    }
}

/********************************************************************/

void check_evalFeatFFaT(
 evalFeatFFaT * a_evalFeatFFaT)
{
  if (a_evalFeatFFaT->get_f())
    {
      if (!findString("f", evalFeatFFaTAtts))
	{warnAtt("f", "evalFeatFFaT", a_evalFeatFFaT);}
      else
        check_fLabel(a_evalFeatFFaT->get_f());
    }
  if (a_evalFeatFFaT->get_fa())
    {
      if (!findString("fa", evalFeatFFaTAtts))
	{warnAtt("fa", "evalFeatFFaT", a_evalFeatFFaT);}
      else
        check_faLabel(a_evalFeatFFaT->get_fa());
    }
  if (a_evalFeatFFaT->get_t())
    {
      if (!findString("t", evalFeatFFaTAtts))
	{warnAtt("t", "evalFeatFFaT", a_evalFeatFFaT);}
      else
        check_tLabel(a_evalFeatFFaT->get_t());
    }
}

/********************************************************************/

void check_evalFeatFaFT(
 evalFeatFaFT * a_evalFeatFaFT)
{
  if (a_evalFeatFaFT->get_fa())
    {
      if (!findString("fa", evalFeatFaFTAtts))
	{warnAtt("fa", "evalFeatFaFT", a_evalFeatFaFT);}
      else
        check_faLabel(a_evalFeatFaFT->get_fa());
    }
  if (a_evalFeatFaFT->get_f())
    {
      if (!findString("f", evalFeatFaFTAtts))
	{warnAtt("f", "evalFeatFaFT", a_evalFeatFaFT);}
      else
        check_fLabel(a_evalFeatFaFT->get_f());
    }
  if (a_evalFeatFaFT->get_t())
    {
      if (!findString("t", evalFeatFaFTAtts))
	{warnAtt("t", "evalFeatFaFT", a_evalFeatFaFT);}
      else
        check_tLabel(a_evalFeatFaFT->get_t());
    }
}

/********************************************************************/

void check_evalFeatFaFaT(
 evalFeatFaFaT * a_evalFeatFaFaT)
{
  if (a_evalFeatFaFaT->get_fa1())
    {
      if (!findString("fa1", evalFeatFaFaTAtts))
	{warnAtt("fa1", "evalFeatFaFaT", a_evalFeatFaFaT);}
      else
        check_faLabel(a_evalFeatFaFaT->get_fa1());
    }
  if (a_evalFeatFaFaT->get_fa2())
    {
      if (!findString("fa2", evalFeatFaFaTAtts))
	{warnAtt("fa2", "evalFeatFaFaT", a_evalFeatFaFaT);}
      else
        check_faLabel(a_evalFeatFaFaT->get_fa2());
    }
  if (a_evalFeatFaFaT->get_t())
    {
      if (!findString("t", evalFeatFaFaTAtts))
	{warnAtt("t", "evalFeatFaFaT", a_evalFeatFaFaT);}
      else
        check_tLabel(a_evalFeatFaFaT->get_t());
    }
}

/********************************************************************/

void check_evalFeatFaT(
 evalFeatFaT * a_evalFeatFaT)
{
  if (a_evalFeatFaT->get_fa())
    {
      if (!findString("fa", evalFeatFaTAtts))
	{warnAtt("fa", "evalFeatFaT", a_evalFeatFaT);}
      else
        check_faLabel(a_evalFeatFaT->get_fa());
    }
  if (a_evalFeatFaT->get_tLabelList())
    {
      if (!findString("a_tLabelList", evalFeatFaTAtts))
	{warnAtt("a_tLabelList", "evalFeatFaT", a_evalFeatFaT);}
      else
        {
          std::list<tLabel *> * theList;
          std::list<tLabel *>::iterator iter;
          theList = a_evalFeatFaT->get_tLabelList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_tLabel(*iter);
        }
    }
}

/********************************************************************/

void check_evalKeychar(
 evalKeychar * a_evalKeychar)
{
  if (isA(a_evalKeychar, kcLabel))
    {
      if (!findString("kcLabel", evalKeycharSubs))
        {warnSub("kcLabel", "evalKeychar", a_evalKeychar);}
      else
        check_kcLabel(dynamic_cast<kcLabel *>(a_evalKeychar));
      return;
    }
}

/********************************************************************/

void check_evalMinor(
 evalMinor * a_evalMinor)
{
  if (isA(a_evalMinor, evalFeat))
    {
      if (!findString("evalFeat", evalMinorSubs))
        {warnSub("evalFeat", "evalMinor", a_evalMinor);}
      else
        check_evalFeat(dynamic_cast<evalFeat *>(a_evalMinor));
      return;
    }
  if (isA(a_evalMinor, evalDat))
    {
      if (!findString("evalDat", evalMinorSubs))
        {warnSub("evalDat", "evalMinor", a_evalMinor);}
      else
        check_evalDat(dynamic_cast<evalDat *>(a_evalMinor));
      return;
    }
  if (isA(a_evalMinor, evalKeychar))
    {
      if (!findString("evalKeychar", evalMinorSubs))
        {warnSub("evalKeychar", "evalMinor", a_evalMinor);}
      else
        check_evalKeychar(dynamic_cast<evalKeychar *>(a_evalMinor));
      return;
    }
}

/********************************************************************/

void check_evalOrOutput(
 evalOrOutput * a_evalOrOutput)
{
  if (isA(a_evalOrOutput, evalStm))
    {
      if (!findString("evalStm", evalOrOutputSubs))
        {warnSub("evalStm", "evalOrOutput", a_evalOrOutput);}
      else
        check_evalStm(dynamic_cast<evalStm *>(a_evalOrOutput));
      return;
    }
  if (isA(a_evalOrOutput, outputStm))
    {
      if (!findString("outputStm", evalOrOutputSubs))
        {warnSub("outputStm", "evalOrOutput", a_evalOrOutput);}
      else
        check_outputStm(dynamic_cast<outputStm *>(a_evalOrOutput));
      return;
    }
}

/********************************************************************/

void check_evalStm(
 evalStm * a_evalStm)
{
  if (a_evalStm->get_evalMinor())
    {
      if (!findString("a_evalMinor", evalStmAtts))
	{warnAtt("a_evalMinor", "evalStm", a_evalStm);}
      else
        check_evalMinor(a_evalStm->get_evalMinor());
    }
}

/********************************************************************/

void check_extensMinor(
 extensMinor * a_extensMinor)
{
  if (isA(a_extensMinor, extensMinor_vector))
    {
      if (!findString("extensMinor_vector", extensMinorSubs))
        {warnSub("extensMinor_vector", "extensMinor", a_extensMinor);}
      else
        check_extensMinor_vector(dynamic_cast<extensMinor_vector *>(a_extensMinor));
      return;
    }
  if (isA(a_extensMinor, extensMinor_VEC))
    {
      if (!findString("extensMinor_VEC", extensMinorSubs))
        {warnSub("extensMinor_VEC", "extensMinor", a_extensMinor);}
      else
        check_extensMinor_VEC(dynamic_cast<extensMinor_VEC *>(a_extensMinor));
      return;
    }
}

/********************************************************************/

void check_extensMinor_VEC(
 extensMinor_VEC * a_extensMinor_VEC)
{
  if (a_extensMinor_VEC->get_perp())
    {
      if (!findString("perp", extensMinor_VECAtts))
	{warnAtt("perp", "extensMinor_VEC", a_extensMinor_VEC);}
      else
        check_vector(a_extensMinor_VEC->get_perp());
    }
  if (a_extensMinor_VEC->get_length())
    {
      if (!findString("length", extensMinor_VECAtts))
	{warnAtt("length", "extensMinor_VEC", a_extensMinor_VEC);}
      else
        check_rentVal(a_extensMinor_VEC->get_length());
    }
}

/********************************************************************/

void check_extensMinor_vector(
 extensMinor_vector * a_extensMinor_vector)
{
  if (a_extensMinor_vector->get_offset())
    {
      if (!findString("offset", extensMinor_vectorAtts))
	{warnAtt("offset", "extensMinor_vector", a_extensMinor_vector);}
      else
        check_vector(a_extensMinor_vector->get_offset());
    }
}

/********************************************************************/

void check_extensStm(
 extensStm * a_extensStm)
{
  if (a_extensStm->get_sxLabel())
    {
      if (!findString("a_sxLabel", extensStmAtts))
	{warnAtt("a_sxLabel", "extensStm", a_extensStm);}
      else
        check_sxLabel(a_extensStm->get_sxLabel());
    }
  if (a_extensStm->get_extensMinor())
    {
      if (!findString("a_extensMinor", extensStmAtts))
	{warnAtt("a_extensMinor", "extensStm", a_extensStm);}
      else
        check_extensMinor(a_extensStm->get_extensMinor());
    }
}

/********************************************************************/

void check_extfilDme(
 extfilDme * a_extfilDme)
{
  if (a_extfilDme->get_filename())
    {
      if (!findString("filename", extfilDmeAtts))
	{warnAtt("filename", "extfilDme", a_extfilDme);}
      else
        check_stringVal(a_extfilDme->get_filename());
    }
}

/********************************************************************/

void check_extfilDmis(
 extfilDmis * a_extfilDmis)
{
  if (a_extfilDmis->get_filename())
    {
      if (!findString("filename", extfilDmisAtts))
	{warnAtt("filename", "extfilDmis", a_extfilDmis);}
      else
        check_stringVal(a_extfilDmis->get_filename());
    }
}

/********************************************************************/

void check_extfilMinor(
 extfilMinor * a_extfilMinor)
{
  if (isA(a_extfilMinor, extfilDmis))
    {
      if (!findString("extfilDmis", extfilMinorSubs))
        {warnSub("extfilDmis", "extfilMinor", a_extfilMinor);}
      else
        check_extfilDmis(dynamic_cast<extfilDmis *>(a_extfilMinor));
      return;
    }
  if (isA(a_extfilMinor, extfilDme))
    {
      if (!findString("extfilDme", extfilMinorSubs))
        {warnSub("extfilDme", "extfilMinor", a_extfilMinor);}
      else
        check_extfilDme(dynamic_cast<extfilDme *>(a_extfilMinor));
      return;
    }
}

/********************************************************************/

void check_extfilStm(
 extfilStm * a_extfilStm)
{
  if (a_extfilStm->get_extfilMinor())
    {
      if (!findString("a_extfilMinor", extfilStmAtts))
	{warnAtt("a_extfilMinor", "extfilStm", a_extfilStm);}
      else
        check_extfilMinor(a_extfilStm->get_extfilMinor());
    }
}

/********************************************************************/

void check_extremConst(
 extremConst * a_extremConst)
{
  if (isA(a_extremConst, extremConst_MIN))
    {
      if (!findString("extremConst_MIN", extremConstSubs))
        {warnSub("extremConst_MIN", "extremConst", a_extremConst);}
      else
        check_extremConst_MIN(dynamic_cast<extremConst_MIN *>(a_extremConst));
      return;
    }
  if (isA(a_extremConst, extremConst_MAX))
    {
      if (!findString("extremConst_MAX", extremConstSubs))
        {warnSub("extremConst_MAX", "extremConst", a_extremConst);}
      else
        check_extremConst_MAX(dynamic_cast<extremConst_MAX *>(a_extremConst));
      return;
    }
}

/********************************************************************/

void check_extremConstAxial(
 extremConstAxial * a_extremConstAxial)
{
  if (isA(a_extremConstAxial, posDir))
    {
      if (!findString("posDir", extremConstAxialSubs))
        {warnSub("posDir", "extremConstAxial", a_extremConstAxial);}
      else
        check_posDir(dynamic_cast<posDir *>(a_extremConstAxial));
      return;
    }
}

/********************************************************************/

void check_extremConstDir(
 extremConstDir * a_extremConstDir)
{
  if (isA(a_extremConstDir, extremConstAxial))
    {
      if (!findString("extremConstAxial", extremConstDirSubs))
        {warnSub("extremConstAxial", "extremConstDir", a_extremConstDir);}
      else
        check_extremConstAxial(dynamic_cast<extremConstAxial *>(a_extremConstDir));
      return;
    }
  if (isA(a_extremConstDir, extremConstVectorial))
    {
      if (!findString("extremConstVectorial", extremConstDirSubs))
        {warnSub("extremConstVectorial", "extremConstDir", a_extremConstDir);}
      else
        check_extremConstVectorial(dynamic_cast<extremConstVectorial *>(a_extremConstDir));
      return;
    }
  if (isA(a_extremConstDir, extremConstFeature))
    {
      if (!findString("extremConstFeature", extremConstDirSubs))
        {warnSub("extremConstFeature", "extremConstDir", a_extremConstDir);}
      else
        check_extremConstFeature(dynamic_cast<extremConstFeature *>(a_extremConstDir));
      return;
    }
  if (isA(a_extremConstDir, extremConstRadial))
    {
      if (!findString("extremConstRadial", extremConstDirSubs))
        {warnSub("extremConstRadial", "extremConstDir", a_extremConstDir);}
      return;
    }
}

/********************************************************************/

void check_extremConstFeature(
 extremConstFeature * a_extremConstFeature)
{
  if (isA(a_extremConstFeature, featureLabel))
    {
      if (!findString("featureLabel", extremConstFeatureSubs))
        {warnSub("featureLabel", "extremConstFeature", a_extremConstFeature);}
      else
        check_featureLabel(dynamic_cast<featureLabel *>(a_extremConstFeature));
      return;
    }
}

/********************************************************************/

void check_extremConstVectorial(
 extremConstVectorial * a_extremConstVectorial)
{
  if (a_extremConstVectorial->get_dir())
    {
      if (!findString("dir", extremConstVectorialAtts))
	{warnAtt("dir", "extremConstVectorial", a_extremConstVectorial);}
      else
        check_vector(a_extremConstVectorial->get_dir());
    }
}

/********************************************************************/

void check_extremConst_MAX(
 extremConst_MAX * a_extremConst_MAX)
{
  if (a_extremConst_MAX->get_faLabel())
    {
      if (!findString("a_faLabel", extremConst_MAXAtts))
	{warnAtt("a_faLabel", "extremConst_MAX", a_extremConst_MAX);}
      else
        check_faLabel(a_extremConst_MAX->get_faLabel());
    }
  if (a_extremConst_MAX->get_extremConstDir())
    {
      if (!findString("a_extremConstDir", extremConst_MAXAtts))
	{warnAtt("a_extremConstDir", "extremConst_MAX", a_extremConst_MAX);}
      else
        check_extremConstDir(a_extremConst_MAX->get_extremConstDir());
    }
}

/********************************************************************/

void check_extremConst_MIN(
 extremConst_MIN * a_extremConst_MIN)
{
  if (a_extremConst_MIN->get_faLabel())
    {
      if (!findString("a_faLabel", extremConst_MINAtts))
	{warnAtt("a_faLabel", "extremConst_MIN", a_extremConst_MIN);}
      else
        check_faLabel(a_extremConst_MIN->get_faLabel());
    }
  if (a_extremConst_MIN->get_extremConstDir())
    {
      if (!findString("a_extremConstDir", extremConst_MINAtts))
	{warnAtt("a_extremConstDir", "extremConst_MIN", a_extremConst_MIN);}
      else
        check_extremConstDir(a_extremConst_MIN->get_extremConstDir());
    }
}

/********************************************************************/

void check_fLabel(
 fLabel * a_fLabel)
{
  if (a_fLabel->get_labelName())
    {
      if (!findString("a_labelName", fLabelAtts))
	{warnAtt("a_labelName", "fLabel", a_fLabel);}
      else
        check_labelName(a_fLabel->get_labelName());
    }
}

/********************************************************************/

void check_faLabel(
 faLabel * a_faLabel)
{
  if (a_faLabel->get_labelName())
    {
      if (!findString("a_labelName", faLabelAtts))
	{warnAtt("a_labelName", "faLabel", a_faLabel);}
      else
        check_labelName(a_faLabel->get_labelName());
    }
}

/********************************************************************/

void check_featArc1Act(
 featArc1Act * a_featArc1Act)
{
  if (a_featArc1Act->get_faLabel())
    {
      if (!findString("a_faLabel", featArc1ActAtts))
	{warnAtt("a_faLabel", "featArc1Act", a_featArc1Act);}
      else
        check_faLabel(a_featArc1Act->get_faLabel());
    }
  if (a_featArc1Act->get_featMinorArc1())
    {
      if (!findString("a_featMinorArc1", featArc1ActAtts))
	{warnAtt("a_featMinorArc1", "featArc1Act", a_featArc1Act);}
      else
        check_featMinorArc1(a_featArc1Act->get_featMinorArc1());
    }
}

/********************************************************************/

void check_featArc1Nom(
 featArc1Nom * a_featArc1Nom)
{
  if (a_featArc1Nom->get_fLabel())
    {
      if (!findString("a_fLabel", featArc1NomAtts))
	{warnAtt("a_fLabel", "featArc1Nom", a_featArc1Nom);}
      else
        check_fLabel(a_featArc1Nom->get_fLabel());
    }
  if (a_featArc1Nom->get_featMinorArc1())
    {
      if (!findString("a_featMinorArc1", featArc1NomAtts))
	{warnAtt("a_featMinorArc1", "featArc1Nom", a_featArc1Nom);}
      else
        check_featMinorArc1(a_featArc1Nom->get_featMinorArc1());
    }
}

/********************************************************************/

void check_featArc1Stm(
 featArc1Stm * a_featArc1Stm)
{
  if (isA(a_featArc1Stm, featArc1Nom))
    {
      if (!findString("featArc1Nom", featArc1StmSubs))
        {warnSub("featArc1Nom", "featArc1Stm", a_featArc1Stm);}
      else
        check_featArc1Nom(dynamic_cast<featArc1Nom *>(a_featArc1Stm));
      return;
    }
  if (isA(a_featArc1Stm, featArc1Act))
    {
      if (!findString("featArc1Act", featArc1StmSubs))
        {warnSub("featArc1Act", "featArc1Stm", a_featArc1Stm);}
      else
        check_featArc1Act(dynamic_cast<featArc1Act *>(a_featArc1Stm));
      return;
    }
}

/********************************************************************/

void check_featArc2Act(
 featArc2Act * a_featArc2Act)
{
  if (a_featArc2Act->get_faLabel())
    {
      if (!findString("a_faLabel", featArc2ActAtts))
	{warnAtt("a_faLabel", "featArc2Act", a_featArc2Act);}
      else
        check_faLabel(a_featArc2Act->get_faLabel());
    }
  if (a_featArc2Act->get_featMinorArc2())
    {
      if (!findString("a_featMinorArc2", featArc2ActAtts))
	{warnAtt("a_featMinorArc2", "featArc2Act", a_featArc2Act);}
      else
        check_featMinorArc2(a_featArc2Act->get_featMinorArc2());
    }
}

/********************************************************************/

void check_featArc2Nom(
 featArc2Nom * a_featArc2Nom)
{
  if (a_featArc2Nom->get_fLabel())
    {
      if (!findString("a_fLabel", featArc2NomAtts))
	{warnAtt("a_fLabel", "featArc2Nom", a_featArc2Nom);}
      else
        check_fLabel(a_featArc2Nom->get_fLabel());
    }
  if (a_featArc2Nom->get_featMinorArc2())
    {
      if (!findString("a_featMinorArc2", featArc2NomAtts))
	{warnAtt("a_featMinorArc2", "featArc2Nom", a_featArc2Nom);}
      else
        check_featMinorArc2(a_featArc2Nom->get_featMinorArc2());
    }
}

/********************************************************************/

void check_featArc2Stm(
 featArc2Stm * a_featArc2Stm)
{
  if (isA(a_featArc2Stm, featArc2Nom))
    {
      if (!findString("featArc2Nom", featArc2StmSubs))
        {warnSub("featArc2Nom", "featArc2Stm", a_featArc2Stm);}
      else
        check_featArc2Nom(dynamic_cast<featArc2Nom *>(a_featArc2Stm));
      return;
    }
  if (isA(a_featArc2Stm, featArc2Act))
    {
      if (!findString("featArc2Act", featArc2StmSubs))
        {warnSub("featArc2Act", "featArc2Stm", a_featArc2Stm);}
      else
        check_featArc2Act(dynamic_cast<featArc2Act *>(a_featArc2Stm));
      return;
    }
}

/********************************************************************/

void check_featCircleAct(
 featCircleAct * a_featCircleAct)
{
  if (a_featCircleAct->get_faLabel())
    {
      if (!findString("a_faLabel", featCircleActAtts))
	{warnAtt("a_faLabel", "featCircleAct", a_featCircleAct);}
      else
        check_faLabel(a_featCircleAct->get_faLabel());
    }
  if (a_featCircleAct->get_featMinorCircle())
    {
      if (!findString("a_featMinorCircle", featCircleActAtts))
	{warnAtt("a_featMinorCircle", "featCircleAct", a_featCircleAct);}
      else
        check_featMinorCircle(a_featCircleAct->get_featMinorCircle());
    }
}

/********************************************************************/

void check_featCircleNom(
 featCircleNom * a_featCircleNom)
{
  if (a_featCircleNom->get_fLabel())
    {
      if (!findString("a_fLabel", featCircleNomAtts))
	{warnAtt("a_fLabel", "featCircleNom", a_featCircleNom);}
      else
        check_fLabel(a_featCircleNom->get_fLabel());
    }
  if (a_featCircleNom->get_featMinorCircle())
    {
      if (!findString("a_featMinorCircle", featCircleNomAtts))
	{warnAtt("a_featMinorCircle", "featCircleNom", a_featCircleNom);}
      else
        check_featMinorCircle(a_featCircleNom->get_featMinorCircle());
    }
}

/********************************************************************/

void check_featCircleStm(
 featCircleStm * a_featCircleStm)
{
  if (isA(a_featCircleStm, featCircleNom))
    {
      if (!findString("featCircleNom", featCircleStmSubs))
        {warnSub("featCircleNom", "featCircleStm", a_featCircleStm);}
      else
        check_featCircleNom(dynamic_cast<featCircleNom *>(a_featCircleStm));
      return;
    }
  if (isA(a_featCircleStm, featCircleAct))
    {
      if (!findString("featCircleAct", featCircleStmSubs))
        {warnSub("featCircleAct", "featCircleStm", a_featCircleStm);}
      else
        check_featCircleAct(dynamic_cast<featCircleAct *>(a_featCircleStm));
      return;
    }
}

/********************************************************************/

void check_featCompoundAxial(
 featCompoundAxial * a_featCompoundAxial)
{
  if (a_featCompoundAxial->get_typePoint())
    {
      if (!findString("a_typePoint", featCompoundAxialAtts))
	{warnAtt("a_typePoint", "featCompoundAxial", a_featCompoundAxial);}
      else
        check_typePoint(a_featCompoundAxial->get_typePoint());
    }
  if (a_featCompoundAxial->get_dir())
    {
      if (!findString("dir", featCompoundAxialAtts))
	{warnAtt("dir", "featCompoundAxial", a_featCompoundAxial);}
      else
        check_vector(a_featCompoundAxial->get_dir());
    }
  if (a_featCompoundAxial->get_fLabel())
    {
      if (!findString("a_fLabel", featCompoundAxialAtts))
	{warnAtt("a_fLabel", "featCompoundAxial", a_featCompoundAxial);}
      else
        check_fLabel(a_featCompoundAxial->get_fLabel());
    }
  if (a_featCompoundAxial->get_featureNominalList())
    {
      if (!findString("a_featureNominalList", featCompoundAxialAtts))
	{warnAtt("a_featureNominalList", "featCompoundAxial", a_featCompoundAxial);}
      else
        {
          std::list<fLabel *> * theList;
          std::list<fLabel *>::iterator iter;
          theList = a_featCompoundAxial->get_featureNominalList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_fLabel(*iter);
        }
    }
}

/********************************************************************/

void check_featCompoundPlane(
 featCompoundPlane * a_featCompoundPlane)
{
  if (a_featCompoundPlane->get_typePoint())
    {
      if (!findString("a_typePoint", featCompoundPlaneAtts))
	{warnAtt("a_typePoint", "featCompoundPlane", a_featCompoundPlane);}
      else
        check_typePoint(a_featCompoundPlane->get_typePoint());
    }
  if (a_featCompoundPlane->get_dir())
    {
      if (!findString("dir", featCompoundPlaneAtts))
	{warnAtt("dir", "featCompoundPlane", a_featCompoundPlane);}
      else
        check_vector(a_featCompoundPlane->get_dir());
    }
  if (a_featCompoundPlane->get_fLabel())
    {
      if (!findString("a_fLabel", featCompoundPlaneAtts))
	{warnAtt("a_fLabel", "featCompoundPlane", a_featCompoundPlane);}
      else
        check_fLabel(a_featCompoundPlane->get_fLabel());
    }
  if (a_featCompoundPlane->get_featureNominalList())
    {
      if (!findString("a_featureNominalList", featCompoundPlaneAtts))
	{warnAtt("a_featureNominalList", "featCompoundPlane", a_featCompoundPlane);}
      else
        {
          std::list<fLabel *> * theList;
          std::list<fLabel *>::iterator iter;
          theList = a_featCompoundPlane->get_featureNominalList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_fLabel(*iter);
        }
    }
}

/********************************************************************/

void check_featCompoundSphere(
 featCompoundSphere * a_featCompoundSphere)
{
  if (a_featCompoundSphere->get_typePoint())
    {
      if (!findString("a_typePoint", featCompoundSphereAtts))
	{warnAtt("a_typePoint", "featCompoundSphere", a_featCompoundSphere);}
      else
        check_typePoint(a_featCompoundSphere->get_typePoint());
    }
  if (a_featCompoundSphere->get_fLabel())
    {
      if (!findString("a_fLabel", featCompoundSphereAtts))
	{warnAtt("a_fLabel", "featCompoundSphere", a_featCompoundSphere);}
      else
        check_fLabel(a_featCompoundSphere->get_fLabel());
    }
  if (a_featCompoundSphere->get_featureNominalList())
    {
      if (!findString("a_featureNominalList", featCompoundSphereAtts))
	{warnAtt("a_featureNominalList", "featCompoundSphere", a_featCompoundSphere);}
      else
        {
          std::list<fLabel *> * theList;
          std::list<fLabel *>::iterator iter;
          theList = a_featCompoundSphere->get_featureNominalList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_fLabel(*iter);
        }
    }
}

/********************************************************************/

void check_featCompoundStm(
 featCompoundStm * a_featCompoundStm)
{
  if (a_featCompoundStm->get_fLabel())
    {
      if (!findString("a_fLabel", featCompoundStmAtts))
	{warnAtt("a_fLabel", "featCompoundStm", a_featCompoundStm);}
      else
        check_fLabel(a_featCompoundStm->get_fLabel());
    }
  if (a_featCompoundStm->get_featMinorCompound())
    {
      if (!findString("a_featMinorCompound", featCompoundStmAtts))
	{warnAtt("a_featMinorCompound", "featCompoundStm", a_featCompoundStm);}
      else
        check_featMinorCompound(a_featCompoundStm->get_featMinorCompound());
    }
}

/********************************************************************/

void check_featConeAct(
 featConeAct * a_featConeAct)
{
  if (a_featConeAct->get_faLabel())
    {
      if (!findString("a_faLabel", featConeActAtts))
	{warnAtt("a_faLabel", "featConeAct", a_featConeAct);}
      else
        check_faLabel(a_featConeAct->get_faLabel());
    }
  if (a_featConeAct->get_featMinorCone())
    {
      if (!findString("a_featMinorCone", featConeActAtts))
	{warnAtt("a_featMinorCone", "featConeAct", a_featConeAct);}
      else
        check_featMinorCone(a_featConeAct->get_featMinorCone());
    }
}

/********************************************************************/

void check_featConeNom(
 featConeNom * a_featConeNom)
{
  if (a_featConeNom->get_fLabel())
    {
      if (!findString("a_fLabel", featConeNomAtts))
	{warnAtt("a_fLabel", "featConeNom", a_featConeNom);}
      else
        check_fLabel(a_featConeNom->get_fLabel());
    }
  if (a_featConeNom->get_featMinorCone())
    {
      if (!findString("a_featMinorCone", featConeNomAtts))
	{warnAtt("a_featMinorCone", "featConeNom", a_featConeNom);}
      else
        check_featMinorCone(a_featConeNom->get_featMinorCone());
    }
}

/********************************************************************/

void check_featConeStm(
 featConeStm * a_featConeStm)
{
  if (isA(a_featConeStm, featConeNom))
    {
      if (!findString("featConeNom", featConeStmSubs))
        {warnSub("featConeNom", "featConeStm", a_featConeStm);}
      else
        check_featConeNom(dynamic_cast<featConeNom *>(a_featConeStm));
      return;
    }
  if (isA(a_featConeStm, featConeAct))
    {
      if (!findString("featConeAct", featConeStmSubs))
        {warnSub("featConeAct", "featConeStm", a_featConeStm);}
      else
        check_featConeAct(dynamic_cast<featConeAct *>(a_featConeStm));
      return;
    }
}

/********************************************************************/

void check_featConradsegAct(
 featConradsegAct * a_featConradsegAct)
{
  if (a_featConradsegAct->get_faLabel())
    {
      if (!findString("a_faLabel", featConradsegActAtts))
	{warnAtt("a_faLabel", "featConradsegAct", a_featConradsegAct);}
      else
        check_faLabel(a_featConradsegAct->get_faLabel());
    }
  if (a_featConradsegAct->get_featMinorConradseg())
    {
      if (!findString("a_featMinorConradseg", featConradsegActAtts))
	{warnAtt("a_featMinorConradseg", "featConradsegAct", a_featConradsegAct);}
      else
        check_featMinorConradseg(a_featConradsegAct->get_featMinorConradseg());
    }
}

/********************************************************************/

void check_featConradsegCart(
 featConradsegCart * a_featConradsegCart)
{
  if (a_featConradsegCart->get_matDir())
    {
      if (!findString("a_matDir", featConradsegCartAtts))
	{warnAtt("a_matDir", "featConradsegCart", a_featConradsegCart);}
      else
        check_matDir(a_featConradsegCart->get_matDir());
    }
  if (a_featConradsegCart->get_axisStart())
    {
      if (!findString("axisStart", featConradsegCartAtts))
	{warnAtt("axisStart", "featConradsegCart", a_featConradsegCart);}
      else
        check_cartPoint(a_featConradsegCart->get_axisStart());
    }
  if (a_featConradsegCart->get_axisEnd())
    {
      if (!findString("axisEnd", featConradsegCartAtts))
	{warnAtt("axisEnd", "featConradsegCart", a_featConradsegCart);}
      else
        check_impCartPoint(a_featConradsegCart->get_axisEnd());
    }
  if (a_featConradsegCart->get_startRad())
    {
      if (!findString("startRad", featConradsegCartAtts))
	{warnAtt("startRad", "featConradsegCart", a_featConradsegCart);}
      else
        check_rentVal(a_featConradsegCart->get_startRad());
    }
  if (a_featConradsegCart->get_endRad())
    {
      if (!findString("endRad", featConradsegCartAtts))
	{warnAtt("endRad", "featConradsegCart", a_featConradsegCart);}
      else
        check_rentVal(a_featConradsegCart->get_endRad());
    }
  if (a_featConradsegCart->get_longStart())
    {
      if (!findString("longStart", featConradsegCartAtts))
	{warnAtt("longStart", "featConradsegCart", a_featConradsegCart);}
      else
        check_vector(a_featConradsegCart->get_longStart());
    }
  if (a_featConradsegCart->get_longEnd())
    {
      if (!findString("longEnd", featConradsegCartAtts))
	{warnAtt("longEnd", "featConradsegCart", a_featConradsegCart);}
      else
        check_vector(a_featConradsegCart->get_longEnd());
    }
}

/********************************************************************/

void check_featConradsegNom(
 featConradsegNom * a_featConradsegNom)
{
  if (a_featConradsegNom->get_fLabel())
    {
      if (!findString("a_fLabel", featConradsegNomAtts))
	{warnAtt("a_fLabel", "featConradsegNom", a_featConradsegNom);}
      else
        check_fLabel(a_featConradsegNom->get_fLabel());
    }
  if (a_featConradsegNom->get_featMinorConradseg())
    {
      if (!findString("a_featMinorConradseg", featConradsegNomAtts))
	{warnAtt("a_featMinorConradseg", "featConradsegNom", a_featConradsegNom);}
      else
        check_featMinorConradseg(a_featConradsegNom->get_featMinorConradseg());
    }
}

/********************************************************************/

void check_featConradsegPol(
 featConradsegPol * a_featConradsegPol)
{
  if (a_featConradsegPol->get_matDir())
    {
      if (!findString("a_matDir", featConradsegPolAtts))
	{warnAtt("a_matDir", "featConradsegPol", a_featConradsegPol);}
      else
        check_matDir(a_featConradsegPol->get_matDir());
    }
  if (a_featConradsegPol->get_axisStart())
    {
      if (!findString("axisStart", featConradsegPolAtts))
	{warnAtt("axisStart", "featConradsegPol", a_featConradsegPol);}
      else
        check_polPoint(a_featConradsegPol->get_axisStart());
    }
  if (a_featConradsegPol->get_axisEnd())
    {
      if (!findString("axisEnd", featConradsegPolAtts))
	{warnAtt("axisEnd", "featConradsegPol", a_featConradsegPol);}
      else
        check_impPolPoint(a_featConradsegPol->get_axisEnd());
    }
  if (a_featConradsegPol->get_startRad())
    {
      if (!findString("startRad", featConradsegPolAtts))
	{warnAtt("startRad", "featConradsegPol", a_featConradsegPol);}
      else
        check_rentVal(a_featConradsegPol->get_startRad());
    }
  if (a_featConradsegPol->get_endRad())
    {
      if (!findString("endRad", featConradsegPolAtts))
	{warnAtt("endRad", "featConradsegPol", a_featConradsegPol);}
      else
        check_rentVal(a_featConradsegPol->get_endRad());
    }
  if (a_featConradsegPol->get_longStart())
    {
      if (!findString("longStart", featConradsegPolAtts))
	{warnAtt("longStart", "featConradsegPol", a_featConradsegPol);}
      else
        check_vector(a_featConradsegPol->get_longStart());
    }
  if (a_featConradsegPol->get_longEnd())
    {
      if (!findString("longEnd", featConradsegPolAtts))
	{warnAtt("longEnd", "featConradsegPol", a_featConradsegPol);}
      else
        check_vector(a_featConradsegPol->get_longEnd());
    }
}

/********************************************************************/

void check_featConradsegStm(
 featConradsegStm * a_featConradsegStm)
{
  if (isA(a_featConradsegStm, featConradsegNom))
    {
      if (!findString("featConradsegNom", featConradsegStmSubs))
        {warnSub("featConradsegNom", "featConradsegStm", a_featConradsegStm);}
      else
        check_featConradsegNom(dynamic_cast<featConradsegNom *>(a_featConradsegStm));
      return;
    }
  if (isA(a_featConradsegStm, featConradsegAct))
    {
      if (!findString("featConradsegAct", featConradsegStmSubs))
        {warnSub("featConradsegAct", "featConradsegStm", a_featConradsegStm);}
      else
        check_featConradsegAct(dynamic_cast<featConradsegAct *>(a_featConradsegStm));
      return;
    }
}

/********************************************************************/

void check_featCparlnAct(
 featCparlnAct * a_featCparlnAct)
{
  if (a_featCparlnAct->get_faLabel())
    {
      if (!findString("a_faLabel", featCparlnActAtts))
	{warnAtt("a_faLabel", "featCparlnAct", a_featCparlnAct);}
      else
        check_faLabel(a_featCparlnAct->get_faLabel());
    }
  if (a_featCparlnAct->get_featMinorCparln())
    {
      if (!findString("a_featMinorCparln", featCparlnActAtts))
	{warnAtt("a_featMinorCparln", "featCparlnAct", a_featCparlnAct);}
      else
        check_featMinorCparln(a_featCparlnAct->get_featMinorCparln());
    }
}

/********************************************************************/

void check_featCparlnNom(
 featCparlnNom * a_featCparlnNom)
{
  if (a_featCparlnNom->get_fLabel())
    {
      if (!findString("a_fLabel", featCparlnNomAtts))
	{warnAtt("a_fLabel", "featCparlnNom", a_featCparlnNom);}
      else
        check_fLabel(a_featCparlnNom->get_fLabel());
    }
  if (a_featCparlnNom->get_featMinorCparln())
    {
      if (!findString("a_featMinorCparln", featCparlnNomAtts))
	{warnAtt("a_featMinorCparln", "featCparlnNom", a_featCparlnNom);}
      else
        check_featMinorCparln(a_featCparlnNom->get_featMinorCparln());
    }
}

/********************************************************************/

void check_featCparlnStm(
 featCparlnStm * a_featCparlnStm)
{
  if (isA(a_featCparlnStm, featCparlnNom))
    {
      if (!findString("featCparlnNom", featCparlnStmSubs))
        {warnSub("featCparlnNom", "featCparlnStm", a_featCparlnStm);}
      else
        check_featCparlnNom(dynamic_cast<featCparlnNom *>(a_featCparlnStm));
      return;
    }
  if (isA(a_featCparlnStm, featCparlnAct))
    {
      if (!findString("featCparlnAct", featCparlnStmSubs))
        {warnSub("featCparlnAct", "featCparlnStm", a_featCparlnStm);}
      else
        check_featCparlnAct(dynamic_cast<featCparlnAct *>(a_featCparlnStm));
      return;
    }
}

/********************************************************************/

void check_featCylndrAct(
 featCylndrAct * a_featCylndrAct)
{
  if (a_featCylndrAct->get_faLabel())
    {
      if (!findString("a_faLabel", featCylndrActAtts))
	{warnAtt("a_faLabel", "featCylndrAct", a_featCylndrAct);}
      else
        check_faLabel(a_featCylndrAct->get_faLabel());
    }
  if (a_featCylndrAct->get_featMinorCylndr())
    {
      if (!findString("a_featMinorCylndr", featCylndrActAtts))
	{warnAtt("a_featMinorCylndr", "featCylndrAct", a_featCylndrAct);}
      else
        check_featMinorCylndr(a_featCylndrAct->get_featMinorCylndr());
    }
}

/********************************************************************/

void check_featCylndrNom(
 featCylndrNom * a_featCylndrNom)
{
  if (a_featCylndrNom->get_fLabel())
    {
      if (!findString("a_fLabel", featCylndrNomAtts))
	{warnAtt("a_fLabel", "featCylndrNom", a_featCylndrNom);}
      else
        check_fLabel(a_featCylndrNom->get_fLabel());
    }
  if (a_featCylndrNom->get_featMinorCylndr())
    {
      if (!findString("a_featMinorCylndr", featCylndrNomAtts))
	{warnAtt("a_featMinorCylndr", "featCylndrNom", a_featCylndrNom);}
      else
        check_featMinorCylndr(a_featCylndrNom->get_featMinorCylndr());
    }
}

/********************************************************************/

void check_featCylndrStm(
 featCylndrStm * a_featCylndrStm)
{
  if (isA(a_featCylndrStm, featCylndrNom))
    {
      if (!findString("featCylndrNom", featCylndrStmSubs))
        {warnSub("featCylndrNom", "featCylndrStm", a_featCylndrStm);}
      else
        check_featCylndrNom(dynamic_cast<featCylndrNom *>(a_featCylndrStm));
      return;
    }
  if (isA(a_featCylndrStm, featCylndrAct))
    {
      if (!findString("featCylndrAct", featCylndrStmSubs))
        {warnSub("featCylndrAct", "featCylndrStm", a_featCylndrStm);}
      else
        check_featCylndrAct(dynamic_cast<featCylndrAct *>(a_featCylndrStm));
      return;
    }
}

/********************************************************************/

void check_featCylradsegAct(
 featCylradsegAct * a_featCylradsegAct)
{
  if (a_featCylradsegAct->get_faLabel())
    {
      if (!findString("a_faLabel", featCylradsegActAtts))
	{warnAtt("a_faLabel", "featCylradsegAct", a_featCylradsegAct);}
      else
        check_faLabel(a_featCylradsegAct->get_faLabel());
    }
  if (a_featCylradsegAct->get_featMinorCylradseg())
    {
      if (!findString("a_featMinorCylradseg", featCylradsegActAtts))
	{warnAtt("a_featMinorCylradseg", "featCylradsegAct", a_featCylradsegAct);}
      else
        check_featMinorCylradseg(a_featCylradsegAct->get_featMinorCylradseg());
    }
}

/********************************************************************/

void check_featCylradsegCart(
 featCylradsegCart * a_featCylradsegCart)
{
  if (a_featCylradsegCart->get_matDir())
    {
      if (!findString("a_matDir", featCylradsegCartAtts))
	{warnAtt("a_matDir", "featCylradsegCart", a_featCylradsegCart);}
      else
        check_matDir(a_featCylradsegCart->get_matDir());
    }
  if (a_featCylradsegCart->get_axisStart())
    {
      if (!findString("axisStart", featCylradsegCartAtts))
	{warnAtt("axisStart", "featCylradsegCart", a_featCylradsegCart);}
      else
        check_cartPoint(a_featCylradsegCart->get_axisStart());
    }
  if (a_featCylradsegCart->get_axisEnd())
    {
      if (!findString("axisEnd", featCylradsegCartAtts))
	{warnAtt("axisEnd", "featCylradsegCart", a_featCylradsegCart);}
      else
        check_impCartPoint(a_featCylradsegCart->get_axisEnd());
    }
  if (a_featCylradsegCart->get_rad())
    {
      if (!findString("rad", featCylradsegCartAtts))
	{warnAtt("rad", "featCylradsegCart", a_featCylradsegCart);}
      else
        check_rentVal(a_featCylradsegCart->get_rad());
    }
  if (a_featCylradsegCart->get_longStart())
    {
      if (!findString("longStart", featCylradsegCartAtts))
	{warnAtt("longStart", "featCylradsegCart", a_featCylradsegCart);}
      else
        check_vector(a_featCylradsegCart->get_longStart());
    }
  if (a_featCylradsegCart->get_longEnd())
    {
      if (!findString("longEnd", featCylradsegCartAtts))
	{warnAtt("longEnd", "featCylradsegCart", a_featCylradsegCart);}
      else
        check_vector(a_featCylradsegCart->get_longEnd());
    }
}

/********************************************************************/

void check_featCylradsegNom(
 featCylradsegNom * a_featCylradsegNom)
{
  if (a_featCylradsegNom->get_fLabel())
    {
      if (!findString("a_fLabel", featCylradsegNomAtts))
	{warnAtt("a_fLabel", "featCylradsegNom", a_featCylradsegNom);}
      else
        check_fLabel(a_featCylradsegNom->get_fLabel());
    }
  if (a_featCylradsegNom->get_featMinorCylradseg())
    {
      if (!findString("a_featMinorCylradseg", featCylradsegNomAtts))
	{warnAtt("a_featMinorCylradseg", "featCylradsegNom", a_featCylradsegNom);}
      else
        check_featMinorCylradseg(a_featCylradsegNom->get_featMinorCylradseg());
    }
}

/********************************************************************/

void check_featCylradsegPol(
 featCylradsegPol * a_featCylradsegPol)
{
  if (a_featCylradsegPol->get_matDir())
    {
      if (!findString("a_matDir", featCylradsegPolAtts))
	{warnAtt("a_matDir", "featCylradsegPol", a_featCylradsegPol);}
      else
        check_matDir(a_featCylradsegPol->get_matDir());
    }
  if (a_featCylradsegPol->get_axisStart())
    {
      if (!findString("axisStart", featCylradsegPolAtts))
	{warnAtt("axisStart", "featCylradsegPol", a_featCylradsegPol);}
      else
        check_polPoint(a_featCylradsegPol->get_axisStart());
    }
  if (a_featCylradsegPol->get_axisEnd())
    {
      if (!findString("axisEnd", featCylradsegPolAtts))
	{warnAtt("axisEnd", "featCylradsegPol", a_featCylradsegPol);}
      else
        check_impPolPoint(a_featCylradsegPol->get_axisEnd());
    }
  if (a_featCylradsegPol->get_rad())
    {
      if (!findString("rad", featCylradsegPolAtts))
	{warnAtt("rad", "featCylradsegPol", a_featCylradsegPol);}
      else
        check_rentVal(a_featCylradsegPol->get_rad());
    }
  if (a_featCylradsegPol->get_longStart())
    {
      if (!findString("longStart", featCylradsegPolAtts))
	{warnAtt("longStart", "featCylradsegPol", a_featCylradsegPol);}
      else
        check_vector(a_featCylradsegPol->get_longStart());
    }
  if (a_featCylradsegPol->get_longEnd())
    {
      if (!findString("longEnd", featCylradsegPolAtts))
	{warnAtt("longEnd", "featCylradsegPol", a_featCylradsegPol);}
      else
        check_vector(a_featCylradsegPol->get_longEnd());
    }
}

/********************************************************************/

void check_featCylradsegStm(
 featCylradsegStm * a_featCylradsegStm)
{
  if (isA(a_featCylradsegStm, featCylradsegNom))
    {
      if (!findString("featCylradsegNom", featCylradsegStmSubs))
        {warnSub("featCylradsegNom", "featCylradsegStm", a_featCylradsegStm);}
      else
        check_featCylradsegNom(dynamic_cast<featCylradsegNom *>(a_featCylradsegStm));
      return;
    }
  if (isA(a_featCylradsegStm, featCylradsegAct))
    {
      if (!findString("featCylradsegAct", featCylradsegStmSubs))
        {warnSub("featCylradsegAct", "featCylradsegStm", a_featCylradsegStm);}
      else
        check_featCylradsegAct(dynamic_cast<featCylradsegAct *>(a_featCylradsegStm));
      return;
    }
}

/********************************************************************/

void check_featEdgeptAct(
 featEdgeptAct * a_featEdgeptAct)
{
  if (a_featEdgeptAct->get_faLabel())
    {
      if (!findString("a_faLabel", featEdgeptActAtts))
	{warnAtt("a_faLabel", "featEdgeptAct", a_featEdgeptAct);}
      else
        check_faLabel(a_featEdgeptAct->get_faLabel());
    }
  if (a_featEdgeptAct->get_featMinorEdgept())
    {
      if (!findString("a_featMinorEdgept", featEdgeptActAtts))
	{warnAtt("a_featMinorEdgept", "featEdgeptAct", a_featEdgeptAct);}
      else
        check_featMinorEdgept(a_featEdgeptAct->get_featMinorEdgept());
    }
}

/********************************************************************/

void check_featEdgeptNom(
 featEdgeptNom * a_featEdgeptNom)
{
  if (a_featEdgeptNom->get_fLabel())
    {
      if (!findString("a_fLabel", featEdgeptNomAtts))
	{warnAtt("a_fLabel", "featEdgeptNom", a_featEdgeptNom);}
      else
        check_fLabel(a_featEdgeptNom->get_fLabel());
    }
  if (a_featEdgeptNom->get_featMinorEdgept())
    {
      if (!findString("a_featMinorEdgept", featEdgeptNomAtts))
	{warnAtt("a_featMinorEdgept", "featEdgeptNom", a_featEdgeptNom);}
      else
        check_featMinorEdgept(a_featEdgeptNom->get_featMinorEdgept());
    }
}

/********************************************************************/

void check_featEdgeptStm(
 featEdgeptStm * a_featEdgeptStm)
{
  if (isA(a_featEdgeptStm, featEdgeptNom))
    {
      if (!findString("featEdgeptNom", featEdgeptStmSubs))
        {warnSub("featEdgeptNom", "featEdgeptStm", a_featEdgeptStm);}
      else
        check_featEdgeptNom(dynamic_cast<featEdgeptNom *>(a_featEdgeptStm));
      return;
    }
  if (isA(a_featEdgeptStm, featEdgeptAct))
    {
      if (!findString("featEdgeptAct", featEdgeptStmSubs))
        {warnSub("featEdgeptAct", "featEdgeptStm", a_featEdgeptStm);}
      else
        check_featEdgeptAct(dynamic_cast<featEdgeptAct *>(a_featEdgeptStm));
      return;
    }
}

/********************************************************************/

void check_featEllipsAct(
 featEllipsAct * a_featEllipsAct)
{
  if (a_featEllipsAct->get_faLabel())
    {
      if (!findString("a_faLabel", featEllipsActAtts))
	{warnAtt("a_faLabel", "featEllipsAct", a_featEllipsAct);}
      else
        check_faLabel(a_featEllipsAct->get_faLabel());
    }
  if (a_featEllipsAct->get_featMinorEllips())
    {
      if (!findString("a_featMinorEllips", featEllipsActAtts))
	{warnAtt("a_featMinorEllips", "featEllipsAct", a_featEllipsAct);}
      else
        check_featMinorEllips(a_featEllipsAct->get_featMinorEllips());
    }
}

/********************************************************************/

void check_featEllipsCart(
 featEllipsCart * a_featEllipsCart)
{
  if (a_featEllipsCart->get_matDir())
    {
      if (!findString("a_matDir", featEllipsCartAtts))
	{warnAtt("a_matDir", "featEllipsCart", a_featEllipsCart);}
      else
        check_matDir(a_featEllipsCart->get_matDir());
    }
  if (a_featEllipsCart->get_focus1())
    {
      if (!findString("focus1", featEllipsCartAtts))
	{warnAtt("focus1", "featEllipsCart", a_featEllipsCart);}
      else
        check_cartPoint(a_featEllipsCart->get_focus1());
    }
  if (a_featEllipsCart->get_focus2())
    {
      if (!findString("focus2", featEllipsCartAtts))
	{warnAtt("focus2", "featEllipsCart", a_featEllipsCart);}
      else
        check_impCartPoint(a_featEllipsCart->get_focus2());
    }
  if (a_featEllipsCart->get_radiusSpec())
    {
      if (!findString("a_radiusSpec", featEllipsCartAtts))
	{warnAtt("a_radiusSpec", "featEllipsCart", a_featEllipsCart);}
      else
        check_radiusSpec(a_featEllipsCart->get_radiusSpec());
    }
  if (a_featEllipsCart->get_planeVec())
    {
      if (!findString("planeVec", featEllipsCartAtts))
	{warnAtt("planeVec", "featEllipsCart", a_featEllipsCart);}
      else
        check_vector(a_featEllipsCart->get_planeVec());
    }
  if (a_featEllipsCart->get_diam())
    {
      if (!findString("diam", featEllipsCartAtts))
	{warnAtt("diam", "featEllipsCart", a_featEllipsCart);}
      else
        check_rentVal(a_featEllipsCart->get_diam());
    }
}

/********************************************************************/

void check_featEllipsNom(
 featEllipsNom * a_featEllipsNom)
{
  if (a_featEllipsNom->get_fLabel())
    {
      if (!findString("a_fLabel", featEllipsNomAtts))
	{warnAtt("a_fLabel", "featEllipsNom", a_featEllipsNom);}
      else
        check_fLabel(a_featEllipsNom->get_fLabel());
    }
  if (a_featEllipsNom->get_featMinorEllips())
    {
      if (!findString("a_featMinorEllips", featEllipsNomAtts))
	{warnAtt("a_featMinorEllips", "featEllipsNom", a_featEllipsNom);}
      else
        check_featMinorEllips(a_featEllipsNom->get_featMinorEllips());
    }
}

/********************************************************************/

void check_featEllipsPol(
 featEllipsPol * a_featEllipsPol)
{
  if (a_featEllipsPol->get_matDir())
    {
      if (!findString("a_matDir", featEllipsPolAtts))
	{warnAtt("a_matDir", "featEllipsPol", a_featEllipsPol);}
      else
        check_matDir(a_featEllipsPol->get_matDir());
    }
  if (a_featEllipsPol->get_focus1())
    {
      if (!findString("focus1", featEllipsPolAtts))
	{warnAtt("focus1", "featEllipsPol", a_featEllipsPol);}
      else
        check_polPoint(a_featEllipsPol->get_focus1());
    }
  if (a_featEllipsPol->get_focus2())
    {
      if (!findString("focus2", featEllipsPolAtts))
	{warnAtt("focus2", "featEllipsPol", a_featEllipsPol);}
      else
        check_impPolPoint(a_featEllipsPol->get_focus2());
    }
  if (a_featEllipsPol->get_radiusSpec())
    {
      if (!findString("a_radiusSpec", featEllipsPolAtts))
	{warnAtt("a_radiusSpec", "featEllipsPol", a_featEllipsPol);}
      else
        check_radiusSpec(a_featEllipsPol->get_radiusSpec());
    }
  if (a_featEllipsPol->get_planeVec())
    {
      if (!findString("planeVec", featEllipsPolAtts))
	{warnAtt("planeVec", "featEllipsPol", a_featEllipsPol);}
      else
        check_vector(a_featEllipsPol->get_planeVec());
    }
  if (a_featEllipsPol->get_diam())
    {
      if (!findString("diam", featEllipsPolAtts))
	{warnAtt("diam", "featEllipsPol", a_featEllipsPol);}
      else
        check_rentVal(a_featEllipsPol->get_diam());
    }
}

/********************************************************************/

void check_featEllipsStm(
 featEllipsStm * a_featEllipsStm)
{
  if (isA(a_featEllipsStm, featEllipsNom))
    {
      if (!findString("featEllipsNom", featEllipsStmSubs))
        {warnSub("featEllipsNom", "featEllipsStm", a_featEllipsStm);}
      else
        check_featEllipsNom(dynamic_cast<featEllipsNom *>(a_featEllipsStm));
      return;
    }
  if (isA(a_featEllipsStm, featEllipsAct))
    {
      if (!findString("featEllipsAct", featEllipsStmSubs))
        {warnSub("featEllipsAct", "featEllipsStm", a_featEllipsStm);}
      else
        check_featEllipsAct(dynamic_cast<featEllipsAct *>(a_featEllipsStm));
      return;
    }
}

/********************************************************************/

void check_featElongcylAct(
 featElongcylAct * a_featElongcylAct)
{
  if (a_featElongcylAct->get_faLabel())
    {
      if (!findString("a_faLabel", featElongcylActAtts))
	{warnAtt("a_faLabel", "featElongcylAct", a_featElongcylAct);}
      else
        check_faLabel(a_featElongcylAct->get_faLabel());
    }
  if (a_featElongcylAct->get_featMinorElongcyl())
    {
      if (!findString("a_featMinorElongcyl", featElongcylActAtts))
	{warnAtt("a_featMinorElongcyl", "featElongcylAct", a_featElongcylAct);}
      else
        check_featMinorElongcyl(a_featElongcylAct->get_featMinorElongcyl());
    }
}

/********************************************************************/

void check_featElongcylNom(
 featElongcylNom * a_featElongcylNom)
{
  if (a_featElongcylNom->get_fLabel())
    {
      if (!findString("a_fLabel", featElongcylNomAtts))
	{warnAtt("a_fLabel", "featElongcylNom", a_featElongcylNom);}
      else
        check_fLabel(a_featElongcylNom->get_fLabel());
    }
  if (a_featElongcylNom->get_featMinorElongcyl())
    {
      if (!findString("a_featMinorElongcyl", featElongcylNomAtts))
	{warnAtt("a_featMinorElongcyl", "featElongcylNom", a_featElongcylNom);}
      else
        check_featMinorElongcyl(a_featElongcylNom->get_featMinorElongcyl());
    }
}

/********************************************************************/

void check_featElongcylStm(
 featElongcylStm * a_featElongcylStm)
{
  if (isA(a_featElongcylStm, featElongcylNom))
    {
      if (!findString("featElongcylNom", featElongcylStmSubs))
        {warnSub("featElongcylNom", "featElongcylStm", a_featElongcylStm);}
      else
        check_featElongcylNom(dynamic_cast<featElongcylNom *>(a_featElongcylStm));
      return;
    }
  if (isA(a_featElongcylStm, featElongcylAct))
    {
      if (!findString("featElongcylAct", featElongcylStmSubs))
        {warnSub("featElongcylAct", "featElongcylStm", a_featElongcylStm);}
      else
        check_featElongcylAct(dynamic_cast<featElongcylAct *>(a_featElongcylStm));
      return;
    }
}

/********************************************************************/

void check_featGcurveCart(
 featGcurveCart * a_featGcurveCart)
{
  if (a_featGcurveCart->get_planeData())
    {
      if (!findString("planeData", featGcurveCartAtts))
	{warnAtt("planeData", "featGcurveCart", a_featGcurveCart);}
      else
        check_pointVecCart(a_featGcurveCart->get_planeData());
    }
  if (a_featGcurveCart->get_curveData1())
    {
      if (!findString("curveData1", featGcurveCartAtts))
	{warnAtt("curveData1", "featGcurveCart", a_featGcurveCart);}
      else
        check_pointVecCart(a_featGcurveCart->get_curveData1());
    }
  if (a_featGcurveCart->get_curveDataRest())
    {
      if (!findString("curveDataRest", featGcurveCartAtts))
	{warnAtt("curveDataRest", "featGcurveCart", a_featGcurveCart);}
      else
        {
          std::list<pointVecCart *> * theList;
          std::list<pointVecCart *>::iterator iter;
          theList = a_featGcurveCart->get_curveDataRest();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_pointVecCart(*iter);
        }
    }
}

/********************************************************************/

void check_featGcurvePol(
 featGcurvePol * a_featGcurvePol)
{
  if (a_featGcurvePol->get_planeData())
    {
      if (!findString("planeData", featGcurvePolAtts))
	{warnAtt("planeData", "featGcurvePol", a_featGcurvePol);}
      else
        check_pointVecPol(a_featGcurvePol->get_planeData());
    }
  if (a_featGcurvePol->get_curveData1())
    {
      if (!findString("curveData1", featGcurvePolAtts))
	{warnAtt("curveData1", "featGcurvePol", a_featGcurvePol);}
      else
        check_pointVecPol(a_featGcurvePol->get_curveData1());
    }
  if (a_featGcurvePol->get_curveDataRest())
    {
      if (!findString("curveDataRest", featGcurvePolAtts))
	{warnAtt("curveDataRest", "featGcurvePol", a_featGcurvePol);}
      else
        {
          std::list<pointVecPol *> * theList;
          std::list<pointVecPol *>::iterator iter;
          theList = a_featGcurvePol->get_curveDataRest();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_pointVecPol(*iter);
        }
    }
}

/********************************************************************/

void check_featGcurveStm(
 featGcurveStm * a_featGcurveStm)
{
  if (a_featGcurveStm->get_fLabel())
    {
      if (!findString("a_fLabel", featGcurveStmAtts))
	{warnAtt("a_fLabel", "featGcurveStm", a_featGcurveStm);}
      else
        check_fLabel(a_featGcurveStm->get_fLabel());
    }
  if (a_featGcurveStm->get_featMinorGcurve())
    {
      if (!findString("a_featMinorGcurve", featGcurveStmAtts))
	{warnAtt("a_featMinorGcurve", "featGcurveStm", a_featGcurveStm);}
      else
        check_featMinorGcurve(a_featGcurveStm->get_featMinorGcurve());
    }
}

/********************************************************************/

void check_featGeomStm(
 featGeomStm * a_featGeomStm)
{
  if (a_featGeomStm->get_fLabel())
    {
      if (!findString("a_fLabel", featGeomStmAtts))
	{warnAtt("a_fLabel", "featGeomStm", a_featGeomStm);}
      else
        check_fLabel(a_featGeomStm->get_fLabel());
    }
  if (a_featGeomStm->get_featMinorGeom())
    {
      if (!findString("a_featMinorGeom", featGeomStmAtts))
	{warnAtt("a_featMinorGeom", "featGeomStm", a_featGeomStm);}
      else
        check_featMinorGeom(a_featGeomStm->get_featMinorGeom());
    }
}

/********************************************************************/

void check_featGsurfCart(
 featGsurfCart * a_featGsurfCart)
{
  if (a_featGsurfCart->get_pt1())
    {
      if (!findString("pt1", featGsurfCartAtts))
	{warnAtt("pt1", "featGsurfCart", a_featGsurfCart);}
      else
        check_pointVecCart(a_featGsurfCart->get_pt1());
    }
  if (a_featGsurfCart->get_pt2())
    {
      if (!findString("pt2", featGsurfCartAtts))
	{warnAtt("pt2", "featGsurfCart", a_featGsurfCart);}
      else
        check_pointVecCart(a_featGsurfCart->get_pt2());
    }
  if (a_featGsurfCart->get_morePts())
    {
      if (!findString("morePts", featGsurfCartAtts))
	{warnAtt("morePts", "featGsurfCart", a_featGsurfCart);}
      else
        {
          std::list<pointVecCart *> * theList;
          std::list<pointVecCart *>::iterator iter;
          theList = a_featGsurfCart->get_morePts();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_pointVecCart(*iter);
        }
    }
}

/********************************************************************/

void check_featGsurfPol(
 featGsurfPol * a_featGsurfPol)
{
  if (a_featGsurfPol->get_pt1())
    {
      if (!findString("pt1", featGsurfPolAtts))
	{warnAtt("pt1", "featGsurfPol", a_featGsurfPol);}
      else
        check_pointVecPol(a_featGsurfPol->get_pt1());
    }
  if (a_featGsurfPol->get_pt2())
    {
      if (!findString("pt2", featGsurfPolAtts))
	{warnAtt("pt2", "featGsurfPol", a_featGsurfPol);}
      else
        check_pointVecPol(a_featGsurfPol->get_pt2());
    }
  if (a_featGsurfPol->get_morePts())
    {
      if (!findString("morePts", featGsurfPolAtts))
	{warnAtt("morePts", "featGsurfPol", a_featGsurfPol);}
      else
        {
          std::list<pointVecPol *> * theList;
          std::list<pointVecPol *>::iterator iter;
          theList = a_featGsurfPol->get_morePts();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_pointVecPol(*iter);
        }
    }
}

/********************************************************************/

void check_featGsurfStm(
 featGsurfStm * a_featGsurfStm)
{
  if (a_featGsurfStm->get_fLabel())
    {
      if (!findString("a_fLabel", featGsurfStmAtts))
	{warnAtt("a_fLabel", "featGsurfStm", a_featGsurfStm);}
      else
        check_fLabel(a_featGsurfStm->get_fLabel());
    }
  if (a_featGsurfStm->get_featMinorGsurf())
    {
      if (!findString("a_featMinorGsurf", featGsurfStmAtts))
	{warnAtt("a_featMinorGsurf", "featGsurfStm", a_featGsurfStm);}
      else
        check_featMinorGsurf(a_featGsurfStm->get_featMinorGsurf());
    }
}

/********************************************************************/

void check_featLineAct(
 featLineAct * a_featLineAct)
{
  if (a_featLineAct->get_faLabel())
    {
      if (!findString("a_faLabel", featLineActAtts))
	{warnAtt("a_faLabel", "featLineAct", a_featLineAct);}
      else
        check_faLabel(a_featLineAct->get_faLabel());
    }
  if (a_featLineAct->get_featMinorLine())
    {
      if (!findString("a_featMinorLine", featLineActAtts))
	{warnAtt("a_featMinorLine", "featLineAct", a_featLineAct);}
      else
        check_featMinorLine(a_featLineAct->get_featMinorLine());
    }
}

/********************************************************************/

void check_featLineBndCart(
 featLineBndCart * a_featLineBndCart)
{
  if (a_featLineBndCart->get_start())
    {
      if (!findString("start", featLineBndCartAtts))
	{warnAtt("start", "featLineBndCart", a_featLineBndCart);}
      else
        check_cartPoint(a_featLineBndCart->get_start());
    }
  if (a_featLineBndCart->get_end())
    {
      if (!findString("end", featLineBndCartAtts))
	{warnAtt("end", "featLineBndCart", a_featLineBndCart);}
      else
        check_impCartPoint(a_featLineBndCart->get_end());
    }
  if (a_featLineBndCart->get_planeVec())
    {
      if (!findString("planeVec", featLineBndCartAtts))
	{warnAtt("planeVec", "featLineBndCart", a_featLineBndCart);}
      else
        check_vector(a_featLineBndCart->get_planeVec());
    }
}

/********************************************************************/

void check_featLineBndPol(
 featLineBndPol * a_featLineBndPol)
{
  if (a_featLineBndPol->get_start())
    {
      if (!findString("start", featLineBndPolAtts))
	{warnAtt("start", "featLineBndPol", a_featLineBndPol);}
      else
        check_polPoint(a_featLineBndPol->get_start());
    }
  if (a_featLineBndPol->get_end())
    {
      if (!findString("end", featLineBndPolAtts))
	{warnAtt("end", "featLineBndPol", a_featLineBndPol);}
      else
        check_impPolPoint(a_featLineBndPol->get_end());
    }
  if (a_featLineBndPol->get_planeVec())
    {
      if (!findString("planeVec", featLineBndPolAtts))
	{warnAtt("planeVec", "featLineBndPol", a_featLineBndPol);}
      else
        check_vector(a_featLineBndPol->get_planeVec());
    }
}

/********************************************************************/

void check_featLineNom(
 featLineNom * a_featLineNom)
{
  if (a_featLineNom->get_fLabel())
    {
      if (!findString("a_fLabel", featLineNomAtts))
	{warnAtt("a_fLabel", "featLineNom", a_featLineNom);}
      else
        check_fLabel(a_featLineNom->get_fLabel());
    }
  if (a_featLineNom->get_featMinorLine())
    {
      if (!findString("a_featMinorLine", featLineNomAtts))
	{warnAtt("a_featMinorLine", "featLineNom", a_featLineNom);}
      else
        check_featMinorLine(a_featLineNom->get_featMinorLine());
    }
}

/********************************************************************/

void check_featLineStm(
 featLineStm * a_featLineStm)
{
  if (isA(a_featLineStm, featLineNom))
    {
      if (!findString("featLineNom", featLineStmSubs))
        {warnSub("featLineNom", "featLineStm", a_featLineStm);}
      else
        check_featLineNom(dynamic_cast<featLineNom *>(a_featLineStm));
      return;
    }
  if (isA(a_featLineStm, featLineAct))
    {
      if (!findString("featLineAct", featLineStmSubs))
        {warnSub("featLineAct", "featLineStm", a_featLineStm);}
      else
        check_featLineAct(dynamic_cast<featLineAct *>(a_featLineStm));
      return;
    }
}

/********************************************************************/

void check_featLineUnbndCart(
 featLineUnbndCart * a_featLineUnbndCart)
{
  if (a_featLineUnbndCart->get_cartPoint())
    {
      if (!findString("a_cartPoint", featLineUnbndCartAtts))
	{warnAtt("a_cartPoint", "featLineUnbndCart", a_featLineUnbndCart);}
      else
        check_cartPoint(a_featLineUnbndCart->get_cartPoint());
    }
  if (a_featLineUnbndCart->get_lineVec())
    {
      if (!findString("lineVec", featLineUnbndCartAtts))
	{warnAtt("lineVec", "featLineUnbndCart", a_featLineUnbndCart);}
      else
        check_vector(a_featLineUnbndCart->get_lineVec());
    }
  if (a_featLineUnbndCart->get_planeVec())
    {
      if (!findString("planeVec", featLineUnbndCartAtts))
	{warnAtt("planeVec", "featLineUnbndCart", a_featLineUnbndCart);}
      else
        check_vector(a_featLineUnbndCart->get_planeVec());
    }
}

/********************************************************************/

void check_featLineUnbndPol(
 featLineUnbndPol * a_featLineUnbndPol)
{
  if (a_featLineUnbndPol->get_polPoint())
    {
      if (!findString("a_polPoint", featLineUnbndPolAtts))
	{warnAtt("a_polPoint", "featLineUnbndPol", a_featLineUnbndPol);}
      else
        check_polPoint(a_featLineUnbndPol->get_polPoint());
    }
  if (a_featLineUnbndPol->get_lineVec())
    {
      if (!findString("lineVec", featLineUnbndPolAtts))
	{warnAtt("lineVec", "featLineUnbndPol", a_featLineUnbndPol);}
      else
        check_vector(a_featLineUnbndPol->get_lineVec());
    }
  if (a_featLineUnbndPol->get_planeVec())
    {
      if (!findString("planeVec", featLineUnbndPolAtts))
	{warnAtt("planeVec", "featLineUnbndPol", a_featLineUnbndPol);}
      else
        check_vector(a_featLineUnbndPol->get_planeVec());
    }
}

/********************************************************************/

void check_featMinorArc1(
 featMinorArc1 * a_featMinorArc1)
{
  if (a_featMinorArc1->get_matDir())
    {
      if (!findString("a_matDir", featMinorArc1Atts))
	{warnAtt("a_matDir", "featMinorArc1", a_featMinorArc1);}
      else
        check_matDir(a_featMinorArc1->get_matDir());
    }
  if (a_featMinorArc1->get_typePoint())
    {
      if (!findString("a_typePoint", featMinorArc1Atts))
	{warnAtt("a_typePoint", "featMinorArc1", a_featMinorArc1);}
      else
        check_typePoint(a_featMinorArc1->get_typePoint());
    }
  if (a_featMinorArc1->get_planeVec())
    {
      if (!findString("planeVec", featMinorArc1Atts))
	{warnAtt("planeVec", "featMinorArc1", a_featMinorArc1);}
      else
        check_vector(a_featMinorArc1->get_planeVec());
    }
  if (a_featMinorArc1->get_radius())
    {
      if (!findString("radius", featMinorArc1Atts))
	{warnAtt("radius", "featMinorArc1", a_featMinorArc1);}
      else
        check_rentVal(a_featMinorArc1->get_radius());
    }
  if (a_featMinorArc1->get_startAngle())
    {
      if (!findString("startAngle", featMinorArc1Atts))
	{warnAtt("startAngle", "featMinorArc1", a_featMinorArc1);}
      else
        check_angle(a_featMinorArc1->get_startAngle());
    }
  if (a_featMinorArc1->get_includAngle())
    {
      if (!findString("includAngle", featMinorArc1Atts))
	{warnAtt("includAngle", "featMinorArc1", a_featMinorArc1);}
      else
        check_angle(a_featMinorArc1->get_includAngle());
    }
  if (a_featMinorArc1->get_startVec())
    {
      if (!findString("startVec", featMinorArc1Atts))
	{warnAtt("startVec", "featMinorArc1", a_featMinorArc1);}
      else
        check_vector(a_featMinorArc1->get_startVec());
    }
}

/********************************************************************/

void check_featMinorArc2(
 featMinorArc2 * a_featMinorArc2)
{
  if (a_featMinorArc2->get_matDir())
    {
      if (!findString("a_matDir", featMinorArc2Atts))
	{warnAtt("a_matDir", "featMinorArc2", a_featMinorArc2);}
      else
        check_matDir(a_featMinorArc2->get_matDir());
    }
  if (a_featMinorArc2->get_end1())
    {
      if (!findString("end1", featMinorArc2Atts))
	{warnAtt("end1", "featMinorArc2", a_featMinorArc2);}
      else
        check_impCartPoint(a_featMinorArc2->get_end1());
    }
  if (a_featMinorArc2->get_end2())
    {
      if (!findString("end2", featMinorArc2Atts))
	{warnAtt("end2", "featMinorArc2", a_featMinorArc2);}
      else
        check_impCartPoint(a_featMinorArc2->get_end2());
    }
  if (a_featMinorArc2->get_midPt())
    {
      if (!findString("midPt", featMinorArc2Atts))
	{warnAtt("midPt", "featMinorArc2", a_featMinorArc2);}
      else
        check_impCartPoint(a_featMinorArc2->get_midPt());
    }
  if (a_featMinorArc2->get_center())
    {
      if (!findString("center", featMinorArc2Atts))
	{warnAtt("center", "featMinorArc2", a_featMinorArc2);}
      else
        check_impCartPoint(a_featMinorArc2->get_center());
    }
}

/********************************************************************/

void check_featMinorCircle(
 featMinorCircle * a_featMinorCircle)
{
  if (a_featMinorCircle->get_matDir())
    {
      if (!findString("a_matDir", featMinorCircleAtts))
	{warnAtt("a_matDir", "featMinorCircle", a_featMinorCircle);}
      else
        check_matDir(a_featMinorCircle->get_matDir());
    }
  if (a_featMinorCircle->get_center())
    {
      if (!findString("center", featMinorCircleAtts))
	{warnAtt("center", "featMinorCircle", a_featMinorCircle);}
      else
        check_typePoint(a_featMinorCircle->get_center());
    }
  if (a_featMinorCircle->get_planeVec())
    {
      if (!findString("planeVec", featMinorCircleAtts))
	{warnAtt("planeVec", "featMinorCircle", a_featMinorCircle);}
      else
        check_vector(a_featMinorCircle->get_planeVec());
    }
  if (a_featMinorCircle->get_diam())
    {
      if (!findString("diam", featMinorCircleAtts))
	{warnAtt("diam", "featMinorCircle", a_featMinorCircle);}
      else
        check_rentVal(a_featMinorCircle->get_diam());
    }
}

/********************************************************************/

void check_featMinorCompound(
 featMinorCompound * a_featMinorCompound)
{
  if (isA(a_featMinorCompound, featCompoundAxial))
    {
      if (!findString("featCompoundAxial", featMinorCompoundSubs))
        {warnSub("featCompoundAxial", "featMinorCompound", a_featMinorCompound);}
      else
        check_featCompoundAxial(dynamic_cast<featCompoundAxial *>(a_featMinorCompound));
      return;
    }
  if (isA(a_featMinorCompound, featCompoundPlane))
    {
      if (!findString("featCompoundPlane", featMinorCompoundSubs))
        {warnSub("featCompoundPlane", "featMinorCompound", a_featMinorCompound);}
      else
        check_featCompoundPlane(dynamic_cast<featCompoundPlane *>(a_featMinorCompound));
      return;
    }
  if (isA(a_featMinorCompound, featCompoundSphere))
    {
      if (!findString("featCompoundSphere", featMinorCompoundSubs))
        {warnSub("featCompoundSphere", "featMinorCompound", a_featMinorCompound);}
      else
        check_featCompoundSphere(dynamic_cast<featCompoundSphere *>(a_featMinorCompound));
      return;
    }
}

/********************************************************************/

void check_featMinorCone(
 featMinorCone * a_featMinorCone)
{
  if (a_featMinorCone->get_matDir())
    {
      if (!findString("a_matDir", featMinorConeAtts))
	{warnAtt("a_matDir", "featMinorCone", a_featMinorCone);}
      else
        check_matDir(a_featMinorCone->get_matDir());
    }
  if (a_featMinorCone->get_vertex())
    {
      if (!findString("vertex", featMinorConeAtts))
	{warnAtt("vertex", "featMinorCone", a_featMinorCone);}
      else
        check_typePoint(a_featMinorCone->get_vertex());
    }
  if (a_featMinorCone->get_axis())
    {
      if (!findString("axis", featMinorConeAtts))
	{warnAtt("axis", "featMinorCone", a_featMinorCone);}
      else
        check_vector(a_featMinorCone->get_axis());
    }
  if (a_featMinorCone->get_ang())
    {
      if (!findString("ang", featMinorConeAtts))
	{warnAtt("ang", "featMinorCone", a_featMinorCone);}
      else
        check_angle(a_featMinorCone->get_ang());
    }
}

/********************************************************************/

void check_featMinorConradseg(
 featMinorConradseg * a_featMinorConradseg)
{
  if (isA(a_featMinorConradseg, featConradsegCart))
    {
      if (!findString("featConradsegCart", featMinorConradsegSubs))
        {warnSub("featConradsegCart", "featMinorConradseg", a_featMinorConradseg);}
      else
        check_featConradsegCart(dynamic_cast<featConradsegCart *>(a_featMinorConradseg));
      return;
    }
  if (isA(a_featMinorConradseg, featConradsegPol))
    {
      if (!findString("featConradsegPol", featMinorConradsegSubs))
        {warnSub("featConradsegPol", "featMinorConradseg", a_featMinorConradseg);}
      else
        check_featConradsegPol(dynamic_cast<featConradsegPol *>(a_featMinorConradseg));
      return;
    }
}

/********************************************************************/

void check_featMinorCparln(
 featMinorCparln * a_featMinorCparln)
{
  if (a_featMinorCparln->get_matDir())
    {
      if (!findString("a_matDir", featMinorCparlnAtts))
	{warnAtt("a_matDir", "featMinorCparln", a_featMinorCparln);}
      else
        check_matDir(a_featMinorCparln->get_matDir());
    }
  if (a_featMinorCparln->get_flatRoundOpen())
    {
      if (!findString("a_flatRoundOpen", featMinorCparlnAtts))
	{warnAtt("a_flatRoundOpen", "featMinorCparln", a_featMinorCparln);}
      else
        check_flatRoundOpen(a_featMinorCparln->get_flatRoundOpen());
    }
  if (a_featMinorCparln->get_center())
    {
      if (!findString("center", featMinorCparlnAtts))
	{warnAtt("center", "featMinorCparln", a_featMinorCparln);}
      else
        check_typePoint(a_featMinorCparln->get_center());
    }
  if (a_featMinorCparln->get_surfVec())
    {
      if (!findString("surfVec", featMinorCparlnAtts))
	{warnAtt("surfVec", "featMinorCparln", a_featMinorCparln);}
      else
        check_vector(a_featMinorCparln->get_surfVec());
    }
  if (a_featMinorCparln->get_lineVec())
    {
      if (!findString("lineVec", featMinorCparlnAtts))
	{warnAtt("lineVec", "featMinorCparln", a_featMinorCparln);}
      else
        check_vector(a_featMinorCparln->get_lineVec());
    }
  if (a_featMinorCparln->get_len())
    {
      if (!findString("len", featMinorCparlnAtts))
	{warnAtt("len", "featMinorCparln", a_featMinorCparln);}
      else
        check_rentVal(a_featMinorCparln->get_len());
    }
  if (a_featMinorCparln->get_width())
    {
      if (!findString("width", featMinorCparlnAtts))
	{warnAtt("width", "featMinorCparln", a_featMinorCparln);}
      else
        check_rentVal(a_featMinorCparln->get_width());
    }
}

/********************************************************************/

void check_featMinorCylndr(
 featMinorCylndr * a_featMinorCylndr)
{
  if (a_featMinorCylndr->get_matDir())
    {
      if (!findString("a_matDir", featMinorCylndrAtts))
	{warnAtt("a_matDir", "featMinorCylndr", a_featMinorCylndr);}
      else
        check_matDir(a_featMinorCylndr->get_matDir());
    }
  if (a_featMinorCylndr->get_axisPoint())
    {
      if (!findString("axisPoint", featMinorCylndrAtts))
	{warnAtt("axisPoint", "featMinorCylndr", a_featMinorCylndr);}
      else
        check_typePoint(a_featMinorCylndr->get_axisPoint());
    }
  if (a_featMinorCylndr->get_axisVec())
    {
      if (!findString("axisVec", featMinorCylndrAtts))
	{warnAtt("axisVec", "featMinorCylndr", a_featMinorCylndr);}
      else
        check_vector(a_featMinorCylndr->get_axisVec());
    }
  if (a_featMinorCylndr->get_diam())
    {
      if (!findString("diam", featMinorCylndrAtts))
	{warnAtt("diam", "featMinorCylndr", a_featMinorCylndr);}
      else
        check_rentVal(a_featMinorCylndr->get_diam());
    }
  if (a_featMinorCylndr->get_len())
    {
      if (!findString("len", featMinorCylndrAtts))
	{warnAtt("len", "featMinorCylndr", a_featMinorCylndr);}
      else
        check_rentVal(a_featMinorCylndr->get_len());
    }
}

/********************************************************************/

void check_featMinorCylradseg(
 featMinorCylradseg * a_featMinorCylradseg)
{
  if (isA(a_featMinorCylradseg, featCylradsegCart))
    {
      if (!findString("featCylradsegCart", featMinorCylradsegSubs))
        {warnSub("featCylradsegCart", "featMinorCylradseg", a_featMinorCylradseg);}
      else
        check_featCylradsegCart(dynamic_cast<featCylradsegCart *>(a_featMinorCylradseg));
      return;
    }
  if (isA(a_featMinorCylradseg, featCylradsegPol))
    {
      if (!findString("featCylradsegPol", featMinorCylradsegSubs))
        {warnSub("featCylradsegPol", "featMinorCylradseg", a_featMinorCylradseg);}
      else
        check_featCylradsegPol(dynamic_cast<featCylradsegPol *>(a_featMinorCylradseg));
      return;
    }
}

/********************************************************************/

void check_featMinorEdgept(
 featMinorEdgept * a_featMinorEdgept)
{
  if (a_featMinorEdgept->get_typePoint())
    {
      if (!findString("a_typePoint", featMinorEdgeptAtts))
	{warnAtt("a_typePoint", "featMinorEdgept", a_featMinorEdgept);}
      else
        check_typePoint(a_featMinorEdgept->get_typePoint());
    }
  if (a_featMinorEdgept->get_edgeNorm())
    {
      if (!findString("edgeNorm", featMinorEdgeptAtts))
	{warnAtt("edgeNorm", "featMinorEdgept", a_featMinorEdgept);}
      else
        check_vector(a_featMinorEdgept->get_edgeNorm());
    }
  if (a_featMinorEdgept->get_surfNorm())
    {
      if (!findString("surfNorm", featMinorEdgeptAtts))
	{warnAtt("surfNorm", "featMinorEdgept", a_featMinorEdgept);}
      else
        check_vector(a_featMinorEdgept->get_surfNorm());
    }
}

/********************************************************************/

void check_featMinorEllips(
 featMinorEllips * a_featMinorEllips)
{
  if (isA(a_featMinorEllips, featEllipsCart))
    {
      if (!findString("featEllipsCart", featMinorEllipsSubs))
        {warnSub("featEllipsCart", "featMinorEllips", a_featMinorEllips);}
      else
        check_featEllipsCart(dynamic_cast<featEllipsCart *>(a_featMinorEllips));
      return;
    }
  if (isA(a_featMinorEllips, featEllipsPol))
    {
      if (!findString("featEllipsPol", featMinorEllipsSubs))
        {warnSub("featEllipsPol", "featMinorEllips", a_featMinorEllips);}
      else
        check_featEllipsPol(dynamic_cast<featEllipsPol *>(a_featMinorEllips));
      return;
    }
}

/********************************************************************/

void check_featMinorElongcyl(
 featMinorElongcyl * a_featMinorElongcyl)
{
  if (a_featMinorElongcyl->get_matDir())
    {
      if (!findString("a_matDir", featMinorElongcylAtts))
	{warnAtt("a_matDir", "featMinorElongcyl", a_featMinorElongcyl);}
      else
        check_matDir(a_featMinorElongcyl->get_matDir());
    }
  if (a_featMinorElongcyl->get_planePt())
    {
      if (!findString("planePt", featMinorElongcylAtts))
	{warnAtt("planePt", "featMinorElongcyl", a_featMinorElongcyl);}
      else
        check_typePoint(a_featMinorElongcyl->get_planePt());
    }
  if (a_featMinorElongcyl->get_planeVec())
    {
      if (!findString("planeVec", featMinorElongcylAtts))
	{warnAtt("planeVec", "featMinorElongcyl", a_featMinorElongcyl);}
      else
        check_vector(a_featMinorElongcyl->get_planeVec());
    }
  if (a_featMinorElongcyl->get_axisVec())
    {
      if (!findString("axisVec", featMinorElongcylAtts))
	{warnAtt("axisVec", "featMinorElongcyl", a_featMinorElongcyl);}
      else
        check_vector(a_featMinorElongcyl->get_axisVec());
    }
  if (a_featMinorElongcyl->get_size())
    {
      if (!findString("size", featMinorElongcylAtts))
	{warnAtt("size", "featMinorElongcyl", a_featMinorElongcyl);}
      else
        check_rentVal(a_featMinorElongcyl->get_size());
    }
  if (a_featMinorElongcyl->get_radius())
    {
      if (!findString("radius", featMinorElongcylAtts))
	{warnAtt("radius", "featMinorElongcyl", a_featMinorElongcyl);}
      else
        check_rentVal(a_featMinorElongcyl->get_radius());
    }
  if (a_featMinorElongcyl->get_len())
    {
      if (!findString("len", featMinorElongcylAtts))
	{warnAtt("len", "featMinorElongcyl", a_featMinorElongcyl);}
      else
        check_rentVal(a_featMinorElongcyl->get_len());
    }
}

/********************************************************************/

void check_featMinorGcurve(
 featMinorGcurve * a_featMinorGcurve)
{
  if (isA(a_featMinorGcurve, featGcurveCart))
    {
      if (!findString("featGcurveCart", featMinorGcurveSubs))
        {warnSub("featGcurveCart", "featMinorGcurve", a_featMinorGcurve);}
      else
        check_featGcurveCart(dynamic_cast<featGcurveCart *>(a_featMinorGcurve));
      return;
    }
  if (isA(a_featMinorGcurve, featGcurvePol))
    {
      if (!findString("featGcurvePol", featMinorGcurveSubs))
        {warnSub("featGcurvePol", "featMinorGcurve", a_featMinorGcurve);}
      else
        check_featGcurvePol(dynamic_cast<featGcurvePol *>(a_featMinorGcurve));
      return;
    }
}

/********************************************************************/

void check_featMinorGeom(
 featMinorGeom * a_featMinorGeom)
{
  if (a_featMinorGeom->get_gLabel())
    {
      if (!findString("a_gLabel", featMinorGeomAtts))
	{warnAtt("a_gLabel", "featMinorGeom", a_featMinorGeom);}
      else
        check_gLabel(a_featMinorGeom->get_gLabel());
    }
  if (a_featMinorGeom->get_coordType())
    {
      if (!findString("a_coordType", featMinorGeomAtts))
	{warnAtt("a_coordType", "featMinorGeom", a_featMinorGeom);}
      else
        check_coordType(a_featMinorGeom->get_coordType());
    }
}

/********************************************************************/

void check_featMinorGsurf(
 featMinorGsurf * a_featMinorGsurf)
{
  if (isA(a_featMinorGsurf, featGsurfPlain))
    {
      if (!findString("featGsurfPlain", featMinorGsurfSubs))
        {warnSub("featGsurfPlain", "featMinorGsurf", a_featMinorGsurf);}
      return;
    }
  if (isA(a_featMinorGsurf, featGsurfCart))
    {
      if (!findString("featGsurfCart", featMinorGsurfSubs))
        {warnSub("featGsurfCart", "featMinorGsurf", a_featMinorGsurf);}
      else
        check_featGsurfCart(dynamic_cast<featGsurfCart *>(a_featMinorGsurf));
      return;
    }
  if (isA(a_featMinorGsurf, featGsurfPol))
    {
      if (!findString("featGsurfPol", featMinorGsurfSubs))
        {warnSub("featGsurfPol", "featMinorGsurf", a_featMinorGsurf);}
      else
        check_featGsurfPol(dynamic_cast<featGsurfPol *>(a_featMinorGsurf));
      return;
    }
}

/********************************************************************/

void check_featMinorLine(
 featMinorLine * a_featMinorLine)
{
  if (isA(a_featMinorLine, featLineBndCart))
    {
      if (!findString("featLineBndCart", featMinorLineSubs))
        {warnSub("featLineBndCart", "featMinorLine", a_featMinorLine);}
      else
        check_featLineBndCart(dynamic_cast<featLineBndCart *>(a_featMinorLine));
      return;
    }
  if (isA(a_featMinorLine, featLineBndPol))
    {
      if (!findString("featLineBndPol", featMinorLineSubs))
        {warnSub("featLineBndPol", "featMinorLine", a_featMinorLine);}
      else
        check_featLineBndPol(dynamic_cast<featLineBndPol *>(a_featMinorLine));
      return;
    }
  if (isA(a_featMinorLine, featLineUnbndCart))
    {
      if (!findString("featLineUnbndCart", featMinorLineSubs))
        {warnSub("featLineUnbndCart", "featMinorLine", a_featMinorLine);}
      else
        check_featLineUnbndCart(dynamic_cast<featLineUnbndCart *>(a_featMinorLine));
      return;
    }
  if (isA(a_featMinorLine, featLineUnbndPol))
    {
      if (!findString("featLineUnbndPol", featMinorLineSubs))
        {warnSub("featLineUnbndPol", "featMinorLine", a_featMinorLine);}
      else
        check_featLineUnbndPol(dynamic_cast<featLineUnbndPol *>(a_featMinorLine));
      return;
    }
}

/********************************************************************/

void check_featMinorObject(
 featMinorObject * a_featMinorObject)
{
  if (a_featMinorObject->get_paramList())
    {
      if (!findString("a_paramList", featMinorObjectAtts))
	{warnAtt("a_paramList", "featMinorObject", a_featMinorObject);}
      else
        {
          std::list<param *> * theList;
          std::list<param *>::iterator iter;
          theList = a_featMinorObject->get_paramList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_param(*iter);
        }
    }
}

/********************************************************************/

void check_featMinorParpln(
 featMinorParpln * a_featMinorParpln)
{
  if (isA(a_featMinorParpln, featParplnPointsCart))
    {
      if (!findString("featParplnPointsCart", featMinorParplnSubs))
        {warnSub("featParplnPointsCart", "featMinorParpln", a_featMinorParpln);}
      else
        check_featParplnPointsCart(dynamic_cast<featParplnPointsCart *>(a_featMinorParpln));
      return;
    }
  if (isA(a_featMinorParpln, featParplnPointsPol))
    {
      if (!findString("featParplnPointsPol", featMinorParplnSubs))
        {warnSub("featParplnPointsPol", "featMinorParpln", a_featMinorParpln);}
      else
        check_featParplnPointsPol(dynamic_cast<featParplnPointsPol *>(a_featMinorParpln));
      return;
    }
  if (isA(a_featMinorParpln, featParplnMidplCart))
    {
      if (!findString("featParplnMidplCart", featMinorParplnSubs))
        {warnSub("featParplnMidplCart", "featMinorParpln", a_featMinorParpln);}
      else
        check_featParplnMidplCart(dynamic_cast<featParplnMidplCart *>(a_featMinorParpln));
      return;
    }
  if (isA(a_featMinorParpln, featParplnMidplPol))
    {
      if (!findString("featParplnMidplPol", featMinorParplnSubs))
        {warnSub("featParplnMidplPol", "featMinorParpln", a_featMinorParpln);}
      else
        check_featParplnMidplPol(dynamic_cast<featParplnMidplPol *>(a_featMinorParpln));
      return;
    }
}

/********************************************************************/

void check_featMinorPatern(
 featMinorPatern * a_featMinorPatern)
{
  if (a_featMinorPatern->get_fLabel())
    {
      if (!findString("a_fLabel", featMinorPaternAtts))
	{warnAtt("a_fLabel", "featMinorPatern", a_featMinorPatern);}
      else
        check_fLabel(a_featMinorPatern->get_fLabel());
    }
  if (a_featMinorPatern->get_featureNominalList())
    {
      if (!findString("a_featureNominalList", featMinorPaternAtts))
	{warnAtt("a_featureNominalList", "featMinorPatern", a_featMinorPatern);}
      else
        {
          std::list<fLabel *> * theList;
          std::list<fLabel *>::iterator iter;
          theList = a_featMinorPatern->get_featureNominalList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_fLabel(*iter);
        }
    }
}

/********************************************************************/

void check_featMinorPlane(
 featMinorPlane * a_featMinorPlane)
{
  if (a_featMinorPlane->get_typePoint())
    {
      if (!findString("a_typePoint", featMinorPlaneAtts))
	{warnAtt("a_typePoint", "featMinorPlane", a_featMinorPlane);}
      else
        check_typePoint(a_featMinorPlane->get_typePoint());
    }
  if (a_featMinorPlane->get_planeVec())
    {
      if (!findString("planeVec", featMinorPlaneAtts))
	{warnAtt("planeVec", "featMinorPlane", a_featMinorPlane);}
      else
        check_vector(a_featMinorPlane->get_planeVec());
    }
}

/********************************************************************/

void check_featMinorPoint(
 featMinorPoint * a_featMinorPoint)
{
  if (a_featMinorPoint->get_typePoint())
    {
      if (!findString("a_typePoint", featMinorPointAtts))
	{warnAtt("a_typePoint", "featMinorPoint", a_featMinorPoint);}
      else
        check_typePoint(a_featMinorPoint->get_typePoint());
    }
  if (a_featMinorPoint->get_surfNorm())
    {
      if (!findString("surfNorm", featMinorPointAtts))
	{warnAtt("surfNorm", "featMinorPoint", a_featMinorPoint);}
      else
        check_vector(a_featMinorPoint->get_surfNorm());
    }
}

/********************************************************************/

void check_featMinorRctngl(
 featMinorRctngl * a_featMinorRctngl)
{
  if (a_featMinorRctngl->get_matDir())
    {
      if (!findString("a_matDir", featMinorRctnglAtts))
	{warnAtt("a_matDir", "featMinorRctngl", a_featMinorRctngl);}
      else
        check_matDir(a_featMinorRctngl->get_matDir());
    }
  if (a_featMinorRctngl->get_center())
    {
      if (!findString("center", featMinorRctnglAtts))
	{warnAtt("center", "featMinorRctngl", a_featMinorRctngl);}
      else
        check_typePoint(a_featMinorRctngl->get_center());
    }
  if (a_featMinorRctngl->get_faceVec1())
    {
      if (!findString("faceVec1", featMinorRctnglAtts))
	{warnAtt("faceVec1", "featMinorRctngl", a_featMinorRctngl);}
      else
        check_vector(a_featMinorRctngl->get_faceVec1());
    }
  if (a_featMinorRctngl->get_width1())
    {
      if (!findString("width1", featMinorRctnglAtts))
	{warnAtt("width1", "featMinorRctngl", a_featMinorRctngl);}
      else
        check_rentVal(a_featMinorRctngl->get_width1());
    }
  if (a_featMinorRctngl->get_faceVec2())
    {
      if (!findString("faceVec2", featMinorRctnglAtts))
	{warnAtt("faceVec2", "featMinorRctngl", a_featMinorRctngl);}
      else
        check_vector(a_featMinorRctngl->get_faceVec2());
    }
  if (a_featMinorRctngl->get_width2())
    {
      if (!findString("width2", featMinorRctnglAtts))
	{warnAtt("width2", "featMinorRctngl", a_featMinorRctngl);}
      else
        check_rentVal(a_featMinorRctngl->get_width2());
    }
  if (a_featMinorRctngl->get_faceVec3())
    {
      if (!findString("faceVec3", featMinorRctnglAtts))
	{warnAtt("faceVec3", "featMinorRctngl", a_featMinorRctngl);}
      else
        check_vector(a_featMinorRctngl->get_faceVec3());
    }
  if (a_featMinorRctngl->get_width3())
    {
      if (!findString("width3", featMinorRctnglAtts))
	{warnAtt("width3", "featMinorRctngl", a_featMinorRctngl);}
      else
        check_rentVal(a_featMinorRctngl->get_width3());
    }
}

/********************************************************************/

void check_featMinorRevsurf(
 featMinorRevsurf * a_featMinorRevsurf)
{
  if (isA(a_featMinorRevsurf, featRevsurfCart))
    {
      if (!findString("featRevsurfCart", featMinorRevsurfSubs))
        {warnSub("featRevsurfCart", "featMinorRevsurf", a_featMinorRevsurf);}
      else
        check_featRevsurfCart(dynamic_cast<featRevsurfCart *>(a_featMinorRevsurf));
      return;
    }
  if (isA(a_featMinorRevsurf, featRevsurfPol))
    {
      if (!findString("featRevsurfPol", featMinorRevsurfSubs))
        {warnSub("featRevsurfPol", "featMinorRevsurf", a_featMinorRevsurf);}
      else
        check_featRevsurfPol(dynamic_cast<featRevsurfPol *>(a_featMinorRevsurf));
      return;
    }
}

/********************************************************************/

void check_featMinorSphere(
 featMinorSphere * a_featMinorSphere)
{
  if (a_featMinorSphere->get_matDir())
    {
      if (!findString("a_matDir", featMinorSphereAtts))
	{warnAtt("a_matDir", "featMinorSphere", a_featMinorSphere);}
      else
        check_matDir(a_featMinorSphere->get_matDir());
    }
  if (a_featMinorSphere->get_center())
    {
      if (!findString("center", featMinorSphereAtts))
	{warnAtt("center", "featMinorSphere", a_featMinorSphere);}
      else
        check_typePoint(a_featMinorSphere->get_center());
    }
  if (a_featMinorSphere->get_diam())
    {
      if (!findString("diam", featMinorSphereAtts))
	{warnAtt("diam", "featMinorSphere", a_featMinorSphere);}
      else
        check_rentVal(a_featMinorSphere->get_diam());
    }
  if (a_featMinorSphere->get_orient())
    {
      if (!findString("orient", featMinorSphereAtts))
	{warnAtt("orient", "featMinorSphere", a_featMinorSphere);}
      else
        check_vector(a_featMinorSphere->get_orient());
    }
  if (a_featMinorSphere->get_lat())
    {
      if (!findString("lat", featMinorSphereAtts))
	{warnAtt("lat", "featMinorSphere", a_featMinorSphere);}
      else
        check_angle(a_featMinorSphere->get_lat());
    }
}

/********************************************************************/

void check_featMinorSphradseg(
 featMinorSphradseg * a_featMinorSphradseg)
{
  if (a_featMinorSphradseg->get_matDir())
    {
      if (!findString("a_matDir", featMinorSphradsegAtts))
	{warnAtt("a_matDir", "featMinorSphradseg", a_featMinorSphradseg);}
      else
        check_matDir(a_featMinorSphradseg->get_matDir());
    }
  if (a_featMinorSphradseg->get_center())
    {
      if (!findString("center", featMinorSphradsegAtts))
	{warnAtt("center", "featMinorSphradseg", a_featMinorSphradseg);}
      else
        check_typePoint(a_featMinorSphradseg->get_center());
    }
  if (a_featMinorSphradseg->get_diam())
    {
      if (!findString("diam", featMinorSphradsegAtts))
	{warnAtt("diam", "featMinorSphradseg", a_featMinorSphradseg);}
      else
        check_rentVal(a_featMinorSphradseg->get_diam());
    }
  if (a_featMinorSphradseg->get_north())
    {
      if (!findString("north", featMinorSphradsegAtts))
	{warnAtt("north", "featMinorSphradseg", a_featMinorSphradseg);}
      else
        check_vector(a_featMinorSphradseg->get_north());
    }
  if (a_featMinorSphradseg->get_latStart())
    {
      if (!findString("latStart", featMinorSphradsegAtts))
	{warnAtt("latStart", "featMinorSphradseg", a_featMinorSphradseg);}
      else
        check_rentVal(a_featMinorSphradseg->get_latStart());
    }
  if (a_featMinorSphradseg->get_latStop())
    {
      if (!findString("latStop", featMinorSphradsegAtts))
	{warnAtt("latStop", "featMinorSphradseg", a_featMinorSphradseg);}
      else
        check_rentVal(a_featMinorSphradseg->get_latStop());
    }
  if (a_featMinorSphradseg->get_prime())
    {
      if (!findString("prime", featMinorSphradsegAtts))
	{warnAtt("prime", "featMinorSphradseg", a_featMinorSphradseg);}
      else
        check_vector(a_featMinorSphradseg->get_prime());
    }
  if (a_featMinorSphradseg->get_longStart())
    {
      if (!findString("longStart", featMinorSphradsegAtts))
	{warnAtt("longStart", "featMinorSphradseg", a_featMinorSphradseg);}
      else
        check_rentVal(a_featMinorSphradseg->get_longStart());
    }
  if (a_featMinorSphradseg->get_longStop())
    {
      if (!findString("longStop", featMinorSphradsegAtts))
	{warnAtt("longStop", "featMinorSphradseg", a_featMinorSphradseg);}
      else
        check_rentVal(a_featMinorSphradseg->get_longStop());
    }
}

/********************************************************************/

void check_featMinorSympln(
 featMinorSympln * a_featMinorSympln)
{
  if (isA(a_featMinorSympln, featSymplnCart))
    {
      if (!findString("featSymplnCart", featMinorSymplnSubs))
        {warnSub("featSymplnCart", "featMinorSympln", a_featMinorSympln);}
      else
        check_featSymplnCart(dynamic_cast<featSymplnCart *>(a_featMinorSympln));
      return;
    }
  if (isA(a_featMinorSympln, featSymplnPol))
    {
      if (!findString("featSymplnPol", featMinorSymplnSubs))
        {warnSub("featSymplnPol", "featMinorSympln", a_featMinorSympln);}
      else
        check_featSymplnPol(dynamic_cast<featSymplnPol *>(a_featMinorSympln));
      return;
    }
}

/********************************************************************/

void check_featMinorTorradseg(
 featMinorTorradseg * a_featMinorTorradseg)
{
  if (a_featMinorTorradseg->get_matDir())
    {
      if (!findString("a_matDir", featMinorTorradsegAtts))
	{warnAtt("a_matDir", "featMinorTorradseg", a_featMinorTorradseg);}
      else
        check_matDir(a_featMinorTorradseg->get_matDir());
    }
  if (a_featMinorTorradseg->get_center())
    {
      if (!findString("center", featMinorTorradsegAtts))
	{warnAtt("center", "featMinorTorradseg", a_featMinorTorradseg);}
      else
        check_typePoint(a_featMinorTorradseg->get_center());
    }
  if (a_featMinorTorradseg->get_majrad())
    {
      if (!findString("majrad", featMinorTorradsegAtts))
	{warnAtt("majrad", "featMinorTorradseg", a_featMinorTorradseg);}
      else
        check_rentVal(a_featMinorTorradseg->get_majrad());
    }
  if (a_featMinorTorradseg->get_minrad())
    {
      if (!findString("minrad", featMinorTorradsegAtts))
	{warnAtt("minrad", "featMinorTorradseg", a_featMinorTorradseg);}
      else
        check_rentVal(a_featMinorTorradseg->get_minrad());
    }
  if (a_featMinorTorradseg->get_north())
    {
      if (!findString("north", featMinorTorradsegAtts))
	{warnAtt("north", "featMinorTorradseg", a_featMinorTorradseg);}
      else
        check_vector(a_featMinorTorradseg->get_north());
    }
  if (a_featMinorTorradseg->get_latStart())
    {
      if (!findString("latStart", featMinorTorradsegAtts))
	{warnAtt("latStart", "featMinorTorradseg", a_featMinorTorradseg);}
      else
        check_rentVal(a_featMinorTorradseg->get_latStart());
    }
  if (a_featMinorTorradseg->get_latStop())
    {
      if (!findString("latStop", featMinorTorradsegAtts))
	{warnAtt("latStop", "featMinorTorradseg", a_featMinorTorradseg);}
      else
        check_rentVal(a_featMinorTorradseg->get_latStop());
    }
  if (a_featMinorTorradseg->get_prime())
    {
      if (!findString("prime", featMinorTorradsegAtts))
	{warnAtt("prime", "featMinorTorradseg", a_featMinorTorradseg);}
      else
        check_vector(a_featMinorTorradseg->get_prime());
    }
  if (a_featMinorTorradseg->get_longStart())
    {
      if (!findString("longStart", featMinorTorradsegAtts))
	{warnAtt("longStart", "featMinorTorradseg", a_featMinorTorradseg);}
      else
        check_rentVal(a_featMinorTorradseg->get_longStart());
    }
  if (a_featMinorTorradseg->get_longStop())
    {
      if (!findString("longStop", featMinorTorradsegAtts))
	{warnAtt("longStop", "featMinorTorradseg", a_featMinorTorradseg);}
      else
        check_rentVal(a_featMinorTorradseg->get_longStop());
    }
}

/********************************************************************/

void check_featMinorTorus(
 featMinorTorus * a_featMinorTorus)
{
  if (a_featMinorTorus->get_matDir())
    {
      if (!findString("a_matDir", featMinorTorusAtts))
	{warnAtt("a_matDir", "featMinorTorus", a_featMinorTorus);}
      else
        check_matDir(a_featMinorTorus->get_matDir());
    }
  if (a_featMinorTorus->get_center())
    {
      if (!findString("center", featMinorTorusAtts))
	{warnAtt("center", "featMinorTorus", a_featMinorTorus);}
      else
        check_typePoint(a_featMinorTorus->get_center());
    }
  if (a_featMinorTorus->get_axis())
    {
      if (!findString("axis", featMinorTorusAtts))
	{warnAtt("axis", "featMinorTorus", a_featMinorTorus);}
      else
        check_vector(a_featMinorTorus->get_axis());
    }
  if (a_featMinorTorus->get_majorDiam())
    {
      if (!findString("majorDiam", featMinorTorusAtts))
	{warnAtt("majorDiam", "featMinorTorus", a_featMinorTorus);}
      else
        check_rentVal(a_featMinorTorus->get_majorDiam());
    }
  if (a_featMinorTorus->get_minorDiam())
    {
      if (!findString("minorDiam", featMinorTorusAtts))
	{warnAtt("minorDiam", "featMinorTorus", a_featMinorTorus);}
      else
        check_rentVal(a_featMinorTorus->get_minorDiam());
    }
}

/********************************************************************/

void check_featObjectAct(
 featObjectAct * a_featObjectAct)
{
  if (a_featObjectAct->get_faLabel())
    {
      if (!findString("a_faLabel", featObjectActAtts))
	{warnAtt("a_faLabel", "featObjectAct", a_featObjectAct);}
      else
        check_faLabel(a_featObjectAct->get_faLabel());
    }
  if (a_featObjectAct->get_featMinorObject())
    {
      if (!findString("a_featMinorObject", featObjectActAtts))
	{warnAtt("a_featMinorObject", "featObjectAct", a_featObjectAct);}
      else
        check_featMinorObject(a_featObjectAct->get_featMinorObject());
    }
}

/********************************************************************/

void check_featObjectNom(
 featObjectNom * a_featObjectNom)
{
  if (a_featObjectNom->get_fLabel())
    {
      if (!findString("a_fLabel", featObjectNomAtts))
	{warnAtt("a_fLabel", "featObjectNom", a_featObjectNom);}
      else
        check_fLabel(a_featObjectNom->get_fLabel());
    }
  if (a_featObjectNom->get_featMinorObject())
    {
      if (!findString("a_featMinorObject", featObjectNomAtts))
	{warnAtt("a_featMinorObject", "featObjectNom", a_featObjectNom);}
      else
        check_featMinorObject(a_featObjectNom->get_featMinorObject());
    }
}

/********************************************************************/

void check_featObjectStm(
 featObjectStm * a_featObjectStm)
{
  if (isA(a_featObjectStm, featObjectNom))
    {
      if (!findString("featObjectNom", featObjectStmSubs))
        {warnSub("featObjectNom", "featObjectStm", a_featObjectStm);}
      else
        check_featObjectNom(dynamic_cast<featObjectNom *>(a_featObjectStm));
      return;
    }
  if (isA(a_featObjectStm, featObjectAct))
    {
      if (!findString("featObjectAct", featObjectStmSubs))
        {warnSub("featObjectAct", "featObjectStm", a_featObjectStm);}
      else
        check_featObjectAct(dynamic_cast<featObjectAct *>(a_featObjectStm));
      return;
    }
}

/********************************************************************/

void check_featParplnAct(
 featParplnAct * a_featParplnAct)
{
  if (a_featParplnAct->get_faLabel())
    {
      if (!findString("a_faLabel", featParplnActAtts))
	{warnAtt("a_faLabel", "featParplnAct", a_featParplnAct);}
      else
        check_faLabel(a_featParplnAct->get_faLabel());
    }
  if (a_featParplnAct->get_featMinorParpln())
    {
      if (!findString("a_featMinorParpln", featParplnActAtts))
	{warnAtt("a_featMinorParpln", "featParplnAct", a_featParplnAct);}
      else
        check_featMinorParpln(a_featParplnAct->get_featMinorParpln());
    }
}

/********************************************************************/

void check_featParplnMidplCart(
 featParplnMidplCart * a_featParplnMidplCart)
{
  if (a_featParplnMidplCart->get_matDir())
    {
      if (!findString("a_matDir", featParplnMidplCartAtts))
	{warnAtt("a_matDir", "featParplnMidplCart", a_featParplnMidplCart);}
      else
        check_matDir(a_featParplnMidplCart->get_matDir());
    }
  if (a_featParplnMidplCart->get_centerPt())
    {
      if (!findString("centerPt", featParplnMidplCartAtts))
	{warnAtt("centerPt", "featParplnMidplCart", a_featParplnMidplCart);}
      else
        check_cartPoint(a_featParplnMidplCart->get_centerPt());
    }
  if (a_featParplnMidplCart->get_centerVec())
    {
      if (!findString("centerVec", featParplnMidplCartAtts))
	{warnAtt("centerVec", "featParplnMidplCart", a_featParplnMidplCart);}
      else
        check_vector(a_featParplnMidplCart->get_centerVec());
    }
  if (a_featParplnMidplCart->get_width())
    {
      if (!findString("width", featParplnMidplCartAtts))
	{warnAtt("width", "featParplnMidplCart", a_featParplnMidplCart);}
      else
        check_rentVal(a_featParplnMidplCart->get_width());
    }
}

/********************************************************************/

void check_featParplnMidplPol(
 featParplnMidplPol * a_featParplnMidplPol)
{
  if (a_featParplnMidplPol->get_matDir())
    {
      if (!findString("a_matDir", featParplnMidplPolAtts))
	{warnAtt("a_matDir", "featParplnMidplPol", a_featParplnMidplPol);}
      else
        check_matDir(a_featParplnMidplPol->get_matDir());
    }
  if (a_featParplnMidplPol->get_centerPt())
    {
      if (!findString("centerPt", featParplnMidplPolAtts))
	{warnAtt("centerPt", "featParplnMidplPol", a_featParplnMidplPol);}
      else
        check_polPoint(a_featParplnMidplPol->get_centerPt());
    }
  if (a_featParplnMidplPol->get_centerVec())
    {
      if (!findString("centerVec", featParplnMidplPolAtts))
	{warnAtt("centerVec", "featParplnMidplPol", a_featParplnMidplPol);}
      else
        check_vector(a_featParplnMidplPol->get_centerVec());
    }
  if (a_featParplnMidplPol->get_width())
    {
      if (!findString("width", featParplnMidplPolAtts))
	{warnAtt("width", "featParplnMidplPol", a_featParplnMidplPol);}
      else
        check_rentVal(a_featParplnMidplPol->get_width());
    }
}

/********************************************************************/

void check_featParplnNom(
 featParplnNom * a_featParplnNom)
{
  if (a_featParplnNom->get_fLabel())
    {
      if (!findString("a_fLabel", featParplnNomAtts))
	{warnAtt("a_fLabel", "featParplnNom", a_featParplnNom);}
      else
        check_fLabel(a_featParplnNom->get_fLabel());
    }
  if (a_featParplnNom->get_featMinorParpln())
    {
      if (!findString("a_featMinorParpln", featParplnNomAtts))
	{warnAtt("a_featMinorParpln", "featParplnNom", a_featParplnNom);}
      else
        check_featMinorParpln(a_featParplnNom->get_featMinorParpln());
    }
}

/********************************************************************/

void check_featParplnPointsCart(
 featParplnPointsCart * a_featParplnPointsCart)
{
  if (a_featParplnPointsCart->get_matDir())
    {
      if (!findString("a_matDir", featParplnPointsCartAtts))
	{warnAtt("a_matDir", "featParplnPointsCart", a_featParplnPointsCart);}
      else
        check_matDir(a_featParplnPointsCart->get_matDir());
    }
  if (a_featParplnPointsCart->get_centerPt())
    {
      if (!findString("centerPt", featParplnPointsCartAtts))
	{warnAtt("centerPt", "featParplnPointsCart", a_featParplnPointsCart);}
      else
        check_cartPoint(a_featParplnPointsCart->get_centerPt());
    }
  if (a_featParplnPointsCart->get_plane1data())
    {
      if (!findString("plane1data", featParplnPointsCartAtts))
	{warnAtt("plane1data", "featParplnPointsCart", a_featParplnPointsCart);}
      else
        check_pointVecCart(a_featParplnPointsCart->get_plane1data());
    }
  if (a_featParplnPointsCart->get_plane2data())
    {
      if (!findString("plane2data", featParplnPointsCartAtts))
	{warnAtt("plane2data", "featParplnPointsCart", a_featParplnPointsCart);}
      else
        check_pointVecCart(a_featParplnPointsCart->get_plane2data());
    }
  if (a_featParplnPointsCart->get_width())
    {
      if (!findString("width", featParplnPointsCartAtts))
	{warnAtt("width", "featParplnPointsCart", a_featParplnPointsCart);}
      else
        check_rentVal(a_featParplnPointsCart->get_width());
    }
}

/********************************************************************/

void check_featParplnPointsPol(
 featParplnPointsPol * a_featParplnPointsPol)
{
  if (a_featParplnPointsPol->get_matDir())
    {
      if (!findString("a_matDir", featParplnPointsPolAtts))
	{warnAtt("a_matDir", "featParplnPointsPol", a_featParplnPointsPol);}
      else
        check_matDir(a_featParplnPointsPol->get_matDir());
    }
  if (a_featParplnPointsPol->get_centerPt())
    {
      if (!findString("centerPt", featParplnPointsPolAtts))
	{warnAtt("centerPt", "featParplnPointsPol", a_featParplnPointsPol);}
      else
        check_polPoint(a_featParplnPointsPol->get_centerPt());
    }
  if (a_featParplnPointsPol->get_plane1data())
    {
      if (!findString("plane1data", featParplnPointsPolAtts))
	{warnAtt("plane1data", "featParplnPointsPol", a_featParplnPointsPol);}
      else
        check_pointVecPol(a_featParplnPointsPol->get_plane1data());
    }
  if (a_featParplnPointsPol->get_plane2data())
    {
      if (!findString("plane2data", featParplnPointsPolAtts))
	{warnAtt("plane2data", "featParplnPointsPol", a_featParplnPointsPol);}
      else
        check_pointVecPol(a_featParplnPointsPol->get_plane2data());
    }
  if (a_featParplnPointsPol->get_width())
    {
      if (!findString("width", featParplnPointsPolAtts))
	{warnAtt("width", "featParplnPointsPol", a_featParplnPointsPol);}
      else
        check_rentVal(a_featParplnPointsPol->get_width());
    }
}

/********************************************************************/

void check_featParplnStm(
 featParplnStm * a_featParplnStm)
{
  if (isA(a_featParplnStm, featParplnNom))
    {
      if (!findString("featParplnNom", featParplnStmSubs))
        {warnSub("featParplnNom", "featParplnStm", a_featParplnStm);}
      else
        check_featParplnNom(dynamic_cast<featParplnNom *>(a_featParplnStm));
      return;
    }
  if (isA(a_featParplnStm, featParplnAct))
    {
      if (!findString("featParplnAct", featParplnStmSubs))
        {warnSub("featParplnAct", "featParplnStm", a_featParplnStm);}
      else
        check_featParplnAct(dynamic_cast<featParplnAct *>(a_featParplnStm));
      return;
    }
}

/********************************************************************/

void check_featPaternStm(
 featPaternStm * a_featPaternStm)
{
  if (a_featPaternStm->get_fLabel())
    {
      if (!findString("a_fLabel", featPaternStmAtts))
	{warnAtt("a_fLabel", "featPaternStm", a_featPaternStm);}
      else
        check_fLabel(a_featPaternStm->get_fLabel());
    }
  if (a_featPaternStm->get_featMinorPatern())
    {
      if (!findString("a_featMinorPatern", featPaternStmAtts))
	{warnAtt("a_featMinorPatern", "featPaternStm", a_featPaternStm);}
      else
        check_featMinorPatern(a_featPaternStm->get_featMinorPatern());
    }
}

/********************************************************************/

void check_featPlaneAct(
 featPlaneAct * a_featPlaneAct)
{
  if (a_featPlaneAct->get_faLabel())
    {
      if (!findString("a_faLabel", featPlaneActAtts))
	{warnAtt("a_faLabel", "featPlaneAct", a_featPlaneAct);}
      else
        check_faLabel(a_featPlaneAct->get_faLabel());
    }
  if (a_featPlaneAct->get_featMinorPlane())
    {
      if (!findString("a_featMinorPlane", featPlaneActAtts))
	{warnAtt("a_featMinorPlane", "featPlaneAct", a_featPlaneAct);}
      else
        check_featMinorPlane(a_featPlaneAct->get_featMinorPlane());
    }
}

/********************************************************************/

void check_featPlaneNom(
 featPlaneNom * a_featPlaneNom)
{
  if (a_featPlaneNom->get_fLabel())
    {
      if (!findString("a_fLabel", featPlaneNomAtts))
	{warnAtt("a_fLabel", "featPlaneNom", a_featPlaneNom);}
      else
        check_fLabel(a_featPlaneNom->get_fLabel());
    }
  if (a_featPlaneNom->get_featMinorPlane())
    {
      if (!findString("a_featMinorPlane", featPlaneNomAtts))
	{warnAtt("a_featMinorPlane", "featPlaneNom", a_featPlaneNom);}
      else
        check_featMinorPlane(a_featPlaneNom->get_featMinorPlane());
    }
}

/********************************************************************/

void check_featPlaneStm(
 featPlaneStm * a_featPlaneStm)
{
  if (isA(a_featPlaneStm, featPlaneNom))
    {
      if (!findString("featPlaneNom", featPlaneStmSubs))
        {warnSub("featPlaneNom", "featPlaneStm", a_featPlaneStm);}
      else
        check_featPlaneNom(dynamic_cast<featPlaneNom *>(a_featPlaneStm));
      return;
    }
  if (isA(a_featPlaneStm, featPlaneAct))
    {
      if (!findString("featPlaneAct", featPlaneStmSubs))
        {warnSub("featPlaneAct", "featPlaneStm", a_featPlaneStm);}
      else
        check_featPlaneAct(dynamic_cast<featPlaneAct *>(a_featPlaneStm));
      return;
    }
}

/********************************************************************/

void check_featPointAct(
 featPointAct * a_featPointAct)
{
  if (a_featPointAct->get_faLabel())
    {
      if (!findString("a_faLabel", featPointActAtts))
	{warnAtt("a_faLabel", "featPointAct", a_featPointAct);}
      else
        check_faLabel(a_featPointAct->get_faLabel());
    }
  if (a_featPointAct->get_featMinorPoint())
    {
      if (!findString("a_featMinorPoint", featPointActAtts))
	{warnAtt("a_featMinorPoint", "featPointAct", a_featPointAct);}
      else
        check_featMinorPoint(a_featPointAct->get_featMinorPoint());
    }
}

/********************************************************************/

void check_featPointNom(
 featPointNom * a_featPointNom)
{
  if (a_featPointNom->get_fLabel())
    {
      if (!findString("a_fLabel", featPointNomAtts))
	{warnAtt("a_fLabel", "featPointNom", a_featPointNom);}
      else
        check_fLabel(a_featPointNom->get_fLabel());
    }
  if (a_featPointNom->get_featMinorPoint())
    {
      if (!findString("a_featMinorPoint", featPointNomAtts))
	{warnAtt("a_featMinorPoint", "featPointNom", a_featPointNom);}
      else
        check_featMinorPoint(a_featPointNom->get_featMinorPoint());
    }
}

/********************************************************************/

void check_featPointStm(
 featPointStm * a_featPointStm)
{
  if (isA(a_featPointStm, featPointNom))
    {
      if (!findString("featPointNom", featPointStmSubs))
        {warnSub("featPointNom", "featPointStm", a_featPointStm);}
      else
        check_featPointNom(dynamic_cast<featPointNom *>(a_featPointStm));
      return;
    }
  if (isA(a_featPointStm, featPointAct))
    {
      if (!findString("featPointAct", featPointStmSubs))
        {warnSub("featPointAct", "featPointStm", a_featPointStm);}
      else
        check_featPointAct(dynamic_cast<featPointAct *>(a_featPointStm));
      return;
    }
}

/********************************************************************/

void check_featRctnglAct(
 featRctnglAct * a_featRctnglAct)
{
  if (a_featRctnglAct->get_faLabel())
    {
      if (!findString("a_faLabel", featRctnglActAtts))
	{warnAtt("a_faLabel", "featRctnglAct", a_featRctnglAct);}
      else
        check_faLabel(a_featRctnglAct->get_faLabel());
    }
  if (a_featRctnglAct->get_featMinorRctngl())
    {
      if (!findString("a_featMinorRctngl", featRctnglActAtts))
	{warnAtt("a_featMinorRctngl", "featRctnglAct", a_featRctnglAct);}
      else
        check_featMinorRctngl(a_featRctnglAct->get_featMinorRctngl());
    }
}

/********************************************************************/

void check_featRctnglNom(
 featRctnglNom * a_featRctnglNom)
{
  if (a_featRctnglNom->get_fLabel())
    {
      if (!findString("a_fLabel", featRctnglNomAtts))
	{warnAtt("a_fLabel", "featRctnglNom", a_featRctnglNom);}
      else
        check_fLabel(a_featRctnglNom->get_fLabel());
    }
  if (a_featRctnglNom->get_featMinorRctngl())
    {
      if (!findString("a_featMinorRctngl", featRctnglNomAtts))
	{warnAtt("a_featMinorRctngl", "featRctnglNom", a_featRctnglNom);}
      else
        check_featMinorRctngl(a_featRctnglNom->get_featMinorRctngl());
    }
}

/********************************************************************/

void check_featRctnglStm(
 featRctnglStm * a_featRctnglStm)
{
  if (isA(a_featRctnglStm, featRctnglNom))
    {
      if (!findString("featRctnglNom", featRctnglStmSubs))
        {warnSub("featRctnglNom", "featRctnglStm", a_featRctnglStm);}
      else
        check_featRctnglNom(dynamic_cast<featRctnglNom *>(a_featRctnglStm));
      return;
    }
  if (isA(a_featRctnglStm, featRctnglAct))
    {
      if (!findString("featRctnglAct", featRctnglStmSubs))
        {warnSub("featRctnglAct", "featRctnglStm", a_featRctnglStm);}
      else
        check_featRctnglAct(dynamic_cast<featRctnglAct *>(a_featRctnglStm));
      return;
    }
}

/********************************************************************/

void check_featRevsurfAct(
 featRevsurfAct * a_featRevsurfAct)
{
  if (a_featRevsurfAct->get_faLabel())
    {
      if (!findString("a_faLabel", featRevsurfActAtts))
	{warnAtt("a_faLabel", "featRevsurfAct", a_featRevsurfAct);}
      else
        check_faLabel(a_featRevsurfAct->get_faLabel());
    }
  if (a_featRevsurfAct->get_featMinorRevsurf())
    {
      if (!findString("a_featMinorRevsurf", featRevsurfActAtts))
	{warnAtt("a_featMinorRevsurf", "featRevsurfAct", a_featRevsurfAct);}
      else
        check_featMinorRevsurf(a_featRevsurfAct->get_featMinorRevsurf());
    }
}

/********************************************************************/

void check_featRevsurfCart(
 featRevsurfCart * a_featRevsurfCart)
{
  if (a_featRevsurfCart->get_matDir())
    {
      if (!findString("a_matDir", featRevsurfCartAtts))
	{warnAtt("a_matDir", "featRevsurfCart", a_featRevsurfCart);}
      else
        check_matDir(a_featRevsurfCart->get_matDir());
    }
  if (a_featRevsurfCart->get_typePoint())
    {
      if (!findString("a_typePoint", featRevsurfCartAtts))
	{warnAtt("a_typePoint", "featRevsurfCart", a_featRevsurfCart);}
      else
        check_typePoint(a_featRevsurfCart->get_typePoint());
    }
  if (a_featRevsurfCart->get_axis())
    {
      if (!findString("axis", featRevsurfCartAtts))
	{warnAtt("axis", "featRevsurfCart", a_featRevsurfCart);}
      else
        check_vector(a_featRevsurfCart->get_axis());
    }
  if (a_featRevsurfCart->get_cartPoint())
    {
      if (!findString("a_cartPoint", featRevsurfCartAtts))
	{warnAtt("a_cartPoint", "featRevsurfCart", a_featRevsurfCart);}
      else
        check_cartPoint(a_featRevsurfCart->get_cartPoint());
    }
  if (a_featRevsurfCart->get_impCartPointList())
    {
      if (!findString("a_impCartPointList", featRevsurfCartAtts))
	{warnAtt("a_impCartPointList", "featRevsurfCart", a_featRevsurfCart);}
      else
        {
          std::list<impCartPoint *> * theList;
          std::list<impCartPoint *>::iterator iter;
          theList = a_featRevsurfCart->get_impCartPointList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_impCartPoint(*iter);
        }
    }
}

/********************************************************************/

void check_featRevsurfNom(
 featRevsurfNom * a_featRevsurfNom)
{
  if (a_featRevsurfNom->get_fLabel())
    {
      if (!findString("a_fLabel", featRevsurfNomAtts))
	{warnAtt("a_fLabel", "featRevsurfNom", a_featRevsurfNom);}
      else
        check_fLabel(a_featRevsurfNom->get_fLabel());
    }
  if (a_featRevsurfNom->get_featMinorRevsurf())
    {
      if (!findString("a_featMinorRevsurf", featRevsurfNomAtts))
	{warnAtt("a_featMinorRevsurf", "featRevsurfNom", a_featRevsurfNom);}
      else
        check_featMinorRevsurf(a_featRevsurfNom->get_featMinorRevsurf());
    }
}

/********************************************************************/

void check_featRevsurfPol(
 featRevsurfPol * a_featRevsurfPol)
{
  if (a_featRevsurfPol->get_matDir())
    {
      if (!findString("a_matDir", featRevsurfPolAtts))
	{warnAtt("a_matDir", "featRevsurfPol", a_featRevsurfPol);}
      else
        check_matDir(a_featRevsurfPol->get_matDir());
    }
  if (a_featRevsurfPol->get_typePoint())
    {
      if (!findString("a_typePoint", featRevsurfPolAtts))
	{warnAtt("a_typePoint", "featRevsurfPol", a_featRevsurfPol);}
      else
        check_typePoint(a_featRevsurfPol->get_typePoint());
    }
  if (a_featRevsurfPol->get_axis())
    {
      if (!findString("axis", featRevsurfPolAtts))
	{warnAtt("axis", "featRevsurfPol", a_featRevsurfPol);}
      else
        check_vector(a_featRevsurfPol->get_axis());
    }
  if (a_featRevsurfPol->get_polPoint())
    {
      if (!findString("a_polPoint", featRevsurfPolAtts))
	{warnAtt("a_polPoint", "featRevsurfPol", a_featRevsurfPol);}
      else
        check_polPoint(a_featRevsurfPol->get_polPoint());
    }
  if (a_featRevsurfPol->get_impPolPointList())
    {
      if (!findString("a_impPolPointList", featRevsurfPolAtts))
	{warnAtt("a_impPolPointList", "featRevsurfPol", a_featRevsurfPol);}
      else
        {
          std::list<impPolPoint *> * theList;
          std::list<impPolPoint *>::iterator iter;
          theList = a_featRevsurfPol->get_impPolPointList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_impPolPoint(*iter);
        }
    }
}

/********************************************************************/

void check_featRevsurfStm(
 featRevsurfStm * a_featRevsurfStm)
{
  if (isA(a_featRevsurfStm, featRevsurfNom))
    {
      if (!findString("featRevsurfNom", featRevsurfStmSubs))
        {warnSub("featRevsurfNom", "featRevsurfStm", a_featRevsurfStm);}
      else
        check_featRevsurfNom(dynamic_cast<featRevsurfNom *>(a_featRevsurfStm));
      return;
    }
  if (isA(a_featRevsurfStm, featRevsurfAct))
    {
      if (!findString("featRevsurfAct", featRevsurfStmSubs))
        {warnSub("featRevsurfAct", "featRevsurfStm", a_featRevsurfStm);}
      else
        check_featRevsurfAct(dynamic_cast<featRevsurfAct *>(a_featRevsurfStm));
      return;
    }
}

/********************************************************************/

void check_featSphereAct(
 featSphereAct * a_featSphereAct)
{
  if (a_featSphereAct->get_faLabel())
    {
      if (!findString("a_faLabel", featSphereActAtts))
	{warnAtt("a_faLabel", "featSphereAct", a_featSphereAct);}
      else
        check_faLabel(a_featSphereAct->get_faLabel());
    }
  if (a_featSphereAct->get_featMinorSphere())
    {
      if (!findString("a_featMinorSphere", featSphereActAtts))
	{warnAtt("a_featMinorSphere", "featSphereAct", a_featSphereAct);}
      else
        check_featMinorSphere(a_featSphereAct->get_featMinorSphere());
    }
}

/********************************************************************/

void check_featSphereNom(
 featSphereNom * a_featSphereNom)
{
  if (a_featSphereNom->get_fLabel())
    {
      if (!findString("a_fLabel", featSphereNomAtts))
	{warnAtt("a_fLabel", "featSphereNom", a_featSphereNom);}
      else
        check_fLabel(a_featSphereNom->get_fLabel());
    }
  if (a_featSphereNom->get_featMinorSphere())
    {
      if (!findString("a_featMinorSphere", featSphereNomAtts))
	{warnAtt("a_featMinorSphere", "featSphereNom", a_featSphereNom);}
      else
        check_featMinorSphere(a_featSphereNom->get_featMinorSphere());
    }
}

/********************************************************************/

void check_featSphereStm(
 featSphereStm * a_featSphereStm)
{
  if (isA(a_featSphereStm, featSphereNom))
    {
      if (!findString("featSphereNom", featSphereStmSubs))
        {warnSub("featSphereNom", "featSphereStm", a_featSphereStm);}
      else
        check_featSphereNom(dynamic_cast<featSphereNom *>(a_featSphereStm));
      return;
    }
  if (isA(a_featSphereStm, featSphereAct))
    {
      if (!findString("featSphereAct", featSphereStmSubs))
        {warnSub("featSphereAct", "featSphereStm", a_featSphereStm);}
      else
        check_featSphereAct(dynamic_cast<featSphereAct *>(a_featSphereStm));
      return;
    }
}

/********************************************************************/

void check_featSphradsegAct(
 featSphradsegAct * a_featSphradsegAct)
{
  if (a_featSphradsegAct->get_faLabel())
    {
      if (!findString("a_faLabel", featSphradsegActAtts))
	{warnAtt("a_faLabel", "featSphradsegAct", a_featSphradsegAct);}
      else
        check_faLabel(a_featSphradsegAct->get_faLabel());
    }
  if (a_featSphradsegAct->get_featMinorSphradseg())
    {
      if (!findString("a_featMinorSphradseg", featSphradsegActAtts))
	{warnAtt("a_featMinorSphradseg", "featSphradsegAct", a_featSphradsegAct);}
      else
        check_featMinorSphradseg(a_featSphradsegAct->get_featMinorSphradseg());
    }
}

/********************************************************************/

void check_featSphradsegNom(
 featSphradsegNom * a_featSphradsegNom)
{
  if (a_featSphradsegNom->get_fLabel())
    {
      if (!findString("a_fLabel", featSphradsegNomAtts))
	{warnAtt("a_fLabel", "featSphradsegNom", a_featSphradsegNom);}
      else
        check_fLabel(a_featSphradsegNom->get_fLabel());
    }
  if (a_featSphradsegNom->get_featMinorSphradseg())
    {
      if (!findString("a_featMinorSphradseg", featSphradsegNomAtts))
	{warnAtt("a_featMinorSphradseg", "featSphradsegNom", a_featSphradsegNom);}
      else
        check_featMinorSphradseg(a_featSphradsegNom->get_featMinorSphradseg());
    }
}

/********************************************************************/

void check_featSphradsegStm(
 featSphradsegStm * a_featSphradsegStm)
{
  if (isA(a_featSphradsegStm, featSphradsegNom))
    {
      if (!findString("featSphradsegNom", featSphradsegStmSubs))
        {warnSub("featSphradsegNom", "featSphradsegStm", a_featSphradsegStm);}
      else
        check_featSphradsegNom(dynamic_cast<featSphradsegNom *>(a_featSphradsegStm));
      return;
    }
  if (isA(a_featSphradsegStm, featSphradsegAct))
    {
      if (!findString("featSphradsegAct", featSphradsegStmSubs))
        {warnSub("featSphradsegAct", "featSphradsegStm", a_featSphradsegStm);}
      else
        check_featSphradsegAct(dynamic_cast<featSphradsegAct *>(a_featSphradsegStm));
      return;
    }
}

/********************************************************************/

void check_featSymplnAct(
 featSymplnAct * a_featSymplnAct)
{
  if (a_featSymplnAct->get_faLabel())
    {
      if (!findString("a_faLabel", featSymplnActAtts))
	{warnAtt("a_faLabel", "featSymplnAct", a_featSymplnAct);}
      else
        check_faLabel(a_featSymplnAct->get_faLabel());
    }
  if (a_featSymplnAct->get_featMinorSympln())
    {
      if (!findString("a_featMinorSympln", featSymplnActAtts))
	{warnAtt("a_featMinorSympln", "featSymplnAct", a_featSymplnAct);}
      else
        check_featMinorSympln(a_featSymplnAct->get_featMinorSympln());
    }
}

/********************************************************************/

void check_featSymplnCart(
 featSymplnCart * a_featSymplnCart)
{
  if (a_featSymplnCart->get_matDir())
    {
      if (!findString("a_matDir", featSymplnCartAtts))
	{warnAtt("a_matDir", "featSymplnCart", a_featSymplnCart);}
      else
        check_matDir(a_featSymplnCart->get_matDir());
    }
  if (a_featSymplnCart->get_centerPt())
    {
      if (!findString("centerPt", featSymplnCartAtts))
	{warnAtt("centerPt", "featSymplnCart", a_featSymplnCart);}
      else
        check_cartPoint(a_featSymplnCart->get_centerPt());
    }
  if (a_featSymplnCart->get_plane1data())
    {
      if (!findString("plane1data", featSymplnCartAtts))
	{warnAtt("plane1data", "featSymplnCart", a_featSymplnCart);}
      else
        check_pointVecCart(a_featSymplnCart->get_plane1data());
    }
  if (a_featSymplnCart->get_plane2data())
    {
      if (!findString("plane2data", featSymplnCartAtts))
	{warnAtt("plane2data", "featSymplnCart", a_featSymplnCart);}
      else
        check_pointVecCart(a_featSymplnCart->get_plane2data());
    }
  if (a_featSymplnCart->get_width())
    {
      if (!findString("width", featSymplnCartAtts))
	{warnAtt("width", "featSymplnCart", a_featSymplnCart);}
      else
        check_rentVal(a_featSymplnCart->get_width());
    }
}

/********************************************************************/

void check_featSymplnNom(
 featSymplnNom * a_featSymplnNom)
{
  if (a_featSymplnNom->get_fLabel())
    {
      if (!findString("a_fLabel", featSymplnNomAtts))
	{warnAtt("a_fLabel", "featSymplnNom", a_featSymplnNom);}
      else
        check_fLabel(a_featSymplnNom->get_fLabel());
    }
  if (a_featSymplnNom->get_featMinorSympln())
    {
      if (!findString("a_featMinorSympln", featSymplnNomAtts))
	{warnAtt("a_featMinorSympln", "featSymplnNom", a_featSymplnNom);}
      else
        check_featMinorSympln(a_featSymplnNom->get_featMinorSympln());
    }
}

/********************************************************************/

void check_featSymplnPol(
 featSymplnPol * a_featSymplnPol)
{
  if (a_featSymplnPol->get_matDir())
    {
      if (!findString("a_matDir", featSymplnPolAtts))
	{warnAtt("a_matDir", "featSymplnPol", a_featSymplnPol);}
      else
        check_matDir(a_featSymplnPol->get_matDir());
    }
  if (a_featSymplnPol->get_centerPt())
    {
      if (!findString("centerPt", featSymplnPolAtts))
	{warnAtt("centerPt", "featSymplnPol", a_featSymplnPol);}
      else
        check_polPoint(a_featSymplnPol->get_centerPt());
    }
  if (a_featSymplnPol->get_plane1data())
    {
      if (!findString("plane1data", featSymplnPolAtts))
	{warnAtt("plane1data", "featSymplnPol", a_featSymplnPol);}
      else
        check_pointVecPol(a_featSymplnPol->get_plane1data());
    }
  if (a_featSymplnPol->get_plane2data())
    {
      if (!findString("plane2data", featSymplnPolAtts))
	{warnAtt("plane2data", "featSymplnPol", a_featSymplnPol);}
      else
        check_pointVecPol(a_featSymplnPol->get_plane2data());
    }
  if (a_featSymplnPol->get_width())
    {
      if (!findString("width", featSymplnPolAtts))
	{warnAtt("width", "featSymplnPol", a_featSymplnPol);}
      else
        check_rentVal(a_featSymplnPol->get_width());
    }
}

/********************************************************************/

void check_featSymplnStm(
 featSymplnStm * a_featSymplnStm)
{
  if (isA(a_featSymplnStm, featSymplnNom))
    {
      if (!findString("featSymplnNom", featSymplnStmSubs))
        {warnSub("featSymplnNom", "featSymplnStm", a_featSymplnStm);}
      else
        check_featSymplnNom(dynamic_cast<featSymplnNom *>(a_featSymplnStm));
      return;
    }
  if (isA(a_featSymplnStm, featSymplnAct))
    {
      if (!findString("featSymplnAct", featSymplnStmSubs))
        {warnSub("featSymplnAct", "featSymplnStm", a_featSymplnStm);}
      else
        check_featSymplnAct(dynamic_cast<featSymplnAct *>(a_featSymplnStm));
      return;
    }
}

/********************************************************************/

void check_featTorradsegAct(
 featTorradsegAct * a_featTorradsegAct)
{
  if (a_featTorradsegAct->get_faLabel())
    {
      if (!findString("a_faLabel", featTorradsegActAtts))
	{warnAtt("a_faLabel", "featTorradsegAct", a_featTorradsegAct);}
      else
        check_faLabel(a_featTorradsegAct->get_faLabel());
    }
  if (a_featTorradsegAct->get_featMinorTorradseg())
    {
      if (!findString("a_featMinorTorradseg", featTorradsegActAtts))
	{warnAtt("a_featMinorTorradseg", "featTorradsegAct", a_featTorradsegAct);}
      else
        check_featMinorTorradseg(a_featTorradsegAct->get_featMinorTorradseg());
    }
}

/********************************************************************/

void check_featTorradsegNom(
 featTorradsegNom * a_featTorradsegNom)
{
  if (a_featTorradsegNom->get_fLabel())
    {
      if (!findString("a_fLabel", featTorradsegNomAtts))
	{warnAtt("a_fLabel", "featTorradsegNom", a_featTorradsegNom);}
      else
        check_fLabel(a_featTorradsegNom->get_fLabel());
    }
  if (a_featTorradsegNom->get_featMinorTorradseg())
    {
      if (!findString("a_featMinorTorradseg", featTorradsegNomAtts))
	{warnAtt("a_featMinorTorradseg", "featTorradsegNom", a_featTorradsegNom);}
      else
        check_featMinorTorradseg(a_featTorradsegNom->get_featMinorTorradseg());
    }
}

/********************************************************************/

void check_featTorradsegStm(
 featTorradsegStm * a_featTorradsegStm)
{
  if (isA(a_featTorradsegStm, featTorradsegNom))
    {
      if (!findString("featTorradsegNom", featTorradsegStmSubs))
        {warnSub("featTorradsegNom", "featTorradsegStm", a_featTorradsegStm);}
      else
        check_featTorradsegNom(dynamic_cast<featTorradsegNom *>(a_featTorradsegStm));
      return;
    }
  if (isA(a_featTorradsegStm, featTorradsegAct))
    {
      if (!findString("featTorradsegAct", featTorradsegStmSubs))
        {warnSub("featTorradsegAct", "featTorradsegStm", a_featTorradsegStm);}
      else
        check_featTorradsegAct(dynamic_cast<featTorradsegAct *>(a_featTorradsegStm));
      return;
    }
}

/********************************************************************/

void check_featTorusAct(
 featTorusAct * a_featTorusAct)
{
  if (a_featTorusAct->get_faLabel())
    {
      if (!findString("a_faLabel", featTorusActAtts))
	{warnAtt("a_faLabel", "featTorusAct", a_featTorusAct);}
      else
        check_faLabel(a_featTorusAct->get_faLabel());
    }
  if (a_featTorusAct->get_featMinorTorus())
    {
      if (!findString("a_featMinorTorus", featTorusActAtts))
	{warnAtt("a_featMinorTorus", "featTorusAct", a_featTorusAct);}
      else
        check_featMinorTorus(a_featTorusAct->get_featMinorTorus());
    }
}

/********************************************************************/

void check_featTorusNom(
 featTorusNom * a_featTorusNom)
{
  if (a_featTorusNom->get_fLabel())
    {
      if (!findString("a_fLabel", featTorusNomAtts))
	{warnAtt("a_fLabel", "featTorusNom", a_featTorusNom);}
      else
        check_fLabel(a_featTorusNom->get_fLabel());
    }
  if (a_featTorusNom->get_featMinorTorus())
    {
      if (!findString("a_featMinorTorus", featTorusNomAtts))
	{warnAtt("a_featMinorTorus", "featTorusNom", a_featTorusNom);}
      else
        check_featMinorTorus(a_featTorusNom->get_featMinorTorus());
    }
}

/********************************************************************/

void check_featTorusStm(
 featTorusStm * a_featTorusStm)
{
  if (isA(a_featTorusStm, featTorusNom))
    {
      if (!findString("featTorusNom", featTorusStmSubs))
        {warnSub("featTorusNom", "featTorusStm", a_featTorusStm);}
      else
        check_featTorusNom(dynamic_cast<featTorusNom *>(a_featTorusStm));
      return;
    }
  if (isA(a_featTorusStm, featTorusAct))
    {
      if (!findString("featTorusAct", featTorusStmSubs))
        {warnSub("featTorusAct", "featTorusStm", a_featTorusStm);}
      else
        check_featTorusAct(dynamic_cast<featTorusAct *>(a_featTorusStm));
      return;
    }
}

/********************************************************************/

void check_featureLabel(
 featureLabel * a_featureLabel)
{
  if (isA(a_featureLabel, fLabel))
    {
      if (!findString("fLabel", featureLabelSubs))
        {warnSub("fLabel", "featureLabel", a_featureLabel);}
      else
        check_fLabel(dynamic_cast<fLabel *>(a_featureLabel));
      return;
    }
  if (isA(a_featureLabel, faLabel))
    {
      if (!findString("faLabel", featureLabelSubs))
        {warnSub("faLabel", "featureLabel", a_featureLabel);}
      else
        check_faLabel(dynamic_cast<faLabel *>(a_featureLabel));
      return;
    }
}

/********************************************************************/

void check_featureLabel1(
 featureLabel1 * a_featureLabel1)
{
  if (isA(a_featureLabel1, fLabel))
    {
      if (!findString("fLabel", featureLabel1Subs))
        {warnSub("fLabel", "featureLabel1", a_featureLabel1);}
      else
        check_fLabel(dynamic_cast<fLabel *>(a_featureLabel1));
      return;
    }
  if (isA(a_featureLabel1, faLabel))
    {
      if (!findString("faLabel", featureLabel1Subs))
        {warnSub("faLabel", "featureLabel1", a_featureLabel1);}
      else
        check_faLabel(dynamic_cast<faLabel *>(a_featureLabel1));
      return;
    }
}

/********************************************************************/

void check_fedratAngSpec(
 fedratAngSpec * a_fedratAngSpec)
{
  if (isA(a_fedratAngSpec, fedratAngular))
    {
      if (!findString("fedratAngular", fedratAngSpecSubs))
        {warnSub("fedratAngular", "fedratAngSpec", a_fedratAngSpec);}
      else
        check_fedratAngular(dynamic_cast<fedratAngular *>(a_fedratAngSpec));
      return;
    }
  if (isA(a_fedratAngSpec, fedratDef))
    {
      if (!findString("fedratDef", fedratAngSpecSubs))
        {warnSub("fedratDef", "fedratAngSpec", a_fedratAngSpec);}
      else
        check_fedratDef(dynamic_cast<fedratDef *>(a_fedratAngSpec));
      return;
    }
}

/********************************************************************/

void check_fedratAngular(
 fedratAngular * a_fedratAngular)
{
  if (a_fedratAngular->get_rate())
    {
      if (!findString("rate", fedratAngularAtts))
	{warnAtt("rate", "fedratAngular", a_fedratAngular);}
      else
        check_rentVal(a_fedratAngular->get_rate());
    }
}

/********************************************************************/

void check_fedratDef(
 fedratDef * a_fedratDef)
{
  if (isA(a_fedratDef, fedratDef_PCENT))
    {
      if (!findString("fedratDef_PCENT", fedratDefSubs))
        {warnSub("fedratDef_PCENT", "fedratDef", a_fedratDef);}
      else
        check_fedratDef_PCENT(dynamic_cast<fedratDef_PCENT *>(a_fedratDef));
      return;
    }
  if (isA(a_fedratDef, fedratDef_HIGH))
    {
      if (!findString("fedratDef_HIGH", fedratDefSubs))
        {warnSub("fedratDef_HIGH", "fedratDef", a_fedratDef);}
      return;
    }
  if (isA(a_fedratDef, fedratDef_LOW))
    {
      if (!findString("fedratDef_LOW", fedratDefSubs))
        {warnSub("fedratDef_LOW", "fedratDef", a_fedratDef);}
      return;
    }
  if (isA(a_fedratDef, fedratDef_DEFALT))
    {
      if (!findString("fedratDef_DEFALT", fedratDefSubs))
        {warnSub("fedratDef_DEFALT", "fedratDef", a_fedratDef);}
      return;
    }
}

/********************************************************************/

void check_fedratDef_PCENT(
 fedratDef_PCENT * a_fedratDef_PCENT)
{
  if (a_fedratDef_PCENT->get_rate())
    {
      if (!findString("rate", fedratDef_PCENTAtts))
	{warnAtt("rate", "fedratDef_PCENT", a_fedratDef_PCENT);}
      else
        check_rentVal(a_fedratDef_PCENT->get_rate());
    }
}

/********************************************************************/

void check_fedratHedMeas(
 fedratHedMeas * a_fedratHedMeas)
{
  if (a_fedratHedMeas->get_fedratLinSpec())
    {
      if (!findString("a_fedratLinSpec", fedratHedMeasAtts))
	{warnAtt("a_fedratLinSpec", "fedratHedMeas", a_fedratHedMeas);}
      else
        check_fedratLinSpec(a_fedratHedMeas->get_fedratLinSpec());
    }
}

/********************************************************************/

void check_fedratHedRot(
 fedratHedRot * a_fedratHedRot)
{
  if (a_fedratHedRot->get_fedratLinSpec())
    {
      if (!findString("a_fedratLinSpec", fedratHedRotAtts))
	{warnAtt("a_fedratLinSpec", "fedratHedRot", a_fedratHedRot);}
      else
        check_fedratLinSpec(a_fedratHedRot->get_fedratLinSpec());
    }
}

/********************************************************************/

void check_fedratHedScan(
 fedratHedScan * a_fedratHedScan)
{
  if (a_fedratHedScan->get_fedratLinSpec())
    {
      if (!findString("a_fedratLinSpec", fedratHedScanAtts))
	{warnAtt("a_fedratLinSpec", "fedratHedScan", a_fedratHedScan);}
      else
        check_fedratLinSpec(a_fedratHedScan->get_fedratLinSpec());
    }
}

/********************************************************************/

void check_fedratLinSpec(
 fedratLinSpec * a_fedratLinSpec)
{
  if (isA(a_fedratLinSpec, fedratLinear))
    {
      if (!findString("fedratLinear", fedratLinSpecSubs))
        {warnSub("fedratLinear", "fedratLinSpec", a_fedratLinSpec);}
      else
        check_fedratLinear(dynamic_cast<fedratLinear *>(a_fedratLinSpec));
      return;
    }
  if (isA(a_fedratLinSpec, fedratDef))
    {
      if (!findString("fedratDef", fedratLinSpecSubs))
        {warnSub("fedratDef", "fedratLinSpec", a_fedratLinSpec);}
      else
        check_fedratDef(dynamic_cast<fedratDef *>(a_fedratLinSpec));
      return;
    }
}

/********************************************************************/

void check_fedratLinear(
 fedratLinear * a_fedratLinear)
{
  if (isA(a_fedratLinear, fedratLinear_MPM))
    {
      if (!findString("fedratLinear_MPM", fedratLinearSubs))
        {warnSub("fedratLinear_MPM", "fedratLinear", a_fedratLinear);}
      else
        check_fedratLinear_MPM(dynamic_cast<fedratLinear_MPM *>(a_fedratLinear));
      return;
    }
  if (isA(a_fedratLinear, fedratLinear_MMPS))
    {
      if (!findString("fedratLinear_MMPS", fedratLinearSubs))
        {warnSub("fedratLinear_MMPS", "fedratLinear", a_fedratLinear);}
      else
        check_fedratLinear_MMPS(dynamic_cast<fedratLinear_MMPS *>(a_fedratLinear));
      return;
    }
  if (isA(a_fedratLinear, fedratLinear_IPM))
    {
      if (!findString("fedratLinear_IPM", fedratLinearSubs))
        {warnSub("fedratLinear_IPM", "fedratLinear", a_fedratLinear);}
      else
        check_fedratLinear_IPM(dynamic_cast<fedratLinear_IPM *>(a_fedratLinear));
      return;
    }
  if (isA(a_fedratLinear, fedratLinear_IPS))
    {
      if (!findString("fedratLinear_IPS", fedratLinearSubs))
        {warnSub("fedratLinear_IPS", "fedratLinear", a_fedratLinear);}
      else
        check_fedratLinear_IPS(dynamic_cast<fedratLinear_IPS *>(a_fedratLinear));
      return;
    }
}

/********************************************************************/

void check_fedratLinear_IPM(
 fedratLinear_IPM * a_fedratLinear_IPM)
{
  if (a_fedratLinear_IPM->get_rate())
    {
      if (!findString("rate", fedratLinear_IPMAtts))
	{warnAtt("rate", "fedratLinear_IPM", a_fedratLinear_IPM);}
      else
        check_rentVal(a_fedratLinear_IPM->get_rate());
    }
}

/********************************************************************/

void check_fedratLinear_IPS(
 fedratLinear_IPS * a_fedratLinear_IPS)
{
  if (a_fedratLinear_IPS->get_rate())
    {
      if (!findString("rate", fedratLinear_IPSAtts))
	{warnAtt("rate", "fedratLinear_IPS", a_fedratLinear_IPS);}
      else
        check_rentVal(a_fedratLinear_IPS->get_rate());
    }
}

/********************************************************************/

void check_fedratLinear_MMPS(
 fedratLinear_MMPS * a_fedratLinear_MMPS)
{
  if (a_fedratLinear_MMPS->get_rate())
    {
      if (!findString("rate", fedratLinear_MMPSAtts))
	{warnAtt("rate", "fedratLinear_MMPS", a_fedratLinear_MMPS);}
      else
        check_rentVal(a_fedratLinear_MMPS->get_rate());
    }
}

/********************************************************************/

void check_fedratLinear_MPM(
 fedratLinear_MPM * a_fedratLinear_MPM)
{
  if (a_fedratLinear_MPM->get_rate())
    {
      if (!findString("rate", fedratLinear_MPMAtts))
	{warnAtt("rate", "fedratLinear_MPM", a_fedratLinear_MPM);}
      else
        check_rentVal(a_fedratLinear_MPM->get_rate());
    }
}

/********************************************************************/

void check_fedratMeas(
 fedratMeas * a_fedratMeas)
{
  if (a_fedratMeas->get_fedratLinSpec())
    {
      if (!findString("a_fedratLinSpec", fedratMeasAtts))
	{warnAtt("a_fedratLinSpec", "fedratMeas", a_fedratMeas);}
      else
        check_fedratLinSpec(a_fedratMeas->get_fedratLinSpec());
    }
}

/********************************************************************/

void check_fedratMinor(
 fedratMinor * a_fedratMinor)
{
  if (isA(a_fedratMinor, fedratMeas))
    {
      if (!findString("fedratMeas", fedratMinorSubs))
        {warnSub("fedratMeas", "fedratMinor", a_fedratMinor);}
      else
        check_fedratMeas(dynamic_cast<fedratMeas *>(a_fedratMinor));
      return;
    }
  if (isA(a_fedratMinor, fedratPos))
    {
      if (!findString("fedratPos", fedratMinorSubs))
        {warnSub("fedratPos", "fedratMinor", a_fedratMinor);}
      else
        check_fedratPos(dynamic_cast<fedratPos *>(a_fedratMinor));
      return;
    }
  if (isA(a_fedratMinor, fedratRot))
    {
      if (!findString("fedratRot", fedratMinorSubs))
        {warnSub("fedratRot", "fedratMinor", a_fedratMinor);}
      else
        check_fedratRot(dynamic_cast<fedratRot *>(a_fedratMinor));
      return;
    }
  if (isA(a_fedratMinor, fedratScan))
    {
      if (!findString("fedratScan", fedratMinorSubs))
        {warnSub("fedratScan", "fedratMinor", a_fedratMinor);}
      else
        check_fedratScan(dynamic_cast<fedratScan *>(a_fedratMinor));
      return;
    }
  if (isA(a_fedratMinor, fedratHedRot))
    {
      if (!findString("fedratHedRot", fedratMinorSubs))
        {warnSub("fedratHedRot", "fedratMinor", a_fedratMinor);}
      else
        check_fedratHedRot(dynamic_cast<fedratHedRot *>(a_fedratMinor));
      return;
    }
  if (isA(a_fedratMinor, fedratHedMeas))
    {
      if (!findString("fedratHedMeas", fedratMinorSubs))
        {warnSub("fedratHedMeas", "fedratMinor", a_fedratMinor);}
      else
        check_fedratHedMeas(dynamic_cast<fedratHedMeas *>(a_fedratMinor));
      return;
    }
  if (isA(a_fedratMinor, fedratHedScan))
    {
      if (!findString("fedratHedScan", fedratMinorSubs))
        {warnSub("fedratHedScan", "fedratMinor", a_fedratMinor);}
      else
        check_fedratHedScan(dynamic_cast<fedratHedScan *>(a_fedratMinor));
      return;
    }
}

/********************************************************************/

void check_fedratPos(
 fedratPos * a_fedratPos)
{
  if (a_fedratPos->get_fedratLinSpec())
    {
      if (!findString("a_fedratLinSpec", fedratPosAtts))
	{warnAtt("a_fedratLinSpec", "fedratPos", a_fedratPos);}
      else
        check_fedratLinSpec(a_fedratPos->get_fedratLinSpec());
    }
}

/********************************************************************/

void check_fedratRot(
 fedratRot * a_fedratRot)
{
  if (a_fedratRot->get_fedratAngSpec())
    {
      if (!findString("a_fedratAngSpec", fedratRotAtts))
	{warnAtt("a_fedratAngSpec", "fedratRot", a_fedratRot);}
      else
        check_fedratAngSpec(a_fedratRot->get_fedratAngSpec());
    }
}

/********************************************************************/

void check_fedratScan(
 fedratScan * a_fedratScan)
{
  if (a_fedratScan->get_fedratLinSpec())
    {
      if (!findString("a_fedratLinSpec", fedratScanAtts))
	{warnAtt("a_fedratLinSpec", "fedratScan", a_fedratScan);}
      else
        check_fedratLinSpec(a_fedratScan->get_fedratLinSpec());
    }
}

/********************************************************************/

void check_fedratStm(
 fedratStm * a_fedratStm)
{
  if (a_fedratStm->get_fedratMinor())
    {
      if (!findString("a_fedratMinor", fedratStmAtts))
	{warnAtt("a_fedratMinor", "fedratStm", a_fedratStm);}
      else
        check_fedratMinor(a_fedratStm->get_fedratMinor());
    }
}

/********************************************************************/

void check_fiLabel(
 fiLabel * a_fiLabel)
{
  if (a_fiLabel->get_labelName())
    {
      if (!findString("a_labelName", fiLabelAtts))
	{warnAtt("a_labelName", "fiLabel", a_fiLabel);}
      else
        check_labelName(a_fiLabel->get_labelName());
    }
}

/********************************************************************/

void check_fildefStm(
 fildefStm * a_fildefStm)
{
  if (a_fildefStm->get_vfLabel())
    {
      if (!findString("a_vfLabel", fildefStmAtts))
	{warnAtt("a_vfLabel", "fildefStm", a_fildefStm);}
      else
        check_vfLabel(a_fildefStm->get_vfLabel());
    }
  if (a_fildefStm->get_code())
    {
      if (!findString("code", fildefStmAtts))
	{warnAtt("code", "fildefStm", a_fildefStm);}
      else
        check_intVal(a_fildefStm->get_code());
    }
}

/********************************************************************/

void check_filnamStm(
 filnamStm * a_filnamStm)
{
  if (a_filnamStm->get_stringConst())
    {
      if (!findString("a_stringConst", filnamStmAtts))
	{warnAtt("a_stringConst", "filnamStm", a_filnamStm);}
      else
        check_stringConst(a_filnamStm->get_stringConst());
    }
  if (a_filnamStm->get_versionTag())
    {
      if (!findString("a_versionTag", filnamStmAtts))
	{warnAtt("a_versionTag", "filnamStm", a_filnamStm);}
      else
        check_versionTag(a_filnamStm->get_versionTag());
    }
}

/********************************************************************/

void check_finposStm(
 finposStm * a_finposStm)
{
  if (a_finposStm->get_state())
    {
      if (!findString("a_state", finposStmAtts))
	{warnAtt("a_state", "finposStm", a_finposStm);}
      else
        check_state(a_finposStm->get_state());
    }
}

/********************************************************************/

void check_fixtidStm(
 fixtidStm * a_fixtidStm)
{
  if (a_fixtidStm->get_fiLabel())
    {
      if (!findString("a_fiLabel", fixtidStmAtts))
	{warnAtt("a_fiLabel", "fixtidStm", a_fixtidStm);}
      else
        check_fiLabel(a_fixtidStm->get_fiLabel());
    }
  if (a_fixtidStm->get_text())
    {
      if (!findString("text", fixtidStmAtts))
	{warnAtt("text", "fixtidStm", a_fixtidStm);}
      else
        check_stringVal(a_fixtidStm->get_text());
    }
}

/********************************************************************/

void check_fixtsnStm(
 fixtsnStm * a_fixtsnStm)
{
  if (a_fixtsnStm->get_fsLabel())
    {
      if (!findString("a_fsLabel", fixtsnStmAtts))
	{warnAtt("a_fsLabel", "fixtsnStm", a_fixtsnStm);}
      else
        check_fsLabel(a_fixtsnStm->get_fsLabel());
    }
  if (a_fixtsnStm->get_text())
    {
      if (!findString("text", fixtsnStmAtts))
	{warnAtt("text", "fixtsnStm", a_fixtsnStm);}
      else
        check_stringVal(a_fixtsnStm->get_text());
    }
}

/********************************************************************/

void check_flatRoundOpen(
 flatRoundOpen * a_flatRoundOpen)
{
  if (isA(a_flatRoundOpen, flatRoundOpen_FLAT))
    {
      if (!findString("flatRoundOpen_FLAT", flatRoundOpenSubs))
        {warnSub("flatRoundOpen_FLAT", "flatRoundOpen", a_flatRoundOpen);}
      return;
    }
  if (isA(a_flatRoundOpen, flatRoundOpen_ROUND))
    {
      if (!findString("flatRoundOpen_ROUND", flatRoundOpenSubs))
        {warnSub("flatRoundOpen_ROUND", "flatRoundOpen", a_flatRoundOpen);}
      return;
    }
  if (isA(a_flatRoundOpen, flatRoundOpen_OPEN))
    {
      if (!findString("flatRoundOpen_OPEN", flatRoundOpenSubs))
        {warnSub("flatRoundOpen_OPEN", "flatRoundOpen", a_flatRoundOpen);}
      return;
    }
}

/********************************************************************/

void check_flipNoFlip(
 flipNoFlip * a_flipNoFlip)
{
  if (isA(a_flipNoFlip, flipNoFlip_FLIP))
    {
      if (!findString("flipNoFlip_FLIP", flipNoFlipSubs))
        {warnSub("flipNoFlip_FLIP", "flipNoFlip", a_flipNoFlip);}
      return;
    }
  if (isA(a_flipNoFlip, flipNoFlip_NOFLIP))
    {
      if (!findString("flipNoFlip_NOFLIP", flipNoFlipSubs))
        {warnSub("flipNoFlip_NOFLIP", "flipNoFlip", a_flipNoFlip);}
      return;
    }
}

/********************************************************************/

void check_flyMinor(
 flyMinor * a_flyMinor)
{
  if (isA(a_flyMinor, flyMinor_OFF))
    {
      if (!findString("flyMinor_OFF", flyMinorSubs))
        {warnSub("flyMinor_OFF", "flyMinor", a_flyMinor);}
      return;
    }
  if (isA(a_flyMinor, flyMinor_rentVal))
    {
      if (!findString("flyMinor_rentVal", flyMinorSubs))
        {warnSub("flyMinor_rentVal", "flyMinor", a_flyMinor);}
      else
        check_flyMinor_rentVal(dynamic_cast<flyMinor_rentVal *>(a_flyMinor));
      return;
    }
}

/********************************************************************/

void check_flyMinor_rentVal(
 flyMinor_rentVal * a_flyMinor_rentVal)
{
  if (a_flyMinor_rentVal->get_radius())
    {
      if (!findString("radius", flyMinor_rentValAtts))
	{warnAtt("radius", "flyMinor_rentVal", a_flyMinor_rentVal);}
      else
        check_rentVal(a_flyMinor_rentVal->get_radius());
    }
}

/********************************************************************/

void check_flyStm(
 flyStm * a_flyStm)
{
  if (a_flyStm->get_flyMinor())
    {
      if (!findString("a_flyMinor", flyStmAtts))
	{warnAtt("a_flyMinor", "flyStm", a_flyStm);}
      else
        check_flyMinor(a_flyStm->get_flyMinor());
    }
}

/********************************************************************/

void check_forceOrDeflection(
 forceOrDeflection * a_forceOrDeflection)
{
  if (isA(a_forceOrDeflection, forceOrDeflection_FORCE))
    {
      if (!findString("forceOrDeflection_FORCE", forceOrDeflectionSubs))
        {warnSub("forceOrDeflection_FORCE", "forceOrDeflection", a_forceOrDeflection);}
      else
        check_forceOrDeflection_FORCE(dynamic_cast<forceOrDeflection_FORCE *>(a_forceOrDeflection));
      return;
    }
  if (isA(a_forceOrDeflection, forceOrDeflection_DEFLECTION))
    {
      if (!findString("forceOrDeflection_DEFLECTION", forceOrDeflectionSubs))
        {warnSub("forceOrDeflection_DEFLECTION", "forceOrDeflection", a_forceOrDeflection);}
      else
        check_forceOrDeflection_DEFLECTION(dynamic_cast<forceOrDeflection_DEFLECTION *>(a_forceOrDeflection));
      return;
    }
}

/********************************************************************/

void check_forceOrDeflection_DEFLECTION(
 forceOrDeflection_DEFLECTION * a_forceOrDeflection_DEFLECTION)
{
  if (a_forceOrDeflection_DEFLECTION->get_deflval())
    {
      if (!findString("deflval", forceOrDeflection_DEFLECTIONAtts))
	{warnAtt("deflval", "forceOrDeflection_DEFLECTION", a_forceOrDeflection_DEFLECTION);}
      else
        check_rentVal(a_forceOrDeflection_DEFLECTION->get_deflval());
    }
}

/********************************************************************/

void check_forceOrDeflection_FORCE(
 forceOrDeflection_FORCE * a_forceOrDeflection_FORCE)
{
  if (a_forceOrDeflection_FORCE->get_force())
    {
      if (!findString("force", forceOrDeflection_FORCEAtts))
	{warnAtt("force", "forceOrDeflection_FORCE", a_forceOrDeflection_FORCE);}
      else
        check_rentVal(a_forceOrDeflection_FORCE->get_force());
    }
}

/********************************************************************/

void check_fromMinor(
 fromMinor * a_fromMinor)
{
  if (isA(a_fromMinor, fromMinor_cartPoint))
    {
      if (!findString("fromMinor_cartPoint", fromMinorSubs))
        {warnSub("fromMinor_cartPoint", "fromMinor", a_fromMinor);}
      else
        check_fromMinor_cartPoint(dynamic_cast<fromMinor_cartPoint *>(a_fromMinor));
      return;
    }
  if (isA(a_fromMinor, fromMinor_DME))
    {
      if (!findString("fromMinor_DME", fromMinorSubs))
        {warnSub("fromMinor_DME", "fromMinor", a_fromMinor);}
      return;
    }
  if (isA(a_fromMinor, fromMinor_impCartPoint))
    {
      if (!findString("fromMinor_impCartPoint", fromMinorSubs))
        {warnSub("fromMinor_impCartPoint", "fromMinor", a_fromMinor);}
      else
        check_fromMinor_impCartPoint(dynamic_cast<fromMinor_impCartPoint *>(a_fromMinor));
      return;
    }
  if (isA(a_fromMinor, fromMinor_polPoint))
    {
      if (!findString("fromMinor_polPoint", fromMinorSubs))
        {warnSub("fromMinor_polPoint", "fromMinor", a_fromMinor);}
      else
        check_fromMinor_polPoint(dynamic_cast<fromMinor_polPoint *>(a_fromMinor));
      return;
    }
  if (isA(a_fromMinor, fromMinor_SCALE))
    {
      if (!findString("fromMinor_SCALE", fromMinorSubs))
        {warnSub("fromMinor_SCALE", "fromMinor", a_fromMinor);}
      return;
    }
}

/********************************************************************/

void check_fromMinor_cartPoint(
 fromMinor_cartPoint * a_fromMinor_cartPoint)
{
  if (a_fromMinor_cartPoint->get_cartPoint())
    {
      if (!findString("a_cartPoint", fromMinor_cartPointAtts))
	{warnAtt("a_cartPoint", "fromMinor_cartPoint", a_fromMinor_cartPoint);}
      else
        check_cartPoint(a_fromMinor_cartPoint->get_cartPoint());
    }
  if (a_fromMinor_cartPoint->get_has_RAM())
    {
      if (!findString("has_RAM", fromMinor_cartPointAtts))
	{warnAtt("has_RAM", "fromMinor_cartPoint", a_fromMinor_cartPoint);}
    }
}

/********************************************************************/

void check_fromMinor_impCartPoint(
 fromMinor_impCartPoint * a_fromMinor_impCartPoint)
{
  if (a_fromMinor_impCartPoint->get_impCartPoint())
    {
      if (!findString("a_impCartPoint", fromMinor_impCartPointAtts))
	{warnAtt("a_impCartPoint", "fromMinor_impCartPoint", a_fromMinor_impCartPoint);}
      else
        check_impCartPoint(a_fromMinor_impCartPoint->get_impCartPoint());
    }
  if (a_fromMinor_impCartPoint->get_has_RAM())
    {
      if (!findString("has_RAM", fromMinor_impCartPointAtts))
	{warnAtt("has_RAM", "fromMinor_impCartPoint", a_fromMinor_impCartPoint);}
    }
}

/********************************************************************/

void check_fromMinor_polPoint(
 fromMinor_polPoint * a_fromMinor_polPoint)
{
  if (a_fromMinor_polPoint->get_polPoint())
    {
      if (!findString("a_polPoint", fromMinor_polPointAtts))
	{warnAtt("a_polPoint", "fromMinor_polPoint", a_fromMinor_polPoint);}
      else
        check_polPoint(a_fromMinor_polPoint->get_polPoint());
    }
  if (a_fromMinor_polPoint->get_has_RAM())
    {
      if (!findString("has_RAM", fromMinor_polPointAtts))
	{warnAtt("has_RAM", "fromMinor_polPoint", a_fromMinor_polPoint);}
    }
}

/********************************************************************/

void check_fromStm(
 fromStm * a_fromStm)
{
  if (a_fromStm->get_fromMinor())
    {
      if (!findString("a_fromMinor", fromStmAtts))
	{warnAtt("a_fromMinor", "fromStm", a_fromStm);}
      else
        check_fromMinor(a_fromStm->get_fromMinor());
    }
}

/********************************************************************/

void check_fsLabel(
 fsLabel * a_fsLabel)
{
  if (a_fsLabel->get_labelName())
    {
      if (!findString("a_labelName", fsLabelAtts))
	{warnAtt("a_labelName", "fsLabel", a_fsLabel);}
      else
        check_labelName(a_fsLabel->get_labelName());
    }
}

/********************************************************************/

void check_gLabel(
 gLabel * a_gLabel)
{
  if (a_gLabel->get_labelName())
    {
      if (!findString("a_labelName", gLabelAtts))
	{warnAtt("a_labelName", "gLabel", a_gLabel);}
      else
        check_labelName(a_gLabel->get_labelName());
    }
}

/********************************************************************/

void check_geoalgArc(
 geoalgArc * a_geoalgArc)
{
  if (a_geoalgArc->get_geoalgSpec1())
    {
      if (!findString("a_geoalgSpec1", geoalgArcAtts))
	{warnAtt("a_geoalgSpec1", "geoalgArc", a_geoalgArc);}
      else
        check_geoalgSpec1(a_geoalgArc->get_geoalgSpec1());
    }
}

/********************************************************************/

void check_geoalgCircle(
 geoalgCircle * a_geoalgCircle)
{
  if (a_geoalgCircle->get_geoalgSpec2())
    {
      if (!findString("a_geoalgSpec2", geoalgCircleAtts))
	{warnAtt("a_geoalgSpec2", "geoalgCircle", a_geoalgCircle);}
      else
        check_geoalgSpec2(a_geoalgCircle->get_geoalgSpec2());
    }
}

/********************************************************************/

void check_geoalgCone(
 geoalgCone * a_geoalgCone)
{
  if (a_geoalgCone->get_geoalgSpec2())
    {
      if (!findString("a_geoalgSpec2", geoalgConeAtts))
	{warnAtt("a_geoalgSpec2", "geoalgCone", a_geoalgCone);}
      else
        check_geoalgSpec2(a_geoalgCone->get_geoalgSpec2());
    }
}

/********************************************************************/

void check_geoalgConradsegmnt(
 geoalgConradsegmnt * a_geoalgConradsegmnt)
{
  if (a_geoalgConradsegmnt->get_geoalgSpec2())
    {
      if (!findString("a_geoalgSpec2", geoalgConradsegmntAtts))
	{warnAtt("a_geoalgSpec2", "geoalgConradsegmnt", a_geoalgConradsegmnt);}
      else
        check_geoalgSpec2(a_geoalgConradsegmnt->get_geoalgSpec2());
    }
}

/********************************************************************/

void check_geoalgCparln(
 geoalgCparln * a_geoalgCparln)
{
  if (a_geoalgCparln->get_geoalgSpec3())
    {
      if (!findString("a_geoalgSpec3", geoalgCparlnAtts))
	{warnAtt("a_geoalgSpec3", "geoalgCparln", a_geoalgCparln);}
      else
        check_geoalgSpec3(a_geoalgCparln->get_geoalgSpec3());
    }
}

/********************************************************************/

void check_geoalgCylndr(
 geoalgCylndr * a_geoalgCylndr)
{
  if (a_geoalgCylndr->get_geoalgSpec2())
    {
      if (!findString("a_geoalgSpec2", geoalgCylndrAtts))
	{warnAtt("a_geoalgSpec2", "geoalgCylndr", a_geoalgCylndr);}
      else
        check_geoalgSpec2(a_geoalgCylndr->get_geoalgSpec2());
    }
}

/********************************************************************/

void check_geoalgCylradsegmnt(
 geoalgCylradsegmnt * a_geoalgCylradsegmnt)
{
  if (a_geoalgCylradsegmnt->get_geoalgSpec2())
    {
      if (!findString("a_geoalgSpec2", geoalgCylradsegmntAtts))
	{warnAtt("a_geoalgSpec2", "geoalgCylradsegmnt", a_geoalgCylradsegmnt);}
      else
        check_geoalgSpec2(a_geoalgCylradsegmnt->get_geoalgSpec2());
    }
}

/********************************************************************/

void check_geoalgEliminate(
 geoalgEliminate * a_geoalgEliminate)
{
  if (isA(a_geoalgEliminate, geoalgEliminateStd))
    {
      if (!findString("geoalgEliminateStd", geoalgEliminateSubs))
        {warnSub("geoalgEliminateStd", "geoalgEliminate", a_geoalgEliminate);}
      else
        check_geoalgEliminateStd(dynamic_cast<geoalgEliminateStd *>(a_geoalgEliminate));
      return;
    }
  if (isA(a_geoalgEliminate, geoalgEliminateOff))
    {
      if (!findString("geoalgEliminateOff", geoalgEliminateSubs))
        {warnSub("geoalgEliminateOff", "geoalgEliminate", a_geoalgEliminate);}
      return;
    }
}

/********************************************************************/

void check_geoalgEliminateStd(
 geoalgEliminateStd * a_geoalgEliminateStd)
{
  if (a_geoalgEliminateStd->get_devVal())
    {
      if (!findString("devVal", geoalgEliminateStdAtts))
	{warnAtt("devVal", "geoalgEliminateStd", a_geoalgEliminateStd);}
      else
        check_rentVal(a_geoalgEliminateStd->get_devVal());
    }
}

/********************************************************************/

void check_geoalgEllips(
 geoalgEllips * a_geoalgEllips)
{
  if (a_geoalgEllips->get_geoalgSpec1())
    {
      if (!findString("a_geoalgSpec1", geoalgEllipsAtts))
	{warnAtt("a_geoalgSpec1", "geoalgEllips", a_geoalgEllips);}
      else
        check_geoalgSpec1(a_geoalgEllips->get_geoalgSpec1());
    }
}

/********************************************************************/

void check_geoalgElongcyl(
 geoalgElongcyl * a_geoalgElongcyl)
{
  if (a_geoalgElongcyl->get_geoalgSpec2())
    {
      if (!findString("a_geoalgSpec2", geoalgElongcylAtts))
	{warnAtt("a_geoalgSpec2", "geoalgElongcyl", a_geoalgElongcyl);}
      else
        check_geoalgSpec2(a_geoalgElongcyl->get_geoalgSpec2());
    }
}

/********************************************************************/

void check_geoalgExternFunc(
 geoalgExternFunc * a_geoalgExternFunc)
{
  if (isA(a_geoalgExternFunc, geoalgExternFunc_DMIS))
    {
      if (!findString("geoalgExternFunc_DMIS", geoalgExternFuncSubs))
        {warnSub("geoalgExternFunc_DMIS", "geoalgExternFunc", a_geoalgExternFunc);}
      else
        check_geoalgExternFunc_DMIS(dynamic_cast<geoalgExternFunc_DMIS *>(a_geoalgExternFunc));
      return;
    }
  if (isA(a_geoalgExternFunc, geoalgExternFunc_DME))
    {
      if (!findString("geoalgExternFunc_DME", geoalgExternFuncSubs))
        {warnSub("geoalgExternFunc_DME", "geoalgExternFunc", a_geoalgExternFunc);}
      else
        check_geoalgExternFunc_DME(dynamic_cast<geoalgExternFunc_DME *>(a_geoalgExternFunc));
      return;
    }
  if (isA(a_geoalgExternFunc, geoalgExternFunc_SYS))
    {
      if (!findString("geoalgExternFunc_SYS", geoalgExternFuncSubs))
        {warnSub("geoalgExternFunc_SYS", "geoalgExternFunc", a_geoalgExternFunc);}
      else
        check_geoalgExternFunc_SYS(dynamic_cast<geoalgExternFunc_SYS *>(a_geoalgExternFunc));
      return;
    }
}

/********************************************************************/

void check_geoalgExternFunc_DME(
 geoalgExternFunc_DME * a_geoalgExternFunc_DME)
{
  if (a_geoalgExternFunc_DME->get_routine())
    {
      if (!findString("routine", geoalgExternFunc_DMEAtts))
	{warnAtt("routine", "geoalgExternFunc_DME", a_geoalgExternFunc_DME);}
      else
        check_stringVal(a_geoalgExternFunc_DME->get_routine());
    }
}

/********************************************************************/

void check_geoalgExternFunc_DMIS(
 geoalgExternFunc_DMIS * a_geoalgExternFunc_DMIS)
{
  if (a_geoalgExternFunc_DMIS->get_mLabel())
    {
      if (!findString("a_mLabel", geoalgExternFunc_DMISAtts))
	{warnAtt("a_mLabel", "geoalgExternFunc_DMIS", a_geoalgExternFunc_DMIS);}
      else
        check_mLabel(a_geoalgExternFunc_DMIS->get_mLabel());
    }
}

/********************************************************************/

void check_geoalgExternFunc_SYS(
 geoalgExternFunc_SYS * a_geoalgExternFunc_SYS)
{
  if (a_geoalgExternFunc_SYS->get_pathname())
    {
      if (!findString("pathname", geoalgExternFunc_SYSAtts))
	{warnAtt("pathname", "geoalgExternFunc_SYS", a_geoalgExternFunc_SYS);}
      else
        check_stringVal(a_geoalgExternFunc_SYS->get_pathname());
    }
}

/********************************************************************/

void check_geoalgFiltSetElim(
 geoalgFiltSetElim * a_geoalgFiltSetElim)
{
  if (a_geoalgFiltSetElim->get_geoalgEliminate())
    {
      if (!findString("a_geoalgEliminate", geoalgFiltSetElimAtts))
	{warnAtt("a_geoalgEliminate", "geoalgFiltSetElim", a_geoalgFiltSetElim);}
      else
        check_geoalgEliminate(a_geoalgFiltSetElim->get_geoalgEliminate());
    }
}

/********************************************************************/

void check_geoalgFiltSetFilt(
 geoalgFiltSetFilt * a_geoalgFiltSetFilt)
{
  if (a_geoalgFiltSetFilt->get_geoalgEliminate())
    {
      if (!findString("a_geoalgEliminate", geoalgFiltSetFiltAtts))
	{warnAtt("a_geoalgEliminate", "geoalgFiltSetFilt", a_geoalgFiltSetFilt);}
      else
        check_geoalgEliminate(a_geoalgFiltSetFilt->get_geoalgEliminate());
    }
  if (a_geoalgFiltSetFilt->get_geoalgFilter())
    {
      if (!findString("a_geoalgFilter", geoalgFiltSetFiltAtts))
	{warnAtt("a_geoalgFilter", "geoalgFiltSetFilt", a_geoalgFiltSetFilt);}
      else
        check_geoalgFilter(a_geoalgFiltSetFilt->get_geoalgFilter());
    }
}

/********************************************************************/

void check_geoalgFilter(
 geoalgFilter * a_geoalgFilter)
{
  if (isA(a_geoalgFilter, geoalgFilterLambda))
    {
      if (!findString("geoalgFilterLambda", geoalgFilterSubs))
        {warnSub("geoalgFilterLambda", "geoalgFilter", a_geoalgFilter);}
      else
        check_geoalgFilterLambda(dynamic_cast<geoalgFilterLambda *>(a_geoalgFilter));
      return;
    }
  if (isA(a_geoalgFilter, geoalgFilterCirc))
    {
      if (!findString("geoalgFilterCirc", geoalgFilterSubs))
        {warnSub("geoalgFilterCirc", "geoalgFilter", a_geoalgFilter);}
      else
        check_geoalgFilterCirc(dynamic_cast<geoalgFilterCirc *>(a_geoalgFilter));
      return;
    }
  if (isA(a_geoalgFilter, geoalgFilterOff))
    {
      if (!findString("geoalgFilterOff", geoalgFilterSubs))
        {warnSub("geoalgFilterOff", "geoalgFilter", a_geoalgFilter);}
      return;
    }
}

/********************************************************************/

void check_geoalgFilterCirc(
 geoalgFilterCirc * a_geoalgFilterCirc)
{
  if (a_geoalgFilterCirc->get_geoalgFilterType())
    {
      if (!findString("a_geoalgFilterType", geoalgFilterCircAtts))
	{warnAtt("a_geoalgFilterType", "geoalgFilterCirc", a_geoalgFilterCirc);}
      else
        check_geoalgFilterType(a_geoalgFilterCirc->get_geoalgFilterType());
    }
}

/********************************************************************/

void check_geoalgFilterCurve(
 geoalgFilterCurve * a_geoalgFilterCurve)
{
  if (isA(a_geoalgFilterCurve, geoalgFilterCurve_GAUSS))
    {
      if (!findString("geoalgFilterCurve_GAUSS", geoalgFilterCurveSubs))
        {warnSub("geoalgFilterCurve_GAUSS", "geoalgFilterCurve", a_geoalgFilterCurve);}
      return;
    }
  if (isA(a_geoalgFilterCurve, geoalgFilterCurve_TWORC))
    {
      if (!findString("geoalgFilterCurve_TWORC", geoalgFilterCurveSubs))
        {warnSub("geoalgFilterCurve_TWORC", "geoalgFilterCurve", a_geoalgFilterCurve);}
      return;
    }
  if (isA(a_geoalgFilterCurve, geoalgFilterCurve_SPLINE))
    {
      if (!findString("geoalgFilterCurve_SPLINE", geoalgFilterCurveSubs))
        {warnSub("geoalgFilterCurve_SPLINE", "geoalgFilterCurve", a_geoalgFilterCurve);}
      return;
    }
  if (isA(a_geoalgFilterCurve, geoalgFilterCurve_RECFILT))
    {
      if (!findString("geoalgFilterCurve_RECFILT", geoalgFilterCurveSubs))
        {warnSub("geoalgFilterCurve_RECFILT", "geoalgFilterCurve", a_geoalgFilterCurve);}
      return;
    }
}

/********************************************************************/

void check_geoalgFilterLambda(
 geoalgFilterLambda * a_geoalgFilterLambda)
{
  if (a_geoalgFilterLambda->get_geoalgFilterType())
    {
      if (!findString("a_geoalgFilterType", geoalgFilterLambdaAtts))
	{warnAtt("a_geoalgFilterType", "geoalgFilterLambda", a_geoalgFilterLambda);}
      else
        check_geoalgFilterType(a_geoalgFilterLambda->get_geoalgFilterType());
    }
}

/********************************************************************/

void check_geoalgFilterSettings(
 geoalgFilterSettings * a_geoalgFilterSettings)
{
  if (isA(a_geoalgFilterSettings, geoalgFiltSetFilt))
    {
      if (!findString("geoalgFiltSetFilt", geoalgFilterSettingsSubs))
        {warnSub("geoalgFiltSetFilt", "geoalgFilterSettings", a_geoalgFilterSettings);}
      else
        check_geoalgFiltSetFilt(dynamic_cast<geoalgFiltSetFilt *>(a_geoalgFilterSettings));
      return;
    }
  if (isA(a_geoalgFilterSettings, geoalgFiltSetElim))
    {
      if (!findString("geoalgFiltSetElim", geoalgFilterSettingsSubs))
        {warnSub("geoalgFiltSetElim", "geoalgFilterSettings", a_geoalgFilterSettings);}
      else
        check_geoalgFiltSetElim(dynamic_cast<geoalgFiltSetElim *>(a_geoalgFilterSettings));
      return;
    }
}

/********************************************************************/

void check_geoalgFilterType(
 geoalgFilterType * a_geoalgFilterType)
{
  if (isA(a_geoalgFilterType, geoalgFilterType_LOWPASS))
    {
      if (!findString("geoalgFilterType_LOWPASS", geoalgFilterTypeSubs))
        {warnSub("geoalgFilterType_LOWPASS", "geoalgFilterType", a_geoalgFilterType);}
      else
        check_geoalgFilterType_LOWPASS(dynamic_cast<geoalgFilterType_LOWPASS *>(a_geoalgFilterType));
      return;
    }
  if (isA(a_geoalgFilterType, geoalgFilterType_HIGHPASS))
    {
      if (!findString("geoalgFilterType_HIGHPASS", geoalgFilterTypeSubs))
        {warnSub("geoalgFilterType_HIGHPASS", "geoalgFilterType", a_geoalgFilterType);}
      else
        check_geoalgFilterType_HIGHPASS(dynamic_cast<geoalgFilterType_HIGHPASS *>(a_geoalgFilterType));
      return;
    }
  if (isA(a_geoalgFilterType, geoalgFilterType_BANDPASS))
    {
      if (!findString("geoalgFilterType_BANDPASS", geoalgFilterTypeSubs))
        {warnSub("geoalgFilterType_BANDPASS", "geoalgFilterType", a_geoalgFilterType);}
      else
        check_geoalgFilterType_BANDPASS(dynamic_cast<geoalgFilterType_BANDPASS *>(a_geoalgFilterType));
      return;
    }
}

/********************************************************************/

void check_geoalgFilterType_BANDPASS(
 geoalgFilterType_BANDPASS * a_geoalgFilterType_BANDPASS)
{
  if (a_geoalgFilterType_BANDPASS->get_waveVal1())
    {
      if (!findString("waveVal1", geoalgFilterType_BANDPASSAtts))
	{warnAtt("waveVal1", "geoalgFilterType_BANDPASS", a_geoalgFilterType_BANDPASS);}
      else
        check_rentVal(a_geoalgFilterType_BANDPASS->get_waveVal1());
    }
  if (a_geoalgFilterType_BANDPASS->get_waveVal2())
    {
      if (!findString("waveVal2", geoalgFilterType_BANDPASSAtts))
	{warnAtt("waveVal2", "geoalgFilterType_BANDPASS", a_geoalgFilterType_BANDPASS);}
      else
        check_rentVal(a_geoalgFilterType_BANDPASS->get_waveVal2());
    }
  if (a_geoalgFilterType_BANDPASS->get_geoalgFilterCurve())
    {
      if (!findString("a_geoalgFilterCurve", geoalgFilterType_BANDPASSAtts))
	{warnAtt("a_geoalgFilterCurve", "geoalgFilterType_BANDPASS", a_geoalgFilterType_BANDPASS);}
      else
        check_geoalgFilterCurve(a_geoalgFilterType_BANDPASS->get_geoalgFilterCurve());
    }
}

/********************************************************************/

void check_geoalgFilterType_HIGHPASS(
 geoalgFilterType_HIGHPASS * a_geoalgFilterType_HIGHPASS)
{
  if (a_geoalgFilterType_HIGHPASS->get_waveVal())
    {
      if (!findString("waveVal", geoalgFilterType_HIGHPASSAtts))
	{warnAtt("waveVal", "geoalgFilterType_HIGHPASS", a_geoalgFilterType_HIGHPASS);}
      else
        check_rentVal(a_geoalgFilterType_HIGHPASS->get_waveVal());
    }
  if (a_geoalgFilterType_HIGHPASS->get_geoalgFilterCurve())
    {
      if (!findString("a_geoalgFilterCurve", geoalgFilterType_HIGHPASSAtts))
	{warnAtt("a_geoalgFilterCurve", "geoalgFilterType_HIGHPASS", a_geoalgFilterType_HIGHPASS);}
      else
        check_geoalgFilterCurve(a_geoalgFilterType_HIGHPASS->get_geoalgFilterCurve());
    }
}

/********************************************************************/

void check_geoalgFilterType_LOWPASS(
 geoalgFilterType_LOWPASS * a_geoalgFilterType_LOWPASS)
{
  if (a_geoalgFilterType_LOWPASS->get_waveVal())
    {
      if (!findString("waveVal", geoalgFilterType_LOWPASSAtts))
	{warnAtt("waveVal", "geoalgFilterType_LOWPASS", a_geoalgFilterType_LOWPASS);}
      else
        check_rentVal(a_geoalgFilterType_LOWPASS->get_waveVal());
    }
  if (a_geoalgFilterType_LOWPASS->get_geoalgFilterCurve())
    {
      if (!findString("a_geoalgFilterCurve", geoalgFilterType_LOWPASSAtts))
	{warnAtt("a_geoalgFilterCurve", "geoalgFilterType_LOWPASS", a_geoalgFilterType_LOWPASS);}
      else
        check_geoalgFilterCurve(a_geoalgFilterType_LOWPASS->get_geoalgFilterCurve());
    }
}

/********************************************************************/

void check_geoalgGcurve(
 geoalgGcurve * a_geoalgGcurve)
{
  if (a_geoalgGcurve->get_geoalgSpec4())
    {
      if (!findString("a_geoalgSpec4", geoalgGcurveAtts))
	{warnAtt("a_geoalgSpec4", "geoalgGcurve", a_geoalgGcurve);}
      else
        check_geoalgSpec4(a_geoalgGcurve->get_geoalgSpec4());
    }
}

/********************************************************************/

void check_geoalgGsurf(
 geoalgGsurf * a_geoalgGsurf)
{
  if (a_geoalgGsurf->get_geoalgSpec5())
    {
      if (!findString("a_geoalgSpec5", geoalgGsurfAtts))
	{warnAtt("a_geoalgSpec5", "geoalgGsurf", a_geoalgGsurf);}
      else
        check_geoalgSpec5(a_geoalgGsurf->get_geoalgSpec5());
    }
}

/********************************************************************/

void check_geoalgLine(
 geoalgLine * a_geoalgLine)
{
  if (a_geoalgLine->get_geoalgSpec1())
    {
      if (!findString("a_geoalgSpec1", geoalgLineAtts))
	{warnAtt("a_geoalgSpec1", "geoalgLine", a_geoalgLine);}
      else
        check_geoalgSpec1(a_geoalgLine->get_geoalgSpec1());
    }
}

/********************************************************************/

void check_geoalgMinor(
 geoalgMinor * a_geoalgMinor)
{
  if (isA(a_geoalgMinor, geoalgArc))
    {
      if (!findString("geoalgArc", geoalgMinorSubs))
        {warnSub("geoalgArc", "geoalgMinor", a_geoalgMinor);}
      else
        check_geoalgArc(dynamic_cast<geoalgArc *>(a_geoalgMinor));
      return;
    }
  if (isA(a_geoalgMinor, geoalgCircle))
    {
      if (!findString("geoalgCircle", geoalgMinorSubs))
        {warnSub("geoalgCircle", "geoalgMinor", a_geoalgMinor);}
      else
        check_geoalgCircle(dynamic_cast<geoalgCircle *>(a_geoalgMinor));
      return;
    }
  if (isA(a_geoalgMinor, geoalgCone))
    {
      if (!findString("geoalgCone", geoalgMinorSubs))
        {warnSub("geoalgCone", "geoalgMinor", a_geoalgMinor);}
      else
        check_geoalgCone(dynamic_cast<geoalgCone *>(a_geoalgMinor));
      return;
    }
  if (isA(a_geoalgMinor, geoalgConradsegmnt))
    {
      if (!findString("geoalgConradsegmnt", geoalgMinorSubs))
        {warnSub("geoalgConradsegmnt", "geoalgMinor", a_geoalgMinor);}
      else
        check_geoalgConradsegmnt(dynamic_cast<geoalgConradsegmnt *>(a_geoalgMinor));
      return;
    }
  if (isA(a_geoalgMinor, geoalgCparln))
    {
      if (!findString("geoalgCparln", geoalgMinorSubs))
        {warnSub("geoalgCparln", "geoalgMinor", a_geoalgMinor);}
      else
        check_geoalgCparln(dynamic_cast<geoalgCparln *>(a_geoalgMinor));
      return;
    }
  if (isA(a_geoalgMinor, geoalgCylndr))
    {
      if (!findString("geoalgCylndr", geoalgMinorSubs))
        {warnSub("geoalgCylndr", "geoalgMinor", a_geoalgMinor);}
      else
        check_geoalgCylndr(dynamic_cast<geoalgCylndr *>(a_geoalgMinor));
      return;
    }
  if (isA(a_geoalgMinor, geoalgCylradsegmnt))
    {
      if (!findString("geoalgCylradsegmnt", geoalgMinorSubs))
        {warnSub("geoalgCylradsegmnt", "geoalgMinor", a_geoalgMinor);}
      else
        check_geoalgCylradsegmnt(dynamic_cast<geoalgCylradsegmnt *>(a_geoalgMinor));
      return;
    }
  if (isA(a_geoalgMinor, geoalgEllips))
    {
      if (!findString("geoalgEllips", geoalgMinorSubs))
        {warnSub("geoalgEllips", "geoalgMinor", a_geoalgMinor);}
      else
        check_geoalgEllips(dynamic_cast<geoalgEllips *>(a_geoalgMinor));
      return;
    }
  if (isA(a_geoalgMinor, geoalgElongcyl))
    {
      if (!findString("geoalgElongcyl", geoalgMinorSubs))
        {warnSub("geoalgElongcyl", "geoalgMinor", a_geoalgMinor);}
      else
        check_geoalgElongcyl(dynamic_cast<geoalgElongcyl *>(a_geoalgMinor));
      return;
    }
  if (isA(a_geoalgMinor, geoalgGcurve))
    {
      if (!findString("geoalgGcurve", geoalgMinorSubs))
        {warnSub("geoalgGcurve", "geoalgMinor", a_geoalgMinor);}
      else
        check_geoalgGcurve(dynamic_cast<geoalgGcurve *>(a_geoalgMinor));
      return;
    }
  if (isA(a_geoalgMinor, geoalgGsurf))
    {
      if (!findString("geoalgGsurf", geoalgMinorSubs))
        {warnSub("geoalgGsurf", "geoalgMinor", a_geoalgMinor);}
      else
        check_geoalgGsurf(dynamic_cast<geoalgGsurf *>(a_geoalgMinor));
      return;
    }
  if (isA(a_geoalgMinor, geoalgLine))
    {
      if (!findString("geoalgLine", geoalgMinorSubs))
        {warnSub("geoalgLine", "geoalgMinor", a_geoalgMinor);}
      else
        check_geoalgLine(dynamic_cast<geoalgLine *>(a_geoalgMinor));
      return;
    }
  if (isA(a_geoalgMinor, geoalgObject))
    {
      if (!findString("geoalgObject", geoalgMinorSubs))
        {warnSub("geoalgObject", "geoalgMinor", a_geoalgMinor);}
      else
        check_geoalgObject(dynamic_cast<geoalgObject *>(a_geoalgMinor));
      return;
    }
  if (isA(a_geoalgMinor, geoalgParpln))
    {
      if (!findString("geoalgParpln", geoalgMinorSubs))
        {warnSub("geoalgParpln", "geoalgMinor", a_geoalgMinor);}
      else
        check_geoalgParpln(dynamic_cast<geoalgParpln *>(a_geoalgMinor));
      return;
    }
  if (isA(a_geoalgMinor, geoalgPlane))
    {
      if (!findString("geoalgPlane", geoalgMinorSubs))
        {warnSub("geoalgPlane", "geoalgMinor", a_geoalgMinor);}
      else
        check_geoalgPlane(dynamic_cast<geoalgPlane *>(a_geoalgMinor));
      return;
    }
  if (isA(a_geoalgMinor, geoalgRctngl))
    {
      if (!findString("geoalgRctngl", geoalgMinorSubs))
        {warnSub("geoalgRctngl", "geoalgMinor", a_geoalgMinor);}
      else
        check_geoalgRctngl(dynamic_cast<geoalgRctngl *>(a_geoalgMinor));
      return;
    }
  if (isA(a_geoalgMinor, geoalgRevsurf))
    {
      if (!findString("geoalgRevsurf", geoalgMinorSubs))
        {warnSub("geoalgRevsurf", "geoalgMinor", a_geoalgMinor);}
      else
        check_geoalgRevsurf(dynamic_cast<geoalgRevsurf *>(a_geoalgMinor));
      return;
    }
  if (isA(a_geoalgMinor, geoalgSphere))
    {
      if (!findString("geoalgSphere", geoalgMinorSubs))
        {warnSub("geoalgSphere", "geoalgMinor", a_geoalgMinor);}
      else
        check_geoalgSphere(dynamic_cast<geoalgSphere *>(a_geoalgMinor));
      return;
    }
  if (isA(a_geoalgMinor, geoalgSphradsegmnt))
    {
      if (!findString("geoalgSphradsegmnt", geoalgMinorSubs))
        {warnSub("geoalgSphradsegmnt", "geoalgMinor", a_geoalgMinor);}
      else
        check_geoalgSphradsegmnt(dynamic_cast<geoalgSphradsegmnt *>(a_geoalgMinor));
      return;
    }
  if (isA(a_geoalgMinor, geoalgSympln))
    {
      if (!findString("geoalgSympln", geoalgMinorSubs))
        {warnSub("geoalgSympln", "geoalgMinor", a_geoalgMinor);}
      else
        check_geoalgSympln(dynamic_cast<geoalgSympln *>(a_geoalgMinor));
      return;
    }
  if (isA(a_geoalgMinor, geoalgTorus))
    {
      if (!findString("geoalgTorus", geoalgMinorSubs))
        {warnSub("geoalgTorus", "geoalgMinor", a_geoalgMinor);}
      else
        check_geoalgTorus(dynamic_cast<geoalgTorus *>(a_geoalgMinor));
      return;
    }
  if (isA(a_geoalgMinor, geoalgTorradsegmnt))
    {
      if (!findString("geoalgTorradsegmnt", geoalgMinorSubs))
        {warnSub("geoalgTorradsegmnt", "geoalgMinor", a_geoalgMinor);}
      else
        check_geoalgTorradsegmnt(dynamic_cast<geoalgTorradsegmnt *>(a_geoalgMinor));
      return;
    }
}

/********************************************************************/

void check_geoalgObject(
 geoalgObject * a_geoalgObject)
{
  if (a_geoalgObject->get_geoalgSpec3())
    {
      if (!findString("a_geoalgSpec3", geoalgObjectAtts))
	{warnAtt("a_geoalgSpec3", "geoalgObject", a_geoalgObject);}
      else
        check_geoalgSpec3(a_geoalgObject->get_geoalgSpec3());
    }
}

/********************************************************************/

void check_geoalgParpln(
 geoalgParpln * a_geoalgParpln)
{
  if (a_geoalgParpln->get_geoalgSpec2())
    {
      if (!findString("a_geoalgSpec2", geoalgParplnAtts))
	{warnAtt("a_geoalgSpec2", "geoalgParpln", a_geoalgParpln);}
      else
        check_geoalgSpec2(a_geoalgParpln->get_geoalgSpec2());
    }
}

/********************************************************************/

void check_geoalgPlane(
 geoalgPlane * a_geoalgPlane)
{
  if (a_geoalgPlane->get_geoalgSpec1())
    {
      if (!findString("a_geoalgSpec1", geoalgPlaneAtts))
	{warnAtt("a_geoalgSpec1", "geoalgPlane", a_geoalgPlane);}
      else
        check_geoalgSpec1(a_geoalgPlane->get_geoalgSpec1());
    }
}

/********************************************************************/

void check_geoalgRctngl(
 geoalgRctngl * a_geoalgRctngl)
{
  if (a_geoalgRctngl->get_geoalgSpec1())
    {
      if (!findString("a_geoalgSpec1", geoalgRctnglAtts))
	{warnAtt("a_geoalgSpec1", "geoalgRctngl", a_geoalgRctngl);}
      else
        check_geoalgSpec1(a_geoalgRctngl->get_geoalgSpec1());
    }
}

/********************************************************************/

void check_geoalgRevsurf(
 geoalgRevsurf * a_geoalgRevsurf)
{
  if (a_geoalgRevsurf->get_geoalgSpec6())
    {
      if (!findString("a_geoalgSpec6", geoalgRevsurfAtts))
	{warnAtt("a_geoalgSpec6", "geoalgRevsurf", a_geoalgRevsurf);}
      else
        check_geoalgSpec6(a_geoalgRevsurf->get_geoalgSpec6());
    }
}

/********************************************************************/

void check_geoalgSpec1(
 geoalgSpec1 * a_geoalgSpec1)
{
  if (isA(a_geoalgSpec1, geoalgSpec1_LSTSQR))
    {
      if (!findString("geoalgSpec1_LSTSQR", geoalgSpec1Subs))
        {warnSub("geoalgSpec1_LSTSQR", "geoalgSpec1", a_geoalgSpec1);}
      else
        check_geoalgSpec1_LSTSQR(dynamic_cast<geoalgSpec1_LSTSQR *>(a_geoalgSpec1));
      return;
    }
  if (isA(a_geoalgSpec1, geoalgSpec1_MINMAX))
    {
      if (!findString("geoalgSpec1_MINMAX", geoalgSpec1Subs))
        {warnSub("geoalgSpec1_MINMAX", "geoalgSpec1", a_geoalgSpec1);}
      else
        check_geoalgSpec1_MINMAX(dynamic_cast<geoalgSpec1_MINMAX *>(a_geoalgSpec1));
      return;
    }
  if (isA(a_geoalgSpec1, geoalgSpec1_DEFALT))
    {
      if (!findString("geoalgSpec1_DEFALT", geoalgSpec1Subs))
        {warnSub("geoalgSpec1_DEFALT", "geoalgSpec1", a_geoalgSpec1);}
      else
        check_geoalgSpec1_DEFALT(dynamic_cast<geoalgSpec1_DEFALT *>(a_geoalgSpec1));
      return;
    }
  if (isA(a_geoalgSpec1, geoalgSpec1_EXTERN))
    {
      if (!findString("geoalgSpec1_EXTERN", geoalgSpec1Subs))
        {warnSub("geoalgSpec1_EXTERN", "geoalgSpec1", a_geoalgSpec1);}
      else
        check_geoalgSpec1_EXTERN(dynamic_cast<geoalgSpec1_EXTERN *>(a_geoalgSpec1));
      return;
    }
}

/********************************************************************/

void check_geoalgSpec1_DEFALT(
 geoalgSpec1_DEFALT * a_geoalgSpec1_DEFALT)
{
  if (a_geoalgSpec1_DEFALT->get_geoalgFilterSettings())
    {
      if (!findString("a_geoalgFilterSettings", geoalgSpec1_DEFALTAtts))
	{warnAtt("a_geoalgFilterSettings", "geoalgSpec1_DEFALT", a_geoalgSpec1_DEFALT);}
      else
        check_geoalgFilterSettings(a_geoalgSpec1_DEFALT->get_geoalgFilterSettings());
    }
}

/********************************************************************/

void check_geoalgSpec1_EXTERN(
 geoalgSpec1_EXTERN * a_geoalgSpec1_EXTERN)
{
  if (a_geoalgSpec1_EXTERN->get_geoalgExternFunc())
    {
      if (!findString("a_geoalgExternFunc", geoalgSpec1_EXTERNAtts))
	{warnAtt("a_geoalgExternFunc", "geoalgSpec1_EXTERN", a_geoalgSpec1_EXTERN);}
      else
        check_geoalgExternFunc(a_geoalgSpec1_EXTERN->get_geoalgExternFunc());
    }
  if (a_geoalgSpec1_EXTERN->get_paramList())
    {
      if (!findString("a_paramList", geoalgSpec1_EXTERNAtts))
	{warnAtt("a_paramList", "geoalgSpec1_EXTERN", a_geoalgSpec1_EXTERN);}
      else
        {
          std::list<param *> * theList;
          std::list<param *>::iterator iter;
          theList = a_geoalgSpec1_EXTERN->get_paramList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_param(*iter);
        }
    }
  if (a_geoalgSpec1_EXTERN->get_geoalgFilterSettings())
    {
      if (!findString("a_geoalgFilterSettings", geoalgSpec1_EXTERNAtts))
	{warnAtt("a_geoalgFilterSettings", "geoalgSpec1_EXTERN", a_geoalgSpec1_EXTERN);}
      else
        check_geoalgFilterSettings(a_geoalgSpec1_EXTERN->get_geoalgFilterSettings());
    }
}

/********************************************************************/

void check_geoalgSpec1_LSTSQR(
 geoalgSpec1_LSTSQR * a_geoalgSpec1_LSTSQR)
{
  if (a_geoalgSpec1_LSTSQR->get_geoalgFilterSettings())
    {
      if (!findString("a_geoalgFilterSettings", geoalgSpec1_LSTSQRAtts))
	{warnAtt("a_geoalgFilterSettings", "geoalgSpec1_LSTSQR", a_geoalgSpec1_LSTSQR);}
      else
        check_geoalgFilterSettings(a_geoalgSpec1_LSTSQR->get_geoalgFilterSettings());
    }
}

/********************************************************************/

void check_geoalgSpec1_MINMAX(
 geoalgSpec1_MINMAX * a_geoalgSpec1_MINMAX)
{
  if (a_geoalgSpec1_MINMAX->get_geoalgFilterSettings())
    {
      if (!findString("a_geoalgFilterSettings", geoalgSpec1_MINMAXAtts))
	{warnAtt("a_geoalgFilterSettings", "geoalgSpec1_MINMAX", a_geoalgSpec1_MINMAX);}
      else
        check_geoalgFilterSettings(a_geoalgSpec1_MINMAX->get_geoalgFilterSettings());
    }
}

/********************************************************************/

void check_geoalgSpec2(
 geoalgSpec2 * a_geoalgSpec2)
{
  if (isA(a_geoalgSpec2, geoalgSpec2_LSTSQR))
    {
      if (!findString("geoalgSpec2_LSTSQR", geoalgSpec2Subs))
        {warnSub("geoalgSpec2_LSTSQR", "geoalgSpec2", a_geoalgSpec2);}
      else
        check_geoalgSpec2_LSTSQR(dynamic_cast<geoalgSpec2_LSTSQR *>(a_geoalgSpec2));
      return;
    }
  if (isA(a_geoalgSpec2, geoalgSpec2_MINMAX))
    {
      if (!findString("geoalgSpec2_MINMAX", geoalgSpec2Subs))
        {warnSub("geoalgSpec2_MINMAX", "geoalgSpec2", a_geoalgSpec2);}
      else
        check_geoalgSpec2_MINMAX(dynamic_cast<geoalgSpec2_MINMAX *>(a_geoalgSpec2));
      return;
    }
  if (isA(a_geoalgSpec2, geoalgSpec2_MAXINS))
    {
      if (!findString("geoalgSpec2_MAXINS", geoalgSpec2Subs))
        {warnSub("geoalgSpec2_MAXINS", "geoalgSpec2", a_geoalgSpec2);}
      else
        check_geoalgSpec2_MAXINS(dynamic_cast<geoalgSpec2_MAXINS *>(a_geoalgSpec2));
      return;
    }
  if (isA(a_geoalgSpec2, geoalgSpec2_MINCIR))
    {
      if (!findString("geoalgSpec2_MINCIR", geoalgSpec2Subs))
        {warnSub("geoalgSpec2_MINCIR", "geoalgSpec2", a_geoalgSpec2);}
      else
        check_geoalgSpec2_MINCIR(dynamic_cast<geoalgSpec2_MINCIR *>(a_geoalgSpec2));
      return;
    }
  if (isA(a_geoalgSpec2, geoalgSpec2_DEFALT))
    {
      if (!findString("geoalgSpec2_DEFALT", geoalgSpec2Subs))
        {warnSub("geoalgSpec2_DEFALT", "geoalgSpec2", a_geoalgSpec2);}
      else
        check_geoalgSpec2_DEFALT(dynamic_cast<geoalgSpec2_DEFALT *>(a_geoalgSpec2));
      return;
    }
  if (isA(a_geoalgSpec2, geoalgSpec2_EXTERN))
    {
      if (!findString("geoalgSpec2_EXTERN", geoalgSpec2Subs))
        {warnSub("geoalgSpec2_EXTERN", "geoalgSpec2", a_geoalgSpec2);}
      else
        check_geoalgSpec2_EXTERN(dynamic_cast<geoalgSpec2_EXTERN *>(a_geoalgSpec2));
      return;
    }
}

/********************************************************************/

void check_geoalgSpec2_DEFALT(
 geoalgSpec2_DEFALT * a_geoalgSpec2_DEFALT)
{
  if (a_geoalgSpec2_DEFALT->get_geoalgFilterSettings())
    {
      if (!findString("a_geoalgFilterSettings", geoalgSpec2_DEFALTAtts))
	{warnAtt("a_geoalgFilterSettings", "geoalgSpec2_DEFALT", a_geoalgSpec2_DEFALT);}
      else
        check_geoalgFilterSettings(a_geoalgSpec2_DEFALT->get_geoalgFilterSettings());
    }
}

/********************************************************************/

void check_geoalgSpec2_EXTERN(
 geoalgSpec2_EXTERN * a_geoalgSpec2_EXTERN)
{
  if (a_geoalgSpec2_EXTERN->get_geoalgExternFunc())
    {
      if (!findString("a_geoalgExternFunc", geoalgSpec2_EXTERNAtts))
	{warnAtt("a_geoalgExternFunc", "geoalgSpec2_EXTERN", a_geoalgSpec2_EXTERN);}
      else
        check_geoalgExternFunc(a_geoalgSpec2_EXTERN->get_geoalgExternFunc());
    }
  if (a_geoalgSpec2_EXTERN->get_paramList())
    {
      if (!findString("a_paramList", geoalgSpec2_EXTERNAtts))
	{warnAtt("a_paramList", "geoalgSpec2_EXTERN", a_geoalgSpec2_EXTERN);}
      else
        {
          std::list<param *> * theList;
          std::list<param *>::iterator iter;
          theList = a_geoalgSpec2_EXTERN->get_paramList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_param(*iter);
        }
    }
  if (a_geoalgSpec2_EXTERN->get_geoalgFilterSettings())
    {
      if (!findString("a_geoalgFilterSettings", geoalgSpec2_EXTERNAtts))
	{warnAtt("a_geoalgFilterSettings", "geoalgSpec2_EXTERN", a_geoalgSpec2_EXTERN);}
      else
        check_geoalgFilterSettings(a_geoalgSpec2_EXTERN->get_geoalgFilterSettings());
    }
}

/********************************************************************/

void check_geoalgSpec2_LSTSQR(
 geoalgSpec2_LSTSQR * a_geoalgSpec2_LSTSQR)
{
  if (a_geoalgSpec2_LSTSQR->get_geoalgFilterSettings())
    {
      if (!findString("a_geoalgFilterSettings", geoalgSpec2_LSTSQRAtts))
	{warnAtt("a_geoalgFilterSettings", "geoalgSpec2_LSTSQR", a_geoalgSpec2_LSTSQR);}
      else
        check_geoalgFilterSettings(a_geoalgSpec2_LSTSQR->get_geoalgFilterSettings());
    }
}

/********************************************************************/

void check_geoalgSpec2_MAXINS(
 geoalgSpec2_MAXINS * a_geoalgSpec2_MAXINS)
{
  if (a_geoalgSpec2_MAXINS->get_geoalgFilterSettings())
    {
      if (!findString("a_geoalgFilterSettings", geoalgSpec2_MAXINSAtts))
	{warnAtt("a_geoalgFilterSettings", "geoalgSpec2_MAXINS", a_geoalgSpec2_MAXINS);}
      else
        check_geoalgFilterSettings(a_geoalgSpec2_MAXINS->get_geoalgFilterSettings());
    }
}

/********************************************************************/

void check_geoalgSpec2_MINCIR(
 geoalgSpec2_MINCIR * a_geoalgSpec2_MINCIR)
{
  if (a_geoalgSpec2_MINCIR->get_geoalgFilterSettings())
    {
      if (!findString("a_geoalgFilterSettings", geoalgSpec2_MINCIRAtts))
	{warnAtt("a_geoalgFilterSettings", "geoalgSpec2_MINCIR", a_geoalgSpec2_MINCIR);}
      else
        check_geoalgFilterSettings(a_geoalgSpec2_MINCIR->get_geoalgFilterSettings());
    }
}

/********************************************************************/

void check_geoalgSpec2_MINMAX(
 geoalgSpec2_MINMAX * a_geoalgSpec2_MINMAX)
{
  if (a_geoalgSpec2_MINMAX->get_geoalgFilterSettings())
    {
      if (!findString("a_geoalgFilterSettings", geoalgSpec2_MINMAXAtts))
	{warnAtt("a_geoalgFilterSettings", "geoalgSpec2_MINMAX", a_geoalgSpec2_MINMAX);}
      else
        check_geoalgFilterSettings(a_geoalgSpec2_MINMAX->get_geoalgFilterSettings());
    }
}

/********************************************************************/

void check_geoalgSpec3(
 geoalgSpec3 * a_geoalgSpec3)
{
  if (isA(a_geoalgSpec3, geoalgSpec3_DEFALT))
    {
      if (!findString("geoalgSpec3_DEFALT", geoalgSpec3Subs))
        {warnSub("geoalgSpec3_DEFALT", "geoalgSpec3", a_geoalgSpec3);}
      else
        check_geoalgSpec3_DEFALT(dynamic_cast<geoalgSpec3_DEFALT *>(a_geoalgSpec3));
      return;
    }
  if (isA(a_geoalgSpec3, geoalgSpec3_EXTERN))
    {
      if (!findString("geoalgSpec3_EXTERN", geoalgSpec3Subs))
        {warnSub("geoalgSpec3_EXTERN", "geoalgSpec3", a_geoalgSpec3);}
      else
        check_geoalgSpec3_EXTERN(dynamic_cast<geoalgSpec3_EXTERN *>(a_geoalgSpec3));
      return;
    }
}

/********************************************************************/

void check_geoalgSpec3_DEFALT(
 geoalgSpec3_DEFALT * a_geoalgSpec3_DEFALT)
{
  if (a_geoalgSpec3_DEFALT->get_geoalgFilterSettings())
    {
      if (!findString("a_geoalgFilterSettings", geoalgSpec3_DEFALTAtts))
	{warnAtt("a_geoalgFilterSettings", "geoalgSpec3_DEFALT", a_geoalgSpec3_DEFALT);}
      else
        check_geoalgFilterSettings(a_geoalgSpec3_DEFALT->get_geoalgFilterSettings());
    }
}

/********************************************************************/

void check_geoalgSpec3_EXTERN(
 geoalgSpec3_EXTERN * a_geoalgSpec3_EXTERN)
{
  if (a_geoalgSpec3_EXTERN->get_geoalgExternFunc())
    {
      if (!findString("a_geoalgExternFunc", geoalgSpec3_EXTERNAtts))
	{warnAtt("a_geoalgExternFunc", "geoalgSpec3_EXTERN", a_geoalgSpec3_EXTERN);}
      else
        check_geoalgExternFunc(a_geoalgSpec3_EXTERN->get_geoalgExternFunc());
    }
  if (a_geoalgSpec3_EXTERN->get_paramList())
    {
      if (!findString("a_paramList", geoalgSpec3_EXTERNAtts))
	{warnAtt("a_paramList", "geoalgSpec3_EXTERN", a_geoalgSpec3_EXTERN);}
      else
        {
          std::list<param *> * theList;
          std::list<param *>::iterator iter;
          theList = a_geoalgSpec3_EXTERN->get_paramList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_param(*iter);
        }
    }
  if (a_geoalgSpec3_EXTERN->get_geoalgFilterSettings())
    {
      if (!findString("a_geoalgFilterSettings", geoalgSpec3_EXTERNAtts))
	{warnAtt("a_geoalgFilterSettings", "geoalgSpec3_EXTERN", a_geoalgSpec3_EXTERN);}
      else
        check_geoalgFilterSettings(a_geoalgSpec3_EXTERN->get_geoalgFilterSettings());
    }
}

/********************************************************************/

void check_geoalgSpec4(
 geoalgSpec4 * a_geoalgSpec4)
{
  if (isA(a_geoalgSpec4, geoalgSpec4_LSTSQR))
    {
      if (!findString("geoalgSpec4_LSTSQR", geoalgSpec4Subs))
        {warnSub("geoalgSpec4_LSTSQR", "geoalgSpec4", a_geoalgSpec4);}
      else
        check_geoalgSpec4_LSTSQR(dynamic_cast<geoalgSpec4_LSTSQR *>(a_geoalgSpec4));
      return;
    }
  if (isA(a_geoalgSpec4, geoalgSpec4_MINMAX))
    {
      if (!findString("geoalgSpec4_MINMAX", geoalgSpec4Subs))
        {warnSub("geoalgSpec4_MINMAX", "geoalgSpec4", a_geoalgSpec4);}
      else
        check_geoalgSpec4_MINMAX(dynamic_cast<geoalgSpec4_MINMAX *>(a_geoalgSpec4));
      return;
    }
  if (isA(a_geoalgSpec4, geoalgSpec4_BSPLIN))
    {
      if (!findString("geoalgSpec4_BSPLIN", geoalgSpec4Subs))
        {warnSub("geoalgSpec4_BSPLIN", "geoalgSpec4", a_geoalgSpec4);}
      else
        check_geoalgSpec4_BSPLIN(dynamic_cast<geoalgSpec4_BSPLIN *>(a_geoalgSpec4));
      return;
    }
  if (isA(a_geoalgSpec4, geoalgSpec4_DEFALT))
    {
      if (!findString("geoalgSpec4_DEFALT", geoalgSpec4Subs))
        {warnSub("geoalgSpec4_DEFALT", "geoalgSpec4", a_geoalgSpec4);}
      else
        check_geoalgSpec4_DEFALT(dynamic_cast<geoalgSpec4_DEFALT *>(a_geoalgSpec4));
      return;
    }
  if (isA(a_geoalgSpec4, geoalgSpec4_EXTERN))
    {
      if (!findString("geoalgSpec4_EXTERN", geoalgSpec4Subs))
        {warnSub("geoalgSpec4_EXTERN", "geoalgSpec4", a_geoalgSpec4);}
      else
        check_geoalgSpec4_EXTERN(dynamic_cast<geoalgSpec4_EXTERN *>(a_geoalgSpec4));
      return;
    }
}

/********************************************************************/

void check_geoalgSpec4_BSPLIN(
 geoalgSpec4_BSPLIN * a_geoalgSpec4_BSPLIN)
{
  if (a_geoalgSpec4_BSPLIN->get_geoalgFilterSettings())
    {
      if (!findString("a_geoalgFilterSettings", geoalgSpec4_BSPLINAtts))
	{warnAtt("a_geoalgFilterSettings", "geoalgSpec4_BSPLIN", a_geoalgSpec4_BSPLIN);}
      else
        check_geoalgFilterSettings(a_geoalgSpec4_BSPLIN->get_geoalgFilterSettings());
    }
}

/********************************************************************/

void check_geoalgSpec4_DEFALT(
 geoalgSpec4_DEFALT * a_geoalgSpec4_DEFALT)
{
  if (a_geoalgSpec4_DEFALT->get_geoalgFilterSettings())
    {
      if (!findString("a_geoalgFilterSettings", geoalgSpec4_DEFALTAtts))
	{warnAtt("a_geoalgFilterSettings", "geoalgSpec4_DEFALT", a_geoalgSpec4_DEFALT);}
      else
        check_geoalgFilterSettings(a_geoalgSpec4_DEFALT->get_geoalgFilterSettings());
    }
}

/********************************************************************/

void check_geoalgSpec4_EXTERN(
 geoalgSpec4_EXTERN * a_geoalgSpec4_EXTERN)
{
  if (a_geoalgSpec4_EXTERN->get_geoalgExternFunc())
    {
      if (!findString("a_geoalgExternFunc", geoalgSpec4_EXTERNAtts))
	{warnAtt("a_geoalgExternFunc", "geoalgSpec4_EXTERN", a_geoalgSpec4_EXTERN);}
      else
        check_geoalgExternFunc(a_geoalgSpec4_EXTERN->get_geoalgExternFunc());
    }
  if (a_geoalgSpec4_EXTERN->get_paramList())
    {
      if (!findString("a_paramList", geoalgSpec4_EXTERNAtts))
	{warnAtt("a_paramList", "geoalgSpec4_EXTERN", a_geoalgSpec4_EXTERN);}
      else
        {
          std::list<param *> * theList;
          std::list<param *>::iterator iter;
          theList = a_geoalgSpec4_EXTERN->get_paramList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_param(*iter);
        }
    }
  if (a_geoalgSpec4_EXTERN->get_geoalgFilterSettings())
    {
      if (!findString("a_geoalgFilterSettings", geoalgSpec4_EXTERNAtts))
	{warnAtt("a_geoalgFilterSettings", "geoalgSpec4_EXTERN", a_geoalgSpec4_EXTERN);}
      else
        check_geoalgFilterSettings(a_geoalgSpec4_EXTERN->get_geoalgFilterSettings());
    }
}

/********************************************************************/

void check_geoalgSpec4_LSTSQR(
 geoalgSpec4_LSTSQR * a_geoalgSpec4_LSTSQR)
{
  if (a_geoalgSpec4_LSTSQR->get_geoalgFilterSettings())
    {
      if (!findString("a_geoalgFilterSettings", geoalgSpec4_LSTSQRAtts))
	{warnAtt("a_geoalgFilterSettings", "geoalgSpec4_LSTSQR", a_geoalgSpec4_LSTSQR);}
      else
        check_geoalgFilterSettings(a_geoalgSpec4_LSTSQR->get_geoalgFilterSettings());
    }
}

/********************************************************************/

void check_geoalgSpec4_MINMAX(
 geoalgSpec4_MINMAX * a_geoalgSpec4_MINMAX)
{
  if (a_geoalgSpec4_MINMAX->get_geoalgFilterSettings())
    {
      if (!findString("a_geoalgFilterSettings", geoalgSpec4_MINMAXAtts))
	{warnAtt("a_geoalgFilterSettings", "geoalgSpec4_MINMAX", a_geoalgSpec4_MINMAX);}
      else
        check_geoalgFilterSettings(a_geoalgSpec4_MINMAX->get_geoalgFilterSettings());
    }
}

/********************************************************************/

void check_geoalgSpec5(
 geoalgSpec5 * a_geoalgSpec5)
{
  if (isA(a_geoalgSpec5, geoalgSpec5_LSTSQR))
    {
      if (!findString("geoalgSpec5_LSTSQR", geoalgSpec5Subs))
        {warnSub("geoalgSpec5_LSTSQR", "geoalgSpec5", a_geoalgSpec5);}
      else
        check_geoalgSpec5_LSTSQR(dynamic_cast<geoalgSpec5_LSTSQR *>(a_geoalgSpec5));
      return;
    }
  if (isA(a_geoalgSpec5, geoalgSpec5_MINMAX))
    {
      if (!findString("geoalgSpec5_MINMAX", geoalgSpec5Subs))
        {warnSub("geoalgSpec5_MINMAX", "geoalgSpec5", a_geoalgSpec5);}
      else
        check_geoalgSpec5_MINMAX(dynamic_cast<geoalgSpec5_MINMAX *>(a_geoalgSpec5));
      return;
    }
  if (isA(a_geoalgSpec5, geoalgSpec5_BEZIER))
    {
      if (!findString("geoalgSpec5_BEZIER", geoalgSpec5Subs))
        {warnSub("geoalgSpec5_BEZIER", "geoalgSpec5", a_geoalgSpec5);}
      else
        check_geoalgSpec5_BEZIER(dynamic_cast<geoalgSpec5_BEZIER *>(a_geoalgSpec5));
      return;
    }
  if (isA(a_geoalgSpec5, geoalgSpec5_NURBS))
    {
      if (!findString("geoalgSpec5_NURBS", geoalgSpec5Subs))
        {warnSub("geoalgSpec5_NURBS", "geoalgSpec5", a_geoalgSpec5);}
      else
        check_geoalgSpec5_NURBS(dynamic_cast<geoalgSpec5_NURBS *>(a_geoalgSpec5));
      return;
    }
  if (isA(a_geoalgSpec5, geoalgSpec5_DEFALT))
    {
      if (!findString("geoalgSpec5_DEFALT", geoalgSpec5Subs))
        {warnSub("geoalgSpec5_DEFALT", "geoalgSpec5", a_geoalgSpec5);}
      else
        check_geoalgSpec5_DEFALT(dynamic_cast<geoalgSpec5_DEFALT *>(a_geoalgSpec5));
      return;
    }
  if (isA(a_geoalgSpec5, geoalgSpec5_EXTERN))
    {
      if (!findString("geoalgSpec5_EXTERN", geoalgSpec5Subs))
        {warnSub("geoalgSpec5_EXTERN", "geoalgSpec5", a_geoalgSpec5);}
      else
        check_geoalgSpec5_EXTERN(dynamic_cast<geoalgSpec5_EXTERN *>(a_geoalgSpec5));
      return;
    }
}

/********************************************************************/

void check_geoalgSpec5_BEZIER(
 geoalgSpec5_BEZIER * a_geoalgSpec5_BEZIER)
{
  if (a_geoalgSpec5_BEZIER->get_geoalgFilterSettings())
    {
      if (!findString("a_geoalgFilterSettings", geoalgSpec5_BEZIERAtts))
	{warnAtt("a_geoalgFilterSettings", "geoalgSpec5_BEZIER", a_geoalgSpec5_BEZIER);}
      else
        check_geoalgFilterSettings(a_geoalgSpec5_BEZIER->get_geoalgFilterSettings());
    }
}

/********************************************************************/

void check_geoalgSpec5_DEFALT(
 geoalgSpec5_DEFALT * a_geoalgSpec5_DEFALT)
{
  if (a_geoalgSpec5_DEFALT->get_geoalgFilterSettings())
    {
      if (!findString("a_geoalgFilterSettings", geoalgSpec5_DEFALTAtts))
	{warnAtt("a_geoalgFilterSettings", "geoalgSpec5_DEFALT", a_geoalgSpec5_DEFALT);}
      else
        check_geoalgFilterSettings(a_geoalgSpec5_DEFALT->get_geoalgFilterSettings());
    }
}

/********************************************************************/

void check_geoalgSpec5_EXTERN(
 geoalgSpec5_EXTERN * a_geoalgSpec5_EXTERN)
{
  if (a_geoalgSpec5_EXTERN->get_geoalgExternFunc())
    {
      if (!findString("a_geoalgExternFunc", geoalgSpec5_EXTERNAtts))
	{warnAtt("a_geoalgExternFunc", "geoalgSpec5_EXTERN", a_geoalgSpec5_EXTERN);}
      else
        check_geoalgExternFunc(a_geoalgSpec5_EXTERN->get_geoalgExternFunc());
    }
  if (a_geoalgSpec5_EXTERN->get_paramList())
    {
      if (!findString("a_paramList", geoalgSpec5_EXTERNAtts))
	{warnAtt("a_paramList", "geoalgSpec5_EXTERN", a_geoalgSpec5_EXTERN);}
      else
        {
          std::list<param *> * theList;
          std::list<param *>::iterator iter;
          theList = a_geoalgSpec5_EXTERN->get_paramList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_param(*iter);
        }
    }
  if (a_geoalgSpec5_EXTERN->get_geoalgFilterSettings())
    {
      if (!findString("a_geoalgFilterSettings", geoalgSpec5_EXTERNAtts))
	{warnAtt("a_geoalgFilterSettings", "geoalgSpec5_EXTERN", a_geoalgSpec5_EXTERN);}
      else
        check_geoalgFilterSettings(a_geoalgSpec5_EXTERN->get_geoalgFilterSettings());
    }
}

/********************************************************************/

void check_geoalgSpec5_LSTSQR(
 geoalgSpec5_LSTSQR * a_geoalgSpec5_LSTSQR)
{
  if (a_geoalgSpec5_LSTSQR->get_geoalgFilterSettings())
    {
      if (!findString("a_geoalgFilterSettings", geoalgSpec5_LSTSQRAtts))
	{warnAtt("a_geoalgFilterSettings", "geoalgSpec5_LSTSQR", a_geoalgSpec5_LSTSQR);}
      else
        check_geoalgFilterSettings(a_geoalgSpec5_LSTSQR->get_geoalgFilterSettings());
    }
}

/********************************************************************/

void check_geoalgSpec5_MINMAX(
 geoalgSpec5_MINMAX * a_geoalgSpec5_MINMAX)
{
  if (a_geoalgSpec5_MINMAX->get_geoalgFilterSettings())
    {
      if (!findString("a_geoalgFilterSettings", geoalgSpec5_MINMAXAtts))
	{warnAtt("a_geoalgFilterSettings", "geoalgSpec5_MINMAX", a_geoalgSpec5_MINMAX);}
      else
        check_geoalgFilterSettings(a_geoalgSpec5_MINMAX->get_geoalgFilterSettings());
    }
}

/********************************************************************/

void check_geoalgSpec5_NURBS(
 geoalgSpec5_NURBS * a_geoalgSpec5_NURBS)
{
  if (a_geoalgSpec5_NURBS->get_geoalgFilterSettings())
    {
      if (!findString("a_geoalgFilterSettings", geoalgSpec5_NURBSAtts))
	{warnAtt("a_geoalgFilterSettings", "geoalgSpec5_NURBS", a_geoalgSpec5_NURBS);}
      else
        check_geoalgFilterSettings(a_geoalgSpec5_NURBS->get_geoalgFilterSettings());
    }
}

/********************************************************************/

void check_geoalgSpec6(
 geoalgSpec6 * a_geoalgSpec6)
{
  if (isA(a_geoalgSpec6, geoalgSpec6_LSTSQR))
    {
      if (!findString("geoalgSpec6_LSTSQR", geoalgSpec6Subs))
        {warnSub("geoalgSpec6_LSTSQR", "geoalgSpec6", a_geoalgSpec6);}
      else
        check_geoalgSpec6_LSTSQR(dynamic_cast<geoalgSpec6_LSTSQR *>(a_geoalgSpec6));
      return;
    }
  if (isA(a_geoalgSpec6, geoalgSpec6_BSPLIN))
    {
      if (!findString("geoalgSpec6_BSPLIN", geoalgSpec6Subs))
        {warnSub("geoalgSpec6_BSPLIN", "geoalgSpec6", a_geoalgSpec6);}
      else
        check_geoalgSpec6_BSPLIN(dynamic_cast<geoalgSpec6_BSPLIN *>(a_geoalgSpec6));
      return;
    }
  if (isA(a_geoalgSpec6, geoalgSpec6_DEFALT))
    {
      if (!findString("geoalgSpec6_DEFALT", geoalgSpec6Subs))
        {warnSub("geoalgSpec6_DEFALT", "geoalgSpec6", a_geoalgSpec6);}
      else
        check_geoalgSpec6_DEFALT(dynamic_cast<geoalgSpec6_DEFALT *>(a_geoalgSpec6));
      return;
    }
  if (isA(a_geoalgSpec6, geoalgSpec6_EXTERN))
    {
      if (!findString("geoalgSpec6_EXTERN", geoalgSpec6Subs))
        {warnSub("geoalgSpec6_EXTERN", "geoalgSpec6", a_geoalgSpec6);}
      else
        check_geoalgSpec6_EXTERN(dynamic_cast<geoalgSpec6_EXTERN *>(a_geoalgSpec6));
      return;
    }
}

/********************************************************************/

void check_geoalgSpec6_BSPLIN(
 geoalgSpec6_BSPLIN * a_geoalgSpec6_BSPLIN)
{
  if (a_geoalgSpec6_BSPLIN->get_geoalgFilterSettings())
    {
      if (!findString("a_geoalgFilterSettings", geoalgSpec6_BSPLINAtts))
	{warnAtt("a_geoalgFilterSettings", "geoalgSpec6_BSPLIN", a_geoalgSpec6_BSPLIN);}
      else
        check_geoalgFilterSettings(a_geoalgSpec6_BSPLIN->get_geoalgFilterSettings());
    }
}

/********************************************************************/

void check_geoalgSpec6_DEFALT(
 geoalgSpec6_DEFALT * a_geoalgSpec6_DEFALT)
{
  if (a_geoalgSpec6_DEFALT->get_geoalgFilterSettings())
    {
      if (!findString("a_geoalgFilterSettings", geoalgSpec6_DEFALTAtts))
	{warnAtt("a_geoalgFilterSettings", "geoalgSpec6_DEFALT", a_geoalgSpec6_DEFALT);}
      else
        check_geoalgFilterSettings(a_geoalgSpec6_DEFALT->get_geoalgFilterSettings());
    }
}

/********************************************************************/

void check_geoalgSpec6_EXTERN(
 geoalgSpec6_EXTERN * a_geoalgSpec6_EXTERN)
{
  if (a_geoalgSpec6_EXTERN->get_geoalgExternFunc())
    {
      if (!findString("a_geoalgExternFunc", geoalgSpec6_EXTERNAtts))
	{warnAtt("a_geoalgExternFunc", "geoalgSpec6_EXTERN", a_geoalgSpec6_EXTERN);}
      else
        check_geoalgExternFunc(a_geoalgSpec6_EXTERN->get_geoalgExternFunc());
    }
  if (a_geoalgSpec6_EXTERN->get_paramList())
    {
      if (!findString("a_paramList", geoalgSpec6_EXTERNAtts))
	{warnAtt("a_paramList", "geoalgSpec6_EXTERN", a_geoalgSpec6_EXTERN);}
      else
        {
          std::list<param *> * theList;
          std::list<param *>::iterator iter;
          theList = a_geoalgSpec6_EXTERN->get_paramList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_param(*iter);
        }
    }
  if (a_geoalgSpec6_EXTERN->get_geoalgFilterSettings())
    {
      if (!findString("a_geoalgFilterSettings", geoalgSpec6_EXTERNAtts))
	{warnAtt("a_geoalgFilterSettings", "geoalgSpec6_EXTERN", a_geoalgSpec6_EXTERN);}
      else
        check_geoalgFilterSettings(a_geoalgSpec6_EXTERN->get_geoalgFilterSettings());
    }
}

/********************************************************************/

void check_geoalgSpec6_LSTSQR(
 geoalgSpec6_LSTSQR * a_geoalgSpec6_LSTSQR)
{
  if (a_geoalgSpec6_LSTSQR->get_geoalgFilterSettings())
    {
      if (!findString("a_geoalgFilterSettings", geoalgSpec6_LSTSQRAtts))
	{warnAtt("a_geoalgFilterSettings", "geoalgSpec6_LSTSQR", a_geoalgSpec6_LSTSQR);}
      else
        check_geoalgFilterSettings(a_geoalgSpec6_LSTSQR->get_geoalgFilterSettings());
    }
}

/********************************************************************/

void check_geoalgSphere(
 geoalgSphere * a_geoalgSphere)
{
  if (a_geoalgSphere->get_geoalgSpec2())
    {
      if (!findString("a_geoalgSpec2", geoalgSphereAtts))
	{warnAtt("a_geoalgSpec2", "geoalgSphere", a_geoalgSphere);}
      else
        check_geoalgSpec2(a_geoalgSphere->get_geoalgSpec2());
    }
}

/********************************************************************/

void check_geoalgSphradsegmnt(
 geoalgSphradsegmnt * a_geoalgSphradsegmnt)
{
  if (a_geoalgSphradsegmnt->get_geoalgSpec2())
    {
      if (!findString("a_geoalgSpec2", geoalgSphradsegmntAtts))
	{warnAtt("a_geoalgSpec2", "geoalgSphradsegmnt", a_geoalgSphradsegmnt);}
      else
        check_geoalgSpec2(a_geoalgSphradsegmnt->get_geoalgSpec2());
    }
}

/********************************************************************/

void check_geoalgStm(
 geoalgStm * a_geoalgStm)
{
  if (a_geoalgStm->get_geoalgMinor())
    {
      if (!findString("a_geoalgMinor", geoalgStmAtts))
	{warnAtt("a_geoalgMinor", "geoalgStm", a_geoalgStm);}
      else
        check_geoalgMinor(a_geoalgStm->get_geoalgMinor());
    }
}

/********************************************************************/

void check_geoalgSympln(
 geoalgSympln * a_geoalgSympln)
{
  if (a_geoalgSympln->get_geoalgSpec2())
    {
      if (!findString("a_geoalgSpec2", geoalgSymplnAtts))
	{warnAtt("a_geoalgSpec2", "geoalgSympln", a_geoalgSympln);}
      else
        check_geoalgSpec2(a_geoalgSympln->get_geoalgSpec2());
    }
}

/********************************************************************/

void check_geoalgTorradsegmnt(
 geoalgTorradsegmnt * a_geoalgTorradsegmnt)
{
  if (a_geoalgTorradsegmnt->get_geoalgSpec2())
    {
      if (!findString("a_geoalgSpec2", geoalgTorradsegmntAtts))
	{warnAtt("a_geoalgSpec2", "geoalgTorradsegmnt", a_geoalgTorradsegmnt);}
      else
        check_geoalgSpec2(a_geoalgTorradsegmnt->get_geoalgSpec2());
    }
}

/********************************************************************/

void check_geoalgTorus(
 geoalgTorus * a_geoalgTorus)
{
  if (a_geoalgTorus->get_geoalgSpec2())
    {
      if (!findString("a_geoalgSpec2", geoalgTorusAtts))
	{warnAtt("a_geoalgSpec2", "geoalgTorus", a_geoalgTorus);}
      else
        check_geoalgSpec2(a_geoalgTorus->get_geoalgSpec2());
    }
}

/********************************************************************/

void check_geomEntityItem(
 geomEntityItem * a_geomEntityItem)
{
  if (a_geomEntityItem->get_identity())
    {
      if (!findString("identity", geomEntityItemAtts))
	{warnAtt("identity", "geomEntityItem", a_geomEntityItem);}
      else
        check_stringVal(a_geomEntityItem->get_identity());
    }
  if (a_geomEntityItem->get_dist())
    {
      if (!findString("dist", geomEntityItemAtts))
	{warnAtt("dist", "geomEntityItem", a_geomEntityItem);}
      else
        check_rentVal(a_geomEntityItem->get_dist());
    }
}

/********************************************************************/

void check_geomMinor(
 geomMinor * a_geomMinor)
{
  if (isA(a_geomMinor, geomStmNone))
    {
      if (!findString("geomStmNone", geomMinorSubs))
        {warnSub("geomStmNone", "geomMinor", a_geomMinor);}
      return;
    }
  if (isA(a_geomMinor, geomStmDid))
    {
      if (!findString("geomStmDid", geomMinorSubs))
        {warnSub("geomStmDid", "geomMinor", a_geomMinor);}
      else
        check_geomStmDid(dynamic_cast<geomStmDid *>(a_geomMinor));
      return;
    }
  if (isA(a_geomMinor, geomStmOffset))
    {
      if (!findString("geomStmOffset", geomMinorSubs))
        {warnSub("geomStmOffset", "geomMinor", a_geomMinor);}
      else
        check_geomStmOffset(dynamic_cast<geomStmOffset *>(a_geomMinor));
      return;
    }
  if (isA(a_geomMinor, geomStmEntity))
    {
      if (!findString("geomStmEntity", geomMinorSubs))
        {warnSub("geomStmEntity", "geomMinor", a_geomMinor);}
      else
        check_geomStmEntity(dynamic_cast<geomStmEntity *>(a_geomMinor));
      return;
    }
}

/********************************************************************/

void check_geomStm(
 geomStm * a_geomStm)
{
  if (a_geomStm->get_gLabel())
    {
      if (!findString("a_gLabel", geomStmAtts))
	{warnAtt("a_gLabel", "geomStm", a_geomStm);}
      else
        check_gLabel(a_geomStm->get_gLabel());
    }
  if (a_geomStm->get_geomMinor())
    {
      if (!findString("a_geomMinor", geomStmAtts))
	{warnAtt("a_geomMinor", "geomStm", a_geomStm);}
      else
        check_geomMinor(a_geomStm->get_geomMinor());
    }
}

/********************************************************************/

void check_geomStmDid(
 geomStmDid * a_geomStmDid)
{
  if (a_geomStmDid->get_didLabel())
    {
      if (!findString("a_didLabel", geomStmDidAtts))
	{warnAtt("a_didLabel", "geomStmDid", a_geomStmDid);}
      else
        check_didLabel(a_geomStmDid->get_didLabel());
    }
}

/********************************************************************/

void check_geomStmEntity(
 geomStmEntity * a_geomStmEntity)
{
  if (a_geomStmEntity->get_gLabel())
    {
      if (!findString("a_gLabel", geomStmEntityAtts))
	{warnAtt("a_gLabel", "geomStmEntity", a_geomStmEntity);}
      else
        check_gLabel(a_geomStmEntity->get_gLabel());
    }
  if (a_geomStmEntity->get_geomEntityList())
    {
      if (!findString("a_geomEntityList", geomStmEntityAtts))
	{warnAtt("a_geomEntityList", "geomStmEntity", a_geomStmEntity);}
      else
        {
          std::list<geomEntityItem *> * theList;
          std::list<geomEntityItem *>::iterator iter;
          theList = a_geomStmEntity->get_geomEntityList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_geomEntityItem(*iter);
        }
    }
}

/********************************************************************/

void check_geomStmOffset(
 geomStmOffset * a_geomStmOffset)
{
  if (a_geomStmOffset->get_gLabel())
    {
      if (!findString("a_gLabel", geomStmOffsetAtts))
	{warnAtt("a_gLabel", "geomStmOffset", a_geomStmOffset);}
      else
        check_gLabel(a_geomStmOffset->get_gLabel());
    }
  if (a_geomStmOffset->get_dist())
    {
      if (!findString("dist", geomStmOffsetAtts))
	{warnAtt("dist", "geomStmOffset", a_geomStmOffset);}
      else
        check_rentVal(a_geomStmOffset->get_dist());
    }
}

/********************************************************************/

void check_gotargBlock(
 gotargBlock * a_gotargBlock)
{
  if (a_gotargBlock->get_gotargStm())
    {
      if (!findString("a_gotargStm", gotargBlockAtts))
	{warnAttBlock("gotargStm", a_gotargBlock->get_gotargStm());}
      else
        check_gotargStm(a_gotargBlock->get_gotargStm());
    }
  if (a_gotargBlock->get_gotoStm())
    {
      if (!findString("a_gotoStm", gotargBlockAtts))
	{warnAttBlock("gotoStm", a_gotargBlock->get_gotoStm());}
      else
        check_gotoStm(a_gotargBlock->get_gotoStm());
    }
  if (a_gotargBlock->get_gotoList())
    {
      if (!findString("a_gotoList", gotargBlockAtts))
	{warnAttBlock("gotoList", a_gotargBlock->get_gotoList()->front());}
      else
        {
          std::list<gotoStm *> * theList;
          std::list<gotoStm *>::iterator iter;
          theList = a_gotargBlock->get_gotoList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_gotoStm(*iter);
        }
    }
  if (a_gotargBlock->get_endgoStm())
    {
      if (!findString("a_endgoStm", gotargBlockAtts))
	{warnAttBlock("endgoStm", a_gotargBlock->get_endgoStm());}
    }
}

/********************************************************************/

void check_gotargCart(
 gotargCart * a_gotargCart)
{
  if (a_gotargCart->get_cartPoint())
    {
      if (!findString("a_cartPoint", gotargCartAtts))
	{warnAtt("a_cartPoint", "gotargCart", a_gotargCart);}
      else
        check_cartPoint(a_gotargCart->get_cartPoint());
    }
}

/********************************************************************/

void check_gotargPol(
 gotargPol * a_gotargPol)
{
  if (a_gotargPol->get_polPoint())
    {
      if (!findString("a_polPoint", gotargPolAtts))
	{warnAtt("a_polPoint", "gotargPol", a_gotargPol);}
      else
        check_polPoint(a_gotargPol->get_polPoint());
    }
}

/********************************************************************/

void check_gotargStm(
 gotargStm * a_gotargStm)
{
  if (isA(a_gotargStm, gotargXyz))
    {
      if (!findString("gotargXyz", gotargStmSubs))
        {warnSub("gotargXyz", "gotargStm", a_gotargStm);}
      else
        check_gotargXyz(dynamic_cast<gotargXyz *>(a_gotargStm));
      return;
    }
  if (isA(a_gotargStm, gotargCart))
    {
      if (!findString("gotargCart", gotargStmSubs))
        {warnSub("gotargCart", "gotargStm", a_gotargStm);}
      else
        check_gotargCart(dynamic_cast<gotargCart *>(a_gotargStm));
      return;
    }
  if (isA(a_gotargStm, gotargPol))
    {
      if (!findString("gotargPol", gotargStmSubs))
        {warnSub("gotargPol", "gotargStm", a_gotargStm);}
      else
        check_gotargPol(dynamic_cast<gotargPol *>(a_gotargStm));
      return;
    }
}

/********************************************************************/

void check_gotargXyz(
 gotargXyz * a_gotargXyz)
{
  if (a_gotargXyz->get_impCartPoint())
    {
      if (!findString("a_impCartPoint", gotargXyzAtts))
	{warnAtt("a_impCartPoint", "gotargXyz", a_gotargXyz);}
      else
        check_impCartPoint(a_gotargXyz->get_impCartPoint());
    }
}

/********************************************************************/

void check_gotoAbs(
 gotoAbs * a_gotoAbs)
{
  if (isA(a_gotoAbs, gotoAbsXyz))
    {
      if (!findString("gotoAbsXyz", gotoAbsSubs))
        {warnSub("gotoAbsXyz", "gotoAbs", a_gotoAbs);}
      else
        check_gotoAbsXyz(dynamic_cast<gotoAbsXyz *>(a_gotoAbs));
      return;
    }
  if (isA(a_gotoAbs, gotoAbsXyzSens))
    {
      if (!findString("gotoAbsXyzSens", gotoAbsSubs))
        {warnSub("gotoAbsXyzSens", "gotoAbs", a_gotoAbs);}
      else
        check_gotoAbsXyzSens(dynamic_cast<gotoAbsXyzSens *>(a_gotoAbs));
      return;
    }
  if (isA(a_gotoAbs, gotoAbsCart))
    {
      if (!findString("gotoAbsCart", gotoAbsSubs))
        {warnSub("gotoAbsCart", "gotoAbs", a_gotoAbs);}
      else
        check_gotoAbsCart(dynamic_cast<gotoAbsCart *>(a_gotoAbs));
      return;
    }
  if (isA(a_gotoAbs, gotoAbsCartSens))
    {
      if (!findString("gotoAbsCartSens", gotoAbsSubs))
        {warnSub("gotoAbsCartSens", "gotoAbs", a_gotoAbs);}
      else
        check_gotoAbsCartSens(dynamic_cast<gotoAbsCartSens *>(a_gotoAbs));
      return;
    }
  if (isA(a_gotoAbs, gotoAbsPol))
    {
      if (!findString("gotoAbsPol", gotoAbsSubs))
        {warnSub("gotoAbsPol", "gotoAbs", a_gotoAbs);}
      else
        check_gotoAbsPol(dynamic_cast<gotoAbsPol *>(a_gotoAbs));
      return;
    }
  if (isA(a_gotoAbs, gotoAbsPolSens))
    {
      if (!findString("gotoAbsPolSens", gotoAbsSubs))
        {warnSub("gotoAbsPolSens", "gotoAbs", a_gotoAbs);}
      else
        check_gotoAbsPolSens(dynamic_cast<gotoAbsPolSens *>(a_gotoAbs));
      return;
    }
}

/********************************************************************/

void check_gotoAbsCart(
 gotoAbsCart * a_gotoAbsCart)
{
  if (a_gotoAbsCart->get_cartPoint())
    {
      if (!findString("a_cartPoint", gotoAbsCartAtts))
	{warnAtt("a_cartPoint", "gotoAbsCart", a_gotoAbsCart);}
      else
        check_cartPoint(a_gotoAbsCart->get_cartPoint());
    }
}

/********************************************************************/

void check_gotoAbsCartSens(
 gotoAbsCartSens * a_gotoAbsCartSens)
{
  if (a_gotoAbsCartSens->get_cartPoint())
    {
      if (!findString("a_cartPoint", gotoAbsCartSensAtts))
	{warnAtt("a_cartPoint", "gotoAbsCartSens", a_gotoAbsCartSens);}
      else
        check_cartPoint(a_gotoAbsCartSens->get_cartPoint());
    }
  if (a_gotoAbsCartSens->get_sensorMove())
    {
      if (!findString("a_sensorMove", gotoAbsCartSensAtts))
	{warnAtt("a_sensorMove", "gotoAbsCartSens", a_gotoAbsCartSens);}
      else
        check_sensorMove(a_gotoAbsCartSens->get_sensorMove());
    }
}

/********************************************************************/

void check_gotoAbsPol(
 gotoAbsPol * a_gotoAbsPol)
{
  if (a_gotoAbsPol->get_polPoint())
    {
      if (!findString("a_polPoint", gotoAbsPolAtts))
	{warnAtt("a_polPoint", "gotoAbsPol", a_gotoAbsPol);}
      else
        check_polPoint(a_gotoAbsPol->get_polPoint());
    }
}

/********************************************************************/

void check_gotoAbsPolSens(
 gotoAbsPolSens * a_gotoAbsPolSens)
{
  if (a_gotoAbsPolSens->get_polPoint())
    {
      if (!findString("a_polPoint", gotoAbsPolSensAtts))
	{warnAtt("a_polPoint", "gotoAbsPolSens", a_gotoAbsPolSens);}
      else
        check_polPoint(a_gotoAbsPolSens->get_polPoint());
    }
  if (a_gotoAbsPolSens->get_sensorMove())
    {
      if (!findString("a_sensorMove", gotoAbsPolSensAtts))
	{warnAtt("a_sensorMove", "gotoAbsPolSens", a_gotoAbsPolSens);}
      else
        check_sensorMove(a_gotoAbsPolSens->get_sensorMove());
    }
}

/********************************************************************/

void check_gotoAbsXyz(
 gotoAbsXyz * a_gotoAbsXyz)
{
  if (a_gotoAbsXyz->get_impCartPoint())
    {
      if (!findString("a_impCartPoint", gotoAbsXyzAtts))
	{warnAtt("a_impCartPoint", "gotoAbsXyz", a_gotoAbsXyz);}
      else
        check_impCartPoint(a_gotoAbsXyz->get_impCartPoint());
    }
}

/********************************************************************/

void check_gotoAbsXyzSens(
 gotoAbsXyzSens * a_gotoAbsXyzSens)
{
  if (a_gotoAbsXyzSens->get_impCartPoint())
    {
      if (!findString("a_impCartPoint", gotoAbsXyzSensAtts))
	{warnAtt("a_impCartPoint", "gotoAbsXyzSens", a_gotoAbsXyzSens);}
      else
        check_impCartPoint(a_gotoAbsXyzSens->get_impCartPoint());
    }
  if (a_gotoAbsXyzSens->get_sensorMove())
    {
      if (!findString("a_sensorMove", gotoAbsXyzSensAtts))
	{warnAtt("a_sensorMove", "gotoAbsXyzSens", a_gotoAbsXyzSens);}
      else
        check_sensorMove(a_gotoAbsXyzSens->get_sensorMove());
    }
}

/********************************************************************/

void check_gotoArc(
 gotoArc * a_gotoArc)
{
  if (a_gotoArc->get_inter())
    {
      if (!findString("inter", gotoArcAtts))
	{warnAtt("inter", "gotoArc", a_gotoArc);}
      else
        check_impCartPoint(a_gotoArc->get_inter());
    }
  if (a_gotoArc->get_end())
    {
      if (!findString("end", gotoArcAtts))
	{warnAtt("end", "gotoArc", a_gotoArc);}
      else
        check_impCartPoint(a_gotoArc->get_end());
    }
  if (a_gotoArc->get_probeOrient())
    {
      if (!findString("a_probeOrient", gotoArcAtts))
	{warnAtt("a_probeOrient", "gotoArc", a_gotoArc);}
      else
        check_probeOrient(a_gotoArc->get_probeOrient());
    }
}

/********************************************************************/

void check_gotoAxis(
 gotoAxis * a_gotoAxis)
{
  if (a_gotoAxis->get_spec1())
    {
      if (!findString("spec1", gotoAxisAtts))
	{warnAtt("spec1", "gotoAxis", a_gotoAxis);}
      else
        check_gotoAxisSpec(a_gotoAxis->get_spec1());
    }
  if (a_gotoAxis->get_spec2())
    {
      if (!findString("spec2", gotoAxisAtts))
	{warnAtt("spec2", "gotoAxis", a_gotoAxis);}
      else
        check_gotoAxisSpec(a_gotoAxis->get_spec2());
    }
  if (a_gotoAxis->get_spec3())
    {
      if (!findString("spec3", gotoAxisAtts))
	{warnAtt("spec3", "gotoAxis", a_gotoAxis);}
      else
        check_gotoAxisSpec(a_gotoAxis->get_spec3());
    }
}

/********************************************************************/

void check_gotoAxisSpec(
 gotoAxisSpec * a_gotoAxisSpec)
{
  if (a_gotoAxisSpec->get_axisName())
    {
      if (!findString("axisName", gotoAxisSpecAtts))
	{warnAtt("axisName", "gotoAxisSpec", a_gotoAxisSpec);}
      else
        check_axis(a_gotoAxisSpec->get_axisName());
    }
  if (a_gotoAxisSpec->get_axisCoord())
    {
      if (!findString("axisCoord", gotoAxisSpecAtts))
	{warnAtt("axisCoord", "gotoAxisSpec", a_gotoAxisSpec);}
      else
        check_rentVal(a_gotoAxisSpec->get_axisCoord());
    }
}

/********************************************************************/

void check_gotoMinor(
 gotoMinor * a_gotoMinor)
{
  if (isA(a_gotoMinor, gotoAbs))
    {
      if (!findString("gotoAbs", gotoMinorSubs))
        {warnSub("gotoAbs", "gotoMinor", a_gotoMinor);}
      else
        check_gotoAbs(dynamic_cast<gotoAbs *>(a_gotoMinor));
      return;
    }
  if (isA(a_gotoMinor, gotoRel))
    {
      if (!findString("gotoRel", gotoMinorSubs))
        {warnSub("gotoRel", "gotoMinor", a_gotoMinor);}
      else
        check_gotoRel(dynamic_cast<gotoRel *>(a_gotoMinor));
      return;
    }
  if (isA(a_gotoMinor, gotoArc))
    {
      if (!findString("gotoArc", gotoMinorSubs))
        {warnSub("gotoArc", "gotoMinor", a_gotoMinor);}
      else
        check_gotoArc(dynamic_cast<gotoArc *>(a_gotoMinor));
      return;
    }
  if (isA(a_gotoMinor, gotoAxis))
    {
      if (!findString("gotoAxis", gotoMinorSubs))
        {warnSub("gotoAxis", "gotoMinor", a_gotoMinor);}
      else
        check_gotoAxis(dynamic_cast<gotoAxis *>(a_gotoMinor));
      return;
    }
  if (isA(a_gotoMinor, probeOrient))
    {
      if (!findString("probeOrient", gotoMinorSubs))
        {warnSub("probeOrient", "gotoMinor", a_gotoMinor);}
      else
        check_probeOrient(dynamic_cast<probeOrient *>(a_gotoMinor));
      return;
    }
}

/********************************************************************/

void check_gotoRel(
 gotoRel * a_gotoRel)
{
  if (a_gotoRel->get_dist())
    {
      if (!findString("dist", gotoRelAtts))
	{warnAtt("dist", "gotoRel", a_gotoRel);}
      else
        check_rentVal(a_gotoRel->get_dist());
    }
  if (a_gotoRel->get_dir())
    {
      if (!findString("dir", gotoRelAtts))
	{warnAtt("dir", "gotoRel", a_gotoRel);}
      else
        check_vector(a_gotoRel->get_dir());
    }
}

/********************************************************************/

void check_gotoStm(
 gotoStm * a_gotoStm)
{
  if (a_gotoStm->get_gotoMinor())
    {
      if (!findString("a_gotoMinor", gotoStmAtts))
	{warnAtt("a_gotoMinor", "gotoStm", a_gotoStm);}
      else
        check_gotoMinor(a_gotoStm->get_gotoMinor());
    }
}

/********************************************************************/

void check_gotoWristAngleItem(
 gotoWristAngleItem * a_gotoWristAngleItem)
{
  if (a_gotoWristAngleItem->get_anglename())
    {
      if (!findString("anglename", gotoWristAngleItemAtts))
	{warnAtt("anglename", "gotoWristAngleItem", a_gotoWristAngleItem);}
      else
        check_stringVal(a_gotoWristAngleItem->get_anglename());
    }
  if (a_gotoWristAngleItem->get_angle())
    {
      if (!findString("a_angle", gotoWristAngleItemAtts))
	{warnAtt("a_angle", "gotoWristAngleItem", a_gotoWristAngleItem);}
      else
        check_angle(a_gotoWristAngleItem->get_angle());
    }
}

/********************************************************************/

void check_gotoWristItem(
 gotoWristItem * a_gotoWristItem)
{
  if (a_gotoWristItem->get_swLabel())
    {
      if (!findString("a_swLabel", gotoWristItemAtts))
	{warnAtt("a_swLabel", "gotoWristItem", a_gotoWristItem);}
      else
        check_swLabel(a_gotoWristItem->get_swLabel());
    }
  if (a_gotoWristItem->get_gotoWristAngleList())
    {
      if (!findString("a_gotoWristAngleList", gotoWristItemAtts))
	{warnAtt("a_gotoWristAngleList", "gotoWristItem", a_gotoWristItem);}
      else
        {
          std::list<gotoWristAngleItem *> * theList;
          std::list<gotoWristAngleItem *>::iterator iter;
          theList = a_gotoWristItem->get_gotoWristAngleList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_gotoWristAngleItem(*iter);
        }
    }
}

/********************************************************************/

void check_groupStm(
 groupStm * a_groupStm)
{
  if (a_groupStm->get_gsaLabel())
    {
      if (!findString("a_gsaLabel", groupStmAtts))
	{warnAtt("a_gsaLabel", "groupStm", a_groupStm);}
      else
        check_gsaLabel(a_groupStm->get_gsaLabel());
    }
  if (a_groupStm->get_saLabel())
    {
      if (!findString("a_saLabel", groupStmAtts))
	{warnAtt("a_saLabel", "groupStm", a_groupStm);}
      else
        check_saLabel(a_groupStm->get_saLabel());
    }
  if (a_groupStm->get_saLabelList())
    {
      if (!findString("a_saLabelList", groupStmAtts))
	{warnAtt("a_saLabelList", "groupStm", a_groupStm);}
      else
        {
          std::list<saLabel *> * theList;
          std::list<saLabel *>::iterator iter;
          theList = a_groupStm->get_saLabelList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_saLabel(*iter);
        }
    }
}

/********************************************************************/

void check_gsaLabel(
 gsaLabel * a_gsaLabel)
{
  if (a_gsaLabel->get_labelName())
    {
      if (!findString("a_labelName", gsaLabelAtts))
	{warnAtt("a_labelName", "gsaLabel", a_gsaLabel);}
      else
        check_labelName(a_gsaLabel->get_labelName());
    }
}

/********************************************************************/

void check_ifBlock(
 ifBlock * a_ifBlock)
{
  if (a_ifBlock->get_ifStm())
    {
      if (!findString("a_ifStm", ifBlockAtts))
	{warnAttBlock("ifStm", a_ifBlock->get_ifStm());}
      else
        check_ifStm(a_ifBlock->get_ifStm());
    }
  if (a_ifBlock->get_ifList())
    {
      if (!findString("ifList", ifBlockAtts))
	{warnAttBlock("ifList", a_ifBlock->get_ifList()->front());}
      else
        {
          std::list<dmisItem *> * theList;
          std::list<dmisItem *>::iterator iter;
          theList = a_ifBlock->get_ifList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_dmisItem(*iter);
        }
    }
  if (a_ifBlock->get_elseStm())
    {
      if (!findString("a_elseStm", ifBlockAtts))
	{warnAttBlock("elseStm", a_ifBlock->get_elseStm());}
    }
  if (a_ifBlock->get_elseList())
    {
      if (!findString("elseList", ifBlockAtts))
	{warnAttBlock("elseList", a_ifBlock->get_elseList()->front());}
      else
        {
          std::list<dmisItem *> * theList;
          std::list<dmisItem *>::iterator iter;
          theList = a_ifBlock->get_elseList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_dmisItem(*iter);
        }
    }
  if (a_ifBlock->get_endifStm())
    {
      if (!findString("a_endifStm", ifBlockAtts))
	{warnAttBlock("endifStm", a_ifBlock->get_endifStm());}
    }
}

/********************************************************************/

void check_ifStm(
 ifStm * a_ifStm)
{
  if (a_ifStm->get_boolVal())
    {
      if (!findString("a_boolVal", ifStmAtts))
	{warnAtt("a_boolVal", "ifStm", a_ifStm);}
      else
        check_boolVal(a_ifStm->get_boolVal());
    }
}

/********************************************************************/

void check_impCartPoint(
 impCartPoint * a_impCartPoint)
{
  if (a_impCartPoint->get_x())
    {
      if (!findString("x", impCartPointAtts))
	{warnAtt("x", "impCartPoint", a_impCartPoint);}
      else
        check_rentVal(a_impCartPoint->get_x());
    }
  if (a_impCartPoint->get_y())
    {
      if (!findString("y", impCartPointAtts))
	{warnAtt("y", "impCartPoint", a_impCartPoint);}
      else
        check_rentVal(a_impCartPoint->get_y());
    }
  if (a_impCartPoint->get_z())
    {
      if (!findString("z", impCartPointAtts))
	{warnAtt("z", "impCartPoint", a_impCartPoint);}
      else
        check_rentVal(a_impCartPoint->get_z());
    }
}

/********************************************************************/

void check_impPolPoint(
 impPolPoint * a_impPolPoint)
{
  if (a_impPolPoint->get_r())
    {
      if (!findString("r", impPolPointAtts))
	{warnAtt("r", "impPolPoint", a_impPolPoint);}
      else
        check_rentVal(a_impPolPoint->get_r());
    }
  if (a_impPolPoint->get_a())
    {
      if (!findString("a", impPolPointAtts))
	{warnAtt("a", "impPolPoint", a_impPolPoint);}
      else
        check_rentVal(a_impPolPoint->get_a());
    }
  if (a_impPolPoint->get_h())
    {
      if (!findString("h", impPolPointAtts))
	{warnAtt("h", "impPolPoint", a_impPolPoint);}
      else
        check_rentVal(a_impPolPoint->get_h());
    }
}

/********************************************************************/

void check_includDme(
 includDme * a_includDme)
{
  if (a_includDme->get_stringConst())
    {
      if (!findString("a_stringConst", includDmeAtts))
	{warnAtt("a_stringConst", "includDme", a_includDme);}
      else
        check_stringConst(a_includDme->get_stringConst());
    }
}

/********************************************************************/

void check_includDmis(
 includDmis * a_includDmis)
{
  if (a_includDmis->get_stringConst())
    {
      if (!findString("a_stringConst", includDmisAtts))
	{warnAtt("a_stringConst", "includDmis", a_includDmis);}
      else
        check_stringConst(a_includDmis->get_stringConst());
    }
}

/********************************************************************/

void check_includMinor(
 includMinor * a_includMinor)
{
  if (isA(a_includMinor, includDmis))
    {
      if (!findString("includDmis", includMinorSubs))
        {warnSub("includDmis", "includMinor", a_includMinor);}
      else
        check_includDmis(dynamic_cast<includDmis *>(a_includMinor));
      return;
    }
  if (isA(a_includMinor, includDme))
    {
      if (!findString("includDme", includMinorSubs))
        {warnSub("includDme", "includMinor", a_includMinor);}
      else
        check_includDme(dynamic_cast<includDme *>(a_includMinor));
      return;
    }
}

/********************************************************************/

void check_includStm(
 includStm * a_includStm)
{
  if (a_includStm->get_includMinor())
    {
      if (!findString("a_includMinor", includStmAtts))
	{warnAtt("a_includMinor", "includStm", a_includStm);}
      else
        check_includMinor(a_includStm->get_includMinor());
    }
}

/********************************************************************/

void check_indexedFeature(
 indexedFeature * a_indexedFeature)
{
  if (a_indexedFeature->get_featureLabel())
    {
      if (!findString("a_featureLabel", indexedFeatureAtts))
	{warnAtt("a_featureLabel", "indexedFeature", a_indexedFeature);}
      else
        check_featureLabel(a_indexedFeature->get_featureLabel());
    }
  if (a_indexedFeature->get_pointRange())
    {
      if (!findString("a_pointRange", indexedFeatureAtts))
	{warnAtt("a_pointRange", "indexedFeature", a_indexedFeature);}
      else
        check_pointRange(a_indexedFeature->get_pointRange());
    }
}

/********************************************************************/

void check_inputFile(
 inputFile * a_inputFile)
{
  if (a_inputFile->get_dmisFirstStatement())
    {
      if (!findString("a_dmisFirstStatement", inputFileAtts))
	{warnAtt("a_dmisFirstStatement", "inputFile", a_inputFile);}
      else
        check_dmisFirstStatement(a_inputFile->get_dmisFirstStatement());
    }
  if (a_inputFile->get_dmisItemList())
    {
      if (!findString("a_dmisItemList", inputFileAtts))
	{warnAtt("a_dmisItemList", "inputFile", a_inputFile);}
      else
        {
          std::list<dmisItem *> * theList;
          std::list<dmisItem *>::iterator iter;
          theList = a_inputFile->get_dmisItemList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_dmisItem(*iter);
        }
    }
  if (a_inputFile->get_endfilStm())
    {
      if (!findString("a_endfilStm", inputFileAtts))
	{warnAtt("a_endfilStm", "inputFile", a_inputFile);}
    }
}

/********************************************************************/

void check_intConst(
 intConst * a_intConst)
{
  if (a_intConst->get_int())
    {
      if (!findString("a_int", intConstAtts))
	{warnAtt("a_int", "intConst", a_intConst);}
    }
}

/********************************************************************/

void check_intExpr(
 intExpr * a_intExpr)
{
  if (isA(a_intExpr, intExprParen))
    {
      if (!findString("intExprParen", intExprSubs))
        {warnSub("intExprParen", "intExpr", a_intExpr);}
      else
        check_intExprParen(dynamic_cast<intExprParen *>(a_intExpr));
      return;
    }
  if (isA(a_intExpr, intExprPlus))
    {
      if (!findString("intExprPlus", intExprSubs))
        {warnSub("intExprPlus", "intExpr", a_intExpr);}
      else
        check_intExprPlus(dynamic_cast<intExprPlus *>(a_intExpr));
      return;
    }
  if (isA(a_intExpr, intExprMinus))
    {
      if (!findString("intExprMinus", intExprSubs))
        {warnSub("intExprMinus", "intExpr", a_intExpr);}
      else
        check_intExprMinus(dynamic_cast<intExprMinus *>(a_intExpr));
      return;
    }
  if (isA(a_intExpr, intExprTimes))
    {
      if (!findString("intExprTimes", intExprSubs))
        {warnSub("intExprTimes", "intExpr", a_intExpr);}
      else
        check_intExprTimes(dynamic_cast<intExprTimes *>(a_intExpr));
      return;
    }
  if (isA(a_intExpr, intExprDivid))
    {
      if (!findString("intExprDivid", intExprSubs))
        {warnSub("intExprDivid", "intExpr", a_intExpr);}
      else
        check_intExprDivid(dynamic_cast<intExprDivid *>(a_intExpr));
      return;
    }
  if (isA(a_intExpr, intExprPower))
    {
      if (!findString("intExprPower", intExprSubs))
        {warnSub("intExprPower", "intExpr", a_intExpr);}
      else
        check_intExprPower(dynamic_cast<intExprPower *>(a_intExpr));
      return;
    }
  if (isA(a_intExpr, intExprNegat))
    {
      if (!findString("intExprNegat", intExprSubs))
        {warnSub("intExprNegat", "intExpr", a_intExpr);}
      else
        check_intExprNegat(dynamic_cast<intExprNegat *>(a_intExpr));
      return;
    }
  if (isA(a_intExpr, intExprPosit))
    {
      if (!findString("intExprPosit", intExprSubs))
        {warnSub("intExprPosit", "intExpr", a_intExpr);}
      else
        check_intExprPosit(dynamic_cast<intExprPosit *>(a_intExpr));
      return;
    }
}

/********************************************************************/

void check_intExprDivid(
 intExprDivid * a_intExprDivid)
{
  if (a_intExprDivid->get_dvend())
    {
      if (!findString("dvend", intExprDividAtts))
	{warnAtt("dvend", "intExprDivid", a_intExprDivid);}
      else
        check_intVal(a_intExprDivid->get_dvend());
    }
  if (a_intExprDivid->get_dvisr())
    {
      if (!findString("dvisr", intExprDividAtts))
	{warnAtt("dvisr", "intExprDivid", a_intExprDivid);}
      else
        check_intVal(a_intExprDivid->get_dvisr());
    }
}

/********************************************************************/

void check_intExprMinus(
 intExprMinus * a_intExprMinus)
{
  if (a_intExprMinus->get_term1())
    {
      if (!findString("term1", intExprMinusAtts))
	{warnAtt("term1", "intExprMinus", a_intExprMinus);}
      else
        check_intVal(a_intExprMinus->get_term1());
    }
  if (a_intExprMinus->get_term2())
    {
      if (!findString("term2", intExprMinusAtts))
	{warnAtt("term2", "intExprMinus", a_intExprMinus);}
      else
        check_intVal(a_intExprMinus->get_term2());
    }
}

/********************************************************************/

void check_intExprNegat(
 intExprNegat * a_intExprNegat)
{
  if (a_intExprNegat->get_x())
    {
      if (!findString("x", intExprNegatAtts))
	{warnAtt("x", "intExprNegat", a_intExprNegat);}
      else
        check_intVal(a_intExprNegat->get_x());
    }
}

/********************************************************************/

void check_intExprParen(
 intExprParen * a_intExprParen)
{
  if (a_intExprParen->get_x())
    {
      if (!findString("x", intExprParenAtts))
	{warnAtt("x", "intExprParen", a_intExprParen);}
      else
        check_intVal(a_intExprParen->get_x());
    }
}

/********************************************************************/

void check_intExprPlus(
 intExprPlus * a_intExprPlus)
{
  if (a_intExprPlus->get_term1())
    {
      if (!findString("term1", intExprPlusAtts))
	{warnAtt("term1", "intExprPlus", a_intExprPlus);}
      else
        check_intVal(a_intExprPlus->get_term1());
    }
  if (a_intExprPlus->get_term2())
    {
      if (!findString("term2", intExprPlusAtts))
	{warnAtt("term2", "intExprPlus", a_intExprPlus);}
      else
        check_intVal(a_intExprPlus->get_term2());
    }
}

/********************************************************************/

void check_intExprPosit(
 intExprPosit * a_intExprPosit)
{
  if (a_intExprPosit->get_x())
    {
      if (!findString("x", intExprPositAtts))
	{warnAtt("x", "intExprPosit", a_intExprPosit);}
      else
        check_intVal(a_intExprPosit->get_x());
    }
}

/********************************************************************/

void check_intExprPower(
 intExprPower * a_intExprPower)
{
  if (a_intExprPower->get_base())
    {
      if (!findString("base", intExprPowerAtts))
	{warnAtt("base", "intExprPower", a_intExprPower);}
      else
        check_intVal(a_intExprPower->get_base());
    }
  if (a_intExprPower->get_expon())
    {
      if (!findString("expon", intExprPowerAtts))
	{warnAtt("expon", "intExprPower", a_intExprPower);}
      else
        check_intVal(a_intExprPower->get_expon());
    }
}

/********************************************************************/

void check_intExprTimes(
 intExprTimes * a_intExprTimes)
{
  if (a_intExprTimes->get_term1())
    {
      if (!findString("term1", intExprTimesAtts))
	{warnAtt("term1", "intExprTimes", a_intExprTimes);}
      else
        check_intVal(a_intExprTimes->get_term1());
    }
  if (a_intExprTimes->get_term2())
    {
      if (!findString("term2", intExprTimesAtts))
	{warnAtt("term2", "intExprTimes", a_intExprTimes);}
      else
        check_intVal(a_intExprTimes->get_term2());
    }
}

/********************************************************************/

void check_intFunc(
 intFunc * a_intFunc)
{
  if (isA(a_intFunc, intFuncAbs))
    {
      if (!findString("intFuncAbs", intFuncSubs))
        {warnSub("intFuncAbs", "intFunc", a_intFunc);}
      else
        check_intFuncAbs(dynamic_cast<intFuncAbs *>(a_intFunc));
      return;
    }
  if (isA(a_intFunc, intFuncIndx))
    {
      if (!findString("intFuncIndx", intFuncSubs))
        {warnSub("intFuncIndx", "intFunc", a_intFunc);}
      else
        check_intFuncIndx(dynamic_cast<intFuncIndx *>(a_intFunc));
      return;
    }
  if (isA(a_intFunc, intFuncInt))
    {
      if (!findString("intFuncInt", intFuncSubs))
        {warnSub("intFuncInt", "intFunc", a_intFunc);}
      else
        check_intFuncInt(dynamic_cast<intFuncInt *>(a_intFunc));
      return;
    }
  if (isA(a_intFunc, intFuncLen))
    {
      if (!findString("intFuncLen", intFuncSubs))
        {warnSub("intFuncLen", "intFunc", a_intFunc);}
      else
        check_intFuncLen(dynamic_cast<intFuncLen *>(a_intFunc));
      return;
    }
  if (isA(a_intFunc, intFuncMod))
    {
      if (!findString("intFuncMod", intFuncSubs))
        {warnSub("intFuncMod", "intFunc", a_intFunc);}
      else
        check_intFuncMod(dynamic_cast<intFuncMod *>(a_intFunc));
      return;
    }
  if (isA(a_intFunc, intFuncNint))
    {
      if (!findString("intFuncNint", intFuncSubs))
        {warnSub("intFuncNint", "intFunc", a_intFunc);}
      else
        check_intFuncNint(dynamic_cast<intFuncNint *>(a_intFunc));
      return;
    }
  if (isA(a_intFunc, intFuncOrd))
    {
      if (!findString("intFuncOrd", intFuncSubs))
        {warnSub("intFuncOrd", "intFunc", a_intFunc);}
      else
        check_intFuncOrd(dynamic_cast<intFuncOrd *>(a_intFunc));
      return;
    }
  if (isA(a_intFunc, intFuncPtdata))
    {
      if (!findString("intFuncPtdata", intFuncSubs))
        {warnSub("intFuncPtdata", "intFunc", a_intFunc);}
      else
        check_intFuncPtdata(dynamic_cast<intFuncPtdata *>(a_intFunc));
      return;
    }
  if (isA(a_intFunc, intFuncSensnotouch))
    {
      if (!findString("intFuncSensnotouch", intFuncSubs))
        {warnSub("intFuncSensnotouch", "intFunc", a_intFunc);}
      return;
    }
  if (isA(a_intFunc, intFuncSign))
    {
      if (!findString("intFuncSign", intFuncSubs))
        {warnSub("intFuncSign", "intFunc", a_intFunc);}
      else
        check_intFuncSign(dynamic_cast<intFuncSign *>(a_intFunc));
      return;
    }
  if (isA(a_intFunc, intFuncSiltch))
    {
      if (!findString("intFuncSiltch", intFuncSubs))
        {warnSub("intFuncSiltch", "intFunc", a_intFunc);}
      return;
    }
}

/********************************************************************/

void check_intFuncAbs(
 intFuncAbs * a_intFuncAbs)
{
  if (a_intFuncAbs->get_x())
    {
      if (!findString("x", intFuncAbsAtts))
	{warnAtt("x", "intFuncAbs", a_intFuncAbs);}
      else
        check_intVal(a_intFuncAbs->get_x());
    }
}

/********************************************************************/

void check_intFuncIndx(
 intFuncIndx * a_intFuncIndx)
{
  if (a_intFuncIndx->get_str())
    {
      if (!findString("str", intFuncIndxAtts))
	{warnAtt("str", "intFuncIndx", a_intFuncIndx);}
      else
        check_stringVal(a_intFuncIndx->get_str());
    }
  if (a_intFuncIndx->get_sstr())
    {
      if (!findString("sstr", intFuncIndxAtts))
	{warnAtt("sstr", "intFuncIndx", a_intFuncIndx);}
      else
        check_stringVal(a_intFuncIndx->get_sstr());
    }
}

/********************************************************************/

void check_intFuncInt(
 intFuncInt * a_intFuncInt)
{
  if (a_intFuncInt->get_realVal())
    {
      if (!findString("a_realVal", intFuncIntAtts))
	{warnAtt("a_realVal", "intFuncInt", a_intFuncInt);}
      else
        check_realVal(a_intFuncInt->get_realVal());
    }
}

/********************************************************************/

void check_intFuncLen(
 intFuncLen * a_intFuncLen)
{
  if (a_intFuncLen->get_str())
    {
      if (!findString("str", intFuncLenAtts))
	{warnAtt("str", "intFuncLen", a_intFuncLen);}
      else
        check_stringVal(a_intFuncLen->get_str());
    }
}

/********************************************************************/

void check_intFuncMod(
 intFuncMod * a_intFuncMod)
{
  if (a_intFuncMod->get_num())
    {
      if (!findString("num", intFuncModAtts))
	{warnAtt("num", "intFuncMod", a_intFuncMod);}
      else
        check_intVal(a_intFuncMod->get_num());
    }
  if (a_intFuncMod->get_dvisr())
    {
      if (!findString("dvisr", intFuncModAtts))
	{warnAtt("dvisr", "intFuncMod", a_intFuncMod);}
      else
        check_intVal(a_intFuncMod->get_dvisr());
    }
}

/********************************************************************/

void check_intFuncNint(
 intFuncNint * a_intFuncNint)
{
  if (a_intFuncNint->get_realVal())
    {
      if (!findString("a_realVal", intFuncNintAtts))
	{warnAtt("a_realVal", "intFuncNint", a_intFuncNint);}
      else
        check_realVal(a_intFuncNint->get_realVal());
    }
}

/********************************************************************/

void check_intFuncOrd(
 intFuncOrd * a_intFuncOrd)
{
  if (isA(a_intFuncOrd, intFuncOrd_stringVal))
    {
      if (!findString("intFuncOrd_stringVal", intFuncOrdSubs))
        {warnSub("intFuncOrd_stringVal", "intFuncOrd", a_intFuncOrd);}
      else
        check_intFuncOrd_stringVal(dynamic_cast<intFuncOrd_stringVal *>(a_intFuncOrd));
      return;
    }
  if (isA(a_intFuncOrd, intFuncOrd_boolVal))
    {
      if (!findString("intFuncOrd_boolVal", intFuncOrdSubs))
        {warnSub("intFuncOrd_boolVal", "intFuncOrd", a_intFuncOrd);}
      else
        check_intFuncOrd_boolVal(dynamic_cast<intFuncOrd_boolVal *>(a_intFuncOrd));
      return;
    }
}

/********************************************************************/

void check_intFuncOrd_boolVal(
 intFuncOrd_boolVal * a_intFuncOrd_boolVal)
{
  if (a_intFuncOrd_boolVal->get_boolVal())
    {
      if (!findString("a_boolVal", intFuncOrd_boolValAtts))
	{warnAtt("a_boolVal", "intFuncOrd_boolVal", a_intFuncOrd_boolVal);}
      else
        check_boolVal(a_intFuncOrd_boolVal->get_boolVal());
    }
}

/********************************************************************/

void check_intFuncOrd_stringVal(
 intFuncOrd_stringVal * a_intFuncOrd_stringVal)
{
  if (a_intFuncOrd_stringVal->get_str())
    {
      if (!findString("str", intFuncOrd_stringValAtts))
	{warnAtt("str", "intFuncOrd_stringVal", a_intFuncOrd_stringVal);}
      else
        check_stringVal(a_intFuncOrd_stringVal->get_str());
    }
}

/********************************************************************/

void check_intFuncPtdata(
 intFuncPtdata * a_intFuncPtdata)
{
  if (a_intFuncPtdata->get_faLabel())
    {
      if (!findString("a_faLabel", intFuncPtdataAtts))
	{warnAtt("a_faLabel", "intFuncPtdata", a_intFuncPtdata);}
      else
        check_faLabel(a_intFuncPtdata->get_faLabel());
    }
}

/********************************************************************/

void check_intFuncSign(
 intFuncSign * a_intFuncSign)
{
  if (a_intFuncSign->get_x())
    {
      if (!findString("x", intFuncSignAtts))
	{warnAtt("x", "intFuncSign", a_intFuncSign);}
      else
        check_intVal(a_intFuncSign->get_x());
    }
  if (a_intFuncSign->get_y())
    {
      if (!findString("y", intFuncSignAtts))
	{warnAtt("y", "intFuncSign", a_intFuncSign);}
      else
        check_intVal(a_intFuncSign->get_y());
    }
}

/********************************************************************/

void check_intRealExpr(
 intRealExpr * a_intRealExpr)
{
  if (isA(a_intRealExpr, intRealExpr_PLUS))
    {
      if (!findString("intRealExpr_PLUS", intRealExprSubs))
        {warnSub("intRealExpr_PLUS", "intRealExpr", a_intRealExpr);}
      else
        check_intRealExpr_PLUS(dynamic_cast<intRealExpr_PLUS *>(a_intRealExpr));
      return;
    }
  if (isA(a_intRealExpr, intRealExpr_MINUS))
    {
      if (!findString("intRealExpr_MINUS", intRealExprSubs))
        {warnSub("intRealExpr_MINUS", "intRealExpr", a_intRealExpr);}
      else
        check_intRealExpr_MINUS(dynamic_cast<intRealExpr_MINUS *>(a_intRealExpr));
      return;
    }
  if (isA(a_intRealExpr, intRealExpr_TIMES))
    {
      if (!findString("intRealExpr_TIMES", intRealExprSubs))
        {warnSub("intRealExpr_TIMES", "intRealExpr", a_intRealExpr);}
      else
        check_intRealExpr_TIMES(dynamic_cast<intRealExpr_TIMES *>(a_intRealExpr));
      return;
    }
  if (isA(a_intRealExpr, intRealExpr_DIVID))
    {
      if (!findString("intRealExpr_DIVID", intRealExprSubs))
        {warnSub("intRealExpr_DIVID", "intRealExpr", a_intRealExpr);}
      else
        check_intRealExpr_DIVID(dynamic_cast<intRealExpr_DIVID *>(a_intRealExpr));
      return;
    }
  if (isA(a_intRealExpr, intRealExpr_POWER))
    {
      if (!findString("intRealExpr_POWER", intRealExprSubs))
        {warnSub("intRealExpr_POWER", "intRealExpr", a_intRealExpr);}
      else
        check_intRealExpr_POWER(dynamic_cast<intRealExpr_POWER *>(a_intRealExpr));
      return;
    }
}

/********************************************************************/

void check_intRealExpr_DIVID(
 intRealExpr_DIVID * a_intRealExpr_DIVID)
{
  if (a_intRealExpr_DIVID->get_dvend())
    {
      if (!findString("dvend", intRealExpr_DIVIDAtts))
	{warnAtt("dvend", "intRealExpr_DIVID", a_intRealExpr_DIVID);}
      else
        check_intVal(a_intRealExpr_DIVID->get_dvend());
    }
  if (a_intRealExpr_DIVID->get_dvisr())
    {
      if (!findString("dvisr", intRealExpr_DIVIDAtts))
	{warnAtt("dvisr", "intRealExpr_DIVID", a_intRealExpr_DIVID);}
      else
        check_realVal(a_intRealExpr_DIVID->get_dvisr());
    }
}

/********************************************************************/

void check_intRealExpr_MINUS(
 intRealExpr_MINUS * a_intRealExpr_MINUS)
{
  if (a_intRealExpr_MINUS->get_term1())
    {
      if (!findString("term1", intRealExpr_MINUSAtts))
	{warnAtt("term1", "intRealExpr_MINUS", a_intRealExpr_MINUS);}
      else
        check_intVal(a_intRealExpr_MINUS->get_term1());
    }
  if (a_intRealExpr_MINUS->get_term2())
    {
      if (!findString("term2", intRealExpr_MINUSAtts))
	{warnAtt("term2", "intRealExpr_MINUS", a_intRealExpr_MINUS);}
      else
        check_realVal(a_intRealExpr_MINUS->get_term2());
    }
}

/********************************************************************/

void check_intRealExpr_PLUS(
 intRealExpr_PLUS * a_intRealExpr_PLUS)
{
  if (a_intRealExpr_PLUS->get_term1())
    {
      if (!findString("term1", intRealExpr_PLUSAtts))
	{warnAtt("term1", "intRealExpr_PLUS", a_intRealExpr_PLUS);}
      else
        check_intVal(a_intRealExpr_PLUS->get_term1());
    }
  if (a_intRealExpr_PLUS->get_term2())
    {
      if (!findString("term2", intRealExpr_PLUSAtts))
	{warnAtt("term2", "intRealExpr_PLUS", a_intRealExpr_PLUS);}
      else
        check_realVal(a_intRealExpr_PLUS->get_term2());
    }
}

/********************************************************************/

void check_intRealExpr_POWER(
 intRealExpr_POWER * a_intRealExpr_POWER)
{
  if (a_intRealExpr_POWER->get_base())
    {
      if (!findString("base", intRealExpr_POWERAtts))
	{warnAtt("base", "intRealExpr_POWER", a_intRealExpr_POWER);}
      else
        check_intVal(a_intRealExpr_POWER->get_base());
    }
  if (a_intRealExpr_POWER->get_expon())
    {
      if (!findString("expon", intRealExpr_POWERAtts))
	{warnAtt("expon", "intRealExpr_POWER", a_intRealExpr_POWER);}
      else
        check_realVal(a_intRealExpr_POWER->get_expon());
    }
}

/********************************************************************/

void check_intRealExpr_TIMES(
 intRealExpr_TIMES * a_intRealExpr_TIMES)
{
  if (a_intRealExpr_TIMES->get_term1())
    {
      if (!findString("term1", intRealExpr_TIMESAtts))
	{warnAtt("term1", "intRealExpr_TIMES", a_intRealExpr_TIMES);}
      else
        check_intVal(a_intRealExpr_TIMES->get_term1());
    }
  if (a_intRealExpr_TIMES->get_term2())
    {
      if (!findString("term2", intRealExpr_TIMESAtts))
	{warnAtt("term2", "intRealExpr_TIMES", a_intRealExpr_TIMES);}
      else
        check_realVal(a_intRealExpr_TIMES->get_term2());
    }
}

/********************************************************************/

void check_intRealRel(
 intRealRel * a_intRealRel)
{
  if (isA(a_intRealRel, intRealRel_EQ))
    {
      if (!findString("intRealRel_EQ", intRealRelSubs))
        {warnSub("intRealRel_EQ", "intRealRel", a_intRealRel);}
      else
        check_intRealRel_EQ(dynamic_cast<intRealRel_EQ *>(a_intRealRel));
      return;
    }
  if (isA(a_intRealRel, intRealRel_NE))
    {
      if (!findString("intRealRel_NE", intRealRelSubs))
        {warnSub("intRealRel_NE", "intRealRel", a_intRealRel);}
      else
        check_intRealRel_NE(dynamic_cast<intRealRel_NE *>(a_intRealRel));
      return;
    }
  if (isA(a_intRealRel, intRealRel_LT))
    {
      if (!findString("intRealRel_LT", intRealRelSubs))
        {warnSub("intRealRel_LT", "intRealRel", a_intRealRel);}
      else
        check_intRealRel_LT(dynamic_cast<intRealRel_LT *>(a_intRealRel));
      return;
    }
  if (isA(a_intRealRel, intRealRel_LE))
    {
      if (!findString("intRealRel_LE", intRealRelSubs))
        {warnSub("intRealRel_LE", "intRealRel", a_intRealRel);}
      else
        check_intRealRel_LE(dynamic_cast<intRealRel_LE *>(a_intRealRel));
      return;
    }
  if (isA(a_intRealRel, intRealRel_GT))
    {
      if (!findString("intRealRel_GT", intRealRelSubs))
        {warnSub("intRealRel_GT", "intRealRel", a_intRealRel);}
      else
        check_intRealRel_GT(dynamic_cast<intRealRel_GT *>(a_intRealRel));
      return;
    }
  if (isA(a_intRealRel, intRealRel_GE))
    {
      if (!findString("intRealRel_GE", intRealRelSubs))
        {warnSub("intRealRel_GE", "intRealRel", a_intRealRel);}
      else
        check_intRealRel_GE(dynamic_cast<intRealRel_GE *>(a_intRealRel));
      return;
    }
}

/********************************************************************/

void check_intRealRel_EQ(
 intRealRel_EQ * a_intRealRel_EQ)
{
  if (a_intRealRel_EQ->get_left())
    {
      if (!findString("left", intRealRel_EQAtts))
	{warnAtt("left", "intRealRel_EQ", a_intRealRel_EQ);}
      else
        check_intVal(a_intRealRel_EQ->get_left());
    }
  if (a_intRealRel_EQ->get_right())
    {
      if (!findString("right", intRealRel_EQAtts))
	{warnAtt("right", "intRealRel_EQ", a_intRealRel_EQ);}
      else
        check_realVal(a_intRealRel_EQ->get_right());
    }
}

/********************************************************************/

void check_intRealRel_GE(
 intRealRel_GE * a_intRealRel_GE)
{
  if (a_intRealRel_GE->get_left())
    {
      if (!findString("left", intRealRel_GEAtts))
	{warnAtt("left", "intRealRel_GE", a_intRealRel_GE);}
      else
        check_intVal(a_intRealRel_GE->get_left());
    }
  if (a_intRealRel_GE->get_right())
    {
      if (!findString("right", intRealRel_GEAtts))
	{warnAtt("right", "intRealRel_GE", a_intRealRel_GE);}
      else
        check_realVal(a_intRealRel_GE->get_right());
    }
}

/********************************************************************/

void check_intRealRel_GT(
 intRealRel_GT * a_intRealRel_GT)
{
  if (a_intRealRel_GT->get_left())
    {
      if (!findString("left", intRealRel_GTAtts))
	{warnAtt("left", "intRealRel_GT", a_intRealRel_GT);}
      else
        check_intVal(a_intRealRel_GT->get_left());
    }
  if (a_intRealRel_GT->get_right())
    {
      if (!findString("right", intRealRel_GTAtts))
	{warnAtt("right", "intRealRel_GT", a_intRealRel_GT);}
      else
        check_realVal(a_intRealRel_GT->get_right());
    }
}

/********************************************************************/

void check_intRealRel_LE(
 intRealRel_LE * a_intRealRel_LE)
{
  if (a_intRealRel_LE->get_left())
    {
      if (!findString("left", intRealRel_LEAtts))
	{warnAtt("left", "intRealRel_LE", a_intRealRel_LE);}
      else
        check_intVal(a_intRealRel_LE->get_left());
    }
  if (a_intRealRel_LE->get_right())
    {
      if (!findString("right", intRealRel_LEAtts))
	{warnAtt("right", "intRealRel_LE", a_intRealRel_LE);}
      else
        check_realVal(a_intRealRel_LE->get_right());
    }
}

/********************************************************************/

void check_intRealRel_LT(
 intRealRel_LT * a_intRealRel_LT)
{
  if (a_intRealRel_LT->get_left())
    {
      if (!findString("left", intRealRel_LTAtts))
	{warnAtt("left", "intRealRel_LT", a_intRealRel_LT);}
      else
        check_intVal(a_intRealRel_LT->get_left());
    }
  if (a_intRealRel_LT->get_right())
    {
      if (!findString("right", intRealRel_LTAtts))
	{warnAtt("right", "intRealRel_LT", a_intRealRel_LT);}
      else
        check_realVal(a_intRealRel_LT->get_right());
    }
}

/********************************************************************/

void check_intRealRel_NE(
 intRealRel_NE * a_intRealRel_NE)
{
  if (a_intRealRel_NE->get_left())
    {
      if (!findString("left", intRealRel_NEAtts))
	{warnAtt("left", "intRealRel_NE", a_intRealRel_NE);}
      else
        check_intVal(a_intRealRel_NE->get_left());
    }
  if (a_intRealRel_NE->get_right())
    {
      if (!findString("right", intRealRel_NEAtts))
	{warnAtt("right", "intRealRel_NE", a_intRealRel_NE);}
      else
        check_realVal(a_intRealRel_NE->get_right());
    }
}

/********************************************************************/

void check_intRel(
 intRel * a_intRel)
{
  if (isA(a_intRel, intRel_EQ))
    {
      if (!findString("intRel_EQ", intRelSubs))
        {warnSub("intRel_EQ", "intRel", a_intRel);}
      else
        check_intRel_EQ(dynamic_cast<intRel_EQ *>(a_intRel));
      return;
    }
  if (isA(a_intRel, intRel_NE))
    {
      if (!findString("intRel_NE", intRelSubs))
        {warnSub("intRel_NE", "intRel", a_intRel);}
      else
        check_intRel_NE(dynamic_cast<intRel_NE *>(a_intRel));
      return;
    }
  if (isA(a_intRel, intRel_LT))
    {
      if (!findString("intRel_LT", intRelSubs))
        {warnSub("intRel_LT", "intRel", a_intRel);}
      else
        check_intRel_LT(dynamic_cast<intRel_LT *>(a_intRel));
      return;
    }
  if (isA(a_intRel, intRel_LE))
    {
      if (!findString("intRel_LE", intRelSubs))
        {warnSub("intRel_LE", "intRel", a_intRel);}
      else
        check_intRel_LE(dynamic_cast<intRel_LE *>(a_intRel));
      return;
    }
  if (isA(a_intRel, intRel_GT))
    {
      if (!findString("intRel_GT", intRelSubs))
        {warnSub("intRel_GT", "intRel", a_intRel);}
      else
        check_intRel_GT(dynamic_cast<intRel_GT *>(a_intRel));
      return;
    }
  if (isA(a_intRel, intRel_GE))
    {
      if (!findString("intRel_GE", intRelSubs))
        {warnSub("intRel_GE", "intRel", a_intRel);}
      else
        check_intRel_GE(dynamic_cast<intRel_GE *>(a_intRel));
      return;
    }
}

/********************************************************************/

void check_intRel_EQ(
 intRel_EQ * a_intRel_EQ)
{
  if (a_intRel_EQ->get_left())
    {
      if (!findString("left", intRel_EQAtts))
	{warnAtt("left", "intRel_EQ", a_intRel_EQ);}
      else
        check_intVal(a_intRel_EQ->get_left());
    }
  if (a_intRel_EQ->get_right())
    {
      if (!findString("right", intRel_EQAtts))
	{warnAtt("right", "intRel_EQ", a_intRel_EQ);}
      else
        check_intVal(a_intRel_EQ->get_right());
    }
}

/********************************************************************/

void check_intRel_GE(
 intRel_GE * a_intRel_GE)
{
  if (a_intRel_GE->get_left())
    {
      if (!findString("left", intRel_GEAtts))
	{warnAtt("left", "intRel_GE", a_intRel_GE);}
      else
        check_intVal(a_intRel_GE->get_left());
    }
  if (a_intRel_GE->get_right())
    {
      if (!findString("right", intRel_GEAtts))
	{warnAtt("right", "intRel_GE", a_intRel_GE);}
      else
        check_intVal(a_intRel_GE->get_right());
    }
}

/********************************************************************/

void check_intRel_GT(
 intRel_GT * a_intRel_GT)
{
  if (a_intRel_GT->get_left())
    {
      if (!findString("left", intRel_GTAtts))
	{warnAtt("left", "intRel_GT", a_intRel_GT);}
      else
        check_intVal(a_intRel_GT->get_left());
    }
  if (a_intRel_GT->get_right())
    {
      if (!findString("right", intRel_GTAtts))
	{warnAtt("right", "intRel_GT", a_intRel_GT);}
      else
        check_intVal(a_intRel_GT->get_right());
    }
}

/********************************************************************/

void check_intRel_LE(
 intRel_LE * a_intRel_LE)
{
  if (a_intRel_LE->get_left())
    {
      if (!findString("left", intRel_LEAtts))
	{warnAtt("left", "intRel_LE", a_intRel_LE);}
      else
        check_intVal(a_intRel_LE->get_left());
    }
  if (a_intRel_LE->get_right())
    {
      if (!findString("right", intRel_LEAtts))
	{warnAtt("right", "intRel_LE", a_intRel_LE);}
      else
        check_intVal(a_intRel_LE->get_right());
    }
}

/********************************************************************/

void check_intRel_LT(
 intRel_LT * a_intRel_LT)
{
  if (a_intRel_LT->get_left())
    {
      if (!findString("left", intRel_LTAtts))
	{warnAtt("left", "intRel_LT", a_intRel_LT);}
      else
        check_intVal(a_intRel_LT->get_left());
    }
  if (a_intRel_LT->get_right())
    {
      if (!findString("right", intRel_LTAtts))
	{warnAtt("right", "intRel_LT", a_intRel_LT);}
      else
        check_intVal(a_intRel_LT->get_right());
    }
}

/********************************************************************/

void check_intRel_NE(
 intRel_NE * a_intRel_NE)
{
  if (a_intRel_NE->get_left())
    {
      if (!findString("left", intRel_NEAtts))
	{warnAtt("left", "intRel_NE", a_intRel_NE);}
      else
        check_intVal(a_intRel_NE->get_left());
    }
  if (a_intRel_NE->get_right())
    {
      if (!findString("right", intRel_NEAtts))
	{warnAtt("right", "intRel_NE", a_intRel_NE);}
      else
        check_intVal(a_intRel_NE->get_right());
    }
}

/********************************************************************/

void check_intVal(
 intVal * a_intVal)
{
  if (isA(a_intVal, intConst))
    {
      if (!findString("intConst", intValSubs))
        {warnSub("intConst", "intVal", a_intVal);}
      else
        check_intConst(dynamic_cast<intConst *>(a_intVal));
      return;
    }
  if (isA(a_intVal, intExpr))
    {
      if (!findString("intExpr", intValSubs))
        {warnSub("intExpr", "intVal", a_intVal);}
      else
        check_intExpr(dynamic_cast<intExpr *>(a_intVal));
      return;
    }
  if (isA(a_intVal, intFunc))
    {
      if (!findString("intFunc", intValSubs))
        {warnSub("intFunc", "intVal", a_intVal);}
      else
        check_intFunc(dynamic_cast<intFunc *>(a_intVal));
      return;
    }
  if (isA(a_intVal, intVar))
    {
      if (!findString("intVar", intValSubs))
        {warnSub("intVar", "intVal", a_intVal);}
      else
        check_intVar(dynamic_cast<intVar *>(a_intVal));
      return;
    }
}

/********************************************************************/

void check_intVar(
 intVar * a_intVar)
{
  if (a_intVar->get_string())
    {
      if (!findString("a_string", intVarAtts))
	{warnAtt("a_string", "intVar", a_intVar);}
    }
  if (a_intVar->get_arrayIndex())
    {
      if (!findString("a_arrayIndex", intVarAtts))
	{warnAtt("a_arrayIndex", "intVar", a_intVar);}
      else
        check_arrayIndex(a_intVar->get_arrayIndex());
    }
}

/********************************************************************/

void check_intVecExpr_TIMES(
 intVecExpr_TIMES * a_intVecExpr_TIMES)
{
  if (a_intVecExpr_TIMES->get_term1())
    {
      if (!findString("term1", intVecExpr_TIMESAtts))
	{warnAtt("term1", "intVecExpr_TIMES", a_intVecExpr_TIMES);}
      else
        check_intVal(a_intVecExpr_TIMES->get_term1());
    }
  if (a_intVecExpr_TIMES->get_term2())
    {
      if (!findString("term2", intVecExpr_TIMESAtts))
	{warnAtt("term2", "intVecExpr_TIMES", a_intVecExpr_TIMES);}
      else
        check_vectorVal(a_intVecExpr_TIMES->get_term2());
    }
}

/********************************************************************/

void check_intofConst(
 intofConst * a_intofConst)
{
  if (a_intofConst->get_faLabel())
    {
      if (!findString("a_faLabel", intofConstAtts))
	{warnAtt("a_faLabel", "intofConst", a_intofConst);}
      else
        check_faLabel(a_intofConst->get_faLabel());
    }
  if (a_intofConst->get_featureLabel())
    {
      if (!findString("a_featureLabel", intofConstAtts))
	{warnAtt("a_featureLabel", "intofConst", a_intofConst);}
      else
        check_featureLabel(a_intofConst->get_featureLabel());
    }
}

/********************************************************************/

void check_iteratConvergence(
 iteratConvergence * a_iteratConvergence)
{
  if (isA(a_iteratConvergence, iteratConvergence_ABSL))
    {
      if (!findString("iteratConvergence_ABSL", iteratConvergenceSubs))
        {warnSub("iteratConvergence_ABSL", "iteratConvergence", a_iteratConvergence);}
      else
        check_iteratConvergence_ABSL(dynamic_cast<iteratConvergence_ABSL *>(a_iteratConvergence));
      return;
    }
  if (isA(a_iteratConvergence, iteratConvergence_INCR))
    {
      if (!findString("iteratConvergence_INCR", iteratConvergenceSubs))
        {warnSub("iteratConvergence_INCR", "iteratConvergence", a_iteratConvergence);}
      else
        check_iteratConvergence_INCR(dynamic_cast<iteratConvergence_INCR *>(a_iteratConvergence));
      return;
    }
}

/********************************************************************/

void check_iteratConvergence_ABSL(
 iteratConvergence_ABSL * a_iteratConvergence_ABSL)
{
  if (a_iteratConvergence_ABSL->get_converg())
    {
      if (!findString("converg", iteratConvergence_ABSLAtts))
	{warnAtt("converg", "iteratConvergence_ABSL", a_iteratConvergence_ABSL);}
      else
        check_rentVal(a_iteratConvergence_ABSL->get_converg());
    }
}

/********************************************************************/

void check_iteratConvergence_INCR(
 iteratConvergence_INCR * a_iteratConvergence_INCR)
{
  if (a_iteratConvergence_INCR->get_converg())
    {
      if (!findString("converg", iteratConvergence_INCRAtts))
	{warnAtt("converg", "iteratConvergence_INCR", a_iteratConvergence_INCR);}
      else
        check_rentVal(a_iteratConvergence_INCR->get_converg());
    }
}

/********************************************************************/

void check_iteratCriterionItem(
 iteratCriterionItem * a_iteratCriterionItem)
{
  if (a_iteratCriterionItem->get_iteratCriterionStart())
    {
      if (!findString("a_iteratCriterionStart", iteratCriterionItemAtts))
	{warnAtt("a_iteratCriterionStart", "iteratCriterionItem", a_iteratCriterionItem);}
      else
        check_iteratCriterionStart(a_iteratCriterionItem->get_iteratCriterionStart());
    }
  if (a_iteratCriterionItem->get_featureActualList())
    {
      if (!findString("a_featureActualList", iteratCriterionItemAtts))
	{warnAtt("a_featureActualList", "iteratCriterionItem", a_iteratCriterionItem);}
      else
        {
          std::list<faLabel *> * theList;
          std::list<faLabel *>::iterator iter;
          theList = a_iteratCriterionItem->get_featureActualList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_faLabel(*iter);
        }
    }
}

/********************************************************************/

void check_iteratCriterionStart(
 iteratCriterionStart * a_iteratCriterionStart)
{
  if (isA(a_iteratCriterionStart, iteratCriterionStart_axis))
    {
      if (!findString("iteratCriterionStart_axis", iteratCriterionStartSubs))
        {warnSub("iteratCriterionStart_axis", "iteratCriterionStart", a_iteratCriterionStart);}
      else
        check_iteratCriterionStart_axis(dynamic_cast<iteratCriterionStart_axis *>(a_iteratCriterionStart));
      return;
    }
  if (isA(a_iteratCriterionStart, iteratCriterionStart_vector))
    {
      if (!findString("iteratCriterionStart_vector", iteratCriterionStartSubs))
        {warnSub("iteratCriterionStart_vector", "iteratCriterionStart", a_iteratCriterionStart);}
      else
        check_iteratCriterionStart_vector(dynamic_cast<iteratCriterionStart_vector *>(a_iteratCriterionStart));
      return;
    }
  if (isA(a_iteratCriterionStart, iteratCriterionStart_NOM))
    {
      if (!findString("iteratCriterionStart_NOM", iteratCriterionStartSubs))
        {warnSub("iteratCriterionStart_NOM", "iteratCriterionStart", a_iteratCriterionStart);}
      return;
    }
}

/********************************************************************/

void check_iteratCriterionStart_axis(
 iteratCriterionStart_axis * a_iteratCriterionStart_axis)
{
  if (a_iteratCriterionStart_axis->get_axis())
    {
      if (!findString("a_axis", iteratCriterionStart_axisAtts))
	{warnAtt("a_axis", "iteratCriterionStart_axis", a_iteratCriterionStart_axis);}
      else
        check_axis(a_iteratCriterionStart_axis->get_axis());
    }
}

/********************************************************************/

void check_iteratCriterionStart_vector(
 iteratCriterionStart_vector * a_iteratCriterionStart_vector)
{
  if (a_iteratCriterionStart_vector->get_dir())
    {
      if (!findString("dir", iteratCriterionStart_vectorAtts))
	{warnAtt("dir", "iteratCriterionStart_vector", a_iteratCriterionStart_vector);}
      else
        check_vector(a_iteratCriterionStart_vector->get_dir());
    }
}

/********************************************************************/

void check_iteratMinor(
 iteratMinor * a_iteratMinor)
{
  if (a_iteratMinor->get_start())
    {
      if (!findString("start", iteratMinorAtts))
	{warnAtt("start", "iteratMinor", a_iteratMinor);}
      else
        check_jumpLabel(a_iteratMinor->get_start());
    }
  if (a_iteratMinor->get_fail())
    {
      if (!findString("fail", iteratMinorAtts))
	{warnAtt("fail", "iteratMinor", a_iteratMinor);}
      else
        check_jumpLabel(a_iteratMinor->get_fail());
    }
  if (a_iteratMinor->get_iteratConvergence())
    {
      if (!findString("a_iteratConvergence", iteratMinorAtts))
	{warnAtt("a_iteratConvergence", "iteratMinor", a_iteratMinor);}
      else
        check_iteratConvergence(a_iteratMinor->get_iteratConvergence());
    }
  if (a_iteratMinor->get_limit())
    {
      if (!findString("limit", iteratMinorAtts))
	{warnAtt("limit", "iteratMinor", a_iteratMinor);}
      else
        check_intVal(a_iteratMinor->get_limit());
    }
  if (a_iteratMinor->get_iteratCriterionList())
    {
      if (!findString("a_iteratCriterionList", iteratMinorAtts))
	{warnAtt("a_iteratCriterionList", "iteratMinor", a_iteratMinor);}
      else
        {
          std::list<iteratCriterionItem *> * theList;
          std::list<iteratCriterionItem *>::iterator iter;
          theList = a_iteratMinor->get_iteratCriterionList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_iteratCriterionItem(*iter);
        }
    }
}

/********************************************************************/

void check_iteratStm(
 iteratStm * a_iteratStm)
{
  if (a_iteratStm->get_realVar())
    {
      if (!findString("a_realVar", iteratStmAtts))
	{warnAtt("a_realVar", "iteratStm", a_iteratStm);}
      else
        check_realVar(a_iteratStm->get_realVar());
    }
  if (a_iteratStm->get_iteratMinor())
    {
      if (!findString("a_iteratMinor", iteratStmAtts))
	{warnAtt("a_iteratMinor", "iteratStm", a_iteratStm);}
      else
        check_iteratMinor(a_iteratStm->get_iteratMinor());
    }
}

/********************************************************************/

void check_jointConf(
 jointConf * a_jointConf)
{
  if (a_jointConf->get_rightyLefty())
    {
      if (!findString("a_rightyLefty", jointConfAtts))
	{warnAtt("a_rightyLefty", "jointConf", a_jointConf);}
      else
        check_rightyLefty(a_jointConf->get_rightyLefty());
    }
  if (a_jointConf->get_aboveBelow())
    {
      if (!findString("a_aboveBelow", jointConfAtts))
	{warnAtt("a_aboveBelow", "jointConf", a_jointConf);}
      else
        check_aboveBelow(a_jointConf->get_aboveBelow());
    }
  if (a_jointConf->get_flipNoFlip())
    {
      if (!findString("a_flipNoFlip", jointConfAtts))
	{warnAtt("a_flipNoFlip", "jointConf", a_jointConf);}
      else
        check_flipNoFlip(a_jointConf->get_flipNoFlip());
    }
  if (a_jointConf->get_stringList())
    {
      if (!findString("a_stringList", jointConfAtts))
	{warnAtt("a_stringList", "jointConf", a_jointConf);}
      else
        {
          std::list<stringVal *> * theList;
          std::list<stringVal *>::iterator iter;
          theList = a_jointConf->get_stringList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_stringVal(*iter);
        }
    }
}

/********************************************************************/

void check_jumpLabel(
 jumpLabel * a_jumpLabel)
{
  if (isA(a_jumpLabel, labelName))
    {
      if (!findString("labelName", jumpLabelSubs))
        {warnSub("labelName", "jumpLabel", a_jumpLabel);}
      else
        check_labelName(dynamic_cast<labelName *>(a_jumpLabel));
      return;
    }
}

/********************************************************************/

void check_jumpStm(
 jumpStm * a_jumpStm)
{
  if (a_jumpStm->get_labelNameConst())
    {
      if (!findString("a_labelNameConst", jumpStmAtts))
	{warnAtt("a_labelNameConst", "jumpStm", a_jumpStm);}
      else
        check_labelNameConst(a_jumpStm->get_labelNameConst());
    }
}

/********************************************************************/

void check_jumptoStm(
 jumptoStm * a_jumptoStm)
{
  if (a_jumptoStm->get_jumpLabel())
    {
      if (!findString("a_jumpLabel", jumptoStmAtts))
	{warnAtt("a_jumpLabel", "jumptoStm", a_jumptoStm);}
      else
        check_jumpLabel(a_jumptoStm->get_jumpLabel());
    }
}

/********************************************************************/

void check_kcLabel(
 kcLabel * a_kcLabel)
{
  if (a_kcLabel->get_labelName())
    {
      if (!findString("a_labelName", kcLabelAtts))
	{warnAtt("a_labelName", "kcLabel", a_kcLabel);}
      else
        check_labelName(a_kcLabel->get_labelName());
    }
}

/********************************************************************/

void check_kcaLabel(
 kcaLabel * a_kcaLabel)
{
  if (a_kcaLabel->get_labelName())
    {
      if (!findString("a_labelName", kcaLabelAtts))
	{warnAtt("a_labelName", "kcaLabel", a_kcaLabel);}
      else
        check_labelName(a_kcaLabel->get_labelName());
    }
}

/********************************************************************/

void check_keycharMinor(
 keycharMinor * a_keycharMinor)
{
  if (isA(a_keycharMinor, keycharOneFeature))
    {
      if (!findString("keycharOneFeature", keycharMinorSubs))
        {warnSub("keycharOneFeature", "keycharMinor", a_keycharMinor);}
      else
        check_keycharOneFeature(dynamic_cast<keycharOneFeature *>(a_keycharMinor));
      return;
    }
  if (isA(a_keycharMinor, keycharTwoFeatures))
    {
      if (!findString("keycharTwoFeatures", keycharMinorSubs))
        {warnSub("keycharTwoFeatures", "keycharMinor", a_keycharMinor);}
      else
        check_keycharTwoFeatures(dynamic_cast<keycharTwoFeatures *>(a_keycharMinor));
      return;
    }
}

/********************************************************************/

void check_keycharOneFeature(
 keycharOneFeature * a_keycharOneFeature)
{
  if (a_keycharOneFeature->get_fLabel())
    {
      if (!findString("a_fLabel", keycharOneFeatureAtts))
	{warnAtt("a_fLabel", "keycharOneFeature", a_keycharOneFeature);}
      else
        check_fLabel(a_keycharOneFeature->get_fLabel());
    }
  if (a_keycharOneFeature->get_tLabelList())
    {
      if (!findString("a_tLabelList", keycharOneFeatureAtts))
	{warnAtt("a_tLabelList", "keycharOneFeature", a_keycharOneFeature);}
      else
        {
          std::list<tLabel *> * theList;
          std::list<tLabel *>::iterator iter;
          theList = a_keycharOneFeature->get_tLabelList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_tLabel(*iter);
        }
    }
  if (a_keycharOneFeature->get_criticality())
    {
      if (!findString("a_criticality", keycharOneFeatureAtts))
	{warnAtt("a_criticality", "keycharOneFeature", a_keycharOneFeature);}
      else
        check_criticality(a_keycharOneFeature->get_criticality());
    }
}

/********************************************************************/

void check_keycharStm(
 keycharStm * a_keycharStm)
{
  if (a_keycharStm->get_kcLabel())
    {
      if (!findString("a_kcLabel", keycharStmAtts))
	{warnAtt("a_kcLabel", "keycharStm", a_keycharStm);}
      else
        check_kcLabel(a_keycharStm->get_kcLabel());
    }
  if (a_keycharStm->get_keycharMinor())
    {
      if (!findString("a_keycharMinor", keycharStmAtts))
	{warnAtt("a_keycharMinor", "keycharStm", a_keycharStm);}
      else
        check_keycharMinor(a_keycharStm->get_keycharMinor());
    }
}

/********************************************************************/

void check_keycharTwoFeatures(
 keycharTwoFeatures * a_keycharTwoFeatures)
{
  if (a_keycharTwoFeatures->get_feat1())
    {
      if (!findString("feat1", keycharTwoFeaturesAtts))
	{warnAtt("feat1", "keycharTwoFeatures", a_keycharTwoFeatures);}
      else
        check_fLabel(a_keycharTwoFeatures->get_feat1());
    }
  if (a_keycharTwoFeatures->get_feat2())
    {
      if (!findString("feat2", keycharTwoFeaturesAtts))
	{warnAtt("feat2", "keycharTwoFeatures", a_keycharTwoFeatures);}
      else
        check_fLabel(a_keycharTwoFeatures->get_feat2());
    }
  if (a_keycharTwoFeatures->get_tLabel())
    {
      if (!findString("a_tLabel", keycharTwoFeaturesAtts))
	{warnAtt("a_tLabel", "keycharTwoFeatures", a_keycharTwoFeatures);}
      else
        check_tLabel(a_keycharTwoFeatures->get_tLabel());
    }
  if (a_keycharTwoFeatures->get_criticality())
    {
      if (!findString("a_criticality", keycharTwoFeaturesAtts))
	{warnAtt("a_criticality", "keycharTwoFeatures", a_keycharTwoFeatures);}
      else
        check_criticality(a_keycharTwoFeatures->get_criticality());
    }
}

/********************************************************************/

void check_labelName(
 labelName * a_labelName)
{
  if (isA(a_labelName, labelNameCon))
    {
      if (!findString("labelNameCon", labelNameSubs))
        {warnSub("labelNameCon", "labelName", a_labelName);}
      else
        check_labelNameCon(dynamic_cast<labelNameCon *>(a_labelName));
      return;
    }
  if (isA(a_labelName, labelNameAt))
    {
      if (!findString("labelNameAt", labelNameSubs))
        {warnSub("labelNameAt", "labelName", a_labelName);}
      else
        check_labelNameAt(dynamic_cast<labelNameAt *>(a_labelName));
      return;
    }
}

/********************************************************************/

void check_labelNameAt(
 labelNameAt * a_labelNameAt)
{
  if (a_labelNameAt->get_stringVar())
    {
      if (!findString("a_stringVar", labelNameAtAtts))
	{warnAtt("a_stringVar", "labelNameAt", a_labelNameAt);}
      else
        check_stringVar(a_labelNameAt->get_stringVar());
    }
}

/********************************************************************/

void check_labelNameCon(
 labelNameCon * a_labelNameCon)
{
  if (a_labelNameCon->get_labelNameConst())
    {
      if (!findString("a_labelNameConst", labelNameConAtts))
	{warnAtt("a_labelNameConst", "labelNameCon", a_labelNameCon);}
      else
        check_labelNameConst(a_labelNameCon->get_labelNameConst());
    }
}

/********************************************************************/

void check_labelNameConst(
 labelNameConst * a_labelNameConst)
{
  if (a_labelNameConst->get_string())
    {
      if (!findString("a_string", labelNameConstAtts))
	{warnAtt("a_string", "labelNameConst", a_labelNameConst);}
    }
}

/********************************************************************/

void check_leftRight(
 leftRight * a_leftRight)
{
  if (isA(a_leftRight, leftRight_LEFT))
    {
      if (!findString("leftRight_LEFT", leftRightSubs))
        {warnSub("leftRight_LEFT", "leftRight", a_leftRight);}
      return;
    }
  if (isA(a_leftRight, leftRight_RIGHT))
    {
      if (!findString("leftRight_RIGHT", leftRightSubs))
        {warnSub("leftRight_RIGHT", "leftRight", a_leftRight);}
      return;
    }
}

/********************************************************************/

void check_lengthUnit(
 lengthUnit * a_lengthUnit)
{
  if (isA(a_lengthUnit, lengthUnit_MM))
    {
      if (!findString("lengthUnit_MM", lengthUnitSubs))
        {warnSub("lengthUnit_MM", "lengthUnit", a_lengthUnit);}
      return;
    }
  if (isA(a_lengthUnit, lengthUnit_CM))
    {
      if (!findString("lengthUnit_CM", lengthUnitSubs))
        {warnSub("lengthUnit_CM", "lengthUnit", a_lengthUnit);}
      return;
    }
  if (isA(a_lengthUnit, lengthUnit_METER))
    {
      if (!findString("lengthUnit_METER", lengthUnitSubs))
        {warnSub("lengthUnit_METER", "lengthUnit", a_lengthUnit);}
      return;
    }
  if (isA(a_lengthUnit, lengthUnit_INCH))
    {
      if (!findString("lengthUnit_INCH", lengthUnitSubs))
        {warnSub("lengthUnit_INCH", "lengthUnit", a_lengthUnit);}
      return;
    }
  if (isA(a_lengthUnit, lengthUnit_FEET))
    {
      if (!findString("lengthUnit_FEET", lengthUnitSubs))
        {warnSub("lengthUnit_FEET", "lengthUnit", a_lengthUnit);}
      return;
    }
}

/********************************************************************/

void check_liLabel(
 liLabel * a_liLabel)
{
  if (a_liLabel->get_labelName())
    {
      if (!findString("a_labelName", liLabelAtts))
	{warnAtt("a_labelName", "liLabel", a_liLabel);}
      else
        check_labelName(a_liLabel->get_labelName());
    }
}

/********************************************************************/

void check_litdefLight(
 litdefLight * a_litdefLight)
{
  if (a_litdefLight->get_litdefLightType())
    {
      if (!findString("a_litdefLightType", litdefLightAtts))
	{warnAtt("a_litdefLightType", "litdefLight", a_litdefLight);}
      else
        check_litdefLightType(a_litdefLight->get_litdefLightType());
    }
  if (a_litdefLight->get_axis())
    {
      if (!findString("axis", litdefLightAtts))
	{warnAtt("axis", "litdefLight", a_litdefLight);}
      else
        check_vector(a_litdefLight->get_axis());
    }
}

/********************************************************************/

void check_litdefLightType(
 litdefLightType * a_litdefLightType)
{
  if (isA(a_litdefLightType, litdefLightType_SURF))
    {
      if (!findString("litdefLightType_SURF", litdefLightTypeSubs))
        {warnSub("litdefLightType_SURF", "litdefLightType", a_litdefLightType);}
      return;
    }
  if (isA(a_litdefLightType, litdefLightType_BACK))
    {
      if (!findString("litdefLightType_BACK", litdefLightTypeSubs))
        {warnSub("litdefLightType_BACK", "litdefLightType", a_litdefLightType);}
      return;
    }
  if (isA(a_litdefLightType, litdefLightType_GRID))
    {
      if (!findString("litdefLightType_GRID", litdefLightTypeSubs))
        {warnSub("litdefLightType_GRID", "litdefLightType", a_litdefLightType);}
      return;
    }
  if (isA(a_litdefLightType, litdefLightType_OBLQ))
    {
      if (!findString("litdefLightType_OBLQ", litdefLightTypeSubs))
        {warnSub("litdefLightType_OBLQ", "litdefLightType", a_litdefLightType);}
      return;
    }
}

/********************************************************************/

void check_litdefMinor(
 litdefMinor * a_litdefMinor)
{
  if (isA(a_litdefMinor, litdefLight))
    {
      if (!findString("litdefLight", litdefMinorSubs))
        {warnSub("litdefLight", "litdefMinor", a_litdefMinor);}
      else
        check_litdefLight(dynamic_cast<litdefLight *>(a_litdefMinor));
      return;
    }
  if (isA(a_litdefMinor, litdefStrobe))
    {
      if (!findString("litdefStrobe", litdefMinorSubs))
        {warnSub("litdefStrobe", "litdefMinor", a_litdefMinor);}
      else
        check_litdefStrobe(dynamic_cast<litdefStrobe *>(a_litdefMinor));
      return;
    }
}

/********************************************************************/

void check_litdefStm(
 litdefStm * a_litdefStm)
{
  if (a_litdefStm->get_vlLabel())
    {
      if (!findString("a_vlLabel", litdefStmAtts))
	{warnAtt("a_vlLabel", "litdefStm", a_litdefStm);}
      else
        check_vlLabel(a_litdefStm->get_vlLabel());
    }
  if (a_litdefStm->get_litdefMinor())
    {
      if (!findString("a_litdefMinor", litdefStmAtts))
	{warnAtt("a_litdefMinor", "litdefStm", a_litdefStm);}
      else
        check_litdefMinor(a_litdefStm->get_litdefMinor());
    }
}

/********************************************************************/

void check_litdefStrobe(
 litdefStrobe * a_litdefStrobe)
{
  if (a_litdefStrobe->get_litdefStrobeType())
    {
      if (!findString("a_litdefStrobeType", litdefStrobeAtts))
	{warnAtt("a_litdefStrobeType", "litdefStrobe", a_litdefStrobe);}
      else
        check_litdefStrobeType(a_litdefStrobe->get_litdefStrobeType());
    }
  if (a_litdefStrobe->get_timeon())
    {
      if (!findString("timeon", litdefStrobeAtts))
	{warnAtt("timeon", "litdefStrobe", a_litdefStrobe);}
      else
        check_rentVal(a_litdefStrobe->get_timeon());
    }
  if (a_litdefStrobe->get_axis())
    {
      if (!findString("axis", litdefStrobeAtts))
	{warnAtt("axis", "litdefStrobe", a_litdefStrobe);}
      else
        check_vector(a_litdefStrobe->get_axis());
    }
}

/********************************************************************/

void check_litdefStrobeType(
 litdefStrobeType * a_litdefStrobeType)
{
  if (isA(a_litdefStrobeType, litdefStrobeType_CYCLE))
    {
      if (!findString("litdefStrobeType_CYCLE", litdefStrobeTypeSubs))
        {warnSub("litdefStrobeType_CYCLE", "litdefStrobeType", a_litdefStrobeType);}
      else
        check_litdefStrobeType_CYCLE(dynamic_cast<litdefStrobeType_CYCLE *>(a_litdefStrobeType));
      return;
    }
  if (isA(a_litdefStrobeType, litdefStrobeType_TRIGER))
    {
      if (!findString("litdefStrobeType_TRIGER", litdefStrobeTypeSubs))
        {warnSub("litdefStrobeType_TRIGER", "litdefStrobeType", a_litdefStrobeType);}
      return;
    }
}

/********************************************************************/

void check_litdefStrobeType_CYCLE(
 litdefStrobeType_CYCLE * a_litdefStrobeType_CYCLE)
{
  if (a_litdefStrobeType_CYCLE->get_value())
    {
      if (!findString("value", litdefStrobeType_CYCLEAtts))
	{warnAtt("value", "litdefStrobeType_CYCLE", a_litdefStrobeType_CYCLE);}
      else
        check_rentVal(a_litdefStrobeType_CYCLE->get_value());
    }
}

/********************************************************************/

void check_locateLabel(
 locateLabel * a_locateLabel)
{
  if (isA(a_locateLabel, faLabel))
    {
      if (!findString("faLabel", locateLabelSubs))
        {warnSub("faLabel", "locateLabel", a_locateLabel);}
      else
        check_faLabel(dynamic_cast<faLabel *>(a_locateLabel));
      return;
    }
  if (isA(a_locateLabel, maLabel))
    {
      if (!findString("maLabel", locateLabelSubs))
        {warnSub("maLabel", "locateLabel", a_locateLabel);}
      else
        check_maLabel(dynamic_cast<maLabel *>(a_locateLabel));
      return;
    }
  if (isA(a_locateLabel, datLabel))
    {
      if (!findString("datLabel", locateLabelSubs))
        {warnSub("datLabel", "locateLabel", a_locateLabel);}
      else
        check_datLabel(dynamic_cast<datLabel *>(a_locateLabel));
      return;
    }
}

/********************************************************************/

void check_locateRotAllowed(
 locateRotAllowed * a_locateRotAllowed)
{
  if (isA(a_locateRotAllowed, locateRotAllowed_XAXIS))
    {
      if (!findString("locateRotAllowed_XAXIS", locateRotAllowedSubs))
        {warnSub("locateRotAllowed_XAXIS", "locateRotAllowed", a_locateRotAllowed);}
      return;
    }
  if (isA(a_locateRotAllowed, locateRotAllowed_YAXIS))
    {
      if (!findString("locateRotAllowed_YAXIS", locateRotAllowedSubs))
        {warnSub("locateRotAllowed_YAXIS", "locateRotAllowed", a_locateRotAllowed);}
      return;
    }
  if (isA(a_locateRotAllowed, locateRotAllowed_ZAXIS))
    {
      if (!findString("locateRotAllowed_ZAXIS", locateRotAllowedSubs))
        {warnSub("locateRotAllowed_ZAXIS", "locateRotAllowed", a_locateRotAllowed);}
      return;
    }
  if (isA(a_locateRotAllowed, locateRotAllowed_XYAXIS))
    {
      if (!findString("locateRotAllowed_XYAXIS", locateRotAllowedSubs))
        {warnSub("locateRotAllowed_XYAXIS", "locateRotAllowed", a_locateRotAllowed);}
      return;
    }
  if (isA(a_locateRotAllowed, locateRotAllowed_YZAXIS))
    {
      if (!findString("locateRotAllowed_YZAXIS", locateRotAllowedSubs))
        {warnSub("locateRotAllowed_YZAXIS", "locateRotAllowed", a_locateRotAllowed);}
      return;
    }
  if (isA(a_locateRotAllowed, locateRotAllowed_ZXAXIS))
    {
      if (!findString("locateRotAllowed_ZXAXIS", locateRotAllowedSubs))
        {warnSub("locateRotAllowed_ZXAXIS", "locateRotAllowed", a_locateRotAllowed);}
      return;
    }
  if (isA(a_locateRotAllowed, locateRotAllowed_XYZAXI))
    {
      if (!findString("locateRotAllowed_XYZAXI", locateRotAllowedSubs))
        {warnSub("locateRotAllowed_XYZAXI", "locateRotAllowed", a_locateRotAllowed);}
      return;
    }
  if (isA(a_locateRotAllowed, locateRotAllowed_NOROT))
    {
      if (!findString("locateRotAllowed_NOROT", locateRotAllowedSubs))
        {warnSub("locateRotAllowed_NOROT", "locateRotAllowed", a_locateRotAllowed);}
      return;
    }
}

/********************************************************************/

void check_locateStm(
 locateStm * a_locateStm)
{
  if (a_locateStm->get_dLabel())
    {
      if (!findString("a_dLabel", locateStmAtts))
	{warnAtt("a_dLabel", "locateStm", a_locateStm);}
      else
        check_dLabel(a_locateStm->get_dLabel());
    }
  if (a_locateStm->get_locateTransAllowed())
    {
      if (!findString("a_locateTransAllowed", locateStmAtts))
	{warnAtt("a_locateTransAllowed", "locateStm", a_locateStm);}
      else
        check_locateTransAllowed(a_locateStm->get_locateTransAllowed());
    }
  if (a_locateStm->get_locateRotAllowed())
    {
      if (!findString("a_locateRotAllowed", locateStmAtts))
	{warnAtt("a_locateRotAllowed", "locateStm", a_locateStm);}
      else
        check_locateRotAllowed(a_locateStm->get_locateRotAllowed());
    }
  if (a_locateStm->get_locateLabelList())
    {
      if (!findString("a_locateLabelList", locateStmAtts))
	{warnAtt("a_locateLabelList", "locateStm", a_locateStm);}
      else
        {
          std::list<locateLabel *> * theList;
          std::list<locateLabel *>::iterator iter;
          theList = a_locateStm->get_locateLabelList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_locateLabel(*iter);
        }
    }
}

/********************************************************************/

void check_locateTransAllowed(
 locateTransAllowed * a_locateTransAllowed)
{
  if (isA(a_locateTransAllowed, locateTransAllowed_XDIR))
    {
      if (!findString("locateTransAllowed_XDIR", locateTransAllowedSubs))
        {warnSub("locateTransAllowed_XDIR", "locateTransAllowed", a_locateTransAllowed);}
      return;
    }
  if (isA(a_locateTransAllowed, locateTransAllowed_YDIR))
    {
      if (!findString("locateTransAllowed_YDIR", locateTransAllowedSubs))
        {warnSub("locateTransAllowed_YDIR", "locateTransAllowed", a_locateTransAllowed);}
      return;
    }
  if (isA(a_locateTransAllowed, locateTransAllowed_ZDIR))
    {
      if (!findString("locateTransAllowed_ZDIR", locateTransAllowedSubs))
        {warnSub("locateTransAllowed_ZDIR", "locateTransAllowed", a_locateTransAllowed);}
      return;
    }
  if (isA(a_locateTransAllowed, locateTransAllowed_XYDIR))
    {
      if (!findString("locateTransAllowed_XYDIR", locateTransAllowedSubs))
        {warnSub("locateTransAllowed_XYDIR", "locateTransAllowed", a_locateTransAllowed);}
      return;
    }
  if (isA(a_locateTransAllowed, locateTransAllowed_YZDIR))
    {
      if (!findString("locateTransAllowed_YZDIR", locateTransAllowedSubs))
        {warnSub("locateTransAllowed_YZDIR", "locateTransAllowed", a_locateTransAllowed);}
      return;
    }
  if (isA(a_locateTransAllowed, locateTransAllowed_ZXDIR))
    {
      if (!findString("locateTransAllowed_ZXDIR", locateTransAllowedSubs))
        {warnSub("locateTransAllowed_ZXDIR", "locateTransAllowed", a_locateTransAllowed);}
      return;
    }
  if (isA(a_locateTransAllowed, locateTransAllowed_XYZDIR))
    {
      if (!findString("locateTransAllowed_XYZDIR", locateTransAllowedSubs))
        {warnSub("locateTransAllowed_XYZDIR", "locateTransAllowed", a_locateTransAllowed);}
      return;
    }
  if (isA(a_locateTransAllowed, locateTransAllowed_NOTRAN))
    {
      if (!findString("locateTransAllowed_NOTRAN", locateTransAllowedSubs))
        {warnSub("locateTransAllowed_NOTRAN", "locateTransAllowed", a_locateTransAllowed);}
      return;
    }
}

/********************************************************************/

void check_longShort(
 longShort * a_longShort)
{
  if (isA(a_longShort, longShort_LONG))
    {
      if (!findString("longShort_LONG", longShortSubs))
        {warnSub("longShort_LONG", "longShort", a_longShort);}
      return;
    }
  if (isA(a_longShort, longShort_SHORT))
    {
      if (!findString("longShort_SHORT", longShortSubs))
        {warnSub("longShort_SHORT", "longShort", a_longShort);}
      return;
    }
}

/********************************************************************/

void check_lotidStm(
 lotidStm * a_lotidStm)
{
  if (a_lotidStm->get_liLabel())
    {
      if (!findString("a_liLabel", lotidStmAtts))
	{warnAtt("a_liLabel", "lotidStm", a_lotidStm);}
      else
        check_liLabel(a_lotidStm->get_liLabel());
    }
  if (a_lotidStm->get_text())
    {
      if (!findString("text", lotidStmAtts))
	{warnAtt("text", "lotidStm", a_lotidStm);}
      else
        check_stringVal(a_lotidStm->get_text());
    }
}

/********************************************************************/

void check_mLabel(
 mLabel * a_mLabel)
{
  if (a_mLabel->get_labelName())
    {
      if (!findString("a_labelName", mLabelAtts))
	{warnAtt("a_labelName", "mLabel", a_mLabel);}
      else
        check_labelName(a_mLabel->get_labelName());
    }
}

/********************************************************************/

void check_mLabelConst(
 mLabelConst * a_mLabelConst)
{
  if (a_mLabelConst->get_labelNameConst())
    {
      if (!findString("a_labelNameConst", mLabelConstAtts))
	{warnAtt("a_labelNameConst", "mLabelConst", a_mLabelConst);}
      else
        check_labelNameConst(a_mLabelConst->get_labelNameConst());
    }
}

/********************************************************************/

void check_maLabel(
 maLabel * a_maLabel)
{
  if (a_maLabel->get_labelName())
    {
      if (!findString("a_labelName", maLabelAtts))
	{warnAtt("a_labelName", "maLabel", a_maLabel);}
      else
        check_labelName(a_maLabel->get_labelName());
    }
}

/********************************************************************/

void check_macroBlock(
 macroBlock * a_macroBlock)
{
  if (a_macroBlock->get_macroStm())
    {
      if (!findString("a_macroStm", macroBlockAtts))
	{warnAttBlock("macroStm", a_macroBlock->get_macroStm());}
      else
        check_macroStm(a_macroBlock->get_macroStm());
    }
  if (a_macroBlock->get_noParseStmList())
    {
      if (!findString("a_noParseStmList", macroBlockAtts))
	{warnAttBlock("noParseStmList", a_macroBlock->get_noParseStmList()->front());}
      else
        {
          std::list<noParseStm *> * theList;
          std::list<noParseStm *>::iterator iter;
          theList = a_macroBlock->get_noParseStmList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_noParseStm(*iter);
        }
    }
  if (a_macroBlock->get_endmacStm())
    {
      if (!findString("a_endmacStm", macroBlockAtts))
	{warnAttBlock("endmacStm", a_macroBlock->get_endmacStm());}
    }
}

/********************************************************************/

void check_macroPar(
 macroPar * a_macroPar)
{
  if (isA(a_macroPar, macroPar_MACROVARNAME))
    {
      if (!findString("macroPar_MACROVARNAME", macroParSubs))
        {warnSub("macroPar_MACROVARNAME", "macroPar", a_macroPar);}
      else
        check_macroPar_MACROVARNAME(dynamic_cast<macroPar_MACROVARNAME *>(a_macroPar));
      return;
    }
  if (isA(a_macroPar, macroPar_stringConst))
    {
      if (!findString("macroPar_stringConst", macroParSubs))
        {warnSub("macroPar_stringConst", "macroPar", a_macroPar);}
      else
        check_macroPar_stringConst(dynamic_cast<macroPar_stringConst *>(a_macroPar));
      return;
    }
}

/********************************************************************/

void check_macroPar_MACROVARNAME(
 macroPar_MACROVARNAME * a_macroPar_MACROVARNAME)
{
  if (a_macroPar_MACROVARNAME->get_string())
    {
      if (!findString("a_string", macroPar_MACROVARNAMEAtts))
	{warnAtt("a_string", "macroPar_MACROVARNAME", a_macroPar_MACROVARNAME);}
    }
}

/********************************************************************/

void check_macroPar_stringConst(
 macroPar_stringConst * a_macroPar_stringConst)
{
  if (a_macroPar_stringConst->get_stringConst())
    {
      if (!findString("a_stringConst", macroPar_stringConstAtts))
	{warnAtt("a_stringConst", "macroPar_stringConst", a_macroPar_stringConst);}
      else
        check_stringConst(a_macroPar_stringConst->get_stringConst());
    }
}

/********************************************************************/

void check_macroStm(
 macroStm * a_macroStm)
{
  if (a_macroStm->get_mLabelConst())
    {
      if (!findString("a_mLabelConst", macroStmAtts))
	{warnAtt("a_mLabelConst", "macroStm", a_macroStm);}
      else
        check_mLabelConst(a_macroStm->get_mLabelConst());
    }
  if (a_macroStm->get_macroParList())
    {
      if (!findString("a_macroParList", macroStmAtts))
	{warnAtt("a_macroParList", "macroStm", a_macroStm);}
      else
        {
          std::list<macroPar *> * theList;
          std::list<macroPar *>::iterator iter;
          theList = a_macroStm->get_macroParList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_macroPar(*iter);
        }
    }
}

/********************************************************************/

void check_matDir(
 matDir * a_matDir)
{
  if (isA(a_matDir, matDir_INNER))
    {
      if (!findString("matDir_INNER", matDirSubs))
        {warnSub("matDir_INNER", "matDir", a_matDir);}
      return;
    }
  if (isA(a_matDir, matDir_OUTER))
    {
      if (!findString("matDir_OUTER", matDirSubs))
        {warnSub("matDir_OUTER", "matDir", a_matDir);}
      return;
    }
}

/********************************************************************/

void check_matdefFeat(
 matdefFeat * a_matdefFeat)
{
  if (a_matdefFeat->get_fLabel())
    {
      if (!findString("a_fLabel", matdefFeatAtts))
	{warnAtt("a_fLabel", "matdefFeat", a_matdefFeat);}
      else
        check_fLabel(a_matdefFeat->get_fLabel());
    }
  if (a_matdefFeat->get_matdefSpec())
    {
      if (!findString("a_matdefSpec", matdefFeatAtts))
	{warnAtt("a_matdefSpec", "matdefFeat", a_matdefFeat);}
      else
        check_matdefSpec(a_matdefFeat->get_matdefSpec());
    }
}

/********************************************************************/

void check_matdefGeom(
 matdefGeom * a_matdefGeom)
{
  if (a_matdefGeom->get_gLabel())
    {
      if (!findString("a_gLabel", matdefGeomAtts))
	{warnAtt("a_gLabel", "matdefGeom", a_matdefGeom);}
      else
        check_gLabel(a_matdefGeom->get_gLabel());
    }
  if (a_matdefGeom->get_matdefSpec())
    {
      if (!findString("a_matdefSpec", matdefGeomAtts))
	{warnAtt("a_matdefSpec", "matdefGeom", a_matdefGeom);}
      else
        check_matdefSpec(a_matdefGeom->get_matdefSpec());
    }
}

/********************************************************************/

void check_matdefMat(
 matdefMat * a_matdefMat)
{
  if (isA(a_matdefMat, matdefMat_MMC))
    {
      if (!findString("matdefMat_MMC", matdefMatSubs))
        {warnSub("matdefMat_MMC", "matdefMat", a_matdefMat);}
      else
        check_matdefMat_MMC(dynamic_cast<matdefMat_MMC *>(a_matdefMat));
      return;
    }
  if (isA(a_matdefMat, matdefMat_LMC))
    {
      if (!findString("matdefMat_LMC", matdefMatSubs))
        {warnSub("matdefMat_LMC", "matdefMat", a_matdefMat);}
      else
        check_matdefMat_LMC(dynamic_cast<matdefMat_LMC *>(a_matdefMat));
      return;
    }
}

/********************************************************************/

void check_matdefMat_LMC(
 matdefMat_LMC * a_matdefMat_LMC)
{
  if (a_matdefMat_LMC->get_tLabel())
    {
      if (!findString("a_tLabel", matdefMat_LMCAtts))
	{warnAtt("a_tLabel", "matdefMat_LMC", a_matdefMat_LMC);}
      else
        check_tLabel(a_matdefMat_LMC->get_tLabel());
    }
}

/********************************************************************/

void check_matdefMat_MMC(
 matdefMat_MMC * a_matdefMat_MMC)
{
  if (a_matdefMat_MMC->get_tLabel())
    {
      if (!findString("a_tLabel", matdefMat_MMCAtts))
	{warnAtt("a_tLabel", "matdefMat_MMC", a_matdefMat_MMC);}
      else
        check_tLabel(a_matdefMat_MMC->get_tLabel());
    }
}

/********************************************************************/

void check_matdefMating(
 matdefMating * a_matdefMating)
{
  if (isA(a_matdefMating, matdefMating_PT2PT))
    {
      if (!findString("matdefMating_PT2PT", matdefMatingSubs))
        {warnSub("matdefMating_PT2PT", "matdefMating", a_matdefMating);}
      return;
    }
  if (isA(a_matdefMating, matdefMating_PT2LN))
    {
      if (!findString("matdefMating_PT2LN", matdefMatingSubs))
        {warnSub("matdefMating_PT2LN", "matdefMating", a_matdefMating);}
      return;
    }
  if (isA(a_matdefMating, matdefMating_PT2PL))
    {
      if (!findString("matdefMating_PT2PL", matdefMatingSubs))
        {warnSub("matdefMating_PT2PL", "matdefMating", a_matdefMating);}
      return;
    }
  if (isA(a_matdefMating, matdefMating_LN2LN))
    {
      if (!findString("matdefMating_LN2LN", matdefMatingSubs))
        {warnSub("matdefMating_LN2LN", "matdefMating", a_matdefMating);}
      return;
    }
}

/********************************************************************/

void check_matdefMethod(
 matdefMethod * a_matdefMethod)
{
  if (isA(a_matdefMethod, matdefMethod_BF))
    {
      if (!findString("matdefMethod_BF", matdefMethodSubs))
        {warnSub("matdefMethod_BF", "matdefMethod", a_matdefMethod);}
      return;
    }
  if (isA(a_matdefMethod, matdefMethod_FZ))
    {
      if (!findString("matdefMethod_FZ", matdefMethodSubs))
        {warnSub("matdefMethod_FZ", "matdefMethod", a_matdefMethod);}
      return;
    }
}

/********************************************************************/

void check_matdefMinor(
 matdefMinor * a_matdefMinor)
{
  if (isA(a_matdefMinor, matdefFeat))
    {
      if (!findString("matdefFeat", matdefMinorSubs))
        {warnSub("matdefFeat", "matdefMinor", a_matdefMinor);}
      else
        check_matdefFeat(dynamic_cast<matdefFeat *>(a_matdefMinor));
      return;
    }
  if (isA(a_matdefMinor, matdefGeom))
    {
      if (!findString("matdefGeom", matdefMinorSubs))
        {warnSub("matdefGeom", "matdefMinor", a_matdefMinor);}
      else
        check_matdefGeom(dynamic_cast<matdefGeom *>(a_matdefMinor));
      return;
    }
}

/********************************************************************/

void check_matdefSpec(
 matdefSpec * a_matdefSpec)
{
  if (a_matdefSpec->get_faLabelList())
    {
      if (!findString("a_faLabelList", matdefSpecAtts))
	{warnAtt("a_faLabelList", "matdefSpec", a_matdefSpec);}
      else
        {
          std::list<faLabel *> * theList;
          std::list<faLabel *>::iterator iter;
          theList = a_matdefSpec->get_faLabelList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_faLabel(*iter);
        }
    }
  if (a_matdefSpec->get_matdefType())
    {
      if (!findString("a_matdefType", matdefSpecAtts))
	{warnAtt("a_matdefType", "matdefSpec", a_matdefSpec);}
      else
        check_matdefType(a_matdefSpec->get_matdefType());
    }
}

/********************************************************************/

void check_matdefStm(
 matdefStm * a_matdefStm)
{
  if (a_matdefStm->get_maLabel())
    {
      if (!findString("a_maLabel", matdefStmAtts))
	{warnAtt("a_maLabel", "matdefStm", a_matdefStm);}
      else
        check_maLabel(a_matdefStm->get_maLabel());
    }
  if (a_matdefStm->get_matdefMinor())
    {
      if (!findString("a_matdefMinor", matdefStmAtts))
	{warnAtt("a_matdefMinor", "matdefStm", a_matdefStm);}
      else
        check_matdefMinor(a_matdefStm->get_matdefMinor());
    }
}

/********************************************************************/

void check_matdefType(
 matdefType * a_matdefType)
{
  if (isA(a_matdefType, matdefTypeZone))
    {
      if (!findString("matdefTypeZone", matdefTypeSubs))
        {warnSub("matdefTypeZone", "matdefType", a_matdefType);}
      else
        check_matdefTypeZone(dynamic_cast<matdefTypeZone *>(a_matdefType));
      return;
    }
  if (isA(a_matdefType, matdefTypeBand))
    {
      if (!findString("matdefTypeBand", matdefTypeSubs))
        {warnSub("matdefTypeBand", "matdefType", a_matdefType);}
      else
        check_matdefTypeBand(dynamic_cast<matdefTypeBand *>(a_matdefType));
      return;
    }
}

/********************************************************************/

void check_matdefTypeBand(
 matdefTypeBand * a_matdefTypeBand)
{
  if (a_matdefTypeBand->get_matdefMating())
    {
      if (!findString("a_matdefMating", matdefTypeBandAtts))
	{warnAtt("a_matdefMating", "matdefTypeBand", a_matdefTypeBand);}
      else
        check_matdefMating(a_matdefTypeBand->get_matdefMating());
    }
  if (a_matdefTypeBand->get_matdefMethod())
    {
      if (!findString("a_matdefMethod", matdefTypeBandAtts))
	{warnAtt("a_matdefMethod", "matdefTypeBand", a_matdefTypeBand);}
      else
        check_matdefMethod(a_matdefTypeBand->get_matdefMethod());
    }
  if (a_matdefTypeBand->get_loband())
    {
      if (!findString("loband", matdefTypeBandAtts))
	{warnAtt("loband", "matdefTypeBand", a_matdefTypeBand);}
      else
        check_rentVal(a_matdefTypeBand->get_loband());
    }
  if (a_matdefTypeBand->get_upband())
    {
      if (!findString("upband", matdefTypeBandAtts))
	{warnAtt("upband", "matdefTypeBand", a_matdefTypeBand);}
      else
        check_rentVal(a_matdefTypeBand->get_upband());
    }
  if (a_matdefTypeBand->get_matdefMat())
    {
      if (!findString("a_matdefMat", matdefTypeBandAtts))
	{warnAtt("a_matdefMat", "matdefTypeBand", a_matdefTypeBand);}
      else
        check_matdefMat(a_matdefTypeBand->get_matdefMat());
    }
}

/********************************************************************/

void check_matdefTypeZone(
 matdefTypeZone * a_matdefTypeZone)
{
  if (a_matdefTypeZone->get_matdefMating())
    {
      if (!findString("a_matdefMating", matdefTypeZoneAtts))
	{warnAtt("a_matdefMating", "matdefTypeZone", a_matdefTypeZone);}
      else
        check_matdefMating(a_matdefTypeZone->get_matdefMating());
    }
  if (a_matdefTypeZone->get_matdefMethod())
    {
      if (!findString("a_matdefMethod", matdefTypeZoneAtts))
	{warnAtt("a_matdefMethod", "matdefTypeZone", a_matdefTypeZone);}
      else
        check_matdefMethod(a_matdefTypeZone->get_matdefMethod());
    }
  if (a_matdefTypeZone->get_fitzon())
    {
      if (!findString("fitzon", matdefTypeZoneAtts))
	{warnAtt("fitzon", "matdefTypeZone", a_matdefTypeZone);}
      else
        check_rentVal(a_matdefTypeZone->get_fitzon());
    }
  if (a_matdefTypeZone->get_matdefMat())
    {
      if (!findString("a_matdefMat", matdefTypeZoneAtts))
	{warnAtt("a_matdefMat", "matdefTypeZone", a_matdefTypeZone);}
      else
        check_matdefMat(a_matdefTypeZone->get_matdefMat());
    }
}

/********************************************************************/

void check_matrix(
 matrix * a_matrix)
{
  if (a_matrix->get_a1())
    {
      if (!findString("a1", matrixAtts))
	{warnAtt("a1", "matrix", a_matrix);}
      else
        check_rentVal(a_matrix->get_a1());
    }
  if (a_matrix->get_a2())
    {
      if (!findString("a2", matrixAtts))
	{warnAtt("a2", "matrix", a_matrix);}
      else
        check_rentVal(a_matrix->get_a2());
    }
  if (a_matrix->get_a3())
    {
      if (!findString("a3", matrixAtts))
	{warnAtt("a3", "matrix", a_matrix);}
      else
        check_rentVal(a_matrix->get_a3());
    }
  if (a_matrix->get_b1())
    {
      if (!findString("b1", matrixAtts))
	{warnAtt("b1", "matrix", a_matrix);}
      else
        check_rentVal(a_matrix->get_b1());
    }
  if (a_matrix->get_b2())
    {
      if (!findString("b2", matrixAtts))
	{warnAtt("b2", "matrix", a_matrix);}
      else
        check_rentVal(a_matrix->get_b2());
    }
  if (a_matrix->get_b3())
    {
      if (!findString("b3", matrixAtts))
	{warnAtt("b3", "matrix", a_matrix);}
      else
        check_rentVal(a_matrix->get_b3());
    }
  if (a_matrix->get_c1())
    {
      if (!findString("c1", matrixAtts))
	{warnAtt("c1", "matrix", a_matrix);}
      else
        check_rentVal(a_matrix->get_c1());
    }
  if (a_matrix->get_c2())
    {
      if (!findString("c2", matrixAtts))
	{warnAtt("c2", "matrix", a_matrix);}
      else
        check_rentVal(a_matrix->get_c2());
    }
  if (a_matrix->get_c3())
    {
      if (!findString("c3", matrixAtts))
	{warnAtt("c3", "matrix", a_matrix);}
      else
        check_rentVal(a_matrix->get_c3());
    }
  if (a_matrix->get_d1())
    {
      if (!findString("d1", matrixAtts))
	{warnAtt("d1", "matrix", a_matrix);}
      else
        check_rentVal(a_matrix->get_d1());
    }
  if (a_matrix->get_d2())
    {
      if (!findString("d2", matrixAtts))
	{warnAtt("d2", "matrix", a_matrix);}
      else
        check_rentVal(a_matrix->get_d2());
    }
  if (a_matrix->get_d3())
    {
      if (!findString("d3", matrixAtts))
	{warnAtt("d3", "matrix", a_matrix);}
      else
        check_rentVal(a_matrix->get_d3());
    }
}

/********************************************************************/

void check_mdLabel(
 mdLabel * a_mdLabel)
{
  if (a_mdLabel->get_labelName())
    {
      if (!findString("a_labelName", mdLabelAtts))
	{warnAtt("a_labelName", "mdLabel", a_mdLabel);}
      else
        check_labelName(a_mdLabel->get_labelName());
    }
}

/********************************************************************/

void check_measBlock(
 measBlock * a_measBlock)
{
  if (isA(a_measBlock, measBlock_measStm))
    {
      if (!findString("measBlock_measStm", measBlockSubs))
        {warnBlockBug("measBlock_measStm", "measBlock");}
      else
        check_measBlock_measStm(dynamic_cast<measBlock_measStm *>(a_measBlock));
    }
  else if (isA(a_measBlock, measBlock_rmeasStm))
    {
      if (!findString("measBlock_rmeasStm", measBlockSubs))
        {warnBlockBug("measBlock_rmeasStm", "measBlock");}
      else
        check_measBlock_rmeasStm(dynamic_cast<measBlock_rmeasStm *>(a_measBlock));
    }
}

/********************************************************************/

void check_measBlockItem(
 measBlockItem * a_measBlockItem)
{
  if (isA(a_measBlockItem, measBlockStatement))
    {
      if (!findString("measBlockStatement", measBlockItemSubs))
        {warnSub("measBlockStatement", "measBlockItem", a_measBlockItem);}
      else
        check_measBlockStatement(dynamic_cast<measBlockStatement *>(a_measBlockItem));
      return;
    }
  if (isA(a_measBlockItem, measDoBlock))
    {
      if (!findString("measDoBlock", measBlockItemSubs))
        {warnSub("measDoBlock", "measBlockItem", a_measBlockItem);}
      else
        check_measDoBlock(dynamic_cast<measDoBlock *>(a_measBlockItem));
      return;
    }
  if (isA(a_measBlockItem, measIfBlock))
    {
      if (!findString("measIfBlock", measBlockItemSubs))
        {warnSub("measIfBlock", "measBlockItem", a_measBlockItem);}
      else
        check_measIfBlock(dynamic_cast<measIfBlock *>(a_measBlockItem));
      return;
    }
  if (isA(a_measBlockItem, measSelectBlock))
    {
      if (!findString("measSelectBlock", measBlockItemSubs))
        {warnSub("measSelectBlock", "measBlockItem", a_measBlockItem);}
      else
        check_measSelectBlock(dynamic_cast<measSelectBlock *>(a_measBlockItem));
      return;
    }
}

/********************************************************************/

void check_measBlockStatement(
 measBlockStatement * a_measBlockStatement)
{
  if (isA(a_measBlockStatement, calibSensBlockStatement))
    {
      if (!findString("calibSensBlockStatement", measBlockStatementSubs))
        {warnSub("calibSensBlockStatement", "measBlockStatement", a_measBlockStatement);}
      else
        check_calibSensBlockStatement(dynamic_cast<calibSensBlockStatement *>(a_measBlockStatement));
      return;
    }
  if (isA(a_measBlockStatement, crslctStm))
    {
      if (!findString("crslctStm", measBlockStatementSubs))
        {warnSub("crslctStm", "measBlockStatement", a_measBlockStatement);}
      else
        check_crslctStm(dynamic_cast<crslctStm *>(a_measBlockStatement));
      return;
    }
  if (isA(a_measBlockStatement, recallSensorStm))
    {
      if (!findString("recallSensorStm", measBlockStatementSubs))
        {warnSub("recallSensorStm", "measBlockStatement", a_measBlockStatement);}
      else
        check_recallSensorStm(dynamic_cast<recallSensorStm *>(a_measBlockStatement));
      return;
    }
  if (isA(a_measBlockStatement, saveSensorStm))
    {
      if (!findString("saveSensorStm", measBlockStatementSubs))
        {warnSub("saveSensorStm", "measBlockStatement", a_measBlockStatement);}
      else
        check_saveSensorStm(dynamic_cast<saveSensorStm *>(a_measBlockStatement));
      return;
    }
  if (isA(a_measBlockStatement, snslctStm))
    {
      if (!findString("snslctStm", measBlockStatementSubs))
        {warnSub("snslctStm", "measBlockStatement", a_measBlockStatement);}
      else
        check_snslctStm(dynamic_cast<snslctStm *>(a_measBlockStatement));
      return;
    }
}

/********************************************************************/

void check_measBlock_measStm(
 measBlock_measStm * a_measBlock_measStm)
{
  if (a_measBlock_measStm->get_measStm())
    {
      if (!findString("a_measStm", measBlock_measStmAtts))
	{warnAttBlock("measStm", a_measBlock_measStm->get_measStm());}
      else
        check_measStm(a_measBlock_measStm->get_measStm());
    }
  if (a_measBlock_measStm->get_measBlockItemList())
    {
      if (!findString("a_measBlockItemList", measBlock_measStmAtts))
	{warnAttBlock("measBlockItemList", a_measBlock_measStm->get_measBlockItemList()->front());}
      else
        {
          std::list<measBlockItem *> * theList;
          std::list<measBlockItem *>::iterator iter;
          theList = a_measBlock_measStm->get_measBlockItemList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_measBlockItem(*iter);
        }
    }
  if (a_measBlock_measStm->get_endmesStm())
    {
      if (!findString("a_endmesStm", measBlock_measStmAtts))
	{warnAttBlock("endmesStm", a_measBlock_measStm->get_endmesStm());}
    }
}

/********************************************************************/

void check_measBlock_rmeasStm(
 measBlock_rmeasStm * a_measBlock_rmeasStm)
{
  if (a_measBlock_rmeasStm->get_rmeasStm())
    {
      if (!findString("a_rmeasStm", measBlock_rmeasStmAtts))
	{warnAttBlock("rmeasStm", a_measBlock_rmeasStm->get_rmeasStm());}
      else
        check_rmeasStm(a_measBlock_rmeasStm->get_rmeasStm());
    }
  if (a_measBlock_rmeasStm->get_measBlockItemList())
    {
      if (!findString("a_measBlockItemList", measBlock_rmeasStmAtts))
	{warnAttBlock("measBlockItemList", a_measBlock_rmeasStm->get_measBlockItemList()->front());}
      else
        {
          std::list<measBlockItem *> * theList;
          std::list<measBlockItem *>::iterator iter;
          theList = a_measBlock_rmeasStm->get_measBlockItemList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_measBlockItem(*iter);
        }
    }
  if (a_measBlock_rmeasStm->get_endmesStm())
    {
      if (!findString("a_endmesStm", measBlock_rmeasStmAtts))
	{warnAttBlock("endmesStm", a_measBlock_rmeasStm->get_endmesStm());}
    }
}

/********************************************************************/

void check_measCaseBlock(
 measCaseBlock * a_measCaseBlock)
{
  if (a_measCaseBlock->get_caseStm())
    {
      if (!findString("a_caseStm", measCaseBlockAtts))
	{warnAttBlock("caseStm", a_measCaseBlock->get_caseStm());}
      else
        check_caseStm(a_measCaseBlock->get_caseStm());
    }
  if (a_measCaseBlock->get_measBlockItemList())
    {
      if (!findString("a_measBlockItemList", measCaseBlockAtts))
	{warnAttBlock("measBlockItemList", a_measCaseBlock->get_measBlockItemList()->front());}
      else
        {
          std::list<measBlockItem *> * theList;
          std::list<measBlockItem *>::iterator iter;
          theList = a_measCaseBlock->get_measBlockItemList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_measBlockItem(*iter);
        }
    }
  if (a_measCaseBlock->get_endcasStm())
    {
      if (!findString("a_endcasStm", measCaseBlockAtts))
	{warnAttBlock("endcasStm", a_measCaseBlock->get_endcasStm());}
    }
}

/********************************************************************/

void check_measDefaultCaseBlock(
 measDefaultCaseBlock * a_measDefaultCaseBlock)
{
  if (a_measDefaultCaseBlock->get_dftcasStm())
    {
      if (!findString("a_dftcasStm", measDefaultCaseBlockAtts))
	{warnAttBlock("dftcasStm", a_measDefaultCaseBlock->get_dftcasStm());}
    }
  if (a_measDefaultCaseBlock->get_measBlockItemList())
    {
      if (!findString("a_measBlockItemList", measDefaultCaseBlockAtts))
	{warnAttBlock("measBlockItemList", a_measDefaultCaseBlock->get_measBlockItemList()->front());}
      else
        {
          std::list<measBlockItem *> * theList;
          std::list<measBlockItem *>::iterator iter;
          theList = a_measDefaultCaseBlock->get_measBlockItemList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_measBlockItem(*iter);
        }
    }
  if (a_measDefaultCaseBlock->get_endcasStm())
    {
      if (!findString("a_endcasStm", measDefaultCaseBlockAtts))
	{warnAttBlock("endcasStm", a_measDefaultCaseBlock->get_endcasStm());}
    }
}

/********************************************************************/

void check_measDoBlock(
 measDoBlock * a_measDoBlock)
{
  if (a_measDoBlock->get_doStm())
    {
      if (!findString("a_doStm", measDoBlockAtts))
	{warnAttBlock("doStm", a_measDoBlock->get_doStm());}
      else
        check_doStm(a_measDoBlock->get_doStm());
    }
  if (a_measDoBlock->get_measBlockItemList())
    {
      if (!findString("a_measBlockItemList", measDoBlockAtts))
	{warnAttBlock("measBlockItemList", a_measDoBlock->get_measBlockItemList()->front());}
      else
        {
          std::list<measBlockItem *> * theList;
          std::list<measBlockItem *>::iterator iter;
          theList = a_measDoBlock->get_measBlockItemList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_measBlockItem(*iter);
        }
    }
  if (a_measDoBlock->get_enddoStm())
    {
      if (!findString("a_enddoStm", measDoBlockAtts))
	{warnAttBlock("enddoStm", a_measDoBlock->get_enddoStm());}
    }
}

/********************************************************************/

void check_measGeotype(
 measGeotype * a_measGeotype)
{
  if (isA(a_measGeotype, measGeotype_ARC))
    {
      if (!findString("measGeotype_ARC", measGeotypeSubs))
        {warnSub("measGeotype_ARC", "measGeotype", a_measGeotype);}
      return;
    }
  if (isA(a_measGeotype, measGeotype_CIRCLE))
    {
      if (!findString("measGeotype_CIRCLE", measGeotypeSubs))
        {warnSub("measGeotype_CIRCLE", "measGeotype", a_measGeotype);}
      return;
    }
  if (isA(a_measGeotype, measGeotype_CONE))
    {
      if (!findString("measGeotype_CONE", measGeotypeSubs))
        {warnSub("measGeotype_CONE", "measGeotype", a_measGeotype);}
      return;
    }
  if (isA(a_measGeotype, measGeotype_CONRADSEGMNT))
    {
      if (!findString("measGeotype_CONRADSEGMNT", measGeotypeSubs))
        {warnSub("measGeotype_CONRADSEGMNT", "measGeotype", a_measGeotype);}
      return;
    }
  if (isA(a_measGeotype, measGeotype_CPARLN))
    {
      if (!findString("measGeotype_CPARLN", measGeotypeSubs))
        {warnSub("measGeotype_CPARLN", "measGeotype", a_measGeotype);}
      return;
    }
  if (isA(a_measGeotype, measGeotype_CYLNDR))
    {
      if (!findString("measGeotype_CYLNDR", measGeotypeSubs))
        {warnSub("measGeotype_CYLNDR", "measGeotype", a_measGeotype);}
      return;
    }
  if (isA(a_measGeotype, measGeotype_CYLRADSEGMNT))
    {
      if (!findString("measGeotype_CYLRADSEGMNT", measGeotypeSubs))
        {warnSub("measGeotype_CYLRADSEGMNT", "measGeotype", a_measGeotype);}
      return;
    }
  if (isA(a_measGeotype, measGeotype_EDGEPT))
    {
      if (!findString("measGeotype_EDGEPT", measGeotypeSubs))
        {warnSub("measGeotype_EDGEPT", "measGeotype", a_measGeotype);}
      return;
    }
  if (isA(a_measGeotype, measGeotype_ELLIPS))
    {
      if (!findString("measGeotype_ELLIPS", measGeotypeSubs))
        {warnSub("measGeotype_ELLIPS", "measGeotype", a_measGeotype);}
      return;
    }
  if (isA(a_measGeotype, measGeotype_ELONGCYL))
    {
      if (!findString("measGeotype_ELONGCYL", measGeotypeSubs))
        {warnSub("measGeotype_ELONGCYL", "measGeotype", a_measGeotype);}
      return;
    }
  if (isA(a_measGeotype, measGeotype_GCURVE))
    {
      if (!findString("measGeotype_GCURVE", measGeotypeSubs))
        {warnSub("measGeotype_GCURVE", "measGeotype", a_measGeotype);}
      return;
    }
  if (isA(a_measGeotype, measGeotype_GSURF))
    {
      if (!findString("measGeotype_GSURF", measGeotypeSubs))
        {warnSub("measGeotype_GSURF", "measGeotype", a_measGeotype);}
      return;
    }
  if (isA(a_measGeotype, measGeotype_LINE))
    {
      if (!findString("measGeotype_LINE", measGeotypeSubs))
        {warnSub("measGeotype_LINE", "measGeotype", a_measGeotype);}
      return;
    }
  if (isA(a_measGeotype, measGeotype_OBJECT))
    {
      if (!findString("measGeotype_OBJECT", measGeotypeSubs))
        {warnSub("measGeotype_OBJECT", "measGeotype", a_measGeotype);}
      return;
    }
  if (isA(a_measGeotype, measGeotype_PARPLN))
    {
      if (!findString("measGeotype_PARPLN", measGeotypeSubs))
        {warnSub("measGeotype_PARPLN", "measGeotype", a_measGeotype);}
      return;
    }
  if (isA(a_measGeotype, measGeotype_PLANE))
    {
      if (!findString("measGeotype_PLANE", measGeotypeSubs))
        {warnSub("measGeotype_PLANE", "measGeotype", a_measGeotype);}
      return;
    }
  if (isA(a_measGeotype, measGeotype_REVSURF))
    {
      if (!findString("measGeotype_REVSURF", measGeotypeSubs))
        {warnSub("measGeotype_REVSURF", "measGeotype", a_measGeotype);}
      return;
    }
  if (isA(a_measGeotype, measGeotype_RCTNGL))
    {
      if (!findString("measGeotype_RCTNGL", measGeotypeSubs))
        {warnSub("measGeotype_RCTNGL", "measGeotype", a_measGeotype);}
      return;
    }
  if (isA(a_measGeotype, measGeotype_SPHERE))
    {
      if (!findString("measGeotype_SPHERE", measGeotypeSubs))
        {warnSub("measGeotype_SPHERE", "measGeotype", a_measGeotype);}
      return;
    }
  if (isA(a_measGeotype, measGeotype_SPHRADSEGMNT))
    {
      if (!findString("measGeotype_SPHRADSEGMNT", measGeotypeSubs))
        {warnSub("measGeotype_SPHRADSEGMNT", "measGeotype", a_measGeotype);}
      return;
    }
  if (isA(a_measGeotype, measGeotype_SYMPLN))
    {
      if (!findString("measGeotype_SYMPLN", measGeotypeSubs))
        {warnSub("measGeotype_SYMPLN", "measGeotype", a_measGeotype);}
      return;
    }
  if (isA(a_measGeotype, measGeotype_TORUS))
    {
      if (!findString("measGeotype_TORUS", measGeotypeSubs))
        {warnSub("measGeotype_TORUS", "measGeotype", a_measGeotype);}
      return;
    }
  if (isA(a_measGeotype, measGeotype_TORRADSEGMNT))
    {
      if (!findString("measGeotype_TORRADSEGMNT", measGeotypeSubs))
        {warnSub("measGeotype_TORRADSEGMNT", "measGeotype", a_measGeotype);}
      return;
    }
}

/********************************************************************/

void check_measIfBlock(
 measIfBlock * a_measIfBlock)
{
  if (a_measIfBlock->get_ifStm())
    {
      if (!findString("a_ifStm", measIfBlockAtts))
	{warnAttBlock("ifStm", a_measIfBlock->get_ifStm());}
      else
        check_ifStm(a_measIfBlock->get_ifStm());
    }
  if (a_measIfBlock->get_ifList())
    {
      if (!findString("ifList", measIfBlockAtts))
	{warnAttBlock("ifList", a_measIfBlock->get_ifList()->front());}
      else
        {
          std::list<measBlockItem *> * theList;
          std::list<measBlockItem *>::iterator iter;
          theList = a_measIfBlock->get_ifList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_measBlockItem(*iter);
        }
    }
  if (a_measIfBlock->get_elseStm())
    {
      if (!findString("a_elseStm", measIfBlockAtts))
	{warnAttBlock("elseStm", a_measIfBlock->get_elseStm());}
    }
  if (a_measIfBlock->get_elseList())
    {
      if (!findString("elseList", measIfBlockAtts))
	{warnAttBlock("elseList", a_measIfBlock->get_elseList()->front());}
      else
        {
          std::list<measBlockItem *> * theList;
          std::list<measBlockItem *>::iterator iter;
          theList = a_measIfBlock->get_elseList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_measBlockItem(*iter);
        }
    }
  if (a_measIfBlock->get_endifStm())
    {
      if (!findString("a_endifStm", measIfBlockAtts))
	{warnAttBlock("endifStm", a_measIfBlock->get_endifStm());}
    }
}

/********************************************************************/

void check_measMinor(
 measMinor * a_measMinor)
{
  if (isA(a_measMinor, measMinorOther))
    {
      if (!findString("measMinorOther", measMinorSubs))
        {warnSub("measMinorOther", "measMinor", a_measMinor);}
      else
        check_measMinorOther(dynamic_cast<measMinorOther *>(a_measMinor));
      return;
    }
  if (isA(a_measMinor, measMinorPoint))
    {
      if (!findString("measMinorPoint", measMinorSubs))
        {warnSub("measMinorPoint", "measMinor", a_measMinor);}
      return;
    }
  if (isA(a_measMinor, measMinorComp))
    {
      if (!findString("measMinorComp", measMinorSubs))
        {warnSub("measMinorComp", "measMinor", a_measMinor);}
      else
        check_measMinorComp(dynamic_cast<measMinorComp *>(a_measMinor));
      return;
    }
}

/********************************************************************/

void check_measMinorComp(
 measMinorComp * a_measMinorComp)
{
  if (a_measMinorComp->get_measVar2())
    {
      if (!findString("a_measVar2", measMinorCompAtts))
	{warnAtt("a_measVar2", "measMinorComp", a_measMinorComp);}
      else
        check_measVar2(a_measMinorComp->get_measVar2());
    }
}

/********************************************************************/

void check_measMinorOther(
 measMinorOther * a_measMinorOther)
{
  if (a_measMinorOther->get_measGeotype())
    {
      if (!findString("a_measGeotype", measMinorOtherAtts))
	{warnAtt("a_measGeotype", "measMinorOther", a_measMinorOther);}
      else
        check_measGeotype(a_measMinorOther->get_measGeotype());
    }
}

/********************************************************************/

void check_measSelectBlock(
 measSelectBlock * a_measSelectBlock)
{
  if (a_measSelectBlock->get_selectStm())
    {
      if (!findString("a_selectStm", measSelectBlockAtts))
	{warnAttBlock("selectStm", a_measSelectBlock->get_selectStm());}
      else
        check_selectStm(a_measSelectBlock->get_selectStm());
    }
  if (a_measSelectBlock->get_measCaseBlockList())
    {
      if (!findString("a_measCaseBlockList", measSelectBlockAtts))
	{warnAttBlock("measCaseBlockList", a_measSelectBlock->get_measCaseBlockList()->front());}
      else
        {
          std::list<measCaseBlock *> * theList;
          std::list<measCaseBlock *>::iterator iter;
          theList = a_measSelectBlock->get_measCaseBlockList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_measCaseBlock(*iter);
        }
    }
  if (a_measSelectBlock->get_measDefaultCaseBlock())
    {
      if (!findString("a_measDefaultCaseBlock", measSelectBlockAtts))
	{warnAttBlock("measDefaultCaseBlock", a_measSelectBlock->get_measDefaultCaseBlock());}
      else
        check_measDefaultCaseBlock(a_measSelectBlock->get_measDefaultCaseBlock());
    }
  if (a_measSelectBlock->get_endselStm())
    {
      if (!findString("a_endselStm", measSelectBlockAtts))
	{warnAttBlock("endselStm", a_measSelectBlock->get_endselStm());}
    }
}

/********************************************************************/

void check_measStm(
 measStm * a_measStm)
{
  if (a_measStm->get_measMinor())
    {
      if (!findString("a_measMinor", measStmAtts))
	{warnAtt("a_measMinor", "measStm", a_measStm);}
      else
        check_measMinor(a_measStm->get_measMinor());
    }
  if (a_measStm->get_fLabel())
    {
      if (!findString("a_fLabel", measStmAtts))
	{warnAtt("a_fLabel", "measStm", a_measStm);}
      else
        check_fLabel(a_measStm->get_fLabel());
    }
  if (a_measStm->get_numMeas())
    {
      if (!findString("numMeas", measStmAtts))
	{warnAtt("numMeas", "measStm", a_measStm);}
      else
        check_intVal(a_measStm->get_numMeas());
    }
}

/********************************************************************/

void check_measVar2(
 measVar2 * a_measVar2)
{
  if (isA(a_measVar2, measVar2_AXDIR))
    {
      if (!findString("measVar2_AXDIR", measVar2Subs))
        {warnSub("measVar2_AXDIR", "measVar2", a_measVar2);}
      return;
    }
  if (isA(a_measVar2, measVar2_DME))
    {
      if (!findString("measVar2_DME", measVar2Subs))
        {warnSub("measVar2_DME", "measVar2", a_measVar2);}
      return;
    }
  if (isA(a_measVar2, measVar2_FEAT))
    {
      if (!findString("measVar2_FEAT", measVar2Subs))
        {warnSub("measVar2_FEAT", "measVar2", a_measVar2);}
      else
        check_measVar2_FEAT(dynamic_cast<measVar2_FEAT *>(a_measVar2));
      return;
    }
  if (isA(a_measVar2, measVar2_POL))
    {
      if (!findString("measVar2_POL", measVar2Subs))
        {warnSub("measVar2_POL", "measVar2", a_measVar2);}
      return;
    }
  if (isA(a_measVar2, measVar2_SPH))
    {
      if (!findString("measVar2_SPH", measVar2Subs))
        {warnSub("measVar2_SPH", "measVar2", a_measVar2);}
      return;
    }
  if (isA(a_measVar2, measVar2_VEC))
    {
      if (!findString("measVar2_VEC", measVar2Subs))
        {warnSub("measVar2_VEC", "measVar2", a_measVar2);}
      else
        check_measVar2_VEC(dynamic_cast<measVar2_VEC *>(a_measVar2));
      return;
    }
}

/********************************************************************/

void check_measVar2Aux(
 measVar2Aux * a_measVar2Aux)
{
  if (isA(a_measVar2Aux, faLabel))
    {
      if (!findString("faLabel", measVar2AuxSubs))
        {warnSub("faLabel", "measVar2Aux", a_measVar2Aux);}
      else
        check_faLabel(dynamic_cast<faLabel *>(a_measVar2Aux));
      return;
    }
  if (isA(a_measVar2Aux, fLabel))
    {
      if (!findString("fLabel", measVar2AuxSubs))
        {warnSub("fLabel", "measVar2Aux", a_measVar2Aux);}
      else
        check_fLabel(dynamic_cast<fLabel *>(a_measVar2Aux));
      return;
    }
  if (isA(a_measVar2Aux, gLabel))
    {
      if (!findString("gLabel", measVar2AuxSubs))
        {warnSub("gLabel", "measVar2Aux", a_measVar2Aux);}
      else
        check_gLabel(dynamic_cast<gLabel *>(a_measVar2Aux));
      return;
    }
}

/********************************************************************/

void check_measVar2_FEAT(
 measVar2_FEAT * a_measVar2_FEAT)
{
  if (a_measVar2_FEAT->get_measVar2Aux())
    {
      if (!findString("a_measVar2Aux", measVar2_FEATAtts))
	{warnAtt("a_measVar2Aux", "measVar2_FEAT", a_measVar2_FEAT);}
      else
        check_measVar2Aux(a_measVar2_FEAT->get_measVar2Aux());
    }
}

/********************************************************************/

void check_measVar2_VEC(
 measVar2_VEC * a_measVar2_VEC)
{
  if (a_measVar2_VEC->get_compDir())
    {
      if (!findString("compDir", measVar2_VECAtts))
	{warnAtt("compDir", "measVar2_VEC", a_measVar2_VEC);}
      else
        check_vector(a_measVar2_VEC->get_compDir());
    }
}

/********************************************************************/

void check_mfgdevStm(
 mfgdevStm * a_mfgdevStm)
{
  if (a_mfgdevStm->get_mdLabel())
    {
      if (!findString("a_mdLabel", mfgdevStmAtts))
	{warnAtt("a_mdLabel", "mfgdevStm", a_mfgdevStm);}
      else
        check_mdLabel(a_mfgdevStm->get_mdLabel());
    }
  if (a_mfgdevStm->get_text())
    {
      if (!findString("text", mfgdevStmAtts))
	{warnAtt("text", "mfgdevStm", a_mfgdevStm);}
      else
        check_stringVal(a_mfgdevStm->get_text());
    }
}

/********************************************************************/

void check_midliConst(
 midliConst * a_midliConst)
{
  if (a_midliConst->get_faLabel())
    {
      if (!findString("a_faLabel", midliConstAtts))
	{warnAtt("a_faLabel", "midliConst", a_midliConst);}
      else
        check_faLabel(a_midliConst->get_faLabel());
    }
  if (a_midliConst->get_featureLabel())
    {
      if (!findString("a_featureLabel", midliConstAtts))
	{warnAtt("a_featureLabel", "midliConst", a_midliConst);}
      else
        check_featureLabel(a_midliConst->get_featureLabel());
    }
}

/********************************************************************/

void check_midplConst(
 midplConst * a_midplConst)
{
  if (a_midplConst->get_faLabel())
    {
      if (!findString("a_faLabel", midplConstAtts))
	{warnAtt("a_faLabel", "midplConst", a_midplConst);}
      else
        check_faLabel(a_midplConst->get_faLabel());
    }
  if (a_midplConst->get_featureLabel())
    {
      if (!findString("a_featureLabel", midplConstAtts))
	{warnAtt("a_featureLabel", "midplConst", a_midplConst);}
      else
        check_featureLabel(a_midplConst->get_featureLabel());
    }
}

/********************************************************************/

void check_midptConst(
 midptConst * a_midptConst)
{
  if (a_midptConst->get_faLabel())
    {
      if (!findString("a_faLabel", midptConstAtts))
	{warnAtt("a_faLabel", "midptConst", a_midptConst);}
      else
        check_faLabel(a_midptConst->get_faLabel());
    }
  if (a_midptConst->get_featureLabel())
    {
      if (!findString("a_featureLabel", midptConstAtts))
	{warnAtt("a_featureLabel", "midptConst", a_midptConst);}
      else
        check_featureLabel(a_midptConst->get_featureLabel());
    }
}

/********************************************************************/

void check_modeStm(
 modeStm * a_modeStm)
{
  if (a_modeStm->get_has_AUTO())
    {
      if (!findString("has_AUTO", modeStmAtts))
	{warnAtt("has_AUTO", "modeStm", a_modeStm);}
    }
  if (a_modeStm->get_has_PROG())
    {
      if (!findString("has_PROG", modeStmAtts))
	{warnAtt("has_PROG", "modeStm", a_modeStm);}
    }
}

/********************************************************************/

void check_moveptConst(
 moveptConst * a_moveptConst)
{
  if (isA(a_moveptConst, moveptConstVec))
    {
      if (!findString("moveptConstVec", moveptConstSubs))
        {warnSub("moveptConstVec", "moveptConst", a_moveptConst);}
      else
        check_moveptConstVec(dynamic_cast<moveptConstVec *>(a_moveptConst));
      return;
    }
  if (isA(a_moveptConst, moveptConstAxis))
    {
      if (!findString("moveptConstAxis", moveptConstSubs))
        {warnSub("moveptConstAxis", "moveptConst", a_moveptConst);}
      else
        check_moveptConstAxis(dynamic_cast<moveptConstAxis *>(a_moveptConst));
      return;
    }
}

/********************************************************************/

void check_moveptConstAxis(
 moveptConstAxis * a_moveptConstAxis)
{
  if (a_moveptConstAxis->get_faLabel())
    {
      if (!findString("a_faLabel", moveptConstAxisAtts))
	{warnAtt("a_faLabel", "moveptConstAxis", a_moveptConstAxis);}
      else
        check_faLabel(a_moveptConstAxis->get_faLabel());
    }
  if (a_moveptConstAxis->get_featureLabel())
    {
      if (!findString("a_featureLabel", moveptConstAxisAtts))
	{warnAtt("a_featureLabel", "moveptConstAxis", a_moveptConstAxis);}
      else
        check_featureLabel(a_moveptConstAxis->get_featureLabel());
    }
  if (a_moveptConstAxis->get_dist())
    {
      if (!findString("dist", moveptConstAxisAtts))
	{warnAtt("dist", "moveptConstAxis", a_moveptConstAxis);}
      else
        check_rentVal(a_moveptConstAxis->get_dist());
    }
}

/********************************************************************/

void check_moveptConstVec(
 moveptConstVec * a_moveptConstVec)
{
  if (a_moveptConstVec->get_faLabel())
    {
      if (!findString("a_faLabel", moveptConstVecAtts))
	{warnAtt("a_faLabel", "moveptConstVec", a_moveptConstVec);}
      else
        check_faLabel(a_moveptConstVec->get_faLabel());
    }
  if (a_moveptConstVec->get_offset())
    {
      if (!findString("offset", moveptConstVecAtts))
	{warnAtt("offset", "moveptConstVec", a_moveptConstVec);}
      else
        check_vector(a_moveptConstVec->get_offset());
    }
}

/********************************************************************/

void check_nearptConst(
 nearptConst * a_nearptConst)
{
  if (a_nearptConst->get_faLabel())
    {
      if (!findString("a_faLabel", nearptConstAtts))
	{warnAtt("a_faLabel", "nearptConst", a_nearptConst);}
      else
        check_faLabel(a_nearptConst->get_faLabel());
    }
}

/********************************************************************/

void check_negDir(
 negDir * a_negDir)
{
  if (isA(a_negDir, negDir_MINUSXDIR))
    {
      if (!findString("negDir_MINUSXDIR", negDirSubs))
        {warnSub("negDir_MINUSXDIR", "negDir", a_negDir);}
      return;
    }
  if (isA(a_negDir, negDir_MINUSYDIR))
    {
      if (!findString("negDir_MINUSYDIR", negDirSubs))
        {warnSub("negDir_MINUSYDIR", "negDir", a_negDir);}
      return;
    }
  if (isA(a_negDir, negDir_MINUSZDIR))
    {
      if (!findString("negDir_MINUSZDIR", negDirSubs))
        {warnSub("negDir_MINUSZDIR", "negDir", a_negDir);}
      return;
    }
}

/********************************************************************/

void check_noParseStm(
 noParseStm * a_noParseStm)
{
  if (a_noParseStm->get_string())
    {
      if (!findString("a_string", noParseStmAtts))
	{warnAtt("a_string", "noParseStm", a_noParseStm);}
    }
}

/********************************************************************/

void check_obtainBool(
 obtainBool * a_obtainBool)
{
  if (a_obtainBool->get_boolVar())
    {
      if (!findString("a_boolVar", obtainBoolAtts))
	{warnAtt("a_boolVar", "obtainBool", a_obtainBool);}
      else
        check_boolVar(a_obtainBool->get_boolVar());
    }
  if (a_obtainBool->get_obtainLabeled())
    {
      if (!findString("a_obtainLabeled", obtainBoolAtts))
	{warnAtt("a_obtainLabeled", "obtainBool", a_obtainBool);}
      else
        check_obtainLabeled(a_obtainBool->get_obtainLabeled());
    }
}

/********************************************************************/

void check_obtainInt(
 obtainInt * a_obtainInt)
{
  if (a_obtainInt->get_intVar())
    {
      if (!findString("a_intVar", obtainIntAtts))
	{warnAtt("a_intVar", "obtainInt", a_obtainInt);}
      else
        check_intVar(a_obtainInt->get_intVar());
    }
  if (a_obtainInt->get_obtainLabeled())
    {
      if (!findString("a_obtainLabeled", obtainIntAtts))
	{warnAtt("a_obtainLabeled", "obtainInt", a_obtainInt);}
      else
        check_obtainLabeled(a_obtainInt->get_obtainLabeled());
    }
}

/********************************************************************/

void check_obtainLabeled(
 obtainLabeled * a_obtainLabeled)
{
  if (isA(a_obtainLabeled, obtainLabeled_datumLabel1))
    {
      if (!findString("obtainLabeled_datumLabel1", obtainLabeledSubs))
        {warnSub("obtainLabeled_datumLabel1", "obtainLabeled", a_obtainLabeled);}
      else
        check_obtainLabeled_datumLabel1(dynamic_cast<obtainLabeled_datumLabel1 *>(a_obtainLabeled));
      return;
    }
  if (isA(a_obtainLabeled, obtainLabeled_featureLabel))
    {
      if (!findString("obtainLabeled_featureLabel", obtainLabeledSubs))
        {warnSub("obtainLabeled_featureLabel", "obtainLabeled", a_obtainLabeled);}
      else
        check_obtainLabeled_featureLabel(dynamic_cast<obtainLabeled_featureLabel *>(a_obtainLabeled));
      return;
    }
  if (isA(a_obtainLabeled, obtainLabeled_sensorLabel1))
    {
      if (!findString("obtainLabeled_sensorLabel1", obtainLabeledSubs))
        {warnSub("obtainLabeled_sensorLabel1", "obtainLabeled", a_obtainLabeled);}
      else
        check_obtainLabeled_sensorLabel1(dynamic_cast<obtainLabeled_sensorLabel1 *>(a_obtainLabeled));
      return;
    }
  if (isA(a_obtainLabeled, obtainLabeled_toleranceLabel))
    {
      if (!findString("obtainLabeled_toleranceLabel", obtainLabeledSubs))
        {warnSub("obtainLabeled_toleranceLabel", "obtainLabeled", a_obtainLabeled);}
      else
        check_obtainLabeled_toleranceLabel(dynamic_cast<obtainLabeled_toleranceLabel *>(a_obtainLabeled));
      return;
    }
  if (isA(a_obtainLabeled, obtainLabeled_didLabel))
    {
      if (!findString("obtainLabeled_didLabel", obtainLabeledSubs))
        {warnSub("obtainLabeled_didLabel", "obtainLabeled", a_obtainLabeled);}
      else
        check_obtainLabeled_didLabel(dynamic_cast<obtainLabeled_didLabel *>(a_obtainLabeled));
      return;
    }
  if (isA(a_obtainLabeled, obtainLabeled_qisLabel))
    {
      if (!findString("obtainLabeled_qisLabel", obtainLabeledSubs))
        {warnSub("obtainLabeled_qisLabel", "obtainLabeled", a_obtainLabeled);}
      else
        check_obtainLabeled_qisLabel(dynamic_cast<obtainLabeled_qisLabel *>(a_obtainLabeled));
      return;
    }
  if (isA(a_obtainLabeled, obtainLabeled_crLabel))
    {
      if (!findString("obtainLabeled_crLabel", obtainLabeledSubs))
        {warnSub("obtainLabeled_crLabel", "obtainLabeled", a_obtainLabeled);}
      else
        check_obtainLabeled_crLabel(dynamic_cast<obtainLabeled_crLabel *>(a_obtainLabeled));
      return;
    }
  if (isA(a_obtainLabeled, obtainLabeled_gLabel))
    {
      if (!findString("obtainLabeled_gLabel", obtainLabeledSubs))
        {warnSub("obtainLabeled_gLabel", "obtainLabeled", a_obtainLabeled);}
      else
        check_obtainLabeled_gLabel(dynamic_cast<obtainLabeled_gLabel *>(a_obtainLabeled));
      return;
    }
  if (isA(a_obtainLabeled, obtainLabeled_gsaLabel))
    {
      if (!findString("obtainLabeled_gsaLabel", obtainLabeledSubs))
        {warnSub("obtainLabeled_gsaLabel", "obtainLabeled", a_obtainLabeled);}
      else
        check_obtainLabeled_gsaLabel(dynamic_cast<obtainLabeled_gsaLabel *>(a_obtainLabeled));
      return;
    }
  if (isA(a_obtainLabeled, obtainLabeled_kcLabel))
    {
      if (!findString("obtainLabeled_kcLabel", obtainLabeledSubs))
        {warnSub("obtainLabeled_kcLabel", "obtainLabeled", a_obtainLabeled);}
      else
        check_obtainLabeled_kcLabel(dynamic_cast<obtainLabeled_kcLabel *>(a_obtainLabeled));
      return;
    }
  if (isA(a_obtainLabeled, obtainLabeled_maLabel))
    {
      if (!findString("obtainLabeled_maLabel", obtainLabeledSubs))
        {warnSub("obtainLabeled_maLabel", "obtainLabeled", a_obtainLabeled);}
      else
        check_obtainLabeled_maLabel(dynamic_cast<obtainLabeled_maLabel *>(a_obtainLabeled));
      return;
    }
  if (isA(a_obtainLabeled, obtainLabeled_pLabel))
    {
      if (!findString("obtainLabeled_pLabel", obtainLabeledSubs))
        {warnSub("obtainLabeled_pLabel", "obtainLabeled", a_obtainLabeled);}
      else
        check_obtainLabeled_pLabel(dynamic_cast<obtainLabeled_pLabel *>(a_obtainLabeled));
      return;
    }
  if (isA(a_obtainLabeled, obtainLabeled_rLabel))
    {
      if (!findString("obtainLabeled_rLabel", obtainLabeledSubs))
        {warnSub("obtainLabeled_rLabel", "obtainLabeled", a_obtainLabeled);}
      else
        check_obtainLabeled_rLabel(dynamic_cast<obtainLabeled_rLabel *>(a_obtainLabeled));
      return;
    }
  if (isA(a_obtainLabeled, obtainLabeled_rmLabel))
    {
      if (!findString("obtainLabeled_rmLabel", obtainLabeledSubs))
        {warnSub("obtainLabeled_rmLabel", "obtainLabeled", a_obtainLabeled);}
      else
        check_obtainLabeled_rmLabel(dynamic_cast<obtainLabeled_rmLabel *>(a_obtainLabeled));
      return;
    }
  if (isA(a_obtainLabeled, obtainLabeled_rtLabel))
    {
      if (!findString("obtainLabeled_rtLabel", obtainLabeledSubs))
        {warnSub("obtainLabeled_rtLabel", "obtainLabeled", a_obtainLabeled);}
      else
        check_obtainLabeled_rtLabel(dynamic_cast<obtainLabeled_rtLabel *>(a_obtainLabeled));
      return;
    }
  if (isA(a_obtainLabeled, obtainLabeled_sgLabel))
    {
      if (!findString("obtainLabeled_sgLabel", obtainLabeledSubs))
        {warnSub("obtainLabeled_sgLabel", "obtainLabeled", a_obtainLabeled);}
      else
        check_obtainLabeled_sgLabel(dynamic_cast<obtainLabeled_sgLabel *>(a_obtainLabeled));
      return;
    }
  if (isA(a_obtainLabeled, obtainLabeled_sgsLabel))
    {
      if (!findString("obtainLabeled_sgsLabel", obtainLabeledSubs))
        {warnSub("obtainLabeled_sgsLabel", "obtainLabeled", a_obtainLabeled);}
      else
        check_obtainLabeled_sgsLabel(dynamic_cast<obtainLabeled_sgsLabel *>(a_obtainLabeled));
      return;
    }
  if (isA(a_obtainLabeled, obtainLabeled_sraLabel))
    {
      if (!findString("obtainLabeled_sraLabel", obtainLabeledSubs))
        {warnSub("obtainLabeled_sraLabel", "obtainLabeled", a_obtainLabeled);}
      else
        check_obtainLabeled_sraLabel(dynamic_cast<obtainLabeled_sraLabel *>(a_obtainLabeled));
      return;
    }
  if (isA(a_obtainLabeled, obtainLabeled_ssLabel))
    {
      if (!findString("obtainLabeled_ssLabel", obtainLabeledSubs))
        {warnSub("obtainLabeled_ssLabel", "obtainLabeled", a_obtainLabeled);}
      else
        check_obtainLabeled_ssLabel(dynamic_cast<obtainLabeled_ssLabel *>(a_obtainLabeled));
      return;
    }
  if (isA(a_obtainLabeled, obtainLabeled_swLabel))
    {
      if (!findString("obtainLabeled_swLabel", obtainLabeledSubs))
        {warnSub("obtainLabeled_swLabel", "obtainLabeled", a_obtainLabeled);}
      else
        check_obtainLabeled_swLabel(dynamic_cast<obtainLabeled_swLabel *>(a_obtainLabeled));
      return;
    }
  if (isA(a_obtainLabeled, obtainLabeled_sxLabel))
    {
      if (!findString("obtainLabeled_sxLabel", obtainLabeledSubs))
        {warnSub("obtainLabeled_sxLabel", "obtainLabeled", a_obtainLabeled);}
      else
        check_obtainLabeled_sxLabel(dynamic_cast<obtainLabeled_sxLabel *>(a_obtainLabeled));
      return;
    }
  if (isA(a_obtainLabeled, obtainLabeled_thLabel))
    {
      if (!findString("obtainLabeled_thLabel", obtainLabeledSubs))
        {warnSub("obtainLabeled_thLabel", "obtainLabeled", a_obtainLabeled);}
      else
        check_obtainLabeled_thLabel(dynamic_cast<obtainLabeled_thLabel *>(a_obtainLabeled));
      return;
    }
  if (isA(a_obtainLabeled, obtainLabeled_vLabel))
    {
      if (!findString("obtainLabeled_vLabel", obtainLabeledSubs))
        {warnSub("obtainLabeled_vLabel", "obtainLabeled", a_obtainLabeled);}
      else
        check_obtainLabeled_vLabel(dynamic_cast<obtainLabeled_vLabel *>(a_obtainLabeled));
      return;
    }
  if (isA(a_obtainLabeled, obtainLabeled_vaLabel))
    {
      if (!findString("obtainLabeled_vaLabel", obtainLabeledSubs))
        {warnSub("obtainLabeled_vaLabel", "obtainLabeled", a_obtainLabeled);}
      else
        check_obtainLabeled_vaLabel(dynamic_cast<obtainLabeled_vaLabel *>(a_obtainLabeled));
      return;
    }
  if (isA(a_obtainLabeled, obtainLabeled_vfLabel))
    {
      if (!findString("obtainLabeled_vfLabel", obtainLabeledSubs))
        {warnSub("obtainLabeled_vfLabel", "obtainLabeled", a_obtainLabeled);}
      else
        check_obtainLabeled_vfLabel(dynamic_cast<obtainLabeled_vfLabel *>(a_obtainLabeled));
      return;
    }
  if (isA(a_obtainLabeled, obtainLabeled_vlLabel))
    {
      if (!findString("obtainLabeled_vlLabel", obtainLabeledSubs))
        {warnSub("obtainLabeled_vlLabel", "obtainLabeled", a_obtainLabeled);}
      else
        check_obtainLabeled_vlLabel(dynamic_cast<obtainLabeled_vlLabel *>(a_obtainLabeled));
      return;
    }
  if (isA(a_obtainLabeled, obtainLabeled_vwLabel))
    {
      if (!findString("obtainLabeled_vwLabel", obtainLabeledSubs))
        {warnSub("obtainLabeled_vwLabel", "obtainLabeled", a_obtainLabeled);}
      else
        check_obtainLabeled_vwLabel(dynamic_cast<obtainLabeled_vwLabel *>(a_obtainLabeled));
      return;
    }
}

/********************************************************************/

void check_obtainLabeled_crLabel(
 obtainLabeled_crLabel * a_obtainLabeled_crLabel)
{
  if (a_obtainLabeled_crLabel->get_crLabel())
    {
      if (!findString("a_crLabel", obtainLabeled_crLabelAtts))
	{warnAtt("a_crLabel", "obtainLabeled_crLabel", a_obtainLabeled_crLabel);}
      else
        check_crLabel(a_obtainLabeled_crLabel->get_crLabel());
    }
  if (a_obtainLabeled_crLabel->get_index())
    {
      if (!findString("index", obtainLabeled_crLabelAtts))
	{warnAtt("index", "obtainLabeled_crLabel", a_obtainLabeled_crLabel);}
      else
        check_intVal(a_obtainLabeled_crLabel->get_index());
    }
}

/********************************************************************/

void check_obtainLabeled_datumLabel1(
 obtainLabeled_datumLabel1 * a_obtainLabeled_datumLabel1)
{
  if (a_obtainLabeled_datumLabel1->get_datumLabel1())
    {
      if (!findString("a_datumLabel1", obtainLabeled_datumLabel1Atts))
	{warnAtt("a_datumLabel1", "obtainLabeled_datumLabel1", a_obtainLabeled_datumLabel1);}
      else
        check_datumLabel1(a_obtainLabeled_datumLabel1->get_datumLabel1());
    }
  if (a_obtainLabeled_datumLabel1->get_index())
    {
      if (!findString("index", obtainLabeled_datumLabel1Atts))
	{warnAtt("index", "obtainLabeled_datumLabel1", a_obtainLabeled_datumLabel1);}
      else
        check_intVal(a_obtainLabeled_datumLabel1->get_index());
    }
}

/********************************************************************/

void check_obtainLabeled_didLabel(
 obtainLabeled_didLabel * a_obtainLabeled_didLabel)
{
  if (a_obtainLabeled_didLabel->get_didLabel())
    {
      if (!findString("a_didLabel", obtainLabeled_didLabelAtts))
	{warnAtt("a_didLabel", "obtainLabeled_didLabel", a_obtainLabeled_didLabel);}
      else
        check_didLabel(a_obtainLabeled_didLabel->get_didLabel());
    }
  if (a_obtainLabeled_didLabel->get_index())
    {
      if (!findString("index", obtainLabeled_didLabelAtts))
	{warnAtt("index", "obtainLabeled_didLabel", a_obtainLabeled_didLabel);}
      else
        check_intVal(a_obtainLabeled_didLabel->get_index());
    }
}

/********************************************************************/

void check_obtainLabeled_featureLabel(
 obtainLabeled_featureLabel * a_obtainLabeled_featureLabel)
{
  if (a_obtainLabeled_featureLabel->get_featureLabel())
    {
      if (!findString("a_featureLabel", obtainLabeled_featureLabelAtts))
	{warnAtt("a_featureLabel", "obtainLabeled_featureLabel", a_obtainLabeled_featureLabel);}
      else
        check_featureLabel(a_obtainLabeled_featureLabel->get_featureLabel());
    }
  if (a_obtainLabeled_featureLabel->get_index())
    {
      if (!findString("index", obtainLabeled_featureLabelAtts))
	{warnAtt("index", "obtainLabeled_featureLabel", a_obtainLabeled_featureLabel);}
      else
        check_intVal(a_obtainLabeled_featureLabel->get_index());
    }
}

/********************************************************************/

void check_obtainLabeled_gLabel(
 obtainLabeled_gLabel * a_obtainLabeled_gLabel)
{
  if (a_obtainLabeled_gLabel->get_gLabel())
    {
      if (!findString("a_gLabel", obtainLabeled_gLabelAtts))
	{warnAtt("a_gLabel", "obtainLabeled_gLabel", a_obtainLabeled_gLabel);}
      else
        check_gLabel(a_obtainLabeled_gLabel->get_gLabel());
    }
  if (a_obtainLabeled_gLabel->get_index())
    {
      if (!findString("index", obtainLabeled_gLabelAtts))
	{warnAtt("index", "obtainLabeled_gLabel", a_obtainLabeled_gLabel);}
      else
        check_intVal(a_obtainLabeled_gLabel->get_index());
    }
}

/********************************************************************/

void check_obtainLabeled_gsaLabel(
 obtainLabeled_gsaLabel * a_obtainLabeled_gsaLabel)
{
  if (a_obtainLabeled_gsaLabel->get_gsaLabel())
    {
      if (!findString("a_gsaLabel", obtainLabeled_gsaLabelAtts))
	{warnAtt("a_gsaLabel", "obtainLabeled_gsaLabel", a_obtainLabeled_gsaLabel);}
      else
        check_gsaLabel(a_obtainLabeled_gsaLabel->get_gsaLabel());
    }
  if (a_obtainLabeled_gsaLabel->get_index())
    {
      if (!findString("index", obtainLabeled_gsaLabelAtts))
	{warnAtt("index", "obtainLabeled_gsaLabel", a_obtainLabeled_gsaLabel);}
      else
        check_intVal(a_obtainLabeled_gsaLabel->get_index());
    }
}

/********************************************************************/

void check_obtainLabeled_kcLabel(
 obtainLabeled_kcLabel * a_obtainLabeled_kcLabel)
{
  if (a_obtainLabeled_kcLabel->get_kcLabel())
    {
      if (!findString("a_kcLabel", obtainLabeled_kcLabelAtts))
	{warnAtt("a_kcLabel", "obtainLabeled_kcLabel", a_obtainLabeled_kcLabel);}
      else
        check_kcLabel(a_obtainLabeled_kcLabel->get_kcLabel());
    }
  if (a_obtainLabeled_kcLabel->get_index())
    {
      if (!findString("index", obtainLabeled_kcLabelAtts))
	{warnAtt("index", "obtainLabeled_kcLabel", a_obtainLabeled_kcLabel);}
      else
        check_intVal(a_obtainLabeled_kcLabel->get_index());
    }
}

/********************************************************************/

void check_obtainLabeled_maLabel(
 obtainLabeled_maLabel * a_obtainLabeled_maLabel)
{
  if (a_obtainLabeled_maLabel->get_maLabel())
    {
      if (!findString("a_maLabel", obtainLabeled_maLabelAtts))
	{warnAtt("a_maLabel", "obtainLabeled_maLabel", a_obtainLabeled_maLabel);}
      else
        check_maLabel(a_obtainLabeled_maLabel->get_maLabel());
    }
  if (a_obtainLabeled_maLabel->get_index())
    {
      if (!findString("index", obtainLabeled_maLabelAtts))
	{warnAtt("index", "obtainLabeled_maLabel", a_obtainLabeled_maLabel);}
      else
        check_intVal(a_obtainLabeled_maLabel->get_index());
    }
}

/********************************************************************/

void check_obtainLabeled_pLabel(
 obtainLabeled_pLabel * a_obtainLabeled_pLabel)
{
  if (a_obtainLabeled_pLabel->get_pLabel())
    {
      if (!findString("a_pLabel", obtainLabeled_pLabelAtts))
	{warnAtt("a_pLabel", "obtainLabeled_pLabel", a_obtainLabeled_pLabel);}
      else
        check_pLabel(a_obtainLabeled_pLabel->get_pLabel());
    }
  if (a_obtainLabeled_pLabel->get_index())
    {
      if (!findString("index", obtainLabeled_pLabelAtts))
	{warnAtt("index", "obtainLabeled_pLabel", a_obtainLabeled_pLabel);}
      else
        check_intVal(a_obtainLabeled_pLabel->get_index());
    }
}

/********************************************************************/

void check_obtainLabeled_qisLabel(
 obtainLabeled_qisLabel * a_obtainLabeled_qisLabel)
{
  if (a_obtainLabeled_qisLabel->get_qisLabel())
    {
      if (!findString("a_qisLabel", obtainLabeled_qisLabelAtts))
	{warnAtt("a_qisLabel", "obtainLabeled_qisLabel", a_obtainLabeled_qisLabel);}
      else
        check_qisLabel(a_obtainLabeled_qisLabel->get_qisLabel());
    }
  if (a_obtainLabeled_qisLabel->get_index())
    {
      if (!findString("index", obtainLabeled_qisLabelAtts))
	{warnAtt("index", "obtainLabeled_qisLabel", a_obtainLabeled_qisLabel);}
      else
        check_intVal(a_obtainLabeled_qisLabel->get_index());
    }
}

/********************************************************************/

void check_obtainLabeled_rLabel(
 obtainLabeled_rLabel * a_obtainLabeled_rLabel)
{
  if (a_obtainLabeled_rLabel->get_rLabel())
    {
      if (!findString("a_rLabel", obtainLabeled_rLabelAtts))
	{warnAtt("a_rLabel", "obtainLabeled_rLabel", a_obtainLabeled_rLabel);}
      else
        check_rLabel(a_obtainLabeled_rLabel->get_rLabel());
    }
  if (a_obtainLabeled_rLabel->get_index())
    {
      if (!findString("index", obtainLabeled_rLabelAtts))
	{warnAtt("index", "obtainLabeled_rLabel", a_obtainLabeled_rLabel);}
      else
        check_intVal(a_obtainLabeled_rLabel->get_index());
    }
}

/********************************************************************/

void check_obtainLabeled_rmLabel(
 obtainLabeled_rmLabel * a_obtainLabeled_rmLabel)
{
  if (a_obtainLabeled_rmLabel->get_rmLabel())
    {
      if (!findString("a_rmLabel", obtainLabeled_rmLabelAtts))
	{warnAtt("a_rmLabel", "obtainLabeled_rmLabel", a_obtainLabeled_rmLabel);}
      else
        check_rmLabel(a_obtainLabeled_rmLabel->get_rmLabel());
    }
  if (a_obtainLabeled_rmLabel->get_index())
    {
      if (!findString("index", obtainLabeled_rmLabelAtts))
	{warnAtt("index", "obtainLabeled_rmLabel", a_obtainLabeled_rmLabel);}
      else
        check_intVal(a_obtainLabeled_rmLabel->get_index());
    }
}

/********************************************************************/

void check_obtainLabeled_rtLabel(
 obtainLabeled_rtLabel * a_obtainLabeled_rtLabel)
{
  if (a_obtainLabeled_rtLabel->get_rtLabel())
    {
      if (!findString("a_rtLabel", obtainLabeled_rtLabelAtts))
	{warnAtt("a_rtLabel", "obtainLabeled_rtLabel", a_obtainLabeled_rtLabel);}
      else
        check_rtLabel(a_obtainLabeled_rtLabel->get_rtLabel());
    }
  if (a_obtainLabeled_rtLabel->get_index())
    {
      if (!findString("index", obtainLabeled_rtLabelAtts))
	{warnAtt("index", "obtainLabeled_rtLabel", a_obtainLabeled_rtLabel);}
      else
        check_intVal(a_obtainLabeled_rtLabel->get_index());
    }
}

/********************************************************************/

void check_obtainLabeled_sensorLabel1(
 obtainLabeled_sensorLabel1 * a_obtainLabeled_sensorLabel1)
{
  if (a_obtainLabeled_sensorLabel1->get_sensorLabel1())
    {
      if (!findString("a_sensorLabel1", obtainLabeled_sensorLabel1Atts))
	{warnAtt("a_sensorLabel1", "obtainLabeled_sensorLabel1", a_obtainLabeled_sensorLabel1);}
      else
        check_sensorLabel1(a_obtainLabeled_sensorLabel1->get_sensorLabel1());
    }
  if (a_obtainLabeled_sensorLabel1->get_index())
    {
      if (!findString("index", obtainLabeled_sensorLabel1Atts))
	{warnAtt("index", "obtainLabeled_sensorLabel1", a_obtainLabeled_sensorLabel1);}
      else
        check_intVal(a_obtainLabeled_sensorLabel1->get_index());
    }
}

/********************************************************************/

void check_obtainLabeled_sgLabel(
 obtainLabeled_sgLabel * a_obtainLabeled_sgLabel)
{
  if (a_obtainLabeled_sgLabel->get_sgLabel())
    {
      if (!findString("a_sgLabel", obtainLabeled_sgLabelAtts))
	{warnAtt("a_sgLabel", "obtainLabeled_sgLabel", a_obtainLabeled_sgLabel);}
      else
        check_sgLabel(a_obtainLabeled_sgLabel->get_sgLabel());
    }
  if (a_obtainLabeled_sgLabel->get_index())
    {
      if (!findString("index", obtainLabeled_sgLabelAtts))
	{warnAtt("index", "obtainLabeled_sgLabel", a_obtainLabeled_sgLabel);}
      else
        check_intVal(a_obtainLabeled_sgLabel->get_index());
    }
}

/********************************************************************/

void check_obtainLabeled_sgsLabel(
 obtainLabeled_sgsLabel * a_obtainLabeled_sgsLabel)
{
  if (a_obtainLabeled_sgsLabel->get_sgsLabel())
    {
      if (!findString("a_sgsLabel", obtainLabeled_sgsLabelAtts))
	{warnAtt("a_sgsLabel", "obtainLabeled_sgsLabel", a_obtainLabeled_sgsLabel);}
      else
        check_sgsLabel(a_obtainLabeled_sgsLabel->get_sgsLabel());
    }
  if (a_obtainLabeled_sgsLabel->get_index())
    {
      if (!findString("index", obtainLabeled_sgsLabelAtts))
	{warnAtt("index", "obtainLabeled_sgsLabel", a_obtainLabeled_sgsLabel);}
      else
        check_intVal(a_obtainLabeled_sgsLabel->get_index());
    }
}

/********************************************************************/

void check_obtainLabeled_sraLabel(
 obtainLabeled_sraLabel * a_obtainLabeled_sraLabel)
{
  if (a_obtainLabeled_sraLabel->get_sraLabel())
    {
      if (!findString("a_sraLabel", obtainLabeled_sraLabelAtts))
	{warnAtt("a_sraLabel", "obtainLabeled_sraLabel", a_obtainLabeled_sraLabel);}
      else
        check_sraLabel(a_obtainLabeled_sraLabel->get_sraLabel());
    }
  if (a_obtainLabeled_sraLabel->get_index())
    {
      if (!findString("index", obtainLabeled_sraLabelAtts))
	{warnAtt("index", "obtainLabeled_sraLabel", a_obtainLabeled_sraLabel);}
      else
        check_intVal(a_obtainLabeled_sraLabel->get_index());
    }
}

/********************************************************************/

void check_obtainLabeled_ssLabel(
 obtainLabeled_ssLabel * a_obtainLabeled_ssLabel)
{
  if (a_obtainLabeled_ssLabel->get_ssLabel())
    {
      if (!findString("a_ssLabel", obtainLabeled_ssLabelAtts))
	{warnAtt("a_ssLabel", "obtainLabeled_ssLabel", a_obtainLabeled_ssLabel);}
      else
        check_ssLabel(a_obtainLabeled_ssLabel->get_ssLabel());
    }
  if (a_obtainLabeled_ssLabel->get_index())
    {
      if (!findString("index", obtainLabeled_ssLabelAtts))
	{warnAtt("index", "obtainLabeled_ssLabel", a_obtainLabeled_ssLabel);}
      else
        check_intVal(a_obtainLabeled_ssLabel->get_index());
    }
}

/********************************************************************/

void check_obtainLabeled_swLabel(
 obtainLabeled_swLabel * a_obtainLabeled_swLabel)
{
  if (a_obtainLabeled_swLabel->get_swLabel())
    {
      if (!findString("a_swLabel", obtainLabeled_swLabelAtts))
	{warnAtt("a_swLabel", "obtainLabeled_swLabel", a_obtainLabeled_swLabel);}
      else
        check_swLabel(a_obtainLabeled_swLabel->get_swLabel());
    }
  if (a_obtainLabeled_swLabel->get_index())
    {
      if (!findString("index", obtainLabeled_swLabelAtts))
	{warnAtt("index", "obtainLabeled_swLabel", a_obtainLabeled_swLabel);}
      else
        check_intVal(a_obtainLabeled_swLabel->get_index());
    }
}

/********************************************************************/

void check_obtainLabeled_sxLabel(
 obtainLabeled_sxLabel * a_obtainLabeled_sxLabel)
{
  if (a_obtainLabeled_sxLabel->get_sxLabel())
    {
      if (!findString("a_sxLabel", obtainLabeled_sxLabelAtts))
	{warnAtt("a_sxLabel", "obtainLabeled_sxLabel", a_obtainLabeled_sxLabel);}
      else
        check_sxLabel(a_obtainLabeled_sxLabel->get_sxLabel());
    }
  if (a_obtainLabeled_sxLabel->get_index())
    {
      if (!findString("index", obtainLabeled_sxLabelAtts))
	{warnAtt("index", "obtainLabeled_sxLabel", a_obtainLabeled_sxLabel);}
      else
        check_intVal(a_obtainLabeled_sxLabel->get_index());
    }
}

/********************************************************************/

void check_obtainLabeled_thLabel(
 obtainLabeled_thLabel * a_obtainLabeled_thLabel)
{
  if (a_obtainLabeled_thLabel->get_thLabel())
    {
      if (!findString("a_thLabel", obtainLabeled_thLabelAtts))
	{warnAtt("a_thLabel", "obtainLabeled_thLabel", a_obtainLabeled_thLabel);}
      else
        check_thLabel(a_obtainLabeled_thLabel->get_thLabel());
    }
  if (a_obtainLabeled_thLabel->get_index())
    {
      if (!findString("index", obtainLabeled_thLabelAtts))
	{warnAtt("index", "obtainLabeled_thLabel", a_obtainLabeled_thLabel);}
      else
        check_intVal(a_obtainLabeled_thLabel->get_index());
    }
}

/********************************************************************/

void check_obtainLabeled_toleranceLabel(
 obtainLabeled_toleranceLabel * a_obtainLabeled_toleranceLabel)
{
  if (a_obtainLabeled_toleranceLabel->get_toleranceLabel())
    {
      if (!findString("a_toleranceLabel", obtainLabeled_toleranceLabelAtts))
	{warnAtt("a_toleranceLabel", "obtainLabeled_toleranceLabel", a_obtainLabeled_toleranceLabel);}
      else
        check_toleranceLabel(a_obtainLabeled_toleranceLabel->get_toleranceLabel());
    }
  if (a_obtainLabeled_toleranceLabel->get_index())
    {
      if (!findString("index", obtainLabeled_toleranceLabelAtts))
	{warnAtt("index", "obtainLabeled_toleranceLabel", a_obtainLabeled_toleranceLabel);}
      else
        check_intVal(a_obtainLabeled_toleranceLabel->get_index());
    }
}

/********************************************************************/

void check_obtainLabeled_vLabel(
 obtainLabeled_vLabel * a_obtainLabeled_vLabel)
{
  if (a_obtainLabeled_vLabel->get_vLabel())
    {
      if (!findString("a_vLabel", obtainLabeled_vLabelAtts))
	{warnAtt("a_vLabel", "obtainLabeled_vLabel", a_obtainLabeled_vLabel);}
      else
        check_vLabel(a_obtainLabeled_vLabel->get_vLabel());
    }
  if (a_obtainLabeled_vLabel->get_index())
    {
      if (!findString("index", obtainLabeled_vLabelAtts))
	{warnAtt("index", "obtainLabeled_vLabel", a_obtainLabeled_vLabel);}
      else
        check_intVal(a_obtainLabeled_vLabel->get_index());
    }
}

/********************************************************************/

void check_obtainLabeled_vaLabel(
 obtainLabeled_vaLabel * a_obtainLabeled_vaLabel)
{
  if (a_obtainLabeled_vaLabel->get_vaLabel())
    {
      if (!findString("a_vaLabel", obtainLabeled_vaLabelAtts))
	{warnAtt("a_vaLabel", "obtainLabeled_vaLabel", a_obtainLabeled_vaLabel);}
      else
        check_vaLabel(a_obtainLabeled_vaLabel->get_vaLabel());
    }
  if (a_obtainLabeled_vaLabel->get_index())
    {
      if (!findString("index", obtainLabeled_vaLabelAtts))
	{warnAtt("index", "obtainLabeled_vaLabel", a_obtainLabeled_vaLabel);}
      else
        check_intVal(a_obtainLabeled_vaLabel->get_index());
    }
}

/********************************************************************/

void check_obtainLabeled_vfLabel(
 obtainLabeled_vfLabel * a_obtainLabeled_vfLabel)
{
  if (a_obtainLabeled_vfLabel->get_vfLabel())
    {
      if (!findString("a_vfLabel", obtainLabeled_vfLabelAtts))
	{warnAtt("a_vfLabel", "obtainLabeled_vfLabel", a_obtainLabeled_vfLabel);}
      else
        check_vfLabel(a_obtainLabeled_vfLabel->get_vfLabel());
    }
  if (a_obtainLabeled_vfLabel->get_index())
    {
      if (!findString("index", obtainLabeled_vfLabelAtts))
	{warnAtt("index", "obtainLabeled_vfLabel", a_obtainLabeled_vfLabel);}
      else
        check_intVal(a_obtainLabeled_vfLabel->get_index());
    }
}

/********************************************************************/

void check_obtainLabeled_vlLabel(
 obtainLabeled_vlLabel * a_obtainLabeled_vlLabel)
{
  if (a_obtainLabeled_vlLabel->get_vlLabel())
    {
      if (!findString("a_vlLabel", obtainLabeled_vlLabelAtts))
	{warnAtt("a_vlLabel", "obtainLabeled_vlLabel", a_obtainLabeled_vlLabel);}
      else
        check_vlLabel(a_obtainLabeled_vlLabel->get_vlLabel());
    }
  if (a_obtainLabeled_vlLabel->get_index())
    {
      if (!findString("index", obtainLabeled_vlLabelAtts))
	{warnAtt("index", "obtainLabeled_vlLabel", a_obtainLabeled_vlLabel);}
      else
        check_intVal(a_obtainLabeled_vlLabel->get_index());
    }
}

/********************************************************************/

void check_obtainLabeled_vwLabel(
 obtainLabeled_vwLabel * a_obtainLabeled_vwLabel)
{
  if (a_obtainLabeled_vwLabel->get_vwLabel())
    {
      if (!findString("a_vwLabel", obtainLabeled_vwLabelAtts))
	{warnAtt("a_vwLabel", "obtainLabeled_vwLabel", a_obtainLabeled_vwLabel);}
      else
        check_vwLabel(a_obtainLabeled_vwLabel->get_vwLabel());
    }
  if (a_obtainLabeled_vwLabel->get_index())
    {
      if (!findString("index", obtainLabeled_vwLabelAtts))
	{warnAtt("index", "obtainLabeled_vwLabel", a_obtainLabeled_vwLabel);}
      else
        check_intVal(a_obtainLabeled_vwLabel->get_index());
    }
}

/********************************************************************/

void check_obtainPoint(
 obtainPoint * a_obtainPoint)
{
  if (a_obtainPoint->get_featureLabel())
    {
      if (!findString("a_featureLabel", obtainPointAtts))
	{warnAtt("a_featureLabel", "obtainPoint", a_obtainPoint);}
      else
        check_featureLabel(a_obtainPoint->get_featureLabel());
    }
  if (a_obtainPoint->get_subscr())
    {
      if (!findString("subscr", obtainPointAtts))
	{warnAtt("subscr", "obtainPoint", a_obtainPoint);}
      else
        check_intVal(a_obtainPoint->get_subscr());
    }
  if (a_obtainPoint->get_index())
    {
      if (!findString("index", obtainPointAtts))
	{warnAtt("index", "obtainPoint", a_obtainPoint);}
      else
        check_intVal(a_obtainPoint->get_index());
    }
}

/********************************************************************/

void check_obtainRealLabel(
 obtainRealLabel * a_obtainRealLabel)
{
  if (a_obtainRealLabel->get_realVar())
    {
      if (!findString("a_realVar", obtainRealLabelAtts))
	{warnAtt("a_realVar", "obtainRealLabel", a_obtainRealLabel);}
      else
        check_realVar(a_obtainRealLabel->get_realVar());
    }
  if (a_obtainRealLabel->get_obtainLabeled())
    {
      if (!findString("a_obtainLabeled", obtainRealLabelAtts))
	{warnAtt("a_obtainLabeled", "obtainRealLabel", a_obtainRealLabel);}
      else
        check_obtainLabeled(a_obtainRealLabel->get_obtainLabeled());
    }
}

/********************************************************************/

void check_obtainRealPoint(
 obtainRealPoint * a_obtainRealPoint)
{
  if (a_obtainRealPoint->get_realVar())
    {
      if (!findString("a_realVar", obtainRealPointAtts))
	{warnAtt("a_realVar", "obtainRealPoint", a_obtainRealPoint);}
      else
        check_realVar(a_obtainRealPoint->get_realVar());
    }
  if (a_obtainRealPoint->get_obtainPoint())
    {
      if (!findString("a_obtainPoint", obtainRealPointAtts))
	{warnAtt("a_obtainPoint", "obtainRealPoint", a_obtainRealPoint);}
      else
        check_obtainPoint(a_obtainRealPoint->get_obtainPoint());
    }
}

/********************************************************************/

void check_obtainStm(
 obtainStm * a_obtainStm)
{
  if (isA(a_obtainStm, obtainBool))
    {
      if (!findString("obtainBool", obtainStmSubs))
        {warnSub("obtainBool", "obtainStm", a_obtainStm);}
      else
        check_obtainBool(dynamic_cast<obtainBool *>(a_obtainStm));
      return;
    }
  if (isA(a_obtainStm, obtainString))
    {
      if (!findString("obtainString", obtainStmSubs))
        {warnSub("obtainString", "obtainStm", a_obtainStm);}
      else
        check_obtainString(dynamic_cast<obtainString *>(a_obtainStm));
      return;
    }
  if (isA(a_obtainStm, obtainInt))
    {
      if (!findString("obtainInt", obtainStmSubs))
        {warnSub("obtainInt", "obtainStm", a_obtainStm);}
      else
        check_obtainInt(dynamic_cast<obtainInt *>(a_obtainStm));
      return;
    }
  if (isA(a_obtainStm, obtainRealLabel))
    {
      if (!findString("obtainRealLabel", obtainStmSubs))
        {warnSub("obtainRealLabel", "obtainStm", a_obtainStm);}
      else
        check_obtainRealLabel(dynamic_cast<obtainRealLabel *>(a_obtainStm));
      return;
    }
  if (isA(a_obtainStm, obtainRealPoint))
    {
      if (!findString("obtainRealPoint", obtainStmSubs))
        {warnSub("obtainRealPoint", "obtainStm", a_obtainStm);}
      else
        check_obtainRealPoint(dynamic_cast<obtainRealPoint *>(a_obtainStm));
      return;
    }
}

/********************************************************************/

void check_obtainString(
 obtainString * a_obtainString)
{
  if (a_obtainString->get_stringVar())
    {
      if (!findString("a_stringVar", obtainStringAtts))
	{warnAtt("a_stringVar", "obtainString", a_obtainString);}
      else
        check_stringVar(a_obtainString->get_stringVar());
    }
  if (a_obtainString->get_obtainLabeled())
    {
      if (!findString("a_obtainLabeled", obtainStringAtts))
	{warnAtt("a_obtainLabeled", "obtainString", a_obtainString);}
      else
        check_obtainLabeled(a_obtainString->get_obtainLabeled());
    }
}

/********************************************************************/

void check_offsetConst(
 offsetConst * a_offsetConst)
{
  if (a_offsetConst->get_featureList())
    {
      if (!findString("a_featureList", offsetConstAtts))
	{warnAtt("a_featureList", "offsetConst", a_offsetConst);}
      else
        {
          std::list<featureLabel *> * theList;
          std::list<featureLabel *>::iterator iter;
          theList = a_offsetConst->get_featureList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_featureLabel(*iter);
        }
    }
}

/********************************************************************/

void check_opLabel(
 opLabel * a_opLabel)
{
  if (a_opLabel->get_labelName())
    {
      if (!findString("a_labelName", opLabelAtts))
	{warnAtt("a_labelName", "opLabel", a_opLabel);}
      else
        check_labelName(a_opLabel->get_labelName());
    }
}

/********************************************************************/

void check_openCadfile(
 openCadfile * a_openCadfile)
{
  if (a_openCadfile->get_cadfileType())
    {
      if (!findString("a_cadfileType", openCadfileAtts))
	{warnAtt("a_cadfileType", "openCadfile", a_openCadfile);}
      else
        check_cadfileType(a_openCadfile->get_cadfileType());
    }
}

/********************************************************************/

void check_openDMLfile(
 openDMLfile * a_openDMLfile)
{
  if (isA(a_openDMLfile, openDmlInput))
    {
      if (!findString("openDmlInput", openDMLfileSubs))
        {warnSub("openDmlInput", "openDMLfile", a_openDMLfile);}
      else
        check_openDmlInput(dynamic_cast<openDmlInput *>(a_openDMLfile));
      return;
    }
  if (isA(a_openDMLfile, openDmlOutput))
    {
      if (!findString("openDmlOutput", openDMLfileSubs))
        {warnSub("openDmlOutput", "openDMLfile", a_openDMLfile);}
      else
        check_openDmlOutput(dynamic_cast<openDmlOutput *>(a_openDMLfile));
      return;
    }
}

/********************************************************************/

void check_openDevice(
 openDevice * a_openDevice)
{
  if (isA(a_openDevice, openDevice_inputAccess))
    {
      if (!findString("openDevice_inputAccess", openDeviceSubs))
        {warnSub("openDevice_inputAccess", "openDevice", a_openDevice);}
      else
        check_openDevice_inputAccess(dynamic_cast<openDevice_inputAccess *>(a_openDevice));
      return;
    }
  if (isA(a_openDevice, openDevice_outputAccess))
    {
      if (!findString("openDevice_outputAccess", openDeviceSubs))
        {warnSub("openDevice_outputAccess", "openDevice", a_openDevice);}
      else
        check_openDevice_outputAccess(dynamic_cast<openDevice_outputAccess *>(a_openDevice));
      return;
    }
}

/********************************************************************/

void check_openDevice_inputAccess(
 openDevice_inputAccess * a_openDevice_inputAccess)
{
  if (a_openDevice_inputAccess->get_inputAccess())
    {
      if (!findString("a_inputAccess", openDevice_inputAccessAtts))
	{warnAtt("a_inputAccess", "openDevice_inputAccess", a_openDevice_inputAccess);}
    }
}

/********************************************************************/

void check_openDevice_outputAccess(
 openDevice_outputAccess * a_openDevice_outputAccess)
{
  if (a_openDevice_outputAccess->get_outputAccess())
    {
      if (!findString("a_outputAccess", openDevice_outputAccessAtts))
	{warnAtt("a_outputAccess", "openDevice_outputAccess", a_openDevice_outputAccess);}
      else
        check_outputAccess(a_openDevice_outputAccess->get_outputAccess());
    }
}

/********************************************************************/

void check_openDmlInput(
 openDmlInput * a_openDmlInput)
{
  if (a_openDmlInput->get_version())
    {
      if (!findString("version", openDmlInputAtts))
	{warnAtt("version", "openDmlInput", a_openDmlInput);}
      else
        check_stringVal(a_openDmlInput->get_version());
    }
}

/********************************************************************/

void check_openDmlOutput(
 openDmlOutput * a_openDmlOutput)
{
  if (a_openDmlOutput->get_version())
    {
      if (!findString("version", openDmlOutputAtts))
	{warnAtt("version", "openDmlOutput", a_openDmlOutput);}
      else
        check_stringVal(a_openDmlOutput->get_version());
    }
  if (a_openDmlOutput->get_state())
    {
      if (!findString("a_state", openDmlOutputAtts))
	{warnAtt("a_state", "openDmlOutput", a_openDmlOutput);}
      else
        check_state(a_openDmlOutput->get_state());
    }
}

/********************************************************************/

void check_openFdata(
 openFdata * a_openFdata)
{
  if (isA(a_openFdata, openFdata_vLabel))
    {
      if (!findString("openFdata_vLabel", openFdataSubs))
        {warnSub("openFdata_vLabel", "openFdata", a_openFdata);}
      else
        check_openFdata_vLabel(dynamic_cast<openFdata_vLabel *>(a_openFdata));
      return;
    }
  if (isA(a_openFdata, openFdata_DMIS))
    {
      if (!findString("openFdata_DMIS", openFdataSubs))
        {warnSub("openFdata_DMIS", "openFdata", a_openFdata);}
      else
        check_openFdata_DMIS(dynamic_cast<openFdata_DMIS *>(a_openFdata));
      return;
    }
}

/********************************************************************/

void check_openFdata_DMIS(
 openFdata_DMIS * a_openFdata_DMIS)
{
  if (a_openFdata_DMIS->get_outputAccess())
    {
      if (!findString("a_outputAccess", openFdata_DMISAtts))
	{warnAtt("a_outputAccess", "openFdata_DMIS", a_openFdata_DMIS);}
      else
        check_outputAccess(a_openFdata_DMIS->get_outputAccess());
    }
}

/********************************************************************/

void check_openFdata_vLabel(
 openFdata_vLabel * a_openFdata_vLabel)
{
  if (a_openFdata_vLabel->get_vLabel())
    {
      if (!findString("a_vLabel", openFdata_vLabelAtts))
	{warnAtt("a_vLabel", "openFdata_vLabel", a_openFdata_vLabel);}
      else
        check_vLabel(a_openFdata_vLabel->get_vLabel());
    }
  if (a_openFdata_vLabel->get_outputAccess())
    {
      if (!findString("a_outputAccess", openFdata_vLabelAtts))
	{warnAtt("a_outputAccess", "openFdata_vLabel", a_openFdata_vLabel);}
      else
        check_outputAccess(a_openFdata_vLabel->get_outputAccess());
    }
}

/********************************************************************/

void check_openMinor(
 openMinor * a_openMinor)
{
  if (isA(a_openMinor, openMinor_openDevice))
    {
      if (!findString("openMinor_openDevice", openMinorSubs))
        {warnSub("openMinor_openDevice", "openMinor", a_openMinor);}
      else
        check_openMinor_openDevice(dynamic_cast<openMinor_openDevice *>(a_openMinor));
      return;
    }
  if (isA(a_openMinor, openMinor_openFdata))
    {
      if (!findString("openMinor_openFdata", openMinorSubs))
        {warnSub("openMinor_openFdata", "openMinor", a_openMinor);}
      else
        check_openMinor_openFdata(dynamic_cast<openMinor_openFdata *>(a_openMinor));
      return;
    }
  if (isA(a_openMinor, openMinor_openCadfile))
    {
      if (!findString("openMinor_openCadfile", openMinorSubs))
        {warnSub("openMinor_openCadfile", "openMinor", a_openMinor);}
      else
        check_openMinor_openCadfile(dynamic_cast<openMinor_openCadfile *>(a_openMinor));
      return;
    }
  if (isA(a_openMinor, openMinor_storageSpecList))
    {
      if (!findString("openMinor_storageSpecList", openMinorSubs))
        {warnSub("openMinor_storageSpecList", "openMinor", a_openMinor);}
      else
        check_openMinor_storageSpecList(dynamic_cast<openMinor_storageSpecList *>(a_openMinor));
      return;
    }
  if (isA(a_openMinor, openMinor_openDMLfile))
    {
      if (!findString("openMinor_openDMLfile", openMinorSubs))
        {warnSub("openMinor_openDMLfile", "openMinor", a_openMinor);}
      else
        check_openMinor_openDMLfile(dynamic_cast<openMinor_openDMLfile *>(a_openMinor));
      return;
    }
}

/********************************************************************/

void check_openMinor_openCadfile(
 openMinor_openCadfile * a_openMinor_openCadfile)
{
  if (a_openMinor_openCadfile->get_didLabel())
    {
      if (!findString("a_didLabel", openMinor_openCadfileAtts))
	{warnAtt("a_didLabel", "openMinor_openCadfile", a_openMinor_openCadfile);}
      else
        check_didLabel(a_openMinor_openCadfile->get_didLabel());
    }
  if (a_openMinor_openCadfile->get_openCadfile())
    {
      if (!findString("a_openCadfile", openMinor_openCadfileAtts))
	{warnAtt("a_openCadfile", "openMinor_openCadfile", a_openMinor_openCadfile);}
      else
        check_openCadfile(a_openMinor_openCadfile->get_openCadfile());
    }
}

/********************************************************************/

void check_openMinor_openDMLfile(
 openMinor_openDMLfile * a_openMinor_openDMLfile)
{
  if (a_openMinor_openDMLfile->get_didLabel())
    {
      if (!findString("a_didLabel", openMinor_openDMLfileAtts))
	{warnAtt("a_didLabel", "openMinor_openDMLfile", a_openMinor_openDMLfile);}
      else
        check_didLabel(a_openMinor_openDMLfile->get_didLabel());
    }
  if (a_openMinor_openDMLfile->get_openDMLfile())
    {
      if (!findString("a_openDMLfile", openMinor_openDMLfileAtts))
	{warnAtt("a_openDMLfile", "openMinor_openDMLfile", a_openMinor_openDMLfile);}
      else
        check_openDMLfile(a_openMinor_openDMLfile->get_openDMLfile());
    }
}

/********************************************************************/

void check_openMinor_openDevice(
 openMinor_openDevice * a_openMinor_openDevice)
{
  if (a_openMinor_openDevice->get_didLabel())
    {
      if (!findString("a_didLabel", openMinor_openDeviceAtts))
	{warnAtt("a_didLabel", "openMinor_openDevice", a_openMinor_openDevice);}
      else
        check_didLabel(a_openMinor_openDevice->get_didLabel());
    }
  if (a_openMinor_openDevice->get_openDevice())
    {
      if (!findString("a_openDevice", openMinor_openDeviceAtts))
	{warnAtt("a_openDevice", "openMinor_openDevice", a_openMinor_openDevice);}
      else
        check_openDevice(a_openMinor_openDevice->get_openDevice());
    }
}

/********************************************************************/

void check_openMinor_openFdata(
 openMinor_openFdata * a_openMinor_openFdata)
{
  if (a_openMinor_openFdata->get_didLabel())
    {
      if (!findString("a_didLabel", openMinor_openFdataAtts))
	{warnAtt("a_didLabel", "openMinor_openFdata", a_openMinor_openFdata);}
      else
        check_didLabel(a_openMinor_openFdata->get_didLabel());
    }
  if (a_openMinor_openFdata->get_openFdata())
    {
      if (!findString("a_openFdata", openMinor_openFdataAtts))
	{warnAtt("a_openFdata", "openMinor_openFdata", a_openMinor_openFdata);}
      else
        check_openFdata(a_openMinor_openFdata->get_openFdata());
    }
}

/********************************************************************/

void check_openMinor_storageSpecList(
 openMinor_storageSpecList * a_openMinor_storageSpecList)
{
  if (a_openMinor_storageSpecList->get_didLabel())
    {
      if (!findString("a_didLabel", openMinor_storageSpecListAtts))
	{warnAtt("a_didLabel", "openMinor_storageSpecList", a_openMinor_storageSpecList);}
      else
        check_didLabel(a_openMinor_storageSpecList->get_didLabel());
    }
  if (a_openMinor_storageSpecList->get_storageSpecList())
    {
      if (!findString("a_storageSpecList", openMinor_storageSpecListAtts))
	{warnAtt("a_storageSpecList", "openMinor_storageSpecList", a_openMinor_storageSpecList);}
      else
        {
          std::list<storageSpec *> * theList;
          std::list<storageSpec *>::iterator iter;
          theList = a_openMinor_storageSpecList->get_storageSpecList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_storageSpec(*iter);
        }
    }
}

/********************************************************************/

void check_openStm(
 openStm * a_openStm)
{
  if (a_openStm->get_openMinor())
    {
      if (!findString("a_openMinor", openStmAtts))
	{warnAtt("a_openMinor", "openStm", a_openStm);}
      else
        check_openMinor(a_openStm->get_openMinor());
    }
}

/********************************************************************/

void check_operidStm(
 operidStm * a_operidStm)
{
  if (a_operidStm->get_opLabel())
    {
      if (!findString("a_opLabel", operidStmAtts))
	{warnAtt("a_opLabel", "operidStm", a_operidStm);}
      else
        check_opLabel(a_operidStm->get_opLabel());
    }
  if (a_operidStm->get_text())
    {
      if (!findString("text", operidStmAtts))
	{warnAtt("text", "operidStm", a_operidStm);}
      else
        check_stringVal(a_operidStm->get_text());
    }
}

/********************************************************************/

void check_orig(
 orig * a_orig)
{
  if (isA(a_orig, orig_XORIG))
    {
      if (!findString("orig_XORIG", origSubs))
        {warnSub("orig_XORIG", "orig", a_orig);}
      return;
    }
  if (isA(a_orig, orig_YORIG))
    {
      if (!findString("orig_YORIG", origSubs))
        {warnSub("orig_YORIG", "orig", a_orig);}
      return;
    }
  if (isA(a_orig, orig_ZORIG))
    {
      if (!findString("orig_ZORIG", origSubs))
        {warnSub("orig_ZORIG", "orig", a_orig);}
      return;
    }
}

/********************************************************************/

void check_outputAccess(
 outputAccess * a_outputAccess)
{
  if (isA(a_outputAccess, outputAccessUnspec))
    {
      if (!findString("outputAccessUnspec", outputAccessSubs))
        {warnSub("outputAccessUnspec", "outputAccess", a_outputAccess);}
      return;
    }
  if (isA(a_outputAccess, outputAccessAppend))
    {
      if (!findString("outputAccessAppend", outputAccessSubs))
        {warnSub("outputAccessAppend", "outputAccess", a_outputAccess);}
      return;
    }
  if (isA(a_outputAccess, outputAccessOverwr))
    {
      if (!findString("outputAccessOverwr", outputAccessSubs))
        {warnSub("outputAccessOverwr", "outputAccess", a_outputAccess);}
      return;
    }
}

/********************************************************************/

void check_outputConstBothData(
 outputConstBothData * a_outputConstBothData)
{
  if (a_outputConstBothData->get_stLabel())
    {
      if (!findString("a_stLabel", outputConstBothDataAtts))
	{warnAtt("a_stLabel", "outputConstBothData", a_outputConstBothData);}
      else
        check_stLabel(a_outputConstBothData->get_stLabel());
    }
  if (a_outputConstBothData->get_seLabel())
    {
      if (!findString("a_seLabel", outputConstBothDataAtts))
	{warnAtt("a_seLabel", "outputConstBothData", a_outputConstBothData);}
      else
        check_seLabel(a_outputConstBothData->get_seLabel());
    }
  if (a_outputConstBothData->get_toleranceLabel())
    {
      if (!findString("a_toleranceLabel", outputConstBothDataAtts))
	{warnAtt("a_toleranceLabel", "outputConstBothData", a_outputConstBothData);}
      else
        check_toleranceLabel(a_outputConstBothData->get_toleranceLabel());
    }
}

/********************************************************************/

void check_outputConstData(
 outputConstData * a_outputConstData)
{
  if (isA(a_outputConstData, outputConstGaugeData))
    {
      if (!findString("outputConstGaugeData", outputConstDataSubs))
        {warnSub("outputConstGaugeData", "outputConstData", a_outputConstData);}
      else
        check_outputConstGaugeData(dynamic_cast<outputConstGaugeData *>(a_outputConstData));
      return;
    }
  if (isA(a_outputConstData, outputConstPartData))
    {
      if (!findString("outputConstPartData", outputConstDataSubs))
        {warnSub("outputConstPartData", "outputConstData", a_outputConstData);}
      else
        check_outputConstPartData(dynamic_cast<outputConstPartData *>(a_outputConstData));
      return;
    }
  if (isA(a_outputConstData, outputConstBothData))
    {
      if (!findString("outputConstBothData", outputConstDataSubs))
        {warnSub("outputConstBothData", "outputConstData", a_outputConstData);}
      else
        check_outputConstBothData(dynamic_cast<outputConstBothData *>(a_outputConstData));
      return;
    }
}

/********************************************************************/

void check_outputConstGaugeData(
 outputConstGaugeData * a_outputConstGaugeData)
{
  if (a_outputConstGaugeData->get_seLabel())
    {
      if (!findString("a_seLabel", outputConstGaugeDataAtts))
	{warnAtt("a_seLabel", "outputConstGaugeData", a_outputConstGaugeData);}
      else
        check_seLabel(a_outputConstGaugeData->get_seLabel());
    }
}

/********************************************************************/

void check_outputConstPartData(
 outputConstPartData * a_outputConstPartData)
{
  if (a_outputConstPartData->get_stLabel())
    {
      if (!findString("a_stLabel", outputConstPartDataAtts))
	{warnAtt("a_stLabel", "outputConstPartData", a_outputConstPartData);}
      else
        check_stLabel(a_outputConstPartData->get_stLabel());
    }
}

/********************************************************************/

void check_outputDat(
 outputDat * a_outputDat)
{
  if (isA(a_outputDat, outputDat_datLabel))
    {
      if (!findString("outputDat_datLabel", outputDatSubs))
        {warnSub("outputDat_datLabel", "outputDat", a_outputDat);}
      else
        check_outputDat_datLabel(dynamic_cast<outputDat_datLabel *>(a_outputDat));
      return;
    }
  if (isA(a_outputDat, outputDat_faLabel))
    {
      if (!findString("outputDat_faLabel", outputDatSubs))
        {warnSub("outputDat_faLabel", "outputDat", a_outputDat);}
      else
        check_outputDat_faLabel(dynamic_cast<outputDat_faLabel *>(a_outputDat));
      return;
    }
}

/********************************************************************/

void check_outputDat_datLabel(
 outputDat_datLabel * a_outputDat_datLabel)
{
  if (a_outputDat_datLabel->get_datLabel())
    {
      if (!findString("a_datLabel", outputDat_datLabelAtts))
	{warnAtt("a_datLabel", "outputDat_datLabel", a_outputDat_datLabel);}
      else
        check_datLabel(a_outputDat_datLabel->get_datLabel());
    }
  if (a_outputDat_datLabel->get_faLabel())
    {
      if (!findString("a_faLabel", outputDat_datLabelAtts))
	{warnAtt("a_faLabel", "outputDat_datLabel", a_outputDat_datLabel);}
      else
        check_faLabel(a_outputDat_datLabel->get_faLabel());
    }
  if (a_outputDat_datLabel->get_taLabel())
    {
      if (!findString("a_taLabel", outputDat_datLabelAtts))
	{warnAtt("a_taLabel", "outputDat_datLabel", a_outputDat_datLabel);}
      else
        check_taLabel(a_outputDat_datLabel->get_taLabel());
    }
  if (a_outputDat_datLabel->get_rLabel())
    {
      if (!findString("a_rLabel", outputDat_datLabelAtts))
	{warnAtt("a_rLabel", "outputDat_datLabel", a_outputDat_datLabel);}
      else
        check_rLabel(a_outputDat_datLabel->get_rLabel());
    }
}

/********************************************************************/

void check_outputDat_faLabel(
 outputDat_faLabel * a_outputDat_faLabel)
{
  if (a_outputDat_faLabel->get_faLabel())
    {
      if (!findString("a_faLabel", outputDat_faLabelAtts))
	{warnAtt("a_faLabel", "outputDat_faLabel", a_outputDat_faLabel);}
      else
        check_faLabel(a_outputDat_faLabel->get_faLabel());
    }
  if (a_outputDat_faLabel->get_datLabel())
    {
      if (!findString("a_datLabel", outputDat_faLabelAtts))
	{warnAtt("a_datLabel", "outputDat_faLabel", a_outputDat_faLabel);}
      else
        check_datLabel(a_outputDat_faLabel->get_datLabel());
    }
  if (a_outputDat_faLabel->get_taLabel())
    {
      if (!findString("a_taLabel", outputDat_faLabelAtts))
	{warnAtt("a_taLabel", "outputDat_faLabel", a_outputDat_faLabel);}
      else
        check_taLabel(a_outputDat_faLabel->get_taLabel());
    }
  if (a_outputDat_faLabel->get_rLabel())
    {
      if (!findString("a_rLabel", outputDat_faLabelAtts))
	{warnAtt("a_rLabel", "outputDat_faLabel", a_outputDat_faLabel);}
      else
        check_rLabel(a_outputDat_faLabel->get_rLabel());
    }
}

/********************************************************************/

void check_outputFeat(
 outputFeat * a_outputFeat)
{
  if (isA(a_outputFeat, outputFeat1F))
    {
      if (!findString("outputFeat1F", outputFeatSubs))
        {warnSub("outputFeat1F", "outputFeat", a_outputFeat);}
      else
        check_outputFeat1F(dynamic_cast<outputFeat1F *>(a_outputFeat));
      return;
    }
  if (isA(a_outputFeat, outputFeat1Fa))
    {
      if (!findString("outputFeat1Fa", outputFeatSubs))
        {warnSub("outputFeat1Fa", "outputFeat", a_outputFeat);}
      else
        check_outputFeat1Fa(dynamic_cast<outputFeat1Fa *>(a_outputFeat));
      return;
    }
  if (isA(a_outputFeat, outputFeat2FFaTa))
    {
      if (!findString("outputFeat2FFaTa", outputFeatSubs))
        {warnSub("outputFeat2FFaTa", "outputFeat", a_outputFeat);}
      else
        check_outputFeat2FFaTa(dynamic_cast<outputFeat2FFaTa *>(a_outputFeat));
      return;
    }
  if (isA(a_outputFeat, outputFeat2FaFaTa))
    {
      if (!findString("outputFeat2FaFaTa", outputFeatSubs))
        {warnSub("outputFeat2FaFaTa", "outputFeat", a_outputFeat);}
      else
        check_outputFeat2FaFaTa(dynamic_cast<outputFeat2FaFaTa *>(a_outputFeat));
      return;
    }
  if (isA(a_outputFeat, outputFeat2FFT))
    {
      if (!findString("outputFeat2FFT", outputFeatSubs))
        {warnSub("outputFeat2FFT", "outputFeat", a_outputFeat);}
      else
        check_outputFeat2FFT(dynamic_cast<outputFeat2FFT *>(a_outputFeat));
      return;
    }
  if (isA(a_outputFeat, outputFeat2FaFTa))
    {
      if (!findString("outputFeat2FaFTa", outputFeatSubs))
        {warnSub("outputFeat2FaFTa", "outputFeat", a_outputFeat);}
      else
        check_outputFeat2FaFTa(dynamic_cast<outputFeat2FaFTa *>(a_outputFeat));
      return;
    }
  if (isA(a_outputFeat, outputFeat1FT))
    {
      if (!findString("outputFeat1FT", outputFeatSubs))
        {warnSub("outputFeat1FT", "outputFeat", a_outputFeat);}
      else
        check_outputFeat1FT(dynamic_cast<outputFeat1FT *>(a_outputFeat));
      return;
    }
  if (isA(a_outputFeat, outputFeat1FaTa))
    {
      if (!findString("outputFeat1FaTa", outputFeatSubs))
        {warnSub("outputFeat1FaTa", "outputFeat", a_outputFeat);}
      else
        check_outputFeat1FaTa(dynamic_cast<outputFeat1FaTa *>(a_outputFeat));
      return;
    }
}

/********************************************************************/

void check_outputFeat1F(
 outputFeat1F * a_outputFeat1F)
{
  if (a_outputFeat1F->get_f())
    {
      if (!findString("f", outputFeat1FAtts))
	{warnAtt("f", "outputFeat1F", a_outputFeat1F);}
      else
        check_fLabel(a_outputFeat1F->get_f());
    }
  if (a_outputFeat1F->get_pointRange())
    {
      if (!findString("a_pointRange", outputFeat1FAtts))
	{warnAtt("a_pointRange", "outputFeat1F", a_outputFeat1F);}
      else
        check_pointRange(a_outputFeat1F->get_pointRange());
    }
  if (a_outputFeat1F->get_rLabel())
    {
      if (!findString("a_rLabel", outputFeat1FAtts))
	{warnAtt("a_rLabel", "outputFeat1F", a_outputFeat1F);}
      else
        check_rLabel(a_outputFeat1F->get_rLabel());
    }
}

/********************************************************************/

void check_outputFeat1FT(
 outputFeat1FT * a_outputFeat1FT)
{
  if (a_outputFeat1FT->get_f())
    {
      if (!findString("f", outputFeat1FTAtts))
	{warnAtt("f", "outputFeat1FT", a_outputFeat1FT);}
      else
        check_fLabel(a_outputFeat1FT->get_f());
    }
  if (a_outputFeat1FT->get_pointRange())
    {
      if (!findString("a_pointRange", outputFeat1FTAtts))
	{warnAtt("a_pointRange", "outputFeat1FT", a_outputFeat1FT);}
      else
        check_pointRange(a_outputFeat1FT->get_pointRange());
    }
  if (a_outputFeat1FT->get_tLabelList())
    {
      if (!findString("a_tLabelList", outputFeat1FTAtts))
	{warnAtt("a_tLabelList", "outputFeat1FT", a_outputFeat1FT);}
      else
        {
          std::list<tLabel *> * theList;
          std::list<tLabel *>::iterator iter;
          theList = a_outputFeat1FT->get_tLabelList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_tLabel(*iter);
        }
    }
  if (a_outputFeat1FT->get_rLabel())
    {
      if (!findString("a_rLabel", outputFeat1FTAtts))
	{warnAtt("a_rLabel", "outputFeat1FT", a_outputFeat1FT);}
      else
        check_rLabel(a_outputFeat1FT->get_rLabel());
    }
}

/********************************************************************/

void check_outputFeat1Fa(
 outputFeat1Fa * a_outputFeat1Fa)
{
  if (a_outputFeat1Fa->get_fa())
    {
      if (!findString("fa", outputFeat1FaAtts))
	{warnAtt("fa", "outputFeat1Fa", a_outputFeat1Fa);}
      else
        check_faLabel(a_outputFeat1Fa->get_fa());
    }
  if (a_outputFeat1Fa->get_pointRange())
    {
      if (!findString("a_pointRange", outputFeat1FaAtts))
	{warnAtt("a_pointRange", "outputFeat1Fa", a_outputFeat1Fa);}
      else
        check_pointRange(a_outputFeat1Fa->get_pointRange());
    }
  if (a_outputFeat1Fa->get_rLabel())
    {
      if (!findString("a_rLabel", outputFeat1FaAtts))
	{warnAtt("a_rLabel", "outputFeat1Fa", a_outputFeat1Fa);}
      else
        check_rLabel(a_outputFeat1Fa->get_rLabel());
    }
}

/********************************************************************/

void check_outputFeat1FaTa(
 outputFeat1FaTa * a_outputFeat1FaTa)
{
  if (a_outputFeat1FaTa->get_fa())
    {
      if (!findString("fa", outputFeat1FaTaAtts))
	{warnAtt("fa", "outputFeat1FaTa", a_outputFeat1FaTa);}
      else
        check_faLabel(a_outputFeat1FaTa->get_fa());
    }
  if (a_outputFeat1FaTa->get_pointRange())
    {
      if (!findString("a_pointRange", outputFeat1FaTaAtts))
	{warnAtt("a_pointRange", "outputFeat1FaTa", a_outputFeat1FaTa);}
      else
        check_pointRange(a_outputFeat1FaTa->get_pointRange());
    }
  if (a_outputFeat1FaTa->get_taLabelList())
    {
      if (!findString("a_taLabelList", outputFeat1FaTaAtts))
	{warnAtt("a_taLabelList", "outputFeat1FaTa", a_outputFeat1FaTa);}
      else
        {
          std::list<taLabel *> * theList;
          std::list<taLabel *>::iterator iter;
          theList = a_outputFeat1FaTa->get_taLabelList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_taLabel(*iter);
        }
    }
  if (a_outputFeat1FaTa->get_rLabel())
    {
      if (!findString("a_rLabel", outputFeat1FaTaAtts))
	{warnAtt("a_rLabel", "outputFeat1FaTa", a_outputFeat1FaTa);}
      else
        check_rLabel(a_outputFeat1FaTa->get_rLabel());
    }
}

/********************************************************************/

void check_outputFeat2FFT(
 outputFeat2FFT * a_outputFeat2FFT)
{
  if (a_outputFeat2FFT->get_f1())
    {
      if (!findString("f1", outputFeat2FFTAtts))
	{warnAtt("f1", "outputFeat2FFT", a_outputFeat2FFT);}
      else
        check_fLabel(a_outputFeat2FFT->get_f1());
    }
  if (a_outputFeat2FFT->get_f2())
    {
      if (!findString("f2", outputFeat2FFTAtts))
	{warnAtt("f2", "outputFeat2FFT", a_outputFeat2FFT);}
      else
        check_fLabel(a_outputFeat2FFT->get_f2());
    }
  if (a_outputFeat2FFT->get_t())
    {
      if (!findString("t", outputFeat2FFTAtts))
	{warnAtt("t", "outputFeat2FFT", a_outputFeat2FFT);}
      else
        check_tLabel(a_outputFeat2FFT->get_t());
    }
  if (a_outputFeat2FFT->get_rLabel())
    {
      if (!findString("a_rLabel", outputFeat2FFTAtts))
	{warnAtt("a_rLabel", "outputFeat2FFT", a_outputFeat2FFT);}
      else
        check_rLabel(a_outputFeat2FFT->get_rLabel());
    }
}

/********************************************************************/

void check_outputFeat2FFaTa(
 outputFeat2FFaTa * a_outputFeat2FFaTa)
{
  if (a_outputFeat2FFaTa->get_f())
    {
      if (!findString("f", outputFeat2FFaTaAtts))
	{warnAtt("f", "outputFeat2FFaTa", a_outputFeat2FFaTa);}
      else
        check_fLabel(a_outputFeat2FFaTa->get_f());
    }
  if (a_outputFeat2FFaTa->get_fa())
    {
      if (!findString("fa", outputFeat2FFaTaAtts))
	{warnAtt("fa", "outputFeat2FFaTa", a_outputFeat2FFaTa);}
      else
        check_faLabel(a_outputFeat2FFaTa->get_fa());
    }
  if (a_outputFeat2FFaTa->get_ta())
    {
      if (!findString("ta", outputFeat2FFaTaAtts))
	{warnAtt("ta", "outputFeat2FFaTa", a_outputFeat2FFaTa);}
      else
        check_taLabel(a_outputFeat2FFaTa->get_ta());
    }
  if (a_outputFeat2FFaTa->get_rLabel())
    {
      if (!findString("a_rLabel", outputFeat2FFaTaAtts))
	{warnAtt("a_rLabel", "outputFeat2FFaTa", a_outputFeat2FFaTa);}
      else
        check_rLabel(a_outputFeat2FFaTa->get_rLabel());
    }
}

/********************************************************************/

void check_outputFeat2FaFTa(
 outputFeat2FaFTa * a_outputFeat2FaFTa)
{
  if (a_outputFeat2FaFTa->get_fa())
    {
      if (!findString("fa", outputFeat2FaFTaAtts))
	{warnAtt("fa", "outputFeat2FaFTa", a_outputFeat2FaFTa);}
      else
        check_faLabel(a_outputFeat2FaFTa->get_fa());
    }
  if (a_outputFeat2FaFTa->get_f())
    {
      if (!findString("f", outputFeat2FaFTaAtts))
	{warnAtt("f", "outputFeat2FaFTa", a_outputFeat2FaFTa);}
      else
        check_fLabel(a_outputFeat2FaFTa->get_f());
    }
  if (a_outputFeat2FaFTa->get_ta())
    {
      if (!findString("ta", outputFeat2FaFTaAtts))
	{warnAtt("ta", "outputFeat2FaFTa", a_outputFeat2FaFTa);}
      else
        check_taLabel(a_outputFeat2FaFTa->get_ta());
    }
  if (a_outputFeat2FaFTa->get_rLabel())
    {
      if (!findString("a_rLabel", outputFeat2FaFTaAtts))
	{warnAtt("a_rLabel", "outputFeat2FaFTa", a_outputFeat2FaFTa);}
      else
        check_rLabel(a_outputFeat2FaFTa->get_rLabel());
    }
}

/********************************************************************/

void check_outputFeat2FaFaTa(
 outputFeat2FaFaTa * a_outputFeat2FaFaTa)
{
  if (a_outputFeat2FaFaTa->get_fa1())
    {
      if (!findString("fa1", outputFeat2FaFaTaAtts))
	{warnAtt("fa1", "outputFeat2FaFaTa", a_outputFeat2FaFaTa);}
      else
        check_faLabel(a_outputFeat2FaFaTa->get_fa1());
    }
  if (a_outputFeat2FaFaTa->get_fa2())
    {
      if (!findString("fa2", outputFeat2FaFaTaAtts))
	{warnAtt("fa2", "outputFeat2FaFaTa", a_outputFeat2FaFaTa);}
      else
        check_faLabel(a_outputFeat2FaFaTa->get_fa2());
    }
  if (a_outputFeat2FaFaTa->get_ta())
    {
      if (!findString("ta", outputFeat2FaFaTaAtts))
	{warnAtt("ta", "outputFeat2FaFaTa", a_outputFeat2FaFaTa);}
      else
        check_taLabel(a_outputFeat2FaFaTa->get_ta());
    }
  if (a_outputFeat2FaFaTa->get_rLabel())
    {
      if (!findString("a_rLabel", outputFeat2FaFaTaAtts))
	{warnAtt("a_rLabel", "outputFeat2FaFaTa", a_outputFeat2FaFaTa);}
      else
        check_rLabel(a_outputFeat2FaFaTa->get_rLabel());
    }
}

/********************************************************************/

void check_outputFeatData(
 outputFeatData * a_outputFeatData)
{
  if (isA(a_outputFeatData, outputFeat))
    {
      if (!findString("outputFeat", outputFeatDataSubs))
        {warnSub("outputFeat", "outputFeatData", a_outputFeatData);}
      else
        check_outputFeat(dynamic_cast<outputFeat *>(a_outputFeatData));
      return;
    }
  if (isA(a_outputFeatData, outputDat))
    {
      if (!findString("outputDat", outputFeatDataSubs))
        {warnSub("outputDat", "outputFeatData", a_outputFeatData);}
      else
        check_outputDat(dynamic_cast<outputDat *>(a_outputFeatData));
      return;
    }
}

/********************************************************************/

void check_outputKeycharData(
 outputKeycharData * a_outputKeycharData)
{
  if (isA(a_outputKeycharData, kcLabel))
    {
      if (!findString("kcLabel", outputKeycharDataSubs))
        {warnSub("kcLabel", "outputKeycharData", a_outputKeycharData);}
      else
        check_kcLabel(dynamic_cast<kcLabel *>(a_outputKeycharData));
      return;
    }
  if (isA(a_outputKeycharData, kcaLabel))
    {
      if (!findString("kcaLabel", outputKeycharDataSubs))
        {warnSub("kcaLabel", "outputKeycharData", a_outputKeycharData);}
      else
        check_kcaLabel(dynamic_cast<kcaLabel *>(a_outputKeycharData));
      return;
    }
}

/********************************************************************/

void check_outputMinor(
 outputMinor * a_outputMinor)
{
  if (isA(a_outputMinor, outputFeatData))
    {
      if (!findString("outputFeatData", outputMinorSubs))
        {warnSub("outputFeatData", "outputMinor", a_outputMinor);}
      else
        check_outputFeatData(dynamic_cast<outputFeatData *>(a_outputMinor));
      return;
    }
  if (isA(a_outputMinor, outputConstData))
    {
      if (!findString("outputConstData", outputMinorSubs))
        {warnSub("outputConstData", "outputMinor", a_outputMinor);}
      else
        check_outputConstData(dynamic_cast<outputConstData *>(a_outputMinor));
      return;
    }
  if (isA(a_outputMinor, outputKeycharData))
    {
      if (!findString("outputKeycharData", outputMinorSubs))
        {warnSub("outputKeycharData", "outputMinor", a_outputMinor);}
      else
        check_outputKeycharData(dynamic_cast<outputKeycharData *>(a_outputMinor));
      return;
    }
  if (isA(a_outputMinor, outputSensorData))
    {
      if (!findString("outputSensorData", outputMinorSubs))
        {warnSub("outputSensorData", "outputMinor", a_outputMinor);}
      else
        check_outputSensorData(dynamic_cast<outputSensorData *>(a_outputMinor));
      return;
    }
  if (isA(a_outputMinor, outputToleranceData))
    {
      if (!findString("outputToleranceData", outputMinorSubs))
        {warnSub("outputToleranceData", "outputMinor", a_outputMinor);}
      else
        check_outputToleranceData(dynamic_cast<outputToleranceData *>(a_outputMinor));
      return;
    }
  if (isA(a_outputMinor, outputReportData))
    {
      if (!findString("outputReportData", outputMinorSubs))
        {warnSub("outputReportData", "outputMinor", a_outputMinor);}
      else
        check_outputReportData(dynamic_cast<outputReportData *>(a_outputMinor));
      return;
    }
}

/********************************************************************/

void check_outputReportData(
 outputReportData * a_outputReportData)
{
  if (isA(a_outputReportData, rLabel))
    {
      if (!findString("rLabel", outputReportDataSubs))
        {warnSub("rLabel", "outputReportData", a_outputReportData);}
      else
        check_rLabel(dynamic_cast<rLabel *>(a_outputReportData));
      return;
    }
}

/********************************************************************/

void check_outputSensorData(
 outputSensorData * a_outputSensorData)
{
  if (isA(a_outputSensorData, outputSensorData_sLabel))
    {
      if (!findString("outputSensorData_sLabel", outputSensorDataSubs))
        {warnSub("outputSensorData_sLabel", "outputSensorData", a_outputSensorData);}
      else
        check_outputSensorData_sLabel(dynamic_cast<outputSensorData_sLabel *>(a_outputSensorData));
      return;
    }
  if (isA(a_outputSensorData, outputSensorData_saLabel))
    {
      if (!findString("outputSensorData_saLabel", outputSensorDataSubs))
        {warnSub("outputSensorData_saLabel", "outputSensorData", a_outputSensorData);}
      else
        check_outputSensorData_saLabel(dynamic_cast<outputSensorData_saLabel *>(a_outputSensorData));
      return;
    }
}

/********************************************************************/

void check_outputSensorData_sLabel(
 outputSensorData_sLabel * a_outputSensorData_sLabel)
{
  if (a_outputSensorData_sLabel->get_sLabel())
    {
      if (!findString("a_sLabel", outputSensorData_sLabelAtts))
	{warnAtt("a_sLabel", "outputSensorData_sLabel", a_outputSensorData_sLabel);}
      else
        check_sLabel(a_outputSensorData_sLabel->get_sLabel());
    }
}

/********************************************************************/

void check_outputSensorData_saLabel(
 outputSensorData_saLabel * a_outputSensorData_saLabel)
{
  if (a_outputSensorData_saLabel->get_saLabel())
    {
      if (!findString("a_saLabel", outputSensorData_saLabelAtts))
	{warnAtt("a_saLabel", "outputSensorData_saLabel", a_outputSensorData_saLabel);}
      else
        check_saLabel(a_outputSensorData_saLabel->get_saLabel());
    }
  if (a_outputSensorData_saLabel->get_outputSensorDesc())
    {
      if (!findString("a_outputSensorDesc", outputSensorData_saLabelAtts))
	{warnAtt("a_outputSensorDesc", "outputSensorData_saLabel", a_outputSensorData_saLabel);}
      else
        check_outputSensorDesc(a_outputSensorData_saLabel->get_outputSensorDesc());
    }
}

/********************************************************************/

void check_outputSensorDesc(
 outputSensorDesc * a_outputSensorDesc)
{
  if (isA(a_outputSensorDesc, outputSensorDesc_stringVal))
    {
      if (!findString("outputSensorDesc_stringVal", outputSensorDescSubs))
        {warnSub("outputSensorDesc_stringVal", "outputSensorDesc", a_outputSensorDesc);}
      else
        check_outputSensorDesc_stringVal(dynamic_cast<outputSensorDesc_stringVal *>(a_outputSensorDesc));
      return;
    }
  if (isA(a_outputSensorDesc, outputSensorDesc_intVal))
    {
      if (!findString("outputSensorDesc_intVal", outputSensorDescSubs))
        {warnSub("outputSensorDesc_intVal", "outputSensorDesc", a_outputSensorDesc);}
      else
        check_outputSensorDesc_intVal(dynamic_cast<outputSensorDesc_intVal *>(a_outputSensorDesc));
      return;
    }
  if (isA(a_outputSensorDesc, outputSensorDesc_outputSensorWristList))
    {
      if (!findString("outputSensorDesc_outputSensorWristList", outputSensorDescSubs))
        {warnSub("outputSensorDesc_outputSensorWristList", "outputSensorDesc", a_outputSensorDesc);}
      else
        check_outputSensorDesc_outputSensorWristList(dynamic_cast<outputSensorDesc_outputSensorWristList *>(a_outputSensorDesc));
      return;
    }
  if (isA(a_outputSensorDesc, outputSensorDesc_CURENT))
    {
      if (!findString("outputSensorDesc_CURENT", outputSensorDescSubs))
        {warnSub("outputSensorDesc_CURENT", "outputSensorDesc", a_outputSensorDesc);}
      return;
    }
}

/********************************************************************/

void check_outputSensorDesc_intVal(
 outputSensorDesc_intVal * a_outputSensorDesc_intVal)
{
  if (a_outputSensorDesc_intVal->get_tipnum())
    {
      if (!findString("tipnum", outputSensorDesc_intValAtts))
	{warnAtt("tipnum", "outputSensorDesc_intVal", a_outputSensorDesc_intVal);}
      else
        check_intVal(a_outputSensorDesc_intVal->get_tipnum());
    }
  if (a_outputSensorDesc_intVal->get_outputSensorWristList())
    {
      if (!findString("a_outputSensorWristList", outputSensorDesc_intValAtts))
	{warnAtt("a_outputSensorWristList", "outputSensorDesc_intVal", a_outputSensorDesc_intVal);}
      else
        {
          std::list<outputSensorWristItem *> * theList;
          std::list<outputSensorWristItem *>::iterator iter;
          theList = a_outputSensorDesc_intVal->get_outputSensorWristList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_outputSensorWristItem(*iter);
        }
    }
}

/********************************************************************/

void check_outputSensorDesc_outputSensorWristList(
 outputSensorDesc_outputSensorWristList * a_outputSensorDesc_outputSensorWristList)
{
  if (a_outputSensorDesc_outputSensorWristList->get_outputSensorWristList())
    {
      if (!findString("a_outputSensorWristList", outputSensorDesc_outputSensorWristListAtts))
	{warnAtt("a_outputSensorWristList", "outputSensorDesc_outputSensorWristList", a_outputSensorDesc_outputSensorWristList);}
      else
        {
          std::list<outputSensorWristItem *> * theList;
          std::list<outputSensorWristItem *>::iterator iter;
          theList = a_outputSensorDesc_outputSensorWristList->get_outputSensorWristList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_outputSensorWristItem(*iter);
        }
    }
}

/********************************************************************/

void check_outputSensorDesc_stringVal(
 outputSensorDesc_stringVal * a_outputSensorDesc_stringVal)
{
  if (a_outputSensorDesc_stringVal->get_desc())
    {
      if (!findString("desc", outputSensorDesc_stringValAtts))
	{warnAtt("desc", "outputSensorDesc_stringVal", a_outputSensorDesc_stringVal);}
      else
        check_stringVal(a_outputSensorDesc_stringVal->get_desc());
    }
  if (a_outputSensorDesc_stringVal->get_outputSensorWristList())
    {
      if (!findString("a_outputSensorWristList", outputSensorDesc_stringValAtts))
	{warnAtt("a_outputSensorWristList", "outputSensorDesc_stringVal", a_outputSensorDesc_stringVal);}
      else
        {
          std::list<outputSensorWristItem *> * theList;
          std::list<outputSensorWristItem *>::iterator iter;
          theList = a_outputSensorDesc_stringVal->get_outputSensorWristList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_outputSensorWristItem(*iter);
        }
    }
}

/********************************************************************/

void check_outputSensorWristAngle(
 outputSensorWristAngle * a_outputSensorWristAngle)
{
  if (a_outputSensorWristAngle->get_anglename())
    {
      if (!findString("anglename", outputSensorWristAngleAtts))
	{warnAtt("anglename", "outputSensorWristAngle", a_outputSensorWristAngle);}
      else
        check_stringVal(a_outputSensorWristAngle->get_anglename());
    }
  if (a_outputSensorWristAngle->get_angle())
    {
      if (!findString("a_angle", outputSensorWristAngleAtts))
	{warnAtt("a_angle", "outputSensorWristAngle", a_outputSensorWristAngle);}
      else
        check_angle(a_outputSensorWristAngle->get_angle());
    }
}

/********************************************************************/

void check_outputSensorWristItem(
 outputSensorWristItem * a_outputSensorWristItem)
{
  if (a_outputSensorWristItem->get_swLabel())
    {
      if (!findString("a_swLabel", outputSensorWristItemAtts))
	{warnAtt("a_swLabel", "outputSensorWristItem", a_outputSensorWristItem);}
      else
        check_swLabel(a_outputSensorWristItem->get_swLabel());
    }
  if (a_outputSensorWristItem->get_outputSensorWristAngleList())
    {
      if (!findString("a_outputSensorWristAngleList", outputSensorWristItemAtts))
	{warnAtt("a_outputSensorWristAngleList", "outputSensorWristItem", a_outputSensorWristItem);}
      else
        {
          std::list<outputSensorWristAngle *> * theList;
          std::list<outputSensorWristAngle *>::iterator iter;
          theList = a_outputSensorWristItem->get_outputSensorWristAngleList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_outputSensorWristAngle(*iter);
        }
    }
}

/********************************************************************/

void check_outputStm(
 outputStm * a_outputStm)
{
  if (a_outputStm->get_outputMinor())
    {
      if (!findString("a_outputMinor", outputStmAtts))
	{warnAtt("a_outputMinor", "outputStm", a_outputStm);}
      else
        check_outputMinor(a_outputStm->get_outputMinor());
    }
}

/********************************************************************/

void check_outputToleranceData(
 outputToleranceData * a_outputToleranceData)
{
  if (isA(a_outputToleranceData, tLabel))
    {
      if (!findString("tLabel", outputToleranceDataSubs))
        {warnSub("tLabel", "outputToleranceData", a_outputToleranceData);}
      else
        check_tLabel(dynamic_cast<tLabel *>(a_outputToleranceData));
      return;
    }
  if (isA(a_outputToleranceData, taLabel))
    {
      if (!findString("taLabel", outputToleranceDataSubs))
        {warnSub("taLabel", "outputToleranceData", a_outputToleranceData);}
      else
        check_taLabel(dynamic_cast<taLabel *>(a_outputToleranceData));
      return;
    }
}

/********************************************************************/

void check_pLabel(
 pLabel * a_pLabel)
{
  if (a_pLabel->get_labelName())
    {
      if (!findString("a_labelName", pLabelAtts))
	{warnAtt("a_labelName", "pLabel", a_pLabel);}
      else
        check_labelName(a_pLabel->get_labelName());
    }
}

/********************************************************************/

void check_pameasDetail(
 pameasDetail * a_pameasDetail)
{
  if (isA(a_pameasDetail, pameasDetailDistance))
    {
      if (!findString("pameasDetailDistance", pameasDetailSubs))
        {warnSub("pameasDetailDistance", "pameasDetail", a_pameasDetail);}
      else
        check_pameasDetailDistance(dynamic_cast<pameasDetailDistance *>(a_pameasDetail));
      return;
    }
  if (isA(a_pameasDetail, pameasDetailScnvelData))
    {
      if (!findString("pameasDetailScnvelData", pameasDetailSubs))
        {warnSub("pameasDetailScnvelData", "pameasDetail", a_pameasDetail);}
      else
        check_pameasDetailScnvelData(dynamic_cast<pameasDetailScnvelData *>(a_pameasDetail));
      return;
    }
  if (isA(a_pameasDetail, pameasDetailPitch))
    {
      if (!findString("pameasDetailPitch", pameasDetailSubs))
        {warnSub("pameasDetailPitch", "pameasDetail", a_pameasDetail);}
      else
        check_pameasDetailPitch(dynamic_cast<pameasDetailPitch *>(a_pameasDetail));
      return;
    }
  if (isA(a_pameasDetail, pameasDetailNoData))
    {
      if (!findString("pameasDetailNoData", pameasDetailSubs))
        {warnSub("pameasDetailNoData", "pameasDetail", a_pameasDetail);}
      return;
    }
  if (isA(a_pameasDetail, pameasDetailScnvelNoData))
    {
      if (!findString("pameasDetailScnvelNoData", pameasDetailSubs))
        {warnSub("pameasDetailScnvelNoData", "pameasDetail", a_pameasDetail);}
      else
        check_pameasDetailScnvelNoData(dynamic_cast<pameasDetailScnvelNoData *>(a_pameasDetail));
      return;
    }
}

/********************************************************************/

void check_pameasDetailDistance(
 pameasDetailDistance * a_pameasDetailDistance)
{
  if (a_pameasDetailDistance->get_dist())
    {
      if (!findString("dist", pameasDetailDistanceAtts))
	{warnAtt("dist", "pameasDetailDistance", a_pameasDetailDistance);}
      else
        check_rentVal(a_pameasDetailDistance->get_dist());
    }
  if (a_pameasDetailDistance->get_feed())
    {
      if (!findString("feed", pameasDetailDistanceAtts))
	{warnAtt("feed", "pameasDetailDistance", a_pameasDetailDistance);}
      else
        check_pameasFedrat(a_pameasDetailDistance->get_feed());
    }
  if (a_pameasDetailDistance->get_pitch())
    {
      if (!findString("pitch", pameasDetailDistanceAtts))
	{warnAtt("pitch", "pameasDetailDistance", a_pameasDetailDistance);}
      else
        check_rentVal(a_pameasDetailDistance->get_pitch());
    }
}

/********************************************************************/

void check_pameasDetailPitch(
 pameasDetailPitch * a_pameasDetailPitch)
{
  if (a_pameasDetailPitch->get_pitch())
    {
      if (!findString("pitch", pameasDetailPitchAtts))
	{warnAtt("pitch", "pameasDetailPitch", a_pameasDetailPitch);}
      else
        check_rentVal(a_pameasDetailPitch->get_pitch());
    }
}

/********************************************************************/

void check_pameasDetailScnvelData(
 pameasDetailScnvelData * a_pameasDetailScnvelData)
{
  if (a_pameasDetailScnvelData->get_feed())
    {
      if (!findString("feed", pameasDetailScnvelDataAtts))
	{warnAtt("feed", "pameasDetailScnvelData", a_pameasDetailScnvelData);}
      else
        check_pameasFedrat(a_pameasDetailScnvelData->get_feed());
    }
  if (a_pameasDetailScnvelData->get_pitch())
    {
      if (!findString("pitch", pameasDetailScnvelDataAtts))
	{warnAtt("pitch", "pameasDetailScnvelData", a_pameasDetailScnvelData);}
      else
        check_rentVal(a_pameasDetailScnvelData->get_pitch());
    }
}

/********************************************************************/

void check_pameasDetailScnvelNoData(
 pameasDetailScnvelNoData * a_pameasDetailScnvelNoData)
{
  if (a_pameasDetailScnvelNoData->get_feed())
    {
      if (!findString("feed", pameasDetailScnvelNoDataAtts))
	{warnAtt("feed", "pameasDetailScnvelNoData", a_pameasDetailScnvelNoData);}
      else
        check_pameasFedrat(a_pameasDetailScnvelNoData->get_feed());
    }
}

/********************************************************************/

void check_pameasFedrat(
 pameasFedrat * a_pameasFedrat)
{
  if (isA(a_pameasFedrat, pameasFedrat_MPM))
    {
      if (!findString("pameasFedrat_MPM", pameasFedratSubs))
        {warnSub("pameasFedrat_MPM", "pameasFedrat", a_pameasFedrat);}
      else
        check_pameasFedrat_MPM(dynamic_cast<pameasFedrat_MPM *>(a_pameasFedrat));
      return;
    }
  if (isA(a_pameasFedrat, pameasFedrat_MMPS))
    {
      if (!findString("pameasFedrat_MMPS", pameasFedratSubs))
        {warnSub("pameasFedrat_MMPS", "pameasFedrat", a_pameasFedrat);}
      else
        check_pameasFedrat_MMPS(dynamic_cast<pameasFedrat_MMPS *>(a_pameasFedrat));
      return;
    }
  if (isA(a_pameasFedrat, pameasFedrat_IPM))
    {
      if (!findString("pameasFedrat_IPM", pameasFedratSubs))
        {warnSub("pameasFedrat_IPM", "pameasFedrat", a_pameasFedrat);}
      else
        check_pameasFedrat_IPM(dynamic_cast<pameasFedrat_IPM *>(a_pameasFedrat));
      return;
    }
  if (isA(a_pameasFedrat, pameasFedrat_IPS))
    {
      if (!findString("pameasFedrat_IPS", pameasFedratSubs))
        {warnSub("pameasFedrat_IPS", "pameasFedrat", a_pameasFedrat);}
      else
        check_pameasFedrat_IPS(dynamic_cast<pameasFedrat_IPS *>(a_pameasFedrat));
      return;
    }
}

/********************************************************************/

void check_pameasFedrat_IPM(
 pameasFedrat_IPM * a_pameasFedrat_IPM)
{
  if (a_pameasFedrat_IPM->get_rate())
    {
      if (!findString("rate", pameasFedrat_IPMAtts))
	{warnAtt("rate", "pameasFedrat_IPM", a_pameasFedrat_IPM);}
      else
        check_rentVal(a_pameasFedrat_IPM->get_rate());
    }
}

/********************************************************************/

void check_pameasFedrat_IPS(
 pameasFedrat_IPS * a_pameasFedrat_IPS)
{
  if (a_pameasFedrat_IPS->get_rate())
    {
      if (!findString("rate", pameasFedrat_IPSAtts))
	{warnAtt("rate", "pameasFedrat_IPS", a_pameasFedrat_IPS);}
      else
        check_rentVal(a_pameasFedrat_IPS->get_rate());
    }
}

/********************************************************************/

void check_pameasFedrat_MMPS(
 pameasFedrat_MMPS * a_pameasFedrat_MMPS)
{
  if (a_pameasFedrat_MMPS->get_rate())
    {
      if (!findString("rate", pameasFedrat_MMPSAtts))
	{warnAtt("rate", "pameasFedrat_MMPS", a_pameasFedrat_MMPS);}
      else
        check_rentVal(a_pameasFedrat_MMPS->get_rate());
    }
}

/********************************************************************/

void check_pameasFedrat_MPM(
 pameasFedrat_MPM * a_pameasFedrat_MPM)
{
  if (a_pameasFedrat_MPM->get_rate())
    {
      if (!findString("rate", pameasFedrat_MPMAtts))
	{warnAtt("rate", "pameasFedrat_MPM", a_pameasFedrat_MPM);}
      else
        check_rentVal(a_pameasFedrat_MPM->get_rate());
    }
}

/********************************************************************/

void check_pameasMinor(
 pameasMinor * a_pameasMinor)
{
  if (isA(a_pameasMinor, pameasMinor_pameasVar2List))
    {
      if (!findString("pameasMinor_pameasVar2List", pameasMinorSubs))
        {warnSub("pameasMinor_pameasVar2List", "pameasMinor", a_pameasMinor);}
      else
        check_pameasMinor_pameasVar2List(dynamic_cast<pameasMinor_pameasVar2List *>(a_pameasMinor));
      return;
    }
  if (isA(a_pameasMinor, pameasMinor_pameasVar3List))
    {
      if (!findString("pameasMinor_pameasVar3List", pameasMinorSubs))
        {warnSub("pameasMinor_pameasVar3List", "pameasMinor", a_pameasMinor);}
      else
        check_pameasMinor_pameasVar3List(dynamic_cast<pameasMinor_pameasVar3List *>(a_pameasMinor));
      return;
    }
}

/********************************************************************/

void check_pameasMinor_pameasVar2List(
 pameasMinor_pameasVar2List * a_pameasMinor_pameasVar2List)
{
  if (a_pameasMinor_pameasVar2List->get_pameasVar2List())
    {
      if (!findString("a_pameasVar2List", pameasMinor_pameasVar2ListAtts))
	{warnAtt("a_pameasVar2List", "pameasMinor_pameasVar2List", a_pameasMinor_pameasVar2List);}
      else
        {
          std::list<pameasVar2ListItem *> * theList;
          std::list<pameasVar2ListItem *>::iterator iter;
          theList = a_pameasMinor_pameasVar2List->get_pameasVar2List();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_pameasVar2ListItem(*iter);
        }
    }
}

/********************************************************************/

void check_pameasMinor_pameasVar3List(
 pameasMinor_pameasVar3List * a_pameasMinor_pameasVar3List)
{
  if (a_pameasMinor_pameasVar3List->get_pameasVar3List())
    {
      if (!findString("a_pameasVar3List", pameasMinor_pameasVar3ListAtts))
	{warnAtt("a_pameasVar3List", "pameasMinor_pameasVar3List", a_pameasMinor_pameasVar3List);}
      else
        {
          std::list<pameasVar3ListItem *> * theList;
          std::list<pameasVar3ListItem *>::iterator iter;
          theList = a_pameasMinor_pameasVar3List->get_pameasVar3List();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_pameasVar3ListItem(*iter);
        }
    }
}

/********************************************************************/

void check_pameasRemove(
 pameasRemove * a_pameasRemove)
{
  if (isA(a_pameasRemove, pameasRemoveCount))
    {
      if (!findString("pameasRemoveCount", pameasRemoveSubs))
        {warnSub("pameasRemoveCount", "pameasRemove", a_pameasRemove);}
      else
        check_pameasRemoveCount(dynamic_cast<pameasRemoveCount *>(a_pameasRemove));
      return;
    }
  if (isA(a_pameasRemove, pameasRemoveDist))
    {
      if (!findString("pameasRemoveDist", pameasRemoveSubs))
        {warnSub("pameasRemoveDist", "pameasRemove", a_pameasRemove);}
      else
        check_pameasRemoveDist(dynamic_cast<pameasRemoveDist *>(a_pameasRemove));
      return;
    }
  if (isA(a_pameasRemove, pameasRemoveAll))
    {
      if (!findString("pameasRemoveAll", pameasRemoveSubs))
        {warnSub("pameasRemoveAll", "pameasRemove", a_pameasRemove);}
      return;
    }
}

/********************************************************************/

void check_pameasRemoveCount(
 pameasRemoveCount * a_pameasRemoveCount)
{
  if (a_pameasRemoveCount->get_numPt1())
    {
      if (!findString("numPt1", pameasRemoveCountAtts))
	{warnAtt("numPt1", "pameasRemoveCount", a_pameasRemoveCount);}
      else
        check_intVal(a_pameasRemoveCount->get_numPt1());
    }
  if (a_pameasRemoveCount->get_numPt2())
    {
      if (!findString("numPt2", pameasRemoveCountAtts))
	{warnAtt("numPt2", "pameasRemoveCount", a_pameasRemoveCount);}
      else
        check_intVal(a_pameasRemoveCount->get_numPt2());
    }
}

/********************************************************************/

void check_pameasRemoveDist(
 pameasRemoveDist * a_pameasRemoveDist)
{
  if (a_pameasRemoveDist->get_dist1())
    {
      if (!findString("dist1", pameasRemoveDistAtts))
	{warnAtt("dist1", "pameasRemoveDist", a_pameasRemoveDist);}
      else
        check_rentVal(a_pameasRemoveDist->get_dist1());
    }
  if (a_pameasRemoveDist->get_dist2())
    {
      if (!findString("dist2", pameasRemoveDistAtts))
	{warnAtt("dist2", "pameasRemoveDist", a_pameasRemoveDist);}
      else
        check_rentVal(a_pameasRemoveDist->get_dist2());
    }
}

/********************************************************************/

void check_pameasStm(
 pameasStm * a_pameasStm)
{
  if (a_pameasStm->get_pameasMinor())
    {
      if (!findString("a_pameasMinor", pameasStmAtts))
	{warnAtt("a_pameasMinor", "pameasStm", a_pameasStm);}
      else
        check_pameasMinor(a_pameasStm->get_pameasMinor());
    }
}

/********************************************************************/

void check_pameasVar2ListItem(
 pameasVar2ListItem * a_pameasVar2ListItem)
{
  if (a_pameasVar2ListItem->get_pameasDetail())
    {
      if (!findString("a_pameasDetail", pameasVar2ListItemAtts))
	{warnAtt("a_pameasDetail", "pameasVar2ListItem", a_pameasVar2ListItem);}
      else
        check_pameasDetail(a_pameasVar2ListItem->get_pameasDetail());
    }
  if (a_pameasVar2ListItem->get_pLabel())
    {
      if (!findString("a_pLabel", pameasVar2ListItemAtts))
	{warnAtt("a_pLabel", "pameasVar2ListItem", a_pameasVar2ListItem);}
      else
        check_pLabel(a_pameasVar2ListItem->get_pLabel());
    }
  if (a_pameasVar2ListItem->get_apprch())
    {
      if (!findString("apprch", pameasVar2ListItemAtts))
	{warnAtt("apprch", "pameasVar2ListItem", a_pameasVar2ListItem);}
      else
        check_vector(a_pameasVar2ListItem->get_apprch());
    }
  if (a_pameasVar2ListItem->get_forceVec())
    {
      if (!findString("forceVec", pameasVar2ListItemAtts))
	{warnAtt("forceVec", "pameasVar2ListItem", a_pameasVar2ListItem);}
      else
        check_vector(a_pameasVar2ListItem->get_forceVec());
    }
  if (a_pameasVar2ListItem->get_forceOrDeflection())
    {
      if (!findString("a_forceOrDeflection", pameasVar2ListItemAtts))
	{warnAtt("a_forceOrDeflection", "pameasVar2ListItem", a_pameasVar2ListItem);}
      else
        check_forceOrDeflection(a_pameasVar2ListItem->get_forceOrDeflection());
    }
  if (a_pameasVar2ListItem->get_pameasRemove())
    {
      if (!findString("a_pameasRemove", pameasVar2ListItemAtts))
	{warnAtt("a_pameasRemove", "pameasVar2ListItem", a_pameasVar2ListItem);}
      else
        check_pameasRemove(a_pameasVar2ListItem->get_pameasRemove());
    }
  if (a_pameasVar2ListItem->get_rtLabel())
    {
      if (!findString("a_rtLabel", pameasVar2ListItemAtts))
	{warnAtt("a_rtLabel", "pameasVar2ListItem", a_pameasVar2ListItem);}
      else
        check_rtLabel(a_pameasVar2ListItem->get_rtLabel());
    }
}

/********************************************************************/

void check_pameasVar3ListItem(
 pameasVar3ListItem * a_pameasVar3ListItem)
{
  if (a_pameasVar3ListItem->get_pLabel())
    {
      if (!findString("a_pLabel", pameasVar3ListItemAtts))
	{warnAtt("a_pLabel", "pameasVar3ListItem", a_pameasVar3ListItem);}
      else
        check_pLabel(a_pameasVar3ListItem->get_pLabel());
    }
  if (a_pameasVar3ListItem->get_apprch())
    {
      if (!findString("apprch", pameasVar3ListItemAtts))
	{warnAtt("apprch", "pameasVar3ListItem", a_pameasVar3ListItem);}
      else
        check_vector(a_pameasVar3ListItem->get_apprch());
    }
  if (a_pameasVar3ListItem->get_forceVec())
    {
      if (!findString("forceVec", pameasVar3ListItemAtts))
	{warnAtt("forceVec", "pameasVar3ListItem", a_pameasVar3ListItem);}
      else
        check_vector(a_pameasVar3ListItem->get_forceVec());
    }
  if (a_pameasVar3ListItem->get_forceOrDeflection())
    {
      if (!findString("a_forceOrDeflection", pameasVar3ListItemAtts))
	{warnAtt("a_forceOrDeflection", "pameasVar3ListItem", a_pameasVar3ListItem);}
      else
        check_forceOrDeflection(a_pameasVar3ListItem->get_forceOrDeflection());
    }
  if (a_pameasVar3ListItem->get_pameasRemove())
    {
      if (!findString("a_pameasRemove", pameasVar3ListItemAtts))
	{warnAtt("a_pameasRemove", "pameasVar3ListItem", a_pameasVar3ListItem);}
      else
        check_pameasRemove(a_pameasVar3ListItem->get_pameasRemove());
    }
  if (a_pameasVar3ListItem->get_rtLabel())
    {
      if (!findString("a_rtLabel", pameasVar3ListItemAtts))
	{warnAtt("a_rtLabel", "pameasVar3ListItem", a_pameasVar3ListItem);}
      else
        check_rtLabel(a_pameasVar3ListItem->get_rtLabel());
    }
}

/********************************************************************/

void check_param(
 param * a_param)
{
  if (isA(a_param, anyVal))
    {
      if (!findString("anyVal", paramSubs))
        {warnSub("anyVal", "param", a_param);}
      else
        check_anyVal(dynamic_cast<anyVal *>(a_param));
      return;
    }
}

/********************************************************************/

void check_partidStm(
 partidStm * a_partidStm)
{
  if (a_partidStm->get_pnLabel())
    {
      if (!findString("a_pnLabel", partidStmAtts))
	{warnAtt("a_pnLabel", "partidStm", a_partidStm);}
      else
        check_pnLabel(a_partidStm->get_pnLabel());
    }
  if (a_partidStm->get_text())
    {
      if (!findString("text", partidStmAtts))
	{warnAtt("text", "partidStm", a_partidStm);}
      else
        check_stringVal(a_partidStm->get_text());
    }
}

/********************************************************************/

void check_partoConst(
 partoConst * a_partoConst)
{
  if (isA(a_partoConst, partoConstAct))
    {
      if (!findString("partoConstAct", partoConstSubs))
        {warnSub("partoConstAct", "partoConst", a_partoConst);}
      else
        check_partoConstAct(dynamic_cast<partoConstAct *>(a_partoConst));
      return;
    }
  if (isA(a_partoConst, partoConstNom))
    {
      if (!findString("partoConstNom", partoConstSubs))
        {warnSub("partoConstNom", "partoConst", a_partoConst);}
      else
        check_partoConstNom(dynamic_cast<partoConstNom *>(a_partoConst));
      return;
    }
}

/********************************************************************/

void check_partoConstAct(
 partoConstAct * a_partoConstAct)
{
  if (a_partoConstAct->get_faLabel())
    {
      if (!findString("a_faLabel", partoConstActAtts))
	{warnAtt("a_faLabel", "partoConstAct", a_partoConstAct);}
      else
        check_faLabel(a_partoConstAct->get_faLabel());
    }
  if (a_partoConstAct->get_featureLabel())
    {
      if (!findString("a_featureLabel", partoConstActAtts))
	{warnAtt("a_featureLabel", "partoConstAct", a_partoConstAct);}
      else
        check_featureLabel(a_partoConstAct->get_featureLabel());
    }
}

/********************************************************************/

void check_partoConstNom(
 partoConstNom * a_partoConstNom)
{
  if (a_partoConstNom->get_fLabel())
    {
      if (!findString("a_fLabel", partoConstNomAtts))
	{warnAtt("a_fLabel", "partoConstNom", a_partoConstNom);}
      else
        check_fLabel(a_partoConstNom->get_fLabel());
    }
  if (a_partoConstNom->get_faLabel())
    {
      if (!findString("a_faLabel", partoConstNomAtts))
	{warnAtt("a_faLabel", "partoConstNom", a_partoConstNom);}
      else
        check_faLabel(a_partoConstNom->get_faLabel());
    }
}

/********************************************************************/

void check_partrvStm(
 partrvStm * a_partrvStm)
{
  if (a_partrvStm->get_prLabel())
    {
      if (!findString("a_prLabel", partrvStmAtts))
	{warnAtt("a_prLabel", "partrvStm", a_partrvStm);}
      else
        check_prLabel(a_partrvStm->get_prLabel());
    }
  if (a_partrvStm->get_text())
    {
      if (!findString("text", partrvStmAtts))
	{warnAtt("text", "partrvStm", a_partrvStm);}
      else
        check_stringVal(a_partrvStm->get_text());
    }
}

/********************************************************************/

void check_partsnStm(
 partsnStm * a_partsnStm)
{
  if (a_partsnStm->get_psLabel())
    {
      if (!findString("a_psLabel", partsnStmAtts))
	{warnAtt("a_psLabel", "partsnStm", a_partsnStm);}
      else
        check_psLabel(a_partsnStm->get_psLabel());
    }
  if (a_partsnStm->get_text())
    {
      if (!findString("text", partsnStmAtts))
	{warnAtt("text", "partsnStm", a_partsnStm);}
      else
        check_stringVal(a_partsnStm->get_text());
    }
}

/********************************************************************/

void check_pathArc(
 pathArc * a_pathArc)
{
  if (a_pathArc->get_center())
    {
      if (!findString("center", pathArcAtts))
	{warnAtt("center", "pathArc", a_pathArc);}
      else
        check_typePoint(a_pathArc->get_center());
    }
  if (a_pathArc->get_planeVec())
    {
      if (!findString("planeVec", pathArcAtts))
	{warnAtt("planeVec", "pathArc", a_pathArc);}
      else
        check_vector(a_pathArc->get_planeVec());
    }
  if (a_pathArc->get_radius())
    {
      if (!findString("radius", pathArcAtts))
	{warnAtt("radius", "pathArc", a_pathArc);}
      else
        check_rentVal(a_pathArc->get_radius());
    }
  if (a_pathArc->get_startAngle())
    {
      if (!findString("startAngle", pathArcAtts))
	{warnAtt("startAngle", "pathArc", a_pathArc);}
      else
        check_angle(a_pathArc->get_startAngle());
    }
  if (a_pathArc->get_includAngle())
    {
      if (!findString("includAngle", pathArcAtts))
	{warnAtt("includAngle", "pathArc", a_pathArc);}
      else
        check_angle(a_pathArc->get_includAngle());
    }
  if (a_pathArc->get_startVec())
    {
      if (!findString("startVec", pathArcAtts))
	{warnAtt("startVec", "pathArc", a_pathArc);}
      else
        check_vector(a_pathArc->get_startVec());
    }
}

/********************************************************************/

void check_pathCurve(
 pathCurve * a_pathCurve)
{
  if (isA(a_pathCurve, pathCurve_pathCurvePtdata))
    {
      if (!findString("pathCurve_pathCurvePtdata", pathCurveSubs))
        {warnSub("pathCurve_pathCurvePtdata", "pathCurve", a_pathCurve);}
      else
        check_pathCurve_pathCurvePtdata(dynamic_cast<pathCurve_pathCurvePtdata *>(a_pathCurve));
      return;
    }
  if (isA(a_pathCurve, pathCurve_pathCurvePoints))
    {
      if (!findString("pathCurve_pathCurvePoints", pathCurveSubs))
        {warnSub("pathCurve_pathCurvePoints", "pathCurve", a_pathCurve);}
      else
        check_pathCurve_pathCurvePoints(dynamic_cast<pathCurve_pathCurvePoints *>(a_pathCurve));
      return;
    }
}

/********************************************************************/

void check_pathCurvePoints(
 pathCurvePoints * a_pathCurvePoints)
{
  if (a_pathCurvePoints->get_pointVecCart())
    {
      if (!findString("a_pointVecCart", pathCurvePointsAtts))
	{warnAtt("a_pointVecCart", "pathCurvePoints", a_pathCurvePoints);}
      else
        check_pointVecCart(a_pathCurvePoints->get_pointVecCart());
    }
  if (a_pathCurvePoints->get_pointVecCartList())
    {
      if (!findString("a_pointVecCartList", pathCurvePointsAtts))
	{warnAtt("a_pointVecCartList", "pathCurvePoints", a_pathCurvePoints);}
      else
        {
          std::list<pointVecCart *> * theList;
          std::list<pointVecCart *>::iterator iter;
          theList = a_pathCurvePoints->get_pointVecCartList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_pointVecCart(*iter);
        }
    }
}

/********************************************************************/

void check_pathCurvePtdata(
 pathCurvePtdata * a_pathCurvePtdata)
{
  if (isA(a_pathCurvePtdata, curvePtdataPcs))
    {
      if (!findString("curvePtdataPcs", pathCurvePtdataSubs))
        {warnSub("curvePtdataPcs", "pathCurvePtdata", a_pathCurvePtdata);}
      else
        check_curvePtdataPcs(dynamic_cast<curvePtdataPcs *>(a_pathCurvePtdata));
      return;
    }
  if (isA(a_pathCurvePtdata, curvePtdataHeadcs))
    {
      if (!findString("curvePtdataHeadcs", pathCurvePtdataSubs))
        {warnSub("curvePtdataHeadcs", "pathCurvePtdata", a_pathCurvePtdata);}
      else
        check_curvePtdataHeadcs(dynamic_cast<curvePtdataHeadcs *>(a_pathCurvePtdata));
      return;
    }
}

/********************************************************************/

void check_pathCurve_pathCurvePoints(
 pathCurve_pathCurvePoints * a_pathCurve_pathCurvePoints)
{
  if (a_pathCurve_pathCurvePoints->get_pathCurvePoints())
    {
      if (!findString("a_pathCurvePoints", pathCurve_pathCurvePointsAtts))
	{warnAtt("a_pathCurvePoints", "pathCurve_pathCurvePoints", a_pathCurve_pathCurvePoints);}
      else
        check_pathCurvePoints(a_pathCurve_pathCurvePoints->get_pathCurvePoints());
    }
}

/********************************************************************/

void check_pathCurve_pathCurvePtdata(
 pathCurve_pathCurvePtdata * a_pathCurve_pathCurvePtdata)
{
  if (a_pathCurve_pathCurvePtdata->get_pathCurvePtdata())
    {
      if (!findString("a_pathCurvePtdata", pathCurve_pathCurvePtdataAtts))
	{warnAtt("a_pathCurvePtdata", "pathCurve_pathCurvePtdata", a_pathCurve_pathCurvePtdata);}
      else
        check_pathCurvePtdata(a_pathCurve_pathCurvePtdata->get_pathCurvePtdata());
    }
}

/********************************************************************/

void check_pathHelical(
 pathHelical * a_pathHelical)
{
  if (a_pathHelical->get_center())
    {
      if (!findString("center", pathHelicalAtts))
	{warnAtt("center", "pathHelical", a_pathHelical);}
      else
        check_typePoint(a_pathHelical->get_center());
    }
  if (a_pathHelical->get_axisVec())
    {
      if (!findString("axisVec", pathHelicalAtts))
	{warnAtt("axisVec", "pathHelical", a_pathHelical);}
      else
        check_vector(a_pathHelical->get_axisVec());
    }
  if (a_pathHelical->get_radius())
    {
      if (!findString("radius", pathHelicalAtts))
	{warnAtt("radius", "pathHelical", a_pathHelical);}
      else
        check_rentVal(a_pathHelical->get_radius());
    }
  if (a_pathHelical->get_startAngle())
    {
      if (!findString("startAngle", pathHelicalAtts))
	{warnAtt("startAngle", "pathHelical", a_pathHelical);}
      else
        check_angle(a_pathHelical->get_startAngle());
    }
  if (a_pathHelical->get_includAngle())
    {
      if (!findString("includAngle", pathHelicalAtts))
	{warnAtt("includAngle", "pathHelical", a_pathHelical);}
      else
        check_angle(a_pathHelical->get_includAngle());
    }
  if (a_pathHelical->get_startVec())
    {
      if (!findString("startVec", pathHelicalAtts))
	{warnAtt("startVec", "pathHelical", a_pathHelical);}
      else
        check_vector(a_pathHelical->get_startVec());
    }
  if (a_pathHelical->get_pitch())
    {
      if (!findString("pitch", pathHelicalAtts))
	{warnAtt("pitch", "pathHelical", a_pathHelical);}
      else
        check_rentVal(a_pathHelical->get_pitch());
    }
  if (a_pathHelical->get_coneAngle())
    {
      if (!findString("coneAngle", pathHelicalAtts))
	{warnAtt("coneAngle", "pathHelical", a_pathHelical);}
      else
        check_angle(a_pathHelical->get_coneAngle());
    }
}

/********************************************************************/

void check_pathLine(
 pathLine * a_pathLine)
{
  if (isA(a_pathLine, pathLineCart))
    {
      if (!findString("pathLineCart", pathLineSubs))
        {warnSub("pathLineCart", "pathLine", a_pathLine);}
      else
        check_pathLineCart(dynamic_cast<pathLineCart *>(a_pathLine));
      return;
    }
  if (isA(a_pathLine, pathLinePol))
    {
      if (!findString("pathLinePol", pathLineSubs))
        {warnSub("pathLinePol", "pathLine", a_pathLine);}
      else
        check_pathLinePol(dynamic_cast<pathLinePol *>(a_pathLine));
      return;
    }
}

/********************************************************************/

void check_pathLineCart(
 pathLineCart * a_pathLineCart)
{
  if (a_pathLineCart->get_start())
    {
      if (!findString("start", pathLineCartAtts))
	{warnAtt("start", "pathLineCart", a_pathLineCart);}
      else
        check_impCartPoint(a_pathLineCart->get_start());
    }
  if (a_pathLineCart->get_startSpec())
    {
      if (!findString("startSpec", pathLineCartAtts))
	{warnAtt("startSpec", "pathLineCart", a_pathLineCart);}
      else
        check_csSpec(a_pathLineCart->get_startSpec());
    }
  if (a_pathLineCart->get_end())
    {
      if (!findString("end", pathLineCartAtts))
	{warnAtt("end", "pathLineCart", a_pathLineCart);}
      else
        check_impCartPoint(a_pathLineCart->get_end());
    }
  if (a_pathLineCart->get_endSpec())
    {
      if (!findString("endSpec", pathLineCartAtts))
	{warnAtt("endSpec", "pathLineCart", a_pathLineCart);}
      else
        check_csSpec(a_pathLineCart->get_endSpec());
    }
  if (a_pathLineCart->get_planeVec())
    {
      if (!findString("planeVec", pathLineCartAtts))
	{warnAtt("planeVec", "pathLineCart", a_pathLineCart);}
      else
        check_vector(a_pathLineCart->get_planeVec());
    }
}

/********************************************************************/

void check_pathLinePol(
 pathLinePol * a_pathLinePol)
{
  if (a_pathLinePol->get_start())
    {
      if (!findString("start", pathLinePolAtts))
	{warnAtt("start", "pathLinePol", a_pathLinePol);}
      else
        check_impPolPoint(a_pathLinePol->get_start());
    }
  if (a_pathLinePol->get_end())
    {
      if (!findString("end", pathLinePolAtts))
	{warnAtt("end", "pathLinePol", a_pathLinePol);}
      else
        check_impPolPoint(a_pathLinePol->get_end());
    }
  if (a_pathLinePol->get_planeVec())
    {
      if (!findString("planeVec", pathLinePolAtts))
	{warnAtt("planeVec", "pathLinePol", a_pathLinePol);}
      else
        check_vector(a_pathLinePol->get_planeVec());
    }
}

/********************************************************************/

void check_pathMinor(
 pathMinor * a_pathMinor)
{
  if (isA(a_pathMinor, pathPoint))
    {
      if (!findString("pathPoint", pathMinorSubs))
        {warnSub("pathPoint", "pathMinor", a_pathMinor);}
      else
        check_pathPoint(dynamic_cast<pathPoint *>(a_pathMinor));
      return;
    }
  if (isA(a_pathMinor, pathArc))
    {
      if (!findString("pathArc", pathMinorSubs))
        {warnSub("pathArc", "pathMinor", a_pathMinor);}
      else
        check_pathArc(dynamic_cast<pathArc *>(a_pathMinor));
      return;
    }
  if (isA(a_pathMinor, pathCurve))
    {
      if (!findString("pathCurve", pathMinorSubs))
        {warnSub("pathCurve", "pathMinor", a_pathMinor);}
      else
        check_pathCurve(dynamic_cast<pathCurve *>(a_pathMinor));
      return;
    }
  if (isA(a_pathMinor, pathHelical))
    {
      if (!findString("pathHelical", pathMinorSubs))
        {warnSub("pathHelical", "pathMinor", a_pathMinor);}
      else
        check_pathHelical(dynamic_cast<pathHelical *>(a_pathMinor));
      return;
    }
  if (isA(a_pathMinor, pathLine))
    {
      if (!findString("pathLine", pathMinorSubs))
        {warnSub("pathLine", "pathMinor", a_pathMinor);}
      else
        check_pathLine(dynamic_cast<pathLine *>(a_pathMinor));
      return;
    }
  if (isA(a_pathMinor, pathSurface))
    {
      if (!findString("pathSurface", pathMinorSubs))
        {warnSub("pathSurface", "pathMinor", a_pathMinor);}
      else
        check_pathSurface(dynamic_cast<pathSurface *>(a_pathMinor));
      return;
    }
  if (isA(a_pathMinor, pathUnknown))
    {
      if (!findString("pathUnknown", pathMinorSubs))
        {warnSub("pathUnknown", "pathMinor", a_pathMinor);}
      else
        check_pathUnknown(dynamic_cast<pathUnknown *>(a_pathMinor));
      return;
    }
}

/********************************************************************/

void check_pathPoint(
 pathPoint * a_pathPoint)
{
  if (a_pathPoint->get_typePoint())
    {
      if (!findString("a_typePoint", pathPointAtts))
	{warnAtt("a_typePoint", "pathPoint", a_pathPoint);}
      else
        check_typePoint(a_pathPoint->get_typePoint());
    }
  if (a_pathPoint->get_dir())
    {
      if (!findString("dir", pathPointAtts))
	{warnAtt("dir", "pathPoint", a_pathPoint);}
      else
        check_vector(a_pathPoint->get_dir());
    }
}

/********************************************************************/

void check_pathStm(
 pathStm * a_pathStm)
{
  if (a_pathStm->get_pLabel())
    {
      if (!findString("a_pLabel", pathStmAtts))
	{warnAtt("a_pLabel", "pathStm", a_pathStm);}
      else
        check_pLabel(a_pathStm->get_pLabel());
    }
  if (a_pathStm->get_pathMinor())
    {
      if (!findString("a_pathMinor", pathStmAtts))
	{warnAtt("a_pathMinor", "pathStm", a_pathStm);}
      else
        check_pathMinor(a_pathStm->get_pathMinor());
    }
}

/********************************************************************/

void check_pathSurface(
 pathSurface * a_pathSurface)
{
  if (isA(a_pathSurface, pathSurfacePlain))
    {
      if (!findString("pathSurfacePlain", pathSurfaceSubs))
        {warnSub("pathSurfacePlain", "pathSurface", a_pathSurface);}
      else
        check_pathSurfacePlain(dynamic_cast<pathSurfacePlain *>(a_pathSurface));
      return;
    }
  if (isA(a_pathSurface, pathSurfacePcs))
    {
      if (!findString("pathSurfacePcs", pathSurfaceSubs))
        {warnSub("pathSurfacePcs", "pathSurface", a_pathSurface);}
      else
        check_pathSurfacePcs(dynamic_cast<pathSurfacePcs *>(a_pathSurface));
      return;
    }
  if (isA(a_pathSurface, pathSurfacePcsData))
    {
      if (!findString("pathSurfacePcsData", pathSurfaceSubs))
        {warnSub("pathSurfacePcsData", "pathSurface", a_pathSurface);}
      else
        check_pathSurfacePcsData(dynamic_cast<pathSurfacePcsData *>(a_pathSurface));
      return;
    }
  if (isA(a_pathSurface, pathSurfaceHeadcs))
    {
      if (!findString("pathSurfaceHeadcs", pathSurfaceSubs))
        {warnSub("pathSurfaceHeadcs", "pathSurface", a_pathSurface);}
      else
        check_pathSurfaceHeadcs(dynamic_cast<pathSurfaceHeadcs *>(a_pathSurface));
      return;
    }
  if (isA(a_pathSurface, pathSurfaceHeadcsData))
    {
      if (!findString("pathSurfaceHeadcsData", pathSurfaceSubs))
        {warnSub("pathSurfaceHeadcsData", "pathSurface", a_pathSurface);}
      else
        check_pathSurfaceHeadcsData(dynamic_cast<pathSurfaceHeadcsData *>(a_pathSurface));
      return;
    }
}

/********************************************************************/

void check_pathSurfaceHeadcs(
 pathSurfaceHeadcs * a_pathSurfaceHeadcs)
{
  if (a_pathSurfaceHeadcs->get_surfPtdataList())
    {
      if (!findString("a_surfPtdataList", pathSurfaceHeadcsAtts))
	{warnAtt("a_surfPtdataList", "pathSurfaceHeadcs", a_pathSurfaceHeadcs);}
      else
        {
          std::list<surfPtdataListItem *> * theList;
          std::list<surfPtdataListItem *>::iterator iter;
          theList = a_pathSurfaceHeadcs->get_surfPtdataList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_surfPtdataListItem(*iter);
        }
    }
  if (a_pathSurfaceHeadcs->get_rot1())
    {
      if (!findString("rot1", pathSurfaceHeadcsAtts))
	{warnAtt("rot1", "pathSurfaceHeadcs", a_pathSurfaceHeadcs);}
      else
        check_rentVal(a_pathSurfaceHeadcs->get_rot1());
    }
  if (a_pathSurfaceHeadcs->get_rot2())
    {
      if (!findString("rot2", pathSurfaceHeadcsAtts))
	{warnAtt("rot2", "pathSurfaceHeadcs", a_pathSurfaceHeadcs);}
      else
        check_rentVal(a_pathSurfaceHeadcs->get_rot2());
    }
  if (a_pathSurfaceHeadcs->get_rot3())
    {
      if (!findString("rot3", pathSurfaceHeadcsAtts))
	{warnAtt("rot3", "pathSurfaceHeadcs", a_pathSurfaceHeadcs);}
      else
        check_rentVal(a_pathSurfaceHeadcs->get_rot3());
    }
}

/********************************************************************/

void check_pathSurfaceHeadcsData(
 pathSurfaceHeadcsData * a_pathSurfaceHeadcsData)
{
  if (a_pathSurfaceHeadcsData->get_surfPtdataList())
    {
      if (!findString("a_surfPtdataList", pathSurfaceHeadcsDataAtts))
	{warnAtt("a_surfPtdataList", "pathSurfaceHeadcsData", a_pathSurfaceHeadcsData);}
      else
        {
          std::list<surfPtdataListItem *> * theList;
          std::list<surfPtdataListItem *>::iterator iter;
          theList = a_pathSurfaceHeadcsData->get_surfPtdataList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_surfPtdataListItem(*iter);
        }
    }
  if (a_pathSurfaceHeadcsData->get_rot1())
    {
      if (!findString("rot1", pathSurfaceHeadcsDataAtts))
	{warnAtt("rot1", "pathSurfaceHeadcsData", a_pathSurfaceHeadcsData);}
      else
        check_rentVal(a_pathSurfaceHeadcsData->get_rot1());
    }
  if (a_pathSurfaceHeadcsData->get_rot2())
    {
      if (!findString("rot2", pathSurfaceHeadcsDataAtts))
	{warnAtt("rot2", "pathSurfaceHeadcsData", a_pathSurfaceHeadcsData);}
      else
        check_rentVal(a_pathSurfaceHeadcsData->get_rot2());
    }
  if (a_pathSurfaceHeadcsData->get_rot3())
    {
      if (!findString("rot3", pathSurfaceHeadcsDataAtts))
	{warnAtt("rot3", "pathSurfaceHeadcsData", a_pathSurfaceHeadcsData);}
      else
        check_rentVal(a_pathSurfaceHeadcsData->get_rot3());
    }
  if (a_pathSurfaceHeadcsData->get_surfPtdataHeadcsList())
    {
      if (!findString("a_surfPtdataHeadcsList", pathSurfaceHeadcsDataAtts))
	{warnAtt("a_surfPtdataHeadcsList", "pathSurfaceHeadcsData", a_pathSurfaceHeadcsData);}
      else
        {
          std::list<surfPtdataHeadcsListItem *> * theList;
          std::list<surfPtdataHeadcsListItem *>::iterator iter;
          theList = a_pathSurfaceHeadcsData->get_surfPtdataHeadcsList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_surfPtdataHeadcsListItem(*iter);
        }
    }
}

/********************************************************************/

void check_pathSurfacePcs(
 pathSurfacePcs * a_pathSurfacePcs)
{
  if (a_pathSurfacePcs->get_surfPtdataList())
    {
      if (!findString("a_surfPtdataList", pathSurfacePcsAtts))
	{warnAtt("a_surfPtdataList", "pathSurfacePcs", a_pathSurfacePcs);}
      else
        {
          std::list<surfPtdataListItem *> * theList;
          std::list<surfPtdataListItem *>::iterator iter;
          theList = a_pathSurfacePcs->get_surfPtdataList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_surfPtdataListItem(*iter);
        }
    }
  if (a_pathSurfacePcs->get_euler())
    {
      if (!findString("a_euler", pathSurfacePcsAtts))
	{warnAtt("a_euler", "pathSurfacePcs", a_pathSurfacePcs);}
      else
        check_euler(a_pathSurfacePcs->get_euler());
    }
}

/********************************************************************/

void check_pathSurfacePcsData(
 pathSurfacePcsData * a_pathSurfacePcsData)
{
  if (a_pathSurfacePcsData->get_surfPtdataList())
    {
      if (!findString("a_surfPtdataList", pathSurfacePcsDataAtts))
	{warnAtt("a_surfPtdataList", "pathSurfacePcsData", a_pathSurfacePcsData);}
      else
        {
          std::list<surfPtdataListItem *> * theList;
          std::list<surfPtdataListItem *>::iterator iter;
          theList = a_pathSurfacePcsData->get_surfPtdataList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_surfPtdataListItem(*iter);
        }
    }
  if (a_pathSurfacePcsData->get_euler())
    {
      if (!findString("a_euler", pathSurfacePcsDataAtts))
	{warnAtt("a_euler", "pathSurfacePcsData", a_pathSurfacePcsData);}
      else
        check_euler(a_pathSurfacePcsData->get_euler());
    }
  if (a_pathSurfacePcsData->get_surfPtdataPcsList())
    {
      if (!findString("a_surfPtdataPcsList", pathSurfacePcsDataAtts))
	{warnAtt("a_surfPtdataPcsList", "pathSurfacePcsData", a_pathSurfacePcsData);}
      else
        {
          std::list<surfPtdataPcsListItem *> * theList;
          std::list<surfPtdataPcsListItem *>::iterator iter;
          theList = a_pathSurfacePcsData->get_surfPtdataPcsList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_surfPtdataPcsListItem(*iter);
        }
    }
}

/********************************************************************/

void check_pathSurfacePlain(
 pathSurfacePlain * a_pathSurfacePlain)
{
  if (a_pathSurfacePlain->get_surfPtdataList())
    {
      if (!findString("a_surfPtdataList", pathSurfacePlainAtts))
	{warnAtt("a_surfPtdataList", "pathSurfacePlain", a_pathSurfacePlain);}
      else
        {
          std::list<surfPtdataListItem *> * theList;
          std::list<surfPtdataListItem *>::iterator iter;
          theList = a_pathSurfacePlain->get_surfPtdataList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_surfPtdataListItem(*iter);
        }
    }
}

/********************************************************************/

void check_pathUnknown(
 pathUnknown * a_pathUnknown)
{
  if (a_pathUnknown->get_start())
    {
      if (!findString("start", pathUnknownAtts))
	{warnAtt("start", "pathUnknown", a_pathUnknown);}
      else
        check_impCartPoint(a_pathUnknown->get_start());
    }
  if (a_pathUnknown->get_direction())
    {
      if (!findString("direction", pathUnknownAtts))
	{warnAtt("direction", "pathUnknown", a_pathUnknown);}
      else
        check_impCartPoint(a_pathUnknown->get_direction());
    }
  if (a_pathUnknown->get_end())
    {
      if (!findString("end", pathUnknownAtts))
	{warnAtt("end", "pathUnknown", a_pathUnknown);}
      else
        check_impCartPoint(a_pathUnknown->get_end());
    }
  if (a_pathUnknown->get_planeVec())
    {
      if (!findString("planeVec", pathUnknownAtts))
	{warnAtt("planeVec", "pathUnknown", a_pathUnknown);}
      else
        check_vector(a_pathUnknown->get_planeVec());
    }
}

/********************************************************************/

void check_pcLabel(
 pcLabel * a_pcLabel)
{
  if (a_pcLabel->get_labelName())
    {
      if (!findString("a_labelName", pcLabelAtts))
	{warnAtt("a_labelName", "pcLabel", a_pcLabel);}
      else
        check_labelName(a_pcLabel->get_labelName());
    }
}

/********************************************************************/

void check_perptoConst(
 perptoConst * a_perptoConst)
{
  if (isA(a_perptoConst, perptoConstAct))
    {
      if (!findString("perptoConstAct", perptoConstSubs))
        {warnSub("perptoConstAct", "perptoConst", a_perptoConst);}
      else
        check_perptoConstAct(dynamic_cast<perptoConstAct *>(a_perptoConst));
      return;
    }
  if (isA(a_perptoConst, perptoConstNom))
    {
      if (!findString("perptoConstNom", perptoConstSubs))
        {warnSub("perptoConstNom", "perptoConst", a_perptoConst);}
      else
        check_perptoConstNom(dynamic_cast<perptoConstNom *>(a_perptoConst));
      return;
    }
}

/********************************************************************/

void check_perptoConstAct(
 perptoConstAct * a_perptoConstAct)
{
  if (a_perptoConstAct->get_faLabel())
    {
      if (!findString("a_faLabel", perptoConstActAtts))
	{warnAtt("a_faLabel", "perptoConstAct", a_perptoConstAct);}
      else
        check_faLabel(a_perptoConstAct->get_faLabel());
    }
  if (a_perptoConstAct->get_featureLabel())
    {
      if (!findString("a_featureLabel", perptoConstActAtts))
	{warnAtt("a_featureLabel", "perptoConstAct", a_perptoConstAct);}
      else
        check_featureLabel(a_perptoConstAct->get_featureLabel());
    }
}

/********************************************************************/

void check_perptoConstNom(
 perptoConstNom * a_perptoConstNom)
{
  if (a_perptoConstNom->get_fLabel())
    {
      if (!findString("a_fLabel", perptoConstNomAtts))
	{warnAtt("a_fLabel", "perptoConstNom", a_perptoConstNom);}
      else
        check_fLabel(a_perptoConstNom->get_fLabel());
    }
  if (a_perptoConstNom->get_faLabel())
    {
      if (!findString("a_faLabel", perptoConstNomAtts))
	{warnAtt("a_faLabel", "perptoConstNom", a_perptoConstNom);}
      else
        check_faLabel(a_perptoConstNom->get_faLabel());
    }
}

/********************************************************************/

void check_pierceConst(
 pierceConst * a_pierceConst)
{
  if (a_pierceConst->get_faLabel())
    {
      if (!findString("a_faLabel", pierceConstAtts))
	{warnAtt("a_faLabel", "pierceConst", a_pierceConst);}
      else
        check_faLabel(a_pierceConst->get_faLabel());
    }
  if (a_pierceConst->get_featureLabel())
    {
      if (!findString("a_featureLabel", pierceConstAtts))
	{warnAtt("a_featureLabel", "pierceConst", a_pierceConst);}
      else
        check_featureLabel(a_pierceConst->get_featureLabel());
    }
}

/********************************************************************/

void check_plLabel(
 plLabel * a_plLabel)
{
  if (a_plLabel->get_labelName())
    {
      if (!findString("a_labelName", plLabelAtts))
	{warnAtt("a_labelName", "plLabel", a_plLabel);}
      else
        check_labelName(a_plLabel->get_labelName());
    }
}

/********************************************************************/

void check_plan(
 plan * a_plan)
{
  if (isA(a_plan, plan_XYPLAN))
    {
      if (!findString("plan_XYPLAN", planSubs))
        {warnSub("plan_XYPLAN", "plan", a_plan);}
      return;
    }
  if (isA(a_plan, plan_YZPLAN))
    {
      if (!findString("plan_YZPLAN", planSubs))
        {warnSub("plan_YZPLAN", "plan", a_plan);}
      return;
    }
  if (isA(a_plan, plan_ZXPLAN))
    {
      if (!findString("plan_ZXPLAN", planSubs))
        {warnSub("plan_ZXPLAN", "plan", a_plan);}
      return;
    }
}

/********************************************************************/

void check_planidStm(
 planidStm * a_planidStm)
{
  if (a_planidStm->get_plLabel())
    {
      if (!findString("a_plLabel", planidStmAtts))
	{warnAtt("a_plLabel", "planidStm", a_planidStm);}
      else
        check_plLabel(a_planidStm->get_plLabel());
    }
  if (a_planidStm->get_text())
    {
      if (!findString("text", planidStmAtts))
	{warnAtt("text", "planidStm", a_planidStm);}
      else
        check_stringVal(a_planidStm->get_text());
    }
}

/********************************************************************/

void check_pnLabel(
 pnLabel * a_pnLabel)
{
  if (a_pnLabel->get_labelName())
    {
      if (!findString("a_labelName", pnLabelAtts))
	{warnAtt("a_labelName", "pnLabel", a_pnLabel);}
      else
        check_labelName(a_pnLabel->get_labelName());
    }
}

/********************************************************************/

void check_pointRange(
 pointRange * a_pointRange)
{
  if (a_pointRange->get_index1())
    {
      if (!findString("index1", pointRangeAtts))
	{warnAtt("index1", "pointRange", a_pointRange);}
      else
        check_intVal(a_pointRange->get_index1());
    }
  if (a_pointRange->get_index2())
    {
      if (!findString("index2", pointRangeAtts))
	{warnAtt("index2", "pointRange", a_pointRange);}
      else
        check_intVal(a_pointRange->get_index2());
    }
}

/********************************************************************/

void check_pointVecCart(
 pointVecCart * a_pointVecCart)
{
  if (a_pointVecCart->get_x())
    {
      if (!findString("x", pointVecCartAtts))
	{warnAtt("x", "pointVecCart", a_pointVecCart);}
      else
        check_rentVal(a_pointVecCart->get_x());
    }
  if (a_pointVecCart->get_y())
    {
      if (!findString("y", pointVecCartAtts))
	{warnAtt("y", "pointVecCart", a_pointVecCart);}
      else
        check_rentVal(a_pointVecCart->get_y());
    }
  if (a_pointVecCart->get_z())
    {
      if (!findString("z", pointVecCartAtts))
	{warnAtt("z", "pointVecCart", a_pointVecCart);}
      else
        check_rentVal(a_pointVecCart->get_z());
    }
  if (a_pointVecCart->get_i())
    {
      if (!findString("i", pointVecCartAtts))
	{warnAtt("i", "pointVecCart", a_pointVecCart);}
      else
        check_rentVal(a_pointVecCart->get_i());
    }
  if (a_pointVecCart->get_j())
    {
      if (!findString("j", pointVecCartAtts))
	{warnAtt("j", "pointVecCart", a_pointVecCart);}
      else
        check_rentVal(a_pointVecCart->get_j());
    }
  if (a_pointVecCart->get_k())
    {
      if (!findString("k", pointVecCartAtts))
	{warnAtt("k", "pointVecCart", a_pointVecCart);}
      else
        check_rentVal(a_pointVecCart->get_k());
    }
}

/********************************************************************/

void check_pointVecPol(
 pointVecPol * a_pointVecPol)
{
  if (a_pointVecPol->get_r())
    {
      if (!findString("r", pointVecPolAtts))
	{warnAtt("r", "pointVecPol", a_pointVecPol);}
      else
        check_rentVal(a_pointVecPol->get_r());
    }
  if (a_pointVecPol->get_a())
    {
      if (!findString("a", pointVecPolAtts))
	{warnAtt("a", "pointVecPol", a_pointVecPol);}
      else
        check_rentVal(a_pointVecPol->get_a());
    }
  if (a_pointVecPol->get_h())
    {
      if (!findString("h", pointVecPolAtts))
	{warnAtt("h", "pointVecPol", a_pointVecPol);}
      else
        check_rentVal(a_pointVecPol->get_h());
    }
  if (a_pointVecPol->get_i())
    {
      if (!findString("i", pointVecPolAtts))
	{warnAtt("i", "pointVecPol", a_pointVecPol);}
      else
        check_rentVal(a_pointVecPol->get_i());
    }
  if (a_pointVecPol->get_j())
    {
      if (!findString("j", pointVecPolAtts))
	{warnAtt("j", "pointVecPol", a_pointVecPol);}
      else
        check_rentVal(a_pointVecPol->get_j());
    }
  if (a_pointVecPol->get_k())
    {
      if (!findString("k", pointVecPolAtts))
	{warnAtt("k", "pointVecPol", a_pointVecPol);}
      else
        check_rentVal(a_pointVecPol->get_k());
    }
}

/********************************************************************/

void check_polPoint(
 polPoint * a_polPoint)
{
  if (a_polPoint->get_r())
    {
      if (!findString("r", polPointAtts))
	{warnAtt("r", "polPoint", a_polPoint);}
      else
        check_rentVal(a_polPoint->get_r());
    }
  if (a_polPoint->get_a())
    {
      if (!findString("a", polPointAtts))
	{warnAtt("a", "polPoint", a_polPoint);}
      else
        check_rentVal(a_polPoint->get_a());
    }
  if (a_polPoint->get_h())
    {
      if (!findString("h", polPointAtts))
	{warnAtt("h", "polPoint", a_polPoint);}
      else
        check_rentVal(a_polPoint->get_h());
    }
}

/********************************************************************/

void check_popStm(
 popStm * a_popStm)
{
  if (a_popStm->get_stackElementList())
    {
      if (!findString("a_stackElementList", popStmAtts))
	{warnAtt("a_stackElementList", "popStm", a_popStm);}
      else
        {
          std::list<stackElement *> * theList;
          std::list<stackElement *>::iterator iter;
          theList = a_popStm->get_stackElementList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_stackElement(*iter);
        }
    }
}

/********************************************************************/

void check_posDir(
 posDir * a_posDir)
{
  if (isA(a_posDir, posDir_XDIR))
    {
      if (!findString("posDir_XDIR", posDirSubs))
        {warnSub("posDir_XDIR", "posDir", a_posDir);}
      return;
    }
  if (isA(a_posDir, posDir_YDIR))
    {
      if (!findString("posDir_YDIR", posDirSubs))
        {warnSub("posDir_YDIR", "posDir", a_posDir);}
      return;
    }
  if (isA(a_posDir, posDir_ZDIR))
    {
      if (!findString("posDir_ZDIR", posDirSubs))
        {warnSub("posDir_ZDIR", "posDir", a_posDir);}
      return;
    }
}

/********************************************************************/

void check_prLabel(
 prLabel * a_prLabel)
{
  if (a_prLabel->get_labelName())
    {
      if (!findString("a_labelName", prLabelAtts))
	{warnAtt("a_labelName", "prLabel", a_prLabel);}
      else
        check_labelName(a_prLabel->get_labelName());
    }
}

/********************************************************************/

void check_prcompStm(
 prcompStm * a_prcompStm)
{
  if (a_prcompStm->get_state())
    {
      if (!findString("a_state", prcompStmAtts))
	{warnAtt("a_state", "prcompStm", a_prcompStm);}
      else
        check_state(a_prcompStm->get_state());
    }
}

/********************************************************************/

void check_prevopStm(
 prevopStm * a_prevopStm)
{
  if (a_prevopStm->get_pvLabel())
    {
      if (!findString("a_pvLabel", prevopStmAtts))
	{warnAtt("a_pvLabel", "prevopStm", a_prevopStm);}
      else
        check_pvLabel(a_prevopStm->get_pvLabel());
    }
  if (a_prevopStm->get_text())
    {
      if (!findString("text", prevopStmAtts))
	{warnAtt("text", "prevopStm", a_prevopStm);}
      else
        check_stringVal(a_prevopStm->get_text());
    }
}

/********************************************************************/

void check_probeLocCart(
 probeLocCart * a_probeLocCart)
{
  if (a_probeLocCart->get_distVec())
    {
      if (!findString("distVec", probeLocCartAtts))
	{warnAtt("distVec", "probeLocCart", a_probeLocCart);}
      else
        check_vector(a_probeLocCart->get_distVec());
    }
  if (a_probeLocCart->get_mountAxisVec())
    {
      if (!findString("mountAxisVec", probeLocCartAtts))
	{warnAtt("mountAxisVec", "probeLocCart", a_probeLocCart);}
      else
        check_vector(a_probeLocCart->get_mountAxisVec());
    }
}

/********************************************************************/

void check_probeLocPol(
 probeLocPol * a_probeLocPol)
{
  if (a_probeLocPol->get_tilt())
    {
      if (!findString("tilt", probeLocPolAtts))
	{warnAtt("tilt", "probeLocPol", a_probeLocPol);}
      else
        check_angle(a_probeLocPol->get_tilt());
    }
  if (a_probeLocPol->get_rot())
    {
      if (!findString("rot", probeLocPolAtts))
	{warnAtt("rot", "probeLocPol", a_probeLocPol);}
      else
        check_angle(a_probeLocPol->get_rot());
    }
  if (a_probeLocPol->get_mountAxisVec())
    {
      if (!findString("mountAxisVec", probeLocPolAtts))
	{warnAtt("mountAxisVec", "probeLocPol", a_probeLocPol);}
      else
        check_vector(a_probeLocPol->get_mountAxisVec());
    }
  if (a_probeLocPol->get_len1())
    {
      if (!findString("len1", probeLocPolAtts))
	{warnAtt("len1", "probeLocPol", a_probeLocPol);}
      else
        check_rentVal(a_probeLocPol->get_len1());
    }
}

/********************************************************************/

void check_probeLocSnsCart(
 probeLocSnsCart * a_probeLocSnsCart)
{
  if (a_probeLocSnsCart->get_sensorLabel2())
    {
      if (!findString("a_sensorLabel2", probeLocSnsCartAtts))
	{warnAtt("a_sensorLabel2", "probeLocSnsCart", a_probeLocSnsCart);}
      else
        check_sensorLabel2(a_probeLocSnsCart->get_sensorLabel2());
    }
  if (a_probeLocSnsCart->get_relVec())
    {
      if (!findString("relVec", probeLocSnsCartAtts))
	{warnAtt("relVec", "probeLocSnsCart", a_probeLocSnsCart);}
      else
        check_vector(a_probeLocSnsCart->get_relVec());
    }
}

/********************************************************************/

void check_probeLocSnsVec(
 probeLocSnsVec * a_probeLocSnsVec)
{
  if (a_probeLocSnsVec->get_sensorLabel2())
    {
      if (!findString("a_sensorLabel2", probeLocSnsVecAtts))
	{warnAtt("a_sensorLabel2", "probeLocSnsVec", a_probeLocSnsVec);}
      else
        check_sensorLabel2(a_probeLocSnsVec->get_sensorLabel2());
    }
  if (a_probeLocSnsVec->get_relVec())
    {
      if (!findString("relVec", probeLocSnsVecAtts))
	{warnAtt("relVec", "probeLocSnsVec", a_probeLocSnsVec);}
      else
        check_vector(a_probeLocSnsVec->get_relVec());
    }
  if (a_probeLocSnsVec->get_rlen())
    {
      if (!findString("rlen", probeLocSnsVecAtts))
	{warnAtt("rlen", "probeLocSnsVec", a_probeLocSnsVec);}
      else
        check_rentVal(a_probeLocSnsVec->get_rlen());
    }
}

/********************************************************************/

void check_probeLocVec(
 probeLocVec * a_probeLocVec)
{
  if (a_probeLocVec->get_tipVec())
    {
      if (!findString("tipVec", probeLocVecAtts))
	{warnAtt("tipVec", "probeLocVec", a_probeLocVec);}
      else
        check_vector(a_probeLocVec->get_tipVec());
    }
  if (a_probeLocVec->get_mountAxisVec())
    {
      if (!findString("mountAxisVec", probeLocVecAtts))
	{warnAtt("mountAxisVec", "probeLocVec", a_probeLocVec);}
      else
        check_vector(a_probeLocVec->get_mountAxisVec());
    }
  if (a_probeLocVec->get_len1())
    {
      if (!findString("len1", probeLocVecAtts))
	{warnAtt("len1", "probeLocVec", a_probeLocVec);}
      else
        check_rentVal(a_probeLocVec->get_len1());
    }
}

/********************************************************************/

void check_probeLocation(
 probeLocation * a_probeLocation)
{
  if (isA(a_probeLocation, probeLocCart))
    {
      if (!findString("probeLocCart", probeLocationSubs))
        {warnSub("probeLocCart", "probeLocation", a_probeLocation);}
      else
        check_probeLocCart(dynamic_cast<probeLocCart *>(a_probeLocation));
      return;
    }
  if (isA(a_probeLocation, probeLocPol))
    {
      if (!findString("probeLocPol", probeLocationSubs))
        {warnSub("probeLocPol", "probeLocation", a_probeLocation);}
      else
        check_probeLocPol(dynamic_cast<probeLocPol *>(a_probeLocation));
      return;
    }
  if (isA(a_probeLocation, probeLocVec))
    {
      if (!findString("probeLocVec", probeLocationSubs))
        {warnSub("probeLocVec", "probeLocation", a_probeLocation);}
      else
        check_probeLocVec(dynamic_cast<probeLocVec *>(a_probeLocation));
      return;
    }
  if (isA(a_probeLocation, probeLocSnsCart))
    {
      if (!findString("probeLocSnsCart", probeLocationSubs))
        {warnSub("probeLocSnsCart", "probeLocation", a_probeLocation);}
      else
        check_probeLocSnsCart(dynamic_cast<probeLocSnsCart *>(a_probeLocation));
      return;
    }
  if (isA(a_probeLocation, probeLocSnsVec))
    {
      if (!findString("probeLocSnsVec", probeLocationSubs))
        {warnSub("probeLocSnsVec", "probeLocation", a_probeLocation);}
      else
        check_probeLocSnsVec(dynamic_cast<probeLocSnsVec *>(a_probeLocation));
      return;
    }
}

/********************************************************************/

void check_probeOrient(
 probeOrient * a_probeOrient)
{
  if (isA(a_probeOrient, probeOrient_featureLabel))
    {
      if (!findString("probeOrient_featureLabel", probeOrientSubs))
        {warnSub("probeOrient_featureLabel", "probeOrient", a_probeOrient);}
      else
        check_probeOrient_featureLabel(dynamic_cast<probeOrient_featureLabel *>(a_probeOrient));
      return;
    }
  if (isA(a_probeOrient, probeOrient_VEC))
    {
      if (!findString("probeOrient_VEC", probeOrientSubs))
        {warnSub("probeOrient_VEC", "probeOrient", a_probeOrient);}
      else
        check_probeOrient_VEC(dynamic_cast<probeOrient_VEC *>(a_probeOrient));
      return;
    }
  if (isA(a_probeOrient, probeOrient_PCS))
    {
      if (!findString("probeOrient_PCS", probeOrientSubs))
        {warnSub("probeOrient_PCS", "probeOrient", a_probeOrient);}
      else
        check_probeOrient_PCS(dynamic_cast<probeOrient_PCS *>(a_probeOrient));
      return;
    }
  if (isA(a_probeOrient, probeOrient_HEADCS))
    {
      if (!findString("probeOrient_HEADCS", probeOrientSubs))
        {warnSub("probeOrient_HEADCS", "probeOrient", a_probeOrient);}
      else
        check_probeOrient_HEADCS(dynamic_cast<probeOrient_HEADCS *>(a_probeOrient));
      return;
    }
}

/********************************************************************/

void check_probeOrient_HEADCS(
 probeOrient_HEADCS * a_probeOrient_HEADCS)
{
  if (a_probeOrient_HEADCS->get_rot1())
    {
      if (!findString("rot1", probeOrient_HEADCSAtts))
	{warnAtt("rot1", "probeOrient_HEADCS", a_probeOrient_HEADCS);}
      else
        check_rentVal(a_probeOrient_HEADCS->get_rot1());
    }
  if (a_probeOrient_HEADCS->get_rot2())
    {
      if (!findString("rot2", probeOrient_HEADCSAtts))
	{warnAtt("rot2", "probeOrient_HEADCS", a_probeOrient_HEADCS);}
      else
        check_rentVal(a_probeOrient_HEADCS->get_rot2());
    }
  if (a_probeOrient_HEADCS->get_rot3())
    {
      if (!findString("rot3", probeOrient_HEADCSAtts))
	{warnAtt("rot3", "probeOrient_HEADCS", a_probeOrient_HEADCS);}
      else
        check_rentVal(a_probeOrient_HEADCS->get_rot3());
    }
}

/********************************************************************/

void check_probeOrient_PCS(
 probeOrient_PCS * a_probeOrient_PCS)
{
  if (a_probeOrient_PCS->get_euler())
    {
      if (!findString("a_euler", probeOrient_PCSAtts))
	{warnAtt("a_euler", "probeOrient_PCS", a_probeOrient_PCS);}
      else
        check_euler(a_probeOrient_PCS->get_euler());
    }
}

/********************************************************************/

void check_probeOrient_VEC(
 probeOrient_VEC * a_probeOrient_VEC)
{
  if (a_probeOrient_VEC->get_dir())
    {
      if (!findString("dir", probeOrient_VECAtts))
	{warnAtt("dir", "probeOrient_VEC", a_probeOrient_VEC);}
      else
        check_vector(a_probeOrient_VEC->get_dir());
    }
  if (a_probeOrient_VEC->get_angle())
    {
      if (!findString("a_angle", probeOrient_VECAtts))
	{warnAtt("a_angle", "probeOrient_VEC", a_probeOrient_VEC);}
      else
        check_angle(a_probeOrient_VEC->get_angle());
    }
}

/********************************************************************/

void check_probeOrient_featureLabel(
 probeOrient_featureLabel * a_probeOrient_featureLabel)
{
  if (a_probeOrient_featureLabel->get_featureLabel())
    {
      if (!findString("a_featureLabel", probeOrient_featureLabelAtts))
	{warnAtt("a_featureLabel", "probeOrient_featureLabel", a_probeOrient_featureLabel);}
      else
        check_featureLabel(a_probeOrient_featureLabel->get_featureLabel());
    }
  if (a_probeOrient_featureLabel->get_angle())
    {
      if (!findString("a_angle", probeOrient_featureLabelAtts))
	{warnAtt("a_angle", "probeOrient_featureLabel", a_probeOrient_featureLabel);}
      else
        check_angle(a_probeOrient_featureLabel->get_angle());
    }
}

/********************************************************************/

void check_procidStm(
 procidStm * a_procidStm)
{
  if (a_procidStm->get_pcLabel())
    {
      if (!findString("a_pcLabel", procidStmAtts))
	{warnAtt("a_pcLabel", "procidStm", a_procidStm);}
      else
        check_pcLabel(a_procidStm->get_pcLabel());
    }
  if (a_procidStm->get_text())
    {
      if (!findString("text", procidStmAtts))
	{warnAtt("text", "procidStm", a_procidStm);}
      else
        check_stringVal(a_procidStm->get_text());
    }
}

/********************************************************************/

void check_projctConst(
 projctConst * a_projctConst)
{
  if (a_projctConst->get_faLabel())
    {
      if (!findString("a_faLabel", projctConstAtts))
	{warnAtt("a_faLabel", "projctConst", a_projctConst);}
      else
        check_faLabel(a_projctConst->get_faLabel());
    }
  if (a_projctConst->get_featureLabel())
    {
      if (!findString("a_featureLabel", projctConstAtts))
	{warnAtt("a_featureLabel", "projctConst", a_projctConst);}
      else
        check_featureLabel(a_projctConst->get_featureLabel());
    }
}

/********************************************************************/

void check_projliConst(
 projliConst * a_projliConst)
{
  if (a_projliConst->get_faLabel())
    {
      if (!findString("a_faLabel", projliConstAtts))
	{warnAtt("a_faLabel", "projliConst", a_projliConst);}
      else
        check_faLabel(a_projliConst->get_faLabel());
    }
  if (a_projliConst->get_featureLabel())
    {
      if (!findString("a_featureLabel", projliConstAtts))
	{warnAtt("a_featureLabel", "projliConst", a_projliConst);}
      else
        check_featureLabel(a_projliConst->get_featureLabel());
    }
}

/********************************************************************/

void check_projptConst(
 projptConst * a_projptConst)
{
  if (a_projptConst->get_faLabel())
    {
      if (!findString("a_faLabel", projptConstAtts))
	{warnAtt("a_faLabel", "projptConst", a_projptConst);}
      else
        check_faLabel(a_projptConst->get_faLabel());
    }
  if (a_projptConst->get_featureLabel())
    {
      if (!findString("a_featureLabel", projptConstAtts))
	{warnAtt("a_featureLabel", "projptConst", a_projptConst);}
      else
        check_featureLabel(a_projptConst->get_featureLabel());
    }
}

/********************************************************************/

void check_promptIntEnd(
 promptIntEnd * a_promptIntEnd)
{
  if (isA(a_promptIntEnd, promptIntEnd_stringVal))
    {
      if (!findString("promptIntEnd_stringVal", promptIntEndSubs))
        {warnSub("promptIntEnd_stringVal", "promptIntEnd", a_promptIntEnd);}
      else
        check_promptIntEnd_stringVal(dynamic_cast<promptIntEnd_stringVal *>(a_promptIntEnd));
      return;
    }
  if (isA(a_promptIntEnd, promptIntEnd_promptItemList))
    {
      if (!findString("promptIntEnd_promptItemList", promptIntEndSubs))
        {warnSub("promptIntEnd_promptItemList", "promptIntEnd", a_promptIntEnd);}
      else
        check_promptIntEnd_promptItemList(dynamic_cast<promptIntEnd_promptItemList *>(a_promptIntEnd));
      return;
    }
}

/********************************************************************/

void check_promptIntEnd_promptItemList(
 promptIntEnd_promptItemList * a_promptIntEnd_promptItemList)
{
  if (a_promptIntEnd_promptItemList->get_promptItemList())
    {
      if (!findString("a_promptItemList", promptIntEnd_promptItemListAtts))
	{warnAtt("a_promptItemList", "promptIntEnd_promptItemList", a_promptIntEnd_promptItemList);}
      else
        {
          std::list<promptItem *> * theList;
          std::list<promptItem *>::iterator iter;
          theList = a_promptIntEnd_promptItemList->get_promptItemList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_promptItem(*iter);
        }
    }
}

/********************************************************************/

void check_promptIntEnd_stringVal(
 promptIntEnd_stringVal * a_promptIntEnd_stringVal)
{
  if (a_promptIntEnd_stringVal->get_text())
    {
      if (!findString("text", promptIntEnd_stringValAtts))
	{warnAtt("text", "promptIntEnd_stringVal", a_promptIntEnd_stringVal);}
      else
        check_stringVal(a_promptIntEnd_stringVal->get_text());
    }
  if (a_promptIntEnd_stringVal->get_maxval())
    {
      if (!findString("maxval", promptIntEnd_stringValAtts))
	{warnAtt("maxval", "promptIntEnd_stringVal", a_promptIntEnd_stringVal);}
      else
        check_intVal(a_promptIntEnd_stringVal->get_maxval());
    }
  if (a_promptIntEnd_stringVal->get_minval())
    {
      if (!findString("minval", promptIntEnd_stringValAtts))
	{warnAtt("minval", "promptIntEnd_stringVal", a_promptIntEnd_stringVal);}
      else
        check_intVal(a_promptIntEnd_stringVal->get_minval());
    }
}

/********************************************************************/

void check_promptItem(
 promptItem * a_promptItem)
{
  if (isA(a_promptItem, promptItem_BUTTON))
    {
      if (!findString("promptItem_BUTTON", promptItemSubs))
        {warnSub("promptItem_BUTTON", "promptItem", a_promptItem);}
      else
        check_promptItem_BUTTON(dynamic_cast<promptItem_BUTTON *>(a_promptItem));
      return;
    }
  if (isA(a_promptItem, promptItem_CHECK))
    {
      if (!findString("promptItem_CHECK", promptItemSubs))
        {warnSub("promptItem_CHECK", "promptItem", a_promptItem);}
      else
        check_promptItem_CHECK(dynamic_cast<promptItem_CHECK *>(a_promptItem));
      return;
    }
  if (isA(a_promptItem, promptItem_EDIT))
    {
      if (!findString("promptItem_EDIT", promptItemSubs))
        {warnSub("promptItem_EDIT", "promptItem", a_promptItem);}
      else
        check_promptItem_EDIT(dynamic_cast<promptItem_EDIT *>(a_promptItem));
      return;
    }
  if (isA(a_promptItem, promptItem_GROUP))
    {
      if (!findString("promptItem_GROUP", promptItemSubs))
        {warnSub("promptItem_GROUP", "promptItem", a_promptItem);}
      else
        check_promptItem_GROUP(dynamic_cast<promptItem_GROUP *>(a_promptItem));
      return;
    }
  if (isA(a_promptItem, promptItem_LIST))
    {
      if (!findString("promptItem_LIST", promptItemSubs))
        {warnSub("promptItem_LIST", "promptItem", a_promptItem);}
      else
        check_promptItem_LIST(dynamic_cast<promptItem_LIST *>(a_promptItem));
      return;
    }
  if (isA(a_promptItem, promptItem_PICTURE))
    {
      if (!findString("promptItem_PICTURE", promptItemSubs))
        {warnSub("promptItem_PICTURE", "promptItem", a_promptItem);}
      else
        check_promptItem_PICTURE(dynamic_cast<promptItem_PICTURE *>(a_promptItem));
      return;
    }
  if (isA(a_promptItem, promptItem_PIXBTN))
    {
      if (!findString("promptItem_PIXBTN", promptItemSubs))
        {warnSub("promptItem_PIXBTN", "promptItem", a_promptItem);}
      else
        check_promptItem_PIXBTN(dynamic_cast<promptItem_PIXBTN *>(a_promptItem));
      return;
    }
  if (isA(a_promptItem, promptItem_SOUND))
    {
      if (!findString("promptItem_SOUND", promptItemSubs))
        {warnSub("promptItem_SOUND", "promptItem", a_promptItem);}
      else
        check_promptItem_SOUND(dynamic_cast<promptItem_SOUND *>(a_promptItem));
      return;
    }
  if (isA(a_promptItem, promptItem_TEXT))
    {
      if (!findString("promptItem_TEXT", promptItemSubs))
        {warnSub("promptItem_TEXT", "promptItem", a_promptItem);}
      else
        check_promptItem_TEXT(dynamic_cast<promptItem_TEXT *>(a_promptItem));
      return;
    }
  if (isA(a_promptItem, promptItem_TITLE))
    {
      if (!findString("promptItem_TITLE", promptItemSubs))
        {warnSub("promptItem_TITLE", "promptItem", a_promptItem);}
      else
        check_promptItem_TITLE(dynamic_cast<promptItem_TITLE *>(a_promptItem));
      return;
    }
}

/********************************************************************/

void check_promptItem_BUTTON(
 promptItem_BUTTON * a_promptItem_BUTTON)
{
  if (a_promptItem_BUTTON->get_text())
    {
      if (!findString("text", promptItem_BUTTONAtts))
	{warnAtt("text", "promptItem_BUTTON", a_promptItem_BUTTON);}
      else
        check_stringVal(a_promptItem_BUTTON->get_text());
    }
  if (a_promptItem_BUTTON->get_retVal())
    {
      if (!findString("retVal", promptItem_BUTTONAtts))
	{warnAtt("retVal", "promptItem_BUTTON", a_promptItem_BUTTON);}
      else
        check_intVal(a_promptItem_BUTTON->get_retVal());
    }
}

/********************************************************************/

void check_promptItem_CHECK(
 promptItem_CHECK * a_promptItem_CHECK)
{
  if (a_promptItem_CHECK->get_text())
    {
      if (!findString("text", promptItem_CHECKAtts))
	{warnAtt("text", "promptItem_CHECK", a_promptItem_CHECK);}
      else
        check_stringVal(a_promptItem_CHECK->get_text());
    }
  if (a_promptItem_CHECK->get_boolVar())
    {
      if (!findString("a_boolVar", promptItem_CHECKAtts))
	{warnAtt("a_boolVar", "promptItem_CHECK", a_promptItem_CHECK);}
      else
        check_boolVar(a_promptItem_CHECK->get_boolVar());
    }
}

/********************************************************************/

void check_promptItem_EDIT(
 promptItem_EDIT * a_promptItem_EDIT)
{
  if (a_promptItem_EDIT->get_promptVar())
    {
      if (!findString("a_promptVar", promptItem_EDITAtts))
	{warnAtt("a_promptVar", "promptItem_EDIT", a_promptItem_EDIT);}
      else
        check_promptVar(a_promptItem_EDIT->get_promptVar());
    }
  if (a_promptItem_EDIT->get_maxval())
    {
      if (!findString("maxval", promptItem_EDITAtts))
	{warnAtt("maxval", "promptItem_EDIT", a_promptItem_EDIT);}
      else
        check_rentVal(a_promptItem_EDIT->get_maxval());
    }
  if (a_promptItem_EDIT->get_minval())
    {
      if (!findString("minval", promptItem_EDITAtts))
	{warnAtt("minval", "promptItem_EDIT", a_promptItem_EDIT);}
      else
        check_rentVal(a_promptItem_EDIT->get_minval());
    }
}

/********************************************************************/

void check_promptItem_GROUP(
 promptItem_GROUP * a_promptItem_GROUP)
{
  if (a_promptItem_GROUP->get_text())
    {
      if (!findString("text", promptItem_GROUPAtts))
	{warnAtt("text", "promptItem_GROUP", a_promptItem_GROUP);}
      else
        check_stringVal(a_promptItem_GROUP->get_text());
    }
  if (a_promptItem_GROUP->get_promptVar())
    {
      if (!findString("a_promptVar", promptItem_GROUPAtts))
	{warnAtt("a_promptVar", "promptItem_GROUP", a_promptItem_GROUP);}
      else
        check_promptVar(a_promptItem_GROUP->get_promptVar());
    }
  if (a_promptItem_GROUP->get_item1())
    {
      if (!findString("item1", promptItem_GROUPAtts))
	{warnAtt("item1", "promptItem_GROUP", a_promptItem_GROUP);}
      else
        check_stringVal(a_promptItem_GROUP->get_item1());
    }
  if (a_promptItem_GROUP->get_moreItems())
    {
      if (!findString("moreItems", promptItem_GROUPAtts))
	{warnAtt("moreItems", "promptItem_GROUP", a_promptItem_GROUP);}
      else
        {
          std::list<stringVal *> * theList;
          std::list<stringVal *>::iterator iter;
          theList = a_promptItem_GROUP->get_moreItems();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_stringVal(*iter);
        }
    }
}

/********************************************************************/

void check_promptItem_LIST(
 promptItem_LIST * a_promptItem_LIST)
{
  if (a_promptItem_LIST->get_promptVar())
    {
      if (!findString("a_promptVar", promptItem_LISTAtts))
	{warnAtt("a_promptVar", "promptItem_LIST", a_promptItem_LIST);}
      else
        check_promptVar(a_promptItem_LIST->get_promptVar());
    }
  if (a_promptItem_LIST->get_item1())
    {
      if (!findString("item1", promptItem_LISTAtts))
	{warnAtt("item1", "promptItem_LIST", a_promptItem_LIST);}
      else
        check_stringVal(a_promptItem_LIST->get_item1());
    }
  if (a_promptItem_LIST->get_moreItems())
    {
      if (!findString("moreItems", promptItem_LISTAtts))
	{warnAtt("moreItems", "promptItem_LIST", a_promptItem_LIST);}
      else
        {
          std::list<stringVal *> * theList;
          std::list<stringVal *>::iterator iter;
          theList = a_promptItem_LIST->get_moreItems();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_stringVal(*iter);
        }
    }
}

/********************************************************************/

void check_promptItem_PICTURE(
 promptItem_PICTURE * a_promptItem_PICTURE)
{
  if (a_promptItem_PICTURE->get_filename())
    {
      if (!findString("filename", promptItem_PICTUREAtts))
	{warnAtt("filename", "promptItem_PICTURE", a_promptItem_PICTURE);}
      else
        check_stringVal(a_promptItem_PICTURE->get_filename());
    }
  if (a_promptItem_PICTURE->get_index())
    {
      if (!findString("index", promptItem_PICTUREAtts))
	{warnAtt("index", "promptItem_PICTURE", a_promptItem_PICTURE);}
      else
        check_intVal(a_promptItem_PICTURE->get_index());
    }
}

/********************************************************************/

void check_promptItem_PIXBTN(
 promptItem_PIXBTN * a_promptItem_PIXBTN)
{
  if (a_promptItem_PIXBTN->get_filnam1())
    {
      if (!findString("filnam1", promptItem_PIXBTNAtts))
	{warnAtt("filnam1", "promptItem_PIXBTN", a_promptItem_PIXBTN);}
      else
        check_stringVal(a_promptItem_PIXBTN->get_filnam1());
    }
  if (a_promptItem_PIXBTN->get_filnam2())
    {
      if (!findString("filnam2", promptItem_PIXBTNAtts))
	{warnAtt("filnam2", "promptItem_PIXBTN", a_promptItem_PIXBTN);}
      else
        check_stringVal(a_promptItem_PIXBTN->get_filnam2());
    }
  if (a_promptItem_PIXBTN->get_retVal())
    {
      if (!findString("retVal", promptItem_PIXBTNAtts))
	{warnAtt("retVal", "promptItem_PIXBTN", a_promptItem_PIXBTN);}
      else
        check_intVal(a_promptItem_PIXBTN->get_retVal());
    }
}

/********************************************************************/

void check_promptItem_SOUND(
 promptItem_SOUND * a_promptItem_SOUND)
{
  if (a_promptItem_SOUND->get_filename())
    {
      if (!findString("filename", promptItem_SOUNDAtts))
	{warnAtt("filename", "promptItem_SOUND", a_promptItem_SOUND);}
      else
        check_stringVal(a_promptItem_SOUND->get_filename());
    }
}

/********************************************************************/

void check_promptItem_TEXT(
 promptItem_TEXT * a_promptItem_TEXT)
{
  if (a_promptItem_TEXT->get_text())
    {
      if (!findString("text", promptItem_TEXTAtts))
	{warnAtt("text", "promptItem_TEXT", a_promptItem_TEXT);}
      else
        check_stringVal(a_promptItem_TEXT->get_text());
    }
}

/********************************************************************/

void check_promptItem_TITLE(
 promptItem_TITLE * a_promptItem_TITLE)
{
  if (a_promptItem_TITLE->get_text())
    {
      if (!findString("text", promptItem_TITLEAtts))
	{warnAtt("text", "promptItem_TITLE", a_promptItem_TITLE);}
      else
        check_stringVal(a_promptItem_TITLE->get_text());
    }
}

/********************************************************************/

void check_promptStm(
 promptStm * a_promptStm)
{
  if (isA(a_promptStm, promptStm_boolVar))
    {
      if (!findString("promptStm_boolVar", promptStmSubs))
        {warnSub("promptStm_boolVar", "promptStm", a_promptStm);}
      else
        check_promptStm_boolVar(dynamic_cast<promptStm_boolVar *>(a_promptStm));
      return;
    }
  if (isA(a_promptStm, promptStm_stringVar))
    {
      if (!findString("promptStm_stringVar", promptStmSubs))
        {warnSub("promptStm_stringVar", "promptStm", a_promptStm);}
      else
        check_promptStm_stringVar(dynamic_cast<promptStm_stringVar *>(a_promptStm));
      return;
    }
  if (isA(a_promptStm, promptStm_intVar))
    {
      if (!findString("promptStm_intVar", promptStmSubs))
        {warnSub("promptStm_intVar", "promptStm", a_promptStm);}
      else
        check_promptStm_intVar(dynamic_cast<promptStm_intVar *>(a_promptStm));
      return;
    }
  if (isA(a_promptStm, promptStm_realVar))
    {
      if (!findString("promptStm_realVar", promptStmSubs))
        {warnSub("promptStm_realVar", "promptStm", a_promptStm);}
      else
        check_promptStm_realVar(dynamic_cast<promptStm_realVar *>(a_promptStm));
      return;
    }
  if (isA(a_promptStm, promptStm_ccLabel))
    {
      if (!findString("promptStm_ccLabel", promptStmSubs))
        {warnSub("promptStm_ccLabel", "promptStm", a_promptStm);}
      else
        check_promptStm_ccLabel(dynamic_cast<promptStm_ccLabel *>(a_promptStm));
      return;
    }
  if (isA(a_promptStm, promptStm_ciLabel))
    {
      if (!findString("promptStm_ciLabel", promptStmSubs))
        {warnSub("promptStm_ciLabel", "promptStm", a_promptStm);}
      else
        check_promptStm_ciLabel(dynamic_cast<promptStm_ciLabel *>(a_promptStm));
      return;
    }
  if (isA(a_promptStm, promptStm_csLabel))
    {
      if (!findString("promptStm_csLabel", promptStmSubs))
        {warnSub("promptStm_csLabel", "promptStm", a_promptStm);}
      else
        check_promptStm_csLabel(dynamic_cast<promptStm_csLabel *>(a_promptStm));
      return;
    }
  if (isA(a_promptStm, promptStm_diLabel))
    {
      if (!findString("promptStm_diLabel", promptStmSubs))
        {warnSub("promptStm_diLabel", "promptStm", a_promptStm);}
      else
        check_promptStm_diLabel(dynamic_cast<promptStm_diLabel *>(a_promptStm));
      return;
    }
  if (isA(a_promptStm, promptStm_dsLabel))
    {
      if (!findString("promptStm_dsLabel", promptStmSubs))
        {warnSub("promptStm_dsLabel", "promptStm", a_promptStm);}
      else
        check_promptStm_dsLabel(dynamic_cast<promptStm_dsLabel *>(a_promptStm));
      return;
    }
  if (isA(a_promptStm, promptStm_dvLabel))
    {
      if (!findString("promptStm_dvLabel", promptStmSubs))
        {warnSub("promptStm_dvLabel", "promptStm", a_promptStm);}
      else
        check_promptStm_dvLabel(dynamic_cast<promptStm_dvLabel *>(a_promptStm));
      return;
    }
  if (isA(a_promptStm, promptStm_fiLabel))
    {
      if (!findString("promptStm_fiLabel", promptStmSubs))
        {warnSub("promptStm_fiLabel", "promptStm", a_promptStm);}
      else
        check_promptStm_fiLabel(dynamic_cast<promptStm_fiLabel *>(a_promptStm));
      return;
    }
  if (isA(a_promptStm, promptStm_fsLabel))
    {
      if (!findString("promptStm_fsLabel", promptStmSubs))
        {warnSub("promptStm_fsLabel", "promptStm", a_promptStm);}
      else
        check_promptStm_fsLabel(dynamic_cast<promptStm_fsLabel *>(a_promptStm));
      return;
    }
  if (isA(a_promptStm, promptStm_liLabel))
    {
      if (!findString("promptStm_liLabel", promptStmSubs))
        {warnSub("promptStm_liLabel", "promptStm", a_promptStm);}
      else
        check_promptStm_liLabel(dynamic_cast<promptStm_liLabel *>(a_promptStm));
      return;
    }
  if (isA(a_promptStm, promptStm_mdLabel))
    {
      if (!findString("promptStm_mdLabel", promptStmSubs))
        {warnSub("promptStm_mdLabel", "promptStm", a_promptStm);}
      else
        check_promptStm_mdLabel(dynamic_cast<promptStm_mdLabel *>(a_promptStm));
      return;
    }
  if (isA(a_promptStm, promptStm_opLabel))
    {
      if (!findString("promptStm_opLabel", promptStmSubs))
        {warnSub("promptStm_opLabel", "promptStm", a_promptStm);}
      else
        check_promptStm_opLabel(dynamic_cast<promptStm_opLabel *>(a_promptStm));
      return;
    }
  if (isA(a_promptStm, promptStm_pcLabel))
    {
      if (!findString("promptStm_pcLabel", promptStmSubs))
        {warnSub("promptStm_pcLabel", "promptStm", a_promptStm);}
      else
        check_promptStm_pcLabel(dynamic_cast<promptStm_pcLabel *>(a_promptStm));
      return;
    }
  if (isA(a_promptStm, promptStm_plLabel))
    {
      if (!findString("promptStm_plLabel", promptStmSubs))
        {warnSub("promptStm_plLabel", "promptStm", a_promptStm);}
      else
        check_promptStm_plLabel(dynamic_cast<promptStm_plLabel *>(a_promptStm));
      return;
    }
  if (isA(a_promptStm, promptStm_pnLabel))
    {
      if (!findString("promptStm_pnLabel", promptStmSubs))
        {warnSub("promptStm_pnLabel", "promptStm", a_promptStm);}
      else
        check_promptStm_pnLabel(dynamic_cast<promptStm_pnLabel *>(a_promptStm));
      return;
    }
  if (isA(a_promptStm, promptStm_prLabel))
    {
      if (!findString("promptStm_prLabel", promptStmSubs))
        {warnSub("promptStm_prLabel", "promptStm", a_promptStm);}
      else
        check_promptStm_prLabel(dynamic_cast<promptStm_prLabel *>(a_promptStm));
      return;
    }
  if (isA(a_promptStm, promptStm_psLabel))
    {
      if (!findString("promptStm_psLabel", promptStmSubs))
        {warnSub("promptStm_psLabel", "promptStm", a_promptStm);}
      else
        check_promptStm_psLabel(dynamic_cast<promptStm_psLabel *>(a_promptStm));
      return;
    }
  if (isA(a_promptStm, promptStm_pvLabel))
    {
      if (!findString("promptStm_pvLabel", promptStmSubs))
        {warnSub("promptStm_pvLabel", "promptStm", a_promptStm);}
      else
        check_promptStm_pvLabel(dynamic_cast<promptStm_pvLabel *>(a_promptStm));
      return;
    }
  if (isA(a_promptStm, promptStm_qLabel))
    {
      if (!findString("promptStm_qLabel", promptStmSubs))
        {warnSub("promptStm_qLabel", "promptStm", a_promptStm);}
      else
        check_promptStm_qLabel(dynamic_cast<promptStm_qLabel *>(a_promptStm));
      return;
    }
  if (isA(a_promptStm, promptStm_tlLabel))
    {
      if (!findString("promptStm_tlLabel", promptStmSubs))
        {warnSub("promptStm_tlLabel", "promptStm", a_promptStm);}
      else
        check_promptStm_tlLabel(dynamic_cast<promptStm_tlLabel *>(a_promptStm));
      return;
    }
}

/********************************************************************/

void check_promptStm_boolVar(
 promptStm_boolVar * a_promptStm_boolVar)
{
  if (a_promptStm_boolVar->get_boolVar())
    {
      if (!findString("a_boolVar", promptStm_boolVarAtts))
	{warnAtt("a_boolVar", "promptStm_boolVar", a_promptStm_boolVar);}
      else
        check_boolVar(a_promptStm_boolVar->get_boolVar());
    }
  if (a_promptStm_boolVar->get_text())
    {
      if (!findString("text", promptStm_boolVarAtts))
	{warnAtt("text", "promptStm_boolVar", a_promptStm_boolVar);}
      else
        check_stringVal(a_promptStm_boolVar->get_text());
    }
}

/********************************************************************/

void check_promptStm_ccLabel(
 promptStm_ccLabel * a_promptStm_ccLabel)
{
  if (a_promptStm_ccLabel->get_ccLabel())
    {
      if (!findString("a_ccLabel", promptStm_ccLabelAtts))
	{warnAtt("a_ccLabel", "promptStm_ccLabel", a_promptStm_ccLabel);}
      else
        check_ccLabel(a_promptStm_ccLabel->get_ccLabel());
    }
  if (a_promptStm_ccLabel->get_text())
    {
      if (!findString("text", promptStm_ccLabelAtts))
	{warnAtt("text", "promptStm_ccLabel", a_promptStm_ccLabel);}
      else
        check_stringVal(a_promptStm_ccLabel->get_text());
    }
  if (a_promptStm_ccLabel->get_maxSize())
    {
      if (!findString("maxSize", promptStm_ccLabelAtts))
	{warnAtt("maxSize", "promptStm_ccLabel", a_promptStm_ccLabel);}
      else
        check_intVal(a_promptStm_ccLabel->get_maxSize());
    }
}

/********************************************************************/

void check_promptStm_ciLabel(
 promptStm_ciLabel * a_promptStm_ciLabel)
{
  if (a_promptStm_ciLabel->get_ciLabel())
    {
      if (!findString("a_ciLabel", promptStm_ciLabelAtts))
	{warnAtt("a_ciLabel", "promptStm_ciLabel", a_promptStm_ciLabel);}
      else
        check_ciLabel(a_promptStm_ciLabel->get_ciLabel());
    }
  if (a_promptStm_ciLabel->get_text())
    {
      if (!findString("text", promptStm_ciLabelAtts))
	{warnAtt("text", "promptStm_ciLabel", a_promptStm_ciLabel);}
      else
        check_stringVal(a_promptStm_ciLabel->get_text());
    }
  if (a_promptStm_ciLabel->get_maxSize())
    {
      if (!findString("maxSize", promptStm_ciLabelAtts))
	{warnAtt("maxSize", "promptStm_ciLabel", a_promptStm_ciLabel);}
      else
        check_intVal(a_promptStm_ciLabel->get_maxSize());
    }
}

/********************************************************************/

void check_promptStm_csLabel(
 promptStm_csLabel * a_promptStm_csLabel)
{
  if (a_promptStm_csLabel->get_csLabel())
    {
      if (!findString("a_csLabel", promptStm_csLabelAtts))
	{warnAtt("a_csLabel", "promptStm_csLabel", a_promptStm_csLabel);}
      else
        check_csLabel(a_promptStm_csLabel->get_csLabel());
    }
  if (a_promptStm_csLabel->get_text())
    {
      if (!findString("text", promptStm_csLabelAtts))
	{warnAtt("text", "promptStm_csLabel", a_promptStm_csLabel);}
      else
        check_stringVal(a_promptStm_csLabel->get_text());
    }
  if (a_promptStm_csLabel->get_maxSize())
    {
      if (!findString("maxSize", promptStm_csLabelAtts))
	{warnAtt("maxSize", "promptStm_csLabel", a_promptStm_csLabel);}
      else
        check_intVal(a_promptStm_csLabel->get_maxSize());
    }
}

/********************************************************************/

void check_promptStm_diLabel(
 promptStm_diLabel * a_promptStm_diLabel)
{
  if (a_promptStm_diLabel->get_diLabel())
    {
      if (!findString("a_diLabel", promptStm_diLabelAtts))
	{warnAtt("a_diLabel", "promptStm_diLabel", a_promptStm_diLabel);}
      else
        check_diLabel(a_promptStm_diLabel->get_diLabel());
    }
  if (a_promptStm_diLabel->get_text())
    {
      if (!findString("text", promptStm_diLabelAtts))
	{warnAtt("text", "promptStm_diLabel", a_promptStm_diLabel);}
      else
        check_stringVal(a_promptStm_diLabel->get_text());
    }
  if (a_promptStm_diLabel->get_maxSize())
    {
      if (!findString("maxSize", promptStm_diLabelAtts))
	{warnAtt("maxSize", "promptStm_diLabel", a_promptStm_diLabel);}
      else
        check_intVal(a_promptStm_diLabel->get_maxSize());
    }
}

/********************************************************************/

void check_promptStm_dsLabel(
 promptStm_dsLabel * a_promptStm_dsLabel)
{
  if (a_promptStm_dsLabel->get_dsLabel())
    {
      if (!findString("a_dsLabel", promptStm_dsLabelAtts))
	{warnAtt("a_dsLabel", "promptStm_dsLabel", a_promptStm_dsLabel);}
      else
        check_dsLabel(a_promptStm_dsLabel->get_dsLabel());
    }
  if (a_promptStm_dsLabel->get_text())
    {
      if (!findString("text", promptStm_dsLabelAtts))
	{warnAtt("text", "promptStm_dsLabel", a_promptStm_dsLabel);}
      else
        check_stringVal(a_promptStm_dsLabel->get_text());
    }
  if (a_promptStm_dsLabel->get_maxSize())
    {
      if (!findString("maxSize", promptStm_dsLabelAtts))
	{warnAtt("maxSize", "promptStm_dsLabel", a_promptStm_dsLabel);}
      else
        check_intVal(a_promptStm_dsLabel->get_maxSize());
    }
}

/********************************************************************/

void check_promptStm_dvLabel(
 promptStm_dvLabel * a_promptStm_dvLabel)
{
  if (a_promptStm_dvLabel->get_dvLabel())
    {
      if (!findString("a_dvLabel", promptStm_dvLabelAtts))
	{warnAtt("a_dvLabel", "promptStm_dvLabel", a_promptStm_dvLabel);}
      else
        check_dvLabel(a_promptStm_dvLabel->get_dvLabel());
    }
  if (a_promptStm_dvLabel->get_text())
    {
      if (!findString("text", promptStm_dvLabelAtts))
	{warnAtt("text", "promptStm_dvLabel", a_promptStm_dvLabel);}
      else
        check_stringVal(a_promptStm_dvLabel->get_text());
    }
  if (a_promptStm_dvLabel->get_maxSize())
    {
      if (!findString("maxSize", promptStm_dvLabelAtts))
	{warnAtt("maxSize", "promptStm_dvLabel", a_promptStm_dvLabel);}
      else
        check_intVal(a_promptStm_dvLabel->get_maxSize());
    }
}

/********************************************************************/

void check_promptStm_fiLabel(
 promptStm_fiLabel * a_promptStm_fiLabel)
{
  if (a_promptStm_fiLabel->get_fiLabel())
    {
      if (!findString("a_fiLabel", promptStm_fiLabelAtts))
	{warnAtt("a_fiLabel", "promptStm_fiLabel", a_promptStm_fiLabel);}
      else
        check_fiLabel(a_promptStm_fiLabel->get_fiLabel());
    }
  if (a_promptStm_fiLabel->get_text())
    {
      if (!findString("text", promptStm_fiLabelAtts))
	{warnAtt("text", "promptStm_fiLabel", a_promptStm_fiLabel);}
      else
        check_stringVal(a_promptStm_fiLabel->get_text());
    }
  if (a_promptStm_fiLabel->get_maxSize())
    {
      if (!findString("maxSize", promptStm_fiLabelAtts))
	{warnAtt("maxSize", "promptStm_fiLabel", a_promptStm_fiLabel);}
      else
        check_intVal(a_promptStm_fiLabel->get_maxSize());
    }
}

/********************************************************************/

void check_promptStm_fsLabel(
 promptStm_fsLabel * a_promptStm_fsLabel)
{
  if (a_promptStm_fsLabel->get_fsLabel())
    {
      if (!findString("a_fsLabel", promptStm_fsLabelAtts))
	{warnAtt("a_fsLabel", "promptStm_fsLabel", a_promptStm_fsLabel);}
      else
        check_fsLabel(a_promptStm_fsLabel->get_fsLabel());
    }
  if (a_promptStm_fsLabel->get_text())
    {
      if (!findString("text", promptStm_fsLabelAtts))
	{warnAtt("text", "promptStm_fsLabel", a_promptStm_fsLabel);}
      else
        check_stringVal(a_promptStm_fsLabel->get_text());
    }
  if (a_promptStm_fsLabel->get_maxSize())
    {
      if (!findString("maxSize", promptStm_fsLabelAtts))
	{warnAtt("maxSize", "promptStm_fsLabel", a_promptStm_fsLabel);}
      else
        check_intVal(a_promptStm_fsLabel->get_maxSize());
    }
}

/********************************************************************/

void check_promptStm_intVar(
 promptStm_intVar * a_promptStm_intVar)
{
  if (a_promptStm_intVar->get_intVar())
    {
      if (!findString("a_intVar", promptStm_intVarAtts))
	{warnAtt("a_intVar", "promptStm_intVar", a_promptStm_intVar);}
      else
        check_intVar(a_promptStm_intVar->get_intVar());
    }
  if (a_promptStm_intVar->get_promptIntEnd())
    {
      if (!findString("a_promptIntEnd", promptStm_intVarAtts))
	{warnAtt("a_promptIntEnd", "promptStm_intVar", a_promptStm_intVar);}
      else
        check_promptIntEnd(a_promptStm_intVar->get_promptIntEnd());
    }
}

/********************************************************************/

void check_promptStm_liLabel(
 promptStm_liLabel * a_promptStm_liLabel)
{
  if (a_promptStm_liLabel->get_liLabel())
    {
      if (!findString("a_liLabel", promptStm_liLabelAtts))
	{warnAtt("a_liLabel", "promptStm_liLabel", a_promptStm_liLabel);}
      else
        check_liLabel(a_promptStm_liLabel->get_liLabel());
    }
  if (a_promptStm_liLabel->get_text())
    {
      if (!findString("text", promptStm_liLabelAtts))
	{warnAtt("text", "promptStm_liLabel", a_promptStm_liLabel);}
      else
        check_stringVal(a_promptStm_liLabel->get_text());
    }
  if (a_promptStm_liLabel->get_maxSize())
    {
      if (!findString("maxSize", promptStm_liLabelAtts))
	{warnAtt("maxSize", "promptStm_liLabel", a_promptStm_liLabel);}
      else
        check_intVal(a_promptStm_liLabel->get_maxSize());
    }
}

/********************************************************************/

void check_promptStm_mdLabel(
 promptStm_mdLabel * a_promptStm_mdLabel)
{
  if (a_promptStm_mdLabel->get_mdLabel())
    {
      if (!findString("a_mdLabel", promptStm_mdLabelAtts))
	{warnAtt("a_mdLabel", "promptStm_mdLabel", a_promptStm_mdLabel);}
      else
        check_mdLabel(a_promptStm_mdLabel->get_mdLabel());
    }
  if (a_promptStm_mdLabel->get_text())
    {
      if (!findString("text", promptStm_mdLabelAtts))
	{warnAtt("text", "promptStm_mdLabel", a_promptStm_mdLabel);}
      else
        check_stringVal(a_promptStm_mdLabel->get_text());
    }
  if (a_promptStm_mdLabel->get_maxSize())
    {
      if (!findString("maxSize", promptStm_mdLabelAtts))
	{warnAtt("maxSize", "promptStm_mdLabel", a_promptStm_mdLabel);}
      else
        check_intVal(a_promptStm_mdLabel->get_maxSize());
    }
}

/********************************************************************/

void check_promptStm_opLabel(
 promptStm_opLabel * a_promptStm_opLabel)
{
  if (a_promptStm_opLabel->get_opLabel())
    {
      if (!findString("a_opLabel", promptStm_opLabelAtts))
	{warnAtt("a_opLabel", "promptStm_opLabel", a_promptStm_opLabel);}
      else
        check_opLabel(a_promptStm_opLabel->get_opLabel());
    }
  if (a_promptStm_opLabel->get_text())
    {
      if (!findString("text", promptStm_opLabelAtts))
	{warnAtt("text", "promptStm_opLabel", a_promptStm_opLabel);}
      else
        check_stringVal(a_promptStm_opLabel->get_text());
    }
  if (a_promptStm_opLabel->get_maxSize())
    {
      if (!findString("maxSize", promptStm_opLabelAtts))
	{warnAtt("maxSize", "promptStm_opLabel", a_promptStm_opLabel);}
      else
        check_intVal(a_promptStm_opLabel->get_maxSize());
    }
}

/********************************************************************/

void check_promptStm_pcLabel(
 promptStm_pcLabel * a_promptStm_pcLabel)
{
  if (a_promptStm_pcLabel->get_pcLabel())
    {
      if (!findString("a_pcLabel", promptStm_pcLabelAtts))
	{warnAtt("a_pcLabel", "promptStm_pcLabel", a_promptStm_pcLabel);}
      else
        check_pcLabel(a_promptStm_pcLabel->get_pcLabel());
    }
  if (a_promptStm_pcLabel->get_text())
    {
      if (!findString("text", promptStm_pcLabelAtts))
	{warnAtt("text", "promptStm_pcLabel", a_promptStm_pcLabel);}
      else
        check_stringVal(a_promptStm_pcLabel->get_text());
    }
  if (a_promptStm_pcLabel->get_maxSize())
    {
      if (!findString("maxSize", promptStm_pcLabelAtts))
	{warnAtt("maxSize", "promptStm_pcLabel", a_promptStm_pcLabel);}
      else
        check_intVal(a_promptStm_pcLabel->get_maxSize());
    }
}

/********************************************************************/

void check_promptStm_plLabel(
 promptStm_plLabel * a_promptStm_plLabel)
{
  if (a_promptStm_plLabel->get_plLabel())
    {
      if (!findString("a_plLabel", promptStm_plLabelAtts))
	{warnAtt("a_plLabel", "promptStm_plLabel", a_promptStm_plLabel);}
      else
        check_plLabel(a_promptStm_plLabel->get_plLabel());
    }
  if (a_promptStm_plLabel->get_text())
    {
      if (!findString("text", promptStm_plLabelAtts))
	{warnAtt("text", "promptStm_plLabel", a_promptStm_plLabel);}
      else
        check_stringVal(a_promptStm_plLabel->get_text());
    }
  if (a_promptStm_plLabel->get_maxSize())
    {
      if (!findString("maxSize", promptStm_plLabelAtts))
	{warnAtt("maxSize", "promptStm_plLabel", a_promptStm_plLabel);}
      else
        check_intVal(a_promptStm_plLabel->get_maxSize());
    }
}

/********************************************************************/

void check_promptStm_pnLabel(
 promptStm_pnLabel * a_promptStm_pnLabel)
{
  if (a_promptStm_pnLabel->get_pnLabel())
    {
      if (!findString("a_pnLabel", promptStm_pnLabelAtts))
	{warnAtt("a_pnLabel", "promptStm_pnLabel", a_promptStm_pnLabel);}
      else
        check_pnLabel(a_promptStm_pnLabel->get_pnLabel());
    }
  if (a_promptStm_pnLabel->get_text())
    {
      if (!findString("text", promptStm_pnLabelAtts))
	{warnAtt("text", "promptStm_pnLabel", a_promptStm_pnLabel);}
      else
        check_stringVal(a_promptStm_pnLabel->get_text());
    }
  if (a_promptStm_pnLabel->get_maxSize())
    {
      if (!findString("maxSize", promptStm_pnLabelAtts))
	{warnAtt("maxSize", "promptStm_pnLabel", a_promptStm_pnLabel);}
      else
        check_intVal(a_promptStm_pnLabel->get_maxSize());
    }
}

/********************************************************************/

void check_promptStm_prLabel(
 promptStm_prLabel * a_promptStm_prLabel)
{
  if (a_promptStm_prLabel->get_prLabel())
    {
      if (!findString("a_prLabel", promptStm_prLabelAtts))
	{warnAtt("a_prLabel", "promptStm_prLabel", a_promptStm_prLabel);}
      else
        check_prLabel(a_promptStm_prLabel->get_prLabel());
    }
  if (a_promptStm_prLabel->get_text())
    {
      if (!findString("text", promptStm_prLabelAtts))
	{warnAtt("text", "promptStm_prLabel", a_promptStm_prLabel);}
      else
        check_stringVal(a_promptStm_prLabel->get_text());
    }
  if (a_promptStm_prLabel->get_maxSize())
    {
      if (!findString("maxSize", promptStm_prLabelAtts))
	{warnAtt("maxSize", "promptStm_prLabel", a_promptStm_prLabel);}
      else
        check_intVal(a_promptStm_prLabel->get_maxSize());
    }
}

/********************************************************************/

void check_promptStm_psLabel(
 promptStm_psLabel * a_promptStm_psLabel)
{
  if (a_promptStm_psLabel->get_psLabel())
    {
      if (!findString("a_psLabel", promptStm_psLabelAtts))
	{warnAtt("a_psLabel", "promptStm_psLabel", a_promptStm_psLabel);}
      else
        check_psLabel(a_promptStm_psLabel->get_psLabel());
    }
  if (a_promptStm_psLabel->get_text())
    {
      if (!findString("text", promptStm_psLabelAtts))
	{warnAtt("text", "promptStm_psLabel", a_promptStm_psLabel);}
      else
        check_stringVal(a_promptStm_psLabel->get_text());
    }
  if (a_promptStm_psLabel->get_maxSize())
    {
      if (!findString("maxSize", promptStm_psLabelAtts))
	{warnAtt("maxSize", "promptStm_psLabel", a_promptStm_psLabel);}
      else
        check_intVal(a_promptStm_psLabel->get_maxSize());
    }
}

/********************************************************************/

void check_promptStm_pvLabel(
 promptStm_pvLabel * a_promptStm_pvLabel)
{
  if (a_promptStm_pvLabel->get_pvLabel())
    {
      if (!findString("a_pvLabel", promptStm_pvLabelAtts))
	{warnAtt("a_pvLabel", "promptStm_pvLabel", a_promptStm_pvLabel);}
      else
        check_pvLabel(a_promptStm_pvLabel->get_pvLabel());
    }
  if (a_promptStm_pvLabel->get_text())
    {
      if (!findString("text", promptStm_pvLabelAtts))
	{warnAtt("text", "promptStm_pvLabel", a_promptStm_pvLabel);}
      else
        check_stringVal(a_promptStm_pvLabel->get_text());
    }
  if (a_promptStm_pvLabel->get_maxSize())
    {
      if (!findString("maxSize", promptStm_pvLabelAtts))
	{warnAtt("maxSize", "promptStm_pvLabel", a_promptStm_pvLabel);}
      else
        check_intVal(a_promptStm_pvLabel->get_maxSize());
    }
}

/********************************************************************/

void check_promptStm_qLabel(
 promptStm_qLabel * a_promptStm_qLabel)
{
  if (a_promptStm_qLabel->get_qLabel())
    {
      if (!findString("a_qLabel", promptStm_qLabelAtts))
	{warnAtt("a_qLabel", "promptStm_qLabel", a_promptStm_qLabel);}
      else
        check_qLabel(a_promptStm_qLabel->get_qLabel());
    }
  if (a_promptStm_qLabel->get_text())
    {
      if (!findString("text", promptStm_qLabelAtts))
	{warnAtt("text", "promptStm_qLabel", a_promptStm_qLabel);}
      else
        check_stringVal(a_promptStm_qLabel->get_text());
    }
  if (a_promptStm_qLabel->get_maxSize())
    {
      if (!findString("maxSize", promptStm_qLabelAtts))
	{warnAtt("maxSize", "promptStm_qLabel", a_promptStm_qLabel);}
      else
        check_intVal(a_promptStm_qLabel->get_maxSize());
    }
}

/********************************************************************/

void check_promptStm_realVar(
 promptStm_realVar * a_promptStm_realVar)
{
  if (a_promptStm_realVar->get_realVar())
    {
      if (!findString("a_realVar", promptStm_realVarAtts))
	{warnAtt("a_realVar", "promptStm_realVar", a_promptStm_realVar);}
      else
        check_realVar(a_promptStm_realVar->get_realVar());
    }
  if (a_promptStm_realVar->get_text())
    {
      if (!findString("text", promptStm_realVarAtts))
	{warnAtt("text", "promptStm_realVar", a_promptStm_realVar);}
      else
        check_stringVal(a_promptStm_realVar->get_text());
    }
  if (a_promptStm_realVar->get_maxval())
    {
      if (!findString("maxval", promptStm_realVarAtts))
	{warnAtt("maxval", "promptStm_realVar", a_promptStm_realVar);}
      else
        check_rentVal(a_promptStm_realVar->get_maxval());
    }
  if (a_promptStm_realVar->get_minval())
    {
      if (!findString("minval", promptStm_realVarAtts))
	{warnAtt("minval", "promptStm_realVar", a_promptStm_realVar);}
      else
        check_rentVal(a_promptStm_realVar->get_minval());
    }
}

/********************************************************************/

void check_promptStm_stringVar(
 promptStm_stringVar * a_promptStm_stringVar)
{
  if (a_promptStm_stringVar->get_stringVar())
    {
      if (!findString("a_stringVar", promptStm_stringVarAtts))
	{warnAtt("a_stringVar", "promptStm_stringVar", a_promptStm_stringVar);}
      else
        check_stringVar(a_promptStm_stringVar->get_stringVar());
    }
  if (a_promptStm_stringVar->get_text())
    {
      if (!findString("text", promptStm_stringVarAtts))
	{warnAtt("text", "promptStm_stringVar", a_promptStm_stringVar);}
      else
        check_stringVal(a_promptStm_stringVar->get_text());
    }
  if (a_promptStm_stringVar->get_maxSize())
    {
      if (!findString("maxSize", promptStm_stringVarAtts))
	{warnAtt("maxSize", "promptStm_stringVar", a_promptStm_stringVar);}
      else
        check_intVal(a_promptStm_stringVar->get_maxSize());
    }
}

/********************************************************************/

void check_promptStm_tlLabel(
 promptStm_tlLabel * a_promptStm_tlLabel)
{
  if (a_promptStm_tlLabel->get_tlLabel())
    {
      if (!findString("a_tlLabel", promptStm_tlLabelAtts))
	{warnAtt("a_tlLabel", "promptStm_tlLabel", a_promptStm_tlLabel);}
      else
        check_tlLabel(a_promptStm_tlLabel->get_tlLabel());
    }
  if (a_promptStm_tlLabel->get_text())
    {
      if (!findString("text", promptStm_tlLabelAtts))
	{warnAtt("text", "promptStm_tlLabel", a_promptStm_tlLabel);}
      else
        check_stringVal(a_promptStm_tlLabel->get_text());
    }
  if (a_promptStm_tlLabel->get_maxSize())
    {
      if (!findString("maxSize", promptStm_tlLabelAtts))
	{warnAtt("maxSize", "promptStm_tlLabel", a_promptStm_tlLabel);}
      else
        check_intVal(a_promptStm_tlLabel->get_maxSize());
    }
}

/********************************************************************/

void check_promptVar(
 promptVar * a_promptVar)
{
  if (isA(a_promptVar, stringVar))
    {
      if (!findString("stringVar", promptVarSubs))
        {warnSub("stringVar", "promptVar", a_promptVar);}
      else
        check_stringVar(dynamic_cast<stringVar *>(a_promptVar));
      return;
    }
  if (isA(a_promptVar, boolVar))
    {
      if (!findString("boolVar", promptVarSubs))
        {warnSub("boolVar", "promptVar", a_promptVar);}
      else
        check_boolVar(dynamic_cast<boolVar *>(a_promptVar));
      return;
    }
  if (isA(a_promptVar, intVar))
    {
      if (!findString("intVar", promptVarSubs))
        {warnSub("intVar", "promptVar", a_promptVar);}
      else
        check_intVar(dynamic_cast<intVar *>(a_promptVar));
      return;
    }
  if (isA(a_promptVar, realVar))
    {
      if (!findString("realVar", promptVarSubs))
        {warnSub("realVar", "promptVar", a_promptVar);}
      else
        check_realVar(dynamic_cast<realVar *>(a_promptVar));
      return;
    }
  if (isA(a_promptVar, qisLabel))
    {
      if (!findString("qisLabel", promptVarSubs))
        {warnSub("qisLabel", "promptVar", a_promptVar);}
      else
        check_qisLabel(dynamic_cast<qisLabel *>(a_promptVar));
      return;
    }
}

/********************************************************************/

void check_psLabel(
 psLabel * a_psLabel)
{
  if (a_psLabel->get_labelName())
    {
      if (!findString("a_labelName", psLabelAtts))
	{warnAtt("a_labelName", "psLabel", a_psLabel);}
      else
        check_labelName(a_psLabel->get_labelName());
    }
}

/********************************************************************/

void check_psthruMinor(
 psthruMinor * a_psthruMinor)
{
  if (isA(a_psthruMinor, psthruMinor_COMAND))
    {
      if (!findString("psthruMinor_COMAND", psthruMinorSubs))
        {warnSub("psthruMinor_COMAND", "psthruMinor", a_psthruMinor);}
      else
        check_psthruMinor_COMAND(dynamic_cast<psthruMinor_COMAND *>(a_psthruMinor));
      return;
    }
  if (isA(a_psthruMinor, psthruMinor_CONTIN))
    {
      if (!findString("psthruMinor_CONTIN", psthruMinorSubs))
        {warnSub("psthruMinor_CONTIN", "psthruMinor", a_psthruMinor);}
      return;
    }
  if (isA(a_psthruMinor, psthruMinor_PAUSE))
    {
      if (!findString("psthruMinor_PAUSE", psthruMinorSubs))
        {warnSub("psthruMinor_PAUSE", "psthruMinor", a_psthruMinor);}
      return;
    }
  if (isA(a_psthruMinor, psthruMinor_START))
    {
      if (!findString("psthruMinor_START", psthruMinorSubs))
        {warnSub("psthruMinor_START", "psthruMinor", a_psthruMinor);}
      return;
    }
  if (isA(a_psthruMinor, psthruMinor_STOP))
    {
      if (!findString("psthruMinor_STOP", psthruMinorSubs))
        {warnSub("psthruMinor_STOP", "psthruMinor", a_psthruMinor);}
      return;
    }
  if (isA(a_psthruMinor, psthruMinor_TRMATX))
    {
      if (!findString("psthruMinor_TRMATX", psthruMinorSubs))
        {warnSub("psthruMinor_TRMATX", "psthruMinor", a_psthruMinor);}
      else
        check_psthruMinor_TRMATX(dynamic_cast<psthruMinor_TRMATX *>(a_psthruMinor));
      return;
    }
}

/********************************************************************/

void check_psthruMinor_COMAND(
 psthruMinor_COMAND * a_psthruMinor_COMAND)
{
  if (a_psthruMinor_COMAND->get_command())
    {
      if (!findString("command", psthruMinor_COMANDAtts))
	{warnAtt("command", "psthruMinor_COMAND", a_psthruMinor_COMAND);}
      else
        check_stringVal(a_psthruMinor_COMAND->get_command());
    }
}

/********************************************************************/

void check_psthruMinor_TRMATX(
 psthruMinor_TRMATX * a_psthruMinor_TRMATX)
{
  if (a_psthruMinor_TRMATX->get_matrix())
    {
      if (!findString("a_matrix", psthruMinor_TRMATXAtts))
	{warnAtt("a_matrix", "psthruMinor_TRMATX", a_psthruMinor_TRMATX);}
      else
        check_matrix(a_psthruMinor_TRMATX->get_matrix());
    }
}

/********************************************************************/

void check_psthruStm(
 psthruStm * a_psthruStm)
{
  if (a_psthruStm->get_psthruMinor())
    {
      if (!findString("a_psthruMinor", psthruStmAtts))
	{warnAtt("a_psthruMinor", "psthruStm", a_psthruStm);}
      else
        check_psthruMinor(a_psthruStm->get_psthruMinor());
    }
}

/********************************************************************/

void check_ptbuffStm(
 ptbuffStm * a_ptbuffStm)
{
  if (a_ptbuffStm->get_state())
    {
      if (!findString("a_state", ptbuffStmAtts))
	{warnAtt("a_state", "ptbuffStm", a_ptbuffStm);}
      else
        check_state(a_ptbuffStm->get_state());
    }
}

/********************************************************************/

void check_ptmeasEnd(
 ptmeasEnd * a_ptmeasEnd)
{
  if (isA(a_ptmeasEnd, ptmeasEnd_csSpec))
    {
      if (!findString("ptmeasEnd_csSpec", ptmeasEndSubs))
        {warnSub("ptmeasEnd_csSpec", "ptmeasEnd", a_ptmeasEnd);}
      else
        check_ptmeasEnd_csSpec(dynamic_cast<ptmeasEnd_csSpec *>(a_ptmeasEnd));
      return;
    }
  if (isA(a_ptmeasEnd, ptmeasEnd_touchSpec))
    {
      if (!findString("ptmeasEnd_touchSpec", ptmeasEndSubs))
        {warnSub("ptmeasEnd_touchSpec", "ptmeasEnd", a_ptmeasEnd);}
      else
        check_ptmeasEnd_touchSpec(dynamic_cast<ptmeasEnd_touchSpec *>(a_ptmeasEnd));
      return;
    }
}

/********************************************************************/

void check_ptmeasEnd_csSpec(
 ptmeasEnd_csSpec * a_ptmeasEnd_csSpec)
{
  if (a_ptmeasEnd_csSpec->get_csSpec())
    {
      if (!findString("a_csSpec", ptmeasEnd_csSpecAtts))
	{warnAtt("a_csSpec", "ptmeasEnd_csSpec", a_ptmeasEnd_csSpec);}
      else
        check_csSpec(a_ptmeasEnd_csSpec->get_csSpec());
    }
  if (a_ptmeasEnd_csSpec->get_touchSpec())
    {
      if (!findString("a_touchSpec", ptmeasEnd_csSpecAtts))
	{warnAtt("a_touchSpec", "ptmeasEnd_csSpec", a_ptmeasEnd_csSpec);}
      else
        check_touchSpec(a_ptmeasEnd_csSpec->get_touchSpec());
    }
}

/********************************************************************/

void check_ptmeasEnd_touchSpec(
 ptmeasEnd_touchSpec * a_ptmeasEnd_touchSpec)
{
  if (a_ptmeasEnd_touchSpec->get_touchSpec())
    {
      if (!findString("a_touchSpec", ptmeasEnd_touchSpecAtts))
	{warnAtt("a_touchSpec", "ptmeasEnd_touchSpec", a_ptmeasEnd_touchSpec);}
      else
        check_touchSpec(a_ptmeasEnd_touchSpec->get_touchSpec());
    }
}

/********************************************************************/

void check_ptmeasStm(
 ptmeasStm * a_ptmeasStm)
{
  if (a_ptmeasStm->get_typePoint())
    {
      if (!findString("a_typePoint", ptmeasStmAtts))
	{warnAtt("a_typePoint", "ptmeasStm", a_ptmeasStm);}
      else
        check_typePoint(a_ptmeasStm->get_typePoint());
    }
  if (a_ptmeasStm->get_dir())
    {
      if (!findString("dir", ptmeasStmAtts))
	{warnAtt("dir", "ptmeasStm", a_ptmeasStm);}
      else
        check_vector(a_ptmeasStm->get_dir());
    }
  if (a_ptmeasStm->get_ptmeasEnd())
    {
      if (!findString("a_ptmeasEnd", ptmeasStmAtts))
	{warnAtt("a_ptmeasEnd", "ptmeasStm", a_ptmeasStm);}
      else
        check_ptmeasEnd(a_ptmeasStm->get_ptmeasEnd());
    }
}

/********************************************************************/

void check_pushStm(
 pushStm * a_pushStm)
{
  if (a_pushStm->get_stackElementList())
    {
      if (!findString("a_stackElementList", pushStmAtts))
	{warnAtt("a_stackElementList", "pushStm", a_pushStm);}
      else
        {
          std::list<stackElement *> * theList;
          std::list<stackElement *>::iterator iter;
          theList = a_pushStm->get_stackElementList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_stackElement(*iter);
        }
    }
}

/********************************************************************/

void check_pvLabel(
 pvLabel * a_pvLabel)
{
  if (a_pvLabel->get_labelName())
    {
      if (!findString("a_labelName", pvLabelAtts))
	{warnAtt("a_labelName", "pvLabel", a_pvLabel);}
      else
        check_labelName(a_pvLabel->get_labelName());
    }
}

/********************************************************************/

void check_qLabel(
 qLabel * a_qLabel)
{
  if (a_qLabel->get_labelName())
    {
      if (!findString("a_labelName", qLabelAtts))
	{warnAtt("a_labelName", "qLabel", a_qLabel);}
      else
        check_labelName(a_qLabel->get_labelName());
    }
}

/********************************************************************/

void check_qisLabel(
 qisLabel * a_qisLabel)
{
  if (isA(a_qisLabel, ccLabel))
    {
      if (!findString("ccLabel", qisLabelSubs))
        {warnSub("ccLabel", "qisLabel", a_qisLabel);}
      else
        check_ccLabel(dynamic_cast<ccLabel *>(a_qisLabel));
      return;
    }
  if (isA(a_qisLabel, ciLabel))
    {
      if (!findString("ciLabel", qisLabelSubs))
        {warnSub("ciLabel", "qisLabel", a_qisLabel);}
      else
        check_ciLabel(dynamic_cast<ciLabel *>(a_qisLabel));
      return;
    }
  if (isA(a_qisLabel, csLabel))
    {
      if (!findString("csLabel", qisLabelSubs))
        {warnSub("csLabel", "qisLabel", a_qisLabel);}
      else
        check_csLabel(dynamic_cast<csLabel *>(a_qisLabel));
      return;
    }
  if (isA(a_qisLabel, diLabel))
    {
      if (!findString("diLabel", qisLabelSubs))
        {warnSub("diLabel", "qisLabel", a_qisLabel);}
      else
        check_diLabel(dynamic_cast<diLabel *>(a_qisLabel));
      return;
    }
  if (isA(a_qisLabel, dsLabel))
    {
      if (!findString("dsLabel", qisLabelSubs))
        {warnSub("dsLabel", "qisLabel", a_qisLabel);}
      else
        check_dsLabel(dynamic_cast<dsLabel *>(a_qisLabel));
      return;
    }
  if (isA(a_qisLabel, dvLabel))
    {
      if (!findString("dvLabel", qisLabelSubs))
        {warnSub("dvLabel", "qisLabel", a_qisLabel);}
      else
        check_dvLabel(dynamic_cast<dvLabel *>(a_qisLabel));
      return;
    }
  if (isA(a_qisLabel, fiLabel))
    {
      if (!findString("fiLabel", qisLabelSubs))
        {warnSub("fiLabel", "qisLabel", a_qisLabel);}
      else
        check_fiLabel(dynamic_cast<fiLabel *>(a_qisLabel));
      return;
    }
  if (isA(a_qisLabel, fsLabel))
    {
      if (!findString("fsLabel", qisLabelSubs))
        {warnSub("fsLabel", "qisLabel", a_qisLabel);}
      else
        check_fsLabel(dynamic_cast<fsLabel *>(a_qisLabel));
      return;
    }
  if (isA(a_qisLabel, liLabel))
    {
      if (!findString("liLabel", qisLabelSubs))
        {warnSub("liLabel", "qisLabel", a_qisLabel);}
      else
        check_liLabel(dynamic_cast<liLabel *>(a_qisLabel));
      return;
    }
  if (isA(a_qisLabel, mdLabel))
    {
      if (!findString("mdLabel", qisLabelSubs))
        {warnSub("mdLabel", "qisLabel", a_qisLabel);}
      else
        check_mdLabel(dynamic_cast<mdLabel *>(a_qisLabel));
      return;
    }
  if (isA(a_qisLabel, opLabel))
    {
      if (!findString("opLabel", qisLabelSubs))
        {warnSub("opLabel", "qisLabel", a_qisLabel);}
      else
        check_opLabel(dynamic_cast<opLabel *>(a_qisLabel));
      return;
    }
  if (isA(a_qisLabel, pcLabel))
    {
      if (!findString("pcLabel", qisLabelSubs))
        {warnSub("pcLabel", "qisLabel", a_qisLabel);}
      else
        check_pcLabel(dynamic_cast<pcLabel *>(a_qisLabel));
      return;
    }
  if (isA(a_qisLabel, plLabel))
    {
      if (!findString("plLabel", qisLabelSubs))
        {warnSub("plLabel", "qisLabel", a_qisLabel);}
      else
        check_plLabel(dynamic_cast<plLabel *>(a_qisLabel));
      return;
    }
  if (isA(a_qisLabel, pnLabel))
    {
      if (!findString("pnLabel", qisLabelSubs))
        {warnSub("pnLabel", "qisLabel", a_qisLabel);}
      else
        check_pnLabel(dynamic_cast<pnLabel *>(a_qisLabel));
      return;
    }
  if (isA(a_qisLabel, prLabel))
    {
      if (!findString("prLabel", qisLabelSubs))
        {warnSub("prLabel", "qisLabel", a_qisLabel);}
      else
        check_prLabel(dynamic_cast<prLabel *>(a_qisLabel));
      return;
    }
  if (isA(a_qisLabel, psLabel))
    {
      if (!findString("psLabel", qisLabelSubs))
        {warnSub("psLabel", "qisLabel", a_qisLabel);}
      else
        check_psLabel(dynamic_cast<psLabel *>(a_qisLabel));
      return;
    }
  if (isA(a_qisLabel, pvLabel))
    {
      if (!findString("pvLabel", qisLabelSubs))
        {warnSub("pvLabel", "qisLabel", a_qisLabel);}
      else
        check_pvLabel(dynamic_cast<pvLabel *>(a_qisLabel));
      return;
    }
  if (isA(a_qisLabel, qLabel))
    {
      if (!findString("qLabel", qisLabelSubs))
        {warnSub("qLabel", "qisLabel", a_qisLabel);}
      else
        check_qLabel(dynamic_cast<qLabel *>(a_qisLabel));
      return;
    }
  if (isA(a_qisLabel, tlLabel))
    {
      if (!findString("tlLabel", qisLabelSubs))
        {warnSub("tlLabel", "qisLabel", a_qisLabel);}
      else
        check_tlLabel(dynamic_cast<tlLabel *>(a_qisLabel));
      return;
    }
}

/********************************************************************/

void check_qisdefStm(
 qisdefStm * a_qisdefStm)
{
  if (a_qisdefStm->get_qLabel())
    {
      if (!findString("a_qLabel", qisdefStmAtts))
	{warnAtt("a_qLabel", "qisdefStm", a_qisdefStm);}
      else
        check_qLabel(a_qisdefStm->get_qLabel());
    }
  if (a_qisdefStm->get_typ())
    {
      if (!findString("typ", qisdefStmAtts))
	{warnAtt("typ", "qisdefStm", a_qisdefStm);}
      else
        check_stringVal(a_qisdefStm->get_typ());
    }
  if (a_qisdefStm->get_text())
    {
      if (!findString("text", qisdefStmAtts))
	{warnAtt("text", "qisdefStm", a_qisdefStm);}
      else
        check_stringVal(a_qisdefStm->get_text());
    }
}

/********************************************************************/

void check_rLabel(
 rLabel * a_rLabel)
{
  if (a_rLabel->get_labelName())
    {
      if (!findString("a_labelName", rLabelAtts))
	{warnAtt("a_labelName", "rLabel", a_rLabel);}
      else
        check_labelName(a_rLabel->get_labelName());
    }
}

/********************************************************************/

void check_radiusSpec(
 radiusSpec * a_radiusSpec)
{
  if (isA(a_radiusSpec, radiusSpec_MAJOR))
    {
      if (!findString("radiusSpec_MAJOR", radiusSpecSubs))
        {warnSub("radiusSpec_MAJOR", "radiusSpec", a_radiusSpec);}
      return;
    }
  if (isA(a_radiusSpec, radiusSpec_MINOR))
    {
      if (!findString("radiusSpec_MINOR", radiusSpecSubs))
        {warnSub("radiusSpec_MINOR", "radiusSpec", a_radiusSpec);}
      return;
    }
}

/********************************************************************/

void check_rapidStm(
 rapidStm * a_rapidStm)
{
  if (a_rapidStm->get_speed())
    {
      if (!findString("speed", rapidStmAtts))
	{warnAtt("speed", "rapidStm", a_rapidStm);}
      else
        check_rentVal(a_rapidStm->get_speed());
    }
}

/********************************************************************/

void check_readSpec(
 readSpec * a_readSpec)
{
  if (a_readSpec->get_rwVar())
    {
      if (!findString("a_rwVar", readSpecAtts))
	{warnAtt("a_rwVar", "readSpec", a_readSpec);}
      else
        check_rwVar(a_readSpec->get_rwVar());
    }
  if (a_readSpec->get_rwFormat())
    {
      if (!findString("a_rwFormat", readSpecAtts))
	{warnAtt("a_rwFormat", "readSpec", a_readSpec);}
      else
        check_rwFormat(a_readSpec->get_rwFormat());
    }
}

/********************************************************************/

void check_readStm(
 readStm * a_readStm)
{
  if (a_readStm->get_didLabel())
    {
      if (!findString("a_didLabel", readStmAtts))
	{warnAtt("a_didLabel", "readStm", a_readStm);}
      else
        check_didLabel(a_readStm->get_didLabel());
    }
  if (a_readStm->get_readSpecList())
    {
      if (!findString("a_readSpecList", readStmAtts))
	{warnAtt("a_readSpecList", "readStm", a_readStm);}
      else
        {
          std::list<readSpec *> * theList;
          std::list<readSpec *>::iterator iter;
          theList = a_readStm->get_readSpecList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_readSpec(*iter);
        }
    }
}

/********************************************************************/

void check_realConst(
 realConst * a_realConst)
{
  if (a_realConst->get_double())
    {
      if (!findString("a_double", realConstAtts))
	{warnAtt("a_double", "realConst", a_realConst);}
    }
}

/********************************************************************/

void check_realExpr(
 realExpr * a_realExpr)
{
  if (isA(a_realExpr, realExprParen))
    {
      if (!findString("realExprParen", realExprSubs))
        {warnSub("realExprParen", "realExpr", a_realExpr);}
      else
        check_realExprParen(dynamic_cast<realExprParen *>(a_realExpr));
      return;
    }
  if (isA(a_realExpr, realRealExpr))
    {
      if (!findString("realRealExpr", realExprSubs))
        {warnSub("realRealExpr", "realExpr", a_realExpr);}
      else
        check_realRealExpr(dynamic_cast<realRealExpr *>(a_realExpr));
      return;
    }
  if (isA(a_realExpr, realIntExpr))
    {
      if (!findString("realIntExpr", realExprSubs))
        {warnSub("realIntExpr", "realExpr", a_realExpr);}
      else
        check_realIntExpr(dynamic_cast<realIntExpr *>(a_realExpr));
      return;
    }
  if (isA(a_realExpr, intRealExpr))
    {
      if (!findString("intRealExpr", realExprSubs))
        {warnSub("intRealExpr", "realExpr", a_realExpr);}
      else
        check_intRealExpr(dynamic_cast<intRealExpr *>(a_realExpr));
      return;
    }
  if (isA(a_realExpr, realExprNegat))
    {
      if (!findString("realExprNegat", realExprSubs))
        {warnSub("realExprNegat", "realExpr", a_realExpr);}
      else
        check_realExprNegat(dynamic_cast<realExprNegat *>(a_realExpr));
      return;
    }
  if (isA(a_realExpr, realExprPosit))
    {
      if (!findString("realExprPosit", realExprSubs))
        {warnSub("realExprPosit", "realExpr", a_realExpr);}
      else
        check_realExprPosit(dynamic_cast<realExprPosit *>(a_realExpr));
      return;
    }
}

/********************************************************************/

void check_realExprNegat(
 realExprNegat * a_realExprNegat)
{
  if (a_realExprNegat->get_x())
    {
      if (!findString("x", realExprNegatAtts))
	{warnAtt("x", "realExprNegat", a_realExprNegat);}
      else
        check_realVal(a_realExprNegat->get_x());
    }
}

/********************************************************************/

void check_realExprParen(
 realExprParen * a_realExprParen)
{
  if (a_realExprParen->get_x())
    {
      if (!findString("x", realExprParenAtts))
	{warnAtt("x", "realExprParen", a_realExprParen);}
      else
        check_realVal(a_realExprParen->get_x());
    }
}

/********************************************************************/

void check_realExprPosit(
 realExprPosit * a_realExprPosit)
{
  if (a_realExprPosit->get_x())
    {
      if (!findString("x", realExprPositAtts))
	{warnAtt("x", "realExprPosit", a_realExprPosit);}
      else
        check_realVal(a_realExprPosit->get_x());
    }
}

/********************************************************************/

void check_realFunc(
 realFunc * a_realFunc)
{
  if (isA(a_realFunc, realFuncAbs))
    {
      if (!findString("realFuncAbs", realFuncSubs))
        {warnSub("realFuncAbs", "realFunc", a_realFunc);}
      else
        check_realFuncAbs(dynamic_cast<realFuncAbs *>(a_realFunc));
      return;
    }
  if (isA(a_realFunc, realFuncAcos))
    {
      if (!findString("realFuncAcos", realFuncSubs))
        {warnSub("realFuncAcos", "realFunc", a_realFunc);}
      else
        check_realFuncAcos(dynamic_cast<realFuncAcos *>(a_realFunc));
      return;
    }
  if (isA(a_realFunc, realFuncAsin))
    {
      if (!findString("realFuncAsin", realFuncSubs))
        {warnSub("realFuncAsin", "realFunc", a_realFunc);}
      else
        check_realFuncAsin(dynamic_cast<realFuncAsin *>(a_realFunc));
      return;
    }
  if (isA(a_realFunc, realFuncAtan))
    {
      if (!findString("realFuncAtan", realFuncSubs))
        {warnSub("realFuncAtan", "realFunc", a_realFunc);}
      else
        check_realFuncAtan(dynamic_cast<realFuncAtan *>(a_realFunc));
      return;
    }
  if (isA(a_realFunc, realFuncAtan2))
    {
      if (!findString("realFuncAtan2", realFuncSubs))
        {warnSub("realFuncAtan2", "realFunc", a_realFunc);}
      else
        check_realFuncAtan2(dynamic_cast<realFuncAtan2 *>(a_realFunc));
      return;
    }
  if (isA(a_realFunc, realFuncCos))
    {
      if (!findString("realFuncCos", realFuncSubs))
        {warnSub("realFuncCos", "realFunc", a_realFunc);}
      else
        check_realFuncCos(dynamic_cast<realFuncCos *>(a_realFunc));
      return;
    }
  if (isA(a_realFunc, realFuncDble))
    {
      if (!findString("realFuncDble", realFuncSubs))
        {warnSub("realFuncDble", "realFunc", a_realFunc);}
      else
        check_realFuncDble(dynamic_cast<realFuncDble *>(a_realFunc));
      return;
    }
  if (isA(a_realFunc, realFuncDtor))
    {
      if (!findString("realFuncDtor", realFuncSubs))
        {warnSub("realFuncDtor", "realFunc", a_realFunc);}
      else
        check_realFuncDtor(dynamic_cast<realFuncDtor *>(a_realFunc));
      return;
    }
  if (isA(a_realFunc, realFuncExp))
    {
      if (!findString("realFuncExp", realFuncSubs))
        {warnSub("realFuncExp", "realFunc", a_realFunc);}
      else
        check_realFuncExp(dynamic_cast<realFuncExp *>(a_realFunc));
      return;
    }
  if (isA(a_realFunc, realFuncLn))
    {
      if (!findString("realFuncLn", realFuncSubs))
        {warnSub("realFuncLn", "realFunc", a_realFunc);}
      else
        check_realFuncLn(dynamic_cast<realFuncLn *>(a_realFunc));
      return;
    }
  if (isA(a_realFunc, realFuncLog))
    {
      if (!findString("realFuncLog", realFuncSubs))
        {warnSub("realFuncLog", "realFunc", a_realFunc);}
      else
        check_realFuncLog(dynamic_cast<realFuncLog *>(a_realFunc));
      return;
    }
  if (isA(a_realFunc, realFuncMn))
    {
      if (!findString("realFuncMn", realFuncSubs))
        {warnSub("realFuncMn", "realFunc", a_realFunc);}
      else
        check_realFuncMn(dynamic_cast<realFuncMn *>(a_realFunc));
      return;
    }
  if (isA(a_realFunc, realFuncMod))
    {
      if (!findString("realFuncMod", realFuncSubs))
        {warnSub("realFuncMod", "realFunc", a_realFunc);}
      else
        check_realFuncMod(dynamic_cast<realFuncMod *>(a_realFunc));
      return;
    }
  if (isA(a_realFunc, realFuncMx))
    {
      if (!findString("realFuncMx", realFuncSubs))
        {warnSub("realFuncMx", "realFunc", a_realFunc);}
      else
        check_realFuncMx(dynamic_cast<realFuncMx *>(a_realFunc));
      return;
    }
  if (isA(a_realFunc, realFuncQtemp))
    {
      if (!findString("realFuncQtemp", realFuncSubs))
        {warnSub("realFuncQtemp", "realFunc", a_realFunc);}
      else
        check_realFuncQtemp(dynamic_cast<realFuncQtemp *>(a_realFunc));
      return;
    }
  if (isA(a_realFunc, realFuncRand))
    {
      if (!findString("realFuncRand", realFuncSubs))
        {warnSub("realFuncRand", "realFunc", a_realFunc);}
      else
        check_realFuncRand(dynamic_cast<realFuncRand *>(a_realFunc));
      return;
    }
  if (isA(a_realFunc, realFuncRl))
    {
      if (!findString("realFuncRl", realFuncSubs))
        {warnSub("realFuncRl", "realFunc", a_realFunc);}
      else
        check_realFuncRl(dynamic_cast<realFuncRl *>(a_realFunc));
      return;
    }
  if (isA(a_realFunc, realFuncRtod))
    {
      if (!findString("realFuncRtod", realFuncSubs))
        {warnSub("realFuncRtod", "realFunc", a_realFunc);}
      else
        check_realFuncRtod(dynamic_cast<realFuncRtod *>(a_realFunc));
      return;
    }
  if (isA(a_realFunc, realFuncSign))
    {
      if (!findString("realFuncSign", realFuncSubs))
        {warnSub("realFuncSign", "realFunc", a_realFunc);}
      else
        check_realFuncSign(dynamic_cast<realFuncSign *>(a_realFunc));
      return;
    }
  if (isA(a_realFunc, realFuncSin))
    {
      if (!findString("realFuncSin", realFuncSubs))
        {warnSub("realFuncSin", "realFunc", a_realFunc);}
      else
        check_realFuncSin(dynamic_cast<realFuncSin *>(a_realFunc));
      return;
    }
  if (isA(a_realFunc, realFuncSqrt))
    {
      if (!findString("realFuncSqrt", realFuncSubs))
        {warnSub("realFuncSqrt", "realFunc", a_realFunc);}
      else
        check_realFuncSqrt(dynamic_cast<realFuncSqrt *>(a_realFunc));
      return;
    }
  if (isA(a_realFunc, realFuncTan))
    {
      if (!findString("realFuncTan", realFuncSubs))
        {warnSub("realFuncTan", "realFunc", a_realFunc);}
      else
        check_realFuncTan(dynamic_cast<realFuncTan *>(a_realFunc));
      return;
    }
  if (isA(a_realFunc, realFuncVal))
    {
      if (!findString("realFuncVal", realFuncSubs))
        {warnSub("realFuncVal", "realFunc", a_realFunc);}
      else
        check_realFuncVal(dynamic_cast<realFuncVal *>(a_realFunc));
      return;
    }
  if (isA(a_realFunc, realFuncVdot))
    {
      if (!findString("realFuncVdot", realFuncSubs))
        {warnSub("realFuncVdot", "realFunc", a_realFunc);}
      else
        check_realFuncVdot(dynamic_cast<realFuncVdot *>(a_realFunc));
      return;
    }
  if (isA(a_realFunc, realFuncVecX))
    {
      if (!findString("realFuncVecX", realFuncSubs))
        {warnSub("realFuncVecX", "realFunc", a_realFunc);}
      else
        check_realFuncVecX(dynamic_cast<realFuncVecX *>(a_realFunc));
      return;
    }
  if (isA(a_realFunc, realFuncVecY))
    {
      if (!findString("realFuncVecY", realFuncSubs))
        {warnSub("realFuncVecY", "realFunc", a_realFunc);}
      else
        check_realFuncVecY(dynamic_cast<realFuncVecY *>(a_realFunc));
      return;
    }
  if (isA(a_realFunc, realFuncVecZ))
    {
      if (!findString("realFuncVecZ", realFuncSubs))
        {warnSub("realFuncVecZ", "realFunc", a_realFunc);}
      else
        check_realFuncVecZ(dynamic_cast<realFuncVecZ *>(a_realFunc));
      return;
    }
  if (isA(a_realFunc, realFuncVmag))
    {
      if (!findString("realFuncVmag", realFuncSubs))
        {warnSub("realFuncVmag", "realFunc", a_realFunc);}
      else
        check_realFuncVmag(dynamic_cast<realFuncVmag *>(a_realFunc));
      return;
    }
}

/********************************************************************/

void check_realFuncAbs(
 realFuncAbs * a_realFuncAbs)
{
  if (a_realFuncAbs->get_realVal())
    {
      if (!findString("a_realVal", realFuncAbsAtts))
	{warnAtt("a_realVal", "realFuncAbs", a_realFuncAbs);}
      else
        check_realVal(a_realFuncAbs->get_realVal());
    }
}

/********************************************************************/

void check_realFuncAcos(
 realFuncAcos * a_realFuncAcos)
{
  if (a_realFuncAcos->get_x())
    {
      if (!findString("x", realFuncAcosAtts))
	{warnAtt("x", "realFuncAcos", a_realFuncAcos);}
      else
        check_rentVal(a_realFuncAcos->get_x());
    }
}

/********************************************************************/

void check_realFuncAsin(
 realFuncAsin * a_realFuncAsin)
{
  if (a_realFuncAsin->get_x())
    {
      if (!findString("x", realFuncAsinAtts))
	{warnAtt("x", "realFuncAsin", a_realFuncAsin);}
      else
        check_rentVal(a_realFuncAsin->get_x());
    }
}

/********************************************************************/

void check_realFuncAtan(
 realFuncAtan * a_realFuncAtan)
{
  if (a_realFuncAtan->get_x())
    {
      if (!findString("x", realFuncAtanAtts))
	{warnAtt("x", "realFuncAtan", a_realFuncAtan);}
      else
        check_rentVal(a_realFuncAtan->get_x());
    }
}

/********************************************************************/

void check_realFuncAtan2(
 realFuncAtan2 * a_realFuncAtan2)
{
  if (a_realFuncAtan2->get_y())
    {
      if (!findString("y", realFuncAtan2Atts))
	{warnAtt("y", "realFuncAtan2", a_realFuncAtan2);}
      else
        check_rentVal(a_realFuncAtan2->get_y());
    }
  if (a_realFuncAtan2->get_x())
    {
      if (!findString("x", realFuncAtan2Atts))
	{warnAtt("x", "realFuncAtan2", a_realFuncAtan2);}
      else
        check_rentVal(a_realFuncAtan2->get_x());
    }
}

/********************************************************************/

void check_realFuncCos(
 realFuncCos * a_realFuncCos)
{
  if (a_realFuncCos->get_x())
    {
      if (!findString("x", realFuncCosAtts))
	{warnAtt("x", "realFuncCos", a_realFuncCos);}
      else
        check_rentVal(a_realFuncCos->get_x());
    }
}

/********************************************************************/

void check_realFuncDble(
 realFuncDble * a_realFuncDble)
{
  if (a_realFuncDble->get_x())
    {
      if (!findString("x", realFuncDbleAtts))
	{warnAtt("x", "realFuncDble", a_realFuncDble);}
      else
        check_rentVal(a_realFuncDble->get_x());
    }
}

/********************************************************************/

void check_realFuncDtor(
 realFuncDtor * a_realFuncDtor)
{
  if (a_realFuncDtor->get_x())
    {
      if (!findString("x", realFuncDtorAtts))
	{warnAtt("x", "realFuncDtor", a_realFuncDtor);}
      else
        check_rentVal(a_realFuncDtor->get_x());
    }
}

/********************************************************************/

void check_realFuncExp(
 realFuncExp * a_realFuncExp)
{
  if (a_realFuncExp->get_x())
    {
      if (!findString("x", realFuncExpAtts))
	{warnAtt("x", "realFuncExp", a_realFuncExp);}
      else
        check_rentVal(a_realFuncExp->get_x());
    }
}

/********************************************************************/

void check_realFuncLn(
 realFuncLn * a_realFuncLn)
{
  if (a_realFuncLn->get_x())
    {
      if (!findString("x", realFuncLnAtts))
	{warnAtt("x", "realFuncLn", a_realFuncLn);}
      else
        check_rentVal(a_realFuncLn->get_x());
    }
}

/********************************************************************/

void check_realFuncLog(
 realFuncLog * a_realFuncLog)
{
  if (a_realFuncLog->get_x())
    {
      if (!findString("x", realFuncLogAtts))
	{warnAtt("x", "realFuncLog", a_realFuncLog);}
      else
        check_rentVal(a_realFuncLog->get_x());
    }
}

/********************************************************************/

void check_realFuncMn(
 realFuncMn * a_realFuncMn)
{
  if (a_realFuncMn->get_arg1())
    {
      if (!findString("arg1", realFuncMnAtts))
	{warnAtt("arg1", "realFuncMn", a_realFuncMn);}
      else
        check_rentVal(a_realFuncMn->get_arg1());
    }
  if (a_realFuncMn->get_moreArgs())
    {
      if (!findString("moreArgs", realFuncMnAtts))
	{warnAtt("moreArgs", "realFuncMn", a_realFuncMn);}
      else
        {
          std::list<rentVal *> * theList;
          std::list<rentVal *>::iterator iter;
          theList = a_realFuncMn->get_moreArgs();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_rentVal(*iter);
        }
    }
}

/********************************************************************/

void check_realFuncMod(
 realFuncMod * a_realFuncMod)
{
  if (a_realFuncMod->get_num())
    {
      if (!findString("num", realFuncModAtts))
	{warnAtt("num", "realFuncMod", a_realFuncMod);}
      else
        check_realVal(a_realFuncMod->get_num());
    }
  if (a_realFuncMod->get_dvisr())
    {
      if (!findString("dvisr", realFuncModAtts))
	{warnAtt("dvisr", "realFuncMod", a_realFuncMod);}
      else
        check_realVal(a_realFuncMod->get_dvisr());
    }
}

/********************************************************************/

void check_realFuncMx(
 realFuncMx * a_realFuncMx)
{
  if (a_realFuncMx->get_arg1())
    {
      if (!findString("arg1", realFuncMxAtts))
	{warnAtt("arg1", "realFuncMx", a_realFuncMx);}
      else
        check_rentVal(a_realFuncMx->get_arg1());
    }
  if (a_realFuncMx->get_moreArgs())
    {
      if (!findString("moreArgs", realFuncMxAtts))
	{warnAtt("moreArgs", "realFuncMx", a_realFuncMx);}
      else
        {
          std::list<rentVal *> * theList;
          std::list<rentVal *>::iterator iter;
          theList = a_realFuncMx->get_moreArgs();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_rentVal(*iter);
        }
    }
}

/********************************************************************/

void check_realFuncQtemp(
 realFuncQtemp * a_realFuncQtemp)
{
  if (a_realFuncQtemp->get_tempsns())
    {
      if (!findString("tempsns", realFuncQtempAtts))
	{warnAtt("tempsns", "realFuncQtemp", a_realFuncQtemp);}
      else
        check_stringVal(a_realFuncQtemp->get_tempsns());
    }
}

/********************************************************************/

void check_realFuncRand(
 realFuncRand * a_realFuncRand)
{
  if (a_realFuncRand->get_seed())
    {
      if (!findString("seed", realFuncRandAtts))
	{warnAtt("seed", "realFuncRand", a_realFuncRand);}
      else
        check_rentVal(a_realFuncRand->get_seed());
    }
}

/********************************************************************/

void check_realFuncRl(
 realFuncRl * a_realFuncRl)
{
  if (a_realFuncRl->get_x())
    {
      if (!findString("x", realFuncRlAtts))
	{warnAtt("x", "realFuncRl", a_realFuncRl);}
      else
        check_rentVal(a_realFuncRl->get_x());
    }
}

/********************************************************************/

void check_realFuncRtod(
 realFuncRtod * a_realFuncRtod)
{
  if (a_realFuncRtod->get_x())
    {
      if (!findString("x", realFuncRtodAtts))
	{warnAtt("x", "realFuncRtod", a_realFuncRtod);}
      else
        check_rentVal(a_realFuncRtod->get_x());
    }
}

/********************************************************************/

void check_realFuncSign(
 realFuncSign * a_realFuncSign)
{
  if (a_realFuncSign->get_x())
    {
      if (!findString("x", realFuncSignAtts))
	{warnAtt("x", "realFuncSign", a_realFuncSign);}
      else
        check_realVal(a_realFuncSign->get_x());
    }
  if (a_realFuncSign->get_y())
    {
      if (!findString("y", realFuncSignAtts))
	{warnAtt("y", "realFuncSign", a_realFuncSign);}
      else
        check_realVal(a_realFuncSign->get_y());
    }
}

/********************************************************************/

void check_realFuncSin(
 realFuncSin * a_realFuncSin)
{
  if (a_realFuncSin->get_x())
    {
      if (!findString("x", realFuncSinAtts))
	{warnAtt("x", "realFuncSin", a_realFuncSin);}
      else
        check_rentVal(a_realFuncSin->get_x());
    }
}

/********************************************************************/

void check_realFuncSqrt(
 realFuncSqrt * a_realFuncSqrt)
{
  if (a_realFuncSqrt->get_x())
    {
      if (!findString("x", realFuncSqrtAtts))
	{warnAtt("x", "realFuncSqrt", a_realFuncSqrt);}
      else
        check_rentVal(a_realFuncSqrt->get_x());
    }
}

/********************************************************************/

void check_realFuncTan(
 realFuncTan * a_realFuncTan)
{
  if (a_realFuncTan->get_x())
    {
      if (!findString("x", realFuncTanAtts))
	{warnAtt("x", "realFuncTan", a_realFuncTan);}
      else
        check_rentVal(a_realFuncTan->get_x());
    }
}

/********************************************************************/

void check_realFuncVal(
 realFuncVal * a_realFuncVal)
{
  if (a_realFuncVal->get_str())
    {
      if (!findString("str", realFuncValAtts))
	{warnAtt("str", "realFuncVal", a_realFuncVal);}
      else
        check_stringVal(a_realFuncVal->get_str());
    }
}

/********************************************************************/

void check_realFuncVdot(
 realFuncVdot * a_realFuncVdot)
{
  if (a_realFuncVdot->get_v1())
    {
      if (!findString("v1", realFuncVdotAtts))
	{warnAtt("v1", "realFuncVdot", a_realFuncVdot);}
      else
        check_vectorVal(a_realFuncVdot->get_v1());
    }
  if (a_realFuncVdot->get_v2())
    {
      if (!findString("v2", realFuncVdotAtts))
	{warnAtt("v2", "realFuncVdot", a_realFuncVdot);}
      else
        check_vectorVal(a_realFuncVdot->get_v2());
    }
}

/********************************************************************/

void check_realFuncVecX(
 realFuncVecX * a_realFuncVecX)
{
  if (a_realFuncVecX->get_vectorVal())
    {
      if (!findString("a_vectorVal", realFuncVecXAtts))
	{warnAtt("a_vectorVal", "realFuncVecX", a_realFuncVecX);}
      else
        check_vectorVal(a_realFuncVecX->get_vectorVal());
    }
}

/********************************************************************/

void check_realFuncVecY(
 realFuncVecY * a_realFuncVecY)
{
  if (a_realFuncVecY->get_vectorVal())
    {
      if (!findString("a_vectorVal", realFuncVecYAtts))
	{warnAtt("a_vectorVal", "realFuncVecY", a_realFuncVecY);}
      else
        check_vectorVal(a_realFuncVecY->get_vectorVal());
    }
}

/********************************************************************/

void check_realFuncVecZ(
 realFuncVecZ * a_realFuncVecZ)
{
  if (a_realFuncVecZ->get_vectorVal())
    {
      if (!findString("a_vectorVal", realFuncVecZAtts))
	{warnAtt("a_vectorVal", "realFuncVecZ", a_realFuncVecZ);}
      else
        check_vectorVal(a_realFuncVecZ->get_vectorVal());
    }
}

/********************************************************************/

void check_realFuncVmag(
 realFuncVmag * a_realFuncVmag)
{
  if (a_realFuncVmag->get_vectorVal())
    {
      if (!findString("a_vectorVal", realFuncVmagAtts))
	{warnAtt("a_vectorVal", "realFuncVmag", a_realFuncVmag);}
      else
        check_vectorVal(a_realFuncVmag->get_vectorVal());
    }
}

/********************************************************************/

void check_realIntExpr(
 realIntExpr * a_realIntExpr)
{
  if (isA(a_realIntExpr, realIntExpr_PLUS))
    {
      if (!findString("realIntExpr_PLUS", realIntExprSubs))
        {warnSub("realIntExpr_PLUS", "realIntExpr", a_realIntExpr);}
      else
        check_realIntExpr_PLUS(dynamic_cast<realIntExpr_PLUS *>(a_realIntExpr));
      return;
    }
  if (isA(a_realIntExpr, realIntExpr_MINUS))
    {
      if (!findString("realIntExpr_MINUS", realIntExprSubs))
        {warnSub("realIntExpr_MINUS", "realIntExpr", a_realIntExpr);}
      else
        check_realIntExpr_MINUS(dynamic_cast<realIntExpr_MINUS *>(a_realIntExpr));
      return;
    }
  if (isA(a_realIntExpr, realIntExpr_TIMES))
    {
      if (!findString("realIntExpr_TIMES", realIntExprSubs))
        {warnSub("realIntExpr_TIMES", "realIntExpr", a_realIntExpr);}
      else
        check_realIntExpr_TIMES(dynamic_cast<realIntExpr_TIMES *>(a_realIntExpr));
      return;
    }
  if (isA(a_realIntExpr, realIntExpr_DIVID))
    {
      if (!findString("realIntExpr_DIVID", realIntExprSubs))
        {warnSub("realIntExpr_DIVID", "realIntExpr", a_realIntExpr);}
      else
        check_realIntExpr_DIVID(dynamic_cast<realIntExpr_DIVID *>(a_realIntExpr));
      return;
    }
  if (isA(a_realIntExpr, realIntExpr_POWER))
    {
      if (!findString("realIntExpr_POWER", realIntExprSubs))
        {warnSub("realIntExpr_POWER", "realIntExpr", a_realIntExpr);}
      else
        check_realIntExpr_POWER(dynamic_cast<realIntExpr_POWER *>(a_realIntExpr));
      return;
    }
}

/********************************************************************/

void check_realIntExpr_DIVID(
 realIntExpr_DIVID * a_realIntExpr_DIVID)
{
  if (a_realIntExpr_DIVID->get_dvend())
    {
      if (!findString("dvend", realIntExpr_DIVIDAtts))
	{warnAtt("dvend", "realIntExpr_DIVID", a_realIntExpr_DIVID);}
      else
        check_realVal(a_realIntExpr_DIVID->get_dvend());
    }
  if (a_realIntExpr_DIVID->get_dvisr())
    {
      if (!findString("dvisr", realIntExpr_DIVIDAtts))
	{warnAtt("dvisr", "realIntExpr_DIVID", a_realIntExpr_DIVID);}
      else
        check_intVal(a_realIntExpr_DIVID->get_dvisr());
    }
}

/********************************************************************/

void check_realIntExpr_MINUS(
 realIntExpr_MINUS * a_realIntExpr_MINUS)
{
  if (a_realIntExpr_MINUS->get_term1())
    {
      if (!findString("term1", realIntExpr_MINUSAtts))
	{warnAtt("term1", "realIntExpr_MINUS", a_realIntExpr_MINUS);}
      else
        check_realVal(a_realIntExpr_MINUS->get_term1());
    }
  if (a_realIntExpr_MINUS->get_term2())
    {
      if (!findString("term2", realIntExpr_MINUSAtts))
	{warnAtt("term2", "realIntExpr_MINUS", a_realIntExpr_MINUS);}
      else
        check_intVal(a_realIntExpr_MINUS->get_term2());
    }
}

/********************************************************************/

void check_realIntExpr_PLUS(
 realIntExpr_PLUS * a_realIntExpr_PLUS)
{
  if (a_realIntExpr_PLUS->get_term1())
    {
      if (!findString("term1", realIntExpr_PLUSAtts))
	{warnAtt("term1", "realIntExpr_PLUS", a_realIntExpr_PLUS);}
      else
        check_realVal(a_realIntExpr_PLUS->get_term1());
    }
  if (a_realIntExpr_PLUS->get_term2())
    {
      if (!findString("term2", realIntExpr_PLUSAtts))
	{warnAtt("term2", "realIntExpr_PLUS", a_realIntExpr_PLUS);}
      else
        check_intVal(a_realIntExpr_PLUS->get_term2());
    }
}

/********************************************************************/

void check_realIntExpr_POWER(
 realIntExpr_POWER * a_realIntExpr_POWER)
{
  if (a_realIntExpr_POWER->get_base())
    {
      if (!findString("base", realIntExpr_POWERAtts))
	{warnAtt("base", "realIntExpr_POWER", a_realIntExpr_POWER);}
      else
        check_realVal(a_realIntExpr_POWER->get_base());
    }
  if (a_realIntExpr_POWER->get_expon())
    {
      if (!findString("expon", realIntExpr_POWERAtts))
	{warnAtt("expon", "realIntExpr_POWER", a_realIntExpr_POWER);}
      else
        check_intVal(a_realIntExpr_POWER->get_expon());
    }
}

/********************************************************************/

void check_realIntExpr_TIMES(
 realIntExpr_TIMES * a_realIntExpr_TIMES)
{
  if (a_realIntExpr_TIMES->get_term1())
    {
      if (!findString("term1", realIntExpr_TIMESAtts))
	{warnAtt("term1", "realIntExpr_TIMES", a_realIntExpr_TIMES);}
      else
        check_realVal(a_realIntExpr_TIMES->get_term1());
    }
  if (a_realIntExpr_TIMES->get_term2())
    {
      if (!findString("term2", realIntExpr_TIMESAtts))
	{warnAtt("term2", "realIntExpr_TIMES", a_realIntExpr_TIMES);}
      else
        check_intVal(a_realIntExpr_TIMES->get_term2());
    }
}

/********************************************************************/

void check_realIntRel(
 realIntRel * a_realIntRel)
{
  if (isA(a_realIntRel, realIntRel_EQ))
    {
      if (!findString("realIntRel_EQ", realIntRelSubs))
        {warnSub("realIntRel_EQ", "realIntRel", a_realIntRel);}
      else
        check_realIntRel_EQ(dynamic_cast<realIntRel_EQ *>(a_realIntRel));
      return;
    }
  if (isA(a_realIntRel, realIntRel_NE))
    {
      if (!findString("realIntRel_NE", realIntRelSubs))
        {warnSub("realIntRel_NE", "realIntRel", a_realIntRel);}
      else
        check_realIntRel_NE(dynamic_cast<realIntRel_NE *>(a_realIntRel));
      return;
    }
  if (isA(a_realIntRel, realIntRel_LT))
    {
      if (!findString("realIntRel_LT", realIntRelSubs))
        {warnSub("realIntRel_LT", "realIntRel", a_realIntRel);}
      else
        check_realIntRel_LT(dynamic_cast<realIntRel_LT *>(a_realIntRel));
      return;
    }
  if (isA(a_realIntRel, realIntRel_LE))
    {
      if (!findString("realIntRel_LE", realIntRelSubs))
        {warnSub("realIntRel_LE", "realIntRel", a_realIntRel);}
      else
        check_realIntRel_LE(dynamic_cast<realIntRel_LE *>(a_realIntRel));
      return;
    }
  if (isA(a_realIntRel, realIntRel_GT))
    {
      if (!findString("realIntRel_GT", realIntRelSubs))
        {warnSub("realIntRel_GT", "realIntRel", a_realIntRel);}
      else
        check_realIntRel_GT(dynamic_cast<realIntRel_GT *>(a_realIntRel));
      return;
    }
  if (isA(a_realIntRel, realIntRel_GE))
    {
      if (!findString("realIntRel_GE", realIntRelSubs))
        {warnSub("realIntRel_GE", "realIntRel", a_realIntRel);}
      else
        check_realIntRel_GE(dynamic_cast<realIntRel_GE *>(a_realIntRel));
      return;
    }
}

/********************************************************************/

void check_realIntRel_EQ(
 realIntRel_EQ * a_realIntRel_EQ)
{
  if (a_realIntRel_EQ->get_left())
    {
      if (!findString("left", realIntRel_EQAtts))
	{warnAtt("left", "realIntRel_EQ", a_realIntRel_EQ);}
      else
        check_realVal(a_realIntRel_EQ->get_left());
    }
  if (a_realIntRel_EQ->get_right())
    {
      if (!findString("right", realIntRel_EQAtts))
	{warnAtt("right", "realIntRel_EQ", a_realIntRel_EQ);}
      else
        check_intVal(a_realIntRel_EQ->get_right());
    }
}

/********************************************************************/

void check_realIntRel_GE(
 realIntRel_GE * a_realIntRel_GE)
{
  if (a_realIntRel_GE->get_left())
    {
      if (!findString("left", realIntRel_GEAtts))
	{warnAtt("left", "realIntRel_GE", a_realIntRel_GE);}
      else
        check_realVal(a_realIntRel_GE->get_left());
    }
  if (a_realIntRel_GE->get_right())
    {
      if (!findString("right", realIntRel_GEAtts))
	{warnAtt("right", "realIntRel_GE", a_realIntRel_GE);}
      else
        check_intVal(a_realIntRel_GE->get_right());
    }
}

/********************************************************************/

void check_realIntRel_GT(
 realIntRel_GT * a_realIntRel_GT)
{
  if (a_realIntRel_GT->get_left())
    {
      if (!findString("left", realIntRel_GTAtts))
	{warnAtt("left", "realIntRel_GT", a_realIntRel_GT);}
      else
        check_realVal(a_realIntRel_GT->get_left());
    }
  if (a_realIntRel_GT->get_right())
    {
      if (!findString("right", realIntRel_GTAtts))
	{warnAtt("right", "realIntRel_GT", a_realIntRel_GT);}
      else
        check_intVal(a_realIntRel_GT->get_right());
    }
}

/********************************************************************/

void check_realIntRel_LE(
 realIntRel_LE * a_realIntRel_LE)
{
  if (a_realIntRel_LE->get_left())
    {
      if (!findString("left", realIntRel_LEAtts))
	{warnAtt("left", "realIntRel_LE", a_realIntRel_LE);}
      else
        check_realVal(a_realIntRel_LE->get_left());
    }
  if (a_realIntRel_LE->get_right())
    {
      if (!findString("right", realIntRel_LEAtts))
	{warnAtt("right", "realIntRel_LE", a_realIntRel_LE);}
      else
        check_intVal(a_realIntRel_LE->get_right());
    }
}

/********************************************************************/

void check_realIntRel_LT(
 realIntRel_LT * a_realIntRel_LT)
{
  if (a_realIntRel_LT->get_left())
    {
      if (!findString("left", realIntRel_LTAtts))
	{warnAtt("left", "realIntRel_LT", a_realIntRel_LT);}
      else
        check_realVal(a_realIntRel_LT->get_left());
    }
  if (a_realIntRel_LT->get_right())
    {
      if (!findString("right", realIntRel_LTAtts))
	{warnAtt("right", "realIntRel_LT", a_realIntRel_LT);}
      else
        check_intVal(a_realIntRel_LT->get_right());
    }
}

/********************************************************************/

void check_realIntRel_NE(
 realIntRel_NE * a_realIntRel_NE)
{
  if (a_realIntRel_NE->get_left())
    {
      if (!findString("left", realIntRel_NEAtts))
	{warnAtt("left", "realIntRel_NE", a_realIntRel_NE);}
      else
        check_realVal(a_realIntRel_NE->get_left());
    }
  if (a_realIntRel_NE->get_right())
    {
      if (!findString("right", realIntRel_NEAtts))
	{warnAtt("right", "realIntRel_NE", a_realIntRel_NE);}
      else
        check_intVal(a_realIntRel_NE->get_right());
    }
}

/********************************************************************/

void check_realRealExpr(
 realRealExpr * a_realRealExpr)
{
  if (isA(a_realRealExpr, realRealExpr_PLUS))
    {
      if (!findString("realRealExpr_PLUS", realRealExprSubs))
        {warnSub("realRealExpr_PLUS", "realRealExpr", a_realRealExpr);}
      else
        check_realRealExpr_PLUS(dynamic_cast<realRealExpr_PLUS *>(a_realRealExpr));
      return;
    }
  if (isA(a_realRealExpr, realRealExpr_MINUS))
    {
      if (!findString("realRealExpr_MINUS", realRealExprSubs))
        {warnSub("realRealExpr_MINUS", "realRealExpr", a_realRealExpr);}
      else
        check_realRealExpr_MINUS(dynamic_cast<realRealExpr_MINUS *>(a_realRealExpr));
      return;
    }
  if (isA(a_realRealExpr, realRealExpr_TIMES))
    {
      if (!findString("realRealExpr_TIMES", realRealExprSubs))
        {warnSub("realRealExpr_TIMES", "realRealExpr", a_realRealExpr);}
      else
        check_realRealExpr_TIMES(dynamic_cast<realRealExpr_TIMES *>(a_realRealExpr));
      return;
    }
  if (isA(a_realRealExpr, realRealExpr_DIVID))
    {
      if (!findString("realRealExpr_DIVID", realRealExprSubs))
        {warnSub("realRealExpr_DIVID", "realRealExpr", a_realRealExpr);}
      else
        check_realRealExpr_DIVID(dynamic_cast<realRealExpr_DIVID *>(a_realRealExpr));
      return;
    }
  if (isA(a_realRealExpr, realRealExpr_POWER))
    {
      if (!findString("realRealExpr_POWER", realRealExprSubs))
        {warnSub("realRealExpr_POWER", "realRealExpr", a_realRealExpr);}
      else
        check_realRealExpr_POWER(dynamic_cast<realRealExpr_POWER *>(a_realRealExpr));
      return;
    }
}

/********************************************************************/

void check_realRealExpr_DIVID(
 realRealExpr_DIVID * a_realRealExpr_DIVID)
{
  if (a_realRealExpr_DIVID->get_dvend())
    {
      if (!findString("dvend", realRealExpr_DIVIDAtts))
	{warnAtt("dvend", "realRealExpr_DIVID", a_realRealExpr_DIVID);}
      else
        check_realVal(a_realRealExpr_DIVID->get_dvend());
    }
  if (a_realRealExpr_DIVID->get_dvisr())
    {
      if (!findString("dvisr", realRealExpr_DIVIDAtts))
	{warnAtt("dvisr", "realRealExpr_DIVID", a_realRealExpr_DIVID);}
      else
        check_realVal(a_realRealExpr_DIVID->get_dvisr());
    }
}

/********************************************************************/

void check_realRealExpr_MINUS(
 realRealExpr_MINUS * a_realRealExpr_MINUS)
{
  if (a_realRealExpr_MINUS->get_term1())
    {
      if (!findString("term1", realRealExpr_MINUSAtts))
	{warnAtt("term1", "realRealExpr_MINUS", a_realRealExpr_MINUS);}
      else
        check_realVal(a_realRealExpr_MINUS->get_term1());
    }
  if (a_realRealExpr_MINUS->get_term2())
    {
      if (!findString("term2", realRealExpr_MINUSAtts))
	{warnAtt("term2", "realRealExpr_MINUS", a_realRealExpr_MINUS);}
      else
        check_realVal(a_realRealExpr_MINUS->get_term2());
    }
}

/********************************************************************/

void check_realRealExpr_PLUS(
 realRealExpr_PLUS * a_realRealExpr_PLUS)
{
  if (a_realRealExpr_PLUS->get_term1())
    {
      if (!findString("term1", realRealExpr_PLUSAtts))
	{warnAtt("term1", "realRealExpr_PLUS", a_realRealExpr_PLUS);}
      else
        check_realVal(a_realRealExpr_PLUS->get_term1());
    }
  if (a_realRealExpr_PLUS->get_term2())
    {
      if (!findString("term2", realRealExpr_PLUSAtts))
	{warnAtt("term2", "realRealExpr_PLUS", a_realRealExpr_PLUS);}
      else
        check_realVal(a_realRealExpr_PLUS->get_term2());
    }
}

/********************************************************************/

void check_realRealExpr_POWER(
 realRealExpr_POWER * a_realRealExpr_POWER)
{
  if (a_realRealExpr_POWER->get_base())
    {
      if (!findString("base", realRealExpr_POWERAtts))
	{warnAtt("base", "realRealExpr_POWER", a_realRealExpr_POWER);}
      else
        check_realVal(a_realRealExpr_POWER->get_base());
    }
  if (a_realRealExpr_POWER->get_expon())
    {
      if (!findString("expon", realRealExpr_POWERAtts))
	{warnAtt("expon", "realRealExpr_POWER", a_realRealExpr_POWER);}
      else
        check_realVal(a_realRealExpr_POWER->get_expon());
    }
}

/********************************************************************/

void check_realRealExpr_TIMES(
 realRealExpr_TIMES * a_realRealExpr_TIMES)
{
  if (a_realRealExpr_TIMES->get_term1())
    {
      if (!findString("term1", realRealExpr_TIMESAtts))
	{warnAtt("term1", "realRealExpr_TIMES", a_realRealExpr_TIMES);}
      else
        check_realVal(a_realRealExpr_TIMES->get_term1());
    }
  if (a_realRealExpr_TIMES->get_term2())
    {
      if (!findString("term2", realRealExpr_TIMESAtts))
	{warnAtt("term2", "realRealExpr_TIMES", a_realRealExpr_TIMES);}
      else
        check_realVal(a_realRealExpr_TIMES->get_term2());
    }
}

/********************************************************************/

void check_realRealRel(
 realRealRel * a_realRealRel)
{
  if (isA(a_realRealRel, realRealRel_EQ))
    {
      if (!findString("realRealRel_EQ", realRealRelSubs))
        {warnSub("realRealRel_EQ", "realRealRel", a_realRealRel);}
      else
        check_realRealRel_EQ(dynamic_cast<realRealRel_EQ *>(a_realRealRel));
      return;
    }
  if (isA(a_realRealRel, realRealRel_NE))
    {
      if (!findString("realRealRel_NE", realRealRelSubs))
        {warnSub("realRealRel_NE", "realRealRel", a_realRealRel);}
      else
        check_realRealRel_NE(dynamic_cast<realRealRel_NE *>(a_realRealRel));
      return;
    }
  if (isA(a_realRealRel, realRealRel_LT))
    {
      if (!findString("realRealRel_LT", realRealRelSubs))
        {warnSub("realRealRel_LT", "realRealRel", a_realRealRel);}
      else
        check_realRealRel_LT(dynamic_cast<realRealRel_LT *>(a_realRealRel));
      return;
    }
  if (isA(a_realRealRel, realRealRel_LE))
    {
      if (!findString("realRealRel_LE", realRealRelSubs))
        {warnSub("realRealRel_LE", "realRealRel", a_realRealRel);}
      else
        check_realRealRel_LE(dynamic_cast<realRealRel_LE *>(a_realRealRel));
      return;
    }
  if (isA(a_realRealRel, realRealRel_GT))
    {
      if (!findString("realRealRel_GT", realRealRelSubs))
        {warnSub("realRealRel_GT", "realRealRel", a_realRealRel);}
      else
        check_realRealRel_GT(dynamic_cast<realRealRel_GT *>(a_realRealRel));
      return;
    }
  if (isA(a_realRealRel, realRealRel_GE))
    {
      if (!findString("realRealRel_GE", realRealRelSubs))
        {warnSub("realRealRel_GE", "realRealRel", a_realRealRel);}
      else
        check_realRealRel_GE(dynamic_cast<realRealRel_GE *>(a_realRealRel));
      return;
    }
}

/********************************************************************/

void check_realRealRel_EQ(
 realRealRel_EQ * a_realRealRel_EQ)
{
  if (a_realRealRel_EQ->get_left())
    {
      if (!findString("left", realRealRel_EQAtts))
	{warnAtt("left", "realRealRel_EQ", a_realRealRel_EQ);}
      else
        check_realVal(a_realRealRel_EQ->get_left());
    }
  if (a_realRealRel_EQ->get_right())
    {
      if (!findString("right", realRealRel_EQAtts))
	{warnAtt("right", "realRealRel_EQ", a_realRealRel_EQ);}
      else
        check_realVal(a_realRealRel_EQ->get_right());
    }
}

/********************************************************************/

void check_realRealRel_GE(
 realRealRel_GE * a_realRealRel_GE)
{
  if (a_realRealRel_GE->get_left())
    {
      if (!findString("left", realRealRel_GEAtts))
	{warnAtt("left", "realRealRel_GE", a_realRealRel_GE);}
      else
        check_realVal(a_realRealRel_GE->get_left());
    }
  if (a_realRealRel_GE->get_right())
    {
      if (!findString("right", realRealRel_GEAtts))
	{warnAtt("right", "realRealRel_GE", a_realRealRel_GE);}
      else
        check_realVal(a_realRealRel_GE->get_right());
    }
}

/********************************************************************/

void check_realRealRel_GT(
 realRealRel_GT * a_realRealRel_GT)
{
  if (a_realRealRel_GT->get_left())
    {
      if (!findString("left", realRealRel_GTAtts))
	{warnAtt("left", "realRealRel_GT", a_realRealRel_GT);}
      else
        check_realVal(a_realRealRel_GT->get_left());
    }
  if (a_realRealRel_GT->get_right())
    {
      if (!findString("right", realRealRel_GTAtts))
	{warnAtt("right", "realRealRel_GT", a_realRealRel_GT);}
      else
        check_realVal(a_realRealRel_GT->get_right());
    }
}

/********************************************************************/

void check_realRealRel_LE(
 realRealRel_LE * a_realRealRel_LE)
{
  if (a_realRealRel_LE->get_left())
    {
      if (!findString("left", realRealRel_LEAtts))
	{warnAtt("left", "realRealRel_LE", a_realRealRel_LE);}
      else
        check_realVal(a_realRealRel_LE->get_left());
    }
  if (a_realRealRel_LE->get_right())
    {
      if (!findString("right", realRealRel_LEAtts))
	{warnAtt("right", "realRealRel_LE", a_realRealRel_LE);}
      else
        check_realVal(a_realRealRel_LE->get_right());
    }
}

/********************************************************************/

void check_realRealRel_LT(
 realRealRel_LT * a_realRealRel_LT)
{
  if (a_realRealRel_LT->get_left())
    {
      if (!findString("left", realRealRel_LTAtts))
	{warnAtt("left", "realRealRel_LT", a_realRealRel_LT);}
      else
        check_realVal(a_realRealRel_LT->get_left());
    }
  if (a_realRealRel_LT->get_right())
    {
      if (!findString("right", realRealRel_LTAtts))
	{warnAtt("right", "realRealRel_LT", a_realRealRel_LT);}
      else
        check_realVal(a_realRealRel_LT->get_right());
    }
}

/********************************************************************/

void check_realRealRel_NE(
 realRealRel_NE * a_realRealRel_NE)
{
  if (a_realRealRel_NE->get_left())
    {
      if (!findString("left", realRealRel_NEAtts))
	{warnAtt("left", "realRealRel_NE", a_realRealRel_NE);}
      else
        check_realVal(a_realRealRel_NE->get_left());
    }
  if (a_realRealRel_NE->get_right())
    {
      if (!findString("right", realRealRel_NEAtts))
	{warnAtt("right", "realRealRel_NE", a_realRealRel_NE);}
      else
        check_realVal(a_realRealRel_NE->get_right());
    }
}

/********************************************************************/

void check_realRel(
 realRel * a_realRel)
{
  if (isA(a_realRel, realRealRel))
    {
      if (!findString("realRealRel", realRelSubs))
        {warnSub("realRealRel", "realRel", a_realRel);}
      else
        check_realRealRel(dynamic_cast<realRealRel *>(a_realRel));
      return;
    }
  if (isA(a_realRel, realIntRel))
    {
      if (!findString("realIntRel", realRelSubs))
        {warnSub("realIntRel", "realRel", a_realRel);}
      else
        check_realIntRel(dynamic_cast<realIntRel *>(a_realRel));
      return;
    }
  if (isA(a_realRel, intRealRel))
    {
      if (!findString("intRealRel", realRelSubs))
        {warnSub("intRealRel", "realRel", a_realRel);}
      else
        check_intRealRel(dynamic_cast<intRealRel *>(a_realRel));
      return;
    }
}

/********************************************************************/

void check_realVal(
 realVal * a_realVal)
{
  if (isA(a_realVal, realConst))
    {
      if (!findString("realConst", realValSubs))
        {warnSub("realConst", "realVal", a_realVal);}
      else
        check_realConst(dynamic_cast<realConst *>(a_realVal));
      return;
    }
  if (isA(a_realVal, realExpr))
    {
      if (!findString("realExpr", realValSubs))
        {warnSub("realExpr", "realVal", a_realVal);}
      else
        check_realExpr(dynamic_cast<realExpr *>(a_realVal));
      return;
    }
  if (isA(a_realVal, realFunc))
    {
      if (!findString("realFunc", realValSubs))
        {warnSub("realFunc", "realVal", a_realVal);}
      else
        check_realFunc(dynamic_cast<realFunc *>(a_realVal));
      return;
    }
  if (isA(a_realVal, realVar))
    {
      if (!findString("realVar", realValSubs))
        {warnSub("realVar", "realVal", a_realVal);}
      else
        check_realVar(dynamic_cast<realVar *>(a_realVal));
      return;
    }
}

/********************************************************************/

void check_realVar(
 realVar * a_realVar)
{
  if (a_realVar->get_string())
    {
      if (!findString("a_string", realVarAtts))
	{warnAtt("a_string", "realVar", a_realVar);}
    }
  if (a_realVar->get_arrayIndex())
    {
      if (!findString("a_arrayIndex", realVarAtts))
	{warnAtt("a_arrayIndex", "realVar", a_realVar);}
      else
        check_arrayIndex(a_realVar->get_arrayIndex());
    }
}

/********************************************************************/

void check_realVecExpr_TIMES(
 realVecExpr_TIMES * a_realVecExpr_TIMES)
{
  if (a_realVecExpr_TIMES->get_term1())
    {
      if (!findString("term1", realVecExpr_TIMESAtts))
	{warnAtt("term1", "realVecExpr_TIMES", a_realVecExpr_TIMES);}
      else
        check_realVal(a_realVecExpr_TIMES->get_term1());
    }
  if (a_realVecExpr_TIMES->get_term2())
    {
      if (!findString("term2", realVecExpr_TIMESAtts))
	{warnAtt("term2", "realVecExpr_TIMES", a_realVecExpr_TIMES);}
      else
        check_vectorVal(a_realVecExpr_TIMES->get_term2());
    }
}

/********************************************************************/

void check_recallDMLStm(
 recallDMLStm * a_recallDMLStm)
{
  if (a_recallDMLStm->get_didLabel())
    {
      if (!findString("a_didLabel", recallDMLStmAtts))
	{warnAtt("a_didLabel", "recallDMLStm", a_recallDMLStm);}
      else
        check_didLabel(a_recallDMLStm->get_didLabel());
    }
  if (a_recallDMLStm->get_daLabel())
    {
      if (!findString("a_daLabel", recallDMLStmAtts))
	{warnAtt("a_daLabel", "recallDMLStm", a_recallDMLStm);}
      else
        check_daLabel(a_recallDMLStm->get_daLabel());
    }
}

/********************************************************************/

void check_recallDatumStm(
 recallDatumStm * a_recallDatumStm)
{
  if (a_recallDatumStm->get_datumLabel2())
    {
      if (!findString("a_datumLabel2", recallDatumStmAtts))
	{warnAtt("a_datumLabel2", "recallDatumStm", a_recallDatumStm);}
      else
        check_datumLabel2(a_recallDatumStm->get_datumLabel2());
    }
  if (a_recallDatumStm->get_didLabel())
    {
      if (!findString("a_didLabel", recallDatumStmAtts))
	{warnAtt("a_didLabel", "recallDatumStm", a_recallDatumStm);}
      else
        check_didLabel(a_recallDatumStm->get_didLabel());
    }
}

/********************************************************************/

void check_recallFeatureStm(
 recallFeatureStm * a_recallFeatureStm)
{
  if (a_recallFeatureStm->get_faLabel())
    {
      if (!findString("a_faLabel", recallFeatureStmAtts))
	{warnAtt("a_faLabel", "recallFeatureStm", a_recallFeatureStm);}
      else
        check_faLabel(a_recallFeatureStm->get_faLabel());
    }
  if (a_recallFeatureStm->get_didLabel())
    {
      if (!findString("a_didLabel", recallFeatureStmAtts))
	{warnAtt("a_didLabel", "recallFeatureStm", a_recallFeatureStm);}
      else
        check_didLabel(a_recallFeatureStm->get_didLabel());
    }
}

/********************************************************************/

void check_recallRotaryTableStm(
 recallRotaryTableStm * a_recallRotaryTableStm)
{
  if (a_recallRotaryTableStm->get_rtLabel())
    {
      if (!findString("a_rtLabel", recallRotaryTableStmAtts))
	{warnAtt("a_rtLabel", "recallRotaryTableStm", a_recallRotaryTableStm);}
      else
        check_rtLabel(a_recallRotaryTableStm->get_rtLabel());
    }
  if (a_recallRotaryTableStm->get_didLabel())
    {
      if (!findString("a_didLabel", recallRotaryTableStmAtts))
	{warnAtt("a_didLabel", "recallRotaryTableStm", a_recallRotaryTableStm);}
      else
        check_didLabel(a_recallRotaryTableStm->get_didLabel());
    }
}

/********************************************************************/

void check_recallSensorStm(
 recallSensorStm * a_recallSensorStm)
{
  if (a_recallSensorStm->get_sensorLabel1())
    {
      if (!findString("a_sensorLabel1", recallSensorStmAtts))
	{warnAtt("a_sensorLabel1", "recallSensorStm", a_recallSensorStm);}
      else
        check_sensorLabel1(a_recallSensorStm->get_sensorLabel1());
    }
  if (a_recallSensorStm->get_didLabel())
    {
      if (!findString("a_didLabel", recallSensorStmAtts))
	{warnAtt("a_didLabel", "recallSensorStm", a_recallSensorStm);}
      else
        check_didLabel(a_recallSensorStm->get_didLabel());
    }
}

/********************************************************************/

void check_refmntStm(
 refmntStm * a_refmntStm)
{
  if (a_refmntStm->get_rmLabel())
    {
      if (!findString("a_rmLabel", refmntStmAtts))
	{warnAtt("a_rmLabel", "refmntStm", a_refmntStm);}
      else
        check_rmLabel(a_refmntStm->get_rmLabel());
    }
  if (a_refmntStm->get_xVec())
    {
      if (!findString("xVec", refmntStmAtts))
	{warnAtt("xVec", "refmntStm", a_refmntStm);}
      else
        check_vector(a_refmntStm->get_xVec());
    }
  if (a_refmntStm->get_zVec())
    {
      if (!findString("zVec", refmntStmAtts))
	{warnAtt("zVec", "refmntStm", a_refmntStm);}
      else
        check_vector(a_refmntStm->get_zVec());
    }
  if (a_refmntStm->get_offset())
    {
      if (!findString("offset", refmntStmAtts))
	{warnAtt("offset", "refmntStm", a_refmntStm);}
      else
        check_vector(a_refmntStm->get_offset());
    }
}

/********************************************************************/

void check_rentVal(
 rentVal * a_rentVal)
{
  if (isA(a_rentVal, realVal))
    {
      if (!findString("realVal", rentValSubs))
        {warnSub("realVal", "rentVal", a_rentVal);}
      else
        check_realVal(dynamic_cast<realVal *>(a_rentVal));
      return;
    }
  if (isA(a_rentVal, intVal))
    {
      if (!findString("intVal", rentValSubs))
        {warnSub("intVal", "rentVal", a_rentVal);}
      else
        check_intVal(dynamic_cast<intVal *>(a_rentVal));
      return;
    }
}

/********************************************************************/

void check_reportItem(
 reportItem * a_reportItem)
{
  if (isA(a_reportItem, reportItem_ALGOR))
    {
      if (!findString("reportItem_ALGOR", reportItemSubs))
        {warnSub("reportItem_ALGOR", "reportItem", a_reportItem);}
      return;
    }
  if (isA(a_reportItem, reportItem_DATE))
    {
      if (!findString("reportItem_DATE", reportItemSubs))
        {warnSub("reportItem_DATE", "reportItem", a_reportItem);}
      return;
    }
  if (isA(a_reportItem, reportItem_HUMID))
    {
      if (!findString("reportItem_HUMID", reportItemSubs))
        {warnSub("reportItem_HUMID", "reportItem", a_reportItem);}
      return;
    }
  if (isA(a_reportItem, reportItem_MODE))
    {
      if (!findString("reportItem_MODE", reportItemSubs))
        {warnSub("reportItem_MODE", "reportItem", a_reportItem);}
      return;
    }
  if (isA(a_reportItem, reportItem_TEMPC))
    {
      if (!findString("reportItem_TEMPC", reportItemSubs))
        {warnSub("reportItem_TEMPC", "reportItem", a_reportItem);}
      return;
    }
  if (isA(a_reportItem, reportItem_TEMPF))
    {
      if (!findString("reportItem_TEMPF", reportItemSubs))
        {warnSub("reportItem_TEMPF", "reportItem", a_reportItem);}
      return;
    }
  if (isA(a_reportItem, reportItem_TEMPWC))
    {
      if (!findString("reportItem_TEMPWC", reportItemSubs))
        {warnSub("reportItem_TEMPWC", "reportItem", a_reportItem);}
      return;
    }
  if (isA(a_reportItem, reportItem_TEMPWF))
    {
      if (!findString("reportItem_TEMPWF", reportItemSubs))
        {warnSub("reportItem_TEMPWF", "reportItem", a_reportItem);}
      return;
    }
  if (isA(a_reportItem, reportItem_TIME))
    {
      if (!findString("reportItem_TIME", reportItemSubs))
        {warnSub("reportItem_TIME", "reportItem", a_reportItem);}
      return;
    }
  if (isA(a_reportItem, reportItem_qisLabel))
    {
      if (!findString("reportItem_qisLabel", reportItemSubs))
        {warnSub("reportItem_qisLabel", "reportItem", a_reportItem);}
      else
        check_reportItem_qisLabel(dynamic_cast<reportItem_qisLabel *>(a_reportItem));
      return;
    }
}

/********************************************************************/

void check_reportItem_qisLabel(
 reportItem_qisLabel * a_reportItem_qisLabel)
{
  if (a_reportItem_qisLabel->get_qisLabel())
    {
      if (!findString("a_qisLabel", reportItem_qisLabelAtts))
	{warnAtt("a_qisLabel", "reportItem_qisLabel", a_reportItem_qisLabel);}
      else
        check_qisLabel(a_reportItem_qisLabel->get_qisLabel());
    }
}

/********************************************************************/

void check_reportStm(
 reportStm * a_reportStm)
{
  if (a_reportStm->get_rLabel())
    {
      if (!findString("a_rLabel", reportStmAtts))
	{warnAtt("a_rLabel", "reportStm", a_reportStm);}
      else
        check_rLabel(a_reportStm->get_rLabel());
    }
  if (a_reportStm->get_reportItemList())
    {
      if (!findString("a_reportItemList", reportStmAtts))
	{warnAtt("a_reportItemList", "reportStm", a_reportStm);}
      else
        {
          std::list<reportItem *> * theList;
          std::list<reportItem *>::iterator iter;
          theList = a_reportStm->get_reportItemList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_reportItem(*iter);
        }
    }
  if (a_reportStm->get_text())
    {
      if (!findString("text", reportStmAtts))
	{warnAtt("text", "reportStm", a_reportStm);}
      else
        check_stringVal(a_reportStm->get_text());
    }
}

/********************************************************************/

void check_resumeMinor(
 resumeMinor * a_resumeMinor)
{
  if (isA(a_resumeMinor, resumeMinor_jumpLabel))
    {
      if (!findString("resumeMinor_jumpLabel", resumeMinorSubs))
        {warnSub("resumeMinor_jumpLabel", "resumeMinor", a_resumeMinor);}
      else
        check_resumeMinor_jumpLabel(dynamic_cast<resumeMinor_jumpLabel *>(a_resumeMinor));
      return;
    }
  if (isA(a_resumeMinor, resumeMinor_CURENT))
    {
      if (!findString("resumeMinor_CURENT", resumeMinorSubs))
        {warnSub("resumeMinor_CURENT", "resumeMinor", a_resumeMinor);}
      return;
    }
  if (isA(a_resumeMinor, resumeMinor_END))
    {
      if (!findString("resumeMinor_END", resumeMinorSubs))
        {warnSub("resumeMinor_END", "resumeMinor", a_resumeMinor);}
      return;
    }
  if (isA(a_resumeMinor, resumeMinor_NEXT))
    {
      if (!findString("resumeMinor_NEXT", resumeMinorSubs))
        {warnSub("resumeMinor_NEXT", "resumeMinor", a_resumeMinor);}
      return;
    }
  if (isA(a_resumeMinor, resumeMinor_START))
    {
      if (!findString("resumeMinor_START", resumeMinorSubs))
        {warnSub("resumeMinor_START", "resumeMinor", a_resumeMinor);}
      return;
    }
  if (isA(a_resumeMinor, resumeMinor_STOP))
    {
      if (!findString("resumeMinor_STOP", resumeMinorSubs))
        {warnSub("resumeMinor_STOP", "resumeMinor", a_resumeMinor);}
      return;
    }
}

/********************************************************************/

void check_resumeMinor_jumpLabel(
 resumeMinor_jumpLabel * a_resumeMinor_jumpLabel)
{
  if (a_resumeMinor_jumpLabel->get_jumpLabel())
    {
      if (!findString("a_jumpLabel", resumeMinor_jumpLabelAtts))
	{warnAtt("a_jumpLabel", "resumeMinor_jumpLabel", a_resumeMinor_jumpLabel);}
      else
        check_jumpLabel(a_resumeMinor_jumpLabel->get_jumpLabel());
    }
}

/********************************************************************/

void check_resumeStm(
 resumeStm * a_resumeStm)
{
  if (a_resumeStm->get_resumeMinor())
    {
      if (!findString("a_resumeMinor", resumeStmAtts))
	{warnAtt("a_resumeMinor", "resumeStm", a_resumeStm);}
      else
        check_resumeMinor(a_resumeStm->get_resumeMinor());
    }
}

/********************************************************************/

void check_retrieve1(
 retrieve1 * a_retrieve1)
{
  if (a_retrieve1->get_searchRad())
    {
      if (!findString("searchRad", retrieve1Atts))
	{warnAtt("searchRad", "retrieve1", a_retrieve1);}
      else
        check_rentVal(a_retrieve1->get_searchRad());
    }
  if (a_retrieve1->get_featureActualList())
    {
      if (!findString("a_featureActualList", retrieve1Atts))
	{warnAtt("a_featureActualList", "retrieve1", a_retrieve1);}
      else
        {
          std::list<faLabel *> * theList;
          std::list<faLabel *>::iterator iter;
          theList = a_retrieve1->get_featureActualList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_faLabel(*iter);
        }
    }
}

/********************************************************************/

void check_retrieve2(
 retrieve2 * a_retrieve2)
{
  if (a_retrieve2->get_searchRad())
    {
      if (!findString("searchRad", retrieve2Atts))
	{warnAtt("searchRad", "retrieve2", a_retrieve2);}
      else
        check_rentVal(a_retrieve2->get_searchRad());
    }
  if (a_retrieve2->get_depth())
    {
      if (!findString("depth", retrieve2Atts))
	{warnAtt("depth", "retrieve2", a_retrieve2);}
      else
        check_rentVal(a_retrieve2->get_depth());
    }
  if (a_retrieve2->get_featureActualList())
    {
      if (!findString("a_featureActualList", retrieve2Atts))
	{warnAtt("a_featureActualList", "retrieve2", a_retrieve2);}
      else
        {
          std::list<faLabel *> * theList;
          std::list<faLabel *>::iterator iter;
          theList = a_retrieve2->get_featureActualList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_faLabel(*iter);
        }
    }
}

/********************************************************************/

void check_retrieve2b(
 retrieve2b * a_retrieve2b)
{
  if (a_retrieve2b->get_searchRad())
    {
      if (!findString("searchRad", retrieve2bAtts))
	{warnAtt("searchRad", "retrieve2b", a_retrieve2b);}
      else
        check_rentVal(a_retrieve2b->get_searchRad());
    }
  if (a_retrieve2b->get_axis())
    {
      if (!findString("axis", retrieve2bAtts))
	{warnAtt("axis", "retrieve2b", a_retrieve2b);}
      else
        check_vector(a_retrieve2b->get_axis());
    }
  if (a_retrieve2b->get_featureActualList())
    {
      if (!findString("a_featureActualList", retrieve2bAtts))
	{warnAtt("a_featureActualList", "retrieve2b", a_retrieve2b);}
      else
        {
          std::list<faLabel *> * theList;
          std::list<faLabel *>::iterator iter;
          theList = a_retrieve2b->get_featureActualList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_faLabel(*iter);
        }
    }
}

/********************************************************************/

void check_retrieve4(
 retrieve4 * a_retrieve4)
{
  if (a_retrieve4->get_dist())
    {
      if (!findString("dist", retrieve4Atts))
	{warnAtt("dist", "retrieve4", a_retrieve4);}
      else
        check_rentVal(a_retrieve4->get_dist());
    }
  if (a_retrieve4->get_patchRad())
    {
      if (!findString("patchRad", retrieve4Atts))
	{warnAtt("patchRad", "retrieve4", a_retrieve4);}
      else
        check_rentVal(a_retrieve4->get_patchRad());
    }
  if (a_retrieve4->get_depth())
    {
      if (!findString("depth", retrieve4Atts))
	{warnAtt("depth", "retrieve4", a_retrieve4);}
      else
        check_rentVal(a_retrieve4->get_depth());
    }
  if (a_retrieve4->get_searchRad())
    {
      if (!findString("searchRad", retrieve4Atts))
	{warnAtt("searchRad", "retrieve4", a_retrieve4);}
      else
        check_rentVal(a_retrieve4->get_searchRad());
    }
  if (a_retrieve4->get_featureActualList())
    {
      if (!findString("a_featureActualList", retrieve4Atts))
	{warnAtt("a_featureActualList", "retrieve4", a_retrieve4);}
      else
        {
          std::list<faLabel *> * theList;
          std::list<faLabel *>::iterator iter;
          theList = a_retrieve4->get_featureActualList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_faLabel(*iter);
        }
    }
}

/********************************************************************/

void check_rightyLefty(
 rightyLefty * a_rightyLefty)
{
  if (isA(a_rightyLefty, rightyLefty_RIGHTY))
    {
      if (!findString("rightyLefty_RIGHTY", rightyLeftySubs))
        {warnSub("rightyLefty_RIGHTY", "rightyLefty", a_rightyLefty);}
      return;
    }
  if (isA(a_rightyLefty, rightyLefty_LEFTY))
    {
      if (!findString("rightyLefty_LEFTY", rightyLeftySubs))
        {warnSub("rightyLefty_LEFTY", "rightyLefty", a_rightyLefty);}
      return;
    }
}

/********************************************************************/

void check_rmLabel(
 rmLabel * a_rmLabel)
{
  if (a_rmLabel->get_labelName())
    {
      if (!findString("a_labelName", rmLabelAtts))
	{warnAtt("a_labelName", "rmLabel", a_rmLabel);}
      else
        check_labelName(a_rmLabel->get_labelName());
    }
}

/********************************************************************/

void check_rmeasArc(
 rmeasArc * a_rmeasArc)
{
  if (isA(a_rmeasArc, rmeasArc_rmeasSpecFa))
    {
      if (!findString("rmeasArc_rmeasSpecFa", rmeasArcSubs))
        {warnSub("rmeasArc_rmeasSpecFa", "rmeasArc", a_rmeasArc);}
      else
        check_rmeasArc_rmeasSpecFa(dynamic_cast<rmeasArc_rmeasSpecFa *>(a_rmeasArc));
      return;
    }
  if (isA(a_rmeasArc, rmeasArc_rmeasSpecVecbld))
    {
      if (!findString("rmeasArc_rmeasSpecVecbld", rmeasArcSubs))
        {warnSub("rmeasArc_rmeasSpecVecbld", "rmeasArc", a_rmeasArc);}
      else
        check_rmeasArc_rmeasSpecVecbld(dynamic_cast<rmeasArc_rmeasSpecVecbld *>(a_rmeasArc));
      return;
    }
}

/********************************************************************/

void check_rmeasArc_rmeasSpecFa(
 rmeasArc_rmeasSpecFa * a_rmeasArc_rmeasSpecFa)
{
  if (a_rmeasArc_rmeasSpecFa->get_fLabel())
    {
      if (!findString("a_fLabel", rmeasArc_rmeasSpecFaAtts))
	{warnAtt("a_fLabel", "rmeasArc_rmeasSpecFa", a_rmeasArc_rmeasSpecFa);}
      else
        check_fLabel(a_rmeasArc_rmeasSpecFa->get_fLabel());
    }
  if (a_rmeasArc_rmeasSpecFa->get_numMeas())
    {
      if (!findString("numMeas", rmeasArc_rmeasSpecFaAtts))
	{warnAtt("numMeas", "rmeasArc_rmeasSpecFa", a_rmeasArc_rmeasSpecFa);}
      else
        check_intVal(a_rmeasArc_rmeasSpecFa->get_numMeas());
    }
  if (a_rmeasArc_rmeasSpecFa->get_rmeasSpecFa())
    {
      if (!findString("a_rmeasSpecFa", rmeasArc_rmeasSpecFaAtts))
	{warnAtt("a_rmeasSpecFa", "rmeasArc_rmeasSpecFa", a_rmeasArc_rmeasSpecFa);}
      else
        check_rmeasSpecFa(a_rmeasArc_rmeasSpecFa->get_rmeasSpecFa());
    }
}

/********************************************************************/

void check_rmeasArc_rmeasSpecVecbld(
 rmeasArc_rmeasSpecVecbld * a_rmeasArc_rmeasSpecVecbld)
{
  if (a_rmeasArc_rmeasSpecVecbld->get_fLabel())
    {
      if (!findString("a_fLabel", rmeasArc_rmeasSpecVecbldAtts))
	{warnAtt("a_fLabel", "rmeasArc_rmeasSpecVecbld", a_rmeasArc_rmeasSpecVecbld);}
      else
        check_fLabel(a_rmeasArc_rmeasSpecVecbld->get_fLabel());
    }
  if (a_rmeasArc_rmeasSpecVecbld->get_numMeas())
    {
      if (!findString("numMeas", rmeasArc_rmeasSpecVecbldAtts))
	{warnAtt("numMeas", "rmeasArc_rmeasSpecVecbld", a_rmeasArc_rmeasSpecVecbld);}
      else
        check_intVal(a_rmeasArc_rmeasSpecVecbld->get_numMeas());
    }
  if (a_rmeasArc_rmeasSpecVecbld->get_rmeasSpecVecbld())
    {
      if (!findString("a_rmeasSpecVecbld", rmeasArc_rmeasSpecVecbldAtts))
	{warnAtt("a_rmeasSpecVecbld", "rmeasArc_rmeasSpecVecbld", a_rmeasArc_rmeasSpecVecbld);}
      else
        check_rmeasSpecVecbld(a_rmeasArc_rmeasSpecVecbld->get_rmeasSpecVecbld());
    }
}

/********************************************************************/

void check_rmeasCircle(
 rmeasCircle * a_rmeasCircle)
{
  if (isA(a_rmeasCircle, rmeasCircle_rmeasSpecFa))
    {
      if (!findString("rmeasCircle_rmeasSpecFa", rmeasCircleSubs))
        {warnSub("rmeasCircle_rmeasSpecFa", "rmeasCircle", a_rmeasCircle);}
      else
        check_rmeasCircle_rmeasSpecFa(dynamic_cast<rmeasCircle_rmeasSpecFa *>(a_rmeasCircle));
      return;
    }
  if (isA(a_rmeasCircle, rmeasCircle_rmeasSpecVecbld))
    {
      if (!findString("rmeasCircle_rmeasSpecVecbld", rmeasCircleSubs))
        {warnSub("rmeasCircle_rmeasSpecVecbld", "rmeasCircle", a_rmeasCircle);}
      else
        check_rmeasCircle_rmeasSpecVecbld(dynamic_cast<rmeasCircle_rmeasSpecVecbld *>(a_rmeasCircle));
      return;
    }
}

/********************************************************************/

void check_rmeasCircle_rmeasSpecFa(
 rmeasCircle_rmeasSpecFa * a_rmeasCircle_rmeasSpecFa)
{
  if (a_rmeasCircle_rmeasSpecFa->get_fLabel())
    {
      if (!findString("a_fLabel", rmeasCircle_rmeasSpecFaAtts))
	{warnAtt("a_fLabel", "rmeasCircle_rmeasSpecFa", a_rmeasCircle_rmeasSpecFa);}
      else
        check_fLabel(a_rmeasCircle_rmeasSpecFa->get_fLabel());
    }
  if (a_rmeasCircle_rmeasSpecFa->get_numMeas())
    {
      if (!findString("numMeas", rmeasCircle_rmeasSpecFaAtts))
	{warnAtt("numMeas", "rmeasCircle_rmeasSpecFa", a_rmeasCircle_rmeasSpecFa);}
      else
        check_intVal(a_rmeasCircle_rmeasSpecFa->get_numMeas());
    }
  if (a_rmeasCircle_rmeasSpecFa->get_rmeasSpecFa())
    {
      if (!findString("a_rmeasSpecFa", rmeasCircle_rmeasSpecFaAtts))
	{warnAtt("a_rmeasSpecFa", "rmeasCircle_rmeasSpecFa", a_rmeasCircle_rmeasSpecFa);}
      else
        check_rmeasSpecFa(a_rmeasCircle_rmeasSpecFa->get_rmeasSpecFa());
    }
}

/********************************************************************/

void check_rmeasCircle_rmeasSpecVecbld(
 rmeasCircle_rmeasSpecVecbld * a_rmeasCircle_rmeasSpecVecbld)
{
  if (a_rmeasCircle_rmeasSpecVecbld->get_fLabel())
    {
      if (!findString("a_fLabel", rmeasCircle_rmeasSpecVecbldAtts))
	{warnAtt("a_fLabel", "rmeasCircle_rmeasSpecVecbld", a_rmeasCircle_rmeasSpecVecbld);}
      else
        check_fLabel(a_rmeasCircle_rmeasSpecVecbld->get_fLabel());
    }
  if (a_rmeasCircle_rmeasSpecVecbld->get_numMeas())
    {
      if (!findString("numMeas", rmeasCircle_rmeasSpecVecbldAtts))
	{warnAtt("numMeas", "rmeasCircle_rmeasSpecVecbld", a_rmeasCircle_rmeasSpecVecbld);}
      else
        check_intVal(a_rmeasCircle_rmeasSpecVecbld->get_numMeas());
    }
  if (a_rmeasCircle_rmeasSpecVecbld->get_rmeasSpecVecbld())
    {
      if (!findString("a_rmeasSpecVecbld", rmeasCircle_rmeasSpecVecbldAtts))
	{warnAtt("a_rmeasSpecVecbld", "rmeasCircle_rmeasSpecVecbld", a_rmeasCircle_rmeasSpecVecbld);}
      else
        check_rmeasSpecVecbld(a_rmeasCircle_rmeasSpecVecbld->get_rmeasSpecVecbld());
    }
}

/********************************************************************/

void check_rmeasCone(
 rmeasCone * a_rmeasCone)
{
  if (a_rmeasCone->get_fLabel())
    {
      if (!findString("a_fLabel", rmeasConeAtts))
	{warnAtt("a_fLabel", "rmeasCone", a_rmeasCone);}
      else
        check_fLabel(a_rmeasCone->get_fLabel());
    }
  if (a_rmeasCone->get_numMeas())
    {
      if (!findString("numMeas", rmeasConeAtts))
	{warnAtt("numMeas", "rmeasCone", a_rmeasCone);}
      else
        check_intVal(a_rmeasCone->get_numMeas());
    }
  if (a_rmeasCone->get_rmeasSpecFa())
    {
      if (!findString("a_rmeasSpecFa", rmeasConeAtts))
	{warnAtt("a_rmeasSpecFa", "rmeasCone", a_rmeasCone);}
      else
        check_rmeasSpecFa(a_rmeasCone->get_rmeasSpecFa());
    }
}

/********************************************************************/

void check_rmeasCparln(
 rmeasCparln * a_rmeasCparln)
{
  if (isA(a_rmeasCparln, rmeasCparln_rmeasSpecFaOrient))
    {
      if (!findString("rmeasCparln_rmeasSpecFaOrient", rmeasCparlnSubs))
        {warnSub("rmeasCparln_rmeasSpecFaOrient", "rmeasCparln", a_rmeasCparln);}
      else
        check_rmeasCparln_rmeasSpecFaOrient(dynamic_cast<rmeasCparln_rmeasSpecFaOrient *>(a_rmeasCparln));
      return;
    }
  if (isA(a_rmeasCparln, rmeasCparln_rmeasSpecVecbldOrient))
    {
      if (!findString("rmeasCparln_rmeasSpecVecbldOrient", rmeasCparlnSubs))
        {warnSub("rmeasCparln_rmeasSpecVecbldOrient", "rmeasCparln", a_rmeasCparln);}
      else
        check_rmeasCparln_rmeasSpecVecbldOrient(dynamic_cast<rmeasCparln_rmeasSpecVecbldOrient *>(a_rmeasCparln));
      return;
    }
}

/********************************************************************/

void check_rmeasCparln_rmeasSpecFaOrient(
 rmeasCparln_rmeasSpecFaOrient * a_rmeasCparln_rmeasSpecFaOrient)
{
  if (a_rmeasCparln_rmeasSpecFaOrient->get_fLabel())
    {
      if (!findString("a_fLabel", rmeasCparln_rmeasSpecFaOrientAtts))
	{warnAtt("a_fLabel", "rmeasCparln_rmeasSpecFaOrient", a_rmeasCparln_rmeasSpecFaOrient);}
      else
        check_fLabel(a_rmeasCparln_rmeasSpecFaOrient->get_fLabel());
    }
  if (a_rmeasCparln_rmeasSpecFaOrient->get_numMeas())
    {
      if (!findString("numMeas", rmeasCparln_rmeasSpecFaOrientAtts))
	{warnAtt("numMeas", "rmeasCparln_rmeasSpecFaOrient", a_rmeasCparln_rmeasSpecFaOrient);}
      else
        check_intVal(a_rmeasCparln_rmeasSpecFaOrient->get_numMeas());
    }
  if (a_rmeasCparln_rmeasSpecFaOrient->get_rmeasSpecFaOrient())
    {
      if (!findString("a_rmeasSpecFaOrient", rmeasCparln_rmeasSpecFaOrientAtts))
	{warnAtt("a_rmeasSpecFaOrient", "rmeasCparln_rmeasSpecFaOrient", a_rmeasCparln_rmeasSpecFaOrient);}
      else
        check_rmeasSpecFaOrient(a_rmeasCparln_rmeasSpecFaOrient->get_rmeasSpecFaOrient());
    }
}

/********************************************************************/

void check_rmeasCparln_rmeasSpecVecbldOrient(
 rmeasCparln_rmeasSpecVecbldOrient * a_rmeasCparln_rmeasSpecVecbldOrient)
{
  if (a_rmeasCparln_rmeasSpecVecbldOrient->get_fLabel())
    {
      if (!findString("a_fLabel", rmeasCparln_rmeasSpecVecbldOrientAtts))
	{warnAtt("a_fLabel", "rmeasCparln_rmeasSpecVecbldOrient", a_rmeasCparln_rmeasSpecVecbldOrient);}
      else
        check_fLabel(a_rmeasCparln_rmeasSpecVecbldOrient->get_fLabel());
    }
  if (a_rmeasCparln_rmeasSpecVecbldOrient->get_numMeas())
    {
      if (!findString("numMeas", rmeasCparln_rmeasSpecVecbldOrientAtts))
	{warnAtt("numMeas", "rmeasCparln_rmeasSpecVecbldOrient", a_rmeasCparln_rmeasSpecVecbldOrient);}
      else
        check_intVal(a_rmeasCparln_rmeasSpecVecbldOrient->get_numMeas());
    }
  if (a_rmeasCparln_rmeasSpecVecbldOrient->get_rmeasSpecVecbldOrient())
    {
      if (!findString("a_rmeasSpecVecbldOrient", rmeasCparln_rmeasSpecVecbldOrientAtts))
	{warnAtt("a_rmeasSpecVecbldOrient", "rmeasCparln_rmeasSpecVecbldOrient", a_rmeasCparln_rmeasSpecVecbldOrient);}
      else
        check_rmeasSpecVecbldOrient(a_rmeasCparln_rmeasSpecVecbldOrient->get_rmeasSpecVecbldOrient());
    }
}

/********************************************************************/

void check_rmeasCylndr(
 rmeasCylndr * a_rmeasCylndr)
{
  if (a_rmeasCylndr->get_fLabel())
    {
      if (!findString("a_fLabel", rmeasCylndrAtts))
	{warnAtt("a_fLabel", "rmeasCylndr", a_rmeasCylndr);}
      else
        check_fLabel(a_rmeasCylndr->get_fLabel());
    }
  if (a_rmeasCylndr->get_numMeas())
    {
      if (!findString("numMeas", rmeasCylndrAtts))
	{warnAtt("numMeas", "rmeasCylndr", a_rmeasCylndr);}
      else
        check_intVal(a_rmeasCylndr->get_numMeas());
    }
  if (a_rmeasCylndr->get_rmeasSpecFa())
    {
      if (!findString("a_rmeasSpecFa", rmeasCylndrAtts))
	{warnAtt("a_rmeasSpecFa", "rmeasCylndr", a_rmeasCylndr);}
      else
        check_rmeasSpecFa(a_rmeasCylndr->get_rmeasSpecFa());
    }
}

/********************************************************************/

void check_rmeasEdgept(
 rmeasEdgept * a_rmeasEdgept)
{
  if (isA(a_rmeasEdgept, rmeasEdgept_rmeasSpecFaAxis))
    {
      if (!findString("rmeasEdgept_rmeasSpecFaAxis", rmeasEdgeptSubs))
        {warnSub("rmeasEdgept_rmeasSpecFaAxis", "rmeasEdgept", a_rmeasEdgept);}
      else
        check_rmeasEdgept_rmeasSpecFaAxis(dynamic_cast<rmeasEdgept_rmeasSpecFaAxis *>(a_rmeasEdgept));
      return;
    }
  if (isA(a_rmeasEdgept, rmeasEdgept_rmeasSpecVecbldEdgept))
    {
      if (!findString("rmeasEdgept_rmeasSpecVecbldEdgept", rmeasEdgeptSubs))
        {warnSub("rmeasEdgept_rmeasSpecVecbldEdgept", "rmeasEdgept", a_rmeasEdgept);}
      else
        check_rmeasEdgept_rmeasSpecVecbldEdgept(dynamic_cast<rmeasEdgept_rmeasSpecVecbldEdgept *>(a_rmeasEdgept));
      return;
    }
}

/********************************************************************/

void check_rmeasEdgept_rmeasSpecFaAxis(
 rmeasEdgept_rmeasSpecFaAxis * a_rmeasEdgept_rmeasSpecFaAxis)
{
  if (a_rmeasEdgept_rmeasSpecFaAxis->get_fLabel())
    {
      if (!findString("a_fLabel", rmeasEdgept_rmeasSpecFaAxisAtts))
	{warnAtt("a_fLabel", "rmeasEdgept_rmeasSpecFaAxis", a_rmeasEdgept_rmeasSpecFaAxis);}
      else
        check_fLabel(a_rmeasEdgept_rmeasSpecFaAxis->get_fLabel());
    }
  if (a_rmeasEdgept_rmeasSpecFaAxis->get_numMeas())
    {
      if (!findString("numMeas", rmeasEdgept_rmeasSpecFaAxisAtts))
	{warnAtt("numMeas", "rmeasEdgept_rmeasSpecFaAxis", a_rmeasEdgept_rmeasSpecFaAxis);}
      else
        check_intVal(a_rmeasEdgept_rmeasSpecFaAxis->get_numMeas());
    }
  if (a_rmeasEdgept_rmeasSpecFaAxis->get_rmeasSpecFaAxis())
    {
      if (!findString("a_rmeasSpecFaAxis", rmeasEdgept_rmeasSpecFaAxisAtts))
	{warnAtt("a_rmeasSpecFaAxis", "rmeasEdgept_rmeasSpecFaAxis", a_rmeasEdgept_rmeasSpecFaAxis);}
      else
        check_rmeasSpecFaAxis(a_rmeasEdgept_rmeasSpecFaAxis->get_rmeasSpecFaAxis());
    }
}

/********************************************************************/

void check_rmeasEdgept_rmeasSpecVecbldEdgept(
 rmeasEdgept_rmeasSpecVecbldEdgept * a_rmeasEdgept_rmeasSpecVecbldEdgept)
{
  if (a_rmeasEdgept_rmeasSpecVecbldEdgept->get_fLabel())
    {
      if (!findString("a_fLabel", rmeasEdgept_rmeasSpecVecbldEdgeptAtts))
	{warnAtt("a_fLabel", "rmeasEdgept_rmeasSpecVecbldEdgept", a_rmeasEdgept_rmeasSpecVecbldEdgept);}
      else
        check_fLabel(a_rmeasEdgept_rmeasSpecVecbldEdgept->get_fLabel());
    }
  if (a_rmeasEdgept_rmeasSpecVecbldEdgept->get_numMeas())
    {
      if (!findString("numMeas", rmeasEdgept_rmeasSpecVecbldEdgeptAtts))
	{warnAtt("numMeas", "rmeasEdgept_rmeasSpecVecbldEdgept", a_rmeasEdgept_rmeasSpecVecbldEdgept);}
      else
        check_intVal(a_rmeasEdgept_rmeasSpecVecbldEdgept->get_numMeas());
    }
  if (a_rmeasEdgept_rmeasSpecVecbldEdgept->get_rmeasSpecVecbldEdgept())
    {
      if (!findString("a_rmeasSpecVecbldEdgept", rmeasEdgept_rmeasSpecVecbldEdgeptAtts))
	{warnAtt("a_rmeasSpecVecbldEdgept", "rmeasEdgept_rmeasSpecVecbldEdgept", a_rmeasEdgept_rmeasSpecVecbldEdgept);}
      else
        check_rmeasSpecVecbldEdgept(a_rmeasEdgept_rmeasSpecVecbldEdgept->get_rmeasSpecVecbldEdgept());
    }
}

/********************************************************************/

void check_rmeasEllips(
 rmeasEllips * a_rmeasEllips)
{
  if (isA(a_rmeasEllips, rmeasEllips_rmeasSpecFa))
    {
      if (!findString("rmeasEllips_rmeasSpecFa", rmeasEllipsSubs))
        {warnSub("rmeasEllips_rmeasSpecFa", "rmeasEllips", a_rmeasEllips);}
      else
        check_rmeasEllips_rmeasSpecFa(dynamic_cast<rmeasEllips_rmeasSpecFa *>(a_rmeasEllips));
      return;
    }
  if (isA(a_rmeasEllips, rmeasEllips_rmeasSpecVecbld))
    {
      if (!findString("rmeasEllips_rmeasSpecVecbld", rmeasEllipsSubs))
        {warnSub("rmeasEllips_rmeasSpecVecbld", "rmeasEllips", a_rmeasEllips);}
      else
        check_rmeasEllips_rmeasSpecVecbld(dynamic_cast<rmeasEllips_rmeasSpecVecbld *>(a_rmeasEllips));
      return;
    }
}

/********************************************************************/

void check_rmeasEllips_rmeasSpecFa(
 rmeasEllips_rmeasSpecFa * a_rmeasEllips_rmeasSpecFa)
{
  if (a_rmeasEllips_rmeasSpecFa->get_fLabel())
    {
      if (!findString("a_fLabel", rmeasEllips_rmeasSpecFaAtts))
	{warnAtt("a_fLabel", "rmeasEllips_rmeasSpecFa", a_rmeasEllips_rmeasSpecFa);}
      else
        check_fLabel(a_rmeasEllips_rmeasSpecFa->get_fLabel());
    }
  if (a_rmeasEllips_rmeasSpecFa->get_numMeas())
    {
      if (!findString("numMeas", rmeasEllips_rmeasSpecFaAtts))
	{warnAtt("numMeas", "rmeasEllips_rmeasSpecFa", a_rmeasEllips_rmeasSpecFa);}
      else
        check_intVal(a_rmeasEllips_rmeasSpecFa->get_numMeas());
    }
  if (a_rmeasEllips_rmeasSpecFa->get_rmeasSpecFa())
    {
      if (!findString("a_rmeasSpecFa", rmeasEllips_rmeasSpecFaAtts))
	{warnAtt("a_rmeasSpecFa", "rmeasEllips_rmeasSpecFa", a_rmeasEllips_rmeasSpecFa);}
      else
        check_rmeasSpecFa(a_rmeasEllips_rmeasSpecFa->get_rmeasSpecFa());
    }
}

/********************************************************************/

void check_rmeasEllips_rmeasSpecVecbld(
 rmeasEllips_rmeasSpecVecbld * a_rmeasEllips_rmeasSpecVecbld)
{
  if (a_rmeasEllips_rmeasSpecVecbld->get_fLabel())
    {
      if (!findString("a_fLabel", rmeasEllips_rmeasSpecVecbldAtts))
	{warnAtt("a_fLabel", "rmeasEllips_rmeasSpecVecbld", a_rmeasEllips_rmeasSpecVecbld);}
      else
        check_fLabel(a_rmeasEllips_rmeasSpecVecbld->get_fLabel());
    }
  if (a_rmeasEllips_rmeasSpecVecbld->get_numMeas())
    {
      if (!findString("numMeas", rmeasEllips_rmeasSpecVecbldAtts))
	{warnAtt("numMeas", "rmeasEllips_rmeasSpecVecbld", a_rmeasEllips_rmeasSpecVecbld);}
      else
        check_intVal(a_rmeasEllips_rmeasSpecVecbld->get_numMeas());
    }
  if (a_rmeasEllips_rmeasSpecVecbld->get_rmeasSpecVecbld())
    {
      if (!findString("a_rmeasSpecVecbld", rmeasEllips_rmeasSpecVecbldAtts))
	{warnAtt("a_rmeasSpecVecbld", "rmeasEllips_rmeasSpecVecbld", a_rmeasEllips_rmeasSpecVecbld);}
      else
        check_rmeasSpecVecbld(a_rmeasEllips_rmeasSpecVecbld->get_rmeasSpecVecbld());
    }
}

/********************************************************************/

void check_rmeasGcurve(
 rmeasGcurve * a_rmeasGcurve)
{
  if (isA(a_rmeasGcurve, rmeasGcurve_rmeasSpecFeatAxis))
    {
      if (!findString("rmeasGcurve_rmeasSpecFeatAxis", rmeasGcurveSubs))
        {warnSub("rmeasGcurve_rmeasSpecFeatAxis", "rmeasGcurve", a_rmeasGcurve);}
      else
        check_rmeasGcurve_rmeasSpecFeatAxis(dynamic_cast<rmeasGcurve_rmeasSpecFeatAxis *>(a_rmeasGcurve));
      return;
    }
  if (isA(a_rmeasGcurve, rmeasGcurve_rmeasSpecVecbld))
    {
      if (!findString("rmeasGcurve_rmeasSpecVecbld", rmeasGcurveSubs))
        {warnSub("rmeasGcurve_rmeasSpecVecbld", "rmeasGcurve", a_rmeasGcurve);}
      else
        check_rmeasGcurve_rmeasSpecVecbld(dynamic_cast<rmeasGcurve_rmeasSpecVecbld *>(a_rmeasGcurve));
      return;
    }
}

/********************************************************************/

void check_rmeasGcurve_rmeasSpecFeatAxis(
 rmeasGcurve_rmeasSpecFeatAxis * a_rmeasGcurve_rmeasSpecFeatAxis)
{
  if (a_rmeasGcurve_rmeasSpecFeatAxis->get_fLabel())
    {
      if (!findString("a_fLabel", rmeasGcurve_rmeasSpecFeatAxisAtts))
	{warnAtt("a_fLabel", "rmeasGcurve_rmeasSpecFeatAxis", a_rmeasGcurve_rmeasSpecFeatAxis);}
      else
        check_fLabel(a_rmeasGcurve_rmeasSpecFeatAxis->get_fLabel());
    }
  if (a_rmeasGcurve_rmeasSpecFeatAxis->get_numMeas())
    {
      if (!findString("numMeas", rmeasGcurve_rmeasSpecFeatAxisAtts))
	{warnAtt("numMeas", "rmeasGcurve_rmeasSpecFeatAxis", a_rmeasGcurve_rmeasSpecFeatAxis);}
      else
        check_intVal(a_rmeasGcurve_rmeasSpecFeatAxis->get_numMeas());
    }
  if (a_rmeasGcurve_rmeasSpecFeatAxis->get_rmeasSpecFeatAxis())
    {
      if (!findString("a_rmeasSpecFeatAxis", rmeasGcurve_rmeasSpecFeatAxisAtts))
	{warnAtt("a_rmeasSpecFeatAxis", "rmeasGcurve_rmeasSpecFeatAxis", a_rmeasGcurve_rmeasSpecFeatAxis);}
      else
        check_rmeasSpecFeatAxis(a_rmeasGcurve_rmeasSpecFeatAxis->get_rmeasSpecFeatAxis());
    }
}

/********************************************************************/

void check_rmeasGcurve_rmeasSpecVecbld(
 rmeasGcurve_rmeasSpecVecbld * a_rmeasGcurve_rmeasSpecVecbld)
{
  if (a_rmeasGcurve_rmeasSpecVecbld->get_fLabel())
    {
      if (!findString("a_fLabel", rmeasGcurve_rmeasSpecVecbldAtts))
	{warnAtt("a_fLabel", "rmeasGcurve_rmeasSpecVecbld", a_rmeasGcurve_rmeasSpecVecbld);}
      else
        check_fLabel(a_rmeasGcurve_rmeasSpecVecbld->get_fLabel());
    }
  if (a_rmeasGcurve_rmeasSpecVecbld->get_numMeas())
    {
      if (!findString("numMeas", rmeasGcurve_rmeasSpecVecbldAtts))
	{warnAtt("numMeas", "rmeasGcurve_rmeasSpecVecbld", a_rmeasGcurve_rmeasSpecVecbld);}
      else
        check_intVal(a_rmeasGcurve_rmeasSpecVecbld->get_numMeas());
    }
  if (a_rmeasGcurve_rmeasSpecVecbld->get_rmeasSpecVecbld())
    {
      if (!findString("a_rmeasSpecVecbld", rmeasGcurve_rmeasSpecVecbldAtts))
	{warnAtt("a_rmeasSpecVecbld", "rmeasGcurve_rmeasSpecVecbld", a_rmeasGcurve_rmeasSpecVecbld);}
      else
        check_rmeasSpecVecbld(a_rmeasGcurve_rmeasSpecVecbld->get_rmeasSpecVecbld());
    }
}

/********************************************************************/

void check_rmeasGsurf(
 rmeasGsurf * a_rmeasGsurf)
{
  if (a_rmeasGsurf->get_fLabel())
    {
      if (!findString("a_fLabel", rmeasGsurfAtts))
	{warnAtt("a_fLabel", "rmeasGsurf", a_rmeasGsurf);}
      else
        check_fLabel(a_rmeasGsurf->get_fLabel());
    }
  if (a_rmeasGsurf->get_numMeas())
    {
      if (!findString("numMeas", rmeasGsurfAtts))
	{warnAtt("numMeas", "rmeasGsurf", a_rmeasGsurf);}
      else
        check_intVal(a_rmeasGsurf->get_numMeas());
    }
  if (a_rmeasGsurf->get_rmeasSpecFaAxis())
    {
      if (!findString("a_rmeasSpecFaAxis", rmeasGsurfAtts))
	{warnAtt("a_rmeasSpecFaAxis", "rmeasGsurf", a_rmeasGsurf);}
      else
        check_rmeasSpecFaAxis(a_rmeasGsurf->get_rmeasSpecFaAxis());
    }
}

/********************************************************************/

void check_rmeasLine(
 rmeasLine * a_rmeasLine)
{
  if (isA(a_rmeasLine, rmeasLine_rmeasSpecFeatAxis))
    {
      if (!findString("rmeasLine_rmeasSpecFeatAxis", rmeasLineSubs))
        {warnSub("rmeasLine_rmeasSpecFeatAxis", "rmeasLine", a_rmeasLine);}
      else
        check_rmeasLine_rmeasSpecFeatAxis(dynamic_cast<rmeasLine_rmeasSpecFeatAxis *>(a_rmeasLine));
      return;
    }
  if (isA(a_rmeasLine, rmeasLine_rmeasSpecVecbld))
    {
      if (!findString("rmeasLine_rmeasSpecVecbld", rmeasLineSubs))
        {warnSub("rmeasLine_rmeasSpecVecbld", "rmeasLine", a_rmeasLine);}
      else
        check_rmeasLine_rmeasSpecVecbld(dynamic_cast<rmeasLine_rmeasSpecVecbld *>(a_rmeasLine));
      return;
    }
}

/********************************************************************/

void check_rmeasLine_rmeasSpecFeatAxis(
 rmeasLine_rmeasSpecFeatAxis * a_rmeasLine_rmeasSpecFeatAxis)
{
  if (a_rmeasLine_rmeasSpecFeatAxis->get_fLabel())
    {
      if (!findString("a_fLabel", rmeasLine_rmeasSpecFeatAxisAtts))
	{warnAtt("a_fLabel", "rmeasLine_rmeasSpecFeatAxis", a_rmeasLine_rmeasSpecFeatAxis);}
      else
        check_fLabel(a_rmeasLine_rmeasSpecFeatAxis->get_fLabel());
    }
  if (a_rmeasLine_rmeasSpecFeatAxis->get_numMeas())
    {
      if (!findString("numMeas", rmeasLine_rmeasSpecFeatAxisAtts))
	{warnAtt("numMeas", "rmeasLine_rmeasSpecFeatAxis", a_rmeasLine_rmeasSpecFeatAxis);}
      else
        check_intVal(a_rmeasLine_rmeasSpecFeatAxis->get_numMeas());
    }
  if (a_rmeasLine_rmeasSpecFeatAxis->get_rmeasSpecFeatAxis())
    {
      if (!findString("a_rmeasSpecFeatAxis", rmeasLine_rmeasSpecFeatAxisAtts))
	{warnAtt("a_rmeasSpecFeatAxis", "rmeasLine_rmeasSpecFeatAxis", a_rmeasLine_rmeasSpecFeatAxis);}
      else
        check_rmeasSpecFeatAxis(a_rmeasLine_rmeasSpecFeatAxis->get_rmeasSpecFeatAxis());
    }
}

/********************************************************************/

void check_rmeasLine_rmeasSpecVecbld(
 rmeasLine_rmeasSpecVecbld * a_rmeasLine_rmeasSpecVecbld)
{
  if (a_rmeasLine_rmeasSpecVecbld->get_fLabel())
    {
      if (!findString("a_fLabel", rmeasLine_rmeasSpecVecbldAtts))
	{warnAtt("a_fLabel", "rmeasLine_rmeasSpecVecbld", a_rmeasLine_rmeasSpecVecbld);}
      else
        check_fLabel(a_rmeasLine_rmeasSpecVecbld->get_fLabel());
    }
  if (a_rmeasLine_rmeasSpecVecbld->get_numMeas())
    {
      if (!findString("numMeas", rmeasLine_rmeasSpecVecbldAtts))
	{warnAtt("numMeas", "rmeasLine_rmeasSpecVecbld", a_rmeasLine_rmeasSpecVecbld);}
      else
        check_intVal(a_rmeasLine_rmeasSpecVecbld->get_numMeas());
    }
  if (a_rmeasLine_rmeasSpecVecbld->get_rmeasSpecVecbld())
    {
      if (!findString("a_rmeasSpecVecbld", rmeasLine_rmeasSpecVecbldAtts))
	{warnAtt("a_rmeasSpecVecbld", "rmeasLine_rmeasSpecVecbld", a_rmeasLine_rmeasSpecVecbld);}
      else
        check_rmeasSpecVecbld(a_rmeasLine_rmeasSpecVecbld->get_rmeasSpecVecbld());
    }
}

/********************************************************************/

void check_rmeasMinor(
 rmeasMinor * a_rmeasMinor)
{
  if (isA(a_rmeasMinor, rmeasArc))
    {
      if (!findString("rmeasArc", rmeasMinorSubs))
        {warnSub("rmeasArc", "rmeasMinor", a_rmeasMinor);}
      else
        check_rmeasArc(dynamic_cast<rmeasArc *>(a_rmeasMinor));
      return;
    }
  if (isA(a_rmeasMinor, rmeasCircle))
    {
      if (!findString("rmeasCircle", rmeasMinorSubs))
        {warnSub("rmeasCircle", "rmeasMinor", a_rmeasMinor);}
      else
        check_rmeasCircle(dynamic_cast<rmeasCircle *>(a_rmeasMinor));
      return;
    }
  if (isA(a_rmeasMinor, rmeasCone))
    {
      if (!findString("rmeasCone", rmeasMinorSubs))
        {warnSub("rmeasCone", "rmeasMinor", a_rmeasMinor);}
      else
        check_rmeasCone(dynamic_cast<rmeasCone *>(a_rmeasMinor));
      return;
    }
  if (isA(a_rmeasMinor, rmeasCparln))
    {
      if (!findString("rmeasCparln", rmeasMinorSubs))
        {warnSub("rmeasCparln", "rmeasMinor", a_rmeasMinor);}
      else
        check_rmeasCparln(dynamic_cast<rmeasCparln *>(a_rmeasMinor));
      return;
    }
  if (isA(a_rmeasMinor, rmeasCylndr))
    {
      if (!findString("rmeasCylndr", rmeasMinorSubs))
        {warnSub("rmeasCylndr", "rmeasMinor", a_rmeasMinor);}
      else
        check_rmeasCylndr(dynamic_cast<rmeasCylndr *>(a_rmeasMinor));
      return;
    }
  if (isA(a_rmeasMinor, rmeasEdgept))
    {
      if (!findString("rmeasEdgept", rmeasMinorSubs))
        {warnSub("rmeasEdgept", "rmeasMinor", a_rmeasMinor);}
      else
        check_rmeasEdgept(dynamic_cast<rmeasEdgept *>(a_rmeasMinor));
      return;
    }
  if (isA(a_rmeasMinor, rmeasEllips))
    {
      if (!findString("rmeasEllips", rmeasMinorSubs))
        {warnSub("rmeasEllips", "rmeasMinor", a_rmeasMinor);}
      else
        check_rmeasEllips(dynamic_cast<rmeasEllips *>(a_rmeasMinor));
      return;
    }
  if (isA(a_rmeasMinor, rmeasGcurve))
    {
      if (!findString("rmeasGcurve", rmeasMinorSubs))
        {warnSub("rmeasGcurve", "rmeasMinor", a_rmeasMinor);}
      else
        check_rmeasGcurve(dynamic_cast<rmeasGcurve *>(a_rmeasMinor));
      return;
    }
  if (isA(a_rmeasMinor, rmeasGsurf))
    {
      if (!findString("rmeasGsurf", rmeasMinorSubs))
        {warnSub("rmeasGsurf", "rmeasMinor", a_rmeasMinor);}
      else
        check_rmeasGsurf(dynamic_cast<rmeasGsurf *>(a_rmeasMinor));
      return;
    }
  if (isA(a_rmeasMinor, rmeasLine))
    {
      if (!findString("rmeasLine", rmeasMinorSubs))
        {warnSub("rmeasLine", "rmeasMinor", a_rmeasMinor);}
      else
        check_rmeasLine(dynamic_cast<rmeasLine *>(a_rmeasMinor));
      return;
    }
  if (isA(a_rmeasMinor, rmeasObject))
    {
      if (!findString("rmeasObject", rmeasMinorSubs))
        {warnSub("rmeasObject", "rmeasMinor", a_rmeasMinor);}
      else
        check_rmeasObject(dynamic_cast<rmeasObject *>(a_rmeasMinor));
      return;
    }
  if (isA(a_rmeasMinor, rmeasParpln))
    {
      if (!findString("rmeasParpln", rmeasMinorSubs))
        {warnSub("rmeasParpln", "rmeasMinor", a_rmeasMinor);}
      else
        check_rmeasParpln(dynamic_cast<rmeasParpln *>(a_rmeasMinor));
      return;
    }
  if (isA(a_rmeasMinor, rmeasPlane))
    {
      if (!findString("rmeasPlane", rmeasMinorSubs))
        {warnSub("rmeasPlane", "rmeasMinor", a_rmeasMinor);}
      else
        check_rmeasPlane(dynamic_cast<rmeasPlane *>(a_rmeasMinor));
      return;
    }
  if (isA(a_rmeasMinor, rmeasPoint))
    {
      if (!findString("rmeasPoint", rmeasMinorSubs))
        {warnSub("rmeasPoint", "rmeasMinor", a_rmeasMinor);}
      else
        check_rmeasPoint(dynamic_cast<rmeasPoint *>(a_rmeasMinor));
      return;
    }
  if (isA(a_rmeasMinor, rmeasRctngl))
    {
      if (!findString("rmeasRctngl", rmeasMinorSubs))
        {warnSub("rmeasRctngl", "rmeasMinor", a_rmeasMinor);}
      else
        check_rmeasRctngl(dynamic_cast<rmeasRctngl *>(a_rmeasMinor));
      return;
    }
  if (isA(a_rmeasMinor, rmeasSphere))
    {
      if (!findString("rmeasSphere", rmeasMinorSubs))
        {warnSub("rmeasSphere", "rmeasMinor", a_rmeasMinor);}
      else
        check_rmeasSphere(dynamic_cast<rmeasSphere *>(a_rmeasMinor));
      return;
    }
  if (isA(a_rmeasMinor, rmeasSympln))
    {
      if (!findString("rmeasSympln", rmeasMinorSubs))
        {warnSub("rmeasSympln", "rmeasMinor", a_rmeasMinor);}
      else
        check_rmeasSympln(dynamic_cast<rmeasSympln *>(a_rmeasMinor));
      return;
    }
  if (isA(a_rmeasMinor, rmeasTorus))
    {
      if (!findString("rmeasTorus", rmeasMinorSubs))
        {warnSub("rmeasTorus", "rmeasMinor", a_rmeasMinor);}
      else
        check_rmeasTorus(dynamic_cast<rmeasTorus *>(a_rmeasMinor));
      return;
    }
}

/********************************************************************/

void check_rmeasObject(
 rmeasObject * a_rmeasObject)
{
  if (isA(a_rmeasObject, rmeasObject_rmeasSpecFa))
    {
      if (!findString("rmeasObject_rmeasSpecFa", rmeasObjectSubs))
        {warnSub("rmeasObject_rmeasSpecFa", "rmeasObject", a_rmeasObject);}
      else
        check_rmeasObject_rmeasSpecFa(dynamic_cast<rmeasObject_rmeasSpecFa *>(a_rmeasObject));
      return;
    }
  if (isA(a_rmeasObject, rmeasObject_rmeasSpecVecbld))
    {
      if (!findString("rmeasObject_rmeasSpecVecbld", rmeasObjectSubs))
        {warnSub("rmeasObject_rmeasSpecVecbld", "rmeasObject", a_rmeasObject);}
      else
        check_rmeasObject_rmeasSpecVecbld(dynamic_cast<rmeasObject_rmeasSpecVecbld *>(a_rmeasObject));
      return;
    }
}

/********************************************************************/

void check_rmeasObject_rmeasSpecFa(
 rmeasObject_rmeasSpecFa * a_rmeasObject_rmeasSpecFa)
{
  if (a_rmeasObject_rmeasSpecFa->get_fLabel())
    {
      if (!findString("a_fLabel", rmeasObject_rmeasSpecFaAtts))
	{warnAtt("a_fLabel", "rmeasObject_rmeasSpecFa", a_rmeasObject_rmeasSpecFa);}
      else
        check_fLabel(a_rmeasObject_rmeasSpecFa->get_fLabel());
    }
  if (a_rmeasObject_rmeasSpecFa->get_numMeas())
    {
      if (!findString("numMeas", rmeasObject_rmeasSpecFaAtts))
	{warnAtt("numMeas", "rmeasObject_rmeasSpecFa", a_rmeasObject_rmeasSpecFa);}
      else
        check_intVal(a_rmeasObject_rmeasSpecFa->get_numMeas());
    }
  if (a_rmeasObject_rmeasSpecFa->get_rmeasSpecFa())
    {
      if (!findString("a_rmeasSpecFa", rmeasObject_rmeasSpecFaAtts))
	{warnAtt("a_rmeasSpecFa", "rmeasObject_rmeasSpecFa", a_rmeasObject_rmeasSpecFa);}
      else
        check_rmeasSpecFa(a_rmeasObject_rmeasSpecFa->get_rmeasSpecFa());
    }
}

/********************************************************************/

void check_rmeasObject_rmeasSpecVecbld(
 rmeasObject_rmeasSpecVecbld * a_rmeasObject_rmeasSpecVecbld)
{
  if (a_rmeasObject_rmeasSpecVecbld->get_fLabel())
    {
      if (!findString("a_fLabel", rmeasObject_rmeasSpecVecbldAtts))
	{warnAtt("a_fLabel", "rmeasObject_rmeasSpecVecbld", a_rmeasObject_rmeasSpecVecbld);}
      else
        check_fLabel(a_rmeasObject_rmeasSpecVecbld->get_fLabel());
    }
  if (a_rmeasObject_rmeasSpecVecbld->get_numMeas())
    {
      if (!findString("numMeas", rmeasObject_rmeasSpecVecbldAtts))
	{warnAtt("numMeas", "rmeasObject_rmeasSpecVecbld", a_rmeasObject_rmeasSpecVecbld);}
      else
        check_intVal(a_rmeasObject_rmeasSpecVecbld->get_numMeas());
    }
  if (a_rmeasObject_rmeasSpecVecbld->get_rmeasSpecVecbld())
    {
      if (!findString("a_rmeasSpecVecbld", rmeasObject_rmeasSpecVecbldAtts))
	{warnAtt("a_rmeasSpecVecbld", "rmeasObject_rmeasSpecVecbld", a_rmeasObject_rmeasSpecVecbld);}
      else
        check_rmeasSpecVecbld(a_rmeasObject_rmeasSpecVecbld->get_rmeasSpecVecbld());
    }
}

/********************************************************************/

void check_rmeasParpln(
 rmeasParpln * a_rmeasParpln)
{
  if (a_rmeasParpln->get_fLabel())
    {
      if (!findString("a_fLabel", rmeasParplnAtts))
	{warnAtt("a_fLabel", "rmeasParpln", a_rmeasParpln);}
      else
        check_fLabel(a_rmeasParpln->get_fLabel());
    }
  if (a_rmeasParpln->get_numMeas())
    {
      if (!findString("numMeas", rmeasParplnAtts))
	{warnAtt("numMeas", "rmeasParpln", a_rmeasParpln);}
      else
        check_intVal(a_rmeasParpln->get_numMeas());
    }
  if (a_rmeasParpln->get_rmeasSpecFa())
    {
      if (!findString("a_rmeasSpecFa", rmeasParplnAtts))
	{warnAtt("a_rmeasSpecFa", "rmeasParpln", a_rmeasParpln);}
      else
        check_rmeasSpecFa(a_rmeasParpln->get_rmeasSpecFa());
    }
}

/********************************************************************/

void check_rmeasPlane(
 rmeasPlane * a_rmeasPlane)
{
  if (a_rmeasPlane->get_fLabel())
    {
      if (!findString("a_fLabel", rmeasPlaneAtts))
	{warnAtt("a_fLabel", "rmeasPlane", a_rmeasPlane);}
      else
        check_fLabel(a_rmeasPlane->get_fLabel());
    }
  if (a_rmeasPlane->get_numMeas())
    {
      if (!findString("numMeas", rmeasPlaneAtts))
	{warnAtt("numMeas", "rmeasPlane", a_rmeasPlane);}
      else
        check_intVal(a_rmeasPlane->get_numMeas());
    }
  if (a_rmeasPlane->get_rmeasSpecFaAxis())
    {
      if (!findString("a_rmeasSpecFaAxis", rmeasPlaneAtts))
	{warnAtt("a_rmeasSpecFaAxis", "rmeasPlane", a_rmeasPlane);}
      else
        check_rmeasSpecFaAxis(a_rmeasPlane->get_rmeasSpecFaAxis());
    }
}

/********************************************************************/

void check_rmeasPoint(
 rmeasPoint * a_rmeasPoint)
{
  if (isA(a_rmeasPoint, rmeasPoint_rmeasSpecFaAxis))
    {
      if (!findString("rmeasPoint_rmeasSpecFaAxis", rmeasPointSubs))
        {warnSub("rmeasPoint_rmeasSpecFaAxis", "rmeasPoint", a_rmeasPoint);}
      else
        check_rmeasPoint_rmeasSpecFaAxis(dynamic_cast<rmeasPoint_rmeasSpecFaAxis *>(a_rmeasPoint));
      return;
    }
  if (isA(a_rmeasPoint, rmeasPoint_rmeasSpecVecbld))
    {
      if (!findString("rmeasPoint_rmeasSpecVecbld", rmeasPointSubs))
        {warnSub("rmeasPoint_rmeasSpecVecbld", "rmeasPoint", a_rmeasPoint);}
      else
        check_rmeasPoint_rmeasSpecVecbld(dynamic_cast<rmeasPoint_rmeasSpecVecbld *>(a_rmeasPoint));
      return;
    }
}

/********************************************************************/

void check_rmeasPoint_rmeasSpecFaAxis(
 rmeasPoint_rmeasSpecFaAxis * a_rmeasPoint_rmeasSpecFaAxis)
{
  if (a_rmeasPoint_rmeasSpecFaAxis->get_fLabel())
    {
      if (!findString("a_fLabel", rmeasPoint_rmeasSpecFaAxisAtts))
	{warnAtt("a_fLabel", "rmeasPoint_rmeasSpecFaAxis", a_rmeasPoint_rmeasSpecFaAxis);}
      else
        check_fLabel(a_rmeasPoint_rmeasSpecFaAxis->get_fLabel());
    }
  if (a_rmeasPoint_rmeasSpecFaAxis->get_numMeas())
    {
      if (!findString("numMeas", rmeasPoint_rmeasSpecFaAxisAtts))
	{warnAtt("numMeas", "rmeasPoint_rmeasSpecFaAxis", a_rmeasPoint_rmeasSpecFaAxis);}
      else
        check_intVal(a_rmeasPoint_rmeasSpecFaAxis->get_numMeas());
    }
  if (a_rmeasPoint_rmeasSpecFaAxis->get_rmeasSpecFaAxis())
    {
      if (!findString("a_rmeasSpecFaAxis", rmeasPoint_rmeasSpecFaAxisAtts))
	{warnAtt("a_rmeasSpecFaAxis", "rmeasPoint_rmeasSpecFaAxis", a_rmeasPoint_rmeasSpecFaAxis);}
      else
        check_rmeasSpecFaAxis(a_rmeasPoint_rmeasSpecFaAxis->get_rmeasSpecFaAxis());
    }
}

/********************************************************************/

void check_rmeasPoint_rmeasSpecVecbld(
 rmeasPoint_rmeasSpecVecbld * a_rmeasPoint_rmeasSpecVecbld)
{
  if (a_rmeasPoint_rmeasSpecVecbld->get_fLabel())
    {
      if (!findString("a_fLabel", rmeasPoint_rmeasSpecVecbldAtts))
	{warnAtt("a_fLabel", "rmeasPoint_rmeasSpecVecbld", a_rmeasPoint_rmeasSpecVecbld);}
      else
        check_fLabel(a_rmeasPoint_rmeasSpecVecbld->get_fLabel());
    }
  if (a_rmeasPoint_rmeasSpecVecbld->get_numMeas())
    {
      if (!findString("numMeas", rmeasPoint_rmeasSpecVecbldAtts))
	{warnAtt("numMeas", "rmeasPoint_rmeasSpecVecbld", a_rmeasPoint_rmeasSpecVecbld);}
      else
        check_intVal(a_rmeasPoint_rmeasSpecVecbld->get_numMeas());
    }
  if (a_rmeasPoint_rmeasSpecVecbld->get_rmeasSpecVecbld())
    {
      if (!findString("a_rmeasSpecVecbld", rmeasPoint_rmeasSpecVecbldAtts))
	{warnAtt("a_rmeasSpecVecbld", "rmeasPoint_rmeasSpecVecbld", a_rmeasPoint_rmeasSpecVecbld);}
      else
        check_rmeasSpecVecbld(a_rmeasPoint_rmeasSpecVecbld->get_rmeasSpecVecbld());
    }
}

/********************************************************************/

void check_rmeasRctngl(
 rmeasRctngl * a_rmeasRctngl)
{
  if (a_rmeasRctngl->get_fLabel())
    {
      if (!findString("a_fLabel", rmeasRctnglAtts))
	{warnAtt("a_fLabel", "rmeasRctngl", a_rmeasRctngl);}
      else
        check_fLabel(a_rmeasRctngl->get_fLabel());
    }
  if (a_rmeasRctngl->get_numMeas())
    {
      if (!findString("numMeas", rmeasRctnglAtts))
	{warnAtt("numMeas", "rmeasRctngl", a_rmeasRctngl);}
      else
        check_intVal(a_rmeasRctngl->get_numMeas());
    }
  if (a_rmeasRctngl->get_rmeasSpecFa())
    {
      if (!findString("a_rmeasSpecFa", rmeasRctnglAtts))
	{warnAtt("a_rmeasSpecFa", "rmeasRctngl", a_rmeasRctngl);}
      else
        check_rmeasSpecFa(a_rmeasRctngl->get_rmeasSpecFa());
    }
}

/********************************************************************/

void check_rmeasSpecFa(
 rmeasSpecFa * a_rmeasSpecFa)
{
  if (isA(a_rmeasSpecFa, faLabel))
    {
      if (!findString("faLabel", rmeasSpecFaSubs))
        {warnSub("faLabel", "rmeasSpecFa", a_rmeasSpecFa);}
      else
        check_faLabel(dynamic_cast<faLabel *>(a_rmeasSpecFa));
      return;
    }
}

/********************************************************************/

void check_rmeasSpecFaAxis(
 rmeasSpecFaAxis * a_rmeasSpecFaAxis)
{
  if (isA(a_rmeasSpecFaAxis, rmeasSpecFaAxis_faLabel))
    {
      if (!findString("rmeasSpecFaAxis_faLabel", rmeasSpecFaAxisSubs))
        {warnSub("rmeasSpecFaAxis_faLabel", "rmeasSpecFaAxis", a_rmeasSpecFaAxis);}
      else
        check_rmeasSpecFaAxis_faLabel(dynamic_cast<rmeasSpecFaAxis_faLabel *>(a_rmeasSpecFaAxis));
      return;
    }
  if (isA(a_rmeasSpecFaAxis, rmeasSpecFaAxis_axis))
    {
      if (!findString("rmeasSpecFaAxis_axis", rmeasSpecFaAxisSubs))
        {warnSub("rmeasSpecFaAxis_axis", "rmeasSpecFaAxis", a_rmeasSpecFaAxis);}
      else
        check_rmeasSpecFaAxis_axis(dynamic_cast<rmeasSpecFaAxis_axis *>(a_rmeasSpecFaAxis));
      return;
    }
}

/********************************************************************/

void check_rmeasSpecFaAxis_axis(
 rmeasSpecFaAxis_axis * a_rmeasSpecFaAxis_axis)
{
  if (a_rmeasSpecFaAxis_axis->get_axis())
    {
      if (!findString("a_axis", rmeasSpecFaAxis_axisAtts))
	{warnAtt("a_axis", "rmeasSpecFaAxis_axis", a_rmeasSpecFaAxis_axis);}
      else
        check_axis(a_rmeasSpecFaAxis_axis->get_axis());
    }
}

/********************************************************************/

void check_rmeasSpecFaAxis_faLabel(
 rmeasSpecFaAxis_faLabel * a_rmeasSpecFaAxis_faLabel)
{
  if (a_rmeasSpecFaAxis_faLabel->get_faLabel())
    {
      if (!findString("a_faLabel", rmeasSpecFaAxis_faLabelAtts))
	{warnAtt("a_faLabel", "rmeasSpecFaAxis_faLabel", a_rmeasSpecFaAxis_faLabel);}
      else
        check_faLabel(a_rmeasSpecFaAxis_faLabel->get_faLabel());
    }
  if (a_rmeasSpecFaAxis_faLabel->get_axis())
    {
      if (!findString("a_axis", rmeasSpecFaAxis_faLabelAtts))
	{warnAtt("a_axis", "rmeasSpecFaAxis_faLabel", a_rmeasSpecFaAxis_faLabel);}
      else
        check_axis(a_rmeasSpecFaAxis_faLabel->get_axis());
    }
}

/********************************************************************/

void check_rmeasSpecFaOrient(
 rmeasSpecFaOrient * a_rmeasSpecFaOrient)
{
  if (a_rmeasSpecFaOrient->get_faLabel())
    {
      if (!findString("a_faLabel", rmeasSpecFaOrientAtts))
	{warnAtt("a_faLabel", "rmeasSpecFaOrient", a_rmeasSpecFaOrient);}
      else
        check_faLabel(a_rmeasSpecFaOrient->get_faLabel());
    }
  if (a_rmeasSpecFaOrient->get_has_ORIENT())
    {
      if (!findString("has_ORIENT", rmeasSpecFaOrientAtts))
	{warnAtt("has_ORIENT", "rmeasSpecFaOrient", a_rmeasSpecFaOrient);}
    }
}

/********************************************************************/

void check_rmeasSpecFeatAxis(
 rmeasSpecFeatAxis * a_rmeasSpecFeatAxis)
{
  if (isA(a_rmeasSpecFeatAxis, rmeasSpecFeatAxis_featureLabel1))
    {
      if (!findString("rmeasSpecFeatAxis_featureLabel1", rmeasSpecFeatAxisSubs))
        {warnSub("rmeasSpecFeatAxis_featureLabel1", "rmeasSpecFeatAxis", a_rmeasSpecFeatAxis);}
      else
        check_rmeasSpecFeatAxis_featureLabel1(dynamic_cast<rmeasSpecFeatAxis_featureLabel1 *>(a_rmeasSpecFeatAxis));
      return;
    }
  if (isA(a_rmeasSpecFeatAxis, rmeasSpecFeatAxis_axis))
    {
      if (!findString("rmeasSpecFeatAxis_axis", rmeasSpecFeatAxisSubs))
        {warnSub("rmeasSpecFeatAxis_axis", "rmeasSpecFeatAxis", a_rmeasSpecFeatAxis);}
      else
        check_rmeasSpecFeatAxis_axis(dynamic_cast<rmeasSpecFeatAxis_axis *>(a_rmeasSpecFeatAxis));
      return;
    }
}

/********************************************************************/

void check_rmeasSpecFeatAxis_axis(
 rmeasSpecFeatAxis_axis * a_rmeasSpecFeatAxis_axis)
{
  if (a_rmeasSpecFeatAxis_axis->get_axis())
    {
      if (!findString("a_axis", rmeasSpecFeatAxis_axisAtts))
	{warnAtt("a_axis", "rmeasSpecFeatAxis_axis", a_rmeasSpecFeatAxis_axis);}
      else
        check_axis(a_rmeasSpecFeatAxis_axis->get_axis());
    }
}

/********************************************************************/

void check_rmeasSpecFeatAxis_featureLabel1(
 rmeasSpecFeatAxis_featureLabel1 * a_rmeasSpecFeatAxis_featureLabel1)
{
  if (a_rmeasSpecFeatAxis_featureLabel1->get_featureLabel1())
    {
      if (!findString("a_featureLabel1", rmeasSpecFeatAxis_featureLabel1Atts))
	{warnAtt("a_featureLabel1", "rmeasSpecFeatAxis_featureLabel1", a_rmeasSpecFeatAxis_featureLabel1);}
      else
        check_featureLabel1(a_rmeasSpecFeatAxis_featureLabel1->get_featureLabel1());
    }
  if (a_rmeasSpecFeatAxis_featureLabel1->get_axis())
    {
      if (!findString("a_axis", rmeasSpecFeatAxis_featureLabel1Atts))
	{warnAtt("a_axis", "rmeasSpecFeatAxis_featureLabel1", a_rmeasSpecFeatAxis_featureLabel1);}
      else
        check_axis(a_rmeasSpecFeatAxis_featureLabel1->get_axis());
    }
}

/********************************************************************/

void check_rmeasSpecVecbld(
 rmeasSpecVecbld * a_rmeasSpecVecbld)
{
  if (a_rmeasSpecVecbld->get_r())
    {
      if (!findString("r", rmeasSpecVecbldAtts))
	{warnAtt("r", "rmeasSpecVecbld", a_rmeasSpecVecbld);}
      else
        check_rentVal(a_rmeasSpecVecbld->get_r());
    }
  if (a_rmeasSpecVecbld->get_numPts())
    {
      if (!findString("numPts", rmeasSpecVecbldAtts))
	{warnAtt("numPts", "rmeasSpecVecbld", a_rmeasSpecVecbld);}
      else
        check_intVal(a_rmeasSpecVecbld->get_numPts());
    }
}

/********************************************************************/

void check_rmeasSpecVecbldEdgept(
 rmeasSpecVecbldEdgept * a_rmeasSpecVecbldEdgept)
{
  if (a_rmeasSpecVecbldEdgept->get_rmeasSpecVecbld())
    {
      if (!findString("a_rmeasSpecVecbld", rmeasSpecVecbldEdgeptAtts))
	{warnAtt("a_rmeasSpecVecbld", "rmeasSpecVecbldEdgept", a_rmeasSpecVecbldEdgept);}
      else
        check_rmeasSpecVecbld(a_rmeasSpecVecbldEdgept->get_rmeasSpecVecbld());
    }
  if (a_rmeasSpecVecbldEdgept->get_offset())
    {
      if (!findString("offset", rmeasSpecVecbldEdgeptAtts))
	{warnAtt("offset", "rmeasSpecVecbldEdgept", a_rmeasSpecVecbldEdgept);}
      else
        check_rentVal(a_rmeasSpecVecbldEdgept->get_offset());
    }
  if (a_rmeasSpecVecbldEdgept->get_posDir())
    {
      if (!findString("a_posDir", rmeasSpecVecbldEdgeptAtts))
	{warnAtt("a_posDir", "rmeasSpecVecbldEdgept", a_rmeasSpecVecbldEdgept);}
      else
        check_posDir(a_rmeasSpecVecbldEdgept->get_posDir());
    }
  if (a_rmeasSpecVecbldEdgept->get_axis())
    {
      if (!findString("a_axis", rmeasSpecVecbldEdgeptAtts))
	{warnAtt("a_axis", "rmeasSpecVecbldEdgept", a_rmeasSpecVecbldEdgept);}
      else
        check_axis(a_rmeasSpecVecbldEdgept->get_axis());
    }
}

/********************************************************************/

void check_rmeasSpecVecbldOrient(
 rmeasSpecVecbldOrient * a_rmeasSpecVecbldOrient)
{
  if (a_rmeasSpecVecbldOrient->get_rmeasSpecVecbld())
    {
      if (!findString("a_rmeasSpecVecbld", rmeasSpecVecbldOrientAtts))
	{warnAtt("a_rmeasSpecVecbld", "rmeasSpecVecbldOrient", a_rmeasSpecVecbldOrient);}
      else
        check_rmeasSpecVecbld(a_rmeasSpecVecbldOrient->get_rmeasSpecVecbld());
    }
  if (a_rmeasSpecVecbldOrient->get_has_ORIENT())
    {
      if (!findString("has_ORIENT", rmeasSpecVecbldOrientAtts))
	{warnAtt("has_ORIENT", "rmeasSpecVecbldOrient", a_rmeasSpecVecbldOrient);}
    }
}

/********************************************************************/

void check_rmeasSphere(
 rmeasSphere * a_rmeasSphere)
{
  if (a_rmeasSphere->get_fLabel())
    {
      if (!findString("a_fLabel", rmeasSphereAtts))
	{warnAtt("a_fLabel", "rmeasSphere", a_rmeasSphere);}
      else
        check_fLabel(a_rmeasSphere->get_fLabel());
    }
  if (a_rmeasSphere->get_numMeas())
    {
      if (!findString("numMeas", rmeasSphereAtts))
	{warnAtt("numMeas", "rmeasSphere", a_rmeasSphere);}
      else
        check_intVal(a_rmeasSphere->get_numMeas());
    }
  if (a_rmeasSphere->get_rmeasSpecFaAxis())
    {
      if (!findString("a_rmeasSpecFaAxis", rmeasSphereAtts))
	{warnAtt("a_rmeasSpecFaAxis", "rmeasSphere", a_rmeasSphere);}
      else
        check_rmeasSpecFaAxis(a_rmeasSphere->get_rmeasSpecFaAxis());
    }
}

/********************************************************************/

void check_rmeasStm(
 rmeasStm * a_rmeasStm)
{
  if (a_rmeasStm->get_rmeasMinor())
    {
      if (!findString("a_rmeasMinor", rmeasStmAtts))
	{warnAtt("a_rmeasMinor", "rmeasStm", a_rmeasStm);}
      else
        check_rmeasMinor(a_rmeasStm->get_rmeasMinor());
    }
}

/********************************************************************/

void check_rmeasSympln(
 rmeasSympln * a_rmeasSympln)
{
  if (a_rmeasSympln->get_fLabel())
    {
      if (!findString("a_fLabel", rmeasSymplnAtts))
	{warnAtt("a_fLabel", "rmeasSympln", a_rmeasSympln);}
      else
        check_fLabel(a_rmeasSympln->get_fLabel());
    }
  if (a_rmeasSympln->get_numMeas())
    {
      if (!findString("numMeas", rmeasSymplnAtts))
	{warnAtt("numMeas", "rmeasSympln", a_rmeasSympln);}
      else
        check_intVal(a_rmeasSympln->get_numMeas());
    }
  if (a_rmeasSympln->get_rmeasSpecFa())
    {
      if (!findString("a_rmeasSpecFa", rmeasSymplnAtts))
	{warnAtt("a_rmeasSpecFa", "rmeasSympln", a_rmeasSympln);}
      else
        check_rmeasSpecFa(a_rmeasSympln->get_rmeasSpecFa());
    }
}

/********************************************************************/

void check_rmeasTorus(
 rmeasTorus * a_rmeasTorus)
{
  if (a_rmeasTorus->get_fLabel())
    {
      if (!findString("a_fLabel", rmeasTorusAtts))
	{warnAtt("a_fLabel", "rmeasTorus", a_rmeasTorus);}
      else
        check_fLabel(a_rmeasTorus->get_fLabel());
    }
  if (a_rmeasTorus->get_numMeas())
    {
      if (!findString("numMeas", rmeasTorusAtts))
	{warnAtt("numMeas", "rmeasTorus", a_rmeasTorus);}
      else
        check_intVal(a_rmeasTorus->get_numMeas());
    }
  if (a_rmeasTorus->get_rmeasSpecFaAxis())
    {
      if (!findString("a_rmeasSpecFaAxis", rmeasTorusAtts))
	{warnAtt("a_rmeasSpecFaAxis", "rmeasTorus", a_rmeasTorus);}
      else
        check_rmeasSpecFaAxis(a_rmeasTorus->get_rmeasSpecFaAxis());
    }
}

/********************************************************************/

void check_rotAbs(
 rotAbs * a_rotAbs)
{
  if (a_rotAbs->get_rotDir())
    {
      if (!findString("a_rotDir", rotAbsAtts))
	{warnAtt("a_rotDir", "rotAbs", a_rotAbs);}
      else
        check_rotDir(a_rotAbs->get_rotDir());
    }
}

/********************************************************************/

void check_rotDir(
 rotDir * a_rotDir)
{
  if (isA(a_rotDir, rotDir_rotOrient))
    {
      if (!findString("rotDir_rotOrient", rotDirSubs))
        {warnSub("rotDir_rotOrient", "rotDir", a_rotDir);}
      else
        check_rotDir_rotOrient(dynamic_cast<rotDir_rotOrient *>(a_rotDir));
      return;
    }
  if (isA(a_rotDir, rotDir_SHORT))
    {
      if (!findString("rotDir_SHORT", rotDirSubs))
        {warnSub("rotDir_SHORT", "rotDir", a_rotDir);}
      return;
    }
}

/********************************************************************/

void check_rotDir_rotOrient(
 rotDir_rotOrient * a_rotDir_rotOrient)
{
  if (a_rotDir_rotOrient->get_rotOrient())
    {
      if (!findString("a_rotOrient", rotDir_rotOrientAtts))
	{warnAtt("a_rotOrient", "rotDir_rotOrient", a_rotDir_rotOrient);}
      else
        check_rotOrient(a_rotDir_rotOrient->get_rotOrient());
    }
}

/********************************************************************/

void check_rotIncr(
 rotIncr * a_rotIncr)
{
  if (a_rotIncr->get_rotOrient())
    {
      if (!findString("a_rotOrient", rotIncrAtts))
	{warnAtt("a_rotOrient", "rotIncr", a_rotIncr);}
      else
        check_rotOrient(a_rotIncr->get_rotOrient());
    }
}

/********************************************************************/

void check_rotOrient(
 rotOrient * a_rotOrient)
{
  if (isA(a_rotOrient, rotOrient_CW))
    {
      if (!findString("rotOrient_CW", rotOrientSubs))
        {warnSub("rotOrient_CW", "rotOrient", a_rotOrient);}
      return;
    }
  if (isA(a_rotOrient, rotOrient_CCW))
    {
      if (!findString("rotOrient_CCW", rotOrientSubs))
        {warnSub("rotOrient_CCW", "rotOrient", a_rotOrient);}
      return;
    }
}

/********************************************************************/

void check_rotType(
 rotType * a_rotType)
{
  if (isA(a_rotType, rotType_ROTTOT))
    {
      if (!findString("rotType_ROTTOT", rotTypeSubs))
        {warnSub("rotType_ROTTOT", "rotType", a_rotType);}
      return;
    }
  if (isA(a_rotType, rotType_ROTORG))
    {
      if (!findString("rotType_ROTORG", rotTypeSubs))
        {warnSub("rotType_ROTORG", "rotType", a_rotType);}
      return;
    }
  if (isA(a_rotType, rotType_ROTNUL))
    {
      if (!findString("rotType_ROTNUL", rotTypeSubs))
        {warnSub("rotType_ROTNUL", "rotType", a_rotType);}
      return;
    }
}

/********************************************************************/

void check_rotabAbs(
 rotabAbs * a_rotabAbs)
{
  if (a_rotabAbs->get_rtLabel())
    {
      if (!findString("a_rtLabel", rotabAbsAtts))
	{warnAtt("a_rtLabel", "rotabAbs", a_rotabAbs);}
      else
        check_rtLabel(a_rotabAbs->get_rtLabel());
    }
  if (a_rotabAbs->get_rotAbs())
    {
      if (!findString("a_rotAbs", rotabAbsAtts))
	{warnAtt("a_rotAbs", "rotabAbs", a_rotabAbs);}
      else
        check_rotAbs(a_rotabAbs->get_rotAbs());
    }
  if (a_rotabAbs->get_rotType())
    {
      if (!findString("a_rotType", rotabAbsAtts))
	{warnAtt("a_rotType", "rotabAbs", a_rotabAbs);}
      else
        check_rotType(a_rotabAbs->get_rotType());
    }
  if (a_rotabAbs->get_rotAngle())
    {
      if (!findString("rotAngle", rotabAbsAtts))
	{warnAtt("rotAngle", "rotabAbs", a_rotabAbs);}
      else
        check_angle(a_rotabAbs->get_rotAngle());
    }
  if (a_rotabAbs->get_maxDev())
    {
      if (!findString("maxDev", rotabAbsAtts))
	{warnAtt("maxDev", "rotabAbs", a_rotabAbs);}
      else
        check_angle(a_rotabAbs->get_maxDev());
    }
}

/********************************************************************/

void check_rotabFeat(
 rotabFeat * a_rotabFeat)
{
  if (a_rotabFeat->get_rtLabel())
    {
      if (!findString("a_rtLabel", rotabFeatAtts))
	{warnAtt("a_rtLabel", "rotabFeat", a_rotabFeat);}
      else
        check_rtLabel(a_rotabFeat->get_rtLabel());
    }
  if (a_rotabFeat->get_featureLabel())
    {
      if (!findString("a_featureLabel", rotabFeatAtts))
	{warnAtt("a_featureLabel", "rotabFeat", a_rotabFeat);}
      else
        check_featureLabel(a_rotabFeat->get_featureLabel());
    }
  if (a_rotabFeat->get_rotType())
    {
      if (!findString("a_rotType", rotabFeatAtts))
	{warnAtt("a_rotType", "rotabFeat", a_rotabFeat);}
      else
        check_rotType(a_rotabFeat->get_rotType());
    }
  if (a_rotabFeat->get_rotDir())
    {
      if (!findString("a_rotDir", rotabFeatAtts))
	{warnAtt("a_rotDir", "rotabFeat", a_rotabFeat);}
      else
        check_rotDir(a_rotabFeat->get_rotDir());
    }
}

/********************************************************************/

void check_rotabIncr(
 rotabIncr * a_rotabIncr)
{
  if (a_rotabIncr->get_rtLabel())
    {
      if (!findString("a_rtLabel", rotabIncrAtts))
	{warnAtt("a_rtLabel", "rotabIncr", a_rotabIncr);}
      else
        check_rtLabel(a_rotabIncr->get_rtLabel());
    }
  if (a_rotabIncr->get_rotIncr())
    {
      if (!findString("a_rotIncr", rotabIncrAtts))
	{warnAtt("a_rotIncr", "rotabIncr", a_rotabIncr);}
      else
        check_rotIncr(a_rotabIncr->get_rotIncr());
    }
  if (a_rotabIncr->get_rotType())
    {
      if (!findString("a_rotType", rotabIncrAtts))
	{warnAtt("a_rotType", "rotabIncr", a_rotabIncr);}
      else
        check_rotType(a_rotabIncr->get_rotType());
    }
  if (a_rotabIncr->get_rotAngle())
    {
      if (!findString("rotAngle", rotabIncrAtts))
	{warnAtt("rotAngle", "rotabIncr", a_rotabIncr);}
      else
        check_angle(a_rotabIncr->get_rotAngle());
    }
  if (a_rotabIncr->get_maxDev())
    {
      if (!findString("maxDev", rotabIncrAtts))
	{warnAtt("maxDev", "rotabIncr", a_rotabIncr);}
      else
        check_angle(a_rotabIncr->get_maxDev());
    }
}

/********************************************************************/

void check_rotabMinor(
 rotabMinor * a_rotabMinor)
{
  if (isA(a_rotabMinor, rotabAbs))
    {
      if (!findString("rotabAbs", rotabMinorSubs))
        {warnSub("rotabAbs", "rotabMinor", a_rotabMinor);}
      else
        check_rotabAbs(dynamic_cast<rotabAbs *>(a_rotabMinor));
      return;
    }
  if (isA(a_rotabMinor, rotabIncr))
    {
      if (!findString("rotabIncr", rotabMinorSubs))
        {warnSub("rotabIncr", "rotabMinor", a_rotabMinor);}
      else
        check_rotabIncr(dynamic_cast<rotabIncr *>(a_rotabMinor));
      return;
    }
  if (isA(a_rotabMinor, rotabFeat))
    {
      if (!findString("rotabFeat", rotabMinorSubs))
        {warnSub("rotabFeat", "rotabMinor", a_rotabMinor);}
      else
        check_rotabFeat(dynamic_cast<rotabFeat *>(a_rotabMinor));
      return;
    }
}

/********************************************************************/

void check_rotabStm(
 rotabStm * a_rotabStm)
{
  if (a_rotabStm->get_rotabMinor())
    {
      if (!findString("a_rotabMinor", rotabStmAtts))
	{warnAtt("a_rotabMinor", "rotabStm", a_rotabStm);}
      else
        check_rotabMinor(a_rotabStm->get_rotabMinor());
    }
}

/********************************************************************/

void check_rotateDatum(
 rotateDatum * a_rotateDatum)
{
  if (a_rotateDatum->get_axis())
    {
      if (!findString("a_axis", rotateDatumAtts))
	{warnAtt("a_axis", "rotateDatum", a_rotateDatum);}
      else
        check_axis(a_rotateDatum->get_axis());
    }
  if (a_rotateDatum->get_datLabel())
    {
      if (!findString("a_datLabel", rotateDatumAtts))
	{warnAtt("a_datLabel", "rotateDatum", a_rotateDatum);}
      else
        check_datLabel(a_rotateDatum->get_datLabel());
    }
  if (a_rotateDatum->get_dir())
    {
      if (!findString("a_dir", rotateDatumAtts))
	{warnAtt("a_dir", "rotateDatum", a_rotateDatum);}
      else
        check_dir(a_rotateDatum->get_dir());
    }
}

/********************************************************************/

void check_rotateFeature(
 rotateFeature * a_rotateFeature)
{
  if (a_rotateFeature->get_axis())
    {
      if (!findString("a_axis", rotateFeatureAtts))
	{warnAtt("a_axis", "rotateFeature", a_rotateFeature);}
      else
        check_axis(a_rotateFeature->get_axis());
    }
  if (a_rotateFeature->get_featureLabel())
    {
      if (!findString("a_featureLabel", rotateFeatureAtts))
	{warnAtt("a_featureLabel", "rotateFeature", a_rotateFeature);}
      else
        check_featureLabel(a_rotateFeature->get_featureLabel());
    }
  if (a_rotateFeature->get_dir())
    {
      if (!findString("a_dir", rotateFeatureAtts))
	{warnAtt("a_dir", "rotateFeature", a_rotateFeature);}
      else
        check_dir(a_rotateFeature->get_dir());
    }
}

/********************************************************************/

void check_rotateMinor(
 rotateMinor * a_rotateMinor)
{
  if (isA(a_rotateMinor, rotateValue))
    {
      if (!findString("rotateValue", rotateMinorSubs))
        {warnSub("rotateValue", "rotateMinor", a_rotateMinor);}
      else
        check_rotateValue(dynamic_cast<rotateValue *>(a_rotateMinor));
      return;
    }
  if (isA(a_rotateMinor, rotateFeature))
    {
      if (!findString("rotateFeature", rotateMinorSubs))
        {warnSub("rotateFeature", "rotateMinor", a_rotateMinor);}
      else
        check_rotateFeature(dynamic_cast<rotateFeature *>(a_rotateMinor));
      return;
    }
  if (isA(a_rotateMinor, rotateDatum))
    {
      if (!findString("rotateDatum", rotateMinorSubs))
        {warnSub("rotateDatum", "rotateMinor", a_rotateMinor);}
      else
        check_rotateDatum(dynamic_cast<rotateDatum *>(a_rotateMinor));
      return;
    }
}

/********************************************************************/

void check_rotateStm(
 rotateStm * a_rotateStm)
{
  if (a_rotateStm->get_dLabel())
    {
      if (!findString("a_dLabel", rotateStmAtts))
	{warnAtt("a_dLabel", "rotateStm", a_rotateStm);}
      else
        check_dLabel(a_rotateStm->get_dLabel());
    }
  if (a_rotateStm->get_rotateMinor())
    {
      if (!findString("a_rotateMinor", rotateStmAtts))
	{warnAtt("a_rotateMinor", "rotateStm", a_rotateStm);}
      else
        check_rotateMinor(a_rotateStm->get_rotateMinor());
    }
}

/********************************************************************/

void check_rotateValue(
 rotateValue * a_rotateValue)
{
  if (a_rotateValue->get_axis())
    {
      if (!findString("a_axis", rotateValueAtts))
	{warnAtt("a_axis", "rotateValue", a_rotateValue);}
      else
        check_axis(a_rotateValue->get_axis());
    }
  if (a_rotateValue->get_angle())
    {
      if (!findString("a_angle", rotateValueAtts))
	{warnAtt("a_angle", "rotateValue", a_rotateValue);}
      else
        check_angle(a_rotateValue->get_angle());
    }
}

/********************************************************************/

void check_rotdefStm(
 rotdefStm * a_rotdefStm)
{
  if (a_rotdefStm->get_theTable())
    {
      if (!findString("theTable", rotdefStmAtts))
	{warnAtt("theTable", "rotdefStm", a_rotdefStm);}
      else
        check_rtLabel(a_rotdefStm->get_theTable());
    }
  if (a_rotdefStm->get_pointVecCart())
    {
      if (!findString("a_pointVecCart", rotdefStmAtts))
	{warnAtt("a_pointVecCart", "rotdefStm", a_rotdefStm);}
      else
        check_pointVecCart(a_rotdefStm->get_pointVecCart());
    }
  if (a_rotdefStm->get_otherTable())
    {
      if (!findString("otherTable", rotdefStmAtts))
	{warnAtt("otherTable", "rotdefStm", a_rotdefStm);}
      else
        check_rtLabel(a_rotdefStm->get_otherTable());
    }
}

/********************************************************************/

void check_rotsetStm(
 rotsetStm * a_rotsetStm)
{
  if (a_rotsetStm->get_rtLabel())
    {
      if (!findString("a_rtLabel", rotsetStmAtts))
	{warnAtt("a_rtLabel", "rotsetStm", a_rotsetStm);}
      else
        check_rtLabel(a_rotsetStm->get_rtLabel());
    }
  if (a_rotsetStm->get_angle())
    {
      if (!findString("a_angle", rotsetStmAtts))
	{warnAtt("a_angle", "rotsetStm", a_rotsetStm);}
      else
        check_angle(a_rotsetStm->get_angle());
    }
}

/********************************************************************/

void check_rtLabel(
 rtLabel * a_rtLabel)
{
  if (a_rtLabel->get_labelName())
    {
      if (!findString("a_labelName", rtLabelAtts))
	{warnAtt("a_labelName", "rtLabel", a_rtLabel);}
      else
        check_labelName(a_rtLabel->get_labelName());
    }
}

/********************************************************************/

void check_rwFormat(
 rwFormat * a_rwFormat)
{
  if (a_rwFormat->get_width())
    {
      if (!findString("width", rwFormatAtts))
	{warnAtt("width", "rwFormat", a_rwFormat);}
      else
        check_intVal(a_rwFormat->get_width());
    }
  if (a_rwFormat->get_decimal())
    {
      if (!findString("decimal", rwFormatAtts))
	{warnAtt("decimal", "rwFormat", a_rwFormat);}
      else
        check_intVal(a_rwFormat->get_decimal());
    }
}

/********************************************************************/

void check_rwVar(
 rwVar * a_rwVar)
{
  if (isA(a_rwVar, stringVar))
    {
      if (!findString("stringVar", rwVarSubs))
        {warnSub("stringVar", "rwVar", a_rwVar);}
      else
        check_stringVar(dynamic_cast<stringVar *>(a_rwVar));
      return;
    }
  if (isA(a_rwVar, boolVar))
    {
      if (!findString("boolVar", rwVarSubs))
        {warnSub("boolVar", "rwVar", a_rwVar);}
      else
        check_boolVar(dynamic_cast<boolVar *>(a_rwVar));
      return;
    }
  if (isA(a_rwVar, intVar))
    {
      if (!findString("intVar", rwVarSubs))
        {warnSub("intVar", "rwVar", a_rwVar);}
      else
        check_intVar(dynamic_cast<intVar *>(a_rwVar));
      return;
    }
  if (isA(a_rwVar, realVar))
    {
      if (!findString("realVar", rwVarSubs))
        {warnSub("realVar", "rwVar", a_rwVar);}
      else
        check_realVar(dynamic_cast<realVar *>(a_rwVar));
      return;
    }
  if (isA(a_rwVar, vectorVar))
    {
      if (!findString("vectorVar", rwVarSubs))
        {warnSub("vectorVar", "rwVar", a_rwVar);}
      else
        check_vectorVar(dynamic_cast<vectorVar *>(a_rwVar));
      return;
    }
}

/********************************************************************/

void check_sLabel(
 sLabel * a_sLabel)
{
  if (a_sLabel->get_labelName())
    {
      if (!findString("a_labelName", sLabelAtts))
	{warnAtt("a_labelName", "sLabel", a_sLabel);}
      else
        check_labelName(a_sLabel->get_labelName());
    }
}

/********************************************************************/

void check_saLabel(
 saLabel * a_saLabel)
{
  if (a_saLabel->get_labelName())
    {
      if (!findString("a_labelName", saLabelAtts))
	{warnAtt("a_labelName", "saLabel", a_saLabel);}
      else
        check_labelName(a_saLabel->get_labelName());
    }
}

/********************************************************************/

void check_saveDMLStm(
 saveDMLStm * a_saveDMLStm)
{
  if (a_saveDMLStm->get_didLabel())
    {
      if (!findString("a_didLabel", saveDMLStmAtts))
	{warnAtt("a_didLabel", "saveDMLStm", a_saveDMLStm);}
      else
        check_didLabel(a_saveDMLStm->get_didLabel());
    }
  if (a_saveDMLStm->get_daLabel())
    {
      if (!findString("a_daLabel", saveDMLStmAtts))
	{warnAtt("a_daLabel", "saveDMLStm", a_saveDMLStm);}
      else
        check_daLabel(a_saveDMLStm->get_daLabel());
    }
}

/********************************************************************/

void check_saveDatumStm(
 saveDatumStm * a_saveDatumStm)
{
  if (a_saveDatumStm->get_datumLabel1())
    {
      if (!findString("a_datumLabel1", saveDatumStmAtts))
	{warnAtt("a_datumLabel1", "saveDatumStm", a_saveDatumStm);}
      else
        check_datumLabel1(a_saveDatumStm->get_datumLabel1());
    }
  if (a_saveDatumStm->get_didLabel())
    {
      if (!findString("a_didLabel", saveDatumStmAtts))
	{warnAtt("a_didLabel", "saveDatumStm", a_saveDatumStm);}
      else
        check_didLabel(a_saveDatumStm->get_didLabel());
    }
}

/********************************************************************/

void check_saveFeatureStm(
 saveFeatureStm * a_saveFeatureStm)
{
  if (a_saveFeatureStm->get_faLabel())
    {
      if (!findString("a_faLabel", saveFeatureStmAtts))
	{warnAtt("a_faLabel", "saveFeatureStm", a_saveFeatureStm);}
      else
        check_faLabel(a_saveFeatureStm->get_faLabel());
    }
  if (a_saveFeatureStm->get_didLabel())
    {
      if (!findString("a_didLabel", saveFeatureStmAtts))
	{warnAtt("a_didLabel", "saveFeatureStm", a_saveFeatureStm);}
      else
        check_didLabel(a_saveFeatureStm->get_didLabel());
    }
}

/********************************************************************/

void check_saveRotaryTableStm(
 saveRotaryTableStm * a_saveRotaryTableStm)
{
  if (a_saveRotaryTableStm->get_rtLabel())
    {
      if (!findString("a_rtLabel", saveRotaryTableStmAtts))
	{warnAtt("a_rtLabel", "saveRotaryTableStm", a_saveRotaryTableStm);}
      else
        check_rtLabel(a_saveRotaryTableStm->get_rtLabel());
    }
  if (a_saveRotaryTableStm->get_didLabel())
    {
      if (!findString("a_didLabel", saveRotaryTableStmAtts))
	{warnAtt("a_didLabel", "saveRotaryTableStm", a_saveRotaryTableStm);}
      else
        check_didLabel(a_saveRotaryTableStm->get_didLabel());
    }
}

/********************************************************************/

void check_saveSensorStm(
 saveSensorStm * a_saveSensorStm)
{
  if (a_saveSensorStm->get_sensorLabel1())
    {
      if (!findString("a_sensorLabel1", saveSensorStmAtts))
	{warnAtt("a_sensorLabel1", "saveSensorStm", a_saveSensorStm);}
      else
        check_sensorLabel1(a_saveSensorStm->get_sensorLabel1());
    }
  if (a_saveSensorStm->get_didLabel())
    {
      if (!findString("a_didLabel", saveSensorStmAtts))
	{warnAtt("a_didLabel", "saveSensorStm", a_saveSensorStm);}
      else
        check_didLabel(a_saveSensorStm->get_didLabel());
    }
}

/********************************************************************/

void check_scnmodStm(
 scnmodStm * a_scnmodStm)
{
  if (a_scnmodStm->get_state())
    {
      if (!findString("a_state", scnmodStmAtts))
	{warnAtt("a_state", "scnmodStm", a_scnmodStm);}
      else
        check_state(a_scnmodStm->get_state());
    }
}

/********************************************************************/

void check_scnsetDrag(
 scnsetDrag * a_scnsetDrag)
{
  if (a_scnsetDrag->get_scnsetSampleDrag())
    {
      if (!findString("a_scnsetSampleDrag", scnsetDragAtts))
	{warnAtt("a_scnsetSampleDrag", "scnsetDrag", a_scnsetDrag);}
      else
        check_scnsetSampleDrag(a_scnsetDrag->get_scnsetSampleDrag());
    }
}

/********************************************************************/

void check_scnsetMinor(
 scnsetMinor * a_scnsetMinor)
{
  if (isA(a_scnsetMinor, scnsetPeck))
    {
      if (!findString("scnsetPeck", scnsetMinorSubs))
        {warnSub("scnsetPeck", "scnsetMinor", a_scnsetMinor);}
      else
        check_scnsetPeck(dynamic_cast<scnsetPeck *>(a_scnsetMinor));
      return;
    }
  if (isA(a_scnsetMinor, scnsetDrag))
    {
      if (!findString("scnsetDrag", scnsetMinorSubs))
        {warnSub("scnsetDrag", "scnsetMinor", a_scnsetMinor);}
      else
        check_scnsetDrag(dynamic_cast<scnsetDrag *>(a_scnsetMinor));
      return;
    }
  if (isA(a_scnsetMinor, scnsetNoncon))
    {
      if (!findString("scnsetNoncon", scnsetMinorSubs))
        {warnSub("scnsetNoncon", "scnsetMinor", a_scnsetMinor);}
      else
        check_scnsetNoncon(dynamic_cast<scnsetNoncon *>(a_scnsetMinor));
      return;
    }
  if (isA(a_scnsetMinor, scnsetStop))
    {
      if (!findString("scnsetStop", scnsetMinorSubs))
        {warnSub("scnsetStop", "scnsetMinor", a_scnsetMinor);}
      else
        check_scnsetStop(dynamic_cast<scnsetStop *>(a_scnsetMinor));
      return;
    }
  if (isA(a_scnsetMinor, scnsetVendor))
    {
      if (!findString("scnsetVendor", scnsetMinorSubs))
        {warnSub("scnsetVendor", "scnsetMinor", a_scnsetMinor);}
      else
        check_scnsetVendor(dynamic_cast<scnsetVendor *>(a_scnsetMinor));
      return;
    }
}

/********************************************************************/

void check_scnsetNoncon(
 scnsetNoncon * a_scnsetNoncon)
{
  if (a_scnsetNoncon->get_scnsetSample())
    {
      if (!findString("a_scnsetSample", scnsetNonconAtts))
	{warnAtt("a_scnsetSample", "scnsetNoncon", a_scnsetNoncon);}
      else
        check_scnsetSample(a_scnsetNoncon->get_scnsetSample());
    }
}

/********************************************************************/

void check_scnsetPeck(
 scnsetPeck * a_scnsetPeck)
{
  if (a_scnsetPeck->get_scnsetSample())
    {
      if (!findString("a_scnsetSample", scnsetPeckAtts))
	{warnAtt("a_scnsetSample", "scnsetPeck", a_scnsetPeck);}
      else
        check_scnsetSample(a_scnsetPeck->get_scnsetSample());
    }
}

/********************************************************************/

void check_scnsetSample(
 scnsetSample * a_scnsetSample)
{
  if (isA(a_scnsetSample, scnsetSample_DIST))
    {
      if (!findString("scnsetSample_DIST", scnsetSampleSubs))
        {warnSub("scnsetSample_DIST", "scnsetSample", a_scnsetSample);}
      else
        check_scnsetSample_DIST(dynamic_cast<scnsetSample_DIST *>(a_scnsetSample));
      return;
    }
  if (isA(a_scnsetSample, scnsetSample_CHORD))
    {
      if (!findString("scnsetSample_CHORD", scnsetSampleSubs))
        {warnSub("scnsetSample_CHORD", "scnsetSample", a_scnsetSample);}
      else
        check_scnsetSample_CHORD(dynamic_cast<scnsetSample_CHORD *>(a_scnsetSample));
      return;
    }
  if (isA(a_scnsetSample, scnsetSample_TIME))
    {
      if (!findString("scnsetSample_TIME", scnsetSampleSubs))
        {warnSub("scnsetSample_TIME", "scnsetSample", a_scnsetSample);}
      else
        check_scnsetSample_TIME(dynamic_cast<scnsetSample_TIME *>(a_scnsetSample));
      return;
    }
  if (isA(a_scnsetSample, scnsetSample_ANGLE))
    {
      if (!findString("scnsetSample_ANGLE", scnsetSampleSubs))
        {warnSub("scnsetSample_ANGLE", "scnsetSample", a_scnsetSample);}
      else
        check_scnsetSample_ANGLE(dynamic_cast<scnsetSample_ANGLE *>(a_scnsetSample));
      return;
    }
  if (isA(a_scnsetSample, scnsetSample_DEFALT))
    {
      if (!findString("scnsetSample_DEFALT", scnsetSampleSubs))
        {warnSub("scnsetSample_DEFALT", "scnsetSample", a_scnsetSample);}
      return;
    }
}

/********************************************************************/

void check_scnsetSampleDrag(
 scnsetSampleDrag * a_scnsetSampleDrag)
{
  if (isA(a_scnsetSampleDrag, scnsetSampleDrag_DIST))
    {
      if (!findString("scnsetSampleDrag_DIST", scnsetSampleDragSubs))
        {warnSub("scnsetSampleDrag_DIST", "scnsetSampleDrag", a_scnsetSampleDrag);}
      else
        check_scnsetSampleDrag_DIST(dynamic_cast<scnsetSampleDrag_DIST *>(a_scnsetSampleDrag));
      return;
    }
  if (isA(a_scnsetSampleDrag, scnsetSampleDrag_CHORD))
    {
      if (!findString("scnsetSampleDrag_CHORD", scnsetSampleDragSubs))
        {warnSub("scnsetSampleDrag_CHORD", "scnsetSampleDrag", a_scnsetSampleDrag);}
      else
        check_scnsetSampleDrag_CHORD(dynamic_cast<scnsetSampleDrag_CHORD *>(a_scnsetSampleDrag));
      return;
    }
  if (isA(a_scnsetSampleDrag, scnsetSampleDrag_TIME))
    {
      if (!findString("scnsetSampleDrag_TIME", scnsetSampleDragSubs))
        {warnSub("scnsetSampleDrag_TIME", "scnsetSampleDrag", a_scnsetSampleDrag);}
      else
        check_scnsetSampleDrag_TIME(dynamic_cast<scnsetSampleDrag_TIME *>(a_scnsetSampleDrag));
      return;
    }
  if (isA(a_scnsetSampleDrag, scnsetSampleDrag_ANGLE))
    {
      if (!findString("scnsetSampleDrag_ANGLE", scnsetSampleDragSubs))
        {warnSub("scnsetSampleDrag_ANGLE", "scnsetSampleDrag", a_scnsetSampleDrag);}
      else
        check_scnsetSampleDrag_ANGLE(dynamic_cast<scnsetSampleDrag_ANGLE *>(a_scnsetSampleDrag));
      return;
    }
  if (isA(a_scnsetSampleDrag, scnsetSampleDrag_DEFALT))
    {
      if (!findString("scnsetSampleDrag_DEFALT", scnsetSampleDragSubs))
        {warnSub("scnsetSampleDrag_DEFALT", "scnsetSampleDrag", a_scnsetSampleDrag);}
      else
        check_scnsetSampleDrag_DEFALT(dynamic_cast<scnsetSampleDrag_DEFALT *>(a_scnsetSampleDrag));
      return;
    }
}

/********************************************************************/

void check_scnsetSampleDrag_ANGLE(
 scnsetSampleDrag_ANGLE * a_scnsetSampleDrag_ANGLE)
{
  if (a_scnsetSampleDrag_ANGLE->get_angle())
    {
      if (!findString("a_angle", scnsetSampleDrag_ANGLEAtts))
	{warnAtt("a_angle", "scnsetSampleDrag_ANGLE", a_scnsetSampleDrag_ANGLE);}
      else
        check_angle(a_scnsetSampleDrag_ANGLE->get_angle());
    }
  if (a_scnsetSampleDrag_ANGLE->get_forceOrDeflection())
    {
      if (!findString("a_forceOrDeflection", scnsetSampleDrag_ANGLEAtts))
	{warnAtt("a_forceOrDeflection", "scnsetSampleDrag_ANGLE", a_scnsetSampleDrag_ANGLE);}
      else
        check_forceOrDeflection(a_scnsetSampleDrag_ANGLE->get_forceOrDeflection());
    }
}

/********************************************************************/

void check_scnsetSampleDrag_CHORD(
 scnsetSampleDrag_CHORD * a_scnsetSampleDrag_CHORD)
{
  if (a_scnsetSampleDrag_CHORD->get_chord())
    {
      if (!findString("chord", scnsetSampleDrag_CHORDAtts))
	{warnAtt("chord", "scnsetSampleDrag_CHORD", a_scnsetSampleDrag_CHORD);}
      else
        check_rentVal(a_scnsetSampleDrag_CHORD->get_chord());
    }
  if (a_scnsetSampleDrag_CHORD->get_maxdist())
    {
      if (!findString("maxdist", scnsetSampleDrag_CHORDAtts))
	{warnAtt("maxdist", "scnsetSampleDrag_CHORD", a_scnsetSampleDrag_CHORD);}
      else
        check_rentVal(a_scnsetSampleDrag_CHORD->get_maxdist());
    }
  if (a_scnsetSampleDrag_CHORD->get_forceOrDeflection())
    {
      if (!findString("a_forceOrDeflection", scnsetSampleDrag_CHORDAtts))
	{warnAtt("a_forceOrDeflection", "scnsetSampleDrag_CHORD", a_scnsetSampleDrag_CHORD);}
      else
        check_forceOrDeflection(a_scnsetSampleDrag_CHORD->get_forceOrDeflection());
    }
}

/********************************************************************/

void check_scnsetSampleDrag_DEFALT(
 scnsetSampleDrag_DEFALT * a_scnsetSampleDrag_DEFALT)
{
  if (a_scnsetSampleDrag_DEFALT->get_forceOrDeflection())
    {
      if (!findString("a_forceOrDeflection", scnsetSampleDrag_DEFALTAtts))
	{warnAtt("a_forceOrDeflection", "scnsetSampleDrag_DEFALT", a_scnsetSampleDrag_DEFALT);}
      else
        check_forceOrDeflection(a_scnsetSampleDrag_DEFALT->get_forceOrDeflection());
    }
}

/********************************************************************/

void check_scnsetSampleDrag_DIST(
 scnsetSampleDrag_DIST * a_scnsetSampleDrag_DIST)
{
  if (a_scnsetSampleDrag_DIST->get_dist())
    {
      if (!findString("dist", scnsetSampleDrag_DISTAtts))
	{warnAtt("dist", "scnsetSampleDrag_DIST", a_scnsetSampleDrag_DIST);}
      else
        check_rentVal(a_scnsetSampleDrag_DIST->get_dist());
    }
  if (a_scnsetSampleDrag_DIST->get_axis())
    {
      if (!findString("a_axis", scnsetSampleDrag_DISTAtts))
	{warnAtt("a_axis", "scnsetSampleDrag_DIST", a_scnsetSampleDrag_DIST);}
      else
        check_axis(a_scnsetSampleDrag_DIST->get_axis());
    }
  if (a_scnsetSampleDrag_DIST->get_forceOrDeflection())
    {
      if (!findString("a_forceOrDeflection", scnsetSampleDrag_DISTAtts))
	{warnAtt("a_forceOrDeflection", "scnsetSampleDrag_DIST", a_scnsetSampleDrag_DIST);}
      else
        check_forceOrDeflection(a_scnsetSampleDrag_DIST->get_forceOrDeflection());
    }
}

/********************************************************************/

void check_scnsetSampleDrag_TIME(
 scnsetSampleDrag_TIME * a_scnsetSampleDrag_TIME)
{
  if (a_scnsetSampleDrag_TIME->get_time())
    {
      if (!findString("time", scnsetSampleDrag_TIMEAtts))
	{warnAtt("time", "scnsetSampleDrag_TIME", a_scnsetSampleDrag_TIME);}
      else
        check_rentVal(a_scnsetSampleDrag_TIME->get_time());
    }
  if (a_scnsetSampleDrag_TIME->get_forceOrDeflection())
    {
      if (!findString("a_forceOrDeflection", scnsetSampleDrag_TIMEAtts))
	{warnAtt("a_forceOrDeflection", "scnsetSampleDrag_TIME", a_scnsetSampleDrag_TIME);}
      else
        check_forceOrDeflection(a_scnsetSampleDrag_TIME->get_forceOrDeflection());
    }
}

/********************************************************************/

void check_scnsetSample_ANGLE(
 scnsetSample_ANGLE * a_scnsetSample_ANGLE)
{
  if (a_scnsetSample_ANGLE->get_angle())
    {
      if (!findString("a_angle", scnsetSample_ANGLEAtts))
	{warnAtt("a_angle", "scnsetSample_ANGLE", a_scnsetSample_ANGLE);}
      else
        check_angle(a_scnsetSample_ANGLE->get_angle());
    }
}

/********************************************************************/

void check_scnsetSample_CHORD(
 scnsetSample_CHORD * a_scnsetSample_CHORD)
{
  if (a_scnsetSample_CHORD->get_chord())
    {
      if (!findString("chord", scnsetSample_CHORDAtts))
	{warnAtt("chord", "scnsetSample_CHORD", a_scnsetSample_CHORD);}
      else
        check_rentVal(a_scnsetSample_CHORD->get_chord());
    }
  if (a_scnsetSample_CHORD->get_maxdist())
    {
      if (!findString("maxdist", scnsetSample_CHORDAtts))
	{warnAtt("maxdist", "scnsetSample_CHORD", a_scnsetSample_CHORD);}
      else
        check_rentVal(a_scnsetSample_CHORD->get_maxdist());
    }
}

/********************************************************************/

void check_scnsetSample_DIST(
 scnsetSample_DIST * a_scnsetSample_DIST)
{
  if (a_scnsetSample_DIST->get_dist())
    {
      if (!findString("dist", scnsetSample_DISTAtts))
	{warnAtt("dist", "scnsetSample_DIST", a_scnsetSample_DIST);}
      else
        check_rentVal(a_scnsetSample_DIST->get_dist());
    }
  if (a_scnsetSample_DIST->get_axis())
    {
      if (!findString("a_axis", scnsetSample_DISTAtts))
	{warnAtt("a_axis", "scnsetSample_DIST", a_scnsetSample_DIST);}
      else
        check_axis(a_scnsetSample_DIST->get_axis());
    }
}

/********************************************************************/

void check_scnsetSample_TIME(
 scnsetSample_TIME * a_scnsetSample_TIME)
{
  if (a_scnsetSample_TIME->get_time())
    {
      if (!findString("time", scnsetSample_TIMEAtts))
	{warnAtt("time", "scnsetSample_TIME", a_scnsetSample_TIME);}
      else
        check_rentVal(a_scnsetSample_TIME->get_time());
    }
}

/********************************************************************/

void check_scnsetStm(
 scnsetStm * a_scnsetStm)
{
  if (a_scnsetStm->get_scnsetMinor())
    {
      if (!findString("a_scnsetMinor", scnsetStmAtts))
	{warnAtt("a_scnsetMinor", "scnsetStm", a_scnsetStm);}
      else
        check_scnsetMinor(a_scnsetStm->get_scnsetMinor());
    }
}

/********************************************************************/

void check_scnsetStop(
 scnsetStop * a_scnsetStop)
{
  if (isA(a_scnsetStop, scnsetStopPlane))
    {
      if (!findString("scnsetStopPlane", scnsetStopSubs))
        {warnSub("scnsetStopPlane", "scnsetStop", a_scnsetStop);}
      else
        check_scnsetStopPlane(dynamic_cast<scnsetStopPlane *>(a_scnsetStop));
      return;
    }
  if (isA(a_scnsetStop, scnsetStopSphere))
    {
      if (!findString("scnsetStopSphere", scnsetStopSubs))
        {warnSub("scnsetStopSphere", "scnsetStop", a_scnsetStop);}
      else
        check_scnsetStopSphere(dynamic_cast<scnsetStopSphere *>(a_scnsetStop));
      return;
    }
}

/********************************************************************/

void check_scnsetStopPlane(
 scnsetStopPlane * a_scnsetStopPlane)
{
  if (a_scnsetStopPlane->get_planeVec())
    {
      if (!findString("planeVec", scnsetStopPlaneAtts))
	{warnAtt("planeVec", "scnsetStopPlane", a_scnsetStopPlane);}
      else
        check_vector(a_scnsetStopPlane->get_planeVec());
    }
  if (a_scnsetStopPlane->get_radius())
    {
      if (!findString("radius", scnsetStopPlaneAtts))
	{warnAtt("radius", "scnsetStopPlane", a_scnsetStopPlane);}
      else
        check_rentVal(a_scnsetStopPlane->get_radius());
    }
  if (a_scnsetStopPlane->get_count())
    {
      if (!findString("count", scnsetStopPlaneAtts))
	{warnAtt("count", "scnsetStopPlane", a_scnsetStopPlane);}
      else
        check_intVal(a_scnsetStopPlane->get_count());
    }
}

/********************************************************************/

void check_scnsetStopSphere(
 scnsetStopSphere * a_scnsetStopSphere)
{
  if (a_scnsetStopSphere->get_radius())
    {
      if (!findString("radius", scnsetStopSphereAtts))
	{warnAtt("radius", "scnsetStopSphere", a_scnsetStopSphere);}
      else
        check_rentVal(a_scnsetStopSphere->get_radius());
    }
}

/********************************************************************/

void check_scnsetVendor(
 scnsetVendor * a_scnsetVendor)
{
  if (isA(a_scnsetVendor, scnsetVendor_FORM))
    {
      if (!findString("scnsetVendor_FORM", scnsetVendorSubs))
        {warnSub("scnsetVendor_FORM", "scnsetVendor", a_scnsetVendor);}
      return;
    }
  if (isA(a_scnsetVendor, scnsetVendor_POS))
    {
      if (!findString("scnsetVendor_POS", scnsetVendorSubs))
        {warnSub("scnsetVendor_POS", "scnsetVendor", a_scnsetVendor);}
      return;
    }
  if (isA(a_scnsetVendor, scnsetVendor_SIZE))
    {
      if (!findString("scnsetVendor_SIZE", scnsetVendorSubs))
        {warnSub("scnsetVendor_SIZE", "scnsetVendor", a_scnsetVendor);}
      return;
    }
}

/********************************************************************/

void check_seLabel(
 seLabel * a_seLabel)
{
  if (a_seLabel->get_labelName())
    {
      if (!findString("a_labelName", seLabelAtts))
	{warnAtt("a_labelName", "seLabel", a_seLabel);}
      else
        check_labelName(a_seLabel->get_labelName());
    }
}

/********************************************************************/

void check_secondsString(
 secondsString * a_secondsString)
{
  if (isA(a_secondsString, secondsString_REALSTRING))
    {
      if (!findString("secondsString_REALSTRING", secondsStringSubs))
        {warnSub("secondsString_REALSTRING", "secondsString", a_secondsString);}
      else
        check_secondsString_REALSTRING(dynamic_cast<secondsString_REALSTRING *>(a_secondsString));
      return;
    }
  if (isA(a_secondsString, secondsString_INTSTRING))
    {
      if (!findString("secondsString_INTSTRING", secondsStringSubs))
        {warnSub("secondsString_INTSTRING", "secondsString", a_secondsString);}
      else
        check_secondsString_INTSTRING(dynamic_cast<secondsString_INTSTRING *>(a_secondsString));
      return;
    }
}

/********************************************************************/

void check_secondsString_INTSTRING(
 secondsString_INTSTRING * a_secondsString_INTSTRING)
{
  if (a_secondsString_INTSTRING->get_int())
    {
      if (!findString("a_int", secondsString_INTSTRINGAtts))
	{warnAtt("a_int", "secondsString_INTSTRING", a_secondsString_INTSTRING);}
    }
}

/********************************************************************/

void check_secondsString_REALSTRING(
 secondsString_REALSTRING * a_secondsString_REALSTRING)
{
  if (a_secondsString_REALSTRING->get_double())
    {
      if (!findString("a_double", secondsString_REALSTRINGAtts))
	{warnAtt("a_double", "secondsString_REALSTRING", a_secondsString_REALSTRING);}
    }
}

/********************************************************************/

void check_selectBlock(
 selectBlock * a_selectBlock)
{
  if (a_selectBlock->get_selectStm())
    {
      if (!findString("a_selectStm", selectBlockAtts))
	{warnAttBlock("selectStm", a_selectBlock->get_selectStm());}
      else
        check_selectStm(a_selectBlock->get_selectStm());
    }
  if (a_selectBlock->get_caseBlockList())
    {
      if (!findString("a_caseBlockList", selectBlockAtts))
	{warnAttBlock("caseBlockList", a_selectBlock->get_caseBlockList()->front());}
      else
        {
          std::list<caseBlock *> * theList;
          std::list<caseBlock *>::iterator iter;
          theList = a_selectBlock->get_caseBlockList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_caseBlock(*iter);
        }
    }
  if (a_selectBlock->get_defaultCaseBlock())
    {
      if (!findString("a_defaultCaseBlock", selectBlockAtts))
	{warnAttBlock("defaultCaseBlock", a_selectBlock->get_defaultCaseBlock());}
      else
        check_defaultCaseBlock(a_selectBlock->get_defaultCaseBlock());
    }
  if (a_selectBlock->get_endselStm())
    {
      if (!findString("a_endselStm", selectBlockAtts))
	{warnAttBlock("endselStm", a_selectBlock->get_endselStm());}
    }
}

/********************************************************************/

void check_selectStm(
 selectStm * a_selectStm)
{
  if (isA(a_selectStm, selectStmInt))
    {
      if (!findString("selectStmInt", selectStmSubs))
        {warnSub("selectStmInt", "selectStm", a_selectStm);}
      else
        check_selectStmInt(dynamic_cast<selectStmInt *>(a_selectStm));
      return;
    }
  if (isA(a_selectStm, selectStmString))
    {
      if (!findString("selectStmString", selectStmSubs))
        {warnSub("selectStmString", "selectStm", a_selectStm);}
      else
        check_selectStmString(dynamic_cast<selectStmString *>(a_selectStm));
      return;
    }
}

/********************************************************************/

void check_selectStmInt(
 selectStmInt * a_selectStmInt)
{
  if (a_selectStmInt->get_arg())
    {
      if (!findString("arg", selectStmIntAtts))
	{warnAtt("arg", "selectStmInt", a_selectStmInt);}
      else
        check_intVal(a_selectStmInt->get_arg());
    }
}

/********************************************************************/

void check_selectStmString(
 selectStmString * a_selectStmString)
{
  if (a_selectStmString->get_arg())
    {
      if (!findString("arg", selectStmStringAtts))
	{warnAtt("arg", "selectStmString", a_selectStmString);}
      else
        check_stringVal(a_selectStmString->get_arg());
    }
}

/********************************************************************/

void check_sensorArea(
 sensorArea * a_sensorArea)
{
  if (a_sensorArea->get_sensorGeometry())
    {
      if (!findString("a_sensorGeometry", sensorAreaAtts))
	{warnAtt("a_sensorGeometry", "sensorArea", a_sensorArea);}
      else
        check_sensorGeometry(a_sensorArea->get_sensorGeometry());
    }
  if (a_sensorArea->get_fovc())
    {
      if (!findString("fovc", sensorAreaAtts))
	{warnAtt("fovc", "sensorArea", a_sensorArea);}
      else
        check_rentVal(a_sensorArea->get_fovc());
    }
  if (a_sensorArea->get_fovo())
    {
      if (!findString("fovo", sensorAreaAtts))
	{warnAtt("fovo", "sensorArea", a_sensorArea);}
      else
        check_rentVal(a_sensorArea->get_fovo());
    }
  if (a_sensorArea->get_fovn())
    {
      if (!findString("fovn", sensorAreaAtts))
	{warnAtt("fovn", "sensorArea", a_sensorArea);}
      else
        check_rentVal(a_sensorArea->get_fovn());
    }
  if (a_sensorArea->get_sensorItem())
    {
      if (!findString("a_sensorItem", sensorAreaAtts))
	{warnAtt("a_sensorItem", "sensorArea", a_sensorArea);}
      else
        check_sensorItem(a_sensorArea->get_sensorItem());
    }
}

/********************************************************************/

void check_sensorGeometry(
 sensorGeometry * a_sensorGeometry)
{
  if (a_sensorGeometry->get_offset())
    {
      if (!findString("offset", sensorGeometryAtts))
	{warnAtt("offset", "sensorGeometry", a_sensorGeometry);}
      else
        check_vector(a_sensorGeometry->get_offset());
    }
  if (a_sensorGeometry->get_normal())
    {
      if (!findString("normal", sensorGeometryAtts))
	{warnAtt("normal", "sensorGeometry", a_sensorGeometry);}
      else
        check_vector(a_sensorGeometry->get_normal());
    }
  if (a_sensorGeometry->get_clock())
    {
      if (!findString("clock", sensorGeometryAtts))
	{warnAtt("clock", "sensorGeometry", a_sensorGeometry);}
      else
        check_vector(a_sensorGeometry->get_clock());
    }
}

/********************************************************************/

void check_sensorInfred(
 sensorInfred * a_sensorInfred)
{
  if (a_sensorInfred->get_sensorGeometry())
    {
      if (!findString("a_sensorGeometry", sensorInfredAtts))
	{warnAtt("a_sensorGeometry", "sensorInfred", a_sensorInfred);}
      else
        check_sensorGeometry(a_sensorInfred->get_sensorGeometry());
    }
  if (a_sensorInfred->get_fovx())
    {
      if (!findString("fovx", sensorInfredAtts))
	{warnAtt("fovx", "sensorInfred", a_sensorInfred);}
      else
        check_rentVal(a_sensorInfred->get_fovx());
    }
  if (a_sensorInfred->get_fovy())
    {
      if (!findString("fovy", sensorInfredAtts))
	{warnAtt("fovy", "sensorInfred", a_sensorInfred);}
      else
        check_rentVal(a_sensorInfred->get_fovy());
    }
  if (a_sensorInfred->get_freq())
    {
      if (!findString("freq", sensorInfredAtts))
	{warnAtt("freq", "sensorInfred", a_sensorInfred);}
      else
        check_rentVal(a_sensorInfred->get_freq());
    }
  if (a_sensorInfred->get_dwell())
    {
      if (!findString("dwell", sensorInfredAtts))
	{warnAtt("dwell", "sensorInfred", a_sensorInfred);}
      else
        check_rentVal(a_sensorInfred->get_dwell());
    }
  if (a_sensorInfred->get_sensorItem())
    {
      if (!findString("a_sensorItem", sensorInfredAtts))
	{warnAtt("a_sensorItem", "sensorInfred", a_sensorInfred);}
      else
        check_sensorItem(a_sensorInfred->get_sensorItem());
    }
}

/********************************************************************/

void check_sensorItem(
 sensorItem * a_sensorItem)
{
  if (isA(a_sensorItem, sensorItem_stringVal))
    {
      if (!findString("sensorItem_stringVal", sensorItemSubs))
        {warnSub("sensorItem_stringVal", "sensorItem", a_sensorItem);}
      else
        check_sensorItem_stringVal(dynamic_cast<sensorItem_stringVal *>(a_sensorItem));
      return;
    }
  if (isA(a_sensorItem, sensorItem_intVal))
    {
      if (!findString("sensorItem_intVal", sensorItemSubs))
        {warnSub("sensorItem_intVal", "sensorItem", a_sensorItem);}
      else
        check_sensorItem_intVal(dynamic_cast<sensorItem_intVal *>(a_sensorItem));
      return;
    }
}

/********************************************************************/

void check_sensorItem_intVal(
 sensorItem_intVal * a_sensorItem_intVal)
{
  if (a_sensorItem_intVal->get_dataStor())
    {
      if (!findString("dataStor", sensorItem_intValAtts))
	{warnAtt("dataStor", "sensorItem_intVal", a_sensorItem_intVal);}
      else
        check_stringVal(a_sensorItem_intVal->get_dataStor());
    }
  if (a_sensorItem_intVal->get_dataList())
    {
      if (!findString("dataList", sensorItem_intValAtts))
	{warnAtt("dataList", "sensorItem_intVal", a_sensorItem_intVal);}
      else
        check_stringVal(a_sensorItem_intVal->get_dataList());
    }
  if (a_sensorItem_intVal->get_index())
    {
      if (!findString("index", sensorItem_intValAtts))
	{warnAtt("index", "sensorItem_intVal", a_sensorItem_intVal);}
      else
        check_intVal(a_sensorItem_intVal->get_index());
    }
}

/********************************************************************/

void check_sensorItem_stringVal(
 sensorItem_stringVal * a_sensorItem_stringVal)
{
  if (a_sensorItem_stringVal->get_dataStor())
    {
      if (!findString("dataStor", sensorItem_stringValAtts))
	{warnAtt("dataStor", "sensorItem_stringVal", a_sensorItem_stringVal);}
      else
        check_stringVal(a_sensorItem_stringVal->get_dataStor());
    }
  if (a_sensorItem_stringVal->get_dataList())
    {
      if (!findString("dataList", sensorItem_stringValAtts))
	{warnAtt("dataList", "sensorItem_stringVal", a_sensorItem_stringVal);}
      else
        check_stringVal(a_sensorItem_stringVal->get_dataList());
    }
  if (a_sensorItem_stringVal->get_dataItem())
    {
      if (!findString("dataItem", sensorItem_stringValAtts))
	{warnAtt("dataItem", "sensorItem_stringVal", a_sensorItem_stringVal);}
      else
        check_stringVal(a_sensorItem_stringVal->get_dataItem());
    }
}

/********************************************************************/

void check_sensorLabel1(
 sensorLabel1 * a_sensorLabel1)
{
  if (isA(a_sensorLabel1, sLabel))
    {
      if (!findString("sLabel", sensorLabel1Subs))
        {warnSub("sLabel", "sensorLabel1", a_sensorLabel1);}
      else
        check_sLabel(dynamic_cast<sLabel *>(a_sensorLabel1));
      return;
    }
  if (isA(a_sensorLabel1, saLabel))
    {
      if (!findString("saLabel", sensorLabel1Subs))
        {warnSub("saLabel", "sensorLabel1", a_sensorLabel1);}
      else
        check_saLabel(dynamic_cast<saLabel *>(a_sensorLabel1));
      return;
    }
}

/********************************************************************/

void check_sensorLabel2(
 sensorLabel2 * a_sensorLabel2)
{
  if (isA(a_sensorLabel2, sLabel))
    {
      if (!findString("sLabel", sensorLabel2Subs))
        {warnSub("sLabel", "sensorLabel2", a_sensorLabel2);}
      else
        check_sLabel(dynamic_cast<sLabel *>(a_sensorLabel2));
      return;
    }
  if (isA(a_sensorLabel2, saLabel))
    {
      if (!findString("saLabel", sensorLabel2Subs))
        {warnSub("saLabel", "sensorLabel2", a_sensorLabel2);}
      else
        check_saLabel(dynamic_cast<saLabel *>(a_sensorLabel2));
      return;
    }
}

/********************************************************************/

void check_sensorLaser(
 sensorLaser * a_sensorLaser)
{
  if (a_sensorLaser->get_sensorGeometry())
    {
      if (!findString("a_sensorGeometry", sensorLaserAtts))
	{warnAtt("a_sensorGeometry", "sensorLaser", a_sensorLaser);}
      else
        check_sensorGeometry(a_sensorLaser->get_sensorGeometry());
    }
  if (a_sensorLaser->get_power())
    {
      if (!findString("power", sensorLaserAtts))
	{warnAtt("power", "sensorLaser", a_sensorLaser);}
      else
        check_rentVal(a_sensorLaser->get_power());
    }
  if (a_sensorLaser->get_shuter())
    {
      if (!findString("shuter", sensorLaserAtts))
	{warnAtt("shuter", "sensorLaser", a_sensorLaser);}
      else
        check_rentVal(a_sensorLaser->get_shuter());
    }
  if (a_sensorLaser->get_sensorItem())
    {
      if (!findString("a_sensorItem", sensorLaserAtts))
	{warnAtt("a_sensorItem", "sensorLaser", a_sensorLaser);}
      else
        check_sensorItem(a_sensorLaser->get_sensorItem());
    }
}

/********************************************************************/

void check_sensorLine(
 sensorLine * a_sensorLine)
{
  if (a_sensorLine->get_sensorGeometry())
    {
      if (!findString("a_sensorGeometry", sensorLineAtts))
	{warnAtt("a_sensorGeometry", "sensorLine", a_sensorLine);}
      else
        check_sensorGeometry(a_sensorLine->get_sensorGeometry());
    }
  if (a_sensorLine->get_fovn())
    {
      if (!findString("fovn", sensorLineAtts))
	{warnAtt("fovn", "sensorLine", a_sensorLine);}
      else
        check_rentVal(a_sensorLine->get_fovn());
    }
  if (a_sensorLine->get_fovc())
    {
      if (!findString("fovc", sensorLineAtts))
	{warnAtt("fovc", "sensorLine", a_sensorLine);}
      else
        check_rentVal(a_sensorLine->get_fovc());
    }
  if (a_sensorLine->get_sensorItem())
    {
      if (!findString("a_sensorItem", sensorLineAtts))
	{warnAtt("a_sensorItem", "sensorLine", a_sensorLine);}
      else
        check_sensorItem(a_sensorLine->get_sensorItem());
    }
}

/********************************************************************/

void check_sensorMinor(
 sensorMinor * a_sensorMinor)
{
  if (isA(a_sensorMinor, sensorProbe))
    {
      if (!findString("sensorProbe", sensorMinorSubs))
        {warnSub("sensorProbe", "sensorMinor", a_sensorMinor);}
      else
        check_sensorProbe(dynamic_cast<sensorProbe *>(a_sensorMinor));
      return;
    }
  if (isA(a_sensorMinor, sensorMltprb))
    {
      if (!findString("sensorMltprb", sensorMinorSubs))
        {warnSub("sensorMltprb", "sensorMinor", a_sensorMinor);}
      else
        check_sensorMltprb(dynamic_cast<sensorMltprb *>(a_sensorMinor));
      return;
    }
  if (isA(a_sensorMinor, sensorVideo))
    {
      if (!findString("sensorVideo", sensorMinorSubs))
        {warnSub("sensorVideo", "sensorMinor", a_sensorMinor);}
      else
        check_sensorVideo(dynamic_cast<sensorVideo *>(a_sensorMinor));
      return;
    }
  if (isA(a_sensorMinor, sensorLaser))
    {
      if (!findString("sensorLaser", sensorMinorSubs))
        {warnSub("sensorLaser", "sensorMinor", a_sensorMinor);}
      else
        check_sensorLaser(dynamic_cast<sensorLaser *>(a_sensorMinor));
      return;
    }
  if (isA(a_sensorMinor, sensorInfred))
    {
      if (!findString("sensorInfred", sensorMinorSubs))
        {warnSub("sensorInfred", "sensorMinor", a_sensorMinor);}
      else
        check_sensorInfred(dynamic_cast<sensorInfred *>(a_sensorMinor));
      return;
    }
  if (isA(a_sensorMinor, sensorNoncon))
    {
      if (!findString("sensorNoncon", sensorMinorSubs))
        {warnSub("sensorNoncon", "sensorMinor", a_sensorMinor);}
      else
        check_sensorNoncon(dynamic_cast<sensorNoncon *>(a_sensorMinor));
      return;
    }
  if (isA(a_sensorMinor, sensorPoint))
    {
      if (!findString("sensorPoint", sensorMinorSubs))
        {warnSub("sensorPoint", "sensorMinor", a_sensorMinor);}
      else
        check_sensorPoint(dynamic_cast<sensorPoint *>(a_sensorMinor));
      return;
    }
  if (isA(a_sensorMinor, sensorLine))
    {
      if (!findString("sensorLine", sensorMinorSubs))
        {warnSub("sensorLine", "sensorMinor", a_sensorMinor);}
      else
        check_sensorLine(dynamic_cast<sensorLine *>(a_sensorMinor));
      return;
    }
  if (isA(a_sensorMinor, sensorArea))
    {
      if (!findString("sensorArea", sensorMinorSubs))
        {warnSub("sensorArea", "sensorMinor", a_sensorMinor);}
      else
        check_sensorArea(dynamic_cast<sensorArea *>(a_sensorMinor));
      return;
    }
}

/********************************************************************/

void check_sensorMltprb(
 sensorMltprb * a_sensorMltprb)
{
  if (a_sensorMltprb->get_numStyli())
    {
      if (!findString("numStyli", sensorMltprbAtts))
	{warnAtt("numStyli", "sensorMltprb", a_sensorMltprb);}
      else
        check_intVal(a_sensorMltprb->get_numStyli());
    }
  if (a_sensorMltprb->get_sensorMltprbItemList())
    {
      if (!findString("a_sensorMltprbItemList", sensorMltprbAtts))
	{warnAtt("a_sensorMltprbItemList", "sensorMltprb", a_sensorMltprb);}
      else
        {
          std::list<sensorMltprbItem *> * theList;
          std::list<sensorMltprbItem *>::iterator iter;
          theList = a_sensorMltprb->get_sensorMltprbItemList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_sensorMltprbItem(*iter);
        }
    }
  if (a_sensorMltprb->get_sensorItem())
    {
      if (!findString("a_sensorItem", sensorMltprbAtts))
	{warnAtt("a_sensorItem", "sensorMltprb", a_sensorMltprb);}
      else
        check_sensorItem(a_sensorMltprb->get_sensorItem());
    }
}

/********************************************************************/

void check_sensorMltprbItem(
 sensorMltprbItem * a_sensorMltprbItem)
{
  if (isA(a_sensorMltprbItem, sensorMltprbItem_stringVal))
    {
      if (!findString("sensorMltprbItem_stringVal", sensorMltprbItemSubs))
        {warnSub("sensorMltprbItem_stringVal", "sensorMltprbItem", a_sensorMltprbItem);}
      else
        check_sensorMltprbItem_stringVal(dynamic_cast<sensorMltprbItem_stringVal *>(a_sensorMltprbItem));
      return;
    }
  if (isA(a_sensorMltprbItem, sensorMltprbItem_intVal))
    {
      if (!findString("sensorMltprbItem_intVal", sensorMltprbItemSubs))
        {warnSub("sensorMltprbItem_intVal", "sensorMltprbItem", a_sensorMltprbItem);}
      else
        check_sensorMltprbItem_intVal(dynamic_cast<sensorMltprbItem_intVal *>(a_sensorMltprbItem));
      return;
    }
}

/********************************************************************/

void check_sensorMltprbItem_intVal(
 sensorMltprbItem_intVal * a_sensorMltprbItem_intVal)
{
  if (a_sensorMltprbItem_intVal->get_tipnum())
    {
      if (!findString("tipnum", sensorMltprbItem_intValAtts))
	{warnAtt("tipnum", "sensorMltprbItem_intVal", a_sensorMltprbItem_intVal);}
      else
        check_intVal(a_sensorMltprbItem_intVal->get_tipnum());
    }
  if (a_sensorMltprbItem_intVal->get_sensorProbeGeometry())
    {
      if (!findString("a_sensorProbeGeometry", sensorMltprbItem_intValAtts))
	{warnAtt("a_sensorProbeGeometry", "sensorMltprbItem_intVal", a_sensorMltprbItem_intVal);}
      else
        check_sensorProbeGeometry(a_sensorMltprbItem_intVal->get_sensorProbeGeometry());
    }
}

/********************************************************************/

void check_sensorMltprbItem_stringVal(
 sensorMltprbItem_stringVal * a_sensorMltprbItem_stringVal)
{
  if (a_sensorMltprbItem_stringVal->get_desc())
    {
      if (!findString("desc", sensorMltprbItem_stringValAtts))
	{warnAtt("desc", "sensorMltprbItem_stringVal", a_sensorMltprbItem_stringVal);}
      else
        check_stringVal(a_sensorMltprbItem_stringVal->get_desc());
    }
  if (a_sensorMltprbItem_stringVal->get_sensorProbeGeometry())
    {
      if (!findString("a_sensorProbeGeometry", sensorMltprbItem_stringValAtts))
	{warnAtt("a_sensorProbeGeometry", "sensorMltprbItem_stringVal", a_sensorMltprbItem_stringVal);}
      else
        check_sensorProbeGeometry(a_sensorMltprbItem_stringVal->get_sensorProbeGeometry());
    }
}

/********************************************************************/

void check_sensorMove(
 sensorMove * a_sensorMove)
{
  if (isA(a_sensorMove, sensorMove_saLabel))
    {
      if (!findString("sensorMove_saLabel", sensorMoveSubs))
        {warnSub("sensorMove_saLabel", "sensorMove", a_sensorMove);}
      else
        check_sensorMove_saLabel(dynamic_cast<sensorMove_saLabel *>(a_sensorMove));
      return;
    }
  if (isA(a_sensorMove, sensorMove_gotoWristList))
    {
      if (!findString("sensorMove_gotoWristList", sensorMoveSubs))
        {warnSub("sensorMove_gotoWristList", "sensorMove", a_sensorMove);}
      else
        check_sensorMove_gotoWristList(dynamic_cast<sensorMove_gotoWristList *>(a_sensorMove));
      return;
    }
  if (isA(a_sensorMove, sensorMove_probeOrient))
    {
      if (!findString("sensorMove_probeOrient", sensorMoveSubs))
        {warnSub("sensorMove_probeOrient", "sensorMove", a_sensorMove);}
      else
        check_sensorMove_probeOrient(dynamic_cast<sensorMove_probeOrient *>(a_sensorMove));
      return;
    }
}

/********************************************************************/

void check_sensorMove_gotoWristList(
 sensorMove_gotoWristList * a_sensorMove_gotoWristList)
{
  if (a_sensorMove_gotoWristList->get_gotoWristList())
    {
      if (!findString("a_gotoWristList", sensorMove_gotoWristListAtts))
	{warnAtt("a_gotoWristList", "sensorMove_gotoWristList", a_sensorMove_gotoWristList);}
      else
        {
          std::list<gotoWristItem *> * theList;
          std::list<gotoWristItem *>::iterator iter;
          theList = a_sensorMove_gotoWristList->get_gotoWristList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_gotoWristItem(*iter);
        }
    }
}

/********************************************************************/

void check_sensorMove_probeOrient(
 sensorMove_probeOrient * a_sensorMove_probeOrient)
{
  if (a_sensorMove_probeOrient->get_probeOrient())
    {
      if (!findString("a_probeOrient", sensorMove_probeOrientAtts))
	{warnAtt("a_probeOrient", "sensorMove_probeOrient", a_sensorMove_probeOrient);}
      else
        check_probeOrient(a_sensorMove_probeOrient->get_probeOrient());
    }
}

/********************************************************************/

void check_sensorMove_saLabel(
 sensorMove_saLabel * a_sensorMove_saLabel)
{
  if (a_sensorMove_saLabel->get_saLabel())
    {
      if (!findString("a_saLabel", sensorMove_saLabelAtts))
	{warnAtt("a_saLabel", "sensorMove_saLabel", a_sensorMove_saLabel);}
      else
        check_saLabel(a_sensorMove_saLabel->get_saLabel());
    }
}

/********************************************************************/

void check_sensorNoncon(
 sensorNoncon * a_sensorNoncon)
{
  if (a_sensorNoncon->get_sensorGeometry())
    {
      if (!findString("a_sensorGeometry", sensorNonconAtts))
	{warnAtt("a_sensorGeometry", "sensorNoncon", a_sensorNoncon);}
      else
        check_sensorGeometry(a_sensorNoncon->get_sensorGeometry());
    }
  if (a_sensorNoncon->get_numProbes())
    {
      if (!findString("numProbes", sensorNonconAtts))
	{warnAtt("numProbes", "sensorNoncon", a_sensorNoncon);}
      else
        check_intVal(a_sensorNoncon->get_numProbes());
    }
  if (a_sensorNoncon->get_sensorItem())
    {
      if (!findString("a_sensorItem", sensorNonconAtts))
	{warnAtt("a_sensorItem", "sensorNoncon", a_sensorNoncon);}
      else
        check_sensorItem(a_sensorNoncon->get_sensorItem());
    }
}

/********************************************************************/

void check_sensorPoint(
 sensorPoint * a_sensorPoint)
{
  if (a_sensorPoint->get_sensorGeometry())
    {
      if (!findString("a_sensorGeometry", sensorPointAtts))
	{warnAtt("a_sensorGeometry", "sensorPoint", a_sensorPoint);}
      else
        check_sensorGeometry(a_sensorPoint->get_sensorGeometry());
    }
  if (a_sensorPoint->get_fovn())
    {
      if (!findString("fovn", sensorPointAtts))
	{warnAtt("fovn", "sensorPoint", a_sensorPoint);}
      else
        check_rentVal(a_sensorPoint->get_fovn());
    }
  if (a_sensorPoint->get_sensorItem())
    {
      if (!findString("a_sensorItem", sensorPointAtts))
	{warnAtt("a_sensorItem", "sensorPoint", a_sensorPoint);}
      else
        check_sensorItem(a_sensorPoint->get_sensorItem());
    }
}

/********************************************************************/

void check_sensorProbe(
 sensorProbe * a_sensorProbe)
{
  if (a_sensorProbe->get_sensorProbeGeometry())
    {
      if (!findString("a_sensorProbeGeometry", sensorProbeAtts))
	{warnAtt("a_sensorProbeGeometry", "sensorProbe", a_sensorProbe);}
      else
        check_sensorProbeGeometry(a_sensorProbe->get_sensorProbeGeometry());
    }
  if (a_sensorProbe->get_sensorProbeForm())
    {
      if (!findString("a_sensorProbeForm", sensorProbeAtts))
	{warnAtt("a_sensorProbeForm", "sensorProbe", a_sensorProbe);}
      else
        check_sensorProbeForm(a_sensorProbe->get_sensorProbeForm());
    }
  if (a_sensorProbe->get_sensorItem())
    {
      if (!findString("a_sensorItem", sensorProbeAtts))
	{warnAtt("a_sensorItem", "sensorProbe", a_sensorProbe);}
      else
        check_sensorItem(a_sensorProbe->get_sensorItem());
    }
}

/********************************************************************/

void check_sensorProbeForm(
 sensorProbeForm * a_sensorProbeForm)
{
  if (isA(a_sensorProbeForm, sensorProbeForm_SPHERE))
    {
      if (!findString("sensorProbeForm_SPHERE", sensorProbeFormSubs))
        {warnSub("sensorProbeForm_SPHERE", "sensorProbeForm", a_sensorProbeForm);}
      return;
    }
  if (isA(a_sensorProbeForm, sensorProbeForm_CYLNDR))
    {
      if (!findString("sensorProbeForm_CYLNDR", sensorProbeFormSubs))
        {warnSub("sensorProbeForm_CYLNDR", "sensorProbeForm", a_sensorProbeForm);}
      else
        check_sensorProbeForm_CYLNDR(dynamic_cast<sensorProbeForm_CYLNDR *>(a_sensorProbeForm));
      return;
    }
  if (isA(a_sensorProbeForm, sensorProbeForm_DISK))
    {
      if (!findString("sensorProbeForm_DISK", sensorProbeFormSubs))
        {warnSub("sensorProbeForm_DISK", "sensorProbeForm", a_sensorProbeForm);}
      else
        check_sensorProbeForm_DISK(dynamic_cast<sensorProbeForm_DISK *>(a_sensorProbeForm));
      return;
    }
}

/********************************************************************/

void check_sensorProbeForm_CYLNDR(
 sensorProbeForm_CYLNDR * a_sensorProbeForm_CYLNDR)
{
  if (a_sensorProbeForm_CYLNDR->get_len1())
    {
      if (!findString("len1", sensorProbeForm_CYLNDRAtts))
	{warnAtt("len1", "sensorProbeForm_CYLNDR", a_sensorProbeForm_CYLNDR);}
      else
        check_rentVal(a_sensorProbeForm_CYLNDR->get_len1());
    }
}

/********************************************************************/

void check_sensorProbeForm_DISK(
 sensorProbeForm_DISK * a_sensorProbeForm_DISK)
{
  if (a_sensorProbeForm_DISK->get_thkn())
    {
      if (!findString("thkn", sensorProbeForm_DISKAtts))
	{warnAtt("thkn", "sensorProbeForm_DISK", a_sensorProbeForm_DISK);}
      else
        check_rentVal(a_sensorProbeForm_DISK->get_thkn());
    }
}

/********************************************************************/

void check_sensorProbeGeometry(
 sensorProbeGeometry * a_sensorProbeGeometry)
{
  if (a_sensorProbeGeometry->get_offset())
    {
      if (!findString("offset", sensorProbeGeometryAtts))
	{warnAtt("offset", "sensorProbeGeometry", a_sensorProbeGeometry);}
      else
        check_vector(a_sensorProbeGeometry->get_offset());
    }
  if (a_sensorProbeGeometry->get_normal())
    {
      if (!findString("normal", sensorProbeGeometryAtts))
	{warnAtt("normal", "sensorProbeGeometry", a_sensorProbeGeometry);}
      else
        check_vector(a_sensorProbeGeometry->get_normal());
    }
  if (a_sensorProbeGeometry->get_diam())
    {
      if (!findString("diam", sensorProbeGeometryAtts))
	{warnAtt("diam", "sensorProbeGeometry", a_sensorProbeGeometry);}
      else
        check_rentVal(a_sensorProbeGeometry->get_diam());
    }
}

/********************************************************************/

void check_sensorStm(
 sensorStm * a_sensorStm)
{
  if (a_sensorStm->get_ssLabel())
    {
      if (!findString("a_ssLabel", sensorStmAtts))
	{warnAtt("a_ssLabel", "sensorStm", a_sensorStm);}
      else
        check_ssLabel(a_sensorStm->get_ssLabel());
    }
  if (a_sensorStm->get_sensorMinor())
    {
      if (!findString("a_sensorMinor", sensorStmAtts))
	{warnAtt("a_sensorMinor", "sensorStm", a_sensorStm);}
      else
        check_sensorMinor(a_sensorStm->get_sensorMinor());
    }
}

/********************************************************************/

void check_sensorVideo(
 sensorVideo * a_sensorVideo)
{
  if (a_sensorVideo->get_sensorGeometry())
    {
      if (!findString("a_sensorGeometry", sensorVideoAtts))
	{warnAtt("a_sensorGeometry", "sensorVideo", a_sensorVideo);}
      else
        check_sensorGeometry(a_sensorVideo->get_sensorGeometry());
    }
  if (a_sensorVideo->get_focal())
    {
      if (!findString("focal", sensorVideoAtts))
	{warnAtt("focal", "sensorVideo", a_sensorVideo);}
      else
        check_rentVal(a_sensorVideo->get_focal());
    }
  if (a_sensorVideo->get_mag())
    {
      if (!findString("mag", sensorVideoAtts))
	{warnAtt("mag", "sensorVideo", a_sensorVideo);}
      else
        check_rentVal(a_sensorVideo->get_mag());
    }
  if (a_sensorVideo->get_apert())
    {
      if (!findString("apert", sensorVideoAtts))
	{warnAtt("apert", "sensorVideo", a_sensorVideo);}
      else
        check_rentVal(a_sensorVideo->get_apert());
    }
  if (a_sensorVideo->get_sensorItem())
    {
      if (!findString("a_sensorItem", sensorVideoAtts))
	{warnAtt("a_sensorItem", "sensorVideo", a_sensorVideo);}
      else
        check_sensorItem(a_sensorVideo->get_sensorItem());
    }
}

/********************************************************************/

void check_sgLabel(
 sgLabel * a_sgLabel)
{
  if (a_sgLabel->get_labelName())
    {
      if (!findString("a_labelName", sgLabelAtts))
	{warnAtt("a_labelName", "sgLabel", a_sgLabel);}
      else
        check_labelName(a_sgLabel->get_labelName());
    }
}

/********************************************************************/

void check_sgageConst(
 sgageConst * a_sgageConst)
{
  if (a_sgageConst->get_featureNominalList())
    {
      if (!findString("a_featureNominalList", sgageConstAtts))
	{warnAtt("a_featureNominalList", "sgageConst", a_sgageConst);}
      else
        {
          std::list<fLabel *> * theList;
          std::list<fLabel *>::iterator iter;
          theList = a_sgageConst->get_featureNominalList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_fLabel(*iter);
        }
    }
}

/********************************************************************/

void check_sgsLabel(
 sgsLabel * a_sgsLabel)
{
  if (a_sgsLabel->get_labelName())
    {
      if (!findString("a_labelName", sgsLabelAtts))
	{warnAtt("a_labelName", "sgsLabel", a_sgsLabel);}
      else
        check_labelName(a_sgsLabel->get_labelName());
    }
}

/********************************************************************/

void check_sign(
 sign * a_sign)
{
  if (isA(a_sign, plusSign))
    {
      if (!findString("plusSign", signSubs))
        {warnSub("plusSign", "sign", a_sign);}
      return;
    }
  if (isA(a_sign, minusSign))
    {
      if (!findString("minusSign", signSubs))
        {warnSub("minusSign", "sign", a_sign);}
      return;
    }
}

/********************************************************************/

void check_simreqtBlock(
 simreqtBlock * a_simreqtBlock)
{
  if (a_simreqtBlock->get_simreqtStm())
    {
      if (!findString("a_simreqtStm", simreqtBlockAtts))
	{warnAttBlock("simreqtStm", a_simreqtBlock->get_simreqtStm());}
      else
        check_simreqtStm(a_simreqtBlock->get_simreqtStm());
    }
  if (a_simreqtBlock->get_evalOrOutputList())
    {
      if (!findString("a_evalOrOutputList", simreqtBlockAtts))
	{warnAttBlock("evalOrOutputList", a_simreqtBlock->get_evalOrOutputList()->front());}
      else
        {
          std::list<evalOrOutput *> * theList;
          std::list<evalOrOutput *>::iterator iter;
          theList = a_simreqtBlock->get_evalOrOutputList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_evalOrOutput(*iter);
        }
    }
  if (a_simreqtBlock->get_endsimreqtStm())
    {
      if (!findString("a_endsimreqtStm", simreqtBlockAtts))
	{warnAttBlock("endsimreqtStm", a_simreqtBlock->get_endsimreqtStm());}
    }
}

/********************************************************************/

void check_simreqtMinor(
 simreqtMinor * a_simreqtMinor)
{
  if (isA(a_simreqtMinor, simreqtMinor_FIRST))
    {
      if (!findString("simreqtMinor_FIRST", simreqtMinorSubs))
        {warnSub("simreqtMinor_FIRST", "simreqtMinor", a_simreqtMinor);}
      return;
    }
  if (isA(a_simreqtMinor, simreqtMinor_OPTIMAL))
    {
      if (!findString("simreqtMinor_OPTIMAL", simreqtMinorSubs))
        {warnSub("simreqtMinor_OPTIMAL", "simreqtMinor", a_simreqtMinor);}
      return;
    }
}

/********************************************************************/

void check_simreqtStm(
 simreqtStm * a_simreqtStm)
{
  if (a_simreqtStm->get_srLabel())
    {
      if (!findString("a_srLabel", simreqtStmAtts))
	{warnAtt("a_srLabel", "simreqtStm", a_simreqtStm);}
      else
        check_srLabel(a_simreqtStm->get_srLabel());
    }
  if (a_simreqtStm->get_simreqtMinor())
    {
      if (!findString("a_simreqtMinor", simreqtStmAtts))
	{warnAtt("a_simreqtMinor", "simreqtStm", a_simreqtStm);}
      else
        check_simreqtMinor(a_simreqtStm->get_simreqtMinor());
    }
}

/********************************************************************/

void check_snsdefBuild(
 snsdefBuild * a_snsdefBuild)
{
  if (a_snsdefBuild->get_snsdefBuildItemList())
    {
      if (!findString("a_snsdefBuildItemList", snsdefBuildAtts))
	{warnAtt("a_snsdefBuildItemList", "snsdefBuild", a_snsdefBuild);}
      else
        {
          std::list<snsdefBuildItem *> * theList;
          std::list<snsdefBuildItem *>::iterator iter;
          theList = a_snsdefBuild->get_snsdefBuildItemList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_snsdefBuildItem(*iter);
        }
    }
  if (a_snsdefBuild->get_snsdefBuildSensor())
    {
      if (!findString("a_snsdefBuildSensor", snsdefBuildAtts))
	{warnAtt("a_snsdefBuildSensor", "snsdefBuild", a_snsdefBuild);}
      else
        check_snsdefBuildSensor(a_snsdefBuild->get_snsdefBuildSensor());
    }
}

/********************************************************************/

void check_snsdefBuildItem(
 snsdefBuildItem * a_snsdefBuildItem)
{
  if (isA(a_snsdefBuildItem, snsdefBuildItem_sgLabel))
    {
      if (!findString("snsdefBuildItem_sgLabel", snsdefBuildItemSubs))
        {warnSub("snsdefBuildItem_sgLabel", "snsdefBuildItem", a_snsdefBuildItem);}
      else
        check_snsdefBuildItem_sgLabel(dynamic_cast<snsdefBuildItem_sgLabel *>(a_snsdefBuildItem));
      return;
    }
  if (isA(a_snsdefBuildItem, snsdefBuildItem_swLabel))
    {
      if (!findString("snsdefBuildItem_swLabel", snsdefBuildItemSubs))
        {warnSub("snsdefBuildItem_swLabel", "snsdefBuildItem", a_snsdefBuildItem);}
      else
        check_snsdefBuildItem_swLabel(dynamic_cast<snsdefBuildItem_swLabel *>(a_snsdefBuildItem));
      return;
    }
  if (isA(a_snsdefBuildItem, snsdefBuildItem_sxLabel))
    {
      if (!findString("snsdefBuildItem_sxLabel", snsdefBuildItemSubs))
        {warnSub("snsdefBuildItem_sxLabel", "snsdefBuildItem", a_snsdefBuildItem);}
      else
        check_snsdefBuildItem_sxLabel(dynamic_cast<snsdefBuildItem_sxLabel *>(a_snsdefBuildItem));
      return;
    }
  if (isA(a_snsdefBuildItem, snsdefBuildItem_rmLabel))
    {
      if (!findString("snsdefBuildItem_rmLabel", snsdefBuildItemSubs))
        {warnSub("snsdefBuildItem_rmLabel", "snsdefBuildItem", a_snsdefBuildItem);}
      else
        check_snsdefBuildItem_rmLabel(dynamic_cast<snsdefBuildItem_rmLabel *>(a_snsdefBuildItem));
      return;
    }
}

/********************************************************************/

void check_snsdefBuildItem_rmLabel(
 snsdefBuildItem_rmLabel * a_snsdefBuildItem_rmLabel)
{
  if (a_snsdefBuildItem_rmLabel->get_rmLabel())
    {
      if (!findString("a_rmLabel", snsdefBuildItem_rmLabelAtts))
	{warnAtt("a_rmLabel", "snsdefBuildItem_rmLabel", a_snsdefBuildItem_rmLabel);}
      else
        check_rmLabel(a_snsdefBuildItem_rmLabel->get_rmLabel());
    }
}

/********************************************************************/

void check_snsdefBuildItem_sgLabel(
 snsdefBuildItem_sgLabel * a_snsdefBuildItem_sgLabel)
{
  if (a_snsdefBuildItem_sgLabel->get_sgLabel())
    {
      if (!findString("a_sgLabel", snsdefBuildItem_sgLabelAtts))
	{warnAtt("a_sgLabel", "snsdefBuildItem_sgLabel", a_snsdefBuildItem_sgLabel);}
      else
        check_sgLabel(a_snsdefBuildItem_sgLabel->get_sgLabel());
    }
}

/********************************************************************/

void check_snsdefBuildItem_swLabel(
 snsdefBuildItem_swLabel * a_snsdefBuildItem_swLabel)
{
  if (a_snsdefBuildItem_swLabel->get_swLabel())
    {
      if (!findString("a_swLabel", snsdefBuildItem_swLabelAtts))
	{warnAtt("a_swLabel", "snsdefBuildItem_swLabel", a_snsdefBuildItem_swLabel);}
      else
        check_swLabel(a_snsdefBuildItem_swLabel->get_swLabel());
    }
  if (a_snsdefBuildItem_swLabel->get_snsdefWristAngleList())
    {
      if (!findString("a_snsdefWristAngleList", snsdefBuildItem_swLabelAtts))
	{warnAtt("a_snsdefWristAngleList", "snsdefBuildItem_swLabel", a_snsdefBuildItem_swLabel);}
      else
        {
          std::list<snsdefWristAngleItem *> * theList;
          std::list<snsdefWristAngleItem *>::iterator iter;
          theList = a_snsdefBuildItem_swLabel->get_snsdefWristAngleList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_snsdefWristAngleItem(*iter);
        }
    }
}

/********************************************************************/

void check_snsdefBuildItem_sxLabel(
 snsdefBuildItem_sxLabel * a_snsdefBuildItem_sxLabel)
{
  if (a_snsdefBuildItem_sxLabel->get_sxLabel())
    {
      if (!findString("a_sxLabel", snsdefBuildItem_sxLabelAtts))
	{warnAtt("a_sxLabel", "snsdefBuildItem_sxLabel", a_snsdefBuildItem_sxLabel);}
      else
        check_sxLabel(a_snsdefBuildItem_sxLabel->get_sxLabel());
    }
}

/********************************************************************/

void check_snsdefBuildSensor(
 snsdefBuildSensor * a_snsdefBuildSensor)
{
  if (isA(a_snsdefBuildSensor, ssLabel))
    {
      if (!findString("ssLabel", snsdefBuildSensorSubs))
        {warnSub("ssLabel", "snsdefBuildSensor", a_snsdefBuildSensor);}
      else
        check_ssLabel(dynamic_cast<ssLabel *>(a_snsdefBuildSensor));
      return;
    }
  if (isA(a_snsdefBuildSensor, sgsLabel))
    {
      if (!findString("sgsLabel", snsdefBuildSensorSubs))
        {warnSub("sgsLabel", "snsdefBuildSensor", a_snsdefBuildSensor);}
      else
        check_sgsLabel(dynamic_cast<sgsLabel *>(a_snsdefBuildSensor));
      return;
    }
}

/********************************************************************/

void check_snsdefInfred(
 snsdefInfred * a_snsdefInfred)
{
  if (a_snsdefInfred->get_snsdefType())
    {
      if (!findString("a_snsdefType", snsdefInfredAtts))
	{warnAtt("a_snsdefType", "snsdefInfred", a_snsdefInfred);}
      else
        check_snsdefType(a_snsdefInfred->get_snsdefType());
    }
  if (a_snsdefInfred->get_snsdefLocation())
    {
      if (!findString("a_snsdefLocation", snsdefInfredAtts))
	{warnAtt("a_snsdefLocation", "snsdefInfred", a_snsdefInfred);}
      else
        check_snsdefLocation(a_snsdefInfred->get_snsdefLocation());
    }
  if (a_snsdefInfred->get_fovx())
    {
      if (!findString("fovx", snsdefInfredAtts))
	{warnAtt("fovx", "snsdefInfred", a_snsdefInfred);}
      else
        check_rentVal(a_snsdefInfred->get_fovx());
    }
  if (a_snsdefInfred->get_fovy())
    {
      if (!findString("fovy", snsdefInfredAtts))
	{warnAtt("fovy", "snsdefInfred", a_snsdefInfred);}
      else
        check_rentVal(a_snsdefInfred->get_fovy());
    }
  if (a_snsdefInfred->get_freq())
    {
      if (!findString("freq", snsdefInfredAtts))
	{warnAtt("freq", "snsdefInfred", a_snsdefInfred);}
      else
        check_rentVal(a_snsdefInfred->get_freq());
    }
  if (a_snsdefInfred->get_dwell())
    {
      if (!findString("dwell", snsdefInfredAtts))
	{warnAtt("dwell", "snsdefInfred", a_snsdefInfred);}
      else
        check_rentVal(a_snsdefInfred->get_dwell());
    }
}

/********************************************************************/

void check_snsdefLaser(
 snsdefLaser * a_snsdefLaser)
{
  if (a_snsdefLaser->get_snsdefType())
    {
      if (!findString("a_snsdefType", snsdefLaserAtts))
	{warnAtt("a_snsdefType", "snsdefLaser", a_snsdefLaser);}
      else
        check_snsdefType(a_snsdefLaser->get_snsdefType());
    }
  if (a_snsdefLaser->get_snsdefLocation())
    {
      if (!findString("a_snsdefLocation", snsdefLaserAtts))
	{warnAtt("a_snsdefLocation", "snsdefLaser", a_snsdefLaser);}
      else
        check_snsdefLocation(a_snsdefLaser->get_snsdefLocation());
    }
  if (a_snsdefLaser->get_power())
    {
      if (!findString("power", snsdefLaserAtts))
	{warnAtt("power", "snsdefLaser", a_snsdefLaser);}
      else
        check_rentVal(a_snsdefLaser->get_power());
    }
  if (a_snsdefLaser->get_shuter())
    {
      if (!findString("shuter", snsdefLaserAtts))
	{warnAtt("shuter", "snsdefLaser", a_snsdefLaser);}
      else
        check_rentVal(a_snsdefLaser->get_shuter());
    }
}

/********************************************************************/

void check_snsdefLocation(
 snsdefLocation * a_snsdefLocation)
{
  if (isA(a_snsdefLocation, snsdefLocation_CART))
    {
      if (!findString("snsdefLocation_CART", snsdefLocationSubs))
        {warnSub("snsdefLocation_CART", "snsdefLocation", a_snsdefLocation);}
      else
        check_snsdefLocation_CART(dynamic_cast<snsdefLocation_CART *>(a_snsdefLocation));
      return;
    }
  if (isA(a_snsdefLocation, snsdefLocation_POL))
    {
      if (!findString("snsdefLocation_POL", snsdefLocationSubs))
        {warnSub("snsdefLocation_POL", "snsdefLocation", a_snsdefLocation);}
      else
        check_snsdefLocation_POL(dynamic_cast<snsdefLocation_POL *>(a_snsdefLocation));
      return;
    }
  if (isA(a_snsdefLocation, snsdefLocation_VEC))
    {
      if (!findString("snsdefLocation_VEC", snsdefLocationSubs))
        {warnSub("snsdefLocation_VEC", "snsdefLocation", a_snsdefLocation);}
      else
        check_snsdefLocation_VEC(dynamic_cast<snsdefLocation_VEC *>(a_snsdefLocation));
      return;
    }
}

/********************************************************************/

void check_snsdefLocation_CART(
 snsdefLocation_CART * a_snsdefLocation_CART)
{
  if (a_snsdefLocation_CART->get_distVec())
    {
      if (!findString("distVec", snsdefLocation_CARTAtts))
	{warnAtt("distVec", "snsdefLocation_CART", a_snsdefLocation_CART);}
      else
        check_vector(a_snsdefLocation_CART->get_distVec());
    }
  if (a_snsdefLocation_CART->get_sockAxis())
    {
      if (!findString("sockAxis", snsdefLocation_CARTAtts))
	{warnAtt("sockAxis", "snsdefLocation_CART", a_snsdefLocation_CART);}
      else
        check_vector(a_snsdefLocation_CART->get_sockAxis());
    }
}

/********************************************************************/

void check_snsdefLocation_POL(
 snsdefLocation_POL * a_snsdefLocation_POL)
{
  if (a_snsdefLocation_POL->get_tilt())
    {
      if (!findString("tilt", snsdefLocation_POLAtts))
	{warnAtt("tilt", "snsdefLocation_POL", a_snsdefLocation_POL);}
      else
        check_angle(a_snsdefLocation_POL->get_tilt());
    }
  if (a_snsdefLocation_POL->get_rot())
    {
      if (!findString("rot", snsdefLocation_POLAtts))
	{warnAtt("rot", "snsdefLocation_POL", a_snsdefLocation_POL);}
      else
        check_angle(a_snsdefLocation_POL->get_rot());
    }
  if (a_snsdefLocation_POL->get_sockAxis())
    {
      if (!findString("sockAxis", snsdefLocation_POLAtts))
	{warnAtt("sockAxis", "snsdefLocation_POL", a_snsdefLocation_POL);}
      else
        check_vector(a_snsdefLocation_POL->get_sockAxis());
    }
}

/********************************************************************/

void check_snsdefLocation_VEC(
 snsdefLocation_VEC * a_snsdefLocation_VEC)
{
  if (a_snsdefLocation_VEC->get_beamAxis())
    {
      if (!findString("beamAxis", snsdefLocation_VECAtts))
	{warnAtt("beamAxis", "snsdefLocation_VEC", a_snsdefLocation_VEC);}
      else
        check_vector(a_snsdefLocation_VEC->get_beamAxis());
    }
  if (a_snsdefLocation_VEC->get_sockAxis())
    {
      if (!findString("sockAxis", snsdefLocation_VECAtts))
	{warnAtt("sockAxis", "snsdefLocation_VEC", a_snsdefLocation_VEC);}
      else
        check_vector(a_snsdefLocation_VEC->get_sockAxis());
    }
}

/********************************************************************/

void check_snsdefMinor(
 snsdefMinor * a_snsdefMinor)
{
  if (isA(a_snsdefMinor, snsdefProbe))
    {
      if (!findString("snsdefProbe", snsdefMinorSubs))
        {warnSub("snsdefProbe", "snsdefMinor", a_snsdefMinor);}
      else
        check_snsdefProbe(dynamic_cast<snsdefProbe *>(a_snsdefMinor));
      return;
    }
  if (isA(a_snsdefMinor, snsdefVideo))
    {
      if (!findString("snsdefVideo", snsdefMinorSubs))
        {warnSub("snsdefVideo", "snsdefMinor", a_snsdefMinor);}
      else
        check_snsdefVideo(dynamic_cast<snsdefVideo *>(a_snsdefMinor));
      return;
    }
  if (isA(a_snsdefMinor, snsdefLaser))
    {
      if (!findString("snsdefLaser", snsdefMinorSubs))
        {warnSub("snsdefLaser", "snsdefMinor", a_snsdefMinor);}
      else
        check_snsdefLaser(dynamic_cast<snsdefLaser *>(a_snsdefMinor));
      return;
    }
  if (isA(a_snsdefMinor, snsdefInfred))
    {
      if (!findString("snsdefInfred", snsdefMinorSubs))
        {warnSub("snsdefInfred", "snsdefMinor", a_snsdefMinor);}
      else
        check_snsdefInfred(dynamic_cast<snsdefInfred *>(a_snsdefMinor));
      return;
    }
  if (isA(a_snsdefMinor, snsdefNoncon))
    {
      if (!findString("snsdefNoncon", snsdefMinorSubs))
        {warnSub("snsdefNoncon", "snsdefMinor", a_snsdefMinor);}
      else
        check_snsdefNoncon(dynamic_cast<snsdefNoncon *>(a_snsdefMinor));
      return;
    }
  if (isA(a_snsdefMinor, snsdefBuild))
    {
      if (!findString("snsdefBuild", snsdefMinorSubs))
        {warnSub("snsdefBuild", "snsdefMinor", a_snsdefMinor);}
      else
        check_snsdefBuild(dynamic_cast<snsdefBuild *>(a_snsdefMinor));
      return;
    }
}

/********************************************************************/

void check_snsdefNoncon(
 snsdefNoncon * a_snsdefNoncon)
{
  if (a_snsdefNoncon->get_snsdefType())
    {
      if (!findString("a_snsdefType", snsdefNonconAtts))
	{warnAtt("a_snsdefType", "snsdefNoncon", a_snsdefNoncon);}
      else
        check_snsdefType(a_snsdefNoncon->get_snsdefType());
    }
  if (a_snsdefNoncon->get_snsdefLocation())
    {
      if (!findString("a_snsdefLocation", snsdefNonconAtts))
	{warnAtt("a_snsdefLocation", "snsdefNoncon", a_snsdefNoncon);}
      else
        check_snsdefLocation(a_snsdefNoncon->get_snsdefLocation());
    }
  if (a_snsdefNoncon->get_numProbes())
    {
      if (!findString("numProbes", snsdefNonconAtts))
	{warnAtt("numProbes", "snsdefNoncon", a_snsdefNoncon);}
      else
        check_intVal(a_snsdefNoncon->get_numProbes());
    }
}

/********************************************************************/

void check_snsdefProbe(
 snsdefProbe * a_snsdefProbe)
{
  if (a_snsdefProbe->get_snsdefType())
    {
      if (!findString("a_snsdefType", snsdefProbeAtts))
	{warnAtt("a_snsdefType", "snsdefProbe", a_snsdefProbe);}
      else
        check_snsdefType(a_snsdefProbe->get_snsdefType());
    }
  if (a_snsdefProbe->get_probeLocation())
    {
      if (!findString("a_probeLocation", snsdefProbeAtts))
	{warnAtt("a_probeLocation", "snsdefProbe", a_snsdefProbe);}
      else
        check_probeLocation(a_snsdefProbe->get_probeLocation());
    }
  if (a_snsdefProbe->get_diam())
    {
      if (!findString("diam", snsdefProbeAtts))
	{warnAtt("diam", "snsdefProbe", a_snsdefProbe);}
      else
        check_rentVal(a_snsdefProbe->get_diam());
    }
  if (a_snsdefProbe->get_snsdefProbeForm())
    {
      if (!findString("a_snsdefProbeForm", snsdefProbeAtts))
	{warnAtt("a_snsdefProbeForm", "snsdefProbe", a_snsdefProbe);}
      else
        check_snsdefProbeForm(a_snsdefProbe->get_snsdefProbeForm());
    }
}

/********************************************************************/

void check_snsdefProbeForm(
 snsdefProbeForm * a_snsdefProbeForm)
{
  if (isA(a_snsdefProbeForm, snsdefProbeForm_SPHERE))
    {
      if (!findString("snsdefProbeForm_SPHERE", snsdefProbeFormSubs))
        {warnSub("snsdefProbeForm_SPHERE", "snsdefProbeForm", a_snsdefProbeForm);}
      return;
    }
  if (isA(a_snsdefProbeForm, snsdefProbeForm_CYLNDR))
    {
      if (!findString("snsdefProbeForm_CYLNDR", snsdefProbeFormSubs))
        {warnSub("snsdefProbeForm_CYLNDR", "snsdefProbeForm", a_snsdefProbeForm);}
      else
        check_snsdefProbeForm_CYLNDR(dynamic_cast<snsdefProbeForm_CYLNDR *>(a_snsdefProbeForm));
      return;
    }
  if (isA(a_snsdefProbeForm, snsdefProbeForm_DISK))
    {
      if (!findString("snsdefProbeForm_DISK", snsdefProbeFormSubs))
        {warnSub("snsdefProbeForm_DISK", "snsdefProbeForm", a_snsdefProbeForm);}
      else
        check_snsdefProbeForm_DISK(dynamic_cast<snsdefProbeForm_DISK *>(a_snsdefProbeForm));
      return;
    }
}

/********************************************************************/

void check_snsdefProbeForm_CYLNDR(
 snsdefProbeForm_CYLNDR * a_snsdefProbeForm_CYLNDR)
{
  if (a_snsdefProbeForm_CYLNDR->get_len2())
    {
      if (!findString("len2", snsdefProbeForm_CYLNDRAtts))
	{warnAtt("len2", "snsdefProbeForm_CYLNDR", a_snsdefProbeForm_CYLNDR);}
      else
        check_rentVal(a_snsdefProbeForm_CYLNDR->get_len2());
    }
}

/********************************************************************/

void check_snsdefProbeForm_DISK(
 snsdefProbeForm_DISK * a_snsdefProbeForm_DISK)
{
  if (a_snsdefProbeForm_DISK->get_thkn())
    {
      if (!findString("thkn", snsdefProbeForm_DISKAtts))
	{warnAtt("thkn", "snsdefProbeForm_DISK", a_snsdefProbeForm_DISK);}
      else
        check_rentVal(a_snsdefProbeForm_DISK->get_thkn());
    }
}

/********************************************************************/

void check_snsdefStm(
 snsdefStm * a_snsdefStm)
{
  if (a_snsdefStm->get_sLabel())
    {
      if (!findString("a_sLabel", snsdefStmAtts))
	{warnAtt("a_sLabel", "snsdefStm", a_snsdefStm);}
      else
        check_sLabel(a_snsdefStm->get_sLabel());
    }
  if (a_snsdefStm->get_snsdefMinor())
    {
      if (!findString("a_snsdefMinor", snsdefStmAtts))
	{warnAtt("a_snsdefMinor", "snsdefStm", a_snsdefStm);}
      else
        check_snsdefMinor(a_snsdefStm->get_snsdefMinor());
    }
}

/********************************************************************/

void check_snsdefType(
 snsdefType * a_snsdefType)
{
  if (isA(a_snsdefType, snsdefType_FIXED))
    {
      if (!findString("snsdefType_FIXED", snsdefTypeSubs))
        {warnSub("snsdefType_FIXED", "snsdefType", a_snsdefType);}
      return;
    }
  if (isA(a_snsdefType, snsdefType_INDEX))
    {
      if (!findString("snsdefType_INDEX", snsdefTypeSubs))
        {warnSub("snsdefType_INDEX", "snsdefType", a_snsdefType);}
      return;
    }
}

/********************************************************************/

void check_snsdefVideo(
 snsdefVideo * a_snsdefVideo)
{
  if (a_snsdefVideo->get_snsdefType())
    {
      if (!findString("a_snsdefType", snsdefVideoAtts))
	{warnAtt("a_snsdefType", "snsdefVideo", a_snsdefVideo);}
      else
        check_snsdefType(a_snsdefVideo->get_snsdefType());
    }
  if (a_snsdefVideo->get_snsdefLocation())
    {
      if (!findString("a_snsdefLocation", snsdefVideoAtts))
	{warnAtt("a_snsdefLocation", "snsdefVideo", a_snsdefVideo);}
      else
        check_snsdefLocation(a_snsdefVideo->get_snsdefLocation());
    }
  if (a_snsdefVideo->get_focal())
    {
      if (!findString("focal", snsdefVideoAtts))
	{warnAtt("focal", "snsdefVideo", a_snsdefVideo);}
      else
        check_rentVal(a_snsdefVideo->get_focal());
    }
  if (a_snsdefVideo->get_mag())
    {
      if (!findString("mag", snsdefVideoAtts))
	{warnAtt("mag", "snsdefVideo", a_snsdefVideo);}
      else
        check_rentVal(a_snsdefVideo->get_mag());
    }
  if (a_snsdefVideo->get_apert())
    {
      if (!findString("apert", snsdefVideoAtts))
	{warnAtt("apert", "snsdefVideo", a_snsdefVideo);}
      else
        check_rentVal(a_snsdefVideo->get_apert());
    }
}

/********************************************************************/

void check_snsdefWristAngleItem(
 snsdefWristAngleItem * a_snsdefWristAngleItem)
{
  if (a_snsdefWristAngleItem->get_anglename())
    {
      if (!findString("anglename", snsdefWristAngleItemAtts))
	{warnAtt("anglename", "snsdefWristAngleItem", a_snsdefWristAngleItem);}
      else
        check_stringVal(a_snsdefWristAngleItem->get_anglename());
    }
  if (a_snsdefWristAngleItem->get_angle())
    {
      if (!findString("a_angle", snsdefWristAngleItemAtts))
	{warnAtt("a_angle", "snsdefWristAngleItem", a_snsdefWristAngleItem);}
      else
        check_angle(a_snsdefWristAngleItem->get_angle());
    }
}

/********************************************************************/

void check_snsetFeat(
 snsetFeat * a_snsetFeat)
{
  if (isA(a_snsetFeat, fLabel))
    {
      if (!findString("fLabel", snsetFeatSubs))
        {warnSub("fLabel", "snsetFeat", a_snsetFeat);}
      else
        check_fLabel(dynamic_cast<fLabel *>(a_snsetFeat));
      return;
    }
  if (isA(a_snsetFeat, faLabel))
    {
      if (!findString("faLabel", snsetFeatSubs))
        {warnSub("faLabel", "snsetFeat", a_snsetFeat);}
      else
        check_faLabel(dynamic_cast<faLabel *>(a_snsetFeat));
      return;
    }
  if (isA(a_snsetFeat, datLabel))
    {
      if (!findString("datLabel", snsetFeatSubs))
        {warnSub("datLabel", "snsetFeat", a_snsetFeat);}
      else
        check_datLabel(dynamic_cast<datLabel *>(a_snsetFeat));
      return;
    }
}

/********************************************************************/

void check_snsetItem(
 snsetItem * a_snsetItem)
{
  if (isA(a_snsetItem, snsetItem_snsetTypeAndValue))
    {
      if (!findString("snsetItem_snsetTypeAndValue", snsetItemSubs))
        {warnSub("snsetItem_snsetTypeAndValue", "snsetItem", a_snsetItem);}
      else
        check_snsetItem_snsetTypeAndValue(dynamic_cast<snsetItem_snsetTypeAndValue *>(a_snsetItem));
      return;
    }
  if (isA(a_snsetItem, snsetItem_snsetType))
    {
      if (!findString("snsetItem_snsetType", snsetItemSubs))
        {warnSub("snsetItem_snsetType", "snsetItem", a_snsetItem);}
      else
        check_snsetItem_snsetType(dynamic_cast<snsetItem_snsetType *>(a_snsetItem));
      return;
    }
  if (isA(a_snsetItem, snsetItem_snsetLabelAndValue))
    {
      if (!findString("snsetItem_snsetLabelAndValue", snsetItemSubs))
        {warnSub("snsetItem_snsetLabelAndValue", "snsetItem", a_snsetItem);}
      else
        check_snsetItem_snsetLabelAndValue(dynamic_cast<snsetItem_snsetLabelAndValue *>(a_snsetItem));
      return;
    }
  if (isA(a_snsetItem, snsetItem_snsetLabel))
    {
      if (!findString("snsetItem_snsetLabel", snsetItemSubs))
        {warnSub("snsetItem_snsetLabel", "snsetItem", a_snsetItem);}
      else
        check_snsetItem_snsetLabel(dynamic_cast<snsetItem_snsetLabel *>(a_snsetItem));
      return;
    }
  if (isA(a_snsetItem, snsetItem_snsetToggle))
    {
      if (!findString("snsetItem_snsetToggle", snsetItemSubs))
        {warnSub("snsetItem_snsetToggle", "snsetItem", a_snsetItem);}
      else
        check_snsetItem_snsetToggle(dynamic_cast<snsetItem_snsetToggle *>(a_snsetItem));
      return;
    }
  if (isA(a_snsetItem, snsetItem_CLRSRF))
    {
      if (!findString("snsetItem_CLRSRF", snsetItemSubs))
        {warnSub("snsetItem_CLRSRF", "snsetItem", a_snsetItem);}
      else
        check_snsetItem_CLRSRF(dynamic_cast<snsetItem_CLRSRF *>(a_snsetItem));
      return;
    }
  if (isA(a_snsetItem, snsetItem_DEPTH))
    {
      if (!findString("snsetItem_DEPTH", snsetItemSubs))
        {warnSub("snsetItem_DEPTH", "snsetItem", a_snsetItem);}
      else
        check_snsetItem_DEPTH(dynamic_cast<snsetItem_DEPTH *>(a_snsetItem));
      return;
    }
}

/********************************************************************/

void check_snsetItem_CLRSRF(
 snsetItem_CLRSRF * a_snsetItem_CLRSRF)
{
  if (a_snsetItem_CLRSRF->get_snsetFeat())
    {
      if (!findString("a_snsetFeat", snsetItem_CLRSRFAtts))
	{warnAtt("a_snsetFeat", "snsetItem_CLRSRF", a_snsetItem_CLRSRF);}
      else
        check_snsetFeat(a_snsetItem_CLRSRF->get_snsetFeat());
    }
  if (a_snsetItem_CLRSRF->get_dist())
    {
      if (!findString("dist", snsetItem_CLRSRFAtts))
	{warnAtt("dist", "snsetItem_CLRSRF", a_snsetItem_CLRSRF);}
      else
        check_rentVal(a_snsetItem_CLRSRF->get_dist());
    }
}

/********************************************************************/

void check_snsetItem_DEPTH(
 snsetItem_DEPTH * a_snsetItem_DEPTH)
{
  if (a_snsetItem_DEPTH->get_snsetFeat())
    {
      if (!findString("a_snsetFeat", snsetItem_DEPTHAtts))
	{warnAtt("a_snsetFeat", "snsetItem_DEPTH", a_snsetItem_DEPTH);}
      else
        check_snsetFeat(a_snsetItem_DEPTH->get_snsetFeat());
    }
  if (a_snsetItem_DEPTH->get_dist())
    {
      if (!findString("dist", snsetItem_DEPTHAtts))
	{warnAtt("dist", "snsetItem_DEPTH", a_snsetItem_DEPTH);}
      else
        check_rentVal(a_snsetItem_DEPTH->get_dist());
    }
}

/********************************************************************/

void check_snsetItem_snsetLabel(
 snsetItem_snsetLabel * a_snsetItem_snsetLabel)
{
  if (a_snsetItem_snsetLabel->get_snsetLabel())
    {
      if (!findString("a_snsetLabel", snsetItem_snsetLabelAtts))
	{warnAtt("a_snsetLabel", "snsetItem_snsetLabel", a_snsetItem_snsetLabel);}
      else
        check_snsetLabel(a_snsetItem_snsetLabel->get_snsetLabel());
    }
}

/********************************************************************/

void check_snsetItem_snsetLabelAndValue(
 snsetItem_snsetLabelAndValue * a_snsetItem_snsetLabelAndValue)
{
  if (a_snsetItem_snsetLabelAndValue->get_snsetLabelAndValue())
    {
      if (!findString("a_snsetLabelAndValue", snsetItem_snsetLabelAndValueAtts))
	{warnAtt("a_snsetLabelAndValue", "snsetItem_snsetLabelAndValue", a_snsetItem_snsetLabelAndValue);}
      else
        check_snsetLabelAndValue(a_snsetItem_snsetLabelAndValue->get_snsetLabelAndValue());
    }
}

/********************************************************************/

void check_snsetItem_snsetToggle(
 snsetItem_snsetToggle * a_snsetItem_snsetToggle)
{
  if (a_snsetItem_snsetToggle->get_snsetToggle())
    {
      if (!findString("a_snsetToggle", snsetItem_snsetToggleAtts))
	{warnAtt("a_snsetToggle", "snsetItem_snsetToggle", a_snsetItem_snsetToggle);}
      else
        check_snsetToggle(a_snsetItem_snsetToggle->get_snsetToggle());
    }
}

/********************************************************************/

void check_snsetItem_snsetType(
 snsetItem_snsetType * a_snsetItem_snsetType)
{
  if (a_snsetItem_snsetType->get_snsetType())
    {
      if (!findString("a_snsetType", snsetItem_snsetTypeAtts))
	{warnAtt("a_snsetType", "snsetItem_snsetType", a_snsetItem_snsetType);}
      else
        check_snsetType(a_snsetItem_snsetType->get_snsetType());
    }
}

/********************************************************************/

void check_snsetItem_snsetTypeAndValue(
 snsetItem_snsetTypeAndValue * a_snsetItem_snsetTypeAndValue)
{
  if (a_snsetItem_snsetTypeAndValue->get_snsetTypeAndValue())
    {
      if (!findString("a_snsetTypeAndValue", snsetItem_snsetTypeAndValueAtts))
	{warnAtt("a_snsetTypeAndValue", "snsetItem_snsetTypeAndValue", a_snsetItem_snsetTypeAndValue);}
      else
        check_snsetTypeAndValue(a_snsetItem_snsetTypeAndValue->get_snsetTypeAndValue());
    }
}

/********************************************************************/

void check_snsetLabel(
 snsetLabel * a_snsetLabel)
{
  if (isA(a_snsetLabel, vaLabel))
    {
      if (!findString("vaLabel", snsetLabelSubs))
        {warnSub("vaLabel", "snsetLabel", a_snsetLabel);}
      else
        check_vaLabel(dynamic_cast<vaLabel *>(a_snsetLabel));
      return;
    }
  if (isA(a_snsetLabel, vfLabel))
    {
      if (!findString("vfLabel", snsetLabelSubs))
        {warnSub("vfLabel", "snsetLabel", a_snsetLabel);}
      else
        check_vfLabel(dynamic_cast<vfLabel *>(a_snsetLabel));
      return;
    }
  if (isA(a_snsetLabel, vwLabel))
    {
      if (!findString("vwLabel", snsetLabelSubs))
        {warnSub("vwLabel", "snsetLabel", a_snsetLabel);}
      else
        check_vwLabel(dynamic_cast<vwLabel *>(a_snsetLabel));
      return;
    }
}

/********************************************************************/

void check_snsetLabelAndValue(
 snsetLabelAndValue * a_snsetLabelAndValue)
{
  if (a_snsetLabelAndValue->get_vlLabel())
    {
      if (!findString("a_vlLabel", snsetLabelAndValueAtts))
	{warnAtt("a_vlLabel", "snsetLabelAndValue", a_snsetLabelAndValue);}
      else
        check_vlLabel(a_snsetLabelAndValue->get_vlLabel());
    }
  if (a_snsetLabelAndValue->get_intnsty())
    {
      if (!findString("intnsty", snsetLabelAndValueAtts))
	{warnAtt("intnsty", "snsetLabelAndValue", a_snsetLabelAndValue);}
      else
        check_rentVal(a_snsetLabelAndValue->get_intnsty());
    }
}

/********************************************************************/

void check_snsetStm(
 snsetStm * a_snsetStm)
{
  if (a_snsetStm->get_snsetItemList())
    {
      if (!findString("a_snsetItemList", snsetStmAtts))
	{warnAtt("a_snsetItemList", "snsetStm", a_snsetStm);}
      else
        {
          std::list<snsetItem *> * theList;
          std::list<snsetItem *>::iterator iter;
          theList = a_snsetStm->get_snsetItemList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_snsetItem(*iter);
        }
    }
}

/********************************************************************/

void check_snsetToggle(
 snsetToggle * a_snsetToggle)
{
  if (isA(a_snsetToggle, snsetToggle_CLRSRF))
    {
      if (!findString("snsetToggle_CLRSRF", snsetToggleSubs))
        {warnSub("snsetToggle_CLRSRF", "snsetToggle", a_snsetToggle);}
      return;
    }
  if (isA(a_snsetToggle, snsetToggle_DEPTH))
    {
      if (!findString("snsetToggle_DEPTH", snsetToggleSubs))
        {warnSub("snsetToggle_DEPTH", "snsetToggle", a_snsetToggle);}
      return;
    }
}

/********************************************************************/

void check_snsetType(
 snsetType * a_snsetType)
{
  if (isA(a_snsetType, snsetType_FOCUSY))
    {
      if (!findString("snsetType_FOCUSY", snsetTypeSubs))
        {warnSub("snsetType_FOCUSY", "snsetType", a_snsetType);}
      return;
    }
  if (isA(a_snsetType, snsetType_FOCUSN))
    {
      if (!findString("snsetType_FOCUSN", snsetTypeSubs))
        {warnSub("snsetType_FOCUSN", "snsetType", a_snsetType);}
      return;
    }
}

/********************************************************************/

void check_snsetTypeAndValue(
 snsetTypeAndValue * a_snsetTypeAndValue)
{
  if (isA(a_snsetTypeAndValue, snsetTypeAndValue_APPRCH))
    {
      if (!findString("snsetTypeAndValue_APPRCH", snsetTypeAndValueSubs))
        {warnSub("snsetTypeAndValue_APPRCH", "snsetTypeAndValue", a_snsetTypeAndValue);}
      else
        check_snsetTypeAndValue_APPRCH(dynamic_cast<snsetTypeAndValue_APPRCH *>(a_snsetTypeAndValue));
      return;
    }
  if (isA(a_snsetTypeAndValue, snsetTypeAndValue_CLRSRF))
    {
      if (!findString("snsetTypeAndValue_CLRSRF", snsetTypeAndValueSubs))
        {warnSub("snsetTypeAndValue_CLRSRF", "snsetTypeAndValue", a_snsetTypeAndValue);}
      else
        check_snsetTypeAndValue_CLRSRF(dynamic_cast<snsetTypeAndValue_CLRSRF *>(a_snsetTypeAndValue));
      return;
    }
  if (isA(a_snsetTypeAndValue, snsetTypeAndValue_DEPTH))
    {
      if (!findString("snsetTypeAndValue_DEPTH", snsetTypeAndValueSubs))
        {warnSub("snsetTypeAndValue_DEPTH", "snsetTypeAndValue", a_snsetTypeAndValue);}
      else
        check_snsetTypeAndValue_DEPTH(dynamic_cast<snsetTypeAndValue_DEPTH *>(a_snsetTypeAndValue));
      return;
    }
  if (isA(a_snsetTypeAndValue, snsetTypeAndValue_MINCON))
    {
      if (!findString("snsetTypeAndValue_MINCON", snsetTypeAndValueSubs))
        {warnSub("snsetTypeAndValue_MINCON", "snsetTypeAndValue", a_snsetTypeAndValue);}
      else
        check_snsetTypeAndValue_MINCON(dynamic_cast<snsetTypeAndValue_MINCON *>(a_snsetTypeAndValue));
      return;
    }
  if (isA(a_snsetTypeAndValue, snsetTypeAndValue_RETRCT))
    {
      if (!findString("snsetTypeAndValue_RETRCT", snsetTypeAndValueSubs))
        {warnSub("snsetTypeAndValue_RETRCT", "snsetTypeAndValue", a_snsetTypeAndValue);}
      else
        check_snsetTypeAndValue_RETRCT(dynamic_cast<snsetTypeAndValue_RETRCT *>(a_snsetTypeAndValue));
      return;
    }
  if (isA(a_snsetTypeAndValue, snsetTypeAndValue_SEARCH))
    {
      if (!findString("snsetTypeAndValue_SEARCH", snsetTypeAndValueSubs))
        {warnSub("snsetTypeAndValue_SEARCH", "snsetTypeAndValue", a_snsetTypeAndValue);}
      else
        check_snsetTypeAndValue_SEARCH(dynamic_cast<snsetTypeAndValue_SEARCH *>(a_snsetTypeAndValue));
      return;
    }
  if (isA(a_snsetTypeAndValue, snsetTypeAndValue_SCALEX))
    {
      if (!findString("snsetTypeAndValue_SCALEX", snsetTypeAndValueSubs))
        {warnSub("snsetTypeAndValue_SCALEX", "snsetTypeAndValue", a_snsetTypeAndValue);}
      else
        check_snsetTypeAndValue_SCALEX(dynamic_cast<snsetTypeAndValue_SCALEX *>(a_snsetTypeAndValue));
      return;
    }
  if (isA(a_snsetTypeAndValue, snsetTypeAndValue_SCALEY))
    {
      if (!findString("snsetTypeAndValue_SCALEY", snsetTypeAndValueSubs))
        {warnSub("snsetTypeAndValue_SCALEY", "snsetTypeAndValue", a_snsetTypeAndValue);}
      else
        check_snsetTypeAndValue_SCALEY(dynamic_cast<snsetTypeAndValue_SCALEY *>(a_snsetTypeAndValue));
      return;
    }
}

/********************************************************************/

void check_snsetTypeAndValue_APPRCH(
 snsetTypeAndValue_APPRCH * a_snsetTypeAndValue_APPRCH)
{
  if (a_snsetTypeAndValue_APPRCH->get_dist())
    {
      if (!findString("dist", snsetTypeAndValue_APPRCHAtts))
	{warnAtt("dist", "snsetTypeAndValue_APPRCH", a_snsetTypeAndValue_APPRCH);}
      else
        check_rentVal(a_snsetTypeAndValue_APPRCH->get_dist());
    }
}

/********************************************************************/

void check_snsetTypeAndValue_CLRSRF(
 snsetTypeAndValue_CLRSRF * a_snsetTypeAndValue_CLRSRF)
{
  if (a_snsetTypeAndValue_CLRSRF->get_dist())
    {
      if (!findString("dist", snsetTypeAndValue_CLRSRFAtts))
	{warnAtt("dist", "snsetTypeAndValue_CLRSRF", a_snsetTypeAndValue_CLRSRF);}
      else
        check_rentVal(a_snsetTypeAndValue_CLRSRF->get_dist());
    }
}

/********************************************************************/

void check_snsetTypeAndValue_DEPTH(
 snsetTypeAndValue_DEPTH * a_snsetTypeAndValue_DEPTH)
{
  if (a_snsetTypeAndValue_DEPTH->get_dist())
    {
      if (!findString("dist", snsetTypeAndValue_DEPTHAtts))
	{warnAtt("dist", "snsetTypeAndValue_DEPTH", a_snsetTypeAndValue_DEPTH);}
      else
        check_rentVal(a_snsetTypeAndValue_DEPTH->get_dist());
    }
}

/********************************************************************/

void check_snsetTypeAndValue_MINCON(
 snsetTypeAndValue_MINCON * a_snsetTypeAndValue_MINCON)
{
  if (a_snsetTypeAndValue_MINCON->get_level())
    {
      if (!findString("level", snsetTypeAndValue_MINCONAtts))
	{warnAtt("level", "snsetTypeAndValue_MINCON", a_snsetTypeAndValue_MINCON);}
      else
        check_rentVal(a_snsetTypeAndValue_MINCON->get_level());
    }
}

/********************************************************************/

void check_snsetTypeAndValue_RETRCT(
 snsetTypeAndValue_RETRCT * a_snsetTypeAndValue_RETRCT)
{
  if (a_snsetTypeAndValue_RETRCT->get_dist())
    {
      if (!findString("dist", snsetTypeAndValue_RETRCTAtts))
	{warnAtt("dist", "snsetTypeAndValue_RETRCT", a_snsetTypeAndValue_RETRCT);}
      else
        check_rentVal(a_snsetTypeAndValue_RETRCT->get_dist());
    }
}

/********************************************************************/

void check_snsetTypeAndValue_SCALEX(
 snsetTypeAndValue_SCALEX * a_snsetTypeAndValue_SCALEX)
{
  if (a_snsetTypeAndValue_SCALEX->get_scale())
    {
      if (!findString("scale", snsetTypeAndValue_SCALEXAtts))
	{warnAtt("scale", "snsetTypeAndValue_SCALEX", a_snsetTypeAndValue_SCALEX);}
      else
        check_rentVal(a_snsetTypeAndValue_SCALEX->get_scale());
    }
}

/********************************************************************/

void check_snsetTypeAndValue_SCALEY(
 snsetTypeAndValue_SCALEY * a_snsetTypeAndValue_SCALEY)
{
  if (a_snsetTypeAndValue_SCALEY->get_scale())
    {
      if (!findString("scale", snsetTypeAndValue_SCALEYAtts))
	{warnAtt("scale", "snsetTypeAndValue_SCALEY", a_snsetTypeAndValue_SCALEY);}
      else
        check_rentVal(a_snsetTypeAndValue_SCALEY->get_scale());
    }
}

/********************************************************************/

void check_snsetTypeAndValue_SEARCH(
 snsetTypeAndValue_SEARCH * a_snsetTypeAndValue_SEARCH)
{
  if (a_snsetTypeAndValue_SEARCH->get_dist())
    {
      if (!findString("dist", snsetTypeAndValue_SEARCHAtts))
	{warnAtt("dist", "snsetTypeAndValue_SEARCH", a_snsetTypeAndValue_SEARCH);}
      else
        check_rentVal(a_snsetTypeAndValue_SEARCH->get_dist());
    }
}

/********************************************************************/

void check_snsgrpItem(
 snsgrpItem * a_snsgrpItem)
{
  if (isA(a_snsgrpItem, sgLabel))
    {
      if (!findString("sgLabel", snsgrpItemSubs))
        {warnSub("sgLabel", "snsgrpItem", a_snsgrpItem);}
      else
        check_sgLabel(dynamic_cast<sgLabel *>(a_snsgrpItem));
      return;
    }
  if (isA(a_snsgrpItem, swLabel))
    {
      if (!findString("swLabel", snsgrpItemSubs))
        {warnSub("swLabel", "snsgrpItem", a_snsgrpItem);}
      else
        check_swLabel(dynamic_cast<swLabel *>(a_snsgrpItem));
      return;
    }
  if (isA(a_snsgrpItem, sxLabel))
    {
      if (!findString("sxLabel", snsgrpItemSubs))
        {warnSub("sxLabel", "snsgrpItem", a_snsgrpItem);}
      else
        check_sxLabel(dynamic_cast<sxLabel *>(a_snsgrpItem));
      return;
    }
  if (isA(a_snsgrpItem, rmLabel))
    {
      if (!findString("rmLabel", snsgrpItemSubs))
        {warnSub("rmLabel", "snsgrpItem", a_snsgrpItem);}
      else
        check_rmLabel(dynamic_cast<rmLabel *>(a_snsgrpItem));
      return;
    }
}

/********************************************************************/

void check_snsgrpMinor(
 snsgrpMinor * a_snsgrpMinor)
{
  if (isA(a_snsgrpMinor, snsgrpMinor_ssLabel))
    {
      if (!findString("snsgrpMinor_ssLabel", snsgrpMinorSubs))
        {warnSub("snsgrpMinor_ssLabel", "snsgrpMinor", a_snsgrpMinor);}
      else
        check_snsgrpMinor_ssLabel(dynamic_cast<snsgrpMinor_ssLabel *>(a_snsgrpMinor));
      return;
    }
  if (isA(a_snsgrpMinor, snsgrpMinor_sgsLabel))
    {
      if (!findString("snsgrpMinor_sgsLabel", snsgrpMinorSubs))
        {warnSub("snsgrpMinor_sgsLabel", "snsgrpMinor", a_snsgrpMinor);}
      else
        check_snsgrpMinor_sgsLabel(dynamic_cast<snsgrpMinor_sgsLabel *>(a_snsgrpMinor));
      return;
    }
}

/********************************************************************/

void check_snsgrpMinor_sgsLabel(
 snsgrpMinor_sgsLabel * a_snsgrpMinor_sgsLabel)
{
  if (a_snsgrpMinor_sgsLabel->get_snsgrpItemList())
    {
      if (!findString("a_snsgrpItemList", snsgrpMinor_sgsLabelAtts))
	{warnAtt("a_snsgrpItemList", "snsgrpMinor_sgsLabel", a_snsgrpMinor_sgsLabel);}
      else
        {
          std::list<snsgrpItem *> * theList;
          std::list<snsgrpItem *>::iterator iter;
          theList = a_snsgrpMinor_sgsLabel->get_snsgrpItemList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_snsgrpItem(*iter);
        }
    }
  if (a_snsgrpMinor_sgsLabel->get_sgsLabel())
    {
      if (!findString("a_sgsLabel", snsgrpMinor_sgsLabelAtts))
	{warnAtt("a_sgsLabel", "snsgrpMinor_sgsLabel", a_snsgrpMinor_sgsLabel);}
      else
        check_sgsLabel(a_snsgrpMinor_sgsLabel->get_sgsLabel());
    }
}

/********************************************************************/

void check_snsgrpMinor_ssLabel(
 snsgrpMinor_ssLabel * a_snsgrpMinor_ssLabel)
{
  if (a_snsgrpMinor_ssLabel->get_snsgrpItemList())
    {
      if (!findString("a_snsgrpItemList", snsgrpMinor_ssLabelAtts))
	{warnAtt("a_snsgrpItemList", "snsgrpMinor_ssLabel", a_snsgrpMinor_ssLabel);}
      else
        {
          std::list<snsgrpItem *> * theList;
          std::list<snsgrpItem *>::iterator iter;
          theList = a_snsgrpMinor_ssLabel->get_snsgrpItemList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_snsgrpItem(*iter);
        }
    }
  if (a_snsgrpMinor_ssLabel->get_ssLabel())
    {
      if (!findString("a_ssLabel", snsgrpMinor_ssLabelAtts))
	{warnAtt("a_ssLabel", "snsgrpMinor_ssLabel", a_snsgrpMinor_ssLabel);}
      else
        check_ssLabel(a_snsgrpMinor_ssLabel->get_ssLabel());
    }
}

/********************************************************************/

void check_snsgrpStm(
 snsgrpStm * a_snsgrpStm)
{
  if (a_snsgrpStm->get_sgsLabel())
    {
      if (!findString("a_sgsLabel", snsgrpStmAtts))
	{warnAtt("a_sgsLabel", "snsgrpStm", a_snsgrpStm);}
      else
        check_sgsLabel(a_snsgrpStm->get_sgsLabel());
    }
  if (a_snsgrpStm->get_snsgrpMinor())
    {
      if (!findString("a_snsgrpMinor", snsgrpStmAtts))
	{warnAtt("a_snsgrpMinor", "snsgrpStm", a_snsgrpStm);}
      else
        check_snsgrpMinor(a_snsgrpStm->get_snsgrpMinor());
    }
}

/********************************************************************/

void check_snslctData(
 snslctData * a_snslctData)
{
  if (isA(a_snslctData, snslctData_snslctWristList))
    {
      if (!findString("snslctData_snslctWristList", snslctDataSubs))
        {warnSub("snslctData_snslctWristList", "snslctData", a_snslctData);}
      else
        check_snslctData_snslctWristList(dynamic_cast<snslctData_snslctWristList *>(a_snslctData));
      return;
    }
  if (isA(a_snslctData, snslctData_probeOrient))
    {
      if (!findString("snslctData_probeOrient", snslctDataSubs))
        {warnSub("snslctData_probeOrient", "snslctData", a_snslctData);}
      else
        check_snslctData_probeOrient(dynamic_cast<snslctData_probeOrient *>(a_snslctData));
      return;
    }
}

/********************************************************************/

void check_snslctData_probeOrient(
 snslctData_probeOrient * a_snslctData_probeOrient)
{
  if (a_snslctData_probeOrient->get_probeOrient())
    {
      if (!findString("a_probeOrient", snslctData_probeOrientAtts))
	{warnAtt("a_probeOrient", "snslctData_probeOrient", a_snslctData_probeOrient);}
      else
        check_probeOrient(a_snslctData_probeOrient->get_probeOrient());
    }
}

/********************************************************************/

void check_snslctData_snslctWristList(
 snslctData_snslctWristList * a_snslctData_snslctWristList)
{
  if (a_snslctData_snslctWristList->get_snslctWristList())
    {
      if (!findString("a_snslctWristList", snslctData_snslctWristListAtts))
	{warnAtt("a_snslctWristList", "snslctData_snslctWristList", a_snslctData_snslctWristList);}
      else
        {
          std::list<snslctWristItem *> * theList;
          std::list<snslctWristItem *>::iterator iter;
          theList = a_snslctData_snslctWristList->get_snslctWristList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_snslctWristItem(*iter);
        }
    }
}

/********************************************************************/

void check_snslctGroup(
 snslctGroup * a_snslctGroup)
{
  if (isA(a_snslctGroup, snslctGroupFeat))
    {
      if (!findString("snslctGroupFeat", snslctGroupSubs))
        {warnSub("snslctGroupFeat", "snslctGroup", a_snslctGroup);}
      else
        check_snslctGroupFeat(dynamic_cast<snslctGroupFeat *>(a_snslctGroup));
      return;
    }
  if (isA(a_snslctGroup, snslctGroupVec))
    {
      if (!findString("snslctGroupVec", snslctGroupSubs))
        {warnSub("snslctGroupVec", "snslctGroup", a_snslctGroup);}
      else
        check_snslctGroupVec(dynamic_cast<snslctGroupVec *>(a_snslctGroup));
      return;
    }
}

/********************************************************************/

void check_snslctGroupFeat(
 snslctGroupFeat * a_snslctGroupFeat)
{
  if (a_snslctGroupFeat->get_gsaLabel())
    {
      if (!findString("a_gsaLabel", snslctGroupFeatAtts))
	{warnAtt("a_gsaLabel", "snslctGroupFeat", a_snslctGroupFeat);}
      else
        check_gsaLabel(a_snslctGroupFeat->get_gsaLabel());
    }
  if (a_snslctGroupFeat->get_featureLabel())
    {
      if (!findString("a_featureLabel", snslctGroupFeatAtts))
	{warnAtt("a_featureLabel", "snslctGroupFeat", a_snslctGroupFeat);}
      else
        check_featureLabel(a_snslctGroupFeat->get_featureLabel());
    }
  if (a_snslctGroupFeat->get_angle())
    {
      if (!findString("a_angle", snslctGroupFeatAtts))
	{warnAtt("a_angle", "snslctGroupFeat", a_snslctGroupFeat);}
      else
        check_angle(a_snslctGroupFeat->get_angle());
    }
}

/********************************************************************/

void check_snslctGroupVec(
 snslctGroupVec * a_snslctGroupVec)
{
  if (a_snslctGroupVec->get_gsaLabel())
    {
      if (!findString("a_gsaLabel", snslctGroupVecAtts))
	{warnAtt("a_gsaLabel", "snslctGroupVec", a_snslctGroupVec);}
      else
        check_gsaLabel(a_snslctGroupVec->get_gsaLabel());
    }
  if (a_snslctGroupVec->get_dir())
    {
      if (!findString("dir", snslctGroupVecAtts))
	{warnAtt("dir", "snslctGroupVec", a_snslctGroupVec);}
      else
        check_vector(a_snslctGroupVec->get_dir());
    }
  if (a_snslctGroupVec->get_angle())
    {
      if (!findString("a_angle", snslctGroupVecAtts))
	{warnAtt("a_angle", "snslctGroupVec", a_snslctGroupVec);}
      else
        check_angle(a_snslctGroupVec->get_angle());
    }
}

/********************************************************************/

void check_snslctSensor(
 snslctSensor * a_snslctSensor)
{
  if (isA(a_snslctSensor, snslctSensorTip))
    {
      if (!findString("snslctSensorTip", snslctSensorSubs))
        {warnSub("snslctSensorTip", "snslctSensor", a_snslctSensor);}
      else
        check_snslctSensorTip(dynamic_cast<snslctSensorTip *>(a_snslctSensor));
      return;
    }
  if (isA(a_snslctSensor, snslctSensorList))
    {
      if (!findString("snslctSensorList", snslctSensorSubs))
        {warnSub("snslctSensorList", "snslctSensor", a_snslctSensor);}
      else
        check_snslctSensorList(dynamic_cast<snslctSensorList *>(a_snslctSensor));
      return;
    }
}

/********************************************************************/

void check_snslctSensorList(
 snslctSensorList * a_snslctSensorList)
{
  if (a_snslctSensorList->get_sensorLabel2())
    {
      if (!findString("a_sensorLabel2", snslctSensorListAtts))
	{warnAtt("a_sensorLabel2", "snslctSensorList", a_snslctSensorList);}
      else
        check_sensorLabel2(a_snslctSensorList->get_sensorLabel2());
    }
  if (a_snslctSensorList->get_sensorList())
    {
      if (!findString("a_sensorList", snslctSensorListAtts))
	{warnAtt("a_sensorList", "snslctSensorList", a_snslctSensorList);}
      else
        {
          std::list<sensorLabel2 *> * theList;
          std::list<sensorLabel2 *>::iterator iter;
          theList = a_snslctSensorList->get_sensorList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_sensorLabel2(*iter);
        }
    }
}

/********************************************************************/

void check_snslctSensorTip(
 snslctSensorTip * a_snslctSensorTip)
{
  if (a_snslctSensorTip->get_sensorLabel2())
    {
      if (!findString("a_sensorLabel2", snslctSensorTipAtts))
	{warnAtt("a_sensorLabel2", "snslctSensorTip", a_snslctSensorTip);}
      else
        check_sensorLabel2(a_snslctSensorTip->get_sensorLabel2());
    }
  if (a_snslctSensorTip->get_snslctTipData())
    {
      if (!findString("a_snslctTipData", snslctSensorTipAtts))
	{warnAtt("a_snslctTipData", "snslctSensorTip", a_snslctSensorTip);}
      else
        check_snslctTipData(a_snslctSensorTip->get_snslctTipData());
    }
  if (a_snslctSensorTip->get_snslctData())
    {
      if (!findString("a_snslctData", snslctSensorTipAtts))
	{warnAtt("a_snslctData", "snslctSensorTip", a_snslctSensorTip);}
      else
        check_snslctData(a_snslctSensorTip->get_snslctData());
    }
}

/********************************************************************/

void check_snslctStm(
 snslctStm * a_snslctStm)
{
  if (isA(a_snslctStm, snslctStmSensor))
    {
      if (!findString("snslctStmSensor", snslctStmSubs))
        {warnSub("snslctStmSensor", "snslctStm", a_snslctStm);}
      else
        check_snslctStmSensor(dynamic_cast<snslctStmSensor *>(a_snslctStm));
      return;
    }
  if (isA(a_snslctStm, snslctStmGroup))
    {
      if (!findString("snslctStmGroup", snslctStmSubs))
        {warnSub("snslctStmGroup", "snslctStm", a_snslctStm);}
      else
        check_snslctStmGroup(dynamic_cast<snslctStmGroup *>(a_snslctStm));
      return;
    }
}

/********************************************************************/

void check_snslctStmGroup(
 snslctStmGroup * a_snslctStmGroup)
{
  if (a_snslctStmGroup->get_snslctGroup())
    {
      if (!findString("a_snslctGroup", snslctStmGroupAtts))
	{warnAtt("a_snslctGroup", "snslctStmGroup", a_snslctStmGroup);}
      else
        check_snslctGroup(a_snslctStmGroup->get_snslctGroup());
    }
}

/********************************************************************/

void check_snslctStmSensor(
 snslctStmSensor * a_snslctStmSensor)
{
  if (a_snslctStmSensor->get_snslctSensor())
    {
      if (!findString("a_snslctSensor", snslctStmSensorAtts))
	{warnAtt("a_snslctSensor", "snslctStmSensor", a_snslctStmSensor);}
      else
        check_snslctSensor(a_snslctStmSensor->get_snslctSensor());
    }
}

/********************************************************************/

void check_snslctTipData(
 snslctTipData * a_snslctTipData)
{
  if (isA(a_snslctTipData, stringVal))
    {
      if (!findString("stringVal", snslctTipDataSubs))
        {warnSub("stringVal", "snslctTipData", a_snslctTipData);}
      else
        check_stringVal(dynamic_cast<stringVal *>(a_snslctTipData));
      return;
    }
  if (isA(a_snslctTipData, intVal))
    {
      if (!findString("intVal", snslctTipDataSubs))
        {warnSub("intVal", "snslctTipData", a_snslctTipData);}
      else
        check_intVal(dynamic_cast<intVal *>(a_snslctTipData));
      return;
    }
}

/********************************************************************/

void check_snslctWristAngleAngle(
 snslctWristAngleAngle * a_snslctWristAngleAngle)
{
  if (a_snslctWristAngleAngle->get_anglename())
    {
      if (!findString("anglename", snslctWristAngleAngleAtts))
	{warnAtt("anglename", "snslctWristAngleAngle", a_snslctWristAngleAngle);}
      else
        check_stringVal(a_snslctWristAngleAngle->get_anglename());
    }
  if (a_snslctWristAngleAngle->get_angle())
    {
      if (!findString("a_angle", snslctWristAngleAngleAtts))
	{warnAtt("a_angle", "snslctWristAngleAngle", a_snslctWristAngleAngle);}
      else
        check_angle(a_snslctWristAngleAngle->get_angle());
    }
}

/********************************************************************/

void check_snslctWristAngleFeat(
 snslctWristAngleFeat * a_snslctWristAngleFeat)
{
  if (a_snslctWristAngleFeat->get_anglename())
    {
      if (!findString("anglename", snslctWristAngleFeatAtts))
	{warnAtt("anglename", "snslctWristAngleFeat", a_snslctWristAngleFeat);}
      else
        check_stringVal(a_snslctWristAngleFeat->get_anglename());
    }
  if (a_snslctWristAngleFeat->get_featureLabel())
    {
      if (!findString("a_featureLabel", snslctWristAngleFeatAtts))
	{warnAtt("a_featureLabel", "snslctWristAngleFeat", a_snslctWristAngleFeat);}
      else
        check_featureLabel(a_snslctWristAngleFeat->get_featureLabel());
    }
  if (a_snslctWristAngleFeat->get_angle())
    {
      if (!findString("a_angle", snslctWristAngleFeatAtts))
	{warnAtt("a_angle", "snslctWristAngleFeat", a_snslctWristAngleFeat);}
      else
        check_angle(a_snslctWristAngleFeat->get_angle());
    }
}

/********************************************************************/

void check_snslctWristAngleItem(
 snslctWristAngleItem * a_snslctWristAngleItem)
{
  if (isA(a_snslctWristAngleItem, snslctWristAngleAngle))
    {
      if (!findString("snslctWristAngleAngle", snslctWristAngleItemSubs))
        {warnSub("snslctWristAngleAngle", "snslctWristAngleItem", a_snslctWristAngleItem);}
      else
        check_snslctWristAngleAngle(dynamic_cast<snslctWristAngleAngle *>(a_snslctWristAngleItem));
      return;
    }
  if (isA(a_snslctWristAngleItem, snslctWristAngleFeat))
    {
      if (!findString("snslctWristAngleFeat", snslctWristAngleItemSubs))
        {warnSub("snslctWristAngleFeat", "snslctWristAngleItem", a_snslctWristAngleItem);}
      else
        check_snslctWristAngleFeat(dynamic_cast<snslctWristAngleFeat *>(a_snslctWristAngleItem));
      return;
    }
  if (isA(a_snslctWristAngleItem, snslctWristAngleVec))
    {
      if (!findString("snslctWristAngleVec", snslctWristAngleItemSubs))
        {warnSub("snslctWristAngleVec", "snslctWristAngleItem", a_snslctWristAngleItem);}
      else
        check_snslctWristAngleVec(dynamic_cast<snslctWristAngleVec *>(a_snslctWristAngleItem));
      return;
    }
}

/********************************************************************/

void check_snslctWristAngleVec(
 snslctWristAngleVec * a_snslctWristAngleVec)
{
  if (a_snslctWristAngleVec->get_anglename())
    {
      if (!findString("anglename", snslctWristAngleVecAtts))
	{warnAtt("anglename", "snslctWristAngleVec", a_snslctWristAngleVec);}
      else
        check_stringVal(a_snslctWristAngleVec->get_anglename());
    }
  if (a_snslctWristAngleVec->get_dir())
    {
      if (!findString("dir", snslctWristAngleVecAtts))
	{warnAtt("dir", "snslctWristAngleVec", a_snslctWristAngleVec);}
      else
        check_vector(a_snslctWristAngleVec->get_dir());
    }
  if (a_snslctWristAngleVec->get_angle())
    {
      if (!findString("a_angle", snslctWristAngleVecAtts))
	{warnAtt("a_angle", "snslctWristAngleVec", a_snslctWristAngleVec);}
      else
        check_angle(a_snslctWristAngleVec->get_angle());
    }
}

/********************************************************************/

void check_snslctWristItem(
 snslctWristItem * a_snslctWristItem)
{
  if (a_snslctWristItem->get_swLabel())
    {
      if (!findString("a_swLabel", snslctWristItemAtts))
	{warnAtt("a_swLabel", "snslctWristItem", a_snslctWristItem);}
      else
        check_swLabel(a_snslctWristItem->get_swLabel());
    }
  if (a_snslctWristItem->get_snslctWristAngleList())
    {
      if (!findString("a_snslctWristAngleList", snslctWristItemAtts))
	{warnAtt("a_snslctWristAngleList", "snslctWristItem", a_snslctWristItem);}
      else
        {
          std::list<snslctWristAngleItem *> * theList;
          std::list<snslctWristAngleItem *>::iterator iter;
          theList = a_snslctWristItem->get_snslctWristAngleList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_snslctWristAngleItem(*iter);
        }
    }
}

/********************************************************************/

void check_snsmntMinor(
 snsmntMinor * a_snsmntMinor)
{
  if (a_snsmntMinor->get_xVec())
    {
      if (!findString("xVec", snsmntMinorAtts))
	{warnAtt("xVec", "snsmntMinor", a_snsmntMinor);}
      else
        check_vector(a_snsmntMinor->get_xVec());
    }
  if (a_snsmntMinor->get_zVec())
    {
      if (!findString("zVec", snsmntMinorAtts))
	{warnAtt("zVec", "snsmntMinor", a_snsmntMinor);}
      else
        check_vector(a_snsmntMinor->get_zVec());
    }
  if (a_snsmntMinor->get_distVec())
    {
      if (!findString("distVec", snsmntMinorAtts))
	{warnAtt("distVec", "snsmntMinor", a_snsmntMinor);}
      else
        check_vector(a_snsmntMinor->get_distVec());
    }
}

/********************************************************************/

void check_snsmntStm(
 snsmntStm * a_snsmntStm)
{
  if (a_snsmntStm->get_snsmntMinor())
    {
      if (!findString("a_snsmntMinor", snsmntStmAtts))
	{warnAtt("a_snsmntMinor", "snsmntStm", a_snsmntStm);}
      else
        check_snsmntMinor(a_snsmntStm->get_snsmntMinor());
    }
}

/********************************************************************/

void check_spartConst(
 spartConst * a_spartConst)
{
  if (a_spartConst->get_featureActualList())
    {
      if (!findString("a_featureActualList", spartConstAtts))
	{warnAtt("a_featureActualList", "spartConst", a_spartConst);}
      else
        {
          std::list<faLabel *> * theList;
          std::list<faLabel *>::iterator iter;
          theList = a_spartConst->get_featureActualList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_faLabel(*iter);
        }
    }
}

/********************************************************************/

void check_srLabel(
 srLabel * a_srLabel)
{
  if (a_srLabel->get_labelName())
    {
      if (!findString("a_labelName", srLabelAtts))
	{warnAtt("a_labelName", "srLabel", a_srLabel);}
      else
        check_labelName(a_srLabel->get_labelName());
    }
}

/********************************************************************/

void check_sraLabel(
 sraLabel * a_sraLabel)
{
  if (a_sraLabel->get_labelName())
    {
      if (!findString("a_labelName", sraLabelAtts))
	{warnAtt("a_labelName", "sraLabel", a_sraLabel);}
      else
        check_labelName(a_sraLabel->get_labelName());
    }
}

/********************************************************************/

void check_ssLabel(
 ssLabel * a_ssLabel)
{
  if (a_ssLabel->get_labelName())
    {
      if (!findString("a_labelName", ssLabelAtts))
	{warnAtt("a_labelName", "ssLabel", a_ssLabel);}
      else
        check_labelName(a_ssLabel->get_labelName());
    }
}

/********************************************************************/

void check_stLabel(
 stLabel * a_stLabel)
{
  if (a_stLabel->get_labelName())
    {
      if (!findString("a_labelName", stLabelAtts))
	{warnAtt("a_labelName", "stLabel", a_stLabel);}
      else
        check_labelName(a_stLabel->get_labelName());
    }
}

/********************************************************************/

void check_stackElement(
 stackElement * a_stackElement)
{
  if (isA(a_stackElement, stackElement_ALGOR))
    {
      if (!findString("stackElement_ALGOR", stackElementSubs))
        {warnSub("stackElement_ALGOR", "stackElement", a_stackElement);}
      return;
    }
  if (isA(a_stackElement, stackElement_DME))
    {
      if (!findString("stackElement_DME", stackElementSubs))
        {warnSub("stackElement_DME", "stackElement", a_stackElement);}
      return;
    }
  if (isA(a_stackElement, stackElement_DATSET))
    {
      if (!findString("stackElement_DATSET", stackElementSubs))
        {warnSub("stackElement_DATSET", "stackElement", a_stackElement);}
      return;
    }
  if (isA(a_stackElement, stackElement_REPORT))
    {
      if (!findString("stackElement_REPORT", stackElementSubs))
        {warnSub("stackElement_REPORT", "stackElement", a_stackElement);}
      return;
    }
}

/********************************************************************/

void check_state(
 state * a_state)
{
  if (isA(a_state, state_ON))
    {
      if (!findString("state_ON", stateSubs))
        {warnSub("state_ON", "state", a_state);}
      return;
    }
  if (isA(a_state, state_OFF))
    {
      if (!findString("state_OFF", stateSubs))
        {warnSub("state_OFF", "state", a_state);}
      return;
    }
}

/********************************************************************/

void check_storageSpec(
 storageSpec * a_storageSpec)
{
  if (isA(a_storageSpec, storageSpec_SNS))
    {
      if (!findString("storageSpec_SNS", storageSpecSubs))
        {warnSub("storageSpec_SNS", "storageSpec", a_storageSpec);}
      return;
    }
  if (isA(a_storageSpec, storageSpec_PCS))
    {
      if (!findString("storageSpec_PCS", storageSpecSubs))
        {warnSub("storageSpec_PCS", "storageSpec", a_storageSpec);}
      return;
    }
  if (isA(a_storageSpec, storageSpec_FEATUR))
    {
      if (!findString("storageSpec_FEATUR", storageSpecSubs))
        {warnSub("storageSpec_FEATUR", "storageSpec", a_storageSpec);}
      return;
    }
  if (isA(a_storageSpec, storageSpec_RTAB))
    {
      if (!findString("storageSpec_RTAB", storageSpecSubs))
        {warnSub("storageSpec_RTAB", "storageSpec", a_storageSpec);}
      return;
    }
}

/********************************************************************/

void check_strVar7(
 strVar7 * a_strVar7)
{
  if (a_strVar7->get_width())
    {
      if (!findString("width", strVar7Atts))
	{warnAtt("width", "strVar7", a_strVar7);}
      else
        check_intVal(a_strVar7->get_width());
    }
  if (a_strVar7->get_decimal())
    {
      if (!findString("decimal", strVar7Atts))
	{warnAtt("decimal", "strVar7", a_strVar7);}
      else
        check_intVal(a_strVar7->get_decimal());
    }
}

/********************************************************************/

void check_stringConst(
 stringConst * a_stringConst)
{
  if (a_stringConst->get_string())
    {
      if (!findString("a_string", stringConstAtts))
	{warnAtt("a_string", "stringConst", a_stringConst);}
    }
}

/********************************************************************/

void check_stringFunc(
 stringFunc * a_stringFunc)
{
  if (isA(a_stringFunc, stringFuncChr))
    {
      if (!findString("stringFuncChr", stringFuncSubs))
        {warnSub("stringFuncChr", "stringFunc", a_stringFunc);}
      else
        check_stringFuncChr(dynamic_cast<stringFuncChr *>(a_stringFunc));
      return;
    }
  if (isA(a_stringFunc, stringFuncConcat))
    {
      if (!findString("stringFuncConcat", stringFuncSubs))
        {warnSub("stringFuncConcat", "stringFunc", a_stringFunc);}
      else
        check_stringFuncConcat(dynamic_cast<stringFuncConcat *>(a_stringFunc));
      return;
    }
  if (isA(a_stringFunc, stringFuncElemnt))
    {
      if (!findString("stringFuncElemnt", stringFuncSubs))
        {warnSub("stringFuncElemnt", "stringFunc", a_stringFunc);}
      else
        check_stringFuncElemnt(dynamic_cast<stringFuncElemnt *>(a_stringFunc));
      return;
    }
  if (isA(a_stringFunc, stringFuncLwc))
    {
      if (!findString("stringFuncLwc", stringFuncSubs))
        {warnSub("stringFuncLwc", "stringFunc", a_stringFunc);}
      else
        check_stringFuncLwc(dynamic_cast<stringFuncLwc *>(a_stringFunc));
      return;
    }
  if (isA(a_stringFunc, stringFuncRpt))
    {
      if (!findString("stringFuncRpt", stringFuncSubs))
        {warnSub("stringFuncRpt", "stringFunc", a_stringFunc);}
      else
        check_stringFuncRpt(dynamic_cast<stringFuncRpt *>(a_stringFunc));
      return;
    }
  if (isA(a_stringFunc, stringFuncScfeat))
    {
      if (!findString("stringFuncScfeat", stringFuncSubs))
        {warnSub("stringFuncScfeat", "stringFunc", a_stringFunc);}
      return;
    }
  if (isA(a_stringFunc, stringFuncScsns))
    {
      if (!findString("stringFuncScsns", stringFuncSubs))
        {warnSub("stringFuncScsns", "stringFunc", a_stringFunc);}
      return;
    }
  if (isA(a_stringFunc, stringFuncSdate))
    {
      if (!findString("stringFuncSdate", stringFuncSubs))
        {warnSub("stringFuncSdate", "stringFunc", a_stringFunc);}
      return;
    }
  if (isA(a_stringFunc, stringFuncSdatetime))
    {
      if (!findString("stringFuncSdatetime", stringFuncSubs))
        {warnSub("stringFuncSdatetime", "stringFunc", a_stringFunc);}
      return;
    }
  if (isA(a_stringFunc, stringFuncSelapsetime))
    {
      if (!findString("stringFuncSelapsetime", stringFuncSubs))
        {warnSub("stringFuncSelapsetime", "stringFunc", a_stringFunc);}
      else
        check_stringFuncSelapsetime(dynamic_cast<stringFuncSelapsetime *>(a_stringFunc));
      return;
    }
  if (isA(a_stringFunc, stringFuncSerror))
    {
      if (!findString("stringFuncSerror", stringFuncSubs))
        {warnSub("stringFuncSerror", "stringFunc", a_stringFunc);}
      return;
    }
  if (isA(a_stringFunc, stringFuncSmode))
    {
      if (!findString("stringFuncSmode", stringFuncSubs))
        {warnSub("stringFuncSmode", "stringFunc", a_stringFunc);}
      return;
    }
  if (isA(a_stringFunc, stringFuncStime))
    {
      if (!findString("stringFuncStime", stringFuncSubs))
        {warnSub("stringFuncStime", "stringFunc", a_stringFunc);}
      return;
    }
  if (isA(a_stringFunc, stringFuncStr))
    {
      if (!findString("stringFuncStr", stringFuncSubs))
        {warnSub("stringFuncStr", "stringFunc", a_stringFunc);}
      else
        check_stringFuncStr(dynamic_cast<stringFuncStr *>(a_stringFunc));
      return;
    }
  if (isA(a_stringFunc, stringFuncSubstr))
    {
      if (!findString("stringFuncSubstr", stringFuncSubs))
        {warnSub("stringFuncSubstr", "stringFunc", a_stringFunc);}
      else
        check_stringFuncSubstr(dynamic_cast<stringFuncSubstr *>(a_stringFunc));
      return;
    }
  if (isA(a_stringFunc, stringFuncTrim))
    {
      if (!findString("stringFuncTrim", stringFuncSubs))
        {warnSub("stringFuncTrim", "stringFunc", a_stringFunc);}
      else
        check_stringFuncTrim(dynamic_cast<stringFuncTrim *>(a_stringFunc));
      return;
    }
  if (isA(a_stringFunc, stringFuncUpc))
    {
      if (!findString("stringFuncUpc", stringFuncSubs))
        {warnSub("stringFuncUpc", "stringFunc", a_stringFunc);}
      else
        check_stringFuncUpc(dynamic_cast<stringFuncUpc *>(a_stringFunc));
      return;
    }
}

/********************************************************************/

void check_stringFuncChr(
 stringFuncChr * a_stringFuncChr)
{
  if (a_stringFuncChr->get_index())
    {
      if (!findString("index", stringFuncChrAtts))
	{warnAtt("index", "stringFuncChr", a_stringFuncChr);}
      else
        check_intVal(a_stringFuncChr->get_index());
    }
}

/********************************************************************/

void check_stringFuncConcat(
 stringFuncConcat * a_stringFuncConcat)
{
  if (a_stringFuncConcat->get_str1())
    {
      if (!findString("str1", stringFuncConcatAtts))
	{warnAtt("str1", "stringFuncConcat", a_stringFuncConcat);}
      else
        check_stringVal(a_stringFuncConcat->get_str1());
    }
  if (a_stringFuncConcat->get_moreStrs())
    {
      if (!findString("moreStrs", stringFuncConcatAtts))
	{warnAtt("moreStrs", "stringFuncConcat", a_stringFuncConcat);}
      else
        {
          std::list<stringVal *> * theList;
          std::list<stringVal *>::iterator iter;
          theList = a_stringFuncConcat->get_moreStrs();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_stringVal(*iter);
        }
    }
}

/********************************************************************/

void check_stringFuncElemnt(
 stringFuncElemnt * a_stringFuncElemnt)
{
  if (a_stringFuncElemnt->get_index())
    {
      if (!findString("index", stringFuncElemntAtts))
	{warnAtt("index", "stringFuncElemnt", a_stringFuncElemnt);}
      else
        check_intVal(a_stringFuncElemnt->get_index());
    }
  if (a_stringFuncElemnt->get_delim())
    {
      if (!findString("delim", stringFuncElemntAtts))
	{warnAtt("delim", "stringFuncElemnt", a_stringFuncElemnt);}
      else
        check_stringVal(a_stringFuncElemnt->get_delim());
    }
  if (a_stringFuncElemnt->get_strings())
    {
      if (!findString("strings", stringFuncElemntAtts))
	{warnAtt("strings", "stringFuncElemnt", a_stringFuncElemnt);}
      else
        check_stringVal(a_stringFuncElemnt->get_strings());
    }
}

/********************************************************************/

void check_stringFuncLwc(
 stringFuncLwc * a_stringFuncLwc)
{
  if (a_stringFuncLwc->get_str())
    {
      if (!findString("str", stringFuncLwcAtts))
	{warnAtt("str", "stringFuncLwc", a_stringFuncLwc);}
      else
        check_stringVal(a_stringFuncLwc->get_str());
    }
}

/********************************************************************/

void check_stringFuncRpt(
 stringFuncRpt * a_stringFuncRpt)
{
  if (a_stringFuncRpt->get_str())
    {
      if (!findString("str", stringFuncRptAtts))
	{warnAtt("str", "stringFuncRpt", a_stringFuncRpt);}
      else
        check_stringVal(a_stringFuncRpt->get_str());
    }
  if (a_stringFuncRpt->get_reps())
    {
      if (!findString("reps", stringFuncRptAtts))
	{warnAtt("reps", "stringFuncRpt", a_stringFuncRpt);}
      else
        check_intVal(a_stringFuncRpt->get_reps());
    }
}

/********************************************************************/

void check_stringFuncSelapsetime(
 stringFuncSelapsetime * a_stringFuncSelapsetime)
{
  if (a_stringFuncSelapsetime->get_start())
    {
      if (!findString("start", stringFuncSelapsetimeAtts))
	{warnAtt("start", "stringFuncSelapsetime", a_stringFuncSelapsetime);}
      else
        check_stringVal(a_stringFuncSelapsetime->get_start());
    }
  if (a_stringFuncSelapsetime->get_stop())
    {
      if (!findString("stop", stringFuncSelapsetimeAtts))
	{warnAtt("stop", "stringFuncSelapsetime", a_stringFuncSelapsetime);}
      else
        check_stringVal(a_stringFuncSelapsetime->get_stop());
    }
  if (a_stringFuncSelapsetime->get_longShort())
    {
      if (!findString("a_longShort", stringFuncSelapsetimeAtts))
	{warnAtt("a_longShort", "stringFuncSelapsetime", a_stringFuncSelapsetime);}
      else
        check_longShort(a_stringFuncSelapsetime->get_longShort());
    }
}

/********************************************************************/

void check_stringFuncStr(
 stringFuncStr * a_stringFuncStr)
{
  if (a_stringFuncStr->get_x())
    {
      if (!findString("x", stringFuncStrAtts))
	{warnAtt("x", "stringFuncStr", a_stringFuncStr);}
      else
        check_rentVal(a_stringFuncStr->get_x());
    }
  if (a_stringFuncStr->get_strVar7())
    {
      if (!findString("a_strVar7", stringFuncStrAtts))
	{warnAtt("a_strVar7", "stringFuncStr", a_stringFuncStr);}
      else
        check_strVar7(a_stringFuncStr->get_strVar7());
    }
}

/********************************************************************/

void check_stringFuncSubstr(
 stringFuncSubstr * a_stringFuncSubstr)
{
  if (a_stringFuncSubstr->get_str())
    {
      if (!findString("str", stringFuncSubstrAtts))
	{warnAtt("str", "stringFuncSubstr", a_stringFuncSubstr);}
      else
        check_stringVal(a_stringFuncSubstr->get_str());
    }
  if (a_stringFuncSubstr->get_startIndex())
    {
      if (!findString("startIndex", stringFuncSubstrAtts))
	{warnAtt("startIndex", "stringFuncSubstr", a_stringFuncSubstr);}
      else
        check_intVal(a_stringFuncSubstr->get_startIndex());
    }
  if (a_stringFuncSubstr->get_endIndex())
    {
      if (!findString("endIndex", stringFuncSubstrAtts))
	{warnAtt("endIndex", "stringFuncSubstr", a_stringFuncSubstr);}
      else
        check_intVal(a_stringFuncSubstr->get_endIndex());
    }
}

/********************************************************************/

void check_stringFuncTrim(
 stringFuncTrim * a_stringFuncTrim)
{
  if (a_stringFuncTrim->get_str())
    {
      if (!findString("str", stringFuncTrimAtts))
	{warnAtt("str", "stringFuncTrim", a_stringFuncTrim);}
      else
        check_stringVal(a_stringFuncTrim->get_str());
    }
}

/********************************************************************/

void check_stringFuncUpc(
 stringFuncUpc * a_stringFuncUpc)
{
  if (a_stringFuncUpc->get_str())
    {
      if (!findString("str", stringFuncUpcAtts))
	{warnAtt("str", "stringFuncUpc", a_stringFuncUpc);}
      else
        check_stringVal(a_stringFuncUpc->get_str());
    }
}

/********************************************************************/

void check_stringRel(
 stringRel * a_stringRel)
{
  if (isA(a_stringRel, stringRel_EQ))
    {
      if (!findString("stringRel_EQ", stringRelSubs))
        {warnSub("stringRel_EQ", "stringRel", a_stringRel);}
      else
        check_stringRel_EQ(dynamic_cast<stringRel_EQ *>(a_stringRel));
      return;
    }
  if (isA(a_stringRel, stringRel_NE))
    {
      if (!findString("stringRel_NE", stringRelSubs))
        {warnSub("stringRel_NE", "stringRel", a_stringRel);}
      else
        check_stringRel_NE(dynamic_cast<stringRel_NE *>(a_stringRel));
      return;
    }
  if (isA(a_stringRel, stringRel_LT))
    {
      if (!findString("stringRel_LT", stringRelSubs))
        {warnSub("stringRel_LT", "stringRel", a_stringRel);}
      else
        check_stringRel_LT(dynamic_cast<stringRel_LT *>(a_stringRel));
      return;
    }
  if (isA(a_stringRel, stringRel_LE))
    {
      if (!findString("stringRel_LE", stringRelSubs))
        {warnSub("stringRel_LE", "stringRel", a_stringRel);}
      else
        check_stringRel_LE(dynamic_cast<stringRel_LE *>(a_stringRel));
      return;
    }
  if (isA(a_stringRel, stringRel_GT))
    {
      if (!findString("stringRel_GT", stringRelSubs))
        {warnSub("stringRel_GT", "stringRel", a_stringRel);}
      else
        check_stringRel_GT(dynamic_cast<stringRel_GT *>(a_stringRel));
      return;
    }
  if (isA(a_stringRel, stringRel_GE))
    {
      if (!findString("stringRel_GE", stringRelSubs))
        {warnSub("stringRel_GE", "stringRel", a_stringRel);}
      else
        check_stringRel_GE(dynamic_cast<stringRel_GE *>(a_stringRel));
      return;
    }
}

/********************************************************************/

void check_stringRel_EQ(
 stringRel_EQ * a_stringRel_EQ)
{
  if (a_stringRel_EQ->get_left())
    {
      if (!findString("left", stringRel_EQAtts))
	{warnAtt("left", "stringRel_EQ", a_stringRel_EQ);}
      else
        check_stringVal(a_stringRel_EQ->get_left());
    }
  if (a_stringRel_EQ->get_right())
    {
      if (!findString("right", stringRel_EQAtts))
	{warnAtt("right", "stringRel_EQ", a_stringRel_EQ);}
      else
        check_stringVal(a_stringRel_EQ->get_right());
    }
}

/********************************************************************/

void check_stringRel_GE(
 stringRel_GE * a_stringRel_GE)
{
  if (a_stringRel_GE->get_left())
    {
      if (!findString("left", stringRel_GEAtts))
	{warnAtt("left", "stringRel_GE", a_stringRel_GE);}
      else
        check_stringVal(a_stringRel_GE->get_left());
    }
  if (a_stringRel_GE->get_right())
    {
      if (!findString("right", stringRel_GEAtts))
	{warnAtt("right", "stringRel_GE", a_stringRel_GE);}
      else
        check_stringVal(a_stringRel_GE->get_right());
    }
}

/********************************************************************/

void check_stringRel_GT(
 stringRel_GT * a_stringRel_GT)
{
  if (a_stringRel_GT->get_left())
    {
      if (!findString("left", stringRel_GTAtts))
	{warnAtt("left", "stringRel_GT", a_stringRel_GT);}
      else
        check_stringVal(a_stringRel_GT->get_left());
    }
  if (a_stringRel_GT->get_right())
    {
      if (!findString("right", stringRel_GTAtts))
	{warnAtt("right", "stringRel_GT", a_stringRel_GT);}
      else
        check_stringVal(a_stringRel_GT->get_right());
    }
}

/********************************************************************/

void check_stringRel_LE(
 stringRel_LE * a_stringRel_LE)
{
  if (a_stringRel_LE->get_left())
    {
      if (!findString("left", stringRel_LEAtts))
	{warnAtt("left", "stringRel_LE", a_stringRel_LE);}
      else
        check_stringVal(a_stringRel_LE->get_left());
    }
  if (a_stringRel_LE->get_right())
    {
      if (!findString("right", stringRel_LEAtts))
	{warnAtt("right", "stringRel_LE", a_stringRel_LE);}
      else
        check_stringVal(a_stringRel_LE->get_right());
    }
}

/********************************************************************/

void check_stringRel_LT(
 stringRel_LT * a_stringRel_LT)
{
  if (a_stringRel_LT->get_left())
    {
      if (!findString("left", stringRel_LTAtts))
	{warnAtt("left", "stringRel_LT", a_stringRel_LT);}
      else
        check_stringVal(a_stringRel_LT->get_left());
    }
  if (a_stringRel_LT->get_right())
    {
      if (!findString("right", stringRel_LTAtts))
	{warnAtt("right", "stringRel_LT", a_stringRel_LT);}
      else
        check_stringVal(a_stringRel_LT->get_right());
    }
}

/********************************************************************/

void check_stringRel_NE(
 stringRel_NE * a_stringRel_NE)
{
  if (a_stringRel_NE->get_left())
    {
      if (!findString("left", stringRel_NEAtts))
	{warnAtt("left", "stringRel_NE", a_stringRel_NE);}
      else
        check_stringVal(a_stringRel_NE->get_left());
    }
  if (a_stringRel_NE->get_right())
    {
      if (!findString("right", stringRel_NEAtts))
	{warnAtt("right", "stringRel_NE", a_stringRel_NE);}
      else
        check_stringVal(a_stringRel_NE->get_right());
    }
}

/********************************************************************/

void check_stringVal(
 stringVal * a_stringVal)
{
  if (isA(a_stringVal, stringConst))
    {
      if (!findString("stringConst", stringValSubs))
        {warnSub("stringConst", "stringVal", a_stringVal);}
      else
        check_stringConst(dynamic_cast<stringConst *>(a_stringVal));
      return;
    }
  if (isA(a_stringVal, stringFunc))
    {
      if (!findString("stringFunc", stringValSubs))
        {warnSub("stringFunc", "stringVal", a_stringVal);}
      else
        check_stringFunc(dynamic_cast<stringFunc *>(a_stringVal));
      return;
    }
  if (isA(a_stringVal, stringVar))
    {
      if (!findString("stringVar", stringValSubs))
        {warnSub("stringVar", "stringVal", a_stringVal);}
      else
        check_stringVar(dynamic_cast<stringVar *>(a_stringVal));
      return;
    }
}

/********************************************************************/

void check_stringVar(
 stringVar * a_stringVar)
{
  if (a_stringVar->get_string())
    {
      if (!findString("a_string", stringVarAtts))
	{warnAtt("a_string", "stringVar", a_stringVar);}
    }
  if (a_stringVar->get_arrayIndex())
    {
      if (!findString("a_arrayIndex", stringVarAtts))
	{warnAtt("a_arrayIndex", "stringVar", a_stringVar);}
      else
        check_arrayIndex(a_stringVar->get_arrayIndex());
    }
}

/********************************************************************/

void check_surfPtdataHeadcsListItem(
 surfPtdataHeadcsListItem * a_surfPtdataHeadcsListItem)
{
  if (a_surfPtdataHeadcsListItem->get_pointVecCart())
    {
      if (!findString("a_pointVecCart", surfPtdataHeadcsListItemAtts))
	{warnAtt("a_pointVecCart", "surfPtdataHeadcsListItem", a_surfPtdataHeadcsListItem);}
      else
        check_pointVecCart(a_surfPtdataHeadcsListItem->get_pointVecCart());
    }
  if (a_surfPtdataHeadcsListItem->get_width())
    {
      if (!findString("width", surfPtdataHeadcsListItemAtts))
	{warnAtt("width", "surfPtdataHeadcsListItem", a_surfPtdataHeadcsListItem);}
      else
        check_rentVal(a_surfPtdataHeadcsListItem->get_width());
    }
  if (a_surfPtdataHeadcsListItem->get_height())
    {
      if (!findString("height", surfPtdataHeadcsListItemAtts))
	{warnAtt("height", "surfPtdataHeadcsListItem", a_surfPtdataHeadcsListItem);}
      else
        check_rentVal(a_surfPtdataHeadcsListItem->get_height());
    }
  if (a_surfPtdataHeadcsListItem->get_rot1())
    {
      if (!findString("rot1", surfPtdataHeadcsListItemAtts))
	{warnAtt("rot1", "surfPtdataHeadcsListItem", a_surfPtdataHeadcsListItem);}
      else
        check_rentVal(a_surfPtdataHeadcsListItem->get_rot1());
    }
  if (a_surfPtdataHeadcsListItem->get_rot2())
    {
      if (!findString("rot2", surfPtdataHeadcsListItemAtts))
	{warnAtt("rot2", "surfPtdataHeadcsListItem", a_surfPtdataHeadcsListItem);}
      else
        check_rentVal(a_surfPtdataHeadcsListItem->get_rot2());
    }
  if (a_surfPtdataHeadcsListItem->get_rot3())
    {
      if (!findString("rot3", surfPtdataHeadcsListItemAtts))
	{warnAtt("rot3", "surfPtdataHeadcsListItem", a_surfPtdataHeadcsListItem);}
      else
        check_rentVal(a_surfPtdataHeadcsListItem->get_rot3());
    }
}

/********************************************************************/

void check_surfPtdataListItem(
 surfPtdataListItem * a_surfPtdataListItem)
{
  if (a_surfPtdataListItem->get_pointVecCart())
    {
      if (!findString("a_pointVecCart", surfPtdataListItemAtts))
	{warnAtt("a_pointVecCart", "surfPtdataListItem", a_surfPtdataListItem);}
      else
        check_pointVecCart(a_surfPtdataListItem->get_pointVecCart());
    }
  if (a_surfPtdataListItem->get_width())
    {
      if (!findString("width", surfPtdataListItemAtts))
	{warnAtt("width", "surfPtdataListItem", a_surfPtdataListItem);}
      else
        check_rentVal(a_surfPtdataListItem->get_width());
    }
  if (a_surfPtdataListItem->get_height())
    {
      if (!findString("height", surfPtdataListItemAtts))
	{warnAtt("height", "surfPtdataListItem", a_surfPtdataListItem);}
      else
        check_rentVal(a_surfPtdataListItem->get_height());
    }
}

/********************************************************************/

void check_surfPtdataPcsListItem(
 surfPtdataPcsListItem * a_surfPtdataPcsListItem)
{
  if (a_surfPtdataPcsListItem->get_pointVecCart())
    {
      if (!findString("a_pointVecCart", surfPtdataPcsListItemAtts))
	{warnAtt("a_pointVecCart", "surfPtdataPcsListItem", a_surfPtdataPcsListItem);}
      else
        check_pointVecCart(a_surfPtdataPcsListItem->get_pointVecCart());
    }
  if (a_surfPtdataPcsListItem->get_width())
    {
      if (!findString("width", surfPtdataPcsListItemAtts))
	{warnAtt("width", "surfPtdataPcsListItem", a_surfPtdataPcsListItem);}
      else
        check_rentVal(a_surfPtdataPcsListItem->get_width());
    }
  if (a_surfPtdataPcsListItem->get_height())
    {
      if (!findString("height", surfPtdataPcsListItemAtts))
	{warnAtt("height", "surfPtdataPcsListItem", a_surfPtdataPcsListItem);}
      else
        check_rentVal(a_surfPtdataPcsListItem->get_height());
    }
  if (a_surfPtdataPcsListItem->get_euler())
    {
      if (!findString("a_euler", surfPtdataPcsListItemAtts))
	{warnAtt("a_euler", "surfPtdataPcsListItem", a_surfPtdataPcsListItem);}
      else
        check_euler(a_surfPtdataPcsListItem->get_euler());
    }
}

/********************************************************************/

void check_swLabel(
 swLabel * a_swLabel)
{
  if (a_swLabel->get_labelName())
    {
      if (!findString("a_labelName", swLabelAtts))
	{warnAtt("a_labelName", "swLabel", a_swLabel);}
      else
        check_labelName(a_swLabel->get_labelName());
    }
}

/********************************************************************/

void check_sxLabel(
 sxLabel * a_sxLabel)
{
  if (a_sxLabel->get_labelName())
    {
      if (!findString("a_labelName", sxLabelAtts))
	{warnAtt("a_labelName", "sxLabel", a_sxLabel);}
      else
        check_labelName(a_sxLabel->get_labelName());
    }
}

/********************************************************************/

void check_tLabel(
 tLabel * a_tLabel)
{
  if (a_tLabel->get_labelName())
    {
      if (!findString("a_labelName", tLabelAtts))
	{warnAtt("a_labelName", "tLabel", a_tLabel);}
      else
        check_labelName(a_tLabel->get_labelName());
    }
}

/********************************************************************/

void check_taLabel(
 taLabel * a_taLabel)
{
  if (a_taLabel->get_labelName())
    {
      if (!findString("a_labelName", taLabelAtts))
	{warnAtt("a_labelName", "taLabel", a_taLabel);}
      else
        check_labelName(a_taLabel->get_labelName());
    }
}

/********************************************************************/

void check_tantoConst(
 tantoConst * a_tantoConst)
{
  if (isA(a_tantoConst, tantoConstFa))
    {
      if (!findString("tantoConstFa", tantoConstSubs))
        {warnSub("tantoConstFa", "tantoConst", a_tantoConst);}
      else
        check_tantoConstFa(dynamic_cast<tantoConstFa *>(a_tantoConst));
      return;
    }
  if (isA(a_tantoConst, tantoConstF))
    {
      if (!findString("tantoConstF", tantoConstSubs))
        {warnSub("tantoConstF", "tantoConst", a_tantoConst);}
      else
        check_tantoConstF(dynamic_cast<tantoConstF *>(a_tantoConst));
      return;
    }
}

/********************************************************************/

void check_tantoConstF(
 tantoConstF * a_tantoConstF)
{
  if (a_tantoConstF->get_fLabel())
    {
      if (!findString("a_fLabel", tantoConstFAtts))
	{warnAtt("a_fLabel", "tantoConstF", a_tantoConstF);}
      else
        check_fLabel(a_tantoConstF->get_fLabel());
    }
  if (a_tantoConstF->get_faLabel())
    {
      if (!findString("a_faLabel", tantoConstFAtts))
	{warnAtt("a_faLabel", "tantoConstF", a_tantoConstF);}
      else
        check_faLabel(a_tantoConstF->get_faLabel());
    }
}

/********************************************************************/

void check_tantoConstFa(
 tantoConstFa * a_tantoConstFa)
{
  if (a_tantoConstFa->get_faLabel())
    {
      if (!findString("a_faLabel", tantoConstFaAtts))
	{warnAtt("a_faLabel", "tantoConstFa", a_tantoConstFa);}
      else
        check_faLabel(a_tantoConstFa->get_faLabel());
    }
  if (a_tantoConstFa->get_has_THRU())
    {
      if (!findString("has_THRU", tantoConstFaAtts))
	{warnAtt("has_THRU", "tantoConstFa", a_tantoConstFa);}
    }
  if (a_tantoConstFa->get_featureLabel())
    {
      if (!findString("a_featureLabel", tantoConstFaAtts))
	{warnAtt("a_featureLabel", "tantoConstFa", a_tantoConstFa);}
      else
        check_featureLabel(a_tantoConstFa->get_featureLabel());
    }
}

/********************************************************************/

void check_tantoConstPlane(
 tantoConstPlane * a_tantoConstPlane)
{
  if (isA(a_tantoConstPlane, tantoConstPlaneFa))
    {
      if (!findString("tantoConstPlaneFa", tantoConstPlaneSubs))
        {warnSub("tantoConstPlaneFa", "tantoConstPlane", a_tantoConstPlane);}
      else
        check_tantoConstPlaneFa(dynamic_cast<tantoConstPlaneFa *>(a_tantoConstPlane));
      return;
    }
  if (isA(a_tantoConstPlane, tantoConstPlaneF))
    {
      if (!findString("tantoConstPlaneF", tantoConstPlaneSubs))
        {warnSub("tantoConstPlaneF", "tantoConstPlane", a_tantoConstPlane);}
      else
        check_tantoConstPlaneF(dynamic_cast<tantoConstPlaneF *>(a_tantoConstPlane));
      return;
    }
}

/********************************************************************/

void check_tantoConstPlaneF(
 tantoConstPlaneF * a_tantoConstPlaneF)
{
  if (a_tantoConstPlaneF->get_fLabel())
    {
      if (!findString("a_fLabel", tantoConstPlaneFAtts))
	{warnAtt("a_fLabel", "tantoConstPlaneF", a_tantoConstPlaneF);}
      else
        check_fLabel(a_tantoConstPlaneF->get_fLabel());
    }
  if (a_tantoConstPlaneF->get_faLabel())
    {
      if (!findString("a_faLabel", tantoConstPlaneFAtts))
	{warnAtt("a_faLabel", "tantoConstPlaneF", a_tantoConstPlaneF);}
      else
        check_faLabel(a_tantoConstPlaneF->get_faLabel());
    }
}

/********************************************************************/

void check_tantoConstPlaneFa(
 tantoConstPlaneFa * a_tantoConstPlaneFa)
{
  if (a_tantoConstPlaneFa->get_faLabel())
    {
      if (!findString("a_faLabel", tantoConstPlaneFaAtts))
	{warnAtt("a_faLabel", "tantoConstPlaneFa", a_tantoConstPlaneFa);}
      else
        check_faLabel(a_tantoConstPlaneFa->get_faLabel());
    }
  if (a_tantoConstPlaneFa->get_featureLabel())
    {
      if (!findString("a_featureLabel", tantoConstPlaneFaAtts))
	{warnAtt("a_featureLabel", "tantoConstPlaneFa", a_tantoConstPlaneFa);}
      else
        check_featureLabel(a_tantoConstPlaneFa->get_featureLabel());
    }
}

/********************************************************************/

void check_tecompDatum(
 tecompDatum * a_tecompDatum)
{
  if (a_tecompDatum->get_daLabel())
    {
      if (!findString("a_daLabel", tecompDatumAtts))
	{warnAtt("a_daLabel", "tecompDatum", a_tecompDatum);}
      else
        check_daLabel(a_tecompDatum->get_daLabel());
    }
}

/********************************************************************/

void check_tecompMinor(
 tecompMinor * a_tecompMinor)
{
  if (isA(a_tecompMinor, tecompMinorMach))
    {
      if (!findString("tecompMinorMach", tecompMinorSubs))
        {warnSub("tecompMinorMach", "tecompMinor", a_tecompMinor);}
      else
        check_tecompMinorMach(dynamic_cast<tecompMinorMach *>(a_tecompMinor));
      return;
    }
  if (isA(a_tecompMinor, tecompMinorOnList))
    {
      if (!findString("tecompMinorOnList", tecompMinorSubs))
        {warnSub("tecompMinorOnList", "tecompMinor", a_tecompMinor);}
      else
        check_tecompMinorOnList(dynamic_cast<tecompMinorOnList *>(a_tecompMinor));
      return;
    }
  if (isA(a_tecompMinor, tecompMinorOnAll))
    {
      if (!findString("tecompMinorOnAll", tecompMinorSubs))
        {warnSub("tecompMinorOnAll", "tecompMinor", a_tecompMinor);}
      else
        check_tecompMinorOnAll(dynamic_cast<tecompMinorOnAll *>(a_tecompMinor));
      return;
    }
  if (isA(a_tecompMinor, tecompMinorOff))
    {
      if (!findString("tecompMinorOff", tecompMinorSubs))
        {warnSub("tecompMinorOff", "tecompMinor", a_tecompMinor);}
      return;
    }
}

/********************************************************************/

void check_tecompMinorMach(
 tecompMinorMach * a_tecompMinorMach)
{
  if (a_tecompMinorMach->get_state())
    {
      if (!findString("a_state", tecompMinorMachAtts))
	{warnAtt("a_state", "tecompMinorMach", a_tecompMinorMach);}
      else
        check_state(a_tecompMinorMach->get_state());
    }
}

/********************************************************************/

void check_tecompMinorOnAll(
 tecompMinorOnAll * a_tecompMinorOnAll)
{
  if (a_tecompMinorOnAll->get_tecompVar2())
    {
      if (!findString("a_tecompVar2", tecompMinorOnAllAtts))
	{warnAtt("a_tecompVar2", "tecompMinorOnAll", a_tecompMinorOnAll);}
      else
        check_tecompVar2(a_tecompMinorOnAll->get_tecompVar2());
    }
  if (a_tecompMinorOnAll->get_tmpexp())
    {
      if (!findString("tmpexp", tecompMinorOnAllAtts))
	{warnAtt("tmpexp", "tecompMinorOnAll", a_tecompMinorOnAll);}
      else
        check_rentVal(a_tecompMinorOnAll->get_tmpexp());
    }
  if (a_tecompMinorOnAll->get_tmpexpunc())
    {
      if (!findString("tmpexpunc", tecompMinorOnAllAtts))
	{warnAtt("tmpexpunc", "tecompMinorOnAll", a_tecompMinorOnAll);}
      else
        check_rentVal(a_tecompMinorOnAll->get_tmpexpunc());
    }
}

/********************************************************************/

void check_tecompMinorOnList(
 tecompMinorOnList * a_tecompMinorOnList)
{
  if (a_tecompMinorOnList->get_tecompVar2())
    {
      if (!findString("a_tecompVar2", tecompMinorOnListAtts))
	{warnAtt("a_tecompVar2", "tecompMinorOnList", a_tecompMinorOnList);}
      else
        check_tecompVar2(a_tecompMinorOnList->get_tecompVar2());
    }
  if (a_tecompMinorOnList->get_tmpexp())
    {
      if (!findString("tmpexp", tecompMinorOnListAtts))
	{warnAtt("tmpexp", "tecompMinorOnList", a_tecompMinorOnList);}
      else
        check_rentVal(a_tecompMinorOnList->get_tmpexp());
    }
  if (a_tecompMinorOnList->get_tmpexpunc())
    {
      if (!findString("tmpexpunc", tecompMinorOnListAtts))
	{warnAtt("tmpexpunc", "tecompMinorOnList", a_tecompMinorOnList);}
      else
        check_rentVal(a_tecompMinorOnList->get_tmpexpunc());
    }
  if (a_tecompMinorOnList->get_stringList())
    {
      if (!findString("a_stringList", tecompMinorOnListAtts))
	{warnAtt("a_stringList", "tecompMinorOnList", a_tecompMinorOnList);}
      else
        {
          std::list<stringVal *> * theList;
          std::list<stringVal *>::iterator iter;
          theList = a_tecompMinorOnList->get_stringList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_stringVal(*iter);
        }
    }
}

/********************************************************************/

void check_tecompOffset(
 tecompOffset * a_tecompOffset)
{
  if (a_tecompOffset->get_xoff())
    {
      if (!findString("xoff", tecompOffsetAtts))
	{warnAtt("xoff", "tecompOffset", a_tecompOffset);}
      else
        check_rentVal(a_tecompOffset->get_xoff());
    }
  if (a_tecompOffset->get_yoff())
    {
      if (!findString("yoff", tecompOffsetAtts))
	{warnAtt("yoff", "tecompOffset", a_tecompOffset);}
      else
        check_rentVal(a_tecompOffset->get_yoff());
    }
  if (a_tecompOffset->get_zoff())
    {
      if (!findString("zoff", tecompOffsetAtts))
	{warnAtt("zoff", "tecompOffset", a_tecompOffset);}
      else
        check_rentVal(a_tecompOffset->get_zoff());
    }
}

/********************************************************************/

void check_tecompStm(
 tecompStm * a_tecompStm)
{
  if (a_tecompStm->get_tecompMinor())
    {
      if (!findString("a_tecompMinor", tecompStmAtts))
	{warnAtt("a_tecompMinor", "tecompStm", a_tecompStm);}
      else
        check_tecompMinor(a_tecompStm->get_tecompMinor());
    }
}

/********************************************************************/

void check_tecompVar2(
 tecompVar2 * a_tecompVar2)
{
  if (isA(a_tecompVar2, tecompDatum))
    {
      if (!findString("tecompDatum", tecompVar2Subs))
        {warnSub("tecompDatum", "tecompVar2", a_tecompVar2);}
      else
        check_tecompDatum(dynamic_cast<tecompDatum *>(a_tecompVar2));
      return;
    }
  if (isA(a_tecompVar2, tecompOffset))
    {
      if (!findString("tecompOffset", tecompVar2Subs))
        {warnSub("tecompOffset", "tecompVar2", a_tecompVar2);}
      else
        check_tecompOffset(dynamic_cast<tecompOffset *>(a_tecompVar2));
      return;
    }
}

/********************************************************************/

void check_tempUnit(
 tempUnit * a_tempUnit)
{
  if (isA(a_tempUnit, tempUnit_TEMPF))
    {
      if (!findString("tempUnit_TEMPF", tempUnitSubs))
        {warnSub("tempUnit_TEMPF", "tempUnit", a_tempUnit);}
      return;
    }
  if (isA(a_tempUnit, tempUnit_TEMPC))
    {
      if (!findString("tempUnit_TEMPC", tempUnitSubs))
        {warnSub("tempUnit_TEMPC", "tempUnit", a_tempUnit);}
      return;
    }
}

/********************************************************************/

void check_textMan(
 textMan * a_textMan)
{
  if (a_textMan->get_text())
    {
      if (!findString("text", textManAtts))
	{warnAtt("text", "textMan", a_textMan);}
      else
        check_stringVal(a_textMan->get_text());
    }
}

/********************************************************************/

void check_textMinor(
 textMinor * a_textMinor)
{
  if (isA(a_textMinor, textMan))
    {
      if (!findString("textMan", textMinorSubs))
        {warnSub("textMan", "textMinor", a_textMinor);}
      else
        check_textMan(dynamic_cast<textMan *>(a_textMinor));
      return;
    }
  if (isA(a_textMinor, textOper))
    {
      if (!findString("textOper", textMinorSubs))
        {warnSub("textOper", "textMinor", a_textMinor);}
      else
        check_textOper(dynamic_cast<textOper *>(a_textMinor));
      return;
    }
  if (isA(a_textMinor, textOutfil))
    {
      if (!findString("textOutfil", textMinorSubs))
        {warnSub("textOutfil", "textMinor", a_textMinor);}
      else
        check_textOutfil(dynamic_cast<textOutfil *>(a_textMinor));
      return;
    }
  if (isA(a_textMinor, textQuery))
    {
      if (!findString("textQuery", textMinorSubs))
        {warnSub("textQuery", "textMinor", a_textMinor);}
      else
        check_textQuery(dynamic_cast<textQuery *>(a_textMinor));
      return;
    }
}

/********************************************************************/

void check_textOper(
 textOper * a_textOper)
{
  if (a_textOper->get_text())
    {
      if (!findString("text", textOperAtts))
	{warnAtt("text", "textOper", a_textOper);}
      else
        check_stringVal(a_textOper->get_text());
    }
}

/********************************************************************/

void check_textOutfil(
 textOutfil * a_textOutfil)
{
  if (a_textOutfil->get_text())
    {
      if (!findString("text", textOutfilAtts))
	{warnAtt("text", "textOutfil", a_textOutfil);}
      else
        check_stringVal(a_textOutfil->get_text());
    }
}

/********************************************************************/

void check_textQuery(
 textQuery * a_textQuery)
{
  if (a_textQuery->get_textQueryFormat())
    {
      if (!findString("a_textQueryFormat", textQueryAtts))
	{warnAtt("a_textQueryFormat", "textQuery", a_textQuery);}
      else
        check_textQueryFormat(a_textQuery->get_textQueryFormat());
    }
  if (a_textQuery->get_text())
    {
      if (!findString("text", textQueryAtts))
	{warnAtt("text", "textQuery", a_textQuery);}
      else
        check_stringVal(a_textQuery->get_text());
    }
}

/********************************************************************/

void check_textQueryFormat(
 textQueryFormat * a_textQueryFormat)
{
  if (a_textQueryFormat->get_labelName())
    {
      if (!findString("a_labelName", textQueryFormatAtts))
	{warnAtt("a_labelName", "textQueryFormat", a_textQueryFormat);}
      else
        check_labelName(a_textQueryFormat->get_labelName());
    }
  if (a_textQueryFormat->get_length())
    {
      if (!findString("length", textQueryFormatAtts))
	{warnAtt("length", "textQueryFormat", a_textQueryFormat);}
      else
        check_intVal(a_textQueryFormat->get_length());
    }
  if (a_textQueryFormat->get_textType())
    {
      if (!findString("a_textType", textQueryFormatAtts))
	{warnAtt("a_textType", "textQueryFormat", a_textQueryFormat);}
      else
        check_textType(a_textQueryFormat->get_textType());
    }
  if (a_textQueryFormat->get_leftRight())
    {
      if (!findString("a_leftRight", textQueryFormatAtts))
	{warnAtt("a_leftRight", "textQueryFormat", a_textQueryFormat);}
      else
        check_leftRight(a_textQueryFormat->get_leftRight());
    }
}

/********************************************************************/

void check_textStm(
 textStm * a_textStm)
{
  if (a_textStm->get_textMinor())
    {
      if (!findString("a_textMinor", textStmAtts))
	{warnAtt("a_textMinor", "textStm", a_textStm);}
      else
        check_textMinor(a_textStm->get_textMinor());
    }
}

/********************************************************************/

void check_textType(
 textType * a_textType)
{
  if (isA(a_textType, textType_ALPHA))
    {
      if (!findString("textType_ALPHA", textTypeSubs))
        {warnSub("textType_ALPHA", "textType", a_textType);}
      return;
    }
  if (isA(a_textType, textType_NUMERIC))
    {
      if (!findString("textType_NUMERIC", textTypeSubs))
        {warnSub("textType_NUMERIC", "textType", a_textType);}
      return;
    }
  if (isA(a_textType, textType_PRNTCHAR))
    {
      if (!findString("textType_PRNTCHAR", textTypeSubs))
        {warnSub("textType_PRNTCHAR", "textType", a_textType);}
      return;
    }
}

/********************************************************************/

void check_thLabel(
 thLabel * a_thLabel)
{
  if (a_thLabel->get_labelName())
    {
      if (!findString("a_labelName", thLabelAtts))
	{warnAtt("a_labelName", "thLabel", a_thLabel);}
      else
        check_labelName(a_thLabel->get_labelName());
    }
}

/********************************************************************/

void check_thldefPocket(
 thldefPocket * a_thldefPocket)
{
  if (isA(a_thldefPocket, thldefPocket_sLabel))
    {
      if (!findString("thldefPocket_sLabel", thldefPocketSubs))
        {warnSub("thldefPocket_sLabel", "thldefPocket", a_thldefPocket);}
      else
        check_thldefPocket_sLabel(dynamic_cast<thldefPocket_sLabel *>(a_thldefPocket));
      return;
    }
  if (isA(a_thldefPocket, thldefPocket_ssLabel))
    {
      if (!findString("thldefPocket_ssLabel", thldefPocketSubs))
        {warnSub("thldefPocket_ssLabel", "thldefPocket", a_thldefPocket);}
      else
        check_thldefPocket_ssLabel(dynamic_cast<thldefPocket_ssLabel *>(a_thldefPocket));
      return;
    }
  if (isA(a_thldefPocket, thldefPocket_sgsLabel))
    {
      if (!findString("thldefPocket_sgsLabel", thldefPocketSubs))
        {warnSub("thldefPocket_sgsLabel", "thldefPocket", a_thldefPocket);}
      else
        check_thldefPocket_sgsLabel(dynamic_cast<thldefPocket_sgsLabel *>(a_thldefPocket));
      return;
    }
  if (isA(a_thldefPocket, thldefPocket_sgLabel))
    {
      if (!findString("thldefPocket_sgLabel", thldefPocketSubs))
        {warnSub("thldefPocket_sgLabel", "thldefPocket", a_thldefPocket);}
      else
        check_thldefPocket_sgLabel(dynamic_cast<thldefPocket_sgLabel *>(a_thldefPocket));
      return;
    }
  if (isA(a_thldefPocket, thldefPocket_swLabel))
    {
      if (!findString("thldefPocket_swLabel", thldefPocketSubs))
        {warnSub("thldefPocket_swLabel", "thldefPocket", a_thldefPocket);}
      else
        check_thldefPocket_swLabel(dynamic_cast<thldefPocket_swLabel *>(a_thldefPocket));
      return;
    }
  if (isA(a_thldefPocket, thldefPocket_sxLabel))
    {
      if (!findString("thldefPocket_sxLabel", thldefPocketSubs))
        {warnSub("thldefPocket_sxLabel", "thldefPocket", a_thldefPocket);}
      else
        check_thldefPocket_sxLabel(dynamic_cast<thldefPocket_sxLabel *>(a_thldefPocket));
      return;
    }
  if (isA(a_thldefPocket, thldefPocket_rmLabel))
    {
      if (!findString("thldefPocket_rmLabel", thldefPocketSubs))
        {warnSub("thldefPocket_rmLabel", "thldefPocket", a_thldefPocket);}
      else
        check_thldefPocket_rmLabel(dynamic_cast<thldefPocket_rmLabel *>(a_thldefPocket));
      return;
    }
}

/********************************************************************/

void check_thldefPocket_rmLabel(
 thldefPocket_rmLabel * a_thldefPocket_rmLabel)
{
  if (a_thldefPocket_rmLabel->get_rmLabel())
    {
      if (!findString("a_rmLabel", thldefPocket_rmLabelAtts))
	{warnAtt("a_rmLabel", "thldefPocket_rmLabel", a_thldefPocket_rmLabel);}
      else
        check_rmLabel(a_thldefPocket_rmLabel->get_rmLabel());
    }
  if (a_thldefPocket_rmLabel->get_pocket())
    {
      if (!findString("pocket", thldefPocket_rmLabelAtts))
	{warnAtt("pocket", "thldefPocket_rmLabel", a_thldefPocket_rmLabel);}
      else
        check_intVal(a_thldefPocket_rmLabel->get_pocket());
    }
}

/********************************************************************/

void check_thldefPocket_sLabel(
 thldefPocket_sLabel * a_thldefPocket_sLabel)
{
  if (a_thldefPocket_sLabel->get_sLabel())
    {
      if (!findString("a_sLabel", thldefPocket_sLabelAtts))
	{warnAtt("a_sLabel", "thldefPocket_sLabel", a_thldefPocket_sLabel);}
      else
        check_sLabel(a_thldefPocket_sLabel->get_sLabel());
    }
  if (a_thldefPocket_sLabel->get_pocket())
    {
      if (!findString("pocket", thldefPocket_sLabelAtts))
	{warnAtt("pocket", "thldefPocket_sLabel", a_thldefPocket_sLabel);}
      else
        check_intVal(a_thldefPocket_sLabel->get_pocket());
    }
}

/********************************************************************/

void check_thldefPocket_sgLabel(
 thldefPocket_sgLabel * a_thldefPocket_sgLabel)
{
  if (a_thldefPocket_sgLabel->get_sgLabel())
    {
      if (!findString("a_sgLabel", thldefPocket_sgLabelAtts))
	{warnAtt("a_sgLabel", "thldefPocket_sgLabel", a_thldefPocket_sgLabel);}
      else
        check_sgLabel(a_thldefPocket_sgLabel->get_sgLabel());
    }
  if (a_thldefPocket_sgLabel->get_pocket())
    {
      if (!findString("pocket", thldefPocket_sgLabelAtts))
	{warnAtt("pocket", "thldefPocket_sgLabel", a_thldefPocket_sgLabel);}
      else
        check_intVal(a_thldefPocket_sgLabel->get_pocket());
    }
}

/********************************************************************/

void check_thldefPocket_sgsLabel(
 thldefPocket_sgsLabel * a_thldefPocket_sgsLabel)
{
  if (a_thldefPocket_sgsLabel->get_sgsLabel())
    {
      if (!findString("a_sgsLabel", thldefPocket_sgsLabelAtts))
	{warnAtt("a_sgsLabel", "thldefPocket_sgsLabel", a_thldefPocket_sgsLabel);}
      else
        check_sgsLabel(a_thldefPocket_sgsLabel->get_sgsLabel());
    }
  if (a_thldefPocket_sgsLabel->get_pocket())
    {
      if (!findString("pocket", thldefPocket_sgsLabelAtts))
	{warnAtt("pocket", "thldefPocket_sgsLabel", a_thldefPocket_sgsLabel);}
      else
        check_intVal(a_thldefPocket_sgsLabel->get_pocket());
    }
}

/********************************************************************/

void check_thldefPocket_ssLabel(
 thldefPocket_ssLabel * a_thldefPocket_ssLabel)
{
  if (a_thldefPocket_ssLabel->get_ssLabel())
    {
      if (!findString("a_ssLabel", thldefPocket_ssLabelAtts))
	{warnAtt("a_ssLabel", "thldefPocket_ssLabel", a_thldefPocket_ssLabel);}
      else
        check_ssLabel(a_thldefPocket_ssLabel->get_ssLabel());
    }
  if (a_thldefPocket_ssLabel->get_pocket())
    {
      if (!findString("pocket", thldefPocket_ssLabelAtts))
	{warnAtt("pocket", "thldefPocket_ssLabel", a_thldefPocket_ssLabel);}
      else
        check_intVal(a_thldefPocket_ssLabel->get_pocket());
    }
}

/********************************************************************/

void check_thldefPocket_swLabel(
 thldefPocket_swLabel * a_thldefPocket_swLabel)
{
  if (a_thldefPocket_swLabel->get_swLabel())
    {
      if (!findString("a_swLabel", thldefPocket_swLabelAtts))
	{warnAtt("a_swLabel", "thldefPocket_swLabel", a_thldefPocket_swLabel);}
      else
        check_swLabel(a_thldefPocket_swLabel->get_swLabel());
    }
  if (a_thldefPocket_swLabel->get_pocket())
    {
      if (!findString("pocket", thldefPocket_swLabelAtts))
	{warnAtt("pocket", "thldefPocket_swLabel", a_thldefPocket_swLabel);}
      else
        check_intVal(a_thldefPocket_swLabel->get_pocket());
    }
}

/********************************************************************/

void check_thldefPocket_sxLabel(
 thldefPocket_sxLabel * a_thldefPocket_sxLabel)
{
  if (a_thldefPocket_sxLabel->get_sxLabel())
    {
      if (!findString("a_sxLabel", thldefPocket_sxLabelAtts))
	{warnAtt("a_sxLabel", "thldefPocket_sxLabel", a_thldefPocket_sxLabel);}
      else
        check_sxLabel(a_thldefPocket_sxLabel->get_sxLabel());
    }
  if (a_thldefPocket_sxLabel->get_pocket())
    {
      if (!findString("pocket", thldefPocket_sxLabelAtts))
	{warnAtt("pocket", "thldefPocket_sxLabel", a_thldefPocket_sxLabel);}
      else
        check_intVal(a_thldefPocket_sxLabel->get_pocket());
    }
}

/********************************************************************/

void check_thldefStm(
 thldefStm * a_thldefStm)
{
  if (a_thldefStm->get_thLabel())
    {
      if (!findString("a_thLabel", thldefStmAtts))
	{warnAtt("a_thLabel", "thldefStm", a_thldefStm);}
      else
        check_thLabel(a_thldefStm->get_thLabel());
    }
  if (a_thldefStm->get_thldefPocketList())
    {
      if (!findString("a_thldefPocketList", thldefStmAtts))
	{warnAtt("a_thldefPocketList", "thldefStm", a_thldefStm);}
      else
        {
          std::list<thldefPocket *> * theList;
          std::list<thldefPocket *>::iterator iter;
          theList = a_thldefStm->get_thldefPocketList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_thldefPocket(*iter);
        }
    }
}

/********************************************************************/

void check_tier(
 tier * a_tier)
{
  if (isA(a_tier, tier_UPTIER))
    {
      if (!findString("tier_UPTIER", tierSubs))
        {warnSub("tier_UPTIER", "tier", a_tier);}
      return;
    }
  if (isA(a_tier, tier_LOTIER))
    {
      if (!findString("tier_LOTIER", tierSubs))
        {warnSub("tier_LOTIER", "tier", a_tier);}
      return;
    }
}

/********************************************************************/

void check_tlLabel(
 tlLabel * a_tlLabel)
{
  if (a_tlLabel->get_labelName())
    {
      if (!findString("a_labelName", tlLabelAtts))
	{warnAtt("a_labelName", "tlLabel", a_tlLabel);}
      else
        check_labelName(a_tlLabel->get_labelName());
    }
}

/********************************************************************/

void check_tolAnglStm(
 tolAnglStm * a_tolAnglStm)
{
  if (a_tolAnglStm->get_tLabel())
    {
      if (!findString("a_tLabel", tolAnglStmAtts))
	{warnAtt("a_tLabel", "tolAnglStm", a_tolAnglStm);}
      else
        check_tLabel(a_tolAnglStm->get_tLabel());
    }
  if (a_tolAnglStm->get_lotol())
    {
      if (!findString("lotol", tolAnglStmAtts))
	{warnAtt("lotol", "tolAnglStm", a_tolAnglStm);}
      else
        check_angle(a_tolAnglStm->get_lotol());
    }
  if (a_tolAnglStm->get_uptol())
    {
      if (!findString("uptol", tolAnglStmAtts))
	{warnAtt("uptol", "tolAnglStm", a_tolAnglStm);}
      else
        check_angle(a_tolAnglStm->get_uptol());
    }
}

/********************************************************************/

void check_tolAnglbStm(
 tolAnglbStm * a_tolAnglbStm)
{
  if (a_tolAnglbStm->get_tLabel())
    {
      if (!findString("a_tLabel", tolAnglbStmAtts))
	{warnAtt("a_tLabel", "tolAnglbStm", a_tolAnglbStm);}
      else
        check_tLabel(a_tolAnglbStm->get_tLabel());
    }
  if (a_tolAnglbStm->get_ang())
    {
      if (!findString("ang", tolAnglbStmAtts))
	{warnAtt("ang", "tolAnglbStm", a_tolAnglbStm);}
      else
        check_angle(a_tolAnglbStm->get_ang());
    }
  if (a_tolAnglbStm->get_lotol())
    {
      if (!findString("lotol", tolAnglbStmAtts))
	{warnAtt("lotol", "tolAnglbStm", a_tolAnglbStm);}
      else
        check_angle(a_tolAnglbStm->get_lotol());
    }
  if (a_tolAnglbStm->get_uptol())
    {
      if (!findString("uptol", tolAnglbStmAtts))
	{warnAtt("uptol", "tolAnglbStm", a_tolAnglbStm);}
      else
        check_angle(a_tolAnglbStm->get_uptol());
    }
  if (a_tolAnglbStm->get_tolZoneDir2())
    {
      if (!findString("a_tolZoneDir2", tolAnglbStmAtts))
	{warnAtt("a_tolZoneDir2", "tolAnglbStm", a_tolAnglbStm);}
      else
        check_tolZoneDir2(a_tolAnglbStm->get_tolZoneDir2());
    }
}

/********************************************************************/

void check_tolAnglrStm(
 tolAnglrStm * a_tolAnglrStm)
{
  if (a_tolAnglrStm->get_tLabel())
    {
      if (!findString("a_tLabel", tolAnglrStmAtts))
	{warnAtt("a_tLabel", "tolAnglrStm", a_tolAnglrStm);}
      else
        check_tLabel(a_tolAnglrStm->get_tLabel());
    }
  if (a_tolAnglrStm->get_angle())
    {
      if (!findString("a_angle", tolAnglrStmAtts))
	{warnAtt("a_angle", "tolAnglrStm", a_tolAnglrStm);}
      else
        check_angle(a_tolAnglrStm->get_angle());
    }
  if (a_tolAnglrStm->get_tolAppData())
    {
      if (!findString("a_tolAppData", tolAnglrStmAtts))
	{warnAtt("a_tolAppData", "tolAnglrStm", a_tolAnglrStm);}
      else
        check_tolAppData(a_tolAnglrStm->get_tolAppData());
    }
}

/********************************************************************/

void check_tolAnglwrtStm(
 tolAnglwrtStm * a_tolAnglwrtStm)
{
  if (a_tolAnglwrtStm->get_tLabel())
    {
      if (!findString("a_tLabel", tolAnglwrtStmAtts))
	{warnAtt("a_tLabel", "tolAnglwrtStm", a_tolAnglwrtStm);}
      else
        check_tLabel(a_tolAnglwrtStm->get_tLabel());
    }
  if (a_tolAnglwrtStm->get_ang())
    {
      if (!findString("ang", tolAnglwrtStmAtts))
	{warnAtt("ang", "tolAnglwrtStm", a_tolAnglwrtStm);}
      else
        check_angle(a_tolAnglwrtStm->get_ang());
    }
  if (a_tolAnglwrtStm->get_lotol())
    {
      if (!findString("lotol", tolAnglwrtStmAtts))
	{warnAtt("lotol", "tolAnglwrtStm", a_tolAnglwrtStm);}
      else
        check_angle(a_tolAnglwrtStm->get_lotol());
    }
  if (a_tolAnglwrtStm->get_uptol())
    {
      if (!findString("uptol", tolAnglwrtStmAtts))
	{warnAtt("uptol", "tolAnglwrtStm", a_tolAnglwrtStm);}
      else
        check_angle(a_tolAnglwrtStm->get_uptol());
    }
  if (a_tolAnglwrtStm->get_tolFeature())
    {
      if (!findString("a_tolFeature", tolAnglwrtStmAtts))
	{warnAtt("a_tolFeature", "tolAnglwrtStm", a_tolAnglwrtStm);}
      else
        check_tolFeature(a_tolAnglwrtStm->get_tolFeature());
    }
  if (a_tolAnglwrtStm->get_tolZoneDir2())
    {
      if (!findString("a_tolZoneDir2", tolAnglwrtStmAtts))
	{warnAtt("a_tolZoneDir2", "tolAnglwrtStm", a_tolAnglwrtStm);}
      else
        check_tolZoneDir2(a_tolAnglwrtStm->get_tolZoneDir2());
    }
}

/********************************************************************/

void check_tolAppData(
 tolAppData * a_tolAppData)
{
  if (a_tolAppData->get_tolzon())
    {
      if (!findString("tolzon", tolAppDataAtts))
	{warnAtt("tolzon", "tolAppData", a_tolAppData);}
      else
        check_rentVal(a_tolAppData->get_tolzon());
    }
  if (a_tolAppData->get_tolMaxMatCond())
    {
      if (!findString("a_tolMaxMatCond", tolAppDataAtts))
	{warnAtt("a_tolMaxMatCond", "tolAppData", a_tolAppData);}
      else
        check_tolMaxMatCond(a_tolAppData->get_tolMaxMatCond());
    }
  if (a_tolAppData->get_ref1())
    {
      if (!findString("ref1", tolAppDataAtts))
	{warnAtt("ref1", "tolAppData", a_tolAppData);}
      else
        check_tolFeatMaxMat(a_tolAppData->get_ref1());
    }
  if (a_tolAppData->get_ref2())
    {
      if (!findString("ref2", tolAppDataAtts))
	{warnAtt("ref2", "tolAppData", a_tolAppData);}
      else
        check_tolFeatMaxMat(a_tolAppData->get_ref2());
    }
  if (a_tolAppData->get_tolZoneType())
    {
      if (!findString("a_tolZoneType", tolAppDataAtts))
	{warnAtt("a_tolZoneType", "tolAppData", a_tolAppData);}
      else
        check_tolZoneType(a_tolAppData->get_tolZoneType());
    }
  if (a_tolAppData->get_tolZoneDir())
    {
      if (!findString("a_tolZoneDir", tolAppDataAtts))
	{warnAtt("a_tolZoneDir", "tolAppData", a_tolAppData);}
      else
        check_tolZoneDir(a_tolAppData->get_tolZoneDir());
    }
}

/********************************************************************/

void check_tolCirltyStm(
 tolCirltyStm * a_tolCirltyStm)
{
  if (a_tolCirltyStm->get_tLabel())
    {
      if (!findString("a_tLabel", tolCirltyStmAtts))
	{warnAtt("a_tLabel", "tolCirltyStm", a_tolCirltyStm);}
      else
        check_tLabel(a_tolCirltyStm->get_tLabel());
    }
  if (a_tolCirltyStm->get_tolzon())
    {
      if (!findString("tolzon", tolCirltyStmAtts))
	{warnAtt("tolzon", "tolCirltyStm", a_tolCirltyStm);}
      else
        check_rentVal(a_tolCirltyStm->get_tolzon());
    }
}

/********************************************************************/

void check_tolCompos1(
 tolCompos1 * a_tolCompos1)
{
  if (a_tolCompos1->get_tolzon1())
    {
      if (!findString("tolzon1", tolCompos1Atts))
	{warnAtt("tolzon1", "tolCompos1", a_tolCompos1);}
      else
        check_rentVal(a_tolCompos1->get_tolzon1());
    }
  if (a_tolCompos1->get_tolMatCond())
    {
      if (!findString("a_tolMatCond", tolCompos1Atts))
	{warnAtt("a_tolMatCond", "tolCompos1", a_tolCompos1);}
      else
        check_tolMatCond(a_tolCompos1->get_tolMatCond());
    }
  if (a_tolCompos1->get_tfm1())
    {
      if (!findString("tfm1", tolCompos1Atts))
	{warnAtt("tfm1", "tolCompos1", a_tolCompos1);}
      else
        check_tolFeatureMat(a_tolCompos1->get_tfm1());
    }
  if (a_tolCompos1->get_tfm2())
    {
      if (!findString("tfm2", tolCompos1Atts))
	{warnAtt("tfm2", "tolCompos1", a_tolCompos1);}
      else
        check_tolFeatureMat(a_tolCompos1->get_tfm2());
    }
  if (a_tolCompos1->get_tfm3())
    {
      if (!findString("tfm3", tolCompos1Atts))
	{warnAtt("tfm3", "tolCompos1", a_tolCompos1);}
      else
        check_tolFeatureMat(a_tolCompos1->get_tfm3());
    }
}

/********************************************************************/

void check_tolCompos2(
 tolCompos2 * a_tolCompos2)
{
  if (a_tolCompos2->get_tolzon2())
    {
      if (!findString("tolzon2", tolCompos2Atts))
	{warnAtt("tolzon2", "tolCompos2", a_tolCompos2);}
      else
        check_rentVal(a_tolCompos2->get_tolzon2());
    }
  if (a_tolCompos2->get_tolMatCond())
    {
      if (!findString("a_tolMatCond", tolCompos2Atts))
	{warnAtt("a_tolMatCond", "tolCompos2", a_tolCompos2);}
      else
        check_tolMatCond(a_tolCompos2->get_tolMatCond());
    }
  if (a_tolCompos2->get_tfm1())
    {
      if (!findString("tfm1", tolCompos2Atts))
	{warnAtt("tfm1", "tolCompos2", a_tolCompos2);}
      else
        check_tolFeatureMat(a_tolCompos2->get_tfm1());
    }
  if (a_tolCompos2->get_tfm2())
    {
      if (!findString("tfm2", tolCompos2Atts))
	{warnAtt("tfm2", "tolCompos2", a_tolCompos2);}
      else
        check_tolFeatureMat(a_tolCompos2->get_tfm2());
    }
  if (a_tolCompos2->get_tfm3())
    {
      if (!findString("tfm3", tolCompos2Atts))
	{warnAtt("tfm3", "tolCompos2", a_tolCompos2);}
      else
        check_tolFeatureMat(a_tolCompos2->get_tfm3());
    }
}

/********************************************************************/

void check_tolComposStm(
 tolComposStm * a_tolComposStm)
{
  if (a_tolComposStm->get_tLabel())
    {
      if (!findString("a_tLabel", tolComposStmAtts))
	{warnAtt("a_tLabel", "tolComposStm", a_tolComposStm);}
      else
        check_tLabel(a_tolComposStm->get_tLabel());
    }
  if (a_tolComposStm->get_tolCompos1())
    {
      if (!findString("a_tolCompos1", tolComposStmAtts))
	{warnAtt("a_tolCompos1", "tolComposStm", a_tolComposStm);}
      else
        check_tolCompos1(a_tolComposStm->get_tolCompos1());
    }
  if (a_tolComposStm->get_tolCompos2())
    {
      if (!findString("a_tolCompos2", tolComposStmAtts))
	{warnAtt("a_tolCompos2", "tolComposStm", a_tolComposStm);}
      else
        check_tolCompos2(a_tolComposStm->get_tolCompos2());
    }
}

/********************************************************************/

void check_tolConcenStm(
 tolConcenStm * a_tolConcenStm)
{
  if (a_tolConcenStm->get_tLabel())
    {
      if (!findString("a_tLabel", tolConcenStmAtts))
	{warnAtt("a_tLabel", "tolConcenStm", a_tolConcenStm);}
      else
        check_tLabel(a_tolConcenStm->get_tLabel());
    }
  if (a_tolConcenStm->get_tolzon())
    {
      if (!findString("tolzon", tolConcenStmAtts))
	{warnAtt("tolzon", "tolConcenStm", a_tolConcenStm);}
      else
        check_rentVal(a_tolConcenStm->get_tolzon());
    }
  if (a_tolConcenStm->get_tolFeature())
    {
      if (!findString("a_tolFeature", tolConcenStmAtts))
	{warnAtt("a_tolFeature", "tolConcenStm", a_tolConcenStm);}
      else
        check_tolFeature(a_tolConcenStm->get_tolFeature());
    }
}

/********************************************************************/

void check_tolCortolAngle(
 tolCortolAngle * a_tolCortolAngle)
{
  if (a_tolCortolAngle->get_lotol())
    {
      if (!findString("lotol", tolCortolAngleAtts))
	{warnAtt("lotol", "tolCortolAngle", a_tolCortolAngle);}
      else
        check_rentVal(a_tolCortolAngle->get_lotol());
    }
  if (a_tolCortolAngle->get_uptol())
    {
      if (!findString("uptol", tolCortolAngleAtts))
	{warnAtt("uptol", "tolCortolAngle", a_tolCortolAngle);}
      else
        check_rentVal(a_tolCortolAngle->get_uptol());
    }
}

/********************************************************************/

void check_tolCortolAxis(
 tolCortolAxis * a_tolCortolAxis)
{
  if (a_tolCortolAxis->get_axis())
    {
      if (!findString("a_axis", tolCortolAxisAtts))
	{warnAtt("a_axis", "tolCortolAxis", a_tolCortolAxis);}
      else
        check_axis(a_tolCortolAxis->get_axis());
    }
  if (a_tolCortolAxis->get_lotol())
    {
      if (!findString("lotol", tolCortolAxisAtts))
	{warnAtt("lotol", "tolCortolAxis", a_tolCortolAxis);}
      else
        check_rentVal(a_tolCortolAxis->get_lotol());
    }
  if (a_tolCortolAxis->get_uptol())
    {
      if (!findString("uptol", tolCortolAxisAtts))
	{warnAtt("uptol", "tolCortolAxis", a_tolCortolAxis);}
      else
        check_rentVal(a_tolCortolAxis->get_uptol());
    }
  if (a_tolCortolAxis->get_axial())
    {
      if (!findString("a_axial", tolCortolAxisAtts))
	{warnAtt("a_axial", "tolCortolAxis", a_tolCortolAxis);}
      else
        check_axial(a_tolCortolAxis->get_axial());
    }
}

/********************************************************************/

void check_tolCortolMinor(
 tolCortolMinor * a_tolCortolMinor)
{
  if (isA(a_tolCortolMinor, tolCortolAxis))
    {
      if (!findString("tolCortolAxis", tolCortolMinorSubs))
        {warnSub("tolCortolAxis", "tolCortolMinor", a_tolCortolMinor);}
      else
        check_tolCortolAxis(dynamic_cast<tolCortolAxis *>(a_tolCortolMinor));
      return;
    }
  if (isA(a_tolCortolMinor, tolCortolRadial))
    {
      if (!findString("tolCortolRadial", tolCortolMinorSubs))
        {warnSub("tolCortolRadial", "tolCortolMinor", a_tolCortolMinor);}
      else
        check_tolCortolRadial(dynamic_cast<tolCortolRadial *>(a_tolCortolMinor));
      return;
    }
  if (isA(a_tolCortolMinor, tolCortolAngle))
    {
      if (!findString("tolCortolAngle", tolCortolMinorSubs))
        {warnSub("tolCortolAngle", "tolCortolMinor", a_tolCortolMinor);}
      else
        check_tolCortolAngle(dynamic_cast<tolCortolAngle *>(a_tolCortolMinor));
      return;
    }
}

/********************************************************************/

void check_tolCortolRadial(
 tolCortolRadial * a_tolCortolRadial)
{
  if (a_tolCortolRadial->get_lotol())
    {
      if (!findString("lotol", tolCortolRadialAtts))
	{warnAtt("lotol", "tolCortolRadial", a_tolCortolRadial);}
      else
        check_rentVal(a_tolCortolRadial->get_lotol());
    }
  if (a_tolCortolRadial->get_uptol())
    {
      if (!findString("uptol", tolCortolRadialAtts))
	{warnAtt("uptol", "tolCortolRadial", a_tolCortolRadial);}
      else
        check_rentVal(a_tolCortolRadial->get_uptol());
    }
}

/********************************************************************/

void check_tolCortolStm(
 tolCortolStm * a_tolCortolStm)
{
  if (a_tolCortolStm->get_tLabel())
    {
      if (!findString("a_tLabel", tolCortolStmAtts))
	{warnAtt("a_tLabel", "tolCortolStm", a_tolCortolStm);}
      else
        check_tLabel(a_tolCortolStm->get_tLabel());
    }
  if (a_tolCortolStm->get_tolCortolMinor())
    {
      if (!findString("a_tolCortolMinor", tolCortolStmAtts))
	{warnAtt("a_tolCortolMinor", "tolCortolStm", a_tolCortolStm);}
      else
        check_tolCortolMinor(a_tolCortolStm->get_tolCortolMinor());
    }
}

/********************************************************************/

void check_tolCprofSpec(
 tolCprofSpec * a_tolCprofSpec)
{
  if (a_tolCprofSpec->get_lotol())
    {
      if (!findString("lotol", tolCprofSpecAtts))
	{warnAtt("lotol", "tolCprofSpec", a_tolCprofSpec);}
      else
        check_rentVal(a_tolCprofSpec->get_lotol());
    }
  if (a_tolCprofSpec->get_uptol())
    {
      if (!findString("uptol", tolCprofSpecAtts))
	{warnAtt("uptol", "tolCprofSpec", a_tolCprofSpec);}
      else
        check_rentVal(a_tolCprofSpec->get_uptol());
    }
  if (a_tolCprofSpec->get_tfm1())
    {
      if (!findString("tfm1", tolCprofSpecAtts))
	{warnAtt("tfm1", "tolCprofSpec", a_tolCprofSpec);}
      else
        check_tolFeatureMat(a_tolCprofSpec->get_tfm1());
    }
  if (a_tolCprofSpec->get_tfm2())
    {
      if (!findString("tfm2", tolCprofSpecAtts))
	{warnAtt("tfm2", "tolCprofSpec", a_tolCprofSpec);}
      else
        check_tolFeatureMat(a_tolCprofSpec->get_tfm2());
    }
  if (a_tolCprofSpec->get_tfm3())
    {
      if (!findString("tfm3", tolCprofSpecAtts))
	{warnAtt("tfm3", "tolCprofSpec", a_tolCprofSpec);}
      else
        check_tolFeatureMat(a_tolCprofSpec->get_tfm3());
    }
  if (a_tolCprofSpec->get_has_AVGDEV())
    {
      if (!findString("has_AVGDEV", tolCprofSpecAtts))
	{warnAtt("has_AVGDEV", "tolCprofSpec", a_tolCprofSpec);}
    }
}

/********************************************************************/

void check_tolCprofSpecC(
 tolCprofSpecC * a_tolCprofSpecC)
{
  if (a_tolCprofSpecC->get_lotol())
    {
      if (!findString("lotol", tolCprofSpecCAtts))
	{warnAtt("lotol", "tolCprofSpecC", a_tolCprofSpecC);}
      else
        check_rentVal(a_tolCprofSpecC->get_lotol());
    }
  if (a_tolCprofSpecC->get_uptol())
    {
      if (!findString("uptol", tolCprofSpecCAtts))
	{warnAtt("uptol", "tolCprofSpecC", a_tolCprofSpecC);}
      else
        check_rentVal(a_tolCprofSpecC->get_uptol());
    }
  if (a_tolCprofSpecC->get_tfm1())
    {
      if (!findString("tfm1", tolCprofSpecCAtts))
	{warnAtt("tfm1", "tolCprofSpecC", a_tolCprofSpecC);}
      else
        check_tolFeatureMat(a_tolCprofSpecC->get_tfm1());
    }
  if (a_tolCprofSpecC->get_tfm2())
    {
      if (!findString("tfm2", tolCprofSpecCAtts))
	{warnAtt("tfm2", "tolCprofSpecC", a_tolCprofSpecC);}
      else
        check_tolFeatureMat(a_tolCprofSpecC->get_tfm2());
    }
  if (a_tolCprofSpecC->get_tfm3())
    {
      if (!findString("tfm3", tolCprofSpecCAtts))
	{warnAtt("tfm3", "tolCprofSpecC", a_tolCprofSpecC);}
      else
        check_tolFeatureMat(a_tolCprofSpecC->get_tfm3());
    }
  if (a_tolCprofSpecC->get_has_AVGDEV())
    {
      if (!findString("has_AVGDEV", tolCprofSpecCAtts))
	{warnAtt("has_AVGDEV", "tolCprofSpecC", a_tolCprofSpecC);}
    }
}

/********************************************************************/

void check_tolCproflStm(
 tolCproflStm * a_tolCproflStm)
{
  if (a_tolCproflStm->get_tLabel())
    {
      if (!findString("a_tLabel", tolCproflStmAtts))
	{warnAtt("a_tLabel", "tolCproflStm", a_tolCproflStm);}
      else
        check_tLabel(a_tolCproflStm->get_tLabel());
    }
  if (a_tolCproflStm->get_upper())
    {
      if (!findString("upper", tolCproflStmAtts))
	{warnAtt("upper", "tolCproflStm", a_tolCproflStm);}
      else
        check_tolCprofSpecC(a_tolCproflStm->get_upper());
    }
  if (a_tolCproflStm->get_lower())
    {
      if (!findString("lower", tolCproflStmAtts))
	{warnAtt("lower", "tolCproflStm", a_tolCproflStm);}
      else
        check_tolCprofSpec(a_tolCproflStm->get_lower());
    }
}

/********************************************************************/

void check_tolCprofsStm(
 tolCprofsStm * a_tolCprofsStm)
{
  if (a_tolCprofsStm->get_tLabel())
    {
      if (!findString("a_tLabel", tolCprofsStmAtts))
	{warnAtt("a_tLabel", "tolCprofsStm", a_tolCprofsStm);}
      else
        check_tLabel(a_tolCprofsStm->get_tLabel());
    }
  if (a_tolCprofsStm->get_upper())
    {
      if (!findString("upper", tolCprofsStmAtts))
	{warnAtt("upper", "tolCprofsStm", a_tolCprofsStm);}
      else
        check_tolCprofSpecC(a_tolCprofsStm->get_upper());
    }
  if (a_tolCprofsStm->get_lower())
    {
      if (!findString("lower", tolCprofsStmAtts))
	{warnAtt("lower", "tolCprofsStm", a_tolCprofsStm);}
      else
        check_tolCprofSpec(a_tolCprofsStm->get_lower());
    }
}

/********************************************************************/

void check_tolCrnoutStm(
 tolCrnoutStm * a_tolCrnoutStm)
{
  if (a_tolCrnoutStm->get_tLabel())
    {
      if (!findString("a_tLabel", tolCrnoutStmAtts))
	{warnAtt("a_tLabel", "tolCrnoutStm", a_tolCrnoutStm);}
      else
        check_tLabel(a_tolCrnoutStm->get_tLabel());
    }
  if (a_tolCrnoutStm->get_tolzon())
    {
      if (!findString("tolzon", tolCrnoutStmAtts))
	{warnAtt("tolzon", "tolCrnoutStm", a_tolCrnoutStm);}
      else
        check_rentVal(a_tolCrnoutStm->get_tolzon());
    }
  if (a_tolCrnoutStm->get_datLabel())
    {
      if (!findString("a_datLabel", tolCrnoutStmAtts))
	{warnAtt("a_datLabel", "tolCrnoutStm", a_tolCrnoutStm);}
      else
        check_datLabel(a_tolCrnoutStm->get_datLabel());
    }
  if (a_tolCrnoutStm->get_tolFeat1())
    {
      if (!findString("tolFeat1", tolCrnoutStmAtts))
	{warnAtt("tolFeat1", "tolCrnoutStm", a_tolCrnoutStm);}
      else
        check_tolFeature(a_tolCrnoutStm->get_tolFeat1());
    }
  if (a_tolCrnoutStm->get_tolFeat2())
    {
      if (!findString("tolFeat2", tolCrnoutStmAtts))
	{warnAtt("tolFeat2", "tolCrnoutStm", a_tolCrnoutStm);}
      else
        check_tolFeature(a_tolCrnoutStm->get_tolFeat2());
    }
  if (a_tolCrnoutStm->get_dir())
    {
      if (!findString("dir", tolCrnoutStmAtts))
	{warnAtt("dir", "tolCrnoutStm", a_tolCrnoutStm);}
      else
        check_vector(a_tolCrnoutStm->get_dir());
    }
}

/********************************************************************/

void check_tolCylctyStm(
 tolCylctyStm * a_tolCylctyStm)
{
  if (a_tolCylctyStm->get_tLabel())
    {
      if (!findString("a_tLabel", tolCylctyStmAtts))
	{warnAtt("a_tLabel", "tolCylctyStm", a_tolCylctyStm);}
      else
        check_tLabel(a_tolCylctyStm->get_tLabel());
    }
  if (a_tolCylctyStm->get_tolzon())
    {
      if (!findString("tolzon", tolCylctyStmAtts))
	{warnAtt("tolzon", "tolCylctyStm", a_tolCylctyStm);}
      else
        check_rentVal(a_tolCylctyStm->get_tolzon());
    }
}

/********************************************************************/

void check_tolDiamAvg(
 tolDiamAvg * a_tolDiamAvg)
{
  if (a_tolDiamAvg->get_lotol())
    {
      if (!findString("lotol", tolDiamAvgAtts))
	{warnAtt("lotol", "tolDiamAvg", a_tolDiamAvg);}
      else
        check_rentVal(a_tolDiamAvg->get_lotol());
    }
  if (a_tolDiamAvg->get_uptol())
    {
      if (!findString("uptol", tolDiamAvgAtts))
	{warnAtt("uptol", "tolDiamAvg", a_tolDiamAvg);}
      else
        check_rentVal(a_tolDiamAvg->get_uptol());
    }
  if (a_tolDiamAvg->get_radiusSpec())
    {
      if (!findString("a_radiusSpec", tolDiamAvgAtts))
	{warnAtt("a_radiusSpec", "tolDiamAvg", a_tolDiamAvg);}
      else
        check_radiusSpec(a_tolDiamAvg->get_radiusSpec());
    }
}

/********************************************************************/

void check_tolDiamMinmax(
 tolDiamMinmax * a_tolDiamMinmax)
{
  if (a_tolDiamMinmax->get_lotol())
    {
      if (!findString("lotol", tolDiamMinmaxAtts))
	{warnAtt("lotol", "tolDiamMinmax", a_tolDiamMinmax);}
      else
        check_rentVal(a_tolDiamMinmax->get_lotol());
    }
  if (a_tolDiamMinmax->get_uptol())
    {
      if (!findString("uptol", tolDiamMinmaxAtts))
	{warnAtt("uptol", "tolDiamMinmax", a_tolDiamMinmax);}
      else
        check_rentVal(a_tolDiamMinmax->get_uptol());
    }
  if (a_tolDiamMinmax->get_radiusSpec())
    {
      if (!findString("a_radiusSpec", tolDiamMinmaxAtts))
	{warnAtt("a_radiusSpec", "tolDiamMinmax", a_tolDiamMinmax);}
      else
        check_radiusSpec(a_tolDiamMinmax->get_radiusSpec());
    }
}

/********************************************************************/

void check_tolDiamMinor(
 tolDiamMinor * a_tolDiamMinor)
{
  if (isA(a_tolDiamMinor, tolDiamPlain))
    {
      if (!findString("tolDiamPlain", tolDiamMinorSubs))
        {warnSub("tolDiamPlain", "tolDiamMinor", a_tolDiamMinor);}
      else
        check_tolDiamPlain(dynamic_cast<tolDiamPlain *>(a_tolDiamMinor));
      return;
    }
  if (isA(a_tolDiamMinor, tolDiamAvg))
    {
      if (!findString("tolDiamAvg", tolDiamMinorSubs))
        {warnSub("tolDiamAvg", "tolDiamMinor", a_tolDiamMinor);}
      else
        check_tolDiamAvg(dynamic_cast<tolDiamAvg *>(a_tolDiamMinor));
      return;
    }
  if (isA(a_tolDiamMinor, tolDiamMinmax))
    {
      if (!findString("tolDiamMinmax", tolDiamMinorSubs))
        {warnSub("tolDiamMinmax", "tolDiamMinor", a_tolDiamMinor);}
      else
        check_tolDiamMinmax(dynamic_cast<tolDiamMinmax *>(a_tolDiamMinor));
      return;
    }
}

/********************************************************************/

void check_tolDiamPlain(
 tolDiamPlain * a_tolDiamPlain)
{
  if (a_tolDiamPlain->get_lotol())
    {
      if (!findString("lotol", tolDiamPlainAtts))
	{warnAtt("lotol", "tolDiamPlain", a_tolDiamPlain);}
      else
        check_rentVal(a_tolDiamPlain->get_lotol());
    }
  if (a_tolDiamPlain->get_uptol())
    {
      if (!findString("uptol", tolDiamPlainAtts))
	{warnAtt("uptol", "tolDiamPlain", a_tolDiamPlain);}
      else
        check_rentVal(a_tolDiamPlain->get_uptol());
    }
  if (a_tolDiamPlain->get_radiusSpec())
    {
      if (!findString("a_radiusSpec", tolDiamPlainAtts))
	{warnAtt("a_radiusSpec", "tolDiamPlain", a_tolDiamPlain);}
      else
        check_radiusSpec(a_tolDiamPlain->get_radiusSpec());
    }
}

/********************************************************************/

void check_tolDiamStm(
 tolDiamStm * a_tolDiamStm)
{
  if (a_tolDiamStm->get_tLabel())
    {
      if (!findString("a_tLabel", tolDiamStmAtts))
	{warnAtt("a_tLabel", "tolDiamStm", a_tolDiamStm);}
      else
        check_tLabel(a_tolDiamStm->get_tLabel());
    }
  if (a_tolDiamStm->get_tolDiamMinor())
    {
      if (!findString("a_tolDiamMinor", tolDiamStmAtts))
	{warnAtt("a_tolDiamMinor", "tolDiamStm", a_tolDiamStm);}
      else
        check_tolDiamMinor(a_tolDiamStm->get_tolDiamMinor());
    }
}

/********************************************************************/

void check_tolDistbDir(
 tolDistbDir * a_tolDistbDir)
{
  if (isA(a_tolDistbDir, tolDistbDir_XAXIS))
    {
      if (!findString("tolDistbDir_XAXIS", tolDistbDirSubs))
        {warnSub("tolDistbDir_XAXIS", "tolDistbDir", a_tolDistbDir);}
      return;
    }
  if (isA(a_tolDistbDir, tolDistbDir_YAXIS))
    {
      if (!findString("tolDistbDir_YAXIS", tolDistbDirSubs))
        {warnSub("tolDistbDir_YAXIS", "tolDistbDir", a_tolDistbDir);}
      return;
    }
  if (isA(a_tolDistbDir, tolDistbDir_ZAXIS))
    {
      if (!findString("tolDistbDir_ZAXIS", tolDistbDirSubs))
        {warnSub("tolDistbDir_ZAXIS", "tolDistbDir", a_tolDistbDir);}
      return;
    }
  if (isA(a_tolDistbDir, tolDistbDir_PT2PT))
    {
      if (!findString("tolDistbDir_PT2PT", tolDistbDirSubs))
        {warnSub("tolDistbDir_PT2PT", "tolDistbDir", a_tolDistbDir);}
      return;
    }
}

/********************************************************************/

void check_tolDistbLimit(
 tolDistbLimit * a_tolDistbLimit)
{
  if (a_tolDistbLimit->get_lolimt())
    {
      if (!findString("lolimt", tolDistbLimitAtts))
	{warnAtt("lolimt", "tolDistbLimit", a_tolDistbLimit);}
      else
        check_rentVal(a_tolDistbLimit->get_lolimt());
    }
  if (a_tolDistbLimit->get_uplimt())
    {
      if (!findString("uplimt", tolDistbLimitAtts))
	{warnAtt("uplimt", "tolDistbLimit", a_tolDistbLimit);}
      else
        check_rentVal(a_tolDistbLimit->get_uplimt());
    }
}

/********************************************************************/

void check_tolDistbNominl(
 tolDistbNominl * a_tolDistbNominl)
{
  if (a_tolDistbNominl->get_dist())
    {
      if (!findString("dist", tolDistbNominlAtts))
	{warnAtt("dist", "tolDistbNominl", a_tolDistbNominl);}
      else
        check_rentVal(a_tolDistbNominl->get_dist());
    }
  if (a_tolDistbNominl->get_lotol())
    {
      if (!findString("lotol", tolDistbNominlAtts))
	{warnAtt("lotol", "tolDistbNominl", a_tolDistbNominl);}
      else
        check_rentVal(a_tolDistbNominl->get_lotol());
    }
  if (a_tolDistbNominl->get_uptol())
    {
      if (!findString("uptol", tolDistbNominlAtts))
	{warnAtt("uptol", "tolDistbNominl", a_tolDistbNominl);}
      else
        check_rentVal(a_tolDistbNominl->get_uptol());
    }
}

/********************************************************************/

void check_tolDistbStm(
 tolDistbStm * a_tolDistbStm)
{
  if (a_tolDistbStm->get_tLabel())
    {
      if (!findString("a_tLabel", tolDistbStmAtts))
	{warnAtt("a_tLabel", "tolDistbStm", a_tolDistbStm);}
      else
        check_tLabel(a_tolDistbStm->get_tLabel());
    }
  if (a_tolDistbStm->get_tolDistbTol())
    {
      if (!findString("a_tolDistbTol", tolDistbStmAtts))
	{warnAtt("a_tolDistbTol", "tolDistbStm", a_tolDistbStm);}
      else
        check_tolDistbTol(a_tolDistbStm->get_tolDistbTol());
    }
  if (a_tolDistbStm->get_tolDistbDir())
    {
      if (!findString("a_tolDistbDir", tolDistbStmAtts))
	{warnAtt("a_tolDistbDir", "tolDistbStm", a_tolDistbStm);}
      else
        check_tolDistbDir(a_tolDistbStm->get_tolDistbDir());
    }
  if (a_tolDistbStm->get_avgMaxMin())
    {
      if (!findString("a_avgMaxMin", tolDistbStmAtts))
	{warnAtt("a_avgMaxMin", "tolDistbStm", a_tolDistbStm);}
      else
        check_avgMaxMin(a_tolDistbStm->get_avgMaxMin());
    }
}

/********************************************************************/

void check_tolDistbTol(
 tolDistbTol * a_tolDistbTol)
{
  if (isA(a_tolDistbTol, tolDistbLimit))
    {
      if (!findString("tolDistbLimit", tolDistbTolSubs))
        {warnSub("tolDistbLimit", "tolDistbTol", a_tolDistbTol);}
      else
        check_tolDistbLimit(dynamic_cast<tolDistbLimit *>(a_tolDistbTol));
      return;
    }
  if (isA(a_tolDistbTol, tolDistbNominl))
    {
      if (!findString("tolDistbNominl", tolDistbTolSubs))
        {warnSub("tolDistbNominl", "tolDistbTol", a_tolDistbTol);}
      else
        check_tolDistbNominl(dynamic_cast<tolDistbNominl *>(a_tolDistbTol));
      return;
    }
}

/********************************************************************/

void check_tolDistwrtStm(
 tolDistwrtStm * a_tolDistwrtStm)
{
  if (a_tolDistwrtStm->get_tLabel())
    {
      if (!findString("a_tLabel", tolDistwrtStmAtts))
	{warnAtt("a_tLabel", "tolDistwrtStm", a_tolDistwrtStm);}
      else
        check_tLabel(a_tolDistwrtStm->get_tLabel());
    }
  if (a_tolDistwrtStm->get_tolDistbTol())
    {
      if (!findString("a_tolDistbTol", tolDistwrtStmAtts))
	{warnAtt("a_tolDistbTol", "tolDistwrtStm", a_tolDistwrtStm);}
      else
        check_tolDistbTol(a_tolDistwrtStm->get_tolDistbTol());
    }
  if (a_tolDistwrtStm->get_tolFeature())
    {
      if (!findString("a_tolFeature", tolDistwrtStmAtts))
	{warnAtt("a_tolFeature", "tolDistwrtStm", a_tolDistwrtStm);}
      else
        check_tolFeature(a_tolDistwrtStm->get_tolFeature());
    }
  if (a_tolDistwrtStm->get_tolDistbDir())
    {
      if (!findString("a_tolDistbDir", tolDistwrtStmAtts))
	{warnAtt("a_tolDistbDir", "tolDistwrtStm", a_tolDistwrtStm);}
      else
        check_tolDistbDir(a_tolDistwrtStm->get_tolDistbDir());
    }
  if (a_tolDistwrtStm->get_avgMaxMin())
    {
      if (!findString("a_avgMaxMin", tolDistwrtStmAtts))
	{warnAtt("a_avgMaxMin", "tolDistwrtStm", a_tolDistwrtStm);}
      else
        check_avgMaxMin(a_tolDistwrtStm->get_avgMaxMin());
    }
}

/********************************************************************/

void check_tolFeatMaxMat(
 tolFeatMaxMat * a_tolFeatMaxMat)
{
  if (isA(a_tolFeatMaxMat, tolFeatMaxMat_datLabel))
    {
      if (!findString("tolFeatMaxMat_datLabel", tolFeatMaxMatSubs))
        {warnSub("tolFeatMaxMat_datLabel", "tolFeatMaxMat", a_tolFeatMaxMat);}
      else
        check_tolFeatMaxMat_datLabel(dynamic_cast<tolFeatMaxMat_datLabel *>(a_tolFeatMaxMat));
      return;
    }
  if (isA(a_tolFeatMaxMat, tolFeatMaxMat_faLabel))
    {
      if (!findString("tolFeatMaxMat_faLabel", tolFeatMaxMatSubs))
        {warnSub("tolFeatMaxMat_faLabel", "tolFeatMaxMat", a_tolFeatMaxMat);}
      else
        check_tolFeatMaxMat_faLabel(dynamic_cast<tolFeatMaxMat_faLabel *>(a_tolFeatMaxMat));
      return;
    }
  if (isA(a_tolFeatMaxMat, tolFeatMaxMat_fLabel))
    {
      if (!findString("tolFeatMaxMat_fLabel", tolFeatMaxMatSubs))
        {warnSub("tolFeatMaxMat_fLabel", "tolFeatMaxMat", a_tolFeatMaxMat);}
      else
        check_tolFeatMaxMat_fLabel(dynamic_cast<tolFeatMaxMat_fLabel *>(a_tolFeatMaxMat));
      return;
    }
}

/********************************************************************/

void check_tolFeatMaxMat_datLabel(
 tolFeatMaxMat_datLabel * a_tolFeatMaxMat_datLabel)
{
  if (a_tolFeatMaxMat_datLabel->get_datLabel())
    {
      if (!findString("a_datLabel", tolFeatMaxMat_datLabelAtts))
	{warnAtt("a_datLabel", "tolFeatMaxMat_datLabel", a_tolFeatMaxMat_datLabel);}
      else
        check_datLabel(a_tolFeatMaxMat_datLabel->get_datLabel());
    }
  if (a_tolFeatMaxMat_datLabel->get_tolMaxMatCond())
    {
      if (!findString("a_tolMaxMatCond", tolFeatMaxMat_datLabelAtts))
	{warnAtt("a_tolMaxMatCond", "tolFeatMaxMat_datLabel", a_tolFeatMaxMat_datLabel);}
      else
        check_tolMaxMatCond(a_tolFeatMaxMat_datLabel->get_tolMaxMatCond());
    }
}

/********************************************************************/

void check_tolFeatMaxMat_fLabel(
 tolFeatMaxMat_fLabel * a_tolFeatMaxMat_fLabel)
{
  if (a_tolFeatMaxMat_fLabel->get_fLabel())
    {
      if (!findString("a_fLabel", tolFeatMaxMat_fLabelAtts))
	{warnAtt("a_fLabel", "tolFeatMaxMat_fLabel", a_tolFeatMaxMat_fLabel);}
      else
        check_fLabel(a_tolFeatMaxMat_fLabel->get_fLabel());
    }
}

/********************************************************************/

void check_tolFeatMaxMat_faLabel(
 tolFeatMaxMat_faLabel * a_tolFeatMaxMat_faLabel)
{
  if (a_tolFeatMaxMat_faLabel->get_faLabel())
    {
      if (!findString("a_faLabel", tolFeatMaxMat_faLabelAtts))
	{warnAtt("a_faLabel", "tolFeatMaxMat_faLabel", a_tolFeatMaxMat_faLabel);}
      else
        check_faLabel(a_tolFeatMaxMat_faLabel->get_faLabel());
    }
  if (a_tolFeatMaxMat_faLabel->get_tolMaxMatCond())
    {
      if (!findString("a_tolMaxMatCond", tolFeatMaxMat_faLabelAtts))
	{warnAtt("a_tolMaxMatCond", "tolFeatMaxMat_faLabel", a_tolFeatMaxMat_faLabel);}
      else
        check_tolMaxMatCond(a_tolFeatMaxMat_faLabel->get_tolMaxMatCond());
    }
}

/********************************************************************/

void check_tolFeature(
 tolFeature * a_tolFeature)
{
  if (isA(a_tolFeature, fLabel))
    {
      if (!findString("fLabel", tolFeatureSubs))
        {warnSub("fLabel", "tolFeature", a_tolFeature);}
      else
        check_fLabel(dynamic_cast<fLabel *>(a_tolFeature));
      return;
    }
  if (isA(a_tolFeature, faLabel))
    {
      if (!findString("faLabel", tolFeatureSubs))
        {warnSub("faLabel", "tolFeature", a_tolFeature);}
      else
        check_faLabel(dynamic_cast<faLabel *>(a_tolFeature));
      return;
    }
  if (isA(a_tolFeature, datLabel))
    {
      if (!findString("datLabel", tolFeatureSubs))
        {warnSub("datLabel", "tolFeature", a_tolFeature);}
      else
        check_datLabel(dynamic_cast<datLabel *>(a_tolFeature));
      return;
    }
}

/********************************************************************/

void check_tolFeatureMat(
 tolFeatureMat * a_tolFeatureMat)
{
  if (isA(a_tolFeatureMat, tolFeatureMat_datLabel))
    {
      if (!findString("tolFeatureMat_datLabel", tolFeatureMatSubs))
        {warnSub("tolFeatureMat_datLabel", "tolFeatureMat", a_tolFeatureMat);}
      else
        check_tolFeatureMat_datLabel(dynamic_cast<tolFeatureMat_datLabel *>(a_tolFeatureMat));
      return;
    }
  if (isA(a_tolFeatureMat, tolFeatureMat_faLabel))
    {
      if (!findString("tolFeatureMat_faLabel", tolFeatureMatSubs))
        {warnSub("tolFeatureMat_faLabel", "tolFeatureMat", a_tolFeatureMat);}
      else
        check_tolFeatureMat_faLabel(dynamic_cast<tolFeatureMat_faLabel *>(a_tolFeatureMat));
      return;
    }
  if (isA(a_tolFeatureMat, tolFeatureMat_fLabel))
    {
      if (!findString("tolFeatureMat_fLabel", tolFeatureMatSubs))
        {warnSub("tolFeatureMat_fLabel", "tolFeatureMat", a_tolFeatureMat);}
      else
        check_tolFeatureMat_fLabel(dynamic_cast<tolFeatureMat_fLabel *>(a_tolFeatureMat));
      return;
    }
}

/********************************************************************/

void check_tolFeatureMat_datLabel(
 tolFeatureMat_datLabel * a_tolFeatureMat_datLabel)
{
  if (a_tolFeatureMat_datLabel->get_datLabel())
    {
      if (!findString("a_datLabel", tolFeatureMat_datLabelAtts))
	{warnAtt("a_datLabel", "tolFeatureMat_datLabel", a_tolFeatureMat_datLabel);}
      else
        check_datLabel(a_tolFeatureMat_datLabel->get_datLabel());
    }
  if (a_tolFeatureMat_datLabel->get_tolMatCond())
    {
      if (!findString("a_tolMatCond", tolFeatureMat_datLabelAtts))
	{warnAtt("a_tolMatCond", "tolFeatureMat_datLabel", a_tolFeatureMat_datLabel);}
      else
        check_tolMatCond(a_tolFeatureMat_datLabel->get_tolMatCond());
    }
}

/********************************************************************/

void check_tolFeatureMat_fLabel(
 tolFeatureMat_fLabel * a_tolFeatureMat_fLabel)
{
  if (a_tolFeatureMat_fLabel->get_fLabel())
    {
      if (!findString("a_fLabel", tolFeatureMat_fLabelAtts))
	{warnAtt("a_fLabel", "tolFeatureMat_fLabel", a_tolFeatureMat_fLabel);}
      else
        check_fLabel(a_tolFeatureMat_fLabel->get_fLabel());
    }
}

/********************************************************************/

void check_tolFeatureMat_faLabel(
 tolFeatureMat_faLabel * a_tolFeatureMat_faLabel)
{
  if (a_tolFeatureMat_faLabel->get_faLabel())
    {
      if (!findString("a_faLabel", tolFeatureMat_faLabelAtts))
	{warnAtt("a_faLabel", "tolFeatureMat_faLabel", a_tolFeatureMat_faLabel);}
      else
        check_faLabel(a_tolFeatureMat_faLabel->get_faLabel());
    }
  if (a_tolFeatureMat_faLabel->get_tolMatCond())
    {
      if (!findString("a_tolMatCond", tolFeatureMat_faLabelAtts))
	{warnAtt("a_tolMatCond", "tolFeatureMat_faLabel", a_tolFeatureMat_faLabel);}
      else
        check_tolMatCond(a_tolFeatureMat_faLabel->get_tolMatCond());
    }
}

/********************************************************************/

void check_tolFlatMinor(
 tolFlatMinor * a_tolFlatMinor)
{
  if (isA(a_tolFlatMinor, tolFlatZon))
    {
      if (!findString("tolFlatZon", tolFlatMinorSubs))
        {warnSub("tolFlatZon", "tolFlatMinor", a_tolFlatMinor);}
      else
        check_tolFlatZon(dynamic_cast<tolFlatZon *>(a_tolFlatMinor));
      return;
    }
  if (isA(a_tolFlatMinor, tolFlatPer))
    {
      if (!findString("tolFlatPer", tolFlatMinorSubs))
        {warnSub("tolFlatPer", "tolFlatMinor", a_tolFlatMinor);}
      else
        check_tolFlatPer(dynamic_cast<tolFlatPer *>(a_tolFlatMinor));
      return;
    }
  if (isA(a_tolFlatMinor, tolFlatZonPer))
    {
      if (!findString("tolFlatZonPer", tolFlatMinorSubs))
        {warnSub("tolFlatZonPer", "tolFlatMinor", a_tolFlatMinor);}
      else
        check_tolFlatZonPer(dynamic_cast<tolFlatZonPer *>(a_tolFlatMinor));
      return;
    }
}

/********************************************************************/

void check_tolFlatPer(
 tolFlatPer * a_tolFlatPer)
{
  if (a_tolFlatPer->get_tolzon1())
    {
      if (!findString("tolzon1", tolFlatPerAtts))
	{warnAtt("tolzon1", "tolFlatPer", a_tolFlatPer);}
      else
        check_rentVal(a_tolFlatPer->get_tolzon1());
    }
  if (a_tolFlatPer->get_unit1())
    {
      if (!findString("unit1", tolFlatPerAtts))
	{warnAtt("unit1", "tolFlatPer", a_tolFlatPer);}
      else
        check_rentVal(a_tolFlatPer->get_unit1());
    }
  if (a_tolFlatPer->get_unit2())
    {
      if (!findString("unit2", tolFlatPerAtts))
	{warnAtt("unit2", "tolFlatPer", a_tolFlatPer);}
      else
        check_rentVal(a_tolFlatPer->get_unit2());
    }
}

/********************************************************************/

void check_tolFlatStm(
 tolFlatStm * a_tolFlatStm)
{
  if (a_tolFlatStm->get_tLabel())
    {
      if (!findString("a_tLabel", tolFlatStmAtts))
	{warnAtt("a_tLabel", "tolFlatStm", a_tolFlatStm);}
      else
        check_tLabel(a_tolFlatStm->get_tLabel());
    }
  if (a_tolFlatStm->get_tolFlatMinor())
    {
      if (!findString("a_tolFlatMinor", tolFlatStmAtts))
	{warnAtt("a_tolFlatMinor", "tolFlatStm", a_tolFlatStm);}
      else
        check_tolFlatMinor(a_tolFlatStm->get_tolFlatMinor());
    }
}

/********************************************************************/

void check_tolFlatZon(
 tolFlatZon * a_tolFlatZon)
{
  if (a_tolFlatZon->get_tolzon())
    {
      if (!findString("tolzon", tolFlatZonAtts))
	{warnAtt("tolzon", "tolFlatZon", a_tolFlatZon);}
      else
        check_rentVal(a_tolFlatZon->get_tolzon());
    }
}

/********************************************************************/

void check_tolFlatZonPer(
 tolFlatZonPer * a_tolFlatZonPer)
{
  if (a_tolFlatZonPer->get_tolzon())
    {
      if (!findString("tolzon", tolFlatZonPerAtts))
	{warnAtt("tolzon", "tolFlatZonPer", a_tolFlatZonPer);}
      else
        check_rentVal(a_tolFlatZonPer->get_tolzon());
    }
  if (a_tolFlatZonPer->get_tolzon1())
    {
      if (!findString("tolzon1", tolFlatZonPerAtts))
	{warnAtt("tolzon1", "tolFlatZonPer", a_tolFlatZonPer);}
      else
        check_rentVal(a_tolFlatZonPer->get_tolzon1());
    }
  if (a_tolFlatZonPer->get_unit1())
    {
      if (!findString("unit1", tolFlatZonPerAtts))
	{warnAtt("unit1", "tolFlatZonPer", a_tolFlatZonPer);}
      else
        check_rentVal(a_tolFlatZonPer->get_unit1());
    }
  if (a_tolFlatZonPer->get_unit2())
    {
      if (!findString("unit2", tolFlatZonPerAtts))
	{warnAtt("unit2", "tolFlatZonPer", a_tolFlatZonPer);}
      else
        check_rentVal(a_tolFlatZonPer->get_unit2());
    }
}

/********************************************************************/

void check_tolGtolRot(
 tolGtolRot * a_tolGtolRot)
{
  if (isA(a_tolGtolRot, tolGtolRot_XAXIS))
    {
      if (!findString("tolGtolRot_XAXIS", tolGtolRotSubs))
        {warnSub("tolGtolRot_XAXIS", "tolGtolRot", a_tolGtolRot);}
      return;
    }
  if (isA(a_tolGtolRot, tolGtolRot_YAXIS))
    {
      if (!findString("tolGtolRot_YAXIS", tolGtolRotSubs))
        {warnSub("tolGtolRot_YAXIS", "tolGtolRot", a_tolGtolRot);}
      return;
    }
  if (isA(a_tolGtolRot, tolGtolRot_ZAXIS))
    {
      if (!findString("tolGtolRot_ZAXIS", tolGtolRotSubs))
        {warnSub("tolGtolRot_ZAXIS", "tolGtolRot", a_tolGtolRot);}
      return;
    }
  if (isA(a_tolGtolRot, tolGtolRot_XYAXIS))
    {
      if (!findString("tolGtolRot_XYAXIS", tolGtolRotSubs))
        {warnSub("tolGtolRot_XYAXIS", "tolGtolRot", a_tolGtolRot);}
      return;
    }
  if (isA(a_tolGtolRot, tolGtolRot_YZAXIS))
    {
      if (!findString("tolGtolRot_YZAXIS", tolGtolRotSubs))
        {warnSub("tolGtolRot_YZAXIS", "tolGtolRot", a_tolGtolRot);}
      return;
    }
  if (isA(a_tolGtolRot, tolGtolRot_ZXAXIS))
    {
      if (!findString("tolGtolRot_ZXAXIS", tolGtolRotSubs))
        {warnSub("tolGtolRot_ZXAXIS", "tolGtolRot", a_tolGtolRot);}
      return;
    }
  if (isA(a_tolGtolRot, tolGtolRot_XYZAXI))
    {
      if (!findString("tolGtolRot_XYZAXI", tolGtolRotSubs))
        {warnSub("tolGtolRot_XYZAXI", "tolGtolRot", a_tolGtolRot);}
      return;
    }
  if (isA(a_tolGtolRot, tolGtolRot_NOROT))
    {
      if (!findString("tolGtolRot_NOROT", tolGtolRotSubs))
        {warnSub("tolGtolRot_NOROT", "tolGtolRot", a_tolGtolRot);}
      return;
    }
}

/********************************************************************/

void check_tolGtolSpec(
 tolGtolSpec * a_tolGtolSpec)
{
  if (isA(a_tolGtolSpec, tolGtolSpec_PERCNT))
    {
      if (!findString("tolGtolSpec_PERCNT", tolGtolSpecSubs))
        {warnSub("tolGtolSpec_PERCNT", "tolGtolSpec", a_tolGtolSpec);}
      return;
    }
  if (isA(a_tolGtolSpec, tolGtolSpec_INTFPT))
    {
      if (!findString("tolGtolSpec_INTFPT", tolGtolSpecSubs))
        {warnSub("tolGtolSpec_INTFPT", "tolGtolSpec", a_tolGtolSpec);}
      return;
    }
}

/********************************************************************/

void check_tolGtolStm(
 tolGtolStm * a_tolGtolStm)
{
  if (a_tolGtolStm->get_tLabel())
    {
      if (!findString("a_tLabel", tolGtolStmAtts))
	{warnAtt("a_tLabel", "tolGtolStm", a_tolGtolStm);}
      else
        check_tLabel(a_tolGtolStm->get_tLabel());
    }
  if (a_tolGtolStm->get_tolGtolTrans())
    {
      if (!findString("a_tolGtolTrans", tolGtolStmAtts))
	{warnAtt("a_tolGtolTrans", "tolGtolStm", a_tolGtolStm);}
      else
        check_tolGtolTrans(a_tolGtolStm->get_tolGtolTrans());
    }
  if (a_tolGtolStm->get_tolGtolRot())
    {
      if (!findString("a_tolGtolRot", tolGtolStmAtts))
	{warnAtt("a_tolGtolRot", "tolGtolStm", a_tolGtolStm);}
      else
        check_tolGtolRot(a_tolGtolStm->get_tolGtolRot());
    }
  if (a_tolGtolStm->get_maxitr())
    {
      if (!findString("maxitr", tolGtolStmAtts))
	{warnAtt("maxitr", "tolGtolStm", a_tolGtolStm);}
      else
        check_intVal(a_tolGtolStm->get_maxitr());
    }
  if (a_tolGtolStm->get_minshf())
    {
      if (!findString("minshf", tolGtolStmAtts))
	{warnAtt("minshf", "tolGtolStm", a_tolGtolStm);}
      else
        check_rentVal(a_tolGtolStm->get_minshf());
    }
  if (a_tolGtolStm->get_maxrot())
    {
      if (!findString("maxrot", tolGtolStmAtts))
	{warnAtt("maxrot", "tolGtolStm", a_tolGtolStm);}
      else
        check_angle(a_tolGtolStm->get_maxrot());
    }
  if (a_tolGtolStm->get_tolGtolSpec())
    {
      if (!findString("a_tolGtolSpec", tolGtolStmAtts))
	{warnAtt("a_tolGtolSpec", "tolGtolStm", a_tolGtolStm);}
      else
        check_tolGtolSpec(a_tolGtolStm->get_tolGtolSpec());
    }
}

/********************************************************************/

void check_tolGtolTrans(
 tolGtolTrans * a_tolGtolTrans)
{
  if (isA(a_tolGtolTrans, tolGtolTrans_XDIR))
    {
      if (!findString("tolGtolTrans_XDIR", tolGtolTransSubs))
        {warnSub("tolGtolTrans_XDIR", "tolGtolTrans", a_tolGtolTrans);}
      return;
    }
  if (isA(a_tolGtolTrans, tolGtolTrans_YDIR))
    {
      if (!findString("tolGtolTrans_YDIR", tolGtolTransSubs))
        {warnSub("tolGtolTrans_YDIR", "tolGtolTrans", a_tolGtolTrans);}
      return;
    }
  if (isA(a_tolGtolTrans, tolGtolTrans_ZDIR))
    {
      if (!findString("tolGtolTrans_ZDIR", tolGtolTransSubs))
        {warnSub("tolGtolTrans_ZDIR", "tolGtolTrans", a_tolGtolTrans);}
      return;
    }
  if (isA(a_tolGtolTrans, tolGtolTrans_XYDIR))
    {
      if (!findString("tolGtolTrans_XYDIR", tolGtolTransSubs))
        {warnSub("tolGtolTrans_XYDIR", "tolGtolTrans", a_tolGtolTrans);}
      return;
    }
  if (isA(a_tolGtolTrans, tolGtolTrans_YZDIR))
    {
      if (!findString("tolGtolTrans_YZDIR", tolGtolTransSubs))
        {warnSub("tolGtolTrans_YZDIR", "tolGtolTrans", a_tolGtolTrans);}
      return;
    }
  if (isA(a_tolGtolTrans, tolGtolTrans_ZXDIR))
    {
      if (!findString("tolGtolTrans_ZXDIR", tolGtolTransSubs))
        {warnSub("tolGtolTrans_ZXDIR", "tolGtolTrans", a_tolGtolTrans);}
      return;
    }
  if (isA(a_tolGtolTrans, tolGtolTrans_XYZDIR))
    {
      if (!findString("tolGtolTrans_XYZDIR", tolGtolTransSubs))
        {warnSub("tolGtolTrans_XYZDIR", "tolGtolTrans", a_tolGtolTrans);}
      return;
    }
  if (isA(a_tolGtolTrans, tolGtolTrans_NOTRAN))
    {
      if (!findString("tolGtolTrans_NOTRAN", tolGtolTransSubs))
        {warnSub("tolGtolTrans_NOTRAN", "tolGtolTrans", a_tolGtolTrans);}
      return;
    }
}

/********************************************************************/

void check_tolMatCond(
 tolMatCond * a_tolMatCond)
{
  if (isA(a_tolMatCond, tolMatCond_MMC))
    {
      if (!findString("tolMatCond_MMC", tolMatCondSubs))
        {warnSub("tolMatCond_MMC", "tolMatCond", a_tolMatCond);}
      return;
    }
  if (isA(a_tolMatCond, tolMatCond_LMC))
    {
      if (!findString("tolMatCond_LMC", tolMatCondSubs))
        {warnSub("tolMatCond_LMC", "tolMatCond", a_tolMatCond);}
      return;
    }
  if (isA(a_tolMatCond, tolMatCond_RFS))
    {
      if (!findString("tolMatCond_RFS", tolMatCondSubs))
        {warnSub("tolMatCond_RFS", "tolMatCond", a_tolMatCond);}
      return;
    }
}

/********************************************************************/

void check_tolMaxMatCond(
 tolMaxMatCond * a_tolMaxMatCond)
{
  if (isA(a_tolMaxMatCond, tolMaxMatCond_LMC))
    {
      if (!findString("tolMaxMatCond_LMC", tolMaxMatCondSubs))
        {warnSub("tolMaxMatCond_LMC", "tolMaxMatCond", a_tolMaxMatCond);}
      else
        check_tolMaxMatCond_LMC(dynamic_cast<tolMaxMatCond_LMC *>(a_tolMaxMatCond));
      return;
    }
  if (isA(a_tolMaxMatCond, tolMaxMatCond_RFS))
    {
      if (!findString("tolMaxMatCond_RFS", tolMaxMatCondSubs))
        {warnSub("tolMaxMatCond_RFS", "tolMaxMatCond", a_tolMaxMatCond);}
      return;
    }
  if (isA(a_tolMaxMatCond, tolMaxMatCond_MMC))
    {
      if (!findString("tolMaxMatCond_MMC", tolMaxMatCondSubs))
        {warnSub("tolMaxMatCond_MMC", "tolMaxMatCond", a_tolMaxMatCond);}
      else
        check_tolMaxMatCond_MMC(dynamic_cast<tolMaxMatCond_MMC *>(a_tolMaxMatCond));
      return;
    }
}

/********************************************************************/

void check_tolMaxMatCond_LMC(
 tolMaxMatCond_LMC * a_tolMaxMatCond_LMC)
{
  if (a_tolMaxMatCond_LMC->get_lim())
    {
      if (!findString("lim", tolMaxMatCond_LMCAtts))
	{warnAtt("lim", "tolMaxMatCond_LMC", a_tolMaxMatCond_LMC);}
      else
        check_rentVal(a_tolMaxMatCond_LMC->get_lim());
    }
}

/********************************************************************/

void check_tolMaxMatCond_MMC(
 tolMaxMatCond_MMC * a_tolMaxMatCond_MMC)
{
  if (a_tolMaxMatCond_MMC->get_lim())
    {
      if (!findString("lim", tolMaxMatCond_MMCAtts))
	{warnAtt("lim", "tolMaxMatCond_MMC", a_tolMaxMatCond_MMC);}
      else
        check_rentVal(a_tolMaxMatCond_MMC->get_lim());
    }
}

/********************************************************************/

void check_tolParlelStm(
 tolParlelStm * a_tolParlelStm)
{
  if (a_tolParlelStm->get_tLabel())
    {
      if (!findString("a_tLabel", tolParlelStmAtts))
	{warnAtt("a_tLabel", "tolParlelStm", a_tolParlelStm);}
      else
        check_tLabel(a_tolParlelStm->get_tLabel());
    }
  if (a_tolParlelStm->get_tolAppData())
    {
      if (!findString("a_tolAppData", tolParlelStmAtts))
	{warnAtt("a_tolAppData", "tolParlelStm", a_tolParlelStm);}
      else
        check_tolAppData(a_tolParlelStm->get_tolAppData());
    }
}

/********************************************************************/

void check_tolPerpStm(
 tolPerpStm * a_tolPerpStm)
{
  if (a_tolPerpStm->get_tLabel())
    {
      if (!findString("a_tLabel", tolPerpStmAtts))
	{warnAtt("a_tLabel", "tolPerpStm", a_tolPerpStm);}
      else
        check_tLabel(a_tolPerpStm->get_tLabel());
    }
  if (a_tolPerpStm->get_tolAppData())
    {
      if (!findString("a_tolAppData", tolPerpStmAtts))
	{warnAtt("a_tolAppData", "tolPerpStm", a_tolPerpStm);}
      else
        check_tolAppData(a_tolPerpStm->get_tolAppData());
    }
}

/********************************************************************/

void check_tolPosEnd(
 tolPosEnd * a_tolPosEnd)
{
  if (a_tolPosEnd->get_tolMatCond())
    {
      if (!findString("a_tolMatCond", tolPosEndAtts))
	{warnAtt("a_tolMatCond", "tolPosEnd", a_tolPosEnd);}
      else
        check_tolMatCond(a_tolPosEnd->get_tolMatCond());
    }
  if (a_tolPosEnd->get_tfm1())
    {
      if (!findString("tfm1", tolPosEndAtts))
	{warnAtt("tfm1", "tolPosEnd", a_tolPosEnd);}
      else
        check_tolFeatureMat(a_tolPosEnd->get_tfm1());
    }
  if (a_tolPosEnd->get_tfm2())
    {
      if (!findString("tfm2", tolPosEndAtts))
	{warnAtt("tfm2", "tolPosEnd", a_tolPosEnd);}
      else
        check_tolFeatureMat(a_tolPosEnd->get_tfm2());
    }
  if (a_tolPosEnd->get_tfm3())
    {
      if (!findString("tfm3", tolPosEndAtts))
	{warnAtt("tfm3", "tolPosEnd", a_tolPosEnd);}
      else
        check_tolFeatureMat(a_tolPosEnd->get_tfm3());
    }
  if (a_tolPosEnd->get_tolPosMethod())
    {
      if (!findString("a_tolPosMethod", tolPosEndAtts))
	{warnAtt("a_tolPosMethod", "tolPosEnd", a_tolPosEnd);}
      else
        check_tolPosMethod(a_tolPosEnd->get_tolPosMethod());
    }
}

/********************************************************************/

void check_tolPosMethod(
 tolPosMethod * a_tolPosMethod)
{
  if (isA(a_tolPosMethod, tolPosMethod_XAXIS))
    {
      if (!findString("tolPosMethod_XAXIS", tolPosMethodSubs))
        {warnSub("tolPosMethod_XAXIS", "tolPosMethod", a_tolPosMethod);}
      return;
    }
  if (isA(a_tolPosMethod, tolPosMethod_YAXIS))
    {
      if (!findString("tolPosMethod_YAXIS", tolPosMethodSubs))
        {warnSub("tolPosMethod_YAXIS", "tolPosMethod", a_tolPosMethod);}
      return;
    }
  if (isA(a_tolPosMethod, tolPosMethod_ZAXIS))
    {
      if (!findString("tolPosMethod_ZAXIS", tolPosMethodSubs))
        {warnSub("tolPosMethod_ZAXIS", "tolPosMethod", a_tolPosMethod);}
      return;
    }
  if (isA(a_tolPosMethod, tolPosMethod_RADIAL))
    {
      if (!findString("tolPosMethod_RADIAL", tolPosMethodSubs))
        {warnSub("tolPosMethod_RADIAL", "tolPosMethod", a_tolPosMethod);}
      return;
    }
  if (isA(a_tolPosMethod, tolPosMethod_ANGLE))
    {
      if (!findString("tolPosMethod_ANGLE", tolPosMethodSubs))
        {warnSub("tolPosMethod_ANGLE", "tolPosMethod", a_tolPosMethod);}
      return;
    }
  if (isA(a_tolPosMethod, tolPosMethod_VEC))
    {
      if (!findString("tolPosMethod_VEC", tolPosMethodSubs))
        {warnSub("tolPosMethod_VEC", "tolPosMethod", a_tolPosMethod);}
      else
        check_tolPosMethod_VEC(dynamic_cast<tolPosMethod_VEC *>(a_tolPosMethod));
      return;
    }
}

/********************************************************************/

void check_tolPosMethod_VEC(
 tolPosMethod_VEC * a_tolPosMethod_VEC)
{
  if (a_tolPosMethod_VEC->get_dir())
    {
      if (!findString("dir", tolPosMethod_VECAtts))
	{warnAtt("dir", "tolPosMethod_VEC", a_tolPosMethod_VEC);}
      else
        check_vector(a_tolPosMethod_VEC->get_dir());
    }
}

/********************************************************************/

void check_tolPosStart(
 tolPosStart * a_tolPosStart)
{
  if (isA(a_tolPosStart, tolPosStart_TWOD))
    {
      if (!findString("tolPosStart_TWOD", tolPosStartSubs))
        {warnSub("tolPosStart_TWOD", "tolPosStart", a_tolPosStart);}
      else
        check_tolPosStart_TWOD(dynamic_cast<tolPosStart_TWOD *>(a_tolPosStart));
      return;
    }
  if (isA(a_tolPosStart, tolPosStart_THREED))
    {
      if (!findString("tolPosStart_THREED", tolPosStartSubs))
        {warnSub("tolPosStart_THREED", "tolPosStart", a_tolPosStart);}
      else
        check_tolPosStart_THREED(dynamic_cast<tolPosStart_THREED *>(a_tolPosStart));
      return;
    }
}

/********************************************************************/

void check_tolPosStart_THREED(
 tolPosStart_THREED * a_tolPosStart_THREED)
{
  if (a_tolPosStart_THREED->get_tolzon())
    {
      if (!findString("tolzon", tolPosStart_THREEDAtts))
	{warnAtt("tolzon", "tolPosStart_THREED", a_tolPosStart_THREED);}
      else
        check_rentVal(a_tolPosStart_THREED->get_tolzon());
    }
}

/********************************************************************/

void check_tolPosStart_TWOD(
 tolPosStart_TWOD * a_tolPosStart_TWOD)
{
  if (a_tolPosStart_TWOD->get_tolzon())
    {
      if (!findString("tolzon", tolPosStart_TWODAtts))
	{warnAtt("tolzon", "tolPosStart_TWOD", a_tolPosStart_TWOD);}
      else
        check_rentVal(a_tolPosStart_TWOD->get_tolzon());
    }
}

/********************************************************************/

void check_tolPosStm(
 tolPosStm * a_tolPosStm)
{
  if (a_tolPosStm->get_tLabel())
    {
      if (!findString("a_tLabel", tolPosStmAtts))
	{warnAtt("a_tLabel", "tolPosStm", a_tolPosStm);}
      else
        check_tLabel(a_tolPosStm->get_tLabel());
    }
  if (a_tolPosStm->get_tolPosStart())
    {
      if (!findString("a_tolPosStart", tolPosStmAtts))
	{warnAtt("a_tolPosStart", "tolPosStm", a_tolPosStm);}
      else
        check_tolPosStart(a_tolPosStm->get_tolPosStart());
    }
  if (a_tolPosStm->get_tolPosEnd())
    {
      if (!findString("a_tolPosEnd", tolPosStmAtts))
	{warnAtt("a_tolPosEnd", "tolPosStm", a_tolPosStm);}
      else
        check_tolPosEnd(a_tolPosStm->get_tolPosEnd());
    }
}

/********************************************************************/

void check_tolProflStm(
 tolProflStm * a_tolProflStm)
{
  if (a_tolProflStm->get_tLabel())
    {
      if (!findString("a_tLabel", tolProflStmAtts))
	{warnAtt("a_tLabel", "tolProflStm", a_tolProflStm);}
      else
        check_tLabel(a_tolProflStm->get_tLabel());
    }
  if (a_tolProflStm->get_lotol())
    {
      if (!findString("lotol", tolProflStmAtts))
	{warnAtt("lotol", "tolProflStm", a_tolProflStm);}
      else
        check_rentVal(a_tolProflStm->get_lotol());
    }
  if (a_tolProflStm->get_uptol())
    {
      if (!findString("uptol", tolProflStmAtts))
	{warnAtt("uptol", "tolProflStm", a_tolProflStm);}
      else
        check_rentVal(a_tolProflStm->get_uptol());
    }
  if (a_tolProflStm->get_tfm1())
    {
      if (!findString("tfm1", tolProflStmAtts))
	{warnAtt("tfm1", "tolProflStm", a_tolProflStm);}
      else
        check_tolFeatureMat(a_tolProflStm->get_tfm1());
    }
  if (a_tolProflStm->get_tfm2())
    {
      if (!findString("tfm2", tolProflStmAtts))
	{warnAtt("tfm2", "tolProflStm", a_tolProflStm);}
      else
        check_tolFeatureMat(a_tolProflStm->get_tfm2());
    }
  if (a_tolProflStm->get_tfm3())
    {
      if (!findString("tfm3", tolProflStmAtts))
	{warnAtt("tfm3", "tolProflStm", a_tolProflStm);}
      else
        check_tolFeatureMat(a_tolProflStm->get_tfm3());
    }
  if (a_tolProflStm->get_tolZoneDir2())
    {
      if (!findString("a_tolZoneDir2", tolProflStmAtts))
	{warnAtt("a_tolZoneDir2", "tolProflStm", a_tolProflStm);}
      else
        check_tolZoneDir2(a_tolProflStm->get_tolZoneDir2());
    }
}

/********************************************************************/

void check_tolProfpStm(
 tolProfpStm * a_tolProfpStm)
{
  if (a_tolProfpStm->get_tLabel())
    {
      if (!findString("a_tLabel", tolProfpStmAtts))
	{warnAtt("a_tLabel", "tolProfpStm", a_tolProfpStm);}
      else
        check_tLabel(a_tolProfpStm->get_tLabel());
    }
  if (a_tolProfpStm->get_lotol())
    {
      if (!findString("lotol", tolProfpStmAtts))
	{warnAtt("lotol", "tolProfpStm", a_tolProfpStm);}
      else
        check_rentVal(a_tolProfpStm->get_lotol());
    }
  if (a_tolProfpStm->get_uptol())
    {
      if (!findString("uptol", tolProfpStmAtts))
	{warnAtt("uptol", "tolProfpStm", a_tolProfpStm);}
      else
        check_rentVal(a_tolProfpStm->get_uptol());
    }
  if (a_tolProfpStm->get_tfm1())
    {
      if (!findString("tfm1", tolProfpStmAtts))
	{warnAtt("tfm1", "tolProfpStm", a_tolProfpStm);}
      else
        check_tolFeatureMat(a_tolProfpStm->get_tfm1());
    }
  if (a_tolProfpStm->get_tfm2())
    {
      if (!findString("tfm2", tolProfpStmAtts))
	{warnAtt("tfm2", "tolProfpStm", a_tolProfpStm);}
      else
        check_tolFeatureMat(a_tolProfpStm->get_tfm2());
    }
  if (a_tolProfpStm->get_tfm3())
    {
      if (!findString("tfm3", tolProfpStmAtts))
	{warnAtt("tfm3", "tolProfpStm", a_tolProfpStm);}
      else
        check_tolFeatureMat(a_tolProfpStm->get_tfm3());
    }
}

/********************************************************************/

void check_tolProfsStm(
 tolProfsStm * a_tolProfsStm)
{
  if (a_tolProfsStm->get_tLabel())
    {
      if (!findString("a_tLabel", tolProfsStmAtts))
	{warnAtt("a_tLabel", "tolProfsStm", a_tolProfsStm);}
      else
        check_tLabel(a_tolProfsStm->get_tLabel());
    }
  if (a_tolProfsStm->get_lotol())
    {
      if (!findString("lotol", tolProfsStmAtts))
	{warnAtt("lotol", "tolProfsStm", a_tolProfsStm);}
      else
        check_rentVal(a_tolProfsStm->get_lotol());
    }
  if (a_tolProfsStm->get_uptol())
    {
      if (!findString("uptol", tolProfsStmAtts))
	{warnAtt("uptol", "tolProfsStm", a_tolProfsStm);}
      else
        check_rentVal(a_tolProfsStm->get_uptol());
    }
  if (a_tolProfsStm->get_tfm1())
    {
      if (!findString("tfm1", tolProfsStmAtts))
	{warnAtt("tfm1", "tolProfsStm", a_tolProfsStm);}
      else
        check_tolFeatureMat(a_tolProfsStm->get_tfm1());
    }
  if (a_tolProfsStm->get_tfm2())
    {
      if (!findString("tfm2", tolProfsStmAtts))
	{warnAtt("tfm2", "tolProfsStm", a_tolProfsStm);}
      else
        check_tolFeatureMat(a_tolProfsStm->get_tfm2());
    }
  if (a_tolProfsStm->get_tfm3())
    {
      if (!findString("tfm3", tolProfsStmAtts))
	{warnAtt("tfm3", "tolProfsStm", a_tolProfsStm);}
      else
        check_tolFeatureMat(a_tolProfsStm->get_tfm3());
    }
  if (a_tolProfsStm->get_has_AVGDEV())
    {
      if (!findString("has_AVGDEV", tolProfsStmAtts))
	{warnAtt("has_AVGDEV", "tolProfsStm", a_tolProfsStm);}
    }
}

/********************************************************************/

void check_tolRadSpec(
 tolRadSpec * a_tolRadSpec)
{
  if (isA(a_tolRadSpec, tolRadSpec_AVG))
    {
      if (!findString("tolRadSpec_AVG", tolRadSpecSubs))
        {warnSub("tolRadSpec_AVG", "tolRadSpec", a_tolRadSpec);}
      return;
    }
  if (isA(a_tolRadSpec, tolRadSpec_CRAD))
    {
      if (!findString("tolRadSpec_CRAD", tolRadSpecSubs))
        {warnSub("tolRadSpec_CRAD", "tolRadSpec", a_tolRadSpec);}
      return;
    }
}

/********************************************************************/

void check_tolRadStm(
 tolRadStm * a_tolRadStm)
{
  if (a_tolRadStm->get_tLabel())
    {
      if (!findString("a_tLabel", tolRadStmAtts))
	{warnAtt("a_tLabel", "tolRadStm", a_tolRadStm);}
      else
        check_tLabel(a_tolRadStm->get_tLabel());
    }
  if (a_tolRadStm->get_lotol())
    {
      if (!findString("lotol", tolRadStmAtts))
	{warnAtt("lotol", "tolRadStm", a_tolRadStm);}
      else
        check_rentVal(a_tolRadStm->get_lotol());
    }
  if (a_tolRadStm->get_uptol())
    {
      if (!findString("uptol", tolRadStmAtts))
	{warnAtt("uptol", "tolRadStm", a_tolRadStm);}
      else
        check_rentVal(a_tolRadStm->get_uptol());
    }
  if (a_tolRadStm->get_tolRadSpec())
    {
      if (!findString("a_tolRadSpec", tolRadStmAtts))
	{warnAtt("a_tolRadSpec", "tolRadStm", a_tolRadStm);}
      else
        check_tolRadSpec(a_tolRadStm->get_tolRadSpec());
    }
  if (a_tolRadStm->get_has_MINMAX())
    {
      if (!findString("has_MINMAX", tolRadStmAtts))
	{warnAtt("has_MINMAX", "tolRadStm", a_tolRadStm);}
    }
}

/********************************************************************/

void check_tolStrghtMat(
 tolStrghtMat * a_tolStrghtMat)
{
  if (a_tolStrghtMat->get_tolzon())
    {
      if (!findString("tolzon", tolStrghtMatAtts))
	{warnAtt("tolzon", "tolStrghtMat", a_tolStrghtMat);}
      else
        check_rentVal(a_tolStrghtMat->get_tolzon());
    }
  if (a_tolStrghtMat->get_tolMatCond())
    {
      if (!findString("a_tolMatCond", tolStrghtMatAtts))
	{warnAtt("a_tolMatCond", "tolStrghtMat", a_tolStrghtMat);}
      else
        check_tolMatCond(a_tolStrghtMat->get_tolMatCond());
    }
  if (a_tolStrghtMat->get_axis())
    {
      if (!findString("a_axis", tolStrghtMatAtts))
	{warnAtt("a_axis", "tolStrghtMat", a_tolStrghtMat);}
      else
        check_axis(a_tolStrghtMat->get_axis());
    }
  if (a_tolStrghtMat->get_tolZoneDir3())
    {
      if (!findString("a_tolZoneDir3", tolStrghtMatAtts))
	{warnAtt("a_tolZoneDir3", "tolStrghtMat", a_tolStrghtMat);}
      else
        check_tolZoneDir3(a_tolStrghtMat->get_tolZoneDir3());
    }
}

/********************************************************************/

void check_tolStrghtMinor(
 tolStrghtMinor * a_tolStrghtMinor)
{
  if (isA(a_tolStrghtMinor, tolStrghtPlain))
    {
      if (!findString("tolStrghtPlain", tolStrghtMinorSubs))
        {warnSub("tolStrghtPlain", "tolStrghtMinor", a_tolStrghtMinor);}
      else
        check_tolStrghtPlain(dynamic_cast<tolStrghtPlain *>(a_tolStrghtMinor));
      return;
    }
  if (isA(a_tolStrghtMinor, tolStrghtMat))
    {
      if (!findString("tolStrghtMat", tolStrghtMinorSubs))
        {warnSub("tolStrghtMat", "tolStrghtMinor", a_tolStrghtMinor);}
      else
        check_tolStrghtMat(dynamic_cast<tolStrghtMat *>(a_tolStrghtMinor));
      return;
    }
  if (isA(a_tolStrghtMinor, tolStrghtPer1))
    {
      if (!findString("tolStrghtPer1", tolStrghtMinorSubs))
        {warnSub("tolStrghtPer1", "tolStrghtMinor", a_tolStrghtMinor);}
      else
        check_tolStrghtPer1(dynamic_cast<tolStrghtPer1 *>(a_tolStrghtMinor));
      return;
    }
  if (isA(a_tolStrghtMinor, tolStrghtPer2))
    {
      if (!findString("tolStrghtPer2", tolStrghtMinorSubs))
        {warnSub("tolStrghtPer2", "tolStrghtMinor", a_tolStrghtMinor);}
      else
        check_tolStrghtPer2(dynamic_cast<tolStrghtPer2 *>(a_tolStrghtMinor));
      return;
    }
}

/********************************************************************/

void check_tolStrghtPer1(
 tolStrghtPer1 * a_tolStrghtPer1)
{
  if (a_tolStrghtPer1->get_tolzon())
    {
      if (!findString("tolzon", tolStrghtPer1Atts))
	{warnAtt("tolzon", "tolStrghtPer1", a_tolStrghtPer1);}
      else
        check_rentVal(a_tolStrghtPer1->get_tolzon());
    }
  if (a_tolStrghtPer1->get_unit())
    {
      if (!findString("unit", tolStrghtPer1Atts))
	{warnAtt("unit", "tolStrghtPer1", a_tolStrghtPer1);}
      else
        check_rentVal(a_tolStrghtPer1->get_unit());
    }
  if (a_tolStrghtPer1->get_axis())
    {
      if (!findString("a_axis", tolStrghtPer1Atts))
	{warnAtt("a_axis", "tolStrghtPer1", a_tolStrghtPer1);}
      else
        check_axis(a_tolStrghtPer1->get_axis());
    }
  if (a_tolStrghtPer1->get_tolZoneDir3())
    {
      if (!findString("a_tolZoneDir3", tolStrghtPer1Atts))
	{warnAtt("a_tolZoneDir3", "tolStrghtPer1", a_tolStrghtPer1);}
      else
        check_tolZoneDir3(a_tolStrghtPer1->get_tolZoneDir3());
    }
}

/********************************************************************/

void check_tolStrghtPer2(
 tolStrghtPer2 * a_tolStrghtPer2)
{
  if (a_tolStrghtPer2->get_tolzon())
    {
      if (!findString("tolzon", tolStrghtPer2Atts))
	{warnAtt("tolzon", "tolStrghtPer2", a_tolStrghtPer2);}
      else
        check_rentVal(a_tolStrghtPer2->get_tolzon());
    }
  if (a_tolStrghtPer2->get_tolzon1())
    {
      if (!findString("tolzon1", tolStrghtPer2Atts))
	{warnAtt("tolzon1", "tolStrghtPer2", a_tolStrghtPer2);}
      else
        check_rentVal(a_tolStrghtPer2->get_tolzon1());
    }
  if (a_tolStrghtPer2->get_unit())
    {
      if (!findString("unit", tolStrghtPer2Atts))
	{warnAtt("unit", "tolStrghtPer2", a_tolStrghtPer2);}
      else
        check_rentVal(a_tolStrghtPer2->get_unit());
    }
  if (a_tolStrghtPer2->get_axis())
    {
      if (!findString("a_axis", tolStrghtPer2Atts))
	{warnAtt("a_axis", "tolStrghtPer2", a_tolStrghtPer2);}
      else
        check_axis(a_tolStrghtPer2->get_axis());
    }
  if (a_tolStrghtPer2->get_tolZoneDir3())
    {
      if (!findString("a_tolZoneDir3", tolStrghtPer2Atts))
	{warnAtt("a_tolZoneDir3", "tolStrghtPer2", a_tolStrghtPer2);}
      else
        check_tolZoneDir3(a_tolStrghtPer2->get_tolZoneDir3());
    }
}

/********************************************************************/

void check_tolStrghtPlain(
 tolStrghtPlain * a_tolStrghtPlain)
{
  if (a_tolStrghtPlain->get_tolzon())
    {
      if (!findString("tolzon", tolStrghtPlainAtts))
	{warnAtt("tolzon", "tolStrghtPlain", a_tolStrghtPlain);}
      else
        check_rentVal(a_tolStrghtPlain->get_tolzon());
    }
  if (a_tolStrghtPlain->get_axis())
    {
      if (!findString("a_axis", tolStrghtPlainAtts))
	{warnAtt("a_axis", "tolStrghtPlain", a_tolStrghtPlain);}
      else
        check_axis(a_tolStrghtPlain->get_axis());
    }
  if (a_tolStrghtPlain->get_tolZoneDir3())
    {
      if (!findString("a_tolZoneDir3", tolStrghtPlainAtts))
	{warnAtt("a_tolZoneDir3", "tolStrghtPlain", a_tolStrghtPlain);}
      else
        check_tolZoneDir3(a_tolStrghtPlain->get_tolZoneDir3());
    }
}

/********************************************************************/

void check_tolStrghtStm(
 tolStrghtStm * a_tolStrghtStm)
{
  if (a_tolStrghtStm->get_tLabel())
    {
      if (!findString("a_tLabel", tolStrghtStmAtts))
	{warnAtt("a_tLabel", "tolStrghtStm", a_tolStrghtStm);}
      else
        check_tLabel(a_tolStrghtStm->get_tLabel());
    }
  if (a_tolStrghtStm->get_tolStrghtMinor())
    {
      if (!findString("a_tolStrghtMinor", tolStrghtStmAtts))
	{warnAtt("a_tolStrghtMinor", "tolStrghtStm", a_tolStrghtStm);}
      else
        check_tolStrghtMinor(a_tolStrghtStm->get_tolStrghtMinor());
    }
}

/********************************************************************/

void check_tolSymStm(
 tolSymStm * a_tolSymStm)
{
  if (a_tolSymStm->get_tLabel())
    {
      if (!findString("a_tLabel", tolSymStmAtts))
	{warnAtt("a_tLabel", "tolSymStm", a_tolSymStm);}
      else
        check_tLabel(a_tolSymStm->get_tLabel());
    }
  if (a_tolSymStm->get_tolzon())
    {
      if (!findString("tolzon", tolSymStmAtts))
	{warnAtt("tolzon", "tolSymStm", a_tolSymStm);}
      else
        check_rentVal(a_tolSymStm->get_tolzon());
    }
  if (a_tolSymStm->get_tolFeatureMat())
    {
      if (!findString("a_tolFeatureMat", tolSymStmAtts))
	{warnAtt("a_tolFeatureMat", "tolSymStm", a_tolSymStm);}
      else
        check_tolFeatureMat(a_tolSymStm->get_tolFeatureMat());
    }
  if (a_tolSymStm->get_tolZoneDir3())
    {
      if (!findString("a_tolZoneDir3", tolSymStmAtts))
	{warnAtt("a_tolZoneDir3", "tolSymStm", a_tolSymStm);}
      else
        check_tolZoneDir3(a_tolSymStm->get_tolZoneDir3());
    }
}

/********************************************************************/

void check_tolTrnoutStm(
 tolTrnoutStm * a_tolTrnoutStm)
{
  if (a_tolTrnoutStm->get_tLabel())
    {
      if (!findString("a_tLabel", tolTrnoutStmAtts))
	{warnAtt("a_tLabel", "tolTrnoutStm", a_tolTrnoutStm);}
      else
        check_tLabel(a_tolTrnoutStm->get_tLabel());
    }
  if (a_tolTrnoutStm->get_tolzon())
    {
      if (!findString("tolzon", tolTrnoutStmAtts))
	{warnAtt("tolzon", "tolTrnoutStm", a_tolTrnoutStm);}
      else
        check_rentVal(a_tolTrnoutStm->get_tolzon());
    }
  if (a_tolTrnoutStm->get_datLabel())
    {
      if (!findString("a_datLabel", tolTrnoutStmAtts))
	{warnAtt("a_datLabel", "tolTrnoutStm", a_tolTrnoutStm);}
      else
        check_datLabel(a_tolTrnoutStm->get_datLabel());
    }
  if (a_tolTrnoutStm->get_tolFeat1())
    {
      if (!findString("tolFeat1", tolTrnoutStmAtts))
	{warnAtt("tolFeat1", "tolTrnoutStm", a_tolTrnoutStm);}
      else
        check_tolFeature(a_tolTrnoutStm->get_tolFeat1());
    }
  if (a_tolTrnoutStm->get_tolFeat2())
    {
      if (!findString("tolFeat2", tolTrnoutStmAtts))
	{warnAtt("tolFeat2", "tolTrnoutStm", a_tolTrnoutStm);}
      else
        check_tolFeature(a_tolTrnoutStm->get_tolFeat2());
    }
}

/********************************************************************/

void check_tolUsetolStm(
 tolUsetolStm * a_tolUsetolStm)
{
  if (a_tolUsetolStm->get_tLabel())
    {
      if (!findString("a_tLabel", tolUsetolStmAtts))
	{warnAtt("a_tLabel", "tolUsetolStm", a_tolUsetolStm);}
      else
        check_tLabel(a_tolUsetolStm->get_tLabel());
    }
  if (a_tolUsetolStm->get_text())
    {
      if (!findString("text", tolUsetolStmAtts))
	{warnAtt("text", "tolUsetolStm", a_tolUsetolStm);}
      else
        check_stringVal(a_tolUsetolStm->get_text());
    }
}

/********************************************************************/

void check_tolWidthDir(
 tolWidthDir * a_tolWidthDir)
{
  if (isA(a_tolWidthDir, tolWidthDir_vector))
    {
      if (!findString("tolWidthDir_vector", tolWidthDirSubs))
        {warnSub("tolWidthDir_vector", "tolWidthDir", a_tolWidthDir);}
      else
        check_tolWidthDir_vector(dynamic_cast<tolWidthDir_vector *>(a_tolWidthDir));
      return;
    }
  if (isA(a_tolWidthDir, tolWidthDir_SHORT))
    {
      if (!findString("tolWidthDir_SHORT", tolWidthDirSubs))
        {warnSub("tolWidthDir_SHORT", "tolWidthDir", a_tolWidthDir);}
      return;
    }
  if (isA(a_tolWidthDir, tolWidthDir_LONG))
    {
      if (!findString("tolWidthDir_LONG", tolWidthDirSubs))
        {warnSub("tolWidthDir_LONG", "tolWidthDir", a_tolWidthDir);}
      return;
    }
}

/********************************************************************/

void check_tolWidthDir_vector(
 tolWidthDir_vector * a_tolWidthDir_vector)
{
  if (a_tolWidthDir_vector->get_dir())
    {
      if (!findString("dir", tolWidthDir_vectorAtts))
	{warnAtt("dir", "tolWidthDir_vector", a_tolWidthDir_vector);}
      else
        check_vector(a_tolWidthDir_vector->get_dir());
    }
}

/********************************************************************/

void check_tolWidthStm(
 tolWidthStm * a_tolWidthStm)
{
  if (a_tolWidthStm->get_tLabel())
    {
      if (!findString("a_tLabel", tolWidthStmAtts))
	{warnAtt("a_tLabel", "tolWidthStm", a_tolWidthStm);}
      else
        check_tLabel(a_tolWidthStm->get_tLabel());
    }
  if (a_tolWidthStm->get_lotol())
    {
      if (!findString("lotol", tolWidthStmAtts))
	{warnAtt("lotol", "tolWidthStm", a_tolWidthStm);}
      else
        check_rentVal(a_tolWidthStm->get_lotol());
    }
  if (a_tolWidthStm->get_uptol())
    {
      if (!findString("uptol", tolWidthStmAtts))
	{warnAtt("uptol", "tolWidthStm", a_tolWidthStm);}
      else
        check_rentVal(a_tolWidthStm->get_uptol());
    }
  if (a_tolWidthStm->get_tolWidthDir())
    {
      if (!findString("a_tolWidthDir", tolWidthStmAtts))
	{warnAtt("a_tolWidthDir", "tolWidthStm", a_tolWidthStm);}
      else
        check_tolWidthDir(a_tolWidthStm->get_tolWidthDir());
    }
  if (a_tolWidthStm->get_has_MINMAX())
    {
      if (!findString("has_MINMAX", tolWidthStmAtts))
	{warnAtt("has_MINMAX", "tolWidthStm", a_tolWidthStm);}
    }
}

/********************************************************************/

void check_tolZoneDir(
 tolZoneDir * a_tolZoneDir)
{
  if (isA(a_tolZoneDir, tolZoneDir_XAXIS))
    {
      if (!findString("tolZoneDir_XAXIS", tolZoneDirSubs))
        {warnSub("tolZoneDir_XAXIS", "tolZoneDir", a_tolZoneDir);}
      return;
    }
  if (isA(a_tolZoneDir, tolZoneDir_YAXIS))
    {
      if (!findString("tolZoneDir_YAXIS", tolZoneDirSubs))
        {warnSub("tolZoneDir_YAXIS", "tolZoneDir", a_tolZoneDir);}
      return;
    }
  if (isA(a_tolZoneDir, tolZoneDir_ZAXIS))
    {
      if (!findString("tolZoneDir_ZAXIS", tolZoneDirSubs))
        {warnSub("tolZoneDir_ZAXIS", "tolZoneDir", a_tolZoneDir);}
      return;
    }
  if (isA(a_tolZoneDir, tolZoneDir_VEC))
    {
      if (!findString("tolZoneDir_VEC", tolZoneDirSubs))
        {warnSub("tolZoneDir_VEC", "tolZoneDir", a_tolZoneDir);}
      else
        check_tolZoneDir_VEC(dynamic_cast<tolZoneDir_VEC *>(a_tolZoneDir));
      return;
    }
}

/********************************************************************/

void check_tolZoneDir2(
 tolZoneDir2 * a_tolZoneDir2)
{
  if (isA(a_tolZoneDir2, tolZoneDir2_XYPLAN))
    {
      if (!findString("tolZoneDir2_XYPLAN", tolZoneDir2Subs))
        {warnSub("tolZoneDir2_XYPLAN", "tolZoneDir2", a_tolZoneDir2);}
      return;
    }
  if (isA(a_tolZoneDir2, tolZoneDir2_YZPLAN))
    {
      if (!findString("tolZoneDir2_YZPLAN", tolZoneDir2Subs))
        {warnSub("tolZoneDir2_YZPLAN", "tolZoneDir2", a_tolZoneDir2);}
      return;
    }
  if (isA(a_tolZoneDir2, tolZoneDir2_ZXPLAN))
    {
      if (!findString("tolZoneDir2_ZXPLAN", tolZoneDir2Subs))
        {warnSub("tolZoneDir2_ZXPLAN", "tolZoneDir2", a_tolZoneDir2);}
      return;
    }
  if (isA(a_tolZoneDir2, tolZoneDir2_VEC))
    {
      if (!findString("tolZoneDir2_VEC", tolZoneDir2Subs))
        {warnSub("tolZoneDir2_VEC", "tolZoneDir2", a_tolZoneDir2);}
      else
        check_tolZoneDir2_VEC(dynamic_cast<tolZoneDir2_VEC *>(a_tolZoneDir2));
      return;
    }
}

/********************************************************************/

void check_tolZoneDir2_VEC(
 tolZoneDir2_VEC * a_tolZoneDir2_VEC)
{
  if (a_tolZoneDir2_VEC->get_planeVec())
    {
      if (!findString("planeVec", tolZoneDir2_VECAtts))
	{warnAtt("planeVec", "tolZoneDir2_VEC", a_tolZoneDir2_VEC);}
      else
        check_vector(a_tolZoneDir2_VEC->get_planeVec());
    }
}

/********************************************************************/

void check_tolZoneDir3(
 tolZoneDir3 * a_tolZoneDir3)
{
  if (isA(a_tolZoneDir3, tolZoneDir3_XDIR))
    {
      if (!findString("tolZoneDir3_XDIR", tolZoneDir3Subs))
        {warnSub("tolZoneDir3_XDIR", "tolZoneDir3", a_tolZoneDir3);}
      return;
    }
  if (isA(a_tolZoneDir3, tolZoneDir3_YDIR))
    {
      if (!findString("tolZoneDir3_YDIR", tolZoneDir3Subs))
        {warnSub("tolZoneDir3_YDIR", "tolZoneDir3", a_tolZoneDir3);}
      return;
    }
  if (isA(a_tolZoneDir3, tolZoneDir3_ZDIR))
    {
      if (!findString("tolZoneDir3_ZDIR", tolZoneDir3Subs))
        {warnSub("tolZoneDir3_ZDIR", "tolZoneDir3", a_tolZoneDir3);}
      return;
    }
  if (isA(a_tolZoneDir3, tolZoneDir3_VEC))
    {
      if (!findString("tolZoneDir3_VEC", tolZoneDir3Subs))
        {warnSub("tolZoneDir3_VEC", "tolZoneDir3", a_tolZoneDir3);}
      else
        check_tolZoneDir3_VEC(dynamic_cast<tolZoneDir3_VEC *>(a_tolZoneDir3));
      return;
    }
}

/********************************************************************/

void check_tolZoneDir3_VEC(
 tolZoneDir3_VEC * a_tolZoneDir3_VEC)
{
  if (a_tolZoneDir3_VEC->get_dir())
    {
      if (!findString("dir", tolZoneDir3_VECAtts))
	{warnAtt("dir", "tolZoneDir3_VEC", a_tolZoneDir3_VEC);}
      else
        check_vector(a_tolZoneDir3_VEC->get_dir());
    }
}

/********************************************************************/

void check_tolZoneDir_VEC(
 tolZoneDir_VEC * a_tolZoneDir_VEC)
{
  if (a_tolZoneDir_VEC->get_dir())
    {
      if (!findString("dir", tolZoneDir_VECAtts))
	{warnAtt("dir", "tolZoneDir_VEC", a_tolZoneDir_VEC);}
      else
        check_vector(a_tolZoneDir_VEC->get_dir());
    }
}

/********************************************************************/

void check_tolZoneType(
 tolZoneType * a_tolZoneType)
{
  if (isA(a_tolZoneType, tolZoneType_TANGPL))
    {
      if (!findString("tolZoneType_TANGPL", tolZoneTypeSubs))
        {warnSub("tolZoneType_TANGPL", "tolZoneType", a_tolZoneType);}
      return;
    }
  if (isA(a_tolZoneType, tolZoneType_PARPLN))
    {
      if (!findString("tolZoneType_PARPLN", tolZoneTypeSubs))
        {warnSub("tolZoneType_PARPLN", "tolZoneType", a_tolZoneType);}
      return;
    }
}

/********************************************************************/

void check_toleranceLabel(
 toleranceLabel * a_toleranceLabel)
{
  if (isA(a_toleranceLabel, tLabel))
    {
      if (!findString("tLabel", toleranceLabelSubs))
        {warnSub("tLabel", "toleranceLabel", a_toleranceLabel);}
      else
        check_tLabel(dynamic_cast<tLabel *>(a_toleranceLabel));
      return;
    }
  if (isA(a_toleranceLabel, taLabel))
    {
      if (!findString("taLabel", toleranceLabelSubs))
        {warnSub("taLabel", "toleranceLabel", a_toleranceLabel);}
      else
        check_taLabel(dynamic_cast<taLabel *>(a_toleranceLabel));
      return;
    }
}

/********************************************************************/

void check_tooldfStm(
 tooldfStm * a_tooldfStm)
{
  if (a_tooldfStm->get_tlLabel())
    {
      if (!findString("a_tlLabel", tooldfStmAtts))
	{warnAtt("a_tlLabel", "tooldfStm", a_tooldfStm);}
      else
        check_tlLabel(a_tooldfStm->get_tlLabel());
    }
  if (a_tooldfStm->get_mdLabel())
    {
      if (!findString("a_mdLabel", tooldfStmAtts))
	{warnAtt("a_mdLabel", "tooldfStm", a_tooldfStm);}
      else
        check_mdLabel(a_tooldfStm->get_mdLabel());
    }
  if (a_tooldfStm->get_text())
    {
      if (!findString("text", tooldfStmAtts))
	{warnAtt("text", "tooldfStm", a_tooldfStm);}
      else
        check_stringVal(a_tooldfStm->get_text());
    }
}

/********************************************************************/

void check_touchSpec(
 touchSpec * a_touchSpec)
{
  if (isA(a_touchSpec, touchSpec_HEADTOUCH))
    {
      if (!findString("touchSpec_HEADTOUCH", touchSpecSubs))
        {warnSub("touchSpec_HEADTOUCH", "touchSpec", a_touchSpec);}
      return;
    }
  if (isA(a_touchSpec, touchSpec_ALLAXESTOUCH))
    {
      if (!findString("touchSpec_ALLAXESTOUCH", touchSpecSubs))
        {warnSub("touchSpec_ALLAXESTOUCH", "touchSpec", a_touchSpec);}
      return;
    }
}

/********************************************************************/

void check_trConst(
 trConst * a_trConst)
{
  if (a_trConst->get_faLabel())
    {
      if (!findString("a_faLabel", trConstAtts))
	{warnAtt("a_faLabel", "trConst", a_trConst);}
      else
        check_faLabel(a_trConst->get_faLabel());
    }
  if (a_trConst->get_datumLabel())
    {
      if (!findString("a_datumLabel", trConstAtts))
	{warnAtt("a_datumLabel", "trConst", a_trConst);}
      else
        check_datumLabel(a_trConst->get_datumLabel());
    }
}

/********************************************************************/

void check_transDatum(
 transDatum * a_transDatum)
{
  if (a_transDatum->get_orig())
    {
      if (!findString("a_orig", transDatumAtts))
	{warnAtt("a_orig", "transDatum", a_transDatum);}
      else
        check_orig(a_transDatum->get_orig());
    }
  if (a_transDatum->get_datLabel())
    {
      if (!findString("a_datLabel", transDatumAtts))
	{warnAtt("a_datLabel", "transDatum", a_transDatum);}
      else
        check_datLabel(a_transDatum->get_datLabel());
    }
}

/********************************************************************/

void check_transFeature(
 transFeature * a_transFeature)
{
  if (a_transFeature->get_orig())
    {
      if (!findString("a_orig", transFeatureAtts))
	{warnAtt("a_orig", "transFeature", a_transFeature);}
      else
        check_orig(a_transFeature->get_orig());
    }
  if (a_transFeature->get_featureLabel())
    {
      if (!findString("a_featureLabel", transFeatureAtts))
	{warnAtt("a_featureLabel", "transFeature", a_transFeature);}
      else
        check_featureLabel(a_transFeature->get_featureLabel());
    }
}

/********************************************************************/

void check_transMinor(
 transMinor * a_transMinor)
{
  if (isA(a_transMinor, transValue))
    {
      if (!findString("transValue", transMinorSubs))
        {warnSub("transValue", "transMinor", a_transMinor);}
      else
        check_transValue(dynamic_cast<transValue *>(a_transMinor));
      return;
    }
  if (isA(a_transMinor, transFeature))
    {
      if (!findString("transFeature", transMinorSubs))
        {warnSub("transFeature", "transMinor", a_transMinor);}
      else
        check_transFeature(dynamic_cast<transFeature *>(a_transMinor));
      return;
    }
  if (isA(a_transMinor, transDatum))
    {
      if (!findString("transDatum", transMinorSubs))
        {warnSub("transDatum", "transMinor", a_transMinor);}
      else
        check_transDatum(dynamic_cast<transDatum *>(a_transMinor));
      return;
    }
  if (isA(a_transMinor, transProbe))
    {
      if (!findString("transProbe", transMinorSubs))
        {warnSub("transProbe", "transMinor", a_transMinor);}
      else
        check_transProbe(dynamic_cast<transProbe *>(a_transMinor));
      return;
    }
}

/********************************************************************/

void check_transProbe(
 transProbe * a_transProbe)
{
  if (isA(a_transProbe, transProbe_MINUSPRBRAD))
    {
      if (!findString("transProbe_MINUSPRBRAD", transProbeSubs))
        {warnSub("transProbe_MINUSPRBRAD", "transProbe", a_transProbe);}
      else
        check_transProbe_MINUSPRBRAD(dynamic_cast<transProbe_MINUSPRBRAD *>(a_transProbe));
      return;
    }
  if (isA(a_transProbe, transProbe_PRBRAD))
    {
      if (!findString("transProbe_PRBRAD", transProbeSubs))
        {warnSub("transProbe_PRBRAD", "transProbe", a_transProbe);}
      else
        check_transProbe_PRBRAD(dynamic_cast<transProbe_PRBRAD *>(a_transProbe));
      return;
    }
}

/********************************************************************/

void check_transProbe_MINUSPRBRAD(
 transProbe_MINUSPRBRAD * a_transProbe_MINUSPRBRAD)
{
  if (a_transProbe_MINUSPRBRAD->get_orig())
    {
      if (!findString("a_orig", transProbe_MINUSPRBRADAtts))
	{warnAtt("a_orig", "transProbe_MINUSPRBRAD", a_transProbe_MINUSPRBRAD);}
      else
        check_orig(a_transProbe_MINUSPRBRAD->get_orig());
    }
}

/********************************************************************/

void check_transProbe_PRBRAD(
 transProbe_PRBRAD * a_transProbe_PRBRAD)
{
  if (a_transProbe_PRBRAD->get_orig())
    {
      if (!findString("a_orig", transProbe_PRBRADAtts))
	{warnAtt("a_orig", "transProbe_PRBRAD", a_transProbe_PRBRAD);}
      else
        check_orig(a_transProbe_PRBRAD->get_orig());
    }
}

/********************************************************************/

void check_transStm(
 transStm * a_transStm)
{
  if (a_transStm->get_dLabel())
    {
      if (!findString("a_dLabel", transStmAtts))
	{warnAtt("a_dLabel", "transStm", a_transStm);}
      else
        check_dLabel(a_transStm->get_dLabel());
    }
  if (a_transStm->get_tMinor1())
    {
      if (!findString("tMinor1", transStmAtts))
	{warnAtt("tMinor1", "transStm", a_transStm);}
      else
        check_transMinor(a_transStm->get_tMinor1());
    }
  if (a_transStm->get_tMinor2())
    {
      if (!findString("tMinor2", transStmAtts))
	{warnAtt("tMinor2", "transStm", a_transStm);}
      else
        check_transMinor(a_transStm->get_tMinor2());
    }
  if (a_transStm->get_tMinor3())
    {
      if (!findString("tMinor3", transStmAtts))
	{warnAtt("tMinor3", "transStm", a_transStm);}
      else
        check_transMinor(a_transStm->get_tMinor3());
    }
}

/********************************************************************/

void check_transValue(
 transValue * a_transValue)
{
  if (a_transValue->get_orig())
    {
      if (!findString("a_orig", transValueAtts))
	{warnAtt("a_orig", "transValue", a_transValue);}
      else
        check_orig(a_transValue->get_orig());
    }
  if (a_transValue->get_value())
    {
      if (!findString("value", transValueAtts))
	{warnAtt("value", "transValue", a_transValue);}
      else
        check_rentVal(a_transValue->get_value());
    }
}

/********************************************************************/

void check_typePoint(
 typePoint * a_typePoint)
{
  if (isA(a_typePoint, cartPoint))
    {
      if (!findString("cartPoint", typePointSubs))
        {warnSub("cartPoint", "typePoint", a_typePoint);}
      else
        check_cartPoint(dynamic_cast<cartPoint *>(a_typePoint));
      return;
    }
  if (isA(a_typePoint, polPoint))
    {
      if (!findString("polPoint", typePointSubs))
        {warnSub("polPoint", "typePoint", a_typePoint);}
      else
        check_polPoint(dynamic_cast<polPoint *>(a_typePoint));
      return;
    }
}

/********************************************************************/

void check_uLabel(
 uLabel * a_uLabel)
{
  if (a_uLabel->get_labelName())
    {
      if (!findString("a_labelName", uLabelAtts))
	{warnAtt("a_labelName", "uLabel", a_uLabel);}
      else
        check_labelName(a_uLabel->get_labelName());
    }
}

/********************************************************************/

void check_uncertMinor(
 uncertMinor * a_uncertMinor)
{
  if (isA(a_uncertMinor, uncertMinor_ALGOR))
    {
      if (!findString("uncertMinor_ALGOR", uncertMinorSubs))
        {warnSub("uncertMinor_ALGOR", "uncertMinor", a_uncertMinor);}
      else
        check_uncertMinor_ALGOR(dynamic_cast<uncertMinor_ALGOR *>(a_uncertMinor));
      return;
    }
  if (isA(a_uncertMinor, uncertMinor_stringVal))
    {
      if (!findString("uncertMinor_stringVal", uncertMinorSubs))
        {warnSub("uncertMinor_stringVal", "uncertMinor", a_uncertMinor);}
      else
        check_uncertMinor_stringVal(dynamic_cast<uncertMinor_stringVal *>(a_uncertMinor));
      return;
    }
}

/********************************************************************/

void check_uncertMinor_ALGOR(
 uncertMinor_ALGOR * a_uncertMinor_ALGOR)
{
  if (a_uncertMinor_ALGOR->get_code())
    {
      if (!findString("code", uncertMinor_ALGORAtts))
	{warnAtt("code", "uncertMinor_ALGOR", a_uncertMinor_ALGOR);}
      else
        check_intVal(a_uncertMinor_ALGOR->get_code());
    }
}

/********************************************************************/

void check_uncertMinor_stringVal(
 uncertMinor_stringVal * a_uncertMinor_stringVal)
{
  if (a_uncertMinor_stringVal->get_name())
    {
      if (!findString("name", uncertMinor_stringValAtts))
	{warnAtt("name", "uncertMinor_stringVal", a_uncertMinor_stringVal);}
      else
        check_stringVal(a_uncertMinor_stringVal->get_name());
    }
  if (a_uncertMinor_stringVal->get_uncertVar3())
    {
      if (!findString("a_uncertVar3", uncertMinor_stringValAtts))
	{warnAtt("a_uncertVar3", "uncertMinor_stringVal", a_uncertMinor_stringVal);}
      else
        check_uncertVar3(a_uncertMinor_stringVal->get_uncertVar3());
    }
}

/********************************************************************/

void check_uncertVar3(
 uncertVar3 * a_uncertVar3)
{
  if (isA(a_uncertVar3, uncertVar3_DME))
    {
      if (!findString("uncertVar3_DME", uncertVar3Subs))
        {warnSub("uncertVar3_DME", "uncertVar3", a_uncertVar3);}
      else
        check_uncertVar3_DME(dynamic_cast<uncertVar3_DME *>(a_uncertVar3));
      return;
    }
  if (isA(a_uncertVar3, uncertVar3_SENS))
    {
      if (!findString("uncertVar3_SENS", uncertVar3Subs))
        {warnSub("uncertVar3_SENS", "uncertVar3", a_uncertVar3);}
      else
        check_uncertVar3_SENS(dynamic_cast<uncertVar3_SENS *>(a_uncertVar3));
      return;
    }
  if (isA(a_uncertVar3, uncertVar3_paramList))
    {
      if (!findString("uncertVar3_paramList", uncertVar3Subs))
        {warnSub("uncertVar3_paramList", "uncertVar3", a_uncertVar3);}
      else
        check_uncertVar3_paramList(dynamic_cast<uncertVar3_paramList *>(a_uncertVar3));
      return;
    }
}

/********************************************************************/

void check_uncertVar3_DME(
 uncertVar3_DME * a_uncertVar3_DME)
{
  if (a_uncertVar3_DME->get_paramList())
    {
      if (!findString("a_paramList", uncertVar3_DMEAtts))
	{warnAtt("a_paramList", "uncertVar3_DME", a_uncertVar3_DME);}
      else
        {
          std::list<param *> * theList;
          std::list<param *>::iterator iter;
          theList = a_uncertVar3_DME->get_paramList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_param(*iter);
        }
    }
}

/********************************************************************/

void check_uncertVar3_SENS(
 uncertVar3_SENS * a_uncertVar3_SENS)
{
  if (a_uncertVar3_SENS->get_paramList())
    {
      if (!findString("a_paramList", uncertVar3_SENSAtts))
	{warnAtt("a_paramList", "uncertVar3_SENS", a_uncertVar3_SENS);}
      else
        {
          std::list<param *> * theList;
          std::list<param *>::iterator iter;
          theList = a_uncertVar3_SENS->get_paramList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_param(*iter);
        }
    }
}

/********************************************************************/

void check_uncertVar3_paramList(
 uncertVar3_paramList * a_uncertVar3_paramList)
{
  if (a_uncertVar3_paramList->get_paramList())
    {
      if (!findString("a_paramList", uncertVar3_paramListAtts))
	{warnAtt("a_paramList", "uncertVar3_paramList", a_uncertVar3_paramList);}
      else
        {
          std::list<param *> * theList;
          std::list<param *>::iterator iter;
          theList = a_uncertVar3_paramList->get_paramList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_param(*iter);
        }
    }
}

/********************************************************************/

void check_uncertalgStm(
 uncertalgStm * a_uncertalgStm)
{
  if (a_uncertalgStm->get_uLabel())
    {
      if (!findString("a_uLabel", uncertalgStmAtts))
	{warnAtt("a_uLabel", "uncertalgStm", a_uncertalgStm);}
      else
        check_uLabel(a_uncertalgStm->get_uLabel());
    }
  if (a_uncertalgStm->get_uncertMinor())
    {
      if (!findString("a_uncertMinor", uncertalgStmAtts))
	{warnAtt("a_uncertMinor", "uncertalgStm", a_uncertalgStm);}
      else
        check_uncertMinor(a_uncertalgStm->get_uncertMinor());
    }
}

/********************************************************************/

void check_uncertsetMinor(
 uncertsetMinor * a_uncertsetMinor)
{
  if (isA(a_uncertsetMinor, uncertsetMinor_ON))
    {
      if (!findString("uncertsetMinor_ON", uncertsetMinorSubs))
        {warnSub("uncertsetMinor_ON", "uncertsetMinor", a_uncertsetMinor);}
      else
        check_uncertsetMinor_ON(dynamic_cast<uncertsetMinor_ON *>(a_uncertsetMinor));
      return;
    }
  if (isA(a_uncertsetMinor, uncertsetMinor_OFF))
    {
      if (!findString("uncertsetMinor_OFF", uncertsetMinorSubs))
        {warnSub("uncertsetMinor_OFF", "uncertsetMinor", a_uncertsetMinor);}
      return;
    }
}

/********************************************************************/

void check_uncertsetMinor_ON(
 uncertsetMinor_ON * a_uncertsetMinor_ON)
{
  if (a_uncertsetMinor_ON->get_uLabel())
    {
      if (!findString("a_uLabel", uncertsetMinor_ONAtts))
	{warnAtt("a_uLabel", "uncertsetMinor_ON", a_uncertsetMinor_ON);}
      else
        check_uLabel(a_uncertsetMinor_ON->get_uLabel());
    }
  if (a_uncertsetMinor_ON->get_uncertsetVar2())
    {
      if (!findString("a_uncertsetVar2", uncertsetMinor_ONAtts))
	{warnAtt("a_uncertsetVar2", "uncertsetMinor_ON", a_uncertsetMinor_ON);}
      else
        check_uncertsetVar2(a_uncertsetMinor_ON->get_uncertsetVar2());
    }
}

/********************************************************************/

void check_uncertsetStm(
 uncertsetStm * a_uncertsetStm)
{
  if (a_uncertsetStm->get_uncertsetMinor())
    {
      if (!findString("a_uncertsetMinor", uncertsetStmAtts))
	{warnAtt("a_uncertsetMinor", "uncertsetStm", a_uncertsetStm);}
      else
        check_uncertsetMinor(a_uncertsetStm->get_uncertsetMinor());
    }
}

/********************************************************************/

void check_uncertsetVar2(
 uncertsetVar2 * a_uncertsetVar2)
{
  if (isA(a_uncertsetVar2, uncertsetVar2_drLabel))
    {
      if (!findString("uncertsetVar2_drLabel", uncertsetVar2Subs))
        {warnSub("uncertsetVar2_drLabel", "uncertsetVar2", a_uncertsetVar2);}
      else
        check_uncertsetVar2_drLabel(dynamic_cast<uncertsetVar2_drLabel *>(a_uncertsetVar2));
      return;
    }
  if (isA(a_uncertsetVar2, uncertsetVar2_NONE))
    {
      if (!findString("uncertsetVar2_NONE", uncertsetVar2Subs))
        {warnSub("uncertsetVar2_NONE", "uncertsetVar2", a_uncertsetVar2);}
      return;
    }
}

/********************************************************************/

void check_uncertsetVar2_drLabel(
 uncertsetVar2_drLabel * a_uncertsetVar2_drLabel)
{
  if (a_uncertsetVar2_drLabel->get_drLabel())
    {
      if (!findString("a_drLabel", uncertsetVar2_drLabelAtts))
	{warnAtt("a_drLabel", "uncertsetVar2_drLabel", a_uncertsetVar2_drLabel);}
      else
        check_drLabel(a_uncertsetVar2_drLabel->get_drLabel());
    }
}

/********************************************************************/

void check_unitsStm(
 unitsStm * a_unitsStm)
{
  if (a_unitsStm->get_lengthUnit())
    {
      if (!findString("a_lengthUnit", unitsStmAtts))
	{warnAtt("a_lengthUnit", "unitsStm", a_unitsStm);}
      else
        check_lengthUnit(a_unitsStm->get_lengthUnit());
    }
  if (a_unitsStm->get_angleUnit())
    {
      if (!findString("a_angleUnit", unitsStmAtts))
	{warnAtt("a_angleUnit", "unitsStm", a_unitsStm);}
      else
        check_angleUnit(a_unitsStm->get_angleUnit());
    }
  if (a_unitsStm->get_tempUnit())
    {
      if (!findString("a_tempUnit", unitsStmAtts))
	{warnAtt("a_tempUnit", "unitsStm", a_unitsStm);}
      else
        check_tempUnit(a_unitsStm->get_tempUnit());
    }
}

/********************************************************************/

void check_vLabel(
 vLabel * a_vLabel)
{
  if (a_vLabel->get_labelName())
    {
      if (!findString("a_labelName", vLabelAtts))
	{warnAtt("a_labelName", "vLabel", a_vLabel);}
      else
        check_labelName(a_vLabel->get_labelName());
    }
}

/********************************************************************/

void check_vaLabel(
 vaLabel * a_vaLabel)
{
  if (a_vaLabel->get_labelName())
    {
      if (!findString("a_labelName", vaLabelAtts))
	{warnAtt("a_labelName", "vaLabel", a_vaLabel);}
      else
        check_labelName(a_vaLabel->get_labelName());
    }
}

/********************************************************************/

void check_valueAclratReal(
 valueAclratReal * a_valueAclratReal)
{
  if (isA(a_valueAclratReal, valueAclratReal_MESACL))
    {
      if (!findString("valueAclratReal_MESACL", valueAclratRealSubs))
        {warnSub("valueAclratReal_MESACL", "valueAclratReal", a_valueAclratReal);}
      return;
    }
  if (isA(a_valueAclratReal, valueAclratReal_POSACL))
    {
      if (!findString("valueAclratReal_POSACL", valueAclratRealSubs))
        {warnSub("valueAclratReal_POSACL", "valueAclratReal", a_valueAclratReal);}
      return;
    }
  if (isA(a_valueAclratReal, valueAclratReal_ROTACL))
    {
      if (!findString("valueAclratReal_ROTACL", valueAclratRealSubs))
        {warnSub("valueAclratReal_ROTACL", "valueAclratReal", a_valueAclratReal);}
      return;
    }
}

/********************************************************************/

void check_valueAclratString(
 valueAclratString * a_valueAclratString)
{
  if (a_valueAclratString->get_valueAclratReal())
    {
      if (!findString("a_valueAclratReal", valueAclratStringAtts))
	{warnAtt("a_valueAclratReal", "valueAclratString", a_valueAclratString);}
      else
        check_valueAclratReal(a_valueAclratString->get_valueAclratReal());
    }
}

/********************************************************************/

void check_valueBoundInt(
 valueBoundInt * a_valueBoundInt)
{
  if (isA(a_valueBoundInt, valueBoundInt_featureLabel))
    {
      if (!findString("valueBoundInt_featureLabel", valueBoundIntSubs))
        {warnSub("valueBoundInt_featureLabel", "valueBoundInt", a_valueBoundInt);}
      else
        check_valueBoundInt_featureLabel(dynamic_cast<valueBoundInt_featureLabel *>(a_valueBoundInt));
      return;
    }
  if (isA(a_valueBoundInt, valueBoundInt_toleranceLabel))
    {
      if (!findString("valueBoundInt_toleranceLabel", valueBoundIntSubs))
        {warnSub("valueBoundInt_toleranceLabel", "valueBoundInt", a_valueBoundInt);}
      else
        check_valueBoundInt_toleranceLabel(dynamic_cast<valueBoundInt_toleranceLabel *>(a_valueBoundInt));
      return;
    }
}

/********************************************************************/

void check_valueBoundInt_featureLabel(
 valueBoundInt_featureLabel * a_valueBoundInt_featureLabel)
{
  if (a_valueBoundInt_featureLabel->get_featureLabel())
    {
      if (!findString("a_featureLabel", valueBoundInt_featureLabelAtts))
	{warnAtt("a_featureLabel", "valueBoundInt_featureLabel", a_valueBoundInt_featureLabel);}
      else
        check_featureLabel(a_valueBoundInt_featureLabel->get_featureLabel());
    }
}

/********************************************************************/

void check_valueBoundInt_toleranceLabel(
 valueBoundInt_toleranceLabel * a_valueBoundInt_toleranceLabel)
{
  if (a_valueBoundInt_toleranceLabel->get_toleranceLabel())
    {
      if (!findString("a_toleranceLabel", valueBoundInt_toleranceLabelAtts))
	{warnAtt("a_toleranceLabel", "valueBoundInt_toleranceLabel", a_valueBoundInt_toleranceLabel);}
      else
        check_toleranceLabel(a_valueBoundInt_toleranceLabel->get_toleranceLabel());
    }
}

/********************************************************************/

void check_valueBoundString(
 valueBoundString * a_valueBoundString)
{
  if (isA(a_valueBoundString, valueBoundString_featureLabel))
    {
      if (!findString("valueBoundString_featureLabel", valueBoundStringSubs))
        {warnSub("valueBoundString_featureLabel", "valueBoundString", a_valueBoundString);}
      else
        check_valueBoundString_featureLabel(dynamic_cast<valueBoundString_featureLabel *>(a_valueBoundString));
      return;
    }
  if (isA(a_valueBoundString, valueBoundString_toleranceLabel))
    {
      if (!findString("valueBoundString_toleranceLabel", valueBoundStringSubs))
        {warnSub("valueBoundString_toleranceLabel", "valueBoundString", a_valueBoundString);}
      else
        check_valueBoundString_toleranceLabel(dynamic_cast<valueBoundString_toleranceLabel *>(a_valueBoundString));
      return;
    }
}

/********************************************************************/

void check_valueBoundString_featureLabel(
 valueBoundString_featureLabel * a_valueBoundString_featureLabel)
{
  if (a_valueBoundString_featureLabel->get_featureLabel())
    {
      if (!findString("a_featureLabel", valueBoundString_featureLabelAtts))
	{warnAtt("a_featureLabel", "valueBoundString_featureLabel", a_valueBoundString_featureLabel);}
      else
        check_featureLabel(a_valueBoundString_featureLabel->get_featureLabel());
    }
  if (a_valueBoundString_featureLabel->get_bndnum())
    {
      if (!findString("bndnum", valueBoundString_featureLabelAtts))
	{warnAtt("bndnum", "valueBoundString_featureLabel", a_valueBoundString_featureLabel);}
      else
        check_intVal(a_valueBoundString_featureLabel->get_bndnum());
    }
}

/********************************************************************/

void check_valueBoundString_toleranceLabel(
 valueBoundString_toleranceLabel * a_valueBoundString_toleranceLabel)
{
  if (a_valueBoundString_toleranceLabel->get_toleranceLabel())
    {
      if (!findString("a_toleranceLabel", valueBoundString_toleranceLabelAtts))
	{warnAtt("a_toleranceLabel", "valueBoundString_toleranceLabel", a_valueBoundString_toleranceLabel);}
      else
        check_toleranceLabel(a_valueBoundString_toleranceLabel->get_toleranceLabel());
    }
  if (a_valueBoundString_toleranceLabel->get_bndnum())
    {
      if (!findString("bndnum", valueBoundString_toleranceLabelAtts))
	{warnAtt("bndnum", "valueBoundString_toleranceLabel", a_valueBoundString_toleranceLabel);}
      else
        check_intVal(a_valueBoundString_toleranceLabel->get_bndnum());
    }
}

/********************************************************************/

void check_valueCzslct(
 valueCzslct * a_valueCzslct)
{
  if (a_valueCzslct->get_czLabel())
    {
      if (!findString("a_czLabel", valueCzslctAtts))
	{warnAtt("a_czLabel", "valueCzslct", a_valueCzslct);}
      else
        check_czLabel(a_valueCzslct->get_czLabel());
    }
}

/********************************************************************/

void check_valueDmismd(
 valueDmismd * a_valueDmismd)
{
  if (isA(a_valueDmismd, valueDmismd_NAME))
    {
      if (!findString("valueDmismd_NAME", valueDmismdSubs))
        {warnSub("valueDmismd_NAME", "valueDmismd", a_valueDmismd);}
      return;
    }
  if (isA(a_valueDmismd, valueDmismd_VERSION))
    {
      if (!findString("valueDmismd_VERSION", valueDmismdSubs))
        {warnSub("valueDmismd_VERSION", "valueDmismd", a_valueDmismd);}
      return;
    }
}

/********************************************************************/

void check_valueDmismn(
 valueDmismn * a_valueDmismn)
{
  if (isA(a_valueDmismn, valueDmismn_NAME))
    {
      if (!findString("valueDmismn_NAME", valueDmismnSubs))
        {warnSub("valueDmismn_NAME", "valueDmismn", a_valueDmismn);}
      return;
    }
  if (isA(a_valueDmismn, valueDmismn_VERSION))
    {
      if (!findString("valueDmismn_VERSION", valueDmismnSubs))
        {warnSub("valueDmismn_VERSION", "valueDmismn", a_valueDmismn);}
      return;
    }
}

/********************************************************************/

void check_valueError(
 valueError * a_valueError)
{
  if (isA(a_valueError, valueError_ERR))
    {
      if (!findString("valueError_ERR", valueErrorSubs))
        {warnSub("valueError_ERR", "valueError", a_valueError);}
      return;
    }
  if (isA(a_valueError, valueError_ERRMODE))
    {
      if (!findString("valueError_ERRMODE", valueErrorSubs))
        {warnSub("valueError_ERRMODE", "valueError", a_valueError);}
      return;
    }
}

/********************************************************************/

void check_valueFaInt(
 valueFaInt * a_valueFaInt)
{
  if (a_valueFaInt->get_faLabel())
    {
      if (!findString("a_faLabel", valueFaIntAtts))
	{warnAtt("a_faLabel", "valueFaInt", a_valueFaInt);}
      else
        check_faLabel(a_valueFaInt->get_faLabel());
    }
}

/********************************************************************/

void check_valueFaReal(
 valueFaReal * a_valueFaReal)
{
  if (a_valueFaReal->get_faLabel())
    {
      if (!findString("a_faLabel", valueFaRealAtts))
	{warnAtt("a_faLabel", "valueFaReal", a_valueFaReal);}
      else
        check_faLabel(a_valueFaReal->get_faLabel());
    }
  if (a_valueFaReal->get_sizenum())
    {
      if (!findString("sizenum", valueFaRealAtts))
	{warnAtt("sizenum", "valueFaReal", a_valueFaReal);}
      else
        check_intVal(a_valueFaReal->get_sizenum());
    }
}

/********************************************************************/

void check_valueFedratReal(
 valueFedratReal * a_valueFedratReal)
{
  if (isA(a_valueFedratReal, valueFedratReal_MESVEL))
    {
      if (!findString("valueFedratReal_MESVEL", valueFedratRealSubs))
        {warnSub("valueFedratReal_MESVEL", "valueFedratReal", a_valueFedratReal);}
      return;
    }
  if (isA(a_valueFedratReal, valueFedratReal_POSVEL))
    {
      if (!findString("valueFedratReal_POSVEL", valueFedratRealSubs))
        {warnSub("valueFedratReal_POSVEL", "valueFedratReal", a_valueFedratReal);}
      return;
    }
  if (isA(a_valueFedratReal, valueFedratReal_ROTVEL))
    {
      if (!findString("valueFedratReal_ROTVEL", valueFedratRealSubs))
        {warnSub("valueFedratReal_ROTVEL", "valueFedratReal", a_valueFedratReal);}
      return;
    }
  if (isA(a_valueFedratReal, valueFedratReal_SCNVEL))
    {
      if (!findString("valueFedratReal_SCNVEL", valueFedratRealSubs))
        {warnSub("valueFedratReal_SCNVEL", "valueFedratReal", a_valueFedratReal);}
      return;
    }
}

/********************************************************************/

void check_valueFedratString(
 valueFedratString * a_valueFedratString)
{
  if (a_valueFedratString->get_valueFedratReal())
    {
      if (!findString("a_valueFedratReal", valueFedratStringAtts))
	{warnAtt("a_valueFedratReal", "valueFedratString", a_valueFedratString);}
      else
        check_valueFedratReal(a_valueFedratString->get_valueFedratReal());
    }
}

/********************************************************************/

void check_valueFilnam(
 valueFilnam * a_valueFilnam)
{
  if (isA(a_valueFilnam, valueFilnam_NAME))
    {
      if (!findString("valueFilnam_NAME", valueFilnamSubs))
        {warnSub("valueFilnam_NAME", "valueFilnam", a_valueFilnam);}
      return;
    }
  if (isA(a_valueFilnam, valueFilnam_VERSION))
    {
      if (!findString("valueFilnam_VERSION", valueFilnamSubs))
        {warnSub("valueFilnam_VERSION", "valueFilnam", a_valueFilnam);}
      return;
    }
}

/********************************************************************/

void check_valueGeoalg(
 valueGeoalg * a_valueGeoalg)
{
  if (a_valueGeoalg->get_measGeotype())
    {
      if (!findString("a_measGeotype", valueGeoalgAtts))
	{warnAtt("a_measGeotype", "valueGeoalg", a_valueGeoalg);}
      else
        check_measGeotype(a_valueGeoalg->get_measGeotype());
    }
}

/********************************************************************/

void check_valueGotoReal(
 valueGotoReal * a_valueGotoReal)
{
  if (a_valueGotoReal->get_axis())
    {
      if (!findString("a_axis", valueGotoRealAtts))
	{warnAtt("a_axis", "valueGotoReal", a_valueGotoReal);}
      else
        check_axis(a_valueGotoReal->get_axis());
    }
}

/********************************************************************/

void check_valueKeychar(
 valueKeychar * a_valueKeychar)
{
  if (isA(a_valueKeychar, kcLabel))
    {
      if (!findString("kcLabel", valueKeycharSubs))
        {warnSub("kcLabel", "valueKeychar", a_valueKeychar);}
      else
        check_kcLabel(dynamic_cast<kcLabel *>(a_valueKeychar));
      return;
    }
}

/********************************************************************/

void check_valueMinorBool(
 valueMinorBool * a_valueMinorBool)
{
  if (isA(a_valueMinorBool, valueBadtst))
    {
      if (!findString("valueBadtst", valueMinorBoolSubs))
        {warnSub("valueBadtst", "valueMinorBool", a_valueMinorBool);}
      return;
    }
  if (isA(a_valueMinorBool, valueCroscl))
    {
      if (!findString("valueCroscl", valueMinorBoolSubs))
        {warnSub("valueCroscl", "valueMinorBool", a_valueMinorBool);}
      return;
    }
  if (isA(a_valueMinorBool, valueCzslct))
    {
      if (!findString("valueCzslct", valueMinorBoolSubs))
        {warnSub("valueCzslct", "valueMinorBool", a_valueMinorBool);}
      else
        check_valueCzslct(dynamic_cast<valueCzslct *>(a_valueMinorBool));
      return;
    }
  if (isA(a_valueMinorBool, valueFinpos))
    {
      if (!findString("valueFinpos", valueMinorBoolSubs))
        {warnSub("valueFinpos", "valueMinorBool", a_valueMinorBool);}
      return;
    }
  if (isA(a_valueMinorBool, valuePrcomp))
    {
      if (!findString("valuePrcomp", valueMinorBoolSubs))
        {warnSub("valuePrcomp", "valueMinorBool", a_valueMinorBool);}
      return;
    }
  if (isA(a_valueMinorBool, valuePtbuff))
    {
      if (!findString("valuePtbuff", valueMinorBoolSubs))
        {warnSub("valuePtbuff", "valueMinorBool", a_valueMinorBool);}
      return;
    }
  if (isA(a_valueMinorBool, valueScnmod))
    {
      if (!findString("valueScnmod", valueMinorBoolSubs))
        {warnSub("valueScnmod", "valueMinorBool", a_valueMinorBool);}
      return;
    }
  if (isA(a_valueMinorBool, valueTaBool))
    {
      if (!findString("valueTaBool", valueMinorBoolSubs))
        {warnSub("valueTaBool", "valueMinorBool", a_valueMinorBool);}
      else
        check_valueTaBool(dynamic_cast<valueTaBool *>(a_valueMinorBool));
      return;
    }
  if (isA(a_valueMinorBool, valueTecomp))
    {
      if (!findString("valueTecomp", valueMinorBoolSubs))
        {warnSub("valueTecomp", "valueMinorBool", a_valueMinorBool);}
      return;
    }
}

/********************************************************************/

void check_valueMinorInt(
 valueMinorInt * a_valueMinorInt)
{
  if (isA(a_valueMinorInt, valueBoundInt))
    {
      if (!findString("valueBoundInt", valueMinorIntSubs))
        {warnSub("valueBoundInt", "valueMinorInt", a_valueMinorInt);}
      else
        check_valueBoundInt(dynamic_cast<valueBoundInt *>(a_valueMinorInt));
      return;
    }
  if (isA(a_valueMinorInt, valueFaInt))
    {
      if (!findString("valueFaInt", valueMinorIntSubs))
        {warnSub("valueFaInt", "valueMinorInt", a_valueMinorInt);}
      else
        check_valueFaInt(dynamic_cast<valueFaInt *>(a_valueMinorInt));
      return;
    }
}

/********************************************************************/

void check_valueMinorReal(
 valueMinorReal * a_valueMinorReal)
{
  if (isA(a_valueMinorReal, valueAclratReal))
    {
      if (!findString("valueAclratReal", valueMinorRealSubs))
        {warnSub("valueAclratReal", "valueMinorReal", a_valueMinorReal);}
      else
        check_valueAclratReal(dynamic_cast<valueAclratReal *>(a_valueMinorReal));
      return;
    }
  if (isA(a_valueMinorReal, valueDeflection))
    {
      if (!findString("valueDeflection", valueMinorRealSubs))
        {warnSub("valueDeflection", "valueMinorReal", a_valueMinorReal);}
      return;
    }
  if (isA(a_valueMinorReal, valueFedratReal))
    {
      if (!findString("valueFedratReal", valueMinorRealSubs))
        {warnSub("valueFedratReal", "valueMinorReal", a_valueMinorReal);}
      else
        check_valueFedratReal(dynamic_cast<valueFedratReal *>(a_valueMinorReal));
      return;
    }
  if (isA(a_valueMinorReal, valueGotoReal))
    {
      if (!findString("valueGotoReal", valueMinorRealSubs))
        {warnSub("valueGotoReal", "valueMinorReal", a_valueMinorReal);}
      else
        check_valueGotoReal(dynamic_cast<valueGotoReal *>(a_valueMinorReal));
      return;
    }
  if (isA(a_valueMinorReal, valuePtmeasReal))
    {
      if (!findString("valuePtmeasReal", valueMinorRealSubs))
        {warnSub("valuePtmeasReal", "valueMinorReal", a_valueMinorReal);}
      else
        check_valuePtmeasReal(dynamic_cast<valuePtmeasReal *>(a_valueMinorReal));
      return;
    }
  if (isA(a_valueMinorReal, valueSnsetReal))
    {
      if (!findString("valueSnsetReal", valueMinorRealSubs))
        {warnSub("valueSnsetReal", "valueMinorReal", a_valueMinorReal);}
      else
        check_valueSnsetReal(dynamic_cast<valueSnsetReal *>(a_valueMinorReal));
      return;
    }
  if (isA(a_valueMinorReal, valueFaReal))
    {
      if (!findString("valueFaReal", valueMinorRealSubs))
        {warnSub("valueFaReal", "valueMinorReal", a_valueMinorReal);}
      else
        check_valueFaReal(dynamic_cast<valueFaReal *>(a_valueMinorReal));
      return;
    }
  if (isA(a_valueMinorReal, valueRt))
    {
      if (!findString("valueRt", valueMinorRealSubs))
        {warnSub("valueRt", "valueMinorReal", a_valueMinorReal);}
      else
        check_valueRt(dynamic_cast<valueRt *>(a_valueMinorReal));
      return;
    }
  if (isA(a_valueMinorReal, valueSa))
    {
      if (!findString("valueSa", valueMinorRealSubs))
        {warnSub("valueSa", "valueMinorReal", a_valueMinorReal);}
      else
        check_valueSa(dynamic_cast<valueSa *>(a_valueMinorReal));
      return;
    }
  if (isA(a_valueMinorReal, valueSw))
    {
      if (!findString("valueSw", valueMinorRealSubs))
        {warnSub("valueSw", "valueMinorReal", a_valueMinorReal);}
      else
        check_valueSw(dynamic_cast<valueSw *>(a_valueMinorReal));
      return;
    }
  if (isA(a_valueMinorReal, valueTaReal))
    {
      if (!findString("valueTaReal", valueMinorRealSubs))
        {warnSub("valueTaReal", "valueMinorReal", a_valueMinorReal);}
      else
        check_valueTaReal(dynamic_cast<valueTaReal *>(a_valueMinorReal));
      return;
    }
}

/********************************************************************/

void check_valueMinorString(
 valueMinorString * a_valueMinorString)
{
  if (isA(a_valueMinorString, valueAclratString))
    {
      if (!findString("valueAclratString", valueMinorStringSubs))
        {warnSub("valueAclratString", "valueMinorString", a_valueMinorString);}
      else
        check_valueAclratString(dynamic_cast<valueAclratString *>(a_valueMinorString));
      return;
    }
  if (isA(a_valueMinorString, valueBoundString))
    {
      if (!findString("valueBoundString", valueMinorStringSubs))
        {warnSub("valueBoundString", "valueMinorString", a_valueMinorString);}
      else
        check_valueBoundString(dynamic_cast<valueBoundString *>(a_valueMinorString));
      return;
    }
  if (isA(a_valueMinorString, valueCrmode))
    {
      if (!findString("valueCrmode", valueMinorStringSubs))
        {warnSub("valueCrmode", "valueMinorString", a_valueMinorString);}
      return;
    }
  if (isA(a_valueMinorString, valueCrslct))
    {
      if (!findString("valueCrslct", valueMinorStringSubs))
        {warnSub("valueCrslct", "valueMinorString", a_valueMinorString);}
      return;
    }
  if (isA(a_valueMinorString, valueDatset))
    {
      if (!findString("valueDatset", valueMinorStringSubs))
        {warnSub("valueDatset", "valueMinorString", a_valueMinorString);}
      return;
    }
  if (isA(a_valueMinorString, valueDmismd))
    {
      if (!findString("valueDmismd", valueMinorStringSubs))
        {warnSub("valueDmismd", "valueMinorString", a_valueMinorString);}
      else
        check_valueDmismd(dynamic_cast<valueDmismd *>(a_valueMinorString));
      return;
    }
  if (isA(a_valueMinorString, valueDmismn))
    {
      if (!findString("valueDmismn", valueMinorStringSubs))
        {warnSub("valueDmismn", "valueMinorString", a_valueMinorString);}
      else
        check_valueDmismn(dynamic_cast<valueDmismn *>(a_valueMinorString));
      return;
    }
  if (isA(a_valueMinorString, valueError))
    {
      if (!findString("valueError", valueMinorStringSubs))
        {warnSub("valueError", "valueMinorString", a_valueMinorString);}
      else
        check_valueError(dynamic_cast<valueError *>(a_valueMinorString));
      return;
    }
  if (isA(a_valueMinorString, valueFedratString))
    {
      if (!findString("valueFedratString", valueMinorStringSubs))
        {warnSub("valueFedratString", "valueMinorString", a_valueMinorString);}
      else
        check_valueFedratString(dynamic_cast<valueFedratString *>(a_valueMinorString));
      return;
    }
  if (isA(a_valueMinorString, valueFilnam))
    {
      if (!findString("valueFilnam", valueMinorStringSubs))
        {warnSub("valueFilnam", "valueMinorString", a_valueMinorString);}
      else
        check_valueFilnam(dynamic_cast<valueFilnam *>(a_valueMinorString));
      return;
    }
  if (isA(a_valueMinorString, valueGeoalg))
    {
      if (!findString("valueGeoalg", valueMinorStringSubs))
        {warnSub("valueGeoalg", "valueMinorString", a_valueMinorString);}
      else
        check_valueGeoalg(dynamic_cast<valueGeoalg *>(a_valueMinorString));
      return;
    }
  if (isA(a_valueMinorString, valueKeychar))
    {
      if (!findString("valueKeychar", valueMinorStringSubs))
        {warnSub("valueKeychar", "valueMinorString", a_valueMinorString);}
      else
        check_valueKeychar(dynamic_cast<valueKeychar *>(a_valueMinorString));
      return;
    }
  if (isA(a_valueMinorString, valueMode))
    {
      if (!findString("valueMode", valueMinorStringSubs))
        {warnSub("valueMode", "valueMinorString", a_valueMinorString);}
      return;
    }
  if (isA(a_valueMinorString, valueSnsetString))
    {
      if (!findString("valueSnsetString", valueMinorStringSubs))
        {warnSub("valueSnsetString", "valueMinorString", a_valueMinorString);}
      else
        check_valueSnsetString(dynamic_cast<valueSnsetString *>(a_valueMinorString));
      return;
    }
  if (isA(a_valueMinorString, valueSnslct))
    {
      if (!findString("valueSnslct", valueMinorStringSubs))
        {warnSub("valueSnslct", "valueMinorString", a_valueMinorString);}
      return;
    }
  if (isA(a_valueMinorString, valueUnits))
    {
      if (!findString("valueUnits", valueMinorStringSubs))
        {warnSub("valueUnits", "valueMinorString", a_valueMinorString);}
      else
        check_valueUnits(dynamic_cast<valueUnits *>(a_valueMinorString));
      return;
    }
  if (isA(a_valueMinorString, valueWkplan))
    {
      if (!findString("valueWkplan", valueMinorStringSubs))
        {warnSub("valueWkplan", "valueMinorString", a_valueMinorString);}
      return;
    }
}

/********************************************************************/

void check_valueMinorVector(
 valueMinorVector * a_valueMinorVector)
{
  if (isA(a_valueMinorVector, valueGotoVector))
    {
      if (!findString("valueGotoVector", valueMinorVectorSubs))
        {warnSub("valueGotoVector", "valueMinorVector", a_valueMinorVector);}
      return;
    }
  if (isA(a_valueMinorVector, valuePtmeasVector))
    {
      if (!findString("valuePtmeasVector", valueMinorVectorSubs))
        {warnSub("valuePtmeasVector", "valueMinorVector", a_valueMinorVector);}
      return;
    }
  if (isA(a_valueMinorVector, valueSnsmnt))
    {
      if (!findString("valueSnsmnt", valueMinorVectorSubs))
        {warnSub("valueSnsmnt", "valueMinorVector", a_valueMinorVector);}
      else
        check_valueSnsmnt(dynamic_cast<valueSnsmnt *>(a_valueMinorVector));
      return;
    }
}

/********************************************************************/

void check_valuePtmeasReal(
 valuePtmeasReal * a_valuePtmeasReal)
{
  if (a_valuePtmeasReal->get_axis())
    {
      if (!findString("a_axis", valuePtmeasRealAtts))
	{warnAtt("a_axis", "valuePtmeasReal", a_valuePtmeasReal);}
      else
        check_axis(a_valuePtmeasReal->get_axis());
    }
}

/********************************************************************/

void check_valueRt(
 valueRt * a_valueRt)
{
  if (isA(a_valueRt, valueRt_CW))
    {
      if (!findString("valueRt_CW", valueRtSubs))
        {warnSub("valueRt_CW", "valueRt", a_valueRt);}
      else
        check_valueRt_CW(dynamic_cast<valueRt_CW *>(a_valueRt));
      return;
    }
  if (isA(a_valueRt, valueRt_CCW))
    {
      if (!findString("valueRt_CCW", valueRtSubs))
        {warnSub("valueRt_CCW", "valueRt", a_valueRt);}
      else
        check_valueRt_CCW(dynamic_cast<valueRt_CCW *>(a_valueRt));
      return;
    }
}

/********************************************************************/

void check_valueRt_CCW(
 valueRt_CCW * a_valueRt_CCW)
{
  if (a_valueRt_CCW->get_rtLabel())
    {
      if (!findString("a_rtLabel", valueRt_CCWAtts))
	{warnAtt("a_rtLabel", "valueRt_CCW", a_valueRt_CCW);}
      else
        check_rtLabel(a_valueRt_CCW->get_rtLabel());
    }
}

/********************************************************************/

void check_valueRt_CW(
 valueRt_CW * a_valueRt_CW)
{
  if (a_valueRt_CW->get_rtLabel())
    {
      if (!findString("a_rtLabel", valueRt_CWAtts))
	{warnAtt("a_rtLabel", "valueRt_CW", a_valueRt_CW);}
      else
        check_rtLabel(a_valueRt_CW->get_rtLabel());
    }
}

/********************************************************************/

void check_valueSa(
 valueSa * a_valueSa)
{
  if (isA(a_valueSa, valueSaPlain))
    {
      if (!findString("valueSaPlain", valueSaSubs))
        {warnSub("valueSaPlain", "valueSa", a_valueSa);}
      else
        check_valueSaPlain(dynamic_cast<valueSaPlain *>(a_valueSa));
      return;
    }
  if (isA(a_valueSa, valueSaDesc))
    {
      if (!findString("valueSaDesc", valueSaSubs))
        {warnSub("valueSaDesc", "valueSa", a_valueSa);}
      else
        check_valueSaDesc(dynamic_cast<valueSaDesc *>(a_valueSa));
      return;
    }
  if (isA(a_valueSa, valueSaTipnum))
    {
      if (!findString("valueSaTipnum", valueSaSubs))
        {warnSub("valueSaTipnum", "valueSa", a_valueSa);}
      else
        check_valueSaTipnum(dynamic_cast<valueSaTipnum *>(a_valueSa));
      return;
    }
}

/********************************************************************/

void check_valueSaDesc(
 valueSaDesc * a_valueSaDesc)
{
  if (a_valueSaDesc->get_saLabel())
    {
      if (!findString("a_saLabel", valueSaDescAtts))
	{warnAtt("a_saLabel", "valueSaDesc", a_valueSaDesc);}
      else
        check_saLabel(a_valueSaDesc->get_saLabel());
    }
  if (a_valueSaDesc->get_desc())
    {
      if (!findString("desc", valueSaDescAtts))
	{warnAtt("desc", "valueSaDesc", a_valueSaDesc);}
      else
        check_stringVal(a_valueSaDesc->get_desc());
    }
}

/********************************************************************/

void check_valueSaPlain(
 valueSaPlain * a_valueSaPlain)
{
  if (a_valueSaPlain->get_saLabel())
    {
      if (!findString("a_saLabel", valueSaPlainAtts))
	{warnAtt("a_saLabel", "valueSaPlain", a_valueSaPlain);}
      else
        check_saLabel(a_valueSaPlain->get_saLabel());
    }
}

/********************************************************************/

void check_valueSaTipnum(
 valueSaTipnum * a_valueSaTipnum)
{
  if (a_valueSaTipnum->get_saLabel())
    {
      if (!findString("a_saLabel", valueSaTipnumAtts))
	{warnAtt("a_saLabel", "valueSaTipnum", a_valueSaTipnum);}
      else
        check_saLabel(a_valueSaTipnum->get_saLabel());
    }
  if (a_valueSaTipnum->get_tipnum())
    {
      if (!findString("tipnum", valueSaTipnumAtts))
	{warnAtt("tipnum", "valueSaTipnum", a_valueSaTipnum);}
      else
        check_intVal(a_valueSaTipnum->get_tipnum());
    }
}

/********************************************************************/

void check_valueSnsetReal(
 valueSnsetReal * a_valueSnsetReal)
{
  if (isA(a_valueSnsetReal, valueSnsetRealApprch))
    {
      if (!findString("valueSnsetRealApprch", valueSnsetRealSubs))
        {warnSub("valueSnsetRealApprch", "valueSnsetReal", a_valueSnsetReal);}
      return;
    }
  if (isA(a_valueSnsetReal, valueSnsetRealRetrct))
    {
      if (!findString("valueSnsetRealRetrct", valueSnsetRealSubs))
        {warnSub("valueSnsetRealRetrct", "valueSnsetReal", a_valueSnsetReal);}
      return;
    }
  if (isA(a_valueSnsetReal, valueSnsetRealSearch))
    {
      if (!findString("valueSnsetRealSearch", valueSnsetRealSubs))
        {warnSub("valueSnsetRealSearch", "valueSnsetReal", a_valueSnsetReal);}
      return;
    }
  if (isA(a_valueSnsetReal, valueSnsetRealClrsrf))
    {
      if (!findString("valueSnsetRealClrsrf", valueSnsetRealSubs))
        {warnSub("valueSnsetRealClrsrf", "valueSnsetReal", a_valueSnsetReal);}
      return;
    }
  if (isA(a_valueSnsetReal, valueSnsetRealDepth))
    {
      if (!findString("valueSnsetRealDepth", valueSnsetRealSubs))
        {warnSub("valueSnsetRealDepth", "valueSnsetReal", a_valueSnsetReal);}
      return;
    }
}

/********************************************************************/

void check_valueSnsetString(
 valueSnsetString * a_valueSnsetString)
{
  if (isA(a_valueSnsetString, valueSnsetString_CLRSRF))
    {
      if (!findString("valueSnsetString_CLRSRF", valueSnsetStringSubs))
        {warnSub("valueSnsetString_CLRSRF", "valueSnsetString", a_valueSnsetString);}
      return;
    }
  if (isA(a_valueSnsetString, valueSnsetString_DEPTH))
    {
      if (!findString("valueSnsetString_DEPTH", valueSnsetStringSubs))
        {warnSub("valueSnsetString_DEPTH", "valueSnsetString", a_valueSnsetString);}
      return;
    }
}

/********************************************************************/

void check_valueSnsmnt(
 valueSnsmnt * a_valueSnsmnt)
{
  if (isA(a_valueSnsmnt, valueSnsmnt_XVEC))
    {
      if (!findString("valueSnsmnt_XVEC", valueSnsmntSubs))
        {warnSub("valueSnsmnt_XVEC", "valueSnsmnt", a_valueSnsmnt);}
      return;
    }
  if (isA(a_valueSnsmnt, valueSnsmnt_ZVEC))
    {
      if (!findString("valueSnsmnt_ZVEC", valueSnsmntSubs))
        {warnSub("valueSnsmnt_ZVEC", "valueSnsmnt", a_valueSnsmnt);}
      return;
    }
  if (isA(a_valueSnsmnt, valueSnsmnt_MNTLEN))
    {
      if (!findString("valueSnsmnt_MNTLEN", valueSnsmntSubs))
        {warnSub("valueSnsmnt_MNTLEN", "valueSnsmnt", a_valueSnsmnt);}
      return;
    }
}

/********************************************************************/

void check_valueStm(
 valueStm * a_valueStm)
{
  if (isA(a_valueStm, valueStm_boolVar))
    {
      if (!findString("valueStm_boolVar", valueStmSubs))
        {warnSub("valueStm_boolVar", "valueStm", a_valueStm);}
      else
        check_valueStm_boolVar(dynamic_cast<valueStm_boolVar *>(a_valueStm));
      return;
    }
  if (isA(a_valueStm, valueStm_stringVar))
    {
      if (!findString("valueStm_stringVar", valueStmSubs))
        {warnSub("valueStm_stringVar", "valueStm", a_valueStm);}
      else
        check_valueStm_stringVar(dynamic_cast<valueStm_stringVar *>(a_valueStm));
      return;
    }
  if (isA(a_valueStm, valueStm_intVar))
    {
      if (!findString("valueStm_intVar", valueStmSubs))
        {warnSub("valueStm_intVar", "valueStm", a_valueStm);}
      else
        check_valueStm_intVar(dynamic_cast<valueStm_intVar *>(a_valueStm));
      return;
    }
  if (isA(a_valueStm, valueStm_realVar))
    {
      if (!findString("valueStm_realVar", valueStmSubs))
        {warnSub("valueStm_realVar", "valueStm", a_valueStm);}
      else
        check_valueStm_realVar(dynamic_cast<valueStm_realVar *>(a_valueStm));
      return;
    }
  if (isA(a_valueStm, valueStm_vectorVar))
    {
      if (!findString("valueStm_vectorVar", valueStmSubs))
        {warnSub("valueStm_vectorVar", "valueStm", a_valueStm);}
      else
        check_valueStm_vectorVar(dynamic_cast<valueStm_vectorVar *>(a_valueStm));
      return;
    }
}

/********************************************************************/

void check_valueStm_boolVar(
 valueStm_boolVar * a_valueStm_boolVar)
{
  if (a_valueStm_boolVar->get_boolVar())
    {
      if (!findString("a_boolVar", valueStm_boolVarAtts))
	{warnAtt("a_boolVar", "valueStm_boolVar", a_valueStm_boolVar);}
      else
        check_boolVar(a_valueStm_boolVar->get_boolVar());
    }
  if (a_valueStm_boolVar->get_valueMinorBool())
    {
      if (!findString("a_valueMinorBool", valueStm_boolVarAtts))
	{warnAtt("a_valueMinorBool", "valueStm_boolVar", a_valueStm_boolVar);}
      else
        check_valueMinorBool(a_valueStm_boolVar->get_valueMinorBool());
    }
}

/********************************************************************/

void check_valueStm_intVar(
 valueStm_intVar * a_valueStm_intVar)
{
  if (a_valueStm_intVar->get_intVar())
    {
      if (!findString("a_intVar", valueStm_intVarAtts))
	{warnAtt("a_intVar", "valueStm_intVar", a_valueStm_intVar);}
      else
        check_intVar(a_valueStm_intVar->get_intVar());
    }
  if (a_valueStm_intVar->get_valueMinorInt())
    {
      if (!findString("a_valueMinorInt", valueStm_intVarAtts))
	{warnAtt("a_valueMinorInt", "valueStm_intVar", a_valueStm_intVar);}
      else
        check_valueMinorInt(a_valueStm_intVar->get_valueMinorInt());
    }
}

/********************************************************************/

void check_valueStm_realVar(
 valueStm_realVar * a_valueStm_realVar)
{
  if (a_valueStm_realVar->get_realVar())
    {
      if (!findString("a_realVar", valueStm_realVarAtts))
	{warnAtt("a_realVar", "valueStm_realVar", a_valueStm_realVar);}
      else
        check_realVar(a_valueStm_realVar->get_realVar());
    }
  if (a_valueStm_realVar->get_valueMinorReal())
    {
      if (!findString("a_valueMinorReal", valueStm_realVarAtts))
	{warnAtt("a_valueMinorReal", "valueStm_realVar", a_valueStm_realVar);}
      else
        check_valueMinorReal(a_valueStm_realVar->get_valueMinorReal());
    }
}

/********************************************************************/

void check_valueStm_stringVar(
 valueStm_stringVar * a_valueStm_stringVar)
{
  if (a_valueStm_stringVar->get_stringVar())
    {
      if (!findString("a_stringVar", valueStm_stringVarAtts))
	{warnAtt("a_stringVar", "valueStm_stringVar", a_valueStm_stringVar);}
      else
        check_stringVar(a_valueStm_stringVar->get_stringVar());
    }
  if (a_valueStm_stringVar->get_valueMinorString())
    {
      if (!findString("a_valueMinorString", valueStm_stringVarAtts))
	{warnAtt("a_valueMinorString", "valueStm_stringVar", a_valueStm_stringVar);}
      else
        check_valueMinorString(a_valueStm_stringVar->get_valueMinorString());
    }
}

/********************************************************************/

void check_valueStm_vectorVar(
 valueStm_vectorVar * a_valueStm_vectorVar)
{
  if (a_valueStm_vectorVar->get_vectorVar())
    {
      if (!findString("a_vectorVar", valueStm_vectorVarAtts))
	{warnAtt("a_vectorVar", "valueStm_vectorVar", a_valueStm_vectorVar);}
      else
        check_vectorVar(a_valueStm_vectorVar->get_vectorVar());
    }
  if (a_valueStm_vectorVar->get_valueMinorVector())
    {
      if (!findString("a_valueMinorVector", valueStm_vectorVarAtts))
	{warnAtt("a_valueMinorVector", "valueStm_vectorVar", a_valueStm_vectorVar);}
      else
        check_valueMinorVector(a_valueStm_vectorVar->get_valueMinorVector());
    }
}

/********************************************************************/

void check_valueSw(
 valueSw * a_valueSw)
{
  if (a_valueSw->get_swLabel())
    {
      if (!findString("a_swLabel", valueSwAtts))
	{warnAtt("a_swLabel", "valueSw", a_valueSw);}
      else
        check_swLabel(a_valueSw->get_swLabel());
    }
  if (a_valueSw->get_anglename())
    {
      if (!findString("anglename", valueSwAtts))
	{warnAtt("anglename", "valueSw", a_valueSw);}
      else
        check_stringVal(a_valueSw->get_anglename());
    }
}

/********************************************************************/

void check_valueTaBool(
 valueTaBool * a_valueTaBool)
{
  if (isA(a_valueTaBool, valueTaBoolIntol))
    {
      if (!findString("valueTaBoolIntol", valueTaBoolSubs))
        {warnSub("valueTaBoolIntol", "valueTaBool", a_valueTaBool);}
      else
        check_valueTaBoolIntol(dynamic_cast<valueTaBoolIntol *>(a_valueTaBool));
      return;
    }
  if (isA(a_valueTaBool, valueTaBoolOutol))
    {
      if (!findString("valueTaBoolOutol", valueTaBoolSubs))
        {warnSub("valueTaBoolOutol", "valueTaBool", a_valueTaBool);}
      else
        check_valueTaBoolOutol(dynamic_cast<valueTaBoolOutol *>(a_valueTaBool));
      return;
    }
}

/********************************************************************/

void check_valueTaBoolIntol(
 valueTaBoolIntol * a_valueTaBoolIntol)
{
  if (a_valueTaBoolIntol->get_taLabel())
    {
      if (!findString("a_taLabel", valueTaBoolIntolAtts))
	{warnAtt("a_taLabel", "valueTaBoolIntol", a_valueTaBoolIntol);}
      else
        check_taLabel(a_valueTaBoolIntol->get_taLabel());
    }
  if (a_valueTaBoolIntol->get_tolnum())
    {
      if (!findString("tolnum", valueTaBoolIntolAtts))
	{warnAtt("tolnum", "valueTaBoolIntol", a_valueTaBoolIntol);}
      else
        check_intVal(a_valueTaBoolIntol->get_tolnum());
    }
}

/********************************************************************/

void check_valueTaBoolOutol(
 valueTaBoolOutol * a_valueTaBoolOutol)
{
  if (a_valueTaBoolOutol->get_taLabel())
    {
      if (!findString("a_taLabel", valueTaBoolOutolAtts))
	{warnAtt("a_taLabel", "valueTaBoolOutol", a_valueTaBoolOutol);}
      else
        check_taLabel(a_valueTaBoolOutol->get_taLabel());
    }
  if (a_valueTaBoolOutol->get_tolnum())
    {
      if (!findString("tolnum", valueTaBoolOutolAtts))
	{warnAtt("tolnum", "valueTaBoolOutol", a_valueTaBoolOutol);}
      else
        check_intVal(a_valueTaBoolOutol->get_tolnum());
    }
}

/********************************************************************/

void check_valueTaReal(
 valueTaReal * a_valueTaReal)
{
  if (isA(a_valueTaReal, valueTaRealAct))
    {
      if (!findString("valueTaRealAct", valueTaRealSubs))
        {warnSub("valueTaRealAct", "valueTaReal", a_valueTaReal);}
      else
        check_valueTaRealAct(dynamic_cast<valueTaRealAct *>(a_valueTaReal));
      return;
    }
  if (isA(a_valueTaReal, valueTaRealDev))
    {
      if (!findString("valueTaRealDev", valueTaRealSubs))
        {warnSub("valueTaRealDev", "valueTaReal", a_valueTaReal);}
      else
        check_valueTaRealDev(dynamic_cast<valueTaRealDev *>(a_valueTaReal));
      return;
    }
  if (isA(a_valueTaReal, valueTaRealAmt))
    {
      if (!findString("valueTaRealAmt", valueTaRealSubs))
        {warnSub("valueTaRealAmt", "valueTaReal", a_valueTaReal);}
      else
        check_valueTaRealAmt(dynamic_cast<valueTaRealAmt *>(a_valueTaReal));
      return;
    }
}

/********************************************************************/

void check_valueTaRealAct(
 valueTaRealAct * a_valueTaRealAct)
{
  if (a_valueTaRealAct->get_taLabel())
    {
      if (!findString("a_taLabel", valueTaRealActAtts))
	{warnAtt("a_taLabel", "valueTaRealAct", a_valueTaRealAct);}
      else
        check_taLabel(a_valueTaRealAct->get_taLabel());
    }
  if (a_valueTaRealAct->get_tolnum())
    {
      if (!findString("tolnum", valueTaRealActAtts))
	{warnAtt("tolnum", "valueTaRealAct", a_valueTaRealAct);}
      else
        check_intVal(a_valueTaRealAct->get_tolnum());
    }
}

/********************************************************************/

void check_valueTaRealAmt(
 valueTaRealAmt * a_valueTaRealAmt)
{
  if (a_valueTaRealAmt->get_taLabel())
    {
      if (!findString("a_taLabel", valueTaRealAmtAtts))
	{warnAtt("a_taLabel", "valueTaRealAmt", a_valueTaRealAmt);}
      else
        check_taLabel(a_valueTaRealAmt->get_taLabel());
    }
  if (a_valueTaRealAmt->get_tolnum())
    {
      if (!findString("tolnum", valueTaRealAmtAtts))
	{warnAtt("tolnum", "valueTaRealAmt", a_valueTaRealAmt);}
      else
        check_intVal(a_valueTaRealAmt->get_tolnum());
    }
}

/********************************************************************/

void check_valueTaRealDev(
 valueTaRealDev * a_valueTaRealDev)
{
  if (a_valueTaRealDev->get_taLabel())
    {
      if (!findString("a_taLabel", valueTaRealDevAtts))
	{warnAtt("a_taLabel", "valueTaRealDev", a_valueTaRealDev);}
      else
        check_taLabel(a_valueTaRealDev->get_taLabel());
    }
  if (a_valueTaRealDev->get_tolnum())
    {
      if (!findString("tolnum", valueTaRealDevAtts))
	{warnAtt("tolnum", "valueTaRealDev", a_valueTaRealDev);}
      else
        check_intVal(a_valueTaRealDev->get_tolnum());
    }
}

/********************************************************************/

void check_valueUnits(
 valueUnits * a_valueUnits)
{
  if (isA(a_valueUnits, valueUnits_DIST))
    {
      if (!findString("valueUnits_DIST", valueUnitsSubs))
        {warnSub("valueUnits_DIST", "valueUnits", a_valueUnits);}
      return;
    }
  if (isA(a_valueUnits, valueUnits_ANGL))
    {
      if (!findString("valueUnits_ANGL", valueUnitsSubs))
        {warnSub("valueUnits_ANGL", "valueUnits", a_valueUnits);}
      return;
    }
  if (isA(a_valueUnits, valueUnits_TEMP))
    {
      if (!findString("valueUnits_TEMP", valueUnitsSubs))
        {warnSub("valueUnits_TEMP", "valueUnits", a_valueUnits);}
      return;
    }
}

/********************************************************************/

void check_vecExpr_MINUS(
 vecExpr_MINUS * a_vecExpr_MINUS)
{
  if (a_vecExpr_MINUS->get_term1())
    {
      if (!findString("term1", vecExpr_MINUSAtts))
	{warnAtt("term1", "vecExpr_MINUS", a_vecExpr_MINUS);}
      else
        check_vectorVal(a_vecExpr_MINUS->get_term1());
    }
  if (a_vecExpr_MINUS->get_term2())
    {
      if (!findString("term2", vecExpr_MINUSAtts))
	{warnAtt("term2", "vecExpr_MINUS", a_vecExpr_MINUS);}
      else
        check_vectorVal(a_vecExpr_MINUS->get_term2());
    }
}

/********************************************************************/

void check_vecExpr_PAREN(
 vecExpr_PAREN * a_vecExpr_PAREN)
{
  if (a_vecExpr_PAREN->get_vectorVal())
    {
      if (!findString("a_vectorVal", vecExpr_PARENAtts))
	{warnAtt("a_vectorVal", "vecExpr_PAREN", a_vecExpr_PAREN);}
      else
        check_vectorVal(a_vecExpr_PAREN->get_vectorVal());
    }
}

/********************************************************************/

void check_vecExpr_PLUS(
 vecExpr_PLUS * a_vecExpr_PLUS)
{
  if (a_vecExpr_PLUS->get_term1())
    {
      if (!findString("term1", vecExpr_PLUSAtts))
	{warnAtt("term1", "vecExpr_PLUS", a_vecExpr_PLUS);}
      else
        check_vectorVal(a_vecExpr_PLUS->get_term1());
    }
  if (a_vecExpr_PLUS->get_term2())
    {
      if (!findString("term2", vecExpr_PLUSAtts))
	{warnAtt("term2", "vecExpr_PLUS", a_vecExpr_PLUS);}
      else
        check_vectorVal(a_vecExpr_PLUS->get_term2());
    }
}

/********************************************************************/

void check_vecIntExpr_DIVID(
 vecIntExpr_DIVID * a_vecIntExpr_DIVID)
{
  if (a_vecIntExpr_DIVID->get_dvend())
    {
      if (!findString("dvend", vecIntExpr_DIVIDAtts))
	{warnAtt("dvend", "vecIntExpr_DIVID", a_vecIntExpr_DIVID);}
      else
        check_vectorVal(a_vecIntExpr_DIVID->get_dvend());
    }
  if (a_vecIntExpr_DIVID->get_dvisr())
    {
      if (!findString("dvisr", vecIntExpr_DIVIDAtts))
	{warnAtt("dvisr", "vecIntExpr_DIVID", a_vecIntExpr_DIVID);}
      else
        check_intVal(a_vecIntExpr_DIVID->get_dvisr());
    }
}

/********************************************************************/

void check_vecIntExpr_TIMES(
 vecIntExpr_TIMES * a_vecIntExpr_TIMES)
{
  if (a_vecIntExpr_TIMES->get_term1())
    {
      if (!findString("term1", vecIntExpr_TIMESAtts))
	{warnAtt("term1", "vecIntExpr_TIMES", a_vecIntExpr_TIMES);}
      else
        check_vectorVal(a_vecIntExpr_TIMES->get_term1());
    }
  if (a_vecIntExpr_TIMES->get_term2())
    {
      if (!findString("term2", vecIntExpr_TIMESAtts))
	{warnAtt("term2", "vecIntExpr_TIMES", a_vecIntExpr_TIMES);}
      else
        check_intVal(a_vecIntExpr_TIMES->get_term2());
    }
}

/********************************************************************/

void check_vecRealExpr_DIVID(
 vecRealExpr_DIVID * a_vecRealExpr_DIVID)
{
  if (a_vecRealExpr_DIVID->get_dvend())
    {
      if (!findString("dvend", vecRealExpr_DIVIDAtts))
	{warnAtt("dvend", "vecRealExpr_DIVID", a_vecRealExpr_DIVID);}
      else
        check_vectorVal(a_vecRealExpr_DIVID->get_dvend());
    }
  if (a_vecRealExpr_DIVID->get_dvisr())
    {
      if (!findString("dvisr", vecRealExpr_DIVIDAtts))
	{warnAtt("dvisr", "vecRealExpr_DIVID", a_vecRealExpr_DIVID);}
      else
        check_realVal(a_vecRealExpr_DIVID->get_dvisr());
    }
}

/********************************************************************/

void check_vecRealExpr_TIMES(
 vecRealExpr_TIMES * a_vecRealExpr_TIMES)
{
  if (a_vecRealExpr_TIMES->get_term1())
    {
      if (!findString("term1", vecRealExpr_TIMESAtts))
	{warnAtt("term1", "vecRealExpr_TIMES", a_vecRealExpr_TIMES);}
      else
        check_vectorVal(a_vecRealExpr_TIMES->get_term1());
    }
  if (a_vecRealExpr_TIMES->get_term2())
    {
      if (!findString("term2", vecRealExpr_TIMESAtts))
	{warnAtt("term2", "vecRealExpr_TIMES", a_vecRealExpr_TIMES);}
      else
        check_realVal(a_vecRealExpr_TIMES->get_term2());
    }
}

/********************************************************************/

void check_vector(
 vector * a_vector)
{
  if (a_vector->get_i())
    {
      if (!findString("i", vectorAtts))
	{warnAtt("i", "vector", a_vector);}
      else
        check_rentVal(a_vector->get_i());
    }
  if (a_vector->get_j())
    {
      if (!findString("j", vectorAtts))
	{warnAtt("j", "vector", a_vector);}
      else
        check_rentVal(a_vector->get_j());
    }
  if (a_vector->get_k())
    {
      if (!findString("k", vectorAtts))
	{warnAtt("k", "vector", a_vector);}
      else
        check_rentVal(a_vector->get_k());
    }
}

/********************************************************************/

void check_vectorExpr(
 vectorExpr * a_vectorExpr)
{
  if (isA(a_vectorExpr, vecExpr_PAREN))
    {
      if (!findString("vecExpr_PAREN", vectorExprSubs))
        {warnSub("vecExpr_PAREN", "vectorExpr", a_vectorExpr);}
      else
        check_vecExpr_PAREN(dynamic_cast<vecExpr_PAREN *>(a_vectorExpr));
      return;
    }
  if (isA(a_vectorExpr, vecExpr_PLUS))
    {
      if (!findString("vecExpr_PLUS", vectorExprSubs))
        {warnSub("vecExpr_PLUS", "vectorExpr", a_vectorExpr);}
      else
        check_vecExpr_PLUS(dynamic_cast<vecExpr_PLUS *>(a_vectorExpr));
      return;
    }
  if (isA(a_vectorExpr, vecExpr_MINUS))
    {
      if (!findString("vecExpr_MINUS", vectorExprSubs))
        {warnSub("vecExpr_MINUS", "vectorExpr", a_vectorExpr);}
      else
        check_vecExpr_MINUS(dynamic_cast<vecExpr_MINUS *>(a_vectorExpr));
      return;
    }
  if (isA(a_vectorExpr, vecRealExpr_DIVID))
    {
      if (!findString("vecRealExpr_DIVID", vectorExprSubs))
        {warnSub("vecRealExpr_DIVID", "vectorExpr", a_vectorExpr);}
      else
        check_vecRealExpr_DIVID(dynamic_cast<vecRealExpr_DIVID *>(a_vectorExpr));
      return;
    }
  if (isA(a_vectorExpr, vecIntExpr_DIVID))
    {
      if (!findString("vecIntExpr_DIVID", vectorExprSubs))
        {warnSub("vecIntExpr_DIVID", "vectorExpr", a_vectorExpr);}
      else
        check_vecIntExpr_DIVID(dynamic_cast<vecIntExpr_DIVID *>(a_vectorExpr));
      return;
    }
  if (isA(a_vectorExpr, vecRealExpr_TIMES))
    {
      if (!findString("vecRealExpr_TIMES", vectorExprSubs))
        {warnSub("vecRealExpr_TIMES", "vectorExpr", a_vectorExpr);}
      else
        check_vecRealExpr_TIMES(dynamic_cast<vecRealExpr_TIMES *>(a_vectorExpr));
      return;
    }
  if (isA(a_vectorExpr, realVecExpr_TIMES))
    {
      if (!findString("realVecExpr_TIMES", vectorExprSubs))
        {warnSub("realVecExpr_TIMES", "vectorExpr", a_vectorExpr);}
      else
        check_realVecExpr_TIMES(dynamic_cast<realVecExpr_TIMES *>(a_vectorExpr));
      return;
    }
  if (isA(a_vectorExpr, vecIntExpr_TIMES))
    {
      if (!findString("vecIntExpr_TIMES", vectorExprSubs))
        {warnSub("vecIntExpr_TIMES", "vectorExpr", a_vectorExpr);}
      else
        check_vecIntExpr_TIMES(dynamic_cast<vecIntExpr_TIMES *>(a_vectorExpr));
      return;
    }
  if (isA(a_vectorExpr, intVecExpr_TIMES))
    {
      if (!findString("intVecExpr_TIMES", vectorExprSubs))
        {warnSub("intVecExpr_TIMES", "vectorExpr", a_vectorExpr);}
      else
        check_intVecExpr_TIMES(dynamic_cast<intVecExpr_TIMES *>(a_vectorExpr));
      return;
    }
}

/********************************************************************/

void check_vectorFunc(
 vectorFunc * a_vectorFunc)
{
  if (isA(a_vectorFunc, vectorFuncVcart))
    {
      if (!findString("vectorFuncVcart", vectorFuncSubs))
        {warnSub("vectorFuncVcart", "vectorFunc", a_vectorFunc);}
      else
        check_vectorFuncVcart(dynamic_cast<vectorFuncVcart *>(a_vectorFunc));
      return;
    }
  if (isA(a_vectorFunc, vectorFuncVcross))
    {
      if (!findString("vectorFuncVcross", vectorFuncSubs))
        {warnSub("vectorFuncVcross", "vectorFunc", a_vectorFunc);}
      else
        check_vectorFuncVcross(dynamic_cast<vectorFuncVcross *>(a_vectorFunc));
      return;
    }
  if (isA(a_vectorFunc, vectorFuncVmcs))
    {
      if (!findString("vectorFuncVmcs", vectorFuncSubs))
        {warnSub("vectorFuncVmcs", "vectorFunc", a_vectorFunc);}
      else
        check_vectorFuncVmcs(dynamic_cast<vectorFuncVmcs *>(a_vectorFunc));
      return;
    }
  if (isA(a_vectorFunc, vectorFuncVpcs))
    {
      if (!findString("vectorFuncVpcs", vectorFuncSubs))
        {warnSub("vectorFuncVpcs", "vectorFunc", a_vectorFunc);}
      else
        check_vectorFuncVpcs(dynamic_cast<vectorFuncVpcs *>(a_vectorFunc));
      return;
    }
  if (isA(a_vectorFunc, vectorFuncVpol))
    {
      if (!findString("vectorFuncVpol", vectorFuncSubs))
        {warnSub("vectorFuncVpol", "vectorFunc", a_vectorFunc);}
      else
        check_vectorFuncVpol(dynamic_cast<vectorFuncVpol *>(a_vectorFunc));
      return;
    }
  if (isA(a_vectorFunc, vectorFuncVunit))
    {
      if (!findString("vectorFuncVunit", vectorFuncSubs))
        {warnSub("vectorFuncVunit", "vectorFunc", a_vectorFunc);}
      else
        check_vectorFuncVunit(dynamic_cast<vectorFuncVunit *>(a_vectorFunc));
      return;
    }
}

/********************************************************************/

void check_vectorFuncVcart(
 vectorFuncVcart * a_vectorFuncVcart)
{
  if (a_vectorFuncVcart->get_x())
    {
      if (!findString("x", vectorFuncVcartAtts))
	{warnAtt("x", "vectorFuncVcart", a_vectorFuncVcart);}
      else
        check_rentVal(a_vectorFuncVcart->get_x());
    }
  if (a_vectorFuncVcart->get_y())
    {
      if (!findString("y", vectorFuncVcartAtts))
	{warnAtt("y", "vectorFuncVcart", a_vectorFuncVcart);}
      else
        check_rentVal(a_vectorFuncVcart->get_y());
    }
  if (a_vectorFuncVcart->get_z())
    {
      if (!findString("z", vectorFuncVcartAtts))
	{warnAtt("z", "vectorFuncVcart", a_vectorFuncVcart);}
      else
        check_rentVal(a_vectorFuncVcart->get_z());
    }
}

/********************************************************************/

void check_vectorFuncVcross(
 vectorFuncVcross * a_vectorFuncVcross)
{
  if (a_vectorFuncVcross->get_v1())
    {
      if (!findString("v1", vectorFuncVcrossAtts))
	{warnAtt("v1", "vectorFuncVcross", a_vectorFuncVcross);}
      else
        check_vectorVal(a_vectorFuncVcross->get_v1());
    }
  if (a_vectorFuncVcross->get_v2())
    {
      if (!findString("v2", vectorFuncVcrossAtts))
	{warnAtt("v2", "vectorFuncVcross", a_vectorFuncVcross);}
      else
        check_vectorVal(a_vectorFuncVcross->get_v2());
    }
}

/********************************************************************/

void check_vectorFuncVmcs(
 vectorFuncVmcs * a_vectorFuncVmcs)
{
  if (a_vectorFuncVmcs->get_vectorVal())
    {
      if (!findString("a_vectorVal", vectorFuncVmcsAtts))
	{warnAtt("a_vectorVal", "vectorFuncVmcs", a_vectorFuncVmcs);}
      else
        check_vectorVal(a_vectorFuncVmcs->get_vectorVal());
    }
}

/********************************************************************/

void check_vectorFuncVpcs(
 vectorFuncVpcs * a_vectorFuncVpcs)
{
  if (a_vectorFuncVpcs->get_vectorVal())
    {
      if (!findString("a_vectorVal", vectorFuncVpcsAtts))
	{warnAtt("a_vectorVal", "vectorFuncVpcs", a_vectorFuncVpcs);}
      else
        check_vectorVal(a_vectorFuncVpcs->get_vectorVal());
    }
}

/********************************************************************/

void check_vectorFuncVpol(
 vectorFuncVpol * a_vectorFuncVpol)
{
  if (a_vectorFuncVpol->get_r())
    {
      if (!findString("r", vectorFuncVpolAtts))
	{warnAtt("r", "vectorFuncVpol", a_vectorFuncVpol);}
      else
        check_rentVal(a_vectorFuncVpol->get_r());
    }
  if (a_vectorFuncVpol->get_a())
    {
      if (!findString("a", vectorFuncVpolAtts))
	{warnAtt("a", "vectorFuncVpol", a_vectorFuncVpol);}
      else
        check_angle(a_vectorFuncVpol->get_a());
    }
  if (a_vectorFuncVpol->get_h())
    {
      if (!findString("h", vectorFuncVpolAtts))
	{warnAtt("h", "vectorFuncVpol", a_vectorFuncVpol);}
      else
        check_rentVal(a_vectorFuncVpol->get_h());
    }
}

/********************************************************************/

void check_vectorFuncVunit(
 vectorFuncVunit * a_vectorFuncVunit)
{
  if (a_vectorFuncVunit->get_vectorVal())
    {
      if (!findString("a_vectorVal", vectorFuncVunitAtts))
	{warnAtt("a_vectorVal", "vectorFuncVunit", a_vectorFuncVunit);}
      else
        check_vectorVal(a_vectorFuncVunit->get_vectorVal());
    }
}

/********************************************************************/

void check_vectorRel(
 vectorRel * a_vectorRel)
{
  if (isA(a_vectorRel, vectorRel_EQ))
    {
      if (!findString("vectorRel_EQ", vectorRelSubs))
        {warnSub("vectorRel_EQ", "vectorRel", a_vectorRel);}
      else
        check_vectorRel_EQ(dynamic_cast<vectorRel_EQ *>(a_vectorRel));
      return;
    }
  if (isA(a_vectorRel, vectorRel_NE))
    {
      if (!findString("vectorRel_NE", vectorRelSubs))
        {warnSub("vectorRel_NE", "vectorRel", a_vectorRel);}
      else
        check_vectorRel_NE(dynamic_cast<vectorRel_NE *>(a_vectorRel));
      return;
    }
}

/********************************************************************/

void check_vectorRel_EQ(
 vectorRel_EQ * a_vectorRel_EQ)
{
  if (a_vectorRel_EQ->get_left())
    {
      if (!findString("left", vectorRel_EQAtts))
	{warnAtt("left", "vectorRel_EQ", a_vectorRel_EQ);}
      else
        check_vectorVal(a_vectorRel_EQ->get_left());
    }
  if (a_vectorRel_EQ->get_right())
    {
      if (!findString("right", vectorRel_EQAtts))
	{warnAtt("right", "vectorRel_EQ", a_vectorRel_EQ);}
      else
        check_vectorVal(a_vectorRel_EQ->get_right());
    }
}

/********************************************************************/

void check_vectorRel_NE(
 vectorRel_NE * a_vectorRel_NE)
{
  if (a_vectorRel_NE->get_left())
    {
      if (!findString("left", vectorRel_NEAtts))
	{warnAtt("left", "vectorRel_NE", a_vectorRel_NE);}
      else
        check_vectorVal(a_vectorRel_NE->get_left());
    }
  if (a_vectorRel_NE->get_right())
    {
      if (!findString("right", vectorRel_NEAtts))
	{warnAtt("right", "vectorRel_NE", a_vectorRel_NE);}
      else
        check_vectorVal(a_vectorRel_NE->get_right());
    }
}

/********************************************************************/

void check_vectorVal(
 vectorVal * a_vectorVal)
{
  if (isA(a_vectorVal, vectorFunc))
    {
      if (!findString("vectorFunc", vectorValSubs))
        {warnSub("vectorFunc", "vectorVal", a_vectorVal);}
      else
        check_vectorFunc(dynamic_cast<vectorFunc *>(a_vectorVal));
      return;
    }
  if (isA(a_vectorVal, vectorExpr))
    {
      if (!findString("vectorExpr", vectorValSubs))
        {warnSub("vectorExpr", "vectorVal", a_vectorVal);}
      else
        check_vectorExpr(dynamic_cast<vectorExpr *>(a_vectorVal));
      return;
    }
  if (isA(a_vectorVal, vectorVar))
    {
      if (!findString("vectorVar", vectorValSubs))
        {warnSub("vectorVar", "vectorVal", a_vectorVal);}
      else
        check_vectorVar(dynamic_cast<vectorVar *>(a_vectorVal));
      return;
    }
}

/********************************************************************/

void check_vectorVar(
 vectorVar * a_vectorVar)
{
  if (a_vectorVar->get_string())
    {
      if (!findString("a_string", vectorVarAtts))
	{warnAtt("a_string", "vectorVar", a_vectorVar);}
    }
  if (a_vectorVar->get_arrayIndex())
    {
      if (!findString("a_arrayIndex", vectorVarAtts))
	{warnAtt("a_arrayIndex", "vectorVar", a_vectorVar);}
      else
        check_arrayIndex(a_vectorVar->get_arrayIndex());
    }
}

/********************************************************************/

void check_versionTag(
 versionTag * a_versionTag)
{
  if (a_versionTag->get_double())
    {
      if (!findString("a_double", versionTagAtts))
	{warnAtt("a_double", "versionTag", a_versionTag);}
    }
}

/********************************************************************/

void check_vertexConst(
 vertexConst * a_vertexConst)
{
  if (a_vertexConst->get_faLabel())
    {
      if (!findString("a_faLabel", vertexConstAtts))
	{warnAtt("a_faLabel", "vertexConst", a_vertexConst);}
      else
        check_faLabel(a_vertexConst->get_faLabel());
    }
}

/********************************************************************/

void check_vfLabel(
 vfLabel * a_vfLabel)
{
  if (a_vfLabel->get_labelName())
    {
      if (!findString("a_labelName", vfLabelAtts))
	{warnAtt("a_labelName", "vfLabel", a_vfLabel);}
      else
        check_labelName(a_vfLabel->get_labelName());
    }
}

/********************************************************************/

void check_vformItem(
 vformItem * a_vformItem)
{
  if (isA(a_vformItem, vformItem_NOM))
    {
      if (!findString("vformItem_NOM", vformItemSubs))
        {warnSub("vformItem_NOM", "vformItem", a_vformItem);}
      else
        check_vformItem_NOM(dynamic_cast<vformItem_NOM *>(a_vformItem));
      return;
    }
  if (isA(a_vformItem, vformItem_ACT))
    {
      if (!findString("vformItem_ACT", vformItemSubs))
        {warnSub("vformItem_ACT", "vformItem", a_vformItem);}
      else
        check_vformItem_ACT(dynamic_cast<vformItem_ACT *>(a_vformItem));
      return;
    }
  if (isA(a_vformItem, vformItem_DEV))
    {
      if (!findString("vformItem_DEV", vformItemSubs))
        {warnSub("vformItem_DEV", "vformItem", a_vformItem);}
      else
        check_vformItem_DEV(dynamic_cast<vformItem_DEV *>(a_vformItem));
      return;
    }
  if (isA(a_vformItem, vformItem_AMT))
    {
      if (!findString("vformItem_AMT", vformItemSubs))
        {warnSub("vformItem_AMT", "vformItem", a_vformItem);}
      else
        check_vformItem_AMT(dynamic_cast<vformItem_AMT *>(a_vformItem));
      return;
    }
  if (isA(a_vformItem, vformItem_HIST))
    {
      if (!findString("vformItem_HIST", vformItemSubs))
        {warnSub("vformItem_HIST", "vformItem", a_vformItem);}
      else
        check_vformItem_HIST(dynamic_cast<vformItem_HIST *>(a_vformItem));
      return;
    }
  if (isA(a_vformItem, vformItem_PLOT))
    {
      if (!findString("vformItem_PLOT", vformItemSubs))
        {warnSub("vformItem_PLOT", "vformItem", a_vformItem);}
      else
        check_vformItem_PLOT(dynamic_cast<vformItem_PLOT *>(a_vformItem));
      return;
    }
  if (isA(a_vformItem, vformItem_STAT))
    {
      if (!findString("vformItem_STAT", vformItemSubs))
        {warnSub("vformItem_STAT", "vformItem", a_vformItem);}
      else
        check_vformItem_STAT(dynamic_cast<vformItem_STAT *>(a_vformItem));
      return;
    }
  if (isA(a_vformItem, vformItem_ALL))
    {
      if (!findString("vformItem_ALL", vformItemSubs))
        {warnSub("vformItem_ALL", "vformItem", a_vformItem);}
      return;
    }
  if (isA(a_vformItem, vformItem_DME))
    {
      if (!findString("vformItem_DME", vformItemSubs))
        {warnSub("vformItem_DME", "vformItem", a_vformItem);}
      else
        check_vformItem_DME(dynamic_cast<vformItem_DME *>(a_vformItem));
      return;
    }
}

/********************************************************************/

void check_vformItem_ACT(
 vformItem_ACT * a_vformItem_ACT)
{
  if (a_vformItem_ACT->get_text())
    {
      if (!findString("text", vformItem_ACTAtts))
	{warnAtt("text", "vformItem_ACT", a_vformItem_ACT);}
      else
        check_stringVal(a_vformItem_ACT->get_text());
    }
}

/********************************************************************/

void check_vformItem_AMT(
 vformItem_AMT * a_vformItem_AMT)
{
  if (a_vformItem_AMT->get_text())
    {
      if (!findString("text", vformItem_AMTAtts))
	{warnAtt("text", "vformItem_AMT", a_vformItem_AMT);}
      else
        check_stringVal(a_vformItem_AMT->get_text());
    }
}

/********************************************************************/

void check_vformItem_DEV(
 vformItem_DEV * a_vformItem_DEV)
{
  if (a_vformItem_DEV->get_text())
    {
      if (!findString("text", vformItem_DEVAtts))
	{warnAtt("text", "vformItem_DEV", a_vformItem_DEV);}
      else
        check_stringVal(a_vformItem_DEV->get_text());
    }
}

/********************************************************************/

void check_vformItem_DME(
 vformItem_DME * a_vformItem_DME)
{
  if (a_vformItem_DME->get_text())
    {
      if (!findString("text", vformItem_DMEAtts))
	{warnAtt("text", "vformItem_DME", a_vformItem_DME);}
      else
        check_stringVal(a_vformItem_DME->get_text());
    }
}

/********************************************************************/

void check_vformItem_HIST(
 vformItem_HIST * a_vformItem_HIST)
{
  if (a_vformItem_HIST->get_text())
    {
      if (!findString("text", vformItem_HISTAtts))
	{warnAtt("text", "vformItem_HIST", a_vformItem_HIST);}
      else
        check_stringVal(a_vformItem_HIST->get_text());
    }
}

/********************************************************************/

void check_vformItem_NOM(
 vformItem_NOM * a_vformItem_NOM)
{
  if (a_vformItem_NOM->get_text())
    {
      if (!findString("text", vformItem_NOMAtts))
	{warnAtt("text", "vformItem_NOM", a_vformItem_NOM);}
      else
        check_stringVal(a_vformItem_NOM->get_text());
    }
}

/********************************************************************/

void check_vformItem_PLOT(
 vformItem_PLOT * a_vformItem_PLOT)
{
  if (a_vformItem_PLOT->get_text())
    {
      if (!findString("text", vformItem_PLOTAtts))
	{warnAtt("text", "vformItem_PLOT", a_vformItem_PLOT);}
      else
        check_stringVal(a_vformItem_PLOT->get_text());
    }
}

/********************************************************************/

void check_vformItem_STAT(
 vformItem_STAT * a_vformItem_STAT)
{
  if (a_vformItem_STAT->get_text())
    {
      if (!findString("text", vformItem_STATAtts))
	{warnAtt("text", "vformItem_STAT", a_vformItem_STAT);}
      else
        check_stringVal(a_vformItem_STAT->get_text());
    }
}

/********************************************************************/

void check_vformStm(
 vformStm * a_vformStm)
{
  if (a_vformStm->get_vLabel())
    {
      if (!findString("a_vLabel", vformStmAtts))
	{warnAtt("a_vLabel", "vformStm", a_vformStm);}
      else
        check_vLabel(a_vformStm->get_vLabel());
    }
  if (a_vformStm->get_vformItemList())
    {
      if (!findString("a_vformItemList", vformStmAtts))
	{warnAtt("a_vformItemList", "vformStm", a_vformStm);}
      else
        {
          std::list<vformItem *> * theList;
          std::list<vformItem *>::iterator iter;
          theList = a_vformStm->get_vformItemList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_vformItem(*iter);
        }
    }
}

/********************************************************************/

void check_vlLabel(
 vlLabel * a_vlLabel)
{
  if (a_vlLabel->get_labelName())
    {
      if (!findString("a_labelName", vlLabelAtts))
	{warnAtt("a_labelName", "vlLabel", a_vlLabel);}
      else
        check_labelName(a_vlLabel->get_labelName());
    }
}

/********************************************************************/

void check_vwLabel(
 vwLabel * a_vwLabel)
{
  if (a_vwLabel->get_labelName())
    {
      if (!findString("a_labelName", vwLabelAtts))
	{warnAtt("a_labelName", "vwLabel", a_vwLabel);}
      else
        check_labelName(a_vwLabel->get_labelName());
    }
}

/********************************************************************/

void check_windefBox(
 windefBox * a_windefBox)
{
  if (a_windefBox->get_impCartPoint())
    {
      if (!findString("a_impCartPoint", windefBoxAtts))
	{warnAtt("a_impCartPoint", "windefBox", a_windefBox);}
      else
        check_impCartPoint(a_windefBox->get_impCartPoint());
    }
  if (a_windefBox->get_dx())
    {
      if (!findString("dx", windefBoxAtts))
	{warnAtt("dx", "windefBox", a_windefBox);}
      else
        check_rentVal(a_windefBox->get_dx());
    }
  if (a_windefBox->get_dy())
    {
      if (!findString("dy", windefBoxAtts))
	{warnAtt("dy", "windefBox", a_windefBox);}
      else
        check_rentVal(a_windefBox->get_dy());
    }
  if (a_windefBox->get_angle())
    {
      if (!findString("a_angle", windefBoxAtts))
	{warnAtt("a_angle", "windefBox", a_windefBox);}
      else
        check_angle(a_windefBox->get_angle());
    }
}

/********************************************************************/

void check_windefEdgeln(
 windefEdgeln * a_windefEdgeln)
{
  if (a_windefEdgeln->get_impCartPoint())
    {
      if (!findString("a_impCartPoint", windefEdgelnAtts))
	{warnAtt("a_impCartPoint", "windefEdgeln", a_windefEdgeln);}
      else
        check_impCartPoint(a_windefEdgeln->get_impCartPoint());
    }
  if (a_windefEdgeln->get_angle())
    {
      if (!findString("a_angle", windefEdgelnAtts))
	{warnAtt("a_angle", "windefEdgeln", a_windefEdgeln);}
      else
        check_angle(a_windefEdgeln->get_angle());
    }
  if (a_windefEdgeln->get_len())
    {
      if (!findString("len", windefEdgelnAtts))
	{warnAtt("len", "windefEdgeln", a_windefEdgeln);}
      else
        check_rentVal(a_windefEdgeln->get_len());
    }
}

/********************************************************************/

void check_windefMinor(
 windefMinor * a_windefMinor)
{
  if (isA(a_windefMinor, windefEdgeln))
    {
      if (!findString("windefEdgeln", windefMinorSubs))
        {warnSub("windefEdgeln", "windefMinor", a_windefMinor);}
      else
        check_windefEdgeln(dynamic_cast<windefEdgeln *>(a_windefMinor));
      return;
    }
  if (isA(a_windefMinor, windefBox))
    {
      if (!findString("windefBox", windefMinorSubs))
        {warnSub("windefBox", "windefMinor", a_windefMinor);}
      else
        check_windefBox(dynamic_cast<windefBox *>(a_windefMinor));
      return;
    }
}

/********************************************************************/

void check_windefStm(
 windefStm * a_windefStm)
{
  if (a_windefStm->get_vwLabel())
    {
      if (!findString("a_vwLabel", windefStmAtts))
	{warnAtt("a_vwLabel", "windefStm", a_windefStm);}
      else
        check_vwLabel(a_windefStm->get_vwLabel());
    }
  if (a_windefStm->get_windefMinor())
    {
      if (!findString("a_windefMinor", windefStmAtts))
	{warnAtt("a_windefMinor", "windefStm", a_windefStm);}
      else
        check_windefMinor(a_windefStm->get_windefMinor());
    }
}

/********************************************************************/

void check_wkplanStm(
 wkplanStm * a_wkplanStm)
{
  if (a_wkplanStm->get_plan())
    {
      if (!findString("a_plan", wkplanStmAtts))
	{warnAtt("a_plan", "wkplanStm", a_wkplanStm);}
      else
        check_plan(a_wkplanStm->get_plan());
    }
}

/********************************************************************/

void check_wristDataDesc(
 wristDataDesc * a_wristDataDesc)
{
  if (isA(a_wristDataDesc, wristDataDesc_stringVal))
    {
      if (!findString("wristDataDesc_stringVal", wristDataDescSubs))
        {warnSub("wristDataDesc_stringVal", "wristDataDesc", a_wristDataDesc);}
      else
        check_wristDataDesc_stringVal(dynamic_cast<wristDataDesc_stringVal *>(a_wristDataDesc));
      return;
    }
  if (isA(a_wristDataDesc, wristDataDesc_intVal))
    {
      if (!findString("wristDataDesc_intVal", wristDataDescSubs))
        {warnSub("wristDataDesc_intVal", "wristDataDesc", a_wristDataDesc);}
      else
        check_wristDataDesc_intVal(dynamic_cast<wristDataDesc_intVal *>(a_wristDataDesc));
      return;
    }
}

/********************************************************************/

void check_wristDataDesc_intVal(
 wristDataDesc_intVal * a_wristDataDesc_intVal)
{
  if (a_wristDataDesc_intVal->get_dataStor())
    {
      if (!findString("dataStor", wristDataDesc_intValAtts))
	{warnAtt("dataStor", "wristDataDesc_intVal", a_wristDataDesc_intVal);}
      else
        check_stringVal(a_wristDataDesc_intVal->get_dataStor());
    }
  if (a_wristDataDesc_intVal->get_dataList())
    {
      if (!findString("dataList", wristDataDesc_intValAtts))
	{warnAtt("dataList", "wristDataDesc_intVal", a_wristDataDesc_intVal);}
      else
        check_stringVal(a_wristDataDesc_intVal->get_dataList());
    }
  if (a_wristDataDesc_intVal->get_index())
    {
      if (!findString("index", wristDataDesc_intValAtts))
	{warnAtt("index", "wristDataDesc_intVal", a_wristDataDesc_intVal);}
      else
        check_intVal(a_wristDataDesc_intVal->get_index());
    }
}

/********************************************************************/

void check_wristDataDesc_stringVal(
 wristDataDesc_stringVal * a_wristDataDesc_stringVal)
{
  if (a_wristDataDesc_stringVal->get_dataStor())
    {
      if (!findString("dataStor", wristDataDesc_stringValAtts))
	{warnAtt("dataStor", "wristDataDesc_stringVal", a_wristDataDesc_stringVal);}
      else
        check_stringVal(a_wristDataDesc_stringVal->get_dataStor());
    }
  if (a_wristDataDesc_stringVal->get_dataList())
    {
      if (!findString("dataList", wristDataDesc_stringValAtts))
	{warnAtt("dataList", "wristDataDesc_stringVal", a_wristDataDesc_stringVal);}
      else
        check_stringVal(a_wristDataDesc_stringVal->get_dataList());
    }
  if (a_wristDataDesc_stringVal->get_dataItem())
    {
      if (!findString("dataItem", wristDataDesc_stringValAtts))
	{warnAtt("dataItem", "wristDataDesc_stringVal", a_wristDataDesc_stringVal);}
      else
        check_stringVal(a_wristDataDesc_stringVal->get_dataItem());
    }
}

/********************************************************************/

void check_wristDef(
 wristDef * a_wristDef)
{
  if (a_wristDef->get_wristMountDef())
    {
      if (!findString("a_wristMountDef", wristDefAtts))
	{warnAtt("a_wristMountDef", "wristDef", a_wristDef);}
      else
        check_wristMountDef(a_wristDef->get_wristMountDef());
    }
  if (a_wristDef->get_wristRotDef())
    {
      if (!findString("a_wristRotDef", wristDefAtts))
	{warnAtt("a_wristRotDef", "wristDef", a_wristDef);}
      else
        check_wristRotDef(a_wristDef->get_wristRotDef());
    }
}

/********************************************************************/

void check_wristMountDef(
 wristMountDef * a_wristMountDef)
{
  if (a_wristMountDef->get_offset())
    {
      if (!findString("offset", wristMountDefAtts))
	{warnAtt("offset", "wristMountDef", a_wristMountDef);}
      else
        check_vector(a_wristMountDef->get_offset());
    }
  if (a_wristMountDef->get_axisVec())
    {
      if (!findString("axisVec", wristMountDefAtts))
	{warnAtt("axisVec", "wristMountDef", a_wristMountDef);}
      else
        check_vector(a_wristMountDef->get_axisVec());
    }
  if (a_wristMountDef->get_zeroVec())
    {
      if (!findString("zeroVec", wristMountDefAtts))
	{warnAtt("zeroVec", "wristMountDef", a_wristMountDef);}
      else
        check_vector(a_wristMountDef->get_zeroVec());
    }
}

/********************************************************************/

void check_wristMountOffset(
 wristMountOffset * a_wristMountOffset)
{
  if (a_wristMountOffset->get_offset())
    {
      if (!findString("offset", wristMountOffsetAtts))
	{warnAtt("offset", "wristMountOffset", a_wristMountOffset);}
      else
        check_vector(a_wristMountOffset->get_offset());
    }
}

/********************************************************************/

void check_wristRotDef(
 wristRotDef * a_wristRotDef)
{
  if (a_wristRotDef->get_anglename())
    {
      if (!findString("anglename", wristRotDefAtts))
	{warnAtt("anglename", "wristRotDef", a_wristRotDef);}
      else
        check_stringVal(a_wristRotDef->get_anglename());
    }
  if (a_wristRotDef->get_wristRotLimit())
    {
      if (!findString("a_wristRotLimit", wristRotDefAtts))
	{warnAtt("a_wristRotLimit", "wristRotDef", a_wristRotDef);}
      else
        check_wristRotLimit(a_wristRotDef->get_wristRotLimit());
    }
  if (a_wristRotDef->get_wristRotStep())
    {
      if (!findString("a_wristRotStep", wristRotDefAtts))
	{warnAtt("a_wristRotStep", "wristRotDef", a_wristRotDef);}
      else
        check_wristRotStep(a_wristRotDef->get_wristRotStep());
    }
}

/********************************************************************/

void check_wristRotLimit(
 wristRotLimit * a_wristRotLimit)
{
  if (isA(a_wristRotLimit, wristRotLimit_angle))
    {
      if (!findString("wristRotLimit_angle", wristRotLimitSubs))
        {warnSub("wristRotLimit_angle", "wristRotLimit", a_wristRotLimit);}
      else
        check_wristRotLimit_angle(dynamic_cast<wristRotLimit_angle *>(a_wristRotLimit));
      return;
    }
  if (isA(a_wristRotLimit, wristRotLimit_THRU))
    {
      if (!findString("wristRotLimit_THRU", wristRotLimitSubs))
        {warnSub("wristRotLimit_THRU", "wristRotLimit", a_wristRotLimit);}
      return;
    }
}

/********************************************************************/

void check_wristRotLimit_angle(
 wristRotLimit_angle * a_wristRotLimit_angle)
{
  if (a_wristRotLimit_angle->get_begin())
    {
      if (!findString("begin", wristRotLimit_angleAtts))
	{warnAtt("begin", "wristRotLimit_angle", a_wristRotLimit_angle);}
      else
        check_angle(a_wristRotLimit_angle->get_begin());
    }
  if (a_wristRotLimit_angle->get_end())
    {
      if (!findString("end", wristRotLimit_angleAtts))
	{warnAtt("end", "wristRotLimit_angle", a_wristRotLimit_angle);}
      else
        check_angle(a_wristRotLimit_angle->get_end());
    }
}

/********************************************************************/

void check_wristRotStep(
 wristRotStep * a_wristRotStep)
{
  if (isA(a_wristRotStep, wristRotStep_angle))
    {
      if (!findString("wristRotStep_angle", wristRotStepSubs))
        {warnSub("wristRotStep_angle", "wristRotStep", a_wristRotStep);}
      else
        check_wristRotStep_angle(dynamic_cast<wristRotStep_angle *>(a_wristRotStep));
      return;
    }
  if (isA(a_wristRotStep, wristRotStep_CONTIN))
    {
      if (!findString("wristRotStep_CONTIN", wristRotStepSubs))
        {warnSub("wristRotStep_CONTIN", "wristRotStep", a_wristRotStep);}
      return;
    }
}

/********************************************************************/

void check_wristRotStep_angle(
 wristRotStep_angle * a_wristRotStep_angle)
{
  if (a_wristRotStep_angle->get_angle())
    {
      if (!findString("a_angle", wristRotStep_angleAtts))
	{warnAtt("a_angle", "wristRotStep_angle", a_wristRotStep_angle);}
      else
        check_angle(a_wristRotStep_angle->get_angle());
    }
}

/********************************************************************/

void check_wristStm(
 wristStm * a_wristStm)
{
  if (a_wristStm->get_swLabel())
    {
      if (!findString("a_swLabel", wristStmAtts))
	{warnAtt("a_swLabel", "wristStm", a_wristStm);}
      else
        check_swLabel(a_wristStm->get_swLabel());
    }
  if (a_wristStm->get_wristList())
    {
      if (!findString("a_wristList", wristStmAtts))
	{warnAtt("a_wristList", "wristStm", a_wristStm);}
      else
        {
          std::list<wristDef *> * theList;
          std::list<wristDef *>::iterator iter;
          theList = a_wristStm->get_wristList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_wristDef(*iter);
        }
    }
  if (a_wristStm->get_wristMountOffset())
    {
      if (!findString("a_wristMountOffset", wristStmAtts))
	{warnAtt("a_wristMountOffset", "wristStm", a_wristStm);}
      else
        check_wristMountOffset(a_wristStm->get_wristMountOffset());
    }
  if (a_wristStm->get_wristDataDesc())
    {
      if (!findString("a_wristDataDesc", wristStmAtts))
	{warnAtt("a_wristDataDesc", "wristStm", a_wristStm);}
      else
        check_wristDataDesc(a_wristStm->get_wristDataDesc());
    }
}

/********************************************************************/

void check_writeSpec(
 writeSpec * a_writeSpec)
{
  if (isA(a_writeSpec, writeSpec_stringConst))
    {
      if (!findString("writeSpec_stringConst", writeSpecSubs))
        {warnSub("writeSpec_stringConst", "writeSpec", a_writeSpec);}
      else
        check_writeSpec_stringConst(dynamic_cast<writeSpec_stringConst *>(a_writeSpec));
      return;
    }
  if (isA(a_writeSpec, writeSpec_stringFunc))
    {
      if (!findString("writeSpec_stringFunc", writeSpecSubs))
        {warnSub("writeSpec_stringFunc", "writeSpec", a_writeSpec);}
      else
        check_writeSpec_stringFunc(dynamic_cast<writeSpec_stringFunc *>(a_writeSpec));
      return;
    }
  if (isA(a_writeSpec, writeSpec_rwVar))
    {
      if (!findString("writeSpec_rwVar", writeSpecSubs))
        {warnSub("writeSpec_rwVar", "writeSpec", a_writeSpec);}
      else
        check_writeSpec_rwVar(dynamic_cast<writeSpec_rwVar *>(a_writeSpec));
      return;
    }
}

/********************************************************************/

void check_writeSpec_rwVar(
 writeSpec_rwVar * a_writeSpec_rwVar)
{
  if (a_writeSpec_rwVar->get_rwVar())
    {
      if (!findString("a_rwVar", writeSpec_rwVarAtts))
	{warnAtt("a_rwVar", "writeSpec_rwVar", a_writeSpec_rwVar);}
      else
        check_rwVar(a_writeSpec_rwVar->get_rwVar());
    }
  if (a_writeSpec_rwVar->get_rwFormat())
    {
      if (!findString("a_rwFormat", writeSpec_rwVarAtts))
	{warnAtt("a_rwFormat", "writeSpec_rwVar", a_writeSpec_rwVar);}
      else
        check_rwFormat(a_writeSpec_rwVar->get_rwFormat());
    }
}

/********************************************************************/

void check_writeSpec_stringConst(
 writeSpec_stringConst * a_writeSpec_stringConst)
{
  if (a_writeSpec_stringConst->get_stringConst())
    {
      if (!findString("a_stringConst", writeSpec_stringConstAtts))
	{warnAtt("a_stringConst", "writeSpec_stringConst", a_writeSpec_stringConst);}
      else
        check_stringConst(a_writeSpec_stringConst->get_stringConst());
    }
}

/********************************************************************/

void check_writeSpec_stringFunc(
 writeSpec_stringFunc * a_writeSpec_stringFunc)
{
  if (a_writeSpec_stringFunc->get_stringFunc())
    {
      if (!findString("a_stringFunc", writeSpec_stringFuncAtts))
	{warnAtt("a_stringFunc", "writeSpec_stringFunc", a_writeSpec_stringFunc);}
      else
        check_stringFunc(a_writeSpec_stringFunc->get_stringFunc());
    }
}

/********************************************************************/

void check_writeStm(
 writeStm * a_writeStm)
{
  if (a_writeStm->get_didLabel())
    {
      if (!findString("a_didLabel", writeStmAtts))
	{warnAtt("a_didLabel", "writeStm", a_writeStm);}
      else
        check_didLabel(a_writeStm->get_didLabel());
    }
  if (a_writeStm->get_writeSpecList())
    {
      if (!findString("a_writeSpecList", writeStmAtts))
	{warnAtt("a_writeSpecList", "writeStm", a_writeStm);}
      else
        {
          std::list<writeSpec *> * theList;
          std::list<writeSpec *>::iterator iter;
          theList = a_writeStm->get_writeSpecList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_writeSpec(*iter);
        }
    }
}

/********************************************************************/

void check_xternBlock(
 xternBlock * a_xternBlock)
{
  if (a_xternBlock->get_xternStm())
    {
      if (!findString("a_xternStm", xternBlockAtts))
	{warnAttBlock("xternStm", a_xternBlock->get_xternStm());}
    }
  if (a_xternBlock->get_extfilList())
    {
      if (!findString("a_extfilList", xternBlockAtts))
	{warnAttBlock("extfilList", a_xternBlock->get_extfilList()->front());}
      else
        {
          std::list<extfilStm *> * theList;
          std::list<extfilStm *>::iterator iter;
          theList = a_xternBlock->get_extfilList();
          for (iter = theList->begin(); iter != theList->end(); iter++)
            check_extfilStm(*iter);
        }
    }
  if (a_xternBlock->get_endxtnStm())
    {
      if (!findString("a_endxtnStm", xternBlockAtts))
	{warnAttBlock("endxtnStm", a_xternBlock->get_endxtnStm());}
    }
}

/********************************************************************/

void check_xtractStm(
 xtractStm * a_xtractStm)
{
  if (a_xtractStm->get_fLabel())
    {
      if (!findString("a_fLabel", xtractStmAtts))
	{warnAtt("a_fLabel", "xtractStm", a_xtractStm);}
      else
        check_fLabel(a_xtractStm->get_fLabel());
    }
  if (a_xtractStm->get_faLabel())
    {
      if (!findString("a_faLabel", xtractStmAtts))
	{warnAtt("a_faLabel", "xtractStm", a_xtractStm);}
      else
        check_faLabel(a_xtractStm->get_faLabel());
    }
}

/********************************************************************/

} // namespace NDTU

#include "assignModuleSubAtts.cc"
#include "assignMasterSubAtts.cc"

namespace NDTU {

/********************************************************************/

/* reportSummary

For each statement type T in full DMIS:

A. If T is on theStatements list (i.e., T is included in statement
   types allowed in the conformance class), then
1. If T has been used, the number of times it was used is printed.
2. If T has not been used, it is added to the unusedStms array.
B. Otherwise (T is not allowed in the conformance class), if T has been
   used, it is added to the nonoStms array.
Then this prints the percentage of statements in the conformance class
that were used, the names of statements that were not used, and the
names of statements that were used but are not in the conformance class.

Statements in the conformance class that are essential metrology statements
are marked with an M in the output. They are named in the "essentials"
array.

*/

void reportSummary()
{
  int allowed; // counter for the number of statements allowed
  int used;    // counter for number of allowed statements used
  int unused;  // counter for number of allowed statements not used
  int nono;    // counter for number of disallowed statements used
  int k;       // counter for theStatements (then unusedStms and nonoStms)
  int j;       // counter for essentials array
  int result;  // result of strcmp
  const char * unusedStms[300];
  const char * nonoStms[300];
  static const char * essentials[] =
    {"const",
     "datdef",
     "datset",
     "endmes",
     "featArc1",
     "featArc2",
     "featCircle",
     "featCompound",
     "featCone",
     "featConradseg",
     "featCparln",
     "featCylndr",
     "featCylradseg",
     "featEdgept",
     "featEllips",
     "featElongcyl",
     "featGcurve",
     "featGeom",
     "featGsurf",
     "featLine",
     "featObject",
     "featParpln",
     "featPatern",
     "featPlane",
     "featPoint",
     "featRctngl",
     "featRevsurf",
     "featSphere",
     "featSphradseg",
     "featSympln",
     "featTorradseg",
     "featTorus",
     "goto",
     "meas",
     "mode",
     "pameas",
     "ptmeas",
     "rmeas",
     "rotate",
     "scnmod",
     "scnset",
     "snsdef",
     "snslct",
     "tolAngl",
     "tolAnglb",
     "tolAnglr",
     "tolAnglwrt",
     "tolCirlty",
     "tolCompos",
     "tolConcen",
     "tolCortol",
     "tolCprofl",
     "tolCprofs",
     "tolCrnout",
     "tolCylcty",
     "tolDiam",
     "tolDistb",
     "tolDistwrt",
     "tolFlat",
     "tolGtol",
     "tolParlel",
     "tolPerp",
     "tolPos",
     "tolProfl",
     "tolProfp",
     "tolProfs",
     "tolRad",
     "tolStrght",
     "tolSym",
     "tolTrnout",
     "tolUsetol",
     "tolWidth",
     "trans",
     "ze end"
    };

  allowed = 0;
  used = 0;
  unused = 0;
  nono = 0;
  k = 0;

  printf("********************************************\n\n");
  printf("Total statement uses for all files\n\n");

  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "aclratStm") == 0))
    {
      k++;
      allowed++;
      if (aclratStms)
        {
          printf("aclrat %d\n", aclratStms);
          used++;
        }
      else
        unusedStms[unused++] = "aclrat";
    }
  else if (aclratStms)
    nonoStms[nono++] = "aclrat";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "algdefStm") == 0))
    {
      k++;
      allowed++;
      if (algdefStms)
        {
          printf("algdef %d\n", algdefStms);
          used++;
        }
      else
        unusedStms[unused++] = "algdef";
    }
  else if (algdefStms)
    nonoStms[nono++] = "algdef";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "assignStm") == 0))
    {
      k++;
      allowed++;
      if (assignStms)
        {
          printf("assign %d\n", assignStms);
          used++;
        }
      else
        unusedStms[unused++] = "assign";
    }
  else if (assignStms)
    nonoStms[nono++] = "assign";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "badtstStm") == 0))
    {
      k++;
      allowed++;
      if (badtstStms)
        {
          printf("badtst %d\n", badtstStms);
          used++;
        }
      else
        unusedStms[unused++] = "badtst";
    }
  else if (badtstStms)
    nonoStms[nono++] = "badtst";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "boundStm") == 0))
    {
      k++;
      allowed++;
      if (boundStms)
        {
          printf("bound %d\n", boundStms);
          used++;
        }
      else
        unusedStms[unused++] = "bound";
    }
  else if (boundStms)
    nonoStms[nono++] = "bound";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "calibMasterStm") == 0))
    {
      k++;
      allowed++;
      if (calibMasterStms)
        {
          printf("calibMaster %d\n", calibMasterStms);
          used++;
        }
      else
        unusedStms[unused++] = "calibMaster";
    }
  else if (calibMasterStms)
    nonoStms[nono++] = "calibMaster";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "calibRtabStm") == 0))
    {
      k++;
      allowed++;
      if (calibRtabStms)
        {
          printf("calibRtab %d\n", calibRtabStms);
          used++;
        }
      else
        unusedStms[unused++] = "calibRtab";
    }
  else if (calibRtabStms)
    nonoStms[nono++] = "calibRtab";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "calibSensStm") == 0))
    {
      k++;
      allowed++;
      if (calibSensStms)
        {
          printf("calibSens %d\n", calibSensStms);
          used++;
        }
      else
        unusedStms[unused++] = "calibSens";
    }
  else if (calibSensStms)
    nonoStms[nono++] = "calibSens";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "callStm") == 0))
    {
      k++;
      allowed++;
      if (callStms)
        {
          printf("call %d\n", callStms);
          used++;
        }
      else
        unusedStms[unused++] = "call";
    }
  else if (callStms)
    nonoStms[nono++] = "call";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "caseStm") == 0))
    {
      k++;
      allowed++;
      if (caseStms)
        {
          printf("case %d\n", caseStms);
          used++;
        }
      else
        unusedStms[unused++] = "case";
    }
  else if (caseStms)
    nonoStms[nono++] = "case";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "clmpidStm") == 0))
    {
      k++;
      allowed++;
      if (clmpidStms)
        {
          printf("clmpid %d\n", clmpidStms);
          used++;
        }
      else
        unusedStms[unused++] = "clmpid";
    }
  else if (clmpidStms)
    nonoStms[nono++] = "clmpid";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "clmpsnStm") == 0))
    {
      k++;
      allowed++;
      if (clmpsnStms)
        {
          printf("clmpsn %d\n", clmpsnStms);
          used++;
        }
      else
        unusedStms[unused++] = "clmpsn";
    }
  else if (clmpsnStms)
    nonoStms[nono++] = "clmpsn";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "closeStm") == 0))
    {
      k++;
      allowed++;
      if (closeStms)
        {
          printf("close %d\n", closeStms);
          used++;
        }
      else
        unusedStms[unused++] = "close";
    }
  else if (closeStms)
    nonoStms[nono++] = "close";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "cmpntgrpStm") == 0))
    {
      k++;
      allowed++;
      if (cmpntgrpStms)
        {
          printf("cmpntgrp %d\n", cmpntgrpStms);
          used++;
        }
      else
        unusedStms[unused++] = "cmpntgrp";
    }
  else if (cmpntgrpStms)
    nonoStms[nono++] = "cmpntgrp";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "cnfrmrulStm") == 0))
    {
      k++;
      allowed++;
      if (cnfrmrulStms)
        {
          printf("cnfrmrul %d\n", cnfrmrulStms);
          used++;
        }
      else
        unusedStms[unused++] = "cnfrmrul";
    }
  else if (cnfrmrulStms)
    nonoStms[nono++] = "cnfrmrul";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "constStm") == 0))
    {
      k++;
      allowed++;
      if (constStms)
        {
          printf("M const %d\n", constStms);
          used++;
        }
      else
        unusedStms[unused++] = "const";
    }
  else if (constStms)
    nonoStms[nono++] = "const";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "crgdefStm") == 0))
    {
      k++;
      allowed++;
      if (crgdefStms)
        {
          printf("crgdef %d\n", crgdefStms);
          used++;
        }
      else
        unusedStms[unused++] = "crgdef";
    }
  else if (crgdefStms)
    nonoStms[nono++] = "crgdef";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "crmodeStm") == 0))
    {
      k++;
      allowed++;
      if (crmodeStms)
        {
          printf("crmode %d\n", crmodeStms);
          used++;
        }
      else
        unusedStms[unused++] = "crmode";
    }
  else if (crmodeStms)
    nonoStms[nono++] = "crmode";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "crosclStm") == 0))
    {
      k++;
      allowed++;
      if (crosclStms)
        {
          printf("croscl %d\n", crosclStms);
          used++;
        }
      else
        unusedStms[unused++] = "croscl";
    }
  else if (crosclStms)
    nonoStms[nono++] = "croscl";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "crslctStm") == 0))
    {
      k++;
      allowed++;
      if (crslctStms)
        {
          printf("crslct %d\n", crslctStms);
          used++;
        }
      else
        unusedStms[unused++] = "crslct";
    }
  else if (crslctStms)
    nonoStms[nono++] = "crslct";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "cutcomStm") == 0))
    {
      k++;
      allowed++;
      if (cutcomStms)
        {
          printf("cutcom %d\n", cutcomStms);
          used++;
        }
      else
        unusedStms[unused++] = "cutcom";
    }
  else if (cutcomStms)
    nonoStms[nono++] = "cutcom";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "czoneStm") == 0))
    {
      k++;
      allowed++;
      if (czoneStms)
        {
          printf("czone %d\n", czoneStms);
          used++;
        }
      else
        unusedStms[unused++] = "czone";
    }
  else if (czoneStms)
    nonoStms[nono++] = "czone";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "czslctStm") == 0))
    {
      k++;
      allowed++;
      if (czslctStms)
        {
          printf("czslct %d\n", czslctStms);
          used++;
        }
      else
        unusedStms[unused++] = "czslct";
    }
  else if (czslctStms)
    nonoStms[nono++] = "czslct";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "datdefStm") == 0))
    {
      k++;
      allowed++;
      if (datdefStms)
        {
          printf("M datdef %d\n", datdefStms);
          used++;
        }
      else
        unusedStms[unused++] = "datdef";
    }
  else if (datdefStms)
    nonoStms[nono++] = "datdef";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "datsetStm") == 0))
    {
      k++;
      allowed++;
      if (datsetStms)
        {
          printf("M datset %d\n", datsetStms);
          used++;
        }
      else
        unusedStms[unused++] = "datset";
    }
  else if (datsetStms)
    nonoStms[nono++] = "datset";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "dattrgdefStm") == 0))
    {
      k++;
      allowed++;
      if (dattrgdefStms)
        {
          printf("dattrgdef %d\n", dattrgdefStms);
          used++;
        }
      else
        unusedStms[unused++] = "dattrgdef";
    }
  else if (dattrgdefStms)
    nonoStms[nono++] = "dattrgdef";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "declStm") == 0))
    {
      k++;
      allowed++;
      if (declStms)
        {
          printf("decl %d\n", declStms);
          used++;
        }
      else
        unusedStms[unused++] = "decl";
    }
  else if (declStms)
    nonoStms[nono++] = "decl";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "decplStm") == 0))
    {
      k++;
      allowed++;
      if (decplStms)
        {
          printf("decpl %d\n", decplStms);
          used++;
        }
      else
        unusedStms[unused++] = "decpl";
    }
  else if (decplStms)
    nonoStms[nono++] = "decpl";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "deleteStm") == 0))
    {
      k++;
      allowed++;
      if (deleteStms)
        {
          printf("delete %d\n", deleteStms);
          used++;
        }
      else
        unusedStms[unused++] = "delete";
    }
  else if (deleteStms)
    nonoStms[nono++] = "delete";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "deviceStm") == 0))
    {
      k++;
      allowed++;
      if (deviceStms)
        {
          printf("device %d\n", deviceStms);
          used++;
        }
      else
        unusedStms[unused++] = "device";
    }
  else if (deviceStms)
    nonoStms[nono++] = "device";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "dftcasStm") == 0))
    {
      k++;
      allowed++;
      if (dftcasStms)
        {
          printf("dftcas %d\n", dftcasStms);
          used++;
        }
      else
        unusedStms[unused++] = "dftcas";
    }
  else if (dftcasStms)
    nonoStms[nono++] = "dftcas";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "displyStm") == 0))
    {
      k++;
      allowed++;
      if (displyStms)
        {
          printf("disply %d\n", displyStms);
          used++;
        }
      else
        unusedStms[unused++] = "disply";
    }
  else if (displyStms)
    nonoStms[nono++] = "disply";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "dmehwStm") == 0))
    {
      k++;
      allowed++;
      if (dmehwStms)
        {
          printf("dmehw %d\n", dmehwStms);
          used++;
        }
      else
        unusedStms[unused++] = "dmehw";
    }
  else if (dmehwStms)
    nonoStms[nono++] = "dmehw";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "dmeidStm") == 0))
    {
      k++;
      allowed++;
      if (dmeidStms)
        {
          printf("dmeid %d\n", dmeidStms);
          used++;
        }
      else
        unusedStms[unused++] = "dmeid";
    }
  else if (dmeidStms)
    nonoStms[nono++] = "dmeid";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "dmeswStm") == 0))
    {
      k++;
      allowed++;
      if (dmeswStms)
        {
          printf("dmesw %d\n", dmeswStms);
          used++;
        }
      else
        unusedStms[unused++] = "dmesw";
    }
  else if (dmeswStms)
    nonoStms[nono++] = "dmesw";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "dmeswiStm") == 0))
    {
      k++;
      allowed++;
      if (dmeswiStms)
        {
          printf("dmeswi %d\n", dmeswiStms);
          used++;
        }
      else
        unusedStms[unused++] = "dmeswi";
    }
  else if (dmeswiStms)
    nonoStms[nono++] = "dmeswi";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "dmeswvStm") == 0))
    {
      k++;
      allowed++;
      if (dmeswvStms)
        {
          printf("dmeswv %d\n", dmeswvStms);
          used++;
        }
      else
        unusedStms[unused++] = "dmeswv";
    }
  else if (dmeswvStms)
    nonoStms[nono++] = "dmeswv";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "dmisOffStm") == 0))
    {
      k++;
      allowed++;
      if (dmisOffStms)
        {
          printf("dmisOff %d\n", dmisOffStms);
          used++;
        }
      else
        unusedStms[unused++] = "dmisOff";
    }
  else if (dmisOffStms)
    nonoStms[nono++] = "dmisOff";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "dmisOnStm") == 0))
    {
      k++;
      allowed++;
      if (dmisOnStms)
        {
          printf("dmisOn %d\n", dmisOnStms);
          used++;
        }
      else
        unusedStms[unused++] = "dmisOn";
    }
  else if (dmisOnStms)
    nonoStms[nono++] = "dmisOn";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "dmismdStm") == 0))
    {
      k++;
      allowed++;
      if (dmismdStms)
        {
          printf("dmismd %d\n", dmismdStms);
          used++;
        }
      else
        unusedStms[unused++] = "dmismd";
    }
  else if (dmismdStms)
    nonoStms[nono++] = "dmismd";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "dmismnStm") == 0))
    {
      k++;
      allowed++;
      if (dmismnStms)
        {
          printf("dmismn %d\n", dmismnStms);
          used++;
        }
      else
        unusedStms[unused++] = "dmismn";
    }
  else if (dmismnStms)
    nonoStms[nono++] = "dmismn";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "doStm") == 0))
    {
      k++;
      allowed++;
      if (doStms)
        {
          printf("do %d\n", doStms);
          used++;
        }
      else
        unusedStms[unused++] = "do";
    }
  else if (doStms)
    nonoStms[nono++] = "do";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "elseStm") == 0))
    {
      k++;
      allowed++;
      if (elseStms)
        {
          printf("else %d\n", elseStms);
          used++;
        }
      else
        unusedStms[unused++] = "else";
    }
  else if (elseStms)
    nonoStms[nono++] = "else";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "endcasStm") == 0))
    {
      k++;
      allowed++;
      if (endcasStms)
        {
          printf("endcas %d\n", endcasStms);
          used++;
        }
      else
        unusedStms[unused++] = "endcas";
    }
  else if (endcasStms)
    nonoStms[nono++] = "endcas";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "enddoStm") == 0))
    {
      k++;
      allowed++;
      if (enddoStms)
        {
          printf("enddo %d\n", enddoStms);
          used++;
        }
      else
        unusedStms[unused++] = "enddo";
    }
  else if (enddoStms)
    nonoStms[nono++] = "enddo";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "endfilStm") == 0))
    {
      k++;
      allowed++;
      if (endfilStms)
        {
          printf("endfil %d\n", endfilStms);
          used++;
        }
      else
        unusedStms[unused++] = "endfil";
    }
  else if (endfilStms)
    nonoStms[nono++] = "endfil";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "endgoStm") == 0))
    {
      k++;
      allowed++;
      if (endgoStms)
        {
          printf("endgo %d\n", endgoStms);
          used++;
        }
      else
        unusedStms[unused++] = "endgo";
    }
  else if (endgoStms)
    nonoStms[nono++] = "endgo";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "endifStm") == 0))
    {
      k++;
      allowed++;
      if (endifStms)
        {
          printf("endif %d\n", endifStms);
          used++;
        }
      else
        unusedStms[unused++] = "endif";
    }
  else if (endifStms)
    nonoStms[nono++] = "endif";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "endmacStm") == 0))
    {
      k++;
      allowed++;
      if (endmacStms)
        {
          printf("endmac %d\n", endmacStms);
          used++;
        }
      else
        unusedStms[unused++] = "endmac";
    }
  else if (endmacStms)
    nonoStms[nono++] = "endmac";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "endmesStm") == 0))
    {
      k++;
      allowed++;
      if (endmesStms)
        {
          printf("M endmes %d\n", endmesStms);
          used++;
        }
      else
        unusedStms[unused++] = "endmes";
    }
  else if (endmesStms)
    nonoStms[nono++] = "endmes";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "endselStm") == 0))
    {
      k++;
      allowed++;
      if (endselStms)
        {
          printf("endsel %d\n", endselStms);
          used++;
        }
      else
        unusedStms[unused++] = "endsel";
    }
  else if (endselStms)
    nonoStms[nono++] = "endsel";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "endsimreqtStm") == 0))
    {
      k++;
      allowed++;
      if (endsimreqtStms)
        {
          printf("endsimreqt %d\n", endsimreqtStms);
          used++;
        }
      else
        unusedStms[unused++] = "endsimreqt";
    }
  else if (endsimreqtStms)
    nonoStms[nono++] = "endsimreqt";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "endxtnStm") == 0))
    {
      k++;
      allowed++;
      if (endxtnStms)
        {
          printf("endxtn %d\n", endxtnStms);
          used++;
        }
      else
        unusedStms[unused++] = "endxtn";
    }
  else if (endxtnStms)
    nonoStms[nono++] = "endxtn";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "equateStm") == 0))
    {
      k++;
      allowed++;
      if (equateStms)
        {
          printf("equate %d\n", equateStms);
          used++;
        }
      else
        unusedStms[unused++] = "equate";
    }
  else if (equateStms)
    nonoStms[nono++] = "equate";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "errorStm") == 0))
    {
      k++;
      allowed++;
      if (errorStms)
        {
          printf("error %d\n", errorStms);
          used++;
        }
      else
        unusedStms[unused++] = "error";
    }
  else if (errorStms)
    nonoStms[nono++] = "error";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "evalStm") == 0))
    {
      k++;
      allowed++;
      if (evalStms)
        {
          printf("eval %d\n", evalStms);
          used++;
        }
      else
        unusedStms[unused++] = "eval";
    }
  else if (evalStms)
    nonoStms[nono++] = "eval";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "extensStm") == 0))
    {
      k++;
      allowed++;
      if (extensStms)
        {
          printf("extens %d\n", extensStms);
          used++;
        }
      else
        unusedStms[unused++] = "extens";
    }
  else if (extensStms)
    nonoStms[nono++] = "extens";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "extfilStm") == 0))
    {
      k++;
      allowed++;
      if (extfilStms)
        {
          printf("extfil %d\n", extfilStms);
          used++;
        }
      else
        unusedStms[unused++] = "extfil";
    }
  else if (extfilStms)
    nonoStms[nono++] = "extfil";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "featArc1Stm") == 0))
    {
      k++;
      allowed++;
      if (featArc1Stms)
        {
          printf("M featArc1 %d\n", featArc1Stms);
          used++;
        }
      else
        unusedStms[unused++] = "featArc1";
    }
  else if (featArc1Stms)
    nonoStms[nono++] = "featArc1";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "featArc2Stm") == 0))
    {
      k++;
      allowed++;
      if (featArc2Stms)
        {
          printf("M featArc2 %d\n", featArc2Stms);
          used++;
        }
      else
        unusedStms[unused++] = "featArc2";
    }
  else if (featArc2Stms)
    nonoStms[nono++] = "featArc2";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "featCircleStm") == 0))
    {
      k++;
      allowed++;
      if (featCircleStms)
        {
          printf("M featCircle %d\n", featCircleStms);
          used++;
        }
      else
        unusedStms[unused++] = "featCircle";
    }
  else if (featCircleStms)
    nonoStms[nono++] = "featCircle";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "featCompoundStm") == 0))
    {
      k++;
      allowed++;
      if (featCompoundStms)
        {
          printf("M featCompound %d\n", featCompoundStms);
          used++;
        }
      else
        unusedStms[unused++] = "featCompound";
    }
  else if (featCompoundStms)
    nonoStms[nono++] = "featCompound";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "featConeStm") == 0))
    {
      k++;
      allowed++;
      if (featConeStms)
        {
          printf("M featCone %d\n", featConeStms);
          used++;
        }
      else
        unusedStms[unused++] = "featCone";
    }
  else if (featConeStms)
    nonoStms[nono++] = "featCone";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "featConradsegStm") == 0))
    {
      k++;
      allowed++;
      if (featConradsegStms)
        {
          printf("M featConradseg %d\n", featConradsegStms);
          used++;
        }
      else
        unusedStms[unused++] = "featConradseg";
    }
  else if (featConradsegStms)
    nonoStms[nono++] = "featConradseg";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "featCparlnStm") == 0))
    {
      k++;
      allowed++;
      if (featCparlnStms)
        {
          printf("M featCparln %d\n", featCparlnStms);
          used++;
        }
      else
        unusedStms[unused++] = "featCparln";
    }
  else if (featCparlnStms)
    nonoStms[nono++] = "featCparln";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "featCylndrStm") == 0))
    {
      k++;
      allowed++;
      if (featCylndrStms)
        {
          printf("M featCylndr %d\n", featCylndrStms);
          used++;
        }
      else
        unusedStms[unused++] = "featCylndr";
    }
  else if (featCylndrStms)
    nonoStms[nono++] = "featCylndr";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "featCylradsegStm") == 0))
    {
      k++;
      allowed++;
      if (featCylradsegStms)
        {
          printf("M featCylradseg %d\n", featCylradsegStms);
          used++;
        }
      else
        unusedStms[unused++] = "featCylradseg";
    }
  else if (featCylradsegStms)
    nonoStms[nono++] = "featCylradseg";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "featEdgeptStm") == 0))
    {
      k++;
      allowed++;
      if (featEdgeptStms)
        {
          printf("M featEdgept %d\n", featEdgeptStms);
          used++;
        }
      else
        unusedStms[unused++] = "featEdgept";
    }
  else if (featEdgeptStms)
    nonoStms[nono++] = "featEdgept";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "featEllipsStm") == 0))
    {
      k++;
      allowed++;
      if (featEllipsStms)
        {
          printf("M featEllips %d\n", featEllipsStms);
          used++;
        }
      else
        unusedStms[unused++] = "featEllips";
    }
  else if (featEllipsStms)
    nonoStms[nono++] = "featEllips";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "featElongcylStm") == 0))
    {
      k++;
      allowed++;
      if (featElongcylStms)
        {
          printf("M featElongcyl %d\n", featElongcylStms);
          used++;
        }
      else
        unusedStms[unused++] = "featElongcyl";
    }
  else if (featElongcylStms)
    nonoStms[nono++] = "featElongcyl";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "featGcurveStm") == 0))
    {
      k++;
      allowed++;
      if (featGcurveStms)
        {
          printf("M featGcurve %d\n", featGcurveStms);
          used++;
        }
      else
        unusedStms[unused++] = "featGcurve";
    }
  else if (featGcurveStms)
    nonoStms[nono++] = "featGcurve";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "featGeomStm") == 0))
    {
      k++;
      allowed++;
      if (featGeomStms)
        {
          printf("M featGeom %d\n", featGeomStms);
          used++;
        }
      else
        unusedStms[unused++] = "featGeom";
    }
  else if (featGeomStms)
    nonoStms[nono++] = "featGeom";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "featGsurfStm") == 0))
    {
      k++;
      allowed++;
      if (featGsurfStms)
        {
          printf("M featGsurf %d\n", featGsurfStms);
          used++;
        }
      else
        unusedStms[unused++] = "featGsurf";
    }
  else if (featGsurfStms)
    nonoStms[nono++] = "featGsurf";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "featLineStm") == 0))
    {
      k++;
      allowed++;
      if (featLineStms)
        {
          printf("M featLine %d\n", featLineStms);
          used++;
        }
      else
        unusedStms[unused++] = "featLine";
    }
  else if (featLineStms)
    nonoStms[nono++] = "featLine";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "featObjectStm") == 0))
    {
      k++;
      allowed++;
      if (featObjectStms)
        {
          printf("M featObject %d\n", featObjectStms);
          used++;
        }
      else
        unusedStms[unused++] = "featObject";
    }
  else if (featObjectStms)
    nonoStms[nono++] = "featObject";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "featParplnStm") == 0))
    {
      k++;
      allowed++;
      if (featParplnStms)
        {
          printf("M featParpln %d\n", featParplnStms);
          used++;
        }
      else
        unusedStms[unused++] = "featParpln";
    }
  else if (featParplnStms)
    nonoStms[nono++] = "featParpln";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "featPaternStm") == 0))
    {
      k++;
      allowed++;
      if (featPaternStms)
        {
          printf("M featPatern %d\n", featPaternStms);
          used++;
        }
      else
        unusedStms[unused++] = "featPatern";
    }
  else if (featPaternStms)
    nonoStms[nono++] = "featPatern";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "featPlaneStm") == 0))
    {
      k++;
      allowed++;
      if (featPlaneStms)
        {
          printf("M featPlane %d\n", featPlaneStms);
          used++;
        }
      else
        unusedStms[unused++] = "featPlane";
    }
  else if (featPlaneStms)
    nonoStms[nono++] = "featPlane";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "featPointStm") == 0))
    {
      k++;
      allowed++;
      if (featPointStms)
        {
          printf("M featPoint %d\n", featPointStms);
          used++;
        }
      else
        unusedStms[unused++] = "featPoint";
    }
  else if (featPointStms)
    nonoStms[nono++] = "featPoint";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "featRctnglStm") == 0))
    {
      k++;
      allowed++;
      if (featRctnglStms)
        {
          printf("M featRctngl %d\n", featRctnglStms);
          used++;
        }
      else
        unusedStms[unused++] = "featRctngl";
    }
  else if (featRctnglStms)
    nonoStms[nono++] = "featRctngl";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "featRevsurfStm") == 0))
    {
      k++;
      allowed++;
      if (featRevsurfStms)
        {
          printf("M featRevsurf %d\n", featRevsurfStms);
          used++;
        }
      else
        unusedStms[unused++] = "featRevsurf";
    }
  else if (featRevsurfStms)
    nonoStms[nono++] = "featRevsurf";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "featSphereStm") == 0))
    {
      k++;
      allowed++;
      if (featSphereStms)
        {
          printf("M featSphere %d\n", featSphereStms);
          used++;
        }
      else
        unusedStms[unused++] = "featSphere";
    }
  else if (featSphereStms)
    nonoStms[nono++] = "featSphere";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "featSphradsegStm") == 0))
    {
      k++;
      allowed++;
      if (featSphradsegStms)
        {
          printf("M featSphradseg %d\n", featSphradsegStms);
          used++;
        }
      else
        unusedStms[unused++] = "featSphradseg";
    }
  else if (featSphradsegStms)
    nonoStms[nono++] = "featSphradseg";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "featSymplnStm") == 0))
    {
      k++;
      allowed++;
      if (featSymplnStms)
        {
          printf("M featSympln %d\n", featSymplnStms);
          used++;
        }
      else
        unusedStms[unused++] = "featSympln";
    }
  else if (featSymplnStms)
    nonoStms[nono++] = "featSympln";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "featTorradsegStm") == 0))
    {
      k++;
      allowed++;
      if (featTorradsegStms)
        {
          printf("M featTorradseg %d\n", featTorradsegStms);
          used++;
        }
      else
        unusedStms[unused++] = "featTorradseg";
    }
  else if (featTorradsegStms)
    nonoStms[nono++] = "featTorradseg";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "featTorusStm") == 0))
    {
      k++;
      allowed++;
      if (featTorusStms)
        {
          printf("M featTorus %d\n", featTorusStms);
          used++;
        }
      else
        unusedStms[unused++] = "featTorus";
    }
  else if (featTorusStms)
    nonoStms[nono++] = "featTorus";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "fedratStm") == 0))
    {
      k++;
      allowed++;
      if (fedratStms)
        {
          printf("fedrat %d\n", fedratStms);
          used++;
        }
      else
        unusedStms[unused++] = "fedrat";
    }
  else if (fedratStms)
    nonoStms[nono++] = "fedrat";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "fildefStm") == 0))
    {
      k++;
      allowed++;
      if (fildefStms)
        {
          printf("fildef %d\n", fildefStms);
          used++;
        }
      else
        unusedStms[unused++] = "fildef";
    }
  else if (fildefStms)
    nonoStms[nono++] = "fildef";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "filnamStm") == 0))
    {
      k++;
      allowed++;
      if (filnamStms)
        {
          printf("filnam %d\n", filnamStms);
          used++;
        }
      else
        unusedStms[unused++] = "filnam";
    }
  else if (filnamStms)
    nonoStms[nono++] = "filnam";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "finposStm") == 0))
    {
      k++;
      allowed++;
      if (finposStms)
        {
          printf("finpos %d\n", finposStms);
          used++;
        }
      else
        unusedStms[unused++] = "finpos";
    }
  else if (finposStms)
    nonoStms[nono++] = "finpos";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "fixtidStm") == 0))
    {
      k++;
      allowed++;
      if (fixtidStms)
        {
          printf("fixtid %d\n", fixtidStms);
          used++;
        }
      else
        unusedStms[unused++] = "fixtid";
    }
  else if (fixtidStms)
    nonoStms[nono++] = "fixtid";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "fixtsnStm") == 0))
    {
      k++;
      allowed++;
      if (fixtsnStms)
        {
          printf("fixtsn %d\n", fixtsnStms);
          used++;
        }
      else
        unusedStms[unused++] = "fixtsn";
    }
  else if (fixtsnStms)
    nonoStms[nono++] = "fixtsn";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "flyStm") == 0))
    {
      k++;
      allowed++;
      if (flyStms)
        {
          printf("fly %d\n", flyStms);
          used++;
        }
      else
        unusedStms[unused++] = "fly";
    }
  else if (flyStms)
    nonoStms[nono++] = "fly";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "fromStm") == 0))
    {
      k++;
      allowed++;
      if (fromStms)
        {
          printf("from %d\n", fromStms);
          used++;
        }
      else
        unusedStms[unused++] = "from";
    }
  else if (fromStms)
    nonoStms[nono++] = "from";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "geoalgStm") == 0))
    {
      k++;
      allowed++;
      if (geoalgStms)
        {
          printf("geoalg %d\n", geoalgStms);
          used++;
        }
      else
        unusedStms[unused++] = "geoalg";
    }
  else if (geoalgStms)
    nonoStms[nono++] = "geoalg";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "geomStm") == 0))
    {
      k++;
      allowed++;
      if (geomStms)
        {
          printf("geom %d\n", geomStms);
          used++;
        }
      else
        unusedStms[unused++] = "geom";
    }
  else if (geomStms)
    nonoStms[nono++] = "geom";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "gohomeStm") == 0))
    {
      k++;
      allowed++;
      if (gohomeStms)
        {
          printf("gohome %d\n", gohomeStms);
          used++;
        }
      else
        unusedStms[unused++] = "gohome";
    }
  else if (gohomeStms)
    nonoStms[nono++] = "gohome";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "gotargStm") == 0))
    {
      k++;
      allowed++;
      if (gotargStms)
        {
          printf("gotarg %d\n", gotargStms);
          used++;
        }
      else
        unusedStms[unused++] = "gotarg";
    }
  else if (gotargStms)
    nonoStms[nono++] = "gotarg";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "gotoStm") == 0))
    {
      k++;
      allowed++;
      if (gotoStms)
        {
          printf("M goto %d\n", gotoStms);
          used++;
        }
      else
        unusedStms[unused++] = "goto";
    }
  else if (gotoStms)
    nonoStms[nono++] = "goto";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "groupStm") == 0))
    {
      k++;
      allowed++;
      if (groupStms)
        {
          printf("group %d\n", groupStms);
          used++;
        }
      else
        unusedStms[unused++] = "group";
    }
  else if (groupStms)
    nonoStms[nono++] = "group";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "ifStm") == 0))
    {
      k++;
      allowed++;
      if (ifStms)
        {
          printf("if %d\n", ifStms);
          used++;
        }
      else
        unusedStms[unused++] = "if";
    }
  else if (ifStms)
    nonoStms[nono++] = "if";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "includStm") == 0))
    {
      k++;
      allowed++;
      if (includStms)
        {
          printf("includ %d\n", includStms);
          used++;
        }
      else
        unusedStms[unused++] = "includ";
    }
  else if (includStms)
    nonoStms[nono++] = "includ";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "iteratStm") == 0))
    {
      k++;
      allowed++;
      if (iteratStms)
        {
          printf("iterat %d\n", iteratStms);
          used++;
        }
      else
        unusedStms[unused++] = "iterat";
    }
  else if (iteratStms)
    nonoStms[nono++] = "iterat";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "jumpStm") == 0))
    {
      k++;
      allowed++;
      if (jumpStms)
        {
          printf("jump %d\n", jumpStms);
          used++;
        }
      else
        unusedStms[unused++] = "jump";
    }
  else if (jumpStms)
    nonoStms[nono++] = "jump";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "jumptoStm") == 0))
    {
      k++;
      allowed++;
      if (jumptoStms)
        {
          printf("jumpto %d\n", jumptoStms);
          used++;
        }
      else
        unusedStms[unused++] = "jumpto";
    }
  else if (jumptoStms)
    nonoStms[nono++] = "jumpto";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "keycharStm") == 0))
    {
      k++;
      allowed++;
      if (keycharStms)
        {
          printf("keychar %d\n", keycharStms);
          used++;
        }
      else
        unusedStms[unused++] = "keychar";
    }
  else if (keycharStms)
    nonoStms[nono++] = "keychar";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "litdefStm") == 0))
    {
      k++;
      allowed++;
      if (litdefStms)
        {
          printf("litdef %d\n", litdefStms);
          used++;
        }
      else
        unusedStms[unused++] = "litdef";
    }
  else if (litdefStms)
    nonoStms[nono++] = "litdef";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "locateStm") == 0))
    {
      k++;
      allowed++;
      if (locateStms)
        {
          printf("locate %d\n", locateStms);
          used++;
        }
      else
        unusedStms[unused++] = "locate";
    }
  else if (locateStms)
    nonoStms[nono++] = "locate";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "lotidStm") == 0))
    {
      k++;
      allowed++;
      if (lotidStms)
        {
          printf("lotid %d\n", lotidStms);
          used++;
        }
      else
        unusedStms[unused++] = "lotid";
    }
  else if (lotidStms)
    nonoStms[nono++] = "lotid";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "macroStm") == 0))
    {
      k++;
      allowed++;
      if (macroStms)
        {
          printf("macro %d\n", macroStms);
          used++;
        }
      else
        unusedStms[unused++] = "macro";
    }
  else if (macroStms)
    nonoStms[nono++] = "macro";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "matdefStm") == 0))
    {
      k++;
      allowed++;
      if (matdefStms)
        {
          printf("matdef %d\n", matdefStms);
          used++;
        }
      else
        unusedStms[unused++] = "matdef";
    }
  else if (matdefStms)
    nonoStms[nono++] = "matdef";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "measStm") == 0))
    {
      k++;
      allowed++;
      if (measStms)
        {
          printf("M meas %d\n", measStms);
          used++;
        }
      else
        unusedStms[unused++] = "meas";
    }
  else if (measStms)
    nonoStms[nono++] = "meas";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "mfgdevStm") == 0))
    {
      k++;
      allowed++;
      if (mfgdevStms)
        {
          printf("mfgdev %d\n", mfgdevStms);
          used++;
        }
      else
        unusedStms[unused++] = "mfgdev";
    }
  else if (mfgdevStms)
    nonoStms[nono++] = "mfgdev";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "modeStm") == 0))
    {
      k++;
      allowed++;
      if (modeStms)
        {
          printf("M mode %d\n", modeStms);
          used++;
        }
      else
        unusedStms[unused++] = "mode";
    }
  else if (modeStms)
    nonoStms[nono++] = "mode";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "obtainStm") == 0))
    {
      k++;
      allowed++;
      if (obtainStms)
        {
          printf("obtain %d\n", obtainStms);
          used++;
        }
      else
        unusedStms[unused++] = "obtain";
    }
  else if (obtainStms)
    nonoStms[nono++] = "obtain";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "openStm") == 0))
    {
      k++;
      allowed++;
      if (openStms)
        {
          printf("open %d\n", openStms);
          used++;
        }
      else
        unusedStms[unused++] = "open";
    }
  else if (openStms)
    nonoStms[nono++] = "open";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "operidStm") == 0))
    {
      k++;
      allowed++;
      if (operidStms)
        {
          printf("operid %d\n", operidStms);
          used++;
        }
      else
        unusedStms[unused++] = "operid";
    }
  else if (operidStms)
    nonoStms[nono++] = "operid";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "outputStm") == 0))
    {
      k++;
      allowed++;
      if (outputStms)
        {
          printf("output %d\n", outputStms);
          used++;
        }
      else
        unusedStms[unused++] = "output";
    }
  else if (outputStms)
    nonoStms[nono++] = "output";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "pameasStm") == 0))
    {
      k++;
      allowed++;
      if (pameasStms)
        {
          printf("M pameas %d\n", pameasStms);
          used++;
        }
      else
        unusedStms[unused++] = "pameas";
    }
  else if (pameasStms)
    nonoStms[nono++] = "pameas";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "partidStm") == 0))
    {
      k++;
      allowed++;
      if (partidStms)
        {
          printf("partid %d\n", partidStms);
          used++;
        }
      else
        unusedStms[unused++] = "partid";
    }
  else if (partidStms)
    nonoStms[nono++] = "partid";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "partrvStm") == 0))
    {
      k++;
      allowed++;
      if (partrvStms)
        {
          printf("partrv %d\n", partrvStms);
          used++;
        }
      else
        unusedStms[unused++] = "partrv";
    }
  else if (partrvStms)
    nonoStms[nono++] = "partrv";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "partsnStm") == 0))
    {
      k++;
      allowed++;
      if (partsnStms)
        {
          printf("partsn %d\n", partsnStms);
          used++;
        }
      else
        unusedStms[unused++] = "partsn";
    }
  else if (partsnStms)
    nonoStms[nono++] = "partsn";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "pathStm") == 0))
    {
      k++;
      allowed++;
      if (pathStms)
        {
          printf("path %d\n", pathStms);
          used++;
        }
      else
        unusedStms[unused++] = "path";
    }
  else if (pathStms)
    nonoStms[nono++] = "path";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "planidStm") == 0))
    {
      k++;
      allowed++;
      if (planidStms)
        {
          printf("planid %d\n", planidStms);
          used++;
        }
      else
        unusedStms[unused++] = "planid";
    }
  else if (planidStms)
    nonoStms[nono++] = "planid";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "popStm") == 0))
    {
      k++;
      allowed++;
      if (popStms)
        {
          printf("pop %d\n", popStms);
          used++;
        }
      else
        unusedStms[unused++] = "pop";
    }
  else if (popStms)
    nonoStms[nono++] = "pop";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "prcompStm") == 0))
    {
      k++;
      allowed++;
      if (prcompStms)
        {
          printf("prcomp %d\n", prcompStms);
          used++;
        }
      else
        unusedStms[unused++] = "prcomp";
    }
  else if (prcompStms)
    nonoStms[nono++] = "prcomp";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "prevopStm") == 0))
    {
      k++;
      allowed++;
      if (prevopStms)
        {
          printf("prevop %d\n", prevopStms);
          used++;
        }
      else
        unusedStms[unused++] = "prevop";
    }
  else if (prevopStms)
    nonoStms[nono++] = "prevop";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "procidStm") == 0))
    {
      k++;
      allowed++;
      if (procidStms)
        {
          printf("procid %d\n", procidStms);
          used++;
        }
      else
        unusedStms[unused++] = "procid";
    }
  else if (procidStms)
    nonoStms[nono++] = "procid";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "promptStm") == 0))
    {
      k++;
      allowed++;
      if (promptStms)
        {
          printf("prompt %d\n", promptStms);
          used++;
        }
      else
        unusedStms[unused++] = "prompt";
    }
  else if (promptStms)
    nonoStms[nono++] = "prompt";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "psthruStm") == 0))
    {
      k++;
      allowed++;
      if (psthruStms)
        {
          printf("psthru %d\n", psthruStms);
          used++;
        }
      else
        unusedStms[unused++] = "psthru";
    }
  else if (psthruStms)
    nonoStms[nono++] = "psthru";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "ptbuffStm") == 0))
    {
      k++;
      allowed++;
      if (ptbuffStms)
        {
          printf("ptbuff %d\n", ptbuffStms);
          used++;
        }
      else
        unusedStms[unused++] = "ptbuff";
    }
  else if (ptbuffStms)
    nonoStms[nono++] = "ptbuff";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "ptmeasStm") == 0))
    {
      k++;
      allowed++;
      if (ptmeasStms)
        {
          printf("M ptmeas %d\n", ptmeasStms);
          used++;
        }
      else
        unusedStms[unused++] = "ptmeas";
    }
  else if (ptmeasStms)
    nonoStms[nono++] = "ptmeas";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "pushStm") == 0))
    {
      k++;
      allowed++;
      if (pushStms)
        {
          printf("push %d\n", pushStms);
          used++;
        }
      else
        unusedStms[unused++] = "push";
    }
  else if (pushStms)
    nonoStms[nono++] = "push";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "qisdefStm") == 0))
    {
      k++;
      allowed++;
      if (qisdefStms)
        {
          printf("qisdef %d\n", qisdefStms);
          used++;
        }
      else
        unusedStms[unused++] = "qisdef";
    }
  else if (qisdefStms)
    nonoStms[nono++] = "qisdef";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "rapidStm") == 0))
    {
      k++;
      allowed++;
      if (rapidStms)
        {
          printf("rapid %d\n", rapidStms);
          used++;
        }
      else
        unusedStms[unused++] = "rapid";
    }
  else if (rapidStms)
    nonoStms[nono++] = "rapid";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "readStm") == 0))
    {
      k++;
      allowed++;
      if (readStms)
        {
          printf("read %d\n", readStms);
          used++;
        }
      else
        unusedStms[unused++] = "read";
    }
  else if (readStms)
    nonoStms[nono++] = "read";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "recallDMLStm") == 0))
    {
      k++;
      allowed++;
      if (recallDMLStms)
        {
          printf("recallDML %d\n", recallDMLStms);
          used++;
        }
      else
        unusedStms[unused++] = "recallDML";
    }
  else if (recallDMLStms)
    nonoStms[nono++] = "recallDML";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "recallDatumStm") == 0))
    {
      k++;
      allowed++;
      if (recallDatumStms)
        {
          printf("recallDatum %d\n", recallDatumStms);
          used++;
        }
      else
        unusedStms[unused++] = "recallDatum";
    }
  else if (recallDatumStms)
    nonoStms[nono++] = "recallDatum";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "recallFeatureStm") == 0))
    {
      k++;
      allowed++;
      if (recallFeatureStms)
        {
          printf("recallFeature %d\n", recallFeatureStms);
          used++;
        }
      else
        unusedStms[unused++] = "recallFeature";
    }
  else if (recallFeatureStms)
    nonoStms[nono++] = "recallFeature";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "recallRotaryTableStm") == 0))
    {
      k++;
      allowed++;
      if (recallRotaryTableStms)
        {
          printf("recallRotaryTable %d\n", recallRotaryTableStms);
          used++;
        }
      else
        unusedStms[unused++] = "recallRotaryTable";
    }
  else if (recallRotaryTableStms)
    nonoStms[nono++] = "recallRotaryTable";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "recallSensorStm") == 0))
    {
      k++;
      allowed++;
      if (recallSensorStms)
        {
          printf("recallSensor %d\n", recallSensorStms);
          used++;
        }
      else
        unusedStms[unused++] = "recallSensor";
    }
  else if (recallSensorStms)
    nonoStms[nono++] = "recallSensor";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "refmntStm") == 0))
    {
      k++;
      allowed++;
      if (refmntStms)
        {
          printf("refmnt %d\n", refmntStms);
          used++;
        }
      else
        unusedStms[unused++] = "refmnt";
    }
  else if (refmntStms)
    nonoStms[nono++] = "refmnt";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "reportStm") == 0))
    {
      k++;
      allowed++;
      if (reportStms)
        {
          printf("report %d\n", reportStms);
          used++;
        }
      else
        unusedStms[unused++] = "report";
    }
  else if (reportStms)
    nonoStms[nono++] = "report";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "resumeStm") == 0))
    {
      k++;
      allowed++;
      if (resumeStms)
        {
          printf("resume %d\n", resumeStms);
          used++;
        }
      else
        unusedStms[unused++] = "resume";
    }
  else if (resumeStms)
    nonoStms[nono++] = "resume";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "rmeasStm") == 0))
    {
      k++;
      allowed++;
      if (rmeasStms)
        {
          printf("M rmeas %d\n", rmeasStms);
          used++;
        }
      else
        unusedStms[unused++] = "rmeas";
    }
  else if (rmeasStms)
    nonoStms[nono++] = "rmeas";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "rotabStm") == 0))
    {
      k++;
      allowed++;
      if (rotabStms)
        {
          printf("rotab %d\n", rotabStms);
          used++;
        }
      else
        unusedStms[unused++] = "rotab";
    }
  else if (rotabStms)
    nonoStms[nono++] = "rotab";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "rotateStm") == 0))
    {
      k++;
      allowed++;
      if (rotateStms)
        {
          printf("M rotate %d\n", rotateStms);
          used++;
        }
      else
        unusedStms[unused++] = "rotate";
    }
  else if (rotateStms)
    nonoStms[nono++] = "rotate";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "rotdefStm") == 0))
    {
      k++;
      allowed++;
      if (rotdefStms)
        {
          printf("rotdef %d\n", rotdefStms);
          used++;
        }
      else
        unusedStms[unused++] = "rotdef";
    }
  else if (rotdefStms)
    nonoStms[nono++] = "rotdef";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "rotsetStm") == 0))
    {
      k++;
      allowed++;
      if (rotsetStms)
        {
          printf("rotset %d\n", rotsetStms);
          used++;
        }
      else
        unusedStms[unused++] = "rotset";
    }
  else if (rotsetStms)
    nonoStms[nono++] = "rotset";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "saveDMLStm") == 0))
    {
      k++;
      allowed++;
      if (saveDMLStms)
        {
          printf("saveDML %d\n", saveDMLStms);
          used++;
        }
      else
        unusedStms[unused++] = "saveDML";
    }
  else if (saveDMLStms)
    nonoStms[nono++] = "saveDML";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "saveDatumStm") == 0))
    {
      k++;
      allowed++;
      if (saveDatumStms)
        {
          printf("saveDatum %d\n", saveDatumStms);
          used++;
        }
      else
        unusedStms[unused++] = "saveDatum";
    }
  else if (saveDatumStms)
    nonoStms[nono++] = "saveDatum";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "saveFeatureStm") == 0))
    {
      k++;
      allowed++;
      if (saveFeatureStms)
        {
          printf("saveFeature %d\n", saveFeatureStms);
          used++;
        }
      else
        unusedStms[unused++] = "saveFeature";
    }
  else if (saveFeatureStms)
    nonoStms[nono++] = "saveFeature";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "saveRotaryTableStm") == 0))
    {
      k++;
      allowed++;
      if (saveRotaryTableStms)
        {
          printf("saveRotaryTable %d\n", saveRotaryTableStms);
          used++;
        }
      else
        unusedStms[unused++] = "saveRotaryTable";
    }
  else if (saveRotaryTableStms)
    nonoStms[nono++] = "saveRotaryTable";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "saveSensorStm") == 0))
    {
      k++;
      allowed++;
      if (saveSensorStms)
        {
          printf("saveSensor %d\n", saveSensorStms);
          used++;
        }
      else
        unusedStms[unused++] = "saveSensor";
    }
  else if (saveSensorStms)
    nonoStms[nono++] = "saveSensor";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "scnmodStm") == 0))
    {
      k++;
      allowed++;
      if (scnmodStms)
        {
          printf("M scnmod %d\n", scnmodStms);
          used++;
        }
      else
        unusedStms[unused++] = "scnmod";
    }
  else if (scnmodStms)
    nonoStms[nono++] = "scnmod";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "scnsetStm") == 0))
    {
      k++;
      allowed++;
      if (scnsetStms)
        {
          printf("M scnset %d\n", scnsetStms);
          used++;
        }
      else
        unusedStms[unused++] = "scnset";
    }
  else if (scnsetStms)
    nonoStms[nono++] = "scnset";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "selectStm") == 0))
    {
      k++;
      allowed++;
      if (selectStms)
        {
          printf("select %d\n", selectStms);
          used++;
        }
      else
        unusedStms[unused++] = "select";
    }
  else if (selectStms)
    nonoStms[nono++] = "select";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "sensorStm") == 0))
    {
      k++;
      allowed++;
      if (sensorStms)
        {
          printf("sensor %d\n", sensorStms);
          used++;
        }
      else
        unusedStms[unused++] = "sensor";
    }
  else if (sensorStms)
    nonoStms[nono++] = "sensor";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "simreqtStm") == 0))
    {
      k++;
      allowed++;
      if (simreqtStms)
        {
          printf("simreqt %d\n", simreqtStms);
          used++;
        }
      else
        unusedStms[unused++] = "simreqt";
    }
  else if (simreqtStms)
    nonoStms[nono++] = "simreqt";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "snsdefStm") == 0))
    {
      k++;
      allowed++;
      if (snsdefStms)
        {
          printf("M snsdef %d\n", snsdefStms);
          used++;
        }
      else
        unusedStms[unused++] = "snsdef";
    }
  else if (snsdefStms)
    nonoStms[nono++] = "snsdef";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "snsetStm") == 0))
    {
      k++;
      allowed++;
      if (snsetStms)
        {
          printf("snset %d\n", snsetStms);
          used++;
        }
      else
        unusedStms[unused++] = "snset";
    }
  else if (snsetStms)
    nonoStms[nono++] = "snset";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "snsgrpStm") == 0))
    {
      k++;
      allowed++;
      if (snsgrpStms)
        {
          printf("snsgrp %d\n", snsgrpStms);
          used++;
        }
      else
        unusedStms[unused++] = "snsgrp";
    }
  else if (snsgrpStms)
    nonoStms[nono++] = "snsgrp";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "snslctStm") == 0))
    {
      k++;
      allowed++;
      if (snslctStms)
        {
          printf("M snslct %d\n", snslctStms);
          used++;
        }
      else
        unusedStms[unused++] = "snslct";
    }
  else if (snslctStms)
    nonoStms[nono++] = "snslct";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "snsmntStm") == 0))
    {
      k++;
      allowed++;
      if (snsmntStms)
        {
          printf("snsmnt %d\n", snsmntStms);
          used++;
        }
      else
        unusedStms[unused++] = "snsmnt";
    }
  else if (snsmntStms)
    nonoStms[nono++] = "snsmnt";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "tecompStm") == 0))
    {
      k++;
      allowed++;
      if (tecompStms)
        {
          printf("tecomp %d\n", tecompStms);
          used++;
        }
      else
        unusedStms[unused++] = "tecomp";
    }
  else if (tecompStms)
    nonoStms[nono++] = "tecomp";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "textStm") == 0))
    {
      k++;
      allowed++;
      if (textStms)
        {
          printf("text %d\n", textStms);
          used++;
        }
      else
        unusedStms[unused++] = "text";
    }
  else if (textStms)
    nonoStms[nono++] = "text";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "thldefStm") == 0))
    {
      k++;
      allowed++;
      if (thldefStms)
        {
          printf("thldef %d\n", thldefStms);
          used++;
        }
      else
        unusedStms[unused++] = "thldef";
    }
  else if (thldefStms)
    nonoStms[nono++] = "thldef";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "tolAnglStm") == 0))
    {
      k++;
      allowed++;
      if (tolAnglStms)
        {
          printf("M tolAngl %d\n", tolAnglStms);
          used++;
        }
      else
        unusedStms[unused++] = "tolAngl";
    }
  else if (tolAnglStms)
    nonoStms[nono++] = "tolAngl";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "tolAnglbStm") == 0))
    {
      k++;
      allowed++;
      if (tolAnglbStms)
        {
          printf("M tolAnglb %d\n", tolAnglbStms);
          used++;
        }
      else
        unusedStms[unused++] = "tolAnglb";
    }
  else if (tolAnglbStms)
    nonoStms[nono++] = "tolAnglb";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "tolAnglrStm") == 0))
    {
      k++;
      allowed++;
      if (tolAnglrStms)
        {
          printf("M tolAnglr %d\n", tolAnglrStms);
          used++;
        }
      else
        unusedStms[unused++] = "tolAnglr";
    }
  else if (tolAnglrStms)
    nonoStms[nono++] = "tolAnglr";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "tolAnglwrtStm") == 0))
    {
      k++;
      allowed++;
      if (tolAnglwrtStms)
        {
          printf("M tolAnglwrt %d\n", tolAnglwrtStms);
          used++;
        }
      else
        unusedStms[unused++] = "tolAnglwrt";
    }
  else if (tolAnglwrtStms)
    nonoStms[nono++] = "tolAnglwrt";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "tolCirltyStm") == 0))
    {
      k++;
      allowed++;
      if (tolCirltyStms)
        {
          printf("M tolCirlty %d\n", tolCirltyStms);
          used++;
        }
      else
        unusedStms[unused++] = "tolCirlty";
    }
  else if (tolCirltyStms)
    nonoStms[nono++] = "tolCirlty";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "tolComposStm") == 0))
    {
      k++;
      allowed++;
      if (tolComposStms)
        {
          printf("M tolCompos %d\n", tolComposStms);
          used++;
        }
      else
        unusedStms[unused++] = "tolCompos";
    }
  else if (tolComposStms)
    nonoStms[nono++] = "tolCompos";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "tolConcenStm") == 0))
    {
      k++;
      allowed++;
      if (tolConcenStms)
        {
          printf("M tolConcen %d\n", tolConcenStms);
          used++;
        }
      else
        unusedStms[unused++] = "tolConcen";
    }
  else if (tolConcenStms)
    nonoStms[nono++] = "tolConcen";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "tolCortolStm") == 0))
    {
      k++;
      allowed++;
      if (tolCortolStms)
        {
          printf("M tolCortol %d\n", tolCortolStms);
          used++;
        }
      else
        unusedStms[unused++] = "tolCortol";
    }
  else if (tolCortolStms)
    nonoStms[nono++] = "tolCortol";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "tolCproflStm") == 0))
    {
      k++;
      allowed++;
      if (tolCproflStms)
        {
          printf("M tolCprofl %d\n", tolCproflStms);
          used++;
        }
      else
        unusedStms[unused++] = "tolCprofl";
    }
  else if (tolCproflStms)
    nonoStms[nono++] = "tolCprofl";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "tolCprofsStm") == 0))
    {
      k++;
      allowed++;
      if (tolCprofsStms)
        {
          printf("M tolCprofs %d\n", tolCprofsStms);
          used++;
        }
      else
        unusedStms[unused++] = "tolCprofs";
    }
  else if (tolCprofsStms)
    nonoStms[nono++] = "tolCprofs";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "tolCrnoutStm") == 0))
    {
      k++;
      allowed++;
      if (tolCrnoutStms)
        {
          printf("M tolCrnout %d\n", tolCrnoutStms);
          used++;
        }
      else
        unusedStms[unused++] = "tolCrnout";
    }
  else if (tolCrnoutStms)
    nonoStms[nono++] = "tolCrnout";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "tolCylctyStm") == 0))
    {
      k++;
      allowed++;
      if (tolCylctyStms)
        {
          printf("M tolCylcty %d\n", tolCylctyStms);
          used++;
        }
      else
        unusedStms[unused++] = "tolCylcty";
    }
  else if (tolCylctyStms)
    nonoStms[nono++] = "tolCylcty";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "tolDiamStm") == 0))
    {
      k++;
      allowed++;
      if (tolDiamStms)
        {
          printf("M tolDiam %d\n", tolDiamStms);
          used++;
        }
      else
        unusedStms[unused++] = "tolDiam";
    }
  else if (tolDiamStms)
    nonoStms[nono++] = "tolDiam";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "tolDistbStm") == 0))
    {
      k++;
      allowed++;
      if (tolDistbStms)
        {
          printf("M tolDistb %d\n", tolDistbStms);
          used++;
        }
      else
        unusedStms[unused++] = "tolDistb";
    }
  else if (tolDistbStms)
    nonoStms[nono++] = "tolDistb";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "tolDistwrtStm") == 0))
    {
      k++;
      allowed++;
      if (tolDistwrtStms)
        {
          printf("M tolDistwrt %d\n", tolDistwrtStms);
          used++;
        }
      else
        unusedStms[unused++] = "tolDistwrt";
    }
  else if (tolDistwrtStms)
    nonoStms[nono++] = "tolDistwrt";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "tolFlatStm") == 0))
    {
      k++;
      allowed++;
      if (tolFlatStms)
        {
          printf("M tolFlat %d\n", tolFlatStms);
          used++;
        }
      else
        unusedStms[unused++] = "tolFlat";
    }
  else if (tolFlatStms)
    nonoStms[nono++] = "tolFlat";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "tolGtolStm") == 0))
    {
      k++;
      allowed++;
      if (tolGtolStms)
        {
          printf("M tolGtol %d\n", tolGtolStms);
          used++;
        }
      else
        unusedStms[unused++] = "tolGtol";
    }
  else if (tolGtolStms)
    nonoStms[nono++] = "tolGtol";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "tolParlelStm") == 0))
    {
      k++;
      allowed++;
      if (tolParlelStms)
        {
          printf("M tolParlel %d\n", tolParlelStms);
          used++;
        }
      else
        unusedStms[unused++] = "tolParlel";
    }
  else if (tolParlelStms)
    nonoStms[nono++] = "tolParlel";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "tolPerpStm") == 0))
    {
      k++;
      allowed++;
      if (tolPerpStms)
        {
          printf("M tolPerp %d\n", tolPerpStms);
          used++;
        }
      else
        unusedStms[unused++] = "tolPerp";
    }
  else if (tolPerpStms)
    nonoStms[nono++] = "tolPerp";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "tolPosStm") == 0))
    {
      k++;
      allowed++;
      if (tolPosStms)
        {
          printf("M tolPos %d\n", tolPosStms);
          used++;
        }
      else
        unusedStms[unused++] = "tolPos";
    }
  else if (tolPosStms)
    nonoStms[nono++] = "tolPos";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "tolProflStm") == 0))
    {
      k++;
      allowed++;
      if (tolProflStms)
        {
          printf("M tolProfl %d\n", tolProflStms);
          used++;
        }
      else
        unusedStms[unused++] = "tolProfl";
    }
  else if (tolProflStms)
    nonoStms[nono++] = "tolProfl";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "tolProfpStm") == 0))
    {
      k++;
      allowed++;
      if (tolProfpStms)
        {
          printf("M tolProfp %d\n", tolProfpStms);
          used++;
        }
      else
        unusedStms[unused++] = "tolProfp";
    }
  else if (tolProfpStms)
    nonoStms[nono++] = "tolProfp";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "tolProfsStm") == 0))
    {
      k++;
      allowed++;
      if (tolProfsStms)
        {
          printf("M tolProfs %d\n", tolProfsStms);
          used++;
        }
      else
        unusedStms[unused++] = "tolProfs";
    }
  else if (tolProfsStms)
    nonoStms[nono++] = "tolProfs";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "tolRadStm") == 0))
    {
      k++;
      allowed++;
      if (tolRadStms)
        {
          printf("M tolRad %d\n", tolRadStms);
          used++;
        }
      else
        unusedStms[unused++] = "tolRad";
    }
  else if (tolRadStms)
    nonoStms[nono++] = "tolRad";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "tolStrghtStm") == 0))
    {
      k++;
      allowed++;
      if (tolStrghtStms)
        {
          printf("M tolStrght %d\n", tolStrghtStms);
          used++;
        }
      else
        unusedStms[unused++] = "tolStrght";
    }
  else if (tolStrghtStms)
    nonoStms[nono++] = "tolStrght";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "tolSymStm") == 0))
    {
      k++;
      allowed++;
      if (tolSymStms)
        {
          printf("M tolSym %d\n", tolSymStms);
          used++;
        }
      else
        unusedStms[unused++] = "tolSym";
    }
  else if (tolSymStms)
    nonoStms[nono++] = "tolSym";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "tolTrnoutStm") == 0))
    {
      k++;
      allowed++;
      if (tolTrnoutStms)
        {
          printf("M tolTrnout %d\n", tolTrnoutStms);
          used++;
        }
      else
        unusedStms[unused++] = "tolTrnout";
    }
  else if (tolTrnoutStms)
    nonoStms[nono++] = "tolTrnout";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "tolUsetolStm") == 0))
    {
      k++;
      allowed++;
      if (tolUsetolStms)
        {
          printf("M tolUsetol %d\n", tolUsetolStms);
          used++;
        }
      else
        unusedStms[unused++] = "tolUsetol";
    }
  else if (tolUsetolStms)
    nonoStms[nono++] = "tolUsetol";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "tolWidthStm") == 0))
    {
      k++;
      allowed++;
      if (tolWidthStms)
        {
          printf("M tolWidth %d\n", tolWidthStms);
          used++;
        }
      else
        unusedStms[unused++] = "tolWidth";
    }
  else if (tolWidthStms)
    nonoStms[nono++] = "tolWidth";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "tooldfStm") == 0))
    {
      k++;
      allowed++;
      if (tooldfStms)
        {
          printf("tooldf %d\n", tooldfStms);
          used++;
        }
      else
        unusedStms[unused++] = "tooldf";
    }
  else if (tooldfStms)
    nonoStms[nono++] = "tooldf";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "transStm") == 0))
    {
      k++;
      allowed++;
      if (transStms)
        {
          printf("M trans %d\n", transStms);
          used++;
        }
      else
        unusedStms[unused++] = "trans";
    }
  else if (transStms)
    nonoStms[nono++] = "trans";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "uncertalgStm") == 0))
    {
      k++;
      allowed++;
      if (uncertalgStms)
        {
          printf("uncertalg %d\n", uncertalgStms);
          used++;
        }
      else
        unusedStms[unused++] = "uncertalg";
    }
  else if (uncertalgStms)
    nonoStms[nono++] = "uncertalg";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "uncertsetStm") == 0))
    {
      k++;
      allowed++;
      if (uncertsetStms)
        {
          printf("uncertset %d\n", uncertsetStms);
          used++;
        }
      else
        unusedStms[unused++] = "uncertset";
    }
  else if (uncertsetStms)
    nonoStms[nono++] = "uncertset";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "unitsStm") == 0))
    {
      k++;
      allowed++;
      if (unitsStms)
        {
          printf("units %d\n", unitsStms);
          used++;
        }
      else
        unusedStms[unused++] = "units";
    }
  else if (unitsStms)
    nonoStms[nono++] = "units";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "valueStm") == 0))
    {
      k++;
      allowed++;
      if (valueStms)
        {
          printf("value %d\n", valueStms);
          used++;
        }
      else
        unusedStms[unused++] = "value";
    }
  else if (valueStms)
    nonoStms[nono++] = "value";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "vformStm") == 0))
    {
      k++;
      allowed++;
      if (vformStms)
        {
          printf("vform %d\n", vformStms);
          used++;
        }
      else
        unusedStms[unused++] = "vform";
    }
  else if (vformStms)
    nonoStms[nono++] = "vform";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "windefStm") == 0))
    {
      k++;
      allowed++;
      if (windefStms)
        {
          printf("windef %d\n", windefStms);
          used++;
        }
      else
        unusedStms[unused++] = "windef";
    }
  else if (windefStms)
    nonoStms[nono++] = "windef";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "wkplanStm") == 0))
    {
      k++;
      allowed++;
      if (wkplanStms)
        {
          printf("wkplan %d\n", wkplanStms);
          used++;
        }
      else
        unusedStms[unused++] = "wkplan";
    }
  else if (wkplanStms)
    nonoStms[nono++] = "wkplan";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "wristStm") == 0))
    {
      k++;
      allowed++;
      if (wristStms)
        {
          printf("wrist %d\n", wristStms);
          used++;
        }
      else
        unusedStms[unused++] = "wrist";
    }
  else if (wristStms)
    nonoStms[nono++] = "wrist";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "writeStm") == 0))
    {
      k++;
      allowed++;
      if (writeStms)
        {
          printf("write %d\n", writeStms);
          used++;
        }
      else
        unusedStms[unused++] = "write";
    }
  else if (writeStms)
    nonoStms[nono++] = "write";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "xternStm") == 0))
    {
      k++;
      allowed++;
      if (xternStms)
        {
          printf("xtern %d\n", xternStms);
          used++;
        }
      else
        unusedStms[unused++] = "xtern";
    }
  else if (xternStms)
    nonoStms[nono++] = "xtern";
  if ((theStatements[k]) &&
      (strcmp(theStatements[k], "xtractStm") == 0))
    {
      k++;
      allowed++;
      if (xtractStms)
        {
          printf("xtract %d\n", xtractStms);
          used++;
        }
      else
        unusedStms[unused++] = "xtract";
    }
  else if (xtractStms)
    nonoStms[nono++] = "xtract";
  printf(
      "%.1f%% of the commands in the conformance class were used.\n",
	  ((used * 100.0) / allowed));
  if (unused)
    {
      j = 0;
      printf("The following commands were not used:\n");
      for (k = 0; k < unused; k++)
	{
	  for (; ((result = strcmp(essentials[j], unusedStms[k])) < 0); j++);
	  printf("%s%s\n", ((result == 0) ? "M " : ""), unusedStms[k]);
	}
    }
  if (nono)
    {
      printf(
       "The following commands not in the conformance class were used:\n");
      for (k = 0; k < nono; k++)
        printf("%s\n", nonoStms[k]);
    }
}

/********************************************************************/

/* reportSummaryFull

For each statement type T in full DMIS:

1. If T has been used, the number of times it was used is printed.
2. If T has not been used, it is added to the unusedStms array.

Then this prints the percentage of full DMIS statements that were
used and the names of statements that were not used.

*/

void reportSummaryFull()
{
  int used;    // counter for number of full DMIS statements used
  int unused;  // counter for number of full DMIS statements not used
  const char * unusedStms[300];
  int k;       // index for unused statements
  used = 0;
  unused = 0;

  printf("********************************************\n\n");
  printf("Total statement uses for all files\n\n");

  if (aclratStms)
    {
      printf("aclrat %d\n", aclratStms);
      used++;
    }
  else
    unusedStms[unused++] = "aclrat";
  if (algdefStms)
    {
      printf("algdef %d\n", algdefStms);
      used++;
    }
  else
    unusedStms[unused++] = "algdef";
  if (assignStms)
    {
      printf("assign %d\n", assignStms);
      used++;
    }
  else
    unusedStms[unused++] = "assign";
  if (badtstStms)
    {
      printf("badtst %d\n", badtstStms);
      used++;
    }
  else
    unusedStms[unused++] = "badtst";
  if (boundStms)
    {
      printf("bound %d\n", boundStms);
      used++;
    }
  else
    unusedStms[unused++] = "bound";
  if (calibMasterStms)
    {
      printf("calibMaster %d\n", calibMasterStms);
      used++;
    }
  else
    unusedStms[unused++] = "calibMaster";
  if (calibRtabStms)
    {
      printf("calibRtab %d\n", calibRtabStms);
      used++;
    }
  else
    unusedStms[unused++] = "calibRtab";
  if (calibSensStms)
    {
      printf("calibSens %d\n", calibSensStms);
      used++;
    }
  else
    unusedStms[unused++] = "calibSens";
  if (callStms)
    {
      printf("call %d\n", callStms);
      used++;
    }
  else
    unusedStms[unused++] = "call";
  if (caseStms)
    {
      printf("case %d\n", caseStms);
      used++;
    }
  else
    unusedStms[unused++] = "case";
  if (clmpidStms)
    {
      printf("clmpid %d\n", clmpidStms);
      used++;
    }
  else
    unusedStms[unused++] = "clmpid";
  if (clmpsnStms)
    {
      printf("clmpsn %d\n", clmpsnStms);
      used++;
    }
  else
    unusedStms[unused++] = "clmpsn";
  if (closeStms)
    {
      printf("close %d\n", closeStms);
      used++;
    }
  else
    unusedStms[unused++] = "close";
  if (cmpntgrpStms)
    {
      printf("cmpntgrp %d\n", cmpntgrpStms);
      used++;
    }
  else
    unusedStms[unused++] = "cmpntgrp";
  if (cnfrmrulStms)
    {
      printf("cnfrmrul %d\n", cnfrmrulStms);
      used++;
    }
  else
    unusedStms[unused++] = "cnfrmrul";
  if (constStms)
    {
      printf("const %d\n", constStms);
      used++;
    }
  else
    unusedStms[unused++] = "const";
  if (crgdefStms)
    {
      printf("crgdef %d\n", crgdefStms);
      used++;
    }
  else
    unusedStms[unused++] = "crgdef";
  if (crmodeStms)
    {
      printf("crmode %d\n", crmodeStms);
      used++;
    }
  else
    unusedStms[unused++] = "crmode";
  if (crosclStms)
    {
      printf("croscl %d\n", crosclStms);
      used++;
    }
  else
    unusedStms[unused++] = "croscl";
  if (crslctStms)
    {
      printf("crslct %d\n", crslctStms);
      used++;
    }
  else
    unusedStms[unused++] = "crslct";
  if (cutcomStms)
    {
      printf("cutcom %d\n", cutcomStms);
      used++;
    }
  else
    unusedStms[unused++] = "cutcom";
  if (czoneStms)
    {
      printf("czone %d\n", czoneStms);
      used++;
    }
  else
    unusedStms[unused++] = "czone";
  if (czslctStms)
    {
      printf("czslct %d\n", czslctStms);
      used++;
    }
  else
    unusedStms[unused++] = "czslct";
  if (datdefStms)
    {
      printf("datdef %d\n", datdefStms);
      used++;
    }
  else
    unusedStms[unused++] = "datdef";
  if (datsetStms)
    {
      printf("datset %d\n", datsetStms);
      used++;
    }
  else
    unusedStms[unused++] = "datset";
  if (dattrgdefStms)
    {
      printf("dattrgdef %d\n", dattrgdefStms);
      used++;
    }
  else
    unusedStms[unused++] = "dattrgdef";
  if (declStms)
    {
      printf("decl %d\n", declStms);
      used++;
    }
  else
    unusedStms[unused++] = "decl";
  if (decplStms)
    {
      printf("decpl %d\n", decplStms);
      used++;
    }
  else
    unusedStms[unused++] = "decpl";
  if (deleteStms)
    {
      printf("delete %d\n", deleteStms);
      used++;
    }
  else
    unusedStms[unused++] = "delete";
  if (deviceStms)
    {
      printf("device %d\n", deviceStms);
      used++;
    }
  else
    unusedStms[unused++] = "device";
  if (dftcasStms)
    {
      printf("dftcas %d\n", dftcasStms);
      used++;
    }
  else
    unusedStms[unused++] = "dftcas";
  if (displyStms)
    {
      printf("disply %d\n", displyStms);
      used++;
    }
  else
    unusedStms[unused++] = "disply";
  if (dmehwStms)
    {
      printf("dmehw %d\n", dmehwStms);
      used++;
    }
  else
    unusedStms[unused++] = "dmehw";
  if (dmeidStms)
    {
      printf("dmeid %d\n", dmeidStms);
      used++;
    }
  else
    unusedStms[unused++] = "dmeid";
  if (dmeswStms)
    {
      printf("dmesw %d\n", dmeswStms);
      used++;
    }
  else
    unusedStms[unused++] = "dmesw";
  if (dmeswiStms)
    {
      printf("dmeswi %d\n", dmeswiStms);
      used++;
    }
  else
    unusedStms[unused++] = "dmeswi";
  if (dmeswvStms)
    {
      printf("dmeswv %d\n", dmeswvStms);
      used++;
    }
  else
    unusedStms[unused++] = "dmeswv";
  if (dmisOffStms)
    {
      printf("dmisOff %d\n", dmisOffStms);
      used++;
    }
  else
    unusedStms[unused++] = "dmisOff";
  if (dmisOnStms)
    {
      printf("dmisOn %d\n", dmisOnStms);
      used++;
    }
  else
    unusedStms[unused++] = "dmisOn";
  if (dmismdStms)
    {
      printf("dmismd %d\n", dmismdStms);
      used++;
    }
  else
    unusedStms[unused++] = "dmismd";
  if (dmismnStms)
    {
      printf("dmismn %d\n", dmismnStms);
      used++;
    }
  else
    unusedStms[unused++] = "dmismn";
  if (doStms)
    {
      printf("do %d\n", doStms);
      used++;
    }
  else
    unusedStms[unused++] = "do";
  if (elseStms)
    {
      printf("else %d\n", elseStms);
      used++;
    }
  else
    unusedStms[unused++] = "else";
  if (endcasStms)
    {
      printf("endcas %d\n", endcasStms);
      used++;
    }
  else
    unusedStms[unused++] = "endcas";
  if (enddoStms)
    {
      printf("enddo %d\n", enddoStms);
      used++;
    }
  else
    unusedStms[unused++] = "enddo";
  if (endfilStms)
    {
      printf("endfil %d\n", endfilStms);
      used++;
    }
  else
    unusedStms[unused++] = "endfil";
  if (endgoStms)
    {
      printf("endgo %d\n", endgoStms);
      used++;
    }
  else
    unusedStms[unused++] = "endgo";
  if (endifStms)
    {
      printf("endif %d\n", endifStms);
      used++;
    }
  else
    unusedStms[unused++] = "endif";
  if (endmacStms)
    {
      printf("endmac %d\n", endmacStms);
      used++;
    }
  else
    unusedStms[unused++] = "endmac";
  if (endmesStms)
    {
      printf("endmes %d\n", endmesStms);
      used++;
    }
  else
    unusedStms[unused++] = "endmes";
  if (endselStms)
    {
      printf("endsel %d\n", endselStms);
      used++;
    }
  else
    unusedStms[unused++] = "endsel";
  if (endsimreqtStms)
    {
      printf("endsimreqt %d\n", endsimreqtStms);
      used++;
    }
  else
    unusedStms[unused++] = "endsimreqt";
  if (endxtnStms)
    {
      printf("endxtn %d\n", endxtnStms);
      used++;
    }
  else
    unusedStms[unused++] = "endxtn";
  if (equateStms)
    {
      printf("equate %d\n", equateStms);
      used++;
    }
  else
    unusedStms[unused++] = "equate";
  if (errorStms)
    {
      printf("error %d\n", errorStms);
      used++;
    }
  else
    unusedStms[unused++] = "error";
  if (evalStms)
    {
      printf("eval %d\n", evalStms);
      used++;
    }
  else
    unusedStms[unused++] = "eval";
  if (extensStms)
    {
      printf("extens %d\n", extensStms);
      used++;
    }
  else
    unusedStms[unused++] = "extens";
  if (extfilStms)
    {
      printf("extfil %d\n", extfilStms);
      used++;
    }
  else
    unusedStms[unused++] = "extfil";
  if (featArc1Stms)
    {
      printf("featArc1 %d\n", featArc1Stms);
      used++;
    }
  else
    unusedStms[unused++] = "featArc1";
  if (featArc2Stms)
    {
      printf("featArc2 %d\n", featArc2Stms);
      used++;
    }
  else
    unusedStms[unused++] = "featArc2";
  if (featCircleStms)
    {
      printf("featCircle %d\n", featCircleStms);
      used++;
    }
  else
    unusedStms[unused++] = "featCircle";
  if (featCompoundStms)
    {
      printf("featCompound %d\n", featCompoundStms);
      used++;
    }
  else
    unusedStms[unused++] = "featCompound";
  if (featConeStms)
    {
      printf("featCone %d\n", featConeStms);
      used++;
    }
  else
    unusedStms[unused++] = "featCone";
  if (featConradsegStms)
    {
      printf("featConradseg %d\n", featConradsegStms);
      used++;
    }
  else
    unusedStms[unused++] = "featConradseg";
  if (featCparlnStms)
    {
      printf("featCparln %d\n", featCparlnStms);
      used++;
    }
  else
    unusedStms[unused++] = "featCparln";
  if (featCylndrStms)
    {
      printf("featCylndr %d\n", featCylndrStms);
      used++;
    }
  else
    unusedStms[unused++] = "featCylndr";
  if (featCylradsegStms)
    {
      printf("featCylradseg %d\n", featCylradsegStms);
      used++;
    }
  else
    unusedStms[unused++] = "featCylradseg";
  if (featEdgeptStms)
    {
      printf("featEdgept %d\n", featEdgeptStms);
      used++;
    }
  else
    unusedStms[unused++] = "featEdgept";
  if (featEllipsStms)
    {
      printf("featEllips %d\n", featEllipsStms);
      used++;
    }
  else
    unusedStms[unused++] = "featEllips";
  if (featElongcylStms)
    {
      printf("featElongcyl %d\n", featElongcylStms);
      used++;
    }
  else
    unusedStms[unused++] = "featElongcyl";
  if (featGcurveStms)
    {
      printf("featGcurve %d\n", featGcurveStms);
      used++;
    }
  else
    unusedStms[unused++] = "featGcurve";
  if (featGeomStms)
    {
      printf("featGeom %d\n", featGeomStms);
      used++;
    }
  else
    unusedStms[unused++] = "featGeom";
  if (featGsurfStms)
    {
      printf("featGsurf %d\n", featGsurfStms);
      used++;
    }
  else
    unusedStms[unused++] = "featGsurf";
  if (featLineStms)
    {
      printf("featLine %d\n", featLineStms);
      used++;
    }
  else
    unusedStms[unused++] = "featLine";
  if (featObjectStms)
    {
      printf("featObject %d\n", featObjectStms);
      used++;
    }
  else
    unusedStms[unused++] = "featObject";
  if (featParplnStms)
    {
      printf("featParpln %d\n", featParplnStms);
      used++;
    }
  else
    unusedStms[unused++] = "featParpln";
  if (featPaternStms)
    {
      printf("featPatern %d\n", featPaternStms);
      used++;
    }
  else
    unusedStms[unused++] = "featPatern";
  if (featPlaneStms)
    {
      printf("featPlane %d\n", featPlaneStms);
      used++;
    }
  else
    unusedStms[unused++] = "featPlane";
  if (featPointStms)
    {
      printf("featPoint %d\n", featPointStms);
      used++;
    }
  else
    unusedStms[unused++] = "featPoint";
  if (featRctnglStms)
    {
      printf("featRctngl %d\n", featRctnglStms);
      used++;
    }
  else
    unusedStms[unused++] = "featRctngl";
  if (featRevsurfStms)
    {
      printf("featRevsurf %d\n", featRevsurfStms);
      used++;
    }
  else
    unusedStms[unused++] = "featRevsurf";
  if (featSphereStms)
    {
      printf("featSphere %d\n", featSphereStms);
      used++;
    }
  else
    unusedStms[unused++] = "featSphere";
  if (featSphradsegStms)
    {
      printf("featSphradseg %d\n", featSphradsegStms);
      used++;
    }
  else
    unusedStms[unused++] = "featSphradseg";
  if (featSymplnStms)
    {
      printf("featSympln %d\n", featSymplnStms);
      used++;
    }
  else
    unusedStms[unused++] = "featSympln";
  if (featTorradsegStms)
    {
      printf("featTorradseg %d\n", featTorradsegStms);
      used++;
    }
  else
    unusedStms[unused++] = "featTorradseg";
  if (featTorusStms)
    {
      printf("featTorus %d\n", featTorusStms);
      used++;
    }
  else
    unusedStms[unused++] = "featTorus";
  if (fedratStms)
    {
      printf("fedrat %d\n", fedratStms);
      used++;
    }
  else
    unusedStms[unused++] = "fedrat";
  if (fildefStms)
    {
      printf("fildef %d\n", fildefStms);
      used++;
    }
  else
    unusedStms[unused++] = "fildef";
  if (filnamStms)
    {
      printf("filnam %d\n", filnamStms);
      used++;
    }
  else
    unusedStms[unused++] = "filnam";
  if (finposStms)
    {
      printf("finpos %d\n", finposStms);
      used++;
    }
  else
    unusedStms[unused++] = "finpos";
  if (fixtidStms)
    {
      printf("fixtid %d\n", fixtidStms);
      used++;
    }
  else
    unusedStms[unused++] = "fixtid";
  if (fixtsnStms)
    {
      printf("fixtsn %d\n", fixtsnStms);
      used++;
    }
  else
    unusedStms[unused++] = "fixtsn";
  if (flyStms)
    {
      printf("fly %d\n", flyStms);
      used++;
    }
  else
    unusedStms[unused++] = "fly";
  if (fromStms)
    {
      printf("from %d\n", fromStms);
      used++;
    }
  else
    unusedStms[unused++] = "from";
  if (geoalgStms)
    {
      printf("geoalg %d\n", geoalgStms);
      used++;
    }
  else
    unusedStms[unused++] = "geoalg";
  if (geomStms)
    {
      printf("geom %d\n", geomStms);
      used++;
    }
  else
    unusedStms[unused++] = "geom";
  if (gohomeStms)
    {
      printf("gohome %d\n", gohomeStms);
      used++;
    }
  else
    unusedStms[unused++] = "gohome";
  if (gotargStms)
    {
      printf("gotarg %d\n", gotargStms);
      used++;
    }
  else
    unusedStms[unused++] = "gotarg";
  if (gotoStms)
    {
      printf("goto %d\n", gotoStms);
      used++;
    }
  else
    unusedStms[unused++] = "goto";
  if (groupStms)
    {
      printf("group %d\n", groupStms);
      used++;
    }
  else
    unusedStms[unused++] = "group";
  if (ifStms)
    {
      printf("if %d\n", ifStms);
      used++;
    }
  else
    unusedStms[unused++] = "if";
  if (includStms)
    {
      printf("includ %d\n", includStms);
      used++;
    }
  else
    unusedStms[unused++] = "includ";
  if (iteratStms)
    {
      printf("iterat %d\n", iteratStms);
      used++;
    }
  else
    unusedStms[unused++] = "iterat";
  if (jumpStms)
    {
      printf("jump %d\n", jumpStms);
      used++;
    }
  else
    unusedStms[unused++] = "jump";
  if (jumptoStms)
    {
      printf("jumpto %d\n", jumptoStms);
      used++;
    }
  else
    unusedStms[unused++] = "jumpto";
  if (keycharStms)
    {
      printf("keychar %d\n", keycharStms);
      used++;
    }
  else
    unusedStms[unused++] = "keychar";
  if (litdefStms)
    {
      printf("litdef %d\n", litdefStms);
      used++;
    }
  else
    unusedStms[unused++] = "litdef";
  if (locateStms)
    {
      printf("locate %d\n", locateStms);
      used++;
    }
  else
    unusedStms[unused++] = "locate";
  if (lotidStms)
    {
      printf("lotid %d\n", lotidStms);
      used++;
    }
  else
    unusedStms[unused++] = "lotid";
  if (macroStms)
    {
      printf("macro %d\n", macroStms);
      used++;
    }
  else
    unusedStms[unused++] = "macro";
  if (matdefStms)
    {
      printf("matdef %d\n", matdefStms);
      used++;
    }
  else
    unusedStms[unused++] = "matdef";
  if (measStms)
    {
      printf("meas %d\n", measStms);
      used++;
    }
  else
    unusedStms[unused++] = "meas";
  if (mfgdevStms)
    {
      printf("mfgdev %d\n", mfgdevStms);
      used++;
    }
  else
    unusedStms[unused++] = "mfgdev";
  if (modeStms)
    {
      printf("mode %d\n", modeStms);
      used++;
    }
  else
    unusedStms[unused++] = "mode";
  if (obtainStms)
    {
      printf("obtain %d\n", obtainStms);
      used++;
    }
  else
    unusedStms[unused++] = "obtain";
  if (openStms)
    {
      printf("open %d\n", openStms);
      used++;
    }
  else
    unusedStms[unused++] = "open";
  if (operidStms)
    {
      printf("operid %d\n", operidStms);
      used++;
    }
  else
    unusedStms[unused++] = "operid";
  if (outputStms)
    {
      printf("output %d\n", outputStms);
      used++;
    }
  else
    unusedStms[unused++] = "output";
  if (pameasStms)
    {
      printf("pameas %d\n", pameasStms);
      used++;
    }
  else
    unusedStms[unused++] = "pameas";
  if (partidStms)
    {
      printf("partid %d\n", partidStms);
      used++;
    }
  else
    unusedStms[unused++] = "partid";
  if (partrvStms)
    {
      printf("partrv %d\n", partrvStms);
      used++;
    }
  else
    unusedStms[unused++] = "partrv";
  if (partsnStms)
    {
      printf("partsn %d\n", partsnStms);
      used++;
    }
  else
    unusedStms[unused++] = "partsn";
  if (pathStms)
    {
      printf("path %d\n", pathStms);
      used++;
    }
  else
    unusedStms[unused++] = "path";
  if (planidStms)
    {
      printf("planid %d\n", planidStms);
      used++;
    }
  else
    unusedStms[unused++] = "planid";
  if (popStms)
    {
      printf("pop %d\n", popStms);
      used++;
    }
  else
    unusedStms[unused++] = "pop";
  if (prcompStms)
    {
      printf("prcomp %d\n", prcompStms);
      used++;
    }
  else
    unusedStms[unused++] = "prcomp";
  if (prevopStms)
    {
      printf("prevop %d\n", prevopStms);
      used++;
    }
  else
    unusedStms[unused++] = "prevop";
  if (procidStms)
    {
      printf("procid %d\n", procidStms);
      used++;
    }
  else
    unusedStms[unused++] = "procid";
  if (promptStms)
    {
      printf("prompt %d\n", promptStms);
      used++;
    }
  else
    unusedStms[unused++] = "prompt";
  if (psthruStms)
    {
      printf("psthru %d\n", psthruStms);
      used++;
    }
  else
    unusedStms[unused++] = "psthru";
  if (ptbuffStms)
    {
      printf("ptbuff %d\n", ptbuffStms);
      used++;
    }
  else
    unusedStms[unused++] = "ptbuff";
  if (ptmeasStms)
    {
      printf("ptmeas %d\n", ptmeasStms);
      used++;
    }
  else
    unusedStms[unused++] = "ptmeas";
  if (pushStms)
    {
      printf("push %d\n", pushStms);
      used++;
    }
  else
    unusedStms[unused++] = "push";
  if (qisdefStms)
    {
      printf("qisdef %d\n", qisdefStms);
      used++;
    }
  else
    unusedStms[unused++] = "qisdef";
  if (rapidStms)
    {
      printf("rapid %d\n", rapidStms);
      used++;
    }
  else
    unusedStms[unused++] = "rapid";
  if (readStms)
    {
      printf("read %d\n", readStms);
      used++;
    }
  else
    unusedStms[unused++] = "read";
  if (recallDMLStms)
    {
      printf("recallDML %d\n", recallDMLStms);
      used++;
    }
  else
    unusedStms[unused++] = "recallDML";
  if (recallDatumStms)
    {
      printf("recallDatum %d\n", recallDatumStms);
      used++;
    }
  else
    unusedStms[unused++] = "recallDatum";
  if (recallFeatureStms)
    {
      printf("recallFeature %d\n", recallFeatureStms);
      used++;
    }
  else
    unusedStms[unused++] = "recallFeature";
  if (recallRotaryTableStms)
    {
      printf("recallRotaryTable %d\n", recallRotaryTableStms);
      used++;
    }
  else
    unusedStms[unused++] = "recallRotaryTable";
  if (recallSensorStms)
    {
      printf("recallSensor %d\n", recallSensorStms);
      used++;
    }
  else
    unusedStms[unused++] = "recallSensor";
  if (refmntStms)
    {
      printf("refmnt %d\n", refmntStms);
      used++;
    }
  else
    unusedStms[unused++] = "refmnt";
  if (reportStms)
    {
      printf("report %d\n", reportStms);
      used++;
    }
  else
    unusedStms[unused++] = "report";
  if (resumeStms)
    {
      printf("resume %d\n", resumeStms);
      used++;
    }
  else
    unusedStms[unused++] = "resume";
  if (rmeasStms)
    {
      printf("rmeas %d\n", rmeasStms);
      used++;
    }
  else
    unusedStms[unused++] = "rmeas";
  if (rotabStms)
    {
      printf("rotab %d\n", rotabStms);
      used++;
    }
  else
    unusedStms[unused++] = "rotab";
  if (rotateStms)
    {
      printf("rotate %d\n", rotateStms);
      used++;
    }
  else
    unusedStms[unused++] = "rotate";
  if (rotdefStms)
    {
      printf("rotdef %d\n", rotdefStms);
      used++;
    }
  else
    unusedStms[unused++] = "rotdef";
  if (rotsetStms)
    {
      printf("rotset %d\n", rotsetStms);
      used++;
    }
  else
    unusedStms[unused++] = "rotset";
  if (saveDMLStms)
    {
      printf("saveDML %d\n", saveDMLStms);
      used++;
    }
  else
    unusedStms[unused++] = "saveDML";
  if (saveDatumStms)
    {
      printf("saveDatum %d\n", saveDatumStms);
      used++;
    }
  else
    unusedStms[unused++] = "saveDatum";
  if (saveFeatureStms)
    {
      printf("saveFeature %d\n", saveFeatureStms);
      used++;
    }
  else
    unusedStms[unused++] = "saveFeature";
  if (saveRotaryTableStms)
    {
      printf("saveRotaryTable %d\n", saveRotaryTableStms);
      used++;
    }
  else
    unusedStms[unused++] = "saveRotaryTable";
  if (saveSensorStms)
    {
      printf("saveSensor %d\n", saveSensorStms);
      used++;
    }
  else
    unusedStms[unused++] = "saveSensor";
  if (scnmodStms)
    {
      printf("scnmod %d\n", scnmodStms);
      used++;
    }
  else
    unusedStms[unused++] = "scnmod";
  if (scnsetStms)
    {
      printf("scnset %d\n", scnsetStms);
      used++;
    }
  else
    unusedStms[unused++] = "scnset";
  if (selectStms)
    {
      printf("select %d\n", selectStms);
      used++;
    }
  else
    unusedStms[unused++] = "select";
  if (sensorStms)
    {
      printf("sensor %d\n", sensorStms);
      used++;
    }
  else
    unusedStms[unused++] = "sensor";
  if (simreqtStms)
    {
      printf("simreqt %d\n", simreqtStms);
      used++;
    }
  else
    unusedStms[unused++] = "simreqt";
  if (snsdefStms)
    {
      printf("snsdef %d\n", snsdefStms);
      used++;
    }
  else
    unusedStms[unused++] = "snsdef";
  if (snsetStms)
    {
      printf("snset %d\n", snsetStms);
      used++;
    }
  else
    unusedStms[unused++] = "snset";
  if (snsgrpStms)
    {
      printf("snsgrp %d\n", snsgrpStms);
      used++;
    }
  else
    unusedStms[unused++] = "snsgrp";
  if (snslctStms)
    {
      printf("snslct %d\n", snslctStms);
      used++;
    }
  else
    unusedStms[unused++] = "snslct";
  if (snsmntStms)
    {
      printf("snsmnt %d\n", snsmntStms);
      used++;
    }
  else
    unusedStms[unused++] = "snsmnt";
  if (tecompStms)
    {
      printf("tecomp %d\n", tecompStms);
      used++;
    }
  else
    unusedStms[unused++] = "tecomp";
  if (textStms)
    {
      printf("text %d\n", textStms);
      used++;
    }
  else
    unusedStms[unused++] = "text";
  if (thldefStms)
    {
      printf("thldef %d\n", thldefStms);
      used++;
    }
  else
    unusedStms[unused++] = "thldef";
  if (tolAnglStms)
    {
      printf("tolAngl %d\n", tolAnglStms);
      used++;
    }
  else
    unusedStms[unused++] = "tolAngl";
  if (tolAnglbStms)
    {
      printf("tolAnglb %d\n", tolAnglbStms);
      used++;
    }
  else
    unusedStms[unused++] = "tolAnglb";
  if (tolAnglrStms)
    {
      printf("tolAnglr %d\n", tolAnglrStms);
      used++;
    }
  else
    unusedStms[unused++] = "tolAnglr";
  if (tolAnglwrtStms)
    {
      printf("tolAnglwrt %d\n", tolAnglwrtStms);
      used++;
    }
  else
    unusedStms[unused++] = "tolAnglwrt";
  if (tolCirltyStms)
    {
      printf("tolCirlty %d\n", tolCirltyStms);
      used++;
    }
  else
    unusedStms[unused++] = "tolCirlty";
  if (tolComposStms)
    {
      printf("tolCompos %d\n", tolComposStms);
      used++;
    }
  else
    unusedStms[unused++] = "tolCompos";
  if (tolConcenStms)
    {
      printf("tolConcen %d\n", tolConcenStms);
      used++;
    }
  else
    unusedStms[unused++] = "tolConcen";
  if (tolCortolStms)
    {
      printf("tolCortol %d\n", tolCortolStms);
      used++;
    }
  else
    unusedStms[unused++] = "tolCortol";
  if (tolCproflStms)
    {
      printf("tolCprofl %d\n", tolCproflStms);
      used++;
    }
  else
    unusedStms[unused++] = "tolCprofl";
  if (tolCprofsStms)
    {
      printf("tolCprofs %d\n", tolCprofsStms);
      used++;
    }
  else
    unusedStms[unused++] = "tolCprofs";
  if (tolCrnoutStms)
    {
      printf("tolCrnout %d\n", tolCrnoutStms);
      used++;
    }
  else
    unusedStms[unused++] = "tolCrnout";
  if (tolCylctyStms)
    {
      printf("tolCylcty %d\n", tolCylctyStms);
      used++;
    }
  else
    unusedStms[unused++] = "tolCylcty";
  if (tolDiamStms)
    {
      printf("tolDiam %d\n", tolDiamStms);
      used++;
    }
  else
    unusedStms[unused++] = "tolDiam";
  if (tolDistbStms)
    {
      printf("tolDistb %d\n", tolDistbStms);
      used++;
    }
  else
    unusedStms[unused++] = "tolDistb";
  if (tolDistwrtStms)
    {
      printf("tolDistwrt %d\n", tolDistwrtStms);
      used++;
    }
  else
    unusedStms[unused++] = "tolDistwrt";
  if (tolFlatStms)
    {
      printf("tolFlat %d\n", tolFlatStms);
      used++;
    }
  else
    unusedStms[unused++] = "tolFlat";
  if (tolGtolStms)
    {
      printf("tolGtol %d\n", tolGtolStms);
      used++;
    }
  else
    unusedStms[unused++] = "tolGtol";
  if (tolParlelStms)
    {
      printf("tolParlel %d\n", tolParlelStms);
      used++;
    }
  else
    unusedStms[unused++] = "tolParlel";
  if (tolPerpStms)
    {
      printf("tolPerp %d\n", tolPerpStms);
      used++;
    }
  else
    unusedStms[unused++] = "tolPerp";
  if (tolPosStms)
    {
      printf("tolPos %d\n", tolPosStms);
      used++;
    }
  else
    unusedStms[unused++] = "tolPos";
  if (tolProflStms)
    {
      printf("tolProfl %d\n", tolProflStms);
      used++;
    }
  else
    unusedStms[unused++] = "tolProfl";
  if (tolProfpStms)
    {
      printf("tolProfp %d\n", tolProfpStms);
      used++;
    }
  else
    unusedStms[unused++] = "tolProfp";
  if (tolProfsStms)
    {
      printf("tolProfs %d\n", tolProfsStms);
      used++;
    }
  else
    unusedStms[unused++] = "tolProfs";
  if (tolRadStms)
    {
      printf("tolRad %d\n", tolRadStms);
      used++;
    }
  else
    unusedStms[unused++] = "tolRad";
  if (tolStrghtStms)
    {
      printf("tolStrght %d\n", tolStrghtStms);
      used++;
    }
  else
    unusedStms[unused++] = "tolStrght";
  if (tolSymStms)
    {
      printf("tolSym %d\n", tolSymStms);
      used++;
    }
  else
    unusedStms[unused++] = "tolSym";
  if (tolTrnoutStms)
    {
      printf("tolTrnout %d\n", tolTrnoutStms);
      used++;
    }
  else
    unusedStms[unused++] = "tolTrnout";
  if (tolUsetolStms)
    {
      printf("tolUsetol %d\n", tolUsetolStms);
      used++;
    }
  else
    unusedStms[unused++] = "tolUsetol";
  if (tolWidthStms)
    {
      printf("tolWidth %d\n", tolWidthStms);
      used++;
    }
  else
    unusedStms[unused++] = "tolWidth";
  if (tooldfStms)
    {
      printf("tooldf %d\n", tooldfStms);
      used++;
    }
  else
    unusedStms[unused++] = "tooldf";
  if (transStms)
    {
      printf("trans %d\n", transStms);
      used++;
    }
  else
    unusedStms[unused++] = "trans";
  if (uncertalgStms)
    {
      printf("uncertalg %d\n", uncertalgStms);
      used++;
    }
  else
    unusedStms[unused++] = "uncertalg";
  if (uncertsetStms)
    {
      printf("uncertset %d\n", uncertsetStms);
      used++;
    }
  else
    unusedStms[unused++] = "uncertset";
  if (unitsStms)
    {
      printf("units %d\n", unitsStms);
      used++;
    }
  else
    unusedStms[unused++] = "units";
  if (valueStms)
    {
      printf("value %d\n", valueStms);
      used++;
    }
  else
    unusedStms[unused++] = "value";
  if (vformStms)
    {
      printf("vform %d\n", vformStms);
      used++;
    }
  else
    unusedStms[unused++] = "vform";
  if (windefStms)
    {
      printf("windef %d\n", windefStms);
      used++;
    }
  else
    unusedStms[unused++] = "windef";
  if (wkplanStms)
    {
      printf("wkplan %d\n", wkplanStms);
      used++;
    }
  else
    unusedStms[unused++] = "wkplan";
  if (wristStms)
    {
      printf("wrist %d\n", wristStms);
      used++;
    }
  else
    unusedStms[unused++] = "wrist";
  if (writeStms)
    {
      printf("write %d\n", writeStms);
      used++;
    }
  else
    unusedStms[unused++] = "write";
  if (xternStms)
    {
      printf("xtern %d\n", xternStms);
      used++;
    }
  else
    unusedStms[unused++] = "xtern";
  if (xtractStms)
    {
      printf("xtract %d\n", xtractStms);
      used++;
    }
  else
    unusedStms[unused++] = "xtract";
  printf(
      "%.1f%% of the commands in full DMIS were used.\n",
	  ((used * 100.0) / (used + unused)));
  if (unused)
    {
      printf("The following commands were not used:\n");
      for (k = 0; k < unused; k++)
        printf("%s\n", unusedStms[k]);
    }
}

/********************************************************************/

} // namespace NDTU
